#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 14593
#define LARGE_STATE_COUNT 296
#define SYMBOL_COUNT 715
#define ALIAS_COUNT 2
#define TOKEN_COUNT 412
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 51
#define MAX_ALIAS_SEQUENCE_LENGTH 24
#define PRODUCTION_ID_COUNT 258

enum ts_symbol_identifiers {
  sym__identifier = 1,
  anon_sym_SEMI = 2,
  sym_keyword_select = 3,
  sym_keyword_delete = 4,
  sym_keyword_insert = 5,
  sym_keyword_replace = 6,
  sym_keyword_update = 7,
  sym_keyword_truncate = 8,
  sym_keyword_merge = 9,
  sym_keyword_into = 10,
  sym_keyword_overwrite = 11,
  sym_keyword_values = 12,
  sym_keyword_value = 13,
  sym_keyword_matched = 14,
  sym_keyword_set = 15,
  sym_keyword_from = 16,
  sym_keyword_left = 17,
  sym_keyword_right = 18,
  sym_keyword_inner = 19,
  sym_keyword_full = 20,
  sym_keyword_outer = 21,
  sym_keyword_cross = 22,
  sym_keyword_join = 23,
  sym_keyword_lateral = 24,
  sym_keyword_natural = 25,
  sym_keyword_on = 26,
  sym_keyword_off = 27,
  sym_keyword_where = 28,
  sym_keyword_order = 29,
  sym_keyword_group = 30,
  sym_keyword_partition = 31,
  sym_keyword_by = 32,
  sym_keyword_having = 33,
  sym_keyword_desc = 34,
  sym_keyword_asc = 35,
  sym_keyword_limit = 36,
  sym_keyword_offset = 37,
  sym_keyword_primary = 38,
  sym_keyword_create = 39,
  sym_keyword_alter = 40,
  sym_keyword_change = 41,
  sym_keyword_analyze = 42,
  sym_keyword_explain = 43,
  sym_keyword_verbose = 44,
  sym_keyword_modify = 45,
  sym_keyword_drop = 46,
  sym_keyword_add = 47,
  sym_keyword_table = 48,
  sym_keyword_tables = 49,
  sym_keyword_view = 50,
  sym_keyword_column = 51,
  sym_keyword_columns = 52,
  sym_keyword_materialized = 53,
  sym_keyword_tablespace = 54,
  sym_keyword_sequence = 55,
  sym_keyword_increment = 56,
  sym_keyword_minvalue = 57,
  sym_keyword_maxvalue = 58,
  sym_keyword_none = 59,
  sym_keyword_owned = 60,
  sym_keyword_start = 61,
  sym_keyword_restart = 62,
  sym_keyword_key = 63,
  sym_keyword_as = 64,
  sym_keyword_distinct = 65,
  sym_keyword_constraint = 66,
  sym_keyword_filter = 67,
  sym_keyword_cast = 68,
  sym_keyword_separator = 69,
  sym_keyword_max = 70,
  sym_keyword_min = 71,
  sym_keyword_avg = 72,
  sym_keyword_case = 73,
  sym_keyword_when = 74,
  sym_keyword_then = 75,
  sym_keyword_else = 76,
  sym_keyword_end = 77,
  sym_keyword_in = 78,
  sym_keyword_and = 79,
  sym_keyword_or = 80,
  sym_keyword_is = 81,
  sym_keyword_not = 82,
  sym_keyword_force = 83,
  sym_keyword_ignore = 84,
  sym_keyword_using = 85,
  sym_keyword_use = 86,
  sym_keyword_index = 87,
  sym_keyword_for = 88,
  sym_keyword_if = 89,
  sym_keyword_exists = 90,
  sym_keyword_auto_increment = 91,
  sym_keyword_generated = 92,
  sym_keyword_always = 93,
  sym_keyword_collate = 94,
  aux_sym_keyword_character_token1 = 95,
  sym_keyword_engine = 96,
  sym_keyword_default = 97,
  sym_keyword_cascade = 98,
  sym_keyword_restrict = 99,
  sym_keyword_with = 100,
  sym_keyword_without = 101,
  sym_keyword_no = 102,
  sym_keyword_data = 103,
  sym_keyword_type = 104,
  sym_keyword_rename = 105,
  sym_keyword_to = 106,
  sym_keyword_database = 107,
  sym_keyword_schema = 108,
  sym_keyword_owner = 109,
  sym_keyword_user = 110,
  sym_keyword_admin = 111,
  sym_keyword_password = 112,
  sym_keyword_encrypted = 113,
  sym_keyword_valid = 114,
  sym_keyword_until = 115,
  sym_keyword_connection = 116,
  sym_keyword_role = 117,
  sym_keyword_reset = 118,
  sym_keyword_temp = 119,
  sym_keyword_temporary = 120,
  sym_keyword_unlogged = 121,
  sym_keyword_logged = 122,
  sym_keyword_cycle = 123,
  sym_keyword_union = 124,
  sym_keyword_all = 125,
  sym_keyword_any = 126,
  sym_keyword_some = 127,
  sym_keyword_except = 128,
  sym_keyword_intersect = 129,
  sym_keyword_returning = 130,
  sym_keyword_begin = 131,
  sym_keyword_commit = 132,
  sym_keyword_rollback = 133,
  sym_keyword_transaction = 134,
  sym_keyword_over = 135,
  sym_keyword_nulls = 136,
  sym_keyword_first = 137,
  sym_keyword_after = 138,
  sym_keyword_before = 139,
  sym_keyword_last = 140,
  sym_keyword_window = 141,
  sym_keyword_range = 142,
  sym_keyword_rows = 143,
  sym_keyword_groups = 144,
  sym_keyword_between = 145,
  sym_keyword_unbounded = 146,
  sym_keyword_preceding = 147,
  sym_keyword_following = 148,
  sym_keyword_exclude = 149,
  sym_keyword_current = 150,
  sym_keyword_row = 151,
  sym_keyword_ties = 152,
  sym_keyword_others = 153,
  sym_keyword_only = 154,
  sym_keyword_unique = 155,
  sym_keyword_foreign = 156,
  sym_keyword_references = 157,
  sym_keyword_concurrently = 158,
  sym_keyword_btree = 159,
  sym_keyword_hash = 160,
  sym_keyword_gist = 161,
  sym_keyword_spgist = 162,
  sym_keyword_gin = 163,
  sym_keyword_brin = 164,
  aux_sym_keyword_like_token1 = 165,
  aux_sym_keyword_like_token2 = 166,
  sym_keyword_similar = 167,
  sym_keyword_preserve = 168,
  sym_keyword_unsigned = 169,
  sym_keyword_zerofill = 170,
  sym_keyword_conflict = 171,
  sym_keyword_do = 172,
  sym_keyword_nothing = 173,
  sym_keyword_high_priority = 174,
  sym_keyword_low_priority = 175,
  sym_keyword_delayed = 176,
  sym_keyword_recursive = 177,
  sym_keyword_cascaded = 178,
  sym_keyword_local = 179,
  sym_keyword_current_timestamp = 180,
  sym_keyword_check = 181,
  sym_keyword_option = 182,
  sym_keyword_vacuum = 183,
  sym_keyword_wait = 184,
  sym_keyword_nowait = 185,
  sym_keyword_attribute = 186,
  sym_keyword_authorization = 187,
  sym_keyword_action = 188,
  sym_keyword_extension = 189,
  sym_keyword_copy = 190,
  sym_keyword_stdin = 191,
  sym_keyword_freeze = 192,
  sym_keyword_escape = 193,
  sym_keyword_encoding = 194,
  sym_keyword_force_quote = 195,
  sym_keyword_quote = 196,
  sym_keyword_force_null = 197,
  sym_keyword_force_not_null = 198,
  sym_keyword_header = 199,
  sym_keyword_match = 200,
  sym_keyword_program = 201,
  sym_keyword_plain = 202,
  sym_keyword_extended = 203,
  sym_keyword_main = 204,
  sym_keyword_storage = 205,
  sym_keyword_compression = 206,
  sym_keyword_trigger = 207,
  sym_keyword_function = 208,
  sym_keyword_returns = 209,
  sym_keyword_return = 210,
  sym_keyword_setof = 211,
  sym_keyword_atomic = 212,
  sym_keyword_declare = 213,
  sym_keyword_language = 214,
  sym_keyword_sql = 215,
  sym_keyword_plpgsql = 216,
  sym_keyword_immutable = 217,
  sym_keyword_stable = 218,
  sym_keyword_volatile = 219,
  sym_keyword_leakproof = 220,
  sym_keyword_parallel = 221,
  sym_keyword_safe = 222,
  sym_keyword_unsafe = 223,
  sym_keyword_restricted = 224,
  sym_keyword_called = 225,
  sym_keyword_input = 226,
  sym_keyword_strict = 227,
  sym_keyword_cost = 228,
  sym_keyword_support = 229,
  sym_keyword_definer = 230,
  sym_keyword_invoker = 231,
  sym_keyword_security = 232,
  sym_keyword_version = 233,
  sym_keyword_out = 234,
  sym_keyword_inout = 235,
  sym_keyword_variadic = 236,
  sym_keyword_session = 237,
  sym_keyword_isolation = 238,
  sym_keyword_level = 239,
  sym_keyword_serializable = 240,
  sym_keyword_repeatable = 241,
  sym_keyword_read = 242,
  sym_keyword_write = 243,
  sym_keyword_committed = 244,
  sym_keyword_uncommitted = 245,
  sym_keyword_deferrable = 246,
  sym_keyword_names = 247,
  sym_keyword_zone = 248,
  sym_keyword_immediate = 249,
  sym_keyword_deferred = 250,
  sym_keyword_constraints = 251,
  sym_keyword_snapshot = 252,
  sym_keyword_characteristics = 253,
  sym_keyword_follows = 254,
  sym_keyword_precedes = 255,
  sym_keyword_each = 256,
  sym_keyword_instead = 257,
  sym_keyword_of = 258,
  sym_keyword_initially = 259,
  sym_keyword_old = 260,
  sym_keyword_new = 261,
  sym_keyword_referencing = 262,
  sym_keyword_statement = 263,
  sym_keyword_execute = 264,
  sym_keyword_procedure = 265,
  sym_keyword_external = 266,
  sym_keyword_stored = 267,
  sym_keyword_virtual = 268,
  sym_keyword_cached = 269,
  sym_keyword_uncached = 270,
  sym_keyword_replication = 271,
  sym_keyword_tblproperties = 272,
  sym_keyword_options = 273,
  sym_keyword_compute = 274,
  sym_keyword_stats = 275,
  sym_keyword_statistics = 276,
  sym_keyword_optimize = 277,
  sym_keyword_rewrite = 278,
  sym_keyword_bin_pack = 279,
  sym_keyword_incremental = 280,
  sym_keyword_location = 281,
  sym_keyword_partitioned = 282,
  sym_keyword_comment = 283,
  sym_keyword_sort = 284,
  sym_keyword_format = 285,
  sym_keyword_delimited = 286,
  sym_keyword_delimiter = 287,
  sym_keyword_fields = 288,
  sym_keyword_terminated = 289,
  sym_keyword_escaped = 290,
  sym_keyword_lines = 291,
  sym_keyword_cache = 292,
  sym_keyword_metadata = 293,
  sym_keyword_noscan = 294,
  sym_keyword_parquet = 295,
  sym_keyword_rcfile = 296,
  sym_keyword_csv = 297,
  sym_keyword_textfile = 298,
  sym_keyword_avro = 299,
  sym_keyword_sequencefile = 300,
  sym_keyword_orc = 301,
  sym_keyword_jsonfile = 302,
  sym_keyword_null = 303,
  sym_keyword_true = 304,
  sym_keyword_false = 305,
  sym_keyword_boolean = 306,
  sym_keyword_bit = 307,
  sym_keyword_binary = 308,
  sym_keyword_varbinary = 309,
  sym_keyword_image = 310,
  aux_sym_keyword_smallserial_token1 = 311,
  aux_sym_keyword_smallserial_token2 = 312,
  aux_sym_keyword_serial_token1 = 313,
  aux_sym_keyword_serial_token2 = 314,
  aux_sym_keyword_bigserial_token1 = 315,
  aux_sym_keyword_bigserial_token2 = 316,
  aux_sym_keyword_tinyint_token1 = 317,
  aux_sym_keyword_tinyint_token2 = 318,
  aux_sym_keyword_smallint_token1 = 319,
  aux_sym_keyword_smallint_token2 = 320,
  aux_sym_keyword_mediumint_token1 = 321,
  aux_sym_keyword_mediumint_token2 = 322,
  aux_sym_keyword_int_token1 = 323,
  aux_sym_keyword_int_token2 = 324,
  aux_sym_keyword_int_token3 = 325,
  aux_sym_keyword_bigint_token1 = 326,
  aux_sym_keyword_bigint_token2 = 327,
  sym_keyword_decimal = 328,
  sym_keyword_numeric = 329,
  aux_sym_keyword_real_token1 = 330,
  aux_sym_keyword_real_token2 = 331,
  sym_keyword_float = 332,
  sym_keyword_double = 333,
  sym_keyword_precision = 334,
  sym_keyword_inet = 335,
  sym_keyword_money = 336,
  sym_keyword_smallmoney = 337,
  sym_keyword_varying = 338,
  aux_sym_keyword_char_token1 = 339,
  sym_keyword_nchar = 340,
  aux_sym_keyword_varchar_token1 = 341,
  sym_keyword_nvarchar = 342,
  sym_keyword_text = 343,
  sym_keyword_string = 344,
  sym_keyword_uuid = 345,
  sym_keyword_json = 346,
  sym_keyword_jsonb = 347,
  sym_keyword_xml = 348,
  sym_keyword_bytea = 349,
  sym_keyword_enum = 350,
  sym_keyword_date = 351,
  sym_keyword_datetime = 352,
  sym_keyword_datetime2 = 353,
  sym_keyword_smalldatetime = 354,
  sym_keyword_datetimeoffset = 355,
  sym_keyword_time = 356,
  sym_keyword_timestamp = 357,
  sym_keyword_timestamptz = 358,
  sym_keyword_interval = 359,
  sym_keyword_geometry = 360,
  sym_keyword_geography = 361,
  sym_keyword_box2d = 362,
  sym_keyword_box3d = 363,
  sym_keyword_oid = 364,
  sym_keyword_oids = 365,
  sym_keyword_name = 366,
  sym_keyword_regclass = 367,
  sym_keyword_regnamespace = 368,
  sym_keyword_regproc = 369,
  sym_keyword_regtype = 370,
  sym_keyword_array = 371,
  anon_sym_LBRACK = 372,
  anon_sym_RBRACK = 373,
  anon_sym_LPAREN = 374,
  anon_sym_RPAREN = 375,
  anon_sym_COMMA = 376,
  aux_sym_double_token1 = 377,
  sym_comment = 378,
  sym_marginalia = 379,
  anon_sym_EQ = 380,
  anon_sym_COLON_EQ = 381,
  anon_sym_DOT = 382,
  anon_sym_STAR = 383,
  sym_parameter = 384,
  anon_sym_COLON_COLON = 385,
  anon_sym_LT = 386,
  anon_sym_GT = 387,
  anon_sym_LT_EQ = 388,
  anon_sym_GT_EQ = 389,
  anon_sym_COLON = 390,
  sym_op_other = 391,
  anon_sym_PLUS = 392,
  anon_sym_DASH = 393,
  anon_sym_SLASH = 394,
  anon_sym_PERCENT = 395,
  anon_sym_CARET = 396,
  anon_sym_BANG_EQ = 397,
  anon_sym_LT_GT = 398,
  sym_op_unary_other = 399,
  sym__double_quote_string = 400,
  aux_sym__single_quote_string_token1 = 401,
  aux_sym__single_quote_string_token2 = 402,
  sym__natural_number = 403,
  aux_sym__integer_token1 = 404,
  aux_sym__decimal_number_token1 = 405,
  aux_sym__bit_string_token1 = 406,
  sym_bang = 407,
  aux_sym_identifier_token1 = 408,
  sym__dollar_quoted_string_start_tag = 409,
  sym__dollar_quoted_string_end_tag = 410,
  sym__dollar_quoted_string = 411,
  sym_program = 412,
  sym_keyword_character = 413,
  sym_keyword_like = 414,
  sym_is_not = 415,
  sym_not_like = 416,
  sym_similar_to = 417,
  sym_not_similar_to = 418,
  sym_distinct_from = 419,
  sym_not_distinct_from = 420,
  sym__temporary = 421,
  sym__not_null = 422,
  sym__primary_key = 423,
  sym__if_exists = 424,
  sym__if_not_exists = 425,
  sym__or_replace = 426,
  sym__current_row = 427,
  sym__exclude_current_row = 428,
  sym__exclude_group = 429,
  sym__exclude_no_others = 430,
  sym__exclude_ties = 431,
  sym__check_option = 432,
  sym_direction = 433,
  sym_keyword_smallserial = 434,
  sym_keyword_serial = 435,
  sym_keyword_bigserial = 436,
  sym_keyword_tinyint = 437,
  sym_keyword_smallint = 438,
  sym_keyword_mediumint = 439,
  sym_keyword_int = 440,
  sym_keyword_bigint = 441,
  sym_keyword_real = 442,
  sym_keyword_char = 443,
  sym_keyword_varchar = 444,
  sym__type = 445,
  sym_array_size_definition = 446,
  sym__array_size_definition = 447,
  sym_tinyint = 448,
  sym_smallint = 449,
  sym_mediumint = 450,
  sym_int = 451,
  sym_bigint = 452,
  sym_bit = 453,
  sym_binary = 454,
  sym_varbinary = 455,
  sym_float = 456,
  sym_double = 457,
  sym_decimal = 458,
  sym_numeric = 459,
  sym_char = 460,
  sym_varchar = 461,
  sym_nchar = 462,
  sym_nvarchar = 463,
  sym__include_time_zone = 464,
  sym_datetimeoffset = 465,
  sym_time = 466,
  sym_timestamp = 467,
  sym_enum = 468,
  sym_array = 469,
  sym_transaction = 470,
  sym__commit = 471,
  sym__rollback = 472,
  sym_block = 473,
  sym_statement = 474,
  sym__ddl_statement = 475,
  sym__cte = 476,
  sym__dml_write = 477,
  sym__dml_read = 478,
  sym_cte = 479,
  sym_set_operation = 480,
  sym__select_statement = 481,
  sym_comment_statement = 482,
  sym__argmode = 483,
  sym_function_argument = 484,
  sym_function_arguments = 485,
  sym__comment_target = 486,
  sym_select = 487,
  sym_select_expression = 488,
  sym_term = 489,
  sym__truncate_statement = 490,
  sym__delete_statement = 491,
  sym__delete_from = 492,
  sym_delete = 493,
  sym__create_statement = 494,
  sym__table_settings = 495,
  sym_storage_parameters = 496,
  sym_create_table = 497,
  sym_reset_statement = 498,
  sym__transaction_mode = 499,
  sym_set_statement = 500,
  sym_create_query = 501,
  sym_create_view = 502,
  sym_create_materialized_view = 503,
  sym_create_function = 504,
  sym__function_return = 505,
  sym_function_declaration = 506,
  sym__function_body_statement = 507,
  sym_function_body = 508,
  sym_function_language = 509,
  sym_function_volatility = 510,
  sym_function_leakproof = 511,
  sym_function_security = 512,
  sym_function_safety = 513,
  sym_function_strictness = 514,
  sym_function_cost = 515,
  sym_function_rows = 516,
  sym_function_support = 517,
  sym__operator_class = 518,
  sym__index_field = 519,
  sym_index_fields = 520,
  sym_create_index = 521,
  sym_create_schema = 522,
  sym__with_settings = 523,
  sym_create_database = 524,
  sym_create_role = 525,
  sym__role_options = 526,
  sym__user_access_role_config = 527,
  sym_create_sequence = 528,
  sym_create_extension = 529,
  sym_create_trigger = 530,
  sym__create_trigger_event = 531,
  sym_create_type = 532,
  sym_enum_elements = 533,
  sym__alter_statement = 534,
  sym__rename_statement = 535,
  sym__rename_table_names = 536,
  sym_alter_table = 537,
  sym__alter_specifications = 538,
  sym_add_column = 539,
  sym_add_constraint = 540,
  sym_alter_column = 541,
  sym_modify_column = 542,
  sym_change_column = 543,
  sym_column_position = 544,
  sym_drop_column = 545,
  sym_rename_column = 546,
  sym_alter_view = 547,
  sym_alter_schema = 548,
  sym_alter_database = 549,
  sym_alter_role = 550,
  sym_set_configuration = 551,
  sym_alter_index = 552,
  sym_alter_sequence = 553,
  sym_alter_type = 554,
  sym__drop_behavior = 555,
  sym__drop_statement = 556,
  sym_drop_table = 557,
  sym_drop_view = 558,
  sym_drop_schema = 559,
  sym_drop_database = 560,
  sym_drop_role = 561,
  sym_drop_type = 562,
  sym_drop_sequence = 563,
  sym_drop_index = 564,
  sym_drop_extension = 565,
  sym_rename_object = 566,
  sym_set_schema = 567,
  sym_change_ownership = 568,
  sym_object_reference = 569,
  sym__copy_statement = 570,
  sym__insert_statement = 571,
  sym_insert = 572,
  sym__insert_values = 573,
  sym__set_values = 574,
  sym__column_list = 575,
  sym__column = 576,
  sym__update_statement = 577,
  sym__merge_statement = 578,
  sym_when_clause = 579,
  sym__optimize_statement = 580,
  sym__compute_stats = 581,
  sym__optimize_table = 582,
  sym__vacuum_table = 583,
  sym__vacuum_option = 584,
  sym__partition_spec = 585,
  sym_update = 586,
  sym__mysql_update_statement = 587,
  sym__postgres_update_statement = 588,
  sym_storage_location = 589,
  sym_row_format = 590,
  sym_table_sort = 591,
  sym_table_partition = 592,
  sym__key_value_pair = 593,
  sym_stored_as = 594,
  sym_assignment = 595,
  sym_table_option = 596,
  sym_column_definitions = 597,
  sym_column_definition = 598,
  sym__column_comment = 599,
  sym__column_constraint = 600,
  sym__check_constraint = 601,
  sym__default_expression = 602,
  sym__inner_default_expression = 603,
  sym_constraints = 604,
  sym_constraint = 605,
  sym__constraint_literal = 606,
  sym__primary_key_constraint = 607,
  sym__key_constraint = 608,
  sym_ordered_columns = 609,
  sym_ordered_column = 610,
  sym_all_fields = 611,
  sym_case = 612,
  sym_field = 613,
  sym__qualified_field = 614,
  sym_implicit_cast = 615,
  sym_interval = 616,
  sym_cast = 617,
  sym_filter_expression = 618,
  sym_invocation = 619,
  sym_exists = 620,
  sym_partition_by = 621,
  sym_frame_definition = 622,
  sym_window_frame = 623,
  sym_window_clause = 624,
  sym_window_specification = 625,
  sym_window_function = 626,
  sym__alias = 627,
  sym_from = 628,
  sym_relation = 629,
  sym_values = 630,
  sym_index_hint = 631,
  sym_join = 632,
  sym_cross_join = 633,
  sym_lateral_join = 634,
  sym_lateral_cross_join = 635,
  sym_where = 636,
  sym_group_by = 637,
  sym__having = 638,
  sym_order_by = 639,
  sym_order_target = 640,
  sym_limit = 641,
  sym_offset = 642,
  sym_returning = 643,
  sym__expression = 644,
  sym_parenthesized_expression = 645,
  sym_subscript = 646,
  sym_binary_expression = 647,
  sym_unary_expression = 648,
  sym_between_expression = 649,
  sym_not_in = 650,
  sym_subquery = 651,
  sym_list = 652,
  sym_literal = 653,
  sym__single_quote_string = 654,
  sym__literal_string = 655,
  sym__integer = 656,
  sym__decimal_number = 657,
  sym__bit_string = 658,
  sym__string_casting = 659,
  sym_identifier = 660,
  aux_sym_program_repeat1 = 661,
  aux_sym_array_size_definition_repeat1 = 662,
  aux_sym_enum_repeat1 = 663,
  aux_sym_array_repeat1 = 664,
  aux_sym_transaction_repeat1 = 665,
  aux_sym__cte_repeat1 = 666,
  aux_sym_cte_repeat1 = 667,
  aux_sym_set_operation_repeat1 = 668,
  aux_sym_function_arguments_repeat1 = 669,
  aux_sym_select_expression_repeat1 = 670,
  aux_sym__truncate_statement_repeat1 = 671,
  aux_sym__create_statement_repeat1 = 672,
  aux_sym__table_settings_repeat1 = 673,
  aux_sym_storage_parameters_repeat1 = 674,
  aux_sym_create_table_repeat1 = 675,
  aux_sym_set_statement_repeat1 = 676,
  aux_sym_create_function_repeat1 = 677,
  aux_sym_function_body_repeat1 = 678,
  aux_sym_function_body_repeat2 = 679,
  aux_sym_index_fields_repeat1 = 680,
  aux_sym_create_database_repeat1 = 681,
  aux_sym_create_role_repeat1 = 682,
  aux_sym_create_sequence_repeat1 = 683,
  aux_sym_create_trigger_repeat1 = 684,
  aux_sym_create_trigger_repeat2 = 685,
  aux_sym_create_trigger_repeat3 = 686,
  aux_sym_create_type_repeat1 = 687,
  aux_sym_enum_elements_repeat1 = 688,
  aux_sym__rename_statement_repeat1 = 689,
  aux_sym_alter_table_repeat1 = 690,
  aux_sym_alter_column_repeat1 = 691,
  aux_sym_alter_role_repeat1 = 692,
  aux_sym_alter_index_repeat1 = 693,
  aux_sym_alter_sequence_repeat1 = 694,
  aux_sym__copy_statement_repeat1 = 695,
  aux_sym__insert_values_repeat1 = 696,
  aux_sym__set_values_repeat1 = 697,
  aux_sym__column_list_repeat1 = 698,
  aux_sym__merge_statement_repeat1 = 699,
  aux_sym__compute_stats_repeat1 = 700,
  aux_sym__compute_stats_repeat2 = 701,
  aux_sym__vacuum_table_repeat1 = 702,
  aux_sym__mysql_update_statement_repeat1 = 703,
  aux_sym__mysql_update_statement_repeat2 = 704,
  aux_sym_column_definitions_repeat1 = 705,
  aux_sym_column_definition_repeat1 = 706,
  aux_sym__column_constraint_repeat1 = 707,
  aux_sym_constraints_repeat1 = 708,
  aux_sym_ordered_columns_repeat1 = 709,
  aux_sym_case_repeat1 = 710,
  aux_sym_invocation_repeat1 = 711,
  aux_sym_from_repeat1 = 712,
  aux_sym_order_by_repeat1 = 713,
  aux_sym__single_quote_string_repeat1 = 714,
  anon_alias_sym_command = 715,
  anon_alias_sym_filename = 716,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier] = "_identifier",
  [anon_sym_SEMI] = ";",
  [sym_keyword_select] = "keyword_select",
  [sym_keyword_delete] = "keyword_delete",
  [sym_keyword_insert] = "keyword_insert",
  [sym_keyword_replace] = "keyword_replace",
  [sym_keyword_update] = "keyword_update",
  [sym_keyword_truncate] = "keyword_truncate",
  [sym_keyword_merge] = "keyword_merge",
  [sym_keyword_into] = "keyword_into",
  [sym_keyword_overwrite] = "keyword_overwrite",
  [sym_keyword_values] = "keyword_values",
  [sym_keyword_value] = "keyword_value",
  [sym_keyword_matched] = "keyword_matched",
  [sym_keyword_set] = "keyword_set",
  [sym_keyword_from] = "keyword_from",
  [sym_keyword_left] = "keyword_left",
  [sym_keyword_right] = "keyword_right",
  [sym_keyword_inner] = "keyword_inner",
  [sym_keyword_full] = "keyword_full",
  [sym_keyword_outer] = "keyword_outer",
  [sym_keyword_cross] = "keyword_cross",
  [sym_keyword_join] = "keyword_join",
  [sym_keyword_lateral] = "keyword_lateral",
  [sym_keyword_natural] = "keyword_natural",
  [sym_keyword_on] = "keyword_on",
  [sym_keyword_off] = "keyword_off",
  [sym_keyword_where] = "keyword_where",
  [sym_keyword_order] = "keyword_order",
  [sym_keyword_group] = "keyword_group",
  [sym_keyword_partition] = "keyword_partition",
  [sym_keyword_by] = "keyword_by",
  [sym_keyword_having] = "keyword_having",
  [sym_keyword_desc] = "keyword_desc",
  [sym_keyword_asc] = "keyword_asc",
  [sym_keyword_limit] = "keyword_limit",
  [sym_keyword_offset] = "keyword_offset",
  [sym_keyword_primary] = "keyword_primary",
  [sym_keyword_create] = "keyword_create",
  [sym_keyword_alter] = "keyword_alter",
  [sym_keyword_change] = "keyword_change",
  [sym_keyword_analyze] = "keyword_analyze",
  [sym_keyword_explain] = "keyword_explain",
  [sym_keyword_verbose] = "keyword_verbose",
  [sym_keyword_modify] = "keyword_modify",
  [sym_keyword_drop] = "keyword_drop",
  [sym_keyword_add] = "keyword_add",
  [sym_keyword_table] = "keyword_table",
  [sym_keyword_tables] = "keyword_tables",
  [sym_keyword_view] = "keyword_view",
  [sym_keyword_column] = "keyword_column",
  [sym_keyword_columns] = "keyword_columns",
  [sym_keyword_materialized] = "keyword_materialized",
  [sym_keyword_tablespace] = "keyword_tablespace",
  [sym_keyword_sequence] = "keyword_sequence",
  [sym_keyword_increment] = "keyword_increment",
  [sym_keyword_minvalue] = "keyword_minvalue",
  [sym_keyword_maxvalue] = "keyword_maxvalue",
  [sym_keyword_none] = "keyword_none",
  [sym_keyword_owned] = "keyword_owned",
  [sym_keyword_start] = "keyword_start",
  [sym_keyword_restart] = "keyword_restart",
  [sym_keyword_key] = "keyword_key",
  [sym_keyword_as] = "keyword_as",
  [sym_keyword_distinct] = "keyword_distinct",
  [sym_keyword_constraint] = "keyword_constraint",
  [sym_keyword_filter] = "keyword_filter",
  [sym_keyword_cast] = "keyword_cast",
  [sym_keyword_separator] = "keyword_separator",
  [sym_keyword_max] = "keyword_max",
  [sym_keyword_min] = "keyword_min",
  [sym_keyword_avg] = "keyword_avg",
  [sym_keyword_case] = "keyword_case",
  [sym_keyword_when] = "keyword_when",
  [sym_keyword_then] = "keyword_then",
  [sym_keyword_else] = "keyword_else",
  [sym_keyword_end] = "keyword_end",
  [sym_keyword_in] = "keyword_in",
  [sym_keyword_and] = "keyword_and",
  [sym_keyword_or] = "keyword_or",
  [sym_keyword_is] = "keyword_is",
  [sym_keyword_not] = "keyword_not",
  [sym_keyword_force] = "keyword_force",
  [sym_keyword_ignore] = "keyword_ignore",
  [sym_keyword_using] = "keyword_using",
  [sym_keyword_use] = "keyword_use",
  [sym_keyword_index] = "keyword_index",
  [sym_keyword_for] = "keyword_for",
  [sym_keyword_if] = "keyword_if",
  [sym_keyword_exists] = "keyword_exists",
  [sym_keyword_auto_increment] = "keyword_auto_increment",
  [sym_keyword_generated] = "keyword_generated",
  [sym_keyword_always] = "keyword_always",
  [sym_keyword_collate] = "keyword_collate",
  [aux_sym_keyword_character_token1] = "keyword_character_token1",
  [sym_keyword_engine] = "keyword_engine",
  [sym_keyword_default] = "keyword_default",
  [sym_keyword_cascade] = "keyword_cascade",
  [sym_keyword_restrict] = "keyword_restrict",
  [sym_keyword_with] = "keyword_with",
  [sym_keyword_without] = "keyword_without",
  [sym_keyword_no] = "keyword_no",
  [sym_keyword_data] = "keyword_data",
  [sym_keyword_type] = "keyword_type",
  [sym_keyword_rename] = "keyword_rename",
  [sym_keyword_to] = "keyword_to",
  [sym_keyword_database] = "keyword_database",
  [sym_keyword_schema] = "keyword_schema",
  [sym_keyword_owner] = "keyword_owner",
  [sym_keyword_user] = "keyword_user",
  [sym_keyword_admin] = "keyword_admin",
  [sym_keyword_password] = "keyword_password",
  [sym_keyword_encrypted] = "keyword_encrypted",
  [sym_keyword_valid] = "keyword_valid",
  [sym_keyword_until] = "keyword_until",
  [sym_keyword_connection] = "keyword_connection",
  [sym_keyword_role] = "keyword_role",
  [sym_keyword_reset] = "keyword_reset",
  [sym_keyword_temp] = "keyword_temp",
  [sym_keyword_temporary] = "keyword_temporary",
  [sym_keyword_unlogged] = "keyword_unlogged",
  [sym_keyword_logged] = "keyword_logged",
  [sym_keyword_cycle] = "keyword_cycle",
  [sym_keyword_union] = "keyword_union",
  [sym_keyword_all] = "keyword_all",
  [sym_keyword_any] = "keyword_any",
  [sym_keyword_some] = "keyword_some",
  [sym_keyword_except] = "keyword_except",
  [sym_keyword_intersect] = "keyword_intersect",
  [sym_keyword_returning] = "keyword_returning",
  [sym_keyword_begin] = "keyword_begin",
  [sym_keyword_commit] = "keyword_commit",
  [sym_keyword_rollback] = "keyword_rollback",
  [sym_keyword_transaction] = "keyword_transaction",
  [sym_keyword_over] = "keyword_over",
  [sym_keyword_nulls] = "keyword_nulls",
  [sym_keyword_first] = "keyword_first",
  [sym_keyword_after] = "keyword_after",
  [sym_keyword_before] = "keyword_before",
  [sym_keyword_last] = "keyword_last",
  [sym_keyword_window] = "keyword_window",
  [sym_keyword_range] = "keyword_range",
  [sym_keyword_rows] = "keyword_rows",
  [sym_keyword_groups] = "keyword_groups",
  [sym_keyword_between] = "keyword_between",
  [sym_keyword_unbounded] = "keyword_unbounded",
  [sym_keyword_preceding] = "keyword_preceding",
  [sym_keyword_following] = "keyword_following",
  [sym_keyword_exclude] = "keyword_exclude",
  [sym_keyword_current] = "keyword_current",
  [sym_keyword_row] = "keyword_row",
  [sym_keyword_ties] = "keyword_ties",
  [sym_keyword_others] = "keyword_others",
  [sym_keyword_only] = "keyword_only",
  [sym_keyword_unique] = "keyword_unique",
  [sym_keyword_foreign] = "keyword_foreign",
  [sym_keyword_references] = "keyword_references",
  [sym_keyword_concurrently] = "keyword_concurrently",
  [sym_keyword_btree] = "keyword_btree",
  [sym_keyword_hash] = "keyword_hash",
  [sym_keyword_gist] = "keyword_gist",
  [sym_keyword_spgist] = "keyword_spgist",
  [sym_keyword_gin] = "keyword_gin",
  [sym_keyword_brin] = "keyword_brin",
  [aux_sym_keyword_like_token1] = "keyword_like_token1",
  [aux_sym_keyword_like_token2] = "keyword_like_token2",
  [sym_keyword_similar] = "keyword_similar",
  [sym_keyword_preserve] = "keyword_preserve",
  [sym_keyword_unsigned] = "keyword_unsigned",
  [sym_keyword_zerofill] = "keyword_zerofill",
  [sym_keyword_conflict] = "keyword_conflict",
  [sym_keyword_do] = "keyword_do",
  [sym_keyword_nothing] = "keyword_nothing",
  [sym_keyword_high_priority] = "keyword_high_priority",
  [sym_keyword_low_priority] = "keyword_low_priority",
  [sym_keyword_delayed] = "keyword_delayed",
  [sym_keyword_recursive] = "keyword_recursive",
  [sym_keyword_cascaded] = "keyword_cascaded",
  [sym_keyword_local] = "keyword_local",
  [sym_keyword_current_timestamp] = "keyword_current_timestamp",
  [sym_keyword_check] = "keyword_check",
  [sym_keyword_option] = "keyword_option",
  [sym_keyword_vacuum] = "keyword_vacuum",
  [sym_keyword_wait] = "keyword_wait",
  [sym_keyword_nowait] = "keyword_nowait",
  [sym_keyword_attribute] = "keyword_attribute",
  [sym_keyword_authorization] = "keyword_authorization",
  [sym_keyword_action] = "keyword_action",
  [sym_keyword_extension] = "keyword_extension",
  [sym_keyword_copy] = "keyword_copy",
  [sym_keyword_stdin] = "keyword_stdin",
  [sym_keyword_freeze] = "keyword_freeze",
  [sym_keyword_escape] = "keyword_escape",
  [sym_keyword_encoding] = "keyword_encoding",
  [sym_keyword_force_quote] = "keyword_force_quote",
  [sym_keyword_quote] = "keyword_quote",
  [sym_keyword_force_null] = "keyword_force_null",
  [sym_keyword_force_not_null] = "keyword_force_not_null",
  [sym_keyword_header] = "keyword_header",
  [sym_keyword_match] = "keyword_match",
  [sym_keyword_program] = "keyword_program",
  [sym_keyword_plain] = "keyword_plain",
  [sym_keyword_extended] = "keyword_extended",
  [sym_keyword_main] = "keyword_main",
  [sym_keyword_storage] = "keyword_storage",
  [sym_keyword_compression] = "keyword_compression",
  [sym_keyword_trigger] = "keyword_trigger",
  [sym_keyword_function] = "keyword_function",
  [sym_keyword_returns] = "keyword_returns",
  [sym_keyword_return] = "keyword_return",
  [sym_keyword_setof] = "keyword_setof",
  [sym_keyword_atomic] = "keyword_atomic",
  [sym_keyword_declare] = "keyword_declare",
  [sym_keyword_language] = "keyword_language",
  [sym_keyword_sql] = "keyword_sql",
  [sym_keyword_plpgsql] = "keyword_plpgsql",
  [sym_keyword_immutable] = "keyword_immutable",
  [sym_keyword_stable] = "keyword_stable",
  [sym_keyword_volatile] = "keyword_volatile",
  [sym_keyword_leakproof] = "keyword_leakproof",
  [sym_keyword_parallel] = "keyword_parallel",
  [sym_keyword_safe] = "keyword_safe",
  [sym_keyword_unsafe] = "keyword_unsafe",
  [sym_keyword_restricted] = "keyword_restricted",
  [sym_keyword_called] = "keyword_called",
  [sym_keyword_input] = "keyword_input",
  [sym_keyword_strict] = "keyword_strict",
  [sym_keyword_cost] = "keyword_cost",
  [sym_keyword_support] = "keyword_support",
  [sym_keyword_definer] = "keyword_definer",
  [sym_keyword_invoker] = "keyword_invoker",
  [sym_keyword_security] = "keyword_security",
  [sym_keyword_version] = "keyword_version",
  [sym_keyword_out] = "keyword_out",
  [sym_keyword_inout] = "keyword_inout",
  [sym_keyword_variadic] = "keyword_variadic",
  [sym_keyword_session] = "keyword_session",
  [sym_keyword_isolation] = "keyword_isolation",
  [sym_keyword_level] = "keyword_level",
  [sym_keyword_serializable] = "keyword_serializable",
  [sym_keyword_repeatable] = "keyword_repeatable",
  [sym_keyword_read] = "keyword_read",
  [sym_keyword_write] = "keyword_write",
  [sym_keyword_committed] = "keyword_committed",
  [sym_keyword_uncommitted] = "keyword_uncommitted",
  [sym_keyword_deferrable] = "keyword_deferrable",
  [sym_keyword_names] = "keyword_names",
  [sym_keyword_zone] = "keyword_zone",
  [sym_keyword_immediate] = "keyword_immediate",
  [sym_keyword_deferred] = "keyword_deferred",
  [sym_keyword_constraints] = "keyword_constraints",
  [sym_keyword_snapshot] = "keyword_snapshot",
  [sym_keyword_characteristics] = "keyword_characteristics",
  [sym_keyword_follows] = "keyword_follows",
  [sym_keyword_precedes] = "keyword_precedes",
  [sym_keyword_each] = "keyword_each",
  [sym_keyword_instead] = "keyword_instead",
  [sym_keyword_of] = "keyword_of",
  [sym_keyword_initially] = "keyword_initially",
  [sym_keyword_old] = "keyword_old",
  [sym_keyword_new] = "keyword_new",
  [sym_keyword_referencing] = "keyword_referencing",
  [sym_keyword_statement] = "keyword_statement",
  [sym_keyword_execute] = "keyword_execute",
  [sym_keyword_procedure] = "keyword_procedure",
  [sym_keyword_external] = "keyword_external",
  [sym_keyword_stored] = "keyword_stored",
  [sym_keyword_virtual] = "keyword_virtual",
  [sym_keyword_cached] = "keyword_cached",
  [sym_keyword_uncached] = "keyword_uncached",
  [sym_keyword_replication] = "keyword_replication",
  [sym_keyword_tblproperties] = "keyword_tblproperties",
  [sym_keyword_options] = "keyword_options",
  [sym_keyword_compute] = "keyword_compute",
  [sym_keyword_stats] = "keyword_stats",
  [sym_keyword_statistics] = "keyword_statistics",
  [sym_keyword_optimize] = "keyword_optimize",
  [sym_keyword_rewrite] = "keyword_rewrite",
  [sym_keyword_bin_pack] = "keyword_bin_pack",
  [sym_keyword_incremental] = "keyword_incremental",
  [sym_keyword_location] = "keyword_location",
  [sym_keyword_partitioned] = "keyword_partitioned",
  [sym_keyword_comment] = "keyword_comment",
  [sym_keyword_sort] = "keyword_sort",
  [sym_keyword_format] = "keyword_format",
  [sym_keyword_delimited] = "keyword_delimited",
  [sym_keyword_delimiter] = "keyword_delimiter",
  [sym_keyword_fields] = "keyword_fields",
  [sym_keyword_terminated] = "keyword_terminated",
  [sym_keyword_escaped] = "keyword_escaped",
  [sym_keyword_lines] = "keyword_lines",
  [sym_keyword_cache] = "keyword_cache",
  [sym_keyword_metadata] = "keyword_metadata",
  [sym_keyword_noscan] = "keyword_noscan",
  [sym_keyword_parquet] = "keyword_parquet",
  [sym_keyword_rcfile] = "keyword_rcfile",
  [sym_keyword_csv] = "keyword_csv",
  [sym_keyword_textfile] = "keyword_textfile",
  [sym_keyword_avro] = "keyword_avro",
  [sym_keyword_sequencefile] = "keyword_sequencefile",
  [sym_keyword_orc] = "keyword_orc",
  [sym_keyword_jsonfile] = "keyword_jsonfile",
  [sym_keyword_null] = "keyword_null",
  [sym_keyword_true] = "keyword_true",
  [sym_keyword_false] = "keyword_false",
  [sym_keyword_boolean] = "keyword_boolean",
  [sym_keyword_bit] = "keyword_bit",
  [sym_keyword_binary] = "keyword_binary",
  [sym_keyword_varbinary] = "keyword_varbinary",
  [sym_keyword_image] = "keyword_image",
  [aux_sym_keyword_smallserial_token1] = "keyword_smallserial_token1",
  [aux_sym_keyword_smallserial_token2] = "keyword_smallserial_token2",
  [aux_sym_keyword_serial_token1] = "keyword_serial_token1",
  [aux_sym_keyword_serial_token2] = "keyword_serial_token2",
  [aux_sym_keyword_bigserial_token1] = "keyword_bigserial_token1",
  [aux_sym_keyword_bigserial_token2] = "keyword_bigserial_token2",
  [aux_sym_keyword_tinyint_token1] = "keyword_tinyint_token1",
  [aux_sym_keyword_tinyint_token2] = "keyword_tinyint_token2",
  [aux_sym_keyword_smallint_token1] = "keyword_smallint_token1",
  [aux_sym_keyword_smallint_token2] = "keyword_smallint_token2",
  [aux_sym_keyword_mediumint_token1] = "keyword_mediumint_token1",
  [aux_sym_keyword_mediumint_token2] = "keyword_mediumint_token2",
  [aux_sym_keyword_int_token1] = "keyword_int_token1",
  [aux_sym_keyword_int_token2] = "keyword_int_token2",
  [aux_sym_keyword_int_token3] = "keyword_int_token3",
  [aux_sym_keyword_bigint_token1] = "keyword_bigint_token1",
  [aux_sym_keyword_bigint_token2] = "keyword_bigint_token2",
  [sym_keyword_decimal] = "keyword_decimal",
  [sym_keyword_numeric] = "keyword_numeric",
  [aux_sym_keyword_real_token1] = "keyword_real_token1",
  [aux_sym_keyword_real_token2] = "keyword_real_token2",
  [sym_keyword_float] = "keyword_float",
  [sym_keyword_double] = "keyword_double",
  [sym_keyword_precision] = "keyword_precision",
  [sym_keyword_inet] = "keyword_inet",
  [sym_keyword_money] = "keyword_money",
  [sym_keyword_smallmoney] = "keyword_smallmoney",
  [sym_keyword_varying] = "keyword_varying",
  [aux_sym_keyword_char_token1] = "keyword_char_token1",
  [sym_keyword_nchar] = "keyword_nchar",
  [aux_sym_keyword_varchar_token1] = "keyword_varchar_token1",
  [sym_keyword_nvarchar] = "keyword_nvarchar",
  [sym_keyword_text] = "keyword_text",
  [sym_keyword_string] = "keyword_string",
  [sym_keyword_uuid] = "keyword_uuid",
  [sym_keyword_json] = "keyword_json",
  [sym_keyword_jsonb] = "keyword_jsonb",
  [sym_keyword_xml] = "keyword_xml",
  [sym_keyword_bytea] = "keyword_bytea",
  [sym_keyword_enum] = "keyword_enum",
  [sym_keyword_date] = "keyword_date",
  [sym_keyword_datetime] = "keyword_datetime",
  [sym_keyword_datetime2] = "keyword_datetime2",
  [sym_keyword_smalldatetime] = "keyword_smalldatetime",
  [sym_keyword_datetimeoffset] = "keyword_datetimeoffset",
  [sym_keyword_time] = "keyword_time",
  [sym_keyword_timestamp] = "keyword_timestamp",
  [sym_keyword_timestamptz] = "keyword_timestamptz",
  [sym_keyword_interval] = "keyword_interval",
  [sym_keyword_geometry] = "keyword_geometry",
  [sym_keyword_geography] = "keyword_geography",
  [sym_keyword_box2d] = "keyword_box2d",
  [sym_keyword_box3d] = "keyword_box3d",
  [sym_keyword_oid] = "keyword_oid",
  [sym_keyword_oids] = "keyword_oids",
  [sym_keyword_name] = "keyword_name",
  [sym_keyword_regclass] = "keyword_regclass",
  [sym_keyword_regnamespace] = "keyword_regnamespace",
  [sym_keyword_regproc] = "keyword_regproc",
  [sym_keyword_regtype] = "keyword_regtype",
  [sym_keyword_array] = "keyword_array",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [aux_sym_double_token1] = "double_token1",
  [sym_comment] = "comment",
  [sym_marginalia] = "marginalia",
  [anon_sym_EQ] = "=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [sym_parameter] = "parameter",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_COLON] = ":",
  [sym_op_other] = "op_other",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_GT] = "<>",
  [sym_op_unary_other] = "op_unary_other",
  [sym__double_quote_string] = "_double_quote_string",
  [aux_sym__single_quote_string_token1] = "_single_quote_string_token1",
  [aux_sym__single_quote_string_token2] = "_single_quote_string_token2",
  [sym__natural_number] = "_natural_number",
  [aux_sym__integer_token1] = "_integer_token1",
  [aux_sym__decimal_number_token1] = "_decimal_number_token1",
  [aux_sym__bit_string_token1] = "_bit_string_token1",
  [sym_bang] = "bang",
  [aux_sym_identifier_token1] = "identifier_token1",
  [sym__dollar_quoted_string_start_tag] = "dollar_quote",
  [sym__dollar_quoted_string_end_tag] = "dollar_quote",
  [sym__dollar_quoted_string] = "_dollar_quoted_string",
  [sym_program] = "program",
  [sym_keyword_character] = "keyword_character",
  [sym_keyword_like] = "keyword_like",
  [sym_is_not] = "is_not",
  [sym_not_like] = "not_like",
  [sym_similar_to] = "similar_to",
  [sym_not_similar_to] = "not_similar_to",
  [sym_distinct_from] = "distinct_from",
  [sym_not_distinct_from] = "not_distinct_from",
  [sym__temporary] = "_temporary",
  [sym__not_null] = "_not_null",
  [sym__primary_key] = "_primary_key",
  [sym__if_exists] = "_if_exists",
  [sym__if_not_exists] = "_if_not_exists",
  [sym__or_replace] = "_or_replace",
  [sym__current_row] = "_current_row",
  [sym__exclude_current_row] = "_exclude_current_row",
  [sym__exclude_group] = "_exclude_group",
  [sym__exclude_no_others] = "_exclude_no_others",
  [sym__exclude_ties] = "_exclude_ties",
  [sym__check_option] = "_check_option",
  [sym_direction] = "direction",
  [sym_keyword_smallserial] = "keyword_smallserial",
  [sym_keyword_serial] = "keyword_serial",
  [sym_keyword_bigserial] = "keyword_bigserial",
  [sym_keyword_tinyint] = "keyword_tinyint",
  [sym_keyword_smallint] = "keyword_smallint",
  [sym_keyword_mediumint] = "keyword_mediumint",
  [sym_keyword_int] = "keyword_int",
  [sym_keyword_bigint] = "keyword_bigint",
  [sym_keyword_real] = "keyword_real",
  [sym_keyword_char] = "keyword_char",
  [sym_keyword_varchar] = "keyword_varchar",
  [sym__type] = "_type",
  [sym_array_size_definition] = "array_size_definition",
  [sym__array_size_definition] = "_array_size_definition",
  [sym_tinyint] = "tinyint",
  [sym_smallint] = "smallint",
  [sym_mediumint] = "mediumint",
  [sym_int] = "int",
  [sym_bigint] = "bigint",
  [sym_bit] = "bit",
  [sym_binary] = "binary",
  [sym_varbinary] = "varbinary",
  [sym_float] = "float",
  [sym_double] = "double",
  [sym_decimal] = "decimal",
  [sym_numeric] = "numeric",
  [sym_char] = "char",
  [sym_varchar] = "varchar",
  [sym_nchar] = "nchar",
  [sym_nvarchar] = "nvarchar",
  [sym__include_time_zone] = "_include_time_zone",
  [sym_datetimeoffset] = "datetimeoffset",
  [sym_time] = "time",
  [sym_timestamp] = "timestamp",
  [sym_enum] = "enum",
  [sym_array] = "array",
  [sym_transaction] = "transaction",
  [sym__commit] = "_commit",
  [sym__rollback] = "_rollback",
  [sym_block] = "block",
  [sym_statement] = "statement",
  [sym__ddl_statement] = "_ddl_statement",
  [sym__cte] = "_cte",
  [sym__dml_write] = "_dml_write",
  [sym__dml_read] = "_dml_read",
  [sym_cte] = "cte",
  [sym_set_operation] = "set_operation",
  [sym__select_statement] = "_select_statement",
  [sym_comment_statement] = "comment_statement",
  [sym__argmode] = "_argmode",
  [sym_function_argument] = "function_argument",
  [sym_function_arguments] = "function_arguments",
  [sym__comment_target] = "_comment_target",
  [sym_select] = "select",
  [sym_select_expression] = "select_expression",
  [sym_term] = "term",
  [sym__truncate_statement] = "_truncate_statement",
  [sym__delete_statement] = "_delete_statement",
  [sym__delete_from] = "from",
  [sym_delete] = "delete",
  [sym__create_statement] = "_create_statement",
  [sym__table_settings] = "_table_settings",
  [sym_storage_parameters] = "storage_parameters",
  [sym_create_table] = "create_table",
  [sym_reset_statement] = "reset_statement",
  [sym__transaction_mode] = "_transaction_mode",
  [sym_set_statement] = "set_statement",
  [sym_create_query] = "create_query",
  [sym_create_view] = "create_view",
  [sym_create_materialized_view] = "create_materialized_view",
  [sym_create_function] = "create_function",
  [sym__function_return] = "_function_return",
  [sym_function_declaration] = "function_declaration",
  [sym__function_body_statement] = "_function_body_statement",
  [sym_function_body] = "function_body",
  [sym_function_language] = "function_language",
  [sym_function_volatility] = "function_volatility",
  [sym_function_leakproof] = "function_leakproof",
  [sym_function_security] = "function_security",
  [sym_function_safety] = "function_safety",
  [sym_function_strictness] = "function_strictness",
  [sym_function_cost] = "function_cost",
  [sym_function_rows] = "function_rows",
  [sym_function_support] = "function_support",
  [sym__operator_class] = "_operator_class",
  [sym__index_field] = "field",
  [sym_index_fields] = "index_fields",
  [sym_create_index] = "create_index",
  [sym_create_schema] = "create_schema",
  [sym__with_settings] = "_with_settings",
  [sym_create_database] = "create_database",
  [sym_create_role] = "create_role",
  [sym__role_options] = "_role_options",
  [sym__user_access_role_config] = "_user_access_role_config",
  [sym_create_sequence] = "create_sequence",
  [sym_create_extension] = "create_extension",
  [sym_create_trigger] = "create_trigger",
  [sym__create_trigger_event] = "_create_trigger_event",
  [sym_create_type] = "create_type",
  [sym_enum_elements] = "enum_elements",
  [sym__alter_statement] = "_alter_statement",
  [sym__rename_statement] = "_rename_statement",
  [sym__rename_table_names] = "_rename_table_names",
  [sym_alter_table] = "alter_table",
  [sym__alter_specifications] = "_alter_specifications",
  [sym_add_column] = "add_column",
  [sym_add_constraint] = "add_constraint",
  [sym_alter_column] = "alter_column",
  [sym_modify_column] = "modify_column",
  [sym_change_column] = "change_column",
  [sym_column_position] = "column_position",
  [sym_drop_column] = "drop_column",
  [sym_rename_column] = "rename_column",
  [sym_alter_view] = "alter_view",
  [sym_alter_schema] = "alter_schema",
  [sym_alter_database] = "alter_database",
  [sym_alter_role] = "alter_role",
  [sym_set_configuration] = "set_configuration",
  [sym_alter_index] = "alter_index",
  [sym_alter_sequence] = "alter_sequence",
  [sym_alter_type] = "alter_type",
  [sym__drop_behavior] = "_drop_behavior",
  [sym__drop_statement] = "_drop_statement",
  [sym_drop_table] = "drop_table",
  [sym_drop_view] = "drop_view",
  [sym_drop_schema] = "drop_schema",
  [sym_drop_database] = "drop_database",
  [sym_drop_role] = "drop_role",
  [sym_drop_type] = "drop_type",
  [sym_drop_sequence] = "drop_sequence",
  [sym_drop_index] = "drop_index",
  [sym_drop_extension] = "drop_extension",
  [sym_rename_object] = "rename_object",
  [sym_set_schema] = "set_schema",
  [sym_change_ownership] = "change_ownership",
  [sym_object_reference] = "object_reference",
  [sym__copy_statement] = "_copy_statement",
  [sym__insert_statement] = "_insert_statement",
  [sym_insert] = "insert",
  [sym__insert_values] = "_insert_values",
  [sym__set_values] = "_set_values",
  [sym__column_list] = "_column_list",
  [sym__column] = "_column",
  [sym__update_statement] = "_update_statement",
  [sym__merge_statement] = "_merge_statement",
  [sym_when_clause] = "when_clause",
  [sym__optimize_statement] = "_optimize_statement",
  [sym__compute_stats] = "_compute_stats",
  [sym__optimize_table] = "_optimize_table",
  [sym__vacuum_table] = "_vacuum_table",
  [sym__vacuum_option] = "_vacuum_option",
  [sym__partition_spec] = "_partition_spec",
  [sym_update] = "update",
  [sym__mysql_update_statement] = "_mysql_update_statement",
  [sym__postgres_update_statement] = "_postgres_update_statement",
  [sym_storage_location] = "storage_location",
  [sym_row_format] = "row_format",
  [sym_table_sort] = "table_sort",
  [sym_table_partition] = "table_partition",
  [sym__key_value_pair] = "_key_value_pair",
  [sym_stored_as] = "stored_as",
  [sym_assignment] = "assignment",
  [sym_table_option] = "table_option",
  [sym_column_definitions] = "column_definitions",
  [sym_column_definition] = "column_definition",
  [sym__column_comment] = "_column_comment",
  [sym__column_constraint] = "_column_constraint",
  [sym__check_constraint] = "_check_constraint",
  [sym__default_expression] = "_default_expression",
  [sym__inner_default_expression] = "_inner_default_expression",
  [sym_constraints] = "constraints",
  [sym_constraint] = "constraint",
  [sym__constraint_literal] = "_constraint_literal",
  [sym__primary_key_constraint] = "_primary_key_constraint",
  [sym__key_constraint] = "_key_constraint",
  [sym_ordered_columns] = "ordered_columns",
  [sym_ordered_column] = "column",
  [sym_all_fields] = "all_fields",
  [sym_case] = "case",
  [sym_field] = "field",
  [sym__qualified_field] = "field",
  [sym_implicit_cast] = "cast",
  [sym_interval] = "interval",
  [sym_cast] = "cast",
  [sym_filter_expression] = "filter_expression",
  [sym_invocation] = "invocation",
  [sym_exists] = "exists",
  [sym_partition_by] = "partition_by",
  [sym_frame_definition] = "frame_definition",
  [sym_window_frame] = "window_frame",
  [sym_window_clause] = "window_clause",
  [sym_window_specification] = "window_specification",
  [sym_window_function] = "window_function",
  [sym__alias] = "_alias",
  [sym_from] = "from",
  [sym_relation] = "relation",
  [sym_values] = "values",
  [sym_index_hint] = "index_hint",
  [sym_join] = "join",
  [sym_cross_join] = "cross_join",
  [sym_lateral_join] = "lateral_join",
  [sym_lateral_cross_join] = "lateral_cross_join",
  [sym_where] = "where",
  [sym_group_by] = "group_by",
  [sym__having] = "_having",
  [sym_order_by] = "order_by",
  [sym_order_target] = "order_target",
  [sym_limit] = "limit",
  [sym_offset] = "offset",
  [sym_returning] = "returning",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_subscript] = "subscript",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_between_expression] = "between_expression",
  [sym_not_in] = "not_in",
  [sym_subquery] = "subquery",
  [sym_list] = "list",
  [sym_literal] = "literal",
  [sym__single_quote_string] = "_single_quote_string",
  [sym__literal_string] = "_literal_string",
  [sym__integer] = "_integer",
  [sym__decimal_number] = "_decimal_number",
  [sym__bit_string] = "_bit_string",
  [sym__string_casting] = "_string_casting",
  [sym_identifier] = "identifier",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_array_size_definition_repeat1] = "array_size_definition_repeat1",
  [aux_sym_enum_repeat1] = "enum_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_transaction_repeat1] = "transaction_repeat1",
  [aux_sym__cte_repeat1] = "_cte_repeat1",
  [aux_sym_cte_repeat1] = "cte_repeat1",
  [aux_sym_set_operation_repeat1] = "set_operation_repeat1",
  [aux_sym_function_arguments_repeat1] = "function_arguments_repeat1",
  [aux_sym_select_expression_repeat1] = "select_expression_repeat1",
  [aux_sym__truncate_statement_repeat1] = "_truncate_statement_repeat1",
  [aux_sym__create_statement_repeat1] = "_create_statement_repeat1",
  [aux_sym__table_settings_repeat1] = "_table_settings_repeat1",
  [aux_sym_storage_parameters_repeat1] = "storage_parameters_repeat1",
  [aux_sym_create_table_repeat1] = "create_table_repeat1",
  [aux_sym_set_statement_repeat1] = "set_statement_repeat1",
  [aux_sym_create_function_repeat1] = "create_function_repeat1",
  [aux_sym_function_body_repeat1] = "function_body_repeat1",
  [aux_sym_function_body_repeat2] = "function_body_repeat2",
  [aux_sym_index_fields_repeat1] = "index_fields_repeat1",
  [aux_sym_create_database_repeat1] = "create_database_repeat1",
  [aux_sym_create_role_repeat1] = "create_role_repeat1",
  [aux_sym_create_sequence_repeat1] = "create_sequence_repeat1",
  [aux_sym_create_trigger_repeat1] = "create_trigger_repeat1",
  [aux_sym_create_trigger_repeat2] = "create_trigger_repeat2",
  [aux_sym_create_trigger_repeat3] = "create_trigger_repeat3",
  [aux_sym_create_type_repeat1] = "create_type_repeat1",
  [aux_sym_enum_elements_repeat1] = "enum_elements_repeat1",
  [aux_sym__rename_statement_repeat1] = "_rename_statement_repeat1",
  [aux_sym_alter_table_repeat1] = "alter_table_repeat1",
  [aux_sym_alter_column_repeat1] = "alter_column_repeat1",
  [aux_sym_alter_role_repeat1] = "alter_role_repeat1",
  [aux_sym_alter_index_repeat1] = "alter_index_repeat1",
  [aux_sym_alter_sequence_repeat1] = "alter_sequence_repeat1",
  [aux_sym__copy_statement_repeat1] = "_copy_statement_repeat1",
  [aux_sym__insert_values_repeat1] = "_insert_values_repeat1",
  [aux_sym__set_values_repeat1] = "_set_values_repeat1",
  [aux_sym__column_list_repeat1] = "_column_list_repeat1",
  [aux_sym__merge_statement_repeat1] = "_merge_statement_repeat1",
  [aux_sym__compute_stats_repeat1] = "_compute_stats_repeat1",
  [aux_sym__compute_stats_repeat2] = "_compute_stats_repeat2",
  [aux_sym__vacuum_table_repeat1] = "_vacuum_table_repeat1",
  [aux_sym__mysql_update_statement_repeat1] = "_mysql_update_statement_repeat1",
  [aux_sym__mysql_update_statement_repeat2] = "_mysql_update_statement_repeat2",
  [aux_sym_column_definitions_repeat1] = "column_definitions_repeat1",
  [aux_sym_column_definition_repeat1] = "column_definition_repeat1",
  [aux_sym__column_constraint_repeat1] = "_column_constraint_repeat1",
  [aux_sym_constraints_repeat1] = "constraints_repeat1",
  [aux_sym_ordered_columns_repeat1] = "ordered_columns_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_invocation_repeat1] = "invocation_repeat1",
  [aux_sym_from_repeat1] = "from_repeat1",
  [aux_sym_order_by_repeat1] = "order_by_repeat1",
  [aux_sym__single_quote_string_repeat1] = "_single_quote_string_repeat1",
  [anon_alias_sym_command] = "command",
  [anon_alias_sym_filename] = "filename",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier] = sym__identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_keyword_select] = sym_keyword_select,
  [sym_keyword_delete] = sym_keyword_delete,
  [sym_keyword_insert] = sym_keyword_insert,
  [sym_keyword_replace] = sym_keyword_replace,
  [sym_keyword_update] = sym_keyword_update,
  [sym_keyword_truncate] = sym_keyword_truncate,
  [sym_keyword_merge] = sym_keyword_merge,
  [sym_keyword_into] = sym_keyword_into,
  [sym_keyword_overwrite] = sym_keyword_overwrite,
  [sym_keyword_values] = sym_keyword_values,
  [sym_keyword_value] = sym_keyword_value,
  [sym_keyword_matched] = sym_keyword_matched,
  [sym_keyword_set] = sym_keyword_set,
  [sym_keyword_from] = sym_keyword_from,
  [sym_keyword_left] = sym_keyword_left,
  [sym_keyword_right] = sym_keyword_right,
  [sym_keyword_inner] = sym_keyword_inner,
  [sym_keyword_full] = sym_keyword_full,
  [sym_keyword_outer] = sym_keyword_outer,
  [sym_keyword_cross] = sym_keyword_cross,
  [sym_keyword_join] = sym_keyword_join,
  [sym_keyword_lateral] = sym_keyword_lateral,
  [sym_keyword_natural] = sym_keyword_natural,
  [sym_keyword_on] = sym_keyword_on,
  [sym_keyword_off] = sym_keyword_off,
  [sym_keyword_where] = sym_keyword_where,
  [sym_keyword_order] = sym_keyword_order,
  [sym_keyword_group] = sym_keyword_group,
  [sym_keyword_partition] = sym_keyword_partition,
  [sym_keyword_by] = sym_keyword_by,
  [sym_keyword_having] = sym_keyword_having,
  [sym_keyword_desc] = sym_keyword_desc,
  [sym_keyword_asc] = sym_keyword_asc,
  [sym_keyword_limit] = sym_keyword_limit,
  [sym_keyword_offset] = sym_keyword_offset,
  [sym_keyword_primary] = sym_keyword_primary,
  [sym_keyword_create] = sym_keyword_create,
  [sym_keyword_alter] = sym_keyword_alter,
  [sym_keyword_change] = sym_keyword_change,
  [sym_keyword_analyze] = sym_keyword_analyze,
  [sym_keyword_explain] = sym_keyword_explain,
  [sym_keyword_verbose] = sym_keyword_verbose,
  [sym_keyword_modify] = sym_keyword_modify,
  [sym_keyword_drop] = sym_keyword_drop,
  [sym_keyword_add] = sym_keyword_add,
  [sym_keyword_table] = sym_keyword_table,
  [sym_keyword_tables] = sym_keyword_tables,
  [sym_keyword_view] = sym_keyword_view,
  [sym_keyword_column] = sym_keyword_column,
  [sym_keyword_columns] = sym_keyword_columns,
  [sym_keyword_materialized] = sym_keyword_materialized,
  [sym_keyword_tablespace] = sym_keyword_tablespace,
  [sym_keyword_sequence] = sym_keyword_sequence,
  [sym_keyword_increment] = sym_keyword_increment,
  [sym_keyword_minvalue] = sym_keyword_minvalue,
  [sym_keyword_maxvalue] = sym_keyword_maxvalue,
  [sym_keyword_none] = sym_keyword_none,
  [sym_keyword_owned] = sym_keyword_owned,
  [sym_keyword_start] = sym_keyword_start,
  [sym_keyword_restart] = sym_keyword_restart,
  [sym_keyword_key] = sym_keyword_key,
  [sym_keyword_as] = sym_keyword_as,
  [sym_keyword_distinct] = sym_keyword_distinct,
  [sym_keyword_constraint] = sym_keyword_constraint,
  [sym_keyword_filter] = sym_keyword_filter,
  [sym_keyword_cast] = sym_keyword_cast,
  [sym_keyword_separator] = sym_keyword_separator,
  [sym_keyword_max] = sym_keyword_max,
  [sym_keyword_min] = sym_keyword_min,
  [sym_keyword_avg] = sym_keyword_avg,
  [sym_keyword_case] = sym_keyword_case,
  [sym_keyword_when] = sym_keyword_when,
  [sym_keyword_then] = sym_keyword_then,
  [sym_keyword_else] = sym_keyword_else,
  [sym_keyword_end] = sym_keyword_end,
  [sym_keyword_in] = sym_keyword_in,
  [sym_keyword_and] = sym_keyword_and,
  [sym_keyword_or] = sym_keyword_or,
  [sym_keyword_is] = sym_keyword_is,
  [sym_keyword_not] = sym_keyword_not,
  [sym_keyword_force] = sym_keyword_force,
  [sym_keyword_ignore] = sym_keyword_ignore,
  [sym_keyword_using] = sym_keyword_using,
  [sym_keyword_use] = sym_keyword_use,
  [sym_keyword_index] = sym_keyword_index,
  [sym_keyword_for] = sym_keyword_for,
  [sym_keyword_if] = sym_keyword_if,
  [sym_keyword_exists] = sym_keyword_exists,
  [sym_keyword_auto_increment] = sym_keyword_auto_increment,
  [sym_keyword_generated] = sym_keyword_generated,
  [sym_keyword_always] = sym_keyword_always,
  [sym_keyword_collate] = sym_keyword_collate,
  [aux_sym_keyword_character_token1] = aux_sym_keyword_character_token1,
  [sym_keyword_engine] = sym_keyword_engine,
  [sym_keyword_default] = sym_keyword_default,
  [sym_keyword_cascade] = sym_keyword_cascade,
  [sym_keyword_restrict] = sym_keyword_restrict,
  [sym_keyword_with] = sym_keyword_with,
  [sym_keyword_without] = sym_keyword_without,
  [sym_keyword_no] = sym_keyword_no,
  [sym_keyword_data] = sym_keyword_data,
  [sym_keyword_type] = sym_keyword_type,
  [sym_keyword_rename] = sym_keyword_rename,
  [sym_keyword_to] = sym_keyword_to,
  [sym_keyword_database] = sym_keyword_database,
  [sym_keyword_schema] = sym_keyword_schema,
  [sym_keyword_owner] = sym_keyword_owner,
  [sym_keyword_user] = sym_keyword_user,
  [sym_keyword_admin] = sym_keyword_admin,
  [sym_keyword_password] = sym_keyword_password,
  [sym_keyword_encrypted] = sym_keyword_encrypted,
  [sym_keyword_valid] = sym_keyword_valid,
  [sym_keyword_until] = sym_keyword_until,
  [sym_keyword_connection] = sym_keyword_connection,
  [sym_keyword_role] = sym_keyword_role,
  [sym_keyword_reset] = sym_keyword_reset,
  [sym_keyword_temp] = sym_keyword_temp,
  [sym_keyword_temporary] = sym_keyword_temporary,
  [sym_keyword_unlogged] = sym_keyword_unlogged,
  [sym_keyword_logged] = sym_keyword_logged,
  [sym_keyword_cycle] = sym_keyword_cycle,
  [sym_keyword_union] = sym_keyword_union,
  [sym_keyword_all] = sym_keyword_all,
  [sym_keyword_any] = sym_keyword_any,
  [sym_keyword_some] = sym_keyword_some,
  [sym_keyword_except] = sym_keyword_except,
  [sym_keyword_intersect] = sym_keyword_intersect,
  [sym_keyword_returning] = sym_keyword_returning,
  [sym_keyword_begin] = sym_keyword_begin,
  [sym_keyword_commit] = sym_keyword_commit,
  [sym_keyword_rollback] = sym_keyword_rollback,
  [sym_keyword_transaction] = sym_keyword_transaction,
  [sym_keyword_over] = sym_keyword_over,
  [sym_keyword_nulls] = sym_keyword_nulls,
  [sym_keyword_first] = sym_keyword_first,
  [sym_keyword_after] = sym_keyword_after,
  [sym_keyword_before] = sym_keyword_before,
  [sym_keyword_last] = sym_keyword_last,
  [sym_keyword_window] = sym_keyword_window,
  [sym_keyword_range] = sym_keyword_range,
  [sym_keyword_rows] = sym_keyword_rows,
  [sym_keyword_groups] = sym_keyword_groups,
  [sym_keyword_between] = sym_keyword_between,
  [sym_keyword_unbounded] = sym_keyword_unbounded,
  [sym_keyword_preceding] = sym_keyword_preceding,
  [sym_keyword_following] = sym_keyword_following,
  [sym_keyword_exclude] = sym_keyword_exclude,
  [sym_keyword_current] = sym_keyword_current,
  [sym_keyword_row] = sym_keyword_row,
  [sym_keyword_ties] = sym_keyword_ties,
  [sym_keyword_others] = sym_keyword_others,
  [sym_keyword_only] = sym_keyword_only,
  [sym_keyword_unique] = sym_keyword_unique,
  [sym_keyword_foreign] = sym_keyword_foreign,
  [sym_keyword_references] = sym_keyword_references,
  [sym_keyword_concurrently] = sym_keyword_concurrently,
  [sym_keyword_btree] = sym_keyword_btree,
  [sym_keyword_hash] = sym_keyword_hash,
  [sym_keyword_gist] = sym_keyword_gist,
  [sym_keyword_spgist] = sym_keyword_spgist,
  [sym_keyword_gin] = sym_keyword_gin,
  [sym_keyword_brin] = sym_keyword_brin,
  [aux_sym_keyword_like_token1] = aux_sym_keyword_like_token1,
  [aux_sym_keyword_like_token2] = aux_sym_keyword_like_token2,
  [sym_keyword_similar] = sym_keyword_similar,
  [sym_keyword_preserve] = sym_keyword_preserve,
  [sym_keyword_unsigned] = sym_keyword_unsigned,
  [sym_keyword_zerofill] = sym_keyword_zerofill,
  [sym_keyword_conflict] = sym_keyword_conflict,
  [sym_keyword_do] = sym_keyword_do,
  [sym_keyword_nothing] = sym_keyword_nothing,
  [sym_keyword_high_priority] = sym_keyword_high_priority,
  [sym_keyword_low_priority] = sym_keyword_low_priority,
  [sym_keyword_delayed] = sym_keyword_delayed,
  [sym_keyword_recursive] = sym_keyword_recursive,
  [sym_keyword_cascaded] = sym_keyword_cascaded,
  [sym_keyword_local] = sym_keyword_local,
  [sym_keyword_current_timestamp] = sym_keyword_current_timestamp,
  [sym_keyword_check] = sym_keyword_check,
  [sym_keyword_option] = sym_keyword_option,
  [sym_keyword_vacuum] = sym_keyword_vacuum,
  [sym_keyword_wait] = sym_keyword_wait,
  [sym_keyword_nowait] = sym_keyword_nowait,
  [sym_keyword_attribute] = sym_keyword_attribute,
  [sym_keyword_authorization] = sym_keyword_authorization,
  [sym_keyword_action] = sym_keyword_action,
  [sym_keyword_extension] = sym_keyword_extension,
  [sym_keyword_copy] = sym_keyword_copy,
  [sym_keyword_stdin] = sym_keyword_stdin,
  [sym_keyword_freeze] = sym_keyword_freeze,
  [sym_keyword_escape] = sym_keyword_escape,
  [sym_keyword_encoding] = sym_keyword_encoding,
  [sym_keyword_force_quote] = sym_keyword_force_quote,
  [sym_keyword_quote] = sym_keyword_quote,
  [sym_keyword_force_null] = sym_keyword_force_null,
  [sym_keyword_force_not_null] = sym_keyword_force_not_null,
  [sym_keyword_header] = sym_keyword_header,
  [sym_keyword_match] = sym_keyword_match,
  [sym_keyword_program] = sym_keyword_program,
  [sym_keyword_plain] = sym_keyword_plain,
  [sym_keyword_extended] = sym_keyword_extended,
  [sym_keyword_main] = sym_keyword_main,
  [sym_keyword_storage] = sym_keyword_storage,
  [sym_keyword_compression] = sym_keyword_compression,
  [sym_keyword_trigger] = sym_keyword_trigger,
  [sym_keyword_function] = sym_keyword_function,
  [sym_keyword_returns] = sym_keyword_returns,
  [sym_keyword_return] = sym_keyword_return,
  [sym_keyword_setof] = sym_keyword_setof,
  [sym_keyword_atomic] = sym_keyword_atomic,
  [sym_keyword_declare] = sym_keyword_declare,
  [sym_keyword_language] = sym_keyword_language,
  [sym_keyword_sql] = sym_keyword_sql,
  [sym_keyword_plpgsql] = sym_keyword_plpgsql,
  [sym_keyword_immutable] = sym_keyword_immutable,
  [sym_keyword_stable] = sym_keyword_stable,
  [sym_keyword_volatile] = sym_keyword_volatile,
  [sym_keyword_leakproof] = sym_keyword_leakproof,
  [sym_keyword_parallel] = sym_keyword_parallel,
  [sym_keyword_safe] = sym_keyword_safe,
  [sym_keyword_unsafe] = sym_keyword_unsafe,
  [sym_keyword_restricted] = sym_keyword_restricted,
  [sym_keyword_called] = sym_keyword_called,
  [sym_keyword_input] = sym_keyword_input,
  [sym_keyword_strict] = sym_keyword_strict,
  [sym_keyword_cost] = sym_keyword_cost,
  [sym_keyword_support] = sym_keyword_support,
  [sym_keyword_definer] = sym_keyword_definer,
  [sym_keyword_invoker] = sym_keyword_invoker,
  [sym_keyword_security] = sym_keyword_security,
  [sym_keyword_version] = sym_keyword_version,
  [sym_keyword_out] = sym_keyword_out,
  [sym_keyword_inout] = sym_keyword_inout,
  [sym_keyword_variadic] = sym_keyword_variadic,
  [sym_keyword_session] = sym_keyword_session,
  [sym_keyword_isolation] = sym_keyword_isolation,
  [sym_keyword_level] = sym_keyword_level,
  [sym_keyword_serializable] = sym_keyword_serializable,
  [sym_keyword_repeatable] = sym_keyword_repeatable,
  [sym_keyword_read] = sym_keyword_read,
  [sym_keyword_write] = sym_keyword_write,
  [sym_keyword_committed] = sym_keyword_committed,
  [sym_keyword_uncommitted] = sym_keyword_uncommitted,
  [sym_keyword_deferrable] = sym_keyword_deferrable,
  [sym_keyword_names] = sym_keyword_names,
  [sym_keyword_zone] = sym_keyword_zone,
  [sym_keyword_immediate] = sym_keyword_immediate,
  [sym_keyword_deferred] = sym_keyword_deferred,
  [sym_keyword_constraints] = sym_keyword_constraints,
  [sym_keyword_snapshot] = sym_keyword_snapshot,
  [sym_keyword_characteristics] = sym_keyword_characteristics,
  [sym_keyword_follows] = sym_keyword_follows,
  [sym_keyword_precedes] = sym_keyword_precedes,
  [sym_keyword_each] = sym_keyword_each,
  [sym_keyword_instead] = sym_keyword_instead,
  [sym_keyword_of] = sym_keyword_of,
  [sym_keyword_initially] = sym_keyword_initially,
  [sym_keyword_old] = sym_keyword_old,
  [sym_keyword_new] = sym_keyword_new,
  [sym_keyword_referencing] = sym_keyword_referencing,
  [sym_keyword_statement] = sym_keyword_statement,
  [sym_keyword_execute] = sym_keyword_execute,
  [sym_keyword_procedure] = sym_keyword_procedure,
  [sym_keyword_external] = sym_keyword_external,
  [sym_keyword_stored] = sym_keyword_stored,
  [sym_keyword_virtual] = sym_keyword_virtual,
  [sym_keyword_cached] = sym_keyword_cached,
  [sym_keyword_uncached] = sym_keyword_uncached,
  [sym_keyword_replication] = sym_keyword_replication,
  [sym_keyword_tblproperties] = sym_keyword_tblproperties,
  [sym_keyword_options] = sym_keyword_options,
  [sym_keyword_compute] = sym_keyword_compute,
  [sym_keyword_stats] = sym_keyword_stats,
  [sym_keyword_statistics] = sym_keyword_statistics,
  [sym_keyword_optimize] = sym_keyword_optimize,
  [sym_keyword_rewrite] = sym_keyword_rewrite,
  [sym_keyword_bin_pack] = sym_keyword_bin_pack,
  [sym_keyword_incremental] = sym_keyword_incremental,
  [sym_keyword_location] = sym_keyword_location,
  [sym_keyword_partitioned] = sym_keyword_partitioned,
  [sym_keyword_comment] = sym_keyword_comment,
  [sym_keyword_sort] = sym_keyword_sort,
  [sym_keyword_format] = sym_keyword_format,
  [sym_keyword_delimited] = sym_keyword_delimited,
  [sym_keyword_delimiter] = sym_keyword_delimiter,
  [sym_keyword_fields] = sym_keyword_fields,
  [sym_keyword_terminated] = sym_keyword_terminated,
  [sym_keyword_escaped] = sym_keyword_escaped,
  [sym_keyword_lines] = sym_keyword_lines,
  [sym_keyword_cache] = sym_keyword_cache,
  [sym_keyword_metadata] = sym_keyword_metadata,
  [sym_keyword_noscan] = sym_keyword_noscan,
  [sym_keyword_parquet] = sym_keyword_parquet,
  [sym_keyword_rcfile] = sym_keyword_rcfile,
  [sym_keyword_csv] = sym_keyword_csv,
  [sym_keyword_textfile] = sym_keyword_textfile,
  [sym_keyword_avro] = sym_keyword_avro,
  [sym_keyword_sequencefile] = sym_keyword_sequencefile,
  [sym_keyword_orc] = sym_keyword_orc,
  [sym_keyword_jsonfile] = sym_keyword_jsonfile,
  [sym_keyword_null] = sym_keyword_null,
  [sym_keyword_true] = sym_keyword_true,
  [sym_keyword_false] = sym_keyword_false,
  [sym_keyword_boolean] = sym_keyword_boolean,
  [sym_keyword_bit] = sym_keyword_bit,
  [sym_keyword_binary] = sym_keyword_binary,
  [sym_keyword_varbinary] = sym_keyword_varbinary,
  [sym_keyword_image] = sym_keyword_image,
  [aux_sym_keyword_smallserial_token1] = aux_sym_keyword_smallserial_token1,
  [aux_sym_keyword_smallserial_token2] = aux_sym_keyword_smallserial_token2,
  [aux_sym_keyword_serial_token1] = aux_sym_keyword_serial_token1,
  [aux_sym_keyword_serial_token2] = aux_sym_keyword_serial_token2,
  [aux_sym_keyword_bigserial_token1] = aux_sym_keyword_bigserial_token1,
  [aux_sym_keyword_bigserial_token2] = aux_sym_keyword_bigserial_token2,
  [aux_sym_keyword_tinyint_token1] = aux_sym_keyword_tinyint_token1,
  [aux_sym_keyword_tinyint_token2] = aux_sym_keyword_tinyint_token2,
  [aux_sym_keyword_smallint_token1] = aux_sym_keyword_smallint_token1,
  [aux_sym_keyword_smallint_token2] = aux_sym_keyword_smallint_token2,
  [aux_sym_keyword_mediumint_token1] = aux_sym_keyword_mediumint_token1,
  [aux_sym_keyword_mediumint_token2] = aux_sym_keyword_mediumint_token2,
  [aux_sym_keyword_int_token1] = aux_sym_keyword_int_token1,
  [aux_sym_keyword_int_token2] = aux_sym_keyword_int_token2,
  [aux_sym_keyword_int_token3] = aux_sym_keyword_int_token3,
  [aux_sym_keyword_bigint_token1] = aux_sym_keyword_bigint_token1,
  [aux_sym_keyword_bigint_token2] = aux_sym_keyword_bigint_token2,
  [sym_keyword_decimal] = sym_keyword_decimal,
  [sym_keyword_numeric] = sym_keyword_numeric,
  [aux_sym_keyword_real_token1] = aux_sym_keyword_real_token1,
  [aux_sym_keyword_real_token2] = aux_sym_keyword_real_token2,
  [sym_keyword_float] = sym_keyword_float,
  [sym_keyword_double] = sym_keyword_double,
  [sym_keyword_precision] = sym_keyword_precision,
  [sym_keyword_inet] = sym_keyword_inet,
  [sym_keyword_money] = sym_keyword_money,
  [sym_keyword_smallmoney] = sym_keyword_smallmoney,
  [sym_keyword_varying] = sym_keyword_varying,
  [aux_sym_keyword_char_token1] = aux_sym_keyword_char_token1,
  [sym_keyword_nchar] = sym_keyword_nchar,
  [aux_sym_keyword_varchar_token1] = aux_sym_keyword_varchar_token1,
  [sym_keyword_nvarchar] = sym_keyword_nvarchar,
  [sym_keyword_text] = sym_keyword_text,
  [sym_keyword_string] = sym_keyword_string,
  [sym_keyword_uuid] = sym_keyword_uuid,
  [sym_keyword_json] = sym_keyword_json,
  [sym_keyword_jsonb] = sym_keyword_jsonb,
  [sym_keyword_xml] = sym_keyword_xml,
  [sym_keyword_bytea] = sym_keyword_bytea,
  [sym_keyword_enum] = sym_keyword_enum,
  [sym_keyword_date] = sym_keyword_date,
  [sym_keyword_datetime] = sym_keyword_datetime,
  [sym_keyword_datetime2] = sym_keyword_datetime2,
  [sym_keyword_smalldatetime] = sym_keyword_smalldatetime,
  [sym_keyword_datetimeoffset] = sym_keyword_datetimeoffset,
  [sym_keyword_time] = sym_keyword_time,
  [sym_keyword_timestamp] = sym_keyword_timestamp,
  [sym_keyword_timestamptz] = sym_keyword_timestamptz,
  [sym_keyword_interval] = sym_keyword_interval,
  [sym_keyword_geometry] = sym_keyword_geometry,
  [sym_keyword_geography] = sym_keyword_geography,
  [sym_keyword_box2d] = sym_keyword_box2d,
  [sym_keyword_box3d] = sym_keyword_box3d,
  [sym_keyword_oid] = sym_keyword_oid,
  [sym_keyword_oids] = sym_keyword_oids,
  [sym_keyword_name] = sym_keyword_name,
  [sym_keyword_regclass] = sym_keyword_regclass,
  [sym_keyword_regnamespace] = sym_keyword_regnamespace,
  [sym_keyword_regproc] = sym_keyword_regproc,
  [sym_keyword_regtype] = sym_keyword_regtype,
  [sym_keyword_array] = sym_keyword_array,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_double_token1] = aux_sym_double_token1,
  [sym_comment] = sym_comment,
  [sym_marginalia] = sym_marginalia,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [sym_parameter] = sym_parameter,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_op_other] = sym_op_other,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [sym_op_unary_other] = sym_op_unary_other,
  [sym__double_quote_string] = sym__double_quote_string,
  [aux_sym__single_quote_string_token1] = aux_sym__single_quote_string_token1,
  [aux_sym__single_quote_string_token2] = aux_sym__single_quote_string_token2,
  [sym__natural_number] = sym__natural_number,
  [aux_sym__integer_token1] = aux_sym__integer_token1,
  [aux_sym__decimal_number_token1] = aux_sym__decimal_number_token1,
  [aux_sym__bit_string_token1] = aux_sym__bit_string_token1,
  [sym_bang] = sym_bang,
  [aux_sym_identifier_token1] = aux_sym_identifier_token1,
  [sym__dollar_quoted_string_start_tag] = sym__dollar_quoted_string_start_tag,
  [sym__dollar_quoted_string_end_tag] = sym__dollar_quoted_string_start_tag,
  [sym__dollar_quoted_string] = sym__dollar_quoted_string,
  [sym_program] = sym_program,
  [sym_keyword_character] = sym_keyword_character,
  [sym_keyword_like] = sym_keyword_like,
  [sym_is_not] = sym_is_not,
  [sym_not_like] = sym_not_like,
  [sym_similar_to] = sym_similar_to,
  [sym_not_similar_to] = sym_not_similar_to,
  [sym_distinct_from] = sym_distinct_from,
  [sym_not_distinct_from] = sym_not_distinct_from,
  [sym__temporary] = sym__temporary,
  [sym__not_null] = sym__not_null,
  [sym__primary_key] = sym__primary_key,
  [sym__if_exists] = sym__if_exists,
  [sym__if_not_exists] = sym__if_not_exists,
  [sym__or_replace] = sym__or_replace,
  [sym__current_row] = sym__current_row,
  [sym__exclude_current_row] = sym__exclude_current_row,
  [sym__exclude_group] = sym__exclude_group,
  [sym__exclude_no_others] = sym__exclude_no_others,
  [sym__exclude_ties] = sym__exclude_ties,
  [sym__check_option] = sym__check_option,
  [sym_direction] = sym_direction,
  [sym_keyword_smallserial] = sym_keyword_smallserial,
  [sym_keyword_serial] = sym_keyword_serial,
  [sym_keyword_bigserial] = sym_keyword_bigserial,
  [sym_keyword_tinyint] = sym_keyword_tinyint,
  [sym_keyword_smallint] = sym_keyword_smallint,
  [sym_keyword_mediumint] = sym_keyword_mediumint,
  [sym_keyword_int] = sym_keyword_int,
  [sym_keyword_bigint] = sym_keyword_bigint,
  [sym_keyword_real] = sym_keyword_real,
  [sym_keyword_char] = sym_keyword_char,
  [sym_keyword_varchar] = sym_keyword_varchar,
  [sym__type] = sym__type,
  [sym_array_size_definition] = sym_array_size_definition,
  [sym__array_size_definition] = sym__array_size_definition,
  [sym_tinyint] = sym_tinyint,
  [sym_smallint] = sym_smallint,
  [sym_mediumint] = sym_mediumint,
  [sym_int] = sym_int,
  [sym_bigint] = sym_bigint,
  [sym_bit] = sym_bit,
  [sym_binary] = sym_binary,
  [sym_varbinary] = sym_varbinary,
  [sym_float] = sym_float,
  [sym_double] = sym_double,
  [sym_decimal] = sym_decimal,
  [sym_numeric] = sym_numeric,
  [sym_char] = sym_char,
  [sym_varchar] = sym_varchar,
  [sym_nchar] = sym_nchar,
  [sym_nvarchar] = sym_nvarchar,
  [sym__include_time_zone] = sym__include_time_zone,
  [sym_datetimeoffset] = sym_datetimeoffset,
  [sym_time] = sym_time,
  [sym_timestamp] = sym_timestamp,
  [sym_enum] = sym_enum,
  [sym_array] = sym_array,
  [sym_transaction] = sym_transaction,
  [sym__commit] = sym__commit,
  [sym__rollback] = sym__rollback,
  [sym_block] = sym_block,
  [sym_statement] = sym_statement,
  [sym__ddl_statement] = sym__ddl_statement,
  [sym__cte] = sym__cte,
  [sym__dml_write] = sym__dml_write,
  [sym__dml_read] = sym__dml_read,
  [sym_cte] = sym_cte,
  [sym_set_operation] = sym_set_operation,
  [sym__select_statement] = sym__select_statement,
  [sym_comment_statement] = sym_comment_statement,
  [sym__argmode] = sym__argmode,
  [sym_function_argument] = sym_function_argument,
  [sym_function_arguments] = sym_function_arguments,
  [sym__comment_target] = sym__comment_target,
  [sym_select] = sym_select,
  [sym_select_expression] = sym_select_expression,
  [sym_term] = sym_term,
  [sym__truncate_statement] = sym__truncate_statement,
  [sym__delete_statement] = sym__delete_statement,
  [sym__delete_from] = sym_from,
  [sym_delete] = sym_delete,
  [sym__create_statement] = sym__create_statement,
  [sym__table_settings] = sym__table_settings,
  [sym_storage_parameters] = sym_storage_parameters,
  [sym_create_table] = sym_create_table,
  [sym_reset_statement] = sym_reset_statement,
  [sym__transaction_mode] = sym__transaction_mode,
  [sym_set_statement] = sym_set_statement,
  [sym_create_query] = sym_create_query,
  [sym_create_view] = sym_create_view,
  [sym_create_materialized_view] = sym_create_materialized_view,
  [sym_create_function] = sym_create_function,
  [sym__function_return] = sym__function_return,
  [sym_function_declaration] = sym_function_declaration,
  [sym__function_body_statement] = sym__function_body_statement,
  [sym_function_body] = sym_function_body,
  [sym_function_language] = sym_function_language,
  [sym_function_volatility] = sym_function_volatility,
  [sym_function_leakproof] = sym_function_leakproof,
  [sym_function_security] = sym_function_security,
  [sym_function_safety] = sym_function_safety,
  [sym_function_strictness] = sym_function_strictness,
  [sym_function_cost] = sym_function_cost,
  [sym_function_rows] = sym_function_rows,
  [sym_function_support] = sym_function_support,
  [sym__operator_class] = sym__operator_class,
  [sym__index_field] = sym_field,
  [sym_index_fields] = sym_index_fields,
  [sym_create_index] = sym_create_index,
  [sym_create_schema] = sym_create_schema,
  [sym__with_settings] = sym__with_settings,
  [sym_create_database] = sym_create_database,
  [sym_create_role] = sym_create_role,
  [sym__role_options] = sym__role_options,
  [sym__user_access_role_config] = sym__user_access_role_config,
  [sym_create_sequence] = sym_create_sequence,
  [sym_create_extension] = sym_create_extension,
  [sym_create_trigger] = sym_create_trigger,
  [sym__create_trigger_event] = sym__create_trigger_event,
  [sym_create_type] = sym_create_type,
  [sym_enum_elements] = sym_enum_elements,
  [sym__alter_statement] = sym__alter_statement,
  [sym__rename_statement] = sym__rename_statement,
  [sym__rename_table_names] = sym__rename_table_names,
  [sym_alter_table] = sym_alter_table,
  [sym__alter_specifications] = sym__alter_specifications,
  [sym_add_column] = sym_add_column,
  [sym_add_constraint] = sym_add_constraint,
  [sym_alter_column] = sym_alter_column,
  [sym_modify_column] = sym_modify_column,
  [sym_change_column] = sym_change_column,
  [sym_column_position] = sym_column_position,
  [sym_drop_column] = sym_drop_column,
  [sym_rename_column] = sym_rename_column,
  [sym_alter_view] = sym_alter_view,
  [sym_alter_schema] = sym_alter_schema,
  [sym_alter_database] = sym_alter_database,
  [sym_alter_role] = sym_alter_role,
  [sym_set_configuration] = sym_set_configuration,
  [sym_alter_index] = sym_alter_index,
  [sym_alter_sequence] = sym_alter_sequence,
  [sym_alter_type] = sym_alter_type,
  [sym__drop_behavior] = sym__drop_behavior,
  [sym__drop_statement] = sym__drop_statement,
  [sym_drop_table] = sym_drop_table,
  [sym_drop_view] = sym_drop_view,
  [sym_drop_schema] = sym_drop_schema,
  [sym_drop_database] = sym_drop_database,
  [sym_drop_role] = sym_drop_role,
  [sym_drop_type] = sym_drop_type,
  [sym_drop_sequence] = sym_drop_sequence,
  [sym_drop_index] = sym_drop_index,
  [sym_drop_extension] = sym_drop_extension,
  [sym_rename_object] = sym_rename_object,
  [sym_set_schema] = sym_set_schema,
  [sym_change_ownership] = sym_change_ownership,
  [sym_object_reference] = sym_object_reference,
  [sym__copy_statement] = sym__copy_statement,
  [sym__insert_statement] = sym__insert_statement,
  [sym_insert] = sym_insert,
  [sym__insert_values] = sym__insert_values,
  [sym__set_values] = sym__set_values,
  [sym__column_list] = sym__column_list,
  [sym__column] = sym__column,
  [sym__update_statement] = sym__update_statement,
  [sym__merge_statement] = sym__merge_statement,
  [sym_when_clause] = sym_when_clause,
  [sym__optimize_statement] = sym__optimize_statement,
  [sym__compute_stats] = sym__compute_stats,
  [sym__optimize_table] = sym__optimize_table,
  [sym__vacuum_table] = sym__vacuum_table,
  [sym__vacuum_option] = sym__vacuum_option,
  [sym__partition_spec] = sym__partition_spec,
  [sym_update] = sym_update,
  [sym__mysql_update_statement] = sym__mysql_update_statement,
  [sym__postgres_update_statement] = sym__postgres_update_statement,
  [sym_storage_location] = sym_storage_location,
  [sym_row_format] = sym_row_format,
  [sym_table_sort] = sym_table_sort,
  [sym_table_partition] = sym_table_partition,
  [sym__key_value_pair] = sym__key_value_pair,
  [sym_stored_as] = sym_stored_as,
  [sym_assignment] = sym_assignment,
  [sym_table_option] = sym_table_option,
  [sym_column_definitions] = sym_column_definitions,
  [sym_column_definition] = sym_column_definition,
  [sym__column_comment] = sym__column_comment,
  [sym__column_constraint] = sym__column_constraint,
  [sym__check_constraint] = sym__check_constraint,
  [sym__default_expression] = sym__default_expression,
  [sym__inner_default_expression] = sym__inner_default_expression,
  [sym_constraints] = sym_constraints,
  [sym_constraint] = sym_constraint,
  [sym__constraint_literal] = sym__constraint_literal,
  [sym__primary_key_constraint] = sym__primary_key_constraint,
  [sym__key_constraint] = sym__key_constraint,
  [sym_ordered_columns] = sym_ordered_columns,
  [sym_ordered_column] = sym_ordered_column,
  [sym_all_fields] = sym_all_fields,
  [sym_case] = sym_case,
  [sym_field] = sym_field,
  [sym__qualified_field] = sym_field,
  [sym_implicit_cast] = sym_cast,
  [sym_interval] = sym_interval,
  [sym_cast] = sym_cast,
  [sym_filter_expression] = sym_filter_expression,
  [sym_invocation] = sym_invocation,
  [sym_exists] = sym_exists,
  [sym_partition_by] = sym_partition_by,
  [sym_frame_definition] = sym_frame_definition,
  [sym_window_frame] = sym_window_frame,
  [sym_window_clause] = sym_window_clause,
  [sym_window_specification] = sym_window_specification,
  [sym_window_function] = sym_window_function,
  [sym__alias] = sym__alias,
  [sym_from] = sym_from,
  [sym_relation] = sym_relation,
  [sym_values] = sym_values,
  [sym_index_hint] = sym_index_hint,
  [sym_join] = sym_join,
  [sym_cross_join] = sym_cross_join,
  [sym_lateral_join] = sym_lateral_join,
  [sym_lateral_cross_join] = sym_lateral_cross_join,
  [sym_where] = sym_where,
  [sym_group_by] = sym_group_by,
  [sym__having] = sym__having,
  [sym_order_by] = sym_order_by,
  [sym_order_target] = sym_order_target,
  [sym_limit] = sym_limit,
  [sym_offset] = sym_offset,
  [sym_returning] = sym_returning,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_subscript] = sym_subscript,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_between_expression] = sym_between_expression,
  [sym_not_in] = sym_not_in,
  [sym_subquery] = sym_subquery,
  [sym_list] = sym_list,
  [sym_literal] = sym_literal,
  [sym__single_quote_string] = sym__single_quote_string,
  [sym__literal_string] = sym__literal_string,
  [sym__integer] = sym__integer,
  [sym__decimal_number] = sym__decimal_number,
  [sym__bit_string] = sym__bit_string,
  [sym__string_casting] = sym__string_casting,
  [sym_identifier] = sym_identifier,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_array_size_definition_repeat1] = aux_sym_array_size_definition_repeat1,
  [aux_sym_enum_repeat1] = aux_sym_enum_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_transaction_repeat1] = aux_sym_transaction_repeat1,
  [aux_sym__cte_repeat1] = aux_sym__cte_repeat1,
  [aux_sym_cte_repeat1] = aux_sym_cte_repeat1,
  [aux_sym_set_operation_repeat1] = aux_sym_set_operation_repeat1,
  [aux_sym_function_arguments_repeat1] = aux_sym_function_arguments_repeat1,
  [aux_sym_select_expression_repeat1] = aux_sym_select_expression_repeat1,
  [aux_sym__truncate_statement_repeat1] = aux_sym__truncate_statement_repeat1,
  [aux_sym__create_statement_repeat1] = aux_sym__create_statement_repeat1,
  [aux_sym__table_settings_repeat1] = aux_sym__table_settings_repeat1,
  [aux_sym_storage_parameters_repeat1] = aux_sym_storage_parameters_repeat1,
  [aux_sym_create_table_repeat1] = aux_sym_create_table_repeat1,
  [aux_sym_set_statement_repeat1] = aux_sym_set_statement_repeat1,
  [aux_sym_create_function_repeat1] = aux_sym_create_function_repeat1,
  [aux_sym_function_body_repeat1] = aux_sym_function_body_repeat1,
  [aux_sym_function_body_repeat2] = aux_sym_function_body_repeat2,
  [aux_sym_index_fields_repeat1] = aux_sym_index_fields_repeat1,
  [aux_sym_create_database_repeat1] = aux_sym_create_database_repeat1,
  [aux_sym_create_role_repeat1] = aux_sym_create_role_repeat1,
  [aux_sym_create_sequence_repeat1] = aux_sym_create_sequence_repeat1,
  [aux_sym_create_trigger_repeat1] = aux_sym_create_trigger_repeat1,
  [aux_sym_create_trigger_repeat2] = aux_sym_create_trigger_repeat2,
  [aux_sym_create_trigger_repeat3] = aux_sym_create_trigger_repeat3,
  [aux_sym_create_type_repeat1] = aux_sym_create_type_repeat1,
  [aux_sym_enum_elements_repeat1] = aux_sym_enum_elements_repeat1,
  [aux_sym__rename_statement_repeat1] = aux_sym__rename_statement_repeat1,
  [aux_sym_alter_table_repeat1] = aux_sym_alter_table_repeat1,
  [aux_sym_alter_column_repeat1] = aux_sym_alter_column_repeat1,
  [aux_sym_alter_role_repeat1] = aux_sym_alter_role_repeat1,
  [aux_sym_alter_index_repeat1] = aux_sym_alter_index_repeat1,
  [aux_sym_alter_sequence_repeat1] = aux_sym_alter_sequence_repeat1,
  [aux_sym__copy_statement_repeat1] = aux_sym__copy_statement_repeat1,
  [aux_sym__insert_values_repeat1] = aux_sym__insert_values_repeat1,
  [aux_sym__set_values_repeat1] = aux_sym__set_values_repeat1,
  [aux_sym__column_list_repeat1] = aux_sym__column_list_repeat1,
  [aux_sym__merge_statement_repeat1] = aux_sym__merge_statement_repeat1,
  [aux_sym__compute_stats_repeat1] = aux_sym__compute_stats_repeat1,
  [aux_sym__compute_stats_repeat2] = aux_sym__compute_stats_repeat2,
  [aux_sym__vacuum_table_repeat1] = aux_sym__vacuum_table_repeat1,
  [aux_sym__mysql_update_statement_repeat1] = aux_sym__mysql_update_statement_repeat1,
  [aux_sym__mysql_update_statement_repeat2] = aux_sym__mysql_update_statement_repeat2,
  [aux_sym_column_definitions_repeat1] = aux_sym_column_definitions_repeat1,
  [aux_sym_column_definition_repeat1] = aux_sym_column_definition_repeat1,
  [aux_sym__column_constraint_repeat1] = aux_sym__column_constraint_repeat1,
  [aux_sym_constraints_repeat1] = aux_sym_constraints_repeat1,
  [aux_sym_ordered_columns_repeat1] = aux_sym_ordered_columns_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_invocation_repeat1] = aux_sym_invocation_repeat1,
  [aux_sym_from_repeat1] = aux_sym_from_repeat1,
  [aux_sym_order_by_repeat1] = aux_sym_order_by_repeat1,
  [aux_sym__single_quote_string_repeat1] = aux_sym__single_quote_string_repeat1,
  [anon_alias_sym_command] = anon_alias_sym_command,
  [anon_alias_sym_filename] = anon_alias_sym_filename,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_keyword_select] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_delete] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_insert] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_update] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_truncate] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_merge] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_into] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_overwrite] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_values] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_value] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_matched] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_set] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_from] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_left] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_right] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_inner] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_full] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_outer] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cross] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_join] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_lateral] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_natural] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_on] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_off] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_where] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_order] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_group] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_partition] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_by] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_having] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_desc] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_asc] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_limit] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_offset] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_primary] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_create] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_alter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_change] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_analyze] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_explain] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_verbose] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_modify] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_drop] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_add] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_table] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_tables] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_view] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_column] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_columns] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_materialized] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_tablespace] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_increment] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_minvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_maxvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_none] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_owned] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_start] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_restart] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_key] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_as] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_distinct] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_filter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_max] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_min] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_avg] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_case] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_when] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_then] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_else] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_end] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_in] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_and] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_or] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_is] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_not] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_force] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_ignore] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_using] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_use] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_index] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_for] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_if] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_auto_increment] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_generated] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_always] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_collate] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_character_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_engine] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_default] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cascade] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_restrict] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_with] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_without] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_no] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_data] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rename] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_to] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_database] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_schema] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_owner] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_user] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_admin] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_password] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_encrypted] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_valid] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_until] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_connection] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_role] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_reset] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_temp] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_temporary] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_unlogged] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_logged] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cycle] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_union] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_all] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_any] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_some] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_except] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_intersect] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_returning] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_commit] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rollback] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_transaction] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_over] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_nulls] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_first] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_after] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_before] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_last] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_window] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_range] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rows] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_groups] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_between] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_unbounded] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_preceding] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_following] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_exclude] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_current] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_row] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_ties] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_others] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_only] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_unique] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_foreign] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_references] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_concurrently] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_btree] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_gist] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_spgist] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_gin] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_brin] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_like_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_like_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_similar] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_preserve] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_unsigned] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_zerofill] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_conflict] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_do] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_nothing] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_high_priority] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_low_priority] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_delayed] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_recursive] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cascaded] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_local] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_current_timestamp] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_check] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_option] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_vacuum] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_wait] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_nowait] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_authorization] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_action] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_extension] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_copy] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_stdin] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_freeze] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_encoding] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_force_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_force_null] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_force_not_null] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_header] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_match] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_program] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_plain] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_extended] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_main] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_storage] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_compression] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_trigger] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_function] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_returns] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_return] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_setof] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_atomic] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_declare] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_language] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_sql] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_plpgsql] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_immutable] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_stable] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_volatile] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_leakproof] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parallel] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_safe] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_unsafe] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_restricted] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_called] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_input] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_strict] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cost] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_support] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_definer] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_invoker] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_security] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_version] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_out] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_inout] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_variadic] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_session] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_isolation] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_level] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_serializable] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_repeatable] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_read] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_write] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_committed] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_uncommitted] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_deferrable] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_names] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_zone] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_immediate] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_deferred] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_snapshot] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_characteristics] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_follows] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_precedes] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_each] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_instead] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_of] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_initially] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_old] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_new] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_referencing] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_execute] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_external] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_stored] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_virtual] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cached] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_uncached] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_replication] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_tblproperties] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_options] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_compute] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_stats] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_statistics] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_optimize] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rewrite] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bin_pack] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_incremental] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_location] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_partitioned] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_sort] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_format] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_delimited] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_terminated] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_escaped] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_lines] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_cache] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_noscan] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parquet] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_rcfile] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_csv] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_textfile] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_avro] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_sequencefile] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_orc] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_jsonfile] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_null] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_true] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_false] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bit] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_varbinary] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_image] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_smallserial_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_smallserial_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_serial_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_serial_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_bigserial_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_bigserial_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_tinyint_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_tinyint_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_smallint_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_smallint_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_mediumint_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_mediumint_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_int_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_int_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_int_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_bigint_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_bigint_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_numeric] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_real_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_real_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_float] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_double] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_precision] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_inet] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_money] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_smallmoney] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_varying] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_char_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_nchar] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_keyword_varchar_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword_nvarchar] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_text] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_string] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_uuid] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_json] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_jsonb] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_xml] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bytea] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_enum] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_date] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_datetime] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_datetime2] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_smalldatetime] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_datetimeoffset] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_time] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_timestamp] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_timestamptz] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_interval] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_geometry] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_geography] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_box2d] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_box3d] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_oid] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_oids] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_name] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_regclass] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_regnamespace] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_regproc] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_regtype] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_array] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_double_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_marginalia] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_op_other] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_op_unary_other] = {
    .visible = true,
    .named = true,
  },
  [sym__double_quote_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quote_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__single_quote_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__natural_number] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__integer_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__bit_string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_bang] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__dollar_quoted_string_start_tag] = {
    .visible = true,
    .named = true,
  },
  [sym__dollar_quoted_string_end_tag] = {
    .visible = true,
    .named = true,
  },
  [sym__dollar_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_character] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_like] = {
    .visible = true,
    .named = true,
  },
  [sym_is_not] = {
    .visible = true,
    .named = true,
  },
  [sym_not_like] = {
    .visible = true,
    .named = true,
  },
  [sym_similar_to] = {
    .visible = true,
    .named = true,
  },
  [sym_not_similar_to] = {
    .visible = true,
    .named = true,
  },
  [sym_distinct_from] = {
    .visible = true,
    .named = true,
  },
  [sym_not_distinct_from] = {
    .visible = true,
    .named = true,
  },
  [sym__temporary] = {
    .visible = false,
    .named = true,
  },
  [sym__not_null] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_key] = {
    .visible = false,
    .named = true,
  },
  [sym__if_exists] = {
    .visible = false,
    .named = true,
  },
  [sym__if_not_exists] = {
    .visible = false,
    .named = true,
  },
  [sym__or_replace] = {
    .visible = false,
    .named = true,
  },
  [sym__current_row] = {
    .visible = false,
    .named = true,
  },
  [sym__exclude_current_row] = {
    .visible = false,
    .named = true,
  },
  [sym__exclude_group] = {
    .visible = false,
    .named = true,
  },
  [sym__exclude_no_others] = {
    .visible = false,
    .named = true,
  },
  [sym__exclude_ties] = {
    .visible = false,
    .named = true,
  },
  [sym__check_option] = {
    .visible = false,
    .named = true,
  },
  [sym_direction] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_smallserial] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_serial] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bigserial] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_tinyint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_smallint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_mediumint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_int] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_bigint] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_real] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_char] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_varchar] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_array_size_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__array_size_definition] = {
    .visible = false,
    .named = true,
  },
  [sym_tinyint] = {
    .visible = true,
    .named = true,
  },
  [sym_smallint] = {
    .visible = true,
    .named = true,
  },
  [sym_mediumint] = {
    .visible = true,
    .named = true,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_bigint] = {
    .visible = true,
    .named = true,
  },
  [sym_bit] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_varbinary] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_numeric] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_varchar] = {
    .visible = true,
    .named = true,
  },
  [sym_nchar] = {
    .visible = true,
    .named = true,
  },
  [sym_nvarchar] = {
    .visible = true,
    .named = true,
  },
  [sym__include_time_zone] = {
    .visible = false,
    .named = true,
  },
  [sym_datetimeoffset] = {
    .visible = true,
    .named = true,
  },
  [sym_time] = {
    .visible = true,
    .named = true,
  },
  [sym_timestamp] = {
    .visible = true,
    .named = true,
  },
  [sym_enum] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_transaction] = {
    .visible = true,
    .named = true,
  },
  [sym__commit] = {
    .visible = false,
    .named = true,
  },
  [sym__rollback] = {
    .visible = false,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__ddl_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__cte] = {
    .visible = false,
    .named = true,
  },
  [sym__dml_write] = {
    .visible = false,
    .named = true,
  },
  [sym__dml_read] = {
    .visible = false,
    .named = true,
  },
  [sym_cte] = {
    .visible = true,
    .named = true,
  },
  [sym_set_operation] = {
    .visible = true,
    .named = true,
  },
  [sym__select_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_comment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__argmode] = {
    .visible = false,
    .named = true,
  },
  [sym_function_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_function_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__comment_target] = {
    .visible = false,
    .named = true,
  },
  [sym_select] = {
    .visible = true,
    .named = true,
  },
  [sym_select_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym__truncate_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__delete_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__delete_from] = {
    .visible = true,
    .named = true,
  },
  [sym_delete] = {
    .visible = true,
    .named = true,
  },
  [sym__create_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__table_settings] = {
    .visible = false,
    .named = true,
  },
  [sym_storage_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_create_table] = {
    .visible = true,
    .named = true,
  },
  [sym_reset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__transaction_mode] = {
    .visible = false,
    .named = true,
  },
  [sym_set_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_create_query] = {
    .visible = true,
    .named = true,
  },
  [sym_create_view] = {
    .visible = true,
    .named = true,
  },
  [sym_create_materialized_view] = {
    .visible = true,
    .named = true,
  },
  [sym_create_function] = {
    .visible = true,
    .named = true,
  },
  [sym__function_return] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function_language] = {
    .visible = true,
    .named = true,
  },
  [sym_function_volatility] = {
    .visible = true,
    .named = true,
  },
  [sym_function_leakproof] = {
    .visible = true,
    .named = true,
  },
  [sym_function_security] = {
    .visible = true,
    .named = true,
  },
  [sym_function_safety] = {
    .visible = true,
    .named = true,
  },
  [sym_function_strictness] = {
    .visible = true,
    .named = true,
  },
  [sym_function_cost] = {
    .visible = true,
    .named = true,
  },
  [sym_function_rows] = {
    .visible = true,
    .named = true,
  },
  [sym_function_support] = {
    .visible = true,
    .named = true,
  },
  [sym__operator_class] = {
    .visible = false,
    .named = true,
  },
  [sym__index_field] = {
    .visible = true,
    .named = true,
  },
  [sym_index_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_create_index] = {
    .visible = true,
    .named = true,
  },
  [sym_create_schema] = {
    .visible = true,
    .named = true,
  },
  [sym__with_settings] = {
    .visible = false,
    .named = true,
  },
  [sym_create_database] = {
    .visible = true,
    .named = true,
  },
  [sym_create_role] = {
    .visible = true,
    .named = true,
  },
  [sym__role_options] = {
    .visible = false,
    .named = true,
  },
  [sym__user_access_role_config] = {
    .visible = false,
    .named = true,
  },
  [sym_create_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_create_extension] = {
    .visible = true,
    .named = true,
  },
  [sym_create_trigger] = {
    .visible = true,
    .named = true,
  },
  [sym__create_trigger_event] = {
    .visible = false,
    .named = true,
  },
  [sym_create_type] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_elements] = {
    .visible = true,
    .named = true,
  },
  [sym__alter_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__rename_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__rename_table_names] = {
    .visible = false,
    .named = true,
  },
  [sym_alter_table] = {
    .visible = true,
    .named = true,
  },
  [sym__alter_specifications] = {
    .visible = false,
    .named = true,
  },
  [sym_add_column] = {
    .visible = true,
    .named = true,
  },
  [sym_add_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_column] = {
    .visible = true,
    .named = true,
  },
  [sym_modify_column] = {
    .visible = true,
    .named = true,
  },
  [sym_change_column] = {
    .visible = true,
    .named = true,
  },
  [sym_column_position] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_column] = {
    .visible = true,
    .named = true,
  },
  [sym_rename_column] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_view] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_schema] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_database] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_role] = {
    .visible = true,
    .named = true,
  },
  [sym_set_configuration] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_index] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_alter_type] = {
    .visible = true,
    .named = true,
  },
  [sym__drop_behavior] = {
    .visible = false,
    .named = true,
  },
  [sym__drop_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_drop_table] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_view] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_schema] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_database] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_role] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_type] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_index] = {
    .visible = true,
    .named = true,
  },
  [sym_drop_extension] = {
    .visible = true,
    .named = true,
  },
  [sym_rename_object] = {
    .visible = true,
    .named = true,
  },
  [sym_set_schema] = {
    .visible = true,
    .named = true,
  },
  [sym_change_ownership] = {
    .visible = true,
    .named = true,
  },
  [sym_object_reference] = {
    .visible = true,
    .named = true,
  },
  [sym__copy_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__insert_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_insert] = {
    .visible = true,
    .named = true,
  },
  [sym__insert_values] = {
    .visible = false,
    .named = true,
  },
  [sym__set_values] = {
    .visible = false,
    .named = true,
  },
  [sym__column_list] = {
    .visible = false,
    .named = true,
  },
  [sym__column] = {
    .visible = false,
    .named = true,
  },
  [sym__update_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__merge_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_when_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__optimize_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__compute_stats] = {
    .visible = false,
    .named = true,
  },
  [sym__optimize_table] = {
    .visible = false,
    .named = true,
  },
  [sym__vacuum_table] = {
    .visible = false,
    .named = true,
  },
  [sym__vacuum_option] = {
    .visible = false,
    .named = true,
  },
  [sym__partition_spec] = {
    .visible = false,
    .named = true,
  },
  [sym_update] = {
    .visible = true,
    .named = true,
  },
  [sym__mysql_update_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__postgres_update_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_storage_location] = {
    .visible = true,
    .named = true,
  },
  [sym_row_format] = {
    .visible = true,
    .named = true,
  },
  [sym_table_sort] = {
    .visible = true,
    .named = true,
  },
  [sym_table_partition] = {
    .visible = true,
    .named = true,
  },
  [sym__key_value_pair] = {
    .visible = false,
    .named = true,
  },
  [sym_stored_as] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_table_option] = {
    .visible = true,
    .named = true,
  },
  [sym_column_definitions] = {
    .visible = true,
    .named = true,
  },
  [sym_column_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__column_comment] = {
    .visible = false,
    .named = true,
  },
  [sym__column_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym__check_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym__default_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__inner_default_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__constraint_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_key_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym__key_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_ordered_columns] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_column] = {
    .visible = true,
    .named = true,
  },
  [sym_all_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_field] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_interval] = {
    .visible = true,
    .named = true,
  },
  [sym_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_filter_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_partition_by] = {
    .visible = true,
    .named = true,
  },
  [sym_frame_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_window_frame] = {
    .visible = true,
    .named = true,
  },
  [sym_window_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_window_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_window_function] = {
    .visible = true,
    .named = true,
  },
  [sym__alias] = {
    .visible = false,
    .named = true,
  },
  [sym_from] = {
    .visible = true,
    .named = true,
  },
  [sym_relation] = {
    .visible = true,
    .named = true,
  },
  [sym_values] = {
    .visible = true,
    .named = true,
  },
  [sym_index_hint] = {
    .visible = true,
    .named = true,
  },
  [sym_join] = {
    .visible = true,
    .named = true,
  },
  [sym_cross_join] = {
    .visible = true,
    .named = true,
  },
  [sym_lateral_join] = {
    .visible = true,
    .named = true,
  },
  [sym_lateral_cross_join] = {
    .visible = true,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym_group_by] = {
    .visible = true,
    .named = true,
  },
  [sym__having] = {
    .visible = false,
    .named = true,
  },
  [sym_order_by] = {
    .visible = true,
    .named = true,
  },
  [sym_order_target] = {
    .visible = true,
    .named = true,
  },
  [sym_limit] = {
    .visible = true,
    .named = true,
  },
  [sym_offset] = {
    .visible = true,
    .named = true,
  },
  [sym_returning] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_between_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_not_in] = {
    .visible = true,
    .named = true,
  },
  [sym_subquery] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quote_string] = {
    .visible = false,
    .named = true,
  },
  [sym__literal_string] = {
    .visible = false,
    .named = true,
  },
  [sym__integer] = {
    .visible = false,
    .named = true,
  },
  [sym__decimal_number] = {
    .visible = false,
    .named = true,
  },
  [sym__bit_string] = {
    .visible = false,
    .named = true,
  },
  [sym__string_casting] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_size_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_transaction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cte_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cte_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_set_operation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__truncate_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__create_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__table_settings_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_storage_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_set_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_function_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_index_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_database_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_role_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_sequence_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_trigger_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_trigger_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_trigger_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_create_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__rename_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alter_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alter_column_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alter_role_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alter_index_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alter_sequence_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__copy_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__insert_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__set_values_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__column_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__merge_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__compute_stats_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__compute_stats_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__vacuum_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mysql_update_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mysql_update_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_column_definitions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_column_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__column_constraint_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_columns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_invocation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_from_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_order_by_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__single_quote_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_command] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_filename] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_argument = 2,
  field_cache = 3,
  field_col_name = 4,
  field_column = 5,
  field_compression_method = 6,
  field_configuration_parameter = 7,
  field_connection_limit = 8,
  field_custom_type = 9,
  field_end = 10,
  field_enum_element = 11,
  field_escaped_char = 12,
  field_expression = 13,
  field_fields_terminated_char = 14,
  field_function = 15,
  field_high = 16,
  field_increment = 17,
  field_index_name = 18,
  field_key = 19,
  field_left = 20,
  field_low = 21,
  field_lower = 22,
  field_name = 23,
  field_new_name = 24,
  field_old_name = 25,
  field_opclass = 26,
  field_opclass_parameters = 27,
  field_operand = 28,
  field_operation = 29,
  field_operator = 30,
  field_option = 31,
  field_parameter = 32,
  field_password = 33,
  field_path = 34,
  field_pool = 35,
  field_precision = 36,
  field_predicate = 37,
  field_restart = 38,
  field_right = 39,
  field_row_terminated_char = 40,
  field_scale = 41,
  field_schema = 42,
  field_size = 43,
  field_start = 44,
  field_statistics = 45,
  field_subscript = 46,
  field_timeout = 47,
  field_type = 48,
  field_upper = 49,
  field_valid_until = 50,
  field_value = 51,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_argument] = "argument",
  [field_cache] = "cache",
  [field_col_name] = "col_name",
  [field_column] = "column",
  [field_compression_method] = "compression_method",
  [field_configuration_parameter] = "configuration_parameter",
  [field_connection_limit] = "connection_limit",
  [field_custom_type] = "custom_type",
  [field_end] = "end",
  [field_enum_element] = "enum_element",
  [field_escaped_char] = "escaped_char",
  [field_expression] = "expression",
  [field_fields_terminated_char] = "fields_terminated_char",
  [field_function] = "function",
  [field_high] = "high",
  [field_increment] = "increment",
  [field_index_name] = "index_name",
  [field_key] = "key",
  [field_left] = "left",
  [field_low] = "low",
  [field_lower] = "lower",
  [field_name] = "name",
  [field_new_name] = "new_name",
  [field_old_name] = "old_name",
  [field_opclass] = "opclass",
  [field_opclass_parameters] = "opclass_parameters",
  [field_operand] = "operand",
  [field_operation] = "operation",
  [field_operator] = "operator",
  [field_option] = "option",
  [field_parameter] = "parameter",
  [field_password] = "password",
  [field_path] = "path",
  [field_pool] = "pool",
  [field_precision] = "precision",
  [field_predicate] = "predicate",
  [field_restart] = "restart",
  [field_right] = "right",
  [field_row_terminated_char] = "row_terminated_char",
  [field_scale] = "scale",
  [field_schema] = "schema",
  [field_size] = "size",
  [field_start] = "start",
  [field_statistics] = "statistics",
  [field_subscript] = "subscript",
  [field_timeout] = "timeout",
  [field_type] = "type",
  [field_upper] = "upper",
  [field_valid_until] = "valid_until",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 3},
  [2] = {.index = 3, .length = 1},
  [3] = {.index = 4, .length = 2},
  [4] = {.index = 6, .length = 1},
  [5] = {.index = 7, .length = 1},
  [6] = {.index = 8, .length = 1},
  [7] = {.index = 9, .length = 3},
  [8] = {.index = 12, .length = 1},
  [9] = {.index = 13, .length = 2},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [14] = {.index = 19, .length = 3},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 2},
  [18] = {.index = 26, .length = 1},
  [19] = {.index = 27, .length = 3},
  [20] = {.index = 30, .length = 1},
  [21] = {.index = 31, .length = 1},
  [22] = {.index = 32, .length = 2},
  [24] = {.index = 18, .length = 1},
  [25] = {.index = 34, .length = 4},
  [26] = {.index = 38, .length = 1},
  [27] = {.index = 39, .length = 4},
  [28] = {.index = 43, .length = 4},
  [29] = {.index = 47, .length = 2},
  [30] = {.index = 49, .length = 2},
  [31] = {.index = 51, .length = 4},
  [32] = {.index = 55, .length = 3},
  [33] = {.index = 58, .length = 1},
  [34] = {.index = 59, .length = 1},
  [35] = {.index = 60, .length = 2},
  [36] = {.index = 62, .length = 1},
  [37] = {.index = 63, .length = 2},
  [38] = {.index = 65, .length = 1},
  [39] = {.index = 66, .length = 1},
  [41] = {.index = 67, .length = 1},
  [42] = {.index = 68, .length = 1},
  [43] = {.index = 69, .length = 4},
  [44] = {.index = 73, .length = 1},
  [45] = {.index = 74, .length = 8},
  [46] = {.index = 82, .length = 1},
  [47] = {.index = 83, .length = 4},
  [48] = {.index = 87, .length = 1},
  [49] = {.index = 88, .length = 1},
  [50] = {.index = 89, .length = 1},
  [51] = {.index = 90, .length = 1},
  [52] = {.index = 91, .length = 8},
  [53] = {.index = 99, .length = 2},
  [54] = {.index = 101, .length = 2},
  [55] = {.index = 101, .length = 2},
  [56] = {.index = 103, .length = 4},
  [58] = {.index = 107, .length = 1},
  [59] = {.index = 108, .length = 1},
  [60] = {.index = 109, .length = 1},
  [61] = {.index = 110, .length = 3},
  [62] = {.index = 113, .length = 4},
  [63] = {.index = 117, .length = 1},
  [64] = {.index = 118, .length = 8},
  [65] = {.index = 126, .length = 1},
  [66] = {.index = 127, .length = 1},
  [67] = {.index = 128, .length = 1},
  [68] = {.index = 129, .length = 1},
  [69] = {.index = 130, .length = 2},
  [70] = {.index = 132, .length = 2},
  [71] = {.index = 134, .length = 4},
  [72] = {.index = 138, .length = 1},
  [73] = {.index = 139, .length = 2},
  [74] = {.index = 141, .length = 1},
  [75] = {.index = 142, .length = 1},
  [76] = {.index = 143, .length = 3},
  [77] = {.index = 146, .length = 2},
  [78] = {.index = 67, .length = 1},
  [79] = {.index = 148, .length = 1},
  [81] = {.index = 149, .length = 1},
  [82] = {.index = 150, .length = 1},
  [83] = {.index = 151, .length = 1},
  [84] = {.index = 152, .length = 2},
  [85] = {.index = 154, .length = 1},
  [86] = {.index = 155, .length = 1},
  [87] = {.index = 156, .length = 1},
  [88] = {.index = 157, .length = 1},
  [89] = {.index = 158, .length = 1},
  [90] = {.index = 159, .length = 2},
  [91] = {.index = 152, .length = 2},
  [92] = {.index = 161, .length = 4},
  [94] = {.index = 165, .length = 1},
  [95] = {.index = 166, .length = 1},
  [96] = {.index = 167, .length = 1},
  [97] = {.index = 168, .length = 1},
  [98] = {.index = 169, .length = 1},
  [100] = {.index = 170, .length = 1},
  [101] = {.index = 171, .length = 2},
  [102] = {.index = 173, .length = 3},
  [103] = {.index = 176, .length = 2},
  [104] = {.index = 62, .length = 1},
  [105] = {.index = 178, .length = 2},
  [106] = {.index = 180, .length = 1},
  [107] = {.index = 181, .length = 1},
  [108] = {.index = 180, .length = 1},
  [109] = {.index = 181, .length = 1},
  [110] = {.index = 182, .length = 5},
  [111] = {.index = 187, .length = 3},
  [112] = {.index = 190, .length = 1},
  [113] = {.index = 191, .length = 1},
  [114] = {.index = 192, .length = 1},
  [115] = {.index = 193, .length = 1},
  [116] = {.index = 194, .length = 1},
  [117] = {.index = 195, .length = 2},
  [118] = {.index = 197, .length = 4},
  [119] = {.index = 201, .length = 4},
  [120] = {.index = 205, .length = 2},
  [121] = {.index = 207, .length = 2},
  [122] = {.index = 209, .length = 1},
  [124] = {.index = 210, .length = 5},
  [125] = {.index = 215, .length = 3},
  [126] = {.index = 218, .length = 1},
  [127] = {.index = 219, .length = 3},
  [128] = {.index = 222, .length = 1},
  [129] = {.index = 223, .length = 2},
  [130] = {.index = 225, .length = 4},
  [132] = {.index = 229, .length = 1},
  [133] = {.index = 230, .length = 2},
  [134] = {.index = 232, .length = 3},
  [135] = {.index = 235, .length = 1},
  [136] = {.index = 236, .length = 2},
  [138] = {.index = 238, .length = 1},
  [140] = {.index = 239, .length = 1},
  [141] = {.index = 128, .length = 1},
  [142] = {.index = 240, .length = 2},
  [143] = {.index = 62, .length = 1},
  [144] = {.index = 242, .length = 1},
  [145] = {.index = 243, .length = 1},
  [146] = {.index = 244, .length = 1},
  [147] = {.index = 245, .length = 2},
  [148] = {.index = 247, .length = 2},
  [149] = {.index = 249, .length = 1},
  [150] = {.index = 250, .length = 1},
  [151] = {.index = 251, .length = 2},
  [152] = {.index = 253, .length = 4},
  [153] = {.index = 257, .length = 1},
  [155] = {.index = 258, .length = 1},
  [156] = {.index = 259, .length = 2},
  [157] = {.index = 261, .length = 3},
  [158] = {.index = 264, .length = 1},
  [159] = {.index = 265, .length = 2},
  [160] = {.index = 267, .length = 1},
  [162] = {.index = 268, .length = 1},
  [163] = {.index = 269, .length = 3},
  [164] = {.index = 272, .length = 2},
  [165] = {.index = 274, .length = 2},
  [166] = {.index = 276, .length = 1},
  [167] = {.index = 277, .length = 2},
  [169] = {.index = 279, .length = 1},
  [172] = {.index = 280, .length = 1},
  [175] = {.index = 128, .length = 1},
  [176] = {.index = 281, .length = 2},
  [177] = {.index = 283, .length = 1},
  [178] = {.index = 284, .length = 4},
  [180] = {.index = 288, .length = 2},
  [181] = {.index = 290, .length = 2},
  [182] = {.index = 292, .length = 5},
  [183] = {.index = 297, .length = 3},
  [184] = {.index = 300, .length = 3},
  [185] = {.index = 303, .length = 3},
  [186] = {.index = 306, .length = 4},
  [187] = {.index = 310, .length = 2},
  [188] = {.index = 312, .length = 2},
  [189] = {.index = 314, .length = 1},
  [191] = {.index = 315, .length = 2},
  [192] = {.index = 317, .length = 2},
  [193] = {.index = 319, .length = 3},
  [194] = {.index = 322, .length = 3},
  [196] = {.index = 325, .length = 1},
  [199] = {.index = 326, .length = 1},
  [201] = {.index = 327, .length = 2},
  [202] = {.index = 329, .length = 1},
  [204] = {.index = 330, .length = 3},
  [205] = {.index = 333, .length = 1},
  [206] = {.index = 334, .length = 1},
  [207] = {.index = 335, .length = 4},
  [208] = {.index = 339, .length = 3},
  [209] = {.index = 342, .length = 3},
  [210] = {.index = 345, .length = 5},
  [211] = {.index = 350, .length = 1},
  [213] = {.index = 351, .length = 2},
  [214] = {.index = 353, .length = 1},
  [216] = {.index = 326, .length = 1},
  [217] = {.index = 354, .length = 2},
  [218] = {.index = 356, .length = 2},
  [219] = {.index = 358, .length = 1},
  [221] = {.index = 359, .length = 2},
  [222] = {.index = 361, .length = 2},
  [223] = {.index = 363, .length = 5},
  [224] = {.index = 368, .length = 5},
  [225] = {.index = 373, .length = 5},
  [226] = {.index = 378, .length = 2},
  [227] = {.index = 326, .length = 1},
  [228] = {.index = 354, .length = 2},
  [229] = {.index = 380, .length = 3},
  [230] = {.index = 383, .length = 3},
  [231] = {.index = 386, .length = 1},
  [232] = {.index = 354, .length = 2},
  [233] = {.index = 387, .length = 2},
  [234] = {.index = 389, .length = 1},
  [235] = {.index = 390, .length = 2},
  [236] = {.index = 392, .length = 1},
  [237] = {.index = 393, .length = 2},
  [238] = {.index = 395, .length = 1},
  [239] = {.index = 396, .length = 2},
  [240] = {.index = 398, .length = 2},
  [241] = {.index = 400, .length = 1},
  [242] = {.index = 401, .length = 3},
  [243] = {.index = 404, .length = 2},
  [244] = {.index = 406, .length = 1},
  [245] = {.index = 407, .length = 2},
  [246] = {.index = 409, .length = 1},
  [247] = {.index = 410, .length = 2},
  [248] = {.index = 412, .length = 1},
  [249] = {.index = 413, .length = 2},
  [250] = {.index = 415, .length = 1},
  [251] = {.index = 416, .length = 2},
  [252] = {.index = 418, .length = 1},
  [253] = {.index = 419, .length = 2},
  [254] = {.index = 421, .length = 1},
  [255] = {.index = 422, .length = 2},
  [256] = {.index = 424, .length = 1},
  [257] = {.index = 425, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_alias, 0, .inherited = true},
    {field_predicate, 0, .inherited = true},
    {field_timeout, 0, .inherited = true},
  [3] =
    {field_timeout, 0, .inherited = true},
  [4] =
    {field_alias, 0, .inherited = true},
    {field_predicate, 0, .inherited = true},
  [6] =
    {field_value, 0},
  [7] =
    {field_name, 0, .inherited = true},
  [8] =
    {field_name, 0},
  [9] =
    {field_alias, 1, .inherited = true},
    {field_predicate, 1, .inherited = true},
    {field_timeout, 1, .inherited = true},
  [12] =
    {field_operation, 1, .inherited = true},
  [13] =
    {field_operand, 1},
    {field_operator, 0},
  [15] =
    {field_alias, 1, .inherited = true},
    {field_value, 0},
  [17] =
    {field_alias, 0},
  [18] =
    {field_alias, 1, .inherited = true},
  [19] =
    {field_alias, 2, .inherited = true},
    {field_predicate, 2, .inherited = true},
    {field_timeout, 2, .inherited = true},
  [22] =
    {field_name, 2},
  [23] =
    {field_operation, 0},
  [24] =
    {field_operation, 0, .inherited = true},
    {field_operation, 1, .inherited = true},
  [26] =
    {field_alias, 1},
  [27] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [30] =
    {field_custom_type, 2, .inherited = true},
  [31] =
    {field_custom_type, 0},
  [32] =
    {field_name, 2},
    {field_schema, 0},
  [34] =
    {field_connection_limit, 0, .inherited = true},
    {field_option, 0, .inherited = true},
    {field_password, 0, .inherited = true},
    {field_valid_until, 0, .inherited = true},
  [38] =
    {field_option, 0},
  [39] =
    {field_connection_limit, 3, .inherited = true},
    {field_option, 3, .inherited = true},
    {field_password, 3, .inherited = true},
    {field_valid_until, 3, .inherited = true},
  [43] =
    {field_cache, 3, .inherited = true},
    {field_custom_type, 3, .inherited = true},
    {field_increment, 3, .inherited = true},
    {field_start, 3, .inherited = true},
  [47] =
    {field_name, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [49] =
    {field_name, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [51] =
    {field_cache, 3, .inherited = true},
    {field_custom_type, 3, .inherited = true},
    {field_restart, 3, .inherited = true},
    {field_start, 3, .inherited = true},
  [55] =
    {field_alias, 3, .inherited = true},
    {field_predicate, 3, .inherited = true},
    {field_timeout, 3, .inherited = true},
  [58] =
    {field_name, 3},
  [59] =
    {field_name, 1, .inherited = true},
  [60] =
    {field_operation, 0},
    {field_operation, 1},
  [62] =
    {field_parameter, 2},
  [63] =
    {field_expression, 0},
    {field_subscript, 2},
  [65] =
    {field_size, 0, .inherited = true},
  [66] =
    {field_alias, 3},
  [67] =
    {field_alias, 3, .inherited = true},
  [68] =
    {field_predicate, 1},
  [69] =
    {field_connection_limit, 4, .inherited = true},
    {field_option, 4, .inherited = true},
    {field_password, 4, .inherited = true},
    {field_valid_until, 4, .inherited = true},
  [73] =
    {field_password, 1},
  [74] =
    {field_connection_limit, 0, .inherited = true},
    {field_connection_limit, 1, .inherited = true},
    {field_option, 0, .inherited = true},
    {field_option, 1, .inherited = true},
    {field_password, 0, .inherited = true},
    {field_password, 1, .inherited = true},
    {field_valid_until, 0, .inherited = true},
    {field_valid_until, 1, .inherited = true},
  [82] =
    {field_path, 1},
  [83] =
    {field_cache, 4, .inherited = true},
    {field_custom_type, 4, .inherited = true},
    {field_increment, 4, .inherited = true},
    {field_start, 4, .inherited = true},
  [87] =
    {field_increment, 1},
  [88] =
    {field_start, 1},
  [89] =
    {field_custom_type, 1, .inherited = true},
  [90] =
    {field_cache, 1},
  [91] =
    {field_cache, 0, .inherited = true},
    {field_cache, 1, .inherited = true},
    {field_custom_type, 0, .inherited = true},
    {field_custom_type, 1, .inherited = true},
    {field_increment, 0, .inherited = true},
    {field_increment, 1, .inherited = true},
    {field_start, 0, .inherited = true},
    {field_start, 1, .inherited = true},
  [99] =
    {field_name, 4, .inherited = true},
    {field_value, 4, .inherited = true},
  [101] =
    {field_name, 0},
    {field_value, 1},
  [103] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [107] =
    {field_custom_type, 0, .inherited = true},
  [108] =
    {field_option, 4},
  [109] =
    {field_name, 1},
  [110] =
    {field_custom_type, 1, .inherited = true},
    {field_name, 0},
    {field_type, 1},
  [113] =
    {field_cache, 4, .inherited = true},
    {field_custom_type, 4, .inherited = true},
    {field_restart, 4, .inherited = true},
    {field_start, 4, .inherited = true},
  [117] =
    {field_restart, 1},
  [118] =
    {field_cache, 0, .inherited = true},
    {field_cache, 1, .inherited = true},
    {field_custom_type, 0, .inherited = true},
    {field_custom_type, 1, .inherited = true},
    {field_restart, 0, .inherited = true},
    {field_restart, 1, .inherited = true},
    {field_start, 0, .inherited = true},
    {field_start, 1, .inherited = true},
  [126] =
    {field_configuration_parameter, 4},
  [127] =
    {field_name, 4},
  [128] =
    {field_parameter, 3},
  [129] =
    {field_parameter, 1},
  [130] =
    {field_parameter, 2},
    {field_parameter, 3, .inherited = true},
  [132] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [134] =
    {field_high, 4},
    {field_left, 0},
    {field_low, 2},
    {field_operator, 1},
  [138] =
    {field_size, 1, .inherited = true},
  [139] =
    {field_size, 0, .inherited = true},
    {field_size, 1, .inherited = true},
  [141] =
    {field_index_name, 3},
  [142] =
    {field_alias, 4},
  [143] =
    {field_left, 0},
    {field_name, 0, .inherited = true},
    {field_right, 2},
  [146] =
    {field_key, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [148] =
    {field_predicate, 3},
  [149] =
    {field_password, 2},
  [150] =
    {field_valid_until, 2},
  [151] =
    {field_connection_limit, 2},
  [152] =
    {field_name, 0},
    {field_value, 2},
  [154] =
    {field_increment, 2},
  [155] =
    {field_start, 2},
  [156] =
    {field_column, 0},
  [157] =
    {field_function, 0},
  [158] =
    {field_column, 2},
  [159] =
    {field_name, 5, .inherited = true},
    {field_value, 5, .inherited = true},
  [161] =
    {field_cache, 5, .inherited = true},
    {field_custom_type, 5, .inherited = true},
    {field_increment, 5, .inherited = true},
    {field_start, 5, .inherited = true},
  [165] =
    {field_schema, 2},
  [166] =
    {field_old_name, 1},
  [167] =
    {field_col_name, 1},
  [168] =
    {field_restart, 2},
  [169] =
    {field_configuration_parameter, 5},
  [170] =
    {field_argument, 1},
  [171] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [173] =
    {field_custom_type, 4, .inherited = true},
    {field_name, 0},
    {field_parameter, 2},
  [176] =
    {field_parameter, 3},
    {field_parameter, 4, .inherited = true},
  [178] =
    {field_parameter, 2},
    {field_parameter, 4, .inherited = true},
  [180] =
    {field_start, 0},
  [181] =
    {field_end, 0},
  [182] =
    {field_high, 5},
    {field_left, 0},
    {field_low, 3},
    {field_operator, 1},
    {field_operator, 2},
  [187] =
    {field_expression, 0},
    {field_lower, 2},
    {field_upper, 4},
  [190] =
    {field_size, 1},
  [191] =
    {field_precision, 2},
  [192] =
    {field_size, 2},
  [193] =
    {field_value, 2},
  [194] =
    {field_alias, 5},
  [195] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [197] =
    {field_key, 2, .inherited = true},
    {field_key, 3, .inherited = true},
    {field_value, 2, .inherited = true},
    {field_value, 3, .inherited = true},
  [201] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [205] =
    {field_key, 0},
    {field_value, 2},
  [207] =
    {field_key, 3, .inherited = true},
    {field_value, 3, .inherited = true},
  [209] =
    {field_predicate, 4},
  [210] =
    {field_column, 1, .inherited = true},
    {field_expression, 1, .inherited = true},
    {field_function, 1, .inherited = true},
    {field_opclass, 1, .inherited = true},
    {field_opclass_parameters, 1, .inherited = true},
  [215] =
    {field_column, 0},
    {field_opclass, 1, .inherited = true},
    {field_opclass_parameters, 1, .inherited = true},
  [218] =
    {field_opclass, 0},
  [219] =
    {field_function, 0},
    {field_opclass, 1, .inherited = true},
    {field_opclass_parameters, 1, .inherited = true},
  [222] =
    {field_column, 3},
  [223] =
    {field_name, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [225] =
    {field_name, 4, .inherited = true},
    {field_name, 5, .inherited = true},
    {field_value, 4, .inherited = true},
    {field_value, 5, .inherited = true},
  [229] =
    {field_custom_type, 5, .inherited = true},
  [230] =
    {field_option, 0},
    {field_parameter, 2},
  [232] =
    {field_custom_type, 3, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [235] =
    {field_old_name, 2},
  [236] =
    {field_new_name, 3},
    {field_old_name, 1},
  [238] =
    {field_custom_type, 6, .inherited = true},
  [239] =
    {field_timeout, 4},
  [240] =
    {field_parameter, 3},
    {field_parameter, 5, .inherited = true},
  [242] =
    {field_size, 3},
  [243] =
    {field_precision, 3},
  [244] =
    {field_value, 1},
  [245] =
    {field_value, 2},
    {field_value, 3, .inherited = true},
  [247] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [249] =
    {field_index_name, 5},
  [250] =
    {field_alias, 6},
  [251] =
    {field_key, 4, .inherited = true},
    {field_value, 4, .inherited = true},
  [253] =
    {field_key, 3, .inherited = true},
    {field_key, 4, .inherited = true},
    {field_value, 3, .inherited = true},
    {field_value, 4, .inherited = true},
  [257] =
    {field_predicate, 5},
  [258] =
    {field_predicate, 6},
  [259] =
    {field_path, 1},
    {field_pool, 4},
  [261] =
    {field_expression, 0},
    {field_expression, 1},
    {field_expression, 2},
  [264] =
    {field_column, 4},
  [265] =
    {field_name, 6, .inherited = true},
    {field_value, 6, .inherited = true},
  [267] =
    {field_enum_element, 1},
  [268] =
    {field_option, 7},
  [269] =
    {field_custom_type, 4, .inherited = true},
    {field_name, 2},
    {field_type, 4},
  [272] =
    {field_compression_method, 4},
    {field_name, 1},
  [274] =
    {field_name, 1},
    {field_statistics, 4},
  [276] =
    {field_old_name, 3},
  [277] =
    {field_new_name, 4},
    {field_old_name, 2},
  [279] =
    {field_custom_type, 7, .inherited = true},
  [280] =
    {field_timeout, 5},
  [281] =
    {field_precision, 2},
    {field_scale, 4},
  [283] =
    {field_alias, 7},
  [284] =
    {field_key, 4, .inherited = true},
    {field_key, 5, .inherited = true},
    {field_value, 4, .inherited = true},
    {field_value, 5, .inherited = true},
  [288] =
    {field_alias, 5, .inherited = true},
    {field_predicate, 7},
  [290] =
    {field_alias, 3, .inherited = true},
    {field_predicate, 7},
  [292] =
    {field_expression, 0},
    {field_expression, 1},
    {field_expression, 2},
    {field_opclass, 3, .inherited = true},
    {field_opclass_parameters, 3, .inherited = true},
  [297] =
    {field_column, 0},
    {field_opclass, 3, .inherited = true},
    {field_opclass_parameters, 3, .inherited = true},
  [300] =
    {field_opclass, 0},
    {field_opclass_parameters, 1},
    {field_opclass_parameters, 2},
  [303] =
    {field_function, 0},
    {field_opclass, 3, .inherited = true},
    {field_opclass_parameters, 3, .inherited = true},
  [306] =
    {field_name, 6, .inherited = true},
    {field_name, 7, .inherited = true},
    {field_value, 6, .inherited = true},
    {field_value, 7, .inherited = true},
  [310] =
    {field_enum_element, 1},
    {field_enum_element, 2, .inherited = true},
  [312] =
    {field_enum_element, 0, .inherited = true},
    {field_enum_element, 1, .inherited = true},
  [314] =
    {field_column, 5},
  [315] =
    {field_compression_method, 5},
    {field_name, 2},
  [317] =
    {field_name, 2},
    {field_statistics, 5},
  [319] =
    {field_custom_type, 5, .inherited = true},
    {field_name, 1},
    {field_type, 5},
  [322] =
    {field_key, 4, .inherited = true},
    {field_name, 1},
    {field_value, 4, .inherited = true},
  [325] =
    {field_value, 7},
  [326] =
    {field_argument, 2},
  [327] =
    {field_precision, 3},
    {field_scale, 5},
  [329] =
    {field_predicate, 7},
  [330] =
    {field_alias, 3, .inherited = true},
    {field_alias, 6, .inherited = true},
    {field_predicate, 8},
  [333] =
    {field_fields_terminated_char, 6},
  [334] =
    {field_row_terminated_char, 6},
  [335] =
    {field_opclass, 0},
    {field_opclass_parameters, 1},
    {field_opclass_parameters, 2},
    {field_opclass_parameters, 3},
  [339] =
    {field_custom_type, 6, .inherited = true},
    {field_name, 2},
    {field_type, 6},
  [342] =
    {field_key, 5, .inherited = true},
    {field_name, 2},
    {field_value, 5, .inherited = true},
  [345] =
    {field_key, 4, .inherited = true},
    {field_key, 5, .inherited = true},
    {field_name, 1},
    {field_value, 4, .inherited = true},
    {field_value, 5, .inherited = true},
  [350] =
    {field_value, 8},
  [351] =
    {field_value, 7},
    {field_value, 8, .inherited = true},
  [353] =
    {field_custom_type, 9, .inherited = true},
  [354] =
    {field_argument, 2},
    {field_argument, 3, .inherited = true},
  [356] =
    {field_precision, 4},
    {field_scale, 6},
  [358] =
    {field_predicate, 8},
  [359] =
    {field_alias, 5, .inherited = true},
    {field_predicate, 8},
  [361] =
    {field_alias, 3, .inherited = true},
    {field_predicate, 8},
  [363] =
    {field_expression, 0},
    {field_expression, 1},
    {field_expression, 2},
    {field_opclass, 5, .inherited = true},
    {field_opclass_parameters, 5, .inherited = true},
  [368] =
    {field_opclass, 0},
    {field_opclass_parameters, 1},
    {field_opclass_parameters, 2},
    {field_opclass_parameters, 3},
    {field_opclass_parameters, 4},
  [373] =
    {field_key, 5, .inherited = true},
    {field_key, 6, .inherited = true},
    {field_name, 2},
    {field_value, 5, .inherited = true},
    {field_value, 6, .inherited = true},
  [378] =
    {field_value, 8},
    {field_value, 9, .inherited = true},
  [380] =
    {field_alias, 3, .inherited = true},
    {field_alias, 6, .inherited = true},
    {field_predicate, 9},
  [383] =
    {field_path, 1},
    {field_pool, 4},
    {field_value, 8},
  [386] =
    {field_value, 3},
  [387] =
    {field_escaped_char, 9},
    {field_fields_terminated_char, 6},
  [389] =
    {field_parameter, 11},
  [390] =
    {field_fields_terminated_char, 6},
    {field_row_terminated_char, 10},
  [392] =
    {field_parameter, 12},
  [393] =
    {field_parameter, 11},
    {field_parameter, 12, .inherited = true},
  [395] =
    {field_parameter, 13},
  [396] =
    {field_parameter, 12},
    {field_parameter, 13, .inherited = true},
  [398] =
    {field_parameter, 13},
    {field_parameter, 14, .inherited = true},
  [400] =
    {field_parameter, 14},
  [401] =
    {field_escaped_char, 9},
    {field_fields_terminated_char, 6},
    {field_row_terminated_char, 13},
  [404] =
    {field_parameter, 14},
    {field_parameter, 15, .inherited = true},
  [406] =
    {field_parameter, 15},
  [407] =
    {field_parameter, 15},
    {field_parameter, 16, .inherited = true},
  [409] =
    {field_parameter, 16},
  [410] =
    {field_parameter, 16},
    {field_parameter, 17, .inherited = true},
  [412] =
    {field_parameter, 17},
  [413] =
    {field_parameter, 17},
    {field_parameter, 18, .inherited = true},
  [415] =
    {field_parameter, 18},
  [416] =
    {field_parameter, 18},
    {field_parameter, 19, .inherited = true},
  [418] =
    {field_parameter, 19},
  [419] =
    {field_parameter, 19},
    {field_parameter, 20, .inherited = true},
  [421] =
    {field_parameter, 20},
  [422] =
    {field_parameter, 20},
    {field_parameter, 21, .inherited = true},
  [424] =
    {field_parameter, 21},
  [425] =
    {field_parameter, 21},
    {field_parameter, 22, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [13] = {
    [0] = sym_literal,
  },
  [23] = {
    [0] = sym_list,
  },
  [24] = {
    [2] = sym_list,
  },
  [34] = {
    [1] = sym_object_reference,
  },
  [40] = {
    [1] = sym_ordered_column,
  },
  [44] = {
    [1] = sym_literal,
  },
  [46] = {
    [1] = sym_literal,
  },
  [48] = {
    [1] = sym_literal,
  },
  [49] = {
    [1] = sym_literal,
  },
  [51] = {
    [1] = sym_literal,
  },
  [54] = {
    [1] = sym_literal,
  },
  [57] = {
    [4] = sym_literal,
  },
  [63] = {
    [1] = sym_literal,
  },
  [78] = {
    [4] = sym_list,
  },
  [80] = {
    [3] = sym_list,
  },
  [81] = {
    [2] = sym_literal,
  },
  [82] = {
    [2] = sym_literal,
  },
  [83] = {
    [2] = sym_literal,
  },
  [85] = {
    [2] = sym_literal,
  },
  [86] = {
    [2] = sym_literal,
  },
  [91] = {
    [2] = sym_literal,
  },
  [93] = {
    [5] = sym_literal,
  },
  [97] = {
    [2] = sym_literal,
  },
  [99] = {
    [3] = sym_statement,
  },
  [104] = {
    [4] = sym_literal,
  },
  [108] = {
    [0] = sym_literal,
  },
  [109] = {
    [0] = sym_literal,
  },
  [112] = {
    [1] = sym_literal,
  },
  [113] = {
    [2] = sym_literal,
  },
  [114] = {
    [2] = sym_literal,
  },
  [115] = {
    [2] = sym_literal,
  },
  [120] = {
    [2] = sym_literal,
  },
  [123] = {
    [4] = sym_list,
  },
  [131] = {
    [6] = sym_literal,
  },
  [137] = {
    [1] = sym_literal,
  },
  [139] = {
    [4] = sym_statement,
  },
  [140] = {
    [4] = sym_literal,
  },
  [141] = {
    [5] = sym_literal,
  },
  [143] = {
    [5] = sym_literal,
  },
  [144] = {
    [3] = sym_literal,
  },
  [145] = {
    [3] = sym_literal,
  },
  [146] = {
    [1] = sym_literal,
  },
  [147] = {
    [2] = sym_literal,
  },
  [154] = {
    [5] = sym_list,
  },
  [156] = {
    [1] = sym_literal,
    [4] = sym_literal,
  },
  [160] = {
    [1] = sym_literal,
  },
  [161] = {
    [7] = sym_literal,
  },
  [168] = {
    [4] = sym_literal,
    [7] = sym_literal,
  },
  [170] = {
    [5] = sym_literal,
    [7] = sym_literal,
  },
  [171] = {
    [5] = sym_statement,
  },
  [172] = {
    [5] = sym_literal,
  },
  [173] = {
    [1] = sym_identifier,
  },
  [174] = {
    [4] = anon_alias_sym_filename,
  },
  [175] = {
    [6] = sym_literal,
  },
  [176] = {
    [2] = sym_literal,
    [4] = sym_literal,
  },
  [179] = {
    [6] = sym_list,
  },
  [187] = {
    [1] = sym_literal,
  },
  [190] = {
    [8] = sym_literal,
  },
  [195] = {
    [5] = sym_literal,
    [8] = sym_literal,
  },
  [197] = {
    [6] = sym_literal,
    [8] = sym_literal,
  },
  [198] = {
    [6] = sym_statement,
  },
  [199] = {
    [6] = sym_statement,
  },
  [200] = {
    [5] = anon_alias_sym_command,
  },
  [201] = {
    [3] = sym_literal,
    [5] = sym_literal,
  },
  [203] = {
    [7] = sym_list,
  },
  [205] = {
    [6] = sym_literal,
  },
  [206] = {
    [6] = sym_literal,
  },
  [212] = {
    [6] = sym_literal,
    [9] = sym_literal,
  },
  [215] = {
    [7] = sym_statement,
  },
  [216] = {
    [7] = sym_statement,
  },
  [217] = {
    [7] = sym_statement,
  },
  [218] = {
    [4] = sym_literal,
    [6] = sym_literal,
  },
  [220] = {
    [8] = sym_list,
  },
  [227] = {
    [8] = sym_statement,
  },
  [228] = {
    [8] = sym_statement,
  },
  [230] = {
    [1] = sym_literal,
    [4] = sym_literal,
    [8] = sym_literal,
  },
  [232] = {
    [9] = sym_statement,
  },
  [233] = {
    [6] = sym_literal,
    [9] = sym_literal,
  },
  [235] = {
    [6] = sym_literal,
    [10] = sym_literal,
  },
  [242] = {
    [6] = sym_literal,
    [9] = sym_literal,
    [13] = sym_literal,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__dml_write, 2,
    sym__dml_write,
    sym_statement,
  sym__dml_read, 2,
    sym__dml_read,
    sym_statement,
  sym__column_list, 2,
    sym__column_list,
    sym_list,
  sym__column, 2,
    sym__column,
    sym_ordered_column,
  sym__qualified_field, 2,
    sym_field,
    sym_object_reference,
  sym__single_quote_string, 2,
    sym__single_quote_string,
    sym_literal,
  sym__literal_string, 5,
    sym__literal_string,
    anon_alias_sym_command,
    anon_alias_sym_filename,
    sym_identifier,
    sym_literal,
  sym__integer, 2,
    sym__integer,
    sym_literal,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 6,
  [9] = 7,
  [10] = 10,
  [11] = 11,
  [12] = 10,
  [13] = 10,
  [14] = 14,
  [15] = 15,
  [16] = 11,
  [17] = 10,
  [18] = 11,
  [19] = 11,
  [20] = 20,
  [21] = 21,
  [22] = 11,
  [23] = 10,
  [24] = 10,
  [25] = 10,
  [26] = 10,
  [27] = 10,
  [28] = 10,
  [29] = 10,
  [30] = 10,
  [31] = 10,
  [32] = 10,
  [33] = 10,
  [34] = 10,
  [35] = 35,
  [36] = 15,
  [37] = 10,
  [38] = 10,
  [39] = 39,
  [40] = 10,
  [41] = 41,
  [42] = 42,
  [43] = 10,
  [44] = 11,
  [45] = 11,
  [46] = 10,
  [47] = 47,
  [48] = 10,
  [49] = 10,
  [50] = 20,
  [51] = 10,
  [52] = 11,
  [53] = 53,
  [54] = 54,
  [55] = 42,
  [56] = 11,
  [57] = 47,
  [58] = 41,
  [59] = 10,
  [60] = 11,
  [61] = 61,
  [62] = 10,
  [63] = 35,
  [64] = 11,
  [65] = 39,
  [66] = 10,
  [67] = 67,
  [68] = 68,
  [69] = 11,
  [70] = 11,
  [71] = 11,
  [72] = 11,
  [73] = 53,
  [74] = 54,
  [75] = 11,
  [76] = 10,
  [77] = 10,
  [78] = 14,
  [79] = 11,
  [80] = 67,
  [81] = 11,
  [82] = 10,
  [83] = 68,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 88,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 97,
  [101] = 101,
  [102] = 99,
  [103] = 103,
  [104] = 104,
  [105] = 96,
  [106] = 106,
  [107] = 104,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 110,
  [112] = 112,
  [113] = 113,
  [114] = 112,
  [115] = 113,
  [116] = 85,
  [117] = 86,
  [118] = 84,
  [119] = 119,
  [120] = 119,
  [121] = 121,
  [122] = 122,
  [123] = 121,
  [124] = 121,
  [125] = 125,
  [126] = 125,
  [127] = 127,
  [128] = 125,
  [129] = 129,
  [130] = 130,
  [131] = 129,
  [132] = 129,
  [133] = 130,
  [134] = 130,
  [135] = 87,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 138,
  [140] = 140,
  [141] = 138,
  [142] = 142,
  [143] = 140,
  [144] = 142,
  [145] = 140,
  [146] = 142,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 88,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 88,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 85,
  [285] = 86,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 84,
  [293] = 88,
  [294] = 88,
  [295] = 88,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 300,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 87,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 331,
  [334] = 334,
  [335] = 331,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 331,
  [340] = 336,
  [341] = 341,
  [342] = 342,
  [343] = 332,
  [344] = 336,
  [345] = 86,
  [346] = 336,
  [347] = 85,
  [348] = 84,
  [349] = 331,
  [350] = 336,
  [351] = 336,
  [352] = 331,
  [353] = 353,
  [354] = 332,
  [355] = 336,
  [356] = 336,
  [357] = 336,
  [358] = 331,
  [359] = 359,
  [360] = 336,
  [361] = 331,
  [362] = 336,
  [363] = 331,
  [364] = 336,
  [365] = 336,
  [366] = 331,
  [367] = 336,
  [368] = 336,
  [369] = 336,
  [370] = 331,
  [371] = 336,
  [372] = 331,
  [373] = 336,
  [374] = 331,
  [375] = 342,
  [376] = 338,
  [377] = 331,
  [378] = 331,
  [379] = 331,
  [380] = 334,
  [381] = 331,
  [382] = 334,
  [383] = 337,
  [384] = 337,
  [385] = 385,
  [386] = 341,
  [387] = 331,
  [388] = 331,
  [389] = 342,
  [390] = 338,
  [391] = 331,
  [392] = 331,
  [393] = 341,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 317,
  [416] = 326,
  [417] = 328,
  [418] = 323,
  [419] = 327,
  [420] = 87,
  [421] = 148,
  [422] = 147,
  [423] = 312,
  [424] = 329,
  [425] = 88,
  [426] = 322,
  [427] = 325,
  [428] = 316,
  [429] = 315,
  [430] = 319,
  [431] = 149,
  [432] = 432,
  [433] = 314,
  [434] = 320,
  [435] = 311,
  [436] = 321,
  [437] = 330,
  [438] = 438,
  [439] = 324,
  [440] = 318,
  [441] = 441,
  [442] = 319,
  [443] = 443,
  [444] = 127,
  [445] = 443,
  [446] = 296,
  [447] = 447,
  [448] = 157,
  [449] = 167,
  [450] = 158,
  [451] = 151,
  [452] = 443,
  [453] = 150,
  [454] = 330,
  [455] = 310,
  [456] = 320,
  [457] = 443,
  [458] = 163,
  [459] = 322,
  [460] = 162,
  [461] = 447,
  [462] = 325,
  [463] = 443,
  [464] = 326,
  [465] = 443,
  [466] = 329,
  [467] = 443,
  [468] = 328,
  [469] = 443,
  [470] = 443,
  [471] = 443,
  [472] = 152,
  [473] = 164,
  [474] = 443,
  [475] = 306,
  [476] = 165,
  [477] = 321,
  [478] = 317,
  [479] = 166,
  [480] = 316,
  [481] = 481,
  [482] = 315,
  [483] = 314,
  [484] = 311,
  [485] = 302,
  [486] = 312,
  [487] = 443,
  [488] = 297,
  [489] = 301,
  [490] = 160,
  [491] = 323,
  [492] = 447,
  [493] = 299,
  [494] = 443,
  [495] = 443,
  [496] = 305,
  [497] = 324,
  [498] = 327,
  [499] = 318,
  [500] = 443,
  [501] = 307,
  [502] = 181,
  [503] = 447,
  [504] = 443,
  [505] = 447,
  [506] = 303,
  [507] = 298,
  [508] = 304,
  [509] = 447,
  [510] = 309,
  [511] = 447,
  [512] = 159,
  [513] = 153,
  [514] = 161,
  [515] = 443,
  [516] = 155,
  [517] = 443,
  [518] = 518,
  [519] = 519,
  [520] = 518,
  [521] = 521,
  [522] = 398,
  [523] = 523,
  [524] = 524,
  [525] = 518,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 528,
  [530] = 527,
  [531] = 531,
  [532] = 527,
  [533] = 526,
  [534] = 518,
  [535] = 518,
  [536] = 518,
  [537] = 526,
  [538] = 527,
  [539] = 526,
  [540] = 527,
  [541] = 541,
  [542] = 404,
  [543] = 528,
  [544] = 518,
  [545] = 526,
  [546] = 518,
  [547] = 528,
  [548] = 527,
  [549] = 528,
  [550] = 527,
  [551] = 526,
  [552] = 171,
  [553] = 518,
  [554] = 405,
  [555] = 518,
  [556] = 556,
  [557] = 394,
  [558] = 526,
  [559] = 528,
  [560] = 410,
  [561] = 527,
  [562] = 521,
  [563] = 168,
  [564] = 528,
  [565] = 528,
  [566] = 566,
  [567] = 84,
  [568] = 528,
  [569] = 527,
  [570] = 526,
  [571] = 571,
  [572] = 518,
  [573] = 176,
  [574] = 178,
  [575] = 411,
  [576] = 576,
  [577] = 528,
  [578] = 399,
  [579] = 524,
  [580] = 179,
  [581] = 396,
  [582] = 518,
  [583] = 566,
  [584] = 526,
  [585] = 527,
  [586] = 310,
  [587] = 576,
  [588] = 526,
  [589] = 527,
  [590] = 527,
  [591] = 591,
  [592] = 528,
  [593] = 412,
  [594] = 594,
  [595] = 527,
  [596] = 596,
  [597] = 597,
  [598] = 403,
  [599] = 599,
  [600] = 556,
  [601] = 531,
  [602] = 541,
  [603] = 528,
  [604] = 604,
  [605] = 302,
  [606] = 409,
  [607] = 407,
  [608] = 297,
  [609] = 301,
  [610] = 299,
  [611] = 527,
  [612] = 526,
  [613] = 518,
  [614] = 518,
  [615] = 615,
  [616] = 175,
  [617] = 526,
  [618] = 397,
  [619] = 526,
  [620] = 527,
  [621] = 303,
  [622] = 400,
  [623] = 401,
  [624] = 527,
  [625] = 526,
  [626] = 541,
  [627] = 528,
  [628] = 628,
  [629] = 528,
  [630] = 169,
  [631] = 615,
  [632] = 177,
  [633] = 527,
  [634] = 628,
  [635] = 541,
  [636] = 296,
  [637] = 526,
  [638] = 596,
  [639] = 526,
  [640] = 518,
  [641] = 172,
  [642] = 541,
  [643] = 518,
  [644] = 526,
  [645] = 518,
  [646] = 646,
  [647] = 395,
  [648] = 521,
  [649] = 649,
  [650] = 413,
  [651] = 170,
  [652] = 528,
  [653] = 527,
  [654] = 402,
  [655] = 406,
  [656] = 85,
  [657] = 408,
  [658] = 658,
  [659] = 528,
  [660] = 86,
  [661] = 528,
  [662] = 526,
  [663] = 173,
  [664] = 306,
  [665] = 541,
  [666] = 594,
  [667] = 305,
  [668] = 304,
  [669] = 309,
  [670] = 604,
  [671] = 86,
  [672] = 298,
  [673] = 541,
  [674] = 599,
  [675] = 518,
  [676] = 85,
  [677] = 528,
  [678] = 84,
  [679] = 307,
  [680] = 310,
  [681] = 200,
  [682] = 202,
  [683] = 398,
  [684] = 184,
  [685] = 685,
  [686] = 686,
  [687] = 183,
  [688] = 199,
  [689] = 399,
  [690] = 85,
  [691] = 400,
  [692] = 401,
  [693] = 198,
  [694] = 214,
  [695] = 695,
  [696] = 685,
  [697] = 185,
  [698] = 213,
  [699] = 685,
  [700] = 685,
  [701] = 302,
  [702] = 212,
  [703] = 406,
  [704] = 188,
  [705] = 304,
  [706] = 297,
  [707] = 408,
  [708] = 196,
  [709] = 182,
  [710] = 301,
  [711] = 299,
  [712] = 192,
  [713] = 432,
  [714] = 714,
  [715] = 685,
  [716] = 303,
  [717] = 717,
  [718] = 211,
  [719] = 84,
  [720] = 195,
  [721] = 205,
  [722] = 219,
  [723] = 723,
  [724] = 218,
  [725] = 307,
  [726] = 306,
  [727] = 685,
  [728] = 190,
  [729] = 181,
  [730] = 298,
  [731] = 685,
  [732] = 732,
  [733] = 206,
  [734] = 734,
  [735] = 735,
  [736] = 685,
  [737] = 86,
  [738] = 695,
  [739] = 201,
  [740] = 740,
  [741] = 741,
  [742] = 412,
  [743] = 695,
  [744] = 695,
  [745] = 217,
  [746] = 685,
  [747] = 685,
  [748] = 403,
  [749] = 207,
  [750] = 180,
  [751] = 396,
  [752] = 189,
  [753] = 186,
  [754] = 397,
  [755] = 404,
  [756] = 193,
  [757] = 685,
  [758] = 685,
  [759] = 759,
  [760] = 405,
  [761] = 695,
  [762] = 210,
  [763] = 685,
  [764] = 296,
  [765] = 695,
  [766] = 766,
  [767] = 685,
  [768] = 695,
  [769] = 394,
  [770] = 410,
  [771] = 309,
  [772] = 685,
  [773] = 773,
  [774] = 411,
  [775] = 775,
  [776] = 776,
  [777] = 413,
  [778] = 685,
  [779] = 779,
  [780] = 197,
  [781] = 781,
  [782] = 208,
  [783] = 409,
  [784] = 204,
  [785] = 407,
  [786] = 203,
  [787] = 402,
  [788] = 187,
  [789] = 685,
  [790] = 209,
  [791] = 685,
  [792] = 792,
  [793] = 215,
  [794] = 395,
  [795] = 305,
  [796] = 191,
  [797] = 194,
  [798] = 261,
  [799] = 259,
  [800] = 242,
  [801] = 245,
  [802] = 256,
  [803] = 803,
  [804] = 759,
  [805] = 775,
  [806] = 250,
  [807] = 227,
  [808] = 714,
  [809] = 809,
  [810] = 234,
  [811] = 223,
  [812] = 251,
  [813] = 432,
  [814] = 253,
  [815] = 815,
  [816] = 220,
  [817] = 281,
  [818] = 221,
  [819] = 248,
  [820] = 87,
  [821] = 280,
  [822] = 246,
  [823] = 282,
  [824] = 824,
  [825] = 224,
  [826] = 826,
  [827] = 87,
  [828] = 828,
  [829] = 270,
  [830] = 269,
  [831] = 257,
  [832] = 268,
  [833] = 267,
  [834] = 834,
  [835] = 266,
  [836] = 241,
  [837] = 837,
  [838] = 226,
  [839] = 839,
  [840] = 238,
  [841] = 233,
  [842] = 740,
  [843] = 279,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 824,
  [848] = 272,
  [849] = 249,
  [850] = 735,
  [851] = 851,
  [852] = 852,
  [853] = 240,
  [854] = 222,
  [855] = 855,
  [856] = 260,
  [857] = 857,
  [858] = 237,
  [859] = 723,
  [860] = 741,
  [861] = 766,
  [862] = 271,
  [863] = 283,
  [864] = 274,
  [865] = 734,
  [866] = 866,
  [867] = 781,
  [868] = 868,
  [869] = 229,
  [870] = 852,
  [871] = 275,
  [872] = 844,
  [873] = 276,
  [874] = 225,
  [875] = 875,
  [876] = 876,
  [877] = 254,
  [878] = 243,
  [879] = 879,
  [880] = 244,
  [881] = 247,
  [882] = 277,
  [883] = 883,
  [884] = 884,
  [885] = 264,
  [886] = 886,
  [887] = 887,
  [888] = 278,
  [889] = 686,
  [890] = 232,
  [891] = 265,
  [892] = 892,
  [893] = 732,
  [894] = 231,
  [895] = 792,
  [896] = 273,
  [897] = 252,
  [898] = 181,
  [899] = 255,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 258,
  [904] = 904,
  [905] = 235,
  [906] = 263,
  [907] = 262,
  [908] = 908,
  [909] = 230,
  [910] = 910,
  [911] = 911,
  [912] = 236,
  [913] = 239,
  [914] = 914,
  [915] = 915,
  [916] = 228,
  [917] = 291,
  [918] = 918,
  [919] = 919,
  [920] = 918,
  [921] = 921,
  [922] = 922,
  [923] = 922,
  [924] = 924,
  [925] = 925,
  [926] = 922,
  [927] = 925,
  [928] = 921,
  [929] = 921,
  [930] = 922,
  [931] = 921,
  [932] = 925,
  [933] = 925,
  [934] = 919,
  [935] = 921,
  [936] = 925,
  [937] = 919,
  [938] = 925,
  [939] = 919,
  [940] = 921,
  [941] = 438,
  [942] = 922,
  [943] = 290,
  [944] = 925,
  [945] = 921,
  [946] = 922,
  [947] = 919,
  [948] = 919,
  [949] = 925,
  [950] = 922,
  [951] = 922,
  [952] = 922,
  [953] = 925,
  [954] = 925,
  [955] = 919,
  [956] = 286,
  [957] = 809,
  [958] = 922,
  [959] = 919,
  [960] = 414,
  [961] = 921,
  [962] = 921,
  [963] = 922,
  [964] = 925,
  [965] = 925,
  [966] = 925,
  [967] = 921,
  [968] = 921,
  [969] = 924,
  [970] = 919,
  [971] = 922,
  [972] = 919,
  [973] = 925,
  [974] = 921,
  [975] = 924,
  [976] = 922,
  [977] = 921,
  [978] = 919,
  [979] = 441,
  [980] = 919,
  [981] = 921,
  [982] = 87,
  [983] = 925,
  [984] = 922,
  [985] = 922,
  [986] = 924,
  [987] = 921,
  [988] = 921,
  [989] = 918,
  [990] = 919,
  [991] = 925,
  [992] = 922,
  [993] = 918,
  [994] = 922,
  [995] = 919,
  [996] = 686,
  [997] = 921,
  [998] = 924,
  [999] = 922,
  [1000] = 88,
  [1001] = 921,
  [1002] = 922,
  [1003] = 904,
  [1004] = 734,
  [1005] = 925,
  [1006] = 766,
  [1007] = 921,
  [1008] = 918,
  [1009] = 919,
  [1010] = 919,
  [1011] = 919,
  [1012] = 921,
  [1013] = 921,
  [1014] = 287,
  [1015] = 922,
  [1016] = 289,
  [1017] = 919,
  [1018] = 741,
  [1019] = 723,
  [1020] = 735,
  [1021] = 918,
  [1022] = 740,
  [1023] = 922,
  [1024] = 922,
  [1025] = 1025,
  [1026] = 922,
  [1027] = 921,
  [1028] = 288,
  [1029] = 924,
  [1030] = 921,
  [1031] = 925,
  [1032] = 792,
  [1033] = 732,
  [1034] = 781,
  [1035] = 775,
  [1036] = 759,
  [1037] = 714,
  [1038] = 148,
  [1039] = 1025,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 414,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 320,
  [1046] = 325,
  [1047] = 326,
  [1048] = 322,
  [1049] = 147,
  [1050] = 1050,
  [1051] = 328,
  [1052] = 149,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 438,
  [1057] = 1053,
  [1058] = 1058,
  [1059] = 441,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 317,
  [1064] = 316,
  [1065] = 1065,
  [1066] = 315,
  [1067] = 314,
  [1068] = 311,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1054,
  [1076] = 1076,
  [1077] = 1076,
  [1078] = 1060,
  [1079] = 1055,
  [1080] = 1054,
  [1081] = 1043,
  [1082] = 323,
  [1083] = 324,
  [1084] = 1053,
  [1085] = 1044,
  [1086] = 1074,
  [1087] = 1073,
  [1088] = 1061,
  [1089] = 1072,
  [1090] = 1090,
  [1091] = 327,
  [1092] = 1070,
  [1093] = 1069,
  [1094] = 1062,
  [1095] = 1071,
  [1096] = 1061,
  [1097] = 1097,
  [1098] = 1062,
  [1099] = 1050,
  [1100] = 330,
  [1101] = 1101,
  [1102] = 1043,
  [1103] = 1071,
  [1104] = 1050,
  [1105] = 686,
  [1106] = 1106,
  [1107] = 312,
  [1108] = 319,
  [1109] = 1061,
  [1110] = 734,
  [1111] = 766,
  [1112] = 741,
  [1113] = 723,
  [1114] = 1062,
  [1115] = 1071,
  [1116] = 1061,
  [1117] = 1041,
  [1118] = 1118,
  [1119] = 1062,
  [1120] = 1071,
  [1121] = 1121,
  [1122] = 735,
  [1123] = 740,
  [1124] = 1061,
  [1125] = 714,
  [1126] = 759,
  [1127] = 1127,
  [1128] = 775,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1062,
  [1133] = 1071,
  [1134] = 1134,
  [1135] = 1061,
  [1136] = 1062,
  [1137] = 312,
  [1138] = 1071,
  [1139] = 1061,
  [1140] = 1062,
  [1141] = 1058,
  [1142] = 1071,
  [1143] = 781,
  [1144] = 732,
  [1145] = 792,
  [1146] = 1061,
  [1147] = 1062,
  [1148] = 1071,
  [1149] = 1040,
  [1150] = 329,
  [1151] = 1061,
  [1152] = 1152,
  [1153] = 1062,
  [1154] = 1154,
  [1155] = 1071,
  [1156] = 321,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 318,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1152,
  [1166] = 1166,
  [1167] = 1069,
  [1168] = 1070,
  [1169] = 1061,
  [1170] = 1062,
  [1171] = 1071,
  [1172] = 1061,
  [1173] = 1044,
  [1174] = 1053,
  [1175] = 1055,
  [1176] = 1176,
  [1177] = 1072,
  [1178] = 1060,
  [1179] = 1076,
  [1180] = 1073,
  [1181] = 1074,
  [1182] = 1062,
  [1183] = 1074,
  [1184] = 1073,
  [1185] = 1185,
  [1186] = 1072,
  [1187] = 1070,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1071,
  [1191] = 1069,
  [1192] = 1061,
  [1193] = 1062,
  [1194] = 1053,
  [1195] = 1071,
  [1196] = 1054,
  [1197] = 1076,
  [1198] = 1061,
  [1199] = 1060,
  [1200] = 1062,
  [1201] = 1071,
  [1202] = 1055,
  [1203] = 1061,
  [1204] = 1043,
  [1205] = 1062,
  [1206] = 318,
  [1207] = 1071,
  [1208] = 1061,
  [1209] = 1062,
  [1210] = 1050,
  [1211] = 1043,
  [1212] = 1044,
  [1213] = 1055,
  [1214] = 1060,
  [1215] = 1215,
  [1216] = 1076,
  [1217] = 1054,
  [1218] = 1041,
  [1219] = 1074,
  [1220] = 1053,
  [1221] = 1073,
  [1222] = 1072,
  [1223] = 1070,
  [1224] = 1157,
  [1225] = 1225,
  [1226] = 1069,
  [1227] = 1118,
  [1228] = 1129,
  [1229] = 1130,
  [1230] = 1230,
  [1231] = 1131,
  [1232] = 1055,
  [1233] = 1101,
  [1234] = 1060,
  [1235] = 1106,
  [1236] = 1236,
  [1237] = 1076,
  [1238] = 1054,
  [1239] = 327,
  [1240] = 1240,
  [1241] = 1061,
  [1242] = 324,
  [1243] = 323,
  [1244] = 1074,
  [1245] = 1245,
  [1246] = 1062,
  [1247] = 1245,
  [1248] = 1248,
  [1249] = 1071,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1240,
  [1254] = 1071,
  [1255] = 1062,
  [1256] = 1071,
  [1257] = 1073,
  [1258] = 1215,
  [1259] = 1055,
  [1260] = 1060,
  [1261] = 1188,
  [1262] = 1158,
  [1263] = 1185,
  [1264] = 1076,
  [1265] = 1054,
  [1266] = 1074,
  [1267] = 1073,
  [1268] = 1160,
  [1269] = 127,
  [1270] = 311,
  [1271] = 1162,
  [1272] = 314,
  [1273] = 1164,
  [1274] = 1152,
  [1275] = 1166,
  [1276] = 1158,
  [1277] = 1053,
  [1278] = 1055,
  [1279] = 315,
  [1280] = 1072,
  [1281] = 316,
  [1282] = 317,
  [1283] = 1070,
  [1284] = 1069,
  [1285] = 1160,
  [1286] = 1286,
  [1287] = 1060,
  [1288] = 88,
  [1289] = 1076,
  [1290] = 1054,
  [1291] = 1050,
  [1292] = 1074,
  [1293] = 1293,
  [1294] = 1058,
  [1295] = 1072,
  [1296] = 1073,
  [1297] = 1072,
  [1298] = 1070,
  [1299] = 1069,
  [1300] = 1050,
  [1301] = 1215,
  [1302] = 1043,
  [1303] = 1070,
  [1304] = 1248,
  [1305] = 1305,
  [1306] = 1154,
  [1307] = 1044,
  [1308] = 1069,
  [1309] = 1043,
  [1310] = 1044,
  [1311] = 1154,
  [1312] = 160,
  [1313] = 1053,
  [1314] = 1188,
  [1315] = 1185,
  [1316] = 1305,
  [1317] = 1043,
  [1318] = 1176,
  [1319] = 1163,
  [1320] = 1158,
  [1321] = 1161,
  [1322] = 1040,
  [1323] = 1050,
  [1324] = 1157,
  [1325] = 1134,
  [1326] = 159,
  [1327] = 153,
  [1328] = 152,
  [1329] = 1050,
  [1330] = 164,
  [1331] = 1121,
  [1332] = 1044,
  [1333] = 155,
  [1334] = 1160,
  [1335] = 1106,
  [1336] = 161,
  [1337] = 1337,
  [1338] = 328,
  [1339] = 1339,
  [1340] = 326,
  [1341] = 325,
  [1342] = 1188,
  [1343] = 1252,
  [1344] = 1162,
  [1345] = 1185,
  [1346] = 1044,
  [1347] = 1251,
  [1348] = 1348,
  [1349] = 322,
  [1350] = 1097,
  [1351] = 1176,
  [1352] = 1044,
  [1353] = 1250,
  [1354] = 1252,
  [1355] = 1050,
  [1356] = 320,
  [1357] = 1357,
  [1358] = 1248,
  [1359] = 1250,
  [1360] = 1225,
  [1361] = 1230,
  [1362] = 1164,
  [1363] = 1245,
  [1364] = 1240,
  [1365] = 1163,
  [1366] = 1161,
  [1367] = 1040,
  [1368] = 1293,
  [1369] = 1286,
  [1370] = 1134,
  [1371] = 1240,
  [1372] = 1245,
  [1373] = 1152,
  [1374] = 1044,
  [1375] = 165,
  [1376] = 1230,
  [1377] = 1248,
  [1378] = 1250,
  [1379] = 1225,
  [1380] = 1166,
  [1381] = 1161,
  [1382] = 1050,
  [1383] = 166,
  [1384] = 1121,
  [1385] = 1043,
  [1386] = 1251,
  [1387] = 167,
  [1388] = 1106,
  [1389] = 1188,
  [1390] = 1185,
  [1391] = 151,
  [1392] = 1176,
  [1393] = 1118,
  [1394] = 150,
  [1395] = 163,
  [1396] = 1163,
  [1397] = 1161,
  [1398] = 1040,
  [1399] = 330,
  [1400] = 1061,
  [1401] = 162,
  [1402] = 319,
  [1403] = 1043,
  [1404] = 1050,
  [1405] = 1163,
  [1406] = 1069,
  [1407] = 1070,
  [1408] = 1072,
  [1409] = 1073,
  [1410] = 1074,
  [1411] = 1134,
  [1412] = 1054,
  [1413] = 1076,
  [1414] = 1161,
  [1415] = 1060,
  [1416] = 1055,
  [1417] = 1053,
  [1418] = 1044,
  [1419] = 1252,
  [1420] = 1164,
  [1421] = 1215,
  [1422] = 1069,
  [1423] = 1070,
  [1424] = 329,
  [1425] = 1121,
  [1426] = 1044,
  [1427] = 1053,
  [1428] = 1055,
  [1429] = 1060,
  [1430] = 1076,
  [1431] = 1054,
  [1432] = 1157,
  [1433] = 1106,
  [1434] = 1188,
  [1435] = 1185,
  [1436] = 1176,
  [1437] = 1163,
  [1438] = 1043,
  [1439] = 1050,
  [1440] = 1134,
  [1441] = 1040,
  [1442] = 1339,
  [1443] = 1134,
  [1444] = 1069,
  [1445] = 1070,
  [1446] = 148,
  [1447] = 1072,
  [1448] = 1073,
  [1449] = 1069,
  [1450] = 1074,
  [1451] = 1054,
  [1452] = 1076,
  [1453] = 1121,
  [1454] = 1060,
  [1455] = 1055,
  [1456] = 1053,
  [1457] = 1044,
  [1458] = 1070,
  [1459] = 1072,
  [1460] = 1073,
  [1461] = 1074,
  [1462] = 1054,
  [1463] = 1076,
  [1464] = 1166,
  [1465] = 1060,
  [1466] = 1055,
  [1467] = 1106,
  [1468] = 1188,
  [1469] = 1185,
  [1470] = 1176,
  [1471] = 1074,
  [1472] = 1163,
  [1473] = 1161,
  [1474] = 1073,
  [1475] = 1040,
  [1476] = 1134,
  [1477] = 1043,
  [1478] = 1050,
  [1479] = 1072,
  [1480] = 1069,
  [1481] = 1070,
  [1482] = 1072,
  [1483] = 1073,
  [1484] = 1074,
  [1485] = 1054,
  [1486] = 1076,
  [1487] = 1121,
  [1488] = 1060,
  [1489] = 1055,
  [1490] = 1053,
  [1491] = 1106,
  [1492] = 1044,
  [1493] = 1188,
  [1494] = 1070,
  [1495] = 1185,
  [1496] = 1176,
  [1497] = 1163,
  [1498] = 1161,
  [1499] = 1053,
  [1500] = 1044,
  [1501] = 1040,
  [1502] = 1069,
  [1503] = 1134,
  [1504] = 1053,
  [1505] = 1121,
  [1506] = 1106,
  [1507] = 1188,
  [1508] = 1185,
  [1509] = 1176,
  [1510] = 1163,
  [1511] = 1043,
  [1512] = 1050,
  [1513] = 1161,
  [1514] = 1069,
  [1515] = 1070,
  [1516] = 1072,
  [1517] = 1073,
  [1518] = 1074,
  [1519] = 1054,
  [1520] = 1076,
  [1521] = 1040,
  [1522] = 1060,
  [1523] = 1134,
  [1524] = 1097,
  [1525] = 1090,
  [1526] = 1121,
  [1527] = 1176,
  [1528] = 1055,
  [1529] = 1053,
  [1530] = 1044,
  [1531] = 1072,
  [1532] = 1073,
  [1533] = 321,
  [1534] = 1074,
  [1535] = 1054,
  [1536] = 1050,
  [1537] = 1076,
  [1538] = 1043,
  [1539] = 1106,
  [1540] = 1188,
  [1541] = 1185,
  [1542] = 1542,
  [1543] = 1134,
  [1544] = 1176,
  [1545] = 1163,
  [1546] = 1161,
  [1547] = 1121,
  [1548] = 1040,
  [1549] = 1134,
  [1550] = 1154,
  [1551] = 148,
  [1552] = 1043,
  [1553] = 1230,
  [1554] = 1060,
  [1555] = 1121,
  [1556] = 1044,
  [1557] = 1053,
  [1558] = 1106,
  [1559] = 1225,
  [1560] = 1188,
  [1561] = 1185,
  [1562] = 1176,
  [1563] = 1163,
  [1564] = 1161,
  [1565] = 1040,
  [1566] = 1188,
  [1567] = 1055,
  [1568] = 1060,
  [1569] = 1121,
  [1570] = 1106,
  [1571] = 1043,
  [1572] = 1050,
  [1573] = 1188,
  [1574] = 1069,
  [1575] = 1070,
  [1576] = 1072,
  [1577] = 1055,
  [1578] = 1073,
  [1579] = 1060,
  [1580] = 1044,
  [1581] = 1074,
  [1582] = 1054,
  [1583] = 1076,
  [1584] = 1185,
  [1585] = 1060,
  [1586] = 1055,
  [1587] = 1053,
  [1588] = 1044,
  [1589] = 1053,
  [1590] = 1076,
  [1591] = 1076,
  [1592] = 1054,
  [1593] = 1054,
  [1594] = 1074,
  [1595] = 1073,
  [1596] = 1072,
  [1597] = 1070,
  [1598] = 1069,
  [1599] = 1050,
  [1600] = 1043,
  [1601] = 1074,
  [1602] = 1055,
  [1603] = 1215,
  [1604] = 1090,
  [1605] = 1176,
  [1606] = 1055,
  [1607] = 1073,
  [1608] = 1163,
  [1609] = 1060,
  [1610] = 1076,
  [1611] = 1054,
  [1612] = 1154,
  [1613] = 1074,
  [1614] = 1073,
  [1615] = 1072,
  [1616] = 1305,
  [1617] = 1161,
  [1618] = 1040,
  [1619] = 1154,
  [1620] = 1072,
  [1621] = 1134,
  [1622] = 1158,
  [1623] = 1070,
  [1624] = 1157,
  [1625] = 1069,
  [1626] = 1070,
  [1627] = 1251,
  [1628] = 1121,
  [1629] = 1106,
  [1630] = 1106,
  [1631] = 1043,
  [1632] = 1050,
  [1633] = 1185,
  [1634] = 1069,
  [1635] = 1070,
  [1636] = 1072,
  [1637] = 1069,
  [1638] = 1073,
  [1639] = 1074,
  [1640] = 1054,
  [1641] = 1076,
  [1642] = 1176,
  [1643] = 1060,
  [1644] = 1055,
  [1645] = 1053,
  [1646] = 1044,
  [1647] = 1162,
  [1648] = 1166,
  [1649] = 1163,
  [1650] = 1152,
  [1651] = 1161,
  [1652] = 1040,
  [1653] = 1134,
  [1654] = 1121,
  [1655] = 1106,
  [1656] = 1131,
  [1657] = 1130,
  [1658] = 1164,
  [1659] = 1129,
  [1660] = 1188,
  [1661] = 1162,
  [1662] = 1185,
  [1663] = 1176,
  [1664] = 1160,
  [1665] = 1163,
  [1666] = 1161,
  [1667] = 1040,
  [1668] = 1134,
  [1669] = 1121,
  [1670] = 1158,
  [1671] = 1106,
  [1672] = 1188,
  [1673] = 1160,
  [1674] = 1154,
  [1675] = 1162,
  [1676] = 1357,
  [1677] = 1225,
  [1678] = 1185,
  [1679] = 1215,
  [1680] = 1053,
  [1681] = 1176,
  [1682] = 1163,
  [1683] = 1161,
  [1684] = 1040,
  [1685] = 1134,
  [1686] = 1043,
  [1687] = 1050,
  [1688] = 1121,
  [1689] = 1069,
  [1690] = 1070,
  [1691] = 1072,
  [1692] = 1073,
  [1693] = 1074,
  [1694] = 1054,
  [1695] = 1076,
  [1696] = 1043,
  [1697] = 1188,
  [1698] = 1060,
  [1699] = 1055,
  [1700] = 1053,
  [1701] = 1044,
  [1702] = 1166,
  [1703] = 1185,
  [1704] = 1152,
  [1705] = 1230,
  [1706] = 1164,
  [1707] = 1164,
  [1708] = 1162,
  [1709] = 1176,
  [1710] = 1160,
  [1711] = 1293,
  [1712] = 1240,
  [1713] = 1158,
  [1714] = 1245,
  [1715] = 1163,
  [1716] = 1154,
  [1717] = 1152,
  [1718] = 1161,
  [1719] = 1040,
  [1720] = 1134,
  [1721] = 1215,
  [1722] = 1121,
  [1723] = 1106,
  [1724] = 1188,
  [1725] = 1185,
  [1726] = 1176,
  [1727] = 1163,
  [1728] = 1161,
  [1729] = 1040,
  [1730] = 1043,
  [1731] = 1050,
  [1732] = 1134,
  [1733] = 1069,
  [1734] = 1070,
  [1735] = 1072,
  [1736] = 1073,
  [1737] = 1074,
  [1738] = 1054,
  [1739] = 1076,
  [1740] = 1121,
  [1741] = 1060,
  [1742] = 1055,
  [1743] = 1106,
  [1744] = 1248,
  [1745] = 1053,
  [1746] = 1044,
  [1747] = 1252,
  [1748] = 1251,
  [1749] = 1250,
  [1750] = 1166,
  [1751] = 1188,
  [1752] = 1166,
  [1753] = 1185,
  [1754] = 1250,
  [1755] = 1248,
  [1756] = 1152,
  [1757] = 1348,
  [1758] = 1176,
  [1759] = 1163,
  [1760] = 1251,
  [1761] = 1245,
  [1762] = 1240,
  [1763] = 1127,
  [1764] = 1164,
  [1765] = 1043,
  [1766] = 1230,
  [1767] = 1161,
  [1768] = 1225,
  [1769] = 1252,
  [1770] = 1044,
  [1771] = 1050,
  [1772] = 1053,
  [1773] = 1040,
  [1774] = 1162,
  [1775] = 1055,
  [1776] = 1160,
  [1777] = 1060,
  [1778] = 1076,
  [1779] = 1157,
  [1780] = 1134,
  [1781] = 1054,
  [1782] = 1121,
  [1783] = 1158,
  [1784] = 1176,
  [1785] = 1106,
  [1786] = 1050,
  [1787] = 1154,
  [1788] = 1074,
  [1789] = 1073,
  [1790] = 1188,
  [1791] = 1176,
  [1792] = 1188,
  [1793] = 1357,
  [1794] = 1215,
  [1795] = 1072,
  [1796] = 1176,
  [1797] = 1188,
  [1798] = 1176,
  [1799] = 1188,
  [1800] = 1154,
  [1801] = 1176,
  [1802] = 1043,
  [1803] = 1050,
  [1804] = 1188,
  [1805] = 1069,
  [1806] = 1070,
  [1807] = 152,
  [1808] = 179,
  [1809] = 523,
  [1810] = 160,
  [1811] = 177,
  [1812] = 649,
  [1813] = 309,
  [1814] = 160,
  [1815] = 158,
  [1816] = 162,
  [1817] = 176,
  [1818] = 649,
  [1819] = 178,
  [1820] = 171,
  [1821] = 163,
  [1822] = 172,
  [1823] = 169,
  [1824] = 150,
  [1825] = 151,
  [1826] = 304,
  [1827] = 441,
  [1828] = 298,
  [1829] = 1829,
  [1830] = 571,
  [1831] = 167,
  [1832] = 441,
  [1833] = 157,
  [1834] = 303,
  [1835] = 85,
  [1836] = 86,
  [1837] = 173,
  [1838] = 175,
  [1839] = 166,
  [1840] = 591,
  [1841] = 165,
  [1842] = 305,
  [1843] = 88,
  [1844] = 84,
  [1845] = 168,
  [1846] = 438,
  [1847] = 147,
  [1848] = 149,
  [1849] = 170,
  [1850] = 161,
  [1851] = 155,
  [1852] = 164,
  [1853] = 299,
  [1854] = 152,
  [1855] = 306,
  [1856] = 153,
  [1857] = 159,
  [1858] = 127,
  [1859] = 85,
  [1860] = 84,
  [1861] = 164,
  [1862] = 151,
  [1863] = 150,
  [1864] = 297,
  [1865] = 296,
  [1866] = 414,
  [1867] = 310,
  [1868] = 155,
  [1869] = 161,
  [1870] = 307,
  [1871] = 302,
  [1872] = 165,
  [1873] = 163,
  [1874] = 166,
  [1875] = 147,
  [1876] = 162,
  [1877] = 159,
  [1878] = 149,
  [1879] = 301,
  [1880] = 153,
  [1881] = 86,
  [1882] = 167,
  [1883] = 88,
  [1884] = 170,
  [1885] = 306,
  [1886] = 179,
  [1887] = 178,
  [1888] = 176,
  [1889] = 157,
  [1890] = 158,
  [1891] = 302,
  [1892] = 322,
  [1893] = 297,
  [1894] = 410,
  [1895] = 396,
  [1896] = 301,
  [1897] = 299,
  [1898] = 191,
  [1899] = 320,
  [1900] = 411,
  [1901] = 409,
  [1902] = 407,
  [1903] = 168,
  [1904] = 402,
  [1905] = 176,
  [1906] = 178,
  [1907] = 309,
  [1908] = 179,
  [1909] = 304,
  [1910] = 172,
  [1911] = 169,
  [1912] = 305,
  [1913] = 171,
  [1914] = 127,
  [1915] = 306,
  [1916] = 310,
  [1917] = 523,
  [1918] = 330,
  [1919] = 395,
  [1920] = 319,
  [1921] = 395,
  [1922] = 296,
  [1923] = 84,
  [1924] = 329,
  [1925] = 168,
  [1926] = 171,
  [1927] = 183,
  [1928] = 173,
  [1929] = 175,
  [1930] = 309,
  [1931] = 304,
  [1932] = 402,
  [1933] = 321,
  [1934] = 86,
  [1935] = 1935,
  [1936] = 212,
  [1937] = 407,
  [1938] = 298,
  [1939] = 792,
  [1940] = 85,
  [1941] = 686,
  [1942] = 732,
  [1943] = 169,
  [1944] = 740,
  [1945] = 409,
  [1946] = 591,
  [1947] = 325,
  [1948] = 326,
  [1949] = 328,
  [1950] = 394,
  [1951] = 307,
  [1952] = 413,
  [1953] = 204,
  [1954] = 405,
  [1955] = 396,
  [1956] = 1829,
  [1957] = 307,
  [1958] = 307,
  [1959] = 571,
  [1960] = 298,
  [1961] = 158,
  [1962] = 157,
  [1963] = 781,
  [1964] = 413,
  [1965] = 397,
  [1966] = 298,
  [1967] = 205,
  [1968] = 210,
  [1969] = 776,
  [1970] = 403,
  [1971] = 317,
  [1972] = 177,
  [1973] = 306,
  [1974] = 775,
  [1975] = 305,
  [1976] = 305,
  [1977] = 303,
  [1978] = 304,
  [1979] = 172,
  [1980] = 309,
  [1981] = 397,
  [1982] = 403,
  [1983] = 411,
  [1984] = 303,
  [1985] = 318,
  [1986] = 412,
  [1987] = 316,
  [1988] = 410,
  [1989] = 735,
  [1990] = 196,
  [1991] = 198,
  [1992] = 315,
  [1993] = 759,
  [1994] = 314,
  [1995] = 296,
  [1996] = 394,
  [1997] = 182,
  [1998] = 405,
  [1999] = 311,
  [2000] = 184,
  [2001] = 412,
  [2002] = 404,
  [2003] = 404,
  [2004] = 127,
  [2005] = 188,
  [2006] = 127,
  [2007] = 408,
  [2008] = 717,
  [2009] = 303,
  [2010] = 406,
  [2011] = 401,
  [2012] = 398,
  [2013] = 399,
  [2014] = 170,
  [2015] = 206,
  [2016] = 207,
  [2017] = 400,
  [2018] = 323,
  [2019] = 310,
  [2020] = 177,
  [2021] = 187,
  [2022] = 189,
  [2023] = 734,
  [2024] = 766,
  [2025] = 324,
  [2026] = 215,
  [2027] = 723,
  [2028] = 741,
  [2029] = 649,
  [2030] = 192,
  [2031] = 213,
  [2032] = 201,
  [2033] = 186,
  [2034] = 197,
  [2035] = 219,
  [2036] = 310,
  [2037] = 209,
  [2038] = 173,
  [2039] = 714,
  [2040] = 175,
  [2041] = 327,
  [2042] = 408,
  [2043] = 299,
  [2044] = 218,
  [2045] = 301,
  [2046] = 217,
  [2047] = 297,
  [2048] = 214,
  [2049] = 302,
  [2050] = 211,
  [2051] = 406,
  [2052] = 208,
  [2053] = 203,
  [2054] = 202,
  [2055] = 299,
  [2056] = 401,
  [2057] = 400,
  [2058] = 399,
  [2059] = 200,
  [2060] = 180,
  [2061] = 398,
  [2062] = 199,
  [2063] = 195,
  [2064] = 193,
  [2065] = 301,
  [2066] = 297,
  [2067] = 190,
  [2068] = 181,
  [2069] = 296,
  [2070] = 302,
  [2071] = 312,
  [2072] = 185,
  [2073] = 194,
  [2074] = 197,
  [2075] = 213,
  [2076] = 302,
  [2077] = 302,
  [2078] = 828,
  [2079] = 250,
  [2080] = 201,
  [2081] = 297,
  [2082] = 186,
  [2083] = 211,
  [2084] = 209,
  [2085] = 900,
  [2086] = 781,
  [2087] = 297,
  [2088] = 301,
  [2089] = 307,
  [2090] = 876,
  [2091] = 214,
  [2092] = 879,
  [2093] = 222,
  [2094] = 211,
  [2095] = 260,
  [2096] = 310,
  [2097] = 223,
  [2098] = 224,
  [2099] = 815,
  [2100] = 208,
  [2101] = 226,
  [2102] = 884,
  [2103] = 252,
  [2104] = 196,
  [2105] = 236,
  [2106] = 203,
  [2107] = 255,
  [2108] = 202,
  [2109] = 283,
  [2110] = 299,
  [2111] = 198,
  [2112] = 432,
  [2113] = 200,
  [2114] = 306,
  [2115] = 204,
  [2116] = 305,
  [2117] = 298,
  [2118] = 199,
  [2119] = 263,
  [2120] = 264,
  [2121] = 195,
  [2122] = 266,
  [2123] = 267,
  [2124] = 268,
  [2125] = 269,
  [2126] = 304,
  [2127] = 270,
  [2128] = 309,
  [2129] = 281,
  [2130] = 279,
  [2131] = 272,
  [2132] = 259,
  [2133] = 258,
  [2134] = 254,
  [2135] = 221,
  [2136] = 253,
  [2137] = 193,
  [2138] = 251,
  [2139] = 234,
  [2140] = 242,
  [2141] = 303,
  [2142] = 245,
  [2143] = 190,
  [2144] = 185,
  [2145] = 310,
  [2146] = 212,
  [2147] = 296,
  [2148] = 188,
  [2149] = 282,
  [2150] = 280,
  [2151] = 230,
  [2152] = 231,
  [2153] = 232,
  [2154] = 240,
  [2155] = 901,
  [2156] = 249,
  [2157] = 220,
  [2158] = 256,
  [2159] = 855,
  [2160] = 261,
  [2161] = 262,
  [2162] = 915,
  [2163] = 852,
  [2164] = 273,
  [2165] = 839,
  [2166] = 84,
  [2167] = 276,
  [2168] = 914,
  [2169] = 649,
  [2170] = 844,
  [2171] = 206,
  [2172] = 846,
  [2173] = 243,
  [2174] = 207,
  [2175] = 857,
  [2176] = 886,
  [2177] = 244,
  [2178] = 247,
  [2179] = 299,
  [2180] = 309,
  [2181] = 149,
  [2182] = 147,
  [2183] = 714,
  [2184] = 911,
  [2185] = 310,
  [2186] = 910,
  [2187] = 686,
  [2188] = 257,
  [2189] = 759,
  [2190] = 205,
  [2191] = 184,
  [2192] = 182,
  [2193] = 210,
  [2194] = 210,
  [2195] = 227,
  [2196] = 775,
  [2197] = 205,
  [2198] = 182,
  [2199] = 233,
  [2200] = 844,
  [2201] = 248,
  [2202] = 215,
  [2203] = 184,
  [2204] = 246,
  [2205] = 87,
  [2206] = 2206,
  [2207] = 188,
  [2208] = 219,
  [2209] = 218,
  [2210] = 241,
  [2211] = 217,
  [2212] = 238,
  [2213] = 237,
  [2214] = 304,
  [2215] = 301,
  [2216] = 732,
  [2217] = 229,
  [2218] = 225,
  [2219] = 239,
  [2220] = 792,
  [2221] = 734,
  [2222] = 228,
  [2223] = 86,
  [2224] = 85,
  [2225] = 766,
  [2226] = 305,
  [2227] = 717,
  [2228] = 892,
  [2229] = 887,
  [2230] = 883,
  [2231] = 875,
  [2232] = 235,
  [2233] = 180,
  [2234] = 307,
  [2235] = 741,
  [2236] = 194,
  [2237] = 571,
  [2238] = 723,
  [2239] = 837,
  [2240] = 298,
  [2241] = 191,
  [2242] = 265,
  [2243] = 735,
  [2244] = 278,
  [2245] = 277,
  [2246] = 740,
  [2247] = 306,
  [2248] = 187,
  [2249] = 214,
  [2250] = 189,
  [2251] = 196,
  [2252] = 198,
  [2253] = 523,
  [2254] = 275,
  [2255] = 274,
  [2256] = 297,
  [2257] = 271,
  [2258] = 206,
  [2259] = 207,
  [2260] = 298,
  [2261] = 215,
  [2262] = 192,
  [2263] = 219,
  [2264] = 307,
  [2265] = 218,
  [2266] = 834,
  [2267] = 296,
  [2268] = 1829,
  [2269] = 826,
  [2270] = 851,
  [2271] = 87,
  [2272] = 217,
  [2273] = 803,
  [2274] = 303,
  [2275] = 180,
  [2276] = 302,
  [2277] = 296,
  [2278] = 591,
  [2279] = 306,
  [2280] = 185,
  [2281] = 299,
  [2282] = 301,
  [2283] = 194,
  [2284] = 297,
  [2285] = 302,
  [2286] = 204,
  [2287] = 191,
  [2288] = 902,
  [2289] = 908,
  [2290] = 190,
  [2291] = 868,
  [2292] = 866,
  [2293] = 181,
  [2294] = 305,
  [2295] = 523,
  [2296] = 845,
  [2297] = 183,
  [2298] = 303,
  [2299] = 212,
  [2300] = 309,
  [2301] = 304,
  [2302] = 301,
  [2303] = 299,
  [2304] = 309,
  [2305] = 304,
  [2306] = 187,
  [2307] = 189,
  [2308] = 192,
  [2309] = 148,
  [2310] = 183,
  [2311] = 1935,
  [2312] = 307,
  [2313] = 298,
  [2314] = 193,
  [2315] = 303,
  [2316] = 306,
  [2317] = 305,
  [2318] = 195,
  [2319] = 213,
  [2320] = 571,
  [2321] = 199,
  [2322] = 200,
  [2323] = 852,
  [2324] = 202,
  [2325] = 201,
  [2326] = 203,
  [2327] = 208,
  [2328] = 310,
  [2329] = 186,
  [2330] = 296,
  [2331] = 197,
  [2332] = 776,
  [2333] = 209,
  [2334] = 411,
  [2335] = 225,
  [2336] = 402,
  [2337] = 407,
  [2338] = 409,
  [2339] = 410,
  [2340] = 394,
  [2341] = 405,
  [2342] = 395,
  [2343] = 404,
  [2344] = 230,
  [2345] = 231,
  [2346] = 232,
  [2347] = 281,
  [2348] = 279,
  [2349] = 272,
  [2350] = 280,
  [2351] = 282,
  [2352] = 259,
  [2353] = 717,
  [2354] = 258,
  [2355] = 87,
  [2356] = 254,
  [2357] = 291,
  [2358] = 290,
  [2359] = 289,
  [2360] = 408,
  [2361] = 157,
  [2362] = 158,
  [2363] = 221,
  [2364] = 287,
  [2365] = 406,
  [2366] = 310,
  [2367] = 286,
  [2368] = 253,
  [2369] = 288,
  [2370] = 857,
  [2371] = 251,
  [2372] = 247,
  [2373] = 234,
  [2374] = 244,
  [2375] = 243,
  [2376] = 250,
  [2377] = 296,
  [2378] = 401,
  [2379] = 846,
  [2380] = 245,
  [2381] = 844,
  [2382] = 242,
  [2383] = 852,
  [2384] = 855,
  [2385] = 826,
  [2386] = 242,
  [2387] = 225,
  [2388] = 229,
  [2389] = 234,
  [2390] = 237,
  [2391] = 238,
  [2392] = 241,
  [2393] = 883,
  [2394] = 246,
  [2395] = 248,
  [2396] = 915,
  [2397] = 815,
  [2398] = 900,
  [2399] = 251,
  [2400] = 901,
  [2401] = 911,
  [2402] = 910,
  [2403] = 892,
  [2404] = 887,
  [2405] = 245,
  [2406] = 253,
  [2407] = 875,
  [2408] = 837,
  [2409] = 902,
  [2410] = 2206,
  [2411] = 908,
  [2412] = 868,
  [2413] = 866,
  [2414] = 845,
  [2415] = 221,
  [2416] = 254,
  [2417] = 258,
  [2418] = 259,
  [2419] = 803,
  [2420] = 851,
  [2421] = 834,
  [2422] = 302,
  [2423] = 272,
  [2424] = 2424,
  [2425] = 297,
  [2426] = 301,
  [2427] = 914,
  [2428] = 828,
  [2429] = 299,
  [2430] = 279,
  [2431] = 281,
  [2432] = 274,
  [2433] = 275,
  [2434] = 876,
  [2435] = 879,
  [2436] = 884,
  [2437] = 886,
  [2438] = 282,
  [2439] = 277,
  [2440] = 278,
  [2441] = 280,
  [2442] = 149,
  [2443] = 147,
  [2444] = 400,
  [2445] = 399,
  [2446] = 398,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 839,
  [2450] = 240,
  [2451] = 249,
  [2452] = 222,
  [2453] = 260,
  [2454] = 223,
  [2455] = 224,
  [2456] = 226,
  [2457] = 309,
  [2458] = 304,
  [2459] = 305,
  [2460] = 306,
  [2461] = 252,
  [2462] = 236,
  [2463] = 220,
  [2464] = 181,
  [2465] = 255,
  [2466] = 283,
  [2467] = 256,
  [2468] = 2468,
  [2469] = 162,
  [2470] = 163,
  [2471] = 150,
  [2472] = 2472,
  [2473] = 151,
  [2474] = 1829,
  [2475] = 167,
  [2476] = 270,
  [2477] = 271,
  [2478] = 269,
  [2479] = 274,
  [2480] = 247,
  [2481] = 275,
  [2482] = 244,
  [2483] = 243,
  [2484] = 239,
  [2485] = 277,
  [2486] = 228,
  [2487] = 278,
  [2488] = 235,
  [2489] = 268,
  [2490] = 148,
  [2491] = 265,
  [2492] = 265,
  [2493] = 267,
  [2494] = 261,
  [2495] = 1935,
  [2496] = 266,
  [2497] = 235,
  [2498] = 228,
  [2499] = 239,
  [2500] = 166,
  [2501] = 233,
  [2502] = 227,
  [2503] = 257,
  [2504] = 276,
  [2505] = 273,
  [2506] = 262,
  [2507] = 261,
  [2508] = 256,
  [2509] = 264,
  [2510] = 220,
  [2511] = 250,
  [2512] = 249,
  [2513] = 240,
  [2514] = 232,
  [2515] = 231,
  [2516] = 230,
  [2517] = 181,
  [2518] = 263,
  [2519] = 776,
  [2520] = 165,
  [2521] = 262,
  [2522] = 273,
  [2523] = 229,
  [2524] = 237,
  [2525] = 238,
  [2526] = 241,
  [2527] = 246,
  [2528] = 248,
  [2529] = 149,
  [2530] = 147,
  [2531] = 149,
  [2532] = 412,
  [2533] = 403,
  [2534] = 397,
  [2535] = 263,
  [2536] = 233,
  [2537] = 264,
  [2538] = 2206,
  [2539] = 266,
  [2540] = 147,
  [2541] = 160,
  [2542] = 283,
  [2543] = 161,
  [2544] = 267,
  [2545] = 2545,
  [2546] = 255,
  [2547] = 155,
  [2548] = 268,
  [2549] = 269,
  [2550] = 270,
  [2551] = 236,
  [2552] = 164,
  [2553] = 252,
  [2554] = 152,
  [2555] = 227,
  [2556] = 257,
  [2557] = 276,
  [2558] = 153,
  [2559] = 159,
  [2560] = 2560,
  [2561] = 226,
  [2562] = 413,
  [2563] = 224,
  [2564] = 223,
  [2565] = 307,
  [2566] = 396,
  [2567] = 260,
  [2568] = 2568,
  [2569] = 222,
  [2570] = 303,
  [2571] = 271,
  [2572] = 298,
  [2573] = 160,
  [2574] = 287,
  [2575] = 286,
  [2576] = 177,
  [2577] = 902,
  [2578] = 2578,
  [2579] = 158,
  [2580] = 908,
  [2581] = 2560,
  [2582] = 159,
  [2583] = 157,
  [2584] = 432,
  [2585] = 866,
  [2586] = 868,
  [2587] = 868,
  [2588] = 153,
  [2589] = 152,
  [2590] = 866,
  [2591] = 441,
  [2592] = 908,
  [2593] = 837,
  [2594] = 875,
  [2595] = 902,
  [2596] = 887,
  [2597] = 892,
  [2598] = 837,
  [2599] = 875,
  [2600] = 289,
  [2601] = 164,
  [2602] = 147,
  [2603] = 149,
  [2604] = 155,
  [2605] = 161,
  [2606] = 887,
  [2607] = 892,
  [2608] = 291,
  [2609] = 290,
  [2610] = 910,
  [2611] = 911,
  [2612] = 914,
  [2613] = 290,
  [2614] = 901,
  [2615] = 291,
  [2616] = 2448,
  [2617] = 438,
  [2618] = 900,
  [2619] = 815,
  [2620] = 2206,
  [2621] = 148,
  [2622] = 915,
  [2623] = 414,
  [2624] = 826,
  [2625] = 883,
  [2626] = 826,
  [2627] = 1935,
  [2628] = 127,
  [2629] = 84,
  [2630] = 88,
  [2631] = 289,
  [2632] = 883,
  [2633] = 165,
  [2634] = 886,
  [2635] = 166,
  [2636] = 2636,
  [2637] = 287,
  [2638] = 173,
  [2639] = 286,
  [2640] = 176,
  [2641] = 175,
  [2642] = 167,
  [2643] = 150,
  [2644] = 178,
  [2645] = 179,
  [2646] = 157,
  [2647] = 158,
  [2648] = 172,
  [2649] = 857,
  [2650] = 169,
  [2651] = 87,
  [2652] = 414,
  [2653] = 846,
  [2654] = 288,
  [2655] = 844,
  [2656] = 845,
  [2657] = 915,
  [2658] = 158,
  [2659] = 852,
  [2660] = 855,
  [2661] = 157,
  [2662] = 163,
  [2663] = 910,
  [2664] = 911,
  [2665] = 438,
  [2666] = 914,
  [2667] = 901,
  [2668] = 803,
  [2669] = 851,
  [2670] = 834,
  [2671] = 886,
  [2672] = 828,
  [2673] = 815,
  [2674] = 857,
  [2675] = 171,
  [2676] = 900,
  [2677] = 168,
  [2678] = 839,
  [2679] = 884,
  [2680] = 879,
  [2681] = 876,
  [2682] = 85,
  [2683] = 828,
  [2684] = 86,
  [2685] = 288,
  [2686] = 162,
  [2687] = 2424,
  [2688] = 170,
  [2689] = 834,
  [2690] = 855,
  [2691] = 851,
  [2692] = 2447,
  [2693] = 803,
  [2694] = 846,
  [2695] = 839,
  [2696] = 2568,
  [2697] = 148,
  [2698] = 2545,
  [2699] = 151,
  [2700] = 2468,
  [2701] = 2472,
  [2702] = 884,
  [2703] = 879,
  [2704] = 876,
  [2705] = 845,
  [2706] = 886,
  [2707] = 151,
  [2708] = 159,
  [2709] = 153,
  [2710] = 441,
  [2711] = 441,
  [2712] = 852,
  [2713] = 152,
  [2714] = 318,
  [2715] = 175,
  [2716] = 164,
  [2717] = 173,
  [2718] = 155,
  [2719] = 161,
  [2720] = 571,
  [2721] = 165,
  [2722] = 166,
  [2723] = 844,
  [2724] = 167,
  [2725] = 178,
  [2726] = 2578,
  [2727] = 151,
  [2728] = 438,
  [2729] = 150,
  [2730] = 163,
  [2731] = 196,
  [2732] = 198,
  [2733] = 441,
  [2734] = 162,
  [2735] = 160,
  [2736] = 204,
  [2737] = 212,
  [2738] = 207,
  [2739] = 183,
  [2740] = 523,
  [2741] = 298,
  [2742] = 307,
  [2743] = 438,
  [2744] = 148,
  [2745] = 205,
  [2746] = 215,
  [2747] = 219,
  [2748] = 218,
  [2749] = 217,
  [2750] = 180,
  [2751] = 210,
  [2752] = 194,
  [2753] = 191,
  [2754] = 206,
  [2755] = 414,
  [2756] = 182,
  [2757] = 185,
  [2758] = 312,
  [2759] = 190,
  [2760] = 184,
  [2761] = 2560,
  [2762] = 188,
  [2763] = 177,
  [2764] = 148,
  [2765] = 414,
  [2766] = 2766,
  [2767] = 149,
  [2768] = 147,
  [2769] = 649,
  [2770] = 157,
  [2771] = 158,
  [2772] = 2636,
  [2773] = 127,
  [2774] = 181,
  [2775] = 414,
  [2776] = 438,
  [2777] = 310,
  [2778] = 88,
  [2779] = 2206,
  [2780] = 296,
  [2781] = 327,
  [2782] = 324,
  [2783] = 323,
  [2784] = 302,
  [2785] = 297,
  [2786] = 301,
  [2787] = 311,
  [2788] = 314,
  [2789] = 315,
  [2790] = 195,
  [2791] = 316,
  [2792] = 317,
  [2793] = 2793,
  [2794] = 199,
  [2795] = 200,
  [2796] = 202,
  [2797] = 176,
  [2798] = 299,
  [2799] = 179,
  [2800] = 172,
  [2801] = 169,
  [2802] = 328,
  [2803] = 326,
  [2804] = 325,
  [2805] = 322,
  [2806] = 309,
  [2807] = 320,
  [2808] = 304,
  [2809] = 303,
  [2810] = 305,
  [2811] = 306,
  [2812] = 2560,
  [2813] = 160,
  [2814] = 159,
  [2815] = 187,
  [2816] = 203,
  [2817] = 330,
  [2818] = 153,
  [2819] = 152,
  [2820] = 319,
  [2821] = 164,
  [2822] = 329,
  [2823] = 171,
  [2824] = 155,
  [2825] = 161,
  [2826] = 168,
  [2827] = 147,
  [2828] = 149,
  [2829] = 127,
  [2830] = 321,
  [2831] = 208,
  [2832] = 165,
  [2833] = 211,
  [2834] = 166,
  [2835] = 170,
  [2836] = 214,
  [2837] = 167,
  [2838] = 148,
  [2839] = 209,
  [2840] = 193,
  [2841] = 197,
  [2842] = 186,
  [2843] = 201,
  [2844] = 213,
  [2845] = 192,
  [2846] = 162,
  [2847] = 189,
  [2848] = 163,
  [2849] = 150,
  [2850] = 269,
  [2851] = 88,
  [2852] = 161,
  [2853] = 155,
  [2854] = 322,
  [2855] = 320,
  [2856] = 164,
  [2857] = 152,
  [2858] = 166,
  [2859] = 252,
  [2860] = 254,
  [2861] = 236,
  [2862] = 327,
  [2863] = 224,
  [2864] = 153,
  [2865] = 168,
  [2866] = 255,
  [2867] = 2636,
  [2868] = 159,
  [2869] = 175,
  [2870] = 844,
  [2871] = 165,
  [2872] = 173,
  [2873] = 283,
  [2874] = 260,
  [2875] = 326,
  [2876] = 325,
  [2877] = 171,
  [2878] = 328,
  [2879] = 323,
  [2880] = 212,
  [2881] = 211,
  [2882] = 441,
  [2883] = 263,
  [2884] = 222,
  [2885] = 264,
  [2886] = 204,
  [2887] = 167,
  [2888] = 151,
  [2889] = 150,
  [2890] = 84,
  [2891] = 571,
  [2892] = 85,
  [2893] = 523,
  [2894] = 86,
  [2895] = 266,
  [2896] = 177,
  [2897] = 267,
  [2898] = 268,
  [2899] = 591,
  [2900] = 163,
  [2901] = 315,
  [2902] = 158,
  [2903] = 321,
  [2904] = 270,
  [2905] = 157,
  [2906] = 229,
  [2907] = 176,
  [2908] = 178,
  [2909] = 179,
  [2910] = 172,
  [2911] = 160,
  [2912] = 169,
  [2913] = 162,
  [2914] = 441,
  [2915] = 205,
  [2916] = 210,
  [2917] = 182,
  [2918] = 184,
  [2919] = 188,
  [2920] = 162,
  [2921] = 163,
  [2922] = 2922,
  [2923] = 414,
  [2924] = 183,
  [2925] = 150,
  [2926] = 151,
  [2927] = 187,
  [2928] = 189,
  [2929] = 167,
  [2930] = 192,
  [2931] = 213,
  [2932] = 591,
  [2933] = 201,
  [2934] = 281,
  [2935] = 2560,
  [2936] = 171,
  [2937] = 168,
  [2938] = 170,
  [2939] = 279,
  [2940] = 272,
  [2941] = 176,
  [2942] = 186,
  [2943] = 2943,
  [2944] = 197,
  [2945] = 209,
  [2946] = 226,
  [2947] = 259,
  [2948] = 258,
  [2949] = 148,
  [2950] = 221,
  [2951] = 318,
  [2952] = 253,
  [2953] = 87,
  [2954] = 438,
  [2955] = 234,
  [2956] = 242,
  [2957] = 245,
  [2958] = 441,
  [2959] = 214,
  [2960] = 312,
  [2961] = 88,
  [2962] = 169,
  [2963] = 172,
  [2964] = 179,
  [2965] = 178,
  [2966] = 314,
  [2967] = 208,
  [2968] = 282,
  [2969] = 203,
  [2970] = 326,
  [2971] = 280,
  [2972] = 251,
  [2973] = 324,
  [2974] = 157,
  [2975] = 158,
  [2976] = 202,
  [2977] = 200,
  [2978] = 199,
  [2979] = 312,
  [2980] = 162,
  [2981] = 163,
  [2982] = 150,
  [2983] = 330,
  [2984] = 151,
  [2985] = 319,
  [2986] = 167,
  [2987] = 166,
  [2988] = 165,
  [2989] = 195,
  [2990] = 161,
  [2991] = 155,
  [2992] = 164,
  [2993] = 152,
  [2994] = 153,
  [2995] = 159,
  [2996] = 852,
  [2997] = 327,
  [2998] = 127,
  [2999] = 324,
  [3000] = 271,
  [3001] = 160,
  [3002] = 1935,
  [3003] = 274,
  [3004] = 321,
  [3005] = 230,
  [3006] = 231,
  [3007] = 232,
  [3008] = 438,
  [3009] = 329,
  [3010] = 240,
  [3011] = 249,
  [3012] = 220,
  [3013] = 256,
  [3014] = 261,
  [3015] = 262,
  [3016] = 193,
  [3017] = 273,
  [3018] = 190,
  [3019] = 276,
  [3020] = 185,
  [3021] = 257,
  [3022] = 191,
  [3023] = 194,
  [3024] = 323,
  [3025] = 166,
  [3026] = 165,
  [3027] = 227,
  [3028] = 223,
  [3029] = 233,
  [3030] = 311,
  [3031] = 314,
  [3032] = 180,
  [3033] = 149,
  [3034] = 147,
  [3035] = 441,
  [3036] = 161,
  [3037] = 155,
  [3038] = 164,
  [3039] = 152,
  [3040] = 153,
  [3041] = 159,
  [3042] = 315,
  [3043] = 318,
  [3044] = 316,
  [3045] = 149,
  [3046] = 147,
  [3047] = 414,
  [3048] = 217,
  [3049] = 160,
  [3050] = 218,
  [3051] = 317,
  [3052] = 414,
  [3053] = 248,
  [3054] = 246,
  [3055] = 237,
  [3056] = 238,
  [3057] = 241,
  [3058] = 219,
  [3059] = 275,
  [3060] = 414,
  [3061] = 277,
  [3062] = 278,
  [3063] = 328,
  [3064] = 265,
  [3065] = 215,
  [3066] = 886,
  [3067] = 329,
  [3068] = 319,
  [3069] = 330,
  [3070] = 235,
  [3071] = 88,
  [3072] = 438,
  [3073] = 175,
  [3074] = 173,
  [3075] = 243,
  [3076] = 244,
  [3077] = 247,
  [3078] = 207,
  [3079] = 206,
  [3080] = 228,
  [3081] = 239,
  [3082] = 717,
  [3083] = 2793,
  [3084] = 438,
  [3085] = 317,
  [3086] = 316,
  [3087] = 325,
  [3088] = 2766,
  [3089] = 198,
  [3090] = 196,
  [3091] = 250,
  [3092] = 170,
  [3093] = 311,
  [3094] = 177,
  [3095] = 225,
  [3096] = 320,
  [3097] = 322,
  [3098] = 176,
  [3099] = 317,
  [3100] = 413,
  [3101] = 329,
  [3102] = 213,
  [3103] = 88,
  [3104] = 201,
  [3105] = 192,
  [3106] = 283,
  [3107] = 255,
  [3108] = 236,
  [3109] = 252,
  [3110] = 321,
  [3111] = 226,
  [3112] = 224,
  [3113] = 189,
  [3114] = 223,
  [3115] = 260,
  [3116] = 187,
  [3117] = 329,
  [3118] = 186,
  [3119] = 319,
  [3120] = 197,
  [3121] = 330,
  [3122] = 209,
  [3123] = 321,
  [3124] = 1829,
  [3125] = 318,
  [3126] = 319,
  [3127] = 214,
  [3128] = 175,
  [3129] = 211,
  [3130] = 208,
  [3131] = 222,
  [3132] = 173,
  [3133] = 330,
  [3134] = 320,
  [3135] = 396,
  [3136] = 322,
  [3137] = 325,
  [3138] = 263,
  [3139] = 264,
  [3140] = 326,
  [3141] = 266,
  [3142] = 250,
  [3143] = 267,
  [3144] = 649,
  [3145] = 268,
  [3146] = 269,
  [3147] = 270,
  [3148] = 328,
  [3149] = 158,
  [3150] = 157,
  [3151] = 176,
  [3152] = 1935,
  [3153] = 178,
  [3154] = 397,
  [3155] = 243,
  [3156] = 320,
  [3157] = 178,
  [3158] = 179,
  [3159] = 244,
  [3160] = 179,
  [3161] = 247,
  [3162] = 172,
  [3163] = 318,
  [3164] = 204,
  [3165] = 172,
  [3166] = 403,
  [3167] = 412,
  [3168] = 169,
  [3169] = 322,
  [3170] = 181,
  [3171] = 203,
  [3172] = 202,
  [3173] = 328,
  [3174] = 312,
  [3175] = 326,
  [3176] = 325,
  [3177] = 281,
  [3178] = 279,
  [3179] = 160,
  [3180] = 177,
  [3181] = 272,
  [3182] = 169,
  [3183] = 147,
  [3184] = 149,
  [3185] = 88,
  [3186] = 317,
  [3187] = 177,
  [3188] = 316,
  [3189] = 315,
  [3190] = 200,
  [3191] = 199,
  [3192] = 195,
  [3193] = 193,
  [3194] = 190,
  [3195] = 185,
  [3196] = 259,
  [3197] = 258,
  [3198] = 254,
  [3199] = 221,
  [3200] = 253,
  [3201] = 414,
  [3202] = 314,
  [3203] = 311,
  [3204] = 325,
  [3205] = 251,
  [3206] = 234,
  [3207] = 191,
  [3208] = 194,
  [3209] = 212,
  [3210] = 855,
  [3211] = 326,
  [3212] = 159,
  [3213] = 180,
  [3214] = 153,
  [3215] = 328,
  [3216] = 217,
  [3217] = 152,
  [3218] = 164,
  [3219] = 242,
  [3220] = 155,
  [3221] = 218,
  [3222] = 219,
  [3223] = 245,
  [3224] = 175,
  [3225] = 161,
  [3226] = 173,
  [3227] = 165,
  [3228] = 327,
  [3229] = 215,
  [3230] = 282,
  [3231] = 280,
  [3232] = 166,
  [3233] = 324,
  [3234] = 183,
  [3235] = 323,
  [3236] = 167,
  [3237] = 151,
  [3238] = 398,
  [3239] = 150,
  [3240] = 322,
  [3241] = 163,
  [3242] = 162,
  [3243] = 207,
  [3244] = 206,
  [3245] = 323,
  [3246] = 324,
  [3247] = 327,
  [3248] = 591,
  [3249] = 591,
  [3250] = 127,
  [3251] = 198,
  [3252] = 399,
  [3253] = 312,
  [3254] = 171,
  [3255] = 168,
  [3256] = 317,
  [3257] = 320,
  [3258] = 400,
  [3259] = 401,
  [3260] = 406,
  [3261] = 408,
  [3262] = 196,
  [3263] = 230,
  [3264] = 84,
  [3265] = 231,
  [3266] = 232,
  [3267] = 571,
  [3268] = 240,
  [3269] = 316,
  [3270] = 249,
  [3271] = 170,
  [3272] = 315,
  [3273] = 220,
  [3274] = 311,
  [3275] = 256,
  [3276] = 261,
  [3277] = 262,
  [3278] = 314,
  [3279] = 273,
  [3280] = 276,
  [3281] = 315,
  [3282] = 257,
  [3283] = 316,
  [3284] = 649,
  [3285] = 227,
  [3286] = 233,
  [3287] = 441,
  [3288] = 314,
  [3289] = 288,
  [3290] = 404,
  [3291] = 127,
  [3292] = 311,
  [3293] = 405,
  [3294] = 394,
  [3295] = 410,
  [3296] = 411,
  [3297] = 248,
  [3298] = 318,
  [3299] = 317,
  [3300] = 173,
  [3301] = 438,
  [3302] = 175,
  [3303] = 246,
  [3304] = 241,
  [3305] = 238,
  [3306] = 237,
  [3307] = 229,
  [3308] = 318,
  [3309] = 225,
  [3310] = 409,
  [3311] = 407,
  [3312] = 316,
  [3313] = 571,
  [3314] = 402,
  [3315] = 239,
  [3316] = 127,
  [3317] = 228,
  [3318] = 315,
  [3319] = 314,
  [3320] = 311,
  [3321] = 235,
  [3322] = 176,
  [3323] = 178,
  [3324] = 265,
  [3325] = 179,
  [3326] = 172,
  [3327] = 169,
  [3328] = 395,
  [3329] = 278,
  [3330] = 523,
  [3331] = 277,
  [3332] = 275,
  [3333] = 328,
  [3334] = 274,
  [3335] = 271,
  [3336] = 326,
  [3337] = 85,
  [3338] = 523,
  [3339] = 571,
  [3340] = 325,
  [3341] = 183,
  [3342] = 322,
  [3343] = 1829,
  [3344] = 649,
  [3345] = 320,
  [3346] = 212,
  [3347] = 204,
  [3348] = 323,
  [3349] = 324,
  [3350] = 291,
  [3351] = 290,
  [3352] = 523,
  [3353] = 327,
  [3354] = 188,
  [3355] = 2636,
  [3356] = 846,
  [3357] = 323,
  [3358] = 330,
  [3359] = 319,
  [3360] = 324,
  [3361] = 327,
  [3362] = 86,
  [3363] = 329,
  [3364] = 171,
  [3365] = 168,
  [3366] = 205,
  [3367] = 857,
  [3368] = 289,
  [3369] = 210,
  [3370] = 182,
  [3371] = 321,
  [3372] = 184,
  [3373] = 188,
  [3374] = 170,
  [3375] = 184,
  [3376] = 182,
  [3377] = 210,
  [3378] = 591,
  [3379] = 187,
  [3380] = 287,
  [3381] = 330,
  [3382] = 196,
  [3383] = 319,
  [3384] = 198,
  [3385] = 1829,
  [3386] = 286,
  [3387] = 329,
  [3388] = 171,
  [3389] = 312,
  [3390] = 157,
  [3391] = 158,
  [3392] = 312,
  [3393] = 206,
  [3394] = 168,
  [3395] = 170,
  [3396] = 207,
  [3397] = 215,
  [3398] = 219,
  [3399] = 218,
  [3400] = 217,
  [3401] = 180,
  [3402] = 189,
  [3403] = 192,
  [3404] = 205,
  [3405] = 177,
  [3406] = 213,
  [3407] = 201,
  [3408] = 186,
  [3409] = 197,
  [3410] = 209,
  [3411] = 194,
  [3412] = 191,
  [3413] = 214,
  [3414] = 211,
  [3415] = 776,
  [3416] = 208,
  [3417] = 776,
  [3418] = 203,
  [3419] = 202,
  [3420] = 200,
  [3421] = 199,
  [3422] = 195,
  [3423] = 2766,
  [3424] = 185,
  [3425] = 190,
  [3426] = 321,
  [3427] = 193,
  [3428] = 203,
  [3429] = 202,
  [3430] = 200,
  [3431] = 181,
  [3432] = 845,
  [3433] = 302,
  [3434] = 866,
  [3435] = 591,
  [3436] = 199,
  [3437] = 222,
  [3438] = 868,
  [3439] = 260,
  [3440] = 223,
  [3441] = 312,
  [3442] = 224,
  [3443] = 204,
  [3444] = 226,
  [3445] = 908,
  [3446] = 252,
  [3447] = 195,
  [3448] = 803,
  [3449] = 236,
  [3450] = 851,
  [3451] = 834,
  [3452] = 902,
  [3453] = 255,
  [3454] = 886,
  [3455] = 193,
  [3456] = 828,
  [3457] = 857,
  [3458] = 283,
  [3459] = 233,
  [3460] = 190,
  [3461] = 1829,
  [3462] = 250,
  [3463] = 185,
  [3464] = 212,
  [3465] = 243,
  [3466] = 846,
  [3467] = 844,
  [3468] = 244,
  [3469] = 876,
  [3470] = 879,
  [3471] = 884,
  [3472] = 776,
  [3473] = 247,
  [3474] = 263,
  [3475] = 149,
  [3476] = 264,
  [3477] = 84,
  [3478] = 147,
  [3479] = 839,
  [3480] = 297,
  [3481] = 301,
  [3482] = 852,
  [3483] = 191,
  [3484] = 266,
  [3485] = 855,
  [3486] = 303,
  [3487] = 87,
  [3488] = 299,
  [3489] = 267,
  [3490] = 268,
  [3491] = 205,
  [3492] = 269,
  [3493] = 270,
  [3494] = 227,
  [3495] = 837,
  [3496] = 208,
  [3497] = 211,
  [3498] = 318,
  [3499] = 257,
  [3500] = 210,
  [3501] = 395,
  [3502] = 875,
  [3503] = 281,
  [3504] = 279,
  [3505] = 272,
  [3506] = 86,
  [3507] = 259,
  [3508] = 258,
  [3509] = 254,
  [3510] = 221,
  [3511] = 253,
  [3512] = 251,
  [3513] = 182,
  [3514] = 234,
  [3515] = 184,
  [3516] = 242,
  [3517] = 245,
  [3518] = 214,
  [3519] = 398,
  [3520] = 188,
  [3521] = 296,
  [3522] = 85,
  [3523] = 282,
  [3524] = 290,
  [3525] = 280,
  [3526] = 276,
  [3527] = 181,
  [3528] = 209,
  [3529] = 197,
  [3530] = 399,
  [3531] = 717,
  [3532] = 186,
  [3533] = 201,
  [3534] = 400,
  [3535] = 84,
  [3536] = 406,
  [3537] = 408,
  [3538] = 327,
  [3539] = 230,
  [3540] = 591,
  [3541] = 231,
  [3542] = 232,
  [3543] = 240,
  [3544] = 183,
  [3545] = 310,
  [3546] = 249,
  [3547] = 220,
  [3548] = 256,
  [3549] = 212,
  [3550] = 324,
  [3551] = 261,
  [3552] = 262,
  [3553] = 204,
  [3554] = 323,
  [3555] = 273,
  [3556] = 887,
  [3557] = 276,
  [3558] = 892,
  [3559] = 183,
  [3560] = 257,
  [3561] = 194,
  [3562] = 227,
  [3563] = 248,
  [3564] = 246,
  [3565] = 233,
  [3566] = 273,
  [3567] = 413,
  [3568] = 180,
  [3569] = 649,
  [3570] = 213,
  [3571] = 217,
  [3572] = 2766,
  [3573] = 311,
  [3574] = 314,
  [3575] = 649,
  [3576] = 315,
  [3577] = 218,
  [3578] = 219,
  [3579] = 910,
  [3580] = 248,
  [3581] = 246,
  [3582] = 205,
  [3583] = 309,
  [3584] = 210,
  [3585] = 241,
  [3586] = 182,
  [3587] = 238,
  [3588] = 184,
  [3589] = 237,
  [3590] = 188,
  [3591] = 229,
  [3592] = 225,
  [3593] = 911,
  [3594] = 316,
  [3595] = 317,
  [3596] = 241,
  [3597] = 238,
  [3598] = 914,
  [3599] = 239,
  [3600] = 228,
  [3601] = 901,
  [3602] = 235,
  [3603] = 237,
  [3604] = 181,
  [3605] = 265,
  [3606] = 262,
  [3607] = 229,
  [3608] = 278,
  [3609] = 277,
  [3610] = 320,
  [3611] = 127,
  [3612] = 275,
  [3613] = 274,
  [3614] = 271,
  [3615] = 225,
  [3616] = 571,
  [3617] = 88,
  [3618] = 215,
  [3619] = 261,
  [3620] = 649,
  [3621] = 328,
  [3622] = 298,
  [3623] = 256,
  [3624] = 900,
  [3625] = 207,
  [3626] = 326,
  [3627] = 307,
  [3628] = 206,
  [3629] = 325,
  [3630] = 220,
  [3631] = 249,
  [3632] = 192,
  [3633] = 401,
  [3634] = 189,
  [3635] = 306,
  [3636] = 187,
  [3637] = 240,
  [3638] = 305,
  [3639] = 304,
  [3640] = 815,
  [3641] = 196,
  [3642] = 198,
  [3643] = 412,
  [3644] = 232,
  [3645] = 915,
  [3646] = 231,
  [3647] = 403,
  [3648] = 230,
  [3649] = 322,
  [3650] = 397,
  [3651] = 172,
  [3652] = 206,
  [3653] = 649,
  [3654] = 207,
  [3655] = 183,
  [3656] = 883,
  [3657] = 212,
  [3658] = 204,
  [3659] = 402,
  [3660] = 407,
  [3661] = 409,
  [3662] = 826,
  [3663] = 591,
  [3664] = 330,
  [3665] = 776,
  [3666] = 247,
  [3667] = 244,
  [3668] = 243,
  [3669] = 776,
  [3670] = 523,
  [3671] = 717,
  [3672] = 187,
  [3673] = 175,
  [3674] = 271,
  [3675] = 189,
  [3676] = 274,
  [3677] = 173,
  [3678] = 198,
  [3679] = 205,
  [3680] = 192,
  [3681] = 319,
  [3682] = 210,
  [3683] = 523,
  [3684] = 182,
  [3685] = 275,
  [3686] = 184,
  [3687] = 188,
  [3688] = 277,
  [3689] = 278,
  [3690] = 196,
  [3691] = 717,
  [3692] = 215,
  [3693] = 213,
  [3694] = 219,
  [3695] = 201,
  [3696] = 88,
  [3697] = 218,
  [3698] = 186,
  [3699] = 280,
  [3700] = 282,
  [3701] = 197,
  [3702] = 217,
  [3703] = 180,
  [3704] = 250,
  [3705] = 265,
  [3706] = 194,
  [3707] = 86,
  [3708] = 85,
  [3709] = 395,
  [3710] = 396,
  [3711] = 191,
  [3712] = 329,
  [3713] = 170,
  [3714] = 185,
  [3715] = 190,
  [3716] = 193,
  [3717] = 209,
  [3718] = 649,
  [3719] = 245,
  [3720] = 195,
  [3721] = 242,
  [3722] = 234,
  [3723] = 214,
  [3724] = 396,
  [3725] = 211,
  [3726] = 402,
  [3727] = 199,
  [3728] = 407,
  [3729] = 200,
  [3730] = 208,
  [3731] = 404,
  [3732] = 177,
  [3733] = 203,
  [3734] = 202,
  [3735] = 200,
  [3736] = 199,
  [3737] = 195,
  [3738] = 193,
  [3739] = 202,
  [3740] = 190,
  [3741] = 185,
  [3742] = 591,
  [3743] = 203,
  [3744] = 288,
  [3745] = 235,
  [3746] = 251,
  [3747] = 208,
  [3748] = 253,
  [3749] = 211,
  [3750] = 432,
  [3751] = 405,
  [3752] = 413,
  [3753] = 321,
  [3754] = 191,
  [3755] = 194,
  [3756] = 214,
  [3757] = 209,
  [3758] = 197,
  [3759] = 186,
  [3760] = 147,
  [3761] = 149,
  [3762] = 180,
  [3763] = 217,
  [3764] = 409,
  [3765] = 394,
  [3766] = 218,
  [3767] = 219,
  [3768] = 215,
  [3769] = 201,
  [3770] = 221,
  [3771] = 2206,
  [3772] = 410,
  [3773] = 207,
  [3774] = 411,
  [3775] = 254,
  [3776] = 206,
  [3777] = 258,
  [3778] = 259,
  [3779] = 272,
  [3780] = 168,
  [3781] = 171,
  [3782] = 279,
  [3783] = 281,
  [3784] = 571,
  [3785] = 411,
  [3786] = 410,
  [3787] = 394,
  [3788] = 405,
  [3789] = 213,
  [3790] = 198,
  [3791] = 196,
  [3792] = 404,
  [3793] = 291,
  [3794] = 397,
  [3795] = 228,
  [3796] = 239,
  [3797] = 403,
  [3798] = 286,
  [3799] = 287,
  [3800] = 222,
  [3801] = 260,
  [3802] = 270,
  [3803] = 223,
  [3804] = 269,
  [3805] = 224,
  [3806] = 226,
  [3807] = 252,
  [3808] = 236,
  [3809] = 268,
  [3810] = 267,
  [3811] = 266,
  [3812] = 192,
  [3813] = 264,
  [3814] = 263,
  [3815] = 189,
  [3816] = 187,
  [3817] = 289,
  [3818] = 412,
  [3819] = 157,
  [3820] = 400,
  [3821] = 399,
  [3822] = 255,
  [3823] = 571,
  [3824] = 408,
  [3825] = 179,
  [3826] = 406,
  [3827] = 398,
  [3828] = 178,
  [3829] = 401,
  [3830] = 176,
  [3831] = 283,
  [3832] = 158,
  [3833] = 523,
  [3834] = 169,
  [3835] = 256,
  [3836] = 233,
  [3837] = 225,
  [3838] = 815,
  [3839] = 239,
  [3840] = 228,
  [3841] = 234,
  [3842] = 251,
  [3843] = 253,
  [3844] = 221,
  [3845] = 254,
  [3846] = 235,
  [3847] = 265,
  [3848] = 278,
  [3849] = 910,
  [3850] = 911,
  [3851] = 277,
  [3852] = 275,
  [3853] = 258,
  [3854] = 274,
  [3855] = 247,
  [3856] = 307,
  [3857] = 244,
  [3858] = 857,
  [3859] = 243,
  [3860] = 846,
  [3861] = 229,
  [3862] = 844,
  [3863] = 237,
  [3864] = 915,
  [3865] = 220,
  [3866] = 914,
  [3867] = 395,
  [3868] = 243,
  [3869] = 892,
  [3870] = 846,
  [3871] = 411,
  [3872] = 407,
  [3873] = 298,
  [3874] = 241,
  [3875] = 901,
  [3876] = 857,
  [3877] = 290,
  [3878] = 291,
  [3879] = 402,
  [3880] = 244,
  [3881] = 407,
  [3882] = 409,
  [3883] = 247,
  [3884] = 855,
  [3885] = 87,
  [3886] = 246,
  [3887] = 717,
  [3888] = 188,
  [3889] = 303,
  [3890] = 184,
  [3891] = 248,
  [3892] = 411,
  [3893] = 410,
  [3894] = 394,
  [3895] = 405,
  [3896] = 242,
  [3897] = 409,
  [3898] = 404,
  [3899] = 839,
  [3900] = 158,
  [3901] = 402,
  [3902] = 883,
  [3903] = 303,
  [3904] = 259,
  [3905] = 272,
  [3906] = 233,
  [3907] = 410,
  [3908] = 279,
  [3909] = 281,
  [3910] = 394,
  [3911] = 405,
  [3912] = 182,
  [3913] = 245,
  [3914] = 852,
  [3915] = 227,
  [3916] = 404,
  [3917] = 887,
  [3918] = 855,
  [3919] = 257,
  [3920] = 408,
  [3921] = 406,
  [3922] = 210,
  [3923] = 826,
  [3924] = 205,
  [3925] = 523,
  [3926] = 900,
  [3927] = 298,
  [3928] = 826,
  [3929] = 88,
  [3930] = 307,
  [3931] = 276,
  [3932] = 187,
  [3933] = 273,
  [3934] = 883,
  [3935] = 189,
  [3936] = 270,
  [3937] = 875,
  [3938] = 192,
  [3939] = 401,
  [3940] = 855,
  [3941] = 852,
  [3942] = 400,
  [3943] = 399,
  [3944] = 84,
  [3945] = 262,
  [3946] = 398,
  [3947] = 247,
  [3948] = 310,
  [3949] = 837,
  [3950] = 261,
  [3951] = 288,
  [3952] = 244,
  [3953] = 256,
  [3954] = 884,
  [3955] = 289,
  [3956] = 249,
  [3957] = 243,
  [3958] = 310,
  [3959] = 839,
  [3960] = 395,
  [3961] = 240,
  [3962] = 408,
  [3963] = 406,
  [3964] = 844,
  [3965] = 250,
  [3966] = 282,
  [3967] = 280,
  [3968] = 846,
  [3969] = 232,
  [3970] = 2636,
  [3971] = 231,
  [3972] = 269,
  [3973] = 396,
  [3974] = 213,
  [3975] = 230,
  [3976] = 201,
  [3977] = 879,
  [3978] = 186,
  [3979] = 876,
  [3980] = 197,
  [3981] = 238,
  [3982] = 209,
  [3983] = 892,
  [3984] = 887,
  [3985] = 398,
  [3986] = 884,
  [3987] = 214,
  [3988] = 879,
  [3989] = 211,
  [3990] = 208,
  [3991] = 157,
  [3992] = 268,
  [3993] = 267,
  [3994] = 776,
  [3995] = 203,
  [3996] = 202,
  [3997] = 200,
  [3998] = 199,
  [3999] = 195,
  [4000] = 193,
  [4001] = 915,
  [4002] = 190,
  [4003] = 185,
  [4004] = 250,
  [4005] = 271,
  [4006] = 875,
  [4007] = 857,
  [4008] = 401,
  [4009] = 400,
  [4010] = 399,
  [4011] = 2424,
  [4012] = 222,
  [4013] = 296,
  [4014] = 837,
  [4015] = 915,
  [4016] = 432,
  [4017] = 274,
  [4018] = 260,
  [4019] = 223,
  [4020] = 224,
  [4021] = 275,
  [4022] = 296,
  [4023] = 412,
  [4024] = 266,
  [4025] = 876,
  [4026] = 403,
  [4027] = 204,
  [4028] = 279,
  [4029] = 212,
  [4030] = 397,
  [4031] = 277,
  [4032] = 278,
  [4033] = 866,
  [4034] = 815,
  [4035] = 868,
  [4036] = 250,
  [4037] = 280,
  [4038] = 282,
  [4039] = 181,
  [4040] = 183,
  [4041] = 908,
  [4042] = 149,
  [4043] = 398,
  [4044] = 900,
  [4045] = 191,
  [4046] = 194,
  [4047] = 395,
  [4048] = 901,
  [4049] = 396,
  [4050] = 226,
  [4051] = 252,
  [4052] = 828,
  [4053] = 236,
  [4054] = 255,
  [4055] = 283,
  [4056] = 591,
  [4057] = 147,
  [4058] = 396,
  [4059] = 180,
  [4060] = 217,
  [4061] = 218,
  [4062] = 219,
  [4063] = 215,
  [4064] = 265,
  [4065] = 235,
  [4066] = 901,
  [4067] = 207,
  [4068] = 206,
  [4069] = 413,
  [4070] = 399,
  [4071] = 886,
  [4072] = 310,
  [4073] = 264,
  [4074] = 263,
  [4075] = 88,
  [4076] = 914,
  [4077] = 834,
  [4078] = 851,
  [4079] = 287,
  [4080] = 911,
  [4081] = 286,
  [4082] = 400,
  [4083] = 910,
  [4084] = 296,
  [4085] = 401,
  [4086] = 892,
  [4087] = 887,
  [4088] = 803,
  [4089] = 914,
  [4090] = 198,
  [4091] = 196,
  [4092] = 222,
  [4093] = 302,
  [4094] = 297,
  [4095] = 281,
  [4096] = 279,
  [4097] = 263,
  [4098] = 413,
  [4099] = 264,
  [4100] = 301,
  [4101] = 299,
  [4102] = 260,
  [4103] = 902,
  [4104] = 875,
  [4105] = 2560,
  [4106] = 837,
  [4107] = 412,
  [4108] = 228,
  [4109] = 902,
  [4110] = 432,
  [4111] = 239,
  [4112] = 908,
  [4113] = 266,
  [4114] = 402,
  [4115] = 267,
  [4116] = 272,
  [4117] = 868,
  [4118] = 407,
  [4119] = 409,
  [4120] = 2468,
  [4121] = 225,
  [4122] = 268,
  [4123] = 2472,
  [4124] = 269,
  [4125] = 310,
  [4126] = 296,
  [4127] = 302,
  [4128] = 297,
  [4129] = 270,
  [4130] = 396,
  [4131] = 286,
  [4132] = 287,
  [4133] = 866,
  [4134] = 255,
  [4135] = 883,
  [4136] = 403,
  [4137] = 397,
  [4138] = 301,
  [4139] = 299,
  [4140] = 717,
  [4141] = 403,
  [4142] = 412,
  [4143] = 776,
  [4144] = 717,
  [4145] = 309,
  [4146] = 304,
  [4147] = 571,
  [4148] = 259,
  [4149] = 305,
  [4150] = 406,
  [4151] = 230,
  [4152] = 306,
  [4153] = 281,
  [4154] = 845,
  [4155] = 303,
  [4156] = 307,
  [4157] = 283,
  [4158] = 258,
  [4159] = 270,
  [4160] = 229,
  [4161] = 269,
  [4162] = 237,
  [4163] = 309,
  [4164] = 272,
  [4165] = 268,
  [4166] = 304,
  [4167] = 303,
  [4168] = 412,
  [4169] = 259,
  [4170] = 258,
  [4171] = 403,
  [4172] = 254,
  [4173] = 221,
  [4174] = 305,
  [4175] = 253,
  [4176] = 267,
  [4177] = 266,
  [4178] = 251,
  [4179] = 234,
  [4180] = 397,
  [4181] = 264,
  [4182] = 263,
  [4183] = 242,
  [4184] = 245,
  [4185] = 306,
  [4186] = 902,
  [4187] = 238,
  [4188] = 908,
  [4189] = 223,
  [4190] = 158,
  [4191] = 157,
  [4192] = 181,
  [4193] = 224,
  [4194] = 868,
  [4195] = 866,
  [4196] = 441,
  [4197] = 2448,
  [4198] = 181,
  [4199] = 2447,
  [4200] = 302,
  [4201] = 717,
  [4202] = 297,
  [4203] = 289,
  [4204] = 302,
  [4205] = 297,
  [4206] = 301,
  [4207] = 254,
  [4208] = 301,
  [4209] = 282,
  [4210] = 280,
  [4211] = 299,
  [4212] = 398,
  [4213] = 221,
  [4214] = 299,
  [4215] = 241,
  [4216] = 399,
  [4217] = 400,
  [4218] = 235,
  [4219] = 401,
  [4220] = 226,
  [4221] = 845,
  [4222] = 290,
  [4223] = 253,
  [4224] = 406,
  [4225] = 408,
  [4226] = 251,
  [4227] = 408,
  [4228] = 230,
  [4229] = 291,
  [4230] = 231,
  [4231] = 232,
  [4232] = 240,
  [4233] = 249,
  [4234] = 413,
  [4235] = 220,
  [4236] = 256,
  [4237] = 246,
  [4238] = 298,
  [4239] = 261,
  [4240] = 262,
  [4241] = 273,
  [4242] = 234,
  [4243] = 276,
  [4244] = 397,
  [4245] = 257,
  [4246] = 227,
  [4247] = 2568,
  [4248] = 248,
  [4249] = 298,
  [4250] = 242,
  [4251] = 404,
  [4252] = 413,
  [4253] = 245,
  [4254] = 405,
  [4255] = 307,
  [4256] = 776,
  [4257] = 394,
  [4258] = 298,
  [4259] = 410,
  [4260] = 283,
  [4261] = 411,
  [4262] = 248,
  [4263] = 246,
  [4264] = 411,
  [4265] = 241,
  [4266] = 238,
  [4267] = 307,
  [4268] = 237,
  [4269] = 410,
  [4270] = 394,
  [4271] = 229,
  [4272] = 2545,
  [4273] = 405,
  [4274] = 828,
  [4275] = 225,
  [4276] = 409,
  [4277] = 407,
  [4278] = 402,
  [4279] = 239,
  [4280] = 228,
  [4281] = 649,
  [4282] = 147,
  [4283] = 149,
  [4284] = 432,
  [4285] = 265,
  [4286] = 815,
  [4287] = 395,
  [4288] = 255,
  [4289] = 278,
  [4290] = 309,
  [4291] = 304,
  [4292] = 404,
  [4293] = 277,
  [4294] = 275,
  [4295] = 85,
  [4296] = 274,
  [4297] = 886,
  [4298] = 271,
  [4299] = 305,
  [4300] = 231,
  [4301] = 776,
  [4302] = 252,
  [4303] = 233,
  [4304] = 310,
  [4305] = 232,
  [4306] = 236,
  [4307] = 296,
  [4308] = 240,
  [4309] = 839,
  [4310] = 252,
  [4311] = 249,
  [4312] = 226,
  [4313] = 884,
  [4314] = 224,
  [4315] = 879,
  [4316] = 223,
  [4317] = 876,
  [4318] = 220,
  [4319] = 261,
  [4320] = 262,
  [4321] = 260,
  [4322] = 302,
  [4323] = 845,
  [4324] = 306,
  [4325] = 297,
  [4326] = 86,
  [4327] = 900,
  [4328] = 222,
  [4329] = 301,
  [4330] = 299,
  [4331] = 273,
  [4332] = 147,
  [4333] = 149,
  [4334] = 276,
  [4335] = 257,
  [4336] = 803,
  [4337] = 271,
  [4338] = 851,
  [4339] = 828,
  [4340] = 886,
  [4341] = 236,
  [4342] = 910,
  [4343] = 834,
  [4344] = 288,
  [4345] = 851,
  [4346] = 911,
  [4347] = 826,
  [4348] = 309,
  [4349] = 803,
  [4350] = 304,
  [4351] = 303,
  [4352] = 305,
  [4353] = 306,
  [4354] = 306,
  [4355] = 305,
  [4356] = 834,
  [4357] = 227,
  [4358] = 304,
  [4359] = 309,
  [4360] = 868,
  [4361] = 828,
  [4362] = 318,
  [4363] = 310,
  [4364] = 296,
  [4365] = 875,
  [4366] = 432,
  [4367] = 87,
  [4368] = 302,
  [4369] = 297,
  [4370] = 301,
  [4371] = 299,
  [4372] = 127,
  [4373] = 312,
  [4374] = 892,
  [4375] = 910,
  [4376] = 911,
  [4377] = 309,
  [4378] = 441,
  [4379] = 914,
  [4380] = 304,
  [4381] = 87,
  [4382] = 303,
  [4383] = 305,
  [4384] = 306,
  [4385] = 852,
  [4386] = 289,
  [4387] = 803,
  [4388] = 408,
  [4389] = 717,
  [4390] = 158,
  [4391] = 157,
  [4392] = 851,
  [4393] = 4393,
  [4394] = 306,
  [4395] = 834,
  [4396] = 305,
  [4397] = 828,
  [4398] = 303,
  [4399] = 304,
  [4400] = 309,
  [4401] = 299,
  [4402] = 876,
  [4403] = 915,
  [4404] = 181,
  [4405] = 839,
  [4406] = 879,
  [4407] = 307,
  [4408] = 297,
  [4409] = 884,
  [4410] = 879,
  [4411] = 876,
  [4412] = 884,
  [4413] = 302,
  [4414] = 887,
  [4415] = 290,
  [4416] = 296,
  [4417] = 310,
  [4418] = 291,
  [4419] = 866,
  [4420] = 432,
  [4421] = 886,
  [4422] = 834,
  [4423] = 851,
  [4424] = 803,
  [4425] = 886,
  [4426] = 289,
  [4427] = 288,
  [4428] = 815,
  [4429] = 396,
  [4430] = 844,
  [4431] = 839,
  [4432] = 287,
  [4433] = 845,
  [4434] = 846,
  [4435] = 884,
  [4436] = 875,
  [4437] = 837,
  [4438] = 826,
  [4439] = 866,
  [4440] = 868,
  [4441] = 883,
  [4442] = 908,
  [4443] = 902,
  [4444] = 879,
  [4445] = 307,
  [4446] = 855,
  [4447] = 298,
  [4448] = 876,
  [4449] = 901,
  [4450] = 828,
  [4451] = 286,
  [4452] = 915,
  [4453] = 834,
  [4454] = 851,
  [4455] = 845,
  [4456] = 327,
  [4457] = 900,
  [4458] = 395,
  [4459] = 837,
  [4460] = 875,
  [4461] = 886,
  [4462] = 291,
  [4463] = 902,
  [4464] = 839,
  [4465] = 247,
  [4466] = 324,
  [4467] = 244,
  [4468] = 402,
  [4469] = 323,
  [4470] = 243,
  [4471] = 290,
  [4472] = 837,
  [4473] = 887,
  [4474] = 892,
  [4475] = 290,
  [4476] = 311,
  [4477] = 314,
  [4478] = 315,
  [4479] = 291,
  [4480] = 316,
  [4481] = 317,
  [4482] = 908,
  [4483] = 232,
  [4484] = 147,
  [4485] = 407,
  [4486] = 149,
  [4487] = 2636,
  [4488] = 289,
  [4489] = 157,
  [4490] = 158,
  [4491] = 250,
  [4492] = 857,
  [4493] = 287,
  [4494] = 271,
  [4495] = 274,
  [4496] = 275,
  [4497] = 845,
  [4498] = 328,
  [4499] = 277,
  [4500] = 286,
  [4501] = 326,
  [4502] = 776,
  [4503] = 868,
  [4504] = 278,
  [4505] = 826,
  [4506] = 902,
  [4507] = 409,
  [4508] = 908,
  [4509] = 325,
  [4510] = 301,
  [4511] = 298,
  [4512] = 803,
  [4513] = 322,
  [4514] = 320,
  [4515] = 265,
  [4516] = 413,
  [4517] = 866,
  [4518] = 815,
  [4519] = 910,
  [4520] = 911,
  [4521] = 228,
  [4522] = 914,
  [4523] = 901,
  [4524] = 239,
  [4525] = 2766,
  [4526] = 866,
  [4527] = 868,
  [4528] = 287,
  [4529] = 286,
  [4530] = 908,
  [4531] = 902,
  [4532] = 235,
  [4533] = 222,
  [4534] = 397,
  [4535] = 330,
  [4536] = 319,
  [4537] = 260,
  [4538] = 411,
  [4539] = 223,
  [4540] = 224,
  [4541] = 403,
  [4542] = 329,
  [4543] = 826,
  [4544] = 226,
  [4545] = 252,
  [4546] = 236,
  [4547] = 255,
  [4548] = 283,
  [4549] = 837,
  [4550] = 875,
  [4551] = 883,
  [4552] = 225,
  [4553] = 229,
  [4554] = 237,
  [4555] = 238,
  [4556] = 241,
  [4557] = 246,
  [4558] = 248,
  [4559] = 901,
  [4560] = 412,
  [4561] = 410,
  [4562] = 900,
  [4563] = 915,
  [4564] = 855,
  [4565] = 883,
  [4566] = 158,
  [4567] = 233,
  [4568] = 157,
  [4569] = 887,
  [4570] = 852,
  [4571] = 892,
  [4572] = 2545,
  [4573] = 263,
  [4574] = 2568,
  [4575] = 264,
  [4576] = 266,
  [4577] = 267,
  [4578] = 321,
  [4579] = 394,
  [4580] = 268,
  [4581] = 269,
  [4582] = 2447,
  [4583] = 2448,
  [4584] = 398,
  [4585] = 405,
  [4586] = 844,
  [4587] = 846,
  [4588] = 270,
  [4589] = 910,
  [4590] = 911,
  [4591] = 857,
  [4592] = 227,
  [4593] = 399,
  [4594] = 815,
  [4595] = 400,
  [4596] = 914,
  [4597] = 288,
  [4598] = 257,
  [4599] = 88,
  [4600] = 900,
  [4601] = 911,
  [4602] = 910,
  [4603] = 2472,
  [4604] = 2468,
  [4605] = 288,
  [4606] = 915,
  [4607] = 276,
  [4608] = 273,
  [4609] = 839,
  [4610] = 432,
  [4611] = 262,
  [4612] = 261,
  [4613] = 432,
  [4614] = 256,
  [4615] = 883,
  [4616] = 220,
  [4617] = 249,
  [4618] = 826,
  [4619] = 240,
  [4620] = 914,
  [4621] = 901,
  [4622] = 281,
  [4623] = 892,
  [4624] = 4393,
  [4625] = 279,
  [4626] = 404,
  [4627] = 884,
  [4628] = 879,
  [4629] = 845,
  [4630] = 272,
  [4631] = 401,
  [4632] = 259,
  [4633] = 876,
  [4634] = 2424,
  [4635] = 258,
  [4636] = 254,
  [4637] = 221,
  [4638] = 253,
  [4639] = 251,
  [4640] = 234,
  [4641] = 242,
  [4642] = 828,
  [4643] = 886,
  [4644] = 245,
  [4645] = 834,
  [4646] = 887,
  [4647] = 282,
  [4648] = 280,
  [4649] = 900,
  [4650] = 855,
  [4651] = 852,
  [4652] = 851,
  [4653] = 803,
  [4654] = 844,
  [4655] = 846,
  [4656] = 406,
  [4657] = 857,
  [4658] = 815,
  [4659] = 230,
  [4660] = 231,
  [4661] = 149,
  [4662] = 884,
  [4663] = 781,
  [4664] = 291,
  [4665] = 714,
  [4666] = 290,
  [4667] = 901,
  [4668] = 2766,
  [4669] = 289,
  [4670] = 4670,
  [4671] = 900,
  [4672] = 287,
  [4673] = 286,
  [4674] = 828,
  [4675] = 288,
  [4676] = 571,
  [4677] = 158,
  [4678] = 148,
  [4679] = 148,
  [4680] = 157,
  [4681] = 147,
  [4682] = 914,
  [4683] = 759,
  [4684] = 523,
  [4685] = 857,
  [4686] = 846,
  [4687] = 87,
  [4688] = 149,
  [4689] = 147,
  [4690] = 307,
  [4691] = 844,
  [4692] = 852,
  [4693] = 876,
  [4694] = 855,
  [4695] = 298,
  [4696] = 732,
  [4697] = 879,
  [4698] = 911,
  [4699] = 886,
  [4700] = 910,
  [4701] = 892,
  [4702] = 887,
  [4703] = 432,
  [4704] = 775,
  [4705] = 815,
  [4706] = 839,
  [4707] = 837,
  [4708] = 649,
  [4709] = 296,
  [4710] = 310,
  [4711] = 306,
  [4712] = 305,
  [4713] = 303,
  [4714] = 304,
  [4715] = 309,
  [4716] = 845,
  [4717] = 792,
  [4718] = 866,
  [4719] = 868,
  [4720] = 826,
  [4721] = 4393,
  [4722] = 908,
  [4723] = 902,
  [4724] = 915,
  [4725] = 875,
  [4726] = 883,
  [4727] = 834,
  [4728] = 302,
  [4729] = 299,
  [4730] = 803,
  [4731] = 301,
  [4732] = 297,
  [4733] = 851,
  [4734] = 157,
  [4735] = 158,
  [4736] = 413,
  [4737] = 397,
  [4738] = 410,
  [4739] = 396,
  [4740] = 403,
  [4741] = 412,
  [4742] = 398,
  [4743] = 2636,
  [4744] = 160,
  [4745] = 148,
  [4746] = 400,
  [4747] = 414,
  [4748] = 159,
  [4749] = 438,
  [4750] = 717,
  [4751] = 401,
  [4752] = 165,
  [4753] = 438,
  [4754] = 406,
  [4755] = 166,
  [4756] = 408,
  [4757] = 160,
  [4758] = 404,
  [4759] = 414,
  [4760] = 161,
  [4761] = 405,
  [4762] = 394,
  [4763] = 411,
  [4764] = 162,
  [4765] = 159,
  [4766] = 153,
  [4767] = 152,
  [4768] = 164,
  [4769] = 155,
  [4770] = 155,
  [4771] = 164,
  [4772] = 148,
  [4773] = 161,
  [4774] = 409,
  [4775] = 407,
  [4776] = 402,
  [4777] = 153,
  [4778] = 147,
  [4779] = 149,
  [4780] = 147,
  [4781] = 149,
  [4782] = 157,
  [4783] = 158,
  [4784] = 441,
  [4785] = 395,
  [4786] = 165,
  [4787] = 167,
  [4788] = 166,
  [4789] = 167,
  [4790] = 151,
  [4791] = 150,
  [4792] = 399,
  [4793] = 162,
  [4794] = 152,
  [4795] = 163,
  [4796] = 150,
  [4797] = 163,
  [4798] = 151,
  [4799] = 851,
  [4800] = 162,
  [4801] = 438,
  [4802] = 414,
  [4803] = 414,
  [4804] = 2636,
  [4805] = 177,
  [4806] = 176,
  [4807] = 837,
  [4808] = 312,
  [4809] = 178,
  [4810] = 179,
  [4811] = 172,
  [4812] = 169,
  [4813] = 875,
  [4814] = 887,
  [4815] = 892,
  [4816] = 171,
  [4817] = 168,
  [4818] = 910,
  [4819] = 911,
  [4820] = 170,
  [4821] = 914,
  [4822] = 901,
  [4823] = 2636,
  [4824] = 902,
  [4825] = 321,
  [4826] = 908,
  [4827] = 329,
  [4828] = 319,
  [4829] = 868,
  [4830] = 330,
  [4831] = 175,
  [4832] = 876,
  [4833] = 866,
  [4834] = 173,
  [4835] = 157,
  [4836] = 158,
  [4837] = 157,
  [4838] = 158,
  [4839] = 4839,
  [4840] = 900,
  [4841] = 320,
  [4842] = 173,
  [4843] = 175,
  [4844] = 414,
  [4845] = 322,
  [4846] = 438,
  [4847] = 325,
  [4848] = 326,
  [4849] = 815,
  [4850] = 4850,
  [4851] = 915,
  [4852] = 328,
  [4853] = 4853,
  [4854] = 883,
  [4855] = 826,
  [4856] = 160,
  [4857] = 159,
  [4858] = 153,
  [4859] = 152,
  [4860] = 164,
  [4861] = 155,
  [4862] = 161,
  [4863] = 855,
  [4864] = 177,
  [4865] = 165,
  [4866] = 166,
  [4867] = 127,
  [4868] = 167,
  [4869] = 151,
  [4870] = 150,
  [4871] = 163,
  [4872] = 162,
  [4873] = 438,
  [4874] = 845,
  [4875] = 317,
  [4876] = 316,
  [4877] = 315,
  [4878] = 314,
  [4879] = 846,
  [4880] = 311,
  [4881] = 857,
  [4882] = 318,
  [4883] = 160,
  [4884] = 441,
  [4885] = 803,
  [4886] = 159,
  [4887] = 170,
  [4888] = 176,
  [4889] = 178,
  [4890] = 179,
  [4891] = 172,
  [4892] = 169,
  [4893] = 834,
  [4894] = 153,
  [4895] = 152,
  [4896] = 164,
  [4897] = 155,
  [4898] = 327,
  [4899] = 886,
  [4900] = 161,
  [4901] = 165,
  [4902] = 324,
  [4903] = 323,
  [4904] = 163,
  [4905] = 839,
  [4906] = 171,
  [4907] = 168,
  [4908] = 884,
  [4909] = 150,
  [4910] = 151,
  [4911] = 879,
  [4912] = 167,
  [4913] = 166,
  [4914] = 4914,
  [4915] = 88,
  [4916] = 828,
  [4917] = 432,
  [4918] = 4918,
  [4919] = 219,
  [4920] = 4918,
  [4921] = 204,
  [4922] = 212,
  [4923] = 183,
  [4924] = 4918,
  [4925] = 175,
  [4926] = 173,
  [4927] = 4927,
  [4928] = 4918,
  [4929] = 4927,
  [4930] = 210,
  [4931] = 4927,
  [4932] = 4918,
  [4933] = 182,
  [4934] = 184,
  [4935] = 188,
  [4936] = 190,
  [4937] = 187,
  [4938] = 177,
  [4939] = 189,
  [4940] = 4850,
  [4941] = 591,
  [4942] = 4839,
  [4943] = 4918,
  [4944] = 176,
  [4945] = 4927,
  [4946] = 178,
  [4947] = 179,
  [4948] = 172,
  [4949] = 169,
  [4950] = 213,
  [4951] = 4853,
  [4952] = 201,
  [4953] = 4927,
  [4954] = 4918,
  [4955] = 186,
  [4956] = 197,
  [4957] = 209,
  [4958] = 4927,
  [4959] = 214,
  [4960] = 4918,
  [4961] = 171,
  [4962] = 168,
  [4963] = 170,
  [4964] = 523,
  [4965] = 175,
  [4966] = 173,
  [4967] = 311,
  [4968] = 211,
  [4969] = 208,
  [4970] = 203,
  [4971] = 202,
  [4972] = 200,
  [4973] = 199,
  [4974] = 195,
  [4975] = 193,
  [4976] = 185,
  [4977] = 4927,
  [4978] = 191,
  [4979] = 4927,
  [4980] = 194,
  [4981] = 4918,
  [4982] = 180,
  [4983] = 177,
  [4984] = 571,
  [4985] = 219,
  [4986] = 191,
  [4987] = 178,
  [4988] = 4918,
  [4989] = 179,
  [4990] = 4927,
  [4991] = 172,
  [4992] = 169,
  [4993] = 176,
  [4994] = 85,
  [4995] = 217,
  [4996] = 215,
  [4997] = 171,
  [4998] = 168,
  [4999] = 86,
  [5000] = 170,
  [5001] = 318,
  [5002] = 217,
  [5003] = 218,
  [5004] = 4927,
  [5005] = 205,
  [5006] = 215,
  [5007] = 218,
  [5008] = 2636,
  [5009] = 4927,
  [5010] = 207,
  [5011] = 4918,
  [5012] = 4918,
  [5013] = 127,
  [5014] = 4927,
  [5015] = 196,
  [5016] = 4918,
  [5017] = 206,
  [5018] = 88,
  [5019] = 198,
  [5020] = 198,
  [5021] = 194,
  [5022] = 196,
  [5023] = 4927,
  [5024] = 4918,
  [5025] = 192,
  [5026] = 649,
  [5027] = 321,
  [5028] = 329,
  [5029] = 4927,
  [5030] = 4927,
  [5031] = 147,
  [5032] = 319,
  [5033] = 149,
  [5034] = 148,
  [5035] = 180,
  [5036] = 84,
  [5037] = 4918,
  [5038] = 183,
  [5039] = 330,
  [5040] = 212,
  [5041] = 206,
  [5042] = 4918,
  [5043] = 204,
  [5044] = 4927,
  [5045] = 314,
  [5046] = 4918,
  [5047] = 4914,
  [5048] = 649,
  [5049] = 205,
  [5050] = 210,
  [5051] = 182,
  [5052] = 184,
  [5053] = 188,
  [5054] = 207,
  [5055] = 320,
  [5056] = 322,
  [5057] = 325,
  [5058] = 4927,
  [5059] = 326,
  [5060] = 328,
  [5061] = 312,
  [5062] = 315,
  [5063] = 187,
  [5064] = 189,
  [5065] = 192,
  [5066] = 591,
  [5067] = 213,
  [5068] = 201,
  [5069] = 147,
  [5070] = 149,
  [5071] = 186,
  [5072] = 197,
  [5073] = 209,
  [5074] = 214,
  [5075] = 211,
  [5076] = 148,
  [5077] = 208,
  [5078] = 203,
  [5079] = 202,
  [5080] = 200,
  [5081] = 199,
  [5082] = 195,
  [5083] = 193,
  [5084] = 316,
  [5085] = 190,
  [5086] = 185,
  [5087] = 4918,
  [5088] = 317,
  [5089] = 4927,
  [5090] = 327,
  [5091] = 324,
  [5092] = 323,
  [5093] = 207,
  [5094] = 218,
  [5095] = 5095,
  [5096] = 5096,
  [5097] = 5095,
  [5098] = 5098,
  [5099] = 5096,
  [5100] = 5100,
  [5101] = 396,
  [5102] = 5102,
  [5103] = 717,
  [5104] = 5102,
  [5105] = 5102,
  [5106] = 438,
  [5107] = 5096,
  [5108] = 5095,
  [5109] = 591,
  [5110] = 5096,
  [5111] = 5102,
  [5112] = 5100,
  [5113] = 5098,
  [5114] = 5114,
  [5115] = 5115,
  [5116] = 5095,
  [5117] = 5117,
  [5118] = 5118,
  [5119] = 5119,
  [5120] = 162,
  [5121] = 163,
  [5122] = 150,
  [5123] = 151,
  [5124] = 167,
  [5125] = 243,
  [5126] = 244,
  [5127] = 5102,
  [5128] = 523,
  [5129] = 247,
  [5130] = 5096,
  [5131] = 166,
  [5132] = 165,
  [5133] = 222,
  [5134] = 247,
  [5135] = 244,
  [5136] = 260,
  [5137] = 223,
  [5138] = 224,
  [5139] = 243,
  [5140] = 226,
  [5141] = 5095,
  [5142] = 5102,
  [5143] = 252,
  [5144] = 5095,
  [5145] = 236,
  [5146] = 5096,
  [5147] = 255,
  [5148] = 5096,
  [5149] = 283,
  [5150] = 5095,
  [5151] = 5151,
  [5152] = 181,
  [5153] = 250,
  [5154] = 5114,
  [5155] = 161,
  [5156] = 5102,
  [5157] = 5096,
  [5158] = 5095,
  [5159] = 155,
  [5160] = 263,
  [5161] = 264,
  [5162] = 5115,
  [5163] = 266,
  [5164] = 5102,
  [5165] = 267,
  [5166] = 268,
  [5167] = 269,
  [5168] = 270,
  [5169] = 776,
  [5170] = 222,
  [5171] = 5102,
  [5172] = 260,
  [5173] = 223,
  [5174] = 224,
  [5175] = 226,
  [5176] = 281,
  [5177] = 279,
  [5178] = 272,
  [5179] = 259,
  [5180] = 258,
  [5181] = 254,
  [5182] = 221,
  [5183] = 253,
  [5184] = 251,
  [5185] = 234,
  [5186] = 242,
  [5187] = 245,
  [5188] = 5117,
  [5189] = 164,
  [5190] = 152,
  [5191] = 153,
  [5192] = 159,
  [5193] = 252,
  [5194] = 282,
  [5195] = 5096,
  [5196] = 280,
  [5197] = 5197,
  [5198] = 236,
  [5199] = 5199,
  [5200] = 5095,
  [5201] = 255,
  [5202] = 283,
  [5203] = 414,
  [5204] = 253,
  [5205] = 230,
  [5206] = 231,
  [5207] = 232,
  [5208] = 5095,
  [5209] = 263,
  [5210] = 5118,
  [5211] = 240,
  [5212] = 249,
  [5213] = 264,
  [5214] = 220,
  [5215] = 411,
  [5216] = 5216,
  [5217] = 256,
  [5218] = 261,
  [5219] = 262,
  [5220] = 266,
  [5221] = 273,
  [5222] = 267,
  [5223] = 276,
  [5224] = 5095,
  [5225] = 257,
  [5226] = 5096,
  [5227] = 227,
  [5228] = 268,
  [5229] = 233,
  [5230] = 5230,
  [5231] = 269,
  [5232] = 270,
  [5233] = 281,
  [5234] = 250,
  [5235] = 279,
  [5236] = 272,
  [5237] = 259,
  [5238] = 258,
  [5239] = 254,
  [5240] = 221,
  [5241] = 5241,
  [5242] = 251,
  [5243] = 5243,
  [5244] = 234,
  [5245] = 717,
  [5246] = 242,
  [5247] = 248,
  [5248] = 246,
  [5249] = 591,
  [5250] = 5118,
  [5251] = 245,
  [5252] = 241,
  [5253] = 238,
  [5254] = 237,
  [5255] = 229,
  [5256] = 225,
  [5257] = 282,
  [5258] = 280,
  [5259] = 5259,
  [5260] = 239,
  [5261] = 228,
  [5262] = 230,
  [5263] = 235,
  [5264] = 231,
  [5265] = 232,
  [5266] = 5230,
  [5267] = 240,
  [5268] = 265,
  [5269] = 5216,
  [5270] = 249,
  [5271] = 278,
  [5272] = 277,
  [5273] = 256,
  [5274] = 275,
  [5275] = 261,
  [5276] = 274,
  [5277] = 262,
  [5278] = 273,
  [5279] = 276,
  [5280] = 257,
  [5281] = 5095,
  [5282] = 271,
  [5283] = 227,
  [5284] = 233,
  [5285] = 162,
  [5286] = 163,
  [5287] = 150,
  [5288] = 151,
  [5289] = 167,
  [5290] = 413,
  [5291] = 5096,
  [5292] = 166,
  [5293] = 165,
  [5294] = 248,
  [5295] = 246,
  [5296] = 5102,
  [5297] = 241,
  [5298] = 238,
  [5299] = 237,
  [5300] = 5102,
  [5301] = 229,
  [5302] = 5199,
  [5303] = 161,
  [5304] = 155,
  [5305] = 164,
  [5306] = 152,
  [5307] = 153,
  [5308] = 159,
  [5309] = 225,
  [5310] = 239,
  [5311] = 228,
  [5312] = 5151,
  [5313] = 235,
  [5314] = 265,
  [5315] = 278,
  [5316] = 395,
  [5317] = 277,
  [5318] = 5102,
  [5319] = 402,
  [5320] = 5102,
  [5321] = 407,
  [5322] = 409,
  [5323] = 275,
  [5324] = 5243,
  [5325] = 5230,
  [5326] = 5216,
  [5327] = 5199,
  [5328] = 274,
  [5329] = 271,
  [5330] = 571,
  [5331] = 5096,
  [5332] = 220,
  [5333] = 5096,
  [5334] = 196,
  [5335] = 198,
  [5336] = 5095,
  [5337] = 405,
  [5338] = 85,
  [5339] = 206,
  [5340] = 410,
  [5341] = 215,
  [5342] = 394,
  [5343] = 160,
  [5344] = 219,
  [5345] = 218,
  [5346] = 217,
  [5347] = 5095,
  [5348] = 180,
  [5349] = 160,
  [5350] = 4839,
  [5351] = 404,
  [5352] = 86,
  [5353] = 5095,
  [5354] = 194,
  [5355] = 191,
  [5356] = 5096,
  [5357] = 5102,
  [5358] = 5095,
  [5359] = 5359,
  [5360] = 88,
  [5361] = 185,
  [5362] = 190,
  [5363] = 193,
  [5364] = 649,
  [5365] = 5365,
  [5366] = 195,
  [5367] = 199,
  [5368] = 200,
  [5369] = 202,
  [5370] = 203,
  [5371] = 213,
  [5372] = 4850,
  [5373] = 208,
  [5374] = 211,
  [5375] = 649,
  [5376] = 214,
  [5377] = 4853,
  [5378] = 209,
  [5379] = 197,
  [5380] = 186,
  [5381] = 591,
  [5382] = 408,
  [5383] = 397,
  [5384] = 406,
  [5385] = 776,
  [5386] = 5241,
  [5387] = 192,
  [5388] = 189,
  [5389] = 401,
  [5390] = 400,
  [5391] = 187,
  [5392] = 5102,
  [5393] = 399,
  [5394] = 5102,
  [5395] = 5096,
  [5396] = 398,
  [5397] = 5095,
  [5398] = 84,
  [5399] = 5359,
  [5400] = 201,
  [5401] = 188,
  [5402] = 5151,
  [5403] = 184,
  [5404] = 5100,
  [5405] = 183,
  [5406] = 403,
  [5407] = 158,
  [5408] = 157,
  [5409] = 182,
  [5410] = 5098,
  [5411] = 210,
  [5412] = 205,
  [5413] = 412,
  [5414] = 5414,
  [5415] = 204,
  [5416] = 212,
  [5417] = 212,
  [5418] = 183,
  [5419] = 189,
  [5420] = 196,
  [5421] = 204,
  [5422] = 198,
  [5423] = 649,
  [5424] = 5095,
  [5425] = 5095,
  [5426] = 206,
  [5427] = 649,
  [5428] = 207,
  [5429] = 157,
  [5430] = 158,
  [5431] = 5096,
  [5432] = 215,
  [5433] = 219,
  [5434] = 217,
  [5435] = 180,
  [5436] = 5102,
  [5437] = 441,
  [5438] = 4914,
  [5439] = 5365,
  [5440] = 5096,
  [5441] = 5095,
  [5442] = 205,
  [5443] = 194,
  [5444] = 191,
  [5445] = 190,
  [5446] = 5117,
  [5447] = 193,
  [5448] = 210,
  [5449] = 195,
  [5450] = 5115,
  [5451] = 199,
  [5452] = 5243,
  [5453] = 5114,
  [5454] = 182,
  [5455] = 5241,
  [5456] = 200,
  [5457] = 184,
  [5458] = 202,
  [5459] = 188,
  [5460] = 203,
  [5461] = 208,
  [5462] = 211,
  [5463] = 414,
  [5464] = 214,
  [5465] = 209,
  [5466] = 197,
  [5467] = 186,
  [5468] = 201,
  [5469] = 213,
  [5470] = 192,
  [5471] = 438,
  [5472] = 187,
  [5473] = 185,
  [5474] = 5096,
  [5475] = 5102,
  [5476] = 5476,
  [5477] = 5476,
  [5478] = 170,
  [5479] = 397,
  [5480] = 413,
  [5481] = 412,
  [5482] = 866,
  [5483] = 282,
  [5484] = 245,
  [5485] = 242,
  [5486] = 173,
  [5487] = 403,
  [5488] = 5476,
  [5489] = 5476,
  [5490] = 234,
  [5491] = 396,
  [5492] = 251,
  [5493] = 5476,
  [5494] = 127,
  [5495] = 398,
  [5496] = 253,
  [5497] = 221,
  [5498] = 254,
  [5499] = 5476,
  [5500] = 399,
  [5501] = 400,
  [5502] = 401,
  [5503] = 776,
  [5504] = 406,
  [5505] = 175,
  [5506] = 408,
  [5507] = 258,
  [5508] = 259,
  [5509] = 868,
  [5510] = 325,
  [5511] = 272,
  [5512] = 404,
  [5513] = 405,
  [5514] = 279,
  [5515] = 394,
  [5516] = 281,
  [5517] = 717,
  [5518] = 270,
  [5519] = 269,
  [5520] = 410,
  [5521] = 411,
  [5522] = 268,
  [5523] = 312,
  [5524] = 267,
  [5525] = 266,
  [5526] = 409,
  [5527] = 803,
  [5528] = 280,
  [5529] = 407,
  [5530] = 402,
  [5531] = 395,
  [5532] = 5532,
  [5533] = 851,
  [5534] = 286,
  [5535] = 287,
  [5536] = 5476,
  [5537] = 264,
  [5538] = 834,
  [5539] = 263,
  [5540] = 231,
  [5541] = 5476,
  [5542] = 826,
  [5543] = 238,
  [5544] = 776,
  [5545] = 289,
  [5546] = 318,
  [5547] = 327,
  [5548] = 857,
  [5549] = 846,
  [5550] = 283,
  [5551] = 232,
  [5552] = 844,
  [5553] = 255,
  [5554] = 324,
  [5555] = 852,
  [5556] = 236,
  [5557] = 240,
  [5558] = 252,
  [5559] = 249,
  [5560] = 226,
  [5561] = 220,
  [5562] = 224,
  [5563] = 717,
  [5564] = 323,
  [5565] = 223,
  [5566] = 290,
  [5567] = 260,
  [5568] = 883,
  [5569] = 256,
  [5570] = 222,
  [5571] = 5476,
  [5572] = 261,
  [5573] = 168,
  [5574] = 291,
  [5575] = 171,
  [5576] = 5476,
  [5577] = 908,
  [5578] = 262,
  [5579] = 286,
  [5580] = 273,
  [5581] = 276,
  [5582] = 257,
  [5583] = 287,
  [5584] = 5476,
  [5585] = 855,
  [5586] = 311,
  [5587] = 250,
  [5588] = 227,
  [5589] = 314,
  [5590] = 315,
  [5591] = 316,
  [5592] = 5476,
  [5593] = 317,
  [5594] = 714,
  [5595] = 233,
  [5596] = 248,
  [5597] = 288,
  [5598] = 901,
  [5599] = 220,
  [5600] = 246,
  [5601] = 911,
  [5602] = 845,
  [5603] = 5476,
  [5604] = 910,
  [5605] = 328,
  [5606] = 326,
  [5607] = 886,
  [5608] = 322,
  [5609] = 241,
  [5610] = 792,
  [5611] = 237,
  [5612] = 176,
  [5613] = 229,
  [5614] = 178,
  [5615] = 225,
  [5616] = 320,
  [5617] = 239,
  [5618] = 289,
  [5619] = 902,
  [5620] = 243,
  [5621] = 244,
  [5622] = 247,
  [5623] = 228,
  [5624] = 235,
  [5625] = 179,
  [5626] = 172,
  [5627] = 717,
  [5628] = 290,
  [5629] = 271,
  [5630] = 274,
  [5631] = 275,
  [5632] = 5632,
  [5633] = 277,
  [5634] = 278,
  [5635] = 265,
  [5636] = 291,
  [5637] = 169,
  [5638] = 235,
  [5639] = 265,
  [5640] = 5640,
  [5641] = 278,
  [5642] = 915,
  [5643] = 228,
  [5644] = 239,
  [5645] = 225,
  [5646] = 229,
  [5647] = 237,
  [5648] = 238,
  [5649] = 241,
  [5650] = 828,
  [5651] = 900,
  [5652] = 914,
  [5653] = 246,
  [5654] = 248,
  [5655] = 233,
  [5656] = 169,
  [5657] = 172,
  [5658] = 227,
  [5659] = 179,
  [5660] = 257,
  [5661] = 5359,
  [5662] = 330,
  [5663] = 288,
  [5664] = 178,
  [5665] = 176,
  [5666] = 277,
  [5667] = 275,
  [5668] = 276,
  [5669] = 274,
  [5670] = 273,
  [5671] = 271,
  [5672] = 759,
  [5673] = 319,
  [5674] = 876,
  [5675] = 879,
  [5676] = 884,
  [5677] = 5476,
  [5678] = 262,
  [5679] = 261,
  [5680] = 256,
  [5681] = 432,
  [5682] = 892,
  [5683] = 249,
  [5684] = 230,
  [5685] = 240,
  [5686] = 232,
  [5687] = 231,
  [5688] = 230,
  [5689] = 280,
  [5690] = 282,
  [5691] = 5365,
  [5692] = 329,
  [5693] = 5476,
  [5694] = 815,
  [5695] = 2560,
  [5696] = 245,
  [5697] = 242,
  [5698] = 234,
  [5699] = 251,
  [5700] = 253,
  [5701] = 221,
  [5702] = 254,
  [5703] = 258,
  [5704] = 259,
  [5705] = 272,
  [5706] = 279,
  [5707] = 281,
  [5708] = 732,
  [5709] = 270,
  [5710] = 269,
  [5711] = 268,
  [5712] = 267,
  [5713] = 266,
  [5714] = 170,
  [5715] = 321,
  [5716] = 264,
  [5717] = 263,
  [5718] = 887,
  [5719] = 177,
  [5720] = 175,
  [5721] = 173,
  [5722] = 87,
  [5723] = 283,
  [5724] = 781,
  [5725] = 181,
  [5726] = 255,
  [5727] = 717,
  [5728] = 168,
  [5729] = 236,
  [5730] = 776,
  [5731] = 171,
  [5732] = 839,
  [5733] = 252,
  [5734] = 4839,
  [5735] = 226,
  [5736] = 224,
  [5737] = 223,
  [5738] = 260,
  [5739] = 2560,
  [5740] = 222,
  [5741] = 181,
  [5742] = 875,
  [5743] = 837,
  [5744] = 5476,
  [5745] = 5476,
  [5746] = 250,
  [5747] = 775,
  [5748] = 243,
  [5749] = 244,
  [5750] = 247,
  [5751] = 5476,
  [5752] = 177,
  [5753] = 4914,
  [5754] = 4853,
  [5755] = 4850,
  [5756] = 5756,
  [5757] = 5757,
  [5758] = 5758,
  [5759] = 197,
  [5760] = 209,
  [5761] = 5761,
  [5762] = 213,
  [5763] = 187,
  [5764] = 5758,
  [5765] = 5765,
  [5766] = 188,
  [5767] = 201,
  [5768] = 186,
  [5769] = 184,
  [5770] = 213,
  [5771] = 287,
  [5772] = 197,
  [5773] = 209,
  [5774] = 5765,
  [5775] = 5775,
  [5776] = 214,
  [5777] = 204,
  [5778] = 5757,
  [5779] = 210,
  [5780] = 5758,
  [5781] = 211,
  [5782] = 5782,
  [5783] = 205,
  [5784] = 208,
  [5785] = 5775,
  [5786] = 5786,
  [5787] = 189,
  [5788] = 5775,
  [5789] = 201,
  [5790] = 5761,
  [5791] = 211,
  [5792] = 204,
  [5793] = 203,
  [5794] = 886,
  [5795] = 5795,
  [5796] = 857,
  [5797] = 202,
  [5798] = 844,
  [5799] = 200,
  [5800] = 5800,
  [5801] = 199,
  [5802] = 5802,
  [5803] = 5803,
  [5804] = 852,
  [5805] = 855,
  [5806] = 195,
  [5807] = 5761,
  [5808] = 193,
  [5809] = 192,
  [5810] = 190,
  [5811] = 185,
  [5812] = 5632,
  [5813] = 5761,
  [5814] = 208,
  [5815] = 5775,
  [5816] = 5786,
  [5817] = 5756,
  [5818] = 591,
  [5819] = 5765,
  [5820] = 5782,
  [5821] = 5757,
  [5822] = 286,
  [5823] = 290,
  [5824] = 5800,
  [5825] = 5756,
  [5826] = 5757,
  [5827] = 191,
  [5828] = 194,
  [5829] = 5761,
  [5830] = 180,
  [5831] = 217,
  [5832] = 218,
  [5833] = 182,
  [5834] = 219,
  [5835] = 215,
  [5836] = 203,
  [5837] = 5782,
  [5838] = 207,
  [5839] = 206,
  [5840] = 202,
  [5841] = 846,
  [5842] = 5800,
  [5843] = 5843,
  [5844] = 198,
  [5845] = 196,
  [5846] = 5782,
  [5847] = 5782,
  [5848] = 289,
  [5849] = 5757,
  [5850] = 200,
  [5851] = 5765,
  [5852] = 198,
  [5853] = 5756,
  [5854] = 5756,
  [5855] = 5757,
  [5856] = 5803,
  [5857] = 5802,
  [5858] = 5800,
  [5859] = 199,
  [5860] = 195,
  [5861] = 193,
  [5862] = 5758,
  [5863] = 190,
  [5864] = 291,
  [5865] = 5803,
  [5866] = 5802,
  [5867] = 5800,
  [5868] = 185,
  [5869] = 5803,
  [5870] = 5786,
  [5871] = 5871,
  [5872] = 5782,
  [5873] = 212,
  [5874] = 5758,
  [5875] = 192,
  [5876] = 288,
  [5877] = 523,
  [5878] = 5756,
  [5879] = 5802,
  [5880] = 5765,
  [5881] = 5800,
  [5882] = 5757,
  [5883] = 5803,
  [5884] = 5802,
  [5885] = 5800,
  [5886] = 5803,
  [5887] = 5802,
  [5888] = 5800,
  [5889] = 5803,
  [5890] = 5802,
  [5891] = 5800,
  [5892] = 5803,
  [5893] = 5758,
  [5894] = 5758,
  [5895] = 87,
  [5896] = 5896,
  [5897] = 571,
  [5898] = 5802,
  [5899] = 5758,
  [5900] = 5765,
  [5901] = 5782,
  [5902] = 5757,
  [5903] = 5795,
  [5904] = 649,
  [5905] = 5782,
  [5906] = 5802,
  [5907] = 5800,
  [5908] = 214,
  [5909] = 5803,
  [5910] = 5802,
  [5911] = 5765,
  [5912] = 5800,
  [5913] = 5803,
  [5914] = 5871,
  [5915] = 5757,
  [5916] = 5803,
  [5917] = 5802,
  [5918] = 5800,
  [5919] = 5758,
  [5920] = 189,
  [5921] = 183,
  [5922] = 5803,
  [5923] = 5802,
  [5924] = 187,
  [5925] = 5803,
  [5926] = 5802,
  [5927] = 5800,
  [5928] = 5765,
  [5929] = 5786,
  [5930] = 5756,
  [5931] = 5758,
  [5932] = 5782,
  [5933] = 186,
  [5934] = 5765,
  [5935] = 5756,
  [5936] = 5786,
  [5937] = 5758,
  [5938] = 194,
  [5939] = 5775,
  [5940] = 5761,
  [5941] = 5803,
  [5942] = 5802,
  [5943] = 5782,
  [5944] = 591,
  [5945] = 5800,
  [5946] = 188,
  [5947] = 5775,
  [5948] = 5803,
  [5949] = 5802,
  [5950] = 5800,
  [5951] = 184,
  [5952] = 5803,
  [5953] = 182,
  [5954] = 5802,
  [5955] = 5758,
  [5956] = 5800,
  [5957] = 210,
  [5958] = 5803,
  [5959] = 5802,
  [5960] = 5960,
  [5961] = 205,
  [5962] = 5761,
  [5963] = 5757,
  [5964] = 5786,
  [5965] = 5765,
  [5966] = 286,
  [5967] = 5758,
  [5968] = 5786,
  [5969] = 287,
  [5970] = 879,
  [5971] = 5800,
  [5972] = 5756,
  [5973] = 5761,
  [5974] = 5775,
  [5975] = 5975,
  [5976] = 5803,
  [5977] = 5802,
  [5978] = 5758,
  [5979] = 839,
  [5980] = 5786,
  [5981] = 5782,
  [5982] = 884,
  [5983] = 5800,
  [5984] = 212,
  [5985] = 5757,
  [5986] = 5786,
  [5987] = 876,
  [5988] = 5765,
  [5989] = 5761,
  [5990] = 5758,
  [5991] = 828,
  [5992] = 5765,
  [5993] = 5775,
  [5994] = 5786,
  [5995] = 5756,
  [5996] = 432,
  [5997] = 5761,
  [5998] = 5775,
  [5999] = 180,
  [6000] = 834,
  [6001] = 851,
  [6002] = 803,
  [6003] = 289,
  [6004] = 217,
  [6005] = 290,
  [6006] = 5757,
  [6007] = 5782,
  [6008] = 5757,
  [6009] = 5765,
  [6010] = 218,
  [6011] = 219,
  [6012] = 6012,
  [6013] = 215,
  [6014] = 291,
  [6015] = 88,
  [6016] = 5786,
  [6017] = 5756,
  [6018] = 5758,
  [6019] = 5761,
  [6020] = 5975,
  [6021] = 5782,
  [6022] = 207,
  [6023] = 5775,
  [6024] = 5765,
  [6025] = 5765,
  [6026] = 5786,
  [6027] = 206,
  [6028] = 5765,
  [6029] = 826,
  [6030] = 5756,
  [6031] = 5758,
  [6032] = 5761,
  [6033] = 191,
  [6034] = 5775,
  [6035] = 5757,
  [6036] = 883,
  [6037] = 5775,
  [6038] = 5756,
  [6039] = 5761,
  [6040] = 5757,
  [6041] = 5775,
  [6042] = 288,
  [6043] = 5786,
  [6044] = 5757,
  [6045] = 5757,
  [6046] = 5756,
  [6047] = 5761,
  [6048] = 5775,
  [6049] = 5782,
  [6050] = 915,
  [6051] = 5765,
  [6052] = 815,
  [6053] = 5786,
  [6054] = 5757,
  [6055] = 5756,
  [6056] = 5975,
  [6057] = 5761,
  [6058] = 5782,
  [6059] = 5975,
  [6060] = 5975,
  [6061] = 5975,
  [6062] = 5775,
  [6063] = 5975,
  [6064] = 5786,
  [6065] = 5756,
  [6066] = 5761,
  [6067] = 5975,
  [6068] = 5975,
  [6069] = 5975,
  [6070] = 5782,
  [6071] = 5975,
  [6072] = 5975,
  [6073] = 5775,
  [6074] = 845,
  [6075] = 5975,
  [6076] = 5975,
  [6077] = 5786,
  [6078] = 5756,
  [6079] = 900,
  [6080] = 866,
  [6081] = 5975,
  [6082] = 868,
  [6083] = 5761,
  [6084] = 5871,
  [6085] = 908,
  [6086] = 902,
  [6087] = 5795,
  [6088] = 5975,
  [6089] = 5775,
  [6090] = 901,
  [6091] = 5975,
  [6092] = 5786,
  [6093] = 5756,
  [6094] = 5761,
  [6095] = 196,
  [6096] = 837,
  [6097] = 5975,
  [6098] = 875,
  [6099] = 183,
  [6100] = 5782,
  [6101] = 5775,
  [6102] = 5758,
  [6103] = 5782,
  [6104] = 887,
  [6105] = 892,
  [6106] = 914,
  [6107] = 910,
  [6108] = 911,
  [6109] = 5786,
  [6110] = 5765,
  [6111] = 240,
  [6112] = 6112,
  [6113] = 776,
  [6114] = 6114,
  [6115] = 271,
  [6116] = 274,
  [6117] = 275,
  [6118] = 277,
  [6119] = 278,
  [6120] = 265,
  [6121] = 235,
  [6122] = 228,
  [6123] = 239,
  [6124] = 225,
  [6125] = 229,
  [6126] = 237,
  [6127] = 238,
  [6128] = 241,
  [6129] = 246,
  [6130] = 248,
  [6131] = 233,
  [6132] = 227,
  [6133] = 257,
  [6134] = 276,
  [6135] = 273,
  [6136] = 262,
  [6137] = 261,
  [6138] = 256,
  [6139] = 220,
  [6140] = 249,
  [6141] = 232,
  [6142] = 231,
  [6143] = 230,
  [6144] = 280,
  [6145] = 282,
  [6146] = 245,
  [6147] = 242,
  [6148] = 234,
  [6149] = 251,
  [6150] = 253,
  [6151] = 221,
  [6152] = 254,
  [6153] = 258,
  [6154] = 259,
  [6155] = 272,
  [6156] = 279,
  [6157] = 281,
  [6158] = 6158,
  [6159] = 270,
  [6160] = 269,
  [6161] = 268,
  [6162] = 267,
  [6163] = 266,
  [6164] = 264,
  [6165] = 263,
  [6166] = 6166,
  [6167] = 5896,
  [6168] = 6168,
  [6169] = 283,
  [6170] = 255,
  [6171] = 236,
  [6172] = 252,
  [6173] = 226,
  [6174] = 224,
  [6175] = 223,
  [6176] = 260,
  [6177] = 222,
  [6178] = 6178,
  [6179] = 5119,
  [6180] = 250,
  [6181] = 243,
  [6182] = 244,
  [6183] = 247,
  [6184] = 6112,
  [6185] = 6185,
  [6186] = 6186,
  [6187] = 6112,
  [6188] = 6185,
  [6189] = 6186,
  [6190] = 6112,
  [6191] = 6185,
  [6192] = 6166,
  [6193] = 6112,
  [6194] = 6185,
  [6195] = 6112,
  [6196] = 6185,
  [6197] = 6185,
  [6198] = 6112,
  [6199] = 6185,
  [6200] = 6112,
  [6201] = 6185,
  [6202] = 6202,
  [6203] = 6112,
  [6204] = 6185,
  [6205] = 6112,
  [6206] = 6185,
  [6207] = 6112,
  [6208] = 6112,
  [6209] = 6185,
  [6210] = 6112,
  [6211] = 6158,
  [6212] = 6185,
  [6213] = 6112,
  [6214] = 6185,
  [6215] = 6112,
  [6216] = 395,
  [6217] = 717,
  [6218] = 6185,
  [6219] = 6114,
  [6220] = 397,
  [6221] = 6185,
  [6222] = 6112,
  [6223] = 6185,
  [6224] = 233,
  [6225] = 6112,
  [6226] = 6185,
  [6227] = 402,
  [6228] = 6112,
  [6229] = 407,
  [6230] = 409,
  [6231] = 411,
  [6232] = 410,
  [6233] = 394,
  [6234] = 405,
  [6235] = 271,
  [6236] = 274,
  [6237] = 275,
  [6238] = 277,
  [6239] = 278,
  [6240] = 265,
  [6241] = 235,
  [6242] = 228,
  [6243] = 239,
  [6244] = 404,
  [6245] = 6185,
  [6246] = 225,
  [6247] = 229,
  [6248] = 237,
  [6249] = 238,
  [6250] = 241,
  [6251] = 246,
  [6252] = 248,
  [6253] = 6186,
  [6254] = 4914,
  [6255] = 6112,
  [6256] = 4853,
  [6257] = 4850,
  [6258] = 222,
  [6259] = 227,
  [6260] = 257,
  [6261] = 276,
  [6262] = 273,
  [6263] = 262,
  [6264] = 261,
  [6265] = 256,
  [6266] = 220,
  [6267] = 249,
  [6268] = 240,
  [6269] = 232,
  [6270] = 231,
  [6271] = 230,
  [6272] = 408,
  [6273] = 406,
  [6274] = 401,
  [6275] = 400,
  [6276] = 399,
  [6277] = 280,
  [6278] = 282,
  [6279] = 245,
  [6280] = 242,
  [6281] = 234,
  [6282] = 251,
  [6283] = 253,
  [6284] = 221,
  [6285] = 254,
  [6286] = 258,
  [6287] = 259,
  [6288] = 272,
  [6289] = 279,
  [6290] = 281,
  [6291] = 398,
  [6292] = 6178,
  [6293] = 4839,
  [6294] = 6186,
  [6295] = 6112,
  [6296] = 6168,
  [6297] = 270,
  [6298] = 269,
  [6299] = 268,
  [6300] = 267,
  [6301] = 266,
  [6302] = 264,
  [6303] = 263,
  [6304] = 6185,
  [6305] = 6112,
  [6306] = 6185,
  [6307] = 6185,
  [6308] = 412,
  [6309] = 283,
  [6310] = 255,
  [6311] = 236,
  [6312] = 252,
  [6313] = 226,
  [6314] = 224,
  [6315] = 223,
  [6316] = 260,
  [6317] = 6112,
  [6318] = 403,
  [6319] = 413,
  [6320] = 776,
  [6321] = 6112,
  [6322] = 6185,
  [6323] = 250,
  [6324] = 243,
  [6325] = 244,
  [6326] = 247,
  [6327] = 396,
  [6328] = 6185,
  [6329] = 6202,
  [6330] = 902,
  [6331] = 845,
  [6332] = 6332,
  [6333] = 291,
  [6334] = 857,
  [6335] = 291,
  [6336] = 287,
  [6337] = 6337,
  [6338] = 290,
  [6339] = 6339,
  [6340] = 6340,
  [6341] = 6339,
  [6342] = 4839,
  [6343] = 6337,
  [6344] = 289,
  [6345] = 4850,
  [6346] = 4853,
  [6347] = 4914,
  [6348] = 287,
  [6349] = 6158,
  [6350] = 6350,
  [6351] = 6351,
  [6352] = 6352,
  [6353] = 286,
  [6354] = 288,
  [6355] = 6355,
  [6356] = 6178,
  [6357] = 5640,
  [6358] = 5532,
  [6359] = 914,
  [6360] = 6202,
  [6361] = 6168,
  [6362] = 6362,
  [6363] = 6363,
  [6364] = 846,
  [6365] = 6355,
  [6366] = 6366,
  [6367] = 6114,
  [6368] = 288,
  [6369] = 6352,
  [6370] = 844,
  [6371] = 6166,
  [6372] = 6340,
  [6373] = 6363,
  [6374] = 6362,
  [6375] = 852,
  [6376] = 6376,
  [6377] = 6377,
  [6378] = 6362,
  [6379] = 6355,
  [6380] = 6340,
  [6381] = 6339,
  [6382] = 6337,
  [6383] = 432,
  [6384] = 839,
  [6385] = 884,
  [6386] = 879,
  [6387] = 876,
  [6388] = 6363,
  [6389] = 6352,
  [6390] = 855,
  [6391] = 886,
  [6392] = 826,
  [6393] = 883,
  [6394] = 915,
  [6395] = 834,
  [6396] = 851,
  [6397] = 815,
  [6398] = 900,
  [6399] = 901,
  [6400] = 803,
  [6401] = 6401,
  [6402] = 866,
  [6403] = 868,
  [6404] = 6404,
  [6405] = 6405,
  [6406] = 908,
  [6407] = 837,
  [6408] = 875,
  [6409] = 887,
  [6410] = 892,
  [6411] = 910,
  [6412] = 911,
  [6413] = 828,
  [6414] = 649,
  [6415] = 290,
  [6416] = 289,
  [6417] = 6404,
  [6418] = 6405,
  [6419] = 6351,
  [6420] = 6350,
  [6421] = 286,
  [6422] = 6422,
  [6423] = 6332,
  [6424] = 6401,
  [6425] = 6376,
  [6426] = 6426,
  [6427] = 6427,
  [6428] = 6428,
  [6429] = 6429,
  [6430] = 6430,
  [6431] = 6431,
  [6432] = 6432,
  [6433] = 6433,
  [6434] = 6434,
  [6435] = 6432,
  [6436] = 6436,
  [6437] = 6376,
  [6438] = 6405,
  [6439] = 6404,
  [6440] = 6436,
  [6441] = 6441,
  [6442] = 6351,
  [6443] = 6443,
  [6444] = 6444,
  [6445] = 6445,
  [6446] = 6350,
  [6447] = 6447,
  [6448] = 6445,
  [6449] = 6449,
  [6450] = 6444,
  [6451] = 6451,
  [6452] = 6449,
  [6453] = 6332,
  [6454] = 649,
  [6455] = 6401,
  [6456] = 6447,
  [6457] = 6457,
  [6458] = 6458,
  [6459] = 6451,
  [6460] = 6460,
  [6461] = 6461,
  [6462] = 6457,
  [6463] = 6433,
  [6464] = 6464,
  [6465] = 6430,
  [6466] = 6458,
  [6467] = 6460,
  [6468] = 6441,
  [6469] = 6461,
  [6470] = 6434,
  [6471] = 6443,
  [6472] = 6429,
  [6473] = 6473,
  [6474] = 6474,
  [6475] = 6475,
  [6476] = 6476,
  [6477] = 6376,
  [6478] = 6478,
  [6479] = 6479,
  [6480] = 6480,
  [6481] = 6481,
  [6482] = 6482,
  [6483] = 6473,
  [6484] = 6484,
  [6485] = 6485,
  [6486] = 441,
  [6487] = 6487,
  [6488] = 6431,
  [6489] = 6489,
  [6490] = 6490,
  [6491] = 6491,
  [6492] = 6492,
  [6493] = 6493,
  [6494] = 6494,
  [6495] = 6495,
  [6496] = 6405,
  [6497] = 6404,
  [6498] = 6351,
  [6499] = 6350,
  [6500] = 6332,
  [6501] = 6401,
  [6502] = 6502,
  [6503] = 6503,
  [6504] = 6504,
  [6505] = 6505,
  [6506] = 6506,
  [6507] = 6507,
  [6508] = 181,
  [6509] = 6509,
  [6510] = 6464,
  [6511] = 6511,
  [6512] = 6512,
  [6513] = 6513,
  [6514] = 6514,
  [6515] = 6511,
  [6516] = 85,
  [6517] = 6484,
  [6518] = 6492,
  [6519] = 6519,
  [6520] = 6520,
  [6521] = 6495,
  [6522] = 6520,
  [6523] = 6476,
  [6524] = 6514,
  [6525] = 6507,
  [6526] = 6526,
  [6527] = 6527,
  [6528] = 6528,
  [6529] = 6528,
  [6530] = 6520,
  [6531] = 6422,
  [6532] = 6485,
  [6533] = 6519,
  [6534] = 6534,
  [6535] = 86,
  [6536] = 6512,
  [6537] = 6506,
  [6538] = 6509,
  [6539] = 6474,
  [6540] = 6540,
  [6541] = 6541,
  [6542] = 6482,
  [6543] = 6543,
  [6544] = 6526,
  [6545] = 6527,
  [6546] = 6526,
  [6547] = 6478,
  [6548] = 6527,
  [6549] = 6489,
  [6550] = 6366,
  [6551] = 84,
  [6552] = 6479,
  [6553] = 6534,
  [6554] = 6480,
  [6555] = 6493,
  [6556] = 6505,
  [6557] = 6481,
  [6558] = 6426,
  [6559] = 6427,
  [6560] = 6377,
  [6561] = 6528,
  [6562] = 6490,
  [6563] = 6519,
  [6564] = 2578,
  [6565] = 6475,
  [6566] = 6494,
  [6567] = 6567,
  [6568] = 6491,
  [6569] = 6569,
  [6570] = 6502,
  [6571] = 6534,
  [6572] = 6475,
  [6573] = 438,
  [6574] = 86,
  [6575] = 6351,
  [6576] = 6332,
  [6577] = 6577,
  [6578] = 6350,
  [6579] = 6579,
  [6580] = 6540,
  [6581] = 414,
  [6582] = 84,
  [6583] = 6376,
  [6584] = 85,
  [6585] = 6401,
  [6586] = 6586,
  [6587] = 6405,
  [6588] = 6487,
  [6589] = 6404,
  [6590] = 6513,
  [6591] = 6591,
  [6592] = 438,
  [6593] = 87,
  [6594] = 6404,
  [6595] = 6595,
  [6596] = 414,
  [6597] = 6504,
  [6598] = 6503,
  [6599] = 6569,
  [6600] = 6600,
  [6601] = 6601,
  [6602] = 6602,
  [6603] = 6603,
  [6604] = 6595,
  [6605] = 6376,
  [6606] = 6606,
  [6607] = 2922,
  [6608] = 2943,
  [6609] = 6609,
  [6610] = 6586,
  [6611] = 6611,
  [6612] = 6603,
  [6613] = 6401,
  [6614] = 6332,
  [6615] = 6350,
  [6616] = 6351,
  [6617] = 6617,
  [6618] = 6405,
  [6619] = 6586,
  [6620] = 6620,
  [6621] = 6621,
  [6622] = 6622,
  [6623] = 6623,
  [6624] = 649,
  [6625] = 87,
  [6626] = 6626,
  [6627] = 6627,
  [6628] = 6628,
  [6629] = 6629,
  [6630] = 591,
  [6631] = 6626,
  [6632] = 6632,
  [6633] = 6626,
  [6634] = 6634,
  [6635] = 6635,
  [6636] = 6636,
  [6637] = 649,
  [6638] = 6586,
  [6639] = 6639,
  [6640] = 776,
  [6641] = 6641,
  [6642] = 6642,
  [6643] = 6643,
  [6644] = 6636,
  [6645] = 6645,
  [6646] = 6646,
  [6647] = 6647,
  [6648] = 6642,
  [6649] = 6649,
  [6650] = 6650,
  [6651] = 6651,
  [6652] = 6652,
  [6653] = 591,
  [6654] = 6654,
  [6655] = 6655,
  [6656] = 6656,
  [6657] = 6657,
  [6658] = 776,
  [6659] = 6643,
  [6660] = 6660,
  [6661] = 6645,
  [6662] = 6662,
  [6663] = 6663,
  [6664] = 6664,
  [6665] = 6665,
  [6666] = 6666,
  [6667] = 6649,
  [6668] = 6646,
  [6669] = 6669,
  [6670] = 6639,
  [6671] = 6671,
  [6672] = 6672,
  [6673] = 6652,
  [6674] = 6674,
  [6675] = 6675,
  [6676] = 6676,
  [6677] = 6647,
  [6678] = 6678,
  [6679] = 6679,
  [6680] = 6680,
  [6681] = 6681,
  [6682] = 6682,
  [6683] = 6651,
  [6684] = 6684,
  [6685] = 6685,
  [6686] = 6650,
  [6687] = 6687,
  [6688] = 6688,
  [6689] = 6675,
  [6690] = 6681,
  [6691] = 6691,
  [6692] = 6620,
  [6693] = 6693,
  [6694] = 6694,
  [6695] = 6695,
  [6696] = 6696,
  [6697] = 6697,
  [6698] = 6698,
  [6699] = 6699,
  [6700] = 6700,
  [6701] = 6629,
  [6702] = 6702,
  [6703] = 6703,
  [6704] = 6704,
  [6705] = 6663,
  [6706] = 6706,
  [6707] = 6707,
  [6708] = 6708,
  [6709] = 6709,
  [6710] = 6710,
  [6711] = 6711,
  [6712] = 6679,
  [6713] = 6713,
  [6714] = 6714,
  [6715] = 6715,
  [6716] = 6716,
  [6717] = 6717,
  [6718] = 6657,
  [6719] = 6665,
  [6720] = 6720,
  [6721] = 6721,
  [6722] = 6722,
  [6723] = 6627,
  [6724] = 6724,
  [6725] = 6725,
  [6726] = 6726,
  [6727] = 6727,
  [6728] = 6543,
  [6729] = 6729,
  [6730] = 6730,
  [6731] = 6731,
  [6732] = 6541,
  [6733] = 127,
  [6734] = 6734,
  [6735] = 6735,
  [6736] = 6736,
  [6737] = 6737,
  [6738] = 6738,
  [6739] = 6739,
  [6740] = 6740,
  [6741] = 6741,
  [6742] = 6632,
  [6743] = 6743,
  [6744] = 6656,
  [6745] = 6567,
  [6746] = 6722,
  [6747] = 6747,
  [6748] = 6704,
  [6749] = 6749,
  [6750] = 6703,
  [6751] = 6707,
  [6752] = 6708,
  [6753] = 6709,
  [6754] = 6586,
  [6755] = 6660,
  [6756] = 6756,
  [6757] = 6622,
  [6758] = 6685,
  [6759] = 6759,
  [6760] = 6760,
  [6761] = 6761,
  [6762] = 6762,
  [6763] = 6763,
  [6764] = 6764,
  [6765] = 6623,
  [6766] = 6766,
  [6767] = 6767,
  [6768] = 6768,
  [6769] = 6769,
  [6770] = 6770,
  [6771] = 6771,
  [6772] = 6682,
  [6773] = 6680,
  [6774] = 6634,
  [6775] = 6672,
  [6776] = 6776,
  [6777] = 6621,
  [6778] = 6740,
  [6779] = 6779,
  [6780] = 6779,
  [6781] = 6779,
  [6782] = 6779,
  [6783] = 6700,
  [6784] = 6721,
  [6785] = 6785,
  [6786] = 6786,
  [6787] = 6779,
  [6788] = 6785,
  [6789] = 6770,
  [6790] = 6790,
  [6791] = 6779,
  [6792] = 6792,
  [6793] = 6764,
  [6794] = 6794,
  [6795] = 6743,
  [6796] = 6779,
  [6797] = 6738,
  [6798] = 6749,
  [6799] = 6761,
  [6800] = 6779,
  [6801] = 6779,
  [6802] = 6767,
  [6803] = 6803,
  [6804] = 6741,
  [6805] = 6541,
  [6806] = 6806,
  [6807] = 6726,
  [6808] = 6779,
  [6809] = 6806,
  [6810] = 6766,
  [6811] = 6714,
  [6812] = 649,
  [6813] = 6747,
  [6814] = 6706,
  [6815] = 6729,
  [6816] = 6736,
  [6817] = 6779,
  [6818] = 6676,
  [6819] = 6769,
  [6820] = 6779,
  [6821] = 6821,
  [6822] = 6779,
  [6823] = 6756,
  [6824] = 6725,
  [6825] = 6737,
  [6826] = 6567,
  [6827] = 6779,
  [6828] = 6790,
  [6829] = 6762,
  [6830] = 6779,
  [6831] = 127,
  [6832] = 6776,
  [6833] = 6727,
  [6834] = 6834,
  [6835] = 6759,
  [6836] = 6771,
  [6837] = 6834,
  [6838] = 6779,
  [6839] = 6730,
  [6840] = 6739,
  [6841] = 6841,
  [6842] = 6731,
  [6843] = 6792,
  [6844] = 6844,
  [6845] = 6845,
  [6846] = 6846,
  [6847] = 6803,
  [6848] = 6848,
  [6849] = 6543,
  [6850] = 6779,
  [6851] = 6851,
  [6852] = 6852,
  [6853] = 6853,
  [6854] = 6854,
  [6855] = 6715,
  [6856] = 6779,
  [6857] = 6779,
  [6858] = 6699,
  [6859] = 6848,
  [6860] = 6779,
  [6861] = 6861,
  [6862] = 6717,
  [6863] = 6586,
  [6864] = 6768,
  [6865] = 6702,
  [6866] = 6724,
  [6867] = 6841,
  [6868] = 6821,
  [6869] = 6713,
  [6870] = 6870,
  [6871] = 6844,
  [6872] = 88,
  [6873] = 6873,
  [6874] = 6874,
  [6875] = 6875,
  [6876] = 6876,
  [6877] = 6877,
  [6878] = 6878,
  [6879] = 149,
  [6880] = 147,
  [6881] = 6881,
  [6882] = 6882,
  [6883] = 6883,
  [6884] = 6884,
  [6885] = 6885,
  [6886] = 6886,
  [6887] = 6887,
  [6888] = 6888,
  [6889] = 6881,
  [6890] = 6890,
  [6891] = 148,
  [6892] = 6892,
  [6893] = 6881,
  [6894] = 6894,
  [6895] = 6873,
  [6896] = 6896,
  [6897] = 6896,
  [6898] = 6894,
  [6899] = 6734,
  [6900] = 6886,
  [6901] = 6887,
  [6902] = 6876,
  [6903] = 6883,
  [6904] = 153,
  [6905] = 6884,
  [6906] = 152,
  [6907] = 6892,
  [6908] = 6878,
  [6909] = 6763,
  [6910] = 6711,
  [6911] = 6877,
  [6912] = 438,
  [6913] = 6890,
  [6914] = 164,
  [6915] = 155,
  [6916] = 161,
  [6917] = 160,
  [6918] = 6918,
  [6919] = 6919,
  [6920] = 6693,
  [6921] = 6921,
  [6922] = 159,
  [6923] = 6691,
  [6924] = 6710,
  [6925] = 165,
  [6926] = 6720,
  [6927] = 157,
  [6928] = 158,
  [6929] = 166,
  [6930] = 6882,
  [6931] = 6931,
  [6932] = 6716,
  [6933] = 6933,
  [6934] = 167,
  [6935] = 6694,
  [6936] = 6695,
  [6937] = 6696,
  [6938] = 151,
  [6939] = 150,
  [6940] = 6697,
  [6941] = 6698,
  [6942] = 163,
  [6943] = 6888,
  [6944] = 162,
  [6945] = 6945,
  [6946] = 414,
  [6947] = 6749,
  [6948] = 6885,
  [6949] = 6949,
  [6950] = 6945,
  [6951] = 179,
  [6952] = 6919,
  [6953] = 6953,
  [6954] = 6954,
  [6955] = 6921,
  [6956] = 6956,
  [6957] = 6760,
  [6958] = 171,
  [6959] = 168,
  [6960] = 6918,
  [6961] = 6961,
  [6962] = 6962,
  [6963] = 6963,
  [6964] = 6964,
  [6965] = 6954,
  [6966] = 6963,
  [6967] = 6964,
  [6968] = 6968,
  [6969] = 170,
  [6970] = 6963,
  [6971] = 6971,
  [6972] = 6954,
  [6973] = 6964,
  [6974] = 6962,
  [6975] = 6933,
  [6976] = 6976,
  [6977] = 6977,
  [6978] = 6977,
  [6979] = 6976,
  [6980] = 6976,
  [6981] = 6981,
  [6982] = 6982,
  [6983] = 175,
  [6984] = 173,
  [6985] = 6977,
  [6986] = 6953,
  [6987] = 6987,
  [6988] = 6988,
  [6989] = 6963,
  [6990] = 6990,
  [6991] = 177,
  [6992] = 6961,
  [6993] = 6993,
  [6994] = 178,
  [6995] = 176,
  [6996] = 169,
  [6997] = 172,
  [6998] = 6998,
  [6999] = 218,
  [7000] = 7000,
  [7001] = 184,
  [7002] = 6963,
  [7003] = 188,
  [7004] = 6987,
  [7005] = 6962,
  [7006] = 6988,
  [7007] = 6963,
  [7008] = 6953,
  [7009] = 6993,
  [7010] = 6990,
  [7011] = 6945,
  [7012] = 6933,
  [7013] = 6919,
  [7014] = 6921,
  [7015] = 6874,
  [7016] = 6918,
  [7017] = 204,
  [7018] = 7018,
  [7019] = 523,
  [7020] = 6875,
  [7021] = 7021,
  [7022] = 7022,
  [7023] = 212,
  [7024] = 7024,
  [7025] = 571,
  [7026] = 7026,
  [7027] = 7027,
  [7028] = 183,
  [7029] = 7022,
  [7030] = 7026,
  [7031] = 6982,
  [7032] = 7032,
  [7033] = 205,
  [7034] = 196,
  [7035] = 211,
  [7036] = 219,
  [7037] = 191,
  [7038] = 194,
  [7039] = 208,
  [7040] = 187,
  [7041] = 215,
  [7042] = 203,
  [7043] = 202,
  [7044] = 200,
  [7045] = 7032,
  [7046] = 199,
  [7047] = 591,
  [7048] = 195,
  [7049] = 193,
  [7050] = 189,
  [7051] = 7051,
  [7052] = 207,
  [7053] = 192,
  [7054] = 7054,
  [7055] = 206,
  [7056] = 213,
  [7057] = 190,
  [7058] = 201,
  [7059] = 182,
  [7060] = 186,
  [7061] = 185,
  [7062] = 197,
  [7063] = 7063,
  [7064] = 209,
  [7065] = 210,
  [7066] = 6956,
  [7067] = 180,
  [7068] = 217,
  [7069] = 198,
  [7070] = 214,
  [7071] = 236,
  [7072] = 229,
  [7073] = 267,
  [7074] = 266,
  [7075] = 233,
  [7076] = 273,
  [7077] = 264,
  [7078] = 263,
  [7079] = 262,
  [7080] = 776,
  [7081] = 261,
  [7082] = 256,
  [7083] = 220,
  [7084] = 249,
  [7085] = 7027,
  [7086] = 248,
  [7087] = 240,
  [7088] = 283,
  [7089] = 255,
  [7090] = 252,
  [7091] = 226,
  [7092] = 224,
  [7093] = 223,
  [7094] = 232,
  [7095] = 260,
  [7096] = 222,
  [7097] = 246,
  [7098] = 241,
  [7099] = 7063,
  [7100] = 7051,
  [7101] = 238,
  [7102] = 7102,
  [7103] = 7103,
  [7104] = 7104,
  [7105] = 257,
  [7106] = 231,
  [7107] = 230,
  [7108] = 281,
  [7109] = 7109,
  [7110] = 127,
  [7111] = 237,
  [7112] = 250,
  [7113] = 523,
  [7114] = 280,
  [7115] = 268,
  [7116] = 282,
  [7117] = 243,
  [7118] = 6918,
  [7119] = 86,
  [7120] = 438,
  [7121] = 247,
  [7122] = 276,
  [7123] = 269,
  [7124] = 7124,
  [7125] = 7125,
  [7126] = 7126,
  [7127] = 414,
  [7128] = 245,
  [7129] = 7129,
  [7130] = 225,
  [7131] = 239,
  [7132] = 228,
  [7133] = 242,
  [7134] = 6982,
  [7135] = 234,
  [7136] = 7024,
  [7137] = 251,
  [7138] = 253,
  [7139] = 571,
  [7140] = 221,
  [7141] = 85,
  [7142] = 235,
  [7143] = 6998,
  [7144] = 254,
  [7145] = 258,
  [7146] = 7000,
  [7147] = 84,
  [7148] = 259,
  [7149] = 270,
  [7150] = 265,
  [7151] = 271,
  [7152] = 272,
  [7153] = 7054,
  [7154] = 279,
  [7155] = 6945,
  [7156] = 274,
  [7157] = 6933,
  [7158] = 6919,
  [7159] = 6921,
  [7160] = 275,
  [7161] = 244,
  [7162] = 277,
  [7163] = 227,
  [7164] = 278,
  [7165] = 7165,
  [7166] = 7166,
  [7167] = 7167,
  [7168] = 7168,
  [7169] = 852,
  [7170] = 7170,
  [7171] = 7171,
  [7172] = 6982,
  [7173] = 7173,
  [7174] = 7174,
  [7175] = 7175,
  [7176] = 855,
  [7177] = 7177,
  [7178] = 7178,
  [7179] = 7179,
  [7180] = 288,
  [7181] = 7181,
  [7182] = 7182,
  [7183] = 7183,
  [7184] = 7184,
  [7185] = 7185,
  [7186] = 7186,
  [7187] = 7187,
  [7188] = 844,
  [7189] = 846,
  [7190] = 7178,
  [7191] = 7179,
  [7192] = 7175,
  [7193] = 7183,
  [7194] = 7185,
  [7195] = 127,
  [7196] = 7196,
  [7197] = 7170,
  [7198] = 7183,
  [7199] = 7166,
  [7200] = 7167,
  [7201] = 857,
  [7202] = 7173,
  [7203] = 7203,
  [7204] = 7051,
  [7205] = 7205,
  [7206] = 7125,
  [7207] = 7124,
  [7208] = 7208,
  [7209] = 7178,
  [7210] = 7027,
  [7211] = 7211,
  [7212] = 7212,
  [7213] = 7213,
  [7214] = 7000,
  [7215] = 7184,
  [7216] = 7054,
  [7217] = 7185,
  [7218] = 6998,
  [7219] = 7196,
  [7220] = 7175,
  [7221] = 7024,
  [7222] = 7063,
  [7223] = 287,
  [7224] = 7224,
  [7225] = 7225,
  [7226] = 7187,
  [7227] = 7104,
  [7228] = 7103,
  [7229] = 7229,
  [7230] = 7063,
  [7231] = 7231,
  [7232] = 291,
  [7233] = 7233,
  [7234] = 7173,
  [7235] = 7179,
  [7236] = 7167,
  [7237] = 7109,
  [7238] = 7238,
  [7239] = 7102,
  [7240] = 7126,
  [7241] = 7166,
  [7242] = 7129,
  [7243] = 7170,
  [7244] = 7196,
  [7245] = 7203,
  [7246] = 6931,
  [7247] = 87,
  [7248] = 286,
  [7249] = 290,
  [7250] = 289,
  [7251] = 855,
  [7252] = 857,
  [7253] = 846,
  [7254] = 844,
  [7255] = 852,
  [7256] = 7256,
  [7257] = 7257,
  [7258] = 7258,
  [7259] = 6749,
  [7260] = 7260,
  [7261] = 7261,
  [7262] = 649,
  [7263] = 7263,
  [7264] = 7264,
  [7265] = 7265,
  [7266] = 7258,
  [7267] = 7267,
  [7268] = 7268,
  [7269] = 7269,
  [7270] = 7270,
  [7271] = 7271,
  [7272] = 7272,
  [7273] = 7213,
  [7274] = 6949,
  [7275] = 7275,
  [7276] = 7205,
  [7277] = 7277,
  [7278] = 7278,
  [7279] = 7279,
  [7280] = 7271,
  [7281] = 7258,
  [7282] = 7263,
  [7283] = 7283,
  [7284] = 7284,
  [7285] = 7285,
  [7286] = 7286,
  [7287] = 7287,
  [7288] = 7238,
  [7289] = 7278,
  [7290] = 7271,
  [7291] = 7258,
  [7292] = 7292,
  [7293] = 7293,
  [7294] = 7294,
  [7295] = 7263,
  [7296] = 7278,
  [7297] = 7297,
  [7298] = 7271,
  [7299] = 7279,
  [7300] = 7258,
  [7301] = 7263,
  [7302] = 7278,
  [7303] = 7271,
  [7304] = 7261,
  [7305] = 7258,
  [7306] = 7263,
  [7307] = 7278,
  [7308] = 7177,
  [7309] = 7309,
  [7310] = 7263,
  [7311] = 7311,
  [7312] = 7277,
  [7313] = 7313,
  [7314] = 7271,
  [7315] = 7315,
  [7316] = 7316,
  [7317] = 7024,
  [7318] = 7318,
  [7319] = 7275,
  [7320] = 7258,
  [7321] = 7263,
  [7322] = 6998,
  [7323] = 7323,
  [7324] = 7324,
  [7325] = 7309,
  [7326] = 7054,
  [7327] = 7327,
  [7328] = 7000,
  [7329] = 7278,
  [7330] = 7027,
  [7331] = 7278,
  [7332] = 7051,
  [7333] = 7233,
  [7334] = 7315,
  [7335] = 7168,
  [7336] = 7336,
  [7337] = 7337,
  [7338] = 7338,
  [7339] = 7339,
  [7340] = 7340,
  [7341] = 7171,
  [7342] = 7231,
  [7343] = 7229,
  [7344] = 7271,
  [7345] = 7225,
  [7346] = 7346,
  [7347] = 7347,
  [7348] = 7348,
  [7349] = 7264,
  [7350] = 7350,
  [7351] = 7351,
  [7352] = 6918,
  [7353] = 7353,
  [7354] = 7224,
  [7355] = 7355,
  [7356] = 7297,
  [7357] = 7212,
  [7358] = 7358,
  [7359] = 7258,
  [7360] = 7063,
  [7361] = 7361,
  [7362] = 7165,
  [7363] = 7211,
  [7364] = 7208,
  [7365] = 7365,
  [7366] = 6945,
  [7367] = 7367,
  [7368] = 7267,
  [7369] = 7271,
  [7370] = 7182,
  [7371] = 7267,
  [7372] = 7264,
  [7373] = 7181,
  [7374] = 7350,
  [7375] = 6933,
  [7376] = 7376,
  [7377] = 7377,
  [7378] = 7279,
  [7379] = 7379,
  [7380] = 7376,
  [7381] = 7292,
  [7382] = 7377,
  [7383] = 7379,
  [7384] = 7292,
  [7385] = 7261,
  [7386] = 7277,
  [7387] = 6921,
  [7388] = 7388,
  [7389] = 7278,
  [7390] = 7379,
  [7391] = 7391,
  [7392] = 7377,
  [7393] = 7393,
  [7394] = 7263,
  [7395] = 7350,
  [7396] = 7315,
  [7397] = 7376,
  [7398] = 7256,
  [7399] = 7268,
  [7400] = 7400,
  [7401] = 7186,
  [7402] = 7402,
  [7403] = 7403,
  [7404] = 7268,
  [7405] = 7256,
  [7406] = 7406,
  [7407] = 591,
  [7408] = 6919,
  [7409] = 7311,
  [7410] = 6971,
  [7411] = 7411,
  [7412] = 7269,
  [7413] = 7413,
  [7414] = 7316,
  [7415] = 6968,
  [7416] = 7416,
  [7417] = 7388,
  [7418] = 7257,
  [7419] = 7419,
  [7420] = 7400,
  [7421] = 7403,
  [7422] = 7416,
  [7423] = 7423,
  [7424] = 7424,
  [7425] = 7425,
  [7426] = 7406,
  [7427] = 7427,
  [7428] = 7419,
  [7429] = 7423,
  [7430] = 7430,
  [7431] = 7431,
  [7432] = 7413,
  [7433] = 7433,
  [7434] = 7427,
  [7435] = 7435,
  [7436] = 7436,
  [7437] = 7318,
  [7438] = 7269,
  [7439] = 7436,
  [7440] = 7431,
  [7441] = 7212,
  [7442] = 7338,
  [7443] = 7424,
  [7444] = 7424,
  [7445] = 7427,
  [7446] = 6981,
  [7447] = 7323,
  [7448] = 7294,
  [7449] = 7324,
  [7450] = 7327,
  [7451] = 7177,
  [7452] = 7452,
  [7453] = 7238,
  [7454] = 7213,
  [7455] = 7423,
  [7456] = 7018,
  [7457] = 7340,
  [7458] = 7021,
  [7459] = 7168,
  [7460] = 7339,
  [7461] = 7461,
  [7462] = 7337,
  [7463] = 7336,
  [7464] = 7419,
  [7465] = 7465,
  [7466] = 7367,
  [7467] = 7402,
  [7468] = 7468,
  [7469] = 7469,
  [7470] = 6918,
  [7471] = 7260,
  [7472] = 7361,
  [7473] = 7358,
  [7474] = 7474,
  [7475] = 7475,
  [7476] = 7391,
  [7477] = 7431,
  [7478] = 7478,
  [7479] = 7181,
  [7480] = 7186,
  [7481] = 7430,
  [7482] = 6921,
  [7483] = 7293,
  [7484] = 6919,
  [7485] = 7452,
  [7486] = 6933,
  [7487] = 7413,
  [7488] = 7283,
  [7489] = 7435,
  [7490] = 7284,
  [7491] = 7285,
  [7492] = 7286,
  [7493] = 6945,
  [7494] = 7494,
  [7495] = 7474,
  [7496] = 6982,
  [7497] = 7287,
  [7498] = 7403,
  [7499] = 7416,
  [7500] = 7465,
  [7501] = 7436,
  [7502] = 7365,
  [7503] = 776,
  [7504] = 7478,
  [7505] = 7346,
  [7506] = 7353,
  [7507] = 7351,
  [7508] = 7260,
  [7509] = 7313,
  [7510] = 7348,
  [7511] = 7265,
  [7512] = 7347,
  [7513] = 7475,
  [7514] = 7403,
  [7515] = 7515,
  [7516] = 7212,
  [7517] = 7517,
  [7518] = 7177,
  [7519] = 7519,
  [7520] = 7238,
  [7521] = 7521,
  [7522] = 7213,
  [7523] = 7168,
  [7524] = 7524,
  [7525] = 7525,
  [7526] = 7257,
  [7527] = 6982,
  [7528] = 7528,
  [7529] = 7181,
  [7530] = 7388,
  [7531] = 7531,
  [7532] = 7532,
  [7533] = 7533,
  [7534] = 7534,
  [7535] = 7051,
  [7536] = 7536,
  [7537] = 7537,
  [7538] = 7538,
  [7539] = 7024,
  [7540] = 7540,
  [7541] = 7541,
  [7542] = 7260,
  [7543] = 7468,
  [7544] = 7532,
  [7545] = 6998,
  [7546] = 7528,
  [7547] = 7365,
  [7548] = 7411,
  [7549] = 7549,
  [7550] = 7550,
  [7551] = 7551,
  [7552] = 7186,
  [7553] = 7553,
  [7554] = 7554,
  [7555] = 7555,
  [7556] = 7556,
  [7557] = 7425,
  [7558] = 6882,
  [7559] = 7000,
  [7560] = 7515,
  [7561] = 7561,
  [7562] = 7562,
  [7563] = 7563,
  [7564] = 7054,
  [7565] = 7565,
  [7566] = 7566,
  [7567] = 7567,
  [7568] = 7541,
  [7569] = 7569,
  [7570] = 7570,
  [7571] = 7571,
  [7572] = 7569,
  [7573] = 7573,
  [7574] = 7574,
  [7575] = 7575,
  [7576] = 7576,
  [7577] = 7575,
  [7578] = 7027,
  [7579] = 7538,
  [7580] = 7532,
  [7581] = 414,
  [7582] = 127,
  [7583] = 438,
  [7584] = 7584,
  [7585] = 7585,
  [7586] = 7586,
  [7587] = 7586,
  [7588] = 7588,
  [7589] = 6956,
  [7590] = 7269,
  [7591] = 7591,
  [7592] = 7575,
  [7593] = 7593,
  [7594] = 7574,
  [7595] = 7595,
  [7596] = 7596,
  [7597] = 7597,
  [7598] = 7537,
  [7599] = 7524,
  [7600] = 7573,
  [7601] = 7563,
  [7602] = 7602,
  [7603] = 7603,
  [7604] = 7604,
  [7605] = 7605,
  [7606] = 7606,
  [7607] = 7561,
  [7608] = 7608,
  [7609] = 7608,
  [7610] = 7610,
  [7611] = 7585,
  [7612] = 7570,
  [7613] = 7613,
  [7614] = 7576,
  [7615] = 7588,
  [7616] = 7565,
  [7617] = 7608,
  [7618] = 7567,
  [7619] = 7619,
  [7620] = 7562,
  [7621] = 7621,
  [7622] = 7540,
  [7623] = 7623,
  [7624] = 7610,
  [7625] = 7625,
  [7626] = 7626,
  [7627] = 7627,
  [7628] = 7596,
  [7629] = 7608,
  [7630] = 7630,
  [7631] = 7550,
  [7632] = 7551,
  [7633] = 7633,
  [7634] = 7571,
  [7635] = 7635,
  [7636] = 7627,
  [7637] = 7637,
  [7638] = 7556,
  [7639] = 7639,
  [7640] = 7595,
  [7641] = 7641,
  [7642] = 7642,
  [7643] = 7593,
  [7644] = 7644,
  [7645] = 7531,
  [7646] = 7633,
  [7647] = 7647,
  [7648] = 7648,
  [7649] = 7649,
  [7650] = 7641,
  [7651] = 7596,
  [7652] = 7652,
  [7653] = 7653,
  [7654] = 7063,
  [7655] = 7553,
  [7656] = 7584,
  [7657] = 7475,
  [7658] = 7051,
  [7659] = 7605,
  [7660] = 7660,
  [7661] = 7661,
  [7662] = 7662,
  [7663] = 7626,
  [7664] = 7027,
  [7665] = 7000,
  [7666] = 7269,
  [7667] = 7054,
  [7668] = 7403,
  [7669] = 6998,
  [7670] = 7536,
  [7671] = 7260,
  [7672] = 7642,
  [7673] = 7024,
  [7674] = 7596,
  [7675] = 7603,
  [7676] = 7676,
  [7677] = 7677,
  [7678] = 7257,
  [7679] = 7388,
  [7680] = 7633,
  [7681] = 7605,
  [7682] = 7682,
  [7683] = 7677,
  [7684] = 7641,
  [7685] = 7606,
  [7686] = 7591,
  [7687] = 7687,
  [7688] = 7682,
  [7689] = 7689,
  [7690] = 7608,
  [7691] = 7635,
  [7692] = 7677,
  [7693] = 7693,
  [7694] = 7694,
  [7695] = 7608,
  [7696] = 7635,
  [7697] = 7697,
  [7698] = 7697,
  [7699] = 7699,
  [7700] = 7641,
  [7701] = 7701,
  [7702] = 7694,
  [7703] = 7676,
  [7704] = 7633,
  [7705] = 7633,
  [7706] = 7641,
  [7707] = 7555,
  [7708] = 7637,
  [7709] = 7635,
  [7710] = 7652,
  [7711] = 7625,
  [7712] = 7635,
  [7713] = 7713,
  [7714] = 7621,
  [7715] = 7627,
  [7716] = 7716,
  [7717] = 7633,
  [7718] = 7365,
  [7719] = 7719,
  [7720] = 7720,
  [7721] = 7641,
  [7722] = 7722,
  [7723] = 7723,
  [7724] = 7635,
  [7725] = 7725,
  [7726] = 7726,
  [7727] = 7727,
  [7728] = 7728,
  [7729] = 7729,
  [7730] = 7730,
  [7731] = 7731,
  [7732] = 7644,
  [7733] = 7733,
  [7734] = 7734,
  [7735] = 649,
  [7736] = 7736,
  [7737] = 7737,
  [7738] = 7738,
  [7739] = 7475,
  [7740] = 7740,
  [7741] = 7741,
  [7742] = 7742,
  [7743] = 7743,
  [7744] = 7740,
  [7745] = 7745,
  [7746] = 7730,
  [7747] = 7747,
  [7748] = 7731,
  [7749] = 7749,
  [7750] = 7737,
  [7751] = 7734,
  [7752] = 7752,
  [7753] = 7753,
  [7754] = 7741,
  [7755] = 7742,
  [7756] = 7756,
  [7757] = 7757,
  [7758] = 7733,
  [7759] = 7745,
  [7760] = 7760,
  [7761] = 7745,
  [7762] = 7733,
  [7763] = 7731,
  [7764] = 7764,
  [7765] = 7757,
  [7766] = 7730,
  [7767] = 7767,
  [7768] = 7768,
  [7769] = 7769,
  [7770] = 7770,
  [7771] = 7740,
  [7772] = 7734,
  [7773] = 7773,
  [7774] = 7728,
  [7775] = 7775,
  [7776] = 7730,
  [7777] = 7737,
  [7778] = 7757,
  [7779] = 7737,
  [7780] = 7740,
  [7781] = 7740,
  [7782] = 7782,
  [7783] = 7727,
  [7784] = 7733,
  [7785] = 7731,
  [7786] = 7757,
  [7787] = 7745,
  [7788] = 7788,
  [7789] = 7789,
  [7790] = 7734,
  [7791] = 7757,
  [7792] = 7730,
  [7793] = 7793,
  [7794] = 7181,
  [7795] = 7795,
  [7796] = 7733,
  [7797] = 7212,
  [7798] = 7738,
  [7799] = 7745,
  [7800] = 7800,
  [7801] = 7801,
  [7802] = 7802,
  [7803] = 7730,
  [7804] = 7804,
  [7805] = 7757,
  [7806] = 7806,
  [7807] = 7807,
  [7808] = 7731,
  [7809] = 7734,
  [7810] = 7733,
  [7811] = 7736,
  [7812] = 7812,
  [7813] = 7782,
  [7814] = 7752,
  [7815] = 7745,
  [7816] = 7801,
  [7817] = 7812,
  [7818] = 7818,
  [7819] = 7819,
  [7820] = 7764,
  [7821] = 7770,
  [7822] = 7822,
  [7823] = 7737,
  [7824] = 7760,
  [7825] = 7731,
  [7826] = 7722,
  [7827] = 7806,
  [7828] = 7757,
  [7829] = 7727,
  [7830] = 7720,
  [7831] = 7716,
  [7832] = 7713,
  [7833] = 7757,
  [7834] = 7740,
  [7835] = 7818,
  [7836] = 7734,
  [7837] = 7743,
  [7838] = 7838,
  [7839] = 7745,
  [7840] = 7737,
  [7841] = 7841,
  [7842] = 7842,
  [7843] = 7757,
  [7844] = 7844,
  [7845] = 7238,
  [7846] = 7736,
  [7847] = 7847,
  [7848] = 7848,
  [7849] = 7177,
  [7850] = 7753,
  [7851] = 7731,
  [7852] = 7740,
  [7853] = 7727,
  [7854] = 7745,
  [7855] = 591,
  [7856] = 7856,
  [7857] = 7186,
  [7858] = 7768,
  [7859] = 7757,
  [7860] = 7757,
  [7861] = 7861,
  [7862] = 7740,
  [7863] = 7757,
  [7864] = 7864,
  [7865] = 7865,
  [7866] = 7729,
  [7867] = 7733,
  [7868] = 7868,
  [7869] = 7699,
  [7870] = 7737,
  [7871] = 7734,
  [7872] = 7838,
  [7873] = 7737,
  [7874] = 7874,
  [7875] = 7875,
  [7876] = 7550,
  [7877] = 7756,
  [7878] = 7730,
  [7879] = 7727,
  [7880] = 7874,
  [7881] = 7807,
  [7882] = 7800,
  [7883] = 7727,
  [7884] = 7757,
  [7885] = 7563,
  [7886] = 7757,
  [7887] = 7887,
  [7888] = 7213,
  [7889] = 7889,
  [7890] = 7818,
  [7891] = 7891,
  [7892] = 7892,
  [7893] = 7893,
  [7894] = 7789,
  [7895] = 7788,
  [7896] = 7893,
  [7897] = 7588,
  [7898] = 88,
  [7899] = 7747,
  [7900] = 7892,
  [7901] = 7875,
  [7902] = 7749,
  [7903] = 7793,
  [7904] = 7168,
  [7905] = 7905,
  [7906] = 7795,
  [7907] = 7757,
  [7908] = 7819,
  [7909] = 7731,
  [7910] = 7822,
  [7911] = 7861,
  [7912] = 7757,
  [7913] = 7730,
  [7914] = 7767,
  [7915] = 7915,
  [7916] = 7841,
  [7917] = 7769,
  [7918] = 7842,
  [7919] = 7847,
  [7920] = 7848,
  [7921] = 7856,
  [7922] = 7623,
  [7923] = 7757,
  [7924] = 7565,
  [7925] = 7925,
  [7926] = 7838,
  [7927] = 7864,
  [7928] = 7865,
  [7929] = 7653,
  [7930] = 7733,
  [7931] = 7868,
  [7932] = 7734,
  [7933] = 7604,
  [7934] = 7540,
  [7935] = 7891,
  [7936] = 7602,
  [7937] = 7887,
  [7938] = 7757,
  [7939] = 7775,
  [7940] = 7773,
  [7941] = 7802,
  [7942] = 7804,
  [7943] = 7943,
  [7944] = 7944,
  [7945] = 7945,
  [7946] = 7943,
  [7947] = 7947,
  [7948] = 7948,
  [7949] = 7949,
  [7950] = 7950,
  [7951] = 7944,
  [7952] = 7952,
  [7953] = 7953,
  [7954] = 7945,
  [7955] = 7945,
  [7956] = 7943,
  [7957] = 7957,
  [7958] = 7958,
  [7959] = 7949,
  [7960] = 7960,
  [7961] = 7961,
  [7962] = 7945,
  [7963] = 7943,
  [7964] = 7943,
  [7965] = 7949,
  [7966] = 7944,
  [7967] = 7944,
  [7968] = 7949,
  [7969] = 181,
  [7970] = 7970,
  [7971] = 7971,
  [7972] = 7945,
  [7973] = 7943,
  [7974] = 7974,
  [7975] = 7975,
  [7976] = 7953,
  [7977] = 7977,
  [7978] = 7978,
  [7979] = 7979,
  [7980] = 7980,
  [7981] = 7981,
  [7982] = 7982,
  [7983] = 7944,
  [7984] = 7945,
  [7985] = 7949,
  [7986] = 7943,
  [7987] = 7987,
  [7988] = 7988,
  [7989] = 7989,
  [7990] = 7944,
  [7991] = 7944,
  [7992] = 7949,
  [7993] = 7945,
  [7994] = 7943,
  [7995] = 7944,
  [7996] = 7996,
  [7997] = 7949,
  [7998] = 7998,
  [7999] = 7999,
  [8000] = 8000,
  [8001] = 7949,
  [8002] = 7949,
  [8003] = 7977,
  [8004] = 7944,
  [8005] = 8005,
  [8006] = 7950,
  [8007] = 7943,
  [8008] = 8008,
  [8009] = 8009,
  [8010] = 7944,
  [8011] = 7987,
  [8012] = 8012,
  [8013] = 8013,
  [8014] = 8014,
  [8015] = 7945,
  [8016] = 7949,
  [8017] = 7945,
  [8018] = 8018,
  [8019] = 8019,
  [8020] = 7949,
  [8021] = 7978,
  [8022] = 7943,
  [8023] = 8023,
  [8024] = 8008,
  [8025] = 8025,
  [8026] = 7999,
  [8027] = 8018,
  [8028] = 7978,
  [8029] = 8029,
  [8030] = 8023,
  [8031] = 7943,
  [8032] = 8032,
  [8033] = 8033,
  [8034] = 8034,
  [8035] = 8035,
  [8036] = 7540,
  [8037] = 7945,
  [8038] = 7905,
  [8039] = 7945,
  [8040] = 7565,
  [8041] = 7588,
  [8042] = 7943,
  [8043] = 7563,
  [8044] = 8044,
  [8045] = 7982,
  [8046] = 7550,
  [8047] = 7945,
  [8048] = 7953,
  [8049] = 8049,
  [8050] = 8013,
  [8051] = 8051,
  [8052] = 8035,
  [8053] = 7949,
  [8054] = 7943,
  [8055] = 7989,
  [8056] = 7958,
  [8057] = 7979,
  [8058] = 8058,
  [8059] = 8018,
  [8060] = 7978,
  [8061] = 7949,
  [8062] = 8023,
  [8063] = 7944,
  [8064] = 7944,
  [8065] = 8023,
  [8066] = 8019,
  [8067] = 8067,
  [8068] = 7996,
  [8069] = 7944,
  [8070] = 8070,
  [8071] = 7943,
  [8072] = 7949,
  [8073] = 7945,
  [8074] = 7945,
  [8075] = 7186,
  [8076] = 7181,
  [8077] = 7868,
  [8078] = 7943,
  [8079] = 8079,
  [8080] = 7168,
  [8081] = 7213,
  [8082] = 7945,
  [8083] = 7943,
  [8084] = 7950,
  [8085] = 7238,
  [8086] = 7861,
  [8087] = 7177,
  [8088] = 8088,
  [8089] = 8005,
  [8090] = 8000,
  [8091] = 7945,
  [8092] = 7943,
  [8093] = 8025,
  [8094] = 8094,
  [8095] = 8067,
  [8096] = 7212,
  [8097] = 8070,
  [8098] = 8049,
  [8099] = 8099,
  [8100] = 8100,
  [8101] = 8005,
  [8102] = 7949,
  [8103] = 8018,
  [8104] = 7949,
  [8105] = 8009,
  [8106] = 7944,
  [8107] = 7944,
  [8108] = 8018,
  [8109] = 7949,
  [8110] = 8051,
  [8111] = 7743,
  [8112] = 8044,
  [8113] = 7978,
  [8114] = 7945,
  [8115] = 8009,
  [8116] = 7945,
  [8117] = 7978,
  [8118] = 7944,
  [8119] = 7943,
  [8120] = 8023,
  [8121] = 8018,
  [8122] = 7944,
  [8123] = 8023,
  [8124] = 8124,
  [8125] = 8125,
  [8126] = 7944,
  [8127] = 7949,
  [8128] = 8128,
  [8129] = 776,
  [8130] = 8013,
  [8131] = 8131,
  [8132] = 8034,
  [8133] = 8133,
  [8134] = 8134,
  [8135] = 7948,
  [8136] = 8136,
  [8137] = 8137,
  [8138] = 8131,
  [8139] = 8139,
  [8140] = 8140,
  [8141] = 8131,
  [8142] = 8139,
  [8143] = 8139,
  [8144] = 7947,
  [8145] = 8140,
  [8146] = 8137,
  [8147] = 8147,
  [8148] = 8148,
  [8149] = 8149,
  [8150] = 8150,
  [8151] = 8150,
  [8152] = 8152,
  [8153] = 7952,
  [8154] = 8154,
  [8155] = 8131,
  [8156] = 8156,
  [8157] = 8157,
  [8158] = 7980,
  [8159] = 7981,
  [8160] = 8160,
  [8161] = 8161,
  [8162] = 8162,
  [8163] = 8163,
  [8164] = 8094,
  [8165] = 8165,
  [8166] = 8131,
  [8167] = 8167,
  [8168] = 8161,
  [8169] = 8169,
  [8170] = 8170,
  [8171] = 8131,
  [8172] = 8100,
  [8173] = 8173,
  [8174] = 8174,
  [8175] = 8175,
  [8176] = 8167,
  [8177] = 8177,
  [8178] = 8178,
  [8179] = 8179,
  [8180] = 8180,
  [8181] = 8181,
  [8182] = 8131,
  [8183] = 8183,
  [8184] = 8169,
  [8185] = 8185,
  [8186] = 649,
  [8187] = 8175,
  [8188] = 8188,
  [8189] = 8189,
  [8190] = 8162,
  [8191] = 8174,
  [8192] = 8140,
  [8193] = 8137,
  [8194] = 8194,
  [8195] = 8133,
  [8196] = 8131,
  [8197] = 8178,
  [8198] = 8198,
  [8199] = 8147,
  [8200] = 8200,
  [8201] = 8131,
  [8202] = 8136,
  [8203] = 8203,
  [8204] = 8167,
  [8205] = 8198,
  [8206] = 7998,
  [8207] = 8207,
  [8208] = 8208,
  [8209] = 8209,
  [8210] = 8210,
  [8211] = 8131,
  [8212] = 8212,
  [8213] = 8174,
  [8214] = 8214,
  [8215] = 8215,
  [8216] = 8216,
  [8217] = 8070,
  [8218] = 8218,
  [8219] = 8131,
  [8220] = 8220,
  [8221] = 7974,
  [8222] = 8207,
  [8223] = 8223,
  [8224] = 8224,
  [8225] = 7970,
  [8226] = 8067,
  [8227] = 8165,
  [8228] = 8228,
  [8229] = 8131,
  [8230] = 8230,
  [8231] = 8231,
  [8232] = 8185,
  [8233] = 8233,
  [8234] = 8228,
  [8235] = 8235,
  [8236] = 8131,
  [8237] = 8163,
  [8238] = 8044,
  [8239] = 8218,
  [8240] = 8131,
  [8241] = 8179,
  [8242] = 8242,
  [8243] = 8180,
  [8244] = 8209,
  [8245] = 8245,
  [8246] = 8131,
  [8247] = 8247,
  [8248] = 7975,
  [8249] = 8181,
  [8250] = 7996,
  [8251] = 7988,
  [8252] = 8208,
  [8253] = 8253,
  [8254] = 8131,
  [8255] = 8207,
  [8256] = 8175,
  [8257] = 7961,
  [8258] = 7957,
  [8259] = 8259,
  [8260] = 8260,
  [8261] = 8134,
  [8262] = 8150,
  [8263] = 8012,
  [8264] = 8264,
  [8265] = 8265,
  [8266] = 8266,
  [8267] = 8267,
  [8268] = 8029,
  [8269] = 8180,
  [8270] = 8131,
  [8271] = 8207,
  [8272] = 8272,
  [8273] = 8088,
  [8274] = 8259,
  [8275] = 8260,
  [8276] = 8276,
  [8277] = 8264,
  [8278] = 8266,
  [8279] = 8198,
  [8280] = 8267,
  [8281] = 8281,
  [8282] = 8282,
  [8283] = 8218,
  [8284] = 8284,
  [8285] = 8285,
  [8286] = 8286,
  [8287] = 8245,
  [8288] = 8288,
  [8289] = 8242,
  [8290] = 8170,
  [8291] = 8224,
  [8292] = 8134,
  [8293] = 8281,
  [8294] = 8189,
  [8295] = 8295,
  [8296] = 8215,
  [8297] = 8162,
  [8298] = 8014,
  [8299] = 8299,
  [8300] = 8133,
  [8301] = 8301,
  [8302] = 8302,
  [8303] = 8209,
  [8304] = 8231,
  [8305] = 8230,
  [8306] = 7269,
  [8307] = 8200,
  [8308] = 8189,
  [8309] = 8233,
  [8310] = 7403,
  [8311] = 8311,
  [8312] = 7260,
  [8313] = 8272,
  [8314] = 8314,
  [8315] = 8276,
  [8316] = 8203,
  [8317] = 8160,
  [8318] = 8318,
  [8319] = 8152,
  [8320] = 8149,
  [8321] = 8099,
  [8322] = 8131,
  [8323] = 8183,
  [8324] = 8324,
  [8325] = 8325,
  [8326] = 8148,
  [8327] = 8327,
  [8328] = 8328,
  [8329] = 8329,
  [8330] = 8330,
  [8331] = 8331,
  [8332] = 8332,
  [8333] = 8333,
  [8334] = 6776,
  [8335] = 8335,
  [8336] = 8335,
  [8337] = 8220,
  [8338] = 8338,
  [8339] = 8339,
  [8340] = 6737,
  [8341] = 8341,
  [8342] = 6725,
  [8343] = 8331,
  [8344] = 8344,
  [8345] = 8345,
  [8346] = 8346,
  [8347] = 8347,
  [8348] = 8154,
  [8349] = 8349,
  [8350] = 8350,
  [8351] = 8235,
  [8352] = 8352,
  [8353] = 8301,
  [8354] = 6700,
  [8355] = 8355,
  [8356] = 8328,
  [8357] = 8357,
  [8358] = 8358,
  [8359] = 8359,
  [8360] = 8360,
  [8361] = 8361,
  [8362] = 8362,
  [8363] = 8363,
  [8364] = 8288,
  [8365] = 8365,
  [8366] = 8366,
  [8367] = 8367,
  [8368] = 8368,
  [8369] = 8328,
  [8370] = 8370,
  [8371] = 8371,
  [8372] = 8372,
  [8373] = 8373,
  [8374] = 8156,
  [8375] = 8375,
  [8376] = 8376,
  [8377] = 8372,
  [8378] = 8333,
  [8379] = 8332,
  [8380] = 8188,
  [8381] = 8381,
  [8382] = 8382,
  [8383] = 8383,
  [8384] = 8384,
  [8385] = 8385,
  [8386] = 8386,
  [8387] = 8387,
  [8388] = 8388,
  [8389] = 8384,
  [8390] = 8384,
  [8391] = 8391,
  [8392] = 8392,
  [8393] = 8393,
  [8394] = 8394,
  [8395] = 8362,
  [8396] = 8157,
  [8397] = 8165,
  [8398] = 8398,
  [8399] = 8399,
  [8400] = 8400,
  [8401] = 8401,
  [8402] = 8402,
  [8403] = 8403,
  [8404] = 8404,
  [8405] = 8405,
  [8406] = 8406,
  [8407] = 8407,
  [8408] = 8386,
  [8409] = 8388,
  [8410] = 8373,
  [8411] = 8394,
  [8412] = 8384,
  [8413] = 8329,
  [8414] = 8414,
  [8415] = 8344,
  [8416] = 8416,
  [8417] = 8384,
  [8418] = 8384,
  [8419] = 8419,
  [8420] = 8344,
  [8421] = 8284,
  [8422] = 8422,
  [8423] = 8407,
  [8424] = 8424,
  [8425] = 8370,
  [8426] = 8426,
  [8427] = 8427,
  [8428] = 8330,
  [8429] = 8325,
  [8430] = 8430,
  [8431] = 8393,
  [8432] = 8125,
  [8433] = 8433,
  [8434] = 8375,
  [8435] = 8435,
  [8436] = 8128,
  [8437] = 8437,
  [8438] = 8438,
  [8439] = 8282,
  [8440] = 8331,
  [8441] = 8344,
  [8442] = 8406,
  [8443] = 8328,
  [8444] = 8384,
  [8445] = 8384,
  [8446] = 8341,
  [8447] = 8399,
  [8448] = 8373,
  [8449] = 8352,
  [8450] = 8328,
  [8451] = 8295,
  [8452] = 8265,
  [8453] = 7257,
  [8454] = 8454,
  [8455] = 8328,
  [8456] = 8456,
  [8457] = 8457,
  [8458] = 8457,
  [8459] = 8399,
  [8460] = 8398,
  [8461] = 8370,
  [8462] = 8462,
  [8463] = 8457,
  [8464] = 8464,
  [8465] = 8465,
  [8466] = 8033,
  [8467] = 8467,
  [8468] = 8194,
  [8469] = 8469,
  [8470] = 8470,
  [8471] = 8467,
  [8472] = 8472,
  [8473] = 8473,
  [8474] = 8359,
  [8475] = 8328,
  [8476] = 8476,
  [8477] = 8426,
  [8478] = 8344,
  [8479] = 8032,
  [8480] = 8480,
  [8481] = 8437,
  [8482] = 8482,
  [8483] = 8427,
  [8484] = 8407,
  [8485] = 8371,
  [8486] = 8331,
  [8487] = 8328,
  [8488] = 8331,
  [8489] = 8331,
  [8490] = 8331,
  [8491] = 8359,
  [8492] = 8492,
  [8493] = 8328,
  [8494] = 8405,
  [8495] = 8401,
  [8496] = 8496,
  [8497] = 8392,
  [8498] = 8223,
  [8499] = 8331,
  [8500] = 8331,
  [8501] = 8482,
  [8502] = 6699,
  [8503] = 8416,
  [8504] = 8384,
  [8505] = 8404,
  [8506] = 8414,
  [8507] = 8344,
  [8508] = 8328,
  [8509] = 8384,
  [8510] = 8331,
  [8511] = 8456,
  [8512] = 8345,
  [8513] = 8366,
  [8514] = 8406,
  [8515] = 8515,
  [8516] = 8384,
  [8517] = 8345,
  [8518] = 8330,
  [8519] = 8438,
  [8520] = 8331,
  [8521] = 8521,
  [8522] = 8430,
  [8523] = 8331,
  [8524] = 7365,
  [8525] = 8325,
  [8526] = 8526,
  [8527] = 8527,
  [8528] = 8344,
  [8529] = 8328,
  [8530] = 8467,
  [8531] = 8302,
  [8532] = 8454,
  [8533] = 8467,
  [8534] = 8534,
  [8535] = 8359,
  [8536] = 8536,
  [8537] = 6739,
  [8538] = 8538,
  [8539] = 8496,
  [8540] = 8540,
  [8541] = 6740,
  [8542] = 8329,
  [8543] = 8344,
  [8544] = 8331,
  [8545] = 8328,
  [8546] = 8482,
  [8547] = 8472,
  [8548] = 8362,
  [8549] = 8358,
  [8550] = 8381,
  [8551] = 8331,
  [8552] = 8552,
  [8553] = 8338,
  [8554] = 8554,
  [8555] = 8311,
  [8556] = 8328,
  [8557] = 8557,
  [8558] = 8476,
  [8559] = 8559,
  [8560] = 8560,
  [8561] = 8467,
  [8562] = 8562,
  [8563] = 8344,
  [8564] = 8564,
  [8565] = 8387,
  [8566] = 8492,
  [8567] = 8567,
  [8568] = 8359,
  [8569] = 8569,
  [8570] = 8384,
  [8571] = 8571,
  [8572] = 8344,
  [8573] = 8419,
  [8574] = 8482,
  [8575] = 8482,
  [8576] = 8576,
  [8577] = 8384,
  [8578] = 8344,
  [8579] = 8492,
  [8580] = 8381,
  [8581] = 8476,
  [8582] = 8384,
  [8583] = 8496,
  [8584] = 8331,
  [8585] = 8585,
  [8586] = 8358,
  [8587] = 8534,
  [8588] = 7257,
  [8589] = 8344,
  [8590] = 8331,
  [8591] = 8355,
  [8592] = 7388,
  [8593] = 8593,
  [8594] = 8384,
  [8595] = 8595,
  [8596] = 8482,
  [8597] = 8328,
  [8598] = 8210,
  [8599] = 8328,
  [8600] = 7388,
  [8601] = 7365,
  [8602] = 8247,
  [8603] = 8212,
  [8604] = 8331,
  [8605] = 8385,
  [8606] = 8214,
  [8607] = 8344,
  [8608] = 8437,
  [8609] = 8609,
  [8610] = 8299,
  [8611] = 8611,
  [8612] = 8365,
  [8613] = 8613,
  [8614] = 8614,
  [8615] = 8335,
  [8616] = 8331,
  [8617] = 8617,
  [8618] = 8177,
  [8619] = 8619,
  [8620] = 8430,
  [8621] = 8328,
  [8622] = 8344,
  [8623] = 8332,
  [8624] = 8383,
  [8625] = 8625,
  [8626] = 8344,
  [8627] = 8627,
  [8628] = 8628,
  [8629] = 8314,
  [8630] = 8496,
  [8631] = 8527,
  [8632] = 8359,
  [8633] = 8633,
  [8634] = 8344,
  [8635] = 8331,
  [8636] = 8435,
  [8637] = 8435,
  [8638] = 8331,
  [8639] = 8285,
  [8640] = 8384,
  [8641] = 6714,
  [8642] = 8642,
  [8643] = 8286,
  [8644] = 8384,
  [8645] = 8426,
  [8646] = 8328,
  [8647] = 8647,
  [8648] = 8427,
  [8649] = 8585,
  [8650] = 7475,
  [8651] = 8651,
  [8652] = 8467,
  [8653] = 8653,
  [8654] = 8654,
  [8655] = 8344,
  [8656] = 6956,
  [8657] = 6729,
  [8658] = 8331,
  [8659] = 8659,
  [8660] = 8660,
  [8661] = 8344,
  [8662] = 8344,
  [8663] = 6726,
  [8664] = 8328,
  [8665] = 8665,
  [8666] = 8344,
  [8667] = 8344,
  [8668] = 8437,
  [8669] = 8344,
  [8670] = 8344,
  [8671] = 6724,
  [8672] = 6702,
  [8673] = 8384,
  [8674] = 8324,
  [8675] = 8675,
  [8676] = 8676,
  [8677] = 8677,
  [8678] = 8678,
  [8679] = 8679,
  [8680] = 8680,
  [8681] = 8681,
  [8682] = 8682,
  [8683] = 8683,
  [8684] = 8684,
  [8685] = 8685,
  [8686] = 8677,
  [8687] = 8687,
  [8688] = 8683,
  [8689] = 8682,
  [8690] = 8684,
  [8691] = 8682,
  [8692] = 8692,
  [8693] = 8462,
  [8694] = 8694,
  [8695] = 8684,
  [8696] = 8682,
  [8697] = 8683,
  [8698] = 8515,
  [8699] = 8699,
  [8700] = 8700,
  [8701] = 8682,
  [8702] = 8702,
  [8703] = 8703,
  [8704] = 8567,
  [8705] = 8705,
  [8706] = 8569,
  [8707] = 8571,
  [8708] = 8653,
  [8709] = 8677,
  [8710] = 8660,
  [8711] = 8403,
  [8712] = 8540,
  [8713] = 8684,
  [8714] = 8714,
  [8715] = 8665,
  [8716] = 8716,
  [8717] = 8717,
  [8718] = 8718,
  [8719] = 8627,
  [8720] = 8625,
  [8721] = 8721,
  [8722] = 8722,
  [8723] = 8723,
  [8724] = 8724,
  [8725] = 8725,
  [8726] = 8619,
  [8727] = 8727,
  [8728] = 8728,
  [8729] = 8617,
  [8730] = 8727,
  [8731] = 8614,
  [8732] = 8613,
  [8733] = 8727,
  [8734] = 8734,
  [8735] = 8564,
  [8736] = 8736,
  [8737] = 8737,
  [8738] = 8684,
  [8739] = 8560,
  [8740] = 8740,
  [8741] = 8557,
  [8742] = 8554,
  [8743] = 8743,
  [8744] = 8552,
  [8745] = 8745,
  [8746] = 8682,
  [8747] = 8683,
  [8748] = 8748,
  [8749] = 8749,
  [8750] = 8750,
  [8751] = 8751,
  [8752] = 8752,
  [8753] = 8470,
  [8754] = 8469,
  [8755] = 8465,
  [8756] = 8756,
  [8757] = 8757,
  [8758] = 8677,
  [8759] = 8759,
  [8760] = 8760,
  [8761] = 8761,
  [8762] = 8762,
  [8763] = 8763,
  [8764] = 8764,
  [8765] = 8765,
  [8766] = 8647,
  [8767] = 8767,
  [8768] = 8768,
  [8769] = 8769,
  [8770] = 8770,
  [8771] = 8771,
  [8772] = 8400,
  [8773] = 8773,
  [8774] = 8464,
  [8775] = 8775,
  [8776] = 8776,
  [8777] = 8777,
  [8778] = 8778,
  [8779] = 8779,
  [8780] = 8780,
  [8781] = 8781,
  [8782] = 8782,
  [8783] = 8783,
  [8784] = 8784,
  [8785] = 8785,
  [8786] = 8786,
  [8787] = 8787,
  [8788] = 8788,
  [8789] = 8789,
  [8790] = 8684,
  [8791] = 8761,
  [8792] = 8792,
  [8793] = 8682,
  [8794] = 8794,
  [8795] = 8683,
  [8796] = 8796,
  [8797] = 8797,
  [8798] = 8798,
  [8799] = 8799,
  [8800] = 8771,
  [8801] = 8801,
  [8802] = 8677,
  [8803] = 8803,
  [8804] = 8804,
  [8805] = 8805,
  [8806] = 8794,
  [8807] = 8785,
  [8808] = 8808,
  [8809] = 8777,
  [8810] = 8810,
  [8811] = 8759,
  [8812] = 8812,
  [8813] = 8700,
  [8814] = 8814,
  [8815] = 8815,
  [8816] = 8816,
  [8817] = 8703,
  [8818] = 8818,
  [8819] = 8819,
  [8820] = 8799,
  [8821] = 8821,
  [8822] = 8822,
  [8823] = 8823,
  [8824] = 8824,
  [8825] = 8702,
  [8826] = 8826,
  [8827] = 8827,
  [8828] = 8828,
  [8829] = 8829,
  [8830] = 8830,
  [8831] = 8831,
  [8832] = 8832,
  [8833] = 8833,
  [8834] = 8834,
  [8835] = 8835,
  [8836] = 8836,
  [8837] = 8684,
  [8838] = 8838,
  [8839] = 8839,
  [8840] = 8682,
  [8841] = 8683,
  [8842] = 8740,
  [8843] = 8843,
  [8844] = 8844,
  [8845] = 8845,
  [8846] = 8846,
  [8847] = 8824,
  [8848] = 8848,
  [8849] = 8849,
  [8850] = 8850,
  [8851] = 8851,
  [8852] = 8852,
  [8853] = 8853,
  [8854] = 8854,
  [8855] = 8855,
  [8856] = 8856,
  [8857] = 8857,
  [8858] = 8858,
  [8859] = 8839,
  [8860] = 8860,
  [8861] = 8677,
  [8862] = 8862,
  [8863] = 8863,
  [8864] = 8864,
  [8865] = 8865,
  [8866] = 8866,
  [8867] = 8867,
  [8868] = 8868,
  [8869] = 8869,
  [8870] = 8769,
  [8871] = 8871,
  [8872] = 8872,
  [8873] = 8828,
  [8874] = 8874,
  [8875] = 8875,
  [8876] = 8876,
  [8877] = 8877,
  [8878] = 8878,
  [8879] = 8879,
  [8880] = 8880,
  [8881] = 8872,
  [8882] = 8815,
  [8883] = 8559,
  [8884] = 8562,
  [8885] = 8684,
  [8886] = 8682,
  [8887] = 8683,
  [8888] = 8888,
  [8889] = 8433,
  [8890] = 8835,
  [8891] = 8891,
  [8892] = 8892,
  [8893] = 8773,
  [8894] = 8677,
  [8895] = 8743,
  [8896] = 8737,
  [8897] = 8897,
  [8898] = 8877,
  [8899] = 8899,
  [8900] = 8900,
  [8901] = 8901,
  [8902] = 8902,
  [8903] = 8804,
  [8904] = 8728,
  [8905] = 8721,
  [8906] = 8906,
  [8907] = 8907,
  [8908] = 8678,
  [8909] = 8909,
  [8910] = 8910,
  [8911] = 8679,
  [8912] = 8848,
  [8913] = 8913,
  [8914] = 8875,
  [8915] = 8684,
  [8916] = 8869,
  [8917] = 8680,
  [8918] = 8867,
  [8919] = 8865,
  [8920] = 8681,
  [8921] = 8682,
  [8922] = 8683,
  [8923] = 8923,
  [8924] = 8699,
  [8925] = 8723,
  [8926] = 8923,
  [8927] = 8927,
  [8928] = 8928,
  [8929] = 8929,
  [8930] = 8930,
  [8931] = 8931,
  [8932] = 8932,
  [8933] = 8933,
  [8934] = 8934,
  [8935] = 8880,
  [8936] = 8677,
  [8937] = 8937,
  [8938] = 8938,
  [8939] = 8939,
  [8940] = 8940,
  [8941] = 8628,
  [8942] = 8942,
  [8943] = 8789,
  [8944] = 8944,
  [8945] = 8945,
  [8946] = 8946,
  [8947] = 8947,
  [8948] = 8796,
  [8949] = 8949,
  [8950] = 8950,
  [8951] = 8951,
  [8952] = 8952,
  [8953] = 8953,
  [8954] = 8954,
  [8955] = 8955,
  [8956] = 8756,
  [8957] = 8957,
  [8958] = 8684,
  [8959] = 8683,
  [8960] = 8682,
  [8961] = 8961,
  [8962] = 8682,
  [8963] = 8963,
  [8964] = 8683,
  [8965] = 8965,
  [8966] = 8966,
  [8967] = 8967,
  [8968] = 8763,
  [8969] = 8969,
  [8970] = 8970,
  [8971] = 8971,
  [8972] = 8788,
  [8973] = 8973,
  [8974] = 8974,
  [8975] = 8786,
  [8976] = 8976,
  [8977] = 8977,
  [8978] = 8978,
  [8979] = 8862,
  [8980] = 8852,
  [8981] = 8981,
  [8982] = 8677,
  [8983] = 8851,
  [8984] = 8984,
  [8985] = 8984,
  [8986] = 8986,
  [8987] = 8844,
  [8988] = 8988,
  [8989] = 8843,
  [8990] = 8990,
  [8991] = 8991,
  [8992] = 8992,
  [8993] = 8993,
  [8994] = 8981,
  [8995] = 8995,
  [8996] = 8996,
  [8997] = 8997,
  [8998] = 8998,
  [8999] = 8999,
  [9000] = 8684,
  [9001] = 9001,
  [9002] = 8682,
  [9003] = 9003,
  [9004] = 8683,
  [9005] = 9005,
  [9006] = 9006,
  [9007] = 8778,
  [9008] = 8779,
  [9009] = 9009,
  [9010] = 8826,
  [9011] = 8830,
  [9012] = 9012,
  [9013] = 9013,
  [9014] = 8677,
  [9015] = 8942,
  [9016] = 8526,
  [9017] = 8777,
  [9018] = 8759,
  [9019] = 9019,
  [9020] = 9020,
  [9021] = 8907,
  [9022] = 8906,
  [9023] = 8838,
  [9024] = 8779,
  [9025] = 8778,
  [9026] = 8779,
  [9027] = 8777,
  [9028] = 9028,
  [9029] = 8759,
  [9030] = 8521,
  [9031] = 9031,
  [9032] = 8682,
  [9033] = 8745,
  [9034] = 9034,
  [9035] = 8816,
  [9036] = 9028,
  [9037] = 8838,
  [9038] = 9038,
  [9039] = 9006,
  [9040] = 8683,
  [9041] = 9034,
  [9042] = 9042,
  [9043] = 9003,
  [9044] = 8978,
  [9045] = 8748,
  [9046] = 8778,
  [9047] = 8684,
  [9048] = 9048,
  [9049] = 8684,
  [9050] = 8778,
  [9051] = 8818,
  [9052] = 8977,
  [9053] = 8779,
  [9054] = 8538,
  [9055] = 8682,
  [9056] = 8838,
  [9057] = 8752,
  [9058] = 8683,
  [9059] = 8997,
  [9060] = 8777,
  [9061] = 8759,
  [9062] = 9062,
  [9063] = 8846,
  [9064] = 9064,
  [9065] = 8838,
  [9066] = 8677,
  [9067] = 8778,
  [9068] = 8779,
  [9069] = 8777,
  [9070] = 9070,
  [9071] = 8759,
  [9072] = 9072,
  [9073] = 8967,
  [9074] = 9074,
  [9075] = 8402,
  [9076] = 8838,
  [9077] = 9077,
  [9078] = 8949,
  [9079] = 8801,
  [9080] = 9080,
  [9081] = 8760,
  [9082] = 8778,
  [9083] = 9083,
  [9084] = 8779,
  [9085] = 9085,
  [9086] = 8777,
  [9087] = 8759,
  [9088] = 9088,
  [9089] = 9089,
  [9090] = 8823,
  [9091] = 8838,
  [9092] = 9092,
  [9093] = 8684,
  [9094] = 9094,
  [9095] = 8350,
  [9096] = 9096,
  [9097] = 8682,
  [9098] = 8683,
  [9099] = 8938,
  [9100] = 8705,
  [9101] = 8805,
  [9102] = 9102,
  [9103] = 9103,
  [9104] = 8812,
  [9105] = 8970,
  [9106] = 8810,
  [9107] = 8808,
  [9108] = 9108,
  [9109] = 8778,
  [9110] = 8888,
  [9111] = 9111,
  [9112] = 8779,
  [9113] = 9113,
  [9114] = 9092,
  [9115] = 8891,
  [9116] = 8771,
  [9117] = 8771,
  [9118] = 8777,
  [9119] = 9119,
  [9120] = 8771,
  [9121] = 8759,
  [9122] = 8971,
  [9123] = 8864,
  [9124] = 8838,
  [9125] = 8927,
  [9126] = 8932,
  [9127] = 8945,
  [9128] = 8595,
  [9129] = 8803,
  [9130] = 8677,
  [9131] = 8900,
  [9132] = 8778,
  [9133] = 9133,
  [9134] = 8779,
  [9135] = 8777,
  [9136] = 8771,
  [9137] = 8759,
  [9138] = 9138,
  [9139] = 8838,
  [9140] = 8778,
  [9141] = 8751,
  [9142] = 9142,
  [9143] = 8779,
  [9144] = 8777,
  [9145] = 8759,
  [9146] = 8946,
  [9147] = 8838,
  [9148] = 9148,
  [9149] = 8684,
  [9150] = 8367,
  [9151] = 9151,
  [9152] = 8778,
  [9153] = 8779,
  [9154] = 8682,
  [9155] = 8777,
  [9156] = 9156,
  [9157] = 8940,
  [9158] = 8683,
  [9159] = 8759,
  [9160] = 9160,
  [9161] = 8976,
  [9162] = 8838,
  [9163] = 8933,
  [9164] = 9164,
  [9165] = 8745,
  [9166] = 9166,
  [9167] = 9167,
  [9168] = 8929,
  [9169] = 8771,
  [9170] = 8928,
  [9171] = 9171,
  [9172] = 8955,
  [9173] = 9111,
  [9174] = 9077,
  [9175] = 9160,
  [9176] = 9176,
  [9177] = 9177,
  [9178] = 8778,
  [9179] = 8677,
  [9180] = 8981,
  [9181] = 9070,
  [9182] = 8676,
  [9183] = 8779,
  [9184] = 8777,
  [9185] = 8759,
  [9186] = 8838,
  [9187] = 8998,
  [9188] = 8480,
  [9189] = 8857,
  [9190] = 8769,
  [9191] = 8913,
  [9192] = 9072,
  [9193] = 8778,
  [9194] = 8700,
  [9195] = 9195,
  [9196] = 8855,
  [9197] = 8785,
  [9198] = 8779,
  [9199] = 8422,
  [9200] = 8777,
  [9201] = 9013,
  [9202] = 9202,
  [9203] = 8759,
  [9204] = 8838,
  [9205] = 8910,
  [9206] = 9102,
  [9207] = 9207,
  [9208] = 8771,
  [9209] = 9209,
  [9210] = 8368,
  [9211] = 8797,
  [9212] = 8778,
  [9213] = 9213,
  [9214] = 9214,
  [9215] = 8779,
  [9216] = 8792,
  [9217] = 8992,
  [9218] = 8777,
  [9219] = 8357,
  [9220] = 8974,
  [9221] = 8759,
  [9222] = 8787,
  [9223] = 8684,
  [9224] = 8838,
  [9225] = 8931,
  [9226] = 8997,
  [9227] = 8798,
  [9228] = 8784,
  [9229] = 8783,
  [9230] = 9020,
  [9231] = 9231,
  [9232] = 8682,
  [9233] = 8361,
  [9234] = 9019,
  [9235] = 8683,
  [9236] = 9236,
  [9237] = 9237,
  [9238] = 8382,
  [9239] = 9239,
  [9240] = 8391,
  [9241] = 9148,
  [9242] = 9242,
  [9243] = 8757,
  [9244] = 8782,
  [9245] = 9245,
  [9246] = 8718,
  [9247] = 8768,
  [9248] = 9248,
  [9249] = 8703,
  [9250] = 9250,
  [9251] = 8909,
  [9252] = 9252,
  [9253] = 9253,
  [9254] = 8780,
  [9255] = 9255,
  [9256] = 8778,
  [9257] = 8944,
  [9258] = 8677,
  [9259] = 8779,
  [9260] = 8777,
  [9261] = 8759,
  [9262] = 8838,
  [9263] = 9263,
  [9264] = 8576,
  [9265] = 9013,
  [9266] = 8677,
  [9267] = 8764,
  [9268] = 9089,
  [9269] = 9269,
  [9270] = 8878,
  [9271] = 8778,
  [9272] = 8779,
  [9273] = 8829,
  [9274] = 8777,
  [9275] = 8902,
  [9276] = 8759,
  [9277] = 8899,
  [9278] = 8838,
  [9279] = 9279,
  [9280] = 8937,
  [9281] = 8770,
  [9282] = 9282,
  [9283] = 8821,
  [9284] = 9284,
  [9285] = 8473,
  [9286] = 9286,
  [9287] = 9138,
  [9288] = 8897,
  [9289] = 8778,
  [9290] = 8779,
  [9291] = 8777,
  [9292] = 8759,
  [9293] = 8717,
  [9294] = 8838,
  [9295] = 9295,
  [9296] = 9074,
  [9297] = 9297,
  [9298] = 9103,
  [9299] = 8376,
  [9300] = 9300,
  [9301] = 8778,
  [9302] = 8779,
  [9303] = 8777,
  [9304] = 9263,
  [9305] = 8684,
  [9306] = 8759,
  [9307] = 8363,
  [9308] = 8838,
  [9309] = 8682,
  [9310] = 9310,
  [9311] = 9207,
  [9312] = 9297,
  [9313] = 9313,
  [9314] = 8683,
  [9315] = 9295,
  [9316] = 7475,
  [9317] = 9317,
  [9318] = 9318,
  [9319] = 9319,
  [9320] = 8327,
  [9321] = 9321,
  [9322] = 9322,
  [9323] = 9209,
  [9324] = 9324,
  [9325] = 8779,
  [9326] = 8694,
  [9327] = 8692,
  [9328] = 8339,
  [9329] = 9012,
  [9330] = 9330,
  [9331] = 9331,
  [9332] = 9171,
  [9333] = 8346,
  [9334] = 9245,
  [9335] = 8779,
  [9336] = 9164,
  [9337] = 8349,
  [9338] = 9156,
  [9339] = 9269,
  [9340] = 8703,
  [9341] = 9341,
  [9342] = 9113,
  [9343] = 8866,
  [9344] = 8536,
  [9345] = 8833,
  [9346] = 8832,
  [9347] = 8814,
  [9348] = 9348,
  [9349] = 9349,
  [9350] = 8677,
  [9351] = 8947,
  [9352] = 8954,
  [9353] = 9151,
  [9354] = 8785,
  [9355] = 8963,
  [9356] = 8700,
  [9357] = 9248,
  [9358] = 9358,
  [9359] = 8850,
  [9360] = 9358,
  [9361] = 8939,
  [9362] = 9318,
  [9363] = 8677,
  [9364] = 9364,
  [9365] = 8714,
  [9366] = 8857,
  [9367] = 9284,
  [9368] = 9282,
  [9369] = 8764,
  [9370] = 9370,
  [9371] = 9236,
  [9372] = 9331,
  [9373] = 9373,
  [9374] = 9317,
  [9375] = 8761,
  [9376] = 9213,
  [9377] = 8781,
  [9378] = 8684,
  [9379] = 9379,
  [9380] = 8991,
  [9381] = 8786,
  [9382] = 8981,
  [9383] = 8999,
  [9384] = 8682,
  [9385] = 8931,
  [9386] = 8683,
  [9387] = 8856,
  [9388] = 8788,
  [9389] = 8951,
  [9390] = 8950,
  [9391] = 9319,
  [9392] = 9392,
  [9393] = 8996,
  [9394] = 9394,
  [9395] = 8857,
  [9396] = 8703,
  [9397] = 9397,
  [9398] = 8714,
  [9399] = 9399,
  [9400] = 7365,
  [9401] = 9321,
  [9402] = 8845,
  [9403] = 9403,
  [9404] = 9404,
  [9405] = 9405,
  [9406] = 8986,
  [9407] = 9062,
  [9408] = 8872,
  [9409] = 8848,
  [9410] = 8677,
  [9411] = 9239,
  [9412] = 9324,
  [9413] = 9088,
  [9414] = 9414,
  [9415] = 8799,
  [9416] = 8824,
  [9417] = 8849,
  [9418] = 8892,
  [9419] = 7388,
  [9420] = 7257,
  [9421] = 8855,
  [9422] = 8913,
  [9423] = 9064,
  [9424] = 8860,
  [9425] = 8768,
  [9426] = 9231,
  [9427] = 9404,
  [9428] = 9286,
  [9429] = 9330,
  [9430] = 8740,
  [9431] = 8750,
  [9432] = 8863,
  [9433] = 8988,
  [9434] = 9349,
  [9435] = 9435,
  [9436] = 6543,
  [9437] = 9437,
  [9438] = 8770,
  [9439] = 6541,
  [9440] = 9440,
  [9441] = 9441,
  [9442] = 9442,
  [9443] = 9443,
  [9444] = 9444,
  [9445] = 9445,
  [9446] = 9446,
  [9447] = 9440,
  [9448] = 9448,
  [9449] = 9449,
  [9450] = 9450,
  [9451] = 9451,
  [9452] = 9452,
  [9453] = 9453,
  [9454] = 9454,
  [9455] = 9455,
  [9456] = 8750,
  [9457] = 9457,
  [9458] = 9458,
  [9459] = 9459,
  [9460] = 9460,
  [9461] = 9440,
  [9462] = 8780,
  [9463] = 9463,
  [9464] = 9464,
  [9465] = 9465,
  [9466] = 9440,
  [9467] = 9467,
  [9468] = 9468,
  [9469] = 9469,
  [9470] = 9460,
  [9471] = 9471,
  [9472] = 9463,
  [9473] = 9450,
  [9474] = 9459,
  [9475] = 9459,
  [9476] = 9463,
  [9477] = 9440,
  [9478] = 9478,
  [9479] = 9479,
  [9480] = 8986,
  [9481] = 9460,
  [9482] = 9450,
  [9483] = 9483,
  [9484] = 9440,
  [9485] = 9460,
  [9486] = 9486,
  [9487] = 9487,
  [9488] = 9450,
  [9489] = 9489,
  [9490] = 9448,
  [9491] = 9450,
  [9492] = 9492,
  [9493] = 9440,
  [9494] = 9460,
  [9495] = 6567,
  [9496] = 9496,
  [9497] = 9460,
  [9498] = 9498,
  [9499] = 9499,
  [9500] = 9450,
  [9501] = 9440,
  [9502] = 9502,
  [9503] = 9440,
  [9504] = 9440,
  [9505] = 9505,
  [9506] = 9506,
  [9507] = 9440,
  [9508] = 8787,
  [9509] = 9509,
  [9510] = 9510,
  [9511] = 9440,
  [9512] = 9440,
  [9513] = 9513,
  [9514] = 9440,
  [9515] = 9464,
  [9516] = 9440,
  [9517] = 9460,
  [9518] = 9440,
  [9519] = 9519,
  [9520] = 9520,
  [9521] = 9521,
  [9522] = 9463,
  [9523] = 9523,
  [9524] = 9524,
  [9525] = 8792,
  [9526] = 9526,
  [9527] = 9459,
  [9528] = 9528,
  [9529] = 9529,
  [9530] = 9449,
  [9531] = 9531,
  [9532] = 9532,
  [9533] = 9533,
  [9534] = 9534,
  [9535] = 9535,
  [9536] = 9440,
  [9537] = 9537,
  [9538] = 9538,
  [9539] = 9463,
  [9540] = 9540,
  [9541] = 9541,
  [9542] = 9542,
  [9543] = 9448,
  [9544] = 9440,
  [9545] = 9545,
  [9546] = 9546,
  [9547] = 9547,
  [9548] = 8751,
  [9549] = 9549,
  [9550] = 9550,
  [9551] = 8803,
  [9552] = 9552,
  [9553] = 9553,
  [9554] = 9441,
  [9555] = 9555,
  [9556] = 9556,
  [9557] = 9557,
  [9558] = 9558,
  [9559] = 9542,
  [9560] = 9450,
  [9561] = 9561,
  [9562] = 9562,
  [9563] = 9563,
  [9564] = 9564,
  [9565] = 9565,
  [9566] = 9460,
  [9567] = 9567,
  [9568] = 9568,
  [9569] = 9569,
  [9570] = 9570,
  [9571] = 9571,
  [9572] = 9572,
  [9573] = 9573,
  [9574] = 9414,
  [9575] = 9575,
  [9576] = 9576,
  [9577] = 9542,
  [9578] = 9578,
  [9579] = 9579,
  [9580] = 8818,
  [9581] = 9581,
  [9582] = 9524,
  [9583] = 9440,
  [9584] = 8823,
  [9585] = 9585,
  [9586] = 9586,
  [9587] = 9587,
  [9588] = 9588,
  [9589] = 9460,
  [9590] = 9590,
  [9591] = 9591,
  [9592] = 9592,
  [9593] = 9593,
  [9594] = 9594,
  [9595] = 9463,
  [9596] = 9596,
  [9597] = 9597,
  [9598] = 9598,
  [9599] = 9590,
  [9600] = 9600,
  [9601] = 9601,
  [9602] = 8681,
  [9603] = 9603,
  [9604] = 8680,
  [9605] = 9459,
  [9606] = 9450,
  [9607] = 9279,
  [9608] = 9608,
  [9609] = 9609,
  [9610] = 9610,
  [9611] = 9611,
  [9612] = 9612,
  [9613] = 8679,
  [9614] = 8678,
  [9615] = 9615,
  [9616] = 9616,
  [9617] = 9617,
  [9618] = 8843,
  [9619] = 9619,
  [9620] = 9620,
  [9621] = 9621,
  [9622] = 9622,
  [9623] = 9623,
  [9624] = 9624,
  [9625] = 9625,
  [9626] = 8844,
  [9627] = 9627,
  [9628] = 8851,
  [9629] = 9629,
  [9630] = 9630,
  [9631] = 8852,
  [9632] = 9632,
  [9633] = 9633,
  [9634] = 9593,
  [9635] = 9593,
  [9636] = 9636,
  [9637] = 9637,
  [9638] = 9638,
  [9639] = 9639,
  [9640] = 9640,
  [9641] = 9641,
  [9642] = 9642,
  [9643] = 9441,
  [9644] = 9644,
  [9645] = 9645,
  [9646] = 9646,
  [9647] = 9647,
  [9648] = 9648,
  [9649] = 9649,
  [9650] = 9650,
  [9651] = 9651,
  [9652] = 9450,
  [9653] = 9653,
  [9654] = 9654,
  [9655] = 9655,
  [9656] = 9656,
  [9657] = 9657,
  [9658] = 9195,
  [9659] = 9659,
  [9660] = 9660,
  [9661] = 8875,
  [9662] = 9662,
  [9663] = 9663,
  [9664] = 9664,
  [9665] = 9665,
  [9666] = 9666,
  [9667] = 9452,
  [9668] = 9460,
  [9669] = 9142,
  [9670] = 9670,
  [9671] = 9671,
  [9672] = 9459,
  [9673] = 9673,
  [9674] = 9674,
  [9675] = 9675,
  [9676] = 9676,
  [9677] = 9677,
  [9678] = 9678,
  [9679] = 9440,
  [9680] = 9680,
  [9681] = 9681,
  [9682] = 9682,
  [9683] = 9683,
  [9684] = 9524,
  [9685] = 9492,
  [9686] = 8877,
  [9687] = 9687,
  [9688] = 9603,
  [9689] = 8869,
  [9690] = 9451,
  [9691] = 9691,
  [9692] = 9692,
  [9693] = 9693,
  [9694] = 9694,
  [9695] = 9695,
  [9696] = 9696,
  [9697] = 8867,
  [9698] = 9463,
  [9699] = 9463,
  [9700] = 8865,
  [9701] = 9701,
  [9702] = 9471,
  [9703] = 9467,
  [9704] = 9704,
  [9705] = 9705,
  [9706] = 9662,
  [9707] = 9499,
  [9708] = 9640,
  [9709] = 9459,
  [9710] = 9710,
  [9711] = 9711,
  [9712] = 9712,
  [9713] = 9713,
  [9714] = 9603,
  [9715] = 9715,
  [9716] = 9048,
  [9717] = 9717,
  [9718] = 9715,
  [9719] = 9042,
  [9720] = 9720,
  [9721] = 9721,
  [9722] = 9722,
  [9723] = 9723,
  [9724] = 9724,
  [9725] = 9725,
  [9726] = 9460,
  [9727] = 9533,
  [9728] = 9440,
  [9729] = 9448,
  [9730] = 9031,
  [9731] = 9440,
  [9732] = 9561,
  [9733] = 9733,
  [9734] = 9450,
  [9735] = 8812,
  [9736] = 9736,
  [9737] = 9737,
  [9738] = 9738,
  [9739] = 9739,
  [9740] = 9740,
  [9741] = 9741,
  [9742] = 9742,
  [9743] = 8810,
  [9744] = 9744,
  [9745] = 9745,
  [9746] = 9746,
  [9747] = 8901,
  [9748] = 9748,
  [9749] = 9749,
  [9750] = 9750,
  [9751] = 9751,
  [9752] = 8808,
  [9753] = 8773,
  [9754] = 9754,
  [9755] = 9460,
  [9756] = 9756,
  [9757] = 9460,
  [9758] = 9758,
  [9759] = 9759,
  [9760] = 9760,
  [9761] = 9761,
  [9762] = 8784,
  [9763] = 8743,
  [9764] = 8737,
  [9765] = 8783,
  [9766] = 8728,
  [9767] = 8721,
  [9768] = 9768,
  [9769] = 9509,
  [9770] = 9450,
  [9771] = 9771,
  [9772] = 9445,
  [9773] = 9773,
  [9774] = 9492,
  [9775] = 9440,
  [9776] = 9776,
  [9777] = 9777,
  [9778] = 8699,
  [9779] = 9779,
  [9780] = 9780,
  [9781] = 9781,
  [9782] = 9621,
  [9783] = 8934,
  [9784] = 9784,
  [9785] = 9214,
  [9786] = 9786,
  [9787] = 9787,
  [9788] = 9788,
  [9789] = 9460,
  [9790] = 9790,
  [9791] = 9463,
  [9792] = 9650,
  [9793] = 9793,
  [9794] = 9794,
  [9795] = 9795,
  [9796] = 9796,
  [9797] = 9797,
  [9798] = 9520,
  [9799] = 9799,
  [9800] = 9459,
  [9801] = 9533,
  [9802] = 9437,
  [9803] = 9803,
  [9804] = 9804,
  [9805] = 9805,
  [9806] = 9797,
  [9807] = 8876,
  [9808] = 9808,
  [9809] = 9313,
  [9810] = 9810,
  [9811] = 9795,
  [9812] = 9812,
  [9813] = 9813,
  [9814] = 9814,
  [9815] = 9568,
  [9816] = 9269,
  [9817] = 9794,
  [9818] = 9818,
  [9819] = 9642,
  [9820] = 9452,
  [9821] = 9803,
  [9822] = 9459,
  [9823] = 9637,
  [9824] = 9824,
  [9825] = 9805,
  [9826] = 9826,
  [9827] = 9662,
  [9828] = 8834,
  [9829] = 8827,
  [9830] = 9450,
  [9831] = 9831,
  [9832] = 8822,
  [9833] = 9810,
  [9834] = 9616,
  [9835] = 9733,
  [9836] = 8967,
  [9837] = 9837,
  [9838] = 9460,
  [9839] = 9644,
  [9840] = 9840,
  [9841] = 9841,
  [9842] = 9842,
  [9843] = 8970,
  [9844] = 9463,
  [9845] = 8971,
  [9846] = 9846,
  [9847] = 9847,
  [9848] = 9848,
  [9849] = 8974,
  [9850] = 8854,
  [9851] = 9851,
  [9852] = 9852,
  [9853] = 9796,
  [9854] = 9696,
  [9855] = 8776,
  [9856] = 9856,
  [9857] = 9533,
  [9858] = 9858,
  [9859] = 9859,
  [9860] = 9860,
  [9861] = 9300,
  [9862] = 9812,
  [9863] = 9863,
  [9864] = 6649,
  [9865] = 9865,
  [9866] = 9866,
  [9867] = 9812,
  [9868] = 9440,
  [9869] = 9457,
  [9870] = 9870,
  [9871] = 9871,
  [9872] = 9872,
  [9873] = 9873,
  [9874] = 9252,
  [9875] = 9440,
  [9876] = 9876,
  [9877] = 9877,
  [9878] = 9878,
  [9879] = 9879,
  [9880] = 9880,
  [9881] = 9881,
  [9882] = 9882,
  [9883] = 9883,
  [9884] = 9884,
  [9885] = 9745,
  [9886] = 8988,
  [9887] = 9638,
  [9888] = 9877,
  [9889] = 9889,
  [9890] = 9710,
  [9891] = 9891,
  [9892] = 9892,
  [9893] = 9746,
  [9894] = 9894,
  [9895] = 9463,
  [9896] = 9562,
  [9897] = 9460,
  [9898] = 9711,
  [9899] = 9831,
  [9900] = 9813,
  [9901] = 9901,
  [9902] = 9446,
  [9903] = 9444,
  [9904] = 9904,
  [9905] = 9523,
  [9906] = 9906,
  [9907] = 9907,
  [9908] = 9558,
  [9909] = 9677,
  [9910] = 9450,
  [9911] = 9911,
  [9912] = 9459,
  [9913] = 9842,
  [9914] = 9914,
  [9915] = 9463,
  [9916] = 9720,
  [9917] = 9917,
  [9918] = 9550,
  [9919] = 9919,
  [9920] = 9674,
  [9921] = 9921,
  [9922] = 9922,
  [9923] = 9923,
  [9924] = 9924,
  [9925] = 9787,
  [9926] = 9858,
  [9927] = 9927,
  [9928] = 9202,
  [9929] = 9929,
  [9930] = 9930,
  [9931] = 9884,
  [9932] = 9932,
  [9933] = 9467,
  [9934] = 9934,
  [9935] = 9935,
  [9936] = 9936,
  [9937] = 9786,
  [9938] = 9938,
  [9939] = 9784,
  [9940] = 9940,
  [9941] = 9133,
  [9942] = 9483,
  [9943] = 9943,
  [9944] = 9944,
  [9945] = 9528,
  [9946] = 9443,
  [9947] = 9450,
  [9948] = 9948,
  [9949] = 9949,
  [9950] = 9773,
  [9951] = 9653,
  [9952] = 9671,
  [9953] = 8722,
  [9954] = 9860,
  [9955] = 9955,
  [9956] = 9459,
  [9957] = 9603,
  [9958] = 8724,
  [9959] = 9085,
  [9960] = 8725,
  [9961] = 9961,
  [9962] = 9083,
  [9963] = 9460,
  [9964] = 9250,
  [9965] = 9965,
  [9966] = 9966,
  [9967] = 9660,
  [9968] = 9526,
  [9969] = 9019,
  [9970] = 9970,
  [9971] = 9971,
  [9972] = 9450,
  [9973] = 9973,
  [9974] = 9463,
  [9975] = 9720,
  [9976] = 9976,
  [9977] = 9977,
  [9978] = 8734,
  [9979] = 9020,
  [9980] = 9980,
  [9981] = 9981,
  [9982] = 9949,
  [9983] = 9983,
  [9984] = 9894,
  [9985] = 9748,
  [9986] = 8995,
  [9987] = 9077,
  [9988] = 9988,
  [9989] = 9492,
  [9990] = 9990,
  [9991] = 9627,
  [9992] = 9440,
  [9993] = 9993,
  [9994] = 9532,
  [9995] = 9641,
  [9996] = 9996,
  [9997] = 9549,
  [9998] = 9998,
  [9999] = 9999,
  [10000] = 10000,
  [10001] = 10001,
  [10002] = 10002,
  [10003] = 9440,
  [10004] = 9556,
  [10005] = 9722,
  [10006] = 9737,
  [10007] = 9645,
  [10008] = 9638,
  [10009] = 10009,
  [10010] = 9891,
  [10011] = 9463,
  [10012] = 8762,
  [10013] = 8765,
  [10014] = 10014,
  [10015] = 10000,
  [10016] = 8990,
  [10017] = 9636,
  [10018] = 9459,
  [10019] = 9460,
  [10020] = 9450,
  [10021] = 10021,
  [10022] = 9647,
  [10023] = 10023,
  [10024] = 9535,
  [10025] = 8966,
  [10026] = 10026,
  [10027] = 9998,
  [10028] = 10028,
  [10029] = 9717,
  [10030] = 9392,
  [10031] = 10031,
  [10032] = 9450,
  [10033] = 10033,
  [10034] = 10034,
  [10035] = 10035,
  [10036] = 10034,
  [10037] = 9704,
  [10038] = 9565,
  [10039] = 8868,
  [10040] = 8961,
  [10041] = 8965,
  [10042] = 9754,
  [10043] = 10043,
  [10044] = 9435,
  [10045] = 10045,
  [10046] = 10028,
  [10047] = 10047,
  [10048] = 10048,
  [10049] = 9676,
  [10050] = 9450,
  [10051] = 10051,
  [10052] = 9621,
  [10053] = 10053,
  [10054] = 8953,
  [10055] = 9441,
  [10056] = 8952,
  [10057] = 8675,
  [10058] = 10058,
  [10059] = 9524,
  [10060] = 9460,
  [10061] = 10061,
  [10062] = 9662,
  [10063] = 10063,
  [10064] = 8998,
  [10065] = 9459,
  [10066] = 10066,
  [10067] = 9657,
  [10068] = 10068,
  [10069] = 9322,
  [10070] = 9627,
  [10071] = 9921,
  [10072] = 10072,
  [10073] = 10009,
  [10074] = 9440,
  [10075] = 10075,
  [10076] = 9737,
  [10077] = 9459,
  [10078] = 10078,
  [10079] = 10079,
  [10080] = 9624,
  [10081] = 9510,
  [10082] = 9924,
  [10083] = 9948,
  [10084] = 10084,
  [10085] = 10085,
  [10086] = 9463,
  [10087] = 10087,
  [10088] = 10084,
  [10089] = 9944,
  [10090] = 9624,
  [10091] = 9622,
  [10092] = 9399,
  [10093] = 10093,
  [10094] = 10094,
  [10095] = 9463,
  [10096] = 10096,
  [10097] = 9662,
  [10098] = 9397,
  [10099] = 10099,
  [10100] = 9177,
  [10101] = 9627,
  [10102] = 9940,
  [10103] = 9524,
  [10104] = 9459,
  [10105] = 10068,
  [10106] = 9932,
  [10107] = 9927,
  [10108] = 9917,
  [10109] = 9901,
  [10110] = 9394,
  [10111] = 10111,
  [10112] = 10075,
  [10113] = 9440,
  [10114] = 10114,
  [10115] = 10115,
  [10116] = 10116,
  [10117] = 9889,
  [10118] = 8976,
  [10119] = 9379,
  [10120] = 9977,
  [10121] = 9621,
  [10122] = 9364,
  [10123] = 9441,
  [10124] = 9695,
  [10125] = 9724,
  [10126] = 9450,
  [10127] = 9348,
  [10128] = 10128,
  [10129] = 9973,
  [10130] = 9460,
  [10131] = 9616,
  [10132] = 9756,
  [10133] = 10133,
  [10134] = 9552,
  [10135] = 10135,
  [10136] = 10136,
  [10137] = 10137,
  [10138] = 9760,
  [10139] = 9722,
  [10140] = 9460,
  [10141] = 9310,
  [10142] = 10142,
  [10143] = 9860,
  [10144] = 9866,
  [10145] = 9255,
  [10146] = 10146,
  [10147] = 9253,
  [10148] = 10148,
  [10149] = 10149,
  [10150] = 9810,
  [10151] = 9440,
  [10152] = 9450,
  [10153] = 8879,
  [10154] = 9930,
  [10155] = 8836,
  [10156] = 9929,
  [10157] = 10157,
  [10158] = 8801,
  [10159] = 10159,
  [10160] = 10160,
  [10161] = 9914,
  [10162] = 9176,
  [10163] = 9167,
  [10164] = 9463,
  [10165] = 9892,
  [10166] = 9166,
  [10167] = 10167,
  [10168] = 10136,
  [10169] = 10148,
  [10170] = 9459,
  [10171] = 8993,
  [10172] = 10172,
  [10173] = 9465,
  [10174] = 10174,
  [10175] = 8760,
  [10176] = 10176,
  [10177] = 9557,
  [10178] = 10142,
  [10179] = 9880,
  [10180] = 9005,
  [10181] = 9506,
  [10182] = 9502,
  [10183] = 10183,
  [10184] = 9502,
  [10185] = 9001,
  [10186] = 8736,
  [10187] = 8749,
  [10188] = 9499,
  [10189] = 10189,
  [10190] = 9712,
  [10191] = 9662,
  [10192] = 10192,
  [10193] = 8775,
  [10194] = 9459,
  [10195] = 9459,
  [10196] = 9524,
  [10197] = 9441,
  [10198] = 10061,
  [10199] = 8969,
  [10200] = 9682,
  [10201] = 9450,
  [10202] = 9450,
  [10203] = 10203,
  [10204] = 9452,
  [10205] = 9468,
  [10206] = 9759,
  [10207] = 8853,
  [10208] = 9463,
  [10209] = 8858,
  [10210] = 10210,
  [10211] = 9846,
  [10212] = 9847,
  [10213] = 9650,
  [10214] = 9440,
  [10215] = 9865,
  [10216] = 9970,
  [10217] = 10217,
  [10218] = 10218,
  [10219] = 9981,
  [10220] = 9993,
  [10221] = 9460,
  [10222] = 9999,
  [10223] = 9572,
  [10224] = 10001,
  [10225] = 10225,
  [10226] = 9863,
  [10227] = 10227,
  [10228] = 10228,
  [10229] = 10229,
  [10230] = 9871,
  [10231] = 9911,
  [10232] = 9955,
  [10233] = 9961,
  [10234] = 9965,
  [10235] = 9966,
  [10236] = 9852,
  [10237] = 9976,
  [10238] = 9980,
  [10239] = 10239,
  [10240] = 10240,
  [10241] = 10241,
  [10242] = 10242,
  [10243] = 10243,
  [10244] = 10244,
  [10245] = 9841,
  [10246] = 10246,
  [10247] = 10247,
  [10248] = 10248,
  [10249] = 10249,
  [10250] = 9990,
  [10251] = 10251,
  [10252] = 10252,
  [10253] = 10253,
  [10254] = 10254,
  [10255] = 10255,
  [10256] = 9740,
  [10257] = 10257,
  [10258] = 9848,
  [10259] = 10259,
  [10260] = 10260,
  [10261] = 10261,
  [10262] = 10262,
  [10263] = 10263,
  [10264] = 10264,
  [10265] = 10246,
  [10266] = 10253,
  [10267] = 10267,
  [10268] = 10268,
  [10269] = 10263,
  [10270] = 10270,
  [10271] = 10271,
  [10272] = 10272,
  [10273] = 10273,
  [10274] = 10274,
  [10275] = 10275,
  [10276] = 9681,
  [10277] = 10275,
  [10278] = 10278,
  [10279] = 10279,
  [10280] = 9654,
  [10281] = 10281,
  [10282] = 10282,
  [10283] = 10283,
  [10284] = 10284,
  [10285] = 10283,
  [10286] = 10286,
  [10287] = 10066,
  [10288] = 10284,
  [10289] = 10289,
  [10290] = 10282,
  [10291] = 10270,
  [10292] = 10292,
  [10293] = 10293,
  [10294] = 10294,
  [10295] = 10295,
  [10296] = 10281,
  [10297] = 10264,
  [10298] = 10298,
  [10299] = 10264,
  [10300] = 10300,
  [10301] = 10301,
  [10302] = 10302,
  [10303] = 10303,
  [10304] = 9496,
  [10305] = 9736,
  [10306] = 10306,
  [10307] = 10307,
  [10308] = 10308,
  [10309] = 9487,
  [10310] = 10160,
  [10311] = 10275,
  [10312] = 10284,
  [10313] = 10263,
  [10314] = 10314,
  [10315] = 10315,
  [10316] = 10253,
  [10317] = 10317,
  [10318] = 10116,
  [10319] = 10282,
  [10320] = 10078,
  [10321] = 10321,
  [10322] = 10014,
  [10323] = 7063,
  [10324] = 10244,
  [10325] = 10281,
  [10326] = 9611,
  [10327] = 10327,
  [10328] = 10227,
  [10329] = 10329,
  [10330] = 9907,
  [10331] = 10275,
  [10332] = 10332,
  [10333] = 10244,
  [10334] = 10334,
  [10335] = 9788,
  [10336] = 9906,
  [10337] = 10270,
  [10338] = 10338,
  [10339] = 9904,
  [10340] = 9768,
  [10341] = 9483,
  [10342] = 10342,
  [10343] = 10246,
  [10344] = 10344,
  [10345] = 10345,
  [10346] = 9881,
  [10347] = 9879,
  [10348] = 9824,
  [10349] = 9701,
  [10350] = 10350,
  [10351] = 10257,
  [10352] = 10352,
  [10353] = 10353,
  [10354] = 10354,
  [10355] = 10355,
  [10356] = 10356,
  [10357] = 10252,
  [10358] = 10358,
  [10359] = 10359,
  [10360] = 9751,
  [10361] = 9749,
  [10362] = 9744,
  [10363] = 9837,
  [10364] = 10364,
  [10365] = 9742,
  [10366] = 10252,
  [10367] = 10367,
  [10368] = 10368,
  [10369] = 10369,
  [10370] = 10370,
  [10371] = 10257,
  [10372] = 9741,
  [10373] = 9739,
  [10374] = 9738,
  [10375] = 10375,
  [10376] = 10376,
  [10377] = 10136,
  [10378] = 10246,
  [10379] = 10379,
  [10380] = 9725,
  [10381] = 10381,
  [10382] = 9723,
  [10383] = 10270,
  [10384] = 10355,
  [10385] = 10385,
  [10386] = 10386,
  [10387] = 10387,
  [10388] = 10388,
  [10389] = 10389,
  [10390] = 10390,
  [10391] = 10148,
  [10392] = 10392,
  [10393] = 10393,
  [10394] = 10281,
  [10395] = 10282,
  [10396] = 10396,
  [10397] = 10284,
  [10398] = 10398,
  [10399] = 10399,
  [10400] = 10400,
  [10401] = 10401,
  [10402] = 10402,
  [10403] = 10403,
  [10404] = 10404,
  [10405] = 9632,
  [10406] = 10406,
  [10407] = 10407,
  [10408] = 10408,
  [10409] = 10409,
  [10410] = 10264,
  [10411] = 10411,
  [10412] = 10412,
  [10413] = 10413,
  [10414] = 10414,
  [10415] = 10415,
  [10416] = 9465,
  [10417] = 10417,
  [10418] = 10418,
  [10419] = 9468,
  [10420] = 10420,
  [10421] = 9587,
  [10422] = 9977,
  [10423] = 9934,
  [10424] = 10275,
  [10425] = 10425,
  [10426] = 10263,
  [10427] = 10427,
  [10428] = 9943,
  [10429] = 10253,
  [10430] = 10430,
  [10431] = 10227,
  [10432] = 10432,
  [10433] = 10244,
  [10434] = 10283,
  [10435] = 10435,
  [10436] = 9541,
  [10437] = 10244,
  [10438] = 10438,
  [10439] = 10364,
  [10440] = 10440,
  [10441] = 10227,
  [10442] = 10442,
  [10443] = 9513,
  [10444] = 10353,
  [10445] = 10253,
  [10446] = 10263,
  [10447] = 10447,
  [10448] = 10448,
  [10449] = 9973,
  [10450] = 10450,
  [10451] = 9873,
  [10452] = 9776,
  [10453] = 10453,
  [10454] = 9971,
  [10455] = 9510,
  [10456] = 10456,
  [10457] = 10457,
  [10458] = 10227,
  [10459] = 10459,
  [10460] = 10460,
  [10461] = 10461,
  [10462] = 10462,
  [10463] = 10463,
  [10464] = 10142,
  [10465] = 10465,
  [10466] = 10466,
  [10467] = 9538,
  [10468] = 10468,
  [10469] = 10415,
  [10470] = 9804,
  [10471] = 10264,
  [10472] = 10432,
  [10473] = 10473,
  [10474] = 10474,
  [10475] = 10404,
  [10476] = 10476,
  [10477] = 10477,
  [10478] = 9882,
  [10479] = 10252,
  [10480] = 10480,
  [10481] = 10481,
  [10482] = 10275,
  [10483] = 10263,
  [10484] = 10257,
  [10485] = 9637,
  [10486] = 10396,
  [10487] = 10146,
  [10488] = 10253,
  [10489] = 10399,
  [10490] = 10192,
  [10491] = 10246,
  [10492] = 10284,
  [10493] = 10493,
  [10494] = 10189,
  [10495] = 10282,
  [10496] = 10270,
  [10497] = 10183,
  [10498] = 10281,
  [10499] = 10499,
  [10500] = 10500,
  [10501] = 10389,
  [10502] = 10385,
  [10503] = 10058,
  [10504] = 10403,
  [10505] = 10048,
  [10506] = 10390,
  [10507] = 10281,
  [10508] = 10282,
  [10509] = 10509,
  [10510] = 10284,
  [10511] = 10031,
  [10512] = 10512,
  [10513] = 10270,
  [10514] = 10244,
  [10515] = 10515,
  [10516] = 10033,
  [10517] = 10270,
  [10518] = 9694,
  [10519] = 9692,
  [10520] = 10047,
  [10521] = 10246,
  [10522] = 10522,
  [10523] = 10264,
  [10524] = 9629,
  [10525] = 9620,
  [10526] = 10526,
  [10527] = 7063,
  [10528] = 10528,
  [10529] = 10271,
  [10530] = 10530,
  [10531] = 10531,
  [10532] = 10257,
  [10533] = 9601,
  [10534] = 10359,
  [10535] = 10535,
  [10536] = 9600,
  [10537] = 10275,
  [10538] = 10246,
  [10539] = 10263,
  [10540] = 9760,
  [10541] = 9597,
  [10542] = 10253,
  [10543] = 10543,
  [10544] = 10386,
  [10545] = 10545,
  [10546] = 10252,
  [10547] = 10260,
  [10548] = 10548,
  [10549] = 10409,
  [10550] = 10244,
  [10551] = 10551,
  [10552] = 10411,
  [10553] = 9586,
  [10554] = 10227,
  [10555] = 10096,
  [10556] = 10556,
  [10557] = 10376,
  [10558] = 9570,
  [10559] = 10559,
  [10560] = 10289,
  [10561] = 10356,
  [10562] = 10562,
  [10563] = 10500,
  [10564] = 10352,
  [10565] = 10565,
  [10566] = 10283,
  [10567] = 10292,
  [10568] = 10499,
  [10569] = 10569,
  [10570] = 10570,
  [10571] = 10522,
  [10572] = 10530,
  [10573] = 10573,
  [10574] = 10565,
  [10575] = 10575,
  [10576] = 10576,
  [10577] = 10577,
  [10578] = 10283,
  [10579] = 10573,
  [10580] = 10580,
  [10581] = 10581,
  [10582] = 10582,
  [10583] = 9561,
  [10584] = 10584,
  [10585] = 10114,
  [10586] = 10586,
  [10587] = 10244,
  [10588] = 10217,
  [10589] = 10267,
  [10590] = 10590,
  [10591] = 10453,
  [10592] = 10252,
  [10593] = 10593,
  [10594] = 10594,
  [10595] = 10253,
  [10596] = 10596,
  [10597] = 10257,
  [10598] = 10263,
  [10599] = 10599,
  [10600] = 10275,
  [10601] = 10581,
  [10602] = 10602,
  [10603] = 10603,
  [10604] = 10246,
  [10605] = 10286,
  [10606] = 10606,
  [10607] = 9705,
  [10608] = 10608,
  [10609] = 10270,
  [10610] = 10569,
  [10611] = 10611,
  [10612] = 10612,
  [10613] = 9486,
  [10614] = 10264,
  [10615] = 9847,
  [10616] = 9453,
  [10617] = 10617,
  [10618] = 9846,
  [10619] = 10099,
  [10620] = 10281,
  [10621] = 10282,
  [10622] = 10622,
  [10623] = 10284,
  [10624] = 10624,
  [10625] = 10625,
  [10626] = 10350,
  [10627] = 10627,
  [10628] = 10584,
  [10629] = 10283,
  [10630] = 9944,
  [10631] = 10631,
  [10632] = 10632,
  [10633] = 10284,
  [10634] = 9610,
  [10635] = 10087,
  [10636] = 10264,
  [10637] = 9489,
  [10638] = 10638,
  [10639] = 10282,
  [10640] = 10281,
  [10641] = 10641,
  [10642] = 10642,
  [10643] = 10643,
  [10644] = 9519,
  [10645] = 10645,
  [10646] = 10281,
  [10647] = 10270,
  [10648] = 10227,
  [10649] = 10649,
  [10650] = 10275,
  [10651] = 10651,
  [10652] = 10263,
  [10653] = 10246,
  [10654] = 10654,
  [10655] = 10253,
  [10656] = 10590,
  [10657] = 10657,
  [10658] = 10658,
  [10659] = 10257,
  [10660] = 10594,
  [10661] = 10661,
  [10662] = 10662,
  [10663] = 10244,
  [10664] = 10664,
  [10665] = 10665,
  [10666] = 10252,
  [10667] = 10227,
  [10668] = 10668,
  [10669] = 10669,
  [10670] = 10670,
  [10671] = 10671,
  [10672] = 9537,
  [10673] = 9546,
  [10674] = 10596,
  [10675] = 10675,
  [10676] = 10676,
  [10677] = 9555,
  [10678] = 9567,
  [10679] = 10679,
  [10680] = 9923,
  [10681] = 10681,
  [10682] = 9876,
  [10683] = 10683,
  [10684] = 10684,
  [10685] = 9581,
  [10686] = 9596,
  [10687] = 10687,
  [10688] = 10688,
  [10689] = 10602,
  [10690] = 10690,
  [10691] = 10691,
  [10692] = 10354,
  [10693] = 10642,
  [10694] = 10387,
  [10695] = 10580,
  [10696] = 10227,
  [10697] = 10697,
  [10698] = 10698,
  [10699] = 9615,
  [10700] = 9617,
  [10701] = 9649,
  [10702] = 10393,
  [10703] = 10402,
  [10704] = 9665,
  [10705] = 10252,
  [10706] = 9981,
  [10707] = 10707,
  [10708] = 10662,
  [10709] = 9673,
  [10710] = 10257,
  [10711] = 9687,
  [10712] = 9691,
  [10713] = 10244,
  [10714] = 10714,
  [10715] = 10715,
  [10716] = 10302,
  [10717] = 10246,
  [10718] = 10412,
  [10719] = 10719,
  [10720] = 9713,
  [10721] = 10721,
  [10722] = 10270,
  [10723] = 10253,
  [10724] = 9758,
  [10725] = 10725,
  [10726] = 9750,
  [10727] = 10727,
  [10728] = 10263,
  [10729] = 10729,
  [10730] = 10730,
  [10731] = 10707,
  [10732] = 10732,
  [10733] = 10281,
  [10734] = 10282,
  [10735] = 10735,
  [10736] = 10284,
  [10737] = 10737,
  [10738] = 10275,
  [10739] = 10338,
  [10740] = 9630,
  [10741] = 10741,
  [10742] = 10342,
  [10743] = 10329,
  [10744] = 10744,
  [10745] = 10745,
  [10746] = 9790,
  [10747] = 10294,
  [10748] = 10748,
  [10749] = 10264,
  [10750] = 10283,
  [10751] = 10751,
  [10752] = 10412,
  [10753] = 10753,
  [10754] = 10293,
  [10755] = 10755,
  [10756] = 10756,
  [10757] = 9793,
  [10758] = 10387,
  [10759] = 10759,
  [10760] = 10264,
  [10761] = 9528,
  [10762] = 10279,
  [10763] = 10275,
  [10764] = 10764,
  [10765] = 10263,
  [10766] = 9526,
  [10767] = 9808,
  [10768] = 10253,
  [10769] = 10769,
  [10770] = 9840,
  [10771] = 9859,
  [10772] = 10772,
  [10773] = 10284,
  [10774] = 10735,
  [10775] = 10775,
  [10776] = 10244,
  [10777] = 10777,
  [10778] = 10282,
  [10779] = 10257,
  [10780] = 10227,
  [10781] = 10307,
  [10782] = 10306,
  [10783] = 10281,
  [10784] = 10784,
  [10785] = 10785,
  [10786] = 10786,
  [10787] = 10787,
  [10788] = 10596,
  [10789] = 9983,
  [10790] = 10790,
  [10791] = 10791,
  [10792] = 10584,
  [10793] = 10793,
  [10794] = 10002,
  [10795] = 10270,
  [10796] = 10581,
  [10797] = 10797,
  [10798] = 10283,
  [10799] = 10799,
  [10800] = 10051,
  [10801] = 10063,
  [10802] = 10246,
  [10803] = 10793,
  [10804] = 10252,
  [10805] = 10257,
  [10806] = 10714,
  [10807] = 10252,
  [10808] = 10808,
  [10809] = 10257,
  [10810] = 10072,
  [10811] = 10079,
  [10812] = 10812,
  [10813] = 10813,
  [10814] = 10814,
  [10815] = 10815,
  [10816] = 10246,
  [10817] = 10817,
  [10818] = 10818,
  [10819] = 10819,
  [10820] = 10820,
  [10821] = 10270,
  [10822] = 10111,
  [10823] = 10128,
  [10824] = 10824,
  [10825] = 10133,
  [10826] = 10159,
  [10827] = 10827,
  [10828] = 10167,
  [10829] = 10174,
  [10830] = 9592,
  [10831] = 10824,
  [10832] = 10281,
  [10833] = 10282,
  [10834] = 10818,
  [10835] = 10284,
  [10836] = 10836,
  [10837] = 10837,
  [10838] = 10345,
  [10839] = 10839,
  [10840] = 10799,
  [10841] = 10283,
  [10842] = 10085,
  [10843] = 10411,
  [10844] = 10844,
  [10845] = 10845,
  [10846] = 10283,
  [10847] = 10210,
  [10848] = 10264,
  [10849] = 9797,
  [10850] = 10850,
  [10851] = 10851,
  [10852] = 10045,
  [10853] = 10687,
  [10854] = 10854,
  [10855] = 10817,
  [10856] = 10334,
  [10857] = 10332,
  [10858] = 10786,
  [10859] = 10176,
  [10860] = 10625,
  [10861] = 10252,
  [10862] = 10275,
  [10863] = 10327,
  [10864] = 10263,
  [10865] = 10172,
  [10866] = 10283,
  [10867] = 10253,
  [10868] = 10671,
  [10869] = 10668,
  [10870] = 10157,
  [10871] = 9795,
  [10872] = 10149,
  [10873] = 9794,
  [10874] = 10874,
  [10875] = 10244,
  [10876] = 9505,
  [10877] = 10227,
  [10878] = 10631,
  [10879] = 10227,
  [10880] = 10880,
  [10881] = 10815,
  [10882] = 10882,
  [10883] = 10409,
  [10884] = 10359,
  [10885] = 10244,
  [10886] = 10137,
  [10887] = 10808,
  [10888] = 10115,
  [10889] = 10094,
  [10890] = 10753,
  [10891] = 10093,
  [10892] = 10892,
  [10893] = 9780,
  [10894] = 10283,
  [10895] = 10253,
  [10896] = 10896,
  [10897] = 10263,
  [10898] = 10275,
  [10899] = 10899,
  [10900] = 10900,
  [10901] = 10334,
  [10902] = 10035,
  [10903] = 10252,
  [10904] = 10332,
  [10905] = 10278,
  [10906] = 10262,
  [10907] = 10259,
  [10908] = 10257,
  [10909] = 10021,
  [10910] = 10910,
  [10911] = 10911,
  [10912] = 10327,
  [10913] = 10913,
  [10914] = 10914,
  [10915] = 10246,
  [10916] = 10916,
  [10917] = 10264,
  [10918] = 10918,
  [10919] = 10919,
  [10920] = 10270,
  [10921] = 10913,
  [10922] = 10922,
  [10923] = 10684,
  [10924] = 10924,
  [10925] = 9938,
  [10926] = 10919,
  [10927] = 10927,
  [10928] = 10284,
  [10929] = 10741,
  [10930] = 9936,
  [10931] = 10281,
  [10932] = 10282,
  [10933] = 9935,
  [10934] = 10284,
  [10935] = 10399,
  [10936] = 10790,
  [10937] = 10317,
  [10938] = 10282,
  [10939] = 10281,
  [10940] = 10442,
  [10941] = 9922,
  [10942] = 10415,
  [10943] = 10943,
  [10944] = 10315,
  [10945] = 10945,
  [10946] = 10946,
  [10947] = 10264,
  [10948] = 9919,
  [10949] = 9883,
  [10950] = 10396,
  [10951] = 9870,
  [10952] = 10952,
  [10953] = 10283,
  [10954] = 9856,
  [10955] = 10955,
  [10956] = 10956,
  [10957] = 10270,
  [10958] = 10958,
  [10959] = 10314,
  [10960] = 10732,
  [10961] = 10275,
  [10962] = 10246,
  [10963] = 10263,
  [10964] = 10714,
  [10965] = 10281,
  [10966] = 10253,
  [10967] = 9799,
  [10968] = 10968,
  [10969] = 10376,
  [10970] = 10970,
  [10971] = 10715,
  [10972] = 9779,
  [10973] = 10642,
  [10974] = 10244,
  [10975] = 10975,
  [10976] = 10274,
  [10977] = 10282,
  [10978] = 10227,
  [10979] = 9777,
  [10980] = 9771,
  [10981] = 9721,
  [10982] = 10982,
  [10983] = 10983,
  [10984] = 10257,
  [10985] = 10268,
  [10986] = 9712,
  [10987] = 10854,
  [10988] = 9639,
  [10989] = 9579,
  [10990] = 9576,
  [10991] = 10252,
  [10992] = 10632,
  [10993] = 10993,
  [10994] = 10994,
  [10995] = 10272,
  [10996] = 10996,
  [10997] = 10228,
  [10998] = 10998,
  [10999] = 10999,
  [11000] = 10283,
  [11001] = 11001,
  [11002] = 10252,
  [11003] = 11003,
  [11004] = 11004,
  [11005] = 11005,
  [11006] = 10914,
  [11007] = 10257,
  [11008] = 11008,
  [11009] = 10755,
  [11010] = 10756,
  [11011] = 9454,
  [11012] = 11012,
  [11013] = 9455,
  [11014] = 10246,
  [11015] = 11015,
  [11016] = 9458,
  [11017] = 9469,
  [11018] = 11018,
  [11019] = 10270,
  [11020] = 9478,
  [11021] = 9479,
  [11022] = 10643,
  [11023] = 11023,
  [11024] = 11024,
  [11025] = 10970,
  [11026] = 11026,
  [11027] = 11027,
  [11028] = 10854,
  [11029] = 11029,
  [11030] = 10281,
  [11031] = 10282,
  [11032] = 10473,
  [11033] = 10284,
  [11034] = 11034,
  [11035] = 9921,
  [11036] = 10407,
  [11037] = 11037,
  [11038] = 9529,
  [11039] = 11039,
  [11040] = 9531,
  [11041] = 11041,
  [11042] = 11042,
  [11043] = 9534,
  [11044] = 9545,
  [11045] = 9619,
  [11046] = 10264,
  [11047] = 9451,
  [11048] = 9553,
  [11049] = 11049,
  [11050] = 11050,
  [11051] = 11024,
  [11052] = 10283,
  [11053] = 10227,
  [11054] = 10641,
  [11055] = 11012,
  [11056] = 11056,
  [11057] = 9894,
  [11058] = 10257,
  [11059] = 9563,
  [11060] = 10275,
  [11061] = 9564,
  [11062] = 10263,
  [11063] = 9569,
  [11064] = 11064,
  [11065] = 10253,
  [11066] = 9571,
  [11067] = 10559,
  [11068] = 9573,
  [11069] = 9578,
  [11070] = 11070,
  [11071] = 11071,
  [11072] = 10408,
  [11073] = 10244,
  [11074] = 9696,
  [11075] = 10354,
  [11076] = 9562,
  [11077] = 10227,
  [11078] = 11078,
  [11079] = 11079,
  [11080] = 11080,
  [11081] = 11081,
  [11082] = 11082,
  [11083] = 10300,
  [11084] = 11084,
  [11085] = 11085,
  [11086] = 10535,
  [11087] = 10414,
  [11088] = 11088,
  [11089] = 11089,
  [11090] = 10892,
  [11091] = 10896,
  [11092] = 10252,
  [11093] = 10899,
  [11094] = 10321,
  [11095] = 10668,
  [11096] = 10910,
  [11097] = 10911,
  [11098] = 10745,
  [11099] = 11099,
  [11100] = 10918,
  [11101] = 10252,
  [11102] = 9585,
  [11103] = 10671,
  [11104] = 10927,
  [11105] = 10244,
  [11106] = 10257,
  [11107] = 9591,
  [11108] = 9594,
  [11109] = 9598,
  [11110] = 10301,
  [11111] = 10264,
  [11112] = 11112,
  [11113] = 10246,
  [11114] = 10943,
  [11115] = 10283,
  [11116] = 10956,
  [11117] = 10283,
  [11118] = 10270,
  [11119] = 10958,
  [11120] = 10968,
  [11121] = 10283,
  [11122] = 11122,
  [11123] = 9608,
  [11124] = 10882,
  [11125] = 10983,
  [11126] = 9609,
  [11127] = 9612,
  [11128] = 10284,
  [11129] = 10281,
  [11130] = 10282,
  [11131] = 10993,
  [11132] = 10284,
  [11133] = 10244,
  [11134] = 10797,
  [11135] = 10994,
  [11136] = 10264,
  [11137] = 10283,
  [11138] = 11138,
  [11139] = 10998,
  [11140] = 9623,
  [11141] = 10999,
  [11142] = 10264,
  [11143] = 10227,
  [11144] = 11144,
  [11145] = 10264,
  [11146] = 10244,
  [11147] = 10253,
  [11148] = 10263,
  [11149] = 10275,
  [11150] = 11026,
  [11151] = 10264,
  [11152] = 11152,
  [11153] = 10284,
  [11154] = 10282,
  [11155] = 10281,
  [11156] = 9625,
  [11157] = 11027,
  [11158] = 11158,
  [11159] = 10275,
  [11160] = 11160,
  [11161] = 10263,
  [11162] = 9633,
  [11163] = 10270,
  [11164] = 10253,
  [11165] = 9646,
  [11166] = 9648,
  [11167] = 11167,
  [11168] = 10246,
  [11169] = 9442,
  [11170] = 9655,
  [11171] = 10257,
  [11172] = 10244,
  [11173] = 9656,
  [11174] = 11174,
  [11175] = 11039,
  [11176] = 10227,
  [11177] = 11041,
  [11178] = 10676,
  [11179] = 10252,
  [11180] = 9659,
  [11181] = 9664,
  [11182] = 11078,
  [11183] = 11080,
  [11184] = 11081,
  [11185] = 9666,
  [11186] = 10227,
  [11187] = 11082,
  [11188] = 9675,
  [11189] = 11189,
  [11190] = 10244,
  [11191] = 11191,
  [11192] = 10253,
  [11193] = 10263,
  [11194] = 10275,
  [11195] = 10278,
  [11196] = 9678,
  [11197] = 9680,
  [11198] = 10252,
  [11199] = 10262,
  [11200] = 11174,
  [11201] = 11201,
  [11202] = 11202,
  [11203] = 10257,
  [11204] = 9683,
  [11205] = 11202,
  [11206] = 11189,
  [11207] = 10264,
  [11208] = 10259,
  [11209] = 11089,
  [11210] = 10246,
  [11211] = 11088,
  [11212] = 11079,
  [11213] = 10691,
  [11214] = 10282,
  [11215] = 10270,
  [11216] = 9651,
  [11217] = 10283,
  [11218] = 11003,
  [11219] = 10952,
  [11220] = 10576,
  [11221] = 10283,
  [11222] = 10284,
  [11223] = 11223,
  [11224] = 11224,
  [11225] = 11144,
  [11226] = 11226,
  [11227] = 11227,
  [11228] = 11224,
  [11229] = 10611,
  [11230] = 10608,
  [11231] = 10606,
  [11232] = 10586,
  [11233] = 10603,
  [11234] = 10295,
  [11235] = 10248,
  [11236] = 10251,
  [11237] = 11237,
  [11238] = 11238,
  [11239] = 11227,
  [11240] = 10254,
  [11241] = 10229,
  [11242] = 11242,
  [11243] = 10255,
  [11244] = 10261,
  [11245] = 10273,
  [11246] = 10617,
  [11247] = 10225,
  [11248] = 10764,
  [11249] = 10777,
  [11250] = 10784,
  [11251] = 10785,
  [11252] = 10787,
  [11253] = 10812,
  [11254] = 10813,
  [11255] = 10814,
  [11256] = 11223,
  [11257] = 11049,
  [11258] = 10298,
  [11259] = 9547,
  [11260] = 11034,
  [11261] = 11261,
  [11262] = 11029,
  [11263] = 11263,
  [11264] = 11152,
  [11265] = 11018,
  [11266] = 11008,
  [11267] = 10836,
  [11268] = 10819,
  [11269] = 11001,
  [11270] = 11270,
  [11271] = 11023,
  [11272] = 10996,
  [11273] = 11273,
  [11274] = 11274,
  [11275] = 10955,
  [11276] = 10946,
  [11277] = 10945,
  [11278] = 9670,
  [11279] = 10900,
  [11280] = 10880,
  [11281] = 10839,
  [11282] = 10837,
  [11283] = 10791,
  [11284] = 11037,
  [11285] = 10369,
  [11286] = 10459,
  [11287] = 11270,
  [11288] = 10460,
  [11289] = 11242,
  [11290] = 10461,
  [11291] = 10463,
  [11292] = 10466,
  [11293] = 10468,
  [11294] = 10474,
  [11295] = 10476,
  [11296] = 10480,
  [11297] = 11297,
  [11298] = 11298,
  [11299] = 10551,
  [11300] = 10575,
  [11301] = 6741,
  [11302] = 11099,
  [11303] = 11112,
  [11304] = 11237,
  [11305] = 10851,
  [11306] = 10844,
  [11307] = 10820,
  [11308] = 10772,
  [11309] = 10744,
  [11310] = 10737,
  [11311] = 10730,
  [11312] = 10729,
  [11313] = 10721,
  [11314] = 10698,
  [11315] = 10697,
  [11316] = 6759,
  [11317] = 10679,
  [11318] = 10670,
  [11319] = 10661,
  [11320] = 10638,
  [11321] = 11321,
  [11322] = 10627,
  [11323] = 10624,
  [11324] = 10548,
  [11325] = 10543,
  [11326] = 6766,
  [11327] = 10417,
  [11328] = 10413,
  [11329] = 11297,
  [11330] = 11330,
  [11331] = 10308,
  [11332] = 11332,
  [11333] = 10344,
  [11334] = 11237,
  [11335] = 11238,
  [11336] = 11227,
  [11337] = 10425,
  [11338] = 10427,
  [11339] = 10430,
  [11340] = 11340,
  [11341] = 10435,
  [11342] = 10448,
  [11343] = 10690,
  [11344] = 11344,
  [11345] = 10457,
  [11346] = 10456,
  [11347] = 11347,
  [11348] = 10465,
  [11349] = 10477,
  [11350] = 10481,
  [11351] = 10420,
  [11352] = 10493,
  [11353] = 10515,
  [11354] = 10545,
  [11355] = 11355,
  [11356] = 10570,
  [11357] = 10593,
  [11358] = 10775,
  [11359] = 10751,
  [11360] = 11270,
  [11361] = 11361,
  [11362] = 11362,
  [11363] = 11242,
  [11364] = 11085,
  [11365] = 11167,
  [11366] = 10688,
  [11367] = 10509,
  [11368] = 10438,
  [11369] = 10418,
  [11370] = 10398,
  [11371] = 10358,
  [11372] = 11372,
  [11373] = 10850,
  [11374] = 10450,
  [11375] = 11158,
  [11376] = 11201,
  [11377] = 10845,
  [11378] = 10462,
  [11379] = 10375,
  [11380] = 10381,
  [11381] = 11381,
  [11382] = 10401,
  [11383] = 11227,
  [11384] = 11242,
  [11385] = 10769,
  [11386] = 11238,
  [11387] = 10675,
  [11388] = 11237,
  [11389] = 10664,
  [11390] = 10658,
  [11391] = 11227,
  [11392] = 10654,
  [11393] = 11238,
  [11394] = 10651,
  [11395] = 10649,
  [11396] = 11396,
  [11397] = 11397,
  [11398] = 11398,
  [11399] = 11237,
  [11400] = 11238,
  [11401] = 11227,
  [11402] = 11402,
  [11403] = 10612,
  [11404] = 11404,
  [11405] = 11405,
  [11406] = 11406,
  [11407] = 11407,
  [11408] = 11408,
  [11409] = 11409,
  [11410] = 11410,
  [11411] = 11411,
  [11412] = 11412,
  [11413] = 11413,
  [11414] = 11414,
  [11415] = 11415,
  [11416] = 11416,
  [11417] = 11417,
  [11418] = 11418,
  [11419] = 11419,
  [11420] = 11420,
  [11421] = 11421,
  [11422] = 11422,
  [11423] = 11423,
  [11424] = 11424,
  [11425] = 11425,
  [11426] = 11426,
  [11427] = 11427,
  [11428] = 11428,
  [11429] = 11429,
  [11430] = 11430,
  [11431] = 11431,
  [11432] = 11242,
  [11433] = 11433,
  [11434] = 11434,
  [11435] = 11332,
  [11436] = 11436,
  [11437] = 11437,
  [11438] = 11438,
  [11439] = 11439,
  [11440] = 11440,
  [11441] = 11441,
  [11442] = 11442,
  [11443] = 11443,
  [11444] = 11237,
  [11445] = 11238,
  [11446] = 11227,
  [11447] = 11447,
  [11448] = 11442,
  [11449] = 11443,
  [11450] = 11450,
  [11451] = 11451,
  [11452] = 11442,
  [11453] = 11453,
  [11454] = 11454,
  [11455] = 11443,
  [11456] = 11456,
  [11457] = 11457,
  [11458] = 11451,
  [11459] = 11442,
  [11460] = 11460,
  [11461] = 11461,
  [11462] = 11443,
  [11463] = 11463,
  [11464] = 11464,
  [11465] = 11451,
  [11466] = 11442,
  [11467] = 11467,
  [11468] = 11468,
  [11469] = 11443,
  [11470] = 11470,
  [11471] = 11471,
  [11472] = 11472,
  [11473] = 11451,
  [11474] = 11442,
  [11475] = 11475,
  [11476] = 11476,
  [11477] = 11477,
  [11478] = 11443,
  [11479] = 11479,
  [11480] = 11480,
  [11481] = 11481,
  [11482] = 11482,
  [11483] = 11242,
  [11484] = 11484,
  [11485] = 11485,
  [11486] = 11486,
  [11487] = 11270,
  [11488] = 11488,
  [11489] = 11396,
  [11490] = 11397,
  [11491] = 11398,
  [11492] = 11404,
  [11493] = 11410,
  [11494] = 11419,
  [11495] = 11437,
  [11496] = 11479,
  [11497] = 11497,
  [11498] = 11498,
  [11499] = 11499,
  [11500] = 11500,
  [11501] = 11501,
  [11502] = 11502,
  [11503] = 11503,
  [11504] = 11504,
  [11505] = 11505,
  [11506] = 11506,
  [11507] = 11507,
  [11508] = 11508,
  [11509] = 11509,
  [11510] = 11297,
  [11511] = 11511,
  [11512] = 11512,
  [11513] = 11513,
  [11514] = 11514,
  [11515] = 11515,
  [11516] = 11516,
  [11517] = 11517,
  [11518] = 11499,
  [11519] = 11362,
  [11520] = 11381,
  [11521] = 11521,
  [11522] = 11522,
  [11523] = 11523,
  [11524] = 11524,
  [11525] = 11525,
  [11526] = 11526,
  [11527] = 11527,
  [11528] = 11528,
  [11529] = 11332,
  [11530] = 11530,
  [11531] = 11531,
  [11532] = 11532,
  [11533] = 11533,
  [11534] = 11534,
  [11535] = 11535,
  [11536] = 11451,
  [11537] = 11537,
  [11538] = 11538,
  [11539] = 11539,
  [11540] = 11540,
  [11541] = 11442,
  [11542] = 11542,
  [11543] = 11543,
  [11544] = 11544,
  [11545] = 11545,
  [11546] = 11546,
  [11547] = 11547,
  [11548] = 11548,
  [11549] = 11549,
  [11550] = 11227,
  [11551] = 11238,
  [11552] = 11237,
  [11553] = 11553,
  [11554] = 11443,
  [11555] = 11555,
  [11556] = 11556,
  [11557] = 11557,
  [11558] = 11558,
  [11559] = 11559,
  [11560] = 11560,
  [11561] = 11561,
  [11562] = 11562,
  [11563] = 11563,
  [11564] = 11564,
  [11565] = 11565,
  [11566] = 11566,
  [11567] = 11567,
  [11568] = 11568,
  [11569] = 11569,
  [11570] = 11570,
  [11571] = 11242,
  [11572] = 11270,
  [11573] = 11501,
  [11574] = 11574,
  [11575] = 11575,
  [11576] = 11576,
  [11577] = 11577,
  [11578] = 11578,
  [11579] = 11579,
  [11580] = 11580,
  [11581] = 11544,
  [11582] = 11582,
  [11583] = 11583,
  [11584] = 11584,
  [11585] = 11585,
  [11586] = 11586,
  [11587] = 11587,
  [11588] = 11588,
  [11589] = 11263,
  [11590] = 11590,
  [11591] = 11591,
  [11592] = 11443,
  [11593] = 11593,
  [11594] = 11344,
  [11595] = 11355,
  [11596] = 11596,
  [11597] = 11270,
  [11598] = 11242,
  [11599] = 11424,
  [11600] = 11600,
  [11601] = 11601,
  [11602] = 11588,
  [11603] = 11372,
  [11604] = 11604,
  [11605] = 11604,
  [11606] = 11606,
  [11607] = 11606,
  [11608] = 11608,
  [11609] = 11608,
  [11610] = 11560,
  [11611] = 11611,
  [11612] = 11612,
  [11613] = 11613,
  [11614] = 11614,
  [11615] = 11615,
  [11616] = 11616,
  [11617] = 11617,
  [11618] = 11618,
  [11619] = 11506,
  [11620] = 11620,
  [11621] = 11621,
  [11622] = 11622,
  [11623] = 11623,
  [11624] = 11546,
  [11625] = 11625,
  [11626] = 11626,
  [11627] = 11627,
  [11628] = 11628,
  [11629] = 11629,
  [11630] = 11237,
  [11631] = 11238,
  [11632] = 11227,
  [11633] = 11568,
  [11634] = 11273,
  [11635] = 11321,
  [11636] = 11600,
  [11637] = 11637,
  [11638] = 11638,
  [11639] = 11639,
  [11640] = 11640,
  [11641] = 11641,
  [11642] = 11642,
  [11643] = 11643,
  [11644] = 11644,
  [11645] = 11645,
  [11646] = 11646,
  [11647] = 11647,
  [11648] = 11648,
  [11649] = 11649,
  [11650] = 11650,
  [11651] = 11651,
  [11652] = 11652,
  [11653] = 11653,
  [11654] = 11654,
  [11655] = 11655,
  [11656] = 11656,
  [11657] = 11657,
  [11658] = 11227,
  [11659] = 11659,
  [11660] = 11660,
  [11661] = 11238,
  [11662] = 11237,
  [11663] = 11663,
  [11664] = 11664,
  [11665] = 11665,
  [11666] = 11666,
  [11667] = 11667,
  [11668] = 11668,
  [11669] = 11669,
  [11670] = 11670,
  [11671] = 11671,
  [11672] = 11672,
  [11673] = 11673,
  [11674] = 11645,
  [11675] = 11637,
  [11676] = 11226,
  [11677] = 11613,
  [11678] = 11593,
  [11679] = 11590,
  [11680] = 11680,
  [11681] = 11242,
  [11682] = 11270,
  [11683] = 11673,
  [11684] = 11585,
  [11685] = 11685,
  [11686] = 11582,
  [11687] = 11601,
  [11688] = 11578,
  [11689] = 11577,
  [11690] = 11575,
  [11691] = 11402,
  [11692] = 11584,
  [11693] = 11405,
  [11694] = 11611,
  [11695] = 11411,
  [11696] = 11556,
  [11697] = 11420,
  [11698] = 11555,
  [11699] = 11548,
  [11700] = 11542,
  [11701] = 11439,
  [11702] = 11440,
  [11703] = 11672,
  [11704] = 11540,
  [11705] = 11538,
  [11706] = 11482,
  [11707] = 11485,
  [11708] = 11708,
  [11709] = 11533,
  [11710] = 11532,
  [11711] = 11436,
  [11712] = 11531,
  [11713] = 11477,
  [11714] = 11527,
  [11715] = 11525,
  [11716] = 11531,
  [11717] = 11525,
  [11718] = 11524,
  [11719] = 11600,
  [11720] = 11523,
  [11721] = 11535,
  [11722] = 11502,
  [11723] = 11475,
  [11724] = 11612,
  [11725] = 11497,
  [11726] = 11671,
  [11727] = 11601,
  [11728] = 11584,
  [11729] = 11729,
  [11730] = 11730,
  [11731] = 11486,
  [11732] = 11485,
  [11733] = 11484,
  [11734] = 11482,
  [11735] = 11480,
  [11736] = 11453,
  [11737] = 11737,
  [11738] = 11423,
  [11739] = 11270,
  [11740] = 11441,
  [11741] = 11440,
  [11742] = 11227,
  [11743] = 11238,
  [11744] = 11237,
  [11745] = 11439,
  [11746] = 11746,
  [11747] = 11438,
  [11748] = 11642,
  [11749] = 11670,
  [11750] = 11737,
  [11751] = 11668,
  [11752] = 11667,
  [11753] = 11425,
  [11754] = 11574,
  [11755] = 11414,
  [11756] = 11413,
  [11757] = 11412,
  [11758] = 11411,
  [11759] = 11406,
  [11760] = 11646,
  [11761] = 11405,
  [11762] = 11762,
  [11763] = 11668,
  [11764] = 11421,
  [11765] = 11526,
  [11766] = 11402,
  [11767] = 11767,
  [11768] = 11667,
  [11769] = 11528,
  [11770] = 11770,
  [11771] = 11653,
  [11772] = 11666,
  [11773] = 11773,
  [11774] = 11242,
  [11775] = 11644,
  [11776] = 11372,
  [11777] = 11420,
  [11778] = 11685,
  [11779] = 11521,
  [11780] = 11780,
  [11781] = 11270,
  [11782] = 11782,
  [11783] = 11273,
  [11784] = 11242,
  [11785] = 11614,
  [11786] = 11786,
  [11787] = 11526,
  [11788] = 11528,
  [11789] = 11625,
  [11790] = 11237,
  [11791] = 11238,
  [11792] = 11227,
  [11793] = 11793,
  [11794] = 11614,
  [11795] = 11274,
  [11796] = 11796,
  [11797] = 11361,
  [11798] = 11586,
  [11799] = 11372,
  [11800] = 11786,
  [11801] = 11660,
  [11802] = 11355,
  [11803] = 11270,
  [11804] = 11340,
  [11805] = 11242,
  [11806] = 11442,
  [11807] = 11544,
  [11808] = 11544,
  [11809] = 11544,
  [11810] = 11659,
  [11811] = 11666,
  [11812] = 11583,
  [11813] = 11746,
  [11814] = 11544,
  [11815] = 11782,
  [11816] = 11737,
  [11817] = 11544,
  [11818] = 11657,
  [11819] = 11611,
  [11820] = 11237,
  [11821] = 11238,
  [11822] = 11645,
  [11823] = 11227,
  [11824] = 11587,
  [11825] = 11544,
  [11826] = 11637,
  [11827] = 11226,
  [11828] = 11362,
  [11829] = 11611,
  [11830] = 11596,
  [11831] = 11544,
  [11832] = 11362,
  [11833] = 11611,
  [11834] = 11656,
  [11835] = 11544,
  [11836] = 11362,
  [11837] = 11611,
  [11838] = 11838,
  [11839] = 11839,
  [11840] = 11840,
  [11841] = 11841,
  [11842] = 11842,
  [11843] = 11227,
  [11844] = 11238,
  [11845] = 11237,
  [11846] = 11270,
  [11847] = 11242,
  [11848] = 11848,
  [11849] = 11685,
  [11850] = 11544,
  [11851] = 11362,
  [11852] = 11611,
  [11853] = 11237,
  [11854] = 11238,
  [11855] = 11227,
  [11856] = 11582,
  [11857] = 11793,
  [11858] = 11578,
  [11859] = 11576,
  [11860] = 11575,
  [11861] = 11544,
  [11862] = 11862,
  [11863] = 11362,
  [11864] = 11611,
  [11865] = 11544,
  [11866] = 11556,
  [11867] = 11555,
  [11868] = 11548,
  [11869] = 11729,
  [11870] = 11362,
  [11871] = 11871,
  [11872] = 11611,
  [11873] = 11873,
  [11874] = 11730,
  [11875] = 11653,
  [11876] = 11651,
  [11877] = 11270,
  [11878] = 11242,
  [11879] = 11242,
  [11880] = 11638,
  [11881] = 11532,
  [11882] = 11544,
  [11883] = 11527,
  [11884] = 11270,
  [11885] = 11523,
  [11886] = 11639,
  [11887] = 11362,
  [11888] = 11650,
  [11889] = 11502,
  [11890] = 11622,
  [11891] = 11475,
  [11892] = 11537,
  [11893] = 11611,
  [11894] = 11623,
  [11895] = 11544,
  [11896] = 11362,
  [11897] = 11237,
  [11898] = 11238,
  [11899] = 11227,
  [11900] = 11486,
  [11901] = 11611,
  [11902] = 11484,
  [11903] = 11544,
  [11904] = 11362,
  [11905] = 11611,
  [11906] = 11767,
  [11907] = 11453,
  [11908] = 11649,
  [11909] = 11544,
  [11910] = 11362,
  [11911] = 11447,
  [11912] = 11576,
  [11913] = 11441,
  [11914] = 11746,
  [11915] = 11762,
  [11916] = 11647,
  [11917] = 11762,
  [11918] = 11646,
  [11919] = 11919,
  [11920] = 11436,
  [11921] = 11425,
  [11922] = 11922,
  [11923] = 11611,
  [11924] = 11270,
  [11925] = 11925,
  [11926] = 11652,
  [11927] = 11242,
  [11928] = 11644,
  [11929] = 11544,
  [11930] = 11362,
  [11931] = 11576,
  [11932] = 11746,
  [11933] = 11762,
  [11934] = 11237,
  [11935] = 11238,
  [11936] = 11680,
  [11937] = 11436,
  [11938] = 11227,
  [11939] = 11611,
  [11940] = 11652,
  [11941] = 11544,
  [11942] = 11362,
  [11943] = 11576,
  [11944] = 11746,
  [11945] = 11762,
  [11946] = 11436,
  [11947] = 11611,
  [11948] = 11451,
  [11949] = 11530,
  [11950] = 11629,
  [11951] = 11652,
  [11952] = 11544,
  [11953] = 11362,
  [11954] = 11576,
  [11955] = 11227,
  [11956] = 11238,
  [11957] = 11237,
  [11958] = 11746,
  [11959] = 11762,
  [11960] = 11270,
  [11961] = 11242,
  [11962] = 11962,
  [11963] = 11436,
  [11964] = 11611,
  [11965] = 11652,
  [11966] = 11237,
  [11967] = 11238,
  [11968] = 11227,
  [11969] = 11544,
  [11970] = 11381,
  [11971] = 11362,
  [11972] = 11576,
  [11973] = 11746,
  [11974] = 11640,
  [11975] = 11762,
  [11976] = 11436,
  [11977] = 11611,
  [11978] = 11242,
  [11979] = 11270,
  [11980] = 11652,
  [11981] = 11544,
  [11982] = 11381,
  [11983] = 11362,
  [11984] = 11576,
  [11985] = 11642,
  [11986] = 11746,
  [11987] = 11762,
  [11988] = 11436,
  [11989] = 11611,
  [11990] = 11652,
  [11991] = 11270,
  [11992] = 11521,
  [11993] = 11242,
  [11994] = 11583,
  [11995] = 11995,
  [11996] = 11330,
  [11997] = 11544,
  [11998] = 11381,
  [11999] = 11362,
  [12000] = 11625,
  [12001] = 11237,
  [12002] = 11238,
  [12003] = 11227,
  [12004] = 11626,
  [12005] = 11652,
  [12006] = 11534,
  [12007] = 11627,
  [12008] = 12008,
  [12009] = 11270,
  [12010] = 11242,
  [12011] = 12011,
  [12012] = 11298,
  [12013] = 11628,
  [12014] = 11641,
  [12015] = 11238,
  [12016] = 11237,
  [12017] = 11669,
  [12018] = 12018,
  [12019] = 12019,
  [12020] = 12020,
  [12021] = 12021,
  [12022] = 12022,
  [12023] = 12023,
  [12024] = 12024,
  [12025] = 12025,
  [12026] = 12026,
  [12027] = 12027,
  [12028] = 12028,
  [12029] = 12029,
  [12030] = 12030,
  [12031] = 12031,
  [12032] = 12032,
  [12033] = 12033,
  [12034] = 12034,
  [12035] = 12035,
  [12036] = 12036,
  [12037] = 12037,
  [12038] = 12038,
  [12039] = 12039,
  [12040] = 12040,
  [12041] = 12041,
  [12042] = 12042,
  [12043] = 12043,
  [12044] = 12044,
  [12045] = 12045,
  [12046] = 12046,
  [12047] = 12047,
  [12048] = 12048,
  [12049] = 12049,
  [12050] = 12050,
  [12051] = 12051,
  [12052] = 12052,
  [12053] = 12053,
  [12054] = 12054,
  [12055] = 12055,
  [12056] = 12019,
  [12057] = 12057,
  [12058] = 12058,
  [12059] = 12059,
  [12060] = 12060,
  [12061] = 12061,
  [12062] = 12062,
  [12063] = 12063,
  [12064] = 12064,
  [12065] = 12065,
  [12066] = 12066,
  [12067] = 12067,
  [12068] = 12068,
  [12069] = 12069,
  [12070] = 12070,
  [12071] = 12071,
  [12072] = 12072,
  [12073] = 12034,
  [12074] = 12074,
  [12075] = 12075,
  [12076] = 12076,
  [12077] = 12077,
  [12078] = 12078,
  [12079] = 12079,
  [12080] = 12080,
  [12081] = 12081,
  [12082] = 12082,
  [12083] = 12083,
  [12084] = 12084,
  [12085] = 12085,
  [12086] = 12086,
  [12087] = 12087,
  [12088] = 12087,
  [12089] = 12069,
  [12090] = 12046,
  [12091] = 12086,
  [12092] = 12092,
  [12093] = 12093,
  [12094] = 12045,
  [12095] = 12039,
  [12096] = 12036,
  [12097] = 12097,
  [12098] = 12020,
  [12099] = 12021,
  [12100] = 12100,
  [12101] = 12101,
  [12102] = 12022,
  [12103] = 12084,
  [12104] = 12023,
  [12105] = 12024,
  [12106] = 12083,
  [12107] = 12107,
  [12108] = 12108,
  [12109] = 12082,
  [12110] = 12025,
  [12111] = 12026,
  [12112] = 12027,
  [12113] = 12028,
  [12114] = 12030,
  [12115] = 12115,
  [12116] = 12081,
  [12117] = 12032,
  [12118] = 12033,
  [12119] = 12119,
  [12120] = 12120,
  [12121] = 12080,
  [12122] = 12079,
  [12123] = 12078,
  [12124] = 12035,
  [12125] = 12038,
  [12126] = 12075,
  [12127] = 12063,
  [12128] = 12128,
  [12129] = 12129,
  [12130] = 12130,
  [12131] = 12041,
  [12132] = 12132,
  [12133] = 12133,
  [12134] = 12070,
  [12135] = 12135,
  [12136] = 12136,
  [12137] = 12137,
  [12138] = 12138,
  [12139] = 12044,
  [12140] = 12140,
  [12141] = 12141,
  [12142] = 12068,
  [12143] = 12143,
  [12144] = 12067,
  [12145] = 12145,
  [12146] = 12146,
  [12147] = 12147,
  [12148] = 12148,
  [12149] = 12149,
  [12150] = 12018,
  [12151] = 12151,
  [12152] = 12152,
  [12153] = 12153,
  [12154] = 12065,
  [12155] = 12155,
  [12156] = 12156,
  [12157] = 12157,
  [12158] = 12100,
  [12159] = 12159,
  [12160] = 12160,
  [12161] = 12161,
  [12162] = 12162,
  [12163] = 12163,
  [12164] = 12164,
  [12165] = 12165,
  [12166] = 12055,
  [12167] = 12167,
  [12168] = 12115,
  [12169] = 12165,
  [12170] = 12052,
  [12171] = 12062,
  [12172] = 12164,
  [12173] = 12054,
  [12174] = 12174,
  [12175] = 12175,
  [12176] = 12176,
  [12177] = 12177,
  [12178] = 12178,
  [12179] = 12179,
  [12180] = 12022,
  [12181] = 12019,
  [12182] = 12060,
  [12183] = 12183,
  [12184] = 12058,
  [12185] = 12163,
  [12186] = 12162,
  [12187] = 12060,
  [12188] = 12161,
  [12189] = 12189,
  [12190] = 12190,
  [12191] = 12191,
  [12192] = 12192,
  [12193] = 12062,
  [12194] = 12058,
  [12195] = 12063,
  [12196] = 12065,
  [12197] = 12197,
  [12198] = 12160,
  [12199] = 12159,
  [12200] = 12200,
  [12201] = 12201,
  [12202] = 12202,
  [12203] = 12019,
  [12204] = 12067,
  [12205] = 12068,
  [12206] = 12206,
  [12207] = 12055,
  [12208] = 12208,
  [12209] = 12054,
  [12210] = 12210,
  [12211] = 12211,
  [12212] = 12157,
  [12213] = 12156,
  [12214] = 12070,
  [12215] = 12155,
  [12216] = 12216,
  [12217] = 12052,
  [12218] = 12218,
  [12219] = 12034,
  [12220] = 12075,
  [12221] = 12078,
  [12222] = 12153,
  [12223] = 12130,
  [12224] = 12152,
  [12225] = 12225,
  [12226] = 12079,
  [12227] = 12080,
  [12228] = 12140,
  [12229] = 12141,
  [12230] = 12151,
  [12231] = 12018,
  [12232] = 12081,
  [12233] = 12149,
  [12234] = 12146,
  [12235] = 12147,
  [12236] = 12148,
  [12237] = 12149,
  [12238] = 12018,
  [12239] = 12151,
  [12240] = 12152,
  [12241] = 12153,
  [12242] = 12082,
  [12243] = 12155,
  [12244] = 12156,
  [12245] = 12157,
  [12246] = 12100,
  [12247] = 12159,
  [12248] = 12160,
  [12249] = 12161,
  [12250] = 12162,
  [12251] = 12163,
  [12252] = 12164,
  [12253] = 12165,
  [12254] = 12083,
  [12255] = 12084,
  [12256] = 12256,
  [12257] = 12148,
  [12258] = 12258,
  [12259] = 12259,
  [12260] = 12147,
  [12261] = 12086,
  [12262] = 12174,
  [12263] = 12175,
  [12264] = 12176,
  [12265] = 12177,
  [12266] = 12178,
  [12267] = 12179,
  [12268] = 12087,
  [12269] = 12069,
  [12270] = 12044,
  [12271] = 12046,
  [12272] = 12146,
  [12273] = 12045,
  [12274] = 12039,
  [12275] = 12275,
  [12276] = 12189,
  [12277] = 12190,
  [12278] = 12191,
  [12279] = 12192,
  [12280] = 12036,
  [12281] = 12281,
  [12282] = 12097,
  [12283] = 12020,
  [12284] = 12197,
  [12285] = 12021,
  [12286] = 12035,
  [12287] = 12200,
  [12288] = 12201,
  [12289] = 12202,
  [12290] = 12022,
  [12291] = 12190,
  [12292] = 12023,
  [12293] = 12206,
  [12294] = 12024,
  [12295] = 12208,
  [12296] = 12296,
  [12297] = 12210,
  [12298] = 12211,
  [12299] = 12299,
  [12300] = 12300,
  [12301] = 12038,
  [12302] = 12035,
  [12303] = 12033,
  [12304] = 12304,
  [12305] = 12032,
  [12306] = 12130,
  [12307] = 12038,
  [12308] = 12025,
  [12309] = 12026,
  [12310] = 12140,
  [12311] = 12141,
  [12312] = 12027,
  [12313] = 12313,
  [12314] = 12028,
  [12315] = 12030,
  [12316] = 12146,
  [12317] = 12147,
  [12318] = 12148,
  [12319] = 12149,
  [12320] = 12018,
  [12321] = 12151,
  [12322] = 12152,
  [12323] = 12153,
  [12324] = 12115,
  [12325] = 12155,
  [12326] = 12156,
  [12327] = 12157,
  [12328] = 12100,
  [12329] = 12159,
  [12330] = 12160,
  [12331] = 12161,
  [12332] = 12162,
  [12333] = 12163,
  [12334] = 12164,
  [12335] = 12165,
  [12336] = 12032,
  [12337] = 12033,
  [12338] = 12115,
  [12339] = 12035,
  [12340] = 12038,
  [12341] = 12030,
  [12342] = 12084,
  [12343] = 12083,
  [12344] = 12174,
  [12345] = 12175,
  [12346] = 12176,
  [12347] = 12177,
  [12348] = 12178,
  [12349] = 12179,
  [12350] = 12082,
  [12351] = 12041,
  [12352] = 12352,
  [12353] = 12028,
  [12354] = 12044,
  [12355] = 12027,
  [12356] = 12026,
  [12357] = 12357,
  [12358] = 12189,
  [12359] = 12190,
  [12360] = 12191,
  [12361] = 12192,
  [12362] = 12081,
  [12363] = 12025,
  [12364] = 12364,
  [12365] = 12365,
  [12366] = 12197,
  [12367] = 12367,
  [12368] = 12080,
  [12369] = 12200,
  [12370] = 12201,
  [12371] = 12202,
  [12372] = 12372,
  [12373] = 12079,
  [12374] = 12078,
  [12375] = 12206,
  [12376] = 12075,
  [12377] = 12208,
  [12378] = 12378,
  [12379] = 12210,
  [12380] = 12211,
  [12381] = 12024,
  [12382] = 12023,
  [12383] = 12034,
  [12384] = 12070,
  [12385] = 12052,
  [12386] = 12189,
  [12387] = 12130,
  [12388] = 12141,
  [12389] = 12140,
  [12390] = 12054,
  [12391] = 12055,
  [12392] = 12392,
  [12393] = 12019,
  [12394] = 12394,
  [12395] = 12146,
  [12396] = 12147,
  [12397] = 12148,
  [12398] = 12149,
  [12399] = 12018,
  [12400] = 12151,
  [12401] = 12152,
  [12402] = 12153,
  [12403] = 12058,
  [12404] = 12155,
  [12405] = 12156,
  [12406] = 12157,
  [12407] = 12100,
  [12408] = 12159,
  [12409] = 12160,
  [12410] = 12161,
  [12411] = 12162,
  [12412] = 12163,
  [12413] = 12164,
  [12414] = 12165,
  [12415] = 12070,
  [12416] = 12060,
  [12417] = 12417,
  [12418] = 12021,
  [12419] = 12062,
  [12420] = 12420,
  [12421] = 12063,
  [12422] = 12065,
  [12423] = 12174,
  [12424] = 12175,
  [12425] = 12176,
  [12426] = 12177,
  [12427] = 12178,
  [12428] = 12179,
  [12429] = 12067,
  [12430] = 12068,
  [12431] = 12020,
  [12432] = 12191,
  [12433] = 12433,
  [12434] = 12034,
  [12435] = 12075,
  [12436] = 12189,
  [12437] = 12190,
  [12438] = 12191,
  [12439] = 12192,
  [12440] = 12078,
  [12441] = 12097,
  [12442] = 12079,
  [12443] = 12080,
  [12444] = 12081,
  [12445] = 12200,
  [12446] = 12201,
  [12447] = 12202,
  [12448] = 12036,
  [12449] = 12082,
  [12450] = 12083,
  [12451] = 12208,
  [12452] = 12039,
  [12453] = 12453,
  [12454] = 12045,
  [12455] = 12084,
  [12456] = 12456,
  [12457] = 12086,
  [12458] = 12458,
  [12459] = 12130,
  [12460] = 12087,
  [12461] = 12461,
  [12462] = 12069,
  [12463] = 12463,
  [12464] = 12464,
  [12465] = 12046,
  [12466] = 12045,
  [12467] = 12146,
  [12468] = 12147,
  [12469] = 12148,
  [12470] = 12149,
  [12471] = 12018,
  [12472] = 12151,
  [12473] = 12152,
  [12474] = 12153,
  [12475] = 12039,
  [12476] = 12155,
  [12477] = 12156,
  [12478] = 12157,
  [12479] = 12100,
  [12480] = 12159,
  [12481] = 12160,
  [12482] = 12161,
  [12483] = 12162,
  [12484] = 12163,
  [12485] = 12164,
  [12486] = 12165,
  [12487] = 12036,
  [12488] = 12097,
  [12489] = 12046,
  [12490] = 12020,
  [12491] = 12021,
  [12492] = 12069,
  [12493] = 12022,
  [12494] = 12023,
  [12495] = 12174,
  [12496] = 12175,
  [12497] = 12176,
  [12498] = 12177,
  [12499] = 12178,
  [12500] = 12179,
  [12501] = 12024,
  [12502] = 12087,
  [12503] = 12086,
  [12504] = 12084,
  [12505] = 12083,
  [12506] = 12025,
  [12507] = 12026,
  [12508] = 12189,
  [12509] = 12190,
  [12510] = 12191,
  [12511] = 12192,
  [12512] = 12027,
  [12513] = 12513,
  [12514] = 12028,
  [12515] = 12192,
  [12516] = 12030,
  [12517] = 12200,
  [12518] = 12201,
  [12519] = 12202,
  [12520] = 12520,
  [12521] = 12115,
  [12522] = 12032,
  [12523] = 12208,
  [12524] = 12524,
  [12525] = 12525,
  [12526] = 12526,
  [12527] = 12033,
  [12528] = 12035,
  [12529] = 12038,
  [12530] = 12530,
  [12531] = 12130,
  [12532] = 12532,
  [12533] = 12533,
  [12534] = 12534,
  [12535] = 12535,
  [12536] = 12082,
  [12537] = 12537,
  [12538] = 12041,
  [12539] = 12146,
  [12540] = 12147,
  [12541] = 12148,
  [12542] = 12149,
  [12543] = 12018,
  [12544] = 12151,
  [12545] = 12152,
  [12546] = 12153,
  [12547] = 12083,
  [12548] = 12155,
  [12549] = 12156,
  [12550] = 12157,
  [12551] = 12100,
  [12552] = 12159,
  [12553] = 12160,
  [12554] = 12161,
  [12555] = 12162,
  [12556] = 12163,
  [12557] = 12164,
  [12558] = 12165,
  [12559] = 12044,
  [12560] = 12041,
  [12561] = 12561,
  [12562] = 12081,
  [12563] = 12563,
  [12564] = 12080,
  [12565] = 12565,
  [12566] = 12566,
  [12567] = 12174,
  [12568] = 12175,
  [12569] = 12176,
  [12570] = 12177,
  [12571] = 12178,
  [12572] = 12179,
  [12573] = 12079,
  [12574] = 12574,
  [12575] = 12575,
  [12576] = 12576,
  [12577] = 12577,
  [12578] = 12078,
  [12579] = 12579,
  [12580] = 12189,
  [12581] = 12190,
  [12582] = 12191,
  [12583] = 12192,
  [12584] = 12075,
  [12585] = 12034,
  [12586] = 12070,
  [12587] = 12052,
  [12588] = 12588,
  [12589] = 12200,
  [12590] = 12201,
  [12591] = 12202,
  [12592] = 12592,
  [12593] = 12054,
  [12594] = 12055,
  [12595] = 12208,
  [12596] = 12068,
  [12597] = 12067,
  [12598] = 12065,
  [12599] = 12019,
  [12600] = 12058,
  [12601] = 12601,
  [12602] = 12602,
  [12603] = 12130,
  [12604] = 12060,
  [12605] = 12062,
  [12606] = 12063,
  [12607] = 12065,
  [12608] = 12067,
  [12609] = 12068,
  [12610] = 12146,
  [12611] = 12147,
  [12612] = 12148,
  [12613] = 12149,
  [12614] = 12018,
  [12615] = 12151,
  [12616] = 12152,
  [12617] = 12153,
  [12618] = 12063,
  [12619] = 12155,
  [12620] = 12156,
  [12621] = 12157,
  [12622] = 12100,
  [12623] = 12159,
  [12624] = 12160,
  [12625] = 12161,
  [12626] = 12162,
  [12627] = 12163,
  [12628] = 12164,
  [12629] = 12165,
  [12630] = 12630,
  [12631] = 12070,
  [12632] = 12632,
  [12633] = 12034,
  [12634] = 12075,
  [12635] = 12174,
  [12636] = 12175,
  [12637] = 12176,
  [12638] = 12177,
  [12639] = 12178,
  [12640] = 12179,
  [12641] = 12078,
  [12642] = 12079,
  [12643] = 12080,
  [12644] = 12081,
  [12645] = 12189,
  [12646] = 12190,
  [12647] = 12191,
  [12648] = 12192,
  [12649] = 12082,
  [12650] = 12021,
  [12651] = 12200,
  [12652] = 12201,
  [12653] = 12202,
  [12654] = 12084,
  [12655] = 12208,
  [12656] = 12656,
  [12657] = 12062,
  [12658] = 12086,
  [12659] = 12087,
  [12660] = 12069,
  [12661] = 12046,
  [12662] = 12130,
  [12663] = 12045,
  [12664] = 12039,
  [12665] = 12036,
  [12666] = 12666,
  [12667] = 12097,
  [12668] = 12020,
  [12669] = 12146,
  [12670] = 12147,
  [12671] = 12148,
  [12672] = 12149,
  [12673] = 12018,
  [12674] = 12151,
  [12675] = 12152,
  [12676] = 12153,
  [12677] = 12054,
  [12678] = 12155,
  [12679] = 12156,
  [12680] = 12157,
  [12681] = 12100,
  [12682] = 12159,
  [12683] = 12160,
  [12684] = 12161,
  [12685] = 12162,
  [12686] = 12163,
  [12687] = 12164,
  [12688] = 12165,
  [12689] = 12022,
  [12690] = 12023,
  [12691] = 12041,
  [12692] = 12024,
  [12693] = 12693,
  [12694] = 12174,
  [12695] = 12175,
  [12696] = 12176,
  [12697] = 12177,
  [12698] = 12178,
  [12699] = 12179,
  [12700] = 12058,
  [12701] = 12701,
  [12702] = 12211,
  [12703] = 12703,
  [12704] = 12189,
  [12705] = 12190,
  [12706] = 12191,
  [12707] = 12192,
  [12708] = 12708,
  [12709] = 12709,
  [12710] = 12200,
  [12711] = 12201,
  [12712] = 12202,
  [12713] = 12713,
  [12714] = 12208,
  [12715] = 12019,
  [12716] = 12055,
  [12717] = 12025,
  [12718] = 12026,
  [12719] = 12027,
  [12720] = 12028,
  [12721] = 12130,
  [12722] = 12722,
  [12723] = 12030,
  [12724] = 12115,
  [12725] = 12054,
  [12726] = 12032,
  [12727] = 12727,
  [12728] = 12146,
  [12729] = 12147,
  [12730] = 12148,
  [12731] = 12149,
  [12732] = 12018,
  [12733] = 12151,
  [12734] = 12152,
  [12735] = 12153,
  [12736] = 12033,
  [12737] = 12155,
  [12738] = 12156,
  [12739] = 12157,
  [12740] = 12100,
  [12741] = 12159,
  [12742] = 12160,
  [12743] = 12161,
  [12744] = 12162,
  [12745] = 12163,
  [12746] = 12164,
  [12747] = 12165,
  [12748] = 12748,
  [12749] = 12749,
  [12750] = 12750,
  [12751] = 12751,
  [12752] = 12035,
  [12753] = 12174,
  [12754] = 12175,
  [12755] = 12176,
  [12756] = 12177,
  [12757] = 12178,
  [12758] = 12179,
  [12759] = 12759,
  [12760] = 12760,
  [12761] = 12038,
  [12762] = 12762,
  [12763] = 12189,
  [12764] = 12190,
  [12765] = 12191,
  [12766] = 12192,
  [12767] = 12767,
  [12768] = 12041,
  [12769] = 12200,
  [12770] = 12201,
  [12771] = 12202,
  [12772] = 12052,
  [12773] = 12208,
  [12774] = 12774,
  [12775] = 12775,
  [12776] = 12776,
  [12777] = 12044,
  [12778] = 12778,
  [12779] = 12779,
  [12780] = 12130,
  [12781] = 12210,
  [12782] = 12782,
  [12783] = 12783,
  [12784] = 12784,
  [12785] = 12044,
  [12786] = 12786,
  [12787] = 12146,
  [12788] = 12147,
  [12789] = 12148,
  [12790] = 12149,
  [12791] = 12018,
  [12792] = 12151,
  [12793] = 12152,
  [12794] = 12153,
  [12795] = 12052,
  [12796] = 12155,
  [12797] = 12156,
  [12798] = 12157,
  [12799] = 12100,
  [12800] = 12159,
  [12801] = 12160,
  [12802] = 12161,
  [12803] = 12162,
  [12804] = 12163,
  [12805] = 12164,
  [12806] = 12165,
  [12807] = 12087,
  [12808] = 12055,
  [12809] = 12809,
  [12810] = 12019,
  [12811] = 12058,
  [12812] = 12174,
  [12813] = 12175,
  [12814] = 12176,
  [12815] = 12177,
  [12816] = 12178,
  [12817] = 12179,
  [12818] = 12818,
  [12819] = 12819,
  [12820] = 12060,
  [12821] = 12062,
  [12822] = 12189,
  [12823] = 12190,
  [12824] = 12191,
  [12825] = 12192,
  [12826] = 12063,
  [12827] = 12065,
  [12828] = 12200,
  [12829] = 12201,
  [12830] = 12202,
  [12831] = 12067,
  [12832] = 12208,
  [12833] = 12833,
  [12834] = 12032,
  [12835] = 12068,
  [12836] = 12070,
  [12837] = 12034,
  [12838] = 12075,
  [12839] = 12130,
  [12840] = 12078,
  [12841] = 12079,
  [12842] = 12080,
  [12843] = 12081,
  [12844] = 12082,
  [12845] = 12083,
  [12846] = 12146,
  [12847] = 12147,
  [12848] = 12148,
  [12849] = 12149,
  [12850] = 12018,
  [12851] = 12151,
  [12852] = 12152,
  [12853] = 12153,
  [12854] = 12084,
  [12855] = 12155,
  [12856] = 12156,
  [12857] = 12157,
  [12858] = 12100,
  [12859] = 12159,
  [12860] = 12160,
  [12861] = 12161,
  [12862] = 12162,
  [12863] = 12163,
  [12864] = 12164,
  [12865] = 12165,
  [12866] = 12086,
  [12867] = 12026,
  [12868] = 12060,
  [12869] = 12069,
  [12870] = 12046,
  [12871] = 12174,
  [12872] = 12175,
  [12873] = 12176,
  [12874] = 12177,
  [12875] = 12178,
  [12876] = 12179,
  [12877] = 12877,
  [12878] = 12045,
  [12879] = 12039,
  [12880] = 12880,
  [12881] = 12189,
  [12882] = 12190,
  [12883] = 12191,
  [12884] = 12192,
  [12885] = 12036,
  [12886] = 12886,
  [12887] = 12200,
  [12888] = 12201,
  [12889] = 12202,
  [12890] = 12097,
  [12891] = 12208,
  [12892] = 12035,
  [12893] = 12033,
  [12894] = 12020,
  [12895] = 12021,
  [12896] = 12896,
  [12897] = 12897,
  [12898] = 12130,
  [12899] = 12022,
  [12900] = 12023,
  [12901] = 12024,
  [12902] = 12902,
  [12903] = 12903,
  [12904] = 12904,
  [12905] = 12146,
  [12906] = 12147,
  [12907] = 12148,
  [12908] = 12149,
  [12909] = 12038,
  [12910] = 12151,
  [12911] = 12152,
  [12912] = 12153,
  [12913] = 12913,
  [12914] = 12155,
  [12915] = 12156,
  [12916] = 12157,
  [12917] = 12100,
  [12918] = 12159,
  [12919] = 12160,
  [12920] = 12161,
  [12921] = 12162,
  [12922] = 12163,
  [12923] = 12164,
  [12924] = 12165,
  [12925] = 12208,
  [12926] = 12025,
  [12927] = 12927,
  [12928] = 12075,
  [12929] = 12027,
  [12930] = 12174,
  [12931] = 12175,
  [12932] = 12176,
  [12933] = 12177,
  [12934] = 12178,
  [12935] = 12179,
  [12936] = 12028,
  [12937] = 12030,
  [12938] = 12115,
  [12939] = 12032,
  [12940] = 12189,
  [12941] = 12190,
  [12942] = 12191,
  [12943] = 12192,
  [12944] = 12033,
  [12945] = 12061,
  [12946] = 12200,
  [12947] = 12201,
  [12948] = 12202,
  [12949] = 12035,
  [12950] = 12208,
  [12951] = 12115,
  [12952] = 12030,
  [12953] = 12038,
  [12954] = 12028,
  [12955] = 12041,
  [12956] = 12206,
  [12957] = 12130,
  [12958] = 12044,
  [12959] = 12027,
  [12960] = 12026,
  [12961] = 12025,
  [12962] = 12024,
  [12963] = 12963,
  [12964] = 12146,
  [12965] = 12147,
  [12966] = 12148,
  [12967] = 12149,
  [12968] = 12018,
  [12969] = 12151,
  [12970] = 12152,
  [12971] = 12153,
  [12972] = 12972,
  [12973] = 12155,
  [12974] = 12156,
  [12975] = 12157,
  [12976] = 12100,
  [12977] = 12159,
  [12978] = 12160,
  [12979] = 12161,
  [12980] = 12162,
  [12981] = 12163,
  [12982] = 12164,
  [12983] = 12165,
  [12984] = 12984,
  [12985] = 12985,
  [12986] = 12023,
  [12987] = 12987,
  [12988] = 12052,
  [12989] = 12174,
  [12990] = 12175,
  [12991] = 12176,
  [12992] = 12177,
  [12993] = 12178,
  [12994] = 12179,
  [12995] = 12995,
  [12996] = 12996,
  [12997] = 12997,
  [12998] = 12054,
  [12999] = 12189,
  [13000] = 12190,
  [13001] = 12191,
  [13002] = 12192,
  [13003] = 12055,
  [13004] = 13004,
  [13005] = 12200,
  [13006] = 12201,
  [13007] = 12202,
  [13008] = 12019,
  [13009] = 12208,
  [13010] = 13010,
  [13011] = 12022,
  [13012] = 12058,
  [13013] = 13013,
  [13014] = 13014,
  [13015] = 12060,
  [13016] = 12130,
  [13017] = 12062,
  [13018] = 12063,
  [13019] = 12065,
  [13020] = 12067,
  [13021] = 12068,
  [13022] = 12021,
  [13023] = 12146,
  [13024] = 12147,
  [13025] = 12148,
  [13026] = 12149,
  [13027] = 12018,
  [13028] = 12151,
  [13029] = 12152,
  [13030] = 12153,
  [13031] = 13031,
  [13032] = 12155,
  [13033] = 12156,
  [13034] = 12157,
  [13035] = 12100,
  [13036] = 12159,
  [13037] = 12160,
  [13038] = 12161,
  [13039] = 12162,
  [13040] = 12163,
  [13041] = 12164,
  [13042] = 12165,
  [13043] = 13043,
  [13044] = 12574,
  [13045] = 13045,
  [13046] = 12070,
  [13047] = 12034,
  [13048] = 12174,
  [13049] = 12175,
  [13050] = 12176,
  [13051] = 12177,
  [13052] = 12178,
  [13053] = 12179,
  [13054] = 13054,
  [13055] = 12084,
  [13056] = 12078,
  [13057] = 13057,
  [13058] = 12189,
  [13059] = 12190,
  [13060] = 12191,
  [13061] = 12192,
  [13062] = 12079,
  [13063] = 12080,
  [13064] = 12200,
  [13065] = 12201,
  [13066] = 12202,
  [13067] = 12081,
  [13068] = 12208,
  [13069] = 12086,
  [13070] = 12020,
  [13071] = 12082,
  [13072] = 12083,
  [13073] = 12097,
  [13074] = 13074,
  [13075] = 12130,
  [13076] = 13076,
  [13077] = 13077,
  [13078] = 13078,
  [13079] = 13079,
  [13080] = 12086,
  [13081] = 13081,
  [13082] = 12146,
  [13083] = 12147,
  [13084] = 12148,
  [13085] = 12149,
  [13086] = 12018,
  [13087] = 12151,
  [13088] = 12152,
  [13089] = 12153,
  [13090] = 12087,
  [13091] = 12155,
  [13092] = 12156,
  [13093] = 12157,
  [13094] = 12100,
  [13095] = 12159,
  [13096] = 12160,
  [13097] = 12161,
  [13098] = 12162,
  [13099] = 12163,
  [13100] = 12164,
  [13101] = 12165,
  [13102] = 12069,
  [13103] = 12046,
  [13104] = 12036,
  [13105] = 13105,
  [13106] = 12045,
  [13107] = 12174,
  [13108] = 12175,
  [13109] = 12176,
  [13110] = 12177,
  [13111] = 12178,
  [13112] = 12179,
  [13113] = 13113,
  [13114] = 12039,
  [13115] = 12036,
  [13116] = 12097,
  [13117] = 12189,
  [13118] = 12190,
  [13119] = 12191,
  [13120] = 12192,
  [13121] = 13121,
  [13122] = 12138,
  [13123] = 12200,
  [13124] = 12201,
  [13125] = 12202,
  [13126] = 12137,
  [13127] = 12208,
  [13128] = 12039,
  [13129] = 12045,
  [13130] = 12020,
  [13131] = 12021,
  [13132] = 12136,
  [13133] = 12022,
  [13134] = 12130,
  [13135] = 12023,
  [13136] = 12046,
  [13137] = 12024,
  [13138] = 12069,
  [13139] = 12087,
  [13140] = 13140,
  [13141] = 12146,
  [13142] = 12147,
  [13143] = 12148,
  [13144] = 12149,
  [13145] = 12018,
  [13146] = 12151,
  [13147] = 12152,
  [13148] = 12153,
  [13149] = 12025,
  [13150] = 12155,
  [13151] = 12156,
  [13152] = 12157,
  [13153] = 12100,
  [13154] = 12159,
  [13155] = 12160,
  [13156] = 12161,
  [13157] = 12162,
  [13158] = 12163,
  [13159] = 12164,
  [13160] = 12165,
  [13161] = 13161,
  [13162] = 12026,
  [13163] = 13163,
  [13164] = 12027,
  [13165] = 12028,
  [13166] = 12174,
  [13167] = 12175,
  [13168] = 12176,
  [13169] = 12177,
  [13170] = 12178,
  [13171] = 12179,
  [13172] = 12030,
  [13173] = 12115,
  [13174] = 12032,
  [13175] = 13175,
  [13176] = 12189,
  [13177] = 12190,
  [13178] = 12191,
  [13179] = 12192,
  [13180] = 13180,
  [13181] = 12033,
  [13182] = 12200,
  [13183] = 12201,
  [13184] = 12202,
  [13185] = 12060,
  [13186] = 12208,
  [13187] = 12080,
  [13188] = 13188,
  [13189] = 12130,
  [13190] = 12061,
  [13191] = 12146,
  [13192] = 12147,
  [13193] = 12148,
  [13194] = 12149,
  [13195] = 12018,
  [13196] = 12151,
  [13197] = 12152,
  [13198] = 12153,
  [13199] = 12035,
  [13200] = 12155,
  [13201] = 12156,
  [13202] = 12157,
  [13203] = 12100,
  [13204] = 12159,
  [13205] = 12160,
  [13206] = 12161,
  [13207] = 12162,
  [13208] = 12163,
  [13209] = 12164,
  [13210] = 12165,
  [13211] = 12174,
  [13212] = 12175,
  [13213] = 12176,
  [13214] = 12177,
  [13215] = 12178,
  [13216] = 12179,
  [13217] = 12189,
  [13218] = 12190,
  [13219] = 12191,
  [13220] = 12192,
  [13221] = 12200,
  [13222] = 12201,
  [13223] = 12202,
  [13224] = 12208,
  [13225] = 13225,
  [13226] = 12084,
  [13227] = 12130,
  [13228] = 12038,
  [13229] = 12146,
  [13230] = 12147,
  [13231] = 12148,
  [13232] = 12149,
  [13233] = 12018,
  [13234] = 12151,
  [13235] = 12152,
  [13236] = 12153,
  [13237] = 13237,
  [13238] = 12155,
  [13239] = 12156,
  [13240] = 12157,
  [13241] = 12100,
  [13242] = 12159,
  [13243] = 12160,
  [13244] = 12161,
  [13245] = 12162,
  [13246] = 12163,
  [13247] = 12164,
  [13248] = 12165,
  [13249] = 12174,
  [13250] = 12175,
  [13251] = 12176,
  [13252] = 12177,
  [13253] = 12178,
  [13254] = 12179,
  [13255] = 12189,
  [13256] = 12190,
  [13257] = 12191,
  [13258] = 12192,
  [13259] = 12200,
  [13260] = 12201,
  [13261] = 12202,
  [13262] = 12208,
  [13263] = 13263,
  [13264] = 13264,
  [13265] = 12130,
  [13266] = 13266,
  [13267] = 12157,
  [13268] = 12100,
  [13269] = 12202,
  [13270] = 12041,
  [13271] = 13271,
  [13272] = 12157,
  [13273] = 12100,
  [13274] = 12201,
  [13275] = 12200,
  [13276] = 12044,
  [13277] = 12157,
  [13278] = 12100,
  [13279] = 12157,
  [13280] = 12100,
  [13281] = 12157,
  [13282] = 12100,
  [13283] = 12157,
  [13284] = 12100,
  [13285] = 12157,
  [13286] = 12100,
  [13287] = 12157,
  [13288] = 12100,
  [13289] = 13289,
  [13290] = 13290,
  [13291] = 12083,
  [13292] = 13292,
  [13293] = 12082,
  [13294] = 13294,
  [13295] = 12197,
  [13296] = 13296,
  [13297] = 12081,
  [13298] = 13298,
  [13299] = 12052,
  [13300] = 13300,
  [13301] = 13301,
  [13302] = 13302,
  [13303] = 12054,
  [13304] = 12055,
  [13305] = 12097,
  [13306] = 12058,
  [13307] = 13307,
  [13308] = 13308,
  [13309] = 13309,
  [13310] = 13310,
  [13311] = 12055,
  [13312] = 13312,
  [13313] = 12079,
  [13314] = 12062,
  [13315] = 13315,
  [13316] = 12063,
  [13317] = 12065,
  [13318] = 12067,
  [13319] = 12068,
  [13320] = 13320,
  [13321] = 12078,
  [13322] = 12574,
  [13323] = 13323,
  [13324] = 12075,
  [13325] = 12070,
  [13326] = 12034,
  [13327] = 12075,
  [13328] = 13328,
  [13329] = 12078,
  [13330] = 12034,
  [13331] = 13331,
  [13332] = 12079,
  [13333] = 12080,
  [13334] = 12081,
  [13335] = 12082,
  [13336] = 13328,
  [13337] = 12083,
  [13338] = 13105,
  [13339] = 13078,
  [13340] = 12084,
  [13341] = 13077,
  [13342] = 12086,
  [13343] = 12087,
  [13344] = 12069,
  [13345] = 13004,
  [13346] = 12046,
  [13347] = 12045,
  [13348] = 12039,
  [13349] = 12902,
  [13350] = 12036,
  [13351] = 12097,
  [13352] = 12070,
  [13353] = 12880,
  [13354] = 12748,
  [13355] = 12708,
  [13356] = 12464,
  [13357] = 12020,
  [13358] = 12021,
  [13359] = 12022,
  [13360] = 12023,
  [13361] = 12024,
  [13362] = 12133,
  [13363] = 12068,
  [13364] = 13364,
  [13365] = 12313,
  [13366] = 12067,
  [13367] = 12145,
  [13368] = 13312,
  [13369] = 12132,
  [13370] = 12025,
  [13371] = 12026,
  [13372] = 12027,
  [13373] = 12028,
  [13374] = 12093,
  [13375] = 12030,
  [13376] = 12071,
  [13377] = 12115,
  [13378] = 12032,
  [13379] = 12033,
  [13380] = 13380,
  [13381] = 13381,
  [13382] = 12043,
  [13383] = 12061,
  [13384] = 12065,
  [13385] = 12035,
  [13386] = 12038,
  [13387] = 13387,
  [13388] = 13121,
  [13389] = 13389,
  [13390] = 12453,
  [13391] = 13309,
  [13392] = 13301,
  [13393] = 12063,
  [13394] = 13394,
  [13395] = 13331,
  [13396] = 13396,
  [13397] = 13397,
  [13398] = 13398,
  [13399] = 13399,
  [13400] = 13400,
  [13401] = 13401,
  [13402] = 12041,
  [13403] = 13403,
  [13404] = 13404,
  [13405] = 12044,
  [13406] = 13406,
  [13407] = 12062,
  [13408] = 13408,
  [13409] = 12060,
  [13410] = 12058,
  [13411] = 13411,
  [13412] = 12062,
  [13413] = 13031,
  [13414] = 13414,
  [13415] = 13415,
  [13416] = 12197,
  [13417] = 12068,
  [13418] = 12067,
  [13419] = 13419,
  [13420] = 13420,
  [13421] = 13421,
  [13422] = 13422,
  [13423] = 13423,
  [13424] = 13424,
  [13425] = 12200,
  [13426] = 13426,
  [13427] = 12201,
  [13428] = 12296,
  [13429] = 12256,
  [13430] = 12216,
  [13431] = 12085,
  [13432] = 12135,
  [13433] = 12065,
  [13434] = 12019,
  [13435] = 12048,
  [13436] = 12063,
  [13437] = 12130,
  [13438] = 12041,
  [13439] = 12023,
  [13440] = 12054,
  [13441] = 12202,
  [13442] = 12060,
  [13443] = 12364,
  [13444] = 12367,
  [13445] = 12456,
  [13446] = 12534,
  [13447] = 12052,
  [13448] = 12038,
  [13449] = 12433,
  [13450] = 13263,
  [13451] = 12601,
  [13452] = 12602,
  [13453] = 12749,
  [13454] = 12751,
  [13455] = 12044,
  [13456] = 12041,
  [13457] = 12767,
  [13458] = 13237,
  [13459] = 13459,
  [13460] = 13424,
  [13461] = 12038,
  [13462] = 12035,
  [13463] = 12995,
  [13464] = 13013,
  [13465] = 12033,
  [13466] = 13302,
  [13467] = 13307,
  [13468] = 13308,
  [13469] = 12032,
  [13470] = 13415,
  [13471] = 13471,
  [13472] = 12579,
  [13473] = 13473,
  [13474] = 12115,
  [13475] = 12537,
  [13476] = 12192,
  [13477] = 12191,
  [13478] = 12190,
  [13479] = 13426,
  [13480] = 13480,
  [13481] = 12189,
  [13482] = 13482,
  [13483] = 13459,
  [13484] = 12030,
  [13485] = 12028,
  [13486] = 12027,
  [13487] = 13487,
  [13488] = 12026,
  [13489] = 13489,
  [13490] = 13490,
  [13491] = 13491,
  [13492] = 12025,
  [13493] = 12024,
  [13494] = 12063,
  [13495] = 12021,
  [13496] = 12020,
  [13497] = 12029,
  [13498] = 13498,
  [13499] = 13499,
  [13500] = 13500,
  [13501] = 13501,
  [13502] = 12299,
  [13503] = 12097,
  [13504] = 12036,
  [13505] = 12039,
  [13506] = 12786,
  [13507] = 13507,
  [13508] = 12045,
  [13509] = 12896,
  [13510] = 13510,
  [13511] = 12046,
  [13512] = 13480,
  [13513] = 13513,
  [13514] = 13514,
  [13515] = 13515,
  [13516] = 13516,
  [13517] = 12069,
  [13518] = 13518,
  [13519] = 13519,
  [13520] = 12087,
  [13521] = 12086,
  [13522] = 13522,
  [13523] = 12084,
  [13524] = 12083,
  [13525] = 13525,
  [13526] = 12183,
  [13527] = 13180,
  [13528] = 12082,
  [13529] = 13529,
  [13530] = 13530,
  [13531] = 12081,
  [13532] = 13532,
  [13533] = 12080,
  [13534] = 13534,
  [13535] = 12052,
  [13536] = 13163,
  [13537] = 12079,
  [13538] = 12078,
  [13539] = 13539,
  [13540] = 13540,
  [13541] = 13541,
  [13542] = 12075,
  [13543] = 12034,
  [13544] = 13544,
  [13545] = 13545,
  [13546] = 12070,
  [13547] = 13547,
  [13548] = 13548,
  [13549] = 13549,
  [13550] = 12068,
  [13551] = 13551,
  [13552] = 13552,
  [13553] = 13323,
  [13554] = 12179,
  [13555] = 12178,
  [13556] = 12177,
  [13557] = 12176,
  [13558] = 12175,
  [13559] = 13559,
  [13560] = 13560,
  [13561] = 12174,
  [13562] = 12067,
  [13563] = 13563,
  [13564] = 12065,
  [13565] = 13565,
  [13566] = 13566,
  [13567] = 12153,
  [13568] = 12062,
  [13569] = 13569,
  [13570] = 13570,
  [13571] = 13400,
  [13572] = 12060,
  [13573] = 13140,
  [13574] = 12058,
  [13575] = 12019,
  [13576] = 12055,
  [13577] = 12054,
  [13578] = 12054,
  [13579] = 12055,
  [13580] = 12019,
  [13581] = 12058,
  [13582] = 12052,
  [13583] = 13489,
  [13584] = 13584,
  [13585] = 13585,
  [13586] = 13586,
  [13587] = 13587,
  [13588] = 13588,
  [13589] = 13225,
  [13590] = 12044,
  [13591] = 13591,
  [13592] = 13592,
  [13593] = 13593,
  [13594] = 13594,
  [13595] = 13595,
  [13596] = 13596,
  [13597] = 12420,
  [13598] = 12041,
  [13599] = 12038,
  [13600] = 12035,
  [13601] = 13601,
  [13602] = 13584,
  [13603] = 12033,
  [13604] = 12183,
  [13605] = 12032,
  [13606] = 13500,
  [13607] = 12107,
  [13608] = 12115,
  [13609] = 12030,
  [13610] = 12037,
  [13611] = 12060,
  [13612] = 12062,
  [13613] = 12063,
  [13614] = 12065,
  [13615] = 12067,
  [13616] = 12068,
  [13617] = 12028,
  [13618] = 12027,
  [13619] = 12026,
  [13620] = 13403,
  [13621] = 13381,
  [13622] = 13380,
  [13623] = 13310,
  [13624] = 12025,
  [13625] = 13271,
  [13626] = 13266,
  [13627] = 13264,
  [13628] = 12064,
  [13629] = 12066,
  [13630] = 13043,
  [13631] = 12024,
  [13632] = 13014,
  [13633] = 12023,
  [13634] = 12996,
  [13635] = 12987,
  [13636] = 12076,
  [13637] = 12046,
  [13638] = 13400,
  [13639] = 13516,
  [13640] = 12022,
  [13641] = 12776,
  [13642] = 12021,
  [13643] = 12020,
  [13644] = 13331,
  [13645] = 12108,
  [13646] = 12097,
  [13647] = 12022,
  [13648] = 12313,
  [13649] = 12574,
  [13650] = 12039,
  [13651] = 12165,
  [13652] = 12722,
  [13653] = 12070,
  [13654] = 12034,
  [13655] = 12075,
  [13656] = 13404,
  [13657] = 12078,
  [13658] = 12079,
  [13659] = 12080,
  [13660] = 13660,
  [13661] = 12364,
  [13662] = 12367,
  [13663] = 12456,
  [13664] = 12081,
  [13665] = 12082,
  [13666] = 13426,
  [13667] = 12083,
  [13668] = 12084,
  [13669] = 12164,
  [13670] = 12163,
  [13671] = 12120,
  [13672] = 12031,
  [13673] = 12047,
  [13674] = 12042,
  [13675] = 12040,
  [13676] = 12162,
  [13677] = 12259,
  [13678] = 12281,
  [13679] = 12161,
  [13680] = 12352,
  [13681] = 12160,
  [13682] = 12159,
  [13683] = 12783,
  [13684] = 12100,
  [13685] = 12183,
  [13686] = 12157,
  [13687] = 12156,
  [13688] = 12155,
  [13689] = 13077,
  [13690] = 12045,
  [13691] = 13331,
  [13692] = 12086,
  [13693] = 12087,
  [13694] = 12069,
  [13695] = 12313,
  [13696] = 12392,
  [13697] = 12045,
  [13698] = 12039,
  [13699] = 12036,
  [13700] = 12097,
  [13701] = 12020,
  [13702] = 13404,
  [13703] = 12021,
  [13704] = 12022,
  [13705] = 12023,
  [13706] = 12024,
  [13707] = 12364,
  [13708] = 12367,
  [13709] = 12456,
  [13710] = 12778,
  [13711] = 12152,
  [13712] = 13426,
  [13713] = 12151,
  [13714] = 12025,
  [13715] = 12026,
  [13716] = 12027,
  [13717] = 12028,
  [13718] = 12030,
  [13719] = 13331,
  [13720] = 12115,
  [13721] = 12032,
  [13722] = 12033,
  [13723] = 12313,
  [13724] = 13534,
  [13725] = 13489,
  [13726] = 13294,
  [13727] = 13289,
  [13728] = 13728,
  [13729] = 12775,
  [13730] = 13404,
  [13731] = 12760,
  [13732] = 12018,
  [13733] = 12378,
  [13734] = 13734,
  [13735] = 12364,
  [13736] = 12367,
  [13737] = 12456,
  [13738] = 12372,
  [13739] = 12300,
  [13740] = 13426,
  [13741] = 12149,
  [13742] = 12057,
  [13743] = 12059,
  [13744] = 12061,
  [13745] = 12074,
  [13746] = 12076,
  [13747] = 13331,
  [13748] = 12148,
  [13749] = 12147,
  [13750] = 13750,
  [13751] = 12313,
  [13752] = 13752,
  [13753] = 12146,
  [13754] = 12143,
  [13755] = 12035,
  [13756] = 12046,
  [13757] = 13404,
  [13758] = 12038,
  [13759] = 12533,
  [13760] = 12666,
  [13761] = 12364,
  [13762] = 12367,
  [13763] = 12456,
  [13764] = 13426,
  [13765] = 12703,
  [13766] = 12709,
  [13767] = 12069,
  [13768] = 12727,
  [13769] = 13331,
  [13770] = 12087,
  [13771] = 13522,
  [13772] = 12313,
  [13773] = 13773,
  [13774] = 13774,
  [13775] = 12033,
  [13776] = 12086,
  [13777] = 13404,
  [13778] = 12819,
  [13779] = 12084,
  [13780] = 12364,
  [13781] = 12367,
  [13782] = 12456,
  [13783] = 13426,
  [13784] = 12713,
  [13785] = 12877,
  [13786] = 12032,
  [13787] = 12083,
  [13788] = 13331,
  [13789] = 12082,
  [13790] = 12984,
  [13791] = 12313,
  [13792] = 13113,
  [13793] = 12081,
  [13794] = 13121,
  [13795] = 12138,
  [13796] = 13404,
  [13797] = 12137,
  [13798] = 13320,
  [13799] = 12364,
  [13800] = 12367,
  [13801] = 12456,
  [13802] = 13426,
  [13803] = 12136,
  [13804] = 13498,
  [13805] = 12080,
  [13806] = 13045,
  [13807] = 13331,
  [13808] = 12141,
  [13809] = 12313,
  [13810] = 13810,
  [13811] = 13811,
  [13812] = 12130,
  [13813] = 13404,
  [13814] = 12041,
  [13815] = 12364,
  [13816] = 12367,
  [13817] = 12456,
  [13818] = 13426,
  [13819] = 13490,
  [13820] = 13514,
  [13821] = 12140,
  [13822] = 12464,
  [13823] = 13331,
  [13824] = 13824,
  [13825] = 12313,
  [13826] = 13660,
  [13827] = 12129,
  [13828] = 13728,
  [13829] = 13404,
  [13830] = 12060,
  [13831] = 12364,
  [13832] = 12367,
  [13833] = 12456,
  [13834] = 13426,
  [13835] = 12535,
  [13836] = 12701,
  [13837] = 13315,
  [13838] = 13838,
  [13839] = 13331,
  [13840] = 12759,
  [13841] = 12313,
  [13842] = 13838,
  [13843] = 13843,
  [13844] = 13843,
  [13845] = 13404,
  [13846] = 12782,
  [13847] = 12364,
  [13848] = 12367,
  [13849] = 12456,
  [13850] = 13426,
  [13851] = 12079,
  [13852] = 13852,
  [13853] = 13853,
  [13854] = 12078,
  [13855] = 13331,
  [13856] = 13594,
  [13857] = 12313,
  [13858] = 13593,
  [13859] = 12075,
  [13860] = 13592,
  [13861] = 13404,
  [13862] = 12044,
  [13863] = 12364,
  [13864] = 12367,
  [13865] = 12456,
  [13866] = 13426,
  [13867] = 13867,
  [13868] = 13868,
  [13869] = 12034,
  [13870] = 13870,
  [13871] = 13331,
  [13872] = 13872,
  [13873] = 12313,
  [13874] = 12070,
  [13875] = 13875,
  [13876] = 12036,
  [13877] = 13404,
  [13878] = 13054,
  [13879] = 12364,
  [13880] = 12367,
  [13881] = 12456,
  [13882] = 13426,
  [13883] = 13057,
  [13884] = 12067,
  [13885] = 12065,
  [13886] = 13886,
  [13887] = 13331,
  [13888] = 13079,
  [13889] = 12313,
  [13890] = 13852,
  [13891] = 13081,
  [13892] = 13501,
  [13893] = 13404,
  [13894] = 13113,
  [13895] = 12364,
  [13896] = 12367,
  [13897] = 12456,
  [13898] = 13426,
  [13899] = 13010,
  [13900] = 13588,
  [13901] = 12972,
  [13902] = 12128,
  [13903] = 13331,
  [13904] = 13587,
  [13905] = 12313,
  [13906] = 13586,
  [13907] = 12138,
  [13908] = 12137,
  [13909] = 13404,
  [13910] = 13585,
  [13911] = 12364,
  [13912] = 12367,
  [13913] = 12456,
  [13914] = 13426,
  [13915] = 13915,
  [13916] = 13916,
  [13917] = 13917,
  [13918] = 12136,
  [13919] = 13331,
  [13920] = 13920,
  [13921] = 12313,
  [13922] = 13922,
  [13923] = 13923,
  [13924] = 12206,
  [13925] = 13404,
  [13926] = 13161,
  [13927] = 12364,
  [13928] = 12367,
  [13929] = 12456,
  [13930] = 13426,
  [13931] = 12058,
  [13932] = 13932,
  [13933] = 13933,
  [13934] = 12019,
  [13935] = 13331,
  [13936] = 12208,
  [13937] = 12313,
  [13938] = 12055,
  [13939] = 12044,
  [13940] = 12054,
  [13941] = 13404,
  [13942] = 12063,
  [13943] = 12364,
  [13944] = 12367,
  [13945] = 12456,
  [13946] = 13426,
  [13947] = 12913,
  [13948] = 12062,
  [13949] = 13507,
  [13950] = 12133,
  [13951] = 13331,
  [13952] = 13570,
  [13953] = 12313,
  [13954] = 12070,
  [13955] = 12903,
  [13956] = 12058,
  [13957] = 13404,
  [13958] = 12019,
  [13959] = 12364,
  [13960] = 12367,
  [13961] = 12456,
  [13962] = 13426,
  [13963] = 12055,
  [13964] = 12054,
  [13965] = 13331,
  [13966] = 13404,
  [13967] = 12364,
  [13968] = 12367,
  [13969] = 12456,
  [13970] = 13426,
  [13971] = 12052,
  [13972] = 12896,
  [13973] = 13331,
  [13974] = 13404,
  [13975] = 12364,
  [13976] = 12367,
  [13977] = 12456,
  [13978] = 13426,
  [13979] = 13979,
  [13980] = 13518,
  [13981] = 12130,
  [13982] = 13566,
  [13983] = 12115,
  [13984] = 13984,
  [13985] = 13516,
  [13986] = 13986,
  [13987] = 13987,
  [13988] = 12044,
  [13989] = 12041,
  [13990] = 13990,
  [13991] = 12038,
  [13992] = 13992,
  [13993] = 13993,
  [13994] = 12035,
  [13995] = 13995,
  [13996] = 12033,
  [13997] = 13529,
  [13998] = 12032,
  [13999] = 12115,
  [14000] = 12030,
  [14001] = 12129,
  [14002] = 12028,
  [14003] = 12027,
  [14004] = 12026,
  [14005] = 13886,
  [14006] = 12128,
  [14007] = 12025,
  [14008] = 12833,
  [14009] = 12024,
  [14010] = 13320,
  [14011] = 14011,
  [14012] = 14012,
  [14013] = 13752,
  [14014] = 13750,
  [14015] = 12023,
  [14016] = 12022,
  [14017] = 13323,
  [14018] = 13516,
  [14019] = 12021,
  [14020] = 14020,
  [14021] = 13394,
  [14022] = 12818,
  [14023] = 13549,
  [14024] = 13290,
  [14025] = 12020,
  [14026] = 14026,
  [14027] = 12097,
  [14028] = 12036,
  [14029] = 13076,
  [14030] = 13525,
  [14031] = 13004,
  [14032] = 12039,
  [14033] = 12886,
  [14034] = 13545,
  [14035] = 12045,
  [14036] = 13544,
  [14037] = 12046,
  [14038] = 12394,
  [14039] = 12140,
  [14040] = 12141,
  [14041] = 14041,
  [14042] = 14042,
  [14043] = 14043,
  [14044] = 14044,
  [14045] = 12225,
  [14046] = 12030,
  [14047] = 12108,
  [14048] = 12072,
  [14049] = 12210,
  [14050] = 12092,
  [14051] = 12069,
  [14052] = 12043,
  [14053] = 12087,
  [14054] = 14054,
  [14055] = 12052,
  [14056] = 12086,
  [14057] = 12084,
  [14058] = 12779,
  [14059] = 12083,
  [14060] = 13188,
  [14061] = 12082,
  [14062] = 12081,
  [14063] = 12080,
  [14064] = 13530,
  [14065] = 13867,
  [14066] = 13868,
  [14067] = 13569,
  [14068] = 14068,
  [14069] = 14069,
  [14070] = 14070,
  [14071] = 13547,
  [14072] = 12079,
  [14073] = 13424,
  [14074] = 12078,
  [14075] = 12075,
  [14076] = 12034,
  [14077] = 12774,
  [14078] = 12218,
  [14079] = 12135,
  [14080] = 12179,
  [14081] = 12048,
  [14082] = 14082,
  [14083] = 12068,
  [14084] = 12068,
  [14085] = 12067,
  [14086] = 12365,
  [14087] = 12537,
  [14088] = 12065,
  [14089] = 12579,
  [14090] = 13995,
  [14091] = 13824,
  [14092] = 12063,
  [14093] = 13870,
  [14094] = 12997,
  [14095] = 12062,
  [14096] = 13296,
  [14097] = 13415,
  [14098] = 14068,
  [14099] = 14069,
  [14100] = 12060,
  [14101] = 12097,
  [14102] = 12197,
  [14103] = 13263,
  [14104] = 13237,
  [14105] = 12020,
  [14106] = 12174,
  [14107] = 12058,
  [14108] = 12097,
  [14109] = 12020,
  [14110] = 12175,
  [14111] = 14111,
  [14112] = 12019,
  [14113] = 12206,
  [14114] = 12913,
  [14115] = 12903,
  [14116] = 14116,
  [14117] = 12097,
  [14118] = 12762,
  [14119] = 13519,
  [14120] = 13515,
  [14121] = 14121,
  [14122] = 12210,
  [14123] = 12779,
  [14124] = 12020,
  [14125] = 14125,
  [14126] = 13872,
  [14127] = 12176,
  [14128] = 12750,
  [14129] = 13513,
  [14130] = 12055,
  [14131] = 13539,
  [14132] = 12211,
  [14133] = 12693,
  [14134] = 13540,
  [14135] = 12097,
  [14136] = 12020,
  [14137] = 14137,
  [14138] = 14138,
  [14139] = 12177,
  [14140] = 14140,
  [14141] = 12054,
  [14142] = 12097,
  [14143] = 12020,
  [14144] = 12178,
  [14145] = 12052,
  [14146] = 12097,
  [14147] = 12020,
  [14148] = 12211,
  [14149] = 12028,
  [14150] = 12097,
  [14151] = 12693,
  [14152] = 12020,
  [14153] = 12069,
  [14154] = 12097,
  [14155] = 12656,
  [14156] = 13548,
  [14157] = 13499,
  [14158] = 12020,
  [14159] = 12044,
  [14160] = 12632,
  [14161] = 13414,
  [14162] = 12027,
  [14163] = 13532,
  [14164] = 13290,
  [14165] = 12052,
  [14166] = 12054,
  [14167] = 12394,
  [14168] = 12225,
  [14169] = 12072,
  [14170] = 13569,
  [14171] = 14068,
  [14172] = 14069,
  [14173] = 14070,
  [14174] = 12365,
  [14175] = 12055,
  [14176] = 12019,
  [14177] = 12060,
  [14178] = 12062,
  [14179] = 12063,
  [14180] = 12065,
  [14181] = 13290,
  [14182] = 13411,
  [14183] = 12070,
  [14184] = 12394,
  [14185] = 12225,
  [14186] = 12072,
  [14187] = 13569,
  [14188] = 14068,
  [14189] = 14069,
  [14190] = 14070,
  [14191] = 12365,
  [14192] = 12034,
  [14193] = 12075,
  [14194] = 12078,
  [14195] = 12079,
  [14196] = 12080,
  [14197] = 13290,
  [14198] = 12086,
  [14199] = 12087,
  [14200] = 12394,
  [14201] = 12225,
  [14202] = 12072,
  [14203] = 13569,
  [14204] = 14068,
  [14205] = 14069,
  [14206] = 14070,
  [14207] = 12365,
  [14208] = 12028,
  [14209] = 12046,
  [14210] = 12045,
  [14211] = 12039,
  [14212] = 12036,
  [14213] = 13290,
  [14214] = 12097,
  [14215] = 12020,
  [14216] = 12394,
  [14217] = 12225,
  [14218] = 12072,
  [14219] = 13569,
  [14220] = 14068,
  [14221] = 14069,
  [14222] = 14070,
  [14223] = 12365,
  [14224] = 12021,
  [14225] = 14225,
  [14226] = 12022,
  [14227] = 12630,
  [14228] = 13551,
  [14229] = 13290,
  [14230] = 12038,
  [14231] = 12225,
  [14232] = 12072,
  [14233] = 14068,
  [14234] = 14069,
  [14235] = 14070,
  [14236] = 12365,
  [14237] = 13552,
  [14238] = 12023,
  [14239] = 12024,
  [14240] = 14240,
  [14241] = 14241,
  [14242] = 13290,
  [14243] = 12025,
  [14244] = 12225,
  [14245] = 12072,
  [14246] = 14068,
  [14247] = 14069,
  [14248] = 14070,
  [14249] = 12365,
  [14250] = 12026,
  [14251] = 12027,
  [14252] = 12028,
  [14253] = 12225,
  [14254] = 14068,
  [14255] = 14069,
  [14256] = 14070,
  [14257] = 12365,
  [14258] = 12592,
  [14259] = 13300,
  [14260] = 14260,
  [14261] = 12225,
  [14262] = 14068,
  [14263] = 14069,
  [14264] = 14070,
  [14265] = 12365,
  [14266] = 12035,
  [14267] = 12588,
  [14268] = 12033,
  [14269] = 12225,
  [14270] = 14068,
  [14271] = 14069,
  [14272] = 14070,
  [14273] = 12365,
  [14274] = 13993,
  [14275] = 13992,
  [14276] = 12026,
  [14277] = 12225,
  [14278] = 14068,
  [14279] = 14069,
  [14280] = 14070,
  [14281] = 12365,
  [14282] = 12025,
  [14283] = 12032,
  [14284] = 12115,
  [14285] = 12225,
  [14286] = 14068,
  [14287] = 14069,
  [14288] = 14070,
  [14289] = 12365,
  [14290] = 12030,
  [14291] = 12052,
  [14292] = 14292,
  [14293] = 12225,
  [14294] = 14068,
  [14295] = 14069,
  [14296] = 14070,
  [14297] = 12365,
  [14298] = 12054,
  [14299] = 12055,
  [14300] = 13990,
  [14301] = 12225,
  [14302] = 14068,
  [14303] = 14069,
  [14304] = 14070,
  [14305] = 12365,
  [14306] = 12019,
  [14307] = 12060,
  [14308] = 13482,
  [14309] = 12225,
  [14310] = 14068,
  [14311] = 14069,
  [14312] = 14070,
  [14313] = 12365,
  [14314] = 12062,
  [14315] = 13875,
  [14316] = 12063,
  [14317] = 12225,
  [14318] = 14068,
  [14319] = 14069,
  [14320] = 14070,
  [14321] = 12365,
  [14322] = 13559,
  [14323] = 13560,
  [14324] = 12065,
  [14325] = 12225,
  [14326] = 14068,
  [14327] = 14069,
  [14328] = 14070,
  [14329] = 12365,
  [14330] = 12225,
  [14331] = 14068,
  [14332] = 14069,
  [14333] = 14070,
  [14334] = 12365,
  [14335] = 12225,
  [14336] = 14068,
  [14337] = 14069,
  [14338] = 14070,
  [14339] = 12365,
  [14340] = 12083,
  [14341] = 12070,
  [14342] = 12575,
  [14343] = 12034,
  [14344] = 14344,
  [14345] = 12075,
  [14346] = 12078,
  [14347] = 12079,
  [14348] = 12080,
  [14349] = 12086,
  [14350] = 13992,
  [14351] = 14351,
  [14352] = 13995,
  [14353] = 12087,
  [14354] = 13563,
  [14355] = 12069,
  [14356] = 13473,
  [14357] = 13853,
  [14358] = 12046,
  [14359] = 13565,
  [14360] = 12563,
  [14361] = 12045,
  [14362] = 13487,
  [14363] = 12039,
  [14364] = 13328,
  [14365] = 13175,
  [14366] = 12036,
  [14367] = 12097,
  [14368] = 14368,
  [14369] = 13471,
  [14370] = 12020,
  [14371] = 12021,
  [14372] = 12132,
  [14373] = 12561,
  [14374] = 12417,
  [14375] = 14375,
  [14376] = 12022,
  [14377] = 13406,
  [14378] = 13408,
  [14379] = 12027,
  [14380] = 13411,
  [14381] = 12023,
  [14382] = 12526,
  [14383] = 12024,
  [14384] = 12525,
  [14385] = 12534,
  [14386] = 12433,
  [14387] = 12601,
  [14388] = 12602,
  [14389] = 12025,
  [14390] = 12524,
  [14391] = 12026,
  [14392] = 13480,
  [14393] = 13459,
  [14394] = 12520,
  [14395] = 12513,
  [14396] = 12027,
  [14397] = 12028,
  [14398] = 13507,
  [14399] = 12026,
  [14400] = 12041,
  [14401] = 14401,
  [14402] = 14070,
  [14403] = 13404,
  [14404] = 12024,
  [14405] = 12023,
  [14406] = 13530,
  [14407] = 13987,
  [14408] = 12052,
  [14409] = 12024,
  [14410] = 12054,
  [14411] = 12055,
  [14412] = 12019,
  [14413] = 12058,
  [14414] = 12022,
  [14415] = 12060,
  [14416] = 12062,
  [14417] = 12063,
  [14418] = 12065,
  [14419] = 12067,
  [14420] = 12023,
  [14421] = 12068,
  [14422] = 12022,
  [14423] = 12021,
  [14424] = 12021,
  [14425] = 14344,
  [14426] = 12070,
  [14427] = 12034,
  [14428] = 14344,
  [14429] = 12075,
  [14430] = 12078,
  [14431] = 14344,
  [14432] = 12079,
  [14433] = 14344,
  [14434] = 14344,
  [14435] = 12080,
  [14436] = 12081,
  [14437] = 14344,
  [14438] = 12020,
  [14439] = 12082,
  [14440] = 14344,
  [14441] = 12036,
  [14442] = 12097,
  [14443] = 14344,
  [14444] = 12084,
  [14445] = 12036,
  [14446] = 14344,
  [14447] = 12020,
  [14448] = 12039,
  [14449] = 14344,
  [14450] = 12086,
  [14451] = 12087,
  [14452] = 14344,
  [14453] = 12069,
  [14454] = 14454,
  [14455] = 14344,
  [14456] = 14456,
  [14457] = 12046,
  [14458] = 14344,
  [14459] = 13292,
  [14460] = 12045,
  [14461] = 14344,
  [14462] = 12039,
  [14463] = 12035,
  [14464] = 14344,
  [14465] = 12097,
  [14466] = 12020,
  [14467] = 14344,
  [14468] = 12021,
  [14469] = 12022,
  [14470] = 14344,
  [14471] = 12045,
  [14472] = 13984,
  [14473] = 12023,
  [14474] = 12024,
  [14475] = 12025,
  [14476] = 13300,
  [14477] = 12026,
  [14478] = 12027,
  [14479] = 12028,
  [14480] = 12097,
  [14481] = 12046,
  [14482] = 12030,
  [14483] = 13487,
  [14484] = 12061,
  [14485] = 12069,
  [14486] = 12115,
  [14487] = 12087,
  [14488] = 12086,
  [14489] = 12032,
  [14490] = 12036,
  [14491] = 12033,
  [14492] = 12084,
  [14493] = 12039,
  [14494] = 12045,
  [14495] = 12083,
  [14496] = 12035,
  [14497] = 12082,
  [14498] = 14498,
  [14499] = 12081,
  [14500] = 12038,
  [14501] = 12080,
  [14502] = 12079,
  [14503] = 12078,
  [14504] = 12075,
  [14505] = 12046,
  [14506] = 13510,
  [14507] = 12069,
  [14508] = 12086,
  [14509] = 12034,
  [14510] = 12070,
  [14511] = 14498,
  [14512] = 12068,
  [14513] = 12041,
  [14514] = 12067,
  [14515] = 12065,
  [14516] = 13175,
  [14517] = 12063,
  [14518] = 12062,
  [14519] = 12060,
  [14520] = 13547,
  [14521] = 12087,
  [14522] = 12044,
  [14523] = 13406,
  [14524] = 12058,
  [14525] = 12019,
  [14526] = 12052,
  [14527] = 12055,
  [14528] = 12054,
  [14529] = 12055,
  [14530] = 12019,
  [14531] = 12058,
  [14532] = 12054,
  [14533] = 12060,
  [14534] = 12062,
  [14535] = 12063,
  [14536] = 12065,
  [14537] = 12067,
  [14538] = 12068,
  [14539] = 12052,
  [14540] = 12025,
  [14541] = 12070,
  [14542] = 12034,
  [14543] = 12075,
  [14544] = 12078,
  [14545] = 12079,
  [14546] = 12080,
  [14547] = 12081,
  [14548] = 12082,
  [14549] = 12904,
  [14550] = 12083,
  [14551] = 12049,
  [14552] = 13986,
  [14553] = 12044,
  [14554] = 12784,
  [14555] = 12084,
  [14556] = 13408,
  [14557] = 13810,
  [14558] = 14026,
  [14559] = 12041,
  [14560] = 14121,
  [14561] = 13077,
  [14562] = 14225,
  [14563] = 14498,
  [14564] = 12086,
  [14565] = 12087,
  [14566] = 12069,
  [14567] = 12046,
  [14568] = 12045,
  [14569] = 12039,
  [14570] = 12036,
  [14571] = 12097,
  [14572] = 12020,
  [14573] = 12021,
  [14574] = 12022,
  [14575] = 12023,
  [14576] = 12024,
  [14577] = 12025,
  [14578] = 12026,
  [14579] = 13811,
  [14580] = 9177,
  [14581] = 12027,
  [14582] = 12897,
  [14583] = 12028,
  [14584] = 12101,
  [14585] = 12030,
  [14586] = 12809,
  [14587] = 12115,
  [14588] = 13074,
  [14589] = 12032,
  [14590] = 12033,
  [14591] = 14260,
  [14592] = 13734,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '!', 100,
        '"', 2,
        '$', 24,
        '%', 76,
        '\'', 4,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        ',', 43,
        '-', 73,
        '.', 48,
        '/', 75,
        ':', 60,
        ';', 38,
        '<', 54,
        '=', 46,
        '>', 55,
        '?', 50,
        '@', 82,
        '[', 39,
        ']', 40,
        '^', 77,
        '`', 31,
        '|', 13,
        '#', 81,
        '~', 81,
        'U', 102,
        'u', 102,
        'B', 103,
        'X', 103,
        'b', 103,
        'x', 103,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 99,
        '"', 2,
        '$', 24,
        '\'', 4,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        '-', 73,
        '.', 28,
        '/', 7,
        '0', 87,
        '?', 50,
        '@', 82,
        ']', 40,
        '`', 31,
        '|', 13,
        '#', 81,
        '~', 81,
        'U', 102,
        'u', 102,
        'B', 103,
        'X', 103,
        'b', 103,
        'x', 103,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(88);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(83);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '\'') ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(84);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == '\'') ADVANCE(98);
      if (lookahead != 0) ADVANCE(5);
      END_STATE();
    case 6:
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead != 0) ADVANCE(6);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(9);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead == '/') ADVANCE(45);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '+') ADVANCE(72);
      if (lookahead == '-') ADVANCE(73);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(92);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(93);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 11:
      if (lookahead == '-') ADVANCE(61);
      END_STATE();
    case 12:
      if (lookahead == '/') ADVANCE(81);
      END_STATE();
    case 13:
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '|') ADVANCE(12);
      END_STATE();
    case 14:
      if (lookahead == ':') ADVANCE(52);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '~') ADVANCE(63);
      END_STATE();
    case 16:
      if (lookahead == '>') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == '@') ADVANCE(81);
      END_STATE();
    case 18:
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '>' ||
          lookahead == '?') ADVANCE(61);
      END_STATE();
    case 19:
      if (lookahead == '`') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 21:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 22:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(89);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(90);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(93);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 29:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 31:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(19);
      END_STATE();
    case 32:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '!', 100,
        '"', 2,
        '$', 24,
        '%', 76,
        '\'', 4,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        ',', 43,
        '-', 73,
        '.', 48,
        '/', 75,
        ':', 60,
        ';', 38,
        '<', 54,
        '=', 46,
        '>', 55,
        '?', 50,
        '@', 82,
        '[', 39,
        ']', 40,
        '^', 77,
        '`', 31,
        '|', 13,
        '#', 81,
        '~', 81,
        'U', 102,
        'u', 102,
        'B', 103,
        'X', 103,
        'b', 103,
        'x', 103,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 33:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '!', 15,
        '"', 2,
        '#', 67,
        '%', 76,
        '&', 65,
        '\'', 4,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        ',', 43,
        '-', 74,
        '.', 48,
        '/', 75,
        '0', 92,
        ':', 14,
        ';', 38,
        '<', 53,
        '=', 46,
        '>', 56,
        '?', 64,
        '@', 18,
        '[', 39,
        '^', 78,
        '`', 31,
        '|', 62,
        '~', 63,
        'U', 102,
        'u', 102,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(93);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 34:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '!', 15,
        '"', 2,
        '#', 67,
        '%', 76,
        '&', 65,
        '\'', 4,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        ',', 43,
        '-', 74,
        '.', 48,
        '/', 75,
        ':', 59,
        ';', 38,
        '<', 53,
        '=', 46,
        '>', 56,
        '?', 64,
        '@', 18,
        '[', 39,
        ']', 40,
        '^', 78,
        '`', 31,
        '|', 62,
        '~', 63,
        'U', 102,
        'u', 102,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 35:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '!', 15,
        '"', 2,
        '#', 67,
        '%', 76,
        '&', 65,
        '\'', 6,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        ',', 43,
        '-', 74,
        '.', 48,
        '/', 75,
        ':', 59,
        ';', 38,
        '<', 53,
        '=', 46,
        '>', 56,
        '?', 64,
        '@', 18,
        '[', 39,
        ']', 40,
        '^', 78,
        '`', 31,
        '|', 62,
        '~', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 36:
      if (eof) ADVANCE(37);
      ADVANCE_MAP(
        '!', 15,
        '"', 2,
        '#', 67,
        '%', 76,
        '&', 65,
        '(', 41,
        ')', 42,
        '*', 49,
        '+', 72,
        ',', 43,
        '-', 74,
        '.', 48,
        '/', 75,
        ':', 14,
        ';', 38,
        '<', 53,
        '=', 46,
        '>', 56,
        '?', 64,
        '@', 18,
        '[', 39,
        '^', 78,
        '`', 31,
        '|', 62,
        '~', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(44);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_marginalia);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_parameter);
      if (lookahead == '-' ||
          lookahead == '|') ADVANCE(81);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_parameter);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(16);
      if (lookahead == '<') ADVANCE(71);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '@' ||
          lookahead == '^') ADVANCE(61);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(80);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(58);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(66);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(52);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(52);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_op_other);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '&') ADVANCE(16);
      if (lookahead == '>') ADVANCE(16);
      if (lookahead == '|') ADVANCE(61);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '*') ADVANCE(61);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '-') ADVANCE(70);
      if (lookahead == '|') ADVANCE(70);
      if (lookahead == '#' ||
          lookahead == '&') ADVANCE(61);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '<') ADVANCE(70);
      if (lookahead == '>') ADVANCE(61);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '=') ADVANCE(61);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '>') ADVANCE(68);
      if (lookahead == '#' ||
          lookahead == '-') ADVANCE(61);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '>') ADVANCE(61);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '@') ADVANCE(61);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '|') ADVANCE(61);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_op_other);
      if (lookahead == '=' ||
          lookahead == '|') ADVANCE(61);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(44);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(44);
      if (lookahead == '>') ADVANCE(68);
      if (lookahead == '|') ADVANCE(11);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(9);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '>' ||
          lookahead == '@') ADVANCE(61);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_op_unary_other);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_op_unary_other);
      if (lookahead == '-') ADVANCE(17);
      if (lookahead == '@') ADVANCE(81);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym__double_quote_string);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym__single_quote_string_token1);
      if (lookahead == '\'') ADVANCE(4);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym__single_quote_string_token2);
      if (lookahead == '\'') ADVANCE(6);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym__natural_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      ADVANCE_MAP(
        '.', 97,
        '_', 27,
        'e', 20,
        'B', 22,
        'b', 22,
        'O', 23,
        'o', 23,
        'X', 30,
        'x', 30,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      if (lookahead == '_') ADVANCE(22);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      if (lookahead == '_') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(90);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      ADVANCE_MAP(
        '_', 25,
        'e', 20,
        'B', 22,
        'b', 22,
        'O', 23,
        'o', 23,
        'X', 30,
        'x', 30,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(93);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      if (lookahead == '_') ADVANCE(25);
      if (lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(93);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym__integer_token1);
      if (lookahead == '_') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '_') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym__bit_string_token1);
      if (lookahead == '\'') ADVANCE(5);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_bang);
      if (lookahead == '!') ADVANCE(81);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_bang);
      if (lookahead == '!') ADVANCE(81);
      if (lookahead == '=') ADVANCE(79);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == '&') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym__identifier);
      if (lookahead == '\'') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym__identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'A', 1,
        'a', 1,
        'B', 2,
        'b', 2,
        'C', 3,
        'c', 3,
        'D', 4,
        'd', 4,
        'E', 5,
        'e', 5,
        'F', 6,
        'f', 6,
        'G', 7,
        'g', 7,
        'H', 8,
        'h', 8,
        'I', 9,
        'i', 9,
        'J', 10,
        'j', 10,
        'K', 11,
        'k', 11,
        'L', 12,
        'l', 12,
        'M', 13,
        'm', 13,
        'N', 14,
        'n', 14,
        'O', 15,
        'o', 15,
        'P', 16,
        'p', 16,
        'Q', 17,
        'q', 17,
        'R', 18,
        'r', 18,
        'S', 19,
        's', 19,
        'T', 20,
        't', 20,
        'U', 21,
        'u', 21,
        'V', 22,
        'v', 22,
        'W', 23,
        'w', 23,
        'X', 24,
        'x', 24,
        'Z', 25,
        'z', 25,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        'C', 27,
        'c', 27,
        'D', 28,
        'd', 28,
        'F', 29,
        'f', 29,
        'L', 30,
        'l', 30,
        'N', 31,
        'n', 31,
        'R', 32,
        'r', 32,
        'S', 33,
        's', 33,
        'T', 34,
        't', 34,
        'U', 35,
        'u', 35,
        'V', 36,
        'v', 36,
      );
      END_STATE();
    case 2:
      ADVANCE_MAP(
        'E', 37,
        'e', 37,
        'I', 38,
        'i', 38,
        'O', 39,
        'o', 39,
        'R', 40,
        'r', 40,
        'T', 41,
        't', 41,
        'Y', 42,
        'y', 42,
      );
      END_STATE();
    case 3:
      ADVANCE_MAP(
        'A', 43,
        'a', 43,
        'H', 44,
        'h', 44,
        'O', 45,
        'o', 45,
        'R', 46,
        'r', 46,
        'S', 47,
        's', 47,
        'U', 48,
        'u', 48,
        'Y', 49,
        'y', 49,
      );
      END_STATE();
    case 4:
      ADVANCE_MAP(
        'A', 50,
        'a', 50,
        'E', 51,
        'e', 51,
        'I', 52,
        'i', 52,
        'O', 53,
        'o', 53,
        'R', 54,
        'r', 54,
      );
      END_STATE();
    case 5:
      ADVANCE_MAP(
        'A', 55,
        'a', 55,
        'L', 56,
        'l', 56,
        'N', 57,
        'n', 57,
        'S', 58,
        's', 58,
        'X', 59,
        'x', 59,
      );
      END_STATE();
    case 6:
      ADVANCE_MAP(
        'A', 60,
        'a', 60,
        'I', 61,
        'i', 61,
        'L', 62,
        'l', 62,
        'O', 63,
        'o', 63,
        'R', 64,
        'r', 64,
        'U', 65,
        'u', 65,
      );
      END_STATE();
    case 7:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(67);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 8:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(69);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(70);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        'F', 72,
        'f', 72,
        'G', 73,
        'g', 73,
        'L', 74,
        'l', 74,
        'M', 75,
        'm', 75,
        'N', 76,
        'n', 76,
        'S', 77,
        's', 77,
      );
      END_STATE();
    case 10:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(78);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(79);
      END_STATE();
    case 11:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        'A', 81,
        'a', 81,
        'E', 82,
        'e', 82,
        'I', 83,
        'i', 83,
        'O', 84,
        'o', 84,
      );
      END_STATE();
    case 13:
      ADVANCE_MAP(
        'A', 85,
        'a', 85,
        'E', 86,
        'e', 86,
        'I', 87,
        'i', 87,
        'O', 88,
        'o', 88,
      );
      END_STATE();
    case 14:
      ADVANCE_MAP(
        'A', 89,
        'a', 89,
        'C', 90,
        'c', 90,
        'E', 91,
        'e', 91,
        'O', 92,
        'o', 92,
        'U', 93,
        'u', 93,
        'V', 94,
        'v', 94,
      );
      END_STATE();
    case 15:
      ADVANCE_MAP(
        'F', 95,
        'f', 95,
        'I', 96,
        'i', 96,
        'L', 97,
        'l', 97,
        'N', 98,
        'n', 98,
        'P', 99,
        'p', 99,
        'R', 100,
        'r', 100,
        'T', 101,
        't', 101,
        'U', 102,
        'u', 102,
        'V', 103,
        'v', 103,
        'W', 104,
        'w', 104,
      );
      END_STATE();
    case 16:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(105);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(106);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 17:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(108);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        'A', 109,
        'a', 109,
        'C', 110,
        'c', 110,
        'E', 111,
        'e', 111,
        'I', 112,
        'i', 112,
        'O', 113,
        'o', 113,
      );
      END_STATE();
    case 19:
      ADVANCE_MAP(
        'A', 114,
        'a', 114,
        'C', 115,
        'c', 115,
        'E', 116,
        'e', 116,
        'I', 117,
        'i', 117,
        'M', 118,
        'm', 118,
        'N', 119,
        'n', 119,
        'O', 120,
        'o', 120,
        'P', 121,
        'p', 121,
        'Q', 122,
        'q', 122,
        'T', 123,
        't', 123,
        'U', 124,
        'u', 124,
      );
      END_STATE();
    case 20:
      ADVANCE_MAP(
        'A', 125,
        'a', 125,
        'B', 126,
        'b', 126,
        'E', 127,
        'e', 127,
        'H', 128,
        'h', 128,
        'I', 129,
        'i', 129,
        'O', 130,
        'o', 130,
        'R', 131,
        'r', 131,
        'Y', 132,
        'y', 132,
      );
      END_STATE();
    case 21:
      ADVANCE_MAP(
        'N', 133,
        'n', 133,
        'P', 134,
        'p', 134,
        'S', 135,
        's', 135,
        'U', 136,
        'u', 136,
      );
      END_STATE();
    case 22:
      ADVANCE_MAP(
        'A', 137,
        'a', 137,
        'E', 138,
        'e', 138,
        'I', 139,
        'i', 139,
        'O', 140,
        'o', 140,
      );
      END_STATE();
    case 23:
      ADVANCE_MAP(
        'A', 141,
        'a', 141,
        'H', 142,
        'h', 142,
        'I', 143,
        'i', 143,
        'R', 144,
        'r', 144,
      );
      END_STATE();
    case 24:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(145);
      END_STATE();
    case 25:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(146);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        'A', 1,
        'a', 1,
        'B', 2,
        'b', 2,
        'C', 3,
        'c', 3,
        'D', 4,
        'd', 4,
        'E', 5,
        'e', 5,
        'F', 6,
        'f', 6,
        'G', 7,
        'g', 7,
        'H', 8,
        'h', 8,
        'I', 9,
        'i', 9,
        'J', 10,
        'j', 10,
        'K', 11,
        'k', 11,
        'L', 12,
        'l', 12,
        'M', 13,
        'm', 13,
        'N', 14,
        'n', 14,
        'O', 15,
        'o', 15,
        'P', 16,
        'p', 16,
        'Q', 17,
        'q', 17,
        'R', 18,
        'r', 18,
        'S', 19,
        's', 19,
        'T', 20,
        't', 20,
        'U', 21,
        'u', 21,
        'V', 22,
        'v', 22,
        'W', 23,
        'w', 23,
        'X', 24,
        'x', 24,
        'Z', 25,
        'z', 25,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      END_STATE();
    case 27:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(148);
      END_STATE();
    case 28:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(149);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(150);
      END_STATE();
    case 29:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(151);
      END_STATE();
    case 30:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(152);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(153);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(154);
      END_STATE();
    case 31:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(155);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(156);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(157);
      END_STATE();
    case 32:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(158);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_keyword_as);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(159);
      END_STATE();
    case 34:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(160);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(161);
      END_STATE();
    case 35:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(162);
      END_STATE();
    case 36:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(163);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 37:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(165);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(166);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(167);
      END_STATE();
    case 38:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(168);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(169);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(170);
      END_STATE();
    case 39:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(171);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(172);
      END_STATE();
    case 40:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(173);
      END_STATE();
    case 41:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_keyword_by);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(175);
      END_STATE();
    case 43:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(176);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(177);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(178);
      END_STATE();
    case 44:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(179);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        'L', 181,
        'l', 181,
        'M', 182,
        'm', 182,
        'N', 183,
        'n', 183,
        'P', 184,
        'p', 184,
        'S', 185,
        's', 185,
      );
      END_STATE();
    case 46:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(186);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 47:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(188);
      END_STATE();
    case 48:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 49:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 50:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(191);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        'C', 192,
        'c', 192,
        'F', 193,
        'f', 193,
        'L', 194,
        'l', 194,
        'S', 195,
        's', 195,
      );
      END_STATE();
    case 52:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(196);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_keyword_do);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(197);
      END_STATE();
    case 54:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 55:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(199);
      END_STATE();
    case 56:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(200);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        'C', 201,
        'c', 201,
        'D', 202,
        'd', 202,
        'G', 203,
        'g', 203,
        'U', 204,
        'u', 204,
      );
      END_STATE();
    case 58:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(205);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        'C', 206,
        'c', 206,
        'E', 207,
        'e', 207,
        'I', 208,
        'i', 208,
        'P', 209,
        'p', 209,
        'T', 210,
        't', 210,
      );
      END_STATE();
    case 60:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(211);
      END_STATE();
    case 61:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(212);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(213);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(214);
      END_STATE();
    case 62:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(215);
      END_STATE();
    case 63:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(216);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 64:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 65:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(220);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(221);
      END_STATE();
    case 66:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(222);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 67:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(224);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(225);
      END_STATE();
    case 68:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(226);
      END_STATE();
    case 69:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(227);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(228);
      END_STATE();
    case 70:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 71:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(230);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_keyword_if);
      END_STATE();
    case 73:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(231);
      END_STATE();
    case 74:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 75:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(233);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(234);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_keyword_in);
      ADVANCE_MAP(
        'C', 235,
        'c', 235,
        'D', 236,
        'd', 236,
        'E', 237,
        'e', 237,
        'I', 238,
        'i', 238,
        'N', 239,
        'n', 239,
        'O', 240,
        'o', 240,
        'P', 241,
        'p', 241,
        'S', 242,
        's', 242,
        'T', 243,
        't', 243,
        'V', 244,
        'v', 244,
      );
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_keyword_is);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(245);
      END_STATE();
    case 78:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(246);
      END_STATE();
    case 79:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 80:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(248);
      END_STATE();
    case 81:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(249);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(250);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(251);
      END_STATE();
    case 82:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(252);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(253);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(254);
      END_STATE();
    case 83:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(255);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(256);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 84:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(258);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(259);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(260);
      END_STATE();
    case 85:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(261);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(262);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(263);
      END_STATE();
    case 86:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(264);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(265);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(266);
      END_STATE();
    case 87:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(267);
      END_STATE();
    case 88:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(268);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(269);
      END_STATE();
    case 89:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(270);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(271);
      END_STATE();
    case 90:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(272);
      END_STATE();
    case 91:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(273);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_keyword_no);
      ADVANCE_MAP(
        'N', 274,
        'n', 274,
        'S', 275,
        's', 275,
        'T', 276,
        't', 276,
        'W', 277,
        'w', 277,
      );
      END_STATE();
    case 93:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(278);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(279);
      END_STATE();
    case 94:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_keyword_of);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 96:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(282);
      END_STATE();
    case 97:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(283);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_keyword_on);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 99:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(285);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_keyword_or);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(286);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(287);
      END_STATE();
    case 101:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(288);
      END_STATE();
    case 102:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(289);
      END_STATE();
    case 103:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 104:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(291);
      END_STATE();
    case 105:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(292);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(293);
      END_STATE();
    case 106:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(294);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      END_STATE();
    case 107:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(296);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(297);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 108:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 109:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(300);
      END_STATE();
    case 110:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(301);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        'A', 302,
        'a', 302,
        'C', 303,
        'c', 303,
        'F', 304,
        'f', 304,
        'G', 305,
        'g', 305,
        'N', 306,
        'n', 306,
        'P', 307,
        'p', 307,
        'S', 308,
        's', 308,
        'T', 309,
        't', 309,
        'W', 310,
        'w', 310,
      );
      END_STATE();
    case 112:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(311);
      END_STATE();
    case 113:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(312);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(313);
      END_STATE();
    case 114:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(314);
      END_STATE();
    case 115:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(315);
      END_STATE();
    case 116:
      ADVANCE_MAP(
        'C', 316,
        'c', 316,
        'L', 317,
        'l', 317,
        'P', 318,
        'p', 318,
        'Q', 319,
        'q', 319,
        'R', 320,
        'r', 320,
        'S', 321,
        's', 321,
        'T', 322,
        't', 322,
      );
      END_STATE();
    case 117:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(323);
      END_STATE();
    case 118:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(324);
      END_STATE();
    case 119:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 120:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(326);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(327);
      END_STATE();
    case 121:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(328);
      END_STATE();
    case 122:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 123:
      ADVANCE_MAP(
        'A', 330,
        'a', 330,
        'D', 331,
        'd', 331,
        'O', 332,
        'o', 332,
        'R', 333,
        'r', 333,
      );
      END_STATE();
    case 124:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(334);
      END_STATE();
    case 125:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(335);
      END_STATE();
    case 126:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(336);
      END_STATE();
    case 127:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(337);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(338);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(339);
      END_STATE();
    case 128:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 129:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(341);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(342);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_keyword_to);
      END_STATE();
    case 131:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(344);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(345);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(346);
      END_STATE();
    case 132:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(347);
      END_STATE();
    case 133:
      ADVANCE_MAP(
        'B', 348,
        'b', 348,
        'C', 349,
        'c', 349,
        'I', 350,
        'i', 350,
        'L', 351,
        'l', 351,
        'S', 352,
        's', 352,
        'T', 353,
        't', 353,
      );
      END_STATE();
    case 134:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(354);
      END_STATE();
    case 135:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(355);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(356);
      END_STATE();
    case 136:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(357);
      END_STATE();
    case 137:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(358);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(359);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(360);
      END_STATE();
    case 138:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(361);
      END_STATE();
    case 139:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(362);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(363);
      END_STATE();
    case 140:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(364);
      END_STATE();
    case 141:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(365);
      END_STATE();
    case 142:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 143:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(367);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(368);
      END_STATE();
    case 144:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(369);
      END_STATE();
    case 145:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(370);
      END_STATE();
    case 146:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(371);
      END_STATE();
    case 147:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(372);
      END_STATE();
    case 148:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(373);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_keyword_add);
      END_STATE();
    case 150:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 151:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_keyword_all);
      END_STATE();
    case 153:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 154:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(377);
      END_STATE();
    case 155:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(378);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_keyword_and);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_keyword_any);
      END_STATE();
    case 158:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(379);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_keyword_asc);
      END_STATE();
    case 160:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(380);
      END_STATE();
    case 161:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(381);
      END_STATE();
    case 162:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(382);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(383);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_keyword_avg);
      END_STATE();
    case 164:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(384);
      END_STATE();
    case 165:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(385);
      END_STATE();
    case 166:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(386);
      END_STATE();
    case 167:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(387);
      END_STATE();
    case 168:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(388);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(389);
      END_STATE();
    case 169:
      if (lookahead == '_') ADVANCE(390);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(391);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_keyword_bit);
      END_STATE();
    case 171:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(392);
      END_STATE();
    case 172:
      if (lookahead == '2') ADVANCE(393);
      if (lookahead == '3') ADVANCE(394);
      END_STATE();
    case 173:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(395);
      END_STATE();
    case 174:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 175:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(397);
      END_STATE();
    case 176:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(398);
      END_STATE();
    case 177:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(399);
      END_STATE();
    case 178:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(400);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(401);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(402);
      END_STATE();
    case 179:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(403);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(404);
      END_STATE();
    case 180:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(405);
      END_STATE();
    case 181:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(406);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(407);
      END_STATE();
    case 182:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(408);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(409);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        'C', 410,
        'c', 410,
        'F', 411,
        'f', 411,
        'N', 412,
        'n', 412,
        'S', 413,
        's', 413,
      );
      END_STATE();
    case 184:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(414);
      END_STATE();
    case 185:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(415);
      END_STATE();
    case 186:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(416);
      END_STATE();
    case 187:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(417);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_keyword_csv);
      END_STATE();
    case 189:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(418);
      END_STATE();
    case 190:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 191:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(420);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 192:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(422);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(423);
      END_STATE();
    case 193:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(424);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(425);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(426);
      END_STATE();
    case 194:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(427);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(428);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(429);
      END_STATE();
    case 195:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(430);
      END_STATE();
    case 196:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(431);
      END_STATE();
    case 197:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(432);
      END_STATE();
    case 198:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(433);
      END_STATE();
    case 199:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(434);
      END_STATE();
    case 200:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 201:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(436);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(437);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_keyword_end);
      END_STATE();
    case 203:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(438);
      END_STATE();
    case 204:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(439);
      END_STATE();
    case 205:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(440);
      END_STATE();
    case 206:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(441);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(442);
      END_STATE();
    case 207:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(443);
      END_STATE();
    case 208:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(444);
      END_STATE();
    case 209:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(445);
      END_STATE();
    case 210:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(446);
      END_STATE();
    case 211:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(447);
      END_STATE();
    case 212:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(448);
      END_STATE();
    case 213:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(449);
      END_STATE();
    case 214:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(450);
      END_STATE();
    case 215:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(451);
      END_STATE();
    case 216:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(452);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_keyword_for);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(453);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(454);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(455);
      END_STATE();
    case 218:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(456);
      END_STATE();
    case 219:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(457);
      END_STATE();
    case 220:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 221:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(459);
      END_STATE();
    case 222:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(460);
      END_STATE();
    case 223:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(461);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(462);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_keyword_gin);
      END_STATE();
    case 225:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(463);
      END_STATE();
    case 226:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(464);
      END_STATE();
    case 227:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(465);
      END_STATE();
    case 228:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(466);
      END_STATE();
    case 229:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(467);
      END_STATE();
    case 230:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(468);
      END_STATE();
    case 231:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(469);
      END_STATE();
    case 232:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(470);
      END_STATE();
    case 233:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(471);
      END_STATE();
    case 234:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(472);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(473);
      END_STATE();
    case 235:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(474);
      END_STATE();
    case 236:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(475);
      END_STATE();
    case 237:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(476);
      END_STATE();
    case 238:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(477);
      END_STATE();
    case 239:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 240:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(479);
      END_STATE();
    case 241:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(480);
      END_STATE();
    case 242:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(481);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(482);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym_keyword_int_token1);
      ADVANCE_MAP(
        '1', 483,
        '2', 484,
        '3', 485,
        '4', 486,
        '8', 487,
        'E', 488,
        'e', 488,
        'O', 489,
        'o', 489,
      );
      END_STATE();
    case 244:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(490);
      END_STATE();
    case 245:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(491);
      END_STATE();
    case 246:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(492);
      END_STATE();
    case 247:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(493);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_keyword_key);
      END_STATE();
    case 249:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(494);
      END_STATE();
    case 250:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(495);
      END_STATE();
    case 251:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(496);
      END_STATE();
    case 252:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(497);
      END_STATE();
    case 253:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(498);
      END_STATE();
    case 254:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(499);
      END_STATE();
    case 255:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(500);
      END_STATE();
    case 256:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(501);
      END_STATE();
    case 257:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(502);
      END_STATE();
    case 258:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 259:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(504);
      END_STATE();
    case 260:
      if (lookahead == '_') ADVANCE(505);
      END_STATE();
    case 261:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(506);
      END_STATE();
    case 262:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(507);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(508);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_keyword_max);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(509);
      END_STATE();
    case 264:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(510);
      END_STATE();
    case 265:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(511);
      END_STATE();
    case 266:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(512);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_keyword_min);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(513);
      END_STATE();
    case 268:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(514);
      END_STATE();
    case 269:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 270:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 271:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(517);
      END_STATE();
    case 272:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(518);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_keyword_new);
      END_STATE();
    case 274:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(519);
      END_STATE();
    case 275:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(520);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_keyword_not);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(521);
      END_STATE();
    case 277:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(522);
      END_STATE();
    case 278:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(523);
      END_STATE();
    case 279:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(524);
      END_STATE();
    case 280:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(525);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_keyword_off);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(526);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_keyword_oid);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(527);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_keyword_old);
      END_STATE();
    case 284:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(528);
      END_STATE();
    case 285:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(529);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_keyword_orc);
      END_STATE();
    case 287:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(530);
      END_STATE();
    case 288:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(531);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_keyword_out);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(532);
      END_STATE();
    case 290:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(533);
      END_STATE();
    case 291:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 292:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(535);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(536);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(537);
      END_STATE();
    case 293:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(538);
      END_STATE();
    case 294:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(539);
      END_STATE();
    case 295:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(540);
      END_STATE();
    case 296:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(541);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(542);
      END_STATE();
    case 297:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(543);
      END_STATE();
    case 298:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(544);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(545);
      END_STATE();
    case 299:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(546);
      END_STATE();
    case 300:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(547);
      END_STATE();
    case 301:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(548);
      END_STATE();
    case 302:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(549);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(550);
      END_STATE();
    case 303:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(551);
      END_STATE();
    case 304:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(552);
      END_STATE();
    case 305:
      ADVANCE_MAP(
        'C', 553,
        'c', 553,
        'N', 554,
        'n', 554,
        'P', 555,
        'p', 555,
        'T', 556,
        't', 556,
      );
      END_STATE();
    case 306:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(557);
      END_STATE();
    case 307:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(558);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(559);
      END_STATE();
    case 308:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(560);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(561);
      END_STATE();
    case 309:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      END_STATE();
    case 310:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(563);
      END_STATE();
    case 311:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(564);
      END_STATE();
    case 312:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(565);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(566);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_keyword_row);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(567);
      END_STATE();
    case 314:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 315:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(569);
      END_STATE();
    case 316:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(570);
      END_STATE();
    case 317:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(571);
      END_STATE();
    case 318:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(572);
      END_STATE();
    case 319:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(573);
      END_STATE();
    case 320:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(574);
      END_STATE();
    case 321:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(575);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_keyword_set);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(576);
      END_STATE();
    case 323:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(577);
      END_STATE();
    case 324:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(578);
      END_STATE();
    case 325:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(579);
      END_STATE();
    case 326:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(580);
      END_STATE();
    case 327:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(581);
      END_STATE();
    case 328:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(582);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_keyword_sql);
      END_STATE();
    case 330:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(583);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(584);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(585);
      END_STATE();
    case 331:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(586);
      END_STATE();
    case 332:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(587);
      END_STATE();
    case 333:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(588);
      END_STATE();
    case 334:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(589);
      END_STATE();
    case 335:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(590);
      END_STATE();
    case 336:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(591);
      END_STATE();
    case 337:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(592);
      END_STATE();
    case 338:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(593);
      END_STATE();
    case 339:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(594);
      END_STATE();
    case 340:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(595);
      END_STATE();
    case 341:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(596);
      END_STATE();
    case 342:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(597);
      END_STATE();
    case 343:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(598);
      END_STATE();
    case 344:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(599);
      END_STATE();
    case 345:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(600);
      END_STATE();
    case 346:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(601);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(602);
      END_STATE();
    case 347:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(603);
      END_STATE();
    case 348:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(604);
      END_STATE();
    case 349:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(605);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(606);
      END_STATE();
    case 350:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(607);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(608);
      END_STATE();
    case 351:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(609);
      END_STATE();
    case 352:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(610);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(611);
      END_STATE();
    case 353:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(612);
      END_STATE();
    case 354:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(613);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_keyword_use);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(614);
      END_STATE();
    case 356:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(615);
      END_STATE();
    case 357:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(616);
      END_STATE();
    case 358:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(617);
      END_STATE();
    case 359:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(618);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(619);
      END_STATE();
    case 360:
      ADVANCE_MAP(
        'B', 620,
        'b', 620,
        'C', 621,
        'c', 621,
        'I', 622,
        'i', 622,
        'Y', 623,
        'y', 623,
      );
      END_STATE();
    case 361:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(624);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(625);
      END_STATE();
    case 362:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(626);
      END_STATE();
    case 363:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(627);
      END_STATE();
    case 364:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(628);
      END_STATE();
    case 365:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(629);
      END_STATE();
    case 366:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(630);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(631);
      END_STATE();
    case 367:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(632);
      END_STATE();
    case 368:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(633);
      END_STATE();
    case 369:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(634);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_keyword_xml);
      END_STATE();
    case 371:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(635);
      END_STATE();
    case 372:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(636);
      END_STATE();
    case 373:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(637);
      END_STATE();
    case 374:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(638);
      END_STATE();
    case 375:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(639);
      END_STATE();
    case 376:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(640);
      END_STATE();
    case 377:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(641);
      END_STATE();
    case 378:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(642);
      END_STATE();
    case 379:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(643);
      END_STATE();
    case 380:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(644);
      END_STATE();
    case 381:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(645);
      END_STATE();
    case 382:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(646);
      END_STATE();
    case 383:
      if (lookahead == '_') ADVANCE(647);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_keyword_avro);
      END_STATE();
    case 385:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(648);
      END_STATE();
    case 386:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(649);
      END_STATE();
    case 387:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(650);
      END_STATE();
    case 388:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(651);
      END_STATE();
    case 389:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(652);
      END_STATE();
    case 390:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(653);
      END_STATE();
    case 391:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(654);
      END_STATE();
    case 392:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(655);
      END_STATE();
    case 393:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(656);
      END_STATE();
    case 394:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(657);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_keyword_brin);
      END_STATE();
    case 396:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(658);
      END_STATE();
    case 397:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(659);
      END_STATE();
    case 398:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(660);
      END_STATE();
    case 399:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(661);
      END_STATE();
    case 400:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(662);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_keyword_case);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_keyword_cast);
      END_STATE();
    case 403:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(663);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_keyword_char_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(664);
      END_STATE();
    case 405:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(665);
      END_STATE();
    case 406:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(666);
      END_STATE();
    case 407:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(667);
      END_STATE();
    case 408:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(668);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(669);
      END_STATE();
    case 409:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(670);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(671);
      END_STATE();
    case 410:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(672);
      END_STATE();
    case 411:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(673);
      END_STATE();
    case 412:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(674);
      END_STATE();
    case 413:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(675);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_keyword_copy);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_keyword_cost);
      END_STATE();
    case 416:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(676);
      END_STATE();
    case 417:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(677);
      END_STATE();
    case 418:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(678);
      END_STATE();
    case 419:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(679);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_keyword_data);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(680);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_keyword_date);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(681);
      END_STATE();
    case 422:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(682);
      END_STATE();
    case 423:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(683);
      END_STATE();
    case 424:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(684);
      END_STATE();
    case 425:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(685);
      END_STATE();
    case 426:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(686);
      END_STATE();
    case 427:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(687);
      END_STATE();
    case 428:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(688);
      END_STATE();
    case 429:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(689);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(sym_keyword_desc);
      END_STATE();
    case 431:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(690);
      END_STATE();
    case 432:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(691);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym_keyword_drop);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym_keyword_each);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym_keyword_else);
      END_STATE();
    case 436:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(692);
      END_STATE();
    case 437:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(693);
      END_STATE();
    case 438:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(694);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym_keyword_enum);
      END_STATE();
    case 440:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(695);
      END_STATE();
    case 441:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(696);
      END_STATE();
    case 442:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(697);
      END_STATE();
    case 443:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(698);
      END_STATE();
    case 444:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(699);
      END_STATE();
    case 445:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(700);
      END_STATE();
    case 446:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(701);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(702);
      END_STATE();
    case 447:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(703);
      END_STATE();
    case 448:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(704);
      END_STATE();
    case 449:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(705);
      END_STATE();
    case 450:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(706);
      END_STATE();
    case 451:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(707);
      END_STATE();
    case 452:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(708);
      END_STATE();
    case 453:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(709);
      END_STATE();
    case 454:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(710);
      END_STATE();
    case 455:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(711);
      END_STATE();
    case 456:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(712);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym_keyword_from);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(sym_keyword_full);
      END_STATE();
    case 459:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(713);
      END_STATE();
    case 460:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(714);
      END_STATE();
    case 461:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(715);
      END_STATE();
    case 462:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(716);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(sym_keyword_gist);
      END_STATE();
    case 464:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(717);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(sym_keyword_hash);
      END_STATE();
    case 466:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(718);
      END_STATE();
    case 467:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(719);
      END_STATE();
    case 468:
      if (lookahead == '_') ADVANCE(720);
      END_STATE();
    case 469:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(721);
      END_STATE();
    case 470:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(722);
      END_STATE();
    case 471:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(723);
      END_STATE();
    case 472:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(724);
      END_STATE();
    case 473:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(725);
      END_STATE();
    case 474:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(726);
      END_STATE();
    case 475:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(727);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(sym_keyword_inet);
      END_STATE();
    case 477:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(728);
      END_STATE();
    case 478:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(729);
      END_STATE();
    case 479:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(730);
      END_STATE();
    case 480:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(731);
      END_STATE();
    case 481:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(732);
      END_STATE();
    case 482:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(733);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(aux_sym_keyword_tinyint_token2);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(aux_sym_keyword_smallint_token2);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(aux_sym_keyword_mediumint_token2);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(aux_sym_keyword_int_token3);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(aux_sym_keyword_bigint_token2);
      END_STATE();
    case 488:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(734);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(735);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(sym_keyword_into);
      END_STATE();
    case 490:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(736);
      END_STATE();
    case 491:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(737);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_keyword_join);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(sym_keyword_json);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(738);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(739);
      END_STATE();
    case 494:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(740);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_keyword_last);
      END_STATE();
    case 496:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(741);
      END_STATE();
    case 497:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(742);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_keyword_left);
      END_STATE();
    case 499:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(743);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_keyword_like_token1);
      END_STATE();
    case 501:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(744);
      END_STATE();
    case 502:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(745);
      END_STATE();
    case 503:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(746);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(747);
      END_STATE();
    case 504:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(748);
      END_STATE();
    case 505:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(749);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_keyword_main);
      END_STATE();
    case 507:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(750);
      END_STATE();
    case 508:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(751);
      END_STATE();
    case 509:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(752);
      END_STATE();
    case 510:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(753);
      END_STATE();
    case 511:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(754);
      END_STATE();
    case 512:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(755);
      END_STATE();
    case 513:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(756);
      END_STATE();
    case 514:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(757);
      END_STATE();
    case 515:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(758);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_keyword_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(759);
      END_STATE();
    case 517:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(760);
      END_STATE();
    case 518:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(761);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_keyword_none);
      END_STATE();
    case 520:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(762);
      END_STATE();
    case 521:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(763);
      END_STATE();
    case 522:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(764);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_keyword_null);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(765);
      END_STATE();
    case 524:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(766);
      END_STATE();
    case 525:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(767);
      END_STATE();
    case 526:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(768);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(sym_keyword_oids);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_keyword_only);
      END_STATE();
    case 529:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(769);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(770);
      END_STATE();
    case 530:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(771);
      END_STATE();
    case 531:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(772);
      END_STATE();
    case 532:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(773);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_keyword_over);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(774);
      END_STATE();
    case 534:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(775);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(776);
      END_STATE();
    case 535:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(777);
      END_STATE();
    case 536:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(778);
      END_STATE();
    case 537:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(779);
      END_STATE();
    case 538:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(780);
      END_STATE();
    case 539:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(781);
      END_STATE();
    case 540:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(782);
      END_STATE();
    case 541:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(783);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(784);
      END_STATE();
    case 542:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(785);
      END_STATE();
    case 543:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(786);
      END_STATE();
    case 544:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(787);
      END_STATE();
    case 545:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(788);
      END_STATE();
    case 546:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(789);
      END_STATE();
    case 547:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(790);
      END_STATE();
    case 548:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(791);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_keyword_read);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(aux_sym_keyword_real_token1);
      END_STATE();
    case 551:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(792);
      END_STATE();
    case 552:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(793);
      END_STATE();
    case 553:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(794);
      END_STATE();
    case 554:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(795);
      END_STATE();
    case 555:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(796);
      END_STATE();
    case 556:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(797);
      END_STATE();
    case 557:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(798);
      END_STATE();
    case 558:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(799);
      END_STATE();
    case 559:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(800);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(801);
      END_STATE();
    case 560:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(802);
      END_STATE();
    case 561:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(803);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(804);
      END_STATE();
    case 562:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(805);
      END_STATE();
    case 563:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(806);
      END_STATE();
    case 564:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(807);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_keyword_role);
      END_STATE();
    case 566:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(808);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_keyword_rows);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_keyword_safe);
      END_STATE();
    case 569:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(809);
      END_STATE();
    case 570:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(810);
      END_STATE();
    case 571:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(811);
      END_STATE();
    case 572:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(812);
      END_STATE();
    case 573:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(813);
      END_STATE();
    case 574:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(814);
      END_STATE();
    case 575:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(815);
      END_STATE();
    case 576:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(816);
      END_STATE();
    case 577:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(817);
      END_STATE();
    case 578:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(818);
      END_STATE();
    case 579:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(819);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_keyword_some);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_keyword_sort);
      END_STATE();
    case 582:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(820);
      END_STATE();
    case 583:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(821);
      END_STATE();
    case 584:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(822);
      END_STATE();
    case 585:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(823);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(824);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(825);
      END_STATE();
    case 586:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(826);
      END_STATE();
    case 587:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(827);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(828);
      END_STATE();
    case 588:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(829);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(830);
      END_STATE();
    case 589:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(831);
      END_STATE();
    case 590:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(832);
      END_STATE();
    case 591:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(833);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_keyword_temp);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(834);
      END_STATE();
    case 593:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(835);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_keyword_text);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(836);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_keyword_then);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_keyword_ties);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_keyword_time);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(837);
      END_STATE();
    case 598:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(838);
      END_STATE();
    case 599:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(839);
      END_STATE();
    case 600:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(840);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_keyword_true);
      END_STATE();
    case 602:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(841);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_keyword_type);
      END_STATE();
    case 604:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(842);
      END_STATE();
    case 605:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(843);
      END_STATE();
    case 606:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(844);
      END_STATE();
    case 607:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(845);
      END_STATE();
    case 608:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(846);
      END_STATE();
    case 609:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(847);
      END_STATE();
    case 610:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(848);
      END_STATE();
    case 611:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(849);
      END_STATE();
    case 612:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(850);
      END_STATE();
    case 613:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(851);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_keyword_user);
      END_STATE();
    case 615:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(852);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_keyword_uuid);
      END_STATE();
    case 617:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(853);
      END_STATE();
    case 618:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(854);
      END_STATE();
    case 619:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(855);
      END_STATE();
    case 620:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(856);
      END_STATE();
    case 621:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(857);
      END_STATE();
    case 622:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(858);
      END_STATE();
    case 623:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(859);
      END_STATE();
    case 624:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(860);
      END_STATE();
    case 625:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(861);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_keyword_view);
      END_STATE();
    case 627:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(862);
      END_STATE();
    case 628:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(863);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_keyword_wait);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_keyword_when);
      END_STATE();
    case 631:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(864);
      END_STATE();
    case 632:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(865);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_keyword_with);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(866);
      END_STATE();
    case 634:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(867);
      END_STATE();
    case 635:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(868);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_keyword_zone);
      END_STATE();
    case 637:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(869);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_keyword_admin);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_keyword_after);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_keyword_alter);
      END_STATE();
    case 641:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(870);
      END_STATE();
    case 642:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(871);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_keyword_array);
      END_STATE();
    case 644:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(872);
      END_STATE();
    case 645:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(873);
      END_STATE();
    case 646:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(874);
      END_STATE();
    case 647:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(875);
      END_STATE();
    case 648:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(876);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_keyword_begin);
      END_STATE();
    case 650:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(877);
      END_STATE();
    case 651:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(878);
      END_STATE();
    case 652:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(879);
      END_STATE();
    case 653:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(880);
      END_STATE();
    case 654:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(881);
      END_STATE();
    case 655:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(882);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_keyword_box2d);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_keyword_box3d);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_keyword_btree);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_keyword_bytea);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_keyword_cache);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(883);
      END_STATE();
    case 661:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(884);
      END_STATE();
    case 662:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(885);
      END_STATE();
    case 663:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(886);
      END_STATE();
    case 664:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(887);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_keyword_check);
      END_STATE();
    case 666:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(888);
      END_STATE();
    case 667:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(889);
      END_STATE();
    case 668:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(890);
      END_STATE();
    case 669:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(891);
      END_STATE();
    case 670:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(892);
      END_STATE();
    case 671:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(893);
      END_STATE();
    case 672:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(894);
      END_STATE();
    case 673:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(895);
      END_STATE();
    case 674:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(896);
      END_STATE();
    case 675:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(897);
      END_STATE();
    case 676:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(898);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_keyword_cross);
      END_STATE();
    case 678:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(899);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_keyword_cycle);
      END_STATE();
    case 680:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(900);
      END_STATE();
    case 681:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(901);
      END_STATE();
    case 682:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(902);
      END_STATE();
    case 683:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(903);
      END_STATE();
    case 684:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(904);
      END_STATE();
    case 685:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(905);
      END_STATE();
    case 686:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(906);
      END_STATE();
    case 687:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(907);
      END_STATE();
    case 688:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(908);
      END_STATE();
    case 689:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(909);
      END_STATE();
    case 690:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(910);
      END_STATE();
    case 691:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(911);
      END_STATE();
    case 692:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(912);
      END_STATE();
    case 693:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(913);
      END_STATE();
    case 694:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(914);
      END_STATE();
    case 695:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(915);
      END_STATE();
    case 696:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(916);
      END_STATE();
    case 697:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(917);
      END_STATE();
    case 698:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(918);
      END_STATE();
    case 699:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(919);
      END_STATE();
    case 700:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(920);
      END_STATE();
    case 701:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(921);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(922);
      END_STATE();
    case 702:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(923);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_keyword_false);
      END_STATE();
    case 704:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(924);
      END_STATE();
    case 705:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(925);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_keyword_first);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_keyword_float);
      if (lookahead == '4') ADVANCE(926);
      if (lookahead == '8') ADVANCE(927);
      END_STATE();
    case 708:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(928);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_keyword_force);
      if (lookahead == '_') ADVANCE(929);
      END_STATE();
    case 710:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(930);
      END_STATE();
    case 711:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(931);
      END_STATE();
    case 712:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(932);
      END_STATE();
    case 713:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(933);
      END_STATE();
    case 714:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(934);
      END_STATE();
    case 715:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(935);
      END_STATE();
    case 716:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(936);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_keyword_group);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(937);
      END_STATE();
    case 718:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(938);
      END_STATE();
    case 719:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(939);
      END_STATE();
    case 720:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(940);
      END_STATE();
    case 721:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(941);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(aux_sym_keyword_like_token2);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym_keyword_image);
      END_STATE();
    case 724:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(942);
      END_STATE();
    case 725:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(943);
      END_STATE();
    case 726:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(944);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym_keyword_index);
      END_STATE();
    case 728:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(945);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_keyword_inner);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_keyword_inout);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_keyword_input);
      END_STATE();
    case 732:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(946);
      END_STATE();
    case 733:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(947);
      END_STATE();
    case 734:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(948);
      END_STATE();
    case 735:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(949);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(950);
      END_STATE();
    case 736:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(951);
      END_STATE();
    case 737:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(952);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_keyword_jsonb);
      END_STATE();
    case 739:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(953);
      END_STATE();
    case 740:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(954);
      END_STATE();
    case 741:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(955);
      END_STATE();
    case 742:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(956);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_keyword_level);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_keyword_limit);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_keyword_lines);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym_keyword_local);
      END_STATE();
    case 747:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(957);
      END_STATE();
    case 748:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(958);
      END_STATE();
    case 749:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(959);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_keyword_match);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(960);
      END_STATE();
    case 751:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(961);
      END_STATE();
    case 752:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(962);
      END_STATE();
    case 753:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(963);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym_keyword_merge);
      END_STATE();
    case 755:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(964);
      END_STATE();
    case 756:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(965);
      END_STATE();
    case 757:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(966);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym_keyword_money);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(sym_keyword_names);
      END_STATE();
    case 760:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(967);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(sym_keyword_nchar);
      END_STATE();
    case 762:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(968);
      END_STATE();
    case 763:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(969);
      END_STATE();
    case 764:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(970);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(sym_keyword_nulls);
      END_STATE();
    case 766:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(971);
      END_STATE();
    case 767:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(972);
      END_STATE();
    case 768:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(973);
      END_STATE();
    case 769:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(974);
      END_STATE();
    case 770:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(975);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_keyword_order);
      END_STATE();
    case 772:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(976);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_keyword_outer);
      END_STATE();
    case 774:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(977);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_keyword_owned);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_keyword_owner);
      END_STATE();
    case 777:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(978);
      END_STATE();
    case 778:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(979);
      END_STATE();
    case 779:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(980);
      END_STATE();
    case 780:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(981);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_keyword_plain);
      END_STATE();
    case 782:
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(982);
      END_STATE();
    case 783:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(983);
      END_STATE();
    case 784:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(984);
      END_STATE();
    case 785:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(985);
      END_STATE();
    case 786:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(986);
      END_STATE();
    case 787:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(987);
      END_STATE();
    case 788:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(988);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym_keyword_quote);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym_keyword_range);
      END_STATE();
    case 791:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(989);
      END_STATE();
    case 792:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(990);
      END_STATE();
    case 793:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(991);
      END_STATE();
    case 794:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(992);
      END_STATE();
    case 795:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(993);
      END_STATE();
    case 796:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(994);
      END_STATE();
    case 797:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(995);
      END_STATE();
    case 798:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(996);
      END_STATE();
    case 799:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(997);
      END_STATE();
    case 800:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(998);
      END_STATE();
    case 801:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(999);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym_keyword_reset);
      END_STATE();
    case 803:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1000);
      END_STATE();
    case 804:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1001);
      END_STATE();
    case 805:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1002);
      END_STATE();
    case 806:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1003);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym_keyword_right);
      END_STATE();
    case 808:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1004);
      END_STATE();
    case 809:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1005);
      END_STATE();
    case 810:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1006);
      END_STATE();
    case 811:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1007);
      END_STATE();
    case 812:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1008);
      END_STATE();
    case 813:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1009);
      END_STATE();
    case 814:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1010);
      END_STATE();
    case 815:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1011);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym_keyword_setof);
      END_STATE();
    case 817:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1012);
      END_STATE();
    case 818:
      ADVANCE_MAP(
        'D', 1013,
        'd', 1013,
        'I', 1014,
        'i', 1014,
        'M', 1015,
        'm', 1015,
        'S', 1016,
        's', 1016,
      );
      END_STATE();
    case 819:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1017);
      END_STATE();
    case 820:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1018);
      END_STATE();
    case 821:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1019);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym_keyword_start);
      END_STATE();
    case 823:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1020);
      END_STATE();
    case 824:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1021);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym_keyword_stats);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym_keyword_stdin);
      END_STATE();
    case 827:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1022);
      END_STATE();
    case 828:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1023);
      END_STATE();
    case 829:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1024);
      END_STATE();
    case 830:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1025);
      END_STATE();
    case 831:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1026);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym_keyword_table);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1027);
      END_STATE();
    case 833:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1028);
      END_STATE();
    case 834:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1029);
      END_STATE();
    case 835:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1030);
      END_STATE();
    case 836:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1031);
      END_STATE();
    case 837:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1032);
      END_STATE();
    case 838:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1033);
      END_STATE();
    case 839:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1034);
      END_STATE();
    case 840:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1035);
      END_STATE();
    case 841:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1036);
      END_STATE();
    case 842:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1037);
      END_STATE();
    case 843:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1038);
      END_STATE();
    case 844:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1039);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(sym_keyword_union);
      END_STATE();
    case 846:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1040);
      END_STATE();
    case 847:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1041);
      END_STATE();
    case 848:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1042);
      END_STATE();
    case 849:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1043);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(sym_keyword_until);
      END_STATE();
    case 851:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1044);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(sym_keyword_using);
      END_STATE();
    case 853:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1045);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(sym_keyword_valid);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(sym_keyword_value);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1046);
      END_STATE();
    case 856:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1047);
      END_STATE();
    case 857:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1048);
      END_STATE();
    case 858:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1049);
      END_STATE();
    case 859:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1050);
      END_STATE();
    case 860:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1051);
      END_STATE();
    case 861:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1052);
      END_STATE();
    case 862:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1053);
      END_STATE();
    case 863:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1054);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(sym_keyword_where);
      END_STATE();
    case 865:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(1055);
      END_STATE();
    case 866:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1056);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(sym_keyword_write);
      END_STATE();
    case 868:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1057);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(sym_keyword_action);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(sym_keyword_always);
      END_STATE();
    case 871:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1058);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(sym_keyword_atomic);
      END_STATE();
    case 873:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1059);
      END_STATE();
    case 874:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1060);
      END_STATE();
    case 875:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1061);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(sym_keyword_before);
      END_STATE();
    case 877:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1062);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(aux_sym_keyword_bigint_token1);
      END_STATE();
    case 879:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1063);
      END_STATE();
    case 880:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1064);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(sym_keyword_binary);
      END_STATE();
    case 882:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1065);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(sym_keyword_cached);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_keyword_called);
      END_STATE();
    case 885:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1066);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(sym_keyword_change);
      END_STATE();
    case 887:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1067);
      END_STATE();
    case 888:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1068);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(sym_keyword_column);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1069);
      END_STATE();
    case 890:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1070);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(sym_keyword_commit);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1071);
      END_STATE();
    case 892:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1072);
      END_STATE();
    case 893:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1073);
      END_STATE();
    case 894:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1074);
      END_STATE();
    case 895:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1075);
      END_STATE();
    case 896:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1076);
      END_STATE();
    case 897:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1077);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(sym_keyword_create);
      END_STATE();
    case 899:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1078);
      END_STATE();
    case 900:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1079);
      END_STATE();
    case 901:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1080);
      END_STATE();
    case 902:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1081);
      END_STATE();
    case 903:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1082);
      END_STATE();
    case 904:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1083);
      END_STATE();
    case 905:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1084);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1085);
      END_STATE();
    case 906:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1086);
      END_STATE();
    case 907:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1087);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(sym_keyword_delete);
      END_STATE();
    case 909:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1088);
      END_STATE();
    case 910:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1089);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(sym_keyword_double);
      END_STATE();
    case 912:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1090);
      END_STATE();
    case 913:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1091);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(sym_keyword_engine);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(sym_keyword_escape);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1092);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(sym_keyword_except);
      END_STATE();
    case 917:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1093);
      END_STATE();
    case 918:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1094);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(sym_keyword_exists);
      END_STATE();
    case 920:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1095);
      END_STATE();
    case 921:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1096);
      END_STATE();
    case 922:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1097);
      END_STATE();
    case 923:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1098);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(sym_keyword_fields);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(sym_keyword_filter);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(aux_sym_keyword_real_token2);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(aux_sym_double_token1);
      END_STATE();
    case 928:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1099);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1100);
      END_STATE();
    case 929:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1101);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1102);
      END_STATE();
    case 930:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1103);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(sym_keyword_format);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(sym_keyword_freeze);
      END_STATE();
    case 933:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1104);
      END_STATE();
    case 934:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1105);
      END_STATE();
    case 935:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1106);
      END_STATE();
    case 936:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1107);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(sym_keyword_groups);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(sym_keyword_having);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(sym_keyword_header);
      END_STATE();
    case 940:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1108);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(sym_keyword_ignore);
      END_STATE();
    case 942:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1109);
      END_STATE();
    case 943:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1110);
      END_STATE();
    case 944:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1111);
      END_STATE();
    case 945:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1112);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(sym_keyword_insert);
      END_STATE();
    case 947:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1113);
      END_STATE();
    case 948:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1114);
      END_STATE();
    case 949:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1115);
      END_STATE();
    case 950:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1116);
      END_STATE();
    case 951:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1117);
      END_STATE();
    case 952:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1118);
      END_STATE();
    case 953:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1119);
      END_STATE();
    case 954:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1120);
      END_STATE();
    case 955:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1121);
      END_STATE();
    case 956:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1122);
      END_STATE();
    case 957:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1123);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(sym_keyword_logged);
      END_STATE();
    case 959:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1124);
      END_STATE();
    case 960:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1125);
      END_STATE();
    case 961:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1126);
      END_STATE();
    case 962:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1127);
      END_STATE();
    case 963:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1128);
      END_STATE();
    case 964:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1129);
      END_STATE();
    case 965:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1130);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(sym_keyword_modify);
      END_STATE();
    case 967:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1131);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(sym_keyword_noscan);
      END_STATE();
    case 969:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1132);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(sym_keyword_nowait);
      END_STATE();
    case 971:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1133);
      END_STATE();
    case 972:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1134);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(sym_keyword_offset);
      END_STATE();
    case 974:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(1135);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(sym_keyword_option);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1136);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(sym_keyword_others);
      END_STATE();
    case 977:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1137);
      END_STATE();
    case 978:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1138);
      END_STATE();
    case 979:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1139);
      END_STATE();
    case 980:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1140);
      END_STATE();
    case 981:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1141);
      END_STATE();
    case 982:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1142);
      END_STATE();
    case 983:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1143);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1144);
      END_STATE();
    case 984:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1145);
      END_STATE();
    case 985:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1146);
      END_STATE();
    case 986:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1147);
      END_STATE();
    case 987:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1148);
      END_STATE();
    case 988:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1149);
      END_STATE();
    case 989:
      ACCEPT_TOKEN(sym_keyword_rcfile);
      END_STATE();
    case 990:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1150);
      END_STATE();
    case 991:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1151);
      END_STATE();
    case 992:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1152);
      END_STATE();
    case 993:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1153);
      END_STATE();
    case 994:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1154);
      END_STATE();
    case 995:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1155);
      END_STATE();
    case 996:
      ACCEPT_TOKEN(sym_keyword_rename);
      END_STATE();
    case 997:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1156);
      END_STATE();
    case 998:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1157);
      END_STATE();
    case 999:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1158);
      END_STATE();
    case 1000:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1159);
      END_STATE();
    case 1001:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1160);
      END_STATE();
    case 1002:
      ACCEPT_TOKEN(sym_keyword_return);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1161);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1162);
      END_STATE();
    case 1003:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1163);
      END_STATE();
    case 1004:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1164);
      END_STATE();
    case 1005:
      ACCEPT_TOKEN(sym_keyword_schema);
      END_STATE();
    case 1006:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1165);
      END_STATE();
    case 1007:
      ACCEPT_TOKEN(sym_keyword_select);
      END_STATE();
    case 1008:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1166);
      END_STATE();
    case 1009:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1167);
      END_STATE();
    case 1010:
      ACCEPT_TOKEN(aux_sym_keyword_serial_token1);
      if (lookahead == '2') ADVANCE(1168);
      if (lookahead == '4') ADVANCE(1169);
      if (lookahead == '8') ADVANCE(1170);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1171);
      END_STATE();
    case 1011:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1172);
      END_STATE();
    case 1012:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1173);
      END_STATE();
    case 1013:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1174);
      END_STATE();
    case 1014:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1175);
      END_STATE();
    case 1015:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1176);
      END_STATE();
    case 1016:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1177);
      END_STATE();
    case 1017:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1178);
      END_STATE();
    case 1018:
      ACCEPT_TOKEN(sym_keyword_spgist);
      END_STATE();
    case 1019:
      ACCEPT_TOKEN(sym_keyword_stable);
      END_STATE();
    case 1020:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1179);
      END_STATE();
    case 1021:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1180);
      END_STATE();
    case 1022:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1181);
      END_STATE();
    case 1023:
      ACCEPT_TOKEN(sym_keyword_stored);
      END_STATE();
    case 1024:
      ACCEPT_TOKEN(sym_keyword_strict);
      END_STATE();
    case 1025:
      ACCEPT_TOKEN(sym_keyword_string);
      END_STATE();
    case 1026:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1182);
      END_STATE();
    case 1027:
      ACCEPT_TOKEN(sym_keyword_tables);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1183);
      END_STATE();
    case 1028:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1184);
      END_STATE();
    case 1029:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1185);
      END_STATE();
    case 1030:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1186);
      END_STATE();
    case 1031:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1187);
      END_STATE();
    case 1032:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1188);
      END_STATE();
    case 1033:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1189);
      END_STATE();
    case 1034:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1190);
      END_STATE();
    case 1035:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1191);
      END_STATE();
    case 1036:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1192);
      END_STATE();
    case 1037:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1193);
      END_STATE();
    case 1038:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1194);
      END_STATE();
    case 1039:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1195);
      END_STATE();
    case 1040:
      ACCEPT_TOKEN(sym_keyword_unique);
      END_STATE();
    case 1041:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1196);
      END_STATE();
    case 1042:
      ACCEPT_TOKEN(sym_keyword_unsafe);
      END_STATE();
    case 1043:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1197);
      END_STATE();
    case 1044:
      ACCEPT_TOKEN(sym_keyword_update);
      END_STATE();
    case 1045:
      ACCEPT_TOKEN(sym_keyword_vacuum);
      END_STATE();
    case 1046:
      ACCEPT_TOKEN(sym_keyword_values);
      END_STATE();
    case 1047:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1198);
      END_STATE();
    case 1048:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1199);
      END_STATE();
    case 1049:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1200);
      END_STATE();
    case 1050:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 1051:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1202);
      END_STATE();
    case 1052:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1203);
      END_STATE();
    case 1053:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1204);
      END_STATE();
    case 1054:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1205);
      END_STATE();
    case 1055:
      ACCEPT_TOKEN(sym_keyword_window);
      END_STATE();
    case 1056:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1206);
      END_STATE();
    case 1057:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1207);
      END_STATE();
    case 1058:
      ACCEPT_TOKEN(sym_keyword_analyze);
      END_STATE();
    case 1059:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1208);
      END_STATE();
    case 1060:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(1209);
      END_STATE();
    case 1061:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1210);
      END_STATE();
    case 1062:
      ACCEPT_TOKEN(sym_keyword_between);
      END_STATE();
    case 1063:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1211);
      END_STATE();
    case 1064:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1212);
      END_STATE();
    case 1065:
      ACCEPT_TOKEN(sym_keyword_boolean);
      END_STATE();
    case 1066:
      ACCEPT_TOKEN(sym_keyword_cascade);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1213);
      END_STATE();
    case 1067:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1214);
      END_STATE();
    case 1068:
      ACCEPT_TOKEN(sym_keyword_collate);
      END_STATE();
    case 1069:
      ACCEPT_TOKEN(sym_keyword_columns);
      END_STATE();
    case 1070:
      ACCEPT_TOKEN(sym_keyword_comment);
      END_STATE();
    case 1071:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1215);
      END_STATE();
    case 1072:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1216);
      END_STATE();
    case 1073:
      ACCEPT_TOKEN(sym_keyword_compute);
      END_STATE();
    case 1074:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1217);
      END_STATE();
    case 1075:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1218);
      END_STATE();
    case 1076:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1219);
      END_STATE();
    case 1077:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1220);
      END_STATE();
    case 1078:
      ACCEPT_TOKEN(sym_keyword_current);
      if (lookahead == '_') ADVANCE(1221);
      END_STATE();
    case 1079:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1222);
      END_STATE();
    case 1080:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1223);
      END_STATE();
    case 1081:
      ACCEPT_TOKEN(sym_keyword_decimal);
      END_STATE();
    case 1082:
      ACCEPT_TOKEN(sym_keyword_declare);
      END_STATE();
    case 1083:
      ACCEPT_TOKEN(sym_keyword_default);
      END_STATE();
    case 1084:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1224);
      END_STATE();
    case 1085:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1225);
      END_STATE();
    case 1086:
      ACCEPT_TOKEN(sym_keyword_definer);
      END_STATE();
    case 1087:
      ACCEPT_TOKEN(sym_keyword_delayed);
      END_STATE();
    case 1088:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1226);
      END_STATE();
    case 1089:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1227);
      END_STATE();
    case 1090:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1228);
      END_STATE();
    case 1091:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1229);
      END_STATE();
    case 1092:
      ACCEPT_TOKEN(sym_keyword_escaped);
      END_STATE();
    case 1093:
      ACCEPT_TOKEN(sym_keyword_exclude);
      END_STATE();
    case 1094:
      ACCEPT_TOKEN(sym_keyword_execute);
      END_STATE();
    case 1095:
      ACCEPT_TOKEN(sym_keyword_explain);
      END_STATE();
    case 1096:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1230);
      END_STATE();
    case 1097:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1231);
      END_STATE();
    case 1098:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1232);
      END_STATE();
    case 1099:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1233);
      END_STATE();
    case 1100:
      ACCEPT_TOKEN(sym_keyword_follows);
      END_STATE();
    case 1101:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1234);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1235);
      END_STATE();
    case 1102:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1236);
      END_STATE();
    case 1103:
      ACCEPT_TOKEN(sym_keyword_foreign);
      END_STATE();
    case 1104:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1237);
      END_STATE();
    case 1105:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1238);
      END_STATE();
    case 1106:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1239);
      END_STATE();
    case 1107:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1240);
      END_STATE();
    case 1108:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1241);
      END_STATE();
    case 1109:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1242);
      END_STATE();
    case 1110:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1243);
      END_STATE();
    case 1111:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1244);
      END_STATE();
    case 1112:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1245);
      END_STATE();
    case 1113:
      ACCEPT_TOKEN(sym_keyword_instead);
      END_STATE();
    case 1114:
      ACCEPT_TOKEN(aux_sym_keyword_int_token2);
      END_STATE();
    case 1115:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1246);
      END_STATE();
    case 1116:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1247);
      END_STATE();
    case 1117:
      ACCEPT_TOKEN(sym_keyword_invoker);
      END_STATE();
    case 1118:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1248);
      END_STATE();
    case 1119:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1249);
      END_STATE();
    case 1120:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1250);
      END_STATE();
    case 1121:
      ACCEPT_TOKEN(sym_keyword_lateral);
      END_STATE();
    case 1122:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1251);
      END_STATE();
    case 1123:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1252);
      END_STATE();
    case 1124:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1253);
      END_STATE();
    case 1125:
      ACCEPT_TOKEN(sym_keyword_matched);
      END_STATE();
    case 1126:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1254);
      END_STATE();
    case 1127:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1255);
      END_STATE();
    case 1128:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1256);
      END_STATE();
    case 1129:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1257);
      END_STATE();
    case 1130:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1258);
      END_STATE();
    case 1131:
      ACCEPT_TOKEN(sym_keyword_natural);
      END_STATE();
    case 1132:
      ACCEPT_TOKEN(sym_keyword_nothing);
      END_STATE();
    case 1133:
      ACCEPT_TOKEN(sym_keyword_numeric);
      END_STATE();
    case 1134:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1259);
      END_STATE();
    case 1135:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1260);
      END_STATE();
    case 1136:
      ACCEPT_TOKEN(sym_keyword_options);
      END_STATE();
    case 1137:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1261);
      END_STATE();
    case 1138:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1262);
      END_STATE();
    case 1139:
      ACCEPT_TOKEN(sym_keyword_parquet);
      END_STATE();
    case 1140:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1263);
      END_STATE();
    case 1141:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1264);
      END_STATE();
    case 1142:
      ACCEPT_TOKEN(sym_keyword_plpgsql);
      END_STATE();
    case 1143:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1265);
      END_STATE();
    case 1144:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1266);
      END_STATE();
    case 1145:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1267);
      END_STATE();
    case 1146:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1268);
      END_STATE();
    case 1147:
      ACCEPT_TOKEN(sym_keyword_primary);
      END_STATE();
    case 1148:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1269);
      END_STATE();
    case 1149:
      ACCEPT_TOKEN(sym_keyword_program);
      END_STATE();
    case 1150:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1270);
      END_STATE();
    case 1151:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1271);
      END_STATE();
    case 1152:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1272);
      END_STATE();
    case 1153:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1273);
      END_STATE();
    case 1154:
      ACCEPT_TOKEN(sym_keyword_regproc);
      END_STATE();
    case 1155:
      ACCEPT_TOKEN(sym_keyword_regtype);
      END_STATE();
    case 1156:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1274);
      END_STATE();
    case 1157:
      ACCEPT_TOKEN(sym_keyword_replace);
      END_STATE();
    case 1158:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1275);
      END_STATE();
    case 1159:
      ACCEPT_TOKEN(sym_keyword_restart);
      END_STATE();
    case 1160:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1276);
      END_STATE();
    case 1161:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1277);
      END_STATE();
    case 1162:
      ACCEPT_TOKEN(sym_keyword_returns);
      END_STATE();
    case 1163:
      ACCEPT_TOKEN(sym_keyword_rewrite);
      END_STATE();
    case 1164:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1278);
      END_STATE();
    case 1165:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1279);
      END_STATE();
    case 1166:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1280);
      END_STATE();
    case 1167:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1281);
      END_STATE();
    case 1168:
      ACCEPT_TOKEN(aux_sym_keyword_smallserial_token2);
      END_STATE();
    case 1169:
      ACCEPT_TOKEN(aux_sym_keyword_serial_token2);
      END_STATE();
    case 1170:
      ACCEPT_TOKEN(aux_sym_keyword_bigserial_token2);
      END_STATE();
    case 1171:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(1282);
      END_STATE();
    case 1172:
      ACCEPT_TOKEN(sym_keyword_session);
      END_STATE();
    case 1173:
      ACCEPT_TOKEN(sym_keyword_similar);
      END_STATE();
    case 1174:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1283);
      END_STATE();
    case 1175:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1284);
      END_STATE();
    case 1176:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1285);
      END_STATE();
    case 1177:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1286);
      END_STATE();
    case 1178:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1287);
      END_STATE();
    case 1179:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1288);
      END_STATE();
    case 1180:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1289);
      END_STATE();
    case 1181:
      ACCEPT_TOKEN(sym_keyword_storage);
      END_STATE();
    case 1182:
      ACCEPT_TOKEN(sym_keyword_support);
      END_STATE();
    case 1183:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1290);
      END_STATE();
    case 1184:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1291);
      END_STATE();
    case 1185:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1292);
      END_STATE();
    case 1186:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1293);
      END_STATE();
    case 1187:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1294);
      END_STATE();
    case 1188:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1295);
      END_STATE();
    case 1189:
      ACCEPT_TOKEN(aux_sym_keyword_tinyint_token1);
      END_STATE();
    case 1190:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1296);
      END_STATE();
    case 1191:
      ACCEPT_TOKEN(sym_keyword_trigger);
      END_STATE();
    case 1192:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1297);
      END_STATE();
    case 1193:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1298);
      END_STATE();
    case 1194:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1299);
      END_STATE();
    case 1195:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1300);
      END_STATE();
    case 1196:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1301);
      END_STATE();
    case 1197:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1302);
      END_STATE();
    case 1198:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1303);
      END_STATE();
    case 1199:
      ACCEPT_TOKEN(aux_sym_keyword_varchar_token1);
      END_STATE();
    case 1200:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1304);
      END_STATE();
    case 1201:
      ACCEPT_TOKEN(sym_keyword_varying);
      END_STATE();
    case 1202:
      ACCEPT_TOKEN(sym_keyword_verbose);
      END_STATE();
    case 1203:
      ACCEPT_TOKEN(sym_keyword_version);
      END_STATE();
    case 1204:
      ACCEPT_TOKEN(sym_keyword_virtual);
      END_STATE();
    case 1205:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1305);
      END_STATE();
    case 1206:
      ACCEPT_TOKEN(sym_keyword_without);
      END_STATE();
    case 1207:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1306);
      END_STATE();
    case 1208:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1307);
      END_STATE();
    case 1209:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1308);
      END_STATE();
    case 1210:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1309);
      END_STATE();
    case 1211:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1310);
      END_STATE();
    case 1212:
      ACCEPT_TOKEN(sym_keyword_bin_pack);
      END_STATE();
    case 1213:
      ACCEPT_TOKEN(sym_keyword_cascaded);
      END_STATE();
    case 1214:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1311);
      END_STATE();
    case 1215:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1312);
      END_STATE();
    case 1216:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1313);
      END_STATE();
    case 1217:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1314);
      END_STATE();
    case 1218:
      ACCEPT_TOKEN(sym_keyword_conflict);
      END_STATE();
    case 1219:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1315);
      END_STATE();
    case 1220:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1316);
      END_STATE();
    case 1221:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1317);
      END_STATE();
    case 1222:
      ACCEPT_TOKEN(sym_keyword_database);
      END_STATE();
    case 1223:
      ACCEPT_TOKEN(sym_keyword_datetime);
      if (lookahead == '2') ADVANCE(1318);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1319);
      END_STATE();
    case 1224:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1320);
      END_STATE();
    case 1225:
      ACCEPT_TOKEN(sym_keyword_deferred);
      END_STATE();
    case 1226:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1321);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1322);
      END_STATE();
    case 1227:
      ACCEPT_TOKEN(sym_keyword_distinct);
      END_STATE();
    case 1228:
      ACCEPT_TOKEN(sym_keyword_encoding);
      END_STATE();
    case 1229:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1323);
      END_STATE();
    case 1230:
      ACCEPT_TOKEN(sym_keyword_extended);
      END_STATE();
    case 1231:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1324);
      END_STATE();
    case 1232:
      ACCEPT_TOKEN(sym_keyword_external);
      END_STATE();
    case 1233:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1325);
      END_STATE();
    case 1234:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1326);
      END_STATE();
    case 1235:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1327);
      END_STATE();
    case 1236:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1328);
      END_STATE();
    case 1237:
      ACCEPT_TOKEN(sym_keyword_function);
      END_STATE();
    case 1238:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1329);
      END_STATE();
    case 1239:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1330);
      END_STATE();
    case 1240:
      ACCEPT_TOKEN(sym_keyword_geometry);
      END_STATE();
    case 1241:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1331);
      END_STATE();
    case 1242:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1332);
      END_STATE();
    case 1243:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1333);
      END_STATE();
    case 1244:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1334);
      END_STATE();
    case 1245:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1335);
      END_STATE();
    case 1246:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1336);
      END_STATE();
    case 1247:
      ACCEPT_TOKEN(sym_keyword_interval);
      END_STATE();
    case 1248:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1337);
      END_STATE();
    case 1249:
      ACCEPT_TOKEN(sym_keyword_jsonfile);
      END_STATE();
    case 1250:
      ACCEPT_TOKEN(sym_keyword_language);
      END_STATE();
    case 1251:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1338);
      END_STATE();
    case 1252:
      ACCEPT_TOKEN(sym_keyword_location);
      END_STATE();
    case 1253:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1339);
      END_STATE();
    case 1254:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1340);
      END_STATE();
    case 1255:
      ACCEPT_TOKEN(sym_keyword_maxvalue);
      END_STATE();
    case 1256:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1341);
      END_STATE();
    case 1257:
      ACCEPT_TOKEN(sym_keyword_metadata);
      END_STATE();
    case 1258:
      ACCEPT_TOKEN(sym_keyword_minvalue);
      END_STATE();
    case 1259:
      ACCEPT_TOKEN(sym_keyword_nvarchar);
      END_STATE();
    case 1260:
      ACCEPT_TOKEN(sym_keyword_optimize);
      END_STATE();
    case 1261:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1342);
      END_STATE();
    case 1262:
      ACCEPT_TOKEN(sym_keyword_parallel);
      END_STATE();
    case 1263:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1343);
      END_STATE();
    case 1264:
      ACCEPT_TOKEN(sym_keyword_password);
      END_STATE();
    case 1265:
      ACCEPT_TOKEN(sym_keyword_precedes);
      END_STATE();
    case 1266:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1344);
      END_STATE();
    case 1267:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1345);
      END_STATE();
    case 1268:
      ACCEPT_TOKEN(sym_keyword_preserve);
      END_STATE();
    case 1269:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1346);
      END_STATE();
    case 1270:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1347);
      END_STATE();
    case 1271:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1348);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1349);
      END_STATE();
    case 1272:
      ACCEPT_TOKEN(sym_keyword_regclass);
      END_STATE();
    case 1273:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1350);
      END_STATE();
    case 1274:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1351);
      END_STATE();
    case 1275:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1352);
      END_STATE();
    case 1276:
      ACCEPT_TOKEN(sym_keyword_restrict);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1353);
      END_STATE();
    case 1277:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1354);
      END_STATE();
    case 1278:
      ACCEPT_TOKEN(sym_keyword_rollback);
      END_STATE();
    case 1279:
      ACCEPT_TOKEN(sym_keyword_security);
      END_STATE();
    case 1280:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1355);
      END_STATE();
    case 1281:
      ACCEPT_TOKEN(sym_keyword_sequence);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1356);
      END_STATE();
    case 1282:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1357);
      END_STATE();
    case 1283:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1358);
      END_STATE();
    case 1284:
      ACCEPT_TOKEN(aux_sym_keyword_smallint_token1);
      END_STATE();
    case 1285:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1359);
      END_STATE();
    case 1286:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1360);
      END_STATE();
    case 1287:
      ACCEPT_TOKEN(sym_keyword_snapshot);
      END_STATE();
    case 1288:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1361);
      END_STATE();
    case 1289:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1362);
      END_STATE();
    case 1290:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1363);
      END_STATE();
    case 1291:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1364);
      END_STATE();
    case 1292:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1365);
      END_STATE();
    case 1293:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1366);
      END_STATE();
    case 1294:
      ACCEPT_TOKEN(sym_keyword_textfile);
      END_STATE();
    case 1295:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1367);
      END_STATE();
    case 1296:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1368);
      END_STATE();
    case 1297:
      ACCEPT_TOKEN(sym_keyword_truncate);
      END_STATE();
    case 1298:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1369);
      END_STATE();
    case 1299:
      ACCEPT_TOKEN(sym_keyword_uncached);
      END_STATE();
    case 1300:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1370);
      END_STATE();
    case 1301:
      ACCEPT_TOKEN(sym_keyword_unlogged);
      END_STATE();
    case 1302:
      ACCEPT_TOKEN(sym_keyword_unsigned);
      END_STATE();
    case 1303:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1371);
      END_STATE();
    case 1304:
      ACCEPT_TOKEN(sym_keyword_variadic);
      END_STATE();
    case 1305:
      ACCEPT_TOKEN(sym_keyword_volatile);
      END_STATE();
    case 1306:
      ACCEPT_TOKEN(sym_keyword_zerofill);
      END_STATE();
    case 1307:
      ACCEPT_TOKEN(sym_keyword_attribute);
      END_STATE();
    case 1308:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1372);
      END_STATE();
    case 1309:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1373);
      END_STATE();
    case 1310:
      ACCEPT_TOKEN(aux_sym_keyword_bigserial_token1);
      END_STATE();
    case 1311:
      ACCEPT_TOKEN(aux_sym_keyword_character_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1374);
      END_STATE();
    case 1312:
      ACCEPT_TOKEN(sym_keyword_committed);
      END_STATE();
    case 1313:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1375);
      END_STATE();
    case 1314:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1376);
      END_STATE();
    case 1315:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1377);
      END_STATE();
    case 1316:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1378);
      END_STATE();
    case 1317:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1379);
      END_STATE();
    case 1318:
      ACCEPT_TOKEN(sym_keyword_datetime2);
      END_STATE();
    case 1319:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1380);
      END_STATE();
    case 1320:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1381);
      END_STATE();
    case 1321:
      ACCEPT_TOKEN(sym_keyword_delimited);
      END_STATE();
    case 1322:
      ACCEPT_TOKEN(sym_keyword_delimiter);
      END_STATE();
    case 1323:
      ACCEPT_TOKEN(sym_keyword_encrypted);
      END_STATE();
    case 1324:
      ACCEPT_TOKEN(sym_keyword_extension);
      END_STATE();
    case 1325:
      ACCEPT_TOKEN(sym_keyword_following);
      END_STATE();
    case 1326:
      if (lookahead == '_') ADVANCE(1382);
      END_STATE();
    case 1327:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1383);
      END_STATE();
    case 1328:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1384);
      END_STATE();
    case 1329:
      ACCEPT_TOKEN(sym_keyword_generated);
      END_STATE();
    case 1330:
      ACCEPT_TOKEN(sym_keyword_geography);
      END_STATE();
    case 1331:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1385);
      END_STATE();
    case 1332:
      ACCEPT_TOKEN(sym_keyword_immediate);
      END_STATE();
    case 1333:
      ACCEPT_TOKEN(sym_keyword_immutable);
      END_STATE();
    case 1334:
      ACCEPT_TOKEN(sym_keyword_increment);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1386);
      END_STATE();
    case 1335:
      ACCEPT_TOKEN(sym_keyword_initially);
      END_STATE();
    case 1336:
      ACCEPT_TOKEN(sym_keyword_intersect);
      END_STATE();
    case 1337:
      ACCEPT_TOKEN(sym_keyword_isolation);
      END_STATE();
    case 1338:
      ACCEPT_TOKEN(sym_keyword_leakproof);
      END_STATE();
    case 1339:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1387);
      END_STATE();
    case 1340:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(1388);
      END_STATE();
    case 1341:
      ACCEPT_TOKEN(aux_sym_keyword_mediumint_token1);
      END_STATE();
    case 1342:
      ACCEPT_TOKEN(sym_keyword_overwrite);
      END_STATE();
    case 1343:
      ACCEPT_TOKEN(sym_keyword_partition);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1389);
      END_STATE();
    case 1344:
      ACCEPT_TOKEN(sym_keyword_preceding);
      END_STATE();
    case 1345:
      ACCEPT_TOKEN(sym_keyword_precision);
      END_STATE();
    case 1346:
      ACCEPT_TOKEN(sym_keyword_procedure);
      END_STATE();
    case 1347:
      ACCEPT_TOKEN(sym_keyword_recursive);
      END_STATE();
    case 1348:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1390);
      END_STATE();
    case 1349:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1391);
      END_STATE();
    case 1350:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1392);
      END_STATE();
    case 1351:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1393);
      END_STATE();
    case 1352:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1394);
      END_STATE();
    case 1353:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1395);
      END_STATE();
    case 1354:
      ACCEPT_TOKEN(sym_keyword_returning);
      END_STATE();
    case 1355:
      ACCEPT_TOKEN(sym_keyword_separator);
      END_STATE();
    case 1356:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1396);
      END_STATE();
    case 1357:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1397);
      END_STATE();
    case 1358:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1398);
      END_STATE();
    case 1359:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1399);
      END_STATE();
    case 1360:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1400);
      END_STATE();
    case 1361:
      ACCEPT_TOKEN(sym_keyword_statement);
      END_STATE();
    case 1362:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1401);
      END_STATE();
    case 1363:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1402);
      END_STATE();
    case 1364:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1403);
      END_STATE();
    case 1365:
      ACCEPT_TOKEN(sym_keyword_temporary);
      END_STATE();
    case 1366:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1404);
      END_STATE();
    case 1367:
      ACCEPT_TOKEN(sym_keyword_timestamp);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1405);
      END_STATE();
    case 1368:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1406);
      END_STATE();
    case 1369:
      ACCEPT_TOKEN(sym_keyword_unbounded);
      END_STATE();
    case 1370:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1407);
      END_STATE();
    case 1371:
      ACCEPT_TOKEN(sym_keyword_varbinary);
      END_STATE();
    case 1372:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1408);
      END_STATE();
    case 1373:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1409);
      END_STATE();
    case 1374:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1410);
      END_STATE();
    case 1375:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1411);
      END_STATE();
    case 1376:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1412);
      END_STATE();
    case 1377:
      ACCEPT_TOKEN(sym_keyword_connection);
      END_STATE();
    case 1378:
      ACCEPT_TOKEN(sym_keyword_constraint);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1413);
      END_STATE();
    case 1379:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1414);
      END_STATE();
    case 1380:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1415);
      END_STATE();
    case 1381:
      ACCEPT_TOKEN(sym_keyword_deferrable);
      END_STATE();
    case 1382:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1416);
      END_STATE();
    case 1383:
      ACCEPT_TOKEN(sym_keyword_force_null);
      END_STATE();
    case 1384:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1417);
      END_STATE();
    case 1385:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1418);
      END_STATE();
    case 1386:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1419);
      END_STATE();
    case 1387:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1420);
      END_STATE();
    case 1388:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1421);
      END_STATE();
    case 1389:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1422);
      END_STATE();
    case 1390:
      ACCEPT_TOKEN(sym_keyword_references);
      END_STATE();
    case 1391:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1423);
      END_STATE();
    case 1392:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1424);
      END_STATE();
    case 1393:
      ACCEPT_TOKEN(sym_keyword_repeatable);
      END_STATE();
    case 1394:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1425);
      END_STATE();
    case 1395:
      ACCEPT_TOKEN(sym_keyword_restricted);
      END_STATE();
    case 1396:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1426);
      END_STATE();
    case 1397:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1427);
      END_STATE();
    case 1398:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1428);
      END_STATE();
    case 1399:
      ACCEPT_TOKEN(sym_keyword_smallmoney);
      END_STATE();
    case 1400:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1429);
      END_STATE();
    case 1401:
      ACCEPT_TOKEN(sym_keyword_statistics);
      END_STATE();
    case 1402:
      ACCEPT_TOKEN(sym_keyword_tablespace);
      END_STATE();
    case 1403:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1430);
      END_STATE();
    case 1404:
      ACCEPT_TOKEN(sym_keyword_terminated);
      END_STATE();
    case 1405:
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(1431);
      END_STATE();
    case 1406:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1432);
      END_STATE();
    case 1407:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1433);
      END_STATE();
    case 1408:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1434);
      END_STATE();
    case 1409:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1435);
      END_STATE();
    case 1410:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1436);
      END_STATE();
    case 1411:
      ACCEPT_TOKEN(sym_keyword_compression);
      END_STATE();
    case 1412:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1437);
      END_STATE();
    case 1413:
      ACCEPT_TOKEN(sym_keyword_constraints);
      END_STATE();
    case 1414:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1438);
      END_STATE();
    case 1415:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1439);
      END_STATE();
    case 1416:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1440);
      END_STATE();
    case 1417:
      ACCEPT_TOKEN(sym_keyword_force_quote);
      END_STATE();
    case 1418:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1441);
      END_STATE();
    case 1419:
      ACCEPT_TOKEN(sym_keyword_incremental);
      END_STATE();
    case 1420:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1442);
      END_STATE();
    case 1421:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1443);
      END_STATE();
    case 1422:
      ACCEPT_TOKEN(sym_keyword_partitioned);
      END_STATE();
    case 1423:
      ACCEPT_TOKEN(sym_keyword_referencing);
      END_STATE();
    case 1424:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1444);
      END_STATE();
    case 1425:
      ACCEPT_TOKEN(sym_keyword_replication);
      END_STATE();
    case 1426:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1445);
      END_STATE();
    case 1427:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1446);
      END_STATE();
    case 1428:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1447);
      END_STATE();
    case 1429:
      ACCEPT_TOKEN(aux_sym_keyword_smallserial_token1);
      END_STATE();
    case 1430:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1448);
      END_STATE();
    case 1431:
      ACCEPT_TOKEN(sym_keyword_timestamptz);
      END_STATE();
    case 1432:
      ACCEPT_TOKEN(sym_keyword_transaction);
      END_STATE();
    case 1433:
      ACCEPT_TOKEN(sym_keyword_uncommitted);
      END_STATE();
    case 1434:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1449);
      END_STATE();
    case 1435:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1450);
      END_STATE();
    case 1436:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1451);
      END_STATE();
    case 1437:
      ACCEPT_TOKEN(sym_keyword_concurrently);
      END_STATE();
    case 1438:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1452);
      END_STATE();
    case 1439:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1453);
      END_STATE();
    case 1440:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1454);
      END_STATE();
    case 1441:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1455);
      END_STATE();
    case 1442:
      ACCEPT_TOKEN(sym_keyword_low_priority);
      END_STATE();
    case 1443:
      ACCEPT_TOKEN(sym_keyword_materialized);
      END_STATE();
    case 1444:
      ACCEPT_TOKEN(sym_keyword_regnamespace);
      END_STATE();
    case 1445:
      ACCEPT_TOKEN(sym_keyword_sequencefile);
      END_STATE();
    case 1446:
      ACCEPT_TOKEN(sym_keyword_serializable);
      END_STATE();
    case 1447:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1456);
      END_STATE();
    case 1448:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1457);
      END_STATE();
    case 1449:
      ACCEPT_TOKEN(sym_keyword_authorization);
      END_STATE();
    case 1450:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1458);
      END_STATE();
    case 1451:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1459);
      END_STATE();
    case 1452:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1460);
      END_STATE();
    case 1453:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1461);
      END_STATE();
    case 1454:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1462);
      END_STATE();
    case 1455:
      ACCEPT_TOKEN(sym_keyword_high_priority);
      END_STATE();
    case 1456:
      ACCEPT_TOKEN(sym_keyword_smalldatetime);
      END_STATE();
    case 1457:
      ACCEPT_TOKEN(sym_keyword_tblproperties);
      END_STATE();
    case 1458:
      ACCEPT_TOKEN(sym_keyword_auto_increment);
      END_STATE();
    case 1459:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1463);
      END_STATE();
    case 1460:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1464);
      END_STATE();
    case 1461:
      ACCEPT_TOKEN(sym_keyword_datetimeoffset);
      END_STATE();
    case 1462:
      ACCEPT_TOKEN(sym_keyword_force_not_null);
      END_STATE();
    case 1463:
      ACCEPT_TOKEN(sym_keyword_characteristics);
      END_STATE();
    case 1464:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1465);
      END_STATE();
    case 1465:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1466);
      END_STATE();
    case 1466:
      ACCEPT_TOKEN(sym_keyword_current_timestamp);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 35},
  [2] = {.lex_state = 35},
  [3] = {.lex_state = 35},
  [4] = {.lex_state = 35},
  [5] = {.lex_state = 35},
  [6] = {.lex_state = 35},
  [7] = {.lex_state = 35},
  [8] = {.lex_state = 35},
  [9] = {.lex_state = 35},
  [10] = {.lex_state = 35},
  [11] = {.lex_state = 35},
  [12] = {.lex_state = 35},
  [13] = {.lex_state = 35},
  [14] = {.lex_state = 35},
  [15] = {.lex_state = 35},
  [16] = {.lex_state = 35},
  [17] = {.lex_state = 35},
  [18] = {.lex_state = 35},
  [19] = {.lex_state = 35},
  [20] = {.lex_state = 35},
  [21] = {.lex_state = 35},
  [22] = {.lex_state = 35},
  [23] = {.lex_state = 35},
  [24] = {.lex_state = 35},
  [25] = {.lex_state = 35},
  [26] = {.lex_state = 35},
  [27] = {.lex_state = 35},
  [28] = {.lex_state = 35},
  [29] = {.lex_state = 35},
  [30] = {.lex_state = 35},
  [31] = {.lex_state = 35},
  [32] = {.lex_state = 35},
  [33] = {.lex_state = 35},
  [34] = {.lex_state = 35},
  [35] = {.lex_state = 35},
  [36] = {.lex_state = 35},
  [37] = {.lex_state = 35},
  [38] = {.lex_state = 35},
  [39] = {.lex_state = 35},
  [40] = {.lex_state = 35},
  [41] = {.lex_state = 35},
  [42] = {.lex_state = 35},
  [43] = {.lex_state = 35},
  [44] = {.lex_state = 35},
  [45] = {.lex_state = 35},
  [46] = {.lex_state = 35},
  [47] = {.lex_state = 35},
  [48] = {.lex_state = 35},
  [49] = {.lex_state = 35},
  [50] = {.lex_state = 35},
  [51] = {.lex_state = 35},
  [52] = {.lex_state = 35},
  [53] = {.lex_state = 35},
  [54] = {.lex_state = 35},
  [55] = {.lex_state = 35},
  [56] = {.lex_state = 35},
  [57] = {.lex_state = 35},
  [58] = {.lex_state = 35},
  [59] = {.lex_state = 35},
  [60] = {.lex_state = 35},
  [61] = {.lex_state = 35},
  [62] = {.lex_state = 35},
  [63] = {.lex_state = 35},
  [64] = {.lex_state = 35},
  [65] = {.lex_state = 35},
  [66] = {.lex_state = 35},
  [67] = {.lex_state = 35},
  [68] = {.lex_state = 35},
  [69] = {.lex_state = 35},
  [70] = {.lex_state = 35},
  [71] = {.lex_state = 35},
  [72] = {.lex_state = 35},
  [73] = {.lex_state = 35},
  [74] = {.lex_state = 35},
  [75] = {.lex_state = 35},
  [76] = {.lex_state = 35},
  [77] = {.lex_state = 35},
  [78] = {.lex_state = 35},
  [79] = {.lex_state = 35},
  [80] = {.lex_state = 35},
  [81] = {.lex_state = 35},
  [82] = {.lex_state = 35},
  [83] = {.lex_state = 35},
  [84] = {.lex_state = 35},
  [85] = {.lex_state = 35},
  [86] = {.lex_state = 35},
  [87] = {.lex_state = 35},
  [88] = {.lex_state = 33},
  [89] = {.lex_state = 35},
  [90] = {.lex_state = 35},
  [91] = {.lex_state = 35},
  [92] = {.lex_state = 35},
  [93] = {.lex_state = 35},
  [94] = {.lex_state = 35},
  [95] = {.lex_state = 35},
  [96] = {.lex_state = 35},
  [97] = {.lex_state = 35},
  [98] = {.lex_state = 35},
  [99] = {.lex_state = 35},
  [100] = {.lex_state = 35},
  [101] = {.lex_state = 35},
  [102] = {.lex_state = 35},
  [103] = {.lex_state = 35},
  [104] = {.lex_state = 35},
  [105] = {.lex_state = 35},
  [106] = {.lex_state = 35},
  [107] = {.lex_state = 35},
  [108] = {.lex_state = 35},
  [109] = {.lex_state = 35},
  [110] = {.lex_state = 35},
  [111] = {.lex_state = 35},
  [112] = {.lex_state = 35},
  [113] = {.lex_state = 35},
  [114] = {.lex_state = 35},
  [115] = {.lex_state = 35},
  [116] = {.lex_state = 35},
  [117] = {.lex_state = 35},
  [118] = {.lex_state = 35},
  [119] = {.lex_state = 35},
  [120] = {.lex_state = 35},
  [121] = {.lex_state = 35},
  [122] = {.lex_state = 35},
  [123] = {.lex_state = 35},
  [124] = {.lex_state = 35},
  [125] = {.lex_state = 35},
  [126] = {.lex_state = 35},
  [127] = {.lex_state = 35},
  [128] = {.lex_state = 35},
  [129] = {.lex_state = 35},
  [130] = {.lex_state = 35},
  [131] = {.lex_state = 35},
  [132] = {.lex_state = 35},
  [133] = {.lex_state = 35},
  [134] = {.lex_state = 35},
  [135] = {.lex_state = 35},
  [136] = {.lex_state = 35},
  [137] = {.lex_state = 35},
  [138] = {.lex_state = 35},
  [139] = {.lex_state = 35},
  [140] = {.lex_state = 35},
  [141] = {.lex_state = 35},
  [142] = {.lex_state = 35},
  [143] = {.lex_state = 35},
  [144] = {.lex_state = 35},
  [145] = {.lex_state = 35},
  [146] = {.lex_state = 35},
  [147] = {.lex_state = 35},
  [148] = {.lex_state = 35},
  [149] = {.lex_state = 35},
  [150] = {.lex_state = 35},
  [151] = {.lex_state = 35},
  [152] = {.lex_state = 35},
  [153] = {.lex_state = 35},
  [154] = {.lex_state = 35, .external_lex_state = 2},
  [155] = {.lex_state = 35},
  [156] = {.lex_state = 35},
  [157] = {.lex_state = 35},
  [158] = {.lex_state = 35},
  [159] = {.lex_state = 35},
  [160] = {.lex_state = 35},
  [161] = {.lex_state = 35},
  [162] = {.lex_state = 35},
  [163] = {.lex_state = 35},
  [164] = {.lex_state = 35},
  [165] = {.lex_state = 35},
  [166] = {.lex_state = 35},
  [167] = {.lex_state = 35},
  [168] = {.lex_state = 35},
  [169] = {.lex_state = 35},
  [170] = {.lex_state = 35},
  [171] = {.lex_state = 35},
  [172] = {.lex_state = 35},
  [173] = {.lex_state = 35},
  [174] = {.lex_state = 35},
  [175] = {.lex_state = 35},
  [176] = {.lex_state = 35},
  [177] = {.lex_state = 35},
  [178] = {.lex_state = 35},
  [179] = {.lex_state = 35},
  [180] = {.lex_state = 35},
  [181] = {.lex_state = 36},
  [182] = {.lex_state = 35},
  [183] = {.lex_state = 35},
  [184] = {.lex_state = 35},
  [185] = {.lex_state = 35},
  [186] = {.lex_state = 35},
  [187] = {.lex_state = 35},
  [188] = {.lex_state = 35},
  [189] = {.lex_state = 35},
  [190] = {.lex_state = 35},
  [191] = {.lex_state = 35},
  [192] = {.lex_state = 35},
  [193] = {.lex_state = 35},
  [194] = {.lex_state = 35},
  [195] = {.lex_state = 35},
  [196] = {.lex_state = 35},
  [197] = {.lex_state = 35},
  [198] = {.lex_state = 35},
  [199] = {.lex_state = 35},
  [200] = {.lex_state = 35},
  [201] = {.lex_state = 35},
  [202] = {.lex_state = 35},
  [203] = {.lex_state = 35},
  [204] = {.lex_state = 35},
  [205] = {.lex_state = 35},
  [206] = {.lex_state = 35},
  [207] = {.lex_state = 35},
  [208] = {.lex_state = 35},
  [209] = {.lex_state = 35},
  [210] = {.lex_state = 35},
  [211] = {.lex_state = 35},
  [212] = {.lex_state = 35},
  [213] = {.lex_state = 35},
  [214] = {.lex_state = 35},
  [215] = {.lex_state = 35},
  [216] = {.lex_state = 33, .external_lex_state = 2},
  [217] = {.lex_state = 35},
  [218] = {.lex_state = 35},
  [219] = {.lex_state = 35},
  [220] = {.lex_state = 35},
  [221] = {.lex_state = 35},
  [222] = {.lex_state = 35},
  [223] = {.lex_state = 35},
  [224] = {.lex_state = 35},
  [225] = {.lex_state = 35},
  [226] = {.lex_state = 35},
  [227] = {.lex_state = 35},
  [228] = {.lex_state = 35},
  [229] = {.lex_state = 35},
  [230] = {.lex_state = 35},
  [231] = {.lex_state = 35},
  [232] = {.lex_state = 35},
  [233] = {.lex_state = 35},
  [234] = {.lex_state = 35},
  [235] = {.lex_state = 35},
  [236] = {.lex_state = 35},
  [237] = {.lex_state = 35},
  [238] = {.lex_state = 35},
  [239] = {.lex_state = 35},
  [240] = {.lex_state = 35},
  [241] = {.lex_state = 35},
  [242] = {.lex_state = 35},
  [243] = {.lex_state = 35},
  [244] = {.lex_state = 35},
  [245] = {.lex_state = 35},
  [246] = {.lex_state = 35},
  [247] = {.lex_state = 35},
  [248] = {.lex_state = 35},
  [249] = {.lex_state = 35},
  [250] = {.lex_state = 35},
  [251] = {.lex_state = 35},
  [252] = {.lex_state = 35},
  [253] = {.lex_state = 35},
  [254] = {.lex_state = 35},
  [255] = {.lex_state = 35},
  [256] = {.lex_state = 35},
  [257] = {.lex_state = 35},
  [258] = {.lex_state = 35},
  [259] = {.lex_state = 35},
  [260] = {.lex_state = 35},
  [261] = {.lex_state = 35},
  [262] = {.lex_state = 35},
  [263] = {.lex_state = 35},
  [264] = {.lex_state = 35},
  [265] = {.lex_state = 35},
  [266] = {.lex_state = 35},
  [267] = {.lex_state = 35},
  [268] = {.lex_state = 35},
  [269] = {.lex_state = 35},
  [270] = {.lex_state = 35},
  [271] = {.lex_state = 35},
  [272] = {.lex_state = 35},
  [273] = {.lex_state = 35},
  [274] = {.lex_state = 35},
  [275] = {.lex_state = 35},
  [276] = {.lex_state = 35},
  [277] = {.lex_state = 35},
  [278] = {.lex_state = 35},
  [279] = {.lex_state = 35},
  [280] = {.lex_state = 35},
  [281] = {.lex_state = 35},
  [282] = {.lex_state = 35},
  [283] = {.lex_state = 35},
  [284] = {.lex_state = 35, .external_lex_state = 2},
  [285] = {.lex_state = 35, .external_lex_state = 2},
  [286] = {.lex_state = 35},
  [287] = {.lex_state = 35},
  [288] = {.lex_state = 35},
  [289] = {.lex_state = 35},
  [290] = {.lex_state = 35},
  [291] = {.lex_state = 35},
  [292] = {.lex_state = 35, .external_lex_state = 2},
  [293] = {.lex_state = 35},
  [294] = {.lex_state = 33},
  [295] = {.lex_state = 35},
  [296] = {.lex_state = 35},
  [297] = {.lex_state = 35},
  [298] = {.lex_state = 35},
  [299] = {.lex_state = 35},
  [300] = {.lex_state = 1, .external_lex_state = 3},
  [301] = {.lex_state = 35},
  [302] = {.lex_state = 35},
  [303] = {.lex_state = 35},
  [304] = {.lex_state = 35},
  [305] = {.lex_state = 35},
  [306] = {.lex_state = 35},
  [307] = {.lex_state = 35},
  [308] = {.lex_state = 1, .external_lex_state = 3},
  [309] = {.lex_state = 35},
  [310] = {.lex_state = 35},
  [311] = {.lex_state = 35},
  [312] = {.lex_state = 35},
  [313] = {.lex_state = 35, .external_lex_state = 2},
  [314] = {.lex_state = 35},
  [315] = {.lex_state = 35},
  [316] = {.lex_state = 35},
  [317] = {.lex_state = 35},
  [318] = {.lex_state = 35},
  [319] = {.lex_state = 35},
  [320] = {.lex_state = 35},
  [321] = {.lex_state = 35},
  [322] = {.lex_state = 35},
  [323] = {.lex_state = 35},
  [324] = {.lex_state = 35},
  [325] = {.lex_state = 35},
  [326] = {.lex_state = 35},
  [327] = {.lex_state = 35},
  [328] = {.lex_state = 35},
  [329] = {.lex_state = 35},
  [330] = {.lex_state = 35},
  [331] = {.lex_state = 1, .external_lex_state = 3},
  [332] = {.lex_state = 1, .external_lex_state = 3},
  [333] = {.lex_state = 1, .external_lex_state = 3},
  [334] = {.lex_state = 1, .external_lex_state = 3},
  [335] = {.lex_state = 1, .external_lex_state = 3},
  [336] = {.lex_state = 1, .external_lex_state = 3},
  [337] = {.lex_state = 1, .external_lex_state = 3},
  [338] = {.lex_state = 1, .external_lex_state = 3},
  [339] = {.lex_state = 1, .external_lex_state = 3},
  [340] = {.lex_state = 1, .external_lex_state = 3},
  [341] = {.lex_state = 1, .external_lex_state = 3},
  [342] = {.lex_state = 1, .external_lex_state = 3},
  [343] = {.lex_state = 1, .external_lex_state = 3},
  [344] = {.lex_state = 1, .external_lex_state = 3},
  [345] = {.lex_state = 35, .external_lex_state = 2},
  [346] = {.lex_state = 1, .external_lex_state = 3},
  [347] = {.lex_state = 35, .external_lex_state = 2},
  [348] = {.lex_state = 35, .external_lex_state = 2},
  [349] = {.lex_state = 1, .external_lex_state = 3},
  [350] = {.lex_state = 1, .external_lex_state = 3},
  [351] = {.lex_state = 1, .external_lex_state = 3},
  [352] = {.lex_state = 1, .external_lex_state = 3},
  [353] = {.lex_state = 1, .external_lex_state = 3},
  [354] = {.lex_state = 1, .external_lex_state = 3},
  [355] = {.lex_state = 1, .external_lex_state = 3},
  [356] = {.lex_state = 1, .external_lex_state = 3},
  [357] = {.lex_state = 1, .external_lex_state = 3},
  [358] = {.lex_state = 1, .external_lex_state = 3},
  [359] = {.lex_state = 1, .external_lex_state = 3},
  [360] = {.lex_state = 1, .external_lex_state = 3},
  [361] = {.lex_state = 1, .external_lex_state = 3},
  [362] = {.lex_state = 1, .external_lex_state = 3},
  [363] = {.lex_state = 1, .external_lex_state = 3},
  [364] = {.lex_state = 1, .external_lex_state = 3},
  [365] = {.lex_state = 1, .external_lex_state = 3},
  [366] = {.lex_state = 1, .external_lex_state = 3},
  [367] = {.lex_state = 1, .external_lex_state = 3},
  [368] = {.lex_state = 1, .external_lex_state = 3},
  [369] = {.lex_state = 1, .external_lex_state = 3},
  [370] = {.lex_state = 1, .external_lex_state = 3},
  [371] = {.lex_state = 1, .external_lex_state = 3},
  [372] = {.lex_state = 1, .external_lex_state = 3},
  [373] = {.lex_state = 1, .external_lex_state = 3},
  [374] = {.lex_state = 1, .external_lex_state = 3},
  [375] = {.lex_state = 1, .external_lex_state = 3},
  [376] = {.lex_state = 1, .external_lex_state = 3},
  [377] = {.lex_state = 1, .external_lex_state = 3},
  [378] = {.lex_state = 1, .external_lex_state = 3},
  [379] = {.lex_state = 1, .external_lex_state = 3},
  [380] = {.lex_state = 1, .external_lex_state = 3},
  [381] = {.lex_state = 1, .external_lex_state = 3},
  [382] = {.lex_state = 1, .external_lex_state = 3},
  [383] = {.lex_state = 1, .external_lex_state = 3},
  [384] = {.lex_state = 1, .external_lex_state = 3},
  [385] = {.lex_state = 1, .external_lex_state = 3},
  [386] = {.lex_state = 1, .external_lex_state = 3},
  [387] = {.lex_state = 1, .external_lex_state = 3},
  [388] = {.lex_state = 1, .external_lex_state = 3},
  [389] = {.lex_state = 1, .external_lex_state = 3},
  [390] = {.lex_state = 1, .external_lex_state = 3},
  [391] = {.lex_state = 1, .external_lex_state = 3},
  [392] = {.lex_state = 1, .external_lex_state = 3},
  [393] = {.lex_state = 1, .external_lex_state = 3},
  [394] = {.lex_state = 35},
  [395] = {.lex_state = 35},
  [396] = {.lex_state = 35},
  [397] = {.lex_state = 35},
  [398] = {.lex_state = 35},
  [399] = {.lex_state = 35},
  [400] = {.lex_state = 35},
  [401] = {.lex_state = 35},
  [402] = {.lex_state = 35},
  [403] = {.lex_state = 35},
  [404] = {.lex_state = 35},
  [405] = {.lex_state = 35},
  [406] = {.lex_state = 35},
  [407] = {.lex_state = 35},
  [408] = {.lex_state = 35},
  [409] = {.lex_state = 35},
  [410] = {.lex_state = 35},
  [411] = {.lex_state = 35},
  [412] = {.lex_state = 35},
  [413] = {.lex_state = 35},
  [414] = {.lex_state = 35},
  [415] = {.lex_state = 35, .external_lex_state = 2},
  [416] = {.lex_state = 35, .external_lex_state = 2},
  [417] = {.lex_state = 35, .external_lex_state = 2},
  [418] = {.lex_state = 35, .external_lex_state = 2},
  [419] = {.lex_state = 35, .external_lex_state = 2},
  [420] = {.lex_state = 35, .external_lex_state = 2},
  [421] = {.lex_state = 35, .external_lex_state = 2},
  [422] = {.lex_state = 35, .external_lex_state = 2},
  [423] = {.lex_state = 35, .external_lex_state = 2},
  [424] = {.lex_state = 35, .external_lex_state = 2},
  [425] = {.lex_state = 33},
  [426] = {.lex_state = 35, .external_lex_state = 2},
  [427] = {.lex_state = 35, .external_lex_state = 2},
  [428] = {.lex_state = 35, .external_lex_state = 2},
  [429] = {.lex_state = 35, .external_lex_state = 2},
  [430] = {.lex_state = 35, .external_lex_state = 2},
  [431] = {.lex_state = 35, .external_lex_state = 2},
  [432] = {.lex_state = 35},
  [433] = {.lex_state = 35, .external_lex_state = 2},
  [434] = {.lex_state = 35, .external_lex_state = 2},
  [435] = {.lex_state = 35, .external_lex_state = 2},
  [436] = {.lex_state = 35, .external_lex_state = 2},
  [437] = {.lex_state = 35, .external_lex_state = 2},
  [438] = {.lex_state = 35},
  [439] = {.lex_state = 35, .external_lex_state = 2},
  [440] = {.lex_state = 35, .external_lex_state = 2},
  [441] = {.lex_state = 33},
  [442] = {.lex_state = 35},
  [443] = {.lex_state = 1, .external_lex_state = 3},
  [444] = {.lex_state = 33},
  [445] = {.lex_state = 1, .external_lex_state = 3},
  [446] = {.lex_state = 35, .external_lex_state = 2},
  [447] = {.lex_state = 1, .external_lex_state = 3},
  [448] = {.lex_state = 35, .external_lex_state = 2},
  [449] = {.lex_state = 35, .external_lex_state = 2},
  [450] = {.lex_state = 35, .external_lex_state = 2},
  [451] = {.lex_state = 35, .external_lex_state = 2},
  [452] = {.lex_state = 1, .external_lex_state = 3},
  [453] = {.lex_state = 35, .external_lex_state = 2},
  [454] = {.lex_state = 35},
  [455] = {.lex_state = 35, .external_lex_state = 2},
  [456] = {.lex_state = 35},
  [457] = {.lex_state = 1, .external_lex_state = 3},
  [458] = {.lex_state = 35, .external_lex_state = 2},
  [459] = {.lex_state = 35},
  [460] = {.lex_state = 35, .external_lex_state = 2},
  [461] = {.lex_state = 1, .external_lex_state = 3},
  [462] = {.lex_state = 35},
  [463] = {.lex_state = 1, .external_lex_state = 3},
  [464] = {.lex_state = 35},
  [465] = {.lex_state = 1, .external_lex_state = 3},
  [466] = {.lex_state = 35},
  [467] = {.lex_state = 1, .external_lex_state = 3},
  [468] = {.lex_state = 35},
  [469] = {.lex_state = 1, .external_lex_state = 3},
  [470] = {.lex_state = 1, .external_lex_state = 3},
  [471] = {.lex_state = 1, .external_lex_state = 3},
  [472] = {.lex_state = 35, .external_lex_state = 2},
  [473] = {.lex_state = 35, .external_lex_state = 2},
  [474] = {.lex_state = 1, .external_lex_state = 3},
  [475] = {.lex_state = 35, .external_lex_state = 2},
  [476] = {.lex_state = 35, .external_lex_state = 2},
  [477] = {.lex_state = 35},
  [478] = {.lex_state = 35},
  [479] = {.lex_state = 35, .external_lex_state = 2},
  [480] = {.lex_state = 35},
  [481] = {.lex_state = 1, .external_lex_state = 3},
  [482] = {.lex_state = 35},
  [483] = {.lex_state = 35},
  [484] = {.lex_state = 35},
  [485] = {.lex_state = 35, .external_lex_state = 2},
  [486] = {.lex_state = 35},
  [487] = {.lex_state = 1, .external_lex_state = 3},
  [488] = {.lex_state = 35, .external_lex_state = 2},
  [489] = {.lex_state = 35, .external_lex_state = 2},
  [490] = {.lex_state = 35, .external_lex_state = 2},
  [491] = {.lex_state = 35},
  [492] = {.lex_state = 1, .external_lex_state = 3},
  [493] = {.lex_state = 35, .external_lex_state = 2},
  [494] = {.lex_state = 1, .external_lex_state = 3},
  [495] = {.lex_state = 1, .external_lex_state = 3},
  [496] = {.lex_state = 35, .external_lex_state = 2},
  [497] = {.lex_state = 35},
  [498] = {.lex_state = 35},
  [499] = {.lex_state = 35},
  [500] = {.lex_state = 1, .external_lex_state = 3},
  [501] = {.lex_state = 35, .external_lex_state = 2},
  [502] = {.lex_state = 35},
  [503] = {.lex_state = 1, .external_lex_state = 3},
  [504] = {.lex_state = 1, .external_lex_state = 3},
  [505] = {.lex_state = 1, .external_lex_state = 3},
  [506] = {.lex_state = 35, .external_lex_state = 2},
  [507] = {.lex_state = 35, .external_lex_state = 2},
  [508] = {.lex_state = 35, .external_lex_state = 2},
  [509] = {.lex_state = 1, .external_lex_state = 3},
  [510] = {.lex_state = 35, .external_lex_state = 2},
  [511] = {.lex_state = 1, .external_lex_state = 3},
  [512] = {.lex_state = 35, .external_lex_state = 2},
  [513] = {.lex_state = 35, .external_lex_state = 2},
  [514] = {.lex_state = 35, .external_lex_state = 2},
  [515] = {.lex_state = 1, .external_lex_state = 3},
  [516] = {.lex_state = 35, .external_lex_state = 2},
  [517] = {.lex_state = 1, .external_lex_state = 3},
  [518] = {.lex_state = 1, .external_lex_state = 3},
  [519] = {.lex_state = 1, .external_lex_state = 3},
  [520] = {.lex_state = 1, .external_lex_state = 3},
  [521] = {.lex_state = 1, .external_lex_state = 3},
  [522] = {.lex_state = 35, .external_lex_state = 2},
  [523] = {.lex_state = 35},
  [524] = {.lex_state = 1, .external_lex_state = 3},
  [525] = {.lex_state = 1, .external_lex_state = 3},
  [526] = {.lex_state = 1, .external_lex_state = 3},
  [527] = {.lex_state = 1, .external_lex_state = 3},
  [528] = {.lex_state = 1, .external_lex_state = 3},
  [529] = {.lex_state = 1, .external_lex_state = 3},
  [530] = {.lex_state = 1, .external_lex_state = 3},
  [531] = {.lex_state = 1, .external_lex_state = 3},
  [532] = {.lex_state = 1, .external_lex_state = 3},
  [533] = {.lex_state = 1, .external_lex_state = 3},
  [534] = {.lex_state = 1, .external_lex_state = 3},
  [535] = {.lex_state = 1, .external_lex_state = 3},
  [536] = {.lex_state = 1, .external_lex_state = 3},
  [537] = {.lex_state = 1, .external_lex_state = 3},
  [538] = {.lex_state = 1, .external_lex_state = 3},
  [539] = {.lex_state = 1, .external_lex_state = 3},
  [540] = {.lex_state = 1, .external_lex_state = 3},
  [541] = {.lex_state = 1, .external_lex_state = 3},
  [542] = {.lex_state = 35, .external_lex_state = 2},
  [543] = {.lex_state = 1, .external_lex_state = 3},
  [544] = {.lex_state = 1, .external_lex_state = 3},
  [545] = {.lex_state = 1, .external_lex_state = 3},
  [546] = {.lex_state = 1, .external_lex_state = 3},
  [547] = {.lex_state = 1, .external_lex_state = 3},
  [548] = {.lex_state = 1, .external_lex_state = 3},
  [549] = {.lex_state = 1, .external_lex_state = 3},
  [550] = {.lex_state = 1, .external_lex_state = 3},
  [551] = {.lex_state = 1, .external_lex_state = 3},
  [552] = {.lex_state = 35, .external_lex_state = 2},
  [553] = {.lex_state = 1, .external_lex_state = 3},
  [554] = {.lex_state = 35, .external_lex_state = 2},
  [555] = {.lex_state = 1, .external_lex_state = 3},
  [556] = {.lex_state = 1, .external_lex_state = 3},
  [557] = {.lex_state = 35, .external_lex_state = 2},
  [558] = {.lex_state = 1, .external_lex_state = 3},
  [559] = {.lex_state = 1, .external_lex_state = 3},
  [560] = {.lex_state = 35, .external_lex_state = 2},
  [561] = {.lex_state = 1, .external_lex_state = 3},
  [562] = {.lex_state = 1, .external_lex_state = 3},
  [563] = {.lex_state = 35, .external_lex_state = 2},
  [564] = {.lex_state = 1, .external_lex_state = 3},
  [565] = {.lex_state = 1, .external_lex_state = 3},
  [566] = {.lex_state = 1, .external_lex_state = 3},
  [567] = {.lex_state = 35},
  [568] = {.lex_state = 1, .external_lex_state = 3},
  [569] = {.lex_state = 1, .external_lex_state = 3},
  [570] = {.lex_state = 1, .external_lex_state = 3},
  [571] = {.lex_state = 35},
  [572] = {.lex_state = 1, .external_lex_state = 3},
  [573] = {.lex_state = 35, .external_lex_state = 2},
  [574] = {.lex_state = 35, .external_lex_state = 2},
  [575] = {.lex_state = 35, .external_lex_state = 2},
  [576] = {.lex_state = 1, .external_lex_state = 3},
  [577] = {.lex_state = 1, .external_lex_state = 3},
  [578] = {.lex_state = 35, .external_lex_state = 2},
  [579] = {.lex_state = 1, .external_lex_state = 3},
  [580] = {.lex_state = 35, .external_lex_state = 2},
  [581] = {.lex_state = 35, .external_lex_state = 2},
  [582] = {.lex_state = 1, .external_lex_state = 3},
  [583] = {.lex_state = 1, .external_lex_state = 3},
  [584] = {.lex_state = 1, .external_lex_state = 3},
  [585] = {.lex_state = 1, .external_lex_state = 3},
  [586] = {.lex_state = 35},
  [587] = {.lex_state = 1, .external_lex_state = 3},
  [588] = {.lex_state = 1, .external_lex_state = 3},
  [589] = {.lex_state = 1, .external_lex_state = 3},
  [590] = {.lex_state = 1, .external_lex_state = 3},
  [591] = {.lex_state = 35},
  [592] = {.lex_state = 1, .external_lex_state = 3},
  [593] = {.lex_state = 35, .external_lex_state = 2},
  [594] = {.lex_state = 1, .external_lex_state = 3},
  [595] = {.lex_state = 1, .external_lex_state = 3},
  [596] = {.lex_state = 1, .external_lex_state = 3},
  [597] = {.lex_state = 1, .external_lex_state = 3},
  [598] = {.lex_state = 35, .external_lex_state = 2},
  [599] = {.lex_state = 1, .external_lex_state = 3},
  [600] = {.lex_state = 1, .external_lex_state = 3},
  [601] = {.lex_state = 1, .external_lex_state = 3},
  [602] = {.lex_state = 1, .external_lex_state = 3},
  [603] = {.lex_state = 1, .external_lex_state = 3},
  [604] = {.lex_state = 1, .external_lex_state = 3},
  [605] = {.lex_state = 35},
  [606] = {.lex_state = 35, .external_lex_state = 2},
  [607] = {.lex_state = 35, .external_lex_state = 2},
  [608] = {.lex_state = 35},
  [609] = {.lex_state = 35},
  [610] = {.lex_state = 35},
  [611] = {.lex_state = 1, .external_lex_state = 3},
  [612] = {.lex_state = 1, .external_lex_state = 3},
  [613] = {.lex_state = 1, .external_lex_state = 3},
  [614] = {.lex_state = 1, .external_lex_state = 3},
  [615] = {.lex_state = 1, .external_lex_state = 3},
  [616] = {.lex_state = 35, .external_lex_state = 2},
  [617] = {.lex_state = 1, .external_lex_state = 3},
  [618] = {.lex_state = 35, .external_lex_state = 2},
  [619] = {.lex_state = 1, .external_lex_state = 3},
  [620] = {.lex_state = 1, .external_lex_state = 3},
  [621] = {.lex_state = 35},
  [622] = {.lex_state = 35, .external_lex_state = 2},
  [623] = {.lex_state = 35, .external_lex_state = 2},
  [624] = {.lex_state = 1, .external_lex_state = 3},
  [625] = {.lex_state = 1, .external_lex_state = 3},
  [626] = {.lex_state = 1, .external_lex_state = 3},
  [627] = {.lex_state = 1, .external_lex_state = 3},
  [628] = {.lex_state = 1, .external_lex_state = 3},
  [629] = {.lex_state = 1, .external_lex_state = 3},
  [630] = {.lex_state = 35, .external_lex_state = 2},
  [631] = {.lex_state = 1, .external_lex_state = 3},
  [632] = {.lex_state = 35, .external_lex_state = 2},
  [633] = {.lex_state = 1, .external_lex_state = 3},
  [634] = {.lex_state = 1, .external_lex_state = 3},
  [635] = {.lex_state = 1, .external_lex_state = 3},
  [636] = {.lex_state = 35},
  [637] = {.lex_state = 1, .external_lex_state = 3},
  [638] = {.lex_state = 1, .external_lex_state = 3},
  [639] = {.lex_state = 1, .external_lex_state = 3},
  [640] = {.lex_state = 1, .external_lex_state = 3},
  [641] = {.lex_state = 35, .external_lex_state = 2},
  [642] = {.lex_state = 1, .external_lex_state = 3},
  [643] = {.lex_state = 1, .external_lex_state = 3},
  [644] = {.lex_state = 1, .external_lex_state = 3},
  [645] = {.lex_state = 1, .external_lex_state = 3},
  [646] = {.lex_state = 1, .external_lex_state = 3},
  [647] = {.lex_state = 35, .external_lex_state = 2},
  [648] = {.lex_state = 1, .external_lex_state = 3},
  [649] = {.lex_state = 35},
  [650] = {.lex_state = 35, .external_lex_state = 2},
  [651] = {.lex_state = 35, .external_lex_state = 2},
  [652] = {.lex_state = 1, .external_lex_state = 3},
  [653] = {.lex_state = 1, .external_lex_state = 3},
  [654] = {.lex_state = 35, .external_lex_state = 2},
  [655] = {.lex_state = 35, .external_lex_state = 2},
  [656] = {.lex_state = 35},
  [657] = {.lex_state = 35, .external_lex_state = 2},
  [658] = {.lex_state = 1, .external_lex_state = 3},
  [659] = {.lex_state = 1, .external_lex_state = 3},
  [660] = {.lex_state = 35},
  [661] = {.lex_state = 1, .external_lex_state = 3},
  [662] = {.lex_state = 1, .external_lex_state = 3},
  [663] = {.lex_state = 35, .external_lex_state = 2},
  [664] = {.lex_state = 35},
  [665] = {.lex_state = 1, .external_lex_state = 3},
  [666] = {.lex_state = 1, .external_lex_state = 3},
  [667] = {.lex_state = 35},
  [668] = {.lex_state = 35},
  [669] = {.lex_state = 35},
  [670] = {.lex_state = 1, .external_lex_state = 3},
  [671] = {.lex_state = 35},
  [672] = {.lex_state = 35},
  [673] = {.lex_state = 1, .external_lex_state = 3},
  [674] = {.lex_state = 1, .external_lex_state = 3},
  [675] = {.lex_state = 1, .external_lex_state = 3},
  [676] = {.lex_state = 35},
  [677] = {.lex_state = 1, .external_lex_state = 3},
  [678] = {.lex_state = 35},
  [679] = {.lex_state = 35},
  [680] = {.lex_state = 35, .external_lex_state = 2},
  [681] = {.lex_state = 35, .external_lex_state = 2},
  [682] = {.lex_state = 35, .external_lex_state = 2},
  [683] = {.lex_state = 35},
  [684] = {.lex_state = 35, .external_lex_state = 2},
  [685] = {.lex_state = 1, .external_lex_state = 3},
  [686] = {.lex_state = 35},
  [687] = {.lex_state = 35, .external_lex_state = 2},
  [688] = {.lex_state = 35, .external_lex_state = 2},
  [689] = {.lex_state = 35},
  [690] = {.lex_state = 35},
  [691] = {.lex_state = 35},
  [692] = {.lex_state = 35},
  [693] = {.lex_state = 35, .external_lex_state = 2},
  [694] = {.lex_state = 35, .external_lex_state = 2},
  [695] = {.lex_state = 1, .external_lex_state = 3},
  [696] = {.lex_state = 1, .external_lex_state = 3},
  [697] = {.lex_state = 35, .external_lex_state = 2},
  [698] = {.lex_state = 35, .external_lex_state = 2},
  [699] = {.lex_state = 1, .external_lex_state = 3},
  [700] = {.lex_state = 1, .external_lex_state = 3},
  [701] = {.lex_state = 35, .external_lex_state = 2},
  [702] = {.lex_state = 35, .external_lex_state = 2},
  [703] = {.lex_state = 35},
  [704] = {.lex_state = 35, .external_lex_state = 2},
  [705] = {.lex_state = 35, .external_lex_state = 2},
  [706] = {.lex_state = 35, .external_lex_state = 2},
  [707] = {.lex_state = 35},
  [708] = {.lex_state = 35, .external_lex_state = 2},
  [709] = {.lex_state = 35, .external_lex_state = 2},
  [710] = {.lex_state = 35, .external_lex_state = 2},
  [711] = {.lex_state = 35, .external_lex_state = 2},
  [712] = {.lex_state = 35, .external_lex_state = 2},
  [713] = {.lex_state = 35, .external_lex_state = 2},
  [714] = {.lex_state = 35},
  [715] = {.lex_state = 1, .external_lex_state = 3},
  [716] = {.lex_state = 35, .external_lex_state = 2},
  [717] = {.lex_state = 35},
  [718] = {.lex_state = 35, .external_lex_state = 2},
  [719] = {.lex_state = 35},
  [720] = {.lex_state = 35, .external_lex_state = 2},
  [721] = {.lex_state = 35, .external_lex_state = 2},
  [722] = {.lex_state = 35, .external_lex_state = 2},
  [723] = {.lex_state = 35},
  [724] = {.lex_state = 35, .external_lex_state = 2},
  [725] = {.lex_state = 35, .external_lex_state = 2},
  [726] = {.lex_state = 35, .external_lex_state = 2},
  [727] = {.lex_state = 1, .external_lex_state = 3},
  [728] = {.lex_state = 35, .external_lex_state = 2},
  [729] = {.lex_state = 35},
  [730] = {.lex_state = 35, .external_lex_state = 2},
  [731] = {.lex_state = 1, .external_lex_state = 3},
  [732] = {.lex_state = 35},
  [733] = {.lex_state = 35, .external_lex_state = 2},
  [734] = {.lex_state = 35},
  [735] = {.lex_state = 35},
  [736] = {.lex_state = 1, .external_lex_state = 3},
  [737] = {.lex_state = 35},
  [738] = {.lex_state = 1, .external_lex_state = 3},
  [739] = {.lex_state = 35, .external_lex_state = 2},
  [740] = {.lex_state = 35},
  [741] = {.lex_state = 35},
  [742] = {.lex_state = 35},
  [743] = {.lex_state = 1, .external_lex_state = 3},
  [744] = {.lex_state = 1, .external_lex_state = 3},
  [745] = {.lex_state = 35, .external_lex_state = 2},
  [746] = {.lex_state = 1, .external_lex_state = 3},
  [747] = {.lex_state = 1, .external_lex_state = 3},
  [748] = {.lex_state = 35},
  [749] = {.lex_state = 35, .external_lex_state = 2},
  [750] = {.lex_state = 35, .external_lex_state = 2},
  [751] = {.lex_state = 35},
  [752] = {.lex_state = 35, .external_lex_state = 2},
  [753] = {.lex_state = 35, .external_lex_state = 2},
  [754] = {.lex_state = 35},
  [755] = {.lex_state = 35},
  [756] = {.lex_state = 35, .external_lex_state = 2},
  [757] = {.lex_state = 1, .external_lex_state = 3},
  [758] = {.lex_state = 1, .external_lex_state = 3},
  [759] = {.lex_state = 35},
  [760] = {.lex_state = 35},
  [761] = {.lex_state = 1, .external_lex_state = 3},
  [762] = {.lex_state = 35, .external_lex_state = 2},
  [763] = {.lex_state = 1, .external_lex_state = 3},
  [764] = {.lex_state = 35, .external_lex_state = 2},
  [765] = {.lex_state = 1, .external_lex_state = 3},
  [766] = {.lex_state = 35},
  [767] = {.lex_state = 1, .external_lex_state = 3},
  [768] = {.lex_state = 1, .external_lex_state = 3},
  [769] = {.lex_state = 35},
  [770] = {.lex_state = 35},
  [771] = {.lex_state = 35, .external_lex_state = 2},
  [772] = {.lex_state = 1, .external_lex_state = 3},
  [773] = {.lex_state = 1, .external_lex_state = 3},
  [774] = {.lex_state = 35},
  [775] = {.lex_state = 35},
  [776] = {.lex_state = 35},
  [777] = {.lex_state = 35},
  [778] = {.lex_state = 1, .external_lex_state = 3},
  [779] = {.lex_state = 1, .external_lex_state = 3},
  [780] = {.lex_state = 35, .external_lex_state = 2},
  [781] = {.lex_state = 35},
  [782] = {.lex_state = 35, .external_lex_state = 2},
  [783] = {.lex_state = 35},
  [784] = {.lex_state = 35, .external_lex_state = 2},
  [785] = {.lex_state = 35},
  [786] = {.lex_state = 35, .external_lex_state = 2},
  [787] = {.lex_state = 35},
  [788] = {.lex_state = 35, .external_lex_state = 2},
  [789] = {.lex_state = 1, .external_lex_state = 3},
  [790] = {.lex_state = 35, .external_lex_state = 2},
  [791] = {.lex_state = 1, .external_lex_state = 3},
  [792] = {.lex_state = 35},
  [793] = {.lex_state = 35, .external_lex_state = 2},
  [794] = {.lex_state = 35},
  [795] = {.lex_state = 35, .external_lex_state = 2},
  [796] = {.lex_state = 35, .external_lex_state = 2},
  [797] = {.lex_state = 35, .external_lex_state = 2},
  [798] = {.lex_state = 35, .external_lex_state = 2},
  [799] = {.lex_state = 35, .external_lex_state = 2},
  [800] = {.lex_state = 35, .external_lex_state = 2},
  [801] = {.lex_state = 35, .external_lex_state = 2},
  [802] = {.lex_state = 35, .external_lex_state = 2},
  [803] = {.lex_state = 35},
  [804] = {.lex_state = 35, .external_lex_state = 2},
  [805] = {.lex_state = 35, .external_lex_state = 2},
  [806] = {.lex_state = 35, .external_lex_state = 2},
  [807] = {.lex_state = 35, .external_lex_state = 2},
  [808] = {.lex_state = 35, .external_lex_state = 2},
  [809] = {.lex_state = 35},
  [810] = {.lex_state = 35, .external_lex_state = 2},
  [811] = {.lex_state = 35, .external_lex_state = 2},
  [812] = {.lex_state = 35, .external_lex_state = 2},
  [813] = {.lex_state = 35},
  [814] = {.lex_state = 35, .external_lex_state = 2},
  [815] = {.lex_state = 35},
  [816] = {.lex_state = 35, .external_lex_state = 2},
  [817] = {.lex_state = 35, .external_lex_state = 2},
  [818] = {.lex_state = 35, .external_lex_state = 2},
  [819] = {.lex_state = 35, .external_lex_state = 2},
  [820] = {.lex_state = 35},
  [821] = {.lex_state = 35, .external_lex_state = 2},
  [822] = {.lex_state = 35, .external_lex_state = 2},
  [823] = {.lex_state = 35, .external_lex_state = 2},
  [824] = {.lex_state = 1, .external_lex_state = 3},
  [825] = {.lex_state = 35, .external_lex_state = 2},
  [826] = {.lex_state = 35},
  [827] = {.lex_state = 35},
  [828] = {.lex_state = 35},
  [829] = {.lex_state = 35, .external_lex_state = 2},
  [830] = {.lex_state = 35, .external_lex_state = 2},
  [831] = {.lex_state = 35, .external_lex_state = 2},
  [832] = {.lex_state = 35, .external_lex_state = 2},
  [833] = {.lex_state = 35, .external_lex_state = 2},
  [834] = {.lex_state = 35},
  [835] = {.lex_state = 35, .external_lex_state = 2},
  [836] = {.lex_state = 35, .external_lex_state = 2},
  [837] = {.lex_state = 35},
  [838] = {.lex_state = 35, .external_lex_state = 2},
  [839] = {.lex_state = 35},
  [840] = {.lex_state = 35, .external_lex_state = 2},
  [841] = {.lex_state = 35, .external_lex_state = 2},
  [842] = {.lex_state = 35, .external_lex_state = 2},
  [843] = {.lex_state = 35, .external_lex_state = 2},
  [844] = {.lex_state = 35},
  [845] = {.lex_state = 35},
  [846] = {.lex_state = 35},
  [847] = {.lex_state = 1, .external_lex_state = 3},
  [848] = {.lex_state = 35, .external_lex_state = 2},
  [849] = {.lex_state = 35, .external_lex_state = 2},
  [850] = {.lex_state = 35, .external_lex_state = 2},
  [851] = {.lex_state = 35},
  [852] = {.lex_state = 35},
  [853] = {.lex_state = 35, .external_lex_state = 2},
  [854] = {.lex_state = 35, .external_lex_state = 2},
  [855] = {.lex_state = 35},
  [856] = {.lex_state = 35, .external_lex_state = 2},
  [857] = {.lex_state = 35},
  [858] = {.lex_state = 35, .external_lex_state = 2},
  [859] = {.lex_state = 35, .external_lex_state = 2},
  [860] = {.lex_state = 35, .external_lex_state = 2},
  [861] = {.lex_state = 35, .external_lex_state = 2},
  [862] = {.lex_state = 35, .external_lex_state = 2},
  [863] = {.lex_state = 35, .external_lex_state = 2},
  [864] = {.lex_state = 35, .external_lex_state = 2},
  [865] = {.lex_state = 35, .external_lex_state = 2},
  [866] = {.lex_state = 35},
  [867] = {.lex_state = 35, .external_lex_state = 2},
  [868] = {.lex_state = 35},
  [869] = {.lex_state = 35, .external_lex_state = 2},
  [870] = {.lex_state = 35},
  [871] = {.lex_state = 35, .external_lex_state = 2},
  [872] = {.lex_state = 35},
  [873] = {.lex_state = 35, .external_lex_state = 2},
  [874] = {.lex_state = 35, .external_lex_state = 2},
  [875] = {.lex_state = 35},
  [876] = {.lex_state = 35},
  [877] = {.lex_state = 35, .external_lex_state = 2},
  [878] = {.lex_state = 35, .external_lex_state = 2},
  [879] = {.lex_state = 35},
  [880] = {.lex_state = 35, .external_lex_state = 2},
  [881] = {.lex_state = 35, .external_lex_state = 2},
  [882] = {.lex_state = 35, .external_lex_state = 2},
  [883] = {.lex_state = 35},
  [884] = {.lex_state = 35},
  [885] = {.lex_state = 35, .external_lex_state = 2},
  [886] = {.lex_state = 35},
  [887] = {.lex_state = 35},
  [888] = {.lex_state = 35, .external_lex_state = 2},
  [889] = {.lex_state = 35, .external_lex_state = 2},
  [890] = {.lex_state = 35, .external_lex_state = 2},
  [891] = {.lex_state = 35, .external_lex_state = 2},
  [892] = {.lex_state = 35},
  [893] = {.lex_state = 35, .external_lex_state = 2},
  [894] = {.lex_state = 35, .external_lex_state = 2},
  [895] = {.lex_state = 35, .external_lex_state = 2},
  [896] = {.lex_state = 35, .external_lex_state = 2},
  [897] = {.lex_state = 35, .external_lex_state = 2},
  [898] = {.lex_state = 35, .external_lex_state = 2},
  [899] = {.lex_state = 35, .external_lex_state = 2},
  [900] = {.lex_state = 35},
  [901] = {.lex_state = 35},
  [902] = {.lex_state = 35},
  [903] = {.lex_state = 35, .external_lex_state = 2},
  [904] = {.lex_state = 35},
  [905] = {.lex_state = 35, .external_lex_state = 2},
  [906] = {.lex_state = 35, .external_lex_state = 2},
  [907] = {.lex_state = 35, .external_lex_state = 2},
  [908] = {.lex_state = 35},
  [909] = {.lex_state = 35, .external_lex_state = 2},
  [910] = {.lex_state = 35},
  [911] = {.lex_state = 35},
  [912] = {.lex_state = 35, .external_lex_state = 2},
  [913] = {.lex_state = 35, .external_lex_state = 2},
  [914] = {.lex_state = 35},
  [915] = {.lex_state = 35},
  [916] = {.lex_state = 35, .external_lex_state = 2},
  [917] = {.lex_state = 35, .external_lex_state = 2},
  [918] = {.lex_state = 1, .external_lex_state = 3},
  [919] = {.lex_state = 1, .external_lex_state = 3},
  [920] = {.lex_state = 1, .external_lex_state = 3},
  [921] = {.lex_state = 1, .external_lex_state = 3},
  [922] = {.lex_state = 1, .external_lex_state = 3},
  [923] = {.lex_state = 1, .external_lex_state = 3},
  [924] = {.lex_state = 1, .external_lex_state = 3},
  [925] = {.lex_state = 1, .external_lex_state = 3},
  [926] = {.lex_state = 1, .external_lex_state = 3},
  [927] = {.lex_state = 1, .external_lex_state = 3},
  [928] = {.lex_state = 1, .external_lex_state = 3},
  [929] = {.lex_state = 1, .external_lex_state = 3},
  [930] = {.lex_state = 1, .external_lex_state = 3},
  [931] = {.lex_state = 1, .external_lex_state = 3},
  [932] = {.lex_state = 1, .external_lex_state = 3},
  [933] = {.lex_state = 1, .external_lex_state = 3},
  [934] = {.lex_state = 1, .external_lex_state = 3},
  [935] = {.lex_state = 1, .external_lex_state = 3},
  [936] = {.lex_state = 1, .external_lex_state = 3},
  [937] = {.lex_state = 1, .external_lex_state = 3},
  [938] = {.lex_state = 1, .external_lex_state = 3},
  [939] = {.lex_state = 1, .external_lex_state = 3},
  [940] = {.lex_state = 1, .external_lex_state = 3},
  [941] = {.lex_state = 35, .external_lex_state = 2},
  [942] = {.lex_state = 1, .external_lex_state = 3},
  [943] = {.lex_state = 35, .external_lex_state = 2},
  [944] = {.lex_state = 1, .external_lex_state = 3},
  [945] = {.lex_state = 1, .external_lex_state = 3},
  [946] = {.lex_state = 1, .external_lex_state = 3},
  [947] = {.lex_state = 1, .external_lex_state = 3},
  [948] = {.lex_state = 1, .external_lex_state = 3},
  [949] = {.lex_state = 1, .external_lex_state = 3},
  [950] = {.lex_state = 1, .external_lex_state = 3},
  [951] = {.lex_state = 1, .external_lex_state = 3},
  [952] = {.lex_state = 1, .external_lex_state = 3},
  [953] = {.lex_state = 1, .external_lex_state = 3},
  [954] = {.lex_state = 1, .external_lex_state = 3},
  [955] = {.lex_state = 1, .external_lex_state = 3},
  [956] = {.lex_state = 35, .external_lex_state = 2},
  [957] = {.lex_state = 35, .external_lex_state = 2},
  [958] = {.lex_state = 1, .external_lex_state = 3},
  [959] = {.lex_state = 1, .external_lex_state = 3},
  [960] = {.lex_state = 35, .external_lex_state = 2},
  [961] = {.lex_state = 1, .external_lex_state = 3},
  [962] = {.lex_state = 1, .external_lex_state = 3},
  [963] = {.lex_state = 1, .external_lex_state = 3},
  [964] = {.lex_state = 1, .external_lex_state = 3},
  [965] = {.lex_state = 1, .external_lex_state = 3},
  [966] = {.lex_state = 1, .external_lex_state = 3},
  [967] = {.lex_state = 1, .external_lex_state = 3},
  [968] = {.lex_state = 1, .external_lex_state = 3},
  [969] = {.lex_state = 1, .external_lex_state = 3},
  [970] = {.lex_state = 1, .external_lex_state = 3},
  [971] = {.lex_state = 1, .external_lex_state = 3},
  [972] = {.lex_state = 1, .external_lex_state = 3},
  [973] = {.lex_state = 1, .external_lex_state = 3},
  [974] = {.lex_state = 1, .external_lex_state = 3},
  [975] = {.lex_state = 1, .external_lex_state = 3},
  [976] = {.lex_state = 1, .external_lex_state = 3},
  [977] = {.lex_state = 1, .external_lex_state = 3},
  [978] = {.lex_state = 1, .external_lex_state = 3},
  [979] = {.lex_state = 33, .external_lex_state = 2},
  [980] = {.lex_state = 1, .external_lex_state = 3},
  [981] = {.lex_state = 1, .external_lex_state = 3},
  [982] = {.lex_state = 35},
  [983] = {.lex_state = 1, .external_lex_state = 3},
  [984] = {.lex_state = 1, .external_lex_state = 3},
  [985] = {.lex_state = 1, .external_lex_state = 3},
  [986] = {.lex_state = 1, .external_lex_state = 3},
  [987] = {.lex_state = 1, .external_lex_state = 3},
  [988] = {.lex_state = 1, .external_lex_state = 3},
  [989] = {.lex_state = 1, .external_lex_state = 3},
  [990] = {.lex_state = 1, .external_lex_state = 3},
  [991] = {.lex_state = 1, .external_lex_state = 3},
  [992] = {.lex_state = 1, .external_lex_state = 3},
  [993] = {.lex_state = 1, .external_lex_state = 3},
  [994] = {.lex_state = 1, .external_lex_state = 3},
  [995] = {.lex_state = 1, .external_lex_state = 3},
  [996] = {.lex_state = 35},
  [997] = {.lex_state = 1, .external_lex_state = 3},
  [998] = {.lex_state = 1, .external_lex_state = 3},
  [999] = {.lex_state = 1, .external_lex_state = 3},
  [1000] = {.lex_state = 33, .external_lex_state = 2},
  [1001] = {.lex_state = 1, .external_lex_state = 3},
  [1002] = {.lex_state = 1, .external_lex_state = 3},
  [1003] = {.lex_state = 35, .external_lex_state = 2},
  [1004] = {.lex_state = 35},
  [1005] = {.lex_state = 1, .external_lex_state = 3},
  [1006] = {.lex_state = 35},
  [1007] = {.lex_state = 1, .external_lex_state = 3},
  [1008] = {.lex_state = 1, .external_lex_state = 3},
  [1009] = {.lex_state = 1, .external_lex_state = 3},
  [1010] = {.lex_state = 1, .external_lex_state = 3},
  [1011] = {.lex_state = 1, .external_lex_state = 3},
  [1012] = {.lex_state = 1, .external_lex_state = 3},
  [1013] = {.lex_state = 1, .external_lex_state = 3},
  [1014] = {.lex_state = 35, .external_lex_state = 2},
  [1015] = {.lex_state = 1, .external_lex_state = 3},
  [1016] = {.lex_state = 35, .external_lex_state = 2},
  [1017] = {.lex_state = 1, .external_lex_state = 3},
  [1018] = {.lex_state = 35},
  [1019] = {.lex_state = 35},
  [1020] = {.lex_state = 35},
  [1021] = {.lex_state = 1, .external_lex_state = 3},
  [1022] = {.lex_state = 35},
  [1023] = {.lex_state = 1, .external_lex_state = 3},
  [1024] = {.lex_state = 1, .external_lex_state = 3},
  [1025] = {.lex_state = 1, .external_lex_state = 3},
  [1026] = {.lex_state = 1, .external_lex_state = 3},
  [1027] = {.lex_state = 1, .external_lex_state = 3},
  [1028] = {.lex_state = 35, .external_lex_state = 2},
  [1029] = {.lex_state = 1, .external_lex_state = 3},
  [1030] = {.lex_state = 1, .external_lex_state = 3},
  [1031] = {.lex_state = 1, .external_lex_state = 3},
  [1032] = {.lex_state = 35},
  [1033] = {.lex_state = 35},
  [1034] = {.lex_state = 35},
  [1035] = {.lex_state = 35},
  [1036] = {.lex_state = 35},
  [1037] = {.lex_state = 35},
  [1038] = {.lex_state = 35},
  [1039] = {.lex_state = 1, .external_lex_state = 3},
  [1040] = {.lex_state = 1, .external_lex_state = 3},
  [1041] = {.lex_state = 1, .external_lex_state = 3},
  [1042] = {.lex_state = 35},
  [1043] = {.lex_state = 1, .external_lex_state = 3},
  [1044] = {.lex_state = 1, .external_lex_state = 3},
  [1045] = {.lex_state = 35},
  [1046] = {.lex_state = 35},
  [1047] = {.lex_state = 35},
  [1048] = {.lex_state = 35},
  [1049] = {.lex_state = 35},
  [1050] = {.lex_state = 1, .external_lex_state = 3},
  [1051] = {.lex_state = 35},
  [1052] = {.lex_state = 35},
  [1053] = {.lex_state = 1, .external_lex_state = 3},
  [1054] = {.lex_state = 1, .external_lex_state = 3},
  [1055] = {.lex_state = 1, .external_lex_state = 3},
  [1056] = {.lex_state = 35},
  [1057] = {.lex_state = 1, .external_lex_state = 3},
  [1058] = {.lex_state = 1, .external_lex_state = 3},
  [1059] = {.lex_state = 33},
  [1060] = {.lex_state = 1, .external_lex_state = 3},
  [1061] = {.lex_state = 1, .external_lex_state = 3},
  [1062] = {.lex_state = 1, .external_lex_state = 3},
  [1063] = {.lex_state = 35},
  [1064] = {.lex_state = 35},
  [1065] = {.lex_state = 1, .external_lex_state = 3},
  [1066] = {.lex_state = 35},
  [1067] = {.lex_state = 35},
  [1068] = {.lex_state = 35},
  [1069] = {.lex_state = 1, .external_lex_state = 3},
  [1070] = {.lex_state = 1, .external_lex_state = 3},
  [1071] = {.lex_state = 1, .external_lex_state = 3},
  [1072] = {.lex_state = 1, .external_lex_state = 3},
  [1073] = {.lex_state = 1, .external_lex_state = 3},
  [1074] = {.lex_state = 1, .external_lex_state = 3},
  [1075] = {.lex_state = 1, .external_lex_state = 3},
  [1076] = {.lex_state = 1, .external_lex_state = 3},
  [1077] = {.lex_state = 1, .external_lex_state = 3},
  [1078] = {.lex_state = 1, .external_lex_state = 3},
  [1079] = {.lex_state = 1, .external_lex_state = 3},
  [1080] = {.lex_state = 1, .external_lex_state = 3},
  [1081] = {.lex_state = 1, .external_lex_state = 3},
  [1082] = {.lex_state = 35},
  [1083] = {.lex_state = 35},
  [1084] = {.lex_state = 1, .external_lex_state = 3},
  [1085] = {.lex_state = 1, .external_lex_state = 3},
  [1086] = {.lex_state = 1, .external_lex_state = 3},
  [1087] = {.lex_state = 1, .external_lex_state = 3},
  [1088] = {.lex_state = 1, .external_lex_state = 3},
  [1089] = {.lex_state = 1, .external_lex_state = 3},
  [1090] = {.lex_state = 1, .external_lex_state = 3},
  [1091] = {.lex_state = 35},
  [1092] = {.lex_state = 1, .external_lex_state = 3},
  [1093] = {.lex_state = 1, .external_lex_state = 3},
  [1094] = {.lex_state = 1, .external_lex_state = 3},
  [1095] = {.lex_state = 1, .external_lex_state = 3},
  [1096] = {.lex_state = 1, .external_lex_state = 3},
  [1097] = {.lex_state = 1, .external_lex_state = 3},
  [1098] = {.lex_state = 1, .external_lex_state = 3},
  [1099] = {.lex_state = 1, .external_lex_state = 3},
  [1100] = {.lex_state = 35},
  [1101] = {.lex_state = 1, .external_lex_state = 3},
  [1102] = {.lex_state = 1, .external_lex_state = 3},
  [1103] = {.lex_state = 1, .external_lex_state = 3},
  [1104] = {.lex_state = 1, .external_lex_state = 3},
  [1105] = {.lex_state = 35, .external_lex_state = 2},
  [1106] = {.lex_state = 1, .external_lex_state = 3},
  [1107] = {.lex_state = 35},
  [1108] = {.lex_state = 35},
  [1109] = {.lex_state = 1, .external_lex_state = 3},
  [1110] = {.lex_state = 35, .external_lex_state = 2},
  [1111] = {.lex_state = 35, .external_lex_state = 2},
  [1112] = {.lex_state = 35, .external_lex_state = 2},
  [1113] = {.lex_state = 35, .external_lex_state = 2},
  [1114] = {.lex_state = 1, .external_lex_state = 3},
  [1115] = {.lex_state = 1, .external_lex_state = 3},
  [1116] = {.lex_state = 1, .external_lex_state = 3},
  [1117] = {.lex_state = 1, .external_lex_state = 3},
  [1118] = {.lex_state = 1, .external_lex_state = 3},
  [1119] = {.lex_state = 1, .external_lex_state = 3},
  [1120] = {.lex_state = 1, .external_lex_state = 3},
  [1121] = {.lex_state = 1, .external_lex_state = 3},
  [1122] = {.lex_state = 35, .external_lex_state = 2},
  [1123] = {.lex_state = 35, .external_lex_state = 2},
  [1124] = {.lex_state = 1, .external_lex_state = 3},
  [1125] = {.lex_state = 35, .external_lex_state = 2},
  [1126] = {.lex_state = 35, .external_lex_state = 2},
  [1127] = {.lex_state = 1, .external_lex_state = 3},
  [1128] = {.lex_state = 35, .external_lex_state = 2},
  [1129] = {.lex_state = 1, .external_lex_state = 3},
  [1130] = {.lex_state = 1, .external_lex_state = 3},
  [1131] = {.lex_state = 1, .external_lex_state = 3},
  [1132] = {.lex_state = 1, .external_lex_state = 3},
  [1133] = {.lex_state = 1, .external_lex_state = 3},
  [1134] = {.lex_state = 1, .external_lex_state = 3},
  [1135] = {.lex_state = 1, .external_lex_state = 3},
  [1136] = {.lex_state = 1, .external_lex_state = 3},
  [1137] = {.lex_state = 35, .external_lex_state = 2},
  [1138] = {.lex_state = 1, .external_lex_state = 3},
  [1139] = {.lex_state = 1, .external_lex_state = 3},
  [1140] = {.lex_state = 1, .external_lex_state = 3},
  [1141] = {.lex_state = 1, .external_lex_state = 3},
  [1142] = {.lex_state = 1, .external_lex_state = 3},
  [1143] = {.lex_state = 35, .external_lex_state = 2},
  [1144] = {.lex_state = 35, .external_lex_state = 2},
  [1145] = {.lex_state = 35, .external_lex_state = 2},
  [1146] = {.lex_state = 1, .external_lex_state = 3},
  [1147] = {.lex_state = 1, .external_lex_state = 3},
  [1148] = {.lex_state = 1, .external_lex_state = 3},
  [1149] = {.lex_state = 1, .external_lex_state = 3},
  [1150] = {.lex_state = 35},
  [1151] = {.lex_state = 1, .external_lex_state = 3},
  [1152] = {.lex_state = 1, .external_lex_state = 3},
  [1153] = {.lex_state = 1, .external_lex_state = 3},
  [1154] = {.lex_state = 1, .external_lex_state = 3},
  [1155] = {.lex_state = 1, .external_lex_state = 3},
  [1156] = {.lex_state = 35},
  [1157] = {.lex_state = 1, .external_lex_state = 3},
  [1158] = {.lex_state = 1, .external_lex_state = 3},
  [1159] = {.lex_state = 35},
  [1160] = {.lex_state = 1, .external_lex_state = 3},
  [1161] = {.lex_state = 1, .external_lex_state = 3},
  [1162] = {.lex_state = 1, .external_lex_state = 3},
  [1163] = {.lex_state = 1, .external_lex_state = 3},
  [1164] = {.lex_state = 1, .external_lex_state = 3},
  [1165] = {.lex_state = 1, .external_lex_state = 3},
  [1166] = {.lex_state = 1, .external_lex_state = 3},
  [1167] = {.lex_state = 1, .external_lex_state = 3},
  [1168] = {.lex_state = 1, .external_lex_state = 3},
  [1169] = {.lex_state = 1, .external_lex_state = 3},
  [1170] = {.lex_state = 1, .external_lex_state = 3},
  [1171] = {.lex_state = 1, .external_lex_state = 3},
  [1172] = {.lex_state = 1, .external_lex_state = 3},
  [1173] = {.lex_state = 1, .external_lex_state = 3},
  [1174] = {.lex_state = 1, .external_lex_state = 3},
  [1175] = {.lex_state = 1, .external_lex_state = 3},
  [1176] = {.lex_state = 1, .external_lex_state = 3},
  [1177] = {.lex_state = 1, .external_lex_state = 3},
  [1178] = {.lex_state = 1, .external_lex_state = 3},
  [1179] = {.lex_state = 1, .external_lex_state = 3},
  [1180] = {.lex_state = 1, .external_lex_state = 3},
  [1181] = {.lex_state = 1, .external_lex_state = 3},
  [1182] = {.lex_state = 1, .external_lex_state = 3},
  [1183] = {.lex_state = 1, .external_lex_state = 3},
  [1184] = {.lex_state = 1, .external_lex_state = 3},
  [1185] = {.lex_state = 1, .external_lex_state = 3},
  [1186] = {.lex_state = 1, .external_lex_state = 3},
  [1187] = {.lex_state = 1, .external_lex_state = 3},
  [1188] = {.lex_state = 1, .external_lex_state = 3},
  [1189] = {.lex_state = 1, .external_lex_state = 3},
  [1190] = {.lex_state = 1, .external_lex_state = 3},
  [1191] = {.lex_state = 1, .external_lex_state = 3},
  [1192] = {.lex_state = 1, .external_lex_state = 3},
  [1193] = {.lex_state = 1, .external_lex_state = 3},
  [1194] = {.lex_state = 1, .external_lex_state = 3},
  [1195] = {.lex_state = 1, .external_lex_state = 3},
  [1196] = {.lex_state = 1, .external_lex_state = 3},
  [1197] = {.lex_state = 1, .external_lex_state = 3},
  [1198] = {.lex_state = 1, .external_lex_state = 3},
  [1199] = {.lex_state = 1, .external_lex_state = 3},
  [1200] = {.lex_state = 1, .external_lex_state = 3},
  [1201] = {.lex_state = 1, .external_lex_state = 3},
  [1202] = {.lex_state = 1, .external_lex_state = 3},
  [1203] = {.lex_state = 1, .external_lex_state = 3},
  [1204] = {.lex_state = 1, .external_lex_state = 3},
  [1205] = {.lex_state = 1, .external_lex_state = 3},
  [1206] = {.lex_state = 35, .external_lex_state = 2},
  [1207] = {.lex_state = 1, .external_lex_state = 3},
  [1208] = {.lex_state = 1, .external_lex_state = 3},
  [1209] = {.lex_state = 1, .external_lex_state = 3},
  [1210] = {.lex_state = 1, .external_lex_state = 3},
  [1211] = {.lex_state = 1, .external_lex_state = 3},
  [1212] = {.lex_state = 1, .external_lex_state = 3},
  [1213] = {.lex_state = 1, .external_lex_state = 3},
  [1214] = {.lex_state = 1, .external_lex_state = 3},
  [1215] = {.lex_state = 1, .external_lex_state = 3},
  [1216] = {.lex_state = 1, .external_lex_state = 3},
  [1217] = {.lex_state = 1, .external_lex_state = 3},
  [1218] = {.lex_state = 1, .external_lex_state = 3},
  [1219] = {.lex_state = 1, .external_lex_state = 3},
  [1220] = {.lex_state = 1, .external_lex_state = 3},
  [1221] = {.lex_state = 1, .external_lex_state = 3},
  [1222] = {.lex_state = 1, .external_lex_state = 3},
  [1223] = {.lex_state = 1, .external_lex_state = 3},
  [1224] = {.lex_state = 1, .external_lex_state = 3},
  [1225] = {.lex_state = 1, .external_lex_state = 3},
  [1226] = {.lex_state = 1, .external_lex_state = 3},
  [1227] = {.lex_state = 1, .external_lex_state = 3},
  [1228] = {.lex_state = 1, .external_lex_state = 3},
  [1229] = {.lex_state = 1, .external_lex_state = 3},
  [1230] = {.lex_state = 1, .external_lex_state = 3},
  [1231] = {.lex_state = 1, .external_lex_state = 3},
  [1232] = {.lex_state = 1, .external_lex_state = 3},
  [1233] = {.lex_state = 1, .external_lex_state = 3},
  [1234] = {.lex_state = 1, .external_lex_state = 3},
  [1235] = {.lex_state = 1, .external_lex_state = 3},
  [1236] = {.lex_state = 1, .external_lex_state = 3},
  [1237] = {.lex_state = 1, .external_lex_state = 3},
  [1238] = {.lex_state = 1, .external_lex_state = 3},
  [1239] = {.lex_state = 35, .external_lex_state = 2},
  [1240] = {.lex_state = 1, .external_lex_state = 3},
  [1241] = {.lex_state = 1, .external_lex_state = 3},
  [1242] = {.lex_state = 35, .external_lex_state = 2},
  [1243] = {.lex_state = 35, .external_lex_state = 2},
  [1244] = {.lex_state = 1, .external_lex_state = 3},
  [1245] = {.lex_state = 1, .external_lex_state = 3},
  [1246] = {.lex_state = 1, .external_lex_state = 3},
  [1247] = {.lex_state = 1, .external_lex_state = 3},
  [1248] = {.lex_state = 1, .external_lex_state = 3},
  [1249] = {.lex_state = 1, .external_lex_state = 3},
  [1250] = {.lex_state = 1, .external_lex_state = 3},
  [1251] = {.lex_state = 1, .external_lex_state = 3},
  [1252] = {.lex_state = 1, .external_lex_state = 3},
  [1253] = {.lex_state = 1, .external_lex_state = 3},
  [1254] = {.lex_state = 1, .external_lex_state = 3},
  [1255] = {.lex_state = 1, .external_lex_state = 3},
  [1256] = {.lex_state = 1, .external_lex_state = 3},
  [1257] = {.lex_state = 1, .external_lex_state = 3},
  [1258] = {.lex_state = 1, .external_lex_state = 3},
  [1259] = {.lex_state = 1, .external_lex_state = 3},
  [1260] = {.lex_state = 1, .external_lex_state = 3},
  [1261] = {.lex_state = 1, .external_lex_state = 3},
  [1262] = {.lex_state = 1, .external_lex_state = 3},
  [1263] = {.lex_state = 1, .external_lex_state = 3},
  [1264] = {.lex_state = 1, .external_lex_state = 3},
  [1265] = {.lex_state = 1, .external_lex_state = 3},
  [1266] = {.lex_state = 1, .external_lex_state = 3},
  [1267] = {.lex_state = 1, .external_lex_state = 3},
  [1268] = {.lex_state = 1, .external_lex_state = 3},
  [1269] = {.lex_state = 33, .external_lex_state = 2},
  [1270] = {.lex_state = 35, .external_lex_state = 2},
  [1271] = {.lex_state = 1, .external_lex_state = 3},
  [1272] = {.lex_state = 35, .external_lex_state = 2},
  [1273] = {.lex_state = 1, .external_lex_state = 3},
  [1274] = {.lex_state = 1, .external_lex_state = 3},
  [1275] = {.lex_state = 1, .external_lex_state = 3},
  [1276] = {.lex_state = 1, .external_lex_state = 3},
  [1277] = {.lex_state = 1, .external_lex_state = 3},
  [1278] = {.lex_state = 1, .external_lex_state = 3},
  [1279] = {.lex_state = 35, .external_lex_state = 2},
  [1280] = {.lex_state = 1, .external_lex_state = 3},
  [1281] = {.lex_state = 35, .external_lex_state = 2},
  [1282] = {.lex_state = 35, .external_lex_state = 2},
  [1283] = {.lex_state = 1, .external_lex_state = 3},
  [1284] = {.lex_state = 1, .external_lex_state = 3},
  [1285] = {.lex_state = 1, .external_lex_state = 3},
  [1286] = {.lex_state = 1, .external_lex_state = 3},
  [1287] = {.lex_state = 1, .external_lex_state = 3},
  [1288] = {.lex_state = 33},
  [1289] = {.lex_state = 1, .external_lex_state = 3},
  [1290] = {.lex_state = 1, .external_lex_state = 3},
  [1291] = {.lex_state = 1, .external_lex_state = 3},
  [1292] = {.lex_state = 1, .external_lex_state = 3},
  [1293] = {.lex_state = 1, .external_lex_state = 3},
  [1294] = {.lex_state = 1, .external_lex_state = 3},
  [1295] = {.lex_state = 1, .external_lex_state = 3},
  [1296] = {.lex_state = 1, .external_lex_state = 3},
  [1297] = {.lex_state = 1, .external_lex_state = 3},
  [1298] = {.lex_state = 1, .external_lex_state = 3},
  [1299] = {.lex_state = 1, .external_lex_state = 3},
  [1300] = {.lex_state = 1, .external_lex_state = 3},
  [1301] = {.lex_state = 1, .external_lex_state = 3},
  [1302] = {.lex_state = 1, .external_lex_state = 3},
  [1303] = {.lex_state = 1, .external_lex_state = 3},
  [1304] = {.lex_state = 1, .external_lex_state = 3},
  [1305] = {.lex_state = 1, .external_lex_state = 3},
  [1306] = {.lex_state = 1, .external_lex_state = 3},
  [1307] = {.lex_state = 1, .external_lex_state = 3},
  [1308] = {.lex_state = 1, .external_lex_state = 3},
  [1309] = {.lex_state = 1, .external_lex_state = 3},
  [1310] = {.lex_state = 1, .external_lex_state = 3},
  [1311] = {.lex_state = 1, .external_lex_state = 3},
  [1312] = {.lex_state = 35},
  [1313] = {.lex_state = 1, .external_lex_state = 3},
  [1314] = {.lex_state = 1, .external_lex_state = 3},
  [1315] = {.lex_state = 1, .external_lex_state = 3},
  [1316] = {.lex_state = 1, .external_lex_state = 3},
  [1317] = {.lex_state = 1, .external_lex_state = 3},
  [1318] = {.lex_state = 1, .external_lex_state = 3},
  [1319] = {.lex_state = 1, .external_lex_state = 3},
  [1320] = {.lex_state = 1, .external_lex_state = 3},
  [1321] = {.lex_state = 1, .external_lex_state = 3},
  [1322] = {.lex_state = 1, .external_lex_state = 3},
  [1323] = {.lex_state = 1, .external_lex_state = 3},
  [1324] = {.lex_state = 1, .external_lex_state = 3},
  [1325] = {.lex_state = 1, .external_lex_state = 3},
  [1326] = {.lex_state = 35},
  [1327] = {.lex_state = 35},
  [1328] = {.lex_state = 35},
  [1329] = {.lex_state = 1, .external_lex_state = 3},
  [1330] = {.lex_state = 35},
  [1331] = {.lex_state = 1, .external_lex_state = 3},
  [1332] = {.lex_state = 1, .external_lex_state = 3},
  [1333] = {.lex_state = 35},
  [1334] = {.lex_state = 1, .external_lex_state = 3},
  [1335] = {.lex_state = 1, .external_lex_state = 3},
  [1336] = {.lex_state = 35},
  [1337] = {.lex_state = 1, .external_lex_state = 3},
  [1338] = {.lex_state = 35, .external_lex_state = 2},
  [1339] = {.lex_state = 1, .external_lex_state = 3},
  [1340] = {.lex_state = 35, .external_lex_state = 2},
  [1341] = {.lex_state = 35, .external_lex_state = 2},
  [1342] = {.lex_state = 1, .external_lex_state = 3},
  [1343] = {.lex_state = 1, .external_lex_state = 3},
  [1344] = {.lex_state = 1, .external_lex_state = 3},
  [1345] = {.lex_state = 1, .external_lex_state = 3},
  [1346] = {.lex_state = 1, .external_lex_state = 3},
  [1347] = {.lex_state = 1, .external_lex_state = 3},
  [1348] = {.lex_state = 1, .external_lex_state = 3},
  [1349] = {.lex_state = 35, .external_lex_state = 2},
  [1350] = {.lex_state = 1, .external_lex_state = 3},
  [1351] = {.lex_state = 1, .external_lex_state = 3},
  [1352] = {.lex_state = 1, .external_lex_state = 3},
  [1353] = {.lex_state = 1, .external_lex_state = 3},
  [1354] = {.lex_state = 1, .external_lex_state = 3},
  [1355] = {.lex_state = 1, .external_lex_state = 3},
  [1356] = {.lex_state = 35, .external_lex_state = 2},
  [1357] = {.lex_state = 1, .external_lex_state = 3},
  [1358] = {.lex_state = 1, .external_lex_state = 3},
  [1359] = {.lex_state = 1, .external_lex_state = 3},
  [1360] = {.lex_state = 1, .external_lex_state = 3},
  [1361] = {.lex_state = 1, .external_lex_state = 3},
  [1362] = {.lex_state = 1, .external_lex_state = 3},
  [1363] = {.lex_state = 1, .external_lex_state = 3},
  [1364] = {.lex_state = 1, .external_lex_state = 3},
  [1365] = {.lex_state = 1, .external_lex_state = 3},
  [1366] = {.lex_state = 1, .external_lex_state = 3},
  [1367] = {.lex_state = 1, .external_lex_state = 3},
  [1368] = {.lex_state = 1, .external_lex_state = 3},
  [1369] = {.lex_state = 1, .external_lex_state = 3},
  [1370] = {.lex_state = 1, .external_lex_state = 3},
  [1371] = {.lex_state = 1, .external_lex_state = 3},
  [1372] = {.lex_state = 1, .external_lex_state = 3},
  [1373] = {.lex_state = 1, .external_lex_state = 3},
  [1374] = {.lex_state = 1, .external_lex_state = 3},
  [1375] = {.lex_state = 35},
  [1376] = {.lex_state = 1, .external_lex_state = 3},
  [1377] = {.lex_state = 1, .external_lex_state = 3},
  [1378] = {.lex_state = 1, .external_lex_state = 3},
  [1379] = {.lex_state = 1, .external_lex_state = 3},
  [1380] = {.lex_state = 1, .external_lex_state = 3},
  [1381] = {.lex_state = 1, .external_lex_state = 3},
  [1382] = {.lex_state = 1, .external_lex_state = 3},
  [1383] = {.lex_state = 35},
  [1384] = {.lex_state = 1, .external_lex_state = 3},
  [1385] = {.lex_state = 1, .external_lex_state = 3},
  [1386] = {.lex_state = 1, .external_lex_state = 3},
  [1387] = {.lex_state = 35},
  [1388] = {.lex_state = 1, .external_lex_state = 3},
  [1389] = {.lex_state = 1, .external_lex_state = 3},
  [1390] = {.lex_state = 1, .external_lex_state = 3},
  [1391] = {.lex_state = 35},
  [1392] = {.lex_state = 1, .external_lex_state = 3},
  [1393] = {.lex_state = 1, .external_lex_state = 3},
  [1394] = {.lex_state = 35},
  [1395] = {.lex_state = 35},
  [1396] = {.lex_state = 1, .external_lex_state = 3},
  [1397] = {.lex_state = 1, .external_lex_state = 3},
  [1398] = {.lex_state = 1, .external_lex_state = 3},
  [1399] = {.lex_state = 35, .external_lex_state = 2},
  [1400] = {.lex_state = 1, .external_lex_state = 3},
  [1401] = {.lex_state = 35},
  [1402] = {.lex_state = 35, .external_lex_state = 2},
  [1403] = {.lex_state = 1, .external_lex_state = 3},
  [1404] = {.lex_state = 1, .external_lex_state = 3},
  [1405] = {.lex_state = 1, .external_lex_state = 3},
  [1406] = {.lex_state = 1, .external_lex_state = 3},
  [1407] = {.lex_state = 1, .external_lex_state = 3},
  [1408] = {.lex_state = 1, .external_lex_state = 3},
  [1409] = {.lex_state = 1, .external_lex_state = 3},
  [1410] = {.lex_state = 1, .external_lex_state = 3},
  [1411] = {.lex_state = 1, .external_lex_state = 3},
  [1412] = {.lex_state = 1, .external_lex_state = 3},
  [1413] = {.lex_state = 1, .external_lex_state = 3},
  [1414] = {.lex_state = 1, .external_lex_state = 3},
  [1415] = {.lex_state = 1, .external_lex_state = 3},
  [1416] = {.lex_state = 1, .external_lex_state = 3},
  [1417] = {.lex_state = 1, .external_lex_state = 3},
  [1418] = {.lex_state = 1, .external_lex_state = 3},
  [1419] = {.lex_state = 1, .external_lex_state = 3},
  [1420] = {.lex_state = 1, .external_lex_state = 3},
  [1421] = {.lex_state = 1, .external_lex_state = 3},
  [1422] = {.lex_state = 1, .external_lex_state = 3},
  [1423] = {.lex_state = 1, .external_lex_state = 3},
  [1424] = {.lex_state = 35, .external_lex_state = 2},
  [1425] = {.lex_state = 1, .external_lex_state = 3},
  [1426] = {.lex_state = 1, .external_lex_state = 3},
  [1427] = {.lex_state = 1, .external_lex_state = 3},
  [1428] = {.lex_state = 1, .external_lex_state = 3},
  [1429] = {.lex_state = 1, .external_lex_state = 3},
  [1430] = {.lex_state = 1, .external_lex_state = 3},
  [1431] = {.lex_state = 1, .external_lex_state = 3},
  [1432] = {.lex_state = 1, .external_lex_state = 3},
  [1433] = {.lex_state = 1, .external_lex_state = 3},
  [1434] = {.lex_state = 1, .external_lex_state = 3},
  [1435] = {.lex_state = 1, .external_lex_state = 3},
  [1436] = {.lex_state = 1, .external_lex_state = 3},
  [1437] = {.lex_state = 1, .external_lex_state = 3},
  [1438] = {.lex_state = 1, .external_lex_state = 3},
  [1439] = {.lex_state = 1, .external_lex_state = 3},
  [1440] = {.lex_state = 1, .external_lex_state = 3},
  [1441] = {.lex_state = 1, .external_lex_state = 3},
  [1442] = {.lex_state = 1, .external_lex_state = 3},
  [1443] = {.lex_state = 1, .external_lex_state = 3},
  [1444] = {.lex_state = 1, .external_lex_state = 3},
  [1445] = {.lex_state = 1, .external_lex_state = 3},
  [1446] = {.lex_state = 35, .external_lex_state = 2},
  [1447] = {.lex_state = 1, .external_lex_state = 3},
  [1448] = {.lex_state = 1, .external_lex_state = 3},
  [1449] = {.lex_state = 1, .external_lex_state = 3},
  [1450] = {.lex_state = 1, .external_lex_state = 3},
  [1451] = {.lex_state = 1, .external_lex_state = 3},
  [1452] = {.lex_state = 1, .external_lex_state = 3},
  [1453] = {.lex_state = 1, .external_lex_state = 3},
  [1454] = {.lex_state = 1, .external_lex_state = 3},
  [1455] = {.lex_state = 1, .external_lex_state = 3},
  [1456] = {.lex_state = 1, .external_lex_state = 3},
  [1457] = {.lex_state = 1, .external_lex_state = 3},
  [1458] = {.lex_state = 1, .external_lex_state = 3},
  [1459] = {.lex_state = 1, .external_lex_state = 3},
  [1460] = {.lex_state = 1, .external_lex_state = 3},
  [1461] = {.lex_state = 1, .external_lex_state = 3},
  [1462] = {.lex_state = 1, .external_lex_state = 3},
  [1463] = {.lex_state = 1, .external_lex_state = 3},
  [1464] = {.lex_state = 1, .external_lex_state = 3},
  [1465] = {.lex_state = 1, .external_lex_state = 3},
  [1466] = {.lex_state = 1, .external_lex_state = 3},
  [1467] = {.lex_state = 1, .external_lex_state = 3},
  [1468] = {.lex_state = 1, .external_lex_state = 3},
  [1469] = {.lex_state = 1, .external_lex_state = 3},
  [1470] = {.lex_state = 1, .external_lex_state = 3},
  [1471] = {.lex_state = 1, .external_lex_state = 3},
  [1472] = {.lex_state = 1, .external_lex_state = 3},
  [1473] = {.lex_state = 1, .external_lex_state = 3},
  [1474] = {.lex_state = 1, .external_lex_state = 3},
  [1475] = {.lex_state = 1, .external_lex_state = 3},
  [1476] = {.lex_state = 1, .external_lex_state = 3},
  [1477] = {.lex_state = 1, .external_lex_state = 3},
  [1478] = {.lex_state = 1, .external_lex_state = 3},
  [1479] = {.lex_state = 1, .external_lex_state = 3},
  [1480] = {.lex_state = 1, .external_lex_state = 3},
  [1481] = {.lex_state = 1, .external_lex_state = 3},
  [1482] = {.lex_state = 1, .external_lex_state = 3},
  [1483] = {.lex_state = 1, .external_lex_state = 3},
  [1484] = {.lex_state = 1, .external_lex_state = 3},
  [1485] = {.lex_state = 1, .external_lex_state = 3},
  [1486] = {.lex_state = 1, .external_lex_state = 3},
  [1487] = {.lex_state = 1, .external_lex_state = 3},
  [1488] = {.lex_state = 1, .external_lex_state = 3},
  [1489] = {.lex_state = 1, .external_lex_state = 3},
  [1490] = {.lex_state = 1, .external_lex_state = 3},
  [1491] = {.lex_state = 1, .external_lex_state = 3},
  [1492] = {.lex_state = 1, .external_lex_state = 3},
  [1493] = {.lex_state = 1, .external_lex_state = 3},
  [1494] = {.lex_state = 1, .external_lex_state = 3},
  [1495] = {.lex_state = 1, .external_lex_state = 3},
  [1496] = {.lex_state = 1, .external_lex_state = 3},
  [1497] = {.lex_state = 1, .external_lex_state = 3},
  [1498] = {.lex_state = 1, .external_lex_state = 3},
  [1499] = {.lex_state = 1, .external_lex_state = 3},
  [1500] = {.lex_state = 1, .external_lex_state = 3},
  [1501] = {.lex_state = 1, .external_lex_state = 3},
  [1502] = {.lex_state = 1, .external_lex_state = 3},
  [1503] = {.lex_state = 1, .external_lex_state = 3},
  [1504] = {.lex_state = 1, .external_lex_state = 3},
  [1505] = {.lex_state = 1, .external_lex_state = 3},
  [1506] = {.lex_state = 1, .external_lex_state = 3},
  [1507] = {.lex_state = 1, .external_lex_state = 3},
  [1508] = {.lex_state = 1, .external_lex_state = 3},
  [1509] = {.lex_state = 1, .external_lex_state = 3},
  [1510] = {.lex_state = 1, .external_lex_state = 3},
  [1511] = {.lex_state = 1, .external_lex_state = 3},
  [1512] = {.lex_state = 1, .external_lex_state = 3},
  [1513] = {.lex_state = 1, .external_lex_state = 3},
  [1514] = {.lex_state = 1, .external_lex_state = 3},
  [1515] = {.lex_state = 1, .external_lex_state = 3},
  [1516] = {.lex_state = 1, .external_lex_state = 3},
  [1517] = {.lex_state = 1, .external_lex_state = 3},
  [1518] = {.lex_state = 1, .external_lex_state = 3},
  [1519] = {.lex_state = 1, .external_lex_state = 3},
  [1520] = {.lex_state = 1, .external_lex_state = 3},
  [1521] = {.lex_state = 1, .external_lex_state = 3},
  [1522] = {.lex_state = 1, .external_lex_state = 3},
  [1523] = {.lex_state = 1, .external_lex_state = 3},
  [1524] = {.lex_state = 1, .external_lex_state = 3},
  [1525] = {.lex_state = 1, .external_lex_state = 3},
  [1526] = {.lex_state = 1, .external_lex_state = 3},
  [1527] = {.lex_state = 1, .external_lex_state = 3},
  [1528] = {.lex_state = 1, .external_lex_state = 3},
  [1529] = {.lex_state = 1, .external_lex_state = 3},
  [1530] = {.lex_state = 1, .external_lex_state = 3},
  [1531] = {.lex_state = 1, .external_lex_state = 3},
  [1532] = {.lex_state = 1, .external_lex_state = 3},
  [1533] = {.lex_state = 35, .external_lex_state = 2},
  [1534] = {.lex_state = 1, .external_lex_state = 3},
  [1535] = {.lex_state = 1, .external_lex_state = 3},
  [1536] = {.lex_state = 1, .external_lex_state = 3},
  [1537] = {.lex_state = 1, .external_lex_state = 3},
  [1538] = {.lex_state = 1, .external_lex_state = 3},
  [1539] = {.lex_state = 1, .external_lex_state = 3},
  [1540] = {.lex_state = 1, .external_lex_state = 3},
  [1541] = {.lex_state = 1, .external_lex_state = 3},
  [1542] = {.lex_state = 1, .external_lex_state = 3},
  [1543] = {.lex_state = 1, .external_lex_state = 3},
  [1544] = {.lex_state = 1, .external_lex_state = 3},
  [1545] = {.lex_state = 1, .external_lex_state = 3},
  [1546] = {.lex_state = 1, .external_lex_state = 3},
  [1547] = {.lex_state = 1, .external_lex_state = 3},
  [1548] = {.lex_state = 1, .external_lex_state = 3},
  [1549] = {.lex_state = 1, .external_lex_state = 3},
  [1550] = {.lex_state = 1, .external_lex_state = 3},
  [1551] = {.lex_state = 36},
  [1552] = {.lex_state = 1, .external_lex_state = 3},
  [1553] = {.lex_state = 1, .external_lex_state = 3},
  [1554] = {.lex_state = 1, .external_lex_state = 3},
  [1555] = {.lex_state = 1, .external_lex_state = 3},
  [1556] = {.lex_state = 1, .external_lex_state = 3},
  [1557] = {.lex_state = 1, .external_lex_state = 3},
  [1558] = {.lex_state = 1, .external_lex_state = 3},
  [1559] = {.lex_state = 1, .external_lex_state = 3},
  [1560] = {.lex_state = 1, .external_lex_state = 3},
  [1561] = {.lex_state = 1, .external_lex_state = 3},
  [1562] = {.lex_state = 1, .external_lex_state = 3},
  [1563] = {.lex_state = 1, .external_lex_state = 3},
  [1564] = {.lex_state = 1, .external_lex_state = 3},
  [1565] = {.lex_state = 1, .external_lex_state = 3},
  [1566] = {.lex_state = 1, .external_lex_state = 3},
  [1567] = {.lex_state = 1, .external_lex_state = 3},
  [1568] = {.lex_state = 1, .external_lex_state = 3},
  [1569] = {.lex_state = 1, .external_lex_state = 3},
  [1570] = {.lex_state = 1, .external_lex_state = 3},
  [1571] = {.lex_state = 1, .external_lex_state = 3},
  [1572] = {.lex_state = 1, .external_lex_state = 3},
  [1573] = {.lex_state = 1, .external_lex_state = 3},
  [1574] = {.lex_state = 1, .external_lex_state = 3},
  [1575] = {.lex_state = 1, .external_lex_state = 3},
  [1576] = {.lex_state = 1, .external_lex_state = 3},
  [1577] = {.lex_state = 1, .external_lex_state = 3},
  [1578] = {.lex_state = 1, .external_lex_state = 3},
  [1579] = {.lex_state = 1, .external_lex_state = 3},
  [1580] = {.lex_state = 1, .external_lex_state = 3},
  [1581] = {.lex_state = 1, .external_lex_state = 3},
  [1582] = {.lex_state = 1, .external_lex_state = 3},
  [1583] = {.lex_state = 1, .external_lex_state = 3},
  [1584] = {.lex_state = 1, .external_lex_state = 3},
  [1585] = {.lex_state = 1, .external_lex_state = 3},
  [1586] = {.lex_state = 1, .external_lex_state = 3},
  [1587] = {.lex_state = 1, .external_lex_state = 3},
  [1588] = {.lex_state = 1, .external_lex_state = 3},
  [1589] = {.lex_state = 1, .external_lex_state = 3},
  [1590] = {.lex_state = 1, .external_lex_state = 3},
  [1591] = {.lex_state = 1, .external_lex_state = 3},
  [1592] = {.lex_state = 1, .external_lex_state = 3},
  [1593] = {.lex_state = 1, .external_lex_state = 3},
  [1594] = {.lex_state = 1, .external_lex_state = 3},
  [1595] = {.lex_state = 1, .external_lex_state = 3},
  [1596] = {.lex_state = 1, .external_lex_state = 3},
  [1597] = {.lex_state = 1, .external_lex_state = 3},
  [1598] = {.lex_state = 1, .external_lex_state = 3},
  [1599] = {.lex_state = 1, .external_lex_state = 3},
  [1600] = {.lex_state = 1, .external_lex_state = 3},
  [1601] = {.lex_state = 1, .external_lex_state = 3},
  [1602] = {.lex_state = 1, .external_lex_state = 3},
  [1603] = {.lex_state = 1, .external_lex_state = 3},
  [1604] = {.lex_state = 1, .external_lex_state = 3},
  [1605] = {.lex_state = 1, .external_lex_state = 3},
  [1606] = {.lex_state = 1, .external_lex_state = 3},
  [1607] = {.lex_state = 1, .external_lex_state = 3},
  [1608] = {.lex_state = 1, .external_lex_state = 3},
  [1609] = {.lex_state = 1, .external_lex_state = 3},
  [1610] = {.lex_state = 1, .external_lex_state = 3},
  [1611] = {.lex_state = 1, .external_lex_state = 3},
  [1612] = {.lex_state = 1, .external_lex_state = 3},
  [1613] = {.lex_state = 1, .external_lex_state = 3},
  [1614] = {.lex_state = 1, .external_lex_state = 3},
  [1615] = {.lex_state = 1, .external_lex_state = 3},
  [1616] = {.lex_state = 1, .external_lex_state = 3},
  [1617] = {.lex_state = 1, .external_lex_state = 3},
  [1618] = {.lex_state = 1, .external_lex_state = 3},
  [1619] = {.lex_state = 1, .external_lex_state = 3},
  [1620] = {.lex_state = 1, .external_lex_state = 3},
  [1621] = {.lex_state = 1, .external_lex_state = 3},
  [1622] = {.lex_state = 1, .external_lex_state = 3},
  [1623] = {.lex_state = 1, .external_lex_state = 3},
  [1624] = {.lex_state = 1, .external_lex_state = 3},
  [1625] = {.lex_state = 1, .external_lex_state = 3},
  [1626] = {.lex_state = 1, .external_lex_state = 3},
  [1627] = {.lex_state = 1, .external_lex_state = 3},
  [1628] = {.lex_state = 1, .external_lex_state = 3},
  [1629] = {.lex_state = 1, .external_lex_state = 3},
  [1630] = {.lex_state = 1, .external_lex_state = 3},
  [1631] = {.lex_state = 1, .external_lex_state = 3},
  [1632] = {.lex_state = 1, .external_lex_state = 3},
  [1633] = {.lex_state = 1, .external_lex_state = 3},
  [1634] = {.lex_state = 1, .external_lex_state = 3},
  [1635] = {.lex_state = 1, .external_lex_state = 3},
  [1636] = {.lex_state = 1, .external_lex_state = 3},
  [1637] = {.lex_state = 1, .external_lex_state = 3},
  [1638] = {.lex_state = 1, .external_lex_state = 3},
  [1639] = {.lex_state = 1, .external_lex_state = 3},
  [1640] = {.lex_state = 1, .external_lex_state = 3},
  [1641] = {.lex_state = 1, .external_lex_state = 3},
  [1642] = {.lex_state = 1, .external_lex_state = 3},
  [1643] = {.lex_state = 1, .external_lex_state = 3},
  [1644] = {.lex_state = 1, .external_lex_state = 3},
  [1645] = {.lex_state = 1, .external_lex_state = 3},
  [1646] = {.lex_state = 1, .external_lex_state = 3},
  [1647] = {.lex_state = 1, .external_lex_state = 3},
  [1648] = {.lex_state = 1, .external_lex_state = 3},
  [1649] = {.lex_state = 1, .external_lex_state = 3},
  [1650] = {.lex_state = 1, .external_lex_state = 3},
  [1651] = {.lex_state = 1, .external_lex_state = 3},
  [1652] = {.lex_state = 1, .external_lex_state = 3},
  [1653] = {.lex_state = 1, .external_lex_state = 3},
  [1654] = {.lex_state = 1, .external_lex_state = 3},
  [1655] = {.lex_state = 1, .external_lex_state = 3},
  [1656] = {.lex_state = 1, .external_lex_state = 3},
  [1657] = {.lex_state = 1, .external_lex_state = 3},
  [1658] = {.lex_state = 1, .external_lex_state = 3},
  [1659] = {.lex_state = 1, .external_lex_state = 3},
  [1660] = {.lex_state = 1, .external_lex_state = 3},
  [1661] = {.lex_state = 1, .external_lex_state = 3},
  [1662] = {.lex_state = 1, .external_lex_state = 3},
  [1663] = {.lex_state = 1, .external_lex_state = 3},
  [1664] = {.lex_state = 1, .external_lex_state = 3},
  [1665] = {.lex_state = 1, .external_lex_state = 3},
  [1666] = {.lex_state = 1, .external_lex_state = 3},
  [1667] = {.lex_state = 1, .external_lex_state = 3},
  [1668] = {.lex_state = 1, .external_lex_state = 3},
  [1669] = {.lex_state = 1, .external_lex_state = 3},
  [1670] = {.lex_state = 1, .external_lex_state = 3},
  [1671] = {.lex_state = 1, .external_lex_state = 3},
  [1672] = {.lex_state = 1, .external_lex_state = 3},
  [1673] = {.lex_state = 1, .external_lex_state = 3},
  [1674] = {.lex_state = 1, .external_lex_state = 3},
  [1675] = {.lex_state = 1, .external_lex_state = 3},
  [1676] = {.lex_state = 1, .external_lex_state = 3},
  [1677] = {.lex_state = 1, .external_lex_state = 3},
  [1678] = {.lex_state = 1, .external_lex_state = 3},
  [1679] = {.lex_state = 1, .external_lex_state = 3},
  [1680] = {.lex_state = 1, .external_lex_state = 3},
  [1681] = {.lex_state = 1, .external_lex_state = 3},
  [1682] = {.lex_state = 1, .external_lex_state = 3},
  [1683] = {.lex_state = 1, .external_lex_state = 3},
  [1684] = {.lex_state = 1, .external_lex_state = 3},
  [1685] = {.lex_state = 1, .external_lex_state = 3},
  [1686] = {.lex_state = 1, .external_lex_state = 3},
  [1687] = {.lex_state = 1, .external_lex_state = 3},
  [1688] = {.lex_state = 1, .external_lex_state = 3},
  [1689] = {.lex_state = 1, .external_lex_state = 3},
  [1690] = {.lex_state = 1, .external_lex_state = 3},
  [1691] = {.lex_state = 1, .external_lex_state = 3},
  [1692] = {.lex_state = 1, .external_lex_state = 3},
  [1693] = {.lex_state = 1, .external_lex_state = 3},
  [1694] = {.lex_state = 1, .external_lex_state = 3},
  [1695] = {.lex_state = 1, .external_lex_state = 3},
  [1696] = {.lex_state = 1, .external_lex_state = 3},
  [1697] = {.lex_state = 1, .external_lex_state = 3},
  [1698] = {.lex_state = 1, .external_lex_state = 3},
  [1699] = {.lex_state = 1, .external_lex_state = 3},
  [1700] = {.lex_state = 1, .external_lex_state = 3},
  [1701] = {.lex_state = 1, .external_lex_state = 3},
  [1702] = {.lex_state = 1, .external_lex_state = 3},
  [1703] = {.lex_state = 1, .external_lex_state = 3},
  [1704] = {.lex_state = 1, .external_lex_state = 3},
  [1705] = {.lex_state = 1, .external_lex_state = 3},
  [1706] = {.lex_state = 1, .external_lex_state = 3},
  [1707] = {.lex_state = 1, .external_lex_state = 3},
  [1708] = {.lex_state = 1, .external_lex_state = 3},
  [1709] = {.lex_state = 1, .external_lex_state = 3},
  [1710] = {.lex_state = 1, .external_lex_state = 3},
  [1711] = {.lex_state = 1, .external_lex_state = 3},
  [1712] = {.lex_state = 1, .external_lex_state = 3},
  [1713] = {.lex_state = 1, .external_lex_state = 3},
  [1714] = {.lex_state = 1, .external_lex_state = 3},
  [1715] = {.lex_state = 1, .external_lex_state = 3},
  [1716] = {.lex_state = 1, .external_lex_state = 3},
  [1717] = {.lex_state = 1, .external_lex_state = 3},
  [1718] = {.lex_state = 1, .external_lex_state = 3},
  [1719] = {.lex_state = 1, .external_lex_state = 3},
  [1720] = {.lex_state = 1, .external_lex_state = 3},
  [1721] = {.lex_state = 1, .external_lex_state = 3},
  [1722] = {.lex_state = 1, .external_lex_state = 3},
  [1723] = {.lex_state = 1, .external_lex_state = 3},
  [1724] = {.lex_state = 1, .external_lex_state = 3},
  [1725] = {.lex_state = 1, .external_lex_state = 3},
  [1726] = {.lex_state = 1, .external_lex_state = 3},
  [1727] = {.lex_state = 1, .external_lex_state = 3},
  [1728] = {.lex_state = 1, .external_lex_state = 3},
  [1729] = {.lex_state = 1, .external_lex_state = 3},
  [1730] = {.lex_state = 1, .external_lex_state = 3},
  [1731] = {.lex_state = 1, .external_lex_state = 3},
  [1732] = {.lex_state = 1, .external_lex_state = 3},
  [1733] = {.lex_state = 1, .external_lex_state = 3},
  [1734] = {.lex_state = 1, .external_lex_state = 3},
  [1735] = {.lex_state = 1, .external_lex_state = 3},
  [1736] = {.lex_state = 1, .external_lex_state = 3},
  [1737] = {.lex_state = 1, .external_lex_state = 3},
  [1738] = {.lex_state = 1, .external_lex_state = 3},
  [1739] = {.lex_state = 1, .external_lex_state = 3},
  [1740] = {.lex_state = 1, .external_lex_state = 3},
  [1741] = {.lex_state = 1, .external_lex_state = 3},
  [1742] = {.lex_state = 1, .external_lex_state = 3},
  [1743] = {.lex_state = 1, .external_lex_state = 3},
  [1744] = {.lex_state = 1, .external_lex_state = 3},
  [1745] = {.lex_state = 1, .external_lex_state = 3},
  [1746] = {.lex_state = 1, .external_lex_state = 3},
  [1747] = {.lex_state = 1, .external_lex_state = 3},
  [1748] = {.lex_state = 1, .external_lex_state = 3},
  [1749] = {.lex_state = 1, .external_lex_state = 3},
  [1750] = {.lex_state = 1, .external_lex_state = 3},
  [1751] = {.lex_state = 1, .external_lex_state = 3},
  [1752] = {.lex_state = 1, .external_lex_state = 3},
  [1753] = {.lex_state = 1, .external_lex_state = 3},
  [1754] = {.lex_state = 1, .external_lex_state = 3},
  [1755] = {.lex_state = 1, .external_lex_state = 3},
  [1756] = {.lex_state = 1, .external_lex_state = 3},
  [1757] = {.lex_state = 1, .external_lex_state = 3},
  [1758] = {.lex_state = 1, .external_lex_state = 3},
  [1759] = {.lex_state = 1, .external_lex_state = 3},
  [1760] = {.lex_state = 1, .external_lex_state = 3},
  [1761] = {.lex_state = 1, .external_lex_state = 3},
  [1762] = {.lex_state = 1, .external_lex_state = 3},
  [1763] = {.lex_state = 1, .external_lex_state = 3},
  [1764] = {.lex_state = 1, .external_lex_state = 3},
  [1765] = {.lex_state = 1, .external_lex_state = 3},
  [1766] = {.lex_state = 1, .external_lex_state = 3},
  [1767] = {.lex_state = 1, .external_lex_state = 3},
  [1768] = {.lex_state = 1, .external_lex_state = 3},
  [1769] = {.lex_state = 1, .external_lex_state = 3},
  [1770] = {.lex_state = 1, .external_lex_state = 3},
  [1771] = {.lex_state = 1, .external_lex_state = 3},
  [1772] = {.lex_state = 1, .external_lex_state = 3},
  [1773] = {.lex_state = 1, .external_lex_state = 3},
  [1774] = {.lex_state = 1, .external_lex_state = 3},
  [1775] = {.lex_state = 1, .external_lex_state = 3},
  [1776] = {.lex_state = 1, .external_lex_state = 3},
  [1777] = {.lex_state = 1, .external_lex_state = 3},
  [1778] = {.lex_state = 1, .external_lex_state = 3},
  [1779] = {.lex_state = 1, .external_lex_state = 3},
  [1780] = {.lex_state = 1, .external_lex_state = 3},
  [1781] = {.lex_state = 1, .external_lex_state = 3},
  [1782] = {.lex_state = 1, .external_lex_state = 3},
  [1783] = {.lex_state = 1, .external_lex_state = 3},
  [1784] = {.lex_state = 1, .external_lex_state = 3},
  [1785] = {.lex_state = 1, .external_lex_state = 3},
  [1786] = {.lex_state = 1, .external_lex_state = 3},
  [1787] = {.lex_state = 1, .external_lex_state = 3},
  [1788] = {.lex_state = 1, .external_lex_state = 3},
  [1789] = {.lex_state = 1, .external_lex_state = 3},
  [1790] = {.lex_state = 1, .external_lex_state = 3},
  [1791] = {.lex_state = 1, .external_lex_state = 3},
  [1792] = {.lex_state = 1, .external_lex_state = 3},
  [1793] = {.lex_state = 1, .external_lex_state = 3},
  [1794] = {.lex_state = 1, .external_lex_state = 3},
  [1795] = {.lex_state = 1, .external_lex_state = 3},
  [1796] = {.lex_state = 1, .external_lex_state = 3},
  [1797] = {.lex_state = 1, .external_lex_state = 3},
  [1798] = {.lex_state = 1, .external_lex_state = 3},
  [1799] = {.lex_state = 1, .external_lex_state = 3},
  [1800] = {.lex_state = 1, .external_lex_state = 3},
  [1801] = {.lex_state = 1, .external_lex_state = 3},
  [1802] = {.lex_state = 1, .external_lex_state = 3},
  [1803] = {.lex_state = 1, .external_lex_state = 3},
  [1804] = {.lex_state = 1, .external_lex_state = 3},
  [1805] = {.lex_state = 1, .external_lex_state = 3},
  [1806] = {.lex_state = 1, .external_lex_state = 3},
  [1807] = {.lex_state = 36},
  [1808] = {.lex_state = 35},
  [1809] = {.lex_state = 35, .external_lex_state = 2},
  [1810] = {.lex_state = 35, .external_lex_state = 2},
  [1811] = {.lex_state = 35},
  [1812] = {.lex_state = 35, .external_lex_state = 2},
  [1813] = {.lex_state = 35},
  [1814] = {.lex_state = 36},
  [1815] = {.lex_state = 35},
  [1816] = {.lex_state = 35, .external_lex_state = 2},
  [1817] = {.lex_state = 35},
  [1818] = {.lex_state = 35},
  [1819] = {.lex_state = 35},
  [1820] = {.lex_state = 35},
  [1821] = {.lex_state = 35, .external_lex_state = 2},
  [1822] = {.lex_state = 35},
  [1823] = {.lex_state = 35},
  [1824] = {.lex_state = 35, .external_lex_state = 2},
  [1825] = {.lex_state = 35, .external_lex_state = 2},
  [1826] = {.lex_state = 35},
  [1827] = {.lex_state = 34},
  [1828] = {.lex_state = 35},
  [1829] = {.lex_state = 35},
  [1830] = {.lex_state = 35, .external_lex_state = 2},
  [1831] = {.lex_state = 35, .external_lex_state = 2},
  [1832] = {.lex_state = 33, .external_lex_state = 2},
  [1833] = {.lex_state = 35},
  [1834] = {.lex_state = 35},
  [1835] = {.lex_state = 35, .external_lex_state = 2},
  [1836] = {.lex_state = 35, .external_lex_state = 2},
  [1837] = {.lex_state = 35},
  [1838] = {.lex_state = 35},
  [1839] = {.lex_state = 35, .external_lex_state = 2},
  [1840] = {.lex_state = 35, .external_lex_state = 2},
  [1841] = {.lex_state = 35, .external_lex_state = 2},
  [1842] = {.lex_state = 35},
  [1843] = {.lex_state = 33, .external_lex_state = 2},
  [1844] = {.lex_state = 35, .external_lex_state = 2},
  [1845] = {.lex_state = 35},
  [1846] = {.lex_state = 35, .external_lex_state = 2},
  [1847] = {.lex_state = 35, .external_lex_state = 2},
  [1848] = {.lex_state = 35, .external_lex_state = 2},
  [1849] = {.lex_state = 35},
  [1850] = {.lex_state = 35, .external_lex_state = 2},
  [1851] = {.lex_state = 35, .external_lex_state = 2},
  [1852] = {.lex_state = 35, .external_lex_state = 2},
  [1853] = {.lex_state = 35},
  [1854] = {.lex_state = 35, .external_lex_state = 2},
  [1855] = {.lex_state = 35},
  [1856] = {.lex_state = 35, .external_lex_state = 2},
  [1857] = {.lex_state = 35, .external_lex_state = 2},
  [1858] = {.lex_state = 33},
  [1859] = {.lex_state = 35},
  [1860] = {.lex_state = 35},
  [1861] = {.lex_state = 36},
  [1862] = {.lex_state = 36},
  [1863] = {.lex_state = 36},
  [1864] = {.lex_state = 35},
  [1865] = {.lex_state = 35},
  [1866] = {.lex_state = 35, .external_lex_state = 2},
  [1867] = {.lex_state = 35},
  [1868] = {.lex_state = 36},
  [1869] = {.lex_state = 36},
  [1870] = {.lex_state = 35},
  [1871] = {.lex_state = 35},
  [1872] = {.lex_state = 36},
  [1873] = {.lex_state = 36},
  [1874] = {.lex_state = 36},
  [1875] = {.lex_state = 36},
  [1876] = {.lex_state = 36},
  [1877] = {.lex_state = 36},
  [1878] = {.lex_state = 36},
  [1879] = {.lex_state = 35},
  [1880] = {.lex_state = 36},
  [1881] = {.lex_state = 35},
  [1882] = {.lex_state = 36},
  [1883] = {.lex_state = 34},
  [1884] = {.lex_state = 35, .external_lex_state = 2},
  [1885] = {.lex_state = 35},
  [1886] = {.lex_state = 36},
  [1887] = {.lex_state = 36},
  [1888] = {.lex_state = 36},
  [1889] = {.lex_state = 36},
  [1890] = {.lex_state = 36},
  [1891] = {.lex_state = 35},
  [1892] = {.lex_state = 35},
  [1893] = {.lex_state = 35},
  [1894] = {.lex_state = 35},
  [1895] = {.lex_state = 35, .external_lex_state = 2},
  [1896] = {.lex_state = 35},
  [1897] = {.lex_state = 35},
  [1898] = {.lex_state = 35},
  [1899] = {.lex_state = 35},
  [1900] = {.lex_state = 35},
  [1901] = {.lex_state = 35},
  [1902] = {.lex_state = 35},
  [1903] = {.lex_state = 35, .external_lex_state = 2},
  [1904] = {.lex_state = 35},
  [1905] = {.lex_state = 35, .external_lex_state = 2},
  [1906] = {.lex_state = 35, .external_lex_state = 2},
  [1907] = {.lex_state = 35},
  [1908] = {.lex_state = 35, .external_lex_state = 2},
  [1909] = {.lex_state = 35},
  [1910] = {.lex_state = 35, .external_lex_state = 2},
  [1911] = {.lex_state = 35, .external_lex_state = 2},
  [1912] = {.lex_state = 35},
  [1913] = {.lex_state = 35, .external_lex_state = 2},
  [1914] = {.lex_state = 33, .external_lex_state = 2},
  [1915] = {.lex_state = 35},
  [1916] = {.lex_state = 35},
  [1917] = {.lex_state = 35},
  [1918] = {.lex_state = 35},
  [1919] = {.lex_state = 35},
  [1920] = {.lex_state = 35},
  [1921] = {.lex_state = 35, .external_lex_state = 2},
  [1922] = {.lex_state = 35},
  [1923] = {.lex_state = 35},
  [1924] = {.lex_state = 35},
  [1925] = {.lex_state = 36},
  [1926] = {.lex_state = 36},
  [1927] = {.lex_state = 35},
  [1928] = {.lex_state = 36},
  [1929] = {.lex_state = 36},
  [1930] = {.lex_state = 35},
  [1931] = {.lex_state = 35},
  [1932] = {.lex_state = 35, .external_lex_state = 2},
  [1933] = {.lex_state = 35},
  [1934] = {.lex_state = 35},
  [1935] = {.lex_state = 35},
  [1936] = {.lex_state = 35},
  [1937] = {.lex_state = 35, .external_lex_state = 2},
  [1938] = {.lex_state = 35},
  [1939] = {.lex_state = 35},
  [1940] = {.lex_state = 35},
  [1941] = {.lex_state = 35},
  [1942] = {.lex_state = 35},
  [1943] = {.lex_state = 36},
  [1944] = {.lex_state = 35},
  [1945] = {.lex_state = 35, .external_lex_state = 2},
  [1946] = {.lex_state = 35},
  [1947] = {.lex_state = 35},
  [1948] = {.lex_state = 35},
  [1949] = {.lex_state = 35},
  [1950] = {.lex_state = 35},
  [1951] = {.lex_state = 35},
  [1952] = {.lex_state = 35, .external_lex_state = 2},
  [1953] = {.lex_state = 35},
  [1954] = {.lex_state = 35},
  [1955] = {.lex_state = 35},
  [1956] = {.lex_state = 35, .external_lex_state = 2},
  [1957] = {.lex_state = 35},
  [1958] = {.lex_state = 35},
  [1959] = {.lex_state = 35},
  [1960] = {.lex_state = 35},
  [1961] = {.lex_state = 35, .external_lex_state = 2},
  [1962] = {.lex_state = 35, .external_lex_state = 2},
  [1963] = {.lex_state = 35},
  [1964] = {.lex_state = 35},
  [1965] = {.lex_state = 35},
  [1966] = {.lex_state = 35},
  [1967] = {.lex_state = 35},
  [1968] = {.lex_state = 35},
  [1969] = {.lex_state = 35, .external_lex_state = 2},
  [1970] = {.lex_state = 35},
  [1971] = {.lex_state = 35},
  [1972] = {.lex_state = 35, .external_lex_state = 2},
  [1973] = {.lex_state = 35},
  [1974] = {.lex_state = 35},
  [1975] = {.lex_state = 35},
  [1976] = {.lex_state = 35},
  [1977] = {.lex_state = 35},
  [1978] = {.lex_state = 35},
  [1979] = {.lex_state = 36},
  [1980] = {.lex_state = 35},
  [1981] = {.lex_state = 35, .external_lex_state = 2},
  [1982] = {.lex_state = 35, .external_lex_state = 2},
  [1983] = {.lex_state = 35, .external_lex_state = 2},
  [1984] = {.lex_state = 35},
  [1985] = {.lex_state = 35},
  [1986] = {.lex_state = 35, .external_lex_state = 2},
  [1987] = {.lex_state = 35},
  [1988] = {.lex_state = 35, .external_lex_state = 2},
  [1989] = {.lex_state = 35},
  [1990] = {.lex_state = 35},
  [1991] = {.lex_state = 35},
  [1992] = {.lex_state = 35},
  [1993] = {.lex_state = 35},
  [1994] = {.lex_state = 35},
  [1995] = {.lex_state = 35},
  [1996] = {.lex_state = 35, .external_lex_state = 2},
  [1997] = {.lex_state = 35},
  [1998] = {.lex_state = 35, .external_lex_state = 2},
  [1999] = {.lex_state = 35},
  [2000] = {.lex_state = 35},
  [2001] = {.lex_state = 35},
  [2002] = {.lex_state = 35},
  [2003] = {.lex_state = 35, .external_lex_state = 2},
  [2004] = {.lex_state = 34},
  [2005] = {.lex_state = 35},
  [2006] = {.lex_state = 33},
  [2007] = {.lex_state = 35},
  [2008] = {.lex_state = 35, .external_lex_state = 2},
  [2009] = {.lex_state = 35},
  [2010] = {.lex_state = 35},
  [2011] = {.lex_state = 35},
  [2012] = {.lex_state = 35},
  [2013] = {.lex_state = 35},
  [2014] = {.lex_state = 36},
  [2015] = {.lex_state = 35},
  [2016] = {.lex_state = 35},
  [2017] = {.lex_state = 35},
  [2018] = {.lex_state = 35},
  [2019] = {.lex_state = 35},
  [2020] = {.lex_state = 36},
  [2021] = {.lex_state = 35},
  [2022] = {.lex_state = 35},
  [2023] = {.lex_state = 35},
  [2024] = {.lex_state = 35},
  [2025] = {.lex_state = 35},
  [2026] = {.lex_state = 35},
  [2027] = {.lex_state = 35},
  [2028] = {.lex_state = 35},
  [2029] = {.lex_state = 35},
  [2030] = {.lex_state = 35},
  [2031] = {.lex_state = 35},
  [2032] = {.lex_state = 35},
  [2033] = {.lex_state = 35},
  [2034] = {.lex_state = 35},
  [2035] = {.lex_state = 35},
  [2036] = {.lex_state = 35},
  [2037] = {.lex_state = 35},
  [2038] = {.lex_state = 35, .external_lex_state = 2},
  [2039] = {.lex_state = 35},
  [2040] = {.lex_state = 35, .external_lex_state = 2},
  [2041] = {.lex_state = 35},
  [2042] = {.lex_state = 35, .external_lex_state = 2},
  [2043] = {.lex_state = 35},
  [2044] = {.lex_state = 35},
  [2045] = {.lex_state = 35},
  [2046] = {.lex_state = 35},
  [2047] = {.lex_state = 35},
  [2048] = {.lex_state = 35},
  [2049] = {.lex_state = 35},
  [2050] = {.lex_state = 35},
  [2051] = {.lex_state = 35, .external_lex_state = 2},
  [2052] = {.lex_state = 35},
  [2053] = {.lex_state = 35},
  [2054] = {.lex_state = 35},
  [2055] = {.lex_state = 35},
  [2056] = {.lex_state = 35, .external_lex_state = 2},
  [2057] = {.lex_state = 35, .external_lex_state = 2},
  [2058] = {.lex_state = 35, .external_lex_state = 2},
  [2059] = {.lex_state = 35},
  [2060] = {.lex_state = 35},
  [2061] = {.lex_state = 35, .external_lex_state = 2},
  [2062] = {.lex_state = 35},
  [2063] = {.lex_state = 35},
  [2064] = {.lex_state = 35},
  [2065] = {.lex_state = 35},
  [2066] = {.lex_state = 35},
  [2067] = {.lex_state = 35},
  [2068] = {.lex_state = 35},
  [2069] = {.lex_state = 35},
  [2070] = {.lex_state = 35},
  [2071] = {.lex_state = 35},
  [2072] = {.lex_state = 35},
  [2073] = {.lex_state = 35},
  [2074] = {.lex_state = 36},
  [2075] = {.lex_state = 36},
  [2076] = {.lex_state = 35, .external_lex_state = 2},
  [2077] = {.lex_state = 35},
  [2078] = {.lex_state = 35, .external_lex_state = 2},
  [2079] = {.lex_state = 35},
  [2080] = {.lex_state = 36},
  [2081] = {.lex_state = 35},
  [2082] = {.lex_state = 36},
  [2083] = {.lex_state = 35, .external_lex_state = 2},
  [2084] = {.lex_state = 36},
  [2085] = {.lex_state = 35, .external_lex_state = 2},
  [2086] = {.lex_state = 35, .external_lex_state = 2},
  [2087] = {.lex_state = 35, .external_lex_state = 2},
  [2088] = {.lex_state = 35, .external_lex_state = 2},
  [2089] = {.lex_state = 35, .external_lex_state = 2},
  [2090] = {.lex_state = 35, .external_lex_state = 2},
  [2091] = {.lex_state = 36},
  [2092] = {.lex_state = 35, .external_lex_state = 2},
  [2093] = {.lex_state = 35},
  [2094] = {.lex_state = 36},
  [2095] = {.lex_state = 35},
  [2096] = {.lex_state = 35, .external_lex_state = 2},
  [2097] = {.lex_state = 35},
  [2098] = {.lex_state = 35},
  [2099] = {.lex_state = 35, .external_lex_state = 2},
  [2100] = {.lex_state = 36},
  [2101] = {.lex_state = 35},
  [2102] = {.lex_state = 35, .external_lex_state = 2},
  [2103] = {.lex_state = 35},
  [2104] = {.lex_state = 35, .external_lex_state = 2},
  [2105] = {.lex_state = 35},
  [2106] = {.lex_state = 36},
  [2107] = {.lex_state = 35},
  [2108] = {.lex_state = 36},
  [2109] = {.lex_state = 35},
  [2110] = {.lex_state = 35},
  [2111] = {.lex_state = 35, .external_lex_state = 2},
  [2112] = {.lex_state = 35, .external_lex_state = 2},
  [2113] = {.lex_state = 36},
  [2114] = {.lex_state = 35, .external_lex_state = 2},
  [2115] = {.lex_state = 36},
  [2116] = {.lex_state = 35, .external_lex_state = 2},
  [2117] = {.lex_state = 35, .external_lex_state = 2},
  [2118] = {.lex_state = 36},
  [2119] = {.lex_state = 35},
  [2120] = {.lex_state = 35},
  [2121] = {.lex_state = 36},
  [2122] = {.lex_state = 35},
  [2123] = {.lex_state = 35},
  [2124] = {.lex_state = 35},
  [2125] = {.lex_state = 35},
  [2126] = {.lex_state = 35, .external_lex_state = 2},
  [2127] = {.lex_state = 35},
  [2128] = {.lex_state = 35, .external_lex_state = 2},
  [2129] = {.lex_state = 35},
  [2130] = {.lex_state = 35},
  [2131] = {.lex_state = 35},
  [2132] = {.lex_state = 35},
  [2133] = {.lex_state = 35},
  [2134] = {.lex_state = 35},
  [2135] = {.lex_state = 35},
  [2136] = {.lex_state = 35},
  [2137] = {.lex_state = 36},
  [2138] = {.lex_state = 35},
  [2139] = {.lex_state = 35},
  [2140] = {.lex_state = 35},
  [2141] = {.lex_state = 35, .external_lex_state = 2},
  [2142] = {.lex_state = 35},
  [2143] = {.lex_state = 36},
  [2144] = {.lex_state = 36},
  [2145] = {.lex_state = 35, .external_lex_state = 2},
  [2146] = {.lex_state = 36},
  [2147] = {.lex_state = 35},
  [2148] = {.lex_state = 35, .external_lex_state = 2},
  [2149] = {.lex_state = 35},
  [2150] = {.lex_state = 35},
  [2151] = {.lex_state = 35},
  [2152] = {.lex_state = 35},
  [2153] = {.lex_state = 35},
  [2154] = {.lex_state = 35},
  [2155] = {.lex_state = 35, .external_lex_state = 2},
  [2156] = {.lex_state = 35},
  [2157] = {.lex_state = 35},
  [2158] = {.lex_state = 35},
  [2159] = {.lex_state = 35, .external_lex_state = 2},
  [2160] = {.lex_state = 35},
  [2161] = {.lex_state = 35},
  [2162] = {.lex_state = 35, .external_lex_state = 2},
  [2163] = {.lex_state = 35, .external_lex_state = 2},
  [2164] = {.lex_state = 35},
  [2165] = {.lex_state = 35, .external_lex_state = 2},
  [2166] = {.lex_state = 35, .external_lex_state = 2},
  [2167] = {.lex_state = 35},
  [2168] = {.lex_state = 35, .external_lex_state = 2},
  [2169] = {.lex_state = 35, .external_lex_state = 2},
  [2170] = {.lex_state = 35, .external_lex_state = 2},
  [2171] = {.lex_state = 35, .external_lex_state = 2},
  [2172] = {.lex_state = 35, .external_lex_state = 2},
  [2173] = {.lex_state = 35},
  [2174] = {.lex_state = 35, .external_lex_state = 2},
  [2175] = {.lex_state = 35, .external_lex_state = 2},
  [2176] = {.lex_state = 35, .external_lex_state = 2},
  [2177] = {.lex_state = 35},
  [2178] = {.lex_state = 35},
  [2179] = {.lex_state = 35, .external_lex_state = 2},
  [2180] = {.lex_state = 35},
  [2181] = {.lex_state = 35},
  [2182] = {.lex_state = 35},
  [2183] = {.lex_state = 35, .external_lex_state = 2},
  [2184] = {.lex_state = 35, .external_lex_state = 2},
  [2185] = {.lex_state = 35},
  [2186] = {.lex_state = 35, .external_lex_state = 2},
  [2187] = {.lex_state = 35, .external_lex_state = 2},
  [2188] = {.lex_state = 35},
  [2189] = {.lex_state = 35, .external_lex_state = 2},
  [2190] = {.lex_state = 36},
  [2191] = {.lex_state = 35, .external_lex_state = 2},
  [2192] = {.lex_state = 35, .external_lex_state = 2},
  [2193] = {.lex_state = 35, .external_lex_state = 2},
  [2194] = {.lex_state = 36},
  [2195] = {.lex_state = 35},
  [2196] = {.lex_state = 35, .external_lex_state = 2},
  [2197] = {.lex_state = 35, .external_lex_state = 2},
  [2198] = {.lex_state = 36},
  [2199] = {.lex_state = 35},
  [2200] = {.lex_state = 35},
  [2201] = {.lex_state = 35},
  [2202] = {.lex_state = 35, .external_lex_state = 2},
  [2203] = {.lex_state = 36},
  [2204] = {.lex_state = 35},
  [2205] = {.lex_state = 35, .external_lex_state = 2},
  [2206] = {.lex_state = 35},
  [2207] = {.lex_state = 36},
  [2208] = {.lex_state = 35, .external_lex_state = 2},
  [2209] = {.lex_state = 35, .external_lex_state = 2},
  [2210] = {.lex_state = 35},
  [2211] = {.lex_state = 35, .external_lex_state = 2},
  [2212] = {.lex_state = 35},
  [2213] = {.lex_state = 35},
  [2214] = {.lex_state = 35},
  [2215] = {.lex_state = 35},
  [2216] = {.lex_state = 35, .external_lex_state = 2},
  [2217] = {.lex_state = 35},
  [2218] = {.lex_state = 35},
  [2219] = {.lex_state = 35},
  [2220] = {.lex_state = 35, .external_lex_state = 2},
  [2221] = {.lex_state = 35, .external_lex_state = 2},
  [2222] = {.lex_state = 35},
  [2223] = {.lex_state = 35, .external_lex_state = 2},
  [2224] = {.lex_state = 35, .external_lex_state = 2},
  [2225] = {.lex_state = 35, .external_lex_state = 2},
  [2226] = {.lex_state = 35},
  [2227] = {.lex_state = 35},
  [2228] = {.lex_state = 35, .external_lex_state = 2},
  [2229] = {.lex_state = 35, .external_lex_state = 2},
  [2230] = {.lex_state = 35, .external_lex_state = 2},
  [2231] = {.lex_state = 35, .external_lex_state = 2},
  [2232] = {.lex_state = 35},
  [2233] = {.lex_state = 35, .external_lex_state = 2},
  [2234] = {.lex_state = 35, .external_lex_state = 2},
  [2235] = {.lex_state = 35, .external_lex_state = 2},
  [2236] = {.lex_state = 35, .external_lex_state = 2},
  [2237] = {.lex_state = 35, .external_lex_state = 2},
  [2238] = {.lex_state = 35, .external_lex_state = 2},
  [2239] = {.lex_state = 35, .external_lex_state = 2},
  [2240] = {.lex_state = 35, .external_lex_state = 2},
  [2241] = {.lex_state = 35, .external_lex_state = 2},
  [2242] = {.lex_state = 35},
  [2243] = {.lex_state = 35, .external_lex_state = 2},
  [2244] = {.lex_state = 35},
  [2245] = {.lex_state = 35},
  [2246] = {.lex_state = 35, .external_lex_state = 2},
  [2247] = {.lex_state = 35},
  [2248] = {.lex_state = 36},
  [2249] = {.lex_state = 35, .external_lex_state = 2},
  [2250] = {.lex_state = 36},
  [2251] = {.lex_state = 36},
  [2252] = {.lex_state = 36},
  [2253] = {.lex_state = 35},
  [2254] = {.lex_state = 35},
  [2255] = {.lex_state = 35},
  [2256] = {.lex_state = 35, .external_lex_state = 2},
  [2257] = {.lex_state = 35},
  [2258] = {.lex_state = 36},
  [2259] = {.lex_state = 36},
  [2260] = {.lex_state = 35},
  [2261] = {.lex_state = 36},
  [2262] = {.lex_state = 36},
  [2263] = {.lex_state = 36},
  [2264] = {.lex_state = 35},
  [2265] = {.lex_state = 36},
  [2266] = {.lex_state = 35, .external_lex_state = 2},
  [2267] = {.lex_state = 35, .external_lex_state = 2},
  [2268] = {.lex_state = 35},
  [2269] = {.lex_state = 35, .external_lex_state = 2},
  [2270] = {.lex_state = 35, .external_lex_state = 2},
  [2271] = {.lex_state = 35},
  [2272] = {.lex_state = 36},
  [2273] = {.lex_state = 35, .external_lex_state = 2},
  [2274] = {.lex_state = 35},
  [2275] = {.lex_state = 36},
  [2276] = {.lex_state = 35, .external_lex_state = 2},
  [2277] = {.lex_state = 35, .external_lex_state = 2},
  [2278] = {.lex_state = 35, .external_lex_state = 2},
  [2279] = {.lex_state = 35, .external_lex_state = 2},
  [2280] = {.lex_state = 35, .external_lex_state = 2},
  [2281] = {.lex_state = 35, .external_lex_state = 2},
  [2282] = {.lex_state = 35, .external_lex_state = 2},
  [2283] = {.lex_state = 36},
  [2284] = {.lex_state = 35, .external_lex_state = 2},
  [2285] = {.lex_state = 35, .external_lex_state = 2},
  [2286] = {.lex_state = 35, .external_lex_state = 2},
  [2287] = {.lex_state = 36},
  [2288] = {.lex_state = 35, .external_lex_state = 2},
  [2289] = {.lex_state = 35, .external_lex_state = 2},
  [2290] = {.lex_state = 35, .external_lex_state = 2},
  [2291] = {.lex_state = 35, .external_lex_state = 2},
  [2292] = {.lex_state = 35, .external_lex_state = 2},
  [2293] = {.lex_state = 35},
  [2294] = {.lex_state = 35, .external_lex_state = 2},
  [2295] = {.lex_state = 35, .external_lex_state = 2},
  [2296] = {.lex_state = 35, .external_lex_state = 2},
  [2297] = {.lex_state = 36},
  [2298] = {.lex_state = 35, .external_lex_state = 2},
  [2299] = {.lex_state = 35, .external_lex_state = 2},
  [2300] = {.lex_state = 35, .external_lex_state = 2},
  [2301] = {.lex_state = 35, .external_lex_state = 2},
  [2302] = {.lex_state = 35, .external_lex_state = 2},
  [2303] = {.lex_state = 35, .external_lex_state = 2},
  [2304] = {.lex_state = 35, .external_lex_state = 2},
  [2305] = {.lex_state = 35, .external_lex_state = 2},
  [2306] = {.lex_state = 35, .external_lex_state = 2},
  [2307] = {.lex_state = 35, .external_lex_state = 2},
  [2308] = {.lex_state = 35, .external_lex_state = 2},
  [2309] = {.lex_state = 35, .external_lex_state = 2},
  [2310] = {.lex_state = 35, .external_lex_state = 2},
  [2311] = {.lex_state = 35, .external_lex_state = 2},
  [2312] = {.lex_state = 35, .external_lex_state = 2},
  [2313] = {.lex_state = 35, .external_lex_state = 2},
  [2314] = {.lex_state = 35, .external_lex_state = 2},
  [2315] = {.lex_state = 35, .external_lex_state = 2},
  [2316] = {.lex_state = 35, .external_lex_state = 2},
  [2317] = {.lex_state = 35, .external_lex_state = 2},
  [2318] = {.lex_state = 35, .external_lex_state = 2},
  [2319] = {.lex_state = 35, .external_lex_state = 2},
  [2320] = {.lex_state = 35},
  [2321] = {.lex_state = 35, .external_lex_state = 2},
  [2322] = {.lex_state = 35, .external_lex_state = 2},
  [2323] = {.lex_state = 35},
  [2324] = {.lex_state = 35, .external_lex_state = 2},
  [2325] = {.lex_state = 35, .external_lex_state = 2},
  [2326] = {.lex_state = 35, .external_lex_state = 2},
  [2327] = {.lex_state = 35, .external_lex_state = 2},
  [2328] = {.lex_state = 35, .external_lex_state = 2},
  [2329] = {.lex_state = 35, .external_lex_state = 2},
  [2330] = {.lex_state = 35, .external_lex_state = 2},
  [2331] = {.lex_state = 35, .external_lex_state = 2},
  [2332] = {.lex_state = 35},
  [2333] = {.lex_state = 35, .external_lex_state = 2},
  [2334] = {.lex_state = 35},
  [2335] = {.lex_state = 35, .external_lex_state = 2},
  [2336] = {.lex_state = 35},
  [2337] = {.lex_state = 35},
  [2338] = {.lex_state = 35},
  [2339] = {.lex_state = 35},
  [2340] = {.lex_state = 35},
  [2341] = {.lex_state = 35},
  [2342] = {.lex_state = 35},
  [2343] = {.lex_state = 35},
  [2344] = {.lex_state = 35, .external_lex_state = 2},
  [2345] = {.lex_state = 35, .external_lex_state = 2},
  [2346] = {.lex_state = 35, .external_lex_state = 2},
  [2347] = {.lex_state = 36},
  [2348] = {.lex_state = 36},
  [2349] = {.lex_state = 36},
  [2350] = {.lex_state = 35, .external_lex_state = 2},
  [2351] = {.lex_state = 35, .external_lex_state = 2},
  [2352] = {.lex_state = 36},
  [2353] = {.lex_state = 35, .external_lex_state = 2},
  [2354] = {.lex_state = 36},
  [2355] = {.lex_state = 35},
  [2356] = {.lex_state = 36},
  [2357] = {.lex_state = 35},
  [2358] = {.lex_state = 35},
  [2359] = {.lex_state = 35},
  [2360] = {.lex_state = 35},
  [2361] = {.lex_state = 35},
  [2362] = {.lex_state = 35},
  [2363] = {.lex_state = 36},
  [2364] = {.lex_state = 35},
  [2365] = {.lex_state = 35},
  [2366] = {.lex_state = 35, .external_lex_state = 2},
  [2367] = {.lex_state = 35},
  [2368] = {.lex_state = 36},
  [2369] = {.lex_state = 35},
  [2370] = {.lex_state = 35},
  [2371] = {.lex_state = 36},
  [2372] = {.lex_state = 36},
  [2373] = {.lex_state = 36},
  [2374] = {.lex_state = 36},
  [2375] = {.lex_state = 36},
  [2376] = {.lex_state = 36},
  [2377] = {.lex_state = 35, .external_lex_state = 2},
  [2378] = {.lex_state = 35},
  [2379] = {.lex_state = 35},
  [2380] = {.lex_state = 35, .external_lex_state = 2},
  [2381] = {.lex_state = 35},
  [2382] = {.lex_state = 36},
  [2383] = {.lex_state = 35},
  [2384] = {.lex_state = 35},
  [2385] = {.lex_state = 35},
  [2386] = {.lex_state = 35, .external_lex_state = 2},
  [2387] = {.lex_state = 36},
  [2388] = {.lex_state = 36},
  [2389] = {.lex_state = 35, .external_lex_state = 2},
  [2390] = {.lex_state = 36},
  [2391] = {.lex_state = 36},
  [2392] = {.lex_state = 36},
  [2393] = {.lex_state = 35},
  [2394] = {.lex_state = 36},
  [2395] = {.lex_state = 36},
  [2396] = {.lex_state = 35},
  [2397] = {.lex_state = 35},
  [2398] = {.lex_state = 35},
  [2399] = {.lex_state = 35, .external_lex_state = 2},
  [2400] = {.lex_state = 35},
  [2401] = {.lex_state = 35},
  [2402] = {.lex_state = 35},
  [2403] = {.lex_state = 35},
  [2404] = {.lex_state = 35},
  [2405] = {.lex_state = 36},
  [2406] = {.lex_state = 35, .external_lex_state = 2},
  [2407] = {.lex_state = 35},
  [2408] = {.lex_state = 35},
  [2409] = {.lex_state = 35},
  [2410] = {.lex_state = 35},
  [2411] = {.lex_state = 35},
  [2412] = {.lex_state = 35},
  [2413] = {.lex_state = 35},
  [2414] = {.lex_state = 35},
  [2415] = {.lex_state = 35, .external_lex_state = 2},
  [2416] = {.lex_state = 35, .external_lex_state = 2},
  [2417] = {.lex_state = 35, .external_lex_state = 2},
  [2418] = {.lex_state = 35, .external_lex_state = 2},
  [2419] = {.lex_state = 35},
  [2420] = {.lex_state = 35},
  [2421] = {.lex_state = 35},
  [2422] = {.lex_state = 35, .external_lex_state = 2},
  [2423] = {.lex_state = 35, .external_lex_state = 2},
  [2424] = {.lex_state = 35},
  [2425] = {.lex_state = 35, .external_lex_state = 2},
  [2426] = {.lex_state = 35, .external_lex_state = 2},
  [2427] = {.lex_state = 35},
  [2428] = {.lex_state = 35},
  [2429] = {.lex_state = 35, .external_lex_state = 2},
  [2430] = {.lex_state = 35, .external_lex_state = 2},
  [2431] = {.lex_state = 35, .external_lex_state = 2},
  [2432] = {.lex_state = 36},
  [2433] = {.lex_state = 36},
  [2434] = {.lex_state = 35},
  [2435] = {.lex_state = 35},
  [2436] = {.lex_state = 35},
  [2437] = {.lex_state = 35},
  [2438] = {.lex_state = 36},
  [2439] = {.lex_state = 36},
  [2440] = {.lex_state = 36},
  [2441] = {.lex_state = 36},
  [2442] = {.lex_state = 35, .external_lex_state = 2},
  [2443] = {.lex_state = 35, .external_lex_state = 2},
  [2444] = {.lex_state = 35},
  [2445] = {.lex_state = 35},
  [2446] = {.lex_state = 35},
  [2447] = {.lex_state = 35},
  [2448] = {.lex_state = 35},
  [2449] = {.lex_state = 35},
  [2450] = {.lex_state = 35, .external_lex_state = 2},
  [2451] = {.lex_state = 35, .external_lex_state = 2},
  [2452] = {.lex_state = 36},
  [2453] = {.lex_state = 36},
  [2454] = {.lex_state = 36},
  [2455] = {.lex_state = 36},
  [2456] = {.lex_state = 36},
  [2457] = {.lex_state = 35, .external_lex_state = 2},
  [2458] = {.lex_state = 35, .external_lex_state = 2},
  [2459] = {.lex_state = 35, .external_lex_state = 2},
  [2460] = {.lex_state = 35, .external_lex_state = 2},
  [2461] = {.lex_state = 36},
  [2462] = {.lex_state = 36},
  [2463] = {.lex_state = 35, .external_lex_state = 2},
  [2464] = {.lex_state = 35},
  [2465] = {.lex_state = 36},
  [2466] = {.lex_state = 36},
  [2467] = {.lex_state = 35, .external_lex_state = 2},
  [2468] = {.lex_state = 35},
  [2469] = {.lex_state = 35, .external_lex_state = 2},
  [2470] = {.lex_state = 35, .external_lex_state = 2},
  [2471] = {.lex_state = 35, .external_lex_state = 2},
  [2472] = {.lex_state = 35},
  [2473] = {.lex_state = 35, .external_lex_state = 2},
  [2474] = {.lex_state = 35, .external_lex_state = 2},
  [2475] = {.lex_state = 35, .external_lex_state = 2},
  [2476] = {.lex_state = 35, .external_lex_state = 2},
  [2477] = {.lex_state = 35, .external_lex_state = 2},
  [2478] = {.lex_state = 35, .external_lex_state = 2},
  [2479] = {.lex_state = 35, .external_lex_state = 2},
  [2480] = {.lex_state = 35, .external_lex_state = 2},
  [2481] = {.lex_state = 35, .external_lex_state = 2},
  [2482] = {.lex_state = 35, .external_lex_state = 2},
  [2483] = {.lex_state = 35, .external_lex_state = 2},
  [2484] = {.lex_state = 36},
  [2485] = {.lex_state = 35, .external_lex_state = 2},
  [2486] = {.lex_state = 36},
  [2487] = {.lex_state = 35, .external_lex_state = 2},
  [2488] = {.lex_state = 36},
  [2489] = {.lex_state = 35, .external_lex_state = 2},
  [2490] = {.lex_state = 35},
  [2491] = {.lex_state = 36},
  [2492] = {.lex_state = 35, .external_lex_state = 2},
  [2493] = {.lex_state = 35, .external_lex_state = 2},
  [2494] = {.lex_state = 35, .external_lex_state = 2},
  [2495] = {.lex_state = 35},
  [2496] = {.lex_state = 35, .external_lex_state = 2},
  [2497] = {.lex_state = 35, .external_lex_state = 2},
  [2498] = {.lex_state = 35, .external_lex_state = 2},
  [2499] = {.lex_state = 35, .external_lex_state = 2},
  [2500] = {.lex_state = 35, .external_lex_state = 2},
  [2501] = {.lex_state = 36},
  [2502] = {.lex_state = 36},
  [2503] = {.lex_state = 36},
  [2504] = {.lex_state = 36},
  [2505] = {.lex_state = 36},
  [2506] = {.lex_state = 36},
  [2507] = {.lex_state = 36},
  [2508] = {.lex_state = 36},
  [2509] = {.lex_state = 35, .external_lex_state = 2},
  [2510] = {.lex_state = 36},
  [2511] = {.lex_state = 35, .external_lex_state = 2},
  [2512] = {.lex_state = 36},
  [2513] = {.lex_state = 36},
  [2514] = {.lex_state = 36},
  [2515] = {.lex_state = 36},
  [2516] = {.lex_state = 36},
  [2517] = {.lex_state = 35, .external_lex_state = 2},
  [2518] = {.lex_state = 35, .external_lex_state = 2},
  [2519] = {.lex_state = 35, .external_lex_state = 2},
  [2520] = {.lex_state = 35, .external_lex_state = 2},
  [2521] = {.lex_state = 35, .external_lex_state = 2},
  [2522] = {.lex_state = 35, .external_lex_state = 2},
  [2523] = {.lex_state = 35, .external_lex_state = 2},
  [2524] = {.lex_state = 35, .external_lex_state = 2},
  [2525] = {.lex_state = 35, .external_lex_state = 2},
  [2526] = {.lex_state = 35, .external_lex_state = 2},
  [2527] = {.lex_state = 35, .external_lex_state = 2},
  [2528] = {.lex_state = 35, .external_lex_state = 2},
  [2529] = {.lex_state = 35},
  [2530] = {.lex_state = 35, .external_lex_state = 2},
  [2531] = {.lex_state = 35, .external_lex_state = 2},
  [2532] = {.lex_state = 35},
  [2533] = {.lex_state = 35},
  [2534] = {.lex_state = 35},
  [2535] = {.lex_state = 36},
  [2536] = {.lex_state = 35, .external_lex_state = 2},
  [2537] = {.lex_state = 36},
  [2538] = {.lex_state = 35, .external_lex_state = 2},
  [2539] = {.lex_state = 36},
  [2540] = {.lex_state = 35},
  [2541] = {.lex_state = 35, .external_lex_state = 2},
  [2542] = {.lex_state = 35, .external_lex_state = 2},
  [2543] = {.lex_state = 35, .external_lex_state = 2},
  [2544] = {.lex_state = 36},
  [2545] = {.lex_state = 35},
  [2546] = {.lex_state = 35, .external_lex_state = 2},
  [2547] = {.lex_state = 35, .external_lex_state = 2},
  [2548] = {.lex_state = 36},
  [2549] = {.lex_state = 36},
  [2550] = {.lex_state = 36},
  [2551] = {.lex_state = 35, .external_lex_state = 2},
  [2552] = {.lex_state = 35, .external_lex_state = 2},
  [2553] = {.lex_state = 35, .external_lex_state = 2},
  [2554] = {.lex_state = 35, .external_lex_state = 2},
  [2555] = {.lex_state = 35, .external_lex_state = 2},
  [2556] = {.lex_state = 35, .external_lex_state = 2},
  [2557] = {.lex_state = 35, .external_lex_state = 2},
  [2558] = {.lex_state = 35, .external_lex_state = 2},
  [2559] = {.lex_state = 35, .external_lex_state = 2},
  [2560] = {.lex_state = 35},
  [2561] = {.lex_state = 35, .external_lex_state = 2},
  [2562] = {.lex_state = 35},
  [2563] = {.lex_state = 35, .external_lex_state = 2},
  [2564] = {.lex_state = 35, .external_lex_state = 2},
  [2565] = {.lex_state = 35, .external_lex_state = 2},
  [2566] = {.lex_state = 35},
  [2567] = {.lex_state = 35, .external_lex_state = 2},
  [2568] = {.lex_state = 35},
  [2569] = {.lex_state = 35, .external_lex_state = 2},
  [2570] = {.lex_state = 35, .external_lex_state = 2},
  [2571] = {.lex_state = 36},
  [2572] = {.lex_state = 35, .external_lex_state = 2},
  [2573] = {.lex_state = 35},
  [2574] = {.lex_state = 35, .external_lex_state = 2},
  [2575] = {.lex_state = 35, .external_lex_state = 2},
  [2576] = {.lex_state = 35, .external_lex_state = 2},
  [2577] = {.lex_state = 35},
  [2578] = {.lex_state = 35},
  [2579] = {.lex_state = 35},
  [2580] = {.lex_state = 35},
  [2581] = {.lex_state = 35, .external_lex_state = 2},
  [2582] = {.lex_state = 35},
  [2583] = {.lex_state = 35},
  [2584] = {.lex_state = 35},
  [2585] = {.lex_state = 35, .external_lex_state = 2},
  [2586] = {.lex_state = 35, .external_lex_state = 2},
  [2587] = {.lex_state = 35},
  [2588] = {.lex_state = 35},
  [2589] = {.lex_state = 35},
  [2590] = {.lex_state = 35},
  [2591] = {.lex_state = 33},
  [2592] = {.lex_state = 35, .external_lex_state = 2},
  [2593] = {.lex_state = 35},
  [2594] = {.lex_state = 35},
  [2595] = {.lex_state = 35, .external_lex_state = 2},
  [2596] = {.lex_state = 35},
  [2597] = {.lex_state = 35},
  [2598] = {.lex_state = 35, .external_lex_state = 2},
  [2599] = {.lex_state = 35, .external_lex_state = 2},
  [2600] = {.lex_state = 35, .external_lex_state = 2},
  [2601] = {.lex_state = 35},
  [2602] = {.lex_state = 35},
  [2603] = {.lex_state = 35},
  [2604] = {.lex_state = 35},
  [2605] = {.lex_state = 35},
  [2606] = {.lex_state = 35, .external_lex_state = 2},
  [2607] = {.lex_state = 35, .external_lex_state = 2},
  [2608] = {.lex_state = 36},
  [2609] = {.lex_state = 36},
  [2610] = {.lex_state = 35, .external_lex_state = 2},
  [2611] = {.lex_state = 35, .external_lex_state = 2},
  [2612] = {.lex_state = 35, .external_lex_state = 2},
  [2613] = {.lex_state = 35, .external_lex_state = 2},
  [2614] = {.lex_state = 35, .external_lex_state = 2},
  [2615] = {.lex_state = 35, .external_lex_state = 2},
  [2616] = {.lex_state = 35, .external_lex_state = 2},
  [2617] = {.lex_state = 35},
  [2618] = {.lex_state = 35, .external_lex_state = 2},
  [2619] = {.lex_state = 35, .external_lex_state = 2},
  [2620] = {.lex_state = 35},
  [2621] = {.lex_state = 35},
  [2622] = {.lex_state = 35, .external_lex_state = 2},
  [2623] = {.lex_state = 35},
  [2624] = {.lex_state = 35},
  [2625] = {.lex_state = 35, .external_lex_state = 2},
  [2626] = {.lex_state = 35, .external_lex_state = 2},
  [2627] = {.lex_state = 35, .external_lex_state = 2},
  [2628] = {.lex_state = 33},
  [2629] = {.lex_state = 35, .external_lex_state = 2},
  [2630] = {.lex_state = 33},
  [2631] = {.lex_state = 36},
  [2632] = {.lex_state = 35},
  [2633] = {.lex_state = 35},
  [2634] = {.lex_state = 35, .external_lex_state = 2},
  [2635] = {.lex_state = 35},
  [2636] = {.lex_state = 35},
  [2637] = {.lex_state = 36},
  [2638] = {.lex_state = 35, .external_lex_state = 2},
  [2639] = {.lex_state = 36},
  [2640] = {.lex_state = 35, .external_lex_state = 2},
  [2641] = {.lex_state = 35, .external_lex_state = 2},
  [2642] = {.lex_state = 35},
  [2643] = {.lex_state = 35},
  [2644] = {.lex_state = 35, .external_lex_state = 2},
  [2645] = {.lex_state = 35, .external_lex_state = 2},
  [2646] = {.lex_state = 35, .external_lex_state = 2},
  [2647] = {.lex_state = 35, .external_lex_state = 2},
  [2648] = {.lex_state = 35, .external_lex_state = 2},
  [2649] = {.lex_state = 35, .external_lex_state = 2},
  [2650] = {.lex_state = 35, .external_lex_state = 2},
  [2651] = {.lex_state = 35, .external_lex_state = 2},
  [2652] = {.lex_state = 35},
  [2653] = {.lex_state = 35, .external_lex_state = 2},
  [2654] = {.lex_state = 35, .external_lex_state = 2},
  [2655] = {.lex_state = 35, .external_lex_state = 2},
  [2656] = {.lex_state = 35},
  [2657] = {.lex_state = 35},
  [2658] = {.lex_state = 35, .external_lex_state = 2},
  [2659] = {.lex_state = 35, .external_lex_state = 2},
  [2660] = {.lex_state = 35, .external_lex_state = 2},
  [2661] = {.lex_state = 35, .external_lex_state = 2},
  [2662] = {.lex_state = 35},
  [2663] = {.lex_state = 35},
  [2664] = {.lex_state = 35},
  [2665] = {.lex_state = 35},
  [2666] = {.lex_state = 35},
  [2667] = {.lex_state = 35},
  [2668] = {.lex_state = 35},
  [2669] = {.lex_state = 35},
  [2670] = {.lex_state = 35},
  [2671] = {.lex_state = 35},
  [2672] = {.lex_state = 35},
  [2673] = {.lex_state = 35},
  [2674] = {.lex_state = 35},
  [2675] = {.lex_state = 35, .external_lex_state = 2},
  [2676] = {.lex_state = 35},
  [2677] = {.lex_state = 35, .external_lex_state = 2},
  [2678] = {.lex_state = 35, .external_lex_state = 2},
  [2679] = {.lex_state = 35, .external_lex_state = 2},
  [2680] = {.lex_state = 35, .external_lex_state = 2},
  [2681] = {.lex_state = 35, .external_lex_state = 2},
  [2682] = {.lex_state = 35, .external_lex_state = 2},
  [2683] = {.lex_state = 35, .external_lex_state = 2},
  [2684] = {.lex_state = 35, .external_lex_state = 2},
  [2685] = {.lex_state = 36},
  [2686] = {.lex_state = 35},
  [2687] = {.lex_state = 35, .external_lex_state = 2},
  [2688] = {.lex_state = 35, .external_lex_state = 2},
  [2689] = {.lex_state = 35, .external_lex_state = 2},
  [2690] = {.lex_state = 35},
  [2691] = {.lex_state = 35, .external_lex_state = 2},
  [2692] = {.lex_state = 35, .external_lex_state = 2},
  [2693] = {.lex_state = 35, .external_lex_state = 2},
  [2694] = {.lex_state = 35},
  [2695] = {.lex_state = 35},
  [2696] = {.lex_state = 35, .external_lex_state = 2},
  [2697] = {.lex_state = 35},
  [2698] = {.lex_state = 35, .external_lex_state = 2},
  [2699] = {.lex_state = 35},
  [2700] = {.lex_state = 35, .external_lex_state = 2},
  [2701] = {.lex_state = 35, .external_lex_state = 2},
  [2702] = {.lex_state = 35},
  [2703] = {.lex_state = 35},
  [2704] = {.lex_state = 35},
  [2705] = {.lex_state = 35, .external_lex_state = 2},
  [2706] = {.lex_state = 35},
  [2707] = {.lex_state = 35},
  [2708] = {.lex_state = 35},
  [2709] = {.lex_state = 35},
  [2710] = {.lex_state = 33},
  [2711] = {.lex_state = 33},
  [2712] = {.lex_state = 35, .external_lex_state = 2},
  [2713] = {.lex_state = 35},
  [2714] = {.lex_state = 35},
  [2715] = {.lex_state = 35},
  [2716] = {.lex_state = 35},
  [2717] = {.lex_state = 35},
  [2718] = {.lex_state = 35},
  [2719] = {.lex_state = 35},
  [2720] = {.lex_state = 35},
  [2721] = {.lex_state = 35},
  [2722] = {.lex_state = 35},
  [2723] = {.lex_state = 35, .external_lex_state = 2},
  [2724] = {.lex_state = 35},
  [2725] = {.lex_state = 35},
  [2726] = {.lex_state = 35, .external_lex_state = 2},
  [2727] = {.lex_state = 35},
  [2728] = {.lex_state = 35},
  [2729] = {.lex_state = 35},
  [2730] = {.lex_state = 35},
  [2731] = {.lex_state = 35, .external_lex_state = 2},
  [2732] = {.lex_state = 35, .external_lex_state = 2},
  [2733] = {.lex_state = 33},
  [2734] = {.lex_state = 35},
  [2735] = {.lex_state = 35},
  [2736] = {.lex_state = 35, .external_lex_state = 2},
  [2737] = {.lex_state = 35, .external_lex_state = 2},
  [2738] = {.lex_state = 35, .external_lex_state = 2},
  [2739] = {.lex_state = 35, .external_lex_state = 2},
  [2740] = {.lex_state = 35},
  [2741] = {.lex_state = 35},
  [2742] = {.lex_state = 35},
  [2743] = {.lex_state = 35},
  [2744] = {.lex_state = 35, .external_lex_state = 2},
  [2745] = {.lex_state = 35, .external_lex_state = 2},
  [2746] = {.lex_state = 35, .external_lex_state = 2},
  [2747] = {.lex_state = 35, .external_lex_state = 2},
  [2748] = {.lex_state = 35, .external_lex_state = 2},
  [2749] = {.lex_state = 35, .external_lex_state = 2},
  [2750] = {.lex_state = 35, .external_lex_state = 2},
  [2751] = {.lex_state = 35, .external_lex_state = 2},
  [2752] = {.lex_state = 35, .external_lex_state = 2},
  [2753] = {.lex_state = 35, .external_lex_state = 2},
  [2754] = {.lex_state = 35, .external_lex_state = 2},
  [2755] = {.lex_state = 35},
  [2756] = {.lex_state = 35, .external_lex_state = 2},
  [2757] = {.lex_state = 35, .external_lex_state = 2},
  [2758] = {.lex_state = 35},
  [2759] = {.lex_state = 35, .external_lex_state = 2},
  [2760] = {.lex_state = 35, .external_lex_state = 2},
  [2761] = {.lex_state = 35},
  [2762] = {.lex_state = 35, .external_lex_state = 2},
  [2763] = {.lex_state = 35},
  [2764] = {.lex_state = 35},
  [2765] = {.lex_state = 35},
  [2766] = {.lex_state = 35},
  [2767] = {.lex_state = 35, .external_lex_state = 2},
  [2768] = {.lex_state = 35, .external_lex_state = 2},
  [2769] = {.lex_state = 35},
  [2770] = {.lex_state = 35},
  [2771] = {.lex_state = 35},
  [2772] = {.lex_state = 35, .external_lex_state = 2},
  [2773] = {.lex_state = 33, .external_lex_state = 2},
  [2774] = {.lex_state = 35, .external_lex_state = 2},
  [2775] = {.lex_state = 35},
  [2776] = {.lex_state = 35},
  [2777] = {.lex_state = 35},
  [2778] = {.lex_state = 33},
  [2779] = {.lex_state = 35, .external_lex_state = 2},
  [2780] = {.lex_state = 35},
  [2781] = {.lex_state = 35},
  [2782] = {.lex_state = 35},
  [2783] = {.lex_state = 35},
  [2784] = {.lex_state = 35},
  [2785] = {.lex_state = 35},
  [2786] = {.lex_state = 35},
  [2787] = {.lex_state = 35},
  [2788] = {.lex_state = 35},
  [2789] = {.lex_state = 35},
  [2790] = {.lex_state = 35, .external_lex_state = 2},
  [2791] = {.lex_state = 35},
  [2792] = {.lex_state = 35},
  [2793] = {.lex_state = 35},
  [2794] = {.lex_state = 35, .external_lex_state = 2},
  [2795] = {.lex_state = 35, .external_lex_state = 2},
  [2796] = {.lex_state = 35, .external_lex_state = 2},
  [2797] = {.lex_state = 35},
  [2798] = {.lex_state = 35},
  [2799] = {.lex_state = 35},
  [2800] = {.lex_state = 35},
  [2801] = {.lex_state = 35},
  [2802] = {.lex_state = 35},
  [2803] = {.lex_state = 35},
  [2804] = {.lex_state = 35},
  [2805] = {.lex_state = 35},
  [2806] = {.lex_state = 35},
  [2807] = {.lex_state = 35},
  [2808] = {.lex_state = 35},
  [2809] = {.lex_state = 35},
  [2810] = {.lex_state = 35},
  [2811] = {.lex_state = 35},
  [2812] = {.lex_state = 35},
  [2813] = {.lex_state = 35},
  [2814] = {.lex_state = 35},
  [2815] = {.lex_state = 35, .external_lex_state = 2},
  [2816] = {.lex_state = 35, .external_lex_state = 2},
  [2817] = {.lex_state = 35},
  [2818] = {.lex_state = 35},
  [2819] = {.lex_state = 35},
  [2820] = {.lex_state = 35},
  [2821] = {.lex_state = 35},
  [2822] = {.lex_state = 35},
  [2823] = {.lex_state = 35},
  [2824] = {.lex_state = 35},
  [2825] = {.lex_state = 35},
  [2826] = {.lex_state = 35},
  [2827] = {.lex_state = 35},
  [2828] = {.lex_state = 35},
  [2829] = {.lex_state = 33},
  [2830] = {.lex_state = 35},
  [2831] = {.lex_state = 35, .external_lex_state = 2},
  [2832] = {.lex_state = 35},
  [2833] = {.lex_state = 35, .external_lex_state = 2},
  [2834] = {.lex_state = 35},
  [2835] = {.lex_state = 35},
  [2836] = {.lex_state = 35, .external_lex_state = 2},
  [2837] = {.lex_state = 35},
  [2838] = {.lex_state = 35, .external_lex_state = 2},
  [2839] = {.lex_state = 35, .external_lex_state = 2},
  [2840] = {.lex_state = 35, .external_lex_state = 2},
  [2841] = {.lex_state = 35, .external_lex_state = 2},
  [2842] = {.lex_state = 35, .external_lex_state = 2},
  [2843] = {.lex_state = 35, .external_lex_state = 2},
  [2844] = {.lex_state = 35, .external_lex_state = 2},
  [2845] = {.lex_state = 35, .external_lex_state = 2},
  [2846] = {.lex_state = 35},
  [2847] = {.lex_state = 35, .external_lex_state = 2},
  [2848] = {.lex_state = 35},
  [2849] = {.lex_state = 35},
  [2850] = {.lex_state = 35, .external_lex_state = 2},
  [2851] = {.lex_state = 33, .external_lex_state = 2},
  [2852] = {.lex_state = 35, .external_lex_state = 2},
  [2853] = {.lex_state = 35, .external_lex_state = 2},
  [2854] = {.lex_state = 35},
  [2855] = {.lex_state = 35},
  [2856] = {.lex_state = 35, .external_lex_state = 2},
  [2857] = {.lex_state = 35, .external_lex_state = 2},
  [2858] = {.lex_state = 35, .external_lex_state = 2},
  [2859] = {.lex_state = 35, .external_lex_state = 2},
  [2860] = {.lex_state = 35, .external_lex_state = 2},
  [2861] = {.lex_state = 35, .external_lex_state = 2},
  [2862] = {.lex_state = 35},
  [2863] = {.lex_state = 35, .external_lex_state = 2},
  [2864] = {.lex_state = 35, .external_lex_state = 2},
  [2865] = {.lex_state = 35},
  [2866] = {.lex_state = 35, .external_lex_state = 2},
  [2867] = {.lex_state = 35},
  [2868] = {.lex_state = 35, .external_lex_state = 2},
  [2869] = {.lex_state = 35},
  [2870] = {.lex_state = 35, .external_lex_state = 2},
  [2871] = {.lex_state = 35, .external_lex_state = 2},
  [2872] = {.lex_state = 35},
  [2873] = {.lex_state = 35, .external_lex_state = 2},
  [2874] = {.lex_state = 35, .external_lex_state = 2},
  [2875] = {.lex_state = 35},
  [2876] = {.lex_state = 35},
  [2877] = {.lex_state = 35},
  [2878] = {.lex_state = 35},
  [2879] = {.lex_state = 35},
  [2880] = {.lex_state = 35},
  [2881] = {.lex_state = 35},
  [2882] = {.lex_state = 33, .external_lex_state = 2},
  [2883] = {.lex_state = 35, .external_lex_state = 2},
  [2884] = {.lex_state = 35, .external_lex_state = 2},
  [2885] = {.lex_state = 35, .external_lex_state = 2},
  [2886] = {.lex_state = 35},
  [2887] = {.lex_state = 35, .external_lex_state = 2},
  [2888] = {.lex_state = 35, .external_lex_state = 2},
  [2889] = {.lex_state = 35, .external_lex_state = 2},
  [2890] = {.lex_state = 35},
  [2891] = {.lex_state = 35},
  [2892] = {.lex_state = 35},
  [2893] = {.lex_state = 35},
  [2894] = {.lex_state = 35},
  [2895] = {.lex_state = 35, .external_lex_state = 2},
  [2896] = {.lex_state = 35},
  [2897] = {.lex_state = 35, .external_lex_state = 2},
  [2898] = {.lex_state = 35, .external_lex_state = 2},
  [2899] = {.lex_state = 35},
  [2900] = {.lex_state = 35, .external_lex_state = 2},
  [2901] = {.lex_state = 35},
  [2902] = {.lex_state = 35},
  [2903] = {.lex_state = 35},
  [2904] = {.lex_state = 35, .external_lex_state = 2},
  [2905] = {.lex_state = 35},
  [2906] = {.lex_state = 35, .external_lex_state = 2},
  [2907] = {.lex_state = 35},
  [2908] = {.lex_state = 35},
  [2909] = {.lex_state = 35},
  [2910] = {.lex_state = 35},
  [2911] = {.lex_state = 35, .external_lex_state = 2},
  [2912] = {.lex_state = 35},
  [2913] = {.lex_state = 35, .external_lex_state = 2},
  [2914] = {.lex_state = 33},
  [2915] = {.lex_state = 35},
  [2916] = {.lex_state = 35},
  [2917] = {.lex_state = 35},
  [2918] = {.lex_state = 35},
  [2919] = {.lex_state = 35},
  [2920] = {.lex_state = 35, .external_lex_state = 2},
  [2921] = {.lex_state = 35, .external_lex_state = 2},
  [2922] = {.lex_state = 35},
  [2923] = {.lex_state = 35, .external_lex_state = 2},
  [2924] = {.lex_state = 35},
  [2925] = {.lex_state = 35, .external_lex_state = 2},
  [2926] = {.lex_state = 35, .external_lex_state = 2},
  [2927] = {.lex_state = 35},
  [2928] = {.lex_state = 35},
  [2929] = {.lex_state = 35, .external_lex_state = 2},
  [2930] = {.lex_state = 35},
  [2931] = {.lex_state = 35},
  [2932] = {.lex_state = 35},
  [2933] = {.lex_state = 35},
  [2934] = {.lex_state = 35, .external_lex_state = 2},
  [2935] = {.lex_state = 35, .external_lex_state = 2},
  [2936] = {.lex_state = 35},
  [2937] = {.lex_state = 35},
  [2938] = {.lex_state = 35},
  [2939] = {.lex_state = 35, .external_lex_state = 2},
  [2940] = {.lex_state = 35, .external_lex_state = 2},
  [2941] = {.lex_state = 35},
  [2942] = {.lex_state = 35},
  [2943] = {.lex_state = 35},
  [2944] = {.lex_state = 35},
  [2945] = {.lex_state = 35},
  [2946] = {.lex_state = 35, .external_lex_state = 2},
  [2947] = {.lex_state = 35, .external_lex_state = 2},
  [2948] = {.lex_state = 35, .external_lex_state = 2},
  [2949] = {.lex_state = 35, .external_lex_state = 2},
  [2950] = {.lex_state = 35, .external_lex_state = 2},
  [2951] = {.lex_state = 35},
  [2952] = {.lex_state = 35, .external_lex_state = 2},
  [2953] = {.lex_state = 35, .external_lex_state = 2},
  [2954] = {.lex_state = 35, .external_lex_state = 2},
  [2955] = {.lex_state = 35, .external_lex_state = 2},
  [2956] = {.lex_state = 35, .external_lex_state = 2},
  [2957] = {.lex_state = 35, .external_lex_state = 2},
  [2958] = {.lex_state = 33, .external_lex_state = 2},
  [2959] = {.lex_state = 35},
  [2960] = {.lex_state = 35},
  [2961] = {.lex_state = 33, .external_lex_state = 2},
  [2962] = {.lex_state = 35},
  [2963] = {.lex_state = 35},
  [2964] = {.lex_state = 35},
  [2965] = {.lex_state = 35},
  [2966] = {.lex_state = 35},
  [2967] = {.lex_state = 35},
  [2968] = {.lex_state = 35, .external_lex_state = 2},
  [2969] = {.lex_state = 35},
  [2970] = {.lex_state = 35},
  [2971] = {.lex_state = 35, .external_lex_state = 2},
  [2972] = {.lex_state = 35, .external_lex_state = 2},
  [2973] = {.lex_state = 35},
  [2974] = {.lex_state = 35, .external_lex_state = 2},
  [2975] = {.lex_state = 35, .external_lex_state = 2},
  [2976] = {.lex_state = 35},
  [2977] = {.lex_state = 35},
  [2978] = {.lex_state = 35},
  [2979] = {.lex_state = 35},
  [2980] = {.lex_state = 35},
  [2981] = {.lex_state = 35},
  [2982] = {.lex_state = 35},
  [2983] = {.lex_state = 35},
  [2984] = {.lex_state = 35},
  [2985] = {.lex_state = 35},
  [2986] = {.lex_state = 35},
  [2987] = {.lex_state = 35},
  [2988] = {.lex_state = 35},
  [2989] = {.lex_state = 35},
  [2990] = {.lex_state = 35},
  [2991] = {.lex_state = 35},
  [2992] = {.lex_state = 35},
  [2993] = {.lex_state = 35},
  [2994] = {.lex_state = 35},
  [2995] = {.lex_state = 35},
  [2996] = {.lex_state = 35, .external_lex_state = 2},
  [2997] = {.lex_state = 35},
  [2998] = {.lex_state = 33},
  [2999] = {.lex_state = 35},
  [3000] = {.lex_state = 35, .external_lex_state = 2},
  [3001] = {.lex_state = 35},
  [3002] = {.lex_state = 35},
  [3003] = {.lex_state = 35, .external_lex_state = 2},
  [3004] = {.lex_state = 35},
  [3005] = {.lex_state = 35, .external_lex_state = 2},
  [3006] = {.lex_state = 35, .external_lex_state = 2},
  [3007] = {.lex_state = 35, .external_lex_state = 2},
  [3008] = {.lex_state = 35},
  [3009] = {.lex_state = 35},
  [3010] = {.lex_state = 35, .external_lex_state = 2},
  [3011] = {.lex_state = 35, .external_lex_state = 2},
  [3012] = {.lex_state = 35, .external_lex_state = 2},
  [3013] = {.lex_state = 35, .external_lex_state = 2},
  [3014] = {.lex_state = 35, .external_lex_state = 2},
  [3015] = {.lex_state = 35, .external_lex_state = 2},
  [3016] = {.lex_state = 35},
  [3017] = {.lex_state = 35, .external_lex_state = 2},
  [3018] = {.lex_state = 35},
  [3019] = {.lex_state = 35, .external_lex_state = 2},
  [3020] = {.lex_state = 35},
  [3021] = {.lex_state = 35, .external_lex_state = 2},
  [3022] = {.lex_state = 35},
  [3023] = {.lex_state = 35},
  [3024] = {.lex_state = 35},
  [3025] = {.lex_state = 35, .external_lex_state = 2},
  [3026] = {.lex_state = 35, .external_lex_state = 2},
  [3027] = {.lex_state = 35, .external_lex_state = 2},
  [3028] = {.lex_state = 35, .external_lex_state = 2},
  [3029] = {.lex_state = 35, .external_lex_state = 2},
  [3030] = {.lex_state = 35},
  [3031] = {.lex_state = 35},
  [3032] = {.lex_state = 35},
  [3033] = {.lex_state = 35, .external_lex_state = 2},
  [3034] = {.lex_state = 35, .external_lex_state = 2},
  [3035] = {.lex_state = 33, .external_lex_state = 2},
  [3036] = {.lex_state = 35, .external_lex_state = 2},
  [3037] = {.lex_state = 35, .external_lex_state = 2},
  [3038] = {.lex_state = 35, .external_lex_state = 2},
  [3039] = {.lex_state = 35, .external_lex_state = 2},
  [3040] = {.lex_state = 35, .external_lex_state = 2},
  [3041] = {.lex_state = 35, .external_lex_state = 2},
  [3042] = {.lex_state = 35},
  [3043] = {.lex_state = 35},
  [3044] = {.lex_state = 35},
  [3045] = {.lex_state = 35},
  [3046] = {.lex_state = 35},
  [3047] = {.lex_state = 35},
  [3048] = {.lex_state = 35},
  [3049] = {.lex_state = 35, .external_lex_state = 2},
  [3050] = {.lex_state = 35},
  [3051] = {.lex_state = 35},
  [3052] = {.lex_state = 35, .external_lex_state = 2},
  [3053] = {.lex_state = 35, .external_lex_state = 2},
  [3054] = {.lex_state = 35, .external_lex_state = 2},
  [3055] = {.lex_state = 35, .external_lex_state = 2},
  [3056] = {.lex_state = 35, .external_lex_state = 2},
  [3057] = {.lex_state = 35, .external_lex_state = 2},
  [3058] = {.lex_state = 35},
  [3059] = {.lex_state = 35, .external_lex_state = 2},
  [3060] = {.lex_state = 35, .external_lex_state = 2},
  [3061] = {.lex_state = 35, .external_lex_state = 2},
  [3062] = {.lex_state = 35, .external_lex_state = 2},
  [3063] = {.lex_state = 35},
  [3064] = {.lex_state = 35, .external_lex_state = 2},
  [3065] = {.lex_state = 35},
  [3066] = {.lex_state = 35, .external_lex_state = 2},
  [3067] = {.lex_state = 35},
  [3068] = {.lex_state = 35},
  [3069] = {.lex_state = 35},
  [3070] = {.lex_state = 35, .external_lex_state = 2},
  [3071] = {.lex_state = 33},
  [3072] = {.lex_state = 35, .external_lex_state = 2},
  [3073] = {.lex_state = 35},
  [3074] = {.lex_state = 35},
  [3075] = {.lex_state = 35, .external_lex_state = 2},
  [3076] = {.lex_state = 35, .external_lex_state = 2},
  [3077] = {.lex_state = 35, .external_lex_state = 2},
  [3078] = {.lex_state = 35},
  [3079] = {.lex_state = 35},
  [3080] = {.lex_state = 35, .external_lex_state = 2},
  [3081] = {.lex_state = 35, .external_lex_state = 2},
  [3082] = {.lex_state = 35},
  [3083] = {.lex_state = 35, .external_lex_state = 2},
  [3084] = {.lex_state = 35, .external_lex_state = 2},
  [3085] = {.lex_state = 35},
  [3086] = {.lex_state = 35},
  [3087] = {.lex_state = 35},
  [3088] = {.lex_state = 35, .external_lex_state = 2},
  [3089] = {.lex_state = 35},
  [3090] = {.lex_state = 35},
  [3091] = {.lex_state = 35, .external_lex_state = 2},
  [3092] = {.lex_state = 35},
  [3093] = {.lex_state = 35},
  [3094] = {.lex_state = 35},
  [3095] = {.lex_state = 35, .external_lex_state = 2},
  [3096] = {.lex_state = 35},
  [3097] = {.lex_state = 35},
  [3098] = {.lex_state = 35, .external_lex_state = 2},
  [3099] = {.lex_state = 35, .external_lex_state = 2},
  [3100] = {.lex_state = 35},
  [3101] = {.lex_state = 35, .external_lex_state = 2},
  [3102] = {.lex_state = 35},
  [3103] = {.lex_state = 35},
  [3104] = {.lex_state = 35},
  [3105] = {.lex_state = 35},
  [3106] = {.lex_state = 35},
  [3107] = {.lex_state = 35},
  [3108] = {.lex_state = 35},
  [3109] = {.lex_state = 35},
  [3110] = {.lex_state = 35},
  [3111] = {.lex_state = 35},
  [3112] = {.lex_state = 35},
  [3113] = {.lex_state = 35},
  [3114] = {.lex_state = 35},
  [3115] = {.lex_state = 35},
  [3116] = {.lex_state = 35},
  [3117] = {.lex_state = 35},
  [3118] = {.lex_state = 35},
  [3119] = {.lex_state = 35},
  [3120] = {.lex_state = 35},
  [3121] = {.lex_state = 35},
  [3122] = {.lex_state = 35},
  [3123] = {.lex_state = 35, .external_lex_state = 2},
  [3124] = {.lex_state = 35},
  [3125] = {.lex_state = 35, .external_lex_state = 2},
  [3126] = {.lex_state = 35, .external_lex_state = 2},
  [3127] = {.lex_state = 35},
  [3128] = {.lex_state = 35},
  [3129] = {.lex_state = 35},
  [3130] = {.lex_state = 35},
  [3131] = {.lex_state = 35},
  [3132] = {.lex_state = 35},
  [3133] = {.lex_state = 35, .external_lex_state = 2},
  [3134] = {.lex_state = 35},
  [3135] = {.lex_state = 35},
  [3136] = {.lex_state = 35},
  [3137] = {.lex_state = 35},
  [3138] = {.lex_state = 35},
  [3139] = {.lex_state = 35},
  [3140] = {.lex_state = 35},
  [3141] = {.lex_state = 35},
  [3142] = {.lex_state = 35},
  [3143] = {.lex_state = 35},
  [3144] = {.lex_state = 35},
  [3145] = {.lex_state = 35},
  [3146] = {.lex_state = 35},
  [3147] = {.lex_state = 35},
  [3148] = {.lex_state = 35},
  [3149] = {.lex_state = 35, .external_lex_state = 2},
  [3150] = {.lex_state = 35, .external_lex_state = 2},
  [3151] = {.lex_state = 35, .external_lex_state = 2},
  [3152] = {.lex_state = 35, .external_lex_state = 2},
  [3153] = {.lex_state = 35, .external_lex_state = 2},
  [3154] = {.lex_state = 35},
  [3155] = {.lex_state = 35},
  [3156] = {.lex_state = 35, .external_lex_state = 2},
  [3157] = {.lex_state = 35, .external_lex_state = 2},
  [3158] = {.lex_state = 35, .external_lex_state = 2},
  [3159] = {.lex_state = 35},
  [3160] = {.lex_state = 35, .external_lex_state = 2},
  [3161] = {.lex_state = 35},
  [3162] = {.lex_state = 35, .external_lex_state = 2},
  [3163] = {.lex_state = 35, .external_lex_state = 2},
  [3164] = {.lex_state = 35},
  [3165] = {.lex_state = 35, .external_lex_state = 2},
  [3166] = {.lex_state = 35},
  [3167] = {.lex_state = 35},
  [3168] = {.lex_state = 35, .external_lex_state = 2},
  [3169] = {.lex_state = 35, .external_lex_state = 2},
  [3170] = {.lex_state = 35},
  [3171] = {.lex_state = 35},
  [3172] = {.lex_state = 35},
  [3173] = {.lex_state = 35, .external_lex_state = 2},
  [3174] = {.lex_state = 35, .external_lex_state = 2},
  [3175] = {.lex_state = 35, .external_lex_state = 2},
  [3176] = {.lex_state = 35, .external_lex_state = 2},
  [3177] = {.lex_state = 35},
  [3178] = {.lex_state = 35},
  [3179] = {.lex_state = 35, .external_lex_state = 2},
  [3180] = {.lex_state = 35},
  [3181] = {.lex_state = 35},
  [3182] = {.lex_state = 35, .external_lex_state = 2},
  [3183] = {.lex_state = 35, .external_lex_state = 2},
  [3184] = {.lex_state = 35, .external_lex_state = 2},
  [3185] = {.lex_state = 33, .external_lex_state = 2},
  [3186] = {.lex_state = 35},
  [3187] = {.lex_state = 35, .external_lex_state = 2},
  [3188] = {.lex_state = 35},
  [3189] = {.lex_state = 35},
  [3190] = {.lex_state = 35},
  [3191] = {.lex_state = 35},
  [3192] = {.lex_state = 35},
  [3193] = {.lex_state = 35},
  [3194] = {.lex_state = 35},
  [3195] = {.lex_state = 35},
  [3196] = {.lex_state = 35},
  [3197] = {.lex_state = 35},
  [3198] = {.lex_state = 35},
  [3199] = {.lex_state = 35},
  [3200] = {.lex_state = 35},
  [3201] = {.lex_state = 35, .external_lex_state = 2},
  [3202] = {.lex_state = 35},
  [3203] = {.lex_state = 35},
  [3204] = {.lex_state = 35, .external_lex_state = 2},
  [3205] = {.lex_state = 35},
  [3206] = {.lex_state = 35},
  [3207] = {.lex_state = 35},
  [3208] = {.lex_state = 35},
  [3209] = {.lex_state = 35},
  [3210] = {.lex_state = 35},
  [3211] = {.lex_state = 35, .external_lex_state = 2},
  [3212] = {.lex_state = 35, .external_lex_state = 2},
  [3213] = {.lex_state = 35},
  [3214] = {.lex_state = 35, .external_lex_state = 2},
  [3215] = {.lex_state = 35, .external_lex_state = 2},
  [3216] = {.lex_state = 35},
  [3217] = {.lex_state = 35, .external_lex_state = 2},
  [3218] = {.lex_state = 35, .external_lex_state = 2},
  [3219] = {.lex_state = 35},
  [3220] = {.lex_state = 35, .external_lex_state = 2},
  [3221] = {.lex_state = 35},
  [3222] = {.lex_state = 35},
  [3223] = {.lex_state = 35},
  [3224] = {.lex_state = 35, .external_lex_state = 2},
  [3225] = {.lex_state = 35, .external_lex_state = 2},
  [3226] = {.lex_state = 35, .external_lex_state = 2},
  [3227] = {.lex_state = 35, .external_lex_state = 2},
  [3228] = {.lex_state = 35, .external_lex_state = 2},
  [3229] = {.lex_state = 35},
  [3230] = {.lex_state = 35},
  [3231] = {.lex_state = 35},
  [3232] = {.lex_state = 35, .external_lex_state = 2},
  [3233] = {.lex_state = 35, .external_lex_state = 2},
  [3234] = {.lex_state = 35},
  [3235] = {.lex_state = 35, .external_lex_state = 2},
  [3236] = {.lex_state = 35, .external_lex_state = 2},
  [3237] = {.lex_state = 35, .external_lex_state = 2},
  [3238] = {.lex_state = 35},
  [3239] = {.lex_state = 35, .external_lex_state = 2},
  [3240] = {.lex_state = 35, .external_lex_state = 2},
  [3241] = {.lex_state = 35, .external_lex_state = 2},
  [3242] = {.lex_state = 35, .external_lex_state = 2},
  [3243] = {.lex_state = 35},
  [3244] = {.lex_state = 35},
  [3245] = {.lex_state = 35},
  [3246] = {.lex_state = 35},
  [3247] = {.lex_state = 35},
  [3248] = {.lex_state = 35},
  [3249] = {.lex_state = 35},
  [3250] = {.lex_state = 33, .external_lex_state = 2},
  [3251] = {.lex_state = 35},
  [3252] = {.lex_state = 35},
  [3253] = {.lex_state = 35},
  [3254] = {.lex_state = 35, .external_lex_state = 2},
  [3255] = {.lex_state = 35, .external_lex_state = 2},
  [3256] = {.lex_state = 35, .external_lex_state = 2},
  [3257] = {.lex_state = 35, .external_lex_state = 2},
  [3258] = {.lex_state = 35},
  [3259] = {.lex_state = 35},
  [3260] = {.lex_state = 35},
  [3261] = {.lex_state = 35},
  [3262] = {.lex_state = 35},
  [3263] = {.lex_state = 35},
  [3264] = {.lex_state = 35},
  [3265] = {.lex_state = 35},
  [3266] = {.lex_state = 35},
  [3267] = {.lex_state = 35, .external_lex_state = 2},
  [3268] = {.lex_state = 35},
  [3269] = {.lex_state = 35, .external_lex_state = 2},
  [3270] = {.lex_state = 35},
  [3271] = {.lex_state = 35, .external_lex_state = 2},
  [3272] = {.lex_state = 35, .external_lex_state = 2},
  [3273] = {.lex_state = 35},
  [3274] = {.lex_state = 35, .external_lex_state = 2},
  [3275] = {.lex_state = 35},
  [3276] = {.lex_state = 35},
  [3277] = {.lex_state = 35},
  [3278] = {.lex_state = 35, .external_lex_state = 2},
  [3279] = {.lex_state = 35},
  [3280] = {.lex_state = 35},
  [3281] = {.lex_state = 35, .external_lex_state = 2},
  [3282] = {.lex_state = 35},
  [3283] = {.lex_state = 35, .external_lex_state = 2},
  [3284] = {.lex_state = 35},
  [3285] = {.lex_state = 35},
  [3286] = {.lex_state = 35},
  [3287] = {.lex_state = 33, .external_lex_state = 2},
  [3288] = {.lex_state = 35, .external_lex_state = 2},
  [3289] = {.lex_state = 35, .external_lex_state = 2},
  [3290] = {.lex_state = 35},
  [3291] = {.lex_state = 33, .external_lex_state = 2},
  [3292] = {.lex_state = 35, .external_lex_state = 2},
  [3293] = {.lex_state = 35},
  [3294] = {.lex_state = 35},
  [3295] = {.lex_state = 35},
  [3296] = {.lex_state = 35},
  [3297] = {.lex_state = 35},
  [3298] = {.lex_state = 35},
  [3299] = {.lex_state = 35, .external_lex_state = 2},
  [3300] = {.lex_state = 35, .external_lex_state = 2},
  [3301] = {.lex_state = 35, .external_lex_state = 2},
  [3302] = {.lex_state = 35, .external_lex_state = 2},
  [3303] = {.lex_state = 35},
  [3304] = {.lex_state = 35},
  [3305] = {.lex_state = 35},
  [3306] = {.lex_state = 35},
  [3307] = {.lex_state = 35},
  [3308] = {.lex_state = 35, .external_lex_state = 2},
  [3309] = {.lex_state = 35},
  [3310] = {.lex_state = 35},
  [3311] = {.lex_state = 35},
  [3312] = {.lex_state = 35, .external_lex_state = 2},
  [3313] = {.lex_state = 35},
  [3314] = {.lex_state = 35},
  [3315] = {.lex_state = 35},
  [3316] = {.lex_state = 33},
  [3317] = {.lex_state = 35},
  [3318] = {.lex_state = 35, .external_lex_state = 2},
  [3319] = {.lex_state = 35, .external_lex_state = 2},
  [3320] = {.lex_state = 35, .external_lex_state = 2},
  [3321] = {.lex_state = 35},
  [3322] = {.lex_state = 35},
  [3323] = {.lex_state = 35},
  [3324] = {.lex_state = 35},
  [3325] = {.lex_state = 35},
  [3326] = {.lex_state = 35},
  [3327] = {.lex_state = 35},
  [3328] = {.lex_state = 35},
  [3329] = {.lex_state = 35},
  [3330] = {.lex_state = 35},
  [3331] = {.lex_state = 35},
  [3332] = {.lex_state = 35},
  [3333] = {.lex_state = 35, .external_lex_state = 2},
  [3334] = {.lex_state = 35},
  [3335] = {.lex_state = 35},
  [3336] = {.lex_state = 35, .external_lex_state = 2},
  [3337] = {.lex_state = 35},
  [3338] = {.lex_state = 35, .external_lex_state = 2},
  [3339] = {.lex_state = 35},
  [3340] = {.lex_state = 35, .external_lex_state = 2},
  [3341] = {.lex_state = 35},
  [3342] = {.lex_state = 35, .external_lex_state = 2},
  [3343] = {.lex_state = 35, .external_lex_state = 2},
  [3344] = {.lex_state = 35},
  [3345] = {.lex_state = 35, .external_lex_state = 2},
  [3346] = {.lex_state = 35},
  [3347] = {.lex_state = 35},
  [3348] = {.lex_state = 35, .external_lex_state = 2},
  [3349] = {.lex_state = 35, .external_lex_state = 2},
  [3350] = {.lex_state = 35, .external_lex_state = 2},
  [3351] = {.lex_state = 35, .external_lex_state = 2},
  [3352] = {.lex_state = 35},
  [3353] = {.lex_state = 35, .external_lex_state = 2},
  [3354] = {.lex_state = 35},
  [3355] = {.lex_state = 35, .external_lex_state = 2},
  [3356] = {.lex_state = 35},
  [3357] = {.lex_state = 35, .external_lex_state = 2},
  [3358] = {.lex_state = 35, .external_lex_state = 2},
  [3359] = {.lex_state = 35, .external_lex_state = 2},
  [3360] = {.lex_state = 35, .external_lex_state = 2},
  [3361] = {.lex_state = 35, .external_lex_state = 2},
  [3362] = {.lex_state = 35},
  [3363] = {.lex_state = 35, .external_lex_state = 2},
  [3364] = {.lex_state = 35},
  [3365] = {.lex_state = 35},
  [3366] = {.lex_state = 35},
  [3367] = {.lex_state = 35},
  [3368] = {.lex_state = 35, .external_lex_state = 2},
  [3369] = {.lex_state = 35},
  [3370] = {.lex_state = 35},
  [3371] = {.lex_state = 35, .external_lex_state = 2},
  [3372] = {.lex_state = 35},
  [3373] = {.lex_state = 35},
  [3374] = {.lex_state = 35},
  [3375] = {.lex_state = 35},
  [3376] = {.lex_state = 35},
  [3377] = {.lex_state = 35},
  [3378] = {.lex_state = 35},
  [3379] = {.lex_state = 35},
  [3380] = {.lex_state = 35, .external_lex_state = 2},
  [3381] = {.lex_state = 35, .external_lex_state = 2},
  [3382] = {.lex_state = 35},
  [3383] = {.lex_state = 35, .external_lex_state = 2},
  [3384] = {.lex_state = 35},
  [3385] = {.lex_state = 35},
  [3386] = {.lex_state = 35, .external_lex_state = 2},
  [3387] = {.lex_state = 35, .external_lex_state = 2},
  [3388] = {.lex_state = 35, .external_lex_state = 2},
  [3389] = {.lex_state = 35, .external_lex_state = 2},
  [3390] = {.lex_state = 35},
  [3391] = {.lex_state = 35},
  [3392] = {.lex_state = 35, .external_lex_state = 2},
  [3393] = {.lex_state = 35},
  [3394] = {.lex_state = 35, .external_lex_state = 2},
  [3395] = {.lex_state = 35, .external_lex_state = 2},
  [3396] = {.lex_state = 35},
  [3397] = {.lex_state = 35},
  [3398] = {.lex_state = 35},
  [3399] = {.lex_state = 35},
  [3400] = {.lex_state = 35},
  [3401] = {.lex_state = 35},
  [3402] = {.lex_state = 35},
  [3403] = {.lex_state = 35},
  [3404] = {.lex_state = 35},
  [3405] = {.lex_state = 35, .external_lex_state = 2},
  [3406] = {.lex_state = 35},
  [3407] = {.lex_state = 35},
  [3408] = {.lex_state = 35},
  [3409] = {.lex_state = 35},
  [3410] = {.lex_state = 35},
  [3411] = {.lex_state = 35},
  [3412] = {.lex_state = 35},
  [3413] = {.lex_state = 35},
  [3414] = {.lex_state = 35},
  [3415] = {.lex_state = 35},
  [3416] = {.lex_state = 35},
  [3417] = {.lex_state = 35},
  [3418] = {.lex_state = 35},
  [3419] = {.lex_state = 35},
  [3420] = {.lex_state = 35},
  [3421] = {.lex_state = 35},
  [3422] = {.lex_state = 35},
  [3423] = {.lex_state = 35},
  [3424] = {.lex_state = 35},
  [3425] = {.lex_state = 35},
  [3426] = {.lex_state = 35, .external_lex_state = 2},
  [3427] = {.lex_state = 35},
  [3428] = {.lex_state = 35, .external_lex_state = 2},
  [3429] = {.lex_state = 35, .external_lex_state = 2},
  [3430] = {.lex_state = 35, .external_lex_state = 2},
  [3431] = {.lex_state = 35},
  [3432] = {.lex_state = 35},
  [3433] = {.lex_state = 35, .external_lex_state = 2},
  [3434] = {.lex_state = 35},
  [3435] = {.lex_state = 35},
  [3436] = {.lex_state = 35, .external_lex_state = 2},
  [3437] = {.lex_state = 35},
  [3438] = {.lex_state = 35},
  [3439] = {.lex_state = 35},
  [3440] = {.lex_state = 35},
  [3441] = {.lex_state = 35, .external_lex_state = 2},
  [3442] = {.lex_state = 35},
  [3443] = {.lex_state = 35, .external_lex_state = 2},
  [3444] = {.lex_state = 35},
  [3445] = {.lex_state = 35},
  [3446] = {.lex_state = 35},
  [3447] = {.lex_state = 35, .external_lex_state = 2},
  [3448] = {.lex_state = 35},
  [3449] = {.lex_state = 35},
  [3450] = {.lex_state = 35},
  [3451] = {.lex_state = 35},
  [3452] = {.lex_state = 35},
  [3453] = {.lex_state = 35},
  [3454] = {.lex_state = 35},
  [3455] = {.lex_state = 35, .external_lex_state = 2},
  [3456] = {.lex_state = 35},
  [3457] = {.lex_state = 35},
  [3458] = {.lex_state = 35},
  [3459] = {.lex_state = 35},
  [3460] = {.lex_state = 35, .external_lex_state = 2},
  [3461] = {.lex_state = 35},
  [3462] = {.lex_state = 35},
  [3463] = {.lex_state = 35, .external_lex_state = 2},
  [3464] = {.lex_state = 35, .external_lex_state = 2},
  [3465] = {.lex_state = 35},
  [3466] = {.lex_state = 35},
  [3467] = {.lex_state = 35},
  [3468] = {.lex_state = 35},
  [3469] = {.lex_state = 35},
  [3470] = {.lex_state = 35},
  [3471] = {.lex_state = 35},
  [3472] = {.lex_state = 35},
  [3473] = {.lex_state = 35},
  [3474] = {.lex_state = 35},
  [3475] = {.lex_state = 35},
  [3476] = {.lex_state = 35},
  [3477] = {.lex_state = 35, .external_lex_state = 2},
  [3478] = {.lex_state = 35},
  [3479] = {.lex_state = 35},
  [3480] = {.lex_state = 35, .external_lex_state = 2},
  [3481] = {.lex_state = 35, .external_lex_state = 2},
  [3482] = {.lex_state = 35},
  [3483] = {.lex_state = 35, .external_lex_state = 2},
  [3484] = {.lex_state = 35},
  [3485] = {.lex_state = 35},
  [3486] = {.lex_state = 35, .external_lex_state = 2},
  [3487] = {.lex_state = 35},
  [3488] = {.lex_state = 35, .external_lex_state = 2},
  [3489] = {.lex_state = 35},
  [3490] = {.lex_state = 35},
  [3491] = {.lex_state = 35, .external_lex_state = 2},
  [3492] = {.lex_state = 35},
  [3493] = {.lex_state = 35},
  [3494] = {.lex_state = 35},
  [3495] = {.lex_state = 35},
  [3496] = {.lex_state = 35, .external_lex_state = 2},
  [3497] = {.lex_state = 35, .external_lex_state = 2},
  [3498] = {.lex_state = 35, .external_lex_state = 2},
  [3499] = {.lex_state = 35},
  [3500] = {.lex_state = 35, .external_lex_state = 2},
  [3501] = {.lex_state = 35},
  [3502] = {.lex_state = 35},
  [3503] = {.lex_state = 35},
  [3504] = {.lex_state = 35},
  [3505] = {.lex_state = 35},
  [3506] = {.lex_state = 35},
  [3507] = {.lex_state = 35},
  [3508] = {.lex_state = 35},
  [3509] = {.lex_state = 35},
  [3510] = {.lex_state = 35},
  [3511] = {.lex_state = 35},
  [3512] = {.lex_state = 35},
  [3513] = {.lex_state = 35, .external_lex_state = 2},
  [3514] = {.lex_state = 35},
  [3515] = {.lex_state = 35, .external_lex_state = 2},
  [3516] = {.lex_state = 35},
  [3517] = {.lex_state = 35},
  [3518] = {.lex_state = 35, .external_lex_state = 2},
  [3519] = {.lex_state = 35},
  [3520] = {.lex_state = 35, .external_lex_state = 2},
  [3521] = {.lex_state = 35, .external_lex_state = 2},
  [3522] = {.lex_state = 35},
  [3523] = {.lex_state = 35},
  [3524] = {.lex_state = 35},
  [3525] = {.lex_state = 35},
  [3526] = {.lex_state = 35},
  [3527] = {.lex_state = 35},
  [3528] = {.lex_state = 35, .external_lex_state = 2},
  [3529] = {.lex_state = 35, .external_lex_state = 2},
  [3530] = {.lex_state = 35},
  [3531] = {.lex_state = 35},
  [3532] = {.lex_state = 35, .external_lex_state = 2},
  [3533] = {.lex_state = 35, .external_lex_state = 2},
  [3534] = {.lex_state = 35},
  [3535] = {.lex_state = 35},
  [3536] = {.lex_state = 35},
  [3537] = {.lex_state = 35},
  [3538] = {.lex_state = 35, .external_lex_state = 2},
  [3539] = {.lex_state = 35},
  [3540] = {.lex_state = 35, .external_lex_state = 2},
  [3541] = {.lex_state = 35},
  [3542] = {.lex_state = 35},
  [3543] = {.lex_state = 35},
  [3544] = {.lex_state = 35},
  [3545] = {.lex_state = 35, .external_lex_state = 2},
  [3546] = {.lex_state = 35},
  [3547] = {.lex_state = 35},
  [3548] = {.lex_state = 35},
  [3549] = {.lex_state = 35},
  [3550] = {.lex_state = 35, .external_lex_state = 2},
  [3551] = {.lex_state = 35},
  [3552] = {.lex_state = 35},
  [3553] = {.lex_state = 35},
  [3554] = {.lex_state = 35, .external_lex_state = 2},
  [3555] = {.lex_state = 35},
  [3556] = {.lex_state = 35},
  [3557] = {.lex_state = 35},
  [3558] = {.lex_state = 35},
  [3559] = {.lex_state = 35, .external_lex_state = 2},
  [3560] = {.lex_state = 35},
  [3561] = {.lex_state = 35, .external_lex_state = 2},
  [3562] = {.lex_state = 35},
  [3563] = {.lex_state = 35},
  [3564] = {.lex_state = 35},
  [3565] = {.lex_state = 35},
  [3566] = {.lex_state = 35},
  [3567] = {.lex_state = 35},
  [3568] = {.lex_state = 35, .external_lex_state = 2},
  [3569] = {.lex_state = 35},
  [3570] = {.lex_state = 35, .external_lex_state = 2},
  [3571] = {.lex_state = 35, .external_lex_state = 2},
  [3572] = {.lex_state = 35, .external_lex_state = 2},
  [3573] = {.lex_state = 35, .external_lex_state = 2},
  [3574] = {.lex_state = 35, .external_lex_state = 2},
  [3575] = {.lex_state = 35, .external_lex_state = 2},
  [3576] = {.lex_state = 35, .external_lex_state = 2},
  [3577] = {.lex_state = 35, .external_lex_state = 2},
  [3578] = {.lex_state = 35, .external_lex_state = 2},
  [3579] = {.lex_state = 35},
  [3580] = {.lex_state = 35},
  [3581] = {.lex_state = 35},
  [3582] = {.lex_state = 35},
  [3583] = {.lex_state = 35, .external_lex_state = 2},
  [3584] = {.lex_state = 35},
  [3585] = {.lex_state = 35},
  [3586] = {.lex_state = 35},
  [3587] = {.lex_state = 35},
  [3588] = {.lex_state = 35},
  [3589] = {.lex_state = 35},
  [3590] = {.lex_state = 35},
  [3591] = {.lex_state = 35},
  [3592] = {.lex_state = 35},
  [3593] = {.lex_state = 35},
  [3594] = {.lex_state = 35, .external_lex_state = 2},
  [3595] = {.lex_state = 35, .external_lex_state = 2},
  [3596] = {.lex_state = 35},
  [3597] = {.lex_state = 35},
  [3598] = {.lex_state = 35},
  [3599] = {.lex_state = 35},
  [3600] = {.lex_state = 35},
  [3601] = {.lex_state = 35},
  [3602] = {.lex_state = 35},
  [3603] = {.lex_state = 35},
  [3604] = {.lex_state = 35},
  [3605] = {.lex_state = 35},
  [3606] = {.lex_state = 35},
  [3607] = {.lex_state = 35},
  [3608] = {.lex_state = 35},
  [3609] = {.lex_state = 35},
  [3610] = {.lex_state = 35, .external_lex_state = 2},
  [3611] = {.lex_state = 33, .external_lex_state = 2},
  [3612] = {.lex_state = 35},
  [3613] = {.lex_state = 35},
  [3614] = {.lex_state = 35},
  [3615] = {.lex_state = 35},
  [3616] = {.lex_state = 35, .external_lex_state = 2},
  [3617] = {.lex_state = 35, .external_lex_state = 2},
  [3618] = {.lex_state = 35, .external_lex_state = 2},
  [3619] = {.lex_state = 35},
  [3620] = {.lex_state = 35, .external_lex_state = 2},
  [3621] = {.lex_state = 35, .external_lex_state = 2},
  [3622] = {.lex_state = 35, .external_lex_state = 2},
  [3623] = {.lex_state = 35},
  [3624] = {.lex_state = 35},
  [3625] = {.lex_state = 35, .external_lex_state = 2},
  [3626] = {.lex_state = 35, .external_lex_state = 2},
  [3627] = {.lex_state = 35, .external_lex_state = 2},
  [3628] = {.lex_state = 35, .external_lex_state = 2},
  [3629] = {.lex_state = 35, .external_lex_state = 2},
  [3630] = {.lex_state = 35},
  [3631] = {.lex_state = 35},
  [3632] = {.lex_state = 35, .external_lex_state = 2},
  [3633] = {.lex_state = 35},
  [3634] = {.lex_state = 35, .external_lex_state = 2},
  [3635] = {.lex_state = 35, .external_lex_state = 2},
  [3636] = {.lex_state = 35, .external_lex_state = 2},
  [3637] = {.lex_state = 35},
  [3638] = {.lex_state = 35, .external_lex_state = 2},
  [3639] = {.lex_state = 35, .external_lex_state = 2},
  [3640] = {.lex_state = 35},
  [3641] = {.lex_state = 35, .external_lex_state = 2},
  [3642] = {.lex_state = 35, .external_lex_state = 2},
  [3643] = {.lex_state = 35},
  [3644] = {.lex_state = 35},
  [3645] = {.lex_state = 35},
  [3646] = {.lex_state = 35},
  [3647] = {.lex_state = 35},
  [3648] = {.lex_state = 35},
  [3649] = {.lex_state = 35, .external_lex_state = 2},
  [3650] = {.lex_state = 35},
  [3651] = {.lex_state = 35, .external_lex_state = 2},
  [3652] = {.lex_state = 35, .external_lex_state = 2},
  [3653] = {.lex_state = 35, .external_lex_state = 2},
  [3654] = {.lex_state = 35, .external_lex_state = 2},
  [3655] = {.lex_state = 35, .external_lex_state = 2},
  [3656] = {.lex_state = 35},
  [3657] = {.lex_state = 35, .external_lex_state = 2},
  [3658] = {.lex_state = 35, .external_lex_state = 2},
  [3659] = {.lex_state = 35},
  [3660] = {.lex_state = 35},
  [3661] = {.lex_state = 35},
  [3662] = {.lex_state = 35},
  [3663] = {.lex_state = 35, .external_lex_state = 2},
  [3664] = {.lex_state = 35, .external_lex_state = 2},
  [3665] = {.lex_state = 35},
  [3666] = {.lex_state = 35},
  [3667] = {.lex_state = 35},
  [3668] = {.lex_state = 35},
  [3669] = {.lex_state = 35},
  [3670] = {.lex_state = 35, .external_lex_state = 2},
  [3671] = {.lex_state = 35},
  [3672] = {.lex_state = 35},
  [3673] = {.lex_state = 35, .external_lex_state = 2},
  [3674] = {.lex_state = 35},
  [3675] = {.lex_state = 35},
  [3676] = {.lex_state = 35},
  [3677] = {.lex_state = 35, .external_lex_state = 2},
  [3678] = {.lex_state = 35, .external_lex_state = 2},
  [3679] = {.lex_state = 35, .external_lex_state = 2},
  [3680] = {.lex_state = 35},
  [3681] = {.lex_state = 35, .external_lex_state = 2},
  [3682] = {.lex_state = 35, .external_lex_state = 2},
  [3683] = {.lex_state = 35, .external_lex_state = 2},
  [3684] = {.lex_state = 35, .external_lex_state = 2},
  [3685] = {.lex_state = 35},
  [3686] = {.lex_state = 35, .external_lex_state = 2},
  [3687] = {.lex_state = 35, .external_lex_state = 2},
  [3688] = {.lex_state = 35},
  [3689] = {.lex_state = 35},
  [3690] = {.lex_state = 35, .external_lex_state = 2},
  [3691] = {.lex_state = 35},
  [3692] = {.lex_state = 35, .external_lex_state = 2},
  [3693] = {.lex_state = 35},
  [3694] = {.lex_state = 35, .external_lex_state = 2},
  [3695] = {.lex_state = 35},
  [3696] = {.lex_state = 35, .external_lex_state = 2},
  [3697] = {.lex_state = 35, .external_lex_state = 2},
  [3698] = {.lex_state = 35},
  [3699] = {.lex_state = 35},
  [3700] = {.lex_state = 35},
  [3701] = {.lex_state = 35},
  [3702] = {.lex_state = 35, .external_lex_state = 2},
  [3703] = {.lex_state = 35, .external_lex_state = 2},
  [3704] = {.lex_state = 35},
  [3705] = {.lex_state = 35},
  [3706] = {.lex_state = 35, .external_lex_state = 2},
  [3707] = {.lex_state = 35, .external_lex_state = 2},
  [3708] = {.lex_state = 35, .external_lex_state = 2},
  [3709] = {.lex_state = 35},
  [3710] = {.lex_state = 35},
  [3711] = {.lex_state = 35, .external_lex_state = 2},
  [3712] = {.lex_state = 35, .external_lex_state = 2},
  [3713] = {.lex_state = 35, .external_lex_state = 2},
  [3714] = {.lex_state = 35, .external_lex_state = 2},
  [3715] = {.lex_state = 35, .external_lex_state = 2},
  [3716] = {.lex_state = 35, .external_lex_state = 2},
  [3717] = {.lex_state = 35},
  [3718] = {.lex_state = 35, .external_lex_state = 2},
  [3719] = {.lex_state = 35},
  [3720] = {.lex_state = 35, .external_lex_state = 2},
  [3721] = {.lex_state = 35},
  [3722] = {.lex_state = 35},
  [3723] = {.lex_state = 35},
  [3724] = {.lex_state = 35},
  [3725] = {.lex_state = 35},
  [3726] = {.lex_state = 35},
  [3727] = {.lex_state = 35, .external_lex_state = 2},
  [3728] = {.lex_state = 35},
  [3729] = {.lex_state = 35, .external_lex_state = 2},
  [3730] = {.lex_state = 35},
  [3731] = {.lex_state = 35},
  [3732] = {.lex_state = 35, .external_lex_state = 2},
  [3733] = {.lex_state = 35},
  [3734] = {.lex_state = 35},
  [3735] = {.lex_state = 35},
  [3736] = {.lex_state = 35},
  [3737] = {.lex_state = 35},
  [3738] = {.lex_state = 35},
  [3739] = {.lex_state = 35, .external_lex_state = 2},
  [3740] = {.lex_state = 35},
  [3741] = {.lex_state = 35},
  [3742] = {.lex_state = 35, .external_lex_state = 2},
  [3743] = {.lex_state = 35, .external_lex_state = 2},
  [3744] = {.lex_state = 35},
  [3745] = {.lex_state = 35},
  [3746] = {.lex_state = 35},
  [3747] = {.lex_state = 35, .external_lex_state = 2},
  [3748] = {.lex_state = 35},
  [3749] = {.lex_state = 35, .external_lex_state = 2},
  [3750] = {.lex_state = 35},
  [3751] = {.lex_state = 35},
  [3752] = {.lex_state = 35},
  [3753] = {.lex_state = 35, .external_lex_state = 2},
  [3754] = {.lex_state = 35},
  [3755] = {.lex_state = 35},
  [3756] = {.lex_state = 35, .external_lex_state = 2},
  [3757] = {.lex_state = 35, .external_lex_state = 2},
  [3758] = {.lex_state = 35, .external_lex_state = 2},
  [3759] = {.lex_state = 35, .external_lex_state = 2},
  [3760] = {.lex_state = 35},
  [3761] = {.lex_state = 35},
  [3762] = {.lex_state = 35},
  [3763] = {.lex_state = 35},
  [3764] = {.lex_state = 35},
  [3765] = {.lex_state = 35},
  [3766] = {.lex_state = 35},
  [3767] = {.lex_state = 35},
  [3768] = {.lex_state = 35},
  [3769] = {.lex_state = 35, .external_lex_state = 2},
  [3770] = {.lex_state = 35},
  [3771] = {.lex_state = 35, .external_lex_state = 2},
  [3772] = {.lex_state = 35},
  [3773] = {.lex_state = 35},
  [3774] = {.lex_state = 35},
  [3775] = {.lex_state = 35},
  [3776] = {.lex_state = 35},
  [3777] = {.lex_state = 35},
  [3778] = {.lex_state = 35},
  [3779] = {.lex_state = 35},
  [3780] = {.lex_state = 35, .external_lex_state = 2},
  [3781] = {.lex_state = 35, .external_lex_state = 2},
  [3782] = {.lex_state = 35},
  [3783] = {.lex_state = 35},
  [3784] = {.lex_state = 35, .external_lex_state = 2},
  [3785] = {.lex_state = 35},
  [3786] = {.lex_state = 35},
  [3787] = {.lex_state = 35},
  [3788] = {.lex_state = 35},
  [3789] = {.lex_state = 35, .external_lex_state = 2},
  [3790] = {.lex_state = 35},
  [3791] = {.lex_state = 35},
  [3792] = {.lex_state = 35},
  [3793] = {.lex_state = 35},
  [3794] = {.lex_state = 35},
  [3795] = {.lex_state = 35},
  [3796] = {.lex_state = 35},
  [3797] = {.lex_state = 35},
  [3798] = {.lex_state = 35},
  [3799] = {.lex_state = 35},
  [3800] = {.lex_state = 35},
  [3801] = {.lex_state = 35},
  [3802] = {.lex_state = 35},
  [3803] = {.lex_state = 35},
  [3804] = {.lex_state = 35},
  [3805] = {.lex_state = 35},
  [3806] = {.lex_state = 35},
  [3807] = {.lex_state = 35},
  [3808] = {.lex_state = 35},
  [3809] = {.lex_state = 35},
  [3810] = {.lex_state = 35},
  [3811] = {.lex_state = 35},
  [3812] = {.lex_state = 35, .external_lex_state = 2},
  [3813] = {.lex_state = 35},
  [3814] = {.lex_state = 35},
  [3815] = {.lex_state = 35, .external_lex_state = 2},
  [3816] = {.lex_state = 35, .external_lex_state = 2},
  [3817] = {.lex_state = 35},
  [3818] = {.lex_state = 35},
  [3819] = {.lex_state = 35, .external_lex_state = 2},
  [3820] = {.lex_state = 35},
  [3821] = {.lex_state = 35},
  [3822] = {.lex_state = 35},
  [3823] = {.lex_state = 35},
  [3824] = {.lex_state = 35},
  [3825] = {.lex_state = 35, .external_lex_state = 2},
  [3826] = {.lex_state = 35},
  [3827] = {.lex_state = 35},
  [3828] = {.lex_state = 35, .external_lex_state = 2},
  [3829] = {.lex_state = 35},
  [3830] = {.lex_state = 35, .external_lex_state = 2},
  [3831] = {.lex_state = 35},
  [3832] = {.lex_state = 35, .external_lex_state = 2},
  [3833] = {.lex_state = 35},
  [3834] = {.lex_state = 35, .external_lex_state = 2},
  [3835] = {.lex_state = 35, .external_lex_state = 2},
  [3836] = {.lex_state = 35},
  [3837] = {.lex_state = 35, .external_lex_state = 2},
  [3838] = {.lex_state = 35},
  [3839] = {.lex_state = 35, .external_lex_state = 2},
  [3840] = {.lex_state = 35, .external_lex_state = 2},
  [3841] = {.lex_state = 35, .external_lex_state = 2},
  [3842] = {.lex_state = 35, .external_lex_state = 2},
  [3843] = {.lex_state = 35, .external_lex_state = 2},
  [3844] = {.lex_state = 35, .external_lex_state = 2},
  [3845] = {.lex_state = 35, .external_lex_state = 2},
  [3846] = {.lex_state = 35, .external_lex_state = 2},
  [3847] = {.lex_state = 35, .external_lex_state = 2},
  [3848] = {.lex_state = 35, .external_lex_state = 2},
  [3849] = {.lex_state = 35},
  [3850] = {.lex_state = 35},
  [3851] = {.lex_state = 35, .external_lex_state = 2},
  [3852] = {.lex_state = 35, .external_lex_state = 2},
  [3853] = {.lex_state = 35, .external_lex_state = 2},
  [3854] = {.lex_state = 35, .external_lex_state = 2},
  [3855] = {.lex_state = 35, .external_lex_state = 2},
  [3856] = {.lex_state = 35, .external_lex_state = 2},
  [3857] = {.lex_state = 35, .external_lex_state = 2},
  [3858] = {.lex_state = 35},
  [3859] = {.lex_state = 35, .external_lex_state = 2},
  [3860] = {.lex_state = 35},
  [3861] = {.lex_state = 35, .external_lex_state = 2},
  [3862] = {.lex_state = 35},
  [3863] = {.lex_state = 35, .external_lex_state = 2},
  [3864] = {.lex_state = 35},
  [3865] = {.lex_state = 35, .external_lex_state = 2},
  [3866] = {.lex_state = 35},
  [3867] = {.lex_state = 35},
  [3868] = {.lex_state = 35, .external_lex_state = 2},
  [3869] = {.lex_state = 35},
  [3870] = {.lex_state = 35, .external_lex_state = 2},
  [3871] = {.lex_state = 35, .external_lex_state = 2},
  [3872] = {.lex_state = 35, .external_lex_state = 2},
  [3873] = {.lex_state = 35, .external_lex_state = 2},
  [3874] = {.lex_state = 35, .external_lex_state = 2},
  [3875] = {.lex_state = 35},
  [3876] = {.lex_state = 35, .external_lex_state = 2},
  [3877] = {.lex_state = 35},
  [3878] = {.lex_state = 35},
  [3879] = {.lex_state = 35},
  [3880] = {.lex_state = 35, .external_lex_state = 2},
  [3881] = {.lex_state = 35},
  [3882] = {.lex_state = 35},
  [3883] = {.lex_state = 35, .external_lex_state = 2},
  [3884] = {.lex_state = 35, .external_lex_state = 2},
  [3885] = {.lex_state = 35},
  [3886] = {.lex_state = 35, .external_lex_state = 2},
  [3887] = {.lex_state = 35, .external_lex_state = 2},
  [3888] = {.lex_state = 35, .external_lex_state = 2},
  [3889] = {.lex_state = 35},
  [3890] = {.lex_state = 35, .external_lex_state = 2},
  [3891] = {.lex_state = 35, .external_lex_state = 2},
  [3892] = {.lex_state = 35},
  [3893] = {.lex_state = 35},
  [3894] = {.lex_state = 35},
  [3895] = {.lex_state = 35},
  [3896] = {.lex_state = 35, .external_lex_state = 2},
  [3897] = {.lex_state = 35, .external_lex_state = 2},
  [3898] = {.lex_state = 35},
  [3899] = {.lex_state = 35},
  [3900] = {.lex_state = 35},
  [3901] = {.lex_state = 35, .external_lex_state = 2},
  [3902] = {.lex_state = 35},
  [3903] = {.lex_state = 35, .external_lex_state = 2},
  [3904] = {.lex_state = 35, .external_lex_state = 2},
  [3905] = {.lex_state = 35, .external_lex_state = 2},
  [3906] = {.lex_state = 35, .external_lex_state = 2},
  [3907] = {.lex_state = 35, .external_lex_state = 2},
  [3908] = {.lex_state = 35, .external_lex_state = 2},
  [3909] = {.lex_state = 35, .external_lex_state = 2},
  [3910] = {.lex_state = 35, .external_lex_state = 2},
  [3911] = {.lex_state = 35, .external_lex_state = 2},
  [3912] = {.lex_state = 35, .external_lex_state = 2},
  [3913] = {.lex_state = 35, .external_lex_state = 2},
  [3914] = {.lex_state = 35},
  [3915] = {.lex_state = 35, .external_lex_state = 2},
  [3916] = {.lex_state = 35, .external_lex_state = 2},
  [3917] = {.lex_state = 35},
  [3918] = {.lex_state = 35},
  [3919] = {.lex_state = 35, .external_lex_state = 2},
  [3920] = {.lex_state = 35},
  [3921] = {.lex_state = 35},
  [3922] = {.lex_state = 35, .external_lex_state = 2},
  [3923] = {.lex_state = 35},
  [3924] = {.lex_state = 35, .external_lex_state = 2},
  [3925] = {.lex_state = 35, .external_lex_state = 2},
  [3926] = {.lex_state = 35},
  [3927] = {.lex_state = 35},
  [3928] = {.lex_state = 35},
  [3929] = {.lex_state = 33, .external_lex_state = 2},
  [3930] = {.lex_state = 35},
  [3931] = {.lex_state = 35, .external_lex_state = 2},
  [3932] = {.lex_state = 35, .external_lex_state = 2},
  [3933] = {.lex_state = 35, .external_lex_state = 2},
  [3934] = {.lex_state = 35},
  [3935] = {.lex_state = 35, .external_lex_state = 2},
  [3936] = {.lex_state = 35, .external_lex_state = 2},
  [3937] = {.lex_state = 35},
  [3938] = {.lex_state = 35, .external_lex_state = 2},
  [3939] = {.lex_state = 35},
  [3940] = {.lex_state = 35},
  [3941] = {.lex_state = 35},
  [3942] = {.lex_state = 35},
  [3943] = {.lex_state = 35},
  [3944] = {.lex_state = 35, .external_lex_state = 2},
  [3945] = {.lex_state = 35, .external_lex_state = 2},
  [3946] = {.lex_state = 35},
  [3947] = {.lex_state = 35},
  [3948] = {.lex_state = 35, .external_lex_state = 2},
  [3949] = {.lex_state = 35},
  [3950] = {.lex_state = 35, .external_lex_state = 2},
  [3951] = {.lex_state = 35},
  [3952] = {.lex_state = 35},
  [3953] = {.lex_state = 35, .external_lex_state = 2},
  [3954] = {.lex_state = 35},
  [3955] = {.lex_state = 35},
  [3956] = {.lex_state = 35, .external_lex_state = 2},
  [3957] = {.lex_state = 35},
  [3958] = {.lex_state = 35},
  [3959] = {.lex_state = 35},
  [3960] = {.lex_state = 35, .external_lex_state = 2},
  [3961] = {.lex_state = 35, .external_lex_state = 2},
  [3962] = {.lex_state = 35, .external_lex_state = 2},
  [3963] = {.lex_state = 35, .external_lex_state = 2},
  [3964] = {.lex_state = 35},
  [3965] = {.lex_state = 35},
  [3966] = {.lex_state = 35, .external_lex_state = 2},
  [3967] = {.lex_state = 35, .external_lex_state = 2},
  [3968] = {.lex_state = 35},
  [3969] = {.lex_state = 35, .external_lex_state = 2},
  [3970] = {.lex_state = 35},
  [3971] = {.lex_state = 35, .external_lex_state = 2},
  [3972] = {.lex_state = 35, .external_lex_state = 2},
  [3973] = {.lex_state = 35, .external_lex_state = 2},
  [3974] = {.lex_state = 35, .external_lex_state = 2},
  [3975] = {.lex_state = 35, .external_lex_state = 2},
  [3976] = {.lex_state = 35, .external_lex_state = 2},
  [3977] = {.lex_state = 35},
  [3978] = {.lex_state = 35, .external_lex_state = 2},
  [3979] = {.lex_state = 35},
  [3980] = {.lex_state = 35, .external_lex_state = 2},
  [3981] = {.lex_state = 35, .external_lex_state = 2},
  [3982] = {.lex_state = 35, .external_lex_state = 2},
  [3983] = {.lex_state = 35},
  [3984] = {.lex_state = 35},
  [3985] = {.lex_state = 35, .external_lex_state = 2},
  [3986] = {.lex_state = 35},
  [3987] = {.lex_state = 35, .external_lex_state = 2},
  [3988] = {.lex_state = 35},
  [3989] = {.lex_state = 35, .external_lex_state = 2},
  [3990] = {.lex_state = 35, .external_lex_state = 2},
  [3991] = {.lex_state = 35},
  [3992] = {.lex_state = 35, .external_lex_state = 2},
  [3993] = {.lex_state = 35, .external_lex_state = 2},
  [3994] = {.lex_state = 35, .external_lex_state = 2},
  [3995] = {.lex_state = 35, .external_lex_state = 2},
  [3996] = {.lex_state = 35, .external_lex_state = 2},
  [3997] = {.lex_state = 35, .external_lex_state = 2},
  [3998] = {.lex_state = 35, .external_lex_state = 2},
  [3999] = {.lex_state = 35, .external_lex_state = 2},
  [4000] = {.lex_state = 35, .external_lex_state = 2},
  [4001] = {.lex_state = 35},
  [4002] = {.lex_state = 35, .external_lex_state = 2},
  [4003] = {.lex_state = 35, .external_lex_state = 2},
  [4004] = {.lex_state = 35, .external_lex_state = 2},
  [4005] = {.lex_state = 35, .external_lex_state = 2},
  [4006] = {.lex_state = 35},
  [4007] = {.lex_state = 35},
  [4008] = {.lex_state = 35, .external_lex_state = 2},
  [4009] = {.lex_state = 35, .external_lex_state = 2},
  [4010] = {.lex_state = 35, .external_lex_state = 2},
  [4011] = {.lex_state = 35},
  [4012] = {.lex_state = 35},
  [4013] = {.lex_state = 35, .external_lex_state = 2},
  [4014] = {.lex_state = 35},
  [4015] = {.lex_state = 35},
  [4016] = {.lex_state = 35},
  [4017] = {.lex_state = 35, .external_lex_state = 2},
  [4018] = {.lex_state = 35},
  [4019] = {.lex_state = 35},
  [4020] = {.lex_state = 35},
  [4021] = {.lex_state = 35, .external_lex_state = 2},
  [4022] = {.lex_state = 35},
  [4023] = {.lex_state = 35},
  [4024] = {.lex_state = 35, .external_lex_state = 2},
  [4025] = {.lex_state = 35},
  [4026] = {.lex_state = 35},
  [4027] = {.lex_state = 35, .external_lex_state = 2},
  [4028] = {.lex_state = 35},
  [4029] = {.lex_state = 35, .external_lex_state = 2},
  [4030] = {.lex_state = 35},
  [4031] = {.lex_state = 35, .external_lex_state = 2},
  [4032] = {.lex_state = 35, .external_lex_state = 2},
  [4033] = {.lex_state = 35},
  [4034] = {.lex_state = 35},
  [4035] = {.lex_state = 35},
  [4036] = {.lex_state = 35, .external_lex_state = 2},
  [4037] = {.lex_state = 35, .external_lex_state = 2},
  [4038] = {.lex_state = 35, .external_lex_state = 2},
  [4039] = {.lex_state = 35, .external_lex_state = 2},
  [4040] = {.lex_state = 35, .external_lex_state = 2},
  [4041] = {.lex_state = 35},
  [4042] = {.lex_state = 35, .external_lex_state = 2},
  [4043] = {.lex_state = 35, .external_lex_state = 2},
  [4044] = {.lex_state = 35},
  [4045] = {.lex_state = 35, .external_lex_state = 2},
  [4046] = {.lex_state = 35, .external_lex_state = 2},
  [4047] = {.lex_state = 35, .external_lex_state = 2},
  [4048] = {.lex_state = 35},
  [4049] = {.lex_state = 35, .external_lex_state = 2},
  [4050] = {.lex_state = 35},
  [4051] = {.lex_state = 35},
  [4052] = {.lex_state = 35},
  [4053] = {.lex_state = 35},
  [4054] = {.lex_state = 35},
  [4055] = {.lex_state = 35},
  [4056] = {.lex_state = 35, .external_lex_state = 2},
  [4057] = {.lex_state = 35, .external_lex_state = 2},
  [4058] = {.lex_state = 35, .external_lex_state = 2},
  [4059] = {.lex_state = 35, .external_lex_state = 2},
  [4060] = {.lex_state = 35, .external_lex_state = 2},
  [4061] = {.lex_state = 35, .external_lex_state = 2},
  [4062] = {.lex_state = 35, .external_lex_state = 2},
  [4063] = {.lex_state = 35, .external_lex_state = 2},
  [4064] = {.lex_state = 35, .external_lex_state = 2},
  [4065] = {.lex_state = 35, .external_lex_state = 2},
  [4066] = {.lex_state = 35},
  [4067] = {.lex_state = 35, .external_lex_state = 2},
  [4068] = {.lex_state = 35, .external_lex_state = 2},
  [4069] = {.lex_state = 35, .external_lex_state = 2},
  [4070] = {.lex_state = 35, .external_lex_state = 2},
  [4071] = {.lex_state = 35},
  [4072] = {.lex_state = 35},
  [4073] = {.lex_state = 35, .external_lex_state = 2},
  [4074] = {.lex_state = 35, .external_lex_state = 2},
  [4075] = {.lex_state = 35},
  [4076] = {.lex_state = 35},
  [4077] = {.lex_state = 35},
  [4078] = {.lex_state = 35},
  [4079] = {.lex_state = 35},
  [4080] = {.lex_state = 35},
  [4081] = {.lex_state = 35},
  [4082] = {.lex_state = 35, .external_lex_state = 2},
  [4083] = {.lex_state = 35},
  [4084] = {.lex_state = 35},
  [4085] = {.lex_state = 35, .external_lex_state = 2},
  [4086] = {.lex_state = 35},
  [4087] = {.lex_state = 35},
  [4088] = {.lex_state = 35},
  [4089] = {.lex_state = 35},
  [4090] = {.lex_state = 35, .external_lex_state = 2},
  [4091] = {.lex_state = 35, .external_lex_state = 2},
  [4092] = {.lex_state = 35, .external_lex_state = 2},
  [4093] = {.lex_state = 35},
  [4094] = {.lex_state = 35},
  [4095] = {.lex_state = 35, .external_lex_state = 2},
  [4096] = {.lex_state = 35, .external_lex_state = 2},
  [4097] = {.lex_state = 35},
  [4098] = {.lex_state = 35},
  [4099] = {.lex_state = 35},
  [4100] = {.lex_state = 35},
  [4101] = {.lex_state = 35},
  [4102] = {.lex_state = 35, .external_lex_state = 2},
  [4103] = {.lex_state = 35},
  [4104] = {.lex_state = 35},
  [4105] = {.lex_state = 35, .external_lex_state = 2},
  [4106] = {.lex_state = 35},
  [4107] = {.lex_state = 35, .external_lex_state = 2},
  [4108] = {.lex_state = 35, .external_lex_state = 2},
  [4109] = {.lex_state = 35},
  [4110] = {.lex_state = 35},
  [4111] = {.lex_state = 35, .external_lex_state = 2},
  [4112] = {.lex_state = 35},
  [4113] = {.lex_state = 35},
  [4114] = {.lex_state = 35, .external_lex_state = 2},
  [4115] = {.lex_state = 35},
  [4116] = {.lex_state = 35, .external_lex_state = 2},
  [4117] = {.lex_state = 35},
  [4118] = {.lex_state = 35, .external_lex_state = 2},
  [4119] = {.lex_state = 35, .external_lex_state = 2},
  [4120] = {.lex_state = 35},
  [4121] = {.lex_state = 35, .external_lex_state = 2},
  [4122] = {.lex_state = 35},
  [4123] = {.lex_state = 35},
  [4124] = {.lex_state = 35},
  [4125] = {.lex_state = 35, .external_lex_state = 2},
  [4126] = {.lex_state = 35, .external_lex_state = 2},
  [4127] = {.lex_state = 35, .external_lex_state = 2},
  [4128] = {.lex_state = 35, .external_lex_state = 2},
  [4129] = {.lex_state = 35},
  [4130] = {.lex_state = 35},
  [4131] = {.lex_state = 35},
  [4132] = {.lex_state = 35},
  [4133] = {.lex_state = 35},
  [4134] = {.lex_state = 35, .external_lex_state = 2},
  [4135] = {.lex_state = 35},
  [4136] = {.lex_state = 35, .external_lex_state = 2},
  [4137] = {.lex_state = 35, .external_lex_state = 2},
  [4138] = {.lex_state = 35, .external_lex_state = 2},
  [4139] = {.lex_state = 35, .external_lex_state = 2},
  [4140] = {.lex_state = 35, .external_lex_state = 2},
  [4141] = {.lex_state = 35, .external_lex_state = 2},
  [4142] = {.lex_state = 35, .external_lex_state = 2},
  [4143] = {.lex_state = 35},
  [4144] = {.lex_state = 35, .external_lex_state = 2},
  [4145] = {.lex_state = 35, .external_lex_state = 2},
  [4146] = {.lex_state = 35, .external_lex_state = 2},
  [4147] = {.lex_state = 35, .external_lex_state = 2},
  [4148] = {.lex_state = 35, .external_lex_state = 2},
  [4149] = {.lex_state = 35, .external_lex_state = 2},
  [4150] = {.lex_state = 35, .external_lex_state = 2},
  [4151] = {.lex_state = 35, .external_lex_state = 2},
  [4152] = {.lex_state = 35, .external_lex_state = 2},
  [4153] = {.lex_state = 35},
  [4154] = {.lex_state = 35},
  [4155] = {.lex_state = 35, .external_lex_state = 2},
  [4156] = {.lex_state = 35, .external_lex_state = 2},
  [4157] = {.lex_state = 35, .external_lex_state = 2},
  [4158] = {.lex_state = 35, .external_lex_state = 2},
  [4159] = {.lex_state = 35, .external_lex_state = 2},
  [4160] = {.lex_state = 35, .external_lex_state = 2},
  [4161] = {.lex_state = 35, .external_lex_state = 2},
  [4162] = {.lex_state = 35, .external_lex_state = 2},
  [4163] = {.lex_state = 35},
  [4164] = {.lex_state = 35},
  [4165] = {.lex_state = 35, .external_lex_state = 2},
  [4166] = {.lex_state = 35},
  [4167] = {.lex_state = 35},
  [4168] = {.lex_state = 35, .external_lex_state = 2},
  [4169] = {.lex_state = 35},
  [4170] = {.lex_state = 35},
  [4171] = {.lex_state = 35, .external_lex_state = 2},
  [4172] = {.lex_state = 35},
  [4173] = {.lex_state = 35},
  [4174] = {.lex_state = 35},
  [4175] = {.lex_state = 35},
  [4176] = {.lex_state = 35, .external_lex_state = 2},
  [4177] = {.lex_state = 35, .external_lex_state = 2},
  [4178] = {.lex_state = 35},
  [4179] = {.lex_state = 35},
  [4180] = {.lex_state = 35, .external_lex_state = 2},
  [4181] = {.lex_state = 35, .external_lex_state = 2},
  [4182] = {.lex_state = 35, .external_lex_state = 2},
  [4183] = {.lex_state = 35},
  [4184] = {.lex_state = 35},
  [4185] = {.lex_state = 35},
  [4186] = {.lex_state = 35},
  [4187] = {.lex_state = 35, .external_lex_state = 2},
  [4188] = {.lex_state = 35},
  [4189] = {.lex_state = 35, .external_lex_state = 2},
  [4190] = {.lex_state = 35},
  [4191] = {.lex_state = 35},
  [4192] = {.lex_state = 35, .external_lex_state = 2},
  [4193] = {.lex_state = 35, .external_lex_state = 2},
  [4194] = {.lex_state = 35},
  [4195] = {.lex_state = 35},
  [4196] = {.lex_state = 33, .external_lex_state = 2},
  [4197] = {.lex_state = 35},
  [4198] = {.lex_state = 35, .external_lex_state = 2},
  [4199] = {.lex_state = 35},
  [4200] = {.lex_state = 35},
  [4201] = {.lex_state = 35},
  [4202] = {.lex_state = 35},
  [4203] = {.lex_state = 35},
  [4204] = {.lex_state = 35, .external_lex_state = 2},
  [4205] = {.lex_state = 35, .external_lex_state = 2},
  [4206] = {.lex_state = 35, .external_lex_state = 2},
  [4207] = {.lex_state = 35, .external_lex_state = 2},
  [4208] = {.lex_state = 35},
  [4209] = {.lex_state = 35},
  [4210] = {.lex_state = 35},
  [4211] = {.lex_state = 35, .external_lex_state = 2},
  [4212] = {.lex_state = 35, .external_lex_state = 2},
  [4213] = {.lex_state = 35, .external_lex_state = 2},
  [4214] = {.lex_state = 35},
  [4215] = {.lex_state = 35, .external_lex_state = 2},
  [4216] = {.lex_state = 35, .external_lex_state = 2},
  [4217] = {.lex_state = 35, .external_lex_state = 2},
  [4218] = {.lex_state = 35},
  [4219] = {.lex_state = 35, .external_lex_state = 2},
  [4220] = {.lex_state = 35, .external_lex_state = 2},
  [4221] = {.lex_state = 35},
  [4222] = {.lex_state = 35},
  [4223] = {.lex_state = 35, .external_lex_state = 2},
  [4224] = {.lex_state = 35, .external_lex_state = 2},
  [4225] = {.lex_state = 35, .external_lex_state = 2},
  [4226] = {.lex_state = 35, .external_lex_state = 2},
  [4227] = {.lex_state = 35, .external_lex_state = 2},
  [4228] = {.lex_state = 35},
  [4229] = {.lex_state = 35},
  [4230] = {.lex_state = 35},
  [4231] = {.lex_state = 35},
  [4232] = {.lex_state = 35},
  [4233] = {.lex_state = 35},
  [4234] = {.lex_state = 35, .external_lex_state = 2},
  [4235] = {.lex_state = 35},
  [4236] = {.lex_state = 35},
  [4237] = {.lex_state = 35, .external_lex_state = 2},
  [4238] = {.lex_state = 35},
  [4239] = {.lex_state = 35},
  [4240] = {.lex_state = 35},
  [4241] = {.lex_state = 35},
  [4242] = {.lex_state = 35, .external_lex_state = 2},
  [4243] = {.lex_state = 35},
  [4244] = {.lex_state = 35, .external_lex_state = 2},
  [4245] = {.lex_state = 35},
  [4246] = {.lex_state = 35},
  [4247] = {.lex_state = 35},
  [4248] = {.lex_state = 35, .external_lex_state = 2},
  [4249] = {.lex_state = 35},
  [4250] = {.lex_state = 35, .external_lex_state = 2},
  [4251] = {.lex_state = 35, .external_lex_state = 2},
  [4252] = {.lex_state = 35, .external_lex_state = 2},
  [4253] = {.lex_state = 35, .external_lex_state = 2},
  [4254] = {.lex_state = 35, .external_lex_state = 2},
  [4255] = {.lex_state = 35},
  [4256] = {.lex_state = 35, .external_lex_state = 2},
  [4257] = {.lex_state = 35, .external_lex_state = 2},
  [4258] = {.lex_state = 35, .external_lex_state = 2},
  [4259] = {.lex_state = 35, .external_lex_state = 2},
  [4260] = {.lex_state = 35, .external_lex_state = 2},
  [4261] = {.lex_state = 35, .external_lex_state = 2},
  [4262] = {.lex_state = 35},
  [4263] = {.lex_state = 35},
  [4264] = {.lex_state = 35, .external_lex_state = 2},
  [4265] = {.lex_state = 35},
  [4266] = {.lex_state = 35},
  [4267] = {.lex_state = 35},
  [4268] = {.lex_state = 35},
  [4269] = {.lex_state = 35, .external_lex_state = 2},
  [4270] = {.lex_state = 35, .external_lex_state = 2},
  [4271] = {.lex_state = 35},
  [4272] = {.lex_state = 35},
  [4273] = {.lex_state = 35, .external_lex_state = 2},
  [4274] = {.lex_state = 35},
  [4275] = {.lex_state = 35},
  [4276] = {.lex_state = 35, .external_lex_state = 2},
  [4277] = {.lex_state = 35, .external_lex_state = 2},
  [4278] = {.lex_state = 35, .external_lex_state = 2},
  [4279] = {.lex_state = 35},
  [4280] = {.lex_state = 35},
  [4281] = {.lex_state = 35, .external_lex_state = 2},
  [4282] = {.lex_state = 35},
  [4283] = {.lex_state = 35},
  [4284] = {.lex_state = 35},
  [4285] = {.lex_state = 35},
  [4286] = {.lex_state = 35},
  [4287] = {.lex_state = 35, .external_lex_state = 2},
  [4288] = {.lex_state = 35, .external_lex_state = 2},
  [4289] = {.lex_state = 35},
  [4290] = {.lex_state = 35, .external_lex_state = 2},
  [4291] = {.lex_state = 35, .external_lex_state = 2},
  [4292] = {.lex_state = 35, .external_lex_state = 2},
  [4293] = {.lex_state = 35},
  [4294] = {.lex_state = 35},
  [4295] = {.lex_state = 35, .external_lex_state = 2},
  [4296] = {.lex_state = 35},
  [4297] = {.lex_state = 35},
  [4298] = {.lex_state = 35},
  [4299] = {.lex_state = 35, .external_lex_state = 2},
  [4300] = {.lex_state = 35, .external_lex_state = 2},
  [4301] = {.lex_state = 35, .external_lex_state = 2},
  [4302] = {.lex_state = 35, .external_lex_state = 2},
  [4303] = {.lex_state = 35, .external_lex_state = 2},
  [4304] = {.lex_state = 35},
  [4305] = {.lex_state = 35, .external_lex_state = 2},
  [4306] = {.lex_state = 35, .external_lex_state = 2},
  [4307] = {.lex_state = 35},
  [4308] = {.lex_state = 35, .external_lex_state = 2},
  [4309] = {.lex_state = 35},
  [4310] = {.lex_state = 35, .external_lex_state = 2},
  [4311] = {.lex_state = 35, .external_lex_state = 2},
  [4312] = {.lex_state = 35, .external_lex_state = 2},
  [4313] = {.lex_state = 35},
  [4314] = {.lex_state = 35, .external_lex_state = 2},
  [4315] = {.lex_state = 35},
  [4316] = {.lex_state = 35, .external_lex_state = 2},
  [4317] = {.lex_state = 35},
  [4318] = {.lex_state = 35, .external_lex_state = 2},
  [4319] = {.lex_state = 35, .external_lex_state = 2},
  [4320] = {.lex_state = 35, .external_lex_state = 2},
  [4321] = {.lex_state = 35, .external_lex_state = 2},
  [4322] = {.lex_state = 35},
  [4323] = {.lex_state = 35},
  [4324] = {.lex_state = 35, .external_lex_state = 2},
  [4325] = {.lex_state = 35},
  [4326] = {.lex_state = 35, .external_lex_state = 2},
  [4327] = {.lex_state = 35},
  [4328] = {.lex_state = 35, .external_lex_state = 2},
  [4329] = {.lex_state = 35},
  [4330] = {.lex_state = 35},
  [4331] = {.lex_state = 35, .external_lex_state = 2},
  [4332] = {.lex_state = 35, .external_lex_state = 2},
  [4333] = {.lex_state = 35, .external_lex_state = 2},
  [4334] = {.lex_state = 35, .external_lex_state = 2},
  [4335] = {.lex_state = 35, .external_lex_state = 2},
  [4336] = {.lex_state = 35},
  [4337] = {.lex_state = 35, .external_lex_state = 2},
  [4338] = {.lex_state = 35},
  [4339] = {.lex_state = 35},
  [4340] = {.lex_state = 35},
  [4341] = {.lex_state = 35, .external_lex_state = 2},
  [4342] = {.lex_state = 35},
  [4343] = {.lex_state = 35},
  [4344] = {.lex_state = 35},
  [4345] = {.lex_state = 35},
  [4346] = {.lex_state = 35},
  [4347] = {.lex_state = 35},
  [4348] = {.lex_state = 35},
  [4349] = {.lex_state = 35},
  [4350] = {.lex_state = 35},
  [4351] = {.lex_state = 35},
  [4352] = {.lex_state = 35},
  [4353] = {.lex_state = 35},
  [4354] = {.lex_state = 35},
  [4355] = {.lex_state = 35},
  [4356] = {.lex_state = 35},
  [4357] = {.lex_state = 35, .external_lex_state = 2},
  [4358] = {.lex_state = 35},
  [4359] = {.lex_state = 35},
  [4360] = {.lex_state = 35, .external_lex_state = 2},
  [4361] = {.lex_state = 35},
  [4362] = {.lex_state = 35, .external_lex_state = 2},
  [4363] = {.lex_state = 35},
  [4364] = {.lex_state = 35},
  [4365] = {.lex_state = 35, .external_lex_state = 2},
  [4366] = {.lex_state = 35, .external_lex_state = 2},
  [4367] = {.lex_state = 35},
  [4368] = {.lex_state = 35},
  [4369] = {.lex_state = 35},
  [4370] = {.lex_state = 35},
  [4371] = {.lex_state = 35},
  [4372] = {.lex_state = 33, .external_lex_state = 2},
  [4373] = {.lex_state = 35, .external_lex_state = 2},
  [4374] = {.lex_state = 35, .external_lex_state = 2},
  [4375] = {.lex_state = 35, .external_lex_state = 2},
  [4376] = {.lex_state = 35, .external_lex_state = 2},
  [4377] = {.lex_state = 35},
  [4378] = {.lex_state = 33},
  [4379] = {.lex_state = 35, .external_lex_state = 2},
  [4380] = {.lex_state = 35},
  [4381] = {.lex_state = 35, .external_lex_state = 2},
  [4382] = {.lex_state = 35},
  [4383] = {.lex_state = 35},
  [4384] = {.lex_state = 35},
  [4385] = {.lex_state = 35, .external_lex_state = 2},
  [4386] = {.lex_state = 35, .external_lex_state = 2},
  [4387] = {.lex_state = 35, .external_lex_state = 2},
  [4388] = {.lex_state = 35, .external_lex_state = 2},
  [4389] = {.lex_state = 35, .external_lex_state = 2},
  [4390] = {.lex_state = 35, .external_lex_state = 2},
  [4391] = {.lex_state = 35, .external_lex_state = 2},
  [4392] = {.lex_state = 35, .external_lex_state = 2},
  [4393] = {.lex_state = 35, .external_lex_state = 2},
  [4394] = {.lex_state = 35},
  [4395] = {.lex_state = 35, .external_lex_state = 2},
  [4396] = {.lex_state = 35},
  [4397] = {.lex_state = 35, .external_lex_state = 2},
  [4398] = {.lex_state = 35},
  [4399] = {.lex_state = 35},
  [4400] = {.lex_state = 35},
  [4401] = {.lex_state = 35},
  [4402] = {.lex_state = 35, .external_lex_state = 2},
  [4403] = {.lex_state = 35, .external_lex_state = 2},
  [4404] = {.lex_state = 35, .external_lex_state = 2},
  [4405] = {.lex_state = 35},
  [4406] = {.lex_state = 35, .external_lex_state = 2},
  [4407] = {.lex_state = 35},
  [4408] = {.lex_state = 35},
  [4409] = {.lex_state = 35},
  [4410] = {.lex_state = 35},
  [4411] = {.lex_state = 35},
  [4412] = {.lex_state = 35, .external_lex_state = 2},
  [4413] = {.lex_state = 35},
  [4414] = {.lex_state = 35, .external_lex_state = 2},
  [4415] = {.lex_state = 35, .external_lex_state = 2},
  [4416] = {.lex_state = 35},
  [4417] = {.lex_state = 35},
  [4418] = {.lex_state = 35, .external_lex_state = 2},
  [4419] = {.lex_state = 35, .external_lex_state = 2},
  [4420] = {.lex_state = 35},
  [4421] = {.lex_state = 35},
  [4422] = {.lex_state = 35},
  [4423] = {.lex_state = 35},
  [4424] = {.lex_state = 35},
  [4425] = {.lex_state = 35, .external_lex_state = 2},
  [4426] = {.lex_state = 35, .external_lex_state = 2},
  [4427] = {.lex_state = 35},
  [4428] = {.lex_state = 35, .external_lex_state = 2},
  [4429] = {.lex_state = 35, .external_lex_state = 2},
  [4430] = {.lex_state = 35, .external_lex_state = 2},
  [4431] = {.lex_state = 35, .external_lex_state = 2},
  [4432] = {.lex_state = 35, .external_lex_state = 2},
  [4433] = {.lex_state = 35},
  [4434] = {.lex_state = 35, .external_lex_state = 2},
  [4435] = {.lex_state = 35, .external_lex_state = 2},
  [4436] = {.lex_state = 35, .external_lex_state = 2},
  [4437] = {.lex_state = 35, .external_lex_state = 2},
  [4438] = {.lex_state = 35, .external_lex_state = 2},
  [4439] = {.lex_state = 35},
  [4440] = {.lex_state = 35},
  [4441] = {.lex_state = 35, .external_lex_state = 2},
  [4442] = {.lex_state = 35},
  [4443] = {.lex_state = 35},
  [4444] = {.lex_state = 35, .external_lex_state = 2},
  [4445] = {.lex_state = 35},
  [4446] = {.lex_state = 35, .external_lex_state = 2},
  [4447] = {.lex_state = 35},
  [4448] = {.lex_state = 35, .external_lex_state = 2},
  [4449] = {.lex_state = 35, .external_lex_state = 2},
  [4450] = {.lex_state = 35, .external_lex_state = 2},
  [4451] = {.lex_state = 35, .external_lex_state = 2},
  [4452] = {.lex_state = 35, .external_lex_state = 2},
  [4453] = {.lex_state = 35, .external_lex_state = 2},
  [4454] = {.lex_state = 35, .external_lex_state = 2},
  [4455] = {.lex_state = 35, .external_lex_state = 2},
  [4456] = {.lex_state = 35, .external_lex_state = 2},
  [4457] = {.lex_state = 35, .external_lex_state = 2},
  [4458] = {.lex_state = 35, .external_lex_state = 2},
  [4459] = {.lex_state = 35},
  [4460] = {.lex_state = 35},
  [4461] = {.lex_state = 35, .external_lex_state = 2},
  [4462] = {.lex_state = 35},
  [4463] = {.lex_state = 35, .external_lex_state = 2},
  [4464] = {.lex_state = 35, .external_lex_state = 2},
  [4465] = {.lex_state = 35, .external_lex_state = 2},
  [4466] = {.lex_state = 35, .external_lex_state = 2},
  [4467] = {.lex_state = 35, .external_lex_state = 2},
  [4468] = {.lex_state = 35, .external_lex_state = 2},
  [4469] = {.lex_state = 35, .external_lex_state = 2},
  [4470] = {.lex_state = 35, .external_lex_state = 2},
  [4471] = {.lex_state = 35},
  [4472] = {.lex_state = 35, .external_lex_state = 2},
  [4473] = {.lex_state = 35},
  [4474] = {.lex_state = 35},
  [4475] = {.lex_state = 35, .external_lex_state = 2},
  [4476] = {.lex_state = 35, .external_lex_state = 2},
  [4477] = {.lex_state = 35, .external_lex_state = 2},
  [4478] = {.lex_state = 35, .external_lex_state = 2},
  [4479] = {.lex_state = 35, .external_lex_state = 2},
  [4480] = {.lex_state = 35, .external_lex_state = 2},
  [4481] = {.lex_state = 35, .external_lex_state = 2},
  [4482] = {.lex_state = 35, .external_lex_state = 2},
  [4483] = {.lex_state = 35, .external_lex_state = 2},
  [4484] = {.lex_state = 35, .external_lex_state = 2},
  [4485] = {.lex_state = 35, .external_lex_state = 2},
  [4486] = {.lex_state = 35, .external_lex_state = 2},
  [4487] = {.lex_state = 35, .external_lex_state = 2},
  [4488] = {.lex_state = 35},
  [4489] = {.lex_state = 35, .external_lex_state = 2},
  [4490] = {.lex_state = 35, .external_lex_state = 2},
  [4491] = {.lex_state = 35, .external_lex_state = 2},
  [4492] = {.lex_state = 35, .external_lex_state = 2},
  [4493] = {.lex_state = 35, .external_lex_state = 2},
  [4494] = {.lex_state = 35, .external_lex_state = 2},
  [4495] = {.lex_state = 35, .external_lex_state = 2},
  [4496] = {.lex_state = 35, .external_lex_state = 2},
  [4497] = {.lex_state = 35, .external_lex_state = 2},
  [4498] = {.lex_state = 35, .external_lex_state = 2},
  [4499] = {.lex_state = 35, .external_lex_state = 2},
  [4500] = {.lex_state = 35, .external_lex_state = 2},
  [4501] = {.lex_state = 35, .external_lex_state = 2},
  [4502] = {.lex_state = 35, .external_lex_state = 2},
  [4503] = {.lex_state = 35, .external_lex_state = 2},
  [4504] = {.lex_state = 35, .external_lex_state = 2},
  [4505] = {.lex_state = 35, .external_lex_state = 2},
  [4506] = {.lex_state = 35, .external_lex_state = 2},
  [4507] = {.lex_state = 35, .external_lex_state = 2},
  [4508] = {.lex_state = 35, .external_lex_state = 2},
  [4509] = {.lex_state = 35, .external_lex_state = 2},
  [4510] = {.lex_state = 35},
  [4511] = {.lex_state = 35},
  [4512] = {.lex_state = 35, .external_lex_state = 2},
  [4513] = {.lex_state = 35, .external_lex_state = 2},
  [4514] = {.lex_state = 35, .external_lex_state = 2},
  [4515] = {.lex_state = 35, .external_lex_state = 2},
  [4516] = {.lex_state = 35, .external_lex_state = 2},
  [4517] = {.lex_state = 35, .external_lex_state = 2},
  [4518] = {.lex_state = 35, .external_lex_state = 2},
  [4519] = {.lex_state = 35},
  [4520] = {.lex_state = 35},
  [4521] = {.lex_state = 35, .external_lex_state = 2},
  [4522] = {.lex_state = 35},
  [4523] = {.lex_state = 35},
  [4524] = {.lex_state = 35, .external_lex_state = 2},
  [4525] = {.lex_state = 35},
  [4526] = {.lex_state = 35, .external_lex_state = 2},
  [4527] = {.lex_state = 35, .external_lex_state = 2},
  [4528] = {.lex_state = 35},
  [4529] = {.lex_state = 35},
  [4530] = {.lex_state = 35, .external_lex_state = 2},
  [4531] = {.lex_state = 35, .external_lex_state = 2},
  [4532] = {.lex_state = 35, .external_lex_state = 2},
  [4533] = {.lex_state = 35, .external_lex_state = 2},
  [4534] = {.lex_state = 35, .external_lex_state = 2},
  [4535] = {.lex_state = 35, .external_lex_state = 2},
  [4536] = {.lex_state = 35, .external_lex_state = 2},
  [4537] = {.lex_state = 35, .external_lex_state = 2},
  [4538] = {.lex_state = 35, .external_lex_state = 2},
  [4539] = {.lex_state = 35, .external_lex_state = 2},
  [4540] = {.lex_state = 35, .external_lex_state = 2},
  [4541] = {.lex_state = 35, .external_lex_state = 2},
  [4542] = {.lex_state = 35, .external_lex_state = 2},
  [4543] = {.lex_state = 35, .external_lex_state = 2},
  [4544] = {.lex_state = 35, .external_lex_state = 2},
  [4545] = {.lex_state = 35, .external_lex_state = 2},
  [4546] = {.lex_state = 35, .external_lex_state = 2},
  [4547] = {.lex_state = 35, .external_lex_state = 2},
  [4548] = {.lex_state = 35, .external_lex_state = 2},
  [4549] = {.lex_state = 35, .external_lex_state = 2},
  [4550] = {.lex_state = 35, .external_lex_state = 2},
  [4551] = {.lex_state = 35, .external_lex_state = 2},
  [4552] = {.lex_state = 35, .external_lex_state = 2},
  [4553] = {.lex_state = 35, .external_lex_state = 2},
  [4554] = {.lex_state = 35, .external_lex_state = 2},
  [4555] = {.lex_state = 35, .external_lex_state = 2},
  [4556] = {.lex_state = 35, .external_lex_state = 2},
  [4557] = {.lex_state = 35, .external_lex_state = 2},
  [4558] = {.lex_state = 35, .external_lex_state = 2},
  [4559] = {.lex_state = 35, .external_lex_state = 2},
  [4560] = {.lex_state = 35, .external_lex_state = 2},
  [4561] = {.lex_state = 35, .external_lex_state = 2},
  [4562] = {.lex_state = 35},
  [4563] = {.lex_state = 35, .external_lex_state = 2},
  [4564] = {.lex_state = 35, .external_lex_state = 2},
  [4565] = {.lex_state = 35, .external_lex_state = 2},
  [4566] = {.lex_state = 35},
  [4567] = {.lex_state = 35, .external_lex_state = 2},
  [4568] = {.lex_state = 35},
  [4569] = {.lex_state = 35, .external_lex_state = 2},
  [4570] = {.lex_state = 35, .external_lex_state = 2},
  [4571] = {.lex_state = 35, .external_lex_state = 2},
  [4572] = {.lex_state = 35, .external_lex_state = 2},
  [4573] = {.lex_state = 35, .external_lex_state = 2},
  [4574] = {.lex_state = 35, .external_lex_state = 2},
  [4575] = {.lex_state = 35, .external_lex_state = 2},
  [4576] = {.lex_state = 35, .external_lex_state = 2},
  [4577] = {.lex_state = 35, .external_lex_state = 2},
  [4578] = {.lex_state = 35, .external_lex_state = 2},
  [4579] = {.lex_state = 35, .external_lex_state = 2},
  [4580] = {.lex_state = 35, .external_lex_state = 2},
  [4581] = {.lex_state = 35, .external_lex_state = 2},
  [4582] = {.lex_state = 35, .external_lex_state = 2},
  [4583] = {.lex_state = 35, .external_lex_state = 2},
  [4584] = {.lex_state = 35, .external_lex_state = 2},
  [4585] = {.lex_state = 35, .external_lex_state = 2},
  [4586] = {.lex_state = 35, .external_lex_state = 2},
  [4587] = {.lex_state = 35, .external_lex_state = 2},
  [4588] = {.lex_state = 35, .external_lex_state = 2},
  [4589] = {.lex_state = 35, .external_lex_state = 2},
  [4590] = {.lex_state = 35, .external_lex_state = 2},
  [4591] = {.lex_state = 35, .external_lex_state = 2},
  [4592] = {.lex_state = 35, .external_lex_state = 2},
  [4593] = {.lex_state = 35, .external_lex_state = 2},
  [4594] = {.lex_state = 35},
  [4595] = {.lex_state = 35, .external_lex_state = 2},
  [4596] = {.lex_state = 35, .external_lex_state = 2},
  [4597] = {.lex_state = 35, .external_lex_state = 2},
  [4598] = {.lex_state = 35, .external_lex_state = 2},
  [4599] = {.lex_state = 33},
  [4600] = {.lex_state = 35, .external_lex_state = 2},
  [4601] = {.lex_state = 35, .external_lex_state = 2},
  [4602] = {.lex_state = 35, .external_lex_state = 2},
  [4603] = {.lex_state = 35, .external_lex_state = 2},
  [4604] = {.lex_state = 35, .external_lex_state = 2},
  [4605] = {.lex_state = 35, .external_lex_state = 2},
  [4606] = {.lex_state = 35},
  [4607] = {.lex_state = 35, .external_lex_state = 2},
  [4608] = {.lex_state = 35, .external_lex_state = 2},
  [4609] = {.lex_state = 35, .external_lex_state = 2},
  [4610] = {.lex_state = 35, .external_lex_state = 2},
  [4611] = {.lex_state = 35, .external_lex_state = 2},
  [4612] = {.lex_state = 35, .external_lex_state = 2},
  [4613] = {.lex_state = 35, .external_lex_state = 2},
  [4614] = {.lex_state = 35, .external_lex_state = 2},
  [4615] = {.lex_state = 35},
  [4616] = {.lex_state = 35, .external_lex_state = 2},
  [4617] = {.lex_state = 35, .external_lex_state = 2},
  [4618] = {.lex_state = 35},
  [4619] = {.lex_state = 35, .external_lex_state = 2},
  [4620] = {.lex_state = 35, .external_lex_state = 2},
  [4621] = {.lex_state = 35, .external_lex_state = 2},
  [4622] = {.lex_state = 35, .external_lex_state = 2},
  [4623] = {.lex_state = 35, .external_lex_state = 2},
  [4624] = {.lex_state = 35},
  [4625] = {.lex_state = 35, .external_lex_state = 2},
  [4626] = {.lex_state = 35, .external_lex_state = 2},
  [4627] = {.lex_state = 35, .external_lex_state = 2},
  [4628] = {.lex_state = 35, .external_lex_state = 2},
  [4629] = {.lex_state = 35, .external_lex_state = 2},
  [4630] = {.lex_state = 35, .external_lex_state = 2},
  [4631] = {.lex_state = 35, .external_lex_state = 2},
  [4632] = {.lex_state = 35, .external_lex_state = 2},
  [4633] = {.lex_state = 35, .external_lex_state = 2},
  [4634] = {.lex_state = 35, .external_lex_state = 2},
  [4635] = {.lex_state = 35, .external_lex_state = 2},
  [4636] = {.lex_state = 35, .external_lex_state = 2},
  [4637] = {.lex_state = 35, .external_lex_state = 2},
  [4638] = {.lex_state = 35, .external_lex_state = 2},
  [4639] = {.lex_state = 35, .external_lex_state = 2},
  [4640] = {.lex_state = 35, .external_lex_state = 2},
  [4641] = {.lex_state = 35, .external_lex_state = 2},
  [4642] = {.lex_state = 35, .external_lex_state = 2},
  [4643] = {.lex_state = 35, .external_lex_state = 2},
  [4644] = {.lex_state = 35, .external_lex_state = 2},
  [4645] = {.lex_state = 35, .external_lex_state = 2},
  [4646] = {.lex_state = 35, .external_lex_state = 2},
  [4647] = {.lex_state = 35, .external_lex_state = 2},
  [4648] = {.lex_state = 35, .external_lex_state = 2},
  [4649] = {.lex_state = 35, .external_lex_state = 2},
  [4650] = {.lex_state = 35},
  [4651] = {.lex_state = 35},
  [4652] = {.lex_state = 35, .external_lex_state = 2},
  [4653] = {.lex_state = 35, .external_lex_state = 2},
  [4654] = {.lex_state = 35},
  [4655] = {.lex_state = 35},
  [4656] = {.lex_state = 35, .external_lex_state = 2},
  [4657] = {.lex_state = 35},
  [4658] = {.lex_state = 35, .external_lex_state = 2},
  [4659] = {.lex_state = 35, .external_lex_state = 2},
  [4660] = {.lex_state = 35, .external_lex_state = 2},
  [4661] = {.lex_state = 35},
  [4662] = {.lex_state = 35, .external_lex_state = 2},
  [4663] = {.lex_state = 35},
  [4664] = {.lex_state = 35, .external_lex_state = 2},
  [4665] = {.lex_state = 35},
  [4666] = {.lex_state = 35, .external_lex_state = 2},
  [4667] = {.lex_state = 35, .external_lex_state = 2},
  [4668] = {.lex_state = 35, .external_lex_state = 2},
  [4669] = {.lex_state = 35, .external_lex_state = 2},
  [4670] = {.lex_state = 35},
  [4671] = {.lex_state = 35, .external_lex_state = 2},
  [4672] = {.lex_state = 35, .external_lex_state = 2},
  [4673] = {.lex_state = 35, .external_lex_state = 2},
  [4674] = {.lex_state = 35, .external_lex_state = 2},
  [4675] = {.lex_state = 35, .external_lex_state = 2},
  [4676] = {.lex_state = 35, .external_lex_state = 2},
  [4677] = {.lex_state = 35, .external_lex_state = 2},
  [4678] = {.lex_state = 35},
  [4679] = {.lex_state = 35, .external_lex_state = 2},
  [4680] = {.lex_state = 35, .external_lex_state = 2},
  [4681] = {.lex_state = 35},
  [4682] = {.lex_state = 35, .external_lex_state = 2},
  [4683] = {.lex_state = 35},
  [4684] = {.lex_state = 35, .external_lex_state = 2},
  [4685] = {.lex_state = 35, .external_lex_state = 2},
  [4686] = {.lex_state = 35, .external_lex_state = 2},
  [4687] = {.lex_state = 35, .external_lex_state = 2},
  [4688] = {.lex_state = 35, .external_lex_state = 2},
  [4689] = {.lex_state = 35, .external_lex_state = 2},
  [4690] = {.lex_state = 35},
  [4691] = {.lex_state = 35, .external_lex_state = 2},
  [4692] = {.lex_state = 35, .external_lex_state = 2},
  [4693] = {.lex_state = 35, .external_lex_state = 2},
  [4694] = {.lex_state = 35, .external_lex_state = 2},
  [4695] = {.lex_state = 35},
  [4696] = {.lex_state = 35},
  [4697] = {.lex_state = 35, .external_lex_state = 2},
  [4698] = {.lex_state = 35, .external_lex_state = 2},
  [4699] = {.lex_state = 35, .external_lex_state = 2},
  [4700] = {.lex_state = 35, .external_lex_state = 2},
  [4701] = {.lex_state = 35, .external_lex_state = 2},
  [4702] = {.lex_state = 35, .external_lex_state = 2},
  [4703] = {.lex_state = 35, .external_lex_state = 2},
  [4704] = {.lex_state = 35},
  [4705] = {.lex_state = 35, .external_lex_state = 2},
  [4706] = {.lex_state = 35, .external_lex_state = 2},
  [4707] = {.lex_state = 35, .external_lex_state = 2},
  [4708] = {.lex_state = 35},
  [4709] = {.lex_state = 35},
  [4710] = {.lex_state = 35},
  [4711] = {.lex_state = 35},
  [4712] = {.lex_state = 35},
  [4713] = {.lex_state = 35},
  [4714] = {.lex_state = 35},
  [4715] = {.lex_state = 35},
  [4716] = {.lex_state = 35, .external_lex_state = 2},
  [4717] = {.lex_state = 35},
  [4718] = {.lex_state = 35, .external_lex_state = 2},
  [4719] = {.lex_state = 35, .external_lex_state = 2},
  [4720] = {.lex_state = 35, .external_lex_state = 2},
  [4721] = {.lex_state = 35},
  [4722] = {.lex_state = 35, .external_lex_state = 2},
  [4723] = {.lex_state = 35, .external_lex_state = 2},
  [4724] = {.lex_state = 35, .external_lex_state = 2},
  [4725] = {.lex_state = 35, .external_lex_state = 2},
  [4726] = {.lex_state = 35, .external_lex_state = 2},
  [4727] = {.lex_state = 35, .external_lex_state = 2},
  [4728] = {.lex_state = 35},
  [4729] = {.lex_state = 35},
  [4730] = {.lex_state = 35, .external_lex_state = 2},
  [4731] = {.lex_state = 35},
  [4732] = {.lex_state = 35},
  [4733] = {.lex_state = 35, .external_lex_state = 2},
  [4734] = {.lex_state = 35, .external_lex_state = 2},
  [4735] = {.lex_state = 35, .external_lex_state = 2},
  [4736] = {.lex_state = 35, .external_lex_state = 2},
  [4737] = {.lex_state = 35, .external_lex_state = 2},
  [4738] = {.lex_state = 35, .external_lex_state = 2},
  [4739] = {.lex_state = 35, .external_lex_state = 2},
  [4740] = {.lex_state = 35, .external_lex_state = 2},
  [4741] = {.lex_state = 35, .external_lex_state = 2},
  [4742] = {.lex_state = 35, .external_lex_state = 2},
  [4743] = {.lex_state = 35},
  [4744] = {.lex_state = 35, .external_lex_state = 2},
  [4745] = {.lex_state = 35},
  [4746] = {.lex_state = 35, .external_lex_state = 2},
  [4747] = {.lex_state = 35},
  [4748] = {.lex_state = 35, .external_lex_state = 2},
  [4749] = {.lex_state = 35},
  [4750] = {.lex_state = 35},
  [4751] = {.lex_state = 35, .external_lex_state = 2},
  [4752] = {.lex_state = 35, .external_lex_state = 2},
  [4753] = {.lex_state = 35, .external_lex_state = 2},
  [4754] = {.lex_state = 35, .external_lex_state = 2},
  [4755] = {.lex_state = 35, .external_lex_state = 2},
  [4756] = {.lex_state = 35, .external_lex_state = 2},
  [4757] = {.lex_state = 35},
  [4758] = {.lex_state = 35, .external_lex_state = 2},
  [4759] = {.lex_state = 35, .external_lex_state = 2},
  [4760] = {.lex_state = 35, .external_lex_state = 2},
  [4761] = {.lex_state = 35, .external_lex_state = 2},
  [4762] = {.lex_state = 35, .external_lex_state = 2},
  [4763] = {.lex_state = 35, .external_lex_state = 2},
  [4764] = {.lex_state = 35, .external_lex_state = 2},
  [4765] = {.lex_state = 35},
  [4766] = {.lex_state = 35},
  [4767] = {.lex_state = 35},
  [4768] = {.lex_state = 35},
  [4769] = {.lex_state = 35},
  [4770] = {.lex_state = 35, .external_lex_state = 2},
  [4771] = {.lex_state = 35, .external_lex_state = 2},
  [4772] = {.lex_state = 35, .external_lex_state = 2},
  [4773] = {.lex_state = 35},
  [4774] = {.lex_state = 35, .external_lex_state = 2},
  [4775] = {.lex_state = 35, .external_lex_state = 2},
  [4776] = {.lex_state = 35, .external_lex_state = 2},
  [4777] = {.lex_state = 35, .external_lex_state = 2},
  [4778] = {.lex_state = 35, .external_lex_state = 2},
  [4779] = {.lex_state = 35, .external_lex_state = 2},
  [4780] = {.lex_state = 35},
  [4781] = {.lex_state = 35},
  [4782] = {.lex_state = 35},
  [4783] = {.lex_state = 35},
  [4784] = {.lex_state = 33, .external_lex_state = 2},
  [4785] = {.lex_state = 35, .external_lex_state = 2},
  [4786] = {.lex_state = 35},
  [4787] = {.lex_state = 35, .external_lex_state = 2},
  [4788] = {.lex_state = 35},
  [4789] = {.lex_state = 35},
  [4790] = {.lex_state = 35},
  [4791] = {.lex_state = 35},
  [4792] = {.lex_state = 35, .external_lex_state = 2},
  [4793] = {.lex_state = 35},
  [4794] = {.lex_state = 35, .external_lex_state = 2},
  [4795] = {.lex_state = 35},
  [4796] = {.lex_state = 35, .external_lex_state = 2},
  [4797] = {.lex_state = 35, .external_lex_state = 2},
  [4798] = {.lex_state = 35, .external_lex_state = 2},
  [4799] = {.lex_state = 35, .external_lex_state = 2},
  [4800] = {.lex_state = 35},
  [4801] = {.lex_state = 35, .external_lex_state = 2},
  [4802] = {.lex_state = 35, .external_lex_state = 2},
  [4803] = {.lex_state = 35, .external_lex_state = 2},
  [4804] = {.lex_state = 35, .external_lex_state = 2},
  [4805] = {.lex_state = 35, .external_lex_state = 2},
  [4806] = {.lex_state = 35, .external_lex_state = 2},
  [4807] = {.lex_state = 35, .external_lex_state = 2},
  [4808] = {.lex_state = 35, .external_lex_state = 2},
  [4809] = {.lex_state = 35, .external_lex_state = 2},
  [4810] = {.lex_state = 35, .external_lex_state = 2},
  [4811] = {.lex_state = 35, .external_lex_state = 2},
  [4812] = {.lex_state = 35, .external_lex_state = 2},
  [4813] = {.lex_state = 35, .external_lex_state = 2},
  [4814] = {.lex_state = 35, .external_lex_state = 2},
  [4815] = {.lex_state = 35, .external_lex_state = 2},
  [4816] = {.lex_state = 35, .external_lex_state = 2},
  [4817] = {.lex_state = 35, .external_lex_state = 2},
  [4818] = {.lex_state = 35, .external_lex_state = 2},
  [4819] = {.lex_state = 35, .external_lex_state = 2},
  [4820] = {.lex_state = 35, .external_lex_state = 2},
  [4821] = {.lex_state = 35, .external_lex_state = 2},
  [4822] = {.lex_state = 35, .external_lex_state = 2},
  [4823] = {.lex_state = 35},
  [4824] = {.lex_state = 35, .external_lex_state = 2},
  [4825] = {.lex_state = 35, .external_lex_state = 2},
  [4826] = {.lex_state = 35, .external_lex_state = 2},
  [4827] = {.lex_state = 35, .external_lex_state = 2},
  [4828] = {.lex_state = 35, .external_lex_state = 2},
  [4829] = {.lex_state = 35, .external_lex_state = 2},
  [4830] = {.lex_state = 35, .external_lex_state = 2},
  [4831] = {.lex_state = 35},
  [4832] = {.lex_state = 35, .external_lex_state = 2},
  [4833] = {.lex_state = 35, .external_lex_state = 2},
  [4834] = {.lex_state = 35},
  [4835] = {.lex_state = 35, .external_lex_state = 2},
  [4836] = {.lex_state = 35, .external_lex_state = 2},
  [4837] = {.lex_state = 35},
  [4838] = {.lex_state = 35},
  [4839] = {.lex_state = 35},
  [4840] = {.lex_state = 35, .external_lex_state = 2},
  [4841] = {.lex_state = 35, .external_lex_state = 2},
  [4842] = {.lex_state = 35, .external_lex_state = 2},
  [4843] = {.lex_state = 35, .external_lex_state = 2},
  [4844] = {.lex_state = 35},
  [4845] = {.lex_state = 35, .external_lex_state = 2},
  [4846] = {.lex_state = 35},
  [4847] = {.lex_state = 35, .external_lex_state = 2},
  [4848] = {.lex_state = 35, .external_lex_state = 2},
  [4849] = {.lex_state = 35, .external_lex_state = 2},
  [4850] = {.lex_state = 35},
  [4851] = {.lex_state = 35, .external_lex_state = 2},
  [4852] = {.lex_state = 35, .external_lex_state = 2},
  [4853] = {.lex_state = 35},
  [4854] = {.lex_state = 35, .external_lex_state = 2},
  [4855] = {.lex_state = 35, .external_lex_state = 2},
  [4856] = {.lex_state = 35, .external_lex_state = 2},
  [4857] = {.lex_state = 35, .external_lex_state = 2},
  [4858] = {.lex_state = 35, .external_lex_state = 2},
  [4859] = {.lex_state = 35, .external_lex_state = 2},
  [4860] = {.lex_state = 35, .external_lex_state = 2},
  [4861] = {.lex_state = 35, .external_lex_state = 2},
  [4862] = {.lex_state = 35, .external_lex_state = 2},
  [4863] = {.lex_state = 35, .external_lex_state = 2},
  [4864] = {.lex_state = 35},
  [4865] = {.lex_state = 35, .external_lex_state = 2},
  [4866] = {.lex_state = 35, .external_lex_state = 2},
  [4867] = {.lex_state = 33, .external_lex_state = 2},
  [4868] = {.lex_state = 35, .external_lex_state = 2},
  [4869] = {.lex_state = 35, .external_lex_state = 2},
  [4870] = {.lex_state = 35, .external_lex_state = 2},
  [4871] = {.lex_state = 35, .external_lex_state = 2},
  [4872] = {.lex_state = 35, .external_lex_state = 2},
  [4873] = {.lex_state = 35, .external_lex_state = 2},
  [4874] = {.lex_state = 35, .external_lex_state = 2},
  [4875] = {.lex_state = 35, .external_lex_state = 2},
  [4876] = {.lex_state = 35, .external_lex_state = 2},
  [4877] = {.lex_state = 35, .external_lex_state = 2},
  [4878] = {.lex_state = 35, .external_lex_state = 2},
  [4879] = {.lex_state = 35, .external_lex_state = 2},
  [4880] = {.lex_state = 35, .external_lex_state = 2},
  [4881] = {.lex_state = 35, .external_lex_state = 2},
  [4882] = {.lex_state = 35, .external_lex_state = 2},
  [4883] = {.lex_state = 35},
  [4884] = {.lex_state = 33},
  [4885] = {.lex_state = 35, .external_lex_state = 2},
  [4886] = {.lex_state = 35},
  [4887] = {.lex_state = 35},
  [4888] = {.lex_state = 35},
  [4889] = {.lex_state = 35},
  [4890] = {.lex_state = 35},
  [4891] = {.lex_state = 35},
  [4892] = {.lex_state = 35},
  [4893] = {.lex_state = 35, .external_lex_state = 2},
  [4894] = {.lex_state = 35},
  [4895] = {.lex_state = 35},
  [4896] = {.lex_state = 35},
  [4897] = {.lex_state = 35},
  [4898] = {.lex_state = 35, .external_lex_state = 2},
  [4899] = {.lex_state = 35, .external_lex_state = 2},
  [4900] = {.lex_state = 35},
  [4901] = {.lex_state = 35},
  [4902] = {.lex_state = 35, .external_lex_state = 2},
  [4903] = {.lex_state = 35, .external_lex_state = 2},
  [4904] = {.lex_state = 35},
  [4905] = {.lex_state = 35, .external_lex_state = 2},
  [4906] = {.lex_state = 35},
  [4907] = {.lex_state = 35},
  [4908] = {.lex_state = 35, .external_lex_state = 2},
  [4909] = {.lex_state = 35},
  [4910] = {.lex_state = 35},
  [4911] = {.lex_state = 35, .external_lex_state = 2},
  [4912] = {.lex_state = 35},
  [4913] = {.lex_state = 35},
  [4914] = {.lex_state = 35},
  [4915] = {.lex_state = 33, .external_lex_state = 2},
  [4916] = {.lex_state = 35, .external_lex_state = 2},
  [4917] = {.lex_state = 35, .external_lex_state = 2},
  [4918] = {.lex_state = 35},
  [4919] = {.lex_state = 35},
  [4920] = {.lex_state = 35},
  [4921] = {.lex_state = 35},
  [4922] = {.lex_state = 35},
  [4923] = {.lex_state = 35},
  [4924] = {.lex_state = 35},
  [4925] = {.lex_state = 35},
  [4926] = {.lex_state = 35},
  [4927] = {.lex_state = 35},
  [4928] = {.lex_state = 35},
  [4929] = {.lex_state = 35},
  [4930] = {.lex_state = 35},
  [4931] = {.lex_state = 35},
  [4932] = {.lex_state = 35},
  [4933] = {.lex_state = 35},
  [4934] = {.lex_state = 35},
  [4935] = {.lex_state = 35},
  [4936] = {.lex_state = 35},
  [4937] = {.lex_state = 35},
  [4938] = {.lex_state = 35},
  [4939] = {.lex_state = 35},
  [4940] = {.lex_state = 35, .external_lex_state = 2},
  [4941] = {.lex_state = 35, .external_lex_state = 2},
  [4942] = {.lex_state = 35, .external_lex_state = 2},
  [4943] = {.lex_state = 35},
  [4944] = {.lex_state = 35},
  [4945] = {.lex_state = 35},
  [4946] = {.lex_state = 35},
  [4947] = {.lex_state = 35},
  [4948] = {.lex_state = 35},
  [4949] = {.lex_state = 35},
  [4950] = {.lex_state = 35},
  [4951] = {.lex_state = 35, .external_lex_state = 2},
  [4952] = {.lex_state = 35},
  [4953] = {.lex_state = 35},
  [4954] = {.lex_state = 35},
  [4955] = {.lex_state = 35},
  [4956] = {.lex_state = 35},
  [4957] = {.lex_state = 35},
  [4958] = {.lex_state = 35},
  [4959] = {.lex_state = 35},
  [4960] = {.lex_state = 35},
  [4961] = {.lex_state = 35},
  [4962] = {.lex_state = 35},
  [4963] = {.lex_state = 35},
  [4964] = {.lex_state = 35, .external_lex_state = 2},
  [4965] = {.lex_state = 35, .external_lex_state = 2},
  [4966] = {.lex_state = 35, .external_lex_state = 2},
  [4967] = {.lex_state = 35},
  [4968] = {.lex_state = 35},
  [4969] = {.lex_state = 35},
  [4970] = {.lex_state = 35},
  [4971] = {.lex_state = 35},
  [4972] = {.lex_state = 35},
  [4973] = {.lex_state = 35},
  [4974] = {.lex_state = 35},
  [4975] = {.lex_state = 35},
  [4976] = {.lex_state = 35},
  [4977] = {.lex_state = 35},
  [4978] = {.lex_state = 35},
  [4979] = {.lex_state = 35},
  [4980] = {.lex_state = 35},
  [4981] = {.lex_state = 35},
  [4982] = {.lex_state = 35},
  [4983] = {.lex_state = 35, .external_lex_state = 2},
  [4984] = {.lex_state = 35, .external_lex_state = 2},
  [4985] = {.lex_state = 35, .external_lex_state = 2},
  [4986] = {.lex_state = 35, .external_lex_state = 2},
  [4987] = {.lex_state = 35, .external_lex_state = 2},
  [4988] = {.lex_state = 35},
  [4989] = {.lex_state = 35, .external_lex_state = 2},
  [4990] = {.lex_state = 35},
  [4991] = {.lex_state = 35, .external_lex_state = 2},
  [4992] = {.lex_state = 35, .external_lex_state = 2},
  [4993] = {.lex_state = 35, .external_lex_state = 2},
  [4994] = {.lex_state = 35, .external_lex_state = 2},
  [4995] = {.lex_state = 35},
  [4996] = {.lex_state = 35, .external_lex_state = 2},
  [4997] = {.lex_state = 35, .external_lex_state = 2},
  [4998] = {.lex_state = 35, .external_lex_state = 2},
  [4999] = {.lex_state = 35, .external_lex_state = 2},
  [5000] = {.lex_state = 35, .external_lex_state = 2},
  [5001] = {.lex_state = 35},
  [5002] = {.lex_state = 35, .external_lex_state = 2},
  [5003] = {.lex_state = 35},
  [5004] = {.lex_state = 35},
  [5005] = {.lex_state = 35},
  [5006] = {.lex_state = 35},
  [5007] = {.lex_state = 35, .external_lex_state = 2},
  [5008] = {.lex_state = 35},
  [5009] = {.lex_state = 35},
  [5010] = {.lex_state = 35},
  [5011] = {.lex_state = 35},
  [5012] = {.lex_state = 35},
  [5013] = {.lex_state = 33},
  [5014] = {.lex_state = 35},
  [5015] = {.lex_state = 35, .external_lex_state = 2},
  [5016] = {.lex_state = 35},
  [5017] = {.lex_state = 35},
  [5018] = {.lex_state = 33},
  [5019] = {.lex_state = 35},
  [5020] = {.lex_state = 35, .external_lex_state = 2},
  [5021] = {.lex_state = 35, .external_lex_state = 2},
  [5022] = {.lex_state = 35},
  [5023] = {.lex_state = 35},
  [5024] = {.lex_state = 35},
  [5025] = {.lex_state = 35},
  [5026] = {.lex_state = 35, .external_lex_state = 2},
  [5027] = {.lex_state = 35},
  [5028] = {.lex_state = 35},
  [5029] = {.lex_state = 35},
  [5030] = {.lex_state = 35},
  [5031] = {.lex_state = 35},
  [5032] = {.lex_state = 35},
  [5033] = {.lex_state = 35},
  [5034] = {.lex_state = 35},
  [5035] = {.lex_state = 35, .external_lex_state = 2},
  [5036] = {.lex_state = 35, .external_lex_state = 2},
  [5037] = {.lex_state = 35},
  [5038] = {.lex_state = 35, .external_lex_state = 2},
  [5039] = {.lex_state = 35},
  [5040] = {.lex_state = 35, .external_lex_state = 2},
  [5041] = {.lex_state = 35, .external_lex_state = 2},
  [5042] = {.lex_state = 35},
  [5043] = {.lex_state = 35, .external_lex_state = 2},
  [5044] = {.lex_state = 35},
  [5045] = {.lex_state = 35},
  [5046] = {.lex_state = 35},
  [5047] = {.lex_state = 35, .external_lex_state = 2},
  [5048] = {.lex_state = 35},
  [5049] = {.lex_state = 35, .external_lex_state = 2},
  [5050] = {.lex_state = 35, .external_lex_state = 2},
  [5051] = {.lex_state = 35, .external_lex_state = 2},
  [5052] = {.lex_state = 35, .external_lex_state = 2},
  [5053] = {.lex_state = 35, .external_lex_state = 2},
  [5054] = {.lex_state = 35, .external_lex_state = 2},
  [5055] = {.lex_state = 35},
  [5056] = {.lex_state = 35},
  [5057] = {.lex_state = 35},
  [5058] = {.lex_state = 35},
  [5059] = {.lex_state = 35},
  [5060] = {.lex_state = 35},
  [5061] = {.lex_state = 35},
  [5062] = {.lex_state = 35},
  [5063] = {.lex_state = 35, .external_lex_state = 2},
  [5064] = {.lex_state = 35, .external_lex_state = 2},
  [5065] = {.lex_state = 35, .external_lex_state = 2},
  [5066] = {.lex_state = 35},
  [5067] = {.lex_state = 35, .external_lex_state = 2},
  [5068] = {.lex_state = 35, .external_lex_state = 2},
  [5069] = {.lex_state = 35},
  [5070] = {.lex_state = 35},
  [5071] = {.lex_state = 35, .external_lex_state = 2},
  [5072] = {.lex_state = 35, .external_lex_state = 2},
  [5073] = {.lex_state = 35, .external_lex_state = 2},
  [5074] = {.lex_state = 35, .external_lex_state = 2},
  [5075] = {.lex_state = 35, .external_lex_state = 2},
  [5076] = {.lex_state = 35},
  [5077] = {.lex_state = 35, .external_lex_state = 2},
  [5078] = {.lex_state = 35, .external_lex_state = 2},
  [5079] = {.lex_state = 35, .external_lex_state = 2},
  [5080] = {.lex_state = 35, .external_lex_state = 2},
  [5081] = {.lex_state = 35, .external_lex_state = 2},
  [5082] = {.lex_state = 35, .external_lex_state = 2},
  [5083] = {.lex_state = 35, .external_lex_state = 2},
  [5084] = {.lex_state = 35},
  [5085] = {.lex_state = 35, .external_lex_state = 2},
  [5086] = {.lex_state = 35, .external_lex_state = 2},
  [5087] = {.lex_state = 35},
  [5088] = {.lex_state = 35},
  [5089] = {.lex_state = 35},
  [5090] = {.lex_state = 35},
  [5091] = {.lex_state = 35},
  [5092] = {.lex_state = 35},
  [5093] = {.lex_state = 35},
  [5094] = {.lex_state = 35, .external_lex_state = 2},
  [5095] = {.lex_state = 35},
  [5096] = {.lex_state = 35},
  [5097] = {.lex_state = 35},
  [5098] = {.lex_state = 35},
  [5099] = {.lex_state = 35},
  [5100] = {.lex_state = 35},
  [5101] = {.lex_state = 35, .external_lex_state = 2},
  [5102] = {.lex_state = 35},
  [5103] = {.lex_state = 35},
  [5104] = {.lex_state = 35},
  [5105] = {.lex_state = 35},
  [5106] = {.lex_state = 35},
  [5107] = {.lex_state = 35},
  [5108] = {.lex_state = 35},
  [5109] = {.lex_state = 35, .external_lex_state = 2},
  [5110] = {.lex_state = 35},
  [5111] = {.lex_state = 35},
  [5112] = {.lex_state = 35},
  [5113] = {.lex_state = 35},
  [5114] = {.lex_state = 35},
  [5115] = {.lex_state = 35},
  [5116] = {.lex_state = 35},
  [5117] = {.lex_state = 35},
  [5118] = {.lex_state = 35},
  [5119] = {.lex_state = 35},
  [5120] = {.lex_state = 35},
  [5121] = {.lex_state = 35},
  [5122] = {.lex_state = 35},
  [5123] = {.lex_state = 35},
  [5124] = {.lex_state = 35},
  [5125] = {.lex_state = 35, .external_lex_state = 2},
  [5126] = {.lex_state = 35, .external_lex_state = 2},
  [5127] = {.lex_state = 35},
  [5128] = {.lex_state = 35},
  [5129] = {.lex_state = 35, .external_lex_state = 2},
  [5130] = {.lex_state = 35},
  [5131] = {.lex_state = 35},
  [5132] = {.lex_state = 35},
  [5133] = {.lex_state = 35, .external_lex_state = 2},
  [5134] = {.lex_state = 35},
  [5135] = {.lex_state = 35},
  [5136] = {.lex_state = 35, .external_lex_state = 2},
  [5137] = {.lex_state = 35, .external_lex_state = 2},
  [5138] = {.lex_state = 35, .external_lex_state = 2},
  [5139] = {.lex_state = 35},
  [5140] = {.lex_state = 35, .external_lex_state = 2},
  [5141] = {.lex_state = 35},
  [5142] = {.lex_state = 35},
  [5143] = {.lex_state = 35, .external_lex_state = 2},
  [5144] = {.lex_state = 35},
  [5145] = {.lex_state = 35, .external_lex_state = 2},
  [5146] = {.lex_state = 35},
  [5147] = {.lex_state = 35, .external_lex_state = 2},
  [5148] = {.lex_state = 35},
  [5149] = {.lex_state = 35, .external_lex_state = 2},
  [5150] = {.lex_state = 35},
  [5151] = {.lex_state = 35},
  [5152] = {.lex_state = 35, .external_lex_state = 2},
  [5153] = {.lex_state = 35},
  [5154] = {.lex_state = 35},
  [5155] = {.lex_state = 35},
  [5156] = {.lex_state = 35},
  [5157] = {.lex_state = 35},
  [5158] = {.lex_state = 35},
  [5159] = {.lex_state = 35},
  [5160] = {.lex_state = 35, .external_lex_state = 2},
  [5161] = {.lex_state = 35, .external_lex_state = 2},
  [5162] = {.lex_state = 35},
  [5163] = {.lex_state = 35, .external_lex_state = 2},
  [5164] = {.lex_state = 35},
  [5165] = {.lex_state = 35, .external_lex_state = 2},
  [5166] = {.lex_state = 35, .external_lex_state = 2},
  [5167] = {.lex_state = 35, .external_lex_state = 2},
  [5168] = {.lex_state = 35, .external_lex_state = 2},
  [5169] = {.lex_state = 35},
  [5170] = {.lex_state = 35},
  [5171] = {.lex_state = 35},
  [5172] = {.lex_state = 35},
  [5173] = {.lex_state = 35},
  [5174] = {.lex_state = 35},
  [5175] = {.lex_state = 35},
  [5176] = {.lex_state = 35, .external_lex_state = 2},
  [5177] = {.lex_state = 35, .external_lex_state = 2},
  [5178] = {.lex_state = 35, .external_lex_state = 2},
  [5179] = {.lex_state = 35, .external_lex_state = 2},
  [5180] = {.lex_state = 35, .external_lex_state = 2},
  [5181] = {.lex_state = 35, .external_lex_state = 2},
  [5182] = {.lex_state = 35, .external_lex_state = 2},
  [5183] = {.lex_state = 35, .external_lex_state = 2},
  [5184] = {.lex_state = 35, .external_lex_state = 2},
  [5185] = {.lex_state = 35, .external_lex_state = 2},
  [5186] = {.lex_state = 35, .external_lex_state = 2},
  [5187] = {.lex_state = 35, .external_lex_state = 2},
  [5188] = {.lex_state = 35},
  [5189] = {.lex_state = 35},
  [5190] = {.lex_state = 35},
  [5191] = {.lex_state = 35},
  [5192] = {.lex_state = 35},
  [5193] = {.lex_state = 35},
  [5194] = {.lex_state = 35, .external_lex_state = 2},
  [5195] = {.lex_state = 35},
  [5196] = {.lex_state = 35, .external_lex_state = 2},
  [5197] = {.lex_state = 35},
  [5198] = {.lex_state = 35},
  [5199] = {.lex_state = 35},
  [5200] = {.lex_state = 35},
  [5201] = {.lex_state = 35},
  [5202] = {.lex_state = 35},
  [5203] = {.lex_state = 35},
  [5204] = {.lex_state = 35},
  [5205] = {.lex_state = 35, .external_lex_state = 2},
  [5206] = {.lex_state = 35, .external_lex_state = 2},
  [5207] = {.lex_state = 35, .external_lex_state = 2},
  [5208] = {.lex_state = 35},
  [5209] = {.lex_state = 35},
  [5210] = {.lex_state = 35},
  [5211] = {.lex_state = 35, .external_lex_state = 2},
  [5212] = {.lex_state = 35, .external_lex_state = 2},
  [5213] = {.lex_state = 35},
  [5214] = {.lex_state = 35, .external_lex_state = 2},
  [5215] = {.lex_state = 35, .external_lex_state = 2},
  [5216] = {.lex_state = 35},
  [5217] = {.lex_state = 35, .external_lex_state = 2},
  [5218] = {.lex_state = 35, .external_lex_state = 2},
  [5219] = {.lex_state = 35, .external_lex_state = 2},
  [5220] = {.lex_state = 35},
  [5221] = {.lex_state = 35, .external_lex_state = 2},
  [5222] = {.lex_state = 35},
  [5223] = {.lex_state = 35, .external_lex_state = 2},
  [5224] = {.lex_state = 35},
  [5225] = {.lex_state = 35, .external_lex_state = 2},
  [5226] = {.lex_state = 35},
  [5227] = {.lex_state = 35, .external_lex_state = 2},
  [5228] = {.lex_state = 35},
  [5229] = {.lex_state = 35, .external_lex_state = 2},
  [5230] = {.lex_state = 35},
  [5231] = {.lex_state = 35},
  [5232] = {.lex_state = 35},
  [5233] = {.lex_state = 35},
  [5234] = {.lex_state = 35, .external_lex_state = 2},
  [5235] = {.lex_state = 35},
  [5236] = {.lex_state = 35},
  [5237] = {.lex_state = 35},
  [5238] = {.lex_state = 35},
  [5239] = {.lex_state = 35},
  [5240] = {.lex_state = 35},
  [5241] = {.lex_state = 35},
  [5242] = {.lex_state = 35},
  [5243] = {.lex_state = 35},
  [5244] = {.lex_state = 35},
  [5245] = {.lex_state = 35, .external_lex_state = 2},
  [5246] = {.lex_state = 35},
  [5247] = {.lex_state = 35, .external_lex_state = 2},
  [5248] = {.lex_state = 35, .external_lex_state = 2},
  [5249] = {.lex_state = 35, .external_lex_state = 2},
  [5250] = {.lex_state = 35},
  [5251] = {.lex_state = 35},
  [5252] = {.lex_state = 35, .external_lex_state = 2},
  [5253] = {.lex_state = 35, .external_lex_state = 2},
  [5254] = {.lex_state = 35, .external_lex_state = 2},
  [5255] = {.lex_state = 35, .external_lex_state = 2},
  [5256] = {.lex_state = 35, .external_lex_state = 2},
  [5257] = {.lex_state = 35},
  [5258] = {.lex_state = 35},
  [5259] = {.lex_state = 35},
  [5260] = {.lex_state = 35, .external_lex_state = 2},
  [5261] = {.lex_state = 35, .external_lex_state = 2},
  [5262] = {.lex_state = 35},
  [5263] = {.lex_state = 35, .external_lex_state = 2},
  [5264] = {.lex_state = 35},
  [5265] = {.lex_state = 35},
  [5266] = {.lex_state = 35},
  [5267] = {.lex_state = 35},
  [5268] = {.lex_state = 35, .external_lex_state = 2},
  [5269] = {.lex_state = 35},
  [5270] = {.lex_state = 35},
  [5271] = {.lex_state = 35, .external_lex_state = 2},
  [5272] = {.lex_state = 35, .external_lex_state = 2},
  [5273] = {.lex_state = 35},
  [5274] = {.lex_state = 35, .external_lex_state = 2},
  [5275] = {.lex_state = 35},
  [5276] = {.lex_state = 35, .external_lex_state = 2},
  [5277] = {.lex_state = 35},
  [5278] = {.lex_state = 35},
  [5279] = {.lex_state = 35},
  [5280] = {.lex_state = 35},
  [5281] = {.lex_state = 35},
  [5282] = {.lex_state = 35, .external_lex_state = 2},
  [5283] = {.lex_state = 35},
  [5284] = {.lex_state = 35},
  [5285] = {.lex_state = 35},
  [5286] = {.lex_state = 35},
  [5287] = {.lex_state = 35},
  [5288] = {.lex_state = 35},
  [5289] = {.lex_state = 35},
  [5290] = {.lex_state = 35, .external_lex_state = 2},
  [5291] = {.lex_state = 35},
  [5292] = {.lex_state = 35},
  [5293] = {.lex_state = 35},
  [5294] = {.lex_state = 35},
  [5295] = {.lex_state = 35},
  [5296] = {.lex_state = 35},
  [5297] = {.lex_state = 35},
  [5298] = {.lex_state = 35},
  [5299] = {.lex_state = 35},
  [5300] = {.lex_state = 35},
  [5301] = {.lex_state = 35},
  [5302] = {.lex_state = 35},
  [5303] = {.lex_state = 35},
  [5304] = {.lex_state = 35},
  [5305] = {.lex_state = 35},
  [5306] = {.lex_state = 35},
  [5307] = {.lex_state = 35},
  [5308] = {.lex_state = 35},
  [5309] = {.lex_state = 35},
  [5310] = {.lex_state = 35},
  [5311] = {.lex_state = 35},
  [5312] = {.lex_state = 35},
  [5313] = {.lex_state = 35},
  [5314] = {.lex_state = 35},
  [5315] = {.lex_state = 35},
  [5316] = {.lex_state = 35, .external_lex_state = 2},
  [5317] = {.lex_state = 35},
  [5318] = {.lex_state = 35},
  [5319] = {.lex_state = 35, .external_lex_state = 2},
  [5320] = {.lex_state = 35},
  [5321] = {.lex_state = 35, .external_lex_state = 2},
  [5322] = {.lex_state = 35, .external_lex_state = 2},
  [5323] = {.lex_state = 35},
  [5324] = {.lex_state = 35},
  [5325] = {.lex_state = 35},
  [5326] = {.lex_state = 35},
  [5327] = {.lex_state = 35},
  [5328] = {.lex_state = 35},
  [5329] = {.lex_state = 35},
  [5330] = {.lex_state = 35},
  [5331] = {.lex_state = 35},
  [5332] = {.lex_state = 35},
  [5333] = {.lex_state = 35},
  [5334] = {.lex_state = 35},
  [5335] = {.lex_state = 35},
  [5336] = {.lex_state = 35},
  [5337] = {.lex_state = 35, .external_lex_state = 2},
  [5338] = {.lex_state = 35},
  [5339] = {.lex_state = 35},
  [5340] = {.lex_state = 35, .external_lex_state = 2},
  [5341] = {.lex_state = 35},
  [5342] = {.lex_state = 35, .external_lex_state = 2},
  [5343] = {.lex_state = 35},
  [5344] = {.lex_state = 35},
  [5345] = {.lex_state = 35},
  [5346] = {.lex_state = 35},
  [5347] = {.lex_state = 35},
  [5348] = {.lex_state = 35},
  [5349] = {.lex_state = 35},
  [5350] = {.lex_state = 35},
  [5351] = {.lex_state = 35, .external_lex_state = 2},
  [5352] = {.lex_state = 35},
  [5353] = {.lex_state = 35},
  [5354] = {.lex_state = 35},
  [5355] = {.lex_state = 35},
  [5356] = {.lex_state = 35},
  [5357] = {.lex_state = 35},
  [5358] = {.lex_state = 35},
  [5359] = {.lex_state = 35},
  [5360] = {.lex_state = 35, .external_lex_state = 2},
  [5361] = {.lex_state = 35},
  [5362] = {.lex_state = 35},
  [5363] = {.lex_state = 35},
  [5364] = {.lex_state = 35},
  [5365] = {.lex_state = 35, .external_lex_state = 2},
  [5366] = {.lex_state = 35},
  [5367] = {.lex_state = 35},
  [5368] = {.lex_state = 35},
  [5369] = {.lex_state = 35},
  [5370] = {.lex_state = 35},
  [5371] = {.lex_state = 35},
  [5372] = {.lex_state = 35},
  [5373] = {.lex_state = 35},
  [5374] = {.lex_state = 35},
  [5375] = {.lex_state = 35},
  [5376] = {.lex_state = 35},
  [5377] = {.lex_state = 35},
  [5378] = {.lex_state = 35},
  [5379] = {.lex_state = 35},
  [5380] = {.lex_state = 35},
  [5381] = {.lex_state = 35},
  [5382] = {.lex_state = 35, .external_lex_state = 2},
  [5383] = {.lex_state = 35, .external_lex_state = 2},
  [5384] = {.lex_state = 35, .external_lex_state = 2},
  [5385] = {.lex_state = 35, .external_lex_state = 2},
  [5386] = {.lex_state = 35},
  [5387] = {.lex_state = 35},
  [5388] = {.lex_state = 35},
  [5389] = {.lex_state = 35, .external_lex_state = 2},
  [5390] = {.lex_state = 35, .external_lex_state = 2},
  [5391] = {.lex_state = 35},
  [5392] = {.lex_state = 35},
  [5393] = {.lex_state = 35, .external_lex_state = 2},
  [5394] = {.lex_state = 35},
  [5395] = {.lex_state = 35},
  [5396] = {.lex_state = 35, .external_lex_state = 2},
  [5397] = {.lex_state = 35},
  [5398] = {.lex_state = 35},
  [5399] = {.lex_state = 35, .external_lex_state = 2},
  [5400] = {.lex_state = 35},
  [5401] = {.lex_state = 35},
  [5402] = {.lex_state = 35},
  [5403] = {.lex_state = 35},
  [5404] = {.lex_state = 35},
  [5405] = {.lex_state = 35, .external_lex_state = 2},
  [5406] = {.lex_state = 35, .external_lex_state = 2},
  [5407] = {.lex_state = 35},
  [5408] = {.lex_state = 35},
  [5409] = {.lex_state = 35},
  [5410] = {.lex_state = 35},
  [5411] = {.lex_state = 35},
  [5412] = {.lex_state = 35},
  [5413] = {.lex_state = 35, .external_lex_state = 2},
  [5414] = {.lex_state = 35},
  [5415] = {.lex_state = 35},
  [5416] = {.lex_state = 35},
  [5417] = {.lex_state = 35, .external_lex_state = 2},
  [5418] = {.lex_state = 35},
  [5419] = {.lex_state = 35, .external_lex_state = 2},
  [5420] = {.lex_state = 35, .external_lex_state = 2},
  [5421] = {.lex_state = 35, .external_lex_state = 2},
  [5422] = {.lex_state = 35, .external_lex_state = 2},
  [5423] = {.lex_state = 35, .external_lex_state = 2},
  [5424] = {.lex_state = 35},
  [5425] = {.lex_state = 35},
  [5426] = {.lex_state = 35, .external_lex_state = 2},
  [5427] = {.lex_state = 35, .external_lex_state = 2},
  [5428] = {.lex_state = 35, .external_lex_state = 2},
  [5429] = {.lex_state = 35},
  [5430] = {.lex_state = 35},
  [5431] = {.lex_state = 35},
  [5432] = {.lex_state = 35, .external_lex_state = 2},
  [5433] = {.lex_state = 35, .external_lex_state = 2},
  [5434] = {.lex_state = 35, .external_lex_state = 2},
  [5435] = {.lex_state = 35, .external_lex_state = 2},
  [5436] = {.lex_state = 35},
  [5437] = {.lex_state = 33},
  [5438] = {.lex_state = 35},
  [5439] = {.lex_state = 35},
  [5440] = {.lex_state = 35},
  [5441] = {.lex_state = 35},
  [5442] = {.lex_state = 35, .external_lex_state = 2},
  [5443] = {.lex_state = 35, .external_lex_state = 2},
  [5444] = {.lex_state = 35, .external_lex_state = 2},
  [5445] = {.lex_state = 35, .external_lex_state = 2},
  [5446] = {.lex_state = 35},
  [5447] = {.lex_state = 35, .external_lex_state = 2},
  [5448] = {.lex_state = 35, .external_lex_state = 2},
  [5449] = {.lex_state = 35, .external_lex_state = 2},
  [5450] = {.lex_state = 35},
  [5451] = {.lex_state = 35, .external_lex_state = 2},
  [5452] = {.lex_state = 35},
  [5453] = {.lex_state = 35},
  [5454] = {.lex_state = 35, .external_lex_state = 2},
  [5455] = {.lex_state = 35},
  [5456] = {.lex_state = 35, .external_lex_state = 2},
  [5457] = {.lex_state = 35, .external_lex_state = 2},
  [5458] = {.lex_state = 35, .external_lex_state = 2},
  [5459] = {.lex_state = 35, .external_lex_state = 2},
  [5460] = {.lex_state = 35, .external_lex_state = 2},
  [5461] = {.lex_state = 35, .external_lex_state = 2},
  [5462] = {.lex_state = 35, .external_lex_state = 2},
  [5463] = {.lex_state = 35},
  [5464] = {.lex_state = 35, .external_lex_state = 2},
  [5465] = {.lex_state = 35, .external_lex_state = 2},
  [5466] = {.lex_state = 35, .external_lex_state = 2},
  [5467] = {.lex_state = 35, .external_lex_state = 2},
  [5468] = {.lex_state = 35, .external_lex_state = 2},
  [5469] = {.lex_state = 35, .external_lex_state = 2},
  [5470] = {.lex_state = 35, .external_lex_state = 2},
  [5471] = {.lex_state = 35},
  [5472] = {.lex_state = 35, .external_lex_state = 2},
  [5473] = {.lex_state = 35, .external_lex_state = 2},
  [5474] = {.lex_state = 35},
  [5475] = {.lex_state = 35},
  [5476] = {.lex_state = 35},
  [5477] = {.lex_state = 35},
  [5478] = {.lex_state = 35},
  [5479] = {.lex_state = 35},
  [5480] = {.lex_state = 35},
  [5481] = {.lex_state = 35},
  [5482] = {.lex_state = 35, .external_lex_state = 2},
  [5483] = {.lex_state = 35, .external_lex_state = 2},
  [5484] = {.lex_state = 35, .external_lex_state = 2},
  [5485] = {.lex_state = 35, .external_lex_state = 2},
  [5486] = {.lex_state = 35},
  [5487] = {.lex_state = 35},
  [5488] = {.lex_state = 35},
  [5489] = {.lex_state = 35},
  [5490] = {.lex_state = 35, .external_lex_state = 2},
  [5491] = {.lex_state = 35},
  [5492] = {.lex_state = 35, .external_lex_state = 2},
  [5493] = {.lex_state = 35},
  [5494] = {.lex_state = 33},
  [5495] = {.lex_state = 35},
  [5496] = {.lex_state = 35, .external_lex_state = 2},
  [5497] = {.lex_state = 35, .external_lex_state = 2},
  [5498] = {.lex_state = 35, .external_lex_state = 2},
  [5499] = {.lex_state = 35},
  [5500] = {.lex_state = 35},
  [5501] = {.lex_state = 35},
  [5502] = {.lex_state = 35},
  [5503] = {.lex_state = 35, .external_lex_state = 2},
  [5504] = {.lex_state = 35},
  [5505] = {.lex_state = 35},
  [5506] = {.lex_state = 35},
  [5507] = {.lex_state = 35, .external_lex_state = 2},
  [5508] = {.lex_state = 35, .external_lex_state = 2},
  [5509] = {.lex_state = 35, .external_lex_state = 2},
  [5510] = {.lex_state = 35},
  [5511] = {.lex_state = 35, .external_lex_state = 2},
  [5512] = {.lex_state = 35},
  [5513] = {.lex_state = 35},
  [5514] = {.lex_state = 35, .external_lex_state = 2},
  [5515] = {.lex_state = 35},
  [5516] = {.lex_state = 35, .external_lex_state = 2},
  [5517] = {.lex_state = 35},
  [5518] = {.lex_state = 35, .external_lex_state = 2},
  [5519] = {.lex_state = 35, .external_lex_state = 2},
  [5520] = {.lex_state = 35},
  [5521] = {.lex_state = 35},
  [5522] = {.lex_state = 35, .external_lex_state = 2},
  [5523] = {.lex_state = 35},
  [5524] = {.lex_state = 35, .external_lex_state = 2},
  [5525] = {.lex_state = 35, .external_lex_state = 2},
  [5526] = {.lex_state = 35},
  [5527] = {.lex_state = 35, .external_lex_state = 2},
  [5528] = {.lex_state = 35, .external_lex_state = 2},
  [5529] = {.lex_state = 35},
  [5530] = {.lex_state = 35},
  [5531] = {.lex_state = 35},
  [5532] = {.lex_state = 35},
  [5533] = {.lex_state = 35, .external_lex_state = 2},
  [5534] = {.lex_state = 35, .external_lex_state = 2},
  [5535] = {.lex_state = 35, .external_lex_state = 2},
  [5536] = {.lex_state = 35},
  [5537] = {.lex_state = 35, .external_lex_state = 2},
  [5538] = {.lex_state = 35, .external_lex_state = 2},
  [5539] = {.lex_state = 35, .external_lex_state = 2},
  [5540] = {.lex_state = 35, .external_lex_state = 2},
  [5541] = {.lex_state = 35},
  [5542] = {.lex_state = 35, .external_lex_state = 2},
  [5543] = {.lex_state = 35, .external_lex_state = 2},
  [5544] = {.lex_state = 35, .external_lex_state = 2},
  [5545] = {.lex_state = 35, .external_lex_state = 2},
  [5546] = {.lex_state = 35},
  [5547] = {.lex_state = 35},
  [5548] = {.lex_state = 35, .external_lex_state = 2},
  [5549] = {.lex_state = 35, .external_lex_state = 2},
  [5550] = {.lex_state = 35, .external_lex_state = 2},
  [5551] = {.lex_state = 35, .external_lex_state = 2},
  [5552] = {.lex_state = 35, .external_lex_state = 2},
  [5553] = {.lex_state = 35, .external_lex_state = 2},
  [5554] = {.lex_state = 35},
  [5555] = {.lex_state = 35, .external_lex_state = 2},
  [5556] = {.lex_state = 35, .external_lex_state = 2},
  [5557] = {.lex_state = 35, .external_lex_state = 2},
  [5558] = {.lex_state = 35, .external_lex_state = 2},
  [5559] = {.lex_state = 35, .external_lex_state = 2},
  [5560] = {.lex_state = 35, .external_lex_state = 2},
  [5561] = {.lex_state = 35, .external_lex_state = 2},
  [5562] = {.lex_state = 35, .external_lex_state = 2},
  [5563] = {.lex_state = 35},
  [5564] = {.lex_state = 35},
  [5565] = {.lex_state = 35, .external_lex_state = 2},
  [5566] = {.lex_state = 35, .external_lex_state = 2},
  [5567] = {.lex_state = 35, .external_lex_state = 2},
  [5568] = {.lex_state = 35, .external_lex_state = 2},
  [5569] = {.lex_state = 35, .external_lex_state = 2},
  [5570] = {.lex_state = 35, .external_lex_state = 2},
  [5571] = {.lex_state = 35},
  [5572] = {.lex_state = 35, .external_lex_state = 2},
  [5573] = {.lex_state = 35},
  [5574] = {.lex_state = 35, .external_lex_state = 2},
  [5575] = {.lex_state = 35},
  [5576] = {.lex_state = 35},
  [5577] = {.lex_state = 35, .external_lex_state = 2},
  [5578] = {.lex_state = 35, .external_lex_state = 2},
  [5579] = {.lex_state = 35},
  [5580] = {.lex_state = 35, .external_lex_state = 2},
  [5581] = {.lex_state = 35, .external_lex_state = 2},
  [5582] = {.lex_state = 35, .external_lex_state = 2},
  [5583] = {.lex_state = 35},
  [5584] = {.lex_state = 35},
  [5585] = {.lex_state = 35, .external_lex_state = 2},
  [5586] = {.lex_state = 35},
  [5587] = {.lex_state = 35, .external_lex_state = 2},
  [5588] = {.lex_state = 35, .external_lex_state = 2},
  [5589] = {.lex_state = 35},
  [5590] = {.lex_state = 35},
  [5591] = {.lex_state = 35},
  [5592] = {.lex_state = 35},
  [5593] = {.lex_state = 35},
  [5594] = {.lex_state = 35},
  [5595] = {.lex_state = 35, .external_lex_state = 2},
  [5596] = {.lex_state = 35, .external_lex_state = 2},
  [5597] = {.lex_state = 35, .external_lex_state = 2},
  [5598] = {.lex_state = 35, .external_lex_state = 2},
  [5599] = {.lex_state = 35},
  [5600] = {.lex_state = 35, .external_lex_state = 2},
  [5601] = {.lex_state = 35, .external_lex_state = 2},
  [5602] = {.lex_state = 35, .external_lex_state = 2},
  [5603] = {.lex_state = 35},
  [5604] = {.lex_state = 35, .external_lex_state = 2},
  [5605] = {.lex_state = 35},
  [5606] = {.lex_state = 35},
  [5607] = {.lex_state = 35, .external_lex_state = 2},
  [5608] = {.lex_state = 35},
  [5609] = {.lex_state = 35, .external_lex_state = 2},
  [5610] = {.lex_state = 35},
  [5611] = {.lex_state = 35, .external_lex_state = 2},
  [5612] = {.lex_state = 35},
  [5613] = {.lex_state = 35, .external_lex_state = 2},
  [5614] = {.lex_state = 35},
  [5615] = {.lex_state = 35, .external_lex_state = 2},
  [5616] = {.lex_state = 35},
  [5617] = {.lex_state = 35, .external_lex_state = 2},
  [5618] = {.lex_state = 35},
  [5619] = {.lex_state = 35, .external_lex_state = 2},
  [5620] = {.lex_state = 35, .external_lex_state = 2},
  [5621] = {.lex_state = 35, .external_lex_state = 2},
  [5622] = {.lex_state = 35, .external_lex_state = 2},
  [5623] = {.lex_state = 35, .external_lex_state = 2},
  [5624] = {.lex_state = 35, .external_lex_state = 2},
  [5625] = {.lex_state = 35},
  [5626] = {.lex_state = 35},
  [5627] = {.lex_state = 35, .external_lex_state = 2},
  [5628] = {.lex_state = 35},
  [5629] = {.lex_state = 35},
  [5630] = {.lex_state = 35},
  [5631] = {.lex_state = 35},
  [5632] = {.lex_state = 35, .external_lex_state = 2},
  [5633] = {.lex_state = 35},
  [5634] = {.lex_state = 35},
  [5635] = {.lex_state = 35},
  [5636] = {.lex_state = 35},
  [5637] = {.lex_state = 35},
  [5638] = {.lex_state = 35},
  [5639] = {.lex_state = 35, .external_lex_state = 2},
  [5640] = {.lex_state = 35},
  [5641] = {.lex_state = 35, .external_lex_state = 2},
  [5642] = {.lex_state = 35, .external_lex_state = 2},
  [5643] = {.lex_state = 35},
  [5644] = {.lex_state = 35},
  [5645] = {.lex_state = 35},
  [5646] = {.lex_state = 35},
  [5647] = {.lex_state = 35},
  [5648] = {.lex_state = 35},
  [5649] = {.lex_state = 35},
  [5650] = {.lex_state = 35, .external_lex_state = 2},
  [5651] = {.lex_state = 35, .external_lex_state = 2},
  [5652] = {.lex_state = 35, .external_lex_state = 2},
  [5653] = {.lex_state = 35},
  [5654] = {.lex_state = 35},
  [5655] = {.lex_state = 35},
  [5656] = {.lex_state = 35},
  [5657] = {.lex_state = 35},
  [5658] = {.lex_state = 35},
  [5659] = {.lex_state = 35},
  [5660] = {.lex_state = 35},
  [5661] = {.lex_state = 35},
  [5662] = {.lex_state = 35},
  [5663] = {.lex_state = 35},
  [5664] = {.lex_state = 35},
  [5665] = {.lex_state = 35},
  [5666] = {.lex_state = 35, .external_lex_state = 2},
  [5667] = {.lex_state = 35, .external_lex_state = 2},
  [5668] = {.lex_state = 35},
  [5669] = {.lex_state = 35, .external_lex_state = 2},
  [5670] = {.lex_state = 35},
  [5671] = {.lex_state = 35, .external_lex_state = 2},
  [5672] = {.lex_state = 35},
  [5673] = {.lex_state = 35},
  [5674] = {.lex_state = 35, .external_lex_state = 2},
  [5675] = {.lex_state = 35, .external_lex_state = 2},
  [5676] = {.lex_state = 35, .external_lex_state = 2},
  [5677] = {.lex_state = 35},
  [5678] = {.lex_state = 35},
  [5679] = {.lex_state = 35},
  [5680] = {.lex_state = 35},
  [5681] = {.lex_state = 35, .external_lex_state = 2},
  [5682] = {.lex_state = 35, .external_lex_state = 2},
  [5683] = {.lex_state = 35},
  [5684] = {.lex_state = 35, .external_lex_state = 2},
  [5685] = {.lex_state = 35},
  [5686] = {.lex_state = 35},
  [5687] = {.lex_state = 35},
  [5688] = {.lex_state = 35},
  [5689] = {.lex_state = 35},
  [5690] = {.lex_state = 35},
  [5691] = {.lex_state = 35},
  [5692] = {.lex_state = 35},
  [5693] = {.lex_state = 35},
  [5694] = {.lex_state = 35, .external_lex_state = 2},
  [5695] = {.lex_state = 35},
  [5696] = {.lex_state = 35},
  [5697] = {.lex_state = 35},
  [5698] = {.lex_state = 35},
  [5699] = {.lex_state = 35},
  [5700] = {.lex_state = 35},
  [5701] = {.lex_state = 35},
  [5702] = {.lex_state = 35},
  [5703] = {.lex_state = 35},
  [5704] = {.lex_state = 35},
  [5705] = {.lex_state = 35},
  [5706] = {.lex_state = 35},
  [5707] = {.lex_state = 35},
  [5708] = {.lex_state = 35},
  [5709] = {.lex_state = 35},
  [5710] = {.lex_state = 35},
  [5711] = {.lex_state = 35},
  [5712] = {.lex_state = 35},
  [5713] = {.lex_state = 35},
  [5714] = {.lex_state = 35},
  [5715] = {.lex_state = 35},
  [5716] = {.lex_state = 35},
  [5717] = {.lex_state = 35},
  [5718] = {.lex_state = 35, .external_lex_state = 2},
  [5719] = {.lex_state = 35},
  [5720] = {.lex_state = 35},
  [5721] = {.lex_state = 35},
  [5722] = {.lex_state = 35, .external_lex_state = 2},
  [5723] = {.lex_state = 35},
  [5724] = {.lex_state = 35},
  [5725] = {.lex_state = 35},
  [5726] = {.lex_state = 35},
  [5727] = {.lex_state = 35, .external_lex_state = 2},
  [5728] = {.lex_state = 35},
  [5729] = {.lex_state = 35},
  [5730] = {.lex_state = 35},
  [5731] = {.lex_state = 35},
  [5732] = {.lex_state = 35, .external_lex_state = 2},
  [5733] = {.lex_state = 35},
  [5734] = {.lex_state = 35, .external_lex_state = 2},
  [5735] = {.lex_state = 35},
  [5736] = {.lex_state = 35},
  [5737] = {.lex_state = 35},
  [5738] = {.lex_state = 35},
  [5739] = {.lex_state = 35},
  [5740] = {.lex_state = 35},
  [5741] = {.lex_state = 35, .external_lex_state = 2},
  [5742] = {.lex_state = 35, .external_lex_state = 2},
  [5743] = {.lex_state = 35, .external_lex_state = 2},
  [5744] = {.lex_state = 35},
  [5745] = {.lex_state = 35},
  [5746] = {.lex_state = 35},
  [5747] = {.lex_state = 35},
  [5748] = {.lex_state = 35},
  [5749] = {.lex_state = 35},
  [5750] = {.lex_state = 35},
  [5751] = {.lex_state = 35},
  [5752] = {.lex_state = 35},
  [5753] = {.lex_state = 35, .external_lex_state = 2},
  [5754] = {.lex_state = 35, .external_lex_state = 2},
  [5755] = {.lex_state = 35, .external_lex_state = 2},
  [5756] = {.lex_state = 35},
  [5757] = {.lex_state = 35},
  [5758] = {.lex_state = 35},
  [5759] = {.lex_state = 35},
  [5760] = {.lex_state = 35},
  [5761] = {.lex_state = 35},
  [5762] = {.lex_state = 35},
  [5763] = {.lex_state = 35},
  [5764] = {.lex_state = 35},
  [5765] = {.lex_state = 35},
  [5766] = {.lex_state = 35},
  [5767] = {.lex_state = 35},
  [5768] = {.lex_state = 35},
  [5769] = {.lex_state = 35},
  [5770] = {.lex_state = 35},
  [5771] = {.lex_state = 35},
  [5772] = {.lex_state = 35},
  [5773] = {.lex_state = 35},
  [5774] = {.lex_state = 35},
  [5775] = {.lex_state = 35},
  [5776] = {.lex_state = 35},
  [5777] = {.lex_state = 35},
  [5778] = {.lex_state = 35},
  [5779] = {.lex_state = 35},
  [5780] = {.lex_state = 35},
  [5781] = {.lex_state = 35},
  [5782] = {.lex_state = 35},
  [5783] = {.lex_state = 35},
  [5784] = {.lex_state = 35},
  [5785] = {.lex_state = 35},
  [5786] = {.lex_state = 35},
  [5787] = {.lex_state = 35},
  [5788] = {.lex_state = 35},
  [5789] = {.lex_state = 35},
  [5790] = {.lex_state = 35},
  [5791] = {.lex_state = 35},
  [5792] = {.lex_state = 35},
  [5793] = {.lex_state = 35},
  [5794] = {.lex_state = 35},
  [5795] = {.lex_state = 35},
  [5796] = {.lex_state = 35},
  [5797] = {.lex_state = 35},
  [5798] = {.lex_state = 35},
  [5799] = {.lex_state = 35},
  [5800] = {.lex_state = 35},
  [5801] = {.lex_state = 35},
  [5802] = {.lex_state = 35},
  [5803] = {.lex_state = 35},
  [5804] = {.lex_state = 35},
  [5805] = {.lex_state = 35},
  [5806] = {.lex_state = 35},
  [5807] = {.lex_state = 35},
  [5808] = {.lex_state = 35},
  [5809] = {.lex_state = 35},
  [5810] = {.lex_state = 35},
  [5811] = {.lex_state = 35},
  [5812] = {.lex_state = 35},
  [5813] = {.lex_state = 35},
  [5814] = {.lex_state = 35},
  [5815] = {.lex_state = 35},
  [5816] = {.lex_state = 35},
  [5817] = {.lex_state = 35},
  [5818] = {.lex_state = 35},
  [5819] = {.lex_state = 35},
  [5820] = {.lex_state = 35},
  [5821] = {.lex_state = 35},
  [5822] = {.lex_state = 35},
  [5823] = {.lex_state = 35},
  [5824] = {.lex_state = 35},
  [5825] = {.lex_state = 35},
  [5826] = {.lex_state = 35},
  [5827] = {.lex_state = 35},
  [5828] = {.lex_state = 35},
  [5829] = {.lex_state = 35},
  [5830] = {.lex_state = 35},
  [5831] = {.lex_state = 35},
  [5832] = {.lex_state = 35},
  [5833] = {.lex_state = 35},
  [5834] = {.lex_state = 35},
  [5835] = {.lex_state = 35},
  [5836] = {.lex_state = 35},
  [5837] = {.lex_state = 35},
  [5838] = {.lex_state = 35},
  [5839] = {.lex_state = 35},
  [5840] = {.lex_state = 35},
  [5841] = {.lex_state = 35},
  [5842] = {.lex_state = 35},
  [5843] = {.lex_state = 35},
  [5844] = {.lex_state = 35},
  [5845] = {.lex_state = 35},
  [5846] = {.lex_state = 35},
  [5847] = {.lex_state = 35},
  [5848] = {.lex_state = 35},
  [5849] = {.lex_state = 35},
  [5850] = {.lex_state = 35},
  [5851] = {.lex_state = 35},
  [5852] = {.lex_state = 35},
  [5853] = {.lex_state = 35},
  [5854] = {.lex_state = 35},
  [5855] = {.lex_state = 35},
  [5856] = {.lex_state = 35},
  [5857] = {.lex_state = 35},
  [5858] = {.lex_state = 35},
  [5859] = {.lex_state = 35},
  [5860] = {.lex_state = 35},
  [5861] = {.lex_state = 35},
  [5862] = {.lex_state = 35},
  [5863] = {.lex_state = 35},
  [5864] = {.lex_state = 35},
  [5865] = {.lex_state = 35},
  [5866] = {.lex_state = 35},
  [5867] = {.lex_state = 35},
  [5868] = {.lex_state = 35},
  [5869] = {.lex_state = 35},
  [5870] = {.lex_state = 35},
  [5871] = {.lex_state = 35},
  [5872] = {.lex_state = 35},
  [5873] = {.lex_state = 35},
  [5874] = {.lex_state = 35},
  [5875] = {.lex_state = 35},
  [5876] = {.lex_state = 35},
  [5877] = {.lex_state = 35},
  [5878] = {.lex_state = 35},
  [5879] = {.lex_state = 35},
  [5880] = {.lex_state = 35},
  [5881] = {.lex_state = 35},
  [5882] = {.lex_state = 35},
  [5883] = {.lex_state = 35},
  [5884] = {.lex_state = 35},
  [5885] = {.lex_state = 35},
  [5886] = {.lex_state = 35},
  [5887] = {.lex_state = 35},
  [5888] = {.lex_state = 35},
  [5889] = {.lex_state = 35},
  [5890] = {.lex_state = 35},
  [5891] = {.lex_state = 35},
  [5892] = {.lex_state = 35},
  [5893] = {.lex_state = 35},
  [5894] = {.lex_state = 35},
  [5895] = {.lex_state = 35},
  [5896] = {.lex_state = 33, .external_lex_state = 3},
  [5897] = {.lex_state = 35},
  [5898] = {.lex_state = 35},
  [5899] = {.lex_state = 35},
  [5900] = {.lex_state = 35},
  [5901] = {.lex_state = 35},
  [5902] = {.lex_state = 35},
  [5903] = {.lex_state = 35},
  [5904] = {.lex_state = 35},
  [5905] = {.lex_state = 35},
  [5906] = {.lex_state = 35},
  [5907] = {.lex_state = 35},
  [5908] = {.lex_state = 35},
  [5909] = {.lex_state = 35},
  [5910] = {.lex_state = 35},
  [5911] = {.lex_state = 35},
  [5912] = {.lex_state = 35},
  [5913] = {.lex_state = 35},
  [5914] = {.lex_state = 35},
  [5915] = {.lex_state = 35},
  [5916] = {.lex_state = 35},
  [5917] = {.lex_state = 35},
  [5918] = {.lex_state = 35},
  [5919] = {.lex_state = 35},
  [5920] = {.lex_state = 35},
  [5921] = {.lex_state = 35},
  [5922] = {.lex_state = 35},
  [5923] = {.lex_state = 35},
  [5924] = {.lex_state = 35},
  [5925] = {.lex_state = 35},
  [5926] = {.lex_state = 35},
  [5927] = {.lex_state = 35},
  [5928] = {.lex_state = 35},
  [5929] = {.lex_state = 35},
  [5930] = {.lex_state = 35},
  [5931] = {.lex_state = 35},
  [5932] = {.lex_state = 35},
  [5933] = {.lex_state = 35},
  [5934] = {.lex_state = 35},
  [5935] = {.lex_state = 35},
  [5936] = {.lex_state = 35},
  [5937] = {.lex_state = 35},
  [5938] = {.lex_state = 35},
  [5939] = {.lex_state = 35},
  [5940] = {.lex_state = 35},
  [5941] = {.lex_state = 35},
  [5942] = {.lex_state = 35},
  [5943] = {.lex_state = 35},
  [5944] = {.lex_state = 35},
  [5945] = {.lex_state = 35},
  [5946] = {.lex_state = 35},
  [5947] = {.lex_state = 35},
  [5948] = {.lex_state = 35},
  [5949] = {.lex_state = 35},
  [5950] = {.lex_state = 35},
  [5951] = {.lex_state = 35},
  [5952] = {.lex_state = 35},
  [5953] = {.lex_state = 35},
  [5954] = {.lex_state = 35},
  [5955] = {.lex_state = 35},
  [5956] = {.lex_state = 35},
  [5957] = {.lex_state = 35},
  [5958] = {.lex_state = 35},
  [5959] = {.lex_state = 35},
  [5960] = {.lex_state = 35},
  [5961] = {.lex_state = 35},
  [5962] = {.lex_state = 35},
  [5963] = {.lex_state = 35},
  [5964] = {.lex_state = 35},
  [5965] = {.lex_state = 35},
  [5966] = {.lex_state = 35, .external_lex_state = 2},
  [5967] = {.lex_state = 35},
  [5968] = {.lex_state = 35},
  [5969] = {.lex_state = 35, .external_lex_state = 2},
  [5970] = {.lex_state = 35},
  [5971] = {.lex_state = 35},
  [5972] = {.lex_state = 35},
  [5973] = {.lex_state = 35},
  [5974] = {.lex_state = 35},
  [5975] = {.lex_state = 35},
  [5976] = {.lex_state = 35},
  [5977] = {.lex_state = 35},
  [5978] = {.lex_state = 35},
  [5979] = {.lex_state = 35},
  [5980] = {.lex_state = 35},
  [5981] = {.lex_state = 35},
  [5982] = {.lex_state = 35},
  [5983] = {.lex_state = 35},
  [5984] = {.lex_state = 35},
  [5985] = {.lex_state = 35},
  [5986] = {.lex_state = 35},
  [5987] = {.lex_state = 35},
  [5988] = {.lex_state = 35},
  [5989] = {.lex_state = 35},
  [5990] = {.lex_state = 35},
  [5991] = {.lex_state = 35},
  [5992] = {.lex_state = 35},
  [5993] = {.lex_state = 35},
  [5994] = {.lex_state = 35},
  [5995] = {.lex_state = 35},
  [5996] = {.lex_state = 35},
  [5997] = {.lex_state = 35},
  [5998] = {.lex_state = 35},
  [5999] = {.lex_state = 35},
  [6000] = {.lex_state = 35},
  [6001] = {.lex_state = 35},
  [6002] = {.lex_state = 35},
  [6003] = {.lex_state = 35, .external_lex_state = 2},
  [6004] = {.lex_state = 35},
  [6005] = {.lex_state = 35, .external_lex_state = 2},
  [6006] = {.lex_state = 35},
  [6007] = {.lex_state = 35},
  [6008] = {.lex_state = 35},
  [6009] = {.lex_state = 35},
  [6010] = {.lex_state = 35},
  [6011] = {.lex_state = 35},
  [6012] = {.lex_state = 35},
  [6013] = {.lex_state = 35},
  [6014] = {.lex_state = 35, .external_lex_state = 2},
  [6015] = {.lex_state = 33, .external_lex_state = 3},
  [6016] = {.lex_state = 35},
  [6017] = {.lex_state = 35},
  [6018] = {.lex_state = 35},
  [6019] = {.lex_state = 35},
  [6020] = {.lex_state = 35},
  [6021] = {.lex_state = 35},
  [6022] = {.lex_state = 35},
  [6023] = {.lex_state = 35},
  [6024] = {.lex_state = 35},
  [6025] = {.lex_state = 35},
  [6026] = {.lex_state = 35},
  [6027] = {.lex_state = 35},
  [6028] = {.lex_state = 35},
  [6029] = {.lex_state = 35},
  [6030] = {.lex_state = 35},
  [6031] = {.lex_state = 35},
  [6032] = {.lex_state = 35},
  [6033] = {.lex_state = 35},
  [6034] = {.lex_state = 35},
  [6035] = {.lex_state = 35},
  [6036] = {.lex_state = 35},
  [6037] = {.lex_state = 35},
  [6038] = {.lex_state = 35},
  [6039] = {.lex_state = 35},
  [6040] = {.lex_state = 35},
  [6041] = {.lex_state = 35},
  [6042] = {.lex_state = 35, .external_lex_state = 2},
  [6043] = {.lex_state = 35},
  [6044] = {.lex_state = 35},
  [6045] = {.lex_state = 35},
  [6046] = {.lex_state = 35},
  [6047] = {.lex_state = 35},
  [6048] = {.lex_state = 35},
  [6049] = {.lex_state = 35},
  [6050] = {.lex_state = 35},
  [6051] = {.lex_state = 35},
  [6052] = {.lex_state = 35},
  [6053] = {.lex_state = 35},
  [6054] = {.lex_state = 35},
  [6055] = {.lex_state = 35},
  [6056] = {.lex_state = 35},
  [6057] = {.lex_state = 35},
  [6058] = {.lex_state = 35},
  [6059] = {.lex_state = 35},
  [6060] = {.lex_state = 35},
  [6061] = {.lex_state = 35},
  [6062] = {.lex_state = 35},
  [6063] = {.lex_state = 35},
  [6064] = {.lex_state = 35},
  [6065] = {.lex_state = 35},
  [6066] = {.lex_state = 35},
  [6067] = {.lex_state = 35},
  [6068] = {.lex_state = 35},
  [6069] = {.lex_state = 35},
  [6070] = {.lex_state = 35},
  [6071] = {.lex_state = 35},
  [6072] = {.lex_state = 35},
  [6073] = {.lex_state = 35},
  [6074] = {.lex_state = 35},
  [6075] = {.lex_state = 35},
  [6076] = {.lex_state = 35},
  [6077] = {.lex_state = 35},
  [6078] = {.lex_state = 35},
  [6079] = {.lex_state = 35},
  [6080] = {.lex_state = 35},
  [6081] = {.lex_state = 35},
  [6082] = {.lex_state = 35},
  [6083] = {.lex_state = 35},
  [6084] = {.lex_state = 35},
  [6085] = {.lex_state = 35},
  [6086] = {.lex_state = 35},
  [6087] = {.lex_state = 35},
  [6088] = {.lex_state = 35},
  [6089] = {.lex_state = 35},
  [6090] = {.lex_state = 35},
  [6091] = {.lex_state = 35},
  [6092] = {.lex_state = 35},
  [6093] = {.lex_state = 35},
  [6094] = {.lex_state = 35},
  [6095] = {.lex_state = 35},
  [6096] = {.lex_state = 35},
  [6097] = {.lex_state = 35},
  [6098] = {.lex_state = 35},
  [6099] = {.lex_state = 35},
  [6100] = {.lex_state = 35},
  [6101] = {.lex_state = 35},
  [6102] = {.lex_state = 35},
  [6103] = {.lex_state = 35},
  [6104] = {.lex_state = 35},
  [6105] = {.lex_state = 35},
  [6106] = {.lex_state = 35},
  [6107] = {.lex_state = 35},
  [6108] = {.lex_state = 35},
  [6109] = {.lex_state = 35},
  [6110] = {.lex_state = 35},
  [6111] = {.lex_state = 35},
  [6112] = {.lex_state = 35},
  [6113] = {.lex_state = 35},
  [6114] = {.lex_state = 33, .external_lex_state = 4},
  [6115] = {.lex_state = 35},
  [6116] = {.lex_state = 35},
  [6117] = {.lex_state = 35},
  [6118] = {.lex_state = 35},
  [6119] = {.lex_state = 35},
  [6120] = {.lex_state = 35},
  [6121] = {.lex_state = 35},
  [6122] = {.lex_state = 35},
  [6123] = {.lex_state = 35},
  [6124] = {.lex_state = 35},
  [6125] = {.lex_state = 35},
  [6126] = {.lex_state = 35},
  [6127] = {.lex_state = 35},
  [6128] = {.lex_state = 35},
  [6129] = {.lex_state = 35},
  [6130] = {.lex_state = 35},
  [6131] = {.lex_state = 35},
  [6132] = {.lex_state = 35},
  [6133] = {.lex_state = 35},
  [6134] = {.lex_state = 35},
  [6135] = {.lex_state = 35},
  [6136] = {.lex_state = 35},
  [6137] = {.lex_state = 35},
  [6138] = {.lex_state = 35},
  [6139] = {.lex_state = 35},
  [6140] = {.lex_state = 35},
  [6141] = {.lex_state = 35},
  [6142] = {.lex_state = 35},
  [6143] = {.lex_state = 35},
  [6144] = {.lex_state = 35},
  [6145] = {.lex_state = 35},
  [6146] = {.lex_state = 35},
  [6147] = {.lex_state = 35},
  [6148] = {.lex_state = 35},
  [6149] = {.lex_state = 35},
  [6150] = {.lex_state = 35},
  [6151] = {.lex_state = 35},
  [6152] = {.lex_state = 35},
  [6153] = {.lex_state = 35},
  [6154] = {.lex_state = 35},
  [6155] = {.lex_state = 35},
  [6156] = {.lex_state = 35},
  [6157] = {.lex_state = 35},
  [6158] = {.lex_state = 33, .external_lex_state = 4},
  [6159] = {.lex_state = 35},
  [6160] = {.lex_state = 35},
  [6161] = {.lex_state = 35},
  [6162] = {.lex_state = 35},
  [6163] = {.lex_state = 35},
  [6164] = {.lex_state = 35},
  [6165] = {.lex_state = 35},
  [6166] = {.lex_state = 33, .external_lex_state = 4},
  [6167] = {.lex_state = 33, .external_lex_state = 4},
  [6168] = {.lex_state = 33, .external_lex_state = 4},
  [6169] = {.lex_state = 35},
  [6170] = {.lex_state = 35},
  [6171] = {.lex_state = 35},
  [6172] = {.lex_state = 35},
  [6173] = {.lex_state = 35},
  [6174] = {.lex_state = 35},
  [6175] = {.lex_state = 35},
  [6176] = {.lex_state = 35},
  [6177] = {.lex_state = 35},
  [6178] = {.lex_state = 33, .external_lex_state = 4},
  [6179] = {.lex_state = 35, .external_lex_state = 2},
  [6180] = {.lex_state = 35},
  [6181] = {.lex_state = 35},
  [6182] = {.lex_state = 35},
  [6183] = {.lex_state = 35},
  [6184] = {.lex_state = 35},
  [6185] = {.lex_state = 35},
  [6186] = {.lex_state = 35},
  [6187] = {.lex_state = 35},
  [6188] = {.lex_state = 35},
  [6189] = {.lex_state = 35},
  [6190] = {.lex_state = 35},
  [6191] = {.lex_state = 35},
  [6192] = {.lex_state = 33, .external_lex_state = 3},
  [6193] = {.lex_state = 35},
  [6194] = {.lex_state = 35},
  [6195] = {.lex_state = 35},
  [6196] = {.lex_state = 35},
  [6197] = {.lex_state = 35},
  [6198] = {.lex_state = 35},
  [6199] = {.lex_state = 35},
  [6200] = {.lex_state = 35},
  [6201] = {.lex_state = 35},
  [6202] = {.lex_state = 33, .external_lex_state = 4},
  [6203] = {.lex_state = 35},
  [6204] = {.lex_state = 35},
  [6205] = {.lex_state = 35},
  [6206] = {.lex_state = 35},
  [6207] = {.lex_state = 35},
  [6208] = {.lex_state = 35},
  [6209] = {.lex_state = 35},
  [6210] = {.lex_state = 35},
  [6211] = {.lex_state = 33, .external_lex_state = 3},
  [6212] = {.lex_state = 35},
  [6213] = {.lex_state = 35},
  [6214] = {.lex_state = 35},
  [6215] = {.lex_state = 35},
  [6216] = {.lex_state = 35},
  [6217] = {.lex_state = 35},
  [6218] = {.lex_state = 35},
  [6219] = {.lex_state = 33, .external_lex_state = 3},
  [6220] = {.lex_state = 35},
  [6221] = {.lex_state = 35},
  [6222] = {.lex_state = 35},
  [6223] = {.lex_state = 35},
  [6224] = {.lex_state = 35},
  [6225] = {.lex_state = 35},
  [6226] = {.lex_state = 35},
  [6227] = {.lex_state = 35},
  [6228] = {.lex_state = 35},
  [6229] = {.lex_state = 35},
  [6230] = {.lex_state = 35},
  [6231] = {.lex_state = 35},
  [6232] = {.lex_state = 35},
  [6233] = {.lex_state = 35},
  [6234] = {.lex_state = 35},
  [6235] = {.lex_state = 35},
  [6236] = {.lex_state = 35},
  [6237] = {.lex_state = 35},
  [6238] = {.lex_state = 35},
  [6239] = {.lex_state = 35},
  [6240] = {.lex_state = 35},
  [6241] = {.lex_state = 35},
  [6242] = {.lex_state = 35},
  [6243] = {.lex_state = 35},
  [6244] = {.lex_state = 35},
  [6245] = {.lex_state = 35},
  [6246] = {.lex_state = 35},
  [6247] = {.lex_state = 35},
  [6248] = {.lex_state = 35},
  [6249] = {.lex_state = 35},
  [6250] = {.lex_state = 35},
  [6251] = {.lex_state = 35},
  [6252] = {.lex_state = 35},
  [6253] = {.lex_state = 35},
  [6254] = {.lex_state = 35},
  [6255] = {.lex_state = 35},
  [6256] = {.lex_state = 35},
  [6257] = {.lex_state = 35},
  [6258] = {.lex_state = 35},
  [6259] = {.lex_state = 35},
  [6260] = {.lex_state = 35},
  [6261] = {.lex_state = 35},
  [6262] = {.lex_state = 35},
  [6263] = {.lex_state = 35},
  [6264] = {.lex_state = 35},
  [6265] = {.lex_state = 35},
  [6266] = {.lex_state = 35},
  [6267] = {.lex_state = 35},
  [6268] = {.lex_state = 35},
  [6269] = {.lex_state = 35},
  [6270] = {.lex_state = 35},
  [6271] = {.lex_state = 35},
  [6272] = {.lex_state = 35},
  [6273] = {.lex_state = 35},
  [6274] = {.lex_state = 35},
  [6275] = {.lex_state = 35},
  [6276] = {.lex_state = 35},
  [6277] = {.lex_state = 35},
  [6278] = {.lex_state = 35},
  [6279] = {.lex_state = 35},
  [6280] = {.lex_state = 35},
  [6281] = {.lex_state = 35},
  [6282] = {.lex_state = 35},
  [6283] = {.lex_state = 35},
  [6284] = {.lex_state = 35},
  [6285] = {.lex_state = 35},
  [6286] = {.lex_state = 35},
  [6287] = {.lex_state = 35},
  [6288] = {.lex_state = 35},
  [6289] = {.lex_state = 35},
  [6290] = {.lex_state = 35},
  [6291] = {.lex_state = 35},
  [6292] = {.lex_state = 33, .external_lex_state = 3},
  [6293] = {.lex_state = 35},
  [6294] = {.lex_state = 35},
  [6295] = {.lex_state = 35},
  [6296] = {.lex_state = 33, .external_lex_state = 3},
  [6297] = {.lex_state = 35},
  [6298] = {.lex_state = 35},
  [6299] = {.lex_state = 35},
  [6300] = {.lex_state = 35},
  [6301] = {.lex_state = 35},
  [6302] = {.lex_state = 35},
  [6303] = {.lex_state = 35},
  [6304] = {.lex_state = 35},
  [6305] = {.lex_state = 35},
  [6306] = {.lex_state = 35},
  [6307] = {.lex_state = 35},
  [6308] = {.lex_state = 35},
  [6309] = {.lex_state = 35},
  [6310] = {.lex_state = 35},
  [6311] = {.lex_state = 35},
  [6312] = {.lex_state = 35},
  [6313] = {.lex_state = 35},
  [6314] = {.lex_state = 35},
  [6315] = {.lex_state = 35},
  [6316] = {.lex_state = 35},
  [6317] = {.lex_state = 35},
  [6318] = {.lex_state = 35},
  [6319] = {.lex_state = 35},
  [6320] = {.lex_state = 35},
  [6321] = {.lex_state = 35},
  [6322] = {.lex_state = 35},
  [6323] = {.lex_state = 35},
  [6324] = {.lex_state = 35},
  [6325] = {.lex_state = 35},
  [6326] = {.lex_state = 35},
  [6327] = {.lex_state = 35},
  [6328] = {.lex_state = 35},
  [6329] = {.lex_state = 33, .external_lex_state = 3},
  [6330] = {.lex_state = 35},
  [6331] = {.lex_state = 35},
  [6332] = {.lex_state = 35},
  [6333] = {.lex_state = 35},
  [6334] = {.lex_state = 35},
  [6335] = {.lex_state = 35},
  [6336] = {.lex_state = 35},
  [6337] = {.lex_state = 33, .external_lex_state = 3},
  [6338] = {.lex_state = 35},
  [6339] = {.lex_state = 33, .external_lex_state = 3},
  [6340] = {.lex_state = 33, .external_lex_state = 3},
  [6341] = {.lex_state = 33, .external_lex_state = 3},
  [6342] = {.lex_state = 35, .external_lex_state = 2},
  [6343] = {.lex_state = 33, .external_lex_state = 3},
  [6344] = {.lex_state = 35},
  [6345] = {.lex_state = 35, .external_lex_state = 2},
  [6346] = {.lex_state = 35, .external_lex_state = 2},
  [6347] = {.lex_state = 35, .external_lex_state = 2},
  [6348] = {.lex_state = 35},
  [6349] = {.lex_state = 33, .external_lex_state = 3},
  [6350] = {.lex_state = 35},
  [6351] = {.lex_state = 35},
  [6352] = {.lex_state = 33, .external_lex_state = 3},
  [6353] = {.lex_state = 35},
  [6354] = {.lex_state = 35},
  [6355] = {.lex_state = 33, .external_lex_state = 3},
  [6356] = {.lex_state = 33, .external_lex_state = 3},
  [6357] = {.lex_state = 35, .external_lex_state = 2},
  [6358] = {.lex_state = 35, .external_lex_state = 2},
  [6359] = {.lex_state = 35},
  [6360] = {.lex_state = 33, .external_lex_state = 3},
  [6361] = {.lex_state = 33, .external_lex_state = 3},
  [6362] = {.lex_state = 33, .external_lex_state = 3},
  [6363] = {.lex_state = 33, .external_lex_state = 3},
  [6364] = {.lex_state = 35},
  [6365] = {.lex_state = 33, .external_lex_state = 3},
  [6366] = {.lex_state = 35},
  [6367] = {.lex_state = 33, .external_lex_state = 3},
  [6368] = {.lex_state = 35},
  [6369] = {.lex_state = 33, .external_lex_state = 3},
  [6370] = {.lex_state = 35},
  [6371] = {.lex_state = 33, .external_lex_state = 3},
  [6372] = {.lex_state = 33, .external_lex_state = 3},
  [6373] = {.lex_state = 33, .external_lex_state = 3},
  [6374] = {.lex_state = 33, .external_lex_state = 3},
  [6375] = {.lex_state = 35},
  [6376] = {.lex_state = 35},
  [6377] = {.lex_state = 35},
  [6378] = {.lex_state = 33, .external_lex_state = 3},
  [6379] = {.lex_state = 33, .external_lex_state = 3},
  [6380] = {.lex_state = 33, .external_lex_state = 3},
  [6381] = {.lex_state = 33, .external_lex_state = 3},
  [6382] = {.lex_state = 33, .external_lex_state = 3},
  [6383] = {.lex_state = 35},
  [6384] = {.lex_state = 35},
  [6385] = {.lex_state = 35},
  [6386] = {.lex_state = 35},
  [6387] = {.lex_state = 35},
  [6388] = {.lex_state = 33, .external_lex_state = 3},
  [6389] = {.lex_state = 33, .external_lex_state = 3},
  [6390] = {.lex_state = 35},
  [6391] = {.lex_state = 35},
  [6392] = {.lex_state = 35},
  [6393] = {.lex_state = 35},
  [6394] = {.lex_state = 35},
  [6395] = {.lex_state = 35},
  [6396] = {.lex_state = 35},
  [6397] = {.lex_state = 35},
  [6398] = {.lex_state = 35},
  [6399] = {.lex_state = 35},
  [6400] = {.lex_state = 35},
  [6401] = {.lex_state = 35},
  [6402] = {.lex_state = 35},
  [6403] = {.lex_state = 35},
  [6404] = {.lex_state = 35},
  [6405] = {.lex_state = 35},
  [6406] = {.lex_state = 35},
  [6407] = {.lex_state = 35},
  [6408] = {.lex_state = 35},
  [6409] = {.lex_state = 35},
  [6410] = {.lex_state = 35},
  [6411] = {.lex_state = 35},
  [6412] = {.lex_state = 35},
  [6413] = {.lex_state = 35},
  [6414] = {.lex_state = 36},
  [6415] = {.lex_state = 35},
  [6416] = {.lex_state = 35},
  [6417] = {.lex_state = 35, .external_lex_state = 2},
  [6418] = {.lex_state = 35, .external_lex_state = 2},
  [6419] = {.lex_state = 35, .external_lex_state = 2},
  [6420] = {.lex_state = 35, .external_lex_state = 2},
  [6421] = {.lex_state = 35},
  [6422] = {.lex_state = 35},
  [6423] = {.lex_state = 35, .external_lex_state = 2},
  [6424] = {.lex_state = 35, .external_lex_state = 2},
  [6425] = {.lex_state = 35, .external_lex_state = 2},
  [6426] = {.lex_state = 35},
  [6427] = {.lex_state = 35},
  [6428] = {.lex_state = 33},
  [6429] = {.lex_state = 35},
  [6430] = {.lex_state = 33, .external_lex_state = 3},
  [6431] = {.lex_state = 35},
  [6432] = {.lex_state = 35},
  [6433] = {.lex_state = 33, .external_lex_state = 3},
  [6434] = {.lex_state = 35},
  [6435] = {.lex_state = 35},
  [6436] = {.lex_state = 35},
  [6437] = {.lex_state = 35},
  [6438] = {.lex_state = 35},
  [6439] = {.lex_state = 35},
  [6440] = {.lex_state = 35},
  [6441] = {.lex_state = 35},
  [6442] = {.lex_state = 35},
  [6443] = {.lex_state = 35},
  [6444] = {.lex_state = 35},
  [6445] = {.lex_state = 35},
  [6446] = {.lex_state = 35},
  [6447] = {.lex_state = 33, .external_lex_state = 3},
  [6448] = {.lex_state = 35},
  [6449] = {.lex_state = 35},
  [6450] = {.lex_state = 35},
  [6451] = {.lex_state = 35},
  [6452] = {.lex_state = 35},
  [6453] = {.lex_state = 35},
  [6454] = {.lex_state = 33, .external_lex_state = 3},
  [6455] = {.lex_state = 35},
  [6456] = {.lex_state = 33, .external_lex_state = 3},
  [6457] = {.lex_state = 35},
  [6458] = {.lex_state = 35},
  [6459] = {.lex_state = 35},
  [6460] = {.lex_state = 35},
  [6461] = {.lex_state = 35},
  [6462] = {.lex_state = 35},
  [6463] = {.lex_state = 33, .external_lex_state = 3},
  [6464] = {.lex_state = 35},
  [6465] = {.lex_state = 33, .external_lex_state = 3},
  [6466] = {.lex_state = 35},
  [6467] = {.lex_state = 35},
  [6468] = {.lex_state = 35},
  [6469] = {.lex_state = 35},
  [6470] = {.lex_state = 35},
  [6471] = {.lex_state = 35},
  [6472] = {.lex_state = 35},
  [6473] = {.lex_state = 35},
  [6474] = {.lex_state = 35},
  [6475] = {.lex_state = 35},
  [6476] = {.lex_state = 35},
  [6477] = {.lex_state = 35, .external_lex_state = 2},
  [6478] = {.lex_state = 35},
  [6479] = {.lex_state = 35},
  [6480] = {.lex_state = 35},
  [6481] = {.lex_state = 35},
  [6482] = {.lex_state = 35},
  [6483] = {.lex_state = 35, .external_lex_state = 2},
  [6484] = {.lex_state = 35},
  [6485] = {.lex_state = 35},
  [6486] = {.lex_state = 33},
  [6487] = {.lex_state = 35},
  [6488] = {.lex_state = 35, .external_lex_state = 2},
  [6489] = {.lex_state = 35},
  [6490] = {.lex_state = 35},
  [6491] = {.lex_state = 35},
  [6492] = {.lex_state = 35},
  [6493] = {.lex_state = 35},
  [6494] = {.lex_state = 35},
  [6495] = {.lex_state = 35},
  [6496] = {.lex_state = 35, .external_lex_state = 2},
  [6497] = {.lex_state = 35, .external_lex_state = 2},
  [6498] = {.lex_state = 35, .external_lex_state = 2},
  [6499] = {.lex_state = 35, .external_lex_state = 2},
  [6500] = {.lex_state = 35, .external_lex_state = 2},
  [6501] = {.lex_state = 35, .external_lex_state = 2},
  [6502] = {.lex_state = 35},
  [6503] = {.lex_state = 35},
  [6504] = {.lex_state = 35},
  [6505] = {.lex_state = 35},
  [6506] = {.lex_state = 35},
  [6507] = {.lex_state = 35},
  [6508] = {.lex_state = 33, .external_lex_state = 3},
  [6509] = {.lex_state = 35},
  [6510] = {.lex_state = 35, .external_lex_state = 2},
  [6511] = {.lex_state = 35},
  [6512] = {.lex_state = 35},
  [6513] = {.lex_state = 35},
  [6514] = {.lex_state = 35},
  [6515] = {.lex_state = 35, .external_lex_state = 2},
  [6516] = {.lex_state = 33, .external_lex_state = 3},
  [6517] = {.lex_state = 35, .external_lex_state = 2},
  [6518] = {.lex_state = 35, .external_lex_state = 2},
  [6519] = {.lex_state = 35},
  [6520] = {.lex_state = 35},
  [6521] = {.lex_state = 35, .external_lex_state = 2},
  [6522] = {.lex_state = 35},
  [6523] = {.lex_state = 35, .external_lex_state = 2},
  [6524] = {.lex_state = 35, .external_lex_state = 2},
  [6525] = {.lex_state = 35, .external_lex_state = 2},
  [6526] = {.lex_state = 35},
  [6527] = {.lex_state = 35},
  [6528] = {.lex_state = 35},
  [6529] = {.lex_state = 35},
  [6530] = {.lex_state = 35},
  [6531] = {.lex_state = 35, .external_lex_state = 2},
  [6532] = {.lex_state = 35, .external_lex_state = 2},
  [6533] = {.lex_state = 35},
  [6534] = {.lex_state = 35},
  [6535] = {.lex_state = 33, .external_lex_state = 3},
  [6536] = {.lex_state = 35, .external_lex_state = 2},
  [6537] = {.lex_state = 35, .external_lex_state = 2},
  [6538] = {.lex_state = 35, .external_lex_state = 2},
  [6539] = {.lex_state = 35, .external_lex_state = 2},
  [6540] = {.lex_state = 35},
  [6541] = {.lex_state = 35},
  [6542] = {.lex_state = 35, .external_lex_state = 2},
  [6543] = {.lex_state = 35},
  [6544] = {.lex_state = 35},
  [6545] = {.lex_state = 35},
  [6546] = {.lex_state = 35},
  [6547] = {.lex_state = 35, .external_lex_state = 2},
  [6548] = {.lex_state = 35},
  [6549] = {.lex_state = 35, .external_lex_state = 2},
  [6550] = {.lex_state = 35, .external_lex_state = 2},
  [6551] = {.lex_state = 33, .external_lex_state = 3},
  [6552] = {.lex_state = 35, .external_lex_state = 2},
  [6553] = {.lex_state = 35},
  [6554] = {.lex_state = 35, .external_lex_state = 2},
  [6555] = {.lex_state = 35, .external_lex_state = 2},
  [6556] = {.lex_state = 35, .external_lex_state = 2},
  [6557] = {.lex_state = 35, .external_lex_state = 2},
  [6558] = {.lex_state = 35, .external_lex_state = 2},
  [6559] = {.lex_state = 35, .external_lex_state = 2},
  [6560] = {.lex_state = 35, .external_lex_state = 2},
  [6561] = {.lex_state = 35},
  [6562] = {.lex_state = 35, .external_lex_state = 2},
  [6563] = {.lex_state = 35},
  [6564] = {.lex_state = 35},
  [6565] = {.lex_state = 35},
  [6566] = {.lex_state = 35, .external_lex_state = 2},
  [6567] = {.lex_state = 35},
  [6568] = {.lex_state = 35, .external_lex_state = 2},
  [6569] = {.lex_state = 35},
  [6570] = {.lex_state = 35, .external_lex_state = 2},
  [6571] = {.lex_state = 35},
  [6572] = {.lex_state = 35, .external_lex_state = 2},
  [6573] = {.lex_state = 35},
  [6574] = {.lex_state = 33, .external_lex_state = 4},
  [6575] = {.lex_state = 35},
  [6576] = {.lex_state = 35},
  [6577] = {.lex_state = 35},
  [6578] = {.lex_state = 35},
  [6579] = {.lex_state = 35},
  [6580] = {.lex_state = 35, .external_lex_state = 2},
  [6581] = {.lex_state = 35},
  [6582] = {.lex_state = 33, .external_lex_state = 4},
  [6583] = {.lex_state = 35},
  [6584] = {.lex_state = 33, .external_lex_state = 4},
  [6585] = {.lex_state = 35},
  [6586] = {.lex_state = 35},
  [6587] = {.lex_state = 35},
  [6588] = {.lex_state = 35, .external_lex_state = 2},
  [6589] = {.lex_state = 35},
  [6590] = {.lex_state = 35, .external_lex_state = 2},
  [6591] = {.lex_state = 1, .external_lex_state = 3},
  [6592] = {.lex_state = 35, .external_lex_state = 2},
  [6593] = {.lex_state = 33, .external_lex_state = 3},
  [6594] = {.lex_state = 35, .external_lex_state = 2},
  [6595] = {.lex_state = 35},
  [6596] = {.lex_state = 35, .external_lex_state = 2},
  [6597] = {.lex_state = 35, .external_lex_state = 2},
  [6598] = {.lex_state = 35, .external_lex_state = 2},
  [6599] = {.lex_state = 35, .external_lex_state = 2},
  [6600] = {.lex_state = 1, .external_lex_state = 3},
  [6601] = {.lex_state = 1, .external_lex_state = 3},
  [6602] = {.lex_state = 1, .external_lex_state = 3},
  [6603] = {.lex_state = 35},
  [6604] = {.lex_state = 35},
  [6605] = {.lex_state = 35, .external_lex_state = 2},
  [6606] = {.lex_state = 35},
  [6607] = {.lex_state = 35, .external_lex_state = 2},
  [6608] = {.lex_state = 35, .external_lex_state = 2},
  [6609] = {.lex_state = 1, .external_lex_state = 3},
  [6610] = {.lex_state = 35, .external_lex_state = 2},
  [6611] = {.lex_state = 35},
  [6612] = {.lex_state = 35},
  [6613] = {.lex_state = 35, .external_lex_state = 2},
  [6614] = {.lex_state = 35, .external_lex_state = 2},
  [6615] = {.lex_state = 35, .external_lex_state = 2},
  [6616] = {.lex_state = 35, .external_lex_state = 2},
  [6617] = {.lex_state = 1, .external_lex_state = 3},
  [6618] = {.lex_state = 35, .external_lex_state = 2},
  [6619] = {.lex_state = 35},
  [6620] = {.lex_state = 35},
  [6621] = {.lex_state = 35},
  [6622] = {.lex_state = 35},
  [6623] = {.lex_state = 35},
  [6624] = {.lex_state = 35},
  [6625] = {.lex_state = 33, .external_lex_state = 4},
  [6626] = {.lex_state = 35},
  [6627] = {.lex_state = 35},
  [6628] = {.lex_state = 35},
  [6629] = {.lex_state = 35},
  [6630] = {.lex_state = 35},
  [6631] = {.lex_state = 35},
  [6632] = {.lex_state = 35},
  [6633] = {.lex_state = 35},
  [6634] = {.lex_state = 35},
  [6635] = {.lex_state = 35},
  [6636] = {.lex_state = 1, .external_lex_state = 3},
  [6637] = {.lex_state = 35, .external_lex_state = 2},
  [6638] = {.lex_state = 35, .external_lex_state = 2},
  [6639] = {.lex_state = 35},
  [6640] = {.lex_state = 35},
  [6641] = {.lex_state = 35},
  [6642] = {.lex_state = 1, .external_lex_state = 3},
  [6643] = {.lex_state = 35},
  [6644] = {.lex_state = 1, .external_lex_state = 3},
  [6645] = {.lex_state = 35},
  [6646] = {.lex_state = 35},
  [6647] = {.lex_state = 33, .external_lex_state = 3},
  [6648] = {.lex_state = 1, .external_lex_state = 3},
  [6649] = {.lex_state = 33, .external_lex_state = 3},
  [6650] = {.lex_state = 33, .external_lex_state = 3},
  [6651] = {.lex_state = 35},
  [6652] = {.lex_state = 35},
  [6653] = {.lex_state = 35, .external_lex_state = 2},
  [6654] = {.lex_state = 35},
  [6655] = {.lex_state = 35},
  [6656] = {.lex_state = 35},
  [6657] = {.lex_state = 33, .external_lex_state = 3},
  [6658] = {.lex_state = 35, .external_lex_state = 2},
  [6659] = {.lex_state = 35, .external_lex_state = 2},
  [6660] = {.lex_state = 35},
  [6661] = {.lex_state = 35, .external_lex_state = 2},
  [6662] = {.lex_state = 35},
  [6663] = {.lex_state = 33, .external_lex_state = 3},
  [6664] = {.lex_state = 35},
  [6665] = {.lex_state = 35},
  [6666] = {.lex_state = 35},
  [6667] = {.lex_state = 33, .external_lex_state = 4},
  [6668] = {.lex_state = 35, .external_lex_state = 2},
  [6669] = {.lex_state = 35},
  [6670] = {.lex_state = 35, .external_lex_state = 2},
  [6671] = {.lex_state = 35},
  [6672] = {.lex_state = 35},
  [6673] = {.lex_state = 35, .external_lex_state = 2},
  [6674] = {.lex_state = 35},
  [6675] = {.lex_state = 1, .external_lex_state = 3},
  [6676] = {.lex_state = 35},
  [6677] = {.lex_state = 33, .external_lex_state = 4},
  [6678] = {.lex_state = 35},
  [6679] = {.lex_state = 33, .external_lex_state = 3},
  [6680] = {.lex_state = 35},
  [6681] = {.lex_state = 1, .external_lex_state = 3},
  [6682] = {.lex_state = 35},
  [6683] = {.lex_state = 35, .external_lex_state = 2},
  [6684] = {.lex_state = 35},
  [6685] = {.lex_state = 35},
  [6686] = {.lex_state = 33, .external_lex_state = 4},
  [6687] = {.lex_state = 33, .external_lex_state = 3},
  [6688] = {.lex_state = 35},
  [6689] = {.lex_state = 1, .external_lex_state = 3},
  [6690] = {.lex_state = 1, .external_lex_state = 3},
  [6691] = {.lex_state = 35},
  [6692] = {.lex_state = 35, .external_lex_state = 2},
  [6693] = {.lex_state = 35},
  [6694] = {.lex_state = 35},
  [6695] = {.lex_state = 35},
  [6696] = {.lex_state = 35},
  [6697] = {.lex_state = 35},
  [6698] = {.lex_state = 35},
  [6699] = {.lex_state = 33, .external_lex_state = 3},
  [6700] = {.lex_state = 33, .external_lex_state = 3},
  [6701] = {.lex_state = 35, .external_lex_state = 2},
  [6702] = {.lex_state = 33, .external_lex_state = 3},
  [6703] = {.lex_state = 1, .external_lex_state = 3},
  [6704] = {.lex_state = 1, .external_lex_state = 3},
  [6705] = {.lex_state = 33, .external_lex_state = 4},
  [6706] = {.lex_state = 33, .external_lex_state = 3},
  [6707] = {.lex_state = 1, .external_lex_state = 3},
  [6708] = {.lex_state = 1, .external_lex_state = 3},
  [6709] = {.lex_state = 1, .external_lex_state = 3},
  [6710] = {.lex_state = 35},
  [6711] = {.lex_state = 35},
  [6712] = {.lex_state = 33, .external_lex_state = 4},
  [6713] = {.lex_state = 35},
  [6714] = {.lex_state = 33, .external_lex_state = 3},
  [6715] = {.lex_state = 33, .external_lex_state = 3},
  [6716] = {.lex_state = 35},
  [6717] = {.lex_state = 33, .external_lex_state = 3},
  [6718] = {.lex_state = 33, .external_lex_state = 4},
  [6719] = {.lex_state = 35, .external_lex_state = 2},
  [6720] = {.lex_state = 35},
  [6721] = {.lex_state = 33, .external_lex_state = 3},
  [6722] = {.lex_state = 1, .external_lex_state = 3},
  [6723] = {.lex_state = 35, .external_lex_state = 2},
  [6724] = {.lex_state = 33, .external_lex_state = 3},
  [6725] = {.lex_state = 33, .external_lex_state = 3},
  [6726] = {.lex_state = 33, .external_lex_state = 3},
  [6727] = {.lex_state = 33, .external_lex_state = 3},
  [6728] = {.lex_state = 33, .external_lex_state = 3},
  [6729] = {.lex_state = 33, .external_lex_state = 3},
  [6730] = {.lex_state = 33, .external_lex_state = 3},
  [6731] = {.lex_state = 33, .external_lex_state = 3},
  [6732] = {.lex_state = 33, .external_lex_state = 3},
  [6733] = {.lex_state = 33, .external_lex_state = 3},
  [6734] = {.lex_state = 35},
  [6735] = {.lex_state = 1, .external_lex_state = 3},
  [6736] = {.lex_state = 33, .external_lex_state = 3},
  [6737] = {.lex_state = 33, .external_lex_state = 3},
  [6738] = {.lex_state = 35},
  [6739] = {.lex_state = 33, .external_lex_state = 3},
  [6740] = {.lex_state = 33, .external_lex_state = 3},
  [6741] = {.lex_state = 33, .external_lex_state = 3},
  [6742] = {.lex_state = 35, .external_lex_state = 2},
  [6743] = {.lex_state = 35},
  [6744] = {.lex_state = 35, .external_lex_state = 2},
  [6745] = {.lex_state = 33, .external_lex_state = 3},
  [6746] = {.lex_state = 1, .external_lex_state = 3},
  [6747] = {.lex_state = 33, .external_lex_state = 3},
  [6748] = {.lex_state = 1, .external_lex_state = 3},
  [6749] = {.lex_state = 35},
  [6750] = {.lex_state = 1, .external_lex_state = 3},
  [6751] = {.lex_state = 1, .external_lex_state = 3},
  [6752] = {.lex_state = 1, .external_lex_state = 3},
  [6753] = {.lex_state = 1, .external_lex_state = 3},
  [6754] = {.lex_state = 35},
  [6755] = {.lex_state = 35, .external_lex_state = 2},
  [6756] = {.lex_state = 33, .external_lex_state = 3},
  [6757] = {.lex_state = 35, .external_lex_state = 2},
  [6758] = {.lex_state = 35, .external_lex_state = 2},
  [6759] = {.lex_state = 33, .external_lex_state = 3},
  [6760] = {.lex_state = 35},
  [6761] = {.lex_state = 35},
  [6762] = {.lex_state = 35},
  [6763] = {.lex_state = 35},
  [6764] = {.lex_state = 33, .external_lex_state = 3},
  [6765] = {.lex_state = 35, .external_lex_state = 2},
  [6766] = {.lex_state = 33, .external_lex_state = 3},
  [6767] = {.lex_state = 33, .external_lex_state = 3},
  [6768] = {.lex_state = 33, .external_lex_state = 3},
  [6769] = {.lex_state = 35},
  [6770] = {.lex_state = 33, .external_lex_state = 3},
  [6771] = {.lex_state = 33, .external_lex_state = 3},
  [6772] = {.lex_state = 35, .external_lex_state = 2},
  [6773] = {.lex_state = 35, .external_lex_state = 2},
  [6774] = {.lex_state = 35, .external_lex_state = 2},
  [6775] = {.lex_state = 35, .external_lex_state = 2},
  [6776] = {.lex_state = 33, .external_lex_state = 3},
  [6777] = {.lex_state = 35, .external_lex_state = 2},
  [6778] = {.lex_state = 33, .external_lex_state = 4},
  [6779] = {.lex_state = 35},
  [6780] = {.lex_state = 35},
  [6781] = {.lex_state = 35},
  [6782] = {.lex_state = 35},
  [6783] = {.lex_state = 33, .external_lex_state = 4},
  [6784] = {.lex_state = 33, .external_lex_state = 4},
  [6785] = {.lex_state = 1, .external_lex_state = 3},
  [6786] = {.lex_state = 1, .external_lex_state = 3},
  [6787] = {.lex_state = 35},
  [6788] = {.lex_state = 1, .external_lex_state = 3},
  [6789] = {.lex_state = 33, .external_lex_state = 4},
  [6790] = {.lex_state = 1, .external_lex_state = 3},
  [6791] = {.lex_state = 35},
  [6792] = {.lex_state = 1, .external_lex_state = 3},
  [6793] = {.lex_state = 33, .external_lex_state = 4},
  [6794] = {.lex_state = 1, .external_lex_state = 3},
  [6795] = {.lex_state = 35, .external_lex_state = 2},
  [6796] = {.lex_state = 35},
  [6797] = {.lex_state = 35, .external_lex_state = 2},
  [6798] = {.lex_state = 35, .external_lex_state = 2},
  [6799] = {.lex_state = 35, .external_lex_state = 2},
  [6800] = {.lex_state = 35},
  [6801] = {.lex_state = 35},
  [6802] = {.lex_state = 33, .external_lex_state = 4},
  [6803] = {.lex_state = 1, .external_lex_state = 3},
  [6804] = {.lex_state = 33, .external_lex_state = 4},
  [6805] = {.lex_state = 33, .external_lex_state = 4},
  [6806] = {.lex_state = 1, .external_lex_state = 3},
  [6807] = {.lex_state = 33, .external_lex_state = 4},
  [6808] = {.lex_state = 35},
  [6809] = {.lex_state = 1, .external_lex_state = 3},
  [6810] = {.lex_state = 33, .external_lex_state = 4},
  [6811] = {.lex_state = 33, .external_lex_state = 4},
  [6812] = {.lex_state = 35},
  [6813] = {.lex_state = 33, .external_lex_state = 4},
  [6814] = {.lex_state = 33, .external_lex_state = 4},
  [6815] = {.lex_state = 33, .external_lex_state = 4},
  [6816] = {.lex_state = 33, .external_lex_state = 4},
  [6817] = {.lex_state = 35},
  [6818] = {.lex_state = 35, .external_lex_state = 2},
  [6819] = {.lex_state = 35, .external_lex_state = 2},
  [6820] = {.lex_state = 35},
  [6821] = {.lex_state = 1, .external_lex_state = 3},
  [6822] = {.lex_state = 35},
  [6823] = {.lex_state = 33, .external_lex_state = 4},
  [6824] = {.lex_state = 33, .external_lex_state = 4},
  [6825] = {.lex_state = 33, .external_lex_state = 4},
  [6826] = {.lex_state = 33, .external_lex_state = 4},
  [6827] = {.lex_state = 35},
  [6828] = {.lex_state = 1, .external_lex_state = 3},
  [6829] = {.lex_state = 35, .external_lex_state = 2},
  [6830] = {.lex_state = 35},
  [6831] = {.lex_state = 33, .external_lex_state = 4},
  [6832] = {.lex_state = 33, .external_lex_state = 4},
  [6833] = {.lex_state = 33, .external_lex_state = 4},
  [6834] = {.lex_state = 1, .external_lex_state = 3},
  [6835] = {.lex_state = 33, .external_lex_state = 4},
  [6836] = {.lex_state = 33, .external_lex_state = 4},
  [6837] = {.lex_state = 1, .external_lex_state = 3},
  [6838] = {.lex_state = 35},
  [6839] = {.lex_state = 33, .external_lex_state = 4},
  [6840] = {.lex_state = 33, .external_lex_state = 4},
  [6841] = {.lex_state = 1, .external_lex_state = 3},
  [6842] = {.lex_state = 33, .external_lex_state = 4},
  [6843] = {.lex_state = 1, .external_lex_state = 3},
  [6844] = {.lex_state = 1, .external_lex_state = 3},
  [6845] = {.lex_state = 1, .external_lex_state = 3},
  [6846] = {.lex_state = 1, .external_lex_state = 3},
  [6847] = {.lex_state = 1, .external_lex_state = 3},
  [6848] = {.lex_state = 1, .external_lex_state = 3},
  [6849] = {.lex_state = 33, .external_lex_state = 4},
  [6850] = {.lex_state = 35},
  [6851] = {.lex_state = 1, .external_lex_state = 3},
  [6852] = {.lex_state = 1, .external_lex_state = 3},
  [6853] = {.lex_state = 1, .external_lex_state = 3},
  [6854] = {.lex_state = 1, .external_lex_state = 3},
  [6855] = {.lex_state = 33, .external_lex_state = 4},
  [6856] = {.lex_state = 35},
  [6857] = {.lex_state = 35},
  [6858] = {.lex_state = 33, .external_lex_state = 4},
  [6859] = {.lex_state = 1, .external_lex_state = 3},
  [6860] = {.lex_state = 35},
  [6861] = {.lex_state = 1, .external_lex_state = 3},
  [6862] = {.lex_state = 33, .external_lex_state = 4},
  [6863] = {.lex_state = 35, .external_lex_state = 2},
  [6864] = {.lex_state = 33, .external_lex_state = 4},
  [6865] = {.lex_state = 33, .external_lex_state = 4},
  [6866] = {.lex_state = 33, .external_lex_state = 4},
  [6867] = {.lex_state = 1, .external_lex_state = 3},
  [6868] = {.lex_state = 1, .external_lex_state = 3},
  [6869] = {.lex_state = 35, .external_lex_state = 2},
  [6870] = {.lex_state = 1, .external_lex_state = 3},
  [6871] = {.lex_state = 1, .external_lex_state = 3},
  [6872] = {.lex_state = 33, .external_lex_state = 4},
  [6873] = {.lex_state = 35},
  [6874] = {.lex_state = 35},
  [6875] = {.lex_state = 35},
  [6876] = {.lex_state = 35},
  [6877] = {.lex_state = 35},
  [6878] = {.lex_state = 35},
  [6879] = {.lex_state = 35, .external_lex_state = 2},
  [6880] = {.lex_state = 35, .external_lex_state = 2},
  [6881] = {.lex_state = 35},
  [6882] = {.lex_state = 35},
  [6883] = {.lex_state = 35},
  [6884] = {.lex_state = 35},
  [6885] = {.lex_state = 35},
  [6886] = {.lex_state = 35},
  [6887] = {.lex_state = 35},
  [6888] = {.lex_state = 35},
  [6889] = {.lex_state = 35},
  [6890] = {.lex_state = 35},
  [6891] = {.lex_state = 35, .external_lex_state = 2},
  [6892] = {.lex_state = 35},
  [6893] = {.lex_state = 35},
  [6894] = {.lex_state = 35},
  [6895] = {.lex_state = 35, .external_lex_state = 2},
  [6896] = {.lex_state = 35},
  [6897] = {.lex_state = 35, .external_lex_state = 2},
  [6898] = {.lex_state = 35, .external_lex_state = 2},
  [6899] = {.lex_state = 35, .external_lex_state = 2},
  [6900] = {.lex_state = 35, .external_lex_state = 2},
  [6901] = {.lex_state = 35, .external_lex_state = 2},
  [6902] = {.lex_state = 35, .external_lex_state = 2},
  [6903] = {.lex_state = 35, .external_lex_state = 2},
  [6904] = {.lex_state = 35, .external_lex_state = 2},
  [6905] = {.lex_state = 35, .external_lex_state = 2},
  [6906] = {.lex_state = 35, .external_lex_state = 2},
  [6907] = {.lex_state = 35, .external_lex_state = 2},
  [6908] = {.lex_state = 35, .external_lex_state = 2},
  [6909] = {.lex_state = 35, .external_lex_state = 2},
  [6910] = {.lex_state = 35, .external_lex_state = 2},
  [6911] = {.lex_state = 35, .external_lex_state = 2},
  [6912] = {.lex_state = 35, .external_lex_state = 2},
  [6913] = {.lex_state = 35, .external_lex_state = 2},
  [6914] = {.lex_state = 35, .external_lex_state = 2},
  [6915] = {.lex_state = 35, .external_lex_state = 2},
  [6916] = {.lex_state = 35, .external_lex_state = 2},
  [6917] = {.lex_state = 35, .external_lex_state = 2},
  [6918] = {.lex_state = 35},
  [6919] = {.lex_state = 35},
  [6920] = {.lex_state = 35, .external_lex_state = 2},
  [6921] = {.lex_state = 35},
  [6922] = {.lex_state = 35, .external_lex_state = 2},
  [6923] = {.lex_state = 35, .external_lex_state = 2},
  [6924] = {.lex_state = 35, .external_lex_state = 2},
  [6925] = {.lex_state = 35, .external_lex_state = 2},
  [6926] = {.lex_state = 35, .external_lex_state = 2},
  [6927] = {.lex_state = 35, .external_lex_state = 2},
  [6928] = {.lex_state = 35, .external_lex_state = 2},
  [6929] = {.lex_state = 35, .external_lex_state = 2},
  [6930] = {.lex_state = 35, .external_lex_state = 2},
  [6931] = {.lex_state = 35},
  [6932] = {.lex_state = 35, .external_lex_state = 2},
  [6933] = {.lex_state = 35},
  [6934] = {.lex_state = 35, .external_lex_state = 2},
  [6935] = {.lex_state = 35, .external_lex_state = 2},
  [6936] = {.lex_state = 35, .external_lex_state = 2},
  [6937] = {.lex_state = 35, .external_lex_state = 2},
  [6938] = {.lex_state = 35, .external_lex_state = 2},
  [6939] = {.lex_state = 35, .external_lex_state = 2},
  [6940] = {.lex_state = 35, .external_lex_state = 2},
  [6941] = {.lex_state = 35, .external_lex_state = 2},
  [6942] = {.lex_state = 35, .external_lex_state = 2},
  [6943] = {.lex_state = 35, .external_lex_state = 2},
  [6944] = {.lex_state = 35, .external_lex_state = 2},
  [6945] = {.lex_state = 35},
  [6946] = {.lex_state = 35, .external_lex_state = 2},
  [6947] = {.lex_state = 35},
  [6948] = {.lex_state = 35, .external_lex_state = 2},
  [6949] = {.lex_state = 35},
  [6950] = {.lex_state = 35, .external_lex_state = 2},
  [6951] = {.lex_state = 35, .external_lex_state = 2},
  [6952] = {.lex_state = 35, .external_lex_state = 2},
  [6953] = {.lex_state = 35},
  [6954] = {.lex_state = 35},
  [6955] = {.lex_state = 35, .external_lex_state = 2},
  [6956] = {.lex_state = 35},
  [6957] = {.lex_state = 35, .external_lex_state = 2},
  [6958] = {.lex_state = 35, .external_lex_state = 2},
  [6959] = {.lex_state = 35, .external_lex_state = 2},
  [6960] = {.lex_state = 35, .external_lex_state = 2},
  [6961] = {.lex_state = 35},
  [6962] = {.lex_state = 35, .external_lex_state = 2},
  [6963] = {.lex_state = 35},
  [6964] = {.lex_state = 35},
  [6965] = {.lex_state = 35},
  [6966] = {.lex_state = 35},
  [6967] = {.lex_state = 35},
  [6968] = {.lex_state = 35},
  [6969] = {.lex_state = 35, .external_lex_state = 2},
  [6970] = {.lex_state = 35, .external_lex_state = 2},
  [6971] = {.lex_state = 35},
  [6972] = {.lex_state = 35},
  [6973] = {.lex_state = 35},
  [6974] = {.lex_state = 35},
  [6975] = {.lex_state = 35, .external_lex_state = 2},
  [6976] = {.lex_state = 35},
  [6977] = {.lex_state = 35},
  [6978] = {.lex_state = 35},
  [6979] = {.lex_state = 35},
  [6980] = {.lex_state = 35},
  [6981] = {.lex_state = 35},
  [6982] = {.lex_state = 35},
  [6983] = {.lex_state = 35, .external_lex_state = 2},
  [6984] = {.lex_state = 35, .external_lex_state = 2},
  [6985] = {.lex_state = 35},
  [6986] = {.lex_state = 35, .external_lex_state = 2},
  [6987] = {.lex_state = 35},
  [6988] = {.lex_state = 35},
  [6989] = {.lex_state = 35, .external_lex_state = 2},
  [6990] = {.lex_state = 35},
  [6991] = {.lex_state = 35, .external_lex_state = 2},
  [6992] = {.lex_state = 35},
  [6993] = {.lex_state = 35},
  [6994] = {.lex_state = 35, .external_lex_state = 2},
  [6995] = {.lex_state = 35, .external_lex_state = 2},
  [6996] = {.lex_state = 35, .external_lex_state = 2},
  [6997] = {.lex_state = 35, .external_lex_state = 2},
  [6998] = {.lex_state = 35},
  [6999] = {.lex_state = 35, .external_lex_state = 2},
  [7000] = {.lex_state = 35},
  [7001] = {.lex_state = 35, .external_lex_state = 2},
  [7002] = {.lex_state = 35},
  [7003] = {.lex_state = 35, .external_lex_state = 2},
  [7004] = {.lex_state = 35, .external_lex_state = 2},
  [7005] = {.lex_state = 35},
  [7006] = {.lex_state = 35, .external_lex_state = 2},
  [7007] = {.lex_state = 35},
  [7008] = {.lex_state = 35},
  [7009] = {.lex_state = 35, .external_lex_state = 2},
  [7010] = {.lex_state = 35, .external_lex_state = 2},
  [7011] = {.lex_state = 35},
  [7012] = {.lex_state = 35},
  [7013] = {.lex_state = 35},
  [7014] = {.lex_state = 35},
  [7015] = {.lex_state = 35, .external_lex_state = 2},
  [7016] = {.lex_state = 35},
  [7017] = {.lex_state = 35, .external_lex_state = 2},
  [7018] = {.lex_state = 35},
  [7019] = {.lex_state = 35},
  [7020] = {.lex_state = 35, .external_lex_state = 2},
  [7021] = {.lex_state = 35},
  [7022] = {.lex_state = 33, .external_lex_state = 3},
  [7023] = {.lex_state = 35, .external_lex_state = 2},
  [7024] = {.lex_state = 35},
  [7025] = {.lex_state = 35},
  [7026] = {.lex_state = 35},
  [7027] = {.lex_state = 35},
  [7028] = {.lex_state = 35, .external_lex_state = 2},
  [7029] = {.lex_state = 33, .external_lex_state = 3},
  [7030] = {.lex_state = 35},
  [7031] = {.lex_state = 35, .external_lex_state = 2},
  [7032] = {.lex_state = 35},
  [7033] = {.lex_state = 35, .external_lex_state = 2},
  [7034] = {.lex_state = 35, .external_lex_state = 2},
  [7035] = {.lex_state = 35, .external_lex_state = 2},
  [7036] = {.lex_state = 35, .external_lex_state = 2},
  [7037] = {.lex_state = 35, .external_lex_state = 2},
  [7038] = {.lex_state = 35, .external_lex_state = 2},
  [7039] = {.lex_state = 35, .external_lex_state = 2},
  [7040] = {.lex_state = 35, .external_lex_state = 2},
  [7041] = {.lex_state = 35, .external_lex_state = 2},
  [7042] = {.lex_state = 35, .external_lex_state = 2},
  [7043] = {.lex_state = 35, .external_lex_state = 2},
  [7044] = {.lex_state = 35, .external_lex_state = 2},
  [7045] = {.lex_state = 35},
  [7046] = {.lex_state = 35, .external_lex_state = 2},
  [7047] = {.lex_state = 35, .external_lex_state = 2},
  [7048] = {.lex_state = 35, .external_lex_state = 2},
  [7049] = {.lex_state = 35, .external_lex_state = 2},
  [7050] = {.lex_state = 35, .external_lex_state = 2},
  [7051] = {.lex_state = 35},
  [7052] = {.lex_state = 35, .external_lex_state = 2},
  [7053] = {.lex_state = 35, .external_lex_state = 2},
  [7054] = {.lex_state = 35},
  [7055] = {.lex_state = 35, .external_lex_state = 2},
  [7056] = {.lex_state = 35, .external_lex_state = 2},
  [7057] = {.lex_state = 35, .external_lex_state = 2},
  [7058] = {.lex_state = 35, .external_lex_state = 2},
  [7059] = {.lex_state = 35, .external_lex_state = 2},
  [7060] = {.lex_state = 35, .external_lex_state = 2},
  [7061] = {.lex_state = 35, .external_lex_state = 2},
  [7062] = {.lex_state = 35, .external_lex_state = 2},
  [7063] = {.lex_state = 35},
  [7064] = {.lex_state = 35, .external_lex_state = 2},
  [7065] = {.lex_state = 35, .external_lex_state = 2},
  [7066] = {.lex_state = 35, .external_lex_state = 2},
  [7067] = {.lex_state = 35, .external_lex_state = 2},
  [7068] = {.lex_state = 35, .external_lex_state = 2},
  [7069] = {.lex_state = 35, .external_lex_state = 2},
  [7070] = {.lex_state = 35, .external_lex_state = 2},
  [7071] = {.lex_state = 35, .external_lex_state = 2},
  [7072] = {.lex_state = 35, .external_lex_state = 2},
  [7073] = {.lex_state = 35, .external_lex_state = 2},
  [7074] = {.lex_state = 35, .external_lex_state = 2},
  [7075] = {.lex_state = 35, .external_lex_state = 2},
  [7076] = {.lex_state = 35, .external_lex_state = 2},
  [7077] = {.lex_state = 35, .external_lex_state = 2},
  [7078] = {.lex_state = 35, .external_lex_state = 2},
  [7079] = {.lex_state = 35, .external_lex_state = 2},
  [7080] = {.lex_state = 35, .external_lex_state = 2},
  [7081] = {.lex_state = 35, .external_lex_state = 2},
  [7082] = {.lex_state = 35, .external_lex_state = 2},
  [7083] = {.lex_state = 35, .external_lex_state = 2},
  [7084] = {.lex_state = 35, .external_lex_state = 2},
  [7085] = {.lex_state = 35, .external_lex_state = 2},
  [7086] = {.lex_state = 35, .external_lex_state = 2},
  [7087] = {.lex_state = 35, .external_lex_state = 2},
  [7088] = {.lex_state = 35, .external_lex_state = 2},
  [7089] = {.lex_state = 35, .external_lex_state = 2},
  [7090] = {.lex_state = 35, .external_lex_state = 2},
  [7091] = {.lex_state = 35, .external_lex_state = 2},
  [7092] = {.lex_state = 35, .external_lex_state = 2},
  [7093] = {.lex_state = 35, .external_lex_state = 2},
  [7094] = {.lex_state = 35, .external_lex_state = 2},
  [7095] = {.lex_state = 35, .external_lex_state = 2},
  [7096] = {.lex_state = 35, .external_lex_state = 2},
  [7097] = {.lex_state = 35, .external_lex_state = 2},
  [7098] = {.lex_state = 35, .external_lex_state = 2},
  [7099] = {.lex_state = 35, .external_lex_state = 2},
  [7100] = {.lex_state = 35, .external_lex_state = 2},
  [7101] = {.lex_state = 35, .external_lex_state = 2},
  [7102] = {.lex_state = 35},
  [7103] = {.lex_state = 35},
  [7104] = {.lex_state = 35},
  [7105] = {.lex_state = 35, .external_lex_state = 2},
  [7106] = {.lex_state = 35, .external_lex_state = 2},
  [7107] = {.lex_state = 35, .external_lex_state = 2},
  [7108] = {.lex_state = 35, .external_lex_state = 2},
  [7109] = {.lex_state = 35},
  [7110] = {.lex_state = 33},
  [7111] = {.lex_state = 35, .external_lex_state = 2},
  [7112] = {.lex_state = 35, .external_lex_state = 2},
  [7113] = {.lex_state = 35, .external_lex_state = 2},
  [7114] = {.lex_state = 35, .external_lex_state = 2},
  [7115] = {.lex_state = 35, .external_lex_state = 2},
  [7116] = {.lex_state = 35, .external_lex_state = 2},
  [7117] = {.lex_state = 35, .external_lex_state = 2},
  [7118] = {.lex_state = 35, .external_lex_state = 2},
  [7119] = {.lex_state = 35, .external_lex_state = 2},
  [7120] = {.lex_state = 36},
  [7121] = {.lex_state = 35, .external_lex_state = 2},
  [7122] = {.lex_state = 35, .external_lex_state = 2},
  [7123] = {.lex_state = 35, .external_lex_state = 2},
  [7124] = {.lex_state = 35},
  [7125] = {.lex_state = 35},
  [7126] = {.lex_state = 35},
  [7127] = {.lex_state = 36},
  [7128] = {.lex_state = 35, .external_lex_state = 2},
  [7129] = {.lex_state = 35},
  [7130] = {.lex_state = 35, .external_lex_state = 2},
  [7131] = {.lex_state = 35, .external_lex_state = 2},
  [7132] = {.lex_state = 35, .external_lex_state = 2},
  [7133] = {.lex_state = 35, .external_lex_state = 2},
  [7134] = {.lex_state = 35},
  [7135] = {.lex_state = 35, .external_lex_state = 2},
  [7136] = {.lex_state = 35, .external_lex_state = 2},
  [7137] = {.lex_state = 35, .external_lex_state = 2},
  [7138] = {.lex_state = 35, .external_lex_state = 2},
  [7139] = {.lex_state = 35, .external_lex_state = 2},
  [7140] = {.lex_state = 35, .external_lex_state = 2},
  [7141] = {.lex_state = 35, .external_lex_state = 2},
  [7142] = {.lex_state = 35, .external_lex_state = 2},
  [7143] = {.lex_state = 35, .external_lex_state = 2},
  [7144] = {.lex_state = 35, .external_lex_state = 2},
  [7145] = {.lex_state = 35, .external_lex_state = 2},
  [7146] = {.lex_state = 35, .external_lex_state = 2},
  [7147] = {.lex_state = 35, .external_lex_state = 2},
  [7148] = {.lex_state = 35, .external_lex_state = 2},
  [7149] = {.lex_state = 35, .external_lex_state = 2},
  [7150] = {.lex_state = 35, .external_lex_state = 2},
  [7151] = {.lex_state = 35, .external_lex_state = 2},
  [7152] = {.lex_state = 35, .external_lex_state = 2},
  [7153] = {.lex_state = 35, .external_lex_state = 2},
  [7154] = {.lex_state = 35, .external_lex_state = 2},
  [7155] = {.lex_state = 35, .external_lex_state = 2},
  [7156] = {.lex_state = 35, .external_lex_state = 2},
  [7157] = {.lex_state = 35, .external_lex_state = 2},
  [7158] = {.lex_state = 35, .external_lex_state = 2},
  [7159] = {.lex_state = 35, .external_lex_state = 2},
  [7160] = {.lex_state = 35, .external_lex_state = 2},
  [7161] = {.lex_state = 35, .external_lex_state = 2},
  [7162] = {.lex_state = 35, .external_lex_state = 2},
  [7163] = {.lex_state = 35, .external_lex_state = 2},
  [7164] = {.lex_state = 35, .external_lex_state = 2},
  [7165] = {.lex_state = 35},
  [7166] = {.lex_state = 35},
  [7167] = {.lex_state = 35},
  [7168] = {.lex_state = 35},
  [7169] = {.lex_state = 35},
  [7170] = {.lex_state = 35},
  [7171] = {.lex_state = 35},
  [7172] = {.lex_state = 35, .external_lex_state = 2},
  [7173] = {.lex_state = 35},
  [7174] = {.lex_state = 35},
  [7175] = {.lex_state = 35},
  [7176] = {.lex_state = 35},
  [7177] = {.lex_state = 35},
  [7178] = {.lex_state = 35},
  [7179] = {.lex_state = 35},
  [7180] = {.lex_state = 35, .external_lex_state = 2},
  [7181] = {.lex_state = 35},
  [7182] = {.lex_state = 35},
  [7183] = {.lex_state = 35},
  [7184] = {.lex_state = 33, .external_lex_state = 3},
  [7185] = {.lex_state = 35},
  [7186] = {.lex_state = 35},
  [7187] = {.lex_state = 33, .external_lex_state = 3},
  [7188] = {.lex_state = 35},
  [7189] = {.lex_state = 35},
  [7190] = {.lex_state = 35},
  [7191] = {.lex_state = 35},
  [7192] = {.lex_state = 35},
  [7193] = {.lex_state = 35},
  [7194] = {.lex_state = 35},
  [7195] = {.lex_state = 33, .external_lex_state = 2},
  [7196] = {.lex_state = 35},
  [7197] = {.lex_state = 35},
  [7198] = {.lex_state = 35},
  [7199] = {.lex_state = 35},
  [7200] = {.lex_state = 35},
  [7201] = {.lex_state = 35},
  [7202] = {.lex_state = 35},
  [7203] = {.lex_state = 35},
  [7204] = {.lex_state = 35},
  [7205] = {.lex_state = 35},
  [7206] = {.lex_state = 35, .external_lex_state = 2},
  [7207] = {.lex_state = 35, .external_lex_state = 2},
  [7208] = {.lex_state = 35},
  [7209] = {.lex_state = 35},
  [7210] = {.lex_state = 35},
  [7211] = {.lex_state = 35},
  [7212] = {.lex_state = 35},
  [7213] = {.lex_state = 35},
  [7214] = {.lex_state = 35},
  [7215] = {.lex_state = 33, .external_lex_state = 3},
  [7216] = {.lex_state = 35},
  [7217] = {.lex_state = 35},
  [7218] = {.lex_state = 35},
  [7219] = {.lex_state = 35},
  [7220] = {.lex_state = 35},
  [7221] = {.lex_state = 35},
  [7222] = {.lex_state = 35},
  [7223] = {.lex_state = 35, .external_lex_state = 2},
  [7224] = {.lex_state = 35},
  [7225] = {.lex_state = 35},
  [7226] = {.lex_state = 33, .external_lex_state = 3},
  [7227] = {.lex_state = 35, .external_lex_state = 2},
  [7228] = {.lex_state = 35, .external_lex_state = 2},
  [7229] = {.lex_state = 35},
  [7230] = {.lex_state = 35},
  [7231] = {.lex_state = 35},
  [7232] = {.lex_state = 35, .external_lex_state = 2},
  [7233] = {.lex_state = 35},
  [7234] = {.lex_state = 35},
  [7235] = {.lex_state = 35},
  [7236] = {.lex_state = 35},
  [7237] = {.lex_state = 35, .external_lex_state = 2},
  [7238] = {.lex_state = 35},
  [7239] = {.lex_state = 35, .external_lex_state = 2},
  [7240] = {.lex_state = 35, .external_lex_state = 2},
  [7241] = {.lex_state = 35},
  [7242] = {.lex_state = 35, .external_lex_state = 2},
  [7243] = {.lex_state = 35},
  [7244] = {.lex_state = 35},
  [7245] = {.lex_state = 35, .external_lex_state = 2},
  [7246] = {.lex_state = 35, .external_lex_state = 2},
  [7247] = {.lex_state = 35, .external_lex_state = 2},
  [7248] = {.lex_state = 35, .external_lex_state = 2},
  [7249] = {.lex_state = 35, .external_lex_state = 2},
  [7250] = {.lex_state = 35, .external_lex_state = 2},
  [7251] = {.lex_state = 35, .external_lex_state = 2},
  [7252] = {.lex_state = 35, .external_lex_state = 2},
  [7253] = {.lex_state = 35, .external_lex_state = 2},
  [7254] = {.lex_state = 35, .external_lex_state = 2},
  [7255] = {.lex_state = 35, .external_lex_state = 2},
  [7256] = {.lex_state = 35},
  [7257] = {.lex_state = 35},
  [7258] = {.lex_state = 35},
  [7259] = {.lex_state = 35, .external_lex_state = 2},
  [7260] = {.lex_state = 35},
  [7261] = {.lex_state = 35},
  [7262] = {.lex_state = 35, .external_lex_state = 2},
  [7263] = {.lex_state = 35},
  [7264] = {.lex_state = 33, .external_lex_state = 3},
  [7265] = {.lex_state = 35},
  [7266] = {.lex_state = 35},
  [7267] = {.lex_state = 35},
  [7268] = {.lex_state = 35},
  [7269] = {.lex_state = 35},
  [7270] = {.lex_state = 35},
  [7271] = {.lex_state = 35},
  [7272] = {.lex_state = 35},
  [7273] = {.lex_state = 35, .external_lex_state = 2},
  [7274] = {.lex_state = 35, .external_lex_state = 2},
  [7275] = {.lex_state = 35},
  [7276] = {.lex_state = 35, .external_lex_state = 2},
  [7277] = {.lex_state = 35},
  [7278] = {.lex_state = 35},
  [7279] = {.lex_state = 33, .external_lex_state = 3},
  [7280] = {.lex_state = 35},
  [7281] = {.lex_state = 35},
  [7282] = {.lex_state = 35},
  [7283] = {.lex_state = 35},
  [7284] = {.lex_state = 35},
  [7285] = {.lex_state = 35},
  [7286] = {.lex_state = 35},
  [7287] = {.lex_state = 35},
  [7288] = {.lex_state = 35, .external_lex_state = 2},
  [7289] = {.lex_state = 35},
  [7290] = {.lex_state = 35},
  [7291] = {.lex_state = 35},
  [7292] = {.lex_state = 35},
  [7293] = {.lex_state = 35},
  [7294] = {.lex_state = 35},
  [7295] = {.lex_state = 35},
  [7296] = {.lex_state = 35},
  [7297] = {.lex_state = 33, .external_lex_state = 3},
  [7298] = {.lex_state = 35},
  [7299] = {.lex_state = 33, .external_lex_state = 3},
  [7300] = {.lex_state = 35},
  [7301] = {.lex_state = 35},
  [7302] = {.lex_state = 35},
  [7303] = {.lex_state = 35},
  [7304] = {.lex_state = 35},
  [7305] = {.lex_state = 35},
  [7306] = {.lex_state = 35},
  [7307] = {.lex_state = 35},
  [7308] = {.lex_state = 35, .external_lex_state = 2},
  [7309] = {.lex_state = 35},
  [7310] = {.lex_state = 35},
  [7311] = {.lex_state = 35},
  [7312] = {.lex_state = 35},
  [7313] = {.lex_state = 35},
  [7314] = {.lex_state = 35},
  [7315] = {.lex_state = 35},
  [7316] = {.lex_state = 35},
  [7317] = {.lex_state = 35, .external_lex_state = 2},
  [7318] = {.lex_state = 35},
  [7319] = {.lex_state = 35},
  [7320] = {.lex_state = 35},
  [7321] = {.lex_state = 35},
  [7322] = {.lex_state = 35, .external_lex_state = 2},
  [7323] = {.lex_state = 35},
  [7324] = {.lex_state = 35},
  [7325] = {.lex_state = 35},
  [7326] = {.lex_state = 35, .external_lex_state = 2},
  [7327] = {.lex_state = 35},
  [7328] = {.lex_state = 35, .external_lex_state = 2},
  [7329] = {.lex_state = 35},
  [7330] = {.lex_state = 35, .external_lex_state = 2},
  [7331] = {.lex_state = 35},
  [7332] = {.lex_state = 35, .external_lex_state = 2},
  [7333] = {.lex_state = 35, .external_lex_state = 2},
  [7334] = {.lex_state = 35},
  [7335] = {.lex_state = 35, .external_lex_state = 2},
  [7336] = {.lex_state = 35},
  [7337] = {.lex_state = 35},
  [7338] = {.lex_state = 35},
  [7339] = {.lex_state = 35},
  [7340] = {.lex_state = 35},
  [7341] = {.lex_state = 35, .external_lex_state = 2},
  [7342] = {.lex_state = 35, .external_lex_state = 2},
  [7343] = {.lex_state = 35, .external_lex_state = 2},
  [7344] = {.lex_state = 35},
  [7345] = {.lex_state = 35, .external_lex_state = 2},
  [7346] = {.lex_state = 35},
  [7347] = {.lex_state = 35},
  [7348] = {.lex_state = 35},
  [7349] = {.lex_state = 33, .external_lex_state = 3},
  [7350] = {.lex_state = 35},
  [7351] = {.lex_state = 35},
  [7352] = {.lex_state = 35},
  [7353] = {.lex_state = 35},
  [7354] = {.lex_state = 35, .external_lex_state = 2},
  [7355] = {.lex_state = 33, .external_lex_state = 3},
  [7356] = {.lex_state = 33, .external_lex_state = 3},
  [7357] = {.lex_state = 35, .external_lex_state = 2},
  [7358] = {.lex_state = 35},
  [7359] = {.lex_state = 35},
  [7360] = {.lex_state = 35, .external_lex_state = 2},
  [7361] = {.lex_state = 35},
  [7362] = {.lex_state = 35, .external_lex_state = 2},
  [7363] = {.lex_state = 35, .external_lex_state = 2},
  [7364] = {.lex_state = 35, .external_lex_state = 2},
  [7365] = {.lex_state = 35},
  [7366] = {.lex_state = 35},
  [7367] = {.lex_state = 35},
  [7368] = {.lex_state = 35},
  [7369] = {.lex_state = 35},
  [7370] = {.lex_state = 35, .external_lex_state = 2},
  [7371] = {.lex_state = 35},
  [7372] = {.lex_state = 33, .external_lex_state = 3},
  [7373] = {.lex_state = 35, .external_lex_state = 2},
  [7374] = {.lex_state = 35},
  [7375] = {.lex_state = 35},
  [7376] = {.lex_state = 35},
  [7377] = {.lex_state = 35},
  [7378] = {.lex_state = 33, .external_lex_state = 3},
  [7379] = {.lex_state = 35},
  [7380] = {.lex_state = 35},
  [7381] = {.lex_state = 35},
  [7382] = {.lex_state = 35},
  [7383] = {.lex_state = 35},
  [7384] = {.lex_state = 35},
  [7385] = {.lex_state = 35},
  [7386] = {.lex_state = 35},
  [7387] = {.lex_state = 35},
  [7388] = {.lex_state = 35},
  [7389] = {.lex_state = 35},
  [7390] = {.lex_state = 35},
  [7391] = {.lex_state = 35},
  [7392] = {.lex_state = 35},
  [7393] = {.lex_state = 35},
  [7394] = {.lex_state = 35},
  [7395] = {.lex_state = 35},
  [7396] = {.lex_state = 35},
  [7397] = {.lex_state = 35},
  [7398] = {.lex_state = 35},
  [7399] = {.lex_state = 35},
  [7400] = {.lex_state = 35},
  [7401] = {.lex_state = 35, .external_lex_state = 2},
  [7402] = {.lex_state = 35},
  [7403] = {.lex_state = 35},
  [7404] = {.lex_state = 35},
  [7405] = {.lex_state = 35},
  [7406] = {.lex_state = 35},
  [7407] = {.lex_state = 36},
  [7408] = {.lex_state = 35},
  [7409] = {.lex_state = 35, .external_lex_state = 2},
  [7410] = {.lex_state = 35, .external_lex_state = 2},
  [7411] = {.lex_state = 35},
  [7412] = {.lex_state = 35},
  [7413] = {.lex_state = 33, .external_lex_state = 3},
  [7414] = {.lex_state = 35, .external_lex_state = 2},
  [7415] = {.lex_state = 35, .external_lex_state = 2},
  [7416] = {.lex_state = 35},
  [7417] = {.lex_state = 35, .external_lex_state = 2},
  [7418] = {.lex_state = 35, .external_lex_state = 2},
  [7419] = {.lex_state = 33, .external_lex_state = 3},
  [7420] = {.lex_state = 35, .external_lex_state = 2},
  [7421] = {.lex_state = 35, .external_lex_state = 2},
  [7422] = {.lex_state = 35},
  [7423] = {.lex_state = 35},
  [7424] = {.lex_state = 33, .external_lex_state = 3},
  [7425] = {.lex_state = 35},
  [7426] = {.lex_state = 35, .external_lex_state = 2},
  [7427] = {.lex_state = 33, .external_lex_state = 3},
  [7428] = {.lex_state = 33, .external_lex_state = 3},
  [7429] = {.lex_state = 35},
  [7430] = {.lex_state = 35},
  [7431] = {.lex_state = 33, .external_lex_state = 3},
  [7432] = {.lex_state = 33, .external_lex_state = 3},
  [7433] = {.lex_state = 35},
  [7434] = {.lex_state = 33, .external_lex_state = 3},
  [7435] = {.lex_state = 33, .external_lex_state = 3},
  [7436] = {.lex_state = 35},
  [7437] = {.lex_state = 35, .external_lex_state = 2},
  [7438] = {.lex_state = 35, .external_lex_state = 2},
  [7439] = {.lex_state = 35},
  [7440] = {.lex_state = 33, .external_lex_state = 3},
  [7441] = {.lex_state = 35},
  [7442] = {.lex_state = 35, .external_lex_state = 2},
  [7443] = {.lex_state = 33, .external_lex_state = 3},
  [7444] = {.lex_state = 33, .external_lex_state = 3},
  [7445] = {.lex_state = 33, .external_lex_state = 3},
  [7446] = {.lex_state = 35, .external_lex_state = 2},
  [7447] = {.lex_state = 35, .external_lex_state = 2},
  [7448] = {.lex_state = 35, .external_lex_state = 2},
  [7449] = {.lex_state = 35, .external_lex_state = 2},
  [7450] = {.lex_state = 35, .external_lex_state = 2},
  [7451] = {.lex_state = 35},
  [7452] = {.lex_state = 33, .external_lex_state = 3},
  [7453] = {.lex_state = 35},
  [7454] = {.lex_state = 35},
  [7455] = {.lex_state = 35},
  [7456] = {.lex_state = 35, .external_lex_state = 2},
  [7457] = {.lex_state = 35, .external_lex_state = 2},
  [7458] = {.lex_state = 35, .external_lex_state = 2},
  [7459] = {.lex_state = 35},
  [7460] = {.lex_state = 35, .external_lex_state = 2},
  [7461] = {.lex_state = 35},
  [7462] = {.lex_state = 35, .external_lex_state = 2},
  [7463] = {.lex_state = 35, .external_lex_state = 2},
  [7464] = {.lex_state = 33, .external_lex_state = 3},
  [7465] = {.lex_state = 33, .external_lex_state = 3},
  [7466] = {.lex_state = 35, .external_lex_state = 2},
  [7467] = {.lex_state = 35, .external_lex_state = 2},
  [7468] = {.lex_state = 35},
  [7469] = {.lex_state = 33, .external_lex_state = 3},
  [7470] = {.lex_state = 35, .external_lex_state = 2},
  [7471] = {.lex_state = 35},
  [7472] = {.lex_state = 35, .external_lex_state = 2},
  [7473] = {.lex_state = 35, .external_lex_state = 2},
  [7474] = {.lex_state = 33, .external_lex_state = 3},
  [7475] = {.lex_state = 35},
  [7476] = {.lex_state = 35, .external_lex_state = 2},
  [7477] = {.lex_state = 33, .external_lex_state = 3},
  [7478] = {.lex_state = 33, .external_lex_state = 3},
  [7479] = {.lex_state = 35},
  [7480] = {.lex_state = 35},
  [7481] = {.lex_state = 35},
  [7482] = {.lex_state = 35, .external_lex_state = 2},
  [7483] = {.lex_state = 35, .external_lex_state = 2},
  [7484] = {.lex_state = 35, .external_lex_state = 2},
  [7485] = {.lex_state = 33, .external_lex_state = 3},
  [7486] = {.lex_state = 35, .external_lex_state = 2},
  [7487] = {.lex_state = 33, .external_lex_state = 3},
  [7488] = {.lex_state = 35, .external_lex_state = 2},
  [7489] = {.lex_state = 33, .external_lex_state = 3},
  [7490] = {.lex_state = 35, .external_lex_state = 2},
  [7491] = {.lex_state = 35, .external_lex_state = 2},
  [7492] = {.lex_state = 35, .external_lex_state = 2},
  [7493] = {.lex_state = 35, .external_lex_state = 2},
  [7494] = {.lex_state = 35},
  [7495] = {.lex_state = 33, .external_lex_state = 3},
  [7496] = {.lex_state = 35},
  [7497] = {.lex_state = 35, .external_lex_state = 2},
  [7498] = {.lex_state = 35},
  [7499] = {.lex_state = 35},
  [7500] = {.lex_state = 33, .external_lex_state = 3},
  [7501] = {.lex_state = 35},
  [7502] = {.lex_state = 35, .external_lex_state = 2},
  [7503] = {.lex_state = 36},
  [7504] = {.lex_state = 33, .external_lex_state = 3},
  [7505] = {.lex_state = 35, .external_lex_state = 2},
  [7506] = {.lex_state = 35, .external_lex_state = 2},
  [7507] = {.lex_state = 35, .external_lex_state = 2},
  [7508] = {.lex_state = 35, .external_lex_state = 2},
  [7509] = {.lex_state = 35, .external_lex_state = 2},
  [7510] = {.lex_state = 35, .external_lex_state = 2},
  [7511] = {.lex_state = 35, .external_lex_state = 2},
  [7512] = {.lex_state = 35, .external_lex_state = 2},
  [7513] = {.lex_state = 35, .external_lex_state = 2},
  [7514] = {.lex_state = 35},
  [7515] = {.lex_state = 35},
  [7516] = {.lex_state = 35, .external_lex_state = 2},
  [7517] = {.lex_state = 35},
  [7518] = {.lex_state = 35, .external_lex_state = 2},
  [7519] = {.lex_state = 35},
  [7520] = {.lex_state = 35, .external_lex_state = 2},
  [7521] = {.lex_state = 35},
  [7522] = {.lex_state = 35, .external_lex_state = 2},
  [7523] = {.lex_state = 35, .external_lex_state = 2},
  [7524] = {.lex_state = 35},
  [7525] = {.lex_state = 35},
  [7526] = {.lex_state = 35},
  [7527] = {.lex_state = 35, .external_lex_state = 2},
  [7528] = {.lex_state = 35},
  [7529] = {.lex_state = 35, .external_lex_state = 2},
  [7530] = {.lex_state = 35},
  [7531] = {.lex_state = 35},
  [7532] = {.lex_state = 35},
  [7533] = {.lex_state = 35},
  [7534] = {.lex_state = 35},
  [7535] = {.lex_state = 35},
  [7536] = {.lex_state = 35},
  [7537] = {.lex_state = 35},
  [7538] = {.lex_state = 35},
  [7539] = {.lex_state = 35},
  [7540] = {.lex_state = 35},
  [7541] = {.lex_state = 35},
  [7542] = {.lex_state = 35},
  [7543] = {.lex_state = 35, .external_lex_state = 2},
  [7544] = {.lex_state = 35},
  [7545] = {.lex_state = 35},
  [7546] = {.lex_state = 35},
  [7547] = {.lex_state = 35},
  [7548] = {.lex_state = 35, .external_lex_state = 2},
  [7549] = {.lex_state = 35},
  [7550] = {.lex_state = 35},
  [7551] = {.lex_state = 35},
  [7552] = {.lex_state = 35, .external_lex_state = 2},
  [7553] = {.lex_state = 35},
  [7554] = {.lex_state = 35},
  [7555] = {.lex_state = 35},
  [7556] = {.lex_state = 35},
  [7557] = {.lex_state = 35, .external_lex_state = 2},
  [7558] = {.lex_state = 35},
  [7559] = {.lex_state = 35},
  [7560] = {.lex_state = 35},
  [7561] = {.lex_state = 35},
  [7562] = {.lex_state = 35},
  [7563] = {.lex_state = 35},
  [7564] = {.lex_state = 35},
  [7565] = {.lex_state = 35},
  [7566] = {.lex_state = 35},
  [7567] = {.lex_state = 35},
  [7568] = {.lex_state = 35},
  [7569] = {.lex_state = 35},
  [7570] = {.lex_state = 35},
  [7571] = {.lex_state = 35},
  [7572] = {.lex_state = 35},
  [7573] = {.lex_state = 35},
  [7574] = {.lex_state = 35},
  [7575] = {.lex_state = 35},
  [7576] = {.lex_state = 35},
  [7577] = {.lex_state = 35},
  [7578] = {.lex_state = 35},
  [7579] = {.lex_state = 35},
  [7580] = {.lex_state = 35},
  [7581] = {.lex_state = 35, .external_lex_state = 2},
  [7582] = {.lex_state = 35},
  [7583] = {.lex_state = 35, .external_lex_state = 2},
  [7584] = {.lex_state = 35},
  [7585] = {.lex_state = 35},
  [7586] = {.lex_state = 35},
  [7587] = {.lex_state = 35},
  [7588] = {.lex_state = 35},
  [7589] = {.lex_state = 35},
  [7590] = {.lex_state = 35},
  [7591] = {.lex_state = 35},
  [7592] = {.lex_state = 35},
  [7593] = {.lex_state = 35},
  [7594] = {.lex_state = 35},
  [7595] = {.lex_state = 35},
  [7596] = {.lex_state = 33, .external_lex_state = 3},
  [7597] = {.lex_state = 35},
  [7598] = {.lex_state = 35, .external_lex_state = 2},
  [7599] = {.lex_state = 35, .external_lex_state = 2},
  [7600] = {.lex_state = 35, .external_lex_state = 2},
  [7601] = {.lex_state = 35, .external_lex_state = 2},
  [7602] = {.lex_state = 35},
  [7603] = {.lex_state = 35},
  [7604] = {.lex_state = 35},
  [7605] = {.lex_state = 35},
  [7606] = {.lex_state = 33, .external_lex_state = 3},
  [7607] = {.lex_state = 35, .external_lex_state = 2},
  [7608] = {.lex_state = 35},
  [7609] = {.lex_state = 35},
  [7610] = {.lex_state = 33, .external_lex_state = 3},
  [7611] = {.lex_state = 35, .external_lex_state = 2},
  [7612] = {.lex_state = 35, .external_lex_state = 2},
  [7613] = {.lex_state = 35},
  [7614] = {.lex_state = 35, .external_lex_state = 2},
  [7615] = {.lex_state = 35, .external_lex_state = 2},
  [7616] = {.lex_state = 35, .external_lex_state = 2},
  [7617] = {.lex_state = 35},
  [7618] = {.lex_state = 35, .external_lex_state = 2},
  [7619] = {.lex_state = 35},
  [7620] = {.lex_state = 35, .external_lex_state = 2},
  [7621] = {.lex_state = 33, .external_lex_state = 3},
  [7622] = {.lex_state = 35, .external_lex_state = 2},
  [7623] = {.lex_state = 35},
  [7624] = {.lex_state = 33, .external_lex_state = 3},
  [7625] = {.lex_state = 33, .external_lex_state = 3},
  [7626] = {.lex_state = 35},
  [7627] = {.lex_state = 35},
  [7628] = {.lex_state = 33, .external_lex_state = 3},
  [7629] = {.lex_state = 35},
  [7630] = {.lex_state = 33, .external_lex_state = 3},
  [7631] = {.lex_state = 35, .external_lex_state = 2},
  [7632] = {.lex_state = 35, .external_lex_state = 2},
  [7633] = {.lex_state = 35},
  [7634] = {.lex_state = 35, .external_lex_state = 2},
  [7635] = {.lex_state = 35},
  [7636] = {.lex_state = 35},
  [7637] = {.lex_state = 33, .external_lex_state = 3},
  [7638] = {.lex_state = 35, .external_lex_state = 2},
  [7639] = {.lex_state = 35},
  [7640] = {.lex_state = 35, .external_lex_state = 2},
  [7641] = {.lex_state = 35},
  [7642] = {.lex_state = 33, .external_lex_state = 3},
  [7643] = {.lex_state = 35, .external_lex_state = 2},
  [7644] = {.lex_state = 35},
  [7645] = {.lex_state = 35, .external_lex_state = 2},
  [7646] = {.lex_state = 35},
  [7647] = {.lex_state = 35},
  [7648] = {.lex_state = 33, .external_lex_state = 3},
  [7649] = {.lex_state = 35},
  [7650] = {.lex_state = 35},
  [7651] = {.lex_state = 33, .external_lex_state = 3},
  [7652] = {.lex_state = 35},
  [7653] = {.lex_state = 35},
  [7654] = {.lex_state = 35, .external_lex_state = 2},
  [7655] = {.lex_state = 35, .external_lex_state = 2},
  [7656] = {.lex_state = 35, .external_lex_state = 2},
  [7657] = {.lex_state = 35},
  [7658] = {.lex_state = 35, .external_lex_state = 2},
  [7659] = {.lex_state = 35},
  [7660] = {.lex_state = 35},
  [7661] = {.lex_state = 35},
  [7662] = {.lex_state = 35},
  [7663] = {.lex_state = 35},
  [7664] = {.lex_state = 35, .external_lex_state = 2},
  [7665] = {.lex_state = 35, .external_lex_state = 2},
  [7666] = {.lex_state = 35, .external_lex_state = 2},
  [7667] = {.lex_state = 35, .external_lex_state = 2},
  [7668] = {.lex_state = 35, .external_lex_state = 2},
  [7669] = {.lex_state = 35, .external_lex_state = 2},
  [7670] = {.lex_state = 35, .external_lex_state = 2},
  [7671] = {.lex_state = 35, .external_lex_state = 2},
  [7672] = {.lex_state = 33, .external_lex_state = 3},
  [7673] = {.lex_state = 35, .external_lex_state = 2},
  [7674] = {.lex_state = 33, .external_lex_state = 3},
  [7675] = {.lex_state = 35},
  [7676] = {.lex_state = 33, .external_lex_state = 3},
  [7677] = {.lex_state = 35},
  [7678] = {.lex_state = 35, .external_lex_state = 2},
  [7679] = {.lex_state = 35, .external_lex_state = 2},
  [7680] = {.lex_state = 35},
  [7681] = {.lex_state = 35},
  [7682] = {.lex_state = 35},
  [7683] = {.lex_state = 35},
  [7684] = {.lex_state = 35},
  [7685] = {.lex_state = 33, .external_lex_state = 3},
  [7686] = {.lex_state = 35, .external_lex_state = 2},
  [7687] = {.lex_state = 35},
  [7688] = {.lex_state = 35},
  [7689] = {.lex_state = 35},
  [7690] = {.lex_state = 35},
  [7691] = {.lex_state = 35},
  [7692] = {.lex_state = 35},
  [7693] = {.lex_state = 35},
  [7694] = {.lex_state = 33, .external_lex_state = 3},
  [7695] = {.lex_state = 35},
  [7696] = {.lex_state = 35},
  [7697] = {.lex_state = 33, .external_lex_state = 3},
  [7698] = {.lex_state = 33, .external_lex_state = 3},
  [7699] = {.lex_state = 35},
  [7700] = {.lex_state = 35},
  [7701] = {.lex_state = 35},
  [7702] = {.lex_state = 33, .external_lex_state = 3},
  [7703] = {.lex_state = 33, .external_lex_state = 3},
  [7704] = {.lex_state = 35},
  [7705] = {.lex_state = 35},
  [7706] = {.lex_state = 35},
  [7707] = {.lex_state = 35, .external_lex_state = 2},
  [7708] = {.lex_state = 33, .external_lex_state = 3},
  [7709] = {.lex_state = 35},
  [7710] = {.lex_state = 35},
  [7711] = {.lex_state = 33, .external_lex_state = 3},
  [7712] = {.lex_state = 35},
  [7713] = {.lex_state = 35},
  [7714] = {.lex_state = 33, .external_lex_state = 3},
  [7715] = {.lex_state = 35},
  [7716] = {.lex_state = 35},
  [7717] = {.lex_state = 35},
  [7718] = {.lex_state = 35, .external_lex_state = 2},
  [7719] = {.lex_state = 35},
  [7720] = {.lex_state = 35},
  [7721] = {.lex_state = 35},
  [7722] = {.lex_state = 35},
  [7723] = {.lex_state = 35},
  [7724] = {.lex_state = 35},
  [7725] = {.lex_state = 35},
  [7726] = {.lex_state = 35},
  [7727] = {.lex_state = 35},
  [7728] = {.lex_state = 35},
  [7729] = {.lex_state = 35},
  [7730] = {.lex_state = 35},
  [7731] = {.lex_state = 35},
  [7732] = {.lex_state = 35, .external_lex_state = 2},
  [7733] = {.lex_state = 35},
  [7734] = {.lex_state = 35},
  [7735] = {.lex_state = 35},
  [7736] = {.lex_state = 33, .external_lex_state = 3},
  [7737] = {.lex_state = 35},
  [7738] = {.lex_state = 35},
  [7739] = {.lex_state = 35, .external_lex_state = 2},
  [7740] = {.lex_state = 35},
  [7741] = {.lex_state = 35},
  [7742] = {.lex_state = 35},
  [7743] = {.lex_state = 35, .external_lex_state = 2},
  [7744] = {.lex_state = 35},
  [7745] = {.lex_state = 35},
  [7746] = {.lex_state = 35},
  [7747] = {.lex_state = 35},
  [7748] = {.lex_state = 35},
  [7749] = {.lex_state = 35},
  [7750] = {.lex_state = 35},
  [7751] = {.lex_state = 35},
  [7752] = {.lex_state = 35},
  [7753] = {.lex_state = 35},
  [7754] = {.lex_state = 35},
  [7755] = {.lex_state = 35},
  [7756] = {.lex_state = 35},
  [7757] = {.lex_state = 35},
  [7758] = {.lex_state = 35},
  [7759] = {.lex_state = 35},
  [7760] = {.lex_state = 35},
  [7761] = {.lex_state = 35},
  [7762] = {.lex_state = 35},
  [7763] = {.lex_state = 35},
  [7764] = {.lex_state = 35},
  [7765] = {.lex_state = 35},
  [7766] = {.lex_state = 35},
  [7767] = {.lex_state = 35},
  [7768] = {.lex_state = 35},
  [7769] = {.lex_state = 35},
  [7770] = {.lex_state = 35},
  [7771] = {.lex_state = 35},
  [7772] = {.lex_state = 35},
  [7773] = {.lex_state = 35},
  [7774] = {.lex_state = 35},
  [7775] = {.lex_state = 35},
  [7776] = {.lex_state = 35},
  [7777] = {.lex_state = 35},
  [7778] = {.lex_state = 35},
  [7779] = {.lex_state = 35},
  [7780] = {.lex_state = 35},
  [7781] = {.lex_state = 35},
  [7782] = {.lex_state = 33, .external_lex_state = 3},
  [7783] = {.lex_state = 35},
  [7784] = {.lex_state = 35},
  [7785] = {.lex_state = 35},
  [7786] = {.lex_state = 35},
  [7787] = {.lex_state = 35},
  [7788] = {.lex_state = 35},
  [7789] = {.lex_state = 35},
  [7790] = {.lex_state = 35},
  [7791] = {.lex_state = 35},
  [7792] = {.lex_state = 35},
  [7793] = {.lex_state = 35},
  [7794] = {.lex_state = 35},
  [7795] = {.lex_state = 35},
  [7796] = {.lex_state = 35},
  [7797] = {.lex_state = 35},
  [7798] = {.lex_state = 35},
  [7799] = {.lex_state = 35},
  [7800] = {.lex_state = 35},
  [7801] = {.lex_state = 35},
  [7802] = {.lex_state = 35},
  [7803] = {.lex_state = 35},
  [7804] = {.lex_state = 35},
  [7805] = {.lex_state = 35},
  [7806] = {.lex_state = 35},
  [7807] = {.lex_state = 35},
  [7808] = {.lex_state = 35},
  [7809] = {.lex_state = 35},
  [7810] = {.lex_state = 35},
  [7811] = {.lex_state = 33, .external_lex_state = 3},
  [7812] = {.lex_state = 35},
  [7813] = {.lex_state = 33, .external_lex_state = 3},
  [7814] = {.lex_state = 35},
  [7815] = {.lex_state = 35},
  [7816] = {.lex_state = 35},
  [7817] = {.lex_state = 35},
  [7818] = {.lex_state = 33, .external_lex_state = 3},
  [7819] = {.lex_state = 35},
  [7820] = {.lex_state = 35},
  [7821] = {.lex_state = 35},
  [7822] = {.lex_state = 35},
  [7823] = {.lex_state = 35},
  [7824] = {.lex_state = 35},
  [7825] = {.lex_state = 35},
  [7826] = {.lex_state = 35, .external_lex_state = 2},
  [7827] = {.lex_state = 35},
  [7828] = {.lex_state = 35},
  [7829] = {.lex_state = 35},
  [7830] = {.lex_state = 35, .external_lex_state = 2},
  [7831] = {.lex_state = 35, .external_lex_state = 2},
  [7832] = {.lex_state = 35, .external_lex_state = 2},
  [7833] = {.lex_state = 35},
  [7834] = {.lex_state = 35},
  [7835] = {.lex_state = 33, .external_lex_state = 3},
  [7836] = {.lex_state = 35},
  [7837] = {.lex_state = 35},
  [7838] = {.lex_state = 33, .external_lex_state = 3},
  [7839] = {.lex_state = 35},
  [7840] = {.lex_state = 35},
  [7841] = {.lex_state = 35},
  [7842] = {.lex_state = 35},
  [7843] = {.lex_state = 35},
  [7844] = {.lex_state = 35},
  [7845] = {.lex_state = 35},
  [7846] = {.lex_state = 33, .external_lex_state = 3},
  [7847] = {.lex_state = 35},
  [7848] = {.lex_state = 35},
  [7849] = {.lex_state = 35},
  [7850] = {.lex_state = 35},
  [7851] = {.lex_state = 35},
  [7852] = {.lex_state = 35},
  [7853] = {.lex_state = 35},
  [7854] = {.lex_state = 35},
  [7855] = {.lex_state = 35, .external_lex_state = 2},
  [7856] = {.lex_state = 35},
  [7857] = {.lex_state = 35},
  [7858] = {.lex_state = 35},
  [7859] = {.lex_state = 35},
  [7860] = {.lex_state = 35},
  [7861] = {.lex_state = 35, .external_lex_state = 2},
  [7862] = {.lex_state = 35},
  [7863] = {.lex_state = 35},
  [7864] = {.lex_state = 35},
  [7865] = {.lex_state = 35},
  [7866] = {.lex_state = 35},
  [7867] = {.lex_state = 35},
  [7868] = {.lex_state = 35},
  [7869] = {.lex_state = 35, .external_lex_state = 2},
  [7870] = {.lex_state = 35},
  [7871] = {.lex_state = 35},
  [7872] = {.lex_state = 33, .external_lex_state = 3},
  [7873] = {.lex_state = 35},
  [7874] = {.lex_state = 35},
  [7875] = {.lex_state = 35},
  [7876] = {.lex_state = 35},
  [7877] = {.lex_state = 35},
  [7878] = {.lex_state = 35},
  [7879] = {.lex_state = 35},
  [7880] = {.lex_state = 35},
  [7881] = {.lex_state = 35},
  [7882] = {.lex_state = 35},
  [7883] = {.lex_state = 35},
  [7884] = {.lex_state = 35},
  [7885] = {.lex_state = 35},
  [7886] = {.lex_state = 35},
  [7887] = {.lex_state = 35},
  [7888] = {.lex_state = 35},
  [7889] = {.lex_state = 35},
  [7890] = {.lex_state = 33, .external_lex_state = 3},
  [7891] = {.lex_state = 35},
  [7892] = {.lex_state = 35},
  [7893] = {.lex_state = 35},
  [7894] = {.lex_state = 35},
  [7895] = {.lex_state = 35},
  [7896] = {.lex_state = 35},
  [7897] = {.lex_state = 35},
  [7898] = {.lex_state = 35},
  [7899] = {.lex_state = 35},
  [7900] = {.lex_state = 35},
  [7901] = {.lex_state = 35},
  [7902] = {.lex_state = 35},
  [7903] = {.lex_state = 35},
  [7904] = {.lex_state = 35},
  [7905] = {.lex_state = 35},
  [7906] = {.lex_state = 35},
  [7907] = {.lex_state = 35},
  [7908] = {.lex_state = 35},
  [7909] = {.lex_state = 35},
  [7910] = {.lex_state = 35},
  [7911] = {.lex_state = 35},
  [7912] = {.lex_state = 35},
  [7913] = {.lex_state = 35},
  [7914] = {.lex_state = 35},
  [7915] = {.lex_state = 33, .external_lex_state = 3},
  [7916] = {.lex_state = 35},
  [7917] = {.lex_state = 35},
  [7918] = {.lex_state = 35},
  [7919] = {.lex_state = 35},
  [7920] = {.lex_state = 35},
  [7921] = {.lex_state = 35},
  [7922] = {.lex_state = 35, .external_lex_state = 2},
  [7923] = {.lex_state = 35},
  [7924] = {.lex_state = 35},
  [7925] = {.lex_state = 35},
  [7926] = {.lex_state = 33, .external_lex_state = 3},
  [7927] = {.lex_state = 35},
  [7928] = {.lex_state = 35},
  [7929] = {.lex_state = 35, .external_lex_state = 2},
  [7930] = {.lex_state = 35},
  [7931] = {.lex_state = 35, .external_lex_state = 2},
  [7932] = {.lex_state = 35},
  [7933] = {.lex_state = 35, .external_lex_state = 2},
  [7934] = {.lex_state = 35},
  [7935] = {.lex_state = 35},
  [7936] = {.lex_state = 35, .external_lex_state = 2},
  [7937] = {.lex_state = 35},
  [7938] = {.lex_state = 35},
  [7939] = {.lex_state = 35},
  [7940] = {.lex_state = 35},
  [7941] = {.lex_state = 35},
  [7942] = {.lex_state = 35},
  [7943] = {.lex_state = 35},
  [7944] = {.lex_state = 35},
  [7945] = {.lex_state = 35},
  [7946] = {.lex_state = 35},
  [7947] = {.lex_state = 35},
  [7948] = {.lex_state = 35},
  [7949] = {.lex_state = 35},
  [7950] = {.lex_state = 35},
  [7951] = {.lex_state = 35},
  [7952] = {.lex_state = 35},
  [7953] = {.lex_state = 35},
  [7954] = {.lex_state = 35},
  [7955] = {.lex_state = 35},
  [7956] = {.lex_state = 35},
  [7957] = {.lex_state = 35},
  [7958] = {.lex_state = 35},
  [7959] = {.lex_state = 35},
  [7960] = {.lex_state = 35},
  [7961] = {.lex_state = 35},
  [7962] = {.lex_state = 35},
  [7963] = {.lex_state = 35},
  [7964] = {.lex_state = 35},
  [7965] = {.lex_state = 35},
  [7966] = {.lex_state = 35},
  [7967] = {.lex_state = 35},
  [7968] = {.lex_state = 35},
  [7969] = {.lex_state = 35},
  [7970] = {.lex_state = 35},
  [7971] = {.lex_state = 35},
  [7972] = {.lex_state = 35},
  [7973] = {.lex_state = 35},
  [7974] = {.lex_state = 35},
  [7975] = {.lex_state = 35},
  [7976] = {.lex_state = 35},
  [7977] = {.lex_state = 33, .external_lex_state = 3},
  [7978] = {.lex_state = 35},
  [7979] = {.lex_state = 35},
  [7980] = {.lex_state = 35},
  [7981] = {.lex_state = 35},
  [7982] = {.lex_state = 35},
  [7983] = {.lex_state = 35},
  [7984] = {.lex_state = 35},
  [7985] = {.lex_state = 35},
  [7986] = {.lex_state = 35},
  [7987] = {.lex_state = 35},
  [7988] = {.lex_state = 35},
  [7989] = {.lex_state = 33, .external_lex_state = 3},
  [7990] = {.lex_state = 35},
  [7991] = {.lex_state = 35},
  [7992] = {.lex_state = 35},
  [7993] = {.lex_state = 35},
  [7994] = {.lex_state = 35},
  [7995] = {.lex_state = 35},
  [7996] = {.lex_state = 35},
  [7997] = {.lex_state = 35},
  [7998] = {.lex_state = 35},
  [7999] = {.lex_state = 35},
  [8000] = {.lex_state = 35},
  [8001] = {.lex_state = 35},
  [8002] = {.lex_state = 35},
  [8003] = {.lex_state = 33, .external_lex_state = 3},
  [8004] = {.lex_state = 35},
  [8005] = {.lex_state = 35},
  [8006] = {.lex_state = 35},
  [8007] = {.lex_state = 35},
  [8008] = {.lex_state = 33, .external_lex_state = 3},
  [8009] = {.lex_state = 33, .external_lex_state = 3},
  [8010] = {.lex_state = 35},
  [8011] = {.lex_state = 35},
  [8012] = {.lex_state = 35},
  [8013] = {.lex_state = 35},
  [8014] = {.lex_state = 35},
  [8015] = {.lex_state = 35},
  [8016] = {.lex_state = 35},
  [8017] = {.lex_state = 35},
  [8018] = {.lex_state = 35},
  [8019] = {.lex_state = 35},
  [8020] = {.lex_state = 35},
  [8021] = {.lex_state = 35},
  [8022] = {.lex_state = 35},
  [8023] = {.lex_state = 35},
  [8024] = {.lex_state = 33, .external_lex_state = 3},
  [8025] = {.lex_state = 33, .external_lex_state = 3},
  [8026] = {.lex_state = 35},
  [8027] = {.lex_state = 35},
  [8028] = {.lex_state = 35},
  [8029] = {.lex_state = 35},
  [8030] = {.lex_state = 35},
  [8031] = {.lex_state = 35},
  [8032] = {.lex_state = 35},
  [8033] = {.lex_state = 35},
  [8034] = {.lex_state = 35},
  [8035] = {.lex_state = 35},
  [8036] = {.lex_state = 35, .external_lex_state = 2},
  [8037] = {.lex_state = 35},
  [8038] = {.lex_state = 35, .external_lex_state = 2},
  [8039] = {.lex_state = 35},
  [8040] = {.lex_state = 35, .external_lex_state = 2},
  [8041] = {.lex_state = 35, .external_lex_state = 2},
  [8042] = {.lex_state = 35},
  [8043] = {.lex_state = 35, .external_lex_state = 2},
  [8044] = {.lex_state = 35},
  [8045] = {.lex_state = 35},
  [8046] = {.lex_state = 35, .external_lex_state = 2},
  [8047] = {.lex_state = 35},
  [8048] = {.lex_state = 35},
  [8049] = {.lex_state = 33, .external_lex_state = 3},
  [8050] = {.lex_state = 35},
  [8051] = {.lex_state = 35},
  [8052] = {.lex_state = 35},
  [8053] = {.lex_state = 35},
  [8054] = {.lex_state = 35},
  [8055] = {.lex_state = 33, .external_lex_state = 3},
  [8056] = {.lex_state = 35},
  [8057] = {.lex_state = 35},
  [8058] = {.lex_state = 35},
  [8059] = {.lex_state = 35},
  [8060] = {.lex_state = 35},
  [8061] = {.lex_state = 35},
  [8062] = {.lex_state = 35},
  [8063] = {.lex_state = 35},
  [8064] = {.lex_state = 35},
  [8065] = {.lex_state = 35},
  [8066] = {.lex_state = 35},
  [8067] = {.lex_state = 35},
  [8068] = {.lex_state = 35, .external_lex_state = 2},
  [8069] = {.lex_state = 35},
  [8070] = {.lex_state = 35, .external_lex_state = 2},
  [8071] = {.lex_state = 35},
  [8072] = {.lex_state = 35},
  [8073] = {.lex_state = 35},
  [8074] = {.lex_state = 35},
  [8075] = {.lex_state = 35, .external_lex_state = 2},
  [8076] = {.lex_state = 35, .external_lex_state = 2},
  [8077] = {.lex_state = 35},
  [8078] = {.lex_state = 35},
  [8079] = {.lex_state = 35},
  [8080] = {.lex_state = 35, .external_lex_state = 2},
  [8081] = {.lex_state = 35, .external_lex_state = 2},
  [8082] = {.lex_state = 35},
  [8083] = {.lex_state = 35},
  [8084] = {.lex_state = 35},
  [8085] = {.lex_state = 35, .external_lex_state = 2},
  [8086] = {.lex_state = 35},
  [8087] = {.lex_state = 35, .external_lex_state = 2},
  [8088] = {.lex_state = 35},
  [8089] = {.lex_state = 35},
  [8090] = {.lex_state = 35},
  [8091] = {.lex_state = 35},
  [8092] = {.lex_state = 35},
  [8093] = {.lex_state = 33, .external_lex_state = 3},
  [8094] = {.lex_state = 35},
  [8095] = {.lex_state = 35, .external_lex_state = 2},
  [8096] = {.lex_state = 35, .external_lex_state = 2},
  [8097] = {.lex_state = 35},
  [8098] = {.lex_state = 33, .external_lex_state = 3},
  [8099] = {.lex_state = 35},
  [8100] = {.lex_state = 35},
  [8101] = {.lex_state = 35},
  [8102] = {.lex_state = 35},
  [8103] = {.lex_state = 35},
  [8104] = {.lex_state = 35},
  [8105] = {.lex_state = 33, .external_lex_state = 3},
  [8106] = {.lex_state = 35},
  [8107] = {.lex_state = 35},
  [8108] = {.lex_state = 35},
  [8109] = {.lex_state = 35},
  [8110] = {.lex_state = 35},
  [8111] = {.lex_state = 35},
  [8112] = {.lex_state = 35, .external_lex_state = 2},
  [8113] = {.lex_state = 35},
  [8114] = {.lex_state = 35},
  [8115] = {.lex_state = 33, .external_lex_state = 3},
  [8116] = {.lex_state = 35},
  [8117] = {.lex_state = 35},
  [8118] = {.lex_state = 35},
  [8119] = {.lex_state = 35},
  [8120] = {.lex_state = 35},
  [8121] = {.lex_state = 35},
  [8122] = {.lex_state = 35},
  [8123] = {.lex_state = 35},
  [8124] = {.lex_state = 35},
  [8125] = {.lex_state = 35},
  [8126] = {.lex_state = 35},
  [8127] = {.lex_state = 35},
  [8128] = {.lex_state = 35},
  [8129] = {.lex_state = 35, .external_lex_state = 2},
  [8130] = {.lex_state = 35},
  [8131] = {.lex_state = 35},
  [8132] = {.lex_state = 35, .external_lex_state = 2},
  [8133] = {.lex_state = 35},
  [8134] = {.lex_state = 35},
  [8135] = {.lex_state = 35, .external_lex_state = 2},
  [8136] = {.lex_state = 35},
  [8137] = {.lex_state = 35},
  [8138] = {.lex_state = 35},
  [8139] = {.lex_state = 33},
  [8140] = {.lex_state = 35},
  [8141] = {.lex_state = 35},
  [8142] = {.lex_state = 33},
  [8143] = {.lex_state = 33},
  [8144] = {.lex_state = 35, .external_lex_state = 2},
  [8145] = {.lex_state = 35},
  [8146] = {.lex_state = 35},
  [8147] = {.lex_state = 35},
  [8148] = {.lex_state = 35},
  [8149] = {.lex_state = 35},
  [8150] = {.lex_state = 35},
  [8151] = {.lex_state = 35},
  [8152] = {.lex_state = 35},
  [8153] = {.lex_state = 35, .external_lex_state = 2},
  [8154] = {.lex_state = 35},
  [8155] = {.lex_state = 35},
  [8156] = {.lex_state = 35},
  [8157] = {.lex_state = 35},
  [8158] = {.lex_state = 35, .external_lex_state = 2},
  [8159] = {.lex_state = 35, .external_lex_state = 2},
  [8160] = {.lex_state = 35},
  [8161] = {.lex_state = 35},
  [8162] = {.lex_state = 35},
  [8163] = {.lex_state = 35},
  [8164] = {.lex_state = 35, .external_lex_state = 2},
  [8165] = {.lex_state = 35},
  [8166] = {.lex_state = 35},
  [8167] = {.lex_state = 35},
  [8168] = {.lex_state = 35},
  [8169] = {.lex_state = 35},
  [8170] = {.lex_state = 35},
  [8171] = {.lex_state = 35},
  [8172] = {.lex_state = 35, .external_lex_state = 2},
  [8173] = {.lex_state = 35},
  [8174] = {.lex_state = 35},
  [8175] = {.lex_state = 33, .external_lex_state = 3},
  [8176] = {.lex_state = 35},
  [8177] = {.lex_state = 35},
  [8178] = {.lex_state = 35},
  [8179] = {.lex_state = 35},
  [8180] = {.lex_state = 35},
  [8181] = {.lex_state = 35},
  [8182] = {.lex_state = 35},
  [8183] = {.lex_state = 35},
  [8184] = {.lex_state = 35},
  [8185] = {.lex_state = 35},
  [8186] = {.lex_state = 35, .external_lex_state = 2},
  [8187] = {.lex_state = 33, .external_lex_state = 3},
  [8188] = {.lex_state = 35},
  [8189] = {.lex_state = 35},
  [8190] = {.lex_state = 35},
  [8191] = {.lex_state = 35},
  [8192] = {.lex_state = 35},
  [8193] = {.lex_state = 35},
  [8194] = {.lex_state = 35},
  [8195] = {.lex_state = 35},
  [8196] = {.lex_state = 35},
  [8197] = {.lex_state = 35},
  [8198] = {.lex_state = 35},
  [8199] = {.lex_state = 35},
  [8200] = {.lex_state = 35},
  [8201] = {.lex_state = 35},
  [8202] = {.lex_state = 35},
  [8203] = {.lex_state = 35},
  [8204] = {.lex_state = 35},
  [8205] = {.lex_state = 35},
  [8206] = {.lex_state = 35, .external_lex_state = 2},
  [8207] = {.lex_state = 35},
  [8208] = {.lex_state = 35},
  [8209] = {.lex_state = 35},
  [8210] = {.lex_state = 35},
  [8211] = {.lex_state = 35},
  [8212] = {.lex_state = 35},
  [8213] = {.lex_state = 35},
  [8214] = {.lex_state = 35},
  [8215] = {.lex_state = 35},
  [8216] = {.lex_state = 35},
  [8217] = {.lex_state = 35},
  [8218] = {.lex_state = 35},
  [8219] = {.lex_state = 35},
  [8220] = {.lex_state = 35},
  [8221] = {.lex_state = 35, .external_lex_state = 2},
  [8222] = {.lex_state = 35},
  [8223] = {.lex_state = 35},
  [8224] = {.lex_state = 35},
  [8225] = {.lex_state = 35, .external_lex_state = 2},
  [8226] = {.lex_state = 35},
  [8227] = {.lex_state = 35, .external_lex_state = 2},
  [8228] = {.lex_state = 35},
  [8229] = {.lex_state = 35},
  [8230] = {.lex_state = 35},
  [8231] = {.lex_state = 33},
  [8232] = {.lex_state = 35},
  [8233] = {.lex_state = 35},
  [8234] = {.lex_state = 35},
  [8235] = {.lex_state = 35},
  [8236] = {.lex_state = 35},
  [8237] = {.lex_state = 35},
  [8238] = {.lex_state = 35},
  [8239] = {.lex_state = 35},
  [8240] = {.lex_state = 35},
  [8241] = {.lex_state = 35},
  [8242] = {.lex_state = 35},
  [8243] = {.lex_state = 35},
  [8244] = {.lex_state = 35},
  [8245] = {.lex_state = 35},
  [8246] = {.lex_state = 35},
  [8247] = {.lex_state = 35},
  [8248] = {.lex_state = 35, .external_lex_state = 2},
  [8249] = {.lex_state = 35},
  [8250] = {.lex_state = 35},
  [8251] = {.lex_state = 35, .external_lex_state = 2},
  [8252] = {.lex_state = 35},
  [8253] = {.lex_state = 35},
  [8254] = {.lex_state = 35},
  [8255] = {.lex_state = 35},
  [8256] = {.lex_state = 33, .external_lex_state = 3},
  [8257] = {.lex_state = 35, .external_lex_state = 2},
  [8258] = {.lex_state = 35, .external_lex_state = 2},
  [8259] = {.lex_state = 35},
  [8260] = {.lex_state = 35},
  [8261] = {.lex_state = 35},
  [8262] = {.lex_state = 35},
  [8263] = {.lex_state = 35, .external_lex_state = 2},
  [8264] = {.lex_state = 35},
  [8265] = {.lex_state = 35},
  [8266] = {.lex_state = 35},
  [8267] = {.lex_state = 35},
  [8268] = {.lex_state = 35, .external_lex_state = 2},
  [8269] = {.lex_state = 35},
  [8270] = {.lex_state = 35},
  [8271] = {.lex_state = 35},
  [8272] = {.lex_state = 35},
  [8273] = {.lex_state = 35, .external_lex_state = 2},
  [8274] = {.lex_state = 35},
  [8275] = {.lex_state = 35},
  [8276] = {.lex_state = 35},
  [8277] = {.lex_state = 35},
  [8278] = {.lex_state = 35},
  [8279] = {.lex_state = 35},
  [8280] = {.lex_state = 35},
  [8281] = {.lex_state = 35},
  [8282] = {.lex_state = 35},
  [8283] = {.lex_state = 35},
  [8284] = {.lex_state = 35},
  [8285] = {.lex_state = 35},
  [8286] = {.lex_state = 35},
  [8287] = {.lex_state = 35},
  [8288] = {.lex_state = 35},
  [8289] = {.lex_state = 35},
  [8290] = {.lex_state = 35},
  [8291] = {.lex_state = 35},
  [8292] = {.lex_state = 35},
  [8293] = {.lex_state = 35},
  [8294] = {.lex_state = 35},
  [8295] = {.lex_state = 35},
  [8296] = {.lex_state = 35},
  [8297] = {.lex_state = 35},
  [8298] = {.lex_state = 35, .external_lex_state = 2},
  [8299] = {.lex_state = 35},
  [8300] = {.lex_state = 35},
  [8301] = {.lex_state = 35},
  [8302] = {.lex_state = 35},
  [8303] = {.lex_state = 35},
  [8304] = {.lex_state = 33},
  [8305] = {.lex_state = 35},
  [8306] = {.lex_state = 35, .external_lex_state = 2},
  [8307] = {.lex_state = 35},
  [8308] = {.lex_state = 35},
  [8309] = {.lex_state = 35},
  [8310] = {.lex_state = 35, .external_lex_state = 2},
  [8311] = {.lex_state = 35},
  [8312] = {.lex_state = 35, .external_lex_state = 2},
  [8313] = {.lex_state = 35},
  [8314] = {.lex_state = 35},
  [8315] = {.lex_state = 35},
  [8316] = {.lex_state = 35},
  [8317] = {.lex_state = 35},
  [8318] = {.lex_state = 35},
  [8319] = {.lex_state = 35},
  [8320] = {.lex_state = 35},
  [8321] = {.lex_state = 35, .external_lex_state = 2},
  [8322] = {.lex_state = 35},
  [8323] = {.lex_state = 35},
  [8324] = {.lex_state = 35},
  [8325] = {.lex_state = 35},
  [8326] = {.lex_state = 35, .external_lex_state = 2},
  [8327] = {.lex_state = 35},
  [8328] = {.lex_state = 35},
  [8329] = {.lex_state = 35},
  [8330] = {.lex_state = 35},
  [8331] = {.lex_state = 35},
  [8332] = {.lex_state = 35},
  [8333] = {.lex_state = 35},
  [8334] = {.lex_state = 35},
  [8335] = {.lex_state = 35},
  [8336] = {.lex_state = 35},
  [8337] = {.lex_state = 35, .external_lex_state = 2},
  [8338] = {.lex_state = 35},
  [8339] = {.lex_state = 35},
  [8340] = {.lex_state = 35},
  [8341] = {.lex_state = 35},
  [8342] = {.lex_state = 35},
  [8343] = {.lex_state = 35},
  [8344] = {.lex_state = 35},
  [8345] = {.lex_state = 35},
  [8346] = {.lex_state = 35},
  [8347] = {.lex_state = 35},
  [8348] = {.lex_state = 35, .external_lex_state = 2},
  [8349] = {.lex_state = 35},
  [8350] = {.lex_state = 35},
  [8351] = {.lex_state = 35, .external_lex_state = 2},
  [8352] = {.lex_state = 35},
  [8353] = {.lex_state = 35, .external_lex_state = 2},
  [8354] = {.lex_state = 35},
  [8355] = {.lex_state = 35},
  [8356] = {.lex_state = 35},
  [8357] = {.lex_state = 35},
  [8358] = {.lex_state = 35},
  [8359] = {.lex_state = 35},
  [8360] = {.lex_state = 35},
  [8361] = {.lex_state = 35},
  [8362] = {.lex_state = 35},
  [8363] = {.lex_state = 35},
  [8364] = {.lex_state = 35, .external_lex_state = 2},
  [8365] = {.lex_state = 35},
  [8366] = {.lex_state = 35},
  [8367] = {.lex_state = 35},
  [8368] = {.lex_state = 35},
  [8369] = {.lex_state = 35},
  [8370] = {.lex_state = 35},
  [8371] = {.lex_state = 35},
  [8372] = {.lex_state = 35},
  [8373] = {.lex_state = 35},
  [8374] = {.lex_state = 35, .external_lex_state = 2},
  [8375] = {.lex_state = 35},
  [8376] = {.lex_state = 35},
  [8377] = {.lex_state = 35},
  [8378] = {.lex_state = 35},
  [8379] = {.lex_state = 35},
  [8380] = {.lex_state = 35, .external_lex_state = 2},
  [8381] = {.lex_state = 35},
  [8382] = {.lex_state = 35},
  [8383] = {.lex_state = 35},
  [8384] = {.lex_state = 35},
  [8385] = {.lex_state = 35},
  [8386] = {.lex_state = 35},
  [8387] = {.lex_state = 35},
  [8388] = {.lex_state = 35},
  [8389] = {.lex_state = 35},
  [8390] = {.lex_state = 35},
  [8391] = {.lex_state = 35},
  [8392] = {.lex_state = 35},
  [8393] = {.lex_state = 33, .external_lex_state = 3},
  [8394] = {.lex_state = 35},
  [8395] = {.lex_state = 35},
  [8396] = {.lex_state = 35, .external_lex_state = 2},
  [8397] = {.lex_state = 35},
  [8398] = {.lex_state = 35},
  [8399] = {.lex_state = 35},
  [8400] = {.lex_state = 35},
  [8401] = {.lex_state = 0, .external_lex_state = 3},
  [8402] = {.lex_state = 35},
  [8403] = {.lex_state = 35},
  [8404] = {.lex_state = 35},
  [8405] = {.lex_state = 35},
  [8406] = {.lex_state = 35},
  [8407] = {.lex_state = 35},
  [8408] = {.lex_state = 35},
  [8409] = {.lex_state = 35},
  [8410] = {.lex_state = 35},
  [8411] = {.lex_state = 35},
  [8412] = {.lex_state = 35},
  [8413] = {.lex_state = 35},
  [8414] = {.lex_state = 35},
  [8415] = {.lex_state = 35},
  [8416] = {.lex_state = 35},
  [8417] = {.lex_state = 35},
  [8418] = {.lex_state = 35},
  [8419] = {.lex_state = 35},
  [8420] = {.lex_state = 35},
  [8421] = {.lex_state = 35, .external_lex_state = 2},
  [8422] = {.lex_state = 35},
  [8423] = {.lex_state = 35},
  [8424] = {.lex_state = 35},
  [8425] = {.lex_state = 35},
  [8426] = {.lex_state = 35},
  [8427] = {.lex_state = 33},
  [8428] = {.lex_state = 35},
  [8429] = {.lex_state = 35},
  [8430] = {.lex_state = 35},
  [8431] = {.lex_state = 33, .external_lex_state = 3},
  [8432] = {.lex_state = 35, .external_lex_state = 2},
  [8433] = {.lex_state = 35},
  [8434] = {.lex_state = 35},
  [8435] = {.lex_state = 35},
  [8436] = {.lex_state = 35, .external_lex_state = 2},
  [8437] = {.lex_state = 33, .external_lex_state = 3},
  [8438] = {.lex_state = 35},
  [8439] = {.lex_state = 35, .external_lex_state = 2},
  [8440] = {.lex_state = 35},
  [8441] = {.lex_state = 35},
  [8442] = {.lex_state = 35},
  [8443] = {.lex_state = 35},
  [8444] = {.lex_state = 35},
  [8445] = {.lex_state = 35},
  [8446] = {.lex_state = 35},
  [8447] = {.lex_state = 35},
  [8448] = {.lex_state = 35},
  [8449] = {.lex_state = 35},
  [8450] = {.lex_state = 35},
  [8451] = {.lex_state = 35, .external_lex_state = 2},
  [8452] = {.lex_state = 35, .external_lex_state = 2},
  [8453] = {.lex_state = 35},
  [8454] = {.lex_state = 35},
  [8455] = {.lex_state = 35},
  [8456] = {.lex_state = 35},
  [8457] = {.lex_state = 35},
  [8458] = {.lex_state = 35},
  [8459] = {.lex_state = 35},
  [8460] = {.lex_state = 35},
  [8461] = {.lex_state = 35},
  [8462] = {.lex_state = 35},
  [8463] = {.lex_state = 35},
  [8464] = {.lex_state = 35},
  [8465] = {.lex_state = 35},
  [8466] = {.lex_state = 35, .external_lex_state = 2},
  [8467] = {.lex_state = 35},
  [8468] = {.lex_state = 35, .external_lex_state = 2},
  [8469] = {.lex_state = 35},
  [8470] = {.lex_state = 35},
  [8471] = {.lex_state = 35},
  [8472] = {.lex_state = 35},
  [8473] = {.lex_state = 35},
  [8474] = {.lex_state = 35},
  [8475] = {.lex_state = 35},
  [8476] = {.lex_state = 35},
  [8477] = {.lex_state = 35},
  [8478] = {.lex_state = 35},
  [8479] = {.lex_state = 35, .external_lex_state = 2},
  [8480] = {.lex_state = 35},
  [8481] = {.lex_state = 33, .external_lex_state = 3},
  [8482] = {.lex_state = 35},
  [8483] = {.lex_state = 33},
  [8484] = {.lex_state = 35},
  [8485] = {.lex_state = 35},
  [8486] = {.lex_state = 35},
  [8487] = {.lex_state = 35},
  [8488] = {.lex_state = 35},
  [8489] = {.lex_state = 35},
  [8490] = {.lex_state = 35},
  [8491] = {.lex_state = 35},
  [8492] = {.lex_state = 35},
  [8493] = {.lex_state = 35},
  [8494] = {.lex_state = 35},
  [8495] = {.lex_state = 0, .external_lex_state = 3},
  [8496] = {.lex_state = 33, .external_lex_state = 3},
  [8497] = {.lex_state = 35},
  [8498] = {.lex_state = 35, .external_lex_state = 2},
  [8499] = {.lex_state = 35},
  [8500] = {.lex_state = 35},
  [8501] = {.lex_state = 35},
  [8502] = {.lex_state = 35},
  [8503] = {.lex_state = 35},
  [8504] = {.lex_state = 35},
  [8505] = {.lex_state = 35},
  [8506] = {.lex_state = 35},
  [8507] = {.lex_state = 35},
  [8508] = {.lex_state = 35},
  [8509] = {.lex_state = 35},
  [8510] = {.lex_state = 35},
  [8511] = {.lex_state = 35},
  [8512] = {.lex_state = 35},
  [8513] = {.lex_state = 35},
  [8514] = {.lex_state = 35},
  [8515] = {.lex_state = 35},
  [8516] = {.lex_state = 35},
  [8517] = {.lex_state = 35},
  [8518] = {.lex_state = 35},
  [8519] = {.lex_state = 35},
  [8520] = {.lex_state = 35},
  [8521] = {.lex_state = 35},
  [8522] = {.lex_state = 35},
  [8523] = {.lex_state = 35},
  [8524] = {.lex_state = 35, .external_lex_state = 2},
  [8525] = {.lex_state = 35},
  [8526] = {.lex_state = 35},
  [8527] = {.lex_state = 35},
  [8528] = {.lex_state = 35},
  [8529] = {.lex_state = 35},
  [8530] = {.lex_state = 35},
  [8531] = {.lex_state = 35, .external_lex_state = 2},
  [8532] = {.lex_state = 35},
  [8533] = {.lex_state = 35},
  [8534] = {.lex_state = 35},
  [8535] = {.lex_state = 35},
  [8536] = {.lex_state = 35},
  [8537] = {.lex_state = 35},
  [8538] = {.lex_state = 35},
  [8539] = {.lex_state = 33, .external_lex_state = 3},
  [8540] = {.lex_state = 35},
  [8541] = {.lex_state = 35},
  [8542] = {.lex_state = 35},
  [8543] = {.lex_state = 35},
  [8544] = {.lex_state = 35},
  [8545] = {.lex_state = 35},
  [8546] = {.lex_state = 35},
  [8547] = {.lex_state = 35},
  [8548] = {.lex_state = 35},
  [8549] = {.lex_state = 35},
  [8550] = {.lex_state = 35},
  [8551] = {.lex_state = 35},
  [8552] = {.lex_state = 35},
  [8553] = {.lex_state = 35},
  [8554] = {.lex_state = 35},
  [8555] = {.lex_state = 35, .external_lex_state = 2},
  [8556] = {.lex_state = 35},
  [8557] = {.lex_state = 35},
  [8558] = {.lex_state = 35},
  [8559] = {.lex_state = 35},
  [8560] = {.lex_state = 35},
  [8561] = {.lex_state = 35},
  [8562] = {.lex_state = 35},
  [8563] = {.lex_state = 35},
  [8564] = {.lex_state = 35},
  [8565] = {.lex_state = 35},
  [8566] = {.lex_state = 35},
  [8567] = {.lex_state = 35},
  [8568] = {.lex_state = 35},
  [8569] = {.lex_state = 35},
  [8570] = {.lex_state = 35},
  [8571] = {.lex_state = 35},
  [8572] = {.lex_state = 35},
  [8573] = {.lex_state = 35},
  [8574] = {.lex_state = 35},
  [8575] = {.lex_state = 35},
  [8576] = {.lex_state = 35},
  [8577] = {.lex_state = 35},
  [8578] = {.lex_state = 35},
  [8579] = {.lex_state = 35},
  [8580] = {.lex_state = 35},
  [8581] = {.lex_state = 35},
  [8582] = {.lex_state = 35},
  [8583] = {.lex_state = 33, .external_lex_state = 3},
  [8584] = {.lex_state = 35},
  [8585] = {.lex_state = 35},
  [8586] = {.lex_state = 35},
  [8587] = {.lex_state = 35},
  [8588] = {.lex_state = 35, .external_lex_state = 2},
  [8589] = {.lex_state = 35},
  [8590] = {.lex_state = 35},
  [8591] = {.lex_state = 35},
  [8592] = {.lex_state = 35, .external_lex_state = 2},
  [8593] = {.lex_state = 35},
  [8594] = {.lex_state = 35},
  [8595] = {.lex_state = 35},
  [8596] = {.lex_state = 35},
  [8597] = {.lex_state = 35},
  [8598] = {.lex_state = 35, .external_lex_state = 2},
  [8599] = {.lex_state = 35},
  [8600] = {.lex_state = 35},
  [8601] = {.lex_state = 35},
  [8602] = {.lex_state = 35, .external_lex_state = 2},
  [8603] = {.lex_state = 35, .external_lex_state = 2},
  [8604] = {.lex_state = 35},
  [8605] = {.lex_state = 35},
  [8606] = {.lex_state = 35, .external_lex_state = 2},
  [8607] = {.lex_state = 35},
  [8608] = {.lex_state = 33, .external_lex_state = 3},
  [8609] = {.lex_state = 35},
  [8610] = {.lex_state = 35, .external_lex_state = 2},
  [8611] = {.lex_state = 35},
  [8612] = {.lex_state = 35},
  [8613] = {.lex_state = 35},
  [8614] = {.lex_state = 35},
  [8615] = {.lex_state = 35},
  [8616] = {.lex_state = 35},
  [8617] = {.lex_state = 35},
  [8618] = {.lex_state = 35, .external_lex_state = 2},
  [8619] = {.lex_state = 35},
  [8620] = {.lex_state = 35},
  [8621] = {.lex_state = 35},
  [8622] = {.lex_state = 35},
  [8623] = {.lex_state = 35},
  [8624] = {.lex_state = 35},
  [8625] = {.lex_state = 35},
  [8626] = {.lex_state = 35},
  [8627] = {.lex_state = 35},
  [8628] = {.lex_state = 35},
  [8629] = {.lex_state = 35, .external_lex_state = 2},
  [8630] = {.lex_state = 33, .external_lex_state = 3},
  [8631] = {.lex_state = 35},
  [8632] = {.lex_state = 35},
  [8633] = {.lex_state = 35},
  [8634] = {.lex_state = 35},
  [8635] = {.lex_state = 35},
  [8636] = {.lex_state = 35},
  [8637] = {.lex_state = 35},
  [8638] = {.lex_state = 35},
  [8639] = {.lex_state = 35, .external_lex_state = 2},
  [8640] = {.lex_state = 35},
  [8641] = {.lex_state = 35},
  [8642] = {.lex_state = 35},
  [8643] = {.lex_state = 35, .external_lex_state = 2},
  [8644] = {.lex_state = 35},
  [8645] = {.lex_state = 35},
  [8646] = {.lex_state = 35},
  [8647] = {.lex_state = 35},
  [8648] = {.lex_state = 33},
  [8649] = {.lex_state = 35},
  [8650] = {.lex_state = 35},
  [8651] = {.lex_state = 35},
  [8652] = {.lex_state = 35},
  [8653] = {.lex_state = 35},
  [8654] = {.lex_state = 35},
  [8655] = {.lex_state = 35},
  [8656] = {.lex_state = 35, .external_lex_state = 2},
  [8657] = {.lex_state = 35},
  [8658] = {.lex_state = 35},
  [8659] = {.lex_state = 35},
  [8660] = {.lex_state = 35},
  [8661] = {.lex_state = 35},
  [8662] = {.lex_state = 35},
  [8663] = {.lex_state = 35},
  [8664] = {.lex_state = 35},
  [8665] = {.lex_state = 35},
  [8666] = {.lex_state = 35},
  [8667] = {.lex_state = 35},
  [8668] = {.lex_state = 33, .external_lex_state = 3},
  [8669] = {.lex_state = 35},
  [8670] = {.lex_state = 35},
  [8671] = {.lex_state = 35},
  [8672] = {.lex_state = 35},
  [8673] = {.lex_state = 35},
  [8674] = {.lex_state = 35, .external_lex_state = 2},
  [8675] = {.lex_state = 35},
  [8676] = {.lex_state = 35},
  [8677] = {.lex_state = 0, .external_lex_state = 3},
  [8678] = {.lex_state = 35},
  [8679] = {.lex_state = 35},
  [8680] = {.lex_state = 35},
  [8681] = {.lex_state = 35},
  [8682] = {.lex_state = 1},
  [8683] = {.lex_state = 35},
  [8684] = {.lex_state = 35},
  [8685] = {.lex_state = 35},
  [8686] = {.lex_state = 0, .external_lex_state = 3},
  [8687] = {.lex_state = 0, .external_lex_state = 3},
  [8688] = {.lex_state = 35},
  [8689] = {.lex_state = 1},
  [8690] = {.lex_state = 35},
  [8691] = {.lex_state = 1},
  [8692] = {.lex_state = 0, .external_lex_state = 3},
  [8693] = {.lex_state = 35, .external_lex_state = 2},
  [8694] = {.lex_state = 0, .external_lex_state = 3},
  [8695] = {.lex_state = 35},
  [8696] = {.lex_state = 1},
  [8697] = {.lex_state = 35},
  [8698] = {.lex_state = 35, .external_lex_state = 2},
  [8699] = {.lex_state = 35},
  [8700] = {.lex_state = 35},
  [8701] = {.lex_state = 1},
  [8702] = {.lex_state = 35},
  [8703] = {.lex_state = 35},
  [8704] = {.lex_state = 35, .external_lex_state = 2},
  [8705] = {.lex_state = 35},
  [8706] = {.lex_state = 35, .external_lex_state = 2},
  [8707] = {.lex_state = 35, .external_lex_state = 2},
  [8708] = {.lex_state = 35, .external_lex_state = 2},
  [8709] = {.lex_state = 0, .external_lex_state = 3},
  [8710] = {.lex_state = 35, .external_lex_state = 2},
  [8711] = {.lex_state = 35, .external_lex_state = 2},
  [8712] = {.lex_state = 35, .external_lex_state = 2},
  [8713] = {.lex_state = 35},
  [8714] = {.lex_state = 35},
  [8715] = {.lex_state = 35, .external_lex_state = 2},
  [8716] = {.lex_state = 35},
  [8717] = {.lex_state = 35},
  [8718] = {.lex_state = 35},
  [8719] = {.lex_state = 35, .external_lex_state = 2},
  [8720] = {.lex_state = 35, .external_lex_state = 2},
  [8721] = {.lex_state = 35},
  [8722] = {.lex_state = 0},
  [8723] = {.lex_state = 35},
  [8724] = {.lex_state = 0},
  [8725] = {.lex_state = 0},
  [8726] = {.lex_state = 35, .external_lex_state = 2},
  [8727] = {.lex_state = 35},
  [8728] = {.lex_state = 35},
  [8729] = {.lex_state = 35, .external_lex_state = 2},
  [8730] = {.lex_state = 35},
  [8731] = {.lex_state = 35, .external_lex_state = 2},
  [8732] = {.lex_state = 35, .external_lex_state = 2},
  [8733] = {.lex_state = 35},
  [8734] = {.lex_state = 35},
  [8735] = {.lex_state = 35, .external_lex_state = 2},
  [8736] = {.lex_state = 35},
  [8737] = {.lex_state = 35},
  [8738] = {.lex_state = 35},
  [8739] = {.lex_state = 35, .external_lex_state = 2},
  [8740] = {.lex_state = 35},
  [8741] = {.lex_state = 35, .external_lex_state = 2},
  [8742] = {.lex_state = 35, .external_lex_state = 2},
  [8743] = {.lex_state = 35},
  [8744] = {.lex_state = 35, .external_lex_state = 2},
  [8745] = {.lex_state = 35},
  [8746] = {.lex_state = 1},
  [8747] = {.lex_state = 35},
  [8748] = {.lex_state = 35},
  [8749] = {.lex_state = 35},
  [8750] = {.lex_state = 35, .external_lex_state = 2},
  [8751] = {.lex_state = 35, .external_lex_state = 2},
  [8752] = {.lex_state = 35},
  [8753] = {.lex_state = 35, .external_lex_state = 2},
  [8754] = {.lex_state = 35, .external_lex_state = 2},
  [8755] = {.lex_state = 35, .external_lex_state = 2},
  [8756] = {.lex_state = 35},
  [8757] = {.lex_state = 35},
  [8758] = {.lex_state = 0, .external_lex_state = 3},
  [8759] = {.lex_state = 0, .external_lex_state = 3},
  [8760] = {.lex_state = 35},
  [8761] = {.lex_state = 35},
  [8762] = {.lex_state = 35},
  [8763] = {.lex_state = 35},
  [8764] = {.lex_state = 35},
  [8765] = {.lex_state = 35},
  [8766] = {.lex_state = 35, .external_lex_state = 2},
  [8767] = {.lex_state = 35},
  [8768] = {.lex_state = 35},
  [8769] = {.lex_state = 35},
  [8770] = {.lex_state = 35, .external_lex_state = 2},
  [8771] = {.lex_state = 35},
  [8772] = {.lex_state = 35, .external_lex_state = 2},
  [8773] = {.lex_state = 35},
  [8774] = {.lex_state = 35, .external_lex_state = 2},
  [8775] = {.lex_state = 35},
  [8776] = {.lex_state = 35},
  [8777] = {.lex_state = 0, .external_lex_state = 3},
  [8778] = {.lex_state = 0, .external_lex_state = 3},
  [8779] = {.lex_state = 0, .external_lex_state = 3},
  [8780] = {.lex_state = 35, .external_lex_state = 2},
  [8781] = {.lex_state = 35},
  [8782] = {.lex_state = 35},
  [8783] = {.lex_state = 35, .external_lex_state = 2},
  [8784] = {.lex_state = 35, .external_lex_state = 2},
  [8785] = {.lex_state = 35},
  [8786] = {.lex_state = 35},
  [8787] = {.lex_state = 35, .external_lex_state = 2},
  [8788] = {.lex_state = 35},
  [8789] = {.lex_state = 35},
  [8790] = {.lex_state = 35},
  [8791] = {.lex_state = 35},
  [8792] = {.lex_state = 35, .external_lex_state = 2},
  [8793] = {.lex_state = 1},
  [8794] = {.lex_state = 35},
  [8795] = {.lex_state = 35},
  [8796] = {.lex_state = 35},
  [8797] = {.lex_state = 35},
  [8798] = {.lex_state = 35},
  [8799] = {.lex_state = 35},
  [8800] = {.lex_state = 35},
  [8801] = {.lex_state = 35},
  [8802] = {.lex_state = 0, .external_lex_state = 3},
  [8803] = {.lex_state = 35, .external_lex_state = 2},
  [8804] = {.lex_state = 35},
  [8805] = {.lex_state = 35},
  [8806] = {.lex_state = 35},
  [8807] = {.lex_state = 35},
  [8808] = {.lex_state = 35, .external_lex_state = 2},
  [8809] = {.lex_state = 0, .external_lex_state = 3},
  [8810] = {.lex_state = 35, .external_lex_state = 2},
  [8811] = {.lex_state = 0, .external_lex_state = 3},
  [8812] = {.lex_state = 35, .external_lex_state = 2},
  [8813] = {.lex_state = 35},
  [8814] = {.lex_state = 35},
  [8815] = {.lex_state = 35},
  [8816] = {.lex_state = 35},
  [8817] = {.lex_state = 35},
  [8818] = {.lex_state = 35, .external_lex_state = 2},
  [8819] = {.lex_state = 35},
  [8820] = {.lex_state = 35},
  [8821] = {.lex_state = 35},
  [8822] = {.lex_state = 35},
  [8823] = {.lex_state = 35, .external_lex_state = 2},
  [8824] = {.lex_state = 35},
  [8825] = {.lex_state = 35},
  [8826] = {.lex_state = 35},
  [8827] = {.lex_state = 35},
  [8828] = {.lex_state = 35},
  [8829] = {.lex_state = 35},
  [8830] = {.lex_state = 35},
  [8831] = {.lex_state = 35},
  [8832] = {.lex_state = 35},
  [8833] = {.lex_state = 35},
  [8834] = {.lex_state = 35},
  [8835] = {.lex_state = 35},
  [8836] = {.lex_state = 0},
  [8837] = {.lex_state = 35},
  [8838] = {.lex_state = 0, .external_lex_state = 3},
  [8839] = {.lex_state = 35},
  [8840] = {.lex_state = 1},
  [8841] = {.lex_state = 35},
  [8842] = {.lex_state = 35},
  [8843] = {.lex_state = 35, .external_lex_state = 2},
  [8844] = {.lex_state = 35, .external_lex_state = 2},
  [8845] = {.lex_state = 35},
  [8846] = {.lex_state = 35},
  [8847] = {.lex_state = 35},
  [8848] = {.lex_state = 0, .external_lex_state = 3},
  [8849] = {.lex_state = 35},
  [8850] = {.lex_state = 35},
  [8851] = {.lex_state = 35, .external_lex_state = 2},
  [8852] = {.lex_state = 35, .external_lex_state = 2},
  [8853] = {.lex_state = 35},
  [8854] = {.lex_state = 35},
  [8855] = {.lex_state = 35},
  [8856] = {.lex_state = 35},
  [8857] = {.lex_state = 35},
  [8858] = {.lex_state = 35},
  [8859] = {.lex_state = 35},
  [8860] = {.lex_state = 35},
  [8861] = {.lex_state = 0, .external_lex_state = 3},
  [8862] = {.lex_state = 35},
  [8863] = {.lex_state = 35},
  [8864] = {.lex_state = 35},
  [8865] = {.lex_state = 35, .external_lex_state = 2},
  [8866] = {.lex_state = 35},
  [8867] = {.lex_state = 35, .external_lex_state = 2},
  [8868] = {.lex_state = 35},
  [8869] = {.lex_state = 35, .external_lex_state = 2},
  [8870] = {.lex_state = 35},
  [8871] = {.lex_state = 35},
  [8872] = {.lex_state = 35},
  [8873] = {.lex_state = 35},
  [8874] = {.lex_state = 35},
  [8875] = {.lex_state = 35, .external_lex_state = 2},
  [8876] = {.lex_state = 0},
  [8877] = {.lex_state = 35, .external_lex_state = 2},
  [8878] = {.lex_state = 35},
  [8879] = {.lex_state = 0},
  [8880] = {.lex_state = 35},
  [8881] = {.lex_state = 35},
  [8882] = {.lex_state = 35},
  [8883] = {.lex_state = 35, .external_lex_state = 2},
  [8884] = {.lex_state = 35, .external_lex_state = 2},
  [8885] = {.lex_state = 35},
  [8886] = {.lex_state = 1},
  [8887] = {.lex_state = 35},
  [8888] = {.lex_state = 35},
  [8889] = {.lex_state = 35, .external_lex_state = 2},
  [8890] = {.lex_state = 35},
  [8891] = {.lex_state = 35},
  [8892] = {.lex_state = 35},
  [8893] = {.lex_state = 35, .external_lex_state = 2},
  [8894] = {.lex_state = 0, .external_lex_state = 3},
  [8895] = {.lex_state = 35, .external_lex_state = 2},
  [8896] = {.lex_state = 35, .external_lex_state = 2},
  [8897] = {.lex_state = 0, .external_lex_state = 3},
  [8898] = {.lex_state = 35},
  [8899] = {.lex_state = 10},
  [8900] = {.lex_state = 35},
  [8901] = {.lex_state = 35},
  [8902] = {.lex_state = 10},
  [8903] = {.lex_state = 35},
  [8904] = {.lex_state = 35, .external_lex_state = 2},
  [8905] = {.lex_state = 35, .external_lex_state = 2},
  [8906] = {.lex_state = 35},
  [8907] = {.lex_state = 35},
  [8908] = {.lex_state = 35, .external_lex_state = 2},
  [8909] = {.lex_state = 35},
  [8910] = {.lex_state = 35},
  [8911] = {.lex_state = 35, .external_lex_state = 2},
  [8912] = {.lex_state = 0, .external_lex_state = 3},
  [8913] = {.lex_state = 35},
  [8914] = {.lex_state = 35},
  [8915] = {.lex_state = 35},
  [8916] = {.lex_state = 35},
  [8917] = {.lex_state = 35, .external_lex_state = 2},
  [8918] = {.lex_state = 35},
  [8919] = {.lex_state = 35},
  [8920] = {.lex_state = 35, .external_lex_state = 2},
  [8921] = {.lex_state = 1},
  [8922] = {.lex_state = 35},
  [8923] = {.lex_state = 35},
  [8924] = {.lex_state = 35, .external_lex_state = 2},
  [8925] = {.lex_state = 35},
  [8926] = {.lex_state = 35},
  [8927] = {.lex_state = 0, .external_lex_state = 3},
  [8928] = {.lex_state = 10},
  [8929] = {.lex_state = 10},
  [8930] = {.lex_state = 35},
  [8931] = {.lex_state = 35},
  [8932] = {.lex_state = 35},
  [8933] = {.lex_state = 35},
  [8934] = {.lex_state = 35},
  [8935] = {.lex_state = 35},
  [8936] = {.lex_state = 0, .external_lex_state = 3},
  [8937] = {.lex_state = 35},
  [8938] = {.lex_state = 35},
  [8939] = {.lex_state = 35},
  [8940] = {.lex_state = 35},
  [8941] = {.lex_state = 35, .external_lex_state = 2},
  [8942] = {.lex_state = 35},
  [8943] = {.lex_state = 35},
  [8944] = {.lex_state = 35},
  [8945] = {.lex_state = 35},
  [8946] = {.lex_state = 35},
  [8947] = {.lex_state = 35},
  [8948] = {.lex_state = 35},
  [8949] = {.lex_state = 35},
  [8950] = {.lex_state = 35},
  [8951] = {.lex_state = 35},
  [8952] = {.lex_state = 35},
  [8953] = {.lex_state = 35},
  [8954] = {.lex_state = 35},
  [8955] = {.lex_state = 35},
  [8956] = {.lex_state = 35},
  [8957] = {.lex_state = 35},
  [8958] = {.lex_state = 35},
  [8959] = {.lex_state = 35},
  [8960] = {.lex_state = 1},
  [8961] = {.lex_state = 35},
  [8962] = {.lex_state = 1},
  [8963] = {.lex_state = 35},
  [8964] = {.lex_state = 35},
  [8965] = {.lex_state = 35},
  [8966] = {.lex_state = 35},
  [8967] = {.lex_state = 35, .external_lex_state = 2},
  [8968] = {.lex_state = 35},
  [8969] = {.lex_state = 35},
  [8970] = {.lex_state = 35, .external_lex_state = 2},
  [8971] = {.lex_state = 35, .external_lex_state = 2},
  [8972] = {.lex_state = 35},
  [8973] = {.lex_state = 35},
  [8974] = {.lex_state = 35, .external_lex_state = 2},
  [8975] = {.lex_state = 35},
  [8976] = {.lex_state = 35},
  [8977] = {.lex_state = 35},
  [8978] = {.lex_state = 35},
  [8979] = {.lex_state = 35},
  [8980] = {.lex_state = 35},
  [8981] = {.lex_state = 0, .external_lex_state = 3},
  [8982] = {.lex_state = 0, .external_lex_state = 3},
  [8983] = {.lex_state = 35},
  [8984] = {.lex_state = 35},
  [8985] = {.lex_state = 35},
  [8986] = {.lex_state = 35, .external_lex_state = 2},
  [8987] = {.lex_state = 35},
  [8988] = {.lex_state = 35, .external_lex_state = 2},
  [8989] = {.lex_state = 35},
  [8990] = {.lex_state = 35},
  [8991] = {.lex_state = 35},
  [8992] = {.lex_state = 35},
  [8993] = {.lex_state = 35},
  [8994] = {.lex_state = 0, .external_lex_state = 3},
  [8995] = {.lex_state = 0},
  [8996] = {.lex_state = 35},
  [8997] = {.lex_state = 35},
  [8998] = {.lex_state = 35},
  [8999] = {.lex_state = 35},
  [9000] = {.lex_state = 35},
  [9001] = {.lex_state = 0},
  [9002] = {.lex_state = 1},
  [9003] = {.lex_state = 35},
  [9004] = {.lex_state = 35},
  [9005] = {.lex_state = 0},
  [9006] = {.lex_state = 35},
  [9007] = {.lex_state = 0, .external_lex_state = 3},
  [9008] = {.lex_state = 0, .external_lex_state = 3},
  [9009] = {.lex_state = 35},
  [9010] = {.lex_state = 35},
  [9011] = {.lex_state = 35},
  [9012] = {.lex_state = 35},
  [9013] = {.lex_state = 0, .external_lex_state = 3},
  [9014] = {.lex_state = 0, .external_lex_state = 3},
  [9015] = {.lex_state = 35},
  [9016] = {.lex_state = 35, .external_lex_state = 2},
  [9017] = {.lex_state = 0, .external_lex_state = 3},
  [9018] = {.lex_state = 0, .external_lex_state = 3},
  [9019] = {.lex_state = 35, .external_lex_state = 2},
  [9020] = {.lex_state = 35, .external_lex_state = 2},
  [9021] = {.lex_state = 35},
  [9022] = {.lex_state = 35},
  [9023] = {.lex_state = 0, .external_lex_state = 3},
  [9024] = {.lex_state = 0, .external_lex_state = 3},
  [9025] = {.lex_state = 0, .external_lex_state = 3},
  [9026] = {.lex_state = 0, .external_lex_state = 3},
  [9027] = {.lex_state = 0, .external_lex_state = 3},
  [9028] = {.lex_state = 35},
  [9029] = {.lex_state = 0, .external_lex_state = 3},
  [9030] = {.lex_state = 35, .external_lex_state = 2},
  [9031] = {.lex_state = 35},
  [9032] = {.lex_state = 1},
  [9033] = {.lex_state = 35},
  [9034] = {.lex_state = 35},
  [9035] = {.lex_state = 35},
  [9036] = {.lex_state = 35},
  [9037] = {.lex_state = 0, .external_lex_state = 3},
  [9038] = {.lex_state = 0, .external_lex_state = 3},
  [9039] = {.lex_state = 35},
  [9040] = {.lex_state = 35},
  [9041] = {.lex_state = 35},
  [9042] = {.lex_state = 35},
  [9043] = {.lex_state = 35},
  [9044] = {.lex_state = 35},
  [9045] = {.lex_state = 35},
  [9046] = {.lex_state = 0, .external_lex_state = 3},
  [9047] = {.lex_state = 35},
  [9048] = {.lex_state = 35},
  [9049] = {.lex_state = 35},
  [9050] = {.lex_state = 0, .external_lex_state = 3},
  [9051] = {.lex_state = 35},
  [9052] = {.lex_state = 35},
  [9053] = {.lex_state = 0, .external_lex_state = 3},
  [9054] = {.lex_state = 35, .external_lex_state = 2},
  [9055] = {.lex_state = 1},
  [9056] = {.lex_state = 0, .external_lex_state = 3},
  [9057] = {.lex_state = 35},
  [9058] = {.lex_state = 35},
  [9059] = {.lex_state = 35},
  [9060] = {.lex_state = 0, .external_lex_state = 3},
  [9061] = {.lex_state = 0, .external_lex_state = 3},
  [9062] = {.lex_state = 35},
  [9063] = {.lex_state = 35},
  [9064] = {.lex_state = 35},
  [9065] = {.lex_state = 0, .external_lex_state = 3},
  [9066] = {.lex_state = 0, .external_lex_state = 3},
  [9067] = {.lex_state = 0, .external_lex_state = 3},
  [9068] = {.lex_state = 0, .external_lex_state = 3},
  [9069] = {.lex_state = 0, .external_lex_state = 3},
  [9070] = {.lex_state = 35},
  [9071] = {.lex_state = 0, .external_lex_state = 3},
  [9072] = {.lex_state = 35},
  [9073] = {.lex_state = 35},
  [9074] = {.lex_state = 35},
  [9075] = {.lex_state = 35, .external_lex_state = 2},
  [9076] = {.lex_state = 0, .external_lex_state = 3},
  [9077] = {.lex_state = 35, .external_lex_state = 2},
  [9078] = {.lex_state = 35},
  [9079] = {.lex_state = 35, .external_lex_state = 2},
  [9080] = {.lex_state = 35},
  [9081] = {.lex_state = 35, .external_lex_state = 2},
  [9082] = {.lex_state = 0, .external_lex_state = 3},
  [9083] = {.lex_state = 0},
  [9084] = {.lex_state = 0, .external_lex_state = 3},
  [9085] = {.lex_state = 0},
  [9086] = {.lex_state = 0, .external_lex_state = 3},
  [9087] = {.lex_state = 0, .external_lex_state = 3},
  [9088] = {.lex_state = 35},
  [9089] = {.lex_state = 35},
  [9090] = {.lex_state = 35},
  [9091] = {.lex_state = 0, .external_lex_state = 3},
  [9092] = {.lex_state = 35},
  [9093] = {.lex_state = 35},
  [9094] = {.lex_state = 35},
  [9095] = {.lex_state = 35, .external_lex_state = 2},
  [9096] = {.lex_state = 0, .external_lex_state = 3},
  [9097] = {.lex_state = 1},
  [9098] = {.lex_state = 35},
  [9099] = {.lex_state = 35},
  [9100] = {.lex_state = 35},
  [9101] = {.lex_state = 35},
  [9102] = {.lex_state = 35},
  [9103] = {.lex_state = 35},
  [9104] = {.lex_state = 35},
  [9105] = {.lex_state = 35},
  [9106] = {.lex_state = 35},
  [9107] = {.lex_state = 35},
  [9108] = {.lex_state = 35},
  [9109] = {.lex_state = 0, .external_lex_state = 3},
  [9110] = {.lex_state = 35},
  [9111] = {.lex_state = 35},
  [9112] = {.lex_state = 0, .external_lex_state = 3},
  [9113] = {.lex_state = 35},
  [9114] = {.lex_state = 35},
  [9115] = {.lex_state = 35},
  [9116] = {.lex_state = 35},
  [9117] = {.lex_state = 35},
  [9118] = {.lex_state = 0, .external_lex_state = 3},
  [9119] = {.lex_state = 35},
  [9120] = {.lex_state = 35},
  [9121] = {.lex_state = 0, .external_lex_state = 3},
  [9122] = {.lex_state = 35},
  [9123] = {.lex_state = 35},
  [9124] = {.lex_state = 0, .external_lex_state = 3},
  [9125] = {.lex_state = 0, .external_lex_state = 3},
  [9126] = {.lex_state = 35},
  [9127] = {.lex_state = 35},
  [9128] = {.lex_state = 35, .external_lex_state = 2},
  [9129] = {.lex_state = 35},
  [9130] = {.lex_state = 0, .external_lex_state = 3},
  [9131] = {.lex_state = 35},
  [9132] = {.lex_state = 0, .external_lex_state = 3},
  [9133] = {.lex_state = 35},
  [9134] = {.lex_state = 0, .external_lex_state = 3},
  [9135] = {.lex_state = 0, .external_lex_state = 3},
  [9136] = {.lex_state = 35},
  [9137] = {.lex_state = 0, .external_lex_state = 3},
  [9138] = {.lex_state = 35},
  [9139] = {.lex_state = 0, .external_lex_state = 3},
  [9140] = {.lex_state = 0, .external_lex_state = 3},
  [9141] = {.lex_state = 35},
  [9142] = {.lex_state = 35},
  [9143] = {.lex_state = 0, .external_lex_state = 3},
  [9144] = {.lex_state = 0, .external_lex_state = 3},
  [9145] = {.lex_state = 0, .external_lex_state = 3},
  [9146] = {.lex_state = 35},
  [9147] = {.lex_state = 0, .external_lex_state = 3},
  [9148] = {.lex_state = 35},
  [9149] = {.lex_state = 35},
  [9150] = {.lex_state = 35, .external_lex_state = 2},
  [9151] = {.lex_state = 35},
  [9152] = {.lex_state = 0, .external_lex_state = 3},
  [9153] = {.lex_state = 0, .external_lex_state = 3},
  [9154] = {.lex_state = 1},
  [9155] = {.lex_state = 0, .external_lex_state = 3},
  [9156] = {.lex_state = 35},
  [9157] = {.lex_state = 35},
  [9158] = {.lex_state = 35},
  [9159] = {.lex_state = 0, .external_lex_state = 3},
  [9160] = {.lex_state = 0, .external_lex_state = 3},
  [9161] = {.lex_state = 35, .external_lex_state = 2},
  [9162] = {.lex_state = 0, .external_lex_state = 3},
  [9163] = {.lex_state = 35},
  [9164] = {.lex_state = 35},
  [9165] = {.lex_state = 35},
  [9166] = {.lex_state = 35},
  [9167] = {.lex_state = 35},
  [9168] = {.lex_state = 10},
  [9169] = {.lex_state = 35},
  [9170] = {.lex_state = 10},
  [9171] = {.lex_state = 35},
  [9172] = {.lex_state = 35},
  [9173] = {.lex_state = 35},
  [9174] = {.lex_state = 35},
  [9175] = {.lex_state = 0, .external_lex_state = 3},
  [9176] = {.lex_state = 35},
  [9177] = {.lex_state = 33, .external_lex_state = 3},
  [9178] = {.lex_state = 0, .external_lex_state = 3},
  [9179] = {.lex_state = 0, .external_lex_state = 3},
  [9180] = {.lex_state = 0, .external_lex_state = 3},
  [9181] = {.lex_state = 35},
  [9182] = {.lex_state = 35},
  [9183] = {.lex_state = 0, .external_lex_state = 3},
  [9184] = {.lex_state = 0, .external_lex_state = 3},
  [9185] = {.lex_state = 0, .external_lex_state = 3},
  [9186] = {.lex_state = 0, .external_lex_state = 3},
  [9187] = {.lex_state = 35, .external_lex_state = 2},
  [9188] = {.lex_state = 35, .external_lex_state = 2},
  [9189] = {.lex_state = 35},
  [9190] = {.lex_state = 35},
  [9191] = {.lex_state = 35},
  [9192] = {.lex_state = 35},
  [9193] = {.lex_state = 0, .external_lex_state = 3},
  [9194] = {.lex_state = 35},
  [9195] = {.lex_state = 35},
  [9196] = {.lex_state = 35},
  [9197] = {.lex_state = 35},
  [9198] = {.lex_state = 0, .external_lex_state = 3},
  [9199] = {.lex_state = 35, .external_lex_state = 2},
  [9200] = {.lex_state = 0, .external_lex_state = 3},
  [9201] = {.lex_state = 0, .external_lex_state = 3},
  [9202] = {.lex_state = 35},
  [9203] = {.lex_state = 0, .external_lex_state = 3},
  [9204] = {.lex_state = 0, .external_lex_state = 3},
  [9205] = {.lex_state = 35},
  [9206] = {.lex_state = 35},
  [9207] = {.lex_state = 35},
  [9208] = {.lex_state = 35},
  [9209] = {.lex_state = 35},
  [9210] = {.lex_state = 35, .external_lex_state = 2},
  [9211] = {.lex_state = 35},
  [9212] = {.lex_state = 0, .external_lex_state = 3},
  [9213] = {.lex_state = 35},
  [9214] = {.lex_state = 35},
  [9215] = {.lex_state = 0, .external_lex_state = 3},
  [9216] = {.lex_state = 35},
  [9217] = {.lex_state = 35},
  [9218] = {.lex_state = 0, .external_lex_state = 3},
  [9219] = {.lex_state = 35, .external_lex_state = 2},
  [9220] = {.lex_state = 35},
  [9221] = {.lex_state = 0, .external_lex_state = 3},
  [9222] = {.lex_state = 35},
  [9223] = {.lex_state = 35},
  [9224] = {.lex_state = 0, .external_lex_state = 3},
  [9225] = {.lex_state = 35},
  [9226] = {.lex_state = 35},
  [9227] = {.lex_state = 35},
  [9228] = {.lex_state = 35},
  [9229] = {.lex_state = 35},
  [9230] = {.lex_state = 35},
  [9231] = {.lex_state = 0, .external_lex_state = 3},
  [9232] = {.lex_state = 1},
  [9233] = {.lex_state = 35, .external_lex_state = 2},
  [9234] = {.lex_state = 35},
  [9235] = {.lex_state = 35},
  [9236] = {.lex_state = 35},
  [9237] = {.lex_state = 35},
  [9238] = {.lex_state = 35, .external_lex_state = 2},
  [9239] = {.lex_state = 35},
  [9240] = {.lex_state = 35, .external_lex_state = 2},
  [9241] = {.lex_state = 35},
  [9242] = {.lex_state = 35},
  [9243] = {.lex_state = 35},
  [9244] = {.lex_state = 35},
  [9245] = {.lex_state = 35},
  [9246] = {.lex_state = 35},
  [9247] = {.lex_state = 35},
  [9248] = {.lex_state = 35},
  [9249] = {.lex_state = 35},
  [9250] = {.lex_state = 33, .external_lex_state = 3},
  [9251] = {.lex_state = 35},
  [9252] = {.lex_state = 35},
  [9253] = {.lex_state = 35},
  [9254] = {.lex_state = 35},
  [9255] = {.lex_state = 35},
  [9256] = {.lex_state = 0, .external_lex_state = 3},
  [9257] = {.lex_state = 35},
  [9258] = {.lex_state = 0, .external_lex_state = 3},
  [9259] = {.lex_state = 0, .external_lex_state = 3},
  [9260] = {.lex_state = 0, .external_lex_state = 3},
  [9261] = {.lex_state = 0, .external_lex_state = 3},
  [9262] = {.lex_state = 0, .external_lex_state = 3},
  [9263] = {.lex_state = 35},
  [9264] = {.lex_state = 35, .external_lex_state = 2},
  [9265] = {.lex_state = 0, .external_lex_state = 3},
  [9266] = {.lex_state = 0, .external_lex_state = 3},
  [9267] = {.lex_state = 35},
  [9268] = {.lex_state = 35},
  [9269] = {.lex_state = 35, .external_lex_state = 2},
  [9270] = {.lex_state = 35},
  [9271] = {.lex_state = 0, .external_lex_state = 3},
  [9272] = {.lex_state = 0, .external_lex_state = 3},
  [9273] = {.lex_state = 35},
  [9274] = {.lex_state = 0, .external_lex_state = 3},
  [9275] = {.lex_state = 10},
  [9276] = {.lex_state = 0, .external_lex_state = 3},
  [9277] = {.lex_state = 10},
  [9278] = {.lex_state = 0, .external_lex_state = 3},
  [9279] = {.lex_state = 35},
  [9280] = {.lex_state = 35},
  [9281] = {.lex_state = 35},
  [9282] = {.lex_state = 35},
  [9283] = {.lex_state = 35},
  [9284] = {.lex_state = 35},
  [9285] = {.lex_state = 35, .external_lex_state = 2},
  [9286] = {.lex_state = 35},
  [9287] = {.lex_state = 35},
  [9288] = {.lex_state = 0, .external_lex_state = 3},
  [9289] = {.lex_state = 0, .external_lex_state = 3},
  [9290] = {.lex_state = 0, .external_lex_state = 3},
  [9291] = {.lex_state = 0, .external_lex_state = 3},
  [9292] = {.lex_state = 0, .external_lex_state = 3},
  [9293] = {.lex_state = 35},
  [9294] = {.lex_state = 0, .external_lex_state = 3},
  [9295] = {.lex_state = 35},
  [9296] = {.lex_state = 35},
  [9297] = {.lex_state = 35},
  [9298] = {.lex_state = 35},
  [9299] = {.lex_state = 35, .external_lex_state = 2},
  [9300] = {.lex_state = 0},
  [9301] = {.lex_state = 0, .external_lex_state = 3},
  [9302] = {.lex_state = 0, .external_lex_state = 3},
  [9303] = {.lex_state = 0, .external_lex_state = 3},
  [9304] = {.lex_state = 35},
  [9305] = {.lex_state = 35},
  [9306] = {.lex_state = 0, .external_lex_state = 3},
  [9307] = {.lex_state = 35, .external_lex_state = 2},
  [9308] = {.lex_state = 0, .external_lex_state = 3},
  [9309] = {.lex_state = 1},
  [9310] = {.lex_state = 0},
  [9311] = {.lex_state = 35},
  [9312] = {.lex_state = 35},
  [9313] = {.lex_state = 0},
  [9314] = {.lex_state = 35},
  [9315] = {.lex_state = 35},
  [9316] = {.lex_state = 35, .external_lex_state = 2},
  [9317] = {.lex_state = 35},
  [9318] = {.lex_state = 35},
  [9319] = {.lex_state = 35},
  [9320] = {.lex_state = 35, .external_lex_state = 2},
  [9321] = {.lex_state = 35},
  [9322] = {.lex_state = 35},
  [9323] = {.lex_state = 35},
  [9324] = {.lex_state = 35},
  [9325] = {.lex_state = 0, .external_lex_state = 3},
  [9326] = {.lex_state = 0, .external_lex_state = 3},
  [9327] = {.lex_state = 0, .external_lex_state = 3},
  [9328] = {.lex_state = 35, .external_lex_state = 2},
  [9329] = {.lex_state = 35},
  [9330] = {.lex_state = 35},
  [9331] = {.lex_state = 35},
  [9332] = {.lex_state = 35},
  [9333] = {.lex_state = 35, .external_lex_state = 2},
  [9334] = {.lex_state = 35},
  [9335] = {.lex_state = 0, .external_lex_state = 3},
  [9336] = {.lex_state = 35},
  [9337] = {.lex_state = 35, .external_lex_state = 2},
  [9338] = {.lex_state = 35},
  [9339] = {.lex_state = 35},
  [9340] = {.lex_state = 35},
  [9341] = {.lex_state = 35},
  [9342] = {.lex_state = 35},
  [9343] = {.lex_state = 35},
  [9344] = {.lex_state = 35, .external_lex_state = 2},
  [9345] = {.lex_state = 35},
  [9346] = {.lex_state = 35},
  [9347] = {.lex_state = 35},
  [9348] = {.lex_state = 35},
  [9349] = {.lex_state = 0, .external_lex_state = 3},
  [9350] = {.lex_state = 0, .external_lex_state = 3},
  [9351] = {.lex_state = 35},
  [9352] = {.lex_state = 35},
  [9353] = {.lex_state = 35},
  [9354] = {.lex_state = 35},
  [9355] = {.lex_state = 35},
  [9356] = {.lex_state = 35},
  [9357] = {.lex_state = 35},
  [9358] = {.lex_state = 35},
  [9359] = {.lex_state = 35},
  [9360] = {.lex_state = 35},
  [9361] = {.lex_state = 35},
  [9362] = {.lex_state = 35},
  [9363] = {.lex_state = 0, .external_lex_state = 3},
  [9364] = {.lex_state = 35},
  [9365] = {.lex_state = 35},
  [9366] = {.lex_state = 35},
  [9367] = {.lex_state = 35},
  [9368] = {.lex_state = 35},
  [9369] = {.lex_state = 35},
  [9370] = {.lex_state = 35},
  [9371] = {.lex_state = 35},
  [9372] = {.lex_state = 35},
  [9373] = {.lex_state = 35},
  [9374] = {.lex_state = 35},
  [9375] = {.lex_state = 35},
  [9376] = {.lex_state = 35},
  [9377] = {.lex_state = 35},
  [9378] = {.lex_state = 35},
  [9379] = {.lex_state = 35},
  [9380] = {.lex_state = 35},
  [9381] = {.lex_state = 35},
  [9382] = {.lex_state = 0, .external_lex_state = 3},
  [9383] = {.lex_state = 35},
  [9384] = {.lex_state = 1},
  [9385] = {.lex_state = 35},
  [9386] = {.lex_state = 35},
  [9387] = {.lex_state = 35},
  [9388] = {.lex_state = 35},
  [9389] = {.lex_state = 35},
  [9390] = {.lex_state = 35},
  [9391] = {.lex_state = 35},
  [9392] = {.lex_state = 0},
  [9393] = {.lex_state = 35},
  [9394] = {.lex_state = 0},
  [9395] = {.lex_state = 35},
  [9396] = {.lex_state = 35},
  [9397] = {.lex_state = 0},
  [9398] = {.lex_state = 35},
  [9399] = {.lex_state = 0},
  [9400] = {.lex_state = 35},
  [9401] = {.lex_state = 35},
  [9402] = {.lex_state = 35},
  [9403] = {.lex_state = 0, .external_lex_state = 3},
  [9404] = {.lex_state = 0, .external_lex_state = 3},
  [9405] = {.lex_state = 35},
  [9406] = {.lex_state = 35},
  [9407] = {.lex_state = 35},
  [9408] = {.lex_state = 35},
  [9409] = {.lex_state = 0, .external_lex_state = 3},
  [9410] = {.lex_state = 0, .external_lex_state = 3},
  [9411] = {.lex_state = 35},
  [9412] = {.lex_state = 35},
  [9413] = {.lex_state = 35},
  [9414] = {.lex_state = 35},
  [9415] = {.lex_state = 35},
  [9416] = {.lex_state = 35},
  [9417] = {.lex_state = 35},
  [9418] = {.lex_state = 35},
  [9419] = {.lex_state = 35},
  [9420] = {.lex_state = 35},
  [9421] = {.lex_state = 35},
  [9422] = {.lex_state = 35},
  [9423] = {.lex_state = 35},
  [9424] = {.lex_state = 35},
  [9425] = {.lex_state = 35},
  [9426] = {.lex_state = 0, .external_lex_state = 3},
  [9427] = {.lex_state = 0, .external_lex_state = 3},
  [9428] = {.lex_state = 35},
  [9429] = {.lex_state = 35},
  [9430] = {.lex_state = 35},
  [9431] = {.lex_state = 35},
  [9432] = {.lex_state = 35},
  [9433] = {.lex_state = 35},
  [9434] = {.lex_state = 0, .external_lex_state = 3},
  [9435] = {.lex_state = 35},
  [9436] = {.lex_state = 35, .external_lex_state = 2},
  [9437] = {.lex_state = 35},
  [9438] = {.lex_state = 35},
  [9439] = {.lex_state = 35, .external_lex_state = 2},
  [9440] = {.lex_state = 35},
  [9441] = {.lex_state = 35},
  [9442] = {.lex_state = 35},
  [9443] = {.lex_state = 35},
  [9444] = {.lex_state = 35},
  [9445] = {.lex_state = 35},
  [9446] = {.lex_state = 35},
  [9447] = {.lex_state = 35},
  [9448] = {.lex_state = 35},
  [9449] = {.lex_state = 35},
  [9450] = {.lex_state = 35},
  [9451] = {.lex_state = 35},
  [9452] = {.lex_state = 0},
  [9453] = {.lex_state = 35},
  [9454] = {.lex_state = 35},
  [9455] = {.lex_state = 35},
  [9456] = {.lex_state = 35},
  [9457] = {.lex_state = 35},
  [9458] = {.lex_state = 35},
  [9459] = {.lex_state = 35},
  [9460] = {.lex_state = 35},
  [9461] = {.lex_state = 35},
  [9462] = {.lex_state = 35},
  [9463] = {.lex_state = 35},
  [9464] = {.lex_state = 35},
  [9465] = {.lex_state = 35},
  [9466] = {.lex_state = 35},
  [9467] = {.lex_state = 35},
  [9468] = {.lex_state = 35},
  [9469] = {.lex_state = 35},
  [9470] = {.lex_state = 35},
  [9471] = {.lex_state = 35},
  [9472] = {.lex_state = 35},
  [9473] = {.lex_state = 35},
  [9474] = {.lex_state = 35},
  [9475] = {.lex_state = 35},
  [9476] = {.lex_state = 35},
  [9477] = {.lex_state = 35},
  [9478] = {.lex_state = 35},
  [9479] = {.lex_state = 35},
  [9480] = {.lex_state = 35},
  [9481] = {.lex_state = 35},
  [9482] = {.lex_state = 35},
  [9483] = {.lex_state = 35},
  [9484] = {.lex_state = 35},
  [9485] = {.lex_state = 35},
  [9486] = {.lex_state = 35},
  [9487] = {.lex_state = 35},
  [9488] = {.lex_state = 35},
  [9489] = {.lex_state = 35},
  [9490] = {.lex_state = 35},
  [9491] = {.lex_state = 35},
  [9492] = {.lex_state = 35},
  [9493] = {.lex_state = 35},
  [9494] = {.lex_state = 35},
  [9495] = {.lex_state = 35, .external_lex_state = 2},
  [9496] = {.lex_state = 35},
  [9497] = {.lex_state = 35},
  [9498] = {.lex_state = 35},
  [9499] = {.lex_state = 35},
  [9500] = {.lex_state = 35},
  [9501] = {.lex_state = 35},
  [9502] = {.lex_state = 35},
  [9503] = {.lex_state = 35},
  [9504] = {.lex_state = 35},
  [9505] = {.lex_state = 35},
  [9506] = {.lex_state = 0},
  [9507] = {.lex_state = 35},
  [9508] = {.lex_state = 35},
  [9509] = {.lex_state = 35},
  [9510] = {.lex_state = 35},
  [9511] = {.lex_state = 35},
  [9512] = {.lex_state = 35},
  [9513] = {.lex_state = 35},
  [9514] = {.lex_state = 35},
  [9515] = {.lex_state = 35},
  [9516] = {.lex_state = 35},
  [9517] = {.lex_state = 35},
  [9518] = {.lex_state = 35},
  [9519] = {.lex_state = 35},
  [9520] = {.lex_state = 35},
  [9521] = {.lex_state = 35},
  [9522] = {.lex_state = 35},
  [9523] = {.lex_state = 35},
  [9524] = {.lex_state = 35},
  [9525] = {.lex_state = 35},
  [9526] = {.lex_state = 35},
  [9527] = {.lex_state = 35},
  [9528] = {.lex_state = 35},
  [9529] = {.lex_state = 35},
  [9530] = {.lex_state = 35},
  [9531] = {.lex_state = 35},
  [9532] = {.lex_state = 35},
  [9533] = {.lex_state = 35},
  [9534] = {.lex_state = 35},
  [9535] = {.lex_state = 35},
  [9536] = {.lex_state = 35},
  [9537] = {.lex_state = 35},
  [9538] = {.lex_state = 35},
  [9539] = {.lex_state = 35},
  [9540] = {.lex_state = 35},
  [9541] = {.lex_state = 35},
  [9542] = {.lex_state = 35},
  [9543] = {.lex_state = 35},
  [9544] = {.lex_state = 35},
  [9545] = {.lex_state = 35},
  [9546] = {.lex_state = 35},
  [9547] = {.lex_state = 35},
  [9548] = {.lex_state = 35},
  [9549] = {.lex_state = 35},
  [9550] = {.lex_state = 0},
  [9551] = {.lex_state = 35},
  [9552] = {.lex_state = 35},
  [9553] = {.lex_state = 35},
  [9554] = {.lex_state = 35},
  [9555] = {.lex_state = 35},
  [9556] = {.lex_state = 35},
  [9557] = {.lex_state = 35},
  [9558] = {.lex_state = 35},
  [9559] = {.lex_state = 35},
  [9560] = {.lex_state = 35},
  [9561] = {.lex_state = 35},
  [9562] = {.lex_state = 35, .external_lex_state = 2},
  [9563] = {.lex_state = 35},
  [9564] = {.lex_state = 35},
  [9565] = {.lex_state = 35},
  [9566] = {.lex_state = 35},
  [9567] = {.lex_state = 35},
  [9568] = {.lex_state = 35},
  [9569] = {.lex_state = 35},
  [9570] = {.lex_state = 0},
  [9571] = {.lex_state = 35},
  [9572] = {.lex_state = 35},
  [9573] = {.lex_state = 35},
  [9574] = {.lex_state = 35, .external_lex_state = 2},
  [9575] = {.lex_state = 35},
  [9576] = {.lex_state = 35},
  [9577] = {.lex_state = 35},
  [9578] = {.lex_state = 35},
  [9579] = {.lex_state = 35},
  [9580] = {.lex_state = 35},
  [9581] = {.lex_state = 35},
  [9582] = {.lex_state = 35},
  [9583] = {.lex_state = 35},
  [9584] = {.lex_state = 35},
  [9585] = {.lex_state = 35},
  [9586] = {.lex_state = 0},
  [9587] = {.lex_state = 0},
  [9588] = {.lex_state = 35},
  [9589] = {.lex_state = 35},
  [9590] = {.lex_state = 35},
  [9591] = {.lex_state = 35},
  [9592] = {.lex_state = 35},
  [9593] = {.lex_state = 35},
  [9594] = {.lex_state = 35},
  [9595] = {.lex_state = 35},
  [9596] = {.lex_state = 35},
  [9597] = {.lex_state = 0},
  [9598] = {.lex_state = 35},
  [9599] = {.lex_state = 35},
  [9600] = {.lex_state = 0},
  [9601] = {.lex_state = 0},
  [9602] = {.lex_state = 35},
  [9603] = {.lex_state = 35},
  [9604] = {.lex_state = 35},
  [9605] = {.lex_state = 35},
  [9606] = {.lex_state = 35},
  [9607] = {.lex_state = 35, .external_lex_state = 2},
  [9608] = {.lex_state = 35},
  [9609] = {.lex_state = 35},
  [9610] = {.lex_state = 35},
  [9611] = {.lex_state = 35},
  [9612] = {.lex_state = 35},
  [9613] = {.lex_state = 35},
  [9614] = {.lex_state = 35},
  [9615] = {.lex_state = 35},
  [9616] = {.lex_state = 35},
  [9617] = {.lex_state = 35},
  [9618] = {.lex_state = 35},
  [9619] = {.lex_state = 35},
  [9620] = {.lex_state = 0},
  [9621] = {.lex_state = 0},
  [9622] = {.lex_state = 35},
  [9623] = {.lex_state = 35},
  [9624] = {.lex_state = 35},
  [9625] = {.lex_state = 35},
  [9626] = {.lex_state = 35},
  [9627] = {.lex_state = 1},
  [9628] = {.lex_state = 35},
  [9629] = {.lex_state = 0},
  [9630] = {.lex_state = 0},
  [9631] = {.lex_state = 35},
  [9632] = {.lex_state = 35},
  [9633] = {.lex_state = 35},
  [9634] = {.lex_state = 35},
  [9635] = {.lex_state = 35},
  [9636] = {.lex_state = 35},
  [9637] = {.lex_state = 35},
  [9638] = {.lex_state = 35},
  [9639] = {.lex_state = 35},
  [9640] = {.lex_state = 35},
  [9641] = {.lex_state = 35},
  [9642] = {.lex_state = 35},
  [9643] = {.lex_state = 35},
  [9644] = {.lex_state = 35},
  [9645] = {.lex_state = 35},
  [9646] = {.lex_state = 35},
  [9647] = {.lex_state = 35},
  [9648] = {.lex_state = 35},
  [9649] = {.lex_state = 0},
  [9650] = {.lex_state = 35},
  [9651] = {.lex_state = 35},
  [9652] = {.lex_state = 35},
  [9653] = {.lex_state = 35},
  [9654] = {.lex_state = 35},
  [9655] = {.lex_state = 35},
  [9656] = {.lex_state = 35},
  [9657] = {.lex_state = 35},
  [9658] = {.lex_state = 35, .external_lex_state = 2},
  [9659] = {.lex_state = 35},
  [9660] = {.lex_state = 35},
  [9661] = {.lex_state = 35},
  [9662] = {.lex_state = 35},
  [9663] = {.lex_state = 35},
  [9664] = {.lex_state = 35},
  [9665] = {.lex_state = 0},
  [9666] = {.lex_state = 35},
  [9667] = {.lex_state = 0},
  [9668] = {.lex_state = 35},
  [9669] = {.lex_state = 35, .external_lex_state = 2},
  [9670] = {.lex_state = 35},
  [9671] = {.lex_state = 35},
  [9672] = {.lex_state = 35},
  [9673] = {.lex_state = 0},
  [9674] = {.lex_state = 35},
  [9675] = {.lex_state = 35},
  [9676] = {.lex_state = 35},
  [9677] = {.lex_state = 35},
  [9678] = {.lex_state = 35},
  [9679] = {.lex_state = 35},
  [9680] = {.lex_state = 35},
  [9681] = {.lex_state = 35},
  [9682] = {.lex_state = 35},
  [9683] = {.lex_state = 35},
  [9684] = {.lex_state = 35},
  [9685] = {.lex_state = 35},
  [9686] = {.lex_state = 35},
  [9687] = {.lex_state = 0},
  [9688] = {.lex_state = 35},
  [9689] = {.lex_state = 35},
  [9690] = {.lex_state = 35, .external_lex_state = 2},
  [9691] = {.lex_state = 0},
  [9692] = {.lex_state = 0},
  [9693] = {.lex_state = 35},
  [9694] = {.lex_state = 0},
  [9695] = {.lex_state = 35},
  [9696] = {.lex_state = 35, .external_lex_state = 2},
  [9697] = {.lex_state = 35},
  [9698] = {.lex_state = 35},
  [9699] = {.lex_state = 35},
  [9700] = {.lex_state = 35},
  [9701] = {.lex_state = 35},
  [9702] = {.lex_state = 35},
  [9703] = {.lex_state = 35},
  [9704] = {.lex_state = 1},
  [9705] = {.lex_state = 0},
  [9706] = {.lex_state = 35},
  [9707] = {.lex_state = 35},
  [9708] = {.lex_state = 35},
  [9709] = {.lex_state = 35},
  [9710] = {.lex_state = 35},
  [9711] = {.lex_state = 35},
  [9712] = {.lex_state = 35, .external_lex_state = 2},
  [9713] = {.lex_state = 0},
  [9714] = {.lex_state = 35},
  [9715] = {.lex_state = 35},
  [9716] = {.lex_state = 35, .external_lex_state = 2},
  [9717] = {.lex_state = 35},
  [9718] = {.lex_state = 35},
  [9719] = {.lex_state = 35, .external_lex_state = 2},
  [9720] = {.lex_state = 35},
  [9721] = {.lex_state = 35},
  [9722] = {.lex_state = 35},
  [9723] = {.lex_state = 0},
  [9724] = {.lex_state = 35},
  [9725] = {.lex_state = 0},
  [9726] = {.lex_state = 35},
  [9727] = {.lex_state = 35},
  [9728] = {.lex_state = 35},
  [9729] = {.lex_state = 35},
  [9730] = {.lex_state = 35, .external_lex_state = 2},
  [9731] = {.lex_state = 35},
  [9732] = {.lex_state = 35, .external_lex_state = 2},
  [9733] = {.lex_state = 35},
  [9734] = {.lex_state = 35},
  [9735] = {.lex_state = 35},
  [9736] = {.lex_state = 35},
  [9737] = {.lex_state = 35},
  [9738] = {.lex_state = 0},
  [9739] = {.lex_state = 0},
  [9740] = {.lex_state = 35},
  [9741] = {.lex_state = 0},
  [9742] = {.lex_state = 0},
  [9743] = {.lex_state = 35},
  [9744] = {.lex_state = 0},
  [9745] = {.lex_state = 35},
  [9746] = {.lex_state = 35},
  [9747] = {.lex_state = 35, .external_lex_state = 2},
  [9748] = {.lex_state = 35},
  [9749] = {.lex_state = 0},
  [9750] = {.lex_state = 35},
  [9751] = {.lex_state = 0},
  [9752] = {.lex_state = 35},
  [9753] = {.lex_state = 35},
  [9754] = {.lex_state = 35},
  [9755] = {.lex_state = 35},
  [9756] = {.lex_state = 1},
  [9757] = {.lex_state = 35},
  [9758] = {.lex_state = 35},
  [9759] = {.lex_state = 35},
  [9760] = {.lex_state = 0},
  [9761] = {.lex_state = 35},
  [9762] = {.lex_state = 35},
  [9763] = {.lex_state = 35},
  [9764] = {.lex_state = 35},
  [9765] = {.lex_state = 35},
  [9766] = {.lex_state = 35},
  [9767] = {.lex_state = 35},
  [9768] = {.lex_state = 35},
  [9769] = {.lex_state = 35},
  [9770] = {.lex_state = 35},
  [9771] = {.lex_state = 35},
  [9772] = {.lex_state = 35},
  [9773] = {.lex_state = 35},
  [9774] = {.lex_state = 35},
  [9775] = {.lex_state = 35},
  [9776] = {.lex_state = 35},
  [9777] = {.lex_state = 35},
  [9778] = {.lex_state = 35},
  [9779] = {.lex_state = 35},
  [9780] = {.lex_state = 35},
  [9781] = {.lex_state = 35},
  [9782] = {.lex_state = 0},
  [9783] = {.lex_state = 35, .external_lex_state = 2},
  [9784] = {.lex_state = 35},
  [9785] = {.lex_state = 35, .external_lex_state = 2},
  [9786] = {.lex_state = 35},
  [9787] = {.lex_state = 35},
  [9788] = {.lex_state = 35},
  [9789] = {.lex_state = 35},
  [9790] = {.lex_state = 35},
  [9791] = {.lex_state = 35},
  [9792] = {.lex_state = 35},
  [9793] = {.lex_state = 0},
  [9794] = {.lex_state = 35, .external_lex_state = 2},
  [9795] = {.lex_state = 35, .external_lex_state = 2},
  [9796] = {.lex_state = 35},
  [9797] = {.lex_state = 35},
  [9798] = {.lex_state = 35},
  [9799] = {.lex_state = 35},
  [9800] = {.lex_state = 35},
  [9801] = {.lex_state = 35},
  [9802] = {.lex_state = 35},
  [9803] = {.lex_state = 35},
  [9804] = {.lex_state = 35},
  [9805] = {.lex_state = 35},
  [9806] = {.lex_state = 35, .external_lex_state = 2},
  [9807] = {.lex_state = 0, .external_lex_state = 2},
  [9808] = {.lex_state = 0},
  [9809] = {.lex_state = 0, .external_lex_state = 2},
  [9810] = {.lex_state = 35},
  [9811] = {.lex_state = 35},
  [9812] = {.lex_state = 35},
  [9813] = {.lex_state = 35},
  [9814] = {.lex_state = 35},
  [9815] = {.lex_state = 35},
  [9816] = {.lex_state = 35},
  [9817] = {.lex_state = 35},
  [9818] = {.lex_state = 35},
  [9819] = {.lex_state = 35},
  [9820] = {.lex_state = 0},
  [9821] = {.lex_state = 35},
  [9822] = {.lex_state = 35},
  [9823] = {.lex_state = 35, .external_lex_state = 2},
  [9824] = {.lex_state = 35},
  [9825] = {.lex_state = 35},
  [9826] = {.lex_state = 35},
  [9827] = {.lex_state = 35},
  [9828] = {.lex_state = 35, .external_lex_state = 2},
  [9829] = {.lex_state = 35, .external_lex_state = 2},
  [9830] = {.lex_state = 35},
  [9831] = {.lex_state = 35},
  [9832] = {.lex_state = 35, .external_lex_state = 2},
  [9833] = {.lex_state = 35},
  [9834] = {.lex_state = 35},
  [9835] = {.lex_state = 35},
  [9836] = {.lex_state = 35},
  [9837] = {.lex_state = 35},
  [9838] = {.lex_state = 35},
  [9839] = {.lex_state = 35},
  [9840] = {.lex_state = 35},
  [9841] = {.lex_state = 0},
  [9842] = {.lex_state = 1},
  [9843] = {.lex_state = 35},
  [9844] = {.lex_state = 35},
  [9845] = {.lex_state = 35},
  [9846] = {.lex_state = 0},
  [9847] = {.lex_state = 0},
  [9848] = {.lex_state = 0},
  [9849] = {.lex_state = 35},
  [9850] = {.lex_state = 35, .external_lex_state = 2},
  [9851] = {.lex_state = 35},
  [9852] = {.lex_state = 35},
  [9853] = {.lex_state = 35},
  [9854] = {.lex_state = 35},
  [9855] = {.lex_state = 35, .external_lex_state = 2},
  [9856] = {.lex_state = 35},
  [9857] = {.lex_state = 35},
  [9858] = {.lex_state = 35},
  [9859] = {.lex_state = 35},
  [9860] = {.lex_state = 35},
  [9861] = {.lex_state = 0, .external_lex_state = 2},
  [9862] = {.lex_state = 35},
  [9863] = {.lex_state = 0},
  [9864] = {.lex_state = 35},
  [9865] = {.lex_state = 35},
  [9866] = {.lex_state = 0, .external_lex_state = 5},
  [9867] = {.lex_state = 35},
  [9868] = {.lex_state = 35},
  [9869] = {.lex_state = 35},
  [9870] = {.lex_state = 35},
  [9871] = {.lex_state = 0},
  [9872] = {.lex_state = 35},
  [9873] = {.lex_state = 35},
  [9874] = {.lex_state = 35, .external_lex_state = 2},
  [9875] = {.lex_state = 35},
  [9876] = {.lex_state = 35},
  [9877] = {.lex_state = 35},
  [9878] = {.lex_state = 35},
  [9879] = {.lex_state = 35},
  [9880] = {.lex_state = 35},
  [9881] = {.lex_state = 35},
  [9882] = {.lex_state = 35},
  [9883] = {.lex_state = 35},
  [9884] = {.lex_state = 35},
  [9885] = {.lex_state = 35},
  [9886] = {.lex_state = 35},
  [9887] = {.lex_state = 35},
  [9888] = {.lex_state = 35},
  [9889] = {.lex_state = 35},
  [9890] = {.lex_state = 35},
  [9891] = {.lex_state = 35},
  [9892] = {.lex_state = 35},
  [9893] = {.lex_state = 35},
  [9894] = {.lex_state = 0, .external_lex_state = 2},
  [9895] = {.lex_state = 35},
  [9896] = {.lex_state = 35},
  [9897] = {.lex_state = 35},
  [9898] = {.lex_state = 35},
  [9899] = {.lex_state = 35},
  [9900] = {.lex_state = 35},
  [9901] = {.lex_state = 35},
  [9902] = {.lex_state = 35},
  [9903] = {.lex_state = 35},
  [9904] = {.lex_state = 35},
  [9905] = {.lex_state = 35},
  [9906] = {.lex_state = 35},
  [9907] = {.lex_state = 35},
  [9908] = {.lex_state = 35},
  [9909] = {.lex_state = 35},
  [9910] = {.lex_state = 35},
  [9911] = {.lex_state = 0},
  [9912] = {.lex_state = 35},
  [9913] = {.lex_state = 1},
  [9914] = {.lex_state = 35},
  [9915] = {.lex_state = 35},
  [9916] = {.lex_state = 35},
  [9917] = {.lex_state = 33},
  [9918] = {.lex_state = 0},
  [9919] = {.lex_state = 35},
  [9920] = {.lex_state = 35},
  [9921] = {.lex_state = 0},
  [9922] = {.lex_state = 35},
  [9923] = {.lex_state = 35},
  [9924] = {.lex_state = 35},
  [9925] = {.lex_state = 35},
  [9926] = {.lex_state = 35},
  [9927] = {.lex_state = 35},
  [9928] = {.lex_state = 35, .external_lex_state = 2},
  [9929] = {.lex_state = 1},
  [9930] = {.lex_state = 1},
  [9931] = {.lex_state = 35},
  [9932] = {.lex_state = 35},
  [9933] = {.lex_state = 35},
  [9934] = {.lex_state = 0},
  [9935] = {.lex_state = 35},
  [9936] = {.lex_state = 35},
  [9937] = {.lex_state = 35},
  [9938] = {.lex_state = 35},
  [9939] = {.lex_state = 35},
  [9940] = {.lex_state = 35},
  [9941] = {.lex_state = 35, .external_lex_state = 2},
  [9942] = {.lex_state = 35, .external_lex_state = 2},
  [9943] = {.lex_state = 0},
  [9944] = {.lex_state = 0},
  [9945] = {.lex_state = 35, .external_lex_state = 2},
  [9946] = {.lex_state = 35},
  [9947] = {.lex_state = 35},
  [9948] = {.lex_state = 35},
  [9949] = {.lex_state = 35},
  [9950] = {.lex_state = 35},
  [9951] = {.lex_state = 35},
  [9952] = {.lex_state = 35},
  [9953] = {.lex_state = 0, .external_lex_state = 2},
  [9954] = {.lex_state = 35},
  [9955] = {.lex_state = 0},
  [9956] = {.lex_state = 35},
  [9957] = {.lex_state = 35},
  [9958] = {.lex_state = 0, .external_lex_state = 2},
  [9959] = {.lex_state = 0, .external_lex_state = 2},
  [9960] = {.lex_state = 0, .external_lex_state = 2},
  [9961] = {.lex_state = 0},
  [9962] = {.lex_state = 0, .external_lex_state = 2},
  [9963] = {.lex_state = 35},
  [9964] = {.lex_state = 35},
  [9965] = {.lex_state = 0},
  [9966] = {.lex_state = 0},
  [9967] = {.lex_state = 35},
  [9968] = {.lex_state = 35, .external_lex_state = 2},
  [9969] = {.lex_state = 35},
  [9970] = {.lex_state = 35},
  [9971] = {.lex_state = 0},
  [9972] = {.lex_state = 35},
  [9973] = {.lex_state = 35, .external_lex_state = 2},
  [9974] = {.lex_state = 35},
  [9975] = {.lex_state = 35},
  [9976] = {.lex_state = 0},
  [9977] = {.lex_state = 35, .external_lex_state = 2},
  [9978] = {.lex_state = 35, .external_lex_state = 2},
  [9979] = {.lex_state = 35},
  [9980] = {.lex_state = 0},
  [9981] = {.lex_state = 0},
  [9982] = {.lex_state = 35},
  [9983] = {.lex_state = 35},
  [9984] = {.lex_state = 0},
  [9985] = {.lex_state = 35},
  [9986] = {.lex_state = 0, .external_lex_state = 2},
  [9987] = {.lex_state = 35},
  [9988] = {.lex_state = 35},
  [9989] = {.lex_state = 35},
  [9990] = {.lex_state = 0},
  [9991] = {.lex_state = 1},
  [9992] = {.lex_state = 35},
  [9993] = {.lex_state = 35},
  [9994] = {.lex_state = 35},
  [9995] = {.lex_state = 35},
  [9996] = {.lex_state = 35},
  [9997] = {.lex_state = 35},
  [9998] = {.lex_state = 35},
  [9999] = {.lex_state = 35},
  [10000] = {.lex_state = 1},
  [10001] = {.lex_state = 35},
  [10002] = {.lex_state = 35},
  [10003] = {.lex_state = 35},
  [10004] = {.lex_state = 35},
  [10005] = {.lex_state = 35},
  [10006] = {.lex_state = 35},
  [10007] = {.lex_state = 35},
  [10008] = {.lex_state = 35},
  [10009] = {.lex_state = 35},
  [10010] = {.lex_state = 35},
  [10011] = {.lex_state = 35},
  [10012] = {.lex_state = 35, .external_lex_state = 2},
  [10013] = {.lex_state = 35, .external_lex_state = 2},
  [10014] = {.lex_state = 35},
  [10015] = {.lex_state = 1},
  [10016] = {.lex_state = 35, .external_lex_state = 2},
  [10017] = {.lex_state = 35},
  [10018] = {.lex_state = 35},
  [10019] = {.lex_state = 35},
  [10020] = {.lex_state = 35},
  [10021] = {.lex_state = 0},
  [10022] = {.lex_state = 35},
  [10023] = {.lex_state = 35},
  [10024] = {.lex_state = 35},
  [10025] = {.lex_state = 35, .external_lex_state = 2},
  [10026] = {.lex_state = 35},
  [10027] = {.lex_state = 35},
  [10028] = {.lex_state = 35},
  [10029] = {.lex_state = 35},
  [10030] = {.lex_state = 0, .external_lex_state = 2},
  [10031] = {.lex_state = 35},
  [10032] = {.lex_state = 35},
  [10033] = {.lex_state = 35},
  [10034] = {.lex_state = 35},
  [10035] = {.lex_state = 35},
  [10036] = {.lex_state = 35},
  [10037] = {.lex_state = 1},
  [10038] = {.lex_state = 35},
  [10039] = {.lex_state = 35, .external_lex_state = 2},
  [10040] = {.lex_state = 35, .external_lex_state = 2},
  [10041] = {.lex_state = 35, .external_lex_state = 2},
  [10042] = {.lex_state = 35},
  [10043] = {.lex_state = 35},
  [10044] = {.lex_state = 35},
  [10045] = {.lex_state = 0},
  [10046] = {.lex_state = 35},
  [10047] = {.lex_state = 35},
  [10048] = {.lex_state = 35},
  [10049] = {.lex_state = 35},
  [10050] = {.lex_state = 35},
  [10051] = {.lex_state = 35},
  [10052] = {.lex_state = 0},
  [10053] = {.lex_state = 35},
  [10054] = {.lex_state = 35, .external_lex_state = 2},
  [10055] = {.lex_state = 35},
  [10056] = {.lex_state = 35, .external_lex_state = 2},
  [10057] = {.lex_state = 35, .external_lex_state = 2},
  [10058] = {.lex_state = 35},
  [10059] = {.lex_state = 35},
  [10060] = {.lex_state = 35},
  [10061] = {.lex_state = 35},
  [10062] = {.lex_state = 35},
  [10063] = {.lex_state = 35},
  [10064] = {.lex_state = 35},
  [10065] = {.lex_state = 35},
  [10066] = {.lex_state = 35},
  [10067] = {.lex_state = 35},
  [10068] = {.lex_state = 35},
  [10069] = {.lex_state = 35, .external_lex_state = 2},
  [10070] = {.lex_state = 1},
  [10071] = {.lex_state = 0, .external_lex_state = 2},
  [10072] = {.lex_state = 35},
  [10073] = {.lex_state = 35},
  [10074] = {.lex_state = 35},
  [10075] = {.lex_state = 1},
  [10076] = {.lex_state = 35},
  [10077] = {.lex_state = 35},
  [10078] = {.lex_state = 35},
  [10079] = {.lex_state = 35},
  [10080] = {.lex_state = 35},
  [10081] = {.lex_state = 35, .external_lex_state = 2},
  [10082] = {.lex_state = 35},
  [10083] = {.lex_state = 35},
  [10084] = {.lex_state = 1},
  [10085] = {.lex_state = 35},
  [10086] = {.lex_state = 35},
  [10087] = {.lex_state = 35},
  [10088] = {.lex_state = 1},
  [10089] = {.lex_state = 0, .external_lex_state = 2},
  [10090] = {.lex_state = 35},
  [10091] = {.lex_state = 35},
  [10092] = {.lex_state = 0, .external_lex_state = 2},
  [10093] = {.lex_state = 35},
  [10094] = {.lex_state = 35},
  [10095] = {.lex_state = 35},
  [10096] = {.lex_state = 35},
  [10097] = {.lex_state = 35},
  [10098] = {.lex_state = 0, .external_lex_state = 2},
  [10099] = {.lex_state = 35},
  [10100] = {.lex_state = 35},
  [10101] = {.lex_state = 1},
  [10102] = {.lex_state = 35},
  [10103] = {.lex_state = 35},
  [10104] = {.lex_state = 35},
  [10105] = {.lex_state = 35},
  [10106] = {.lex_state = 35},
  [10107] = {.lex_state = 35},
  [10108] = {.lex_state = 33},
  [10109] = {.lex_state = 35},
  [10110] = {.lex_state = 0, .external_lex_state = 2},
  [10111] = {.lex_state = 35},
  [10112] = {.lex_state = 1},
  [10113] = {.lex_state = 35},
  [10114] = {.lex_state = 35},
  [10115] = {.lex_state = 35},
  [10116] = {.lex_state = 35},
  [10117] = {.lex_state = 35},
  [10118] = {.lex_state = 35},
  [10119] = {.lex_state = 35, .external_lex_state = 2},
  [10120] = {.lex_state = 35},
  [10121] = {.lex_state = 0},
  [10122] = {.lex_state = 35, .external_lex_state = 2},
  [10123] = {.lex_state = 35},
  [10124] = {.lex_state = 35},
  [10125] = {.lex_state = 35},
  [10126] = {.lex_state = 35},
  [10127] = {.lex_state = 35, .external_lex_state = 2},
  [10128] = {.lex_state = 35},
  [10129] = {.lex_state = 35},
  [10130] = {.lex_state = 35},
  [10131] = {.lex_state = 35},
  [10132] = {.lex_state = 1},
  [10133] = {.lex_state = 35},
  [10134] = {.lex_state = 35},
  [10135] = {.lex_state = 35},
  [10136] = {.lex_state = 35},
  [10137] = {.lex_state = 35},
  [10138] = {.lex_state = 0, .external_lex_state = 2},
  [10139] = {.lex_state = 35},
  [10140] = {.lex_state = 35},
  [10141] = {.lex_state = 0, .external_lex_state = 2},
  [10142] = {.lex_state = 35},
  [10143] = {.lex_state = 35},
  [10144] = {.lex_state = 0, .external_lex_state = 5},
  [10145] = {.lex_state = 35, .external_lex_state = 2},
  [10146] = {.lex_state = 35},
  [10147] = {.lex_state = 35, .external_lex_state = 2},
  [10148] = {.lex_state = 35},
  [10149] = {.lex_state = 35},
  [10150] = {.lex_state = 35},
  [10151] = {.lex_state = 35},
  [10152] = {.lex_state = 35},
  [10153] = {.lex_state = 0, .external_lex_state = 2},
  [10154] = {.lex_state = 1},
  [10155] = {.lex_state = 0, .external_lex_state = 2},
  [10156] = {.lex_state = 1},
  [10157] = {.lex_state = 35},
  [10158] = {.lex_state = 35},
  [10159] = {.lex_state = 0},
  [10160] = {.lex_state = 35},
  [10161] = {.lex_state = 35},
  [10162] = {.lex_state = 35, .external_lex_state = 2},
  [10163] = {.lex_state = 35, .external_lex_state = 2},
  [10164] = {.lex_state = 35},
  [10165] = {.lex_state = 35},
  [10166] = {.lex_state = 35, .external_lex_state = 2},
  [10167] = {.lex_state = 0},
  [10168] = {.lex_state = 35, .external_lex_state = 2},
  [10169] = {.lex_state = 35, .external_lex_state = 2},
  [10170] = {.lex_state = 35},
  [10171] = {.lex_state = 35, .external_lex_state = 2},
  [10172] = {.lex_state = 35},
  [10173] = {.lex_state = 35, .external_lex_state = 2},
  [10174] = {.lex_state = 0},
  [10175] = {.lex_state = 35},
  [10176] = {.lex_state = 35},
  [10177] = {.lex_state = 35},
  [10178] = {.lex_state = 35, .external_lex_state = 2},
  [10179] = {.lex_state = 35},
  [10180] = {.lex_state = 0, .external_lex_state = 2},
  [10181] = {.lex_state = 0},
  [10182] = {.lex_state = 35},
  [10183] = {.lex_state = 35},
  [10184] = {.lex_state = 35},
  [10185] = {.lex_state = 0, .external_lex_state = 2},
  [10186] = {.lex_state = 35, .external_lex_state = 2},
  [10187] = {.lex_state = 35, .external_lex_state = 2},
  [10188] = {.lex_state = 35},
  [10189] = {.lex_state = 35},
  [10190] = {.lex_state = 35},
  [10191] = {.lex_state = 35},
  [10192] = {.lex_state = 35},
  [10193] = {.lex_state = 35, .external_lex_state = 2},
  [10194] = {.lex_state = 35},
  [10195] = {.lex_state = 35},
  [10196] = {.lex_state = 35},
  [10197] = {.lex_state = 35},
  [10198] = {.lex_state = 35},
  [10199] = {.lex_state = 35, .external_lex_state = 2},
  [10200] = {.lex_state = 35},
  [10201] = {.lex_state = 35},
  [10202] = {.lex_state = 35},
  [10203] = {.lex_state = 35},
  [10204] = {.lex_state = 0},
  [10205] = {.lex_state = 35, .external_lex_state = 2},
  [10206] = {.lex_state = 35},
  [10207] = {.lex_state = 35, .external_lex_state = 2},
  [10208] = {.lex_state = 35},
  [10209] = {.lex_state = 35, .external_lex_state = 2},
  [10210] = {.lex_state = 35},
  [10211] = {.lex_state = 0, .external_lex_state = 2},
  [10212] = {.lex_state = 0, .external_lex_state = 2},
  [10213] = {.lex_state = 35},
  [10214] = {.lex_state = 35},
  [10215] = {.lex_state = 35},
  [10216] = {.lex_state = 35},
  [10217] = {.lex_state = 35},
  [10218] = {.lex_state = 35},
  [10219] = {.lex_state = 0, .external_lex_state = 2},
  [10220] = {.lex_state = 35},
  [10221] = {.lex_state = 35},
  [10222] = {.lex_state = 35},
  [10223] = {.lex_state = 35},
  [10224] = {.lex_state = 35, .external_lex_state = 2},
  [10225] = {.lex_state = 0},
  [10226] = {.lex_state = 0, .external_lex_state = 2},
  [10227] = {.lex_state = 35},
  [10228] = {.lex_state = 35},
  [10229] = {.lex_state = 0},
  [10230] = {.lex_state = 0, .external_lex_state = 2},
  [10231] = {.lex_state = 0, .external_lex_state = 2},
  [10232] = {.lex_state = 0, .external_lex_state = 2},
  [10233] = {.lex_state = 0, .external_lex_state = 2},
  [10234] = {.lex_state = 0, .external_lex_state = 2},
  [10235] = {.lex_state = 0, .external_lex_state = 2},
  [10236] = {.lex_state = 35, .external_lex_state = 2},
  [10237] = {.lex_state = 0, .external_lex_state = 2},
  [10238] = {.lex_state = 0, .external_lex_state = 2},
  [10239] = {.lex_state = 35},
  [10240] = {.lex_state = 35},
  [10241] = {.lex_state = 35},
  [10242] = {.lex_state = 35},
  [10243] = {.lex_state = 0},
  [10244] = {.lex_state = 0},
  [10245] = {.lex_state = 0, .external_lex_state = 2},
  [10246] = {.lex_state = 0},
  [10247] = {.lex_state = 35},
  [10248] = {.lex_state = 0},
  [10249] = {.lex_state = 35},
  [10250] = {.lex_state = 0, .external_lex_state = 2},
  [10251] = {.lex_state = 0},
  [10252] = {.lex_state = 0},
  [10253] = {.lex_state = 35},
  [10254] = {.lex_state = 0},
  [10255] = {.lex_state = 0},
  [10256] = {.lex_state = 35, .external_lex_state = 2},
  [10257] = {.lex_state = 0},
  [10258] = {.lex_state = 0, .external_lex_state = 2},
  [10259] = {.lex_state = 0},
  [10260] = {.lex_state = 0},
  [10261] = {.lex_state = 0},
  [10262] = {.lex_state = 0},
  [10263] = {.lex_state = 0},
  [10264] = {.lex_state = 0},
  [10265] = {.lex_state = 0},
  [10266] = {.lex_state = 35},
  [10267] = {.lex_state = 35},
  [10268] = {.lex_state = 0},
  [10269] = {.lex_state = 0},
  [10270] = {.lex_state = 0},
  [10271] = {.lex_state = 35},
  [10272] = {.lex_state = 35},
  [10273] = {.lex_state = 0},
  [10274] = {.lex_state = 0},
  [10275] = {.lex_state = 35},
  [10276] = {.lex_state = 35, .external_lex_state = 2},
  [10277] = {.lex_state = 35},
  [10278] = {.lex_state = 0},
  [10279] = {.lex_state = 35},
  [10280] = {.lex_state = 35, .external_lex_state = 2},
  [10281] = {.lex_state = 0},
  [10282] = {.lex_state = 35},
  [10283] = {.lex_state = 0},
  [10284] = {.lex_state = 0},
  [10285] = {.lex_state = 0},
  [10286] = {.lex_state = 0},
  [10287] = {.lex_state = 35, .external_lex_state = 2},
  [10288] = {.lex_state = 0},
  [10289] = {.lex_state = 35},
  [10290] = {.lex_state = 35},
  [10291] = {.lex_state = 0},
  [10292] = {.lex_state = 35},
  [10293] = {.lex_state = 35},
  [10294] = {.lex_state = 35},
  [10295] = {.lex_state = 0},
  [10296] = {.lex_state = 0},
  [10297] = {.lex_state = 0},
  [10298] = {.lex_state = 0},
  [10299] = {.lex_state = 0},
  [10300] = {.lex_state = 0},
  [10301] = {.lex_state = 35},
  [10302] = {.lex_state = 0},
  [10303] = {.lex_state = 0},
  [10304] = {.lex_state = 35, .external_lex_state = 2},
  [10305] = {.lex_state = 35, .external_lex_state = 2},
  [10306] = {.lex_state = 0},
  [10307] = {.lex_state = 0},
  [10308] = {.lex_state = 0},
  [10309] = {.lex_state = 35, .external_lex_state = 2},
  [10310] = {.lex_state = 35, .external_lex_state = 2},
  [10311] = {.lex_state = 35},
  [10312] = {.lex_state = 0},
  [10313] = {.lex_state = 0},
  [10314] = {.lex_state = 0},
  [10315] = {.lex_state = 35},
  [10316] = {.lex_state = 35},
  [10317] = {.lex_state = 0},
  [10318] = {.lex_state = 35, .external_lex_state = 2},
  [10319] = {.lex_state = 35},
  [10320] = {.lex_state = 35, .external_lex_state = 2},
  [10321] = {.lex_state = 35},
  [10322] = {.lex_state = 35, .external_lex_state = 2},
  [10323] = {.lex_state = 0},
  [10324] = {.lex_state = 0},
  [10325] = {.lex_state = 0},
  [10326] = {.lex_state = 35, .external_lex_state = 2},
  [10327] = {.lex_state = 35},
  [10328] = {.lex_state = 35},
  [10329] = {.lex_state = 0},
  [10330] = {.lex_state = 35, .external_lex_state = 2},
  [10331] = {.lex_state = 35},
  [10332] = {.lex_state = 35},
  [10333] = {.lex_state = 0},
  [10334] = {.lex_state = 35},
  [10335] = {.lex_state = 35, .external_lex_state = 2},
  [10336] = {.lex_state = 35, .external_lex_state = 2},
  [10337] = {.lex_state = 0},
  [10338] = {.lex_state = 0},
  [10339] = {.lex_state = 35, .external_lex_state = 2},
  [10340] = {.lex_state = 35, .external_lex_state = 2},
  [10341] = {.lex_state = 35},
  [10342] = {.lex_state = 35},
  [10343] = {.lex_state = 0},
  [10344] = {.lex_state = 0},
  [10345] = {.lex_state = 0},
  [10346] = {.lex_state = 35, .external_lex_state = 2},
  [10347] = {.lex_state = 35, .external_lex_state = 2},
  [10348] = {.lex_state = 35, .external_lex_state = 2},
  [10349] = {.lex_state = 35, .external_lex_state = 2},
  [10350] = {.lex_state = 35},
  [10351] = {.lex_state = 0},
  [10352] = {.lex_state = 35},
  [10353] = {.lex_state = 0},
  [10354] = {.lex_state = 35},
  [10355] = {.lex_state = 35},
  [10356] = {.lex_state = 35},
  [10357] = {.lex_state = 0},
  [10358] = {.lex_state = 0},
  [10359] = {.lex_state = 0},
  [10360] = {.lex_state = 0, .external_lex_state = 2},
  [10361] = {.lex_state = 0, .external_lex_state = 2},
  [10362] = {.lex_state = 0, .external_lex_state = 2},
  [10363] = {.lex_state = 35, .external_lex_state = 2},
  [10364] = {.lex_state = 0},
  [10365] = {.lex_state = 0, .external_lex_state = 2},
  [10366] = {.lex_state = 0},
  [10367] = {.lex_state = 0},
  [10368] = {.lex_state = 35},
  [10369] = {.lex_state = 0},
  [10370] = {.lex_state = 0},
  [10371] = {.lex_state = 0},
  [10372] = {.lex_state = 0, .external_lex_state = 2},
  [10373] = {.lex_state = 0, .external_lex_state = 2},
  [10374] = {.lex_state = 0, .external_lex_state = 2},
  [10375] = {.lex_state = 0},
  [10376] = {.lex_state = 35},
  [10377] = {.lex_state = 35},
  [10378] = {.lex_state = 0},
  [10379] = {.lex_state = 0},
  [10380] = {.lex_state = 0, .external_lex_state = 2},
  [10381] = {.lex_state = 0},
  [10382] = {.lex_state = 0, .external_lex_state = 2},
  [10383] = {.lex_state = 0},
  [10384] = {.lex_state = 35},
  [10385] = {.lex_state = 35},
  [10386] = {.lex_state = 35},
  [10387] = {.lex_state = 35},
  [10388] = {.lex_state = 0},
  [10389] = {.lex_state = 0},
  [10390] = {.lex_state = 35},
  [10391] = {.lex_state = 35},
  [10392] = {.lex_state = 0},
  [10393] = {.lex_state = 35},
  [10394] = {.lex_state = 0},
  [10395] = {.lex_state = 35},
  [10396] = {.lex_state = 0},
  [10397] = {.lex_state = 0},
  [10398] = {.lex_state = 0},
  [10399] = {.lex_state = 35},
  [10400] = {.lex_state = 0},
  [10401] = {.lex_state = 0},
  [10402] = {.lex_state = 35},
  [10403] = {.lex_state = 0},
  [10404] = {.lex_state = 0},
  [10405] = {.lex_state = 35, .external_lex_state = 2},
  [10406] = {.lex_state = 0},
  [10407] = {.lex_state = 35},
  [10408] = {.lex_state = 35},
  [10409] = {.lex_state = 0},
  [10410] = {.lex_state = 0},
  [10411] = {.lex_state = 0},
  [10412] = {.lex_state = 35},
  [10413] = {.lex_state = 0},
  [10414] = {.lex_state = 35},
  [10415] = {.lex_state = 35},
  [10416] = {.lex_state = 35},
  [10417] = {.lex_state = 0},
  [10418] = {.lex_state = 0},
  [10419] = {.lex_state = 35},
  [10420] = {.lex_state = 0},
  [10421] = {.lex_state = 0, .external_lex_state = 2},
  [10422] = {.lex_state = 35},
  [10423] = {.lex_state = 0, .external_lex_state = 2},
  [10424] = {.lex_state = 35},
  [10425] = {.lex_state = 0},
  [10426] = {.lex_state = 0},
  [10427] = {.lex_state = 0},
  [10428] = {.lex_state = 0, .external_lex_state = 2},
  [10429] = {.lex_state = 35},
  [10430] = {.lex_state = 0},
  [10431] = {.lex_state = 35},
  [10432] = {.lex_state = 0},
  [10433] = {.lex_state = 0},
  [10434] = {.lex_state = 0},
  [10435] = {.lex_state = 0},
  [10436] = {.lex_state = 35, .external_lex_state = 2},
  [10437] = {.lex_state = 0},
  [10438] = {.lex_state = 0},
  [10439] = {.lex_state = 0},
  [10440] = {.lex_state = 35},
  [10441] = {.lex_state = 35},
  [10442] = {.lex_state = 0},
  [10443] = {.lex_state = 35, .external_lex_state = 2},
  [10444] = {.lex_state = 0},
  [10445] = {.lex_state = 35},
  [10446] = {.lex_state = 0},
  [10447] = {.lex_state = 35},
  [10448] = {.lex_state = 0},
  [10449] = {.lex_state = 35},
  [10450] = {.lex_state = 0},
  [10451] = {.lex_state = 35, .external_lex_state = 2},
  [10452] = {.lex_state = 35, .external_lex_state = 2},
  [10453] = {.lex_state = 35},
  [10454] = {.lex_state = 0, .external_lex_state = 2},
  [10455] = {.lex_state = 35},
  [10456] = {.lex_state = 0},
  [10457] = {.lex_state = 0},
  [10458] = {.lex_state = 35},
  [10459] = {.lex_state = 0},
  [10460] = {.lex_state = 0},
  [10461] = {.lex_state = 0},
  [10462] = {.lex_state = 0},
  [10463] = {.lex_state = 0},
  [10464] = {.lex_state = 35},
  [10465] = {.lex_state = 0},
  [10466] = {.lex_state = 0},
  [10467] = {.lex_state = 35, .external_lex_state = 2},
  [10468] = {.lex_state = 0},
  [10469] = {.lex_state = 35},
  [10470] = {.lex_state = 35, .external_lex_state = 2},
  [10471] = {.lex_state = 0},
  [10472] = {.lex_state = 0},
  [10473] = {.lex_state = 0},
  [10474] = {.lex_state = 0},
  [10475] = {.lex_state = 0},
  [10476] = {.lex_state = 0},
  [10477] = {.lex_state = 0},
  [10478] = {.lex_state = 35, .external_lex_state = 2},
  [10479] = {.lex_state = 0},
  [10480] = {.lex_state = 0},
  [10481] = {.lex_state = 0},
  [10482] = {.lex_state = 35},
  [10483] = {.lex_state = 0},
  [10484] = {.lex_state = 0},
  [10485] = {.lex_state = 35},
  [10486] = {.lex_state = 0},
  [10487] = {.lex_state = 35, .external_lex_state = 2},
  [10488] = {.lex_state = 35},
  [10489] = {.lex_state = 35},
  [10490] = {.lex_state = 35, .external_lex_state = 2},
  [10491] = {.lex_state = 0},
  [10492] = {.lex_state = 0},
  [10493] = {.lex_state = 0},
  [10494] = {.lex_state = 35, .external_lex_state = 2},
  [10495] = {.lex_state = 35},
  [10496] = {.lex_state = 0},
  [10497] = {.lex_state = 35, .external_lex_state = 2},
  [10498] = {.lex_state = 0},
  [10499] = {.lex_state = 35},
  [10500] = {.lex_state = 0},
  [10501] = {.lex_state = 0},
  [10502] = {.lex_state = 35},
  [10503] = {.lex_state = 35, .external_lex_state = 2},
  [10504] = {.lex_state = 0},
  [10505] = {.lex_state = 35, .external_lex_state = 2},
  [10506] = {.lex_state = 35},
  [10507] = {.lex_state = 0},
  [10508] = {.lex_state = 35},
  [10509] = {.lex_state = 0},
  [10510] = {.lex_state = 0},
  [10511] = {.lex_state = 35, .external_lex_state = 2},
  [10512] = {.lex_state = 0},
  [10513] = {.lex_state = 0},
  [10514] = {.lex_state = 0},
  [10515] = {.lex_state = 0},
  [10516] = {.lex_state = 35, .external_lex_state = 2},
  [10517] = {.lex_state = 0},
  [10518] = {.lex_state = 0, .external_lex_state = 2},
  [10519] = {.lex_state = 0, .external_lex_state = 2},
  [10520] = {.lex_state = 35, .external_lex_state = 2},
  [10521] = {.lex_state = 0},
  [10522] = {.lex_state = 0},
  [10523] = {.lex_state = 0},
  [10524] = {.lex_state = 0, .external_lex_state = 2},
  [10525] = {.lex_state = 0, .external_lex_state = 2},
  [10526] = {.lex_state = 35},
  [10527] = {.lex_state = 0},
  [10528] = {.lex_state = 35},
  [10529] = {.lex_state = 35},
  [10530] = {.lex_state = 0},
  [10531] = {.lex_state = 0},
  [10532] = {.lex_state = 0},
  [10533] = {.lex_state = 0, .external_lex_state = 2},
  [10534] = {.lex_state = 0},
  [10535] = {.lex_state = 0},
  [10536] = {.lex_state = 0, .external_lex_state = 2},
  [10537] = {.lex_state = 35},
  [10538] = {.lex_state = 0},
  [10539] = {.lex_state = 0},
  [10540] = {.lex_state = 0},
  [10541] = {.lex_state = 0, .external_lex_state = 2},
  [10542] = {.lex_state = 35},
  [10543] = {.lex_state = 0},
  [10544] = {.lex_state = 35},
  [10545] = {.lex_state = 0},
  [10546] = {.lex_state = 0},
  [10547] = {.lex_state = 0},
  [10548] = {.lex_state = 0},
  [10549] = {.lex_state = 0},
  [10550] = {.lex_state = 0},
  [10551] = {.lex_state = 0},
  [10552] = {.lex_state = 0},
  [10553] = {.lex_state = 0, .external_lex_state = 2},
  [10554] = {.lex_state = 35},
  [10555] = {.lex_state = 35, .external_lex_state = 2},
  [10556] = {.lex_state = 35},
  [10557] = {.lex_state = 35},
  [10558] = {.lex_state = 0, .external_lex_state = 2},
  [10559] = {.lex_state = 0},
  [10560] = {.lex_state = 35},
  [10561] = {.lex_state = 35},
  [10562] = {.lex_state = 35},
  [10563] = {.lex_state = 0},
  [10564] = {.lex_state = 35},
  [10565] = {.lex_state = 35},
  [10566] = {.lex_state = 0},
  [10567] = {.lex_state = 35},
  [10568] = {.lex_state = 35},
  [10569] = {.lex_state = 35},
  [10570] = {.lex_state = 0},
  [10571] = {.lex_state = 0},
  [10572] = {.lex_state = 0},
  [10573] = {.lex_state = 0},
  [10574] = {.lex_state = 35},
  [10575] = {.lex_state = 0},
  [10576] = {.lex_state = 0},
  [10577] = {.lex_state = 35},
  [10578] = {.lex_state = 0},
  [10579] = {.lex_state = 0},
  [10580] = {.lex_state = 35},
  [10581] = {.lex_state = 35},
  [10582] = {.lex_state = 35},
  [10583] = {.lex_state = 35},
  [10584] = {.lex_state = 35},
  [10585] = {.lex_state = 35, .external_lex_state = 2},
  [10586] = {.lex_state = 0},
  [10587] = {.lex_state = 0},
  [10588] = {.lex_state = 35, .external_lex_state = 2},
  [10589] = {.lex_state = 35},
  [10590] = {.lex_state = 0},
  [10591] = {.lex_state = 35},
  [10592] = {.lex_state = 0},
  [10593] = {.lex_state = 0},
  [10594] = {.lex_state = 0},
  [10595] = {.lex_state = 35},
  [10596] = {.lex_state = 35},
  [10597] = {.lex_state = 0},
  [10598] = {.lex_state = 0},
  [10599] = {.lex_state = 35},
  [10600] = {.lex_state = 35},
  [10601] = {.lex_state = 35},
  [10602] = {.lex_state = 35},
  [10603] = {.lex_state = 0},
  [10604] = {.lex_state = 0},
  [10605] = {.lex_state = 0},
  [10606] = {.lex_state = 0},
  [10607] = {.lex_state = 0, .external_lex_state = 2},
  [10608] = {.lex_state = 0},
  [10609] = {.lex_state = 0},
  [10610] = {.lex_state = 35},
  [10611] = {.lex_state = 0},
  [10612] = {.lex_state = 0},
  [10613] = {.lex_state = 35, .external_lex_state = 2},
  [10614] = {.lex_state = 0},
  [10615] = {.lex_state = 0},
  [10616] = {.lex_state = 35, .external_lex_state = 2},
  [10617] = {.lex_state = 0},
  [10618] = {.lex_state = 0},
  [10619] = {.lex_state = 35, .external_lex_state = 2},
  [10620] = {.lex_state = 0},
  [10621] = {.lex_state = 35},
  [10622] = {.lex_state = 35},
  [10623] = {.lex_state = 0},
  [10624] = {.lex_state = 0},
  [10625] = {.lex_state = 0},
  [10626] = {.lex_state = 35},
  [10627] = {.lex_state = 0},
  [10628] = {.lex_state = 35},
  [10629] = {.lex_state = 0},
  [10630] = {.lex_state = 0},
  [10631] = {.lex_state = 0},
  [10632] = {.lex_state = 35},
  [10633] = {.lex_state = 0},
  [10634] = {.lex_state = 35, .external_lex_state = 2},
  [10635] = {.lex_state = 35, .external_lex_state = 2},
  [10636] = {.lex_state = 0},
  [10637] = {.lex_state = 35, .external_lex_state = 2},
  [10638] = {.lex_state = 0},
  [10639] = {.lex_state = 35},
  [10640] = {.lex_state = 0},
  [10641] = {.lex_state = 0},
  [10642] = {.lex_state = 35},
  [10643] = {.lex_state = 0},
  [10644] = {.lex_state = 35, .external_lex_state = 2},
  [10645] = {.lex_state = 0},
  [10646] = {.lex_state = 0},
  [10647] = {.lex_state = 0},
  [10648] = {.lex_state = 35},
  [10649] = {.lex_state = 0},
  [10650] = {.lex_state = 35},
  [10651] = {.lex_state = 0},
  [10652] = {.lex_state = 0},
  [10653] = {.lex_state = 0},
  [10654] = {.lex_state = 0},
  [10655] = {.lex_state = 35},
  [10656] = {.lex_state = 0},
  [10657] = {.lex_state = 35},
  [10658] = {.lex_state = 0},
  [10659] = {.lex_state = 0},
  [10660] = {.lex_state = 0},
  [10661] = {.lex_state = 0},
  [10662] = {.lex_state = 35},
  [10663] = {.lex_state = 0},
  [10664] = {.lex_state = 0},
  [10665] = {.lex_state = 35},
  [10666] = {.lex_state = 0},
  [10667] = {.lex_state = 35},
  [10668] = {.lex_state = 0},
  [10669] = {.lex_state = 0},
  [10670] = {.lex_state = 0},
  [10671] = {.lex_state = 0},
  [10672] = {.lex_state = 35, .external_lex_state = 2},
  [10673] = {.lex_state = 35, .external_lex_state = 2},
  [10674] = {.lex_state = 35},
  [10675] = {.lex_state = 0},
  [10676] = {.lex_state = 0},
  [10677] = {.lex_state = 35, .external_lex_state = 2},
  [10678] = {.lex_state = 35, .external_lex_state = 2},
  [10679] = {.lex_state = 0},
  [10680] = {.lex_state = 35, .external_lex_state = 2},
  [10681] = {.lex_state = 35},
  [10682] = {.lex_state = 35, .external_lex_state = 2},
  [10683] = {.lex_state = 0},
  [10684] = {.lex_state = 0},
  [10685] = {.lex_state = 35, .external_lex_state = 2},
  [10686] = {.lex_state = 35, .external_lex_state = 2},
  [10687] = {.lex_state = 0},
  [10688] = {.lex_state = 0},
  [10689] = {.lex_state = 35},
  [10690] = {.lex_state = 0},
  [10691] = {.lex_state = 0},
  [10692] = {.lex_state = 35},
  [10693] = {.lex_state = 35},
  [10694] = {.lex_state = 35},
  [10695] = {.lex_state = 35},
  [10696] = {.lex_state = 35},
  [10697] = {.lex_state = 0},
  [10698] = {.lex_state = 0},
  [10699] = {.lex_state = 35, .external_lex_state = 2},
  [10700] = {.lex_state = 35, .external_lex_state = 2},
  [10701] = {.lex_state = 0, .external_lex_state = 2},
  [10702] = {.lex_state = 35},
  [10703] = {.lex_state = 35},
  [10704] = {.lex_state = 0, .external_lex_state = 2},
  [10705] = {.lex_state = 0},
  [10706] = {.lex_state = 0},
  [10707] = {.lex_state = 35},
  [10708] = {.lex_state = 35},
  [10709] = {.lex_state = 0, .external_lex_state = 2},
  [10710] = {.lex_state = 0},
  [10711] = {.lex_state = 0, .external_lex_state = 2},
  [10712] = {.lex_state = 0, .external_lex_state = 2},
  [10713] = {.lex_state = 0},
  [10714] = {.lex_state = 35},
  [10715] = {.lex_state = 0},
  [10716] = {.lex_state = 0},
  [10717] = {.lex_state = 0},
  [10718] = {.lex_state = 35},
  [10719] = {.lex_state = 35},
  [10720] = {.lex_state = 0, .external_lex_state = 2},
  [10721] = {.lex_state = 0},
  [10722] = {.lex_state = 0},
  [10723] = {.lex_state = 35},
  [10724] = {.lex_state = 35, .external_lex_state = 2},
  [10725] = {.lex_state = 35},
  [10726] = {.lex_state = 35, .external_lex_state = 2},
  [10727] = {.lex_state = 0},
  [10728] = {.lex_state = 0},
  [10729] = {.lex_state = 0},
  [10730] = {.lex_state = 0},
  [10731] = {.lex_state = 35},
  [10732] = {.lex_state = 0},
  [10733] = {.lex_state = 0},
  [10734] = {.lex_state = 35},
  [10735] = {.lex_state = 35},
  [10736] = {.lex_state = 0},
  [10737] = {.lex_state = 0},
  [10738] = {.lex_state = 35},
  [10739] = {.lex_state = 0},
  [10740] = {.lex_state = 0, .external_lex_state = 2},
  [10741] = {.lex_state = 35},
  [10742] = {.lex_state = 35},
  [10743] = {.lex_state = 0},
  [10744] = {.lex_state = 0},
  [10745] = {.lex_state = 0},
  [10746] = {.lex_state = 35, .external_lex_state = 2},
  [10747] = {.lex_state = 35},
  [10748] = {.lex_state = 35},
  [10749] = {.lex_state = 0},
  [10750] = {.lex_state = 0},
  [10751] = {.lex_state = 0},
  [10752] = {.lex_state = 35},
  [10753] = {.lex_state = 0},
  [10754] = {.lex_state = 35},
  [10755] = {.lex_state = 0},
  [10756] = {.lex_state = 0},
  [10757] = {.lex_state = 0, .external_lex_state = 2},
  [10758] = {.lex_state = 35},
  [10759] = {.lex_state = 0},
  [10760] = {.lex_state = 0},
  [10761] = {.lex_state = 35},
  [10762] = {.lex_state = 35},
  [10763] = {.lex_state = 35},
  [10764] = {.lex_state = 0},
  [10765] = {.lex_state = 0},
  [10766] = {.lex_state = 35},
  [10767] = {.lex_state = 0, .external_lex_state = 2},
  [10768] = {.lex_state = 35},
  [10769] = {.lex_state = 0},
  [10770] = {.lex_state = 35, .external_lex_state = 2},
  [10771] = {.lex_state = 35, .external_lex_state = 2},
  [10772] = {.lex_state = 0},
  [10773] = {.lex_state = 0},
  [10774] = {.lex_state = 35},
  [10775] = {.lex_state = 0},
  [10776] = {.lex_state = 0},
  [10777] = {.lex_state = 0},
  [10778] = {.lex_state = 35},
  [10779] = {.lex_state = 0},
  [10780] = {.lex_state = 35},
  [10781] = {.lex_state = 0},
  [10782] = {.lex_state = 0},
  [10783] = {.lex_state = 0},
  [10784] = {.lex_state = 0},
  [10785] = {.lex_state = 0},
  [10786] = {.lex_state = 35},
  [10787] = {.lex_state = 0},
  [10788] = {.lex_state = 35},
  [10789] = {.lex_state = 35, .external_lex_state = 2},
  [10790] = {.lex_state = 35},
  [10791] = {.lex_state = 0},
  [10792] = {.lex_state = 35},
  [10793] = {.lex_state = 35},
  [10794] = {.lex_state = 35, .external_lex_state = 2},
  [10795] = {.lex_state = 0},
  [10796] = {.lex_state = 35},
  [10797] = {.lex_state = 0},
  [10798] = {.lex_state = 0},
  [10799] = {.lex_state = 0},
  [10800] = {.lex_state = 35, .external_lex_state = 2},
  [10801] = {.lex_state = 35, .external_lex_state = 2},
  [10802] = {.lex_state = 0},
  [10803] = {.lex_state = 35},
  [10804] = {.lex_state = 0},
  [10805] = {.lex_state = 0},
  [10806] = {.lex_state = 35},
  [10807] = {.lex_state = 0},
  [10808] = {.lex_state = 0},
  [10809] = {.lex_state = 0},
  [10810] = {.lex_state = 35, .external_lex_state = 2},
  [10811] = {.lex_state = 35, .external_lex_state = 2},
  [10812] = {.lex_state = 0},
  [10813] = {.lex_state = 0},
  [10814] = {.lex_state = 0},
  [10815] = {.lex_state = 0},
  [10816] = {.lex_state = 0},
  [10817] = {.lex_state = 0},
  [10818] = {.lex_state = 0},
  [10819] = {.lex_state = 0},
  [10820] = {.lex_state = 0},
  [10821] = {.lex_state = 0},
  [10822] = {.lex_state = 35, .external_lex_state = 2},
  [10823] = {.lex_state = 35, .external_lex_state = 2},
  [10824] = {.lex_state = 0},
  [10825] = {.lex_state = 35, .external_lex_state = 2},
  [10826] = {.lex_state = 0, .external_lex_state = 2},
  [10827] = {.lex_state = 0},
  [10828] = {.lex_state = 0, .external_lex_state = 2},
  [10829] = {.lex_state = 0, .external_lex_state = 2},
  [10830] = {.lex_state = 35, .external_lex_state = 2},
  [10831] = {.lex_state = 0},
  [10832] = {.lex_state = 0},
  [10833] = {.lex_state = 35},
  [10834] = {.lex_state = 0},
  [10835] = {.lex_state = 0},
  [10836] = {.lex_state = 0},
  [10837] = {.lex_state = 0},
  [10838] = {.lex_state = 0},
  [10839] = {.lex_state = 0},
  [10840] = {.lex_state = 0},
  [10841] = {.lex_state = 0},
  [10842] = {.lex_state = 35, .external_lex_state = 2},
  [10843] = {.lex_state = 0},
  [10844] = {.lex_state = 0},
  [10845] = {.lex_state = 0},
  [10846] = {.lex_state = 0},
  [10847] = {.lex_state = 35, .external_lex_state = 2},
  [10848] = {.lex_state = 0},
  [10849] = {.lex_state = 35},
  [10850] = {.lex_state = 0},
  [10851] = {.lex_state = 0},
  [10852] = {.lex_state = 0, .external_lex_state = 2},
  [10853] = {.lex_state = 0},
  [10854] = {.lex_state = 35},
  [10855] = {.lex_state = 0},
  [10856] = {.lex_state = 35},
  [10857] = {.lex_state = 35},
  [10858] = {.lex_state = 35},
  [10859] = {.lex_state = 35, .external_lex_state = 2},
  [10860] = {.lex_state = 0},
  [10861] = {.lex_state = 0},
  [10862] = {.lex_state = 35},
  [10863] = {.lex_state = 35},
  [10864] = {.lex_state = 0},
  [10865] = {.lex_state = 35, .external_lex_state = 2},
  [10866] = {.lex_state = 0},
  [10867] = {.lex_state = 35},
  [10868] = {.lex_state = 0},
  [10869] = {.lex_state = 0},
  [10870] = {.lex_state = 35, .external_lex_state = 2},
  [10871] = {.lex_state = 35},
  [10872] = {.lex_state = 35, .external_lex_state = 2},
  [10873] = {.lex_state = 35},
  [10874] = {.lex_state = 0},
  [10875] = {.lex_state = 0},
  [10876] = {.lex_state = 35, .external_lex_state = 2},
  [10877] = {.lex_state = 35},
  [10878] = {.lex_state = 0},
  [10879] = {.lex_state = 35},
  [10880] = {.lex_state = 0},
  [10881] = {.lex_state = 0},
  [10882] = {.lex_state = 0},
  [10883] = {.lex_state = 0},
  [10884] = {.lex_state = 0},
  [10885] = {.lex_state = 0},
  [10886] = {.lex_state = 35, .external_lex_state = 2},
  [10887] = {.lex_state = 0},
  [10888] = {.lex_state = 35, .external_lex_state = 2},
  [10889] = {.lex_state = 35, .external_lex_state = 2},
  [10890] = {.lex_state = 0},
  [10891] = {.lex_state = 35, .external_lex_state = 2},
  [10892] = {.lex_state = 0},
  [10893] = {.lex_state = 35, .external_lex_state = 2},
  [10894] = {.lex_state = 0},
  [10895] = {.lex_state = 35},
  [10896] = {.lex_state = 0},
  [10897] = {.lex_state = 0},
  [10898] = {.lex_state = 35},
  [10899] = {.lex_state = 0},
  [10900] = {.lex_state = 0},
  [10901] = {.lex_state = 35},
  [10902] = {.lex_state = 35, .external_lex_state = 2},
  [10903] = {.lex_state = 0},
  [10904] = {.lex_state = 35},
  [10905] = {.lex_state = 0},
  [10906] = {.lex_state = 0},
  [10907] = {.lex_state = 0},
  [10908] = {.lex_state = 0},
  [10909] = {.lex_state = 0, .external_lex_state = 2},
  [10910] = {.lex_state = 0},
  [10911] = {.lex_state = 0},
  [10912] = {.lex_state = 35},
  [10913] = {.lex_state = 0},
  [10914] = {.lex_state = 0},
  [10915] = {.lex_state = 0},
  [10916] = {.lex_state = 35},
  [10917] = {.lex_state = 0},
  [10918] = {.lex_state = 0},
  [10919] = {.lex_state = 0},
  [10920] = {.lex_state = 0},
  [10921] = {.lex_state = 0},
  [10922] = {.lex_state = 0},
  [10923] = {.lex_state = 0},
  [10924] = {.lex_state = 0},
  [10925] = {.lex_state = 35, .external_lex_state = 2},
  [10926] = {.lex_state = 0},
  [10927] = {.lex_state = 0},
  [10928] = {.lex_state = 0},
  [10929] = {.lex_state = 35},
  [10930] = {.lex_state = 35, .external_lex_state = 2},
  [10931] = {.lex_state = 0},
  [10932] = {.lex_state = 35},
  [10933] = {.lex_state = 35, .external_lex_state = 2},
  [10934] = {.lex_state = 0},
  [10935] = {.lex_state = 35},
  [10936] = {.lex_state = 35},
  [10937] = {.lex_state = 0},
  [10938] = {.lex_state = 35},
  [10939] = {.lex_state = 0},
  [10940] = {.lex_state = 0},
  [10941] = {.lex_state = 35, .external_lex_state = 2},
  [10942] = {.lex_state = 35},
  [10943] = {.lex_state = 0},
  [10944] = {.lex_state = 35},
  [10945] = {.lex_state = 0},
  [10946] = {.lex_state = 0},
  [10947] = {.lex_state = 0},
  [10948] = {.lex_state = 35, .external_lex_state = 2},
  [10949] = {.lex_state = 35, .external_lex_state = 2},
  [10950] = {.lex_state = 0},
  [10951] = {.lex_state = 35, .external_lex_state = 2},
  [10952] = {.lex_state = 0},
  [10953] = {.lex_state = 0},
  [10954] = {.lex_state = 35, .external_lex_state = 2},
  [10955] = {.lex_state = 0},
  [10956] = {.lex_state = 0},
  [10957] = {.lex_state = 0},
  [10958] = {.lex_state = 0},
  [10959] = {.lex_state = 0},
  [10960] = {.lex_state = 0},
  [10961] = {.lex_state = 35},
  [10962] = {.lex_state = 0},
  [10963] = {.lex_state = 0},
  [10964] = {.lex_state = 35},
  [10965] = {.lex_state = 0},
  [10966] = {.lex_state = 35},
  [10967] = {.lex_state = 35, .external_lex_state = 2},
  [10968] = {.lex_state = 0},
  [10969] = {.lex_state = 35},
  [10970] = {.lex_state = 0},
  [10971] = {.lex_state = 0},
  [10972] = {.lex_state = 35, .external_lex_state = 2},
  [10973] = {.lex_state = 35},
  [10974] = {.lex_state = 0},
  [10975] = {.lex_state = 35},
  [10976] = {.lex_state = 0},
  [10977] = {.lex_state = 35},
  [10978] = {.lex_state = 35},
  [10979] = {.lex_state = 35, .external_lex_state = 2},
  [10980] = {.lex_state = 35, .external_lex_state = 2},
  [10981] = {.lex_state = 35, .external_lex_state = 2},
  [10982] = {.lex_state = 0},
  [10983] = {.lex_state = 0},
  [10984] = {.lex_state = 0},
  [10985] = {.lex_state = 0},
  [10986] = {.lex_state = 35},
  [10987] = {.lex_state = 35},
  [10988] = {.lex_state = 35, .external_lex_state = 2},
  [10989] = {.lex_state = 35, .external_lex_state = 2},
  [10990] = {.lex_state = 35, .external_lex_state = 2},
  [10991] = {.lex_state = 0},
  [10992] = {.lex_state = 35},
  [10993] = {.lex_state = 0},
  [10994] = {.lex_state = 0},
  [10995] = {.lex_state = 35},
  [10996] = {.lex_state = 0},
  [10997] = {.lex_state = 35},
  [10998] = {.lex_state = 0},
  [10999] = {.lex_state = 0},
  [11000] = {.lex_state = 0},
  [11001] = {.lex_state = 0},
  [11002] = {.lex_state = 0},
  [11003] = {.lex_state = 0},
  [11004] = {.lex_state = 35},
  [11005] = {.lex_state = 35},
  [11006] = {.lex_state = 0},
  [11007] = {.lex_state = 0},
  [11008] = {.lex_state = 0},
  [11009] = {.lex_state = 0},
  [11010] = {.lex_state = 0},
  [11011] = {.lex_state = 35, .external_lex_state = 2},
  [11012] = {.lex_state = 0},
  [11013] = {.lex_state = 35, .external_lex_state = 2},
  [11014] = {.lex_state = 0},
  [11015] = {.lex_state = 0},
  [11016] = {.lex_state = 35, .external_lex_state = 2},
  [11017] = {.lex_state = 35, .external_lex_state = 2},
  [11018] = {.lex_state = 0},
  [11019] = {.lex_state = 0},
  [11020] = {.lex_state = 35, .external_lex_state = 2},
  [11021] = {.lex_state = 35, .external_lex_state = 2},
  [11022] = {.lex_state = 0},
  [11023] = {.lex_state = 0},
  [11024] = {.lex_state = 0},
  [11025] = {.lex_state = 0},
  [11026] = {.lex_state = 0},
  [11027] = {.lex_state = 0},
  [11028] = {.lex_state = 35},
  [11029] = {.lex_state = 0},
  [11030] = {.lex_state = 0},
  [11031] = {.lex_state = 35},
  [11032] = {.lex_state = 0},
  [11033] = {.lex_state = 0},
  [11034] = {.lex_state = 0},
  [11035] = {.lex_state = 0},
  [11036] = {.lex_state = 35},
  [11037] = {.lex_state = 0},
  [11038] = {.lex_state = 35, .external_lex_state = 2},
  [11039] = {.lex_state = 0},
  [11040] = {.lex_state = 35, .external_lex_state = 2},
  [11041] = {.lex_state = 0},
  [11042] = {.lex_state = 0},
  [11043] = {.lex_state = 35, .external_lex_state = 2},
  [11044] = {.lex_state = 35, .external_lex_state = 2},
  [11045] = {.lex_state = 35, .external_lex_state = 2},
  [11046] = {.lex_state = 0},
  [11047] = {.lex_state = 35},
  [11048] = {.lex_state = 35, .external_lex_state = 2},
  [11049] = {.lex_state = 0},
  [11050] = {.lex_state = 35},
  [11051] = {.lex_state = 0},
  [11052] = {.lex_state = 0},
  [11053] = {.lex_state = 35},
  [11054] = {.lex_state = 0},
  [11055] = {.lex_state = 0},
  [11056] = {.lex_state = 35},
  [11057] = {.lex_state = 0},
  [11058] = {.lex_state = 0},
  [11059] = {.lex_state = 35, .external_lex_state = 2},
  [11060] = {.lex_state = 35},
  [11061] = {.lex_state = 35, .external_lex_state = 2},
  [11062] = {.lex_state = 0},
  [11063] = {.lex_state = 35, .external_lex_state = 2},
  [11064] = {.lex_state = 0},
  [11065] = {.lex_state = 35},
  [11066] = {.lex_state = 35, .external_lex_state = 2},
  [11067] = {.lex_state = 0},
  [11068] = {.lex_state = 35, .external_lex_state = 2},
  [11069] = {.lex_state = 35, .external_lex_state = 2},
  [11070] = {.lex_state = 35},
  [11071] = {.lex_state = 35},
  [11072] = {.lex_state = 35},
  [11073] = {.lex_state = 0},
  [11074] = {.lex_state = 35},
  [11075] = {.lex_state = 35},
  [11076] = {.lex_state = 35},
  [11077] = {.lex_state = 35},
  [11078] = {.lex_state = 0},
  [11079] = {.lex_state = 0},
  [11080] = {.lex_state = 0},
  [11081] = {.lex_state = 0},
  [11082] = {.lex_state = 0},
  [11083] = {.lex_state = 0},
  [11084] = {.lex_state = 0},
  [11085] = {.lex_state = 0},
  [11086] = {.lex_state = 0},
  [11087] = {.lex_state = 35},
  [11088] = {.lex_state = 0},
  [11089] = {.lex_state = 0},
  [11090] = {.lex_state = 0},
  [11091] = {.lex_state = 0},
  [11092] = {.lex_state = 0},
  [11093] = {.lex_state = 0},
  [11094] = {.lex_state = 35},
  [11095] = {.lex_state = 0},
  [11096] = {.lex_state = 0},
  [11097] = {.lex_state = 0},
  [11098] = {.lex_state = 0},
  [11099] = {.lex_state = 0},
  [11100] = {.lex_state = 0},
  [11101] = {.lex_state = 0},
  [11102] = {.lex_state = 35, .external_lex_state = 2},
  [11103] = {.lex_state = 0},
  [11104] = {.lex_state = 0},
  [11105] = {.lex_state = 0},
  [11106] = {.lex_state = 0},
  [11107] = {.lex_state = 35, .external_lex_state = 2},
  [11108] = {.lex_state = 35, .external_lex_state = 2},
  [11109] = {.lex_state = 35, .external_lex_state = 2},
  [11110] = {.lex_state = 35},
  [11111] = {.lex_state = 0},
  [11112] = {.lex_state = 0},
  [11113] = {.lex_state = 0},
  [11114] = {.lex_state = 0},
  [11115] = {.lex_state = 0},
  [11116] = {.lex_state = 0},
  [11117] = {.lex_state = 0},
  [11118] = {.lex_state = 0},
  [11119] = {.lex_state = 0},
  [11120] = {.lex_state = 0},
  [11121] = {.lex_state = 0},
  [11122] = {.lex_state = 0},
  [11123] = {.lex_state = 35, .external_lex_state = 2},
  [11124] = {.lex_state = 0},
  [11125] = {.lex_state = 0},
  [11126] = {.lex_state = 35, .external_lex_state = 2},
  [11127] = {.lex_state = 35, .external_lex_state = 2},
  [11128] = {.lex_state = 0},
  [11129] = {.lex_state = 0},
  [11130] = {.lex_state = 35},
  [11131] = {.lex_state = 0},
  [11132] = {.lex_state = 0},
  [11133] = {.lex_state = 0},
  [11134] = {.lex_state = 0},
  [11135] = {.lex_state = 0},
  [11136] = {.lex_state = 0},
  [11137] = {.lex_state = 0},
  [11138] = {.lex_state = 0},
  [11139] = {.lex_state = 0},
  [11140] = {.lex_state = 35, .external_lex_state = 2},
  [11141] = {.lex_state = 0},
  [11142] = {.lex_state = 0},
  [11143] = {.lex_state = 35},
  [11144] = {.lex_state = 0},
  [11145] = {.lex_state = 0},
  [11146] = {.lex_state = 0},
  [11147] = {.lex_state = 35},
  [11148] = {.lex_state = 0},
  [11149] = {.lex_state = 35},
  [11150] = {.lex_state = 0},
  [11151] = {.lex_state = 0},
  [11152] = {.lex_state = 0},
  [11153] = {.lex_state = 0},
  [11154] = {.lex_state = 35},
  [11155] = {.lex_state = 0},
  [11156] = {.lex_state = 35, .external_lex_state = 2},
  [11157] = {.lex_state = 0},
  [11158] = {.lex_state = 0},
  [11159] = {.lex_state = 35},
  [11160] = {.lex_state = 0},
  [11161] = {.lex_state = 0},
  [11162] = {.lex_state = 35, .external_lex_state = 2},
  [11163] = {.lex_state = 0},
  [11164] = {.lex_state = 35},
  [11165] = {.lex_state = 35, .external_lex_state = 2},
  [11166] = {.lex_state = 35, .external_lex_state = 2},
  [11167] = {.lex_state = 0},
  [11168] = {.lex_state = 0},
  [11169] = {.lex_state = 35, .external_lex_state = 2},
  [11170] = {.lex_state = 35, .external_lex_state = 2},
  [11171] = {.lex_state = 0},
  [11172] = {.lex_state = 0},
  [11173] = {.lex_state = 35, .external_lex_state = 2},
  [11174] = {.lex_state = 0},
  [11175] = {.lex_state = 0},
  [11176] = {.lex_state = 35},
  [11177] = {.lex_state = 0},
  [11178] = {.lex_state = 0},
  [11179] = {.lex_state = 0},
  [11180] = {.lex_state = 35, .external_lex_state = 2},
  [11181] = {.lex_state = 35, .external_lex_state = 2},
  [11182] = {.lex_state = 0},
  [11183] = {.lex_state = 0},
  [11184] = {.lex_state = 0},
  [11185] = {.lex_state = 35, .external_lex_state = 2},
  [11186] = {.lex_state = 35},
  [11187] = {.lex_state = 0},
  [11188] = {.lex_state = 35, .external_lex_state = 2},
  [11189] = {.lex_state = 0},
  [11190] = {.lex_state = 0},
  [11191] = {.lex_state = 0},
  [11192] = {.lex_state = 35},
  [11193] = {.lex_state = 0},
  [11194] = {.lex_state = 35},
  [11195] = {.lex_state = 0},
  [11196] = {.lex_state = 35, .external_lex_state = 2},
  [11197] = {.lex_state = 35, .external_lex_state = 2},
  [11198] = {.lex_state = 0},
  [11199] = {.lex_state = 0},
  [11200] = {.lex_state = 0},
  [11201] = {.lex_state = 0},
  [11202] = {.lex_state = 0},
  [11203] = {.lex_state = 0},
  [11204] = {.lex_state = 35, .external_lex_state = 2},
  [11205] = {.lex_state = 0},
  [11206] = {.lex_state = 0},
  [11207] = {.lex_state = 0},
  [11208] = {.lex_state = 0},
  [11209] = {.lex_state = 0},
  [11210] = {.lex_state = 0},
  [11211] = {.lex_state = 0},
  [11212] = {.lex_state = 0},
  [11213] = {.lex_state = 0},
  [11214] = {.lex_state = 35},
  [11215] = {.lex_state = 0},
  [11216] = {.lex_state = 35, .external_lex_state = 2},
  [11217] = {.lex_state = 0},
  [11218] = {.lex_state = 0},
  [11219] = {.lex_state = 0},
  [11220] = {.lex_state = 0},
  [11221] = {.lex_state = 0},
  [11222] = {.lex_state = 0},
  [11223] = {.lex_state = 0},
  [11224] = {.lex_state = 0},
  [11225] = {.lex_state = 0},
  [11226] = {.lex_state = 0},
  [11227] = {.lex_state = 0},
  [11228] = {.lex_state = 0, .external_lex_state = 2},
  [11229] = {.lex_state = 0, .external_lex_state = 2},
  [11230] = {.lex_state = 0, .external_lex_state = 2},
  [11231] = {.lex_state = 0, .external_lex_state = 2},
  [11232] = {.lex_state = 0, .external_lex_state = 2},
  [11233] = {.lex_state = 0, .external_lex_state = 2},
  [11234] = {.lex_state = 0, .external_lex_state = 2},
  [11235] = {.lex_state = 0, .external_lex_state = 2},
  [11236] = {.lex_state = 0, .external_lex_state = 2},
  [11237] = {.lex_state = 0},
  [11238] = {.lex_state = 0},
  [11239] = {.lex_state = 0},
  [11240] = {.lex_state = 0, .external_lex_state = 2},
  [11241] = {.lex_state = 0, .external_lex_state = 2},
  [11242] = {.lex_state = 1},
  [11243] = {.lex_state = 0, .external_lex_state = 2},
  [11244] = {.lex_state = 0, .external_lex_state = 2},
  [11245] = {.lex_state = 0, .external_lex_state = 2},
  [11246] = {.lex_state = 0, .external_lex_state = 2},
  [11247] = {.lex_state = 0, .external_lex_state = 2},
  [11248] = {.lex_state = 0, .external_lex_state = 2},
  [11249] = {.lex_state = 0, .external_lex_state = 2},
  [11250] = {.lex_state = 0, .external_lex_state = 2},
  [11251] = {.lex_state = 0, .external_lex_state = 2},
  [11252] = {.lex_state = 0, .external_lex_state = 2},
  [11253] = {.lex_state = 0, .external_lex_state = 2},
  [11254] = {.lex_state = 0, .external_lex_state = 2},
  [11255] = {.lex_state = 0, .external_lex_state = 2},
  [11256] = {.lex_state = 0, .external_lex_state = 2},
  [11257] = {.lex_state = 0, .external_lex_state = 2},
  [11258] = {.lex_state = 0, .external_lex_state = 2},
  [11259] = {.lex_state = 0, .external_lex_state = 2},
  [11260] = {.lex_state = 0, .external_lex_state = 2},
  [11261] = {.lex_state = 0},
  [11262] = {.lex_state = 0, .external_lex_state = 2},
  [11263] = {.lex_state = 0},
  [11264] = {.lex_state = 0, .external_lex_state = 2},
  [11265] = {.lex_state = 0, .external_lex_state = 2},
  [11266] = {.lex_state = 0, .external_lex_state = 2},
  [11267] = {.lex_state = 0, .external_lex_state = 2},
  [11268] = {.lex_state = 0, .external_lex_state = 2},
  [11269] = {.lex_state = 0, .external_lex_state = 2},
  [11270] = {.lex_state = 0},
  [11271] = {.lex_state = 0, .external_lex_state = 2},
  [11272] = {.lex_state = 0, .external_lex_state = 2},
  [11273] = {.lex_state = 35},
  [11274] = {.lex_state = 0},
  [11275] = {.lex_state = 0, .external_lex_state = 2},
  [11276] = {.lex_state = 0, .external_lex_state = 2},
  [11277] = {.lex_state = 0, .external_lex_state = 2},
  [11278] = {.lex_state = 0, .external_lex_state = 2},
  [11279] = {.lex_state = 0, .external_lex_state = 2},
  [11280] = {.lex_state = 0, .external_lex_state = 2},
  [11281] = {.lex_state = 0, .external_lex_state = 2},
  [11282] = {.lex_state = 0, .external_lex_state = 2},
  [11283] = {.lex_state = 0, .external_lex_state = 2},
  [11284] = {.lex_state = 0, .external_lex_state = 2},
  [11285] = {.lex_state = 0, .external_lex_state = 2},
  [11286] = {.lex_state = 0, .external_lex_state = 2},
  [11287] = {.lex_state = 0},
  [11288] = {.lex_state = 0, .external_lex_state = 2},
  [11289] = {.lex_state = 1},
  [11290] = {.lex_state = 0, .external_lex_state = 2},
  [11291] = {.lex_state = 0, .external_lex_state = 2},
  [11292] = {.lex_state = 0, .external_lex_state = 2},
  [11293] = {.lex_state = 0, .external_lex_state = 2},
  [11294] = {.lex_state = 0, .external_lex_state = 2},
  [11295] = {.lex_state = 0, .external_lex_state = 2},
  [11296] = {.lex_state = 0, .external_lex_state = 2},
  [11297] = {.lex_state = 0},
  [11298] = {.lex_state = 0},
  [11299] = {.lex_state = 0, .external_lex_state = 2},
  [11300] = {.lex_state = 0, .external_lex_state = 2},
  [11301] = {.lex_state = 0},
  [11302] = {.lex_state = 0, .external_lex_state = 2},
  [11303] = {.lex_state = 0, .external_lex_state = 2},
  [11304] = {.lex_state = 0},
  [11305] = {.lex_state = 0, .external_lex_state = 2},
  [11306] = {.lex_state = 0, .external_lex_state = 2},
  [11307] = {.lex_state = 0, .external_lex_state = 2},
  [11308] = {.lex_state = 0, .external_lex_state = 2},
  [11309] = {.lex_state = 0, .external_lex_state = 2},
  [11310] = {.lex_state = 0, .external_lex_state = 2},
  [11311] = {.lex_state = 0, .external_lex_state = 2},
  [11312] = {.lex_state = 0, .external_lex_state = 2},
  [11313] = {.lex_state = 0, .external_lex_state = 2},
  [11314] = {.lex_state = 0, .external_lex_state = 2},
  [11315] = {.lex_state = 0, .external_lex_state = 2},
  [11316] = {.lex_state = 0},
  [11317] = {.lex_state = 0, .external_lex_state = 2},
  [11318] = {.lex_state = 0, .external_lex_state = 2},
  [11319] = {.lex_state = 0, .external_lex_state = 2},
  [11320] = {.lex_state = 0, .external_lex_state = 2},
  [11321] = {.lex_state = 0},
  [11322] = {.lex_state = 0, .external_lex_state = 2},
  [11323] = {.lex_state = 0, .external_lex_state = 2},
  [11324] = {.lex_state = 0, .external_lex_state = 2},
  [11325] = {.lex_state = 0, .external_lex_state = 2},
  [11326] = {.lex_state = 0},
  [11327] = {.lex_state = 0, .external_lex_state = 2},
  [11328] = {.lex_state = 0, .external_lex_state = 2},
  [11329] = {.lex_state = 0},
  [11330] = {.lex_state = 0},
  [11331] = {.lex_state = 0, .external_lex_state = 2},
  [11332] = {.lex_state = 35},
  [11333] = {.lex_state = 0, .external_lex_state = 2},
  [11334] = {.lex_state = 0},
  [11335] = {.lex_state = 0},
  [11336] = {.lex_state = 0},
  [11337] = {.lex_state = 0, .external_lex_state = 2},
  [11338] = {.lex_state = 0, .external_lex_state = 2},
  [11339] = {.lex_state = 0, .external_lex_state = 2},
  [11340] = {.lex_state = 35},
  [11341] = {.lex_state = 0, .external_lex_state = 2},
  [11342] = {.lex_state = 0, .external_lex_state = 2},
  [11343] = {.lex_state = 0, .external_lex_state = 2},
  [11344] = {.lex_state = 35},
  [11345] = {.lex_state = 0, .external_lex_state = 2},
  [11346] = {.lex_state = 0, .external_lex_state = 2},
  [11347] = {.lex_state = 0},
  [11348] = {.lex_state = 0, .external_lex_state = 2},
  [11349] = {.lex_state = 0, .external_lex_state = 2},
  [11350] = {.lex_state = 0, .external_lex_state = 2},
  [11351] = {.lex_state = 0, .external_lex_state = 2},
  [11352] = {.lex_state = 0, .external_lex_state = 2},
  [11353] = {.lex_state = 0, .external_lex_state = 2},
  [11354] = {.lex_state = 0, .external_lex_state = 2},
  [11355] = {.lex_state = 35},
  [11356] = {.lex_state = 0, .external_lex_state = 2},
  [11357] = {.lex_state = 0, .external_lex_state = 2},
  [11358] = {.lex_state = 0, .external_lex_state = 2},
  [11359] = {.lex_state = 0, .external_lex_state = 2},
  [11360] = {.lex_state = 0},
  [11361] = {.lex_state = 0},
  [11362] = {.lex_state = 0},
  [11363] = {.lex_state = 1},
  [11364] = {.lex_state = 0, .external_lex_state = 2},
  [11365] = {.lex_state = 0, .external_lex_state = 2},
  [11366] = {.lex_state = 0, .external_lex_state = 2},
  [11367] = {.lex_state = 0, .external_lex_state = 2},
  [11368] = {.lex_state = 0, .external_lex_state = 2},
  [11369] = {.lex_state = 0, .external_lex_state = 2},
  [11370] = {.lex_state = 0, .external_lex_state = 2},
  [11371] = {.lex_state = 0, .external_lex_state = 2},
  [11372] = {.lex_state = 0},
  [11373] = {.lex_state = 0, .external_lex_state = 2},
  [11374] = {.lex_state = 0, .external_lex_state = 2},
  [11375] = {.lex_state = 0, .external_lex_state = 2},
  [11376] = {.lex_state = 0, .external_lex_state = 2},
  [11377] = {.lex_state = 0, .external_lex_state = 2},
  [11378] = {.lex_state = 0, .external_lex_state = 2},
  [11379] = {.lex_state = 0, .external_lex_state = 2},
  [11380] = {.lex_state = 0, .external_lex_state = 2},
  [11381] = {.lex_state = 0},
  [11382] = {.lex_state = 0, .external_lex_state = 2},
  [11383] = {.lex_state = 0},
  [11384] = {.lex_state = 1},
  [11385] = {.lex_state = 0, .external_lex_state = 2},
  [11386] = {.lex_state = 0},
  [11387] = {.lex_state = 0, .external_lex_state = 2},
  [11388] = {.lex_state = 0},
  [11389] = {.lex_state = 0, .external_lex_state = 2},
  [11390] = {.lex_state = 0, .external_lex_state = 2},
  [11391] = {.lex_state = 0},
  [11392] = {.lex_state = 0, .external_lex_state = 2},
  [11393] = {.lex_state = 0},
  [11394] = {.lex_state = 0, .external_lex_state = 2},
  [11395] = {.lex_state = 0, .external_lex_state = 2},
  [11396] = {.lex_state = 35},
  [11397] = {.lex_state = 35},
  [11398] = {.lex_state = 35},
  [11399] = {.lex_state = 0},
  [11400] = {.lex_state = 0},
  [11401] = {.lex_state = 0},
  [11402] = {.lex_state = 35},
  [11403] = {.lex_state = 0, .external_lex_state = 2},
  [11404] = {.lex_state = 35},
  [11405] = {.lex_state = 35},
  [11406] = {.lex_state = 35},
  [11407] = {.lex_state = 0},
  [11408] = {.lex_state = 0},
  [11409] = {.lex_state = 0},
  [11410] = {.lex_state = 35},
  [11411] = {.lex_state = 35},
  [11412] = {.lex_state = 35},
  [11413] = {.lex_state = 0, .external_lex_state = 2},
  [11414] = {.lex_state = 35},
  [11415] = {.lex_state = 35},
  [11416] = {.lex_state = 0},
  [11417] = {.lex_state = 0},
  [11418] = {.lex_state = 0},
  [11419] = {.lex_state = 35},
  [11420] = {.lex_state = 35},
  [11421] = {.lex_state = 35},
  [11422] = {.lex_state = 0},
  [11423] = {.lex_state = 0, .external_lex_state = 2},
  [11424] = {.lex_state = 35},
  [11425] = {.lex_state = 35},
  [11426] = {.lex_state = 0},
  [11427] = {.lex_state = 0},
  [11428] = {.lex_state = 0},
  [11429] = {.lex_state = 0},
  [11430] = {.lex_state = 0},
  [11431] = {.lex_state = 35},
  [11432] = {.lex_state = 1},
  [11433] = {.lex_state = 35},
  [11434] = {.lex_state = 0},
  [11435] = {.lex_state = 35},
  [11436] = {.lex_state = 35},
  [11437] = {.lex_state = 35},
  [11438] = {.lex_state = 35},
  [11439] = {.lex_state = 35},
  [11440] = {.lex_state = 35},
  [11441] = {.lex_state = 35},
  [11442] = {.lex_state = 35},
  [11443] = {.lex_state = 35},
  [11444] = {.lex_state = 0},
  [11445] = {.lex_state = 0},
  [11446] = {.lex_state = 0},
  [11447] = {.lex_state = 35},
  [11448] = {.lex_state = 35},
  [11449] = {.lex_state = 35},
  [11450] = {.lex_state = 33},
  [11451] = {.lex_state = 35},
  [11452] = {.lex_state = 35},
  [11453] = {.lex_state = 0},
  [11454] = {.lex_state = 35},
  [11455] = {.lex_state = 35},
  [11456] = {.lex_state = 0},
  [11457] = {.lex_state = 0},
  [11458] = {.lex_state = 35},
  [11459] = {.lex_state = 35},
  [11460] = {.lex_state = 0},
  [11461] = {.lex_state = 35},
  [11462] = {.lex_state = 35},
  [11463] = {.lex_state = 0},
  [11464] = {.lex_state = 0},
  [11465] = {.lex_state = 35},
  [11466] = {.lex_state = 35},
  [11467] = {.lex_state = 0},
  [11468] = {.lex_state = 35},
  [11469] = {.lex_state = 35},
  [11470] = {.lex_state = 0},
  [11471] = {.lex_state = 0},
  [11472] = {.lex_state = 0},
  [11473] = {.lex_state = 35},
  [11474] = {.lex_state = 35},
  [11475] = {.lex_state = 0},
  [11476] = {.lex_state = 35},
  [11477] = {.lex_state = 35},
  [11478] = {.lex_state = 35},
  [11479] = {.lex_state = 35},
  [11480] = {.lex_state = 35},
  [11481] = {.lex_state = 35},
  [11482] = {.lex_state = 35},
  [11483] = {.lex_state = 1},
  [11484] = {.lex_state = 35},
  [11485] = {.lex_state = 35},
  [11486] = {.lex_state = 35},
  [11487] = {.lex_state = 0},
  [11488] = {.lex_state = 0},
  [11489] = {.lex_state = 35},
  [11490] = {.lex_state = 35},
  [11491] = {.lex_state = 35},
  [11492] = {.lex_state = 35},
  [11493] = {.lex_state = 35},
  [11494] = {.lex_state = 35},
  [11495] = {.lex_state = 35},
  [11496] = {.lex_state = 35},
  [11497] = {.lex_state = 0},
  [11498] = {.lex_state = 0},
  [11499] = {.lex_state = 35},
  [11500] = {.lex_state = 35},
  [11501] = {.lex_state = 35},
  [11502] = {.lex_state = 0},
  [11503] = {.lex_state = 0},
  [11504] = {.lex_state = 0},
  [11505] = {.lex_state = 35},
  [11506] = {.lex_state = 35},
  [11507] = {.lex_state = 35},
  [11508] = {.lex_state = 0},
  [11509] = {.lex_state = 0},
  [11510] = {.lex_state = 0},
  [11511] = {.lex_state = 0},
  [11512] = {.lex_state = 35},
  [11513] = {.lex_state = 35},
  [11514] = {.lex_state = 0},
  [11515] = {.lex_state = 35},
  [11516] = {.lex_state = 35},
  [11517] = {.lex_state = 0},
  [11518] = {.lex_state = 35},
  [11519] = {.lex_state = 0},
  [11520] = {.lex_state = 0},
  [11521] = {.lex_state = 35},
  [11522] = {.lex_state = 0},
  [11523] = {.lex_state = 35},
  [11524] = {.lex_state = 0},
  [11525] = {.lex_state = 35},
  [11526] = {.lex_state = 35},
  [11527] = {.lex_state = 35},
  [11528] = {.lex_state = 35},
  [11529] = {.lex_state = 35},
  [11530] = {.lex_state = 35},
  [11531] = {.lex_state = 35},
  [11532] = {.lex_state = 35},
  [11533] = {.lex_state = 35},
  [11534] = {.lex_state = 35},
  [11535] = {.lex_state = 35},
  [11536] = {.lex_state = 35},
  [11537] = {.lex_state = 35},
  [11538] = {.lex_state = 0},
  [11539] = {.lex_state = 0},
  [11540] = {.lex_state = 35},
  [11541] = {.lex_state = 35},
  [11542] = {.lex_state = 0, .external_lex_state = 2},
  [11543] = {.lex_state = 0},
  [11544] = {.lex_state = 0},
  [11545] = {.lex_state = 0},
  [11546] = {.lex_state = 0},
  [11547] = {.lex_state = 35},
  [11548] = {.lex_state = 0},
  [11549] = {.lex_state = 35},
  [11550] = {.lex_state = 0},
  [11551] = {.lex_state = 0},
  [11552] = {.lex_state = 0},
  [11553] = {.lex_state = 0},
  [11554] = {.lex_state = 35},
  [11555] = {.lex_state = 0},
  [11556] = {.lex_state = 0},
  [11557] = {.lex_state = 35},
  [11558] = {.lex_state = 0},
  [11559] = {.lex_state = 0},
  [11560] = {.lex_state = 35},
  [11561] = {.lex_state = 35},
  [11562] = {.lex_state = 0},
  [11563] = {.lex_state = 35},
  [11564] = {.lex_state = 35},
  [11565] = {.lex_state = 0},
  [11566] = {.lex_state = 0},
  [11567] = {.lex_state = 0},
  [11568] = {.lex_state = 35},
  [11569] = {.lex_state = 35},
  [11570] = {.lex_state = 35},
  [11571] = {.lex_state = 1},
  [11572] = {.lex_state = 0},
  [11573] = {.lex_state = 35},
  [11574] = {.lex_state = 35},
  [11575] = {.lex_state = 35},
  [11576] = {.lex_state = 35},
  [11577] = {.lex_state = 0},
  [11578] = {.lex_state = 35},
  [11579] = {.lex_state = 0},
  [11580] = {.lex_state = 0},
  [11581] = {.lex_state = 0},
  [11582] = {.lex_state = 35},
  [11583] = {.lex_state = 35},
  [11584] = {.lex_state = 35},
  [11585] = {.lex_state = 35},
  [11586] = {.lex_state = 35},
  [11587] = {.lex_state = 35},
  [11588] = {.lex_state = 0},
  [11589] = {.lex_state = 0},
  [11590] = {.lex_state = 0},
  [11591] = {.lex_state = 0},
  [11592] = {.lex_state = 35},
  [11593] = {.lex_state = 0},
  [11594] = {.lex_state = 35},
  [11595] = {.lex_state = 35},
  [11596] = {.lex_state = 35},
  [11597] = {.lex_state = 0},
  [11598] = {.lex_state = 1},
  [11599] = {.lex_state = 35},
  [11600] = {.lex_state = 0},
  [11601] = {.lex_state = 35},
  [11602] = {.lex_state = 0},
  [11603] = {.lex_state = 0},
  [11604] = {.lex_state = 35},
  [11605] = {.lex_state = 35},
  [11606] = {.lex_state = 35},
  [11607] = {.lex_state = 35},
  [11608] = {.lex_state = 35},
  [11609] = {.lex_state = 35},
  [11610] = {.lex_state = 35},
  [11611] = {.lex_state = 35},
  [11612] = {.lex_state = 35},
  [11613] = {.lex_state = 35},
  [11614] = {.lex_state = 0},
  [11615] = {.lex_state = 0},
  [11616] = {.lex_state = 0},
  [11617] = {.lex_state = 0},
  [11618] = {.lex_state = 0},
  [11619] = {.lex_state = 35},
  [11620] = {.lex_state = 35},
  [11621] = {.lex_state = 35},
  [11622] = {.lex_state = 35},
  [11623] = {.lex_state = 35},
  [11624] = {.lex_state = 0},
  [11625] = {.lex_state = 0},
  [11626] = {.lex_state = 0},
  [11627] = {.lex_state = 35},
  [11628] = {.lex_state = 0},
  [11629] = {.lex_state = 35},
  [11630] = {.lex_state = 0},
  [11631] = {.lex_state = 0},
  [11632] = {.lex_state = 0},
  [11633] = {.lex_state = 35},
  [11634] = {.lex_state = 35},
  [11635] = {.lex_state = 0},
  [11636] = {.lex_state = 0},
  [11637] = {.lex_state = 0},
  [11638] = {.lex_state = 35},
  [11639] = {.lex_state = 35},
  [11640] = {.lex_state = 0},
  [11641] = {.lex_state = 35},
  [11642] = {.lex_state = 0},
  [11643] = {.lex_state = 35},
  [11644] = {.lex_state = 35},
  [11645] = {.lex_state = 0},
  [11646] = {.lex_state = 35},
  [11647] = {.lex_state = 0},
  [11648] = {.lex_state = 35},
  [11649] = {.lex_state = 35},
  [11650] = {.lex_state = 35},
  [11651] = {.lex_state = 35},
  [11652] = {.lex_state = 35},
  [11653] = {.lex_state = 0},
  [11654] = {.lex_state = 35},
  [11655] = {.lex_state = 0},
  [11656] = {.lex_state = 35},
  [11657] = {.lex_state = 0},
  [11658] = {.lex_state = 0},
  [11659] = {.lex_state = 35},
  [11660] = {.lex_state = 0},
  [11661] = {.lex_state = 0},
  [11662] = {.lex_state = 0},
  [11663] = {.lex_state = 35},
  [11664] = {.lex_state = 0},
  [11665] = {.lex_state = 0},
  [11666] = {.lex_state = 35},
  [11667] = {.lex_state = 35},
  [11668] = {.lex_state = 35},
  [11669] = {.lex_state = 35},
  [11670] = {.lex_state = 0},
  [11671] = {.lex_state = 35},
  [11672] = {.lex_state = 35},
  [11673] = {.lex_state = 35},
  [11674] = {.lex_state = 0},
  [11675] = {.lex_state = 0},
  [11676] = {.lex_state = 0},
  [11677] = {.lex_state = 35},
  [11678] = {.lex_state = 0},
  [11679] = {.lex_state = 0},
  [11680] = {.lex_state = 0},
  [11681] = {.lex_state = 1},
  [11682] = {.lex_state = 0},
  [11683] = {.lex_state = 35},
  [11684] = {.lex_state = 35},
  [11685] = {.lex_state = 0},
  [11686] = {.lex_state = 35},
  [11687] = {.lex_state = 35},
  [11688] = {.lex_state = 35},
  [11689] = {.lex_state = 0},
  [11690] = {.lex_state = 35},
  [11691] = {.lex_state = 35},
  [11692] = {.lex_state = 35},
  [11693] = {.lex_state = 35},
  [11694] = {.lex_state = 35},
  [11695] = {.lex_state = 35},
  [11696] = {.lex_state = 0},
  [11697] = {.lex_state = 35},
  [11698] = {.lex_state = 0},
  [11699] = {.lex_state = 0},
  [11700] = {.lex_state = 0, .external_lex_state = 2},
  [11701] = {.lex_state = 35},
  [11702] = {.lex_state = 35},
  [11703] = {.lex_state = 35},
  [11704] = {.lex_state = 35},
  [11705] = {.lex_state = 0},
  [11706] = {.lex_state = 35},
  [11707] = {.lex_state = 35},
  [11708] = {.lex_state = 0},
  [11709] = {.lex_state = 35},
  [11710] = {.lex_state = 35},
  [11711] = {.lex_state = 35},
  [11712] = {.lex_state = 35},
  [11713] = {.lex_state = 35},
  [11714] = {.lex_state = 35},
  [11715] = {.lex_state = 35},
  [11716] = {.lex_state = 35},
  [11717] = {.lex_state = 35},
  [11718] = {.lex_state = 0},
  [11719] = {.lex_state = 0},
  [11720] = {.lex_state = 35},
  [11721] = {.lex_state = 35},
  [11722] = {.lex_state = 0},
  [11723] = {.lex_state = 0},
  [11724] = {.lex_state = 35},
  [11725] = {.lex_state = 0},
  [11726] = {.lex_state = 35},
  [11727] = {.lex_state = 35},
  [11728] = {.lex_state = 35},
  [11729] = {.lex_state = 0},
  [11730] = {.lex_state = 35},
  [11731] = {.lex_state = 35},
  [11732] = {.lex_state = 35},
  [11733] = {.lex_state = 35},
  [11734] = {.lex_state = 35},
  [11735] = {.lex_state = 35},
  [11736] = {.lex_state = 0},
  [11737] = {.lex_state = 35},
  [11738] = {.lex_state = 0, .external_lex_state = 2},
  [11739] = {.lex_state = 0},
  [11740] = {.lex_state = 35},
  [11741] = {.lex_state = 35},
  [11742] = {.lex_state = 0},
  [11743] = {.lex_state = 0},
  [11744] = {.lex_state = 0},
  [11745] = {.lex_state = 35},
  [11746] = {.lex_state = 35},
  [11747] = {.lex_state = 35},
  [11748] = {.lex_state = 0},
  [11749] = {.lex_state = 0},
  [11750] = {.lex_state = 35},
  [11751] = {.lex_state = 35},
  [11752] = {.lex_state = 35},
  [11753] = {.lex_state = 35},
  [11754] = {.lex_state = 35},
  [11755] = {.lex_state = 35},
  [11756] = {.lex_state = 0, .external_lex_state = 2},
  [11757] = {.lex_state = 35},
  [11758] = {.lex_state = 35},
  [11759] = {.lex_state = 35},
  [11760] = {.lex_state = 35},
  [11761] = {.lex_state = 35},
  [11762] = {.lex_state = 35},
  [11763] = {.lex_state = 35},
  [11764] = {.lex_state = 35},
  [11765] = {.lex_state = 35},
  [11766] = {.lex_state = 35},
  [11767] = {.lex_state = 35},
  [11768] = {.lex_state = 35},
  [11769] = {.lex_state = 35},
  [11770] = {.lex_state = 0},
  [11771] = {.lex_state = 0},
  [11772] = {.lex_state = 35},
  [11773] = {.lex_state = 0},
  [11774] = {.lex_state = 1},
  [11775] = {.lex_state = 35},
  [11776] = {.lex_state = 0},
  [11777] = {.lex_state = 35},
  [11778] = {.lex_state = 0},
  [11779] = {.lex_state = 35},
  [11780] = {.lex_state = 0},
  [11781] = {.lex_state = 0},
  [11782] = {.lex_state = 35},
  [11783] = {.lex_state = 35},
  [11784] = {.lex_state = 1},
  [11785] = {.lex_state = 0},
  [11786] = {.lex_state = 35},
  [11787] = {.lex_state = 35},
  [11788] = {.lex_state = 35},
  [11789] = {.lex_state = 0},
  [11790] = {.lex_state = 0},
  [11791] = {.lex_state = 0},
  [11792] = {.lex_state = 0},
  [11793] = {.lex_state = 0},
  [11794] = {.lex_state = 0},
  [11795] = {.lex_state = 0},
  [11796] = {.lex_state = 35},
  [11797] = {.lex_state = 0},
  [11798] = {.lex_state = 35},
  [11799] = {.lex_state = 0},
  [11800] = {.lex_state = 35},
  [11801] = {.lex_state = 0},
  [11802] = {.lex_state = 35},
  [11803] = {.lex_state = 0},
  [11804] = {.lex_state = 35},
  [11805] = {.lex_state = 1},
  [11806] = {.lex_state = 35},
  [11807] = {.lex_state = 0},
  [11808] = {.lex_state = 0},
  [11809] = {.lex_state = 0},
  [11810] = {.lex_state = 35},
  [11811] = {.lex_state = 35},
  [11812] = {.lex_state = 35},
  [11813] = {.lex_state = 35},
  [11814] = {.lex_state = 0},
  [11815] = {.lex_state = 35},
  [11816] = {.lex_state = 35},
  [11817] = {.lex_state = 0},
  [11818] = {.lex_state = 0},
  [11819] = {.lex_state = 35},
  [11820] = {.lex_state = 0},
  [11821] = {.lex_state = 0},
  [11822] = {.lex_state = 0},
  [11823] = {.lex_state = 0},
  [11824] = {.lex_state = 35},
  [11825] = {.lex_state = 0},
  [11826] = {.lex_state = 0},
  [11827] = {.lex_state = 0},
  [11828] = {.lex_state = 0},
  [11829] = {.lex_state = 35},
  [11830] = {.lex_state = 35},
  [11831] = {.lex_state = 0},
  [11832] = {.lex_state = 0},
  [11833] = {.lex_state = 35},
  [11834] = {.lex_state = 35},
  [11835] = {.lex_state = 0},
  [11836] = {.lex_state = 0},
  [11837] = {.lex_state = 35},
  [11838] = {.lex_state = 35},
  [11839] = {.lex_state = 0},
  [11840] = {.lex_state = 0},
  [11841] = {.lex_state = 0},
  [11842] = {.lex_state = 35},
  [11843] = {.lex_state = 0},
  [11844] = {.lex_state = 0},
  [11845] = {.lex_state = 0},
  [11846] = {.lex_state = 0},
  [11847] = {.lex_state = 1},
  [11848] = {.lex_state = 0},
  [11849] = {.lex_state = 0},
  [11850] = {.lex_state = 0},
  [11851] = {.lex_state = 0},
  [11852] = {.lex_state = 35},
  [11853] = {.lex_state = 0},
  [11854] = {.lex_state = 0},
  [11855] = {.lex_state = 0},
  [11856] = {.lex_state = 35},
  [11857] = {.lex_state = 0},
  [11858] = {.lex_state = 35},
  [11859] = {.lex_state = 35},
  [11860] = {.lex_state = 35},
  [11861] = {.lex_state = 0},
  [11862] = {.lex_state = 35},
  [11863] = {.lex_state = 0},
  [11864] = {.lex_state = 35},
  [11865] = {.lex_state = 0},
  [11866] = {.lex_state = 0},
  [11867] = {.lex_state = 0},
  [11868] = {.lex_state = 0},
  [11869] = {.lex_state = 0},
  [11870] = {.lex_state = 0},
  [11871] = {.lex_state = 35},
  [11872] = {.lex_state = 35},
  [11873] = {.lex_state = 35},
  [11874] = {.lex_state = 35},
  [11875] = {.lex_state = 0},
  [11876] = {.lex_state = 35},
  [11877] = {.lex_state = 0},
  [11878] = {.lex_state = 1},
  [11879] = {.lex_state = 1},
  [11880] = {.lex_state = 35},
  [11881] = {.lex_state = 35},
  [11882] = {.lex_state = 0},
  [11883] = {.lex_state = 35},
  [11884] = {.lex_state = 0},
  [11885] = {.lex_state = 35},
  [11886] = {.lex_state = 35},
  [11887] = {.lex_state = 0},
  [11888] = {.lex_state = 35},
  [11889] = {.lex_state = 0},
  [11890] = {.lex_state = 35},
  [11891] = {.lex_state = 0},
  [11892] = {.lex_state = 35},
  [11893] = {.lex_state = 35},
  [11894] = {.lex_state = 35},
  [11895] = {.lex_state = 0},
  [11896] = {.lex_state = 0},
  [11897] = {.lex_state = 0},
  [11898] = {.lex_state = 0},
  [11899] = {.lex_state = 0},
  [11900] = {.lex_state = 35},
  [11901] = {.lex_state = 35},
  [11902] = {.lex_state = 35},
  [11903] = {.lex_state = 0},
  [11904] = {.lex_state = 0},
  [11905] = {.lex_state = 35},
  [11906] = {.lex_state = 35},
  [11907] = {.lex_state = 0},
  [11908] = {.lex_state = 35},
  [11909] = {.lex_state = 0},
  [11910] = {.lex_state = 0},
  [11911] = {.lex_state = 35},
  [11912] = {.lex_state = 35},
  [11913] = {.lex_state = 35},
  [11914] = {.lex_state = 35},
  [11915] = {.lex_state = 35},
  [11916] = {.lex_state = 0},
  [11917] = {.lex_state = 35},
  [11918] = {.lex_state = 35},
  [11919] = {.lex_state = 0},
  [11920] = {.lex_state = 35},
  [11921] = {.lex_state = 35},
  [11922] = {.lex_state = 0},
  [11923] = {.lex_state = 35},
  [11924] = {.lex_state = 0},
  [11925] = {.lex_state = 0},
  [11926] = {.lex_state = 35},
  [11927] = {.lex_state = 1},
  [11928] = {.lex_state = 35},
  [11929] = {.lex_state = 0},
  [11930] = {.lex_state = 0},
  [11931] = {.lex_state = 35},
  [11932] = {.lex_state = 35},
  [11933] = {.lex_state = 35},
  [11934] = {.lex_state = 0},
  [11935] = {.lex_state = 0},
  [11936] = {.lex_state = 0},
  [11937] = {.lex_state = 35},
  [11938] = {.lex_state = 0},
  [11939] = {.lex_state = 35},
  [11940] = {.lex_state = 35},
  [11941] = {.lex_state = 0},
  [11942] = {.lex_state = 0},
  [11943] = {.lex_state = 35},
  [11944] = {.lex_state = 35},
  [11945] = {.lex_state = 35},
  [11946] = {.lex_state = 35},
  [11947] = {.lex_state = 35},
  [11948] = {.lex_state = 35},
  [11949] = {.lex_state = 35},
  [11950] = {.lex_state = 35},
  [11951] = {.lex_state = 35},
  [11952] = {.lex_state = 0},
  [11953] = {.lex_state = 0},
  [11954] = {.lex_state = 35},
  [11955] = {.lex_state = 0},
  [11956] = {.lex_state = 0},
  [11957] = {.lex_state = 0},
  [11958] = {.lex_state = 35},
  [11959] = {.lex_state = 35},
  [11960] = {.lex_state = 0},
  [11961] = {.lex_state = 1},
  [11962] = {.lex_state = 0},
  [11963] = {.lex_state = 35},
  [11964] = {.lex_state = 35},
  [11965] = {.lex_state = 35},
  [11966] = {.lex_state = 0},
  [11967] = {.lex_state = 0},
  [11968] = {.lex_state = 0},
  [11969] = {.lex_state = 0},
  [11970] = {.lex_state = 0},
  [11971] = {.lex_state = 0},
  [11972] = {.lex_state = 35},
  [11973] = {.lex_state = 35},
  [11974] = {.lex_state = 0},
  [11975] = {.lex_state = 35},
  [11976] = {.lex_state = 35},
  [11977] = {.lex_state = 35},
  [11978] = {.lex_state = 1},
  [11979] = {.lex_state = 0},
  [11980] = {.lex_state = 35},
  [11981] = {.lex_state = 0},
  [11982] = {.lex_state = 0},
  [11983] = {.lex_state = 0},
  [11984] = {.lex_state = 35},
  [11985] = {.lex_state = 0},
  [11986] = {.lex_state = 35},
  [11987] = {.lex_state = 35},
  [11988] = {.lex_state = 35},
  [11989] = {.lex_state = 35},
  [11990] = {.lex_state = 35},
  [11991] = {.lex_state = 0},
  [11992] = {.lex_state = 35},
  [11993] = {.lex_state = 1},
  [11994] = {.lex_state = 35},
  [11995] = {.lex_state = 0},
  [11996] = {.lex_state = 0},
  [11997] = {.lex_state = 0},
  [11998] = {.lex_state = 0},
  [11999] = {.lex_state = 0},
  [12000] = {.lex_state = 0},
  [12001] = {.lex_state = 0},
  [12002] = {.lex_state = 0},
  [12003] = {.lex_state = 0},
  [12004] = {.lex_state = 0},
  [12005] = {.lex_state = 35},
  [12006] = {.lex_state = 35},
  [12007] = {.lex_state = 35},
  [12008] = {.lex_state = 0},
  [12009] = {.lex_state = 0},
  [12010] = {.lex_state = 1},
  [12011] = {.lex_state = 35},
  [12012] = {.lex_state = 0},
  [12013] = {.lex_state = 0},
  [12014] = {.lex_state = 35},
  [12015] = {.lex_state = 0},
  [12016] = {.lex_state = 0},
  [12017] = {.lex_state = 35},
  [12018] = {.lex_state = 0},
  [12019] = {.lex_state = 0},
  [12020] = {.lex_state = 0},
  [12021] = {.lex_state = 35},
  [12022] = {.lex_state = 0},
  [12023] = {.lex_state = 0},
  [12024] = {.lex_state = 0},
  [12025] = {.lex_state = 0},
  [12026] = {.lex_state = 0},
  [12027] = {.lex_state = 0},
  [12028] = {.lex_state = 0},
  [12029] = {.lex_state = 35},
  [12030] = {.lex_state = 0},
  [12031] = {.lex_state = 35},
  [12032] = {.lex_state = 0},
  [12033] = {.lex_state = 0},
  [12034] = {.lex_state = 0},
  [12035] = {.lex_state = 0},
  [12036] = {.lex_state = 0},
  [12037] = {.lex_state = 0},
  [12038] = {.lex_state = 0},
  [12039] = {.lex_state = 0},
  [12040] = {.lex_state = 35},
  [12041] = {.lex_state = 0},
  [12042] = {.lex_state = 35},
  [12043] = {.lex_state = 35},
  [12044] = {.lex_state = 0},
  [12045] = {.lex_state = 0},
  [12046] = {.lex_state = 0},
  [12047] = {.lex_state = 35},
  [12048] = {.lex_state = 0},
  [12049] = {.lex_state = 35},
  [12050] = {.lex_state = 0},
  [12051] = {.lex_state = 0},
  [12052] = {.lex_state = 0},
  [12053] = {.lex_state = 35},
  [12054] = {.lex_state = 0},
  [12055] = {.lex_state = 0},
  [12056] = {.lex_state = 0},
  [12057] = {.lex_state = 35},
  [12058] = {.lex_state = 0},
  [12059] = {.lex_state = 35},
  [12060] = {.lex_state = 0},
  [12061] = {.lex_state = 33},
  [12062] = {.lex_state = 0},
  [12063] = {.lex_state = 0},
  [12064] = {.lex_state = 35},
  [12065] = {.lex_state = 0},
  [12066] = {.lex_state = 35},
  [12067] = {.lex_state = 0},
  [12068] = {.lex_state = 0},
  [12069] = {.lex_state = 0},
  [12070] = {.lex_state = 0},
  [12071] = {.lex_state = 0},
  [12072] = {.lex_state = 35},
  [12073] = {.lex_state = 0},
  [12074] = {.lex_state = 35},
  [12075] = {.lex_state = 0},
  [12076] = {.lex_state = 35},
  [12077] = {.lex_state = 35},
  [12078] = {.lex_state = 0},
  [12079] = {.lex_state = 0},
  [12080] = {.lex_state = 0},
  [12081] = {.lex_state = 0},
  [12082] = {.lex_state = 0},
  [12083] = {.lex_state = 0},
  [12084] = {.lex_state = 0},
  [12085] = {.lex_state = 0},
  [12086] = {.lex_state = 0},
  [12087] = {.lex_state = 0},
  [12088] = {.lex_state = 0},
  [12089] = {.lex_state = 0},
  [12090] = {.lex_state = 0},
  [12091] = {.lex_state = 0},
  [12092] = {.lex_state = 35},
  [12093] = {.lex_state = 35},
  [12094] = {.lex_state = 0},
  [12095] = {.lex_state = 0},
  [12096] = {.lex_state = 0},
  [12097] = {.lex_state = 0},
  [12098] = {.lex_state = 0},
  [12099] = {.lex_state = 35},
  [12100] = {.lex_state = 0},
  [12101] = {.lex_state = 35},
  [12102] = {.lex_state = 0},
  [12103] = {.lex_state = 0},
  [12104] = {.lex_state = 0},
  [12105] = {.lex_state = 0},
  [12106] = {.lex_state = 0},
  [12107] = {.lex_state = 35},
  [12108] = {.lex_state = 35},
  [12109] = {.lex_state = 0},
  [12110] = {.lex_state = 0},
  [12111] = {.lex_state = 0},
  [12112] = {.lex_state = 0},
  [12113] = {.lex_state = 0},
  [12114] = {.lex_state = 0},
  [12115] = {.lex_state = 0},
  [12116] = {.lex_state = 0},
  [12117] = {.lex_state = 0},
  [12118] = {.lex_state = 0},
  [12119] = {.lex_state = 0},
  [12120] = {.lex_state = 35},
  [12121] = {.lex_state = 0},
  [12122] = {.lex_state = 0},
  [12123] = {.lex_state = 0},
  [12124] = {.lex_state = 0},
  [12125] = {.lex_state = 0},
  [12126] = {.lex_state = 0},
  [12127] = {.lex_state = 0},
  [12128] = {.lex_state = 35},
  [12129] = {.lex_state = 35},
  [12130] = {.lex_state = 0},
  [12131] = {.lex_state = 0},
  [12132] = {.lex_state = 35},
  [12133] = {.lex_state = 0},
  [12134] = {.lex_state = 0},
  [12135] = {.lex_state = 0},
  [12136] = {.lex_state = 35},
  [12137] = {.lex_state = 35},
  [12138] = {.lex_state = 35},
  [12139] = {.lex_state = 0},
  [12140] = {.lex_state = 35},
  [12141] = {.lex_state = 35},
  [12142] = {.lex_state = 0},
  [12143] = {.lex_state = 0},
  [12144] = {.lex_state = 0},
  [12145] = {.lex_state = 0},
  [12146] = {.lex_state = 0},
  [12147] = {.lex_state = 0},
  [12148] = {.lex_state = 0},
  [12149] = {.lex_state = 0},
  [12150] = {.lex_state = 0},
  [12151] = {.lex_state = 0},
  [12152] = {.lex_state = 0},
  [12153] = {.lex_state = 0},
  [12154] = {.lex_state = 0},
  [12155] = {.lex_state = 0},
  [12156] = {.lex_state = 35},
  [12157] = {.lex_state = 0},
  [12158] = {.lex_state = 0},
  [12159] = {.lex_state = 0},
  [12160] = {.lex_state = 0},
  [12161] = {.lex_state = 0},
  [12162] = {.lex_state = 0},
  [12163] = {.lex_state = 0},
  [12164] = {.lex_state = 0},
  [12165] = {.lex_state = 0},
  [12166] = {.lex_state = 0},
  [12167] = {.lex_state = 35},
  [12168] = {.lex_state = 0},
  [12169] = {.lex_state = 0},
  [12170] = {.lex_state = 0},
  [12171] = {.lex_state = 0},
  [12172] = {.lex_state = 0},
  [12173] = {.lex_state = 0},
  [12174] = {.lex_state = 0},
  [12175] = {.lex_state = 0},
  [12176] = {.lex_state = 0},
  [12177] = {.lex_state = 0},
  [12178] = {.lex_state = 0},
  [12179] = {.lex_state = 0},
  [12180] = {.lex_state = 0},
  [12181] = {.lex_state = 0},
  [12182] = {.lex_state = 0},
  [12183] = {.lex_state = 0},
  [12184] = {.lex_state = 0},
  [12185] = {.lex_state = 0},
  [12186] = {.lex_state = 0},
  [12187] = {.lex_state = 0},
  [12188] = {.lex_state = 0},
  [12189] = {.lex_state = 0},
  [12190] = {.lex_state = 0},
  [12191] = {.lex_state = 0},
  [12192] = {.lex_state = 0},
  [12193] = {.lex_state = 0},
  [12194] = {.lex_state = 0},
  [12195] = {.lex_state = 0},
  [12196] = {.lex_state = 0},
  [12197] = {.lex_state = 35},
  [12198] = {.lex_state = 0},
  [12199] = {.lex_state = 0},
  [12200] = {.lex_state = 0},
  [12201] = {.lex_state = 0},
  [12202] = {.lex_state = 0},
  [12203] = {.lex_state = 0},
  [12204] = {.lex_state = 0},
  [12205] = {.lex_state = 0},
  [12206] = {.lex_state = 35},
  [12207] = {.lex_state = 0},
  [12208] = {.lex_state = 0},
  [12209] = {.lex_state = 0},
  [12210] = {.lex_state = 35},
  [12211] = {.lex_state = 35},
  [12212] = {.lex_state = 0},
  [12213] = {.lex_state = 35},
  [12214] = {.lex_state = 0},
  [12215] = {.lex_state = 0},
  [12216] = {.lex_state = 35},
  [12217] = {.lex_state = 0},
  [12218] = {.lex_state = 0},
  [12219] = {.lex_state = 0},
  [12220] = {.lex_state = 0},
  [12221] = {.lex_state = 0},
  [12222] = {.lex_state = 0},
  [12223] = {.lex_state = 0},
  [12224] = {.lex_state = 0},
  [12225] = {.lex_state = 0},
  [12226] = {.lex_state = 0},
  [12227] = {.lex_state = 0},
  [12228] = {.lex_state = 35},
  [12229] = {.lex_state = 35},
  [12230] = {.lex_state = 0},
  [12231] = {.lex_state = 0},
  [12232] = {.lex_state = 0},
  [12233] = {.lex_state = 0},
  [12234] = {.lex_state = 0},
  [12235] = {.lex_state = 0},
  [12236] = {.lex_state = 0},
  [12237] = {.lex_state = 0},
  [12238] = {.lex_state = 0},
  [12239] = {.lex_state = 0},
  [12240] = {.lex_state = 0},
  [12241] = {.lex_state = 0},
  [12242] = {.lex_state = 0},
  [12243] = {.lex_state = 0},
  [12244] = {.lex_state = 35},
  [12245] = {.lex_state = 0},
  [12246] = {.lex_state = 0},
  [12247] = {.lex_state = 0},
  [12248] = {.lex_state = 0},
  [12249] = {.lex_state = 0},
  [12250] = {.lex_state = 0},
  [12251] = {.lex_state = 0},
  [12252] = {.lex_state = 0},
  [12253] = {.lex_state = 0},
  [12254] = {.lex_state = 0},
  [12255] = {.lex_state = 0},
  [12256] = {.lex_state = 35},
  [12257] = {.lex_state = 0},
  [12258] = {.lex_state = 35},
  [12259] = {.lex_state = 35},
  [12260] = {.lex_state = 0},
  [12261] = {.lex_state = 0},
  [12262] = {.lex_state = 0},
  [12263] = {.lex_state = 0},
  [12264] = {.lex_state = 0},
  [12265] = {.lex_state = 0},
  [12266] = {.lex_state = 0},
  [12267] = {.lex_state = 0},
  [12268] = {.lex_state = 0},
  [12269] = {.lex_state = 0},
  [12270] = {.lex_state = 0},
  [12271] = {.lex_state = 0},
  [12272] = {.lex_state = 0},
  [12273] = {.lex_state = 0},
  [12274] = {.lex_state = 0},
  [12275] = {.lex_state = 35},
  [12276] = {.lex_state = 0},
  [12277] = {.lex_state = 0},
  [12278] = {.lex_state = 0},
  [12279] = {.lex_state = 0},
  [12280] = {.lex_state = 0},
  [12281] = {.lex_state = 35},
  [12282] = {.lex_state = 0},
  [12283] = {.lex_state = 0},
  [12284] = {.lex_state = 35},
  [12285] = {.lex_state = 35},
  [12286] = {.lex_state = 0},
  [12287] = {.lex_state = 0},
  [12288] = {.lex_state = 0},
  [12289] = {.lex_state = 0},
  [12290] = {.lex_state = 0},
  [12291] = {.lex_state = 0},
  [12292] = {.lex_state = 0},
  [12293] = {.lex_state = 35},
  [12294] = {.lex_state = 0},
  [12295] = {.lex_state = 0},
  [12296] = {.lex_state = 0},
  [12297] = {.lex_state = 35},
  [12298] = {.lex_state = 35},
  [12299] = {.lex_state = 35},
  [12300] = {.lex_state = 35},
  [12301] = {.lex_state = 0},
  [12302] = {.lex_state = 0},
  [12303] = {.lex_state = 0},
  [12304] = {.lex_state = 35},
  [12305] = {.lex_state = 0},
  [12306] = {.lex_state = 0},
  [12307] = {.lex_state = 0},
  [12308] = {.lex_state = 0},
  [12309] = {.lex_state = 0},
  [12310] = {.lex_state = 35},
  [12311] = {.lex_state = 35},
  [12312] = {.lex_state = 0},
  [12313] = {.lex_state = 0},
  [12314] = {.lex_state = 0},
  [12315] = {.lex_state = 0},
  [12316] = {.lex_state = 0},
  [12317] = {.lex_state = 0},
  [12318] = {.lex_state = 0},
  [12319] = {.lex_state = 0},
  [12320] = {.lex_state = 0},
  [12321] = {.lex_state = 0},
  [12322] = {.lex_state = 0},
  [12323] = {.lex_state = 0},
  [12324] = {.lex_state = 0},
  [12325] = {.lex_state = 0},
  [12326] = {.lex_state = 35},
  [12327] = {.lex_state = 0},
  [12328] = {.lex_state = 0},
  [12329] = {.lex_state = 0},
  [12330] = {.lex_state = 0},
  [12331] = {.lex_state = 0},
  [12332] = {.lex_state = 0},
  [12333] = {.lex_state = 0},
  [12334] = {.lex_state = 0},
  [12335] = {.lex_state = 0},
  [12336] = {.lex_state = 0},
  [12337] = {.lex_state = 0},
  [12338] = {.lex_state = 0},
  [12339] = {.lex_state = 0},
  [12340] = {.lex_state = 0},
  [12341] = {.lex_state = 0},
  [12342] = {.lex_state = 0},
  [12343] = {.lex_state = 0},
  [12344] = {.lex_state = 0},
  [12345] = {.lex_state = 0},
  [12346] = {.lex_state = 0},
  [12347] = {.lex_state = 0},
  [12348] = {.lex_state = 0},
  [12349] = {.lex_state = 0},
  [12350] = {.lex_state = 0},
  [12351] = {.lex_state = 0},
  [12352] = {.lex_state = 35},
  [12353] = {.lex_state = 0},
  [12354] = {.lex_state = 0},
  [12355] = {.lex_state = 0},
  [12356] = {.lex_state = 0},
  [12357] = {.lex_state = 0},
  [12358] = {.lex_state = 0},
  [12359] = {.lex_state = 0},
  [12360] = {.lex_state = 0},
  [12361] = {.lex_state = 0},
  [12362] = {.lex_state = 0},
  [12363] = {.lex_state = 0},
  [12364] = {.lex_state = 0},
  [12365] = {.lex_state = 0},
  [12366] = {.lex_state = 35},
  [12367] = {.lex_state = 0},
  [12368] = {.lex_state = 0},
  [12369] = {.lex_state = 0},
  [12370] = {.lex_state = 0},
  [12371] = {.lex_state = 0},
  [12372] = {.lex_state = 35},
  [12373] = {.lex_state = 0},
  [12374] = {.lex_state = 0},
  [12375] = {.lex_state = 35},
  [12376] = {.lex_state = 0},
  [12377] = {.lex_state = 0},
  [12378] = {.lex_state = 35},
  [12379] = {.lex_state = 35},
  [12380] = {.lex_state = 35},
  [12381] = {.lex_state = 0},
  [12382] = {.lex_state = 0},
  [12383] = {.lex_state = 0},
  [12384] = {.lex_state = 0},
  [12385] = {.lex_state = 0},
  [12386] = {.lex_state = 0},
  [12387] = {.lex_state = 0},
  [12388] = {.lex_state = 35},
  [12389] = {.lex_state = 35},
  [12390] = {.lex_state = 0},
  [12391] = {.lex_state = 0},
  [12392] = {.lex_state = 35},
  [12393] = {.lex_state = 0},
  [12394] = {.lex_state = 35},
  [12395] = {.lex_state = 0},
  [12396] = {.lex_state = 0},
  [12397] = {.lex_state = 0},
  [12398] = {.lex_state = 0},
  [12399] = {.lex_state = 0},
  [12400] = {.lex_state = 0},
  [12401] = {.lex_state = 0},
  [12402] = {.lex_state = 0},
  [12403] = {.lex_state = 0},
  [12404] = {.lex_state = 0},
  [12405] = {.lex_state = 35},
  [12406] = {.lex_state = 0},
  [12407] = {.lex_state = 0},
  [12408] = {.lex_state = 0},
  [12409] = {.lex_state = 0},
  [12410] = {.lex_state = 0},
  [12411] = {.lex_state = 0},
  [12412] = {.lex_state = 0},
  [12413] = {.lex_state = 0},
  [12414] = {.lex_state = 0},
  [12415] = {.lex_state = 0},
  [12416] = {.lex_state = 0},
  [12417] = {.lex_state = 0},
  [12418] = {.lex_state = 35},
  [12419] = {.lex_state = 0},
  [12420] = {.lex_state = 0},
  [12421] = {.lex_state = 0},
  [12422] = {.lex_state = 0},
  [12423] = {.lex_state = 0},
  [12424] = {.lex_state = 0},
  [12425] = {.lex_state = 0},
  [12426] = {.lex_state = 0},
  [12427] = {.lex_state = 0},
  [12428] = {.lex_state = 0},
  [12429] = {.lex_state = 0},
  [12430] = {.lex_state = 0},
  [12431] = {.lex_state = 0},
  [12432] = {.lex_state = 0},
  [12433] = {.lex_state = 35},
  [12434] = {.lex_state = 0},
  [12435] = {.lex_state = 0},
  [12436] = {.lex_state = 0},
  [12437] = {.lex_state = 0},
  [12438] = {.lex_state = 0},
  [12439] = {.lex_state = 0},
  [12440] = {.lex_state = 0},
  [12441] = {.lex_state = 0},
  [12442] = {.lex_state = 0},
  [12443] = {.lex_state = 0},
  [12444] = {.lex_state = 0},
  [12445] = {.lex_state = 0},
  [12446] = {.lex_state = 0},
  [12447] = {.lex_state = 0},
  [12448] = {.lex_state = 0},
  [12449] = {.lex_state = 0},
  [12450] = {.lex_state = 0},
  [12451] = {.lex_state = 0},
  [12452] = {.lex_state = 0},
  [12453] = {.lex_state = 35},
  [12454] = {.lex_state = 0},
  [12455] = {.lex_state = 0},
  [12456] = {.lex_state = 0},
  [12457] = {.lex_state = 0},
  [12458] = {.lex_state = 35},
  [12459] = {.lex_state = 0},
  [12460] = {.lex_state = 0},
  [12461] = {.lex_state = 35},
  [12462] = {.lex_state = 0},
  [12463] = {.lex_state = 35},
  [12464] = {.lex_state = 35},
  [12465] = {.lex_state = 0},
  [12466] = {.lex_state = 0},
  [12467] = {.lex_state = 0},
  [12468] = {.lex_state = 0},
  [12469] = {.lex_state = 0},
  [12470] = {.lex_state = 0},
  [12471] = {.lex_state = 0},
  [12472] = {.lex_state = 0},
  [12473] = {.lex_state = 0},
  [12474] = {.lex_state = 0},
  [12475] = {.lex_state = 0},
  [12476] = {.lex_state = 0},
  [12477] = {.lex_state = 35},
  [12478] = {.lex_state = 0},
  [12479] = {.lex_state = 0},
  [12480] = {.lex_state = 0},
  [12481] = {.lex_state = 0},
  [12482] = {.lex_state = 0},
  [12483] = {.lex_state = 0},
  [12484] = {.lex_state = 0},
  [12485] = {.lex_state = 0},
  [12486] = {.lex_state = 0},
  [12487] = {.lex_state = 0},
  [12488] = {.lex_state = 0},
  [12489] = {.lex_state = 0},
  [12490] = {.lex_state = 0},
  [12491] = {.lex_state = 35},
  [12492] = {.lex_state = 0},
  [12493] = {.lex_state = 0},
  [12494] = {.lex_state = 0},
  [12495] = {.lex_state = 0},
  [12496] = {.lex_state = 0},
  [12497] = {.lex_state = 0},
  [12498] = {.lex_state = 0},
  [12499] = {.lex_state = 0},
  [12500] = {.lex_state = 0},
  [12501] = {.lex_state = 0},
  [12502] = {.lex_state = 0},
  [12503] = {.lex_state = 0},
  [12504] = {.lex_state = 0},
  [12505] = {.lex_state = 0},
  [12506] = {.lex_state = 0},
  [12507] = {.lex_state = 0},
  [12508] = {.lex_state = 0},
  [12509] = {.lex_state = 0},
  [12510] = {.lex_state = 0},
  [12511] = {.lex_state = 0},
  [12512] = {.lex_state = 0},
  [12513] = {.lex_state = 0},
  [12514] = {.lex_state = 0},
  [12515] = {.lex_state = 0},
  [12516] = {.lex_state = 0},
  [12517] = {.lex_state = 0},
  [12518] = {.lex_state = 0},
  [12519] = {.lex_state = 0},
  [12520] = {.lex_state = 0},
  [12521] = {.lex_state = 0},
  [12522] = {.lex_state = 0},
  [12523] = {.lex_state = 0},
  [12524] = {.lex_state = 0},
  [12525] = {.lex_state = 0},
  [12526] = {.lex_state = 0},
  [12527] = {.lex_state = 0},
  [12528] = {.lex_state = 0},
  [12529] = {.lex_state = 0},
  [12530] = {.lex_state = 0},
  [12531] = {.lex_state = 0},
  [12532] = {.lex_state = 0},
  [12533] = {.lex_state = 35},
  [12534] = {.lex_state = 35},
  [12535] = {.lex_state = 0},
  [12536] = {.lex_state = 0},
  [12537] = {.lex_state = 35},
  [12538] = {.lex_state = 0},
  [12539] = {.lex_state = 0},
  [12540] = {.lex_state = 0},
  [12541] = {.lex_state = 0},
  [12542] = {.lex_state = 0},
  [12543] = {.lex_state = 0},
  [12544] = {.lex_state = 0},
  [12545] = {.lex_state = 0},
  [12546] = {.lex_state = 0},
  [12547] = {.lex_state = 0},
  [12548] = {.lex_state = 0},
  [12549] = {.lex_state = 35},
  [12550] = {.lex_state = 0},
  [12551] = {.lex_state = 0},
  [12552] = {.lex_state = 0},
  [12553] = {.lex_state = 0},
  [12554] = {.lex_state = 0},
  [12555] = {.lex_state = 0},
  [12556] = {.lex_state = 0},
  [12557] = {.lex_state = 0},
  [12558] = {.lex_state = 0},
  [12559] = {.lex_state = 0},
  [12560] = {.lex_state = 0},
  [12561] = {.lex_state = 35},
  [12562] = {.lex_state = 0},
  [12563] = {.lex_state = 0},
  [12564] = {.lex_state = 0},
  [12565] = {.lex_state = 35},
  [12566] = {.lex_state = 0},
  [12567] = {.lex_state = 0},
  [12568] = {.lex_state = 0},
  [12569] = {.lex_state = 0},
  [12570] = {.lex_state = 0},
  [12571] = {.lex_state = 0},
  [12572] = {.lex_state = 0},
  [12573] = {.lex_state = 0},
  [12574] = {.lex_state = 0},
  [12575] = {.lex_state = 0},
  [12576] = {.lex_state = 35},
  [12577] = {.lex_state = 0},
  [12578] = {.lex_state = 0},
  [12579] = {.lex_state = 35},
  [12580] = {.lex_state = 0},
  [12581] = {.lex_state = 0},
  [12582] = {.lex_state = 0},
  [12583] = {.lex_state = 0},
  [12584] = {.lex_state = 0},
  [12585] = {.lex_state = 0},
  [12586] = {.lex_state = 0},
  [12587] = {.lex_state = 0},
  [12588] = {.lex_state = 0},
  [12589] = {.lex_state = 0},
  [12590] = {.lex_state = 0},
  [12591] = {.lex_state = 0},
  [12592] = {.lex_state = 35},
  [12593] = {.lex_state = 0},
  [12594] = {.lex_state = 0},
  [12595] = {.lex_state = 0},
  [12596] = {.lex_state = 0},
  [12597] = {.lex_state = 0},
  [12598] = {.lex_state = 0},
  [12599] = {.lex_state = 0},
  [12600] = {.lex_state = 0},
  [12601] = {.lex_state = 35},
  [12602] = {.lex_state = 35},
  [12603] = {.lex_state = 0},
  [12604] = {.lex_state = 0},
  [12605] = {.lex_state = 0},
  [12606] = {.lex_state = 0},
  [12607] = {.lex_state = 0},
  [12608] = {.lex_state = 0},
  [12609] = {.lex_state = 0},
  [12610] = {.lex_state = 0},
  [12611] = {.lex_state = 0},
  [12612] = {.lex_state = 0},
  [12613] = {.lex_state = 0},
  [12614] = {.lex_state = 0},
  [12615] = {.lex_state = 0},
  [12616] = {.lex_state = 0},
  [12617] = {.lex_state = 0},
  [12618] = {.lex_state = 0},
  [12619] = {.lex_state = 0},
  [12620] = {.lex_state = 35},
  [12621] = {.lex_state = 0},
  [12622] = {.lex_state = 0},
  [12623] = {.lex_state = 0},
  [12624] = {.lex_state = 0},
  [12625] = {.lex_state = 0},
  [12626] = {.lex_state = 0},
  [12627] = {.lex_state = 0},
  [12628] = {.lex_state = 0},
  [12629] = {.lex_state = 0},
  [12630] = {.lex_state = 35},
  [12631] = {.lex_state = 0},
  [12632] = {.lex_state = 0},
  [12633] = {.lex_state = 0},
  [12634] = {.lex_state = 0},
  [12635] = {.lex_state = 0},
  [12636] = {.lex_state = 0},
  [12637] = {.lex_state = 0},
  [12638] = {.lex_state = 0},
  [12639] = {.lex_state = 0},
  [12640] = {.lex_state = 0},
  [12641] = {.lex_state = 0},
  [12642] = {.lex_state = 0},
  [12643] = {.lex_state = 0},
  [12644] = {.lex_state = 0},
  [12645] = {.lex_state = 0},
  [12646] = {.lex_state = 0},
  [12647] = {.lex_state = 0},
  [12648] = {.lex_state = 0},
  [12649] = {.lex_state = 0},
  [12650] = {.lex_state = 35},
  [12651] = {.lex_state = 0},
  [12652] = {.lex_state = 0},
  [12653] = {.lex_state = 0},
  [12654] = {.lex_state = 0},
  [12655] = {.lex_state = 0},
  [12656] = {.lex_state = 35},
  [12657] = {.lex_state = 0},
  [12658] = {.lex_state = 0},
  [12659] = {.lex_state = 0},
  [12660] = {.lex_state = 0},
  [12661] = {.lex_state = 0},
  [12662] = {.lex_state = 0},
  [12663] = {.lex_state = 0},
  [12664] = {.lex_state = 0},
  [12665] = {.lex_state = 0},
  [12666] = {.lex_state = 0},
  [12667] = {.lex_state = 0},
  [12668] = {.lex_state = 0},
  [12669] = {.lex_state = 0},
  [12670] = {.lex_state = 0},
  [12671] = {.lex_state = 0},
  [12672] = {.lex_state = 0},
  [12673] = {.lex_state = 0},
  [12674] = {.lex_state = 0},
  [12675] = {.lex_state = 0},
  [12676] = {.lex_state = 0},
  [12677] = {.lex_state = 0},
  [12678] = {.lex_state = 0},
  [12679] = {.lex_state = 35},
  [12680] = {.lex_state = 0},
  [12681] = {.lex_state = 0},
  [12682] = {.lex_state = 0},
  [12683] = {.lex_state = 0},
  [12684] = {.lex_state = 0},
  [12685] = {.lex_state = 0},
  [12686] = {.lex_state = 0},
  [12687] = {.lex_state = 0},
  [12688] = {.lex_state = 0},
  [12689] = {.lex_state = 0},
  [12690] = {.lex_state = 0},
  [12691] = {.lex_state = 0},
  [12692] = {.lex_state = 0},
  [12693] = {.lex_state = 35},
  [12694] = {.lex_state = 0},
  [12695] = {.lex_state = 0},
  [12696] = {.lex_state = 0},
  [12697] = {.lex_state = 0},
  [12698] = {.lex_state = 0},
  [12699] = {.lex_state = 0},
  [12700] = {.lex_state = 0},
  [12701] = {.lex_state = 35},
  [12702] = {.lex_state = 35},
  [12703] = {.lex_state = 35},
  [12704] = {.lex_state = 0},
  [12705] = {.lex_state = 0},
  [12706] = {.lex_state = 0},
  [12707] = {.lex_state = 0},
  [12708] = {.lex_state = 0},
  [12709] = {.lex_state = 35},
  [12710] = {.lex_state = 0},
  [12711] = {.lex_state = 0},
  [12712] = {.lex_state = 0},
  [12713] = {.lex_state = 35},
  [12714] = {.lex_state = 0},
  [12715] = {.lex_state = 0},
  [12716] = {.lex_state = 0},
  [12717] = {.lex_state = 0},
  [12718] = {.lex_state = 0},
  [12719] = {.lex_state = 0},
  [12720] = {.lex_state = 0},
  [12721] = {.lex_state = 0},
  [12722] = {.lex_state = 0},
  [12723] = {.lex_state = 0},
  [12724] = {.lex_state = 0},
  [12725] = {.lex_state = 0},
  [12726] = {.lex_state = 0},
  [12727] = {.lex_state = 35},
  [12728] = {.lex_state = 0},
  [12729] = {.lex_state = 0},
  [12730] = {.lex_state = 0},
  [12731] = {.lex_state = 0},
  [12732] = {.lex_state = 0},
  [12733] = {.lex_state = 0},
  [12734] = {.lex_state = 0},
  [12735] = {.lex_state = 0},
  [12736] = {.lex_state = 0},
  [12737] = {.lex_state = 0},
  [12738] = {.lex_state = 35},
  [12739] = {.lex_state = 0},
  [12740] = {.lex_state = 0},
  [12741] = {.lex_state = 0},
  [12742] = {.lex_state = 0},
  [12743] = {.lex_state = 0},
  [12744] = {.lex_state = 0},
  [12745] = {.lex_state = 0},
  [12746] = {.lex_state = 0},
  [12747] = {.lex_state = 0},
  [12748] = {.lex_state = 35},
  [12749] = {.lex_state = 35},
  [12750] = {.lex_state = 35},
  [12751] = {.lex_state = 35},
  [12752] = {.lex_state = 0},
  [12753] = {.lex_state = 0},
  [12754] = {.lex_state = 0},
  [12755] = {.lex_state = 0},
  [12756] = {.lex_state = 0},
  [12757] = {.lex_state = 0},
  [12758] = {.lex_state = 0},
  [12759] = {.lex_state = 0},
  [12760] = {.lex_state = 35},
  [12761] = {.lex_state = 0},
  [12762] = {.lex_state = 0},
  [12763] = {.lex_state = 0},
  [12764] = {.lex_state = 0},
  [12765] = {.lex_state = 0},
  [12766] = {.lex_state = 0},
  [12767] = {.lex_state = 35},
  [12768] = {.lex_state = 0},
  [12769] = {.lex_state = 0},
  [12770] = {.lex_state = 0},
  [12771] = {.lex_state = 0},
  [12772] = {.lex_state = 0},
  [12773] = {.lex_state = 0},
  [12774] = {.lex_state = 0},
  [12775] = {.lex_state = 0},
  [12776] = {.lex_state = 35},
  [12777] = {.lex_state = 0},
  [12778] = {.lex_state = 35},
  [12779] = {.lex_state = 35},
  [12780] = {.lex_state = 0},
  [12781] = {.lex_state = 35},
  [12782] = {.lex_state = 35},
  [12783] = {.lex_state = 35},
  [12784] = {.lex_state = 35},
  [12785] = {.lex_state = 0},
  [12786] = {.lex_state = 35},
  [12787] = {.lex_state = 0},
  [12788] = {.lex_state = 0},
  [12789] = {.lex_state = 0},
  [12790] = {.lex_state = 0},
  [12791] = {.lex_state = 0},
  [12792] = {.lex_state = 0},
  [12793] = {.lex_state = 0},
  [12794] = {.lex_state = 0},
  [12795] = {.lex_state = 0},
  [12796] = {.lex_state = 0},
  [12797] = {.lex_state = 35},
  [12798] = {.lex_state = 0},
  [12799] = {.lex_state = 0},
  [12800] = {.lex_state = 0},
  [12801] = {.lex_state = 0},
  [12802] = {.lex_state = 0},
  [12803] = {.lex_state = 0},
  [12804] = {.lex_state = 0},
  [12805] = {.lex_state = 0},
  [12806] = {.lex_state = 0},
  [12807] = {.lex_state = 0},
  [12808] = {.lex_state = 0},
  [12809] = {.lex_state = 35},
  [12810] = {.lex_state = 0},
  [12811] = {.lex_state = 0},
  [12812] = {.lex_state = 0},
  [12813] = {.lex_state = 0},
  [12814] = {.lex_state = 0},
  [12815] = {.lex_state = 0},
  [12816] = {.lex_state = 0},
  [12817] = {.lex_state = 0},
  [12818] = {.lex_state = 35},
  [12819] = {.lex_state = 35},
  [12820] = {.lex_state = 0},
  [12821] = {.lex_state = 0},
  [12822] = {.lex_state = 0},
  [12823] = {.lex_state = 0},
  [12824] = {.lex_state = 0},
  [12825] = {.lex_state = 0},
  [12826] = {.lex_state = 0},
  [12827] = {.lex_state = 0},
  [12828] = {.lex_state = 0},
  [12829] = {.lex_state = 0},
  [12830] = {.lex_state = 0},
  [12831] = {.lex_state = 0},
  [12832] = {.lex_state = 0},
  [12833] = {.lex_state = 35},
  [12834] = {.lex_state = 0},
  [12835] = {.lex_state = 0},
  [12836] = {.lex_state = 0},
  [12837] = {.lex_state = 0},
  [12838] = {.lex_state = 0},
  [12839] = {.lex_state = 0},
  [12840] = {.lex_state = 0},
  [12841] = {.lex_state = 0},
  [12842] = {.lex_state = 0},
  [12843] = {.lex_state = 0},
  [12844] = {.lex_state = 0},
  [12845] = {.lex_state = 0},
  [12846] = {.lex_state = 0},
  [12847] = {.lex_state = 0},
  [12848] = {.lex_state = 0},
  [12849] = {.lex_state = 0},
  [12850] = {.lex_state = 0},
  [12851] = {.lex_state = 0},
  [12852] = {.lex_state = 0},
  [12853] = {.lex_state = 0},
  [12854] = {.lex_state = 0},
  [12855] = {.lex_state = 0},
  [12856] = {.lex_state = 35},
  [12857] = {.lex_state = 0},
  [12858] = {.lex_state = 0},
  [12859] = {.lex_state = 0},
  [12860] = {.lex_state = 0},
  [12861] = {.lex_state = 0},
  [12862] = {.lex_state = 0},
  [12863] = {.lex_state = 0},
  [12864] = {.lex_state = 0},
  [12865] = {.lex_state = 0},
  [12866] = {.lex_state = 0},
  [12867] = {.lex_state = 0},
  [12868] = {.lex_state = 0},
  [12869] = {.lex_state = 0},
  [12870] = {.lex_state = 0},
  [12871] = {.lex_state = 0},
  [12872] = {.lex_state = 0},
  [12873] = {.lex_state = 0},
  [12874] = {.lex_state = 0},
  [12875] = {.lex_state = 0},
  [12876] = {.lex_state = 0},
  [12877] = {.lex_state = 35},
  [12878] = {.lex_state = 0},
  [12879] = {.lex_state = 0},
  [12880] = {.lex_state = 35},
  [12881] = {.lex_state = 0},
  [12882] = {.lex_state = 0},
  [12883] = {.lex_state = 0},
  [12884] = {.lex_state = 0},
  [12885] = {.lex_state = 0},
  [12886] = {.lex_state = 35},
  [12887] = {.lex_state = 0},
  [12888] = {.lex_state = 0},
  [12889] = {.lex_state = 0},
  [12890] = {.lex_state = 0},
  [12891] = {.lex_state = 0},
  [12892] = {.lex_state = 0},
  [12893] = {.lex_state = 0},
  [12894] = {.lex_state = 0},
  [12895] = {.lex_state = 35},
  [12896] = {.lex_state = 35},
  [12897] = {.lex_state = 35},
  [12898] = {.lex_state = 0},
  [12899] = {.lex_state = 0},
  [12900] = {.lex_state = 0},
  [12901] = {.lex_state = 0},
  [12902] = {.lex_state = 35},
  [12903] = {.lex_state = 35},
  [12904] = {.lex_state = 35},
  [12905] = {.lex_state = 0},
  [12906] = {.lex_state = 0},
  [12907] = {.lex_state = 0},
  [12908] = {.lex_state = 0},
  [12909] = {.lex_state = 0},
  [12910] = {.lex_state = 0},
  [12911] = {.lex_state = 0},
  [12912] = {.lex_state = 0},
  [12913] = {.lex_state = 35},
  [12914] = {.lex_state = 0},
  [12915] = {.lex_state = 35},
  [12916] = {.lex_state = 0},
  [12917] = {.lex_state = 0},
  [12918] = {.lex_state = 0},
  [12919] = {.lex_state = 0},
  [12920] = {.lex_state = 0},
  [12921] = {.lex_state = 0},
  [12922] = {.lex_state = 0},
  [12923] = {.lex_state = 0},
  [12924] = {.lex_state = 0},
  [12925] = {.lex_state = 0},
  [12926] = {.lex_state = 0},
  [12927] = {.lex_state = 35},
  [12928] = {.lex_state = 0},
  [12929] = {.lex_state = 0},
  [12930] = {.lex_state = 0},
  [12931] = {.lex_state = 0},
  [12932] = {.lex_state = 0},
  [12933] = {.lex_state = 0},
  [12934] = {.lex_state = 0},
  [12935] = {.lex_state = 0},
  [12936] = {.lex_state = 0},
  [12937] = {.lex_state = 0},
  [12938] = {.lex_state = 0},
  [12939] = {.lex_state = 0},
  [12940] = {.lex_state = 0},
  [12941] = {.lex_state = 0},
  [12942] = {.lex_state = 0},
  [12943] = {.lex_state = 0},
  [12944] = {.lex_state = 0},
  [12945] = {.lex_state = 33},
  [12946] = {.lex_state = 0},
  [12947] = {.lex_state = 0},
  [12948] = {.lex_state = 0},
  [12949] = {.lex_state = 0},
  [12950] = {.lex_state = 0},
  [12951] = {.lex_state = 0},
  [12952] = {.lex_state = 0},
  [12953] = {.lex_state = 0},
  [12954] = {.lex_state = 0},
  [12955] = {.lex_state = 0},
  [12956] = {.lex_state = 35},
  [12957] = {.lex_state = 0},
  [12958] = {.lex_state = 0},
  [12959] = {.lex_state = 0},
  [12960] = {.lex_state = 0},
  [12961] = {.lex_state = 0},
  [12962] = {.lex_state = 0},
  [12963] = {.lex_state = 0},
  [12964] = {.lex_state = 0},
  [12965] = {.lex_state = 0},
  [12966] = {.lex_state = 0},
  [12967] = {.lex_state = 0},
  [12968] = {.lex_state = 0},
  [12969] = {.lex_state = 0},
  [12970] = {.lex_state = 0},
  [12971] = {.lex_state = 0},
  [12972] = {.lex_state = 35},
  [12973] = {.lex_state = 0},
  [12974] = {.lex_state = 35},
  [12975] = {.lex_state = 0},
  [12976] = {.lex_state = 0},
  [12977] = {.lex_state = 0},
  [12978] = {.lex_state = 0},
  [12979] = {.lex_state = 0},
  [12980] = {.lex_state = 0},
  [12981] = {.lex_state = 0},
  [12982] = {.lex_state = 0},
  [12983] = {.lex_state = 0},
  [12984] = {.lex_state = 35},
  [12985] = {.lex_state = 0},
  [12986] = {.lex_state = 0},
  [12987] = {.lex_state = 35},
  [12988] = {.lex_state = 0},
  [12989] = {.lex_state = 0},
  [12990] = {.lex_state = 0},
  [12991] = {.lex_state = 0},
  [12992] = {.lex_state = 0},
  [12993] = {.lex_state = 0},
  [12994] = {.lex_state = 0},
  [12995] = {.lex_state = 35},
  [12996] = {.lex_state = 0},
  [12997] = {.lex_state = 35},
  [12998] = {.lex_state = 0},
  [12999] = {.lex_state = 0},
  [13000] = {.lex_state = 0},
  [13001] = {.lex_state = 0},
  [13002] = {.lex_state = 0},
  [13003] = {.lex_state = 0},
  [13004] = {.lex_state = 35},
  [13005] = {.lex_state = 0},
  [13006] = {.lex_state = 0},
  [13007] = {.lex_state = 0},
  [13008] = {.lex_state = 0},
  [13009] = {.lex_state = 0},
  [13010] = {.lex_state = 35},
  [13011] = {.lex_state = 0},
  [13012] = {.lex_state = 0},
  [13013] = {.lex_state = 35},
  [13014] = {.lex_state = 0},
  [13015] = {.lex_state = 0},
  [13016] = {.lex_state = 0},
  [13017] = {.lex_state = 0},
  [13018] = {.lex_state = 0},
  [13019] = {.lex_state = 0},
  [13020] = {.lex_state = 0},
  [13021] = {.lex_state = 0},
  [13022] = {.lex_state = 35},
  [13023] = {.lex_state = 0},
  [13024] = {.lex_state = 0},
  [13025] = {.lex_state = 0},
  [13026] = {.lex_state = 0},
  [13027] = {.lex_state = 0},
  [13028] = {.lex_state = 0},
  [13029] = {.lex_state = 0},
  [13030] = {.lex_state = 0},
  [13031] = {.lex_state = 35},
  [13032] = {.lex_state = 0},
  [13033] = {.lex_state = 35},
  [13034] = {.lex_state = 0},
  [13035] = {.lex_state = 0},
  [13036] = {.lex_state = 0},
  [13037] = {.lex_state = 0},
  [13038] = {.lex_state = 0},
  [13039] = {.lex_state = 0},
  [13040] = {.lex_state = 0},
  [13041] = {.lex_state = 0},
  [13042] = {.lex_state = 0},
  [13043] = {.lex_state = 0},
  [13044] = {.lex_state = 0},
  [13045] = {.lex_state = 35},
  [13046] = {.lex_state = 0},
  [13047] = {.lex_state = 0},
  [13048] = {.lex_state = 0},
  [13049] = {.lex_state = 0},
  [13050] = {.lex_state = 0},
  [13051] = {.lex_state = 0},
  [13052] = {.lex_state = 0},
  [13053] = {.lex_state = 0},
  [13054] = {.lex_state = 35},
  [13055] = {.lex_state = 0},
  [13056] = {.lex_state = 0},
  [13057] = {.lex_state = 35},
  [13058] = {.lex_state = 0},
  [13059] = {.lex_state = 0},
  [13060] = {.lex_state = 0},
  [13061] = {.lex_state = 0},
  [13062] = {.lex_state = 0},
  [13063] = {.lex_state = 0},
  [13064] = {.lex_state = 0},
  [13065] = {.lex_state = 0},
  [13066] = {.lex_state = 0},
  [13067] = {.lex_state = 0},
  [13068] = {.lex_state = 0},
  [13069] = {.lex_state = 0},
  [13070] = {.lex_state = 0},
  [13071] = {.lex_state = 0},
  [13072] = {.lex_state = 0},
  [13073] = {.lex_state = 0},
  [13074] = {.lex_state = 35},
  [13075] = {.lex_state = 0},
  [13076] = {.lex_state = 35},
  [13077] = {.lex_state = 0},
  [13078] = {.lex_state = 0},
  [13079] = {.lex_state = 35},
  [13080] = {.lex_state = 0},
  [13081] = {.lex_state = 35},
  [13082] = {.lex_state = 0},
  [13083] = {.lex_state = 0},
  [13084] = {.lex_state = 0},
  [13085] = {.lex_state = 0},
  [13086] = {.lex_state = 0},
  [13087] = {.lex_state = 0},
  [13088] = {.lex_state = 0},
  [13089] = {.lex_state = 0},
  [13090] = {.lex_state = 0},
  [13091] = {.lex_state = 0},
  [13092] = {.lex_state = 35},
  [13093] = {.lex_state = 0},
  [13094] = {.lex_state = 0},
  [13095] = {.lex_state = 0},
  [13096] = {.lex_state = 0},
  [13097] = {.lex_state = 0},
  [13098] = {.lex_state = 0},
  [13099] = {.lex_state = 0},
  [13100] = {.lex_state = 0},
  [13101] = {.lex_state = 0},
  [13102] = {.lex_state = 0},
  [13103] = {.lex_state = 0},
  [13104] = {.lex_state = 0},
  [13105] = {.lex_state = 0},
  [13106] = {.lex_state = 0},
  [13107] = {.lex_state = 0},
  [13108] = {.lex_state = 0},
  [13109] = {.lex_state = 0},
  [13110] = {.lex_state = 0},
  [13111] = {.lex_state = 0},
  [13112] = {.lex_state = 0},
  [13113] = {.lex_state = 0},
  [13114] = {.lex_state = 0},
  [13115] = {.lex_state = 0},
  [13116] = {.lex_state = 0},
  [13117] = {.lex_state = 0},
  [13118] = {.lex_state = 0},
  [13119] = {.lex_state = 0},
  [13120] = {.lex_state = 0},
  [13121] = {.lex_state = 35},
  [13122] = {.lex_state = 35},
  [13123] = {.lex_state = 0},
  [13124] = {.lex_state = 0},
  [13125] = {.lex_state = 0},
  [13126] = {.lex_state = 35},
  [13127] = {.lex_state = 0},
  [13128] = {.lex_state = 0},
  [13129] = {.lex_state = 0},
  [13130] = {.lex_state = 0},
  [13131] = {.lex_state = 35},
  [13132] = {.lex_state = 35},
  [13133] = {.lex_state = 0},
  [13134] = {.lex_state = 0},
  [13135] = {.lex_state = 0},
  [13136] = {.lex_state = 0},
  [13137] = {.lex_state = 0},
  [13138] = {.lex_state = 0},
  [13139] = {.lex_state = 0},
  [13140] = {.lex_state = 35},
  [13141] = {.lex_state = 0},
  [13142] = {.lex_state = 0},
  [13143] = {.lex_state = 0},
  [13144] = {.lex_state = 0},
  [13145] = {.lex_state = 0},
  [13146] = {.lex_state = 0},
  [13147] = {.lex_state = 0},
  [13148] = {.lex_state = 0},
  [13149] = {.lex_state = 0},
  [13150] = {.lex_state = 0},
  [13151] = {.lex_state = 35},
  [13152] = {.lex_state = 0},
  [13153] = {.lex_state = 0},
  [13154] = {.lex_state = 0},
  [13155] = {.lex_state = 0},
  [13156] = {.lex_state = 0},
  [13157] = {.lex_state = 0},
  [13158] = {.lex_state = 0},
  [13159] = {.lex_state = 0},
  [13160] = {.lex_state = 0},
  [13161] = {.lex_state = 35},
  [13162] = {.lex_state = 0},
  [13163] = {.lex_state = 35},
  [13164] = {.lex_state = 0},
  [13165] = {.lex_state = 0},
  [13166] = {.lex_state = 0},
  [13167] = {.lex_state = 0},
  [13168] = {.lex_state = 0},
  [13169] = {.lex_state = 0},
  [13170] = {.lex_state = 0},
  [13171] = {.lex_state = 0},
  [13172] = {.lex_state = 0},
  [13173] = {.lex_state = 0},
  [13174] = {.lex_state = 0},
  [13175] = {.lex_state = 35},
  [13176] = {.lex_state = 0},
  [13177] = {.lex_state = 0},
  [13178] = {.lex_state = 0},
  [13179] = {.lex_state = 0},
  [13180] = {.lex_state = 35},
  [13181] = {.lex_state = 0},
  [13182] = {.lex_state = 0},
  [13183] = {.lex_state = 0},
  [13184] = {.lex_state = 0},
  [13185] = {.lex_state = 0},
  [13186] = {.lex_state = 0},
  [13187] = {.lex_state = 0},
  [13188] = {.lex_state = 0},
  [13189] = {.lex_state = 0},
  [13190] = {.lex_state = 33},
  [13191] = {.lex_state = 0},
  [13192] = {.lex_state = 0},
  [13193] = {.lex_state = 0},
  [13194] = {.lex_state = 0},
  [13195] = {.lex_state = 0},
  [13196] = {.lex_state = 0},
  [13197] = {.lex_state = 0},
  [13198] = {.lex_state = 0},
  [13199] = {.lex_state = 0},
  [13200] = {.lex_state = 0},
  [13201] = {.lex_state = 35},
  [13202] = {.lex_state = 0},
  [13203] = {.lex_state = 0},
  [13204] = {.lex_state = 0},
  [13205] = {.lex_state = 0},
  [13206] = {.lex_state = 0},
  [13207] = {.lex_state = 0},
  [13208] = {.lex_state = 0},
  [13209] = {.lex_state = 0},
  [13210] = {.lex_state = 0},
  [13211] = {.lex_state = 0},
  [13212] = {.lex_state = 0},
  [13213] = {.lex_state = 0},
  [13214] = {.lex_state = 0},
  [13215] = {.lex_state = 0},
  [13216] = {.lex_state = 0},
  [13217] = {.lex_state = 0},
  [13218] = {.lex_state = 0},
  [13219] = {.lex_state = 0},
  [13220] = {.lex_state = 0},
  [13221] = {.lex_state = 0},
  [13222] = {.lex_state = 0},
  [13223] = {.lex_state = 0},
  [13224] = {.lex_state = 0},
  [13225] = {.lex_state = 0},
  [13226] = {.lex_state = 0},
  [13227] = {.lex_state = 0},
  [13228] = {.lex_state = 0},
  [13229] = {.lex_state = 0},
  [13230] = {.lex_state = 0},
  [13231] = {.lex_state = 0},
  [13232] = {.lex_state = 0},
  [13233] = {.lex_state = 0},
  [13234] = {.lex_state = 0},
  [13235] = {.lex_state = 0},
  [13236] = {.lex_state = 0},
  [13237] = {.lex_state = 35},
  [13238] = {.lex_state = 0},
  [13239] = {.lex_state = 35},
  [13240] = {.lex_state = 0},
  [13241] = {.lex_state = 0},
  [13242] = {.lex_state = 0},
  [13243] = {.lex_state = 0},
  [13244] = {.lex_state = 0},
  [13245] = {.lex_state = 0},
  [13246] = {.lex_state = 0},
  [13247] = {.lex_state = 0},
  [13248] = {.lex_state = 0},
  [13249] = {.lex_state = 0},
  [13250] = {.lex_state = 0},
  [13251] = {.lex_state = 0},
  [13252] = {.lex_state = 0},
  [13253] = {.lex_state = 0},
  [13254] = {.lex_state = 0},
  [13255] = {.lex_state = 0},
  [13256] = {.lex_state = 0},
  [13257] = {.lex_state = 0},
  [13258] = {.lex_state = 0},
  [13259] = {.lex_state = 0},
  [13260] = {.lex_state = 0},
  [13261] = {.lex_state = 0},
  [13262] = {.lex_state = 0},
  [13263] = {.lex_state = 35},
  [13264] = {.lex_state = 35},
  [13265] = {.lex_state = 0},
  [13266] = {.lex_state = 35},
  [13267] = {.lex_state = 0},
  [13268] = {.lex_state = 0},
  [13269] = {.lex_state = 0},
  [13270] = {.lex_state = 0},
  [13271] = {.lex_state = 35},
  [13272] = {.lex_state = 0},
  [13273] = {.lex_state = 0},
  [13274] = {.lex_state = 0},
  [13275] = {.lex_state = 0},
  [13276] = {.lex_state = 0},
  [13277] = {.lex_state = 0},
  [13278] = {.lex_state = 0},
  [13279] = {.lex_state = 0},
  [13280] = {.lex_state = 0},
  [13281] = {.lex_state = 0},
  [13282] = {.lex_state = 0},
  [13283] = {.lex_state = 0},
  [13284] = {.lex_state = 0},
  [13285] = {.lex_state = 0},
  [13286] = {.lex_state = 0},
  [13287] = {.lex_state = 0},
  [13288] = {.lex_state = 0},
  [13289] = {.lex_state = 35},
  [13290] = {.lex_state = 35},
  [13291] = {.lex_state = 0},
  [13292] = {.lex_state = 35},
  [13293] = {.lex_state = 0},
  [13294] = {.lex_state = 35},
  [13295] = {.lex_state = 35},
  [13296] = {.lex_state = 35},
  [13297] = {.lex_state = 0},
  [13298] = {.lex_state = 0},
  [13299] = {.lex_state = 0},
  [13300] = {.lex_state = 35},
  [13301] = {.lex_state = 35},
  [13302] = {.lex_state = 0},
  [13303] = {.lex_state = 0},
  [13304] = {.lex_state = 0},
  [13305] = {.lex_state = 0},
  [13306] = {.lex_state = 0},
  [13307] = {.lex_state = 0},
  [13308] = {.lex_state = 35},
  [13309] = {.lex_state = 35},
  [13310] = {.lex_state = 0},
  [13311] = {.lex_state = 0},
  [13312] = {.lex_state = 35},
  [13313] = {.lex_state = 0},
  [13314] = {.lex_state = 0},
  [13315] = {.lex_state = 35},
  [13316] = {.lex_state = 0},
  [13317] = {.lex_state = 0},
  [13318] = {.lex_state = 0},
  [13319] = {.lex_state = 0},
  [13320] = {.lex_state = 35},
  [13321] = {.lex_state = 0},
  [13322] = {.lex_state = 0},
  [13323] = {.lex_state = 35},
  [13324] = {.lex_state = 0},
  [13325] = {.lex_state = 0},
  [13326] = {.lex_state = 0},
  [13327] = {.lex_state = 0},
  [13328] = {.lex_state = 35},
  [13329] = {.lex_state = 0},
  [13330] = {.lex_state = 0},
  [13331] = {.lex_state = 0},
  [13332] = {.lex_state = 0},
  [13333] = {.lex_state = 0},
  [13334] = {.lex_state = 0},
  [13335] = {.lex_state = 0},
  [13336] = {.lex_state = 35},
  [13337] = {.lex_state = 0},
  [13338] = {.lex_state = 0},
  [13339] = {.lex_state = 0},
  [13340] = {.lex_state = 0},
  [13341] = {.lex_state = 0},
  [13342] = {.lex_state = 0},
  [13343] = {.lex_state = 0},
  [13344] = {.lex_state = 0},
  [13345] = {.lex_state = 35},
  [13346] = {.lex_state = 0},
  [13347] = {.lex_state = 0},
  [13348] = {.lex_state = 0},
  [13349] = {.lex_state = 35},
  [13350] = {.lex_state = 0},
  [13351] = {.lex_state = 0},
  [13352] = {.lex_state = 0},
  [13353] = {.lex_state = 35},
  [13354] = {.lex_state = 35},
  [13355] = {.lex_state = 0},
  [13356] = {.lex_state = 35},
  [13357] = {.lex_state = 0},
  [13358] = {.lex_state = 35},
  [13359] = {.lex_state = 0},
  [13360] = {.lex_state = 0},
  [13361] = {.lex_state = 0},
  [13362] = {.lex_state = 0},
  [13363] = {.lex_state = 0},
  [13364] = {.lex_state = 0},
  [13365] = {.lex_state = 0},
  [13366] = {.lex_state = 0},
  [13367] = {.lex_state = 0},
  [13368] = {.lex_state = 35},
  [13369] = {.lex_state = 35},
  [13370] = {.lex_state = 0},
  [13371] = {.lex_state = 0},
  [13372] = {.lex_state = 0},
  [13373] = {.lex_state = 0},
  [13374] = {.lex_state = 35},
  [13375] = {.lex_state = 0},
  [13376] = {.lex_state = 0},
  [13377] = {.lex_state = 0},
  [13378] = {.lex_state = 0},
  [13379] = {.lex_state = 0},
  [13380] = {.lex_state = 35},
  [13381] = {.lex_state = 35},
  [13382] = {.lex_state = 35},
  [13383] = {.lex_state = 33},
  [13384] = {.lex_state = 0},
  [13385] = {.lex_state = 0},
  [13386] = {.lex_state = 0},
  [13387] = {.lex_state = 0},
  [13388] = {.lex_state = 35},
  [13389] = {.lex_state = 0},
  [13390] = {.lex_state = 35},
  [13391] = {.lex_state = 35},
  [13392] = {.lex_state = 35},
  [13393] = {.lex_state = 0},
  [13394] = {.lex_state = 35},
  [13395] = {.lex_state = 0},
  [13396] = {.lex_state = 0},
  [13397] = {.lex_state = 35},
  [13398] = {.lex_state = 35},
  [13399] = {.lex_state = 0},
  [13400] = {.lex_state = 35},
  [13401] = {.lex_state = 35},
  [13402] = {.lex_state = 0},
  [13403] = {.lex_state = 35},
  [13404] = {.lex_state = 0},
  [13405] = {.lex_state = 0},
  [13406] = {.lex_state = 35},
  [13407] = {.lex_state = 0},
  [13408] = {.lex_state = 35},
  [13409] = {.lex_state = 0},
  [13410] = {.lex_state = 0},
  [13411] = {.lex_state = 35},
  [13412] = {.lex_state = 0},
  [13413] = {.lex_state = 35},
  [13414] = {.lex_state = 35},
  [13415] = {.lex_state = 0},
  [13416] = {.lex_state = 35},
  [13417] = {.lex_state = 0},
  [13418] = {.lex_state = 0},
  [13419] = {.lex_state = 0},
  [13420] = {.lex_state = 0},
  [13421] = {.lex_state = 35},
  [13422] = {.lex_state = 35},
  [13423] = {.lex_state = 0},
  [13424] = {.lex_state = 35},
  [13425] = {.lex_state = 0},
  [13426] = {.lex_state = 0},
  [13427] = {.lex_state = 0},
  [13428] = {.lex_state = 0},
  [13429] = {.lex_state = 35},
  [13430] = {.lex_state = 35},
  [13431] = {.lex_state = 0},
  [13432] = {.lex_state = 0},
  [13433] = {.lex_state = 0},
  [13434] = {.lex_state = 0},
  [13435] = {.lex_state = 0},
  [13436] = {.lex_state = 0},
  [13437] = {.lex_state = 0},
  [13438] = {.lex_state = 0},
  [13439] = {.lex_state = 0},
  [13440] = {.lex_state = 0},
  [13441] = {.lex_state = 0},
  [13442] = {.lex_state = 0},
  [13443] = {.lex_state = 0},
  [13444] = {.lex_state = 0},
  [13445] = {.lex_state = 0},
  [13446] = {.lex_state = 35},
  [13447] = {.lex_state = 0},
  [13448] = {.lex_state = 0},
  [13449] = {.lex_state = 35},
  [13450] = {.lex_state = 35},
  [13451] = {.lex_state = 35},
  [13452] = {.lex_state = 35},
  [13453] = {.lex_state = 35},
  [13454] = {.lex_state = 35},
  [13455] = {.lex_state = 0},
  [13456] = {.lex_state = 0},
  [13457] = {.lex_state = 35},
  [13458] = {.lex_state = 35},
  [13459] = {.lex_state = 35},
  [13460] = {.lex_state = 35},
  [13461] = {.lex_state = 0},
  [13462] = {.lex_state = 0},
  [13463] = {.lex_state = 35},
  [13464] = {.lex_state = 35},
  [13465] = {.lex_state = 0},
  [13466] = {.lex_state = 0},
  [13467] = {.lex_state = 0},
  [13468] = {.lex_state = 35},
  [13469] = {.lex_state = 0},
  [13470] = {.lex_state = 0},
  [13471] = {.lex_state = 0, .external_lex_state = 2},
  [13472] = {.lex_state = 35},
  [13473] = {.lex_state = 35},
  [13474] = {.lex_state = 0},
  [13475] = {.lex_state = 35},
  [13476] = {.lex_state = 0},
  [13477] = {.lex_state = 0},
  [13478] = {.lex_state = 0},
  [13479] = {.lex_state = 0},
  [13480] = {.lex_state = 35},
  [13481] = {.lex_state = 0},
  [13482] = {.lex_state = 0, .external_lex_state = 2},
  [13483] = {.lex_state = 35},
  [13484] = {.lex_state = 0},
  [13485] = {.lex_state = 0},
  [13486] = {.lex_state = 0},
  [13487] = {.lex_state = 35},
  [13488] = {.lex_state = 0},
  [13489] = {.lex_state = 35},
  [13490] = {.lex_state = 0},
  [13491] = {.lex_state = 35},
  [13492] = {.lex_state = 0},
  [13493] = {.lex_state = 0},
  [13494] = {.lex_state = 0},
  [13495] = {.lex_state = 35},
  [13496] = {.lex_state = 0},
  [13497] = {.lex_state = 35},
  [13498] = {.lex_state = 35},
  [13499] = {.lex_state = 0},
  [13500] = {.lex_state = 35},
  [13501] = {.lex_state = 0},
  [13502] = {.lex_state = 35},
  [13503] = {.lex_state = 0},
  [13504] = {.lex_state = 0},
  [13505] = {.lex_state = 0},
  [13506] = {.lex_state = 35},
  [13507] = {.lex_state = 35},
  [13508] = {.lex_state = 0},
  [13509] = {.lex_state = 35},
  [13510] = {.lex_state = 0},
  [13511] = {.lex_state = 0},
  [13512] = {.lex_state = 35},
  [13513] = {.lex_state = 35},
  [13514] = {.lex_state = 0},
  [13515] = {.lex_state = 35},
  [13516] = {.lex_state = 0},
  [13517] = {.lex_state = 0},
  [13518] = {.lex_state = 35},
  [13519] = {.lex_state = 0, .external_lex_state = 2},
  [13520] = {.lex_state = 0},
  [13521] = {.lex_state = 0},
  [13522] = {.lex_state = 35},
  [13523] = {.lex_state = 0},
  [13524] = {.lex_state = 0},
  [13525] = {.lex_state = 0},
  [13526] = {.lex_state = 0},
  [13527] = {.lex_state = 35},
  [13528] = {.lex_state = 0},
  [13529] = {.lex_state = 35},
  [13530] = {.lex_state = 35},
  [13531] = {.lex_state = 0},
  [13532] = {.lex_state = 35},
  [13533] = {.lex_state = 0},
  [13534] = {.lex_state = 0},
  [13535] = {.lex_state = 0},
  [13536] = {.lex_state = 35},
  [13537] = {.lex_state = 0},
  [13538] = {.lex_state = 0},
  [13539] = {.lex_state = 0},
  [13540] = {.lex_state = 0},
  [13541] = {.lex_state = 35},
  [13542] = {.lex_state = 0},
  [13543] = {.lex_state = 0},
  [13544] = {.lex_state = 35},
  [13545] = {.lex_state = 0},
  [13546] = {.lex_state = 0},
  [13547] = {.lex_state = 35},
  [13548] = {.lex_state = 35},
  [13549] = {.lex_state = 35},
  [13550] = {.lex_state = 0},
  [13551] = {.lex_state = 0},
  [13552] = {.lex_state = 0},
  [13553] = {.lex_state = 35},
  [13554] = {.lex_state = 0},
  [13555] = {.lex_state = 0},
  [13556] = {.lex_state = 0},
  [13557] = {.lex_state = 0},
  [13558] = {.lex_state = 0},
  [13559] = {.lex_state = 0},
  [13560] = {.lex_state = 0},
  [13561] = {.lex_state = 0},
  [13562] = {.lex_state = 0},
  [13563] = {.lex_state = 0},
  [13564] = {.lex_state = 0},
  [13565] = {.lex_state = 35},
  [13566] = {.lex_state = 35},
  [13567] = {.lex_state = 0},
  [13568] = {.lex_state = 0},
  [13569] = {.lex_state = 35},
  [13570] = {.lex_state = 35},
  [13571] = {.lex_state = 35},
  [13572] = {.lex_state = 0},
  [13573] = {.lex_state = 35},
  [13574] = {.lex_state = 0},
  [13575] = {.lex_state = 0},
  [13576] = {.lex_state = 0},
  [13577] = {.lex_state = 0},
  [13578] = {.lex_state = 0},
  [13579] = {.lex_state = 0},
  [13580] = {.lex_state = 0},
  [13581] = {.lex_state = 0},
  [13582] = {.lex_state = 0},
  [13583] = {.lex_state = 35},
  [13584] = {.lex_state = 35},
  [13585] = {.lex_state = 35},
  [13586] = {.lex_state = 35},
  [13587] = {.lex_state = 0},
  [13588] = {.lex_state = 0},
  [13589] = {.lex_state = 0},
  [13590] = {.lex_state = 0},
  [13591] = {.lex_state = 0},
  [13592] = {.lex_state = 35},
  [13593] = {.lex_state = 35},
  [13594] = {.lex_state = 35},
  [13595] = {.lex_state = 0},
  [13596] = {.lex_state = 0},
  [13597] = {.lex_state = 0},
  [13598] = {.lex_state = 0},
  [13599] = {.lex_state = 0},
  [13600] = {.lex_state = 0},
  [13601] = {.lex_state = 0},
  [13602] = {.lex_state = 35},
  [13603] = {.lex_state = 0},
  [13604] = {.lex_state = 0},
  [13605] = {.lex_state = 0},
  [13606] = {.lex_state = 35},
  [13607] = {.lex_state = 35},
  [13608] = {.lex_state = 0},
  [13609] = {.lex_state = 0},
  [13610] = {.lex_state = 0},
  [13611] = {.lex_state = 0},
  [13612] = {.lex_state = 0},
  [13613] = {.lex_state = 0},
  [13614] = {.lex_state = 0},
  [13615] = {.lex_state = 0},
  [13616] = {.lex_state = 0},
  [13617] = {.lex_state = 0},
  [13618] = {.lex_state = 0},
  [13619] = {.lex_state = 0},
  [13620] = {.lex_state = 35},
  [13621] = {.lex_state = 35},
  [13622] = {.lex_state = 35},
  [13623] = {.lex_state = 0},
  [13624] = {.lex_state = 0},
  [13625] = {.lex_state = 35},
  [13626] = {.lex_state = 35},
  [13627] = {.lex_state = 35},
  [13628] = {.lex_state = 35},
  [13629] = {.lex_state = 35},
  [13630] = {.lex_state = 0},
  [13631] = {.lex_state = 0},
  [13632] = {.lex_state = 0},
  [13633] = {.lex_state = 0},
  [13634] = {.lex_state = 0},
  [13635] = {.lex_state = 35},
  [13636] = {.lex_state = 35},
  [13637] = {.lex_state = 0},
  [13638] = {.lex_state = 35},
  [13639] = {.lex_state = 0},
  [13640] = {.lex_state = 0},
  [13641] = {.lex_state = 35},
  [13642] = {.lex_state = 35},
  [13643] = {.lex_state = 0},
  [13644] = {.lex_state = 0},
  [13645] = {.lex_state = 35},
  [13646] = {.lex_state = 0},
  [13647] = {.lex_state = 0},
  [13648] = {.lex_state = 0},
  [13649] = {.lex_state = 0},
  [13650] = {.lex_state = 0},
  [13651] = {.lex_state = 0},
  [13652] = {.lex_state = 0},
  [13653] = {.lex_state = 0},
  [13654] = {.lex_state = 0},
  [13655] = {.lex_state = 0},
  [13656] = {.lex_state = 0},
  [13657] = {.lex_state = 0},
  [13658] = {.lex_state = 0},
  [13659] = {.lex_state = 0},
  [13660] = {.lex_state = 0},
  [13661] = {.lex_state = 0},
  [13662] = {.lex_state = 0},
  [13663] = {.lex_state = 0},
  [13664] = {.lex_state = 0},
  [13665] = {.lex_state = 0},
  [13666] = {.lex_state = 0},
  [13667] = {.lex_state = 0},
  [13668] = {.lex_state = 0},
  [13669] = {.lex_state = 0},
  [13670] = {.lex_state = 0},
  [13671] = {.lex_state = 35},
  [13672] = {.lex_state = 35},
  [13673] = {.lex_state = 35},
  [13674] = {.lex_state = 35},
  [13675] = {.lex_state = 35},
  [13676] = {.lex_state = 0},
  [13677] = {.lex_state = 35},
  [13678] = {.lex_state = 35},
  [13679] = {.lex_state = 0},
  [13680] = {.lex_state = 35},
  [13681] = {.lex_state = 0},
  [13682] = {.lex_state = 0},
  [13683] = {.lex_state = 35},
  [13684] = {.lex_state = 0},
  [13685] = {.lex_state = 0},
  [13686] = {.lex_state = 0},
  [13687] = {.lex_state = 35},
  [13688] = {.lex_state = 0},
  [13689] = {.lex_state = 0},
  [13690] = {.lex_state = 0},
  [13691] = {.lex_state = 0},
  [13692] = {.lex_state = 0},
  [13693] = {.lex_state = 0},
  [13694] = {.lex_state = 0},
  [13695] = {.lex_state = 0},
  [13696] = {.lex_state = 35},
  [13697] = {.lex_state = 0},
  [13698] = {.lex_state = 0},
  [13699] = {.lex_state = 0},
  [13700] = {.lex_state = 0},
  [13701] = {.lex_state = 0},
  [13702] = {.lex_state = 0},
  [13703] = {.lex_state = 35},
  [13704] = {.lex_state = 0},
  [13705] = {.lex_state = 0},
  [13706] = {.lex_state = 0},
  [13707] = {.lex_state = 0},
  [13708] = {.lex_state = 0},
  [13709] = {.lex_state = 0},
  [13710] = {.lex_state = 35},
  [13711] = {.lex_state = 0},
  [13712] = {.lex_state = 0},
  [13713] = {.lex_state = 0},
  [13714] = {.lex_state = 0},
  [13715] = {.lex_state = 0},
  [13716] = {.lex_state = 0},
  [13717] = {.lex_state = 0},
  [13718] = {.lex_state = 0},
  [13719] = {.lex_state = 0},
  [13720] = {.lex_state = 0},
  [13721] = {.lex_state = 0},
  [13722] = {.lex_state = 0},
  [13723] = {.lex_state = 0},
  [13724] = {.lex_state = 0},
  [13725] = {.lex_state = 35},
  [13726] = {.lex_state = 35},
  [13727] = {.lex_state = 35},
  [13728] = {.lex_state = 35},
  [13729] = {.lex_state = 0},
  [13730] = {.lex_state = 0},
  [13731] = {.lex_state = 35},
  [13732] = {.lex_state = 0},
  [13733] = {.lex_state = 35},
  [13734] = {.lex_state = 0},
  [13735] = {.lex_state = 0},
  [13736] = {.lex_state = 0},
  [13737] = {.lex_state = 0},
  [13738] = {.lex_state = 35},
  [13739] = {.lex_state = 35},
  [13740] = {.lex_state = 0},
  [13741] = {.lex_state = 0},
  [13742] = {.lex_state = 35},
  [13743] = {.lex_state = 35},
  [13744] = {.lex_state = 33},
  [13745] = {.lex_state = 35},
  [13746] = {.lex_state = 35},
  [13747] = {.lex_state = 0},
  [13748] = {.lex_state = 0},
  [13749] = {.lex_state = 0},
  [13750] = {.lex_state = 35},
  [13751] = {.lex_state = 0},
  [13752] = {.lex_state = 35},
  [13753] = {.lex_state = 0},
  [13754] = {.lex_state = 0},
  [13755] = {.lex_state = 0},
  [13756] = {.lex_state = 0},
  [13757] = {.lex_state = 0},
  [13758] = {.lex_state = 0},
  [13759] = {.lex_state = 35},
  [13760] = {.lex_state = 0},
  [13761] = {.lex_state = 0},
  [13762] = {.lex_state = 0},
  [13763] = {.lex_state = 0},
  [13764] = {.lex_state = 0},
  [13765] = {.lex_state = 35},
  [13766] = {.lex_state = 35},
  [13767] = {.lex_state = 0},
  [13768] = {.lex_state = 35},
  [13769] = {.lex_state = 0},
  [13770] = {.lex_state = 0},
  [13771] = {.lex_state = 35},
  [13772] = {.lex_state = 0},
  [13773] = {.lex_state = 0},
  [13774] = {.lex_state = 35},
  [13775] = {.lex_state = 0},
  [13776] = {.lex_state = 0},
  [13777] = {.lex_state = 0},
  [13778] = {.lex_state = 35},
  [13779] = {.lex_state = 0},
  [13780] = {.lex_state = 0},
  [13781] = {.lex_state = 0},
  [13782] = {.lex_state = 0},
  [13783] = {.lex_state = 0},
  [13784] = {.lex_state = 35},
  [13785] = {.lex_state = 35},
  [13786] = {.lex_state = 0},
  [13787] = {.lex_state = 0},
  [13788] = {.lex_state = 0},
  [13789] = {.lex_state = 0},
  [13790] = {.lex_state = 35},
  [13791] = {.lex_state = 0},
  [13792] = {.lex_state = 0},
  [13793] = {.lex_state = 0},
  [13794] = {.lex_state = 35},
  [13795] = {.lex_state = 35},
  [13796] = {.lex_state = 0},
  [13797] = {.lex_state = 35},
  [13798] = {.lex_state = 35},
  [13799] = {.lex_state = 0},
  [13800] = {.lex_state = 0},
  [13801] = {.lex_state = 0},
  [13802] = {.lex_state = 0},
  [13803] = {.lex_state = 35},
  [13804] = {.lex_state = 35},
  [13805] = {.lex_state = 0},
  [13806] = {.lex_state = 35},
  [13807] = {.lex_state = 0},
  [13808] = {.lex_state = 35},
  [13809] = {.lex_state = 0},
  [13810] = {.lex_state = 35},
  [13811] = {.lex_state = 35},
  [13812] = {.lex_state = 0},
  [13813] = {.lex_state = 0},
  [13814] = {.lex_state = 0},
  [13815] = {.lex_state = 0},
  [13816] = {.lex_state = 0},
  [13817] = {.lex_state = 0},
  [13818] = {.lex_state = 0},
  [13819] = {.lex_state = 0},
  [13820] = {.lex_state = 0},
  [13821] = {.lex_state = 35},
  [13822] = {.lex_state = 35},
  [13823] = {.lex_state = 0},
  [13824] = {.lex_state = 35},
  [13825] = {.lex_state = 0},
  [13826] = {.lex_state = 0},
  [13827] = {.lex_state = 35},
  [13828] = {.lex_state = 35},
  [13829] = {.lex_state = 0},
  [13830] = {.lex_state = 0},
  [13831] = {.lex_state = 0},
  [13832] = {.lex_state = 0},
  [13833] = {.lex_state = 0},
  [13834] = {.lex_state = 0},
  [13835] = {.lex_state = 0},
  [13836] = {.lex_state = 35},
  [13837] = {.lex_state = 35},
  [13838] = {.lex_state = 35},
  [13839] = {.lex_state = 0},
  [13840] = {.lex_state = 0},
  [13841] = {.lex_state = 0},
  [13842] = {.lex_state = 35},
  [13843] = {.lex_state = 35},
  [13844] = {.lex_state = 35},
  [13845] = {.lex_state = 0},
  [13846] = {.lex_state = 35},
  [13847] = {.lex_state = 0},
  [13848] = {.lex_state = 0},
  [13849] = {.lex_state = 0},
  [13850] = {.lex_state = 0},
  [13851] = {.lex_state = 0},
  [13852] = {.lex_state = 0},
  [13853] = {.lex_state = 35},
  [13854] = {.lex_state = 0},
  [13855] = {.lex_state = 0},
  [13856] = {.lex_state = 35},
  [13857] = {.lex_state = 0},
  [13858] = {.lex_state = 35},
  [13859] = {.lex_state = 0},
  [13860] = {.lex_state = 35},
  [13861] = {.lex_state = 0},
  [13862] = {.lex_state = 0},
  [13863] = {.lex_state = 0},
  [13864] = {.lex_state = 0},
  [13865] = {.lex_state = 0},
  [13866] = {.lex_state = 0},
  [13867] = {.lex_state = 0},
  [13868] = {.lex_state = 0},
  [13869] = {.lex_state = 0},
  [13870] = {.lex_state = 35},
  [13871] = {.lex_state = 0},
  [13872] = {.lex_state = 35},
  [13873] = {.lex_state = 0},
  [13874] = {.lex_state = 0},
  [13875] = {.lex_state = 35},
  [13876] = {.lex_state = 0},
  [13877] = {.lex_state = 0},
  [13878] = {.lex_state = 35},
  [13879] = {.lex_state = 0},
  [13880] = {.lex_state = 0},
  [13881] = {.lex_state = 0},
  [13882] = {.lex_state = 0},
  [13883] = {.lex_state = 35},
  [13884] = {.lex_state = 0},
  [13885] = {.lex_state = 0},
  [13886] = {.lex_state = 35},
  [13887] = {.lex_state = 0},
  [13888] = {.lex_state = 35},
  [13889] = {.lex_state = 0},
  [13890] = {.lex_state = 0},
  [13891] = {.lex_state = 35},
  [13892] = {.lex_state = 0},
  [13893] = {.lex_state = 0},
  [13894] = {.lex_state = 0},
  [13895] = {.lex_state = 0},
  [13896] = {.lex_state = 0},
  [13897] = {.lex_state = 0},
  [13898] = {.lex_state = 0},
  [13899] = {.lex_state = 35},
  [13900] = {.lex_state = 0},
  [13901] = {.lex_state = 35},
  [13902] = {.lex_state = 35},
  [13903] = {.lex_state = 0},
  [13904] = {.lex_state = 0},
  [13905] = {.lex_state = 0},
  [13906] = {.lex_state = 35},
  [13907] = {.lex_state = 35},
  [13908] = {.lex_state = 35},
  [13909] = {.lex_state = 0},
  [13910] = {.lex_state = 35},
  [13911] = {.lex_state = 0},
  [13912] = {.lex_state = 0},
  [13913] = {.lex_state = 0},
  [13914] = {.lex_state = 0},
  [13915] = {.lex_state = 0},
  [13916] = {.lex_state = 0},
  [13917] = {.lex_state = 0},
  [13918] = {.lex_state = 35},
  [13919] = {.lex_state = 0},
  [13920] = {.lex_state = 0},
  [13921] = {.lex_state = 0},
  [13922] = {.lex_state = 35},
  [13923] = {.lex_state = 35},
  [13924] = {.lex_state = 35},
  [13925] = {.lex_state = 0},
  [13926] = {.lex_state = 35},
  [13927] = {.lex_state = 0},
  [13928] = {.lex_state = 0},
  [13929] = {.lex_state = 0},
  [13930] = {.lex_state = 0},
  [13931] = {.lex_state = 0},
  [13932] = {.lex_state = 0},
  [13933] = {.lex_state = 0},
  [13934] = {.lex_state = 0},
  [13935] = {.lex_state = 0},
  [13936] = {.lex_state = 0},
  [13937] = {.lex_state = 0},
  [13938] = {.lex_state = 0},
  [13939] = {.lex_state = 0},
  [13940] = {.lex_state = 0},
  [13941] = {.lex_state = 0},
  [13942] = {.lex_state = 0},
  [13943] = {.lex_state = 0},
  [13944] = {.lex_state = 0},
  [13945] = {.lex_state = 0},
  [13946] = {.lex_state = 0},
  [13947] = {.lex_state = 35},
  [13948] = {.lex_state = 0},
  [13949] = {.lex_state = 35},
  [13950] = {.lex_state = 0},
  [13951] = {.lex_state = 0},
  [13952] = {.lex_state = 35},
  [13953] = {.lex_state = 0},
  [13954] = {.lex_state = 0},
  [13955] = {.lex_state = 35},
  [13956] = {.lex_state = 0},
  [13957] = {.lex_state = 0},
  [13958] = {.lex_state = 0},
  [13959] = {.lex_state = 0},
  [13960] = {.lex_state = 0},
  [13961] = {.lex_state = 0},
  [13962] = {.lex_state = 0},
  [13963] = {.lex_state = 0},
  [13964] = {.lex_state = 0},
  [13965] = {.lex_state = 0},
  [13966] = {.lex_state = 0},
  [13967] = {.lex_state = 0},
  [13968] = {.lex_state = 0},
  [13969] = {.lex_state = 0},
  [13970] = {.lex_state = 0},
  [13971] = {.lex_state = 0},
  [13972] = {.lex_state = 35},
  [13973] = {.lex_state = 0},
  [13974] = {.lex_state = 0},
  [13975] = {.lex_state = 0},
  [13976] = {.lex_state = 0},
  [13977] = {.lex_state = 0},
  [13978] = {.lex_state = 0},
  [13979] = {.lex_state = 0},
  [13980] = {.lex_state = 35},
  [13981] = {.lex_state = 0},
  [13982] = {.lex_state = 35},
  [13983] = {.lex_state = 0},
  [13984] = {.lex_state = 35},
  [13985] = {.lex_state = 0},
  [13986] = {.lex_state = 35},
  [13987] = {.lex_state = 35},
  [13988] = {.lex_state = 0},
  [13989] = {.lex_state = 0},
  [13990] = {.lex_state = 35},
  [13991] = {.lex_state = 0},
  [13992] = {.lex_state = 35},
  [13993] = {.lex_state = 35},
  [13994] = {.lex_state = 0},
  [13995] = {.lex_state = 35},
  [13996] = {.lex_state = 0},
  [13997] = {.lex_state = 35},
  [13998] = {.lex_state = 0},
  [13999] = {.lex_state = 0},
  [14000] = {.lex_state = 0},
  [14001] = {.lex_state = 35},
  [14002] = {.lex_state = 0},
  [14003] = {.lex_state = 0},
  [14004] = {.lex_state = 0},
  [14005] = {.lex_state = 35},
  [14006] = {.lex_state = 35},
  [14007] = {.lex_state = 0},
  [14008] = {.lex_state = 35},
  [14009] = {.lex_state = 0},
  [14010] = {.lex_state = 35},
  [14011] = {.lex_state = 35},
  [14012] = {.lex_state = 35},
  [14013] = {.lex_state = 35},
  [14014] = {.lex_state = 35},
  [14015] = {.lex_state = 0},
  [14016] = {.lex_state = 0},
  [14017] = {.lex_state = 35},
  [14018] = {.lex_state = 0},
  [14019] = {.lex_state = 35},
  [14020] = {.lex_state = 0},
  [14021] = {.lex_state = 35},
  [14022] = {.lex_state = 35},
  [14023] = {.lex_state = 35},
  [14024] = {.lex_state = 35},
  [14025] = {.lex_state = 0},
  [14026] = {.lex_state = 35},
  [14027] = {.lex_state = 0},
  [14028] = {.lex_state = 0},
  [14029] = {.lex_state = 35},
  [14030] = {.lex_state = 0},
  [14031] = {.lex_state = 35},
  [14032] = {.lex_state = 0},
  [14033] = {.lex_state = 35},
  [14034] = {.lex_state = 0},
  [14035] = {.lex_state = 0},
  [14036] = {.lex_state = 35},
  [14037] = {.lex_state = 0},
  [14038] = {.lex_state = 35},
  [14039] = {.lex_state = 35},
  [14040] = {.lex_state = 35},
  [14041] = {.lex_state = 0},
  [14042] = {.lex_state = 0},
  [14043] = {.lex_state = 0},
  [14044] = {.lex_state = 0},
  [14045] = {.lex_state = 0},
  [14046] = {.lex_state = 0},
  [14047] = {.lex_state = 35},
  [14048] = {.lex_state = 35},
  [14049] = {.lex_state = 35},
  [14050] = {.lex_state = 35},
  [14051] = {.lex_state = 0},
  [14052] = {.lex_state = 35},
  [14053] = {.lex_state = 0},
  [14054] = {.lex_state = 0},
  [14055] = {.lex_state = 0},
  [14056] = {.lex_state = 0},
  [14057] = {.lex_state = 0},
  [14058] = {.lex_state = 35},
  [14059] = {.lex_state = 0},
  [14060] = {.lex_state = 0},
  [14061] = {.lex_state = 0},
  [14062] = {.lex_state = 0},
  [14063] = {.lex_state = 0},
  [14064] = {.lex_state = 35},
  [14065] = {.lex_state = 0},
  [14066] = {.lex_state = 0},
  [14067] = {.lex_state = 35},
  [14068] = {.lex_state = 0},
  [14069] = {.lex_state = 0},
  [14070] = {.lex_state = 0},
  [14071] = {.lex_state = 35},
  [14072] = {.lex_state = 0},
  [14073] = {.lex_state = 35},
  [14074] = {.lex_state = 0},
  [14075] = {.lex_state = 0},
  [14076] = {.lex_state = 0},
  [14077] = {.lex_state = 0},
  [14078] = {.lex_state = 0},
  [14079] = {.lex_state = 0},
  [14080] = {.lex_state = 0},
  [14081] = {.lex_state = 0},
  [14082] = {.lex_state = 0},
  [14083] = {.lex_state = 0},
  [14084] = {.lex_state = 0},
  [14085] = {.lex_state = 0},
  [14086] = {.lex_state = 0},
  [14087] = {.lex_state = 35},
  [14088] = {.lex_state = 0},
  [14089] = {.lex_state = 35},
  [14090] = {.lex_state = 35},
  [14091] = {.lex_state = 35},
  [14092] = {.lex_state = 0},
  [14093] = {.lex_state = 35},
  [14094] = {.lex_state = 35},
  [14095] = {.lex_state = 0},
  [14096] = {.lex_state = 35},
  [14097] = {.lex_state = 0},
  [14098] = {.lex_state = 0},
  [14099] = {.lex_state = 0},
  [14100] = {.lex_state = 0},
  [14101] = {.lex_state = 0},
  [14102] = {.lex_state = 35},
  [14103] = {.lex_state = 35},
  [14104] = {.lex_state = 35},
  [14105] = {.lex_state = 0},
  [14106] = {.lex_state = 0},
  [14107] = {.lex_state = 0},
  [14108] = {.lex_state = 0},
  [14109] = {.lex_state = 0},
  [14110] = {.lex_state = 0},
  [14111] = {.lex_state = 0},
  [14112] = {.lex_state = 0},
  [14113] = {.lex_state = 35},
  [14114] = {.lex_state = 35},
  [14115] = {.lex_state = 35},
  [14116] = {.lex_state = 0},
  [14117] = {.lex_state = 0},
  [14118] = {.lex_state = 0},
  [14119] = {.lex_state = 0, .external_lex_state = 2},
  [14120] = {.lex_state = 35},
  [14121] = {.lex_state = 35},
  [14122] = {.lex_state = 35},
  [14123] = {.lex_state = 35},
  [14124] = {.lex_state = 0},
  [14125] = {.lex_state = 0},
  [14126] = {.lex_state = 35},
  [14127] = {.lex_state = 0},
  [14128] = {.lex_state = 35},
  [14129] = {.lex_state = 35},
  [14130] = {.lex_state = 0},
  [14131] = {.lex_state = 0},
  [14132] = {.lex_state = 35},
  [14133] = {.lex_state = 35},
  [14134] = {.lex_state = 0},
  [14135] = {.lex_state = 0},
  [14136] = {.lex_state = 0},
  [14137] = {.lex_state = 0},
  [14138] = {.lex_state = 0},
  [14139] = {.lex_state = 0},
  [14140] = {.lex_state = 0},
  [14141] = {.lex_state = 0},
  [14142] = {.lex_state = 0},
  [14143] = {.lex_state = 0},
  [14144] = {.lex_state = 0},
  [14145] = {.lex_state = 0},
  [14146] = {.lex_state = 0},
  [14147] = {.lex_state = 0},
  [14148] = {.lex_state = 35},
  [14149] = {.lex_state = 0},
  [14150] = {.lex_state = 0},
  [14151] = {.lex_state = 35},
  [14152] = {.lex_state = 0},
  [14153] = {.lex_state = 0},
  [14154] = {.lex_state = 0},
  [14155] = {.lex_state = 35},
  [14156] = {.lex_state = 35},
  [14157] = {.lex_state = 0},
  [14158] = {.lex_state = 0},
  [14159] = {.lex_state = 0},
  [14160] = {.lex_state = 0},
  [14161] = {.lex_state = 35},
  [14162] = {.lex_state = 0},
  [14163] = {.lex_state = 35},
  [14164] = {.lex_state = 35},
  [14165] = {.lex_state = 0},
  [14166] = {.lex_state = 0},
  [14167] = {.lex_state = 35},
  [14168] = {.lex_state = 0},
  [14169] = {.lex_state = 35},
  [14170] = {.lex_state = 35},
  [14171] = {.lex_state = 0},
  [14172] = {.lex_state = 0},
  [14173] = {.lex_state = 0},
  [14174] = {.lex_state = 0},
  [14175] = {.lex_state = 0},
  [14176] = {.lex_state = 0},
  [14177] = {.lex_state = 0},
  [14178] = {.lex_state = 0},
  [14179] = {.lex_state = 0},
  [14180] = {.lex_state = 0},
  [14181] = {.lex_state = 35},
  [14182] = {.lex_state = 35},
  [14183] = {.lex_state = 0},
  [14184] = {.lex_state = 35},
  [14185] = {.lex_state = 0},
  [14186] = {.lex_state = 35},
  [14187] = {.lex_state = 35},
  [14188] = {.lex_state = 0},
  [14189] = {.lex_state = 0},
  [14190] = {.lex_state = 0},
  [14191] = {.lex_state = 0},
  [14192] = {.lex_state = 0},
  [14193] = {.lex_state = 0},
  [14194] = {.lex_state = 0},
  [14195] = {.lex_state = 0},
  [14196] = {.lex_state = 0},
  [14197] = {.lex_state = 35},
  [14198] = {.lex_state = 0},
  [14199] = {.lex_state = 0},
  [14200] = {.lex_state = 35},
  [14201] = {.lex_state = 0},
  [14202] = {.lex_state = 35},
  [14203] = {.lex_state = 35},
  [14204] = {.lex_state = 0},
  [14205] = {.lex_state = 0},
  [14206] = {.lex_state = 0},
  [14207] = {.lex_state = 0},
  [14208] = {.lex_state = 0},
  [14209] = {.lex_state = 0},
  [14210] = {.lex_state = 0},
  [14211] = {.lex_state = 0},
  [14212] = {.lex_state = 0},
  [14213] = {.lex_state = 35},
  [14214] = {.lex_state = 0},
  [14215] = {.lex_state = 0},
  [14216] = {.lex_state = 35},
  [14217] = {.lex_state = 0},
  [14218] = {.lex_state = 35},
  [14219] = {.lex_state = 35},
  [14220] = {.lex_state = 0},
  [14221] = {.lex_state = 0},
  [14222] = {.lex_state = 0},
  [14223] = {.lex_state = 0},
  [14224] = {.lex_state = 35},
  [14225] = {.lex_state = 35},
  [14226] = {.lex_state = 0},
  [14227] = {.lex_state = 35},
  [14228] = {.lex_state = 0},
  [14229] = {.lex_state = 35},
  [14230] = {.lex_state = 0},
  [14231] = {.lex_state = 0},
  [14232] = {.lex_state = 35},
  [14233] = {.lex_state = 0},
  [14234] = {.lex_state = 0},
  [14235] = {.lex_state = 0},
  [14236] = {.lex_state = 0},
  [14237] = {.lex_state = 0},
  [14238] = {.lex_state = 0},
  [14239] = {.lex_state = 0},
  [14240] = {.lex_state = 0},
  [14241] = {.lex_state = 0},
  [14242] = {.lex_state = 35},
  [14243] = {.lex_state = 0},
  [14244] = {.lex_state = 0},
  [14245] = {.lex_state = 35},
  [14246] = {.lex_state = 0},
  [14247] = {.lex_state = 0},
  [14248] = {.lex_state = 0},
  [14249] = {.lex_state = 0},
  [14250] = {.lex_state = 0},
  [14251] = {.lex_state = 0},
  [14252] = {.lex_state = 0},
  [14253] = {.lex_state = 0},
  [14254] = {.lex_state = 0},
  [14255] = {.lex_state = 0},
  [14256] = {.lex_state = 0},
  [14257] = {.lex_state = 0},
  [14258] = {.lex_state = 35},
  [14259] = {.lex_state = 35},
  [14260] = {.lex_state = 0},
  [14261] = {.lex_state = 0},
  [14262] = {.lex_state = 0},
  [14263] = {.lex_state = 0},
  [14264] = {.lex_state = 0},
  [14265] = {.lex_state = 0},
  [14266] = {.lex_state = 0},
  [14267] = {.lex_state = 0},
  [14268] = {.lex_state = 0},
  [14269] = {.lex_state = 0},
  [14270] = {.lex_state = 0},
  [14271] = {.lex_state = 0},
  [14272] = {.lex_state = 0},
  [14273] = {.lex_state = 0},
  [14274] = {.lex_state = 35},
  [14275] = {.lex_state = 35},
  [14276] = {.lex_state = 0},
  [14277] = {.lex_state = 0},
  [14278] = {.lex_state = 0},
  [14279] = {.lex_state = 0},
  [14280] = {.lex_state = 0},
  [14281] = {.lex_state = 0},
  [14282] = {.lex_state = 0},
  [14283] = {.lex_state = 0},
  [14284] = {.lex_state = 0},
  [14285] = {.lex_state = 0},
  [14286] = {.lex_state = 0},
  [14287] = {.lex_state = 0},
  [14288] = {.lex_state = 0},
  [14289] = {.lex_state = 0},
  [14290] = {.lex_state = 0},
  [14291] = {.lex_state = 0},
  [14292] = {.lex_state = 35},
  [14293] = {.lex_state = 0},
  [14294] = {.lex_state = 0},
  [14295] = {.lex_state = 0},
  [14296] = {.lex_state = 0},
  [14297] = {.lex_state = 0},
  [14298] = {.lex_state = 0},
  [14299] = {.lex_state = 0},
  [14300] = {.lex_state = 35},
  [14301] = {.lex_state = 0},
  [14302] = {.lex_state = 0},
  [14303] = {.lex_state = 0},
  [14304] = {.lex_state = 0},
  [14305] = {.lex_state = 0},
  [14306] = {.lex_state = 0},
  [14307] = {.lex_state = 0},
  [14308] = {.lex_state = 0, .external_lex_state = 2},
  [14309] = {.lex_state = 0},
  [14310] = {.lex_state = 0},
  [14311] = {.lex_state = 0},
  [14312] = {.lex_state = 0},
  [14313] = {.lex_state = 0},
  [14314] = {.lex_state = 0},
  [14315] = {.lex_state = 35},
  [14316] = {.lex_state = 0},
  [14317] = {.lex_state = 0},
  [14318] = {.lex_state = 0},
  [14319] = {.lex_state = 0},
  [14320] = {.lex_state = 0},
  [14321] = {.lex_state = 0},
  [14322] = {.lex_state = 0},
  [14323] = {.lex_state = 0},
  [14324] = {.lex_state = 0},
  [14325] = {.lex_state = 0},
  [14326] = {.lex_state = 0},
  [14327] = {.lex_state = 0},
  [14328] = {.lex_state = 0},
  [14329] = {.lex_state = 0},
  [14330] = {.lex_state = 0},
  [14331] = {.lex_state = 0},
  [14332] = {.lex_state = 0},
  [14333] = {.lex_state = 0},
  [14334] = {.lex_state = 0},
  [14335] = {.lex_state = 0},
  [14336] = {.lex_state = 0},
  [14337] = {.lex_state = 0},
  [14338] = {.lex_state = 0},
  [14339] = {.lex_state = 0},
  [14340] = {.lex_state = 0},
  [14341] = {.lex_state = 0},
  [14342] = {.lex_state = 0},
  [14343] = {.lex_state = 0},
  [14344] = {.lex_state = 0},
  [14345] = {.lex_state = 0},
  [14346] = {.lex_state = 0},
  [14347] = {.lex_state = 0},
  [14348] = {.lex_state = 0},
  [14349] = {.lex_state = 0},
  [14350] = {.lex_state = 35},
  [14351] = {.lex_state = 0},
  [14352] = {.lex_state = 35},
  [14353] = {.lex_state = 0},
  [14354] = {.lex_state = 0},
  [14355] = {.lex_state = 0},
  [14356] = {.lex_state = 35},
  [14357] = {.lex_state = 35},
  [14358] = {.lex_state = 0},
  [14359] = {.lex_state = 35},
  [14360] = {.lex_state = 0},
  [14361] = {.lex_state = 0},
  [14362] = {.lex_state = 35},
  [14363] = {.lex_state = 0},
  [14364] = {.lex_state = 35},
  [14365] = {.lex_state = 35},
  [14366] = {.lex_state = 0},
  [14367] = {.lex_state = 0},
  [14368] = {.lex_state = 0},
  [14369] = {.lex_state = 0, .external_lex_state = 2},
  [14370] = {.lex_state = 0},
  [14371] = {.lex_state = 35},
  [14372] = {.lex_state = 35},
  [14373] = {.lex_state = 35},
  [14374] = {.lex_state = 0},
  [14375] = {.lex_state = 0},
  [14376] = {.lex_state = 0},
  [14377] = {.lex_state = 35},
  [14378] = {.lex_state = 35},
  [14379] = {.lex_state = 0},
  [14380] = {.lex_state = 35},
  [14381] = {.lex_state = 0},
  [14382] = {.lex_state = 0},
  [14383] = {.lex_state = 0},
  [14384] = {.lex_state = 0},
  [14385] = {.lex_state = 35},
  [14386] = {.lex_state = 35},
  [14387] = {.lex_state = 35},
  [14388] = {.lex_state = 35},
  [14389] = {.lex_state = 0},
  [14390] = {.lex_state = 0},
  [14391] = {.lex_state = 0},
  [14392] = {.lex_state = 35},
  [14393] = {.lex_state = 35},
  [14394] = {.lex_state = 0},
  [14395] = {.lex_state = 0},
  [14396] = {.lex_state = 0},
  [14397] = {.lex_state = 0},
  [14398] = {.lex_state = 35},
  [14399] = {.lex_state = 0},
  [14400] = {.lex_state = 0},
  [14401] = {.lex_state = 35},
  [14402] = {.lex_state = 0},
  [14403] = {.lex_state = 0},
  [14404] = {.lex_state = 0},
  [14405] = {.lex_state = 0},
  [14406] = {.lex_state = 35},
  [14407] = {.lex_state = 35},
  [14408] = {.lex_state = 0},
  [14409] = {.lex_state = 0},
  [14410] = {.lex_state = 0},
  [14411] = {.lex_state = 0},
  [14412] = {.lex_state = 0},
  [14413] = {.lex_state = 0},
  [14414] = {.lex_state = 0},
  [14415] = {.lex_state = 0},
  [14416] = {.lex_state = 0},
  [14417] = {.lex_state = 0},
  [14418] = {.lex_state = 0},
  [14419] = {.lex_state = 0},
  [14420] = {.lex_state = 0},
  [14421] = {.lex_state = 0},
  [14422] = {.lex_state = 0},
  [14423] = {.lex_state = 35},
  [14424] = {.lex_state = 35},
  [14425] = {.lex_state = 0},
  [14426] = {.lex_state = 0},
  [14427] = {.lex_state = 0},
  [14428] = {.lex_state = 0},
  [14429] = {.lex_state = 0},
  [14430] = {.lex_state = 0},
  [14431] = {.lex_state = 0},
  [14432] = {.lex_state = 0},
  [14433] = {.lex_state = 0},
  [14434] = {.lex_state = 0},
  [14435] = {.lex_state = 0},
  [14436] = {.lex_state = 0},
  [14437] = {.lex_state = 0},
  [14438] = {.lex_state = 0},
  [14439] = {.lex_state = 0},
  [14440] = {.lex_state = 0},
  [14441] = {.lex_state = 0},
  [14442] = {.lex_state = 0},
  [14443] = {.lex_state = 0},
  [14444] = {.lex_state = 0},
  [14445] = {.lex_state = 0},
  [14446] = {.lex_state = 0},
  [14447] = {.lex_state = 0},
  [14448] = {.lex_state = 0},
  [14449] = {.lex_state = 0},
  [14450] = {.lex_state = 0},
  [14451] = {.lex_state = 0},
  [14452] = {.lex_state = 0},
  [14453] = {.lex_state = 0},
  [14454] = {.lex_state = 0},
  [14455] = {.lex_state = 0},
  [14456] = {.lex_state = 0},
  [14457] = {.lex_state = 0},
  [14458] = {.lex_state = 0},
  [14459] = {.lex_state = 35},
  [14460] = {.lex_state = 0},
  [14461] = {.lex_state = 0},
  [14462] = {.lex_state = 0},
  [14463] = {.lex_state = 0},
  [14464] = {.lex_state = 0},
  [14465] = {.lex_state = 0},
  [14466] = {.lex_state = 0},
  [14467] = {.lex_state = 0},
  [14468] = {.lex_state = 35},
  [14469] = {.lex_state = 0},
  [14470] = {.lex_state = 0},
  [14471] = {.lex_state = 0},
  [14472] = {.lex_state = 35},
  [14473] = {.lex_state = 0},
  [14474] = {.lex_state = 0},
  [14475] = {.lex_state = 0},
  [14476] = {.lex_state = 35},
  [14477] = {.lex_state = 0},
  [14478] = {.lex_state = 0},
  [14479] = {.lex_state = 0},
  [14480] = {.lex_state = 0},
  [14481] = {.lex_state = 0},
  [14482] = {.lex_state = 0},
  [14483] = {.lex_state = 35},
  [14484] = {.lex_state = 33},
  [14485] = {.lex_state = 0},
  [14486] = {.lex_state = 0},
  [14487] = {.lex_state = 0},
  [14488] = {.lex_state = 0},
  [14489] = {.lex_state = 0},
  [14490] = {.lex_state = 0},
  [14491] = {.lex_state = 0},
  [14492] = {.lex_state = 0},
  [14493] = {.lex_state = 0},
  [14494] = {.lex_state = 0},
  [14495] = {.lex_state = 0},
  [14496] = {.lex_state = 0},
  [14497] = {.lex_state = 0},
  [14498] = {.lex_state = 35},
  [14499] = {.lex_state = 0},
  [14500] = {.lex_state = 0},
  [14501] = {.lex_state = 0},
  [14502] = {.lex_state = 0},
  [14503] = {.lex_state = 0},
  [14504] = {.lex_state = 0},
  [14505] = {.lex_state = 0},
  [14506] = {.lex_state = 0},
  [14507] = {.lex_state = 0},
  [14508] = {.lex_state = 0},
  [14509] = {.lex_state = 0},
  [14510] = {.lex_state = 0},
  [14511] = {.lex_state = 35},
  [14512] = {.lex_state = 0},
  [14513] = {.lex_state = 0},
  [14514] = {.lex_state = 0},
  [14515] = {.lex_state = 0},
  [14516] = {.lex_state = 35},
  [14517] = {.lex_state = 0},
  [14518] = {.lex_state = 0},
  [14519] = {.lex_state = 0},
  [14520] = {.lex_state = 35},
  [14521] = {.lex_state = 0},
  [14522] = {.lex_state = 0},
  [14523] = {.lex_state = 35},
  [14524] = {.lex_state = 0},
  [14525] = {.lex_state = 0},
  [14526] = {.lex_state = 0},
  [14527] = {.lex_state = 0},
  [14528] = {.lex_state = 0},
  [14529] = {.lex_state = 0},
  [14530] = {.lex_state = 0},
  [14531] = {.lex_state = 0},
  [14532] = {.lex_state = 0},
  [14533] = {.lex_state = 0},
  [14534] = {.lex_state = 0},
  [14535] = {.lex_state = 0},
  [14536] = {.lex_state = 0},
  [14537] = {.lex_state = 0},
  [14538] = {.lex_state = 0},
  [14539] = {.lex_state = 0},
  [14540] = {.lex_state = 0},
  [14541] = {.lex_state = 0},
  [14542] = {.lex_state = 0},
  [14543] = {.lex_state = 0},
  [14544] = {.lex_state = 0},
  [14545] = {.lex_state = 0},
  [14546] = {.lex_state = 0},
  [14547] = {.lex_state = 0},
  [14548] = {.lex_state = 0},
  [14549] = {.lex_state = 35},
  [14550] = {.lex_state = 0},
  [14551] = {.lex_state = 35},
  [14552] = {.lex_state = 35},
  [14553] = {.lex_state = 0},
  [14554] = {.lex_state = 35},
  [14555] = {.lex_state = 0},
  [14556] = {.lex_state = 35},
  [14557] = {.lex_state = 35},
  [14558] = {.lex_state = 35},
  [14559] = {.lex_state = 0},
  [14560] = {.lex_state = 35},
  [14561] = {.lex_state = 0},
  [14562] = {.lex_state = 35},
  [14563] = {.lex_state = 35},
  [14564] = {.lex_state = 0},
  [14565] = {.lex_state = 0},
  [14566] = {.lex_state = 0},
  [14567] = {.lex_state = 0},
  [14568] = {.lex_state = 0},
  [14569] = {.lex_state = 0},
  [14570] = {.lex_state = 0},
  [14571] = {.lex_state = 0},
  [14572] = {.lex_state = 0},
  [14573] = {.lex_state = 35},
  [14574] = {.lex_state = 0},
  [14575] = {.lex_state = 0},
  [14576] = {.lex_state = 0},
  [14577] = {.lex_state = 0},
  [14578] = {.lex_state = 0},
  [14579] = {.lex_state = 35},
  [14580] = {.lex_state = 0},
  [14581] = {.lex_state = 0},
  [14582] = {.lex_state = 35},
  [14583] = {.lex_state = 0},
  [14584] = {.lex_state = 35},
  [14585] = {.lex_state = 0},
  [14586] = {.lex_state = 35},
  [14587] = {.lex_state = 0},
  [14588] = {.lex_state = 35},
  [14589] = {.lex_state = 0},
  [14590] = {.lex_state = 0},
  [14591] = {.lex_state = 0},
  [14592] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_keyword_select] = ACTIONS(1),
    [sym_keyword_delete] = ACTIONS(1),
    [sym_keyword_insert] = ACTIONS(1),
    [sym_keyword_replace] = ACTIONS(1),
    [sym_keyword_update] = ACTIONS(1),
    [sym_keyword_truncate] = ACTIONS(1),
    [sym_keyword_merge] = ACTIONS(1),
    [sym_keyword_into] = ACTIONS(1),
    [sym_keyword_overwrite] = ACTIONS(1),
    [sym_keyword_values] = ACTIONS(1),
    [sym_keyword_value] = ACTIONS(1),
    [sym_keyword_matched] = ACTIONS(1),
    [sym_keyword_set] = ACTIONS(1),
    [sym_keyword_from] = ACTIONS(1),
    [sym_keyword_left] = ACTIONS(1),
    [sym_keyword_right] = ACTIONS(1),
    [sym_keyword_inner] = ACTIONS(1),
    [sym_keyword_full] = ACTIONS(1),
    [sym_keyword_outer] = ACTIONS(1),
    [sym_keyword_cross] = ACTIONS(1),
    [sym_keyword_join] = ACTIONS(1),
    [sym_keyword_lateral] = ACTIONS(1),
    [sym_keyword_natural] = ACTIONS(1),
    [sym_keyword_on] = ACTIONS(1),
    [sym_keyword_off] = ACTIONS(1),
    [sym_keyword_where] = ACTIONS(1),
    [sym_keyword_order] = ACTIONS(1),
    [sym_keyword_group] = ACTIONS(1),
    [sym_keyword_partition] = ACTIONS(1),
    [sym_keyword_by] = ACTIONS(1),
    [sym_keyword_having] = ACTIONS(1),
    [sym_keyword_desc] = ACTIONS(1),
    [sym_keyword_asc] = ACTIONS(1),
    [sym_keyword_limit] = ACTIONS(1),
    [sym_keyword_offset] = ACTIONS(1),
    [sym_keyword_primary] = ACTIONS(1),
    [sym_keyword_create] = ACTIONS(1),
    [sym_keyword_alter] = ACTIONS(1),
    [sym_keyword_change] = ACTIONS(1),
    [sym_keyword_analyze] = ACTIONS(1),
    [sym_keyword_explain] = ACTIONS(1),
    [sym_keyword_verbose] = ACTIONS(1),
    [sym_keyword_modify] = ACTIONS(1),
    [sym_keyword_drop] = ACTIONS(1),
    [sym_keyword_add] = ACTIONS(1),
    [sym_keyword_table] = ACTIONS(1),
    [sym_keyword_tables] = ACTIONS(1),
    [sym_keyword_view] = ACTIONS(1),
    [sym_keyword_column] = ACTIONS(1),
    [sym_keyword_columns] = ACTIONS(1),
    [sym_keyword_materialized] = ACTIONS(1),
    [sym_keyword_tablespace] = ACTIONS(1),
    [sym_keyword_sequence] = ACTIONS(1),
    [sym_keyword_increment] = ACTIONS(1),
    [sym_keyword_minvalue] = ACTIONS(1),
    [sym_keyword_maxvalue] = ACTIONS(1),
    [sym_keyword_none] = ACTIONS(1),
    [sym_keyword_owned] = ACTIONS(1),
    [sym_keyword_start] = ACTIONS(1),
    [sym_keyword_restart] = ACTIONS(1),
    [sym_keyword_key] = ACTIONS(1),
    [sym_keyword_as] = ACTIONS(1),
    [sym_keyword_distinct] = ACTIONS(1),
    [sym_keyword_constraint] = ACTIONS(1),
    [sym_keyword_filter] = ACTIONS(1),
    [sym_keyword_cast] = ACTIONS(1),
    [sym_keyword_separator] = ACTIONS(1),
    [sym_keyword_max] = ACTIONS(1),
    [sym_keyword_min] = ACTIONS(1),
    [sym_keyword_avg] = ACTIONS(1),
    [sym_keyword_case] = ACTIONS(1),
    [sym_keyword_when] = ACTIONS(1),
    [sym_keyword_then] = ACTIONS(1),
    [sym_keyword_else] = ACTIONS(1),
    [sym_keyword_end] = ACTIONS(1),
    [sym_keyword_in] = ACTIONS(1),
    [sym_keyword_and] = ACTIONS(1),
    [sym_keyword_or] = ACTIONS(1),
    [sym_keyword_is] = ACTIONS(1),
    [sym_keyword_not] = ACTIONS(1),
    [sym_keyword_force] = ACTIONS(1),
    [sym_keyword_ignore] = ACTIONS(1),
    [sym_keyword_using] = ACTIONS(1),
    [sym_keyword_use] = ACTIONS(1),
    [sym_keyword_index] = ACTIONS(1),
    [sym_keyword_for] = ACTIONS(1),
    [sym_keyword_if] = ACTIONS(1),
    [sym_keyword_exists] = ACTIONS(1),
    [sym_keyword_auto_increment] = ACTIONS(1),
    [sym_keyword_generated] = ACTIONS(1),
    [sym_keyword_always] = ACTIONS(1),
    [sym_keyword_collate] = ACTIONS(1),
    [aux_sym_keyword_character_token1] = ACTIONS(1),
    [sym_keyword_engine] = ACTIONS(1),
    [sym_keyword_default] = ACTIONS(1),
    [sym_keyword_cascade] = ACTIONS(1),
    [sym_keyword_restrict] = ACTIONS(1),
    [sym_keyword_with] = ACTIONS(1),
    [sym_keyword_without] = ACTIONS(1),
    [sym_keyword_no] = ACTIONS(1),
    [sym_keyword_data] = ACTIONS(1),
    [sym_keyword_type] = ACTIONS(1),
    [sym_keyword_rename] = ACTIONS(1),
    [sym_keyword_to] = ACTIONS(1),
    [sym_keyword_database] = ACTIONS(1),
    [sym_keyword_schema] = ACTIONS(1),
    [sym_keyword_owner] = ACTIONS(1),
    [sym_keyword_user] = ACTIONS(1),
    [sym_keyword_admin] = ACTIONS(1),
    [sym_keyword_password] = ACTIONS(1),
    [sym_keyword_encrypted] = ACTIONS(1),
    [sym_keyword_valid] = ACTIONS(1),
    [sym_keyword_until] = ACTIONS(1),
    [sym_keyword_connection] = ACTIONS(1),
    [sym_keyword_role] = ACTIONS(1),
    [sym_keyword_reset] = ACTIONS(1),
    [sym_keyword_temp] = ACTIONS(1),
    [sym_keyword_temporary] = ACTIONS(1),
    [sym_keyword_unlogged] = ACTIONS(1),
    [sym_keyword_logged] = ACTIONS(1),
    [sym_keyword_cycle] = ACTIONS(1),
    [sym_keyword_union] = ACTIONS(1),
    [sym_keyword_all] = ACTIONS(1),
    [sym_keyword_any] = ACTIONS(1),
    [sym_keyword_some] = ACTIONS(1),
    [sym_keyword_except] = ACTIONS(1),
    [sym_keyword_intersect] = ACTIONS(1),
    [sym_keyword_returning] = ACTIONS(1),
    [sym_keyword_begin] = ACTIONS(1),
    [sym_keyword_commit] = ACTIONS(1),
    [sym_keyword_rollback] = ACTIONS(1),
    [sym_keyword_transaction] = ACTIONS(1),
    [sym_keyword_over] = ACTIONS(1),
    [sym_keyword_nulls] = ACTIONS(1),
    [sym_keyword_first] = ACTIONS(1),
    [sym_keyword_after] = ACTIONS(1),
    [sym_keyword_before] = ACTIONS(1),
    [sym_keyword_last] = ACTIONS(1),
    [sym_keyword_window] = ACTIONS(1),
    [sym_keyword_range] = ACTIONS(1),
    [sym_keyword_rows] = ACTIONS(1),
    [sym_keyword_groups] = ACTIONS(1),
    [sym_keyword_between] = ACTIONS(1),
    [sym_keyword_unbounded] = ACTIONS(1),
    [sym_keyword_preceding] = ACTIONS(1),
    [sym_keyword_following] = ACTIONS(1),
    [sym_keyword_exclude] = ACTIONS(1),
    [sym_keyword_current] = ACTIONS(1),
    [sym_keyword_row] = ACTIONS(1),
    [sym_keyword_ties] = ACTIONS(1),
    [sym_keyword_others] = ACTIONS(1),
    [sym_keyword_only] = ACTIONS(1),
    [sym_keyword_unique] = ACTIONS(1),
    [sym_keyword_foreign] = ACTIONS(1),
    [sym_keyword_references] = ACTIONS(1),
    [sym_keyword_concurrently] = ACTIONS(1),
    [sym_keyword_btree] = ACTIONS(1),
    [sym_keyword_hash] = ACTIONS(1),
    [sym_keyword_gist] = ACTIONS(1),
    [sym_keyword_spgist] = ACTIONS(1),
    [sym_keyword_gin] = ACTIONS(1),
    [sym_keyword_brin] = ACTIONS(1),
    [aux_sym_keyword_like_token1] = ACTIONS(1),
    [aux_sym_keyword_like_token2] = ACTIONS(1),
    [sym_keyword_similar] = ACTIONS(1),
    [sym_keyword_preserve] = ACTIONS(1),
    [sym_keyword_unsigned] = ACTIONS(1),
    [sym_keyword_zerofill] = ACTIONS(1),
    [sym_keyword_conflict] = ACTIONS(1),
    [sym_keyword_do] = ACTIONS(1),
    [sym_keyword_nothing] = ACTIONS(1),
    [sym_keyword_high_priority] = ACTIONS(1),
    [sym_keyword_low_priority] = ACTIONS(1),
    [sym_keyword_delayed] = ACTIONS(1),
    [sym_keyword_recursive] = ACTIONS(1),
    [sym_keyword_cascaded] = ACTIONS(1),
    [sym_keyword_local] = ACTIONS(1),
    [sym_keyword_current_timestamp] = ACTIONS(1),
    [sym_keyword_check] = ACTIONS(1),
    [sym_keyword_option] = ACTIONS(1),
    [sym_keyword_vacuum] = ACTIONS(1),
    [sym_keyword_wait] = ACTIONS(1),
    [sym_keyword_nowait] = ACTIONS(1),
    [sym_keyword_attribute] = ACTIONS(1),
    [sym_keyword_authorization] = ACTIONS(1),
    [sym_keyword_action] = ACTIONS(1),
    [sym_keyword_extension] = ACTIONS(1),
    [sym_keyword_copy] = ACTIONS(1),
    [sym_keyword_stdin] = ACTIONS(1),
    [sym_keyword_freeze] = ACTIONS(1),
    [sym_keyword_escape] = ACTIONS(1),
    [sym_keyword_encoding] = ACTIONS(1),
    [sym_keyword_force_quote] = ACTIONS(1),
    [sym_keyword_quote] = ACTIONS(1),
    [sym_keyword_force_null] = ACTIONS(1),
    [sym_keyword_force_not_null] = ACTIONS(1),
    [sym_keyword_header] = ACTIONS(1),
    [sym_keyword_match] = ACTIONS(1),
    [sym_keyword_program] = ACTIONS(1),
    [sym_keyword_plain] = ACTIONS(1),
    [sym_keyword_extended] = ACTIONS(1),
    [sym_keyword_main] = ACTIONS(1),
    [sym_keyword_storage] = ACTIONS(1),
    [sym_keyword_compression] = ACTIONS(1),
    [sym_keyword_trigger] = ACTIONS(1),
    [sym_keyword_function] = ACTIONS(1),
    [sym_keyword_returns] = ACTIONS(1),
    [sym_keyword_return] = ACTIONS(1),
    [sym_keyword_setof] = ACTIONS(1),
    [sym_keyword_atomic] = ACTIONS(1),
    [sym_keyword_declare] = ACTIONS(1),
    [sym_keyword_language] = ACTIONS(1),
    [sym_keyword_sql] = ACTIONS(1),
    [sym_keyword_plpgsql] = ACTIONS(1),
    [sym_keyword_immutable] = ACTIONS(1),
    [sym_keyword_stable] = ACTIONS(1),
    [sym_keyword_volatile] = ACTIONS(1),
    [sym_keyword_leakproof] = ACTIONS(1),
    [sym_keyword_parallel] = ACTIONS(1),
    [sym_keyword_safe] = ACTIONS(1),
    [sym_keyword_unsafe] = ACTIONS(1),
    [sym_keyword_restricted] = ACTIONS(1),
    [sym_keyword_called] = ACTIONS(1),
    [sym_keyword_input] = ACTIONS(1),
    [sym_keyword_strict] = ACTIONS(1),
    [sym_keyword_cost] = ACTIONS(1),
    [sym_keyword_support] = ACTIONS(1),
    [sym_keyword_definer] = ACTIONS(1),
    [sym_keyword_invoker] = ACTIONS(1),
    [sym_keyword_security] = ACTIONS(1),
    [sym_keyword_version] = ACTIONS(1),
    [sym_keyword_out] = ACTIONS(1),
    [sym_keyword_inout] = ACTIONS(1),
    [sym_keyword_variadic] = ACTIONS(1),
    [sym_keyword_session] = ACTIONS(1),
    [sym_keyword_isolation] = ACTIONS(1),
    [sym_keyword_level] = ACTIONS(1),
    [sym_keyword_serializable] = ACTIONS(1),
    [sym_keyword_repeatable] = ACTIONS(1),
    [sym_keyword_read] = ACTIONS(1),
    [sym_keyword_write] = ACTIONS(1),
    [sym_keyword_committed] = ACTIONS(1),
    [sym_keyword_uncommitted] = ACTIONS(1),
    [sym_keyword_deferrable] = ACTIONS(1),
    [sym_keyword_names] = ACTIONS(1),
    [sym_keyword_zone] = ACTIONS(1),
    [sym_keyword_immediate] = ACTIONS(1),
    [sym_keyword_deferred] = ACTIONS(1),
    [sym_keyword_constraints] = ACTIONS(1),
    [sym_keyword_snapshot] = ACTIONS(1),
    [sym_keyword_characteristics] = ACTIONS(1),
    [sym_keyword_follows] = ACTIONS(1),
    [sym_keyword_precedes] = ACTIONS(1),
    [sym_keyword_each] = ACTIONS(1),
    [sym_keyword_instead] = ACTIONS(1),
    [sym_keyword_of] = ACTIONS(1),
    [sym_keyword_initially] = ACTIONS(1),
    [sym_keyword_old] = ACTIONS(1),
    [sym_keyword_new] = ACTIONS(1),
    [sym_keyword_referencing] = ACTIONS(1),
    [sym_keyword_statement] = ACTIONS(1),
    [sym_keyword_execute] = ACTIONS(1),
    [sym_keyword_procedure] = ACTIONS(1),
    [sym_keyword_external] = ACTIONS(1),
    [sym_keyword_stored] = ACTIONS(1),
    [sym_keyword_virtual] = ACTIONS(1),
    [sym_keyword_cached] = ACTIONS(1),
    [sym_keyword_uncached] = ACTIONS(1),
    [sym_keyword_replication] = ACTIONS(1),
    [sym_keyword_tblproperties] = ACTIONS(1),
    [sym_keyword_options] = ACTIONS(1),
    [sym_keyword_compute] = ACTIONS(1),
    [sym_keyword_stats] = ACTIONS(1),
    [sym_keyword_statistics] = ACTIONS(1),
    [sym_keyword_optimize] = ACTIONS(1),
    [sym_keyword_rewrite] = ACTIONS(1),
    [sym_keyword_bin_pack] = ACTIONS(1),
    [sym_keyword_incremental] = ACTIONS(1),
    [sym_keyword_location] = ACTIONS(1),
    [sym_keyword_partitioned] = ACTIONS(1),
    [sym_keyword_comment] = ACTIONS(1),
    [sym_keyword_sort] = ACTIONS(1),
    [sym_keyword_format] = ACTIONS(1),
    [sym_keyword_delimited] = ACTIONS(1),
    [sym_keyword_delimiter] = ACTIONS(1),
    [sym_keyword_fields] = ACTIONS(1),
    [sym_keyword_terminated] = ACTIONS(1),
    [sym_keyword_escaped] = ACTIONS(1),
    [sym_keyword_lines] = ACTIONS(1),
    [sym_keyword_cache] = ACTIONS(1),
    [sym_keyword_metadata] = ACTIONS(1),
    [sym_keyword_noscan] = ACTIONS(1),
    [sym_keyword_parquet] = ACTIONS(1),
    [sym_keyword_rcfile] = ACTIONS(1),
    [sym_keyword_csv] = ACTIONS(1),
    [sym_keyword_textfile] = ACTIONS(1),
    [sym_keyword_avro] = ACTIONS(1),
    [sym_keyword_sequencefile] = ACTIONS(1),
    [sym_keyword_orc] = ACTIONS(1),
    [sym_keyword_jsonfile] = ACTIONS(1),
    [sym_keyword_null] = ACTIONS(1),
    [sym_keyword_true] = ACTIONS(1),
    [sym_keyword_false] = ACTIONS(1),
    [sym_keyword_boolean] = ACTIONS(1),
    [sym_keyword_bit] = ACTIONS(1),
    [sym_keyword_binary] = ACTIONS(1),
    [sym_keyword_varbinary] = ACTIONS(1),
    [sym_keyword_image] = ACTIONS(1),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1),
    [aux_sym_keyword_serial_token1] = ACTIONS(1),
    [aux_sym_keyword_serial_token2] = ACTIONS(1),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1),
    [aux_sym_keyword_int_token1] = ACTIONS(1),
    [aux_sym_keyword_int_token2] = ACTIONS(1),
    [aux_sym_keyword_int_token3] = ACTIONS(1),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1),
    [sym_keyword_decimal] = ACTIONS(1),
    [sym_keyword_numeric] = ACTIONS(1),
    [aux_sym_keyword_real_token1] = ACTIONS(1),
    [aux_sym_keyword_real_token2] = ACTIONS(1),
    [sym_keyword_float] = ACTIONS(1),
    [sym_keyword_double] = ACTIONS(1),
    [sym_keyword_precision] = ACTIONS(1),
    [sym_keyword_inet] = ACTIONS(1),
    [sym_keyword_money] = ACTIONS(1),
    [sym_keyword_smallmoney] = ACTIONS(1),
    [sym_keyword_varying] = ACTIONS(1),
    [aux_sym_keyword_char_token1] = ACTIONS(1),
    [sym_keyword_nchar] = ACTIONS(1),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1),
    [sym_keyword_nvarchar] = ACTIONS(1),
    [sym_keyword_text] = ACTIONS(1),
    [sym_keyword_string] = ACTIONS(1),
    [sym_keyword_uuid] = ACTIONS(1),
    [sym_keyword_json] = ACTIONS(1),
    [sym_keyword_jsonb] = ACTIONS(1),
    [sym_keyword_xml] = ACTIONS(1),
    [sym_keyword_bytea] = ACTIONS(1),
    [sym_keyword_enum] = ACTIONS(1),
    [sym_keyword_date] = ACTIONS(1),
    [sym_keyword_datetime] = ACTIONS(1),
    [sym_keyword_datetime2] = ACTIONS(1),
    [sym_keyword_smalldatetime] = ACTIONS(1),
    [sym_keyword_datetimeoffset] = ACTIONS(1),
    [sym_keyword_time] = ACTIONS(1),
    [sym_keyword_timestamp] = ACTIONS(1),
    [sym_keyword_timestamptz] = ACTIONS(1),
    [sym_keyword_interval] = ACTIONS(1),
    [sym_keyword_geometry] = ACTIONS(1),
    [sym_keyword_geography] = ACTIONS(1),
    [sym_keyword_box2d] = ACTIONS(1),
    [sym_keyword_box3d] = ACTIONS(1),
    [sym_keyword_oid] = ACTIONS(1),
    [sym_keyword_oids] = ACTIONS(1),
    [sym_keyword_name] = ACTIONS(1),
    [sym_keyword_regclass] = ACTIONS(1),
    [sym_keyword_regnamespace] = ACTIONS(1),
    [sym_keyword_regproc] = ACTIONS(1),
    [sym_keyword_regtype] = ACTIONS(1),
    [sym_keyword_array] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_double_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [sym_parameter] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [sym_op_unary_other] = ACTIONS(1),
    [sym__double_quote_string] = ACTIONS(1),
    [aux_sym__single_quote_string_token1] = ACTIONS(1),
    [aux_sym__single_quote_string_token2] = ACTIONS(1),
    [sym__natural_number] = ACTIONS(1),
    [aux_sym__bit_string_token1] = ACTIONS(1),
    [sym_bang] = ACTIONS(1),
    [aux_sym_identifier_token1] = ACTIONS(1),
    [sym__dollar_quoted_string_start_tag] = ACTIONS(1),
    [sym__dollar_quoted_string_end_tag] = ACTIONS(1),
    [sym__dollar_quoted_string] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(14456),
    [sym_transaction] = STATE(14454),
    [sym_block] = STATE(14454),
    [sym_statement] = STATE(11347),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_program_repeat1] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_begin] = ACTIONS(37),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [2] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(9872),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_default] = ACTIONS(55),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [sym_keyword_array] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(113),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [3] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(9826),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_default] = ACTIONS(55),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [sym_keyword_array] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(113),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [4] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(10023),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym__argmode] = STATE(21),
    [sym_function_argument] = STATE(10531),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(3),
    [sym__identifier] = ACTIONS(117),
    [sym_keyword_in] = ACTIONS(119),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_out] = ACTIONS(121),
    [sym_keyword_inout] = ACTIONS(121),
    [sym_keyword_variadic] = ACTIONS(121),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [anon_sym_RPAREN] = ACTIONS(123),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(125),
    [aux_sym_identifier_token1] = ACTIONS(125),
  },
  [5] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(10023),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym__argmode] = STATE(21),
    [sym_function_argument] = STATE(11839),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(3),
    [sym__identifier] = ACTIONS(117),
    [sym_keyword_in] = ACTIONS(119),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_out] = ACTIONS(121),
    [sym_keyword_inout] = ACTIONS(121),
    [sym_keyword_variadic] = ACTIONS(121),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(125),
    [aux_sym_identifier_token1] = ACTIONS(125),
  },
  [6] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6449),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [sym_keyword_table] = ACTIONS(129),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_trigger] = ACTIONS(135),
    [sym_keyword_setof] = ACTIONS(137),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [7] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6462),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [sym_keyword_table] = ACTIONS(193),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_trigger] = ACTIONS(195),
    [sym_keyword_setof] = ACTIONS(197),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [8] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6452),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [sym_keyword_table] = ACTIONS(199),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_trigger] = ACTIONS(201),
    [sym_keyword_setof] = ACTIONS(203),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [9] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6457),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [sym_keyword_table] = ACTIONS(205),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_trigger] = ACTIONS(207),
    [sym_keyword_setof] = ACTIONS(209),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [10] = {
    [sym_keyword_smallserial] = STATE(2743),
    [sym_keyword_serial] = STATE(2743),
    [sym_keyword_bigserial] = STATE(2743),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(4323),
    [sym_tinyint] = STATE(2743),
    [sym_smallint] = STATE(2743),
    [sym_mediumint] = STATE(2743),
    [sym_int] = STATE(2743),
    [sym_bigint] = STATE(2743),
    [sym_bit] = STATE(2743),
    [sym_binary] = STATE(2743),
    [sym_varbinary] = STATE(2743),
    [sym_float] = STATE(2743),
    [sym_double] = STATE(2743),
    [sym_decimal] = STATE(2743),
    [sym_numeric] = STATE(2743),
    [sym_char] = STATE(2743),
    [sym_varchar] = STATE(2743),
    [sym_nchar] = STATE(2743),
    [sym_nvarchar] = STATE(2743),
    [sym_datetimeoffset] = STATE(2743),
    [sym_time] = STATE(2743),
    [sym_timestamp] = STATE(2743),
    [sym_enum] = STATE(2743),
    [sym_object_reference] = STATE(2755),
    [sym_identifier] = STATE(3344),
    [sym__identifier] = ACTIONS(211),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(213),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(213),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(213),
    [sym_keyword_money] = ACTIONS(213),
    [sym_keyword_smallmoney] = ACTIONS(213),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(213),
    [sym_keyword_string] = ACTIONS(213),
    [sym_keyword_uuid] = ACTIONS(213),
    [sym_keyword_json] = ACTIONS(213),
    [sym_keyword_jsonb] = ACTIONS(213),
    [sym_keyword_xml] = ACTIONS(213),
    [sym_keyword_bytea] = ACTIONS(213),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(213),
    [sym_keyword_datetime] = ACTIONS(213),
    [sym_keyword_datetime2] = ACTIONS(213),
    [sym_keyword_smalldatetime] = ACTIONS(213),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(213),
    [sym_keyword_interval] = ACTIONS(213),
    [sym_keyword_geometry] = ACTIONS(213),
    [sym_keyword_geography] = ACTIONS(213),
    [sym_keyword_box2d] = ACTIONS(213),
    [sym_keyword_box3d] = ACTIONS(213),
    [sym_keyword_oid] = ACTIONS(213),
    [sym_keyword_name] = ACTIONS(213),
    [sym_keyword_regclass] = ACTIONS(213),
    [sym_keyword_regnamespace] = ACTIONS(213),
    [sym_keyword_regproc] = ACTIONS(213),
    [sym_keyword_regtype] = ACTIONS(213),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(215),
    [aux_sym_identifier_token1] = ACTIONS(215),
  },
  [11] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12337),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [12] = {
    [sym_keyword_smallserial] = STATE(2776),
    [sym_keyword_serial] = STATE(2776),
    [sym_keyword_bigserial] = STATE(2776),
    [sym_keyword_tinyint] = STATE(2825),
    [sym_keyword_smallint] = STATE(2824),
    [sym_keyword_mediumint] = STATE(2821),
    [sym_keyword_int] = STATE(2819),
    [sym_keyword_bigint] = STATE(2818),
    [sym_keyword_real] = STATE(2814),
    [sym_keyword_char] = STATE(3411),
    [sym_keyword_varchar] = STATE(3412),
    [sym__type] = STATE(4154),
    [sym_tinyint] = STATE(2776),
    [sym_smallint] = STATE(2776),
    [sym_mediumint] = STATE(2776),
    [sym_int] = STATE(2776),
    [sym_bigint] = STATE(2776),
    [sym_bit] = STATE(2776),
    [sym_binary] = STATE(2776),
    [sym_varbinary] = STATE(2776),
    [sym_float] = STATE(2776),
    [sym_double] = STATE(2776),
    [sym_decimal] = STATE(2776),
    [sym_numeric] = STATE(2776),
    [sym_char] = STATE(2776),
    [sym_varchar] = STATE(2776),
    [sym_nchar] = STATE(2776),
    [sym_nvarchar] = STATE(2776),
    [sym_datetimeoffset] = STATE(2776),
    [sym_time] = STATE(2776),
    [sym_timestamp] = STATE(2776),
    [sym_enum] = STATE(2776),
    [sym_object_reference] = STATE(2775),
    [sym_identifier] = STATE(3284),
    [sym__identifier] = ACTIONS(217),
    [aux_sym_keyword_character_token1] = ACTIONS(219),
    [sym_keyword_unsigned] = ACTIONS(221),
    [sym_keyword_boolean] = ACTIONS(223),
    [sym_keyword_bit] = ACTIONS(225),
    [sym_keyword_binary] = ACTIONS(227),
    [sym_keyword_varbinary] = ACTIONS(229),
    [sym_keyword_image] = ACTIONS(223),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(231),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(231),
    [aux_sym_keyword_serial_token1] = ACTIONS(233),
    [aux_sym_keyword_serial_token2] = ACTIONS(233),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(235),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(235),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(237),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(237),
    [aux_sym_keyword_smallint_token1] = ACTIONS(239),
    [aux_sym_keyword_smallint_token2] = ACTIONS(239),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(241),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(241),
    [aux_sym_keyword_int_token1] = ACTIONS(243),
    [aux_sym_keyword_int_token2] = ACTIONS(243),
    [aux_sym_keyword_int_token3] = ACTIONS(243),
    [aux_sym_keyword_bigint_token1] = ACTIONS(245),
    [aux_sym_keyword_bigint_token2] = ACTIONS(245),
    [sym_keyword_decimal] = ACTIONS(247),
    [sym_keyword_numeric] = ACTIONS(249),
    [aux_sym_keyword_real_token1] = ACTIONS(251),
    [aux_sym_keyword_real_token2] = ACTIONS(251),
    [sym_keyword_float] = ACTIONS(253),
    [sym_keyword_double] = ACTIONS(255),
    [sym_keyword_inet] = ACTIONS(223),
    [sym_keyword_money] = ACTIONS(223),
    [sym_keyword_smallmoney] = ACTIONS(223),
    [aux_sym_keyword_char_token1] = ACTIONS(257),
    [sym_keyword_nchar] = ACTIONS(259),
    [aux_sym_keyword_varchar_token1] = ACTIONS(261),
    [sym_keyword_nvarchar] = ACTIONS(263),
    [sym_keyword_text] = ACTIONS(223),
    [sym_keyword_string] = ACTIONS(223),
    [sym_keyword_uuid] = ACTIONS(223),
    [sym_keyword_json] = ACTIONS(223),
    [sym_keyword_jsonb] = ACTIONS(223),
    [sym_keyword_xml] = ACTIONS(223),
    [sym_keyword_bytea] = ACTIONS(223),
    [sym_keyword_enum] = ACTIONS(265),
    [sym_keyword_date] = ACTIONS(223),
    [sym_keyword_datetime] = ACTIONS(223),
    [sym_keyword_datetime2] = ACTIONS(223),
    [sym_keyword_smalldatetime] = ACTIONS(223),
    [sym_keyword_datetimeoffset] = ACTIONS(267),
    [sym_keyword_time] = ACTIONS(269),
    [sym_keyword_timestamp] = ACTIONS(271),
    [sym_keyword_timestamptz] = ACTIONS(223),
    [sym_keyword_interval] = ACTIONS(223),
    [sym_keyword_geometry] = ACTIONS(223),
    [sym_keyword_geography] = ACTIONS(223),
    [sym_keyword_box2d] = ACTIONS(223),
    [sym_keyword_box3d] = ACTIONS(223),
    [sym_keyword_oid] = ACTIONS(223),
    [sym_keyword_name] = ACTIONS(223),
    [sym_keyword_regclass] = ACTIONS(223),
    [sym_keyword_regnamespace] = ACTIONS(223),
    [sym_keyword_regproc] = ACTIONS(223),
    [sym_keyword_regtype] = ACTIONS(223),
    [aux_sym_double_token1] = ACTIONS(273),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(275),
    [aux_sym_identifier_token1] = ACTIONS(275),
  },
  [13] = {
    [sym_keyword_smallserial] = STATE(438),
    [sym_keyword_serial] = STATE(438),
    [sym_keyword_bigserial] = STATE(438),
    [sym_keyword_tinyint] = STATE(161),
    [sym_keyword_smallint] = STATE(155),
    [sym_keyword_mediumint] = STATE(164),
    [sym_keyword_int] = STATE(152),
    [sym_keyword_bigint] = STATE(153),
    [sym_keyword_real] = STATE(159),
    [sym_keyword_char] = STATE(194),
    [sym_keyword_varchar] = STATE(191),
    [sym__type] = STATE(845),
    [sym_tinyint] = STATE(438),
    [sym_smallint] = STATE(438),
    [sym_mediumint] = STATE(438),
    [sym_int] = STATE(438),
    [sym_bigint] = STATE(438),
    [sym_bit] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_varbinary] = STATE(438),
    [sym_float] = STATE(438),
    [sym_double] = STATE(438),
    [sym_decimal] = STATE(438),
    [sym_numeric] = STATE(438),
    [sym_char] = STATE(438),
    [sym_varchar] = STATE(438),
    [sym_nchar] = STATE(438),
    [sym_nvarchar] = STATE(438),
    [sym_datetimeoffset] = STATE(438),
    [sym_time] = STATE(438),
    [sym_timestamp] = STATE(438),
    [sym_enum] = STATE(438),
    [sym_object_reference] = STATE(414),
    [sym_identifier] = STATE(649),
    [sym__identifier] = ACTIONS(277),
    [aux_sym_keyword_character_token1] = ACTIONS(279),
    [sym_keyword_unsigned] = ACTIONS(281),
    [sym_keyword_boolean] = ACTIONS(283),
    [sym_keyword_bit] = ACTIONS(285),
    [sym_keyword_binary] = ACTIONS(287),
    [sym_keyword_varbinary] = ACTIONS(289),
    [sym_keyword_image] = ACTIONS(283),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(291),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(291),
    [aux_sym_keyword_serial_token1] = ACTIONS(293),
    [aux_sym_keyword_serial_token2] = ACTIONS(293),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(295),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(295),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(297),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(297),
    [aux_sym_keyword_smallint_token1] = ACTIONS(299),
    [aux_sym_keyword_smallint_token2] = ACTIONS(299),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(301),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(301),
    [aux_sym_keyword_int_token1] = ACTIONS(303),
    [aux_sym_keyword_int_token2] = ACTIONS(303),
    [aux_sym_keyword_int_token3] = ACTIONS(303),
    [aux_sym_keyword_bigint_token1] = ACTIONS(305),
    [aux_sym_keyword_bigint_token2] = ACTIONS(305),
    [sym_keyword_decimal] = ACTIONS(307),
    [sym_keyword_numeric] = ACTIONS(309),
    [aux_sym_keyword_real_token1] = ACTIONS(311),
    [aux_sym_keyword_real_token2] = ACTIONS(311),
    [sym_keyword_float] = ACTIONS(313),
    [sym_keyword_double] = ACTIONS(315),
    [sym_keyword_inet] = ACTIONS(283),
    [sym_keyword_money] = ACTIONS(283),
    [sym_keyword_smallmoney] = ACTIONS(283),
    [aux_sym_keyword_char_token1] = ACTIONS(317),
    [sym_keyword_nchar] = ACTIONS(319),
    [aux_sym_keyword_varchar_token1] = ACTIONS(321),
    [sym_keyword_nvarchar] = ACTIONS(323),
    [sym_keyword_text] = ACTIONS(283),
    [sym_keyword_string] = ACTIONS(283),
    [sym_keyword_uuid] = ACTIONS(283),
    [sym_keyword_json] = ACTIONS(283),
    [sym_keyword_jsonb] = ACTIONS(283),
    [sym_keyword_xml] = ACTIONS(283),
    [sym_keyword_bytea] = ACTIONS(283),
    [sym_keyword_enum] = ACTIONS(325),
    [sym_keyword_date] = ACTIONS(283),
    [sym_keyword_datetime] = ACTIONS(283),
    [sym_keyword_datetime2] = ACTIONS(283),
    [sym_keyword_smalldatetime] = ACTIONS(283),
    [sym_keyword_datetimeoffset] = ACTIONS(327),
    [sym_keyword_time] = ACTIONS(329),
    [sym_keyword_timestamp] = ACTIONS(331),
    [sym_keyword_timestamptz] = ACTIONS(283),
    [sym_keyword_interval] = ACTIONS(283),
    [sym_keyword_geometry] = ACTIONS(283),
    [sym_keyword_geography] = ACTIONS(283),
    [sym_keyword_box2d] = ACTIONS(283),
    [sym_keyword_box3d] = ACTIONS(283),
    [sym_keyword_oid] = ACTIONS(283),
    [sym_keyword_name] = ACTIONS(283),
    [sym_keyword_regclass] = ACTIONS(283),
    [sym_keyword_regnamespace] = ACTIONS(283),
    [sym_keyword_regproc] = ACTIONS(283),
    [sym_keyword_regtype] = ACTIONS(283),
    [aux_sym_double_token1] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(335),
    [aux_sym_identifier_token1] = ACTIONS(335),
  },
  [14] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(9749),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [15] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(8639),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [16] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13775),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [17] = {
    [sym_keyword_smallserial] = STATE(4846),
    [sym_keyword_serial] = STATE(4846),
    [sym_keyword_bigserial] = STATE(4846),
    [sym_keyword_tinyint] = STATE(4900),
    [sym_keyword_smallint] = STATE(4897),
    [sym_keyword_mediumint] = STATE(4896),
    [sym_keyword_int] = STATE(4895),
    [sym_keyword_bigint] = STATE(4894),
    [sym_keyword_real] = STATE(4886),
    [sym_keyword_char] = STATE(5354),
    [sym_keyword_varchar] = STATE(5355),
    [sym__type] = STATE(6074),
    [sym_tinyint] = STATE(4846),
    [sym_smallint] = STATE(4846),
    [sym_mediumint] = STATE(4846),
    [sym_int] = STATE(4846),
    [sym_bigint] = STATE(4846),
    [sym_bit] = STATE(4846),
    [sym_binary] = STATE(4846),
    [sym_varbinary] = STATE(4846),
    [sym_float] = STATE(4846),
    [sym_double] = STATE(4846),
    [sym_decimal] = STATE(4846),
    [sym_numeric] = STATE(4846),
    [sym_char] = STATE(4846),
    [sym_varchar] = STATE(4846),
    [sym_nchar] = STATE(4846),
    [sym_nvarchar] = STATE(4846),
    [sym_datetimeoffset] = STATE(4846),
    [sym_time] = STATE(4846),
    [sym_timestamp] = STATE(4846),
    [sym_enum] = STATE(4846),
    [sym_object_reference] = STATE(4844),
    [sym_identifier] = STATE(5375),
    [sym__identifier] = ACTIONS(397),
    [aux_sym_keyword_character_token1] = ACTIONS(399),
    [sym_keyword_unsigned] = ACTIONS(401),
    [sym_keyword_boolean] = ACTIONS(403),
    [sym_keyword_bit] = ACTIONS(405),
    [sym_keyword_binary] = ACTIONS(407),
    [sym_keyword_varbinary] = ACTIONS(409),
    [sym_keyword_image] = ACTIONS(403),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(411),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(411),
    [aux_sym_keyword_serial_token1] = ACTIONS(413),
    [aux_sym_keyword_serial_token2] = ACTIONS(413),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(415),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(415),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(417),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(417),
    [aux_sym_keyword_smallint_token1] = ACTIONS(419),
    [aux_sym_keyword_smallint_token2] = ACTIONS(419),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(421),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(421),
    [aux_sym_keyword_int_token1] = ACTIONS(423),
    [aux_sym_keyword_int_token2] = ACTIONS(423),
    [aux_sym_keyword_int_token3] = ACTIONS(423),
    [aux_sym_keyword_bigint_token1] = ACTIONS(425),
    [aux_sym_keyword_bigint_token2] = ACTIONS(425),
    [sym_keyword_decimal] = ACTIONS(427),
    [sym_keyword_numeric] = ACTIONS(429),
    [aux_sym_keyword_real_token1] = ACTIONS(431),
    [aux_sym_keyword_real_token2] = ACTIONS(431),
    [sym_keyword_float] = ACTIONS(433),
    [sym_keyword_double] = ACTIONS(435),
    [sym_keyword_inet] = ACTIONS(403),
    [sym_keyword_money] = ACTIONS(403),
    [sym_keyword_smallmoney] = ACTIONS(403),
    [aux_sym_keyword_char_token1] = ACTIONS(437),
    [sym_keyword_nchar] = ACTIONS(439),
    [aux_sym_keyword_varchar_token1] = ACTIONS(441),
    [sym_keyword_nvarchar] = ACTIONS(443),
    [sym_keyword_text] = ACTIONS(403),
    [sym_keyword_string] = ACTIONS(403),
    [sym_keyword_uuid] = ACTIONS(403),
    [sym_keyword_json] = ACTIONS(403),
    [sym_keyword_jsonb] = ACTIONS(403),
    [sym_keyword_xml] = ACTIONS(403),
    [sym_keyword_bytea] = ACTIONS(403),
    [sym_keyword_enum] = ACTIONS(445),
    [sym_keyword_date] = ACTIONS(403),
    [sym_keyword_datetime] = ACTIONS(403),
    [sym_keyword_datetime2] = ACTIONS(403),
    [sym_keyword_smalldatetime] = ACTIONS(403),
    [sym_keyword_datetimeoffset] = ACTIONS(447),
    [sym_keyword_time] = ACTIONS(449),
    [sym_keyword_timestamp] = ACTIONS(451),
    [sym_keyword_timestamptz] = ACTIONS(403),
    [sym_keyword_interval] = ACTIONS(403),
    [sym_keyword_geometry] = ACTIONS(403),
    [sym_keyword_geography] = ACTIONS(403),
    [sym_keyword_box2d] = ACTIONS(403),
    [sym_keyword_box3d] = ACTIONS(403),
    [sym_keyword_oid] = ACTIONS(403),
    [sym_keyword_name] = ACTIONS(403),
    [sym_keyword_regclass] = ACTIONS(403),
    [sym_keyword_regnamespace] = ACTIONS(403),
    [sym_keyword_regproc] = ACTIONS(403),
    [sym_keyword_regtype] = ACTIONS(403),
    [aux_sym_double_token1] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(455),
    [aux_sym_identifier_token1] = ACTIONS(455),
  },
  [18] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12944),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [19] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13722),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [20] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6467),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [21] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(9818),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(2),
    [sym__identifier] = ACTIONS(117),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(125),
    [aux_sym_identifier_token1] = ACTIONS(125),
  },
  [22] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12527),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [23] = {
    [sym_keyword_smallserial] = STATE(1846),
    [sym_keyword_serial] = STATE(1846),
    [sym_keyword_bigserial] = STATE(1846),
    [sym_keyword_tinyint] = STATE(1850),
    [sym_keyword_smallint] = STATE(1851),
    [sym_keyword_mediumint] = STATE(1852),
    [sym_keyword_int] = STATE(1854),
    [sym_keyword_bigint] = STATE(1856),
    [sym_keyword_real] = STATE(1857),
    [sym_keyword_char] = STATE(2236),
    [sym_keyword_varchar] = STATE(2241),
    [sym__type] = STATE(2705),
    [sym_tinyint] = STATE(1846),
    [sym_smallint] = STATE(1846),
    [sym_mediumint] = STATE(1846),
    [sym_int] = STATE(1846),
    [sym_bigint] = STATE(1846),
    [sym_bit] = STATE(1846),
    [sym_binary] = STATE(1846),
    [sym_varbinary] = STATE(1846),
    [sym_float] = STATE(1846),
    [sym_double] = STATE(1846),
    [sym_decimal] = STATE(1846),
    [sym_numeric] = STATE(1846),
    [sym_char] = STATE(1846),
    [sym_varchar] = STATE(1846),
    [sym_nchar] = STATE(1846),
    [sym_nvarchar] = STATE(1846),
    [sym_datetimeoffset] = STATE(1846),
    [sym_time] = STATE(1846),
    [sym_timestamp] = STATE(1846),
    [sym_enum] = STATE(1846),
    [sym_object_reference] = STATE(1866),
    [sym_identifier] = STATE(2169),
    [sym__identifier] = ACTIONS(457),
    [aux_sym_keyword_character_token1] = ACTIONS(459),
    [sym_keyword_unsigned] = ACTIONS(461),
    [sym_keyword_boolean] = ACTIONS(463),
    [sym_keyword_bit] = ACTIONS(465),
    [sym_keyword_binary] = ACTIONS(467),
    [sym_keyword_varbinary] = ACTIONS(469),
    [sym_keyword_image] = ACTIONS(463),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(471),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(471),
    [aux_sym_keyword_serial_token1] = ACTIONS(473),
    [aux_sym_keyword_serial_token2] = ACTIONS(473),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(475),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(475),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(477),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(477),
    [aux_sym_keyword_smallint_token1] = ACTIONS(479),
    [aux_sym_keyword_smallint_token2] = ACTIONS(479),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(481),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(481),
    [aux_sym_keyword_int_token1] = ACTIONS(483),
    [aux_sym_keyword_int_token2] = ACTIONS(483),
    [aux_sym_keyword_int_token3] = ACTIONS(483),
    [aux_sym_keyword_bigint_token1] = ACTIONS(485),
    [aux_sym_keyword_bigint_token2] = ACTIONS(485),
    [sym_keyword_decimal] = ACTIONS(487),
    [sym_keyword_numeric] = ACTIONS(489),
    [aux_sym_keyword_real_token1] = ACTIONS(491),
    [aux_sym_keyword_real_token2] = ACTIONS(491),
    [sym_keyword_float] = ACTIONS(493),
    [sym_keyword_double] = ACTIONS(495),
    [sym_keyword_inet] = ACTIONS(463),
    [sym_keyword_money] = ACTIONS(463),
    [sym_keyword_smallmoney] = ACTIONS(463),
    [aux_sym_keyword_char_token1] = ACTIONS(497),
    [sym_keyword_nchar] = ACTIONS(499),
    [aux_sym_keyword_varchar_token1] = ACTIONS(501),
    [sym_keyword_nvarchar] = ACTIONS(503),
    [sym_keyword_text] = ACTIONS(463),
    [sym_keyword_string] = ACTIONS(463),
    [sym_keyword_uuid] = ACTIONS(463),
    [sym_keyword_json] = ACTIONS(463),
    [sym_keyword_jsonb] = ACTIONS(463),
    [sym_keyword_xml] = ACTIONS(463),
    [sym_keyword_bytea] = ACTIONS(463),
    [sym_keyword_enum] = ACTIONS(505),
    [sym_keyword_date] = ACTIONS(463),
    [sym_keyword_datetime] = ACTIONS(463),
    [sym_keyword_datetime2] = ACTIONS(463),
    [sym_keyword_smalldatetime] = ACTIONS(463),
    [sym_keyword_datetimeoffset] = ACTIONS(507),
    [sym_keyword_time] = ACTIONS(509),
    [sym_keyword_timestamp] = ACTIONS(511),
    [sym_keyword_timestamptz] = ACTIONS(463),
    [sym_keyword_interval] = ACTIONS(463),
    [sym_keyword_geometry] = ACTIONS(463),
    [sym_keyword_geography] = ACTIONS(463),
    [sym_keyword_box2d] = ACTIONS(463),
    [sym_keyword_box3d] = ACTIONS(463),
    [sym_keyword_oid] = ACTIONS(463),
    [sym_keyword_name] = ACTIONS(463),
    [sym_keyword_regclass] = ACTIONS(463),
    [sym_keyword_regnamespace] = ACTIONS(463),
    [sym_keyword_regproc] = ACTIONS(463),
    [sym_keyword_regtype] = ACTIONS(463),
    [aux_sym_double_token1] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(515),
    [aux_sym_identifier_token1] = ACTIONS(515),
  },
  [24] = {
    [sym_keyword_smallserial] = STATE(3301),
    [sym_keyword_serial] = STATE(3301),
    [sym_keyword_bigserial] = STATE(3301),
    [sym_keyword_tinyint] = STATE(3225),
    [sym_keyword_smallint] = STATE(3220),
    [sym_keyword_mediumint] = STATE(3218),
    [sym_keyword_int] = STATE(3217),
    [sym_keyword_bigint] = STATE(3214),
    [sym_keyword_real] = STATE(3212),
    [sym_keyword_char] = STATE(4046),
    [sym_keyword_varchar] = STATE(4045),
    [sym__type] = STATE(4716),
    [sym_tinyint] = STATE(3301),
    [sym_smallint] = STATE(3301),
    [sym_mediumint] = STATE(3301),
    [sym_int] = STATE(3301),
    [sym_bigint] = STATE(3301),
    [sym_bit] = STATE(3301),
    [sym_binary] = STATE(3301),
    [sym_varbinary] = STATE(3301),
    [sym_float] = STATE(3301),
    [sym_double] = STATE(3301),
    [sym_decimal] = STATE(3301),
    [sym_numeric] = STATE(3301),
    [sym_char] = STATE(3301),
    [sym_varchar] = STATE(3301),
    [sym_nchar] = STATE(3301),
    [sym_nvarchar] = STATE(3301),
    [sym_datetimeoffset] = STATE(3301),
    [sym_time] = STATE(3301),
    [sym_timestamp] = STATE(3301),
    [sym_enum] = STATE(3301),
    [sym_object_reference] = STATE(3201),
    [sym_identifier] = STATE(4281),
    [sym__identifier] = ACTIONS(517),
    [aux_sym_keyword_character_token1] = ACTIONS(519),
    [sym_keyword_unsigned] = ACTIONS(521),
    [sym_keyword_boolean] = ACTIONS(523),
    [sym_keyword_bit] = ACTIONS(525),
    [sym_keyword_binary] = ACTIONS(527),
    [sym_keyword_varbinary] = ACTIONS(529),
    [sym_keyword_image] = ACTIONS(523),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(531),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(531),
    [aux_sym_keyword_serial_token1] = ACTIONS(533),
    [aux_sym_keyword_serial_token2] = ACTIONS(533),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(535),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(535),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(537),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(537),
    [aux_sym_keyword_smallint_token1] = ACTIONS(539),
    [aux_sym_keyword_smallint_token2] = ACTIONS(539),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(541),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(541),
    [aux_sym_keyword_int_token1] = ACTIONS(543),
    [aux_sym_keyword_int_token2] = ACTIONS(543),
    [aux_sym_keyword_int_token3] = ACTIONS(543),
    [aux_sym_keyword_bigint_token1] = ACTIONS(545),
    [aux_sym_keyword_bigint_token2] = ACTIONS(545),
    [sym_keyword_decimal] = ACTIONS(547),
    [sym_keyword_numeric] = ACTIONS(549),
    [aux_sym_keyword_real_token1] = ACTIONS(551),
    [aux_sym_keyword_real_token2] = ACTIONS(551),
    [sym_keyword_float] = ACTIONS(553),
    [sym_keyword_double] = ACTIONS(555),
    [sym_keyword_inet] = ACTIONS(523),
    [sym_keyword_money] = ACTIONS(523),
    [sym_keyword_smallmoney] = ACTIONS(523),
    [aux_sym_keyword_char_token1] = ACTIONS(557),
    [sym_keyword_nchar] = ACTIONS(559),
    [aux_sym_keyword_varchar_token1] = ACTIONS(561),
    [sym_keyword_nvarchar] = ACTIONS(563),
    [sym_keyword_text] = ACTIONS(523),
    [sym_keyword_string] = ACTIONS(523),
    [sym_keyword_uuid] = ACTIONS(523),
    [sym_keyword_json] = ACTIONS(523),
    [sym_keyword_jsonb] = ACTIONS(523),
    [sym_keyword_xml] = ACTIONS(523),
    [sym_keyword_bytea] = ACTIONS(523),
    [sym_keyword_enum] = ACTIONS(565),
    [sym_keyword_date] = ACTIONS(523),
    [sym_keyword_datetime] = ACTIONS(523),
    [sym_keyword_datetime2] = ACTIONS(523),
    [sym_keyword_smalldatetime] = ACTIONS(523),
    [sym_keyword_datetimeoffset] = ACTIONS(567),
    [sym_keyword_time] = ACTIONS(569),
    [sym_keyword_timestamp] = ACTIONS(571),
    [sym_keyword_timestamptz] = ACTIONS(523),
    [sym_keyword_interval] = ACTIONS(523),
    [sym_keyword_geometry] = ACTIONS(523),
    [sym_keyword_geography] = ACTIONS(523),
    [sym_keyword_box2d] = ACTIONS(523),
    [sym_keyword_box3d] = ACTIONS(523),
    [sym_keyword_oid] = ACTIONS(523),
    [sym_keyword_name] = ACTIONS(523),
    [sym_keyword_regclass] = ACTIONS(523),
    [sym_keyword_regnamespace] = ACTIONS(523),
    [sym_keyword_regproc] = ACTIONS(523),
    [sym_keyword_regtype] = ACTIONS(523),
    [aux_sym_double_token1] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(575),
    [aux_sym_identifier_token1] = ACTIONS(575),
  },
  [25] = {
    [sym_keyword_smallserial] = STATE(2954),
    [sym_keyword_serial] = STATE(2954),
    [sym_keyword_bigserial] = STATE(2954),
    [sym_keyword_tinyint] = STATE(2852),
    [sym_keyword_smallint] = STATE(2853),
    [sym_keyword_mediumint] = STATE(2856),
    [sym_keyword_int] = STATE(2857),
    [sym_keyword_bigint] = STATE(2864),
    [sym_keyword_real] = STATE(2868),
    [sym_keyword_char] = STATE(3561),
    [sym_keyword_varchar] = STATE(3483),
    [sym__type] = STATE(4629),
    [sym_tinyint] = STATE(2954),
    [sym_smallint] = STATE(2954),
    [sym_mediumint] = STATE(2954),
    [sym_int] = STATE(2954),
    [sym_bigint] = STATE(2954),
    [sym_bit] = STATE(2954),
    [sym_binary] = STATE(2954),
    [sym_varbinary] = STATE(2954),
    [sym_float] = STATE(2954),
    [sym_double] = STATE(2954),
    [sym_decimal] = STATE(2954),
    [sym_numeric] = STATE(2954),
    [sym_char] = STATE(2954),
    [sym_varchar] = STATE(2954),
    [sym_nchar] = STATE(2954),
    [sym_nvarchar] = STATE(2954),
    [sym_datetimeoffset] = STATE(2954),
    [sym_time] = STATE(2954),
    [sym_timestamp] = STATE(2954),
    [sym_enum] = STATE(2954),
    [sym_object_reference] = STATE(3052),
    [sym_identifier] = STATE(3620),
    [sym__identifier] = ACTIONS(577),
    [aux_sym_keyword_character_token1] = ACTIONS(579),
    [sym_keyword_unsigned] = ACTIONS(581),
    [sym_keyword_boolean] = ACTIONS(583),
    [sym_keyword_bit] = ACTIONS(585),
    [sym_keyword_binary] = ACTIONS(587),
    [sym_keyword_varbinary] = ACTIONS(589),
    [sym_keyword_image] = ACTIONS(583),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(591),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(591),
    [aux_sym_keyword_serial_token1] = ACTIONS(593),
    [aux_sym_keyword_serial_token2] = ACTIONS(593),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(595),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(595),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(597),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(597),
    [aux_sym_keyword_smallint_token1] = ACTIONS(599),
    [aux_sym_keyword_smallint_token2] = ACTIONS(599),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(601),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(601),
    [aux_sym_keyword_int_token1] = ACTIONS(603),
    [aux_sym_keyword_int_token2] = ACTIONS(603),
    [aux_sym_keyword_int_token3] = ACTIONS(603),
    [aux_sym_keyword_bigint_token1] = ACTIONS(605),
    [aux_sym_keyword_bigint_token2] = ACTIONS(605),
    [sym_keyword_decimal] = ACTIONS(607),
    [sym_keyword_numeric] = ACTIONS(609),
    [aux_sym_keyword_real_token1] = ACTIONS(611),
    [aux_sym_keyword_real_token2] = ACTIONS(611),
    [sym_keyword_float] = ACTIONS(613),
    [sym_keyword_double] = ACTIONS(615),
    [sym_keyword_inet] = ACTIONS(583),
    [sym_keyword_money] = ACTIONS(583),
    [sym_keyword_smallmoney] = ACTIONS(583),
    [aux_sym_keyword_char_token1] = ACTIONS(617),
    [sym_keyword_nchar] = ACTIONS(619),
    [aux_sym_keyword_varchar_token1] = ACTIONS(621),
    [sym_keyword_nvarchar] = ACTIONS(623),
    [sym_keyword_text] = ACTIONS(583),
    [sym_keyword_string] = ACTIONS(583),
    [sym_keyword_uuid] = ACTIONS(583),
    [sym_keyword_json] = ACTIONS(583),
    [sym_keyword_jsonb] = ACTIONS(583),
    [sym_keyword_xml] = ACTIONS(583),
    [sym_keyword_bytea] = ACTIONS(583),
    [sym_keyword_enum] = ACTIONS(625),
    [sym_keyword_date] = ACTIONS(583),
    [sym_keyword_datetime] = ACTIONS(583),
    [sym_keyword_datetime2] = ACTIONS(583),
    [sym_keyword_smalldatetime] = ACTIONS(583),
    [sym_keyword_datetimeoffset] = ACTIONS(627),
    [sym_keyword_time] = ACTIONS(629),
    [sym_keyword_timestamp] = ACTIONS(631),
    [sym_keyword_timestamptz] = ACTIONS(583),
    [sym_keyword_interval] = ACTIONS(583),
    [sym_keyword_geometry] = ACTIONS(583),
    [sym_keyword_geography] = ACTIONS(583),
    [sym_keyword_box2d] = ACTIONS(583),
    [sym_keyword_box3d] = ACTIONS(583),
    [sym_keyword_oid] = ACTIONS(583),
    [sym_keyword_name] = ACTIONS(583),
    [sym_keyword_regclass] = ACTIONS(583),
    [sym_keyword_regnamespace] = ACTIONS(583),
    [sym_keyword_regproc] = ACTIONS(583),
    [sym_keyword_regtype] = ACTIONS(583),
    [aux_sym_double_token1] = ACTIONS(633),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(635),
    [aux_sym_identifier_token1] = ACTIONS(635),
  },
  [26] = {
    [sym_keyword_smallserial] = STATE(3084),
    [sym_keyword_serial] = STATE(3084),
    [sym_keyword_bigserial] = STATE(3084),
    [sym_keyword_tinyint] = STATE(3036),
    [sym_keyword_smallint] = STATE(3037),
    [sym_keyword_mediumint] = STATE(3038),
    [sym_keyword_int] = STATE(3039),
    [sym_keyword_bigint] = STATE(3040),
    [sym_keyword_real] = STATE(3041),
    [sym_keyword_char] = STATE(3706),
    [sym_keyword_varchar] = STATE(3711),
    [sym__type] = STATE(4497),
    [sym_tinyint] = STATE(3084),
    [sym_smallint] = STATE(3084),
    [sym_mediumint] = STATE(3084),
    [sym_int] = STATE(3084),
    [sym_bigint] = STATE(3084),
    [sym_bit] = STATE(3084),
    [sym_binary] = STATE(3084),
    [sym_varbinary] = STATE(3084),
    [sym_float] = STATE(3084),
    [sym_double] = STATE(3084),
    [sym_decimal] = STATE(3084),
    [sym_numeric] = STATE(3084),
    [sym_char] = STATE(3084),
    [sym_varchar] = STATE(3084),
    [sym_nchar] = STATE(3084),
    [sym_nvarchar] = STATE(3084),
    [sym_datetimeoffset] = STATE(3084),
    [sym_time] = STATE(3084),
    [sym_timestamp] = STATE(3084),
    [sym_enum] = STATE(3084),
    [sym_object_reference] = STATE(3060),
    [sym_identifier] = STATE(3718),
    [sym__identifier] = ACTIONS(637),
    [aux_sym_keyword_character_token1] = ACTIONS(639),
    [sym_keyword_unsigned] = ACTIONS(641),
    [sym_keyword_boolean] = ACTIONS(643),
    [sym_keyword_bit] = ACTIONS(645),
    [sym_keyword_binary] = ACTIONS(647),
    [sym_keyword_varbinary] = ACTIONS(649),
    [sym_keyword_image] = ACTIONS(643),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(651),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(651),
    [aux_sym_keyword_serial_token1] = ACTIONS(653),
    [aux_sym_keyword_serial_token2] = ACTIONS(653),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(655),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(655),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(657),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(657),
    [aux_sym_keyword_smallint_token1] = ACTIONS(659),
    [aux_sym_keyword_smallint_token2] = ACTIONS(659),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(661),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(661),
    [aux_sym_keyword_int_token1] = ACTIONS(663),
    [aux_sym_keyword_int_token2] = ACTIONS(663),
    [aux_sym_keyword_int_token3] = ACTIONS(663),
    [aux_sym_keyword_bigint_token1] = ACTIONS(665),
    [aux_sym_keyword_bigint_token2] = ACTIONS(665),
    [sym_keyword_decimal] = ACTIONS(667),
    [sym_keyword_numeric] = ACTIONS(669),
    [aux_sym_keyword_real_token1] = ACTIONS(671),
    [aux_sym_keyword_real_token2] = ACTIONS(671),
    [sym_keyword_float] = ACTIONS(673),
    [sym_keyword_double] = ACTIONS(675),
    [sym_keyword_inet] = ACTIONS(643),
    [sym_keyword_money] = ACTIONS(643),
    [sym_keyword_smallmoney] = ACTIONS(643),
    [aux_sym_keyword_char_token1] = ACTIONS(677),
    [sym_keyword_nchar] = ACTIONS(679),
    [aux_sym_keyword_varchar_token1] = ACTIONS(681),
    [sym_keyword_nvarchar] = ACTIONS(683),
    [sym_keyword_text] = ACTIONS(643),
    [sym_keyword_string] = ACTIONS(643),
    [sym_keyword_uuid] = ACTIONS(643),
    [sym_keyword_json] = ACTIONS(643),
    [sym_keyword_jsonb] = ACTIONS(643),
    [sym_keyword_xml] = ACTIONS(643),
    [sym_keyword_bytea] = ACTIONS(643),
    [sym_keyword_enum] = ACTIONS(685),
    [sym_keyword_date] = ACTIONS(643),
    [sym_keyword_datetime] = ACTIONS(643),
    [sym_keyword_datetime2] = ACTIONS(643),
    [sym_keyword_smalldatetime] = ACTIONS(643),
    [sym_keyword_datetimeoffset] = ACTIONS(687),
    [sym_keyword_time] = ACTIONS(689),
    [sym_keyword_timestamp] = ACTIONS(691),
    [sym_keyword_timestamptz] = ACTIONS(643),
    [sym_keyword_interval] = ACTIONS(643),
    [sym_keyword_geometry] = ACTIONS(643),
    [sym_keyword_geography] = ACTIONS(643),
    [sym_keyword_box2d] = ACTIONS(643),
    [sym_keyword_box3d] = ACTIONS(643),
    [sym_keyword_oid] = ACTIONS(643),
    [sym_keyword_name] = ACTIONS(643),
    [sym_keyword_regclass] = ACTIONS(643),
    [sym_keyword_regnamespace] = ACTIONS(643),
    [sym_keyword_regproc] = ACTIONS(643),
    [sym_keyword_regtype] = ACTIONS(643),
    [aux_sym_double_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(695),
    [aux_sym_identifier_token1] = ACTIONS(695),
  },
  [27] = {
    [sym_keyword_smallserial] = STATE(1846),
    [sym_keyword_serial] = STATE(1846),
    [sym_keyword_bigserial] = STATE(1846),
    [sym_keyword_tinyint] = STATE(1850),
    [sym_keyword_smallint] = STATE(1851),
    [sym_keyword_mediumint] = STATE(1852),
    [sym_keyword_int] = STATE(1854),
    [sym_keyword_bigint] = STATE(1856),
    [sym_keyword_real] = STATE(1857),
    [sym_keyword_char] = STATE(2236),
    [sym_keyword_varchar] = STATE(2241),
    [sym__type] = STATE(2705),
    [sym_tinyint] = STATE(1846),
    [sym_smallint] = STATE(1846),
    [sym_mediumint] = STATE(1846),
    [sym_int] = STATE(1846),
    [sym_bigint] = STATE(1846),
    [sym_bit] = STATE(1846),
    [sym_binary] = STATE(1846),
    [sym_varbinary] = STATE(1846),
    [sym_float] = STATE(1846),
    [sym_double] = STATE(1846),
    [sym_decimal] = STATE(1846),
    [sym_numeric] = STATE(1846),
    [sym_char] = STATE(1846),
    [sym_varchar] = STATE(1846),
    [sym_nchar] = STATE(1846),
    [sym_nvarchar] = STATE(1846),
    [sym_datetimeoffset] = STATE(1846),
    [sym_time] = STATE(1846),
    [sym_timestamp] = STATE(1846),
    [sym_enum] = STATE(1846),
    [sym_object_reference] = STATE(1866),
    [sym_identifier] = STATE(2169),
    [sym__identifier] = ACTIONS(457),
    [aux_sym_keyword_character_token1] = ACTIONS(459),
    [sym_keyword_unsigned] = ACTIONS(461),
    [sym_keyword_boolean] = ACTIONS(463),
    [sym_keyword_bit] = ACTIONS(465),
    [sym_keyword_binary] = ACTIONS(467),
    [sym_keyword_varbinary] = ACTIONS(469),
    [sym_keyword_image] = ACTIONS(463),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(471),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(471),
    [aux_sym_keyword_serial_token1] = ACTIONS(473),
    [aux_sym_keyword_serial_token2] = ACTIONS(473),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(475),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(475),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(477),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(477),
    [aux_sym_keyword_smallint_token1] = ACTIONS(479),
    [aux_sym_keyword_smallint_token2] = ACTIONS(479),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(481),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(481),
    [aux_sym_keyword_int_token1] = ACTIONS(483),
    [aux_sym_keyword_int_token2] = ACTIONS(483),
    [aux_sym_keyword_int_token3] = ACTIONS(483),
    [aux_sym_keyword_bigint_token1] = ACTIONS(485),
    [aux_sym_keyword_bigint_token2] = ACTIONS(485),
    [sym_keyword_decimal] = ACTIONS(487),
    [sym_keyword_numeric] = ACTIONS(489),
    [aux_sym_keyword_real_token1] = ACTIONS(491),
    [aux_sym_keyword_real_token2] = ACTIONS(491),
    [sym_keyword_float] = ACTIONS(493),
    [sym_keyword_double] = ACTIONS(495),
    [sym_keyword_inet] = ACTIONS(463),
    [sym_keyword_money] = ACTIONS(463),
    [sym_keyword_smallmoney] = ACTIONS(463),
    [aux_sym_keyword_char_token1] = ACTIONS(497),
    [sym_keyword_nchar] = ACTIONS(499),
    [aux_sym_keyword_varchar_token1] = ACTIONS(501),
    [sym_keyword_nvarchar] = ACTIONS(503),
    [sym_keyword_text] = ACTIONS(463),
    [sym_keyword_string] = ACTIONS(463),
    [sym_keyword_uuid] = ACTIONS(463),
    [sym_keyword_json] = ACTIONS(463),
    [sym_keyword_jsonb] = ACTIONS(463),
    [sym_keyword_xml] = ACTIONS(463),
    [sym_keyword_bytea] = ACTIONS(463),
    [sym_keyword_enum] = ACTIONS(505),
    [sym_keyword_date] = ACTIONS(463),
    [sym_keyword_datetime] = ACTIONS(463),
    [sym_keyword_datetime2] = ACTIONS(463),
    [sym_keyword_smalldatetime] = ACTIONS(463),
    [sym_keyword_datetimeoffset] = ACTIONS(507),
    [sym_keyword_time] = ACTIONS(697),
    [sym_keyword_timestamp] = ACTIONS(699),
    [sym_keyword_timestamptz] = ACTIONS(463),
    [sym_keyword_interval] = ACTIONS(463),
    [sym_keyword_geometry] = ACTIONS(463),
    [sym_keyword_geography] = ACTIONS(463),
    [sym_keyword_box2d] = ACTIONS(463),
    [sym_keyword_box3d] = ACTIONS(463),
    [sym_keyword_oid] = ACTIONS(463),
    [sym_keyword_name] = ACTIONS(463),
    [sym_keyword_regclass] = ACTIONS(463),
    [sym_keyword_regnamespace] = ACTIONS(463),
    [sym_keyword_regproc] = ACTIONS(463),
    [sym_keyword_regtype] = ACTIONS(463),
    [aux_sym_double_token1] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(515),
    [aux_sym_identifier_token1] = ACTIONS(515),
  },
  [28] = {
    [sym_keyword_smallserial] = STATE(941),
    [sym_keyword_serial] = STATE(941),
    [sym_keyword_bigserial] = STATE(941),
    [sym_keyword_tinyint] = STATE(514),
    [sym_keyword_smallint] = STATE(516),
    [sym_keyword_mediumint] = STATE(473),
    [sym_keyword_int] = STATE(472),
    [sym_keyword_bigint] = STATE(513),
    [sym_keyword_real] = STATE(512),
    [sym_keyword_char] = STATE(797),
    [sym_keyword_varchar] = STATE(796),
    [sym__type] = STATE(2296),
    [sym_tinyint] = STATE(941),
    [sym_smallint] = STATE(941),
    [sym_mediumint] = STATE(941),
    [sym_int] = STATE(941),
    [sym_bigint] = STATE(941),
    [sym_bit] = STATE(941),
    [sym_binary] = STATE(941),
    [sym_varbinary] = STATE(941),
    [sym_float] = STATE(941),
    [sym_double] = STATE(941),
    [sym_decimal] = STATE(941),
    [sym_numeric] = STATE(941),
    [sym_char] = STATE(941),
    [sym_varchar] = STATE(941),
    [sym_nchar] = STATE(941),
    [sym_nvarchar] = STATE(941),
    [sym_datetimeoffset] = STATE(941),
    [sym_time] = STATE(941),
    [sym_timestamp] = STATE(941),
    [sym_enum] = STATE(941),
    [sym_object_reference] = STATE(960),
    [sym_identifier] = STATE(1812),
    [sym__identifier] = ACTIONS(701),
    [aux_sym_keyword_character_token1] = ACTIONS(703),
    [sym_keyword_unsigned] = ACTIONS(705),
    [sym_keyword_boolean] = ACTIONS(707),
    [sym_keyword_bit] = ACTIONS(709),
    [sym_keyword_binary] = ACTIONS(711),
    [sym_keyword_varbinary] = ACTIONS(713),
    [sym_keyword_image] = ACTIONS(707),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(715),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(715),
    [aux_sym_keyword_serial_token1] = ACTIONS(717),
    [aux_sym_keyword_serial_token2] = ACTIONS(717),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(719),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(719),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(721),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(721),
    [aux_sym_keyword_smallint_token1] = ACTIONS(723),
    [aux_sym_keyword_smallint_token2] = ACTIONS(723),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(725),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(725),
    [aux_sym_keyword_int_token1] = ACTIONS(727),
    [aux_sym_keyword_int_token2] = ACTIONS(727),
    [aux_sym_keyword_int_token3] = ACTIONS(727),
    [aux_sym_keyword_bigint_token1] = ACTIONS(729),
    [aux_sym_keyword_bigint_token2] = ACTIONS(729),
    [sym_keyword_decimal] = ACTIONS(731),
    [sym_keyword_numeric] = ACTIONS(733),
    [aux_sym_keyword_real_token1] = ACTIONS(735),
    [aux_sym_keyword_real_token2] = ACTIONS(735),
    [sym_keyword_float] = ACTIONS(737),
    [sym_keyword_double] = ACTIONS(739),
    [sym_keyword_inet] = ACTIONS(707),
    [sym_keyword_money] = ACTIONS(707),
    [sym_keyword_smallmoney] = ACTIONS(707),
    [aux_sym_keyword_char_token1] = ACTIONS(741),
    [sym_keyword_nchar] = ACTIONS(743),
    [aux_sym_keyword_varchar_token1] = ACTIONS(745),
    [sym_keyword_nvarchar] = ACTIONS(747),
    [sym_keyword_text] = ACTIONS(707),
    [sym_keyword_string] = ACTIONS(707),
    [sym_keyword_uuid] = ACTIONS(707),
    [sym_keyword_json] = ACTIONS(707),
    [sym_keyword_jsonb] = ACTIONS(707),
    [sym_keyword_xml] = ACTIONS(707),
    [sym_keyword_bytea] = ACTIONS(707),
    [sym_keyword_enum] = ACTIONS(749),
    [sym_keyword_date] = ACTIONS(707),
    [sym_keyword_datetime] = ACTIONS(707),
    [sym_keyword_datetime2] = ACTIONS(707),
    [sym_keyword_smalldatetime] = ACTIONS(707),
    [sym_keyword_datetimeoffset] = ACTIONS(751),
    [sym_keyword_time] = ACTIONS(753),
    [sym_keyword_timestamp] = ACTIONS(755),
    [sym_keyword_timestamptz] = ACTIONS(707),
    [sym_keyword_interval] = ACTIONS(707),
    [sym_keyword_geometry] = ACTIONS(707),
    [sym_keyword_geography] = ACTIONS(707),
    [sym_keyword_box2d] = ACTIONS(707),
    [sym_keyword_box3d] = ACTIONS(707),
    [sym_keyword_oid] = ACTIONS(707),
    [sym_keyword_name] = ACTIONS(707),
    [sym_keyword_regclass] = ACTIONS(707),
    [sym_keyword_regnamespace] = ACTIONS(707),
    [sym_keyword_regproc] = ACTIONS(707),
    [sym_keyword_regtype] = ACTIONS(707),
    [aux_sym_double_token1] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(759),
    [aux_sym_identifier_token1] = ACTIONS(759),
  },
  [29] = {
    [sym_keyword_smallserial] = STATE(3301),
    [sym_keyword_serial] = STATE(3301),
    [sym_keyword_bigserial] = STATE(3301),
    [sym_keyword_tinyint] = STATE(3225),
    [sym_keyword_smallint] = STATE(3220),
    [sym_keyword_mediumint] = STATE(3218),
    [sym_keyword_int] = STATE(3217),
    [sym_keyword_bigint] = STATE(3214),
    [sym_keyword_real] = STATE(3212),
    [sym_keyword_char] = STATE(4046),
    [sym_keyword_varchar] = STATE(4045),
    [sym__type] = STATE(4716),
    [sym_tinyint] = STATE(3301),
    [sym_smallint] = STATE(3301),
    [sym_mediumint] = STATE(3301),
    [sym_int] = STATE(3301),
    [sym_bigint] = STATE(3301),
    [sym_bit] = STATE(3301),
    [sym_binary] = STATE(3301),
    [sym_varbinary] = STATE(3301),
    [sym_float] = STATE(3301),
    [sym_double] = STATE(3301),
    [sym_decimal] = STATE(3301),
    [sym_numeric] = STATE(3301),
    [sym_char] = STATE(3301),
    [sym_varchar] = STATE(3301),
    [sym_nchar] = STATE(3301),
    [sym_nvarchar] = STATE(3301),
    [sym_datetimeoffset] = STATE(3301),
    [sym_time] = STATE(3301),
    [sym_timestamp] = STATE(3301),
    [sym_enum] = STATE(3301),
    [sym_object_reference] = STATE(3201),
    [sym_identifier] = STATE(4281),
    [sym__identifier] = ACTIONS(517),
    [aux_sym_keyword_character_token1] = ACTIONS(519),
    [sym_keyword_unsigned] = ACTIONS(521),
    [sym_keyword_boolean] = ACTIONS(523),
    [sym_keyword_bit] = ACTIONS(525),
    [sym_keyword_binary] = ACTIONS(527),
    [sym_keyword_varbinary] = ACTIONS(529),
    [sym_keyword_image] = ACTIONS(523),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(531),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(531),
    [aux_sym_keyword_serial_token1] = ACTIONS(533),
    [aux_sym_keyword_serial_token2] = ACTIONS(533),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(535),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(535),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(537),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(537),
    [aux_sym_keyword_smallint_token1] = ACTIONS(539),
    [aux_sym_keyword_smallint_token2] = ACTIONS(539),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(541),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(541),
    [aux_sym_keyword_int_token1] = ACTIONS(543),
    [aux_sym_keyword_int_token2] = ACTIONS(543),
    [aux_sym_keyword_int_token3] = ACTIONS(543),
    [aux_sym_keyword_bigint_token1] = ACTIONS(545),
    [aux_sym_keyword_bigint_token2] = ACTIONS(545),
    [sym_keyword_decimal] = ACTIONS(547),
    [sym_keyword_numeric] = ACTIONS(549),
    [aux_sym_keyword_real_token1] = ACTIONS(551),
    [aux_sym_keyword_real_token2] = ACTIONS(551),
    [sym_keyword_float] = ACTIONS(553),
    [sym_keyword_double] = ACTIONS(555),
    [sym_keyword_inet] = ACTIONS(523),
    [sym_keyword_money] = ACTIONS(523),
    [sym_keyword_smallmoney] = ACTIONS(523),
    [aux_sym_keyword_char_token1] = ACTIONS(557),
    [sym_keyword_nchar] = ACTIONS(559),
    [aux_sym_keyword_varchar_token1] = ACTIONS(561),
    [sym_keyword_nvarchar] = ACTIONS(563),
    [sym_keyword_text] = ACTIONS(523),
    [sym_keyword_string] = ACTIONS(523),
    [sym_keyword_uuid] = ACTIONS(523),
    [sym_keyword_json] = ACTIONS(523),
    [sym_keyword_jsonb] = ACTIONS(523),
    [sym_keyword_xml] = ACTIONS(523),
    [sym_keyword_bytea] = ACTIONS(523),
    [sym_keyword_enum] = ACTIONS(565),
    [sym_keyword_date] = ACTIONS(523),
    [sym_keyword_datetime] = ACTIONS(523),
    [sym_keyword_datetime2] = ACTIONS(523),
    [sym_keyword_smalldatetime] = ACTIONS(523),
    [sym_keyword_datetimeoffset] = ACTIONS(567),
    [sym_keyword_time] = ACTIONS(761),
    [sym_keyword_timestamp] = ACTIONS(763),
    [sym_keyword_timestamptz] = ACTIONS(523),
    [sym_keyword_interval] = ACTIONS(523),
    [sym_keyword_geometry] = ACTIONS(523),
    [sym_keyword_geography] = ACTIONS(523),
    [sym_keyword_box2d] = ACTIONS(523),
    [sym_keyword_box3d] = ACTIONS(523),
    [sym_keyword_oid] = ACTIONS(523),
    [sym_keyword_name] = ACTIONS(523),
    [sym_keyword_regclass] = ACTIONS(523),
    [sym_keyword_regnamespace] = ACTIONS(523),
    [sym_keyword_regproc] = ACTIONS(523),
    [sym_keyword_regtype] = ACTIONS(523),
    [aux_sym_double_token1] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(575),
    [aux_sym_identifier_token1] = ACTIONS(575),
  },
  [30] = {
    [sym_keyword_smallserial] = STATE(3072),
    [sym_keyword_serial] = STATE(3072),
    [sym_keyword_bigserial] = STATE(3072),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(4455),
    [sym_tinyint] = STATE(3072),
    [sym_smallint] = STATE(3072),
    [sym_mediumint] = STATE(3072),
    [sym_int] = STATE(3072),
    [sym_bigint] = STATE(3072),
    [sym_bit] = STATE(3072),
    [sym_binary] = STATE(3072),
    [sym_varbinary] = STATE(3072),
    [sym_float] = STATE(3072),
    [sym_double] = STATE(3072),
    [sym_decimal] = STATE(3072),
    [sym_numeric] = STATE(3072),
    [sym_char] = STATE(3072),
    [sym_varchar] = STATE(3072),
    [sym_nchar] = STATE(3072),
    [sym_nvarchar] = STATE(3072),
    [sym_datetimeoffset] = STATE(3072),
    [sym_time] = STATE(3072),
    [sym_timestamp] = STATE(3072),
    [sym_enum] = STATE(3072),
    [sym_object_reference] = STATE(2923),
    [sym_identifier] = STATE(3653),
    [sym__identifier] = ACTIONS(765),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(767),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(767),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(767),
    [sym_keyword_money] = ACTIONS(767),
    [sym_keyword_smallmoney] = ACTIONS(767),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(767),
    [sym_keyword_string] = ACTIONS(767),
    [sym_keyword_uuid] = ACTIONS(767),
    [sym_keyword_json] = ACTIONS(767),
    [sym_keyword_jsonb] = ACTIONS(767),
    [sym_keyword_xml] = ACTIONS(767),
    [sym_keyword_bytea] = ACTIONS(767),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(767),
    [sym_keyword_datetime] = ACTIONS(767),
    [sym_keyword_datetime2] = ACTIONS(767),
    [sym_keyword_smalldatetime] = ACTIONS(767),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(769),
    [sym_keyword_timestamp] = ACTIONS(771),
    [sym_keyword_timestamptz] = ACTIONS(767),
    [sym_keyword_interval] = ACTIONS(767),
    [sym_keyword_geometry] = ACTIONS(767),
    [sym_keyword_geography] = ACTIONS(767),
    [sym_keyword_box2d] = ACTIONS(767),
    [sym_keyword_box3d] = ACTIONS(767),
    [sym_keyword_oid] = ACTIONS(767),
    [sym_keyword_name] = ACTIONS(767),
    [sym_keyword_regclass] = ACTIONS(767),
    [sym_keyword_regnamespace] = ACTIONS(767),
    [sym_keyword_regproc] = ACTIONS(767),
    [sym_keyword_regtype] = ACTIONS(767),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(773),
    [aux_sym_identifier_token1] = ACTIONS(773),
  },
  [31] = {
    [sym_keyword_smallserial] = STATE(4753),
    [sym_keyword_serial] = STATE(4753),
    [sym_keyword_bigserial] = STATE(4753),
    [sym_keyword_tinyint] = STATE(4760),
    [sym_keyword_smallint] = STATE(4770),
    [sym_keyword_mediumint] = STATE(4771),
    [sym_keyword_int] = STATE(4794),
    [sym_keyword_bigint] = STATE(4777),
    [sym_keyword_real] = STATE(4748),
    [sym_keyword_char] = STATE(5021),
    [sym_keyword_varchar] = STATE(4986),
    [sym__type] = STATE(5602),
    [sym_tinyint] = STATE(4753),
    [sym_smallint] = STATE(4753),
    [sym_mediumint] = STATE(4753),
    [sym_int] = STATE(4753),
    [sym_bigint] = STATE(4753),
    [sym_bit] = STATE(4753),
    [sym_binary] = STATE(4753),
    [sym_varbinary] = STATE(4753),
    [sym_float] = STATE(4753),
    [sym_double] = STATE(4753),
    [sym_decimal] = STATE(4753),
    [sym_numeric] = STATE(4753),
    [sym_char] = STATE(4753),
    [sym_varchar] = STATE(4753),
    [sym_nchar] = STATE(4753),
    [sym_nvarchar] = STATE(4753),
    [sym_datetimeoffset] = STATE(4753),
    [sym_time] = STATE(4753),
    [sym_timestamp] = STATE(4753),
    [sym_enum] = STATE(4753),
    [sym_object_reference] = STATE(4759),
    [sym_identifier] = STATE(5026),
    [sym__identifier] = ACTIONS(775),
    [aux_sym_keyword_character_token1] = ACTIONS(777),
    [sym_keyword_unsigned] = ACTIONS(779),
    [sym_keyword_boolean] = ACTIONS(781),
    [sym_keyword_bit] = ACTIONS(783),
    [sym_keyword_binary] = ACTIONS(785),
    [sym_keyword_varbinary] = ACTIONS(787),
    [sym_keyword_image] = ACTIONS(781),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(789),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(789),
    [aux_sym_keyword_serial_token1] = ACTIONS(791),
    [aux_sym_keyword_serial_token2] = ACTIONS(791),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(793),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(793),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(795),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(795),
    [aux_sym_keyword_smallint_token1] = ACTIONS(797),
    [aux_sym_keyword_smallint_token2] = ACTIONS(797),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(799),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(799),
    [aux_sym_keyword_int_token1] = ACTIONS(801),
    [aux_sym_keyword_int_token2] = ACTIONS(801),
    [aux_sym_keyword_int_token3] = ACTIONS(801),
    [aux_sym_keyword_bigint_token1] = ACTIONS(803),
    [aux_sym_keyword_bigint_token2] = ACTIONS(803),
    [sym_keyword_decimal] = ACTIONS(805),
    [sym_keyword_numeric] = ACTIONS(807),
    [aux_sym_keyword_real_token1] = ACTIONS(809),
    [aux_sym_keyword_real_token2] = ACTIONS(809),
    [sym_keyword_float] = ACTIONS(811),
    [sym_keyword_double] = ACTIONS(813),
    [sym_keyword_inet] = ACTIONS(781),
    [sym_keyword_money] = ACTIONS(781),
    [sym_keyword_smallmoney] = ACTIONS(781),
    [aux_sym_keyword_char_token1] = ACTIONS(815),
    [sym_keyword_nchar] = ACTIONS(817),
    [aux_sym_keyword_varchar_token1] = ACTIONS(819),
    [sym_keyword_nvarchar] = ACTIONS(821),
    [sym_keyword_text] = ACTIONS(781),
    [sym_keyword_string] = ACTIONS(781),
    [sym_keyword_uuid] = ACTIONS(781),
    [sym_keyword_json] = ACTIONS(781),
    [sym_keyword_jsonb] = ACTIONS(781),
    [sym_keyword_xml] = ACTIONS(781),
    [sym_keyword_bytea] = ACTIONS(781),
    [sym_keyword_enum] = ACTIONS(823),
    [sym_keyword_date] = ACTIONS(781),
    [sym_keyword_datetime] = ACTIONS(781),
    [sym_keyword_datetime2] = ACTIONS(781),
    [sym_keyword_smalldatetime] = ACTIONS(781),
    [sym_keyword_datetimeoffset] = ACTIONS(825),
    [sym_keyword_time] = ACTIONS(827),
    [sym_keyword_timestamp] = ACTIONS(829),
    [sym_keyword_timestamptz] = ACTIONS(781),
    [sym_keyword_interval] = ACTIONS(781),
    [sym_keyword_geometry] = ACTIONS(781),
    [sym_keyword_geography] = ACTIONS(781),
    [sym_keyword_box2d] = ACTIONS(781),
    [sym_keyword_box3d] = ACTIONS(781),
    [sym_keyword_oid] = ACTIONS(781),
    [sym_keyword_name] = ACTIONS(781),
    [sym_keyword_regclass] = ACTIONS(781),
    [sym_keyword_regnamespace] = ACTIONS(781),
    [sym_keyword_regproc] = ACTIONS(781),
    [sym_keyword_regtype] = ACTIONS(781),
    [aux_sym_double_token1] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(833),
    [aux_sym_identifier_token1] = ACTIONS(833),
  },
  [32] = {
    [sym_keyword_smallserial] = STATE(2954),
    [sym_keyword_serial] = STATE(2954),
    [sym_keyword_bigserial] = STATE(2954),
    [sym_keyword_tinyint] = STATE(2852),
    [sym_keyword_smallint] = STATE(2853),
    [sym_keyword_mediumint] = STATE(2856),
    [sym_keyword_int] = STATE(2857),
    [sym_keyword_bigint] = STATE(2864),
    [sym_keyword_real] = STATE(2868),
    [sym_keyword_char] = STATE(3561),
    [sym_keyword_varchar] = STATE(3483),
    [sym__type] = STATE(4629),
    [sym_tinyint] = STATE(2954),
    [sym_smallint] = STATE(2954),
    [sym_mediumint] = STATE(2954),
    [sym_int] = STATE(2954),
    [sym_bigint] = STATE(2954),
    [sym_bit] = STATE(2954),
    [sym_binary] = STATE(2954),
    [sym_varbinary] = STATE(2954),
    [sym_float] = STATE(2954),
    [sym_double] = STATE(2954),
    [sym_decimal] = STATE(2954),
    [sym_numeric] = STATE(2954),
    [sym_char] = STATE(2954),
    [sym_varchar] = STATE(2954),
    [sym_nchar] = STATE(2954),
    [sym_nvarchar] = STATE(2954),
    [sym_datetimeoffset] = STATE(2954),
    [sym_time] = STATE(2954),
    [sym_timestamp] = STATE(2954),
    [sym_enum] = STATE(2954),
    [sym_object_reference] = STATE(3052),
    [sym_identifier] = STATE(3620),
    [sym__identifier] = ACTIONS(577),
    [aux_sym_keyword_character_token1] = ACTIONS(579),
    [sym_keyword_unsigned] = ACTIONS(581),
    [sym_keyword_boolean] = ACTIONS(583),
    [sym_keyword_bit] = ACTIONS(585),
    [sym_keyword_binary] = ACTIONS(587),
    [sym_keyword_varbinary] = ACTIONS(589),
    [sym_keyword_image] = ACTIONS(583),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(591),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(591),
    [aux_sym_keyword_serial_token1] = ACTIONS(593),
    [aux_sym_keyword_serial_token2] = ACTIONS(593),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(595),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(595),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(597),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(597),
    [aux_sym_keyword_smallint_token1] = ACTIONS(599),
    [aux_sym_keyword_smallint_token2] = ACTIONS(599),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(601),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(601),
    [aux_sym_keyword_int_token1] = ACTIONS(603),
    [aux_sym_keyword_int_token2] = ACTIONS(603),
    [aux_sym_keyword_int_token3] = ACTIONS(603),
    [aux_sym_keyword_bigint_token1] = ACTIONS(605),
    [aux_sym_keyword_bigint_token2] = ACTIONS(605),
    [sym_keyword_decimal] = ACTIONS(607),
    [sym_keyword_numeric] = ACTIONS(609),
    [aux_sym_keyword_real_token1] = ACTIONS(611),
    [aux_sym_keyword_real_token2] = ACTIONS(611),
    [sym_keyword_float] = ACTIONS(613),
    [sym_keyword_double] = ACTIONS(615),
    [sym_keyword_inet] = ACTIONS(583),
    [sym_keyword_money] = ACTIONS(583),
    [sym_keyword_smallmoney] = ACTIONS(583),
    [aux_sym_keyword_char_token1] = ACTIONS(617),
    [sym_keyword_nchar] = ACTIONS(619),
    [aux_sym_keyword_varchar_token1] = ACTIONS(621),
    [sym_keyword_nvarchar] = ACTIONS(623),
    [sym_keyword_text] = ACTIONS(583),
    [sym_keyword_string] = ACTIONS(583),
    [sym_keyword_uuid] = ACTIONS(583),
    [sym_keyword_json] = ACTIONS(583),
    [sym_keyword_jsonb] = ACTIONS(583),
    [sym_keyword_xml] = ACTIONS(583),
    [sym_keyword_bytea] = ACTIONS(583),
    [sym_keyword_enum] = ACTIONS(625),
    [sym_keyword_date] = ACTIONS(583),
    [sym_keyword_datetime] = ACTIONS(583),
    [sym_keyword_datetime2] = ACTIONS(583),
    [sym_keyword_smalldatetime] = ACTIONS(583),
    [sym_keyword_datetimeoffset] = ACTIONS(627),
    [sym_keyword_time] = ACTIONS(835),
    [sym_keyword_timestamp] = ACTIONS(837),
    [sym_keyword_timestamptz] = ACTIONS(583),
    [sym_keyword_interval] = ACTIONS(583),
    [sym_keyword_geometry] = ACTIONS(583),
    [sym_keyword_geography] = ACTIONS(583),
    [sym_keyword_box2d] = ACTIONS(583),
    [sym_keyword_box3d] = ACTIONS(583),
    [sym_keyword_oid] = ACTIONS(583),
    [sym_keyword_name] = ACTIONS(583),
    [sym_keyword_regclass] = ACTIONS(583),
    [sym_keyword_regnamespace] = ACTIONS(583),
    [sym_keyword_regproc] = ACTIONS(583),
    [sym_keyword_regtype] = ACTIONS(583),
    [aux_sym_double_token1] = ACTIONS(633),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(635),
    [aux_sym_identifier_token1] = ACTIONS(635),
  },
  [33] = {
    [sym_keyword_smallserial] = STATE(4801),
    [sym_keyword_serial] = STATE(4801),
    [sym_keyword_bigserial] = STATE(4801),
    [sym_keyword_tinyint] = STATE(4862),
    [sym_keyword_smallint] = STATE(4861),
    [sym_keyword_mediumint] = STATE(4860),
    [sym_keyword_int] = STATE(4859),
    [sym_keyword_bigint] = STATE(4858),
    [sym_keyword_real] = STATE(4857),
    [sym_keyword_char] = STATE(5443),
    [sym_keyword_varchar] = STATE(5444),
    [sym__type] = STATE(4874),
    [sym_tinyint] = STATE(4801),
    [sym_smallint] = STATE(4801),
    [sym_mediumint] = STATE(4801),
    [sym_int] = STATE(4801),
    [sym_bigint] = STATE(4801),
    [sym_bit] = STATE(4801),
    [sym_binary] = STATE(4801),
    [sym_varbinary] = STATE(4801),
    [sym_float] = STATE(4801),
    [sym_double] = STATE(4801),
    [sym_decimal] = STATE(4801),
    [sym_numeric] = STATE(4801),
    [sym_char] = STATE(4801),
    [sym_varchar] = STATE(4801),
    [sym_nchar] = STATE(4801),
    [sym_nvarchar] = STATE(4801),
    [sym_datetimeoffset] = STATE(4801),
    [sym_time] = STATE(4801),
    [sym_timestamp] = STATE(4801),
    [sym_enum] = STATE(4801),
    [sym_object_reference] = STATE(4802),
    [sym_identifier] = STATE(5427),
    [sym__identifier] = ACTIONS(839),
    [aux_sym_keyword_character_token1] = ACTIONS(841),
    [sym_keyword_unsigned] = ACTIONS(843),
    [sym_keyword_boolean] = ACTIONS(845),
    [sym_keyword_bit] = ACTIONS(847),
    [sym_keyword_binary] = ACTIONS(849),
    [sym_keyword_varbinary] = ACTIONS(851),
    [sym_keyword_image] = ACTIONS(845),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(853),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(853),
    [aux_sym_keyword_serial_token1] = ACTIONS(855),
    [aux_sym_keyword_serial_token2] = ACTIONS(855),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(857),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(857),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(859),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(859),
    [aux_sym_keyword_smallint_token1] = ACTIONS(861),
    [aux_sym_keyword_smallint_token2] = ACTIONS(861),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(863),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(863),
    [aux_sym_keyword_int_token1] = ACTIONS(865),
    [aux_sym_keyword_int_token2] = ACTIONS(865),
    [aux_sym_keyword_int_token3] = ACTIONS(865),
    [aux_sym_keyword_bigint_token1] = ACTIONS(867),
    [aux_sym_keyword_bigint_token2] = ACTIONS(867),
    [sym_keyword_decimal] = ACTIONS(869),
    [sym_keyword_numeric] = ACTIONS(871),
    [aux_sym_keyword_real_token1] = ACTIONS(873),
    [aux_sym_keyword_real_token2] = ACTIONS(873),
    [sym_keyword_float] = ACTIONS(875),
    [sym_keyword_double] = ACTIONS(877),
    [sym_keyword_inet] = ACTIONS(845),
    [sym_keyword_money] = ACTIONS(845),
    [sym_keyword_smallmoney] = ACTIONS(845),
    [aux_sym_keyword_char_token1] = ACTIONS(879),
    [sym_keyword_nchar] = ACTIONS(881),
    [aux_sym_keyword_varchar_token1] = ACTIONS(883),
    [sym_keyword_nvarchar] = ACTIONS(885),
    [sym_keyword_text] = ACTIONS(845),
    [sym_keyword_string] = ACTIONS(845),
    [sym_keyword_uuid] = ACTIONS(845),
    [sym_keyword_json] = ACTIONS(845),
    [sym_keyword_jsonb] = ACTIONS(845),
    [sym_keyword_xml] = ACTIONS(845),
    [sym_keyword_bytea] = ACTIONS(845),
    [sym_keyword_enum] = ACTIONS(887),
    [sym_keyword_date] = ACTIONS(845),
    [sym_keyword_datetime] = ACTIONS(845),
    [sym_keyword_datetime2] = ACTIONS(845),
    [sym_keyword_smalldatetime] = ACTIONS(845),
    [sym_keyword_datetimeoffset] = ACTIONS(889),
    [sym_keyword_time] = ACTIONS(891),
    [sym_keyword_timestamp] = ACTIONS(893),
    [sym_keyword_timestamptz] = ACTIONS(845),
    [sym_keyword_interval] = ACTIONS(845),
    [sym_keyword_geometry] = ACTIONS(845),
    [sym_keyword_geography] = ACTIONS(845),
    [sym_keyword_box2d] = ACTIONS(845),
    [sym_keyword_box3d] = ACTIONS(845),
    [sym_keyword_oid] = ACTIONS(845),
    [sym_keyword_name] = ACTIONS(845),
    [sym_keyword_regclass] = ACTIONS(845),
    [sym_keyword_regnamespace] = ACTIONS(845),
    [sym_keyword_regproc] = ACTIONS(845),
    [sym_keyword_regtype] = ACTIONS(845),
    [aux_sym_double_token1] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(897),
    [aux_sym_identifier_token1] = ACTIONS(897),
  },
  [34] = {
    [sym_keyword_smallserial] = STATE(1056),
    [sym_keyword_serial] = STATE(1056),
    [sym_keyword_bigserial] = STATE(1056),
    [sym_keyword_tinyint] = STATE(1336),
    [sym_keyword_smallint] = STATE(1333),
    [sym_keyword_mediumint] = STATE(1330),
    [sym_keyword_int] = STATE(1328),
    [sym_keyword_bigint] = STATE(1327),
    [sym_keyword_real] = STATE(1326),
    [sym_keyword_char] = STATE(2073),
    [sym_keyword_varchar] = STATE(1898),
    [sym__type] = STATE(2414),
    [sym_tinyint] = STATE(1056),
    [sym_smallint] = STATE(1056),
    [sym_mediumint] = STATE(1056),
    [sym_int] = STATE(1056),
    [sym_bigint] = STATE(1056),
    [sym_bit] = STATE(1056),
    [sym_binary] = STATE(1056),
    [sym_varbinary] = STATE(1056),
    [sym_float] = STATE(1056),
    [sym_double] = STATE(1056),
    [sym_decimal] = STATE(1056),
    [sym_numeric] = STATE(1056),
    [sym_char] = STATE(1056),
    [sym_varchar] = STATE(1056),
    [sym_nchar] = STATE(1056),
    [sym_nvarchar] = STATE(1056),
    [sym_datetimeoffset] = STATE(1056),
    [sym_time] = STATE(1056),
    [sym_timestamp] = STATE(1056),
    [sym_enum] = STATE(1056),
    [sym_object_reference] = STATE(1042),
    [sym_identifier] = STATE(2029),
    [sym__identifier] = ACTIONS(899),
    [aux_sym_keyword_character_token1] = ACTIONS(901),
    [sym_keyword_unsigned] = ACTIONS(903),
    [sym_keyword_boolean] = ACTIONS(905),
    [sym_keyword_bit] = ACTIONS(907),
    [sym_keyword_binary] = ACTIONS(909),
    [sym_keyword_varbinary] = ACTIONS(911),
    [sym_keyword_image] = ACTIONS(905),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(913),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(913),
    [aux_sym_keyword_serial_token1] = ACTIONS(915),
    [aux_sym_keyword_serial_token2] = ACTIONS(915),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(917),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(917),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(919),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(919),
    [aux_sym_keyword_smallint_token1] = ACTIONS(921),
    [aux_sym_keyword_smallint_token2] = ACTIONS(921),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(923),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(923),
    [aux_sym_keyword_int_token1] = ACTIONS(925),
    [aux_sym_keyword_int_token2] = ACTIONS(925),
    [aux_sym_keyword_int_token3] = ACTIONS(925),
    [aux_sym_keyword_bigint_token1] = ACTIONS(927),
    [aux_sym_keyword_bigint_token2] = ACTIONS(927),
    [sym_keyword_decimal] = ACTIONS(929),
    [sym_keyword_numeric] = ACTIONS(931),
    [aux_sym_keyword_real_token1] = ACTIONS(933),
    [aux_sym_keyword_real_token2] = ACTIONS(933),
    [sym_keyword_float] = ACTIONS(935),
    [sym_keyword_double] = ACTIONS(937),
    [sym_keyword_inet] = ACTIONS(905),
    [sym_keyword_money] = ACTIONS(905),
    [sym_keyword_smallmoney] = ACTIONS(905),
    [aux_sym_keyword_char_token1] = ACTIONS(939),
    [sym_keyword_nchar] = ACTIONS(941),
    [aux_sym_keyword_varchar_token1] = ACTIONS(943),
    [sym_keyword_nvarchar] = ACTIONS(945),
    [sym_keyword_text] = ACTIONS(905),
    [sym_keyword_string] = ACTIONS(905),
    [sym_keyword_uuid] = ACTIONS(905),
    [sym_keyword_json] = ACTIONS(905),
    [sym_keyword_jsonb] = ACTIONS(905),
    [sym_keyword_xml] = ACTIONS(905),
    [sym_keyword_bytea] = ACTIONS(905),
    [sym_keyword_enum] = ACTIONS(947),
    [sym_keyword_date] = ACTIONS(905),
    [sym_keyword_datetime] = ACTIONS(905),
    [sym_keyword_datetime2] = ACTIONS(905),
    [sym_keyword_smalldatetime] = ACTIONS(905),
    [sym_keyword_datetimeoffset] = ACTIONS(949),
    [sym_keyword_time] = ACTIONS(951),
    [sym_keyword_timestamp] = ACTIONS(953),
    [sym_keyword_timestamptz] = ACTIONS(905),
    [sym_keyword_interval] = ACTIONS(905),
    [sym_keyword_geometry] = ACTIONS(905),
    [sym_keyword_geography] = ACTIONS(905),
    [sym_keyword_box2d] = ACTIONS(905),
    [sym_keyword_box3d] = ACTIONS(905),
    [sym_keyword_oid] = ACTIONS(905),
    [sym_keyword_name] = ACTIONS(905),
    [sym_keyword_regclass] = ACTIONS(905),
    [sym_keyword_regnamespace] = ACTIONS(905),
    [sym_keyword_regproc] = ACTIONS(905),
    [sym_keyword_regtype] = ACTIONS(905),
    [aux_sym_double_token1] = ACTIONS(955),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(957),
    [aux_sym_identifier_token1] = ACTIONS(957),
  },
  [35] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(10519),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [36] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(8285),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [37] = {
    [sym_keyword_smallserial] = STATE(4873),
    [sym_keyword_serial] = STATE(4873),
    [sym_keyword_bigserial] = STATE(4873),
    [sym_keyword_tinyint] = STATE(514),
    [sym_keyword_smallint] = STATE(516),
    [sym_keyword_mediumint] = STATE(473),
    [sym_keyword_int] = STATE(472),
    [sym_keyword_bigint] = STATE(513),
    [sym_keyword_real] = STATE(512),
    [sym_keyword_char] = STATE(797),
    [sym_keyword_varchar] = STATE(796),
    [sym__type] = STATE(4874),
    [sym_tinyint] = STATE(4873),
    [sym_smallint] = STATE(4873),
    [sym_mediumint] = STATE(4873),
    [sym_int] = STATE(4873),
    [sym_bigint] = STATE(4873),
    [sym_bit] = STATE(4873),
    [sym_binary] = STATE(4873),
    [sym_varbinary] = STATE(4873),
    [sym_float] = STATE(4873),
    [sym_double] = STATE(4873),
    [sym_decimal] = STATE(4873),
    [sym_numeric] = STATE(4873),
    [sym_char] = STATE(4873),
    [sym_varchar] = STATE(4873),
    [sym_nchar] = STATE(4873),
    [sym_nvarchar] = STATE(4873),
    [sym_datetimeoffset] = STATE(4873),
    [sym_time] = STATE(4873),
    [sym_timestamp] = STATE(4873),
    [sym_enum] = STATE(4873),
    [sym_object_reference] = STATE(4803),
    [sym_identifier] = STATE(5423),
    [sym__identifier] = ACTIONS(959),
    [aux_sym_keyword_character_token1] = ACTIONS(703),
    [sym_keyword_unsigned] = ACTIONS(705),
    [sym_keyword_boolean] = ACTIONS(961),
    [sym_keyword_bit] = ACTIONS(709),
    [sym_keyword_binary] = ACTIONS(711),
    [sym_keyword_varbinary] = ACTIONS(713),
    [sym_keyword_image] = ACTIONS(961),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(715),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(715),
    [aux_sym_keyword_serial_token1] = ACTIONS(717),
    [aux_sym_keyword_serial_token2] = ACTIONS(717),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(719),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(719),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(721),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(721),
    [aux_sym_keyword_smallint_token1] = ACTIONS(723),
    [aux_sym_keyword_smallint_token2] = ACTIONS(723),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(725),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(725),
    [aux_sym_keyword_int_token1] = ACTIONS(727),
    [aux_sym_keyword_int_token2] = ACTIONS(727),
    [aux_sym_keyword_int_token3] = ACTIONS(727),
    [aux_sym_keyword_bigint_token1] = ACTIONS(729),
    [aux_sym_keyword_bigint_token2] = ACTIONS(729),
    [sym_keyword_decimal] = ACTIONS(731),
    [sym_keyword_numeric] = ACTIONS(733),
    [aux_sym_keyword_real_token1] = ACTIONS(735),
    [aux_sym_keyword_real_token2] = ACTIONS(735),
    [sym_keyword_float] = ACTIONS(737),
    [sym_keyword_double] = ACTIONS(739),
    [sym_keyword_inet] = ACTIONS(961),
    [sym_keyword_money] = ACTIONS(961),
    [sym_keyword_smallmoney] = ACTIONS(961),
    [aux_sym_keyword_char_token1] = ACTIONS(741),
    [sym_keyword_nchar] = ACTIONS(743),
    [aux_sym_keyword_varchar_token1] = ACTIONS(745),
    [sym_keyword_nvarchar] = ACTIONS(747),
    [sym_keyword_text] = ACTIONS(961),
    [sym_keyword_string] = ACTIONS(961),
    [sym_keyword_uuid] = ACTIONS(961),
    [sym_keyword_json] = ACTIONS(961),
    [sym_keyword_jsonb] = ACTIONS(961),
    [sym_keyword_xml] = ACTIONS(961),
    [sym_keyword_bytea] = ACTIONS(961),
    [sym_keyword_enum] = ACTIONS(749),
    [sym_keyword_date] = ACTIONS(961),
    [sym_keyword_datetime] = ACTIONS(961),
    [sym_keyword_datetime2] = ACTIONS(961),
    [sym_keyword_smalldatetime] = ACTIONS(961),
    [sym_keyword_datetimeoffset] = ACTIONS(751),
    [sym_keyword_time] = ACTIONS(753),
    [sym_keyword_timestamp] = ACTIONS(755),
    [sym_keyword_timestamptz] = ACTIONS(961),
    [sym_keyword_interval] = ACTIONS(961),
    [sym_keyword_geometry] = ACTIONS(961),
    [sym_keyword_geography] = ACTIONS(961),
    [sym_keyword_box2d] = ACTIONS(961),
    [sym_keyword_box3d] = ACTIONS(961),
    [sym_keyword_oid] = ACTIONS(961),
    [sym_keyword_name] = ACTIONS(961),
    [sym_keyword_regclass] = ACTIONS(961),
    [sym_keyword_regnamespace] = ACTIONS(961),
    [sym_keyword_regproc] = ACTIONS(961),
    [sym_keyword_regtype] = ACTIONS(961),
    [aux_sym_double_token1] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(963),
    [aux_sym_identifier_token1] = ACTIONS(963),
  },
  [38] = {
    [sym_keyword_smallserial] = STATE(3008),
    [sym_keyword_serial] = STATE(3008),
    [sym_keyword_bigserial] = STATE(3008),
    [sym_keyword_tinyint] = STATE(2990),
    [sym_keyword_smallint] = STATE(2991),
    [sym_keyword_mediumint] = STATE(2992),
    [sym_keyword_int] = STATE(2993),
    [sym_keyword_bigint] = STATE(2994),
    [sym_keyword_real] = STATE(2995),
    [sym_keyword_char] = STATE(3755),
    [sym_keyword_varchar] = STATE(3754),
    [sym__type] = STATE(4433),
    [sym_tinyint] = STATE(3008),
    [sym_smallint] = STATE(3008),
    [sym_mediumint] = STATE(3008),
    [sym_int] = STATE(3008),
    [sym_bigint] = STATE(3008),
    [sym_bit] = STATE(3008),
    [sym_binary] = STATE(3008),
    [sym_varbinary] = STATE(3008),
    [sym_float] = STATE(3008),
    [sym_double] = STATE(3008),
    [sym_decimal] = STATE(3008),
    [sym_numeric] = STATE(3008),
    [sym_char] = STATE(3008),
    [sym_varchar] = STATE(3008),
    [sym_nchar] = STATE(3008),
    [sym_nvarchar] = STATE(3008),
    [sym_datetimeoffset] = STATE(3008),
    [sym_time] = STATE(3008),
    [sym_timestamp] = STATE(3008),
    [sym_enum] = STATE(3008),
    [sym_object_reference] = STATE(3047),
    [sym_identifier] = STATE(3569),
    [sym__identifier] = ACTIONS(965),
    [aux_sym_keyword_character_token1] = ACTIONS(967),
    [sym_keyword_unsigned] = ACTIONS(969),
    [sym_keyword_boolean] = ACTIONS(971),
    [sym_keyword_bit] = ACTIONS(973),
    [sym_keyword_binary] = ACTIONS(975),
    [sym_keyword_varbinary] = ACTIONS(977),
    [sym_keyword_image] = ACTIONS(971),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(979),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(979),
    [aux_sym_keyword_serial_token1] = ACTIONS(981),
    [aux_sym_keyword_serial_token2] = ACTIONS(981),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(983),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(983),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(985),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(985),
    [aux_sym_keyword_smallint_token1] = ACTIONS(987),
    [aux_sym_keyword_smallint_token2] = ACTIONS(987),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(989),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(989),
    [aux_sym_keyword_int_token1] = ACTIONS(991),
    [aux_sym_keyword_int_token2] = ACTIONS(991),
    [aux_sym_keyword_int_token3] = ACTIONS(991),
    [aux_sym_keyword_bigint_token1] = ACTIONS(993),
    [aux_sym_keyword_bigint_token2] = ACTIONS(993),
    [sym_keyword_decimal] = ACTIONS(995),
    [sym_keyword_numeric] = ACTIONS(997),
    [aux_sym_keyword_real_token1] = ACTIONS(999),
    [aux_sym_keyword_real_token2] = ACTIONS(999),
    [sym_keyword_float] = ACTIONS(1001),
    [sym_keyword_double] = ACTIONS(1003),
    [sym_keyword_inet] = ACTIONS(971),
    [sym_keyword_money] = ACTIONS(971),
    [sym_keyword_smallmoney] = ACTIONS(971),
    [aux_sym_keyword_char_token1] = ACTIONS(1005),
    [sym_keyword_nchar] = ACTIONS(1007),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1009),
    [sym_keyword_nvarchar] = ACTIONS(1011),
    [sym_keyword_text] = ACTIONS(971),
    [sym_keyword_string] = ACTIONS(971),
    [sym_keyword_uuid] = ACTIONS(971),
    [sym_keyword_json] = ACTIONS(971),
    [sym_keyword_jsonb] = ACTIONS(971),
    [sym_keyword_xml] = ACTIONS(971),
    [sym_keyword_bytea] = ACTIONS(971),
    [sym_keyword_enum] = ACTIONS(1013),
    [sym_keyword_date] = ACTIONS(971),
    [sym_keyword_datetime] = ACTIONS(971),
    [sym_keyword_datetime2] = ACTIONS(971),
    [sym_keyword_smalldatetime] = ACTIONS(971),
    [sym_keyword_datetimeoffset] = ACTIONS(1015),
    [sym_keyword_time] = ACTIONS(1017),
    [sym_keyword_timestamp] = ACTIONS(1019),
    [sym_keyword_timestamptz] = ACTIONS(971),
    [sym_keyword_interval] = ACTIONS(971),
    [sym_keyword_geometry] = ACTIONS(971),
    [sym_keyword_geography] = ACTIONS(971),
    [sym_keyword_box2d] = ACTIONS(971),
    [sym_keyword_box3d] = ACTIONS(971),
    [sym_keyword_oid] = ACTIONS(971),
    [sym_keyword_name] = ACTIONS(971),
    [sym_keyword_regclass] = ACTIONS(971),
    [sym_keyword_regnamespace] = ACTIONS(971),
    [sym_keyword_regproc] = ACTIONS(971),
    [sym_keyword_regtype] = ACTIONS(971),
    [aux_sym_double_token1] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1023),
    [aux_sym_identifier_token1] = ACTIONS(1023),
  },
  [39] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(10159),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [40] = {
    [sym_keyword_smallserial] = STATE(3072),
    [sym_keyword_serial] = STATE(3072),
    [sym_keyword_bigserial] = STATE(3072),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(4455),
    [sym_tinyint] = STATE(3072),
    [sym_smallint] = STATE(3072),
    [sym_mediumint] = STATE(3072),
    [sym_int] = STATE(3072),
    [sym_bigint] = STATE(3072),
    [sym_bit] = STATE(3072),
    [sym_binary] = STATE(3072),
    [sym_varbinary] = STATE(3072),
    [sym_float] = STATE(3072),
    [sym_double] = STATE(3072),
    [sym_decimal] = STATE(3072),
    [sym_numeric] = STATE(3072),
    [sym_char] = STATE(3072),
    [sym_varchar] = STATE(3072),
    [sym_nchar] = STATE(3072),
    [sym_nvarchar] = STATE(3072),
    [sym_datetimeoffset] = STATE(3072),
    [sym_time] = STATE(3072),
    [sym_timestamp] = STATE(3072),
    [sym_enum] = STATE(3072),
    [sym_object_reference] = STATE(2923),
    [sym_identifier] = STATE(3653),
    [sym__identifier] = ACTIONS(765),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(767),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(767),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(767),
    [sym_keyword_money] = ACTIONS(767),
    [sym_keyword_smallmoney] = ACTIONS(767),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(767),
    [sym_keyword_string] = ACTIONS(767),
    [sym_keyword_uuid] = ACTIONS(767),
    [sym_keyword_json] = ACTIONS(767),
    [sym_keyword_jsonb] = ACTIONS(767),
    [sym_keyword_xml] = ACTIONS(767),
    [sym_keyword_bytea] = ACTIONS(767),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(767),
    [sym_keyword_datetime] = ACTIONS(767),
    [sym_keyword_datetime2] = ACTIONS(767),
    [sym_keyword_smalldatetime] = ACTIONS(767),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(767),
    [sym_keyword_interval] = ACTIONS(767),
    [sym_keyword_geometry] = ACTIONS(767),
    [sym_keyword_geography] = ACTIONS(767),
    [sym_keyword_box2d] = ACTIONS(767),
    [sym_keyword_box3d] = ACTIONS(767),
    [sym_keyword_oid] = ACTIONS(767),
    [sym_keyword_name] = ACTIONS(767),
    [sym_keyword_regclass] = ACTIONS(767),
    [sym_keyword_regnamespace] = ACTIONS(767),
    [sym_keyword_regproc] = ACTIONS(767),
    [sym_keyword_regtype] = ACTIONS(767),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(773),
    [aux_sym_identifier_token1] = ACTIONS(773),
  },
  [41] = {
    [sym_keyword_smallserial] = STATE(6592),
    [sym_keyword_serial] = STATE(6592),
    [sym_keyword_bigserial] = STATE(6592),
    [sym_keyword_tinyint] = STATE(514),
    [sym_keyword_smallint] = STATE(516),
    [sym_keyword_mediumint] = STATE(473),
    [sym_keyword_int] = STATE(472),
    [sym_keyword_bigint] = STATE(513),
    [sym_keyword_real] = STATE(512),
    [sym_keyword_char] = STATE(797),
    [sym_keyword_varchar] = STATE(796),
    [sym__type] = STATE(6510),
    [sym_tinyint] = STATE(6592),
    [sym_smallint] = STATE(6592),
    [sym_mediumint] = STATE(6592),
    [sym_int] = STATE(6592),
    [sym_bigint] = STATE(6592),
    [sym_bit] = STATE(6592),
    [sym_binary] = STATE(6592),
    [sym_varbinary] = STATE(6592),
    [sym_float] = STATE(6592),
    [sym_double] = STATE(6592),
    [sym_decimal] = STATE(6592),
    [sym_numeric] = STATE(6592),
    [sym_char] = STATE(6592),
    [sym_varchar] = STATE(6592),
    [sym_nchar] = STATE(6592),
    [sym_nvarchar] = STATE(6592),
    [sym_datetimeoffset] = STATE(6592),
    [sym_time] = STATE(6592),
    [sym_timestamp] = STATE(6592),
    [sym_enum] = STATE(6592),
    [sym_object_reference] = STATE(6596),
    [sym_identifier] = STATE(6637),
    [sym__identifier] = ACTIONS(775),
    [aux_sym_keyword_character_token1] = ACTIONS(703),
    [sym_keyword_unsigned] = ACTIONS(705),
    [sym_keyword_boolean] = ACTIONS(1025),
    [sym_keyword_bit] = ACTIONS(709),
    [sym_keyword_binary] = ACTIONS(711),
    [sym_keyword_varbinary] = ACTIONS(713),
    [sym_keyword_image] = ACTIONS(1025),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(715),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(715),
    [aux_sym_keyword_serial_token1] = ACTIONS(717),
    [aux_sym_keyword_serial_token2] = ACTIONS(717),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(719),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(719),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(721),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(721),
    [aux_sym_keyword_smallint_token1] = ACTIONS(723),
    [aux_sym_keyword_smallint_token2] = ACTIONS(723),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(725),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(725),
    [aux_sym_keyword_int_token1] = ACTIONS(727),
    [aux_sym_keyword_int_token2] = ACTIONS(727),
    [aux_sym_keyword_int_token3] = ACTIONS(727),
    [aux_sym_keyword_bigint_token1] = ACTIONS(729),
    [aux_sym_keyword_bigint_token2] = ACTIONS(729),
    [sym_keyword_decimal] = ACTIONS(731),
    [sym_keyword_numeric] = ACTIONS(733),
    [aux_sym_keyword_real_token1] = ACTIONS(735),
    [aux_sym_keyword_real_token2] = ACTIONS(735),
    [sym_keyword_float] = ACTIONS(737),
    [sym_keyword_double] = ACTIONS(739),
    [sym_keyword_inet] = ACTIONS(1025),
    [sym_keyword_money] = ACTIONS(1025),
    [sym_keyword_smallmoney] = ACTIONS(1025),
    [aux_sym_keyword_char_token1] = ACTIONS(741),
    [sym_keyword_nchar] = ACTIONS(743),
    [aux_sym_keyword_varchar_token1] = ACTIONS(745),
    [sym_keyword_nvarchar] = ACTIONS(747),
    [sym_keyword_text] = ACTIONS(1025),
    [sym_keyword_string] = ACTIONS(1025),
    [sym_keyword_uuid] = ACTIONS(1025),
    [sym_keyword_json] = ACTIONS(1025),
    [sym_keyword_jsonb] = ACTIONS(1025),
    [sym_keyword_xml] = ACTIONS(1025),
    [sym_keyword_bytea] = ACTIONS(1025),
    [sym_keyword_enum] = ACTIONS(749),
    [sym_keyword_date] = ACTIONS(1025),
    [sym_keyword_datetime] = ACTIONS(1025),
    [sym_keyword_datetime2] = ACTIONS(1025),
    [sym_keyword_smalldatetime] = ACTIONS(1025),
    [sym_keyword_datetimeoffset] = ACTIONS(751),
    [sym_keyword_time] = ACTIONS(753),
    [sym_keyword_timestamp] = ACTIONS(755),
    [sym_keyword_timestamptz] = ACTIONS(1025),
    [sym_keyword_interval] = ACTIONS(1025),
    [sym_keyword_geometry] = ACTIONS(1025),
    [sym_keyword_geography] = ACTIONS(1025),
    [sym_keyword_box2d] = ACTIONS(1025),
    [sym_keyword_box3d] = ACTIONS(1025),
    [sym_keyword_oid] = ACTIONS(1025),
    [sym_keyword_name] = ACTIONS(1025),
    [sym_keyword_regclass] = ACTIONS(1025),
    [sym_keyword_regnamespace] = ACTIONS(1025),
    [sym_keyword_regproc] = ACTIONS(1025),
    [sym_keyword_regtype] = ACTIONS(1025),
    [aux_sym_double_token1] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(833),
    [aux_sym_identifier_token1] = ACTIONS(833),
  },
  [42] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(10711),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [43] = {
    [sym_keyword_smallserial] = STATE(2743),
    [sym_keyword_serial] = STATE(2743),
    [sym_keyword_bigserial] = STATE(2743),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(4323),
    [sym_tinyint] = STATE(2743),
    [sym_smallint] = STATE(2743),
    [sym_mediumint] = STATE(2743),
    [sym_int] = STATE(2743),
    [sym_bigint] = STATE(2743),
    [sym_bit] = STATE(2743),
    [sym_binary] = STATE(2743),
    [sym_varbinary] = STATE(2743),
    [sym_float] = STATE(2743),
    [sym_double] = STATE(2743),
    [sym_decimal] = STATE(2743),
    [sym_numeric] = STATE(2743),
    [sym_char] = STATE(2743),
    [sym_varchar] = STATE(2743),
    [sym_nchar] = STATE(2743),
    [sym_nvarchar] = STATE(2743),
    [sym_datetimeoffset] = STATE(2743),
    [sym_time] = STATE(2743),
    [sym_timestamp] = STATE(2743),
    [sym_enum] = STATE(2743),
    [sym_object_reference] = STATE(2755),
    [sym_identifier] = STATE(3344),
    [sym__identifier] = ACTIONS(211),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(213),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(213),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(213),
    [sym_keyword_money] = ACTIONS(213),
    [sym_keyword_smallmoney] = ACTIONS(213),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(213),
    [sym_keyword_string] = ACTIONS(213),
    [sym_keyword_uuid] = ACTIONS(213),
    [sym_keyword_json] = ACTIONS(213),
    [sym_keyword_jsonb] = ACTIONS(213),
    [sym_keyword_xml] = ACTIONS(213),
    [sym_keyword_bytea] = ACTIONS(213),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(213),
    [sym_keyword_datetime] = ACTIONS(213),
    [sym_keyword_datetime2] = ACTIONS(213),
    [sym_keyword_smalldatetime] = ACTIONS(213),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(1027),
    [sym_keyword_timestamp] = ACTIONS(1029),
    [sym_keyword_timestamptz] = ACTIONS(213),
    [sym_keyword_interval] = ACTIONS(213),
    [sym_keyword_geometry] = ACTIONS(213),
    [sym_keyword_geography] = ACTIONS(213),
    [sym_keyword_box2d] = ACTIONS(213),
    [sym_keyword_box3d] = ACTIONS(213),
    [sym_keyword_oid] = ACTIONS(213),
    [sym_keyword_name] = ACTIONS(213),
    [sym_keyword_regclass] = ACTIONS(213),
    [sym_keyword_regnamespace] = ACTIONS(213),
    [sym_keyword_regproc] = ACTIONS(213),
    [sym_keyword_regtype] = ACTIONS(213),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(215),
    [aux_sym_identifier_token1] = ACTIONS(215),
  },
  [44] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12118),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [45] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12033),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [46] = {
    [sym_keyword_smallserial] = STATE(5471),
    [sym_keyword_serial] = STATE(5471),
    [sym_keyword_bigserial] = STATE(5471),
    [sym_keyword_tinyint] = STATE(5303),
    [sym_keyword_smallint] = STATE(5304),
    [sym_keyword_mediumint] = STATE(5305),
    [sym_keyword_int] = STATE(5306),
    [sym_keyword_bigint] = STATE(5307),
    [sym_keyword_real] = STATE(5308),
    [sym_keyword_char] = STATE(5828),
    [sym_keyword_varchar] = STATE(5827),
    [sym__type] = STATE(6331),
    [sym_tinyint] = STATE(5471),
    [sym_smallint] = STATE(5471),
    [sym_mediumint] = STATE(5471),
    [sym_int] = STATE(5471),
    [sym_bigint] = STATE(5471),
    [sym_bit] = STATE(5471),
    [sym_binary] = STATE(5471),
    [sym_varbinary] = STATE(5471),
    [sym_float] = STATE(5471),
    [sym_double] = STATE(5471),
    [sym_decimal] = STATE(5471),
    [sym_numeric] = STATE(5471),
    [sym_char] = STATE(5471),
    [sym_varchar] = STATE(5471),
    [sym_nchar] = STATE(5471),
    [sym_nvarchar] = STATE(5471),
    [sym_datetimeoffset] = STATE(5471),
    [sym_time] = STATE(5471),
    [sym_timestamp] = STATE(5471),
    [sym_enum] = STATE(5471),
    [sym_object_reference] = STATE(5463),
    [sym_identifier] = STATE(5904),
    [sym__identifier] = ACTIONS(1031),
    [aux_sym_keyword_character_token1] = ACTIONS(1033),
    [sym_keyword_unsigned] = ACTIONS(1035),
    [sym_keyword_boolean] = ACTIONS(1037),
    [sym_keyword_bit] = ACTIONS(1039),
    [sym_keyword_binary] = ACTIONS(1041),
    [sym_keyword_varbinary] = ACTIONS(1043),
    [sym_keyword_image] = ACTIONS(1037),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1045),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1045),
    [aux_sym_keyword_serial_token1] = ACTIONS(1047),
    [aux_sym_keyword_serial_token2] = ACTIONS(1047),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1049),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1049),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1051),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1051),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1053),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1053),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1055),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1055),
    [aux_sym_keyword_int_token1] = ACTIONS(1057),
    [aux_sym_keyword_int_token2] = ACTIONS(1057),
    [aux_sym_keyword_int_token3] = ACTIONS(1057),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1059),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1059),
    [sym_keyword_decimal] = ACTIONS(1061),
    [sym_keyword_numeric] = ACTIONS(1063),
    [aux_sym_keyword_real_token1] = ACTIONS(1065),
    [aux_sym_keyword_real_token2] = ACTIONS(1065),
    [sym_keyword_float] = ACTIONS(1067),
    [sym_keyword_double] = ACTIONS(1069),
    [sym_keyword_inet] = ACTIONS(1037),
    [sym_keyword_money] = ACTIONS(1037),
    [sym_keyword_smallmoney] = ACTIONS(1037),
    [aux_sym_keyword_char_token1] = ACTIONS(1071),
    [sym_keyword_nchar] = ACTIONS(1073),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1075),
    [sym_keyword_nvarchar] = ACTIONS(1077),
    [sym_keyword_text] = ACTIONS(1037),
    [sym_keyword_string] = ACTIONS(1037),
    [sym_keyword_uuid] = ACTIONS(1037),
    [sym_keyword_json] = ACTIONS(1037),
    [sym_keyword_jsonb] = ACTIONS(1037),
    [sym_keyword_xml] = ACTIONS(1037),
    [sym_keyword_bytea] = ACTIONS(1037),
    [sym_keyword_enum] = ACTIONS(1079),
    [sym_keyword_date] = ACTIONS(1037),
    [sym_keyword_datetime] = ACTIONS(1037),
    [sym_keyword_datetime2] = ACTIONS(1037),
    [sym_keyword_smalldatetime] = ACTIONS(1037),
    [sym_keyword_datetimeoffset] = ACTIONS(1081),
    [sym_keyword_time] = ACTIONS(1083),
    [sym_keyword_timestamp] = ACTIONS(1085),
    [sym_keyword_timestamptz] = ACTIONS(1037),
    [sym_keyword_interval] = ACTIONS(1037),
    [sym_keyword_geometry] = ACTIONS(1037),
    [sym_keyword_geography] = ACTIONS(1037),
    [sym_keyword_box2d] = ACTIONS(1037),
    [sym_keyword_box3d] = ACTIONS(1037),
    [sym_keyword_oid] = ACTIONS(1037),
    [sym_keyword_name] = ACTIONS(1037),
    [sym_keyword_regclass] = ACTIONS(1037),
    [sym_keyword_regnamespace] = ACTIONS(1037),
    [sym_keyword_regproc] = ACTIONS(1037),
    [sym_keyword_regtype] = ACTIONS(1037),
    [aux_sym_double_token1] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1089),
    [aux_sym_identifier_token1] = ACTIONS(1089),
  },
  [47] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(8348),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [48] = {
    [sym_keyword_smallserial] = STATE(2665),
    [sym_keyword_serial] = STATE(2665),
    [sym_keyword_bigserial] = STATE(2665),
    [sym_keyword_tinyint] = STATE(161),
    [sym_keyword_smallint] = STATE(155),
    [sym_keyword_mediumint] = STATE(164),
    [sym_keyword_int] = STATE(152),
    [sym_keyword_bigint] = STATE(153),
    [sym_keyword_real] = STATE(159),
    [sym_keyword_char] = STATE(194),
    [sym_keyword_varchar] = STATE(191),
    [sym__type] = STATE(2656),
    [sym_tinyint] = STATE(2665),
    [sym_smallint] = STATE(2665),
    [sym_mediumint] = STATE(2665),
    [sym_int] = STATE(2665),
    [sym_bigint] = STATE(2665),
    [sym_bit] = STATE(2665),
    [sym_binary] = STATE(2665),
    [sym_varbinary] = STATE(2665),
    [sym_float] = STATE(2665),
    [sym_double] = STATE(2665),
    [sym_decimal] = STATE(2665),
    [sym_numeric] = STATE(2665),
    [sym_char] = STATE(2665),
    [sym_varchar] = STATE(2665),
    [sym_nchar] = STATE(2665),
    [sym_nvarchar] = STATE(2665),
    [sym_datetimeoffset] = STATE(2665),
    [sym_time] = STATE(2665),
    [sym_timestamp] = STATE(2665),
    [sym_enum] = STATE(2665),
    [sym_object_reference] = STATE(2652),
    [sym_identifier] = STATE(2769),
    [sym__identifier] = ACTIONS(1091),
    [aux_sym_keyword_character_token1] = ACTIONS(279),
    [sym_keyword_unsigned] = ACTIONS(281),
    [sym_keyword_boolean] = ACTIONS(1093),
    [sym_keyword_bit] = ACTIONS(285),
    [sym_keyword_binary] = ACTIONS(287),
    [sym_keyword_varbinary] = ACTIONS(289),
    [sym_keyword_image] = ACTIONS(1093),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(291),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(291),
    [aux_sym_keyword_serial_token1] = ACTIONS(293),
    [aux_sym_keyword_serial_token2] = ACTIONS(293),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(295),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(295),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(297),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(297),
    [aux_sym_keyword_smallint_token1] = ACTIONS(299),
    [aux_sym_keyword_smallint_token2] = ACTIONS(299),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(301),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(301),
    [aux_sym_keyword_int_token1] = ACTIONS(303),
    [aux_sym_keyword_int_token2] = ACTIONS(303),
    [aux_sym_keyword_int_token3] = ACTIONS(303),
    [aux_sym_keyword_bigint_token1] = ACTIONS(305),
    [aux_sym_keyword_bigint_token2] = ACTIONS(305),
    [sym_keyword_decimal] = ACTIONS(307),
    [sym_keyword_numeric] = ACTIONS(309),
    [aux_sym_keyword_real_token1] = ACTIONS(311),
    [aux_sym_keyword_real_token2] = ACTIONS(311),
    [sym_keyword_float] = ACTIONS(313),
    [sym_keyword_double] = ACTIONS(315),
    [sym_keyword_inet] = ACTIONS(1093),
    [sym_keyword_money] = ACTIONS(1093),
    [sym_keyword_smallmoney] = ACTIONS(1093),
    [aux_sym_keyword_char_token1] = ACTIONS(317),
    [sym_keyword_nchar] = ACTIONS(319),
    [aux_sym_keyword_varchar_token1] = ACTIONS(321),
    [sym_keyword_nvarchar] = ACTIONS(323),
    [sym_keyword_text] = ACTIONS(1093),
    [sym_keyword_string] = ACTIONS(1093),
    [sym_keyword_uuid] = ACTIONS(1093),
    [sym_keyword_json] = ACTIONS(1093),
    [sym_keyword_jsonb] = ACTIONS(1093),
    [sym_keyword_xml] = ACTIONS(1093),
    [sym_keyword_bytea] = ACTIONS(1093),
    [sym_keyword_enum] = ACTIONS(325),
    [sym_keyword_date] = ACTIONS(1093),
    [sym_keyword_datetime] = ACTIONS(1093),
    [sym_keyword_datetime2] = ACTIONS(1093),
    [sym_keyword_smalldatetime] = ACTIONS(1093),
    [sym_keyword_datetimeoffset] = ACTIONS(327),
    [sym_keyword_time] = ACTIONS(329),
    [sym_keyword_timestamp] = ACTIONS(331),
    [sym_keyword_timestamptz] = ACTIONS(1093),
    [sym_keyword_interval] = ACTIONS(1093),
    [sym_keyword_geometry] = ACTIONS(1093),
    [sym_keyword_geography] = ACTIONS(1093),
    [sym_keyword_box2d] = ACTIONS(1093),
    [sym_keyword_box3d] = ACTIONS(1093),
    [sym_keyword_oid] = ACTIONS(1093),
    [sym_keyword_name] = ACTIONS(1093),
    [sym_keyword_regclass] = ACTIONS(1093),
    [sym_keyword_regnamespace] = ACTIONS(1093),
    [sym_keyword_regproc] = ACTIONS(1093),
    [sym_keyword_regtype] = ACTIONS(1093),
    [aux_sym_double_token1] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1095),
    [aux_sym_identifier_token1] = ACTIONS(1095),
  },
  [49] = {
    [sym_keyword_smallserial] = STATE(4749),
    [sym_keyword_serial] = STATE(4749),
    [sym_keyword_bigserial] = STATE(4749),
    [sym_keyword_tinyint] = STATE(4773),
    [sym_keyword_smallint] = STATE(4769),
    [sym_keyword_mediumint] = STATE(4768),
    [sym_keyword_int] = STATE(4767),
    [sym_keyword_bigint] = STATE(4766),
    [sym_keyword_real] = STATE(4765),
    [sym_keyword_char] = STATE(4980),
    [sym_keyword_varchar] = STATE(4978),
    [sym__type] = STATE(2656),
    [sym_tinyint] = STATE(4749),
    [sym_smallint] = STATE(4749),
    [sym_mediumint] = STATE(4749),
    [sym_int] = STATE(4749),
    [sym_bigint] = STATE(4749),
    [sym_bit] = STATE(4749),
    [sym_binary] = STATE(4749),
    [sym_varbinary] = STATE(4749),
    [sym_float] = STATE(4749),
    [sym_double] = STATE(4749),
    [sym_decimal] = STATE(4749),
    [sym_numeric] = STATE(4749),
    [sym_char] = STATE(4749),
    [sym_varchar] = STATE(4749),
    [sym_nchar] = STATE(4749),
    [sym_nvarchar] = STATE(4749),
    [sym_datetimeoffset] = STATE(4749),
    [sym_time] = STATE(4749),
    [sym_timestamp] = STATE(4749),
    [sym_enum] = STATE(4749),
    [sym_object_reference] = STATE(4747),
    [sym_identifier] = STATE(5048),
    [sym__identifier] = ACTIONS(127),
    [aux_sym_keyword_character_token1] = ACTIONS(1097),
    [sym_keyword_unsigned] = ACTIONS(1099),
    [sym_keyword_boolean] = ACTIONS(1101),
    [sym_keyword_bit] = ACTIONS(1103),
    [sym_keyword_binary] = ACTIONS(1105),
    [sym_keyword_varbinary] = ACTIONS(1107),
    [sym_keyword_image] = ACTIONS(1101),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1109),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1109),
    [aux_sym_keyword_serial_token1] = ACTIONS(1111),
    [aux_sym_keyword_serial_token2] = ACTIONS(1111),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1113),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1113),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1115),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1115),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1117),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1117),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1119),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1119),
    [aux_sym_keyword_int_token1] = ACTIONS(1121),
    [aux_sym_keyword_int_token2] = ACTIONS(1121),
    [aux_sym_keyword_int_token3] = ACTIONS(1121),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1123),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1123),
    [sym_keyword_decimal] = ACTIONS(1125),
    [sym_keyword_numeric] = ACTIONS(1127),
    [aux_sym_keyword_real_token1] = ACTIONS(1129),
    [aux_sym_keyword_real_token2] = ACTIONS(1129),
    [sym_keyword_float] = ACTIONS(1131),
    [sym_keyword_double] = ACTIONS(1133),
    [sym_keyword_inet] = ACTIONS(1101),
    [sym_keyword_money] = ACTIONS(1101),
    [sym_keyword_smallmoney] = ACTIONS(1101),
    [aux_sym_keyword_char_token1] = ACTIONS(1135),
    [sym_keyword_nchar] = ACTIONS(1137),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1139),
    [sym_keyword_nvarchar] = ACTIONS(1141),
    [sym_keyword_text] = ACTIONS(1101),
    [sym_keyword_string] = ACTIONS(1101),
    [sym_keyword_uuid] = ACTIONS(1101),
    [sym_keyword_json] = ACTIONS(1101),
    [sym_keyword_jsonb] = ACTIONS(1101),
    [sym_keyword_xml] = ACTIONS(1101),
    [sym_keyword_bytea] = ACTIONS(1101),
    [sym_keyword_enum] = ACTIONS(1143),
    [sym_keyword_date] = ACTIONS(1101),
    [sym_keyword_datetime] = ACTIONS(1101),
    [sym_keyword_datetime2] = ACTIONS(1101),
    [sym_keyword_smalldatetime] = ACTIONS(1101),
    [sym_keyword_datetimeoffset] = ACTIONS(1145),
    [sym_keyword_time] = ACTIONS(1147),
    [sym_keyword_timestamp] = ACTIONS(1149),
    [sym_keyword_timestamptz] = ACTIONS(1101),
    [sym_keyword_interval] = ACTIONS(1101),
    [sym_keyword_geometry] = ACTIONS(1101),
    [sym_keyword_geography] = ACTIONS(1101),
    [sym_keyword_box2d] = ACTIONS(1101),
    [sym_keyword_box3d] = ACTIONS(1101),
    [sym_keyword_oid] = ACTIONS(1101),
    [sym_keyword_name] = ACTIONS(1101),
    [sym_keyword_regclass] = ACTIONS(1101),
    [sym_keyword_regnamespace] = ACTIONS(1101),
    [sym_keyword_regproc] = ACTIONS(1101),
    [sym_keyword_regtype] = ACTIONS(1101),
    [aux_sym_double_token1] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [50] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6460),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [51] = {
    [sym_keyword_smallserial] = STATE(3008),
    [sym_keyword_serial] = STATE(3008),
    [sym_keyword_bigserial] = STATE(3008),
    [sym_keyword_tinyint] = STATE(2990),
    [sym_keyword_smallint] = STATE(2991),
    [sym_keyword_mediumint] = STATE(2992),
    [sym_keyword_int] = STATE(2993),
    [sym_keyword_bigint] = STATE(2994),
    [sym_keyword_real] = STATE(2995),
    [sym_keyword_char] = STATE(3755),
    [sym_keyword_varchar] = STATE(3754),
    [sym__type] = STATE(4433),
    [sym_tinyint] = STATE(3008),
    [sym_smallint] = STATE(3008),
    [sym_mediumint] = STATE(3008),
    [sym_int] = STATE(3008),
    [sym_bigint] = STATE(3008),
    [sym_bit] = STATE(3008),
    [sym_binary] = STATE(3008),
    [sym_varbinary] = STATE(3008),
    [sym_float] = STATE(3008),
    [sym_double] = STATE(3008),
    [sym_decimal] = STATE(3008),
    [sym_numeric] = STATE(3008),
    [sym_char] = STATE(3008),
    [sym_varchar] = STATE(3008),
    [sym_nchar] = STATE(3008),
    [sym_nvarchar] = STATE(3008),
    [sym_datetimeoffset] = STATE(3008),
    [sym_time] = STATE(3008),
    [sym_timestamp] = STATE(3008),
    [sym_enum] = STATE(3008),
    [sym_object_reference] = STATE(3047),
    [sym_identifier] = STATE(3569),
    [sym__identifier] = ACTIONS(965),
    [aux_sym_keyword_character_token1] = ACTIONS(967),
    [sym_keyword_unsigned] = ACTIONS(969),
    [sym_keyword_boolean] = ACTIONS(971),
    [sym_keyword_bit] = ACTIONS(973),
    [sym_keyword_binary] = ACTIONS(975),
    [sym_keyword_varbinary] = ACTIONS(977),
    [sym_keyword_image] = ACTIONS(971),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(979),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(979),
    [aux_sym_keyword_serial_token1] = ACTIONS(981),
    [aux_sym_keyword_serial_token2] = ACTIONS(981),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(983),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(983),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(985),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(985),
    [aux_sym_keyword_smallint_token1] = ACTIONS(987),
    [aux_sym_keyword_smallint_token2] = ACTIONS(987),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(989),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(989),
    [aux_sym_keyword_int_token1] = ACTIONS(991),
    [aux_sym_keyword_int_token2] = ACTIONS(991),
    [aux_sym_keyword_int_token3] = ACTIONS(991),
    [aux_sym_keyword_bigint_token1] = ACTIONS(993),
    [aux_sym_keyword_bigint_token2] = ACTIONS(993),
    [sym_keyword_decimal] = ACTIONS(995),
    [sym_keyword_numeric] = ACTIONS(997),
    [aux_sym_keyword_real_token1] = ACTIONS(999),
    [aux_sym_keyword_real_token2] = ACTIONS(999),
    [sym_keyword_float] = ACTIONS(1001),
    [sym_keyword_double] = ACTIONS(1003),
    [sym_keyword_inet] = ACTIONS(971),
    [sym_keyword_money] = ACTIONS(971),
    [sym_keyword_smallmoney] = ACTIONS(971),
    [aux_sym_keyword_char_token1] = ACTIONS(1005),
    [sym_keyword_nchar] = ACTIONS(1007),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1009),
    [sym_keyword_nvarchar] = ACTIONS(1011),
    [sym_keyword_text] = ACTIONS(971),
    [sym_keyword_string] = ACTIONS(971),
    [sym_keyword_uuid] = ACTIONS(971),
    [sym_keyword_json] = ACTIONS(971),
    [sym_keyword_jsonb] = ACTIONS(971),
    [sym_keyword_xml] = ACTIONS(971),
    [sym_keyword_bytea] = ACTIONS(971),
    [sym_keyword_enum] = ACTIONS(1013),
    [sym_keyword_date] = ACTIONS(971),
    [sym_keyword_datetime] = ACTIONS(971),
    [sym_keyword_datetime2] = ACTIONS(971),
    [sym_keyword_smalldatetime] = ACTIONS(971),
    [sym_keyword_datetimeoffset] = ACTIONS(1015),
    [sym_keyword_time] = ACTIONS(1153),
    [sym_keyword_timestamp] = ACTIONS(1155),
    [sym_keyword_timestamptz] = ACTIONS(971),
    [sym_keyword_interval] = ACTIONS(971),
    [sym_keyword_geometry] = ACTIONS(971),
    [sym_keyword_geography] = ACTIONS(971),
    [sym_keyword_box2d] = ACTIONS(971),
    [sym_keyword_box3d] = ACTIONS(971),
    [sym_keyword_oid] = ACTIONS(971),
    [sym_keyword_name] = ACTIONS(971),
    [sym_keyword_regclass] = ACTIONS(971),
    [sym_keyword_regnamespace] = ACTIONS(971),
    [sym_keyword_regproc] = ACTIONS(971),
    [sym_keyword_regtype] = ACTIONS(971),
    [aux_sym_double_token1] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1023),
    [aux_sym_identifier_token1] = ACTIONS(1023),
  },
  [52] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12303),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [53] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(7351),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(1818),
    [sym__identifier] = ACTIONS(1157),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1159),
    [aux_sym_identifier_token1] = ACTIONS(1159),
  },
  [54] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(8602),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [55] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(9687),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [56] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12893),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [57] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(8154),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [58] = {
    [sym_keyword_smallserial] = STATE(6573),
    [sym_keyword_serial] = STATE(6573),
    [sym_keyword_bigserial] = STATE(6573),
    [sym_keyword_tinyint] = STATE(161),
    [sym_keyword_smallint] = STATE(155),
    [sym_keyword_mediumint] = STATE(164),
    [sym_keyword_int] = STATE(152),
    [sym_keyword_bigint] = STATE(153),
    [sym_keyword_real] = STATE(159),
    [sym_keyword_char] = STATE(194),
    [sym_keyword_varchar] = STATE(191),
    [sym__type] = STATE(6464),
    [sym_tinyint] = STATE(6573),
    [sym_smallint] = STATE(6573),
    [sym_mediumint] = STATE(6573),
    [sym_int] = STATE(6573),
    [sym_bigint] = STATE(6573),
    [sym_bit] = STATE(6573),
    [sym_binary] = STATE(6573),
    [sym_varbinary] = STATE(6573),
    [sym_float] = STATE(6573),
    [sym_double] = STATE(6573),
    [sym_decimal] = STATE(6573),
    [sym_numeric] = STATE(6573),
    [sym_char] = STATE(6573),
    [sym_varchar] = STATE(6573),
    [sym_nchar] = STATE(6573),
    [sym_nvarchar] = STATE(6573),
    [sym_datetimeoffset] = STATE(6573),
    [sym_time] = STATE(6573),
    [sym_timestamp] = STATE(6573),
    [sym_enum] = STATE(6573),
    [sym_object_reference] = STATE(6581),
    [sym_identifier] = STATE(6624),
    [sym__identifier] = ACTIONS(217),
    [aux_sym_keyword_character_token1] = ACTIONS(279),
    [sym_keyword_unsigned] = ACTIONS(281),
    [sym_keyword_boolean] = ACTIONS(1161),
    [sym_keyword_bit] = ACTIONS(285),
    [sym_keyword_binary] = ACTIONS(287),
    [sym_keyword_varbinary] = ACTIONS(289),
    [sym_keyword_image] = ACTIONS(1161),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(291),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(291),
    [aux_sym_keyword_serial_token1] = ACTIONS(293),
    [aux_sym_keyword_serial_token2] = ACTIONS(293),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(295),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(295),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(297),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(297),
    [aux_sym_keyword_smallint_token1] = ACTIONS(299),
    [aux_sym_keyword_smallint_token2] = ACTIONS(299),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(301),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(301),
    [aux_sym_keyword_int_token1] = ACTIONS(303),
    [aux_sym_keyword_int_token2] = ACTIONS(303),
    [aux_sym_keyword_int_token3] = ACTIONS(303),
    [aux_sym_keyword_bigint_token1] = ACTIONS(305),
    [aux_sym_keyword_bigint_token2] = ACTIONS(305),
    [sym_keyword_decimal] = ACTIONS(307),
    [sym_keyword_numeric] = ACTIONS(309),
    [aux_sym_keyword_real_token1] = ACTIONS(311),
    [aux_sym_keyword_real_token2] = ACTIONS(311),
    [sym_keyword_float] = ACTIONS(313),
    [sym_keyword_double] = ACTIONS(315),
    [sym_keyword_inet] = ACTIONS(1161),
    [sym_keyword_money] = ACTIONS(1161),
    [sym_keyword_smallmoney] = ACTIONS(1161),
    [aux_sym_keyword_char_token1] = ACTIONS(317),
    [sym_keyword_nchar] = ACTIONS(319),
    [aux_sym_keyword_varchar_token1] = ACTIONS(321),
    [sym_keyword_nvarchar] = ACTIONS(323),
    [sym_keyword_text] = ACTIONS(1161),
    [sym_keyword_string] = ACTIONS(1161),
    [sym_keyword_uuid] = ACTIONS(1161),
    [sym_keyword_json] = ACTIONS(1161),
    [sym_keyword_jsonb] = ACTIONS(1161),
    [sym_keyword_xml] = ACTIONS(1161),
    [sym_keyword_bytea] = ACTIONS(1161),
    [sym_keyword_enum] = ACTIONS(325),
    [sym_keyword_date] = ACTIONS(1161),
    [sym_keyword_datetime] = ACTIONS(1161),
    [sym_keyword_datetime2] = ACTIONS(1161),
    [sym_keyword_smalldatetime] = ACTIONS(1161),
    [sym_keyword_datetimeoffset] = ACTIONS(327),
    [sym_keyword_time] = ACTIONS(329),
    [sym_keyword_timestamp] = ACTIONS(331),
    [sym_keyword_timestamptz] = ACTIONS(1161),
    [sym_keyword_interval] = ACTIONS(1161),
    [sym_keyword_geometry] = ACTIONS(1161),
    [sym_keyword_geography] = ACTIONS(1161),
    [sym_keyword_box2d] = ACTIONS(1161),
    [sym_keyword_box3d] = ACTIONS(1161),
    [sym_keyword_oid] = ACTIONS(1161),
    [sym_keyword_name] = ACTIONS(1161),
    [sym_keyword_regclass] = ACTIONS(1161),
    [sym_keyword_regnamespace] = ACTIONS(1161),
    [sym_keyword_regproc] = ACTIONS(1161),
    [sym_keyword_regtype] = ACTIONS(1161),
    [aux_sym_double_token1] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(275),
    [aux_sym_identifier_token1] = ACTIONS(275),
  },
  [59] = {
    [sym_keyword_smallserial] = STATE(2617),
    [sym_keyword_serial] = STATE(2617),
    [sym_keyword_bigserial] = STATE(2617),
    [sym_keyword_tinyint] = STATE(2605),
    [sym_keyword_smallint] = STATE(2604),
    [sym_keyword_mediumint] = STATE(2601),
    [sym_keyword_int] = STATE(2589),
    [sym_keyword_bigint] = STATE(2588),
    [sym_keyword_real] = STATE(2582),
    [sym_keyword_char] = STATE(3023),
    [sym_keyword_varchar] = STATE(3022),
    [sym__type] = STATE(3432),
    [sym_tinyint] = STATE(2617),
    [sym_smallint] = STATE(2617),
    [sym_mediumint] = STATE(2617),
    [sym_int] = STATE(2617),
    [sym_bigint] = STATE(2617),
    [sym_bit] = STATE(2617),
    [sym_binary] = STATE(2617),
    [sym_varbinary] = STATE(2617),
    [sym_float] = STATE(2617),
    [sym_double] = STATE(2617),
    [sym_decimal] = STATE(2617),
    [sym_numeric] = STATE(2617),
    [sym_char] = STATE(2617),
    [sym_varchar] = STATE(2617),
    [sym_nchar] = STATE(2617),
    [sym_nvarchar] = STATE(2617),
    [sym_datetimeoffset] = STATE(2617),
    [sym_time] = STATE(2617),
    [sym_timestamp] = STATE(2617),
    [sym_enum] = STATE(2617),
    [sym_object_reference] = STATE(2623),
    [sym_identifier] = STATE(4708),
    [sym__identifier] = ACTIONS(1163),
    [aux_sym_keyword_character_token1] = ACTIONS(1165),
    [sym_keyword_unsigned] = ACTIONS(1167),
    [sym_keyword_boolean] = ACTIONS(1169),
    [sym_keyword_bit] = ACTIONS(1171),
    [sym_keyword_binary] = ACTIONS(1173),
    [sym_keyword_varbinary] = ACTIONS(1175),
    [sym_keyword_image] = ACTIONS(1169),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1177),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1177),
    [aux_sym_keyword_serial_token1] = ACTIONS(1179),
    [aux_sym_keyword_serial_token2] = ACTIONS(1179),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1181),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1181),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1183),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1183),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1185),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1185),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1187),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1187),
    [aux_sym_keyword_int_token1] = ACTIONS(1189),
    [aux_sym_keyword_int_token2] = ACTIONS(1189),
    [aux_sym_keyword_int_token3] = ACTIONS(1189),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1191),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1191),
    [sym_keyword_decimal] = ACTIONS(1193),
    [sym_keyword_numeric] = ACTIONS(1195),
    [aux_sym_keyword_real_token1] = ACTIONS(1197),
    [aux_sym_keyword_real_token2] = ACTIONS(1197),
    [sym_keyword_float] = ACTIONS(1199),
    [sym_keyword_double] = ACTIONS(1201),
    [sym_keyword_inet] = ACTIONS(1169),
    [sym_keyword_money] = ACTIONS(1169),
    [sym_keyword_smallmoney] = ACTIONS(1169),
    [aux_sym_keyword_char_token1] = ACTIONS(1203),
    [sym_keyword_nchar] = ACTIONS(1205),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1207),
    [sym_keyword_nvarchar] = ACTIONS(1209),
    [sym_keyword_text] = ACTIONS(1169),
    [sym_keyword_string] = ACTIONS(1169),
    [sym_keyword_uuid] = ACTIONS(1169),
    [sym_keyword_json] = ACTIONS(1169),
    [sym_keyword_jsonb] = ACTIONS(1169),
    [sym_keyword_xml] = ACTIONS(1169),
    [sym_keyword_bytea] = ACTIONS(1169),
    [sym_keyword_enum] = ACTIONS(1211),
    [sym_keyword_date] = ACTIONS(1169),
    [sym_keyword_datetime] = ACTIONS(1169),
    [sym_keyword_datetime2] = ACTIONS(1169),
    [sym_keyword_smalldatetime] = ACTIONS(1169),
    [sym_keyword_datetimeoffset] = ACTIONS(1213),
    [sym_keyword_time] = ACTIONS(1215),
    [sym_keyword_timestamp] = ACTIONS(1217),
    [sym_keyword_timestamptz] = ACTIONS(1169),
    [sym_keyword_interval] = ACTIONS(1169),
    [sym_keyword_geometry] = ACTIONS(1169),
    [sym_keyword_geography] = ACTIONS(1169),
    [sym_keyword_box2d] = ACTIONS(1169),
    [sym_keyword_box3d] = ACTIONS(1169),
    [sym_keyword_oid] = ACTIONS(1169),
    [sym_keyword_name] = ACTIONS(1169),
    [sym_keyword_regclass] = ACTIONS(1169),
    [sym_keyword_regnamespace] = ACTIONS(1169),
    [sym_keyword_regproc] = ACTIONS(1169),
    [sym_keyword_regtype] = ACTIONS(1169),
    [aux_sym_double_token1] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1221),
    [aux_sym_identifier_token1] = ACTIONS(1221),
  },
  [60] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13465),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [61] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(11450),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [62] = {
    [sym_keyword_smallserial] = STATE(4749),
    [sym_keyword_serial] = STATE(4749),
    [sym_keyword_bigserial] = STATE(4749),
    [sym_keyword_tinyint] = STATE(4773),
    [sym_keyword_smallint] = STATE(4769),
    [sym_keyword_mediumint] = STATE(4768),
    [sym_keyword_int] = STATE(4767),
    [sym_keyword_bigint] = STATE(4766),
    [sym_keyword_real] = STATE(4765),
    [sym_keyword_char] = STATE(4980),
    [sym_keyword_varchar] = STATE(4978),
    [sym__type] = STATE(2656),
    [sym_tinyint] = STATE(4749),
    [sym_smallint] = STATE(4749),
    [sym_mediumint] = STATE(4749),
    [sym_int] = STATE(4749),
    [sym_bigint] = STATE(4749),
    [sym_bit] = STATE(4749),
    [sym_binary] = STATE(4749),
    [sym_varbinary] = STATE(4749),
    [sym_float] = STATE(4749),
    [sym_double] = STATE(4749),
    [sym_decimal] = STATE(4749),
    [sym_numeric] = STATE(4749),
    [sym_char] = STATE(4749),
    [sym_varchar] = STATE(4749),
    [sym_nchar] = STATE(4749),
    [sym_nvarchar] = STATE(4749),
    [sym_datetimeoffset] = STATE(4749),
    [sym_time] = STATE(4749),
    [sym_timestamp] = STATE(4749),
    [sym_enum] = STATE(4749),
    [sym_object_reference] = STATE(4747),
    [sym_identifier] = STATE(2769),
    [sym__identifier] = ACTIONS(1091),
    [aux_sym_keyword_character_token1] = ACTIONS(1097),
    [sym_keyword_unsigned] = ACTIONS(1099),
    [sym_keyword_boolean] = ACTIONS(1101),
    [sym_keyword_bit] = ACTIONS(1103),
    [sym_keyword_binary] = ACTIONS(1105),
    [sym_keyword_varbinary] = ACTIONS(1107),
    [sym_keyword_image] = ACTIONS(1101),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1109),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1109),
    [aux_sym_keyword_serial_token1] = ACTIONS(1111),
    [aux_sym_keyword_serial_token2] = ACTIONS(1111),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1113),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1113),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1115),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1115),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1117),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1117),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1119),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1119),
    [aux_sym_keyword_int_token1] = ACTIONS(1121),
    [aux_sym_keyword_int_token2] = ACTIONS(1121),
    [aux_sym_keyword_int_token3] = ACTIONS(1121),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1123),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1123),
    [sym_keyword_decimal] = ACTIONS(1125),
    [sym_keyword_numeric] = ACTIONS(1127),
    [aux_sym_keyword_real_token1] = ACTIONS(1129),
    [aux_sym_keyword_real_token2] = ACTIONS(1129),
    [sym_keyword_float] = ACTIONS(1131),
    [sym_keyword_double] = ACTIONS(1133),
    [sym_keyword_inet] = ACTIONS(1101),
    [sym_keyword_money] = ACTIONS(1101),
    [sym_keyword_smallmoney] = ACTIONS(1101),
    [aux_sym_keyword_char_token1] = ACTIONS(1135),
    [sym_keyword_nchar] = ACTIONS(1137),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1139),
    [sym_keyword_nvarchar] = ACTIONS(1141),
    [sym_keyword_text] = ACTIONS(1101),
    [sym_keyword_string] = ACTIONS(1101),
    [sym_keyword_uuid] = ACTIONS(1101),
    [sym_keyword_json] = ACTIONS(1101),
    [sym_keyword_jsonb] = ACTIONS(1101),
    [sym_keyword_xml] = ACTIONS(1101),
    [sym_keyword_bytea] = ACTIONS(1101),
    [sym_keyword_enum] = ACTIONS(1143),
    [sym_keyword_date] = ACTIONS(1101),
    [sym_keyword_datetime] = ACTIONS(1101),
    [sym_keyword_datetime2] = ACTIONS(1101),
    [sym_keyword_smalldatetime] = ACTIONS(1101),
    [sym_keyword_datetimeoffset] = ACTIONS(1145),
    [sym_keyword_time] = ACTIONS(1147),
    [sym_keyword_timestamp] = ACTIONS(1149),
    [sym_keyword_timestamptz] = ACTIONS(1101),
    [sym_keyword_interval] = ACTIONS(1101),
    [sym_keyword_geometry] = ACTIONS(1101),
    [sym_keyword_geography] = ACTIONS(1101),
    [sym_keyword_box2d] = ACTIONS(1101),
    [sym_keyword_box3d] = ACTIONS(1101),
    [sym_keyword_oid] = ACTIONS(1101),
    [sym_keyword_name] = ACTIONS(1101),
    [sym_keyword_regclass] = ACTIONS(1101),
    [sym_keyword_regnamespace] = ACTIONS(1101),
    [sym_keyword_regproc] = ACTIONS(1101),
    [sym_keyword_regtype] = ACTIONS(1101),
    [aux_sym_double_token1] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1095),
    [aux_sym_identifier_token1] = ACTIONS(1095),
  },
  [63] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(9692),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [64] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13603),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [65] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(10826),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [66] = {
    [sym_keyword_smallserial] = STATE(1056),
    [sym_keyword_serial] = STATE(1056),
    [sym_keyword_bigserial] = STATE(1056),
    [sym_keyword_tinyint] = STATE(1336),
    [sym_keyword_smallint] = STATE(1333),
    [sym_keyword_mediumint] = STATE(1330),
    [sym_keyword_int] = STATE(1328),
    [sym_keyword_bigint] = STATE(1327),
    [sym_keyword_real] = STATE(1326),
    [sym_keyword_char] = STATE(2073),
    [sym_keyword_varchar] = STATE(1898),
    [sym__type] = STATE(2414),
    [sym_tinyint] = STATE(1056),
    [sym_smallint] = STATE(1056),
    [sym_mediumint] = STATE(1056),
    [sym_int] = STATE(1056),
    [sym_bigint] = STATE(1056),
    [sym_bit] = STATE(1056),
    [sym_binary] = STATE(1056),
    [sym_varbinary] = STATE(1056),
    [sym_float] = STATE(1056),
    [sym_double] = STATE(1056),
    [sym_decimal] = STATE(1056),
    [sym_numeric] = STATE(1056),
    [sym_char] = STATE(1056),
    [sym_varchar] = STATE(1056),
    [sym_nchar] = STATE(1056),
    [sym_nvarchar] = STATE(1056),
    [sym_datetimeoffset] = STATE(1056),
    [sym_time] = STATE(1056),
    [sym_timestamp] = STATE(1056),
    [sym_enum] = STATE(1056),
    [sym_object_reference] = STATE(1042),
    [sym_identifier] = STATE(2029),
    [sym__identifier] = ACTIONS(899),
    [aux_sym_keyword_character_token1] = ACTIONS(901),
    [sym_keyword_unsigned] = ACTIONS(903),
    [sym_keyword_boolean] = ACTIONS(905),
    [sym_keyword_bit] = ACTIONS(907),
    [sym_keyword_binary] = ACTIONS(909),
    [sym_keyword_varbinary] = ACTIONS(911),
    [sym_keyword_image] = ACTIONS(905),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(913),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(913),
    [aux_sym_keyword_serial_token1] = ACTIONS(915),
    [aux_sym_keyword_serial_token2] = ACTIONS(915),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(917),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(917),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(919),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(919),
    [aux_sym_keyword_smallint_token1] = ACTIONS(921),
    [aux_sym_keyword_smallint_token2] = ACTIONS(921),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(923),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(923),
    [aux_sym_keyword_int_token1] = ACTIONS(925),
    [aux_sym_keyword_int_token2] = ACTIONS(925),
    [aux_sym_keyword_int_token3] = ACTIONS(925),
    [aux_sym_keyword_bigint_token1] = ACTIONS(927),
    [aux_sym_keyword_bigint_token2] = ACTIONS(927),
    [sym_keyword_decimal] = ACTIONS(929),
    [sym_keyword_numeric] = ACTIONS(931),
    [aux_sym_keyword_real_token1] = ACTIONS(933),
    [aux_sym_keyword_real_token2] = ACTIONS(933),
    [sym_keyword_float] = ACTIONS(935),
    [sym_keyword_double] = ACTIONS(937),
    [sym_keyword_inet] = ACTIONS(905),
    [sym_keyword_money] = ACTIONS(905),
    [sym_keyword_smallmoney] = ACTIONS(905),
    [aux_sym_keyword_char_token1] = ACTIONS(939),
    [sym_keyword_nchar] = ACTIONS(941),
    [aux_sym_keyword_varchar_token1] = ACTIONS(943),
    [sym_keyword_nvarchar] = ACTIONS(945),
    [sym_keyword_text] = ACTIONS(905),
    [sym_keyword_string] = ACTIONS(905),
    [sym_keyword_uuid] = ACTIONS(905),
    [sym_keyword_json] = ACTIONS(905),
    [sym_keyword_jsonb] = ACTIONS(905),
    [sym_keyword_xml] = ACTIONS(905),
    [sym_keyword_bytea] = ACTIONS(905),
    [sym_keyword_enum] = ACTIONS(947),
    [sym_keyword_date] = ACTIONS(905),
    [sym_keyword_datetime] = ACTIONS(905),
    [sym_keyword_datetime2] = ACTIONS(905),
    [sym_keyword_smalldatetime] = ACTIONS(905),
    [sym_keyword_datetimeoffset] = ACTIONS(949),
    [sym_keyword_time] = ACTIONS(1223),
    [sym_keyword_timestamp] = ACTIONS(1225),
    [sym_keyword_timestamptz] = ACTIONS(905),
    [sym_keyword_interval] = ACTIONS(905),
    [sym_keyword_geometry] = ACTIONS(905),
    [sym_keyword_geography] = ACTIONS(905),
    [sym_keyword_box2d] = ACTIONS(905),
    [sym_keyword_box3d] = ACTIONS(905),
    [sym_keyword_oid] = ACTIONS(905),
    [sym_keyword_name] = ACTIONS(905),
    [sym_keyword_regclass] = ACTIONS(905),
    [sym_keyword_regnamespace] = ACTIONS(905),
    [sym_keyword_regproc] = ACTIONS(905),
    [sym_keyword_regtype] = ACTIONS(905),
    [aux_sym_double_token1] = ACTIONS(955),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(957),
    [aux_sym_identifier_token1] = ACTIONS(957),
  },
  [67] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6472),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [68] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(7286),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(1818),
    [sym__identifier] = ACTIONS(1157),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1159),
    [aux_sym_identifier_token1] = ACTIONS(1159),
  },
  [69] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(14491),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [70] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13996),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [71] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13379),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [72] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(12736),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [73] = {
    [sym_keyword_smallserial] = STATE(6912),
    [sym_keyword_serial] = STATE(6912),
    [sym_keyword_bigserial] = STATE(6912),
    [sym_keyword_tinyint] = STATE(6916),
    [sym_keyword_smallint] = STATE(6915),
    [sym_keyword_mediumint] = STATE(6914),
    [sym_keyword_int] = STATE(6906),
    [sym_keyword_bigint] = STATE(6904),
    [sym_keyword_real] = STATE(6922),
    [sym_keyword_char] = STATE(7038),
    [sym_keyword_varchar] = STATE(7037),
    [sym__type] = STATE(7507),
    [sym_tinyint] = STATE(6912),
    [sym_smallint] = STATE(6912),
    [sym_mediumint] = STATE(6912),
    [sym_int] = STATE(6912),
    [sym_bigint] = STATE(6912),
    [sym_bit] = STATE(6912),
    [sym_binary] = STATE(6912),
    [sym_varbinary] = STATE(6912),
    [sym_float] = STATE(6912),
    [sym_double] = STATE(6912),
    [sym_decimal] = STATE(6912),
    [sym_numeric] = STATE(6912),
    [sym_char] = STATE(6912),
    [sym_varchar] = STATE(6912),
    [sym_nchar] = STATE(6912),
    [sym_nvarchar] = STATE(6912),
    [sym_datetimeoffset] = STATE(6912),
    [sym_time] = STATE(6912),
    [sym_timestamp] = STATE(6912),
    [sym_enum] = STATE(6912),
    [sym_object_reference] = STATE(6946),
    [sym_identifier] = STATE(3575),
    [sym__identifier] = ACTIONS(1227),
    [aux_sym_keyword_character_token1] = ACTIONS(1229),
    [sym_keyword_unsigned] = ACTIONS(1231),
    [sym_keyword_boolean] = ACTIONS(1233),
    [sym_keyword_bit] = ACTIONS(1235),
    [sym_keyword_binary] = ACTIONS(1237),
    [sym_keyword_varbinary] = ACTIONS(1239),
    [sym_keyword_image] = ACTIONS(1233),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1241),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1241),
    [aux_sym_keyword_serial_token1] = ACTIONS(1243),
    [aux_sym_keyword_serial_token2] = ACTIONS(1243),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1245),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1245),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1247),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1247),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1249),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1249),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1251),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1251),
    [aux_sym_keyword_int_token1] = ACTIONS(1253),
    [aux_sym_keyword_int_token2] = ACTIONS(1253),
    [aux_sym_keyword_int_token3] = ACTIONS(1253),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1255),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1255),
    [sym_keyword_decimal] = ACTIONS(1257),
    [sym_keyword_numeric] = ACTIONS(1259),
    [aux_sym_keyword_real_token1] = ACTIONS(1261),
    [aux_sym_keyword_real_token2] = ACTIONS(1261),
    [sym_keyword_float] = ACTIONS(1263),
    [sym_keyword_double] = ACTIONS(1265),
    [sym_keyword_inet] = ACTIONS(1233),
    [sym_keyword_money] = ACTIONS(1233),
    [sym_keyword_smallmoney] = ACTIONS(1233),
    [aux_sym_keyword_char_token1] = ACTIONS(1267),
    [sym_keyword_nchar] = ACTIONS(1269),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1271),
    [sym_keyword_nvarchar] = ACTIONS(1273),
    [sym_keyword_text] = ACTIONS(1233),
    [sym_keyword_string] = ACTIONS(1233),
    [sym_keyword_uuid] = ACTIONS(1233),
    [sym_keyword_json] = ACTIONS(1233),
    [sym_keyword_jsonb] = ACTIONS(1233),
    [sym_keyword_xml] = ACTIONS(1233),
    [sym_keyword_bytea] = ACTIONS(1233),
    [sym_keyword_enum] = ACTIONS(1275),
    [sym_keyword_date] = ACTIONS(1233),
    [sym_keyword_datetime] = ACTIONS(1233),
    [sym_keyword_datetime2] = ACTIONS(1233),
    [sym_keyword_smalldatetime] = ACTIONS(1233),
    [sym_keyword_datetimeoffset] = ACTIONS(1277),
    [sym_keyword_time] = ACTIONS(1279),
    [sym_keyword_timestamp] = ACTIONS(1281),
    [sym_keyword_timestamptz] = ACTIONS(1233),
    [sym_keyword_interval] = ACTIONS(1233),
    [sym_keyword_geometry] = ACTIONS(1233),
    [sym_keyword_geography] = ACTIONS(1233),
    [sym_keyword_box2d] = ACTIONS(1233),
    [sym_keyword_box3d] = ACTIONS(1233),
    [sym_keyword_oid] = ACTIONS(1233),
    [sym_keyword_name] = ACTIONS(1233),
    [sym_keyword_regclass] = ACTIONS(1233),
    [sym_keyword_regnamespace] = ACTIONS(1233),
    [sym_keyword_regproc] = ACTIONS(1233),
    [sym_keyword_regtype] = ACTIONS(1233),
    [aux_sym_double_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1285),
    [aux_sym_identifier_token1] = ACTIONS(1285),
  },
  [74] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(8247),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [75] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(14590),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [76] = {
    [sym_keyword_smallserial] = STATE(2617),
    [sym_keyword_serial] = STATE(2617),
    [sym_keyword_bigserial] = STATE(2617),
    [sym_keyword_tinyint] = STATE(2605),
    [sym_keyword_smallint] = STATE(2604),
    [sym_keyword_mediumint] = STATE(2601),
    [sym_keyword_int] = STATE(2589),
    [sym_keyword_bigint] = STATE(2588),
    [sym_keyword_real] = STATE(2582),
    [sym_keyword_char] = STATE(3023),
    [sym_keyword_varchar] = STATE(3022),
    [sym__type] = STATE(3432),
    [sym_tinyint] = STATE(2617),
    [sym_smallint] = STATE(2617),
    [sym_mediumint] = STATE(2617),
    [sym_int] = STATE(2617),
    [sym_bigint] = STATE(2617),
    [sym_bit] = STATE(2617),
    [sym_binary] = STATE(2617),
    [sym_varbinary] = STATE(2617),
    [sym_float] = STATE(2617),
    [sym_double] = STATE(2617),
    [sym_decimal] = STATE(2617),
    [sym_numeric] = STATE(2617),
    [sym_char] = STATE(2617),
    [sym_varchar] = STATE(2617),
    [sym_nchar] = STATE(2617),
    [sym_nvarchar] = STATE(2617),
    [sym_datetimeoffset] = STATE(2617),
    [sym_time] = STATE(2617),
    [sym_timestamp] = STATE(2617),
    [sym_enum] = STATE(2617),
    [sym_object_reference] = STATE(2623),
    [sym_identifier] = STATE(5364),
    [sym__identifier] = ACTIONS(397),
    [aux_sym_keyword_character_token1] = ACTIONS(1165),
    [sym_keyword_unsigned] = ACTIONS(1167),
    [sym_keyword_boolean] = ACTIONS(1169),
    [sym_keyword_bit] = ACTIONS(1171),
    [sym_keyword_binary] = ACTIONS(1173),
    [sym_keyword_varbinary] = ACTIONS(1175),
    [sym_keyword_image] = ACTIONS(1169),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1177),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1177),
    [aux_sym_keyword_serial_token1] = ACTIONS(1179),
    [aux_sym_keyword_serial_token2] = ACTIONS(1179),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1181),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1181),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1183),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1183),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1185),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1185),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1187),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1187),
    [aux_sym_keyword_int_token1] = ACTIONS(1189),
    [aux_sym_keyword_int_token2] = ACTIONS(1189),
    [aux_sym_keyword_int_token3] = ACTIONS(1189),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1191),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1191),
    [sym_keyword_decimal] = ACTIONS(1193),
    [sym_keyword_numeric] = ACTIONS(1195),
    [aux_sym_keyword_real_token1] = ACTIONS(1197),
    [aux_sym_keyword_real_token2] = ACTIONS(1197),
    [sym_keyword_float] = ACTIONS(1199),
    [sym_keyword_double] = ACTIONS(1201),
    [sym_keyword_inet] = ACTIONS(1169),
    [sym_keyword_money] = ACTIONS(1169),
    [sym_keyword_smallmoney] = ACTIONS(1169),
    [aux_sym_keyword_char_token1] = ACTIONS(1203),
    [sym_keyword_nchar] = ACTIONS(1205),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1207),
    [sym_keyword_nvarchar] = ACTIONS(1209),
    [sym_keyword_text] = ACTIONS(1169),
    [sym_keyword_string] = ACTIONS(1169),
    [sym_keyword_uuid] = ACTIONS(1169),
    [sym_keyword_json] = ACTIONS(1169),
    [sym_keyword_jsonb] = ACTIONS(1169),
    [sym_keyword_xml] = ACTIONS(1169),
    [sym_keyword_bytea] = ACTIONS(1169),
    [sym_keyword_enum] = ACTIONS(1211),
    [sym_keyword_date] = ACTIONS(1169),
    [sym_keyword_datetime] = ACTIONS(1169),
    [sym_keyword_datetime2] = ACTIONS(1169),
    [sym_keyword_smalldatetime] = ACTIONS(1169),
    [sym_keyword_datetimeoffset] = ACTIONS(1213),
    [sym_keyword_time] = ACTIONS(1215),
    [sym_keyword_timestamp] = ACTIONS(1217),
    [sym_keyword_timestamptz] = ACTIONS(1169),
    [sym_keyword_interval] = ACTIONS(1169),
    [sym_keyword_geometry] = ACTIONS(1169),
    [sym_keyword_geography] = ACTIONS(1169),
    [sym_keyword_box2d] = ACTIONS(1169),
    [sym_keyword_box3d] = ACTIONS(1169),
    [sym_keyword_oid] = ACTIONS(1169),
    [sym_keyword_name] = ACTIONS(1169),
    [sym_keyword_regclass] = ACTIONS(1169),
    [sym_keyword_regnamespace] = ACTIONS(1169),
    [sym_keyword_regproc] = ACTIONS(1169),
    [sym_keyword_regtype] = ACTIONS(1169),
    [aux_sym_double_token1] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(455),
    [aux_sym_identifier_token1] = ACTIONS(455),
  },
  [77] = {
    [sym_keyword_smallserial] = STATE(2776),
    [sym_keyword_serial] = STATE(2776),
    [sym_keyword_bigserial] = STATE(2776),
    [sym_keyword_tinyint] = STATE(2825),
    [sym_keyword_smallint] = STATE(2824),
    [sym_keyword_mediumint] = STATE(2821),
    [sym_keyword_int] = STATE(2819),
    [sym_keyword_bigint] = STATE(2818),
    [sym_keyword_real] = STATE(2814),
    [sym_keyword_char] = STATE(3411),
    [sym_keyword_varchar] = STATE(3412),
    [sym__type] = STATE(4154),
    [sym_tinyint] = STATE(2776),
    [sym_smallint] = STATE(2776),
    [sym_mediumint] = STATE(2776),
    [sym_int] = STATE(2776),
    [sym_bigint] = STATE(2776),
    [sym_bit] = STATE(2776),
    [sym_binary] = STATE(2776),
    [sym_varbinary] = STATE(2776),
    [sym_float] = STATE(2776),
    [sym_double] = STATE(2776),
    [sym_decimal] = STATE(2776),
    [sym_numeric] = STATE(2776),
    [sym_char] = STATE(2776),
    [sym_varchar] = STATE(2776),
    [sym_nchar] = STATE(2776),
    [sym_nvarchar] = STATE(2776),
    [sym_datetimeoffset] = STATE(2776),
    [sym_time] = STATE(2776),
    [sym_timestamp] = STATE(2776),
    [sym_enum] = STATE(2776),
    [sym_object_reference] = STATE(2775),
    [sym_identifier] = STATE(3284),
    [sym__identifier] = ACTIONS(217),
    [aux_sym_keyword_character_token1] = ACTIONS(219),
    [sym_keyword_unsigned] = ACTIONS(221),
    [sym_keyword_boolean] = ACTIONS(223),
    [sym_keyword_bit] = ACTIONS(225),
    [sym_keyword_binary] = ACTIONS(227),
    [sym_keyword_varbinary] = ACTIONS(229),
    [sym_keyword_image] = ACTIONS(223),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(231),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(231),
    [aux_sym_keyword_serial_token1] = ACTIONS(233),
    [aux_sym_keyword_serial_token2] = ACTIONS(233),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(235),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(235),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(237),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(237),
    [aux_sym_keyword_smallint_token1] = ACTIONS(239),
    [aux_sym_keyword_smallint_token2] = ACTIONS(239),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(241),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(241),
    [aux_sym_keyword_int_token1] = ACTIONS(243),
    [aux_sym_keyword_int_token2] = ACTIONS(243),
    [aux_sym_keyword_int_token3] = ACTIONS(243),
    [aux_sym_keyword_bigint_token1] = ACTIONS(245),
    [aux_sym_keyword_bigint_token2] = ACTIONS(245),
    [sym_keyword_decimal] = ACTIONS(247),
    [sym_keyword_numeric] = ACTIONS(249),
    [aux_sym_keyword_real_token1] = ACTIONS(251),
    [aux_sym_keyword_real_token2] = ACTIONS(251),
    [sym_keyword_float] = ACTIONS(253),
    [sym_keyword_double] = ACTIONS(255),
    [sym_keyword_inet] = ACTIONS(223),
    [sym_keyword_money] = ACTIONS(223),
    [sym_keyword_smallmoney] = ACTIONS(223),
    [aux_sym_keyword_char_token1] = ACTIONS(257),
    [sym_keyword_nchar] = ACTIONS(259),
    [aux_sym_keyword_varchar_token1] = ACTIONS(261),
    [sym_keyword_nvarchar] = ACTIONS(263),
    [sym_keyword_text] = ACTIONS(223),
    [sym_keyword_string] = ACTIONS(223),
    [sym_keyword_uuid] = ACTIONS(223),
    [sym_keyword_json] = ACTIONS(223),
    [sym_keyword_jsonb] = ACTIONS(223),
    [sym_keyword_xml] = ACTIONS(223),
    [sym_keyword_bytea] = ACTIONS(223),
    [sym_keyword_enum] = ACTIONS(265),
    [sym_keyword_date] = ACTIONS(223),
    [sym_keyword_datetime] = ACTIONS(223),
    [sym_keyword_datetime2] = ACTIONS(223),
    [sym_keyword_smalldatetime] = ACTIONS(223),
    [sym_keyword_datetimeoffset] = ACTIONS(267),
    [sym_keyword_time] = ACTIONS(1287),
    [sym_keyword_timestamp] = ACTIONS(1289),
    [sym_keyword_timestamptz] = ACTIONS(223),
    [sym_keyword_interval] = ACTIONS(223),
    [sym_keyword_geometry] = ACTIONS(223),
    [sym_keyword_geography] = ACTIONS(223),
    [sym_keyword_box2d] = ACTIONS(223),
    [sym_keyword_box3d] = ACTIONS(223),
    [sym_keyword_oid] = ACTIONS(223),
    [sym_keyword_name] = ACTIONS(223),
    [sym_keyword_regclass] = ACTIONS(223),
    [sym_keyword_regnamespace] = ACTIONS(223),
    [sym_keyword_regproc] = ACTIONS(223),
    [sym_keyword_regtype] = ACTIONS(223),
    [aux_sym_double_token1] = ACTIONS(273),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(275),
    [aux_sym_identifier_token1] = ACTIONS(275),
  },
  [78] = {
    [sym_keyword_smallserial] = STATE(7583),
    [sym_keyword_serial] = STATE(7583),
    [sym_keyword_bigserial] = STATE(7583),
    [sym_keyword_tinyint] = STATE(2543),
    [sym_keyword_smallint] = STATE(2547),
    [sym_keyword_mediumint] = STATE(2552),
    [sym_keyword_int] = STATE(2554),
    [sym_keyword_bigint] = STATE(2558),
    [sym_keyword_real] = STATE(2559),
    [sym_keyword_char] = STATE(2752),
    [sym_keyword_varchar] = STATE(2753),
    [sym__type] = STATE(10361),
    [sym_tinyint] = STATE(7583),
    [sym_smallint] = STATE(7583),
    [sym_mediumint] = STATE(7583),
    [sym_int] = STATE(7583),
    [sym_bigint] = STATE(7583),
    [sym_bit] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_varbinary] = STATE(7583),
    [sym_float] = STATE(7583),
    [sym_double] = STATE(7583),
    [sym_decimal] = STATE(7583),
    [sym_numeric] = STATE(7583),
    [sym_char] = STATE(7583),
    [sym_varchar] = STATE(7583),
    [sym_nchar] = STATE(7583),
    [sym_nvarchar] = STATE(7583),
    [sym_datetimeoffset] = STATE(7583),
    [sym_time] = STATE(7583),
    [sym_timestamp] = STATE(7583),
    [sym_enum] = STATE(7583),
    [sym_object_reference] = STATE(7581),
    [sym_identifier] = STATE(7262),
    [sym__identifier] = ACTIONS(337),
    [aux_sym_keyword_character_token1] = ACTIONS(339),
    [sym_keyword_unsigned] = ACTIONS(341),
    [sym_keyword_boolean] = ACTIONS(343),
    [sym_keyword_bit] = ACTIONS(345),
    [sym_keyword_binary] = ACTIONS(347),
    [sym_keyword_varbinary] = ACTIONS(349),
    [sym_keyword_image] = ACTIONS(343),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(351),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(351),
    [aux_sym_keyword_serial_token1] = ACTIONS(353),
    [aux_sym_keyword_serial_token2] = ACTIONS(353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(355),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(355),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(357),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(357),
    [aux_sym_keyword_smallint_token1] = ACTIONS(359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(361),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(361),
    [aux_sym_keyword_int_token1] = ACTIONS(363),
    [aux_sym_keyword_int_token2] = ACTIONS(363),
    [aux_sym_keyword_int_token3] = ACTIONS(363),
    [aux_sym_keyword_bigint_token1] = ACTIONS(365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(365),
    [sym_keyword_decimal] = ACTIONS(367),
    [sym_keyword_numeric] = ACTIONS(369),
    [aux_sym_keyword_real_token1] = ACTIONS(371),
    [aux_sym_keyword_real_token2] = ACTIONS(371),
    [sym_keyword_float] = ACTIONS(373),
    [sym_keyword_double] = ACTIONS(375),
    [sym_keyword_inet] = ACTIONS(343),
    [sym_keyword_money] = ACTIONS(343),
    [sym_keyword_smallmoney] = ACTIONS(343),
    [aux_sym_keyword_char_token1] = ACTIONS(377),
    [sym_keyword_nchar] = ACTIONS(379),
    [aux_sym_keyword_varchar_token1] = ACTIONS(381),
    [sym_keyword_nvarchar] = ACTIONS(383),
    [sym_keyword_text] = ACTIONS(343),
    [sym_keyword_string] = ACTIONS(343),
    [sym_keyword_uuid] = ACTIONS(343),
    [sym_keyword_json] = ACTIONS(343),
    [sym_keyword_jsonb] = ACTIONS(343),
    [sym_keyword_xml] = ACTIONS(343),
    [sym_keyword_bytea] = ACTIONS(343),
    [sym_keyword_enum] = ACTIONS(385),
    [sym_keyword_date] = ACTIONS(343),
    [sym_keyword_datetime] = ACTIONS(343),
    [sym_keyword_datetime2] = ACTIONS(343),
    [sym_keyword_smalldatetime] = ACTIONS(343),
    [sym_keyword_datetimeoffset] = ACTIONS(387),
    [sym_keyword_time] = ACTIONS(389),
    [sym_keyword_timestamp] = ACTIONS(391),
    [sym_keyword_timestamptz] = ACTIONS(343),
    [sym_keyword_interval] = ACTIONS(343),
    [sym_keyword_geometry] = ACTIONS(343),
    [sym_keyword_geography] = ACTIONS(343),
    [sym_keyword_box2d] = ACTIONS(343),
    [sym_keyword_box3d] = ACTIONS(343),
    [sym_keyword_oid] = ACTIONS(343),
    [sym_keyword_name] = ACTIONS(343),
    [sym_keyword_regclass] = ACTIONS(343),
    [sym_keyword_regnamespace] = ACTIONS(343),
    [sym_keyword_regproc] = ACTIONS(343),
    [sym_keyword_regtype] = ACTIONS(343),
    [aux_sym_double_token1] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(395),
    [aux_sym_identifier_token1] = ACTIONS(395),
  },
  [79] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(13181),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [80] = {
    [sym_keyword_smallserial] = STATE(5106),
    [sym_keyword_serial] = STATE(5106),
    [sym_keyword_bigserial] = STATE(5106),
    [sym_keyword_tinyint] = STATE(5155),
    [sym_keyword_smallint] = STATE(5159),
    [sym_keyword_mediumint] = STATE(5189),
    [sym_keyword_int] = STATE(5190),
    [sym_keyword_bigint] = STATE(5191),
    [sym_keyword_real] = STATE(5192),
    [sym_keyword_char] = STATE(5938),
    [sym_keyword_varchar] = STATE(6033),
    [sym__type] = STATE(6429),
    [sym_tinyint] = STATE(5106),
    [sym_smallint] = STATE(5106),
    [sym_mediumint] = STATE(5106),
    [sym_int] = STATE(5106),
    [sym_bigint] = STATE(5106),
    [sym_bit] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym_varbinary] = STATE(5106),
    [sym_float] = STATE(5106),
    [sym_double] = STATE(5106),
    [sym_decimal] = STATE(5106),
    [sym_numeric] = STATE(5106),
    [sym_char] = STATE(5106),
    [sym_varchar] = STATE(5106),
    [sym_nchar] = STATE(5106),
    [sym_nvarchar] = STATE(5106),
    [sym_datetimeoffset] = STATE(5106),
    [sym_time] = STATE(5106),
    [sym_timestamp] = STATE(5106),
    [sym_enum] = STATE(5106),
    [sym_object_reference] = STATE(5203),
    [sym_identifier] = STATE(6812),
    [sym__identifier] = ACTIONS(127),
    [aux_sym_keyword_character_token1] = ACTIONS(131),
    [sym_keyword_unsigned] = ACTIONS(133),
    [sym_keyword_boolean] = ACTIONS(139),
    [sym_keyword_bit] = ACTIONS(141),
    [sym_keyword_binary] = ACTIONS(143),
    [sym_keyword_varbinary] = ACTIONS(145),
    [sym_keyword_image] = ACTIONS(139),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(147),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(147),
    [aux_sym_keyword_serial_token1] = ACTIONS(149),
    [aux_sym_keyword_serial_token2] = ACTIONS(149),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(151),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(151),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(153),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(153),
    [aux_sym_keyword_smallint_token1] = ACTIONS(155),
    [aux_sym_keyword_smallint_token2] = ACTIONS(155),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(157),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(157),
    [aux_sym_keyword_int_token1] = ACTIONS(159),
    [aux_sym_keyword_int_token2] = ACTIONS(159),
    [aux_sym_keyword_int_token3] = ACTIONS(159),
    [aux_sym_keyword_bigint_token1] = ACTIONS(161),
    [aux_sym_keyword_bigint_token2] = ACTIONS(161),
    [sym_keyword_decimal] = ACTIONS(163),
    [sym_keyword_numeric] = ACTIONS(165),
    [aux_sym_keyword_real_token1] = ACTIONS(167),
    [aux_sym_keyword_real_token2] = ACTIONS(167),
    [sym_keyword_float] = ACTIONS(169),
    [sym_keyword_double] = ACTIONS(171),
    [sym_keyword_inet] = ACTIONS(139),
    [sym_keyword_money] = ACTIONS(139),
    [sym_keyword_smallmoney] = ACTIONS(139),
    [aux_sym_keyword_char_token1] = ACTIONS(173),
    [sym_keyword_nchar] = ACTIONS(175),
    [aux_sym_keyword_varchar_token1] = ACTIONS(177),
    [sym_keyword_nvarchar] = ACTIONS(179),
    [sym_keyword_text] = ACTIONS(139),
    [sym_keyword_string] = ACTIONS(139),
    [sym_keyword_uuid] = ACTIONS(139),
    [sym_keyword_json] = ACTIONS(139),
    [sym_keyword_jsonb] = ACTIONS(139),
    [sym_keyword_xml] = ACTIONS(139),
    [sym_keyword_bytea] = ACTIONS(139),
    [sym_keyword_enum] = ACTIONS(181),
    [sym_keyword_date] = ACTIONS(139),
    [sym_keyword_datetime] = ACTIONS(139),
    [sym_keyword_datetime2] = ACTIONS(139),
    [sym_keyword_smalldatetime] = ACTIONS(139),
    [sym_keyword_datetimeoffset] = ACTIONS(183),
    [sym_keyword_time] = ACTIONS(185),
    [sym_keyword_timestamp] = ACTIONS(187),
    [sym_keyword_timestamptz] = ACTIONS(139),
    [sym_keyword_interval] = ACTIONS(139),
    [sym_keyword_geometry] = ACTIONS(139),
    [sym_keyword_geography] = ACTIONS(139),
    [sym_keyword_box2d] = ACTIONS(139),
    [sym_keyword_box3d] = ACTIONS(139),
    [sym_keyword_oid] = ACTIONS(139),
    [sym_keyword_name] = ACTIONS(139),
    [sym_keyword_regclass] = ACTIONS(139),
    [sym_keyword_regnamespace] = ACTIONS(139),
    [sym_keyword_regproc] = ACTIONS(139),
    [sym_keyword_regtype] = ACTIONS(139),
    [aux_sym_double_token1] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(191),
    [aux_sym_identifier_token1] = ACTIONS(191),
  },
  [81] = {
    [sym_keyword_smallserial] = STATE(7120),
    [sym_keyword_serial] = STATE(7120),
    [sym_keyword_bigserial] = STATE(7120),
    [sym_keyword_tinyint] = STATE(1869),
    [sym_keyword_smallint] = STATE(1868),
    [sym_keyword_mediumint] = STATE(1861),
    [sym_keyword_int] = STATE(1807),
    [sym_keyword_bigint] = STATE(1880),
    [sym_keyword_real] = STATE(1877),
    [sym_keyword_char] = STATE(2283),
    [sym_keyword_varchar] = STATE(2287),
    [sym__type] = STATE(14268),
    [sym_tinyint] = STATE(7120),
    [sym_smallint] = STATE(7120),
    [sym_mediumint] = STATE(7120),
    [sym_int] = STATE(7120),
    [sym_bigint] = STATE(7120),
    [sym_bit] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym_varbinary] = STATE(7120),
    [sym_float] = STATE(7120),
    [sym_double] = STATE(7120),
    [sym_decimal] = STATE(7120),
    [sym_numeric] = STATE(7120),
    [sym_char] = STATE(7120),
    [sym_varchar] = STATE(7120),
    [sym_nchar] = STATE(7120),
    [sym_nvarchar] = STATE(7120),
    [sym_datetimeoffset] = STATE(7120),
    [sym_time] = STATE(7120),
    [sym_timestamp] = STATE(7120),
    [sym_enum] = STATE(7120),
    [sym_object_reference] = STATE(7127),
    [sym_identifier] = STATE(6414),
    [sym__identifier] = ACTIONS(51),
    [aux_sym_keyword_character_token1] = ACTIONS(53),
    [sym_keyword_unsigned] = ACTIONS(57),
    [sym_keyword_boolean] = ACTIONS(59),
    [sym_keyword_bit] = ACTIONS(61),
    [sym_keyword_binary] = ACTIONS(63),
    [sym_keyword_varbinary] = ACTIONS(65),
    [sym_keyword_image] = ACTIONS(59),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(67),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(67),
    [aux_sym_keyword_serial_token1] = ACTIONS(69),
    [aux_sym_keyword_serial_token2] = ACTIONS(69),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(71),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(71),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(73),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(73),
    [aux_sym_keyword_smallint_token1] = ACTIONS(75),
    [aux_sym_keyword_smallint_token2] = ACTIONS(75),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(77),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(77),
    [aux_sym_keyword_int_token1] = ACTIONS(79),
    [aux_sym_keyword_int_token2] = ACTIONS(79),
    [aux_sym_keyword_int_token3] = ACTIONS(79),
    [aux_sym_keyword_bigint_token1] = ACTIONS(81),
    [aux_sym_keyword_bigint_token2] = ACTIONS(81),
    [sym_keyword_decimal] = ACTIONS(83),
    [sym_keyword_numeric] = ACTIONS(85),
    [aux_sym_keyword_real_token1] = ACTIONS(87),
    [aux_sym_keyword_real_token2] = ACTIONS(87),
    [sym_keyword_float] = ACTIONS(89),
    [sym_keyword_double] = ACTIONS(91),
    [sym_keyword_inet] = ACTIONS(59),
    [sym_keyword_money] = ACTIONS(59),
    [sym_keyword_smallmoney] = ACTIONS(59),
    [aux_sym_keyword_char_token1] = ACTIONS(93),
    [sym_keyword_nchar] = ACTIONS(95),
    [aux_sym_keyword_varchar_token1] = ACTIONS(97),
    [sym_keyword_nvarchar] = ACTIONS(99),
    [sym_keyword_text] = ACTIONS(59),
    [sym_keyword_string] = ACTIONS(59),
    [sym_keyword_uuid] = ACTIONS(59),
    [sym_keyword_json] = ACTIONS(59),
    [sym_keyword_jsonb] = ACTIONS(59),
    [sym_keyword_xml] = ACTIONS(59),
    [sym_keyword_bytea] = ACTIONS(59),
    [sym_keyword_enum] = ACTIONS(101),
    [sym_keyword_date] = ACTIONS(59),
    [sym_keyword_datetime] = ACTIONS(59),
    [sym_keyword_datetime2] = ACTIONS(59),
    [sym_keyword_smalldatetime] = ACTIONS(59),
    [sym_keyword_datetimeoffset] = ACTIONS(103),
    [sym_keyword_time] = ACTIONS(105),
    [sym_keyword_timestamp] = ACTIONS(107),
    [sym_keyword_timestamptz] = ACTIONS(59),
    [sym_keyword_interval] = ACTIONS(59),
    [sym_keyword_geometry] = ACTIONS(59),
    [sym_keyword_geography] = ACTIONS(59),
    [sym_keyword_box2d] = ACTIONS(59),
    [sym_keyword_box3d] = ACTIONS(59),
    [sym_keyword_oid] = ACTIONS(59),
    [sym_keyword_name] = ACTIONS(59),
    [sym_keyword_regclass] = ACTIONS(59),
    [sym_keyword_regnamespace] = ACTIONS(59),
    [sym_keyword_regproc] = ACTIONS(59),
    [sym_keyword_regtype] = ACTIONS(59),
    [aux_sym_double_token1] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(115),
    [aux_sym_identifier_token1] = ACTIONS(115),
  },
  [82] = {
    [sym_keyword_smallserial] = STATE(2728),
    [sym_keyword_serial] = STATE(2728),
    [sym_keyword_bigserial] = STATE(2728),
    [sym_keyword_tinyint] = STATE(2719),
    [sym_keyword_smallint] = STATE(2718),
    [sym_keyword_mediumint] = STATE(2716),
    [sym_keyword_int] = STATE(2713),
    [sym_keyword_bigint] = STATE(2709),
    [sym_keyword_real] = STATE(2708),
    [sym_keyword_char] = STATE(3208),
    [sym_keyword_varchar] = STATE(3207),
    [sym__type] = STATE(4221),
    [sym_tinyint] = STATE(2728),
    [sym_smallint] = STATE(2728),
    [sym_mediumint] = STATE(2728),
    [sym_int] = STATE(2728),
    [sym_bigint] = STATE(2728),
    [sym_bit] = STATE(2728),
    [sym_binary] = STATE(2728),
    [sym_varbinary] = STATE(2728),
    [sym_float] = STATE(2728),
    [sym_double] = STATE(2728),
    [sym_decimal] = STATE(2728),
    [sym_numeric] = STATE(2728),
    [sym_char] = STATE(2728),
    [sym_varchar] = STATE(2728),
    [sym_nchar] = STATE(2728),
    [sym_nvarchar] = STATE(2728),
    [sym_datetimeoffset] = STATE(2728),
    [sym_time] = STATE(2728),
    [sym_timestamp] = STATE(2728),
    [sym_enum] = STATE(2728),
    [sym_object_reference] = STATE(2765),
    [sym_identifier] = STATE(3144),
    [sym__identifier] = ACTIONS(1291),
    [aux_sym_keyword_character_token1] = ACTIONS(1293),
    [sym_keyword_unsigned] = ACTIONS(1295),
    [sym_keyword_boolean] = ACTIONS(1297),
    [sym_keyword_bit] = ACTIONS(1299),
    [sym_keyword_binary] = ACTIONS(1301),
    [sym_keyword_varbinary] = ACTIONS(1303),
    [sym_keyword_image] = ACTIONS(1297),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1305),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1305),
    [aux_sym_keyword_serial_token1] = ACTIONS(1307),
    [aux_sym_keyword_serial_token2] = ACTIONS(1307),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1309),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1309),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1311),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1311),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1313),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1313),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1315),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1315),
    [aux_sym_keyword_int_token1] = ACTIONS(1317),
    [aux_sym_keyword_int_token2] = ACTIONS(1317),
    [aux_sym_keyword_int_token3] = ACTIONS(1317),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1319),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1319),
    [sym_keyword_decimal] = ACTIONS(1321),
    [sym_keyword_numeric] = ACTIONS(1323),
    [aux_sym_keyword_real_token1] = ACTIONS(1325),
    [aux_sym_keyword_real_token2] = ACTIONS(1325),
    [sym_keyword_float] = ACTIONS(1327),
    [sym_keyword_double] = ACTIONS(1329),
    [sym_keyword_inet] = ACTIONS(1297),
    [sym_keyword_money] = ACTIONS(1297),
    [sym_keyword_smallmoney] = ACTIONS(1297),
    [aux_sym_keyword_char_token1] = ACTIONS(1331),
    [sym_keyword_nchar] = ACTIONS(1333),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1335),
    [sym_keyword_nvarchar] = ACTIONS(1337),
    [sym_keyword_text] = ACTIONS(1297),
    [sym_keyword_string] = ACTIONS(1297),
    [sym_keyword_uuid] = ACTIONS(1297),
    [sym_keyword_json] = ACTIONS(1297),
    [sym_keyword_jsonb] = ACTIONS(1297),
    [sym_keyword_xml] = ACTIONS(1297),
    [sym_keyword_bytea] = ACTIONS(1297),
    [sym_keyword_enum] = ACTIONS(1339),
    [sym_keyword_date] = ACTIONS(1297),
    [sym_keyword_datetime] = ACTIONS(1297),
    [sym_keyword_datetime2] = ACTIONS(1297),
    [sym_keyword_smalldatetime] = ACTIONS(1297),
    [sym_keyword_datetimeoffset] = ACTIONS(1341),
    [sym_keyword_time] = ACTIONS(1343),
    [sym_keyword_timestamp] = ACTIONS(1345),
    [sym_keyword_timestamptz] = ACTIONS(1297),
    [sym_keyword_interval] = ACTIONS(1297),
    [sym_keyword_geometry] = ACTIONS(1297),
    [sym_keyword_geography] = ACTIONS(1297),
    [sym_keyword_box2d] = ACTIONS(1297),
    [sym_keyword_box3d] = ACTIONS(1297),
    [sym_keyword_oid] = ACTIONS(1297),
    [sym_keyword_name] = ACTIONS(1297),
    [sym_keyword_regclass] = ACTIONS(1297),
    [sym_keyword_regnamespace] = ACTIONS(1297),
    [sym_keyword_regproc] = ACTIONS(1297),
    [sym_keyword_regtype] = ACTIONS(1297),
    [aux_sym_double_token1] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1349),
    [aux_sym_identifier_token1] = ACTIONS(1349),
  },
  [83] = {
    [sym_keyword_smallserial] = STATE(6912),
    [sym_keyword_serial] = STATE(6912),
    [sym_keyword_bigserial] = STATE(6912),
    [sym_keyword_tinyint] = STATE(6916),
    [sym_keyword_smallint] = STATE(6915),
    [sym_keyword_mediumint] = STATE(6914),
    [sym_keyword_int] = STATE(6906),
    [sym_keyword_bigint] = STATE(6904),
    [sym_keyword_real] = STATE(6922),
    [sym_keyword_char] = STATE(7038),
    [sym_keyword_varchar] = STATE(7037),
    [sym__type] = STATE(7492),
    [sym_tinyint] = STATE(6912),
    [sym_smallint] = STATE(6912),
    [sym_mediumint] = STATE(6912),
    [sym_int] = STATE(6912),
    [sym_bigint] = STATE(6912),
    [sym_bit] = STATE(6912),
    [sym_binary] = STATE(6912),
    [sym_varbinary] = STATE(6912),
    [sym_float] = STATE(6912),
    [sym_double] = STATE(6912),
    [sym_decimal] = STATE(6912),
    [sym_numeric] = STATE(6912),
    [sym_char] = STATE(6912),
    [sym_varchar] = STATE(6912),
    [sym_nchar] = STATE(6912),
    [sym_nvarchar] = STATE(6912),
    [sym_datetimeoffset] = STATE(6912),
    [sym_time] = STATE(6912),
    [sym_timestamp] = STATE(6912),
    [sym_enum] = STATE(6912),
    [sym_object_reference] = STATE(6946),
    [sym_identifier] = STATE(3575),
    [sym__identifier] = ACTIONS(1227),
    [aux_sym_keyword_character_token1] = ACTIONS(1229),
    [sym_keyword_unsigned] = ACTIONS(1231),
    [sym_keyword_boolean] = ACTIONS(1233),
    [sym_keyword_bit] = ACTIONS(1235),
    [sym_keyword_binary] = ACTIONS(1237),
    [sym_keyword_varbinary] = ACTIONS(1239),
    [sym_keyword_image] = ACTIONS(1233),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1241),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1241),
    [aux_sym_keyword_serial_token1] = ACTIONS(1243),
    [aux_sym_keyword_serial_token2] = ACTIONS(1243),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1245),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1245),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1247),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1247),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1249),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1249),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1251),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1251),
    [aux_sym_keyword_int_token1] = ACTIONS(1253),
    [aux_sym_keyword_int_token2] = ACTIONS(1253),
    [aux_sym_keyword_int_token3] = ACTIONS(1253),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1255),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1255),
    [sym_keyword_decimal] = ACTIONS(1257),
    [sym_keyword_numeric] = ACTIONS(1259),
    [aux_sym_keyword_real_token1] = ACTIONS(1261),
    [aux_sym_keyword_real_token2] = ACTIONS(1261),
    [sym_keyword_float] = ACTIONS(1263),
    [sym_keyword_double] = ACTIONS(1265),
    [sym_keyword_inet] = ACTIONS(1233),
    [sym_keyword_money] = ACTIONS(1233),
    [sym_keyword_smallmoney] = ACTIONS(1233),
    [aux_sym_keyword_char_token1] = ACTIONS(1267),
    [sym_keyword_nchar] = ACTIONS(1269),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1271),
    [sym_keyword_nvarchar] = ACTIONS(1273),
    [sym_keyword_text] = ACTIONS(1233),
    [sym_keyword_string] = ACTIONS(1233),
    [sym_keyword_uuid] = ACTIONS(1233),
    [sym_keyword_json] = ACTIONS(1233),
    [sym_keyword_jsonb] = ACTIONS(1233),
    [sym_keyword_xml] = ACTIONS(1233),
    [sym_keyword_bytea] = ACTIONS(1233),
    [sym_keyword_enum] = ACTIONS(1275),
    [sym_keyword_date] = ACTIONS(1233),
    [sym_keyword_datetime] = ACTIONS(1233),
    [sym_keyword_datetime2] = ACTIONS(1233),
    [sym_keyword_smalldatetime] = ACTIONS(1233),
    [sym_keyword_datetimeoffset] = ACTIONS(1277),
    [sym_keyword_time] = ACTIONS(1279),
    [sym_keyword_timestamp] = ACTIONS(1281),
    [sym_keyword_timestamptz] = ACTIONS(1233),
    [sym_keyword_interval] = ACTIONS(1233),
    [sym_keyword_geometry] = ACTIONS(1233),
    [sym_keyword_geography] = ACTIONS(1233),
    [sym_keyword_box2d] = ACTIONS(1233),
    [sym_keyword_box3d] = ACTIONS(1233),
    [sym_keyword_oid] = ACTIONS(1233),
    [sym_keyword_name] = ACTIONS(1233),
    [sym_keyword_regclass] = ACTIONS(1233),
    [sym_keyword_regnamespace] = ACTIONS(1233),
    [sym_keyword_regproc] = ACTIONS(1233),
    [sym_keyword_regtype] = ACTIONS(1233),
    [aux_sym_double_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1285),
    [aux_sym_identifier_token1] = ACTIONS(1285),
  },
  [84] = {
    [aux_sym__single_quote_string_repeat1] = STATE(85),
    [ts_builtin_sym_end] = ACTIONS(1351),
    [sym__identifier] = ACTIONS(1353),
    [anon_sym_SEMI] = ACTIONS(1351),
    [sym_keyword_create] = ACTIONS(1353),
    [sym_keyword_increment] = ACTIONS(1353),
    [sym_keyword_minvalue] = ACTIONS(1353),
    [sym_keyword_maxvalue] = ACTIONS(1353),
    [sym_keyword_owned] = ACTIONS(1353),
    [sym_keyword_start] = ACTIONS(1353),
    [sym_keyword_restart] = ACTIONS(1353),
    [sym_keyword_as] = ACTIONS(1353),
    [sym_keyword_not] = ACTIONS(1353),
    [aux_sym_keyword_character_token1] = ACTIONS(1353),
    [sym_keyword_no] = ACTIONS(1353),
    [sym_keyword_cycle] = ACTIONS(1353),
    [sym_keyword_begin] = ACTIONS(1353),
    [sym_keyword_rows] = ACTIONS(1353),
    [sym_keyword_unsigned] = ACTIONS(1353),
    [sym_keyword_returns] = ACTIONS(1353),
    [sym_keyword_return] = ACTIONS(1353),
    [sym_keyword_language] = ACTIONS(1353),
    [sym_keyword_immutable] = ACTIONS(1353),
    [sym_keyword_stable] = ACTIONS(1353),
    [sym_keyword_volatile] = ACTIONS(1353),
    [sym_keyword_leakproof] = ACTIONS(1353),
    [sym_keyword_parallel] = ACTIONS(1353),
    [sym_keyword_called] = ACTIONS(1353),
    [sym_keyword_strict] = ACTIONS(1353),
    [sym_keyword_cost] = ACTIONS(1353),
    [sym_keyword_support] = ACTIONS(1353),
    [sym_keyword_security] = ACTIONS(1353),
    [sym_keyword_external] = ACTIONS(1353),
    [sym_keyword_cache] = ACTIONS(1353),
    [sym_keyword_boolean] = ACTIONS(1353),
    [sym_keyword_bit] = ACTIONS(1353),
    [sym_keyword_binary] = ACTIONS(1353),
    [sym_keyword_varbinary] = ACTIONS(1353),
    [sym_keyword_image] = ACTIONS(1353),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1353),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1353),
    [aux_sym_keyword_serial_token1] = ACTIONS(1353),
    [aux_sym_keyword_serial_token2] = ACTIONS(1353),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1353),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1353),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1353),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1353),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1353),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1353),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1353),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1353),
    [aux_sym_keyword_int_token1] = ACTIONS(1353),
    [aux_sym_keyword_int_token2] = ACTIONS(1353),
    [aux_sym_keyword_int_token3] = ACTIONS(1353),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1353),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1353),
    [sym_keyword_decimal] = ACTIONS(1353),
    [sym_keyword_numeric] = ACTIONS(1353),
    [aux_sym_keyword_real_token1] = ACTIONS(1353),
    [aux_sym_keyword_real_token2] = ACTIONS(1353),
    [sym_keyword_float] = ACTIONS(1353),
    [sym_keyword_double] = ACTIONS(1353),
    [sym_keyword_inet] = ACTIONS(1353),
    [sym_keyword_money] = ACTIONS(1353),
    [sym_keyword_smallmoney] = ACTIONS(1353),
    [aux_sym_keyword_char_token1] = ACTIONS(1353),
    [sym_keyword_nchar] = ACTIONS(1353),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1353),
    [sym_keyword_nvarchar] = ACTIONS(1353),
    [sym_keyword_text] = ACTIONS(1353),
    [sym_keyword_string] = ACTIONS(1353),
    [sym_keyword_uuid] = ACTIONS(1353),
    [sym_keyword_json] = ACTIONS(1353),
    [sym_keyword_jsonb] = ACTIONS(1353),
    [sym_keyword_xml] = ACTIONS(1353),
    [sym_keyword_bytea] = ACTIONS(1353),
    [sym_keyword_enum] = ACTIONS(1353),
    [sym_keyword_date] = ACTIONS(1353),
    [sym_keyword_datetime] = ACTIONS(1353),
    [sym_keyword_datetime2] = ACTIONS(1353),
    [sym_keyword_smalldatetime] = ACTIONS(1353),
    [sym_keyword_datetimeoffset] = ACTIONS(1353),
    [sym_keyword_time] = ACTIONS(1353),
    [sym_keyword_timestamp] = ACTIONS(1353),
    [sym_keyword_timestamptz] = ACTIONS(1353),
    [sym_keyword_interval] = ACTIONS(1353),
    [sym_keyword_geometry] = ACTIONS(1353),
    [sym_keyword_geography] = ACTIONS(1353),
    [sym_keyword_box2d] = ACTIONS(1353),
    [sym_keyword_box3d] = ACTIONS(1353),
    [sym_keyword_oid] = ACTIONS(1353),
    [sym_keyword_name] = ACTIONS(1353),
    [sym_keyword_regclass] = ACTIONS(1353),
    [sym_keyword_regnamespace] = ACTIONS(1353),
    [sym_keyword_regproc] = ACTIONS(1353),
    [sym_keyword_regtype] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [aux_sym_double_token1] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1351),
    [aux_sym__single_quote_string_token2] = ACTIONS(1355),
    [aux_sym_identifier_token1] = ACTIONS(1351),
  },
  [85] = {
    [aux_sym__single_quote_string_repeat1] = STATE(86),
    [ts_builtin_sym_end] = ACTIONS(1357),
    [sym__identifier] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1357),
    [sym_keyword_create] = ACTIONS(1359),
    [sym_keyword_increment] = ACTIONS(1359),
    [sym_keyword_minvalue] = ACTIONS(1359),
    [sym_keyword_maxvalue] = ACTIONS(1359),
    [sym_keyword_owned] = ACTIONS(1359),
    [sym_keyword_start] = ACTIONS(1359),
    [sym_keyword_restart] = ACTIONS(1359),
    [sym_keyword_as] = ACTIONS(1359),
    [sym_keyword_not] = ACTIONS(1359),
    [aux_sym_keyword_character_token1] = ACTIONS(1359),
    [sym_keyword_no] = ACTIONS(1359),
    [sym_keyword_cycle] = ACTIONS(1359),
    [sym_keyword_begin] = ACTIONS(1359),
    [sym_keyword_rows] = ACTIONS(1359),
    [sym_keyword_unsigned] = ACTIONS(1359),
    [sym_keyword_returns] = ACTIONS(1359),
    [sym_keyword_return] = ACTIONS(1359),
    [sym_keyword_language] = ACTIONS(1359),
    [sym_keyword_immutable] = ACTIONS(1359),
    [sym_keyword_stable] = ACTIONS(1359),
    [sym_keyword_volatile] = ACTIONS(1359),
    [sym_keyword_leakproof] = ACTIONS(1359),
    [sym_keyword_parallel] = ACTIONS(1359),
    [sym_keyword_called] = ACTIONS(1359),
    [sym_keyword_strict] = ACTIONS(1359),
    [sym_keyword_cost] = ACTIONS(1359),
    [sym_keyword_support] = ACTIONS(1359),
    [sym_keyword_security] = ACTIONS(1359),
    [sym_keyword_external] = ACTIONS(1359),
    [sym_keyword_cache] = ACTIONS(1359),
    [sym_keyword_boolean] = ACTIONS(1359),
    [sym_keyword_bit] = ACTIONS(1359),
    [sym_keyword_binary] = ACTIONS(1359),
    [sym_keyword_varbinary] = ACTIONS(1359),
    [sym_keyword_image] = ACTIONS(1359),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1359),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1359),
    [aux_sym_keyword_serial_token1] = ACTIONS(1359),
    [aux_sym_keyword_serial_token2] = ACTIONS(1359),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1359),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1359),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1359),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1359),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1359),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1359),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1359),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1359),
    [aux_sym_keyword_int_token1] = ACTIONS(1359),
    [aux_sym_keyword_int_token2] = ACTIONS(1359),
    [aux_sym_keyword_int_token3] = ACTIONS(1359),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1359),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1359),
    [sym_keyword_decimal] = ACTIONS(1359),
    [sym_keyword_numeric] = ACTIONS(1359),
    [aux_sym_keyword_real_token1] = ACTIONS(1359),
    [aux_sym_keyword_real_token2] = ACTIONS(1359),
    [sym_keyword_float] = ACTIONS(1359),
    [sym_keyword_double] = ACTIONS(1359),
    [sym_keyword_inet] = ACTIONS(1359),
    [sym_keyword_money] = ACTIONS(1359),
    [sym_keyword_smallmoney] = ACTIONS(1359),
    [aux_sym_keyword_char_token1] = ACTIONS(1359),
    [sym_keyword_nchar] = ACTIONS(1359),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1359),
    [sym_keyword_nvarchar] = ACTIONS(1359),
    [sym_keyword_text] = ACTIONS(1359),
    [sym_keyword_string] = ACTIONS(1359),
    [sym_keyword_uuid] = ACTIONS(1359),
    [sym_keyword_json] = ACTIONS(1359),
    [sym_keyword_jsonb] = ACTIONS(1359),
    [sym_keyword_xml] = ACTIONS(1359),
    [sym_keyword_bytea] = ACTIONS(1359),
    [sym_keyword_enum] = ACTIONS(1359),
    [sym_keyword_date] = ACTIONS(1359),
    [sym_keyword_datetime] = ACTIONS(1359),
    [sym_keyword_datetime2] = ACTIONS(1359),
    [sym_keyword_smalldatetime] = ACTIONS(1359),
    [sym_keyword_datetimeoffset] = ACTIONS(1359),
    [sym_keyword_time] = ACTIONS(1359),
    [sym_keyword_timestamp] = ACTIONS(1359),
    [sym_keyword_timestamptz] = ACTIONS(1359),
    [sym_keyword_interval] = ACTIONS(1359),
    [sym_keyword_geometry] = ACTIONS(1359),
    [sym_keyword_geography] = ACTIONS(1359),
    [sym_keyword_box2d] = ACTIONS(1359),
    [sym_keyword_box3d] = ACTIONS(1359),
    [sym_keyword_oid] = ACTIONS(1359),
    [sym_keyword_name] = ACTIONS(1359),
    [sym_keyword_regclass] = ACTIONS(1359),
    [sym_keyword_regnamespace] = ACTIONS(1359),
    [sym_keyword_regproc] = ACTIONS(1359),
    [sym_keyword_regtype] = ACTIONS(1359),
    [anon_sym_RPAREN] = ACTIONS(1357),
    [aux_sym_double_token1] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1357),
    [aux_sym__single_quote_string_token2] = ACTIONS(1361),
    [aux_sym_identifier_token1] = ACTIONS(1357),
  },
  [86] = {
    [aux_sym__single_quote_string_repeat1] = STATE(86),
    [ts_builtin_sym_end] = ACTIONS(1363),
    [sym__identifier] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1363),
    [sym_keyword_create] = ACTIONS(1365),
    [sym_keyword_increment] = ACTIONS(1365),
    [sym_keyword_minvalue] = ACTIONS(1365),
    [sym_keyword_maxvalue] = ACTIONS(1365),
    [sym_keyword_owned] = ACTIONS(1365),
    [sym_keyword_start] = ACTIONS(1365),
    [sym_keyword_restart] = ACTIONS(1365),
    [sym_keyword_as] = ACTIONS(1365),
    [sym_keyword_not] = ACTIONS(1365),
    [aux_sym_keyword_character_token1] = ACTIONS(1365),
    [sym_keyword_no] = ACTIONS(1365),
    [sym_keyword_cycle] = ACTIONS(1365),
    [sym_keyword_begin] = ACTIONS(1365),
    [sym_keyword_rows] = ACTIONS(1365),
    [sym_keyword_unsigned] = ACTIONS(1365),
    [sym_keyword_returns] = ACTIONS(1365),
    [sym_keyword_return] = ACTIONS(1365),
    [sym_keyword_language] = ACTIONS(1365),
    [sym_keyword_immutable] = ACTIONS(1365),
    [sym_keyword_stable] = ACTIONS(1365),
    [sym_keyword_volatile] = ACTIONS(1365),
    [sym_keyword_leakproof] = ACTIONS(1365),
    [sym_keyword_parallel] = ACTIONS(1365),
    [sym_keyword_called] = ACTIONS(1365),
    [sym_keyword_strict] = ACTIONS(1365),
    [sym_keyword_cost] = ACTIONS(1365),
    [sym_keyword_support] = ACTIONS(1365),
    [sym_keyword_security] = ACTIONS(1365),
    [sym_keyword_external] = ACTIONS(1365),
    [sym_keyword_cache] = ACTIONS(1365),
    [sym_keyword_boolean] = ACTIONS(1365),
    [sym_keyword_bit] = ACTIONS(1365),
    [sym_keyword_binary] = ACTIONS(1365),
    [sym_keyword_varbinary] = ACTIONS(1365),
    [sym_keyword_image] = ACTIONS(1365),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1365),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1365),
    [aux_sym_keyword_serial_token1] = ACTIONS(1365),
    [aux_sym_keyword_serial_token2] = ACTIONS(1365),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1365),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1365),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1365),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1365),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1365),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1365),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1365),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1365),
    [aux_sym_keyword_int_token1] = ACTIONS(1365),
    [aux_sym_keyword_int_token2] = ACTIONS(1365),
    [aux_sym_keyword_int_token3] = ACTIONS(1365),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1365),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1365),
    [sym_keyword_decimal] = ACTIONS(1365),
    [sym_keyword_numeric] = ACTIONS(1365),
    [aux_sym_keyword_real_token1] = ACTIONS(1365),
    [aux_sym_keyword_real_token2] = ACTIONS(1365),
    [sym_keyword_float] = ACTIONS(1365),
    [sym_keyword_double] = ACTIONS(1365),
    [sym_keyword_inet] = ACTIONS(1365),
    [sym_keyword_money] = ACTIONS(1365),
    [sym_keyword_smallmoney] = ACTIONS(1365),
    [aux_sym_keyword_char_token1] = ACTIONS(1365),
    [sym_keyword_nchar] = ACTIONS(1365),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1365),
    [sym_keyword_nvarchar] = ACTIONS(1365),
    [sym_keyword_text] = ACTIONS(1365),
    [sym_keyword_string] = ACTIONS(1365),
    [sym_keyword_uuid] = ACTIONS(1365),
    [sym_keyword_json] = ACTIONS(1365),
    [sym_keyword_jsonb] = ACTIONS(1365),
    [sym_keyword_xml] = ACTIONS(1365),
    [sym_keyword_bytea] = ACTIONS(1365),
    [sym_keyword_enum] = ACTIONS(1365),
    [sym_keyword_date] = ACTIONS(1365),
    [sym_keyword_datetime] = ACTIONS(1365),
    [sym_keyword_datetime2] = ACTIONS(1365),
    [sym_keyword_smalldatetime] = ACTIONS(1365),
    [sym_keyword_datetimeoffset] = ACTIONS(1365),
    [sym_keyword_time] = ACTIONS(1365),
    [sym_keyword_timestamp] = ACTIONS(1365),
    [sym_keyword_timestamptz] = ACTIONS(1365),
    [sym_keyword_interval] = ACTIONS(1365),
    [sym_keyword_geometry] = ACTIONS(1365),
    [sym_keyword_geography] = ACTIONS(1365),
    [sym_keyword_box2d] = ACTIONS(1365),
    [sym_keyword_box3d] = ACTIONS(1365),
    [sym_keyword_oid] = ACTIONS(1365),
    [sym_keyword_name] = ACTIONS(1365),
    [sym_keyword_regclass] = ACTIONS(1365),
    [sym_keyword_regnamespace] = ACTIONS(1365),
    [sym_keyword_regproc] = ACTIONS(1365),
    [sym_keyword_regtype] = ACTIONS(1365),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [aux_sym_double_token1] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1363),
    [aux_sym__single_quote_string_token2] = ACTIONS(1367),
    [aux_sym_identifier_token1] = ACTIONS(1363),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym__identifier] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [sym_keyword_create] = ACTIONS(1372),
    [sym_keyword_increment] = ACTIONS(1372),
    [sym_keyword_minvalue] = ACTIONS(1372),
    [sym_keyword_maxvalue] = ACTIONS(1372),
    [sym_keyword_owned] = ACTIONS(1372),
    [sym_keyword_start] = ACTIONS(1372),
    [sym_keyword_restart] = ACTIONS(1372),
    [sym_keyword_as] = ACTIONS(1372),
    [sym_keyword_not] = ACTIONS(1372),
    [aux_sym_keyword_character_token1] = ACTIONS(1372),
    [sym_keyword_no] = ACTIONS(1372),
    [sym_keyword_cycle] = ACTIONS(1372),
    [sym_keyword_begin] = ACTIONS(1372),
    [sym_keyword_rows] = ACTIONS(1372),
    [sym_keyword_unsigned] = ACTIONS(1372),
    [sym_keyword_returns] = ACTIONS(1372),
    [sym_keyword_return] = ACTIONS(1372),
    [sym_keyword_language] = ACTIONS(1372),
    [sym_keyword_immutable] = ACTIONS(1372),
    [sym_keyword_stable] = ACTIONS(1372),
    [sym_keyword_volatile] = ACTIONS(1372),
    [sym_keyword_leakproof] = ACTIONS(1372),
    [sym_keyword_parallel] = ACTIONS(1372),
    [sym_keyword_called] = ACTIONS(1372),
    [sym_keyword_strict] = ACTIONS(1372),
    [sym_keyword_cost] = ACTIONS(1372),
    [sym_keyword_support] = ACTIONS(1372),
    [sym_keyword_security] = ACTIONS(1372),
    [sym_keyword_external] = ACTIONS(1372),
    [sym_keyword_cache] = ACTIONS(1372),
    [sym_keyword_boolean] = ACTIONS(1372),
    [sym_keyword_bit] = ACTIONS(1372),
    [sym_keyword_binary] = ACTIONS(1372),
    [sym_keyword_varbinary] = ACTIONS(1372),
    [sym_keyword_image] = ACTIONS(1372),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1372),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1372),
    [aux_sym_keyword_serial_token1] = ACTIONS(1372),
    [aux_sym_keyword_serial_token2] = ACTIONS(1372),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1372),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1372),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1372),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1372),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1372),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1372),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1372),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1372),
    [aux_sym_keyword_int_token1] = ACTIONS(1372),
    [aux_sym_keyword_int_token2] = ACTIONS(1372),
    [aux_sym_keyword_int_token3] = ACTIONS(1372),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1372),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1372),
    [sym_keyword_decimal] = ACTIONS(1372),
    [sym_keyword_numeric] = ACTIONS(1372),
    [aux_sym_keyword_real_token1] = ACTIONS(1372),
    [aux_sym_keyword_real_token2] = ACTIONS(1372),
    [sym_keyword_float] = ACTIONS(1372),
    [sym_keyword_double] = ACTIONS(1372),
    [sym_keyword_inet] = ACTIONS(1372),
    [sym_keyword_money] = ACTIONS(1372),
    [sym_keyword_smallmoney] = ACTIONS(1372),
    [aux_sym_keyword_char_token1] = ACTIONS(1372),
    [sym_keyword_nchar] = ACTIONS(1372),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1372),
    [sym_keyword_nvarchar] = ACTIONS(1372),
    [sym_keyword_text] = ACTIONS(1372),
    [sym_keyword_string] = ACTIONS(1372),
    [sym_keyword_uuid] = ACTIONS(1372),
    [sym_keyword_json] = ACTIONS(1372),
    [sym_keyword_jsonb] = ACTIONS(1372),
    [sym_keyword_xml] = ACTIONS(1372),
    [sym_keyword_bytea] = ACTIONS(1372),
    [sym_keyword_enum] = ACTIONS(1372),
    [sym_keyword_date] = ACTIONS(1372),
    [sym_keyword_datetime] = ACTIONS(1372),
    [sym_keyword_datetime2] = ACTIONS(1372),
    [sym_keyword_smalldatetime] = ACTIONS(1372),
    [sym_keyword_datetimeoffset] = ACTIONS(1372),
    [sym_keyword_time] = ACTIONS(1372),
    [sym_keyword_timestamp] = ACTIONS(1372),
    [sym_keyword_timestamptz] = ACTIONS(1372),
    [sym_keyword_interval] = ACTIONS(1372),
    [sym_keyword_geometry] = ACTIONS(1372),
    [sym_keyword_geography] = ACTIONS(1372),
    [sym_keyword_box2d] = ACTIONS(1372),
    [sym_keyword_box3d] = ACTIONS(1372),
    [sym_keyword_oid] = ACTIONS(1372),
    [sym_keyword_name] = ACTIONS(1372),
    [sym_keyword_regclass] = ACTIONS(1372),
    [sym_keyword_regnamespace] = ACTIONS(1372),
    [sym_keyword_regproc] = ACTIONS(1372),
    [sym_keyword_regtype] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1370),
    [aux_sym_double_token1] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1370),
    [aux_sym_identifier_token1] = ACTIONS(1370),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym__identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_keyword_select] = ACTIONS(1376),
    [sym_keyword_values] = ACTIONS(1376),
    [sym_keyword_set] = ACTIONS(1376),
    [sym_keyword_from] = ACTIONS(1376),
    [sym_keyword_on] = ACTIONS(1376),
    [sym_keyword_partition] = ACTIONS(1376),
    [sym_keyword_primary] = ACTIONS(1376),
    [sym_keyword_create] = ACTIONS(1376),
    [sym_keyword_alter] = ACTIONS(1376),
    [sym_keyword_drop] = ACTIONS(1376),
    [sym_keyword_add] = ACTIONS(1376),
    [sym_keyword_as] = ACTIONS(1376),
    [sym_keyword_constraint] = ACTIONS(1376),
    [sym_keyword_when] = ACTIONS(1376),
    [sym_keyword_in] = ACTIONS(1376),
    [sym_keyword_and] = ACTIONS(1376),
    [sym_keyword_or] = ACTIONS(1376),
    [sym_keyword_is] = ACTIONS(1376),
    [sym_keyword_not] = ACTIONS(1376),
    [sym_keyword_force] = ACTIONS(1376),
    [sym_keyword_using] = ACTIONS(1376),
    [sym_keyword_collate] = ACTIONS(1376),
    [sym_keyword_default] = ACTIONS(1376),
    [sym_keyword_cascade] = ACTIONS(1376),
    [sym_keyword_restrict] = ACTIONS(1376),
    [sym_keyword_with] = ACTIONS(1376),
    [sym_keyword_type] = ACTIONS(1376),
    [sym_keyword_rename] = ACTIONS(1376),
    [sym_keyword_to] = ACTIONS(1376),
    [sym_keyword_schema] = ACTIONS(1376),
    [sym_keyword_owner] = ACTIONS(1376),
    [sym_keyword_reset] = ACTIONS(1376),
    [sym_keyword_temp] = ACTIONS(1376),
    [sym_keyword_temporary] = ACTIONS(1376),
    [sym_keyword_union] = ACTIONS(1376),
    [sym_keyword_except] = ACTIONS(1376),
    [sym_keyword_intersect] = ACTIONS(1376),
    [sym_keyword_returning] = ACTIONS(1376),
    [sym_keyword_rows] = ACTIONS(1376),
    [sym_keyword_between] = ACTIONS(1376),
    [aux_sym_keyword_like_token1] = ACTIONS(1376),
    [aux_sym_keyword_like_token2] = ACTIONS(1376),
    [sym_keyword_similar] = ACTIONS(1376),
    [sym_keyword_check] = ACTIONS(1376),
    [sym_keyword_wait] = ACTIONS(1376),
    [sym_keyword_nowait] = ACTIONS(1376),
    [sym_keyword_authorization] = ACTIONS(1376),
    [sym_keyword_trigger] = ACTIONS(1376),
    [sym_keyword_returns] = ACTIONS(1376),
    [sym_keyword_language] = ACTIONS(1376),
    [sym_keyword_immutable] = ACTIONS(1376),
    [sym_keyword_stable] = ACTIONS(1376),
    [sym_keyword_volatile] = ACTIONS(1376),
    [sym_keyword_leakproof] = ACTIONS(1376),
    [sym_keyword_parallel] = ACTIONS(1376),
    [sym_keyword_called] = ACTIONS(1376),
    [sym_keyword_strict] = ACTIONS(1376),
    [sym_keyword_cost] = ACTIONS(1376),
    [sym_keyword_support] = ACTIONS(1376),
    [sym_keyword_security] = ACTIONS(1376),
    [sym_keyword_version] = ACTIONS(1376),
    [sym_keyword_immediate] = ACTIONS(1376),
    [sym_keyword_deferred] = ACTIONS(1376),
    [sym_keyword_external] = ACTIONS(1376),
    [sym_keyword_compute] = ACTIONS(1376),
    [sym_keyword_rewrite] = ACTIONS(1376),
    [sym_keyword_partitioned] = ACTIONS(1376),
    [sym_keyword_array] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_COLON_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [sym_op_other] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_LT_GT] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1374),
    [aux_sym__single_quote_string_token1] = ACTIONS(1374),
    [aux_sym_identifier_token1] = ACTIONS(1374),
  },
  [89] = {
    [sym__commit] = STATE(14116),
    [sym__rollback] = STATE(14116),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(91),
    [anon_sym_SEMI] = ACTIONS(1378),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1380),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_transaction] = ACTIONS(1386),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [90] = {
    [sym__identifier] = ACTIONS(1376),
    [sym_keyword_desc] = ACTIONS(1376),
    [sym_keyword_asc] = ACTIONS(1376),
    [sym_keyword_primary] = ACTIONS(1376),
    [sym_keyword_key] = ACTIONS(1376),
    [sym_keyword_constraint] = ACTIONS(1376),
    [sym_keyword_index] = ACTIONS(1376),
    [sym_keyword_collate] = ACTIONS(1376),
    [aux_sym_keyword_character_token1] = ACTIONS(1376),
    [sym_keyword_default] = ACTIONS(1376),
    [sym_keyword_nulls] = ACTIONS(1376),
    [sym_keyword_unique] = ACTIONS(1376),
    [sym_keyword_foreign] = ACTIONS(1376),
    [sym_keyword_unsigned] = ACTIONS(1376),
    [sym_keyword_check] = ACTIONS(1376),
    [sym_keyword_boolean] = ACTIONS(1376),
    [sym_keyword_bit] = ACTIONS(1376),
    [sym_keyword_binary] = ACTIONS(1376),
    [sym_keyword_varbinary] = ACTIONS(1376),
    [sym_keyword_image] = ACTIONS(1376),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1376),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1376),
    [aux_sym_keyword_serial_token1] = ACTIONS(1376),
    [aux_sym_keyword_serial_token2] = ACTIONS(1376),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1376),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1376),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1376),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1376),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1376),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1376),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1376),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1376),
    [aux_sym_keyword_int_token1] = ACTIONS(1376),
    [aux_sym_keyword_int_token2] = ACTIONS(1376),
    [aux_sym_keyword_int_token3] = ACTIONS(1376),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1376),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1376),
    [sym_keyword_decimal] = ACTIONS(1376),
    [sym_keyword_numeric] = ACTIONS(1376),
    [aux_sym_keyword_real_token1] = ACTIONS(1376),
    [aux_sym_keyword_real_token2] = ACTIONS(1376),
    [sym_keyword_float] = ACTIONS(1376),
    [sym_keyword_double] = ACTIONS(1376),
    [sym_keyword_inet] = ACTIONS(1376),
    [sym_keyword_money] = ACTIONS(1376),
    [sym_keyword_smallmoney] = ACTIONS(1376),
    [aux_sym_keyword_char_token1] = ACTIONS(1376),
    [sym_keyword_nchar] = ACTIONS(1376),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1376),
    [sym_keyword_nvarchar] = ACTIONS(1376),
    [sym_keyword_text] = ACTIONS(1376),
    [sym_keyword_string] = ACTIONS(1376),
    [sym_keyword_uuid] = ACTIONS(1376),
    [sym_keyword_json] = ACTIONS(1376),
    [sym_keyword_jsonb] = ACTIONS(1376),
    [sym_keyword_xml] = ACTIONS(1376),
    [sym_keyword_bytea] = ACTIONS(1376),
    [sym_keyword_enum] = ACTIONS(1376),
    [sym_keyword_date] = ACTIONS(1376),
    [sym_keyword_datetime] = ACTIONS(1376),
    [sym_keyword_datetime2] = ACTIONS(1376),
    [sym_keyword_smalldatetime] = ACTIONS(1376),
    [sym_keyword_datetimeoffset] = ACTIONS(1376),
    [sym_keyword_time] = ACTIONS(1376),
    [sym_keyword_timestamp] = ACTIONS(1376),
    [sym_keyword_timestamptz] = ACTIONS(1376),
    [sym_keyword_interval] = ACTIONS(1376),
    [sym_keyword_geometry] = ACTIONS(1376),
    [sym_keyword_geography] = ACTIONS(1376),
    [sym_keyword_box2d] = ACTIONS(1376),
    [sym_keyword_box3d] = ACTIONS(1376),
    [sym_keyword_oid] = ACTIONS(1376),
    [sym_keyword_name] = ACTIONS(1376),
    [sym_keyword_regclass] = ACTIONS(1376),
    [sym_keyword_regnamespace] = ACTIONS(1376),
    [sym_keyword_regproc] = ACTIONS(1376),
    [sym_keyword_regtype] = ACTIONS(1376),
    [sym_keyword_array] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [aux_sym_double_token1] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1374),
    [aux_sym_identifier_token1] = ACTIONS(1374),
  },
  [91] = {
    [sym__commit] = STATE(13596),
    [sym__rollback] = STATE(13596),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(109),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1388),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [92] = {
    [sym__commit] = STATE(12530),
    [sym__rollback] = STATE(12530),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(109),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1390),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [93] = {
    [sym__commit] = STATE(13596),
    [sym__rollback] = STATE(13596),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(92),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1388),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [94] = {
    [sym__commit] = STATE(13596),
    [sym__rollback] = STATE(13596),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(103),
    [anon_sym_SEMI] = ACTIONS(1392),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [95] = {
    [sym_transaction] = STATE(14454),
    [sym_block] = STATE(14454),
    [sym_statement] = STATE(11580),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_program_repeat1] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_begin] = ACTIONS(37),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [96] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1396),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [97] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1400),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [98] = {
    [sym_transaction] = STATE(14454),
    [sym_block] = STATE(14454),
    [sym_statement] = STATE(14454),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_program_repeat1] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_keyword_select] = ACTIONS(1404),
    [sym_keyword_delete] = ACTIONS(1407),
    [sym_keyword_insert] = ACTIONS(1410),
    [sym_keyword_replace] = ACTIONS(1410),
    [sym_keyword_update] = ACTIONS(1413),
    [sym_keyword_truncate] = ACTIONS(1416),
    [sym_keyword_merge] = ACTIONS(1419),
    [sym_keyword_set] = ACTIONS(1422),
    [sym_keyword_create] = ACTIONS(1425),
    [sym_keyword_alter] = ACTIONS(1428),
    [sym_keyword_analyze] = ACTIONS(1431),
    [sym_keyword_explain] = ACTIONS(1434),
    [sym_keyword_drop] = ACTIONS(1437),
    [sym_keyword_with] = ACTIONS(1440),
    [sym_keyword_rename] = ACTIONS(1443),
    [sym_keyword_reset] = ACTIONS(1446),
    [sym_keyword_begin] = ACTIONS(1449),
    [sym_keyword_vacuum] = ACTIONS(1452),
    [sym_keyword_copy] = ACTIONS(1455),
    [sym_keyword_compute] = ACTIONS(1458),
    [sym_keyword_optimize] = ACTIONS(1461),
    [sym_keyword_comment] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [99] = {
    [sym_statement] = STATE(11542),
    [sym__ddl_statement] = STATE(11395),
    [sym__cte] = STATE(6889),
    [sym__dml_write] = STATE(11394),
    [sym__dml_read] = STATE(11392),
    [sym_set_operation] = STATE(8298),
    [sym__select_statement] = STATE(7622),
    [sym_comment_statement] = STATE(11395),
    [sym_select] = STATE(7513),
    [sym__truncate_statement] = STATE(11390),
    [sym__delete_statement] = STATE(11390),
    [sym_delete] = STATE(11595),
    [sym__create_statement] = STATE(11395),
    [sym_create_table] = STATE(11395),
    [sym_reset_statement] = STATE(11395),
    [sym_set_statement] = STATE(11395),
    [sym_create_view] = STATE(11395),
    [sym_create_materialized_view] = STATE(11395),
    [sym_create_function] = STATE(11395),
    [sym__function_return] = STATE(11542),
    [sym__function_body_statement] = STATE(11542),
    [sym_create_index] = STATE(11395),
    [sym_create_schema] = STATE(6986),
    [sym_create_database] = STATE(11395),
    [sym_create_role] = STATE(11395),
    [sym_create_sequence] = STATE(11395),
    [sym_create_extension] = STATE(11395),
    [sym_create_trigger] = STATE(11395),
    [sym_create_type] = STATE(11395),
    [sym__alter_statement] = STATE(11395),
    [sym__rename_statement] = STATE(11389),
    [sym_alter_table] = STATE(11395),
    [sym_alter_view] = STATE(11395),
    [sym_alter_schema] = STATE(11395),
    [sym_alter_database] = STATE(11395),
    [sym_alter_role] = STATE(11395),
    [sym_alter_index] = STATE(11395),
    [sym_alter_sequence] = STATE(11395),
    [sym_alter_type] = STATE(11395),
    [sym__drop_statement] = STATE(11395),
    [sym_drop_table] = STATE(11395),
    [sym_drop_view] = STATE(11395),
    [sym_drop_schema] = STATE(11395),
    [sym_drop_database] = STATE(11395),
    [sym_drop_role] = STATE(11395),
    [sym_drop_type] = STATE(11395),
    [sym_drop_sequence] = STATE(11395),
    [sym_drop_index] = STATE(11395),
    [sym_drop_extension] = STATE(11395),
    [sym__copy_statement] = STATE(11390),
    [sym__insert_statement] = STATE(11390),
    [sym_insert] = STATE(9562),
    [sym__update_statement] = STATE(11390),
    [sym__merge_statement] = STATE(11387),
    [sym__optimize_statement] = STATE(11395),
    [sym__compute_stats] = STATE(11395),
    [sym__optimize_table] = STATE(11395),
    [sym__vacuum_table] = STATE(11395),
    [sym_update] = STATE(9696),
    [sym_keyword_select] = ACTIONS(1470),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1472),
    [sym_keyword_replace] = ACTIONS(1472),
    [sym_keyword_update] = ACTIONS(1474),
    [sym_keyword_truncate] = ACTIONS(1476),
    [sym_keyword_merge] = ACTIONS(1478),
    [sym_keyword_set] = ACTIONS(1480),
    [sym_keyword_create] = ACTIONS(1482),
    [sym_keyword_alter] = ACTIONS(1484),
    [sym_keyword_analyze] = ACTIONS(1486),
    [sym_keyword_explain] = ACTIONS(1488),
    [sym_keyword_drop] = ACTIONS(1490),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(1492),
    [sym_keyword_reset] = ACTIONS(1494),
    [sym_keyword_begin] = ACTIONS(1496),
    [sym_keyword_vacuum] = ACTIONS(1498),
    [sym_keyword_copy] = ACTIONS(1500),
    [sym_keyword_return] = ACTIONS(1502),
    [sym_keyword_declare] = ACTIONS(1504),
    [sym_keyword_compute] = ACTIONS(1506),
    [sym_keyword_optimize] = ACTIONS(1508),
    [sym_keyword_comment] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [100] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1514),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [101] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(1516),
    [sym_keyword_delete] = ACTIONS(1519),
    [sym_keyword_insert] = ACTIONS(1522),
    [sym_keyword_replace] = ACTIONS(1522),
    [sym_keyword_update] = ACTIONS(1525),
    [sym_keyword_truncate] = ACTIONS(1528),
    [sym_keyword_merge] = ACTIONS(1531),
    [sym_keyword_set] = ACTIONS(1534),
    [sym_keyword_create] = ACTIONS(1537),
    [sym_keyword_alter] = ACTIONS(1540),
    [sym_keyword_analyze] = ACTIONS(1543),
    [sym_keyword_explain] = ACTIONS(1546),
    [sym_keyword_drop] = ACTIONS(1549),
    [sym_keyword_end] = ACTIONS(1552),
    [sym_keyword_with] = ACTIONS(1554),
    [sym_keyword_rename] = ACTIONS(1557),
    [sym_keyword_reset] = ACTIONS(1560),
    [sym_keyword_vacuum] = ACTIONS(1563),
    [sym_keyword_copy] = ACTIONS(1566),
    [sym_keyword_return] = ACTIONS(1569),
    [sym_keyword_compute] = ACTIONS(1572),
    [sym_keyword_optimize] = ACTIONS(1575),
    [sym_keyword_comment] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [102] = {
    [sym_statement] = STATE(11700),
    [sym__ddl_statement] = STATE(11395),
    [sym__cte] = STATE(6889),
    [sym__dml_write] = STATE(11394),
    [sym__dml_read] = STATE(11392),
    [sym_set_operation] = STATE(8298),
    [sym__select_statement] = STATE(7622),
    [sym_comment_statement] = STATE(11395),
    [sym_select] = STATE(7513),
    [sym__truncate_statement] = STATE(11390),
    [sym__delete_statement] = STATE(11390),
    [sym_delete] = STATE(11595),
    [sym__create_statement] = STATE(11395),
    [sym_create_table] = STATE(11395),
    [sym_reset_statement] = STATE(11395),
    [sym_set_statement] = STATE(11395),
    [sym_create_view] = STATE(11395),
    [sym_create_materialized_view] = STATE(11395),
    [sym_create_function] = STATE(11395),
    [sym__function_return] = STATE(11700),
    [sym__function_body_statement] = STATE(11700),
    [sym_create_index] = STATE(11395),
    [sym_create_schema] = STATE(6986),
    [sym_create_database] = STATE(11395),
    [sym_create_role] = STATE(11395),
    [sym_create_sequence] = STATE(11395),
    [sym_create_extension] = STATE(11395),
    [sym_create_trigger] = STATE(11395),
    [sym_create_type] = STATE(11395),
    [sym__alter_statement] = STATE(11395),
    [sym__rename_statement] = STATE(11389),
    [sym_alter_table] = STATE(11395),
    [sym_alter_view] = STATE(11395),
    [sym_alter_schema] = STATE(11395),
    [sym_alter_database] = STATE(11395),
    [sym_alter_role] = STATE(11395),
    [sym_alter_index] = STATE(11395),
    [sym_alter_sequence] = STATE(11395),
    [sym_alter_type] = STATE(11395),
    [sym__drop_statement] = STATE(11395),
    [sym_drop_table] = STATE(11395),
    [sym_drop_view] = STATE(11395),
    [sym_drop_schema] = STATE(11395),
    [sym_drop_database] = STATE(11395),
    [sym_drop_role] = STATE(11395),
    [sym_drop_type] = STATE(11395),
    [sym_drop_sequence] = STATE(11395),
    [sym_drop_index] = STATE(11395),
    [sym_drop_extension] = STATE(11395),
    [sym__copy_statement] = STATE(11390),
    [sym__insert_statement] = STATE(11390),
    [sym_insert] = STATE(9562),
    [sym__update_statement] = STATE(11390),
    [sym__merge_statement] = STATE(11387),
    [sym__optimize_statement] = STATE(11395),
    [sym__compute_stats] = STATE(11395),
    [sym__optimize_table] = STATE(11395),
    [sym__vacuum_table] = STATE(11395),
    [sym_update] = STATE(9696),
    [sym_keyword_select] = ACTIONS(1470),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1472),
    [sym_keyword_replace] = ACTIONS(1472),
    [sym_keyword_update] = ACTIONS(1474),
    [sym_keyword_truncate] = ACTIONS(1476),
    [sym_keyword_merge] = ACTIONS(1478),
    [sym_keyword_set] = ACTIONS(1480),
    [sym_keyword_create] = ACTIONS(1482),
    [sym_keyword_alter] = ACTIONS(1484),
    [sym_keyword_analyze] = ACTIONS(1486),
    [sym_keyword_explain] = ACTIONS(1488),
    [sym_keyword_drop] = ACTIONS(1490),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(1492),
    [sym_keyword_reset] = ACTIONS(1494),
    [sym_keyword_begin] = ACTIONS(1584),
    [sym_keyword_vacuum] = ACTIONS(1498),
    [sym_keyword_copy] = ACTIONS(1500),
    [sym_keyword_return] = ACTIONS(1502),
    [sym_keyword_declare] = ACTIONS(1586),
    [sym_keyword_compute] = ACTIONS(1506),
    [sym_keyword_optimize] = ACTIONS(1508),
    [sym_keyword_comment] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [103] = {
    [sym__commit] = STATE(12530),
    [sym__rollback] = STATE(12530),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(109),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [104] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1588),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [105] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1590),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [106] = {
    [sym__commit] = STATE(13298),
    [sym__rollback] = STATE(13298),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(109),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [107] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(101),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_end] = ACTIONS(1592),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [108] = {
    [sym__commit] = STATE(12530),
    [sym__rollback] = STATE(12530),
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(106),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_commit] = ACTIONS(1382),
    [sym_keyword_rollback] = ACTIONS(1384),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [109] = {
    [sym_statement] = STATE(14111),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_transaction_repeat1] = STATE(109),
    [sym_keyword_select] = ACTIONS(1594),
    [sym_keyword_delete] = ACTIONS(1597),
    [sym_keyword_insert] = ACTIONS(1600),
    [sym_keyword_replace] = ACTIONS(1600),
    [sym_keyword_update] = ACTIONS(1603),
    [sym_keyword_truncate] = ACTIONS(1606),
    [sym_keyword_merge] = ACTIONS(1609),
    [sym_keyword_set] = ACTIONS(1612),
    [sym_keyword_create] = ACTIONS(1615),
    [sym_keyword_alter] = ACTIONS(1618),
    [sym_keyword_analyze] = ACTIONS(1621),
    [sym_keyword_explain] = ACTIONS(1624),
    [sym_keyword_drop] = ACTIONS(1627),
    [sym_keyword_end] = ACTIONS(1630),
    [sym_keyword_with] = ACTIONS(1632),
    [sym_keyword_rename] = ACTIONS(1635),
    [sym_keyword_reset] = ACTIONS(1638),
    [sym_keyword_commit] = ACTIONS(1630),
    [sym_keyword_rollback] = ACTIONS(1630),
    [sym_keyword_vacuum] = ACTIONS(1641),
    [sym_keyword_copy] = ACTIONS(1644),
    [sym_keyword_compute] = ACTIONS(1647),
    [sym_keyword_optimize] = ACTIONS(1650),
    [sym_keyword_comment] = ACTIONS(1653),
    [anon_sym_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [110] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(105),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [111] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(96),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [112] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(107),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [113] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(100),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [114] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(104),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [115] = {
    [sym_statement] = STATE(14020),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym__function_return] = STATE(14020),
    [sym__function_body_statement] = STATE(14020),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(9854),
    [aux_sym_function_body_repeat1] = STATE(97),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(27),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_return] = ACTIONS(1398),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [116] = {
    [aux_sym__single_quote_string_repeat1] = STATE(117),
    [ts_builtin_sym_end] = ACTIONS(1357),
    [sym__identifier] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1357),
    [sym_keyword_from] = ACTIONS(1359),
    [sym_keyword_on] = ACTIONS(1359),
    [sym_keyword_limit] = ACTIONS(1359),
    [sym_keyword_offset] = ACTIONS(1359),
    [sym_keyword_create] = ACTIONS(1359),
    [sym_keyword_as] = ACTIONS(1359),
    [sym_keyword_when] = ACTIONS(1359),
    [sym_keyword_in] = ACTIONS(1359),
    [sym_keyword_and] = ACTIONS(1359),
    [sym_keyword_or] = ACTIONS(1359),
    [sym_keyword_is] = ACTIONS(1359),
    [sym_keyword_not] = ACTIONS(1359),
    [sym_keyword_default] = ACTIONS(1359),
    [sym_keyword_cascade] = ACTIONS(1359),
    [sym_keyword_with] = ACTIONS(1359),
    [sym_keyword_to] = ACTIONS(1359),
    [sym_keyword_password] = ACTIONS(1359),
    [sym_keyword_encrypted] = ACTIONS(1359),
    [sym_keyword_valid] = ACTIONS(1359),
    [sym_keyword_connection] = ACTIONS(1359),
    [sym_keyword_union] = ACTIONS(1359),
    [sym_keyword_except] = ACTIONS(1359),
    [sym_keyword_intersect] = ACTIONS(1359),
    [sym_keyword_returning] = ACTIONS(1359),
    [sym_keyword_after] = ACTIONS(1359),
    [sym_keyword_before] = ACTIONS(1359),
    [sym_keyword_rows] = ACTIONS(1359),
    [sym_keyword_between] = ACTIONS(1359),
    [aux_sym_keyword_like_token1] = ACTIONS(1359),
    [aux_sym_keyword_like_token2] = ACTIONS(1359),
    [sym_keyword_similar] = ACTIONS(1359),
    [sym_keyword_check] = ACTIONS(1359),
    [sym_keyword_freeze] = ACTIONS(1359),
    [sym_keyword_escape] = ACTIONS(1359),
    [sym_keyword_encoding] = ACTIONS(1359),
    [sym_keyword_force_quote] = ACTIONS(1359),
    [sym_keyword_quote] = ACTIONS(1359),
    [sym_keyword_force_null] = ACTIONS(1359),
    [sym_keyword_force_not_null] = ACTIONS(1359),
    [sym_keyword_header] = ACTIONS(1359),
    [sym_keyword_returns] = ACTIONS(1359),
    [sym_keyword_language] = ACTIONS(1359),
    [sym_keyword_immutable] = ACTIONS(1359),
    [sym_keyword_stable] = ACTIONS(1359),
    [sym_keyword_volatile] = ACTIONS(1359),
    [sym_keyword_leakproof] = ACTIONS(1359),
    [sym_keyword_parallel] = ACTIONS(1359),
    [sym_keyword_called] = ACTIONS(1359),
    [sym_keyword_strict] = ACTIONS(1359),
    [sym_keyword_cost] = ACTIONS(1359),
    [sym_keyword_support] = ACTIONS(1359),
    [sym_keyword_security] = ACTIONS(1359),
    [sym_keyword_external] = ACTIONS(1359),
    [sym_keyword_format] = ACTIONS(1359),
    [sym_keyword_delimiter] = ACTIONS(1359),
    [sym_keyword_null] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_LT_EQ] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1357),
    [sym_op_other] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1357),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1357),
    [anon_sym_LT_GT] = ACTIONS(1357),
    [sym__double_quote_string] = ACTIONS(1357),
    [aux_sym__single_quote_string_token2] = ACTIONS(1659),
    [aux_sym_identifier_token1] = ACTIONS(1357),
  },
  [117] = {
    [aux_sym__single_quote_string_repeat1] = STATE(117),
    [ts_builtin_sym_end] = ACTIONS(1363),
    [sym__identifier] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1363),
    [sym_keyword_from] = ACTIONS(1365),
    [sym_keyword_on] = ACTIONS(1365),
    [sym_keyword_limit] = ACTIONS(1365),
    [sym_keyword_offset] = ACTIONS(1365),
    [sym_keyword_create] = ACTIONS(1365),
    [sym_keyword_as] = ACTIONS(1365),
    [sym_keyword_when] = ACTIONS(1365),
    [sym_keyword_in] = ACTIONS(1365),
    [sym_keyword_and] = ACTIONS(1365),
    [sym_keyword_or] = ACTIONS(1365),
    [sym_keyword_is] = ACTIONS(1365),
    [sym_keyword_not] = ACTIONS(1365),
    [sym_keyword_default] = ACTIONS(1365),
    [sym_keyword_cascade] = ACTIONS(1365),
    [sym_keyword_with] = ACTIONS(1365),
    [sym_keyword_to] = ACTIONS(1365),
    [sym_keyword_password] = ACTIONS(1365),
    [sym_keyword_encrypted] = ACTIONS(1365),
    [sym_keyword_valid] = ACTIONS(1365),
    [sym_keyword_connection] = ACTIONS(1365),
    [sym_keyword_union] = ACTIONS(1365),
    [sym_keyword_except] = ACTIONS(1365),
    [sym_keyword_intersect] = ACTIONS(1365),
    [sym_keyword_returning] = ACTIONS(1365),
    [sym_keyword_after] = ACTIONS(1365),
    [sym_keyword_before] = ACTIONS(1365),
    [sym_keyword_rows] = ACTIONS(1365),
    [sym_keyword_between] = ACTIONS(1365),
    [aux_sym_keyword_like_token1] = ACTIONS(1365),
    [aux_sym_keyword_like_token2] = ACTIONS(1365),
    [sym_keyword_similar] = ACTIONS(1365),
    [sym_keyword_check] = ACTIONS(1365),
    [sym_keyword_freeze] = ACTIONS(1365),
    [sym_keyword_escape] = ACTIONS(1365),
    [sym_keyword_encoding] = ACTIONS(1365),
    [sym_keyword_force_quote] = ACTIONS(1365),
    [sym_keyword_quote] = ACTIONS(1365),
    [sym_keyword_force_null] = ACTIONS(1365),
    [sym_keyword_force_not_null] = ACTIONS(1365),
    [sym_keyword_header] = ACTIONS(1365),
    [sym_keyword_returns] = ACTIONS(1365),
    [sym_keyword_language] = ACTIONS(1365),
    [sym_keyword_immutable] = ACTIONS(1365),
    [sym_keyword_stable] = ACTIONS(1365),
    [sym_keyword_volatile] = ACTIONS(1365),
    [sym_keyword_leakproof] = ACTIONS(1365),
    [sym_keyword_parallel] = ACTIONS(1365),
    [sym_keyword_called] = ACTIONS(1365),
    [sym_keyword_strict] = ACTIONS(1365),
    [sym_keyword_cost] = ACTIONS(1365),
    [sym_keyword_support] = ACTIONS(1365),
    [sym_keyword_security] = ACTIONS(1365),
    [sym_keyword_external] = ACTIONS(1365),
    [sym_keyword_format] = ACTIONS(1365),
    [sym_keyword_delimiter] = ACTIONS(1365),
    [sym_keyword_null] = ACTIONS(1365),
    [anon_sym_LBRACK] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(1363),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [sym_op_other] = ACTIONS(1363),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_LT_GT] = ACTIONS(1363),
    [sym__double_quote_string] = ACTIONS(1363),
    [aux_sym__single_quote_string_token2] = ACTIONS(1661),
    [aux_sym_identifier_token1] = ACTIONS(1363),
  },
  [118] = {
    [aux_sym__single_quote_string_repeat1] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(1351),
    [sym__identifier] = ACTIONS(1353),
    [anon_sym_SEMI] = ACTIONS(1351),
    [sym_keyword_from] = ACTIONS(1353),
    [sym_keyword_on] = ACTIONS(1353),
    [sym_keyword_limit] = ACTIONS(1353),
    [sym_keyword_offset] = ACTIONS(1353),
    [sym_keyword_create] = ACTIONS(1353),
    [sym_keyword_as] = ACTIONS(1353),
    [sym_keyword_when] = ACTIONS(1353),
    [sym_keyword_in] = ACTIONS(1353),
    [sym_keyword_and] = ACTIONS(1353),
    [sym_keyword_or] = ACTIONS(1353),
    [sym_keyword_is] = ACTIONS(1353),
    [sym_keyword_not] = ACTIONS(1353),
    [sym_keyword_default] = ACTIONS(1353),
    [sym_keyword_cascade] = ACTIONS(1353),
    [sym_keyword_with] = ACTIONS(1353),
    [sym_keyword_to] = ACTIONS(1353),
    [sym_keyword_password] = ACTIONS(1353),
    [sym_keyword_encrypted] = ACTIONS(1353),
    [sym_keyword_valid] = ACTIONS(1353),
    [sym_keyword_connection] = ACTIONS(1353),
    [sym_keyword_union] = ACTIONS(1353),
    [sym_keyword_except] = ACTIONS(1353),
    [sym_keyword_intersect] = ACTIONS(1353),
    [sym_keyword_returning] = ACTIONS(1353),
    [sym_keyword_after] = ACTIONS(1353),
    [sym_keyword_before] = ACTIONS(1353),
    [sym_keyword_rows] = ACTIONS(1353),
    [sym_keyword_between] = ACTIONS(1353),
    [aux_sym_keyword_like_token1] = ACTIONS(1353),
    [aux_sym_keyword_like_token2] = ACTIONS(1353),
    [sym_keyword_similar] = ACTIONS(1353),
    [sym_keyword_check] = ACTIONS(1353),
    [sym_keyword_freeze] = ACTIONS(1353),
    [sym_keyword_escape] = ACTIONS(1353),
    [sym_keyword_encoding] = ACTIONS(1353),
    [sym_keyword_force_quote] = ACTIONS(1353),
    [sym_keyword_quote] = ACTIONS(1353),
    [sym_keyword_force_null] = ACTIONS(1353),
    [sym_keyword_force_not_null] = ACTIONS(1353),
    [sym_keyword_header] = ACTIONS(1353),
    [sym_keyword_returns] = ACTIONS(1353),
    [sym_keyword_language] = ACTIONS(1353),
    [sym_keyword_immutable] = ACTIONS(1353),
    [sym_keyword_stable] = ACTIONS(1353),
    [sym_keyword_volatile] = ACTIONS(1353),
    [sym_keyword_leakproof] = ACTIONS(1353),
    [sym_keyword_parallel] = ACTIONS(1353),
    [sym_keyword_called] = ACTIONS(1353),
    [sym_keyword_strict] = ACTIONS(1353),
    [sym_keyword_cost] = ACTIONS(1353),
    [sym_keyword_support] = ACTIONS(1353),
    [sym_keyword_security] = ACTIONS(1353),
    [sym_keyword_external] = ACTIONS(1353),
    [sym_keyword_format] = ACTIONS(1353),
    [sym_keyword_delimiter] = ACTIONS(1353),
    [sym_keyword_null] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym_op_other] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_PERCENT] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_LT_GT] = ACTIONS(1351),
    [sym__double_quote_string] = ACTIONS(1351),
    [aux_sym__single_quote_string_token2] = ACTIONS(1664),
    [aux_sym_identifier_token1] = ACTIONS(1351),
  },
  [119] = {
    [sym__primary_key] = STATE(11974),
    [sym__check_constraint] = STATE(9955),
    [sym_constraint] = STATE(9961),
    [sym__constraint_literal] = STATE(9965),
    [sym__primary_key_constraint] = STATE(9955),
    [sym__key_constraint] = STATE(9966),
    [sym__identifier] = ACTIONS(1666),
    [sym_keyword_primary] = ACTIONS(1668),
    [sym_keyword_key] = ACTIONS(1670),
    [sym_keyword_constraint] = ACTIONS(1672),
    [sym_keyword_index] = ACTIONS(1674),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unique] = ACTIONS(1676),
    [sym_keyword_foreign] = ACTIONS(1678),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_check] = ACTIONS(1680),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [120] = {
    [sym__primary_key] = STATE(11640),
    [sym__check_constraint] = STATE(10232),
    [sym_constraint] = STATE(10233),
    [sym__constraint_literal] = STATE(10234),
    [sym__primary_key_constraint] = STATE(10232),
    [sym__key_constraint] = STATE(10235),
    [sym__identifier] = ACTIONS(1666),
    [sym_keyword_primary] = ACTIONS(1668),
    [sym_keyword_key] = ACTIONS(1684),
    [sym_keyword_constraint] = ACTIONS(1686),
    [sym_keyword_index] = ACTIONS(1688),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unique] = ACTIONS(1690),
    [sym_keyword_foreign] = ACTIONS(1692),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_check] = ACTIONS(1694),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [121] = {
    [sym__ddl_statement] = STATE(11371),
    [sym__cte] = STATE(6889),
    [sym__dml_write] = STATE(11370),
    [sym__dml_read] = STATE(11369),
    [sym_set_operation] = STATE(8298),
    [sym__select_statement] = STATE(7622),
    [sym_comment_statement] = STATE(11371),
    [sym_select] = STATE(7513),
    [sym__truncate_statement] = STATE(11390),
    [sym__delete_statement] = STATE(11390),
    [sym_delete] = STATE(11595),
    [sym__create_statement] = STATE(11371),
    [sym_create_table] = STATE(11371),
    [sym_reset_statement] = STATE(11371),
    [sym_set_statement] = STATE(11371),
    [sym_create_view] = STATE(11371),
    [sym_create_materialized_view] = STATE(11371),
    [sym_create_function] = STATE(11371),
    [sym_create_index] = STATE(11371),
    [sym_create_schema] = STATE(6986),
    [sym_create_database] = STATE(11371),
    [sym_create_role] = STATE(11371),
    [sym_create_sequence] = STATE(11371),
    [sym_create_extension] = STATE(11371),
    [sym_create_trigger] = STATE(11371),
    [sym_create_type] = STATE(11371),
    [sym__alter_statement] = STATE(11371),
    [sym__rename_statement] = STATE(11389),
    [sym_alter_table] = STATE(11371),
    [sym_alter_view] = STATE(11371),
    [sym_alter_schema] = STATE(11371),
    [sym_alter_database] = STATE(11371),
    [sym_alter_role] = STATE(11371),
    [sym_alter_index] = STATE(11371),
    [sym_alter_sequence] = STATE(11371),
    [sym_alter_type] = STATE(11371),
    [sym__drop_statement] = STATE(11371),
    [sym_drop_table] = STATE(11371),
    [sym_drop_view] = STATE(11371),
    [sym_drop_schema] = STATE(11371),
    [sym_drop_database] = STATE(11371),
    [sym_drop_role] = STATE(11371),
    [sym_drop_type] = STATE(11371),
    [sym_drop_sequence] = STATE(11371),
    [sym_drop_index] = STATE(11371),
    [sym_drop_extension] = STATE(11371),
    [sym__copy_statement] = STATE(11390),
    [sym__insert_statement] = STATE(11390),
    [sym_insert] = STATE(9562),
    [sym__update_statement] = STATE(11390),
    [sym__merge_statement] = STATE(11387),
    [sym__optimize_statement] = STATE(11371),
    [sym__compute_stats] = STATE(11371),
    [sym__optimize_table] = STATE(11371),
    [sym__vacuum_table] = STATE(11371),
    [sym_update] = STATE(9696),
    [sym_keyword_select] = ACTIONS(1470),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1472),
    [sym_keyword_replace] = ACTIONS(1472),
    [sym_keyword_update] = ACTIONS(1474),
    [sym_keyword_truncate] = ACTIONS(1476),
    [sym_keyword_merge] = ACTIONS(1478),
    [sym_keyword_set] = ACTIONS(1480),
    [sym_keyword_create] = ACTIONS(1482),
    [sym_keyword_alter] = ACTIONS(1484),
    [sym_keyword_analyze] = ACTIONS(1486),
    [sym_keyword_verbose] = ACTIONS(1696),
    [sym_keyword_drop] = ACTIONS(1490),
    [sym_keyword_table] = ACTIONS(1698),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(1492),
    [sym_keyword_reset] = ACTIONS(1494),
    [sym_keyword_vacuum] = ACTIONS(1498),
    [sym_keyword_copy] = ACTIONS(1500),
    [sym_keyword_compute] = ACTIONS(1506),
    [sym_keyword_optimize] = ACTIONS(1508),
    [sym_keyword_comment] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1700),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [122] = {
    [sym_statement] = STATE(14368),
    [sym__ddl_statement] = STATE(10649),
    [sym__cte] = STATE(6893),
    [sym__dml_write] = STATE(10651),
    [sym__dml_read] = STATE(10654),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10649),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11802),
    [sym__create_statement] = STATE(10649),
    [sym_create_table] = STATE(10649),
    [sym_reset_statement] = STATE(10649),
    [sym_set_statement] = STATE(10649),
    [sym_create_view] = STATE(10649),
    [sym_create_materialized_view] = STATE(10649),
    [sym_create_function] = STATE(10649),
    [sym_create_index] = STATE(10649),
    [sym_create_schema] = STATE(7008),
    [sym_create_database] = STATE(10649),
    [sym_create_role] = STATE(10649),
    [sym_create_sequence] = STATE(10649),
    [sym_create_extension] = STATE(10649),
    [sym_create_trigger] = STATE(10649),
    [sym_create_type] = STATE(10649),
    [sym__alter_statement] = STATE(10649),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10649),
    [sym_alter_view] = STATE(10649),
    [sym_alter_schema] = STATE(10649),
    [sym_alter_database] = STATE(10649),
    [sym_alter_role] = STATE(10649),
    [sym_alter_index] = STATE(10649),
    [sym_alter_sequence] = STATE(10649),
    [sym_alter_type] = STATE(10649),
    [sym__drop_statement] = STATE(10649),
    [sym_drop_table] = STATE(10649),
    [sym_drop_view] = STATE(10649),
    [sym_drop_schema] = STATE(10649),
    [sym_drop_database] = STATE(10649),
    [sym_drop_role] = STATE(10649),
    [sym_drop_type] = STATE(10649),
    [sym_drop_sequence] = STATE(10649),
    [sym_drop_index] = STATE(10649),
    [sym_drop_extension] = STATE(10649),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(11076),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10649),
    [sym__compute_stats] = STATE(10649),
    [sym__optimize_table] = STATE(10649),
    [sym__vacuum_table] = STATE(10649),
    [sym_update] = STATE(11074),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1702),
    [sym_keyword_replace] = ACTIONS(1702),
    [sym_keyword_update] = ACTIONS(1704),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(1706),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(1708),
    [sym_keyword_alter] = ACTIONS(1710),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_explain] = ACTIONS(1712),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(1714),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(1716),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [123] = {
    [sym__ddl_statement] = STATE(10358),
    [sym__cte] = STATE(6893),
    [sym__dml_write] = STATE(10398),
    [sym__dml_read] = STATE(10418),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10358),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11802),
    [sym__create_statement] = STATE(10358),
    [sym_create_table] = STATE(10358),
    [sym_reset_statement] = STATE(10358),
    [sym_set_statement] = STATE(10358),
    [sym_create_view] = STATE(10358),
    [sym_create_materialized_view] = STATE(10358),
    [sym_create_function] = STATE(10358),
    [sym_create_index] = STATE(10358),
    [sym_create_schema] = STATE(7008),
    [sym_create_database] = STATE(10358),
    [sym_create_role] = STATE(10358),
    [sym_create_sequence] = STATE(10358),
    [sym_create_extension] = STATE(10358),
    [sym_create_trigger] = STATE(10358),
    [sym_create_type] = STATE(10358),
    [sym__alter_statement] = STATE(10358),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10358),
    [sym_alter_view] = STATE(10358),
    [sym_alter_schema] = STATE(10358),
    [sym_alter_database] = STATE(10358),
    [sym_alter_role] = STATE(10358),
    [sym_alter_index] = STATE(10358),
    [sym_alter_sequence] = STATE(10358),
    [sym_alter_type] = STATE(10358),
    [sym__drop_statement] = STATE(10358),
    [sym_drop_table] = STATE(10358),
    [sym_drop_view] = STATE(10358),
    [sym_drop_schema] = STATE(10358),
    [sym_drop_database] = STATE(10358),
    [sym_drop_role] = STATE(10358),
    [sym_drop_type] = STATE(10358),
    [sym_drop_sequence] = STATE(10358),
    [sym_drop_index] = STATE(10358),
    [sym_drop_extension] = STATE(10358),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(11076),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10358),
    [sym__compute_stats] = STATE(10358),
    [sym__optimize_table] = STATE(10358),
    [sym__vacuum_table] = STATE(10358),
    [sym_update] = STATE(11074),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1702),
    [sym_keyword_replace] = ACTIONS(1702),
    [sym_keyword_update] = ACTIONS(1704),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(1706),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(1708),
    [sym_keyword_alter] = ACTIONS(1710),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_verbose] = ACTIONS(1718),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_table] = ACTIONS(1720),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(1714),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(1716),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [124] = {
    [sym__ddl_statement] = STATE(10358),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10398),
    [sym__dml_read] = STATE(10418),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10358),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10358),
    [sym_create_table] = STATE(10358),
    [sym_reset_statement] = STATE(10358),
    [sym_set_statement] = STATE(10358),
    [sym_create_view] = STATE(10358),
    [sym_create_materialized_view] = STATE(10358),
    [sym_create_function] = STATE(10358),
    [sym_create_index] = STATE(10358),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10358),
    [sym_create_role] = STATE(10358),
    [sym_create_sequence] = STATE(10358),
    [sym_create_extension] = STATE(10358),
    [sym_create_trigger] = STATE(10358),
    [sym_create_type] = STATE(10358),
    [sym__alter_statement] = STATE(10358),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10358),
    [sym_alter_view] = STATE(10358),
    [sym_alter_schema] = STATE(10358),
    [sym_alter_database] = STATE(10358),
    [sym_alter_role] = STATE(10358),
    [sym_alter_index] = STATE(10358),
    [sym_alter_sequence] = STATE(10358),
    [sym_alter_type] = STATE(10358),
    [sym__drop_statement] = STATE(10358),
    [sym_drop_table] = STATE(10358),
    [sym_drop_view] = STATE(10358),
    [sym_drop_schema] = STATE(10358),
    [sym_drop_database] = STATE(10358),
    [sym_drop_role] = STATE(10358),
    [sym_drop_type] = STATE(10358),
    [sym_drop_sequence] = STATE(10358),
    [sym_drop_index] = STATE(10358),
    [sym_drop_extension] = STATE(10358),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10358),
    [sym__compute_stats] = STATE(10358),
    [sym__optimize_table] = STATE(10358),
    [sym__vacuum_table] = STATE(10358),
    [sym_update] = STATE(9854),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_verbose] = ACTIONS(1724),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_table] = ACTIONS(1720),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [125] = {
    [sym__ddl_statement] = STATE(10401),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10381),
    [sym__dml_read] = STATE(10375),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10401),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10401),
    [sym_create_table] = STATE(10401),
    [sym_reset_statement] = STATE(10401),
    [sym_set_statement] = STATE(10401),
    [sym_create_view] = STATE(10401),
    [sym_create_materialized_view] = STATE(10401),
    [sym_create_function] = STATE(10401),
    [sym_create_index] = STATE(10401),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10401),
    [sym_create_role] = STATE(10401),
    [sym_create_sequence] = STATE(10401),
    [sym_create_extension] = STATE(10401),
    [sym_create_trigger] = STATE(10401),
    [sym_create_type] = STATE(10401),
    [sym__alter_statement] = STATE(10401),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10401),
    [sym_alter_view] = STATE(10401),
    [sym_alter_schema] = STATE(10401),
    [sym_alter_database] = STATE(10401),
    [sym_alter_role] = STATE(10401),
    [sym_alter_index] = STATE(10401),
    [sym_alter_sequence] = STATE(10401),
    [sym_alter_type] = STATE(10401),
    [sym__drop_statement] = STATE(10401),
    [sym_drop_table] = STATE(10401),
    [sym_drop_view] = STATE(10401),
    [sym_drop_schema] = STATE(10401),
    [sym_drop_database] = STATE(10401),
    [sym_drop_role] = STATE(10401),
    [sym_drop_type] = STATE(10401),
    [sym_drop_sequence] = STATE(10401),
    [sym_drop_index] = STATE(10401),
    [sym_drop_extension] = STATE(10401),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10401),
    [sym__compute_stats] = STATE(10401),
    [sym__optimize_table] = STATE(10401),
    [sym__vacuum_table] = STATE(10401),
    [sym_update] = STATE(9854),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(1726),
    [sym_keyword_verbose] = ACTIONS(1728),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [126] = {
    [sym__ddl_statement] = STATE(11382),
    [sym__cte] = STATE(6889),
    [sym__dml_write] = STATE(11380),
    [sym__dml_read] = STATE(11379),
    [sym_set_operation] = STATE(8298),
    [sym__select_statement] = STATE(7622),
    [sym_comment_statement] = STATE(11382),
    [sym_select] = STATE(7513),
    [sym__truncate_statement] = STATE(11390),
    [sym__delete_statement] = STATE(11390),
    [sym_delete] = STATE(11595),
    [sym__create_statement] = STATE(11382),
    [sym_create_table] = STATE(11382),
    [sym_reset_statement] = STATE(11382),
    [sym_set_statement] = STATE(11382),
    [sym_create_view] = STATE(11382),
    [sym_create_materialized_view] = STATE(11382),
    [sym_create_function] = STATE(11382),
    [sym_create_index] = STATE(11382),
    [sym_create_schema] = STATE(6986),
    [sym_create_database] = STATE(11382),
    [sym_create_role] = STATE(11382),
    [sym_create_sequence] = STATE(11382),
    [sym_create_extension] = STATE(11382),
    [sym_create_trigger] = STATE(11382),
    [sym_create_type] = STATE(11382),
    [sym__alter_statement] = STATE(11382),
    [sym__rename_statement] = STATE(11389),
    [sym_alter_table] = STATE(11382),
    [sym_alter_view] = STATE(11382),
    [sym_alter_schema] = STATE(11382),
    [sym_alter_database] = STATE(11382),
    [sym_alter_role] = STATE(11382),
    [sym_alter_index] = STATE(11382),
    [sym_alter_sequence] = STATE(11382),
    [sym_alter_type] = STATE(11382),
    [sym__drop_statement] = STATE(11382),
    [sym_drop_table] = STATE(11382),
    [sym_drop_view] = STATE(11382),
    [sym_drop_schema] = STATE(11382),
    [sym_drop_database] = STATE(11382),
    [sym_drop_role] = STATE(11382),
    [sym_drop_type] = STATE(11382),
    [sym_drop_sequence] = STATE(11382),
    [sym_drop_index] = STATE(11382),
    [sym_drop_extension] = STATE(11382),
    [sym__copy_statement] = STATE(11390),
    [sym__insert_statement] = STATE(11390),
    [sym_insert] = STATE(9562),
    [sym__update_statement] = STATE(11390),
    [sym__merge_statement] = STATE(11387),
    [sym__optimize_statement] = STATE(11382),
    [sym__compute_stats] = STATE(11382),
    [sym__optimize_table] = STATE(11382),
    [sym__vacuum_table] = STATE(11382),
    [sym_update] = STATE(9696),
    [sym_keyword_select] = ACTIONS(1470),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1472),
    [sym_keyword_replace] = ACTIONS(1472),
    [sym_keyword_update] = ACTIONS(1474),
    [sym_keyword_truncate] = ACTIONS(1476),
    [sym_keyword_merge] = ACTIONS(1478),
    [sym_keyword_set] = ACTIONS(1480),
    [sym_keyword_create] = ACTIONS(1482),
    [sym_keyword_alter] = ACTIONS(1484),
    [sym_keyword_analyze] = ACTIONS(1732),
    [sym_keyword_verbose] = ACTIONS(1734),
    [sym_keyword_drop] = ACTIONS(1490),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(1492),
    [sym_keyword_reset] = ACTIONS(1494),
    [sym_keyword_vacuum] = ACTIONS(1498),
    [sym_keyword_copy] = ACTIONS(1500),
    [sym_keyword_compute] = ACTIONS(1506),
    [sym_keyword_optimize] = ACTIONS(1508),
    [sym_keyword_comment] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1736),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [127] = {
    [sym__identifier] = ACTIONS(1372),
    [sym_keyword_primary] = ACTIONS(1376),
    [sym_keyword_key] = ACTIONS(1376),
    [sym_keyword_constraint] = ACTIONS(1376),
    [sym_keyword_index] = ACTIONS(1376),
    [aux_sym_keyword_character_token1] = ACTIONS(1372),
    [sym_keyword_unique] = ACTIONS(1376),
    [sym_keyword_foreign] = ACTIONS(1376),
    [sym_keyword_unsigned] = ACTIONS(1372),
    [sym_keyword_check] = ACTIONS(1376),
    [sym_keyword_boolean] = ACTIONS(1372),
    [sym_keyword_bit] = ACTIONS(1372),
    [sym_keyword_binary] = ACTIONS(1372),
    [sym_keyword_varbinary] = ACTIONS(1372),
    [sym_keyword_image] = ACTIONS(1372),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1372),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1372),
    [aux_sym_keyword_serial_token1] = ACTIONS(1372),
    [aux_sym_keyword_serial_token2] = ACTIONS(1372),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1372),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1372),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1372),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1372),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1372),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1372),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1372),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1372),
    [aux_sym_keyword_int_token1] = ACTIONS(1372),
    [aux_sym_keyword_int_token2] = ACTIONS(1372),
    [aux_sym_keyword_int_token3] = ACTIONS(1372),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1372),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1372),
    [sym_keyword_decimal] = ACTIONS(1372),
    [sym_keyword_numeric] = ACTIONS(1372),
    [aux_sym_keyword_real_token1] = ACTIONS(1372),
    [aux_sym_keyword_real_token2] = ACTIONS(1372),
    [sym_keyword_float] = ACTIONS(1372),
    [sym_keyword_double] = ACTIONS(1372),
    [sym_keyword_inet] = ACTIONS(1372),
    [sym_keyword_money] = ACTIONS(1372),
    [sym_keyword_smallmoney] = ACTIONS(1372),
    [aux_sym_keyword_char_token1] = ACTIONS(1372),
    [sym_keyword_nchar] = ACTIONS(1372),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1372),
    [sym_keyword_nvarchar] = ACTIONS(1372),
    [sym_keyword_text] = ACTIONS(1372),
    [sym_keyword_string] = ACTIONS(1372),
    [sym_keyword_uuid] = ACTIONS(1372),
    [sym_keyword_json] = ACTIONS(1372),
    [sym_keyword_jsonb] = ACTIONS(1372),
    [sym_keyword_xml] = ACTIONS(1372),
    [sym_keyword_bytea] = ACTIONS(1372),
    [sym_keyword_enum] = ACTIONS(1372),
    [sym_keyword_date] = ACTIONS(1372),
    [sym_keyword_datetime] = ACTIONS(1372),
    [sym_keyword_datetime2] = ACTIONS(1372),
    [sym_keyword_smalldatetime] = ACTIONS(1372),
    [sym_keyword_datetimeoffset] = ACTIONS(1372),
    [sym_keyword_time] = ACTIONS(1372),
    [sym_keyword_timestamp] = ACTIONS(1372),
    [sym_keyword_timestamptz] = ACTIONS(1372),
    [sym_keyword_interval] = ACTIONS(1372),
    [sym_keyword_geometry] = ACTIONS(1372),
    [sym_keyword_geography] = ACTIONS(1372),
    [sym_keyword_box2d] = ACTIONS(1372),
    [sym_keyword_box3d] = ACTIONS(1372),
    [sym_keyword_oid] = ACTIONS(1372),
    [sym_keyword_name] = ACTIONS(1372),
    [sym_keyword_regclass] = ACTIONS(1372),
    [sym_keyword_regnamespace] = ACTIONS(1372),
    [sym_keyword_regproc] = ACTIONS(1372),
    [sym_keyword_regtype] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [aux_sym_double_token1] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1370),
    [aux_sym_identifier_token1] = ACTIONS(1370),
  },
  [128] = {
    [sym__ddl_statement] = STATE(10401),
    [sym__cte] = STATE(6893),
    [sym__dml_write] = STATE(10381),
    [sym__dml_read] = STATE(10375),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10401),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11802),
    [sym__create_statement] = STATE(10401),
    [sym_create_table] = STATE(10401),
    [sym_reset_statement] = STATE(10401),
    [sym_set_statement] = STATE(10401),
    [sym_create_view] = STATE(10401),
    [sym_create_materialized_view] = STATE(10401),
    [sym_create_function] = STATE(10401),
    [sym_create_index] = STATE(10401),
    [sym_create_schema] = STATE(7008),
    [sym_create_database] = STATE(10401),
    [sym_create_role] = STATE(10401),
    [sym_create_sequence] = STATE(10401),
    [sym_create_extension] = STATE(10401),
    [sym_create_trigger] = STATE(10401),
    [sym_create_type] = STATE(10401),
    [sym__alter_statement] = STATE(10401),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10401),
    [sym_alter_view] = STATE(10401),
    [sym_alter_schema] = STATE(10401),
    [sym_alter_database] = STATE(10401),
    [sym_alter_role] = STATE(10401),
    [sym_alter_index] = STATE(10401),
    [sym_alter_sequence] = STATE(10401),
    [sym_alter_type] = STATE(10401),
    [sym__drop_statement] = STATE(10401),
    [sym_drop_table] = STATE(10401),
    [sym_drop_view] = STATE(10401),
    [sym_drop_schema] = STATE(10401),
    [sym_drop_database] = STATE(10401),
    [sym_drop_role] = STATE(10401),
    [sym_drop_type] = STATE(10401),
    [sym_drop_sequence] = STATE(10401),
    [sym_drop_index] = STATE(10401),
    [sym_drop_extension] = STATE(10401),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(11076),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10401),
    [sym__compute_stats] = STATE(10401),
    [sym__optimize_table] = STATE(10401),
    [sym__vacuum_table] = STATE(10401),
    [sym_update] = STATE(11074),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1702),
    [sym_keyword_replace] = ACTIONS(1702),
    [sym_keyword_update] = ACTIONS(1704),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(1706),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(1708),
    [sym_keyword_alter] = ACTIONS(1710),
    [sym_keyword_analyze] = ACTIONS(1738),
    [sym_keyword_verbose] = ACTIONS(1740),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(1714),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(1716),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [129] = {
    [sym__ddl_statement] = STATE(10481),
    [sym__cte] = STATE(6893),
    [sym__dml_write] = STATE(10477),
    [sym__dml_read] = STATE(10465),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10481),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11802),
    [sym__create_statement] = STATE(10481),
    [sym_create_table] = STATE(10481),
    [sym_reset_statement] = STATE(10481),
    [sym_set_statement] = STATE(10481),
    [sym_create_view] = STATE(10481),
    [sym_create_materialized_view] = STATE(10481),
    [sym_create_function] = STATE(10481),
    [sym_create_index] = STATE(10481),
    [sym_create_schema] = STATE(7008),
    [sym_create_database] = STATE(10481),
    [sym_create_role] = STATE(10481),
    [sym_create_sequence] = STATE(10481),
    [sym_create_extension] = STATE(10481),
    [sym_create_trigger] = STATE(10481),
    [sym_create_type] = STATE(10481),
    [sym__alter_statement] = STATE(10481),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10481),
    [sym_alter_view] = STATE(10481),
    [sym_alter_schema] = STATE(10481),
    [sym_alter_database] = STATE(10481),
    [sym_alter_role] = STATE(10481),
    [sym_alter_index] = STATE(10481),
    [sym_alter_sequence] = STATE(10481),
    [sym_alter_type] = STATE(10481),
    [sym__drop_statement] = STATE(10481),
    [sym_drop_table] = STATE(10481),
    [sym_drop_view] = STATE(10481),
    [sym_drop_schema] = STATE(10481),
    [sym_drop_database] = STATE(10481),
    [sym_drop_role] = STATE(10481),
    [sym_drop_type] = STATE(10481),
    [sym_drop_sequence] = STATE(10481),
    [sym_drop_index] = STATE(10481),
    [sym_drop_extension] = STATE(10481),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(11076),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10481),
    [sym__compute_stats] = STATE(10481),
    [sym__optimize_table] = STATE(10481),
    [sym__vacuum_table] = STATE(10481),
    [sym_update] = STATE(11074),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1702),
    [sym_keyword_replace] = ACTIONS(1702),
    [sym_keyword_update] = ACTIONS(1704),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(1706),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(1708),
    [sym_keyword_alter] = ACTIONS(1710),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(1714),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(1716),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [130] = {
    [sym__ddl_statement] = STATE(10438),
    [sym__cte] = STATE(6893),
    [sym__dml_write] = STATE(10398),
    [sym__dml_read] = STATE(10418),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10438),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11802),
    [sym__create_statement] = STATE(10438),
    [sym_create_table] = STATE(10438),
    [sym_reset_statement] = STATE(10438),
    [sym_set_statement] = STATE(10438),
    [sym_create_view] = STATE(10438),
    [sym_create_materialized_view] = STATE(10438),
    [sym_create_function] = STATE(10438),
    [sym_create_index] = STATE(10438),
    [sym_create_schema] = STATE(7008),
    [sym_create_database] = STATE(10438),
    [sym_create_role] = STATE(10438),
    [sym_create_sequence] = STATE(10438),
    [sym_create_extension] = STATE(10438),
    [sym_create_trigger] = STATE(10438),
    [sym_create_type] = STATE(10438),
    [sym__alter_statement] = STATE(10438),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10438),
    [sym_alter_view] = STATE(10438),
    [sym_alter_schema] = STATE(10438),
    [sym_alter_database] = STATE(10438),
    [sym_alter_role] = STATE(10438),
    [sym_alter_index] = STATE(10438),
    [sym_alter_sequence] = STATE(10438),
    [sym_alter_type] = STATE(10438),
    [sym__drop_statement] = STATE(10438),
    [sym_drop_table] = STATE(10438),
    [sym_drop_view] = STATE(10438),
    [sym_drop_schema] = STATE(10438),
    [sym_drop_database] = STATE(10438),
    [sym_drop_role] = STATE(10438),
    [sym_drop_type] = STATE(10438),
    [sym_drop_sequence] = STATE(10438),
    [sym_drop_index] = STATE(10438),
    [sym_drop_extension] = STATE(10438),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(11076),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10438),
    [sym__compute_stats] = STATE(10438),
    [sym__optimize_table] = STATE(10438),
    [sym__vacuum_table] = STATE(10438),
    [sym_update] = STATE(11074),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1702),
    [sym_keyword_replace] = ACTIONS(1702),
    [sym_keyword_update] = ACTIONS(1704),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(1706),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(1708),
    [sym_keyword_alter] = ACTIONS(1710),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(1714),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(1716),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [131] = {
    [sym__ddl_statement] = STATE(10481),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10477),
    [sym__dml_read] = STATE(10465),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10481),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10481),
    [sym_create_table] = STATE(10481),
    [sym_reset_statement] = STATE(10481),
    [sym_set_statement] = STATE(10481),
    [sym_create_view] = STATE(10481),
    [sym_create_materialized_view] = STATE(10481),
    [sym_create_function] = STATE(10481),
    [sym_create_index] = STATE(10481),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10481),
    [sym_create_role] = STATE(10481),
    [sym_create_sequence] = STATE(10481),
    [sym_create_extension] = STATE(10481),
    [sym_create_trigger] = STATE(10481),
    [sym_create_type] = STATE(10481),
    [sym__alter_statement] = STATE(10481),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10481),
    [sym_alter_view] = STATE(10481),
    [sym_alter_schema] = STATE(10481),
    [sym_alter_database] = STATE(10481),
    [sym_alter_role] = STATE(10481),
    [sym_alter_index] = STATE(10481),
    [sym_alter_sequence] = STATE(10481),
    [sym_alter_type] = STATE(10481),
    [sym__drop_statement] = STATE(10481),
    [sym_drop_table] = STATE(10481),
    [sym_drop_view] = STATE(10481),
    [sym_drop_schema] = STATE(10481),
    [sym_drop_database] = STATE(10481),
    [sym_drop_role] = STATE(10481),
    [sym_drop_type] = STATE(10481),
    [sym_drop_sequence] = STATE(10481),
    [sym_drop_index] = STATE(10481),
    [sym_drop_extension] = STATE(10481),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10481),
    [sym__compute_stats] = STATE(10481),
    [sym__optimize_table] = STATE(10481),
    [sym__vacuum_table] = STATE(10481),
    [sym_update] = STATE(9854),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [132] = {
    [sym__ddl_statement] = STATE(11350),
    [sym__cte] = STATE(6889),
    [sym__dml_write] = STATE(11349),
    [sym__dml_read] = STATE(11348),
    [sym_set_operation] = STATE(8298),
    [sym__select_statement] = STATE(7622),
    [sym_comment_statement] = STATE(11350),
    [sym_select] = STATE(7513),
    [sym__truncate_statement] = STATE(11390),
    [sym__delete_statement] = STATE(11390),
    [sym_delete] = STATE(11595),
    [sym__create_statement] = STATE(11350),
    [sym_create_table] = STATE(11350),
    [sym_reset_statement] = STATE(11350),
    [sym_set_statement] = STATE(11350),
    [sym_create_view] = STATE(11350),
    [sym_create_materialized_view] = STATE(11350),
    [sym_create_function] = STATE(11350),
    [sym_create_index] = STATE(11350),
    [sym_create_schema] = STATE(6986),
    [sym_create_database] = STATE(11350),
    [sym_create_role] = STATE(11350),
    [sym_create_sequence] = STATE(11350),
    [sym_create_extension] = STATE(11350),
    [sym_create_trigger] = STATE(11350),
    [sym_create_type] = STATE(11350),
    [sym__alter_statement] = STATE(11350),
    [sym__rename_statement] = STATE(11389),
    [sym_alter_table] = STATE(11350),
    [sym_alter_view] = STATE(11350),
    [sym_alter_schema] = STATE(11350),
    [sym_alter_database] = STATE(11350),
    [sym_alter_role] = STATE(11350),
    [sym_alter_index] = STATE(11350),
    [sym_alter_sequence] = STATE(11350),
    [sym_alter_type] = STATE(11350),
    [sym__drop_statement] = STATE(11350),
    [sym_drop_table] = STATE(11350),
    [sym_drop_view] = STATE(11350),
    [sym_drop_schema] = STATE(11350),
    [sym_drop_database] = STATE(11350),
    [sym_drop_role] = STATE(11350),
    [sym_drop_type] = STATE(11350),
    [sym_drop_sequence] = STATE(11350),
    [sym_drop_index] = STATE(11350),
    [sym_drop_extension] = STATE(11350),
    [sym__copy_statement] = STATE(11390),
    [sym__insert_statement] = STATE(11390),
    [sym_insert] = STATE(9562),
    [sym__update_statement] = STATE(11390),
    [sym__merge_statement] = STATE(11387),
    [sym__optimize_statement] = STATE(11350),
    [sym__compute_stats] = STATE(11350),
    [sym__optimize_table] = STATE(11350),
    [sym__vacuum_table] = STATE(11350),
    [sym_update] = STATE(9696),
    [sym_keyword_select] = ACTIONS(1470),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1472),
    [sym_keyword_replace] = ACTIONS(1472),
    [sym_keyword_update] = ACTIONS(1474),
    [sym_keyword_truncate] = ACTIONS(1476),
    [sym_keyword_merge] = ACTIONS(1478),
    [sym_keyword_set] = ACTIONS(1480),
    [sym_keyword_create] = ACTIONS(1482),
    [sym_keyword_alter] = ACTIONS(1484),
    [sym_keyword_analyze] = ACTIONS(1486),
    [sym_keyword_drop] = ACTIONS(1490),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(1492),
    [sym_keyword_reset] = ACTIONS(1494),
    [sym_keyword_vacuum] = ACTIONS(1498),
    [sym_keyword_copy] = ACTIONS(1500),
    [sym_keyword_compute] = ACTIONS(1506),
    [sym_keyword_optimize] = ACTIONS(1508),
    [sym_keyword_comment] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [133] = {
    [sym__ddl_statement] = STATE(10438),
    [sym__cte] = STATE(6881),
    [sym__dml_write] = STATE(10398),
    [sym__dml_read] = STATE(10418),
    [sym_set_operation] = STATE(8014),
    [sym__select_statement] = STATE(7540),
    [sym_comment_statement] = STATE(10438),
    [sym_select] = STATE(7475),
    [sym__truncate_statement] = STATE(10658),
    [sym__delete_statement] = STATE(10658),
    [sym_delete] = STATE(11355),
    [sym__create_statement] = STATE(10438),
    [sym_create_table] = STATE(10438),
    [sym_reset_statement] = STATE(10438),
    [sym_set_statement] = STATE(10438),
    [sym_create_view] = STATE(10438),
    [sym_create_materialized_view] = STATE(10438),
    [sym_create_function] = STATE(10438),
    [sym_create_index] = STATE(10438),
    [sym_create_schema] = STATE(6953),
    [sym_create_database] = STATE(10438),
    [sym_create_role] = STATE(10438),
    [sym_create_sequence] = STATE(10438),
    [sym_create_extension] = STATE(10438),
    [sym_create_trigger] = STATE(10438),
    [sym_create_type] = STATE(10438),
    [sym__alter_statement] = STATE(10438),
    [sym__rename_statement] = STATE(10664),
    [sym_alter_table] = STATE(10438),
    [sym_alter_view] = STATE(10438),
    [sym_alter_schema] = STATE(10438),
    [sym_alter_database] = STATE(10438),
    [sym_alter_role] = STATE(10438),
    [sym_alter_index] = STATE(10438),
    [sym_alter_sequence] = STATE(10438),
    [sym_alter_type] = STATE(10438),
    [sym__drop_statement] = STATE(10438),
    [sym_drop_table] = STATE(10438),
    [sym_drop_view] = STATE(10438),
    [sym_drop_schema] = STATE(10438),
    [sym_drop_database] = STATE(10438),
    [sym_drop_role] = STATE(10438),
    [sym_drop_type] = STATE(10438),
    [sym_drop_sequence] = STATE(10438),
    [sym_drop_index] = STATE(10438),
    [sym_drop_extension] = STATE(10438),
    [sym__copy_statement] = STATE(10658),
    [sym__insert_statement] = STATE(10658),
    [sym_insert] = STATE(9896),
    [sym__update_statement] = STATE(10658),
    [sym__merge_statement] = STATE(10675),
    [sym__optimize_statement] = STATE(10438),
    [sym__compute_stats] = STATE(10438),
    [sym__optimize_table] = STATE(10438),
    [sym__vacuum_table] = STATE(10438),
    [sym_update] = STATE(9854),
    [sym_keyword_select] = ACTIONS(7),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(11),
    [sym_keyword_replace] = ACTIONS(11),
    [sym_keyword_update] = ACTIONS(13),
    [sym_keyword_truncate] = ACTIONS(15),
    [sym_keyword_merge] = ACTIONS(17),
    [sym_keyword_set] = ACTIONS(19),
    [sym_keyword_create] = ACTIONS(21),
    [sym_keyword_alter] = ACTIONS(23),
    [sym_keyword_analyze] = ACTIONS(25),
    [sym_keyword_drop] = ACTIONS(29),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(33),
    [sym_keyword_reset] = ACTIONS(35),
    [sym_keyword_vacuum] = ACTIONS(39),
    [sym_keyword_copy] = ACTIONS(41),
    [sym_keyword_compute] = ACTIONS(43),
    [sym_keyword_optimize] = ACTIONS(45),
    [sym_keyword_comment] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [134] = {
    [sym__ddl_statement] = STATE(11368),
    [sym__cte] = STATE(6889),
    [sym__dml_write] = STATE(11370),
    [sym__dml_read] = STATE(11369),
    [sym_set_operation] = STATE(8298),
    [sym__select_statement] = STATE(7622),
    [sym_comment_statement] = STATE(11368),
    [sym_select] = STATE(7513),
    [sym__truncate_statement] = STATE(11390),
    [sym__delete_statement] = STATE(11390),
    [sym_delete] = STATE(11595),
    [sym__create_statement] = STATE(11368),
    [sym_create_table] = STATE(11368),
    [sym_reset_statement] = STATE(11368),
    [sym_set_statement] = STATE(11368),
    [sym_create_view] = STATE(11368),
    [sym_create_materialized_view] = STATE(11368),
    [sym_create_function] = STATE(11368),
    [sym_create_index] = STATE(11368),
    [sym_create_schema] = STATE(6986),
    [sym_create_database] = STATE(11368),
    [sym_create_role] = STATE(11368),
    [sym_create_sequence] = STATE(11368),
    [sym_create_extension] = STATE(11368),
    [sym_create_trigger] = STATE(11368),
    [sym_create_type] = STATE(11368),
    [sym__alter_statement] = STATE(11368),
    [sym__rename_statement] = STATE(11389),
    [sym_alter_table] = STATE(11368),
    [sym_alter_view] = STATE(11368),
    [sym_alter_schema] = STATE(11368),
    [sym_alter_database] = STATE(11368),
    [sym_alter_role] = STATE(11368),
    [sym_alter_index] = STATE(11368),
    [sym_alter_sequence] = STATE(11368),
    [sym_alter_type] = STATE(11368),
    [sym__drop_statement] = STATE(11368),
    [sym_drop_table] = STATE(11368),
    [sym_drop_view] = STATE(11368),
    [sym_drop_schema] = STATE(11368),
    [sym_drop_database] = STATE(11368),
    [sym_drop_role] = STATE(11368),
    [sym_drop_type] = STATE(11368),
    [sym_drop_sequence] = STATE(11368),
    [sym_drop_index] = STATE(11368),
    [sym_drop_extension] = STATE(11368),
    [sym__copy_statement] = STATE(11390),
    [sym__insert_statement] = STATE(11390),
    [sym_insert] = STATE(9562),
    [sym__update_statement] = STATE(11390),
    [sym__merge_statement] = STATE(11387),
    [sym__optimize_statement] = STATE(11368),
    [sym__compute_stats] = STATE(11368),
    [sym__optimize_table] = STATE(11368),
    [sym__vacuum_table] = STATE(11368),
    [sym_update] = STATE(9696),
    [sym_keyword_select] = ACTIONS(1470),
    [sym_keyword_delete] = ACTIONS(9),
    [sym_keyword_insert] = ACTIONS(1472),
    [sym_keyword_replace] = ACTIONS(1472),
    [sym_keyword_update] = ACTIONS(1474),
    [sym_keyword_truncate] = ACTIONS(1476),
    [sym_keyword_merge] = ACTIONS(1478),
    [sym_keyword_set] = ACTIONS(1480),
    [sym_keyword_create] = ACTIONS(1482),
    [sym_keyword_alter] = ACTIONS(1484),
    [sym_keyword_analyze] = ACTIONS(1486),
    [sym_keyword_drop] = ACTIONS(1490),
    [sym_keyword_with] = ACTIONS(31),
    [sym_keyword_rename] = ACTIONS(1492),
    [sym_keyword_reset] = ACTIONS(1494),
    [sym_keyword_vacuum] = ACTIONS(1498),
    [sym_keyword_copy] = ACTIONS(1500),
    [sym_keyword_compute] = ACTIONS(1506),
    [sym_keyword_optimize] = ACTIONS(1508),
    [sym_keyword_comment] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1700),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym__identifier] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1370),
    [sym_keyword_from] = ACTIONS(1372),
    [sym_keyword_on] = ACTIONS(1372),
    [sym_keyword_limit] = ACTIONS(1372),
    [sym_keyword_offset] = ACTIONS(1372),
    [sym_keyword_create] = ACTIONS(1372),
    [sym_keyword_as] = ACTIONS(1372),
    [sym_keyword_when] = ACTIONS(1372),
    [sym_keyword_in] = ACTIONS(1372),
    [sym_keyword_and] = ACTIONS(1372),
    [sym_keyword_or] = ACTIONS(1372),
    [sym_keyword_is] = ACTIONS(1372),
    [sym_keyword_not] = ACTIONS(1372),
    [sym_keyword_default] = ACTIONS(1372),
    [sym_keyword_cascade] = ACTIONS(1372),
    [sym_keyword_with] = ACTIONS(1372),
    [sym_keyword_password] = ACTIONS(1372),
    [sym_keyword_encrypted] = ACTIONS(1372),
    [sym_keyword_valid] = ACTIONS(1372),
    [sym_keyword_connection] = ACTIONS(1372),
    [sym_keyword_union] = ACTIONS(1372),
    [sym_keyword_except] = ACTIONS(1372),
    [sym_keyword_intersect] = ACTIONS(1372),
    [sym_keyword_returning] = ACTIONS(1372),
    [sym_keyword_rows] = ACTIONS(1372),
    [sym_keyword_between] = ACTIONS(1372),
    [aux_sym_keyword_like_token1] = ACTIONS(1372),
    [aux_sym_keyword_like_token2] = ACTIONS(1372),
    [sym_keyword_similar] = ACTIONS(1372),
    [sym_keyword_check] = ACTIONS(1372),
    [sym_keyword_freeze] = ACTIONS(1372),
    [sym_keyword_escape] = ACTIONS(1372),
    [sym_keyword_encoding] = ACTIONS(1372),
    [sym_keyword_force_quote] = ACTIONS(1372),
    [sym_keyword_quote] = ACTIONS(1372),
    [sym_keyword_force_null] = ACTIONS(1372),
    [sym_keyword_force_not_null] = ACTIONS(1372),
    [sym_keyword_header] = ACTIONS(1372),
    [sym_keyword_returns] = ACTIONS(1372),
    [sym_keyword_language] = ACTIONS(1372),
    [sym_keyword_immutable] = ACTIONS(1372),
    [sym_keyword_stable] = ACTIONS(1372),
    [sym_keyword_volatile] = ACTIONS(1372),
    [sym_keyword_leakproof] = ACTIONS(1372),
    [sym_keyword_parallel] = ACTIONS(1372),
    [sym_keyword_called] = ACTIONS(1372),
    [sym_keyword_strict] = ACTIONS(1372),
    [sym_keyword_cost] = ACTIONS(1372),
    [sym_keyword_support] = ACTIONS(1372),
    [sym_keyword_security] = ACTIONS(1372),
    [sym_keyword_external] = ACTIONS(1372),
    [sym_keyword_format] = ACTIONS(1372),
    [sym_keyword_delimiter] = ACTIONS(1372),
    [sym_keyword_null] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_RPAREN] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [sym_op_other] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_LT_GT] = ACTIONS(1370),
    [sym__double_quote_string] = ACTIONS(1370),
    [aux_sym_identifier_token1] = ACTIONS(1370),
  },
  [136] = {
    [sym__identifier] = ACTIONS(1746),
    [sym_keyword_on] = ACTIONS(1746),
    [sym_keyword_desc] = ACTIONS(1746),
    [sym_keyword_asc] = ACTIONS(1746),
    [sym_keyword_collate] = ACTIONS(1746),
    [aux_sym_keyword_character_token1] = ACTIONS(1746),
    [sym_keyword_nulls] = ACTIONS(1746),
    [sym_keyword_unsigned] = ACTIONS(1746),
    [sym_keyword_boolean] = ACTIONS(1746),
    [sym_keyword_bit] = ACTIONS(1746),
    [sym_keyword_binary] = ACTIONS(1746),
    [sym_keyword_varbinary] = ACTIONS(1746),
    [sym_keyword_image] = ACTIONS(1746),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1746),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1746),
    [aux_sym_keyword_serial_token1] = ACTIONS(1746),
    [aux_sym_keyword_serial_token2] = ACTIONS(1746),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1746),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1746),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1746),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1746),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1746),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1746),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1746),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1746),
    [aux_sym_keyword_int_token1] = ACTIONS(1746),
    [aux_sym_keyword_int_token2] = ACTIONS(1746),
    [aux_sym_keyword_int_token3] = ACTIONS(1746),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1746),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1746),
    [sym_keyword_decimal] = ACTIONS(1746),
    [sym_keyword_numeric] = ACTIONS(1746),
    [aux_sym_keyword_real_token1] = ACTIONS(1746),
    [aux_sym_keyword_real_token2] = ACTIONS(1746),
    [sym_keyword_float] = ACTIONS(1746),
    [sym_keyword_double] = ACTIONS(1746),
    [sym_keyword_inet] = ACTIONS(1746),
    [sym_keyword_money] = ACTIONS(1746),
    [sym_keyword_smallmoney] = ACTIONS(1746),
    [aux_sym_keyword_char_token1] = ACTIONS(1746),
    [sym_keyword_nchar] = ACTIONS(1746),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1746),
    [sym_keyword_nvarchar] = ACTIONS(1746),
    [sym_keyword_text] = ACTIONS(1746),
    [sym_keyword_string] = ACTIONS(1746),
    [sym_keyword_uuid] = ACTIONS(1746),
    [sym_keyword_json] = ACTIONS(1746),
    [sym_keyword_jsonb] = ACTIONS(1746),
    [sym_keyword_xml] = ACTIONS(1746),
    [sym_keyword_bytea] = ACTIONS(1746),
    [sym_keyword_enum] = ACTIONS(1746),
    [sym_keyword_date] = ACTIONS(1746),
    [sym_keyword_datetime] = ACTIONS(1746),
    [sym_keyword_datetime2] = ACTIONS(1746),
    [sym_keyword_smalldatetime] = ACTIONS(1746),
    [sym_keyword_datetimeoffset] = ACTIONS(1746),
    [sym_keyword_time] = ACTIONS(1746),
    [sym_keyword_timestamp] = ACTIONS(1746),
    [sym_keyword_timestamptz] = ACTIONS(1746),
    [sym_keyword_interval] = ACTIONS(1746),
    [sym_keyword_geometry] = ACTIONS(1746),
    [sym_keyword_geography] = ACTIONS(1746),
    [sym_keyword_box2d] = ACTIONS(1746),
    [sym_keyword_box3d] = ACTIONS(1746),
    [sym_keyword_oid] = ACTIONS(1746),
    [sym_keyword_name] = ACTIONS(1746),
    [sym_keyword_regclass] = ACTIONS(1746),
    [sym_keyword_regnamespace] = ACTIONS(1746),
    [sym_keyword_regproc] = ACTIONS(1746),
    [sym_keyword_regtype] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [anon_sym_COMMA] = ACTIONS(1748),
    [aux_sym_double_token1] = ACTIONS(1746),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1748),
    [aux_sym_identifier_token1] = ACTIONS(1748),
  },
  [137] = {
    [sym__identifier] = ACTIONS(1666),
    [sym_keyword_on] = ACTIONS(1666),
    [sym_keyword_desc] = ACTIONS(1666),
    [sym_keyword_asc] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_COMMA] = ACTIONS(1682),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [138] = {
    [aux_sym_set_statement_repeat1] = STATE(11199),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [139] = {
    [aux_sym_set_statement_repeat1] = STATE(10906),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [140] = {
    [aux_sym_set_statement_repeat1] = STATE(10843),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1758),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [141] = {
    [aux_sym_set_statement_repeat1] = STATE(10262),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [142] = {
    [aux_sym_set_statement_repeat1] = STATE(10868),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [143] = {
    [aux_sym_set_statement_repeat1] = STATE(10411),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1764),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [144] = {
    [aux_sym_set_statement_repeat1] = STATE(11103),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1766),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [145] = {
    [aux_sym_set_statement_repeat1] = STATE(10552),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [146] = {
    [aux_sym_set_statement_repeat1] = STATE(10671),
    [sym__identifier] = ACTIONS(1666),
    [aux_sym_keyword_character_token1] = ACTIONS(1666),
    [sym_keyword_unsigned] = ACTIONS(1666),
    [sym_keyword_boolean] = ACTIONS(1666),
    [sym_keyword_bit] = ACTIONS(1666),
    [sym_keyword_binary] = ACTIONS(1666),
    [sym_keyword_varbinary] = ACTIONS(1666),
    [sym_keyword_image] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_serial_token1] = ACTIONS(1666),
    [aux_sym_keyword_serial_token2] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1666),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1666),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1666),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token1] = ACTIONS(1666),
    [aux_sym_keyword_int_token2] = ACTIONS(1666),
    [aux_sym_keyword_int_token3] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1666),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1666),
    [sym_keyword_decimal] = ACTIONS(1666),
    [sym_keyword_numeric] = ACTIONS(1666),
    [aux_sym_keyword_real_token1] = ACTIONS(1666),
    [aux_sym_keyword_real_token2] = ACTIONS(1666),
    [sym_keyword_float] = ACTIONS(1666),
    [sym_keyword_double] = ACTIONS(1666),
    [sym_keyword_inet] = ACTIONS(1666),
    [sym_keyword_money] = ACTIONS(1666),
    [sym_keyword_smallmoney] = ACTIONS(1666),
    [aux_sym_keyword_char_token1] = ACTIONS(1666),
    [sym_keyword_nchar] = ACTIONS(1666),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1666),
    [sym_keyword_nvarchar] = ACTIONS(1666),
    [sym_keyword_text] = ACTIONS(1666),
    [sym_keyword_string] = ACTIONS(1666),
    [sym_keyword_uuid] = ACTIONS(1666),
    [sym_keyword_json] = ACTIONS(1666),
    [sym_keyword_jsonb] = ACTIONS(1666),
    [sym_keyword_xml] = ACTIONS(1666),
    [sym_keyword_bytea] = ACTIONS(1666),
    [sym_keyword_enum] = ACTIONS(1666),
    [sym_keyword_date] = ACTIONS(1666),
    [sym_keyword_datetime] = ACTIONS(1666),
    [sym_keyword_datetime2] = ACTIONS(1666),
    [sym_keyword_smalldatetime] = ACTIONS(1666),
    [sym_keyword_datetimeoffset] = ACTIONS(1666),
    [sym_keyword_time] = ACTIONS(1666),
    [sym_keyword_timestamp] = ACTIONS(1666),
    [sym_keyword_timestamptz] = ACTIONS(1666),
    [sym_keyword_interval] = ACTIONS(1666),
    [sym_keyword_geometry] = ACTIONS(1666),
    [sym_keyword_geography] = ACTIONS(1666),
    [sym_keyword_box2d] = ACTIONS(1666),
    [sym_keyword_box3d] = ACTIONS(1666),
    [sym_keyword_oid] = ACTIONS(1666),
    [sym_keyword_name] = ACTIONS(1666),
    [sym_keyword_regclass] = ACTIONS(1666),
    [sym_keyword_regnamespace] = ACTIONS(1666),
    [sym_keyword_regproc] = ACTIONS(1666),
    [sym_keyword_regtype] = ACTIONS(1666),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [anon_sym_COMMA] = ACTIONS(1752),
    [aux_sym_double_token1] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1754),
    [sym__double_quote_string] = ACTIONS(1682),
    [aux_sym_identifier_token1] = ACTIONS(1682),
  },
  [147] = {
    [sym__include_time_zone] = STATE(224),
    [ts_builtin_sym_end] = ACTIONS(1772),
    [anon_sym_SEMI] = ACTIONS(1772),
    [sym_keyword_from] = ACTIONS(1772),
    [sym_keyword_on] = ACTIONS(1772),
    [sym_keyword_where] = ACTIONS(1772),
    [sym_keyword_desc] = ACTIONS(1772),
    [sym_keyword_asc] = ACTIONS(1772),
    [sym_keyword_limit] = ACTIONS(1772),
    [sym_keyword_primary] = ACTIONS(1772),
    [sym_keyword_create] = ACTIONS(1772),
    [sym_keyword_as] = ACTIONS(1774),
    [sym_keyword_constraint] = ACTIONS(1772),
    [sym_keyword_separator] = ACTIONS(1772),
    [sym_keyword_when] = ACTIONS(1772),
    [sym_keyword_then] = ACTIONS(1772),
    [sym_keyword_else] = ACTIONS(1772),
    [sym_keyword_end] = ACTIONS(1772),
    [sym_keyword_in] = ACTIONS(1772),
    [sym_keyword_and] = ACTIONS(1772),
    [sym_keyword_or] = ACTIONS(1772),
    [sym_keyword_is] = ACTIONS(1772),
    [sym_keyword_not] = ACTIONS(1772),
    [sym_keyword_using] = ACTIONS(1772),
    [sym_keyword_auto_increment] = ACTIONS(1772),
    [sym_keyword_generated] = ACTIONS(1772),
    [sym_keyword_default] = ACTIONS(1772),
    [sym_keyword_with] = ACTIONS(1776),
    [sym_keyword_without] = ACTIONS(1778),
    [sym_keyword_returning] = ACTIONS(1772),
    [sym_keyword_first] = ACTIONS(1772),
    [sym_keyword_after] = ACTIONS(1772),
    [sym_keyword_range] = ACTIONS(1772),
    [sym_keyword_rows] = ACTIONS(1772),
    [sym_keyword_groups] = ACTIONS(1772),
    [sym_keyword_between] = ACTIONS(1772),
    [sym_keyword_preceding] = ACTIONS(1772),
    [sym_keyword_following] = ACTIONS(1772),
    [sym_keyword_unique] = ACTIONS(1772),
    [sym_keyword_references] = ACTIONS(1772),
    [aux_sym_keyword_like_token1] = ACTIONS(1772),
    [aux_sym_keyword_like_token2] = ACTIONS(1772),
    [sym_keyword_similar] = ACTIONS(1772),
    [sym_keyword_check] = ACTIONS(1772),
    [sym_keyword_stored] = ACTIONS(1772),
    [sym_keyword_virtual] = ACTIONS(1772),
    [sym_keyword_comment] = ACTIONS(1772),
    [sym_keyword_null] = ACTIONS(1772),
    [sym_keyword_array] = ACTIONS(1772),
    [anon_sym_LBRACK] = ACTIONS(1772),
    [anon_sym_RBRACK] = ACTIONS(1772),
    [anon_sym_LPAREN] = ACTIONS(1780),
    [anon_sym_RPAREN] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1772),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_COLON_COLON] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1774),
    [anon_sym_LT_EQ] = ACTIONS(1772),
    [anon_sym_GT_EQ] = ACTIONS(1772),
    [anon_sym_COLON] = ACTIONS(1774),
    [sym_op_other] = ACTIONS(1772),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1774),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_CARET] = ACTIONS(1774),
    [anon_sym_BANG_EQ] = ACTIONS(1772),
    [anon_sym_LT_GT] = ACTIONS(1772),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(1782),
    [anon_sym_SEMI] = ACTIONS(1782),
    [sym_keyword_from] = ACTIONS(1782),
    [sym_keyword_on] = ACTIONS(1782),
    [sym_keyword_where] = ACTIONS(1782),
    [sym_keyword_desc] = ACTIONS(1782),
    [sym_keyword_asc] = ACTIONS(1782),
    [sym_keyword_limit] = ACTIONS(1782),
    [sym_keyword_primary] = ACTIONS(1782),
    [sym_keyword_create] = ACTIONS(1782),
    [sym_keyword_as] = ACTIONS(1784),
    [sym_keyword_constraint] = ACTIONS(1782),
    [sym_keyword_separator] = ACTIONS(1782),
    [sym_keyword_when] = ACTIONS(1782),
    [sym_keyword_then] = ACTIONS(1782),
    [sym_keyword_else] = ACTIONS(1782),
    [sym_keyword_end] = ACTIONS(1782),
    [sym_keyword_in] = ACTIONS(1782),
    [sym_keyword_and] = ACTIONS(1782),
    [sym_keyword_or] = ACTIONS(1782),
    [sym_keyword_is] = ACTIONS(1782),
    [sym_keyword_not] = ACTIONS(1782),
    [sym_keyword_using] = ACTIONS(1782),
    [sym_keyword_auto_increment] = ACTIONS(1782),
    [sym_keyword_generated] = ACTIONS(1782),
    [sym_keyword_default] = ACTIONS(1782),
    [sym_keyword_returning] = ACTIONS(1782),
    [sym_keyword_first] = ACTIONS(1782),
    [sym_keyword_after] = ACTIONS(1782),
    [sym_keyword_range] = ACTIONS(1782),
    [sym_keyword_rows] = ACTIONS(1782),
    [sym_keyword_groups] = ACTIONS(1782),
    [sym_keyword_between] = ACTIONS(1782),
    [sym_keyword_preceding] = ACTIONS(1782),
    [sym_keyword_following] = ACTIONS(1782),
    [sym_keyword_unique] = ACTIONS(1782),
    [sym_keyword_references] = ACTIONS(1782),
    [aux_sym_keyword_like_token1] = ACTIONS(1782),
    [aux_sym_keyword_like_token2] = ACTIONS(1782),
    [sym_keyword_similar] = ACTIONS(1782),
    [sym_keyword_unsigned] = ACTIONS(1786),
    [sym_keyword_zerofill] = ACTIONS(1788),
    [sym_keyword_check] = ACTIONS(1782),
    [sym_keyword_stored] = ACTIONS(1782),
    [sym_keyword_virtual] = ACTIONS(1782),
    [sym_keyword_comment] = ACTIONS(1782),
    [sym_keyword_null] = ACTIONS(1782),
    [sym_keyword_precision] = ACTIONS(1790),
    [sym_keyword_array] = ACTIONS(1782),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_RBRACK] = ACTIONS(1782),
    [anon_sym_LPAREN] = ACTIONS(1792),
    [anon_sym_RPAREN] = ACTIONS(1782),
    [anon_sym_COMMA] = ACTIONS(1782),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1782),
    [anon_sym_STAR] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_GT] = ACTIONS(1784),
    [anon_sym_LT_EQ] = ACTIONS(1782),
    [anon_sym_GT_EQ] = ACTIONS(1782),
    [anon_sym_COLON] = ACTIONS(1784),
    [sym_op_other] = ACTIONS(1782),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1784),
    [anon_sym_SLASH] = ACTIONS(1784),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_CARET] = ACTIONS(1784),
    [anon_sym_BANG_EQ] = ACTIONS(1782),
    [anon_sym_LT_GT] = ACTIONS(1782),
  },
  [149] = {
    [sym__include_time_zone] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1794),
    [anon_sym_SEMI] = ACTIONS(1794),
    [sym_keyword_from] = ACTIONS(1794),
    [sym_keyword_on] = ACTIONS(1794),
    [sym_keyword_where] = ACTIONS(1794),
    [sym_keyword_desc] = ACTIONS(1794),
    [sym_keyword_asc] = ACTIONS(1794),
    [sym_keyword_limit] = ACTIONS(1794),
    [sym_keyword_primary] = ACTIONS(1794),
    [sym_keyword_create] = ACTIONS(1794),
    [sym_keyword_as] = ACTIONS(1796),
    [sym_keyword_constraint] = ACTIONS(1794),
    [sym_keyword_separator] = ACTIONS(1794),
    [sym_keyword_when] = ACTIONS(1794),
    [sym_keyword_then] = ACTIONS(1794),
    [sym_keyword_else] = ACTIONS(1794),
    [sym_keyword_end] = ACTIONS(1794),
    [sym_keyword_in] = ACTIONS(1794),
    [sym_keyword_and] = ACTIONS(1794),
    [sym_keyword_or] = ACTIONS(1794),
    [sym_keyword_is] = ACTIONS(1794),
    [sym_keyword_not] = ACTIONS(1794),
    [sym_keyword_using] = ACTIONS(1794),
    [sym_keyword_auto_increment] = ACTIONS(1794),
    [sym_keyword_generated] = ACTIONS(1794),
    [sym_keyword_default] = ACTIONS(1794),
    [sym_keyword_with] = ACTIONS(1776),
    [sym_keyword_without] = ACTIONS(1778),
    [sym_keyword_returning] = ACTIONS(1794),
    [sym_keyword_first] = ACTIONS(1794),
    [sym_keyword_after] = ACTIONS(1794),
    [sym_keyword_range] = ACTIONS(1794),
    [sym_keyword_rows] = ACTIONS(1794),
    [sym_keyword_groups] = ACTIONS(1794),
    [sym_keyword_between] = ACTIONS(1794),
    [sym_keyword_preceding] = ACTIONS(1794),
    [sym_keyword_following] = ACTIONS(1794),
    [sym_keyword_unique] = ACTIONS(1794),
    [sym_keyword_references] = ACTIONS(1794),
    [aux_sym_keyword_like_token1] = ACTIONS(1794),
    [aux_sym_keyword_like_token2] = ACTIONS(1794),
    [sym_keyword_similar] = ACTIONS(1794),
    [sym_keyword_check] = ACTIONS(1794),
    [sym_keyword_stored] = ACTIONS(1794),
    [sym_keyword_virtual] = ACTIONS(1794),
    [sym_keyword_comment] = ACTIONS(1794),
    [sym_keyword_null] = ACTIONS(1794),
    [sym_keyword_array] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_RBRACK] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1794),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_COLON_COLON] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1796),
    [anon_sym_GT] = ACTIONS(1796),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_COLON] = ACTIONS(1796),
    [sym_op_other] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1796),
    [anon_sym_SLASH] = ACTIONS(1796),
    [anon_sym_PERCENT] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(1796),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(1794),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1800),
    [sym_keyword_from] = ACTIONS(1800),
    [sym_keyword_on] = ACTIONS(1800),
    [sym_keyword_where] = ACTIONS(1800),
    [sym_keyword_desc] = ACTIONS(1800),
    [sym_keyword_asc] = ACTIONS(1800),
    [sym_keyword_limit] = ACTIONS(1800),
    [sym_keyword_primary] = ACTIONS(1800),
    [sym_keyword_create] = ACTIONS(1800),
    [sym_keyword_as] = ACTIONS(1802),
    [sym_keyword_constraint] = ACTIONS(1800),
    [sym_keyword_separator] = ACTIONS(1800),
    [sym_keyword_when] = ACTIONS(1800),
    [sym_keyword_then] = ACTIONS(1800),
    [sym_keyword_else] = ACTIONS(1800),
    [sym_keyword_end] = ACTIONS(1800),
    [sym_keyword_in] = ACTIONS(1800),
    [sym_keyword_and] = ACTIONS(1800),
    [sym_keyword_or] = ACTIONS(1800),
    [sym_keyword_is] = ACTIONS(1800),
    [sym_keyword_not] = ACTIONS(1800),
    [sym_keyword_using] = ACTIONS(1800),
    [sym_keyword_auto_increment] = ACTIONS(1800),
    [sym_keyword_generated] = ACTIONS(1800),
    [sym_keyword_default] = ACTIONS(1800),
    [sym_keyword_returning] = ACTIONS(1800),
    [sym_keyword_first] = ACTIONS(1800),
    [sym_keyword_after] = ACTIONS(1800),
    [sym_keyword_range] = ACTIONS(1800),
    [sym_keyword_rows] = ACTIONS(1800),
    [sym_keyword_groups] = ACTIONS(1800),
    [sym_keyword_between] = ACTIONS(1800),
    [sym_keyword_preceding] = ACTIONS(1800),
    [sym_keyword_following] = ACTIONS(1800),
    [sym_keyword_unique] = ACTIONS(1800),
    [sym_keyword_references] = ACTIONS(1800),
    [aux_sym_keyword_like_token1] = ACTIONS(1800),
    [aux_sym_keyword_like_token2] = ACTIONS(1800),
    [sym_keyword_similar] = ACTIONS(1800),
    [sym_keyword_unsigned] = ACTIONS(1800),
    [sym_keyword_zerofill] = ACTIONS(1800),
    [sym_keyword_check] = ACTIONS(1800),
    [sym_keyword_stored] = ACTIONS(1800),
    [sym_keyword_virtual] = ACTIONS(1800),
    [sym_keyword_comment] = ACTIONS(1800),
    [sym_keyword_null] = ACTIONS(1800),
    [sym_keyword_array] = ACTIONS(1800),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_RBRACK] = ACTIONS(1800),
    [anon_sym_LPAREN] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_COLON_COLON] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1802),
    [anon_sym_GT] = ACTIONS(1802),
    [anon_sym_LT_EQ] = ACTIONS(1800),
    [anon_sym_GT_EQ] = ACTIONS(1800),
    [anon_sym_COLON] = ACTIONS(1802),
    [sym_op_other] = ACTIONS(1800),
    [anon_sym_PLUS] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1802),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_PERCENT] = ACTIONS(1800),
    [anon_sym_CARET] = ACTIONS(1802),
    [anon_sym_BANG_EQ] = ACTIONS(1800),
    [anon_sym_LT_GT] = ACTIONS(1800),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1804),
    [sym_keyword_from] = ACTIONS(1804),
    [sym_keyword_on] = ACTIONS(1804),
    [sym_keyword_where] = ACTIONS(1804),
    [sym_keyword_desc] = ACTIONS(1804),
    [sym_keyword_asc] = ACTIONS(1804),
    [sym_keyword_limit] = ACTIONS(1804),
    [sym_keyword_primary] = ACTIONS(1804),
    [sym_keyword_create] = ACTIONS(1804),
    [sym_keyword_as] = ACTIONS(1806),
    [sym_keyword_constraint] = ACTIONS(1804),
    [sym_keyword_separator] = ACTIONS(1804),
    [sym_keyword_when] = ACTIONS(1804),
    [sym_keyword_then] = ACTIONS(1804),
    [sym_keyword_else] = ACTIONS(1804),
    [sym_keyword_end] = ACTIONS(1804),
    [sym_keyword_in] = ACTIONS(1804),
    [sym_keyword_and] = ACTIONS(1804),
    [sym_keyword_or] = ACTIONS(1804),
    [sym_keyword_is] = ACTIONS(1804),
    [sym_keyword_not] = ACTIONS(1804),
    [sym_keyword_using] = ACTIONS(1804),
    [sym_keyword_auto_increment] = ACTIONS(1804),
    [sym_keyword_generated] = ACTIONS(1804),
    [sym_keyword_default] = ACTIONS(1804),
    [sym_keyword_returning] = ACTIONS(1804),
    [sym_keyword_first] = ACTIONS(1804),
    [sym_keyword_after] = ACTIONS(1804),
    [sym_keyword_range] = ACTIONS(1804),
    [sym_keyword_rows] = ACTIONS(1804),
    [sym_keyword_groups] = ACTIONS(1804),
    [sym_keyword_between] = ACTIONS(1804),
    [sym_keyword_preceding] = ACTIONS(1804),
    [sym_keyword_following] = ACTIONS(1804),
    [sym_keyword_unique] = ACTIONS(1804),
    [sym_keyword_references] = ACTIONS(1804),
    [aux_sym_keyword_like_token1] = ACTIONS(1804),
    [aux_sym_keyword_like_token2] = ACTIONS(1804),
    [sym_keyword_similar] = ACTIONS(1804),
    [sym_keyword_unsigned] = ACTIONS(1804),
    [sym_keyword_zerofill] = ACTIONS(1804),
    [sym_keyword_check] = ACTIONS(1804),
    [sym_keyword_stored] = ACTIONS(1804),
    [sym_keyword_virtual] = ACTIONS(1804),
    [sym_keyword_comment] = ACTIONS(1804),
    [sym_keyword_null] = ACTIONS(1804),
    [sym_keyword_array] = ACTIONS(1804),
    [anon_sym_LBRACK] = ACTIONS(1804),
    [anon_sym_RBRACK] = ACTIONS(1804),
    [anon_sym_LPAREN] = ACTIONS(1804),
    [anon_sym_RPAREN] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(1804),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_COLON_COLON] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(1806),
    [anon_sym_GT] = ACTIONS(1806),
    [anon_sym_LT_EQ] = ACTIONS(1804),
    [anon_sym_GT_EQ] = ACTIONS(1804),
    [anon_sym_COLON] = ACTIONS(1806),
    [sym_op_other] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_DASH] = ACTIONS(1806),
    [anon_sym_SLASH] = ACTIONS(1806),
    [anon_sym_PERCENT] = ACTIONS(1804),
    [anon_sym_CARET] = ACTIONS(1806),
    [anon_sym_BANG_EQ] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(1804),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1808),
    [sym_keyword_from] = ACTIONS(1808),
    [sym_keyword_on] = ACTIONS(1808),
    [sym_keyword_where] = ACTIONS(1808),
    [sym_keyword_desc] = ACTIONS(1808),
    [sym_keyword_asc] = ACTIONS(1808),
    [sym_keyword_limit] = ACTIONS(1808),
    [sym_keyword_primary] = ACTIONS(1808),
    [sym_keyword_create] = ACTIONS(1808),
    [sym_keyword_as] = ACTIONS(1810),
    [sym_keyword_constraint] = ACTIONS(1808),
    [sym_keyword_separator] = ACTIONS(1808),
    [sym_keyword_when] = ACTIONS(1808),
    [sym_keyword_then] = ACTIONS(1808),
    [sym_keyword_else] = ACTIONS(1808),
    [sym_keyword_end] = ACTIONS(1808),
    [sym_keyword_in] = ACTIONS(1808),
    [sym_keyword_and] = ACTIONS(1808),
    [sym_keyword_or] = ACTIONS(1808),
    [sym_keyword_is] = ACTIONS(1808),
    [sym_keyword_not] = ACTIONS(1808),
    [sym_keyword_using] = ACTIONS(1808),
    [sym_keyword_auto_increment] = ACTIONS(1808),
    [sym_keyword_generated] = ACTIONS(1808),
    [sym_keyword_default] = ACTIONS(1808),
    [sym_keyword_returning] = ACTIONS(1808),
    [sym_keyword_first] = ACTIONS(1808),
    [sym_keyword_after] = ACTIONS(1808),
    [sym_keyword_range] = ACTIONS(1808),
    [sym_keyword_rows] = ACTIONS(1808),
    [sym_keyword_groups] = ACTIONS(1808),
    [sym_keyword_between] = ACTIONS(1808),
    [sym_keyword_preceding] = ACTIONS(1808),
    [sym_keyword_following] = ACTIONS(1808),
    [sym_keyword_unique] = ACTIONS(1808),
    [sym_keyword_references] = ACTIONS(1808),
    [aux_sym_keyword_like_token1] = ACTIONS(1808),
    [aux_sym_keyword_like_token2] = ACTIONS(1808),
    [sym_keyword_similar] = ACTIONS(1808),
    [sym_keyword_unsigned] = ACTIONS(1812),
    [sym_keyword_zerofill] = ACTIONS(1814),
    [sym_keyword_check] = ACTIONS(1808),
    [sym_keyword_stored] = ACTIONS(1808),
    [sym_keyword_virtual] = ACTIONS(1808),
    [sym_keyword_comment] = ACTIONS(1808),
    [sym_keyword_null] = ACTIONS(1808),
    [sym_keyword_array] = ACTIONS(1808),
    [anon_sym_LBRACK] = ACTIONS(1808),
    [anon_sym_RBRACK] = ACTIONS(1808),
    [anon_sym_LPAREN] = ACTIONS(1816),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_COMMA] = ACTIONS(1808),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_COLON_COLON] = ACTIONS(1808),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_GT] = ACTIONS(1810),
    [anon_sym_LT_EQ] = ACTIONS(1808),
    [anon_sym_GT_EQ] = ACTIONS(1808),
    [anon_sym_COLON] = ACTIONS(1810),
    [sym_op_other] = ACTIONS(1808),
    [anon_sym_PLUS] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_SLASH] = ACTIONS(1810),
    [anon_sym_PERCENT] = ACTIONS(1808),
    [anon_sym_CARET] = ACTIONS(1810),
    [anon_sym_BANG_EQ] = ACTIONS(1808),
    [anon_sym_LT_GT] = ACTIONS(1808),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [sym_keyword_from] = ACTIONS(1818),
    [sym_keyword_on] = ACTIONS(1818),
    [sym_keyword_where] = ACTIONS(1818),
    [sym_keyword_desc] = ACTIONS(1818),
    [sym_keyword_asc] = ACTIONS(1818),
    [sym_keyword_limit] = ACTIONS(1818),
    [sym_keyword_primary] = ACTIONS(1818),
    [sym_keyword_create] = ACTIONS(1818),
    [sym_keyword_as] = ACTIONS(1820),
    [sym_keyword_constraint] = ACTIONS(1818),
    [sym_keyword_separator] = ACTIONS(1818),
    [sym_keyword_when] = ACTIONS(1818),
    [sym_keyword_then] = ACTIONS(1818),
    [sym_keyword_else] = ACTIONS(1818),
    [sym_keyword_end] = ACTIONS(1818),
    [sym_keyword_in] = ACTIONS(1818),
    [sym_keyword_and] = ACTIONS(1818),
    [sym_keyword_or] = ACTIONS(1818),
    [sym_keyword_is] = ACTIONS(1818),
    [sym_keyword_not] = ACTIONS(1818),
    [sym_keyword_using] = ACTIONS(1818),
    [sym_keyword_auto_increment] = ACTIONS(1818),
    [sym_keyword_generated] = ACTIONS(1818),
    [sym_keyword_default] = ACTIONS(1818),
    [sym_keyword_returning] = ACTIONS(1818),
    [sym_keyword_first] = ACTIONS(1818),
    [sym_keyword_after] = ACTIONS(1818),
    [sym_keyword_range] = ACTIONS(1818),
    [sym_keyword_rows] = ACTIONS(1818),
    [sym_keyword_groups] = ACTIONS(1818),
    [sym_keyword_between] = ACTIONS(1818),
    [sym_keyword_preceding] = ACTIONS(1818),
    [sym_keyword_following] = ACTIONS(1818),
    [sym_keyword_unique] = ACTIONS(1818),
    [sym_keyword_references] = ACTIONS(1818),
    [aux_sym_keyword_like_token1] = ACTIONS(1818),
    [aux_sym_keyword_like_token2] = ACTIONS(1818),
    [sym_keyword_similar] = ACTIONS(1818),
    [sym_keyword_unsigned] = ACTIONS(1822),
    [sym_keyword_zerofill] = ACTIONS(1824),
    [sym_keyword_check] = ACTIONS(1818),
    [sym_keyword_stored] = ACTIONS(1818),
    [sym_keyword_virtual] = ACTIONS(1818),
    [sym_keyword_comment] = ACTIONS(1818),
    [sym_keyword_null] = ACTIONS(1818),
    [sym_keyword_array] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1818),
    [anon_sym_RBRACK] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_COMMA] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_COLON_COLON] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_LT_EQ] = ACTIONS(1818),
    [anon_sym_GT_EQ] = ACTIONS(1818),
    [anon_sym_COLON] = ACTIONS(1820),
    [sym_op_other] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1820),
    [anon_sym_SLASH] = ACTIONS(1820),
    [anon_sym_PERCENT] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1820),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_LT_GT] = ACTIONS(1818),
  },
  [154] = {
    [sym__identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_keyword_set] = ACTIONS(1376),
    [sym_keyword_where] = ACTIONS(1376),
    [sym_keyword_order] = ACTIONS(1376),
    [sym_keyword_group] = ACTIONS(1376),
    [sym_keyword_having] = ACTIONS(1376),
    [sym_keyword_desc] = ACTIONS(1376),
    [sym_keyword_asc] = ACTIONS(1376),
    [sym_keyword_limit] = ACTIONS(1376),
    [sym_keyword_primary] = ACTIONS(1376),
    [sym_keyword_create] = ACTIONS(1376),
    [sym_keyword_as] = ACTIONS(1376),
    [sym_keyword_constraint] = ACTIONS(1376),
    [sym_keyword_in] = ACTIONS(1376),
    [sym_keyword_and] = ACTIONS(1376),
    [sym_keyword_or] = ACTIONS(1376),
    [sym_keyword_is] = ACTIONS(1376),
    [sym_keyword_not] = ACTIONS(1376),
    [sym_keyword_auto_increment] = ACTIONS(1376),
    [sym_keyword_generated] = ACTIONS(1376),
    [sym_keyword_default] = ACTIONS(1376),
    [sym_keyword_with] = ACTIONS(1376),
    [sym_keyword_rename] = ACTIONS(1376),
    [sym_keyword_user] = ACTIONS(1376),
    [sym_keyword_admin] = ACTIONS(1376),
    [sym_keyword_password] = ACTIONS(1376),
    [sym_keyword_encrypted] = ACTIONS(1376),
    [sym_keyword_valid] = ACTIONS(1376),
    [sym_keyword_connection] = ACTIONS(1376),
    [sym_keyword_role] = ACTIONS(1376),
    [sym_keyword_reset] = ACTIONS(1376),
    [sym_keyword_returning] = ACTIONS(1376),
    [sym_keyword_first] = ACTIONS(1376),
    [sym_keyword_after] = ACTIONS(1376),
    [sym_keyword_window] = ACTIONS(1376),
    [sym_keyword_between] = ACTIONS(1376),
    [sym_keyword_unique] = ACTIONS(1376),
    [sym_keyword_references] = ACTIONS(1376),
    [aux_sym_keyword_like_token1] = ACTIONS(1376),
    [aux_sym_keyword_like_token2] = ACTIONS(1376),
    [sym_keyword_similar] = ACTIONS(1376),
    [sym_keyword_check] = ACTIONS(1376),
    [sym_keyword_stored] = ACTIONS(1376),
    [sym_keyword_virtual] = ACTIONS(1376),
    [sym_keyword_comment] = ACTIONS(1376),
    [sym_keyword_null] = ACTIONS(1376),
    [sym_keyword_array] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [sym_op_other] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_LT_GT] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1374),
    [aux_sym_identifier_token1] = ACTIONS(1374),
    [sym__dollar_quoted_string_end_tag] = ACTIONS(1374),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1828),
    [sym_keyword_from] = ACTIONS(1828),
    [sym_keyword_on] = ACTIONS(1828),
    [sym_keyword_where] = ACTIONS(1828),
    [sym_keyword_desc] = ACTIONS(1828),
    [sym_keyword_asc] = ACTIONS(1828),
    [sym_keyword_limit] = ACTIONS(1828),
    [sym_keyword_primary] = ACTIONS(1828),
    [sym_keyword_create] = ACTIONS(1828),
    [sym_keyword_as] = ACTIONS(1830),
    [sym_keyword_constraint] = ACTIONS(1828),
    [sym_keyword_separator] = ACTIONS(1828),
    [sym_keyword_when] = ACTIONS(1828),
    [sym_keyword_then] = ACTIONS(1828),
    [sym_keyword_else] = ACTIONS(1828),
    [sym_keyword_end] = ACTIONS(1828),
    [sym_keyword_in] = ACTIONS(1828),
    [sym_keyword_and] = ACTIONS(1828),
    [sym_keyword_or] = ACTIONS(1828),
    [sym_keyword_is] = ACTIONS(1828),
    [sym_keyword_not] = ACTIONS(1828),
    [sym_keyword_using] = ACTIONS(1828),
    [sym_keyword_auto_increment] = ACTIONS(1828),
    [sym_keyword_generated] = ACTIONS(1828),
    [sym_keyword_default] = ACTIONS(1828),
    [sym_keyword_returning] = ACTIONS(1828),
    [sym_keyword_first] = ACTIONS(1828),
    [sym_keyword_after] = ACTIONS(1828),
    [sym_keyword_range] = ACTIONS(1828),
    [sym_keyword_rows] = ACTIONS(1828),
    [sym_keyword_groups] = ACTIONS(1828),
    [sym_keyword_between] = ACTIONS(1828),
    [sym_keyword_preceding] = ACTIONS(1828),
    [sym_keyword_following] = ACTIONS(1828),
    [sym_keyword_unique] = ACTIONS(1828),
    [sym_keyword_references] = ACTIONS(1828),
    [aux_sym_keyword_like_token1] = ACTIONS(1828),
    [aux_sym_keyword_like_token2] = ACTIONS(1828),
    [sym_keyword_similar] = ACTIONS(1828),
    [sym_keyword_unsigned] = ACTIONS(1832),
    [sym_keyword_zerofill] = ACTIONS(1834),
    [sym_keyword_check] = ACTIONS(1828),
    [sym_keyword_stored] = ACTIONS(1828),
    [sym_keyword_virtual] = ACTIONS(1828),
    [sym_keyword_comment] = ACTIONS(1828),
    [sym_keyword_null] = ACTIONS(1828),
    [sym_keyword_array] = ACTIONS(1828),
    [anon_sym_LBRACK] = ACTIONS(1828),
    [anon_sym_RBRACK] = ACTIONS(1828),
    [anon_sym_LPAREN] = ACTIONS(1836),
    [anon_sym_RPAREN] = ACTIONS(1828),
    [anon_sym_COMMA] = ACTIONS(1828),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1828),
    [anon_sym_STAR] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(1828),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_GT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(1828),
    [anon_sym_GT_EQ] = ACTIONS(1828),
    [anon_sym_COLON] = ACTIONS(1830),
    [sym_op_other] = ACTIONS(1828),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1830),
    [anon_sym_SLASH] = ACTIONS(1830),
    [anon_sym_PERCENT] = ACTIONS(1828),
    [anon_sym_CARET] = ACTIONS(1830),
    [anon_sym_BANG_EQ] = ACTIONS(1828),
    [anon_sym_LT_GT] = ACTIONS(1828),
  },
  [156] = {
    [sym__identifier] = ACTIONS(1838),
    [aux_sym_keyword_character_token1] = ACTIONS(1838),
    [sym_keyword_unsigned] = ACTIONS(1838),
    [sym_keyword_out] = ACTIONS(1840),
    [sym_keyword_boolean] = ACTIONS(1838),
    [sym_keyword_bit] = ACTIONS(1838),
    [sym_keyword_binary] = ACTIONS(1838),
    [sym_keyword_varbinary] = ACTIONS(1838),
    [sym_keyword_image] = ACTIONS(1838),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1838),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1838),
    [aux_sym_keyword_serial_token1] = ACTIONS(1838),
    [aux_sym_keyword_serial_token2] = ACTIONS(1838),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1838),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1838),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1838),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1838),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1838),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1838),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1838),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1838),
    [aux_sym_keyword_int_token1] = ACTIONS(1838),
    [aux_sym_keyword_int_token2] = ACTIONS(1838),
    [aux_sym_keyword_int_token3] = ACTIONS(1838),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1838),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1838),
    [sym_keyword_decimal] = ACTIONS(1838),
    [sym_keyword_numeric] = ACTIONS(1838),
    [aux_sym_keyword_real_token1] = ACTIONS(1838),
    [aux_sym_keyword_real_token2] = ACTIONS(1838),
    [sym_keyword_float] = ACTIONS(1838),
    [sym_keyword_double] = ACTIONS(1838),
    [sym_keyword_inet] = ACTIONS(1838),
    [sym_keyword_money] = ACTIONS(1838),
    [sym_keyword_smallmoney] = ACTIONS(1838),
    [aux_sym_keyword_char_token1] = ACTIONS(1838),
    [sym_keyword_nchar] = ACTIONS(1838),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1838),
    [sym_keyword_nvarchar] = ACTIONS(1838),
    [sym_keyword_text] = ACTIONS(1838),
    [sym_keyword_string] = ACTIONS(1838),
    [sym_keyword_uuid] = ACTIONS(1838),
    [sym_keyword_json] = ACTIONS(1838),
    [sym_keyword_jsonb] = ACTIONS(1838),
    [sym_keyword_xml] = ACTIONS(1838),
    [sym_keyword_bytea] = ACTIONS(1838),
    [sym_keyword_enum] = ACTIONS(1838),
    [sym_keyword_date] = ACTIONS(1838),
    [sym_keyword_datetime] = ACTIONS(1838),
    [sym_keyword_datetime2] = ACTIONS(1838),
    [sym_keyword_smalldatetime] = ACTIONS(1838),
    [sym_keyword_datetimeoffset] = ACTIONS(1838),
    [sym_keyword_time] = ACTIONS(1838),
    [sym_keyword_timestamp] = ACTIONS(1838),
    [sym_keyword_timestamptz] = ACTIONS(1838),
    [sym_keyword_interval] = ACTIONS(1838),
    [sym_keyword_geometry] = ACTIONS(1838),
    [sym_keyword_geography] = ACTIONS(1838),
    [sym_keyword_box2d] = ACTIONS(1838),
    [sym_keyword_box3d] = ACTIONS(1838),
    [sym_keyword_oid] = ACTIONS(1838),
    [sym_keyword_name] = ACTIONS(1838),
    [sym_keyword_regclass] = ACTIONS(1838),
    [sym_keyword_regnamespace] = ACTIONS(1838),
    [sym_keyword_regproc] = ACTIONS(1838),
    [sym_keyword_regtype] = ACTIONS(1838),
    [aux_sym_double_token1] = ACTIONS(1838),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1842),
    [aux_sym_identifier_token1] = ACTIONS(1842),
  },
  [157] = {
    [sym__include_time_zone] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(1844),
    [anon_sym_SEMI] = ACTIONS(1844),
    [sym_keyword_from] = ACTIONS(1844),
    [sym_keyword_on] = ACTIONS(1844),
    [sym_keyword_where] = ACTIONS(1844),
    [sym_keyword_desc] = ACTIONS(1844),
    [sym_keyword_asc] = ACTIONS(1844),
    [sym_keyword_limit] = ACTIONS(1844),
    [sym_keyword_primary] = ACTIONS(1844),
    [sym_keyword_create] = ACTIONS(1844),
    [sym_keyword_as] = ACTIONS(1846),
    [sym_keyword_constraint] = ACTIONS(1844),
    [sym_keyword_separator] = ACTIONS(1844),
    [sym_keyword_when] = ACTIONS(1844),
    [sym_keyword_then] = ACTIONS(1844),
    [sym_keyword_else] = ACTIONS(1844),
    [sym_keyword_end] = ACTIONS(1844),
    [sym_keyword_in] = ACTIONS(1844),
    [sym_keyword_and] = ACTIONS(1844),
    [sym_keyword_or] = ACTIONS(1844),
    [sym_keyword_is] = ACTIONS(1844),
    [sym_keyword_not] = ACTIONS(1844),
    [sym_keyword_using] = ACTIONS(1844),
    [sym_keyword_auto_increment] = ACTIONS(1844),
    [sym_keyword_generated] = ACTIONS(1844),
    [sym_keyword_default] = ACTIONS(1844),
    [sym_keyword_with] = ACTIONS(1776),
    [sym_keyword_without] = ACTIONS(1778),
    [sym_keyword_returning] = ACTIONS(1844),
    [sym_keyword_first] = ACTIONS(1844),
    [sym_keyword_after] = ACTIONS(1844),
    [sym_keyword_range] = ACTIONS(1844),
    [sym_keyword_rows] = ACTIONS(1844),
    [sym_keyword_groups] = ACTIONS(1844),
    [sym_keyword_between] = ACTIONS(1844),
    [sym_keyword_preceding] = ACTIONS(1844),
    [sym_keyword_following] = ACTIONS(1844),
    [sym_keyword_unique] = ACTIONS(1844),
    [sym_keyword_references] = ACTIONS(1844),
    [aux_sym_keyword_like_token1] = ACTIONS(1844),
    [aux_sym_keyword_like_token2] = ACTIONS(1844),
    [sym_keyword_similar] = ACTIONS(1844),
    [sym_keyword_check] = ACTIONS(1844),
    [sym_keyword_stored] = ACTIONS(1844),
    [sym_keyword_virtual] = ACTIONS(1844),
    [sym_keyword_comment] = ACTIONS(1844),
    [sym_keyword_null] = ACTIONS(1844),
    [sym_keyword_array] = ACTIONS(1844),
    [anon_sym_LBRACK] = ACTIONS(1844),
    [anon_sym_RBRACK] = ACTIONS(1844),
    [anon_sym_RPAREN] = ACTIONS(1844),
    [anon_sym_COMMA] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_COLON_COLON] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_LT_EQ] = ACTIONS(1844),
    [anon_sym_GT_EQ] = ACTIONS(1844),
    [anon_sym_COLON] = ACTIONS(1846),
    [sym_op_other] = ACTIONS(1844),
    [anon_sym_PLUS] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1846),
    [anon_sym_SLASH] = ACTIONS(1846),
    [anon_sym_PERCENT] = ACTIONS(1844),
    [anon_sym_CARET] = ACTIONS(1846),
    [anon_sym_BANG_EQ] = ACTIONS(1844),
    [anon_sym_LT_GT] = ACTIONS(1844),
  },
  [158] = {
    [sym__include_time_zone] = STATE(261),
    [ts_builtin_sym_end] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1848),
    [sym_keyword_from] = ACTIONS(1848),
    [sym_keyword_on] = ACTIONS(1848),
    [sym_keyword_where] = ACTIONS(1848),
    [sym_keyword_desc] = ACTIONS(1848),
    [sym_keyword_asc] = ACTIONS(1848),
    [sym_keyword_limit] = ACTIONS(1848),
    [sym_keyword_primary] = ACTIONS(1848),
    [sym_keyword_create] = ACTIONS(1848),
    [sym_keyword_as] = ACTIONS(1850),
    [sym_keyword_constraint] = ACTIONS(1848),
    [sym_keyword_separator] = ACTIONS(1848),
    [sym_keyword_when] = ACTIONS(1848),
    [sym_keyword_then] = ACTIONS(1848),
    [sym_keyword_else] = ACTIONS(1848),
    [sym_keyword_end] = ACTIONS(1848),
    [sym_keyword_in] = ACTIONS(1848),
    [sym_keyword_and] = ACTIONS(1848),
    [sym_keyword_or] = ACTIONS(1848),
    [sym_keyword_is] = ACTIONS(1848),
    [sym_keyword_not] = ACTIONS(1848),
    [sym_keyword_using] = ACTIONS(1848),
    [sym_keyword_auto_increment] = ACTIONS(1848),
    [sym_keyword_generated] = ACTIONS(1848),
    [sym_keyword_default] = ACTIONS(1848),
    [sym_keyword_with] = ACTIONS(1776),
    [sym_keyword_without] = ACTIONS(1778),
    [sym_keyword_returning] = ACTIONS(1848),
    [sym_keyword_first] = ACTIONS(1848),
    [sym_keyword_after] = ACTIONS(1848),
    [sym_keyword_range] = ACTIONS(1848),
    [sym_keyword_rows] = ACTIONS(1848),
    [sym_keyword_groups] = ACTIONS(1848),
    [sym_keyword_between] = ACTIONS(1848),
    [sym_keyword_preceding] = ACTIONS(1848),
    [sym_keyword_following] = ACTIONS(1848),
    [sym_keyword_unique] = ACTIONS(1848),
    [sym_keyword_references] = ACTIONS(1848),
    [aux_sym_keyword_like_token1] = ACTIONS(1848),
    [aux_sym_keyword_like_token2] = ACTIONS(1848),
    [sym_keyword_similar] = ACTIONS(1848),
    [sym_keyword_check] = ACTIONS(1848),
    [sym_keyword_stored] = ACTIONS(1848),
    [sym_keyword_virtual] = ACTIONS(1848),
    [sym_keyword_comment] = ACTIONS(1848),
    [sym_keyword_null] = ACTIONS(1848),
    [sym_keyword_array] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1848),
    [anon_sym_RBRACK] = ACTIONS(1848),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [anon_sym_COMMA] = ACTIONS(1848),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_COLON_COLON] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_GT] = ACTIONS(1850),
    [anon_sym_LT_EQ] = ACTIONS(1848),
    [anon_sym_GT_EQ] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(1850),
    [sym_op_other] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1850),
    [anon_sym_SLASH] = ACTIONS(1850),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_LT_GT] = ACTIONS(1848),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(1782),
    [anon_sym_SEMI] = ACTIONS(1782),
    [sym_keyword_from] = ACTIONS(1782),
    [sym_keyword_on] = ACTIONS(1782),
    [sym_keyword_where] = ACTIONS(1782),
    [sym_keyword_desc] = ACTIONS(1782),
    [sym_keyword_asc] = ACTIONS(1782),
    [sym_keyword_limit] = ACTIONS(1782),
    [sym_keyword_primary] = ACTIONS(1782),
    [sym_keyword_create] = ACTIONS(1782),
    [sym_keyword_as] = ACTIONS(1784),
    [sym_keyword_constraint] = ACTIONS(1782),
    [sym_keyword_separator] = ACTIONS(1782),
    [sym_keyword_when] = ACTIONS(1782),
    [sym_keyword_then] = ACTIONS(1782),
    [sym_keyword_else] = ACTIONS(1782),
    [sym_keyword_end] = ACTIONS(1782),
    [sym_keyword_in] = ACTIONS(1782),
    [sym_keyword_and] = ACTIONS(1782),
    [sym_keyword_or] = ACTIONS(1782),
    [sym_keyword_is] = ACTIONS(1782),
    [sym_keyword_not] = ACTIONS(1782),
    [sym_keyword_using] = ACTIONS(1782),
    [sym_keyword_auto_increment] = ACTIONS(1782),
    [sym_keyword_generated] = ACTIONS(1782),
    [sym_keyword_default] = ACTIONS(1782),
    [sym_keyword_returning] = ACTIONS(1782),
    [sym_keyword_first] = ACTIONS(1782),
    [sym_keyword_after] = ACTIONS(1782),
    [sym_keyword_range] = ACTIONS(1782),
    [sym_keyword_rows] = ACTIONS(1782),
    [sym_keyword_groups] = ACTIONS(1782),
    [sym_keyword_between] = ACTIONS(1782),
    [sym_keyword_preceding] = ACTIONS(1782),
    [sym_keyword_following] = ACTIONS(1782),
    [sym_keyword_unique] = ACTIONS(1782),
    [sym_keyword_references] = ACTIONS(1782),
    [aux_sym_keyword_like_token1] = ACTIONS(1782),
    [aux_sym_keyword_like_token2] = ACTIONS(1782),
    [sym_keyword_similar] = ACTIONS(1782),
    [sym_keyword_unsigned] = ACTIONS(1786),
    [sym_keyword_zerofill] = ACTIONS(1788),
    [sym_keyword_check] = ACTIONS(1782),
    [sym_keyword_stored] = ACTIONS(1782),
    [sym_keyword_virtual] = ACTIONS(1782),
    [sym_keyword_comment] = ACTIONS(1782),
    [sym_keyword_null] = ACTIONS(1782),
    [sym_keyword_array] = ACTIONS(1782),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_RBRACK] = ACTIONS(1782),
    [anon_sym_LPAREN] = ACTIONS(1792),
    [anon_sym_RPAREN] = ACTIONS(1782),
    [anon_sym_COMMA] = ACTIONS(1782),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1782),
    [anon_sym_STAR] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_GT] = ACTIONS(1784),
    [anon_sym_LT_EQ] = ACTIONS(1782),
    [anon_sym_GT_EQ] = ACTIONS(1782),
    [anon_sym_COLON] = ACTIONS(1784),
    [sym_op_other] = ACTIONS(1782),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1784),
    [anon_sym_SLASH] = ACTIONS(1784),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_CARET] = ACTIONS(1784),
    [anon_sym_BANG_EQ] = ACTIONS(1782),
    [anon_sym_LT_GT] = ACTIONS(1782),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [sym_keyword_from] = ACTIONS(1852),
    [sym_keyword_on] = ACTIONS(1852),
    [sym_keyword_where] = ACTIONS(1852),
    [sym_keyword_desc] = ACTIONS(1852),
    [sym_keyword_asc] = ACTIONS(1852),
    [sym_keyword_limit] = ACTIONS(1852),
    [sym_keyword_primary] = ACTIONS(1852),
    [sym_keyword_create] = ACTIONS(1852),
    [sym_keyword_as] = ACTIONS(1854),
    [sym_keyword_constraint] = ACTIONS(1852),
    [sym_keyword_separator] = ACTIONS(1852),
    [sym_keyword_when] = ACTIONS(1852),
    [sym_keyword_then] = ACTIONS(1852),
    [sym_keyword_else] = ACTIONS(1852),
    [sym_keyword_end] = ACTIONS(1852),
    [sym_keyword_in] = ACTIONS(1852),
    [sym_keyword_and] = ACTIONS(1852),
    [sym_keyword_or] = ACTIONS(1852),
    [sym_keyword_is] = ACTIONS(1852),
    [sym_keyword_not] = ACTIONS(1852),
    [sym_keyword_using] = ACTIONS(1852),
    [sym_keyword_auto_increment] = ACTIONS(1852),
    [sym_keyword_generated] = ACTIONS(1852),
    [sym_keyword_default] = ACTIONS(1852),
    [sym_keyword_returning] = ACTIONS(1852),
    [sym_keyword_first] = ACTIONS(1852),
    [sym_keyword_after] = ACTIONS(1852),
    [sym_keyword_range] = ACTIONS(1852),
    [sym_keyword_rows] = ACTIONS(1852),
    [sym_keyword_groups] = ACTIONS(1852),
    [sym_keyword_between] = ACTIONS(1852),
    [sym_keyword_preceding] = ACTIONS(1852),
    [sym_keyword_following] = ACTIONS(1852),
    [sym_keyword_unique] = ACTIONS(1852),
    [sym_keyword_references] = ACTIONS(1852),
    [aux_sym_keyword_like_token1] = ACTIONS(1852),
    [aux_sym_keyword_like_token2] = ACTIONS(1852),
    [sym_keyword_similar] = ACTIONS(1852),
    [sym_keyword_unsigned] = ACTIONS(1856),
    [sym_keyword_zerofill] = ACTIONS(1858),
    [sym_keyword_check] = ACTIONS(1852),
    [sym_keyword_stored] = ACTIONS(1852),
    [sym_keyword_virtual] = ACTIONS(1852),
    [sym_keyword_comment] = ACTIONS(1852),
    [sym_keyword_null] = ACTIONS(1852),
    [sym_keyword_array] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1854),
    [sym_op_other] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1854),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_LT_GT] = ACTIONS(1852),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(1862),
    [anon_sym_SEMI] = ACTIONS(1862),
    [sym_keyword_from] = ACTIONS(1862),
    [sym_keyword_on] = ACTIONS(1862),
    [sym_keyword_where] = ACTIONS(1862),
    [sym_keyword_desc] = ACTIONS(1862),
    [sym_keyword_asc] = ACTIONS(1862),
    [sym_keyword_limit] = ACTIONS(1862),
    [sym_keyword_primary] = ACTIONS(1862),
    [sym_keyword_create] = ACTIONS(1862),
    [sym_keyword_as] = ACTIONS(1864),
    [sym_keyword_constraint] = ACTIONS(1862),
    [sym_keyword_separator] = ACTIONS(1862),
    [sym_keyword_when] = ACTIONS(1862),
    [sym_keyword_then] = ACTIONS(1862),
    [sym_keyword_else] = ACTIONS(1862),
    [sym_keyword_end] = ACTIONS(1862),
    [sym_keyword_in] = ACTIONS(1862),
    [sym_keyword_and] = ACTIONS(1862),
    [sym_keyword_or] = ACTIONS(1862),
    [sym_keyword_is] = ACTIONS(1862),
    [sym_keyword_not] = ACTIONS(1862),
    [sym_keyword_using] = ACTIONS(1862),
    [sym_keyword_auto_increment] = ACTIONS(1862),
    [sym_keyword_generated] = ACTIONS(1862),
    [sym_keyword_default] = ACTIONS(1862),
    [sym_keyword_returning] = ACTIONS(1862),
    [sym_keyword_first] = ACTIONS(1862),
    [sym_keyword_after] = ACTIONS(1862),
    [sym_keyword_range] = ACTIONS(1862),
    [sym_keyword_rows] = ACTIONS(1862),
    [sym_keyword_groups] = ACTIONS(1862),
    [sym_keyword_between] = ACTIONS(1862),
    [sym_keyword_preceding] = ACTIONS(1862),
    [sym_keyword_following] = ACTIONS(1862),
    [sym_keyword_unique] = ACTIONS(1862),
    [sym_keyword_references] = ACTIONS(1862),
    [aux_sym_keyword_like_token1] = ACTIONS(1862),
    [aux_sym_keyword_like_token2] = ACTIONS(1862),
    [sym_keyword_similar] = ACTIONS(1862),
    [sym_keyword_unsigned] = ACTIONS(1866),
    [sym_keyword_zerofill] = ACTIONS(1868),
    [sym_keyword_check] = ACTIONS(1862),
    [sym_keyword_stored] = ACTIONS(1862),
    [sym_keyword_virtual] = ACTIONS(1862),
    [sym_keyword_comment] = ACTIONS(1862),
    [sym_keyword_null] = ACTIONS(1862),
    [sym_keyword_array] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1870),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1862),
    [anon_sym_COLON_COLON] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1862),
    [anon_sym_COLON] = ACTIONS(1864),
    [sym_op_other] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1864),
    [anon_sym_BANG_EQ] = ACTIONS(1862),
    [anon_sym_LT_GT] = ACTIONS(1862),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(1872),
    [anon_sym_SEMI] = ACTIONS(1872),
    [sym_keyword_from] = ACTIONS(1872),
    [sym_keyword_on] = ACTIONS(1872),
    [sym_keyword_where] = ACTIONS(1872),
    [sym_keyword_desc] = ACTIONS(1872),
    [sym_keyword_asc] = ACTIONS(1872),
    [sym_keyword_limit] = ACTIONS(1872),
    [sym_keyword_primary] = ACTIONS(1872),
    [sym_keyword_create] = ACTIONS(1872),
    [sym_keyword_as] = ACTIONS(1874),
    [sym_keyword_constraint] = ACTIONS(1872),
    [sym_keyword_separator] = ACTIONS(1872),
    [sym_keyword_when] = ACTIONS(1872),
    [sym_keyword_then] = ACTIONS(1872),
    [sym_keyword_else] = ACTIONS(1872),
    [sym_keyword_end] = ACTIONS(1872),
    [sym_keyword_in] = ACTIONS(1872),
    [sym_keyword_and] = ACTIONS(1872),
    [sym_keyword_or] = ACTIONS(1872),
    [sym_keyword_is] = ACTIONS(1872),
    [sym_keyword_not] = ACTIONS(1872),
    [sym_keyword_using] = ACTIONS(1872),
    [sym_keyword_auto_increment] = ACTIONS(1872),
    [sym_keyword_generated] = ACTIONS(1872),
    [sym_keyword_default] = ACTIONS(1872),
    [sym_keyword_returning] = ACTIONS(1872),
    [sym_keyword_first] = ACTIONS(1872),
    [sym_keyword_after] = ACTIONS(1872),
    [sym_keyword_range] = ACTIONS(1872),
    [sym_keyword_rows] = ACTIONS(1872),
    [sym_keyword_groups] = ACTIONS(1872),
    [sym_keyword_between] = ACTIONS(1872),
    [sym_keyword_preceding] = ACTIONS(1872),
    [sym_keyword_following] = ACTIONS(1872),
    [sym_keyword_unique] = ACTIONS(1872),
    [sym_keyword_references] = ACTIONS(1872),
    [aux_sym_keyword_like_token1] = ACTIONS(1872),
    [aux_sym_keyword_like_token2] = ACTIONS(1872),
    [sym_keyword_similar] = ACTIONS(1872),
    [sym_keyword_unsigned] = ACTIONS(1872),
    [sym_keyword_zerofill] = ACTIONS(1872),
    [sym_keyword_check] = ACTIONS(1872),
    [sym_keyword_stored] = ACTIONS(1872),
    [sym_keyword_virtual] = ACTIONS(1872),
    [sym_keyword_comment] = ACTIONS(1872),
    [sym_keyword_null] = ACTIONS(1872),
    [sym_keyword_array] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1872),
    [anon_sym_RBRACK] = ACTIONS(1872),
    [anon_sym_LPAREN] = ACTIONS(1872),
    [anon_sym_RPAREN] = ACTIONS(1872),
    [anon_sym_COMMA] = ACTIONS(1872),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1872),
    [anon_sym_COLON_COLON] = ACTIONS(1872),
    [anon_sym_LT] = ACTIONS(1874),
    [anon_sym_GT] = ACTIONS(1874),
    [anon_sym_LT_EQ] = ACTIONS(1872),
    [anon_sym_GT_EQ] = ACTIONS(1872),
    [anon_sym_COLON] = ACTIONS(1874),
    [sym_op_other] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1874),
    [anon_sym_SLASH] = ACTIONS(1874),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_CARET] = ACTIONS(1874),
    [anon_sym_BANG_EQ] = ACTIONS(1872),
    [anon_sym_LT_GT] = ACTIONS(1872),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1876),
    [sym_keyword_from] = ACTIONS(1876),
    [sym_keyword_on] = ACTIONS(1876),
    [sym_keyword_where] = ACTIONS(1876),
    [sym_keyword_desc] = ACTIONS(1876),
    [sym_keyword_asc] = ACTIONS(1876),
    [sym_keyword_limit] = ACTIONS(1876),
    [sym_keyword_primary] = ACTIONS(1876),
    [sym_keyword_create] = ACTIONS(1876),
    [sym_keyword_as] = ACTIONS(1878),
    [sym_keyword_constraint] = ACTIONS(1876),
    [sym_keyword_separator] = ACTIONS(1876),
    [sym_keyword_when] = ACTIONS(1876),
    [sym_keyword_then] = ACTIONS(1876),
    [sym_keyword_else] = ACTIONS(1876),
    [sym_keyword_end] = ACTIONS(1876),
    [sym_keyword_in] = ACTIONS(1876),
    [sym_keyword_and] = ACTIONS(1876),
    [sym_keyword_or] = ACTIONS(1876),
    [sym_keyword_is] = ACTIONS(1876),
    [sym_keyword_not] = ACTIONS(1876),
    [sym_keyword_using] = ACTIONS(1876),
    [sym_keyword_auto_increment] = ACTIONS(1876),
    [sym_keyword_generated] = ACTIONS(1876),
    [sym_keyword_default] = ACTIONS(1876),
    [sym_keyword_returning] = ACTIONS(1876),
    [sym_keyword_first] = ACTIONS(1876),
    [sym_keyword_after] = ACTIONS(1876),
    [sym_keyword_range] = ACTIONS(1876),
    [sym_keyword_rows] = ACTIONS(1876),
    [sym_keyword_groups] = ACTIONS(1876),
    [sym_keyword_between] = ACTIONS(1876),
    [sym_keyword_preceding] = ACTIONS(1876),
    [sym_keyword_following] = ACTIONS(1876),
    [sym_keyword_unique] = ACTIONS(1876),
    [sym_keyword_references] = ACTIONS(1876),
    [aux_sym_keyword_like_token1] = ACTIONS(1876),
    [aux_sym_keyword_like_token2] = ACTIONS(1876),
    [sym_keyword_similar] = ACTIONS(1876),
    [sym_keyword_unsigned] = ACTIONS(1876),
    [sym_keyword_zerofill] = ACTIONS(1876),
    [sym_keyword_check] = ACTIONS(1876),
    [sym_keyword_stored] = ACTIONS(1876),
    [sym_keyword_virtual] = ACTIONS(1876),
    [sym_keyword_comment] = ACTIONS(1876),
    [sym_keyword_null] = ACTIONS(1876),
    [sym_keyword_array] = ACTIONS(1876),
    [anon_sym_LBRACK] = ACTIONS(1876),
    [anon_sym_RBRACK] = ACTIONS(1876),
    [anon_sym_LPAREN] = ACTIONS(1876),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_COMMA] = ACTIONS(1876),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1876),
    [anon_sym_STAR] = ACTIONS(1876),
    [anon_sym_COLON_COLON] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_LT_EQ] = ACTIONS(1876),
    [anon_sym_GT_EQ] = ACTIONS(1876),
    [anon_sym_COLON] = ACTIONS(1878),
    [sym_op_other] = ACTIONS(1876),
    [anon_sym_PLUS] = ACTIONS(1876),
    [anon_sym_DASH] = ACTIONS(1878),
    [anon_sym_SLASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1876),
    [anon_sym_CARET] = ACTIONS(1878),
    [anon_sym_BANG_EQ] = ACTIONS(1876),
    [anon_sym_LT_GT] = ACTIONS(1876),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1880),
    [sym_keyword_from] = ACTIONS(1880),
    [sym_keyword_on] = ACTIONS(1880),
    [sym_keyword_where] = ACTIONS(1880),
    [sym_keyword_desc] = ACTIONS(1880),
    [sym_keyword_asc] = ACTIONS(1880),
    [sym_keyword_limit] = ACTIONS(1880),
    [sym_keyword_primary] = ACTIONS(1880),
    [sym_keyword_create] = ACTIONS(1880),
    [sym_keyword_as] = ACTIONS(1882),
    [sym_keyword_constraint] = ACTIONS(1880),
    [sym_keyword_separator] = ACTIONS(1880),
    [sym_keyword_when] = ACTIONS(1880),
    [sym_keyword_then] = ACTIONS(1880),
    [sym_keyword_else] = ACTIONS(1880),
    [sym_keyword_end] = ACTIONS(1880),
    [sym_keyword_in] = ACTIONS(1880),
    [sym_keyword_and] = ACTIONS(1880),
    [sym_keyword_or] = ACTIONS(1880),
    [sym_keyword_is] = ACTIONS(1880),
    [sym_keyword_not] = ACTIONS(1880),
    [sym_keyword_using] = ACTIONS(1880),
    [sym_keyword_auto_increment] = ACTIONS(1880),
    [sym_keyword_generated] = ACTIONS(1880),
    [sym_keyword_default] = ACTIONS(1880),
    [sym_keyword_returning] = ACTIONS(1880),
    [sym_keyword_first] = ACTIONS(1880),
    [sym_keyword_after] = ACTIONS(1880),
    [sym_keyword_range] = ACTIONS(1880),
    [sym_keyword_rows] = ACTIONS(1880),
    [sym_keyword_groups] = ACTIONS(1880),
    [sym_keyword_between] = ACTIONS(1880),
    [sym_keyword_preceding] = ACTIONS(1880),
    [sym_keyword_following] = ACTIONS(1880),
    [sym_keyword_unique] = ACTIONS(1880),
    [sym_keyword_references] = ACTIONS(1880),
    [aux_sym_keyword_like_token1] = ACTIONS(1880),
    [aux_sym_keyword_like_token2] = ACTIONS(1880),
    [sym_keyword_similar] = ACTIONS(1880),
    [sym_keyword_unsigned] = ACTIONS(1884),
    [sym_keyword_zerofill] = ACTIONS(1886),
    [sym_keyword_check] = ACTIONS(1880),
    [sym_keyword_stored] = ACTIONS(1880),
    [sym_keyword_virtual] = ACTIONS(1880),
    [sym_keyword_comment] = ACTIONS(1880),
    [sym_keyword_null] = ACTIONS(1880),
    [sym_keyword_array] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(1880),
    [anon_sym_RBRACK] = ACTIONS(1880),
    [anon_sym_LPAREN] = ACTIONS(1888),
    [anon_sym_RPAREN] = ACTIONS(1880),
    [anon_sym_COMMA] = ACTIONS(1880),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1880),
    [anon_sym_STAR] = ACTIONS(1880),
    [anon_sym_COLON_COLON] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_LT_EQ] = ACTIONS(1880),
    [anon_sym_GT_EQ] = ACTIONS(1880),
    [anon_sym_COLON] = ACTIONS(1882),
    [sym_op_other] = ACTIONS(1880),
    [anon_sym_PLUS] = ACTIONS(1880),
    [anon_sym_DASH] = ACTIONS(1882),
    [anon_sym_SLASH] = ACTIONS(1882),
    [anon_sym_PERCENT] = ACTIONS(1880),
    [anon_sym_CARET] = ACTIONS(1882),
    [anon_sym_BANG_EQ] = ACTIONS(1880),
    [anon_sym_LT_GT] = ACTIONS(1880),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1890),
    [sym_keyword_from] = ACTIONS(1890),
    [sym_keyword_on] = ACTIONS(1890),
    [sym_keyword_where] = ACTIONS(1890),
    [sym_keyword_desc] = ACTIONS(1890),
    [sym_keyword_asc] = ACTIONS(1890),
    [sym_keyword_limit] = ACTIONS(1890),
    [sym_keyword_primary] = ACTIONS(1890),
    [sym_keyword_create] = ACTIONS(1890),
    [sym_keyword_as] = ACTIONS(1892),
    [sym_keyword_constraint] = ACTIONS(1890),
    [sym_keyword_separator] = ACTIONS(1890),
    [sym_keyword_when] = ACTIONS(1890),
    [sym_keyword_then] = ACTIONS(1890),
    [sym_keyword_else] = ACTIONS(1890),
    [sym_keyword_end] = ACTIONS(1890),
    [sym_keyword_in] = ACTIONS(1890),
    [sym_keyword_and] = ACTIONS(1890),
    [sym_keyword_or] = ACTIONS(1890),
    [sym_keyword_is] = ACTIONS(1890),
    [sym_keyword_not] = ACTIONS(1890),
    [sym_keyword_using] = ACTIONS(1890),
    [sym_keyword_auto_increment] = ACTIONS(1890),
    [sym_keyword_generated] = ACTIONS(1890),
    [sym_keyword_default] = ACTIONS(1890),
    [sym_keyword_returning] = ACTIONS(1890),
    [sym_keyword_first] = ACTIONS(1890),
    [sym_keyword_after] = ACTIONS(1890),
    [sym_keyword_range] = ACTIONS(1890),
    [sym_keyword_rows] = ACTIONS(1890),
    [sym_keyword_groups] = ACTIONS(1890),
    [sym_keyword_between] = ACTIONS(1890),
    [sym_keyword_preceding] = ACTIONS(1890),
    [sym_keyword_following] = ACTIONS(1890),
    [sym_keyword_unique] = ACTIONS(1890),
    [sym_keyword_references] = ACTIONS(1890),
    [aux_sym_keyword_like_token1] = ACTIONS(1890),
    [aux_sym_keyword_like_token2] = ACTIONS(1890),
    [sym_keyword_similar] = ACTIONS(1890),
    [sym_keyword_unsigned] = ACTIONS(1894),
    [sym_keyword_zerofill] = ACTIONS(1896),
    [sym_keyword_check] = ACTIONS(1890),
    [sym_keyword_stored] = ACTIONS(1890),
    [sym_keyword_virtual] = ACTIONS(1890),
    [sym_keyword_comment] = ACTIONS(1890),
    [sym_keyword_null] = ACTIONS(1890),
    [sym_keyword_array] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1890),
    [anon_sym_RBRACK] = ACTIONS(1890),
    [anon_sym_LPAREN] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1890),
    [anon_sym_COLON_COLON] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1892),
    [anon_sym_LT_EQ] = ACTIONS(1890),
    [anon_sym_GT_EQ] = ACTIONS(1890),
    [anon_sym_COLON] = ACTIONS(1892),
    [sym_op_other] = ACTIONS(1890),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_SLASH] = ACTIONS(1892),
    [anon_sym_PERCENT] = ACTIONS(1890),
    [anon_sym_CARET] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1890),
    [anon_sym_LT_GT] = ACTIONS(1890),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(1900),
    [anon_sym_SEMI] = ACTIONS(1900),
    [sym_keyword_from] = ACTIONS(1900),
    [sym_keyword_on] = ACTIONS(1900),
    [sym_keyword_where] = ACTIONS(1900),
    [sym_keyword_desc] = ACTIONS(1900),
    [sym_keyword_asc] = ACTIONS(1900),
    [sym_keyword_limit] = ACTIONS(1900),
    [sym_keyword_primary] = ACTIONS(1900),
    [sym_keyword_create] = ACTIONS(1900),
    [sym_keyword_as] = ACTIONS(1902),
    [sym_keyword_constraint] = ACTIONS(1900),
    [sym_keyword_separator] = ACTIONS(1900),
    [sym_keyword_when] = ACTIONS(1900),
    [sym_keyword_then] = ACTIONS(1900),
    [sym_keyword_else] = ACTIONS(1900),
    [sym_keyword_end] = ACTIONS(1900),
    [sym_keyword_in] = ACTIONS(1900),
    [sym_keyword_and] = ACTIONS(1900),
    [sym_keyword_or] = ACTIONS(1900),
    [sym_keyword_is] = ACTIONS(1900),
    [sym_keyword_not] = ACTIONS(1900),
    [sym_keyword_using] = ACTIONS(1900),
    [sym_keyword_auto_increment] = ACTIONS(1900),
    [sym_keyword_generated] = ACTIONS(1900),
    [sym_keyword_default] = ACTIONS(1900),
    [sym_keyword_returning] = ACTIONS(1900),
    [sym_keyword_first] = ACTIONS(1900),
    [sym_keyword_after] = ACTIONS(1900),
    [sym_keyword_range] = ACTIONS(1900),
    [sym_keyword_rows] = ACTIONS(1900),
    [sym_keyword_groups] = ACTIONS(1900),
    [sym_keyword_between] = ACTIONS(1900),
    [sym_keyword_preceding] = ACTIONS(1900),
    [sym_keyword_following] = ACTIONS(1900),
    [sym_keyword_unique] = ACTIONS(1900),
    [sym_keyword_references] = ACTIONS(1900),
    [aux_sym_keyword_like_token1] = ACTIONS(1900),
    [aux_sym_keyword_like_token2] = ACTIONS(1900),
    [sym_keyword_similar] = ACTIONS(1900),
    [sym_keyword_unsigned] = ACTIONS(1900),
    [sym_keyword_zerofill] = ACTIONS(1900),
    [sym_keyword_check] = ACTIONS(1900),
    [sym_keyword_stored] = ACTIONS(1900),
    [sym_keyword_virtual] = ACTIONS(1900),
    [sym_keyword_comment] = ACTIONS(1900),
    [sym_keyword_null] = ACTIONS(1900),
    [sym_keyword_array] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(1900),
    [anon_sym_RBRACK] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(1900),
    [anon_sym_RPAREN] = ACTIONS(1900),
    [anon_sym_COMMA] = ACTIONS(1900),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1900),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_COLON_COLON] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(1900),
    [anon_sym_GT_EQ] = ACTIONS(1900),
    [anon_sym_COLON] = ACTIONS(1902),
    [sym_op_other] = ACTIONS(1900),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [anon_sym_PERCENT] = ACTIONS(1900),
    [anon_sym_CARET] = ACTIONS(1902),
    [anon_sym_BANG_EQ] = ACTIONS(1900),
    [anon_sym_LT_GT] = ACTIONS(1900),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1904),
    [sym_keyword_from] = ACTIONS(1904),
    [sym_keyword_on] = ACTIONS(1904),
    [sym_keyword_where] = ACTIONS(1904),
    [sym_keyword_desc] = ACTIONS(1904),
    [sym_keyword_asc] = ACTIONS(1904),
    [sym_keyword_limit] = ACTIONS(1904),
    [sym_keyword_primary] = ACTIONS(1904),
    [sym_keyword_create] = ACTIONS(1904),
    [sym_keyword_as] = ACTIONS(1906),
    [sym_keyword_constraint] = ACTIONS(1904),
    [sym_keyword_separator] = ACTIONS(1904),
    [sym_keyword_when] = ACTIONS(1904),
    [sym_keyword_then] = ACTIONS(1904),
    [sym_keyword_else] = ACTIONS(1904),
    [sym_keyword_end] = ACTIONS(1904),
    [sym_keyword_in] = ACTIONS(1904),
    [sym_keyword_and] = ACTIONS(1904),
    [sym_keyword_or] = ACTIONS(1904),
    [sym_keyword_is] = ACTIONS(1904),
    [sym_keyword_not] = ACTIONS(1904),
    [sym_keyword_using] = ACTIONS(1904),
    [sym_keyword_auto_increment] = ACTIONS(1904),
    [sym_keyword_generated] = ACTIONS(1904),
    [sym_keyword_default] = ACTIONS(1904),
    [sym_keyword_returning] = ACTIONS(1904),
    [sym_keyword_first] = ACTIONS(1904),
    [sym_keyword_after] = ACTIONS(1904),
    [sym_keyword_range] = ACTIONS(1904),
    [sym_keyword_rows] = ACTIONS(1904),
    [sym_keyword_groups] = ACTIONS(1904),
    [sym_keyword_between] = ACTIONS(1904),
    [sym_keyword_preceding] = ACTIONS(1904),
    [sym_keyword_following] = ACTIONS(1904),
    [sym_keyword_unique] = ACTIONS(1904),
    [sym_keyword_references] = ACTIONS(1904),
    [aux_sym_keyword_like_token1] = ACTIONS(1904),
    [aux_sym_keyword_like_token2] = ACTIONS(1904),
    [sym_keyword_similar] = ACTIONS(1904),
    [sym_keyword_unsigned] = ACTIONS(1904),
    [sym_keyword_zerofill] = ACTIONS(1904),
    [sym_keyword_check] = ACTIONS(1904),
    [sym_keyword_stored] = ACTIONS(1904),
    [sym_keyword_virtual] = ACTIONS(1904),
    [sym_keyword_comment] = ACTIONS(1904),
    [sym_keyword_null] = ACTIONS(1904),
    [sym_keyword_array] = ACTIONS(1904),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_RBRACK] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_RPAREN] = ACTIONS(1904),
    [anon_sym_COMMA] = ACTIONS(1904),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1904),
    [anon_sym_STAR] = ACTIONS(1904),
    [anon_sym_COLON_COLON] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1906),
    [anon_sym_GT] = ACTIONS(1906),
    [anon_sym_LT_EQ] = ACTIONS(1904),
    [anon_sym_GT_EQ] = ACTIONS(1904),
    [anon_sym_COLON] = ACTIONS(1906),
    [sym_op_other] = ACTIONS(1904),
    [anon_sym_PLUS] = ACTIONS(1904),
    [anon_sym_DASH] = ACTIONS(1906),
    [anon_sym_SLASH] = ACTIONS(1906),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_CARET] = ACTIONS(1906),
    [anon_sym_BANG_EQ] = ACTIONS(1904),
    [anon_sym_LT_GT] = ACTIONS(1904),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(1908),
    [anon_sym_SEMI] = ACTIONS(1908),
    [sym_keyword_from] = ACTIONS(1908),
    [sym_keyword_on] = ACTIONS(1908),
    [sym_keyword_where] = ACTIONS(1908),
    [sym_keyword_desc] = ACTIONS(1908),
    [sym_keyword_asc] = ACTIONS(1908),
    [sym_keyword_limit] = ACTIONS(1908),
    [sym_keyword_primary] = ACTIONS(1908),
    [sym_keyword_create] = ACTIONS(1908),
    [sym_keyword_as] = ACTIONS(1910),
    [sym_keyword_constraint] = ACTIONS(1908),
    [sym_keyword_separator] = ACTIONS(1908),
    [sym_keyword_when] = ACTIONS(1908),
    [sym_keyword_then] = ACTIONS(1908),
    [sym_keyword_else] = ACTIONS(1908),
    [sym_keyword_end] = ACTIONS(1908),
    [sym_keyword_in] = ACTIONS(1908),
    [sym_keyword_and] = ACTIONS(1908),
    [sym_keyword_or] = ACTIONS(1908),
    [sym_keyword_is] = ACTIONS(1908),
    [sym_keyword_not] = ACTIONS(1908),
    [sym_keyword_using] = ACTIONS(1908),
    [sym_keyword_auto_increment] = ACTIONS(1908),
    [sym_keyword_generated] = ACTIONS(1908),
    [sym_keyword_default] = ACTIONS(1908),
    [sym_keyword_returning] = ACTIONS(1908),
    [sym_keyword_first] = ACTIONS(1908),
    [sym_keyword_after] = ACTIONS(1908),
    [sym_keyword_range] = ACTIONS(1908),
    [sym_keyword_rows] = ACTIONS(1908),
    [sym_keyword_groups] = ACTIONS(1908),
    [sym_keyword_between] = ACTIONS(1908),
    [sym_keyword_preceding] = ACTIONS(1908),
    [sym_keyword_following] = ACTIONS(1908),
    [sym_keyword_unique] = ACTIONS(1908),
    [sym_keyword_references] = ACTIONS(1908),
    [aux_sym_keyword_like_token1] = ACTIONS(1908),
    [aux_sym_keyword_like_token2] = ACTIONS(1908),
    [sym_keyword_similar] = ACTIONS(1908),
    [sym_keyword_unsigned] = ACTIONS(1912),
    [sym_keyword_zerofill] = ACTIONS(1914),
    [sym_keyword_check] = ACTIONS(1908),
    [sym_keyword_stored] = ACTIONS(1908),
    [sym_keyword_virtual] = ACTIONS(1908),
    [sym_keyword_comment] = ACTIONS(1908),
    [sym_keyword_null] = ACTIONS(1908),
    [sym_keyword_array] = ACTIONS(1908),
    [anon_sym_LBRACK] = ACTIONS(1908),
    [anon_sym_RBRACK] = ACTIONS(1908),
    [anon_sym_RPAREN] = ACTIONS(1908),
    [anon_sym_COMMA] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1908),
    [anon_sym_STAR] = ACTIONS(1908),
    [anon_sym_COLON_COLON] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_LT_EQ] = ACTIONS(1908),
    [anon_sym_GT_EQ] = ACTIONS(1908),
    [anon_sym_COLON] = ACTIONS(1910),
    [sym_op_other] = ACTIONS(1908),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_SLASH] = ACTIONS(1910),
    [anon_sym_PERCENT] = ACTIONS(1908),
    [anon_sym_CARET] = ACTIONS(1910),
    [anon_sym_BANG_EQ] = ACTIONS(1908),
    [anon_sym_LT_GT] = ACTIONS(1908),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1916),
    [sym_keyword_from] = ACTIONS(1916),
    [sym_keyword_on] = ACTIONS(1916),
    [sym_keyword_where] = ACTIONS(1916),
    [sym_keyword_desc] = ACTIONS(1916),
    [sym_keyword_asc] = ACTIONS(1916),
    [sym_keyword_limit] = ACTIONS(1916),
    [sym_keyword_primary] = ACTIONS(1916),
    [sym_keyword_create] = ACTIONS(1916),
    [sym_keyword_as] = ACTIONS(1918),
    [sym_keyword_constraint] = ACTIONS(1916),
    [sym_keyword_separator] = ACTIONS(1916),
    [sym_keyword_when] = ACTIONS(1916),
    [sym_keyword_then] = ACTIONS(1916),
    [sym_keyword_else] = ACTIONS(1916),
    [sym_keyword_end] = ACTIONS(1916),
    [sym_keyword_in] = ACTIONS(1916),
    [sym_keyword_and] = ACTIONS(1916),
    [sym_keyword_or] = ACTIONS(1916),
    [sym_keyword_is] = ACTIONS(1916),
    [sym_keyword_not] = ACTIONS(1916),
    [sym_keyword_using] = ACTIONS(1916),
    [sym_keyword_auto_increment] = ACTIONS(1916),
    [sym_keyword_generated] = ACTIONS(1916),
    [sym_keyword_default] = ACTIONS(1916),
    [sym_keyword_returning] = ACTIONS(1916),
    [sym_keyword_first] = ACTIONS(1916),
    [sym_keyword_after] = ACTIONS(1916),
    [sym_keyword_range] = ACTIONS(1916),
    [sym_keyword_rows] = ACTIONS(1916),
    [sym_keyword_groups] = ACTIONS(1916),
    [sym_keyword_between] = ACTIONS(1916),
    [sym_keyword_preceding] = ACTIONS(1916),
    [sym_keyword_following] = ACTIONS(1916),
    [sym_keyword_unique] = ACTIONS(1916),
    [sym_keyword_references] = ACTIONS(1916),
    [aux_sym_keyword_like_token1] = ACTIONS(1916),
    [aux_sym_keyword_like_token2] = ACTIONS(1916),
    [sym_keyword_similar] = ACTIONS(1916),
    [sym_keyword_unsigned] = ACTIONS(1920),
    [sym_keyword_zerofill] = ACTIONS(1922),
    [sym_keyword_check] = ACTIONS(1916),
    [sym_keyword_stored] = ACTIONS(1916),
    [sym_keyword_virtual] = ACTIONS(1916),
    [sym_keyword_comment] = ACTIONS(1916),
    [sym_keyword_null] = ACTIONS(1916),
    [sym_keyword_array] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_RBRACK] = ACTIONS(1916),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_COMMA] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_LT_EQ] = ACTIONS(1916),
    [anon_sym_GT_EQ] = ACTIONS(1916),
    [anon_sym_COLON] = ACTIONS(1918),
    [sym_op_other] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1918),
    [anon_sym_SLASH] = ACTIONS(1918),
    [anon_sym_PERCENT] = ACTIONS(1916),
    [anon_sym_CARET] = ACTIONS(1918),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [anon_sym_LT_GT] = ACTIONS(1916),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1924),
    [sym_keyword_from] = ACTIONS(1924),
    [sym_keyword_on] = ACTIONS(1924),
    [sym_keyword_where] = ACTIONS(1924),
    [sym_keyword_desc] = ACTIONS(1924),
    [sym_keyword_asc] = ACTIONS(1924),
    [sym_keyword_limit] = ACTIONS(1924),
    [sym_keyword_primary] = ACTIONS(1924),
    [sym_keyword_create] = ACTIONS(1924),
    [sym_keyword_as] = ACTIONS(1926),
    [sym_keyword_constraint] = ACTIONS(1924),
    [sym_keyword_separator] = ACTIONS(1924),
    [sym_keyword_when] = ACTIONS(1924),
    [sym_keyword_then] = ACTIONS(1924),
    [sym_keyword_else] = ACTIONS(1924),
    [sym_keyword_end] = ACTIONS(1924),
    [sym_keyword_in] = ACTIONS(1924),
    [sym_keyword_and] = ACTIONS(1924),
    [sym_keyword_or] = ACTIONS(1924),
    [sym_keyword_is] = ACTIONS(1924),
    [sym_keyword_not] = ACTIONS(1924),
    [sym_keyword_using] = ACTIONS(1924),
    [sym_keyword_auto_increment] = ACTIONS(1924),
    [sym_keyword_generated] = ACTIONS(1924),
    [sym_keyword_default] = ACTIONS(1924),
    [sym_keyword_returning] = ACTIONS(1924),
    [sym_keyword_first] = ACTIONS(1924),
    [sym_keyword_after] = ACTIONS(1924),
    [sym_keyword_range] = ACTIONS(1924),
    [sym_keyword_rows] = ACTIONS(1924),
    [sym_keyword_groups] = ACTIONS(1924),
    [sym_keyword_between] = ACTIONS(1924),
    [sym_keyword_preceding] = ACTIONS(1924),
    [sym_keyword_following] = ACTIONS(1924),
    [sym_keyword_unique] = ACTIONS(1924),
    [sym_keyword_references] = ACTIONS(1924),
    [aux_sym_keyword_like_token1] = ACTIONS(1924),
    [aux_sym_keyword_like_token2] = ACTIONS(1924),
    [sym_keyword_similar] = ACTIONS(1924),
    [sym_keyword_unsigned] = ACTIONS(1928),
    [sym_keyword_zerofill] = ACTIONS(1930),
    [sym_keyword_check] = ACTIONS(1924),
    [sym_keyword_stored] = ACTIONS(1924),
    [sym_keyword_virtual] = ACTIONS(1924),
    [sym_keyword_comment] = ACTIONS(1924),
    [sym_keyword_null] = ACTIONS(1924),
    [sym_keyword_array] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_RBRACK] = ACTIONS(1924),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_COMMA] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_COLON] = ACTIONS(1926),
    [sym_op_other] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1926),
    [anon_sym_PERCENT] = ACTIONS(1924),
    [anon_sym_CARET] = ACTIONS(1926),
    [anon_sym_BANG_EQ] = ACTIONS(1924),
    [anon_sym_LT_GT] = ACTIONS(1924),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(1932),
    [anon_sym_SEMI] = ACTIONS(1932),
    [sym_keyword_from] = ACTIONS(1932),
    [sym_keyword_on] = ACTIONS(1932),
    [sym_keyword_where] = ACTIONS(1932),
    [sym_keyword_desc] = ACTIONS(1932),
    [sym_keyword_asc] = ACTIONS(1932),
    [sym_keyword_limit] = ACTIONS(1932),
    [sym_keyword_primary] = ACTIONS(1932),
    [sym_keyword_create] = ACTIONS(1932),
    [sym_keyword_as] = ACTIONS(1934),
    [sym_keyword_constraint] = ACTIONS(1932),
    [sym_keyword_separator] = ACTIONS(1932),
    [sym_keyword_when] = ACTIONS(1932),
    [sym_keyword_then] = ACTIONS(1932),
    [sym_keyword_else] = ACTIONS(1932),
    [sym_keyword_end] = ACTIONS(1932),
    [sym_keyword_in] = ACTIONS(1932),
    [sym_keyword_and] = ACTIONS(1932),
    [sym_keyword_or] = ACTIONS(1932),
    [sym_keyword_is] = ACTIONS(1932),
    [sym_keyword_not] = ACTIONS(1932),
    [sym_keyword_using] = ACTIONS(1932),
    [sym_keyword_auto_increment] = ACTIONS(1932),
    [sym_keyword_generated] = ACTIONS(1932),
    [sym_keyword_default] = ACTIONS(1932),
    [sym_keyword_returning] = ACTIONS(1932),
    [sym_keyword_first] = ACTIONS(1932),
    [sym_keyword_after] = ACTIONS(1932),
    [sym_keyword_range] = ACTIONS(1932),
    [sym_keyword_rows] = ACTIONS(1932),
    [sym_keyword_groups] = ACTIONS(1932),
    [sym_keyword_between] = ACTIONS(1932),
    [sym_keyword_preceding] = ACTIONS(1932),
    [sym_keyword_following] = ACTIONS(1932),
    [sym_keyword_unique] = ACTIONS(1932),
    [sym_keyword_references] = ACTIONS(1932),
    [aux_sym_keyword_like_token1] = ACTIONS(1932),
    [aux_sym_keyword_like_token2] = ACTIONS(1932),
    [sym_keyword_similar] = ACTIONS(1932),
    [sym_keyword_unsigned] = ACTIONS(1936),
    [sym_keyword_zerofill] = ACTIONS(1938),
    [sym_keyword_check] = ACTIONS(1932),
    [sym_keyword_stored] = ACTIONS(1932),
    [sym_keyword_virtual] = ACTIONS(1932),
    [sym_keyword_comment] = ACTIONS(1932),
    [sym_keyword_null] = ACTIONS(1932),
    [sym_keyword_array] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_RBRACK] = ACTIONS(1932),
    [anon_sym_RPAREN] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1932),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_STAR] = ACTIONS(1932),
    [anon_sym_COLON_COLON] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_GT] = ACTIONS(1934),
    [anon_sym_LT_EQ] = ACTIONS(1932),
    [anon_sym_GT_EQ] = ACTIONS(1932),
    [anon_sym_COLON] = ACTIONS(1934),
    [sym_op_other] = ACTIONS(1932),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1934),
    [anon_sym_SLASH] = ACTIONS(1934),
    [anon_sym_PERCENT] = ACTIONS(1932),
    [anon_sym_CARET] = ACTIONS(1934),
    [anon_sym_BANG_EQ] = ACTIONS(1932),
    [anon_sym_LT_GT] = ACTIONS(1932),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1940),
    [sym_keyword_from] = ACTIONS(1940),
    [sym_keyword_on] = ACTIONS(1940),
    [sym_keyword_where] = ACTIONS(1940),
    [sym_keyword_desc] = ACTIONS(1940),
    [sym_keyword_asc] = ACTIONS(1940),
    [sym_keyword_limit] = ACTIONS(1940),
    [sym_keyword_primary] = ACTIONS(1940),
    [sym_keyword_create] = ACTIONS(1940),
    [sym_keyword_as] = ACTIONS(1942),
    [sym_keyword_constraint] = ACTIONS(1940),
    [sym_keyword_separator] = ACTIONS(1940),
    [sym_keyword_when] = ACTIONS(1940),
    [sym_keyword_then] = ACTIONS(1940),
    [sym_keyword_else] = ACTIONS(1940),
    [sym_keyword_end] = ACTIONS(1940),
    [sym_keyword_in] = ACTIONS(1940),
    [sym_keyword_and] = ACTIONS(1940),
    [sym_keyword_or] = ACTIONS(1940),
    [sym_keyword_is] = ACTIONS(1940),
    [sym_keyword_not] = ACTIONS(1940),
    [sym_keyword_using] = ACTIONS(1940),
    [sym_keyword_auto_increment] = ACTIONS(1940),
    [sym_keyword_generated] = ACTIONS(1940),
    [sym_keyword_default] = ACTIONS(1940),
    [sym_keyword_returning] = ACTIONS(1940),
    [sym_keyword_first] = ACTIONS(1940),
    [sym_keyword_after] = ACTIONS(1940),
    [sym_keyword_range] = ACTIONS(1940),
    [sym_keyword_rows] = ACTIONS(1940),
    [sym_keyword_groups] = ACTIONS(1940),
    [sym_keyword_between] = ACTIONS(1940),
    [sym_keyword_preceding] = ACTIONS(1940),
    [sym_keyword_following] = ACTIONS(1940),
    [sym_keyword_unique] = ACTIONS(1940),
    [sym_keyword_references] = ACTIONS(1940),
    [aux_sym_keyword_like_token1] = ACTIONS(1940),
    [aux_sym_keyword_like_token2] = ACTIONS(1940),
    [sym_keyword_similar] = ACTIONS(1940),
    [sym_keyword_unsigned] = ACTIONS(1944),
    [sym_keyword_zerofill] = ACTIONS(1946),
    [sym_keyword_check] = ACTIONS(1940),
    [sym_keyword_stored] = ACTIONS(1940),
    [sym_keyword_virtual] = ACTIONS(1940),
    [sym_keyword_comment] = ACTIONS(1940),
    [sym_keyword_null] = ACTIONS(1940),
    [sym_keyword_array] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1940),
    [anon_sym_RBRACK] = ACTIONS(1940),
    [anon_sym_RPAREN] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(1940),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_LT_EQ] = ACTIONS(1940),
    [anon_sym_GT_EQ] = ACTIONS(1940),
    [anon_sym_COLON] = ACTIONS(1942),
    [sym_op_other] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1942),
    [anon_sym_PERCENT] = ACTIONS(1940),
    [anon_sym_CARET] = ACTIONS(1942),
    [anon_sym_BANG_EQ] = ACTIONS(1940),
    [anon_sym_LT_GT] = ACTIONS(1940),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1948),
    [sym_keyword_from] = ACTIONS(1948),
    [sym_keyword_on] = ACTIONS(1948),
    [sym_keyword_where] = ACTIONS(1948),
    [sym_keyword_desc] = ACTIONS(1948),
    [sym_keyword_asc] = ACTIONS(1948),
    [sym_keyword_limit] = ACTIONS(1948),
    [sym_keyword_primary] = ACTIONS(1948),
    [sym_keyword_create] = ACTIONS(1948),
    [sym_keyword_as] = ACTIONS(1950),
    [sym_keyword_constraint] = ACTIONS(1948),
    [sym_keyword_separator] = ACTIONS(1948),
    [sym_keyword_when] = ACTIONS(1948),
    [sym_keyword_then] = ACTIONS(1948),
    [sym_keyword_else] = ACTIONS(1948),
    [sym_keyword_end] = ACTIONS(1948),
    [sym_keyword_in] = ACTIONS(1948),
    [sym_keyword_and] = ACTIONS(1948),
    [sym_keyword_or] = ACTIONS(1948),
    [sym_keyword_is] = ACTIONS(1948),
    [sym_keyword_not] = ACTIONS(1948),
    [sym_keyword_using] = ACTIONS(1948),
    [sym_keyword_auto_increment] = ACTIONS(1948),
    [sym_keyword_generated] = ACTIONS(1948),
    [sym_keyword_default] = ACTIONS(1948),
    [sym_keyword_returning] = ACTIONS(1948),
    [sym_keyword_first] = ACTIONS(1948),
    [sym_keyword_after] = ACTIONS(1948),
    [sym_keyword_range] = ACTIONS(1948),
    [sym_keyword_rows] = ACTIONS(1948),
    [sym_keyword_groups] = ACTIONS(1948),
    [sym_keyword_between] = ACTIONS(1948),
    [sym_keyword_preceding] = ACTIONS(1948),
    [sym_keyword_following] = ACTIONS(1948),
    [sym_keyword_unique] = ACTIONS(1948),
    [sym_keyword_references] = ACTIONS(1948),
    [aux_sym_keyword_like_token1] = ACTIONS(1948),
    [aux_sym_keyword_like_token2] = ACTIONS(1948),
    [sym_keyword_similar] = ACTIONS(1948),
    [sym_keyword_check] = ACTIONS(1948),
    [sym_keyword_stored] = ACTIONS(1948),
    [sym_keyword_virtual] = ACTIONS(1948),
    [sym_keyword_comment] = ACTIONS(1948),
    [sym_keyword_null] = ACTIONS(1948),
    [sym_keyword_varying] = ACTIONS(1952),
    [sym_keyword_array] = ACTIONS(1948),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_RBRACK] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_COMMA] = ACTIONS(1948),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(1950),
    [anon_sym_GT] = ACTIONS(1950),
    [anon_sym_LT_EQ] = ACTIONS(1948),
    [anon_sym_GT_EQ] = ACTIONS(1948),
    [anon_sym_COLON] = ACTIONS(1950),
    [sym_op_other] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_SLASH] = ACTIONS(1950),
    [anon_sym_PERCENT] = ACTIONS(1948),
    [anon_sym_CARET] = ACTIONS(1950),
    [anon_sym_BANG_EQ] = ACTIONS(1948),
    [anon_sym_LT_GT] = ACTIONS(1948),
  },
  [174] = {
    [sym__identifier] = ACTIONS(1956),
    [aux_sym_keyword_character_token1] = ACTIONS(1956),
    [sym_keyword_unsigned] = ACTIONS(1956),
    [sym_keyword_boolean] = ACTIONS(1956),
    [sym_keyword_bit] = ACTIONS(1956),
    [sym_keyword_binary] = ACTIONS(1956),
    [sym_keyword_varbinary] = ACTIONS(1956),
    [sym_keyword_image] = ACTIONS(1956),
    [aux_sym_keyword_smallserial_token1] = ACTIONS(1956),
    [aux_sym_keyword_smallserial_token2] = ACTIONS(1956),
    [aux_sym_keyword_serial_token1] = ACTIONS(1956),
    [aux_sym_keyword_serial_token2] = ACTIONS(1956),
    [aux_sym_keyword_bigserial_token1] = ACTIONS(1956),
    [aux_sym_keyword_bigserial_token2] = ACTIONS(1956),
    [aux_sym_keyword_tinyint_token1] = ACTIONS(1956),
    [aux_sym_keyword_tinyint_token2] = ACTIONS(1956),
    [aux_sym_keyword_smallint_token1] = ACTIONS(1956),
    [aux_sym_keyword_smallint_token2] = ACTIONS(1956),
    [aux_sym_keyword_mediumint_token1] = ACTIONS(1956),
    [aux_sym_keyword_mediumint_token2] = ACTIONS(1956),
    [aux_sym_keyword_int_token1] = ACTIONS(1956),
    [aux_sym_keyword_int_token2] = ACTIONS(1956),
    [aux_sym_keyword_int_token3] = ACTIONS(1956),
    [aux_sym_keyword_bigint_token1] = ACTIONS(1956),
    [aux_sym_keyword_bigint_token2] = ACTIONS(1956),
    [sym_keyword_decimal] = ACTIONS(1956),
    [sym_keyword_numeric] = ACTIONS(1956),
    [aux_sym_keyword_real_token1] = ACTIONS(1956),
    [aux_sym_keyword_real_token2] = ACTIONS(1956),
    [sym_keyword_float] = ACTIONS(1956),
    [sym_keyword_double] = ACTIONS(1956),
    [sym_keyword_inet] = ACTIONS(1956),
    [sym_keyword_money] = ACTIONS(1956),
    [sym_keyword_smallmoney] = ACTIONS(1956),
    [aux_sym_keyword_char_token1] = ACTIONS(1956),
    [sym_keyword_nchar] = ACTIONS(1956),
    [aux_sym_keyword_varchar_token1] = ACTIONS(1956),
    [sym_keyword_nvarchar] = ACTIONS(1956),
    [sym_keyword_text] = ACTIONS(1956),
    [sym_keyword_string] = ACTIONS(1956),
    [sym_keyword_uuid] = ACTIONS(1956),
    [sym_keyword_json] = ACTIONS(1956),
    [sym_keyword_jsonb] = ACTIONS(1956),
    [sym_keyword_xml] = ACTIONS(1956),
    [sym_keyword_bytea] = ACTIONS(1956),
    [sym_keyword_enum] = ACTIONS(1956),
    [sym_keyword_date] = ACTIONS(1956),
    [sym_keyword_datetime] = ACTIONS(1956),
    [sym_keyword_datetime2] = ACTIONS(1956),
    [sym_keyword_smalldatetime] = ACTIONS(1956),
    [sym_keyword_datetimeoffset] = ACTIONS(1956),
    [sym_keyword_time] = ACTIONS(1956),
    [sym_keyword_timestamp] = ACTIONS(1956),
    [sym_keyword_timestamptz] = ACTIONS(1956),
    [sym_keyword_interval] = ACTIONS(1956),
    [sym_keyword_geometry] = ACTIONS(1956),
    [sym_keyword_geography] = ACTIONS(1956),
    [sym_keyword_box2d] = ACTIONS(1956),
    [sym_keyword_box3d] = ACTIONS(1956),
    [sym_keyword_oid] = ACTIONS(1956),
    [sym_keyword_name] = ACTIONS(1956),
    [sym_keyword_regclass] = ACTIONS(1956),
    [sym_keyword_regnamespace] = ACTIONS(1956),
    [sym_keyword_regproc] = ACTIONS(1956),
    [sym_keyword_regtype] = ACTIONS(1956),
    [aux_sym_double_token1] = ACTIONS(1956),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [sym__double_quote_string] = ACTIONS(1958),
    [aux_sym_identifier_token1] = ACTIONS(1958),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_keyword_from] = ACTIONS(1960),
    [sym_keyword_on] = ACTIONS(1960),
    [sym_keyword_where] = ACTIONS(1960),
    [sym_keyword_desc] = ACTIONS(1960),
    [sym_keyword_asc] = ACTIONS(1960),
    [sym_keyword_limit] = ACTIONS(1960),
    [sym_keyword_primary] = ACTIONS(1960),
    [sym_keyword_create] = ACTIONS(1960),
    [sym_keyword_as] = ACTIONS(1962),
    [sym_keyword_constraint] = ACTIONS(1960),
    [sym_keyword_separator] = ACTIONS(1960),
    [sym_keyword_when] = ACTIONS(1960),
    [sym_keyword_then] = ACTIONS(1960),
    [sym_keyword_else] = ACTIONS(1960),
    [sym_keyword_end] = ACTIONS(1960),
    [sym_keyword_in] = ACTIONS(1960),
    [sym_keyword_and] = ACTIONS(1960),
    [sym_keyword_or] = ACTIONS(1960),
    [sym_keyword_is] = ACTIONS(1960),
    [sym_keyword_not] = ACTIONS(1960),
    [sym_keyword_using] = ACTIONS(1960),
    [sym_keyword_auto_increment] = ACTIONS(1960),
    [sym_keyword_generated] = ACTIONS(1960),
    [sym_keyword_default] = ACTIONS(1960),
    [sym_keyword_returning] = ACTIONS(1960),
    [sym_keyword_first] = ACTIONS(1960),
    [sym_keyword_after] = ACTIONS(1960),
    [sym_keyword_range] = ACTIONS(1960),
    [sym_keyword_rows] = ACTIONS(1960),
    [sym_keyword_groups] = ACTIONS(1960),
    [sym_keyword_between] = ACTIONS(1960),
    [sym_keyword_preceding] = ACTIONS(1960),
    [sym_keyword_following] = ACTIONS(1960),
    [sym_keyword_unique] = ACTIONS(1960),
    [sym_keyword_references] = ACTIONS(1960),
    [aux_sym_keyword_like_token1] = ACTIONS(1960),
    [aux_sym_keyword_like_token2] = ACTIONS(1960),
    [sym_keyword_similar] = ACTIONS(1960),
    [sym_keyword_check] = ACTIONS(1960),
    [sym_keyword_stored] = ACTIONS(1960),
    [sym_keyword_virtual] = ACTIONS(1960),
    [sym_keyword_comment] = ACTIONS(1960),
    [sym_keyword_null] = ACTIONS(1960),
    [sym_keyword_varying] = ACTIONS(1964),
    [sym_keyword_array] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1960),
    [anon_sym_RBRACK] = ACTIONS(1960),
    [anon_sym_LPAREN] = ACTIONS(1960),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_COMMA] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_LT_EQ] = ACTIONS(1960),
    [anon_sym_GT_EQ] = ACTIONS(1960),
    [anon_sym_COLON] = ACTIONS(1962),
    [sym_op_other] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1962),
    [anon_sym_SLASH] = ACTIONS(1962),
    [anon_sym_PERCENT] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_LT_GT] = ACTIONS(1960),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1966),
    [anon_sym_SEMI] = ACTIONS(1966),
    [sym_keyword_from] = ACTIONS(1966),
    [sym_keyword_on] = ACTIONS(1966),
    [sym_keyword_where] = ACTIONS(1966),
    [sym_keyword_desc] = ACTIONS(1966),
    [sym_keyword_asc] = ACTIONS(1966),
    [sym_keyword_limit] = ACTIONS(1966),
    [sym_keyword_primary] = ACTIONS(1966),
    [sym_keyword_create] = ACTIONS(1966),
    [sym_keyword_as] = ACTIONS(1968),
    [sym_keyword_constraint] = ACTIONS(1966),
    [sym_keyword_separator] = ACTIONS(1966),
    [sym_keyword_when] = ACTIONS(1966),
    [sym_keyword_then] = ACTIONS(1966),
    [sym_keyword_else] = ACTIONS(1966),
    [sym_keyword_end] = ACTIONS(1966),
    [sym_keyword_in] = ACTIONS(1966),
    [sym_keyword_and] = ACTIONS(1966),
    [sym_keyword_or] = ACTIONS(1966),
    [sym_keyword_is] = ACTIONS(1966),
    [sym_keyword_not] = ACTIONS(1966),
    [sym_keyword_using] = ACTIONS(1966),
    [sym_keyword_auto_increment] = ACTIONS(1966),
    [sym_keyword_generated] = ACTIONS(1966),
    [sym_keyword_default] = ACTIONS(1966),
    [sym_keyword_returning] = ACTIONS(1966),
    [sym_keyword_first] = ACTIONS(1966),
    [sym_keyword_after] = ACTIONS(1966),
    [sym_keyword_range] = ACTIONS(1966),
    [sym_keyword_rows] = ACTIONS(1966),
    [sym_keyword_groups] = ACTIONS(1966),
    [sym_keyword_between] = ACTIONS(1966),
    [sym_keyword_preceding] = ACTIONS(1966),
    [sym_keyword_following] = ACTIONS(1966),
    [sym_keyword_unique] = ACTIONS(1966),
    [sym_keyword_references] = ACTIONS(1966),
    [aux_sym_keyword_like_token1] = ACTIONS(1966),
    [aux_sym_keyword_like_token2] = ACTIONS(1966),
    [sym_keyword_similar] = ACTIONS(1966),
    [sym_keyword_unsigned] = ACTIONS(1970),
    [sym_keyword_zerofill] = ACTIONS(1972),
    [sym_keyword_check] = ACTIONS(1966),
    [sym_keyword_stored] = ACTIONS(1966),
    [sym_keyword_virtual] = ACTIONS(1966),
    [sym_keyword_comment] = ACTIONS(1966),
    [sym_keyword_null] = ACTIONS(1966),
    [sym_keyword_array] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_RBRACK] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1968),
    [sym_op_other] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1968),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_LT_GT] = ACTIONS(1966),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [sym_keyword_from] = ACTIONS(1852),
    [sym_keyword_on] = ACTIONS(1852),
    [sym_keyword_where] = ACTIONS(1852),
    [sym_keyword_desc] = ACTIONS(1852),
    [sym_keyword_asc] = ACTIONS(1852),
    [sym_keyword_limit] = ACTIONS(1852),
    [sym_keyword_primary] = ACTIONS(1852),
    [sym_keyword_create] = ACTIONS(1852),
    [sym_keyword_as] = ACTIONS(1854),
    [sym_keyword_constraint] = ACTIONS(1852),
    [sym_keyword_separator] = ACTIONS(1852),
    [sym_keyword_when] = ACTIONS(1852),
    [sym_keyword_then] = ACTIONS(1852),
    [sym_keyword_else] = ACTIONS(1852),
    [sym_keyword_end] = ACTIONS(1852),
    [sym_keyword_in] = ACTIONS(1852),
    [sym_keyword_and] = ACTIONS(1852),
    [sym_keyword_or] = ACTIONS(1852),
    [sym_keyword_is] = ACTIONS(1852),
    [sym_keyword_not] = ACTIONS(1852),
    [sym_keyword_using] = ACTIONS(1852),
    [sym_keyword_auto_increment] = ACTIONS(1852),
    [sym_keyword_generated] = ACTIONS(1852),
    [sym_keyword_default] = ACTIONS(1852),
    [sym_keyword_returning] = ACTIONS(1852),
    [sym_keyword_first] = ACTIONS(1852),
    [sym_keyword_after] = ACTIONS(1852),
    [sym_keyword_range] = ACTIONS(1852),
    [sym_keyword_rows] = ACTIONS(1852),
    [sym_keyword_groups] = ACTIONS(1852),
    [sym_keyword_between] = ACTIONS(1852),
    [sym_keyword_preceding] = ACTIONS(1852),
    [sym_keyword_following] = ACTIONS(1852),
    [sym_keyword_unique] = ACTIONS(1852),
    [sym_keyword_references] = ACTIONS(1852),
    [aux_sym_keyword_like_token1] = ACTIONS(1852),
    [aux_sym_keyword_like_token2] = ACTIONS(1852),
    [sym_keyword_similar] = ACTIONS(1852),
    [sym_keyword_check] = ACTIONS(1852),
    [sym_keyword_stored] = ACTIONS(1852),
    [sym_keyword_virtual] = ACTIONS(1852),
    [sym_keyword_comment] = ACTIONS(1852),
    [sym_keyword_null] = ACTIONS(1852),
    [sym_keyword_precision] = ACTIONS(1974),
    [sym_keyword_array] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1976),
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1854),
    [sym_op_other] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1854),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_LT_GT] = ACTIONS(1852),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(1978),
    [anon_sym_SEMI] = ACTIONS(1978),
    [sym_keyword_from] = ACTIONS(1978),
    [sym_keyword_on] = ACTIONS(1978),
    [sym_keyword_where] = ACTIONS(1978),
    [sym_keyword_desc] = ACTIONS(1978),
    [sym_keyword_asc] = ACTIONS(1978),
    [sym_keyword_limit] = ACTIONS(1978),
    [sym_keyword_primary] = ACTIONS(1978),
    [sym_keyword_create] = ACTIONS(1978),
    [sym_keyword_as] = ACTIONS(1980),
    [sym_keyword_constraint] = ACTIONS(1978),
    [sym_keyword_separator] = ACTIONS(1978),
    [sym_keyword_when] = ACTIONS(1978),
    [sym_keyword_then] = ACTIONS(1978),
    [sym_keyword_else] = ACTIONS(1978),
    [sym_keyword_end] = ACTIONS(1978),
    [sym_keyword_in] = ACTIONS(1978),
    [sym_keyword_and] = ACTIONS(1978),
    [sym_keyword_or] = ACTIONS(1978),
    [sym_keyword_is] = ACTIONS(1978),
    [sym_keyword_not] = ACTIONS(1978),
    [sym_keyword_using] = ACTIONS(1978),
    [sym_keyword_auto_increment] = ACTIONS(1978),
    [sym_keyword_generated] = ACTIONS(1978),
    [sym_keyword_default] = ACTIONS(1978),
    [sym_keyword_returning] = ACTIONS(1978),
    [sym_keyword_first] = ACTIONS(1978),
    [sym_keyword_after] = ACTIONS(1978),
    [sym_keyword_range] = ACTIONS(1978),
    [sym_keyword_rows] = ACTIONS(1978),
    [sym_keyword_groups] = ACTIONS(1978),
    [sym_keyword_between] = ACTIONS(1978),
    [sym_keyword_preceding] = ACTIONS(1978),
    [sym_keyword_following] = ACTIONS(1978),
    [sym_keyword_unique] = ACTIONS(1978),
    [sym_keyword_references] = ACTIONS(1978),
    [aux_sym_keyword_like_token1] = ACTIONS(1978),
    [aux_sym_keyword_like_token2] = ACTIONS(1978),
    [sym_keyword_similar] = ACTIONS(1978),
    [sym_keyword_unsigned] = ACTIONS(1982),
    [sym_keyword_zerofill] = ACTIONS(1984),
    [sym_keyword_check] = ACTIONS(1978),
    [sym_keyword_stored] = ACTIONS(1978),
    [sym_keyword_virtual] = ACTIONS(1978),
    [sym_keyword_comment] = ACTIONS(1978),
    [sym_keyword_null] = ACTIONS(1978),
    [sym_keyword_array] = ACTIONS(1978),
    [anon_sym_LBRACK] = ACTIONS(1978),
    [anon_sym_RBRACK] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1978),
    [anon_sym_COMMA] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LT] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1980),
    [anon_sym_LT_EQ] = ACTIONS(1978),
    [anon_sym_GT_EQ] = ACTIONS(1978),
    [anon_sym_COLON] = ACTIONS(1980),
    [sym_op_other] = ACTIONS(1978),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1980),
    [anon_sym_PERCENT] = ACTIONS(1978),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_BANG_EQ] = ACTIONS(1978),
    [anon_sym_LT_GT] = ACTIONS(1978),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(1986),
    [anon_sym_SEMI] = ACTIONS(1986),
    [sym_keyword_from] = ACTIONS(1986),
    [sym_keyword_on] = ACTIONS(1986),
    [sym_keyword_where] = ACTIONS(1986),
    [sym_keyword_desc] = ACTIONS(1986),
    [sym_keyword_asc] = ACTIONS(1986),
    [sym_keyword_limit] = ACTIONS(1986),
    [sym_keyword_primary] = ACTIONS(1986),
    [sym_keyword_create] = ACTIONS(1986),
    [sym_keyword_as] = ACTIONS(1988),
    [sym_keyword_constraint] = ACTIONS(1986),
    [sym_keyword_separator] = ACTIONS(1986),
    [sym_keyword_when] = ACTIONS(1986),
    [sym_keyword_then] = ACTIONS(1986),
    [sym_keyword_else] = ACTIONS(1986),
    [sym_keyword_end] = ACTIONS(1986),
    [sym_keyword_in] = ACTIONS(1986),
    [sym_keyword_and] = ACTIONS(1986),
    [sym_keyword_or] = ACTIONS(1986),
    [sym_keyword_is] = ACTIONS(1986),
    [sym_keyword_not] = ACTIONS(1986),
    [sym_keyword_using] = ACTIONS(1986),
    [sym_keyword_auto_increment] = ACTIONS(1986),
    [sym_keyword_generated] = ACTIONS(1986),
    [sym_keyword_default] = ACTIONS(1986),
    [sym_keyword_returning] = ACTIONS(1986),
    [sym_keyword_first] = ACTIONS(1986),
    [sym_keyword_after] = ACTIONS(1986),
    [sym_keyword_range] = ACTIONS(1986),
    [sym_keyword_rows] = ACTIONS(1986),
    [sym_keyword_groups] = ACTIONS(1986),
    [sym_keyword_between] = ACTIONS(1986),
    [sym_keyword_preceding] = ACTIONS(1986),
    [sym_keyword_following] = ACTIONS(1986),
    [sym_keyword_unique] = ACTIONS(1986),
    [sym_keyword_references] = ACTIONS(1986),
    [aux_sym_keyword_like_token1] = ACTIONS(1986),
    [aux_sym_keyword_like_token2] = ACTIONS(1986),
    [sym_keyword_similar] = ACTIONS(1986),
    [sym_keyword_unsigned] = ACTIONS(1990),
    [sym_keyword_zerofill] = ACTIONS(1992),
    [sym_keyword_check] = ACTIONS(1986),
    [sym_keyword_stored] = ACTIONS(1986),
    [sym_keyword_virtual] = ACTIONS(1986),
    [sym_keyword_comment] = ACTIONS(1986),
    [sym_keyword_null] = ACTIONS(1986),
    [sym_keyword_array] = ACTIONS(1986),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_RBRACK] = ACTIONS(1986),
    [anon_sym_RPAREN] = ACTIONS(1986),
    [anon_sym_COMMA] = ACTIONS(1986),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_LT_EQ] = ACTIONS(1986),
    [anon_sym_GT_EQ] = ACTIONS(1986),
    [anon_sym_COLON] = ACTIONS(1988),
    [sym_op_other] = ACTIONS(1986),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_SLASH] = ACTIONS(1988),
    [anon_sym_PERCENT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1986),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(1994),
    [anon_sym_SEMI] = ACTIONS(1994),
    [sym_keyword_from] = ACTIONS(1994),
    [sym_keyword_on] = ACTIONS(1994),
    [sym_keyword_where] = ACTIONS(1994),
    [sym_keyword_desc] = ACTIONS(1994),
    [sym_keyword_asc] = ACTIONS(1994),
    [sym_keyword_limit] = ACTIONS(1994),
    [sym_keyword_primary] = ACTIONS(1994),
    [sym_keyword_create] = ACTIONS(1994),
    [sym_keyword_as] = ACTIONS(1996),
    [sym_keyword_constraint] = ACTIONS(1994),
    [sym_keyword_separator] = ACTIONS(1994),
    [sym_keyword_when] = ACTIONS(1994),
    [sym_keyword_then] = ACTIONS(1994),
    [sym_keyword_else] = ACTIONS(1994),
    [sym_keyword_end] = ACTIONS(1994),
    [sym_keyword_in] = ACTIONS(1994),
    [sym_keyword_and] = ACTIONS(1994),
    [sym_keyword_or] = ACTIONS(1994),
    [sym_keyword_is] = ACTIONS(1994),
    [sym_keyword_not] = ACTIONS(1994),
    [sym_keyword_using] = ACTIONS(1994),
    [sym_keyword_auto_increment] = ACTIONS(1994),
    [sym_keyword_generated] = ACTIONS(1994),
    [sym_keyword_default] = ACTIONS(1994),
    [sym_keyword_returning] = ACTIONS(1994),
    [sym_keyword_first] = ACTIONS(1994),
    [sym_keyword_after] = ACTIONS(1994),
    [sym_keyword_range] = ACTIONS(1994),
    [sym_keyword_rows] = ACTIONS(1994),
    [sym_keyword_groups] = ACTIONS(1994),
    [sym_keyword_between] = ACTIONS(1994),
    [sym_keyword_preceding] = ACTIONS(1994),
    [sym_keyword_following] = ACTIONS(1994),
    [sym_keyword_unique] = ACTIONS(1994),
    [sym_keyword_references] = ACTIONS(1994),
    [aux_sym_keyword_like_token1] = ACTIONS(1994),
    [aux_sym_keyword_like_token2] = ACTIONS(1994),
    [sym_keyword_similar] = ACTIONS(1994),
    [sym_keyword_check] = ACTIONS(1994),
    [sym_keyword_stored] = ACTIONS(1994),
    [sym_keyword_virtual] = ACTIONS(1994),
    [sym_keyword_comment] = ACTIONS(1994),
    [sym_keyword_null] = ACTIONS(1994),
    [sym_keyword_array] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_RBRACK] = ACTIONS(1994),
    [anon_sym_LPAREN] = ACTIONS(1998),
    [anon_sym_RPAREN] = ACTIONS(1994),
    [anon_sym_COMMA] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_LT] = ACTIONS(1996),
    [anon_sym_GT] = ACTIONS(1996),
    [anon_sym_LT_EQ] = ACTIONS(1994),
    [anon_sym_GT_EQ] = ACTIONS(1994),
    [anon_sym_COLON] = ACTIONS(1996),
    [sym_op_other] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_SLASH] = ACTIONS(1996),
    [anon_sym_PERCENT] = ACTIONS(1994),
    [anon_sym_CARET] = ACTIONS(1996),
    [anon_sym_BANG_EQ] = ACTIONS(1994),
    [anon_sym_LT_GT] = ACTIONS(1994),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(2000),
    [sym__identifier] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2000),
    [sym_keyword_select] = ACTIONS(2002),
    [sym_keyword_values] = ACTIONS(2002),
    [sym_keyword_set] = ACTIONS(2002),
    [sym_keyword_left] = ACTIONS(2002),
    [sym_keyword_right] = ACTIONS(2002),
    [sym_keyword_inner] = ACTIONS(2002),
    [sym_keyword_full] = ACTIONS(2002),
    [sym_keyword_cross] = ACTIONS(2002),
    [sym_keyword_join] = ACTIONS(2002),
    [sym_keyword_natural] = ACTIONS(2002),
    [sym_keyword_on] = ACTIONS(2002),
    [sym_keyword_where] = ACTIONS(2002),
    [sym_keyword_order] = ACTIONS(2002),
    [sym_keyword_group] = ACTIONS(2002),
    [sym_keyword_partition] = ACTIONS(2002),
    [sym_keyword_limit] = ACTIONS(2002),
    [sym_keyword_create] = ACTIONS(2002),
    [sym_keyword_increment] = ACTIONS(2002),
    [sym_keyword_minvalue] = ACTIONS(2002),
    [sym_keyword_maxvalue] = ACTIONS(2002),
    [sym_keyword_owned] = ACTIONS(2002),
    [sym_keyword_start] = ACTIONS(2002),
    [sym_keyword_restart] = ACTIONS(2002),
    [sym_keyword_as] = ACTIONS(2002),
    [sym_keyword_when] = ACTIONS(2002),
    [sym_keyword_is] = ACTIONS(2002),
    [sym_keyword_force] = ACTIONS(2002),
    [sym_keyword_ignore] = ACTIONS(2002),
    [sym_keyword_using] = ACTIONS(2002),
    [sym_keyword_use] = ACTIONS(2002),
    [sym_keyword_collate] = ACTIONS(2002),
    [sym_keyword_default] = ACTIONS(2002),
    [sym_keyword_cascade] = ACTIONS(2002),
    [sym_keyword_restrict] = ACTIONS(2002),
    [sym_keyword_with] = ACTIONS(2002),
    [sym_keyword_no] = ACTIONS(2002),
    [sym_keyword_rename] = ACTIONS(2002),
    [sym_keyword_to] = ACTIONS(2002),
    [sym_keyword_owner] = ACTIONS(2002),
    [sym_keyword_cycle] = ACTIONS(2002),
    [sym_keyword_union] = ACTIONS(2002),
    [sym_keyword_except] = ACTIONS(2002),
    [sym_keyword_intersect] = ACTIONS(2002),
    [sym_keyword_returning] = ACTIONS(2002),
    [sym_keyword_after] = ACTIONS(2002),
    [sym_keyword_before] = ACTIONS(2002),
    [sym_keyword_window] = ACTIONS(2002),
    [sym_keyword_wait] = ACTIONS(2002),
    [sym_keyword_nowait] = ACTIONS(2002),
    [sym_keyword_instead] = ACTIONS(2002),
    [sym_keyword_compute] = ACTIONS(2002),
    [sym_keyword_rewrite] = ACTIONS(2002),
    [sym_keyword_partitioned] = ACTIONS(2002),
    [sym_keyword_cache] = ACTIONS(2002),
    [sym_keyword_array] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_LPAREN] = ACTIONS(2000),
    [anon_sym_RPAREN] = ACTIONS(2000),
    [anon_sym_COMMA] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2000),
    [anon_sym_COLON_EQ] = ACTIONS(2000),
    [anon_sym_DOT] = ACTIONS(2000),
    [sym__double_quote_string] = ACTIONS(2000),
    [aux_sym_identifier_token1] = ACTIONS(2000),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2004),
    [sym_keyword_from] = ACTIONS(2004),
    [sym_keyword_on] = ACTIONS(2004),
    [sym_keyword_where] = ACTIONS(2004),
    [sym_keyword_desc] = ACTIONS(2004),
    [sym_keyword_asc] = ACTIONS(2004),
    [sym_keyword_limit] = ACTIONS(2004),
    [sym_keyword_primary] = ACTIONS(2004),
    [sym_keyword_create] = ACTIONS(2004),
    [sym_keyword_as] = ACTIONS(2006),
    [sym_keyword_constraint] = ACTIONS(2004),
    [sym_keyword_separator] = ACTIONS(2004),
    [sym_keyword_when] = ACTIONS(2004),
    [sym_keyword_then] = ACTIONS(2004),
    [sym_keyword_else] = ACTIONS(2004),
    [sym_keyword_end] = ACTIONS(2004),
    [sym_keyword_in] = ACTIONS(2004),
    [sym_keyword_and] = ACTIONS(2004),
    [sym_keyword_or] = ACTIONS(2004),
    [sym_keyword_is] = ACTIONS(2004),
    [sym_keyword_not] = ACTIONS(2004),
    [sym_keyword_using] = ACTIONS(2004),
    [sym_keyword_auto_increment] = ACTIONS(2004),
    [sym_keyword_generated] = ACTIONS(2004),
    [sym_keyword_default] = ACTIONS(2004),
    [sym_keyword_returning] = ACTIONS(2004),
    [sym_keyword_first] = ACTIONS(2004),
    [sym_keyword_after] = ACTIONS(2004),
    [sym_keyword_range] = ACTIONS(2004),
    [sym_keyword_rows] = ACTIONS(2004),
    [sym_keyword_groups] = ACTIONS(2004),
    [sym_keyword_between] = ACTIONS(2004),
    [sym_keyword_preceding] = ACTIONS(2004),
    [sym_keyword_following] = ACTIONS(2004),
    [sym_keyword_unique] = ACTIONS(2004),
    [sym_keyword_references] = ACTIONS(2004),
    [aux_sym_keyword_like_token1] = ACTIONS(2004),
    [aux_sym_keyword_like_token2] = ACTIONS(2004),
    [sym_keyword_similar] = ACTIONS(2004),
    [sym_keyword_zerofill] = ACTIONS(2008),
    [sym_keyword_check] = ACTIONS(2004),
    [sym_keyword_stored] = ACTIONS(2004),
    [sym_keyword_virtual] = ACTIONS(2004),
    [sym_keyword_comment] = ACTIONS(2004),
    [sym_keyword_null] = ACTIONS(2004),
    [sym_keyword_array] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_RBRACK] = ACTIONS(2004),
    [anon_sym_RPAREN] = ACTIONS(2004),
    [anon_sym_COMMA] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2006),
    [anon_sym_LT_EQ] = ACTIONS(2004),
    [anon_sym_GT_EQ] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2006),
    [sym_op_other] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_DASH] = ACTIONS(2006),
    [anon_sym_SLASH] = ACTIONS(2006),
    [anon_sym_PERCENT] = ACTIONS(2004),
    [anon_sym_CARET] = ACTIONS(2006),
    [anon_sym_BANG_EQ] = ACTIONS(2004),
    [anon_sym_LT_GT] = ACTIONS(2004),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(2010),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_keyword_from] = ACTIONS(2010),
    [sym_keyword_on] = ACTIONS(2010),
    [sym_keyword_where] = ACTIONS(2010),
    [sym_keyword_desc] = ACTIONS(2010),
    [sym_keyword_asc] = ACTIONS(2010),
    [sym_keyword_limit] = ACTIONS(2010),
    [sym_keyword_primary] = ACTIONS(2010),
    [sym_keyword_create] = ACTIONS(2010),
    [sym_keyword_as] = ACTIONS(2012),
    [sym_keyword_constraint] = ACTIONS(2010),
    [sym_keyword_separator] = ACTIONS(2010),
    [sym_keyword_when] = ACTIONS(2010),
    [sym_keyword_then] = ACTIONS(2010),
    [sym_keyword_else] = ACTIONS(2010),
    [sym_keyword_end] = ACTIONS(2010),
    [sym_keyword_in] = ACTIONS(2010),
    [sym_keyword_and] = ACTIONS(2010),
    [sym_keyword_or] = ACTIONS(2010),
    [sym_keyword_is] = ACTIONS(2010),
    [sym_keyword_not] = ACTIONS(2010),
    [sym_keyword_using] = ACTIONS(2010),
    [sym_keyword_auto_increment] = ACTIONS(2010),
    [sym_keyword_generated] = ACTIONS(2010),
    [sym_keyword_default] = ACTIONS(2010),
    [sym_keyword_returning] = ACTIONS(2010),
    [sym_keyword_first] = ACTIONS(2010),
    [sym_keyword_after] = ACTIONS(2010),
    [sym_keyword_range] = ACTIONS(2010),
    [sym_keyword_rows] = ACTIONS(2010),
    [sym_keyword_groups] = ACTIONS(2010),
    [sym_keyword_between] = ACTIONS(2010),
    [sym_keyword_preceding] = ACTIONS(2010),
    [sym_keyword_following] = ACTIONS(2010),
    [sym_keyword_unique] = ACTIONS(2010),
    [sym_keyword_references] = ACTIONS(2010),
    [aux_sym_keyword_like_token1] = ACTIONS(2010),
    [aux_sym_keyword_like_token2] = ACTIONS(2010),
    [sym_keyword_similar] = ACTIONS(2010),
    [sym_keyword_zerofill] = ACTIONS(2014),
    [sym_keyword_check] = ACTIONS(2010),
    [sym_keyword_stored] = ACTIONS(2010),
    [sym_keyword_virtual] = ACTIONS(2010),
    [sym_keyword_comment] = ACTIONS(2010),
    [sym_keyword_null] = ACTIONS(2010),
    [sym_keyword_array] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_COMMA] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2010),
    [anon_sym_GT_EQ] = ACTIONS(2010),
    [anon_sym_COLON] = ACTIONS(2012),
    [sym_op_other] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2010),
    [anon_sym_CARET] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2010),
    [anon_sym_LT_GT] = ACTIONS(2010),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2016),
    [sym_keyword_from] = ACTIONS(2016),
    [sym_keyword_on] = ACTIONS(2016),
    [sym_keyword_where] = ACTIONS(2016),
    [sym_keyword_desc] = ACTIONS(2016),
    [sym_keyword_asc] = ACTIONS(2016),
    [sym_keyword_limit] = ACTIONS(2016),
    [sym_keyword_primary] = ACTIONS(2016),
    [sym_keyword_create] = ACTIONS(2016),
    [sym_keyword_as] = ACTIONS(2018),
    [sym_keyword_constraint] = ACTIONS(2016),
    [sym_keyword_separator] = ACTIONS(2016),
    [sym_keyword_when] = ACTIONS(2016),
    [sym_keyword_then] = ACTIONS(2016),
    [sym_keyword_else] = ACTIONS(2016),
    [sym_keyword_end] = ACTIONS(2016),
    [sym_keyword_in] = ACTIONS(2016),
    [sym_keyword_and] = ACTIONS(2016),
    [sym_keyword_or] = ACTIONS(2016),
    [sym_keyword_is] = ACTIONS(2016),
    [sym_keyword_not] = ACTIONS(2016),
    [sym_keyword_using] = ACTIONS(2016),
    [sym_keyword_auto_increment] = ACTIONS(2016),
    [sym_keyword_generated] = ACTIONS(2016),
    [sym_keyword_default] = ACTIONS(2016),
    [sym_keyword_returning] = ACTIONS(2016),
    [sym_keyword_first] = ACTIONS(2016),
    [sym_keyword_after] = ACTIONS(2016),
    [sym_keyword_range] = ACTIONS(2016),
    [sym_keyword_rows] = ACTIONS(2016),
    [sym_keyword_groups] = ACTIONS(2016),
    [sym_keyword_between] = ACTIONS(2016),
    [sym_keyword_preceding] = ACTIONS(2016),
    [sym_keyword_following] = ACTIONS(2016),
    [sym_keyword_unique] = ACTIONS(2016),
    [sym_keyword_references] = ACTIONS(2016),
    [aux_sym_keyword_like_token1] = ACTIONS(2016),
    [aux_sym_keyword_like_token2] = ACTIONS(2016),
    [sym_keyword_similar] = ACTIONS(2016),
    [sym_keyword_zerofill] = ACTIONS(2020),
    [sym_keyword_check] = ACTIONS(2016),
    [sym_keyword_stored] = ACTIONS(2016),
    [sym_keyword_virtual] = ACTIONS(2016),
    [sym_keyword_comment] = ACTIONS(2016),
    [sym_keyword_null] = ACTIONS(2016),
    [sym_keyword_array] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_RBRACK] = ACTIONS(2016),
    [anon_sym_RPAREN] = ACTIONS(2016),
    [anon_sym_COMMA] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_LT_EQ] = ACTIONS(2016),
    [anon_sym_GT_EQ] = ACTIONS(2016),
    [anon_sym_COLON] = ACTIONS(2018),
    [sym_op_other] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_SLASH] = ACTIONS(2018),
    [anon_sym_PERCENT] = ACTIONS(2016),
    [anon_sym_CARET] = ACTIONS(2018),
    [anon_sym_BANG_EQ] = ACTIONS(2016),
    [anon_sym_LT_GT] = ACTIONS(2016),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2022),
    [sym_keyword_from] = ACTIONS(2022),
    [sym_keyword_on] = ACTIONS(2022),
    [sym_keyword_where] = ACTIONS(2022),
    [sym_keyword_desc] = ACTIONS(2022),
    [sym_keyword_asc] = ACTIONS(2022),
    [sym_keyword_limit] = ACTIONS(2022),
    [sym_keyword_primary] = ACTIONS(2022),
    [sym_keyword_create] = ACTIONS(2022),
    [sym_keyword_as] = ACTIONS(2024),
    [sym_keyword_constraint] = ACTIONS(2022),
    [sym_keyword_separator] = ACTIONS(2022),
    [sym_keyword_when] = ACTIONS(2022),
    [sym_keyword_then] = ACTIONS(2022),
    [sym_keyword_else] = ACTIONS(2022),
    [sym_keyword_end] = ACTIONS(2022),
    [sym_keyword_in] = ACTIONS(2022),
    [sym_keyword_and] = ACTIONS(2022),
    [sym_keyword_or] = ACTIONS(2022),
    [sym_keyword_is] = ACTIONS(2022),
    [sym_keyword_not] = ACTIONS(2022),
    [sym_keyword_using] = ACTIONS(2022),
    [sym_keyword_auto_increment] = ACTIONS(2022),
    [sym_keyword_generated] = ACTIONS(2022),
    [sym_keyword_default] = ACTIONS(2022),
    [sym_keyword_returning] = ACTIONS(2022),
    [sym_keyword_first] = ACTIONS(2022),
    [sym_keyword_after] = ACTIONS(2022),
    [sym_keyword_range] = ACTIONS(2022),
    [sym_keyword_rows] = ACTIONS(2022),
    [sym_keyword_groups] = ACTIONS(2022),
    [sym_keyword_between] = ACTIONS(2022),
    [sym_keyword_preceding] = ACTIONS(2022),
    [sym_keyword_following] = ACTIONS(2022),
    [sym_keyword_unique] = ACTIONS(2022),
    [sym_keyword_references] = ACTIONS(2022),
    [aux_sym_keyword_like_token1] = ACTIONS(2022),
    [aux_sym_keyword_like_token2] = ACTIONS(2022),
    [sym_keyword_similar] = ACTIONS(2022),
    [sym_keyword_check] = ACTIONS(2022),
    [sym_keyword_stored] = ACTIONS(2022),
    [sym_keyword_virtual] = ACTIONS(2022),
    [sym_keyword_comment] = ACTIONS(2022),
    [sym_keyword_null] = ACTIONS(2022),
    [sym_keyword_array] = ACTIONS(2022),
    [anon_sym_LBRACK] = ACTIONS(2022),
    [anon_sym_RBRACK] = ACTIONS(2022),
    [anon_sym_LPAREN] = ACTIONS(2022),
    [anon_sym_RPAREN] = ACTIONS(2022),
    [anon_sym_COMMA] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2022),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_LT] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(2024),
    [anon_sym_LT_EQ] = ACTIONS(2022),
    [anon_sym_GT_EQ] = ACTIONS(2022),
    [anon_sym_COLON] = ACTIONS(2024),
    [sym_op_other] = ACTIONS(2022),
    [anon_sym_PLUS] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2024),
    [anon_sym_PERCENT] = ACTIONS(2022),
    [anon_sym_CARET] = ACTIONS(2024),
    [anon_sym_BANG_EQ] = ACTIONS(2022),
    [anon_sym_LT_GT] = ACTIONS(2022),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2026),
    [sym_keyword_from] = ACTIONS(2026),
    [sym_keyword_on] = ACTIONS(2026),
    [sym_keyword_where] = ACTIONS(2026),
    [sym_keyword_desc] = ACTIONS(2026),
    [sym_keyword_asc] = ACTIONS(2026),
    [sym_keyword_limit] = ACTIONS(2026),
    [sym_keyword_primary] = ACTIONS(2026),
    [sym_keyword_create] = ACTIONS(2026),
    [sym_keyword_as] = ACTIONS(2028),
    [sym_keyword_constraint] = ACTIONS(2026),
    [sym_keyword_separator] = ACTIONS(2026),
    [sym_keyword_when] = ACTIONS(2026),
    [sym_keyword_then] = ACTIONS(2026),
    [sym_keyword_else] = ACTIONS(2026),
    [sym_keyword_end] = ACTIONS(2026),
    [sym_keyword_in] = ACTIONS(2026),
    [sym_keyword_and] = ACTIONS(2026),
    [sym_keyword_or] = ACTIONS(2026),
    [sym_keyword_is] = ACTIONS(2026),
    [sym_keyword_not] = ACTIONS(2026),
    [sym_keyword_using] = ACTIONS(2026),
    [sym_keyword_auto_increment] = ACTIONS(2026),
    [sym_keyword_generated] = ACTIONS(2026),
    [sym_keyword_default] = ACTIONS(2026),
    [sym_keyword_returning] = ACTIONS(2026),
    [sym_keyword_first] = ACTIONS(2026),
    [sym_keyword_after] = ACTIONS(2026),
    [sym_keyword_range] = ACTIONS(2026),
    [sym_keyword_rows] = ACTIONS(2026),
    [sym_keyword_groups] = ACTIONS(2026),
    [sym_keyword_between] = ACTIONS(2026),
    [sym_keyword_preceding] = ACTIONS(2026),
    [sym_keyword_following] = ACTIONS(2026),
    [sym_keyword_unique] = ACTIONS(2026),
    [sym_keyword_references] = ACTIONS(2026),
    [aux_sym_keyword_like_token1] = ACTIONS(2026),
    [aux_sym_keyword_like_token2] = ACTIONS(2026),
    [sym_keyword_similar] = ACTIONS(2026),
    [sym_keyword_zerofill] = ACTIONS(2030),
    [sym_keyword_check] = ACTIONS(2026),
    [sym_keyword_stored] = ACTIONS(2026),
    [sym_keyword_virtual] = ACTIONS(2026),
    [sym_keyword_comment] = ACTIONS(2026),
    [sym_keyword_null] = ACTIONS(2026),
    [sym_keyword_array] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [anon_sym_RBRACK] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_COMMA] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_LT_EQ] = ACTIONS(2026),
    [anon_sym_GT_EQ] = ACTIONS(2026),
    [anon_sym_COLON] = ACTIONS(2028),
    [sym_op_other] = ACTIONS(2026),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2028),
    [anon_sym_PERCENT] = ACTIONS(2026),
    [anon_sym_CARET] = ACTIONS(2028),
    [anon_sym_BANG_EQ] = ACTIONS(2026),
    [anon_sym_LT_GT] = ACTIONS(2026),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2032),
    [sym_keyword_from] = ACTIONS(2032),
    [sym_keyword_on] = ACTIONS(2032),
    [sym_keyword_where] = ACTIONS(2032),
    [sym_keyword_desc] = ACTIONS(2032),
    [sym_keyword_asc] = ACTIONS(2032),
    [sym_keyword_limit] = ACTIONS(2032),
    [sym_keyword_primary] = ACTIONS(2032),
    [sym_keyword_create] = ACTIONS(2032),
    [sym_keyword_as] = ACTIONS(2034),
    [sym_keyword_constraint] = ACTIONS(2032),
    [sym_keyword_separator] = ACTIONS(2032),
    [sym_keyword_when] = ACTIONS(2032),
    [sym_keyword_then] = ACTIONS(2032),
    [sym_keyword_else] = ACTIONS(2032),
    [sym_keyword_end] = ACTIONS(2032),
    [sym_keyword_in] = ACTIONS(2032),
    [sym_keyword_and] = ACTIONS(2032),
    [sym_keyword_or] = ACTIONS(2032),
    [sym_keyword_is] = ACTIONS(2032),
    [sym_keyword_not] = ACTIONS(2032),
    [sym_keyword_using] = ACTIONS(2032),
    [sym_keyword_auto_increment] = ACTIONS(2032),
    [sym_keyword_generated] = ACTIONS(2032),
    [sym_keyword_default] = ACTIONS(2032),
    [sym_keyword_returning] = ACTIONS(2032),
    [sym_keyword_first] = ACTIONS(2032),
    [sym_keyword_after] = ACTIONS(2032),
    [sym_keyword_range] = ACTIONS(2032),
    [sym_keyword_rows] = ACTIONS(2032),
    [sym_keyword_groups] = ACTIONS(2032),
    [sym_keyword_between] = ACTIONS(2032),
    [sym_keyword_preceding] = ACTIONS(2032),
    [sym_keyword_following] = ACTIONS(2032),
    [sym_keyword_unique] = ACTIONS(2032),
    [sym_keyword_references] = ACTIONS(2032),
    [aux_sym_keyword_like_token1] = ACTIONS(2032),
    [aux_sym_keyword_like_token2] = ACTIONS(2032),
    [sym_keyword_similar] = ACTIONS(2032),
    [sym_keyword_zerofill] = ACTIONS(2036),
    [sym_keyword_check] = ACTIONS(2032),
    [sym_keyword_stored] = ACTIONS(2032),
    [sym_keyword_virtual] = ACTIONS(2032),
    [sym_keyword_comment] = ACTIONS(2032),
    [sym_keyword_null] = ACTIONS(2032),
    [sym_keyword_array] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_RBRACK] = ACTIONS(2032),
    [anon_sym_RPAREN] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_GT] = ACTIONS(2034),
    [anon_sym_LT_EQ] = ACTIONS(2032),
    [anon_sym_GT_EQ] = ACTIONS(2032),
    [anon_sym_COLON] = ACTIONS(2034),
    [sym_op_other] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2034),
    [anon_sym_PERCENT] = ACTIONS(2032),
    [anon_sym_CARET] = ACTIONS(2034),
    [anon_sym_BANG_EQ] = ACTIONS(2032),
    [anon_sym_LT_GT] = ACTIONS(2032),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2038),
    [sym_keyword_from] = ACTIONS(2038),
    [sym_keyword_on] = ACTIONS(2038),
    [sym_keyword_where] = ACTIONS(2038),
    [sym_keyword_desc] = ACTIONS(2038),
    [sym_keyword_asc] = ACTIONS(2038),
    [sym_keyword_limit] = ACTIONS(2038),
    [sym_keyword_primary] = ACTIONS(2038),
    [sym_keyword_create] = ACTIONS(2038),
    [sym_keyword_as] = ACTIONS(2040),
    [sym_keyword_constraint] = ACTIONS(2038),
    [sym_keyword_separator] = ACTIONS(2038),
    [sym_keyword_when] = ACTIONS(2038),
    [sym_keyword_then] = ACTIONS(2038),
    [sym_keyword_else] = ACTIONS(2038),
    [sym_keyword_end] = ACTIONS(2038),
    [sym_keyword_in] = ACTIONS(2038),
    [sym_keyword_and] = ACTIONS(2038),
    [sym_keyword_or] = ACTIONS(2038),
    [sym_keyword_is] = ACTIONS(2038),
    [sym_keyword_not] = ACTIONS(2038),
    [sym_keyword_using] = ACTIONS(2038),
    [sym_keyword_auto_increment] = ACTIONS(2038),
    [sym_keyword_generated] = ACTIONS(2038),
    [sym_keyword_default] = ACTIONS(2038),
    [sym_keyword_returning] = ACTIONS(2038),
    [sym_keyword_first] = ACTIONS(2038),
    [sym_keyword_after] = ACTIONS(2038),
    [sym_keyword_range] = ACTIONS(2038),
    [sym_keyword_rows] = ACTIONS(2038),
    [sym_keyword_groups] = ACTIONS(2038),
    [sym_keyword_between] = ACTIONS(2038),
    [sym_keyword_preceding] = ACTIONS(2038),
    [sym_keyword_following] = ACTIONS(2038),
    [sym_keyword_unique] = ACTIONS(2038),
    [sym_keyword_references] = ACTIONS(2038),
    [aux_sym_keyword_like_token1] = ACTIONS(2038),
    [aux_sym_keyword_like_token2] = ACTIONS(2038),
    [sym_keyword_similar] = ACTIONS(2038),
    [sym_keyword_zerofill] = ACTIONS(2042),
    [sym_keyword_check] = ACTIONS(2038),
    [sym_keyword_stored] = ACTIONS(2038),
    [sym_keyword_virtual] = ACTIONS(2038),
    [sym_keyword_comment] = ACTIONS(2038),
    [sym_keyword_null] = ACTIONS(2038),
    [sym_keyword_array] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_RBRACK] = ACTIONS(2038),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_COMMA] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2040),
    [anon_sym_GT] = ACTIONS(2040),
    [anon_sym_LT_EQ] = ACTIONS(2038),
    [anon_sym_GT_EQ] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2040),
    [sym_op_other] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(2040),
    [anon_sym_PERCENT] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(2040),
    [anon_sym_BANG_EQ] = ACTIONS(2038),
    [anon_sym_LT_GT] = ACTIONS(2038),
  },
  [189] = {
    [sym__array_size_definition] = STATE(287),
    [aux_sym_array_size_definition_repeat1] = STATE(189),
    [ts_builtin_sym_end] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2044),
    [sym_keyword_from] = ACTIONS(2044),
    [sym_keyword_on] = ACTIONS(2044),
    [sym_keyword_where] = ACTIONS(2044),
    [sym_keyword_desc] = ACTIONS(2044),
    [sym_keyword_asc] = ACTIONS(2044),
    [sym_keyword_limit] = ACTIONS(2044),
    [sym_keyword_primary] = ACTIONS(2044),
    [sym_keyword_create] = ACTIONS(2044),
    [sym_keyword_as] = ACTIONS(2046),
    [sym_keyword_constraint] = ACTIONS(2044),
    [sym_keyword_separator] = ACTIONS(2044),
    [sym_keyword_when] = ACTIONS(2044),
    [sym_keyword_then] = ACTIONS(2044),
    [sym_keyword_else] = ACTIONS(2044),
    [sym_keyword_end] = ACTIONS(2044),
    [sym_keyword_in] = ACTIONS(2044),
    [sym_keyword_and] = ACTIONS(2044),
    [sym_keyword_or] = ACTIONS(2044),
    [sym_keyword_is] = ACTIONS(2044),
    [sym_keyword_not] = ACTIONS(2044),
    [sym_keyword_using] = ACTIONS(2044),
    [sym_keyword_auto_increment] = ACTIONS(2044),
    [sym_keyword_generated] = ACTIONS(2044),
    [sym_keyword_default] = ACTIONS(2044),
    [sym_keyword_returning] = ACTIONS(2044),
    [sym_keyword_first] = ACTIONS(2044),
    [sym_keyword_after] = ACTIONS(2044),
    [sym_keyword_range] = ACTIONS(2044),
    [sym_keyword_rows] = ACTIONS(2044),
    [sym_keyword_groups] = ACTIONS(2044),
    [sym_keyword_between] = ACTIONS(2044),
    [sym_keyword_preceding] = ACTIONS(2044),
    [sym_keyword_following] = ACTIONS(2044),
    [sym_keyword_unique] = ACTIONS(2044),
    [sym_keyword_references] = ACTIONS(2044),
    [aux_sym_keyword_like_token1] = ACTIONS(2044),
    [aux_sym_keyword_like_token2] = ACTIONS(2044),
    [sym_keyword_similar] = ACTIONS(2044),
    [sym_keyword_check] = ACTIONS(2044),
    [sym_keyword_stored] = ACTIONS(2044),
    [sym_keyword_virtual] = ACTIONS(2044),
    [sym_keyword_comment] = ACTIONS(2044),
    [sym_keyword_null] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2048),
    [anon_sym_RBRACK] = ACTIONS(2044),
    [anon_sym_RPAREN] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2044),
    [anon_sym_COLON_COLON] = ACTIONS(2044),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_GT] = ACTIONS(2046),
    [anon_sym_LT_EQ] = ACTIONS(2044),
    [anon_sym_GT_EQ] = ACTIONS(2044),
    [anon_sym_COLON] = ACTIONS(2046),
    [sym_op_other] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2046),
    [anon_sym_SLASH] = ACTIONS(2046),
    [anon_sym_PERCENT] = ACTIONS(2044),
    [anon_sym_CARET] = ACTIONS(2046),
    [anon_sym_BANG_EQ] = ACTIONS(2044),
    [anon_sym_LT_GT] = ACTIONS(2044),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2051),
    [sym_keyword_from] = ACTIONS(2051),
    [sym_keyword_on] = ACTIONS(2051),
    [sym_keyword_where] = ACTIONS(2051),
    [sym_keyword_desc] = ACTIONS(2051),
    [sym_keyword_asc] = ACTIONS(2051),
    [sym_keyword_limit] = ACTIONS(2051),
    [sym_keyword_primary] = ACTIONS(2051),
    [sym_keyword_create] = ACTIONS(2051),
    [sym_keyword_as] = ACTIONS(2053),
    [sym_keyword_constraint] = ACTIONS(2051),
    [sym_keyword_separator] = ACTIONS(2051),
    [sym_keyword_when] = ACTIONS(2051),
    [sym_keyword_then] = ACTIONS(2051),
    [sym_keyword_else] = ACTIONS(2051),
    [sym_keyword_end] = ACTIONS(2051),
    [sym_keyword_in] = ACTIONS(2051),
    [sym_keyword_and] = ACTIONS(2051),
    [sym_keyword_or] = ACTIONS(2051),
    [sym_keyword_is] = ACTIONS(2051),
    [sym_keyword_not] = ACTIONS(2051),
    [sym_keyword_using] = ACTIONS(2051),
    [sym_keyword_auto_increment] = ACTIONS(2051),
    [sym_keyword_generated] = ACTIONS(2051),
    [sym_keyword_default] = ACTIONS(2051),
    [sym_keyword_returning] = ACTIONS(2051),
    [sym_keyword_first] = ACTIONS(2051),
    [sym_keyword_after] = ACTIONS(2051),
    [sym_keyword_range] = ACTIONS(2051),
    [sym_keyword_rows] = ACTIONS(2051),
    [sym_keyword_groups] = ACTIONS(2051),
    [sym_keyword_between] = ACTIONS(2051),
    [sym_keyword_preceding] = ACTIONS(2051),
    [sym_keyword_following] = ACTIONS(2051),
    [sym_keyword_unique] = ACTIONS(2051),
    [sym_keyword_references] = ACTIONS(2051),
    [aux_sym_keyword_like_token1] = ACTIONS(2051),
    [aux_sym_keyword_like_token2] = ACTIONS(2051),
    [sym_keyword_similar] = ACTIONS(2051),
    [sym_keyword_check] = ACTIONS(2051),
    [sym_keyword_stored] = ACTIONS(2051),
    [sym_keyword_virtual] = ACTIONS(2051),
    [sym_keyword_comment] = ACTIONS(2051),
    [sym_keyword_null] = ACTIONS(2051),
    [sym_keyword_array] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(2055),
    [anon_sym_RPAREN] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_COLON] = ACTIONS(2053),
    [sym_op_other] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_GT] = ACTIONS(2051),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [sym_keyword_from] = ACTIONS(2057),
    [sym_keyword_on] = ACTIONS(2057),
    [sym_keyword_where] = ACTIONS(2057),
    [sym_keyword_desc] = ACTIONS(2057),
    [sym_keyword_asc] = ACTIONS(2057),
    [sym_keyword_limit] = ACTIONS(2057),
    [sym_keyword_primary] = ACTIONS(2057),
    [sym_keyword_create] = ACTIONS(2057),
    [sym_keyword_as] = ACTIONS(2059),
    [sym_keyword_constraint] = ACTIONS(2057),
    [sym_keyword_separator] = ACTIONS(2057),
    [sym_keyword_when] = ACTIONS(2057),
    [sym_keyword_then] = ACTIONS(2057),
    [sym_keyword_else] = ACTIONS(2057),
    [sym_keyword_end] = ACTIONS(2057),
    [sym_keyword_in] = ACTIONS(2057),
    [sym_keyword_and] = ACTIONS(2057),
    [sym_keyword_or] = ACTIONS(2057),
    [sym_keyword_is] = ACTIONS(2057),
    [sym_keyword_not] = ACTIONS(2057),
    [sym_keyword_using] = ACTIONS(2057),
    [sym_keyword_auto_increment] = ACTIONS(2057),
    [sym_keyword_generated] = ACTIONS(2057),
    [sym_keyword_default] = ACTIONS(2057),
    [sym_keyword_returning] = ACTIONS(2057),
    [sym_keyword_first] = ACTIONS(2057),
    [sym_keyword_after] = ACTIONS(2057),
    [sym_keyword_range] = ACTIONS(2057),
    [sym_keyword_rows] = ACTIONS(2057),
    [sym_keyword_groups] = ACTIONS(2057),
    [sym_keyword_between] = ACTIONS(2057),
    [sym_keyword_preceding] = ACTIONS(2057),
    [sym_keyword_following] = ACTIONS(2057),
    [sym_keyword_unique] = ACTIONS(2057),
    [sym_keyword_references] = ACTIONS(2057),
    [aux_sym_keyword_like_token1] = ACTIONS(2057),
    [aux_sym_keyword_like_token2] = ACTIONS(2057),
    [sym_keyword_similar] = ACTIONS(2057),
    [sym_keyword_check] = ACTIONS(2057),
    [sym_keyword_stored] = ACTIONS(2057),
    [sym_keyword_virtual] = ACTIONS(2057),
    [sym_keyword_comment] = ACTIONS(2057),
    [sym_keyword_null] = ACTIONS(2057),
    [sym_keyword_array] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_RBRACK] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2059),
    [anon_sym_GT] = ACTIONS(2059),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(2059),
    [sym_op_other] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2059),
    [anon_sym_SLASH] = ACTIONS(2059),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_LT_GT] = ACTIONS(2057),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2032),
    [sym_keyword_from] = ACTIONS(2032),
    [sym_keyword_on] = ACTIONS(2032),
    [sym_keyword_where] = ACTIONS(2032),
    [sym_keyword_desc] = ACTIONS(2032),
    [sym_keyword_asc] = ACTIONS(2032),
    [sym_keyword_limit] = ACTIONS(2032),
    [sym_keyword_primary] = ACTIONS(2032),
    [sym_keyword_create] = ACTIONS(2032),
    [sym_keyword_as] = ACTIONS(2034),
    [sym_keyword_constraint] = ACTIONS(2032),
    [sym_keyword_separator] = ACTIONS(2032),
    [sym_keyword_when] = ACTIONS(2032),
    [sym_keyword_then] = ACTIONS(2032),
    [sym_keyword_else] = ACTIONS(2032),
    [sym_keyword_end] = ACTIONS(2032),
    [sym_keyword_in] = ACTIONS(2032),
    [sym_keyword_and] = ACTIONS(2032),
    [sym_keyword_or] = ACTIONS(2032),
    [sym_keyword_is] = ACTIONS(2032),
    [sym_keyword_not] = ACTIONS(2032),
    [sym_keyword_using] = ACTIONS(2032),
    [sym_keyword_auto_increment] = ACTIONS(2032),
    [sym_keyword_generated] = ACTIONS(2032),
    [sym_keyword_default] = ACTIONS(2032),
    [sym_keyword_returning] = ACTIONS(2032),
    [sym_keyword_first] = ACTIONS(2032),
    [sym_keyword_after] = ACTIONS(2032),
    [sym_keyword_range] = ACTIONS(2032),
    [sym_keyword_rows] = ACTIONS(2032),
    [sym_keyword_groups] = ACTIONS(2032),
    [sym_keyword_between] = ACTIONS(2032),
    [sym_keyword_preceding] = ACTIONS(2032),
    [sym_keyword_following] = ACTIONS(2032),
    [sym_keyword_unique] = ACTIONS(2032),
    [sym_keyword_references] = ACTIONS(2032),
    [aux_sym_keyword_like_token1] = ACTIONS(2032),
    [aux_sym_keyword_like_token2] = ACTIONS(2032),
    [sym_keyword_similar] = ACTIONS(2032),
    [sym_keyword_check] = ACTIONS(2032),
    [sym_keyword_stored] = ACTIONS(2032),
    [sym_keyword_virtual] = ACTIONS(2032),
    [sym_keyword_comment] = ACTIONS(2032),
    [sym_keyword_null] = ACTIONS(2032),
    [sym_keyword_array] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_RBRACK] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_GT] = ACTIONS(2034),
    [anon_sym_LT_EQ] = ACTIONS(2032),
    [anon_sym_GT_EQ] = ACTIONS(2032),
    [anon_sym_COLON] = ACTIONS(2034),
    [sym_op_other] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2034),
    [anon_sym_PERCENT] = ACTIONS(2032),
    [anon_sym_CARET] = ACTIONS(2034),
    [anon_sym_BANG_EQ] = ACTIONS(2032),
    [anon_sym_LT_GT] = ACTIONS(2032),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(2065),
    [anon_sym_SEMI] = ACTIONS(2065),
    [sym_keyword_from] = ACTIONS(2065),
    [sym_keyword_on] = ACTIONS(2065),
    [sym_keyword_where] = ACTIONS(2065),
    [sym_keyword_desc] = ACTIONS(2065),
    [sym_keyword_asc] = ACTIONS(2065),
    [sym_keyword_limit] = ACTIONS(2065),
    [sym_keyword_primary] = ACTIONS(2065),
    [sym_keyword_create] = ACTIONS(2065),
    [sym_keyword_as] = ACTIONS(2067),
    [sym_keyword_constraint] = ACTIONS(2065),
    [sym_keyword_separator] = ACTIONS(2065),
    [sym_keyword_when] = ACTIONS(2065),
    [sym_keyword_then] = ACTIONS(2065),
    [sym_keyword_else] = ACTIONS(2065),
    [sym_keyword_end] = ACTIONS(2065),
    [sym_keyword_in] = ACTIONS(2065),
    [sym_keyword_and] = ACTIONS(2065),
    [sym_keyword_or] = ACTIONS(2065),
    [sym_keyword_is] = ACTIONS(2065),
    [sym_keyword_not] = ACTIONS(2065),
    [sym_keyword_using] = ACTIONS(2065),
    [sym_keyword_auto_increment] = ACTIONS(2065),
    [sym_keyword_generated] = ACTIONS(2065),
    [sym_keyword_default] = ACTIONS(2065),
    [sym_keyword_returning] = ACTIONS(2065),
    [sym_keyword_first] = ACTIONS(2065),
    [sym_keyword_after] = ACTIONS(2065),
    [sym_keyword_range] = ACTIONS(2065),
    [sym_keyword_rows] = ACTIONS(2065),
    [sym_keyword_groups] = ACTIONS(2065),
    [sym_keyword_between] = ACTIONS(2065),
    [sym_keyword_preceding] = ACTIONS(2065),
    [sym_keyword_following] = ACTIONS(2065),
    [sym_keyword_unique] = ACTIONS(2065),
    [sym_keyword_references] = ACTIONS(2065),
    [aux_sym_keyword_like_token1] = ACTIONS(2065),
    [aux_sym_keyword_like_token2] = ACTIONS(2065),
    [sym_keyword_similar] = ACTIONS(2065),
    [sym_keyword_check] = ACTIONS(2065),
    [sym_keyword_stored] = ACTIONS(2065),
    [sym_keyword_virtual] = ACTIONS(2065),
    [sym_keyword_comment] = ACTIONS(2065),
    [sym_keyword_null] = ACTIONS(2065),
    [sym_keyword_array] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_STAR] = ACTIONS(2065),
    [anon_sym_COLON_COLON] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2067),
    [sym_op_other] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2065),
    [anon_sym_LT_GT] = ACTIONS(2065),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2071),
    [sym_keyword_from] = ACTIONS(2071),
    [sym_keyword_on] = ACTIONS(2071),
    [sym_keyword_where] = ACTIONS(2071),
    [sym_keyword_desc] = ACTIONS(2071),
    [sym_keyword_asc] = ACTIONS(2071),
    [sym_keyword_limit] = ACTIONS(2071),
    [sym_keyword_primary] = ACTIONS(2071),
    [sym_keyword_create] = ACTIONS(2071),
    [sym_keyword_as] = ACTIONS(2073),
    [sym_keyword_constraint] = ACTIONS(2071),
    [sym_keyword_separator] = ACTIONS(2071),
    [sym_keyword_when] = ACTIONS(2071),
    [sym_keyword_then] = ACTIONS(2071),
    [sym_keyword_else] = ACTIONS(2071),
    [sym_keyword_end] = ACTIONS(2071),
    [sym_keyword_in] = ACTIONS(2071),
    [sym_keyword_and] = ACTIONS(2071),
    [sym_keyword_or] = ACTIONS(2071),
    [sym_keyword_is] = ACTIONS(2071),
    [sym_keyword_not] = ACTIONS(2071),
    [sym_keyword_using] = ACTIONS(2071),
    [sym_keyword_auto_increment] = ACTIONS(2071),
    [sym_keyword_generated] = ACTIONS(2071),
    [sym_keyword_default] = ACTIONS(2071),
    [sym_keyword_returning] = ACTIONS(2071),
    [sym_keyword_first] = ACTIONS(2071),
    [sym_keyword_after] = ACTIONS(2071),
    [sym_keyword_range] = ACTIONS(2071),
    [sym_keyword_rows] = ACTIONS(2071),
    [sym_keyword_groups] = ACTIONS(2071),
    [sym_keyword_between] = ACTIONS(2071),
    [sym_keyword_preceding] = ACTIONS(2071),
    [sym_keyword_following] = ACTIONS(2071),
    [sym_keyword_unique] = ACTIONS(2071),
    [sym_keyword_references] = ACTIONS(2071),
    [aux_sym_keyword_like_token1] = ACTIONS(2071),
    [aux_sym_keyword_like_token2] = ACTIONS(2071),
    [sym_keyword_similar] = ACTIONS(2071),
    [sym_keyword_check] = ACTIONS(2071),
    [sym_keyword_stored] = ACTIONS(2071),
    [sym_keyword_virtual] = ACTIONS(2071),
    [sym_keyword_comment] = ACTIONS(2071),
    [sym_keyword_null] = ACTIONS(2071),
    [sym_keyword_array] = ACTIONS(2071),
    [anon_sym_LBRACK] = ACTIONS(2071),
    [anon_sym_RBRACK] = ACTIONS(2071),
    [anon_sym_LPAREN] = ACTIONS(2075),
    [anon_sym_RPAREN] = ACTIONS(2071),
    [anon_sym_COMMA] = ACTIONS(2071),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(2071),
    [anon_sym_COLON_COLON] = ACTIONS(2071),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_GT] = ACTIONS(2073),
    [anon_sym_LT_EQ] = ACTIONS(2071),
    [anon_sym_GT_EQ] = ACTIONS(2071),
    [anon_sym_COLON] = ACTIONS(2073),
    [sym_op_other] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_SLASH] = ACTIONS(2073),
    [anon_sym_PERCENT] = ACTIONS(2071),
    [anon_sym_CARET] = ACTIONS(2073),
    [anon_sym_BANG_EQ] = ACTIONS(2071),
    [anon_sym_LT_GT] = ACTIONS(2071),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(2077),
    [anon_sym_SEMI] = ACTIONS(2077),
    [sym_keyword_from] = ACTIONS(2077),
    [sym_keyword_on] = ACTIONS(2077),
    [sym_keyword_where] = ACTIONS(2077),
    [sym_keyword_desc] = ACTIONS(2077),
    [sym_keyword_asc] = ACTIONS(2077),
    [sym_keyword_limit] = ACTIONS(2077),
    [sym_keyword_primary] = ACTIONS(2077),
    [sym_keyword_create] = ACTIONS(2077),
    [sym_keyword_as] = ACTIONS(2079),
    [sym_keyword_constraint] = ACTIONS(2077),
    [sym_keyword_separator] = ACTIONS(2077),
    [sym_keyword_when] = ACTIONS(2077),
    [sym_keyword_then] = ACTIONS(2077),
    [sym_keyword_else] = ACTIONS(2077),
    [sym_keyword_end] = ACTIONS(2077),
    [sym_keyword_in] = ACTIONS(2077),
    [sym_keyword_and] = ACTIONS(2077),
    [sym_keyword_or] = ACTIONS(2077),
    [sym_keyword_is] = ACTIONS(2077),
    [sym_keyword_not] = ACTIONS(2077),
    [sym_keyword_using] = ACTIONS(2077),
    [sym_keyword_auto_increment] = ACTIONS(2077),
    [sym_keyword_generated] = ACTIONS(2077),
    [sym_keyword_default] = ACTIONS(2077),
    [sym_keyword_returning] = ACTIONS(2077),
    [sym_keyword_first] = ACTIONS(2077),
    [sym_keyword_after] = ACTIONS(2077),
    [sym_keyword_range] = ACTIONS(2077),
    [sym_keyword_rows] = ACTIONS(2077),
    [sym_keyword_groups] = ACTIONS(2077),
    [sym_keyword_between] = ACTIONS(2077),
    [sym_keyword_preceding] = ACTIONS(2077),
    [sym_keyword_following] = ACTIONS(2077),
    [sym_keyword_unique] = ACTIONS(2077),
    [sym_keyword_references] = ACTIONS(2077),
    [aux_sym_keyword_like_token1] = ACTIONS(2077),
    [aux_sym_keyword_like_token2] = ACTIONS(2077),
    [sym_keyword_similar] = ACTIONS(2077),
    [sym_keyword_check] = ACTIONS(2077),
    [sym_keyword_stored] = ACTIONS(2077),
    [sym_keyword_virtual] = ACTIONS(2077),
    [sym_keyword_comment] = ACTIONS(2077),
    [sym_keyword_null] = ACTIONS(2077),
    [sym_keyword_array] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_RBRACK] = ACTIONS(2077),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_RPAREN] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(2077),
    [anon_sym_COLON_COLON] = ACTIONS(2077),
    [anon_sym_LT] = ACTIONS(2079),
    [anon_sym_GT] = ACTIONS(2079),
    [anon_sym_LT_EQ] = ACTIONS(2077),
    [anon_sym_GT_EQ] = ACTIONS(2077),
    [anon_sym_COLON] = ACTIONS(2079),
    [sym_op_other] = ACTIONS(2077),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2079),
    [anon_sym_PERCENT] = ACTIONS(2077),
    [anon_sym_CARET] = ACTIONS(2079),
    [anon_sym_BANG_EQ] = ACTIONS(2077),
    [anon_sym_LT_GT] = ACTIONS(2077),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [sym_keyword_from] = ACTIONS(2083),
    [sym_keyword_on] = ACTIONS(2083),
    [sym_keyword_where] = ACTIONS(2083),
    [sym_keyword_desc] = ACTIONS(2083),
    [sym_keyword_asc] = ACTIONS(2083),
    [sym_keyword_limit] = ACTIONS(2083),
    [sym_keyword_primary] = ACTIONS(2083),
    [sym_keyword_create] = ACTIONS(2083),
    [sym_keyword_as] = ACTIONS(2085),
    [sym_keyword_constraint] = ACTIONS(2083),
    [sym_keyword_separator] = ACTIONS(2083),
    [sym_keyword_when] = ACTIONS(2083),
    [sym_keyword_then] = ACTIONS(2083),
    [sym_keyword_else] = ACTIONS(2083),
    [sym_keyword_end] = ACTIONS(2083),
    [sym_keyword_in] = ACTIONS(2083),
    [sym_keyword_and] = ACTIONS(2083),
    [sym_keyword_or] = ACTIONS(2083),
    [sym_keyword_is] = ACTIONS(2083),
    [sym_keyword_not] = ACTIONS(2083),
    [sym_keyword_using] = ACTIONS(2083),
    [sym_keyword_auto_increment] = ACTIONS(2083),
    [sym_keyword_generated] = ACTIONS(2083),
    [sym_keyword_default] = ACTIONS(2083),
    [sym_keyword_returning] = ACTIONS(2083),
    [sym_keyword_first] = ACTIONS(2083),
    [sym_keyword_after] = ACTIONS(2083),
    [sym_keyword_range] = ACTIONS(2083),
    [sym_keyword_rows] = ACTIONS(2083),
    [sym_keyword_groups] = ACTIONS(2083),
    [sym_keyword_between] = ACTIONS(2083),
    [sym_keyword_preceding] = ACTIONS(2083),
    [sym_keyword_following] = ACTIONS(2083),
    [sym_keyword_unique] = ACTIONS(2083),
    [sym_keyword_references] = ACTIONS(2083),
    [aux_sym_keyword_like_token1] = ACTIONS(2083),
    [aux_sym_keyword_like_token2] = ACTIONS(2083),
    [sym_keyword_similar] = ACTIONS(2083),
    [sym_keyword_check] = ACTIONS(2083),
    [sym_keyword_stored] = ACTIONS(2083),
    [sym_keyword_virtual] = ACTIONS(2083),
    [sym_keyword_comment] = ACTIONS(2083),
    [sym_keyword_null] = ACTIONS(2083),
    [sym_keyword_array] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_RBRACK] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [anon_sym_RPAREN] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2083),
    [anon_sym_COLON] = ACTIONS(2085),
    [sym_op_other] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2085),
    [anon_sym_PERCENT] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2085),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_LT_GT] = ACTIONS(2083),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(2077),
    [anon_sym_SEMI] = ACTIONS(2077),
    [sym_keyword_from] = ACTIONS(2077),
    [sym_keyword_on] = ACTIONS(2077),
    [sym_keyword_where] = ACTIONS(2077),
    [sym_keyword_desc] = ACTIONS(2077),
    [sym_keyword_asc] = ACTIONS(2077),
    [sym_keyword_limit] = ACTIONS(2077),
    [sym_keyword_primary] = ACTIONS(2077),
    [sym_keyword_create] = ACTIONS(2077),
    [sym_keyword_as] = ACTIONS(2079),
    [sym_keyword_constraint] = ACTIONS(2077),
    [sym_keyword_separator] = ACTIONS(2077),
    [sym_keyword_when] = ACTIONS(2077),
    [sym_keyword_then] = ACTIONS(2077),
    [sym_keyword_else] = ACTIONS(2077),
    [sym_keyword_end] = ACTIONS(2077),
    [sym_keyword_in] = ACTIONS(2077),
    [sym_keyword_and] = ACTIONS(2077),
    [sym_keyword_or] = ACTIONS(2077),
    [sym_keyword_is] = ACTIONS(2077),
    [sym_keyword_not] = ACTIONS(2077),
    [sym_keyword_using] = ACTIONS(2077),
    [sym_keyword_auto_increment] = ACTIONS(2077),
    [sym_keyword_generated] = ACTIONS(2077),
    [sym_keyword_default] = ACTIONS(2077),
    [sym_keyword_returning] = ACTIONS(2077),
    [sym_keyword_first] = ACTIONS(2077),
    [sym_keyword_after] = ACTIONS(2077),
    [sym_keyword_range] = ACTIONS(2077),
    [sym_keyword_rows] = ACTIONS(2077),
    [sym_keyword_groups] = ACTIONS(2077),
    [sym_keyword_between] = ACTIONS(2077),
    [sym_keyword_preceding] = ACTIONS(2077),
    [sym_keyword_following] = ACTIONS(2077),
    [sym_keyword_unique] = ACTIONS(2077),
    [sym_keyword_references] = ACTIONS(2077),
    [aux_sym_keyword_like_token1] = ACTIONS(2077),
    [aux_sym_keyword_like_token2] = ACTIONS(2077),
    [sym_keyword_similar] = ACTIONS(2077),
    [sym_keyword_zerofill] = ACTIONS(2089),
    [sym_keyword_check] = ACTIONS(2077),
    [sym_keyword_stored] = ACTIONS(2077),
    [sym_keyword_virtual] = ACTIONS(2077),
    [sym_keyword_comment] = ACTIONS(2077),
    [sym_keyword_null] = ACTIONS(2077),
    [sym_keyword_array] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_RBRACK] = ACTIONS(2077),
    [anon_sym_RPAREN] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(2077),
    [anon_sym_COLON_COLON] = ACTIONS(2077),
    [anon_sym_LT] = ACTIONS(2079),
    [anon_sym_GT] = ACTIONS(2079),
    [anon_sym_LT_EQ] = ACTIONS(2077),
    [anon_sym_GT_EQ] = ACTIONS(2077),
    [anon_sym_COLON] = ACTIONS(2079),
    [sym_op_other] = ACTIONS(2077),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2079),
    [anon_sym_PERCENT] = ACTIONS(2077),
    [anon_sym_CARET] = ACTIONS(2079),
    [anon_sym_BANG_EQ] = ACTIONS(2077),
    [anon_sym_LT_GT] = ACTIONS(2077),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(2091),
    [anon_sym_SEMI] = ACTIONS(2091),
    [sym_keyword_from] = ACTIONS(2091),
    [sym_keyword_on] = ACTIONS(2091),
    [sym_keyword_where] = ACTIONS(2091),
    [sym_keyword_desc] = ACTIONS(2091),
    [sym_keyword_asc] = ACTIONS(2091),
    [sym_keyword_limit] = ACTIONS(2091),
    [sym_keyword_primary] = ACTIONS(2091),
    [sym_keyword_create] = ACTIONS(2091),
    [sym_keyword_as] = ACTIONS(2093),
    [sym_keyword_constraint] = ACTIONS(2091),
    [sym_keyword_separator] = ACTIONS(2091),
    [sym_keyword_when] = ACTIONS(2091),
    [sym_keyword_then] = ACTIONS(2091),
    [sym_keyword_else] = ACTIONS(2091),
    [sym_keyword_end] = ACTIONS(2091),
    [sym_keyword_in] = ACTIONS(2091),
    [sym_keyword_and] = ACTIONS(2091),
    [sym_keyword_or] = ACTIONS(2091),
    [sym_keyword_is] = ACTIONS(2091),
    [sym_keyword_not] = ACTIONS(2091),
    [sym_keyword_using] = ACTIONS(2091),
    [sym_keyword_auto_increment] = ACTIONS(2091),
    [sym_keyword_generated] = ACTIONS(2091),
    [sym_keyword_default] = ACTIONS(2091),
    [sym_keyword_returning] = ACTIONS(2091),
    [sym_keyword_first] = ACTIONS(2091),
    [sym_keyword_after] = ACTIONS(2091),
    [sym_keyword_range] = ACTIONS(2091),
    [sym_keyword_rows] = ACTIONS(2091),
    [sym_keyword_groups] = ACTIONS(2091),
    [sym_keyword_between] = ACTIONS(2091),
    [sym_keyword_preceding] = ACTIONS(2091),
    [sym_keyword_following] = ACTIONS(2091),
    [sym_keyword_unique] = ACTIONS(2091),
    [sym_keyword_references] = ACTIONS(2091),
    [aux_sym_keyword_like_token1] = ACTIONS(2091),
    [aux_sym_keyword_like_token2] = ACTIONS(2091),
    [sym_keyword_similar] = ACTIONS(2091),
    [sym_keyword_check] = ACTIONS(2091),
    [sym_keyword_stored] = ACTIONS(2091),
    [sym_keyword_virtual] = ACTIONS(2091),
    [sym_keyword_comment] = ACTIONS(2091),
    [sym_keyword_null] = ACTIONS(2091),
    [sym_keyword_array] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_RBRACK] = ACTIONS(2091),
    [anon_sym_LPAREN] = ACTIONS(2095),
    [anon_sym_RPAREN] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2091),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2091),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_COLON_COLON] = ACTIONS(2091),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2091),
    [anon_sym_GT_EQ] = ACTIONS(2091),
    [anon_sym_COLON] = ACTIONS(2093),
    [sym_op_other] = ACTIONS(2091),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2091),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2091),
    [anon_sym_LT_GT] = ACTIONS(2091),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2026),
    [sym_keyword_from] = ACTIONS(2026),
    [sym_keyword_on] = ACTIONS(2026),
    [sym_keyword_where] = ACTIONS(2026),
    [sym_keyword_desc] = ACTIONS(2026),
    [sym_keyword_asc] = ACTIONS(2026),
    [sym_keyword_limit] = ACTIONS(2026),
    [sym_keyword_primary] = ACTIONS(2026),
    [sym_keyword_create] = ACTIONS(2026),
    [sym_keyword_as] = ACTIONS(2028),
    [sym_keyword_constraint] = ACTIONS(2026),
    [sym_keyword_separator] = ACTIONS(2026),
    [sym_keyword_when] = ACTIONS(2026),
    [sym_keyword_then] = ACTIONS(2026),
    [sym_keyword_else] = ACTIONS(2026),
    [sym_keyword_end] = ACTIONS(2026),
    [sym_keyword_in] = ACTIONS(2026),
    [sym_keyword_and] = ACTIONS(2026),
    [sym_keyword_or] = ACTIONS(2026),
    [sym_keyword_is] = ACTIONS(2026),
    [sym_keyword_not] = ACTIONS(2026),
    [sym_keyword_using] = ACTIONS(2026),
    [sym_keyword_auto_increment] = ACTIONS(2026),
    [sym_keyword_generated] = ACTIONS(2026),
    [sym_keyword_default] = ACTIONS(2026),
    [sym_keyword_returning] = ACTIONS(2026),
    [sym_keyword_first] = ACTIONS(2026),
    [sym_keyword_after] = ACTIONS(2026),
    [sym_keyword_range] = ACTIONS(2026),
    [sym_keyword_rows] = ACTIONS(2026),
    [sym_keyword_groups] = ACTIONS(2026),
    [sym_keyword_between] = ACTIONS(2026),
    [sym_keyword_preceding] = ACTIONS(2026),
    [sym_keyword_following] = ACTIONS(2026),
    [sym_keyword_unique] = ACTIONS(2026),
    [sym_keyword_references] = ACTIONS(2026),
    [aux_sym_keyword_like_token1] = ACTIONS(2026),
    [aux_sym_keyword_like_token2] = ACTIONS(2026),
    [sym_keyword_similar] = ACTIONS(2026),
    [sym_keyword_check] = ACTIONS(2026),
    [sym_keyword_stored] = ACTIONS(2026),
    [sym_keyword_virtual] = ACTIONS(2026),
    [sym_keyword_comment] = ACTIONS(2026),
    [sym_keyword_null] = ACTIONS(2026),
    [sym_keyword_array] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [anon_sym_RBRACK] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_COMMA] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_LT_EQ] = ACTIONS(2026),
    [anon_sym_GT_EQ] = ACTIONS(2026),
    [anon_sym_COLON] = ACTIONS(2028),
    [sym_op_other] = ACTIONS(2026),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2028),
    [anon_sym_PERCENT] = ACTIONS(2026),
    [anon_sym_CARET] = ACTIONS(2028),
    [anon_sym_BANG_EQ] = ACTIONS(2026),
    [anon_sym_LT_GT] = ACTIONS(2026),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(2099),
    [sym_keyword_from] = ACTIONS(2099),
    [sym_keyword_on] = ACTIONS(2099),
    [sym_keyword_where] = ACTIONS(2099),
    [sym_keyword_desc] = ACTIONS(2099),
    [sym_keyword_asc] = ACTIONS(2099),
    [sym_keyword_limit] = ACTIONS(2099),
    [sym_keyword_primary] = ACTIONS(2099),
    [sym_keyword_create] = ACTIONS(2099),
    [sym_keyword_as] = ACTIONS(2101),
    [sym_keyword_constraint] = ACTIONS(2099),
    [sym_keyword_separator] = ACTIONS(2099),
    [sym_keyword_when] = ACTIONS(2099),
    [sym_keyword_then] = ACTIONS(2099),
    [sym_keyword_else] = ACTIONS(2099),
    [sym_keyword_end] = ACTIONS(2099),
    [sym_keyword_in] = ACTIONS(2099),
    [sym_keyword_and] = ACTIONS(2099),
    [sym_keyword_or] = ACTIONS(2099),
    [sym_keyword_is] = ACTIONS(2099),
    [sym_keyword_not] = ACTIONS(2099),
    [sym_keyword_using] = ACTIONS(2099),
    [sym_keyword_auto_increment] = ACTIONS(2099),
    [sym_keyword_generated] = ACTIONS(2099),
    [sym_keyword_default] = ACTIONS(2099),
    [sym_keyword_returning] = ACTIONS(2099),
    [sym_keyword_first] = ACTIONS(2099),
    [sym_keyword_after] = ACTIONS(2099),
    [sym_keyword_range] = ACTIONS(2099),
    [sym_keyword_rows] = ACTIONS(2099),
    [sym_keyword_groups] = ACTIONS(2099),
    [sym_keyword_between] = ACTIONS(2099),
    [sym_keyword_preceding] = ACTIONS(2099),
    [sym_keyword_following] = ACTIONS(2099),
    [sym_keyword_unique] = ACTIONS(2099),
    [sym_keyword_references] = ACTIONS(2099),
    [aux_sym_keyword_like_token1] = ACTIONS(2099),
    [aux_sym_keyword_like_token2] = ACTIONS(2099),
    [sym_keyword_similar] = ACTIONS(2099),
    [sym_keyword_check] = ACTIONS(2099),
    [sym_keyword_stored] = ACTIONS(2099),
    [sym_keyword_virtual] = ACTIONS(2099),
    [sym_keyword_comment] = ACTIONS(2099),
    [sym_keyword_null] = ACTIONS(2099),
    [sym_keyword_array] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_RBRACK] = ACTIONS(2099),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [anon_sym_COMMA] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2099),
    [anon_sym_STAR] = ACTIONS(2099),
    [anon_sym_COLON_COLON] = ACTIONS(2099),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_LT_EQ] = ACTIONS(2099),
    [anon_sym_GT_EQ] = ACTIONS(2099),
    [anon_sym_COLON] = ACTIONS(2101),
    [sym_op_other] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2099),
    [anon_sym_CARET] = ACTIONS(2101),
    [anon_sym_BANG_EQ] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(2099),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(2099),
    [sym_keyword_from] = ACTIONS(2099),
    [sym_keyword_on] = ACTIONS(2099),
    [sym_keyword_where] = ACTIONS(2099),
    [sym_keyword_desc] = ACTIONS(2099),
    [sym_keyword_asc] = ACTIONS(2099),
    [sym_keyword_limit] = ACTIONS(2099),
    [sym_keyword_primary] = ACTIONS(2099),
    [sym_keyword_create] = ACTIONS(2099),
    [sym_keyword_as] = ACTIONS(2101),
    [sym_keyword_constraint] = ACTIONS(2099),
    [sym_keyword_separator] = ACTIONS(2099),
    [sym_keyword_when] = ACTIONS(2099),
    [sym_keyword_then] = ACTIONS(2099),
    [sym_keyword_else] = ACTIONS(2099),
    [sym_keyword_end] = ACTIONS(2099),
    [sym_keyword_in] = ACTIONS(2099),
    [sym_keyword_and] = ACTIONS(2099),
    [sym_keyword_or] = ACTIONS(2099),
    [sym_keyword_is] = ACTIONS(2099),
    [sym_keyword_not] = ACTIONS(2099),
    [sym_keyword_using] = ACTIONS(2099),
    [sym_keyword_auto_increment] = ACTIONS(2099),
    [sym_keyword_generated] = ACTIONS(2099),
    [sym_keyword_default] = ACTIONS(2099),
    [sym_keyword_returning] = ACTIONS(2099),
    [sym_keyword_first] = ACTIONS(2099),
    [sym_keyword_after] = ACTIONS(2099),
    [sym_keyword_range] = ACTIONS(2099),
    [sym_keyword_rows] = ACTIONS(2099),
    [sym_keyword_groups] = ACTIONS(2099),
    [sym_keyword_between] = ACTIONS(2099),
    [sym_keyword_preceding] = ACTIONS(2099),
    [sym_keyword_following] = ACTIONS(2099),
    [sym_keyword_unique] = ACTIONS(2099),
    [sym_keyword_references] = ACTIONS(2099),
    [aux_sym_keyword_like_token1] = ACTIONS(2099),
    [aux_sym_keyword_like_token2] = ACTIONS(2099),
    [sym_keyword_similar] = ACTIONS(2099),
    [sym_keyword_zerofill] = ACTIONS(2105),
    [sym_keyword_check] = ACTIONS(2099),
    [sym_keyword_stored] = ACTIONS(2099),
    [sym_keyword_virtual] = ACTIONS(2099),
    [sym_keyword_comment] = ACTIONS(2099),
    [sym_keyword_null] = ACTIONS(2099),
    [sym_keyword_array] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_RBRACK] = ACTIONS(2099),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [anon_sym_COMMA] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2099),
    [anon_sym_STAR] = ACTIONS(2099),
    [anon_sym_COLON_COLON] = ACTIONS(2099),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_LT_EQ] = ACTIONS(2099),
    [anon_sym_GT_EQ] = ACTIONS(2099),
    [anon_sym_COLON] = ACTIONS(2101),
    [sym_op_other] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2099),
    [anon_sym_CARET] = ACTIONS(2101),
    [anon_sym_BANG_EQ] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(2099),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2107),
    [sym_keyword_from] = ACTIONS(2107),
    [sym_keyword_on] = ACTIONS(2107),
    [sym_keyword_where] = ACTIONS(2107),
    [sym_keyword_desc] = ACTIONS(2107),
    [sym_keyword_asc] = ACTIONS(2107),
    [sym_keyword_limit] = ACTIONS(2107),
    [sym_keyword_primary] = ACTIONS(2107),
    [sym_keyword_create] = ACTIONS(2107),
    [sym_keyword_as] = ACTIONS(2109),
    [sym_keyword_constraint] = ACTIONS(2107),
    [sym_keyword_separator] = ACTIONS(2107),
    [sym_keyword_when] = ACTIONS(2107),
    [sym_keyword_then] = ACTIONS(2107),
    [sym_keyword_else] = ACTIONS(2107),
    [sym_keyword_end] = ACTIONS(2107),
    [sym_keyword_in] = ACTIONS(2107),
    [sym_keyword_and] = ACTIONS(2107),
    [sym_keyword_or] = ACTIONS(2107),
    [sym_keyword_is] = ACTIONS(2107),
    [sym_keyword_not] = ACTIONS(2107),
    [sym_keyword_using] = ACTIONS(2107),
    [sym_keyword_auto_increment] = ACTIONS(2107),
    [sym_keyword_generated] = ACTIONS(2107),
    [sym_keyword_default] = ACTIONS(2107),
    [sym_keyword_returning] = ACTIONS(2107),
    [sym_keyword_first] = ACTIONS(2107),
    [sym_keyword_after] = ACTIONS(2107),
    [sym_keyword_range] = ACTIONS(2107),
    [sym_keyword_rows] = ACTIONS(2107),
    [sym_keyword_groups] = ACTIONS(2107),
    [sym_keyword_between] = ACTIONS(2107),
    [sym_keyword_preceding] = ACTIONS(2107),
    [sym_keyword_following] = ACTIONS(2107),
    [sym_keyword_unique] = ACTIONS(2107),
    [sym_keyword_references] = ACTIONS(2107),
    [aux_sym_keyword_like_token1] = ACTIONS(2107),
    [aux_sym_keyword_like_token2] = ACTIONS(2107),
    [sym_keyword_similar] = ACTIONS(2107),
    [sym_keyword_check] = ACTIONS(2107),
    [sym_keyword_stored] = ACTIONS(2107),
    [sym_keyword_virtual] = ACTIONS(2107),
    [sym_keyword_comment] = ACTIONS(2107),
    [sym_keyword_null] = ACTIONS(2107),
    [sym_keyword_array] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_RBRACK] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_COMMA] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2107),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_COLON_COLON] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2107),
    [anon_sym_GT_EQ] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2109),
    [sym_op_other] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_PERCENT] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2107),
    [anon_sym_LT_GT] = ACTIONS(2107),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [sym_keyword_from] = ACTIONS(1852),
    [sym_keyword_on] = ACTIONS(1852),
    [sym_keyword_where] = ACTIONS(1852),
    [sym_keyword_desc] = ACTIONS(1852),
    [sym_keyword_asc] = ACTIONS(1852),
    [sym_keyword_limit] = ACTIONS(1852),
    [sym_keyword_primary] = ACTIONS(1852),
    [sym_keyword_create] = ACTIONS(1852),
    [sym_keyword_as] = ACTIONS(1854),
    [sym_keyword_constraint] = ACTIONS(1852),
    [sym_keyword_separator] = ACTIONS(1852),
    [sym_keyword_when] = ACTIONS(1852),
    [sym_keyword_then] = ACTIONS(1852),
    [sym_keyword_else] = ACTIONS(1852),
    [sym_keyword_end] = ACTIONS(1852),
    [sym_keyword_in] = ACTIONS(1852),
    [sym_keyword_and] = ACTIONS(1852),
    [sym_keyword_or] = ACTIONS(1852),
    [sym_keyword_is] = ACTIONS(1852),
    [sym_keyword_not] = ACTIONS(1852),
    [sym_keyword_using] = ACTIONS(1852),
    [sym_keyword_auto_increment] = ACTIONS(1852),
    [sym_keyword_generated] = ACTIONS(1852),
    [sym_keyword_default] = ACTIONS(1852),
    [sym_keyword_returning] = ACTIONS(1852),
    [sym_keyword_first] = ACTIONS(1852),
    [sym_keyword_after] = ACTIONS(1852),
    [sym_keyword_range] = ACTIONS(1852),
    [sym_keyword_rows] = ACTIONS(1852),
    [sym_keyword_groups] = ACTIONS(1852),
    [sym_keyword_between] = ACTIONS(1852),
    [sym_keyword_preceding] = ACTIONS(1852),
    [sym_keyword_following] = ACTIONS(1852),
    [sym_keyword_unique] = ACTIONS(1852),
    [sym_keyword_references] = ACTIONS(1852),
    [aux_sym_keyword_like_token1] = ACTIONS(1852),
    [aux_sym_keyword_like_token2] = ACTIONS(1852),
    [sym_keyword_similar] = ACTIONS(1852),
    [sym_keyword_check] = ACTIONS(1852),
    [sym_keyword_stored] = ACTIONS(1852),
    [sym_keyword_virtual] = ACTIONS(1852),
    [sym_keyword_comment] = ACTIONS(1852),
    [sym_keyword_null] = ACTIONS(1852),
    [sym_keyword_array] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1976),
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1854),
    [sym_op_other] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1854),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_LT_GT] = ACTIONS(1852),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(2113),
    [anon_sym_SEMI] = ACTIONS(2113),
    [sym_keyword_from] = ACTIONS(2113),
    [sym_keyword_on] = ACTIONS(2113),
    [sym_keyword_where] = ACTIONS(2113),
    [sym_keyword_desc] = ACTIONS(2113),
    [sym_keyword_asc] = ACTIONS(2113),
    [sym_keyword_limit] = ACTIONS(2113),
    [sym_keyword_primary] = ACTIONS(2113),
    [sym_keyword_create] = ACTIONS(2113),
    [sym_keyword_as] = ACTIONS(2115),
    [sym_keyword_constraint] = ACTIONS(2113),
    [sym_keyword_separator] = ACTIONS(2113),
    [sym_keyword_when] = ACTIONS(2113),
    [sym_keyword_then] = ACTIONS(2113),
    [sym_keyword_else] = ACTIONS(2113),
    [sym_keyword_end] = ACTIONS(2113),
    [sym_keyword_in] = ACTIONS(2113),
    [sym_keyword_and] = ACTIONS(2113),
    [sym_keyword_or] = ACTIONS(2113),
    [sym_keyword_is] = ACTIONS(2113),
    [sym_keyword_not] = ACTIONS(2113),
    [sym_keyword_using] = ACTIONS(2113),
    [sym_keyword_auto_increment] = ACTIONS(2113),
    [sym_keyword_generated] = ACTIONS(2113),
    [sym_keyword_default] = ACTIONS(2113),
    [sym_keyword_returning] = ACTIONS(2113),
    [sym_keyword_first] = ACTIONS(2113),
    [sym_keyword_after] = ACTIONS(2113),
    [sym_keyword_range] = ACTIONS(2113),
    [sym_keyword_rows] = ACTIONS(2113),
    [sym_keyword_groups] = ACTIONS(2113),
    [sym_keyword_between] = ACTIONS(2113),
    [sym_keyword_preceding] = ACTIONS(2113),
    [sym_keyword_following] = ACTIONS(2113),
    [sym_keyword_unique] = ACTIONS(2113),
    [sym_keyword_references] = ACTIONS(2113),
    [aux_sym_keyword_like_token1] = ACTIONS(2113),
    [aux_sym_keyword_like_token2] = ACTIONS(2113),
    [sym_keyword_similar] = ACTIONS(2113),
    [sym_keyword_zerofill] = ACTIONS(2117),
    [sym_keyword_check] = ACTIONS(2113),
    [sym_keyword_stored] = ACTIONS(2113),
    [sym_keyword_virtual] = ACTIONS(2113),
    [sym_keyword_comment] = ACTIONS(2113),
    [sym_keyword_null] = ACTIONS(2113),
    [sym_keyword_array] = ACTIONS(2113),
    [anon_sym_LBRACK] = ACTIONS(2113),
    [anon_sym_RBRACK] = ACTIONS(2113),
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2113),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(2113),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(2115),
    [anon_sym_GT] = ACTIONS(2115),
    [anon_sym_LT_EQ] = ACTIONS(2113),
    [anon_sym_GT_EQ] = ACTIONS(2113),
    [anon_sym_COLON] = ACTIONS(2115),
    [sym_op_other] = ACTIONS(2113),
    [anon_sym_PLUS] = ACTIONS(2113),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2113),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_BANG_EQ] = ACTIONS(2113),
    [anon_sym_LT_GT] = ACTIONS(2113),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [anon_sym_SEMI] = ACTIONS(2119),
    [sym_keyword_from] = ACTIONS(2119),
    [sym_keyword_on] = ACTIONS(2119),
    [sym_keyword_where] = ACTIONS(2119),
    [sym_keyword_desc] = ACTIONS(2119),
    [sym_keyword_asc] = ACTIONS(2119),
    [sym_keyword_limit] = ACTIONS(2119),
    [sym_keyword_primary] = ACTIONS(2119),
    [sym_keyword_create] = ACTIONS(2119),
    [sym_keyword_as] = ACTIONS(2121),
    [sym_keyword_constraint] = ACTIONS(2119),
    [sym_keyword_separator] = ACTIONS(2119),
    [sym_keyword_when] = ACTIONS(2119),
    [sym_keyword_then] = ACTIONS(2119),
    [sym_keyword_else] = ACTIONS(2119),
    [sym_keyword_end] = ACTIONS(2119),
    [sym_keyword_in] = ACTIONS(2119),
    [sym_keyword_and] = ACTIONS(2119),
    [sym_keyword_or] = ACTIONS(2119),
    [sym_keyword_is] = ACTIONS(2119),
    [sym_keyword_not] = ACTIONS(2119),
    [sym_keyword_using] = ACTIONS(2119),
    [sym_keyword_auto_increment] = ACTIONS(2119),
    [sym_keyword_generated] = ACTIONS(2119),
    [sym_keyword_default] = ACTIONS(2119),
    [sym_keyword_returning] = ACTIONS(2119),
    [sym_keyword_first] = ACTIONS(2119),
    [sym_keyword_after] = ACTIONS(2119),
    [sym_keyword_range] = ACTIONS(2119),
    [sym_keyword_rows] = ACTIONS(2119),
    [sym_keyword_groups] = ACTIONS(2119),
    [sym_keyword_between] = ACTIONS(2119),
    [sym_keyword_preceding] = ACTIONS(2119),
    [sym_keyword_following] = ACTIONS(2119),
    [sym_keyword_unique] = ACTIONS(2119),
    [sym_keyword_references] = ACTIONS(2119),
    [aux_sym_keyword_like_token1] = ACTIONS(2119),
    [aux_sym_keyword_like_token2] = ACTIONS(2119),
    [sym_keyword_similar] = ACTIONS(2119),
    [sym_keyword_zerofill] = ACTIONS(2123),
    [sym_keyword_check] = ACTIONS(2119),
    [sym_keyword_stored] = ACTIONS(2119),
    [sym_keyword_virtual] = ACTIONS(2119),
    [sym_keyword_comment] = ACTIONS(2119),
    [sym_keyword_null] = ACTIONS(2119),
    [sym_keyword_array] = ACTIONS(2119),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_RBRACK] = ACTIONS(2119),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2119),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_COLON_COLON] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_GT] = ACTIONS(2121),
    [anon_sym_LT_EQ] = ACTIONS(2119),
    [anon_sym_GT_EQ] = ACTIONS(2119),
    [anon_sym_COLON] = ACTIONS(2121),
    [sym_op_other] = ACTIONS(2119),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_PERCENT] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2121),
    [anon_sym_BANG_EQ] = ACTIONS(2119),
    [anon_sym_LT_GT] = ACTIONS(2119),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [sym_keyword_from] = ACTIONS(2125),
    [sym_keyword_on] = ACTIONS(2125),
    [sym_keyword_where] = ACTIONS(2125),
    [sym_keyword_desc] = ACTIONS(2125),
    [sym_keyword_asc] = ACTIONS(2125),
    [sym_keyword_limit] = ACTIONS(2125),
    [sym_keyword_primary] = ACTIONS(2125),
    [sym_keyword_create] = ACTIONS(2125),
    [sym_keyword_as] = ACTIONS(2127),
    [sym_keyword_constraint] = ACTIONS(2125),
    [sym_keyword_separator] = ACTIONS(2125),
    [sym_keyword_when] = ACTIONS(2125),
    [sym_keyword_then] = ACTIONS(2125),
    [sym_keyword_else] = ACTIONS(2125),
    [sym_keyword_end] = ACTIONS(2125),
    [sym_keyword_in] = ACTIONS(2125),
    [sym_keyword_and] = ACTIONS(2125),
    [sym_keyword_or] = ACTIONS(2125),
    [sym_keyword_is] = ACTIONS(2125),
    [sym_keyword_not] = ACTIONS(2125),
    [sym_keyword_using] = ACTIONS(2125),
    [sym_keyword_auto_increment] = ACTIONS(2125),
    [sym_keyword_generated] = ACTIONS(2125),
    [sym_keyword_default] = ACTIONS(2125),
    [sym_keyword_returning] = ACTIONS(2125),
    [sym_keyword_first] = ACTIONS(2125),
    [sym_keyword_after] = ACTIONS(2125),
    [sym_keyword_range] = ACTIONS(2125),
    [sym_keyword_rows] = ACTIONS(2125),
    [sym_keyword_groups] = ACTIONS(2125),
    [sym_keyword_between] = ACTIONS(2125),
    [sym_keyword_preceding] = ACTIONS(2125),
    [sym_keyword_following] = ACTIONS(2125),
    [sym_keyword_unique] = ACTIONS(2125),
    [sym_keyword_references] = ACTIONS(2125),
    [aux_sym_keyword_like_token1] = ACTIONS(2125),
    [aux_sym_keyword_like_token2] = ACTIONS(2125),
    [sym_keyword_similar] = ACTIONS(2125),
    [sym_keyword_check] = ACTIONS(2125),
    [sym_keyword_stored] = ACTIONS(2125),
    [sym_keyword_virtual] = ACTIONS(2125),
    [sym_keyword_comment] = ACTIONS(2125),
    [sym_keyword_null] = ACTIONS(2125),
    [sym_keyword_array] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_RBRACK] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_RPAREN] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_COLON_COLON] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2127),
    [anon_sym_GT] = ACTIONS(2127),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_COLON] = ACTIONS(2127),
    [sym_op_other] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_SLASH] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2127),
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_LT_GT] = ACTIONS(2125),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2131),
    [sym_keyword_from] = ACTIONS(2131),
    [sym_keyword_on] = ACTIONS(2131),
    [sym_keyword_where] = ACTIONS(2131),
    [sym_keyword_desc] = ACTIONS(2131),
    [sym_keyword_asc] = ACTIONS(2131),
    [sym_keyword_limit] = ACTIONS(2131),
    [sym_keyword_primary] = ACTIONS(2131),
    [sym_keyword_create] = ACTIONS(2131),
    [sym_keyword_as] = ACTIONS(2133),
    [sym_keyword_constraint] = ACTIONS(2131),
    [sym_keyword_separator] = ACTIONS(2131),
    [sym_keyword_when] = ACTIONS(2131),
    [sym_keyword_then] = ACTIONS(2131),
    [sym_keyword_else] = ACTIONS(2131),
    [sym_keyword_end] = ACTIONS(2131),
    [sym_keyword_in] = ACTIONS(2131),
    [sym_keyword_and] = ACTIONS(2131),
    [sym_keyword_or] = ACTIONS(2131),
    [sym_keyword_is] = ACTIONS(2131),
    [sym_keyword_not] = ACTIONS(2131),
    [sym_keyword_using] = ACTIONS(2131),
    [sym_keyword_auto_increment] = ACTIONS(2131),
    [sym_keyword_generated] = ACTIONS(2131),
    [sym_keyword_default] = ACTIONS(2131),
    [sym_keyword_returning] = ACTIONS(2131),
    [sym_keyword_first] = ACTIONS(2131),
    [sym_keyword_after] = ACTIONS(2131),
    [sym_keyword_range] = ACTIONS(2131),
    [sym_keyword_rows] = ACTIONS(2131),
    [sym_keyword_groups] = ACTIONS(2131),
    [sym_keyword_between] = ACTIONS(2131),
    [sym_keyword_preceding] = ACTIONS(2131),
    [sym_keyword_following] = ACTIONS(2131),
    [sym_keyword_unique] = ACTIONS(2131),
    [sym_keyword_references] = ACTIONS(2131),
    [aux_sym_keyword_like_token1] = ACTIONS(2131),
    [aux_sym_keyword_like_token2] = ACTIONS(2131),
    [sym_keyword_similar] = ACTIONS(2131),
    [sym_keyword_check] = ACTIONS(2131),
    [sym_keyword_stored] = ACTIONS(2131),
    [sym_keyword_virtual] = ACTIONS(2131),
    [sym_keyword_comment] = ACTIONS(2131),
    [sym_keyword_null] = ACTIONS(2131),
    [sym_keyword_array] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_RBRACK] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2135),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_COLON_COLON] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_GT] = ACTIONS(2133),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2133),
    [sym_op_other] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2133),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2133),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_LT_GT] = ACTIONS(2131),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [sym_keyword_from] = ACTIONS(2137),
    [sym_keyword_on] = ACTIONS(2137),
    [sym_keyword_where] = ACTIONS(2137),
    [sym_keyword_desc] = ACTIONS(2137),
    [sym_keyword_asc] = ACTIONS(2137),
    [sym_keyword_limit] = ACTIONS(2137),
    [sym_keyword_primary] = ACTIONS(2137),
    [sym_keyword_create] = ACTIONS(2137),
    [sym_keyword_as] = ACTIONS(2139),
    [sym_keyword_constraint] = ACTIONS(2137),
    [sym_keyword_separator] = ACTIONS(2137),
    [sym_keyword_when] = ACTIONS(2137),
    [sym_keyword_then] = ACTIONS(2137),
    [sym_keyword_else] = ACTIONS(2137),
    [sym_keyword_end] = ACTIONS(2137),
    [sym_keyword_in] = ACTIONS(2137),
    [sym_keyword_and] = ACTIONS(2137),
    [sym_keyword_or] = ACTIONS(2137),
    [sym_keyword_is] = ACTIONS(2137),
    [sym_keyword_not] = ACTIONS(2137),
    [sym_keyword_using] = ACTIONS(2137),
    [sym_keyword_auto_increment] = ACTIONS(2137),
    [sym_keyword_generated] = ACTIONS(2137),
    [sym_keyword_default] = ACTIONS(2137),
    [sym_keyword_returning] = ACTIONS(2137),
    [sym_keyword_first] = ACTIONS(2137),
    [sym_keyword_after] = ACTIONS(2137),
    [sym_keyword_range] = ACTIONS(2137),
    [sym_keyword_rows] = ACTIONS(2137),
    [sym_keyword_groups] = ACTIONS(2137),
    [sym_keyword_between] = ACTIONS(2137),
    [sym_keyword_preceding] = ACTIONS(2137),
    [sym_keyword_following] = ACTIONS(2137),
    [sym_keyword_unique] = ACTIONS(2137),
    [sym_keyword_references] = ACTIONS(2137),
    [aux_sym_keyword_like_token1] = ACTIONS(2137),
    [aux_sym_keyword_like_token2] = ACTIONS(2137),
    [sym_keyword_similar] = ACTIONS(2137),
    [sym_keyword_check] = ACTIONS(2137),
    [sym_keyword_stored] = ACTIONS(2137),
    [sym_keyword_virtual] = ACTIONS(2137),
    [sym_keyword_comment] = ACTIONS(2137),
    [sym_keyword_null] = ACTIONS(2137),
    [sym_keyword_array] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_RBRACK] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2137),
    [anon_sym_COMMA] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_COLON_COLON] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2139),
    [anon_sym_GT] = ACTIONS(2139),
    [anon_sym_LT_EQ] = ACTIONS(2137),
    [anon_sym_GT_EQ] = ACTIONS(2137),
    [anon_sym_COLON] = ACTIONS(2139),
    [sym_op_other] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_SLASH] = ACTIONS(2139),
    [anon_sym_PERCENT] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_BANG_EQ] = ACTIONS(2137),
    [anon_sym_LT_GT] = ACTIONS(2137),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(2065),
    [anon_sym_SEMI] = ACTIONS(2065),
    [sym_keyword_from] = ACTIONS(2065),
    [sym_keyword_on] = ACTIONS(2065),
    [sym_keyword_where] = ACTIONS(2065),
    [sym_keyword_desc] = ACTIONS(2065),
    [sym_keyword_asc] = ACTIONS(2065),
    [sym_keyword_limit] = ACTIONS(2065),
    [sym_keyword_primary] = ACTIONS(2065),
    [sym_keyword_create] = ACTIONS(2065),
    [sym_keyword_as] = ACTIONS(2067),
    [sym_keyword_constraint] = ACTIONS(2065),
    [sym_keyword_separator] = ACTIONS(2065),
    [sym_keyword_when] = ACTIONS(2065),
    [sym_keyword_then] = ACTIONS(2065),
    [sym_keyword_else] = ACTIONS(2065),
    [sym_keyword_end] = ACTIONS(2065),
    [sym_keyword_in] = ACTIONS(2065),
    [sym_keyword_and] = ACTIONS(2065),
    [sym_keyword_or] = ACTIONS(2065),
    [sym_keyword_is] = ACTIONS(2065),
    [sym_keyword_not] = ACTIONS(2065),
    [sym_keyword_using] = ACTIONS(2065),
    [sym_keyword_auto_increment] = ACTIONS(2065),
    [sym_keyword_generated] = ACTIONS(2065),
    [sym_keyword_default] = ACTIONS(2065),
    [sym_keyword_returning] = ACTIONS(2065),
    [sym_keyword_first] = ACTIONS(2065),
    [sym_keyword_after] = ACTIONS(2065),
    [sym_keyword_range] = ACTIONS(2065),
    [sym_keyword_rows] = ACTIONS(2065),
    [sym_keyword_groups] = ACTIONS(2065),
    [sym_keyword_between] = ACTIONS(2065),
    [sym_keyword_preceding] = ACTIONS(2065),
    [sym_keyword_following] = ACTIONS(2065),
    [sym_keyword_unique] = ACTIONS(2065),
    [sym_keyword_references] = ACTIONS(2065),
    [aux_sym_keyword_like_token1] = ACTIONS(2065),
    [aux_sym_keyword_like_token2] = ACTIONS(2065),
    [sym_keyword_similar] = ACTIONS(2065),
    [sym_keyword_zerofill] = ACTIONS(2143),
    [sym_keyword_check] = ACTIONS(2065),
    [sym_keyword_stored] = ACTIONS(2065),
    [sym_keyword_virtual] = ACTIONS(2065),
    [sym_keyword_comment] = ACTIONS(2065),
    [sym_keyword_null] = ACTIONS(2065),
    [sym_keyword_array] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_STAR] = ACTIONS(2065),
    [anon_sym_COLON_COLON] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2067),
    [sym_op_other] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2065),
    [anon_sym_LT_GT] = ACTIONS(2065),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [sym_keyword_from] = ACTIONS(2145),
    [sym_keyword_on] = ACTIONS(2145),
    [sym_keyword_where] = ACTIONS(2145),
    [sym_keyword_desc] = ACTIONS(2145),
    [sym_keyword_asc] = ACTIONS(2145),
    [sym_keyword_limit] = ACTIONS(2145),
    [sym_keyword_primary] = ACTIONS(2145),
    [sym_keyword_create] = ACTIONS(2145),
    [sym_keyword_as] = ACTIONS(2147),
    [sym_keyword_constraint] = ACTIONS(2145),
    [sym_keyword_separator] = ACTIONS(2145),
    [sym_keyword_when] = ACTIONS(2145),
    [sym_keyword_then] = ACTIONS(2145),
    [sym_keyword_else] = ACTIONS(2145),
    [sym_keyword_end] = ACTIONS(2145),
    [sym_keyword_in] = ACTIONS(2145),
    [sym_keyword_and] = ACTIONS(2145),
    [sym_keyword_or] = ACTIONS(2145),
    [sym_keyword_is] = ACTIONS(2145),
    [sym_keyword_not] = ACTIONS(2145),
    [sym_keyword_using] = ACTIONS(2145),
    [sym_keyword_auto_increment] = ACTIONS(2145),
    [sym_keyword_generated] = ACTIONS(2145),
    [sym_keyword_default] = ACTIONS(2145),
    [sym_keyword_returning] = ACTIONS(2145),
    [sym_keyword_first] = ACTIONS(2145),
    [sym_keyword_after] = ACTIONS(2145),
    [sym_keyword_range] = ACTIONS(2145),
    [sym_keyword_rows] = ACTIONS(2145),
    [sym_keyword_groups] = ACTIONS(2145),
    [sym_keyword_between] = ACTIONS(2145),
    [sym_keyword_preceding] = ACTIONS(2145),
    [sym_keyword_following] = ACTIONS(2145),
    [sym_keyword_unique] = ACTIONS(2145),
    [sym_keyword_references] = ACTIONS(2145),
    [aux_sym_keyword_like_token1] = ACTIONS(2145),
    [aux_sym_keyword_like_token2] = ACTIONS(2145),
    [sym_keyword_similar] = ACTIONS(2145),
    [sym_keyword_zerofill] = ACTIONS(2149),
    [sym_keyword_check] = ACTIONS(2145),
    [sym_keyword_stored] = ACTIONS(2145),
    [sym_keyword_virtual] = ACTIONS(2145),
    [sym_keyword_comment] = ACTIONS(2145),
    [sym_keyword_null] = ACTIONS(2145),
    [sym_keyword_array] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_COLON] = ACTIONS(2147),
    [sym_op_other] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_LT_GT] = ACTIONS(2145),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2051),
    [sym_keyword_from] = ACTIONS(2051),
    [sym_keyword_on] = ACTIONS(2051),
    [sym_keyword_where] = ACTIONS(2051),
    [sym_keyword_desc] = ACTIONS(2051),
    [sym_keyword_asc] = ACTIONS(2051),
    [sym_keyword_limit] = ACTIONS(2051),
    [sym_keyword_primary] = ACTIONS(2051),
    [sym_keyword_create] = ACTIONS(2051),
    [sym_keyword_as] = ACTIONS(2053),
    [sym_keyword_constraint] = ACTIONS(2051),
    [sym_keyword_separator] = ACTIONS(2051),
    [sym_keyword_when] = ACTIONS(2051),
    [sym_keyword_then] = ACTIONS(2051),
    [sym_keyword_else] = ACTIONS(2051),
    [sym_keyword_end] = ACTIONS(2051),
    [sym_keyword_in] = ACTIONS(2051),
    [sym_keyword_and] = ACTIONS(2051),
    [sym_keyword_or] = ACTIONS(2051),
    [sym_keyword_is] = ACTIONS(2051),
    [sym_keyword_not] = ACTIONS(2051),
    [sym_keyword_using] = ACTIONS(2051),
    [sym_keyword_auto_increment] = ACTIONS(2051),
    [sym_keyword_generated] = ACTIONS(2051),
    [sym_keyword_default] = ACTIONS(2051),
    [sym_keyword_returning] = ACTIONS(2051),
    [sym_keyword_first] = ACTIONS(2051),
    [sym_keyword_after] = ACTIONS(2051),
    [sym_keyword_range] = ACTIONS(2051),
    [sym_keyword_rows] = ACTIONS(2051),
    [sym_keyword_groups] = ACTIONS(2051),
    [sym_keyword_between] = ACTIONS(2051),
    [sym_keyword_preceding] = ACTIONS(2051),
    [sym_keyword_following] = ACTIONS(2051),
    [sym_keyword_unique] = ACTIONS(2051),
    [sym_keyword_references] = ACTIONS(2051),
    [aux_sym_keyword_like_token1] = ACTIONS(2051),
    [aux_sym_keyword_like_token2] = ACTIONS(2051),
    [sym_keyword_similar] = ACTIONS(2051),
    [sym_keyword_zerofill] = ACTIONS(2151),
    [sym_keyword_check] = ACTIONS(2051),
    [sym_keyword_stored] = ACTIONS(2051),
    [sym_keyword_virtual] = ACTIONS(2051),
    [sym_keyword_comment] = ACTIONS(2051),
    [sym_keyword_null] = ACTIONS(2051),
    [sym_keyword_array] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_COLON] = ACTIONS(2053),
    [sym_op_other] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_GT] = ACTIONS(2051),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2153),
    [sym_keyword_from] = ACTIONS(2153),
    [sym_keyword_on] = ACTIONS(2153),
    [sym_keyword_where] = ACTIONS(2153),
    [sym_keyword_desc] = ACTIONS(2153),
    [sym_keyword_asc] = ACTIONS(2153),
    [sym_keyword_limit] = ACTIONS(2153),
    [sym_keyword_primary] = ACTIONS(2153),
    [sym_keyword_create] = ACTIONS(2153),
    [sym_keyword_as] = ACTIONS(2155),
    [sym_keyword_constraint] = ACTIONS(2153),
    [sym_keyword_separator] = ACTIONS(2153),
    [sym_keyword_when] = ACTIONS(2153),
    [sym_keyword_then] = ACTIONS(2153),
    [sym_keyword_else] = ACTIONS(2153),
    [sym_keyword_end] = ACTIONS(2153),
    [sym_keyword_in] = ACTIONS(2153),
    [sym_keyword_and] = ACTIONS(2153),
    [sym_keyword_or] = ACTIONS(2153),
    [sym_keyword_is] = ACTIONS(2153),
    [sym_keyword_not] = ACTIONS(2153),
    [sym_keyword_using] = ACTIONS(2153),
    [sym_keyword_auto_increment] = ACTIONS(2153),
    [sym_keyword_generated] = ACTIONS(2153),
    [sym_keyword_default] = ACTIONS(2153),
    [sym_keyword_returning] = ACTIONS(2153),
    [sym_keyword_first] = ACTIONS(2153),
    [sym_keyword_after] = ACTIONS(2153),
    [sym_keyword_range] = ACTIONS(2153),
    [sym_keyword_rows] = ACTIONS(2153),
    [sym_keyword_groups] = ACTIONS(2153),
    [sym_keyword_between] = ACTIONS(2153),
    [sym_keyword_preceding] = ACTIONS(2153),
    [sym_keyword_following] = ACTIONS(2153),
    [sym_keyword_unique] = ACTIONS(2153),
    [sym_keyword_references] = ACTIONS(2153),
    [aux_sym_keyword_like_token1] = ACTIONS(2153),
    [aux_sym_keyword_like_token2] = ACTIONS(2153),
    [sym_keyword_similar] = ACTIONS(2153),
    [sym_keyword_zerofill] = ACTIONS(2157),
    [sym_keyword_check] = ACTIONS(2153),
    [sym_keyword_stored] = ACTIONS(2153),
    [sym_keyword_virtual] = ACTIONS(2153),
    [sym_keyword_comment] = ACTIONS(2153),
    [sym_keyword_null] = ACTIONS(2153),
    [sym_keyword_array] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2153),
    [anon_sym_RBRACK] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(2155),
    [anon_sym_GT] = ACTIONS(2155),
    [anon_sym_LT_EQ] = ACTIONS(2153),
    [anon_sym_GT_EQ] = ACTIONS(2153),
    [anon_sym_COLON] = ACTIONS(2155),
    [sym_op_other] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_SLASH] = ACTIONS(2155),
    [anon_sym_PERCENT] = ACTIONS(2153),
    [anon_sym_CARET] = ACTIONS(2155),
    [anon_sym_BANG_EQ] = ACTIONS(2153),
    [anon_sym_LT_GT] = ACTIONS(2153),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2107),
    [sym_keyword_from] = ACTIONS(2107),
    [sym_keyword_on] = ACTIONS(2107),
    [sym_keyword_where] = ACTIONS(2107),
    [sym_keyword_desc] = ACTIONS(2107),
    [sym_keyword_asc] = ACTIONS(2107),
    [sym_keyword_limit] = ACTIONS(2107),
    [sym_keyword_primary] = ACTIONS(2107),
    [sym_keyword_create] = ACTIONS(2107),
    [sym_keyword_as] = ACTIONS(2109),
    [sym_keyword_constraint] = ACTIONS(2107),
    [sym_keyword_separator] = ACTIONS(2107),
    [sym_keyword_when] = ACTIONS(2107),
    [sym_keyword_then] = ACTIONS(2107),
    [sym_keyword_else] = ACTIONS(2107),
    [sym_keyword_end] = ACTIONS(2107),
    [sym_keyword_in] = ACTIONS(2107),
    [sym_keyword_and] = ACTIONS(2107),
    [sym_keyword_or] = ACTIONS(2107),
    [sym_keyword_is] = ACTIONS(2107),
    [sym_keyword_not] = ACTIONS(2107),
    [sym_keyword_using] = ACTIONS(2107),
    [sym_keyword_auto_increment] = ACTIONS(2107),
    [sym_keyword_generated] = ACTIONS(2107),
    [sym_keyword_default] = ACTIONS(2107),
    [sym_keyword_returning] = ACTIONS(2107),
    [sym_keyword_first] = ACTIONS(2107),
    [sym_keyword_after] = ACTIONS(2107),
    [sym_keyword_range] = ACTIONS(2107),
    [sym_keyword_rows] = ACTIONS(2107),
    [sym_keyword_groups] = ACTIONS(2107),
    [sym_keyword_between] = ACTIONS(2107),
    [sym_keyword_preceding] = ACTIONS(2107),
    [sym_keyword_following] = ACTIONS(2107),
    [sym_keyword_unique] = ACTIONS(2107),
    [sym_keyword_references] = ACTIONS(2107),
    [aux_sym_keyword_like_token1] = ACTIONS(2107),
    [aux_sym_keyword_like_token2] = ACTIONS(2107),
    [sym_keyword_similar] = ACTIONS(2107),
    [sym_keyword_zerofill] = ACTIONS(2159),
    [sym_keyword_check] = ACTIONS(2107),
    [sym_keyword_stored] = ACTIONS(2107),
    [sym_keyword_virtual] = ACTIONS(2107),
    [sym_keyword_comment] = ACTIONS(2107),
    [sym_keyword_null] = ACTIONS(2107),
    [sym_keyword_array] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_RBRACK] = ACTIONS(2107),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_COMMA] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2107),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_COLON_COLON] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2107),
    [anon_sym_GT_EQ] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2109),
    [sym_op_other] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_PERCENT] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2107),
    [anon_sym_LT_GT] = ACTIONS(2107),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [sym_keyword_from] = ACTIONS(1852),
    [sym_keyword_on] = ACTIONS(1852),
    [sym_keyword_where] = ACTIONS(1852),
    [sym_keyword_desc] = ACTIONS(1852),
    [sym_keyword_asc] = ACTIONS(1852),
    [sym_keyword_limit] = ACTIONS(1852),
    [sym_keyword_primary] = ACTIONS(1852),
    [sym_keyword_create] = ACTIONS(1852),
    [sym_keyword_as] = ACTIONS(1854),
    [sym_keyword_constraint] = ACTIONS(1852),
    [sym_keyword_separator] = ACTIONS(1852),
    [sym_keyword_when] = ACTIONS(1852),
    [sym_keyword_then] = ACTIONS(1852),
    [sym_keyword_else] = ACTIONS(1852),
    [sym_keyword_end] = ACTIONS(1852),
    [sym_keyword_in] = ACTIONS(1852),
    [sym_keyword_and] = ACTIONS(1852),
    [sym_keyword_or] = ACTIONS(1852),
    [sym_keyword_is] = ACTIONS(1852),
    [sym_keyword_not] = ACTIONS(1852),
    [sym_keyword_using] = ACTIONS(1852),
    [sym_keyword_auto_increment] = ACTIONS(1852),
    [sym_keyword_generated] = ACTIONS(1852),
    [sym_keyword_default] = ACTIONS(1852),
    [sym_keyword_returning] = ACTIONS(1852),
    [sym_keyword_first] = ACTIONS(1852),
    [sym_keyword_after] = ACTIONS(1852),
    [sym_keyword_range] = ACTIONS(1852),
    [sym_keyword_rows] = ACTIONS(1852),
    [sym_keyword_groups] = ACTIONS(1852),
    [sym_keyword_between] = ACTIONS(1852),
    [sym_keyword_preceding] = ACTIONS(1852),
    [sym_keyword_following] = ACTIONS(1852),
    [sym_keyword_unique] = ACTIONS(1852),
    [sym_keyword_references] = ACTIONS(1852),
    [aux_sym_keyword_like_token1] = ACTIONS(1852),
    [aux_sym_keyword_like_token2] = ACTIONS(1852),
    [sym_keyword_similar] = ACTIONS(1852),
    [sym_keyword_zerofill] = ACTIONS(1858),
    [sym_keyword_check] = ACTIONS(1852),
    [sym_keyword_stored] = ACTIONS(1852),
    [sym_keyword_virtual] = ACTIONS(1852),
    [sym_keyword_comment] = ACTIONS(1852),
    [sym_keyword_null] = ACTIONS(1852),
    [sym_keyword_array] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1854),
    [sym_op_other] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1854),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_LT_GT] = ACTIONS(1852),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_keyword_from] = ACTIONS(1960),
    [sym_keyword_on] = ACTIONS(1960),
    [sym_keyword_where] = ACTIONS(1960),
    [sym_keyword_desc] = ACTIONS(1960),
    [sym_keyword_asc] = ACTIONS(1960),
    [sym_keyword_limit] = ACTIONS(1960),
    [sym_keyword_primary] = ACTIONS(1960),
    [sym_keyword_create] = ACTIONS(1960),
    [sym_keyword_as] = ACTIONS(1962),
    [sym_keyword_constraint] = ACTIONS(1960),
    [sym_keyword_separator] = ACTIONS(1960),
    [sym_keyword_when] = ACTIONS(1960),
    [sym_keyword_then] = ACTIONS(1960),
    [sym_keyword_else] = ACTIONS(1960),
    [sym_keyword_end] = ACTIONS(1960),
    [sym_keyword_in] = ACTIONS(1960),
    [sym_keyword_and] = ACTIONS(1960),
    [sym_keyword_or] = ACTIONS(1960),
    [sym_keyword_is] = ACTIONS(1960),
    [sym_keyword_not] = ACTIONS(1960),
    [sym_keyword_using] = ACTIONS(1960),
    [sym_keyword_auto_increment] = ACTIONS(1960),
    [sym_keyword_generated] = ACTIONS(1960),
    [sym_keyword_default] = ACTIONS(1960),
    [sym_keyword_returning] = ACTIONS(1960),
    [sym_keyword_first] = ACTIONS(1960),
    [sym_keyword_after] = ACTIONS(1960),
    [sym_keyword_range] = ACTIONS(1960),
    [sym_keyword_rows] = ACTIONS(1960),
    [sym_keyword_groups] = ACTIONS(1960),
    [sym_keyword_between] = ACTIONS(1960),
    [sym_keyword_preceding] = ACTIONS(1960),
    [sym_keyword_following] = ACTIONS(1960),
    [sym_keyword_unique] = ACTIONS(1960),
    [sym_keyword_references] = ACTIONS(1960),
    [aux_sym_keyword_like_token1] = ACTIONS(1960),
    [aux_sym_keyword_like_token2] = ACTIONS(1960),
    [sym_keyword_similar] = ACTIONS(1960),
    [sym_keyword_check] = ACTIONS(1960),
    [sym_keyword_stored] = ACTIONS(1960),
    [sym_keyword_virtual] = ACTIONS(1960),
    [sym_keyword_comment] = ACTIONS(1960),
    [sym_keyword_null] = ACTIONS(1960),
    [sym_keyword_array] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1960),
    [anon_sym_RBRACK] = ACTIONS(1960),
    [anon_sym_LPAREN] = ACTIONS(1960),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_COMMA] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_LT_EQ] = ACTIONS(1960),
    [anon_sym_GT_EQ] = ACTIONS(1960),
    [anon_sym_COLON] = ACTIONS(1962),
    [sym_op_other] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1962),
    [anon_sym_SLASH] = ACTIONS(1962),
    [anon_sym_PERCENT] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_LT_GT] = ACTIONS(1960),
  },
  [216] = {
    [sym__identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_keyword_from] = ACTIONS(1376),
    [sym_keyword_on] = ACTIONS(1376),
    [sym_keyword_partition] = ACTIONS(1376),
    [sym_keyword_create] = ACTIONS(1376),
    [sym_keyword_as] = ACTIONS(1376),
    [sym_keyword_when] = ACTIONS(1376),
    [sym_keyword_in] = ACTIONS(1376),
    [sym_keyword_and] = ACTIONS(1376),
    [sym_keyword_or] = ACTIONS(1376),
    [sym_keyword_is] = ACTIONS(1376),
    [sym_keyword_not] = ACTIONS(1376),
    [sym_keyword_force] = ACTIONS(1376),
    [sym_keyword_collate] = ACTIONS(1376),
    [sym_keyword_cascade] = ACTIONS(1376),
    [sym_keyword_restrict] = ACTIONS(1376),
    [sym_keyword_with] = ACTIONS(1376),
    [sym_keyword_schema] = ACTIONS(1376),
    [sym_keyword_union] = ACTIONS(1376),
    [sym_keyword_except] = ACTIONS(1376),
    [sym_keyword_intersect] = ACTIONS(1376),
    [sym_keyword_returning] = ACTIONS(1376),
    [sym_keyword_rows] = ACTIONS(1376),
    [sym_keyword_between] = ACTIONS(1376),
    [aux_sym_keyword_like_token1] = ACTIONS(1376),
    [aux_sym_keyword_like_token2] = ACTIONS(1376),
    [sym_keyword_similar] = ACTIONS(1376),
    [sym_keyword_authorization] = ACTIONS(1376),
    [sym_keyword_returns] = ACTIONS(1376),
    [sym_keyword_language] = ACTIONS(1376),
    [sym_keyword_immutable] = ACTIONS(1376),
    [sym_keyword_stable] = ACTIONS(1376),
    [sym_keyword_volatile] = ACTIONS(1376),
    [sym_keyword_leakproof] = ACTIONS(1376),
    [sym_keyword_parallel] = ACTIONS(1376),
    [sym_keyword_called] = ACTIONS(1376),
    [sym_keyword_strict] = ACTIONS(1376),
    [sym_keyword_cost] = ACTIONS(1376),
    [sym_keyword_support] = ACTIONS(1376),
    [sym_keyword_security] = ACTIONS(1376),
    [sym_keyword_version] = ACTIONS(1376),
    [sym_keyword_external] = ACTIONS(1376),
    [sym_keyword_array] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [sym_op_other] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_LT_GT] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1374),
    [aux_sym__single_quote_string_token1] = ACTIONS(1374),
    [aux_sym_identifier_token1] = ACTIONS(1374),
    [sym__dollar_quoted_string_end_tag] = ACTIONS(1374),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(2161),
    [anon_sym_SEMI] = ACTIONS(2161),
    [sym_keyword_from] = ACTIONS(2161),
    [sym_keyword_on] = ACTIONS(2161),
    [sym_keyword_where] = ACTIONS(2161),
    [sym_keyword_desc] = ACTIONS(2161),
    [sym_keyword_asc] = ACTIONS(2161),
    [sym_keyword_limit] = ACTIONS(2161),
    [sym_keyword_primary] = ACTIONS(2161),
    [sym_keyword_create] = ACTIONS(2161),
    [sym_keyword_as] = ACTIONS(2163),
    [sym_keyword_constraint] = ACTIONS(2161),
    [sym_keyword_separator] = ACTIONS(2161),
    [sym_keyword_when] = ACTIONS(2161),
    [sym_keyword_then] = ACTIONS(2161),
    [sym_keyword_else] = ACTIONS(2161),
    [sym_keyword_end] = ACTIONS(2161),
    [sym_keyword_in] = ACTIONS(2161),
    [sym_keyword_and] = ACTIONS(2161),
    [sym_keyword_or] = ACTIONS(2161),
    [sym_keyword_is] = ACTIONS(2161),
    [sym_keyword_not] = ACTIONS(2161),
    [sym_keyword_using] = ACTIONS(2161),
    [sym_keyword_auto_increment] = ACTIONS(2161),
    [sym_keyword_generated] = ACTIONS(2161),
    [sym_keyword_default] = ACTIONS(2161),
    [sym_keyword_returning] = ACTIONS(2161),
    [sym_keyword_first] = ACTIONS(2161),
    [sym_keyword_after] = ACTIONS(2161),
    [sym_keyword_range] = ACTIONS(2161),
    [sym_keyword_rows] = ACTIONS(2161),
    [sym_keyword_groups] = ACTIONS(2161),
    [sym_keyword_between] = ACTIONS(2161),
    [sym_keyword_preceding] = ACTIONS(2161),
    [sym_keyword_following] = ACTIONS(2161),
    [sym_keyword_unique] = ACTIONS(2161),
    [sym_keyword_references] = ACTIONS(2161),
    [aux_sym_keyword_like_token1] = ACTIONS(2161),
    [aux_sym_keyword_like_token2] = ACTIONS(2161),
    [sym_keyword_similar] = ACTIONS(2161),
    [sym_keyword_check] = ACTIONS(2161),
    [sym_keyword_stored] = ACTIONS(2161),
    [sym_keyword_virtual] = ACTIONS(2161),
    [sym_keyword_comment] = ACTIONS(2161),
    [sym_keyword_null] = ACTIONS(2161),
    [sym_keyword_array] = ACTIONS(2161),
    [anon_sym_LBRACK] = ACTIONS(2161),
    [anon_sym_RBRACK] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_RPAREN] = ACTIONS(2161),
    [anon_sym_COMMA] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_LT_EQ] = ACTIONS(2161),
    [anon_sym_GT_EQ] = ACTIONS(2161),
    [anon_sym_COLON] = ACTIONS(2163),
    [sym_op_other] = ACTIONS(2161),
    [anon_sym_PLUS] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_PERCENT] = ACTIONS(2161),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_BANG_EQ] = ACTIONS(2161),
    [anon_sym_LT_GT] = ACTIONS(2161),
  },
  [218] = {
    [ts_builtin_sym_end] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [sym_keyword_from] = ACTIONS(2167),
    [sym_keyword_on] = ACTIONS(2167),
    [sym_keyword_where] = ACTIONS(2167),
    [sym_keyword_desc] = ACTIONS(2167),
    [sym_keyword_asc] = ACTIONS(2167),
    [sym_keyword_limit] = ACTIONS(2167),
    [sym_keyword_primary] = ACTIONS(2167),
    [sym_keyword_create] = ACTIONS(2167),
    [sym_keyword_as] = ACTIONS(2169),
    [sym_keyword_constraint] = ACTIONS(2167),
    [sym_keyword_separator] = ACTIONS(2167),
    [sym_keyword_when] = ACTIONS(2167),
    [sym_keyword_then] = ACTIONS(2167),
    [sym_keyword_else] = ACTIONS(2167),
    [sym_keyword_end] = ACTIONS(2167),
    [sym_keyword_in] = ACTIONS(2167),
    [sym_keyword_and] = ACTIONS(2167),
    [sym_keyword_or] = ACTIONS(2167),
    [sym_keyword_is] = ACTIONS(2167),
    [sym_keyword_not] = ACTIONS(2167),
    [sym_keyword_using] = ACTIONS(2167),
    [sym_keyword_auto_increment] = ACTIONS(2167),
    [sym_keyword_generated] = ACTIONS(2167),
    [sym_keyword_default] = ACTIONS(2167),
    [sym_keyword_returning] = ACTIONS(2167),
    [sym_keyword_first] = ACTIONS(2167),
    [sym_keyword_after] = ACTIONS(2167),
    [sym_keyword_range] = ACTIONS(2167),
    [sym_keyword_rows] = ACTIONS(2167),
    [sym_keyword_groups] = ACTIONS(2167),
    [sym_keyword_between] = ACTIONS(2167),
    [sym_keyword_preceding] = ACTIONS(2167),
    [sym_keyword_following] = ACTIONS(2167),
    [sym_keyword_unique] = ACTIONS(2167),
    [sym_keyword_references] = ACTIONS(2167),
    [aux_sym_keyword_like_token1] = ACTIONS(2167),
    [aux_sym_keyword_like_token2] = ACTIONS(2167),
    [sym_keyword_similar] = ACTIONS(2167),
    [sym_keyword_check] = ACTIONS(2167),
    [sym_keyword_stored] = ACTIONS(2167),
    [sym_keyword_virtual] = ACTIONS(2167),
    [sym_keyword_comment] = ACTIONS(2167),
    [sym_keyword_null] = ACTIONS(2167),
    [sym_keyword_array] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_RBRACK] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_RPAREN] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2167),
    [anon_sym_GT_EQ] = ACTIONS(2167),
    [anon_sym_COLON] = ACTIONS(2169),
    [sym_op_other] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [anon_sym_PERCENT] = ACTIONS(2167),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2167),
    [anon_sym_LT_GT] = ACTIONS(2167),
  },
  [219] = {
    [ts_builtin_sym_end] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2171),
    [sym_keyword_from] = ACTIONS(2171),
    [sym_keyword_on] = ACTIONS(2171),
    [sym_keyword_where] = ACTIONS(2171),
    [sym_keyword_desc] = ACTIONS(2171),
    [sym_keyword_asc] = ACTIONS(2171),
    [sym_keyword_limit] = ACTIONS(2171),
    [sym_keyword_primary] = ACTIONS(2171),
    [sym_keyword_create] = ACTIONS(2171),
    [sym_keyword_as] = ACTIONS(2173),
    [sym_keyword_constraint] = ACTIONS(2171),
    [sym_keyword_separator] = ACTIONS(2171),
    [sym_keyword_when] = ACTIONS(2171),
    [sym_keyword_then] = ACTIONS(2171),
    [sym_keyword_else] = ACTIONS(2171),
    [sym_keyword_end] = ACTIONS(2171),
    [sym_keyword_in] = ACTIONS(2171),
    [sym_keyword_and] = ACTIONS(2171),
    [sym_keyword_or] = ACTIONS(2171),
    [sym_keyword_is] = ACTIONS(2171),
    [sym_keyword_not] = ACTIONS(2171),
    [sym_keyword_using] = ACTIONS(2171),
    [sym_keyword_auto_increment] = ACTIONS(2171),
    [sym_keyword_generated] = ACTIONS(2171),
    [sym_keyword_default] = ACTIONS(2171),
    [sym_keyword_returning] = ACTIONS(2171),
    [sym_keyword_first] = ACTIONS(2171),
    [sym_keyword_after] = ACTIONS(2171),
    [sym_keyword_range] = ACTIONS(2171),
    [sym_keyword_rows] = ACTIONS(2171),
    [sym_keyword_groups] = ACTIONS(2171),
    [sym_keyword_between] = ACTIONS(2171),
    [sym_keyword_preceding] = ACTIONS(2171),
    [sym_keyword_following] = ACTIONS(2171),
    [sym_keyword_unique] = ACTIONS(2171),
    [sym_keyword_references] = ACTIONS(2171),
    [aux_sym_keyword_like_token1] = ACTIONS(2171),
    [aux_sym_keyword_like_token2] = ACTIONS(2171),
    [sym_keyword_similar] = ACTIONS(2171),
    [sym_keyword_check] = ACTIONS(2171),
    [sym_keyword_stored] = ACTIONS(2171),
    [sym_keyword_virtual] = ACTIONS(2171),
    [sym_keyword_comment] = ACTIONS(2171),
    [sym_keyword_null] = ACTIONS(2171),
    [sym_keyword_array] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_RBRACK] = ACTIONS(2171),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_RPAREN] = ACTIONS(2171),
    [anon_sym_COMMA] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2171),
    [anon_sym_COLON_COLON] = ACTIONS(2171),
    [anon_sym_LT] = ACTIONS(2173),
    [anon_sym_GT] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2171),
    [anon_sym_COLON] = ACTIONS(2173),
    [sym_op_other] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(2171),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_LT_GT] = ACTIONS(2171),
  },
  [220] = {
    [ts_builtin_sym_end] = ACTIONS(2177),
    [anon_sym_SEMI] = ACTIONS(2177),
    [sym_keyword_from] = ACTIONS(2177),
    [sym_keyword_on] = ACTIONS(2177),
    [sym_keyword_where] = ACTIONS(2177),
    [sym_keyword_desc] = ACTIONS(2177),
    [sym_keyword_asc] = ACTIONS(2177),
    [sym_keyword_limit] = ACTIONS(2177),
    [sym_keyword_primary] = ACTIONS(2177),
    [sym_keyword_create] = ACTIONS(2177),
    [sym_keyword_as] = ACTIONS(2179),
    [sym_keyword_constraint] = ACTIONS(2177),
    [sym_keyword_separator] = ACTIONS(2177),
    [sym_keyword_when] = ACTIONS(2177),
    [sym_keyword_then] = ACTIONS(2177),
    [sym_keyword_else] = ACTIONS(2177),
    [sym_keyword_end] = ACTIONS(2177),
    [sym_keyword_in] = ACTIONS(2177),
    [sym_keyword_and] = ACTIONS(2177),
    [sym_keyword_or] = ACTIONS(2177),
    [sym_keyword_is] = ACTIONS(2177),
    [sym_keyword_not] = ACTIONS(2177),
    [sym_keyword_using] = ACTIONS(2177),
    [sym_keyword_auto_increment] = ACTIONS(2177),
    [sym_keyword_generated] = ACTIONS(2177),
    [sym_keyword_default] = ACTIONS(2177),
    [sym_keyword_returning] = ACTIONS(2177),
    [sym_keyword_first] = ACTIONS(2177),
    [sym_keyword_after] = ACTIONS(2177),
    [sym_keyword_range] = ACTIONS(2177),
    [sym_keyword_rows] = ACTIONS(2177),
    [sym_keyword_groups] = ACTIONS(2177),
    [sym_keyword_between] = ACTIONS(2177),
    [sym_keyword_preceding] = ACTIONS(2177),
    [sym_keyword_following] = ACTIONS(2177),
    [sym_keyword_unique] = ACTIONS(2177),
    [sym_keyword_references] = ACTIONS(2177),
    [aux_sym_keyword_like_token1] = ACTIONS(2177),
    [aux_sym_keyword_like_token2] = ACTIONS(2177),
    [sym_keyword_similar] = ACTIONS(2177),
    [sym_keyword_check] = ACTIONS(2177),
    [sym_keyword_stored] = ACTIONS(2177),
    [sym_keyword_virtual] = ACTIONS(2177),
    [sym_keyword_comment] = ACTIONS(2177),
    [sym_keyword_null] = ACTIONS(2177),
    [sym_keyword_array] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(2177),
    [anon_sym_RBRACK] = ACTIONS(2177),
    [anon_sym_RPAREN] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2177),
    [anon_sym_STAR] = ACTIONS(2177),
    [anon_sym_COLON_COLON] = ACTIONS(2177),
    [anon_sym_LT] = ACTIONS(2179),
    [anon_sym_GT] = ACTIONS(2179),
    [anon_sym_LT_EQ] = ACTIONS(2177),
    [anon_sym_GT_EQ] = ACTIONS(2177),
    [anon_sym_COLON] = ACTIONS(2179),
    [sym_op_other] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2177),
    [anon_sym_DASH] = ACTIONS(2179),
    [anon_sym_SLASH] = ACTIONS(2179),
    [anon_sym_PERCENT] = ACTIONS(2177),
    [anon_sym_CARET] = ACTIONS(2179),
    [anon_sym_BANG_EQ] = ACTIONS(2177),
    [anon_sym_LT_GT] = ACTIONS(2177),
  },
  [221] = {
    [ts_builtin_sym_end] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2181),
    [sym_keyword_from] = ACTIONS(2181),
    [sym_keyword_on] = ACTIONS(2181),
    [sym_keyword_where] = ACTIONS(2181),
    [sym_keyword_desc] = ACTIONS(2181),
    [sym_keyword_asc] = ACTIONS(2181),
    [sym_keyword_limit] = ACTIONS(2181),
    [sym_keyword_primary] = ACTIONS(2181),
    [sym_keyword_create] = ACTIONS(2181),
    [sym_keyword_as] = ACTIONS(2183),
    [sym_keyword_constraint] = ACTIONS(2181),
    [sym_keyword_separator] = ACTIONS(2181),
    [sym_keyword_when] = ACTIONS(2181),
    [sym_keyword_then] = ACTIONS(2181),
    [sym_keyword_else] = ACTIONS(2181),
    [sym_keyword_end] = ACTIONS(2181),
    [sym_keyword_in] = ACTIONS(2181),
    [sym_keyword_and] = ACTIONS(2181),
    [sym_keyword_or] = ACTIONS(2181),
    [sym_keyword_is] = ACTIONS(2181),
    [sym_keyword_not] = ACTIONS(2181),
    [sym_keyword_using] = ACTIONS(2181),
    [sym_keyword_auto_increment] = ACTIONS(2181),
    [sym_keyword_generated] = ACTIONS(2181),
    [sym_keyword_default] = ACTIONS(2181),
    [sym_keyword_returning] = ACTIONS(2181),
    [sym_keyword_first] = ACTIONS(2181),
    [sym_keyword_after] = ACTIONS(2181),
    [sym_keyword_range] = ACTIONS(2181),
    [sym_keyword_rows] = ACTIONS(2181),
    [sym_keyword_groups] = ACTIONS(2181),
    [sym_keyword_between] = ACTIONS(2181),
    [sym_keyword_preceding] = ACTIONS(2181),
    [sym_keyword_following] = ACTIONS(2181),
    [sym_keyword_unique] = ACTIONS(2181),
    [sym_keyword_references] = ACTIONS(2181),
    [aux_sym_keyword_like_token1] = ACTIONS(2181),
    [aux_sym_keyword_like_token2] = ACTIONS(2181),
    [sym_keyword_similar] = ACTIONS(2181),
    [sym_keyword_check] = ACTIONS(2181),
    [sym_keyword_stored] = ACTIONS(2181),
    [sym_keyword_virtual] = ACTIONS(2181),
    [sym_keyword_comment] = ACTIONS(2181),
    [sym_keyword_null] = ACTIONS(2181),
    [sym_keyword_array] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_COMMA] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2183),
    [sym_op_other] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2181),
    [anon_sym_LT_GT] = ACTIONS(2181),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2051),
    [sym_keyword_from] = ACTIONS(2051),
    [sym_keyword_on] = ACTIONS(2051),
    [sym_keyword_where] = ACTIONS(2051),
    [sym_keyword_desc] = ACTIONS(2051),
    [sym_keyword_asc] = ACTIONS(2051),
    [sym_keyword_limit] = ACTIONS(2051),
    [sym_keyword_primary] = ACTIONS(2051),
    [sym_keyword_create] = ACTIONS(2051),
    [sym_keyword_as] = ACTIONS(2053),
    [sym_keyword_constraint] = ACTIONS(2051),
    [sym_keyword_separator] = ACTIONS(2051),
    [sym_keyword_when] = ACTIONS(2051),
    [sym_keyword_then] = ACTIONS(2051),
    [sym_keyword_else] = ACTIONS(2051),
    [sym_keyword_end] = ACTIONS(2051),
    [sym_keyword_in] = ACTIONS(2051),
    [sym_keyword_and] = ACTIONS(2051),
    [sym_keyword_or] = ACTIONS(2051),
    [sym_keyword_is] = ACTIONS(2051),
    [sym_keyword_not] = ACTIONS(2051),
    [sym_keyword_using] = ACTIONS(2051),
    [sym_keyword_auto_increment] = ACTIONS(2051),
    [sym_keyword_generated] = ACTIONS(2051),
    [sym_keyword_default] = ACTIONS(2051),
    [sym_keyword_returning] = ACTIONS(2051),
    [sym_keyword_first] = ACTIONS(2051),
    [sym_keyword_after] = ACTIONS(2051),
    [sym_keyword_range] = ACTIONS(2051),
    [sym_keyword_rows] = ACTIONS(2051),
    [sym_keyword_groups] = ACTIONS(2051),
    [sym_keyword_between] = ACTIONS(2051),
    [sym_keyword_preceding] = ACTIONS(2051),
    [sym_keyword_following] = ACTIONS(2051),
    [sym_keyword_unique] = ACTIONS(2051),
    [sym_keyword_references] = ACTIONS(2051),
    [aux_sym_keyword_like_token1] = ACTIONS(2051),
    [aux_sym_keyword_like_token2] = ACTIONS(2051),
    [sym_keyword_similar] = ACTIONS(2051),
    [sym_keyword_check] = ACTIONS(2051),
    [sym_keyword_stored] = ACTIONS(2051),
    [sym_keyword_virtual] = ACTIONS(2051),
    [sym_keyword_comment] = ACTIONS(2051),
    [sym_keyword_null] = ACTIONS(2051),
    [sym_keyword_array] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2051),
    [anon_sym_GT_EQ] = ACTIONS(2051),
    [anon_sym_COLON] = ACTIONS(2053),
    [sym_op_other] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2051),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_BANG_EQ] = ACTIONS(2051),
    [anon_sym_LT_GT] = ACTIONS(2051),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(2185),
    [anon_sym_SEMI] = ACTIONS(2185),
    [sym_keyword_from] = ACTIONS(2185),
    [sym_keyword_on] = ACTIONS(2185),
    [sym_keyword_where] = ACTIONS(2185),
    [sym_keyword_desc] = ACTIONS(2185),
    [sym_keyword_asc] = ACTIONS(2185),
    [sym_keyword_limit] = ACTIONS(2185),
    [sym_keyword_primary] = ACTIONS(2185),
    [sym_keyword_create] = ACTIONS(2185),
    [sym_keyword_as] = ACTIONS(2187),
    [sym_keyword_constraint] = ACTIONS(2185),
    [sym_keyword_separator] = ACTIONS(2185),
    [sym_keyword_when] = ACTIONS(2185),
    [sym_keyword_then] = ACTIONS(2185),
    [sym_keyword_else] = ACTIONS(2185),
    [sym_keyword_end] = ACTIONS(2185),
    [sym_keyword_in] = ACTIONS(2185),
    [sym_keyword_and] = ACTIONS(2185),
    [sym_keyword_or] = ACTIONS(2185),
    [sym_keyword_is] = ACTIONS(2185),
    [sym_keyword_not] = ACTIONS(2185),
    [sym_keyword_using] = ACTIONS(2185),
    [sym_keyword_auto_increment] = ACTIONS(2185),
    [sym_keyword_generated] = ACTIONS(2185),
    [sym_keyword_default] = ACTIONS(2185),
    [sym_keyword_returning] = ACTIONS(2185),
    [sym_keyword_first] = ACTIONS(2185),
    [sym_keyword_after] = ACTIONS(2185),
    [sym_keyword_range] = ACTIONS(2185),
    [sym_keyword_rows] = ACTIONS(2185),
    [sym_keyword_groups] = ACTIONS(2185),
    [sym_keyword_between] = ACTIONS(2185),
    [sym_keyword_preceding] = ACTIONS(2185),
    [sym_keyword_following] = ACTIONS(2185),
    [sym_keyword_unique] = ACTIONS(2185),
    [sym_keyword_references] = ACTIONS(2185),
    [aux_sym_keyword_like_token1] = ACTIONS(2185),
    [aux_sym_keyword_like_token2] = ACTIONS(2185),
    [sym_keyword_similar] = ACTIONS(2185),
    [sym_keyword_check] = ACTIONS(2185),
    [sym_keyword_stored] = ACTIONS(2185),
    [sym_keyword_virtual] = ACTIONS(2185),
    [sym_keyword_comment] = ACTIONS(2185),
    [sym_keyword_null] = ACTIONS(2185),
    [sym_keyword_array] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_RBRACK] = ACTIONS(2185),
    [anon_sym_RPAREN] = ACTIONS(2185),
    [anon_sym_COMMA] = ACTIONS(2185),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2185),
    [anon_sym_STAR] = ACTIONS(2185),
    [anon_sym_COLON_COLON] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2185),
    [anon_sym_GT_EQ] = ACTIONS(2185),
    [anon_sym_COLON] = ACTIONS(2187),
    [sym_op_other] = ACTIONS(2185),
    [anon_sym_PLUS] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2185),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2185),
    [anon_sym_LT_GT] = ACTIONS(2185),
  },
  [224] = {
    [ts_builtin_sym_end] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [sym_keyword_from] = ACTIONS(2189),
    [sym_keyword_on] = ACTIONS(2189),
    [sym_keyword_where] = ACTIONS(2189),
    [sym_keyword_desc] = ACTIONS(2189),
    [sym_keyword_asc] = ACTIONS(2189),
    [sym_keyword_limit] = ACTIONS(2189),
    [sym_keyword_primary] = ACTIONS(2189),
    [sym_keyword_create] = ACTIONS(2189),
    [sym_keyword_as] = ACTIONS(2191),
    [sym_keyword_constraint] = ACTIONS(2189),
    [sym_keyword_separator] = ACTIONS(2189),
    [sym_keyword_when] = ACTIONS(2189),
    [sym_keyword_then] = ACTIONS(2189),
    [sym_keyword_else] = ACTIONS(2189),
    [sym_keyword_end] = ACTIONS(2189),
    [sym_keyword_in] = ACTIONS(2189),
    [sym_keyword_and] = ACTIONS(2189),
    [sym_keyword_or] = ACTIONS(2189),
    [sym_keyword_is] = ACTIONS(2189),
    [sym_keyword_not] = ACTIONS(2189),
    [sym_keyword_using] = ACTIONS(2189),
    [sym_keyword_auto_increment] = ACTIONS(2189),
    [sym_keyword_generated] = ACTIONS(2189),
    [sym_keyword_default] = ACTIONS(2189),
    [sym_keyword_returning] = ACTIONS(2189),
    [sym_keyword_first] = ACTIONS(2189),
    [sym_keyword_after] = ACTIONS(2189),
    [sym_keyword_range] = ACTIONS(2189),
    [sym_keyword_rows] = ACTIONS(2189),
    [sym_keyword_groups] = ACTIONS(2189),
    [sym_keyword_between] = ACTIONS(2189),
    [sym_keyword_preceding] = ACTIONS(2189),
    [sym_keyword_following] = ACTIONS(2189),
    [sym_keyword_unique] = ACTIONS(2189),
    [sym_keyword_references] = ACTIONS(2189),
    [aux_sym_keyword_like_token1] = ACTIONS(2189),
    [aux_sym_keyword_like_token2] = ACTIONS(2189),
    [sym_keyword_similar] = ACTIONS(2189),
    [sym_keyword_check] = ACTIONS(2189),
    [sym_keyword_stored] = ACTIONS(2189),
    [sym_keyword_virtual] = ACTIONS(2189),
    [sym_keyword_comment] = ACTIONS(2189),
    [sym_keyword_null] = ACTIONS(2189),
    [sym_keyword_array] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_RBRACK] = ACTIONS(2189),
    [anon_sym_RPAREN] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2189),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2191),
    [anon_sym_GT] = ACTIONS(2191),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2189),
    [anon_sym_COLON] = ACTIONS(2191),
    [sym_op_other] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2191),
    [anon_sym_PERCENT] = ACTIONS(2189),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2189),
    [anon_sym_LT_GT] = ACTIONS(2189),
  },
  [225] = {
    [ts_builtin_sym_end] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2193),
    [sym_keyword_from] = ACTIONS(2193),
    [sym_keyword_on] = ACTIONS(2193),
    [sym_keyword_where] = ACTIONS(2193),
    [sym_keyword_desc] = ACTIONS(2193),
    [sym_keyword_asc] = ACTIONS(2193),
    [sym_keyword_limit] = ACTIONS(2193),
    [sym_keyword_primary] = ACTIONS(2193),
    [sym_keyword_create] = ACTIONS(2193),
    [sym_keyword_as] = ACTIONS(2195),
    [sym_keyword_constraint] = ACTIONS(2193),
    [sym_keyword_separator] = ACTIONS(2193),
    [sym_keyword_when] = ACTIONS(2193),
    [sym_keyword_then] = ACTIONS(2193),
    [sym_keyword_else] = ACTIONS(2193),
    [sym_keyword_end] = ACTIONS(2193),
    [sym_keyword_in] = ACTIONS(2193),
    [sym_keyword_and] = ACTIONS(2193),
    [sym_keyword_or] = ACTIONS(2193),
    [sym_keyword_is] = ACTIONS(2193),
    [sym_keyword_not] = ACTIONS(2193),
    [sym_keyword_using] = ACTIONS(2193),
    [sym_keyword_auto_increment] = ACTIONS(2193),
    [sym_keyword_generated] = ACTIONS(2193),
    [sym_keyword_default] = ACTIONS(2193),
    [sym_keyword_returning] = ACTIONS(2193),
    [sym_keyword_first] = ACTIONS(2193),
    [sym_keyword_after] = ACTIONS(2193),
    [sym_keyword_range] = ACTIONS(2193),
    [sym_keyword_rows] = ACTIONS(2193),
    [sym_keyword_groups] = ACTIONS(2193),
    [sym_keyword_between] = ACTIONS(2193),
    [sym_keyword_preceding] = ACTIONS(2193),
    [sym_keyword_following] = ACTIONS(2193),
    [sym_keyword_unique] = ACTIONS(2193),
    [sym_keyword_references] = ACTIONS(2193),
    [aux_sym_keyword_like_token1] = ACTIONS(2193),
    [aux_sym_keyword_like_token2] = ACTIONS(2193),
    [sym_keyword_similar] = ACTIONS(2193),
    [sym_keyword_check] = ACTIONS(2193),
    [sym_keyword_stored] = ACTIONS(2193),
    [sym_keyword_virtual] = ACTIONS(2193),
    [sym_keyword_comment] = ACTIONS(2193),
    [sym_keyword_null] = ACTIONS(2193),
    [sym_keyword_array] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_RBRACK] = ACTIONS(2193),
    [anon_sym_RPAREN] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2195),
    [anon_sym_GT] = ACTIONS(2195),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2193),
    [anon_sym_COLON] = ACTIONS(2195),
    [sym_op_other] = ACTIONS(2193),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_SLASH] = ACTIONS(2195),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_BANG_EQ] = ACTIONS(2193),
    [anon_sym_LT_GT] = ACTIONS(2193),
  },
  [226] = {
    [ts_builtin_sym_end] = ACTIONS(2065),
    [anon_sym_SEMI] = ACTIONS(2065),
    [sym_keyword_from] = ACTIONS(2065),
    [sym_keyword_on] = ACTIONS(2065),
    [sym_keyword_where] = ACTIONS(2065),
    [sym_keyword_desc] = ACTIONS(2065),
    [sym_keyword_asc] = ACTIONS(2065),
    [sym_keyword_limit] = ACTIONS(2065),
    [sym_keyword_primary] = ACTIONS(2065),
    [sym_keyword_create] = ACTIONS(2065),
    [sym_keyword_as] = ACTIONS(2067),
    [sym_keyword_constraint] = ACTIONS(2065),
    [sym_keyword_separator] = ACTIONS(2065),
    [sym_keyword_when] = ACTIONS(2065),
    [sym_keyword_then] = ACTIONS(2065),
    [sym_keyword_else] = ACTIONS(2065),
    [sym_keyword_end] = ACTIONS(2065),
    [sym_keyword_in] = ACTIONS(2065),
    [sym_keyword_and] = ACTIONS(2065),
    [sym_keyword_or] = ACTIONS(2065),
    [sym_keyword_is] = ACTIONS(2065),
    [sym_keyword_not] = ACTIONS(2065),
    [sym_keyword_using] = ACTIONS(2065),
    [sym_keyword_auto_increment] = ACTIONS(2065),
    [sym_keyword_generated] = ACTIONS(2065),
    [sym_keyword_default] = ACTIONS(2065),
    [sym_keyword_returning] = ACTIONS(2065),
    [sym_keyword_first] = ACTIONS(2065),
    [sym_keyword_after] = ACTIONS(2065),
    [sym_keyword_range] = ACTIONS(2065),
    [sym_keyword_rows] = ACTIONS(2065),
    [sym_keyword_groups] = ACTIONS(2065),
    [sym_keyword_between] = ACTIONS(2065),
    [sym_keyword_preceding] = ACTIONS(2065),
    [sym_keyword_following] = ACTIONS(2065),
    [sym_keyword_unique] = ACTIONS(2065),
    [sym_keyword_references] = ACTIONS(2065),
    [aux_sym_keyword_like_token1] = ACTIONS(2065),
    [aux_sym_keyword_like_token2] = ACTIONS(2065),
    [sym_keyword_similar] = ACTIONS(2065),
    [sym_keyword_check] = ACTIONS(2065),
    [sym_keyword_stored] = ACTIONS(2065),
    [sym_keyword_virtual] = ACTIONS(2065),
    [sym_keyword_comment] = ACTIONS(2065),
    [sym_keyword_null] = ACTIONS(2065),
    [sym_keyword_array] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_COMMA] = ACTIONS(2065),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_STAR] = ACTIONS(2065),
    [anon_sym_COLON_COLON] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2067),
    [sym_op_other] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2065),
    [anon_sym_LT_GT] = ACTIONS(2065),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [sym_keyword_from] = ACTIONS(2145),
    [sym_keyword_on] = ACTIONS(2145),
    [sym_keyword_where] = ACTIONS(2145),
    [sym_keyword_desc] = ACTIONS(2145),
    [sym_keyword_asc] = ACTIONS(2145),
    [sym_keyword_limit] = ACTIONS(2145),
    [sym_keyword_primary] = ACTIONS(2145),
    [sym_keyword_create] = ACTIONS(2145),
    [sym_keyword_as] = ACTIONS(2147),
    [sym_keyword_constraint] = ACTIONS(2145),
    [sym_keyword_separator] = ACTIONS(2145),
    [sym_keyword_when] = ACTIONS(2145),
    [sym_keyword_then] = ACTIONS(2145),
    [sym_keyword_else] = ACTIONS(2145),
    [sym_keyword_end] = ACTIONS(2145),
    [sym_keyword_in] = ACTIONS(2145),
    [sym_keyword_and] = ACTIONS(2145),
    [sym_keyword_or] = ACTIONS(2145),
    [sym_keyword_is] = ACTIONS(2145),
    [sym_keyword_not] = ACTIONS(2145),
    [sym_keyword_using] = ACTIONS(2145),
    [sym_keyword_auto_increment] = ACTIONS(2145),
    [sym_keyword_generated] = ACTIONS(2145),
    [sym_keyword_default] = ACTIONS(2145),
    [sym_keyword_returning] = ACTIONS(2145),
    [sym_keyword_first] = ACTIONS(2145),
    [sym_keyword_after] = ACTIONS(2145),
    [sym_keyword_range] = ACTIONS(2145),
    [sym_keyword_rows] = ACTIONS(2145),
    [sym_keyword_groups] = ACTIONS(2145),
    [sym_keyword_between] = ACTIONS(2145),
    [sym_keyword_preceding] = ACTIONS(2145),
    [sym_keyword_following] = ACTIONS(2145),
    [sym_keyword_unique] = ACTIONS(2145),
    [sym_keyword_references] = ACTIONS(2145),
    [aux_sym_keyword_like_token1] = ACTIONS(2145),
    [aux_sym_keyword_like_token2] = ACTIONS(2145),
    [sym_keyword_similar] = ACTIONS(2145),
    [sym_keyword_check] = ACTIONS(2145),
    [sym_keyword_stored] = ACTIONS(2145),
    [sym_keyword_virtual] = ACTIONS(2145),
    [sym_keyword_comment] = ACTIONS(2145),
    [sym_keyword_null] = ACTIONS(2145),
    [sym_keyword_array] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_COLON] = ACTIONS(2147),
    [sym_op_other] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_LT_GT] = ACTIONS(2145),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1924),
    [sym_keyword_from] = ACTIONS(1924),
    [sym_keyword_on] = ACTIONS(1924),
    [sym_keyword_where] = ACTIONS(1924),
    [sym_keyword_desc] = ACTIONS(1924),
    [sym_keyword_asc] = ACTIONS(1924),
    [sym_keyword_limit] = ACTIONS(1924),
    [sym_keyword_primary] = ACTIONS(1924),
    [sym_keyword_create] = ACTIONS(1924),
    [sym_keyword_as] = ACTIONS(1926),
    [sym_keyword_constraint] = ACTIONS(1924),
    [sym_keyword_separator] = ACTIONS(1924),
    [sym_keyword_when] = ACTIONS(1924),
    [sym_keyword_then] = ACTIONS(1924),
    [sym_keyword_else] = ACTIONS(1924),
    [sym_keyword_end] = ACTIONS(1924),
    [sym_keyword_in] = ACTIONS(1924),
    [sym_keyword_and] = ACTIONS(1924),
    [sym_keyword_or] = ACTIONS(1924),
    [sym_keyword_is] = ACTIONS(1924),
    [sym_keyword_not] = ACTIONS(1924),
    [sym_keyword_using] = ACTIONS(1924),
    [sym_keyword_auto_increment] = ACTIONS(1924),
    [sym_keyword_generated] = ACTIONS(1924),
    [sym_keyword_default] = ACTIONS(1924),
    [sym_keyword_returning] = ACTIONS(1924),
    [sym_keyword_first] = ACTIONS(1924),
    [sym_keyword_after] = ACTIONS(1924),
    [sym_keyword_range] = ACTIONS(1924),
    [sym_keyword_rows] = ACTIONS(1924),
    [sym_keyword_groups] = ACTIONS(1924),
    [sym_keyword_between] = ACTIONS(1924),
    [sym_keyword_preceding] = ACTIONS(1924),
    [sym_keyword_following] = ACTIONS(1924),
    [sym_keyword_unique] = ACTIONS(1924),
    [sym_keyword_references] = ACTIONS(1924),
    [aux_sym_keyword_like_token1] = ACTIONS(1924),
    [aux_sym_keyword_like_token2] = ACTIONS(1924),
    [sym_keyword_similar] = ACTIONS(1924),
    [sym_keyword_check] = ACTIONS(1924),
    [sym_keyword_stored] = ACTIONS(1924),
    [sym_keyword_virtual] = ACTIONS(1924),
    [sym_keyword_comment] = ACTIONS(1924),
    [sym_keyword_null] = ACTIONS(1924),
    [sym_keyword_array] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_RBRACK] = ACTIONS(1924),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_COMMA] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_COLON] = ACTIONS(1926),
    [sym_op_other] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1926),
    [anon_sym_PERCENT] = ACTIONS(1924),
    [anon_sym_CARET] = ACTIONS(1926),
    [anon_sym_BANG_EQ] = ACTIONS(1924),
    [anon_sym_LT_GT] = ACTIONS(1924),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [sym_keyword_from] = ACTIONS(2197),
    [sym_keyword_on] = ACTIONS(2197),
    [sym_keyword_where] = ACTIONS(2197),
    [sym_keyword_desc] = ACTIONS(2197),
    [sym_keyword_asc] = ACTIONS(2197),
    [sym_keyword_limit] = ACTIONS(2197),
    [sym_keyword_primary] = ACTIONS(2197),
    [sym_keyword_create] = ACTIONS(2197),
    [sym_keyword_as] = ACTIONS(2199),
    [sym_keyword_constraint] = ACTIONS(2197),
    [sym_keyword_separator] = ACTIONS(2197),
    [sym_keyword_when] = ACTIONS(2197),
    [sym_keyword_then] = ACTIONS(2197),
    [sym_keyword_else] = ACTIONS(2197),
    [sym_keyword_end] = ACTIONS(2197),
    [sym_keyword_in] = ACTIONS(2197),
    [sym_keyword_and] = ACTIONS(2197),
    [sym_keyword_or] = ACTIONS(2197),
    [sym_keyword_is] = ACTIONS(2197),
    [sym_keyword_not] = ACTIONS(2197),
    [sym_keyword_using] = ACTIONS(2197),
    [sym_keyword_auto_increment] = ACTIONS(2197),
    [sym_keyword_generated] = ACTIONS(2197),
    [sym_keyword_default] = ACTIONS(2197),
    [sym_keyword_returning] = ACTIONS(2197),
    [sym_keyword_first] = ACTIONS(2197),
    [sym_keyword_after] = ACTIONS(2197),
    [sym_keyword_range] = ACTIONS(2197),
    [sym_keyword_rows] = ACTIONS(2197),
    [sym_keyword_groups] = ACTIONS(2197),
    [sym_keyword_between] = ACTIONS(2197),
    [sym_keyword_preceding] = ACTIONS(2197),
    [sym_keyword_following] = ACTIONS(2197),
    [sym_keyword_unique] = ACTIONS(2197),
    [sym_keyword_references] = ACTIONS(2197),
    [aux_sym_keyword_like_token1] = ACTIONS(2197),
    [aux_sym_keyword_like_token2] = ACTIONS(2197),
    [sym_keyword_similar] = ACTIONS(2197),
    [sym_keyword_check] = ACTIONS(2197),
    [sym_keyword_stored] = ACTIONS(2197),
    [sym_keyword_virtual] = ACTIONS(2197),
    [sym_keyword_comment] = ACTIONS(2197),
    [sym_keyword_null] = ACTIONS(2197),
    [sym_keyword_array] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_RBRACK] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2197),
    [anon_sym_COLON] = ACTIONS(2199),
    [sym_op_other] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2197),
    [anon_sym_LT_GT] = ACTIONS(2197),
  },
  [230] = {
    [ts_builtin_sym_end] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2201),
    [sym_keyword_from] = ACTIONS(2201),
    [sym_keyword_on] = ACTIONS(2201),
    [sym_keyword_where] = ACTIONS(2201),
    [sym_keyword_desc] = ACTIONS(2201),
    [sym_keyword_asc] = ACTIONS(2201),
    [sym_keyword_limit] = ACTIONS(2201),
    [sym_keyword_primary] = ACTIONS(2201),
    [sym_keyword_create] = ACTIONS(2201),
    [sym_keyword_as] = ACTIONS(2203),
    [sym_keyword_constraint] = ACTIONS(2201),
    [sym_keyword_separator] = ACTIONS(2201),
    [sym_keyword_when] = ACTIONS(2201),
    [sym_keyword_then] = ACTIONS(2201),
    [sym_keyword_else] = ACTIONS(2201),
    [sym_keyword_end] = ACTIONS(2201),
    [sym_keyword_in] = ACTIONS(2201),
    [sym_keyword_and] = ACTIONS(2201),
    [sym_keyword_or] = ACTIONS(2201),
    [sym_keyword_is] = ACTIONS(2201),
    [sym_keyword_not] = ACTIONS(2201),
    [sym_keyword_using] = ACTIONS(2201),
    [sym_keyword_auto_increment] = ACTIONS(2201),
    [sym_keyword_generated] = ACTIONS(2201),
    [sym_keyword_default] = ACTIONS(2201),
    [sym_keyword_returning] = ACTIONS(2201),
    [sym_keyword_first] = ACTIONS(2201),
    [sym_keyword_after] = ACTIONS(2201),
    [sym_keyword_range] = ACTIONS(2201),
    [sym_keyword_rows] = ACTIONS(2201),
    [sym_keyword_groups] = ACTIONS(2201),
    [sym_keyword_between] = ACTIONS(2201),
    [sym_keyword_preceding] = ACTIONS(2201),
    [sym_keyword_following] = ACTIONS(2201),
    [sym_keyword_unique] = ACTIONS(2201),
    [sym_keyword_references] = ACTIONS(2201),
    [aux_sym_keyword_like_token1] = ACTIONS(2201),
    [aux_sym_keyword_like_token2] = ACTIONS(2201),
    [sym_keyword_similar] = ACTIONS(2201),
    [sym_keyword_check] = ACTIONS(2201),
    [sym_keyword_stored] = ACTIONS(2201),
    [sym_keyword_virtual] = ACTIONS(2201),
    [sym_keyword_comment] = ACTIONS(2201),
    [sym_keyword_null] = ACTIONS(2201),
    [sym_keyword_array] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_RBRACK] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(2201),
    [anon_sym_COMMA] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(2203),
    [anon_sym_LT_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2201),
    [anon_sym_COLON] = ACTIONS(2203),
    [sym_op_other] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(2203),
    [anon_sym_PERCENT] = ACTIONS(2201),
    [anon_sym_CARET] = ACTIONS(2203),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_LT_GT] = ACTIONS(2201),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_keyword_from] = ACTIONS(2205),
    [sym_keyword_on] = ACTIONS(2205),
    [sym_keyword_where] = ACTIONS(2205),
    [sym_keyword_desc] = ACTIONS(2205),
    [sym_keyword_asc] = ACTIONS(2205),
    [sym_keyword_limit] = ACTIONS(2205),
    [sym_keyword_primary] = ACTIONS(2205),
    [sym_keyword_create] = ACTIONS(2205),
    [sym_keyword_as] = ACTIONS(2207),
    [sym_keyword_constraint] = ACTIONS(2205),
    [sym_keyword_separator] = ACTIONS(2205),
    [sym_keyword_when] = ACTIONS(2205),
    [sym_keyword_then] = ACTIONS(2205),
    [sym_keyword_else] = ACTIONS(2205),
    [sym_keyword_end] = ACTIONS(2205),
    [sym_keyword_in] = ACTIONS(2205),
    [sym_keyword_and] = ACTIONS(2205),
    [sym_keyword_or] = ACTIONS(2205),
    [sym_keyword_is] = ACTIONS(2205),
    [sym_keyword_not] = ACTIONS(2205),
    [sym_keyword_using] = ACTIONS(2205),
    [sym_keyword_auto_increment] = ACTIONS(2205),
    [sym_keyword_generated] = ACTIONS(2205),
    [sym_keyword_default] = ACTIONS(2205),
    [sym_keyword_returning] = ACTIONS(2205),
    [sym_keyword_first] = ACTIONS(2205),
    [sym_keyword_after] = ACTIONS(2205),
    [sym_keyword_range] = ACTIONS(2205),
    [sym_keyword_rows] = ACTIONS(2205),
    [sym_keyword_groups] = ACTIONS(2205),
    [sym_keyword_between] = ACTIONS(2205),
    [sym_keyword_preceding] = ACTIONS(2205),
    [sym_keyword_following] = ACTIONS(2205),
    [sym_keyword_unique] = ACTIONS(2205),
    [sym_keyword_references] = ACTIONS(2205),
    [aux_sym_keyword_like_token1] = ACTIONS(2205),
    [aux_sym_keyword_like_token2] = ACTIONS(2205),
    [sym_keyword_similar] = ACTIONS(2205),
    [sym_keyword_check] = ACTIONS(2205),
    [sym_keyword_stored] = ACTIONS(2205),
    [sym_keyword_virtual] = ACTIONS(2205),
    [sym_keyword_comment] = ACTIONS(2205),
    [sym_keyword_null] = ACTIONS(2205),
    [sym_keyword_array] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_RBRACK] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_COMMA] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [anon_sym_COLON] = ACTIONS(2207),
    [sym_op_other] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_SLASH] = ACTIONS(2207),
    [anon_sym_PERCENT] = ACTIONS(2205),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2205),
    [anon_sym_LT_GT] = ACTIONS(2205),
  },
  [232] = {
    [ts_builtin_sym_end] = ACTIONS(2209),
    [anon_sym_SEMI] = ACTIONS(2209),
    [sym_keyword_from] = ACTIONS(2209),
    [sym_keyword_on] = ACTIONS(2209),
    [sym_keyword_where] = ACTIONS(2209),
    [sym_keyword_desc] = ACTIONS(2209),
    [sym_keyword_asc] = ACTIONS(2209),
    [sym_keyword_limit] = ACTIONS(2209),
    [sym_keyword_primary] = ACTIONS(2209),
    [sym_keyword_create] = ACTIONS(2209),
    [sym_keyword_as] = ACTIONS(2211),
    [sym_keyword_constraint] = ACTIONS(2209),
    [sym_keyword_separator] = ACTIONS(2209),
    [sym_keyword_when] = ACTIONS(2209),
    [sym_keyword_then] = ACTIONS(2209),
    [sym_keyword_else] = ACTIONS(2209),
    [sym_keyword_end] = ACTIONS(2209),
    [sym_keyword_in] = ACTIONS(2209),
    [sym_keyword_and] = ACTIONS(2209),
    [sym_keyword_or] = ACTIONS(2209),
    [sym_keyword_is] = ACTIONS(2209),
    [sym_keyword_not] = ACTIONS(2209),
    [sym_keyword_using] = ACTIONS(2209),
    [sym_keyword_auto_increment] = ACTIONS(2209),
    [sym_keyword_generated] = ACTIONS(2209),
    [sym_keyword_default] = ACTIONS(2209),
    [sym_keyword_returning] = ACTIONS(2209),
    [sym_keyword_first] = ACTIONS(2209),
    [sym_keyword_after] = ACTIONS(2209),
    [sym_keyword_range] = ACTIONS(2209),
    [sym_keyword_rows] = ACTIONS(2209),
    [sym_keyword_groups] = ACTIONS(2209),
    [sym_keyword_between] = ACTIONS(2209),
    [sym_keyword_preceding] = ACTIONS(2209),
    [sym_keyword_following] = ACTIONS(2209),
    [sym_keyword_unique] = ACTIONS(2209),
    [sym_keyword_references] = ACTIONS(2209),
    [aux_sym_keyword_like_token1] = ACTIONS(2209),
    [aux_sym_keyword_like_token2] = ACTIONS(2209),
    [sym_keyword_similar] = ACTIONS(2209),
    [sym_keyword_check] = ACTIONS(2209),
    [sym_keyword_stored] = ACTIONS(2209),
    [sym_keyword_virtual] = ACTIONS(2209),
    [sym_keyword_comment] = ACTIONS(2209),
    [sym_keyword_null] = ACTIONS(2209),
    [sym_keyword_array] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2209),
    [anon_sym_RBRACK] = ACTIONS(2209),
    [anon_sym_RPAREN] = ACTIONS(2209),
    [anon_sym_COMMA] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2209),
    [anon_sym_COLON_COLON] = ACTIONS(2209),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2209),
    [anon_sym_GT_EQ] = ACTIONS(2209),
    [anon_sym_COLON] = ACTIONS(2211),
    [sym_op_other] = ACTIONS(2209),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_SLASH] = ACTIONS(2211),
    [anon_sym_PERCENT] = ACTIONS(2209),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_LT_GT] = ACTIONS(2209),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [anon_sym_SEMI] = ACTIONS(2119),
    [sym_keyword_from] = ACTIONS(2119),
    [sym_keyword_on] = ACTIONS(2119),
    [sym_keyword_where] = ACTIONS(2119),
    [sym_keyword_desc] = ACTIONS(2119),
    [sym_keyword_asc] = ACTIONS(2119),
    [sym_keyword_limit] = ACTIONS(2119),
    [sym_keyword_primary] = ACTIONS(2119),
    [sym_keyword_create] = ACTIONS(2119),
    [sym_keyword_as] = ACTIONS(2121),
    [sym_keyword_constraint] = ACTIONS(2119),
    [sym_keyword_separator] = ACTIONS(2119),
    [sym_keyword_when] = ACTIONS(2119),
    [sym_keyword_then] = ACTIONS(2119),
    [sym_keyword_else] = ACTIONS(2119),
    [sym_keyword_end] = ACTIONS(2119),
    [sym_keyword_in] = ACTIONS(2119),
    [sym_keyword_and] = ACTIONS(2119),
    [sym_keyword_or] = ACTIONS(2119),
    [sym_keyword_is] = ACTIONS(2119),
    [sym_keyword_not] = ACTIONS(2119),
    [sym_keyword_using] = ACTIONS(2119),
    [sym_keyword_auto_increment] = ACTIONS(2119),
    [sym_keyword_generated] = ACTIONS(2119),
    [sym_keyword_default] = ACTIONS(2119),
    [sym_keyword_returning] = ACTIONS(2119),
    [sym_keyword_first] = ACTIONS(2119),
    [sym_keyword_after] = ACTIONS(2119),
    [sym_keyword_range] = ACTIONS(2119),
    [sym_keyword_rows] = ACTIONS(2119),
    [sym_keyword_groups] = ACTIONS(2119),
    [sym_keyword_between] = ACTIONS(2119),
    [sym_keyword_preceding] = ACTIONS(2119),
    [sym_keyword_following] = ACTIONS(2119),
    [sym_keyword_unique] = ACTIONS(2119),
    [sym_keyword_references] = ACTIONS(2119),
    [aux_sym_keyword_like_token1] = ACTIONS(2119),
    [aux_sym_keyword_like_token2] = ACTIONS(2119),
    [sym_keyword_similar] = ACTIONS(2119),
    [sym_keyword_check] = ACTIONS(2119),
    [sym_keyword_stored] = ACTIONS(2119),
    [sym_keyword_virtual] = ACTIONS(2119),
    [sym_keyword_comment] = ACTIONS(2119),
    [sym_keyword_null] = ACTIONS(2119),
    [sym_keyword_array] = ACTIONS(2119),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_RBRACK] = ACTIONS(2119),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2119),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_COLON_COLON] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_GT] = ACTIONS(2121),
    [anon_sym_LT_EQ] = ACTIONS(2119),
    [anon_sym_GT_EQ] = ACTIONS(2119),
    [anon_sym_COLON] = ACTIONS(2121),
    [sym_op_other] = ACTIONS(2119),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_PERCENT] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2121),
    [anon_sym_BANG_EQ] = ACTIONS(2119),
    [anon_sym_LT_GT] = ACTIONS(2119),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [sym_keyword_from] = ACTIONS(2213),
    [sym_keyword_on] = ACTIONS(2213),
    [sym_keyword_where] = ACTIONS(2213),
    [sym_keyword_desc] = ACTIONS(2213),
    [sym_keyword_asc] = ACTIONS(2213),
    [sym_keyword_limit] = ACTIONS(2213),
    [sym_keyword_primary] = ACTIONS(2213),
    [sym_keyword_create] = ACTIONS(2213),
    [sym_keyword_as] = ACTIONS(2215),
    [sym_keyword_constraint] = ACTIONS(2213),
    [sym_keyword_separator] = ACTIONS(2213),
    [sym_keyword_when] = ACTIONS(2213),
    [sym_keyword_then] = ACTIONS(2213),
    [sym_keyword_else] = ACTIONS(2213),
    [sym_keyword_end] = ACTIONS(2213),
    [sym_keyword_in] = ACTIONS(2213),
    [sym_keyword_and] = ACTIONS(2213),
    [sym_keyword_or] = ACTIONS(2213),
    [sym_keyword_is] = ACTIONS(2213),
    [sym_keyword_not] = ACTIONS(2213),
    [sym_keyword_using] = ACTIONS(2213),
    [sym_keyword_auto_increment] = ACTIONS(2213),
    [sym_keyword_generated] = ACTIONS(2213),
    [sym_keyword_default] = ACTIONS(2213),
    [sym_keyword_returning] = ACTIONS(2213),
    [sym_keyword_first] = ACTIONS(2213),
    [sym_keyword_after] = ACTIONS(2213),
    [sym_keyword_range] = ACTIONS(2213),
    [sym_keyword_rows] = ACTIONS(2213),
    [sym_keyword_groups] = ACTIONS(2213),
    [sym_keyword_between] = ACTIONS(2213),
    [sym_keyword_preceding] = ACTIONS(2213),
    [sym_keyword_following] = ACTIONS(2213),
    [sym_keyword_unique] = ACTIONS(2213),
    [sym_keyword_references] = ACTIONS(2213),
    [aux_sym_keyword_like_token1] = ACTIONS(2213),
    [aux_sym_keyword_like_token2] = ACTIONS(2213),
    [sym_keyword_similar] = ACTIONS(2213),
    [sym_keyword_check] = ACTIONS(2213),
    [sym_keyword_stored] = ACTIONS(2213),
    [sym_keyword_virtual] = ACTIONS(2213),
    [sym_keyword_comment] = ACTIONS(2213),
    [sym_keyword_null] = ACTIONS(2213),
    [sym_keyword_array] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_RBRACK] = ACTIONS(2213),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_COMMA] = ACTIONS(2213),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_COLON_COLON] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_LT_EQ] = ACTIONS(2213),
    [anon_sym_GT_EQ] = ACTIONS(2213),
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_op_other] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_SLASH] = ACTIONS(2215),
    [anon_sym_PERCENT] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2213),
    [anon_sym_LT_GT] = ACTIONS(2213),
  },
  [235] = {
    [ts_builtin_sym_end] = ACTIONS(2113),
    [anon_sym_SEMI] = ACTIONS(2113),
    [sym_keyword_from] = ACTIONS(2113),
    [sym_keyword_on] = ACTIONS(2113),
    [sym_keyword_where] = ACTIONS(2113),
    [sym_keyword_desc] = ACTIONS(2113),
    [sym_keyword_asc] = ACTIONS(2113),
    [sym_keyword_limit] = ACTIONS(2113),
    [sym_keyword_primary] = ACTIONS(2113),
    [sym_keyword_create] = ACTIONS(2113),
    [sym_keyword_as] = ACTIONS(2115),
    [sym_keyword_constraint] = ACTIONS(2113),
    [sym_keyword_separator] = ACTIONS(2113),
    [sym_keyword_when] = ACTIONS(2113),
    [sym_keyword_then] = ACTIONS(2113),
    [sym_keyword_else] = ACTIONS(2113),
    [sym_keyword_end] = ACTIONS(2113),
    [sym_keyword_in] = ACTIONS(2113),
    [sym_keyword_and] = ACTIONS(2113),
    [sym_keyword_or] = ACTIONS(2113),
    [sym_keyword_is] = ACTIONS(2113),
    [sym_keyword_not] = ACTIONS(2113),
    [sym_keyword_using] = ACTIONS(2113),
    [sym_keyword_auto_increment] = ACTIONS(2113),
    [sym_keyword_generated] = ACTIONS(2113),
    [sym_keyword_default] = ACTIONS(2113),
    [sym_keyword_returning] = ACTIONS(2113),
    [sym_keyword_first] = ACTIONS(2113),
    [sym_keyword_after] = ACTIONS(2113),
    [sym_keyword_range] = ACTIONS(2113),
    [sym_keyword_rows] = ACTIONS(2113),
    [sym_keyword_groups] = ACTIONS(2113),
    [sym_keyword_between] = ACTIONS(2113),
    [sym_keyword_preceding] = ACTIONS(2113),
    [sym_keyword_following] = ACTIONS(2113),
    [sym_keyword_unique] = ACTIONS(2113),
    [sym_keyword_references] = ACTIONS(2113),
    [aux_sym_keyword_like_token1] = ACTIONS(2113),
    [aux_sym_keyword_like_token2] = ACTIONS(2113),
    [sym_keyword_similar] = ACTIONS(2113),
    [sym_keyword_check] = ACTIONS(2113),
    [sym_keyword_stored] = ACTIONS(2113),
    [sym_keyword_virtual] = ACTIONS(2113),
    [sym_keyword_comment] = ACTIONS(2113),
    [sym_keyword_null] = ACTIONS(2113),
    [sym_keyword_array] = ACTIONS(2113),
    [anon_sym_LBRACK] = ACTIONS(2113),
    [anon_sym_RBRACK] = ACTIONS(2113),
    [anon_sym_RPAREN] = ACTIONS(2113),
    [anon_sym_COMMA] = ACTIONS(2113),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(2113),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(2115),
    [anon_sym_GT] = ACTIONS(2115),
    [anon_sym_LT_EQ] = ACTIONS(2113),
    [anon_sym_GT_EQ] = ACTIONS(2113),
    [anon_sym_COLON] = ACTIONS(2115),
    [sym_op_other] = ACTIONS(2113),
    [anon_sym_PLUS] = ACTIONS(2113),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2113),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_BANG_EQ] = ACTIONS(2113),
    [anon_sym_LT_GT] = ACTIONS(2113),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2026),
    [sym_keyword_from] = ACTIONS(2026),
    [sym_keyword_on] = ACTIONS(2026),
    [sym_keyword_where] = ACTIONS(2026),
    [sym_keyword_desc] = ACTIONS(2026),
    [sym_keyword_asc] = ACTIONS(2026),
    [sym_keyword_limit] = ACTIONS(2026),
    [sym_keyword_primary] = ACTIONS(2026),
    [sym_keyword_create] = ACTIONS(2026),
    [sym_keyword_as] = ACTIONS(2028),
    [sym_keyword_constraint] = ACTIONS(2026),
    [sym_keyword_separator] = ACTIONS(2026),
    [sym_keyword_when] = ACTIONS(2026),
    [sym_keyword_then] = ACTIONS(2026),
    [sym_keyword_else] = ACTIONS(2026),
    [sym_keyword_end] = ACTIONS(2026),
    [sym_keyword_in] = ACTIONS(2026),
    [sym_keyword_and] = ACTIONS(2026),
    [sym_keyword_or] = ACTIONS(2026),
    [sym_keyword_is] = ACTIONS(2026),
    [sym_keyword_not] = ACTIONS(2026),
    [sym_keyword_using] = ACTIONS(2026),
    [sym_keyword_auto_increment] = ACTIONS(2026),
    [sym_keyword_generated] = ACTIONS(2026),
    [sym_keyword_default] = ACTIONS(2026),
    [sym_keyword_returning] = ACTIONS(2026),
    [sym_keyword_first] = ACTIONS(2026),
    [sym_keyword_after] = ACTIONS(2026),
    [sym_keyword_range] = ACTIONS(2026),
    [sym_keyword_rows] = ACTIONS(2026),
    [sym_keyword_groups] = ACTIONS(2026),
    [sym_keyword_between] = ACTIONS(2026),
    [sym_keyword_preceding] = ACTIONS(2026),
    [sym_keyword_following] = ACTIONS(2026),
    [sym_keyword_unique] = ACTIONS(2026),
    [sym_keyword_references] = ACTIONS(2026),
    [aux_sym_keyword_like_token1] = ACTIONS(2026),
    [aux_sym_keyword_like_token2] = ACTIONS(2026),
    [sym_keyword_similar] = ACTIONS(2026),
    [sym_keyword_check] = ACTIONS(2026),
    [sym_keyword_stored] = ACTIONS(2026),
    [sym_keyword_virtual] = ACTIONS(2026),
    [sym_keyword_comment] = ACTIONS(2026),
    [sym_keyword_null] = ACTIONS(2026),
    [sym_keyword_array] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [anon_sym_RBRACK] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_COMMA] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_LT_EQ] = ACTIONS(2026),
    [anon_sym_GT_EQ] = ACTIONS(2026),
    [anon_sym_COLON] = ACTIONS(2028),
    [sym_op_other] = ACTIONS(2026),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2028),
    [anon_sym_PERCENT] = ACTIONS(2026),
    [anon_sym_CARET] = ACTIONS(2028),
    [anon_sym_BANG_EQ] = ACTIONS(2026),
    [anon_sym_LT_GT] = ACTIONS(2026),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2217),
    [sym_keyword_from] = ACTIONS(2217),
    [sym_keyword_on] = ACTIONS(2217),
    [sym_keyword_where] = ACTIONS(2217),
    [sym_keyword_desc] = ACTIONS(2217),
    [sym_keyword_asc] = ACTIONS(2217),
    [sym_keyword_limit] = ACTIONS(2217),
    [sym_keyword_primary] = ACTIONS(2217),
    [sym_keyword_create] = ACTIONS(2217),
    [sym_keyword_as] = ACTIONS(2219),
    [sym_keyword_constraint] = ACTIONS(2217),
    [sym_keyword_separator] = ACTIONS(2217),
    [sym_keyword_when] = ACTIONS(2217),
    [sym_keyword_then] = ACTIONS(2217),
    [sym_keyword_else] = ACTIONS(2217),
    [sym_keyword_end] = ACTIONS(2217),
    [sym_keyword_in] = ACTIONS(2217),
    [sym_keyword_and] = ACTIONS(2217),
    [sym_keyword_or] = ACTIONS(2217),
    [sym_keyword_is] = ACTIONS(2217),
    [sym_keyword_not] = ACTIONS(2217),
    [sym_keyword_using] = ACTIONS(2217),
    [sym_keyword_auto_increment] = ACTIONS(2217),
    [sym_keyword_generated] = ACTIONS(2217),
    [sym_keyword_default] = ACTIONS(2217),
    [sym_keyword_returning] = ACTIONS(2217),
    [sym_keyword_first] = ACTIONS(2217),
    [sym_keyword_after] = ACTIONS(2217),
    [sym_keyword_range] = ACTIONS(2217),
    [sym_keyword_rows] = ACTIONS(2217),
    [sym_keyword_groups] = ACTIONS(2217),
    [sym_keyword_between] = ACTIONS(2217),
    [sym_keyword_preceding] = ACTIONS(2217),
    [sym_keyword_following] = ACTIONS(2217),
    [sym_keyword_unique] = ACTIONS(2217),
    [sym_keyword_references] = ACTIONS(2217),
    [aux_sym_keyword_like_token1] = ACTIONS(2217),
    [aux_sym_keyword_like_token2] = ACTIONS(2217),
    [sym_keyword_similar] = ACTIONS(2217),
    [sym_keyword_check] = ACTIONS(2217),
    [sym_keyword_stored] = ACTIONS(2217),
    [sym_keyword_virtual] = ACTIONS(2217),
    [sym_keyword_comment] = ACTIONS(2217),
    [sym_keyword_null] = ACTIONS(2217),
    [sym_keyword_array] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [anon_sym_RBRACK] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2217),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_GT] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2217),
    [anon_sym_GT_EQ] = ACTIONS(2217),
    [anon_sym_COLON] = ACTIONS(2219),
    [sym_op_other] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [anon_sym_PERCENT] = ACTIONS(2217),
    [anon_sym_CARET] = ACTIONS(2219),
    [anon_sym_BANG_EQ] = ACTIONS(2217),
    [anon_sym_LT_GT] = ACTIONS(2217),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [sym_keyword_from] = ACTIONS(2221),
    [sym_keyword_on] = ACTIONS(2221),
    [sym_keyword_where] = ACTIONS(2221),
    [sym_keyword_desc] = ACTIONS(2221),
    [sym_keyword_asc] = ACTIONS(2221),
    [sym_keyword_limit] = ACTIONS(2221),
    [sym_keyword_primary] = ACTIONS(2221),
    [sym_keyword_create] = ACTIONS(2221),
    [sym_keyword_as] = ACTIONS(2223),
    [sym_keyword_constraint] = ACTIONS(2221),
    [sym_keyword_separator] = ACTIONS(2221),
    [sym_keyword_when] = ACTIONS(2221),
    [sym_keyword_then] = ACTIONS(2221),
    [sym_keyword_else] = ACTIONS(2221),
    [sym_keyword_end] = ACTIONS(2221),
    [sym_keyword_in] = ACTIONS(2221),
    [sym_keyword_and] = ACTIONS(2221),
    [sym_keyword_or] = ACTIONS(2221),
    [sym_keyword_is] = ACTIONS(2221),
    [sym_keyword_not] = ACTIONS(2221),
    [sym_keyword_using] = ACTIONS(2221),
    [sym_keyword_auto_increment] = ACTIONS(2221),
    [sym_keyword_generated] = ACTIONS(2221),
    [sym_keyword_default] = ACTIONS(2221),
    [sym_keyword_returning] = ACTIONS(2221),
    [sym_keyword_first] = ACTIONS(2221),
    [sym_keyword_after] = ACTIONS(2221),
    [sym_keyword_range] = ACTIONS(2221),
    [sym_keyword_rows] = ACTIONS(2221),
    [sym_keyword_groups] = ACTIONS(2221),
    [sym_keyword_between] = ACTIONS(2221),
    [sym_keyword_preceding] = ACTIONS(2221),
    [sym_keyword_following] = ACTIONS(2221),
    [sym_keyword_unique] = ACTIONS(2221),
    [sym_keyword_references] = ACTIONS(2221),
    [aux_sym_keyword_like_token1] = ACTIONS(2221),
    [aux_sym_keyword_like_token2] = ACTIONS(2221),
    [sym_keyword_similar] = ACTIONS(2221),
    [sym_keyword_check] = ACTIONS(2221),
    [sym_keyword_stored] = ACTIONS(2221),
    [sym_keyword_virtual] = ACTIONS(2221),
    [sym_keyword_comment] = ACTIONS(2221),
    [sym_keyword_null] = ACTIONS(2221),
    [sym_keyword_array] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_RBRACK] = ACTIONS(2221),
    [anon_sym_RPAREN] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_COLON_COLON] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2223),
    [anon_sym_GT] = ACTIONS(2223),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2221),
    [anon_sym_COLON] = ACTIONS(2223),
    [sym_op_other] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2223),
    [anon_sym_SLASH] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2221),
    [anon_sym_LT_GT] = ACTIONS(2221),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [sym_keyword_from] = ACTIONS(2225),
    [sym_keyword_on] = ACTIONS(2225),
    [sym_keyword_where] = ACTIONS(2225),
    [sym_keyword_desc] = ACTIONS(2225),
    [sym_keyword_asc] = ACTIONS(2225),
    [sym_keyword_limit] = ACTIONS(2225),
    [sym_keyword_primary] = ACTIONS(2225),
    [sym_keyword_create] = ACTIONS(2225),
    [sym_keyword_as] = ACTIONS(2227),
    [sym_keyword_constraint] = ACTIONS(2225),
    [sym_keyword_separator] = ACTIONS(2225),
    [sym_keyword_when] = ACTIONS(2225),
    [sym_keyword_then] = ACTIONS(2225),
    [sym_keyword_else] = ACTIONS(2225),
    [sym_keyword_end] = ACTIONS(2225),
    [sym_keyword_in] = ACTIONS(2225),
    [sym_keyword_and] = ACTIONS(2225),
    [sym_keyword_or] = ACTIONS(2225),
    [sym_keyword_is] = ACTIONS(2225),
    [sym_keyword_not] = ACTIONS(2225),
    [sym_keyword_using] = ACTIONS(2225),
    [sym_keyword_auto_increment] = ACTIONS(2225),
    [sym_keyword_generated] = ACTIONS(2225),
    [sym_keyword_default] = ACTIONS(2225),
    [sym_keyword_returning] = ACTIONS(2225),
    [sym_keyword_first] = ACTIONS(2225),
    [sym_keyword_after] = ACTIONS(2225),
    [sym_keyword_range] = ACTIONS(2225),
    [sym_keyword_rows] = ACTIONS(2225),
    [sym_keyword_groups] = ACTIONS(2225),
    [sym_keyword_between] = ACTIONS(2225),
    [sym_keyword_preceding] = ACTIONS(2225),
    [sym_keyword_following] = ACTIONS(2225),
    [sym_keyword_unique] = ACTIONS(2225),
    [sym_keyword_references] = ACTIONS(2225),
    [aux_sym_keyword_like_token1] = ACTIONS(2225),
    [aux_sym_keyword_like_token2] = ACTIONS(2225),
    [sym_keyword_similar] = ACTIONS(2225),
    [sym_keyword_check] = ACTIONS(2225),
    [sym_keyword_stored] = ACTIONS(2225),
    [sym_keyword_virtual] = ACTIONS(2225),
    [sym_keyword_comment] = ACTIONS(2225),
    [sym_keyword_null] = ACTIONS(2225),
    [sym_keyword_array] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_RBRACK] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_COLON_COLON] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2227),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_LT_EQ] = ACTIONS(2225),
    [anon_sym_GT_EQ] = ACTIONS(2225),
    [anon_sym_COLON] = ACTIONS(2227),
    [sym_op_other] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2227),
    [anon_sym_SLASH] = ACTIONS(2227),
    [anon_sym_PERCENT] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_LT_GT] = ACTIONS(2225),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2229),
    [sym_keyword_from] = ACTIONS(2229),
    [sym_keyword_on] = ACTIONS(2229),
    [sym_keyword_where] = ACTIONS(2229),
    [sym_keyword_desc] = ACTIONS(2229),
    [sym_keyword_asc] = ACTIONS(2229),
    [sym_keyword_limit] = ACTIONS(2229),
    [sym_keyword_primary] = ACTIONS(2229),
    [sym_keyword_create] = ACTIONS(2229),
    [sym_keyword_as] = ACTIONS(2231),
    [sym_keyword_constraint] = ACTIONS(2229),
    [sym_keyword_separator] = ACTIONS(2229),
    [sym_keyword_when] = ACTIONS(2229),
    [sym_keyword_then] = ACTIONS(2229),
    [sym_keyword_else] = ACTIONS(2229),
    [sym_keyword_end] = ACTIONS(2229),
    [sym_keyword_in] = ACTIONS(2229),
    [sym_keyword_and] = ACTIONS(2229),
    [sym_keyword_or] = ACTIONS(2229),
    [sym_keyword_is] = ACTIONS(2229),
    [sym_keyword_not] = ACTIONS(2229),
    [sym_keyword_using] = ACTIONS(2229),
    [sym_keyword_auto_increment] = ACTIONS(2229),
    [sym_keyword_generated] = ACTIONS(2229),
    [sym_keyword_default] = ACTIONS(2229),
    [sym_keyword_returning] = ACTIONS(2229),
    [sym_keyword_first] = ACTIONS(2229),
    [sym_keyword_after] = ACTIONS(2229),
    [sym_keyword_range] = ACTIONS(2229),
    [sym_keyword_rows] = ACTIONS(2229),
    [sym_keyword_groups] = ACTIONS(2229),
    [sym_keyword_between] = ACTIONS(2229),
    [sym_keyword_preceding] = ACTIONS(2229),
    [sym_keyword_following] = ACTIONS(2229),
    [sym_keyword_unique] = ACTIONS(2229),
    [sym_keyword_references] = ACTIONS(2229),
    [aux_sym_keyword_like_token1] = ACTIONS(2229),
    [aux_sym_keyword_like_token2] = ACTIONS(2229),
    [sym_keyword_similar] = ACTIONS(2229),
    [sym_keyword_check] = ACTIONS(2229),
    [sym_keyword_stored] = ACTIONS(2229),
    [sym_keyword_virtual] = ACTIONS(2229),
    [sym_keyword_comment] = ACTIONS(2229),
    [sym_keyword_null] = ACTIONS(2229),
    [sym_keyword_array] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2229),
    [anon_sym_RBRACK] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2231),
    [anon_sym_LT_EQ] = ACTIONS(2229),
    [anon_sym_GT_EQ] = ACTIONS(2229),
    [anon_sym_COLON] = ACTIONS(2231),
    [sym_op_other] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2231),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [anon_sym_CARET] = ACTIONS(2231),
    [anon_sym_BANG_EQ] = ACTIONS(2229),
    [anon_sym_LT_GT] = ACTIONS(2229),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [sym_keyword_from] = ACTIONS(2233),
    [sym_keyword_on] = ACTIONS(2233),
    [sym_keyword_where] = ACTIONS(2233),
    [sym_keyword_desc] = ACTIONS(2233),
    [sym_keyword_asc] = ACTIONS(2233),
    [sym_keyword_limit] = ACTIONS(2233),
    [sym_keyword_primary] = ACTIONS(2233),
    [sym_keyword_create] = ACTIONS(2233),
    [sym_keyword_as] = ACTIONS(2235),
    [sym_keyword_constraint] = ACTIONS(2233),
    [sym_keyword_separator] = ACTIONS(2233),
    [sym_keyword_when] = ACTIONS(2233),
    [sym_keyword_then] = ACTIONS(2233),
    [sym_keyword_else] = ACTIONS(2233),
    [sym_keyword_end] = ACTIONS(2233),
    [sym_keyword_in] = ACTIONS(2233),
    [sym_keyword_and] = ACTIONS(2233),
    [sym_keyword_or] = ACTIONS(2233),
    [sym_keyword_is] = ACTIONS(2233),
    [sym_keyword_not] = ACTIONS(2233),
    [sym_keyword_using] = ACTIONS(2233),
    [sym_keyword_auto_increment] = ACTIONS(2233),
    [sym_keyword_generated] = ACTIONS(2233),
    [sym_keyword_default] = ACTIONS(2233),
    [sym_keyword_returning] = ACTIONS(2233),
    [sym_keyword_first] = ACTIONS(2233),
    [sym_keyword_after] = ACTIONS(2233),
    [sym_keyword_range] = ACTIONS(2233),
    [sym_keyword_rows] = ACTIONS(2233),
    [sym_keyword_groups] = ACTIONS(2233),
    [sym_keyword_between] = ACTIONS(2233),
    [sym_keyword_preceding] = ACTIONS(2233),
    [sym_keyword_following] = ACTIONS(2233),
    [sym_keyword_unique] = ACTIONS(2233),
    [sym_keyword_references] = ACTIONS(2233),
    [aux_sym_keyword_like_token1] = ACTIONS(2233),
    [aux_sym_keyword_like_token2] = ACTIONS(2233),
    [sym_keyword_similar] = ACTIONS(2233),
    [sym_keyword_check] = ACTIONS(2233),
    [sym_keyword_stored] = ACTIONS(2233),
    [sym_keyword_virtual] = ACTIONS(2233),
    [sym_keyword_comment] = ACTIONS(2233),
    [sym_keyword_null] = ACTIONS(2233),
    [sym_keyword_array] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_RBRACK] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2233),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2233),
    [anon_sym_COLON] = ACTIONS(2235),
    [sym_op_other] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_LT_GT] = ACTIONS(2233),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [sym_keyword_from] = ACTIONS(2237),
    [sym_keyword_on] = ACTIONS(2237),
    [sym_keyword_where] = ACTIONS(2237),
    [sym_keyword_desc] = ACTIONS(2237),
    [sym_keyword_asc] = ACTIONS(2237),
    [sym_keyword_limit] = ACTIONS(2237),
    [sym_keyword_primary] = ACTIONS(2237),
    [sym_keyword_create] = ACTIONS(2237),
    [sym_keyword_as] = ACTIONS(2239),
    [sym_keyword_constraint] = ACTIONS(2237),
    [sym_keyword_separator] = ACTIONS(2237),
    [sym_keyword_when] = ACTIONS(2237),
    [sym_keyword_then] = ACTIONS(2237),
    [sym_keyword_else] = ACTIONS(2237),
    [sym_keyword_end] = ACTIONS(2237),
    [sym_keyword_in] = ACTIONS(2237),
    [sym_keyword_and] = ACTIONS(2237),
    [sym_keyword_or] = ACTIONS(2237),
    [sym_keyword_is] = ACTIONS(2237),
    [sym_keyword_not] = ACTIONS(2237),
    [sym_keyword_using] = ACTIONS(2237),
    [sym_keyword_auto_increment] = ACTIONS(2237),
    [sym_keyword_generated] = ACTIONS(2237),
    [sym_keyword_default] = ACTIONS(2237),
    [sym_keyword_returning] = ACTIONS(2237),
    [sym_keyword_first] = ACTIONS(2237),
    [sym_keyword_after] = ACTIONS(2237),
    [sym_keyword_range] = ACTIONS(2237),
    [sym_keyword_rows] = ACTIONS(2237),
    [sym_keyword_groups] = ACTIONS(2237),
    [sym_keyword_between] = ACTIONS(2237),
    [sym_keyword_preceding] = ACTIONS(2237),
    [sym_keyword_following] = ACTIONS(2237),
    [sym_keyword_unique] = ACTIONS(2237),
    [sym_keyword_references] = ACTIONS(2237),
    [aux_sym_keyword_like_token1] = ACTIONS(2237),
    [aux_sym_keyword_like_token2] = ACTIONS(2237),
    [sym_keyword_similar] = ACTIONS(2237),
    [sym_keyword_check] = ACTIONS(2237),
    [sym_keyword_stored] = ACTIONS(2237),
    [sym_keyword_virtual] = ACTIONS(2237),
    [sym_keyword_comment] = ACTIONS(2237),
    [sym_keyword_null] = ACTIONS(2237),
    [sym_keyword_array] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_RBRACK] = ACTIONS(2237),
    [anon_sym_RPAREN] = ACTIONS(2237),
    [anon_sym_COMMA] = ACTIONS(2237),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2237),
    [anon_sym_GT_EQ] = ACTIONS(2237),
    [anon_sym_COLON] = ACTIONS(2239),
    [sym_op_other] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2237),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_BANG_EQ] = ACTIONS(2237),
    [anon_sym_LT_GT] = ACTIONS(2237),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [sym_keyword_from] = ACTIONS(2241),
    [sym_keyword_on] = ACTIONS(2241),
    [sym_keyword_where] = ACTIONS(2241),
    [sym_keyword_desc] = ACTIONS(2241),
    [sym_keyword_asc] = ACTIONS(2241),
    [sym_keyword_limit] = ACTIONS(2241),
    [sym_keyword_primary] = ACTIONS(2241),
    [sym_keyword_create] = ACTIONS(2241),
    [sym_keyword_as] = ACTIONS(2243),
    [sym_keyword_constraint] = ACTIONS(2241),
    [sym_keyword_separator] = ACTIONS(2241),
    [sym_keyword_when] = ACTIONS(2241),
    [sym_keyword_then] = ACTIONS(2241),
    [sym_keyword_else] = ACTIONS(2241),
    [sym_keyword_end] = ACTIONS(2241),
    [sym_keyword_in] = ACTIONS(2241),
    [sym_keyword_and] = ACTIONS(2241),
    [sym_keyword_or] = ACTIONS(2241),
    [sym_keyword_is] = ACTIONS(2241),
    [sym_keyword_not] = ACTIONS(2241),
    [sym_keyword_using] = ACTIONS(2241),
    [sym_keyword_auto_increment] = ACTIONS(2241),
    [sym_keyword_generated] = ACTIONS(2241),
    [sym_keyword_default] = ACTIONS(2241),
    [sym_keyword_returning] = ACTIONS(2241),
    [sym_keyword_first] = ACTIONS(2241),
    [sym_keyword_after] = ACTIONS(2241),
    [sym_keyword_range] = ACTIONS(2241),
    [sym_keyword_rows] = ACTIONS(2241),
    [sym_keyword_groups] = ACTIONS(2241),
    [sym_keyword_between] = ACTIONS(2241),
    [sym_keyword_preceding] = ACTIONS(2241),
    [sym_keyword_following] = ACTIONS(2241),
    [sym_keyword_unique] = ACTIONS(2241),
    [sym_keyword_references] = ACTIONS(2241),
    [aux_sym_keyword_like_token1] = ACTIONS(2241),
    [aux_sym_keyword_like_token2] = ACTIONS(2241),
    [sym_keyword_similar] = ACTIONS(2241),
    [sym_keyword_check] = ACTIONS(2241),
    [sym_keyword_stored] = ACTIONS(2241),
    [sym_keyword_virtual] = ACTIONS(2241),
    [sym_keyword_comment] = ACTIONS(2241),
    [sym_keyword_null] = ACTIONS(2241),
    [sym_keyword_array] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_COLON] = ACTIONS(2243),
    [sym_op_other] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_LT_GT] = ACTIONS(2241),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2245),
    [sym_keyword_from] = ACTIONS(2245),
    [sym_keyword_on] = ACTIONS(2245),
    [sym_keyword_where] = ACTIONS(2245),
    [sym_keyword_desc] = ACTIONS(2245),
    [sym_keyword_asc] = ACTIONS(2245),
    [sym_keyword_limit] = ACTIONS(2245),
    [sym_keyword_primary] = ACTIONS(2245),
    [sym_keyword_create] = ACTIONS(2245),
    [sym_keyword_as] = ACTIONS(2247),
    [sym_keyword_constraint] = ACTIONS(2245),
    [sym_keyword_separator] = ACTIONS(2245),
    [sym_keyword_when] = ACTIONS(2245),
    [sym_keyword_then] = ACTIONS(2245),
    [sym_keyword_else] = ACTIONS(2245),
    [sym_keyword_end] = ACTIONS(2245),
    [sym_keyword_in] = ACTIONS(2245),
    [sym_keyword_and] = ACTIONS(2245),
    [sym_keyword_or] = ACTIONS(2245),
    [sym_keyword_is] = ACTIONS(2245),
    [sym_keyword_not] = ACTIONS(2245),
    [sym_keyword_using] = ACTIONS(2245),
    [sym_keyword_auto_increment] = ACTIONS(2245),
    [sym_keyword_generated] = ACTIONS(2245),
    [sym_keyword_default] = ACTIONS(2245),
    [sym_keyword_returning] = ACTIONS(2245),
    [sym_keyword_first] = ACTIONS(2245),
    [sym_keyword_after] = ACTIONS(2245),
    [sym_keyword_range] = ACTIONS(2245),
    [sym_keyword_rows] = ACTIONS(2245),
    [sym_keyword_groups] = ACTIONS(2245),
    [sym_keyword_between] = ACTIONS(2245),
    [sym_keyword_preceding] = ACTIONS(2245),
    [sym_keyword_following] = ACTIONS(2245),
    [sym_keyword_unique] = ACTIONS(2245),
    [sym_keyword_references] = ACTIONS(2245),
    [aux_sym_keyword_like_token1] = ACTIONS(2245),
    [aux_sym_keyword_like_token2] = ACTIONS(2245),
    [sym_keyword_similar] = ACTIONS(2245),
    [sym_keyword_check] = ACTIONS(2245),
    [sym_keyword_stored] = ACTIONS(2245),
    [sym_keyword_virtual] = ACTIONS(2245),
    [sym_keyword_comment] = ACTIONS(2245),
    [sym_keyword_null] = ACTIONS(2245),
    [sym_keyword_array] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [anon_sym_RBRACK] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2245),
    [anon_sym_STAR] = ACTIONS(2245),
    [anon_sym_COLON_COLON] = ACTIONS(2245),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_COLON] = ACTIONS(2247),
    [sym_op_other] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2247),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_CARET] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_LT_GT] = ACTIONS(2245),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2249),
    [sym_keyword_from] = ACTIONS(2249),
    [sym_keyword_on] = ACTIONS(2249),
    [sym_keyword_where] = ACTIONS(2249),
    [sym_keyword_desc] = ACTIONS(2249),
    [sym_keyword_asc] = ACTIONS(2249),
    [sym_keyword_limit] = ACTIONS(2249),
    [sym_keyword_primary] = ACTIONS(2249),
    [sym_keyword_create] = ACTIONS(2249),
    [sym_keyword_as] = ACTIONS(2251),
    [sym_keyword_constraint] = ACTIONS(2249),
    [sym_keyword_separator] = ACTIONS(2249),
    [sym_keyword_when] = ACTIONS(2249),
    [sym_keyword_then] = ACTIONS(2249),
    [sym_keyword_else] = ACTIONS(2249),
    [sym_keyword_end] = ACTIONS(2249),
    [sym_keyword_in] = ACTIONS(2249),
    [sym_keyword_and] = ACTIONS(2249),
    [sym_keyword_or] = ACTIONS(2249),
    [sym_keyword_is] = ACTIONS(2249),
    [sym_keyword_not] = ACTIONS(2249),
    [sym_keyword_using] = ACTIONS(2249),
    [sym_keyword_auto_increment] = ACTIONS(2249),
    [sym_keyword_generated] = ACTIONS(2249),
    [sym_keyword_default] = ACTIONS(2249),
    [sym_keyword_returning] = ACTIONS(2249),
    [sym_keyword_first] = ACTIONS(2249),
    [sym_keyword_after] = ACTIONS(2249),
    [sym_keyword_range] = ACTIONS(2249),
    [sym_keyword_rows] = ACTIONS(2249),
    [sym_keyword_groups] = ACTIONS(2249),
    [sym_keyword_between] = ACTIONS(2249),
    [sym_keyword_preceding] = ACTIONS(2249),
    [sym_keyword_following] = ACTIONS(2249),
    [sym_keyword_unique] = ACTIONS(2249),
    [sym_keyword_references] = ACTIONS(2249),
    [aux_sym_keyword_like_token1] = ACTIONS(2249),
    [aux_sym_keyword_like_token2] = ACTIONS(2249),
    [sym_keyword_similar] = ACTIONS(2249),
    [sym_keyword_check] = ACTIONS(2249),
    [sym_keyword_stored] = ACTIONS(2249),
    [sym_keyword_virtual] = ACTIONS(2249),
    [sym_keyword_comment] = ACTIONS(2249),
    [sym_keyword_null] = ACTIONS(2249),
    [sym_keyword_array] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [anon_sym_RBRACK] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2249),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_COLON_COLON] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2251),
    [sym_op_other] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2249),
    [anon_sym_LT_GT] = ACTIONS(2249),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(2253),
    [anon_sym_SEMI] = ACTIONS(2253),
    [sym_keyword_from] = ACTIONS(2253),
    [sym_keyword_on] = ACTIONS(2253),
    [sym_keyword_where] = ACTIONS(2253),
    [sym_keyword_desc] = ACTIONS(2253),
    [sym_keyword_asc] = ACTIONS(2253),
    [sym_keyword_limit] = ACTIONS(2253),
    [sym_keyword_primary] = ACTIONS(2253),
    [sym_keyword_create] = ACTIONS(2253),
    [sym_keyword_as] = ACTIONS(2255),
    [sym_keyword_constraint] = ACTIONS(2253),
    [sym_keyword_separator] = ACTIONS(2253),
    [sym_keyword_when] = ACTIONS(2253),
    [sym_keyword_then] = ACTIONS(2253),
    [sym_keyword_else] = ACTIONS(2253),
    [sym_keyword_end] = ACTIONS(2253),
    [sym_keyword_in] = ACTIONS(2253),
    [sym_keyword_and] = ACTIONS(2253),
    [sym_keyword_or] = ACTIONS(2253),
    [sym_keyword_is] = ACTIONS(2253),
    [sym_keyword_not] = ACTIONS(2253),
    [sym_keyword_using] = ACTIONS(2253),
    [sym_keyword_auto_increment] = ACTIONS(2253),
    [sym_keyword_generated] = ACTIONS(2253),
    [sym_keyword_default] = ACTIONS(2253),
    [sym_keyword_returning] = ACTIONS(2253),
    [sym_keyword_first] = ACTIONS(2253),
    [sym_keyword_after] = ACTIONS(2253),
    [sym_keyword_range] = ACTIONS(2253),
    [sym_keyword_rows] = ACTIONS(2253),
    [sym_keyword_groups] = ACTIONS(2253),
    [sym_keyword_between] = ACTIONS(2253),
    [sym_keyword_preceding] = ACTIONS(2253),
    [sym_keyword_following] = ACTIONS(2253),
    [sym_keyword_unique] = ACTIONS(2253),
    [sym_keyword_references] = ACTIONS(2253),
    [aux_sym_keyword_like_token1] = ACTIONS(2253),
    [aux_sym_keyword_like_token2] = ACTIONS(2253),
    [sym_keyword_similar] = ACTIONS(2253),
    [sym_keyword_check] = ACTIONS(2253),
    [sym_keyword_stored] = ACTIONS(2253),
    [sym_keyword_virtual] = ACTIONS(2253),
    [sym_keyword_comment] = ACTIONS(2253),
    [sym_keyword_null] = ACTIONS(2253),
    [sym_keyword_array] = ACTIONS(2253),
    [anon_sym_LBRACK] = ACTIONS(2253),
    [anon_sym_RBRACK] = ACTIONS(2253),
    [anon_sym_RPAREN] = ACTIONS(2253),
    [anon_sym_COMMA] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2253),
    [anon_sym_STAR] = ACTIONS(2253),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2253),
    [anon_sym_GT_EQ] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(2255),
    [sym_op_other] = ACTIONS(2253),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2253),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_BANG_EQ] = ACTIONS(2253),
    [anon_sym_LT_GT] = ACTIONS(2253),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(2257),
    [anon_sym_SEMI] = ACTIONS(2257),
    [sym_keyword_from] = ACTIONS(2257),
    [sym_keyword_on] = ACTIONS(2257),
    [sym_keyword_where] = ACTIONS(2257),
    [sym_keyword_desc] = ACTIONS(2257),
    [sym_keyword_asc] = ACTIONS(2257),
    [sym_keyword_limit] = ACTIONS(2257),
    [sym_keyword_primary] = ACTIONS(2257),
    [sym_keyword_create] = ACTIONS(2257),
    [sym_keyword_as] = ACTIONS(2259),
    [sym_keyword_constraint] = ACTIONS(2257),
    [sym_keyword_separator] = ACTIONS(2257),
    [sym_keyword_when] = ACTIONS(2257),
    [sym_keyword_then] = ACTIONS(2257),
    [sym_keyword_else] = ACTIONS(2257),
    [sym_keyword_end] = ACTIONS(2257),
    [sym_keyword_in] = ACTIONS(2257),
    [sym_keyword_and] = ACTIONS(2257),
    [sym_keyword_or] = ACTIONS(2257),
    [sym_keyword_is] = ACTIONS(2257),
    [sym_keyword_not] = ACTIONS(2257),
    [sym_keyword_using] = ACTIONS(2257),
    [sym_keyword_auto_increment] = ACTIONS(2257),
    [sym_keyword_generated] = ACTIONS(2257),
    [sym_keyword_default] = ACTIONS(2257),
    [sym_keyword_returning] = ACTIONS(2257),
    [sym_keyword_first] = ACTIONS(2257),
    [sym_keyword_after] = ACTIONS(2257),
    [sym_keyword_range] = ACTIONS(2257),
    [sym_keyword_rows] = ACTIONS(2257),
    [sym_keyword_groups] = ACTIONS(2257),
    [sym_keyword_between] = ACTIONS(2257),
    [sym_keyword_preceding] = ACTIONS(2257),
    [sym_keyword_following] = ACTIONS(2257),
    [sym_keyword_unique] = ACTIONS(2257),
    [sym_keyword_references] = ACTIONS(2257),
    [aux_sym_keyword_like_token1] = ACTIONS(2257),
    [aux_sym_keyword_like_token2] = ACTIONS(2257),
    [sym_keyword_similar] = ACTIONS(2257),
    [sym_keyword_check] = ACTIONS(2257),
    [sym_keyword_stored] = ACTIONS(2257),
    [sym_keyword_virtual] = ACTIONS(2257),
    [sym_keyword_comment] = ACTIONS(2257),
    [sym_keyword_null] = ACTIONS(2257),
    [sym_keyword_array] = ACTIONS(2257),
    [anon_sym_LBRACK] = ACTIONS(2257),
    [anon_sym_RBRACK] = ACTIONS(2257),
    [anon_sym_RPAREN] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2259),
    [anon_sym_GT] = ACTIONS(2259),
    [anon_sym_LT_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2257),
    [anon_sym_COLON] = ACTIONS(2259),
    [sym_op_other] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2259),
    [anon_sym_SLASH] = ACTIONS(2259),
    [anon_sym_PERCENT] = ACTIONS(2257),
    [anon_sym_CARET] = ACTIONS(2259),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_LT_GT] = ACTIONS(2257),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(2261),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_keyword_from] = ACTIONS(2261),
    [sym_keyword_on] = ACTIONS(2261),
    [sym_keyword_where] = ACTIONS(2261),
    [sym_keyword_desc] = ACTIONS(2261),
    [sym_keyword_asc] = ACTIONS(2261),
    [sym_keyword_limit] = ACTIONS(2261),
    [sym_keyword_primary] = ACTIONS(2261),
    [sym_keyword_create] = ACTIONS(2261),
    [sym_keyword_as] = ACTIONS(2263),
    [sym_keyword_constraint] = ACTIONS(2261),
    [sym_keyword_separator] = ACTIONS(2261),
    [sym_keyword_when] = ACTIONS(2261),
    [sym_keyword_then] = ACTIONS(2261),
    [sym_keyword_else] = ACTIONS(2261),
    [sym_keyword_end] = ACTIONS(2261),
    [sym_keyword_in] = ACTIONS(2261),
    [sym_keyword_and] = ACTIONS(2261),
    [sym_keyword_or] = ACTIONS(2261),
    [sym_keyword_is] = ACTIONS(2261),
    [sym_keyword_not] = ACTIONS(2261),
    [sym_keyword_using] = ACTIONS(2261),
    [sym_keyword_auto_increment] = ACTIONS(2261),
    [sym_keyword_generated] = ACTIONS(2261),
    [sym_keyword_default] = ACTIONS(2261),
    [sym_keyword_returning] = ACTIONS(2261),
    [sym_keyword_first] = ACTIONS(2261),
    [sym_keyword_after] = ACTIONS(2261),
    [sym_keyword_range] = ACTIONS(2261),
    [sym_keyword_rows] = ACTIONS(2261),
    [sym_keyword_groups] = ACTIONS(2261),
    [sym_keyword_between] = ACTIONS(2261),
    [sym_keyword_preceding] = ACTIONS(2261),
    [sym_keyword_following] = ACTIONS(2261),
    [sym_keyword_unique] = ACTIONS(2261),
    [sym_keyword_references] = ACTIONS(2261),
    [aux_sym_keyword_like_token1] = ACTIONS(2261),
    [aux_sym_keyword_like_token2] = ACTIONS(2261),
    [sym_keyword_similar] = ACTIONS(2261),
    [sym_keyword_check] = ACTIONS(2261),
    [sym_keyword_stored] = ACTIONS(2261),
    [sym_keyword_virtual] = ACTIONS(2261),
    [sym_keyword_comment] = ACTIONS(2261),
    [sym_keyword_null] = ACTIONS(2261),
    [sym_keyword_array] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(2261),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_COMMA] = ACTIONS(2261),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2263),
    [anon_sym_LT_EQ] = ACTIONS(2261),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_COLON] = ACTIONS(2263),
    [sym_op_other] = ACTIONS(2261),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_LT_GT] = ACTIONS(2261),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2265),
    [sym_keyword_from] = ACTIONS(2265),
    [sym_keyword_on] = ACTIONS(2265),
    [sym_keyword_where] = ACTIONS(2265),
    [sym_keyword_desc] = ACTIONS(2265),
    [sym_keyword_asc] = ACTIONS(2265),
    [sym_keyword_limit] = ACTIONS(2265),
    [sym_keyword_primary] = ACTIONS(2265),
    [sym_keyword_create] = ACTIONS(2265),
    [sym_keyword_as] = ACTIONS(2267),
    [sym_keyword_constraint] = ACTIONS(2265),
    [sym_keyword_separator] = ACTIONS(2265),
    [sym_keyword_when] = ACTIONS(2265),
    [sym_keyword_then] = ACTIONS(2265),
    [sym_keyword_else] = ACTIONS(2265),
    [sym_keyword_end] = ACTIONS(2265),
    [sym_keyword_in] = ACTIONS(2265),
    [sym_keyword_and] = ACTIONS(2265),
    [sym_keyword_or] = ACTIONS(2265),
    [sym_keyword_is] = ACTIONS(2265),
    [sym_keyword_not] = ACTIONS(2265),
    [sym_keyword_using] = ACTIONS(2265),
    [sym_keyword_auto_increment] = ACTIONS(2265),
    [sym_keyword_generated] = ACTIONS(2265),
    [sym_keyword_default] = ACTIONS(2265),
    [sym_keyword_returning] = ACTIONS(2265),
    [sym_keyword_first] = ACTIONS(2265),
    [sym_keyword_after] = ACTIONS(2265),
    [sym_keyword_range] = ACTIONS(2265),
    [sym_keyword_rows] = ACTIONS(2265),
    [sym_keyword_groups] = ACTIONS(2265),
    [sym_keyword_between] = ACTIONS(2265),
    [sym_keyword_preceding] = ACTIONS(2265),
    [sym_keyword_following] = ACTIONS(2265),
    [sym_keyword_unique] = ACTIONS(2265),
    [sym_keyword_references] = ACTIONS(2265),
    [aux_sym_keyword_like_token1] = ACTIONS(2265),
    [aux_sym_keyword_like_token2] = ACTIONS(2265),
    [sym_keyword_similar] = ACTIONS(2265),
    [sym_keyword_check] = ACTIONS(2265),
    [sym_keyword_stored] = ACTIONS(2265),
    [sym_keyword_virtual] = ACTIONS(2265),
    [sym_keyword_comment] = ACTIONS(2265),
    [sym_keyword_null] = ACTIONS(2265),
    [sym_keyword_array] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(2265),
    [anon_sym_RBRACK] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_COMMA] = ACTIONS(2265),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2265),
    [anon_sym_COLON_COLON] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2265),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_op_other] = ACTIONS(2265),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2265),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_BANG_EQ] = ACTIONS(2265),
    [anon_sym_LT_GT] = ACTIONS(2265),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1782),
    [anon_sym_SEMI] = ACTIONS(1782),
    [sym_keyword_from] = ACTIONS(1782),
    [sym_keyword_on] = ACTIONS(1782),
    [sym_keyword_where] = ACTIONS(1782),
    [sym_keyword_desc] = ACTIONS(1782),
    [sym_keyword_asc] = ACTIONS(1782),
    [sym_keyword_limit] = ACTIONS(1782),
    [sym_keyword_primary] = ACTIONS(1782),
    [sym_keyword_create] = ACTIONS(1782),
    [sym_keyword_as] = ACTIONS(1784),
    [sym_keyword_constraint] = ACTIONS(1782),
    [sym_keyword_separator] = ACTIONS(1782),
    [sym_keyword_when] = ACTIONS(1782),
    [sym_keyword_then] = ACTIONS(1782),
    [sym_keyword_else] = ACTIONS(1782),
    [sym_keyword_end] = ACTIONS(1782),
    [sym_keyword_in] = ACTIONS(1782),
    [sym_keyword_and] = ACTIONS(1782),
    [sym_keyword_or] = ACTIONS(1782),
    [sym_keyword_is] = ACTIONS(1782),
    [sym_keyword_not] = ACTIONS(1782),
    [sym_keyword_using] = ACTIONS(1782),
    [sym_keyword_auto_increment] = ACTIONS(1782),
    [sym_keyword_generated] = ACTIONS(1782),
    [sym_keyword_default] = ACTIONS(1782),
    [sym_keyword_returning] = ACTIONS(1782),
    [sym_keyword_first] = ACTIONS(1782),
    [sym_keyword_after] = ACTIONS(1782),
    [sym_keyword_range] = ACTIONS(1782),
    [sym_keyword_rows] = ACTIONS(1782),
    [sym_keyword_groups] = ACTIONS(1782),
    [sym_keyword_between] = ACTIONS(1782),
    [sym_keyword_preceding] = ACTIONS(1782),
    [sym_keyword_following] = ACTIONS(1782),
    [sym_keyword_unique] = ACTIONS(1782),
    [sym_keyword_references] = ACTIONS(1782),
    [aux_sym_keyword_like_token1] = ACTIONS(1782),
    [aux_sym_keyword_like_token2] = ACTIONS(1782),
    [sym_keyword_similar] = ACTIONS(1782),
    [sym_keyword_check] = ACTIONS(1782),
    [sym_keyword_stored] = ACTIONS(1782),
    [sym_keyword_virtual] = ACTIONS(1782),
    [sym_keyword_comment] = ACTIONS(1782),
    [sym_keyword_null] = ACTIONS(1782),
    [sym_keyword_array] = ACTIONS(1782),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_RBRACK] = ACTIONS(1782),
    [anon_sym_RPAREN] = ACTIONS(1782),
    [anon_sym_COMMA] = ACTIONS(1782),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1782),
    [anon_sym_STAR] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_GT] = ACTIONS(1784),
    [anon_sym_LT_EQ] = ACTIONS(1782),
    [anon_sym_GT_EQ] = ACTIONS(1782),
    [anon_sym_COLON] = ACTIONS(1784),
    [sym_op_other] = ACTIONS(1782),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1784),
    [anon_sym_SLASH] = ACTIONS(1784),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_CARET] = ACTIONS(1784),
    [anon_sym_BANG_EQ] = ACTIONS(1782),
    [anon_sym_LT_GT] = ACTIONS(1782),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2269),
    [sym_keyword_from] = ACTIONS(2269),
    [sym_keyword_on] = ACTIONS(2269),
    [sym_keyword_where] = ACTIONS(2269),
    [sym_keyword_desc] = ACTIONS(2269),
    [sym_keyword_asc] = ACTIONS(2269),
    [sym_keyword_limit] = ACTIONS(2269),
    [sym_keyword_primary] = ACTIONS(2269),
    [sym_keyword_create] = ACTIONS(2269),
    [sym_keyword_as] = ACTIONS(2271),
    [sym_keyword_constraint] = ACTIONS(2269),
    [sym_keyword_separator] = ACTIONS(2269),
    [sym_keyword_when] = ACTIONS(2269),
    [sym_keyword_then] = ACTIONS(2269),
    [sym_keyword_else] = ACTIONS(2269),
    [sym_keyword_end] = ACTIONS(2269),
    [sym_keyword_in] = ACTIONS(2269),
    [sym_keyword_and] = ACTIONS(2269),
    [sym_keyword_or] = ACTIONS(2269),
    [sym_keyword_is] = ACTIONS(2269),
    [sym_keyword_not] = ACTIONS(2269),
    [sym_keyword_using] = ACTIONS(2269),
    [sym_keyword_auto_increment] = ACTIONS(2269),
    [sym_keyword_generated] = ACTIONS(2269),
    [sym_keyword_default] = ACTIONS(2269),
    [sym_keyword_returning] = ACTIONS(2269),
    [sym_keyword_first] = ACTIONS(2269),
    [sym_keyword_after] = ACTIONS(2269),
    [sym_keyword_range] = ACTIONS(2269),
    [sym_keyword_rows] = ACTIONS(2269),
    [sym_keyword_groups] = ACTIONS(2269),
    [sym_keyword_between] = ACTIONS(2269),
    [sym_keyword_preceding] = ACTIONS(2269),
    [sym_keyword_following] = ACTIONS(2269),
    [sym_keyword_unique] = ACTIONS(2269),
    [sym_keyword_references] = ACTIONS(2269),
    [aux_sym_keyword_like_token1] = ACTIONS(2269),
    [aux_sym_keyword_like_token2] = ACTIONS(2269),
    [sym_keyword_similar] = ACTIONS(2269),
    [sym_keyword_check] = ACTIONS(2269),
    [sym_keyword_stored] = ACTIONS(2269),
    [sym_keyword_virtual] = ACTIONS(2269),
    [sym_keyword_comment] = ACTIONS(2269),
    [sym_keyword_null] = ACTIONS(2269),
    [sym_keyword_array] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2269),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_COLON] = ACTIONS(2271),
    [sym_op_other] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_SLASH] = ACTIONS(2271),
    [anon_sym_PERCENT] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_LT_GT] = ACTIONS(2269),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(2077),
    [anon_sym_SEMI] = ACTIONS(2077),
    [sym_keyword_from] = ACTIONS(2077),
    [sym_keyword_on] = ACTIONS(2077),
    [sym_keyword_where] = ACTIONS(2077),
    [sym_keyword_desc] = ACTIONS(2077),
    [sym_keyword_asc] = ACTIONS(2077),
    [sym_keyword_limit] = ACTIONS(2077),
    [sym_keyword_primary] = ACTIONS(2077),
    [sym_keyword_create] = ACTIONS(2077),
    [sym_keyword_as] = ACTIONS(2079),
    [sym_keyword_constraint] = ACTIONS(2077),
    [sym_keyword_separator] = ACTIONS(2077),
    [sym_keyword_when] = ACTIONS(2077),
    [sym_keyword_then] = ACTIONS(2077),
    [sym_keyword_else] = ACTIONS(2077),
    [sym_keyword_end] = ACTIONS(2077),
    [sym_keyword_in] = ACTIONS(2077),
    [sym_keyword_and] = ACTIONS(2077),
    [sym_keyword_or] = ACTIONS(2077),
    [sym_keyword_is] = ACTIONS(2077),
    [sym_keyword_not] = ACTIONS(2077),
    [sym_keyword_using] = ACTIONS(2077),
    [sym_keyword_auto_increment] = ACTIONS(2077),
    [sym_keyword_generated] = ACTIONS(2077),
    [sym_keyword_default] = ACTIONS(2077),
    [sym_keyword_returning] = ACTIONS(2077),
    [sym_keyword_first] = ACTIONS(2077),
    [sym_keyword_after] = ACTIONS(2077),
    [sym_keyword_range] = ACTIONS(2077),
    [sym_keyword_rows] = ACTIONS(2077),
    [sym_keyword_groups] = ACTIONS(2077),
    [sym_keyword_between] = ACTIONS(2077),
    [sym_keyword_preceding] = ACTIONS(2077),
    [sym_keyword_following] = ACTIONS(2077),
    [sym_keyword_unique] = ACTIONS(2077),
    [sym_keyword_references] = ACTIONS(2077),
    [aux_sym_keyword_like_token1] = ACTIONS(2077),
    [aux_sym_keyword_like_token2] = ACTIONS(2077),
    [sym_keyword_similar] = ACTIONS(2077),
    [sym_keyword_check] = ACTIONS(2077),
    [sym_keyword_stored] = ACTIONS(2077),
    [sym_keyword_virtual] = ACTIONS(2077),
    [sym_keyword_comment] = ACTIONS(2077),
    [sym_keyword_null] = ACTIONS(2077),
    [sym_keyword_array] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_RBRACK] = ACTIONS(2077),
    [anon_sym_RPAREN] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(2077),
    [anon_sym_COLON_COLON] = ACTIONS(2077),
    [anon_sym_LT] = ACTIONS(2079),
    [anon_sym_GT] = ACTIONS(2079),
    [anon_sym_LT_EQ] = ACTIONS(2077),
    [anon_sym_GT_EQ] = ACTIONS(2077),
    [anon_sym_COLON] = ACTIONS(2079),
    [sym_op_other] = ACTIONS(2077),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2079),
    [anon_sym_PERCENT] = ACTIONS(2077),
    [anon_sym_CARET] = ACTIONS(2079),
    [anon_sym_BANG_EQ] = ACTIONS(2077),
    [anon_sym_LT_GT] = ACTIONS(2077),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(2273),
    [anon_sym_SEMI] = ACTIONS(2273),
    [sym_keyword_from] = ACTIONS(2273),
    [sym_keyword_on] = ACTIONS(2273),
    [sym_keyword_where] = ACTIONS(2273),
    [sym_keyword_desc] = ACTIONS(2273),
    [sym_keyword_asc] = ACTIONS(2273),
    [sym_keyword_limit] = ACTIONS(2273),
    [sym_keyword_primary] = ACTIONS(2273),
    [sym_keyword_create] = ACTIONS(2273),
    [sym_keyword_as] = ACTIONS(2275),
    [sym_keyword_constraint] = ACTIONS(2273),
    [sym_keyword_separator] = ACTIONS(2273),
    [sym_keyword_when] = ACTIONS(2273),
    [sym_keyword_then] = ACTIONS(2273),
    [sym_keyword_else] = ACTIONS(2273),
    [sym_keyword_end] = ACTIONS(2273),
    [sym_keyword_in] = ACTIONS(2273),
    [sym_keyword_and] = ACTIONS(2273),
    [sym_keyword_or] = ACTIONS(2273),
    [sym_keyword_is] = ACTIONS(2273),
    [sym_keyword_not] = ACTIONS(2273),
    [sym_keyword_using] = ACTIONS(2273),
    [sym_keyword_auto_increment] = ACTIONS(2273),
    [sym_keyword_generated] = ACTIONS(2273),
    [sym_keyword_default] = ACTIONS(2273),
    [sym_keyword_returning] = ACTIONS(2273),
    [sym_keyword_first] = ACTIONS(2273),
    [sym_keyword_after] = ACTIONS(2273),
    [sym_keyword_range] = ACTIONS(2273),
    [sym_keyword_rows] = ACTIONS(2273),
    [sym_keyword_groups] = ACTIONS(2273),
    [sym_keyword_between] = ACTIONS(2273),
    [sym_keyword_preceding] = ACTIONS(2273),
    [sym_keyword_following] = ACTIONS(2273),
    [sym_keyword_unique] = ACTIONS(2273),
    [sym_keyword_references] = ACTIONS(2273),
    [aux_sym_keyword_like_token1] = ACTIONS(2273),
    [aux_sym_keyword_like_token2] = ACTIONS(2273),
    [sym_keyword_similar] = ACTIONS(2273),
    [sym_keyword_check] = ACTIONS(2273),
    [sym_keyword_stored] = ACTIONS(2273),
    [sym_keyword_virtual] = ACTIONS(2273),
    [sym_keyword_comment] = ACTIONS(2273),
    [sym_keyword_null] = ACTIONS(2273),
    [sym_keyword_array] = ACTIONS(2273),
    [anon_sym_LBRACK] = ACTIONS(2273),
    [anon_sym_RBRACK] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2273),
    [anon_sym_COMMA] = ACTIONS(2273),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_LT_EQ] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2273),
    [anon_sym_COLON] = ACTIONS(2275),
    [sym_op_other] = ACTIONS(2273),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_SLASH] = ACTIONS(2275),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_CARET] = ACTIONS(2275),
    [anon_sym_BANG_EQ] = ACTIONS(2273),
    [anon_sym_LT_GT] = ACTIONS(2273),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2277),
    [sym_keyword_from] = ACTIONS(2277),
    [sym_keyword_on] = ACTIONS(2277),
    [sym_keyword_where] = ACTIONS(2277),
    [sym_keyword_desc] = ACTIONS(2277),
    [sym_keyword_asc] = ACTIONS(2277),
    [sym_keyword_limit] = ACTIONS(2277),
    [sym_keyword_primary] = ACTIONS(2277),
    [sym_keyword_create] = ACTIONS(2277),
    [sym_keyword_as] = ACTIONS(2279),
    [sym_keyword_constraint] = ACTIONS(2277),
    [sym_keyword_separator] = ACTIONS(2277),
    [sym_keyword_when] = ACTIONS(2277),
    [sym_keyword_then] = ACTIONS(2277),
    [sym_keyword_else] = ACTIONS(2277),
    [sym_keyword_end] = ACTIONS(2277),
    [sym_keyword_in] = ACTIONS(2277),
    [sym_keyword_and] = ACTIONS(2277),
    [sym_keyword_or] = ACTIONS(2277),
    [sym_keyword_is] = ACTIONS(2277),
    [sym_keyword_not] = ACTIONS(2277),
    [sym_keyword_using] = ACTIONS(2277),
    [sym_keyword_auto_increment] = ACTIONS(2277),
    [sym_keyword_generated] = ACTIONS(2277),
    [sym_keyword_default] = ACTIONS(2277),
    [sym_keyword_returning] = ACTIONS(2277),
    [sym_keyword_first] = ACTIONS(2277),
    [sym_keyword_after] = ACTIONS(2277),
    [sym_keyword_range] = ACTIONS(2277),
    [sym_keyword_rows] = ACTIONS(2277),
    [sym_keyword_groups] = ACTIONS(2277),
    [sym_keyword_between] = ACTIONS(2277),
    [sym_keyword_preceding] = ACTIONS(2277),
    [sym_keyword_following] = ACTIONS(2277),
    [sym_keyword_unique] = ACTIONS(2277),
    [sym_keyword_references] = ACTIONS(2277),
    [aux_sym_keyword_like_token1] = ACTIONS(2277),
    [aux_sym_keyword_like_token2] = ACTIONS(2277),
    [sym_keyword_similar] = ACTIONS(2277),
    [sym_keyword_check] = ACTIONS(2277),
    [sym_keyword_stored] = ACTIONS(2277),
    [sym_keyword_virtual] = ACTIONS(2277),
    [sym_keyword_comment] = ACTIONS(2277),
    [sym_keyword_null] = ACTIONS(2277),
    [sym_keyword_array] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_RBRACK] = ACTIONS(2277),
    [anon_sym_RPAREN] = ACTIONS(2277),
    [anon_sym_COMMA] = ACTIONS(2277),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(2277),
    [anon_sym_GT_EQ] = ACTIONS(2277),
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_op_other] = ACTIONS(2277),
    [anon_sym_PLUS] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2279),
    [anon_sym_SLASH] = ACTIONS(2279),
    [anon_sym_PERCENT] = ACTIONS(2277),
    [anon_sym_CARET] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(2277),
    [anon_sym_LT_GT] = ACTIONS(2277),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(2099),
    [sym_keyword_from] = ACTIONS(2099),
    [sym_keyword_on] = ACTIONS(2099),
    [sym_keyword_where] = ACTIONS(2099),
    [sym_keyword_desc] = ACTIONS(2099),
    [sym_keyword_asc] = ACTIONS(2099),
    [sym_keyword_limit] = ACTIONS(2099),
    [sym_keyword_primary] = ACTIONS(2099),
    [sym_keyword_create] = ACTIONS(2099),
    [sym_keyword_as] = ACTIONS(2101),
    [sym_keyword_constraint] = ACTIONS(2099),
    [sym_keyword_separator] = ACTIONS(2099),
    [sym_keyword_when] = ACTIONS(2099),
    [sym_keyword_then] = ACTIONS(2099),
    [sym_keyword_else] = ACTIONS(2099),
    [sym_keyword_end] = ACTIONS(2099),
    [sym_keyword_in] = ACTIONS(2099),
    [sym_keyword_and] = ACTIONS(2099),
    [sym_keyword_or] = ACTIONS(2099),
    [sym_keyword_is] = ACTIONS(2099),
    [sym_keyword_not] = ACTIONS(2099),
    [sym_keyword_using] = ACTIONS(2099),
    [sym_keyword_auto_increment] = ACTIONS(2099),
    [sym_keyword_generated] = ACTIONS(2099),
    [sym_keyword_default] = ACTIONS(2099),
    [sym_keyword_returning] = ACTIONS(2099),
    [sym_keyword_first] = ACTIONS(2099),
    [sym_keyword_after] = ACTIONS(2099),
    [sym_keyword_range] = ACTIONS(2099),
    [sym_keyword_rows] = ACTIONS(2099),
    [sym_keyword_groups] = ACTIONS(2099),
    [sym_keyword_between] = ACTIONS(2099),
    [sym_keyword_preceding] = ACTIONS(2099),
    [sym_keyword_following] = ACTIONS(2099),
    [sym_keyword_unique] = ACTIONS(2099),
    [sym_keyword_references] = ACTIONS(2099),
    [aux_sym_keyword_like_token1] = ACTIONS(2099),
    [aux_sym_keyword_like_token2] = ACTIONS(2099),
    [sym_keyword_similar] = ACTIONS(2099),
    [sym_keyword_check] = ACTIONS(2099),
    [sym_keyword_stored] = ACTIONS(2099),
    [sym_keyword_virtual] = ACTIONS(2099),
    [sym_keyword_comment] = ACTIONS(2099),
    [sym_keyword_null] = ACTIONS(2099),
    [sym_keyword_array] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_RBRACK] = ACTIONS(2099),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [anon_sym_COMMA] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2099),
    [anon_sym_STAR] = ACTIONS(2099),
    [anon_sym_COLON_COLON] = ACTIONS(2099),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_LT_EQ] = ACTIONS(2099),
    [anon_sym_GT_EQ] = ACTIONS(2099),
    [anon_sym_COLON] = ACTIONS(2101),
    [sym_op_other] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2099),
    [anon_sym_CARET] = ACTIONS(2101),
    [anon_sym_BANG_EQ] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(2099),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2281),
    [sym_keyword_from] = ACTIONS(2281),
    [sym_keyword_on] = ACTIONS(2281),
    [sym_keyword_where] = ACTIONS(2281),
    [sym_keyword_desc] = ACTIONS(2281),
    [sym_keyword_asc] = ACTIONS(2281),
    [sym_keyword_limit] = ACTIONS(2281),
    [sym_keyword_primary] = ACTIONS(2281),
    [sym_keyword_create] = ACTIONS(2281),
    [sym_keyword_as] = ACTIONS(2283),
    [sym_keyword_constraint] = ACTIONS(2281),
    [sym_keyword_separator] = ACTIONS(2281),
    [sym_keyword_when] = ACTIONS(2281),
    [sym_keyword_then] = ACTIONS(2281),
    [sym_keyword_else] = ACTIONS(2281),
    [sym_keyword_end] = ACTIONS(2281),
    [sym_keyword_in] = ACTIONS(2281),
    [sym_keyword_and] = ACTIONS(2281),
    [sym_keyword_or] = ACTIONS(2281),
    [sym_keyword_is] = ACTIONS(2281),
    [sym_keyword_not] = ACTIONS(2281),
    [sym_keyword_using] = ACTIONS(2281),
    [sym_keyword_auto_increment] = ACTIONS(2281),
    [sym_keyword_generated] = ACTIONS(2281),
    [sym_keyword_default] = ACTIONS(2281),
    [sym_keyword_returning] = ACTIONS(2281),
    [sym_keyword_first] = ACTIONS(2281),
    [sym_keyword_after] = ACTIONS(2281),
    [sym_keyword_range] = ACTIONS(2281),
    [sym_keyword_rows] = ACTIONS(2281),
    [sym_keyword_groups] = ACTIONS(2281),
    [sym_keyword_between] = ACTIONS(2281),
    [sym_keyword_preceding] = ACTIONS(2281),
    [sym_keyword_following] = ACTIONS(2281),
    [sym_keyword_unique] = ACTIONS(2281),
    [sym_keyword_references] = ACTIONS(2281),
    [aux_sym_keyword_like_token1] = ACTIONS(2281),
    [aux_sym_keyword_like_token2] = ACTIONS(2281),
    [sym_keyword_similar] = ACTIONS(2281),
    [sym_keyword_check] = ACTIONS(2281),
    [sym_keyword_stored] = ACTIONS(2281),
    [sym_keyword_virtual] = ACTIONS(2281),
    [sym_keyword_comment] = ACTIONS(2281),
    [sym_keyword_null] = ACTIONS(2281),
    [sym_keyword_array] = ACTIONS(2281),
    [anon_sym_LBRACK] = ACTIONS(2281),
    [anon_sym_RBRACK] = ACTIONS(2281),
    [anon_sym_RPAREN] = ACTIONS(2281),
    [anon_sym_COMMA] = ACTIONS(2281),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2281),
    [anon_sym_STAR] = ACTIONS(2281),
    [anon_sym_COLON_COLON] = ACTIONS(2281),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_LT_EQ] = ACTIONS(2281),
    [anon_sym_GT_EQ] = ACTIONS(2281),
    [anon_sym_COLON] = ACTIONS(2283),
    [sym_op_other] = ACTIONS(2281),
    [anon_sym_PLUS] = ACTIONS(2281),
    [anon_sym_DASH] = ACTIONS(2283),
    [anon_sym_SLASH] = ACTIONS(2283),
    [anon_sym_PERCENT] = ACTIONS(2281),
    [anon_sym_CARET] = ACTIONS(2283),
    [anon_sym_BANG_EQ] = ACTIONS(2281),
    [anon_sym_LT_GT] = ACTIONS(2281),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2004),
    [sym_keyword_from] = ACTIONS(2004),
    [sym_keyword_on] = ACTIONS(2004),
    [sym_keyword_where] = ACTIONS(2004),
    [sym_keyword_desc] = ACTIONS(2004),
    [sym_keyword_asc] = ACTIONS(2004),
    [sym_keyword_limit] = ACTIONS(2004),
    [sym_keyword_primary] = ACTIONS(2004),
    [sym_keyword_create] = ACTIONS(2004),
    [sym_keyword_as] = ACTIONS(2006),
    [sym_keyword_constraint] = ACTIONS(2004),
    [sym_keyword_separator] = ACTIONS(2004),
    [sym_keyword_when] = ACTIONS(2004),
    [sym_keyword_then] = ACTIONS(2004),
    [sym_keyword_else] = ACTIONS(2004),
    [sym_keyword_end] = ACTIONS(2004),
    [sym_keyword_in] = ACTIONS(2004),
    [sym_keyword_and] = ACTIONS(2004),
    [sym_keyword_or] = ACTIONS(2004),
    [sym_keyword_is] = ACTIONS(2004),
    [sym_keyword_not] = ACTIONS(2004),
    [sym_keyword_using] = ACTIONS(2004),
    [sym_keyword_auto_increment] = ACTIONS(2004),
    [sym_keyword_generated] = ACTIONS(2004),
    [sym_keyword_default] = ACTIONS(2004),
    [sym_keyword_returning] = ACTIONS(2004),
    [sym_keyword_first] = ACTIONS(2004),
    [sym_keyword_after] = ACTIONS(2004),
    [sym_keyword_range] = ACTIONS(2004),
    [sym_keyword_rows] = ACTIONS(2004),
    [sym_keyword_groups] = ACTIONS(2004),
    [sym_keyword_between] = ACTIONS(2004),
    [sym_keyword_preceding] = ACTIONS(2004),
    [sym_keyword_following] = ACTIONS(2004),
    [sym_keyword_unique] = ACTIONS(2004),
    [sym_keyword_references] = ACTIONS(2004),
    [aux_sym_keyword_like_token1] = ACTIONS(2004),
    [aux_sym_keyword_like_token2] = ACTIONS(2004),
    [sym_keyword_similar] = ACTIONS(2004),
    [sym_keyword_check] = ACTIONS(2004),
    [sym_keyword_stored] = ACTIONS(2004),
    [sym_keyword_virtual] = ACTIONS(2004),
    [sym_keyword_comment] = ACTIONS(2004),
    [sym_keyword_null] = ACTIONS(2004),
    [sym_keyword_array] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_RBRACK] = ACTIONS(2004),
    [anon_sym_RPAREN] = ACTIONS(2004),
    [anon_sym_COMMA] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2006),
    [anon_sym_LT_EQ] = ACTIONS(2004),
    [anon_sym_GT_EQ] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2006),
    [sym_op_other] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_DASH] = ACTIONS(2006),
    [anon_sym_SLASH] = ACTIONS(2006),
    [anon_sym_PERCENT] = ACTIONS(2004),
    [anon_sym_CARET] = ACTIONS(2006),
    [anon_sym_BANG_EQ] = ACTIONS(2004),
    [anon_sym_LT_GT] = ACTIONS(2004),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2285),
    [sym_keyword_from] = ACTIONS(2285),
    [sym_keyword_on] = ACTIONS(2285),
    [sym_keyword_where] = ACTIONS(2285),
    [sym_keyword_desc] = ACTIONS(2285),
    [sym_keyword_asc] = ACTIONS(2285),
    [sym_keyword_limit] = ACTIONS(2285),
    [sym_keyword_primary] = ACTIONS(2285),
    [sym_keyword_create] = ACTIONS(2285),
    [sym_keyword_as] = ACTIONS(2287),
    [sym_keyword_constraint] = ACTIONS(2285),
    [sym_keyword_separator] = ACTIONS(2285),
    [sym_keyword_when] = ACTIONS(2285),
    [sym_keyword_then] = ACTIONS(2285),
    [sym_keyword_else] = ACTIONS(2285),
    [sym_keyword_end] = ACTIONS(2285),
    [sym_keyword_in] = ACTIONS(2285),
    [sym_keyword_and] = ACTIONS(2285),
    [sym_keyword_or] = ACTIONS(2285),
    [sym_keyword_is] = ACTIONS(2285),
    [sym_keyword_not] = ACTIONS(2285),
    [sym_keyword_using] = ACTIONS(2285),
    [sym_keyword_auto_increment] = ACTIONS(2285),
    [sym_keyword_generated] = ACTIONS(2285),
    [sym_keyword_default] = ACTIONS(2285),
    [sym_keyword_returning] = ACTIONS(2285),
    [sym_keyword_first] = ACTIONS(2285),
    [sym_keyword_after] = ACTIONS(2285),
    [sym_keyword_range] = ACTIONS(2285),
    [sym_keyword_rows] = ACTIONS(2285),
    [sym_keyword_groups] = ACTIONS(2285),
    [sym_keyword_between] = ACTIONS(2285),
    [sym_keyword_preceding] = ACTIONS(2285),
    [sym_keyword_following] = ACTIONS(2285),
    [sym_keyword_unique] = ACTIONS(2285),
    [sym_keyword_references] = ACTIONS(2285),
    [aux_sym_keyword_like_token1] = ACTIONS(2285),
    [aux_sym_keyword_like_token2] = ACTIONS(2285),
    [sym_keyword_similar] = ACTIONS(2285),
    [sym_keyword_check] = ACTIONS(2285),
    [sym_keyword_stored] = ACTIONS(2285),
    [sym_keyword_virtual] = ACTIONS(2285),
    [sym_keyword_comment] = ACTIONS(2285),
    [sym_keyword_null] = ACTIONS(2285),
    [sym_keyword_array] = ACTIONS(2285),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [anon_sym_RPAREN] = ACTIONS(2285),
    [anon_sym_COMMA] = ACTIONS(2285),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2285),
    [anon_sym_STAR] = ACTIONS(2285),
    [anon_sym_COLON_COLON] = ACTIONS(2285),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_LT_EQ] = ACTIONS(2285),
    [anon_sym_GT_EQ] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(2287),
    [sym_op_other] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2285),
    [anon_sym_DASH] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2287),
    [anon_sym_PERCENT] = ACTIONS(2285),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2285),
    [anon_sym_LT_GT] = ACTIONS(2285),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(2289),
    [anon_sym_SEMI] = ACTIONS(2289),
    [sym_keyword_from] = ACTIONS(2289),
    [sym_keyword_on] = ACTIONS(2289),
    [sym_keyword_where] = ACTIONS(2289),
    [sym_keyword_desc] = ACTIONS(2289),
    [sym_keyword_asc] = ACTIONS(2289),
    [sym_keyword_limit] = ACTIONS(2289),
    [sym_keyword_primary] = ACTIONS(2289),
    [sym_keyword_create] = ACTIONS(2289),
    [sym_keyword_as] = ACTIONS(2291),
    [sym_keyword_constraint] = ACTIONS(2289),
    [sym_keyword_separator] = ACTIONS(2289),
    [sym_keyword_when] = ACTIONS(2289),
    [sym_keyword_then] = ACTIONS(2289),
    [sym_keyword_else] = ACTIONS(2289),
    [sym_keyword_end] = ACTIONS(2289),
    [sym_keyword_in] = ACTIONS(2289),
    [sym_keyword_and] = ACTIONS(2289),
    [sym_keyword_or] = ACTIONS(2289),
    [sym_keyword_is] = ACTIONS(2289),
    [sym_keyword_not] = ACTIONS(2289),
    [sym_keyword_using] = ACTIONS(2289),
    [sym_keyword_auto_increment] = ACTIONS(2289),
    [sym_keyword_generated] = ACTIONS(2289),
    [sym_keyword_default] = ACTIONS(2289),
    [sym_keyword_returning] = ACTIONS(2289),
    [sym_keyword_first] = ACTIONS(2289),
    [sym_keyword_after] = ACTIONS(2289),
    [sym_keyword_range] = ACTIONS(2289),
    [sym_keyword_rows] = ACTIONS(2289),
    [sym_keyword_groups] = ACTIONS(2289),
    [sym_keyword_between] = ACTIONS(2289),
    [sym_keyword_preceding] = ACTIONS(2289),
    [sym_keyword_following] = ACTIONS(2289),
    [sym_keyword_unique] = ACTIONS(2289),
    [sym_keyword_references] = ACTIONS(2289),
    [aux_sym_keyword_like_token1] = ACTIONS(2289),
    [aux_sym_keyword_like_token2] = ACTIONS(2289),
    [sym_keyword_similar] = ACTIONS(2289),
    [sym_keyword_check] = ACTIONS(2289),
    [sym_keyword_stored] = ACTIONS(2289),
    [sym_keyword_virtual] = ACTIONS(2289),
    [sym_keyword_comment] = ACTIONS(2289),
    [sym_keyword_null] = ACTIONS(2289),
    [sym_keyword_array] = ACTIONS(2289),
    [anon_sym_LBRACK] = ACTIONS(2289),
    [anon_sym_RBRACK] = ACTIONS(2289),
    [anon_sym_RPAREN] = ACTIONS(2289),
    [anon_sym_COMMA] = ACTIONS(2289),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2289),
    [anon_sym_STAR] = ACTIONS(2289),
    [anon_sym_COLON_COLON] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2289),
    [anon_sym_GT_EQ] = ACTIONS(2289),
    [anon_sym_COLON] = ACTIONS(2291),
    [sym_op_other] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2289),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_SLASH] = ACTIONS(2291),
    [anon_sym_PERCENT] = ACTIONS(2289),
    [anon_sym_CARET] = ACTIONS(2291),
    [anon_sym_BANG_EQ] = ACTIONS(2289),
    [anon_sym_LT_GT] = ACTIONS(2289),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [sym_keyword_from] = ACTIONS(1852),
    [sym_keyword_on] = ACTIONS(1852),
    [sym_keyword_where] = ACTIONS(1852),
    [sym_keyword_desc] = ACTIONS(1852),
    [sym_keyword_asc] = ACTIONS(1852),
    [sym_keyword_limit] = ACTIONS(1852),
    [sym_keyword_primary] = ACTIONS(1852),
    [sym_keyword_create] = ACTIONS(1852),
    [sym_keyword_as] = ACTIONS(1854),
    [sym_keyword_constraint] = ACTIONS(1852),
    [sym_keyword_separator] = ACTIONS(1852),
    [sym_keyword_when] = ACTIONS(1852),
    [sym_keyword_then] = ACTIONS(1852),
    [sym_keyword_else] = ACTIONS(1852),
    [sym_keyword_end] = ACTIONS(1852),
    [sym_keyword_in] = ACTIONS(1852),
    [sym_keyword_and] = ACTIONS(1852),
    [sym_keyword_or] = ACTIONS(1852),
    [sym_keyword_is] = ACTIONS(1852),
    [sym_keyword_not] = ACTIONS(1852),
    [sym_keyword_using] = ACTIONS(1852),
    [sym_keyword_auto_increment] = ACTIONS(1852),
    [sym_keyword_generated] = ACTIONS(1852),
    [sym_keyword_default] = ACTIONS(1852),
    [sym_keyword_returning] = ACTIONS(1852),
    [sym_keyword_first] = ACTIONS(1852),
    [sym_keyword_after] = ACTIONS(1852),
    [sym_keyword_range] = ACTIONS(1852),
    [sym_keyword_rows] = ACTIONS(1852),
    [sym_keyword_groups] = ACTIONS(1852),
    [sym_keyword_between] = ACTIONS(1852),
    [sym_keyword_preceding] = ACTIONS(1852),
    [sym_keyword_following] = ACTIONS(1852),
    [sym_keyword_unique] = ACTIONS(1852),
    [sym_keyword_references] = ACTIONS(1852),
    [aux_sym_keyword_like_token1] = ACTIONS(1852),
    [aux_sym_keyword_like_token2] = ACTIONS(1852),
    [sym_keyword_similar] = ACTIONS(1852),
    [sym_keyword_check] = ACTIONS(1852),
    [sym_keyword_stored] = ACTIONS(1852),
    [sym_keyword_virtual] = ACTIONS(1852),
    [sym_keyword_comment] = ACTIONS(1852),
    [sym_keyword_null] = ACTIONS(1852),
    [sym_keyword_array] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1854),
    [sym_op_other] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1854),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_LT_GT] = ACTIONS(1852),
  },
  [261] = {
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2293),
    [sym_keyword_from] = ACTIONS(2293),
    [sym_keyword_on] = ACTIONS(2293),
    [sym_keyword_where] = ACTIONS(2293),
    [sym_keyword_desc] = ACTIONS(2293),
    [sym_keyword_asc] = ACTIONS(2293),
    [sym_keyword_limit] = ACTIONS(2293),
    [sym_keyword_primary] = ACTIONS(2293),
    [sym_keyword_create] = ACTIONS(2293),
    [sym_keyword_as] = ACTIONS(2295),
    [sym_keyword_constraint] = ACTIONS(2293),
    [sym_keyword_separator] = ACTIONS(2293),
    [sym_keyword_when] = ACTIONS(2293),
    [sym_keyword_then] = ACTIONS(2293),
    [sym_keyword_else] = ACTIONS(2293),
    [sym_keyword_end] = ACTIONS(2293),
    [sym_keyword_in] = ACTIONS(2293),
    [sym_keyword_and] = ACTIONS(2293),
    [sym_keyword_or] = ACTIONS(2293),
    [sym_keyword_is] = ACTIONS(2293),
    [sym_keyword_not] = ACTIONS(2293),
    [sym_keyword_using] = ACTIONS(2293),
    [sym_keyword_auto_increment] = ACTIONS(2293),
    [sym_keyword_generated] = ACTIONS(2293),
    [sym_keyword_default] = ACTIONS(2293),
    [sym_keyword_returning] = ACTIONS(2293),
    [sym_keyword_first] = ACTIONS(2293),
    [sym_keyword_after] = ACTIONS(2293),
    [sym_keyword_range] = ACTIONS(2293),
    [sym_keyword_rows] = ACTIONS(2293),
    [sym_keyword_groups] = ACTIONS(2293),
    [sym_keyword_between] = ACTIONS(2293),
    [sym_keyword_preceding] = ACTIONS(2293),
    [sym_keyword_following] = ACTIONS(2293),
    [sym_keyword_unique] = ACTIONS(2293),
    [sym_keyword_references] = ACTIONS(2293),
    [aux_sym_keyword_like_token1] = ACTIONS(2293),
    [aux_sym_keyword_like_token2] = ACTIONS(2293),
    [sym_keyword_similar] = ACTIONS(2293),
    [sym_keyword_check] = ACTIONS(2293),
    [sym_keyword_stored] = ACTIONS(2293),
    [sym_keyword_virtual] = ACTIONS(2293),
    [sym_keyword_comment] = ACTIONS(2293),
    [sym_keyword_null] = ACTIONS(2293),
    [sym_keyword_array] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2293),
    [anon_sym_STAR] = ACTIONS(2293),
    [anon_sym_COLON_COLON] = ACTIONS(2293),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_LT_EQ] = ACTIONS(2293),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_COLON] = ACTIONS(2295),
    [sym_op_other] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_DASH] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_LT_GT] = ACTIONS(2293),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(2297),
    [anon_sym_SEMI] = ACTIONS(2297),
    [sym_keyword_from] = ACTIONS(2297),
    [sym_keyword_on] = ACTIONS(2297),
    [sym_keyword_where] = ACTIONS(2297),
    [sym_keyword_desc] = ACTIONS(2297),
    [sym_keyword_asc] = ACTIONS(2297),
    [sym_keyword_limit] = ACTIONS(2297),
    [sym_keyword_primary] = ACTIONS(2297),
    [sym_keyword_create] = ACTIONS(2297),
    [sym_keyword_as] = ACTIONS(2299),
    [sym_keyword_constraint] = ACTIONS(2297),
    [sym_keyword_separator] = ACTIONS(2297),
    [sym_keyword_when] = ACTIONS(2297),
    [sym_keyword_then] = ACTIONS(2297),
    [sym_keyword_else] = ACTIONS(2297),
    [sym_keyword_end] = ACTIONS(2297),
    [sym_keyword_in] = ACTIONS(2297),
    [sym_keyword_and] = ACTIONS(2297),
    [sym_keyword_or] = ACTIONS(2297),
    [sym_keyword_is] = ACTIONS(2297),
    [sym_keyword_not] = ACTIONS(2297),
    [sym_keyword_using] = ACTIONS(2297),
    [sym_keyword_auto_increment] = ACTIONS(2297),
    [sym_keyword_generated] = ACTIONS(2297),
    [sym_keyword_default] = ACTIONS(2297),
    [sym_keyword_returning] = ACTIONS(2297),
    [sym_keyword_first] = ACTIONS(2297),
    [sym_keyword_after] = ACTIONS(2297),
    [sym_keyword_range] = ACTIONS(2297),
    [sym_keyword_rows] = ACTIONS(2297),
    [sym_keyword_groups] = ACTIONS(2297),
    [sym_keyword_between] = ACTIONS(2297),
    [sym_keyword_preceding] = ACTIONS(2297),
    [sym_keyword_following] = ACTIONS(2297),
    [sym_keyword_unique] = ACTIONS(2297),
    [sym_keyword_references] = ACTIONS(2297),
    [aux_sym_keyword_like_token1] = ACTIONS(2297),
    [aux_sym_keyword_like_token2] = ACTIONS(2297),
    [sym_keyword_similar] = ACTIONS(2297),
    [sym_keyword_check] = ACTIONS(2297),
    [sym_keyword_stored] = ACTIONS(2297),
    [sym_keyword_virtual] = ACTIONS(2297),
    [sym_keyword_comment] = ACTIONS(2297),
    [sym_keyword_null] = ACTIONS(2297),
    [sym_keyword_array] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2297),
    [anon_sym_RBRACK] = ACTIONS(2297),
    [anon_sym_RPAREN] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2297),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2297),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_COLON_COLON] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2297),
    [anon_sym_GT_EQ] = ACTIONS(2297),
    [anon_sym_COLON] = ACTIONS(2299),
    [sym_op_other] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2297),
    [anon_sym_CARET] = ACTIONS(2299),
    [anon_sym_BANG_EQ] = ACTIONS(2297),
    [anon_sym_LT_GT] = ACTIONS(2297),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [sym_keyword_from] = ACTIONS(2301),
    [sym_keyword_on] = ACTIONS(2301),
    [sym_keyword_where] = ACTIONS(2301),
    [sym_keyword_desc] = ACTIONS(2301),
    [sym_keyword_asc] = ACTIONS(2301),
    [sym_keyword_limit] = ACTIONS(2301),
    [sym_keyword_primary] = ACTIONS(2301),
    [sym_keyword_create] = ACTIONS(2301),
    [sym_keyword_as] = ACTIONS(2303),
    [sym_keyword_constraint] = ACTIONS(2301),
    [sym_keyword_separator] = ACTIONS(2301),
    [sym_keyword_when] = ACTIONS(2301),
    [sym_keyword_then] = ACTIONS(2301),
    [sym_keyword_else] = ACTIONS(2301),
    [sym_keyword_end] = ACTIONS(2301),
    [sym_keyword_in] = ACTIONS(2301),
    [sym_keyword_and] = ACTIONS(2301),
    [sym_keyword_or] = ACTIONS(2301),
    [sym_keyword_is] = ACTIONS(2301),
    [sym_keyword_not] = ACTIONS(2301),
    [sym_keyword_using] = ACTIONS(2301),
    [sym_keyword_auto_increment] = ACTIONS(2301),
    [sym_keyword_generated] = ACTIONS(2301),
    [sym_keyword_default] = ACTIONS(2301),
    [sym_keyword_returning] = ACTIONS(2301),
    [sym_keyword_first] = ACTIONS(2301),
    [sym_keyword_after] = ACTIONS(2301),
    [sym_keyword_range] = ACTIONS(2301),
    [sym_keyword_rows] = ACTIONS(2301),
    [sym_keyword_groups] = ACTIONS(2301),
    [sym_keyword_between] = ACTIONS(2301),
    [sym_keyword_preceding] = ACTIONS(2301),
    [sym_keyword_following] = ACTIONS(2301),
    [sym_keyword_unique] = ACTIONS(2301),
    [sym_keyword_references] = ACTIONS(2301),
    [aux_sym_keyword_like_token1] = ACTIONS(2301),
    [aux_sym_keyword_like_token2] = ACTIONS(2301),
    [sym_keyword_similar] = ACTIONS(2301),
    [sym_keyword_check] = ACTIONS(2301),
    [sym_keyword_stored] = ACTIONS(2301),
    [sym_keyword_virtual] = ACTIONS(2301),
    [sym_keyword_comment] = ACTIONS(2301),
    [sym_keyword_null] = ACTIONS(2301),
    [sym_keyword_array] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2301),
    [anon_sym_COLON_COLON] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_COLON] = ACTIONS(2303),
    [sym_op_other] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2303),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_LT_GT] = ACTIONS(2301),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2032),
    [sym_keyword_from] = ACTIONS(2032),
    [sym_keyword_on] = ACTIONS(2032),
    [sym_keyword_where] = ACTIONS(2032),
    [sym_keyword_desc] = ACTIONS(2032),
    [sym_keyword_asc] = ACTIONS(2032),
    [sym_keyword_limit] = ACTIONS(2032),
    [sym_keyword_primary] = ACTIONS(2032),
    [sym_keyword_create] = ACTIONS(2032),
    [sym_keyword_as] = ACTIONS(2034),
    [sym_keyword_constraint] = ACTIONS(2032),
    [sym_keyword_separator] = ACTIONS(2032),
    [sym_keyword_when] = ACTIONS(2032),
    [sym_keyword_then] = ACTIONS(2032),
    [sym_keyword_else] = ACTIONS(2032),
    [sym_keyword_end] = ACTIONS(2032),
    [sym_keyword_in] = ACTIONS(2032),
    [sym_keyword_and] = ACTIONS(2032),
    [sym_keyword_or] = ACTIONS(2032),
    [sym_keyword_is] = ACTIONS(2032),
    [sym_keyword_not] = ACTIONS(2032),
    [sym_keyword_using] = ACTIONS(2032),
    [sym_keyword_auto_increment] = ACTIONS(2032),
    [sym_keyword_generated] = ACTIONS(2032),
    [sym_keyword_default] = ACTIONS(2032),
    [sym_keyword_returning] = ACTIONS(2032),
    [sym_keyword_first] = ACTIONS(2032),
    [sym_keyword_after] = ACTIONS(2032),
    [sym_keyword_range] = ACTIONS(2032),
    [sym_keyword_rows] = ACTIONS(2032),
    [sym_keyword_groups] = ACTIONS(2032),
    [sym_keyword_between] = ACTIONS(2032),
    [sym_keyword_preceding] = ACTIONS(2032),
    [sym_keyword_following] = ACTIONS(2032),
    [sym_keyword_unique] = ACTIONS(2032),
    [sym_keyword_references] = ACTIONS(2032),
    [aux_sym_keyword_like_token1] = ACTIONS(2032),
    [aux_sym_keyword_like_token2] = ACTIONS(2032),
    [sym_keyword_similar] = ACTIONS(2032),
    [sym_keyword_check] = ACTIONS(2032),
    [sym_keyword_stored] = ACTIONS(2032),
    [sym_keyword_virtual] = ACTIONS(2032),
    [sym_keyword_comment] = ACTIONS(2032),
    [sym_keyword_null] = ACTIONS(2032),
    [sym_keyword_array] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_RBRACK] = ACTIONS(2032),
    [anon_sym_RPAREN] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_GT] = ACTIONS(2034),
    [anon_sym_LT_EQ] = ACTIONS(2032),
    [anon_sym_GT_EQ] = ACTIONS(2032),
    [anon_sym_COLON] = ACTIONS(2034),
    [sym_op_other] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2034),
    [anon_sym_PERCENT] = ACTIONS(2032),
    [anon_sym_CARET] = ACTIONS(2034),
    [anon_sym_BANG_EQ] = ACTIONS(2032),
    [anon_sym_LT_GT] = ACTIONS(2032),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2153),
    [sym_keyword_from] = ACTIONS(2153),
    [sym_keyword_on] = ACTIONS(2153),
    [sym_keyword_where] = ACTIONS(2153),
    [sym_keyword_desc] = ACTIONS(2153),
    [sym_keyword_asc] = ACTIONS(2153),
    [sym_keyword_limit] = ACTIONS(2153),
    [sym_keyword_primary] = ACTIONS(2153),
    [sym_keyword_create] = ACTIONS(2153),
    [sym_keyword_as] = ACTIONS(2155),
    [sym_keyword_constraint] = ACTIONS(2153),
    [sym_keyword_separator] = ACTIONS(2153),
    [sym_keyword_when] = ACTIONS(2153),
    [sym_keyword_then] = ACTIONS(2153),
    [sym_keyword_else] = ACTIONS(2153),
    [sym_keyword_end] = ACTIONS(2153),
    [sym_keyword_in] = ACTIONS(2153),
    [sym_keyword_and] = ACTIONS(2153),
    [sym_keyword_or] = ACTIONS(2153),
    [sym_keyword_is] = ACTIONS(2153),
    [sym_keyword_not] = ACTIONS(2153),
    [sym_keyword_using] = ACTIONS(2153),
    [sym_keyword_auto_increment] = ACTIONS(2153),
    [sym_keyword_generated] = ACTIONS(2153),
    [sym_keyword_default] = ACTIONS(2153),
    [sym_keyword_returning] = ACTIONS(2153),
    [sym_keyword_first] = ACTIONS(2153),
    [sym_keyword_after] = ACTIONS(2153),
    [sym_keyword_range] = ACTIONS(2153),
    [sym_keyword_rows] = ACTIONS(2153),
    [sym_keyword_groups] = ACTIONS(2153),
    [sym_keyword_between] = ACTIONS(2153),
    [sym_keyword_preceding] = ACTIONS(2153),
    [sym_keyword_following] = ACTIONS(2153),
    [sym_keyword_unique] = ACTIONS(2153),
    [sym_keyword_references] = ACTIONS(2153),
    [aux_sym_keyword_like_token1] = ACTIONS(2153),
    [aux_sym_keyword_like_token2] = ACTIONS(2153),
    [sym_keyword_similar] = ACTIONS(2153),
    [sym_keyword_check] = ACTIONS(2153),
    [sym_keyword_stored] = ACTIONS(2153),
    [sym_keyword_virtual] = ACTIONS(2153),
    [sym_keyword_comment] = ACTIONS(2153),
    [sym_keyword_null] = ACTIONS(2153),
    [sym_keyword_array] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2153),
    [anon_sym_RBRACK] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(2155),
    [anon_sym_GT] = ACTIONS(2155),
    [anon_sym_LT_EQ] = ACTIONS(2153),
    [anon_sym_GT_EQ] = ACTIONS(2153),
    [anon_sym_COLON] = ACTIONS(2155),
    [sym_op_other] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_SLASH] = ACTIONS(2155),
    [anon_sym_PERCENT] = ACTIONS(2153),
    [anon_sym_CARET] = ACTIONS(2155),
    [anon_sym_BANG_EQ] = ACTIONS(2153),
    [anon_sym_LT_GT] = ACTIONS(2153),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [sym_keyword_from] = ACTIONS(2305),
    [sym_keyword_on] = ACTIONS(2305),
    [sym_keyword_where] = ACTIONS(2305),
    [sym_keyword_desc] = ACTIONS(2305),
    [sym_keyword_asc] = ACTIONS(2305),
    [sym_keyword_limit] = ACTIONS(2305),
    [sym_keyword_primary] = ACTIONS(2305),
    [sym_keyword_create] = ACTIONS(2305),
    [sym_keyword_as] = ACTIONS(2307),
    [sym_keyword_constraint] = ACTIONS(2305),
    [sym_keyword_separator] = ACTIONS(2305),
    [sym_keyword_when] = ACTIONS(2305),
    [sym_keyword_then] = ACTIONS(2305),
    [sym_keyword_else] = ACTIONS(2305),
    [sym_keyword_end] = ACTIONS(2305),
    [sym_keyword_in] = ACTIONS(2305),
    [sym_keyword_and] = ACTIONS(2305),
    [sym_keyword_or] = ACTIONS(2305),
    [sym_keyword_is] = ACTIONS(2305),
    [sym_keyword_not] = ACTIONS(2305),
    [sym_keyword_using] = ACTIONS(2305),
    [sym_keyword_auto_increment] = ACTIONS(2305),
    [sym_keyword_generated] = ACTIONS(2305),
    [sym_keyword_default] = ACTIONS(2305),
    [sym_keyword_returning] = ACTIONS(2305),
    [sym_keyword_first] = ACTIONS(2305),
    [sym_keyword_after] = ACTIONS(2305),
    [sym_keyword_range] = ACTIONS(2305),
    [sym_keyword_rows] = ACTIONS(2305),
    [sym_keyword_groups] = ACTIONS(2305),
    [sym_keyword_between] = ACTIONS(2305),
    [sym_keyword_preceding] = ACTIONS(2305),
    [sym_keyword_following] = ACTIONS(2305),
    [sym_keyword_unique] = ACTIONS(2305),
    [sym_keyword_references] = ACTIONS(2305),
    [aux_sym_keyword_like_token1] = ACTIONS(2305),
    [aux_sym_keyword_like_token2] = ACTIONS(2305),
    [sym_keyword_similar] = ACTIONS(2305),
    [sym_keyword_check] = ACTIONS(2305),
    [sym_keyword_stored] = ACTIONS(2305),
    [sym_keyword_virtual] = ACTIONS(2305),
    [sym_keyword_comment] = ACTIONS(2305),
    [sym_keyword_null] = ACTIONS(2305),
    [sym_keyword_array] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2305),
    [anon_sym_STAR] = ACTIONS(2305),
    [anon_sym_COLON_COLON] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_COLON] = ACTIONS(2307),
    [sym_op_other] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_LT_GT] = ACTIONS(2305),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2309),
    [sym_keyword_from] = ACTIONS(2309),
    [sym_keyword_on] = ACTIONS(2309),
    [sym_keyword_where] = ACTIONS(2309),
    [sym_keyword_desc] = ACTIONS(2309),
    [sym_keyword_asc] = ACTIONS(2309),
    [sym_keyword_limit] = ACTIONS(2309),
    [sym_keyword_primary] = ACTIONS(2309),
    [sym_keyword_create] = ACTIONS(2309),
    [sym_keyword_as] = ACTIONS(2311),
    [sym_keyword_constraint] = ACTIONS(2309),
    [sym_keyword_separator] = ACTIONS(2309),
    [sym_keyword_when] = ACTIONS(2309),
    [sym_keyword_then] = ACTIONS(2309),
    [sym_keyword_else] = ACTIONS(2309),
    [sym_keyword_end] = ACTIONS(2309),
    [sym_keyword_in] = ACTIONS(2309),
    [sym_keyword_and] = ACTIONS(2309),
    [sym_keyword_or] = ACTIONS(2309),
    [sym_keyword_is] = ACTIONS(2309),
    [sym_keyword_not] = ACTIONS(2309),
    [sym_keyword_using] = ACTIONS(2309),
    [sym_keyword_auto_increment] = ACTIONS(2309),
    [sym_keyword_generated] = ACTIONS(2309),
    [sym_keyword_default] = ACTIONS(2309),
    [sym_keyword_returning] = ACTIONS(2309),
    [sym_keyword_first] = ACTIONS(2309),
    [sym_keyword_after] = ACTIONS(2309),
    [sym_keyword_range] = ACTIONS(2309),
    [sym_keyword_rows] = ACTIONS(2309),
    [sym_keyword_groups] = ACTIONS(2309),
    [sym_keyword_between] = ACTIONS(2309),
    [sym_keyword_preceding] = ACTIONS(2309),
    [sym_keyword_following] = ACTIONS(2309),
    [sym_keyword_unique] = ACTIONS(2309),
    [sym_keyword_references] = ACTIONS(2309),
    [aux_sym_keyword_like_token1] = ACTIONS(2309),
    [aux_sym_keyword_like_token2] = ACTIONS(2309),
    [sym_keyword_similar] = ACTIONS(2309),
    [sym_keyword_check] = ACTIONS(2309),
    [sym_keyword_stored] = ACTIONS(2309),
    [sym_keyword_virtual] = ACTIONS(2309),
    [sym_keyword_comment] = ACTIONS(2309),
    [sym_keyword_null] = ACTIONS(2309),
    [sym_keyword_array] = ACTIONS(2309),
    [anon_sym_LBRACK] = ACTIONS(2309),
    [anon_sym_RBRACK] = ACTIONS(2309),
    [anon_sym_RPAREN] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2309),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_STAR] = ACTIONS(2309),
    [anon_sym_COLON_COLON] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_COLON] = ACTIONS(2311),
    [sym_op_other] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_DASH] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2311),
    [anon_sym_PERCENT] = ACTIONS(2309),
    [anon_sym_CARET] = ACTIONS(2311),
    [anon_sym_BANG_EQ] = ACTIONS(2309),
    [anon_sym_LT_GT] = ACTIONS(2309),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2313),
    [sym_keyword_from] = ACTIONS(2313),
    [sym_keyword_on] = ACTIONS(2313),
    [sym_keyword_where] = ACTIONS(2313),
    [sym_keyword_desc] = ACTIONS(2313),
    [sym_keyword_asc] = ACTIONS(2313),
    [sym_keyword_limit] = ACTIONS(2313),
    [sym_keyword_primary] = ACTIONS(2313),
    [sym_keyword_create] = ACTIONS(2313),
    [sym_keyword_as] = ACTIONS(2315),
    [sym_keyword_constraint] = ACTIONS(2313),
    [sym_keyword_separator] = ACTIONS(2313),
    [sym_keyword_when] = ACTIONS(2313),
    [sym_keyword_then] = ACTIONS(2313),
    [sym_keyword_else] = ACTIONS(2313),
    [sym_keyword_end] = ACTIONS(2313),
    [sym_keyword_in] = ACTIONS(2313),
    [sym_keyword_and] = ACTIONS(2313),
    [sym_keyword_or] = ACTIONS(2313),
    [sym_keyword_is] = ACTIONS(2313),
    [sym_keyword_not] = ACTIONS(2313),
    [sym_keyword_using] = ACTIONS(2313),
    [sym_keyword_auto_increment] = ACTIONS(2313),
    [sym_keyword_generated] = ACTIONS(2313),
    [sym_keyword_default] = ACTIONS(2313),
    [sym_keyword_returning] = ACTIONS(2313),
    [sym_keyword_first] = ACTIONS(2313),
    [sym_keyword_after] = ACTIONS(2313),
    [sym_keyword_range] = ACTIONS(2313),
    [sym_keyword_rows] = ACTIONS(2313),
    [sym_keyword_groups] = ACTIONS(2313),
    [sym_keyword_between] = ACTIONS(2313),
    [sym_keyword_preceding] = ACTIONS(2313),
    [sym_keyword_following] = ACTIONS(2313),
    [sym_keyword_unique] = ACTIONS(2313),
    [sym_keyword_references] = ACTIONS(2313),
    [aux_sym_keyword_like_token1] = ACTIONS(2313),
    [aux_sym_keyword_like_token2] = ACTIONS(2313),
    [sym_keyword_similar] = ACTIONS(2313),
    [sym_keyword_check] = ACTIONS(2313),
    [sym_keyword_stored] = ACTIONS(2313),
    [sym_keyword_virtual] = ACTIONS(2313),
    [sym_keyword_comment] = ACTIONS(2313),
    [sym_keyword_null] = ACTIONS(2313),
    [sym_keyword_array] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2313),
    [anon_sym_RBRACK] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2313),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2313),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_COLON_COLON] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_LT_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2313),
    [anon_sym_COLON] = ACTIONS(2315),
    [sym_op_other] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_SLASH] = ACTIONS(2315),
    [anon_sym_PERCENT] = ACTIONS(2313),
    [anon_sym_CARET] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_LT_GT] = ACTIONS(2313),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(2317),
    [anon_sym_SEMI] = ACTIONS(2317),
    [sym_keyword_from] = ACTIONS(2317),
    [sym_keyword_on] = ACTIONS(2317),
    [sym_keyword_where] = ACTIONS(2317),
    [sym_keyword_desc] = ACTIONS(2317),
    [sym_keyword_asc] = ACTIONS(2317),
    [sym_keyword_limit] = ACTIONS(2317),
    [sym_keyword_primary] = ACTIONS(2317),
    [sym_keyword_create] = ACTIONS(2317),
    [sym_keyword_as] = ACTIONS(2319),
    [sym_keyword_constraint] = ACTIONS(2317),
    [sym_keyword_separator] = ACTIONS(2317),
    [sym_keyword_when] = ACTIONS(2317),
    [sym_keyword_then] = ACTIONS(2317),
    [sym_keyword_else] = ACTIONS(2317),
    [sym_keyword_end] = ACTIONS(2317),
    [sym_keyword_in] = ACTIONS(2317),
    [sym_keyword_and] = ACTIONS(2317),
    [sym_keyword_or] = ACTIONS(2317),
    [sym_keyword_is] = ACTIONS(2317),
    [sym_keyword_not] = ACTIONS(2317),
    [sym_keyword_using] = ACTIONS(2317),
    [sym_keyword_auto_increment] = ACTIONS(2317),
    [sym_keyword_generated] = ACTIONS(2317),
    [sym_keyword_default] = ACTIONS(2317),
    [sym_keyword_returning] = ACTIONS(2317),
    [sym_keyword_first] = ACTIONS(2317),
    [sym_keyword_after] = ACTIONS(2317),
    [sym_keyword_range] = ACTIONS(2317),
    [sym_keyword_rows] = ACTIONS(2317),
    [sym_keyword_groups] = ACTIONS(2317),
    [sym_keyword_between] = ACTIONS(2317),
    [sym_keyword_preceding] = ACTIONS(2317),
    [sym_keyword_following] = ACTIONS(2317),
    [sym_keyword_unique] = ACTIONS(2317),
    [sym_keyword_references] = ACTIONS(2317),
    [aux_sym_keyword_like_token1] = ACTIONS(2317),
    [aux_sym_keyword_like_token2] = ACTIONS(2317),
    [sym_keyword_similar] = ACTIONS(2317),
    [sym_keyword_check] = ACTIONS(2317),
    [sym_keyword_stored] = ACTIONS(2317),
    [sym_keyword_virtual] = ACTIONS(2317),
    [sym_keyword_comment] = ACTIONS(2317),
    [sym_keyword_null] = ACTIONS(2317),
    [sym_keyword_array] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2317),
    [anon_sym_RBRACK] = ACTIONS(2317),
    [anon_sym_RPAREN] = ACTIONS(2317),
    [anon_sym_COMMA] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2317),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_COLON_COLON] = ACTIONS(2317),
    [anon_sym_LT] = ACTIONS(2319),
    [anon_sym_GT] = ACTIONS(2319),
    [anon_sym_LT_EQ] = ACTIONS(2317),
    [anon_sym_GT_EQ] = ACTIONS(2317),
    [anon_sym_COLON] = ACTIONS(2319),
    [sym_op_other] = ACTIONS(2317),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2317),
    [anon_sym_CARET] = ACTIONS(2319),
    [anon_sym_BANG_EQ] = ACTIONS(2317),
    [anon_sym_LT_GT] = ACTIONS(2317),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2321),
    [sym_keyword_from] = ACTIONS(2321),
    [sym_keyword_on] = ACTIONS(2321),
    [sym_keyword_where] = ACTIONS(2321),
    [sym_keyword_desc] = ACTIONS(2321),
    [sym_keyword_asc] = ACTIONS(2321),
    [sym_keyword_limit] = ACTIONS(2321),
    [sym_keyword_primary] = ACTIONS(2321),
    [sym_keyword_create] = ACTIONS(2321),
    [sym_keyword_as] = ACTIONS(2323),
    [sym_keyword_constraint] = ACTIONS(2321),
    [sym_keyword_separator] = ACTIONS(2321),
    [sym_keyword_when] = ACTIONS(2321),
    [sym_keyword_then] = ACTIONS(2321),
    [sym_keyword_else] = ACTIONS(2321),
    [sym_keyword_end] = ACTIONS(2321),
    [sym_keyword_in] = ACTIONS(2321),
    [sym_keyword_and] = ACTIONS(2321),
    [sym_keyword_or] = ACTIONS(2321),
    [sym_keyword_is] = ACTIONS(2321),
    [sym_keyword_not] = ACTIONS(2321),
    [sym_keyword_using] = ACTIONS(2321),
    [sym_keyword_auto_increment] = ACTIONS(2321),
    [sym_keyword_generated] = ACTIONS(2321),
    [sym_keyword_default] = ACTIONS(2321),
    [sym_keyword_returning] = ACTIONS(2321),
    [sym_keyword_first] = ACTIONS(2321),
    [sym_keyword_after] = ACTIONS(2321),
    [sym_keyword_range] = ACTIONS(2321),
    [sym_keyword_rows] = ACTIONS(2321),
    [sym_keyword_groups] = ACTIONS(2321),
    [sym_keyword_between] = ACTIONS(2321),
    [sym_keyword_preceding] = ACTIONS(2321),
    [sym_keyword_following] = ACTIONS(2321),
    [sym_keyword_unique] = ACTIONS(2321),
    [sym_keyword_references] = ACTIONS(2321),
    [aux_sym_keyword_like_token1] = ACTIONS(2321),
    [aux_sym_keyword_like_token2] = ACTIONS(2321),
    [sym_keyword_similar] = ACTIONS(2321),
    [sym_keyword_check] = ACTIONS(2321),
    [sym_keyword_stored] = ACTIONS(2321),
    [sym_keyword_virtual] = ACTIONS(2321),
    [sym_keyword_comment] = ACTIONS(2321),
    [sym_keyword_null] = ACTIONS(2321),
    [sym_keyword_array] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_RBRACK] = ACTIONS(2321),
    [anon_sym_RPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2321),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2323),
    [anon_sym_LT_EQ] = ACTIONS(2321),
    [anon_sym_GT_EQ] = ACTIONS(2321),
    [anon_sym_COLON] = ACTIONS(2323),
    [sym_op_other] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_SLASH] = ACTIONS(2323),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_CARET] = ACTIONS(2323),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_LT_GT] = ACTIONS(2321),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2325),
    [sym_keyword_from] = ACTIONS(2325),
    [sym_keyword_on] = ACTIONS(2325),
    [sym_keyword_where] = ACTIONS(2325),
    [sym_keyword_desc] = ACTIONS(2325),
    [sym_keyword_asc] = ACTIONS(2325),
    [sym_keyword_limit] = ACTIONS(2325),
    [sym_keyword_primary] = ACTIONS(2325),
    [sym_keyword_create] = ACTIONS(2325),
    [sym_keyword_as] = ACTIONS(2327),
    [sym_keyword_constraint] = ACTIONS(2325),
    [sym_keyword_separator] = ACTIONS(2325),
    [sym_keyword_when] = ACTIONS(2325),
    [sym_keyword_then] = ACTIONS(2325),
    [sym_keyword_else] = ACTIONS(2325),
    [sym_keyword_end] = ACTIONS(2325),
    [sym_keyword_in] = ACTIONS(2325),
    [sym_keyword_and] = ACTIONS(2325),
    [sym_keyword_or] = ACTIONS(2325),
    [sym_keyword_is] = ACTIONS(2325),
    [sym_keyword_not] = ACTIONS(2325),
    [sym_keyword_using] = ACTIONS(2325),
    [sym_keyword_auto_increment] = ACTIONS(2325),
    [sym_keyword_generated] = ACTIONS(2325),
    [sym_keyword_default] = ACTIONS(2325),
    [sym_keyword_returning] = ACTIONS(2325),
    [sym_keyword_first] = ACTIONS(2325),
    [sym_keyword_after] = ACTIONS(2325),
    [sym_keyword_range] = ACTIONS(2325),
    [sym_keyword_rows] = ACTIONS(2325),
    [sym_keyword_groups] = ACTIONS(2325),
    [sym_keyword_between] = ACTIONS(2325),
    [sym_keyword_preceding] = ACTIONS(2325),
    [sym_keyword_following] = ACTIONS(2325),
    [sym_keyword_unique] = ACTIONS(2325),
    [sym_keyword_references] = ACTIONS(2325),
    [aux_sym_keyword_like_token1] = ACTIONS(2325),
    [aux_sym_keyword_like_token2] = ACTIONS(2325),
    [sym_keyword_similar] = ACTIONS(2325),
    [sym_keyword_check] = ACTIONS(2325),
    [sym_keyword_stored] = ACTIONS(2325),
    [sym_keyword_virtual] = ACTIONS(2325),
    [sym_keyword_comment] = ACTIONS(2325),
    [sym_keyword_null] = ACTIONS(2325),
    [sym_keyword_array] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(2325),
    [anon_sym_RBRACK] = ACTIONS(2325),
    [anon_sym_RPAREN] = ACTIONS(2325),
    [anon_sym_COMMA] = ACTIONS(2325),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2325),
    [anon_sym_STAR] = ACTIONS(2325),
    [anon_sym_COLON_COLON] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_GT] = ACTIONS(2327),
    [anon_sym_LT_EQ] = ACTIONS(2325),
    [anon_sym_GT_EQ] = ACTIONS(2325),
    [anon_sym_COLON] = ACTIONS(2327),
    [sym_op_other] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(2325),
    [anon_sym_DASH] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2327),
    [anon_sym_PERCENT] = ACTIONS(2325),
    [anon_sym_CARET] = ACTIONS(2327),
    [anon_sym_BANG_EQ] = ACTIONS(2325),
    [anon_sym_LT_GT] = ACTIONS(2325),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2329),
    [sym_keyword_from] = ACTIONS(2329),
    [sym_keyword_on] = ACTIONS(2329),
    [sym_keyword_where] = ACTIONS(2329),
    [sym_keyword_desc] = ACTIONS(2329),
    [sym_keyword_asc] = ACTIONS(2329),
    [sym_keyword_limit] = ACTIONS(2329),
    [sym_keyword_primary] = ACTIONS(2329),
    [sym_keyword_create] = ACTIONS(2329),
    [sym_keyword_as] = ACTIONS(2331),
    [sym_keyword_constraint] = ACTIONS(2329),
    [sym_keyword_separator] = ACTIONS(2329),
    [sym_keyword_when] = ACTIONS(2329),
    [sym_keyword_then] = ACTIONS(2329),
    [sym_keyword_else] = ACTIONS(2329),
    [sym_keyword_end] = ACTIONS(2329),
    [sym_keyword_in] = ACTIONS(2329),
    [sym_keyword_and] = ACTIONS(2329),
    [sym_keyword_or] = ACTIONS(2329),
    [sym_keyword_is] = ACTIONS(2329),
    [sym_keyword_not] = ACTIONS(2329),
    [sym_keyword_using] = ACTIONS(2329),
    [sym_keyword_auto_increment] = ACTIONS(2329),
    [sym_keyword_generated] = ACTIONS(2329),
    [sym_keyword_default] = ACTIONS(2329),
    [sym_keyword_returning] = ACTIONS(2329),
    [sym_keyword_first] = ACTIONS(2329),
    [sym_keyword_after] = ACTIONS(2329),
    [sym_keyword_range] = ACTIONS(2329),
    [sym_keyword_rows] = ACTIONS(2329),
    [sym_keyword_groups] = ACTIONS(2329),
    [sym_keyword_between] = ACTIONS(2329),
    [sym_keyword_preceding] = ACTIONS(2329),
    [sym_keyword_following] = ACTIONS(2329),
    [sym_keyword_unique] = ACTIONS(2329),
    [sym_keyword_references] = ACTIONS(2329),
    [aux_sym_keyword_like_token1] = ACTIONS(2329),
    [aux_sym_keyword_like_token2] = ACTIONS(2329),
    [sym_keyword_similar] = ACTIONS(2329),
    [sym_keyword_check] = ACTIONS(2329),
    [sym_keyword_stored] = ACTIONS(2329),
    [sym_keyword_virtual] = ACTIONS(2329),
    [sym_keyword_comment] = ACTIONS(2329),
    [sym_keyword_null] = ACTIONS(2329),
    [sym_keyword_array] = ACTIONS(2329),
    [anon_sym_LBRACK] = ACTIONS(2329),
    [anon_sym_RBRACK] = ACTIONS(2329),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [anon_sym_COMMA] = ACTIONS(2329),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(2329),
    [anon_sym_COLON_COLON] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(2331),
    [anon_sym_GT] = ACTIONS(2331),
    [anon_sym_LT_EQ] = ACTIONS(2329),
    [anon_sym_GT_EQ] = ACTIONS(2329),
    [anon_sym_COLON] = ACTIONS(2331),
    [sym_op_other] = ACTIONS(2329),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_DASH] = ACTIONS(2331),
    [anon_sym_SLASH] = ACTIONS(2331),
    [anon_sym_PERCENT] = ACTIONS(2329),
    [anon_sym_CARET] = ACTIONS(2331),
    [anon_sym_BANG_EQ] = ACTIONS(2329),
    [anon_sym_LT_GT] = ACTIONS(2329),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2038),
    [sym_keyword_from] = ACTIONS(2038),
    [sym_keyword_on] = ACTIONS(2038),
    [sym_keyword_where] = ACTIONS(2038),
    [sym_keyword_desc] = ACTIONS(2038),
    [sym_keyword_asc] = ACTIONS(2038),
    [sym_keyword_limit] = ACTIONS(2038),
    [sym_keyword_primary] = ACTIONS(2038),
    [sym_keyword_create] = ACTIONS(2038),
    [sym_keyword_as] = ACTIONS(2040),
    [sym_keyword_constraint] = ACTIONS(2038),
    [sym_keyword_separator] = ACTIONS(2038),
    [sym_keyword_when] = ACTIONS(2038),
    [sym_keyword_then] = ACTIONS(2038),
    [sym_keyword_else] = ACTIONS(2038),
    [sym_keyword_end] = ACTIONS(2038),
    [sym_keyword_in] = ACTIONS(2038),
    [sym_keyword_and] = ACTIONS(2038),
    [sym_keyword_or] = ACTIONS(2038),
    [sym_keyword_is] = ACTIONS(2038),
    [sym_keyword_not] = ACTIONS(2038),
    [sym_keyword_using] = ACTIONS(2038),
    [sym_keyword_auto_increment] = ACTIONS(2038),
    [sym_keyword_generated] = ACTIONS(2038),
    [sym_keyword_default] = ACTIONS(2038),
    [sym_keyword_returning] = ACTIONS(2038),
    [sym_keyword_first] = ACTIONS(2038),
    [sym_keyword_after] = ACTIONS(2038),
    [sym_keyword_range] = ACTIONS(2038),
    [sym_keyword_rows] = ACTIONS(2038),
    [sym_keyword_groups] = ACTIONS(2038),
    [sym_keyword_between] = ACTIONS(2038),
    [sym_keyword_preceding] = ACTIONS(2038),
    [sym_keyword_following] = ACTIONS(2038),
    [sym_keyword_unique] = ACTIONS(2038),
    [sym_keyword_references] = ACTIONS(2038),
    [aux_sym_keyword_like_token1] = ACTIONS(2038),
    [aux_sym_keyword_like_token2] = ACTIONS(2038),
    [sym_keyword_similar] = ACTIONS(2038),
    [sym_keyword_check] = ACTIONS(2038),
    [sym_keyword_stored] = ACTIONS(2038),
    [sym_keyword_virtual] = ACTIONS(2038),
    [sym_keyword_comment] = ACTIONS(2038),
    [sym_keyword_null] = ACTIONS(2038),
    [sym_keyword_array] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_RBRACK] = ACTIONS(2038),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [anon_sym_COMMA] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2040),
    [anon_sym_GT] = ACTIONS(2040),
    [anon_sym_LT_EQ] = ACTIONS(2038),
    [anon_sym_GT_EQ] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2040),
    [sym_op_other] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(2040),
    [anon_sym_PERCENT] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(2040),
    [anon_sym_BANG_EQ] = ACTIONS(2038),
    [anon_sym_LT_GT] = ACTIONS(2038),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(2333),
    [anon_sym_SEMI] = ACTIONS(2333),
    [sym_keyword_from] = ACTIONS(2333),
    [sym_keyword_on] = ACTIONS(2333),
    [sym_keyword_where] = ACTIONS(2333),
    [sym_keyword_desc] = ACTIONS(2333),
    [sym_keyword_asc] = ACTIONS(2333),
    [sym_keyword_limit] = ACTIONS(2333),
    [sym_keyword_primary] = ACTIONS(2333),
    [sym_keyword_create] = ACTIONS(2333),
    [sym_keyword_as] = ACTIONS(2335),
    [sym_keyword_constraint] = ACTIONS(2333),
    [sym_keyword_separator] = ACTIONS(2333),
    [sym_keyword_when] = ACTIONS(2333),
    [sym_keyword_then] = ACTIONS(2333),
    [sym_keyword_else] = ACTIONS(2333),
    [sym_keyword_end] = ACTIONS(2333),
    [sym_keyword_in] = ACTIONS(2333),
    [sym_keyword_and] = ACTIONS(2333),
    [sym_keyword_or] = ACTIONS(2333),
    [sym_keyword_is] = ACTIONS(2333),
    [sym_keyword_not] = ACTIONS(2333),
    [sym_keyword_using] = ACTIONS(2333),
    [sym_keyword_auto_increment] = ACTIONS(2333),
    [sym_keyword_generated] = ACTIONS(2333),
    [sym_keyword_default] = ACTIONS(2333),
    [sym_keyword_returning] = ACTIONS(2333),
    [sym_keyword_first] = ACTIONS(2333),
    [sym_keyword_after] = ACTIONS(2333),
    [sym_keyword_range] = ACTIONS(2333),
    [sym_keyword_rows] = ACTIONS(2333),
    [sym_keyword_groups] = ACTIONS(2333),
    [sym_keyword_between] = ACTIONS(2333),
    [sym_keyword_preceding] = ACTIONS(2333),
    [sym_keyword_following] = ACTIONS(2333),
    [sym_keyword_unique] = ACTIONS(2333),
    [sym_keyword_references] = ACTIONS(2333),
    [aux_sym_keyword_like_token1] = ACTIONS(2333),
    [aux_sym_keyword_like_token2] = ACTIONS(2333),
    [sym_keyword_similar] = ACTIONS(2333),
    [sym_keyword_check] = ACTIONS(2333),
    [sym_keyword_stored] = ACTIONS(2333),
    [sym_keyword_virtual] = ACTIONS(2333),
    [sym_keyword_comment] = ACTIONS(2333),
    [sym_keyword_null] = ACTIONS(2333),
    [sym_keyword_array] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2333),
    [anon_sym_RBRACK] = ACTIONS(2333),
    [anon_sym_RPAREN] = ACTIONS(2333),
    [anon_sym_COMMA] = ACTIONS(2333),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2333),
    [anon_sym_STAR] = ACTIONS(2333),
    [anon_sym_COLON_COLON] = ACTIONS(2333),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_GT] = ACTIONS(2335),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_COLON] = ACTIONS(2335),
    [sym_op_other] = ACTIONS(2333),
    [anon_sym_PLUS] = ACTIONS(2333),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(2333),
    [anon_sym_CARET] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(2333),
    [anon_sym_LT_GT] = ACTIONS(2333),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(2010),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_keyword_from] = ACTIONS(2010),
    [sym_keyword_on] = ACTIONS(2010),
    [sym_keyword_where] = ACTIONS(2010),
    [sym_keyword_desc] = ACTIONS(2010),
    [sym_keyword_asc] = ACTIONS(2010),
    [sym_keyword_limit] = ACTIONS(2010),
    [sym_keyword_primary] = ACTIONS(2010),
    [sym_keyword_create] = ACTIONS(2010),
    [sym_keyword_as] = ACTIONS(2012),
    [sym_keyword_constraint] = ACTIONS(2010),
    [sym_keyword_separator] = ACTIONS(2010),
    [sym_keyword_when] = ACTIONS(2010),
    [sym_keyword_then] = ACTIONS(2010),
    [sym_keyword_else] = ACTIONS(2010),
    [sym_keyword_end] = ACTIONS(2010),
    [sym_keyword_in] = ACTIONS(2010),
    [sym_keyword_and] = ACTIONS(2010),
    [sym_keyword_or] = ACTIONS(2010),
    [sym_keyword_is] = ACTIONS(2010),
    [sym_keyword_not] = ACTIONS(2010),
    [sym_keyword_using] = ACTIONS(2010),
    [sym_keyword_auto_increment] = ACTIONS(2010),
    [sym_keyword_generated] = ACTIONS(2010),
    [sym_keyword_default] = ACTIONS(2010),
    [sym_keyword_returning] = ACTIONS(2010),
    [sym_keyword_first] = ACTIONS(2010),
    [sym_keyword_after] = ACTIONS(2010),
    [sym_keyword_range] = ACTIONS(2010),
    [sym_keyword_rows] = ACTIONS(2010),
    [sym_keyword_groups] = ACTIONS(2010),
    [sym_keyword_between] = ACTIONS(2010),
    [sym_keyword_preceding] = ACTIONS(2010),
    [sym_keyword_following] = ACTIONS(2010),
    [sym_keyword_unique] = ACTIONS(2010),
    [sym_keyword_references] = ACTIONS(2010),
    [aux_sym_keyword_like_token1] = ACTIONS(2010),
    [aux_sym_keyword_like_token2] = ACTIONS(2010),
    [sym_keyword_similar] = ACTIONS(2010),
    [sym_keyword_check] = ACTIONS(2010),
    [sym_keyword_stored] = ACTIONS(2010),
    [sym_keyword_virtual] = ACTIONS(2010),
    [sym_keyword_comment] = ACTIONS(2010),
    [sym_keyword_null] = ACTIONS(2010),
    [sym_keyword_array] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_COMMA] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2010),
    [anon_sym_GT_EQ] = ACTIONS(2010),
    [anon_sym_COLON] = ACTIONS(2012),
    [sym_op_other] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2010),
    [anon_sym_CARET] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2010),
    [anon_sym_LT_GT] = ACTIONS(2010),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2016),
    [sym_keyword_from] = ACTIONS(2016),
    [sym_keyword_on] = ACTIONS(2016),
    [sym_keyword_where] = ACTIONS(2016),
    [sym_keyword_desc] = ACTIONS(2016),
    [sym_keyword_asc] = ACTIONS(2016),
    [sym_keyword_limit] = ACTIONS(2016),
    [sym_keyword_primary] = ACTIONS(2016),
    [sym_keyword_create] = ACTIONS(2016),
    [sym_keyword_as] = ACTIONS(2018),
    [sym_keyword_constraint] = ACTIONS(2016),
    [sym_keyword_separator] = ACTIONS(2016),
    [sym_keyword_when] = ACTIONS(2016),
    [sym_keyword_then] = ACTIONS(2016),
    [sym_keyword_else] = ACTIONS(2016),
    [sym_keyword_end] = ACTIONS(2016),
    [sym_keyword_in] = ACTIONS(2016),
    [sym_keyword_and] = ACTIONS(2016),
    [sym_keyword_or] = ACTIONS(2016),
    [sym_keyword_is] = ACTIONS(2016),
    [sym_keyword_not] = ACTIONS(2016),
    [sym_keyword_using] = ACTIONS(2016),
    [sym_keyword_auto_increment] = ACTIONS(2016),
    [sym_keyword_generated] = ACTIONS(2016),
    [sym_keyword_default] = ACTIONS(2016),
    [sym_keyword_returning] = ACTIONS(2016),
    [sym_keyword_first] = ACTIONS(2016),
    [sym_keyword_after] = ACTIONS(2016),
    [sym_keyword_range] = ACTIONS(2016),
    [sym_keyword_rows] = ACTIONS(2016),
    [sym_keyword_groups] = ACTIONS(2016),
    [sym_keyword_between] = ACTIONS(2016),
    [sym_keyword_preceding] = ACTIONS(2016),
    [sym_keyword_following] = ACTIONS(2016),
    [sym_keyword_unique] = ACTIONS(2016),
    [sym_keyword_references] = ACTIONS(2016),
    [aux_sym_keyword_like_token1] = ACTIONS(2016),
    [aux_sym_keyword_like_token2] = ACTIONS(2016),
    [sym_keyword_similar] = ACTIONS(2016),
    [sym_keyword_check] = ACTIONS(2016),
    [sym_keyword_stored] = ACTIONS(2016),
    [sym_keyword_virtual] = ACTIONS(2016),
    [sym_keyword_comment] = ACTIONS(2016),
    [sym_keyword_null] = ACTIONS(2016),
    [sym_keyword_array] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_RBRACK] = ACTIONS(2016),
    [anon_sym_RPAREN] = ACTIONS(2016),
    [anon_sym_COMMA] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_LT_EQ] = ACTIONS(2016),
    [anon_sym_GT_EQ] = ACTIONS(2016),
    [anon_sym_COLON] = ACTIONS(2018),
    [sym_op_other] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_SLASH] = ACTIONS(2018),
    [anon_sym_PERCENT] = ACTIONS(2016),
    [anon_sym_CARET] = ACTIONS(2018),
    [anon_sym_BANG_EQ] = ACTIONS(2016),
    [anon_sym_LT_GT] = ACTIONS(2016),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(2337),
    [sym_keyword_from] = ACTIONS(2337),
    [sym_keyword_on] = ACTIONS(2337),
    [sym_keyword_where] = ACTIONS(2337),
    [sym_keyword_desc] = ACTIONS(2337),
    [sym_keyword_asc] = ACTIONS(2337),
    [sym_keyword_limit] = ACTIONS(2337),
    [sym_keyword_primary] = ACTIONS(2337),
    [sym_keyword_create] = ACTIONS(2337),
    [sym_keyword_as] = ACTIONS(2339),
    [sym_keyword_constraint] = ACTIONS(2337),
    [sym_keyword_separator] = ACTIONS(2337),
    [sym_keyword_when] = ACTIONS(2337),
    [sym_keyword_then] = ACTIONS(2337),
    [sym_keyword_else] = ACTIONS(2337),
    [sym_keyword_end] = ACTIONS(2337),
    [sym_keyword_in] = ACTIONS(2337),
    [sym_keyword_and] = ACTIONS(2337),
    [sym_keyword_or] = ACTIONS(2337),
    [sym_keyword_is] = ACTIONS(2337),
    [sym_keyword_not] = ACTIONS(2337),
    [sym_keyword_using] = ACTIONS(2337),
    [sym_keyword_auto_increment] = ACTIONS(2337),
    [sym_keyword_generated] = ACTIONS(2337),
    [sym_keyword_default] = ACTIONS(2337),
    [sym_keyword_returning] = ACTIONS(2337),
    [sym_keyword_first] = ACTIONS(2337),
    [sym_keyword_after] = ACTIONS(2337),
    [sym_keyword_range] = ACTIONS(2337),
    [sym_keyword_rows] = ACTIONS(2337),
    [sym_keyword_groups] = ACTIONS(2337),
    [sym_keyword_between] = ACTIONS(2337),
    [sym_keyword_preceding] = ACTIONS(2337),
    [sym_keyword_following] = ACTIONS(2337),
    [sym_keyword_unique] = ACTIONS(2337),
    [sym_keyword_references] = ACTIONS(2337),
    [aux_sym_keyword_like_token1] = ACTIONS(2337),
    [aux_sym_keyword_like_token2] = ACTIONS(2337),
    [sym_keyword_similar] = ACTIONS(2337),
    [sym_keyword_check] = ACTIONS(2337),
    [sym_keyword_stored] = ACTIONS(2337),
    [sym_keyword_virtual] = ACTIONS(2337),
    [sym_keyword_comment] = ACTIONS(2337),
    [sym_keyword_null] = ACTIONS(2337),
    [sym_keyword_array] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_RBRACK] = ACTIONS(2337),
    [anon_sym_RPAREN] = ACTIONS(2337),
    [anon_sym_COMMA] = ACTIONS(2337),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2337),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_COLON_COLON] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(2339),
    [anon_sym_GT] = ACTIONS(2339),
    [anon_sym_LT_EQ] = ACTIONS(2337),
    [anon_sym_GT_EQ] = ACTIONS(2337),
    [anon_sym_COLON] = ACTIONS(2339),
    [sym_op_other] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_DASH] = ACTIONS(2339),
    [anon_sym_SLASH] = ACTIONS(2339),
    [anon_sym_PERCENT] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(2337),
    [anon_sym_LT_GT] = ACTIONS(2337),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(2341),
    [anon_sym_SEMI] = ACTIONS(2341),
    [sym_keyword_from] = ACTIONS(2341),
    [sym_keyword_on] = ACTIONS(2341),
    [sym_keyword_where] = ACTIONS(2341),
    [sym_keyword_desc] = ACTIONS(2341),
    [sym_keyword_asc] = ACTIONS(2341),
    [sym_keyword_limit] = ACTIONS(2341),
    [sym_keyword_primary] = ACTIONS(2341),
    [sym_keyword_create] = ACTIONS(2341),
    [sym_keyword_as] = ACTIONS(2343),
    [sym_keyword_constraint] = ACTIONS(2341),
    [sym_keyword_separator] = ACTIONS(2341),
    [sym_keyword_when] = ACTIONS(2341),
    [sym_keyword_then] = ACTIONS(2341),
    [sym_keyword_else] = ACTIONS(2341),
    [sym_keyword_end] = ACTIONS(2341),
    [sym_keyword_in] = ACTIONS(2341),
    [sym_keyword_and] = ACTIONS(2341),
    [sym_keyword_or] = ACTIONS(2341),
    [sym_keyword_is] = ACTIONS(2341),
    [sym_keyword_not] = ACTIONS(2341),
    [sym_keyword_using] = ACTIONS(2341),
    [sym_keyword_auto_increment] = ACTIONS(2341),
    [sym_keyword_generated] = ACTIONS(2341),
    [sym_keyword_default] = ACTIONS(2341),
    [sym_keyword_returning] = ACTIONS(2341),
    [sym_keyword_first] = ACTIONS(2341),
    [sym_keyword_after] = ACTIONS(2341),
    [sym_keyword_range] = ACTIONS(2341),
    [sym_keyword_rows] = ACTIONS(2341),
    [sym_keyword_groups] = ACTIONS(2341),
    [sym_keyword_between] = ACTIONS(2341),
    [sym_keyword_preceding] = ACTIONS(2341),
    [sym_keyword_following] = ACTIONS(2341),
    [sym_keyword_unique] = ACTIONS(2341),
    [sym_keyword_references] = ACTIONS(2341),
    [aux_sym_keyword_like_token1] = ACTIONS(2341),
    [aux_sym_keyword_like_token2] = ACTIONS(2341),
    [sym_keyword_similar] = ACTIONS(2341),
    [sym_keyword_check] = ACTIONS(2341),
    [sym_keyword_stored] = ACTIONS(2341),
    [sym_keyword_virtual] = ACTIONS(2341),
    [sym_keyword_comment] = ACTIONS(2341),
    [sym_keyword_null] = ACTIONS(2341),
    [sym_keyword_array] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [anon_sym_RBRACK] = ACTIONS(2341),
    [anon_sym_RPAREN] = ACTIONS(2341),
    [anon_sym_COMMA] = ACTIONS(2341),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_COLON_COLON] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2341),
    [anon_sym_GT_EQ] = ACTIONS(2341),
    [anon_sym_COLON] = ACTIONS(2343),
    [sym_op_other] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2341),
    [anon_sym_LT_GT] = ACTIONS(2341),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(2345),
    [anon_sym_SEMI] = ACTIONS(2345),
    [sym_keyword_from] = ACTIONS(2345),
    [sym_keyword_on] = ACTIONS(2345),
    [sym_keyword_where] = ACTIONS(2345),
    [sym_keyword_desc] = ACTIONS(2345),
    [sym_keyword_asc] = ACTIONS(2345),
    [sym_keyword_limit] = ACTIONS(2345),
    [sym_keyword_primary] = ACTIONS(2345),
    [sym_keyword_create] = ACTIONS(2345),
    [sym_keyword_as] = ACTIONS(2347),
    [sym_keyword_constraint] = ACTIONS(2345),
    [sym_keyword_separator] = ACTIONS(2345),
    [sym_keyword_when] = ACTIONS(2345),
    [sym_keyword_then] = ACTIONS(2345),
    [sym_keyword_else] = ACTIONS(2345),
    [sym_keyword_end] = ACTIONS(2345),
    [sym_keyword_in] = ACTIONS(2345),
    [sym_keyword_and] = ACTIONS(2345),
    [sym_keyword_or] = ACTIONS(2345),
    [sym_keyword_is] = ACTIONS(2345),
    [sym_keyword_not] = ACTIONS(2345),
    [sym_keyword_using] = ACTIONS(2345),
    [sym_keyword_auto_increment] = ACTIONS(2345),
    [sym_keyword_generated] = ACTIONS(2345),
    [sym_keyword_default] = ACTIONS(2345),
    [sym_keyword_returning] = ACTIONS(2345),
    [sym_keyword_first] = ACTIONS(2345),
    [sym_keyword_after] = ACTIONS(2345),
    [sym_keyword_range] = ACTIONS(2345),
    [sym_keyword_rows] = ACTIONS(2345),
    [sym_keyword_groups] = ACTIONS(2345),
    [sym_keyword_between] = ACTIONS(2345),
    [sym_keyword_preceding] = ACTIONS(2345),
    [sym_keyword_following] = ACTIONS(2345),
    [sym_keyword_unique] = ACTIONS(2345),
    [sym_keyword_references] = ACTIONS(2345),
    [aux_sym_keyword_like_token1] = ACTIONS(2345),
    [aux_sym_keyword_like_token2] = ACTIONS(2345),
    [sym_keyword_similar] = ACTIONS(2345),
    [sym_keyword_check] = ACTIONS(2345),
    [sym_keyword_stored] = ACTIONS(2345),
    [sym_keyword_virtual] = ACTIONS(2345),
    [sym_keyword_comment] = ACTIONS(2345),
    [sym_keyword_null] = ACTIONS(2345),
    [sym_keyword_array] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2345),
    [anon_sym_RBRACK] = ACTIONS(2345),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_COMMA] = ACTIONS(2345),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2345),
    [anon_sym_STAR] = ACTIONS(2345),
    [anon_sym_COLON_COLON] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_COLON] = ACTIONS(2347),
    [sym_op_other] = ACTIONS(2345),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_DASH] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_LT_GT] = ACTIONS(2345),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2349),
    [sym_keyword_from] = ACTIONS(2349),
    [sym_keyword_on] = ACTIONS(2349),
    [sym_keyword_where] = ACTIONS(2349),
    [sym_keyword_desc] = ACTIONS(2349),
    [sym_keyword_asc] = ACTIONS(2349),
    [sym_keyword_limit] = ACTIONS(2349),
    [sym_keyword_primary] = ACTIONS(2349),
    [sym_keyword_create] = ACTIONS(2349),
    [sym_keyword_as] = ACTIONS(2351),
    [sym_keyword_constraint] = ACTIONS(2349),
    [sym_keyword_separator] = ACTIONS(2349),
    [sym_keyword_when] = ACTIONS(2349),
    [sym_keyword_then] = ACTIONS(2349),
    [sym_keyword_else] = ACTIONS(2349),
    [sym_keyword_end] = ACTIONS(2349),
    [sym_keyword_in] = ACTIONS(2349),
    [sym_keyword_and] = ACTIONS(2349),
    [sym_keyword_or] = ACTIONS(2349),
    [sym_keyword_is] = ACTIONS(2349),
    [sym_keyword_not] = ACTIONS(2349),
    [sym_keyword_using] = ACTIONS(2349),
    [sym_keyword_auto_increment] = ACTIONS(2349),
    [sym_keyword_generated] = ACTIONS(2349),
    [sym_keyword_default] = ACTIONS(2349),
    [sym_keyword_returning] = ACTIONS(2349),
    [sym_keyword_first] = ACTIONS(2349),
    [sym_keyword_after] = ACTIONS(2349),
    [sym_keyword_range] = ACTIONS(2349),
    [sym_keyword_rows] = ACTIONS(2349),
    [sym_keyword_groups] = ACTIONS(2349),
    [sym_keyword_between] = ACTIONS(2349),
    [sym_keyword_preceding] = ACTIONS(2349),
    [sym_keyword_following] = ACTIONS(2349),
    [sym_keyword_unique] = ACTIONS(2349),
    [sym_keyword_references] = ACTIONS(2349),
    [aux_sym_keyword_like_token1] = ACTIONS(2349),
    [aux_sym_keyword_like_token2] = ACTIONS(2349),
    [sym_keyword_similar] = ACTIONS(2349),
    [sym_keyword_check] = ACTIONS(2349),
    [sym_keyword_stored] = ACTIONS(2349),
    [sym_keyword_virtual] = ACTIONS(2349),
    [sym_keyword_comment] = ACTIONS(2349),
    [sym_keyword_null] = ACTIONS(2349),
    [sym_keyword_array] = ACTIONS(2349),
    [anon_sym_LBRACK] = ACTIONS(2349),
    [anon_sym_RBRACK] = ACTIONS(2349),
    [anon_sym_RPAREN] = ACTIONS(2349),
    [anon_sym_COMMA] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2349),
    [anon_sym_COLON_COLON] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2351),
    [anon_sym_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_COLON] = ACTIONS(2351),
    [sym_op_other] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_SLASH] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2349),
    [anon_sym_CARET] = ACTIONS(2351),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_LT_GT] = ACTIONS(2349),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2353),
    [sym_keyword_from] = ACTIONS(2353),
    [sym_keyword_on] = ACTIONS(2353),
    [sym_keyword_where] = ACTIONS(2353),
    [sym_keyword_desc] = ACTIONS(2353),
    [sym_keyword_asc] = ACTIONS(2353),
    [sym_keyword_limit] = ACTIONS(2353),
    [sym_keyword_primary] = ACTIONS(2353),
    [sym_keyword_create] = ACTIONS(2353),
    [sym_keyword_as] = ACTIONS(2355),
    [sym_keyword_constraint] = ACTIONS(2353),
    [sym_keyword_separator] = ACTIONS(2353),
    [sym_keyword_when] = ACTIONS(2353),
    [sym_keyword_then] = ACTIONS(2353),
    [sym_keyword_else] = ACTIONS(2353),
    [sym_keyword_end] = ACTIONS(2353),
    [sym_keyword_in] = ACTIONS(2353),
    [sym_keyword_and] = ACTIONS(2353),
    [sym_keyword_or] = ACTIONS(2353),
    [sym_keyword_is] = ACTIONS(2353),
    [sym_keyword_not] = ACTIONS(2353),
    [sym_keyword_using] = ACTIONS(2353),
    [sym_keyword_auto_increment] = ACTIONS(2353),
    [sym_keyword_generated] = ACTIONS(2353),
    [sym_keyword_default] = ACTIONS(2353),
    [sym_keyword_returning] = ACTIONS(2353),
    [sym_keyword_first] = ACTIONS(2353),
    [sym_keyword_after] = ACTIONS(2353),
    [sym_keyword_range] = ACTIONS(2353),
    [sym_keyword_rows] = ACTIONS(2353),
    [sym_keyword_groups] = ACTIONS(2353),
    [sym_keyword_between] = ACTIONS(2353),
    [sym_keyword_preceding] = ACTIONS(2353),
    [sym_keyword_following] = ACTIONS(2353),
    [sym_keyword_unique] = ACTIONS(2353),
    [sym_keyword_references] = ACTIONS(2353),
    [aux_sym_keyword_like_token1] = ACTIONS(2353),
    [aux_sym_keyword_like_token2] = ACTIONS(2353),
    [sym_keyword_similar] = ACTIONS(2353),
    [sym_keyword_check] = ACTIONS(2353),
    [sym_keyword_stored] = ACTIONS(2353),
    [sym_keyword_virtual] = ACTIONS(2353),
    [sym_keyword_comment] = ACTIONS(2353),
    [sym_keyword_null] = ACTIONS(2353),
    [sym_keyword_array] = ACTIONS(2353),
    [anon_sym_LBRACK] = ACTIONS(2353),
    [anon_sym_RBRACK] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2353),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_STAR] = ACTIONS(2353),
    [anon_sym_COLON_COLON] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2355),
    [anon_sym_GT] = ACTIONS(2355),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2353),
    [anon_sym_COLON] = ACTIONS(2355),
    [sym_op_other] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2355),
    [anon_sym_SLASH] = ACTIONS(2355),
    [anon_sym_PERCENT] = ACTIONS(2353),
    [anon_sym_CARET] = ACTIONS(2355),
    [anon_sym_BANG_EQ] = ACTIONS(2353),
    [anon_sym_LT_GT] = ACTIONS(2353),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(2357),
    [anon_sym_SEMI] = ACTIONS(2357),
    [sym_keyword_from] = ACTIONS(2357),
    [sym_keyword_on] = ACTIONS(2357),
    [sym_keyword_where] = ACTIONS(2357),
    [sym_keyword_desc] = ACTIONS(2357),
    [sym_keyword_asc] = ACTIONS(2357),
    [sym_keyword_limit] = ACTIONS(2357),
    [sym_keyword_primary] = ACTIONS(2357),
    [sym_keyword_create] = ACTIONS(2357),
    [sym_keyword_as] = ACTIONS(2359),
    [sym_keyword_constraint] = ACTIONS(2357),
    [sym_keyword_separator] = ACTIONS(2357),
    [sym_keyword_when] = ACTIONS(2357),
    [sym_keyword_then] = ACTIONS(2357),
    [sym_keyword_else] = ACTIONS(2357),
    [sym_keyword_end] = ACTIONS(2357),
    [sym_keyword_in] = ACTIONS(2357),
    [sym_keyword_and] = ACTIONS(2357),
    [sym_keyword_or] = ACTIONS(2357),
    [sym_keyword_is] = ACTIONS(2357),
    [sym_keyword_not] = ACTIONS(2357),
    [sym_keyword_using] = ACTIONS(2357),
    [sym_keyword_auto_increment] = ACTIONS(2357),
    [sym_keyword_generated] = ACTIONS(2357),
    [sym_keyword_default] = ACTIONS(2357),
    [sym_keyword_returning] = ACTIONS(2357),
    [sym_keyword_first] = ACTIONS(2357),
    [sym_keyword_after] = ACTIONS(2357),
    [sym_keyword_range] = ACTIONS(2357),
    [sym_keyword_rows] = ACTIONS(2357),
    [sym_keyword_groups] = ACTIONS(2357),
    [sym_keyword_between] = ACTIONS(2357),
    [sym_keyword_preceding] = ACTIONS(2357),
    [sym_keyword_following] = ACTIONS(2357),
    [sym_keyword_unique] = ACTIONS(2357),
    [sym_keyword_references] = ACTIONS(2357),
    [aux_sym_keyword_like_token1] = ACTIONS(2357),
    [aux_sym_keyword_like_token2] = ACTIONS(2357),
    [sym_keyword_similar] = ACTIONS(2357),
    [sym_keyword_check] = ACTIONS(2357),
    [sym_keyword_stored] = ACTIONS(2357),
    [sym_keyword_virtual] = ACTIONS(2357),
    [sym_keyword_comment] = ACTIONS(2357),
    [sym_keyword_null] = ACTIONS(2357),
    [sym_keyword_array] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_RBRACK] = ACTIONS(2357),
    [anon_sym_RPAREN] = ACTIONS(2357),
    [anon_sym_COMMA] = ACTIONS(2357),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_COLON_COLON] = ACTIONS(2357),
    [anon_sym_LT] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2359),
    [anon_sym_LT_EQ] = ACTIONS(2357),
    [anon_sym_GT_EQ] = ACTIONS(2357),
    [anon_sym_COLON] = ACTIONS(2359),
    [sym_op_other] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(2357),
    [anon_sym_DASH] = ACTIONS(2359),
    [anon_sym_SLASH] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(2357),
    [anon_sym_CARET] = ACTIONS(2359),
    [anon_sym_BANG_EQ] = ACTIONS(2357),
    [anon_sym_LT_GT] = ACTIONS(2357),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2107),
    [sym_keyword_from] = ACTIONS(2107),
    [sym_keyword_on] = ACTIONS(2107),
    [sym_keyword_where] = ACTIONS(2107),
    [sym_keyword_desc] = ACTIONS(2107),
    [sym_keyword_asc] = ACTIONS(2107),
    [sym_keyword_limit] = ACTIONS(2107),
    [sym_keyword_primary] = ACTIONS(2107),
    [sym_keyword_create] = ACTIONS(2107),
    [sym_keyword_as] = ACTIONS(2109),
    [sym_keyword_constraint] = ACTIONS(2107),
    [sym_keyword_separator] = ACTIONS(2107),
    [sym_keyword_when] = ACTIONS(2107),
    [sym_keyword_then] = ACTIONS(2107),
    [sym_keyword_else] = ACTIONS(2107),
    [sym_keyword_end] = ACTIONS(2107),
    [sym_keyword_in] = ACTIONS(2107),
    [sym_keyword_and] = ACTIONS(2107),
    [sym_keyword_or] = ACTIONS(2107),
    [sym_keyword_is] = ACTIONS(2107),
    [sym_keyword_not] = ACTIONS(2107),
    [sym_keyword_using] = ACTIONS(2107),
    [sym_keyword_auto_increment] = ACTIONS(2107),
    [sym_keyword_generated] = ACTIONS(2107),
    [sym_keyword_default] = ACTIONS(2107),
    [sym_keyword_returning] = ACTIONS(2107),
    [sym_keyword_first] = ACTIONS(2107),
    [sym_keyword_after] = ACTIONS(2107),
    [sym_keyword_range] = ACTIONS(2107),
    [sym_keyword_rows] = ACTIONS(2107),
    [sym_keyword_groups] = ACTIONS(2107),
    [sym_keyword_between] = ACTIONS(2107),
    [sym_keyword_preceding] = ACTIONS(2107),
    [sym_keyword_following] = ACTIONS(2107),
    [sym_keyword_unique] = ACTIONS(2107),
    [sym_keyword_references] = ACTIONS(2107),
    [aux_sym_keyword_like_token1] = ACTIONS(2107),
    [aux_sym_keyword_like_token2] = ACTIONS(2107),
    [sym_keyword_similar] = ACTIONS(2107),
    [sym_keyword_check] = ACTIONS(2107),
    [sym_keyword_stored] = ACTIONS(2107),
    [sym_keyword_virtual] = ACTIONS(2107),
    [sym_keyword_comment] = ACTIONS(2107),
    [sym_keyword_null] = ACTIONS(2107),
    [sym_keyword_array] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_RBRACK] = ACTIONS(2107),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_COMMA] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2107),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_COLON_COLON] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2107),
    [anon_sym_GT_EQ] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2109),
    [sym_op_other] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_PERCENT] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2107),
    [anon_sym_LT_GT] = ACTIONS(2107),
  },
  [284] = {
    [aux_sym__single_quote_string_repeat1] = STATE(285),
    [sym__identifier] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1357),
    [sym_keyword_from] = ACTIONS(1359),
    [sym_keyword_on] = ACTIONS(1359),
    [sym_keyword_offset] = ACTIONS(1359),
    [sym_keyword_create] = ACTIONS(1359),
    [sym_keyword_as] = ACTIONS(1359),
    [sym_keyword_when] = ACTIONS(1359),
    [sym_keyword_in] = ACTIONS(1359),
    [sym_keyword_and] = ACTIONS(1359),
    [sym_keyword_or] = ACTIONS(1359),
    [sym_keyword_is] = ACTIONS(1359),
    [sym_keyword_not] = ACTIONS(1359),
    [sym_keyword_cascade] = ACTIONS(1359),
    [sym_keyword_with] = ACTIONS(1359),
    [sym_keyword_password] = ACTIONS(1359),
    [sym_keyword_encrypted] = ACTIONS(1359),
    [sym_keyword_valid] = ACTIONS(1359),
    [sym_keyword_connection] = ACTIONS(1359),
    [sym_keyword_union] = ACTIONS(1359),
    [sym_keyword_except] = ACTIONS(1359),
    [sym_keyword_intersect] = ACTIONS(1359),
    [sym_keyword_returning] = ACTIONS(1359),
    [sym_keyword_after] = ACTIONS(1359),
    [sym_keyword_before] = ACTIONS(1359),
    [sym_keyword_rows] = ACTIONS(1359),
    [sym_keyword_between] = ACTIONS(1359),
    [aux_sym_keyword_like_token1] = ACTIONS(1359),
    [aux_sym_keyword_like_token2] = ACTIONS(1359),
    [sym_keyword_similar] = ACTIONS(1359),
    [sym_keyword_returns] = ACTIONS(1359),
    [sym_keyword_language] = ACTIONS(1359),
    [sym_keyword_immutable] = ACTIONS(1359),
    [sym_keyword_stable] = ACTIONS(1359),
    [sym_keyword_volatile] = ACTIONS(1359),
    [sym_keyword_leakproof] = ACTIONS(1359),
    [sym_keyword_parallel] = ACTIONS(1359),
    [sym_keyword_called] = ACTIONS(1359),
    [sym_keyword_strict] = ACTIONS(1359),
    [sym_keyword_cost] = ACTIONS(1359),
    [sym_keyword_support] = ACTIONS(1359),
    [sym_keyword_security] = ACTIONS(1359),
    [sym_keyword_external] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_LT_EQ] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1357),
    [sym_op_other] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1357),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1357),
    [anon_sym_LT_GT] = ACTIONS(1357),
    [sym__double_quote_string] = ACTIONS(1357),
    [aux_sym__single_quote_string_token2] = ACTIONS(2361),
    [aux_sym_identifier_token1] = ACTIONS(1357),
    [sym__dollar_quoted_string_end_tag] = ACTIONS(1357),
  },
  [285] = {
    [aux_sym__single_quote_string_repeat1] = STATE(285),
    [sym__identifier] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1363),
    [sym_keyword_from] = ACTIONS(1365),
    [sym_keyword_on] = ACTIONS(1365),
    [sym_keyword_offset] = ACTIONS(1365),
    [sym_keyword_create] = ACTIONS(1365),
    [sym_keyword_as] = ACTIONS(1365),
    [sym_keyword_when] = ACTIONS(1365),
    [sym_keyword_in] = ACTIONS(1365),
    [sym_keyword_and] = ACTIONS(1365),
    [sym_keyword_or] = ACTIONS(1365),
    [sym_keyword_is] = ACTIONS(1365),
    [sym_keyword_not] = ACTIONS(1365),
    [sym_keyword_cascade] = ACTIONS(1365),
    [sym_keyword_with] = ACTIONS(1365),
    [sym_keyword_password] = ACTIONS(1365),
    [sym_keyword_encrypted] = ACTIONS(1365),
    [sym_keyword_valid] = ACTIONS(1365),
    [sym_keyword_connection] = ACTIONS(1365),
    [sym_keyword_union] = ACTIONS(1365),
    [sym_keyword_except] = ACTIONS(1365),
    [sym_keyword_intersect] = ACTIONS(1365),
    [sym_keyword_returning] = ACTIONS(1365),
    [sym_keyword_after] = ACTIONS(1365),
    [sym_keyword_before] = ACTIONS(1365),
    [sym_keyword_rows] = ACTIONS(1365),
    [sym_keyword_between] = ACTIONS(1365),
    [aux_sym_keyword_like_token1] = ACTIONS(1365),
    [aux_sym_keyword_like_token2] = ACTIONS(1365),
    [sym_keyword_similar] = ACTIONS(1365),
    [sym_keyword_returns] = ACTIONS(1365),
    [sym_keyword_language] = ACTIONS(1365),
    [sym_keyword_immutable] = ACTIONS(1365),
    [sym_keyword_stable] = ACTIONS(1365),
    [sym_keyword_volatile] = ACTIONS(1365),
    [sym_keyword_leakproof] = ACTIONS(1365),
    [sym_keyword_parallel] = ACTIONS(1365),
    [sym_keyword_called] = ACTIONS(1365),
    [sym_keyword_strict] = ACTIONS(1365),
    [sym_keyword_cost] = ACTIONS(1365),
    [sym_keyword_support] = ACTIONS(1365),
    [sym_keyword_security] = ACTIONS(1365),
    [sym_keyword_external] = ACTIONS(1365),
    [anon_sym_LBRACK] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [sym_op_other] = ACTIONS(1363),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1365),
    [anon_sym_PERCENT] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_LT_GT] = ACTIONS(1363),
    [sym__double_quote_string] = ACTIONS(1363),
    [aux_sym__single_quote_string_token2] = ACTIONS(2363),
    [aux_sym_identifier_token1] = ACTIONS(1363),
    [sym__dollar_quoted_string_end_tag] = ACTIONS(1363),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2366),
    [sym_keyword_from] = ACTIONS(2366),
    [sym_keyword_on] = ACTIONS(2366),
    [sym_keyword_where] = ACTIONS(2366),
    [sym_keyword_desc] = ACTIONS(2366),
    [sym_keyword_asc] = ACTIONS(2366),
    [sym_keyword_limit] = ACTIONS(2366),
    [sym_keyword_primary] = ACTIONS(2366),
    [sym_keyword_create] = ACTIONS(2366),
    [sym_keyword_as] = ACTIONS(2368),
    [sym_keyword_constraint] = ACTIONS(2366),
    [sym_keyword_separator] = ACTIONS(2366),
    [sym_keyword_when] = ACTIONS(2366),
    [sym_keyword_then] = ACTIONS(2366),
    [sym_keyword_else] = ACTIONS(2366),
    [sym_keyword_end] = ACTIONS(2366),
    [sym_keyword_in] = ACTIONS(2366),
    [sym_keyword_and] = ACTIONS(2366),
    [sym_keyword_or] = ACTIONS(2366),
    [sym_keyword_is] = ACTIONS(2366),
    [sym_keyword_not] = ACTIONS(2366),
    [sym_keyword_using] = ACTIONS(2366),
    [sym_keyword_auto_increment] = ACTIONS(2366),
    [sym_keyword_generated] = ACTIONS(2366),
    [sym_keyword_default] = ACTIONS(2366),
    [sym_keyword_returning] = ACTIONS(2366),
    [sym_keyword_first] = ACTIONS(2366),
    [sym_keyword_after] = ACTIONS(2366),
    [sym_keyword_range] = ACTIONS(2366),
    [sym_keyword_rows] = ACTIONS(2366),
    [sym_keyword_groups] = ACTIONS(2366),
    [sym_keyword_between] = ACTIONS(2366),
    [sym_keyword_preceding] = ACTIONS(2366),
    [sym_keyword_following] = ACTIONS(2366),
    [sym_keyword_unique] = ACTIONS(2366),
    [sym_keyword_references] = ACTIONS(2366),
    [aux_sym_keyword_like_token1] = ACTIONS(2366),
    [aux_sym_keyword_like_token2] = ACTIONS(2366),
    [sym_keyword_similar] = ACTIONS(2366),
    [sym_keyword_check] = ACTIONS(2366),
    [sym_keyword_stored] = ACTIONS(2366),
    [sym_keyword_virtual] = ACTIONS(2366),
    [sym_keyword_comment] = ACTIONS(2366),
    [sym_keyword_null] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_RBRACK] = ACTIONS(2366),
    [anon_sym_RPAREN] = ACTIONS(2366),
    [anon_sym_COMMA] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2368),
    [anon_sym_GT] = ACTIONS(2368),
    [anon_sym_LT_EQ] = ACTIONS(2366),
    [anon_sym_GT_EQ] = ACTIONS(2366),
    [anon_sym_COLON] = ACTIONS(2368),
    [sym_op_other] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_SLASH] = ACTIONS(2368),
    [anon_sym_PERCENT] = ACTIONS(2366),
    [anon_sym_CARET] = ACTIONS(2368),
    [anon_sym_BANG_EQ] = ACTIONS(2366),
    [anon_sym_LT_GT] = ACTIONS(2366),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2370),
    [sym_keyword_from] = ACTIONS(2370),
    [sym_keyword_on] = ACTIONS(2370),
    [sym_keyword_where] = ACTIONS(2370),
    [sym_keyword_desc] = ACTIONS(2370),
    [sym_keyword_asc] = ACTIONS(2370),
    [sym_keyword_limit] = ACTIONS(2370),
    [sym_keyword_primary] = ACTIONS(2370),
    [sym_keyword_create] = ACTIONS(2370),
    [sym_keyword_as] = ACTIONS(2372),
    [sym_keyword_constraint] = ACTIONS(2370),
    [sym_keyword_separator] = ACTIONS(2370),
    [sym_keyword_when] = ACTIONS(2370),
    [sym_keyword_then] = ACTIONS(2370),
    [sym_keyword_else] = ACTIONS(2370),
    [sym_keyword_end] = ACTIONS(2370),
    [sym_keyword_in] = ACTIONS(2370),
    [sym_keyword_and] = ACTIONS(2370),
    [sym_keyword_or] = ACTIONS(2370),
    [sym_keyword_is] = ACTIONS(2370),
    [sym_keyword_not] = ACTIONS(2370),
    [sym_keyword_using] = ACTIONS(2370),
    [sym_keyword_auto_increment] = ACTIONS(2370),
    [sym_keyword_generated] = ACTIONS(2370),
    [sym_keyword_default] = ACTIONS(2370),
    [sym_keyword_returning] = ACTIONS(2370),
    [sym_keyword_first] = ACTIONS(2370),
    [sym_keyword_after] = ACTIONS(2370),
    [sym_keyword_range] = ACTIONS(2370),
    [sym_keyword_rows] = ACTIONS(2370),
    [sym_keyword_groups] = ACTIONS(2370),
    [sym_keyword_between] = ACTIONS(2370),
    [sym_keyword_preceding] = ACTIONS(2370),
    [sym_keyword_following] = ACTIONS(2370),
    [sym_keyword_unique] = ACTIONS(2370),
    [sym_keyword_references] = ACTIONS(2370),
    [aux_sym_keyword_like_token1] = ACTIONS(2370),
    [aux_sym_keyword_like_token2] = ACTIONS(2370),
    [sym_keyword_similar] = ACTIONS(2370),
    [sym_keyword_check] = ACTIONS(2370),
    [sym_keyword_stored] = ACTIONS(2370),
    [sym_keyword_virtual] = ACTIONS(2370),
    [sym_keyword_comment] = ACTIONS(2370),
    [sym_keyword_null] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_RBRACK] = ACTIONS(2370),
    [anon_sym_RPAREN] = ACTIONS(2370),
    [anon_sym_COMMA] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2372),
    [anon_sym_GT] = ACTIONS(2372),
    [anon_sym_LT_EQ] = ACTIONS(2370),
    [anon_sym_GT_EQ] = ACTIONS(2370),
    [anon_sym_COLON] = ACTIONS(2372),
    [sym_op_other] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_SLASH] = ACTIONS(2372),
    [anon_sym_PERCENT] = ACTIONS(2370),
    [anon_sym_CARET] = ACTIONS(2372),
    [anon_sym_BANG_EQ] = ACTIONS(2370),
    [anon_sym_LT_GT] = ACTIONS(2370),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2374),
    [sym_keyword_from] = ACTIONS(2374),
    [sym_keyword_on] = ACTIONS(2374),
    [sym_keyword_where] = ACTIONS(2374),
    [sym_keyword_desc] = ACTIONS(2374),
    [sym_keyword_asc] = ACTIONS(2374),
    [sym_keyword_limit] = ACTIONS(2374),
    [sym_keyword_primary] = ACTIONS(2374),
    [sym_keyword_create] = ACTIONS(2374),
    [sym_keyword_as] = ACTIONS(2376),
    [sym_keyword_constraint] = ACTIONS(2374),
    [sym_keyword_separator] = ACTIONS(2374),
    [sym_keyword_when] = ACTIONS(2374),
    [sym_keyword_then] = ACTIONS(2374),
    [sym_keyword_else] = ACTIONS(2374),
    [sym_keyword_end] = ACTIONS(2374),
    [sym_keyword_in] = ACTIONS(2374),
    [sym_keyword_and] = ACTIONS(2374),
    [sym_keyword_or] = ACTIONS(2374),
    [sym_keyword_is] = ACTIONS(2374),
    [sym_keyword_not] = ACTIONS(2374),
    [sym_keyword_using] = ACTIONS(2374),
    [sym_keyword_auto_increment] = ACTIONS(2374),
    [sym_keyword_generated] = ACTIONS(2374),
    [sym_keyword_default] = ACTIONS(2374),
    [sym_keyword_returning] = ACTIONS(2374),
    [sym_keyword_first] = ACTIONS(2374),
    [sym_keyword_after] = ACTIONS(2374),
    [sym_keyword_range] = ACTIONS(2374),
    [sym_keyword_rows] = ACTIONS(2374),
    [sym_keyword_groups] = ACTIONS(2374),
    [sym_keyword_between] = ACTIONS(2374),
    [sym_keyword_preceding] = ACTIONS(2374),
    [sym_keyword_following] = ACTIONS(2374),
    [sym_keyword_unique] = ACTIONS(2374),
    [sym_keyword_references] = ACTIONS(2374),
    [aux_sym_keyword_like_token1] = ACTIONS(2374),
    [aux_sym_keyword_like_token2] = ACTIONS(2374),
    [sym_keyword_similar] = ACTIONS(2374),
    [sym_keyword_check] = ACTIONS(2374),
    [sym_keyword_stored] = ACTIONS(2374),
    [sym_keyword_virtual] = ACTIONS(2374),
    [sym_keyword_comment] = ACTIONS(2374),
    [sym_keyword_null] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_RBRACK] = ACTIONS(2374),
    [anon_sym_RPAREN] = ACTIONS(2374),
    [anon_sym_COMMA] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2374),
    [anon_sym_LT] = ACTIONS(2376),
    [anon_sym_GT] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2374),
    [anon_sym_GT_EQ] = ACTIONS(2374),
    [anon_sym_COLON] = ACTIONS(2376),
    [sym_op_other] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_SLASH] = ACTIONS(2376),
    [anon_sym_PERCENT] = ACTIONS(2374),
    [anon_sym_CARET] = ACTIONS(2376),
    [anon_sym_BANG_EQ] = ACTIONS(2374),
    [anon_sym_LT_GT] = ACTIONS(2374),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2378),
    [sym_keyword_from] = ACTIONS(2378),
    [sym_keyword_on] = ACTIONS(2378),
    [sym_keyword_where] = ACTIONS(2378),
    [sym_keyword_desc] = ACTIONS(2378),
    [sym_keyword_asc] = ACTIONS(2378),
    [sym_keyword_limit] = ACTIONS(2378),
    [sym_keyword_primary] = ACTIONS(2378),
    [sym_keyword_create] = ACTIONS(2378),
    [sym_keyword_as] = ACTIONS(2380),
    [sym_keyword_constraint] = ACTIONS(2378),
    [sym_keyword_separator] = ACTIONS(2378),
    [sym_keyword_when] = ACTIONS(2378),
    [sym_keyword_then] = ACTIONS(2378),
    [sym_keyword_else] = ACTIONS(2378),
    [sym_keyword_end] = ACTIONS(2378),
    [sym_keyword_in] = ACTIONS(2378),
    [sym_keyword_and] = ACTIONS(2378),
    [sym_keyword_or] = ACTIONS(2378),
    [sym_keyword_is] = ACTIONS(2378),
    [sym_keyword_not] = ACTIONS(2378),
    [sym_keyword_using] = ACTIONS(2378),
    [sym_keyword_auto_increment] = ACTIONS(2378),
    [sym_keyword_generated] = ACTIONS(2378),
    [sym_keyword_default] = ACTIONS(2378),
    [sym_keyword_returning] = ACTIONS(2378),
    [sym_keyword_first] = ACTIONS(2378),
    [sym_keyword_after] = ACTIONS(2378),
    [sym_keyword_range] = ACTIONS(2378),
    [sym_keyword_rows] = ACTIONS(2378),
    [sym_keyword_groups] = ACTIONS(2378),
    [sym_keyword_between] = ACTIONS(2378),
    [sym_keyword_preceding] = ACTIONS(2378),
    [sym_keyword_following] = ACTIONS(2378),
    [sym_keyword_unique] = ACTIONS(2378),
    [sym_keyword_references] = ACTIONS(2378),
    [aux_sym_keyword_like_token1] = ACTIONS(2378),
    [aux_sym_keyword_like_token2] = ACTIONS(2378),
    [sym_keyword_similar] = ACTIONS(2378),
    [sym_keyword_check] = ACTIONS(2378),
    [sym_keyword_stored] = ACTIONS(2378),
    [sym_keyword_virtual] = ACTIONS(2378),
    [sym_keyword_comment] = ACTIONS(2378),
    [sym_keyword_null] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_RBRACK] = ACTIONS(2378),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_COMMA] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_GT] = ACTIONS(2380),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_GT_EQ] = ACTIONS(2378),
    [anon_sym_COLON] = ACTIONS(2380),
    [sym_op_other] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_PERCENT] = ACTIONS(2378),
    [anon_sym_CARET] = ACTIONS(2380),
    [anon_sym_BANG_EQ] = ACTIONS(2378),
    [anon_sym_LT_GT] = ACTIONS(2378),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2382),
    [sym_keyword_from] = ACTIONS(2382),
    [sym_keyword_on] = ACTIONS(2382),
    [sym_keyword_where] = ACTIONS(2382),
    [sym_keyword_desc] = ACTIONS(2382),
    [sym_keyword_asc] = ACTIONS(2382),
    [sym_keyword_limit] = ACTIONS(2382),
    [sym_keyword_primary] = ACTIONS(2382),
    [sym_keyword_create] = ACTIONS(2382),
    [sym_keyword_as] = ACTIONS(2384),
    [sym_keyword_constraint] = ACTIONS(2382),
    [sym_keyword_separator] = ACTIONS(2382),
    [sym_keyword_when] = ACTIONS(2382),
    [sym_keyword_then] = ACTIONS(2382),
    [sym_keyword_else] = ACTIONS(2382),
    [sym_keyword_end] = ACTIONS(2382),
    [sym_keyword_in] = ACTIONS(2382),
    [sym_keyword_and] = ACTIONS(2382),
    [sym_keyword_or] = ACTIONS(2382),
    [sym_keyword_is] = ACTIONS(2382),
    [sym_keyword_not] = ACTIONS(2382),
    [sym_keyword_using] = ACTIONS(2382),
    [sym_keyword_auto_increment] = ACTIONS(2382),
    [sym_keyword_generated] = ACTIONS(2382),
    [sym_keyword_default] = ACTIONS(2382),
    [sym_keyword_returning] = ACTIONS(2382),
    [sym_keyword_first] = ACTIONS(2382),
    [sym_keyword_after] = ACTIONS(2382),
    [sym_keyword_range] = ACTIONS(2382),
    [sym_keyword_rows] = ACTIONS(2382),
    [sym_keyword_groups] = ACTIONS(2382),
    [sym_keyword_between] = ACTIONS(2382),
    [sym_keyword_preceding] = ACTIONS(2382),
    [sym_keyword_following] = ACTIONS(2382),
    [sym_keyword_unique] = ACTIONS(2382),
    [sym_keyword_references] = ACTIONS(2382),
    [aux_sym_keyword_like_token1] = ACTIONS(2382),
    [aux_sym_keyword_like_token2] = ACTIONS(2382),
    [sym_keyword_similar] = ACTIONS(2382),
    [sym_keyword_check] = ACTIONS(2382),
    [sym_keyword_stored] = ACTIONS(2382),
    [sym_keyword_virtual] = ACTIONS(2382),
    [sym_keyword_comment] = ACTIONS(2382),
    [sym_keyword_null] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_RBRACK] = ACTIONS(2382),
    [anon_sym_RPAREN] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_LT_EQ] = ACTIONS(2382),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_COLON] = ACTIONS(2384),
    [sym_op_other] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_PERCENT] = ACTIONS(2382),
    [anon_sym_CARET] = ACTIONS(2384),
    [anon_sym_BANG_EQ] = ACTIONS(2382),
    [anon_sym_LT_GT] = ACTIONS(2382),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2386),
    [sym_keyword_from] = ACTIONS(2386),
    [sym_keyword_on] = ACTIONS(2386),
    [sym_keyword_where] = ACTIONS(2386),
    [sym_keyword_desc] = ACTIONS(2386),
    [sym_keyword_asc] = ACTIONS(2386),
    [sym_keyword_limit] = ACTIONS(2386),
    [sym_keyword_primary] = ACTIONS(2386),
    [sym_keyword_create] = ACTIONS(2386),
    [sym_keyword_as] = ACTIONS(2388),
    [sym_keyword_constraint] = ACTIONS(2386),
    [sym_keyword_separator] = ACTIONS(2386),
    [sym_keyword_when] = ACTIONS(2386),
    [sym_keyword_then] = ACTIONS(2386),
    [sym_keyword_else] = ACTIONS(2386),
    [sym_keyword_end] = ACTIONS(2386),
    [sym_keyword_in] = ACTIONS(2386),
    [sym_keyword_and] = ACTIONS(2386),
    [sym_keyword_or] = ACTIONS(2386),
    [sym_keyword_is] = ACTIONS(2386),
    [sym_keyword_not] = ACTIONS(2386),
    [sym_keyword_using] = ACTIONS(2386),
    [sym_keyword_auto_increment] = ACTIONS(2386),
    [sym_keyword_generated] = ACTIONS(2386),
    [sym_keyword_default] = ACTIONS(2386),
    [sym_keyword_returning] = ACTIONS(2386),
    [sym_keyword_first] = ACTIONS(2386),
    [sym_keyword_after] = ACTIONS(2386),
    [sym_keyword_range] = ACTIONS(2386),
    [sym_keyword_rows] = ACTIONS(2386),
    [sym_keyword_groups] = ACTIONS(2386),
    [sym_keyword_between] = ACTIONS(2386),
    [sym_keyword_preceding] = ACTIONS(2386),
    [sym_keyword_following] = ACTIONS(2386),
    [sym_keyword_unique] = ACTIONS(2386),
    [sym_keyword_references] = ACTIONS(2386),
    [aux_sym_keyword_like_token1] = ACTIONS(2386),
    [aux_sym_keyword_like_token2] = ACTIONS(2386),
    [sym_keyword_similar] = ACTIONS(2386),
    [sym_keyword_check] = ACTIONS(2386),
    [sym_keyword_stored] = ACTIONS(2386),
    [sym_keyword_virtual] = ACTIONS(2386),
    [sym_keyword_comment] = ACTIONS(2386),
    [sym_keyword_null] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_RBRACK] = ACTIONS(2386),
    [anon_sym_RPAREN] = ACTIONS(2386),
    [anon_sym_COMMA] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2386),
    [anon_sym_GT_EQ] = ACTIONS(2386),
    [anon_sym_COLON] = ACTIONS(2388),
    [sym_op_other] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(2388),
    [anon_sym_PERCENT] = ACTIONS(2386),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2386),
    [anon_sym_LT_GT] = ACTIONS(2386),
  },
  [292] = {
    [aux_sym__single_quote_string_repeat1] = STATE(284),
    [sym__identifier] = ACTIONS(1353),
    [anon_sym_SEMI] = ACTIONS(1351),
    [sym_keyword_from] = ACTIONS(1353),
    [sym_keyword_on] = ACTIONS(1353),
    [sym_keyword_offset] = ACTIONS(1353),
    [sym_keyword_create] = ACTIONS(1353),
    [sym_keyword_as] = ACTIONS(1353),
    [sym_keyword_when] = ACTIONS(1353),
    [sym_keyword_in] = ACTIONS(1353),
    [sym_keyword_and] = ACTIONS(1353),
    [sym_keyword_or] = ACTIONS(1353),
    [sym_keyword_is] = ACTIONS(1353),
    [sym_keyword_not] = ACTIONS(1353),
    [sym_keyword_cascade] = ACTIONS(1353),
    [sym_keyword_with] = ACTIONS(1353),
    [sym_keyword_password] = ACTIONS(1353),
    [sym_keyword_encrypted] = ACTIONS(1353),
    [sym_keyword_valid] = ACTIONS(1353),
    [sym_keyword_connection] = ACTIONS(1353),
    [sym_keyword_union] = ACTIONS(1353),
    [sym_keyword_except] = ACTIONS(1353),
    [sym_keyword_intersect] = ACTIONS(1353),
    [sym_keyword_returning] = ACTIONS(1353),
    [sym_keyword_after] = ACTIONS(1353),
    [sym_keyword_before] = ACTIONS(1353),
    [sym_keyword_rows] = ACTIONS(1353),
    [sym_keyword_between] = ACTIONS(1353),
    [aux_sym_keyword_like_token1] = ACTIONS(1353),
    [aux_sym_keyword_like_token2] = ACTIONS(1353),
    [sym_keyword_similar] = ACTIONS(1353),
    [sym_keyword_returns] = ACTIONS(1353),
    [sym_keyword_language] = ACTIONS(1353),
    [sym_keyword_immutable] = ACTIONS(1353),
    [sym_keyword_stable] = ACTIONS(1353),
    [sym_keyword_volatile] = ACTIONS(1353),
    [sym_keyword_leakproof] = ACTIONS(1353),
    [sym_keyword_parallel] = ACTIONS(1353),
    [sym_keyword_called] = ACTIONS(1353),
    [sym_keyword_strict] = ACTIONS(1353),
    [sym_keyword_cost] = ACTIONS(1353),
    [sym_keyword_support] = ACTIONS(1353),
    [sym_keyword_security] = ACTIONS(1353),
    [sym_keyword_external] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_LT_EQ] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym_op_other] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_PERCENT] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_LT_GT] = ACTIONS(1351),
    [sym__double_quote_string] = ACTIONS(1351),
    [aux_sym__single_quote_string_token2] = ACTIONS(2390),
    [aux_sym_identifier_token1] = ACTIONS(1351),
    [sym__dollar_quoted_string_end_tag] = ACTIONS(1351),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym__identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_keyword_set] = ACTIONS(1376),
    [sym_keyword_from] = ACTIONS(1376),
    [sym_keyword_create] = ACTIONS(1376),
    [sym_keyword_as] = ACTIONS(1376),
    [sym_keyword_in] = ACTIONS(1376),
    [sym_keyword_and] = ACTIONS(1376),
    [sym_keyword_or] = ACTIONS(1376),
    [sym_keyword_is] = ACTIONS(1376),
    [sym_keyword_not] = ACTIONS(1376),
    [sym_keyword_with] = ACTIONS(1376),
    [sym_keyword_rename] = ACTIONS(1376),
    [sym_keyword_user] = ACTIONS(1376),
    [sym_keyword_admin] = ACTIONS(1376),
    [sym_keyword_password] = ACTIONS(1376),
    [sym_keyword_encrypted] = ACTIONS(1376),
    [sym_keyword_valid] = ACTIONS(1376),
    [sym_keyword_connection] = ACTIONS(1376),
    [sym_keyword_role] = ACTIONS(1376),
    [sym_keyword_reset] = ACTIONS(1376),
    [sym_keyword_begin] = ACTIONS(1376),
    [sym_keyword_rows] = ACTIONS(1376),
    [sym_keyword_between] = ACTIONS(1376),
    [aux_sym_keyword_like_token1] = ACTIONS(1376),
    [aux_sym_keyword_like_token2] = ACTIONS(1376),
    [sym_keyword_similar] = ACTIONS(1376),
    [sym_keyword_returns] = ACTIONS(1376),
    [sym_keyword_return] = ACTIONS(1376),
    [sym_keyword_language] = ACTIONS(1376),
    [sym_keyword_immutable] = ACTIONS(1376),
    [sym_keyword_stable] = ACTIONS(1376),
    [sym_keyword_volatile] = ACTIONS(1376),
    [sym_keyword_leakproof] = ACTIONS(1376),
    [sym_keyword_parallel] = ACTIONS(1376),
    [sym_keyword_called] = ACTIONS(1376),
    [sym_keyword_strict] = ACTIONS(1376),
    [sym_keyword_cost] = ACTIONS(1376),
    [sym_keyword_support] = ACTIONS(1376),
    [sym_keyword_security] = ACTIONS(1376),
    [sym_keyword_external] = ACTIONS(1376),
    [sym_keyword_array] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [sym_op_other] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_LT_GT] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1374),
    [aux_sym_identifier_token1] = ACTIONS(1374),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_keyword_on] = ACTIONS(1374),
    [sym_keyword_order] = ACTIONS(1374),
    [sym_keyword_group] = ACTIONS(1374),
    [sym_keyword_having] = ACTIONS(1374),
    [sym_keyword_desc] = ACTIONS(1374),
    [sym_keyword_asc] = ACTIONS(1374),
    [sym_keyword_limit] = ACTIONS(1374),
    [sym_keyword_primary] = ACTIONS(1374),
    [sym_keyword_create] = ACTIONS(1374),
    [sym_keyword_as] = ACTIONS(1376),
    [sym_keyword_constraint] = ACTIONS(1374),
    [sym_keyword_when] = ACTIONS(1374),
    [sym_keyword_in] = ACTIONS(1376),
    [sym_keyword_and] = ACTIONS(1374),
    [sym_keyword_or] = ACTIONS(1376),
    [sym_keyword_is] = ACTIONS(1374),
    [sym_keyword_not] = ACTIONS(1374),
    [sym_keyword_auto_increment] = ACTIONS(1374),
    [sym_keyword_generated] = ACTIONS(1374),
    [sym_keyword_default] = ACTIONS(1374),
    [sym_keyword_with] = ACTIONS(1374),
    [sym_keyword_union] = ACTIONS(1374),
    [sym_keyword_except] = ACTIONS(1374),
    [sym_keyword_intersect] = ACTIONS(1374),
    [sym_keyword_returning] = ACTIONS(1374),
    [sym_keyword_first] = ACTIONS(1374),
    [sym_keyword_after] = ACTIONS(1374),
    [sym_keyword_window] = ACTIONS(1374),
    [sym_keyword_between] = ACTIONS(1374),
    [sym_keyword_unique] = ACTIONS(1374),
    [sym_keyword_references] = ACTIONS(1374),
    [aux_sym_keyword_like_token1] = ACTIONS(1374),
    [aux_sym_keyword_like_token2] = ACTIONS(1374),
    [sym_keyword_similar] = ACTIONS(1374),
    [sym_keyword_check] = ACTIONS(1374),
    [sym_keyword_stored] = ACTIONS(1374),
    [sym_keyword_virtual] = ACTIONS(1374),
    [sym_keyword_comment] = ACTIONS(1374),
    [sym_keyword_null] = ACTIONS(1374),
    [sym_keyword_array] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_COLON_COLON] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [sym_op_other] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_LT_GT] = ACTIONS(1374),
    [aux_sym__single_quote_string_token1] = ACTIONS(1374),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym__identifier] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_keyword_set] = ACTIONS(1376),
    [sym_keyword_left] = ACTIONS(1376),
    [sym_keyword_right] = ACTIONS(1376),
    [sym_keyword_inner] = ACTIONS(1376),
    [sym_keyword_full] = ACTIONS(1376),
    [sym_keyword_cross] = ACTIONS(1376),
    [sym_keyword_join] = ACTIONS(1376),
    [sym_keyword_natural] = ACTIONS(1376),
    [sym_keyword_on] = ACTIONS(1376),
    [sym_keyword_where] = ACTIONS(1376),
    [sym_keyword_order] = ACTIONS(1376),
    [sym_keyword_group] = ACTIONS(1376),
    [sym_keyword_limit] = ACTIONS(1376),
    [sym_keyword_primary] = ACTIONS(1376),
    [sym_keyword_create] = ACTIONS(1376),
    [sym_keyword_increment] = ACTIONS(1376),
    [sym_keyword_minvalue] = ACTIONS(1376),
    [sym_keyword_maxvalue] = ACTIONS(1376),
    [sym_keyword_owned] = ACTIONS(1376),
    [sym_keyword_start] = ACTIONS(1376),
    [sym_keyword_restart] = ACTIONS(1376),
    [sym_keyword_key] = ACTIONS(1376),
    [sym_keyword_as] = ACTIONS(1376),
    [sym_keyword_constraint] = ACTIONS(1376),
    [sym_keyword_separator] = ACTIONS(1376),
    [sym_keyword_when] = ACTIONS(1376),
    [sym_keyword_force] = ACTIONS(1376),
    [sym_keyword_ignore] = ACTIONS(1376),
    [sym_keyword_using] = ACTIONS(1376),
    [sym_keyword_use] = ACTIONS(1376),
    [sym_keyword_index] = ACTIONS(1376),
    [sym_keyword_with] = ACTIONS(1376),
    [sym_keyword_no] = ACTIONS(1376),
    [sym_keyword_rename] = ACTIONS(1376),
    [sym_keyword_owner] = ACTIONS(1376),
    [sym_keyword_password] = ACTIONS(1376),
    [sym_keyword_encrypted] = ACTIONS(1376),
    [sym_keyword_valid] = ACTIONS(1376),
    [sym_keyword_connection] = ACTIONS(1376),
    [sym_keyword_cycle] = ACTIONS(1376),
    [sym_keyword_union] = ACTIONS(1376),
    [sym_keyword_except] = ACTIONS(1376),
    [sym_keyword_intersect] = ACTIONS(1376),
    [sym_keyword_returning] = ACTIONS(1376),
    [sym_keyword_after] = ACTIONS(1376),
    [sym_keyword_before] = ACTIONS(1376),
    [sym_keyword_window] = ACTIONS(1376),
    [sym_keyword_unique] = ACTIONS(1376),
    [sym_keyword_foreign] = ACTIONS(1376),
    [sym_keyword_check] = ACTIONS(1376),
    [sym_keyword_instead] = ACTIONS(1376),
    [sym_keyword_cache] = ACTIONS(1376),
    [sym_keyword_array] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_COMMA] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_marginalia] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1374),
    [sym__double_quote_string] = ACTIONS(1374),
    [aux_sym_identifier_token1] = ACTIONS(1374),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 20,
    ACTIONS(2394), 1,
      sym_keyword_as,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2400), 1,
      sym_keyword_not,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [105] = 8,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186] = 13,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 43,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277] = 13,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 43,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368] = 38,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2444), 1,
      sym_keyword_current_timestamp,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2454), 1,
      anon_sym_RPAREN,
    ACTIONS(2456), 1,
      sym_parameter,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(6564), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    STATE(13588), 1,
      sym__inner_default_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5353), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [509] = 11,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 44,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [596] = 18,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2426), 1,
      sym_keyword_as,
    ACTIONS(2476), 1,
      sym_keyword_not,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [697] = 6,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [774] = 16,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2476), 1,
      sym_keyword_not,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 40,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [871] = 22,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2400), 1,
      sym_keyword_not,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2426), 1,
      sym_keyword_as,
    ACTIONS(2479), 1,
      sym_keyword_and,
    ACTIONS(2481), 1,
      sym_keyword_between,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [980] = 21,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2400), 1,
      sym_keyword_not,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2426), 1,
      sym_keyword_as,
    ACTIONS(2481), 1,
      sym_keyword_between,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [1087] = 8,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [1168] = 38,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2483), 1,
      sym_keyword_current_timestamp,
    ACTIONS(2485), 1,
      anon_sym_RPAREN,
    ACTIONS(2487), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(6564), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    STATE(13900), 1,
      sym__inner_default_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5200), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [1309] = 9,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [1392] = 20,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2400), 1,
      sym_keyword_not,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2491), 1,
      sym_keyword_as,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [1497] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(398), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [1571] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(413), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [1645] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 45,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_cascade,
      sym_keyword_with,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_rows,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [1715] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(399), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [1789] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(401), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [1863] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(406), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [1937] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(408), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2011] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(396), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2085] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(407), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2159] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(411), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2233] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(395), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2307] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(410), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2381] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(412), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2455] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(403), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2529] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(394), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2603] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(405), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2677] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(397), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2751] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(404), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2825] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(402), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2899] = 5,
    ACTIONS(2497), 1,
      sym_keyword_filter,
    STATE(409), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [2973] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2571), 1,
      anon_sym_RPAREN,
    ACTIONS(2573), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10953), 1,
      sym_object_reference,
    STATE(12785), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5116), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3108] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2577), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5250), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3243] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    ACTIONS(2581), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10566), 1,
      sym_object_reference,
    STATE(12777), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5347), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3378] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2583), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5112), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3513] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2585), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5358), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3648] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2587), 1,
      anon_sym_RPAREN,
    ACTIONS(2589), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13276), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5104), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3783] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2591), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5113), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [3918] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2593), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5114), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4053] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2595), 1,
      anon_sym_RPAREN,
    ACTIONS(2597), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10283), 1,
      sym_object_reference,
    STATE(12958), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5224), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4188] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2599), 1,
      anon_sym_RPAREN,
    ACTIONS(2601), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12044), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5156), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4323] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2603), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5115), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4458] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2605), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5117), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4593] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2607), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5118), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4728] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2609), 1,
      anon_sym_RPAREN,
    ACTIONS(2611), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12270), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5142), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [4863] = 5,
    ACTIONS(2613), 1,
      aux_sym__single_quote_string_token2,
    STATE(345), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 8,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 50,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_window,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [4936] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2616), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5318), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5071] = 5,
    ACTIONS(2618), 1,
      aux_sym__single_quote_string_token2,
    STATE(345), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 8,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 50,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_window,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [5144] = 5,
    ACTIONS(2620), 1,
      aux_sym__single_quote_string_token2,
    STATE(347), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 8,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 50,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_window,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [5217] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2587), 1,
      anon_sym_RPAREN,
    ACTIONS(2622), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10285), 1,
      sym_object_reference,
    STATE(13276), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5108), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5352] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2571), 1,
      anon_sym_RPAREN,
    ACTIONS(2624), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12785), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5127), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5487] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2626), 1,
      anon_sym_RPAREN,
    ACTIONS(2628), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12139), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5296), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5622] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2630), 1,
      anon_sym_RPAREN,
    ACTIONS(2632), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10629), 1,
      sym_object_reference,
    STATE(12559), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5441), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5757] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2585), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(8503), 1,
      sym__cte,
    STATE(8534), 1,
      sym_select,
    STATE(8903), 1,
      sym__select_statement,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    STATE(14065), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5358), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [5892] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2634), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5210), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6027] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2485), 1,
      anon_sym_RPAREN,
    ACTIONS(2636), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12354), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5392), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6162] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2638), 1,
      anon_sym_RPAREN,
    ACTIONS(2640), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13590), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5105), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6297] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    ACTIONS(2642), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12777), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5475), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6432] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2485), 1,
      anon_sym_RPAREN,
    ACTIONS(2644), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10750), 1,
      sym_object_reference,
    STATE(12354), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5397), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6567] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2646), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5259), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6702] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2648), 1,
      anon_sym_RPAREN,
    ACTIONS(2650), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13988), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5102), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6837] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2626), 1,
      anon_sym_RPAREN,
    ACTIONS(2652), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10798), 1,
      sym_object_reference,
    STATE(12139), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5336), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [6972] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2654), 1,
      anon_sym_RPAREN,
    ACTIONS(2656), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(14159), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5111), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7107] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2658), 1,
      anon_sym_RPAREN,
    ACTIONS(2660), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10841), 1,
      sym_object_reference,
    STATE(13862), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5158), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7242] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2454), 1,
      anon_sym_RPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2662), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(14553), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5164), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7377] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2664), 1,
      anon_sym_RPAREN,
    ACTIONS(2666), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13939), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5357), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7512] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2599), 1,
      anon_sym_RPAREN,
    ACTIONS(2668), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10846), 1,
      sym_object_reference,
    STATE(12044), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5150), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7647] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2630), 1,
      anon_sym_RPAREN,
    ACTIONS(2670), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12559), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5436), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7782] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2658), 1,
      anon_sym_RPAREN,
    ACTIONS(2672), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13862), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5171), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [7917] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2674), 1,
      anon_sym_RPAREN,
    ACTIONS(2676), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(13455), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5320), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8052] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2609), 1,
      anon_sym_RPAREN,
    ACTIONS(2678), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10894), 1,
      sym_object_reference,
    STATE(12270), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5141), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8187] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2595), 1,
      anon_sym_RPAREN,
    ACTIONS(2680), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(12958), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5300), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8322] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2682), 1,
      anon_sym_RPAREN,
    ACTIONS(2684), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11137), 1,
      sym_object_reference,
    STATE(14522), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5425), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8457] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2682), 1,
      anon_sym_RPAREN,
    ACTIONS(2686), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11581), 1,
      sym_object_reference,
    STATE(14522), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5394), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8592] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2674), 1,
      anon_sym_RPAREN,
    ACTIONS(2688), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11221), 1,
      sym_object_reference,
    STATE(13455), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5424), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8727] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2690), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5188), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8862] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2692), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5453), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [8997] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2664), 1,
      anon_sym_RPAREN,
    ACTIONS(2694), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11117), 1,
      sym_object_reference,
    STATE(13939), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5208), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9132] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2585), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10578), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5358), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9267] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2454), 1,
      anon_sym_RPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2696), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11217), 1,
      sym_object_reference,
    STATE(14553), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5281), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9402] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2698), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5404), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9537] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2638), 1,
      anon_sym_RPAREN,
    ACTIONS(2700), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11052), 1,
      sym_object_reference,
    STATE(13590), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5097), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9672] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5100), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9807] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2704), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5410), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [9942] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2706), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5098), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10077] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2708), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5197), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10212] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2710), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5450), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10347] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2571), 1,
      anon_sym_RPAREN,
    ACTIONS(2573), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11000), 1,
      sym_object_reference,
    STATE(12785), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5116), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10482] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2654), 1,
      anon_sym_RPAREN,
    ACTIONS(2712), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11121), 1,
      sym_object_reference,
    STATE(14159), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5144), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10617] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2714), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5446), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10752] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2716), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5154), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [10887] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2587), 1,
      anon_sym_RPAREN,
    ACTIONS(2622), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10434), 1,
      sym_object_reference,
    STATE(13276), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5108), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11022] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2648), 1,
      anon_sym_RPAREN,
    ACTIONS(2718), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(11115), 1,
      sym_object_reference,
    STATE(13988), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5095), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11157] = 36,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2452), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2720), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(10866), 1,
      sym_object_reference,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5162), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [11292] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11428] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11496] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11564] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11768] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11904] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [11972] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12040] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12244] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12380] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12516] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12652] = 7,
    ACTIONS(2774), 1,
      sym_keyword_array,
    STATE(287), 1,
      sym__array_size_definition,
    STATE(289), 1,
      sym_array_size_definition,
    STATE(591), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [12727] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(657), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12798] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(554), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12869] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(542), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [12940] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(593), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13011] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(618), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 8,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 50,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_window,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [13149] = 7,
    ACTIONS(2778), 1,
      sym_keyword_unsigned,
    ACTIONS(2780), 1,
      sym_keyword_zerofill,
    ACTIONS(2782), 1,
      sym_keyword_precision,
    ACTIONS(2784), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [13224] = 7,
    ACTIONS(2786), 1,
      sym_keyword_with,
    ACTIONS(2788), 1,
      sym_keyword_without,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(825), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [13299] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(650), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13370] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(654), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13441] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 52,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [13508] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(560), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13579] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(557), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13650] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(655), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13721] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(623), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13792] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(607), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [13863] = 7,
    ACTIONS(2786), 1,
      sym_keyword_with,
    ACTIONS(2788), 1,
      sym_keyword_without,
    ACTIONS(2792), 1,
      anon_sym_LPAREN,
    STATE(811), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [13938] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 41,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14005] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(578), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14076] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(575), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14147] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(522), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14218] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(647), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14289] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(606), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14360] = 7,
    ACTIONS(2774), 1,
      sym_keyword_array,
    STATE(286), 1,
      sym_array_size_definition,
    STATE(287), 1,
      sym__array_size_definition,
    STATE(591), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [14435] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(598), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14506] = 5,
    ACTIONS(2776), 1,
      sym_keyword_filter,
    STATE(581), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [14577] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    STATE(857), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [14652] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(785), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [14722] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2813), 1,
      sym_keyword_distinct,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2831), 1,
      anon_sym_RPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7983), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [14848] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [14916] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2855), 1,
      sym_keyword_distinct,
    ACTIONS(2857), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8004), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15042] = 20,
    ACTIONS(2394), 1,
      sym_keyword_as,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2863), 1,
      sym_keyword_not,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [15142] = 33,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2883), 1,
      sym_keyword_distinct,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2901), 1,
      sym_parameter,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7365), 1,
      sym_term,
    STATE(7468), 1,
      sym_select_expression,
    STATE(11381), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1829), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15268] = 6,
    ACTIONS(2786), 1,
      sym_keyword_with,
    ACTIONS(2788), 1,
      sym_keyword_without,
    STATE(907), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 51,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15406] = 6,
    ACTIONS(2786), 1,
      sym_keyword_with,
    ACTIONS(2788), 1,
      sym_keyword_without,
    STATE(798), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15478] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 51,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15544] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2921), 1,
      sym_keyword_distinct,
    ACTIONS(2923), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7966), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [15670] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 51,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15736] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(783), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15806] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_as,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2863), 1,
      sym_keyword_not,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [15906] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(774), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [15976] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2925), 1,
      sym_keyword_distinct,
    ACTIONS(2927), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7995), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16102] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 51,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [16168] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(770), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [16238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 51,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [16304] = 33,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2929), 1,
      sym_keyword_distinct,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(2949), 1,
      sym_parameter,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7543), 1,
      sym_select_expression,
    STATE(7718), 1,
      sym_term,
    STATE(11982), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2474), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16430] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(769), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [16500] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2969), 1,
      sym_keyword_distinct,
    ACTIONS(2971), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7944), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16626] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(760), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [16696] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2973), 1,
      sym_keyword_distinct,
    ACTIONS(2975), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7967), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [16822] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(787), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [16892] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2977), 1,
      sym_keyword_distinct,
    ACTIONS(2979), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7951), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17018] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(755), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [17088] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2981), 1,
      sym_keyword_distinct,
    ACTIONS(2983), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7991), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17214] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2985), 1,
      sym_keyword_distinct,
    ACTIONS(2987), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8069), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17340] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(2989), 1,
      sym_keyword_distinct,
    ACTIONS(2991), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8064), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17466] = 6,
    ACTIONS(2993), 1,
      sym_keyword_unsigned,
    ACTIONS(2995), 1,
      sym_keyword_zerofill,
    ACTIONS(2997), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [17538] = 6,
    ACTIONS(2999), 1,
      sym_keyword_unsigned,
    ACTIONS(3001), 1,
      sym_keyword_zerofill,
    ACTIONS(3003), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [17610] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3005), 1,
      sym_keyword_distinct,
    ACTIONS(3007), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7990), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [17736] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_as,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2863), 1,
      sym_keyword_not,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3009), 1,
      sym_keyword_between,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [17838] = 6,
    ACTIONS(3011), 1,
      sym_keyword_unsigned,
    ACTIONS(3013), 1,
      sym_keyword_zerofill,
    ACTIONS(3015), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [17910] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(794), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [17980] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(707), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 51,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18116] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(703), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18186] = 35,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3019), 1,
      sym_keyword_between,
    ACTIONS(3021), 1,
      sym_keyword_unbounded,
    ACTIONS(3023), 1,
      sym_keyword_current,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3027), 1,
      sym_parameter,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6428), 1,
      sym_identifier,
    STATE(6577), 1,
      sym_binary_expression,
    STATE(8424), 1,
      sym_frame_definition,
    STATE(11050), 1,
      sym__current_row,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6579), 2,
      sym__literal_string,
      sym__integer,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(2690), 3,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6253), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18316] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(692), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18386] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(689), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18456] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(683), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18526] = 18,
    ACTIONS(2426), 1,
      sym_keyword_as,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3031), 1,
      sym_keyword_not,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [18622] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(777), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18692] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3034), 1,
      sym_keyword_distinct,
    ACTIONS(3036), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8106), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [18818] = 8,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18894] = 11,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 39,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [18976] = 6,
    ACTIONS(3038), 1,
      sym_keyword_unsigned,
    ACTIONS(3040), 1,
      sym_keyword_zerofill,
    ACTIONS(3042), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [19048] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(742), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [19118] = 33,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3044), 1,
      sym_keyword_distinct,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3050), 1,
      sym_parameter,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7468), 1,
      sym_select_expression,
    STATE(8601), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3124), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19244] = 13,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [19330] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3054), 1,
      sym_keyword_distinct,
    ACTIONS(3056), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8126), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19456] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3058), 1,
      sym_keyword_distinct,
    ACTIONS(3060), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8122), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [19582] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_as,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2863), 1,
      sym_keyword_not,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3009), 1,
      sym_keyword_between,
    ACTIONS(3062), 1,
      sym_keyword_and,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 25,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [19686] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(748), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [19756] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(754), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [19826] = 5,
    ACTIONS(2811), 1,
      sym_keyword_filter,
    STATE(751), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [19896] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3064), 1,
      sym_keyword_distinct,
    ACTIONS(3066), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8118), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20022] = 8,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [20098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_as,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 50,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [20164] = 33,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3068), 1,
      sym_keyword_distinct,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7468), 1,
      sym_select_expression,
    STATE(9400), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20290] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3076), 1,
      sym_keyword_distinct,
    ACTIONS(3078), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8107), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20416] = 33,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(3080), 1,
      sym_keyword_distinct,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3098), 1,
      sym_parameter,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7543), 1,
      sym_select_expression,
    STATE(8524), 1,
      sym_term,
    STATE(11970), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3343), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20542] = 6,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [20614] = 13,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [20700] = 16,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3031), 1,
      sym_keyword_not,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [20792] = 33,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(3118), 1,
      sym_keyword_distinct,
    ACTIONS(3120), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7468), 1,
      sym_select_expression,
    STATE(7547), 1,
      sym_term,
    STATE(11381), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2268), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [20918] = 9,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [20996] = 33,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(3122), 1,
      sym_keyword_distinct,
    ACTIONS(3124), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7502), 1,
      sym_term,
    STATE(7543), 1,
      sym_select_expression,
    STATE(11982), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1956), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21122] = 6,
    ACTIONS(2778), 1,
      sym_keyword_unsigned,
    ACTIONS(2780), 1,
      sym_keyword_zerofill,
    ACTIONS(2784), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [21194] = 6,
    ACTIONS(3126), 1,
      sym_keyword_unsigned,
    ACTIONS(3128), 1,
      sym_keyword_zerofill,
    ACTIONS(3130), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [21266] = 6,
    ACTIONS(3132), 1,
      sym_keyword_unsigned,
    ACTIONS(3134), 1,
      sym_keyword_zerofill,
    ACTIONS(3136), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [21338] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3138), 1,
      sym_keyword_distinct,
    ACTIONS(3140), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8010), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21464] = 6,
    ACTIONS(3142), 1,
      sym_keyword_unsigned,
    ACTIONS(3144), 1,
      sym_keyword_zerofill,
    ACTIONS(3146), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [21536] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3148), 1,
      sym_keyword_distinct,
    ACTIONS(3150), 1,
      anon_sym_RPAREN,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8063), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21662] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5788), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21787] = 34,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3021), 1,
      sym_keyword_unbounded,
    ACTIONS(3023), 1,
      sym_keyword_current,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3027), 1,
      sym_parameter,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6428), 1,
      sym_identifier,
    STATE(6577), 1,
      sym_binary_expression,
    STATE(8216), 1,
      sym_frame_definition,
    STATE(11050), 1,
      sym__current_row,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6579), 2,
      sym__literal_string,
      sym__integer,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(2690), 3,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6253), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [21914] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6101), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22039] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(9400), 1,
      sym_term,
    STATE(11085), 1,
      sym_select_expression,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22162] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [22227] = 5,
    ACTIONS(3158), 1,
      aux_sym__single_quote_string_token2,
    STATE(660), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [22296] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3160), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11039), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22419] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6041), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22544] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6039), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22669] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6038), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22794] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5986), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [22919] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6109), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23044] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6093), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23169] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3162), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10927), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23292] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5825), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23417] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5962), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23542] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5947), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23667] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6034), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23792] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6073), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [23917] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6032), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24042] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6030), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24167] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6066), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24292] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6065), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24417] = 32,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(3120), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7411), 1,
      sym_select_expression,
    STATE(7547), 1,
      sym_term,
    STATE(11381), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2268), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24540] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [24605] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5929), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24730] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6023), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24855] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6019), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [24980] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5939), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25105] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5936), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25230] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6017), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25355] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6016), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25480] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5878), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25605] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5790), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25730] = 5,
    ACTIONS(3164), 1,
      sym_keyword_unsigned,
    ACTIONS(3166), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [25799] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5785), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [25924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [25989] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5998), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26114] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3168), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10956), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26237] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [26302] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5997), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26427] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5870), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [26617] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5995), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26742] = 32,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3098), 1,
      sym_parameter,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(6930), 1,
      sym_all_fields,
    STATE(8524), 1,
      sym_term,
    STATE(11364), 1,
      sym_select_expression,
    STATE(11970), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3343), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [26865] = 5,
    ACTIONS(3170), 1,
      sym_keyword_unsigned,
    ACTIONS(3172), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [26934] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5994), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27059] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5816), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27184] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11213), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27307] = 5,
    ACTIONS(3176), 1,
      aux_sym__single_quote_string_token2,
    STATE(656), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [27376] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6064), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27501] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5817), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27626] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5761), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27751] = 5,
    ACTIONS(3182), 1,
      aux_sym__single_quote_string_token2,
    STATE(523), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [27820] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5775), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [27945] = 5,
    ACTIONS(3184), 1,
      sym_keyword_unsigned,
    ACTIONS(3186), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [28014] = 5,
    ACTIONS(3188), 1,
      sym_keyword_unsigned,
    ACTIONS(3190), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [28083] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [28148] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11205), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [28271] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5786), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [28396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [28461] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3194), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11175), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [28584] = 5,
    ACTIONS(3196), 1,
      sym_keyword_unsigned,
    ACTIONS(3198), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [28653] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [28718] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5993), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [28843] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3200), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10691), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [28966] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5807), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [29091] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5853), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [29216] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 26,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [29315] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3226), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11202), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [29438] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5989), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [29563] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6055), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [29688] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5935), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [29813] = 5,
    STATE(189), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(287), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [29882] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5980), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [30072] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3232), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11139), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30195] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5756), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30320] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3234), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11124), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30443] = 32,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [30631] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3236), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11219), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30754] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3238), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11116), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [30877] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3240), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11104), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [31000] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7411), 1,
      sym_select_expression,
    STATE(9400), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [31123] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6026), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [31248] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3242), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11006), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [31371] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3244), 1,
      sym_keyword_not,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [31466] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [31531] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [31596] = 8,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [31671] = 11,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(2424), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [31752] = 13,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [31837] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5854), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [31962] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5813), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32087] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5974), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32212] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5815), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32337] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3247), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10896), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32460] = 4,
    ACTIONS(3249), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 49,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [32527] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5829), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32652] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [32717] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5973), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32842] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6078), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [32967] = 6,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [33038] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [33103] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [33168] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5972), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [33293] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6083), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [33418] = 32,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(3124), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7502), 1,
      sym_term,
    STATE(7548), 1,
      sym_select_expression,
    STATE(11982), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1956), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [33541] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6043), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [33666] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3251), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11096), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [33789] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5964), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [33914] = 5,
    ACTIONS(3253), 1,
      sym_keyword_unsigned,
    ACTIONS(3255), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [33983] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3257), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11091), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [34106] = 5,
    ACTIONS(3259), 1,
      sym_keyword_precision,
    ACTIONS(3261), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [34175] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6046), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [34300] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3263), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10910), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [34423] = 32,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3098), 1,
      sym_parameter,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7548), 1,
      sym_select_expression,
    STATE(8524), 1,
      sym_term,
    STATE(11970), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3343), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [34546] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 26,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [34645] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6047), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [34770] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3265), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10882), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [34893] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6094), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35018] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6037), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35143] = 5,
    ACTIONS(3267), 1,
      sym_keyword_unsigned,
    ACTIONS(3269), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [35212] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3050), 1,
      sym_parameter,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7411), 1,
      sym_select_expression,
    STATE(8601), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3124), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35335] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6089), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35460] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5940), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35585] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6048), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35710] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3271), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11064), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [35833] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [35898] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3050), 1,
      sym_parameter,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(8601), 1,
      sym_term,
    STATE(11085), 1,
      sym_select_expression,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3124), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [36021] = 4,
    ACTIONS(3273), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [36088] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [36153] = 5,
    ACTIONS(3275), 1,
      sym_keyword_unsigned,
    ACTIONS(3277), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [36222] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6053), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [36347] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5930), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [36472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [36537] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [36602] = 5,
    ACTIONS(3158), 1,
      aux_sym__single_quote_string_token2,
    STATE(660), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [36671] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 40,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [36736] = 34,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3021), 1,
      sym_keyword_unbounded,
    ACTIONS(3023), 1,
      sym_keyword_current,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3027), 1,
      sym_parameter,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6428), 1,
      sym_identifier,
    STATE(6577), 1,
      sym_binary_expression,
    STATE(8659), 1,
      sym_frame_definition,
    STATE(11050), 1,
      sym__current_row,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6579), 2,
      sym__literal_string,
      sym__integer,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(2690), 3,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6253), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [36863] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6092), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [36988] = 5,
    ACTIONS(3279), 1,
      aux_sym__single_quote_string_token2,
    STATE(660), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [37057] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6077), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [37182] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6057), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [37307] = 5,
    ACTIONS(3282), 1,
      sym_keyword_varying,
    ACTIONS(3284), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [37376] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [37477] = 32,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2901), 1,
      sym_parameter,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7365), 1,
      sym_term,
    STATE(7411), 1,
      sym_select_expression,
    STATE(11381), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1829), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [37600] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3288), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10998), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [37723] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [37826] = 16,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3244), 1,
      sym_keyword_not,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [37917] = 9,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [37994] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3292), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10914), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [38117] = 5,
    ACTIONS(3294), 1,
      aux_sym__single_quote_string_token2,
    STATE(671), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1365), 36,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [38186] = 13,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2430), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [38271] = 32,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(2949), 1,
      sym_parameter,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7548), 1,
      sym_select_expression,
    STATE(7718), 1,
      sym_term,
    STATE(11982), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2474), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [38394] = 32,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3297), 1,
      anon_sym_RPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(10952), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [38517] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(6062), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [38642] = 5,
    ACTIONS(3299), 1,
      aux_sym__single_quote_string_token2,
    STATE(671), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1359), 36,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [38711] = 33,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3152), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(5968), 1,
      sym__literal_string,
    STATE(7558), 1,
      sym_all_fields,
    STATE(9588), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3485), 4,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [38836] = 5,
    ACTIONS(3301), 1,
      aux_sym__single_quote_string_token2,
    STATE(676), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1353), 36,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [38905] = 8,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [38980] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 25,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COLON_COLON,
  [39078] = 4,
    ACTIONS(3327), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39144] = 4,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39274] = 4,
    ACTIONS(3331), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39340] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8072), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [39460] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3333), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [39564] = 4,
    ACTIONS(3339), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39630] = 4,
    ACTIONS(3341), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39760] = 5,
    ACTIONS(3343), 1,
      aux_sym__single_quote_string_token2,
    STATE(737), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 7,
      sym_keyword_as,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [39956] = 4,
    ACTIONS(3345), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40022] = 4,
    ACTIONS(3040), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40088] = 31,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(2949), 1,
      sym_parameter,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7467), 1,
      sym_term,
    STATE(11982), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2474), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [40208] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8109), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [40328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 49,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40392] = 4,
    ACTIONS(3347), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40458] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7965), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [40578] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8016), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [40698] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3349), 1,
      sym_keyword_not,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 28,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COLON_COLON,
  [40792] = 4,
    ACTIONS(3352), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40858] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40922] = 4,
    ACTIONS(3354), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [40988] = 16,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3349), 1,
      sym_keyword_not,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41078] = 8,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41152] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41216] = 4,
    ACTIONS(3356), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41282] = 4,
    ACTIONS(3358), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41348] = 11,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(2424), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41428] = 13,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41512] = 4,
    ACTIONS(3360), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 39,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [41642] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [41746] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7959), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [41866] = 6,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [41936] = 4,
    ACTIONS(3368), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42002] = 4,
    ACTIONS(3370), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42068] = 5,
    ACTIONS(3372), 1,
      aux_sym__single_quote_string_token2,
    STATE(690), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 7,
      sym_keyword_as,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42136] = 4,
    ACTIONS(3374), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42202] = 4,
    ACTIONS(3376), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42268] = 4,
    ACTIONS(3378), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42334] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3380), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [42438] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 49,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42502] = 8,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42576] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 24,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COLON_COLON,
  [42676] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7985), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [42796] = 4,
    ACTIONS(3384), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42862] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [42926] = 13,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2430), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [43010] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8001), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [43130] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [43234] = 4,
    ACTIONS(3388), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [43300] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3390), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [43404] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3392), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [43508] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8127), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [43628] = 5,
    ACTIONS(3394), 1,
      aux_sym__single_quote_string_token2,
    STATE(737), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 7,
      sym_keyword_as,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [43696] = 31,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7402), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [43816] = 4,
    ACTIONS(3397), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [43882] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3399), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [43986] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3401), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [44090] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [44154] = 31,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3098), 1,
      sym_parameter,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7467), 1,
      sym_term,
    STATE(11970), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3343), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [44274] = 31,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3050), 1,
      sym_parameter,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7402), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3124), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [44394] = 4,
    ACTIONS(3403), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [44460] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8104), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [44580] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8061), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [44700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [44764] = 4,
    ACTIONS(3405), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [44830] = 4,
    ACTIONS(3407), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [44896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [44960] = 6,
    ACTIONS(3409), 1,
      anon_sym_LBRACK,
    STATE(752), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(1014), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 46,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45030] = 4,
    ACTIONS(3412), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45096] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45224] = 4,
    ACTIONS(3414), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45290] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7997), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [45410] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8053), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [45530] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [45634] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45698] = 31,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2947), 1,
      anon_sym_STAR,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(3124), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(6930), 1,
      sym_all_fields,
    STATE(7467), 1,
      sym_term,
    STATE(11982), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1956), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [45818] = 4,
    ACTIONS(3418), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [45884] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8102), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [46004] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 25,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COLON_COLON,
  [46102] = 31,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(3120), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7402), 1,
      sym_term,
    STATE(11381), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2268), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [46222] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3420), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [46326] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7992), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [46446] = 31,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2901), 1,
      sym_parameter,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(6882), 1,
      sym_all_fields,
    STATE(7402), 1,
      sym_term,
    STATE(11381), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1829), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [46566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [46630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [46694] = 9,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [46770] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8002), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [46890] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(10203), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [47010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47074] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [47178] = 4,
    STATE(290), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47244] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47308] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7949), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [47428] = 31,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3072), 1,
      sym_parameter,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(6882), 1,
      sym_all_fields,
    STATE(11407), 1,
      sym_term,
    STATE(11520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3461), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [47548] = 4,
    ACTIONS(3428), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47614] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [47718] = 4,
    ACTIONS(3432), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47784] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47848] = 4,
    ACTIONS(3434), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [47978] = 4,
    ACTIONS(3261), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48108] = 4,
    ACTIONS(3436), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48174] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(7968), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [48294] = 4,
    ACTIONS(3438), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48360] = 31,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      anon_sym_STAR,
    ACTIONS(2835), 1,
      sym_parameter,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(7558), 1,
      sym_all_fields,
    STATE(8020), 1,
      sym_term,
    STATE(11998), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3385), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [48480] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(3337), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [48584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 49,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48648] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 49,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48712] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 23,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COLON_COLON,
  [48814] = 4,
    ACTIONS(3444), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48880] = 4,
    ACTIONS(3446), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [48946] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49009] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49072] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49135] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49198] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49324] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [49427] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [49530] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49593] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49656] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [49759] = 23,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2479), 1,
      sym_keyword_and,
    ACTIONS(2481), 1,
      sym_keyword_between,
    ACTIONS(3454), 1,
      sym_keyword_as,
    ACTIONS(3456), 1,
      sym_keyword_or,
    ACTIONS(3458), 1,
      anon_sym_COLON_COLON,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3452), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [49862] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49925] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [49988] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50051] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50114] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50177] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50303] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50366] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50429] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 36,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [50555] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50618] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50744] = 31,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3468), 1,
      sym_keyword_current_timestamp,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3476), 1,
      sym_parameter,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    STATE(441), 1,
      sym_identifier,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(2578), 1,
      sym_invocation,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(6762), 1,
      sym__inner_default_expression,
    STATE(11895), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2793), 7,
      sym_array,
      sym_implicit_cast,
      sym_cast,
      sym_binary_expression,
      sym_unary_expression,
      sym_list,
      sym_literal,
    STATE(6186), 9,
      sym_case,
      sym_interval,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_between_expression,
      sym_subquery,
  [50863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50926] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [50989] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51115] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51241] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51367] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51430] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51493] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51619] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51745] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51808] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51871] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [51934] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3399), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [52037] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52163] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52226] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52289] = 31,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3530), 1,
      sym_keyword_current_timestamp,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3536), 1,
      anon_sym_LPAREN,
    ACTIONS(3538), 1,
      sym_parameter,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(2726), 1,
      sym_invocation,
    STATE(6486), 1,
      sym_identifier,
    STATE(6829), 1,
      sym__inner_default_expression,
    STATE(11809), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3083), 7,
      sym_array,
      sym_implicit_cast,
      sym_cast,
      sym_binary_expression,
      sym_unary_expression,
      sym_list,
      sym_literal,
    STATE(6189), 9,
      sym_case,
      sym_interval,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_between_expression,
      sym_subquery,
  [52408] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52471] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52534] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3392), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [52637] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52763] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52826] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52889] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [52952] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53015] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53078] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53141] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3380), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [53244] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3401), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [53347] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3420), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [53450] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53576] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53639] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3390), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [53742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53805] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [53908] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [53971] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3564), 36,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [54097] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3516), 36,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [54223] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54349] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54412] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54475] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54538] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54601] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54664] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54727] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54790] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54853] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54916] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [54979] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55042] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55231] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3333), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [55334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55523] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [55626] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55689] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(3450), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [55792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55855] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [55981] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56107] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56170] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56233] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56296] = 23,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2479), 1,
      sym_keyword_and,
    ACTIONS(2481), 1,
      sym_keyword_between,
    ACTIONS(3456), 1,
      sym_keyword_or,
    ACTIONS(3458), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3628), 1,
      sym_keyword_as,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3626), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56462] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56525] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56588] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56651] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56777] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56840] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56903] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [56966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [57029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 48,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [57092] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 48,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [57155] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [57217] = 29,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3666), 1,
      sym_parameter,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(6971), 1,
      sym_order_target,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2206), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [57331] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3686), 1,
      anon_sym_RBRACK,
    ACTIONS(3688), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5331), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [57445] = 29,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3706), 1,
      sym_parameter,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(7410), 1,
      sym_order_target,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2779), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [57559] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(2089), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [57637] = 30,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3740), 1,
      sym_keyword_not,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3754), 1,
      sym_parameter,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3889), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [57753] = 30,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3776), 1,
      sym_keyword_not,
    ACTIONS(3778), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4167), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [57869] = 29,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3706), 1,
      sym_parameter,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(7666), 1,
      sym_order_target,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2779), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [57983] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3780), 1,
      sym_keyword_when,
    ACTIONS(3782), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6067), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [58097] = 30,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3788), 1,
      sym_keyword_not,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3802), 1,
      sym_parameter,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2298), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [58213] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3822), 1,
      sym_keyword_when,
    ACTIONS(3824), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6068), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [58327] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(725), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [58405] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(4690), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [58483] = 30,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3826), 1,
      sym_keyword_not,
    ACTIONS(3828), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2274), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [58599] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(4445), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [58677] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3830), 1,
      sym_keyword_when,
    ACTIONS(3832), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6061), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [58791] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3834), 1,
      sym_keyword_when,
    ACTIONS(3836), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6069), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [58905] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3838), 1,
      anon_sym_RBRACK,
    ACTIONS(3840), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5395), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59019] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(2742), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [59097] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3842), 1,
      sym_keyword_when,
    ACTIONS(3844), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6071), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59211] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3846), 1,
      anon_sym_RBRACK,
    ACTIONS(3848), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5431), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59325] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3850), 1,
      sym_keyword_when,
    ACTIONS(3852), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6072), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59439] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3854), 1,
      anon_sym_RBRACK,
    ACTIONS(3856), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5440), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59553] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(2264), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [59631] = 7,
    ACTIONS(3858), 1,
      sym_keyword_array,
    STATE(956), 1,
      sym_array_size_definition,
    STATE(1014), 1,
      sym__array_size_definition,
    STATE(1840), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [59701] = 30,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3864), 1,
      sym_keyword_not,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      sym_parameter,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4713), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59817] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [59879] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3898), 1,
      sym_keyword_when,
    ACTIONS(3900), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6075), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [59993] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(501), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [60071] = 30,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3908), 1,
      sym_keyword_not,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3922), 1,
      sym_parameter,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3486), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60187] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3944), 1,
      anon_sym_RBRACK,
    ACTIONS(3946), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5333), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60301] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3948), 1,
      anon_sym_RBRACK,
    ACTIONS(3950), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5291), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60415] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3952), 1,
      sym_keyword_when,
    ACTIONS(3954), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6060), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60529] = 30,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3956), 1,
      sym_keyword_not,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3962), 1,
      sym_parameter,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3903), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60645] = 30,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3968), 1,
      sym_keyword_not,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(3976), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(303), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60761] = 30,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3978), 1,
      sym_keyword_not,
    ACTIONS(3980), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4155), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60877] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3982), 1,
      sym_keyword_when,
    ACTIONS(3984), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6076), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [60991] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3986), 1,
      sym_keyword_when,
    ACTIONS(3988), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5975), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [61105] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3990), 1,
      anon_sym_RBRACK,
    ACTIONS(3992), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5107), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [61219] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [61281] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3009), 1,
      sym_keyword_between,
    ACTIONS(3062), 1,
      sym_keyword_and,
    ACTIONS(3454), 1,
      sym_keyword_as,
    ACTIONS(3994), 1,
      sym_keyword_or,
    ACTIONS(3996), 1,
      anon_sym_COLON_COLON,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3452), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [61383] = 30,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(3998), 1,
      sym_keyword_not,
    ACTIONS(4000), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4398), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [61499] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4002), 1,
      anon_sym_RBRACK,
    ACTIONS(4004), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5356), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [61613] = 7,
    ACTIONS(3858), 1,
      sym_keyword_array,
    STATE(1014), 1,
      sym__array_size_definition,
    STATE(1016), 1,
      sym_array_size_definition,
    STATE(1840), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [61683] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(2565), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [61761] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(1958), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [61839] = 30,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4006), 1,
      sym_keyword_not,
    ACTIONS(4008), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2009), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [61955] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4010), 1,
      sym_keyword_when,
    ACTIONS(4012), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6059), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62069] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4014), 1,
      sym_keyword_when,
    ACTIONS(4016), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6081), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62183] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4018), 1,
      sym_keyword_when,
    ACTIONS(4020), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6056), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62297] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(307), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [62375] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(4156), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [62453] = 29,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3666), 1,
      sym_parameter,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(7269), 1,
      sym_order_target,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2206), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62567] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4022), 1,
      anon_sym_RBRACK,
    ACTIONS(4024), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5148), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62681] = 30,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4030), 1,
      sym_keyword_not,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4044), 1,
      sym_parameter,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(621), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62797] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4064), 1,
      anon_sym_RBRACK,
    ACTIONS(4066), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5474), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [62911] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4068), 1,
      sym_keyword_when,
    ACTIONS(4070), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6088), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [63025] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(4255), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [63103] = 29,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(4072), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(7412), 1,
      sym_order_target,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2410), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [63217] = 30,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4074), 1,
      sym_keyword_not,
    ACTIONS(4076), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2570), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [63333] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(3627), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [63411] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4078), 1,
      anon_sym_RBRACK,
    ACTIONS(4080), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5195), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [63525] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    STATE(2175), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [63595] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4082), 1,
      anon_sym_RBRACK,
    ACTIONS(4084), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5096), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [63709] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(3930), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [63787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 7,
      sym_keyword_as,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 46,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [63849] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4086), 1,
      sym_keyword_when,
    ACTIONS(4088), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6020), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [63963] = 30,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4090), 1,
      sym_keyword_not,
    ACTIONS(4092), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2315), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64079] = 30,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4094), 1,
      sym_keyword_not,
    ACTIONS(4096), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1834), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64195] = 29,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4098), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(7590), 1,
      sym_order_target,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2620), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64309] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(2234), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [64387] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(1957), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [64465] = 29,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4098), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(6971), 1,
      sym_order_target,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2620), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64579] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4100), 1,
      anon_sym_RBRACK,
    ACTIONS(4102), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5099), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64693] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4104), 1,
      sym_keyword_when,
    ACTIONS(4106), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6091), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64807] = 30,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4110), 1,
      sym_keyword_not,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4118), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(506), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [64923] = 29,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4120), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(7410), 1,
      sym_order_target,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3771), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [65037] = 30,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4122), 1,
      sym_keyword_not,
    ACTIONS(4124), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4382), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [65153] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4126), 1,
      anon_sym_RBRACK,
    ACTIONS(4128), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5157), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [65267] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3333), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [65369] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(679), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [65447] = 29,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4120), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(8306), 1,
      sym_order_target,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3771), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [65561] = 30,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4136), 1,
      sym_keyword_not,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4150), 1,
      sym_parameter,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1977), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [65677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [65739] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(4267), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [65817] = 30,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4174), 1,
      sym_keyword_not,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4188), 1,
      sym_parameter,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(716), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [65933] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3009), 1,
      sym_keyword_between,
    ACTIONS(3062), 1,
      sym_keyword_and,
    ACTIONS(3628), 1,
      sym_keyword_as,
    ACTIONS(3994), 1,
      sym_keyword_or,
    ACTIONS(3996), 1,
      anon_sym_COLON_COLON,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3626), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [66035] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3390), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [66137] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4208), 1,
      sym_keyword_when,
    ACTIONS(4210), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6097), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [66251] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3420), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [66353] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(3856), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [66431] = 29,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(4072), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(6971), 1,
      sym_order_target,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2410), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [66545] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4212), 1,
      anon_sym_RBRACK,
    ACTIONS(4214), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5226), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [66659] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4216), 1,
      anon_sym_RBRACK,
    ACTIONS(4218), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5146), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [66773] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4220), 1,
      anon_sym_RBRACK,
    ACTIONS(4222), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5110), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [66887] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(1951), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [66965] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(4407), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [67043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [67105] = 30,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4228), 1,
      sym_keyword_not,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4242), 1,
      sym_parameter,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1984), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [67221] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [67283] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4262), 1,
      anon_sym_RBRACK,
    ACTIONS(4264), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5130), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [67397] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3401), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [67499] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3380), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [67601] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3392), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [67703] = 29,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(4266), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(7410), 1,
      sym_order_target,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2538), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [67817] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3399), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [67919] = 30,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4272), 1,
      sym_keyword_not,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4286), 1,
      sym_parameter,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2141), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [68035] = 30,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4306), 1,
      sym_keyword_not,
    ACTIONS(4308), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4351), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [68151] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2664), 1,
      anon_sym_RPAREN,
    ACTIONS(2666), 1,
      sym_parameter,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5357), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [68265] = 30,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3734), 1,
      sym_keyword_distinct,
    ACTIONS(4310), 1,
      sym_keyword_not,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4316), 1,
      sym_parameter,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 4,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2809), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [68381] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(1870), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [68459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 47,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [68521] = 29,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(4266), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(7438), 1,
      sym_order_target,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2538), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [68635] = 11,
    ACTIONS(3728), 1,
      sym_keyword_distinct,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    ACTIONS(3730), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    STATE(2312), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
    ACTIONS(3726), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [68713] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4320), 1,
      sym_keyword_when,
    ACTIONS(4322), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6063), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [68827] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [68929] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [69031] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [69133] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [69235] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [69337] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3202), 1,
      sym_keyword_in,
    ACTIONS(3204), 1,
      sym_keyword_is,
    ACTIONS(3206), 1,
      sym_keyword_not,
    ACTIONS(3208), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym_op_other,
    ACTIONS(3218), 1,
      anon_sym_PLUS,
    ACTIONS(3220), 1,
      anon_sym_DASH,
    ACTIONS(3222), 1,
      anon_sym_SLASH,
    ACTIONS(3224), 1,
      anon_sym_CARET,
    ACTIONS(3286), 1,
      sym_keyword_between,
    ACTIONS(3290), 1,
      sym_keyword_and,
    ACTIONS(3335), 1,
      sym_keyword_or,
    ACTIONS(4130), 1,
      anon_sym_COLON_COLON,
    STATE(10366), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3212), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3214), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1422), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1423), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3210), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [69439] = 7,
    ACTIONS(4324), 1,
      sym_keyword_unsigned,
    ACTIONS(4326), 1,
      sym_keyword_zerofill,
    ACTIONS(4328), 1,
      sym_keyword_precision,
    ACTIONS(4330), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [69509] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(2609), 1,
      anon_sym_RPAREN,
    ACTIONS(2611), 1,
      sym_parameter,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5142), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [69623] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4332), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4920), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [69734] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4334), 1,
      anon_sym_LPAREN,
    ACTIONS(4336), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5455), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [69845] = 7,
    ACTIONS(4338), 1,
      sym_keyword_array,
    STATE(1946), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2359), 1,
      sym_array_size_definition,
    STATE(2364), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [69914] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4340), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4304), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [70025] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4342), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1957), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [70136] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1900), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [70201] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1950), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [70266] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1954), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [70331] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1894), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [70396] = 7,
    ACTIONS(4346), 1,
      sym_keyword_with,
    ACTIONS(4348), 1,
      sym_keyword_without,
    ACTIONS(4350), 1,
      anon_sym_LPAREN,
    STATE(2098), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [70465] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4352), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4307), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [70576] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2002), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [70641] = 7,
    ACTIONS(4346), 1,
      sym_keyword_with,
    ACTIONS(4348), 1,
      sym_keyword_without,
    ACTIONS(4354), 1,
      anon_sym_LPAREN,
    STATE(2097), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [70710] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4356), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1966), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [70821] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4358), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4400), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [70932] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4360), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2811), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71043] = 7,
    ACTIONS(4338), 1,
      sym_keyword_array,
    STATE(1946), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2364), 1,
      sym__array_size_definition,
    STATE(2367), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [71112] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4362), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1828), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71223] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4364), 1,
      anon_sym_LPAREN,
    ACTIONS(4366), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5151), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71334] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    STATE(2370), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [71403] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4368), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2810), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71514] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4370), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5983), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71625] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4372), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5977), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71736] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2007), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [71801] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2010), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [71866] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(4374), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5843), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [71977] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2011), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [72042] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2013), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [72107] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2012), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [72172] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4308), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4351), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72283] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4376), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4322), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72394] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4378), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5976), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72505] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4380), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4325), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72616] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4382), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4329), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72727] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4384), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4330), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72838] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4386), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4348), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [72949] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4388), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4350), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73060] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4390), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2808), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73171] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4392), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4352), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73282] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4394), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4353), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73393] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4396), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2806), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73504] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4398), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4710), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73615] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(2001), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [73680] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1970), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [73745] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4400), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4249), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73856] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      sym_op_unary_other,
    ACTIONS(4402), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3046), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4255), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [73967] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4404), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2798), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74078] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4406), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2786), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74189] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4408), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5971), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74300] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4410), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2785), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74411] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(4414), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5914), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74522] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1965), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [74587] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4416), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2784), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74698] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4316), 1,
      sym_parameter,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2809), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74809] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4418), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5959), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [74920] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4420), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5958), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75031] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4422), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5956), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75142] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4426), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5903), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75253] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4428), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5954), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75364] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4430), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2780), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75475] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1901), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [75540] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4432), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6595), 1,
      sym_binary_expression,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6294), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75653] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4434), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2777), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75764] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4436), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5952), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75875] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4438), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4709), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [75986] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3333), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [76087] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4442), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5899), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [76198] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1964), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [76263] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1902), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [76328] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4444), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5950), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [76439] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3390), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [76540] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3420), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [76641] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3401), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [76742] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3380), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [76843] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4446), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5949), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [76954] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4448), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5948), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77065] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4450), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5945), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77176] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4452), 1,
      anon_sym_LPAREN,
    ACTIONS(4454), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5241), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77287] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4456), 1,
      anon_sym_LPAREN,
    ACTIONS(4458), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5243), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77398] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4460), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5942), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77509] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4462), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5941), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77620] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4464), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5880), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [77731] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3392), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [77832] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3399), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [77933] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4466), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5927), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [78044] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [78145] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [78246] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4432), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6603), 1,
      sym_binary_expression,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6294), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [78359] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [78460] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4468), 1,
      anon_sym_LPAREN,
    ACTIONS(4470), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5266), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [78571] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4472), 1,
      anon_sym_LPAREN,
    ACTIONS(4474), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5269), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [78682] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4476), 1,
      anon_sym_LPAREN,
    ACTIONS(4478), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5302), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [78793] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4480), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5926), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [78904] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4482), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5925), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79015] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4484), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5826), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79126] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4486), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5842), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79237] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4488), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5923), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79348] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1952), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [79413] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4492), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5922), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79524] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4494), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5918), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79635] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4496), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5917), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79746] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4498), 1,
      anon_sym_LPAREN,
    ACTIONS(4500), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5312), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79857] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4502), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5916), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [79968] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [80069] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [80170] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(3303), 1,
      sym_keyword_in,
    ACTIONS(3305), 1,
      sym_keyword_is,
    ACTIONS(3307), 1,
      sym_keyword_not,
    ACTIONS(3309), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      sym_op_other,
    ACTIONS(3319), 1,
      anon_sym_PLUS,
    ACTIONS(3321), 1,
      anon_sym_DASH,
    ACTIONS(3323), 1,
      anon_sym_SLASH,
    ACTIONS(3325), 1,
      anon_sym_CARET,
    ACTIONS(3382), 1,
      sym_keyword_between,
    ACTIONS(3442), 1,
      sym_keyword_and,
    ACTIONS(3448), 1,
      sym_keyword_or,
    ACTIONS(4440), 1,
      anon_sym_COLON_COLON,
    STATE(11198), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3313), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3315), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1444), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1445), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(3311), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [80271] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4504), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5912), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [80382] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4506), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5910), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [80493] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4508), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5909), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [80604] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4510), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5016), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [80715] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1904), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [80780] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4512), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5907), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [80891] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4514), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4696), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81002] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4516), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5906), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81113] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4518), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2867), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81224] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4520), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5892), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81335] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1919), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [81400] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4522), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1935), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81511] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4524), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1037), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81622] = 5,
    ACTIONS(4344), 1,
      sym_keyword_filter,
    STATE(1955), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [81687] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4526), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1036), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81798] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4528), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5820), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [81909] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4530), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1035), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82020] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4532), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5030), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82131] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4534), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1034), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82242] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4536), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1033), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82353] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4538), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1032), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82464] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3878), 1,
      sym_parameter,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4713), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82575] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4540), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4728), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82686] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4542), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5891), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82797] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4544), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5890), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [82908] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4546), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5889), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83019] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4548), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5888), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83130] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4550), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4445), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83241] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4552), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4447), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83352] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4554), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4394), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83463] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4556), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6185), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83574] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4558), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4732), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83685] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4560), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4396), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83796] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4562), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4399), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [83907] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4564), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4731), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84018] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4566), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4729), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84129] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4568), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5887), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84240] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4570), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4401), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84351] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4572), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4510), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84462] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4574), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5744), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84573] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4576), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4408), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84684] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4578), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4413), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84795] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4580), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6184), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [84906] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4582), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4670), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85017] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4584), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5886), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85128] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4000), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4398), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85239] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4586), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5885), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85350] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4588), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5884), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85461] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4590), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2260), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85572] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4592), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5883), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85683] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4594), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4715), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85794] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4596), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4714), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [85905] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4598), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5881), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86016] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4600), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4712), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86127] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4602), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5879), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86238] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4604), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5869), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86349] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4606), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4711), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86460] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4608), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5867), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86571] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4610), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1916), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86682] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4612), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5866), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86793] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1895), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [86858] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4614), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5865), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [86969] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4616), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5858), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87080] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4618), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5857), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87191] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4620), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4416), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87302] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3048), 1,
      anon_sym_LPAREN,
    ACTIONS(3074), 1,
      sym_op_unary_other,
    ACTIONS(4622), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(4378), 1,
      sym_identifier,
    STATE(5103), 1,
      sym_invocation,
    STATE(11997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3070), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4417), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87413] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4624), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1870), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87524] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4626), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2247), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87635] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4628), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2226), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87746] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4630), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2812), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87857] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4632), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2214), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [87968] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4634), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2180), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88079] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4636), 1,
      anon_sym_LPAREN,
    ACTIONS(4638), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5386), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88190] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4640), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2110), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88301] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4642), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4695), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88412] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4644), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2215), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88523] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4646), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2081), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88634] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4648), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2077), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88745] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(4650), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2627), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88856] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4654), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4652), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1105), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [88969] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(3828), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2274), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89080] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4656), 1,
      anon_sym_LPAREN,
    ACTIONS(4658), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5324), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89191] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4660), 1,
      anon_sym_LPAREN,
    ACTIONS(4662), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5325), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89302] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4664), 1,
      anon_sym_LPAREN,
    ACTIONS(4666), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5326), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89413] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(4668), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3572), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89524] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4670), 1,
      anon_sym_LPAREN,
    ACTIONS(4672), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5327), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89635] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4674), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1855), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89746] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4432), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6604), 1,
      sym_binary_expression,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6294), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89859] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4676), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1842), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [89970] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4678), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5919), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90081] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4680), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5414), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90192] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4682), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1826), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90303] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4684), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1813), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90414] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1981), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [90479] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4688), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4686), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1110), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90592] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4690), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5800), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90703] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1982), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [90768] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1986), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [90833] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4692), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1853), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [90944] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4696), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4694), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(766), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91057] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4698), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5898), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91168] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4702), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4700), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1111), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91281] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4706), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4704), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1112), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91394] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4708), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5913), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91505] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4712), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4710), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1113), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91618] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4716), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4714), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1122), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91731] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4720), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4718), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1123), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91844] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4724), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4722), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(734), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [91957] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4726), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5803), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92068] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4728), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5802), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92179] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4730), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5856), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92290] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4732), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1879), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92401] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(4734), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2935), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92512] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4736), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1885), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92623] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4738), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1976), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92734] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4740), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6255), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92845] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4742), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1125), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [92956] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4744), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5745), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93067] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4746), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1931), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93178] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4748), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1930), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93289] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4750), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1897), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93400] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4752), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1896), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93511] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4754), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1126), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93622] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [93685] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(2061), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [93750] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4756), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1128), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [93861] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(2058), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [93926] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4758), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1143), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94037] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4760), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1144), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94148] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4762), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1145), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94259] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4764), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4665), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94370] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4766), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4258), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94481] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4768), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4152), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94592] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(2056), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [94657] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4770), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1893), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [94768] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(2051), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [94833] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(2042), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [94898] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4772), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1891), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95009] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(4008), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2009), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95120] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(4774), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4683), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95231] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(4776), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(904), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95342] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4778), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4149), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95453] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [95514] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4780), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4146), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95625] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4782), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4145), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95736] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4784), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1865), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95847] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4786), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4139), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [95958] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4788), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5439), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96069] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4790), 1,
      anon_sym_LPAREN,
    ACTIONS(4792), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5402), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96180] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4794), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1864), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96291] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4796), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4138), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96402] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4798), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4128), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96513] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4800), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4127), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96624] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3980), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4155), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96735] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4802), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4126), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96846] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4804), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5695), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [96957] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4806), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4125), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97068] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4808), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1871), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97179] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4812), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4810), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(741), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97292] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4814), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4624), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97403] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(4816), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3355), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97514] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3096), 1,
      anon_sym_LPAREN,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3104), 1,
      sym_op_unary_other,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(4818), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5627), 1,
      sym_invocation,
    STATE(11835), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3086), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4156), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97625] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4096), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1834), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97736] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4820), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(586), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97847] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(4822), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2089), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [97958] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4824), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2636), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98069] = 6,
    ACTIONS(4826), 1,
      sym_keyword_unsigned,
    ACTIONS(4828), 1,
      sym_keyword_zerofill,
    ACTIONS(4830), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [98136] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4832), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2741), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98247] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4834), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6187), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98358] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4836), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5493), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98469] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(4838), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4721), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98580] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4840), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2019), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98691] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4842), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6188), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98802] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4844), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5089), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [98913] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4846), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(714), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99024] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4848), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6103), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99135] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4850), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5087), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99246] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4852), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(636), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99357] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4854), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3002), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99468] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4856), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6040), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99579] = 6,
    ACTIONS(4324), 1,
      sym_keyword_unsigned,
    ACTIONS(4326), 1,
      sym_keyword_zerofill,
    ACTIONS(4330), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [99646] = 6,
    ACTIONS(4858), 1,
      sym_keyword_unsigned,
    ACTIONS(4860), 1,
      sym_keyword_zerofill,
    ACTIONS(4862), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [99713] = 6,
    ACTIONS(4864), 1,
      sym_keyword_unsigned,
    ACTIONS(4866), 1,
      sym_keyword_zerofill,
    ACTIONS(4868), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [99780] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(4870), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2147), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [99891] = 6,
    ACTIONS(4872), 1,
      sym_keyword_unsigned,
    ACTIONS(4874), 1,
      sym_keyword_zerofill,
    ACTIONS(4876), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [99958] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4878), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6028), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [100069] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(4880), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(725), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [100180] = 6,
    ACTIONS(4882), 1,
      sym_keyword_unsigned,
    ACTIONS(4884), 1,
      sym_keyword_zerofill,
    ACTIONS(4886), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [100247] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4888), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(759), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [100358] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4890), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5937), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [100469] = 6,
    ACTIONS(4892), 1,
      sym_keyword_unsigned,
    ACTIONS(4894), 1,
      sym_keyword_zerofill,
    ACTIONS(4896), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [100536] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(4898), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5960), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [100647] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(2003), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [100712] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4900), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(957), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [100823] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1998), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [100888] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1996), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [100953] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4902), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6305), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101064] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4906), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4904), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1022), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101177] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4908), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(775), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101288] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4910), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5677), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101399] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4912), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2742), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101510] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4916), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4914), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1020), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101623] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(4918), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5632), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101734] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1988), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [101799] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4920), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6087), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [101910] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4922), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6304), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102021] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4924), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(501), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102132] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4928), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4926), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1019), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102245] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4930), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4904), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(740), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102358] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4932), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2069), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102469] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1983), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [102534] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(4934), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5399), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102645] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4936), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4810), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1018), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102758] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4938), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4926), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(723), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102871] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(4942), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4940), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1941), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [102984] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(4944), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4525), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103095] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4946), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(781), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103206] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4948), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4694), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1006), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103319] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4950), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4722), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1004), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103432] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4952), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5014), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103543] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4954), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5837), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103654] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4956), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5012), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103765] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(4958), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5365), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103876] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4960), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1003), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [103987] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4962), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5882), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104098] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(4966), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4964), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2023), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104211] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(4970), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4968), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2024), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104324] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4972), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(732), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104435] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(4974), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2565), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104546] = 6,
    ACTIONS(4976), 1,
      sym_keyword_unsigned,
    ACTIONS(4978), 1,
      sym_keyword_zerofill,
    ACTIONS(4980), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [104613] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(4982), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3423), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104724] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(4986), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4984), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2028), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104837] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(4990), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4988), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2027), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [104950] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4994), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4992), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(996), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105063] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(4996), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(792), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105174] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4998), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5932), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105285] = 28,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2885), 1,
      sym_keyword_cast,
    ACTIONS(2887), 1,
      sym_keyword_case,
    ACTIONS(2891), 1,
      sym_keyword_exists,
    ACTIONS(2895), 1,
      sym_keyword_interval,
    ACTIONS(2897), 1,
      sym_keyword_array,
    ACTIONS(2899), 1,
      anon_sym_LPAREN,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2907), 1,
      sym_op_unary_other,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(5000), 1,
      sym_parameter,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(2733), 1,
      sym_identifier,
    STATE(3671), 1,
      sym_invocation,
    STATE(3899), 1,
      sym__qualified_field,
    STATE(11544), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2889), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1922), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [105457] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5002), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5934), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105568] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(5004), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2185), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105679] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5008), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5006), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1989), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [105853] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5010), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5862), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [105964] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5012), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6190), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106075] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5014), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5477), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106186] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [106247] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5016), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6191), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106358] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5018), 1,
      anon_sym_LPAREN,
    ACTIONS(5020), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5452), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [106530] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [106591] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5022), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4990), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106702] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5024), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6100), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106813] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5026), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4988), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [106924] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1945), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [106989] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5028), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5824), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 45,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [107161] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1937), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [107226] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5030), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2328), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107337] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5032), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2330), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107448] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5034), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5004), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107559] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4286), 1,
      sym_parameter,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2141), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107670] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5036), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2076), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107781] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5038), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2087), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [107892] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5040), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2088), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108003] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5042), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2179), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108114] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5044), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6035), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108225] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5046), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2304), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108336] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5048), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2305), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108447] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5050), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5905), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108558] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5052), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2317), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108669] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5054), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2316), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108780] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5056), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2117), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [108891] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5058), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3627), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109002] = 29,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4234), 1,
      sym_keyword_null,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5062), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5060), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1944), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109115] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(5064), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4663), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109226] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5066), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5739), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109337] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4044), 1,
      sym_parameter,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(621), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109448] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5068), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(605), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109559] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1932), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [109624] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5070), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5992), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109735] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5072), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4407), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109846] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5074), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4511), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [109957] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5076), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4384), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110068] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5078), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4383), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110179] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5080), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4380), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110290] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5082), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4377), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110401] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5084), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2495), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110512] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5086), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5978), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110623] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5088), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6295), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110734] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5090), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5592), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110845] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5092), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6328), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [110956] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5094), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4977), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111067] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5096), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(680), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111178] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5098), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(764), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111289] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5100), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6008), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111400] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5102), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4924), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111511] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5104), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(809), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111622] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5106), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5902), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111733] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4188), 1,
      sym_parameter,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(716), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111844] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5108), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(701), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [111955] = 7,
    ACTIONS(5110), 1,
      sym_keyword_unsigned,
    ACTIONS(5112), 1,
      sym_keyword_zerofill,
    ACTIONS(5114), 1,
      sym_keyword_precision,
    ACTIONS(5116), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [112024] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5118), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(706), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112135] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5120), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(710), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112246] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4150), 1,
      sym_parameter,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1977), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112357] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5122), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(711), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112468] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5124), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(771), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112579] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5126), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(705), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112690] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5128), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5900), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112801] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5130), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(795), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [112912] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5132), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(726), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113023] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5134), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(730), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113134] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5136), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2234), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113245] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5138), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2049), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113356] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5140), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2047), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113467] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5142), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2045), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113578] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5144), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2043), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113689] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5146), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1980), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113800] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5148), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1978), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [113911] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(5150), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4717), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114022] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5152), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1975), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114133] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5154), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1973), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114244] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5156), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5894), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114355] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5158), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6193), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114466] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5160), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5693), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114577] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5162), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6194), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114688] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4371), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114799] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5166), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4945), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [114910] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5168), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5872), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115021] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5170), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4370), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115132] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5172), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4943), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115243] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5174), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5821), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115354] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5176), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(455), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115465] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5178), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(446), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115576] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5180), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4369), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115687] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(4118), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(506), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115798] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5182), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(485), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [115909] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5184), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(488), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116020] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5186), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(489), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116131] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5188), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(493), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116242] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5190), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(510), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116353] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5192), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(508), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116464] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5194), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5819), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116575] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5196), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(496), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116686] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5198), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(475), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116797] = 28,
    ACTIONS(701), 1,
      sym__identifier,
    ACTIONS(759), 1,
      aux_sym_identifier_token1,
    ACTIONS(3526), 1,
      sym_keyword_cast,
    ACTIONS(3534), 1,
      sym_keyword_array,
    ACTIONS(3540), 1,
      anon_sym_PLUS,
    ACTIONS(3542), 1,
      anon_sym_DASH,
    ACTIONS(3544), 1,
      sym_op_unary_other,
    ACTIONS(3546), 1,
      sym__double_quote_string,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3550), 1,
      aux_sym__integer_token1,
    ACTIONS(3552), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3554), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3556), 1,
      sym__dollar_quoted_string,
    ACTIONS(4108), 1,
      sym_keyword_case,
    ACTIONS(4112), 1,
      sym_keyword_exists,
    ACTIONS(4114), 1,
      sym_keyword_interval,
    ACTIONS(4116), 1,
      anon_sym_LPAREN,
    ACTIONS(5200), 1,
      sym_parameter,
    STATE(979), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_invocation,
    STATE(2165), 1,
      sym__qualified_field,
    STATE(2205), 1,
      sym__single_quote_string,
    STATE(11814), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3532), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3528), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2159), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(507), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [116908] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5202), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5758), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117019] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5204), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3856), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117130] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5206), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6321), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117241] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5208), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4368), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117352] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5210), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5751), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117463] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5212), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6322), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117574] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5214), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4931), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117685] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5216), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5847), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117796] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5218), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1960), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [117907] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5220), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1958), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118018] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5222), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4932), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118129] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(4124), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4382), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118240] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5224), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5849), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118351] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5226), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(298), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118462] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5228), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5851), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118573] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5230), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5874), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118684] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5232), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6195), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118795] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5234), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5603), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [118906] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5236), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6197), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119017] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5238), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4958), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119128] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5240), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2366), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119239] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5242), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2377), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119350] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5244), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5846), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119461] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(4076), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2570), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119572] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5246), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2422), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119683] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5248), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2425), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119794] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5250), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2426), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [119905] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5252), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2429), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120016] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5254), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2457), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120127] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5256), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2458), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120238] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5258), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4918), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120349] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5260), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2459), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120460] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5262), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5963), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120571] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(5264), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5795), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120682] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(5266), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6084), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120793] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5268), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5965), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [120904] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5270), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6306), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121015] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5272), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2460), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121126] = 28,
    ACTIONS(517), 1,
      sym__identifier,
    ACTIONS(575), 1,
      aux_sym_identifier_token1,
    ACTIONS(3690), 1,
      sym_keyword_cast,
    ACTIONS(3692), 1,
      sym_keyword_case,
    ACTIONS(3696), 1,
      sym_keyword_exists,
    ACTIONS(3700), 1,
      sym_keyword_interval,
    ACTIONS(3702), 1,
      sym_keyword_array,
    ACTIONS(3704), 1,
      anon_sym_LPAREN,
    ACTIONS(3708), 1,
      anon_sym_PLUS,
    ACTIONS(3710), 1,
      anon_sym_DASH,
    ACTIONS(3712), 1,
      sym_op_unary_other,
    ACTIONS(3714), 1,
      sym__double_quote_string,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3718), 1,
      aux_sym__integer_token1,
    ACTIONS(3720), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3722), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3724), 1,
      sym__dollar_quoted_string,
    ACTIONS(5274), 1,
      sym_parameter,
    STATE(3287), 1,
      sym_identifier,
    STATE(4389), 1,
      sym_invocation,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4706), 1,
      sym__qualified_field,
    STATE(11817), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3698), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3694), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4694), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2572), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121237] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5276), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2312), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121348] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5278), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(608), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121459] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5280), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(609), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121570] = 5,
    ACTIONS(4490), 1,
      sym_keyword_filter,
    STATE(1921), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [121635] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5282), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(610), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121746] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5284), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(669), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121857] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5286), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4364), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [121968] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5288), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(668), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122079] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4363), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122190] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5292), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5967), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122301] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5294), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6198), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122412] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5296), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5571), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122523] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5298), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6012), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122634] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5300), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6006), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122745] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5302), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6199), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122856] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5304), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4979), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [122967] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5306), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5981), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123078] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5308), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5774), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123189] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5310), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4981), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123300] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5312), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5855), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123411] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5314), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4487), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123522] = 7,
    ACTIONS(5316), 1,
      sym_keyword_unsigned,
    ACTIONS(5318), 1,
      sym_keyword_zerofill,
    ACTIONS(5320), 1,
      sym_keyword_precision,
    ACTIONS(5322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [123591] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5324), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1867), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123702] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5326), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2766), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123813] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5328), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(667), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [123924] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5330), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5988), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124035] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(5332), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4690), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124146] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5334), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3927), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124257] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5336), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5990), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124368] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5338), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4992), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(686), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124481] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5340), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6200), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124592] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5342), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5541), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124703] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5344), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6196), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124814] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5346), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5009), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [124925] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5348), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6007), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125036] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5350), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5011), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125147] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5352), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6205), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125258] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5354), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(306), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125369] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(305), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125480] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5358), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6009), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125591] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5360), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5955), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125702] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5362), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3545), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125813] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5364), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3521), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [125924] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5366), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6203), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126035] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3922), 1,
      sym_parameter,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3486), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126146] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5368), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3433), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126257] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5370), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3480), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126368] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5372), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4354), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126479] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5374), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3481), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126590] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5376), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4355), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126701] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5378), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4267), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126812] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5380), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3488), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [126923] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5382), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3583), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127034] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5384), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3639), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127145] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5386), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5536), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127256] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5388), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3638), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127367] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5390), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3635), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127478] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5392), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3622), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127589] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5394), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1951), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127700] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5396), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4238), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127811] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5398), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4358), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [127922] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5400), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(304), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128033] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5402), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(309), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128144] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5404), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4359), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128255] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5406), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4214), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128366] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5408), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4208), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128477] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5410), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4202), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128588] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5412), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4200), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128699] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3754), 1,
      sym_parameter,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3889), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128810] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5414), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4084), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [128921] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5416), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4072), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129032] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5418), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(299), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129143] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5420), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(664), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129254] = 28,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4132), 1,
      sym_keyword_cast,
    ACTIONS(4134), 1,
      sym_keyword_case,
    ACTIONS(4138), 1,
      sym_keyword_exists,
    ACTIONS(4144), 1,
      sym_keyword_interval,
    ACTIONS(4146), 1,
      sym_keyword_array,
    ACTIONS(4148), 1,
      anon_sym_LPAREN,
    ACTIONS(4152), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_DASH,
    ACTIONS(4156), 1,
      sym_op_unary_other,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4162), 1,
      aux_sym__integer_token1,
    ACTIONS(4164), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4166), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(5422), 1,
      sym_parameter,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(2711), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_invocation,
    STATE(3959), 1,
      sym__qualified_field,
    STATE(11969), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4142), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4140), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3940), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2560), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129365] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4412), 1,
      anon_sym_LPAREN,
    ACTIONS(5424), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5871), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129476] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5426), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6204), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129587] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5428), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4185), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129698] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(301), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129809] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5432), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5023), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [129920] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5434), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4174), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130031] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5436), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4166), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130142] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5438), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4163), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130253] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(5440), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4743), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130364] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5442), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4101), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130475] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5444), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4100), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130586] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5446), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4094), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130697] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5448), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4393), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130808] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5450), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6021), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [130919] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5452), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5024), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131030] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5454), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2772), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131141] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5456), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(297), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131252] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5458), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6044), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131363] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5460), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5594), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131474] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5462), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(302), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131585] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5464), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2311), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131696] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(3976), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(303), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131807] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5466), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4093), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [131918] = 29,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4036), 1,
      sym_keyword_null,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5468), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4914), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(735), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132031] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5470), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6025), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132142] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5472), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6031), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132253] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5474), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6018), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132364] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5476), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2145), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132475] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5478), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2267), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132586] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5480), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5499), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132697] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3802), 1,
      sym_parameter,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2298), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132808] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5482), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2285), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [132919] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5484), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2284), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133030] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(3778), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4167), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133141] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5486), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2282), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133252] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5488), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2281), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133363] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5490), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2128), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133474] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5492), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2126), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133585] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5494), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6206), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133696] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5496), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2116), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133807] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5498), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2114), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [133918] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5500), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2240), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134029] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5502), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(679), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134140] = 28,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(1089), 1,
      aux_sym_identifier_token1,
    ACTIONS(3860), 1,
      sym_keyword_cast,
    ACTIONS(3862), 1,
      sym_keyword_case,
    ACTIONS(3866), 1,
      sym_keyword_exists,
    ACTIONS(3872), 1,
      sym_keyword_interval,
    ACTIONS(3874), 1,
      sym_keyword_array,
    ACTIONS(3876), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      anon_sym_PLUS,
    ACTIONS(3882), 1,
      anon_sym_DASH,
    ACTIONS(3884), 1,
      sym_op_unary_other,
    ACTIONS(3886), 1,
      sym__double_quote_string,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3890), 1,
      aux_sym__integer_token1,
    ACTIONS(3892), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3894), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3896), 1,
      sym__dollar_quoted_string,
    ACTIONS(5504), 1,
      sym_parameter,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(5437), 1,
      sym_identifier,
    STATE(6217), 1,
      sym_invocation,
    STATE(6384), 1,
      sym__qualified_field,
    STATE(11941), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3870), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3868), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(6390), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4704), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134251] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5506), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2220), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134362] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5508), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5029), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134473] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5510), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2216), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134584] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5512), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6070), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134695] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5514), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5042), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134806] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5516), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5985), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [134917] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5518), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6110), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135028] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5520), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6102), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135139] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5522), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5199), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135250] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5526), 1,
      anon_sym_LPAREN,
    ACTIONS(5528), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5216), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135361] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5530), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2086), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135472] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5532), 1,
      anon_sym_LPAREN,
    ACTIONS(5534), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5230), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135583] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5536), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6207), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135694] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5538), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2196), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135805] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5540), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5488), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [135916] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5542), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6201), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136027] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5544), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2189), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136138] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5546), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5058), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136249] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5548), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6058), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136360] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5550), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5046), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136471] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5552), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6054), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136582] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5554), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6051), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136693] = 28,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5556), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4278), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2183), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136804] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5558), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5780), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [136915] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5560), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6208), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137026] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5562), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5672), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137137] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5564), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4804), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137248] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5566), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5747), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137359] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5568), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5661), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137470] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5570), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4652), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(889), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137583] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5572), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5489), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137694] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5574), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4105), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137805] = 28,
    ACTIONS(899), 1,
      sym__identifier,
    ACTIONS(957), 1,
      aux_sym_identifier_token1,
    ACTIONS(4026), 1,
      sym_keyword_cast,
    ACTIONS(4028), 1,
      sym_keyword_case,
    ACTIONS(4032), 1,
      sym_keyword_exists,
    ACTIONS(4038), 1,
      sym_keyword_interval,
    ACTIONS(4040), 1,
      sym_keyword_array,
    ACTIONS(4042), 1,
      anon_sym_LPAREN,
    ACTIONS(4046), 1,
      anon_sym_PLUS,
    ACTIONS(4048), 1,
      anon_sym_DASH,
    ACTIONS(4050), 1,
      sym_op_unary_other,
    ACTIONS(4052), 1,
      sym__double_quote_string,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4056), 1,
      aux_sym__integer_token1,
    ACTIONS(4058), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4060), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4062), 1,
      sym__dollar_quoted_string,
    ACTIONS(5576), 1,
      sym_parameter,
    STATE(1059), 1,
      sym_identifier,
    STATE(2227), 1,
      sym_invocation,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2449), 1,
      sym__qualified_field,
    STATE(11882), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4036), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4034), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2384), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(672), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [137916] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5578), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6209), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138027] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5580), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5044), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138138] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5582), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6049), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138249] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5584), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5037), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138360] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5586), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6045), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138471] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5588), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3948), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138582] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5590), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4013), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138693] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5592), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6024), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138804] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3962), 1,
      sym_parameter,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3903), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [138915] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5594), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4204), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139026] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5596), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4205), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139137] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5598), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4206), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139248] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5600), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4211), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139359] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5602), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4290), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139470] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5604), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4291), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139581] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5606), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(310), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139692] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5608), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6210), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139803] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5610), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4299), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [139914] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5612), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4324), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140025] = 28,
    ACTIONS(959), 1,
      sym__identifier,
    ACTIONS(963), 1,
      aux_sym_identifier_token1,
    ACTIONS(3082), 1,
      sym_keyword_cast,
    ACTIONS(3084), 1,
      sym_keyword_case,
    ACTIONS(3088), 1,
      sym_keyword_exists,
    ACTIONS(3092), 1,
      sym_keyword_interval,
    ACTIONS(3094), 1,
      sym_keyword_array,
    ACTIONS(3100), 1,
      anon_sym_PLUS,
    ACTIONS(3102), 1,
      anon_sym_DASH,
    ACTIONS(3106), 1,
      sym__double_quote_string,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3110), 1,
      aux_sym__integer_token1,
    ACTIONS(3112), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3114), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3116), 1,
      sym__dollar_quoted_string,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
    ACTIONS(3964), 1,
      sym_op_unary_other,
    ACTIONS(5614), 1,
      sym_parameter,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4196), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__qualified_field,
    STATE(5727), 1,
      sym_invocation,
    STATE(11861), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3090), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3958), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4863), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3873), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140136] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5616), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3930), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140247] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5618), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(895), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140358] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5620), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5576), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140469] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5622), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(893), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140580] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5624), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3088), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140691] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5626), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(867), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140802] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5628), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5724), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [140913] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5630), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(805), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141024] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5632), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6212), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141135] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5634), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(804), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141246] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5636), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5691), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141357] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5638), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4686), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(865), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141470] = 28,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5640), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4180), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(808), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141581] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5642), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4700), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(861), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141694] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5644), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4929), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141805] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym_op_unary_other,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(5646), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(4378), 1,
      sym_identifier,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2438), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5008), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [141916] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5648), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5708), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142027] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5650), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5943), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142138] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5652), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4954), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142249] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5654), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5757), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142360] = 28,
    ACTIONS(577), 1,
      sym__identifier,
    ACTIONS(635), 1,
      aux_sym_identifier_token1,
    ACTIONS(3784), 1,
      sym_keyword_cast,
    ACTIONS(3786), 1,
      sym_keyword_case,
    ACTIONS(3790), 1,
      sym_keyword_exists,
    ACTIONS(3796), 1,
      sym_keyword_interval,
    ACTIONS(3798), 1,
      sym_keyword_array,
    ACTIONS(3800), 1,
      anon_sym_LPAREN,
    ACTIONS(3804), 1,
      anon_sym_PLUS,
    ACTIONS(3806), 1,
      anon_sym_DASH,
    ACTIONS(3808), 1,
      sym_op_unary_other,
    ACTIONS(3810), 1,
      sym__double_quote_string,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3814), 1,
      aux_sym__integer_token1,
    ACTIONS(3816), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3818), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3820), 1,
      sym__dollar_quoted_string,
    ACTIONS(5656), 1,
      sym_parameter,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(3035), 1,
      sym_identifier,
    STATE(4140), 1,
      sym_invocation,
    STATE(4464), 1,
      sym__qualified_field,
    STATE(11831), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3794), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3792), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4446), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2581), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142471] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5658), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5911), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142582] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5660), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5893), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142693] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5662), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6317), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142804] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5664), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5476), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [142915] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5666), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6307), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143026] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5668), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4927), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143137] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5670), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5782), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143248] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5672), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4928), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143359] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5674), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2096), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143470] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5676), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2277), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143581] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5678), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5778), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143692] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(4092), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2315), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143803] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5680), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2276), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [143914] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5682), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2256), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144025] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5684), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2302), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144136] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5686), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2303), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144247] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5688), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2300), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144358] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5690), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2301), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144469] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5692), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5765), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144580] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5694), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2294), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144691] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5696), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2279), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144802] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5698), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5764), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [144913] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5700), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4704), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(860), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145026] = 28,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2931), 1,
      sym_keyword_cast,
    ACTIONS(2933), 1,
      sym_keyword_case,
    ACTIONS(2937), 1,
      sym_keyword_exists,
    ACTIONS(2941), 1,
      sym_keyword_interval,
    ACTIONS(2943), 1,
      sym_keyword_array,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2955), 1,
      sym_op_unary_other,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(5702), 1,
      sym_parameter,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(2882), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_invocation,
    STATE(4609), 1,
      sym__qualified_field,
    STATE(11850), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2935), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2313), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145137] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5704), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(307), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145248] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5708), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5706), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2246), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145361] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5712), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5710), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2243), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145474] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5714), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4710), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(859), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145587] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5716), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5610), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145698] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5718), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6213), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145809] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5720), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1939), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [145920] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5722), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5584), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146031] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5726), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5724), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2238), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146144] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5730), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5728), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2235), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146257] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5732), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1942), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146368] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5734), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5812), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146479] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5736), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6214), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146590] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5738), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4953), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146701] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5740), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4714), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(850), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146814] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5744), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5742), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2225), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [146927] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5748), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5746), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2221), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147040] = 29,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(4432), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(6612), 1,
      sym_binary_expression,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6294), 15,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147153] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5750), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1963), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147264] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5752), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3958), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147375] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5754), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4668), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147486] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5756), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5901), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147597] = 29,
    ACTIONS(637), 1,
      sym__identifier,
    ACTIONS(695), 1,
      aux_sym_identifier_token1,
    ACTIONS(4268), 1,
      sym_keyword_cast,
    ACTIONS(4270), 1,
      sym_keyword_case,
    ACTIONS(4274), 1,
      sym_keyword_exists,
    ACTIONS(4278), 1,
      sym_keyword_null,
    ACTIONS(4280), 1,
      sym_keyword_interval,
    ACTIONS(4282), 1,
      sym_keyword_array,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4288), 1,
      anon_sym_PLUS,
    ACTIONS(4290), 1,
      anon_sym_DASH,
    ACTIONS(4292), 1,
      sym_op_unary_other,
    ACTIONS(4294), 1,
      sym__double_quote_string,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4298), 1,
      aux_sym__integer_token1,
    ACTIONS(4300), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4302), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4304), 1,
      sym__dollar_quoted_string,
    ACTIONS(5760), 1,
      sym_parameter,
    STATE(2958), 1,
      sym_identifier,
    STATE(4144), 1,
      sym_invocation,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4431), 1,
      sym__qualified_field,
    STATE(11807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5758), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4276), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4564), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2187), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147710] = 29,
    ACTIONS(457), 1,
      sym__identifier,
    ACTIONS(515), 1,
      aux_sym_identifier_token1,
    ACTIONS(4170), 1,
      sym_keyword_cast,
    ACTIONS(4172), 1,
      sym_keyword_case,
    ACTIONS(4176), 1,
      sym_keyword_exists,
    ACTIONS(4180), 1,
      sym_keyword_null,
    ACTIONS(4182), 1,
      sym_keyword_interval,
    ACTIONS(4184), 1,
      sym_keyword_array,
    ACTIONS(4186), 1,
      anon_sym_LPAREN,
    ACTIONS(4190), 1,
      anon_sym_PLUS,
    ACTIONS(4192), 1,
      anon_sym_DASH,
    ACTIONS(4194), 1,
      sym_op_unary_other,
    ACTIONS(4196), 1,
      sym__double_quote_string,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4200), 1,
      aux_sym__integer_token1,
    ACTIONS(4202), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4204), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4206), 1,
      sym__dollar_quoted_string,
    ACTIONS(5762), 1,
      sym_parameter,
    STATE(1832), 1,
      sym_identifier,
    STATE(2353), 1,
      sym_invocation,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2678), 1,
      sym__qualified_field,
    STATE(11808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4718), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4178), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2660), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(842), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147823] = 28,
    ACTIONS(965), 1,
      sym__identifier,
    ACTIONS(1023), 1,
      aux_sym_identifier_token1,
    ACTIONS(3650), 1,
      sym_keyword_cast,
    ACTIONS(3652), 1,
      sym_keyword_case,
    ACTIONS(3656), 1,
      sym_keyword_exists,
    ACTIONS(3660), 1,
      sym_keyword_interval,
    ACTIONS(3662), 1,
      sym_keyword_array,
    ACTIONS(3664), 1,
      anon_sym_LPAREN,
    ACTIONS(3668), 1,
      anon_sym_PLUS,
    ACTIONS(3670), 1,
      anon_sym_DASH,
    ACTIONS(3672), 1,
      sym_op_unary_other,
    ACTIONS(3674), 1,
      sym__double_quote_string,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3678), 1,
      aux_sym__integer_token1,
    ACTIONS(3680), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3682), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3684), 1,
      sym__dollar_quoted_string,
    ACTIONS(5764), 1,
      sym_parameter,
    STATE(2914), 1,
      sym_identifier,
    STATE(4201), 1,
      sym_invocation,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4405), 1,
      sym__qualified_field,
    STATE(11929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3658), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3654), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(4650), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2264), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [147934] = 28,
    ACTIONS(277), 1,
      sym__identifier,
    ACTIONS(335), 1,
      aux_sym_identifier_token1,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3464), 1,
      sym_keyword_cast,
    ACTIONS(3472), 1,
      sym_keyword_array,
    ACTIONS(3478), 1,
      anon_sym_PLUS,
    ACTIONS(3480), 1,
      anon_sym_DASH,
    ACTIONS(3482), 1,
      sym_op_unary_other,
    ACTIONS(3484), 1,
      sym__double_quote_string,
    ACTIONS(3486), 1,
      aux_sym__integer_token1,
    ACTIONS(3488), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3490), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3492), 1,
      sym__dollar_quoted_string,
    ACTIONS(3966), 1,
      sym_keyword_case,
    ACTIONS(3970), 1,
      sym_keyword_exists,
    ACTIONS(3972), 1,
      sym_keyword_interval,
    ACTIONS(3974), 1,
      anon_sym_LPAREN,
    ACTIONS(5766), 1,
      sym_parameter,
    STATE(441), 1,
      sym_identifier,
    STATE(717), 1,
      sym_invocation,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(839), 1,
      sym__qualified_field,
    STATE(11909), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3470), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3466), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(855), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(296), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148045] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5768), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1938), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148156] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5770), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4960), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148267] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5772), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1974), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148378] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5774), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1915), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148489] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5776), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1993), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148600] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5778), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1912), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148711] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5780), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1909), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148822] = 28,
    ACTIONS(3902), 1,
      sym__identifier,
    ACTIONS(3904), 1,
      sym_keyword_cast,
    ACTIONS(3906), 1,
      sym_keyword_case,
    ACTIONS(3910), 1,
      sym_keyword_exists,
    ACTIONS(3916), 1,
      sym_keyword_interval,
    ACTIONS(3918), 1,
      sym_keyword_array,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_PLUS,
    ACTIONS(3926), 1,
      anon_sym_DASH,
    ACTIONS(3928), 1,
      sym_op_unary_other,
    ACTIONS(3930), 1,
      sym__double_quote_string,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3934), 1,
      aux_sym__integer_token1,
    ACTIONS(3936), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3938), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3940), 1,
      aux_sym_identifier_token1,
    ACTIONS(3942), 1,
      sym__dollar_quoted_string,
    ACTIONS(5782), 1,
      sym_parameter,
    STATE(4784), 1,
      sym_identifier,
    STATE(5245), 1,
      sym_invocation,
    STATE(5722), 1,
      sym__single_quote_string,
    STATE(5732), 1,
      sym__qualified_field,
    STATE(11825), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3914), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3912), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5585), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3152), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [148933] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5784), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5915), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149044] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5786), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1907), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149155] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5788), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5928), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149266] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5790), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2039), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149377] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5792), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6245), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149488] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5794), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5931), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149599] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2829), 1,
      anon_sym_LPAREN,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2841), 1,
      sym_op_unary_other,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(5796), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(5517), 1,
      sym_invocation,
    STATE(11981), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(2819), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4022), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149710] = 28,
    ACTIONS(3732), 1,
      sym__identifier,
    ACTIONS(3736), 1,
      sym_keyword_cast,
    ACTIONS(3738), 1,
      sym_keyword_case,
    ACTIONS(3742), 1,
      sym_keyword_exists,
    ACTIONS(3748), 1,
      sym_keyword_interval,
    ACTIONS(3750), 1,
      sym_keyword_array,
    ACTIONS(3752), 1,
      anon_sym_LPAREN,
    ACTIONS(3756), 1,
      anon_sym_PLUS,
    ACTIONS(3758), 1,
      anon_sym_DASH,
    ACTIONS(3760), 1,
      sym_op_unary_other,
    ACTIONS(3762), 1,
      sym__double_quote_string,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3766), 1,
      aux_sym__integer_token1,
    ACTIONS(3768), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3770), 1,
      aux_sym__bit_string_token1,
    ACTIONS(3772), 1,
      aux_sym_identifier_token1,
    ACTIONS(3774), 1,
      sym__dollar_quoted_string,
    ACTIONS(5798), 1,
      sym_parameter,
    STATE(4884), 1,
      sym_identifier,
    STATE(5563), 1,
      sym_invocation,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5979), 1,
      sym__qualified_field,
    STATE(11903), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3746), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3744), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(5805), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(3970), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149821] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5800), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2055), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [149932] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5802), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2065), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150043] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5804), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6215), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150154] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5806), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6218), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150265] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5808), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6112), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150376] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5810), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(5359), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150487] = 28,
    ACTIONS(1163), 1,
      sym__identifier,
    ACTIONS(1221), 1,
      aux_sym_identifier_token1,
    ACTIONS(2815), 1,
      sym_keyword_cast,
    ACTIONS(2817), 1,
      sym_keyword_case,
    ACTIONS(2821), 1,
      sym_keyword_exists,
    ACTIONS(2825), 1,
      sym_keyword_interval,
    ACTIONS(2827), 1,
      sym_keyword_array,
    ACTIONS(2837), 1,
      anon_sym_PLUS,
    ACTIONS(2839), 1,
      anon_sym_DASH,
    ACTIONS(2843), 1,
      sym__double_quote_string,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2847), 1,
      aux_sym__integer_token1,
    ACTIONS(2849), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2851), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2853), 1,
      sym__dollar_quoted_string,
    ACTIONS(4314), 1,
      anon_sym_LPAREN,
    ACTIONS(4318), 1,
      sym_op_unary_other,
    ACTIONS(5812), 1,
      sym_parameter,
    STATE(2591), 1,
      sym_identifier,
    STATE(3479), 1,
      sym__qualified_field,
    STATE(3487), 1,
      sym__single_quote_string,
    STATE(4750), 1,
      sym_invocation,
    STATE(11952), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2823), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4312), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3485), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2761), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150598] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5814), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2066), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150709] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5816), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6221), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150820] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5818), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6222), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [150931] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5820), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6223), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151042] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5822), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6225), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151153] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5824), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(4823), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151264] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5826), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6226), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151375] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5828), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2036), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151486] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5830), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1995), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151597] = 28,
    ACTIONS(1091), 1,
      sym__identifier,
    ACTIONS(1095), 1,
      aux_sym_identifier_token1,
    ACTIONS(2434), 1,
      sym_keyword_cast,
    ACTIONS(2436), 1,
      sym_keyword_case,
    ACTIONS(2440), 1,
      sym_keyword_exists,
    ACTIONS(2448), 1,
      sym_keyword_interval,
    ACTIONS(2450), 1,
      sym_keyword_array,
    ACTIONS(2458), 1,
      anon_sym_PLUS,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__double_quote_string,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2468), 1,
      aux_sym__integer_token1,
    ACTIONS(2470), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2472), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2474), 1,
      sym__dollar_quoted_string,
    ACTIONS(3025), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym_op_unary_other,
    ACTIONS(5832), 1,
      sym_parameter,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(1827), 1,
      sym_identifier,
    STATE(2695), 1,
      sym__qualified_field,
    STATE(3082), 1,
      sym_invocation,
    STATE(11581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2446), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(3017), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(2690), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(6228), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151708] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4242), 1,
      sym_parameter,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(1984), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151819] = 28,
    ACTIONS(1291), 1,
      sym__identifier,
    ACTIONS(1349), 1,
      aux_sym_identifier_token1,
    ACTIONS(4224), 1,
      sym_keyword_cast,
    ACTIONS(4226), 1,
      sym_keyword_case,
    ACTIONS(4230), 1,
      sym_keyword_exists,
    ACTIONS(4236), 1,
      sym_keyword_interval,
    ACTIONS(4238), 1,
      sym_keyword_array,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4244), 1,
      anon_sym_PLUS,
    ACTIONS(4246), 1,
      anon_sym_DASH,
    ACTIONS(4248), 1,
      sym_op_unary_other,
    ACTIONS(4250), 1,
      sym__double_quote_string,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4254), 1,
      aux_sym__integer_token1,
    ACTIONS(4256), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(4258), 1,
      aux_sym__bit_string_token1,
    ACTIONS(4260), 1,
      sym__dollar_quoted_string,
    ACTIONS(5834), 1,
      sym_parameter,
    STATE(2710), 1,
      sym_identifier,
    STATE(3531), 1,
      sym_invocation,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4309), 1,
      sym__qualified_field,
    STATE(11865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4234), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(4232), 5,
      sym_keyword_not,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_bang,
    STATE(3918), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
    STATE(2070), 16,
      sym_array,
      sym_case,
      sym_implicit_cast,
      sym_interval,
      sym_cast,
      sym_exists,
      sym_window_function,
      sym__expression,
      sym_parenthesized_expression,
      sym_subscript,
      sym_binary_expression,
      sym_unary_expression,
      sym_between_expression,
      sym_subquery,
      sym_list,
      sym_literal,
  [151930] = 6,
    ACTIONS(5836), 1,
      sym_keyword_unsigned,
    ACTIONS(5838), 1,
      sym_keyword_zerofill,
    ACTIONS(5840), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1808), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1810), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [151996] = 5,
    ACTIONS(5842), 1,
      sym_keyword_unsigned,
    ACTIONS(5844), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152060] = 5,
    ACTIONS(5846), 1,
      aux_sym__single_quote_string_token2,
    STATE(1836), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152124] = 6,
    ACTIONS(5848), 1,
      sym_keyword_unsigned,
    ACTIONS(5850), 1,
      sym_keyword_zerofill,
    ACTIONS(5852), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152190] = 5,
    ACTIONS(5854), 1,
      sym_keyword_precision,
    ACTIONS(5856), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152254] = 4,
    ACTIONS(5858), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152316] = 9,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152388] = 6,
    ACTIONS(5866), 1,
      sym_keyword_unsigned,
    ACTIONS(5868), 1,
      sym_keyword_zerofill,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [152454] = 6,
    ACTIONS(4346), 1,
      sym_keyword_with,
    ACTIONS(4348), 1,
      sym_keyword_without,
    STATE(2160), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152520] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152580] = 5,
    ACTIONS(5872), 1,
      sym_keyword_unsigned,
    ACTIONS(5874), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152644] = 4,
    ACTIONS(5876), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 42,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_no,
      sym_keyword_rename,
      sym_keyword_owner,
      sym_keyword_cycle,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_after,
      sym_keyword_before,
      sym_keyword_window,
      sym_keyword_instead,
      sym_keyword_cache,
      sym_keyword_array,
      sym__identifier,
  [152706] = 5,
    ACTIONS(5878), 1,
      sym_keyword_unsigned,
    ACTIONS(5880), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152770] = 5,
    ACTIONS(5882), 1,
      sym_keyword_unsigned,
    ACTIONS(5884), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152834] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152894] = 5,
    ACTIONS(5886), 1,
      sym_keyword_unsigned,
    ACTIONS(5888), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [152958] = 5,
    ACTIONS(5890), 1,
      sym_keyword_unsigned,
    ACTIONS(5892), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153022] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153142] = 16,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5896), 1,
      sym_keyword_not,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153228] = 8,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(5909), 1,
      anon_sym_RPAREN,
    STATE(2674), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2804), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [153298] = 13,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153378] = 29,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5920), 1,
      sym_keyword_and,
    ACTIONS(5922), 1,
      sym_keyword_or,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5926), 1,
      sym_keyword_not,
    ACTIONS(5928), 1,
      sym_keyword_between,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5940), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(6377), 1,
      sym_identifier,
    STATE(7021), 1,
      sym__alias,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(5912), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(5914), 8,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [153490] = 5,
    ACTIONS(5954), 1,
      aux_sym__single_quote_string_token2,
    STATE(1809), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153614] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    STATE(2649), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153682] = 6,
    ACTIONS(4346), 1,
      sym_keyword_with,
    ACTIONS(4348), 1,
      sym_keyword_without,
    STATE(2161), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153748] = 6,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153814] = 5,
    ACTIONS(5846), 1,
      aux_sym__single_quote_string_token2,
    STATE(1836), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153878] = 5,
    ACTIONS(5956), 1,
      aux_sym__single_quote_string_token2,
    STATE(1836), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [153942] = 5,
    ACTIONS(5959), 1,
      sym_keyword_varying,
    ACTIONS(5961), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154006] = 4,
    ACTIONS(5963), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 43,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154068] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154128] = 5,
    STATE(752), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(1014), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154192] = 6,
    ACTIONS(5965), 1,
      sym_keyword_unsigned,
    ACTIONS(5967), 1,
      sym_keyword_zerofill,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154258] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      anon_sym_COLON,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_preceding,
      sym_keyword_following,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [154356] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [154416] = 5,
    ACTIONS(5981), 1,
      aux_sym__single_quote_string_token2,
    STATE(1835), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154480] = 5,
    ACTIONS(5983), 1,
      sym_keyword_unsigned,
    ACTIONS(5985), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154544] = 7,
    ACTIONS(5987), 1,
      sym_keyword_array,
    STATE(2278), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2574), 1,
      sym__array_size_definition,
    STATE(2575), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154612] = 7,
    ACTIONS(5989), 1,
      sym_keyword_with,
    ACTIONS(5991), 1,
      sym_keyword_without,
    ACTIONS(5993), 1,
      anon_sym_LPAREN,
    STATE(2563), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154680] = 7,
    ACTIONS(5989), 1,
      sym_keyword_with,
    ACTIONS(5991), 1,
      sym_keyword_without,
    ACTIONS(5995), 1,
      anon_sym_LPAREN,
    STATE(2564), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154748] = 5,
    ACTIONS(5997), 1,
      sym_keyword_unsigned,
    ACTIONS(5999), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154812] = 6,
    ACTIONS(6001), 1,
      sym_keyword_unsigned,
    ACTIONS(6003), 1,
      sym_keyword_zerofill,
    ACTIONS(6005), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154878] = 6,
    ACTIONS(6007), 1,
      sym_keyword_unsigned,
    ACTIONS(6009), 1,
      sym_keyword_zerofill,
    ACTIONS(6011), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [154944] = 6,
    ACTIONS(6013), 1,
      sym_keyword_unsigned,
    ACTIONS(6015), 1,
      sym_keyword_zerofill,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155010] = 13,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155090] = 6,
    ACTIONS(6019), 1,
      sym_keyword_unsigned,
    ACTIONS(6021), 1,
      sym_keyword_zerofill,
    ACTIONS(6023), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155156] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      anon_sym_COLON,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_preceding,
      sym_keyword_following,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [155252] = 6,
    ACTIONS(6025), 1,
      sym_keyword_unsigned,
    ACTIONS(6027), 1,
      sym_keyword_zerofill,
    ACTIONS(6029), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155318] = 6,
    ACTIONS(5110), 1,
      sym_keyword_unsigned,
    ACTIONS(5112), 1,
      sym_keyword_zerofill,
    ACTIONS(5116), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155384] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155446] = 5,
    ACTIONS(6031), 1,
      aux_sym__single_quote_string_token2,
    STATE(1881), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1359), 32,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [155510] = 5,
    ACTIONS(6033), 1,
      aux_sym__single_quote_string_token2,
    STATE(1859), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1353), 32,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [155574] = 6,
    ACTIONS(6035), 1,
      sym_keyword_unsigned,
    ACTIONS(6037), 1,
      sym_keyword_zerofill,
    ACTIONS(6039), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1880), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1882), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [155640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1804), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1806), 32,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [155700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1800), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1802), 32,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [155760] = 8,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155830] = 20,
    ACTIONS(2394), 1,
      anon_sym_COLON,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [155924] = 7,
    ACTIONS(5987), 1,
      sym_keyword_array,
    STATE(2278), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2574), 1,
      sym__array_size_definition,
    STATE(2600), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [155992] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      anon_sym_COLON,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [156086] = 6,
    ACTIONS(6041), 1,
      sym_keyword_unsigned,
    ACTIONS(6043), 1,
      sym_keyword_zerofill,
    ACTIONS(6045), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1828), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1830), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156152] = 6,
    ACTIONS(6047), 1,
      sym_keyword_unsigned,
    ACTIONS(6049), 1,
      sym_keyword_zerofill,
    ACTIONS(6051), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1862), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1864), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156218] = 8,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [156288] = 18,
    ACTIONS(2426), 1,
      anon_sym_COLON,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5896), 1,
      sym_keyword_not,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [156378] = 6,
    ACTIONS(6053), 1,
      sym_keyword_unsigned,
    ACTIONS(6055), 1,
      sym_keyword_zerofill,
    ACTIONS(6057), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1890), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1892), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1876), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1878), 32,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1902), 32,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156564] = 6,
    ACTIONS(6061), 1,
      anon_sym_LPAREN,
    STATE(2455), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6059), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1772), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1872), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1874), 32,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156690] = 6,
    ACTIONS(5316), 1,
      sym_keyword_unsigned,
    ACTIONS(5318), 1,
      sym_keyword_zerofill,
    ACTIONS(5322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156756] = 6,
    ACTIONS(6063), 1,
      anon_sym_LPAREN,
    STATE(2454), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6059), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1794), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156822] = 11,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [156898] = 6,
    ACTIONS(6065), 1,
      sym_keyword_unsigned,
    ACTIONS(6067), 1,
      sym_keyword_zerofill,
    ACTIONS(6069), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1818), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1820), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [156964] = 5,
    ACTIONS(6071), 1,
      aux_sym__single_quote_string_token2,
    STATE(1881), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1365), 32,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157028] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1904), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1906), 32,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157088] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1376), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157148] = 5,
    ACTIONS(6074), 1,
      sym_keyword_unsigned,
    ACTIONS(6076), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [157211] = 21,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5926), 1,
      sym_keyword_not,
    ACTIONS(5928), 1,
      sym_keyword_between,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 13,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [157306] = 5,
    ACTIONS(6078), 1,
      sym_keyword_unsigned,
    ACTIONS(6080), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1986), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1988), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157369] = 5,
    ACTIONS(6082), 1,
      sym_keyword_unsigned,
    ACTIONS(6084), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1978), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1980), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157432] = 5,
    ACTIONS(6086), 1,
      sym_keyword_unsigned,
    ACTIONS(6088), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1966), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1968), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157495] = 5,
    STATE(2506), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6059), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1844), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157558] = 5,
    STATE(2507), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6059), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1848), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157621] = 18,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    ACTIONS(6090), 1,
      sym_keyword_not,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 17,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym__identifier,
  [157710] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2339), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157773] = 8,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 24,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [157901] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [157960] = 11,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [158035] = 13,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 21,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [158114] = 4,
    ACTIONS(6095), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158175] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2334), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [158238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [158297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [158356] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [158415] = 5,
    ACTIONS(6097), 1,
      sym_keyword_unsigned,
    ACTIONS(6099), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158478] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [158537] = 5,
    ACTIONS(6101), 1,
      sym_keyword_unsigned,
    ACTIONS(6103), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158600] = 5,
    ACTIONS(6105), 1,
      sym_keyword_unsigned,
    ACTIONS(6107), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158663] = 9,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158734] = 5,
    ACTIONS(6115), 1,
      sym_keyword_unsigned,
    ACTIONS(6117), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158797] = 16,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6121), 1,
      sym_keyword_not,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158882] = 5,
    ACTIONS(6134), 1,
      sym_keyword_unsigned,
    ACTIONS(6136), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [158945] = 5,
    ACTIONS(6138), 1,
      sym_keyword_unsigned,
    ACTIONS(6140), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [159008] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [159105] = 5,
    ACTIONS(6152), 1,
      sym_keyword_unsigned,
    ACTIONS(6154), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [159168] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [159229] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [159324] = 20,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5926), 1,
      sym_keyword_not,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2491), 14,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      sym__identifier,
  [159417] = 5,
    ACTIONS(6156), 1,
      aux_sym__single_quote_string_token2,
    STATE(1934), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [159480] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2338), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [159543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [159602] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2337), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [159665] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [159724] = 20,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5926), 1,
      sym_keyword_not,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2394), 14,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      sym__identifier,
  [159817] = 5,
    ACTIONS(6158), 1,
      aux_sym__single_quote_string_token2,
    STATE(1940), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [159880] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2336), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [159943] = 5,
    ACTIONS(6160), 1,
      sym_keyword_unsigned,
    ACTIONS(6162), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1910), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [160006] = 5,
    ACTIONS(6164), 1,
      sym_keyword_unsigned,
    ACTIONS(6166), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1932), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1934), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [160069] = 4,
    ACTIONS(6168), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [160130] = 5,
    ACTIONS(6170), 1,
      sym_keyword_varying,
    ACTIONS(6172), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1948), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1950), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [160193] = 4,
    ACTIONS(6174), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [160254] = 9,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [160325] = 16,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    ACTIONS(6090), 1,
      sym_keyword_not,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 19,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [160410] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [160469] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2342), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [160532] = 5,
    ACTIONS(6176), 1,
      aux_sym__single_quote_string_token2,
    STATE(1934), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [160595] = 27,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6181), 1,
      sym_keyword_having,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6197), 1,
      anon_sym_COMMA,
    ACTIONS(6203), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(6982), 1,
      aux_sym_array_repeat1,
    STATE(7205), 1,
      sym__having,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6179), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [160702] = 4,
    ACTIONS(6217), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [160763] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [160822] = 13,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2430), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [160901] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [161000] = 5,
    ACTIONS(6156), 1,
      aux_sym__single_quote_string_token2,
    STATE(1934), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [161063] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3333), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [161162] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [161261] = 5,
    ACTIONS(6223), 1,
      sym_keyword_unsigned,
    ACTIONS(6225), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1918), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [161324] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3399), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [161423] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [161482] = 5,
    STATE(2022), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2364), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [161545] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2340), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [161608] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2341), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [161671] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2343), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [161734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [161793] = 8,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [161862] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [161921] = 4,
    ACTIONS(6227), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [161982] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [162041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [162100] = 29,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6229), 1,
      sym_keyword_as,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6233), 1,
      sym_keyword_and,
    ACTIONS(6235), 1,
      sym_keyword_or,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6239), 1,
      sym_keyword_not,
    ACTIONS(6241), 1,
      sym_keyword_between,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6249), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(6560), 1,
      sym_identifier,
    STATE(7458), 1,
      sym__alias,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5912), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(5914), 8,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [162211] = 8,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 24,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [162280] = 8,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [162349] = 5,
    ACTIONS(6263), 1,
      aux_sym__single_quote_string_token2,
    STATE(1917), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [162412] = 13,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2430), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [162491] = 6,
    ACTIONS(5989), 1,
      sym_keyword_with,
    ACTIONS(5991), 1,
      sym_keyword_without,
    STATE(2494), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [162556] = 6,
    ACTIONS(5989), 1,
      sym_keyword_with,
    ACTIONS(5991), 1,
      sym_keyword_without,
    STATE(2521), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [162621] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [162720] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [162779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [162838] = 13,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 21,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [162917] = 4,
    ACTIONS(6265), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [162978] = 4,
    ACTIONS(6267), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [163039] = 4,
    STATE(943), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [163100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [163159] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2360), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [163222] = 5,
    ACTIONS(6269), 1,
      sym_keyword_precision,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [163285] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [163380] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [163479] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [163576] = 22,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5920), 1,
      sym_keyword_and,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5926), 1,
      sym_keyword_not,
    ACTIONS(5928), 1,
      sym_keyword_between,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 12,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [163673] = 6,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [163738] = 16,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    ACTIONS(6273), 1,
      sym_keyword_not,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [163823] = 5,
    ACTIONS(6276), 1,
      sym_keyword_unsigned,
    ACTIONS(6278), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1940), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1942), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [163886] = 9,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [163957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164016] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164075] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164134] = 6,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164199] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2566), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [164262] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164321] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2365), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [164384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164443] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3392), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [164542] = 4,
    ACTIONS(6280), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164603] = 4,
    ACTIONS(6282), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [164664] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2378), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [164727] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [164826] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2445), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [164889] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6144), 1,
      sym_keyword_not,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [164982] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165041] = 4,
    ACTIONS(6284), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165102] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165161] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2446), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165224] = 4,
    ACTIONS(6286), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165285] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165344] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165403] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165462] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1370), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165523] = 4,
    ACTIONS(6288), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165584] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 2,
      sym_keyword_primary,
      sym_keyword_constraint,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1370), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_cascade,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165647] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165706] = 4,
    ACTIONS(6290), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [165767] = 6,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165891] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [165950] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166009] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166068] = 5,
    ACTIONS(6292), 1,
      sym_keyword_unsigned,
    ACTIONS(6294), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166131] = 4,
    ACTIONS(6296), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [166192] = 4,
    ACTIONS(6298), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [166253] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 33,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166312] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2532), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166375] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [166468] = 5,
    ACTIONS(6300), 1,
      sym_keyword_precision,
    ACTIONS(6302), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166531] = 4,
    ACTIONS(6304), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [166592] = 6,
    ACTIONS(6306), 1,
      anon_sym_LBRACK,
    STATE(2022), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2364), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 40,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [166657] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3390), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [166756] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3420), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [166855] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2533), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [166918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 43,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [166977] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3380), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [167076] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3401), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [167175] = 4,
    ACTIONS(6309), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167236] = 4,
    ACTIONS(6311), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167297] = 4,
    ACTIONS(6313), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167358] = 4,
    ACTIONS(6315), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167419] = 4,
    ACTIONS(6317), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167480] = 4,
    ACTIONS(6319), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167541] = 4,
    ACTIONS(6321), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167602] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6144), 1,
      sym_keyword_not,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [167695] = 4,
    ACTIONS(6323), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167756] = 5,
    ACTIONS(6325), 1,
      sym_keyword_varying,
    ACTIONS(6327), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167819] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    ACTIONS(6142), 1,
      sym_keyword_and,
    ACTIONS(6144), 1,
      sym_keyword_not,
    ACTIONS(6146), 1,
      sym_keyword_between,
    ACTIONS(6219), 1,
      sym_keyword_or,
    ACTIONS(6221), 1,
      anon_sym_COLON_COLON,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [167918] = 4,
    ACTIONS(6329), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 42,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [167979] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2534), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [168042] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168101] = 13,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168180] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 43,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168239] = 11,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(2424), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168314] = 4,
    ACTIONS(6331), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168375] = 8,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168444] = 4,
    ACTIONS(4828), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168505] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    ACTIONS(6273), 1,
      sym_keyword_not,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [168594] = 4,
    ACTIONS(6333), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168655] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168714] = 4,
    ACTIONS(6335), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168775] = 4,
    ACTIONS(5856), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168836] = 4,
    ACTIONS(6337), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168897] = 13,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [168976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169035] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169153] = 4,
    ACTIONS(6339), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169214] = 4,
    ACTIONS(6341), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 44,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169334] = 4,
    ACTIONS(6343), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169395] = 4,
    ACTIONS(6345), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169456] = 4,
    ACTIONS(6347), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169517] = 11,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(2424), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169592] = 8,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169661] = 4,
    ACTIONS(6349), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_return,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 43,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [169781] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [169874] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6109), 1,
      sym_keyword_is,
    ACTIONS(6111), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_CARET,
    ACTIONS(6119), 1,
      sym_keyword_in,
    ACTIONS(6121), 1,
      sym_keyword_not,
    ACTIONS(6126), 1,
      sym_op_other,
    ACTIONS(6128), 1,
      anon_sym_PLUS,
    ACTIONS(6130), 1,
      anon_sym_DASH,
    ACTIONS(6132), 1,
      anon_sym_SLASH,
    STATE(10479), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6124), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6150), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1805), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1806), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6148), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [169963] = 5,
    ACTIONS(6093), 1,
      sym_keyword_filter,
    STATE(2562), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [170026] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 43,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170085] = 4,
    ACTIONS(6351), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170146] = 4,
    ACTIONS(6353), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [170206] = 4,
    ACTIONS(6355), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [170266] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6361), 1,
      sym_keyword_not,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COLON_COLON,
  [170354] = 17,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6386), 1,
      sym_keyword_not,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [170440] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170556] = 4,
    ACTIONS(6407), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [170616] = 8,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170684] = 4,
    ACTIONS(6409), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [170744] = 4,
    ACTIONS(6411), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170804] = 4,
    ACTIONS(6413), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [170864] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [170922] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [171020] = 8,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171088] = 11,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(2424), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171162] = 8,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171288] = 4,
    ACTIONS(5868), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [171348] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171406] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171464] = 4,
    ACTIONS(6425), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [171524] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171582] = 20,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6239), 1,
      sym_keyword_not,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2491), 14,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      sym__identifier,
  [171674] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171732] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171790] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171848] = 4,
    ACTIONS(6427), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2137), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2139), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [171908] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [171966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172024] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172082] = 4,
    ACTIONS(6429), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172200] = 4,
    ACTIONS(6302), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [172260] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172318] = 4,
    ACTIONS(6431), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [172378] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172436] = 13,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172514] = 4,
    ACTIONS(6433), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [172632] = 4,
    ACTIONS(6435), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [172692] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [172786] = 4,
    ACTIONS(6463), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [172846] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [172942] = 13,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2430), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173020] = 4,
    ACTIONS(6467), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [173080] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173196] = 4,
    ACTIONS(6469), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [173256] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173314] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173430] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173488] = 16,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6471), 1,
      sym_keyword_not,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173572] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173630] = 9,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173874] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [173990] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174048] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174106] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174164] = 4,
    ACTIONS(6474), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [174224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174398] = 6,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174462] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174520] = 4,
    ACTIONS(6476), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [174580] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2022), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2024), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [174638] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [174730] = 4,
    ACTIONS(6478), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [174790] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    ACTIONS(6480), 1,
      sym_keyword_not,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [174880] = 4,
    ACTIONS(6482), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174940] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [174998] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175114] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175404] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175462] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175520] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175636] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175694] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175752] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175810] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175868] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175926] = 5,
    ACTIONS(6484), 1,
      aux_sym__single_quote_string_token2,
    STATE(2224), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [175988] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176046] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176104] = 4,
    ACTIONS(6486), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176164] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176222] = 4,
    ACTIONS(6488), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176398] = 4,
    ACTIONS(6490), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176458] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176516] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176690] = 13,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176768] = 9,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176838] = 7,
    ACTIONS(4348), 1,
      sym_keyword_without,
    ACTIONS(6492), 1,
      sym_keyword_with,
    ACTIONS(6495), 1,
      anon_sym_LPAREN,
    STATE(2097), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 38,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176904] = 7,
    ACTIONS(4348), 1,
      sym_keyword_without,
    ACTIONS(6497), 1,
      sym_keyword_with,
    ACTIONS(6500), 1,
      anon_sym_LPAREN,
    STATE(2098), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 38,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [176970] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [177068] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177126] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    ACTIONS(6480), 1,
      sym_keyword_not,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [177216] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177274] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3333), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [177372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177430] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [177528] = 4,
    ACTIONS(6502), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [177588] = 4,
    ACTIONS(6504), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177648] = 4,
    ACTIONS(6506), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177708] = 4,
    ACTIONS(6508), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177768] = 4,
    ACTIONS(6510), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [177828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [177886] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [177984] = 4,
    ACTIONS(6512), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178044] = 4,
    ACTIONS(6514), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [178104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178162] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3516), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [178220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 42,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178336] = 4,
    ACTIONS(6516), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [178396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178454] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178512] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    ACTIONS(6480), 1,
      sym_keyword_not,
    ACTIONS(6522), 1,
      sym_keyword_and,
    ACTIONS(6524), 1,
      sym_keyword_or,
    ACTIONS(6526), 1,
      sym_keyword_using,
    ACTIONS(6528), 1,
      sym_keyword_between,
    ACTIONS(6530), 1,
      anon_sym_COLON_COLON,
    STATE(6949), 1,
      sym_direction,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6518), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [178616] = 4,
    ACTIONS(6532), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [178676] = 4,
    ACTIONS(6534), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178736] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 42,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178794] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178852] = 4,
    ACTIONS(6536), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178912] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [178970] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179028] = 16,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6386), 1,
      sym_keyword_not,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179112] = 11,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179186] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [179284] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179342] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179458] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [179556] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3390), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [179654] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179712] = 5,
    ACTIONS(6538), 1,
      aux_sym__single_quote_string_token2,
    STATE(2223), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179774] = 5,
    ACTIONS(6541), 1,
      aux_sym__single_quote_string_token2,
    STATE(2223), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [179836] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3420), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [179934] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    ACTIONS(6480), 1,
      sym_keyword_not,
    ACTIONS(6522), 1,
      sym_keyword_and,
    ACTIONS(6528), 1,
      sym_keyword_between,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [180028] = 4,
    ACTIONS(6543), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180088] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180146] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180204] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180262] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180320] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180378] = 4,
    ACTIONS(6545), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180438] = 8,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180506] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3401), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [180604] = 4,
    ACTIONS(6547), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180664] = 5,
    ACTIONS(6549), 1,
      aux_sym__single_quote_string_token2,
    STATE(2295), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180726] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3380), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [180824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180882] = 13,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2430), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [180960] = 4,
    ACTIONS(6551), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181020] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181078] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3392), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [181176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181234] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181292] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6417), 1,
      sym_keyword_or,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    ACTIONS(6423), 1,
      anon_sym_COLON_COLON,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3399), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [181390] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    ACTIONS(6480), 1,
      sym_keyword_not,
    ACTIONS(6528), 1,
      sym_keyword_between,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [181482] = 4,
    ACTIONS(6553), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [181542] = 4,
    ACTIONS(5850), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181602] = 6,
    ACTIONS(6555), 1,
      anon_sym_LBRACK,
    STATE(2250), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2637), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2044), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2046), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [181666] = 4,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2083), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2085), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [181726] = 4,
    ACTIONS(6560), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2091), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2093), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [181786] = 5,
    ACTIONS(3299), 1,
      aux_sym__single_quote_string_token2,
    STATE(671), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3156), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [181848] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181906] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [181964] = 8,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 24,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182032] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [182090] = 4,
    ACTIONS(6562), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2125), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2127), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182150] = 4,
    ACTIONS(6564), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2131), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2133), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182210] = 13,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [182288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182346] = 4,
    ACTIONS(6566), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182406] = 4,
    ACTIONS(6568), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2171), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2173), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182466] = 8,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [182534] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2167), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2169), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [182592] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [182650] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [182742] = 29,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(5918), 1,
      sym_keyword_in,
    ACTIONS(5920), 1,
      sym_keyword_and,
    ACTIONS(5922), 1,
      sym_keyword_or,
    ACTIONS(5924), 1,
      sym_keyword_is,
    ACTIONS(5926), 1,
      sym_keyword_not,
    ACTIONS(5928), 1,
      sym_keyword_between,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(5934), 1,
      anon_sym_LBRACK,
    ACTIONS(5944), 1,
      sym_op_other,
    ACTIONS(5946), 1,
      anon_sym_PLUS,
    ACTIONS(5948), 1,
      anon_sym_DASH,
    ACTIONS(5950), 1,
      anon_sym_SLASH,
    ACTIONS(5952), 1,
      anon_sym_CARET,
    ACTIONS(6570), 1,
      anon_sym_COLON_COLON,
    STATE(6377), 1,
      sym_identifier,
    STATE(7021), 1,
      sym__alias,
    STATE(11092), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5938), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5942), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1284), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(5912), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1283), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5936), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(5914), 6,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [182852] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [182910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [182968] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 32,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_nulls,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [183026] = 4,
    ACTIONS(6572), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2161), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2163), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [183086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183144] = 6,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183208] = 4,
    ACTIONS(6574), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1994), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1996), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [183268] = 18,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6576), 1,
      sym_keyword_not,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 17,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym__identifier,
  [183356] = 20,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6239), 1,
      sym_keyword_not,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2394), 14,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      sym__identifier,
  [183448] = 5,
    STATE(2307), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2574), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183510] = 21,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6239), 1,
      sym_keyword_not,
    ACTIONS(6241), 1,
      sym_keyword_between,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 13,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [183604] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 42,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183662] = 13,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183740] = 11,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    ACTIONS(2424), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183814] = 4,
    ACTIONS(6579), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2071), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2073), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [183874] = 8,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [183942] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6471), 1,
      sym_keyword_not,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [184030] = 4,
    ACTIONS(6581), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184090] = 4,
    ACTIONS(6583), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2057), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2059), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [184150] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184266] = 4,
    ACTIONS(6585), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184326] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184442] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 42,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184500] = 22,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6233), 1,
      sym_keyword_and,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6239), 1,
      sym_keyword_not,
    ACTIONS(6241), 1,
      sym_keyword_between,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 12,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [184596] = 5,
    ACTIONS(6541), 1,
      aux_sym__single_quote_string_token2,
    STATE(2223), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184658] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 43,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_primary,
      sym_keyword_create,
      sym_keyword_constraint,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_returning,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_between,
      sym_keyword_unique,
      sym_keyword_references,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184716] = 4,
    ACTIONS(6587), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [184776] = 6,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184840] = 4,
    ACTIONS(6589), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [184900] = 9,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [184970] = 16,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6576), 1,
      sym_keyword_not,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 19,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [185054] = 11,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [185128] = 13,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 21,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [185206] = 9,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185276] = 16,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6361), 1,
      sym_keyword_not,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185360] = 4,
    ACTIONS(6591), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185420] = 6,
    ACTIONS(6593), 1,
      anon_sym_LBRACK,
    STATE(2307), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2574), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 39,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185484] = 4,
    ACTIONS(6596), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185544] = 7,
    ACTIONS(6598), 1,
      sym_keyword_unsigned,
    ACTIONS(6600), 1,
      sym_keyword_zerofill,
    ACTIONS(6602), 1,
      sym_keyword_precision,
    ACTIONS(6604), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [185610] = 4,
    ACTIONS(6606), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185670] = 27,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6608), 1,
      sym_keyword_having,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6612), 1,
      anon_sym_COMMA,
    ACTIONS(6614), 1,
      anon_sym_COLON_COLON,
    STATE(7031), 1,
      aux_sym_array_repeat1,
    STATE(7276), 1,
      sym__having,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6179), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [185776] = 8,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 24,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [185844] = 13,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 21,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [185922] = 4,
    ACTIONS(6616), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [185982] = 6,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [186046] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COLON_COLON,
  [186140] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6415), 1,
      sym_keyword_and,
    ACTIONS(6419), 1,
      sym_keyword_not,
    ACTIONS(6421), 1,
      sym_keyword_between,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COLON_COLON,
  [186236] = 4,
    ACTIONS(6618), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186296] = 4,
    ACTIONS(6620), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186356] = 5,
    ACTIONS(6622), 1,
      aux_sym__single_quote_string_token2,
    STATE(2253), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3180), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [186418] = 4,
    ACTIONS(6624), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186478] = 4,
    ACTIONS(6626), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186538] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3564), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [186596] = 4,
    ACTIONS(6628), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186656] = 4,
    ACTIONS(6630), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186716] = 4,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186776] = 4,
    ACTIONS(6632), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186836] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6419), 1,
      sym_keyword_not,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COLON_COLON,
  [186928] = 4,
    ACTIONS(6634), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [186988] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6357), 1,
      sym_keyword_in,
    ACTIONS(6359), 1,
      sym_keyword_is,
    ACTIONS(6364), 1,
      anon_sym_LBRACK,
    ACTIONS(6372), 1,
      sym_op_other,
    ACTIONS(6374), 1,
      anon_sym_PLUS,
    ACTIONS(6376), 1,
      anon_sym_DASH,
    ACTIONS(6378), 1,
      anon_sym_SLASH,
    ACTIONS(6380), 1,
      anon_sym_CARET,
    ACTIONS(6419), 1,
      sym_keyword_not,
    STATE(11179), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6368), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6370), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1406), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1407), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6366), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COLON_COLON,
  [187080] = 4,
    ACTIONS(6636), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [187140] = 4,
    STATE(2358), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [187200] = 4,
    ACTIONS(6638), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [187260] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [187374] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187431] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187488] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187545] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187602] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187659] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [187830] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [187887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [187944] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2353), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2355), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188058] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2345), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2347), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188115] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2329), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2331), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188229] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2289), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2291), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188343] = 4,
    ACTIONS(6640), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188402] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2285), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2287), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188516] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2277), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2279), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188573] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188801] = 6,
    ACTIONS(4348), 1,
      sym_keyword_without,
    ACTIONS(6642), 1,
      sym_keyword_with,
    STATE(2161), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 38,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188864] = 6,
    ACTIONS(4348), 1,
      sym_keyword_without,
    ACTIONS(6645), 1,
      sym_keyword_with,
    STATE(2160), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 38,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [188927] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2181), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2183), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [188984] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [189041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189098] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6652), 1,
      sym_keyword_not,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [189187] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [189244] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2273), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2275), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189301] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [189358] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [189415] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2269), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2271), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2257), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2259), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2213), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2215), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189586] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2245), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2247), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189643] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2241), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2243), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189757] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6652), 1,
      sym_keyword_not,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [189846] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [189903] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [189960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190017] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2237), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2239), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190131] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190359] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2193), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2195), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190416] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2197), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2199), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190473] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190530] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2217), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2219), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190587] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2221), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2223), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2233), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2235), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190701] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2253), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2255), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190815] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2261), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2263), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [190872] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [190986] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191157] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191214] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2249), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2251), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [191442] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191499] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191670] = 26,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2400), 1,
      sym_keyword_not,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2406), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2479), 1,
      sym_keyword_and,
    ACTIONS(2481), 1,
      sym_keyword_between,
    ACTIONS(3456), 1,
      sym_keyword_or,
    ACTIONS(3458), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6526), 1,
      sym_keyword_using,
    STATE(6949), 1,
      sym_direction,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6518), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [191773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191830] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [191944] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192058] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192115] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192229] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192400] = 17,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    ACTIONS(6672), 1,
      sym_keyword_not,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [192485] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192542] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192599] = 8,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192666] = 11,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192739] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192796] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192853] = 13,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192930] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [192987] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2333), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2335), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193101] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193158] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193215] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193272] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193386] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2357), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2359), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193443] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2337), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2339), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193500] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2341), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2343), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193557] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2349), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2351), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193614] = 7,
    ACTIONS(5991), 1,
      sym_keyword_without,
    ACTIONS(6675), 1,
      sym_keyword_with,
    ACTIONS(6678), 1,
      anon_sym_LPAREN,
    STATE(2564), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 37,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193679] = 7,
    ACTIONS(5991), 1,
      sym_keyword_without,
    ACTIONS(6680), 1,
      sym_keyword_with,
    ACTIONS(6683), 1,
      anon_sym_LPAREN,
    STATE(2563), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 37,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193858] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [193915] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [193972] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194143] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194200] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194314] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2185), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2187), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194371] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2189), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2191), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194428] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194485] = 9,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194554] = 16,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    ACTIONS(6672), 1,
      sym_keyword_not,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194637] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6652), 1,
      sym_keyword_not,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    ACTIONS(6685), 1,
      sym_keyword_and,
    ACTIONS(6687), 1,
      sym_keyword_between,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [194730] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6652), 1,
      sym_keyword_not,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    ACTIONS(6687), 1,
      sym_keyword_between,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [194821] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194878] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [194935] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [194992] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2002), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195049] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195106] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195163] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195277] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1872), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1874), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1876), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1878), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195391] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1800), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1802), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195505] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1804), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1806), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195562] = 29,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6229), 1,
      sym_keyword_as,
    ACTIONS(6231), 1,
      sym_keyword_in,
    ACTIONS(6233), 1,
      sym_keyword_and,
    ACTIONS(6235), 1,
      sym_keyword_or,
    ACTIONS(6237), 1,
      sym_keyword_is,
    ACTIONS(6239), 1,
      sym_keyword_not,
    ACTIONS(6241), 1,
      sym_keyword_between,
    ACTIONS(6243), 1,
      anon_sym_LBRACK,
    ACTIONS(6253), 1,
      sym_op_other,
    ACTIONS(6255), 1,
      anon_sym_PLUS,
    ACTIONS(6257), 1,
      anon_sym_DASH,
    ACTIONS(6259), 1,
      anon_sym_SLASH,
    ACTIONS(6261), 1,
      anon_sym_CARET,
    ACTIONS(6689), 1,
      anon_sym_COLON_COLON,
    STATE(6560), 1,
      sym_identifier,
    STATE(7458), 1,
      sym__alias,
    STATE(10592), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6247), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6251), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5912), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1733), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1734), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(5914), 6,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [195671] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1904), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1906), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [195728] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195899] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [195956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196013] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196070] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196127] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196184] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2225), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2227), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [196241] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196298] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [196355] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196412] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [196469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196526] = 7,
    ACTIONS(6691), 1,
      sym_keyword_unsigned,
    ACTIONS(6693), 1,
      sym_keyword_zerofill,
    ACTIONS(6695), 1,
      sym_keyword_precision,
    ACTIONS(6697), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [196591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [196648] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196705] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196819] = 27,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    ACTIONS(6699), 1,
      sym_keyword_having,
    ACTIONS(6701), 1,
      anon_sym_COMMA,
    ACTIONS(6703), 1,
      anon_sym_COLON_COLON,
    STATE(7134), 1,
      aux_sym_array_repeat1,
    STATE(7205), 1,
      sym__having,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6179), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [196924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [196981] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [197038] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [197095] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [197152] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1902), 31,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197323] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197380] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197437] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197494] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2297), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2299), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197551] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2293), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2295), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197608] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2281), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2283), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197665] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [197722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2177), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2179), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [197836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2265), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2267), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197893] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2229), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2231), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [197950] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2209), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2211), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [198007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2205), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2207), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [198064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2201), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2203), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [198121] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198235] = 4,
    STATE(2613), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198294] = 6,
    ACTIONS(6705), 1,
      sym_keyword_unsigned,
    ACTIONS(6707), 1,
      sym_keyword_zerofill,
    ACTIONS(6709), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1890), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1892), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [198357] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198471] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198528] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198756] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [198813] = 6,
    ACTIONS(6713), 1,
      anon_sym_LPAREN,
    STATE(3114), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6711), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1794), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [198876] = 6,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    STATE(2863), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6715), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1772), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [198939] = 6,
    ACTIONS(6719), 1,
      anon_sym_LPAREN,
    STATE(3028), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6715), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1794), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199002] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199059] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199116] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2301), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2303), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [199287] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199344] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6652), 1,
      sym_keyword_not,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    ACTIONS(6685), 1,
      sym_keyword_and,
    ACTIONS(6687), 1,
      sym_keyword_between,
    ACTIONS(6723), 1,
      sym_keyword_or,
    ACTIONS(6725), 1,
      sym_keyword_using,
    ACTIONS(6727), 1,
      anon_sym_COLON_COLON,
    STATE(7274), 1,
      sym_direction,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6518), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [199447] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2305), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2307), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199504] = 6,
    ACTIONS(6729), 1,
      anon_sym_LPAREN,
    STATE(3112), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6711), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1772), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199567] = 6,
    ACTIONS(6731), 1,
      sym_keyword_unsigned,
    ACTIONS(6733), 1,
      sym_keyword_zerofill,
    ACTIONS(6735), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [199687] = 6,
    ACTIONS(6737), 1,
      sym_keyword_unsigned,
    ACTIONS(6739), 1,
      sym_keyword_zerofill,
    ACTIONS(6741), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1862), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1864), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2309), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2311), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199807] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [199864] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [199921] = 6,
    ACTIONS(6743), 1,
      sym_keyword_unsigned,
    ACTIONS(6745), 1,
      sym_keyword_zerofill,
    ACTIONS(6747), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1828), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1830), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [199984] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2313), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2315), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2317), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2319), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2321), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2323), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200155] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200212] = 6,
    ACTIONS(6749), 1,
      sym_keyword_unsigned,
    ACTIONS(6751), 1,
      sym_keyword_zerofill,
    ACTIONS(6753), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1880), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1882), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200332] = 6,
    ACTIONS(6755), 1,
      sym_keyword_unsigned,
    ACTIONS(6757), 1,
      sym_keyword_zerofill,
    ACTIONS(6759), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1808), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1810), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200395] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200452] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200566] = 6,
    ACTIONS(6761), 1,
      sym_keyword_unsigned,
    ACTIONS(6763), 1,
      sym_keyword_zerofill,
    ACTIONS(6765), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1818), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1820), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200629] = 6,
    ACTIONS(6598), 1,
      sym_keyword_unsigned,
    ACTIONS(6600), 1,
      sym_keyword_zerofill,
    ACTIONS(6604), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200692] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6203), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6767), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [200789] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200846] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [200903] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [200960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201017] = 8,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201084] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201141] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201198] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 41,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201255] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 41,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201312] = 6,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201375] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2325), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2327), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201432] = 13,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201509] = 6,
    ACTIONS(6769), 1,
      sym_keyword_unsigned,
    ACTIONS(6771), 1,
      sym_keyword_zerofill,
    ACTIONS(6773), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201571] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [201683] = 5,
    ACTIONS(6775), 1,
      sym_keyword_precision,
    ACTIONS(6777), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201743] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3622), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3624), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201799] = 6,
    ACTIONS(6781), 1,
      sym_keyword_as,
    ACTIONS(6783), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6779), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [201861] = 5,
    STATE(3276), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6711), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1848), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3630), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3632), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [201977] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6614), 1,
      anon_sym_COLON_COLON,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6767), 14,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [202073] = 6,
    ACTIONS(6691), 1,
      sym_keyword_unsigned,
    ACTIONS(6693), 1,
      sym_keyword_zerofill,
    ACTIONS(6697), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202135] = 5,
    STATE(3277), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6711), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1844), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202195] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202251] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [202307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [202363] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3578), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3580), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202419] = 6,
    ACTIONS(6785), 1,
      sym_keyword_unsigned,
    ACTIONS(6787), 1,
      sym_keyword_zerofill,
    ACTIONS(6789), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1818), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1820), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202481] = 6,
    ACTIONS(6791), 1,
      sym_keyword_unsigned,
    ACTIONS(6793), 1,
      sym_keyword_zerofill,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1808), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1810), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3574), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3576), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202599] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    STATE(3457), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2804), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [202719] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3506), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3508), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202775] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3582), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3584), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202831] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [202887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3606), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3608), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202943] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3610), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3612), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [202999] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203055] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203111] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203167] = 6,
    ACTIONS(6797), 1,
      sym_keyword_unsigned,
    ACTIONS(6799), 1,
      sym_keyword_zerofill,
    ACTIONS(6801), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1880), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1882), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [203229] = 7,
    ACTIONS(6803), 1,
      sym_keyword_with,
    ACTIONS(6805), 1,
      sym_keyword_without,
    ACTIONS(6807), 1,
      anon_sym_LPAREN,
    STATE(3805), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203293] = 7,
    ACTIONS(6803), 1,
      sym_keyword_with,
    ACTIONS(6805), 1,
      sym_keyword_without,
    ACTIONS(6809), 1,
      anon_sym_LPAREN,
    STATE(3803), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203357] = 6,
    ACTIONS(6811), 1,
      sym_keyword_unsigned,
    ACTIONS(6813), 1,
      sym_keyword_zerofill,
    ACTIONS(6815), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1828), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1830), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [203419] = 6,
    ACTIONS(6817), 1,
      sym_keyword_unsigned,
    ACTIONS(6819), 1,
      sym_keyword_zerofill,
    ACTIONS(6821), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1862), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1864), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [203481] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203537] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203593] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2386), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2388), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [203649] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2382), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2384), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [203705] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203817] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [203985] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204097] = 7,
    ACTIONS(6823), 1,
      sym_keyword_array,
    STATE(2899), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3798), 1,
      sym_array_size_definition,
    STATE(3799), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2800), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [204161] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204217] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204273] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6382), 1,
      sym_keyword_in,
    ACTIONS(6384), 1,
      sym_keyword_is,
    ACTIONS(6389), 1,
      anon_sym_LBRACK,
    ACTIONS(6397), 1,
      sym_op_other,
    ACTIONS(6399), 1,
      anon_sym_PLUS,
    ACTIONS(6401), 1,
      anon_sym_DASH,
    ACTIONS(6403), 1,
      anon_sym_SLASH,
    ACTIONS(6405), 1,
      anon_sym_CARET,
    ACTIONS(6480), 1,
      sym_keyword_not,
    ACTIONS(6522), 1,
      sym_keyword_and,
    ACTIONS(6524), 1,
      sym_keyword_or,
    ACTIONS(6526), 1,
      sym_keyword_using,
    ACTIONS(6528), 1,
      sym_keyword_between,
    ACTIONS(6825), 1,
      anon_sym_COLON_COLON,
    STATE(6949), 1,
      sym_direction,
    STATE(10546), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6393), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6395), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(1226), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1223), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6391), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6518), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [204375] = 7,
    ACTIONS(6827), 1,
      sym_keyword_unsigned,
    ACTIONS(6829), 1,
      sym_keyword_zerofill,
    ACTIONS(6831), 1,
      sym_keyword_precision,
    ACTIONS(6833), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204439] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204495] = 7,
    ACTIONS(6823), 1,
      sym_keyword_array,
    STATE(2899), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3799), 1,
      sym__array_size_definition,
    STATE(3817), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2772), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [204559] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3494), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3496), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [204615] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204671] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204727] = 27,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6835), 1,
      sym_keyword_having,
    ACTIONS(6837), 1,
      anon_sym_COMMA,
    ACTIONS(6839), 1,
      anon_sym_COLON_COLON,
    STATE(7172), 1,
      aux_sym_array_repeat1,
    STATE(7276), 1,
      sym__having,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6179), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [204831] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [204889] = 5,
    ACTIONS(6841), 1,
      aux_sym__single_quote_string_token2,
    STATE(2682), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1353), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [204949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1376), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2378), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2380), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205061] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3594), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3596), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205117] = 6,
    ACTIONS(6843), 1,
      sym_keyword_unsigned,
    ACTIONS(6845), 1,
      sym_keyword_zerofill,
    ACTIONS(6847), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1890), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1892), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205179] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [205235] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1902), 29,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205291] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6203), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [205387] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2370), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2372), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205443] = 5,
    ACTIONS(6851), 1,
      sym_keyword_varying,
    ACTIONS(6853), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1948), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1950), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205503] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2366), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2368), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205559] = 5,
    ACTIONS(6855), 1,
      sym_keyword_unsigned,
    ACTIONS(6857), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1966), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1968), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205619] = 4,
    ACTIONS(6859), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1904), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1906), 29,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205733] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1800), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1802), 29,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205789] = 5,
    ACTIONS(6861), 1,
      sym_keyword_unsigned,
    ACTIONS(6863), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1978), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1980), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205849] = 5,
    ACTIONS(6865), 1,
      sym_keyword_unsigned,
    ACTIONS(6867), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1986), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1988), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [205909] = 6,
    ACTIONS(5991), 1,
      sym_keyword_without,
    ACTIONS(6869), 1,
      sym_keyword_with,
    STATE(2521), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 37,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [205971] = 6,
    ACTIONS(5991), 1,
      sym_keyword_without,
    ACTIONS(6872), 1,
      sym_keyword_with,
    STATE(2494), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 37,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206033] = 5,
    ACTIONS(6875), 1,
      sym_keyword_unsigned,
    ACTIONS(6877), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1940), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1942), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206093] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206149] = 5,
    ACTIONS(6879), 1,
      sym_keyword_unsigned,
    ACTIONS(6881), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1918), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206265] = 7,
    ACTIONS(6883), 1,
      sym_keyword_array,
    STATE(287), 1,
      sym__array_size_definition,
    STATE(289), 1,
      sym_array_size_definition,
    STATE(2932), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206441] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206497] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3518), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3520), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3646), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3648), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206609] = 5,
    STATE(3014), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6715), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1848), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206725] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [206781] = 5,
    STATE(3015), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6715), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1844), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206841] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1876), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1878), 29,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206897] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3634), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3636), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [206953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3638), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3640), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207009] = 7,
    ACTIONS(6883), 1,
      sym_keyword_array,
    STATE(286), 1,
      sym_array_size_definition,
    STATE(287), 1,
      sym__array_size_definition,
    STATE(2932), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [207073] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3642), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3644), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207129] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3618), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3620), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207185] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2424), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207241] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3558), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3560), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3502), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3504), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207353] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3602), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3604), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207409] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3498), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3500), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207465] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3460), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3462), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207521] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3572), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207577] = 5,
    ACTIONS(6885), 1,
      sym_keyword_unsigned,
    ACTIONS(6887), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1932), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1934), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207637] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3614), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3616), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207693] = 5,
    ACTIONS(6889), 1,
      sym_keyword_unsigned,
    ACTIONS(6891), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1910), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [207753] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [207809] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [207865] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [207921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [207977] = 5,
    ACTIONS(6893), 1,
      aux_sym__single_quote_string_token2,
    STATE(2684), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1359), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208037] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208093] = 5,
    ACTIONS(6895), 1,
      aux_sym__single_quote_string_token2,
    STATE(2684), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1365), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208153] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2374), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2376), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1872), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1874), 29,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208321] = 5,
    ACTIONS(6898), 1,
      sym_keyword_unsigned,
    ACTIONS(6900), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208381] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208437] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208493] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208549] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208605] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3524), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208717] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3510), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3512), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [208773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208829] = 7,
    ACTIONS(6902), 1,
      sym_keyword_unsigned,
    ACTIONS(6904), 1,
      sym_keyword_zerofill,
    ACTIONS(6906), 1,
      sym_keyword_precision,
    ACTIONS(6908), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208893] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [208949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1804), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1806), 29,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209061] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3598), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3600), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3590), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3592), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209229] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3586), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3588), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209285] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 40,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209341] = 5,
    ACTIONS(3612), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3610), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [209400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209455] = 6,
    ACTIONS(6902), 1,
      sym_keyword_unsigned,
    ACTIONS(6904), 1,
      sym_keyword_zerofill,
    ACTIONS(6908), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209516] = 6,
    ACTIONS(6910), 1,
      sym_keyword_unsigned,
    ACTIONS(6912), 1,
      sym_keyword_zerofill,
    ACTIONS(6914), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209577] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    STATE(3858), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209640] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    STATE(4007), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209703] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3564), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209758] = 6,
    ACTIONS(6916), 1,
      sym_keyword_unsigned,
    ACTIONS(6918), 1,
      sym_keyword_zerofill,
    ACTIONS(6920), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209819] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3135), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209878] = 4,
    ACTIONS(6924), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [209935] = 6,
    ACTIONS(6926), 1,
      sym_keyword_unsigned,
    ACTIONS(6928), 1,
      sym_keyword_zerofill,
    ACTIONS(6930), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [209996] = 5,
    ACTIONS(6932), 1,
      sym_keyword_varying,
    ACTIONS(6934), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1948), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1950), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210055] = 6,
    ACTIONS(6936), 1,
      sym_keyword_unsigned,
    ACTIONS(6938), 1,
      sym_keyword_zerofill,
    ACTIONS(6940), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210116] = 6,
    ACTIONS(6942), 1,
      sym_keyword_unsigned,
    ACTIONS(6944), 1,
      sym_keyword_zerofill,
    ACTIONS(6946), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210177] = 5,
    ACTIONS(6948), 1,
      aux_sym__single_quote_string_token2,
    STATE(2740), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3180), 27,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210236] = 6,
    ACTIONS(6950), 1,
      sym_keyword_unsigned,
    ACTIONS(6952), 1,
      sym_keyword_zerofill,
    ACTIONS(6954), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210352] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3516), 30,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210462] = 5,
    ACTIONS(6956), 1,
      sym_keyword_unsigned,
    ACTIONS(6958), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1978), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1980), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210521] = 6,
    ACTIONS(6781), 1,
      sym_keyword_as,
    ACTIONS(6783), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(6779), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210582] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210637] = 7,
    ACTIONS(6960), 1,
      sym_keyword_array,
    STATE(3378), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4079), 1,
      sym__array_size_definition,
    STATE(4081), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210755] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [210810] = 4,
    ACTIONS(6962), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2083), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2085), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210867] = 4,
    ACTIONS(6964), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2091), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2093), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210924] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(3367), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2804), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [210987] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [211042] = 6,
    ACTIONS(6966), 1,
      sym_keyword_unsigned,
    ACTIONS(6968), 1,
      sym_keyword_zerofill,
    ACTIONS(6970), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [211103] = 4,
    ACTIONS(6972), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211160] = 4,
    ACTIONS(6974), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211217] = 4,
    ACTIONS(6976), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2131), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2133), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211274] = 4,
    ACTIONS(6978), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211331] = 5,
    ACTIONS(1659), 1,
      aux_sym__single_quote_string_token2,
    STATE(117), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3156), 27,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211390] = 13,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [211465] = 8,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [211530] = 7,
    ACTIONS(6994), 1,
      sym_keyword_array,
    STATE(2637), 1,
      sym__array_size_definition,
    STATE(2639), 1,
      sym_array_size_definition,
    STATE(3248), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2800), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211593] = 7,
    ACTIONS(6996), 1,
      sym_keyword_unsigned,
    ACTIONS(6998), 1,
      sym_keyword_zerofill,
    ACTIONS(7000), 1,
      sym_keyword_precision,
    ACTIONS(7002), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [211656] = 4,
    ACTIONS(7004), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211713] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211768] = 4,
    ACTIONS(7006), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2171), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2173), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211825] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2167), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2169), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211880] = 4,
    ACTIONS(7008), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2161), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2163), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211937] = 4,
    ACTIONS(7010), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1994), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1996), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [211994] = 4,
    ACTIONS(7012), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212051] = 4,
    ACTIONS(7014), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2071), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2073), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212108] = 4,
    ACTIONS(7016), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2057), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2059), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212165] = 4,
    ACTIONS(7018), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2125), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2127), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212222] = 7,
    ACTIONS(6994), 1,
      sym_keyword_array,
    STATE(2631), 1,
      sym_array_size_definition,
    STATE(2637), 1,
      sym__array_size_definition,
    STATE(3248), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2772), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212285] = 4,
    ACTIONS(7020), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212342] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2022), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2024), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212397] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3100), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212456] = 4,
    ACTIONS(7022), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212513] = 4,
    ACTIONS(7024), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212570] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7028), 1,
      sym_keyword_and,
    ACTIONS(7030), 1,
      sym_keyword_or,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7038), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6767), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [212665] = 4,
    ACTIONS(7044), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212722] = 5,
    ACTIONS(7046), 1,
      sym_keyword_precision,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [212781] = 7,
    ACTIONS(7050), 1,
      sym_keyword_unsigned,
    ACTIONS(7052), 1,
      sym_keyword_zerofill,
    ACTIONS(7054), 1,
      sym_keyword_precision,
    ACTIONS(7056), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [212844] = 7,
    ACTIONS(6960), 1,
      sym_keyword_array,
    STATE(3378), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3955), 1,
      sym_array_size_definition,
    STATE(4079), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [212907] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6203), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(7058), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [213002] = 7,
    ACTIONS(7060), 1,
      sym_keyword_with,
    ACTIONS(7062), 1,
      sym_keyword_without,
    ACTIONS(7064), 1,
      anon_sym_LPAREN,
    STATE(4189), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213065] = 7,
    ACTIONS(7060), 1,
      sym_keyword_with,
    ACTIONS(7062), 1,
      sym_keyword_without,
    ACTIONS(7066), 1,
      anon_sym_LPAREN,
    STATE(4193), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213128] = 4,
    ACTIONS(7068), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213185] = 6,
    ACTIONS(6803), 1,
      sym_keyword_with,
    ACTIONS(6805), 1,
      sym_keyword_without,
    STATE(3606), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213246] = 6,
    ACTIONS(6803), 1,
      sym_keyword_with,
    ACTIONS(6805), 1,
      sym_keyword_without,
    STATE(3619), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213307] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6614), 1,
      anon_sym_COLON_COLON,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [213402] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1370), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 27,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_cascade,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [213459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2002), 39,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_partition,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_cache,
      sym_keyword_array,
      sym__identifier,
  [213514] = 7,
    ACTIONS(7070), 1,
      sym_keyword_array,
    STATE(3249), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4132), 1,
      sym__array_size_definition,
    STATE(4203), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213577] = 7,
    ACTIONS(7070), 1,
      sym_keyword_array,
    STATE(3249), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4131), 1,
      sym_array_size_definition,
    STATE(4132), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [213640] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [213729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [213784] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6648), 1,
      sym_keyword_in,
    ACTIONS(6650), 1,
      sym_keyword_is,
    ACTIONS(6652), 1,
      sym_keyword_not,
    ACTIONS(6654), 1,
      anon_sym_LBRACK,
    ACTIONS(6662), 1,
      sym_op_other,
    ACTIONS(6664), 1,
      anon_sym_PLUS,
    ACTIONS(6666), 1,
      anon_sym_DASH,
    ACTIONS(6668), 1,
      anon_sym_SLASH,
    ACTIONS(6670), 1,
      anon_sym_CARET,
    ACTIONS(6685), 1,
      sym_keyword_and,
    ACTIONS(6687), 1,
      sym_keyword_between,
    ACTIONS(6723), 1,
      sym_keyword_or,
    ACTIONS(6725), 1,
      sym_keyword_using,
    ACTIONS(7072), 1,
      anon_sym_COLON_COLON,
    STATE(7274), 1,
      sym_direction,
    STATE(11002), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6658), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(1514), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1515), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6656), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6518), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_COMMA,
  [213885] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [213974] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3154), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214033] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3166), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214092] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3167), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214151] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7042), 1,
      sym_op_other,
    ACTIONS(7074), 1,
      sym_keyword_not,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [214236] = 8,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [214301] = 11,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [214372] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3238), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214431] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3252), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214490] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3259), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214549] = 4,
    ACTIONS(7077), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214606] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3260), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214665] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3261), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214724] = 5,
    ACTIONS(6781), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6779), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [214783] = 4,
    ACTIONS(7079), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214840] = 4,
    ACTIONS(7081), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214897] = 4,
    ACTIONS(7083), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [214954] = 5,
    ACTIONS(7085), 1,
      sym_keyword_unsigned,
    ACTIONS(7087), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1966), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1968), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215013] = 13,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [215088] = 5,
    ACTIONS(7089), 1,
      sym_keyword_unsigned,
    ACTIONS(7091), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1986), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1988), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215147] = 5,
    ACTIONS(7093), 1,
      sym_keyword_unsigned,
    ACTIONS(7095), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1940), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1942), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215206] = 5,
    ACTIONS(7097), 1,
      sym_keyword_unsigned,
    ACTIONS(7099), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1918), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215265] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3290), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215324] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3293), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215383] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3294), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215442] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3295), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215501] = 9,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [215568] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3296), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [215627] = 16,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7042), 1,
      sym_op_other,
    ACTIONS(7074), 1,
      sym_keyword_not,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [215708] = 6,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [215769] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7028), 1,
      sym_keyword_and,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [215862] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [215953] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    ACTIONS(6703), 1,
      anon_sym_COLON_COLON,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6767), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [216048] = 6,
    ACTIONS(7101), 1,
      sym_keyword_unsigned,
    ACTIONS(7103), 1,
      sym_keyword_zerofill,
    ACTIONS(7105), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216109] = 6,
    ACTIONS(6827), 1,
      sym_keyword_unsigned,
    ACTIONS(6829), 1,
      sym_keyword_zerofill,
    ACTIONS(6833), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216170] = 4,
    ACTIONS(7107), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216227] = 4,
    ACTIONS(6777), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216284] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3310), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216343] = 6,
    ACTIONS(7109), 1,
      sym_keyword_unsigned,
    ACTIONS(7111), 1,
      sym_keyword_zerofill,
    ACTIONS(7113), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216404] = 6,
    ACTIONS(7115), 1,
      sym_keyword_unsigned,
    ACTIONS(7117), 1,
      sym_keyword_zerofill,
    ACTIONS(7119), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216465] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3311), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216524] = 6,
    ACTIONS(7121), 1,
      sym_keyword_unsigned,
    ACTIONS(7123), 1,
      sym_keyword_zerofill,
    ACTIONS(7125), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216585] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3314), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216644] = 5,
    ACTIONS(7127), 1,
      sym_keyword_unsigned,
    ACTIONS(7129), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1932), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1934), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216703] = 6,
    ACTIONS(7131), 1,
      sym_keyword_unsigned,
    ACTIONS(7133), 1,
      sym_keyword_zerofill,
    ACTIONS(7135), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216764] = 6,
    ACTIONS(7137), 1,
      sym_keyword_unsigned,
    ACTIONS(7139), 1,
      sym_keyword_zerofill,
    ACTIONS(7141), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216825] = 5,
    ACTIONS(7143), 1,
      sym_keyword_unsigned,
    ACTIONS(7145), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1910), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [216884] = 7,
    ACTIONS(7147), 1,
      sym_keyword_with,
    ACTIONS(7149), 1,
      sym_keyword_without,
    ACTIONS(7151), 1,
      anon_sym_LPAREN,
    STATE(3442), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [216947] = 7,
    ACTIONS(7147), 1,
      sym_keyword_with,
    ACTIONS(7149), 1,
      sym_keyword_without,
    ACTIONS(7153), 1,
      anon_sym_LPAREN,
    STATE(3440), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [217010] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1370), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217067] = 5,
    ACTIONS(6922), 1,
      sym_keyword_filter,
    STATE(3328), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217126] = 4,
    ACTIONS(7155), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2137), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2139), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217183] = 6,
    ACTIONS(7157), 1,
      sym_keyword_unsigned,
    ACTIONS(7159), 1,
      sym_keyword_zerofill,
    ACTIONS(7161), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [217244] = 4,
    ACTIONS(7163), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217301] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [217356] = 5,
    ACTIONS(7165), 1,
      sym_keyword_unsigned,
    ACTIONS(7167), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217415] = 4,
    ACTIONS(6733), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [217527] = 7,
    ACTIONS(7169), 1,
      sym_keyword_unsigned,
    ACTIONS(7171), 1,
      sym_keyword_zerofill,
    ACTIONS(7173), 1,
      sym_keyword_precision,
    ACTIONS(7175), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [217590] = 4,
    ACTIONS(7177), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217647] = 4,
    ACTIONS(7179), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217704] = 4,
    ACTIONS(7181), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217761] = 4,
    ACTIONS(7183), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217818] = 4,
    ACTIONS(7185), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217875] = 4,
    ACTIONS(7187), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217932] = 4,
    ACTIONS(7189), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [217989] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218044] = 6,
    ACTIONS(7191), 1,
      anon_sym_LBRACK,
    STATE(2847), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3380), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2044), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2046), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218215] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2317), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2319), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218269] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [218323] = 6,
    ACTIONS(7194), 1,
      sym_keyword_unsigned,
    ACTIONS(7196), 1,
      sym_keyword_zerofill,
    ACTIONS(7198), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218383] = 6,
    ACTIONS(7200), 1,
      sym_keyword_unsigned,
    ACTIONS(7202), 1,
      sym_keyword_zerofill,
    ACTIONS(7204), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218443] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3772), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218501] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3774), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218559] = 6,
    ACTIONS(7208), 1,
      sym_keyword_unsigned,
    ACTIONS(7210), 1,
      sym_keyword_zerofill,
    ACTIONS(7212), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218619] = 6,
    ACTIONS(7214), 1,
      sym_keyword_unsigned,
    ACTIONS(7216), 1,
      sym_keyword_zerofill,
    ACTIONS(7218), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218679] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [218733] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2277), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2279), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218841] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218895] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3650), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [218953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2189), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2191), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219007] = 6,
    ACTIONS(7220), 1,
      sym_keyword_unsigned,
    ACTIONS(7222), 1,
      sym_keyword_zerofill,
    ACTIONS(7224), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219067] = 5,
    ACTIONS(7226), 1,
      sym_keyword_unsigned,
    ACTIONS(7228), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219179] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    ACTIONS(6703), 1,
      anon_sym_COLON_COLON,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [219273] = 6,
    ACTIONS(7169), 1,
      sym_keyword_unsigned,
    ACTIONS(7171), 1,
      sym_keyword_zerofill,
    ACTIONS(7175), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219333] = 4,
    ACTIONS(7230), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219389] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3516), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219443] = 6,
    ACTIONS(7232), 1,
      sym_keyword_unsigned,
    ACTIONS(7234), 1,
      sym_keyword_zerofill,
    ACTIONS(7236), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219503] = 5,
    ACTIONS(7238), 1,
      sym_keyword_varying,
    ACTIONS(7240), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219561] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219615] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219669] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3751), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219727] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3765), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219785] = 5,
    ACTIONS(7242), 1,
      sym_keyword_unsigned,
    ACTIONS(7244), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [219843] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3731), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219901] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3643), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [219959] = 4,
    ACTIONS(7246), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220015] = 4,
    ACTIONS(7248), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220071] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(3876), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2804), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2301), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2303), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220187] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220241] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220295] = 4,
    ACTIONS(7250), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220351] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [220405] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [220459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [220513] = 5,
    ACTIONS(7252), 1,
      aux_sym__single_quote_string_token2,
    STATE(2892), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1353), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220571] = 5,
    ACTIONS(7254), 1,
      aux_sym__single_quote_string_token2,
    STATE(2893), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3180), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220629] = 5,
    ACTIONS(7256), 1,
      aux_sym__single_quote_string_token2,
    STATE(2894), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1359), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220687] = 5,
    ACTIONS(7256), 1,
      aux_sym__single_quote_string_token2,
    STATE(2894), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3156), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220745] = 5,
    ACTIONS(7258), 1,
      aux_sym__single_quote_string_token2,
    STATE(2894), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1365), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220803] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2305), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2307), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220857] = 5,
    ACTIONS(7261), 1,
      sym_keyword_precision,
    ACTIONS(7263), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [220915] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2309), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2311), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [220969] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2313), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2315), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [221023] = 5,
    STATE(2928), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3799), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3230), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [221081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221135] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3633), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [221193] = 6,
    ACTIONS(7147), 1,
      sym_keyword_with,
    ACTIONS(7149), 1,
      sym_keyword_without,
    STATE(3551), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221253] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3501), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [221311] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2321), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2323), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [221365] = 6,
    ACTIONS(7147), 1,
      sym_keyword_with,
    ACTIONS(7149), 1,
      sym_keyword_without,
    STATE(3552), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221425] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2197), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2199), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [221479] = 5,
    ACTIONS(7265), 1,
      sym_keyword_unsigned,
    ACTIONS(7267), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221537] = 5,
    ACTIONS(7269), 1,
      sym_keyword_unsigned,
    ACTIONS(7271), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221595] = 5,
    ACTIONS(7273), 1,
      sym_keyword_unsigned,
    ACTIONS(7275), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221653] = 5,
    ACTIONS(7277), 1,
      sym_keyword_unsigned,
    ACTIONS(7279), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221711] = 6,
    ACTIONS(7281), 1,
      sym_keyword_unsigned,
    ACTIONS(7283), 1,
      sym_keyword_zerofill,
    ACTIONS(7285), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221771] = 5,
    ACTIONS(7287), 1,
      sym_keyword_unsigned,
    ACTIONS(7289), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221829] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221883] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    STATE(4657), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [221945] = 4,
    ACTIONS(7291), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222001] = 4,
    ACTIONS(7293), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222057] = 4,
    ACTIONS(7295), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222113] = 4,
    ACTIONS(7297), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222169] = 4,
    ACTIONS(7299), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222225] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [222279] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [222333] = 3,
    ACTIONS(7303), 1,
      sym_keyword_force,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7301), 44,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_freeze,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_force_quote,
      sym_keyword_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
      sym_keyword_header,
      sym_keyword_format,
      sym_keyword_delimiter,
      sym_keyword_null,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [222387] = 7,
    ACTIONS(7305), 1,
      sym_keyword_array,
    STATE(3368), 1,
      sym_array_size_definition,
    STATE(3380), 1,
      sym__array_size_definition,
    STATE(3663), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2772), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222449] = 4,
    ACTIONS(7307), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222505] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [222559] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [222613] = 4,
    ACTIONS(7309), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222669] = 6,
    ACTIONS(7311), 1,
      anon_sym_LBRACK,
    STATE(2928), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3799), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2044), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2046), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [222783] = 4,
    ACTIONS(7314), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222839] = 4,
    ACTIONS(7316), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [222895] = 5,
    STATE(189), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(287), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [222953] = 4,
    ACTIONS(7318), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223009] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2353), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2355), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223063] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6839), 1,
      anon_sym_COLON_COLON,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6767), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_COMMA,
  [223157] = 5,
    ACTIONS(7320), 1,
      sym_keyword_unsigned,
    ACTIONS(7322), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [223215] = 5,
    ACTIONS(7324), 1,
      sym_keyword_unsigned,
    ACTIONS(7326), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [223273] = 5,
    ACTIONS(7328), 1,
      sym_keyword_unsigned,
    ACTIONS(7330), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [223331] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2345), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2347), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2329), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2331), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223439] = 5,
    ACTIONS(7332), 1,
      sym_keyword_unsigned,
    ACTIONS(7334), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [223497] = 4,
    ACTIONS(7336), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223553] = 3,
    ACTIONS(7340), 1,
      sym_keyword_force,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7338), 44,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_freeze,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_force_quote,
      sym_keyword_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
      sym_keyword_header,
      sym_keyword_format,
      sym_keyword_delimiter,
      sym_keyword_null,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [223607] = 4,
    ACTIONS(7342), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223663] = 4,
    ACTIONS(7344), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223719] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2289), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2291), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223827] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2285), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2287), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223881] = 7,
    ACTIONS(7346), 1,
      sym_keyword_unsigned,
    ACTIONS(7348), 1,
      sym_keyword_zerofill,
    ACTIONS(7350), 1,
      sym_keyword_precision,
    ACTIONS(7352), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [223943] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2181), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2183), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [223997] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3724), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224055] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2273), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2275), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224109] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224163] = 7,
    ACTIONS(7356), 1,
      sym_keyword_array,
    STATE(3742), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4432), 1,
      sym__array_size_definition,
    STATE(4451), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224225] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2213), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2215), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224279] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2237), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2239), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224333] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2249), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2251), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224387] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    STATE(4591), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224449] = 4,
    ACTIONS(6771), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224505] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3567), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224563] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [224617] = 5,
    ACTIONS(7358), 1,
      sym_keyword_unsigned,
    ACTIONS(7360), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224675] = 5,
    ACTIONS(7362), 1,
      sym_keyword_unsigned,
    ACTIONS(7364), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224733] = 5,
    ACTIONS(7366), 1,
      sym_keyword_unsigned,
    ACTIONS(7368), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224791] = 5,
    ACTIONS(7370), 1,
      sym_keyword_unsigned,
    ACTIONS(7372), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [224849] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3530), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224907] = 4,
    ACTIONS(7374), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2137), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2139), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [224963] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2357), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2359), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225017] = 4,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225073] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3788), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225131] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2349), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2351), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225185] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2269), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2271), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225239] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3647), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225297] = 6,
    ACTIONS(7060), 1,
      sym_keyword_with,
    ACTIONS(7062), 1,
      sym_keyword_without,
    STATE(3945), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225357] = 6,
    ACTIONS(7060), 1,
      sym_keyword_with,
    ACTIONS(7062), 1,
      sym_keyword_without,
    STATE(3950), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225417] = 4,
    ACTIONS(7376), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225473] = 4,
    ACTIONS(7378), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225529] = 4,
    ACTIONS(7380), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225585] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3752), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225643] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225697] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225751] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225805] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3661), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [225917] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3660), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [225975] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226083] = 6,
    ACTIONS(7382), 1,
      sym_keyword_unsigned,
    ACTIONS(7384), 1,
      sym_keyword_zerofill,
    ACTIONS(7386), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226143] = 4,
    ACTIONS(7388), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [226199] = 6,
    ACTIONS(7390), 1,
      sym_keyword_unsigned,
    ACTIONS(7392), 1,
      sym_keyword_zerofill,
    ACTIONS(7394), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226259] = 6,
    ACTIONS(7396), 1,
      sym_keyword_unsigned,
    ACTIONS(7398), 1,
      sym_keyword_zerofill,
    ACTIONS(7400), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226319] = 6,
    ACTIONS(7402), 1,
      sym_keyword_unsigned,
    ACTIONS(7404), 1,
      sym_keyword_zerofill,
    ACTIONS(7406), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226379] = 6,
    ACTIONS(7408), 1,
      sym_keyword_unsigned,
    ACTIONS(7410), 1,
      sym_keyword_zerofill,
    ACTIONS(7412), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226439] = 6,
    ACTIONS(7414), 1,
      sym_keyword_unsigned,
    ACTIONS(7416), 1,
      sym_keyword_zerofill,
    ACTIONS(7418), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226499] = 6,
    ACTIONS(7050), 1,
      sym_keyword_unsigned,
    ACTIONS(7052), 1,
      sym_keyword_zerofill,
    ACTIONS(7056), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226559] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3564), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [226613] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3794), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226671] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226727] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3797), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2325), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2327), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [226839] = 6,
    ACTIONS(7420), 1,
      sym_keyword_unsigned,
    ACTIONS(7422), 1,
      sym_keyword_zerofill,
    ACTIONS(7424), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [226899] = 27,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7028), 1,
      sym_keyword_and,
    ACTIONS(7030), 1,
      sym_keyword_or,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7038), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7042), 1,
      sym_op_other,
    ACTIONS(7426), 1,
      sym_keyword_having,
    ACTIONS(7428), 1,
      anon_sym_COMMA,
    STATE(7205), 1,
      sym__having,
    STATE(7496), 1,
      aux_sym_array_repeat1,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6179), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [227001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2333), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2335), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227055] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3709), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [227113] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2201), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2203), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227167] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2205), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2207), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227221] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2209), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2211), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227275] = 7,
    ACTIONS(7430), 1,
      sym_keyword_array,
    STATE(3435), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4528), 1,
      sym__array_size_definition,
    STATE(4529), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [227337] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3659), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227395] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2229), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2231), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2265), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2267), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227503] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2177), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2179), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227557] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2281), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2283), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227611] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2293), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2295), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227665] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2297), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2299), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227719] = 4,
    ACTIONS(7432), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227775] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227829] = 4,
    ACTIONS(7434), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227885] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2022), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2024), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [227993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228047] = 4,
    ACTIONS(7436), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2057), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2059), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228103] = 4,
    ACTIONS(7438), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2071), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2073), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228159] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3818), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228217] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228271] = 6,
    ACTIONS(7440), 1,
      sym_keyword_unsigned,
    ACTIONS(7442), 1,
      sym_keyword_zerofill,
    ACTIONS(7444), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228331] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2185), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2187), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228439] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228493] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3827), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228551] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3821), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228609] = 4,
    ACTIONS(7446), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1994), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1996), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [228665] = 7,
    ACTIONS(7448), 1,
      sym_keyword_with,
    ACTIONS(7450), 1,
      sym_keyword_without,
    ACTIONS(7452), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228727] = 7,
    ACTIONS(7448), 1,
      sym_keyword_with,
    ACTIONS(7450), 1,
      sym_keyword_without,
    ACTIONS(7454), 1,
      anon_sym_LPAREN,
    STATE(4314), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228789] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    STATE(4492), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228851] = 6,
    ACTIONS(7456), 1,
      sym_keyword_unsigned,
    ACTIONS(7458), 1,
      sym_keyword_zerofill,
    ACTIONS(7460), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228911] = 6,
    ACTIONS(7462), 1,
      sym_keyword_unsigned,
    ACTIONS(7464), 1,
      sym_keyword_zerofill,
    ACTIONS(7466), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [228971] = 6,
    ACTIONS(7468), 1,
      sym_keyword_unsigned,
    ACTIONS(7470), 1,
      sym_keyword_zerofill,
    ACTIONS(7472), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229031] = 6,
    ACTIONS(7474), 1,
      sym_keyword_unsigned,
    ACTIONS(7476), 1,
      sym_keyword_zerofill,
    ACTIONS(7478), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229091] = 6,
    ACTIONS(7480), 1,
      sym_keyword_unsigned,
    ACTIONS(7482), 1,
      sym_keyword_zerofill,
    ACTIONS(7484), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229151] = 6,
    ACTIONS(6996), 1,
      sym_keyword_unsigned,
    ACTIONS(6998), 1,
      sym_keyword_zerofill,
    ACTIONS(7002), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229211] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3829), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229269] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3710), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [229327] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3826), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229385] = 7,
    ACTIONS(7486), 1,
      sym_keyword_with,
    ACTIONS(7488), 1,
      sym_keyword_without,
    ACTIONS(7490), 1,
      anon_sym_LPAREN,
    STATE(4019), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229447] = 7,
    ACTIONS(7486), 1,
      sym_keyword_with,
    ACTIONS(7488), 1,
      sym_keyword_without,
    ACTIONS(7492), 1,
      anon_sym_LPAREN,
    STATE(4020), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229509] = 7,
    ACTIONS(7430), 1,
      sym_keyword_array,
    STATE(3435), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4488), 1,
      sym_array_size_definition,
    STATE(4528), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229571] = 4,
    ACTIONS(7494), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2161), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2163), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [229627] = 6,
    ACTIONS(7496), 1,
      sym_keyword_unsigned,
    ACTIONS(7498), 1,
      sym_keyword_zerofill,
    ACTIONS(7500), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2167), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2169), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [229741] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3824), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229799] = 7,
    ACTIONS(7356), 1,
      sym_keyword_array,
    STATE(3742), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4386), 1,
      sym_array_size_definition,
    STATE(4432), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [229861] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2261), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2263), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [229915] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2253), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2255), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [229969] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2217), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2219), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230023] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2221), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2223), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230077] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2233), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2235), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230131] = 4,
    ACTIONS(7502), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2171), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2173), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230187] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230241] = 7,
    ACTIONS(7504), 1,
      sym_keyword_array,
    STATE(3540), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4426), 1,
      sym_array_size_definition,
    STATE(4493), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [230303] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2337), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2339), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230357] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2341), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2343), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230411] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3792), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [230469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230523] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230577] = 5,
    ACTIONS(3612), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
    ACTIONS(3602), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [230635] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3726), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [230693] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3728), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [230751] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3764), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [230809] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 39,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [230917] = 7,
    ACTIONS(7305), 1,
      sym_keyword_array,
    STATE(3380), 1,
      sym__array_size_definition,
    STATE(3386), 1,
      sym_array_size_definition,
    STATE(3663), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2800), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [230979] = 4,
    ACTIONS(7506), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [231035] = 5,
    ACTIONS(7508), 1,
      sym_keyword_varying,
    ACTIONS(7510), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [231093] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2241), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2243), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231147] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2245), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2247), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231201] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2257), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2259), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231255] = 4,
    ACTIONS(7512), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2131), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2133), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231311] = 4,
    ACTIONS(7514), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2125), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2127), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231367] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231421] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2225), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2227), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231475] = 4,
    ACTIONS(6783), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 38,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [231531] = 5,
    ACTIONS(6781), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(6779), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [231589] = 7,
    ACTIONS(7504), 1,
      sym_keyword_array,
    STATE(3540), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4493), 1,
      sym__array_size_definition,
    STATE(4500), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [231651] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3537), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231709] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3536), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231767] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3787), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [231825] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6614), 1,
      anon_sym_COLON_COLON,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(7058), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [231919] = 4,
    ACTIONS(7516), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2091), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2093), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [231975] = 4,
    ACTIONS(7518), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2083), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2085), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232085] = 5,
    ACTIONS(7520), 1,
      sym_keyword_unsigned,
    ACTIONS(7522), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232143] = 5,
    ACTIONS(7206), 1,
      sym_keyword_filter,
    STATE(3519), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232201] = 5,
    ACTIONS(7524), 1,
      sym_keyword_precision,
    ACTIONS(7526), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232259] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2193), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2195), 29,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232313] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3785), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232371] = 5,
    ACTIONS(7354), 1,
      sym_keyword_filter,
    STATE(3786), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232429] = 5,
    ACTIONS(7528), 1,
      sym_keyword_unsigned,
    ACTIONS(7530), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232486] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4225), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232596] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3901), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232653] = 4,
    ACTIONS(7536), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232708] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1376), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232761] = 4,
    ACTIONS(7538), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232816] = 4,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [232871] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [232977] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [233030] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [233083] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3867), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [233193] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2189), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2191), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [233246] = 6,
    ACTIONS(7544), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4079), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233305] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2185), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2187), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [233358] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [233411] = 4,
    ACTIONS(7547), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233466] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3879), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233523] = 4,
    ACTIONS(7549), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233578] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3881), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233635] = 4,
    ACTIONS(7551), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233690] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3882), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233747] = 4,
    ACTIONS(7553), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233802] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3960), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233859] = 29,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7557), 1,
      sym_keyword_and,
    ACTIONS(7559), 1,
      sym_keyword_or,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7563), 1,
      sym_keyword_not,
    ACTIONS(7565), 1,
      sym_keyword_between,
    ACTIONS(7571), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(6377), 1,
      sym_identifier,
    STATE(7021), 1,
      sym__alias,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5914), 2,
      sym_keyword_from,
      sym_keyword_create,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7573), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5912), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7567), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [233964] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(3973), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234021] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3872), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234078] = 4,
    ACTIONS(6968), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234133] = 4,
    ACTIONS(7585), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234188] = 4,
    ACTIONS(7587), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234243] = 4,
    ACTIONS(7589), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234298] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234351] = 5,
    ACTIONS(7591), 1,
      sym_keyword_varying,
    ACTIONS(7593), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234408] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3897), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234465] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3892), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234522] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234575] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3893), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234632] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3894), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2301), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2303), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234795] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3895), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [234852] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2305), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2307), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234905] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [234958] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2309), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2311), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235011] = 4,
    ACTIONS(7595), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235066] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2313), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2315), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235119] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2317), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2319), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2321), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2323), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235225] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3898), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235282] = 6,
    ACTIONS(7448), 1,
      sym_keyword_with,
    ACTIONS(7450), 1,
      sym_keyword_without,
    STATE(4319), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235341] = 6,
    ACTIONS(7448), 1,
      sym_keyword_with,
    ACTIONS(7450), 1,
      sym_keyword_without,
    STATE(4320), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235400] = 5,
    ACTIONS(7597), 1,
      sym_keyword_unsigned,
    ACTIONS(7599), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235457] = 27,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7601), 1,
      sym_keyword_having,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7605), 1,
      sym_keyword_and,
    ACTIONS(7607), 1,
      sym_keyword_or,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7613), 1,
      sym_keyword_between,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_COMMA,
    ACTIONS(7623), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(7276), 1,
      sym__having,
    STATE(7527), 1,
      aux_sym_array_repeat1,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6179), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [235558] = 5,
    ACTIONS(7637), 1,
      sym_keyword_unsigned,
    ACTIONS(7639), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235615] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235668] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2241), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2243), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235721] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3871), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235778] = 5,
    ACTIONS(7641), 1,
      sym_keyword_unsigned,
    ACTIONS(7643), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235835] = 5,
    ACTIONS(7645), 1,
      sym_keyword_unsigned,
    ACTIONS(7647), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [235892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2245), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2247), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [235945] = 5,
    ACTIONS(7649), 1,
      sym_keyword_unsigned,
    ACTIONS(7651), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236002] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2257), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2259), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236055] = 5,
    ACTIONS(7653), 1,
      sym_keyword_unsigned,
    ACTIONS(7655), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236112] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4058), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236169] = 4,
    ACTIONS(7659), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236224] = 5,
    ACTIONS(7661), 1,
      sym_keyword_unsigned,
    ACTIONS(7663), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236281] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236387] = 5,
    ACTIONS(7665), 1,
      sym_keyword_unsigned,
    ACTIONS(7667), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236444] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3907), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2002), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236554] = 4,
    ACTIONS(7526), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236609] = 4,
    ACTIONS(7669), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236664] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4292), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236721] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4069), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236778] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4273), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236835] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4270), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [236892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2353), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2355), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236945] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2345), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2347), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [236998] = 6,
    ACTIONS(7671), 1,
      sym_keyword_unsigned,
    ACTIONS(7673), 1,
      sym_keyword_zerofill,
    ACTIONS(7675), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237057] = 5,
    ACTIONS(7677), 1,
      sym_keyword_precision,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237114] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2329), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2331), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [237167] = 5,
    ACTIONS(7681), 1,
      sym_keyword_unsigned,
    ACTIONS(7683), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237224] = 7,
    ACTIONS(7685), 1,
      sym_keyword_with,
    ACTIONS(7687), 1,
      sym_keyword_without,
    ACTIONS(7689), 1,
      anon_sym_LPAREN,
    STATE(4540), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237285] = 7,
    ACTIONS(7685), 1,
      sym_keyword_with,
    ACTIONS(7687), 1,
      sym_keyword_without,
    ACTIONS(7691), 1,
      anon_sym_LPAREN,
    STATE(4539), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [237399] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3920), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237456] = 5,
    ACTIONS(7693), 1,
      sym_keyword_precision,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237513] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3921), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237570] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3939), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237627] = 4,
    ACTIONS(7697), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237682] = 4,
    ACTIONS(7699), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237737] = 4,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237792] = 4,
    ACTIONS(7703), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237847] = 4,
    ACTIONS(7705), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237902] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [237955] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2289), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2291), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2285), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2287), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238061] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2277), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2279), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238114] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2181), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2183), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238167] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2273), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2275), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238220] = 7,
    ACTIONS(7707), 1,
      sym_keyword_array,
    STATE(4056), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4669), 1,
      sym_array_size_definition,
    STATE(4672), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238281] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3943), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238338] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(3946), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238395] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3910), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238452] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2269), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2271), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238505] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2213), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2215), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238558] = 4,
    ACTIONS(7709), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238613] = 4,
    ACTIONS(7711), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238668] = 4,
    ACTIONS(7713), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238723] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 27,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [238776] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3911), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238833] = 6,
    ACTIONS(7346), 1,
      sym_keyword_unsigned,
    ACTIONS(7348), 1,
      sym_keyword_zerofill,
    ACTIONS(7352), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238892] = 4,
    ACTIONS(7715), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [238947] = 6,
    ACTIONS(7717), 1,
      sym_keyword_unsigned,
    ACTIONS(7719), 1,
      sym_keyword_zerofill,
    ACTIONS(7721), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239006] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3916), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239063] = 4,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239118] = 6,
    ACTIONS(7725), 1,
      sym_keyword_unsigned,
    ACTIONS(7727), 1,
      sym_keyword_zerofill,
    ACTIONS(7729), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239177] = 6,
    ACTIONS(7731), 1,
      sym_keyword_unsigned,
    ACTIONS(7733), 1,
      sym_keyword_zerofill,
    ACTIONS(7735), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239236] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2237), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2239), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [239289] = 6,
    ACTIONS(7737), 1,
      sym_keyword_unsigned,
    ACTIONS(7739), 1,
      sym_keyword_zerofill,
    ACTIONS(7741), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239348] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239401] = 4,
    ACTIONS(7743), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239456] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2249), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2251), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [239509] = 4,
    ACTIONS(7745), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239564] = 6,
    ACTIONS(7747), 1,
      sym_keyword_unsigned,
    ACTIONS(7749), 1,
      sym_keyword_zerofill,
    ACTIONS(7751), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239623] = 5,
    ACTIONS(7753), 1,
      sym_keyword_varying,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239680] = 6,
    ACTIONS(7757), 1,
      sym_keyword_unsigned,
    ACTIONS(7759), 1,
      sym_keyword_zerofill,
    ACTIONS(7761), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239739] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4137), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [239796] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [239849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2357), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2359), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [239902] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2349), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2351), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [239955] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240008] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4141), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [240065] = 4,
    ACTIONS(7763), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240120] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4142), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [240177] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [240336] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240389] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4269), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240446] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240499] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 38,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240552] = 4,
    ACTIONS(7765), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240607] = 4,
    ACTIONS(7767), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240662] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(4023), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240719] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(4026), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240776] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(4030), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240833] = 5,
    STATE(2250), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2637), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3230), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [240890] = 5,
    STATE(3402), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4132), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [240947] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241002] = 4,
    ACTIONS(7769), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241057] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241110] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(4098), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241167] = 5,
    ACTIONS(7771), 1,
      sym_keyword_unsigned,
    ACTIONS(7773), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241224] = 5,
    ACTIONS(7775), 1,
      sym_keyword_unsigned,
    ACTIONS(7777), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241281] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4227), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241338] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4264), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241395] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241607] = 4,
    ACTIONS(7779), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241662] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2201), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2203), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241715] = 5,
    ACTIONS(7781), 1,
      aux_sym__single_quote_string_token2,
    STATE(3337), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [241772] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2205), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2207), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241825] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2209), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2211), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241878] = 5,
    ACTIONS(7783), 1,
      aux_sym__single_quote_string_token2,
    STATE(3338), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3180), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241935] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2229), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2231), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [241988] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4150), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [242045] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2265), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2267), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242098] = 5,
    ACTIONS(7785), 1,
      sym_keyword_unsigned,
    ACTIONS(7787), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [242155] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4085), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [242212] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2177), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2179), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242265] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4212), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242322] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2281), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2283), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242375] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2293), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2295), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242428] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2297), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2299), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242481] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4216), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242538] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242644] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4219), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242701] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242754] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4224), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242811] = 4,
    ACTIONS(7789), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [242866] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242919] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [242972] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    STATE(4685), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243033] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4070), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243090] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2374), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2376), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243143] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243196] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243251] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(3985), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243308] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243361] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243467] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243520] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2261), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2263), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243573] = 5,
    ACTIONS(7542), 1,
      sym_keyword_filter,
    STATE(4130), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243630] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3962), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243687] = 5,
    ACTIONS(7791), 1,
      sym_keyword_varying,
    ACTIONS(7793), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243744] = 7,
    ACTIONS(7707), 1,
      sym_keyword_array,
    STATE(4056), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4672), 1,
      sym__array_size_definition,
    STATE(4673), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243805] = 4,
    ACTIONS(7795), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [243860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2253), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2255), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243913] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2233), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2235), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [243966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2221), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2223), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2217), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2219), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244072] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2197), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2199), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244125] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4049), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244182] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2193), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2195), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244235] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244341] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(3963), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244398] = 5,
    ACTIONS(7797), 1,
      aux_sym__single_quote_string_token2,
    STATE(3330), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244455] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244508] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2225), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2227), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244561] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244616] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244669] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4008), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244726] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4010), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244783] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4043), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244840] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [244893] = 5,
    ACTIONS(7799), 1,
      sym_keyword_unsigned,
    ACTIONS(7801), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [244950] = 5,
    ACTIONS(7803), 1,
      sym_keyword_unsigned,
    ACTIONS(7805), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245060] = 5,
    ACTIONS(7807), 1,
      sym_keyword_unsigned,
    ACTIONS(7809), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245117] = 5,
    ACTIONS(7811), 1,
      sym_keyword_unsigned,
    ACTIONS(7813), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245174] = 5,
    ACTIONS(7815), 1,
      sym_keyword_unsigned,
    ACTIONS(7817), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245231] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245284] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2341), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2343), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245337] = 5,
    ACTIONS(7819), 1,
      aux_sym__single_quote_string_token2,
    STATE(3362), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2337), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2339), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245447] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245500] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4251), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245557] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2333), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2335), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2325), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2327), 27,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245663] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4254), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245720] = 5,
    ACTIONS(7819), 1,
      aux_sym__single_quote_string_token2,
    STATE(3362), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245777] = 5,
    ACTIONS(2361), 1,
      aux_sym__single_quote_string_token2,
    STATE(285), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3156), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245834] = 5,
    ACTIONS(7821), 1,
      aux_sym__single_quote_string_token2,
    STATE(3352), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [245891] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4257), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [245948] = 4,
    ACTIONS(7823), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246003] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4259), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [246060] = 29,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6229), 1,
      sym_keyword_as,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7827), 1,
      sym_keyword_and,
    ACTIONS(7829), 1,
      sym_keyword_or,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7833), 1,
      sym_keyword_not,
    ACTIONS(7835), 1,
      sym_keyword_between,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7843), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(6560), 1,
      sym_identifier,
    STATE(7458), 1,
      sym__alias,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5914), 2,
      sym_keyword_from,
      sym_keyword_create,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5912), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7839), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246165] = 4,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [246220] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4261), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [246277] = 4,
    ACTIONS(7859), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246332] = 4,
    ACTIONS(7861), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246387] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4107), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246444] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4136), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2386), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2388), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [246554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2382), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2384), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [246607] = 5,
    ACTIONS(6031), 1,
      aux_sym__single_quote_string_token2,
    STATE(1881), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246664] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4244), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246721] = 4,
    ACTIONS(7863), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246776] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6839), 1,
      anon_sym_COLON_COLON,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [246869] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3524), 27,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [246922] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4168), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [246979] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4276), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [247036] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4277), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [247093] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4171), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247150] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4180), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247207] = 5,
    ACTIONS(7865), 1,
      aux_sym__single_quote_string_token2,
    STATE(3362), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247264] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4278), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [247321] = 5,
    ACTIONS(7868), 1,
      sym_keyword_unsigned,
    ACTIONS(7870), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247378] = 5,
    ACTIONS(7872), 1,
      sym_keyword_unsigned,
    ACTIONS(7874), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247435] = 4,
    ACTIONS(7876), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247490] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3572), 27,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_check,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [247543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2378), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2380), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [247596] = 4,
    ACTIONS(7878), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247651] = 4,
    ACTIONS(7880), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247706] = 5,
    ACTIONS(7532), 1,
      sym_keyword_filter,
    STATE(4287), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [247763] = 4,
    ACTIONS(7882), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247818] = 4,
    ACTIONS(7884), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247873] = 5,
    ACTIONS(7886), 1,
      sym_keyword_unsigned,
    ACTIONS(7888), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247930] = 4,
    ACTIONS(7890), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [247985] = 4,
    ACTIONS(7892), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248040] = 4,
    ACTIONS(7894), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248095] = 5,
    STATE(3113), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4079), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248152] = 4,
    ACTIONS(7896), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2370), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2372), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [248260] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4119), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248317] = 4,
    ACTIONS(7898), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248372] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4118), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248429] = 4,
    ACTIONS(7900), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248484] = 29,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7902), 1,
      sym_keyword_as,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7906), 1,
      sym_keyword_and,
    ACTIONS(7908), 1,
      sym_keyword_or,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7912), 1,
      sym_keyword_not,
    ACTIONS(7914), 1,
      sym_keyword_between,
    ACTIONS(7920), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(6377), 1,
      sym_identifier,
    STATE(7021), 1,
      sym__alias,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5912), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7922), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5914), 3,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_separator,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7916), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248589] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2366), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2368), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [248642] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4114), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248699] = 5,
    ACTIONS(7934), 1,
      sym_keyword_unsigned,
    ACTIONS(7936), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248756] = 5,
    ACTIONS(7534), 1,
      sym_keyword_filter,
    STATE(4252), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248813] = 6,
    ACTIONS(7486), 1,
      sym_keyword_with,
    ACTIONS(7488), 1,
      sym_keyword_without,
    STATE(4240), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248872] = 6,
    ACTIONS(7486), 1,
      sym_keyword_with,
    ACTIONS(7488), 1,
      sym_keyword_without,
    STATE(4239), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248931] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4234), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [248988] = 4,
    ACTIONS(7938), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249043] = 5,
    ACTIONS(7940), 1,
      sym_keyword_unsigned,
    ACTIONS(7942), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249100] = 5,
    ACTIONS(7944), 1,
      sym_keyword_unsigned,
    ACTIONS(7946), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249157] = 4,
    ACTIONS(7948), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249212] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249265] = 4,
    ACTIONS(7950), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249320] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249373] = 4,
    ACTIONS(7952), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249428] = 4,
    ACTIONS(7954), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249483] = 6,
    ACTIONS(7956), 1,
      anon_sym_LBRACK,
    STATE(3402), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4132), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249542] = 4,
    ACTIONS(7959), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249597] = 4,
    ACTIONS(7961), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249652] = 5,
    ACTIONS(7963), 1,
      sym_keyword_precision,
    ACTIONS(7965), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249709] = 4,
    ACTIONS(7967), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249764] = 4,
    ACTIONS(7969), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249819] = 4,
    ACTIONS(7971), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249874] = 4,
    ACTIONS(7973), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249929] = 4,
    ACTIONS(7975), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [249984] = 4,
    ACTIONS(7977), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250039] = 4,
    ACTIONS(7979), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250094] = 4,
    ACTIONS(7103), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250149] = 4,
    ACTIONS(7981), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250204] = 4,
    STATE(290), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_then,
      sym_keyword_else,
      sym_keyword_end,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_returning,
      sym_keyword_between,
      sym_keyword_preceding,
      sym_keyword_following,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250259] = 4,
    ACTIONS(7983), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250314] = 4,
    STATE(3524), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3426), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [250369] = 4,
    ACTIONS(7263), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250424] = 4,
    ACTIONS(7985), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250479] = 4,
    ACTIONS(7987), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250534] = 4,
    ACTIONS(7989), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250589] = 4,
    ACTIONS(7991), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250644] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6183), 1,
      sym_keyword_in,
    ACTIONS(6185), 1,
      sym_keyword_and,
    ACTIONS(6187), 1,
      sym_keyword_or,
    ACTIONS(6189), 1,
      sym_keyword_is,
    ACTIONS(6191), 1,
      sym_keyword_not,
    ACTIONS(6193), 1,
      sym_keyword_between,
    ACTIONS(6195), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      sym_op_other,
    ACTIONS(6209), 1,
      anon_sym_PLUS,
    ACTIONS(6211), 1,
      anon_sym_DASH,
    ACTIONS(6213), 1,
      anon_sym_SLASH,
    ACTIONS(6215), 1,
      anon_sym_CARET,
    ACTIONS(6703), 1,
      anon_sym_COLON_COLON,
    STATE(10807), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6205), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1449), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1458), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6199), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(7058), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [250737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250790] = 4,
    ACTIONS(7993), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250845] = 5,
    ACTIONS(7657), 1,
      sym_keyword_filter,
    STATE(4047), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250902] = 4,
    ACTIONS(7995), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [250957] = 4,
    ACTIONS(7965), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251011] = 4,
    ACTIONS(7997), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251065] = 4,
    ACTIONS(7999), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251119] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2002), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [251171] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3518), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3520), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [251223] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    ACTIONS(8001), 1,
      sym_keyword_not,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [251305] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3574), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3576), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [251357] = 5,
    STATE(3675), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4528), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251413] = 4,
    ACTIONS(8004), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251467] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251519] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3578), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3580), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [251571] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251623] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251675] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4516), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251783] = 4,
    ACTIONS(8008), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251837] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251889] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3630), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3632), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [251941] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [251993] = 4,
    ACTIONS(8010), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252047] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2424), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252151] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3558), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3560), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252203] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3502), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3504), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252255] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3622), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3624), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252359] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3602), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3604), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252411] = 4,
    ACTIONS(8012), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252465] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3498), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3500), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252517] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3572), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [252569] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252673] = 4,
    ACTIONS(8014), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252727] = 29,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7571), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8016), 1,
      sym_keyword_and,
    ACTIONS(8018), 1,
      sym_keyword_or,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8022), 1,
      sym_keyword_not,
    ACTIONS(8024), 1,
      sym_keyword_between,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(6377), 1,
      sym_identifier,
    STATE(7021), 1,
      sym__alias,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5912), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5914), 2,
      sym_keyword_from,
      sym_keyword_create,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8030), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8026), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252831] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252935] = 4,
    ACTIONS(8042), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [252989] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3524), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253093] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3516), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253145] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253197] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3586), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3588), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253249] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3590), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3592), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253301] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3598), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3600), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253353] = 4,
    STATE(3877), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253511] = 7,
    ACTIONS(7149), 1,
      sym_keyword_without,
    ACTIONS(8044), 1,
      sym_keyword_with,
    ACTIONS(8047), 1,
      anon_sym_LPAREN,
    STATE(3440), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253571] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253623] = 5,
    ACTIONS(8049), 1,
      aux_sym__single_quote_string_token2,
    STATE(3708), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253679] = 7,
    ACTIONS(7149), 1,
      sym_keyword_without,
    ACTIONS(8051), 1,
      sym_keyword_with,
    ACTIONS(8054), 1,
      anon_sym_LPAREN,
    STATE(3442), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253739] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3510), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3512), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253791] = 8,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253853] = 11,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 25,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [253921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3564), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [253973] = 4,
    ACTIONS(8056), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254027] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254079] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [254131] = 6,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254189] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [254241] = 13,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 24,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254313] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254365] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254417] = 4,
    ACTIONS(8058), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254471] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254523] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3506), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3508), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [254679] = 4,
    ACTIONS(8060), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254733] = 4,
    ACTIONS(8062), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254787] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4429), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254843] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254895] = 4,
    ACTIONS(8064), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [254949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [255001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3582), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3584), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [255053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255157] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255209] = 5,
    ACTIONS(8066), 1,
      aux_sym__single_quote_string_token2,
    STATE(3506), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255369] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255421] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255473] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255525] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255577] = 4,
    ACTIONS(8069), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255631] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255683] = 4,
    ACTIONS(8071), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255789] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255841] = 4,
    ACTIONS(7283), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [255895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [255947] = 4,
    ACTIONS(8073), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256001] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [256087] = 5,
    ACTIONS(8075), 1,
      aux_sym__single_quote_string_token2,
    STATE(3506), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256143] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256195] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2382), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2384), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [256247] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256299] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256351] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256403] = 4,
    ACTIONS(8077), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256457] = 4,
    ACTIONS(8079), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256511] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [256563] = 4,
    ACTIONS(8081), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256617] = 4,
    ACTIONS(8083), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256671] = 4,
    ACTIONS(8085), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256725] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [256777] = 5,
    ACTIONS(8087), 1,
      aux_sym__single_quote_string_token2,
    STATE(3522), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256833] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [256885] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [256937] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4534), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [256993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257045] = 5,
    STATE(3815), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4493), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257101] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257153] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257205] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257257] = 4,
    ACTIONS(8089), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257311] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [257397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257553] = 4,
    ACTIONS(8091), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257607] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4541), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257715] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257767] = 4,
    ACTIONS(8093), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257821] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4560), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257877] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [257929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3606), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3608), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [257981] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258033] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3610), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3612), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [258085] = 4,
    ACTIONS(8095), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258139] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258191] = 4,
    ACTIONS(8097), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258349] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258453] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258505] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [258557] = 4,
    ACTIONS(8099), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258611] = 4,
    ACTIONS(8101), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258665] = 4,
    ACTIONS(8103), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258719] = 4,
    ACTIONS(8105), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258773] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6437), 1,
      sym_keyword_in,
    ACTIONS(6439), 1,
      sym_keyword_is,
    ACTIONS(6441), 1,
      sym_keyword_not,
    ACTIONS(6443), 1,
      sym_keyword_between,
    ACTIONS(6445), 1,
      anon_sym_LBRACK,
    ACTIONS(6453), 1,
      sym_op_other,
    ACTIONS(6455), 1,
      anon_sym_PLUS,
    ACTIONS(6457), 1,
      anon_sym_DASH,
    ACTIONS(6459), 1,
      anon_sym_SLASH,
    ACTIONS(6461), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      sym_keyword_and,
    ACTIONS(6610), 1,
      sym_keyword_or,
    ACTIONS(6839), 1,
      anon_sym_COLON_COLON,
    STATE(10804), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6449), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6451), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1634), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1635), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6447), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(7058), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [258865] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4584), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258921] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4593), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [258977] = 4,
    ACTIONS(8107), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 35,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_cache,
      sym_keyword_array,
      sym__identifier,
  [259031] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4631), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259087] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259139] = 4,
    ACTIONS(8109), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259193] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3634), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3636), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [259245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259349] = 4,
    ACTIONS(8111), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259403] = 9,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259467] = 4,
    ACTIONS(8113), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259521] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259573] = 4,
    ACTIONS(8115), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259679] = 4,
    ACTIONS(8117), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259733] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259785] = 4,
    ACTIONS(8119), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259839] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259891] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [259943] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3638), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3640), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [259995] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4656), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260051] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4388), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260107] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260211] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3642), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3644), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [260263] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260315] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260367] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3618), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3620), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [260419] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260471] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260523] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260679] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260783] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260835] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4538), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260891] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260945] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [260997] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261049] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261101] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261153] = 5,
    ACTIONS(8121), 1,
      aux_sym__single_quote_string_token2,
    STATE(3683), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1376), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [261261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261313] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261365] = 4,
    ACTIONS(8123), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261419] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4626), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261475] = 13,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 24,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261547] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261599] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3614), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3616), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [261651] = 4,
    ACTIONS(8125), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261705] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4585), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261761] = 8,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261823] = 4,
    ACTIONS(8127), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261877] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4579), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261933] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [261985] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262037] = 4,
    ACTIONS(8129), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [262143] = 6,
    ACTIONS(8131), 1,
      anon_sym_LBRACK,
    STATE(3634), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4432), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262201] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7613), 1,
      sym_keyword_between,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [262289] = 4,
    ACTIONS(8134), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262395] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7605), 1,
      sym_keyword_and,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7613), 1,
      sym_keyword_between,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [262485] = 16,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    ACTIONS(8001), 1,
      sym_keyword_not,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262563] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3460), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3462), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [262615] = 4,
    ACTIONS(8136), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262669] = 4,
    ACTIONS(8138), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262723] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [262775] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262827] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3646), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3648), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [262879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [262931] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [262983] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263035] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4561), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263143] = 5,
    ACTIONS(8140), 1,
      sym_keyword_unsigned,
    ACTIONS(8142), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263199] = 4,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263253] = 4,
    ACTIONS(8146), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263307] = 4,
    ACTIONS(8148), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263361] = 4,
    ACTIONS(8150), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263415] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3594), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3596), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263467] = 4,
    ACTIONS(8152), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263521] = 4,
    ACTIONS(8154), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263679] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3494), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3496), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263783] = 5,
    STATE(2847), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3380), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3230), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [263839] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4507), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263895] = 4,
    STATE(4222), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [263949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264105] = 4,
    STATE(2609), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3426), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [264159] = 5,
    ACTIONS(2618), 1,
      aux_sym__single_quote_string_token2,
    STATE(345), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264215] = 4,
    ACTIONS(8156), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3364), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3366), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [264269] = 4,
    ACTIONS(8158), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264323] = 4,
    ACTIONS(8160), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264377] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264429] = 6,
    ACTIONS(8162), 1,
      anon_sym_LBRACK,
    STATE(3675), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4528), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264539] = 5,
    ACTIONS(8165), 1,
      sym_keyword_varying,
    ACTIONS(8167), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264595] = 4,
    ACTIONS(8169), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264649] = 4,
    ACTIONS(8171), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264703] = 4,
    ACTIONS(8173), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264757] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4485), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264813] = 4,
    ACTIONS(8175), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264867] = 5,
    ACTIONS(8177), 1,
      aux_sym__single_quote_string_token2,
    STATE(3707), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264923] = 4,
    ACTIONS(8179), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [264977] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265029] = 4,
    ACTIONS(8181), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265083] = 4,
    ACTIONS(8183), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265137] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265189] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265241] = 4,
    ACTIONS(8185), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265295] = 4,
    ACTIONS(8187), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265349] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265401] = 4,
    ACTIONS(8189), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265455] = 4,
    ACTIONS(8191), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265509] = 4,
    ACTIONS(8193), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265563] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1376), 35,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_cache,
      sym_keyword_array,
      sym__identifier,
  [265615] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265667] = 4,
    ACTIONS(8195), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265721] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265825] = 4,
    ACTIONS(8197), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265879] = 4,
    ACTIONS(8199), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265933] = 4,
    ACTIONS(8201), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [265987] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266091] = 4,
    ACTIONS(8203), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266145] = 5,
    ACTIONS(8205), 1,
      aux_sym__single_quote_string_token2,
    STATE(3707), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266201] = 5,
    ACTIONS(8177), 1,
      aux_sym__single_quote_string_token2,
    STATE(3707), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266309] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [266361] = 4,
    ACTIONS(8208), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266415] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4468), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266471] = 5,
    ACTIONS(8210), 1,
      sym_keyword_unsigned,
    ACTIONS(8212), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266527] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266579] = 4,
    ACTIONS(8214), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266633] = 4,
    ACTIONS(8216), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266687] = 4,
    ACTIONS(8218), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266741] = 4,
    ACTIONS(8220), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266795] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266847] = 4,
    ACTIONS(8222), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266901] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [266953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267005] = 4,
    ACTIONS(7422), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267059] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267111] = 4,
    ACTIONS(8224), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267217] = 4,
    ACTIONS(8226), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267323] = 4,
    ACTIONS(8228), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267377] = 4,
    ACTIONS(8230), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267431] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [267483] = 5,
    ACTIONS(8232), 1,
      sym_keyword_precision,
    ACTIONS(8234), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267539] = 4,
    ACTIONS(7679), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267593] = 4,
    ACTIONS(8236), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267647] = 4,
    ACTIONS(8238), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267701] = 4,
    ACTIONS(8240), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267755] = 4,
    ACTIONS(8242), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267809] = 4,
    ACTIONS(8244), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267863] = 4,
    ACTIONS(8246), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267917] = 4,
    ACTIONS(8248), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [267971] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268023] = 5,
    STATE(3634), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4432), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268079] = 4,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2374), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2376), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [268185] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268237] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268289] = 4,
    ACTIONS(8250), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268395] = 4,
    ACTIONS(8252), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [268501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [268553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268605] = 5,
    ACTIONS(8006), 1,
      sym_keyword_filter,
    STATE(4458), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268661] = 4,
    ACTIONS(8254), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268715] = 4,
    ACTIONS(8256), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268769] = 4,
    ACTIONS(7498), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268823] = 4,
    ACTIONS(8258), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268877] = 4,
    ACTIONS(8260), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268931] = 4,
    ACTIONS(8262), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [268985] = 7,
    ACTIONS(6059), 1,
      sym_keyword_without,
    ACTIONS(8264), 1,
      sym_keyword_with,
    ACTIONS(8267), 1,
      anon_sym_LPAREN,
    STATE(2455), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1772), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [269045] = 7,
    ACTIONS(6059), 1,
      sym_keyword_without,
    ACTIONS(8269), 1,
      sym_keyword_with,
    ACTIONS(8272), 1,
      anon_sym_LPAREN,
    STATE(2454), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1794), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [269105] = 4,
    ACTIONS(8274), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269159] = 4,
    ACTIONS(8276), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269213] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [269317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269369] = 4,
    ACTIONS(8278), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269423] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 37,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269475] = 4,
    ACTIONS(8280), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269581] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2863), 1,
      sym_keyword_not,
    ACTIONS(2865), 1,
      anon_sym_LBRACK,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3009), 1,
      sym_keyword_between,
    ACTIONS(3062), 1,
      sym_keyword_and,
    ACTIONS(3994), 1,
      sym_keyword_or,
    ACTIONS(3996), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6725), 1,
      sym_keyword_using,
    STATE(7274), 1,
      sym_direction,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6721), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6518), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_COMMA,
  [269679] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [269731] = 4,
    ACTIONS(8282), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [269837] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269889] = 4,
    ACTIONS(8284), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269943] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [269995] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270047] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270099] = 5,
    ACTIONS(8286), 1,
      sym_keyword_unsigned,
    ACTIONS(8288), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270155] = 5,
    ACTIONS(8290), 1,
      sym_keyword_unsigned,
    ACTIONS(8292), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270211] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270263] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270315] = 5,
    ACTIONS(8294), 1,
      aux_sym__single_quote_string_token2,
    STATE(3670), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270371] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270423] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270475] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270527] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270579] = 4,
    ACTIONS(8296), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270633] = 4,
    ACTIONS(8298), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270687] = 4,
    ACTIONS(8300), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270741] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2386), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2388), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [270845] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270897] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [270949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2366), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2368), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [271105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2370), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2372), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [271157] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271313] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271365] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271417] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271521] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271573] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271625] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271781] = 4,
    ACTIONS(8302), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271835] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271939] = 6,
    ACTIONS(8304), 1,
      anon_sym_LBRACK,
    STATE(3815), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4493), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [271997] = 4,
    ACTIONS(8307), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272051] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2378), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2380), 26,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [272103] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272155] = 6,
    ACTIONS(7685), 1,
      sym_keyword_with,
    ACTIONS(7687), 1,
      sym_keyword_without,
    STATE(4611), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272213] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272369] = 5,
    ACTIONS(8309), 1,
      aux_sym__single_quote_string_token2,
    STATE(3833), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272425] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272477] = 5,
    ACTIONS(8311), 1,
      sym_keyword_unsigned,
    ACTIONS(8313), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272637] = 5,
    ACTIONS(8315), 1,
      sym_keyword_unsigned,
    ACTIONS(8317), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272693] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272745] = 5,
    ACTIONS(8319), 1,
      sym_keyword_unsigned,
    ACTIONS(8321), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272853] = 6,
    ACTIONS(7685), 1,
      sym_keyword_with,
    ACTIONS(7687), 1,
      sym_keyword_without,
    STATE(4612), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272911] = 5,
    ACTIONS(8075), 1,
      aux_sym__single_quote_string_token2,
    STATE(3506), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [272967] = 5,
    ACTIONS(8323), 1,
      sym_keyword_unsigned,
    ACTIONS(8325), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273023] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273227] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273380] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273431] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273482] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273635] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273686] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3634), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3636), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [273788] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3638), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3640), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [273839] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273941] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [273992] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274094] = 8,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274155] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274308] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274359] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274410] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274461] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274512] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274563] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274614] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3642), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3644), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [274665] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274767] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3524), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [274869] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274920] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [274971] = 13,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2430), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 24,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275042] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275093] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3618), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3620), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [275144] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3572), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [275195] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275246] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275348] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275450] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_offset,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [275603] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275654] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275705] = 4,
    ACTIONS(8339), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3364), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3366), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [275758] = 4,
    ACTIONS(8341), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275811] = 6,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275868] = 4,
    ACTIONS(8343), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [275972] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276023] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276227] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3510), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3512), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [276380] = 6,
    ACTIONS(7149), 1,
      sym_keyword_without,
    ACTIONS(8345), 1,
      sym_keyword_with,
    STATE(3551), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276437] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276488] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276539] = 6,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276596] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276647] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276698] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276749] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276902] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [276953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277004] = 4,
    ACTIONS(8348), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277057] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277363] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277465] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277516] = 4,
    ACTIONS(8350), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277569] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277620] = 4,
    ACTIONS(8352), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277673] = 5,
    ACTIONS(8354), 1,
      aux_sym__single_quote_string_token2,
    STATE(4326), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277728] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277779] = 13,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [277901] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 19,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1376), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [277952] = 8,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 26,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278013] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278064] = 4,
    ACTIONS(8370), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278219] = 6,
    ACTIONS(8372), 1,
      anon_sym_LBRACK,
    STATE(3935), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4672), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278276] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278327] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278378] = 4,
    ACTIONS(8375), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278431] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278482] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278635] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278686] = 5,
    ACTIONS(8377), 1,
      aux_sym__single_quote_string_token2,
    STATE(4295), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278741] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278843] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [278894] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [278977] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279028] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279079] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279130] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279181] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3598), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3600), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [279283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279436] = 20,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7912), 1,
      sym_keyword_not,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2489), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(7916), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2491), 8,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [279521] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279572] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279623] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279674] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279725] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279776] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279827] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279878] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [279980] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280082] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8391), 1,
      sym_keyword_and,
    ACTIONS(8393), 1,
      sym_keyword_or,
    ACTIONS(8395), 1,
      sym_keyword_not,
    ACTIONS(8397), 1,
      sym_keyword_between,
    ACTIONS(8401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8405), 1,
      sym_op_other,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8403), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8399), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [280173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [280326] = 4,
    ACTIONS(8407), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280379] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280430] = 4,
    ACTIONS(8409), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280483] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3590), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3592), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [280534] = 4,
    ACTIONS(8411), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280587] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3586), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3588), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [280638] = 4,
    ACTIONS(8413), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280691] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280742] = 4,
    ACTIONS(8415), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280795] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3610), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3612), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [280846] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3606), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3608), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [280897] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280948] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [280999] = 4,
    ACTIONS(7673), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281103] = 4,
    ACTIONS(8417), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281156] = 4,
    ACTIONS(8419), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281209] = 6,
    ACTIONS(7149), 1,
      sym_keyword_without,
    ACTIONS(8421), 1,
      sym_keyword_with,
    STATE(3552), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281368] = 4,
    STATE(4415), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281421] = 4,
    ACTIONS(8234), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281474] = 4,
    ACTIONS(8424), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281527] = 4,
    ACTIONS(8426), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281580] = 4,
    ACTIONS(8428), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281633] = 4,
    ACTIONS(8430), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281686] = 4,
    ACTIONS(8432), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281739] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281790] = 4,
    ACTIONS(8434), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281843] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281945] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [281996] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3582), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3584), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [282047] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282149] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282200] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282251] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282353] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [282436] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3506), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3508), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [282487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3646), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3648), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [282538] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282589] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282691] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282844] = 20,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7912), 1,
      sym_keyword_not,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2392), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(7916), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2394), 8,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [282929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [282980] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283133] = 4,
    ACTIONS(8436), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283186] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283237] = 4,
    ACTIONS(8438), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283290] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283341] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283392] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283443] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3574), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3576), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [283494] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283545] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3578), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3580), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [283596] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283647] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283698] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283749] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283800] = 4,
    ACTIONS(8440), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283853] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3630), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3632), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [283904] = 7,
    ACTIONS(7450), 1,
      sym_keyword_without,
    ACTIONS(8442), 1,
      sym_keyword_with,
    ACTIONS(8445), 1,
      anon_sym_LPAREN,
    STATE(4316), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [283963] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284014] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284065] = 4,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284118] = 4,
    ACTIONS(8449), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284171] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284222] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284273] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284324] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284375] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284477] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284528] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284579] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284630] = 5,
    STATE(3935), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(4672), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284685] = 7,
    ACTIONS(7450), 1,
      sym_keyword_without,
    ACTIONS(8451), 1,
      sym_keyword_with,
    ACTIONS(8454), 1,
      anon_sym_LPAREN,
    STATE(4314), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284795] = 4,
    ACTIONS(8456), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284848] = 4,
    ACTIONS(8458), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284901] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [284952] = 4,
    ACTIONS(8460), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 36,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285107] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285158] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285209] = 4,
    ACTIONS(8462), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285262] = 4,
    ACTIONS(8464), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285315] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [285366] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285417] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285468] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2491), 1,
      sym_keyword_or,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8395), 1,
      sym_keyword_not,
    ACTIONS(8405), 1,
      sym_op_other,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8403), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8399), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [285553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285604] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285655] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1376), 24,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [285706] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285757] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285808] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285859] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [285961] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286012] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286063] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286114] = 20,
    ACTIONS(2394), 1,
      sym_keyword_or,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8395), 1,
      sym_keyword_not,
    ACTIONS(8405), 1,
      sym_op_other,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8403), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8399), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [286199] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286301] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286352] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286403] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286454] = 4,
    ACTIONS(8466), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286507] = 4,
    ACTIONS(8468), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286560] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286611] = 18,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    ACTIONS(8470), 1,
      sym_keyword_not,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(7916), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2426), 11,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym__identifier,
  [286692] = 8,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_keyword_is,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 18,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [286753] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286855] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286906] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [286957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287008] = 11,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 16,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [287075] = 13,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 15,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [287146] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287197] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287248] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287299] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7605), 1,
      sym_keyword_and,
    ACTIONS(7607), 1,
      sym_keyword_or,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7613), 1,
      sym_keyword_between,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7623), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6767), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [287390] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287441] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3622), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3624), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [287594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287645] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287747] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287798] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [287951] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288002] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288155] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288308] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288359] = 20,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7833), 1,
      sym_keyword_not,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7845), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7839), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2491), 7,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [288444] = 20,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7833), 1,
      sym_keyword_not,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7845), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7839), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2394), 7,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [288529] = 18,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    ACTIONS(8473), 1,
      sym_keyword_not,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7845), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7839), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 10,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym__identifier,
  [288610] = 8,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 17,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [288671] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288926] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [288977] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3594), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3596), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [289028] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289079] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [289130] = 11,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 15,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [289197] = 13,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 14,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [289268] = 4,
    ACTIONS(8476), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289321] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [289372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [289423] = 4,
    STATE(4471), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289476] = 4,
    ACTIONS(8478), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289529] = 9,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 16,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [289592] = 16,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    ACTIONS(8473), 1,
      sym_keyword_not,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 12,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [289669] = 5,
    ACTIONS(8480), 1,
      aux_sym__single_quote_string_token2,
    STATE(3925), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289775] = 22,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7827), 1,
      sym_keyword_and,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7833), 1,
      sym_keyword_not,
    ACTIONS(7835), 1,
      sym_keyword_between,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7845), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_or,
      sym__identifier,
    ACTIONS(7839), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [289864] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289915] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [289966] = 21,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7825), 1,
      sym_keyword_in,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7833), 1,
      sym_keyword_not,
    ACTIONS(7835), 1,
      sym_keyword_between,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7847), 1,
      sym_op_other,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7845), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7839), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 6,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym__identifier,
  [290053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290155] = 6,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [290212] = 8,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 17,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [290273] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290324] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290375] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290477] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290528] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290579] = 9,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 17,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [290642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290693] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290744] = 16,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    ACTIONS(8470), 1,
      sym_keyword_not,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 13,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [290821] = 6,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 19,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [290878] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [290980] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291184] = 22,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7906), 1,
      sym_keyword_and,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7912), 1,
      sym_keyword_not,
    ACTIONS(7914), 1,
      sym_keyword_between,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(7916), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2426), 6,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_or,
      sym__identifier,
  [291273] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291324] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291375] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291477] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291528] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291579] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291732] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291783] = 21,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7904), 1,
      sym_keyword_in,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7912), 1,
      sym_keyword_not,
    ACTIONS(7914), 1,
      sym_keyword_between,
    ACTIONS(7924), 1,
      sym_op_other,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(7916), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2426), 7,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_and,
      sym_keyword_or,
      sym__identifier,
  [291870] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [291972] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292023] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292074] = 6,
    ACTIONS(6059), 1,
      sym_keyword_without,
    ACTIONS(8482), 1,
      sym_keyword_with,
    STATE(2507), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1848), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [292131] = 6,
    ACTIONS(6059), 1,
      sym_keyword_without,
    ACTIONS(8485), 1,
      sym_keyword_with,
    STATE(2506), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1844), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [292188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292239] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292290] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292341] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292392] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    STATE(4881), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2804), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [292451] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292502] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2002), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [292553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292604] = 18,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8405), 1,
      sym_op_other,
    ACTIONS(8488), 1,
      sym_keyword_not,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8403), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8399), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [292685] = 4,
    ACTIONS(8491), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292738] = 8,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 26,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292799] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292850] = 17,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8493), 1,
      sym_keyword_not,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [292929] = 8,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [292990] = 11,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 25,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293057] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293108] = 11,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293175] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293226] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293277] = 13,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 24,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293348] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [293399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293450] = 13,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293521] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293572] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [293623] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [293674] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293725] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [293776] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293827] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293878] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [293980] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [294031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [294082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294184] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294235] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294337] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294388] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294439] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294490] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294541] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294592] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294643] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294694] = 13,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_keyword_is,
    ACTIONS(7926), 1,
      anon_sym_PLUS,
    ACTIONS(7928), 1,
      anon_sym_DASH,
    ACTIONS(7930), 1,
      anon_sym_SLASH,
    ACTIONS(7932), 1,
      anon_sym_CARET,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7918), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 15,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [294765] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294867] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [294969] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295020] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295122] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295275] = 13,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 14,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [295346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295499] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295550] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295601] = 8,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_keyword_is,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 17,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295662] = 4,
    STATE(3351), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3426), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295715] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295766] = 13,
    ACTIONS(7831), 1,
      sym_keyword_is,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(7849), 1,
      anon_sym_PLUS,
    ACTIONS(7851), 1,
      anon_sym_DASH,
    ACTIONS(7853), 1,
      anon_sym_SLASH,
    ACTIONS(7855), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7841), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1299), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1298), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 14,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [295837] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295888] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [295939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [295990] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296092] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296143] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296194] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296245] = 8,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_keyword_is,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1637), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1626), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 18,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [296306] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296357] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296408] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296561] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296612] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3498), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3500), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [296663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [296765] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [296816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [296867] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [296969] = 4,
    ACTIONS(8496), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297022] = 7,
    ACTIONS(7488), 1,
      sym_keyword_without,
    ACTIONS(8498), 1,
      sym_keyword_with,
    ACTIONS(8501), 1,
      anon_sym_LPAREN,
    STATE(4020), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297081] = 7,
    ACTIONS(7488), 1,
      sym_keyword_without,
    ACTIONS(8503), 1,
      sym_keyword_with,
    ACTIONS(8506), 1,
      anon_sym_LPAREN,
    STATE(4019), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [297191] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297242] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3460), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3462), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [297293] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [297344] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297395] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297446] = 9,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 27,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297509] = 16,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8493), 1,
      sym_keyword_not,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297586] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297637] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297688] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297739] = 5,
    ACTIONS(8354), 1,
      aux_sym__single_quote_string_token2,
    STATE(4326), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297794] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297845] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3602), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3604), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [297896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 36,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [297947] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8508), 1,
      sym_keyword_and,
    ACTIONS(8510), 1,
      sym_keyword_between,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_or,
      sym_keyword_returning,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [298034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298085] = 4,
    STATE(4475), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298189] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298240] = 20,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7563), 1,
      sym_keyword_not,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7573), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7567), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2491), 7,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [298325] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298427] = 20,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7563), 1,
      sym_keyword_not,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7573), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7567), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2394), 7,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [298512] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298563] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298614] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298665] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298767] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298869] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298920] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [298971] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299022] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299073] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299124] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299175] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299226] = 18,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    ACTIONS(8512), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7573), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7567), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 10,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym__identifier,
  [299307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3518), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3520), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [299358] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8510), 1,
      sym_keyword_between,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [299443] = 8,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_keyword_is,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 17,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [299504] = 5,
    ACTIONS(8515), 1,
      aux_sym__single_quote_string_token2,
    STATE(4326), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299559] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3614), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3616), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [299610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299661] = 11,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 15,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [299728] = 13,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 14,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [299799] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [299850] = 7,
    ACTIONS(6715), 1,
      sym_keyword_without,
    ACTIONS(8518), 1,
      sym_keyword_with,
    ACTIONS(8521), 1,
      anon_sym_LPAREN,
    STATE(2863), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1772), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [299909] = 7,
    ACTIONS(6715), 1,
      sym_keyword_without,
    ACTIONS(8523), 1,
      sym_keyword_with,
    ACTIONS(8526), 1,
      anon_sym_LPAREN,
    STATE(3028), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1794), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [299968] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300070] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2424), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [300121] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3558), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3560), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [300223] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300325] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300427] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300478] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300580] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300631] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3494), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3496), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [300682] = 9,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 16,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [300745] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [300796] = 16,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    ACTIONS(8512), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 12,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [300873] = 6,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [300930] = 22,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7557), 1,
      sym_keyword_and,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7563), 1,
      sym_keyword_not,
    ACTIONS(7565), 1,
      sym_keyword_between,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7573), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_or,
      sym__identifier,
    ACTIONS(7567), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [301019] = 21,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(7561), 1,
      sym_keyword_is,
    ACTIONS(7563), 1,
      sym_keyword_not,
    ACTIONS(7565), 1,
      sym_keyword_between,
    ACTIONS(7575), 1,
      sym_op_other,
    ACTIONS(7577), 1,
      anon_sym_PLUS,
    ACTIONS(7579), 1,
      anon_sym_DASH,
    ACTIONS(7581), 1,
      anon_sym_SLASH,
    ACTIONS(7583), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7569), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7573), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1069), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1070), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7567), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 6,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym__identifier,
  [301106] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8395), 1,
      sym_keyword_not,
    ACTIONS(8397), 1,
      sym_keyword_between,
    ACTIONS(8405), 1,
      sym_op_other,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8403), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8399), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [301193] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2426), 1,
      sym_keyword_or,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8391), 1,
      sym_keyword_and,
    ACTIONS(8395), 1,
      sym_keyword_not,
    ACTIONS(8397), 1,
      sym_keyword_between,
    ACTIONS(8405), 1,
      sym_op_other,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8403), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8399), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
  [301282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3502), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3504), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [301333] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [301384] = 16,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8362), 1,
      anon_sym_PLUS,
    ACTIONS(8364), 1,
      anon_sym_DASH,
    ACTIONS(8366), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8389), 1,
      sym_keyword_in,
    ACTIONS(8405), 1,
      sym_op_other,
    ACTIONS(8488), 1,
      sym_keyword_not,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8360), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [301461] = 9,
    ACTIONS(8356), 1,
      sym_keyword_is,
    ACTIONS(8358), 1,
      anon_sym_LBRACK,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    STATE(10252), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1598), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1597), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 26,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [301524] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3578), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3580), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [301574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [301624] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4739), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2519), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2521), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [301678] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 12,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [301760] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 12,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [301842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3582), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3584), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [301892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [301942] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [301992] = 17,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8550), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 15,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [302070] = 8,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8530), 1,
      sym_keyword_is,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302130] = 11,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 24,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302196] = 13,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302266] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1370), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [302318] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4736), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2499), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2501), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [302372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302422] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302522] = 9,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302584] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    STATE(2674), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2804), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [302642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302692] = 16,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8550), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 20,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302768] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302818] = 6,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 28,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [302874] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 10,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_or,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [302960] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8555), 1,
      sym_keyword_between,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 11,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [303044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303144] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303194] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303244] = 4,
    ACTIONS(8557), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303296] = 6,
    ACTIONS(6715), 1,
      sym_keyword_without,
    ACTIONS(8559), 1,
      sym_keyword_with,
    STATE(3014), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1848), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [303352] = 6,
    ACTIONS(6715), 1,
      sym_keyword_without,
    ACTIONS(8562), 1,
      sym_keyword_with,
    STATE(3015), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1844), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 22,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [303408] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303458] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8508), 1,
      sym_keyword_and,
    ACTIONS(8510), 1,
      sym_keyword_between,
    ACTIONS(8567), 1,
      sym_keyword_or,
    ACTIONS(8569), 1,
      anon_sym_COLON_COLON,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(8565), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_COMMA,
  [303548] = 21,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8022), 1,
      sym_keyword_not,
    ACTIONS(8024), 1,
      sym_keyword_between,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8030), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(8026), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2426), 6,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym__identifier,
  [303634] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303684] = 22,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(8016), 1,
      sym_keyword_and,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8022), 1,
      sym_keyword_not,
    ACTIONS(8024), 1,
      sym_keyword_between,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8030), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 5,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_or,
      sym__identifier,
    ACTIONS(8026), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303772] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [303822] = 6,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [303878] = 16,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    ACTIONS(8571), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 12,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [303954] = 9,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 16,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym__identifier,
  [304016] = 13,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 14,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [304086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304136] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3646), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3648), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [304186] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304236] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304336] = 8,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8530), 1,
      sym_keyword_is,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 26,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304396] = 8,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_keyword_is,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 17,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [304456] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304506] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304606] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304656] = 18,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    ACTIONS(8571), 1,
      sym_keyword_not,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8030), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(8026), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2426), 10,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym__identifier,
  [304736] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304786] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [304836] = 20,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8022), 1,
      sym_keyword_not,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8030), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2392), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(8026), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2394), 7,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [304920] = 20,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5932), 1,
      sym_keyword_similar,
    ACTIONS(7555), 1,
      sym_keyword_in,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8022), 1,
      sym_keyword_not,
    ACTIONS(8032), 1,
      sym_op_other,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(5930), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8030), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2489), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(8026), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2491), 7,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      sym__identifier,
  [305004] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305054] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3574), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3576), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [305104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305154] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305204] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305254] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305404] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305454] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3460), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3462), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [305554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305604] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305654] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305704] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305754] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305854] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305904] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [305954] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306004] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306054] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306154] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306204] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306254] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306354] = 8,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_keyword_is,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 17,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [306414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306464] = 13,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8034), 1,
      anon_sym_PLUS,
    ACTIONS(8036), 1,
      anon_sym_DASH,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2430), 14,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      sym__identifier,
  [306534] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306634] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306684] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306784] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306834] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [306884] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3518), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3520), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [306934] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4737), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2555), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2557), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [306988] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3614), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3616), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [307038] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307088] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307338] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307388] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307438] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4740), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [307492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307542] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307592] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4741), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2539), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2541), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [307646] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307746] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3506), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3508), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [307796] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307846] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [307946] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4742), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [308000] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4792), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2503), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2505), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [308054] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4751), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2507), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2509), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [308108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308158] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4754), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [308212] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4756), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2515), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2517), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [308266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308316] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308366] = 7,
    ACTIONS(7687), 1,
      sym_keyword_without,
    ACTIONS(8574), 1,
      sym_keyword_with,
    ACTIONS(8577), 1,
      anon_sym_LPAREN,
    STATE(4540), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308424] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308474] = 7,
    ACTIONS(7687), 1,
      sym_keyword_without,
    ACTIONS(8579), 1,
      sym_keyword_with,
    ACTIONS(8582), 1,
      anon_sym_LPAREN,
    STATE(4539), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308532] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7605), 1,
      sym_keyword_and,
    ACTIONS(7607), 1,
      sym_keyword_or,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7613), 1,
      sym_keyword_between,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7623), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [308622] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308672] = 6,
    ACTIONS(7450), 1,
      sym_keyword_without,
    ACTIONS(8584), 1,
      sym_keyword_with,
    STATE(4320), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308728] = 6,
    ACTIONS(7450), 1,
      sym_keyword_without,
    ACTIONS(8587), 1,
      sym_keyword_with,
    STATE(4319), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308784] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308834] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308884] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308934] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [308984] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309084] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309134] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4758), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2559), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2561), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [309188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309288] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4761), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [309342] = 4,
    STATE(4666), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309494] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3622), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3624), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [309594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3630), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3632), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [309694] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4762), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2547), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2549), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [309748] = 11,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_keyword_is,
    ACTIONS(8038), 1,
      anon_sym_SLASH,
    ACTIONS(8040), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8028), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1191), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1187), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 15,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      sym__identifier,
  [309814] = 13,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2430), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309884] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [309934] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4738), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [309988] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4763), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2527), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2529), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [310042] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310092] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310192] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310242] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310292] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310342] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310392] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310442] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310542] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7028), 1,
      sym_keyword_and,
    ACTIONS(7030), 1,
      sym_keyword_or,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7038), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(7058), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [310632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310732] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310782] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310882] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [310982] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311032] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311082] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4774), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [311136] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4775), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2523), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2525), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [311190] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311290] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311390] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311440] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4776), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [311494] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3494), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3496), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [311544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311694] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311794] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311844] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311944] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [311994] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312144] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312194] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312244] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312294] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3618), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3620), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [312344] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312494] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3594), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3596), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [312644] = 6,
    ACTIONS(7488), 1,
      sym_keyword_without,
    ACTIONS(8590), 1,
      sym_keyword_with,
    STATE(4239), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312750] = 6,
    ACTIONS(7488), 1,
      sym_keyword_without,
    ACTIONS(8593), 1,
      sym_keyword_with,
    STATE(4240), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312806] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312856] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312906] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [312956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313006] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313106] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313156] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313256] = 5,
    ACTIONS(8528), 1,
      sym_keyword_filter,
    STATE(4785), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [313310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313410] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313560] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313660] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313710] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313760] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313810] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [313960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314060] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314110] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3642), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3644), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [314210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314260] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 35,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_nulls,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [314360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314410] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3638), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3640), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [314460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3634), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3636), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [314510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314560] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314660] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314710] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314760] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314810] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3510), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3512), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [314860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [314910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [314960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315060] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315110] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315260] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315410] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3610), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3612), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [315560] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(8565), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_COMMA,
  [315650] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3598), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3600), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [315800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3590), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3592), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [315850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [315950] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316000] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3586), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3588), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [316100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316150] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316200] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316300] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316350] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316450] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316500] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3498), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3500), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [316550] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3602), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3604), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [316600] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316650] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3502), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3504), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [316700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3606), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3608), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [316750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [316950] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317000] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3558), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3560), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [317050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 25,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [317100] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317150] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317200] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 35,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317300] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 7,
      sym_keyword_in,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317350] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 35,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317450] = 6,
    ACTIONS(8602), 1,
      anon_sym_LPAREN,
    STATE(5173), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8600), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1794), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [317505] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317554] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8608), 1,
      sym_keyword_or,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3430), 7,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
  [317643] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317692] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8608), 1,
      sym_keyword_or,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3362), 7,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
  [317781] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317830] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [317879] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7603), 1,
      sym_keyword_in,
    ACTIONS(7605), 1,
      sym_keyword_and,
    ACTIONS(7607), 1,
      sym_keyword_or,
    ACTIONS(7609), 1,
      sym_keyword_is,
    ACTIONS(7611), 1,
      sym_keyword_not,
    ACTIONS(7613), 1,
      sym_keyword_between,
    ACTIONS(7615), 1,
      anon_sym_LBRACK,
    ACTIONS(7623), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7627), 1,
      sym_op_other,
    ACTIONS(7629), 1,
      anon_sym_PLUS,
    ACTIONS(7631), 1,
      anon_sym_DASH,
    ACTIONS(7633), 1,
      anon_sym_SLASH,
    ACTIONS(7635), 1,
      anon_sym_CARET,
    STATE(10903), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(7621), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7625), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1574), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1575), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7619), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(7058), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [317968] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318017] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7028), 1,
      sym_keyword_and,
    ACTIONS(7030), 1,
      sym_keyword_or,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7038), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7042), 1,
      sym_op_other,
    ACTIONS(7428), 1,
      anon_sym_COMMA,
    STATE(8173), 1,
      aux_sym_array_repeat1,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(8636), 5,
      sym_keyword_order,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
  [318110] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318306] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318355] = 5,
    ACTIONS(8638), 1,
      aux_sym__single_quote_string_token2,
    STATE(4684), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3180), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [318408] = 6,
    ACTIONS(7687), 1,
      sym_keyword_without,
    ACTIONS(8640), 1,
      sym_keyword_with,
    STATE(4612), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318463] = 7,
    ACTIONS(8643), 1,
      sym_keyword_unsigned,
    ACTIONS(8645), 1,
      sym_keyword_zerofill,
    ACTIONS(8647), 1,
      sym_keyword_precision,
    ACTIONS(8649), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [318520] = 7,
    ACTIONS(8651), 1,
      sym_keyword_unsigned,
    ACTIONS(8653), 1,
      sym_keyword_zerofill,
    ACTIONS(8655), 1,
      sym_keyword_precision,
    ACTIONS(8657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318577] = 6,
    ACTIONS(7687), 1,
      sym_keyword_without,
    ACTIONS(8659), 1,
      sym_keyword_with,
    STATE(4611), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318632] = 6,
    ACTIONS(8662), 1,
      anon_sym_LPAREN,
    STATE(5174), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8600), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1772), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [318687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318736] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8608), 1,
      sym_keyword_or,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3416), 7,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
  [318825] = 5,
    ACTIONS(6893), 1,
      aux_sym__single_quote_string_token2,
    STATE(2684), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3156), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [318878] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318927] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [318976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319025] = 7,
    ACTIONS(8664), 1,
      sym_keyword_with,
    ACTIONS(8666), 1,
      sym_keyword_without,
    ACTIONS(8668), 1,
      anon_sym_LPAREN,
    STATE(5137), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319082] = 7,
    ACTIONS(8664), 1,
      sym_keyword_with,
    ACTIONS(8666), 1,
      sym_keyword_without,
    ACTIONS(8670), 1,
      anon_sym_LPAREN,
    STATE(5138), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319139] = 8,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2430), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2428), 24,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319198] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319247] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319296] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319345] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319394] = 13,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2430), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2428), 21,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319463] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8608), 1,
      sym_keyword_or,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3386), 7,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
  [319552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319601] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319650] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319748] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319797] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319846] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [319895] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8608), 1,
      sym_keyword_or,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3422), 7,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
  [319984] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320033] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320131] = 4,
    ACTIONS(8672), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 33,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320182] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2392), 11,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      anon_sym_COLON_COLON,
  [320263] = 19,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2489), 11,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      anon_sym_COLON_COLON,
  [320344] = 20,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 10,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      anon_sym_COLON_COLON,
  [320427] = 21,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 9,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_or,
      anon_sym_COLON_COLON,
  [320512] = 6,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320567] = 16,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    ACTIONS(8674), 1,
      sym_keyword_not,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 19,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320642] = 9,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 5,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2424), 24,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320703] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320752] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8606), 1,
      sym_keyword_and,
    ACTIONS(8608), 1,
      sym_keyword_or,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8612), 1,
      sym_keyword_not,
    ACTIONS(8614), 1,
      sym_keyword_between,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(3440), 7,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
  [320841] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [320988] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(8565), 7,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [321077] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321126] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321175] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321273] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321322] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321371] = 17,
    ACTIONS(8604), 1,
      sym_keyword_in,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8626), 1,
      sym_op_other,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    ACTIONS(8674), 1,
      sym_keyword_not,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8624), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8618), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(2424), 14,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COLON_COLON,
  [321448] = 13,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8628), 1,
      anon_sym_PLUS,
    ACTIONS(8630), 1,
      anon_sym_DASH,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2426), 3,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 21,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321517] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321566] = 11,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    ACTIONS(8632), 1,
      anon_sym_SLASH,
    ACTIONS(8634), 1,
      anon_sym_CARET,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8620), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(2426), 4,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2424), 22,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321631] = 8,
    ACTIONS(8610), 1,
      sym_keyword_is,
    ACTIONS(8616), 1,
      anon_sym_LBRACK,
    STATE(10666), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(1167), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1168), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 24,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321690] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 34,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321739] = 6,
    ACTIONS(8664), 1,
      sym_keyword_with,
    ACTIONS(8666), 1,
      sym_keyword_without,
    STATE(5219), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321793] = 6,
    ACTIONS(8664), 1,
      sym_keyword_with,
    ACTIONS(8666), 1,
      sym_keyword_without,
    STATE(5218), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [321847] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2543), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2545), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [321895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2493), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2495), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [321943] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2762), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2764), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [321991] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2730), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2732), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2511), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2513), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322087] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2766), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2768), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322135] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2551), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2553), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322183] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(6980), 1,
      sym_keyword_is,
    ACTIONS(6982), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_PLUS,
    ACTIONS(6988), 1,
      anon_sym_DASH,
    ACTIONS(6990), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_CARET,
    ACTIONS(7026), 1,
      sym_keyword_in,
    ACTIONS(7028), 1,
      sym_keyword_and,
    ACTIONS(7030), 1,
      sym_keyword_or,
    ACTIONS(7032), 1,
      sym_keyword_not,
    ACTIONS(7034), 1,
      sym_keyword_between,
    ACTIONS(7038), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7042), 1,
      sym_op_other,
    STATE(10991), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6984), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7040), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1093), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1092), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(7036), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [322271] = 6,
    ACTIONS(8679), 1,
      sym_keyword_unsigned,
    ACTIONS(8681), 1,
      sym_keyword_zerofill,
    ACTIONS(8683), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322325] = 7,
    ACTIONS(8685), 1,
      sym_keyword_unsigned,
    ACTIONS(8687), 1,
      sym_keyword_zerofill,
    ACTIONS(8689), 1,
      sym_keyword_precision,
    ACTIONS(8691), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322381] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2738), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2740), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322429] = 7,
    ACTIONS(8693), 1,
      sym_keyword_array,
    STATE(5066), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5583), 1,
      sym__array_size_definition,
    STATE(5618), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2772), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322485] = 6,
    ACTIONS(8651), 1,
      sym_keyword_unsigned,
    ACTIONS(8653), 1,
      sym_keyword_zerofill,
    ACTIONS(8657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322539] = 7,
    ACTIONS(8693), 1,
      sym_keyword_array,
    STATE(5066), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5579), 1,
      sym_array_size_definition,
    STATE(5583), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2800), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322595] = 4,
    ACTIONS(8695), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322645] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2535), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2537), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322693] = 6,
    ACTIONS(8697), 1,
      sym_keyword_unsigned,
    ACTIONS(8699), 1,
      sym_keyword_zerofill,
    ACTIONS(8701), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322747] = 7,
    ACTIONS(8703), 1,
      sym_keyword_array,
    STATE(4941), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5534), 1,
      sym_array_size_definition,
    STATE(5535), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322803] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2750), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2752), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [322899] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2754), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2756), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [322947] = 6,
    ACTIONS(8705), 1,
      sym_keyword_unsigned,
    ACTIONS(8707), 1,
      sym_keyword_zerofill,
    ACTIONS(8709), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2567), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2569), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323049] = 7,
    ACTIONS(8703), 1,
      sym_keyword_array,
    STATE(4941), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5535), 1,
      sym__array_size_definition,
    STATE(5545), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [323105] = 6,
    ACTIONS(8711), 1,
      sym_keyword_unsigned,
    ACTIONS(8713), 1,
      sym_keyword_zerofill,
    ACTIONS(8715), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [323159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2746), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2748), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2722), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2724), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323255] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2563), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2565), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323303] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [323351] = 6,
    ACTIONS(8643), 1,
      sym_keyword_unsigned,
    ACTIONS(8645), 1,
      sym_keyword_zerofill,
    ACTIONS(8649), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323405] = 6,
    ACTIONS(8717), 1,
      sym_keyword_unsigned,
    ACTIONS(8719), 1,
      sym_keyword_zerofill,
    ACTIONS(8721), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1818), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1820), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323459] = 6,
    ACTIONS(8723), 1,
      sym_keyword_unsigned,
    ACTIONS(8725), 1,
      sym_keyword_zerofill,
    ACTIONS(8727), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1808), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1810), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323513] = 6,
    ACTIONS(8729), 1,
      sym_keyword_unsigned,
    ACTIONS(8731), 1,
      sym_keyword_zerofill,
    ACTIONS(8733), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1880), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1882), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323567] = 6,
    ACTIONS(8735), 1,
      sym_keyword_unsigned,
    ACTIONS(8737), 1,
      sym_keyword_zerofill,
    ACTIONS(8739), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1828), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1830), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323621] = 6,
    ACTIONS(8741), 1,
      sym_keyword_unsigned,
    ACTIONS(8743), 1,
      sym_keyword_zerofill,
    ACTIONS(8745), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [323675] = 6,
    ACTIONS(8747), 1,
      sym_keyword_unsigned,
    ACTIONS(8749), 1,
      sym_keyword_zerofill,
    ACTIONS(8751), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [323729] = 7,
    ACTIONS(8753), 1,
      sym_keyword_unsigned,
    ACTIONS(8755), 1,
      sym_keyword_zerofill,
    ACTIONS(8757), 1,
      sym_keyword_precision,
    ACTIONS(8759), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323785] = 6,
    ACTIONS(8761), 1,
      sym_keyword_unsigned,
    ACTIONS(8763), 1,
      sym_keyword_zerofill,
    ACTIONS(8765), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1862), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1864), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323839] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2758), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2760), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2531), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2533), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323935] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2742), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2744), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [323983] = 6,
    ACTIONS(8767), 1,
      sym_keyword_unsigned,
    ACTIONS(8769), 1,
      sym_keyword_zerofill,
    ACTIONS(8771), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [324037] = 6,
    ACTIONS(8775), 1,
      anon_sym_LPAREN,
    STATE(5562), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8773), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1772), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1774), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324091] = 6,
    ACTIONS(8777), 1,
      anon_sym_LPAREN,
    STATE(5565), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8773), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1794), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1796), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324145] = 7,
    ACTIONS(8779), 1,
      sym_keyword_with,
    ACTIONS(8781), 1,
      sym_keyword_without,
    ACTIONS(8783), 1,
      anon_sym_LPAREN,
    STATE(5736), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [324201] = 7,
    ACTIONS(8779), 1,
      sym_keyword_with,
    ACTIONS(8781), 1,
      sym_keyword_without,
    ACTIONS(8785), 1,
      anon_sym_LPAREN,
    STATE(5737), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [324257] = 5,
    STATE(5277), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8600), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1844), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324309] = 5,
    STATE(5275), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8600), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1848), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324361] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    STATE(5548), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [324417] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2726), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2728), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324465] = 6,
    ACTIONS(8787), 1,
      sym_keyword_unsigned,
    ACTIONS(8789), 1,
      sym_keyword_zerofill,
    ACTIONS(8791), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1890), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1892), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324519] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [324567] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1902), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324615] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1904), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1906), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1804), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1806), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324711] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1800), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1802), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324759] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2734), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2736), 23,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324807] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1872), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1874), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324855] = 6,
    ACTIONS(8793), 1,
      sym_keyword_unsigned,
    ACTIONS(8795), 1,
      sym_keyword_zerofill,
    ACTIONS(8797), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [324909] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1876), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1878), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [324957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 33,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325101] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3558), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3560), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325148] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325195] = 7,
    ACTIONS(8799), 1,
      sym_keyword_array,
    STATE(5109), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5966), 1,
      sym_array_size_definition,
    STATE(5969), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2800), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325250] = 7,
    ACTIONS(8799), 1,
      sym_keyword_array,
    STATE(5109), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5969), 1,
      sym__array_size_definition,
    STATE(6003), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2772), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325305] = 7,
    ACTIONS(8801), 1,
      sym_keyword_array,
    STATE(1014), 1,
      sym__array_size_definition,
    STATE(1016), 1,
      sym_array_size_definition,
    STATE(5249), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325360] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8508), 1,
      sym_keyword_and,
    ACTIONS(8510), 1,
      sym_keyword_between,
    ACTIONS(8567), 1,
      sym_keyword_or,
    ACTIONS(8569), 1,
      anon_sym_COLON_COLON,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(6849), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325447] = 5,
    ACTIONS(8803), 1,
      sym_keyword_precision,
    ACTIONS(8805), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325498] = 5,
    ACTIONS(8807), 1,
      sym_keyword_unsigned,
    ACTIONS(8809), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325549] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3506), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3508), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325596] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5290), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325647] = 5,
    ACTIONS(8813), 1,
      sym_keyword_unsigned,
    ACTIONS(8815), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325698] = 5,
    ACTIONS(8817), 1,
      sym_keyword_unsigned,
    ACTIONS(8819), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325749] = 5,
    ACTIONS(8821), 1,
      sym_keyword_unsigned,
    ACTIONS(8823), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325800] = 5,
    ACTIONS(8825), 1,
      sym_keyword_unsigned,
    ACTIONS(8827), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [325851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3582), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3584), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325898] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3606), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3608), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325945] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3610), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3612), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [325992] = 5,
    ACTIONS(8829), 1,
      sym_keyword_unsigned,
    ACTIONS(8831), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326043] = 5,
    ACTIONS(8833), 1,
      sym_keyword_unsigned,
    ACTIONS(8835), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3634), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3636), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326141] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3638), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3640), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326188] = 5,
    ACTIONS(8837), 1,
      sym_keyword_unsigned,
    ACTIONS(8839), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326239] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3642), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3644), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3618), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3620), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326333] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
    ACTIONS(6849), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
  [326420] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3622), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3624), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326467] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5316), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326518] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3630), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3632), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326565] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5319), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326616] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5321), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326667] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3578), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3580), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326714] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5322), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [326765] = 4,
    ACTIONS(8841), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326814] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3586), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3588), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326861] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3574), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3576), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326908] = 5,
    ACTIONS(8843), 1,
      sym_keyword_varying,
    ACTIONS(8845), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1948), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1950), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [326959] = 5,
    STATE(5578), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8773), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1844), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1846), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [327010] = 5,
    STATE(5572), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8773), 2,
      sym_keyword_with,
      sym_keyword_without,
    ACTIONS(1848), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1850), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [327061] = 6,
    ACTIONS(8779), 1,
      sym_keyword_with,
    ACTIONS(8781), 1,
      sym_keyword_without,
    STATE(5678), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327114] = 6,
    ACTIONS(8779), 1,
      sym_keyword_with,
    ACTIONS(8781), 1,
      sym_keyword_without,
    STATE(5679), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327167] = 23,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    STATE(6405), 1,
      sym_index_hint,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6919), 1,
      sym_where,
    STATE(7000), 1,
      sym_group_by,
    STATE(7238), 1,
      sym_window_clause,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6404), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [327254] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3614), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3616), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [327301] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5215), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327352] = 5,
    ACTIONS(8875), 1,
      sym_keyword_varying,
    ACTIONS(8877), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327403] = 4,
    ACTIONS(8879), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327452] = 7,
    ACTIONS(8881), 1,
      sym_keyword_array,
    STATE(5381), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5771), 1,
      sym__array_size_definition,
    STATE(5848), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327507] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5340), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327558] = 7,
    ACTIONS(8881), 1,
      sym_keyword_array,
    STATE(5381), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5771), 1,
      sym__array_size_definition,
    STATE(5822), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327613] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5342), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327664] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5337), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327715] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3460), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3462), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [327762] = 23,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    STATE(6350), 1,
      sym_index_hint,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6921), 1,
      sym_where,
    STATE(7027), 1,
      sym_group_by,
    STATE(7177), 1,
      sym_window_clause,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6351), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [327849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3646), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3648), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [327896] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5351), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [327947] = 23,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    STATE(4839), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6350), 1,
      sym_index_hint,
    STATE(6921), 1,
      sym_where,
    STATE(7027), 1,
      sym_group_by,
    STATE(7177), 1,
      sym_window_clause,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6351), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [328034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3594), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3596), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3494), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3496), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328128] = 6,
    ACTIONS(8885), 1,
      sym_keyword_unsigned,
    ACTIONS(8887), 1,
      sym_keyword_zerofill,
    ACTIONS(8889), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328181] = 6,
    ACTIONS(8753), 1,
      sym_keyword_unsigned,
    ACTIONS(8755), 1,
      sym_keyword_zerofill,
    ACTIONS(8759), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328234] = 6,
    ACTIONS(8891), 1,
      sym_keyword_unsigned,
    ACTIONS(8893), 1,
      sym_keyword_zerofill,
    ACTIONS(8895), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1818), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1820), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328287] = 6,
    ACTIONS(8897), 1,
      sym_keyword_unsigned,
    ACTIONS(8899), 1,
      sym_keyword_zerofill,
    ACTIONS(8901), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1808), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1810), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328340] = 6,
    ACTIONS(8903), 1,
      sym_keyword_unsigned,
    ACTIONS(8905), 1,
      sym_keyword_zerofill,
    ACTIONS(8907), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1880), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1882), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328393] = 6,
    ACTIONS(8909), 1,
      sym_keyword_unsigned,
    ACTIONS(8911), 1,
      sym_keyword_zerofill,
    ACTIONS(8913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1828), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1830), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328446] = 6,
    ACTIONS(8915), 1,
      sym_keyword_unsigned,
    ACTIONS(8917), 1,
      sym_keyword_zerofill,
    ACTIONS(8919), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1862), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1864), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328499] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328546] = 5,
    ACTIONS(8921), 1,
      sym_keyword_precision,
    ACTIONS(8923), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328597] = 6,
    ACTIONS(8925), 1,
      sym_keyword_unsigned,
    ACTIONS(8927), 1,
      sym_keyword_zerofill,
    ACTIONS(8929), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1890), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1892), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328650] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1902), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328697] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [328746] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1904), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1906), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1804), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1806), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328840] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1800), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1802), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1876), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1878), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328934] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1872), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1874), 21,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [328981] = 7,
    ACTIONS(8801), 1,
      sym_keyword_array,
    STATE(956), 1,
      sym_array_size_definition,
    STATE(1014), 1,
      sym__array_size_definition,
    STATE(5249), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329036] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3518), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3520), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329083] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5382), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329134] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5384), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329185] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5389), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329236] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5393), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329287] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3524), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329334] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5396), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3572), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329432] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5101), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329483] = 6,
    ACTIONS(8931), 1,
      sym_keyword_unsigned,
    ACTIONS(8933), 1,
      sym_keyword_zerofill,
    ACTIONS(8935), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329536] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    STATE(5796), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2426), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329638] = 6,
    ACTIONS(8685), 1,
      sym_keyword_unsigned,
    ACTIONS(8687), 1,
      sym_keyword_zerofill,
    ACTIONS(8691), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [329691] = 5,
    ACTIONS(8937), 1,
      sym_keyword_unsigned,
    ACTIONS(8939), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329742] = 5,
    ACTIONS(8941), 1,
      sym_keyword_unsigned,
    ACTIONS(8943), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1966), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1968), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329793] = 5,
    ACTIONS(8945), 1,
      sym_keyword_unsigned,
    ACTIONS(8947), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1978), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1980), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329844] = 5,
    ACTIONS(8949), 1,
      sym_keyword_unsigned,
    ACTIONS(8951), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1986), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1988), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329895] = 5,
    ACTIONS(8953), 1,
      sym_keyword_unsigned,
    ACTIONS(8955), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1940), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1942), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329946] = 5,
    ACTIONS(8957), 1,
      sym_keyword_unsigned,
    ACTIONS(8959), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1918), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [329997] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3502), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3504), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330044] = 6,
    ACTIONS(8961), 1,
      sym_keyword_unsigned,
    ACTIONS(8963), 1,
      sym_keyword_zerofill,
    ACTIONS(8965), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330097] = 6,
    ACTIONS(8967), 1,
      sym_keyword_unsigned,
    ACTIONS(8969), 1,
      sym_keyword_zerofill,
    ACTIONS(8971), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330150] = 6,
    ACTIONS(8973), 1,
      sym_keyword_unsigned,
    ACTIONS(8975), 1,
      sym_keyword_zerofill,
    ACTIONS(8977), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330203] = 6,
    ACTIONS(8979), 1,
      sym_keyword_unsigned,
    ACTIONS(8981), 1,
      sym_keyword_zerofill,
    ACTIONS(8983), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330256] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5383), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3602), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3604), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330354] = 6,
    ACTIONS(8985), 1,
      sym_keyword_unsigned,
    ACTIONS(8987), 1,
      sym_keyword_zerofill,
    ACTIONS(8989), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330407] = 6,
    ACTIONS(8991), 1,
      sym_keyword_unsigned,
    ACTIONS(8993), 1,
      sym_keyword_zerofill,
    ACTIONS(8995), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330460] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5406), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330511] = 5,
    ACTIONS(8811), 1,
      sym_keyword_filter,
    STATE(5413), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330562] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330609] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3510), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3512), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330656] = 5,
    ACTIONS(8997), 1,
      sym_keyword_unsigned,
    ACTIONS(8999), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1932), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1934), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330707] = 5,
    ACTIONS(9001), 1,
      sym_keyword_unsigned,
    ACTIONS(9003), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1910), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3598), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3600), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330805] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330852] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330899] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3590), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3592), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [330946] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [330993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331040] = 23,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    STATE(4850), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6401), 1,
      sym_index_hint,
    STATE(6918), 1,
      sym_where,
    STATE(7051), 1,
      sym_group_by,
    STATE(7212), 1,
      sym_window_clause,
    STATE(7293), 1,
      sym_order_by,
    STATE(7556), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6332), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(9005), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [331127] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 32,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [331174] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3498), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3500), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [331221] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2794), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2796), 22,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [331268] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9009), 1,
      sym_keyword_else,
    ACTIONS(9011), 1,
      sym_keyword_end,
    STATE(10086), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331360] = 4,
    ACTIONS(9013), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2171), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2173), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [331408] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9015), 1,
      sym_keyword_else,
    ACTIONS(9017), 1,
      sym_keyword_end,
    STATE(9539), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331500] = 4,
    ACTIONS(9019), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [331548] = 4,
    ACTIONS(9021), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [331596] = 4,
    ACTIONS(9023), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [331644] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9025), 1,
      sym_keyword_else,
    ACTIONS(9027), 1,
      sym_keyword_end,
    STATE(10095), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331736] = 4,
    ACTIONS(9029), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331784] = 5,
    ACTIONS(9031), 1,
      sym_keyword_varying,
    ACTIONS(9033), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331834] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9035), 1,
      sym_keyword_else,
    ACTIONS(9037), 1,
      sym_keyword_end,
    STATE(9459), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [331926] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9039), 1,
      sym_keyword_else,
    ACTIONS(9041), 1,
      sym_keyword_end,
    STATE(9463), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332018] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9043), 1,
      sym_keyword_else,
    ACTIONS(9045), 1,
      sym_keyword_end,
    STATE(9474), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332110] = 4,
    ACTIONS(9047), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332158] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9049), 1,
      sym_keyword_else,
    ACTIONS(9051), 1,
      sym_keyword_end,
    STATE(10170), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332250] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9053), 1,
      sym_keyword_else,
    ACTIONS(9055), 1,
      sym_keyword_end,
    STATE(10164), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332342] = 4,
    ACTIONS(9057), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332390] = 4,
    ACTIONS(9059), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332438] = 4,
    ACTIONS(9061), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332486] = 4,
    ACTIONS(9063), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332534] = 4,
    ACTIONS(9065), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332582] = 5,
    ACTIONS(9067), 1,
      sym_keyword_precision,
    ACTIONS(9069), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332632] = 6,
    ACTIONS(9071), 1,
      anon_sym_LBRACK,
    STATE(4939), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5583), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2044), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2046), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [332684] = 23,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    STATE(6420), 1,
      sym_index_hint,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6955), 1,
      sym_where,
    STATE(7085), 1,
      sym_group_by,
    STATE(7308), 1,
      sym_window_clause,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6419), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [332770] = 5,
    STATE(5064), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5535), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332820] = 23,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    STATE(6418), 1,
      sym_index_hint,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6952), 1,
      sym_where,
    STATE(7146), 1,
      sym_group_by,
    STATE(7288), 1,
      sym_window_clause,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6417), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [332906] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9100), 1,
      sym_keyword_else,
    ACTIONS(9102), 1,
      sym_keyword_end,
    STATE(10208), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [332998] = 5,
    ACTIONS(9104), 1,
      sym_keyword_unsigned,
    ACTIONS(9106), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333048] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9108), 1,
      sym_keyword_else,
    ACTIONS(9110), 1,
      sym_keyword_end,
    STATE(10195), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333140] = 5,
    ACTIONS(9112), 1,
      sym_keyword_unsigned,
    ACTIONS(9114), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333190] = 5,
    ACTIONS(9116), 1,
      sym_keyword_unsigned,
    ACTIONS(9118), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333240] = 5,
    ACTIONS(9120), 1,
      sym_keyword_unsigned,
    ACTIONS(9122), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333290] = 5,
    ACTIONS(9124), 1,
      sym_keyword_unsigned,
    ACTIONS(9126), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333340] = 4,
    ACTIONS(9128), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [333388] = 23,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    STATE(4942), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6420), 1,
      sym_index_hint,
    STATE(6955), 1,
      sym_where,
    STATE(7085), 1,
      sym_group_by,
    STATE(7308), 1,
      sym_window_clause,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6419), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [333474] = 4,
    ACTIONS(9130), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [333522] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9132), 1,
      sym_keyword_else,
    ACTIONS(9134), 1,
      sym_keyword_end,
    STATE(9475), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333614] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9136), 1,
      sym_keyword_else,
    ACTIONS(9138), 1,
      sym_keyword_end,
    STATE(9472), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333706] = 4,
    ACTIONS(9140), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [333754] = 4,
    ACTIONS(9142), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [333802] = 4,
    ACTIONS(9144), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [333850] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9146), 1,
      sym_keyword_else,
    ACTIONS(9148), 1,
      sym_keyword_end,
    STATE(10104), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [333942] = 4,
    ACTIONS(8707), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [333990] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9150), 1,
      sym_keyword_else,
    ACTIONS(9152), 1,
      sym_keyword_end,
    STATE(9476), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334082] = 5,
    ACTIONS(9154), 1,
      sym_keyword_unsigned,
    ACTIONS(9156), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334132] = 5,
    ACTIONS(9158), 1,
      sym_keyword_unsigned,
    ACTIONS(9160), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334182] = 5,
    ACTIONS(9162), 1,
      sym_keyword_unsigned,
    ACTIONS(9164), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334232] = 5,
    ACTIONS(9166), 1,
      aux_sym__single_quote_string_token2,
    STATE(4999), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334282] = 4,
    ACTIONS(9168), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334330] = 5,
    ACTIONS(9170), 1,
      sym_keyword_varying,
    ACTIONS(9172), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1948), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1950), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334380] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5495), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334430] = 4,
    ACTIONS(9176), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334478] = 4,
    ACTIONS(9178), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2137), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2139), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334526] = 4,
    ACTIONS(8923), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334574] = 4,
    ACTIONS(9180), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334622] = 4,
    ACTIONS(9182), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334670] = 4,
    ACTIONS(9184), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334718] = 4,
    ACTIONS(9186), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334766] = 4,
    ACTIONS(9188), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334814] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2022), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2024), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [334860] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9190), 1,
      sym_keyword_else,
    ACTIONS(9192), 1,
      sym_keyword_end,
    STATE(10077), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [334952] = 4,
    ACTIONS(9194), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2057), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2059), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335000] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9196), 1,
      sym_keyword_else,
    ACTIONS(9198), 1,
      sym_keyword_end,
    STATE(10018), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335092] = 4,
    ACTIONS(9200), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2071), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2073), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335140] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9202), 1,
      sym_keyword_else,
    ACTIONS(9204), 1,
      sym_keyword_end,
    STATE(10011), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335232] = 4,
    ACTIONS(9206), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1994), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1996), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335280] = 5,
    ACTIONS(9208), 1,
      sym_keyword_precision,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335330] = 5,
    ACTIONS(9212), 1,
      aux_sym__single_quote_string_token2,
    STATE(4964), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335380] = 4,
    ACTIONS(9214), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335428] = 4,
    ACTIONS(9216), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335476] = 5,
    ACTIONS(9218), 1,
      sym_keyword_unsigned,
    ACTIONS(9220), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1978), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1980), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335526] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9222), 1,
      sym_keyword_else,
    ACTIONS(9224), 1,
      sym_keyword_end,
    STATE(9974), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335618] = 5,
    ACTIONS(9226), 1,
      sym_keyword_unsigned,
    ACTIONS(9228), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1986), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1988), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335668] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9230), 1,
      sym_keyword_else,
    ACTIONS(9232), 1,
      sym_keyword_end,
    STATE(9956), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335760] = 5,
    ACTIONS(9234), 1,
      sym_keyword_unsigned,
    ACTIONS(9236), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1940), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1942), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335810] = 5,
    ACTIONS(9238), 1,
      sym_keyword_unsigned,
    ACTIONS(9240), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1918), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335860] = 5,
    ACTIONS(9242), 1,
      sym_keyword_unsigned,
    ACTIONS(9244), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1966), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1968), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [335910] = 5,
    ACTIONS(9166), 1,
      aux_sym__single_quote_string_token2,
    STATE(4999), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [335960] = 4,
    ACTIONS(9246), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2161), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2163), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336054] = 5,
    ACTIONS(9248), 1,
      sym_keyword_unsigned,
    ACTIONS(9250), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1932), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1934), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336104] = 5,
    ACTIONS(9252), 1,
      sym_keyword_unsigned,
    ACTIONS(9254), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1910), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336154] = 5,
    ACTIONS(9256), 1,
      aux_sym__single_quote_string_token2,
    STATE(4999), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336204] = 5,
    ACTIONS(9259), 1,
      sym_keyword_unsigned,
    ACTIONS(9261), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336254] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5491), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336304] = 4,
    ACTIONS(9263), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336352] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2167), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2169), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336398] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9265), 1,
      sym_keyword_else,
    ACTIONS(9267), 1,
      sym_keyword_end,
    STATE(10194), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336490] = 4,
    ACTIONS(9269), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336538] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336630] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    ACTIONS(6849), 4,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336716] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9271), 1,
      sym_keyword_else,
    ACTIONS(9273), 1,
      sym_keyword_end,
    STATE(9912), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336808] = 4,
    ACTIONS(9275), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2131), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2133), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [336856] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9277), 1,
      sym_keyword_else,
    ACTIONS(9279), 1,
      sym_keyword_end,
    STATE(9895), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [336948] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9281), 1,
      sym_keyword_else,
    ACTIONS(9283), 1,
      sym_keyword_end,
    STATE(9844), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337040] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337088] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9285), 1,
      sym_keyword_else,
    ACTIONS(9287), 1,
      sym_keyword_end,
    STATE(9822), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337180] = 4,
    ACTIONS(9289), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337228] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9291), 1,
      sym_keyword_else,
    ACTIONS(9293), 1,
      sym_keyword_end,
    STATE(9915), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337320] = 4,
    ACTIONS(9295), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2125), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2127), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [337368] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1376), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1374), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      aux_sym__single_quote_string_token1,
  [337414] = 4,
    ACTIONS(9297), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2091), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2093), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [337462] = 4,
    ACTIONS(9299), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337510] = 4,
    ACTIONS(9301), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337558] = 4,
    ACTIONS(9303), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2083), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2085), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [337606] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9305), 1,
      sym_keyword_else,
    ACTIONS(9307), 1,
      sym_keyword_end,
    STATE(9800), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337698] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9309), 1,
      sym_keyword_else,
    ACTIONS(9311), 1,
      sym_keyword_end,
    STATE(9791), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337790] = 4,
    ACTIONS(9313), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [337838] = 4,
    ACTIONS(9315), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337886] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5531), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337936] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5530), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [337986] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9317), 1,
      sym_keyword_else,
    ACTIONS(9319), 1,
      sym_keyword_end,
    STATE(9709), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338078] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9321), 1,
      sym_keyword_else,
    ACTIONS(9323), 1,
      sym_keyword_end,
    STATE(10065), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338170] = 7,
    ACTIONS(9325), 1,
      sym_keyword_with,
    ACTIONS(9327), 1,
      sym_keyword_without,
    ACTIONS(9329), 1,
      anon_sym_LPAREN,
    STATE(6174), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1772), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338224] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5529), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338274] = 7,
    ACTIONS(9325), 1,
      sym_keyword_with,
    ACTIONS(9327), 1,
      sym_keyword_without,
    ACTIONS(9331), 1,
      anon_sym_LPAREN,
    STATE(6175), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1794), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338328] = 7,
    ACTIONS(9333), 1,
      sym_keyword_unsigned,
    ACTIONS(9335), 1,
      sym_keyword_zerofill,
    ACTIONS(9337), 1,
      sym_keyword_precision,
    ACTIONS(9339), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338382] = 4,
    ACTIONS(9341), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338430] = 5,
    ACTIONS(9343), 1,
      aux_sym__single_quote_string_token2,
    STATE(4994), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338480] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9345), 1,
      sym_keyword_else,
    ACTIONS(9347), 1,
      sym_keyword_end,
    STATE(9522), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338572] = 4,
    ACTIONS(9349), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338620] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5526), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338670] = 4,
    ACTIONS(9351), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338718] = 4,
    ACTIONS(9353), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338766] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9355), 1,
      sym_keyword_else,
    ACTIONS(9357), 1,
      sym_keyword_end,
    STATE(9698), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338858] = 4,
    ACTIONS(9359), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338906] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9361), 1,
      sym_keyword_else,
    ACTIONS(9363), 1,
      sym_keyword_end,
    STATE(9527), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [338998] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5500), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339048] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9365), 1,
      sym_keyword_else,
    ACTIONS(9367), 1,
      sym_keyword_end,
    STATE(9595), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339140] = 23,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    STATE(4940), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6424), 1,
      sym_index_hint,
    STATE(6960), 1,
      sym_where,
    STATE(7100), 1,
      sym_group_by,
    STATE(7357), 1,
      sym_window_clause,
    STATE(7483), 1,
      sym_order_by,
    STATE(7638), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6423), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(9005), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [339226] = 4,
    ACTIONS(9369), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [339274] = 4,
    ACTIONS(9371), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339322] = 4,
    ACTIONS(9373), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339370] = 4,
    ACTIONS(9375), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339418] = 4,
    ACTIONS(9377), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339466] = 4,
    ACTIONS(9379), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339514] = 4,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339562] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5521), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339612] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5520), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339662] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5515), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339712] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9383), 1,
      sym_keyword_else,
    ACTIONS(9385), 1,
      sym_keyword_end,
    STATE(9605), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339804] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5513), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339854] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5512), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339904] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5480), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [339954] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5502), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340004] = 4,
    ACTIONS(9387), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340052] = 6,
    ACTIONS(9389), 1,
      anon_sym_LBRACK,
    STATE(5064), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5535), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 28,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340104] = 4,
    ACTIONS(9392), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340152] = 5,
    STATE(4939), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5583), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3230), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [340202] = 4,
    ACTIONS(9394), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340250] = 4,
    ACTIONS(9396), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340298] = 7,
    ACTIONS(9398), 1,
      sym_keyword_with,
    ACTIONS(9400), 1,
      sym_keyword_without,
    ACTIONS(9402), 1,
      anon_sym_LPAREN,
    STATE(6314), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1774), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1772), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [340352] = 7,
    ACTIONS(9398), 1,
      sym_keyword_with,
    ACTIONS(9400), 1,
      sym_keyword_without,
    ACTIONS(9404), 1,
      anon_sym_LPAREN,
    STATE(6315), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1796), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1794), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [340406] = 4,
    ACTIONS(9406), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340454] = 4,
    ACTIONS(9408), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340502] = 4,
    ACTIONS(9410), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340550] = 4,
    ACTIONS(8681), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340598] = 4,
    ACTIONS(9412), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340646] = 7,
    ACTIONS(9414), 1,
      sym_keyword_unsigned,
    ACTIONS(9416), 1,
      sym_keyword_zerofill,
    ACTIONS(9418), 1,
      sym_keyword_precision,
    ACTIONS(9420), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1782), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [340700] = 4,
    ACTIONS(9422), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340748] = 4,
    ACTIONS(8805), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340796] = 4,
    ACTIONS(9424), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340844] = 4,
    ACTIONS(9426), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340892] = 4,
    ACTIONS(9428), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340940] = 4,
    ACTIONS(9430), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [340988] = 4,
    ACTIONS(9432), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341036] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5504), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341086] = 4,
    ACTIONS(9434), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341134] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 31,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341180] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9436), 1,
      sym_keyword_else,
    ACTIONS(9438), 1,
      sym_keyword_end,
    STATE(9699), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341272] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5506), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341322] = 26,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9440), 1,
      sym_keyword_else,
    ACTIONS(9442), 1,
      sym_keyword_end,
    STATE(9672), 1,
      aux_sym_case_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341414] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5479), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341464] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5487), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341514] = 5,
    ACTIONS(9174), 1,
      sym_keyword_filter,
    STATE(5481), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341564] = 4,
    ACTIONS(9444), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341611] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2167), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2169), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [341656] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9446), 1,
      anon_sym_RPAREN,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    STATE(10861), 1,
      sym_not_in,
    STATE(10908), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341745] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9450), 1,
      anon_sym_RBRACK,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    STATE(10861), 1,
      sym_not_in,
    STATE(11014), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341834] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9454), 1,
      anon_sym_RPAREN,
    STATE(10809), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [341923] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9456), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342012] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9458), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    STATE(10915), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342101] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9460), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342190] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342235] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9462), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(10908), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342324] = 4,
    ACTIONS(9464), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3364), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3366), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [342371] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9466), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(10984), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342460] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9468), 1,
      anon_sym_RPAREN,
    STATE(10809), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342549] = 8,
    ACTIONS(9470), 1,
      sym_keyword_array,
    ACTIONS(9472), 1,
      anon_sym_LBRACK,
    STATE(5818), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6336), 1,
      sym__array_size_definition,
    STATE(6421), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2798), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [342604] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9474), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    STATE(10962), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342693] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9476), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(10984), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342782] = 5,
    STATE(5419), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5969), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3230), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [342831] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9478), 1,
      anon_sym_RBRACK,
    STATE(10816), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [342920] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9480), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11007), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343009] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9482), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343098] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9484), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343187] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9486), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343276] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9488), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343365] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9490), 1,
      anon_sym_RPAREN,
    STATE(10710), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343454] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9492), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343543] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9494), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343632] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(7902), 1,
      sym_keyword_as,
    ACTIONS(9500), 1,
      anon_sym_LPAREN,
    STATE(6377), 1,
      sym_identifier,
    STATE(6427), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(9496), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(9498), 25,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [343689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1872), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [343734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1876), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [343779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1800), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [343824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1804), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [343869] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1904), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [343914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [343959] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344004] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9502), 1,
      anon_sym_RPAREN,
    STATE(10710), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344093] = 5,
    ACTIONS(9504), 1,
      aux_sym__single_quote_string_token2,
    STATE(5352), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344187] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9506), 1,
      anon_sym_RBRACK,
    STATE(10717), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344276] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1900), 34,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [344321] = 6,
    ACTIONS(9508), 1,
      sym_keyword_unsigned,
    ACTIONS(9510), 1,
      sym_keyword_zerofill,
    ACTIONS(9512), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1890), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [344372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344417] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2257), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2259), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [344462] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2245), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2247), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [344507] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344597] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2241), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2243), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [344687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344732] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9514), 1,
      anon_sym_RPAREN,
    STATE(10597), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344821] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9516), 1,
      anon_sym_RPAREN,
    STATE(10597), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [344955] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9518), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11007), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345089] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9520), 1,
      anon_sym_RBRACK,
    STATE(10604), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345223] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9522), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    STATE(11113), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345357] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9524), 1,
      anon_sym_RPAREN,
    STATE(10484), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345446] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9480), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [345623] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9528), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345712] = 6,
    ACTIONS(9530), 1,
      sym_keyword_unsigned,
    ACTIONS(9532), 1,
      sym_keyword_zerofill,
    ACTIONS(9534), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1862), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [345763] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9536), 1,
      anon_sym_RPAREN,
    STATE(10484), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345852] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9538), 1,
      anon_sym_RBRACK,
    STATE(10491), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [345941] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9540), 1,
      anon_sym_RPAREN,
    STATE(10371), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346030] = 6,
    ACTIONS(9542), 1,
      sym_keyword_unsigned,
    ACTIONS(9544), 1,
      sym_keyword_zerofill,
    ACTIONS(9546), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1828), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [346081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346126] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346171] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9548), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346260] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346305] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9550), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11106), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346439] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346484] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346574] = 4,
    STATE(5628), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3426), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [346621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [346666] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9552), 1,
      anon_sym_RPAREN,
    STATE(10371), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346755] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [346800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2185), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2187), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [346845] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2189), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2191), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [346890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [346935] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [346980] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347025] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347070] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347115] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347205] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347295] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347430] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347475] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9554), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347564] = 6,
    ACTIONS(9556), 1,
      sym_keyword_unsigned,
    ACTIONS(9558), 1,
      sym_keyword_zerofill,
    ACTIONS(9560), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1880), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [347615] = 6,
    ACTIONS(9562), 1,
      sym_keyword_unsigned,
    ACTIONS(9564), 1,
      sym_keyword_zerofill,
    ACTIONS(9566), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1808), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [347666] = 6,
    ACTIONS(9568), 1,
      sym_keyword_unsigned,
    ACTIONS(9570), 1,
      sym_keyword_zerofill,
    ACTIONS(9572), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1818), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [347717] = 6,
    ACTIONS(9414), 1,
      sym_keyword_unsigned,
    ACTIONS(9416), 1,
      sym_keyword_zerofill,
    ACTIONS(9420), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1782), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [347768] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [347813] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347858] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9574), 1,
      anon_sym_RBRACK,
    STATE(10378), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347947] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [347992] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9576), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [348126] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9578), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8680), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348213] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9580), 1,
      anon_sym_RPAREN,
    STATE(10351), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [348347] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [348392] = 8,
    ACTIONS(9470), 1,
      sym_keyword_array,
    ACTIONS(9472), 1,
      anon_sym_LBRACK,
    STATE(5818), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6336), 1,
      sym__array_size_definition,
    STATE(6416), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2770), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [348447] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2273), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2275), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [348492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348537] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348582] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348627] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9582), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11058), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2301), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2303), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [348761] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9584), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [348940] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [348985] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349030] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349075] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9578), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8679), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349162] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349252] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2305), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2307), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [349342] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349387] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2309), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2311), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [349432] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349477] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9586), 1,
      anon_sym_RPAREN,
    STATE(10805), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349611] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9588), 1,
      anon_sym_RBRACK,
    STATE(10802), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349745] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2313), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2315), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [349790] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349835] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9578), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8678), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [349922] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2317), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2319), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [349967] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2321), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2323), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350012] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2353), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2355), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350057] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350102] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2345), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2347), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350147] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2329), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2331), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350192] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2289), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2291), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350237] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2285), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2287), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2277), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2279), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350327] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2181), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2183), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350372] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9590), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8865), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2269), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2271), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350504] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9590), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8867), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2213), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2215), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350636] = 4,
    ACTIONS(9592), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350683] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2237), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2239), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [350728] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350818] = 5,
    STATE(752), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(1014), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350867] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9594), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [350956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2249), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2251), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351046] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351136] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351181] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351226] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2357), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2359), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2349), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2351), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351316] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9596), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351405] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351450] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351495] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2201), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2203), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351540] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2205), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2207), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2209), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2211), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351675] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9590), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8908), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2229), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2231), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351807] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351852] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9590), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8911), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [351939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2265), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2267), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [351984] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2281), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2283), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352119] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352164] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2293), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2295), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352254] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2297), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2299), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352299] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352344] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352389] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352434] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9598), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11106), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352523] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352568] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [352658] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1874), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1872), 30,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352703] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1878), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1876), 30,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352748] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1802), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1800), 30,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1806), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1804), 30,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352838] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1906), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1904), 30,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [352928] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9600), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    STATE(11210), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353017] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1902), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1900), 30,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353062] = 6,
    ACTIONS(9602), 1,
      sym_keyword_unsigned,
    ACTIONS(9604), 1,
      sym_keyword_zerofill,
    ACTIONS(9606), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1892), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1890), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353113] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2261), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2263), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353158] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2253), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2255), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353203] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9608), 1,
      anon_sym_RPAREN,
    STATE(10257), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353292] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2233), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2235), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353337] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2221), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2223), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353382] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2217), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2219), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353427] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9610), 1,
      anon_sym_RPAREN,
    STATE(10805), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353516] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2197), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2199), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353561] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9590), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8917), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353648] = 6,
    ACTIONS(9612), 1,
      sym_keyword_unsigned,
    ACTIONS(9614), 1,
      sym_keyword_zerofill,
    ACTIONS(9616), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1864), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1862), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353699] = 6,
    ACTIONS(9618), 1,
      sym_keyword_unsigned,
    ACTIONS(9620), 1,
      sym_keyword_zerofill,
    ACTIONS(9622), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1830), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1828), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353750] = 6,
    ACTIONS(9624), 1,
      sym_keyword_unsigned,
    ACTIONS(9626), 1,
      sym_keyword_zerofill,
    ACTIONS(9628), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1882), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1880), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353801] = 6,
    ACTIONS(9630), 1,
      sym_keyword_unsigned,
    ACTIONS(9632), 1,
      sym_keyword_zerofill,
    ACTIONS(9634), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1810), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1808), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353852] = 6,
    ACTIONS(9636), 1,
      sym_keyword_unsigned,
    ACTIONS(9638), 1,
      sym_keyword_zerofill,
    ACTIONS(9640), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1820), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1818), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353903] = 6,
    ACTIONS(9333), 1,
      sym_keyword_unsigned,
    ACTIONS(9335), 1,
      sym_keyword_zerofill,
    ACTIONS(9339), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [353954] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2193), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2195), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [353999] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2225), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2227), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354089] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9590), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8986), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354221] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2341), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2343), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354311] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354356] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2337), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2339), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354401] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9642), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354490] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354535] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9644), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11203), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [354759] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9697), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354846] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9614), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [354933] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9613), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355020] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9604), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355107] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2333), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2335), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [355152] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2325), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2327), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [355197] = 5,
    ACTIONS(9646), 1,
      aux_sym__single_quote_string_token2,
    STATE(5128), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355246] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9648), 1,
      anon_sym_RBRACK,
    STATE(10246), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355335] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2177), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2179), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [355380] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9650), 1,
      anon_sym_RBRACK,
    STATE(10265), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355469] = 4,
    ACTIONS(9652), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355516] = 4,
    ACTIONS(9654), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355563] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9656), 1,
      anon_sym_RPAREN,
    STATE(10257), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355652] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355697] = 5,
    ACTIONS(9504), 1,
      aux_sym__single_quote_string_token2,
    STATE(5352), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1359), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1357), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355746] = 4,
    ACTIONS(9658), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355838] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355928] = 6,
    ACTIONS(9660), 1,
      sym_keyword_unsigned,
    ACTIONS(9662), 1,
      sym_keyword_zerofill,
    ACTIONS(9664), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [355979] = 4,
    ACTIONS(9666), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356026] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356071] = 4,
    ACTIONS(9668), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356118] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9670), 1,
      anon_sym_RPAREN,
    STATE(10659), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356207] = 4,
    ACTIONS(9672), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356254] = 6,
    ACTIONS(9674), 1,
      sym_keyword_unsigned,
    ACTIONS(9676), 1,
      sym_keyword_zerofill,
    ACTIONS(9678), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1852), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [356305] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(6438), 1,
      sym_index_hint,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(7013), 1,
      sym_where,
    STATE(7214), 1,
      sym_group_by,
    STATE(7338), 1,
      sym_order_by,
    STATE(7453), 1,
      sym_window_clause,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6439), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [356390] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356435] = 5,
    ACTIONS(9696), 1,
      aux_sym__single_quote_string_token2,
    STATE(5352), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1365), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1363), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356484] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9699), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11106), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356573] = 4,
    ACTIONS(9701), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356620] = 4,
    ACTIONS(9703), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356667] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9705), 1,
      anon_sym_RBRACK,
    STATE(10538), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356756] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9707), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11058), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356845] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9709), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [356934] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9711), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1376), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [357064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357109] = 4,
    ACTIONS(9713), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357156] = 4,
    ACTIONS(9715), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357203] = 4,
    ACTIONS(9717), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 20,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [357250] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8508), 1,
      sym_keyword_and,
    ACTIONS(8510), 1,
      sym_keyword_between,
    ACTIONS(8567), 1,
      sym_keyword_or,
    ACTIONS(8569), 1,
      anon_sym_COLON_COLON,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9719), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357335] = 4,
    ACTIONS(9721), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357382] = 4,
    ACTIONS(9723), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357429] = 4,
    ACTIONS(9725), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357476] = 4,
    ACTIONS(9727), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357523] = 4,
    ACTIONS(9069), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357570] = 4,
    ACTIONS(9729), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357617] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(6446), 1,
      sym_index_hint,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(7014), 1,
      sym_where,
    STATE(7210), 1,
      sym_group_by,
    STATE(7391), 1,
      sym_order_by,
    STATE(7451), 1,
      sym_window_clause,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6442), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [357702] = 4,
    ACTIONS(9731), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357749] = 4,
    ACTIONS(9733), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357796] = 4,
    ACTIONS(9735), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357843] = 4,
    ACTIONS(8933), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [357890] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(5350), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6446), 1,
      sym_index_hint,
    STATE(7014), 1,
      sym_where,
    STATE(7210), 1,
      sym_group_by,
    STATE(7391), 1,
      sym_order_by,
    STATE(7451), 1,
      sym_window_clause,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6442), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [357975] = 4,
    ACTIONS(9737), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358022] = 4,
    ACTIONS(9739), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358069] = 4,
    ACTIONS(9741), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358116] = 5,
    STATE(5388), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5771), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358255] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358300] = 4,
    STATE(5566), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358347] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9700), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358434] = 4,
    ACTIONS(9743), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358481] = 6,
    ACTIONS(9745), 1,
      anon_sym_LBRACK,
    STATE(5388), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5771), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358577] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358622] = 4,
    ACTIONS(9748), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358669] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9750), 1,
      anon_sym_RPAREN,
    STATE(10351), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358803] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9752), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11171), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358892] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_RBRACK,
    STATE(10343), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [358981] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359026] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9756), 1,
      anon_sym_RPAREN,
    STATE(10351), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359115] = 5,
    ACTIONS(9758), 1,
      aux_sym__single_quote_string_token2,
    STATE(5338), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1353), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1351), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359164] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8508), 1,
      sym_keyword_and,
    ACTIONS(8510), 1,
      sym_keyword_between,
    ACTIONS(8567), 1,
      sym_keyword_or,
    ACTIONS(8569), 1,
      anon_sym_COLON_COLON,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9711), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359249] = 4,
    ACTIONS(9760), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359296] = 4,
    ACTIONS(9762), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359343] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9578), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(9406), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359430] = 4,
    ACTIONS(9764), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359477] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9766), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359566] = 4,
    ACTIONS(9768), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [359613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359658] = 6,
    ACTIONS(9325), 1,
      sym_keyword_with,
    ACTIONS(9327), 1,
      sym_keyword_without,
    STATE(6137), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1848), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359709] = 6,
    ACTIONS(9325), 1,
      sym_keyword_with,
    ACTIONS(9327), 1,
      sym_keyword_without,
    STATE(6136), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1844), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359760] = 4,
    ACTIONS(9770), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359807] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9772), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359896] = 4,
    ACTIONS(9774), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359943] = 4,
    ACTIONS(9776), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [359990] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360035] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9778), 3,
      sym_keyword_when,
      sym_keyword_else,
      sym_keyword_end,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360120] = 4,
    ACTIONS(9780), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360167] = 4,
    ACTIONS(9782), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360214] = 4,
    ACTIONS(9784), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360261] = 4,
    ACTIONS(9786), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360308] = 6,
    ACTIONS(9788), 1,
      anon_sym_LBRACK,
    STATE(5419), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(5969), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2044), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2046), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360359] = 4,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2083), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2085), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360406] = 4,
    ACTIONS(9793), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360453] = 4,
    ACTIONS(9795), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2091), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2093), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360500] = 4,
    ACTIONS(9797), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 30,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360547] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9799), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11203), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360636] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9801), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    STATE(11171), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [360725] = 4,
    ACTIONS(9803), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2125), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2127), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360772] = 4,
    ACTIONS(9805), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(55), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360819] = 4,
    ACTIONS(9807), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2131), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2133), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [360866] = 6,
    ACTIONS(9398), 1,
      sym_keyword_with,
    ACTIONS(9400), 1,
      sym_keyword_without,
    STATE(6263), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1846), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1844), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [360917] = 6,
    ACTIONS(9398), 1,
      sym_keyword_with,
    ACTIONS(9400), 1,
      sym_keyword_without,
    STATE(6264), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1850), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1848), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [360968] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9809), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    STATE(11168), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [361057] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1962), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361102] = 4,
    ACTIONS(9811), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2171), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2173), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361149] = 4,
    ACTIONS(9813), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2161), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2163), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361196] = 4,
    ACTIONS(9815), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1994), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1996), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361243] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9817), 1,
      anon_sym_RPAREN,
    STATE(10532), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [361332] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    STATE(6334), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [361385] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(5372), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6455), 1,
      sym_index_hint,
    STATE(7016), 1,
      sym_where,
    STATE(7204), 1,
      sym_group_by,
    STATE(7293), 1,
      sym_order_by,
    STATE(7441), 1,
      sym_window_clause,
    STATE(7556), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6453), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(9005), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [361470] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9719), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [361555] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9819), 1,
      anon_sym_RBRACK,
    STATE(10521), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [361644] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9821), 1,
      anon_sym_RPAREN,
    STATE(10532), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [361733] = 4,
    ACTIONS(9823), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361780] = 4,
    ACTIONS(9825), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2071), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2073), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361827] = 4,
    ACTIONS(9827), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2057), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2059), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361874] = 4,
    ACTIONS(9829), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [361921] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9831), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [362010] = 4,
    ACTIONS(9833), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362057] = 4,
    ACTIONS(9835), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362104] = 4,
    ACTIONS(9837), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362151] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9839), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [362240] = 4,
    ACTIONS(9841), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362287] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9578), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8918), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [362374] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9843), 1,
      anon_sym_RPAREN,
    STATE(10779), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [362463] = 4,
    ACTIONS(9845), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362510] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9578), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(8919), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [362597] = 4,
    ACTIONS(9847), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362644] = 4,
    ACTIONS(9849), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362691] = 4,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362738] = 4,
    ACTIONS(9853), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362785] = 4,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362832] = 4,
    ACTIONS(9855), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2137), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2139), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362879] = 4,
    ACTIONS(9857), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [362926] = 7,
    ACTIONS(9859), 1,
      sym_keyword_array,
    STATE(5944), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6344), 1,
      sym_array_size_definition,
    STATE(6348), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2772), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2770), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [362979] = 4,
    ACTIONS(8887), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363026] = 4,
    ACTIONS(9861), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363073] = 4,
    ACTIONS(9863), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363120] = 4,
    ACTIONS(9865), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363167] = 4,
    ACTIONS(9867), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363214] = 4,
    ACTIONS(9869), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363261] = 4,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363308] = 7,
    ACTIONS(9859), 1,
      sym_keyword_array,
    STATE(5944), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6348), 1,
      sym__array_size_definition,
    STATE(6353), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2800), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2798), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363361] = 4,
    ACTIONS(9873), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363408] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2022), 17,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2024), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [363453] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(9875), 1,
      anon_sym_RBRACK,
    STATE(10653), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363542] = 25,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(9877), 1,
      anon_sym_RPAREN,
    STATE(10659), 1,
      aux_sym_array_repeat1,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363631] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9879), 1,
      anon_sym_RBRACK,
    ACTIONS(9881), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363717] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9883), 1,
      anon_sym_RBRACK,
    ACTIONS(9885), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363803] = 5,
    ACTIONS(9887), 1,
      sym_keyword_unsigned,
    ACTIONS(9889), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [363983] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364027] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2357), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2359), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2249), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2251), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364115] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2237), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2239), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364159] = 5,
    ACTIONS(9891), 1,
      sym_keyword_varying,
    ACTIONS(9893), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1948), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [364207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364251] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9895), 1,
      anon_sym_RBRACK,
    ACTIONS(9897), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364337] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9899), 1,
      anon_sym_RBRACK,
    ACTIONS(9901), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364423] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2213), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2215), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364467] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364511] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2269), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2271), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364555] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9903), 1,
      anon_sym_RBRACK,
    ACTIONS(9905), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364641] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 3,
      anon_sym_LPAREN,
      anon_sym_DOT,
      aux_sym__single_quote_string_token1,
    ACTIONS(1372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2273), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2275), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364775] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2181), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2183), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364819] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2277), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2279), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [364863] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9907), 1,
      anon_sym_RBRACK,
    ACTIONS(9909), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [364993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365037] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365081] = 4,
    STATE(6005), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3426), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365127] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365171] = 4,
    ACTIONS(9911), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1960), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [365217] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2285), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2287), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365305] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2289), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2291), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365349] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365393] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6233), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2549), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2547), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365441] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2329), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2331), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365485] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365573] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2345), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2347), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365617] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2353), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2355), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365705] = 4,
    ACTIONS(9915), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3364), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3366), 19,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365751] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2321), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2323), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365795] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2317), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2319), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365839] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [365927] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2313), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2315), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [365971] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6319), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2501), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2499), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2309), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2311), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366063] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2305), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2307), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366107] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366151] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366195] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2349), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2351), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366239] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366327] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_over,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366371] = 8,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(7902), 1,
      sym_keyword_as,
    STATE(6377), 1,
      sym_identifier,
    STATE(6426), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(9496), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(9498), 25,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [366425] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366557] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9917), 1,
      anon_sym_RBRACK,
    ACTIONS(9919), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366643] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2034), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2301), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2303), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366775] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2205), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2207), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366819] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9921), 1,
      anon_sym_RBRACK,
    ACTIONS(9923), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366905] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [366949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2221), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2223), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [366993] = 4,
    STATE(943), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367083] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6327), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2521), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2519), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367131] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6220), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2557), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2555), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367179] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367223] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367267] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2109), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367311] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2209), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2211), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367355] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2101), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367443] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6318), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367491] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367535] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2028), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367579] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2229), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2231), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367623] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2079), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367667] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2265), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2267), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367711] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2067), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367755] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2177), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2179), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367799] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2189), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2191), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367843] = 4,
    ACTIONS(9925), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367889] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6308), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2541), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2539), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [367937] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2185), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2187), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [367981] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368025] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1854), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368069] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368113] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2281), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2283), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368157] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2053), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368201] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9927), 1,
      anon_sym_RBRACK,
    ACTIONS(9929), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368287] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2293), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2295), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368331] = 5,
    ACTIONS(9931), 1,
      sym_keyword_unsigned,
    ACTIONS(9933), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1908), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368379] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368423] = 5,
    ACTIONS(9935), 1,
      sym_keyword_unsigned,
    ACTIONS(9937), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1932), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368471] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9939), 1,
      anon_sym_RBRACK,
    ACTIONS(9941), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368557] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368601] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2297), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2299), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368645] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2366), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2368), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2040), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368733] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2018), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368777] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2006), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368821] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2370), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2372), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [368865] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9943), 1,
      anon_sym_RBRACK,
    ACTIONS(9945), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368951] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [368995] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6291), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1784), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [369087] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2147), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [369131] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6276), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2505), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2503), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369179] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6274), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2509), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2507), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369227] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6273), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369275] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9947), 1,
      anon_sym_RBRACK,
    ACTIONS(9949), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369361] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6272), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2517), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2515), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369409] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3362), 2,
      sym_keyword_on,
      sym_keyword_using,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369493] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2121), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [369537] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2261), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2263), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [369581] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369625] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369713] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2253), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2255), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [369757] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369845] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9951), 1,
      anon_sym_RBRACK,
    ACTIONS(9953), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369931] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [369975] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6244), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2561), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2559), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370023] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6234), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370115] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6232), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370163] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2233), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2235), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370207] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3440), 2,
      sym_keyword_on,
      sym_keyword_using,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370291] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2217), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2219), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370335] = 5,
    ACTIONS(9955), 1,
      sym_keyword_unsigned,
    ACTIONS(9957), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1966), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [370383] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2197), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2199), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370427] = 5,
    ACTIONS(9959), 1,
      sym_keyword_unsigned,
    ACTIONS(9961), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1978), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [370475] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2193), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2195), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370519] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6231), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2529), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2527), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370567] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2225), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2227), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370611] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2378), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2380), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370655] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [370699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2241), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2243), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370743] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2245), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2247), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2257), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2259), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370831] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1926), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2115), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [370919] = 5,
    ACTIONS(9963), 1,
      sym_keyword_unsigned,
    ACTIONS(9965), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1986), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [370967] = 5,
    ACTIONS(9967), 1,
      sym_keyword_unsigned,
    ACTIONS(9969), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1940), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [371015] = 4,
    ACTIONS(9971), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3364), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3366), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [371061] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2382), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2384), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [371105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371149] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371193] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371237] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(7837), 1,
      anon_sym_LBRACK,
    ACTIONS(8327), 1,
      sym_keyword_is,
    ACTIONS(8331), 1,
      anon_sym_PLUS,
    ACTIONS(8333), 1,
      anon_sym_DASH,
    ACTIONS(8335), 1,
      anon_sym_SLASH,
    ACTIONS(8337), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      sym_keyword_in,
    ACTIONS(8381), 1,
      sym_keyword_not,
    ACTIONS(8387), 1,
      sym_op_other,
    ACTIONS(8508), 1,
      sym_keyword_and,
    ACTIONS(8510), 1,
      sym_keyword_between,
    ACTIONS(8567), 1,
      sym_keyword_or,
    ACTIONS(8569), 1,
      anon_sym_COLON_COLON,
    STATE(10705), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8329), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8385), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9973), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(1689), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1690), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8383), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371321] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371365] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371409] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371453] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2386), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2388), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [371497] = 5,
    ACTIONS(9975), 1,
      sym_keyword_unsigned,
    ACTIONS(9977), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1916), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [371545] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371589] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2155), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [371633] = 8,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(7902), 1,
      sym_keyword_as,
    STATE(6377), 1,
      sym_identifier,
    STATE(6422), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(9979), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(9981), 25,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [371687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2341), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2343), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [371731] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371775] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371819] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371907] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371951] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [371995] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372083] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372127] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372171] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372215] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372259] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372303] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372347] = 5,
    ACTIONS(9983), 1,
      sym_keyword_unsigned,
    ACTIONS(9985), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1918), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1916), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372395] = 5,
    ACTIONS(9987), 1,
      sym_keyword_unsigned,
    ACTIONS(9989), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1942), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1940), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372443] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372487] = 5,
    ACTIONS(9991), 1,
      sym_keyword_unsigned,
    ACTIONS(9993), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1988), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1986), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372535] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372579] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9711), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372663] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6230), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372711] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2374), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2376), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [372755] = 5,
    ACTIONS(9995), 1,
      sym_keyword_unsigned,
    ACTIONS(9997), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1980), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1978), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372803] = 5,
    ACTIONS(9999), 1,
      sym_keyword_unsigned,
    ACTIONS(10001), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1968), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1966), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2337), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2339), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [372895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2012), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [372939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [372983] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2333), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2335), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [373027] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2325), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2327), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [373115] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3416), 2,
      sym_keyword_on,
      sym_keyword_using,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373199] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6229), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2525), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2523), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373247] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373291] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373335] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373379] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10003), 1,
      anon_sym_RBRACK,
    ACTIONS(10005), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373465] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373597] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373641] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373685] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2201), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2203), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [373773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373817] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373861] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373905] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [373993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374037] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(9719), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374121] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6227), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374169] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10007), 1,
      anon_sym_RBRACK,
    ACTIONS(10009), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374255] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374299] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6767), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374383] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374427] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374471] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374515] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374559] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374603] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374647] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374691] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374735] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374823] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374867] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374911] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3386), 2,
      sym_keyword_on,
      sym_keyword_using,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [374995] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375083] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375127] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375171] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375215] = 5,
    ACTIONS(10011), 1,
      sym_keyword_unsigned,
    ACTIONS(10013), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1924), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [375263] = 5,
    ACTIONS(9913), 1,
      sym_keyword_filter,
    STATE(6216), 1,
      sym_filter_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375311] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375355] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375443] = 5,
    ACTIONS(10015), 1,
      sym_keyword_precision,
    ACTIONS(10017), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1852), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [375491] = 4,
    ACTIONS(10019), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 28,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375537] = 5,
    ACTIONS(10021), 1,
      sym_keyword_varying,
    ACTIONS(10023), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1950), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1948), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375629] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375673] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3430), 2,
      sym_keyword_on,
      sym_keyword_using,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375757] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2002), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2000), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375845] = 4,
    ACTIONS(10025), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375891] = 5,
    ACTIONS(10027), 1,
      sym_keyword_unsigned,
    ACTIONS(10029), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1910), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1908), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [375939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [375983] = 4,
    STATE(5823), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376029] = 5,
    ACTIONS(10031), 1,
      sym_keyword_unsigned,
    ACTIONS(10033), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1934), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1932), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [376077] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376121] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376165] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(6496), 1,
      sym_index_hint,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(7158), 1,
      sym_where,
    STATE(7328), 1,
      sym_group_by,
    STATE(7442), 1,
      sym_order_by,
    STATE(7520), 1,
      sym_window_clause,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6497), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [376249] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376293] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376337] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376381] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376425] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(6767), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2002), 19,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [376597] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376641] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 29,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376685] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10051), 1,
      anon_sym_RBRACK,
    ACTIONS(10053), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376771] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10055), 1,
      anon_sym_RBRACK,
    ACTIONS(10057), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376857] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376901] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(3422), 2,
      sym_keyword_on,
      sym_keyword_using,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [376985] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377073] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377117] = 24,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10059), 1,
      anon_sym_RBRACK,
    ACTIONS(10061), 1,
      anon_sym_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377203] = 5,
    ACTIONS(10063), 1,
      sym_keyword_precision,
    ACTIONS(10065), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377251] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(5755), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6501), 1,
      sym_index_hint,
    STATE(7118), 1,
      sym_where,
    STATE(7332), 1,
      sym_group_by,
    STATE(7483), 1,
      sym_order_by,
    STATE(7516), 1,
      sym_window_clause,
    STATE(7638), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6500), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(9005), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [377335] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(5734), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6499), 1,
      sym_index_hint,
    STATE(7159), 1,
      sym_where,
    STATE(7330), 1,
      sym_group_by,
    STATE(7476), 1,
      sym_order_by,
    STATE(7518), 1,
      sym_window_clause,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6498), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [377419] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(6499), 1,
      sym_index_hint,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(7159), 1,
      sym_where,
    STATE(7330), 1,
      sym_group_by,
    STATE(7476), 1,
      sym_order_by,
    STATE(7518), 1,
      sym_window_clause,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    STATE(6498), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [377503] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13418), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [377550] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10069), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377633] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10071), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377716] = 4,
    ACTIONS(10073), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2077), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [377761] = 4,
    ACTIONS(10075), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2065), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [377806] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13021), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [377853] = 4,
    ACTIONS(10077), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377898] = 4,
    ACTIONS(10079), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [377943] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10081), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378026] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10083), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378109] = 4,
    ACTIONS(10085), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2038), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [378154] = 4,
    ACTIONS(10087), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378199] = 4,
    ACTIONS(10089), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378244] = 4,
    ACTIONS(10091), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2016), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [378289] = 4,
    ACTIONS(10093), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2107), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [378334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378377] = 4,
    ACTIONS(10095), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378422] = 4,
    ACTIONS(10097), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378467] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10099), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378550] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13071), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [378597] = 4,
    ACTIONS(9662), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378642] = 4,
    ACTIONS(10101), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2113), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [378687] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10103), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378770] = 4,
    ACTIONS(10105), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2145), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [378815] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10107), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378898] = 4,
    ACTIONS(10109), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [378943] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10111), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379026] = 4,
    ACTIONS(10113), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2119), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [379071] = 4,
    ACTIONS(10115), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2137), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379116] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12844), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [379163] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13306), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [379210] = 6,
    ACTIONS(10117), 1,
      anon_sym_LBRACK,
    STATE(5787), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6348), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2044), 25,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379259] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13665), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [379306] = 4,
    ACTIONS(10120), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2099), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [379351] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12835), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [379398] = 4,
    ACTIONS(10122), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2051), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [379443] = 4,
    ACTIONS(10124), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379488] = 4,
    ACTIONS(10065), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379576] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10126), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379659] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379702] = 4,
    ACTIONS(10128), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379747] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379790] = 4,
    ACTIONS(10130), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379835] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10132), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379918] = 4,
    ACTIONS(10134), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [379963] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10136), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380046] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10138), 1,
      sym_keyword_as,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380129] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380215] = 4,
    ACTIONS(10142), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380260] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13417), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [380307] = 4,
    ACTIONS(10144), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380352] = 4,
    ACTIONS(10146), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380397] = 4,
    ACTIONS(10148), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380442] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2022), 28,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380485] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9973), 1,
      anon_sym_SEMI,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380568] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13319), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [380615] = 4,
    ACTIONS(10150), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2139), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2137), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [380660] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13335), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [380707] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13012), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [380754] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13020), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [380801] = 6,
    ACTIONS(9472), 1,
      anon_sym_LBRACK,
    STATE(5920), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6336), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(3228), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [380850] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10152), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [380933] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10154), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381016] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10156), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381185] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10158), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381268] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12608), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [381315] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10160), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381398] = 4,
    ACTIONS(10162), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2057), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381443] = 4,
    ACTIONS(10164), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2071), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381488] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13616), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [381535] = 4,
    ACTIONS(10166), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1994), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381580] = 4,
    ACTIONS(10168), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2161), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381625] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2167), 28,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381668] = 4,
    ACTIONS(10170), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2004), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [381713] = 4,
    ACTIONS(10172), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2171), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1960), 28,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381801] = 4,
    ACTIONS(10017), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1852), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [381846] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10174), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381929] = 4,
    ACTIONS(10176), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2131), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [381974] = 4,
    ACTIONS(10178), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2125), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382019] = 4,
    ACTIONS(10180), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2107), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [382064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382107] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10182), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382190] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(10184), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382273] = 4,
    ACTIONS(10186), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2091), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382318] = 4,
    ACTIONS(10188), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2083), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382363] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10190), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382446] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10192), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382572] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10194), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382655] = 4,
    ACTIONS(10196), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2099), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [382700] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10198), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [382783] = 4,
    ACTIONS(10200), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2093), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2091), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [382828] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13318), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [382875] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13615), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [382922] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10202), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383005] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10204), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383088] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10206), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383171] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10208), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383254] = 4,
    ACTIONS(10210), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2026), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [383299] = 4,
    ACTIONS(10212), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2077), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [383344] = 4,
    ACTIONS(10214), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2065), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [383389] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10216), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383472] = 4,
    ACTIONS(10218), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2051), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [383517] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383560] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10220), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383643] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10222), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383726] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10224), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383809] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2024), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2022), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [383852] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10226), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [383935] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13581), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [383982] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10228), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384065] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10230), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384148] = 4,
    ACTIONS(10232), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2153), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [384193] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10234), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384276] = 4,
    ACTIONS(10236), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2032), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [384321] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384364] = 5,
    ACTIONS(3343), 1,
      aux_sym__single_quote_string_token2,
    STATE(737), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3156), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3154), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384411] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12831), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [384458] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10238), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384541] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10240), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384624] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10242), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384707] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10244), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384790] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10246), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384873] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10248), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [384956] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10250), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385039] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10252), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385122] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10254), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385205] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10256), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385288] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10258), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385371] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10260), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385454] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10262), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385537] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10264), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385620] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10266), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385703] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10268), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385786] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1372), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1370), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385829] = 23,
    ACTIONS(10272), 1,
      sym__identifier,
    ACTIONS(10275), 1,
      sym_keyword_partition,
    ACTIONS(10280), 1,
      sym_keyword_collate,
    ACTIONS(10283), 1,
      sym_keyword_engine,
    ACTIONS(10286), 1,
      sym_keyword_default,
    ACTIONS(10289), 1,
      sym_keyword_with,
    ACTIONS(10292), 1,
      sym_keyword_without,
    ACTIONS(10295), 1,
      sym_keyword_row,
    ACTIONS(10298), 1,
      sym_keyword_stored,
    ACTIONS(10301), 1,
      sym_keyword_tblproperties,
    ACTIONS(10304), 1,
      sym_keyword_location,
    ACTIONS(10307), 1,
      sym_keyword_partitioned,
    ACTIONS(10310), 1,
      sym_keyword_sort,
    ACTIONS(10313), 1,
      sym__double_quote_string,
    ACTIONS(10316), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10319), 1,
      aux_sym_identifier_token1,
    ACTIONS(10322), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10278), 2,
      sym_keyword_create,
      sym_keyword_as,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    ACTIONS(10270), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [385912] = 5,
    ACTIONS(10325), 1,
      aux_sym__single_quote_string_token2,
    STATE(5877), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3180), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3178), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [385959] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10327), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386042] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10329), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386125] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10331), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386208] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10333), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386291] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10335), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386374] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10337), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386457] = 4,
    ACTIONS(10339), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(55), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(109), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386502] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10341), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386585] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10343), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386668] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10345), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386751] = 4,
    ACTIONS(9676), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1852), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [386796] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10347), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386879] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10349), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [386962] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10351), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387045] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10353), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387128] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10355), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387211] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10357), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387294] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10359), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387377] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10361), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387460] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10363), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387543] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10365), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387626] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10367), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387709] = 6,
    ACTIONS(10369), 1,
      anon_sym_LBRACK,
    STATE(5920), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6336), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2046), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2044), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [387758] = 4,
    ACTIONS(10372), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2010), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [387803] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10374), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387886] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10376), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [387969] = 4,
    ACTIONS(10378), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2032), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [388014] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10380), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388097] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10382), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388180] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10384), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388263] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10386), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388346] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14413), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [388393] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14419), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [388440] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10388), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388523] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10390), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388606] = 4,
    ACTIONS(10392), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2026), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [388651] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10394), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388734] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14514), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [388781] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12811), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [388828] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10396), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [388911] = 4,
    ACTIONS(10398), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2073), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2071), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [388956] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12350), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [389003] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14421), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [389050] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10400), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389133] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10402), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389216] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10404), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389299] = 5,
    STATE(5787), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(6348), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3230), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3228), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389346] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10406), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389429] = 4,
    ACTIONS(10408), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389474] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12649), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [389521] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10410), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389604] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10412), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389687] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10414), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389770] = 4,
    ACTIONS(10416), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389815] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10418), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389898] = 4,
    ACTIONS(10420), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [389943] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10422), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390026] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10424), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390109] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10426), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390192] = 4,
    ACTIONS(10428), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390237] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10430), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390320] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10432), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390403] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8532), 1,
      sym_keyword_not,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8555), 1,
      sym_keyword_between,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    ACTIONS(10434), 1,
      anon_sym_RPAREN,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390486] = 4,
    ACTIONS(10436), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390531] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12609), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [390578] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10438), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390661] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [390708] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10440), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390791] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2366), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2368), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [390834] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10442), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [390917] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13931), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [390964] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2370), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2372), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [391007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391050] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10444), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391133] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14537), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [391180] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14538), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [391227] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14548), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [391274] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10446), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391357] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(10140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10448), 1,
      sym_keyword_as,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391440] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10450), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391523] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10452), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391606] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391649] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14524), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [391696] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10454), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391822] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10456), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391905] = 4,
    ACTIONS(10458), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [391950] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10460), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392033] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13410), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392080] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392123] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10462), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392206] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14512), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392253] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10464), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392336] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392379] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10466), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392462] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14497), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392509] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14107), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392556] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14085), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392603] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392646] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14084), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392693] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14061), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392740] = 4,
    ACTIONS(10468), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1996), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1994), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [392785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392871] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [392914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2378), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2380), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [392957] = 4,
    ACTIONS(10470), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2163), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2161), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [393002] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2382), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2384), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [393045] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10472), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393128] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10474), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393211] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10476), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393294] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10478), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393377] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2169), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2167), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [393420] = 4,
    ACTIONS(10480), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2173), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2171), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [393465] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10482), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393548] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1962), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1960), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [393591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2386), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2388), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [393634] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 9,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1376), 25,
      sym_keyword_set,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_change,
      sym_keyword_modify,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_column,
      sym_keyword_as,
      sym_keyword_if,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_rename,
      sym_keyword_owner,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [393677] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13956), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [393724] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13884), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [393771] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10484), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393854] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14083), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [393901] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10486), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [393984] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10488), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394067] = 4,
    ACTIONS(10490), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2133), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2131), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [394112] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13789), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [394159] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10492), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394242] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10494), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394325] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13574), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [394372] = 4,
    ACTIONS(10496), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2127), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2125), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [394417] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10498), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394500] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394543] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [394590] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10500), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394673] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13550), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [394720] = 4,
    ACTIONS(10502), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2059), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2057), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [394765] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13528), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [394812] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10504), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394895] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [394938] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(14439), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [394985] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13366), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395032] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13363), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395079] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10506), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395162] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(13293), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2374), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(2376), 18,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395252] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12700), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395299] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10508), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395382] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10510), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395465] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12597), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395512] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12596), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395559] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12536), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395606] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10512), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395732] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10514), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395815] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395858] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12194), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [395905] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10516), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [395988] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12144), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [396035] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10518), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396118] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12142), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [396165] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10520), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396248] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10522), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396331] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10524), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396414] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10526), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396497] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12109), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [396544] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10528), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396627] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12058), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [396674] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12067), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [396721] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12068), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [396768] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10530), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396851] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10532), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [396934] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10534), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397017] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10536), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397100] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10538), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397183] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10540), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397266] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12082), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [397313] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397356] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10542), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397439] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10544), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397522] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12184), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [397569] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12204), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [397616] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397659] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397702] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10546), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397828] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12205), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [397875] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10548), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [397958] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398044] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10550), 1,
      sym_keyword_then,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398127] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10552), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398210] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12242), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [398257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398300] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10554), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398383] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12403), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [398430] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12429), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [398477] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12430), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [398524] = 4,
    ACTIONS(10556), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2085), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2083), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [398569] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398612] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10558), 1,
      sym_keyword_when,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398695] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398738] = 4,
    ACTIONS(10560), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398783] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10562), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398866] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12449), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [398913] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10564), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [398996] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10566), 1,
      anon_sym_RBRACK,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399079] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399122] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399251] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_or,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399294] = 5,
    ACTIONS(10067), 1,
      sym_keyword_limit,
    STATE(12600), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 15,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(3568), 17,
      sym_keyword_order,
      sym_keyword_as,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
      sym__identifier,
  [399341] = 23,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10568), 1,
      sym_keyword_end,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399424] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2229), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399466] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10570), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399546] = 4,
    STATE(6338), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3424), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399590] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10574), 1,
      sym_keyword_partition,
    ACTIONS(10576), 1,
      sym_keyword_create,
    ACTIONS(10578), 1,
      sym_keyword_as,
    ACTIONS(10580), 1,
      sym_keyword_collate,
    ACTIONS(10582), 1,
      sym_keyword_engine,
    ACTIONS(10584), 1,
      sym_keyword_default,
    ACTIONS(10586), 1,
      sym_keyword_with,
    ACTIONS(10588), 1,
      sym_keyword_without,
    ACTIONS(10590), 1,
      sym_keyword_row,
    ACTIONS(10592), 1,
      sym_keyword_stored,
    ACTIONS(10594), 1,
      sym_keyword_tblproperties,
    ACTIONS(10596), 1,
      sym_keyword_location,
    ACTIONS(10598), 1,
      sym_keyword_partitioned,
    ACTIONS(10600), 1,
      sym_keyword_sort,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10572), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6167), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [399674] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2325), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2333), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2010), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2337), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2341), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399884] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2153), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399926] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2113), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [399968] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1924), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2225), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2193), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2197), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400136] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2217), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2221), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2233), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400262] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2253), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2261), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2119), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400388] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2145), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400430] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2004), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2016), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400514] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2038), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2297), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400598] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2293), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2281), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2177), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2265), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400766] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2209), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400808] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2205), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2201), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400892] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2349), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400934] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2357), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [400976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2249), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401018] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2237), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401060] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2213), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401102] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2269), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401144] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2273), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401186] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2181), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401228] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2277), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401270] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2285), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2289), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2329), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2345), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401438] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2353), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401480] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10574), 1,
      sym_keyword_partition,
    ACTIONS(10576), 1,
      sym_keyword_create,
    ACTIONS(10578), 1,
      sym_keyword_as,
    ACTIONS(10580), 1,
      sym_keyword_collate,
    ACTIONS(10582), 1,
      sym_keyword_engine,
    ACTIONS(10584), 1,
      sym_keyword_default,
    ACTIONS(10586), 1,
      sym_keyword_with,
    ACTIONS(10588), 1,
      sym_keyword_without,
    ACTIONS(10590), 1,
      sym_keyword_row,
    ACTIONS(10592), 1,
      sym_keyword_stored,
    ACTIONS(10594), 1,
      sym_keyword_tblproperties,
    ACTIONS(10596), 1,
      sym_keyword_location,
    ACTIONS(10598), 1,
      sym_keyword_partitioned,
    ACTIONS(10600), 1,
      sym_keyword_sort,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10572), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6166), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [401564] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2321), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401606] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2317), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401648] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2313), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401690] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2309), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401732] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2305), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401774] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2032), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2301), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [401858] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10574), 1,
      sym_keyword_partition,
    ACTIONS(10580), 1,
      sym_keyword_collate,
    ACTIONS(10582), 1,
      sym_keyword_engine,
    ACTIONS(10584), 1,
      sym_keyword_default,
    ACTIONS(10586), 1,
      sym_keyword_with,
    ACTIONS(10588), 1,
      sym_keyword_without,
    ACTIONS(10590), 1,
      sym_keyword_row,
    ACTIONS(10592), 1,
      sym_keyword_stored,
    ACTIONS(10594), 1,
      sym_keyword_tblproperties,
    ACTIONS(10596), 1,
      sym_keyword_location,
    ACTIONS(10598), 1,
      sym_keyword_partitioned,
    ACTIONS(10600), 1,
      sym_keyword_sort,
    ACTIONS(10604), 1,
      sym_keyword_create,
    ACTIONS(10606), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10602), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6167), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [401942] = 23,
    ACTIONS(10272), 1,
      sym__identifier,
    ACTIONS(10313), 1,
      sym__double_quote_string,
    ACTIONS(10316), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10319), 1,
      aux_sym_identifier_token1,
    ACTIONS(10322), 1,
      sym__dollar_quoted_string,
    ACTIONS(10608), 1,
      sym_keyword_partition,
    ACTIONS(10611), 1,
      sym_keyword_collate,
    ACTIONS(10614), 1,
      sym_keyword_engine,
    ACTIONS(10617), 1,
      sym_keyword_default,
    ACTIONS(10620), 1,
      sym_keyword_with,
    ACTIONS(10623), 1,
      sym_keyword_without,
    ACTIONS(10626), 1,
      sym_keyword_row,
    ACTIONS(10629), 1,
      sym_keyword_stored,
    ACTIONS(10632), 1,
      sym_keyword_tblproperties,
    ACTIONS(10635), 1,
      sym_keyword_location,
    ACTIONS(10638), 1,
      sym_keyword_partitioned,
    ACTIONS(10641), 1,
      sym_keyword_sort,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10270), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(10278), 2,
      sym_keyword_create,
      sym_keyword_as,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6167), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [402024] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10574), 1,
      sym_keyword_partition,
    ACTIONS(10580), 1,
      sym_keyword_collate,
    ACTIONS(10582), 1,
      sym_keyword_engine,
    ACTIONS(10584), 1,
      sym_keyword_default,
    ACTIONS(10586), 1,
      sym_keyword_with,
    ACTIONS(10588), 1,
      sym_keyword_without,
    ACTIONS(10590), 1,
      sym_keyword_row,
    ACTIONS(10592), 1,
      sym_keyword_stored,
    ACTIONS(10594), 1,
      sym_keyword_tblproperties,
    ACTIONS(10596), 1,
      sym_keyword_location,
    ACTIONS(10598), 1,
      sym_keyword_partitioned,
    ACTIONS(10600), 1,
      sym_keyword_sort,
    ACTIONS(10646), 1,
      sym_keyword_create,
    ACTIONS(10648), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10644), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6167), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [402108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2107), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402150] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2099), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402192] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2026), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402234] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2077), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402276] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2065), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402318] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2189), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2185), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402402] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1852), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2051), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402486] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10574), 1,
      sym_keyword_partition,
    ACTIONS(10580), 1,
      sym_keyword_collate,
    ACTIONS(10582), 1,
      sym_keyword_engine,
    ACTIONS(10584), 1,
      sym_keyword_default,
    ACTIONS(10586), 1,
      sym_keyword_with,
    ACTIONS(10588), 1,
      sym_keyword_without,
    ACTIONS(10590), 1,
      sym_keyword_row,
    ACTIONS(10592), 1,
      sym_keyword_stored,
    ACTIONS(10594), 1,
      sym_keyword_tblproperties,
    ACTIONS(10596), 1,
      sym_keyword_location,
    ACTIONS(10598), 1,
      sym_keyword_partitioned,
    ACTIONS(10600), 1,
      sym_keyword_sort,
    ACTIONS(10652), 1,
      sym_keyword_create,
    ACTIONS(10654), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10650), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6168), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [402570] = 9,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(10656), 1,
      sym_keyword_as,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    STATE(6559), 1,
      sym__alias,
    STATE(6560), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(9496), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(9498), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [402624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(1782), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402666] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2241), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402708] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2245), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2257), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402792] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10660), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402872] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10662), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [402952] = 22,
    ACTIONS(2396), 1,
      sym_keyword_in,
    ACTIONS(2398), 1,
      sym_keyword_is,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2414), 1,
      sym_op_other,
    ACTIONS(2416), 1,
      anon_sym_PLUS,
    ACTIONS(2418), 1,
      anon_sym_DASH,
    ACTIONS(2420), 1,
      anon_sym_SLASH,
    ACTIONS(2422), 1,
      anon_sym_CARET,
    ACTIONS(2479), 1,
      sym_keyword_and,
    ACTIONS(3456), 1,
      sym_keyword_or,
    ACTIONS(3458), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    STATE(10357), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2410), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1625), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1623), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2408), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403032] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10664), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403112] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10666), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403192] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(2859), 1,
      sym_keyword_in,
    ACTIONS(2861), 1,
      sym_keyword_is,
    ACTIONS(2873), 1,
      sym_op_other,
    ACTIONS(2875), 1,
      anon_sym_PLUS,
    ACTIONS(2877), 1,
      anon_sym_DASH,
    ACTIONS(2879), 1,
      anon_sym_SLASH,
    ACTIONS(2881), 1,
      anon_sym_CARET,
    ACTIONS(3062), 1,
      sym_keyword_and,
    ACTIONS(3994), 1,
      sym_keyword_or,
    ACTIONS(3996), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    STATE(11101), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(2869), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2871), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1480), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1481), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(2867), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403272] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10668), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403352] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10670), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403432] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10604), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10674), 1,
      sym_keyword_as,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10602), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [403516] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10698), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403596] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10700), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403676] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10702), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403756] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10704), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403836] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10706), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403916] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10708), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [403996] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10710), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404076] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10712), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404156] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10714), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404236] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10574), 1,
      sym_keyword_partition,
    ACTIONS(10580), 1,
      sym_keyword_collate,
    ACTIONS(10582), 1,
      sym_keyword_engine,
    ACTIONS(10584), 1,
      sym_keyword_default,
    ACTIONS(10586), 1,
      sym_keyword_with,
    ACTIONS(10588), 1,
      sym_keyword_without,
    ACTIONS(10590), 1,
      sym_keyword_row,
    ACTIONS(10592), 1,
      sym_keyword_stored,
    ACTIONS(10594), 1,
      sym_keyword_tblproperties,
    ACTIONS(10596), 1,
      sym_keyword_location,
    ACTIONS(10598), 1,
      sym_keyword_partitioned,
    ACTIONS(10600), 1,
      sym_keyword_sort,
    ACTIONS(10646), 1,
      sym_keyword_create,
    ACTIONS(10648), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10644), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(13894), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6114), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [404320] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10716), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404400] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10718), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404480] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10720), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404560] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10722), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404640] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10724), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404720] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10726), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404800] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10728), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404880] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10730), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [404960] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10576), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10732), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10572), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6192), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [405044] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10734), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405124] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10736), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405204] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10738), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405284] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10740), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405364] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2728), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2726), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405406] = 4,
    ACTIONS(10742), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405450] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10744), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405530] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10576), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10732), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10572), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [405614] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2495), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2493), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405656] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10746), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405736] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10748), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405816] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10750), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [405896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2121), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2119), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [405938] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10752), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406018] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10754), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2744), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2742), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406140] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10756), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2533), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2531), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406262] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2760), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2758), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406304] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2565), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2563), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2764), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2762), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406388] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2724), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2722), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406430] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2748), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2746), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2327), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2325), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406514] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2335), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2333), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2012), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2010), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406598] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2339), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2337), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2343), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2341), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2155), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2153), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2115), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2113), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406766] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1926), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1924), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406808] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2227), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2225), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [406850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2569), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2567), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406892] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10758), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [406972] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2195), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2193), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407014] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2199), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2197), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2219), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2217), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2223), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2221), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2235), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2233), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407182] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2255), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2253), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2263), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2261), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407266] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5971), 1,
      sym_keyword_and,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [407346] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(6257), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6585), 1,
      sym_index_hint,
    STATE(7293), 1,
      sym_order_by,
    STATE(7352), 1,
      sym_where,
    STATE(7535), 1,
      sym_group_by,
    STATE(7556), 1,
      sym_limit,
    STATE(7797), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(9005), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6576), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [407428] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10778), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [407508] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(6293), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6578), 1,
      sym_index_hint,
    STATE(7387), 1,
      sym_where,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    STATE(7578), 1,
      sym_group_by,
    STATE(7849), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6575), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [407590] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6578), 1,
      sym_index_hint,
    STATE(7387), 1,
      sym_where,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    STATE(7578), 1,
      sym_group_by,
    STATE(7849), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6575), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [407672] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2053), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2051), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2147), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2145), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407756] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2006), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2004), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407798] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2018), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2016), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407840] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2040), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2038), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407882] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2299), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2297), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2295), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2293), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [407966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2283), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2281), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2179), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2177), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2267), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2265), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408092] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2231), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2229), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408134] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2211), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2209), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2207), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2205), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408218] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2203), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2201), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408260] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2756), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2754), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [408302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2752), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2750), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [408344] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2537), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2535), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [408386] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2740), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2738), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [408428] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2736), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2734), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [408470] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2351), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2349), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408512] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2359), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2357), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2251), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2249), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408596] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2239), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2237), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408638] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2215), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2213), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408680] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2271), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2269), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2275), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2273), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408764] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2183), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2181), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408806] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2279), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2277), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408848] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2287), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2285), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2291), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2289), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2331), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2329), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [408974] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2347), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2345), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409016] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2355), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2353), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409058] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2553), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2551), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [409100] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10652), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10780), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10650), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6296), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [409184] = 23,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6587), 1,
      sym_index_hint,
    STATE(7338), 1,
      sym_order_by,
    STATE(7408), 1,
      sym_where,
    STATE(7559), 1,
      sym_group_by,
    STATE(7585), 1,
      sym_limit,
    STATE(7845), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(8847), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6589), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [409266] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8530), 1,
      sym_keyword_is,
    ACTIONS(8540), 1,
      sym_op_other,
    ACTIONS(8542), 1,
      anon_sym_PLUS,
    ACTIONS(8544), 1,
      anon_sym_DASH,
    ACTIONS(8546), 1,
      anon_sym_SLASH,
    ACTIONS(8548), 1,
      anon_sym_CARET,
    ACTIONS(8553), 1,
      sym_keyword_and,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8677), 1,
      sym_keyword_or,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(8536), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8538), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1502), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1494), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(8534), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [409346] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10782), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [409426] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10646), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10784), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10644), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [409510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2323), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2321), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2319), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2317), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2315), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2313), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409636] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2311), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2309), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409678] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2307), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2305), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409720] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2034), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2032), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2303), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2301), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [409804] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10786), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [409884] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10788), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [409964] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10790), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410044] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10792), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410124] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2768), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2766), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410166] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2109), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2107), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2101), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2099), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2028), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2026), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410292] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2079), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2077), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2067), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2065), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2191), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2189), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410418] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2187), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2185), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1854), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1852), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410502] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10794), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410582] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2513), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2511), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2545), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2543), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410666] = 5,
    ACTIONS(9472), 1,
      anon_sym_LBRACK,
    STATE(6415), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3426), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(3424), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [410712] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10796), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410792] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10798), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [410872] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1784), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(1782), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2243), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2241), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2247), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2245), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [410998] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2259), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2257), 31,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [411040] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2732), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2730), 27,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_over,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411082] = 22,
    ACTIONS(2404), 1,
      sym_keyword_similar,
    ACTIONS(5860), 1,
      sym_keyword_is,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      sym_keyword_in,
    ACTIONS(5901), 1,
      sym_op_other,
    ACTIONS(5903), 1,
      anon_sym_PLUS,
    ACTIONS(5905), 1,
      anon_sym_DASH,
    ACTIONS(5907), 1,
      anon_sym_SLASH,
    ACTIONS(5973), 1,
      sym_keyword_not,
    ACTIONS(5975), 1,
      sym_keyword_between,
    ACTIONS(8596), 1,
      sym_keyword_or,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10800), 1,
      sym_keyword_and,
    STATE(10861), 1,
      sym_not_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
    ACTIONS(5899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5979), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1308), 3,
      sym_is_not,
      sym_distinct_from,
      sym_not_distinct_from,
    STATE(1303), 4,
      sym_keyword_like,
      sym_not_like,
      sym_similar_to,
      sym_not_similar_to,
    ACTIONS(5977), 5,
      anon_sym_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411162] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10646), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10784), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10644), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6219), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [411246] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3624), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3622), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411287] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3520), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3518), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411328] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6921), 1,
      sym_where,
    STATE(7027), 1,
      sym_group_by,
    STATE(7177), 1,
      sym_window_clause,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6586), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [411401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2386), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [411442] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3572), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3570), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411483] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2388), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2386), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411524] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2370), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [411565] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10802), 1,
      sym_keyword_set,
    ACTIONS(10804), 1,
      sym_keyword_alter,
    ACTIONS(10806), 1,
      sym_keyword_change,
    ACTIONS(10808), 1,
      sym_keyword_modify,
    ACTIONS(10810), 1,
      sym_keyword_drop,
    ACTIONS(10812), 1,
      sym_keyword_add,
    ACTIONS(10814), 1,
      sym_keyword_column,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10818), 1,
      sym_keyword_rename,
    ACTIONS(10820), 1,
      sym_keyword_owner,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7672), 1,
      sym__if_not_exists,
    STATE(8326), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10238), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [411646] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2382), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [411687] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10802), 1,
      sym_keyword_set,
    ACTIONS(10804), 1,
      sym_keyword_alter,
    ACTIONS(10806), 1,
      sym_keyword_change,
    ACTIONS(10808), 1,
      sym_keyword_modify,
    ACTIONS(10810), 1,
      sym_keyword_drop,
    ACTIONS(10812), 1,
      sym_keyword_add,
    ACTIONS(10814), 1,
      sym_keyword_column,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10818), 1,
      sym_keyword_rename,
    ACTIONS(10820), 1,
      sym_keyword_owner,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7672), 1,
      sym__if_not_exists,
    STATE(8326), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10212), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [411768] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10828), 1,
      sym_keyword_as,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6211), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6433), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [411851] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10834), 1,
      sym_keyword_alter,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9847), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [411932] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6618), 1,
      sym_index_hint,
    STATE(7442), 1,
      sym_order_by,
    STATE(7484), 1,
      sym_where,
    STATE(7611), 1,
      sym_limit,
    STATE(7665), 1,
      sym_group_by,
    STATE(8085), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(8847), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6594), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [412013] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10834), 1,
      sym_keyword_alter,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9980), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [412094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2378), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [412135] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6615), 1,
      sym_index_hint,
    STATE(7476), 1,
      sym_order_by,
    STATE(7482), 1,
      sym_where,
    STATE(7664), 1,
      sym_group_by,
    STATE(7707), 1,
      sym_limit,
    STATE(8087), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6616), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [412216] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(6342), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6615), 1,
      sym_index_hint,
    STATE(7476), 1,
      sym_order_by,
    STATE(7482), 1,
      sym_where,
    STATE(7664), 1,
      sym_group_by,
    STATE(7707), 1,
      sym_limit,
    STATE(8087), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6616), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [412297] = 23,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(6345), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(6613), 1,
      sym_index_hint,
    STATE(7470), 1,
      sym_where,
    STATE(7483), 1,
      sym_order_by,
    STATE(7638), 1,
      sym_limit,
    STATE(7658), 1,
      sym_group_by,
    STATE(8096), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(9094), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(9005), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6614), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [412378] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2372), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2370), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [412419] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10572), 1,
      anon_sym_RPAREN,
    ACTIONS(10576), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10866), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6371), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [412502] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6919), 1,
      sym_where,
    STATE(7000), 1,
      sym_group_by,
    STATE(7238), 1,
      sym_window_clause,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6404), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [412575] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6919), 1,
      sym_where,
    STATE(7000), 1,
      sym_group_by,
    STATE(7238), 1,
      sym_window_clause,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6586), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [412648] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10834), 1,
      sym_keyword_alter,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9921), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [412729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2366), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [412770] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2374), 30,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
  [412811] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    ACTIONS(10868), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6329), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6465), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [412894] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10650), 1,
      anon_sym_RPAREN,
    ACTIONS(10652), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10870), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6361), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [412977] = 8,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(10656), 1,
      sym_keyword_as,
    STATE(6531), 1,
      sym__alias,
    STATE(6560), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(9979), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(9981), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [413028] = 8,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(10656), 1,
      sym_keyword_as,
    STATE(6558), 1,
      sym__alias,
    STATE(6560), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(9496), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(9498), 23,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [413079] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3644), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3642), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [413120] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10644), 1,
      anon_sym_RPAREN,
    ACTIONS(10646), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10872), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6367), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [413203] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10644), 1,
      anon_sym_RPAREN,
    ACTIONS(10646), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10872), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [413286] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10874), 1,
      sym_keyword_as,
    ACTIONS(10876), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6178), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6447), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [413369] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10802), 1,
      sym_keyword_set,
    ACTIONS(10804), 1,
      sym_keyword_alter,
    ACTIONS(10806), 1,
      sym_keyword_change,
    ACTIONS(10808), 1,
      sym_keyword_modify,
    ACTIONS(10810), 1,
      sym_keyword_drop,
    ACTIONS(10812), 1,
      sym_keyword_add,
    ACTIONS(10814), 1,
      sym_keyword_column,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10818), 1,
      sym_keyword_rename,
    ACTIONS(10820), 1,
      sym_keyword_owner,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7672), 1,
      sym__if_not_exists,
    STATE(8326), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9894), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [413450] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3524), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3522), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [413491] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10876), 1,
      anon_sym_LPAREN,
    ACTIONS(10878), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6202), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6430), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [413574] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10880), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [413613] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10572), 1,
      anon_sym_RPAREN,
    ACTIONS(10576), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10866), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [413696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2376), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2374), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [413737] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10802), 1,
      sym_keyword_set,
    ACTIONS(10804), 1,
      sym_keyword_alter,
    ACTIONS(10806), 1,
      sym_keyword_change,
    ACTIONS(10808), 1,
      sym_keyword_modify,
    ACTIONS(10810), 1,
      sym_keyword_drop,
    ACTIONS(10812), 1,
      sym_keyword_add,
    ACTIONS(10814), 1,
      sym_keyword_column,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10818), 1,
      sym_keyword_rename,
    ACTIONS(10820), 1,
      sym_keyword_owner,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7672), 1,
      sym__if_not_exists,
    STATE(8326), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10071), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [413818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3516), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3514), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [413859] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10602), 1,
      anon_sym_RPAREN,
    ACTIONS(10604), 1,
      sym_keyword_create,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10882), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [413942] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10876), 1,
      anon_sym_LPAREN,
    ACTIONS(10884), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6158), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6463), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [414025] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10834), 1,
      sym_keyword_alter,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9984), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [414106] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    ACTIONS(10886), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6292), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6456), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [414189] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3564), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3562), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [414230] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6945), 1,
      sym_where,
    STATE(6998), 1,
      sym_group_by,
    STATE(7168), 1,
      sym_window_clause,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6586), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10888), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [414303] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10890), 32,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [414342] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    ACTIONS(10886), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6356), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6456), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [414425] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    ACTIONS(10868), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6360), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6465), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [414508] = 24,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10828), 1,
      sym_keyword_as,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6349), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(6433), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [414591] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    ACTIONS(10892), 1,
      sym_keyword_alter,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10615), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [414672] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    ACTIONS(10892), 1,
      sym_keyword_alter,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9980), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [414753] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2796), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2794), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [414794] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3512), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3510), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [414835] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3600), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3598), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [414876] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3592), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3590), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [414917] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3588), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3586), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [414958] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    ACTIONS(10892), 1,
      sym_keyword_alter,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11057), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [415039] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(10832), 1,
      sym_keyword_set,
    ACTIONS(10836), 1,
      sym_keyword_change,
    ACTIONS(10838), 1,
      sym_keyword_modify,
    ACTIONS(10840), 1,
      sym_keyword_drop,
    ACTIONS(10842), 1,
      sym_keyword_add,
    ACTIONS(10844), 1,
      sym_keyword_column,
    ACTIONS(10846), 1,
      sym_keyword_rename,
    ACTIONS(10848), 1,
      sym_keyword_owner,
    ACTIONS(10892), 1,
      sym_keyword_alter,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7642), 1,
      sym__if_not_exists,
    STATE(8148), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11035), 11,
      sym__alter_specifications,
      sym_add_column,
      sym_add_constraint,
      sym_alter_column,
      sym_modify_column,
      sym_change_column,
      sym_drop_column,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [415120] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415161] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415202] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3496), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3494), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415243] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3596), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3594), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415284] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3648), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3646), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415325] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3504), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3502), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415366] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3560), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3558), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3462), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3460), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3616), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3614), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415489] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3620), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3618), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415530] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2426), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2424), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415571] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6921), 1,
      sym_where,
    STATE(7027), 1,
      sym_group_by,
    STATE(7177), 1,
      sym_window_clause,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6351), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [415644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3576), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3574), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415685] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3580), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3578), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415726] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6933), 1,
      sym_where,
    STATE(7054), 1,
      sym_group_by,
    STATE(7213), 1,
      sym_window_clause,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6586), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [415799] = 19,
    ACTIONS(8849), 1,
      sym_keyword_left,
    ACTIONS(8853), 1,
      sym_keyword_inner,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8857), 1,
      sym_keyword_join,
    ACTIONS(8859), 1,
      sym_keyword_natural,
    ACTIONS(8861), 1,
      sym_keyword_where,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6933), 1,
      sym_where,
    STATE(7054), 1,
      sym_group_by,
    STATE(7213), 1,
      sym_window_clause,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8851), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6376), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [415872] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3632), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3630), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415913] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3508), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3506), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415954] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3584), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3582), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [415995] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3608), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3606), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [416036] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3612), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3610), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [416077] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3636), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3634), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [416118] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3640), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3638), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [416159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3500), 6,
      sym_keyword_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3498), 26,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [416200] = 4,
    ACTIONS(55), 1,
      sym_keyword_partition,
    ACTIONS(113), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_is,
      sym_keyword_using,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_with,
      sym_keyword_rename,
      sym_keyword_to,
      sym_keyword_owner,
      sym_keyword_wait,
      sym_keyword_nowait,
      sym_keyword_compute,
      sym_keyword_rewrite,
      sym_keyword_partitioned,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [416242] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2384), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2382), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [416282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2380), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2378), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [416322] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6975), 1,
      sym_where,
    STATE(7153), 1,
      sym_group_by,
    STATE(7273), 1,
      sym_window_clause,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6610), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416394] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6975), 1,
      sym_where,
    STATE(7153), 1,
      sym_group_by,
    STATE(7273), 1,
      sym_window_clause,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6425), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416466] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6952), 1,
      sym_where,
    STATE(7146), 1,
      sym_group_by,
    STATE(7288), 1,
      sym_window_clause,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6610), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416538] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6952), 1,
      sym_where,
    STATE(7146), 1,
      sym_group_by,
    STATE(7288), 1,
      sym_window_clause,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6417), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2368), 2,
      sym_keyword_no,
      sym_keyword_return,
    ACTIONS(2366), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_cycle,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [416650] = 4,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6513), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10896), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [416692] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6955), 1,
      sym_where,
    STATE(7085), 1,
      sym_group_by,
    STATE(7308), 1,
      sym_window_clause,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6610), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416764] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6955), 1,
      sym_where,
    STATE(7085), 1,
      sym_group_by,
    STATE(7308), 1,
      sym_window_clause,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6419), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416836] = 19,
    ACTIONS(9074), 1,
      sym_keyword_left,
    ACTIONS(9078), 1,
      sym_keyword_inner,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9082), 1,
      sym_keyword_join,
    ACTIONS(9084), 1,
      sym_keyword_natural,
    ACTIONS(9086), 1,
      sym_keyword_where,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(6950), 1,
      sym_where,
    STATE(7143), 1,
      sym_group_by,
    STATE(7335), 1,
      sym_window_clause,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9076), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6610), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10888), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [416908] = 4,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6503), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10900), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [416950] = 4,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6504), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10900), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [416992] = 9,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(10902), 1,
      sym_keyword_preceding,
    ACTIONS(10904), 1,
      sym_keyword_following,
    STATE(2674), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [417044] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6485), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6451), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417117] = 22,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10884), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [417194] = 14,
    ACTIONS(10943), 1,
      sym_keyword_primary,
    ACTIONS(10946), 1,
      sym_keyword_as,
    ACTIONS(10949), 1,
      sym_keyword_constraint,
    ACTIONS(10952), 1,
      sym_keyword_not,
    ACTIONS(10958), 1,
      sym_keyword_generated,
    ACTIONS(10961), 1,
      sym_keyword_default,
    ACTIONS(10964), 1,
      sym_keyword_references,
    ACTIONS(10967), 1,
      sym_keyword_check,
    ACTIONS(10970), 1,
      sym_keyword_comment,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10940), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(10955), 5,
      sym_keyword_auto_increment,
      sym_keyword_unique,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_null,
    ACTIONS(10938), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_first,
      sym_keyword_after,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(6431), 8,
      sym__not_null,
      sym__primary_key,
      sym_direction,
      sym__column_comment,
      sym__column_constraint,
      sym__check_constraint,
      sym__default_expression,
      aux_sym_column_definition_repeat1,
  [417255] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6512), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6469), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417328] = 22,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10973), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [417405] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6524), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6436), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417478] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6536), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6461), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417551] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6521), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417624] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7011), 1,
      sym_where,
    STATE(7218), 1,
      sym_group_by,
    STATE(7265), 1,
      sym_order_by,
    STATE(7459), 1,
      sym_window_clause,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6619), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10888), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [417695] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7012), 1,
      sym_where,
    STATE(7216), 1,
      sym_group_by,
    STATE(7400), 1,
      sym_order_by,
    STATE(7454), 1,
      sym_window_clause,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6437), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [417766] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7012), 1,
      sym_where,
    STATE(7216), 1,
      sym_group_by,
    STATE(7400), 1,
      sym_order_by,
    STATE(7454), 1,
      sym_window_clause,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6619), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [417837] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6495), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417910] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6491), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [417983] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7013), 1,
      sym_where,
    STATE(7214), 1,
      sym_group_by,
    STATE(7338), 1,
      sym_order_by,
    STATE(7453), 1,
      sym_window_clause,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6619), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [418054] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6495), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6450), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418127] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6552), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418200] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6511), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418273] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7013), 1,
      sym_where,
    STATE(7214), 1,
      sym_group_by,
    STATE(7338), 1,
      sym_order_by,
    STATE(7453), 1,
      sym_window_clause,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6439), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [418344] = 22,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10878), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [418421] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6515), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418494] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6538), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6458), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418567] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6479), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418640] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6481), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418713] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6509), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6466), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [418786] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7014), 1,
      sym_where,
    STATE(7210), 1,
      sym_group_by,
    STATE(7391), 1,
      sym_order_by,
    STATE(7451), 1,
      sym_window_clause,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6619), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [418857] = 4,
    ACTIONS(10979), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 5,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(55), 24,
      sym_keyword_set,
      sym_keyword_partition,
      sym_keyword_alter,
      sym_keyword_change,
      sym_keyword_modify,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_column,
      sym_keyword_as,
      sym_keyword_if,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_rename,
      sym_keyword_owner,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [418898] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9680), 1,
      sym_keyword_left,
    ACTIONS(9684), 1,
      sym_keyword_inner,
    ACTIONS(9686), 1,
      sym_keyword_join,
    ACTIONS(9688), 1,
      sym_keyword_natural,
    ACTIONS(9690), 1,
      sym_keyword_where,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7014), 1,
      sym_where,
    STATE(7210), 1,
      sym_group_by,
    STATE(7391), 1,
      sym_order_by,
    STATE(7451), 1,
      sym_window_clause,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9682), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6442), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [418969] = 22,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10868), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [419046] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6570), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6448), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419119] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6539), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419192] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6557), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419265] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6537), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6468), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419338] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6524), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419411] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6502), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6445), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419484] = 22,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10981), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [419561] = 14,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(10989), 1,
      sym_keyword_as,
    ACTIONS(10991), 1,
      sym_keyword_constraint,
    ACTIONS(10993), 1,
      sym_keyword_not,
    ACTIONS(10997), 1,
      sym_keyword_generated,
    ACTIONS(10999), 1,
      sym_keyword_default,
    ACTIONS(11001), 1,
      sym_keyword_references,
    ACTIONS(11003), 1,
      sym_keyword_check,
    ACTIONS(11005), 1,
      sym_keyword_comment,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10985), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(10995), 5,
      sym_keyword_auto_increment,
      sym_keyword_unique,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_null,
    ACTIONS(10983), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_first,
      sym_keyword_after,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(6473), 8,
      sym__not_null,
      sym__primary_key,
      sym_direction,
      sym__column_comment,
      sym__column_constraint,
      sym__check_constraint,
      sym__default_expression,
      aux_sym_column_definition_repeat1,
  [419622] = 22,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10672), 1,
      sym_keyword_partition,
    ACTIONS(10676), 1,
      sym_keyword_collate,
    ACTIONS(10678), 1,
      sym_keyword_engine,
    ACTIONS(10680), 1,
      sym_keyword_default,
    ACTIONS(10682), 1,
      sym_keyword_with,
    ACTIONS(10684), 1,
      sym_keyword_without,
    ACTIONS(10686), 1,
      sym_keyword_row,
    ACTIONS(10688), 1,
      sym_keyword_stored,
    ACTIONS(10690), 1,
      sym_keyword_tblproperties,
    ACTIONS(10692), 1,
      sym_keyword_location,
    ACTIONS(10694), 1,
      sym_keyword_partitioned,
    ACTIONS(10696), 1,
      sym_keyword_sort,
    ACTIONS(10828), 1,
      sym_keyword_as,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13113), 2,
      sym__literal_string,
      sym_identifier,
    STATE(5896), 9,
      sym__table_settings,
      sym_storage_parameters,
      sym_storage_location,
      sym_row_format,
      sym_table_sort,
      sym_table_partition,
      sym_stored_as,
      sym_table_option,
      aux_sym_create_table_repeat1,
  [419699] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6474), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419772] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6506), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6441), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419845] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6568), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419918] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6514), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [419991] = 20,
    ACTIONS(10906), 1,
      sym_keyword_as,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10910), 1,
      sym_keyword_begin,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    STATE(6514), 1,
      sym_function_body,
    STATE(13043), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6440), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420064] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6521), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6444), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420137] = 20,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10916), 1,
      sym_keyword_return,
    ACTIONS(10918), 1,
      sym_keyword_language,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10932), 1,
      sym_keyword_support,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(10975), 1,
      sym_keyword_as,
    ACTIONS(10977), 1,
      sym_keyword_begin,
    STATE(6532), 1,
      sym_function_body,
    STATE(13630), 1,
      sym__function_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6459), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420210] = 14,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(10989), 1,
      sym_keyword_as,
    ACTIONS(10991), 1,
      sym_keyword_constraint,
    ACTIONS(10993), 1,
      sym_keyword_not,
    ACTIONS(10997), 1,
      sym_keyword_generated,
    ACTIONS(10999), 1,
      sym_keyword_default,
    ACTIONS(11001), 1,
      sym_keyword_references,
    ACTIONS(11003), 1,
      sym_keyword_check,
    ACTIONS(11005), 1,
      sym_keyword_comment,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10985), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(11009), 5,
      sym_keyword_auto_increment,
      sym_keyword_unique,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_null,
    ACTIONS(11007), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_first,
      sym_keyword_after,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(6431), 8,
      sym__not_null,
      sym__primary_key,
      sym_direction,
      sym__column_comment,
      sym__column_constraint,
      sym__check_constraint,
      sym__default_expression,
      aux_sym_column_definition_repeat1,
  [420271] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11011), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6489), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420335] = 16,
    ACTIONS(11019), 1,
      sym_keyword_not,
    ACTIONS(11022), 1,
      sym_keyword_rows,
    ACTIONS(11025), 1,
      sym_keyword_returns,
    ACTIONS(11028), 1,
      sym_keyword_language,
    ACTIONS(11034), 1,
      sym_keyword_leakproof,
    ACTIONS(11037), 1,
      sym_keyword_parallel,
    ACTIONS(11040), 1,
      sym_keyword_called,
    ACTIONS(11043), 1,
      sym_keyword_strict,
    ACTIONS(11046), 1,
      sym_keyword_cost,
    ACTIONS(11049), 1,
      sym_keyword_support,
    ACTIONS(11052), 1,
      sym_keyword_security,
    ACTIONS(11055), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11031), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11017), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420399] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11058), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420463] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7155), 1,
      sym_where,
    STATE(7322), 1,
      sym_group_by,
    STATE(7511), 1,
      sym_order_by,
    STATE(7523), 1,
      sym_window_clause,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6638), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10888), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [420533] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11060), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420597] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11062), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6492), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420661] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11064), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420725] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11064), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6493), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420789] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11062), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420853] = 14,
    ACTIONS(11068), 1,
      sym_keyword_primary,
    ACTIONS(11070), 1,
      sym_keyword_as,
    ACTIONS(11072), 1,
      sym_keyword_constraint,
    ACTIONS(11074), 1,
      sym_keyword_not,
    ACTIONS(11078), 1,
      sym_keyword_generated,
    ACTIONS(11080), 1,
      sym_keyword_default,
    ACTIONS(11082), 1,
      sym_keyword_references,
    ACTIONS(11084), 1,
      sym_keyword_check,
    ACTIONS(11086), 1,
      sym_keyword_comment,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11066), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(11007), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_first,
      sym_keyword_after,
      anon_sym_COMMA,
    ACTIONS(11076), 5,
      sym_keyword_auto_increment,
      sym_keyword_unique,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_null,
    STATE(6488), 8,
      sym__not_null,
      sym__primary_key,
      sym_direction,
      sym__column_comment,
      sym__column_constraint,
      sym__check_constraint,
      sym__default_expression,
      aux_sym_column_definition_repeat1,
  [420913] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11088), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [420977] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11090), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6480), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421041] = 7,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    STATE(2175), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2804), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(2802), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [421087] = 4,
    ACTIONS(11094), 1,
      anon_sym_COMMA,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11092), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [421127] = 14,
    ACTIONS(11100), 1,
      sym_keyword_primary,
    ACTIONS(11103), 1,
      sym_keyword_as,
    ACTIONS(11106), 1,
      sym_keyword_constraint,
    ACTIONS(11109), 1,
      sym_keyword_not,
    ACTIONS(11115), 1,
      sym_keyword_generated,
    ACTIONS(11118), 1,
      sym_keyword_default,
    ACTIONS(11121), 1,
      sym_keyword_references,
    ACTIONS(11124), 1,
      sym_keyword_check,
    ACTIONS(11127), 1,
      sym_keyword_comment,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11097), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(10938), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_first,
      sym_keyword_after,
      anon_sym_COMMA,
    ACTIONS(11112), 5,
      sym_keyword_auto_increment,
      sym_keyword_unique,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_null,
    STATE(6488), 8,
      sym__not_null,
      sym__primary_key,
      sym_direction,
      sym__column_comment,
      sym__column_constraint,
      sym__check_constraint,
      sym__default_expression,
      aux_sym_column_definition_repeat1,
  [421187] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11130), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421251] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11060), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421315] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11088), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6478), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421379] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11132), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421443] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11134), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421507] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11088), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421571] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11058), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6482), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [421635] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7157), 1,
      sym_where,
    STATE(7326), 1,
      sym_group_by,
    STATE(7420), 1,
      sym_order_by,
    STATE(7522), 1,
      sym_window_clause,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6477), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [421705] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7157), 1,
      sym_where,
    STATE(7326), 1,
      sym_group_by,
    STATE(7420), 1,
      sym_order_by,
    STATE(7522), 1,
      sym_window_clause,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6638), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(10894), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [421775] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7158), 1,
      sym_where,
    STATE(7328), 1,
      sym_group_by,
    STATE(7442), 1,
      sym_order_by,
    STATE(7520), 1,
      sym_window_clause,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6638), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [421845] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7158), 1,
      sym_where,
    STATE(7328), 1,
      sym_group_by,
    STATE(7442), 1,
      sym_order_by,
    STATE(7520), 1,
      sym_window_clause,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6497), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8847), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [421915] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7159), 1,
      sym_where,
    STATE(7330), 1,
      sym_group_by,
    STATE(7476), 1,
      sym_order_by,
    STATE(7518), 1,
      sym_window_clause,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6638), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [421985] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10035), 1,
      sym_keyword_left,
    ACTIONS(10039), 1,
      sym_keyword_inner,
    ACTIONS(10041), 1,
      sym_keyword_join,
    ACTIONS(10043), 1,
      sym_keyword_natural,
    ACTIONS(10045), 1,
      sym_keyword_where,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7159), 1,
      sym_where,
    STATE(7330), 1,
      sym_group_by,
    STATE(7476), 1,
      sym_order_by,
    STATE(7518), 1,
      sym_window_clause,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10037), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6498), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [422055] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11136), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6484), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422119] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11138), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [422155] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11138), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [422191] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11011), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422255] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11136), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6494), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422319] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11140), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6475), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422383] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 5,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(2002), 24,
      sym_keyword_set,
      sym_keyword_partition,
      sym_keyword_alter,
      sym_keyword_change,
      sym_keyword_modify,
      sym_keyword_drop,
      sym_keyword_add,
      sym_keyword_column,
      sym_keyword_as,
      sym_keyword_if,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_rename,
      sym_keyword_owner,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [422421] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11142), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6505), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422485] = 14,
    ACTIONS(11068), 1,
      sym_keyword_primary,
    ACTIONS(11070), 1,
      sym_keyword_as,
    ACTIONS(11072), 1,
      sym_keyword_constraint,
    ACTIONS(11074), 1,
      sym_keyword_not,
    ACTIONS(11078), 1,
      sym_keyword_generated,
    ACTIONS(11080), 1,
      sym_keyword_default,
    ACTIONS(11082), 1,
      sym_keyword_references,
    ACTIONS(11084), 1,
      sym_keyword_check,
    ACTIONS(11086), 1,
      sym_keyword_comment,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11066), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(10983), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_first,
      sym_keyword_after,
      anon_sym_COMMA,
    ACTIONS(11144), 5,
      sym_keyword_auto_increment,
      sym_keyword_unique,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_null,
    STATE(6483), 8,
      sym__not_null,
      sym__primary_key,
      sym_direction,
      sym__column_comment,
      sym__column_constraint,
      sym__check_constraint,
      sym__default_expression,
      aux_sym_column_definition_repeat1,
  [422545] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11088), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6490), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422609] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11146), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6507), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422673] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11148), 29,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_using,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [422709] = 16,
    ACTIONS(10908), 1,
      sym_keyword_not,
    ACTIONS(10912), 1,
      sym_keyword_rows,
    ACTIONS(10914), 1,
      sym_keyword_returns,
    ACTIONS(10922), 1,
      sym_keyword_leakproof,
    ACTIONS(10924), 1,
      sym_keyword_parallel,
    ACTIONS(10926), 1,
      sym_keyword_called,
    ACTIONS(10928), 1,
      sym_keyword_strict,
    ACTIONS(10930), 1,
      sym_keyword_cost,
    ACTIONS(10934), 1,
      sym_keyword_security,
    ACTIONS(10936), 1,
      sym_keyword_external,
    ACTIONS(11013), 1,
      sym_keyword_language,
    ACTIONS(11015), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10920), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    ACTIONS(11140), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(6476), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422773] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11088), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6562), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422836] = 5,
    ACTIONS(11176), 1,
      aux_sym__single_quote_string_token2,
    STATE(6535), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1359), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [422877] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11088), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [422940] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11132), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423003] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9104), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423042] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9106), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423081] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11058), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6542), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423144] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8810), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423183] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11058), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423246] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11140), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6523), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423309] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11140), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423372] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9765), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423411] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9762), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423450] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9107), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423489] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9752), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423528] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9743), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423567] = 4,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6590), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10896), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [423606] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11090), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6554), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423669] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9735), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423708] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9689), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [423747] = 5,
    ACTIONS(11180), 1,
      aux_sym__single_quote_string_token2,
    STATE(6535), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1365), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [423788] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11146), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6525), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423851] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11136), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6566), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423914] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11142), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6556), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [423977] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11011), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6549), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424040] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(11187), 1,
      sym_keyword_as,
    STATE(6660), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(11183), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(11185), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [424085] = 3,
    ACTIONS(11191), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11189), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [424122] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11062), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424185] = 3,
    ACTIONS(11195), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11193), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [424222] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8783), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [424261] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9228), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [424300] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9229), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [424339] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11060), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424402] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8784), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [424441] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11130), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424504] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10880), 28,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [424539] = 5,
    ACTIONS(11197), 1,
      aux_sym__single_quote_string_token2,
    STATE(6516), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1353), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [424580] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11062), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6518), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424643] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8916), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [424682] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11064), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424745] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11134), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424808] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11011), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424871] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11064), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6555), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [424934] = 4,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6598), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10900), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [424973] = 4,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6597), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10900), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [425012] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10890), 28,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [425047] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8808), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [425086] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11060), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [425149] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8812), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [425188] = 4,
    ACTIONS(6783), 1,
      sym_keyword_over,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 22,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [425227] = 17,
    ACTIONS(11019), 1,
      sym_keyword_not,
    ACTIONS(11022), 1,
      sym_keyword_rows,
    ACTIONS(11025), 1,
      sym_keyword_returns,
    ACTIONS(11034), 1,
      sym_keyword_leakproof,
    ACTIONS(11037), 1,
      sym_keyword_parallel,
    ACTIONS(11040), 1,
      sym_keyword_called,
    ACTIONS(11043), 1,
      sym_keyword_strict,
    ACTIONS(11046), 1,
      sym_keyword_cost,
    ACTIONS(11052), 1,
      sym_keyword_security,
    ACTIONS(11055), 1,
      sym_keyword_external,
    ACTIONS(11199), 1,
      sym_keyword_return,
    ACTIONS(11201), 1,
      sym_keyword_language,
    ACTIONS(11204), 1,
      sym_keyword_support,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11017), 2,
      sym_keyword_as,
      sym_keyword_begin,
    ACTIONS(11031), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6565), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [425292] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11088), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [425355] = 3,
    ACTIONS(11209), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11207), 27,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_collate,
      sym_keyword_with,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [425392] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11088), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6547), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [425455] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11092), 28,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [425490] = 16,
    ACTIONS(11150), 1,
      sym_keyword_not,
    ACTIONS(11152), 1,
      sym_keyword_rows,
    ACTIONS(11154), 1,
      sym_keyword_returns,
    ACTIONS(11156), 1,
      sym_keyword_language,
    ACTIONS(11160), 1,
      sym_keyword_leakproof,
    ACTIONS(11162), 1,
      sym_keyword_parallel,
    ACTIONS(11164), 1,
      sym_keyword_called,
    ACTIONS(11166), 1,
      sym_keyword_strict,
    ACTIONS(11168), 1,
      sym_keyword_cost,
    ACTIONS(11170), 1,
      sym_keyword_support,
    ACTIONS(11172), 1,
      sym_keyword_security,
    ACTIONS(11174), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11136), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11158), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6517), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [425553] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8869), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_when,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [425592] = 16,
    ACTIONS(11211), 1,
      sym_keyword_not,
    ACTIONS(11214), 1,
      sym_keyword_rows,
    ACTIONS(11217), 1,
      sym_keyword_returns,
    ACTIONS(11220), 1,
      sym_keyword_language,
    ACTIONS(11226), 1,
      sym_keyword_leakproof,
    ACTIONS(11229), 1,
      sym_keyword_parallel,
    ACTIONS(11232), 1,
      sym_keyword_called,
    ACTIONS(11235), 1,
      sym_keyword_strict,
    ACTIONS(11238), 1,
      sym_keyword_cost,
    ACTIONS(11241), 1,
      sym_keyword_support,
    ACTIONS(11244), 1,
      sym_keyword_security,
    ACTIONS(11247), 1,
      sym_keyword_external,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11017), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    ACTIONS(11223), 3,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
    STATE(6572), 10,
      sym_function_language,
      sym_function_volatility,
      sym_function_leakproof,
      sym_function_security,
      sym_function_safety,
      sym_function_strictness,
      sym_function_cost,
      sym_function_rows,
      sym_function_support,
      aux_sym_create_function_repeat1,
  [425655] = 8,
    ACTIONS(2800), 1,
      sym_keyword_as,
    ACTIONS(11250), 1,
      sym_keyword_array,
    ACTIONS(11252), 1,
      anon_sym_LBRACK,
    STATE(286), 1,
      sym_array_size_definition,
    STATE(287), 1,
      sym__array_size_definition,
    STATE(6630), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [425701] = 5,
    ACTIONS(11254), 1,
      aux_sym__single_quote_string_token2,
    STATE(6574), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1365), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [425741] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7338), 1,
      sym_order_by,
    STATE(7408), 1,
      sym_where,
    STATE(7559), 1,
      sym_group_by,
    STATE(7585), 1,
      sym_limit,
    STATE(7845), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8847), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6754), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [425809] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7387), 1,
      sym_where,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    STATE(7578), 1,
      sym_group_by,
    STATE(7849), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6754), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [425877] = 5,
    ACTIONS(10902), 1,
      sym_keyword_preceding,
    ACTIONS(10904), 1,
      sym_keyword_following,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [425917] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7338), 1,
      sym_order_by,
    STATE(7408), 1,
      sym_where,
    STATE(7559), 1,
      sym_group_by,
    STATE(7585), 1,
      sym_limit,
    STATE(7845), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8847), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6589), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [425985] = 5,
    ACTIONS(11257), 1,
      sym_keyword_preceding,
    ACTIONS(11259), 1,
      sym_keyword_following,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3568), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3566), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [426025] = 7,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(11261), 1,
      sym_keyword_as,
    STATE(6755), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(11183), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(11185), 20,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [426069] = 8,
    ACTIONS(2772), 1,
      sym_keyword_as,
    ACTIONS(11250), 1,
      sym_keyword_array,
    ACTIONS(11252), 1,
      anon_sym_LBRACK,
    STATE(287), 1,
      sym__array_size_definition,
    STATE(289), 1,
      sym_array_size_definition,
    STATE(6630), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [426115] = 5,
    ACTIONS(11263), 1,
      aux_sym__single_quote_string_token2,
    STATE(6584), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1353), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [426155] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7265), 1,
      sym_order_by,
    STATE(7366), 1,
      sym_where,
    STATE(7545), 1,
      sym_group_by,
    STATE(7591), 1,
      sym_limit,
    STATE(7904), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(10888), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6754), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [426223] = 5,
    ACTIONS(11265), 1,
      aux_sym__single_quote_string_token2,
    STATE(6574), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1359), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [426263] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7387), 1,
      sym_where,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    STATE(7578), 1,
      sym_group_by,
    STATE(7849), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6575), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [426331] = 9,
    ACTIONS(11269), 1,
      sym_keyword_left,
    ACTIONS(11275), 1,
      sym_keyword_inner,
    ACTIONS(11278), 1,
      sym_keyword_cross,
    ACTIONS(11281), 1,
      sym_keyword_join,
    ACTIONS(11284), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11272), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6586), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(11267), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [426379] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7375), 1,
      sym_where,
    STATE(7400), 1,
      sym_order_by,
    STATE(7564), 1,
      sym_group_by,
    STATE(7593), 1,
      sym_limit,
    STATE(7888), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(10894), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6583), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [426447] = 4,
    ACTIONS(11287), 1,
      anon_sym_COMMA,
    STATE(6588), 1,
      aux_sym__mysql_update_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11092), 25,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [426485] = 19,
    ACTIONS(8855), 1,
      sym_keyword_cross,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10760), 1,
      sym_keyword_left,
    ACTIONS(10764), 1,
      sym_keyword_inner,
    ACTIONS(10766), 1,
      sym_keyword_join,
    ACTIONS(10768), 1,
      sym_keyword_natural,
    ACTIONS(10770), 1,
      sym_keyword_where,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7375), 1,
      sym_where,
    STATE(7400), 1,
      sym_order_by,
    STATE(7564), 1,
      sym_group_by,
    STATE(7593), 1,
      sym_limit,
    STATE(7888), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10762), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(10894), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
    STATE(6754), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [426553] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11148), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [426586] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11292), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11290), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [426621] = 8,
    ACTIONS(2800), 1,
      sym_keyword_as,
    ACTIONS(11294), 1,
      sym_keyword_array,
    ACTIONS(11296), 1,
      anon_sym_LBRACK,
    STATE(956), 1,
      sym_array_size_definition,
    STATE(1014), 1,
      sym__array_size_definition,
    STATE(6653), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [426666] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1372), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [426701] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7420), 1,
      sym_order_by,
    STATE(7486), 1,
      sym_where,
    STATE(7643), 1,
      sym_limit,
    STATE(7667), 1,
      sym_group_by,
    STATE(8081), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(10894), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6863), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [426768] = 4,
    ACTIONS(11298), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [426805] = 8,
    ACTIONS(2772), 1,
      sym_keyword_as,
    ACTIONS(11294), 1,
      sym_keyword_array,
    ACTIONS(11296), 1,
      anon_sym_LBRACK,
    STATE(1014), 1,
      sym__array_size_definition,
    STATE(1016), 1,
      sym_array_size_definition,
    STATE(6653), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [426850] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11138), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [426883] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11138), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [426916] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11092), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [426949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11302), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11300), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [426984] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11306), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11304), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [427019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11310), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11308), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [427054] = 4,
    ACTIONS(11312), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [427091] = 4,
    ACTIONS(11314), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [427128] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7493), 1,
      sym_where,
    STATE(7511), 1,
      sym_order_by,
    STATE(7669), 1,
      sym_group_by,
    STATE(7686), 1,
      sym_limit,
    STATE(8080), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(10888), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6863), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [427195] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_then,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [427230] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7301), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [427263] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(7338), 26,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_COMMA,
  [427296] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11318), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11316), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [427331] = 9,
    ACTIONS(11320), 1,
      sym_keyword_left,
    ACTIONS(11326), 1,
      sym_keyword_inner,
    ACTIONS(11329), 1,
      sym_keyword_cross,
    ACTIONS(11332), 1,
      sym_keyword_join,
    ACTIONS(11335), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11323), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6610), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(11267), 14,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [427378] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3604), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3602), 21,
      sym_keyword_then,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [427413] = 4,
    ACTIONS(11338), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3366), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_CARET,
    ACTIONS(3364), 20,
      sym_keyword_in,
      sym_keyword_and,
      sym_keyword_or,
      sym_keyword_is,
      sym_keyword_not,
      sym_keyword_between,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
      sym_keyword_similar,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_op_other,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_LT_GT,
  [427450] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7476), 1,
      sym_order_by,
    STATE(7482), 1,
      sym_where,
    STATE(7664), 1,
      sym_group_by,
    STATE(7707), 1,
      sym_limit,
    STATE(8087), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6616), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [427517] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7476), 1,
      sym_order_by,
    STATE(7482), 1,
      sym_where,
    STATE(7664), 1,
      sym_group_by,
    STATE(7707), 1,
      sym_limit,
    STATE(8087), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6863), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [427584] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7442), 1,
      sym_order_by,
    STATE(7484), 1,
      sym_where,
    STATE(7611), 1,
      sym_limit,
    STATE(7665), 1,
      sym_group_by,
    STATE(8085), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8847), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6594), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [427651] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7442), 1,
      sym_order_by,
    STATE(7484), 1,
      sym_where,
    STATE(7611), 1,
      sym_limit,
    STATE(7665), 1,
      sym_group_by,
    STATE(8085), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(8847), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6863), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [427718] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11342), 9,
      sym__dollar_quoted_string,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      sym_op_unary_other,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym__decimal_number_token1,
      aux_sym__bit_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11340), 17,
      sym_keyword_cast,
      sym_keyword_case,
      sym_keyword_not,
      sym_keyword_exists,
      sym_keyword_all,
      sym_keyword_any,
      sym_keyword_some,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
      sym_keyword_interval,
      sym_keyword_array,
      sym_parameter,
      anon_sym_DASH,
      aux_sym__integer_token1,
      sym_bang,
      sym__identifier,
  [427753] = 19,
    ACTIONS(9080), 1,
      sym_keyword_cross,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10850), 1,
      sym_keyword_left,
    ACTIONS(10854), 1,
      sym_keyword_inner,
    ACTIONS(10856), 1,
      sym_keyword_join,
    ACTIONS(10858), 1,
      sym_keyword_natural,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7420), 1,
      sym_order_by,
    STATE(7486), 1,
      sym_where,
    STATE(7643), 1,
      sym_limit,
    STATE(7667), 1,
      sym_group_by,
    STATE(8081), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10852), 2,
      sym_keyword_right,
      sym_keyword_full,
    ACTIONS(10894), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
    STATE(6605), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
  [427820] = 9,
    ACTIONS(11278), 1,
      sym_keyword_cross,
    ACTIONS(11344), 1,
      sym_keyword_left,
    ACTIONS(11350), 1,
      sym_keyword_inner,
    ACTIONS(11353), 1,
      sym_keyword_join,
    ACTIONS(11356), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11347), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6619), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(11267), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [427866] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11359), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [427898] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11361), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [427930] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11363), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [427962] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11365), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [427994] = 4,
    ACTIONS(55), 1,
      sym_keyword_as,
    ACTIONS(11367), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [428030] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1372), 19,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_cached,
      sym_keyword_uncached,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym_keyword_escaped,
      sym_keyword_lines,
      sym__identifier,
  [428064] = 24,
    ACTIONS(11371), 1,
      sym_keyword_table,
    ACTIONS(11373), 1,
      sym_keyword_view,
    ACTIONS(11375), 1,
      sym_keyword_materialized,
    ACTIONS(11377), 1,
      sym_keyword_sequence,
    ACTIONS(11379), 1,
      sym_keyword_constraint,
    ACTIONS(11381), 1,
      sym_keyword_or,
    ACTIONS(11383), 1,
      sym_keyword_index,
    ACTIONS(11385), 1,
      sym_keyword_type,
    ACTIONS(11387), 1,
      sym_keyword_database,
    ACTIONS(11389), 1,
      sym_keyword_schema,
    ACTIONS(11391), 1,
      sym_keyword_temp,
    ACTIONS(11393), 1,
      sym_keyword_temporary,
    ACTIONS(11395), 1,
      sym_keyword_unlogged,
    ACTIONS(11397), 1,
      sym_keyword_unique,
    ACTIONS(11399), 1,
      sym_keyword_recursive,
    ACTIONS(11401), 1,
      sym_keyword_extension,
    ACTIONS(11403), 1,
      sym_keyword_trigger,
    ACTIONS(11405), 1,
      sym_keyword_function,
    ACTIONS(11407), 1,
      sym_keyword_definer,
    ACTIONS(11409), 1,
      sym_keyword_external,
    STATE(7603), 1,
      sym__or_replace,
    STATE(9720), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11369), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [428140] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11411), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [428172] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1630), 25,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_merge,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_analyze,
      sym_keyword_explain,
      sym_keyword_drop,
      sym_keyword_end,
      sym_keyword_with,
      sym_keyword_rename,
      sym_keyword_reset,
      sym_keyword_commit,
      sym_keyword_rollback,
      sym_keyword_vacuum,
      sym_keyword_copy,
      sym_keyword_compute,
      sym_keyword_optimize,
      sym_keyword_comment,
      anon_sym_LPAREN,
  [428204] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11413), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [428236] = 6,
    ACTIONS(3230), 1,
      sym_keyword_as,
    ACTIONS(11252), 1,
      anon_sym_LBRACK,
    STATE(189), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(287), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [428276] = 24,
    ACTIONS(11381), 1,
      sym_keyword_or,
    ACTIONS(11417), 1,
      sym_keyword_table,
    ACTIONS(11419), 1,
      sym_keyword_view,
    ACTIONS(11421), 1,
      sym_keyword_materialized,
    ACTIONS(11423), 1,
      sym_keyword_sequence,
    ACTIONS(11425), 1,
      sym_keyword_constraint,
    ACTIONS(11427), 1,
      sym_keyword_index,
    ACTIONS(11429), 1,
      sym_keyword_type,
    ACTIONS(11431), 1,
      sym_keyword_database,
    ACTIONS(11433), 1,
      sym_keyword_schema,
    ACTIONS(11435), 1,
      sym_keyword_temp,
    ACTIONS(11437), 1,
      sym_keyword_temporary,
    ACTIONS(11439), 1,
      sym_keyword_unlogged,
    ACTIONS(11441), 1,
      sym_keyword_unique,
    ACTIONS(11443), 1,
      sym_keyword_recursive,
    ACTIONS(11445), 1,
      sym_keyword_extension,
    ACTIONS(11447), 1,
      sym_keyword_trigger,
    ACTIONS(11449), 1,
      sym_keyword_function,
    ACTIONS(11451), 1,
      sym_keyword_definer,
    ACTIONS(11453), 1,
      sym_keyword_external,
    STATE(7675), 1,
      sym__or_replace,
    STATE(9975), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11415), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [428352] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11455), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [428384] = 24,
    ACTIONS(11381), 1,
      sym_keyword_or,
    ACTIONS(11419), 1,
      sym_keyword_view,
    ACTIONS(11421), 1,
      sym_keyword_materialized,
    ACTIONS(11423), 1,
      sym_keyword_sequence,
    ACTIONS(11425), 1,
      sym_keyword_constraint,
    ACTIONS(11429), 1,
      sym_keyword_type,
    ACTIONS(11431), 1,
      sym_keyword_database,
    ACTIONS(11433), 1,
      sym_keyword_schema,
    ACTIONS(11435), 1,
      sym_keyword_temp,
    ACTIONS(11437), 1,
      sym_keyword_temporary,
    ACTIONS(11443), 1,
      sym_keyword_recursive,
    ACTIONS(11445), 1,
      sym_keyword_extension,
    ACTIONS(11447), 1,
      sym_keyword_trigger,
    ACTIONS(11449), 1,
      sym_keyword_function,
    ACTIONS(11451), 1,
      sym_keyword_definer,
    ACTIONS(11457), 1,
      sym_keyword_table,
    ACTIONS(11459), 1,
      sym_keyword_index,
    ACTIONS(11461), 1,
      sym_keyword_unlogged,
    ACTIONS(11463), 1,
      sym_keyword_unique,
    ACTIONS(11465), 1,
      sym_keyword_external,
    STATE(7675), 1,
      sym__or_replace,
    STATE(9916), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11415), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [428460] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11467), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_set,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_using,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [428492] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1552), 24,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_merge,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_analyze,
      sym_keyword_explain,
      sym_keyword_drop,
      sym_keyword_end,
      sym_keyword_with,
      sym_keyword_rename,
      sym_keyword_reset,
      sym_keyword_vacuum,
      sym_keyword_copy,
      sym_keyword_return,
      sym_keyword_compute,
      sym_keyword_optimize,
      sym_keyword_comment,
      anon_sym_LPAREN,
  [428523] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(9300), 1,
      sym_identifier,
    STATE(10775), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(11469), 3,
      sym_keyword_on,
      sym_keyword_off,
      sym_keyword_default,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [428584] = 4,
    ACTIONS(55), 1,
      sym_keyword_as,
    ACTIONS(11471), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_COMMA,
  [428619] = 9,
    ACTIONS(11329), 1,
      sym_keyword_cross,
    ACTIONS(11473), 1,
      sym_keyword_left,
    ACTIONS(11479), 1,
      sym_keyword_inner,
    ACTIONS(11482), 1,
      sym_keyword_join,
    ACTIONS(11485), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11476), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6638), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(11267), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [428664] = 5,
    ACTIONS(11490), 1,
      sym_keyword_on,
    ACTIONS(11492), 1,
      sym_keyword_as,
    STATE(6645), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11488), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [428701] = 5,
    ACTIONS(3426), 1,
      sym_keyword_as,
    ACTIONS(11252), 1,
      anon_sym_LBRACK,
    STATE(290), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [428738] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1402), 24,
      ts_builtin_sym_end,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_merge,
      sym_keyword_set,
      sym_keyword_create,
      sym_keyword_alter,
      sym_keyword_analyze,
      sym_keyword_explain,
      sym_keyword_drop,
      sym_keyword_with,
      sym_keyword_rename,
      sym_keyword_reset,
      sym_keyword_begin,
      sym_keyword_vacuum,
      sym_keyword_copy,
      sym_keyword_compute,
      sym_keyword_optimize,
      sym_keyword_comment,
      anon_sym_LPAREN,
  [428769] = 17,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(9986), 1,
      sym_identifier,
    STATE(11327), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(11494), 3,
      sym_keyword_on,
      sym_keyword_off,
      sym_keyword_default,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [428830] = 5,
    ACTIONS(11490), 1,
      sym_keyword_on,
    ACTIONS(11498), 1,
      sym_keyword_as,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11496), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [428867] = 17,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(9861), 1,
      sym_identifier,
    STATE(11358), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(11500), 3,
      sym_keyword_on,
      sym_keyword_off,
      sym_keyword_default,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [428928] = 5,
    ACTIONS(11490), 1,
      sym_keyword_on,
    ACTIONS(11504), 1,
      sym_keyword_as,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11502), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [428965] = 5,
    ACTIONS(11490), 1,
      sym_keyword_on,
    ACTIONS(11504), 1,
      sym_keyword_as,
    STATE(6643), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11502), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [429002] = 5,
    ACTIONS(11510), 1,
      sym_keyword_fields,
    ACTIONS(11512), 1,
      sym_keyword_lines,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11506), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11508), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [429039] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8995), 1,
      sym_identifier,
    STATE(10417), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(11514), 3,
      sym_keyword_on,
      sym_keyword_off,
      sym_keyword_default,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [429100] = 5,
    ACTIONS(11520), 1,
      aux_sym_keyword_character_token1,
    STATE(12076), 1,
      sym_keyword_character,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11516), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11518), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [429137] = 5,
    ACTIONS(11526), 1,
      sym_keyword_escaped,
    ACTIONS(11528), 1,
      sym_keyword_lines,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11522), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11524), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [429174] = 4,
    ACTIONS(11532), 1,
      sym_keyword_as,
    ACTIONS(11534), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11530), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [429209] = 5,
    ACTIONS(11538), 1,
      sym_keyword_on,
    ACTIONS(11541), 1,
      sym_keyword_as,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11536), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [429246] = 6,
    ACTIONS(3230), 1,
      sym_keyword_as,
    ACTIONS(11296), 1,
      anon_sym_LBRACK,
    STATE(752), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(1014), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [429285] = 19,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    STATE(13979), 1,
      sym__dml_read,
    STATE(14044), 1,
      sym__dml_write,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [429349] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(12050), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [429411] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11545), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [429441] = 4,
    ACTIONS(11551), 1,
      sym_keyword_cached,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11547), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11549), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [429475] = 5,
    ACTIONS(3426), 1,
      sym_keyword_as,
    ACTIONS(11296), 1,
      anon_sym_LBRACK,
    STATE(943), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [429511] = 5,
    ACTIONS(11498), 1,
      sym_keyword_as,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11496), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [429547] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11555), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [429577] = 5,
    ACTIONS(11504), 1,
      sym_keyword_as,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11502), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [429613] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(13915), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [429675] = 4,
    ACTIONS(11561), 1,
      sym_keyword_lines,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11557), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11559), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [429709] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(13917), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [429771] = 3,
    ACTIONS(11565), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11563), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [429803] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(14042), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [429865] = 5,
    ACTIONS(11520), 1,
      aux_sym_keyword_character_token1,
    STATE(13636), 1,
      sym_keyword_character,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11516), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11518), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [429901] = 5,
    ACTIONS(11504), 1,
      sym_keyword_as,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6659), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11502), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [429937] = 19,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    STATE(14082), 1,
      sym__dml_read,
    STATE(14140), 1,
      sym__dml_write,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [430001] = 5,
    ACTIONS(11492), 1,
      sym_keyword_as,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6661), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11488), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [430037] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(12985), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [430099] = 3,
    ACTIONS(11532), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11530), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [430131] = 5,
    ACTIONS(11541), 1,
      sym_keyword_as,
    ACTIONS(11567), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11536), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [430167] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(14138), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [430229] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10417), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11514), 2,
      sym_keyword_default,
      sym_keyword_local,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [430289] = 3,
    ACTIONS(11572), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11570), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [430321] = 5,
    ACTIONS(11574), 1,
      sym_keyword_fields,
    ACTIONS(11576), 1,
      sym_keyword_lines,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11506), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11508), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [430357] = 19,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    STATE(14240), 1,
      sym__dml_write,
    STATE(14241), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [430421] = 5,
    ACTIONS(11582), 1,
      sym_keyword_with,
    ACTIONS(11584), 1,
      sym_keyword_uncached,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11578), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11580), 14,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [430457] = 3,
    ACTIONS(11588), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11586), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [430489] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10775), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11469), 2,
      sym_keyword_default,
      sym_keyword_local,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [430549] = 3,
    ACTIONS(11592), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11590), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [430581] = 4,
    ACTIONS(11532), 1,
      sym_keyword_as,
    ACTIONS(11594), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11530), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [430615] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(13387), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [430677] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11596), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [430707] = 5,
    ACTIONS(11598), 1,
      sym_keyword_escaped,
    ACTIONS(11600), 1,
      sym_keyword_lines,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11522), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11524), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [430743] = 23,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1668), 1,
      sym_keyword_primary,
    ACTIONS(1670), 1,
      sym_keyword_key,
    ACTIONS(1672), 1,
      sym_keyword_constraint,
    ACTIONS(1674), 1,
      sym_keyword_index,
    ACTIONS(1676), 1,
      sym_keyword_unique,
    ACTIONS(1678), 1,
      sym_keyword_foreign,
    ACTIONS(1680), 1,
      sym_keyword_check,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(9965), 1,
      sym__constraint_literal,
    STATE(9966), 1,
      sym__key_constraint,
    STATE(10388), 1,
      sym_constraint,
    STATE(11922), 1,
      sym_column_definition,
    STATE(11974), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9955), 2,
      sym__check_constraint,
      sym__primary_key_constraint,
  [430815] = 18,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(6893), 1,
      sym__cte,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(14041), 2,
      sym__dml_write,
      sym__dml_read,
    STATE(10658), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [430877] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(11327), 1,
      sym_literal,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11494), 2,
      sym_keyword_default,
      sym_keyword_local,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [430937] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(11358), 1,
      sym_literal,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11500), 2,
      sym_keyword_default,
      sym_keyword_local,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [430997] = 3,
    ACTIONS(11604), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11602), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431028] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11359), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [431057] = 3,
    ACTIONS(11608), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11606), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431088] = 3,
    ACTIONS(11612), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11610), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431119] = 3,
    ACTIONS(11616), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11614), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431150] = 3,
    ACTIONS(11620), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11618), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431181] = 3,
    ACTIONS(11624), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11622), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431212] = 3,
    ACTIONS(11628), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11626), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431243] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11630), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11632), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11634), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11636), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431305] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11413), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [431334] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11638), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11640), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431365] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(11642), 1,
      sym_keyword_no,
    ACTIONS(11646), 1,
      anon_sym_PLUS,
    ACTIONS(11648), 1,
      anon_sym_DASH,
    ACTIONS(11650), 1,
      sym__double_quote_string,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(11654), 1,
      aux_sym__integer_token1,
    ACTIONS(11656), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11658), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11660), 1,
      sym__dollar_quoted_string,
    STATE(7247), 1,
      sym__single_quote_string,
    STATE(7490), 1,
      sym_literal,
    STATE(11799), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11644), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7251), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [431424] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(11646), 1,
      anon_sym_PLUS,
    ACTIONS(11648), 1,
      anon_sym_DASH,
    ACTIONS(11650), 1,
      sym__double_quote_string,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(11654), 1,
      aux_sym__integer_token1,
    ACTIONS(11656), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11658), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11660), 1,
      sym__dollar_quoted_string,
    ACTIONS(11662), 1,
      sym_keyword_no,
    STATE(7247), 1,
      sym__single_quote_string,
    STATE(7490), 1,
      sym_literal,
    STATE(11799), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11644), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7251), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [431483] = 4,
    ACTIONS(11664), 1,
      sym_keyword_lines,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11557), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11559), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431516] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11666), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11668), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431547] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(11646), 1,
      anon_sym_PLUS,
    ACTIONS(11648), 1,
      anon_sym_DASH,
    ACTIONS(11650), 1,
      sym__double_quote_string,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(11654), 1,
      aux_sym__integer_token1,
    ACTIONS(11656), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11658), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11660), 1,
      sym__dollar_quoted_string,
    ACTIONS(11670), 1,
      sym_keyword_by,
    STATE(7247), 1,
      sym__single_quote_string,
    STATE(7505), 1,
      sym_literal,
    STATE(11799), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11644), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7251), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [431606] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(11646), 1,
      anon_sym_PLUS,
    ACTIONS(11648), 1,
      anon_sym_DASH,
    ACTIONS(11650), 1,
      sym__double_quote_string,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(11654), 1,
      aux_sym__integer_token1,
    ACTIONS(11656), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11658), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11660), 1,
      sym__dollar_quoted_string,
    ACTIONS(11672), 1,
      sym_keyword_no,
    STATE(7247), 1,
      sym__single_quote_string,
    STATE(7505), 1,
      sym_literal,
    STATE(11799), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11644), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7251), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [431665] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(11646), 1,
      anon_sym_PLUS,
    ACTIONS(11648), 1,
      anon_sym_DASH,
    ACTIONS(11650), 1,
      sym__double_quote_string,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(11654), 1,
      aux_sym__integer_token1,
    ACTIONS(11656), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11658), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11660), 1,
      sym__dollar_quoted_string,
    ACTIONS(11674), 1,
      sym_keyword_no,
    STATE(7247), 1,
      sym__single_quote_string,
    STATE(7505), 1,
      sym_literal,
    STATE(11799), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11644), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7251), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [431724] = 3,
    ACTIONS(11678), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11676), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431755] = 3,
    ACTIONS(11682), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11680), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431786] = 5,
    ACTIONS(11684), 1,
      sym_keyword_with,
    ACTIONS(11686), 1,
      sym_keyword_uncached,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11578), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11580), 14,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431821] = 3,
    ACTIONS(11690), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11688), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [431852] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11692), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11694), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11696), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11698), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431914] = 3,
    ACTIONS(11702), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11700), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [431945] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11704), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11706), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [431976] = 4,
    ACTIONS(11708), 1,
      sym_keyword_cached,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11547), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11549), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432009] = 3,
    ACTIONS(11565), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11563), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [432040] = 3,
    ACTIONS(11712), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11710), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [432071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11714), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11716), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432102] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(11718), 1,
      sym_keyword_default,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(9310), 1,
      sym_identifier,
    STATE(10791), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [432161] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11411), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [432190] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11720), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11722), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432221] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11724), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11726), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432252] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11728), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11730), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11732), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11734), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432314] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11193), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11195), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432345] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11736), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11738), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11740), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11742), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11744), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11746), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432438] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11189), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11191), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1372), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432500] = 3,
    ACTIONS(11750), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11748), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [432531] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(11752), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(14351), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [432590] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11754), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11756), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11758), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11760), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432652] = 3,
    ACTIONS(11764), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11762), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [432683] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11766), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11768), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11770), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11772), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432745] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11774), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11776), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432776] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11455), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [432805] = 3,
    ACTIONS(11780), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11778), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [432836] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11545), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [432865] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11207), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11209), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432896] = 17,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    ACTIONS(11782), 1,
      sym_keyword_default,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(10141), 1,
      sym_identifier,
    STATE(11283), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [432955] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11784), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11786), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [432986] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(11788), 1,
      sym_keyword_no,
    ACTIONS(11792), 1,
      anon_sym_PLUS,
    ACTIONS(11794), 1,
      anon_sym_DASH,
    ACTIONS(11796), 1,
      sym__double_quote_string,
    ACTIONS(11798), 1,
      aux_sym__integer_token1,
    ACTIONS(11800), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11802), 1,
      aux_sym__bit_string_token1,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(7284), 1,
      sym_literal,
    STATE(11372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11790), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7176), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [433045] = 3,
    ACTIONS(11806), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11804), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [433076] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(11792), 1,
      anon_sym_PLUS,
    ACTIONS(11794), 1,
      anon_sym_DASH,
    ACTIONS(11796), 1,
      sym__double_quote_string,
    ACTIONS(11798), 1,
      aux_sym__integer_token1,
    ACTIONS(11800), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11802), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11808), 1,
      sym_keyword_no,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(7284), 1,
      sym_literal,
    STATE(11372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11790), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7176), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [433135] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(11792), 1,
      anon_sym_PLUS,
    ACTIONS(11794), 1,
      anon_sym_DASH,
    ACTIONS(11796), 1,
      sym__double_quote_string,
    ACTIONS(11798), 1,
      aux_sym__integer_token1,
    ACTIONS(11800), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11802), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11810), 1,
      sym_keyword_by,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(7346), 1,
      sym_literal,
    STATE(11372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11790), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7176), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [433194] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(11792), 1,
      anon_sym_PLUS,
    ACTIONS(11794), 1,
      anon_sym_DASH,
    ACTIONS(11796), 1,
      sym__double_quote_string,
    ACTIONS(11798), 1,
      aux_sym__integer_token1,
    ACTIONS(11800), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11802), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11812), 1,
      sym_keyword_no,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(7346), 1,
      sym_literal,
    STATE(11372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11790), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7176), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [433253] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(11792), 1,
      anon_sym_PLUS,
    ACTIONS(11794), 1,
      anon_sym_DASH,
    ACTIONS(11796), 1,
      sym__double_quote_string,
    ACTIONS(11798), 1,
      aux_sym__integer_token1,
    ACTIONS(11800), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11802), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11814), 1,
      sym_keyword_no,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(7346), 1,
      sym_literal,
    STATE(11372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11790), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7176), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [433312] = 9,
    ACTIONS(11278), 1,
      sym_keyword_cross,
    ACTIONS(11816), 1,
      sym_keyword_left,
    ACTIONS(11822), 1,
      sym_keyword_inner,
    ACTIONS(11825), 1,
      sym_keyword_join,
    ACTIONS(11828), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11819), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6754), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(11267), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [433355] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11555), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [433384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11831), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11833), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433415] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11363), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [433444] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11596), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [433473] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11835), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11837), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11839), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(11841), 16,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_or,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym_keyword_immediate,
      sym_keyword_deferred,
      sym__identifier,
  [433535] = 3,
    ACTIONS(11845), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11843), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [433566] = 3,
    ACTIONS(11849), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11847), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [433597] = 3,
    ACTIONS(11853), 1,
      sym_keyword_return,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11851), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [433628] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11855), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11857), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433659] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11365), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [433688] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11859), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11861), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433719] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11863), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11865), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11867), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11869), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433781] = 3,
    ACTIONS(11873), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11871), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [433812] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11875), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11877), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433843] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11879), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11881), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [433874] = 3,
    ACTIONS(11592), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11590), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [433905] = 3,
    ACTIONS(11588), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11586), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [433936] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11467), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [433965] = 3,
    ACTIONS(11532), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11530), 21,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [433996] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11883), 7,
      sym__dollar_quoted_string,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11885), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [434027] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11361), 22,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_inner,
      sym_keyword_full,
      sym_keyword_cross,
      sym_keyword_join,
      sym_keyword_natural,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [434056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11770), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11772), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [434086] = 16,
    ACTIONS(1121), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11899), 1,
      sym_keyword_float,
    ACTIONS(11901), 1,
      sym_keyword_double,
    STATE(4970), 1,
      sym_keyword_real,
    STATE(4971), 1,
      sym_keyword_bigint,
    STATE(4972), 1,
      sym_keyword_int,
    STATE(4973), 1,
      sym_keyword_mediumint,
    STATE(4974), 1,
      sym_keyword_smallint,
    STATE(4975), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11887), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11889), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11891), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11893), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11895), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11897), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434142] = 16,
    ACTIONS(1253), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11915), 1,
      sym_keyword_float,
    ACTIONS(11917), 1,
      sym_keyword_double,
    STATE(7042), 1,
      sym_keyword_real,
    STATE(7043), 1,
      sym_keyword_bigint,
    STATE(7044), 1,
      sym_keyword_int,
    STATE(7046), 1,
      sym_keyword_mediumint,
    STATE(7048), 1,
      sym_keyword_smallint,
    STATE(7049), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11903), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11905), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11907), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11909), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11911), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11913), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434198] = 16,
    ACTIONS(663), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11931), 1,
      sym_keyword_float,
    ACTIONS(11933), 1,
      sym_keyword_double,
    STATE(3716), 1,
      sym_keyword_tinyint,
    STATE(3720), 1,
      sym_keyword_smallint,
    STATE(3727), 1,
      sym_keyword_mediumint,
    STATE(3729), 1,
      sym_keyword_int,
    STATE(3739), 1,
      sym_keyword_bigint,
    STATE(3743), 1,
      sym_keyword_real,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11919), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11921), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11923), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11925), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11927), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11929), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434254] = 16,
    ACTIONS(727), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11947), 1,
      sym_keyword_float,
    ACTIONS(11949), 1,
      sym_keyword_double,
    STATE(681), 1,
      sym_keyword_int,
    STATE(682), 1,
      sym_keyword_bigint,
    STATE(688), 1,
      sym_keyword_mediumint,
    STATE(720), 1,
      sym_keyword_smallint,
    STATE(756), 1,
      sym_keyword_tinyint,
    STATE(786), 1,
      sym_keyword_real,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11935), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11937), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11939), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11941), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11943), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11945), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11634), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11636), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [434340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11714), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11716), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [434370] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(14096), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [434426] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(11841), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [434482] = 16,
    ACTIONS(159), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11963), 1,
      sym_keyword_float,
    ACTIONS(11965), 1,
      sym_keyword_double,
    STATE(5836), 1,
      sym_keyword_real,
    STATE(5840), 1,
      sym_keyword_bigint,
    STATE(5850), 1,
      sym_keyword_int,
    STATE(5859), 1,
      sym_keyword_mediumint,
    STATE(5860), 1,
      sym_keyword_smallint,
    STATE(5861), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11951), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11953), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11955), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11957), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11959), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11961), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434538] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(13296), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [434594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11875), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11877), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [434624] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10850), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [434680] = 16,
    ACTIONS(925), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11979), 1,
      sym_keyword_float,
    ACTIONS(11981), 1,
      sym_keyword_double,
    STATE(2053), 1,
      sym_keyword_real,
    STATE(2054), 1,
      sym_keyword_bigint,
    STATE(2059), 1,
      sym_keyword_int,
    STATE(2062), 1,
      sym_keyword_mediumint,
    STATE(2063), 1,
      sym_keyword_smallint,
    STATE(2064), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11967), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11969), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11971), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11973), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11975), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11977), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434736] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11010), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [434792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11855), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11857), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [434822] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(11840), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [434878] = 3,
    ACTIONS(11780), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11778), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [434908] = 16,
    ACTIONS(363), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(11995), 1,
      sym_keyword_float,
    ACTIONS(11997), 1,
      sym_keyword_double,
    STATE(2790), 1,
      sym_keyword_smallint,
    STATE(2794), 1,
      sym_keyword_mediumint,
    STATE(2795), 1,
      sym_keyword_int,
    STATE(2796), 1,
      sym_keyword_bigint,
    STATE(2816), 1,
      sym_keyword_real,
    STATE(2840), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11983), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(11985), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(11987), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(11989), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(11991), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(11993), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [434964] = 3,
    ACTIONS(11764), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11762), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [434994] = 3,
    ACTIONS(11806), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11804), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [435024] = 3,
    ACTIONS(11845), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11843), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [435054] = 16,
    ACTIONS(603), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12011), 1,
      sym_keyword_float,
    ACTIONS(12013), 1,
      sym_keyword_double,
    STATE(3428), 1,
      sym_keyword_real,
    STATE(3429), 1,
      sym_keyword_bigint,
    STATE(3430), 1,
      sym_keyword_int,
    STATE(3436), 1,
      sym_keyword_mediumint,
    STATE(3447), 1,
      sym_keyword_smallint,
    STATE(3455), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11999), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12001), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12003), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12005), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12007), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12009), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [435110] = 16,
    ACTIONS(423), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12027), 1,
      sym_keyword_float,
    ACTIONS(12029), 1,
      sym_keyword_double,
    STATE(5363), 1,
      sym_keyword_tinyint,
    STATE(5366), 1,
      sym_keyword_smallint,
    STATE(5367), 1,
      sym_keyword_mediumint,
    STATE(5368), 1,
      sym_keyword_int,
    STATE(5369), 1,
      sym_keyword_bigint,
    STATE(5370), 1,
      sym_keyword_real,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12015), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12017), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12019), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12021), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12023), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12025), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [435166] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11863), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11865), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435196] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8231), 1,
      sym_identifier,
    STATE(13296), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [435252] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11774), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11776), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11189), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11191), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435312] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(7367), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [435368] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11728), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11730), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435398] = 16,
    ACTIONS(1317), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12043), 1,
      sym_keyword_float,
    ACTIONS(12045), 1,
      sym_keyword_double,
    STATE(3171), 1,
      sym_keyword_real,
    STATE(3172), 1,
      sym_keyword_bigint,
    STATE(3190), 1,
      sym_keyword_int,
    STATE(3191), 1,
      sym_keyword_mediumint,
    STATE(3192), 1,
      sym_keyword_smallint,
    STATE(3193), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12031), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12033), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12035), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12037), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12039), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12041), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [435454] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(7466), 1,
      sym_literal,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [435510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11859), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11861), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435540] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11692), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11694), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435570] = 4,
    ACTIONS(55), 1,
      sym_keyword_return,
    ACTIONS(12047), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 19,
      sym_keyword_as,
      sym_keyword_not,
      sym_keyword_begin,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      sym_keyword_array,
      anon_sym_LBRACK,
  [435602] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11784), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11786), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11666), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11668), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435662] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11736), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11738), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435692] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11754), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11756), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [435722] = 16,
    ACTIONS(865), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12061), 1,
      sym_keyword_float,
    ACTIONS(12063), 1,
      sym_keyword_double,
    STATE(5447), 1,
      sym_keyword_tinyint,
    STATE(5449), 1,
      sym_keyword_smallint,
    STATE(5451), 1,
      sym_keyword_mediumint,
    STATE(5456), 1,
      sym_keyword_int,
    STATE(5458), 1,
      sym_keyword_bigint,
    STATE(5460), 1,
      sym_keyword_real,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12049), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12051), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12053), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12055), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12057), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12059), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [435778] = 3,
    ACTIONS(11572), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11570), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [435808] = 3,
    ACTIONS(11873), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11871), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [435838] = 16,
    ACTIONS(801), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12077), 1,
      sym_keyword_float,
    ACTIONS(12079), 1,
      sym_keyword_double,
    STATE(5078), 1,
      sym_keyword_real,
    STATE(5079), 1,
      sym_keyword_bigint,
    STATE(5080), 1,
      sym_keyword_int,
    STATE(5081), 1,
      sym_keyword_mediumint,
    STATE(5082), 1,
      sym_keyword_smallint,
    STATE(5083), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12065), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12067), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12069), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12071), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12073), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12075), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [435894] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(11358), 1,
      sym_literal,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [435950] = 16,
    ACTIONS(543), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12093), 1,
      sym_keyword_float,
    ACTIONS(12095), 1,
      sym_keyword_double,
    STATE(3995), 1,
      sym_keyword_real,
    STATE(3996), 1,
      sym_keyword_bigint,
    STATE(3997), 1,
      sym_keyword_int,
    STATE(3998), 1,
      sym_keyword_mediumint,
    STATE(3999), 1,
      sym_keyword_smallint,
    STATE(4000), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12081), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12083), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12085), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12087), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12089), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12091), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [436006] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11831), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11833), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436036] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11724), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11726), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436066] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11758), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11760), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436096] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11207), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11209), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436126] = 16,
    ACTIONS(1057), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12109), 1,
      sym_keyword_float,
    ACTIONS(12111), 1,
      sym_keyword_double,
    STATE(5793), 1,
      sym_keyword_real,
    STATE(5797), 1,
      sym_keyword_bigint,
    STATE(5799), 1,
      sym_keyword_int,
    STATE(5801), 1,
      sym_keyword_mediumint,
    STATE(5806), 1,
      sym_keyword_smallint,
    STATE(5808), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12097), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12099), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12101), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12103), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12105), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12107), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [436182] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(11373), 1,
      sym_literal,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436238] = 3,
    ACTIONS(11849), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11847), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [436268] = 16,
    ACTIONS(483), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12125), 1,
      sym_keyword_float,
    ACTIONS(12127), 1,
      sym_keyword_double,
    STATE(2314), 1,
      sym_keyword_tinyint,
    STATE(2318), 1,
      sym_keyword_smallint,
    STATE(2321), 1,
      sym_keyword_mediumint,
    STATE(2322), 1,
      sym_keyword_int,
    STATE(2324), 1,
      sym_keyword_bigint,
    STATE(2326), 1,
      sym_keyword_real,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12113), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12115), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12117), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12119), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12121), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12123), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [436324] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1372), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11883), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11885), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11732), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11734), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436414] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(11646), 1,
      anon_sym_PLUS,
    ACTIONS(11648), 1,
      anon_sym_DASH,
    ACTIONS(11650), 1,
      sym__double_quote_string,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(11654), 1,
      aux_sym__integer_token1,
    ACTIONS(11656), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11658), 1,
      aux_sym__bit_string_token1,
    ACTIONS(11660), 1,
      sym__dollar_quoted_string,
    STATE(7247), 1,
      sym__single_quote_string,
    STATE(7450), 1,
      sym_literal,
    STATE(11799), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11644), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7251), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436470] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11835), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11837), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436500] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11879), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11881), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436530] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(11792), 1,
      anon_sym_PLUS,
    ACTIONS(11794), 1,
      anon_sym_DASH,
    ACTIONS(11796), 1,
      sym__double_quote_string,
    ACTIONS(11798), 1,
      aux_sym__integer_token1,
    ACTIONS(11800), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(11802), 1,
      aux_sym__bit_string_token1,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(7327), 1,
      sym_literal,
    STATE(11372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11790), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(7176), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436586] = 16,
    ACTIONS(79), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12141), 1,
      sym_keyword_float,
    ACTIONS(12143), 1,
      sym_keyword_double,
    STATE(2106), 1,
      sym_keyword_real,
    STATE(2108), 1,
      sym_keyword_bigint,
    STATE(2113), 1,
      sym_keyword_int,
    STATE(2118), 1,
      sym_keyword_mediumint,
    STATE(2121), 1,
      sym_keyword_smallint,
    STATE(2137), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12129), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12131), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12133), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12135), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12137), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12139), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [436642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11740), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11742), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436672] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11766), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11768), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436702] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10834), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436758] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11744), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11746), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [436788] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10756), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436844] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10684), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436900] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11545), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [436956] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11543), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437012] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8304), 1,
      sym_identifier,
    STATE(14096), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437068] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(7595), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437124] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11193), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11195), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437154] = 16,
    ACTIONS(303), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12157), 1,
      sym_keyword_float,
    ACTIONS(12159), 1,
      sym_keyword_double,
    STATE(193), 1,
      sym_keyword_tinyint,
    STATE(195), 1,
      sym_keyword_smallint,
    STATE(199), 1,
      sym_keyword_mediumint,
    STATE(200), 1,
      sym_keyword_int,
    STATE(202), 1,
      sym_keyword_bigint,
    STATE(203), 1,
      sym_keyword_real,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12145), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12147), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12149), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12151), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12153), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12155), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [437210] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(11615), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437266] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(11616), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437322] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(11617), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437378] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11603), 1,
      sym_identifier,
    STATE(11618), 1,
      sym_literal,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437434] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11696), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11698), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437464] = 16,
    ACTIONS(991), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12173), 1,
      sym_keyword_float,
    ACTIONS(12175), 1,
      sym_keyword_double,
    STATE(3733), 1,
      sym_keyword_real,
    STATE(3734), 1,
      sym_keyword_bigint,
    STATE(3735), 1,
      sym_keyword_int,
    STATE(3736), 1,
      sym_keyword_mediumint,
    STATE(3737), 1,
      sym_keyword_smallint,
    STATE(3738), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12161), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12163), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12165), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12167), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12169), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12171), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [437520] = 16,
    ACTIONS(1189), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12189), 1,
      sym_keyword_float,
    ACTIONS(12191), 1,
      sym_keyword_double,
    STATE(2969), 1,
      sym_keyword_real,
    STATE(2976), 1,
      sym_keyword_bigint,
    STATE(2977), 1,
      sym_keyword_int,
    STATE(2978), 1,
      sym_keyword_mediumint,
    STATE(2989), 1,
      sym_keyword_smallint,
    STATE(3016), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12177), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12179), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12181), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12183), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12185), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12187), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [437576] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11630), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11632), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437606] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2951), 1,
      anon_sym_PLUS,
    ACTIONS(2953), 1,
      anon_sym_DASH,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2961), 1,
      aux_sym__integer_token1,
    ACTIONS(2963), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2965), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(7640), 1,
      sym_literal,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2939), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3884), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437662] = 16,
    ACTIONS(243), 1,
      aux_sym_keyword_int_token1,
    ACTIONS(12205), 1,
      sym_keyword_float,
    ACTIONS(12207), 1,
      sym_keyword_double,
    STATE(3418), 1,
      sym_keyword_real,
    STATE(3419), 1,
      sym_keyword_bigint,
    STATE(3420), 1,
      sym_keyword_int,
    STATE(3421), 1,
      sym_keyword_mediumint,
    STATE(3422), 1,
      sym_keyword_smallint,
    STATE(3427), 1,
      sym_keyword_tinyint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12193), 2,
      aux_sym_keyword_tinyint_token1,
      aux_sym_keyword_tinyint_token2,
    ACTIONS(12195), 2,
      aux_sym_keyword_smallint_token1,
      aux_sym_keyword_smallint_token2,
    ACTIONS(12197), 2,
      aux_sym_keyword_mediumint_token1,
      aux_sym_keyword_mediumint_token2,
    ACTIONS(12199), 2,
      aux_sym_keyword_int_token2,
      aux_sym_keyword_int_token3,
    ACTIONS(12201), 2,
      aux_sym_keyword_bigint_token1,
      aux_sym_keyword_bigint_token2,
    ACTIONS(12203), 2,
      aux_sym_keyword_real_token1,
      aux_sym_keyword_real_token2,
  [437718] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11422), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437774] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11704), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11706), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437804] = 9,
    ACTIONS(11329), 1,
      sym_keyword_cross,
    ACTIONS(12209), 1,
      sym_keyword_left,
    ACTIONS(12215), 1,
      sym_keyword_inner,
    ACTIONS(12218), 1,
      sym_keyword_join,
    ACTIONS(12221), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12212), 2,
      sym_keyword_right,
      sym_keyword_full,
    STATE(6863), 5,
      sym_join,
      sym_cross_join,
      sym_lateral_join,
      sym_lateral_cross_join,
      aux_sym_from_repeat1,
    ACTIONS(11267), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_group,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [437846] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11867), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11869), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437876] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11638), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11640), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437906] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11720), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(11722), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [437936] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10818), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [437992] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10775), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [438048] = 3,
    ACTIONS(11690), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11688), 20,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_primary,
      sym_keyword_constraint,
      sym_keyword_not,
      sym_keyword_auto_increment,
      sym_keyword_generated,
      sym_keyword_default,
      sym_keyword_first,
      sym_keyword_after,
      sym_keyword_unique,
      sym_keyword_references,
      sym_keyword_check,
      sym_keyword_stored,
      sym_keyword_virtual,
      sym_keyword_comment,
      sym_keyword_null,
      anon_sym_COMMA,
  [438078] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11522), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [438134] = 16,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2903), 1,
      anon_sym_PLUS,
    ACTIONS(2905), 1,
      anon_sym_DASH,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2913), 1,
      aux_sym__integer_token1,
    ACTIONS(2915), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(2917), 1,
      aux_sym__bit_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10923), 1,
      sym_literal,
    STATE(11603), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2893), 3,
      sym_keyword_null,
      sym_keyword_true,
      sym_keyword_false,
    STATE(3210), 5,
      sym__literal_string,
      sym__integer,
      sym__decimal_number,
      sym__bit_string,
      sym__string_casting,
  [438190] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 6,
      sym__dollar_quoted_string_end_tag,
      sym__dollar_quoted_string,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
    ACTIONS(1376), 15,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_engine,
      sym_keyword_default,
      sym_keyword_with,
      sym_keyword_without,
      sym_keyword_row,
      sym_keyword_stored,
      sym_keyword_tblproperties,
      sym_keyword_location,
      sym_keyword_partitioned,
      sym_keyword_sort,
      sym__identifier,
  [438220] = 15,
    ACTIONS(127), 1,
      sym__identifier,
    ACTIONS(12226), 1,
      sym_keyword_create,
    ACTIONS(12228), 1,
      sym_keyword_in,
    ACTIONS(12230), 1,
      sym_keyword_with,
    ACTIONS(12234), 1,
      sym_keyword_password,
    ACTIONS(12236), 1,
      sym_keyword_encrypted,
    ACTIONS(12238), 1,
      sym_keyword_valid,
    ACTIONS(12240), 1,
      sym_keyword_connection,
    STATE(7124), 1,
      sym_identifier,
    STATE(7125), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6878), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12224), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(12232), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [438273] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12242), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12244), 14,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [438302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12246), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12248), 14,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [438331] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12250), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [438357] = 14,
    ACTIONS(127), 1,
      sym__identifier,
    ACTIONS(12228), 1,
      sym_keyword_in,
    ACTIONS(12234), 1,
      sym_keyword_password,
    ACTIONS(12236), 1,
      sym_keyword_encrypted,
    ACTIONS(12238), 1,
      sym_keyword_valid,
    ACTIONS(12240), 1,
      sym_keyword_connection,
    ACTIONS(12254), 1,
      sym_keyword_create,
    STATE(7124), 1,
      sym_identifier,
    STATE(7125), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6890), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12232), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
    ACTIONS(12252), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [438407] = 14,
    ACTIONS(127), 1,
      sym__identifier,
    ACTIONS(12228), 1,
      sym_keyword_in,
    ACTIONS(12234), 1,
      sym_keyword_password,
    ACTIONS(12236), 1,
      sym_keyword_encrypted,
    ACTIONS(12238), 1,
      sym_keyword_valid,
    ACTIONS(12240), 1,
      sym_keyword_connection,
    ACTIONS(12258), 1,
      sym_keyword_create,
    STATE(7124), 1,
      sym_identifier,
    STATE(7125), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6890), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12232), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
    ACTIONS(12256), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [438457] = 6,
    ACTIONS(12260), 1,
      sym_keyword_with,
    ACTIONS(12262), 1,
      sym_keyword_without,
    ACTIONS(12264), 1,
      anon_sym_LPAREN,
    STATE(7093), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1794), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [438491] = 6,
    ACTIONS(12260), 1,
      sym_keyword_with,
    ACTIONS(12262), 1,
      sym_keyword_without,
    ACTIONS(12266), 1,
      anon_sym_LPAREN,
    STATE(7092), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1772), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [438525] = 15,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(13), 1,
      sym_keyword_update,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(41), 1,
      sym_keyword_copy,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7565), 1,
      sym__select_statement,
    STATE(7988), 1,
      sym_set_operation,
    STATE(9854), 1,
      sym_update,
    STATE(9896), 1,
      sym_insert,
    STATE(11355), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(10845), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [438577] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    STATE(6377), 1,
      sym_identifier,
    STATE(7018), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5912), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5914), 9,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [438615] = 17,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(12272), 1,
      sym_keyword_set,
    ACTIONS(12274), 1,
      sym_keyword_in,
    ACTIONS(12276), 1,
      sym_keyword_with,
    ACTIONS(12278), 1,
      sym_keyword_rename,
    ACTIONS(12280), 1,
      sym_keyword_password,
    ACTIONS(12282), 1,
      sym_keyword_encrypted,
    ACTIONS(12284), 1,
      sym_keyword_valid,
    ACTIONS(12286), 1,
      sym_keyword_connection,
    ACTIONS(12288), 1,
      sym_keyword_reset,
    STATE(7124), 1,
      sym_identifier,
    STATE(7358), 1,
      aux_sym_alter_role_repeat1,
    STATE(7623), 1,
      sym__role_options,
    STATE(10593), 1,
      sym_rename_object,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12270), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [438671] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12290), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [438697] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12292), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [438723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12294), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [438749] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12296), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [438775] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12298), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [438801] = 15,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(1474), 1,
      sym_keyword_update,
    ACTIONS(1476), 1,
      sym_keyword_truncate,
    ACTIONS(1500), 1,
      sym_keyword_copy,
    ACTIONS(12300), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7616), 1,
      sym__select_statement,
    STATE(8251), 1,
      sym_set_operation,
    STATE(9562), 1,
      sym_insert,
    STATE(9696), 1,
      sym_update,
    STATE(11595), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1472), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(11377), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [438853] = 14,
    ACTIONS(12304), 1,
      sym__identifier,
    ACTIONS(12307), 1,
      sym_keyword_create,
    ACTIONS(12309), 1,
      sym_keyword_in,
    ACTIONS(12315), 1,
      sym_keyword_password,
    ACTIONS(12318), 1,
      sym_keyword_encrypted,
    ACTIONS(12321), 1,
      sym_keyword_valid,
    ACTIONS(12324), 1,
      sym_keyword_connection,
    STATE(7124), 1,
      sym_identifier,
    STATE(7125), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12327), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6890), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12302), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(12312), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [438903] = 6,
    ACTIONS(12330), 1,
      sym_keyword_unsigned,
    ACTIONS(12332), 1,
      sym_keyword_zerofill,
    ACTIONS(12334), 1,
      sym_keyword_precision,
    ACTIONS(12336), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [438937] = 14,
    ACTIONS(127), 1,
      sym__identifier,
    ACTIONS(12228), 1,
      sym_keyword_in,
    ACTIONS(12234), 1,
      sym_keyword_password,
    ACTIONS(12236), 1,
      sym_keyword_encrypted,
    ACTIONS(12238), 1,
      sym_keyword_valid,
    ACTIONS(12240), 1,
      sym_keyword_connection,
    ACTIONS(12340), 1,
      sym_keyword_create,
    STATE(7124), 1,
      sym_identifier,
    STATE(7125), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6877), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12232), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
    ACTIONS(12338), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [438987] = 15,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(9), 1,
      sym_keyword_delete,
    ACTIONS(15), 1,
      sym_keyword_truncate,
    ACTIONS(1704), 1,
      sym_keyword_update,
    ACTIONS(1714), 1,
      sym_keyword_copy,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7565), 1,
      sym__select_statement,
    STATE(7988), 1,
      sym_set_operation,
    STATE(11074), 1,
      sym_update,
    STATE(11076), 1,
      sym_insert,
    STATE(11802), 1,
      sym_delete,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1702), 2,
      sym_keyword_insert,
      sym_keyword_replace,
    STATE(10845), 5,
      sym__truncate_statement,
      sym__delete_statement,
      sym__copy_statement,
      sym__insert_statement,
      sym__update_statement,
  [439039] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12342), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [439065] = 15,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12226), 1,
      sym_keyword_create,
    ACTIONS(12344), 1,
      sym_keyword_in,
    ACTIONS(12346), 1,
      sym_keyword_with,
    ACTIONS(12350), 1,
      sym_keyword_password,
    ACTIONS(12352), 1,
      sym_keyword_encrypted,
    ACTIONS(12354), 1,
      sym_keyword_valid,
    ACTIONS(12356), 1,
      sym_keyword_connection,
    STATE(7206), 1,
      sym__role_options,
    STATE(7207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12224), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6908), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12348), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [439117] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12358), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
      anon_sym_RPAREN,
  [439143] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12358), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439168] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12342), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11748), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439218] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12294), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439243] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12296), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439268] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12250), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439293] = 17,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12360), 1,
      sym_keyword_set,
    ACTIONS(12362), 1,
      sym_keyword_in,
    ACTIONS(12364), 1,
      sym_keyword_with,
    ACTIONS(12366), 1,
      sym_keyword_rename,
    ACTIONS(12368), 1,
      sym_keyword_password,
    ACTIONS(12370), 1,
      sym_keyword_encrypted,
    ACTIONS(12372), 1,
      sym_keyword_valid,
    ACTIONS(12374), 1,
      sym_keyword_connection,
    ACTIONS(12376), 1,
      sym_keyword_reset,
    STATE(7207), 1,
      sym_identifier,
    STATE(7473), 1,
      aux_sym_alter_role_repeat1,
    STATE(7922), 1,
      sym__role_options,
    STATE(11357), 1,
      sym_rename_object,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12270), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [439348] = 5,
    ACTIONS(12378), 1,
      sym_keyword_unsigned,
    ACTIONS(12380), 1,
      sym_keyword_zerofill,
    ACTIONS(12382), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1818), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [439379] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12290), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439404] = 5,
    ACTIONS(12384), 1,
      sym_keyword_unsigned,
    ACTIONS(12386), 1,
      sym_keyword_zerofill,
    ACTIONS(12388), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1808), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [439435] = 14,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12340), 1,
      sym_keyword_create,
    ACTIONS(12344), 1,
      sym_keyword_in,
    ACTIONS(12350), 1,
      sym_keyword_password,
    ACTIONS(12352), 1,
      sym_keyword_encrypted,
    ACTIONS(12354), 1,
      sym_keyword_valid,
    ACTIONS(12356), 1,
      sym_keyword_connection,
    STATE(7206), 1,
      sym__role_options,
    STATE(7207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12338), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6911), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12348), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [439484] = 14,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12258), 1,
      sym_keyword_create,
    ACTIONS(12344), 1,
      sym_keyword_in,
    ACTIONS(12350), 1,
      sym_keyword_password,
    ACTIONS(12352), 1,
      sym_keyword_encrypted,
    ACTIONS(12354), 1,
      sym_keyword_valid,
    ACTIONS(12356), 1,
      sym_keyword_connection,
    STATE(7206), 1,
      sym__role_options,
    STATE(7207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12256), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6913), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12348), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [439533] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11851), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439558] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11680), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439583] = 14,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12254), 1,
      sym_keyword_create,
    ACTIONS(12344), 1,
      sym_keyword_in,
    ACTIONS(12350), 1,
      sym_keyword_password,
    ACTIONS(12352), 1,
      sym_keyword_encrypted,
    ACTIONS(12354), 1,
      sym_keyword_valid,
    ACTIONS(12356), 1,
      sym_keyword_connection,
    STATE(7206), 1,
      sym__role_options,
    STATE(7207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12252), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6913), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12348), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [439632] = 7,
    ACTIONS(12390), 1,
      sym_keyword_array,
    ACTIONS(12392), 1,
      anon_sym_LBRACK,
    STATE(7047), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(7223), 1,
      sym__array_size_definition,
    STATE(7248), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [439667] = 14,
    ACTIONS(12307), 1,
      sym_keyword_create,
    ACTIONS(12394), 1,
      sym__identifier,
    ACTIONS(12397), 1,
      sym_keyword_in,
    ACTIONS(12403), 1,
      sym_keyword_password,
    ACTIONS(12406), 1,
      sym_keyword_encrypted,
    ACTIONS(12409), 1,
      sym_keyword_valid,
    ACTIONS(12412), 1,
      sym_keyword_connection,
    STATE(7206), 1,
      sym__role_options,
    STATE(7207), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12302), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(12415), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6913), 2,
      sym__user_access_role_config,
      aux_sym_create_role_repeat1,
    ACTIONS(12400), 3,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_role,
  [439716] = 5,
    ACTIONS(12418), 1,
      sym_keyword_unsigned,
    ACTIONS(12420), 1,
      sym_keyword_zerofill,
    ACTIONS(12422), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1880), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [439747] = 5,
    ACTIONS(12424), 1,
      sym_keyword_unsigned,
    ACTIONS(12426), 1,
      sym_keyword_zerofill,
    ACTIONS(12428), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1828), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [439778] = 5,
    ACTIONS(12430), 1,
      sym_keyword_unsigned,
    ACTIONS(12432), 1,
      sym_keyword_zerofill,
    ACTIONS(12434), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1862), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [439809] = 5,
    ACTIONS(12436), 1,
      sym_keyword_unsigned,
    ACTIONS(12438), 1,
      sym_keyword_zerofill,
    ACTIONS(12440), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [439840] = 10,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7027), 1,
      sym_group_by,
    STATE(7177), 1,
      sym_window_clause,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [439881] = 10,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7054), 1,
      sym_group_by,
    STATE(7213), 1,
      sym_window_clause,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [439922] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11606), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [439947] = 10,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7000), 1,
      sym_group_by,
    STATE(7238), 1,
      sym_window_clause,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [439988] = 5,
    ACTIONS(12330), 1,
      sym_keyword_unsigned,
    ACTIONS(12332), 1,
      sym_keyword_zerofill,
    ACTIONS(12336), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [440019] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11602), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440044] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11676), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440069] = 5,
    ACTIONS(12442), 1,
      sym_keyword_unsigned,
    ACTIONS(12444), 1,
      sym_keyword_zerofill,
    ACTIONS(12446), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1890), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [440100] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11710), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440125] = 5,
    ACTIONS(12260), 1,
      sym_keyword_with,
    ACTIONS(12262), 1,
      sym_keyword_without,
    STATE(7079), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1844), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [440156] = 5,
    ACTIONS(12260), 1,
      sym_keyword_with,
    ACTIONS(12262), 1,
      sym_keyword_without,
    STATE(7081), 1,
      sym__include_time_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1848), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [440187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1900), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [440212] = 8,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(6229), 1,
      sym_keyword_as,
    STATE(6560), 1,
      sym_identifier,
    STATE(7456), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5912), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(5914), 9,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [440249] = 3,
    ACTIONS(12450), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12448), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [440276] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11700), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440301] = 10,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(6998), 1,
      sym_group_by,
    STATE(7168), 1,
      sym_window_clause,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [440342] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1904), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [440367] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11610), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440392] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11614), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440417] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11618), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440442] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1804), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [440467] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1800), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [440492] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11622), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440517] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11626), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440542] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1876), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [440567] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12298), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440592] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1872), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_unsigned,
      sym_keyword_zerofill,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [440617] = 10,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8865), 1,
      sym_keyword_group,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7024), 1,
      sym_group_by,
    STATE(7181), 1,
      sym_window_clause,
    STATE(7294), 1,
      sym_order_by,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [440658] = 7,
    ACTIONS(12390), 1,
      sym_keyword_array,
    ACTIONS(12392), 1,
      anon_sym_LBRACK,
    STATE(7047), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(7223), 1,
      sym__array_size_definition,
    STATE(7250), 1,
      sym_array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [440693] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11804), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_nulls,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [440718] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12292), 18,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_not,
      sym_keyword_rows,
      sym_keyword_returns,
      sym_keyword_language,
      sym_keyword_immutable,
      sym_keyword_stable,
      sym_keyword_volatile,
      sym_keyword_leakproof,
      sym_keyword_parallel,
      sym_keyword_called,
      sym_keyword_strict,
      sym_keyword_cost,
      sym_keyword_support,
      sym_keyword_security,
      sym_keyword_external,
  [440743] = 3,
    ACTIONS(12456), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12454), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [440770] = 10,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7136), 1,
      sym_group_by,
    STATE(7373), 1,
      sym_window_clause,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [440810] = 4,
    ACTIONS(12458), 1,
      sym_keyword_unsigned,
    ACTIONS(12460), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1986), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [440838] = 10,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7153), 1,
      sym_group_by,
    STATE(7273), 1,
      sym_window_clause,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [440878] = 4,
    ACTIONS(21), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12462), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(6966), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [440906] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12470), 1,
      sym_keyword_as,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7190), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9561), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [440958] = 10,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7146), 1,
      sym_group_by,
    STATE(7288), 1,
      sym_window_clause,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [440998] = 5,
    ACTIONS(12476), 1,
      anon_sym_COMMA,
    STATE(6956), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11839), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(11841), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [441028] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11839), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(11841), 12,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [441054] = 4,
    ACTIONS(12479), 1,
      sym_keyword_unsigned,
    ACTIONS(12481), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1932), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [441082] = 4,
    ACTIONS(12483), 1,
      sym_keyword_unsigned,
    ACTIONS(12485), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1908), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [441110] = 10,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7085), 1,
      sym_group_by,
    STATE(7308), 1,
      sym_window_clause,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [441150] = 10,
    ACTIONS(12487), 1,
      sym_keyword_table,
    ACTIONS(12491), 1,
      sym_keyword_column,
    ACTIONS(12493), 1,
      sym_keyword_materialized,
    ACTIONS(12497), 1,
      sym_keyword_cast,
    ACTIONS(12499), 1,
      sym_keyword_trigger,
    ACTIONS(12501), 1,
      sym_keyword_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13522), 2,
      sym__comment_target,
      sym_cast,
    ACTIONS(12489), 4,
      sym_keyword_view,
      sym_keyword_sequence,
      sym_keyword_index,
      sym_keyword_extension,
    ACTIONS(12495), 5,
      sym_keyword_tablespace,
      sym_keyword_type,
      sym_keyword_database,
      sym_keyword_schema,
      sym_keyword_role,
  [441190] = 4,
    ACTIONS(12505), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12503), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6962), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [441218] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12508), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
    STATE(6974), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [441244] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12512), 1,
      sym_keyword_as,
    STATE(7198), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10485), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441296] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12514), 1,
      sym_keyword_as,
    STATE(7209), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10583), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441348] = 4,
    ACTIONS(21), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12508), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(6974), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [441376] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12516), 1,
      sym_keyword_as,
    STATE(7193), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9637), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441428] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12518), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [441452] = 4,
    ACTIONS(12520), 1,
      sym_keyword_unsigned,
    ACTIONS(12522), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [441480] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12508), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
    STATE(6962), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [441506] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [441530] = 16,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12530), 1,
      sym_keyword_as,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7178), 1,
      sym_table_partition,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9732), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441582] = 16,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12534), 1,
      sym_keyword_as,
    STATE(7183), 1,
      sym_table_partition,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9823), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441634] = 4,
    ACTIONS(12536), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12503), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(6974), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [441662] = 10,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9090), 1,
      sym_keyword_group,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7143), 1,
      sym_group_by,
    STATE(7335), 1,
      sym_window_clause,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [441702] = 16,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12539), 1,
      sym_keyword_as,
    STATE(7185), 1,
      sym_table_partition,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9973), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441754] = 16,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12541), 1,
      sym_keyword_as,
    STATE(7191), 1,
      sym_table_partition,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10173), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441806] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12543), 1,
      sym_keyword_as,
    STATE(7179), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10416), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441858] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12545), 1,
      sym_keyword_as,
    STATE(7217), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10129), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441910] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12547), 1,
      sym_keyword_as,
    STATE(7194), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10449), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [441962] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12549), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [441986] = 6,
    ACTIONS(6181), 1,
      sym_keyword_having,
    ACTIONS(6197), 1,
      anon_sym_COMMA,
    STATE(7063), 1,
      aux_sym_array_repeat1,
    STATE(7171), 1,
      sym__having,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [442018] = 3,
    ACTIONS(12553), 1,
      sym_keyword_varying,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [442044] = 4,
    ACTIONS(12555), 1,
      sym_keyword_varying,
    ACTIONS(12557), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1948), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442072] = 16,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12468), 1,
      sym_keyword_partition,
    ACTIONS(12472), 1,
      sym_keyword_partitioned,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12559), 1,
      sym_keyword_as,
    STATE(7235), 1,
      sym_table_partition,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9465), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [442124] = 4,
    ACTIONS(1482), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12462), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6989), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [442152] = 5,
    ACTIONS(12565), 1,
      anon_sym_COMMA,
    STATE(6956), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12561), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12563), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442182] = 5,
    ACTIONS(12565), 1,
      anon_sym_COMMA,
    STATE(6993), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12561), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12563), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442212] = 4,
    ACTIONS(1482), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12508), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(6962), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [442240] = 5,
    ACTIONS(12565), 1,
      anon_sym_COMMA,
    STATE(6987), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12567), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12569), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442270] = 4,
    ACTIONS(12571), 1,
      sym_keyword_precision,
    ACTIONS(12573), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442298] = 10,
    ACTIONS(12487), 1,
      sym_keyword_table,
    ACTIONS(12491), 1,
      sym_keyword_column,
    ACTIONS(12493), 1,
      sym_keyword_materialized,
    ACTIONS(12497), 1,
      sym_keyword_cast,
    ACTIONS(12499), 1,
      sym_keyword_trigger,
    ACTIONS(12501), 1,
      sym_keyword_function,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13771), 2,
      sym__comment_target,
      sym_cast,
    ACTIONS(12489), 4,
      sym_keyword_view,
      sym_keyword_sequence,
      sym_keyword_index,
      sym_keyword_extension,
    ACTIONS(12495), 5,
      sym_keyword_tablespace,
      sym_keyword_type,
      sym_keyword_database,
      sym_keyword_schema,
      sym_keyword_role,
  [442338] = 5,
    ACTIONS(12565), 1,
      anon_sym_COMMA,
    STATE(6956), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12575), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12577), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442368] = 4,
    ACTIONS(12579), 1,
      sym_keyword_unsigned,
    ACTIONS(12581), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1978), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442396] = 4,
    ACTIONS(12583), 1,
      sym_keyword_unsigned,
    ACTIONS(12585), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1966), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442424] = 4,
    ACTIONS(12587), 1,
      sym_keyword_unsigned,
    ACTIONS(12589), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1916), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442452] = 4,
    ACTIONS(12591), 1,
      sym_keyword_unsigned,
    ACTIONS(12593), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1940), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442480] = 8,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7181), 1,
      sym_window_clause,
    STATE(7294), 1,
      sym_order_by,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [442515] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2167), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [442538] = 8,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7213), 1,
      sym_window_clause,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [442573] = 3,
    ACTIONS(12595), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442598] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12508), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
    STATE(7005), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [442623] = 3,
    ACTIONS(12597), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [442648] = 5,
    ACTIONS(12599), 1,
      anon_sym_COMMA,
    STATE(7066), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12561), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12563), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442677] = 4,
    ACTIONS(12503), 1,
      anon_sym_RPAREN,
    ACTIONS(12601), 1,
      sym_keyword_create,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7005), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [442704] = 5,
    ACTIONS(12599), 1,
      anon_sym_COMMA,
    STATE(7009), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12561), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12563), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442733] = 4,
    ACTIONS(1708), 1,
      sym_keyword_create,
    ACTIONS(12508), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7005), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [442760] = 4,
    ACTIONS(1708), 1,
      sym_keyword_create,
    ACTIONS(12462), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7007), 14,
      sym__create_statement,
      sym_create_table,
      sym_create_view,
      sym_create_materialized_view,
      sym_create_function,
      sym_create_index,
      sym_create_schema,
      sym_create_database,
      sym_create_role,
      sym_create_sequence,
      sym_create_extension,
      sym_create_trigger,
      sym_create_type,
      aux_sym__create_statement_repeat1,
  [442787] = 5,
    ACTIONS(12599), 1,
      anon_sym_COMMA,
    STATE(7066), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12575), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12577), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442816] = 5,
    ACTIONS(12599), 1,
      anon_sym_COMMA,
    STATE(7004), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12567), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12569), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [442845] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7221), 1,
      sym_group_by,
    STATE(7294), 1,
      sym_order_by,
    STATE(7479), 1,
      sym_window_clause,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [442884] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7218), 1,
      sym_group_by,
    STATE(7265), 1,
      sym_order_by,
    STATE(7459), 1,
      sym_window_clause,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [442923] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7216), 1,
      sym_group_by,
    STATE(7400), 1,
      sym_order_by,
    STATE(7454), 1,
      sym_window_clause,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [442962] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7214), 1,
      sym_group_by,
    STATE(7338), 1,
      sym_order_by,
    STATE(7453), 1,
      sym_window_clause,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [443001] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12242), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12244), 11,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [443026] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    ACTIONS(9694), 1,
      sym_keyword_group,
    STATE(7210), 1,
      sym_group_by,
    STATE(7391), 1,
      sym_order_by,
    STATE(7451), 1,
      sym_window_clause,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [443065] = 3,
    ACTIONS(12604), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443090] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12606), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [443113] = 4,
    ACTIONS(1361), 1,
      aux_sym__single_quote_string_token2,
    STATE(86), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [443140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12246), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12248), 11,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym__identifier,
  [443165] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12606), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [443188] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8534), 1,
      sym_select,
    STATE(9387), 1,
      sym__select_statement,
    STATE(10890), 1,
      sym__column,
    STATE(13514), 1,
      sym_set_operation,
    STATE(13516), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [443241] = 3,
    ACTIONS(12610), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443266] = 8,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7186), 1,
      sym_window_clause,
    STATE(7316), 1,
      sym_order_by,
    STATE(7531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [443301] = 4,
    ACTIONS(12614), 1,
      aux_sym__single_quote_string_token2,
    STATE(7019), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [443328] = 16,
    ACTIONS(12616), 1,
      sym_keyword_set,
    ACTIONS(12618), 1,
      sym_keyword_increment,
    ACTIONS(12620), 1,
      sym_keyword_minvalue,
    ACTIONS(12622), 1,
      sym_keyword_maxvalue,
    ACTIONS(12624), 1,
      sym_keyword_owned,
    ACTIONS(12626), 1,
      sym_keyword_start,
    ACTIONS(12628), 1,
      sym_keyword_restart,
    ACTIONS(12630), 1,
      sym_keyword_as,
    ACTIONS(12632), 1,
      sym_keyword_no,
    ACTIONS(12634), 1,
      sym_keyword_rename,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(12638), 1,
      sym_keyword_cycle,
    ACTIONS(12640), 1,
      sym_keyword_cache,
    STATE(7165), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10545), 2,
      sym_rename_object,
      sym_change_ownership,
  [443379] = 8,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7238), 1,
      sym_window_clause,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [443414] = 3,
    ACTIONS(12642), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443439] = 17,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2432), 1,
      sym_keyword_select,
    ACTIONS(2442), 1,
      sym_keyword_with,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8587), 1,
      sym_select,
    STATE(8856), 1,
      sym__select_statement,
    STATE(10890), 1,
      sym__column,
    STATE(13820), 1,
      sym_set_operation,
    STATE(13985), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [443492] = 16,
    ACTIONS(12644), 1,
      sym_keyword_set,
    ACTIONS(12646), 1,
      sym_keyword_increment,
    ACTIONS(12648), 1,
      sym_keyword_minvalue,
    ACTIONS(12650), 1,
      sym_keyword_maxvalue,
    ACTIONS(12652), 1,
      sym_keyword_owned,
    ACTIONS(12654), 1,
      sym_keyword_start,
    ACTIONS(12656), 1,
      sym_keyword_restart,
    ACTIONS(12658), 1,
      sym_keyword_as,
    ACTIONS(12660), 1,
      sym_keyword_no,
    ACTIONS(12662), 1,
      sym_keyword_rename,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(12666), 1,
      sym_keyword_cycle,
    ACTIONS(12668), 1,
      sym_keyword_cache,
    STATE(7362), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11354), 2,
      sym_rename_object,
      sym_change_ownership,
  [443543] = 6,
    ACTIONS(6608), 1,
      sym_keyword_having,
    ACTIONS(6612), 1,
      anon_sym_COMMA,
    STATE(7099), 1,
      aux_sym_array_repeat1,
    STATE(7341), 1,
      sym__having,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [443574] = 16,
    ACTIONS(12646), 1,
      sym_keyword_increment,
    ACTIONS(12648), 1,
      sym_keyword_minvalue,
    ACTIONS(12650), 1,
      sym_keyword_maxvalue,
    ACTIONS(12652), 1,
      sym_keyword_owned,
    ACTIONS(12654), 1,
      sym_keyword_start,
    ACTIONS(12656), 1,
      sym_keyword_restart,
    ACTIONS(12658), 1,
      sym_keyword_as,
    ACTIONS(12660), 1,
      sym_keyword_no,
    ACTIONS(12662), 1,
      sym_keyword_rename,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(12668), 1,
      sym_keyword_cache,
    ACTIONS(12670), 1,
      sym_keyword_set,
    ACTIONS(12672), 1,
      sym_keyword_cycle,
    STATE(7342), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11322), 2,
      sym_rename_object,
      sym_change_ownership,
  [443625] = 3,
    ACTIONS(12674), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443650] = 3,
    ACTIONS(12676), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2083), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443675] = 3,
    ACTIONS(12678), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443700] = 3,
    ACTIONS(12680), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2171), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443725] = 3,
    ACTIONS(12682), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2057), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443750] = 3,
    ACTIONS(12684), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2071), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443775] = 3,
    ACTIONS(12686), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2137), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443800] = 3,
    ACTIONS(12688), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443825] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1960), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [443848] = 3,
    ACTIONS(12573), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443873] = 3,
    ACTIONS(12690), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443898] = 3,
    ACTIONS(12692), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443923] = 16,
    ACTIONS(12618), 1,
      sym_keyword_increment,
    ACTIONS(12620), 1,
      sym_keyword_minvalue,
    ACTIONS(12622), 1,
      sym_keyword_maxvalue,
    ACTIONS(12624), 1,
      sym_keyword_owned,
    ACTIONS(12626), 1,
      sym_keyword_start,
    ACTIONS(12628), 1,
      sym_keyword_restart,
    ACTIONS(12630), 1,
      sym_keyword_as,
    ACTIONS(12632), 1,
      sym_keyword_no,
    ACTIONS(12634), 1,
      sym_keyword_rename,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(12640), 1,
      sym_keyword_cache,
    ACTIONS(12694), 1,
      sym_keyword_set,
    ACTIONS(12696), 1,
      sym_keyword_cycle,
    STATE(7231), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10627), 2,
      sym_rename_object,
      sym_change_ownership,
  [443974] = 3,
    ACTIONS(12698), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [443999] = 5,
    ACTIONS(12392), 1,
      anon_sym_LBRACK,
    STATE(7050), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(7223), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [444028] = 3,
    ACTIONS(12700), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444053] = 3,
    ACTIONS(12702), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444078] = 5,
    ACTIONS(12704), 1,
      anon_sym_LBRACK,
    STATE(7050), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(7223), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2044), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [444107] = 8,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7177), 1,
      sym_window_clause,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [444142] = 3,
    ACTIONS(12707), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2131), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444167] = 3,
    ACTIONS(12709), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444192] = 8,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    STATE(7168), 1,
      sym_window_clause,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [444227] = 3,
    ACTIONS(12711), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2125), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444252] = 3,
    ACTIONS(12713), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444277] = 3,
    ACTIONS(12715), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444302] = 3,
    ACTIONS(12717), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444327] = 3,
    ACTIONS(12719), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444352] = 3,
    ACTIONS(12721), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2022), 16,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [444400] = 3,
    ACTIONS(12723), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444425] = 4,
    ACTIONS(12725), 1,
      anon_sym_COMMA,
    STATE(7063), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6767), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [444452] = 3,
    ACTIONS(12728), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444477] = 3,
    ACTIONS(12730), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444502] = 5,
    ACTIONS(12732), 1,
      anon_sym_COMMA,
    STATE(7066), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11839), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(11841), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [444531] = 3,
    ACTIONS(12735), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1994), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444556] = 3,
    ACTIONS(12737), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2161), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444581] = 3,
    ACTIONS(12739), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2091), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444606] = 3,
    ACTIONS(12438), 1,
      sym_keyword_zerofill,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444631] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2026), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444653] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2197), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444675] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2309), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444697] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2305), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444719] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2119), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444741] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2038), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444763] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2032), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444785] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2301), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444807] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2297), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444829] = 4,
    ACTIONS(12392), 1,
      anon_sym_LBRACK,
    STATE(7249), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [444855] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2293), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444877] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2281), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444899] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2177), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444921] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2265), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444943] = 8,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7288), 1,
      sym_window_clause,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [444977] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2261), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [444999] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2229), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445021] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2107), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445043] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2099), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445065] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2077), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445087] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2065), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2189), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445131] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2185), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445153] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2209), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445175] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1852), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445197] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2051), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445219] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2253), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445241] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2233), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445263] = 4,
    ACTIONS(12741), 1,
      anon_sym_COMMA,
    STATE(7099), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6767), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [445289] = 8,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7308), 1,
      sym_window_clause,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [445323] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2221), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445345] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12744), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12746), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445369] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12748), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12750), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445393] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12752), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12754), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445417] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2004), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445439] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2205), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445461] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2201), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445483] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2353), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445505] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12756), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12758), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445529] = 3,
    ACTIONS(1374), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [445553] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2217), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445575] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1782), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445597] = 4,
    ACTIONS(12760), 1,
      aux_sym__single_quote_string_token2,
    STATE(7119), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3154), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [445623] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2349), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2313), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445667] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2357), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2241), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445711] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7330), 1,
      sym_group_by,
    STATE(7476), 1,
      sym_order_by,
    STATE(7518), 1,
      sym_window_clause,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [445749] = 4,
    ACTIONS(12762), 1,
      aux_sym__single_quote_string_token2,
    STATE(7119), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1363), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [445775] = 7,
    ACTIONS(12765), 1,
      sym_keyword_array,
    ACTIONS(12767), 1,
      anon_sym_LBRACK,
    STATE(2637), 1,
      sym__array_size_definition,
    STATE(2639), 1,
      sym_array_size_definition,
    STATE(7407), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [445807] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2257), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445829] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2016), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2317), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12769), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12771), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445897] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12773), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12775), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12777), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12779), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [445945] = 7,
    ACTIONS(12765), 1,
      sym_keyword_array,
    ACTIONS(12767), 1,
      anon_sym_LBRACK,
    STATE(2631), 1,
      sym_array_size_definition,
    STATE(2637), 1,
      sym__array_size_definition,
    STATE(7407), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [445977] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2249), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [445999] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12781), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12783), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [446023] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2193), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446045] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2225), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446067] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1924), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446089] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2237), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446111] = 6,
    ACTIONS(6699), 1,
      sym_keyword_having,
    ACTIONS(6701), 1,
      anon_sym_COMMA,
    STATE(7171), 1,
      sym__having,
    STATE(7222), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [446141] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2213), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446163] = 8,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7401), 1,
      sym_window_clause,
    STATE(7414), 1,
      sym_order_by,
    STATE(7645), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [446197] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2269), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446219] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2273), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446241] = 4,
    ACTIONS(12785), 1,
      aux_sym__single_quote_string_token2,
    STATE(7113), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3178), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [446267] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2181), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446289] = 4,
    ACTIONS(12760), 1,
      aux_sym__single_quote_string_token2,
    STATE(7119), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1357), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [446315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2113), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446337] = 8,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7373), 1,
      sym_window_clause,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [446371] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2277), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446393] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2285), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446415] = 8,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7273), 1,
      sym_window_clause,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [446449] = 4,
    ACTIONS(12787), 1,
      aux_sym__single_quote_string_token2,
    STATE(7141), 1,
      aux_sym__single_quote_string_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1351), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [446475] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2289), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446497] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2321), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446519] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2153), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446541] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2325), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446563] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2329), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446585] = 8,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    STATE(7335), 1,
      sym_window_clause,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [446619] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2345), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446641] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7317), 1,
      sym_group_by,
    STATE(7448), 1,
      sym_order_by,
    STATE(7529), 1,
      sym_window_clause,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [446679] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2333), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446701] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7322), 1,
      sym_group_by,
    STATE(7511), 1,
      sym_order_by,
    STATE(7523), 1,
      sym_window_clause,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [446739] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7326), 1,
      sym_group_by,
    STATE(7420), 1,
      sym_order_by,
    STATE(7522), 1,
      sym_window_clause,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [446777] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    ACTIONS(10049), 1,
      sym_keyword_group,
    STATE(7328), 1,
      sym_group_by,
    STATE(7442), 1,
      sym_order_by,
    STATE(7520), 1,
      sym_window_clause,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [446815] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2010), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446837] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2245), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446859] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2337), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446881] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2145), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446903] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2341), 15,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      sym_keyword_array,
      anon_sym_LBRACK,
  [446925] = 13,
    ACTIONS(12618), 1,
      sym_keyword_increment,
    ACTIONS(12620), 1,
      sym_keyword_minvalue,
    ACTIONS(12622), 1,
      sym_keyword_maxvalue,
    ACTIONS(12624), 1,
      sym_keyword_owned,
    ACTIONS(12626), 1,
      sym_keyword_start,
    ACTIONS(12628), 1,
      sym_keyword_restart,
    ACTIONS(12630), 1,
      sym_keyword_as,
    ACTIONS(12632), 1,
      sym_keyword_no,
    ACTIONS(12640), 1,
      sym_keyword_cache,
    ACTIONS(12791), 1,
      sym_keyword_cycle,
    STATE(7233), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12789), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [446968] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12803), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447001] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12805), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447034] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7294), 1,
      sym_order_by,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [447063] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [447084] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12807), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447117] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12809), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [447138] = 6,
    ACTIONS(6835), 1,
      sym_keyword_having,
    ACTIONS(6837), 1,
      anon_sym_COMMA,
    STATE(7341), 1,
      sym__having,
    STATE(7360), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [447167] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12811), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447200] = 8,
    ACTIONS(12816), 1,
      sym_keyword_freeze,
    ACTIONS(12822), 1,
      sym_keyword_header,
    ACTIONS(12825), 1,
      sym_keyword_format,
    ACTIONS(12828), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12819), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12813), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447233] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12830), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447266] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [447287] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [447316] = 13,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12534), 1,
      sym_keyword_as,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9823), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447359] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12832), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10377), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447402] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2374), 14,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_LBRACK,
  [447423] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7316), 1,
      sym_order_by,
    STATE(7531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [447452] = 12,
    ACTIONS(12836), 1,
      sym_keyword_increment,
    ACTIONS(12838), 1,
      sym_keyword_minvalue,
    ACTIONS(12840), 1,
      sym_keyword_maxvalue,
    ACTIONS(12842), 1,
      sym_keyword_owned,
    ACTIONS(12844), 1,
      sym_keyword_start,
    ACTIONS(12846), 1,
      sym_keyword_as,
    ACTIONS(12848), 1,
      sym_keyword_no,
    ACTIONS(12850), 1,
      sym_keyword_cycle,
    ACTIONS(12852), 1,
      sym_keyword_cache,
    STATE(7211), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12834), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [447493] = 13,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12539), 1,
      sym_keyword_as,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9973), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447536] = 15,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(12854), 1,
      sym_keyword_column,
    ACTIONS(12856), 1,
      sym_keyword_constraint,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(120), 1,
      sym_identifier,
    STATE(136), 1,
      sym__literal_string,
    STATE(7703), 1,
      sym__if_not_exists,
    STATE(8610), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [447583] = 13,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12541), 1,
      sym_keyword_as,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10173), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447626] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7340), 1,
      sym_order_by,
    STATE(7553), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [447655] = 15,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(12860), 1,
      anon_sym_LPAREN,
    ACTIONS(12862), 1,
      anon_sym_RPAREN,
    ACTIONS(12864), 1,
      sym__double_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(7433), 1,
      sym_invocation,
    STATE(7461), 1,
      sym__column,
    STATE(7566), 1,
      sym_identifier,
    STATE(10317), 1,
      sym__index_field,
    STATE(13604), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [447702] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [447723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [447744] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12516), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9637), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447787] = 13,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    ACTIONS(12866), 1,
      sym_keyword_as,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10168), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447830] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12868), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [447863] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12545), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10129), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447906] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12543), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10416), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [447949] = 3,
    ACTIONS(1374), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [447972] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12870), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448005] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12872), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448038] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12547), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10449), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [448081] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12874), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448114] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12876), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448147] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [448168] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12878), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448201] = 12,
    ACTIONS(12836), 1,
      sym_keyword_increment,
    ACTIONS(12838), 1,
      sym_keyword_minvalue,
    ACTIONS(12840), 1,
      sym_keyword_maxvalue,
    ACTIONS(12842), 1,
      sym_keyword_owned,
    ACTIONS(12844), 1,
      sym_keyword_start,
    ACTIONS(12846), 1,
      sym_keyword_as,
    ACTIONS(12848), 1,
      sym_keyword_no,
    ACTIONS(12852), 1,
      sym_keyword_cache,
    ACTIONS(12882), 1,
      sym_keyword_cycle,
    STATE(7225), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12880), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [448242] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7391), 1,
      sym_order_by,
    STATE(7451), 1,
      sym_window_clause,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [448275] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [448296] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12773), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12775), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [448319] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12769), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12771), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [448342] = 12,
    ACTIONS(12836), 1,
      sym_keyword_increment,
    ACTIONS(12838), 1,
      sym_keyword_minvalue,
    ACTIONS(12840), 1,
      sym_keyword_maxvalue,
    ACTIONS(12842), 1,
      sym_keyword_owned,
    ACTIONS(12844), 1,
      sym_keyword_start,
    ACTIONS(12846), 1,
      sym_keyword_as,
    ACTIONS(12848), 1,
      sym_keyword_no,
    ACTIONS(12852), 1,
      sym_keyword_cache,
    ACTIONS(12886), 1,
      sym_keyword_cycle,
    STATE(7224), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12884), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [448383] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(12512), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10485), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [448426] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7338), 1,
      sym_order_by,
    STATE(7453), 1,
      sym_window_clause,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [448459] = 12,
    ACTIONS(12836), 1,
      sym_keyword_increment,
    ACTIONS(12838), 1,
      sym_keyword_minvalue,
    ACTIONS(12840), 1,
      sym_keyword_maxvalue,
    ACTIONS(12842), 1,
      sym_keyword_owned,
    ACTIONS(12844), 1,
      sym_keyword_start,
    ACTIONS(12846), 1,
      sym_keyword_as,
    ACTIONS(12848), 1,
      sym_keyword_no,
    ACTIONS(12852), 1,
      sym_keyword_cache,
    ACTIONS(12882), 1,
      sym_keyword_cycle,
    STATE(7225), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12888), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [448500] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [448529] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [448558] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7400), 1,
      sym_order_by,
    STATE(7454), 1,
      sym_window_clause,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [448591] = 15,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(12890), 1,
      sym_keyword_column,
    ACTIONS(12892), 1,
      sym_keyword_constraint,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(119), 1,
      sym_identifier,
    STATE(136), 1,
      sym__literal_string,
    STATE(7676), 1,
      sym__if_not_exists,
    STATE(8299), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [448638] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7265), 1,
      sym_order_by,
    STATE(7459), 1,
      sym_window_clause,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [448671] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12559), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9465), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [448714] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7294), 1,
      sym_order_by,
    STATE(7479), 1,
      sym_window_clause,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [448747] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12894), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448780] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12896), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [448813] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(8871), 1,
      sym_keyword_window,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7316), 1,
      sym_order_by,
    STATE(7480), 1,
      sym_window_clause,
    STATE(7531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [448846] = 4,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    STATE(7222), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6767), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
      anon_sym_RPAREN,
  [448871] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2370), 14,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_LBRACK,
  [448892] = 12,
    ACTIONS(12836), 1,
      sym_keyword_increment,
    ACTIONS(12838), 1,
      sym_keyword_minvalue,
    ACTIONS(12840), 1,
      sym_keyword_maxvalue,
    ACTIONS(12842), 1,
      sym_keyword_owned,
    ACTIONS(12844), 1,
      sym_keyword_start,
    ACTIONS(12846), 1,
      sym_keyword_as,
    ACTIONS(12848), 1,
      sym_keyword_no,
    ACTIONS(12852), 1,
      sym_keyword_cache,
    ACTIONS(12882), 1,
      sym_keyword_cycle,
    STATE(7225), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12901), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [448933] = 12,
    ACTIONS(12905), 1,
      sym_keyword_increment,
    ACTIONS(12908), 1,
      sym_keyword_minvalue,
    ACTIONS(12911), 1,
      sym_keyword_maxvalue,
    ACTIONS(12914), 1,
      sym_keyword_owned,
    ACTIONS(12917), 1,
      sym_keyword_start,
    ACTIONS(12920), 1,
      sym_keyword_as,
    ACTIONS(12923), 1,
      sym_keyword_no,
    ACTIONS(12926), 1,
      sym_keyword_cycle,
    ACTIONS(12929), 1,
      sym_keyword_cache,
    STATE(7225), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12903), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [448974] = 15,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(12860), 1,
      anon_sym_LPAREN,
    ACTIONS(12864), 1,
      sym__double_quote_string,
    ACTIONS(12932), 1,
      anon_sym_RPAREN,
    STATE(136), 1,
      sym__literal_string,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(7433), 1,
      sym_invocation,
    STATE(7461), 1,
      sym__column,
    STATE(7566), 1,
      sym_identifier,
    STATE(10937), 1,
      sym__index_field,
    STATE(13604), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [449021] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12752), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12754), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [449044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12748), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12750), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [449067] = 12,
    ACTIONS(12836), 1,
      sym_keyword_increment,
    ACTIONS(12838), 1,
      sym_keyword_minvalue,
    ACTIONS(12840), 1,
      sym_keyword_maxvalue,
    ACTIONS(12842), 1,
      sym_keyword_owned,
    ACTIONS(12844), 1,
      sym_keyword_start,
    ACTIONS(12846), 1,
      sym_keyword_as,
    ACTIONS(12848), 1,
      sym_keyword_no,
    ACTIONS(12852), 1,
      sym_keyword_cache,
    ACTIONS(12936), 1,
      sym_keyword_cycle,
    STATE(7203), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12934), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [449108] = 4,
    ACTIONS(12938), 1,
      anon_sym_COMMA,
    STATE(7230), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6767), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
  [449133] = 13,
    ACTIONS(12618), 1,
      sym_keyword_increment,
    ACTIONS(12620), 1,
      sym_keyword_minvalue,
    ACTIONS(12622), 1,
      sym_keyword_maxvalue,
    ACTIONS(12624), 1,
      sym_keyword_owned,
    ACTIONS(12626), 1,
      sym_keyword_start,
    ACTIONS(12628), 1,
      sym_keyword_restart,
    ACTIONS(12630), 1,
      sym_keyword_as,
    ACTIONS(12632), 1,
      sym_keyword_no,
    ACTIONS(12640), 1,
      sym_keyword_cache,
    ACTIONS(12791), 1,
      sym_keyword_cycle,
    STATE(7233), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12941), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [449176] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2386), 14,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_LBRACK,
  [449197] = 13,
    ACTIONS(12945), 1,
      sym_keyword_increment,
    ACTIONS(12948), 1,
      sym_keyword_minvalue,
    ACTIONS(12951), 1,
      sym_keyword_maxvalue,
    ACTIONS(12954), 1,
      sym_keyword_owned,
    ACTIONS(12957), 1,
      sym_keyword_start,
    ACTIONS(12960), 1,
      sym_keyword_restart,
    ACTIONS(12963), 1,
      sym_keyword_as,
    ACTIONS(12966), 1,
      sym_keyword_no,
    ACTIONS(12969), 1,
      sym_keyword_cycle,
    ACTIONS(12972), 1,
      sym_keyword_cache,
    STATE(7233), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12943), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [449240] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12975), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [449273] = 13,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12977), 1,
      sym_keyword_as,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10136), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [449316] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12979), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [449349] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12756), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12758), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [449372] = 6,
    ACTIONS(8863), 1,
      sym_keyword_order,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [449401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12744), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12746), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [449424] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12777), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12779), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [449447] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12981), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [449480] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12781), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(12783), 10,
      sym_keyword_create,
      sym_keyword_in,
      sym_keyword_user,
      sym_keyword_admin,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym_keyword_role,
      sym__identifier,
  [449503] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12983), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [449536] = 8,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    ACTIONS(12985), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [449569] = 12,
    ACTIONS(12987), 1,
      sym_keyword_increment,
    ACTIONS(12989), 1,
      sym_keyword_minvalue,
    ACTIONS(12991), 1,
      sym_keyword_maxvalue,
    ACTIONS(12993), 1,
      sym_keyword_owned,
    ACTIONS(12995), 1,
      sym_keyword_start,
    ACTIONS(12997), 1,
      sym_keyword_as,
    ACTIONS(12999), 1,
      sym_keyword_no,
    ACTIONS(13001), 1,
      sym_keyword_cycle,
    ACTIONS(13003), 1,
      sym_keyword_cache,
    STATE(7345), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12880), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [449609] = 3,
    ACTIONS(13005), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12448), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [449631] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1370), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449651] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2366), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449671] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2382), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449691] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2378), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449711] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3566), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449731] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3570), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449751] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3522), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449771] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3514), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449791] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3562), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [449811] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7219), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [449841] = 4,
    ACTIONS(13009), 1,
      anon_sym_COMMA,
    STATE(7388), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [449865] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13019), 1,
      sym_keyword_on,
    ACTIONS(13021), 1,
      sym_keyword_using,
    STATE(7873), 1,
      sym_index_hint,
    STATE(11436), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [449901] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11804), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_nulls,
      anon_sym_COMMA,
  [449921] = 4,
    ACTIONS(13023), 1,
      anon_sym_COMMA,
    STATE(7260), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [449945] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9468), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [449985] = 3,
    ACTIONS(13026), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_partition,
      sym_keyword_create,
      sym_keyword_as,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_array,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
  [450007] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13028), 1,
      sym_keyword_on,
    ACTIONS(13030), 1,
      sym_keyword_using,
    STATE(7862), 1,
      sym_index_hint,
    STATE(11987), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450043] = 14,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13032), 1,
      sym_keyword_on,
    ACTIONS(13034), 1,
      sym_keyword_concurrently,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7835), 1,
      sym__if_not_exists,
    STATE(14010), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [450087] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [450111] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13036), 1,
      sym_keyword_on,
    STATE(7870), 1,
      sym_index_hint,
    STATE(11988), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450147] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7173), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [450177] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7220), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [450207] = 4,
    ACTIONS(13040), 1,
      anon_sym_COMMA,
    STATE(7403), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13038), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [450231] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12828), 13,
      sym_keyword_default,
      sym_keyword_freeze,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_force_quote,
      sym_keyword_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
      sym_keyword_header,
      sym_keyword_format,
      sym_keyword_delimiter,
      sym_keyword_null,
      anon_sym_RPAREN,
  [450251] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13042), 1,
      sym_keyword_on,
    ACTIONS(13044), 1,
      sym_keyword_using,
    STATE(7871), 1,
      sym_index_hint,
    STATE(11990), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450287] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13046), 13,
      sym_keyword_default,
      sym_keyword_freeze,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_force_quote,
      sym_keyword_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
      sym_keyword_header,
      sym_keyword_format,
      sym_keyword_delimiter,
      sym_keyword_null,
      anon_sym_RPAREN,
  [450307] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [450335] = 3,
    ACTIONS(13048), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12454), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [450357] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13052), 1,
      sym_keyword_role,
    ACTIONS(13054), 1,
      sym_keyword_transaction,
    ACTIONS(13056), 1,
      sym_keyword_local,
    ACTIONS(13058), 1,
      sym_keyword_session,
    ACTIONS(13060), 1,
      sym_keyword_constraints,
    ACTIONS(13062), 1,
      sym_keyword_time,
    STATE(6414), 1,
      sym_identifier,
    STATE(11599), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13050), 2,
      sym_keyword_schema,
      sym_keyword_names,
  [450397] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [450417] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10148), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [450457] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13064), 1,
      sym_keyword_on,
    ACTIONS(13066), 1,
      sym_keyword_using,
    STATE(7851), 1,
      sym_index_hint,
    STATE(11986), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450493] = 14,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13068), 1,
      sym_keyword_on,
    ACTIONS(13070), 1,
      sym_keyword_concurrently,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7838), 1,
      sym__if_not_exists,
    STATE(14031), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [450537] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13044), 1,
      sym_keyword_using,
    ACTIONS(13072), 1,
      sym_keyword_on,
    STATE(7836), 1,
      sym_index_hint,
    STATE(11980), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450573] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13074), 1,
      sym_keyword_on,
    STATE(7823), 1,
      sym_index_hint,
    STATE(11976), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450609] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13076), 1,
      sym_keyword_on,
    STATE(7834), 1,
      sym_index_hint,
    STATE(11975), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13078), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [450665] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13080), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [450685] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13082), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [450705] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13084), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [450725] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13086), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [450745] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [450773] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13088), 1,
      sym_keyword_on,
    STATE(7808), 1,
      sym_index_hint,
    STATE(11973), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450809] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13044), 1,
      sym_keyword_using,
    ACTIONS(13090), 1,
      sym_keyword_on,
    STATE(7790), 1,
      sym_index_hint,
    STATE(11965), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450845] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13092), 1,
      sym_keyword_on,
    STATE(7779), 1,
      sym_index_hint,
    STATE(11963), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [450881] = 12,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9977), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [450921] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [450945] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [450969] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13094), 1,
      sym_keyword_on,
    STATE(7771), 1,
      sym_index_hint,
    STATE(11959), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451005] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13096), 1,
      sym_keyword_on,
    STATE(7763), 1,
      sym_index_hint,
    STATE(11958), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451041] = 14,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13098), 1,
      sym_keyword_column,
    ACTIONS(13100), 1,
      sym_keyword_if,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7702), 1,
      sym__if_exists,
    STATE(8380), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [451085] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13102), 1,
      sym_keyword_on,
    ACTIONS(13104), 1,
      sym_keyword_using,
    STATE(7751), 1,
      sym_index_hint,
    STATE(11951), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451121] = 14,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13106), 1,
      sym_keyword_on,
    ACTIONS(13108), 1,
      sym_keyword_concurrently,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7926), 1,
      sym__if_not_exists,
    STATE(13004), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [451165] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13110), 1,
      sym_keyword_on,
    ACTIONS(13112), 1,
      sym_keyword_using,
    STATE(7750), 1,
      sym_index_hint,
    STATE(11946), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451201] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13114), 1,
      sym_keyword_on,
    ACTIONS(13116), 1,
      sym_keyword_using,
    STATE(7744), 1,
      sym_index_hint,
    STATE(11945), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451237] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13118), 1,
      sym_keyword_on,
    ACTIONS(13120), 1,
      sym_keyword_using,
    STATE(7731), 1,
      sym_index_hint,
    STATE(11944), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451273] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13104), 1,
      sym_keyword_using,
    ACTIONS(13122), 1,
      sym_keyword_on,
    STATE(7734), 1,
      sym_index_hint,
    STATE(11940), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451309] = 12,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10205), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [451349] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(13124), 1,
      sym_keyword_on,
    STATE(7737), 1,
      sym_index_hint,
    STATE(11937), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451385] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(13126), 1,
      sym_keyword_on,
    STATE(7740), 1,
      sym_index_hint,
    STATE(11933), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451421] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(13128), 1,
      sym_keyword_on,
    STATE(7748), 1,
      sym_index_hint,
    STATE(11932), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451457] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [451485] = 13,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(11003), 1,
      sym_keyword_check,
    ACTIONS(13130), 1,
      sym_keyword_key,
    ACTIONS(13132), 1,
      sym_keyword_constraint,
    ACTIONS(13134), 1,
      sym_keyword_index,
    ACTIONS(13136), 1,
      sym_keyword_unique,
    ACTIONS(13138), 1,
      sym_keyword_foreign,
    STATE(9738), 1,
      sym_constraint,
    STATE(9965), 1,
      sym__constraint_literal,
    STATE(9966), 1,
      sym__key_constraint,
    STATE(11974), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9955), 2,
      sym__check_constraint,
      sym__primary_key_constraint,
  [451527] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13140), 1,
      sym_keyword_on,
    STATE(7781), 1,
      sym_index_hint,
    STATE(11915), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451563] = 11,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(12280), 1,
      sym_keyword_password,
    ACTIONS(12282), 1,
      sym_keyword_encrypted,
    ACTIONS(12284), 1,
      sym_keyword_valid,
    ACTIONS(12286), 1,
      sym_keyword_connection,
    STATE(7124), 1,
      sym_identifier,
    STATE(7313), 1,
      aux_sym_alter_role_repeat1,
    STATE(7623), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13142), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [451601] = 12,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10169), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [451641] = 11,
    ACTIONS(13146), 1,
      sym__identifier,
    ACTIONS(13149), 1,
      sym_keyword_password,
    ACTIONS(13152), 1,
      sym_keyword_encrypted,
    ACTIONS(13155), 1,
      sym_keyword_valid,
    ACTIONS(13158), 1,
      sym_keyword_connection,
    STATE(7124), 1,
      sym_identifier,
    STATE(7313), 1,
      aux_sym_alter_role_repeat1,
    STATE(7623), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13161), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13144), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [451679] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13104), 1,
      sym_keyword_using,
    ACTIONS(13164), 1,
      sym_keyword_on,
    STATE(7772), 1,
      sym_index_hint,
    STATE(11926), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451715] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9510), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [451755] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7553), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [451779] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7414), 1,
      sym_order_by,
    STATE(7552), 1,
      sym_window_clause,
    STATE(7645), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [451811] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13168), 1,
      sym_keyword_table,
    ACTIONS(13172), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(8099), 1,
      sym_object_reference,
    STATE(10769), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13170), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13166), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [451847] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13176), 1,
      sym_keyword_role,
    ACTIONS(13178), 1,
      sym_keyword_transaction,
    ACTIONS(13180), 1,
      sym_keyword_local,
    ACTIONS(13182), 1,
      sym_keyword_session,
    ACTIONS(13184), 1,
      sym_keyword_constraints,
    ACTIONS(13186), 1,
      sym_keyword_time,
    STATE(6414), 1,
      sym_identifier,
    STATE(11424), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13174), 2,
      sym_keyword_schema,
      sym_keyword_names,
  [451887] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(13188), 1,
      sym_keyword_on,
    STATE(7777), 1,
      sym_index_hint,
    STATE(11920), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451923] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(13190), 1,
      sym_keyword_on,
    STATE(7780), 1,
      sym_index_hint,
    STATE(11917), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [451959] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7448), 1,
      sym_order_by,
    STATE(7529), 1,
      sym_window_clause,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [451991] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13192), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452011] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13194), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452031] = 13,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(11084), 1,
      sym_keyword_check,
    ACTIONS(13196), 1,
      sym_keyword_key,
    ACTIONS(13198), 1,
      sym_keyword_constraint,
    ACTIONS(13200), 1,
      sym_keyword_index,
    ACTIONS(13202), 1,
      sym_keyword_unique,
    ACTIONS(13204), 1,
      sym_keyword_foreign,
    STATE(10234), 1,
      sym__constraint_literal,
    STATE(10235), 1,
      sym__key_constraint,
    STATE(10374), 1,
      sym_constraint,
    STATE(11640), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10232), 2,
      sym__check_constraint,
      sym__primary_key_constraint,
  [452073] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7511), 1,
      sym_order_by,
    STATE(7523), 1,
      sym_window_clause,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [452105] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13206), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452125] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7420), 1,
      sym_order_by,
    STATE(7522), 1,
      sym_window_clause,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [452157] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(13208), 1,
      sym_keyword_on,
    STATE(7785), 1,
      sym_index_hint,
    STATE(11914), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [452193] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7442), 1,
      sym_order_by,
    STATE(7520), 1,
      sym_window_clause,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [452225] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13210), 1,
      sym_keyword_on,
    STATE(7825), 1,
      sym_index_hint,
    STATE(11746), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [452261] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7476), 1,
      sym_order_by,
    STATE(7518), 1,
      sym_window_clause,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [452293] = 13,
    ACTIONS(13212), 1,
      sym_keyword_increment,
    ACTIONS(13215), 1,
      sym_keyword_minvalue,
    ACTIONS(13218), 1,
      sym_keyword_maxvalue,
    ACTIONS(13221), 1,
      sym_keyword_owned,
    ACTIONS(13224), 1,
      sym_keyword_start,
    ACTIONS(13227), 1,
      sym_keyword_restart,
    ACTIONS(13230), 1,
      sym_keyword_as,
    ACTIONS(13233), 1,
      sym_keyword_no,
    ACTIONS(13236), 1,
      sym_keyword_cycle,
    ACTIONS(13239), 1,
      sym_keyword_cache,
    STATE(7333), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12943), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [452335] = 12,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10081), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [452375] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [452403] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13242), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452423] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13244), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452443] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [452467] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13246), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452487] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7536), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13248), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [452511] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12809), 13,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      sym_keyword_window,
  [452531] = 13,
    ACTIONS(12646), 1,
      sym_keyword_increment,
    ACTIONS(12648), 1,
      sym_keyword_minvalue,
    ACTIONS(12650), 1,
      sym_keyword_maxvalue,
    ACTIONS(12652), 1,
      sym_keyword_owned,
    ACTIONS(12654), 1,
      sym_keyword_start,
    ACTIONS(12656), 1,
      sym_keyword_restart,
    ACTIONS(12658), 1,
      sym_keyword_as,
    ACTIONS(12660), 1,
      sym_keyword_no,
    ACTIONS(12668), 1,
      sym_keyword_cache,
    ACTIONS(13250), 1,
      sym_keyword_cycle,
    STATE(7333), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12941), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [452573] = 12,
    ACTIONS(12987), 1,
      sym_keyword_increment,
    ACTIONS(12989), 1,
      sym_keyword_minvalue,
    ACTIONS(12991), 1,
      sym_keyword_maxvalue,
    ACTIONS(12993), 1,
      sym_keyword_owned,
    ACTIONS(12995), 1,
      sym_keyword_start,
    ACTIONS(12997), 1,
      sym_keyword_as,
    ACTIONS(12999), 1,
      sym_keyword_no,
    ACTIONS(13003), 1,
      sym_keyword_cache,
    ACTIONS(13252), 1,
      sym_keyword_cycle,
    STATE(7245), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12934), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [452613] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13044), 1,
      sym_keyword_using,
    ACTIONS(13254), 1,
      sym_keyword_on,
    STATE(7809), 1,
      sym_index_hint,
    STATE(11652), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [452649] = 12,
    ACTIONS(13256), 1,
      sym_keyword_increment,
    ACTIONS(13259), 1,
      sym_keyword_minvalue,
    ACTIONS(13262), 1,
      sym_keyword_maxvalue,
    ACTIONS(13265), 1,
      sym_keyword_owned,
    ACTIONS(13268), 1,
      sym_keyword_start,
    ACTIONS(13271), 1,
      sym_keyword_as,
    ACTIONS(13274), 1,
      sym_keyword_no,
    ACTIONS(13277), 1,
      sym_keyword_cycle,
    ACTIONS(13280), 1,
      sym_keyword_cache,
    STATE(7345), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12903), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [452689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13283), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452709] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13285), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452729] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13287), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452749] = 14,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13289), 1,
      sym_keyword_on,
    ACTIONS(13291), 1,
      sym_keyword_concurrently,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7818), 1,
      sym__if_not_exists,
    STATE(13798), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [452793] = 12,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9942), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [452833] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13293), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452853] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    STATE(7578), 1,
      sym_group_by,
    STATE(7849), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [452889] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13295), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
      anon_sym_RPAREN,
  [452909] = 12,
    ACTIONS(12987), 1,
      sym_keyword_increment,
    ACTIONS(12989), 1,
      sym_keyword_minvalue,
    ACTIONS(12991), 1,
      sym_keyword_maxvalue,
    ACTIONS(12993), 1,
      sym_keyword_owned,
    ACTIONS(12995), 1,
      sym_keyword_start,
    ACTIONS(12997), 1,
      sym_keyword_as,
    ACTIONS(12999), 1,
      sym_keyword_no,
    ACTIONS(13001), 1,
      sym_keyword_cycle,
    ACTIONS(13003), 1,
      sym_keyword_cache,
    STATE(7345), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12901), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [452949] = 14,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    ACTIONS(12860), 1,
      anon_sym_LPAREN,
    ACTIONS(12864), 1,
      sym__double_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(7433), 1,
      sym_invocation,
    STATE(7461), 1,
      sym__column,
    STATE(7566), 1,
      sym_identifier,
    STATE(11665), 1,
      sym__index_field,
    STATE(13604), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [452993] = 14,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13100), 1,
      sym_keyword_if,
    ACTIONS(13297), 1,
      sym_keyword_column,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7694), 1,
      sym__if_exists,
    STATE(8188), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [453037] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [453065] = 11,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(12280), 1,
      sym_keyword_password,
    ACTIONS(12282), 1,
      sym_keyword_encrypted,
    ACTIONS(12284), 1,
      sym_keyword_valid,
    ACTIONS(12286), 1,
      sym_keyword_connection,
    STATE(7124), 1,
      sym_identifier,
    STATE(7313), 1,
      aux_sym_alter_role_repeat1,
    STATE(7623), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13299), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [453103] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13301), 1,
      sym_keyword_on,
    STATE(7840), 1,
      sym_index_hint,
    STATE(11711), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [453139] = 4,
    ACTIONS(13303), 1,
      anon_sym_COMMA,
    STATE(7360), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6767), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_window,
  [453163] = 11,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(12280), 1,
      sym_keyword_password,
    ACTIONS(12282), 1,
      sym_keyword_encrypted,
    ACTIONS(12284), 1,
      sym_keyword_valid,
    ACTIONS(12286), 1,
      sym_keyword_connection,
    STATE(7124), 1,
      sym_identifier,
    STATE(7311), 1,
      aux_sym_alter_role_repeat1,
    STATE(7623), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13306), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [453201] = 13,
    ACTIONS(12646), 1,
      sym_keyword_increment,
    ACTIONS(12648), 1,
      sym_keyword_minvalue,
    ACTIONS(12650), 1,
      sym_keyword_maxvalue,
    ACTIONS(12652), 1,
      sym_keyword_owned,
    ACTIONS(12654), 1,
      sym_keyword_start,
    ACTIONS(12656), 1,
      sym_keyword_restart,
    ACTIONS(12658), 1,
      sym_keyword_as,
    ACTIONS(12660), 1,
      sym_keyword_no,
    ACTIONS(12668), 1,
      sym_keyword_cache,
    ACTIONS(13250), 1,
      sym_keyword_cycle,
    STATE(7333), 1,
      aux_sym_alter_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12789), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [453243] = 12,
    ACTIONS(12987), 1,
      sym_keyword_increment,
    ACTIONS(12989), 1,
      sym_keyword_minvalue,
    ACTIONS(12991), 1,
      sym_keyword_maxvalue,
    ACTIONS(12993), 1,
      sym_keyword_owned,
    ACTIONS(12995), 1,
      sym_keyword_start,
    ACTIONS(12997), 1,
      sym_keyword_as,
    ACTIONS(12999), 1,
      sym_keyword_no,
    ACTIONS(13001), 1,
      sym_keyword_cycle,
    ACTIONS(13003), 1,
      sym_keyword_cache,
    STATE(7345), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12888), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [453283] = 12,
    ACTIONS(12987), 1,
      sym_keyword_increment,
    ACTIONS(12989), 1,
      sym_keyword_minvalue,
    ACTIONS(12991), 1,
      sym_keyword_maxvalue,
    ACTIONS(12993), 1,
      sym_keyword_owned,
    ACTIONS(12995), 1,
      sym_keyword_start,
    ACTIONS(12997), 1,
      sym_keyword_as,
    ACTIONS(12999), 1,
      sym_keyword_no,
    ACTIONS(13003), 1,
      sym_keyword_cache,
    ACTIONS(13308), 1,
      sym_keyword_cycle,
    STATE(7354), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12884), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [453323] = 4,
    ACTIONS(13009), 1,
      anon_sym_COMMA,
    STATE(7257), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [453347] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7294), 1,
      sym_order_by,
    STATE(7539), 1,
      sym_group_by,
    STATE(7562), 1,
      sym_limit,
    STATE(7794), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [453383] = 4,
    ACTIONS(13314), 1,
      sym_keyword_offset,
    STATE(7584), 1,
      sym_offset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13312), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [453407] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7234), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453437] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13044), 1,
      sym_keyword_using,
    ACTIONS(13316), 1,
      sym_keyword_on,
    STATE(7932), 1,
      sym_index_hint,
    STATE(12005), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [453473] = 12,
    ACTIONS(12987), 1,
      sym_keyword_increment,
    ACTIONS(12989), 1,
      sym_keyword_minvalue,
    ACTIONS(12991), 1,
      sym_keyword_maxvalue,
    ACTIONS(12993), 1,
      sym_keyword_owned,
    ACTIONS(12995), 1,
      sym_keyword_start,
    ACTIONS(12997), 1,
      sym_keyword_as,
    ACTIONS(12999), 1,
      sym_keyword_no,
    ACTIONS(13003), 1,
      sym_keyword_cache,
    ACTIONS(13318), 1,
      sym_keyword_cycle,
    STATE(7363), 1,
      aux_sym_create_sequence_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12834), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [453513] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7202), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453543] = 14,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13320), 1,
      sym_keyword_on,
    ACTIONS(13322), 1,
      sym_keyword_concurrently,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7890), 1,
      sym__if_not_exists,
    STATE(13320), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [453587] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7414), 1,
      sym_order_by,
    STATE(7645), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [453615] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10341), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [453655] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7265), 1,
      sym_order_by,
    STATE(7545), 1,
      sym_group_by,
    STATE(7591), 1,
      sym_limit,
    STATE(7904), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [453691] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7200), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453721] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7199), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453751] = 14,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13324), 1,
      sym_keyword_on,
    ACTIONS(13326), 1,
      sym_keyword_concurrently,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7872), 1,
      sym__if_not_exists,
    STATE(13345), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [453795] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7197), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453825] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7236), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453855] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10120), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [453895] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7241), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453925] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7243), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [453955] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10422), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [453995] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10419), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [454035] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10391), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [454075] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7338), 1,
      sym_order_by,
    STATE(7559), 1,
      sym_group_by,
    STATE(7585), 1,
      sym_limit,
    STATE(7845), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454111] = 4,
    ACTIONS(13330), 1,
      anon_sym_COMMA,
    STATE(7388), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454135] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13333), 1,
      sym_keyword_on,
    STATE(7909), 1,
      sym_index_hint,
    STATE(11813), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [454171] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7170), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454201] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454225] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7166), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454255] = 13,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(11003), 1,
      sym_keyword_check,
    ACTIONS(13130), 1,
      sym_keyword_key,
    ACTIONS(13132), 1,
      sym_keyword_constraint,
    ACTIONS(13134), 1,
      sym_keyword_index,
    ACTIONS(13136), 1,
      sym_keyword_unique,
    ACTIONS(13138), 1,
      sym_keyword_foreign,
    STATE(9965), 1,
      sym__constraint_literal,
    STATE(9966), 1,
      sym__key_constraint,
    STATE(11579), 1,
      sym_constraint,
    STATE(11974), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9955), 2,
      sym__check_constraint,
      sym__primary_key_constraint,
  [454297] = 10,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13335), 1,
      sym_keyword_on,
    STATE(7852), 1,
      sym_index_hint,
    STATE(11762), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [454333] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9483), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [454373] = 12,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10455), 3,
      sym__dml_read,
      sym__insert_values,
      sym__set_values,
  [454413] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7167), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454443] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7244), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454473] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7175), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454503] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454527] = 6,
    ACTIONS(9088), 1,
      sym_keyword_order,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7457), 1,
      sym_order_by,
    STATE(7655), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [454555] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [454575] = 4,
    ACTIONS(13040), 1,
      anon_sym_COMMA,
    STATE(7260), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13337), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454599] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7192), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454629] = 7,
    ACTIONS(12795), 1,
      sym_keyword_freeze,
    ACTIONS(12799), 1,
      sym_keyword_header,
    ACTIONS(12801), 1,
      sym_keyword_format,
    STATE(7196), 1,
      aux_sym__copy_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12797), 3,
      sym_keyword_force_quote,
      sym_keyword_force_null,
      sym_keyword_force_not_null,
    ACTIONS(12793), 6,
      sym_keyword_default,
      sym_keyword_escape,
      sym_keyword_encoding,
      sym_keyword_quote,
      sym_keyword_delimiter,
      sym_keyword_null,
  [454659] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13339), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454679] = 5,
    ACTIONS(12767), 1,
      anon_sym_LBRACK,
    STATE(2250), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(2637), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [454705] = 10,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10774), 1,
      sym_keyword_group,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7400), 1,
      sym_order_by,
    STATE(7564), 1,
      sym_group_by,
    STATE(7593), 1,
      sym_limit,
    STATE(7888), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454741] = 11,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12368), 1,
      sym_keyword_password,
    ACTIONS(12370), 1,
      sym_keyword_encrypted,
    ACTIONS(12372), 1,
      sym_keyword_valid,
    ACTIONS(12374), 1,
      sym_keyword_connection,
    STATE(7207), 1,
      sym_identifier,
    STATE(7509), 1,
      aux_sym_alter_role_repeat1,
    STATE(7922), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13142), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [454778] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [454797] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13341), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [454816] = 4,
    ACTIONS(13343), 1,
      anon_sym_COMMA,
    STATE(7498), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13038), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
  [454839] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(144), 1,
      sym_identifier,
    STATE(10121), 1,
      sym_column_definition,
    STATE(10359), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [454880] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7655), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [454903] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12518), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [454922] = 10,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13345), 1,
      sym_keyword_only,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7455), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    STATE(9505), 2,
      sym__mysql_update_statement,
      sym__postgres_update_statement,
  [454957] = 4,
    ACTIONS(13349), 1,
      anon_sym_COMMA,
    STATE(7417), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [454980] = 4,
    ACTIONS(13352), 1,
      anon_sym_COMMA,
    STATE(7417), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [455003] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1750), 1,
      anon_sym_RPAREN,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(143), 1,
      sym_identifier,
    STATE(10121), 1,
      sym_column_definition,
    STATE(11195), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455044] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [455067] = 4,
    ACTIONS(13354), 1,
      anon_sym_COMMA,
    STATE(7508), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13337), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [455090] = 10,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13356), 1,
      sym_keyword_only,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7429), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    STATE(10876), 2,
      sym__mysql_update_statement,
      sym__postgres_update_statement,
  [455125] = 10,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(7436), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(8165), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7627), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [455160] = 13,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13068), 1,
      sym_keyword_on,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7838), 1,
      sym__if_not_exists,
    STATE(14031), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455201] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13370), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(7970), 1,
      sym_object_reference,
    STATE(10450), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13368), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13366), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [455234] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13339), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [455253] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13372), 1,
      anon_sym_RPAREN,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(139), 1,
      sym_identifier,
    STATE(9621), 1,
      sym_column_definition,
    STATE(10950), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455294] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(140), 1,
      sym_identifier,
    STATE(9621), 1,
      sym_column_definition,
    STATE(10905), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455335] = 10,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(7439), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(8227), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7636), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [455370] = 11,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13376), 1,
      sym_keyword_role,
    ACTIONS(13378), 1,
      sym_keyword_authorization,
    ACTIONS(13380), 1,
      sym_keyword_session,
    ACTIONS(13382), 1,
      sym_keyword_characteristics,
    ACTIONS(13384), 1,
      sym_keyword_time,
    STATE(6414), 1,
      sym_identifier,
    STATE(11607), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13374), 2,
      sym_keyword_schema,
      sym_keyword_names,
  [455407] = 13,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13386), 1,
      sym_keyword_on,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7811), 1,
      sym__if_not_exists,
    STATE(13382), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455448] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(142), 1,
      sym_identifier,
    STATE(9621), 1,
      sym_column_definition,
    STATE(10884), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455489] = 10,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(13390), 1,
      sym_keyword_collate,
    ACTIONS(13392), 1,
      sym_keyword_nulls,
    STATE(8611), 1,
      sym__operator_class,
    STATE(8633), 1,
      sym_identifier,
    STATE(10582), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13388), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(13394), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [455524] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13396), 1,
      anon_sym_RPAREN,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(138), 1,
      sym_identifier,
    STATE(10121), 1,
      sym_column_definition,
    STATE(10396), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455565] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(13398), 1,
      sym_keyword_collate,
    ACTIONS(13400), 1,
      sym_keyword_engine,
    ACTIONS(13402), 1,
      sym_keyword_default,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10432), 1,
      sym_table_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13792), 2,
      sym__literal_string,
      sym_identifier,
  [455604] = 10,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(9339), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7605), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [455639] = 10,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(13404), 1,
      sym_keyword_table,
    ACTIONS(13408), 1,
      sym_keyword_only,
    STATE(7262), 1,
      sym_identifier,
    STATE(8321), 1,
      sym_object_reference,
    STATE(11385), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13166), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(13406), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [455674] = 4,
    ACTIONS(13354), 1,
      anon_sym_COMMA,
    STATE(7421), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13038), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [455697] = 10,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(9269), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7659), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [455732] = 13,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13410), 1,
      sym_keyword_on,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7846), 1,
      sym__if_not_exists,
    STATE(14052), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455773] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [455800] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [455823] = 13,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13324), 1,
      sym_keyword_on,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7872), 1,
      sym__if_not_exists,
    STATE(13345), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455864] = 13,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13106), 1,
      sym_keyword_on,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7926), 1,
      sym__if_not_exists,
    STATE(13004), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455905] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13412), 1,
      anon_sym_RPAREN,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(141), 1,
      sym_identifier,
    STATE(10052), 1,
      sym_column_definition,
    STATE(10486), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [455946] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12549), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [455965] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13192), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [455984] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7645), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [456007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13194), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [456026] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13206), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [456045] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [456072] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7703), 1,
      sym__if_not_exists,
    STATE(8610), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [456113] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [456140] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [456167] = 10,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(7501), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(8397), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7715), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [456202] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12606), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [456221] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7670), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13248), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [456244] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12606), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [456263] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7294), 1,
      sym_order_by,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [456290] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13246), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [456309] = 10,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(13414), 1,
      sym_keyword_collate,
    ACTIONS(13416), 1,
      sym_keyword_nulls,
    STATE(8609), 1,
      sym__operator_class,
    STATE(8633), 1,
      sym_identifier,
    STATE(10577), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13388), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(13418), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [456344] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13244), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [456363] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13242), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [456382] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1760), 1,
      anon_sym_RPAREN,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(145), 1,
      sym_identifier,
    STATE(10052), 1,
      sym_column_definition,
    STATE(10278), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [456423] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13100), 1,
      sym_keyword_if,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7711), 1,
      sym__if_exists,
    STATE(8452), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [456464] = 4,
    ACTIONS(13420), 1,
      sym_keyword_offset,
    STATE(7656), 1,
      sym_offset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13312), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [456487] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_COMMA,
  [456506] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13422), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [456525] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(13398), 1,
      sym_keyword_collate,
    ACTIONS(13400), 1,
      sym_keyword_engine,
    ACTIONS(13402), 1,
      sym_keyword_default,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11708), 1,
      sym_table_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13792), 2,
      sym__literal_string,
      sym_identifier,
  [456564] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7476), 1,
      sym_order_by,
    STATE(7664), 1,
      sym_group_by,
    STATE(7707), 1,
      sym_limit,
    STATE(8087), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [456599] = 4,
    ACTIONS(13424), 1,
      anon_sym_COMMA,
    STATE(7471), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
  [456622] = 11,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12368), 1,
      sym_keyword_password,
    ACTIONS(12370), 1,
      sym_keyword_encrypted,
    ACTIONS(12372), 1,
      sym_keyword_valid,
    ACTIONS(12374), 1,
      sym_keyword_connection,
    STATE(7207), 1,
      sym_identifier,
    STATE(7409), 1,
      aux_sym_alter_role_repeat1,
    STATE(7922), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13306), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [456659] = 11,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(12368), 1,
      sym_keyword_password,
    ACTIONS(12370), 1,
      sym_keyword_encrypted,
    ACTIONS(12372), 1,
      sym_keyword_valid,
    ACTIONS(12374), 1,
      sym_keyword_connection,
    STATE(7207), 1,
      sym_identifier,
    STATE(7509), 1,
      aux_sym_alter_role_repeat1,
    STATE(7922), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13299), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [456696] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(13398), 1,
      sym_keyword_collate,
    ACTIONS(13400), 1,
      sym_keyword_engine,
    ACTIONS(13402), 1,
      sym_keyword_default,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10300), 1,
      sym_table_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13792), 2,
      sym__literal_string,
      sym_identifier,
  [456735] = 4,
    ACTIONS(13429), 1,
      sym_keyword_from,
    STATE(7576), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [456758] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [456781] = 13,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(13431), 1,
      sym_keyword_on,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7736), 1,
      sym__if_not_exists,
    STATE(12043), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [456822] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7708), 1,
      sym__if_not_exists,
    STATE(8468), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [456863] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7316), 1,
      sym_order_by,
    STATE(7531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [456890] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(9692), 1,
      sym_keyword_order,
    STATE(7340), 1,
      sym_order_by,
    STATE(7553), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [456917] = 11,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13435), 1,
      sym_keyword_role,
    ACTIONS(13437), 1,
      sym_keyword_authorization,
    ACTIONS(13439), 1,
      sym_keyword_session,
    ACTIONS(13441), 1,
      sym_keyword_characteristics,
    ACTIONS(13443), 1,
      sym_keyword_time,
    STATE(6414), 1,
      sym_identifier,
    STATE(11606), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13433), 2,
      sym_keyword_schema,
      sym_keyword_names,
  [456954] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    STATE(7665), 1,
      sym_group_by,
    STATE(8085), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [456989] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [457012] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    STATE(7667), 1,
      sym_group_by,
    STATE(8081), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [457047] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7676), 1,
      sym__if_not_exists,
    STATE(8299), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [457088] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7511), 1,
      sym_order_by,
    STATE(7669), 1,
      sym_group_by,
    STATE(7686), 1,
      sym_limit,
    STATE(8080), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [457123] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(1768), 1,
      anon_sym_RPAREN,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(146), 1,
      sym_identifier,
    STATE(10052), 1,
      sym_column_definition,
    STATE(10534), 1,
      sym__key_value_pair,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [457164] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13078), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457183] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(13398), 1,
      sym_keyword_collate,
    ACTIONS(13400), 1,
      sym_keyword_engine,
    ACTIONS(13402), 1,
      sym_keyword_default,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10472), 1,
      sym_table_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13792), 2,
      sym__literal_string,
      sym_identifier,
  [457222] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13080), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457241] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13082), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457260] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13084), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457279] = 10,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    ACTIONS(10864), 1,
      sym_keyword_group,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    STATE(7673), 1,
      sym_group_by,
    STATE(8076), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [457314] = 10,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(13445), 1,
      sym_keyword_collate,
    ACTIONS(13447), 1,
      sym_keyword_nulls,
    STATE(8633), 1,
      sym_identifier,
    STATE(8654), 1,
      sym__operator_class,
    STATE(11071), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13388), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(13449), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [457349] = 12,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    ACTIONS(13398), 1,
      sym_keyword_collate,
    ACTIONS(13400), 1,
      sym_keyword_engine,
    ACTIONS(13402), 1,
      sym_keyword_default,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11083), 1,
      sym_table_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13792), 2,
      sym__literal_string,
      sym_identifier,
  [457388] = 6,
    ACTIONS(7426), 1,
      sym_keyword_having,
    ACTIONS(7428), 1,
      anon_sym_COMMA,
    STATE(7171), 1,
      sym__having,
    STATE(7230), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
      anon_sym_RPAREN,
  [457415] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13086), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457434] = 4,
    ACTIONS(13343), 1,
      anon_sym_COMMA,
    STATE(7471), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13337), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_separator,
      sym_keyword_returning,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
  [457457] = 10,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13451), 1,
      sym_keyword_only,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7423), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    STATE(9505), 2,
      sym__mysql_update_statement,
      sym__postgres_update_statement,
  [457492] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    ACTIONS(13100), 1,
      sym_keyword_if,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7625), 1,
      sym__if_exists,
    STATE(8265), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [457533] = 10,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(6487), 1,
      aux_sym__mysql_update_statement_repeat1,
    STATE(9816), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7681), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [457568] = 4,
    ACTIONS(13352), 1,
      anon_sym_COMMA,
    STATE(7418), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [457591] = 4,
    ACTIONS(12767), 1,
      anon_sym_LBRACK,
    STATE(2609), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_default,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [457614] = 13,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10816), 1,
      sym_keyword_if,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(7637), 1,
      sym__if_not_exists,
    STATE(8194), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [457655] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13283), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457674] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13295), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457693] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13293), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457712] = 4,
    ACTIONS(13453), 1,
      anon_sym_COMMA,
    STATE(7508), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [457735] = 11,
    ACTIONS(13456), 1,
      sym__identifier,
    ACTIONS(13459), 1,
      sym_keyword_password,
    ACTIONS(13462), 1,
      sym_keyword_encrypted,
    ACTIONS(13465), 1,
      sym_keyword_valid,
    ACTIONS(13468), 1,
      sym_keyword_connection,
    STATE(7207), 1,
      sym_identifier,
    STATE(7509), 1,
      aux_sym_alter_role_repeat1,
    STATE(7922), 1,
      sym__role_options,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13144), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(13471), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [457772] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13287), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457791] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [457814] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13285), 12,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_increment,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_owned,
      sym_keyword_start,
      sym_keyword_restart,
      sym_keyword_as,
      sym_keyword_no,
      sym_keyword_cycle,
      sym_keyword_cache,
  [457833] = 4,
    ACTIONS(13474), 1,
      sym_keyword_from,
    STATE(7614), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 9,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [457855] = 4,
    ACTIONS(13476), 1,
      anon_sym_COMMA,
    STATE(7542), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13337), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [457877] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9771), 2,
      sym__dml_read,
      sym__insert_values,
  [457913] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [457939] = 4,
    ACTIONS(13480), 1,
      anon_sym_COMMA,
    STATE(7521), 1,
      aux_sym__cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13478), 9,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [457961] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [457987] = 4,
    ACTIONS(13480), 1,
      anon_sym_COMMA,
    STATE(7517), 1,
      aux_sym__cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13482), 9,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [458009] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [458035] = 4,
    ACTIONS(13486), 1,
      anon_sym_COMMA,
    STATE(7521), 1,
      aux_sym__cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13484), 9,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [458057] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [458083] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [458109] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13491), 1,
      sym_keyword_create,
    ACTIONS(13493), 1,
      sym_keyword_with,
    STATE(7716), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13489), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [458141] = 4,
    ACTIONS(13480), 1,
      anon_sym_COMMA,
    STATE(7534), 1,
      aux_sym__cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13495), 9,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [458163] = 4,
    ACTIONS(13497), 1,
      anon_sym_COMMA,
    STATE(7530), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [458185] = 6,
    ACTIONS(7601), 1,
      sym_keyword_having,
    ACTIONS(7617), 1,
      anon_sym_COMMA,
    STATE(7341), 1,
      sym__having,
    STATE(7654), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12551), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [458211] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9922), 2,
      sym__dml_read,
      sym__insert_values,
  [458247] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7414), 1,
      sym_order_by,
    STATE(7645), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [458273] = 4,
    ACTIONS(13499), 1,
      anon_sym_COMMA,
    STATE(7530), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [458295] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458313] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13504), 1,
      sym_keyword_ignore,
    STATE(6414), 1,
      sym_identifier,
    STATE(6972), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13502), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
    ACTIONS(13506), 3,
      sym_keyword_high_priority,
      sym_keyword_low_priority,
      sym_keyword_delayed,
  [458343] = 9,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(13508), 1,
      sym_keyword_nulls,
    STATE(8633), 1,
      sym_identifier,
    STATE(8651), 1,
      sym__operator_class,
    STATE(11070), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13388), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(13510), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [458375] = 4,
    ACTIONS(13480), 1,
      anon_sym_COMMA,
    STATE(7521), 1,
      aux_sym__cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13482), 9,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [458397] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    STATE(7849), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458427] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13512), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458445] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13514), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458463] = 10,
    ACTIONS(13518), 1,
      sym_keyword_table,
    ACTIONS(13520), 1,
      sym_keyword_view,
    ACTIONS(13522), 1,
      sym_keyword_sequence,
    ACTIONS(13524), 1,
      sym_keyword_index,
    ACTIONS(13526), 1,
      sym_keyword_type,
    ACTIONS(13528), 1,
      sym_keyword_database,
    ACTIONS(13530), 1,
      sym_keyword_schema,
    ACTIONS(13532), 1,
      sym_keyword_extension,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13516), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [458497] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7316), 1,
      sym_order_by,
    STATE(7531), 1,
      sym_limit,
    STATE(7857), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458527] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13534), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458551] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9454), 2,
      sym__dml_read,
      sym__insert_values,
  [458587] = 4,
    ACTIONS(13540), 1,
      anon_sym_COMMA,
    STATE(7542), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [458609] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13422), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [458627] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13545), 1,
      sym_keyword_ignore,
    STATE(6414), 1,
      sym_identifier,
    STATE(6965), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13543), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
    ACTIONS(13547), 3,
      sym_keyword_high_priority,
      sym_keyword_low_priority,
      sym_keyword_delayed,
  [458657] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7294), 1,
      sym_order_by,
    STATE(7562), 1,
      sym_limit,
    STATE(7794), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458687] = 11,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10941), 2,
      sym__dml_read,
      sym__insert_values,
  [458723] = 4,
    ACTIONS(13497), 1,
      anon_sym_COMMA,
    STATE(7526), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [458745] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13341), 11,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [458763] = 9,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(13549), 1,
      sym_keyword_nulls,
    STATE(8360), 1,
      sym__operator_class,
    STATE(8633), 1,
      sym_identifier,
    STATE(10368), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13388), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(13551), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [458795] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13553), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458819] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13555), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458837] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10047), 1,
      sym_keyword_order,
    STATE(7457), 1,
      sym_order_by,
    STATE(7655), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [458863] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13248), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458881] = 9,
    ACTIONS(1031), 1,
      sym__identifier,
    ACTIONS(13557), 1,
      sym_keyword_nulls,
    STATE(8633), 1,
      sym_identifier,
    STATE(8642), 1,
      sym__operator_class,
    STATE(11056), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13388), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(13559), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [458913] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458931] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [458949] = 9,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(13563), 1,
      sym_keyword_only,
    STATE(7262), 1,
      sym_identifier,
    STATE(8225), 1,
      sym_object_reference,
    STATE(11374), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13366), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(13561), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [458981] = 8,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(7902), 1,
      sym_keyword_as,
    STATE(6377), 1,
      sym_identifier,
    STATE(7018), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(5912), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5914), 3,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_separator,
  [459011] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    STATE(7888), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459041] = 11,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10980), 2,
      sym__dml_read,
      sym__insert_values,
  [459077] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13567), 1,
      sym_keyword_create,
    ACTIONS(13569), 1,
      sym_keyword_with,
    STATE(7604), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13565), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [459109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459127] = 5,
    ACTIONS(13573), 1,
      sym_keyword_union,
    STATE(7563), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13576), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13571), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459151] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    STATE(7904), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459181] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13579), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459205] = 5,
    ACTIONS(109), 1,
      anon_sym_LPAREN,
    ACTIONS(113), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1682), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1666), 5,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_collate,
      sym_keyword_nulls,
      sym__identifier,
  [459229] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(7970), 1,
      sym_object_reference,
    STATE(10450), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13368), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13366), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [459259] = 11,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11011), 2,
      sym__dml_read,
      sym__insert_values,
  [459295] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9531), 2,
      sym__dml_read,
      sym__insert_values,
  [459331] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(7981), 1,
      sym_object_reference,
    STATE(10751), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13583), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13581), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [459361] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13585), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459379] = 11,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11040), 2,
      sym__dml_read,
      sym__insert_values,
  [459415] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13587), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459433] = 11,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11059), 2,
      sym__dml_read,
      sym__insert_values,
  [459469] = 8,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7429), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    STATE(10830), 2,
      sym__mysql_update_statement,
      sym__postgres_update_statement,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [459499] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13589), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459517] = 8,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7423), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    STATE(9592), 2,
      sym__mysql_update_statement,
      sym__postgres_update_statement,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [459547] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(10776), 1,
      sym_keyword_window,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    STATE(7845), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459577] = 10,
    ACTIONS(13593), 1,
      sym_keyword_table,
    ACTIONS(13595), 1,
      sym_keyword_view,
    ACTIONS(13597), 1,
      sym_keyword_sequence,
    ACTIONS(13599), 1,
      sym_keyword_index,
    ACTIONS(13601), 1,
      sym_keyword_type,
    ACTIONS(13603), 1,
      sym_keyword_database,
    ACTIONS(13605), 1,
      sym_keyword_schema,
    ACTIONS(13607), 1,
      sym_keyword_extension,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13591), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [459611] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13611), 1,
      sym_keyword_ignore,
    STATE(6414), 1,
      sym_identifier,
    STATE(6954), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13609), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
    ACTIONS(13613), 3,
      sym_keyword_high_priority,
      sym_keyword_low_priority,
      sym_keyword_delayed,
  [459641] = 7,
    ACTIONS(13615), 1,
      sym_keyword_array,
    ACTIONS(13617), 1,
      anon_sym_LBRACK,
    STATE(3368), 1,
      sym_array_size_definition,
    STATE(3380), 1,
      sym__array_size_definition,
    STATE(7855), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2770), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_COMMA,
  [459669] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 2,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1370), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(1372), 5,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_collate,
      sym_keyword_nulls,
      sym__identifier,
  [459691] = 7,
    ACTIONS(13615), 1,
      sym_keyword_array,
    ACTIONS(13617), 1,
      anon_sym_LBRACK,
    STATE(3380), 1,
      sym__array_size_definition,
    STATE(3386), 1,
      sym_array_size_definition,
    STATE(7855), 1,
      aux_sym_array_size_definition_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2798), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_COMMA,
  [459719] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13619), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459737] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459755] = 11,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12526), 1,
      sym_keyword_values,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(7875), 1,
      sym__column_list,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11102), 2,
      sym__dml_read,
      sym__insert_values,
  [459791] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9585), 2,
      sym__dml_read,
      sym__insert_values,
  [459827] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    STATE(7563), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13621), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459851] = 4,
    ACTIONS(13623), 1,
      anon_sym_COMMA,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11839), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_or,
      sym_keyword_cascade,
      sym_keyword_restrict,
      sym_keyword_immediate,
      sym_keyword_deferred,
      anon_sym_RPAREN,
  [459873] = 4,
    ACTIONS(13476), 1,
      anon_sym_COMMA,
    STATE(7514), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13038), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [459895] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459913] = 8,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7455), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    STATE(9592), 2,
      sym__mysql_update_statement,
      sym__postgres_update_statement,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [459943] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [459961] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12464), 1,
      sym_keyword_values,
    ACTIONS(12474), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(7901), 1,
      sym__column_list,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9563), 2,
      sym__dml_read,
      sym__insert_values,
  [459997] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13626), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [460015] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(10052), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460050] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13628), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [460067] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13514), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [460084] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13491), 1,
      sym_keyword_create,
    ACTIONS(13630), 1,
      sym_keyword_with,
    STATE(7831), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13489), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [460115] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13587), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [460132] = 5,
    ACTIONS(13632), 1,
      sym_keyword_union,
    STATE(7601), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13635), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13571), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
  [460155] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13491), 1,
      sym_keyword_create,
    STATE(7720), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13489), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [460184] = 11,
    ACTIONS(13638), 1,
      sym_keyword_view,
    ACTIONS(13640), 1,
      sym_keyword_materialized,
    ACTIONS(13642), 1,
      sym_keyword_constraint,
    ACTIONS(13644), 1,
      sym_keyword_temp,
    ACTIONS(13646), 1,
      sym_keyword_temporary,
    ACTIONS(13648), 1,
      sym_keyword_recursive,
    ACTIONS(13650), 1,
      sym_keyword_trigger,
    ACTIONS(13652), 1,
      sym_keyword_function,
    ACTIONS(13654), 1,
      sym_keyword_definer,
    STATE(10944), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460219] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13658), 1,
      sym_keyword_create,
    STATE(7722), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13656), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [460248] = 8,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(8998), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [460277] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8156), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460312] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13567), 1,
      sym_keyword_create,
    ACTIONS(13660), 1,
      sym_keyword_with,
    STATE(7933), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13565), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [460343] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13662), 1,
      sym_keyword_only,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(5438), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [460374] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13664), 1,
      sym_keyword_only,
    STATE(1818), 1,
      sym_identifier,
    STATE(4914), 1,
      sym_relation,
    STATE(5119), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [460405] = 11,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(8767), 1,
      sym__column,
    STATE(10971), 1,
      sym_ordered_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460440] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [460457] = 8,
    ACTIONS(337), 1,
      sym__identifier,
    STATE(7262), 1,
      sym_identifier,
    STATE(8159), 1,
      sym_object_reference,
    STATE(11359), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13581), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(13666), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [460486] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13668), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [460503] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13589), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [460520] = 5,
    ACTIONS(13670), 1,
      sym_keyword_union,
    STATE(7601), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13672), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13621), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
  [460543] = 5,
    ACTIONS(13670), 1,
      sym_keyword_union,
    STATE(7615), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13672), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13579), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
  [460566] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13674), 1,
      sym_keyword_only,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(6254), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [460597] = 8,
    ACTIONS(337), 1,
      sym__identifier,
    STATE(7262), 1,
      sym_identifier,
    STATE(8225), 1,
      sym_object_reference,
    STATE(11374), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13366), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(13561), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [460626] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13678), 2,
      sym_keyword_follows,
      sym_keyword_precedes,
    ACTIONS(13676), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [460645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [460662] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8210), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460697] = 5,
    ACTIONS(13670), 1,
      sym_keyword_union,
    STATE(7615), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13672), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13534), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
  [460720] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13680), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13682), 5,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym__identifier,
  [460739] = 11,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(8767), 1,
      sym__column,
    STATE(10715), 1,
      sym_ordered_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460774] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8212), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460809] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13376), 1,
      sym_keyword_role,
    ACTIONS(13380), 1,
      sym_keyword_session,
    ACTIONS(13384), 1,
      sym_keyword_time,
    STATE(6414), 1,
      sym_identifier,
    STATE(11607), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13374), 2,
      sym_keyword_schema,
      sym_keyword_names,
  [460840] = 8,
    ACTIONS(12466), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(9339), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [460869] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(9621), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460904] = 9,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(13684), 1,
      sym_keyword_only,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    STATE(3575), 1,
      sym_identifier,
    STATE(5047), 1,
      sym_relation,
    STATE(6179), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
  [460935] = 11,
    ACTIONS(217), 1,
      sym__identifier,
    ACTIONS(275), 1,
      aux_sym_identifier_token1,
    ACTIONS(4158), 1,
      sym__double_quote_string,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(4168), 1,
      sym__dollar_quoted_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(8767), 1,
      sym__column,
    STATE(11498), 1,
      sym_ordered_column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [460970] = 5,
    ACTIONS(13670), 1,
      sym_keyword_union,
    STATE(7615), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13672), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13553), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_returning,
  [460993] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13555), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461010] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13688), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7394), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [461041] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13585), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461058] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13690), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7280), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [461089] = 8,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(9269), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [461118] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8214), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [461153] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461170] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13692), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [461187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13626), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461204] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13694), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7281), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [461235] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8299), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [461270] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461287] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13698), 1,
      sym_keyword_create,
    STATE(7722), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13696), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [461316] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461333] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13700), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7282), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [461364] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13702), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [461381] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(11922), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [461416] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13704), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [461433] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13706), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7359), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [461464] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(9782), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [461499] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13708), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(6685), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [461530] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13712), 1,
      sym_keyword_where,
    STATE(8012), 1,
      sym_where,
    STATE(8480), 1,
      sym_order_by,
    STATE(10217), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13710), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [461559] = 4,
    ACTIONS(13714), 1,
      anon_sym_COMMA,
    STATE(7654), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6767), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_order,
      sym_keyword_having,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
      sym_keyword_window,
  [461580] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13248), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461597] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13619), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461614] = 4,
    ACTIONS(13717), 1,
      sym_keyword_from,
    STATE(7576), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      anon_sym_RPAREN,
  [461635] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    STATE(8087), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [461664] = 8,
    ACTIONS(12528), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(9187), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [461693] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13719), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [461710] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13721), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [461727] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13721), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [461744] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13435), 1,
      sym_keyword_role,
    ACTIONS(13439), 1,
      sym_keyword_session,
    ACTIONS(13443), 1,
      sym_keyword_time,
    STATE(6414), 1,
      sym_identifier,
    STATE(11606), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13433), 2,
      sym_keyword_schema,
      sym_keyword_names,
  [461775] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    STATE(8085), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [461804] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    STATE(8081), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [461833] = 4,
    ACTIONS(13723), 1,
      anon_sym_COMMA,
    STATE(7668), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13038), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [461854] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    STATE(8080), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [461883] = 4,
    ACTIONS(13723), 1,
      anon_sym_COMMA,
    STATE(7671), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13337), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [461904] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    STATE(8076), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [461933] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13512), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [461950] = 4,
    ACTIONS(13725), 1,
      anon_sym_COMMA,
    STATE(7671), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [461971] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8610), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462006] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(9096), 1,
      sym_keyword_window,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7414), 1,
      sym_order_by,
    STATE(7645), 1,
      sym_limit,
    STATE(8075), 1,
      sym_window_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [462035] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(10121), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462070] = 11,
    ACTIONS(13728), 1,
      sym_keyword_view,
    ACTIONS(13730), 1,
      sym_keyword_materialized,
    ACTIONS(13732), 1,
      sym_keyword_constraint,
    ACTIONS(13734), 1,
      sym_keyword_temp,
    ACTIONS(13736), 1,
      sym_keyword_temporary,
    ACTIONS(13738), 1,
      sym_keyword_recursive,
    ACTIONS(13740), 1,
      sym_keyword_trigger,
    ACTIONS(13742), 1,
      sym_keyword_function,
    ACTIONS(13744), 1,
      sym_keyword_definer,
    STATE(10315), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462105] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8194), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462140] = 9,
    ACTIONS(13748), 1,
      sym_keyword_table,
    ACTIONS(13750), 1,
      sym_keyword_view,
    ACTIONS(13752), 1,
      sym_keyword_sequence,
    ACTIONS(13754), 1,
      sym_keyword_index,
    ACTIONS(13756), 1,
      sym_keyword_type,
    ACTIONS(13758), 1,
      sym_keyword_database,
    ACTIONS(13760), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13746), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [462171] = 4,
    ACTIONS(13762), 1,
      anon_sym_COMMA,
    STATE(7679), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [462192] = 4,
    ACTIONS(13764), 1,
      anon_sym_COMMA,
    STATE(7679), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [462213] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13767), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7321), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462244] = 8,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(10064), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [462273] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    ACTIONS(13769), 1,
      sym_keyword_values,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13862), 1,
      sym__dml_read,
    STATE(13890), 1,
      sym_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462308] = 9,
    ACTIONS(13773), 1,
      sym_keyword_table,
    ACTIONS(13775), 1,
      sym_keyword_view,
    ACTIONS(13777), 1,
      sym_keyword_sequence,
    ACTIONS(13779), 1,
      sym_keyword_index,
    ACTIONS(13781), 1,
      sym_keyword_type,
    ACTIONS(13783), 1,
      sym_keyword_database,
    ACTIONS(13785), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13771), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [462339] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13787), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7320), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462370] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8374), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462405] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [462422] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13789), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [462439] = 11,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    ACTIONS(13769), 1,
      sym_keyword_values,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13455), 1,
      sym__dml_read,
    STATE(13852), 1,
      sym_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462474] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13789), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [462491] = 9,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    ACTIONS(13791), 1,
      sym_keyword_only,
    STATE(3575), 1,
      sym_identifier,
    STATE(6179), 1,
      sym_object_reference,
    STATE(6347), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
  [462522] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13793), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7314), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462553] = 9,
    ACTIONS(13775), 1,
      sym_keyword_view,
    ACTIONS(13777), 1,
      sym_keyword_sequence,
    ACTIONS(13779), 1,
      sym_keyword_index,
    ACTIONS(13781), 1,
      sym_keyword_type,
    ACTIONS(13783), 1,
      sym_keyword_database,
    ACTIONS(13785), 1,
      sym_keyword_schema,
    ACTIONS(13795), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13771), 3,
      sym_keyword_group,
      sym_keyword_user,
      sym_keyword_role,
  [462584] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13797), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [462601] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8265), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462636] = 9,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    ACTIONS(13799), 1,
      sym_keyword_only,
    STATE(3575), 1,
      sym_identifier,
    STATE(5753), 1,
      sym_relation,
    STATE(6179), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
  [462667] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13801), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7290), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462698] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(58), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8295), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462733] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8451), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462768] = 8,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13712), 1,
      sym_keyword_where,
    STATE(8088), 1,
      sym_where,
    STATE(8350), 1,
      sym_order_by,
    STATE(9611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [462797] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13805), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7291), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13809), 2,
      sym_keyword_follows,
      sym_keyword_precedes,
    ACTIONS(13807), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [462847] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8452), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462882] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8468), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [462917] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13811), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7306), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462948] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13813), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7295), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [462979] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13815), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7305), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [463010] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 10,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
      sym_keyword_returning,
  [463027] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8606), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463062] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13817), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7344), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [463093] = 9,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    ACTIONS(13819), 1,
      sym_keyword_lateral,
    STATE(3575), 1,
      sym_identifier,
    STATE(6179), 1,
      sym_object_reference,
    STATE(6758), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
  [463124] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8603), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463159] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13821), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7303), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [463190] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13825), 1,
      sym_keyword_create,
    STATE(7644), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13823), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [463219] = 11,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(125), 1,
      aux_sym_identifier_token1,
    ACTIONS(10822), 1,
      sym__double_quote_string,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10826), 1,
      sym__dollar_quoted_string,
    STATE(41), 1,
      sym__column,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(8598), 1,
      sym_column_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463254] = 8,
    ACTIONS(12510), 1,
      sym_keyword_set,
    ACTIONS(13360), 1,
      sym_keyword_inner,
    ACTIONS(13362), 1,
      sym_keyword_join,
    ACTIONS(13364), 1,
      sym_keyword_natural,
    STATE(9816), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(13358), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [463283] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13829), 1,
      sym_keyword_create,
    STATE(7722), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13827), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [463312] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13831), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7301), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [463343] = 4,
    ACTIONS(13762), 1,
      anon_sym_COMMA,
    STATE(7678), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [463364] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13833), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [463381] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13829), 1,
      sym_keyword_create,
    STATE(7722), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13827), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [463410] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13835), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7300), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [463441] = 8,
    ACTIONS(13839), 1,
      sym__identifier,
    ACTIONS(13842), 1,
      sym_keyword_create,
    STATE(7722), 1,
      aux_sym_create_database_repeat1,
    STATE(8139), 1,
      sym_identifier,
    STATE(8286), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13844), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13837), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [463470] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13833), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [463487] = 9,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    ACTIONS(13847), 1,
      sym_keyword_lateral,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7298), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
  [463518] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13484), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [463535] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13849), 10,
      sym_keyword_select,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_replace,
      sym_keyword_update,
      sym_keyword_truncate,
      sym_keyword_copy,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [463552] = 7,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    STATE(3575), 1,
      sym_identifier,
    STATE(5754), 1,
      sym_relation,
    STATE(6179), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [463578] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8736), 1,
      sym_create_query,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463610] = 8,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(13855), 1,
      sym_keyword_set,
    ACTIONS(13857), 1,
      sym_keyword_alter,
    ACTIONS(13859), 1,
      sym_keyword_drop,
    ACTIONS(13861), 1,
      sym_keyword_add,
    ACTIONS(13863), 1,
      sym_keyword_rename,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10493), 3,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [463638] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7281), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [463664] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13865), 1,
      sym_keyword_on,
    ACTIONS(13867), 1,
      sym_keyword_using,
    STATE(11943), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [463692] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13698), 1,
      sym_keyword_create,
    STATE(7826), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13696), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [463720] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7282), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [463746] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(13124), 1,
      sym_keyword_on,
    STATE(11937), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [463774] = 3,
    ACTIONS(13869), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [463792] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(13460), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463824] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(13126), 1,
      sym_keyword_on,
    STATE(11933), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [463852] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(13871), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    STATE(10171), 1,
      sym__dml_read,
    STATE(10320), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463884] = 4,
    ACTIONS(13873), 1,
      sym_keyword_from,
    STATE(7614), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [463904] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(13128), 1,
      sym_keyword_on,
    STATE(11932), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [463932] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10166), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463964] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10163), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [463996] = 4,
    ACTIONS(13881), 1,
      anon_sym_COMMA,
    STATE(7743), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13879), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
  [464016] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13118), 1,
      sym_keyword_on,
    ACTIONS(13120), 1,
      sym_keyword_using,
    STATE(11944), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464044] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7289), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464070] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7291), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464096] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13898), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464128] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13867), 1,
      sym_keyword_using,
    ACTIONS(13900), 1,
      sym_keyword_on,
    STATE(11931), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464156] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13898), 1,
      sym_keyword_execute,
    ACTIONS(13902), 1,
      sym_keyword_deferrable,
    STATE(7793), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464188] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13114), 1,
      sym_keyword_on,
    ACTIONS(13116), 1,
      sym_keyword_using,
    STATE(11945), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464216] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13110), 1,
      sym_keyword_on,
    ACTIONS(13112), 1,
      sym_keyword_using,
    STATE(11946), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464244] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13906), 1,
      sym_keyword_nulls,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(10127), 1,
      sym_ordered_columns,
    STATE(11660), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13904), 2,
      sym_keyword_key,
      sym_keyword_index,
  [464272] = 7,
    ACTIONS(13910), 1,
      anon_sym_RPAREN,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    STATE(9094), 1,
      sym_identifier,
    STATE(10444), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7971), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464298] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9166), 1,
      sym_create_query,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464330] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9167), 1,
      sym_create_query,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464362] = 7,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(13914), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(10643), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7971), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464388] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13920), 1,
      anon_sym_RPAREN,
    STATE(8131), 1,
      sym_partition_by,
    STATE(8747), 1,
      sym_order_by,
    STATE(13994), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [464416] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7295), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464442] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7278), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464468] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9279), 1,
      sym_create_query,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464500] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7296), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464526] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7263), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464552] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13922), 1,
      sym_keyword_on,
    ACTIONS(13924), 1,
      sym_keyword_using,
    STATE(11954), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464580] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9142), 1,
      sym_create_query,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464612] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13926), 1,
      anon_sym_RPAREN,
    STATE(8322), 1,
      sym_partition_by,
    STATE(9098), 1,
      sym_order_by,
    STATE(12528), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [464640] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7266), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464666] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10069), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464698] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13928), 1,
      sym_keyword_deferrable,
    ACTIONS(13930), 1,
      sym_keyword_execute,
    STATE(7927), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464730] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(13871), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    STATE(10171), 1,
      sym__dml_read,
    STATE(10451), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464762] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10171), 1,
      sym__dml_read,
    STATE(10187), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464794] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13096), 1,
      sym_keyword_on,
    STATE(11958), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464822] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(13188), 1,
      sym_keyword_on,
    STATE(11920), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [464850] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10039), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464882] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10171), 1,
      sym__dml_read,
    STATE(10186), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464914] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(13871), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    STATE(10171), 1,
      sym__dml_read,
    STATE(10304), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [464946] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7300), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [464972] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(13190), 1,
      sym_keyword_on,
    STATE(11917), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465000] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13932), 1,
      anon_sym_RPAREN,
    STATE(8236), 1,
      sym_partition_by,
    STATE(8964), 1,
      sym_order_by,
    STATE(12035), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [465028] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13094), 1,
      sym_keyword_on,
    STATE(11959), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465056] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(13208), 1,
      sym_keyword_on,
    STATE(11914), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465084] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13210), 1,
      sym_keyword_on,
    STATE(11746), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465112] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(10753), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465144] = 7,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    STATE(3575), 1,
      sym_identifier,
    STATE(6179), 1,
      sym_object_reference,
    STATE(6346), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465170] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7301), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465196] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13867), 1,
      sym_keyword_using,
    ACTIONS(13934), 1,
      sym_keyword_on,
    STATE(11912), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465224] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13936), 1,
      anon_sym_RPAREN,
    STATE(8201), 1,
      sym_partition_by,
    STATE(9058), 1,
      sym_order_by,
    STATE(12339), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [465252] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7302), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465278] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13938), 1,
      sym_keyword_deferrable,
    ACTIONS(13940), 1,
      sym_keyword_execute,
    STATE(7747), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465310] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13940), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465342] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13092), 1,
      sym_keyword_on,
    STATE(11963), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465370] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13942), 1,
      anon_sym_RPAREN,
    STATE(8270), 1,
      sym_partition_by,
    STATE(8922), 1,
      sym_order_by,
    STATE(12302), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [465398] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7305), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465424] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13944), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465456] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7316), 1,
      sym_order_by,
    STATE(7531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [465480] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13944), 1,
      sym_keyword_execute,
    ACTIONS(13946), 1,
      sym_keyword_deferrable,
    STATE(7819), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465512] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7306), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465538] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7391), 1,
      sym_order_by,
    STATE(7555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [465562] = 10,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(8993), 1,
      sym__dml_read,
    STATE(10078), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465594] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7307), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465620] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13948), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465652] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(9928), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465684] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(10016), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465716] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7320), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465742] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(13871), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    STATE(10171), 1,
      sym__dml_read,
    STATE(10555), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465774] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13950), 1,
      anon_sym_RPAREN,
    STATE(8254), 1,
      sym_partition_by,
    STATE(8697), 1,
      sym_order_by,
    STATE(14266), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [465802] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9356), 1,
      sym__cte,
    STATE(9414), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465834] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13948), 1,
      sym_keyword_execute,
    ACTIONS(13952), 1,
      sym_keyword_deferrable,
    STATE(7935), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465866] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(13954), 1,
      sym_keyword_on,
    STATE(11972), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465894] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13301), 1,
      sym_keyword_on,
    STATE(11711), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [465922] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7321), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [465948] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(13424), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [465980] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8934), 1,
      sym_create_query,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466012] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(10890), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466044] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13958), 1,
      sym_keyword_nulls,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9348), 1,
      sym_ordered_columns,
    STATE(11801), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13956), 2,
      sym_keyword_key,
      sym_keyword_index,
  [466072] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7329), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [466098] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9202), 1,
      sym_create_query,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466130] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(9783), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466162] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(13004), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466194] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13962), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466226] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(9669), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466258] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8749), 1,
      sym_create_query,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466290] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13962), 1,
      sym_keyword_execute,
    ACTIONS(13964), 1,
      sym_keyword_deferrable,
    STATE(7841), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466322] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13076), 1,
      sym_keyword_on,
    STATE(11975), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [466350] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(9607), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466382] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(13966), 1,
      sym_keyword_on,
    STATE(11576), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [466410] = 8,
    ACTIONS(13839), 1,
      sym__identifier,
    ACTIONS(13842), 1,
      sym_keyword_create,
    STATE(7826), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13837), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(13844), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [466438] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(13877), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8036), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(9194), 1,
      sym__cte,
    STATE(9574), 1,
      sym_create_query,
    STATE(10171), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466470] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13968), 1,
      anon_sym_RPAREN,
    STATE(8229), 1,
      sym_partition_by,
    STATE(8795), 1,
      sym_order_by,
    STATE(13600), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [466498] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(4853), 1,
      sym_relation,
    STATE(5119), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [466524] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13829), 1,
      sym_keyword_create,
    STATE(7826), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13827), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [466552] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13829), 1,
      sym_keyword_create,
    STATE(7826), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13827), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [466580] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13825), 1,
      sym_keyword_create,
    STATE(7732), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13823), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [466608] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13970), 1,
      anon_sym_RPAREN,
    STATE(8240), 1,
      sym_partition_by,
    STATE(9158), 1,
      sym_order_by,
    STATE(12752), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [466636] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13088), 1,
      sym_keyword_on,
    STATE(11973), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [466664] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(14031), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466696] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13074), 1,
      sym_keyword_on,
    STATE(11976), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [466724] = 4,
    ACTIONS(13972), 1,
      anon_sym_COMMA,
    STATE(7837), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13879), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
  [466744] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(14052), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466776] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7331), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [466802] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13335), 1,
      sym_keyword_on,
    STATE(11762), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [466830] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13975), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466862] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13975), 1,
      sym_keyword_execute,
    ACTIONS(13977), 1,
      sym_keyword_deferrable,
    STATE(7847), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466894] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13979), 1,
      anon_sym_RPAREN,
    STATE(8211), 1,
      sym_partition_by,
    STATE(8959), 1,
      sym_order_by,
    STATE(13755), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [466922] = 3,
    ACTIONS(13983), 1,
      sym_keyword_temp,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13981), 8,
      sym_keyword_view,
      sym_keyword_materialized,
      sym_keyword_constraint,
      sym_keyword_temporary,
      sym_keyword_recursive,
      sym_keyword_trigger,
      sym_keyword_function,
      sym_keyword_definer,
  [466940] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7400), 1,
      sym_order_by,
    STATE(7593), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [466964] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(14073), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [466996] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13985), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467028] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13985), 1,
      sym_keyword_execute,
    ACTIONS(13987), 1,
      sym_keyword_deferrable,
    STATE(7856), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467060] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7338), 1,
      sym_order_by,
    STATE(7585), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [467084] = 7,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(13989), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(10353), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7971), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467110] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(13991), 1,
      sym_keyword_on,
    STATE(11984), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [467138] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13333), 1,
      sym_keyword_on,
    STATE(11813), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [467166] = 7,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    STATE(3575), 1,
      sym_identifier,
    STATE(4951), 1,
      sym_relation,
    STATE(6179), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467192] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7389), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467218] = 5,
    ACTIONS(13617), 1,
      anon_sym_LBRACK,
    STATE(2847), 1,
      aux_sym_array_size_definition_repeat1,
    STATE(3380), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3228), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_COMMA,
  [467240] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13993), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467272] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7340), 1,
      sym_order_by,
    STATE(7553), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [467296] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13993), 1,
      sym_keyword_execute,
    ACTIONS(13995), 1,
      sym_keyword_deferrable,
    STATE(7864), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467328] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13997), 1,
      anon_sym_RPAREN,
    STATE(8196), 1,
      sym_partition_by,
    STATE(9040), 1,
      sym_order_by,
    STATE(12286), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [467356] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(13999), 1,
      anon_sym_RPAREN,
    STATE(8219), 1,
      sym_partition_by,
    STATE(9386), 1,
      sym_order_by,
    STATE(13385), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [467384] = 4,
    ACTIONS(14003), 1,
      anon_sym_COMMA,
    STATE(7743), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14001), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
  [467404] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13064), 1,
      sym_keyword_on,
    ACTIONS(13066), 1,
      sym_keyword_using,
    STATE(11986), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [467432] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14005), 1,
      anon_sym_RPAREN,
    STATE(8138), 1,
      sym_partition_by,
    STATE(8841), 1,
      sym_order_by,
    STATE(13462), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [467460] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14007), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467492] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14009), 1,
      sym_keyword_deferrable,
    ACTIONS(14011), 1,
      sym_keyword_execute,
    STATE(7882), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467524] = 8,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(14013), 1,
      sym_keyword_set,
    ACTIONS(14015), 1,
      sym_keyword_alter,
    ACTIONS(14017), 1,
      sym_keyword_drop,
    ACTIONS(14019), 1,
      sym_keyword_add,
    ACTIONS(14021), 1,
      sym_keyword_rename,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11352), 3,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [467552] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7394), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467578] = 4,
    ACTIONS(14025), 1,
      anon_sym_COMMA,
    STATE(7911), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14023), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
  [467598] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(8273), 1,
      sym_where,
    STATE(9095), 1,
      sym_order_by,
    STATE(10326), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [467626] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13028), 1,
      sym_keyword_on,
    ACTIONS(13030), 1,
      sym_keyword_using,
    STATE(11987), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [467654] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13036), 1,
      sym_keyword_on,
    STATE(11988), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [467682] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(13382), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467714] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13140), 1,
      sym_keyword_on,
    STATE(11915), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [467742] = 7,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    STATE(3575), 1,
      sym_identifier,
    STATE(6179), 1,
      sym_object_reference,
    STATE(6599), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6358), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467768] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(13871), 1,
      anon_sym_LPAREN,
    ACTIONS(14027), 1,
      sym_keyword_values,
    STATE(7513), 1,
      sym_select,
    STATE(7622), 1,
      sym__select_statement,
    STATE(8298), 1,
      sym_set_operation,
    STATE(8813), 1,
      sym__cte,
    STATE(9285), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467800] = 5,
    ACTIONS(14029), 1,
      sym_keyword_union,
    STATE(7897), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14031), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13553), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      anon_sym_RPAREN,
  [467822] = 7,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(14033), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(11022), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7971), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467848] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7359), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467874] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(5377), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467900] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(6569), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [467926] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14035), 1,
      sym_keyword_deferrable,
    ACTIONS(14037), 1,
      sym_keyword_execute,
    STATE(7891), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467958] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14037), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [467990] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(6256), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [468016] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14039), 1,
      anon_sym_RPAREN,
    STATE(8166), 1,
      sym_partition_by,
    STATE(8688), 1,
      sym_order_by,
    STATE(14496), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [468044] = 5,
    ACTIONS(14041), 1,
      sym_keyword_union,
    STATE(7885), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14044), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13571), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      anon_sym_RPAREN,
  [468066] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14047), 1,
      anon_sym_RPAREN,
    STATE(8155), 1,
      sym_partition_by,
    STATE(9004), 1,
      sym_order_by,
    STATE(12124), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [468094] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14049), 1,
      sym_keyword_deferrable,
    ACTIONS(14051), 1,
      sym_keyword_execute,
    STATE(7894), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468126] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7265), 1,
      sym_order_by,
    STATE(7591), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [468150] = 10,
    ACTIONS(13676), 1,
      sym_keyword_execute,
    ACTIONS(14053), 1,
      sym_keyword_from,
    ACTIONS(14056), 1,
      sym_keyword_when,
    ACTIONS(14059), 1,
      sym_keyword_not,
    ACTIONS(14062), 1,
      sym_keyword_for,
    ACTIONS(14065), 1,
      sym_keyword_deferrable,
    ACTIONS(14068), 1,
      sym_keyword_initially,
    ACTIONS(14071), 1,
      sym_keyword_referencing,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468182] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(13345), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468214] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14051), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468246] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7271), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [468272] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(8963), 1,
      sym__vacuum_option,
    STATE(10045), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14074), 3,
      sym_keyword_full,
      sym_keyword_analyze,
      sym_keyword_parallel,
  [468298] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14076), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468330] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14076), 1,
      sym_keyword_execute,
    ACTIONS(14078), 1,
      sym_keyword_deferrable,
    STATE(7899), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468362] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    STATE(7262), 1,
      sym_identifier,
    STATE(9355), 1,
      sym__vacuum_option,
    STATE(10852), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14074), 3,
      sym_keyword_full,
      sym_keyword_analyze,
      sym_keyword_parallel,
  [468388] = 5,
    ACTIONS(14029), 1,
      sym_keyword_union,
    STATE(7885), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14031), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13621), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      anon_sym_RPAREN,
  [468410] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1374), 9,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
      anon_sym_DOT,
  [468426] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14080), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468458] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7369), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [468484] = 10,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    ACTIONS(14082), 1,
      sym_keyword_values,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8473), 1,
      sym__dml_read,
    STATE(8700), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468516] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14080), 1,
      sym_keyword_execute,
    ACTIONS(14084), 1,
      sym_keyword_deferrable,
    STATE(7903), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468548] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14086), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468580] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(7294), 1,
      sym_order_by,
    STATE(7562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [468604] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13879), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [468620] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14086), 1,
      sym_keyword_execute,
    ACTIONS(14088), 1,
      sym_keyword_deferrable,
    STATE(7908), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468652] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14090), 1,
      anon_sym_RPAREN,
    STATE(8246), 1,
      sym_partition_by,
    STATE(9235), 1,
      sym_order_by,
    STATE(12949), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [468680] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14092), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468712] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(14094), 1,
      sym_keyword_on,
    STATE(11859), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [468740] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14092), 1,
      sym_keyword_execute,
    ACTIONS(14096), 1,
      sym_keyword_deferrable,
    STATE(7916), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468772] = 4,
    ACTIONS(14025), 1,
      anon_sym_COMMA,
    STATE(7837), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14001), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
  [468792] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14098), 1,
      anon_sym_RPAREN,
    STATE(8141), 1,
      sym_partition_by,
    STATE(8683), 1,
      sym_order_by,
    STATE(14463), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [468820] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7258), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [468846] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9322), 1,
      sym_create_query,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468878] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(11261), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468910] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14100), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468942] = 10,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9873), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [468974] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14100), 1,
      sym_keyword_execute,
    ACTIONS(14102), 1,
      sym_keyword_deferrable,
    STATE(7919), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469006] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14104), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469038] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14104), 1,
      sym_keyword_execute,
    ACTIONS(14106), 1,
      sym_keyword_deferrable,
    STATE(7921), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469070] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(13930), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469102] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13680), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13682), 5,
      sym_keyword_password,
      sym_keyword_encrypted,
      sym_keyword_valid,
      sym_keyword_connection,
      sym__identifier,
  [469120] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14108), 1,
      anon_sym_RPAREN,
    STATE(8182), 1,
      sym_partition_by,
    STATE(9314), 1,
      sym_order_by,
    STATE(13199), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [469148] = 5,
    ACTIONS(14029), 1,
      sym_keyword_union,
    STATE(7897), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14031), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13579), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      anon_sym_RPAREN,
  [469170] = 7,
    ACTIONS(14110), 1,
      sym_keyword_set,
    ACTIONS(14115), 1,
      sym_keyword_inner,
    ACTIONS(14118), 1,
      sym_keyword_join,
    ACTIONS(14121), 1,
      sym_keyword_natural,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7925), 2,
      sym_join,
      aux_sym__mysql_update_statement_repeat2,
    ACTIONS(14112), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [469196] = 10,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(136), 1,
      sym__literal_string,
    STATE(137), 1,
      sym_identifier,
    STATE(12043), 1,
      sym__column,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469228] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14124), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469260] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14126), 1,
      sym_keyword_deferrable,
    ACTIONS(14128), 1,
      sym_keyword_execute,
    STATE(7800), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469292] = 8,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10860), 1,
      sym_keyword_where,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(8263), 1,
      sym_where,
    STATE(9188), 1,
      sym_order_by,
    STATE(10588), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13710), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [469320] = 7,
    ACTIONS(13347), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(5119), 1,
      sym_object_reference,
    STATE(7310), 1,
      sym_relation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5532), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [469346] = 4,
    ACTIONS(14003), 1,
      anon_sym_COMMA,
    STATE(7861), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14023), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
  [469366] = 8,
    ACTIONS(13013), 1,
      sym_keyword_inner,
    ACTIONS(13015), 1,
      sym_keyword_join,
    ACTIONS(13017), 1,
      sym_keyword_natural,
    ACTIONS(13019), 1,
      sym_keyword_on,
    ACTIONS(13021), 1,
      sym_keyword_using,
    STATE(11436), 1,
      sym_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13011), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [469394] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13658), 1,
      sym_keyword_create,
    STATE(7826), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13656), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [469422] = 5,
    ACTIONS(14029), 1,
      sym_keyword_union,
    STATE(7897), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14031), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13534), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      anon_sym_RPAREN,
  [469444] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13892), 1,
      sym_keyword_deferrable,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14130), 1,
      sym_keyword_execute,
    STATE(7889), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469476] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13491), 1,
      sym_keyword_create,
    STATE(7830), 1,
      aux_sym_create_database_repeat1,
    STATE(8142), 1,
      sym_identifier,
    STATE(8643), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(13489), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [469504] = 10,
    ACTIONS(13884), 1,
      sym_keyword_from,
    ACTIONS(13886), 1,
      sym_keyword_when,
    ACTIONS(13888), 1,
      sym_keyword_not,
    ACTIONS(13890), 1,
      sym_keyword_for,
    ACTIONS(13894), 1,
      sym_keyword_initially,
    ACTIONS(13896), 1,
      sym_keyword_referencing,
    ACTIONS(14130), 1,
      sym_keyword_execute,
    ACTIONS(14132), 1,
      sym_keyword_deferrable,
    STATE(7789), 1,
      aux_sym_create_trigger_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469536] = 8,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(13916), 1,
      sym_keyword_partition,
    ACTIONS(14134), 1,
      anon_sym_RPAREN,
    STATE(8171), 1,
      sym_partition_by,
    STATE(8887), 1,
      sym_order_by,
    STATE(12892), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [469564] = 10,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9496), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469596] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8868), 1,
      sym_create_query,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469628] = 10,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(13853), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7934), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8990), 1,
      sym_create_query,
    STATE(8993), 1,
      sym__dml_read,
    STATE(9356), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469660] = 10,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(8993), 1,
      sym__dml_read,
    STATE(10096), 1,
      sym_create_query,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469692] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13456), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469721] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14136), 1,
      sym_keyword_separator,
    ACTIONS(14138), 1,
      anon_sym_RPAREN,
    ACTIONS(14140), 1,
      anon_sym_COMMA,
    STATE(8508), 1,
      sym_order_by,
    STATE(10270), 1,
      aux_sym_invocation_repeat1,
    STATE(12340), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469750] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13939), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469779] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13438), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469808] = 6,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11112), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14144), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14142), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [469831] = 4,
    ACTIONS(14150), 1,
      anon_sym_COMMA,
    STATE(7961), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14148), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [469850] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14152), 1,
      sym_keyword_separator,
    ACTIONS(14154), 1,
      anon_sym_RPAREN,
    ACTIONS(14156), 1,
      anon_sym_COMMA,
    STATE(8673), 1,
      sym_order_by,
    STATE(10646), 1,
      aux_sym_invocation_repeat1,
    STATE(14589), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469879] = 7,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(7905), 1,
      sym_assignment,
    STATE(10916), 1,
      sym_identifier,
    STATE(13362), 1,
      sym__qualified_field,
    STATE(13364), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [469904] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14160), 1,
      sym_keyword_separator,
    ACTIONS(14162), 1,
      anon_sym_RPAREN,
    ACTIONS(14164), 1,
      anon_sym_COMMA,
    STATE(8646), 1,
      sym_order_by,
    STATE(11215), 1,
      aux_sym_invocation_repeat1,
    STATE(12909), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [469933] = 4,
    ACTIONS(14150), 1,
      anon_sym_COMMA,
    STATE(7957), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14166), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [469952] = 7,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(7868), 1,
      sym_assignment,
    STATE(10916), 1,
      sym_identifier,
    STATE(13362), 1,
      sym__qualified_field,
    STATE(13364), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [469977] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13276), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470006] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(14159), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470035] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(14400), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470064] = 4,
    ACTIONS(14170), 1,
      anon_sym_COMMA,
    STATE(7957), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14168), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [470083] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14175), 1,
      sym_keyword_session,
    STATE(7262), 1,
      sym_identifier,
    STATE(11403), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14173), 2,
      sym_keyword_role,
      sym_keyword_all,
  [470108] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14177), 1,
      sym_keyword_separator,
    ACTIONS(14179), 1,
      anon_sym_RPAREN,
    ACTIONS(14181), 1,
      anon_sym_COMMA,
    STATE(8640), 1,
      sym_order_by,
    STATE(10394), 1,
      aux_sym_invocation_repeat1,
    STATE(12117), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470137] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13676), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [470152] = 4,
    ACTIONS(14150), 1,
      anon_sym_COMMA,
    STATE(7957), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14183), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [470171] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(14553), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470200] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(14559), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470229] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13402), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470258] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14185), 1,
      sym_keyword_separator,
    ACTIONS(14187), 1,
      anon_sym_RPAREN,
    ACTIONS(14189), 1,
      anon_sym_COMMA,
    STATE(8577), 1,
      sym_order_by,
    STATE(10733), 1,
      aux_sym_invocation_repeat1,
    STATE(12834), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470287] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14191), 1,
      sym_keyword_separator,
    ACTIONS(14193), 1,
      anon_sym_RPAREN,
    ACTIONS(14195), 1,
      anon_sym_COMMA,
    STATE(8621), 1,
      sym_order_by,
    STATE(10383), 1,
      aux_sym_invocation_repeat1,
    STATE(12125), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470316] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14197), 1,
      sym_keyword_separator,
    ACTIONS(14199), 1,
      anon_sym_RPAREN,
    ACTIONS(14201), 1,
      anon_sym_COMMA,
    STATE(8599), 1,
      sym_order_by,
    STATE(11163), 1,
      aux_sym_invocation_repeat1,
    STATE(14500), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470345] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14203), 1,
      sym_keyword_separator,
    ACTIONS(14205), 1,
      anon_sym_RPAREN,
    ACTIONS(14207), 1,
      anon_sym_COMMA,
    STATE(8594), 1,
      sym_order_by,
    STATE(11155), 1,
      aux_sym_invocation_repeat1,
    STATE(14489), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470374] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2000), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [470389] = 6,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(7980), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(10751), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14209), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13581), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [470412] = 5,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14214), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(7971), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(14211), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [470433] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(14522), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470462] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(14513), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470491] = 6,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(10751), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14209), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13581), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [470514] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14216), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [470529] = 7,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(7931), 1,
      sym_assignment,
    STATE(10916), 1,
      sym_identifier,
    STATE(12133), 1,
      sym__qualified_field,
    STATE(13364), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [470554] = 9,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(10040), 1,
      sym_identifier,
    STATE(10041), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470583] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8632), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [470606] = 6,
    ACTIONS(14220), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13526), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6540), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [470629] = 6,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(10413), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14224), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14222), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [470652] = 6,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(7947), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(10413), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14224), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14222), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [470675] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8416), 1,
      sym__cte,
    STATE(8587), 1,
      sym_select,
    STATE(8804), 1,
      sym__select_statement,
    STATE(13760), 1,
      sym__dml_read,
    STATE(13867), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470704] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14226), 1,
      sym_keyword_separator,
    ACTIONS(14228), 1,
      anon_sym_RPAREN,
    ACTIONS(14230), 1,
      anon_sym_COMMA,
    STATE(8493), 1,
      sym_order_by,
    STATE(10513), 1,
      aux_sym_invocation_repeat1,
    STATE(13758), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470733] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12958), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470762] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14232), 1,
      sym_keyword_separator,
    ACTIONS(14234), 1,
      anon_sym_RPAREN,
    ACTIONS(14236), 1,
      anon_sym_COMMA,
    STATE(8582), 1,
      sym_order_by,
    STATE(10783), 1,
      aux_sym_invocation_repeat1,
    STATE(13174), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470791] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13270), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470820] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14238), 8,
      sym_keyword_parquet,
      sym_keyword_rcfile,
      sym_keyword_csv,
      sym_keyword_textfile,
      sym_keyword_avro,
      sym_keyword_sequencefile,
      sym_keyword_orc,
      sym_keyword_jsonfile,
  [470835] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13579), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [470850] = 9,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(10054), 1,
      sym__literal_string,
    STATE(10056), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470879] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14240), 1,
      sym_keyword_separator,
    ACTIONS(14242), 1,
      anon_sym_RPAREN,
    ACTIONS(14244), 1,
      anon_sym_COMMA,
    STATE(8597), 1,
      sym_order_by,
    STATE(10722), 1,
      aux_sym_invocation_repeat1,
    STATE(13448), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470908] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14246), 1,
      sym_keyword_separator,
    ACTIONS(14248), 1,
      anon_sym_RPAREN,
    ACTIONS(14250), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      sym_order_by,
    STATE(10795), 1,
      aux_sym_invocation_repeat1,
    STATE(13228), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470937] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14252), 1,
      sym_keyword_separator,
    ACTIONS(14254), 1,
      anon_sym_RPAREN,
    ACTIONS(14256), 1,
      anon_sym_COMMA,
    STATE(8570), 1,
      sym_order_by,
    STATE(11129), 1,
      aux_sym_invocation_repeat1,
    STATE(14283), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470966] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12777), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [470995] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12955), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471024] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14258), 1,
      sym_keyword_separator,
    ACTIONS(14260), 1,
      anon_sym_RPAREN,
    ACTIONS(14262), 1,
      anon_sym_COMMA,
    STATE(8545), 1,
      sym_order_by,
    STATE(11118), 1,
      aux_sym_invocation_repeat1,
    STATE(14230), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471053] = 7,
    ACTIONS(14266), 1,
      sym_keyword_delete,
    ACTIONS(14268), 1,
      sym_keyword_insert,
    ACTIONS(14270), 1,
      sym_keyword_update,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10149), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14264), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
  [471078] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14274), 1,
      sym_keyword_separator,
    ACTIONS(14276), 1,
      anon_sym_RPAREN,
    ACTIONS(14278), 1,
      anon_sym_COMMA,
    STATE(8504), 1,
      sym_order_by,
    STATE(10965), 1,
      aux_sym_invocation_repeat1,
    STATE(13786), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471107] = 6,
    ACTIONS(14282), 1,
      sym_keyword_cascade,
    ACTIONS(14284), 1,
      sym_keyword_with,
    ACTIONS(14286), 1,
      sym_keyword_schema,
    ACTIONS(14288), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14280), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [471130] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8416), 1,
      sym__cte,
    STATE(8587), 1,
      sym_select,
    STATE(8804), 1,
      sym__select_statement,
    STATE(13867), 1,
      sym_set_operation,
    STATE(13868), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471159] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8416), 1,
      sym__cte,
    STATE(8587), 1,
      sym_select,
    STATE(8804), 1,
      sym__select_statement,
    STATE(13729), 1,
      sym__dml_read,
    STATE(13867), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471188] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14290), 1,
      sym_keyword_separator,
    ACTIONS(14292), 1,
      anon_sym_RPAREN,
    ACTIONS(14294), 1,
      anon_sym_COMMA,
    STATE(8516), 1,
      sym_order_by,
    STATE(10281), 1,
      aux_sym_invocation_repeat1,
    STATE(12336), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471217] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14296), 1,
      sym_keyword_separator,
    ACTIONS(14298), 1,
      anon_sym_RPAREN,
    ACTIONS(14300), 1,
      anon_sym_COMMA,
    STATE(8444), 1,
      sym_order_by,
    STATE(10296), 1,
      aux_sym_invocation_repeat1,
    STATE(13721), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471246] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8961), 1,
      sym_identifier,
    STATE(8965), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471275] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14302), 1,
      sym_keyword_separator,
    ACTIONS(14304), 1,
      anon_sym_RPAREN,
    ACTIONS(14306), 1,
      anon_sym_COMMA,
    STATE(8455), 1,
      sym_order_by,
    STATE(10496), 1,
      aux_sym_invocation_repeat1,
    STATE(12038), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471304] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14310), 1,
      sym_keyword_ignore,
    STATE(6414), 1,
      sym_identifier,
    STATE(6973), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14308), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [471329] = 7,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(8038), 1,
      sym_assignment,
    STATE(10916), 1,
      sym_identifier,
    STATE(12133), 1,
      sym__qualified_field,
    STATE(13364), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471354] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13989), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471383] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8776), 1,
      sym__literal_string,
    STATE(8854), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471412] = 8,
    ACTIONS(14312), 1,
      sym__identifier,
    ACTIONS(14314), 1,
      sym__double_quote_string,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14318), 1,
      aux_sym_identifier_token1,
    ACTIONS(14320), 1,
      sym__dollar_quoted_string,
    STATE(6625), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6804), 2,
      sym__literal_string,
      sym_identifier,
  [471439] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14322), 1,
      sym_keyword_separator,
    ACTIONS(14324), 1,
      anon_sym_RPAREN,
    ACTIONS(14326), 1,
      anon_sym_COMMA,
    STATE(8443), 1,
      sym_order_by,
    STATE(10647), 1,
      aux_sym_invocation_repeat1,
    STATE(12953), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471468] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14328), 8,
      sym_keyword_parquet,
      sym_keyword_rcfile,
      sym_keyword_csv,
      sym_keyword_textfile,
      sym_keyword_avro,
      sym_keyword_sequencefile,
      sym_keyword_orc,
      sym_keyword_jsonfile,
  [471483] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(8350), 1,
      sym_order_by,
    STATE(9611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [471506] = 8,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14334), 1,
      sym_keyword_only,
    STATE(6363), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(8373), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [471533] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13534), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [471548] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13455), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471577] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14338), 1,
      sym_keyword_separator,
    ACTIONS(14340), 1,
      anon_sym_RPAREN,
    ACTIONS(14342), 1,
      anon_sym_COMMA,
    STATE(8445), 1,
      sym_order_by,
    STATE(10507), 1,
      aux_sym_invocation_repeat1,
    STATE(12032), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471606] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13862), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471635] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8471), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471658] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(8624), 1,
      sym__if_not_exists,
    STATE(8765), 1,
      sym_ordered_columns,
    STATE(11593), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [471685] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14346), 1,
      sym_keyword_separator,
    ACTIONS(14348), 1,
      anon_sym_RPAREN,
    ACTIONS(14350), 1,
      anon_sym_COMMA,
    STATE(8389), 1,
      sym_order_by,
    STATE(10640), 1,
      aux_sym_invocation_repeat1,
    STATE(12939), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471714] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8474), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471737] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12768), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471766] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8482), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471789] = 9,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(9850), 1,
      sym_identifier,
    STATE(9855), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471818] = 9,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(10145), 1,
      sym_identifier,
    STATE(10147), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471847] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8503), 1,
      sym__cte,
    STATE(8534), 1,
      sym_select,
    STATE(8903), 1,
      sym__select_statement,
    STATE(14065), 1,
      sym_set_operation,
    STATE(14066), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471876] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8533), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471899] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8535), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471922] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13553), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [471937] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8546), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [471960] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12538), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [471989] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14354), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14352), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [472006] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14358), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14356), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [472023] = 6,
    ACTIONS(14362), 1,
      sym_keyword_cascade,
    ACTIONS(14364), 1,
      sym_keyword_with,
    ACTIONS(14366), 1,
      sym_keyword_schema,
    ACTIONS(14368), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14360), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [472046] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8416), 1,
      sym__cte,
    STATE(8587), 1,
      sym_select,
    STATE(8804), 1,
      sym__select_statement,
    STATE(13826), 1,
      sym__dml_read,
    STATE(13867), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472075] = 5,
    ACTIONS(14370), 1,
      sym_keyword_union,
    STATE(8041), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14372), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13534), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
  [472096] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12559), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472125] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13879), 8,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_COMMA,
  [472140] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13405), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472169] = 5,
    ACTIONS(14370), 1,
      sym_keyword_union,
    STATE(8041), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14372), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13579), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
  [472190] = 5,
    ACTIONS(14370), 1,
      sym_keyword_union,
    STATE(8043), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14372), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13621), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
  [472211] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13814), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472240] = 5,
    ACTIONS(14374), 1,
      sym_keyword_union,
    STATE(8043), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14377), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13571), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
  [472261] = 7,
    ACTIONS(14272), 1,
      sym_keyword_where,
    ACTIONS(14382), 1,
      sym_keyword_delete,
    ACTIONS(14384), 1,
      sym_keyword_insert,
    ACTIONS(14386), 1,
      sym_keyword_update,
    STATE(9922), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14380), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
  [472286] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8503), 1,
      sym__cte,
    STATE(8534), 1,
      sym_select,
    STATE(8903), 1,
      sym__select_statement,
    STATE(12666), 1,
      sym__dml_read,
    STATE(14065), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472315] = 5,
    ACTIONS(14370), 1,
      sym_keyword_union,
    STATE(8041), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14372), 2,
      sym_keyword_except,
      sym_keyword_intersect,
    ACTIONS(13553), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
  [472336] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12354), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472365] = 7,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(8077), 1,
      sym_assignment,
    STATE(10916), 1,
      sym_identifier,
    STATE(13364), 1,
      sym_object_reference,
    STATE(13950), 1,
      sym__qualified_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [472390] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8853), 1,
      sym__literal_string,
    STATE(8858), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472419] = 8,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14388), 1,
      sym_keyword_only,
    STATE(6373), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(8448), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [472446] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(8371), 1,
      sym__if_not_exists,
    STATE(10127), 1,
      sym_ordered_columns,
    STATE(11660), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [472473] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8503), 1,
      sym__cte,
    STATE(8534), 1,
      sym_select,
    STATE(8903), 1,
      sym__select_statement,
    STATE(13660), 1,
      sym__dml_read,
    STATE(14065), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472502] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14390), 1,
      sym_keyword_separator,
    ACTIONS(14392), 1,
      anon_sym_RPAREN,
    ACTIONS(14394), 1,
      anon_sym_COMMA,
    STATE(8384), 1,
      sym_order_by,
    STATE(11030), 1,
      aux_sym_invocation_repeat1,
    STATE(13998), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472531] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12351), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472560] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(8952), 1,
      sym_identifier,
    STATE(8953), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472589] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14398), 1,
      sym_keyword_session,
    STATE(6414), 1,
      sym_identifier,
    STATE(10612), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14396), 2,
      sym_keyword_role,
      sym_keyword_all,
  [472614] = 6,
    ACTIONS(14400), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(12183), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6580), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [472637] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14402), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [472652] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8561), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [472675] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8568), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [472698] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14404), 1,
      sym_keyword_separator,
    ACTIONS(14406), 1,
      anon_sym_RPAREN,
    ACTIONS(14408), 1,
      anon_sym_COMMA,
    STATE(8390), 1,
      sym_order_by,
    STATE(10325), 1,
      aux_sym_invocation_repeat1,
    STATE(12522), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472727] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8574), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [472750] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14410), 1,
      sym_keyword_separator,
    ACTIONS(14412), 1,
      anon_sym_RPAREN,
    ACTIONS(14414), 1,
      anon_sym_COMMA,
    STATE(8369), 1,
      sym_order_by,
    STATE(11019), 1,
      aux_sym_invocation_repeat1,
    STATE(13991), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472779] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14416), 1,
      sym_keyword_separator,
    ACTIONS(14418), 1,
      anon_sym_RPAREN,
    ACTIONS(14420), 1,
      anon_sym_COMMA,
    STATE(8356), 1,
      sym_order_by,
    STATE(10337), 1,
      aux_sym_invocation_repeat1,
    STATE(12529), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472808] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8575), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [472831] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(8383), 1,
      sym__if_not_exists,
    STATE(10013), 1,
      sym_ordered_columns,
    STATE(11678), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [472858] = 7,
    ACTIONS(14272), 1,
      sym_keyword_where,
    ACTIONS(14424), 1,
      sym_keyword_delete,
    ACTIONS(14426), 1,
      sym_keyword_insert,
    ACTIONS(14428), 1,
      sym_keyword_update,
    STATE(9777), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14422), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
  [472883] = 7,
    ACTIONS(14430), 1,
      sym_keyword_delete,
    ACTIONS(14432), 1,
      sym_keyword_insert,
    ACTIONS(14434), 1,
      sym_keyword_update,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10872), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14264), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [472908] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14438), 1,
      sym_keyword_separator,
    ACTIONS(14440), 1,
      anon_sym_RPAREN,
    ACTIONS(14442), 1,
      anon_sym_COMMA,
    STATE(8328), 1,
      sym_order_by,
    STATE(10609), 1,
      aux_sym_invocation_repeat1,
    STATE(12301), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472937] = 7,
    ACTIONS(14436), 1,
      sym_keyword_where,
    ACTIONS(14446), 1,
      sym_keyword_delete,
    ACTIONS(14448), 1,
      sym_keyword_insert,
    ACTIONS(14450), 1,
      sym_keyword_update,
    STATE(11013), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14444), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [472962] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13598), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [472991] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14452), 1,
      sym_keyword_separator,
    ACTIONS(14454), 1,
      anon_sym_RPAREN,
    ACTIONS(14456), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      sym_order_by,
    STATE(10620), 1,
      aux_sym_invocation_repeat1,
    STATE(12305), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473020] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13988), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473049] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12139), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473078] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7457), 1,
      sym_order_by,
    STATE(7655), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12858), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473101] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7414), 1,
      sym_order_by,
    STATE(7645), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12612), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473124] = 4,
    ACTIONS(14458), 1,
      anon_sym_COMMA,
    STATE(8086), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14023), 6,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [473143] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12131), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473172] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14460), 8,
      sym_keyword_from,
      sym_keyword_when,
      sym_keyword_not,
      sym_keyword_for,
      sym_keyword_deferrable,
      sym_keyword_initially,
      sym_keyword_referencing,
      sym_keyword_execute,
  [473187] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7448), 1,
      sym_order_by,
    STATE(7620), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12452), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473210] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7511), 1,
      sym_order_by,
    STATE(7686), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10888), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473233] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12044), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473262] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12041), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473291] = 7,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(7905), 1,
      sym_assignment,
    STATE(10916), 1,
      sym_identifier,
    STATE(13364), 1,
      sym_object_reference,
    STATE(13950), 1,
      sym__qualified_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [473316] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7420), 1,
      sym_order_by,
    STATE(7643), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10894), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473339] = 4,
    ACTIONS(14458), 1,
      anon_sym_COMMA,
    STATE(8111), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14001), 6,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [473358] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7442), 1,
      sym_order_by,
    STATE(7611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8847), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473381] = 6,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(8521), 1,
      sym_order_by,
    STATE(10160), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14462), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [473404] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14466), 1,
      sym_keyword_ignore,
    STATE(6414), 1,
      sym_identifier,
    STATE(6967), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14464), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [473429] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(8503), 1,
      sym__cte,
    STATE(8534), 1,
      sym_select,
    STATE(8903), 1,
      sym__select_statement,
    STATE(12775), 1,
      sym__dml_read,
    STATE(14065), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473458] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12270), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473487] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12560), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473516] = 9,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(9253), 1,
      sym__literal_string,
    STATE(9255), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473545] = 4,
    ACTIONS(14150), 1,
      anon_sym_COMMA,
    STATE(7952), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14468), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [473564] = 7,
    ACTIONS(14436), 1,
      sym_keyword_where,
    ACTIONS(14470), 1,
      sym_keyword_delete,
    ACTIONS(14472), 1,
      sym_keyword_insert,
    ACTIONS(14474), 1,
      sym_keyword_update,
    STATE(10979), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14422), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [473589] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(7476), 1,
      sym_order_by,
    STATE(7707), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8883), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_returning,
  [473612] = 7,
    ACTIONS(14272), 1,
      sym_keyword_where,
    ACTIONS(14476), 1,
      sym_keyword_delete,
    ACTIONS(14478), 1,
      sym_keyword_insert,
    ACTIONS(14480), 1,
      sym_keyword_update,
    STATE(9455), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14444), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
  [473637] = 9,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(395), 1,
      aux_sym_identifier_token1,
    ACTIONS(2957), 1,
      sym__double_quote_string,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2967), 1,
      sym__dollar_quoted_string,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(10207), 1,
      sym__literal_string,
    STATE(10209), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473666] = 6,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(7974), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(10450), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14482), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(13366), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [473689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14484), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [473704] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14488), 1,
      sym_keyword_ignore,
    STATE(6414), 1,
      sym_identifier,
    STATE(6964), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14486), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [473729] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14490), 1,
      sym_keyword_separator,
    ACTIONS(14492), 1,
      anon_sym_RPAREN,
    ACTIONS(14494), 1,
      anon_sym_COMMA,
    STATE(8418), 1,
      sym_order_by,
    STATE(10498), 1,
      aux_sym_invocation_repeat1,
    STATE(12726), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473758] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8467), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [473781] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14496), 1,
      sym_keyword_separator,
    ACTIONS(14498), 1,
      anon_sym_RPAREN,
    ACTIONS(14500), 1,
      anon_sym_COMMA,
    STATE(8412), 1,
      sym_order_by,
    STATE(10931), 1,
      aux_sym_invocation_repeat1,
    STATE(13605), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473810] = 8,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14336), 1,
      aux_sym_identifier_token1,
    ACTIONS(14502), 1,
      sym__double_quote_string,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14506), 1,
      sym__dollar_quoted_string,
    STATE(6593), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6741), 2,
      sym__literal_string,
      sym_identifier,
  [473837] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14508), 1,
      sym_keyword_separator,
    ACTIONS(14510), 1,
      anon_sym_RPAREN,
    ACTIONS(14512), 1,
      anon_sym_COMMA,
    STATE(8450), 1,
      sym_order_by,
    STATE(10517), 1,
      aux_sym_invocation_repeat1,
    STATE(12761), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473866] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14514), 1,
      sym_keyword_separator,
    ACTIONS(14516), 1,
      anon_sym_RPAREN,
    ACTIONS(14518), 1,
      anon_sym_COMMA,
    STATE(8475), 1,
      sym_order_by,
    STATE(10920), 1,
      aux_sym_invocation_repeat1,
    STATE(13599), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473895] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8530), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [473918] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14520), 1,
      sym_keyword_separator,
    ACTIONS(14522), 1,
      anon_sym_RPAREN,
    ACTIONS(14524), 1,
      anon_sym_COMMA,
    STATE(8417), 1,
      sym_order_by,
    STATE(10939), 1,
      aux_sym_invocation_repeat1,
    STATE(13378), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [473947] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(8485), 1,
      sym__if_not_exists,
    STATE(9348), 1,
      sym_ordered_columns,
    STATE(11801), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [473974] = 4,
    ACTIONS(14526), 1,
      anon_sym_COMMA,
    STATE(8111), 1,
      aux_sym__set_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13879), 6,
      sym_keyword_from,
      sym_keyword_on,
      sym_keyword_where,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [473993] = 7,
    ACTIONS(14436), 1,
      sym_keyword_where,
    ACTIONS(14529), 1,
      sym_keyword_delete,
    ACTIONS(14531), 1,
      sym_keyword_insert,
    ACTIONS(14533), 1,
      sym_keyword_update,
    STATE(10941), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14380), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [474018] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8359), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474041] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12785), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474070] = 8,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(115), 1,
      aux_sym_identifier_token1,
    ACTIONS(2909), 1,
      sym__double_quote_string,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(2919), 1,
      sym__dollar_quoted_string,
    STATE(135), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11301), 2,
      sym__literal_string,
      sym_identifier,
  [474097] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(13590), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474126] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8491), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474149] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14535), 1,
      sym_keyword_separator,
    ACTIONS(14537), 1,
      anon_sym_RPAREN,
    ACTIONS(14539), 1,
      anon_sym_COMMA,
    STATE(8664), 1,
      sym_order_by,
    STATE(10821), 1,
      aux_sym_invocation_repeat1,
    STATE(13461), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474178] = 9,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(11543), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7540), 1,
      sym__select_statement,
    STATE(8014), 1,
      sym_set_operation,
    STATE(8700), 1,
      sym__cte,
    STATE(12691), 1,
      sym__dml_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474207] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8501), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474230] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8652), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474253] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14541), 1,
      sym_keyword_separator,
    ACTIONS(14543), 1,
      anon_sym_RPAREN,
    ACTIONS(14545), 1,
      anon_sym_COMMA,
    STATE(8487), 1,
      sym_order_by,
    STATE(10957), 1,
      aux_sym_invocation_repeat1,
    STATE(13386), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474282] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(6414), 1,
      sym_identifier,
    STATE(13685), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8596), 2,
      sym_invocation,
      sym_subquery,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474305] = 5,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14547), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(7971), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474326] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14551), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14549), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474343] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14553), 1,
      sym_keyword_separator,
    ACTIONS(14555), 1,
      anon_sym_RPAREN,
    ACTIONS(14557), 1,
      anon_sym_COMMA,
    STATE(8529), 1,
      sym_order_by,
    STATE(10291), 1,
      aux_sym_invocation_repeat1,
    STATE(12307), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474372] = 9,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14559), 1,
      sym_keyword_separator,
    ACTIONS(14561), 1,
      anon_sym_RPAREN,
    ACTIONS(14563), 1,
      anon_sym_COMMA,
    STATE(8644), 1,
      sym_order_by,
    STATE(10832), 1,
      aux_sym_invocation_repeat1,
    STATE(13469), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [474401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14567), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14565), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474418] = 4,
    ACTIONS(13617), 1,
      anon_sym_LBRACK,
    STATE(3351), 1,
      sym__array_size_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3424), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_collate,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_COMMA,
  [474437] = 8,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14569), 1,
      sym_keyword_only,
    STATE(6388), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(8410), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474464] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14571), 1,
      anon_sym_RPAREN,
    STATE(8738), 1,
      sym_order_by,
    STATE(14000), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [474486] = 6,
    ACTIONS(14573), 1,
      sym_keyword_cascade,
    ACTIONS(14575), 1,
      sym_keyword_with,
    ACTIONS(14577), 1,
      sym_keyword_schema,
    ACTIONS(14579), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14360), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [474508] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(8192), 1,
      sym_object_reference,
    STATE(8193), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [474530] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14581), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(14182), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474554] = 4,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    STATE(8257), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14148), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
  [474572] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14585), 1,
      sym_keyword_column,
    STATE(9971), 1,
      sym_identifier,
    STATE(9982), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474596] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14587), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(14388), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474620] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14589), 1,
      anon_sym_RPAREN,
    STATE(8837), 1,
      sym_order_by,
    STATE(13484), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [474642] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14591), 1,
      anon_sym_EQ,
    STATE(8032), 1,
      sym__single_quote_string,
    STATE(8033), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474666] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14593), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(14387), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474690] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14595), 1,
      anon_sym_RPAREN,
    STATE(8684), 1,
      sym_order_by,
    STATE(14585), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [474712] = 7,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14597), 1,
      anon_sym_EQ,
    STATE(8466), 1,
      sym_identifier,
    STATE(8479), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474736] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14599), 1,
      anon_sym_EQ,
    STATE(8032), 1,
      sym__single_quote_string,
    STATE(8033), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474760] = 6,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11303), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14142), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14601), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [474782] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14605), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(13451), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474806] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14607), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(13452), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474830] = 5,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(13855), 1,
      sym_keyword_set,
    ACTIONS(14609), 1,
      sym_keyword_rename,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10624), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [474850] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9934), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14611), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [474870] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(9273), 1,
      sym__if_not_exists,
    STATE(10707), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474894] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(6979), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14617), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [474916] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(6980), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14619), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [474938] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8835), 1,
      sym__if_not_exists,
    STATE(10632), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [474962] = 4,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    STATE(8258), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14166), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
  [474980] = 5,
    ACTIONS(14623), 1,
      sym_keyword_collate,
    STATE(10787), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14625), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14621), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [475000] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14627), 1,
      anon_sym_RPAREN,
    STATE(9000), 1,
      sym_order_by,
    STATE(12114), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [475022] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9705), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14629), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [475042] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14168), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [475056] = 6,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11328), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14222), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14631), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [475078] = 6,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8144), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11328), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14222), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14631), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [475100] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8979), 1,
      sym__if_not_exists,
    STATE(10453), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475124] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8873), 1,
      sym__if_not_exists,
    STATE(10774), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475148] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14633), 1,
      sym_keyword_table,
    ACTIONS(14635), 1,
      sym_keyword_local,
    STATE(6414), 1,
      sym_identifier,
    STATE(13995), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475172] = 5,
    ACTIONS(13989), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7877), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [475192] = 4,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    STATE(8153), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14468), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
  [475210] = 6,
    ACTIONS(14272), 1,
      sym_keyword_where,
    ACTIONS(14639), 1,
      sym_keyword_from,
    STATE(9750), 1,
      sym_from,
    STATE(9758), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14637), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [475232] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14641), 1,
      anon_sym_RPAREN,
    STATE(8690), 1,
      sym_order_by,
    STATE(14482), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [475254] = 5,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8261), 2,
      sym_object_reference,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [475274] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8828), 1,
      sym__if_not_exists,
    STATE(10735), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475298] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8825), 1,
      sym__if_not_exists,
    STATE(10741), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475322] = 7,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(3575), 1,
      sym_identifier,
    STATE(7370), 1,
      sym_object_reference,
    STATE(8839), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475346] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
    STATE(8885), 1,
      sym_order_by,
    STATE(12952), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [475368] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14484), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
  [475382] = 4,
    ACTIONS(7428), 1,
      anon_sym_COMMA,
    STATE(7230), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14645), 5,
      sym_keyword_order,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
      anon_sym_RPAREN,
  [475400] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14647), 1,
      sym_keyword_using,
    STATE(6377), 1,
      sym_identifier,
    STATE(13175), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475424] = 7,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14649), 1,
      sym_keyword_stdin,
    ACTIONS(14651), 1,
      sym_keyword_program,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11526), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [475448] = 5,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8134), 2,
      sym_object_reference,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [475468] = 4,
    ACTIONS(14655), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14653), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_RPAREN,
  [475486] = 7,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(3575), 1,
      sym_identifier,
    STATE(7364), 1,
      sym_object_reference,
    STATE(8909), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475510] = 5,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(14013), 1,
      sym_keyword_set,
    ACTIONS(14658), 1,
      sym_keyword_rename,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11356), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [475530] = 8,
    ACTIONS(14660), 1,
      sym_keyword_not,
    ACTIONS(14662), 1,
      sym_keyword_default,
    ACTIONS(14664), 1,
      sym_keyword_data,
    ACTIONS(14666), 1,
      sym_keyword_storage,
    ACTIONS(14668), 1,
      sym_keyword_compression,
    ACTIONS(14670), 1,
      sym_keyword_statistics,
    ACTIONS(14672), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [475556] = 7,
    ACTIONS(12662), 1,
      sym_keyword_rename,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(14674), 1,
      sym_keyword_set,
    ACTIONS(14676), 1,
      sym_keyword_with,
    ACTIONS(14678), 1,
      sym_keyword_reset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11351), 2,
      sym_rename_object,
      sym_change_ownership,
  [475580] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14680), 1,
      anon_sym_RPAREN,
    STATE(9305), 1,
      sym_order_by,
    STATE(13172), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [475602] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9282), 1,
      sym__if_not_exists,
    STATE(13057), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475626] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8702), 1,
      sym__if_not_exists,
    STATE(10929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475650] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(9270), 1,
      sym__if_not_exists,
    STATE(10695), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475674] = 3,
    ACTIONS(14682), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(109), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_order,
      sym_keyword_limit,
      sym_keyword_returning,
  [475690] = 7,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14684), 1,
      sym_keyword_stdin,
    ACTIONS(14686), 1,
      sym_keyword_program,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11787), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [475714] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9863), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14688), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [475734] = 8,
    ACTIONS(14690), 1,
      sym_keyword_not,
    ACTIONS(14692), 1,
      sym_keyword_default,
    ACTIONS(14694), 1,
      sym_keyword_data,
    ACTIONS(14696), 1,
      sym_keyword_storage,
    ACTIONS(14698), 1,
      sym_keyword_compression,
    ACTIONS(14700), 1,
      sym_keyword_statistics,
    ACTIONS(14702), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [475760] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14704), 1,
      sym_keyword_table,
    ACTIONS(14706), 1,
      sym_keyword_local,
    STATE(6414), 1,
      sym_identifier,
    STATE(14090), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475784] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14708), 1,
      sym_keyword_using,
    STATE(6377), 1,
      sym_identifier,
    STATE(14516), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475808] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14710), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(12601), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475832] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14712), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(12602), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475856] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9739), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14714), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [475876] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(8145), 1,
      sym_object_reference,
    STATE(8146), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [475898] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14716), 1,
      anon_sym_RPAREN,
    STATE(8713), 1,
      sym_order_by,
    STATE(14046), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [475920] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(7208), 1,
      sym_object_reference,
    STATE(9251), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475944] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6355), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(9247), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [475968] = 5,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(14013), 1,
      sym_keyword_set,
    ACTIONS(14658), 1,
      sym_keyword_rename,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11323), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [475988] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9236), 1,
      sym__if_not_exists,
    STATE(11830), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476012] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14718), 1,
      anon_sym_RPAREN,
    STATE(9047), 1,
      sym_order_by,
    STATE(12315), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [476034] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14720), 1,
      sym_keyword_column,
    STATE(9949), 1,
      sym__if_exists,
    STATE(10454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476058] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9418), 1,
      sym__if_not_exists,
    STATE(11730), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476082] = 5,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8292), 2,
      sym_object_reference,
      sym_subquery,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [476102] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6379), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(9425), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476126] = 6,
    ACTIONS(14722), 1,
      sym_keyword_cascade,
    ACTIONS(14724), 1,
      sym_keyword_with,
    ACTIONS(14726), 1,
      sym_keyword_schema,
    ACTIONS(14728), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14280), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [476148] = 8,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8534), 1,
      sym_select,
    STATE(9387), 1,
      sym__select_statement,
    STATE(13514), 1,
      sym_set_operation,
    STATE(13516), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [476174] = 5,
    ACTIONS(14730), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7753), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [476194] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(6973), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14308), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [476216] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9601), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14732), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [476236] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14734), 1,
      anon_sym_RPAREN,
    STATE(9049), 1,
      sym_order_by,
    STATE(13718), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [476258] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9600), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14736), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [476278] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14738), 1,
      sym_keyword_using,
    STATE(6377), 1,
      sym_identifier,
    STATE(14365), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476302] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9597), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14740), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [476322] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8880), 1,
      sym__if_not_exists,
    STATE(10574), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476346] = 5,
    ACTIONS(14742), 1,
      sym_keyword_and,
    ACTIONS(14744), 1,
      sym_keyword_exclude,
    ACTIONS(14746), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(13419), 4,
      sym__exclude_current_row,
      sym__exclude_group,
      sym__exclude_no_others,
      sym__exclude_ties,
  [476366] = 7,
    ACTIONS(14476), 1,
      sym_keyword_delete,
    ACTIONS(14478), 1,
      sym_keyword_insert,
    ACTIONS(14748), 1,
      sym_keyword_update,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9455), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14444), 2,
      sym_keyword_when,
      anon_sym_RPAREN,
  [476390] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6362), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(8740), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476414] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14752), 1,
      anon_sym_RPAREN,
    STATE(9378), 1,
      sym_order_by,
    STATE(13375), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [476436] = 5,
    ACTIONS(14756), 1,
      sym_keyword_on,
    STATE(10066), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14758), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14754), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [476456] = 6,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11359), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13581), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14760), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [476478] = 8,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8534), 1,
      sym_select,
    STATE(9387), 1,
      sym__select_statement,
    STATE(13514), 1,
      sym_set_operation,
    STATE(14018), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [476504] = 5,
    ACTIONS(14764), 1,
      sym_keyword_collate,
    STATE(10880), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14766), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14762), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [476524] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14768), 1,
      sym_keyword_column,
    STATE(7697), 1,
      sym_identifier,
    STATE(10007), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476548] = 6,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8158), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11359), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13581), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14760), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [476570] = 7,
    ACTIONS(14424), 1,
      sym_keyword_delete,
    ACTIONS(14426), 1,
      sym_keyword_insert,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(14770), 1,
      sym_keyword_update,
    STATE(9777), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14422), 2,
      sym_keyword_when,
      anon_sym_RPAREN,
  [476594] = 6,
    ACTIONS(14436), 1,
      sym_keyword_where,
    ACTIONS(14772), 1,
      sym_keyword_from,
    STATE(10724), 1,
      sym_where,
    STATE(10726), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14637), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [476616] = 6,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(14774), 1,
      sym_keyword_begin,
    STATE(61), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(8318), 2,
      sym_function_declaration,
      aux_sym_function_body_repeat2,
  [476638] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14776), 1,
      anon_sym_RPAREN,
    STATE(8790), 1,
      sym_order_by,
    STATE(13609), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [476660] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8179), 1,
      sym_object_reference,
    STATE(8748), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476684] = 8,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(10991), 1,
      sym_keyword_constraint,
    ACTIONS(11003), 1,
      sym_keyword_check,
    STATE(3367), 1,
      sym__single_quote_string,
    STATE(9586), 1,
      sym__check_constraint,
    STATE(11590), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [476710] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8878), 1,
      sym__if_not_exists,
    STATE(10580), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476734] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(7030), 1,
      sym_object_reference,
    STATE(8752), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476758] = 6,
    ACTIONS(117), 1,
      sym__identifier,
    ACTIONS(14778), 1,
      sym_keyword_begin,
    STATE(61), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(8318), 2,
      sym_function_declaration,
      aux_sym_function_body_repeat2,
  [476780] = 5,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14782), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14780), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [476800] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14784), 1,
      anon_sym_RPAREN,
    STATE(8958), 1,
      sym_order_by,
    STATE(12030), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [476822] = 5,
    ACTIONS(13910), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7756), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [476842] = 7,
    ACTIONS(14382), 1,
      sym_keyword_delete,
    ACTIONS(14384), 1,
      sym_keyword_insert,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(14786), 1,
      sym_keyword_update,
    STATE(9922), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14380), 2,
      sym_keyword_when,
      anon_sym_RPAREN,
  [476866] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6378), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(9430), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476890] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14788), 1,
      anon_sym_RPAREN,
    STATE(9149), 1,
      sym_order_by,
    STATE(12723), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [476912] = 5,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(13855), 1,
      sym_keyword_set,
    ACTIONS(14609), 1,
      sym_keyword_rename,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10570), 4,
      sym_rename_column,
      sym_rename_object,
      sym_set_schema,
      sym_change_ownership,
  [476932] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9359), 1,
      sym__if_not_exists,
    STATE(11560), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [476956] = 8,
    ACTIONS(14660), 1,
      sym_keyword_not,
    ACTIONS(14664), 1,
      sym_keyword_data,
    ACTIONS(14666), 1,
      sym_keyword_storage,
    ACTIONS(14668), 1,
      sym_keyword_compression,
    ACTIONS(14670), 1,
      sym_keyword_statistics,
    ACTIONS(14672), 1,
      anon_sym_LPAREN,
    ACTIONS(14790), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [476982] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(6964), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14486), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [477004] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9243), 1,
      sym__if_exists,
    STATE(10793), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477028] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14792), 1,
      anon_sym_RPAREN,
    STATE(9223), 1,
      sym_order_by,
    STATE(12937), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [477050] = 5,
    ACTIONS(14796), 1,
      sym_keyword_collate,
    STATE(10586), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14798), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14794), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [477070] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14216), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
  [477084] = 7,
    ACTIONS(12634), 1,
      sym_keyword_rename,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(14800), 1,
      sym_keyword_set,
    ACTIONS(14802), 1,
      sym_keyword_with,
    ACTIONS(14804), 1,
      sym_keyword_reset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10420), 2,
      sym_rename_object,
      sym_change_ownership,
  [477108] = 7,
    ACTIONS(14266), 1,
      sym_keyword_delete,
    ACTIONS(14268), 1,
      sym_keyword_insert,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(14806), 1,
      sym_keyword_update,
    STATE(10149), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14264), 2,
      sym_keyword_when,
      anon_sym_RPAREN,
  [477132] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13579), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
  [477146] = 5,
    ACTIONS(14808), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(7850), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [477166] = 6,
    ACTIONS(14158), 1,
      anon_sym_LPAREN,
    STATE(10916), 1,
      sym_identifier,
    STATE(12461), 1,
      sym__qualified_field,
    STATE(13364), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [477188] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14810), 1,
      anon_sym_RPAREN,
    STATE(8695), 1,
      sym_order_by,
    STATE(14290), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [477210] = 8,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8587), 1,
      sym_select,
    STATE(8856), 1,
      sym__select_statement,
    STATE(13820), 1,
      sym_set_operation,
    STATE(13985), 1,
      sym__cte,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [477236] = 7,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(14812), 1,
      sym_keyword_stdin,
    ACTIONS(14814), 1,
      sym_keyword_program,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11765), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [477260] = 4,
    ACTIONS(14583), 1,
      anon_sym_COMMA,
    STATE(8258), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14183), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
  [477278] = 4,
    ACTIONS(14816), 1,
      anon_sym_COMMA,
    STATE(8258), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14168), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
  [477296] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(7262), 1,
      sym_identifier,
    STATE(9320), 1,
      sym_object_reference,
    STATE(9323), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477320] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14819), 1,
      sym_keyword_concurrently,
    STATE(8555), 1,
      sym_identifier,
    STATE(9773), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477344] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14821), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(13411), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477368] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(6976), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14823), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [477390] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(9095), 1,
      sym_order_by,
    STATE(10326), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [477412] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(7262), 1,
      sym_identifier,
    STATE(9328), 1,
      sym_object_reference,
    STATE(9332), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477436] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9742), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14825), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [477456] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(7262), 1,
      sym_identifier,
    STATE(9333), 1,
      sym_object_reference,
    STATE(9336), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477480] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(7262), 1,
      sym_identifier,
    STATE(9337), 1,
      sym_object_reference,
    STATE(9338), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477504] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13553), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
  [477518] = 8,
    ACTIONS(14827), 1,
      sym_keyword_not,
    ACTIONS(14829), 1,
      sym_keyword_default,
    ACTIONS(14831), 1,
      sym_keyword_data,
    ACTIONS(14833), 1,
      sym_keyword_storage,
    ACTIONS(14835), 1,
      sym_keyword_compression,
    ACTIONS(14837), 1,
      sym_keyword_statistics,
    ACTIONS(14839), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [477544] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14841), 1,
      anon_sym_RPAREN,
    STATE(8915), 1,
      sym_order_by,
    STATE(12341), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [477566] = 8,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(31), 1,
      sym_keyword_with,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8587), 1,
      sym_select,
    STATE(8856), 1,
      sym__select_statement,
    STATE(13639), 1,
      sym__cte,
    STATE(13820), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [477592] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9390), 1,
      sym__if_not_exists,
    STATE(13628), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477616] = 6,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    ACTIONS(10862), 1,
      sym_keyword_order,
    STATE(9030), 1,
      sym_order_by,
    STATE(10310), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14462), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [477638] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8327), 1,
      sym_object_reference,
    STATE(9209), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477662] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14843), 1,
      sym_keyword_concurrently,
    STATE(8311), 1,
      sym_identifier,
    STATE(9950), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477686] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9389), 1,
      sym__if_not_exists,
    STATE(11669), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477710] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8339), 1,
      sym_object_reference,
    STATE(9171), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477734] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8346), 1,
      sym_object_reference,
    STATE(9164), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477758] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6365), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(8768), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477782] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8349), 1,
      sym_object_reference,
    STATE(9156), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477806] = 7,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    ACTIONS(14845), 1,
      sym_keyword_authorization,
    STATE(9746), 1,
      sym__if_not_exists,
    STATE(9747), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477830] = 5,
    ACTIONS(14849), 1,
      sym_keyword_cascade,
    ACTIONS(14851), 1,
      sym_keyword_schema,
    ACTIONS(14853), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [477850] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6374), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    STATE(8842), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477874] = 5,
    ACTIONS(14857), 1,
      sym_keyword_on,
    STATE(9837), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14859), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14855), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [477894] = 5,
    ACTIONS(14863), 1,
      sym_keyword_collate,
    STATE(11034), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14865), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14861), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [477914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14869), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14867), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477930] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8757), 1,
      sym__if_exists,
    STATE(10803), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477954] = 5,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(8235), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14873), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14871), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [477974] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8850), 1,
      sym__if_not_exists,
    STATE(11610), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [477998] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(7182), 1,
      sym_object_reference,
    STATE(8859), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478022] = 7,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    ACTIONS(14875), 1,
      sym_keyword_column,
    STATE(7698), 1,
      sym_identifier,
    STATE(9645), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478046] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(5916), 1,
      sym_keyword_as,
    ACTIONS(14877), 1,
      sym_keyword_on,
    STATE(6377), 1,
      sym_identifier,
    STATE(14380), 1,
      sym__alias,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478070] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    ACTIONS(14879), 1,
      sym_keyword_authorization,
    STATE(8901), 1,
      sym_identifier,
    STATE(9893), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478094] = 8,
    ACTIONS(14690), 1,
      sym_keyword_not,
    ACTIONS(14694), 1,
      sym_keyword_data,
    ACTIONS(14696), 1,
      sym_keyword_storage,
    ACTIONS(14698), 1,
      sym_keyword_compression,
    ACTIONS(14700), 1,
      sym_keyword_statistics,
    ACTIONS(14702), 1,
      anon_sym_LPAREN,
    ACTIONS(14881), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [478120] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9744), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14883), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [478140] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8935), 1,
      sym__if_not_exists,
    STATE(10565), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478164] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14704), 1,
      sym_keyword_table,
    ACTIONS(14706), 1,
      sym_keyword_local,
    STATE(6414), 1,
      sym_identifier,
    STATE(14352), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478188] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13534), 7,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_create,
      sym_keyword_when,
      sym_keyword_with,
      sym_keyword_returning,
  [478202] = 5,
    ACTIONS(14613), 1,
      sym_keyword_first,
    ACTIONS(14615), 1,
      sym_keyword_after,
    STATE(9911), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14885), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [478222] = 6,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(1818), 1,
      sym_identifier,
    STATE(8137), 1,
      sym_subquery,
    STATE(8140), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [478244] = 5,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14873), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14871), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [478264] = 5,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(8301), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14889), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14887), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [478284] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    STATE(6414), 1,
      sym_identifier,
    STATE(6967), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    ACTIONS(14464), 2,
      sym_keyword_into,
      sym_keyword_overwrite,
  [478306] = 8,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(10987), 1,
      sym_keyword_primary,
    ACTIONS(11072), 1,
      sym_keyword_constraint,
    ACTIONS(11084), 1,
      sym_keyword_check,
    STATE(3367), 1,
      sym__single_quote_string,
    STATE(10553), 1,
      sym__check_constraint,
    STATE(11679), 1,
      sym__primary_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [478332] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8241), 1,
      sym_object_reference,
    STATE(9045), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478356] = 4,
    ACTIONS(14891), 1,
      anon_sym_COMMA,
    STATE(8310), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13038), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
  [478374] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9371), 1,
      sym__if_not_exists,
    STATE(11596), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478398] = 8,
    ACTIONS(14893), 1,
      sym_keyword_not,
    ACTIONS(14895), 1,
      sym_keyword_default,
    ACTIONS(14897), 1,
      sym_keyword_data,
    ACTIONS(14899), 1,
      sym_keyword_storage,
    ACTIONS(14901), 1,
      sym_keyword_compression,
    ACTIONS(14903), 1,
      sym_keyword_statistics,
    ACTIONS(14905), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [478424] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(7026), 1,
      sym_object_reference,
    STATE(9057), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478448] = 4,
    ACTIONS(14891), 1,
      anon_sym_COMMA,
    STATE(8312), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13337), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
  [478466] = 5,
    ACTIONS(14909), 1,
      sym_keyword_on,
    STATE(10087), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14911), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14907), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [478486] = 4,
    ACTIONS(14913), 1,
      anon_sym_COMMA,
    STATE(8312), 1,
      aux_sym_order_by_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(12524), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_limit,
      sym_keyword_create,
      sym_keyword_returning,
  [478504] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8950), 1,
      sym__if_not_exists,
    STATE(12064), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478528] = 5,
    ACTIONS(14918), 1,
      sym_keyword_collate,
    STATE(11152), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14920), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14916), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [478548] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8951), 1,
      sym__if_not_exists,
    STATE(12017), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478572] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(8892), 1,
      sym__if_not_exists,
    STATE(11874), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478596] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8862), 1,
      sym__if_not_exists,
    STATE(10591), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478620] = 6,
    ACTIONS(14922), 1,
      sym__identifier,
    ACTIONS(14925), 1,
      sym_keyword_begin,
    STATE(61), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14927), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
    STATE(8318), 2,
      sym_function_declaration,
      aux_sym_function_body_repeat2,
  [478642] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8890), 1,
      sym__if_not_exists,
    STATE(10992), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478666] = 7,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(1818), 1,
      sym_identifier,
    STATE(8829), 1,
      sym__if_not_exists,
    STATE(10731), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478690] = 6,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8221), 1,
      aux_sym__truncate_statement_repeat1,
    STATE(11374), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13366), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14930), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [478712] = 6,
    ACTIONS(10772), 1,
      sym_keyword_order,
    ACTIONS(14932), 1,
      anon_sym_RPAREN,
    STATE(9093), 1,
      sym_order_by,
    STATE(12516), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [478734] = 7,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(6414), 1,
      sym_identifier,
    STATE(9368), 1,
      sym__if_not_exists,
    STATE(13883), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478758] = 5,
    ACTIONS(14362), 1,
      sym_keyword_cascade,
    ACTIONS(14366), 1,
      sym_keyword_schema,
    ACTIONS(14368), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14360), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [478778] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14934), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [478791] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10423), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14611), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [478810] = 4,
    STATE(10435), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14942), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14940), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [478827] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(14944), 1,
      sym_keyword_separator,
    ACTIONS(14946), 1,
      anon_sym_RPAREN,
    ACTIONS(14948), 1,
      anon_sym_COMMA,
    STATE(10623), 1,
      aux_sym_invocation_repeat1,
    STATE(12338), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [478850] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14950), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [478863] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14952), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [478876] = 4,
    ACTIONS(14954), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4799), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(897), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [478893] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14956), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10399), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478914] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(9865), 1,
      sym__if_exists,
    STATE(9871), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478935] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11883), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [478948] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14958), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10415), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478969] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14960), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10942), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [478990] = 5,
    ACTIONS(14962), 1,
      sym_keyword_on,
    STATE(10287), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14754), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14964), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [479009] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8284), 1,
      sym_identifier,
    STATE(10082), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479030] = 4,
    STATE(10448), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14968), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14966), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479047] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11758), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [479060] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(9063), 1,
      sym_identifier,
    STATE(10223), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479081] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11724), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [479094] = 4,
    ACTIONS(14970), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6396), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(1089), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479111] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14974), 1,
      sym_keyword_between,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [479132] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14978), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10718), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479153] = 4,
    STATE(10456), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14982), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14980), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479170] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14984), 1,
      sym_keyword_recursive,
    STATE(7525), 1,
      sym_cte,
    STATE(11481), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479191] = 5,
    ACTIONS(14986), 1,
      sym_keyword_collate,
    STATE(11252), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14621), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14988), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [479210] = 4,
    STATE(10457), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14992), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(14990), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479227] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(10160), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14462), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [479244] = 5,
    ACTIONS(14996), 1,
      anon_sym_COMMA,
    STATE(8656), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14780), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14994), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [479263] = 6,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(7621), 1,
      sym_identifier,
    STATE(9898), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479284] = 5,
    ACTIONS(14996), 1,
      anon_sym_COMMA,
    STATE(8656), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14871), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14998), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [479303] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11634), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [479316] = 6,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(7561), 1,
      sym_identifier,
    STATE(9835), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479337] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15000), 1,
      sym_keyword_separator,
    ACTIONS(15002), 1,
      anon_sym_RPAREN,
    ACTIONS(15004), 1,
      anon_sym_COMMA,
    STATE(10312), 1,
      aux_sym_invocation_repeat1,
    STATE(12521), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [479360] = 4,
    STATE(10729), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15008), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15006), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15010), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [479390] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15012), 1,
      sym_keyword_on,
    ACTIONS(15014), 1,
      sym_keyword_as,
    STATE(12956), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479411] = 5,
    ACTIONS(15016), 1,
      sym_keyword_nulls,
    STATE(10665), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15018), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [479430] = 4,
    STATE(10698), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15022), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15020), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479447] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15024), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10973), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479468] = 4,
    STATE(10427), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15028), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15026), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479485] = 5,
    ACTIONS(14996), 1,
      anon_sym_COMMA,
    STATE(8351), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14871), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(14998), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [479504] = 5,
    STATE(6414), 1,
      sym_identifier,
    STATE(10421), 1,
      sym__rename_table_names,
    STATE(13620), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479523] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8498), 1,
      sym_identifier,
    STATE(9435), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479544] = 4,
    ACTIONS(14849), 1,
      sym_keyword_cascade,
    ACTIONS(14853), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [479561] = 4,
    STATE(10737), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15032), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15030), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479578] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15034), 1,
      sym_keyword_separator,
    ACTIONS(15036), 1,
      anon_sym_RPAREN,
    ACTIONS(15038), 1,
      anon_sym_COMMA,
    STATE(11033), 1,
      aux_sym_invocation_repeat1,
    STATE(13999), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [479601] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15040), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [479614] = 5,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(10013), 1,
      sym_ordered_columns,
    STATE(11678), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479633] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(7998), 1,
      sym_identifier,
    STATE(9985), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479654] = 6,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(15042), 1,
      sym_keyword_only,
    STATE(6369), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479675] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10607), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14629), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [479694] = 5,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(10127), 1,
      sym_ordered_columns,
    STATE(11660), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479713] = 5,
    ACTIONS(15046), 1,
      sym_keyword_partition,
    ACTIONS(15048), 1,
      anon_sym_LPAREN,
    STATE(10308), 1,
      sym__partition_spec,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15044), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479732] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(8206), 1,
      sym_identifier,
    STATE(9748), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479753] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(10215), 1,
      sym__if_exists,
    STATE(10230), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479774] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15050), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10935), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479795] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10226), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14688), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [479814] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15052), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [479827] = 4,
    STATE(10697), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15056), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15054), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [479844] = 5,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(9828), 1,
      sym_ordered_columns,
    STATE(11705), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479863] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15058), 1,
      sym_keyword_separator,
    ACTIONS(15060), 1,
      anon_sym_RPAREN,
    ACTIONS(15062), 1,
      anon_sym_COMMA,
    STATE(11062), 1,
      aux_sym_invocation_repeat1,
    STATE(14057), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [479886] = 4,
    STATE(61), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8234), 2,
      sym_function_declaration,
      aux_sym_function_body_repeat2,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479903] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(9214), 1,
      sym_identifier,
    STATE(9939), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479924] = 5,
    ACTIONS(15064), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(10260), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [479943] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8363), 1,
      sym_identifier,
    STATE(9937), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [479964] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15066), 1,
      sym_keyword_separator,
    ACTIONS(15068), 1,
      anon_sym_RPAREN,
    ACTIONS(15070), 1,
      anon_sym_COMMA,
    STATE(10598), 1,
      aux_sym_invocation_repeat1,
    STATE(12854), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [479987] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15072), 1,
      sym_keyword_separator,
    ACTIONS(15074), 1,
      anon_sym_RPAREN,
    ACTIONS(15076), 1,
      anon_sym_COMMA,
    STATE(10269), 1,
      aux_sym_invocation_repeat1,
    STATE(12455), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [480010] = 4,
    STATE(10690), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15080), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15078), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [480027] = 5,
    ACTIONS(15082), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(10782), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [480046] = 6,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15084), 1,
      sym_keyword_null,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(11305), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2967), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [480067] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8302), 1,
      sym_identifier,
    STATE(9925), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480088] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15086), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10642), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14168), 6,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_COMMA,
  [480122] = 6,
    ACTIONS(14639), 1,
      sym_keyword_from,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9750), 1,
      sym_from,
    STATE(9758), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14637), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [480143] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(9754), 1,
      sym__if_exists,
    STATE(11367), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480164] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15088), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480177] = 4,
    STATE(11224), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15092), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15090), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [480194] = 6,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15094), 1,
      anon_sym_RPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10594), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [480215] = 4,
    ACTIONS(15098), 1,
      sym_keyword_cascade,
    ACTIONS(15100), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15096), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [480232] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15102), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [480249] = 6,
    ACTIONS(12634), 1,
      sym_keyword_rename,
    ACTIONS(12636), 1,
      sym_keyword_owner,
    ACTIONS(15104), 1,
      sym_keyword_set,
    ACTIONS(15106), 1,
      sym_keyword_reset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(10661), 2,
      sym_rename_object,
      sym_change_ownership,
  [480270] = 5,
    ACTIONS(15108), 1,
      anon_sym_RPAREN,
    STATE(8143), 1,
      sym_identifier,
    STATE(10590), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [480289] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15110), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10332), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480310] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15112), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10327), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480331] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(9784), 1,
      sym__if_exists,
    STATE(9785), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480352] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(9307), 1,
      sym_identifier,
    STATE(9786), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480373] = 6,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(15114), 1,
      sym_keyword_only,
    STATE(6389), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480394] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8531), 1,
      sym_identifier,
    STATE(9787), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480415] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15116), 1,
      sym_keyword_separator,
    ACTIONS(15118), 1,
      anon_sym_RPAREN,
    ACTIONS(15120), 1,
      anon_sym_COMMA,
    STATE(10963), 1,
      aux_sym_invocation_repeat1,
    STATE(13779), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [480438] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15122), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480451] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15124), 1,
      sym_keyword_tablespace,
    STATE(10544), 1,
      sym_identifier,
    STATE(10661), 1,
      sym_set_configuration,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480472] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15126), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [480493] = 7,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    ACTIONS(15128), 1,
      anon_sym_RPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7565), 1,
      sym__select_statement,
    STATE(7988), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [480516] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15130), 1,
      sym_keyword_separator,
    ACTIONS(15132), 1,
      anon_sym_RPAREN,
    ACTIONS(15134), 1,
      anon_sym_COMMA,
    STATE(10897), 1,
      aux_sym_invocation_repeat1,
    STATE(13340), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [480539] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15136), 1,
      sym_keyword_separator,
    ACTIONS(15138), 1,
      anon_sym_RPAREN,
    ACTIONS(15140), 1,
      anon_sym_COMMA,
    STATE(10446), 1,
      aux_sym_invocation_repeat1,
    STATE(12654), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [480562] = 5,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(9716), 1,
      sym_ordered_columns,
    STATE(11725), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [480581] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15142), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [480602] = 5,
    ACTIONS(15144), 1,
      sym_keyword_on,
    STATE(10363), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14855), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15146), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [480621] = 5,
    ACTIONS(15046), 1,
      sym_keyword_partition,
    ACTIONS(15150), 1,
      anon_sym_LPAREN,
    STATE(10820), 1,
      sym__partition_spec,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15148), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [480640] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15152), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10912), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480661] = 4,
    ACTIONS(14744), 1,
      sym_keyword_exclude,
    ACTIONS(15154), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(12357), 4,
      sym__exclude_current_row,
      sym__exclude_group,
      sym__exclude_no_others,
      sym__exclude_ties,
  [480678] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15156), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480691] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15158), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480704] = 6,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(8125), 1,
      sym__single_quote_string,
    STATE(8128), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480725] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15160), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480738] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15162), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480751] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15164), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480764] = 6,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15166), 1,
      sym_keyword_null,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10851), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [480785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14551), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14549), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480800] = 4,
    STATE(10606), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15170), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15168), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [480817] = 5,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9348), 1,
      sym_ordered_columns,
    STATE(11801), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [480836] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15172), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [480849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14567), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14565), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480864] = 6,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15174), 1,
      sym_keyword_null,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(7239), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2967), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [480885] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15176), 1,
      sym_keyword_column,
    ACTIONS(15178), 1,
      sym_keyword_to,
    STATE(12300), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480906] = 5,
    ACTIONS(15180), 1,
      sym_keyword_cascade,
    ACTIONS(15182), 1,
      sym_keyword_schema,
    ACTIONS(15184), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [480925] = 4,
    ACTIONS(15186), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4652), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(773), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [480942] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15188), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [480963] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15190), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10857), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [480984] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15192), 1,
      sym_keyword_separator,
    ACTIONS(15194), 1,
      anon_sym_RPAREN,
    ACTIONS(15196), 1,
      anon_sym_COMMA,
    STATE(10633), 1,
      aux_sym_invocation_repeat1,
    STATE(12938), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481007] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15198), 1,
      sym_keyword_separator,
    ACTIONS(15200), 1,
      anon_sym_RPAREN,
    ACTIONS(15202), 1,
      anon_sym_COMMA,
    STATE(10483), 1,
      aux_sym_invocation_repeat1,
    STATE(13668), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481030] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15204), 1,
      sym_keyword_separator,
    ACTIONS(15206), 1,
      anon_sym_RPAREN,
    ACTIONS(15208), 1,
      anon_sym_COMMA,
    STATE(10539), 1,
      aux_sym_invocation_repeat1,
    STATE(12103), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481053] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8846), 1,
      sym_identifier,
    STATE(9572), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481074] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15210), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481087] = 6,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(15212), 1,
      sym_keyword_only,
    STATE(6352), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481108] = 6,
    ACTIONS(14330), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(7714), 1,
      sym_identifier,
    STATE(9711), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481129] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15214), 1,
      sym_keyword_separator,
    ACTIONS(15216), 1,
      anon_sym_RPAREN,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    STATE(10492), 1,
      aux_sym_invocation_repeat1,
    STATE(12724), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481152] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10362), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14883), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [481171] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10365), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14825), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [481190] = 4,
    ACTIONS(15220), 1,
      anon_sym_COMMA,
    STATE(8600), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
  [481207] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15222), 1,
      sym_keyword_tablespace,
    STATE(10386), 1,
      sym_identifier,
    STATE(11296), 1,
      sym_set_configuration,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481228] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15224), 1,
      sym_keyword_separator,
    ACTIONS(15226), 1,
      anon_sym_RPAREN,
    ACTIONS(15228), 1,
      anon_sym_COMMA,
    STATE(10510), 1,
      aux_sym_invocation_repeat1,
    STATE(12168), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481251] = 6,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(15230), 1,
      sym_keyword_none,
    STATE(3575), 1,
      sym_identifier,
    STATE(7450), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481272] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15232), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481285] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15234), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481298] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15236), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481311] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(10042), 1,
      sym__if_exists,
    STATE(10509), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481332] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15238), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481345] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15240), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [481362] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15242), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481375] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8469), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15244), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [481392] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8552), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15246), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [481409] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14358), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14356), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481424] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15248), 1,
      sym_keyword_on,
    ACTIONS(15250), 1,
      sym_keyword_as,
    STATE(14122), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481445] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10373), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14714), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [481464] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15246), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [481481] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8560), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15252), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [481498] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15254), 1,
      sym_keyword_on,
    ACTIONS(15256), 1,
      sym_keyword_as,
    STATE(12379), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481519] = 6,
    ACTIONS(1227), 1,
      sym__identifier,
    ACTIONS(15258), 1,
      sym_keyword_none,
    STATE(3575), 1,
      sym_identifier,
    STATE(7462), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481540] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15260), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [481553] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15262), 1,
      sym_keyword_on,
    ACTIONS(15264), 1,
      sym_keyword_as,
    STATE(12375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481574] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15266), 1,
      sym_keyword_separator,
    ACTIONS(15268), 1,
      anon_sym_RPAREN,
    ACTIONS(15270), 1,
      anon_sym_COMMA,
    STATE(10934), 1,
      aux_sym_invocation_repeat1,
    STATE(13608), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481597] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15272), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10601), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481618] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15274), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481631] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15276), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [481652] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14354), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14352), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481667] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(9611), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [481684] = 6,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15174), 1,
      sym_keyword_null,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(7239), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3116), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [481705] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15278), 1,
      sym_keyword_on,
    ACTIONS(15280), 1,
      sym_keyword_as,
    STATE(12366), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481726] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(8125), 1,
      sym__single_quote_string,
    STATE(8128), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481747] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15282), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10863), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481768] = 5,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(8765), 1,
      sym_ordered_columns,
    STATE(11593), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [481787] = 4,
    ACTIONS(15284), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4423), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(1023), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [481804] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15286), 1,
      sym_keyword_separator,
    ACTIONS(15288), 1,
      anon_sym_RPAREN,
    ACTIONS(15290), 1,
      anon_sym_COMMA,
    STATE(10928), 1,
      aux_sym_invocation_repeat1,
    STATE(13377), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481827] = 4,
    ACTIONS(15292), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3450), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(1221), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [481844] = 4,
    ACTIONS(15294), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4345), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(1349), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [481861] = 4,
    ACTIONS(14954), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4799), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(963), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [481878] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15296), 1,
      sym_keyword_on,
    ACTIONS(15298), 1,
      sym_keyword_as,
    STATE(14113), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [481899] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15300), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [481912] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15302), 1,
      sym_keyword_separator,
    ACTIONS(15304), 1,
      anon_sym_RPAREN,
    ACTIONS(15306), 1,
      anon_sym_COMMA,
    STATE(10288), 1,
      aux_sym_invocation_repeat1,
    STATE(13720), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [481935] = 5,
    ACTIONS(15308), 1,
      anon_sym_RPAREN,
    STATE(8143), 1,
      sym_identifier,
    STATE(10656), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [481954] = 6,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15310), 1,
      anon_sym_RPAREN,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10660), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [481975] = 6,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15312), 1,
      sym_keyword_null,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(7228), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2967), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [481996] = 5,
    ACTIONS(15314), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(10306), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482015] = 5,
    ACTIONS(15316), 1,
      sym_keyword_collate,
    STATE(11280), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14762), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15318), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [482034] = 4,
    ACTIONS(15320), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4078), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(275), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482051] = 4,
    ACTIONS(15322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2420), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(957), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482068] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15324), 1,
      sym_keyword_on,
    ACTIONS(15326), 1,
      sym_keyword_as,
    STATE(14102), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482089] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11630), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [482102] = 7,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    ACTIONS(15328), 1,
      anon_sym_RPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7565), 1,
      sym__select_statement,
    STATE(7988), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482125] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15330), 1,
      sym_keyword_separator,
    ACTIONS(15332), 1,
      anon_sym_RPAREN,
    ACTIONS(15334), 1,
      anon_sym_COMMA,
    STATE(10263), 1,
      aux_sym_invocation_repeat1,
    STATE(12342), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482148] = 6,
    ACTIONS(12662), 1,
      sym_keyword_rename,
    ACTIONS(12664), 1,
      sym_keyword_owner,
    ACTIONS(15336), 1,
      sym_keyword_set,
    ACTIONS(15338), 1,
      sym_keyword_reset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(11319), 2,
      sym_rename_object,
      sym_change_ownership,
  [482169] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15340), 1,
      sym_keyword_tablespace,
    STATE(10386), 1,
      sym_identifier,
    STATE(11319), 1,
      sym_set_configuration,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482190] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15342), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [482211] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15344), 1,
      sym_keyword_separator,
    ACTIONS(15346), 1,
      anon_sym_RPAREN,
    ACTIONS(15348), 1,
      anon_sym_COMMA,
    STATE(10284), 1,
      aux_sym_invocation_repeat1,
    STATE(12324), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482234] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15350), 1,
      sym_keyword_separator,
    ACTIONS(15352), 1,
      anon_sym_RPAREN,
    ACTIONS(15354), 1,
      anon_sym_COMMA,
    STATE(10652), 1,
      aux_sym_invocation_repeat1,
    STATE(12504), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482257] = 4,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6001), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482274] = 6,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(15358), 1,
      sym_keyword_none,
    STATE(1818), 1,
      sym_identifier,
    STATE(7327), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482295] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15360), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10752), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482316] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8223), 1,
      sym_identifier,
    STATE(10044), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482337] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15362), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10904), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482358] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8462), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15364), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [482375] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15366), 1,
      sym_keyword_separator,
    ACTIONS(15368), 1,
      anon_sym_RPAREN,
    ACTIONS(15370), 1,
      anon_sym_COMMA,
    STATE(10313), 1,
      aux_sym_invocation_repeat1,
    STATE(12255), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482398] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15372), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10412), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482419] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15374), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [482432] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15376), 1,
      sym_keyword_column,
    ACTIONS(15378), 1,
      sym_keyword_to,
    STATE(13739), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482453] = 4,
    ACTIONS(15380), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4392), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(635), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482470] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    STATE(9541), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15382), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [482487] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15384), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [482500] = 4,
    ACTIONS(15386), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4454), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(695), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482517] = 4,
    ACTIONS(15388), 1,
      anon_sym_COMMA,
    STATE(8588), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
  [482534] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15390), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [482547] = 4,
    ACTIONS(15394), 1,
      sym_keyword_cascade,
    ACTIONS(15396), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15392), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [482564] = 5,
    ACTIONS(15398), 1,
      anon_sym_RPAREN,
    STATE(8143), 1,
      sym_identifier,
    STATE(10389), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482583] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15400), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [482604] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15402), 1,
      sym_keyword_separator,
    ACTIONS(15404), 1,
      anon_sym_RPAREN,
    ACTIONS(15406), 1,
      anon_sym_COMMA,
    STATE(11128), 1,
      aux_sym_invocation_repeat1,
    STATE(13983), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482627] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15408), 1,
      sym_keyword_on,
    ACTIONS(15410), 1,
      sym_keyword_as,
    STATE(12781), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482648] = 5,
    ACTIONS(14996), 1,
      anon_sym_COMMA,
    STATE(8353), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14887), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15412), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [482667] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15414), 1,
      sym_keyword_tablespace,
    STATE(10480), 1,
      sym_set_configuration,
    STATE(10544), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482688] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15416), 1,
      sym_keyword_on,
    ACTIONS(15418), 1,
      sym_keyword_as,
    STATE(12297), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482709] = 5,
    ACTIONS(13429), 1,
      sym_keyword_from,
    ACTIONS(15420), 1,
      anon_sym_RPAREN,
    STATE(9509), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 3,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [482728] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15422), 1,
      sym_keyword_on,
    ACTIONS(15424), 1,
      sym_keyword_as,
    STATE(12293), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482749] = 4,
    ACTIONS(15428), 1,
      sym_keyword_as,
    ACTIONS(15430), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15426), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [482766] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11766), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [482779] = 5,
    ACTIONS(14033), 1,
      sym_keyword_noscan,
    ACTIONS(15434), 1,
      sym_keyword_for,
    ACTIONS(15436), 1,
      sym_keyword_cache,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15432), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [482798] = 6,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15312), 1,
      sym_keyword_null,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(7228), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3116), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [482819] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15438), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [482836] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11770), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [482849] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15440), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [482862] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15442), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [482883] = 4,
    ACTIONS(15292), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3450), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [482900] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15444), 1,
      sym_keyword_separator,
    ACTIONS(15446), 1,
      anon_sym_RPAREN,
    ACTIONS(15448), 1,
      anon_sym_COMMA,
    STATE(11132), 1,
      aux_sym_invocation_repeat1,
    STATE(14284), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [482923] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15450), 1,
      sym_keyword_on,
    ACTIONS(15452), 1,
      sym_keyword_as,
    STATE(12284), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482944] = 6,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(15454), 1,
      sym_keyword_none,
    STATE(1818), 1,
      sym_identifier,
    STATE(7337), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482965] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15456), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10693), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [482986] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15458), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [482999] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15460), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [483012] = 4,
    ACTIONS(15462), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2691), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(515), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [483029] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15464), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483046] = 6,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(14332), 1,
      sym_keyword_if,
    STATE(8421), 1,
      sym_identifier,
    STATE(9924), 1,
      sym__if_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483067] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8613), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15464), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483084] = 5,
    ACTIONS(15466), 1,
      sym_keyword_on,
    STATE(10635), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14907), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15468), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [483103] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15470), 1,
      sym_keyword_separator,
    ACTIONS(15472), 1,
      anon_sym_RPAREN,
    ACTIONS(15474), 1,
      anon_sym_COMMA,
    STATE(10773), 1,
      aux_sym_invocation_repeat1,
    STATE(13173), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483126] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8614), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15476), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483143] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15478), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10581), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483164] = 4,
    STATE(10254), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15482), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15480), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [483181] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15484), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483198] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15486), 1,
      sym_keyword_on,
    ACTIONS(15488), 1,
      sym_keyword_as,
    STATE(12210), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483219] = 4,
    STATE(10229), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15492), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15490), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [483236] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15494), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [483257] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8619), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15484), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483274] = 5,
    ACTIONS(15496), 1,
      anon_sym_RPAREN,
    STATE(9094), 1,
      sym_identifier,
    STATE(10547), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [483293] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15498), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [483306] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15364), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483323] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15500), 1,
      sym_keyword_on,
    ACTIONS(15502), 1,
      sym_keyword_as,
    STATE(12206), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483344] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15504), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483361] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15506), 1,
      sym_keyword_separator,
    ACTIONS(15508), 1,
      anon_sym_RPAREN,
    ACTIONS(15510), 1,
      anon_sym_COMMA,
    STATE(11161), 1,
      aux_sym_invocation_repeat1,
    STATE(14492), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483384] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15512), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483401] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15514), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [483422] = 5,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9048), 1,
      sym_ordered_columns,
    STATE(11497), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [483441] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15516), 1,
      sym_keyword_on,
    ACTIONS(15518), 1,
      sym_keyword_as,
    STATE(12197), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483462] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15520), 1,
      sym_keyword_on,
    ACTIONS(15522), 1,
      sym_keyword_as,
    STATE(13416), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483483] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14653), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [483496] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15524), 1,
      sym_keyword_separator,
    ACTIONS(15526), 1,
      anon_sym_RPAREN,
    ACTIONS(15528), 1,
      anon_sym_COMMA,
    STATE(10765), 1,
      aux_sym_invocation_repeat1,
    STATE(13226), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483519] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15530), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [483540] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15532), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [483553] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15534), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [483566] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15536), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10796), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483587] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15538), 1,
      sym_keyword_separator,
    ACTIONS(15540), 1,
      anon_sym_RPAREN,
    ACTIONS(15542), 1,
      anon_sym_COMMA,
    STATE(10728), 1,
      aux_sym_invocation_repeat1,
    STATE(13055), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483610] = 6,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15544), 1,
      sym_keyword_null,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(7103), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2474), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [483631] = 4,
    ACTIONS(15546), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2669), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(1095), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [483648] = 6,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(15548), 1,
      sym_keyword_only,
    STATE(7929), 1,
      sym_object_reference,
    STATE(8186), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483669] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15550), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [483682] = 5,
    ACTIONS(13429), 1,
      sym_keyword_from,
    ACTIONS(15552), 1,
      anon_sym_RPAREN,
    STATE(9769), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 3,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [483701] = 4,
    ACTIONS(15388), 1,
      anon_sym_COMMA,
    STATE(8592), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
  [483718] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15554), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [483739] = 4,
    ACTIONS(15556), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2270), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(759), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [483756] = 6,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(14344), 1,
      sym_keyword_if,
    STATE(7607), 1,
      sym_identifier,
    STATE(9733), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483777] = 4,
    ACTIONS(15558), 1,
      anon_sym_COMMA,
    STATE(8592), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
  [483794] = 4,
    STATE(9094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8124), 2,
      sym_field,
      aux_sym__compute_stats_repeat1,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [483811] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15561), 1,
      sym_keyword_separator,
    ACTIONS(15563), 1,
      anon_sym_RPAREN,
    ACTIONS(15565), 1,
      anon_sym_COMMA,
    STATE(11148), 1,
      aux_sym_invocation_repeat1,
    STATE(14444), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483834] = 5,
    ACTIONS(13989), 1,
      sym_keyword_noscan,
    ACTIONS(15569), 1,
      sym_keyword_for,
    ACTIONS(15571), 1,
      sym_keyword_cache,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15567), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [483853] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15573), 1,
      sym_keyword_on,
    ACTIONS(15575), 1,
      sym_keyword_as,
    STATE(13295), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [483874] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15577), 1,
      sym_keyword_separator,
    ACTIONS(15579), 1,
      anon_sym_RPAREN,
    ACTIONS(15581), 1,
      anon_sym_COMMA,
    STATE(10736), 1,
      aux_sym_invocation_repeat1,
    STATE(12951), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483897] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10533), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14732), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [483916] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15583), 1,
      sym_keyword_separator,
    ACTIONS(15585), 1,
      anon_sym_RPAREN,
    ACTIONS(15587), 1,
      anon_sym_COMMA,
    STATE(11153), 1,
      aux_sym_invocation_repeat1,
    STATE(14486), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [483939] = 4,
    ACTIONS(15589), 1,
      anon_sym_COMMA,
    STATE(8600), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
  [483956] = 4,
    ACTIONS(15220), 1,
      anon_sym_COMMA,
    STATE(8453), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_from,
      sym_keyword_create,
  [483973] = 5,
    ACTIONS(15592), 1,
      sym_keyword_collate,
    STATE(11232), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14794), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15594), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [483992] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10536), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14736), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [484011] = 4,
    ACTIONS(15596), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(851), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(335), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484028] = 4,
    STATE(61), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(8228), 2,
      sym_function_declaration,
      aux_sym_function_body_repeat2,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484045] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10541), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14740), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [484064] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15598), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [484085] = 6,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15600), 1,
      sym_keyword_null,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(7102), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [484106] = 5,
    ACTIONS(15602), 1,
      sym_keyword_nulls,
    STATE(10622), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15604), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484125] = 5,
    ACTIONS(14936), 1,
      sym_keyword_first,
    ACTIONS(14938), 1,
      sym_keyword_after,
    STATE(10231), 1,
      sym_column_position,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14885), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [484144] = 5,
    ACTIONS(15606), 1,
      sym_keyword_nulls,
    STATE(10556), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15608), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484163] = 5,
    STATE(6414), 1,
      sym_identifier,
    STATE(9587), 1,
      sym__rename_table_names,
    STATE(13403), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484182] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15610), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484199] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15612), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484216] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15614), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10469), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484237] = 4,
    ACTIONS(15616), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4733), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(575), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484254] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8665), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15612), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484271] = 4,
    ACTIONS(15618), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14653), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [484288] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15621), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484305] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15623), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [484318] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15625), 1,
      sym_keyword_separator,
    ACTIONS(15627), 1,
      anon_sym_RPAREN,
    ACTIONS(15629), 1,
      anon_sym_COMMA,
    STATE(10397), 1,
      aux_sym_invocation_repeat1,
    STATE(12115), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [484341] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15631), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [484362] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15633), 1,
      sym_keyword_only,
    STATE(6414), 1,
      sym_identifier,
    STATE(10489), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484383] = 5,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(8834), 1,
      sym_ordered_columns,
    STATE(11538), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484402] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8540), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15610), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484419] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15635), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [484440] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8403), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15637), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484457] = 4,
    STATE(10785), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15641), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
    ACTIONS(15639), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [484474] = 5,
    ACTIONS(15643), 1,
      sym_keyword_collate,
    STATE(11264), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14916), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15645), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [484493] = 6,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15544), 1,
      sym_keyword_null,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(7103), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [484514] = 5,
    ACTIONS(15647), 1,
      anon_sym_RPAREN,
    STATE(8143), 1,
      sym_identifier,
    STATE(10501), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484533] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15649), 1,
      sym_keyword_on,
    ACTIONS(15651), 1,
      sym_keyword_as,
    STATE(13924), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484554] = 3,
    ACTIONS(15655), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15653), 5,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_nulls,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484569] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15657), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [484590] = 4,
    ACTIONS(15659), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5533), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484607] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15661), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [484620] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15663), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [484633] = 4,
    ACTIONS(15546), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2669), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [484650] = 5,
    ACTIONS(15665), 1,
      sym_keyword_collate,
    STATE(11260), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14861), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15667), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [484669] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15669), 1,
      sym_keyword_separator,
    ACTIONS(15671), 1,
      anon_sym_RPAREN,
    ACTIONS(15673), 1,
      anon_sym_COMMA,
    STATE(10426), 1,
      aux_sym_invocation_repeat1,
    STATE(12084), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [484692] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11692), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [484705] = 5,
    ACTIONS(15675), 1,
      sym_keyword_nulls,
    STATE(10440), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15677), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14869), 2,
      sym_keyword_create,
      sym__identifier,
    ACTIONS(14867), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484739] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15679), 1,
      sym_keyword_separator,
    ACTIONS(15681), 1,
      anon_sym_RPAREN,
    ACTIONS(15683), 1,
      anon_sym_COMMA,
    STATE(10864), 1,
      aux_sym_invocation_repeat1,
    STATE(13523), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [484762] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15685), 6,
      sym_keyword_btree,
      sym_keyword_hash,
      sym_keyword_gist,
      sym_keyword_spgist,
      sym_keyword_gin,
      sym_keyword_brin,
  [484775] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15687), 1,
      sym_keyword_separator,
    ACTIONS(15689), 1,
      anon_sym_RPAREN,
    ACTIONS(15691), 1,
      anon_sym_COMMA,
    STATE(11222), 1,
      aux_sym_invocation_repeat1,
    STATE(14587), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [484798] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8567), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15693), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484815] = 6,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(8432), 1,
      sym__single_quote_string,
    STATE(8436), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484836] = 6,
    ACTIONS(1157), 1,
      sym__identifier,
    ACTIONS(15695), 1,
      sym_keyword_only,
    STATE(1818), 1,
      sym_identifier,
    STATE(7653), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484857] = 4,
    ACTIONS(14639), 1,
      sym_keyword_from,
    STATE(7576), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [484874] = 5,
    ACTIONS(15697), 1,
      sym_keyword_nulls,
    STATE(10526), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15699), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484893] = 6,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15701), 1,
      sym_keyword_on,
    ACTIONS(15703), 1,
      sym_keyword_as,
    STATE(14049), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [484914] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8569), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15438), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484931] = 5,
    ACTIONS(15705), 1,
      sym_keyword_nulls,
    STATE(10562), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(6520), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15707), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [484950] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15709), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [484971] = 4,
    ACTIONS(15711), 1,
      anon_sym_COMMA,
    STATE(8656), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11839), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [484988] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11736), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [485001] = 4,
    ACTIONS(15714), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4338), 2,
      sym_window_specification,
      sym_identifier,
    ACTIONS(215), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [485018] = 4,
    ACTIONS(14744), 1,
      sym_keyword_exclude,
    ACTIONS(15716), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(14054), 4,
      sym__exclude_current_row,
      sym__exclude_group,
      sym__exclude_no_others,
      sym__exclude_ties,
  [485035] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(8571), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15102), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [485052] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15718), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [485073] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15720), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [485094] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11728), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [485107] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15722), 1,
      sym_keyword_separator,
    ACTIONS(15724), 1,
      anon_sym_RPAREN,
    ACTIONS(15726), 1,
      anon_sym_COMMA,
    STATE(10835), 1,
      aux_sym_invocation_repeat1,
    STATE(13474), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485130] = 4,
    ACTIONS(11490), 1,
      sym_keyword_on,
    STATE(6652), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15728), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [485147] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15730), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [485168] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15732), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [485189] = 6,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(15600), 1,
      sym_keyword_null,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(7102), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2474), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485210] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15734), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [485231] = 6,
    ACTIONS(14972), 1,
      sym_keyword_in,
    ACTIONS(14976), 1,
      sym_keyword_similar,
    ACTIONS(15736), 1,
      sym_keyword_between,
    STATE(6600), 1,
      sym_keyword_like,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2402), 2,
      aux_sym_keyword_like_token1,
      aux_sym_keyword_like_token2,
  [485252] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11720), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [485265] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11638), 6,
      sym_keyword_select,
      sym_keyword_values,
      sym_keyword_set,
      sym_keyword_as,
      sym_keyword_with,
      anon_sym_LPAREN,
  [485278] = 7,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(15738), 1,
      sym_keyword_separator,
    ACTIONS(15740), 1,
      anon_sym_RPAREN,
    ACTIONS(15742), 1,
      anon_sym_COMMA,
    STATE(11193), 1,
      aux_sym_invocation_repeat1,
    STATE(14555), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485301] = 5,
    ACTIONS(14573), 1,
      sym_keyword_cascade,
    ACTIONS(14577), 1,
      sym_keyword_schema,
    ACTIONS(14579), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14360), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [485320] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15744), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_create,
      anon_sym_RPAREN,
  [485332] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15746), 1,
      sym_keyword_all,
    STATE(10548), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [485350] = 5,
    ACTIONS(4160), 1,
      aux_sym__single_quote_string_token1,
    STATE(2271), 1,
      sym__single_quote_string,
    STATE(3988), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4168), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485368] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15748), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [485384] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15748), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [485400] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15750), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [485416] = 4,
    ACTIONS(15754), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15752), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [485432] = 6,
    ACTIONS(15757), 1,
      anon_sym_RBRACK,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    STATE(14583), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485452] = 4,
    ACTIONS(14595), 1,
      anon_sym_RPAREN,
    STATE(14585), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485468] = 4,
    ACTIONS(15765), 1,
      anon_sym_RPAREN,
    STATE(14547), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485484] = 4,
    STATE(11925), 1,
      sym__key_value_pair,
    STATE(12566), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [485500] = 5,
    ACTIONS(2845), 1,
      aux_sym__single_quote_string_token1,
    STATE(3470), 1,
      sym__literal_string,
    STATE(3487), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2853), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485518] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11919), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485536] = 4,
    ACTIONS(14641), 1,
      anon_sym_RPAREN,
    STATE(14482), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485552] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15767), 1,
      anon_sym_RBRACK,
    STATE(14479), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485572] = 4,
    ACTIONS(15769), 1,
      anon_sym_RPAREN,
    STATE(14436), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485588] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15771), 1,
      anon_sym_RBRACK,
    STATE(14397), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485608] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6736), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485626] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15240), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485642] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6650), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485660] = 4,
    ACTIONS(15773), 1,
      anon_sym_RPAREN,
    STATE(14499), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485676] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15775), 1,
      anon_sym_RBRACK,
    STATE(14208), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485696] = 4,
    ACTIONS(14810), 1,
      anon_sym_RPAREN,
    STATE(14290), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485712] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8693), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15364), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485728] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9859), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15777), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [485744] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7565), 1,
      sym__select_statement,
    STATE(7988), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485764] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15779), 1,
      anon_sym_RBRACK,
    STATE(14252), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [485784] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10342), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [485800] = 4,
    ACTIONS(15781), 1,
      anon_sym_STAR,
    STATE(4356), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(215), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [485816] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15364), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485832] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7788), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [485848] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15504), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485864] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15512), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485880] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8706), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15438), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485896] = 5,
    ACTIONS(4296), 1,
      aux_sym__single_quote_string_token1,
    STATE(4381), 1,
      sym__single_quote_string,
    STATE(4444), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4304), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [485914] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8707), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15102), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485930] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15102), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485946] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15438), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [485962] = 4,
    ACTIONS(15785), 1,
      anon_sym_RPAREN,
    STATE(12362), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [485978] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6973), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [485994] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15728), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486010] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15787), 5,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_nulls,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [486022] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15789), 1,
      sym_keyword_all,
    STATE(9718), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [486040] = 3,
    ACTIONS(15793), 1,
      sym_keyword_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15791), 4,
      sym_keyword_table,
      sym_keyword_view,
      sym_keyword_recursive,
      sym_keyword_trigger,
  [486054] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8711), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15637), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486070] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8712), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15610), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486086] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10051), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15795), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [486102] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9397), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15797), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [486118] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9793), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486134] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9397), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15801), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [486150] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(8876), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15803), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [486166] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15621), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486182] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6979), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486198] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10063), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15805), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [486214] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8715), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15612), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486230] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6980), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486246] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15612), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486262] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15610), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486278] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6976), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486294] = 4,
    ACTIONS(15809), 1,
      sym_keyword_cache,
    ACTIONS(15811), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15807), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [486310] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8726), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15484), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486326] = 3,
    ACTIONS(15815), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15813), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [486340] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10072), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15817), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [486356] = 4,
    ACTIONS(15819), 1,
      anon_sym_RPAREN,
    STATE(14062), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [486372] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15484), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486388] = 4,
    STATE(6365), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486404] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8731), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15476), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486420] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8732), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15464), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486436] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10079), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15821), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [486452] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15464), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486468] = 4,
    STATE(6369), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486484] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15823), 1,
      anon_sym_RBRACK,
    STATE(14002), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [486504] = 4,
    ACTIONS(14571), 1,
      anon_sym_RPAREN,
    STATE(14000), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [486520] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8199), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486536] = 3,
    ACTIONS(15827), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15825), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [486550] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11038), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15829), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [486566] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10951), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15831), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [486582] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(7032), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486598] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8739), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15252), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486614] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(6673), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15246), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486630] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8744), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15246), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486646] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10560), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15833), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [486662] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10561), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486678] = 5,
    ACTIONS(4198), 1,
      aux_sym__single_quote_string_token1,
    STATE(2651), 1,
      sym__single_quote_string,
    STATE(2680), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4206), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [486696] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10253), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [486714] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10001), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15837), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [486730] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6977), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486746] = 3,
    ACTIONS(15841), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15839), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [486760] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14030), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486776] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10415), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486792] = 3,
    ACTIONS(15845), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15843), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [486806] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8704), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15693), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486822] = 4,
    STATE(11539), 1,
      sym_direction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10985), 2,
      sym_keyword_desc,
      sym_keyword_asc,
    ACTIONS(15847), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [486838] = 4,
    STATE(6372), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [486854] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15849), 1,
      sym_keyword_column,
    STATE(10376), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [486872] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11169), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15851), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [486888] = 4,
    ACTIONS(15855), 1,
      sym_keyword_inner,
    ACTIONS(15857), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15853), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [486904] = 4,
    STATE(11228), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15090), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15859), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [486920] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10111), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15861), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [486936] = 4,
    ACTIONS(11553), 1,
      sym_keyword_on,
    STATE(8754), 1,
      aux_sym__column_constraint_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15244), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [486952] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15863), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_create,
      anon_sym_RPAREN,
  [486964] = 3,
    ACTIONS(15867), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15865), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [486978] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10275), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [486996] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10290), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [487014] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10264), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [487032] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10989), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15869), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [487048] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14118), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487064] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11793), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487080] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15871), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [487096] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15871), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [487112] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(15873), 1,
      sym_keyword_all,
    STATE(7475), 1,
      sym_select,
    STATE(7573), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487132] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10327), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487148] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10972), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15875), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [487164] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10334), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487180] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10355), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15877), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [487196] = 4,
    ACTIONS(15879), 1,
      anon_sym_RPAREN,
    STATE(13793), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [487212] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6978), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487228] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10967), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15881), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [487244] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15883), 1,
      anon_sym_RBRACK,
    STATE(13617), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487264] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8534), 1,
      sym_select,
    STATE(9424), 1,
      sym__select_statement,
    STATE(13490), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487284] = 4,
    ACTIONS(14776), 1,
      anon_sym_RPAREN,
    STATE(13609), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [487300] = 6,
    ACTIONS(15885), 1,
      sym_keyword_constraint,
    ACTIONS(15887), 1,
      sym_keyword_temp,
    ACTIONS(15889), 1,
      sym_keyword_temporary,
    ACTIONS(15891), 1,
      sym_keyword_trigger,
    STATE(14586), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487320] = 6,
    ACTIONS(15893), 1,
      sym_keyword_constraint,
    ACTIONS(15895), 1,
      sym_keyword_temp,
    ACTIONS(15897), 1,
      sym_keyword_temporary,
    ACTIONS(15899), 1,
      sym_keyword_trigger,
    STATE(14584), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487340] = 5,
    ACTIONS(775), 1,
      sym__identifier,
    ACTIONS(15901), 1,
      sym_keyword_all,
    STATE(6903), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [487358] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10628), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487374] = 4,
    ACTIONS(15905), 1,
      sym_keyword_inner,
    ACTIONS(15907), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15903), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [487390] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9907), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15909), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [487406] = 5,
    ACTIONS(3548), 1,
      aux_sym__single_quote_string_token1,
    STATE(2092), 1,
      sym__literal_string,
    STATE(2205), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3556), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [487424] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10949), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15911), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [487440] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(15913), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [487458] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9001), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487474] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8587), 1,
      sym_select,
    STATE(8860), 1,
      sym__select_statement,
    STATE(13819), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487494] = 6,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(15915), 1,
      sym_keyword_all,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7600), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487514] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15919), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [487530] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10482), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [487548] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15919), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [487564] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10488), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [487582] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15921), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [487598] = 6,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(12300), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7616), 1,
      sym__select_statement,
    STATE(8251), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [487618] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8576), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487634] = 4,
    STATE(10887), 1,
      sym__key_value_pair,
    STATE(12566), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487650] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(15923), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [487668] = 4,
    ACTIONS(15781), 1,
      anon_sym_STAR,
    STATE(2670), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487684] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10933), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15925), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [487700] = 4,
    STATE(8143), 1,
      sym_identifier,
    STATE(11848), 1,
      sym__with_settings,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487716] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10584), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15927), 5,
      sym_keyword_default,
      sym_keyword_plain,
      sym_keyword_extended,
      sym_keyword_main,
      sym_keyword_external,
  [487744] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15929), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_references,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [487756] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10925), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15931), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [487772] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10596), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487788] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10742), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487804] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14131), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487820] = 3,
    ACTIONS(15935), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15933), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [487834] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10741), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487850] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10735), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487866] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14134), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487882] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12167), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487898] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(11469), 1,
      sym_keyword_none,
    STATE(10775), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [487916] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(11469), 1,
      sym_keyword_default,
    STATE(10775), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [487934] = 3,
    ACTIONS(15939), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15937), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [487948] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10731), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [487964] = 4,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15941), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [487980] = 4,
    ACTIONS(15943), 1,
      anon_sym_RPAREN,
    STATE(13531), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [487996] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10648), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [488014] = 4,
    STATE(3575), 1,
      sym_identifier,
    STATE(7364), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488030] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(15945), 1,
      anon_sym_RBRACK,
    STATE(13485), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [488050] = 4,
    ACTIONS(14589), 1,
      anon_sym_RPAREN,
    STATE(13484), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [488066] = 4,
    STATE(6355), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488082] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10842), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15947), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488098] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10891), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15949), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488114] = 4,
    ACTIONS(15951), 1,
      anon_sym_RPAREN,
    STATE(10921), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488130] = 6,
    ACTIONS(12662), 1,
      sym_keyword_rename,
    ACTIONS(15953), 1,
      sym_keyword_set,
    ACTIONS(15955), 1,
      sym_keyword_alter,
    ACTIONS(15957), 1,
      sym_keyword_reset,
    STATE(11353), 1,
      sym_rename_object,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [488150] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10674), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488166] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11992), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [488184] = 4,
    ACTIONS(15959), 1,
      anon_sym_RPAREN,
    STATE(10676), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488200] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11830), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488216] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10889), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15961), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488232] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10888), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15963), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488248] = 3,
    ACTIONS(15967), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15965), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [488262] = 3,
    ACTIONS(15971), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15969), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [488276] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10694), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488292] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(15913), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [488310] = 6,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(15973), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7631), 1,
      sym__select_statement,
    STATE(8268), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [488330] = 3,
    ACTIONS(15098), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15096), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [488344] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(7208), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488360] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(15975), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [488378] = 5,
    ACTIONS(3716), 1,
      aux_sym__single_quote_string_token1,
    STATE(4687), 1,
      sym__single_quote_string,
    STATE(4697), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3724), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [488396] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10632), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488412] = 4,
    STATE(7869), 1,
      sym_object_reference,
    STATE(8186), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488428] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7928), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488444] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15977), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [488460] = 4,
    STATE(10732), 1,
      sym__key_value_pair,
    STATE(12566), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488476] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15977), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [488492] = 3,
    ACTIONS(15981), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15979), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [488506] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15983), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [488522] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(15985), 1,
      sym_keyword_column,
    STATE(10969), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [488540] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(11842), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15987), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [488556] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10964), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488572] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10929), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488588] = 4,
    STATE(9094), 1,
      sym_identifier,
    STATE(11995), 1,
      sym_field,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488604] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10870), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15989), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [488620] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9397), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15991), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [488636] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10865), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15993), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [488652] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10591), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488668] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9005), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15995), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [488684] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10580), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488700] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10806), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488716] = 4,
    STATE(10808), 1,
      sym__key_value_pair,
    STATE(12566), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488732] = 4,
    STATE(11240), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15480), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15997), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [488748] = 4,
    STATE(11241), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15490), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(15999), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [488764] = 4,
    ACTIONS(16001), 1,
      anon_sym_RPAREN,
    STATE(13297), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [488780] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16003), 1,
      anon_sym_RBRACK,
    STATE(12954), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [488800] = 4,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
    STATE(12952), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [488816] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10461), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488832] = 4,
    STATE(11231), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15168), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16005), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [488848] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10707), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488864] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10463), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488880] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11815), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [488896] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10822), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15861), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488912] = 5,
    ACTIONS(3932), 1,
      aux_sym__single_quote_string_token1,
    STATE(5675), 1,
      sym__literal_string,
    STATE(5722), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3942), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [488930] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10811), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15821), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488946] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10810), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15817), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [488962] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6718), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [488980] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10172), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15993), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [488996] = 6,
    ACTIONS(16007), 1,
      sym_keyword_by,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7488), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489016] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(16015), 1,
      sym_keyword_all,
    STATE(10476), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [489034] = 3,
    ACTIONS(16019), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16017), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [489048] = 6,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    ACTIONS(16021), 1,
      sym_keyword_with,
    STATE(7491), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489068] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(16023), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [489086] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10801), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15805), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [489102] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10800), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15795), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [489118] = 4,
    ACTIONS(16025), 1,
      anon_sym_RPAREN,
    STATE(10504), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489134] = 4,
    ACTIONS(16025), 1,
      anon_sym_RPAREN,
    STATE(12085), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489150] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15748), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489166] = 4,
    STATE(3575), 1,
      sym_identifier,
    STATE(7343), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489182] = 4,
    STATE(10386), 1,
      sym_identifier,
    STATE(11325), 1,
      sym_set_configuration,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489198] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15748), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489214] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11779), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [489232] = 4,
    STATE(6339), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489248] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10157), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15989), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [489264] = 4,
    ACTIONS(16027), 1,
      anon_sym_RPAREN,
    STATE(12562), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [489280] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15983), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489296] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15750), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489312] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15977), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489328] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15977), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489344] = 4,
    ACTIONS(16029), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15752), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [489360] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16032), 1,
      anon_sym_RBRACK,
    STATE(12353), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489380] = 4,
    ACTIONS(14841), 1,
      anon_sym_RPAREN,
    STATE(12341), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [489396] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13466), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489412] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10771), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15777), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [489428] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10757), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489444] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13302), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489460] = 5,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(6761), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3896), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [489478] = 6,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    ACTIONS(16034), 1,
      sym_keyword_with,
    STATE(7512), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489498] = 6,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    ACTIONS(16036), 1,
      sym_keyword_with,
    STATE(7510), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489518] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7960), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489534] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(8191), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489550] = 4,
    ACTIONS(16038), 1,
      anon_sym_RPAREN,
    STATE(13307), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489566] = 6,
    ACTIONS(12662), 1,
      sym_keyword_rename,
    ACTIONS(16040), 1,
      sym_keyword_set,
    ACTIONS(16042), 1,
      sym_keyword_alter,
    ACTIONS(16044), 1,
      sym_keyword_reset,
    STATE(11320), 1,
      sym_rename_object,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489586] = 3,
    ACTIONS(16048), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16046), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [489600] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10695), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489616] = 5,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(4406), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3820), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [489634] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10408), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16050), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489650] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7749), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489666] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14160), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489682] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10402), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16052), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489698] = 4,
    STATE(11251), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15639), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16054), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [489714] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10390), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16056), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489730] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10384), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16058), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489746] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10321), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16060), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489762] = 4,
    ACTIONS(16038), 1,
      anon_sym_RPAREN,
    STATE(10860), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489778] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9841), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489794] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9313), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489810] = 6,
    ACTIONS(16062), 1,
      sym_keyword_constraint,
    ACTIONS(16064), 1,
      sym_keyword_temp,
    ACTIONS(16066), 1,
      sym_keyword_temporary,
    ACTIONS(16068), 1,
      sym_keyword_trigger,
    STATE(12809), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489830] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8587), 1,
      sym_select,
    STATE(9035), 1,
      sym__select_statement,
    STATE(13724), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [489850] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12786), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489866] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11874), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489882] = 3,
    ACTIONS(14849), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [489896] = 3,
    ACTIONS(16072), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16070), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [489910] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8376), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [489926] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10294), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16074), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489942] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10289), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16076), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [489958] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16078), 5,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_nulls,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [489970] = 4,
    ACTIONS(16080), 1,
      anon_sym_RPAREN,
    STATE(12116), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [489986] = 4,
    ACTIONS(14734), 1,
      anon_sym_RPAREN,
    STATE(13718), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [490002] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16082), 1,
      anon_sym_RBRACK,
    STATE(12028), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [490022] = 3,
    ACTIONS(16086), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16084), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [490036] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16088), 1,
      anon_sym_RBRACK,
    STATE(13717), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [490056] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9808), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490072] = 4,
    ACTIONS(14784), 1,
      anon_sym_RPAREN,
    STATE(12030), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [490088] = 3,
    ACTIONS(16092), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16090), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [490102] = 3,
    ACTIONS(16096), 1,
      sym_keyword_collate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16094), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [490116] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10677), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16098), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490132] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13525), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490148] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16102), 2,
      sym_keyword_after,
      sym_keyword_before,
    ACTIONS(16100), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [490162] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10673), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16104), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490178] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10672), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16106), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490194] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10901), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490210] = 4,
    ACTIONS(16108), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16110), 2,
      sym_keyword_true,
      sym_keyword_false,
    ACTIONS(16112), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [490226] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10644), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16114), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490242] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10912), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490258] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9654), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16116), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [490274] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10946), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490290] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10955), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490306] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10992), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490322] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10115), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15963), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [490338] = 5,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(7240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3116), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490356] = 5,
    ACTIONS(3108), 1,
      aux_sym__single_quote_string_token1,
    STATE(2953), 1,
      sym__single_quote_string,
    STATE(4911), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3116), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490374] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10094), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15961), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [490390] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10995), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16118), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [490406] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10272), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16120), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [490422] = 4,
    ACTIONS(9590), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16122), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    STATE(8920), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [490438] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10093), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15949), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [490454] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10613), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16124), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [490470] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10085), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15947), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [490486] = 3,
    ACTIONS(16128), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16126), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [490500] = 4,
    ACTIONS(16130), 1,
      anon_sym_RPAREN,
    STATE(11024), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490516] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10271), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16132), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [490532] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16134), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
      anon_sym_RPAREN,
  [490544] = 5,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(7126), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2474), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490562] = 4,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(3367), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16136), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [490578] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9960), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490594] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11297), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490610] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9487), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16138), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [490626] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(11257), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490642] = 4,
    ACTIONS(16140), 1,
      anon_sym_RPAREN,
    STATE(12081), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [490658] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9392), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16142), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [490674] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16144), 1,
      anon_sym_RBRACK,
    STATE(12113), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [490694] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9394), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490710] = 4,
    ACTIONS(14627), 1,
      anon_sym_RPAREN,
    STATE(12114), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [490726] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9397), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16142), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [490742] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9399), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490758] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10938), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490776] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10917), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490794] = 5,
    ACTIONS(16146), 1,
      sym__identifier,
    ACTIONS(16148), 1,
      sym_keyword_as,
    STATE(8058), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [490812] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13539), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490828] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13540), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [490844] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(16150), 1,
      sym_keyword_all,
    STATE(11267), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [490862] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(6693), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490880] = 5,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(4628), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2967), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490898] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10506), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16152), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [490914] = 4,
    ACTIONS(16154), 1,
      sym_keyword_cascade,
    ACTIONS(16156), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15392), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490930] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10898), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490948] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10895), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [490966] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10490), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16158), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490982] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10487), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16160), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [490998] = 4,
    ACTIONS(16162), 1,
      anon_sym_RPAREN,
    STATE(13431), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491014] = 4,
    ACTIONS(16162), 1,
      anon_sym_RPAREN,
    STATE(10403), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491030] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10877), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491048] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11142), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491066] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10778), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491084] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10760), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491102] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10738), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491120] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13551), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491136] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10723), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491154] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(10436), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15382), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [491170] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16164), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_references,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [491182] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16166), 1,
      anon_sym_RBRACK,
    STATE(14149), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [491202] = 4,
    STATE(6352), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491218] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13552), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491234] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(16168), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [491252] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14228), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491268] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10696), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491286] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11553), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491304] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10092), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491320] = 4,
    ACTIONS(14716), 1,
      anon_sym_RPAREN,
    STATE(14046), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [491336] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14237), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491352] = 3,
    ACTIONS(16172), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16170), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [491366] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10110), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491382] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(11275), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491398] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8147), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491414] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10977), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491432] = 4,
    ACTIONS(16174), 1,
      anon_sym_RPAREN,
    STATE(12232), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [491448] = 3,
    ACTIONS(16178), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16176), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [491462] = 4,
    ACTIONS(16180), 1,
      anon_sym_RPAREN,
    STATE(13664), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [491478] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10639), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491496] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9935), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15925), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [491512] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(11276), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491528] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10614), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491546] = 5,
    ACTIONS(13914), 1,
      sym_keyword_noscan,
    ACTIONS(16182), 1,
      sym_keyword_for,
    ACTIONS(16184), 1,
      sym_keyword_cache,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15432), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [491564] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16186), 1,
      anon_sym_RBRACK,
    STATE(12314), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [491584] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11053), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491602] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(7045), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491618] = 4,
    ACTIONS(14718), 1,
      anon_sym_RPAREN,
    STATE(12315), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [491634] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11329), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491650] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10600), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491668] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10595), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491686] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7768), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491702] = 6,
    ACTIONS(12634), 1,
      sym_keyword_rename,
    ACTIONS(16188), 1,
      sym_keyword_set,
    ACTIONS(16190), 1,
      sym_keyword_alter,
    ACTIONS(16192), 1,
      sym_keyword_reset,
    STATE(10515), 1,
      sym_rename_object,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [491722] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7920), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491738] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10458), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491756] = 5,
    ACTIONS(4252), 1,
      aux_sym__single_quote_string_token1,
    STATE(3885), 1,
      sym__single_quote_string,
    STATE(4315), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4260), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491774] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10495), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491792] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10471), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491810] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10331), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491828] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13559), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491844] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10445), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491862] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13560), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491878] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9555), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16098), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [491894] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13563), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [491910] = 4,
    ACTIONS(16194), 1,
      sym_keyword_cascade,
    ACTIONS(16196), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15096), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [491926] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10431), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [491944] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10478), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16198), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [491960] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(8534), 1,
      sym_select,
    STATE(8816), 1,
      sym__select_statement,
    STATE(13534), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [491980] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10330), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15909), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [491996] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13491), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492012] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10224), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15837), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [492028] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10319), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492046] = 4,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(8836), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16200), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [492062] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10299), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492080] = 4,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(8177), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16200), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [492096] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10277), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492114] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10266), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492132] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7918), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492148] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7910), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492164] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9938), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15931), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [492180] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10227), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492198] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7906), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492214] = 4,
    ACTIONS(16202), 1,
      anon_sym_RPAREN,
    STATE(12444), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [492230] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16204), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492242] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(10310), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14462), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [492258] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11773), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492276] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16206), 1,
      anon_sym_RBRACK,
    STATE(12514), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [492296] = 4,
    ACTIONS(14932), 1,
      anon_sym_RPAREN,
    STATE(12516), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [492312] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7902), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492328] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7895), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492344] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10185), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492360] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8879), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492376] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7887), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492392] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15921), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [492408] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9546), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16104), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [492424] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15919), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [492440] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15919), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [492456] = 4,
    STATE(7519), 1,
      sym_cte,
    STATE(11481), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492472] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10282), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492490] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(11290), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492506] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7881), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492522] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10297), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492540] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14267), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492556] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7795), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492572] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(11291), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492588] = 4,
    ACTIONS(16210), 1,
      sym_keyword_inner,
    ACTIONS(16212), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16208), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [492604] = 4,
    ACTIONS(16216), 1,
      sym_keyword_inner,
    ACTIONS(16218), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16214), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [492620] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10311), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492638] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16220), 5,
      sym_keyword_desc,
      sym_keyword_asc,
      sym_keyword_nulls,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [492650] = 4,
    ACTIONS(16224), 1,
      sym_keyword_inner,
    ACTIONS(16226), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16222), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [492666] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10316), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492684] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9537), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16106), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [492700] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7865), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492716] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10328), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492734] = 5,
    ACTIONS(3812), 1,
      aux_sym__single_quote_string_token1,
    STATE(420), 1,
      sym__single_quote_string,
    STATE(6799), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3820), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492752] = 4,
    ACTIONS(16228), 1,
      anon_sym_RPAREN,
    STATE(13467), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492768] = 4,
    ACTIONS(16228), 1,
      anon_sym_RPAREN,
    STATE(10625), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492784] = 5,
    ACTIONS(13910), 1,
      sym_keyword_noscan,
    ACTIONS(16230), 1,
      sym_keyword_for,
    ACTIONS(16232), 1,
      sym_keyword_cache,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15567), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [492802] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9883), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15911), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [492818] = 5,
    ACTIONS(4054), 1,
      aux_sym__single_quote_string_token1,
    STATE(2355), 1,
      sym__single_quote_string,
    STATE(2435), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(4062), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492836] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(16234), 1,
      sym_keyword_all,
    STATE(11295), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [492854] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10395), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492872] = 4,
    ACTIONS(16238), 1,
      sym_keyword_force,
    ACTIONS(16240), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16236), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [492888] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10410), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492906] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10424), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492924] = 4,
    ACTIONS(16244), 1,
      sym_keyword_inner,
    ACTIONS(16246), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16242), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [492940] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10429), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492958] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10721), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [492974] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10441), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [492992] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10508), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493010] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9870), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15831), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [493026] = 3,
    ACTIONS(16250), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16248), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [493040] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10523), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493058] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10537), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493076] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10542), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493094] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10245), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493110] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10554), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493128] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(16252), 1,
      sym_keyword_all,
    STATE(10670), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [493146] = 4,
    ACTIONS(16254), 1,
      anon_sym_RPAREN,
    STATE(12644), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [493162] = 4,
    ACTIONS(15180), 1,
      sym_keyword_cascade,
    ACTIONS(15184), 1,
      sym_keyword_version,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [493178] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10228), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493194] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10621), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493212] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10636), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493230] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16256), 1,
      anon_sym_RBRACK,
    STATE(12720), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493250] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10650), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493268] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8391), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493284] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10703), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16258), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [493300] = 4,
    ACTIONS(14788), 1,
      anon_sym_RPAREN,
    STATE(12723), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [493316] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10655), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493334] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6679), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493352] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10280), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16116), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [493368] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10667), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493386] = 6,
    ACTIONS(12634), 1,
      sym_keyword_rename,
    ACTIONS(16260), 1,
      sym_keyword_set,
    ACTIONS(16262), 1,
      sym_keyword_alter,
    ACTIONS(16264), 1,
      sym_keyword_reset,
    STATE(10638), 1,
      sym_rename_object,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493406] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8382), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493422] = 4,
    STATE(6389), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493438] = 3,
    ACTIONS(16268), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16266), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [493452] = 3,
    ACTIONS(16272), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16270), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [493466] = 6,
    ACTIONS(16274), 1,
      sym_keyword_with,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7348), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493486] = 4,
    ACTIONS(16284), 1,
      sym_keyword_inner,
    ACTIONS(16286), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16282), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [493502] = 6,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    ACTIONS(16288), 1,
      sym_keyword_with,
    STATE(7347), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493522] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8361), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493538] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10747), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16290), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [493554] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7807), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493570] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9882), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16198), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [493586] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6712), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493604] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16292), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_create,
      anon_sym_RPAREN,
  [493616] = 3,
    ACTIONS(16294), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16296), 4,
      sym__dollar_quoted_string,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
  [493630] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10734), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493648] = 5,
    ACTIONS(3764), 1,
      aux_sym__single_quote_string_token1,
    STATE(5895), 1,
      sym__single_quote_string,
    STATE(5970), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3774), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493666] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(7126), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493684] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14322), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493700] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(16298), 1,
      sym_keyword_all,
    STATE(11324), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [493718] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10749), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493736] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10763), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493754] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10768), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493772] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10780), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493790] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10309), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16138), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [493806] = 4,
    ACTIONS(9092), 1,
      sym_keyword_limit,
    STATE(10326), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [493822] = 6,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(15973), 1,
      anon_sym_LPAREN,
    STATE(7739), 1,
      sym_select,
    STATE(8046), 1,
      sym__select_statement,
    STATE(8268), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493842] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(16300), 1,
      sym_keyword_column,
    STATE(10557), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [493860] = 4,
    STATE(6341), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493876] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14323), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493892] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10833), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493910] = 6,
    ACTIONS(12300), 1,
      anon_sym_LPAREN,
    ACTIONS(13875), 1,
      sym_keyword_select,
    STATE(7739), 1,
      sym_select,
    STATE(8040), 1,
      sym__select_statement,
    STATE(8251), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493930] = 3,
    ACTIONS(16304), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16302), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [493944] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10387), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [493960] = 6,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    ACTIONS(16306), 1,
      sym_keyword_all,
    STATE(7600), 1,
      sym__select_statement,
    STATE(7739), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [493980] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10848), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [493998] = 5,
    ACTIONS(16308), 1,
      sym_keyword_partition,
    ACTIONS(16310), 1,
      anon_sym_LPAREN,
    STATE(11307), 1,
      sym__partition_spec,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15148), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [494016] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10862), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494034] = 5,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(6920), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2967), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494052] = 3,
    ACTIONS(16314), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16312), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [494066] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10867), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494084] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10879), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494102] = 4,
    STATE(10543), 1,
      sym_set_configuration,
    STATE(10544), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494118] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10153), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494134] = 4,
    STATE(10386), 1,
      sym_identifier,
    STATE(11268), 1,
      sym_set_configuration,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494150] = 4,
    ACTIONS(16318), 1,
      sym_keyword_inner,
    ACTIONS(16320), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16316), 3,
      sym_keyword_left,
      sym_keyword_right,
      sym_keyword_full,
  [494166] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8357), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494182] = 4,
    STATE(11310), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15030), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16322), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [494198] = 6,
    ACTIONS(16324), 1,
      sym_keyword_constraint,
    ACTIONS(16326), 1,
      sym_keyword_temp,
    ACTIONS(16328), 1,
      sym_keyword_temporary,
    ACTIONS(16330), 1,
      sym_keyword_trigger,
    STATE(12101), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [494218] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10932), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494236] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16332), 5,
      sym_keyword_default,
      sym_keyword_plain,
      sym_keyword_extended,
      sym_keyword_main,
      sym_keyword_external,
  [494248] = 4,
    ACTIONS(16336), 1,
      sym_keyword_force,
    ACTIONS(16338), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16334), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [494264] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10947), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494282] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9799), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15881), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [494298] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(10529), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16340), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [494314] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10961), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494332] = 4,
    STATE(11312), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15006), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16342), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [494348] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9519), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16114), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [494364] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10966), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494382] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9779), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15875), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [494398] = 4,
    ACTIONS(16344), 1,
      anon_sym_RPAREN,
    STATE(12843), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [494414] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(10978), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494432] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(8213), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494448] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11510), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494464] = 5,
    ACTIONS(127), 1,
      sym__identifier,
    ACTIONS(16346), 1,
      sym_keyword_all,
    STATE(6883), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [494482] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15871), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [494498] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15871), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [494514] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10146), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16160), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [494530] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6663), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494548] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16348), 1,
      anon_sym_RBRACK,
    STATE(12936), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [494568] = 4,
    STATE(11314), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15020), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16350), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [494584] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10192), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16158), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [494600] = 4,
    ACTIONS(14792), 1,
      anon_sym_RPAREN,
    STATE(12937), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [494616] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12017), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494632] = 4,
    STATE(7725), 1,
      sym_cte,
    STATE(11481), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494648] = 4,
    STATE(11315), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15054), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16352), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [494664] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11624), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494680] = 4,
    STATE(11343), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15078), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16354), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [494696] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(16356), 1,
      sym_keyword_all,
    STATE(11318), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [494714] = 4,
    ACTIONS(16358), 1,
      anon_sym_RPAREN,
    STATE(10370), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494730] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10356), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494746] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11857), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494762] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14342), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494778] = 3,
    ACTIONS(16360), 1,
      sym_keyword_sequence,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15791), 4,
      sym_keyword_table,
      sym_keyword_view,
      sym_keyword_recursive,
      sym_keyword_trigger,
  [494792] = 4,
    STATE(6340), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494808] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8536), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494824] = 4,
    ACTIONS(16362), 1,
      anon_sym_STAR,
    STATE(4893), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(897), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494840] = 3,
    ACTIONS(16364), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16366), 4,
      sym__dollar_quoted_string,
      sym__double_quote_string,
      aux_sym__single_quote_string_token1,
      aux_sym_identifier_token1,
  [494854] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(7229), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [494870] = 3,
    ACTIONS(16370), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16368), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [494884] = 3,
    ACTIONS(16374), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16372), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [494898] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9579), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15869), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
  [494914] = 3,
    ACTIONS(15394), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15392), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [494928] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11031), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494946] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(11094), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16376), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [494962] = 5,
    ACTIONS(2809), 1,
      aux_sym__single_quote_string_token1,
    STATE(827), 1,
      sym__single_quote_string,
    STATE(879), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3492), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494980] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11046), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [494998] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11060), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495016] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11065), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495034] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11077), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495052] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(11494), 1,
      sym_keyword_default,
    STATE(11327), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [495070] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14653), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_cascade,
      sym_keyword_restrict,
      anon_sym_COMMA,
  [495082] = 5,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    STATE(87), 1,
      sym__single_quote_string,
    STATE(6693), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10826), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495100] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(3977), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495118] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10469), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495134] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7822), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495150] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(10585), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16378), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [495166] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10453), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495182] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11130), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495200] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11145), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495218] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(10774), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495234] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11159), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495252] = 6,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    ACTIONS(16380), 1,
      sym_keyword_with,
    STATE(7285), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [495272] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11164), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495290] = 6,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    ACTIONS(16382), 1,
      sym_keyword_by,
    STATE(7283), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [495310] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11176), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495328] = 3,
    ACTIONS(16386), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16384), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [495342] = 4,
    ACTIONS(15835), 1,
      sym_keyword_update,
    STATE(11072), 1,
      sym__create_trigger_event,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16388), 3,
      sym_keyword_delete,
      sym_keyword_insert,
      sym_keyword_truncate,
  [495358] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9442), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15851), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [495374] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12064), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495390] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16390), 5,
      sym_keyword_default,
      sym_keyword_plain,
      sym_keyword_extended,
      sym_keyword_main,
      sym_keyword_external,
  [495402] = 4,
    ACTIONS(16392), 1,
      anon_sym_RPAREN,
    STATE(10442), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495418] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15260), 5,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_on,
      sym_keyword_when,
      sym_keyword_returning,
  [495430] = 4,
    ACTIONS(16394), 1,
      anon_sym_RPAREN,
    STATE(11025), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495446] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(11313), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495462] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6657), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495480] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11214), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495498] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11207), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495516] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11194), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495534] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11192), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495552] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(16396), 1,
      sym_keyword_all,
    STATE(9715), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [495570] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11186), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495588] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9962), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495604] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14354), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495620] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9199), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495636] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7937), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495652] = 5,
    ACTIONS(16308), 1,
      sym_keyword_partition,
    ACTIONS(16398), 1,
      anon_sym_LPAREN,
    STATE(11331), 1,
      sym__partition_spec,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15044), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [495670] = 4,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(3367), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16400), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [495686] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11154), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495704] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11151), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495722] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11149), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495740] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(11514), 1,
      sym_keyword_default,
    STATE(10417), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [495758] = 4,
    ACTIONS(16402), 1,
      anon_sym_RPAREN,
    STATE(13067), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [495774] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11147), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495792] = 4,
    STATE(11338), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15026), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16404), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [495808] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11143), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [495826] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16406), 1,
      anon_sym_RBRACK,
    STATE(13165), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [495846] = 4,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(3367), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16408), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [495862] = 4,
    STATE(10544), 1,
      sym_identifier,
    STATE(10819), 1,
      sym_set_configuration,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495878] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8422), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495894] = 4,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    STATE(9085), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16410), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [495910] = 4,
    ACTIONS(14680), 1,
      anon_sym_RPAREN,
    STATE(13172), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [495926] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(9083), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495942] = 4,
    ACTIONS(14772), 1,
      sym_keyword_from,
    STATE(7614), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13427), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [495958] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12513), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495974] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12520), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [495990] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12524), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496006] = 4,
    STATE(11341), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14940), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16412), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [496022] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12525), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496038] = 3,
    ACTIONS(16416), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16414), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [496052] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9219), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496068] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12526), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496084] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11136), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496102] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6686), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496120] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6816), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496138] = 4,
    STATE(11342), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14966), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16418), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [496154] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(16420), 1,
      sym_keyword_all,
    STATE(10836), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [496172] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12417), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496188] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12563), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496204] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9233), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496220] = 4,
    STATE(11346), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14980), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16422), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [496236] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12575), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496252] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11111), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496270] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9238), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496286] = 4,
    STATE(11345), 1,
      sym__drop_behavior,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14990), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(16424), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [496302] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9240), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496318] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10114), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16378), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [496334] = 4,
    ACTIONS(16362), 1,
      anon_sym_STAR,
    STATE(4645), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(773), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496350] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12463), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496366] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12588), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496382] = 4,
    STATE(10960), 1,
      sym__key_value_pair,
    STATE(12566), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496398] = 4,
    ACTIONS(16426), 1,
      sym_keyword_as,
    ACTIONS(16428), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15426), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [496414] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(11500), 1,
      sym_keyword_default,
    STATE(11358), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [496432] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(11500), 1,
      sym_keyword_none,
    STATE(11358), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [496450] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9264), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496466] = 3,
    ACTIONS(16432), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16430), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [496480] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6756), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496498] = 5,
    ACTIONS(3676), 1,
      aux_sym__single_quote_string_token1,
    STATE(4367), 1,
      sym__single_quote_string,
    STATE(4410), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3684), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496516] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9809), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496532] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9299), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496548] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10997), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496564] = 6,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(16434), 1,
      sym_keyword_all,
    STATE(7573), 1,
      sym__select_statement,
    STATE(7657), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [496584] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(10767), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496600] = 6,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    ACTIONS(13851), 1,
      sym_keyword_select,
    STATE(7657), 1,
      sym_select,
    STATE(7924), 1,
      sym__select_statement,
    STATE(7988), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [496620] = 4,
    STATE(7262), 1,
      sym_identifier,
    STATE(9344), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496636] = 5,
    ACTIONS(337), 1,
      sym__identifier,
    ACTIONS(16436), 1,
      sym_keyword_none,
    STATE(11373), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [496654] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11596), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496670] = 5,
    ACTIONS(51), 1,
      sym__identifier,
    ACTIONS(16438), 1,
      sym_keyword_none,
    STATE(10850), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [496688] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12632), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496704] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14394), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496720] = 5,
    ACTIONS(2466), 1,
      aux_sym__single_quote_string_token1,
    STATE(820), 1,
      sym__single_quote_string,
    STATE(2703), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2474), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [496738] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16442), 2,
      sym_keyword_after,
      sym_keyword_before,
    ACTIONS(16440), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [496752] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6967), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496768] = 6,
    ACTIONS(13851), 1,
      sym_keyword_select,
    ACTIONS(16444), 1,
      anon_sym_LPAREN,
    STATE(7657), 1,
      sym_select,
    STATE(7876), 1,
      sym__select_statement,
    STATE(8029), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [496788] = 4,
    ACTIONS(16446), 1,
      anon_sym_RPAREN,
    STATE(10940), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496804] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13628), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496820] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10942), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496836] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10725), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496852] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11669), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496868] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14360), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496884] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12119), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496900] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14395), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496916] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6985), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496932] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16448), 5,
      sym_keyword_default,
      sym_keyword_plain,
      sym_keyword_extended,
      sym_keyword_main,
      sym_keyword_external,
  [496944] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(12762), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [496960] = 4,
    ACTIONS(16450), 1,
      anon_sym_RPAREN,
    STATE(13334), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [496976] = 4,
    ACTIONS(16454), 1,
      sym_keyword_cache,
    ACTIONS(16456), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16452), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [496992] = 4,
    ACTIONS(16458), 1,
      anon_sym_RPAREN,
    STATE(11051), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497008] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10863), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497024] = 5,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(313), 1,
      sym__single_quote_string,
    STATE(7240), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2967), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497042] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11049), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497058] = 6,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    ACTIONS(16460), 1,
      anon_sym_RBRACK,
    STATE(13373), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [497078] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(8174), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497094] = 4,
    ACTIONS(14752), 1,
      anon_sym_RPAREN,
    STATE(13375), 1,
      sym_window_frame,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13918), 3,
      sym_keyword_range,
      sym_keyword_rows,
      sym_keyword_groups,
  [497110] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(16023), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [497128] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10856), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497144] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11730), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497160] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(13506), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497176] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14390), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497192] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(9397), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16462), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [497208] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(8725), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497224] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(8724), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16462), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [497240] = 6,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(16444), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7550), 1,
      sym__select_statement,
    STATE(8029), 1,
      sym_set_operation,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [497260] = 4,
    ACTIONS(15781), 1,
      anon_sym_STAR,
    STATE(3451), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497276] = 4,
    ACTIONS(16466), 1,
      anon_sym_COMMA,
    STATE(9397), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16464), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [497292] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(6964), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497308] = 4,
    ACTIONS(15799), 1,
      anon_sym_COMMA,
    STATE(8722), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16469), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [497324] = 4,
    ACTIONS(16471), 1,
      anon_sym_COMMA,
    STATE(9420), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13310), 3,
      sym_keyword_from,
      sym_keyword_create,
      anon_sym_RPAREN,
  [497340] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14384), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497356] = 4,
    ACTIONS(16473), 1,
      anon_sym_RPAREN,
    STATE(10913), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497372] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(7272), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497390] = 5,
    ACTIONS(14504), 1,
      aux_sym__single_quote_string_token1,
    STATE(6593), 1,
      sym__single_quote_string,
    STATE(6747), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14506), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497408] = 4,
    ACTIONS(16475), 1,
      sym_keyword_from,
    STATE(14401), 1,
      sym_index_hint,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(8869), 3,
      sym_keyword_force,
      sym_keyword_ignore,
      sym_keyword_use,
  [497424] = 4,
    ACTIONS(9578), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16122), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(8681), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [497440] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7858), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497456] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10714), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497472] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(135), 1,
      sym__single_quote_string,
    STATE(11521), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2919), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497490] = 5,
    ACTIONS(3888), 1,
      aux_sym__single_quote_string_token1,
    STATE(982), 1,
      sym__single_quote_string,
    STATE(6386), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(3896), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497508] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11546), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497524] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14382), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497540] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7842), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497556] = 3,
    ACTIONS(16479), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16477), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [497570] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10792), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497586] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10788), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497602] = 4,
    ACTIONS(16481), 1,
      anon_sym_RPAREN,
    STATE(11178), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497618] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(11782), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497634] = 4,
    ACTIONS(16483), 1,
      anon_sym_COMMA,
    STATE(9419), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13328), 3,
      sym_keyword_from,
      sym_keyword_create,
      anon_sym_RPAREN,
  [497650] = 4,
    ACTIONS(16471), 1,
      anon_sym_COMMA,
    STATE(9419), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13007), 3,
      sym_keyword_from,
      sym_keyword_create,
      anon_sym_RPAREN,
  [497666] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(10758), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497682] = 4,
    STATE(6381), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497698] = 4,
    STATE(7735), 1,
      sym_identifier,
    STATE(7848), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497714] = 5,
    ACTIONS(13536), 1,
      sym_keyword_union,
    ACTIONS(16486), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_set_operation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13538), 2,
      sym_keyword_except,
      sym_keyword_intersect,
  [497732] = 4,
    STATE(6380), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497748] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6705), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497766] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6813), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497784] = 4,
    ACTIONS(16488), 1,
      anon_sym_RPAREN,
    STATE(10970), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497800] = 4,
    STATE(6414), 1,
      sym_identifier,
    STATE(14374), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497816] = 4,
    STATE(6379), 1,
      sym_object_reference,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497832] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9529), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15829), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [497848] = 4,
    STATE(1818), 1,
      sym_identifier,
    STATE(7699), 1,
      sym_object_reference,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497864] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(9486), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16124), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [497880] = 5,
    ACTIONS(14316), 1,
      aux_sym__single_quote_string_token1,
    STATE(6625), 1,
      sym__single_quote_string,
    STATE(6823), 1,
      sym__literal_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14320), 2,
      sym__dollar_quoted_string,
      sym__double_quote_string,
  [497898] = 3,
    STATE(8629), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497911] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11193), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_collate,
  [497922] = 4,
    ACTIONS(16490), 1,
      sym_keyword_set,
    ACTIONS(16494), 1,
      sym_keyword_no,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16492), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [497937] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9442), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15851), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [497952] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11189), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_collate,
  [497963] = 3,
    STATE(2464), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1095), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497976] = 3,
    STATE(12956), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [497989] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16496), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498000] = 3,
    STATE(8796), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498013] = 3,
    STATE(11078), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498026] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9983), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16498), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [498041] = 3,
    STATE(11080), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498054] = 3,
    STATE(6508), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498067] = 3,
    STATE(6550), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498080] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(11020), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16502), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [498095] = 3,
    STATE(5742), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498108] = 4,
    ACTIONS(16508), 1,
      sym_keyword_returning,
    STATE(11167), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16506), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [498123] = 5,
    ACTIONS(16510), 1,
      anon_sym_RPAREN,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    STATE(10392), 1,
      aux_sym_column_definitions_repeat1,
    STATE(12574), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498140] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16514), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498151] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16516), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [498162] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16518), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [498173] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9529), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15829), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498188] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10981), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16520), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [498203] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16522), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498214] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9039), 1,
      sym_keyword_else,
    ACTIONS(9041), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498231] = 3,
    STATE(5538), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498244] = 3,
    STATE(3527), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1349), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498257] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9579), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15869), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498272] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10103), 1,
      sym_keyword_end,
    ACTIONS(16524), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498289] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(11048), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16526), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [498304] = 3,
    ACTIONS(16530), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16528), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [498317] = 3,
    STATE(2774), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498330] = 3,
    STATE(7315), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498343] = 3,
    ACTIONS(16534), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16532), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [498356] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16536), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498367] = 3,
    STATE(4727), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(575), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498380] = 3,
    STATE(12722), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498393] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10069), 1,
      sym_keyword_end,
    ACTIONS(16538), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498410] = 3,
    STATE(4725), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(575), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498423] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9136), 1,
      sym_keyword_else,
    ACTIONS(9138), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498440] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9150), 1,
      sym_keyword_else,
    ACTIONS(9152), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498457] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10359), 1,
      sym_keyword_end,
    ACTIONS(16540), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498474] = 3,
    STATE(2774), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498487] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16542), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498498] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16544), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498509] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(16122), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [498524] = 3,
    STATE(2266), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(759), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498537] = 3,
    STATE(2231), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(759), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498550] = 3,
    ACTIONS(16548), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16546), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [498563] = 3,
    STATE(4198), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(773), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498576] = 3,
    STATE(2689), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(515), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15777), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498600] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16550), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498611] = 3,
    STATE(2599), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(515), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498624] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16552), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498635] = 3,
    STATE(6366), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498648] = 3,
    STATE(4436), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(635), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498661] = 5,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7571), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498678] = 3,
    STATE(898), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(963), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498691] = 3,
    STATE(4395), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(635), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498704] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11207), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_collate,
  [498715] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10572), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [498726] = 3,
    STATE(4453), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(695), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498739] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16554), 2,
      sym_keyword_begin,
      sym__identifier,
    ACTIONS(16556), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [498752] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16558), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(10078), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498769] = 3,
    STATE(4550), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(695), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498782] = 3,
    STATE(898), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498795] = 3,
    STATE(6759), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498808] = 3,
    STATE(2774), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498821] = 3,
    STATE(5741), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(897), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498834] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16560), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498845] = 5,
    ACTIONS(16562), 1,
      anon_sym_RPAREN,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(16566), 1,
      anon_sym_EQ,
    STATE(10500), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [498862] = 3,
    STATE(4039), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(635), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498875] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9779), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15875), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498890] = 3,
    ACTIONS(16568), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13589), 3,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [498903] = 3,
    ACTIONS(16572), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16570), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [498916] = 3,
    STATE(5152), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498929] = 3,
    STATE(4404), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(575), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498942] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16124), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [498953] = 3,
    STATE(898), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(759), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498966] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9553), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16574), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [498981] = 3,
    STATE(2517), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(515), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [498994] = 3,
    STATE(2670), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1095), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499007] = 3,
    STATE(4192), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(695), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499020] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15795), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499031] = 3,
    STATE(6656), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499044] = 3,
    STATE(7549), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499057] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10510), 1,
      sym_keyword_end,
    ACTIONS(16576), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [499074] = 3,
    STATE(11225), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499087] = 3,
    STATE(14049), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499100] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9799), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15881), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [499115] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10225), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16578), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [499130] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9345), 1,
      sym_keyword_else,
    ACTIONS(9347), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [499147] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10764), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16580), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [499162] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16582), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [499173] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9478), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16584), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [499188] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16586), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [499199] = 3,
    STATE(7866), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499212] = 3,
    STATE(6957), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499225] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16588), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499236] = 3,
    STATE(8181), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499249] = 3,
    STATE(181), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499262] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15805), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499273] = 3,
    ACTIONS(15811), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15807), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [499286] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10472), 1,
      sym_keyword_end,
    ACTIONS(16590), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [499303] = 4,
    ACTIONS(16592), 1,
      sym_keyword_when,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16595), 2,
      sym_keyword_else,
      sym_keyword_end,
  [499318] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16597), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [499329] = 3,
    STATE(7292), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499342] = 3,
    STATE(6550), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499355] = 3,
    STATE(3431), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(215), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499368] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16599), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499379] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15817), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499390] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16601), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_compute,
      anon_sym_RPAREN,
  [499401] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9870), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15831), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499416] = 3,
    STATE(8559), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499429] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(16605), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [499442] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9883), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15911), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499457] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10948), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16607), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [499472] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16609), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499483] = 3,
    STATE(13924), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499496] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15821), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499507] = 3,
    STATE(8562), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499520] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(10014), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16611), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [499535] = 3,
    STATE(10993), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499548] = 3,
    STATE(7381), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499561] = 3,
    STATE(4813), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(897), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499574] = 3,
    ACTIONS(16615), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16613), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [499587] = 4,
    ACTIONS(16619), 1,
      sym_keyword_returning,
    STATE(11376), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16617), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [499602] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16621), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [499613] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16623), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [499624] = 3,
    STATE(8797), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499637] = 3,
    STATE(4893), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(897), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499650] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16625), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499661] = 3,
    STATE(10824), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499674] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16627), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499685] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16629), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [499696] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16631), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499707] = 3,
    STATE(8933), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499720] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16633), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499731] = 3,
    ACTIONS(16635), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16477), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [499744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16637), 2,
      sym_keyword_begin,
      sym__identifier,
    ACTIONS(16639), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [499757] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16641), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499768] = 3,
    STATE(7384), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499781] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16643), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499792] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16645), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499803] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9935), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15925), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [499818] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16647), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499829] = 3,
    STATE(12781), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499842] = 3,
    STATE(2293), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(957), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499855] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9938), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15931), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [499870] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16649), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [499881] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16651), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [499892] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16464), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [499903] = 4,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(11962), 1,
      sym_order_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16653), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [499918] = 3,
    STATE(2670), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499931] = 3,
    STATE(13754), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499944] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16655), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499955] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16657), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [499966] = 3,
    STATE(7304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [499979] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16659), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [499990] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10516), 1,
      sym_keyword_end,
    ACTIONS(16661), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16663), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500018] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16665), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500029] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16667), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500040] = 3,
    STATE(12143), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500053] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16669), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500064] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16671), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500075] = 4,
    ACTIONS(15752), 1,
      anon_sym_RPAREN,
    ACTIONS(16673), 1,
      sym_keyword_when,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [500090] = 5,
    ACTIONS(7), 1,
      sym_keyword_select,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    STATE(7475), 1,
      sym_select,
    STATE(7573), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500107] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15750), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [500122] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9365), 1,
      sym_keyword_else,
    ACTIONS(9367), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500139] = 3,
    STATE(2594), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500152] = 3,
    ACTIONS(16676), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16384), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [500165] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16678), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500176] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16680), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16312), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500198] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14462), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [500209] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16682), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500220] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15748), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [500235] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15748), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [500250] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16684), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500261] = 3,
    STATE(7312), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500274] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15969), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500285] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10085), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15947), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500300] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16686), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500311] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16688), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500322] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(16690), 1,
      anon_sym_RPAREN,
    STATE(9667), 1,
      aux_sym_column_definitions_repeat1,
    STATE(13341), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500339] = 3,
    STATE(10181), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500352] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16692), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500363] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16694), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(9496), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500380] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16696), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500391] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10093), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15949), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500406] = 5,
    ACTIONS(16698), 1,
      anon_sym_PLUS,
    ACTIONS(16700), 1,
      anon_sym_DASH,
    ACTIONS(16702), 1,
      aux_sym__integer_token1,
    STATE(7242), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500423] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10094), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15961), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500438] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16704), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500449] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9711), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500460] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10115), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15963), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500475] = 3,
    ACTIONS(16456), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16452), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [500488] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16706), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500499] = 3,
    STATE(7261), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500512] = 3,
    STATE(7385), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500525] = 3,
    STATE(11638), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500538] = 3,
    ACTIONS(16710), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16708), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [500551] = 3,
    STATE(10354), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500564] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16712), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500575] = 3,
    STATE(10530), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500588] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10886), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16714), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [500603] = 3,
    STATE(6895), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500616] = 3,
    STATE(14113), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500629] = 5,
    ACTIONS(16716), 1,
      sym_keyword_temp,
    ACTIONS(16718), 1,
      sym_keyword_temporary,
    ACTIONS(16720), 1,
      sym_keyword_trigger,
    STATE(14588), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500646] = 3,
    STATE(7714), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500659] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16722), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500670] = 5,
    ACTIONS(15887), 1,
      sym_keyword_temp,
    ACTIONS(15889), 1,
      sym_keyword_temporary,
    ACTIONS(15891), 1,
      sym_keyword_trigger,
    STATE(14586), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500687] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16724), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500698] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9719), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500709] = 3,
    STATE(13571), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500722] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16726), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500733] = 3,
    STATE(4813), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(963), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500746] = 3,
    STATE(8772), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500759] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15837), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500770] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16728), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500781] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16730), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500792] = 5,
    ACTIONS(16732), 1,
      sym_keyword_temp,
    ACTIONS(16734), 1,
      sym_keyword_temporary,
    ACTIONS(16736), 1,
      sym_keyword_trigger,
    STATE(14582), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500809] = 3,
    ACTIONS(16738), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16302), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [500822] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16740), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500833] = 3,
    STATE(7325), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500846] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10157), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15989), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [500861] = 3,
    STATE(12702), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500874] = 3,
    STATE(12458), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500887] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16742), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500898] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16744), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [500909] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16746), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [500920] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(16748), 1,
      anon_sym_RPAREN,
    STATE(10392), 1,
      aux_sym_column_definitions_repeat1,
    STATE(13322), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [500937] = 3,
    STATE(4645), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(773), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500950] = 3,
    ACTIONS(16750), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16248), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [500963] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16752), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_compute,
      anon_sym_RPAREN,
  [500974] = 3,
    STATE(13678), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [500987] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9436), 1,
      sym_keyword_else,
    ACTIONS(9438), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501004] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16754), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501015] = 3,
    STATE(11641), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501028] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16756), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501039] = 3,
    STATE(8889), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501052] = 3,
    STATE(13674), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501065] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16758), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501076] = 3,
    STATE(5725), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501089] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16760), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501100] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16762), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501111] = 3,
    STATE(9906), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501124] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16764), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501135] = 3,
    STATE(14122), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501148] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(13851), 1,
      sym_keyword_select,
    STATE(7571), 1,
      sym__select_statement,
    STATE(7657), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501165] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10172), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15993), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [501180] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16766), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501191] = 5,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7600), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501208] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [501223] = 4,
    ACTIONS(16619), 1,
      sym_keyword_returning,
    STATE(11365), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16506), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [501238] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16768), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501249] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16770), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501260] = 3,
    STATE(12463), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501273] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16772), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501284] = 3,
    STATE(8628), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501297] = 4,
    ACTIONS(16619), 1,
      sym_keyword_returning,
    STATE(11375), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16774), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [501312] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [501327] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10460), 1,
      sym_keyword_end,
    ACTIONS(16776), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501344] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10506), 1,
      sym_keyword_end,
    ACTIONS(16778), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501361] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [501376] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16780), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501387] = 3,
    STATE(13652), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501400] = 3,
    STATE(7334), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501413] = 5,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    STATE(9673), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501430] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16782), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501441] = 3,
    STATE(14132), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501454] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16694), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(10078), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501471] = 3,
    STATE(10572), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501484] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9355), 1,
      sym_keyword_else,
    ACTIONS(9357), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501501] = 5,
    ACTIONS(13650), 1,
      sym_keyword_trigger,
    ACTIONS(16784), 1,
      sym_keyword_temp,
    ACTIONS(16786), 1,
      sym_keyword_temporary,
    STATE(14579), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501518] = 3,
    STATE(7685), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501531] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11229), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16788), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [501546] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16790), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501557] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(13851), 1,
      sym_keyword_select,
    STATE(7573), 1,
      sym__select_statement,
    STATE(7657), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501574] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(9803), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16792), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [501589] = 3,
    ACTIONS(16794), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16176), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [501602] = 3,
    STATE(11568), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501615] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(9821), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16796), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [501630] = 3,
    ACTIONS(16798), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16170), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [501643] = 5,
    ACTIONS(13638), 1,
      sym_keyword_view,
    ACTIONS(13648), 1,
      sym_keyword_recursive,
    ACTIONS(13650), 1,
      sym_keyword_trigger,
    ACTIONS(16800), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501660] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16477), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501671] = 3,
    STATE(7350), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501684] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16802), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501695] = 3,
    STATE(9570), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501708] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16804), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501719] = 3,
    STATE(4356), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501732] = 3,
    STATE(6957), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501745] = 3,
    STATE(502), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(275), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501758] = 3,
    STATE(6366), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501771] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16164), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_references,
      anon_sym_COMMA,
  [501782] = 3,
    STATE(181), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501795] = 3,
    ACTIONS(16806), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16613), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [501808] = 3,
    STATE(7599), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501821] = 3,
    STATE(4365), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(773), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501834] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [501849] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16808), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501860] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16694), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(9873), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [501877] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16810), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501888] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14740), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501899] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15096), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [501910] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16812), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501921] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14736), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501932] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [501947] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16814), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [501958] = 3,
    STATE(10682), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501971] = 3,
    STATE(9874), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [501984] = 3,
    ACTIONS(16816), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16017), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [501997] = 3,
    STATE(8132), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502010] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16818), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [502021] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16820), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502032] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16822), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [502043] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [502058] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10111), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15861), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502073] = 3,
    STATE(11378), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502086] = 3,
    STATE(4893), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(963), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502099] = 5,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    STATE(9620), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502116] = 3,
    STATE(3451), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502129] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16378), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502140] = 3,
    STATE(8526), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502153] = 4,
    ACTIONS(16826), 1,
      anon_sym_COMMA,
    STATE(9981), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16824), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [502168] = 3,
    STATE(14137), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502181] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [502196] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10079), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15821), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502211] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10072), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15817), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502226] = 4,
    ACTIONS(9526), 1,
      sym_keyword_when,
    ACTIONS(15871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(9602), 2,
      sym_when_clause,
      aux_sym__merge_statement_repeat1,
  [502241] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10063), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15805), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502256] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10051), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15795), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502271] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16828), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502282] = 3,
    ACTIONS(16830), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13589), 3,
      sym_keyword_union,
      sym_keyword_except,
      sym_keyword_intersect,
  [502295] = 3,
    STATE(3502), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502308] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16832), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [502319] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10789), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16834), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [502334] = 3,
    STATE(8421), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502347] = 5,
    ACTIONS(1470), 1,
      sym_keyword_select,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    STATE(7513), 1,
      sym_select,
    STATE(7634), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502364] = 3,
    STATE(729), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(335), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16414), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502388] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16836), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [502399] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9859), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15777), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502414] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16838), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502425] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16840), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502436] = 3,
    STATE(9878), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502449] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(16842), 1,
      anon_sym_RPAREN,
    STATE(9820), 1,
      aux_sym_column_definitions_repeat1,
    STATE(13077), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502466] = 3,
    ACTIONS(16844), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16046), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [502479] = 3,
    STATE(9941), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502492] = 4,
    ACTIONS(16846), 1,
      sym_keyword_force,
    ACTIONS(16848), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16334), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [502507] = 3,
    STATE(9210), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502520] = 3,
    STATE(8364), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502533] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16850), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502544] = 3,
    STATE(4356), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(215), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502557] = 3,
    ACTIONS(16854), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16852), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [502570] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10508), 1,
      sym_keyword_end,
    ACTIONS(16856), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502587] = 3,
    STATE(13400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502600] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16858), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [502611] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11258), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16860), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [502626] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11234), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16862), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [502641] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9610), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16864), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [502656] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10248), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16866), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [502671] = 3,
    STATE(6744), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1285), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502684] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16868), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502695] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9309), 1,
      sym_keyword_else,
    ACTIONS(9311), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502712] = 3,
    STATE(6760), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502725] = 4,
    ACTIONS(16870), 1,
      sym_keyword_set,
    ACTIONS(16874), 1,
      sym_keyword_no,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16872), 2,
      sym_keyword_cascade,
      sym_keyword_restrict,
  [502740] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16876), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [502755] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15979), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [502766] = 3,
    STATE(6990), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502779] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11235), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16866), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [502794] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10098), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15991), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [502809] = 3,
    ACTIONS(16882), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16880), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [502822] = 4,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(9959), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16410), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [502837] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16694), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(9596), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502854] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10295), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16862), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [502869] = 3,
    STATE(6766), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502882] = 3,
    STATE(11189), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502895] = 3,
    STATE(12008), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502908] = 3,
    STATE(10831), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502921] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10114), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16378), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [502936] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10298), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16860), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [502951] = 4,
    ACTIONS(16884), 1,
      sym_keyword_default,
    ACTIONS(16888), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16886), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [502966] = 3,
    STATE(6873), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [502979] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(16890), 1,
      anon_sym_RPAREN,
    STATE(10392), 1,
      aux_sym_column_definitions_repeat1,
    STATE(13044), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [502996] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16892), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [503011] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9281), 1,
      sym_keyword_else,
    ACTIONS(9283), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503028] = 3,
    ACTIONS(16894), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16708), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [503041] = 3,
    ACTIONS(16898), 1,
      sym_keyword_force,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16896), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [503054] = 3,
    STATE(7010), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503067] = 4,
    ACTIONS(16900), 1,
      sym_keyword_default,
    ACTIONS(16902), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16886), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503082] = 3,
    STATE(14148), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503095] = 3,
    ACTIONS(16904), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15937), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [503108] = 3,
    ACTIONS(16906), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15933), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [503121] = 3,
    STATE(4104), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1349), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503134] = 3,
    STATE(11088), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503147] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15929), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_references,
      anon_sym_COMMA,
  [503158] = 5,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    ACTIONS(16908), 1,
      sym_keyword_select,
    STATE(9316), 1,
      sym_select,
    STATE(10686), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503175] = 3,
    STATE(7386), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503188] = 3,
    STATE(7524), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503201] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9555), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16098), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503216] = 3,
    ACTIONS(16912), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16910), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [503229] = 3,
    STATE(4343), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1349), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503242] = 5,
    ACTIONS(16914), 1,
      sym_keyword_temp,
    ACTIONS(16916), 1,
      sym_keyword_temporary,
    ACTIONS(16918), 1,
      sym_keyword_trigger,
    STATE(13074), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16920), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [503270] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16922), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503281] = 5,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7287), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503298] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9546), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16104), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503313] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10244), 1,
      sym_keyword_end,
    ACTIONS(16924), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503330] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9537), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16106), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503345] = 4,
    ACTIONS(16826), 1,
      anon_sym_COMMA,
    STATE(9981), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16926), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [503360] = 4,
    ACTIONS(16826), 1,
      anon_sym_COMMA,
    STATE(9760), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16926), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [503375] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16928), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503386] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9519), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16114), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503401] = 3,
    ACTIONS(16930), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15969), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [503414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16932), 2,
      sym_keyword_begin,
      sym__identifier,
    ACTIONS(16934), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [503427] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16936), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503438] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10634), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16938), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [503453] = 4,
    ACTIONS(16508), 1,
      sym_keyword_returning,
    STATE(11158), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16774), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [503468] = 3,
    ACTIONS(16940), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15865), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [503481] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16942), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503492] = 3,
    STATE(6760), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503505] = 5,
    ACTIONS(16944), 1,
      sym_keyword_range,
    ACTIONS(16946), 1,
      sym_keyword_enum,
    ACTIONS(16948), 1,
      anon_sym_LPAREN,
    STATE(8966), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503522] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15993), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [503533] = 3,
    STATE(6696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503546] = 4,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(3876), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16400), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [503561] = 3,
    STATE(11326), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503574] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14825), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503585] = 4,
    ACTIONS(16950), 1,
      aux_sym_keyword_character_token1,
    STATE(13746), 1,
      sym_keyword_character,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11516), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503600] = 3,
    STATE(9741), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503613] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(16952), 1,
      sym__double_quote_string,
    ACTIONS(16954), 1,
      sym__dollar_quoted_string_start_tag,
    STATE(6896), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503630] = 3,
    STATE(6810), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14318), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503643] = 3,
    STATE(2464), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503656] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9721), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16956), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [503671] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15869), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503682] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16958), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503693] = 4,
    ACTIONS(16960), 1,
      sym_keyword_default,
    ACTIONS(16964), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16962), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [503708] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16966), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503719] = 3,
    ACTIONS(16968), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16368), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [503732] = 3,
    STATE(502), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1023), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503745] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16368), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503756] = 3,
    STATE(10516), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503769] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(10043), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16970), 2,
      sym_keyword_on,
      sym_keyword_or,
  [503784] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16972), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503795] = 3,
    STATE(11067), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503808] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15392), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503819] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16114), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503830] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16974), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [503841] = 3,
    STATE(9150), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503854] = 3,
    STATE(9876), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503867] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9486), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16124), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [503882] = 3,
    STATE(11075), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503895] = 3,
    STATE(10033), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503908] = 3,
    STATE(10474), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503921] = 5,
    ACTIONS(13740), 1,
      sym_keyword_trigger,
    ACTIONS(16976), 1,
      sym_keyword_temp,
    ACTIONS(16978), 1,
      sym_keyword_temporary,
    STATE(13811), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [503938] = 3,
    STATE(11220), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503951] = 3,
    STATE(11098), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503964] = 3,
    STATE(9252), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [503977] = 4,
    ACTIONS(16982), 1,
      anon_sym_COMMA,
    STATE(10089), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16980), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [503992] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10476), 1,
      sym_keyword_end,
    ACTIONS(16984), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504009] = 4,
    ACTIONS(16508), 1,
      sym_keyword_returning,
    STATE(11201), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16617), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [504024] = 3,
    STATE(4077), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(275), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504037] = 3,
    STATE(7606), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504050] = 3,
    STATE(11211), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504063] = 3,
    STATE(11206), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504076] = 3,
    STATE(10480), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504089] = 3,
    STATE(11183), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504102] = 3,
    STATE(11182), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504115] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16986), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [504126] = 3,
    STATE(11144), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504139] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16988), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [504150] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16158), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [504161] = 3,
    STATE(11131), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504174] = 3,
    STATE(12042), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504187] = 3,
    STATE(3937), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(275), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504200] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14714), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504211] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9277), 1,
      sym_keyword_else,
    ACTIONS(9279), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504228] = 5,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7497), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504245] = 3,
    STATE(36), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504258] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10160), 1,
      sym_keyword_end,
    ACTIONS(16990), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504275] = 5,
    ACTIONS(13728), 1,
      sym_keyword_view,
    ACTIONS(13738), 1,
      sym_keyword_recursive,
    ACTIONS(13740), 1,
      sym_keyword_trigger,
    ACTIONS(16992), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504292] = 5,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(16994), 1,
      sym_keyword_if,
    STATE(8969), 1,
      sym__single_quote_string,
    STATE(12012), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504309] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16996), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(16998), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [504322] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16384), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [504333] = 3,
    STATE(12014), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504346] = 4,
    ACTIONS(16826), 1,
      anon_sym_COMMA,
    STATE(9846), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17000), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [504361] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17002), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [504372] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14360), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [504383] = 3,
    STATE(8337), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504396] = 3,
    STATE(8288), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504409] = 5,
    ACTIONS(17004), 1,
      sym_keyword_range,
    ACTIONS(17006), 1,
      sym_keyword_enum,
    ACTIONS(17008), 1,
      anon_sym_LPAREN,
    STATE(10025), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504426] = 3,
    STATE(10551), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504439] = 3,
    ACTIONS(17010), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16312), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [504452] = 5,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7323), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504469] = 5,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7324), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504486] = 3,
    STATE(8367), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504499] = 3,
    STATE(10575), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504512] = 3,
    STATE(7396), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504525] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14885), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504536] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15875), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [504547] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17012), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [504558] = 3,
    STATE(8368), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504571] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17014), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [504582] = 3,
    STATE(9133), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504595] = 3,
    STATE(9990), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504608] = 4,
    ACTIONS(17016), 1,
      sym_keyword_force,
    ACTIONS(17018), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16236), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504623] = 3,
    ACTIONS(17020), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16546), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [504636] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17022), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504647] = 4,
    ACTIONS(16826), 1,
      anon_sym_COMMA,
    STATE(9981), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17000), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [504662] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11248), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16580), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504677] = 3,
    STATE(8948), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504690] = 3,
    STATE(2407), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(957), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504703] = 3,
    STATE(9976), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504716] = 3,
    STATE(10230), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504729] = 3,
    STATE(8284), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504742] = 3,
    STATE(8400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504755] = 3,
    STATE(12281), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504768] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10098), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15797), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504783] = 3,
    STATE(6937), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504796] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17024), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504807] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9222), 1,
      sym_keyword_else,
    ACTIONS(9224), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504824] = 5,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    STATE(7600), 1,
      sym__select_statement,
    STATE(7739), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [504841] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10098), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15801), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504856] = 4,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16200), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504871] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(9807), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15803), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504886] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17026), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504897] = 4,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(10155), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16200), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504912] = 3,
    STATE(2421), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(957), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504925] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16364), 2,
      sym_keyword_only,
      sym__identifier,
    ACTIONS(16366), 2,
      sym__double_quote_string,
      aux_sym_identifier_token1,
  [504938] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17028), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504949] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17028), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [504960] = 3,
    STATE(7309), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1159), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [504973] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11247), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16578), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [504988] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10192), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16158), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505003] = 3,
    STATE(9723), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505016] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17030), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [505027] = 3,
    STATE(4006), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505040] = 3,
    ACTIONS(17034), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17032), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [505053] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10504), 1,
      sym_keyword_end,
    ACTIONS(17036), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505070] = 5,
    ACTIONS(13728), 1,
      sym_keyword_view,
    ACTIONS(13738), 1,
      sym_keyword_recursive,
    ACTIONS(13740), 1,
      sym_keyword_trigger,
    ACTIONS(17038), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505087] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17040), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [505098] = 3,
    ACTIONS(17044), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17042), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [505111] = 4,
    ACTIONS(17046), 1,
      sym_keyword_cache,
    ACTIONS(17048), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15807), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [505126] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10146), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16160), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505141] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17050), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [505152] = 4,
    ACTIONS(17052), 1,
      anon_sym_COMMA,
    STATE(9981), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17050), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [505167] = 3,
    STATE(9871), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505180] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16046), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505191] = 4,
    ACTIONS(16826), 1,
      anon_sym_COMMA,
    STATE(9944), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16980), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [505206] = 3,
    STATE(8034), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505219] = 4,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(3876), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16136), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [505234] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9882), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16198), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505249] = 3,
    STATE(7554), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505262] = 5,
    ACTIONS(13875), 1,
      sym_keyword_select,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    STATE(7634), 1,
      sym__select_statement,
    STATE(7739), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505279] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17055), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [505290] = 5,
    ACTIONS(15759), 1,
      anon_sym_PLUS,
    ACTIONS(15761), 1,
      anon_sym_DASH,
    ACTIONS(15763), 1,
      aux_sym__integer_token1,
    STATE(7129), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505307] = 3,
    STATE(3170), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505320] = 3,
    STATE(10837), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505333] = 3,
    STATE(7729), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505346] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(10137), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17057), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [505361] = 3,
    STATE(7533), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505374] = 3,
    STATE(8883), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505387] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10452), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17059), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [505402] = 3,
    STATE(10839), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505415] = 5,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7506), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505432] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16198), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505443] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17061), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505454] = 3,
    STATE(2068), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505467] = 3,
    STATE(8884), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505480] = 3,
    STATE(7374), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505493] = 5,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    ACTIONS(16908), 1,
      sym_keyword_select,
    STATE(9316), 1,
      sym_select,
    STATE(10451), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505510] = 3,
    STATE(7621), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14336), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505523] = 3,
    STATE(10692), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505536] = 3,
    STATE(9848), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505549] = 3,
    STATE(10576), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505562] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10202), 1,
      sym_keyword_end,
    ACTIONS(17063), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505579] = 3,
    ACTIONS(17065), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15839), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [505592] = 3,
    ACTIONS(17067), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15843), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [505605] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16266), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505616] = 5,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7353), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505633] = 3,
    ACTIONS(17069), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16126), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [505646] = 3,
    STATE(11880), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505659] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9202), 1,
      sym_keyword_else,
    ACTIONS(9204), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505676] = 3,
    STATE(3451), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1221), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505689] = 3,
    STATE(2594), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1095), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505702] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17071), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [505713] = 5,
    ACTIONS(16064), 1,
      sym_keyword_temp,
    ACTIONS(16066), 1,
      sym_keyword_temporary,
    ACTIONS(16068), 1,
      sym_keyword_trigger,
    STATE(12809), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505730] = 4,
    ACTIONS(17073), 1,
      sym_keyword_default,
    ACTIONS(17077), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17075), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [505745] = 3,
    STATE(8249), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505758] = 3,
    ACTIONS(17079), 1,
      sym_keyword_collate,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16094), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [505771] = 3,
    STATE(10924), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505784] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9776), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17081), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [505799] = 3,
    STATE(8402), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505812] = 3,
    STATE(11633), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505825] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10098), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16462), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [505840] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505851] = 3,
    STATE(3502), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1221), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505864] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17083), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505875] = 3,
    STATE(10305), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505888] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17085), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [505899] = 3,
    STATE(9736), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505912] = 5,
    ACTIONS(16698), 1,
      anon_sym_PLUS,
    ACTIONS(16700), 1,
      anon_sym_DASH,
    ACTIONS(16702), 1,
      aux_sym__integer_token1,
    STATE(10709), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [505929] = 3,
    STATE(9211), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505942] = 3,
    ACTIONS(17087), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15979), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [505955] = 3,
    ACTIONS(17089), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16084), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [505968] = 3,
    ACTIONS(17091), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16090), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [505981] = 3,
    STATE(10462), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [505994] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17093), 2,
      sym_keyword_on,
      sym_keyword_or,
  [506009] = 3,
    STATE(8314), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506022] = 3,
    ACTIONS(17097), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17095), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [506035] = 3,
    STATE(9075), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506048] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16094), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506059] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17099), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506070] = 3,
    STATE(8433), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506083] = 3,
    STATE(6098), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506096] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15949), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506107] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(17101), 1,
      anon_sym_RPAREN,
    STATE(10204), 1,
      aux_sym_column_definitions_repeat1,
    STATE(13689), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506124] = 3,
    STATE(8079), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506137] = 3,
    ACTIONS(17103), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16070), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [506150] = 3,
    STATE(12206), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506163] = 3,
    ACTIONS(15180), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [506176] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15744), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_create,
  [506187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16084), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506198] = 3,
    STATE(12210), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506211] = 3,
    STATE(6000), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(455), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506224] = 3,
    STATE(10900), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506237] = 3,
    STATE(12211), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506250] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15963), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506261] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9487), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16138), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [506276] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9291), 1,
      sym_keyword_else,
    ACTIONS(9293), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506293] = 3,
    ACTIONS(17107), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17105), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [506306] = 5,
    ACTIONS(17109), 1,
      sym_keyword_temp,
    ACTIONS(17111), 1,
      sym_keyword_temporary,
    ACTIONS(17113), 1,
      sym_keyword_trigger,
    STATE(12897), 1,
      sym__temporary,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506323] = 3,
    STATE(7006), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(833), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506336] = 3,
    ACTIONS(17115), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16414), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [506349] = 5,
    ACTIONS(17117), 1,
      anon_sym_PLUS,
    ACTIONS(17119), 1,
      anon_sym_DASH,
    ACTIONS(17121), 1,
      aux_sym__integer_token1,
    STATE(7242), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506366] = 4,
    ACTIONS(16982), 1,
      anon_sym_COMMA,
    STATE(10211), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17000), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [506381] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15961), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506392] = 3,
    STATE(10258), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506405] = 3,
    STATE(3170), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1221), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506418] = 5,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7339), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506435] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16558), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(9873), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506452] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9025), 1,
      sym_keyword_else,
    ACTIONS(9027), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506469] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10602), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506480] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17123), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506491] = 5,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    ACTIONS(16908), 1,
      sym_keyword_select,
    STATE(9316), 1,
      sym_select,
    STATE(10304), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506508] = 3,
    ACTIONS(17125), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16570), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [506521] = 3,
    STATE(8220), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506534] = 3,
    STATE(10237), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506547] = 5,
    ACTIONS(16276), 1,
      anon_sym_PLUS,
    ACTIONS(16278), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      aux_sym__integer_token1,
    STATE(7336), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506564] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15831), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506575] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10438), 1,
      sym_keyword_end,
    ACTIONS(17127), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506592] = 3,
    ACTIONS(17131), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17129), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [506605] = 5,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7463), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506622] = 4,
    ACTIONS(16982), 1,
      anon_sym_COMMA,
    STATE(10219), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17000), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [506637] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16558), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(9496), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506654] = 3,
    STATE(9506), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506667] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(9953), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16469), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [506682] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17133), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506693] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17135), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506704] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10335), 1,
      sym_keyword_end,
    ACTIONS(17137), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506721] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10644), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506732] = 3,
    STATE(12380), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506745] = 4,
    ACTIONS(17139), 1,
      anon_sym_COMMA,
    STATE(10098), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16464), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [506760] = 3,
    ACTIONS(16238), 1,
      sym_keyword_force,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16236), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [506773] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16296), 4,
      anon_sym_LPAREN,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506784] = 5,
    ACTIONS(17142), 1,
      anon_sym_PLUS,
    ACTIONS(17144), 1,
      anon_sym_DASH,
    ACTIONS(17146), 1,
      aux_sym__integer_token1,
    STATE(7129), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506801] = 3,
    STATE(10250), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506814] = 3,
    STATE(12379), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506827] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9009), 1,
      sym_keyword_else,
    ACTIONS(9011), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506844] = 3,
    STATE(6988), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506857] = 3,
    STATE(11300), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506870] = 3,
    STATE(11299), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506883] = 5,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(16994), 1,
      sym_keyword_if,
    STATE(10199), 1,
      sym__single_quote_string,
    STATE(11298), 1,
      sym__if_not_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506900] = 3,
    STATE(11296), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506913] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(9958), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16462), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [506928] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15947), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506939] = 5,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7460), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [506956] = 3,
    STATE(2068), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(191), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [506969] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16138), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [506980] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15911), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [506991] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17148), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [507002] = 3,
    STATE(11294), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507015] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9654), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16116), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507030] = 4,
    ACTIONS(17150), 1,
      sym_keyword_cache,
    ACTIONS(17152), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16452), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507045] = 3,
    ACTIONS(17154), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17042), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507058] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(17156), 1,
      anon_sym_RPAREN,
    STATE(9452), 1,
      aux_sym_column_definitions_repeat1,
    STATE(14561), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507075] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16440), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(17158), 2,
      sym_keyword_after,
      sym_keyword_before,
  [507088] = 3,
    STATE(12375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507101] = 3,
    STATE(8941), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507114] = 3,
    STATE(10558), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507127] = 3,
    STATE(875), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(335), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507140] = 3,
    ACTIONS(17160), 1,
      sym_keyword_references,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16430), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [507153] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17162), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507164] = 3,
    ACTIONS(17164), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17032), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507177] = 3,
    STATE(834), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(335), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507190] = 3,
    STATE(7277), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507203] = 5,
    ACTIONS(16698), 1,
      anon_sym_PLUS,
    ACTIONS(16700), 1,
      anon_sym_DASH,
    ACTIONS(16702), 1,
      aux_sym__integer_token1,
    STATE(10525), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507220] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17166), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507231] = 4,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9919), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17168), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [507246] = 3,
    STATE(8058), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507259] = 3,
    ACTIONS(17170), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17148), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507272] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16248), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507283] = 4,
    ACTIONS(16982), 1,
      anon_sym_COMMA,
    STATE(10219), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16824), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507298] = 3,
    STATE(7395), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507311] = 3,
    STATE(6395), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507324] = 4,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(3876), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16408), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507339] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(11023), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17172), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [507354] = 3,
    STATE(6696), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507367] = 5,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(17174), 1,
      sym__double_quote_string,
    ACTIONS(17176), 1,
      sym__dollar_quoted_string_start_tag,
    STATE(6897), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507384] = 3,
    ACTIONS(16154), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15392), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [507397] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16104), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507408] = 3,
    ACTIONS(17178), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16372), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [507421] = 3,
    ACTIONS(17182), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17180), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507434] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14380), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_when,
      anon_sym_RPAREN,
  [507445] = 5,
    ACTIONS(12608), 1,
      anon_sym_LPAREN,
    ACTIONS(16558), 1,
      sym_keyword_select,
    STATE(8650), 1,
      sym_select,
    STATE(9596), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507462] = 3,
    STATE(3604), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(275), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507475] = 3,
    STATE(6408), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1089), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507488] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10180), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15995), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507503] = 5,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7449), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507520] = 4,
    ACTIONS(14603), 1,
      anon_sym_COMMA,
    STATE(8618), 1,
      aux_sym__truncate_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15941), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507535] = 5,
    ACTIONS(16009), 1,
      anon_sym_PLUS,
    ACTIONS(16011), 1,
      anon_sym_DASH,
    ACTIONS(16013), 1,
      aux_sym__integer_token1,
    STATE(7447), 1,
      sym__integer,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507552] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17184), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [507563] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(9907), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15909), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507578] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17186), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [507589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15382), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [507600] = 3,
    STATE(15), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(125), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507613] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16292), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_create,
  [507624] = 3,
    ACTIONS(17188), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16270), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [507637] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10194), 1,
      sym_keyword_end,
    ACTIONS(17190), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507654] = 3,
    STATE(10745), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507667] = 3,
    ACTIONS(17192), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16266), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [507680] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17194), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [507691] = 3,
    ACTIONS(17196), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17148), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507704] = 3,
    ACTIONS(17198), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17180), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507717] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9053), 1,
      sym_keyword_else,
    ACTIONS(9055), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507734] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16134), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
      sym_keyword_with,
  [507745] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15925), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [507756] = 3,
    ACTIONS(17200), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16528), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [507769] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17202), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [507780] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(10001), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15837), 2,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507795] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17204), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [507806] = 4,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10322), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17206), 2,
      sym_keyword_cascaded,
      sym_keyword_local,
  [507821] = 4,
    ACTIONS(14436), 1,
      sym_keyword_where,
    STATE(11271), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17172), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507836] = 3,
    STATE(10559), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507849] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10098), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16142), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507864] = 5,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(17208), 1,
      anon_sym_RPAREN,
    ACTIONS(17210), 1,
      anon_sym_EQ,
    STATE(10563), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507881] = 3,
    STATE(11316), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507894] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17212), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507905] = 3,
    STATE(6835), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14318), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [507918] = 4,
    ACTIONS(16878), 1,
      anon_sym_COMMA,
    STATE(10030), 1,
      aux_sym__rename_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16142), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [507933] = 3,
    ACTIONS(17214), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15813), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [507946] = 3,
    ACTIONS(17216), 1,
      sym_keyword_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15825), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [507959] = 5,
    ACTIONS(15917), 1,
      anon_sym_LPAREN,
    ACTIONS(16908), 1,
      sym_keyword_select,
    STATE(9316), 1,
      sym_select,
    STATE(10320), 1,
      sym__select_statement,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [507976] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17218), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [507987] = 4,
    ACTIONS(14272), 1,
      sym_keyword_where,
    STATE(10611), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16788), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [508002] = 3,
    STATE(12298), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508015] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16098), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_create,
      anon_sym_RPAREN,
  [508026] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15863), 4,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_where,
      sym_keyword_create,
  [508037] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9015), 1,
      sym_keyword_else,
    ACTIONS(9017), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508054] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(9100), 1,
      sym_keyword_else,
    ACTIONS(9102), 1,
      sym_keyword_end,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508071] = 3,
    STATE(12297), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508084] = 3,
    STATE(12293), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508097] = 3,
    STATE(11279), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508110] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16100), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
    ACTIONS(17220), 2,
      sym_keyword_after,
      sym_keyword_before,
  [508123] = 3,
    STATE(10336), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508136] = 3,
    STATE(4460), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1023), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508149] = 3,
    STATE(4006), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(215), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508162] = 4,
    ACTIONS(10772), 1,
      sym_keyword_order,
    STATE(11770), 1,
      sym_order_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17222), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [508177] = 5,
    ACTIONS(16512), 1,
      anon_sym_COMMA,
    ACTIONS(17224), 1,
      anon_sym_RPAREN,
    STATE(10392), 1,
      aux_sym_column_definitions_repeat1,
    STATE(13649), 1,
      sym_constraints,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508194] = 3,
    ACTIONS(17226), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16532), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [508207] = 3,
    STATE(9016), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508220] = 3,
    ACTIONS(17228), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15965), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [508233] = 5,
    ACTIONS(9007), 1,
      sym_keyword_when,
    ACTIONS(10156), 1,
      sym_keyword_end,
    ACTIONS(17230), 1,
      sym_keyword_else,
    STATE(9540), 1,
      aux_sym_case_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508250] = 3,
    ACTIONS(16194), 1,
      sym_keyword_cascade,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15096), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [508263] = 3,
    ACTIONS(17234), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17232), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508276] = 4,
    ACTIONS(16982), 1,
      anon_sym_COMMA,
    STATE(10219), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16926), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [508291] = 4,
    ACTIONS(16982), 1,
      anon_sym_COMMA,
    STATE(10138), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16926), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [508306] = 3,
    STATE(13638), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508319] = 3,
    STATE(7969), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15783), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508332] = 3,
    STATE(10372), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508345] = 3,
    STATE(10382), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508358] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [508369] = 5,
    ACTIONS(17236), 1,
      sym_keyword_group,
    ACTIONS(17238), 1,
      sym_keyword_no,
    ACTIONS(17240), 1,
      sym_keyword_current,
    ACTIONS(17242), 1,
      sym_keyword_ties,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508386] = 4,
    ACTIONS(17244), 1,
      anon_sym_COMMA,
    STATE(10219), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17050), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [508401] = 3,
    STATE(11282), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508414] = 3,
    STATE(4422), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(1023), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508427] = 3,
    STATE(11281), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(395), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508440] = 3,
    STATE(9163), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(115), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [508453] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16198), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [508463] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16860), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508473] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14825), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508483] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17247), 1,
      anon_sym_RPAREN,
    STATE(12403), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508497] = 4,
    ACTIONS(15046), 1,
      sym_keyword_partition,
    ACTIONS(17249), 1,
      sym_keyword_compute,
    STATE(12701), 1,
      sym__partition_spec,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508511] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17251), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508521] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16958), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508531] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14714), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508541] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17024), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508551] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17026), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508561] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17028), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508571] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17028), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508581] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16936), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [508591] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17040), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508601] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17050), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508611] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17253), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [508621] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17255), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [508631] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17257), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [508641] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17259), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [508651] = 4,
    ACTIONS(17261), 1,
      anon_sym_RPAREN,
    ACTIONS(17263), 1,
      anon_sym_COMMA,
    STATE(10243), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508665] = 4,
    ACTIONS(17266), 1,
      anon_sym_RPAREN,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508679] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16922), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508689] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17270), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508703] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17272), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [508713] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17274), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17276), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [508733] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17055), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508743] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17232), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508753] = 3,
    ACTIONS(17278), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6002), 2,
      sym_subquery,
      sym_list,
  [508765] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17280), 1,
      anon_sym_RPAREN,
    STATE(13418), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508779] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17282), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508789] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17284), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508799] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15096), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [508809] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17286), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508823] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16928), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [508833] = 4,
    ACTIONS(17288), 1,
      anon_sym_RPAREN,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508847] = 4,
    ACTIONS(15082), 1,
      anon_sym_RPAREN,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    STATE(10781), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508861] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17294), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [508871] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(1768), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508885] = 4,
    ACTIONS(17296), 1,
      anon_sym_RPAREN,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508899] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17300), 1,
      anon_sym_RPAREN,
    STATE(10514), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508913] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17302), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508927] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17304), 1,
      anon_sym_RPAREN,
    STATE(12429), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508941] = 4,
    ACTIONS(14639), 1,
      sym_keyword_from,
    ACTIONS(15420), 1,
      anon_sym_RPAREN,
    STATE(13510), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508955] = 4,
    ACTIONS(17306), 1,
      anon_sym_RPAREN,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    STATE(10243), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508969] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17310), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508983] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17312), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [508997] = 4,
    ACTIONS(17314), 1,
      sym_keyword_on,
    ACTIONS(17316), 1,
      sym_keyword_or,
    STATE(10279), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509011] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17318), 1,
      sym_keyword_on,
    STATE(10292), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509025] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17320), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [509035] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17322), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509049] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17324), 1,
      anon_sym_RPAREN,
    STATE(13417), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509063] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16762), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509073] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17326), 1,
      anon_sym_RPAREN,
    STATE(12430), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509087] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17328), 1,
      anon_sym_RPAREN,
    STATE(10549), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509101] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17318), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509115] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15837), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509125] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17330), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509139] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17332), 1,
      anon_sym_RPAREN,
    STATE(12242), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509153] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17336), 1,
      anon_sym_RPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509167] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17340), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509181] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(17342), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509195] = 4,
    ACTIONS(17344), 1,
      anon_sym_RPAREN,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    STATE(10669), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509209] = 3,
    ACTIONS(17348), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17105), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [509221] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17350), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509235] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17352), 1,
      sym_keyword_on,
    STATE(10293), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509249] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17354), 1,
      anon_sym_RPAREN,
    STATE(13665), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509263] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17356), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509277] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17352), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509291] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17358), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509305] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17358), 1,
      sym_keyword_on,
    STATE(10301), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16788), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [509329] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17360), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509343] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17362), 1,
      anon_sym_RPAREN,
    STATE(10324), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509357] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17364), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [509367] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17366), 1,
      anon_sym_RPAREN,
    STATE(10244), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509381] = 4,
    ACTIONS(17368), 1,
      anon_sym_RPAREN,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    STATE(10571), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509395] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17372), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509409] = 4,
    ACTIONS(17374), 1,
      anon_sym_RPAREN,
    ACTIONS(17376), 1,
      anon_sym_COMMA,
    STATE(10982), 1,
      aux_sym_enum_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509423] = 4,
    ACTIONS(17378), 1,
      anon_sym_RPAREN,
    ACTIONS(17380), 1,
      anon_sym_COMMA,
    STATE(10303), 1,
      aux_sym_ordered_columns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509437] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10572), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16808), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509457] = 4,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    ACTIONS(17383), 1,
      anon_sym_RPAREN,
    STATE(10439), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509471] = 4,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    ACTIONS(17383), 1,
      anon_sym_RPAREN,
    STATE(10367), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509485] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15148), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [509495] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16550), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [509505] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15382), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [509515] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17385), 1,
      anon_sym_RPAREN,
    STATE(12205), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509529] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17387), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509543] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17389), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509557] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17391), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509571] = 4,
    ACTIONS(17113), 1,
      sym_keyword_trigger,
    ACTIONS(17393), 1,
      sym_keyword_view,
    ACTIONS(17395), 1,
      sym_keyword_recursive,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509585] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17397), 1,
      anon_sym_RPAREN,
    STATE(12204), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509599] = 4,
    ACTIONS(17399), 1,
      anon_sym_RPAREN,
    ACTIONS(17401), 1,
      anon_sym_COMMA,
    STATE(10579), 1,
      aux_sym_index_fields_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509613] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17148), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [509623] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17403), 1,
      anon_sym_RPAREN,
    STATE(12449), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509637] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10602), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509647] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17372), 1,
      sym_keyword_on,
    STATE(10352), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509661] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16266), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509671] = 4,
    ACTIONS(6767), 1,
      anon_sym_RPAREN,
    ACTIONS(17405), 1,
      anon_sym_COMMA,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509685] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17408), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509699] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17410), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509713] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14462), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [509723] = 4,
    ACTIONS(17412), 1,
      sym_keyword_using,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(9077), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509737] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17416), 1,
      anon_sym_RPAREN,
    STATE(12184), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509751] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17418), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509765] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16158), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509775] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17420), 1,
      anon_sym_RPAREN,
    STATE(12609), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509789] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17422), 1,
      sym_keyword_using,
    STATE(9020), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509803] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17424), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509817] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17426), 1,
      sym_keyword_using,
    STATE(9019), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509831] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16850), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509841] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16988), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509851] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17428), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509865] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17430), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509879] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16986), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509889] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16828), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509899] = 3,
    ACTIONS(17432), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16546), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [509911] = 3,
    ACTIONS(17436), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17434), 2,
      sym_keyword_after,
      sym_keyword_before,
  [509923] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17438), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509937] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17440), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [509947] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_RPAREN,
    STATE(10669), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [509961] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15392), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509971] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16972), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [509981] = 3,
    ACTIONS(17444), 1,
      sym_keyword_force,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16896), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [509993] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16780), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [510003] = 3,
    ACTIONS(17446), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17448), 2,
      sym_keyword_unlogged,
      sym_keyword_logged,
  [510015] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17450), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510029] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17452), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510043] = 4,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(14033), 1,
      anon_sym_RPAREN,
    STATE(11015), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510057] = 4,
    ACTIONS(17454), 1,
      sym_keyword_set,
    ACTIONS(17456), 1,
      sym_keyword_drop,
    ACTIONS(17458), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510071] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17460), 1,
      sym_keyword_on,
    STATE(10502), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510085] = 4,
    ACTIONS(17462), 1,
      sym_keyword_to,
    ACTIONS(17464), 1,
      sym_keyword_wait,
    ACTIONS(17466), 1,
      sym_keyword_nowait,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510099] = 3,
    ACTIONS(17468), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(803), 2,
      sym_subquery,
      sym_list,
  [510111] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17470), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510121] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17472), 1,
      anon_sym_RPAREN,
    STATE(11095), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510135] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16822), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510145] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16818), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510155] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16814), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510165] = 3,
    ACTIONS(17474), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16910), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [510177] = 4,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    ACTIONS(17476), 1,
      anon_sym_RPAREN,
    STATE(10367), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510191] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14736), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510201] = 3,
    ACTIONS(17478), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2419), 2,
      sym_subquery,
      sym_list,
  [510213] = 4,
    ACTIONS(17480), 1,
      anon_sym_RPAREN,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    STATE(10367), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510227] = 3,
    ACTIONS(17485), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17487), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [510239] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17489), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510249] = 4,
    ACTIONS(17491), 1,
      anon_sym_RPAREN,
    ACTIONS(17493), 1,
      anon_sym_COMMA,
    STATE(10759), 1,
      aux_sym_cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510263] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17495), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510277] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16812), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510287] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14740), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510297] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16810), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510307] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17497), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510317] = 4,
    ACTIONS(17499), 1,
      sym_keyword_set,
    ACTIONS(17501), 1,
      sym_keyword_drop,
    ACTIONS(17503), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510331] = 3,
    ACTIONS(17505), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17148), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [510343] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17507), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510357] = 4,
    ACTIONS(17509), 1,
      anon_sym_RPAREN,
    ACTIONS(17511), 1,
      anon_sym_COMMA,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510371] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16804), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510381] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17497), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510391] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16802), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510401] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17514), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510415] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17452), 1,
      sym_keyword_on,
    STATE(10385), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510429] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17516), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510443] = 3,
    ACTIONS(17518), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17520), 2,
      sym_keyword_to,
      anon_sym_EQ,
  [510455] = 4,
    ACTIONS(17522), 1,
      sym_keyword_using,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8728), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510469] = 4,
    ACTIONS(17526), 1,
      anon_sym_RPAREN,
    ACTIONS(17528), 1,
      anon_sym_COMMA,
    STATE(11122), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510483] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(17530), 1,
      anon_sym_RPAREN,
    STATE(10345), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510497] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17516), 1,
      sym_keyword_on,
    STATE(10393), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510511] = 3,
    ACTIONS(17532), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17180), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [510523] = 4,
    ACTIONS(17534), 1,
      anon_sym_RPAREN,
    ACTIONS(17536), 1,
      anon_sym_COMMA,
    STATE(10392), 1,
      aux_sym_column_definitions_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510537] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17539), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510551] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17541), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510565] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17543), 1,
      anon_sym_RPAREN,
    STATE(12082), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510579] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17545), 1,
      anon_sym_RPAREN,
    STATE(11208), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510593] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17547), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510607] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17549), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510617] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17551), 1,
      sym_keyword_using,
    STATE(9079), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510631] = 4,
    ACTIONS(17553), 1,
      anon_sym_RPAREN,
    ACTIONS(17555), 1,
      anon_sym_COMMA,
    STATE(10400), 1,
      aux_sym_cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17558), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510655] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17539), 1,
      sym_keyword_on,
    STATE(10407), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510669] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16228), 1,
      anon_sym_RPAREN,
    STATE(10631), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510683] = 4,
    ACTIONS(17560), 1,
      anon_sym_RPAREN,
    ACTIONS(17562), 1,
      anon_sym_COMMA,
    STATE(11191), 1,
      aux_sym__column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510697] = 3,
    ACTIONS(17152), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16452), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [510709] = 4,
    ACTIONS(14150), 1,
      anon_sym_COMMA,
    ACTIONS(17564), 1,
      anon_sym_RPAREN,
    STATE(7957), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510723] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17566), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510737] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17566), 1,
      sym_keyword_on,
    STATE(10414), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510751] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17568), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510765] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17570), 1,
      anon_sym_RPAREN,
    STATE(10437), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510779] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(1766), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510793] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(17572), 1,
      sym_keyword_using,
    STATE(8773), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510807] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14142), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510817] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17574), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510831] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17576), 1,
      sym_keyword_using,
    STATE(9081), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510845] = 3,
    ACTIONS(17578), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16528), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [510857] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16136), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510867] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17549), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510877] = 3,
    ACTIONS(17580), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16532), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [510889] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17582), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510899] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16464), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510909] = 3,
    ACTIONS(17584), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17042), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [510921] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14885), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510931] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17586), 1,
      anon_sym_RPAREN,
    STATE(12068), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510945] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14871), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510955] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17588), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [510969] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15030), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [510979] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17022), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [510989] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17590), 1,
      anon_sym_RPAREN,
    STATE(12067), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511003] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16236), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511013] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17592), 1,
      anon_sym_RPAREN,
    STATE(12600), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511027] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(17594), 1,
      anon_sym_RPAREN,
    STATE(10641), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511041] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17596), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511055] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(17598), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511069] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15006), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511079] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16597), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [511089] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17600), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511103] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17470), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511113] = 4,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_RPAREN,
    STATE(10367), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511127] = 3,
    ACTIONS(17604), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17606), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [511139] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17608), 1,
      anon_sym_RPAREN,
    STATE(12058), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511153] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16130), 1,
      anon_sym_RPAREN,
    STATE(11012), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511167] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16124), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [511177] = 4,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(13914), 1,
      anon_sym_RPAREN,
    STATE(11015), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511191] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17610), 1,
      anon_sym_RPAREN,
    STATE(12608), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511205] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17612), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511219] = 4,
    ACTIONS(17614), 1,
      sym_keyword_materialized,
    ACTIONS(17616), 1,
      sym_keyword_not,
    ACTIONS(17618), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511233] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15020), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511243] = 3,
    ACTIONS(17620), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17032), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [511255] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13581), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511265] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16966), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511275] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16414), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511285] = 3,
    ACTIONS(17624), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17622), 2,
      sym_keyword_after,
      sym_keyword_before,
  [511297] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17030), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [511307] = 3,
    ACTIONS(17626), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16570), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [511319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15054), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511329] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15078), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511339] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17628), 1,
      anon_sym_RPAREN,
    STATE(12811), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511353] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17630), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511363] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17632), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511373] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17634), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511383] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17636), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511393] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17638), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511403] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(17172), 1,
      anon_sym_RPAREN,
    STATE(11023), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511417] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17640), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511427] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17642), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511437] = 3,
    ACTIONS(17048), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15807), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [511449] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15432), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511459] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(17644), 1,
      sym_keyword_using,
    STATE(8760), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511473] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15979), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511483] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17646), 1,
      anon_sym_RPAREN,
    STATE(10433), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511497] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(17648), 1,
      anon_sym_RPAREN,
    STATE(11054), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511511] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(15951), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511525] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17650), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511535] = 4,
    ACTIONS(17562), 1,
      anon_sym_COMMA,
    ACTIONS(17652), 1,
      anon_sym_RPAREN,
    STATE(11191), 1,
      aux_sym__column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511549] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17654), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511559] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17640), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511569] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16114), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511579] = 3,
    ACTIONS(17656), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4349), 2,
      sym_subquery,
      sym_list,
  [511591] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17658), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511601] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17660), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511611] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17662), 1,
      anon_sym_RPAREN,
    STATE(13616), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511625] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17664), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511639] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17666), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511653] = 3,
    ACTIONS(17668), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16708), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [511665] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17670), 1,
      anon_sym_RPAREN,
    STATE(10259), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511679] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16104), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511689] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17672), 1,
      anon_sym_RPAREN,
    STATE(13615), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511703] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(17674), 1,
      sym_keyword_using,
    STATE(8801), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511717] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16098), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511727] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17676), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511741] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17678), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511755] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17680), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511765] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17218), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511775] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17682), 1,
      anon_sym_RPAREN,
    STATE(12649), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511789] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17684), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511803] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17212), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511813] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17686), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511827] = 4,
    ACTIONS(17688), 1,
      sym_keyword_value,
    ACTIONS(17690), 1,
      sym_keyword_to,
    ACTIONS(17692), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511841] = 4,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(17694), 1,
      anon_sym_RPAREN,
    STATE(10922), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511855] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(17696), 1,
      anon_sym_RPAREN,
    STATE(10838), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511869] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17698), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511883] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16084), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511893] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16038), 1,
      anon_sym_RPAREN,
    STATE(10878), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511907] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17099), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511917] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17698), 1,
      sym_keyword_on,
    STATE(10702), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511931] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17700), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511945] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17702), 1,
      anon_sym_RPAREN,
    STATE(12109), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511959] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17704), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [511969] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17706), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [511983] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14847), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [511993] = 4,
    ACTIONS(16471), 1,
      anon_sym_COMMA,
    ACTIONS(17708), 1,
      anon_sym_RPAREN,
    STATE(9419), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512007] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17710), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512021] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17712), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512035] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17714), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512045] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17083), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [512055] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17716), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512069] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16772), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512079] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16770), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512089] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16094), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [512099] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17718), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512113] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(17720), 1,
      anon_sym_RPAREN,
    STATE(10874), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512127] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17722), 1,
      anon_sym_RPAREN,
    STATE(10550), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512141] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16704), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512151] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16688), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512161] = 3,
    ACTIONS(17724), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17726), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [512173] = 4,
    ACTIONS(6767), 1,
      anon_sym_RBRACK,
    ACTIONS(17728), 1,
      anon_sym_COMMA,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512187] = 3,
    ACTIONS(17733), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17731), 2,
      sym_keyword_on,
      sym_keyword_or,
  [512199] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17735), 1,
      sym_keyword_on,
    STATE(10762), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512213] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17737), 1,
      anon_sym_RPAREN,
    STATE(10853), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512227] = 4,
    ACTIONS(17739), 1,
      anon_sym_RPAREN,
    ACTIONS(17741), 1,
      anon_sym_COMMA,
    STATE(10727), 1,
      aux_sym_function_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512241] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17743), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512255] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16671), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512265] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17745), 1,
      anon_sym_RPAREN,
    STATE(10668), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512279] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16394), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512293] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16669), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512303] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17747), 1,
      anon_sym_RPAREN,
    STATE(12142), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512317] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17749), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512331] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17751), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512345] = 4,
    ACTIONS(16824), 1,
      anon_sym_RPAREN,
    ACTIONS(17753), 1,
      anon_sym_COMMA,
    STATE(10706), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512359] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16665), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512369] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17755), 1,
      anon_sym_RPAREN,
    STATE(12144), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512383] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17757), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512393] = 3,
    ACTIONS(17759), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17761), 2,
      sym_keyword_to,
      anon_sym_EQ,
  [512405] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17763), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512415] = 3,
    ACTIONS(17765), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4424), 2,
      sym_subquery,
      sym_list,
  [512427] = 4,
    ACTIONS(15314), 1,
      anon_sym_RPAREN,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    STATE(10307), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512441] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17767), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512451] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(17769), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512465] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17771), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512479] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17773), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512489] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(1770), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512503] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16651), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512513] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17775), 1,
      anon_sym_RPAREN,
    STATE(12194), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512527] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(10644), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [512537] = 3,
    ACTIONS(17777), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17779), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [512549] = 4,
    ACTIONS(17781), 1,
      sym_keyword_set,
    ACTIONS(17783), 1,
      sym_keyword_drop,
    ACTIONS(17785), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512563] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16629), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [512573] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17787), 1,
      anon_sym_RPAREN,
    STATE(10743), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512587] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17789), 1,
      sym_keyword_on,
    STATE(10754), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512601] = 4,
    ACTIONS(17791), 1,
      sym_keyword_to,
    ACTIONS(17793), 1,
      sym_keyword_wait,
    ACTIONS(17795), 1,
      sym_keyword_nowait,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512615] = 3,
    ACTIONS(17797), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17799), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [512627] = 4,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(17801), 1,
      anon_sym_RPAREN,
    STATE(10922), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512641] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17460), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512655] = 3,
    ACTIONS(17805), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17803), 2,
      sym_keyword_after,
      sym_keyword_before,
  [512667] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(17807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512681] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(17789), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512695] = 4,
    ACTIONS(17809), 1,
      sym_keyword_value,
    ACTIONS(17811), 1,
      sym_keyword_to,
    ACTIONS(17813), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512709] = 3,
    ACTIONS(17815), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17817), 2,
      sym_keyword_unlogged,
      sym_keyword_logged,
  [512721] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17819), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512731] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(17821), 1,
      anon_sym_RPAREN,
    STATE(10874), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512745] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17823), 1,
      anon_sym_RPAREN,
    STATE(10687), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512759] = 4,
    ACTIONS(17401), 1,
      anon_sym_COMMA,
    ACTIONS(17825), 1,
      anon_sym_RPAREN,
    STATE(10645), 1,
      aux_sym_index_fields_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512773] = 3,
    ACTIONS(17829), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17827), 2,
      sym_keyword_after,
      sym_keyword_before,
  [512785] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17831), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512795] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17833), 1,
      anon_sym_RPAREN,
    STATE(11079), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512809] = 3,
    ACTIONS(17835), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17837), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [512821] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(17839), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512835] = 4,
    ACTIONS(17401), 1,
      anon_sym_COMMA,
    ACTIONS(17841), 1,
      anon_sym_RPAREN,
    STATE(10645), 1,
      aux_sym_index_fields_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512849] = 3,
    ACTIONS(17845), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17843), 2,
      sym_keyword_after,
      sym_keyword_before,
  [512861] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17847), 1,
      sym_keyword_using,
    STATE(8971), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512875] = 3,
    ACTIONS(17849), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17851), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [512887] = 3,
    ACTIONS(17853), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16613), 2,
      sym_keyword_returning,
      anon_sym_RPAREN,
  [512899] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17855), 1,
      sym_keyword_using,
    STATE(8970), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512913] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16138), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [512923] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17857), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [512933] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17859), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512947] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13803), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [512957] = 4,
    ACTIONS(14639), 1,
      sym_keyword_from,
    ACTIONS(15552), 1,
      anon_sym_RPAREN,
    STATE(14506), 1,
      sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512971] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(17861), 1,
      anon_sym_RPAREN,
    STATE(10605), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [512985] = 3,
    ACTIONS(17865), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17863), 2,
      sym_keyword_after,
      sym_keyword_before,
  [512997] = 3,
    ACTIONS(17867), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4653), 2,
      sym_subquery,
      sym_list,
  [513009] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13306), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513019] = 4,
    ACTIONS(17376), 1,
      anon_sym_COMMA,
    ACTIONS(17869), 1,
      anon_sym_RPAREN,
    STATE(10716), 1,
      aux_sym_enum_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513033] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17871), 1,
      anon_sym_RPAREN,
    STATE(12831), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513047] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17873), 1,
      sym_keyword_using,
    STATE(8974), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513061] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17875), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513075] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17877), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513089] = 3,
    ACTIONS(17881), 1,
      sym_keyword_each,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17879), 2,
      sym_keyword_row,
      sym_keyword_statement,
  [513101] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17883), 1,
      anon_sym_RPAREN,
    STATE(12835), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513115] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(17885), 1,
      sym_keyword_using,
    STATE(9122), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513129] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17887), 3,
      sym_keyword_safe,
      sym_keyword_unsafe,
      sym_keyword_restricted,
  [513139] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17889), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513149] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17891), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513163] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(17893), 1,
      anon_sym_RPAREN,
    STATE(10669), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513177] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17895), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16782), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [513197] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17897), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513207] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17899), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513221] = 3,
    ACTIONS(17901), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17903), 2,
      sym_keyword_unlogged,
      sym_keyword_logged,
  [513233] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17905), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513243] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17907), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513253] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15777), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [513263] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17909), 1,
      anon_sym_RPAREN,
    STATE(10587), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513277] = 4,
    ACTIONS(16926), 1,
      anon_sym_RPAREN,
    ACTIONS(17753), 1,
      anon_sym_COMMA,
    STATE(10540), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513291] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16514), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [513301] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17911), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513311] = 4,
    ACTIONS(16926), 1,
      anon_sym_RPAREN,
    ACTIONS(17753), 1,
      anon_sym_COMMA,
    STATE(10706), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513325] = 3,
    ACTIONS(17016), 1,
      sym_keyword_force,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16236), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [513337] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17913), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513351] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17915), 1,
      anon_sym_RPAREN,
    STATE(12536), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513365] = 3,
    ACTIONS(17917), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17919), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [513377] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17921), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513391] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17923), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513401] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17925), 1,
      anon_sym_RPAREN,
    STATE(10755), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513415] = 3,
    ACTIONS(17927), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17929), 2,
      sym_keyword_unlogged,
      sym_keyword_logged,
  [513427] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17931), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513437] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(17933), 1,
      sym_keyword_using,
    STATE(9105), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513451] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(17935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513465] = 4,
    ACTIONS(17000), 1,
      anon_sym_RPAREN,
    ACTIONS(17753), 1,
      anon_sym_COMMA,
    STATE(10706), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513479] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17925), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513493] = 3,
    ACTIONS(17939), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17937), 2,
      sym_keyword_after,
      sym_keyword_before,
  [513505] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17941), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513519] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16312), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [513529] = 3,
    ACTIONS(17943), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17129), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [513541] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17945), 1,
      anon_sym_RPAREN,
    STATE(10663), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513555] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16552), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [513565] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17947), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513575] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17949), 1,
      anon_sym_RPAREN,
    STATE(12844), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513589] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17951), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513603] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(17953), 1,
      anon_sym_RPAREN,
    STATE(10874), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513617] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(17955), 1,
      sym_keyword_using,
    STATE(9161), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513631] = 4,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(17152), 1,
      anon_sym_RPAREN,
    STATE(11015), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15795), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [513655] = 4,
    ACTIONS(17957), 1,
      anon_sym_RPAREN,
    ACTIONS(17959), 1,
      anon_sym_COMMA,
    STATE(10645), 1,
      aux_sym_index_fields_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513669] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17962), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513683] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17964), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513697] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17966), 1,
      anon_sym_RPAREN,
    STATE(13581), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513711] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17968), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513721] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17970), 1,
      anon_sym_RPAREN,
    STATE(12596), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513735] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17972), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513745] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(17974), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513759] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(17976), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513773] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17972), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513783] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(17978), 1,
      anon_sym_RPAREN,
    STATE(12597), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513797] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(17980), 1,
      anon_sym_RPAREN,
    STATE(10286), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513811] = 4,
    ACTIONS(17982), 1,
      sym_keyword_materialized,
    ACTIONS(17984), 1,
      sym_keyword_not,
    ACTIONS(17986), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513825] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17988), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513835] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(17990), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513849] = 4,
    ACTIONS(17376), 1,
      anon_sym_COMMA,
    ACTIONS(17992), 1,
      anon_sym_RPAREN,
    STATE(10302), 1,
      aux_sym_enum_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513863] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17994), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513873] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17996), 3,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_cycle,
  [513883] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(17998), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513897] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18000), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513907] = 3,
    ACTIONS(18002), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18004), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [513919] = 3,
    ACTIONS(18006), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(6400), 2,
      sym_subquery,
      sym_list,
  [513931] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18008), 1,
      anon_sym_RPAREN,
    STATE(12700), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513945] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18010), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513959] = 4,
    ACTIONS(18012), 1,
      anon_sym_RPAREN,
    ACTIONS(18014), 1,
      anon_sym_COMMA,
    STATE(10669), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513973] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18017), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [513983] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18019), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [513997] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15805), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15817), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514017] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18021), 1,
      sym_keyword_using,
    STATE(9220), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514031] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18023), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514041] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16394), 1,
      anon_sym_RPAREN,
    STATE(10473), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514055] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15821), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514065] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16625), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514075] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18025), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514085] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14360), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514095] = 4,
    ACTIONS(18027), 1,
      sym_keyword_on,
    ACTIONS(18029), 1,
      sym_keyword_or,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16368), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514119] = 4,
    ACTIONS(18032), 1,
      anon_sym_RPAREN,
    ACTIONS(18034), 1,
      anon_sym_COMMA,
    STATE(10683), 1,
      aux_sym_function_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514133] = 4,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(18037), 1,
      anon_sym_RPAREN,
    STATE(10797), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514147] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16647), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514157] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16663), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514167] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18039), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514181] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18041), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514191] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18043), 3,
      sym_keyword_safe,
      sym_keyword_unsafe,
      sym_keyword_restricted,
  [514201] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18045), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514211] = 4,
    ACTIONS(18047), 1,
      anon_sym_RPAREN,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    STATE(11003), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514225] = 4,
    ACTIONS(18051), 1,
      sym_keyword_set,
    ACTIONS(18053), 1,
      sym_keyword_drop,
    ACTIONS(18055), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514239] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18057), 1,
      sym_keyword_using,
    STATE(8976), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514253] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(18059), 1,
      sym_keyword_using,
    STATE(8904), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514267] = 3,
    ACTIONS(18063), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18061), 2,
      sym_keyword_after,
      sym_keyword_before,
  [514279] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18065), 1,
      anon_sym_RPAREN,
    STATE(13012), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514293] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18067), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514303] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18069), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514313] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16684), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514323] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15969), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [514333] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9719), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514343] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18071), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514357] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18071), 1,
      sym_keyword_on,
    STATE(11036), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514371] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16744), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514381] = 3,
    ACTIONS(18073), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4885), 2,
      sym_subquery,
      sym_list,
  [514393] = 4,
    ACTIONS(17050), 1,
      anon_sym_RPAREN,
    ACTIONS(18075), 1,
      anon_sym_COMMA,
    STATE(10706), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514407] = 3,
    ACTIONS(18080), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18078), 2,
      sym_keyword_after,
      sym_keyword_before,
  [514419] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18082), 3,
      sym_keyword_minvalue,
      sym_keyword_maxvalue,
      sym_keyword_cycle,
  [514429] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16754), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514439] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18084), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514453] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16766), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514463] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16768), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514473] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18086), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514487] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18088), 1,
      sym_keyword_using,
    STATE(9618), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514501] = 4,
    ACTIONS(18090), 1,
      anon_sym_RPAREN,
    ACTIONS(18092), 1,
      anon_sym_COMMA,
    STATE(10817), 1,
      aux_sym_ordered_columns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514515] = 4,
    ACTIONS(17376), 1,
      anon_sym_COMMA,
    ACTIONS(18094), 1,
      anon_sym_RPAREN,
    STATE(10982), 1,
      aux_sym_enum_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514529] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18096), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514543] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(18098), 1,
      sym_keyword_using,
    STATE(8893), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514557] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18100), 3,
      sym__double_quote_string,
      aux_sym_identifier_token1,
      sym__identifier,
  [514567] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16790), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514577] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18102), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514587] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514601] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18106), 1,
      anon_sym_RPAREN,
    STATE(13020), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514615] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16378), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [514625] = 4,
    ACTIONS(18108), 1,
      sym_keyword_is,
    ACTIONS(18110), 1,
      anon_sym_LPAREN,
    STATE(13491), 1,
      sym_function_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514639] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16820), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [514649] = 4,
    ACTIONS(17741), 1,
      anon_sym_COMMA,
    ACTIONS(18112), 1,
      anon_sym_RPAREN,
    STATE(10683), 1,
      aux_sym_function_arguments_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514663] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18114), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514677] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18116), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514687] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16896), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514697] = 3,
    ACTIONS(18120), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18118), 2,
      sym_keyword_after,
      sym_keyword_before,
  [514709] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18122), 1,
      anon_sym_RPAREN,
    STATE(10815), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514723] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18124), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514737] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18126), 1,
      anon_sym_RPAREN,
    STATE(13293), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514751] = 3,
    ACTIONS(18130), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18128), 2,
      sym_keyword_after,
      sym_keyword_before,
  [514763] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18132), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514777] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18134), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514787] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18136), 1,
      anon_sym_RPAREN,
    STATE(13021), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514801] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514815] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(9711), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [514825] = 3,
    ACTIONS(18142), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18140), 2,
      sym_keyword_after,
      sym_keyword_before,
  [514837] = 3,
    ACTIONS(18146), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18144), 2,
      sym_keyword_after,
      sym_keyword_before,
  [514849] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17833), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514863] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14780), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514873] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18148), 1,
      anon_sym_RPAREN,
    STATE(11089), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514887] = 3,
    ACTIONS(18150), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16852), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [514899] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18152), 1,
      sym_keyword_on,
    STATE(11110), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514913] = 4,
    ACTIONS(18154), 1,
      sym_keyword_materialized,
    ACTIONS(18156), 1,
      sym_keyword_not,
    ACTIONS(18158), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514927] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18160), 1,
      anon_sym_RPAREN,
    STATE(10776), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514941] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18162), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514955] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14222), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [514965] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18164), 1,
      sym_keyword_using,
    STATE(9753), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514979] = 4,
    ACTIONS(17562), 1,
      anon_sym_COMMA,
    ACTIONS(18166), 1,
      anon_sym_RPAREN,
    STATE(10475), 1,
      aux_sym__column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [514993] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18152), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515007] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18168), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515021] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18170), 1,
      anon_sym_RPAREN,
    STATE(10840), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515035] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16858), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [515045] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18172), 1,
      sym_keyword_using,
    STATE(9766), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515059] = 4,
    ACTIONS(17493), 1,
      anon_sym_COMMA,
    ACTIONS(18174), 1,
      anon_sym_RPAREN,
    STATE(10400), 1,
      aux_sym_cte_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515073] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18176), 1,
      anon_sym_RPAREN,
    STATE(10713), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515087] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(16580), 1,
      anon_sym_RPAREN,
    STATE(10764), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515101] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18178), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515115] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18180), 1,
      anon_sym_RPAREN,
    STATE(13363), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515129] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16866), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515139] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18182), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515153] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(16578), 1,
      anon_sym_RPAREN,
    STATE(10225), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515167] = 3,
    ACTIONS(18184), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16880), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [515179] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18186), 1,
      anon_sym_RPAREN,
    STATE(13366), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13366), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515203] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16920), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [515213] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15993), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [515223] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18188), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515233] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18190), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515247] = 3,
    ACTIONS(18194), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18192), 2,
      sym_keyword_after,
      sym_keyword_before,
  [515259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16400), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515269] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18196), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515283] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16852), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515293] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18198), 1,
      anon_sym_RPAREN,
    STATE(13071), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515307] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18200), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515321] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18202), 1,
      anon_sym_RPAREN,
    STATE(13410), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515335] = 4,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    ACTIONS(18204), 1,
      anon_sym_RPAREN,
    STATE(10367), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515349] = 4,
    ACTIONS(17292), 1,
      anon_sym_COMMA,
    ACTIONS(18204), 1,
      anon_sym_RPAREN,
    STATE(10364), 1,
      aux_sym__vacuum_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515363] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18206), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18208), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515387] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15490), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515397] = 4,
    ACTIONS(18210), 1,
      sym_keyword_serializable,
    ACTIONS(18212), 1,
      sym_keyword_repeatable,
    ACTIONS(18214), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515411] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18216), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515421] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18218), 1,
      sym_keyword_using,
    STATE(9849), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515435] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16046), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515445] = 4,
    ACTIONS(18220), 1,
      sym_keyword_isolation,
    ACTIONS(18222), 1,
      sym_keyword_snapshot,
    STATE(10850), 1,
      sym__transaction_mode,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515459] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18224), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515469] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18226), 1,
      sym_keyword_using,
    STATE(9843), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515483] = 4,
    ACTIONS(18228), 1,
      sym_keyword_to,
    ACTIONS(18230), 1,
      sym_keyword_wait,
    ACTIONS(18232), 1,
      sym_keyword_nowait,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515497] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17061), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515507] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18234), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515521] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18236), 1,
      sym_keyword_using,
    STATE(9845), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515535] = 4,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(18238), 1,
      anon_sym_RPAREN,
    STATE(10922), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515549] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18240), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515563] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18242), 1,
      anon_sym_RPAREN,
    STATE(10243), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515577] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15949), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515587] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15963), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515597] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18244), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515611] = 4,
    ACTIONS(18246), 1,
      sym_keyword_to,
    ACTIONS(18248), 1,
      sym_keyword_wait,
    ACTIONS(18250), 1,
      sym_keyword_nowait,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515625] = 3,
    ACTIONS(18252), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4387), 2,
      sym_subquery,
      sym_list,
  [515637] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18254), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515651] = 4,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    ACTIONS(18256), 1,
      sym_keyword_using,
    STATE(8843), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515665] = 3,
    ACTIONS(18258), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4088), 2,
      sym_subquery,
      sym_list,
  [515677] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18260), 1,
      anon_sym_RPAREN,
    STATE(10959), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515691] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18262), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515705] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15961), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515715] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17123), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515725] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18264), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515735] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18266), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515745] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18268), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515755] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18270), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515769] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18272), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515783] = 4,
    ACTIONS(18092), 1,
      anon_sym_COMMA,
    ACTIONS(18274), 1,
      anon_sym_RPAREN,
    STATE(10303), 1,
      aux_sym_ordered_columns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515797] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18276), 1,
      anon_sym_RPAREN,
    STATE(10268), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515811] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18278), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515821] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15567), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [515831] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18280), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515845] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15947), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515855] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17162), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515865] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18282), 1,
      anon_sym_RPAREN,
    STATE(10274), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515879] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17166), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [515889] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17186), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [515899] = 4,
    ACTIONS(14150), 1,
      anon_sym_COMMA,
    ACTIONS(18284), 1,
      anon_sym_RPAREN,
    STATE(10406), 1,
      aux_sym__insert_values_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515913] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17194), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [515923] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17202), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [515933] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16657), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [515943] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18286), 1,
      anon_sym_RPAREN,
    STATE(10976), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515957] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18288), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515971] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18290), 1,
      anon_sym_RPAREN,
    STATE(13528), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515985] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18292), 1,
      anon_sym_RPAREN,
    STATE(10985), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [515999] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18294), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516013] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18296), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516023] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18298), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516033] = 4,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    ACTIONS(18300), 1,
      anon_sym_RPAREN,
    STATE(10669), 1,
      aux_sym_create_type_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516047] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18302), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516057] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18304), 1,
      anon_sym_RPAREN,
    STATE(10243), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516071] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18306), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516085] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15831), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [516095] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(1762), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18308), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516119] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18310), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516129] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18312), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516143] = 3,
    ACTIONS(18314), 1,
      sym_keyword_noscan,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17232), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [516155] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18316), 1,
      anon_sym_RPAREN,
    STATE(10875), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516169] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(16866), 1,
      anon_sym_RPAREN,
    STATE(10248), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516183] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18318), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18320), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516203] = 3,
    ACTIONS(18322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17095), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [516215] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18324), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516229] = 4,
    ACTIONS(18326), 1,
      sym_keyword_by,
    ACTIONS(18328), 1,
      anon_sym_LPAREN,
    STATE(6700), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516243] = 4,
    ACTIONS(18092), 1,
      anon_sym_COMMA,
    ACTIONS(18330), 1,
      anon_sym_RPAREN,
    STATE(10303), 1,
      aux_sym_ordered_columns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516257] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18332), 1,
      sym_keyword_using,
    STATE(9969), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516271] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18334), 1,
      sym_keyword_using,
    STATE(9979), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516285] = 4,
    ACTIONS(18336), 1,
      sym_keyword_serializable,
    ACTIONS(18338), 1,
      sym_keyword_repeatable,
    ACTIONS(18340), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516299] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17204), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [516309] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18342), 1,
      anon_sym_RPAREN,
    STATE(11009), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516323] = 3,
    ACTIONS(18344), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2668), 2,
      sym_subquery,
      sym_list,
  [516335] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18346), 1,
      anon_sym_RPAREN,
    STATE(13550), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516349] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18348), 1,
      sym_keyword_using,
    STATE(9987), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516363] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18350), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15925), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [516387] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516401] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18354), 1,
      anon_sym_RPAREN,
    STATE(13562), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516415] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18356), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516429] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18358), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516443] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17184), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [516453] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(16862), 1,
      anon_sym_RPAREN,
    STATE(10295), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516467] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14380), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [516477] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(16860), 1,
      anon_sym_RPAREN,
    STATE(10298), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516491] = 4,
    ACTIONS(18360), 1,
      anon_sym_RPAREN,
    ACTIONS(18362), 1,
      anon_sym_COMMA,
    STATE(10874), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516505] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18365), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516519] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16560), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [516529] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18367), 1,
      anon_sym_RPAREN,
    STATE(13306), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516543] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18342), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516557] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18369), 1,
      anon_sym_RPAREN,
    STATE(13574), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516571] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14916), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516581] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18371), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516595] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18373), 1,
      anon_sym_RPAREN,
    STATE(10958), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516609] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18375), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516623] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18377), 1,
      anon_sym_RPAREN,
    STATE(10869), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516637] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18379), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516651] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16248), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [516661] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18381), 1,
      anon_sym_RPAREN,
    STATE(10314), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516675] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15911), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [516685] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17135), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [516695] = 4,
    ACTIONS(17562), 1,
      anon_sym_COMMA,
    ACTIONS(18383), 1,
      anon_sym_RPAREN,
    STATE(10404), 1,
      aux_sym__column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516709] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17133), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [516719] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18385), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516733] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16840), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [516743] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516757] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18389), 1,
      anon_sym_RPAREN,
    STATE(13318), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516771] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18391), 1,
      anon_sym_RPAREN,
    STATE(10892), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516785] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18393), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516799] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18395), 1,
      anon_sym_RPAREN,
    STATE(13319), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516813] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18397), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516827] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18399), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [516837] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18401), 1,
      sym_keyword_using,
    STATE(9234), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17085), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [516861] = 3,
    ACTIONS(18403), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(5527), 2,
      sym_subquery,
      sym_list,
  [516873] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18405), 1,
      sym_keyword_using,
    STATE(9230), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516887] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18407), 1,
      anon_sym_RPAREN,
    STATE(10883), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516901] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516915] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18409), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516929] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18411), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516943] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17071), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [516953] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18413), 1,
      anon_sym_RPAREN,
    STATE(10899), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516967] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18415), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516981] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18417), 1,
      sym_keyword_using,
    STATE(9174), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [516995] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18419), 1,
      anon_sym_RPAREN,
    STATE(10739), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517009] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18421), 1,
      anon_sym_RPAREN,
    STATE(10911), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517023] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18423), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517037] = 3,
    ACTIONS(2806), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(2802), 2,
      sym_keyword_is,
      anon_sym_EQ,
  [517049] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18425), 1,
      anon_sym_RPAREN,
    STATE(10885), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517063] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18427), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517077] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18419), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517091] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18429), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517105] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18431), 1,
      anon_sym_RPAREN,
    STATE(10338), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517119] = 4,
    ACTIONS(18433), 1,
      anon_sym_RPAREN,
    ACTIONS(18435), 1,
      anon_sym_COMMA,
    STATE(10922), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517133] = 4,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(18438), 1,
      anon_sym_RPAREN,
    STATE(11134), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517147] = 3,
    ACTIONS(18440), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18433), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [517159] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17014), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [517169] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18431), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517183] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18442), 1,
      anon_sym_RPAREN,
    STATE(10918), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517197] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18444), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517211] = 3,
    ACTIONS(18448), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18446), 2,
      sym_keyword_after,
      sym_keyword_before,
  [517223] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17012), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [517233] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18450), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517247] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18452), 1,
      anon_sym_RPAREN,
    STATE(13789), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517261] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15875), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [517271] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18454), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517285] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18456), 1,
      sym_keyword_using,
    STATE(10158), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517299] = 4,
    ACTIONS(18458), 1,
      sym_keyword_isolation,
    ACTIONS(18460), 1,
      sym_keyword_snapshot,
    STATE(11373), 1,
      sym__transaction_mode,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517313] = 4,
    ACTIONS(17401), 1,
      anon_sym_COMMA,
    ACTIONS(18462), 1,
      anon_sym_RPAREN,
    STATE(10573), 1,
      aux_sym_index_fields_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517327] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18464), 1,
      anon_sym_RPAREN,
    STATE(13335), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517341] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517355] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16458), 1,
      anon_sym_RPAREN,
    STATE(11055), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517369] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17002), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [517379] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18468), 1,
      sym_keyword_using,
    STATE(10175), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517393] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18470), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517407] = 4,
    ACTIONS(16736), 1,
      sym_keyword_trigger,
    ACTIONS(18472), 1,
      sym_keyword_view,
    ACTIONS(18474), 1,
      sym_keyword_recursive,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517421] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16452), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [517431] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18476), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [517441] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18478), 1,
      anon_sym_RPAREN,
    STATE(10974), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517455] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16384), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517465] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16974), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517475] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18480), 1,
      anon_sym_RPAREN,
    STATE(10907), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517489] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15869), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517499] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18482), 1,
      anon_sym_RPAREN,
    STATE(11174), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517513] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18484), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517527] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16942), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517537] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18486), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [517547] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18488), 1,
      anon_sym_RPAREN,
    STATE(10943), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517561] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18490), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517575] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18492), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517589] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18494), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517603] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18496), 1,
      anon_sym_RPAREN,
    STATE(10881), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517617] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18498), 1,
      anon_sym_RPAREN,
    STATE(14083), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517631] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18500), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517645] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18502), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517659] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18504), 1,
      sym_keyword_using,
    STATE(8989), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517673] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18506), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517687] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18508), 1,
      anon_sym_RPAREN,
    STATE(13884), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517701] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16868), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [517711] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18510), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517725] = 4,
    ACTIONS(17783), 1,
      sym_keyword_drop,
    ACTIONS(17785), 1,
      sym_keyword_type,
    ACTIONS(18512), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517739] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16473), 1,
      anon_sym_RPAREN,
    STATE(10919), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517753] = 4,
    ACTIONS(18092), 1,
      anon_sym_COMMA,
    ACTIONS(18514), 1,
      anon_sym_RPAREN,
    STATE(10855), 1,
      aux_sym_ordered_columns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517767] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16838), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [517777] = 4,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    ACTIONS(18516), 1,
      sym_keyword_using,
    STATE(10118), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517791] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18518), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517805] = 4,
    ACTIONS(18520), 1,
      sym_keyword_materialized,
    ACTIONS(18522), 1,
      sym_keyword_not,
    ACTIONS(18524), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517819] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18526), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517833] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18528), 1,
      anon_sym_RPAREN,
    STATE(12350), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517847] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18530), 1,
      anon_sym_RPAREN,
    STATE(13956), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517861] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16836), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [517871] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16832), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [517881] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16477), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517891] = 4,
    ACTIONS(18532), 1,
      anon_sym_RPAREN,
    ACTIONS(18534), 1,
      anon_sym_COMMA,
    STATE(10982), 1,
      aux_sym_enum_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517905] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18537), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517919] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18539), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517933] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18541), 1,
      anon_sym_RPAREN,
    STATE(10243), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517947] = 4,
    ACTIONS(14750), 1,
      sym_keyword_where,
    ACTIONS(16788), 1,
      anon_sym_RPAREN,
    STATE(10611), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517961] = 4,
    ACTIONS(18543), 1,
      sym_keyword_by,
    ACTIONS(18545), 1,
      anon_sym_LPAREN,
    STATE(6783), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [517975] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16712), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517985] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16645), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [517995] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16641), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518005] = 3,
    ACTIONS(18547), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(3448), 2,
      sym_subquery,
      sym_list,
  [518017] = 3,
    ACTIONS(18551), 1,
      sym_keyword_instead,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18549), 2,
      sym_keyword_after,
      sym_keyword_before,
  [518029] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18553), 1,
      anon_sym_RPAREN,
    STATE(10968), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518043] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18555), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518057] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18178), 1,
      sym_keyword_on,
    STATE(10567), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518071] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18557), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518081] = 4,
    ACTIONS(15046), 1,
      sym_keyword_partition,
    ACTIONS(18559), 1,
      sym_keyword_compute,
    STATE(13836), 1,
      sym__partition_spec,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518095] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18561), 1,
      anon_sym_RPAREN,
    STATE(10983), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518109] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18563), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518123] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518137] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18567), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518147] = 3,
    ACTIONS(18569), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4730), 2,
      sym_subquery,
      sym_list,
  [518159] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18571), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518173] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18573), 3,
      sym_keyword_match,
      sym_keyword_true,
      sym_keyword_false,
  [518183] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18573), 3,
      sym_keyword_csv,
      sym_keyword_binary,
      sym_keyword_text,
  [518193] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18575), 1,
      anon_sym_RPAREN,
    STATE(11097), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518207] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18577), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518221] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18579), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518231] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18581), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518245] = 4,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    ACTIONS(18583), 1,
      anon_sym_RPAREN,
    STATE(10799), 1,
      aux_sym_alter_index_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16516), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [518269] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(15959), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518283] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16518), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [518293] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18585), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518307] = 4,
    ACTIONS(14547), 1,
      anon_sym_RPAREN,
    ACTIONS(18587), 1,
      anon_sym_COMMA,
    STATE(11015), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518321] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16522), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518331] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16536), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518341] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18590), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518351] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18592), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518365] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16542), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518375] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16544), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518385] = 4,
    ACTIONS(13912), 1,
      anon_sym_COMMA,
    ACTIONS(16456), 1,
      anon_sym_RPAREN,
    STATE(11015), 1,
      aux_sym__compute_stats_repeat2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518399] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18594), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518409] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(15959), 1,
      anon_sym_RPAREN,
    STATE(10535), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518423] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(15951), 1,
      anon_sym_RPAREN,
    STATE(10926), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518437] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18596), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518451] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18598), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518465] = 4,
    ACTIONS(18600), 1,
      sym_keyword_by,
    ACTIONS(18602), 1,
      anon_sym_LPAREN,
    STATE(8354), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518479] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18604), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518489] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18606), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518503] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18608), 1,
      anon_sym_RPAREN,
    STATE(14061), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518517] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16473), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518531] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18610), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518545] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18612), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518555] = 4,
    ACTIONS(17000), 1,
      anon_sym_RPAREN,
    ACTIONS(17753), 1,
      anon_sym_COMMA,
    STATE(10618), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518569] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18614), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518583] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15807), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518593] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16582), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [518603] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18616), 1,
      anon_sym_RPAREN,
    STATE(10999), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518617] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16586), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [518627] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18618), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518641] = 4,
    ACTIONS(18620), 1,
      anon_sym_RPAREN,
    ACTIONS(18622), 1,
      anon_sym_COMMA,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518655] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16588), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518665] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16599), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518675] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16686), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518685] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18625), 1,
      anon_sym_RPAREN,
    STATE(11073), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518699] = 4,
    ACTIONS(16506), 1,
      anon_sym_RPAREN,
    ACTIONS(18627), 1,
      sym_keyword_returning,
    STATE(11167), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518713] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16609), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18629), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [518733] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18631), 3,
      sym_keyword_and,
      sym_keyword_exclude,
      anon_sym_RPAREN,
  [518743] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16481), 1,
      anon_sym_RPAREN,
    STATE(11086), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518757] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518771] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18635), 1,
      anon_sym_RPAREN,
    STATE(13931), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518785] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(18637), 1,
      anon_sym_RPAREN,
    STATE(10874), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518799] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16481), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518813] = 3,
    ACTIONS(18639), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18641), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [518825] = 4,
    ACTIONS(16980), 1,
      anon_sym_RPAREN,
    ACTIONS(17753), 1,
      anon_sym_COMMA,
    STATE(10630), 1,
      aux_sym_alter_table_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518839] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18643), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518853] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16621), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [518863] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18645), 1,
      anon_sym_RPAREN,
    STATE(14084), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518877] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16623), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [518887] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18647), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518901] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16627), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518911] = 4,
    ACTIONS(16471), 1,
      anon_sym_COMMA,
    ACTIONS(18649), 1,
      anon_sym_RPAREN,
    STATE(10512), 1,
      aux_sym_select_expression_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518925] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18651), 1,
      anon_sym_RPAREN,
    STATE(14085), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518939] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16631), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518949] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18653), 1,
      anon_sym_RPAREN,
    STATE(10329), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [518963] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16633), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518973] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16643), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [518983] = 3,
    ACTIONS(18655), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18657), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [518995] = 3,
    ACTIONS(18659), 1,
      sym_keyword_nulls,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18661), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [519007] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18614), 1,
      sym_keyword_on,
    STATE(11087), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519021] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18663), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519035] = 4,
    ACTIONS(16774), 1,
      anon_sym_RPAREN,
    ACTIONS(18627), 1,
      sym_keyword_returning,
    STATE(11158), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519049] = 4,
    ACTIONS(18053), 1,
      sym_keyword_drop,
    ACTIONS(18055), 1,
      sym_keyword_type,
    ACTIONS(18665), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519063] = 4,
    ACTIONS(16617), 1,
      anon_sym_RPAREN,
    ACTIONS(18627), 1,
      sym_keyword_returning,
    STATE(11201), 1,
      sym_returning,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519077] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18667), 1,
      anon_sym_RPAREN,
    STATE(14107), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519091] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18669), 1,
      anon_sym_RPAREN,
    STATE(11026), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519105] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18671), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519119] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18673), 1,
      anon_sym_RPAREN,
    STATE(11027), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519133] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18669), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519147] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18675), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519161] = 4,
    ACTIONS(17370), 1,
      anon_sym_COMMA,
    ACTIONS(18677), 1,
      anon_sym_RPAREN,
    STATE(10522), 1,
      aux_sym__table_settings_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519175] = 4,
    ACTIONS(18679), 1,
      anon_sym_RPAREN,
    ACTIONS(18681), 1,
      anon_sym_COMMA,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519189] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18684), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [519199] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16488), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519213] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18686), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519227] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18688), 1,
      anon_sym_RPAREN,
    STATE(11082), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519241] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18690), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519255] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18692), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519269] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18694), 1,
      anon_sym_RPAREN,
    STATE(11090), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519283] = 3,
    ACTIONS(18696), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4336), 2,
      sym_subquery,
      sym_list,
  [519295] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18698), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519309] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18700), 1,
      sym_keyword_on,
    STATE(10564), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519323] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18702), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519337] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18704), 1,
      anon_sym_RPAREN,
    STATE(11093), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519351] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18706), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519365] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18708), 1,
      anon_sym_RPAREN,
    STATE(11209), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519379] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18710), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [519389] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18712), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519403] = 3,
    ACTIONS(18714), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2273), 2,
      sym_subquery,
      sym_list,
  [519415] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16649), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_when,
  [519425] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18716), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519439] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18718), 1,
      anon_sym_RPAREN,
    STATE(11100), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519453] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18720), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519467] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18722), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519481] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16655), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519491] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16659), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519501] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16667), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519511] = 4,
    ACTIONS(17316), 1,
      sym_keyword_or,
    ACTIONS(18700), 1,
      sym_keyword_on,
    STATE(10681), 1,
      aux_sym_create_trigger_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519525] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18724), 1,
      anon_sym_RPAREN,
    STATE(11105), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519539] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18726), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [519549] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18728), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519563] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18730), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519577] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18732), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519591] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18734), 1,
      anon_sym_RPAREN,
    STATE(11114), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519605] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18736), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519619] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18738), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519633] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18740), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519647] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18742), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519661] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18744), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519675] = 4,
    ACTIONS(17528), 1,
      anon_sym_COMMA,
    ACTIONS(18746), 1,
      anon_sym_RPAREN,
    STATE(11160), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16678), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519699] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18748), 1,
      anon_sym_RPAREN,
    STATE(11119), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519713] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18750), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519727] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16680), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519737] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16682), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519747] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18752), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519761] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18754), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519775] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18756), 1,
      anon_sym_RPAREN,
    STATE(14497), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519789] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18758), 1,
      anon_sym_RPAREN,
    STATE(11120), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519803] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18760), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519817] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18762), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519831] = 4,
    ACTIONS(16564), 1,
      anon_sym_COMMA,
    ACTIONS(18764), 1,
      anon_sym_RPAREN,
    STATE(10922), 1,
      aux_sym_storage_parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519845] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18766), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519859] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18768), 1,
      anon_sym_RPAREN,
    STATE(11133), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519873] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18770), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519887] = 4,
    ACTIONS(18772), 1,
      anon_sym_RPAREN,
    ACTIONS(18774), 1,
      anon_sym_COMMA,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519901] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18777), 1,
      anon_sym_RPAREN,
    STATE(11125), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519915] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16692), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [519925] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18779), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519939] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18781), 1,
      anon_sym_RPAREN,
    STATE(10333), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519953] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18783), 1,
      anon_sym_RPAREN,
    STATE(14413), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519967] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18785), 1,
      anon_sym_RPAREN,
    STATE(11135), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519981] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18787), 1,
      anon_sym_RPAREN,
    STATE(11172), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [519995] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18789), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520009] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18791), 1,
      anon_sym_RPAREN,
    STATE(14419), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520023] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18793), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520037] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18795), 1,
      anon_sym_RPAREN,
    STATE(14421), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520051] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18797), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520065] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18799), 1,
      anon_sym_RPAREN,
    STATE(11146), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520079] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15639), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [520089] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18801), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520103] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18803), 1,
      anon_sym_RPAREN,
    STATE(14439), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520117] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18805), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520131] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16696), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520141] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18807), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520155] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18809), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [520165] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18811), 1,
      anon_sym_RPAREN,
    STATE(14512), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520179] = 4,
    ACTIONS(18813), 1,
      anon_sym_RPAREN,
    ACTIONS(18815), 1,
      anon_sym_COMMA,
    STATE(11160), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520193] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18818), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520207] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16706), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520217] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18820), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520231] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18822), 1,
      anon_sym_RPAREN,
    STATE(14514), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520245] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16722), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520255] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16724), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520265] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18824), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [520275] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18826), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520289] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16496), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_returning,
  [520299] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16728), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520309] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18828), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520323] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18830), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520337] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16730), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520347] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18832), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520361] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18834), 1,
      anon_sym_RPAREN,
    STATE(11141), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520375] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18836), 1,
      anon_sym_RPAREN,
    STATE(14524), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520389] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18838), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520403] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(16488), 1,
      anon_sym_RPAREN,
    STATE(11032), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520417] = 3,
    ACTIONS(18840), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(4512), 2,
      sym_subquery,
      sym_list,
  [520429] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16740), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520439] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16742), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520449] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18842), 1,
      anon_sym_RPAREN,
    STATE(11150), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520463] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18844), 1,
      anon_sym_RPAREN,
    STATE(11157), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520477] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18842), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520491] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16746), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520501] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18846), 1,
      anon_sym_RPAREN,
    STATE(14531), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520515] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18848), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520529] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16756), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520539] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18671), 1,
      anon_sym_RPAREN,
    STATE(11081), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520553] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18850), 1,
      anon_sym_RPAREN,
    STATE(11084), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520567] = 4,
    ACTIONS(18852), 1,
      anon_sym_RPAREN,
    ACTIONS(18854), 1,
      anon_sym_COMMA,
    STATE(11191), 1,
      aux_sym__column_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520581] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18857), 1,
      anon_sym_RPAREN,
    STATE(14537), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520595] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18859), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520609] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18861), 1,
      anon_sym_RPAREN,
    STATE(14538), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520623] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18863), 1,
      anon_sym_RPAREN,
    STATE(10409), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520637] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16758), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520647] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16760), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520657] = 3,
    ACTIONS(18865), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    STATE(2693), 2,
      sym_subquery,
      sym_list,
  [520669] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520683] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18867), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520697] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18869), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [520707] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18871), 1,
      anon_sym_RPAREN,
    STATE(11041), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520721] = 4,
    ACTIONS(9448), 1,
      anon_sym_COMMA,
    ACTIONS(18873), 1,
      anon_sym_RPAREN,
    STATE(10323), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520735] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16764), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520745] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18875), 1,
      anon_sym_RPAREN,
    STATE(11177), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520759] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18877), 1,
      anon_sym_RPAREN,
    STATE(11184), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520773] = 4,
    ACTIONS(17268), 1,
      anon_sym_COMMA,
    ACTIONS(18879), 1,
      anon_sym_RPAREN,
    STATE(11190), 1,
      aux_sym_enum_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520787] = 4,
    ACTIONS(17290), 1,
      anon_sym_COMMA,
    ACTIONS(18881), 1,
      anon_sym_RPAREN,
    STATE(10379), 1,
      aux_sym_alter_column_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520801] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18883), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520815] = 4,
    ACTIONS(9452), 1,
      anon_sym_COMMA,
    ACTIONS(18885), 1,
      anon_sym_RBRACK,
    STATE(10527), 1,
      aux_sym_array_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520829] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18887), 1,
      anon_sym_RPAREN,
    STATE(11187), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520843] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18877), 1,
      anon_sym_RPAREN,
    STATE(7589), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520857] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18889), 1,
      anon_sym_RPAREN,
    STATE(11218), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520871] = 4,
    ACTIONS(8867), 1,
      sym_keyword_limit,
    ACTIONS(18891), 1,
      anon_sym_RPAREN,
    STATE(14548), 1,
      sym_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520885] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18893), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520899] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16726), 3,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
      sym_keyword_create,
  [520909] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520923] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18897), 1,
      anon_sym_RPAREN,
    STATE(11138), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520937] = 4,
    ACTIONS(18049), 1,
      anon_sym_COMMA,
    ACTIONS(18899), 1,
      anon_sym_RPAREN,
    STATE(11200), 1,
      aux_sym_create_trigger_repeat3,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520951] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(17418), 1,
      anon_sym_RPAREN,
    STATE(11212), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520965] = 4,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(18901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520979] = 4,
    ACTIONS(17298), 1,
      anon_sym_COMMA,
    ACTIONS(18903), 1,
      anon_sym_RPAREN,
    STATE(11042), 1,
      aux_sym_invocation_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [520993] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18905), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [521003] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18907), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [521013] = 4,
    ACTIONS(1752), 1,
      anon_sym_COMMA,
    ACTIONS(18909), 1,
      anon_sym_RPAREN,
    STATE(10994), 1,
      aux_sym_set_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521027] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8743), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521038] = 3,
    ACTIONS(18911), 1,
      anon_sym_RPAREN,
    ACTIONS(18913), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521049] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18907), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521058] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17905), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521067] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17897), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521076] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17895), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521085] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17857), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521094] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17889), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521103] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16788), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521112] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17274), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521121] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17232), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521130] = 3,
    ACTIONS(18915), 1,
      anon_sym_RPAREN,
    ACTIONS(18917), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521141] = 3,
    ACTIONS(18919), 1,
      anon_sym_RPAREN,
    ACTIONS(18921), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521152] = 3,
    ACTIONS(18923), 1,
      anon_sym_RPAREN,
    ACTIONS(18925), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521163] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17282), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521172] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17251), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521181] = 3,
    ACTIONS(18927), 1,
      aux_sym__integer_token1,
    ACTIONS(18929), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521192] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17284), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521201] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17294), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521210] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17320), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521219] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17911), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521228] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16860), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521237] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16866), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521246] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16852), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521255] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18208), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521264] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15490), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521273] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18216), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521282] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18264), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521291] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18266), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521300] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18268), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521309] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18905), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521318] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18629), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521327] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17364), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521336] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16601), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521345] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18612), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521354] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18931), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [521363] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18604), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521372] = 3,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(11250), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521383] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15639), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521392] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18590), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521401] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18579), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521410] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18296), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521419] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18278), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521428] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18567), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521437] = 3,
    ACTIONS(14400), 1,
      anon_sym_LPAREN,
    STATE(2679), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521448] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18594), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521457] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18557), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521466] = 3,
    ACTIONS(18933), 1,
      sym_keyword_update,
    ACTIONS(18935), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521477] = 3,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(11262), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521488] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18486), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521497] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18476), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521506] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16452), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521515] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16752), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521524] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18399), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521533] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14916), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521542] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18302), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521551] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18298), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521560] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18224), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521569] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15807), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521578] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17489), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521587] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17630), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521596] = 3,
    ACTIONS(18937), 1,
      anon_sym_LPAREN,
    STATE(4435), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521607] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17632), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521616] = 3,
    ACTIONS(18939), 1,
      aux_sym__integer_token1,
    ACTIONS(18941), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521627] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17634), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521636] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17638), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17642), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521654] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15432), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521663] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17650), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521672] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17654), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521681] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17658), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521690] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(14483), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521701] = 3,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(10122), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521712] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17773), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521721] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17831), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521730] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11774), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [521739] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18710), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521748] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18726), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521757] = 3,
    ACTIONS(18943), 1,
      anon_sym_RPAREN,
    ACTIONS(18945), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521768] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18320), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521777] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18308), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521786] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15567), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521795] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18188), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521804] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14780), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521813] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18134), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521822] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16896), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521831] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18116), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521840] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18102), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521849] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18069), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521858] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18067), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521867] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11835), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [521876] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18025), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521885] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18017), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521894] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17994), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521903] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17947), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521912] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6623), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521923] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17931), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521932] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17923), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521941] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17767), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521950] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17757), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521959] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(11859), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [521968] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16136), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521977] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14142), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [521986] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(14362), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [521997] = 3,
    ACTIONS(18947), 1,
      anon_sym_LPAREN,
    STATE(8396), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522008] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15148), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522017] = 3,
    ACTIONS(16360), 1,
      sym_keyword_sequence,
    ACTIONS(17038), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522028] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17440), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522037] = 3,
    ACTIONS(18949), 1,
      anon_sym_RPAREN,
    ACTIONS(18951), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522048] = 3,
    ACTIONS(18953), 1,
      anon_sym_RPAREN,
    ACTIONS(18955), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522059] = 3,
    ACTIONS(18957), 1,
      anon_sym_RPAREN,
    ACTIONS(18959), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522070] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14871), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522079] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15030), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522088] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16236), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522097] = 3,
    ACTIONS(18961), 1,
      sym_keyword_table,
    ACTIONS(18963), 1,
      sym_keyword_tables,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522108] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15006), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522117] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15020), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522126] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18045), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522135] = 3,
    ACTIONS(18965), 1,
      sym_keyword_stats,
    ACTIONS(18967), 1,
      sym_keyword_incremental,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522146] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15078), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522155] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(15054), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522164] = 3,
    ACTIONS(1394), 1,
      ts_builtin_sym_end,
    ACTIONS(18969), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522175] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17640), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522184] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17640), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17660), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522202] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17582), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522211] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17680), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522220] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17714), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522229] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17763), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522238] = 3,
    ACTIONS(18971), 1,
      sym_keyword_from,
    STATE(9451), 1,
      sym__delete_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522249] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17819), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522258] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13306), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522267] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16400), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522276] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(14222), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522285] = 3,
    ACTIONS(14218), 1,
      anon_sym_LPAREN,
    STATE(3954), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522296] = 3,
    ACTIONS(18947), 1,
      anon_sym_LPAREN,
    STATE(8135), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522307] = 3,
    ACTIONS(18973), 1,
      anon_sym_LBRACK,
    ACTIONS(18975), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522318] = 3,
    ACTIONS(18977), 1,
      aux_sym__integer_token1,
    ACTIONS(18979), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522329] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18684), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522338] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18824), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522347] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18041), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522356] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17704), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522365] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17470), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522374] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17549), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522383] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17549), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522392] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17470), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522401] = 3,
    ACTIONS(10824), 1,
      aux_sym__single_quote_string_token1,
    STATE(7201), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522412] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18318), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522421] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13581), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522430] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18809), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522439] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18869), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522448] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18310), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522457] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17636), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522466] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17497), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522475] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17497), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522484] = 3,
    ACTIONS(18981), 1,
      anon_sym_LPAREN,
    ACTIONS(18983), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522495] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17558), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522504] = 3,
    ACTIONS(18985), 1,
      anon_sym_RPAREN,
    ACTIONS(18987), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522515] = 3,
    ACTIONS(18989), 1,
      aux_sym__integer_token1,
    ACTIONS(18991), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522526] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13366), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522535] = 3,
    ACTIONS(18993), 1,
      anon_sym_RPAREN,
    ACTIONS(18995), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522546] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18023), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522555] = 3,
    ACTIONS(18997), 1,
      anon_sym_RPAREN,
    ACTIONS(18999), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522566] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18000), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522575] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17988), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522584] = 3,
    ACTIONS(19001), 1,
      anon_sym_RPAREN,
    ACTIONS(19003), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522595] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17972), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522604] = 3,
    ACTIONS(19005), 1,
      anon_sym_RPAREN,
    ACTIONS(19007), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522615] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17972), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522624] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17968), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522633] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19009), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [522642] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19011), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [522651] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19013), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [522660] = 3,
    ACTIONS(19015), 1,
      anon_sym_RPAREN,
    ACTIONS(19017), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522671] = 3,
    ACTIONS(19019), 1,
      anon_sym_RPAREN,
    ACTIONS(19021), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522682] = 3,
    ACTIONS(19023), 1,
      anon_sym_RPAREN,
    ACTIONS(19025), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522693] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9585), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522704] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17907), 2,
      sym__dollar_quoted_string_end_tag,
      anon_sym_SEMI,
  [522713] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19027), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [522722] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9563), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522733] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9553), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522744] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19029), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522753] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19031), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522762] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19031), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522771] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19033), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [522780] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9531), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522791] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19035), 2,
      sym_keyword_default,
      sym_keyword_null,
  [522800] = 3,
    ACTIONS(19037), 1,
      anon_sym_SEMI,
    ACTIONS(19039), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522811] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9478), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522822] = 3,
    ACTIONS(19041), 1,
      sym_keyword_first,
    ACTIONS(19043), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522833] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19045), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522842] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19045), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19047), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522860] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19049), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [522869] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9454), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522880] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9578), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522891] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19051), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522900] = 3,
    ACTIONS(19053), 1,
      anon_sym_SEMI,
    ACTIONS(19055), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522911] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19057), 2,
      sym_keyword_to,
      anon_sym_EQ,
  [522920] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9431), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522931] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19059), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522940] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19061), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522949] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19061), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522958] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19063), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522967] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19063), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [522976] = 3,
    ACTIONS(19065), 1,
      sym_keyword_first,
    ACTIONS(19067), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522987] = 3,
    ACTIONS(19069), 1,
      aux_sym__integer_token1,
    ACTIONS(19071), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [522998] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19073), 2,
      sym_keyword_first,
      sym_keyword_last,
  [523007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19075), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523016] = 3,
    ACTIONS(16360), 1,
      sym_keyword_sequence,
    ACTIONS(16992), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523027] = 3,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13140), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523038] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19077), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523047] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9721), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523058] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9771), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523069] = 3,
    ACTIONS(19079), 1,
      sym_keyword_update,
    ACTIONS(19081), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523080] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9281), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523091] = 3,
    ACTIONS(19083), 1,
      sym_keyword_outer,
    ACTIONS(19085), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523102] = 3,
    ACTIONS(16318), 1,
      sym_keyword_outer,
    ACTIONS(16320), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523113] = 3,
    ACTIONS(19087), 1,
      anon_sym_RPAREN,
    ACTIONS(19089), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523124] = 3,
    ACTIONS(19091), 1,
      anon_sym_RPAREN,
    ACTIONS(19093), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523135] = 3,
    ACTIONS(19095), 1,
      anon_sym_RPAREN,
    ACTIONS(19097), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523146] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19099), 2,
      sym_keyword_delete,
      sym_keyword_update,
  [523155] = 3,
    ACTIONS(19101), 1,
      sym_keyword_outer,
    ACTIONS(19103), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523166] = 3,
    ACTIONS(16284), 1,
      sym_keyword_outer,
    ACTIONS(16286), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523177] = 3,
    ACTIONS(19105), 1,
      anon_sym_SEMI,
    ACTIONS(19107), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523188] = 3,
    ACTIONS(19109), 1,
      sym_keyword_outer,
    ACTIONS(19111), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523199] = 3,
    ACTIONS(19113), 1,
      sym_keyword_outer,
    ACTIONS(19115), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523210] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9254), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523221] = 3,
    ACTIONS(19117), 1,
      sym_keyword_first,
    ACTIONS(19119), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523232] = 3,
    ACTIONS(16244), 1,
      sym_keyword_outer,
    ACTIONS(16246), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523243] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19121), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523252] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19059), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523261] = 3,
    ACTIONS(19123), 1,
      sym_keyword_outer,
    ACTIONS(19125), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523272] = 3,
    ACTIONS(19127), 1,
      sym_keyword_outer,
    ACTIONS(19129), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523283] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19131), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523292] = 3,
    ACTIONS(19133), 1,
      sym_keyword_first,
    ACTIONS(19135), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523303] = 3,
    ACTIONS(16224), 1,
      sym_keyword_outer,
    ACTIONS(16226), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523314] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19137), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523323] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19137), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523332] = 3,
    ACTIONS(19139), 1,
      sym_keyword_outer,
    ACTIONS(19141), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523343] = 3,
    ACTIONS(19143), 1,
      sym_keyword_outer,
    ACTIONS(19145), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523354] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19147), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523363] = 3,
    ACTIONS(19149), 1,
      sym_keyword_first,
    ACTIONS(19151), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523374] = 3,
    ACTIONS(16216), 1,
      sym_keyword_outer,
    ACTIONS(16218), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523385] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19153), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523394] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19153), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523403] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17487), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523412] = 3,
    ACTIONS(19155), 1,
      sym_keyword_outer,
    ACTIONS(19157), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523423] = 3,
    ACTIONS(19159), 1,
      sym_keyword_outer,
    ACTIONS(19161), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523434] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9141), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523445] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19163), 2,
      sym_keyword_first,
      sym_keyword_last,
  [523454] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19165), 2,
      sym_keyword_only,
      sym_keyword_write,
  [523463] = 3,
    ACTIONS(16210), 1,
      sym_keyword_outer,
    ACTIONS(16212), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523474] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19167), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523483] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9919), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523494] = 3,
    ACTIONS(19169), 1,
      sym_keyword_as,
    ACTIONS(19171), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523505] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9922), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523516] = 3,
    ACTIONS(19173), 1,
      aux_sym__integer_token1,
    ACTIONS(19175), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523527] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9222), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523538] = 3,
    ACTIONS(19177), 1,
      sym_keyword_update,
    ACTIONS(19179), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523549] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9216), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523560] = 3,
    ACTIONS(19181), 1,
      anon_sym_LPAREN,
    STATE(2102), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523571] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19121), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523580] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19183), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19185), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523598] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19187), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523607] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19189), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523616] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19191), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523625] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19193), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523634] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19195), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523643] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19197), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523652] = 3,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9195), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523663] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17378), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523672] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19199), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523681] = 3,
    ACTIONS(19201), 1,
      anon_sym_SEMI,
    ACTIONS(19203), 1,
      sym_keyword_transaction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523692] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19205), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523701] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9129), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523712] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19207), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523721] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19207), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523730] = 3,
    ACTIONS(19209), 1,
      sym_keyword_first,
    ACTIONS(19211), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523741] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19213), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523750] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19215), 2,
      sym_keyword_first,
      sym_keyword_last,
  [523759] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19217), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523768] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19219), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523777] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(13487), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523788] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19219), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523797] = 3,
    ACTIONS(19221), 1,
      sym_keyword_first,
    ACTIONS(19223), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523808] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19225), 2,
      sym_keyword_first,
      sym_keyword_last,
  [523817] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19227), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523826] = 3,
    ACTIONS(19229), 1,
      sym_keyword_first,
    ACTIONS(19231), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523837] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19233), 2,
      sym_keyword_first,
      sym_keyword_last,
  [523846] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13551), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523855] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19235), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [523864] = 3,
    ACTIONS(19237), 1,
      anon_sym_LBRACK,
    ACTIONS(19239), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523875] = 3,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(19241), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523886] = 3,
    ACTIONS(19243), 1,
      sym_keyword_with,
    ACTIONS(19245), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523897] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19247), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [523906] = 3,
    ACTIONS(19249), 1,
      sym_keyword_then,
    ACTIONS(19251), 1,
      sym_keyword_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523917] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6634), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523928] = 3,
    ACTIONS(19253), 1,
      sym_keyword_update,
    ACTIONS(19255), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523939] = 3,
    ACTIONS(19257), 1,
      sym_keyword_with,
    ACTIONS(19259), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523950] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9051), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523961] = 3,
    ACTIONS(19261), 1,
      sym_keyword_with,
    ACTIONS(19263), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523972] = 3,
    ACTIONS(15793), 1,
      sym_keyword_sequence,
    ACTIONS(16800), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523983] = 3,
    ACTIONS(19265), 1,
      sym_keyword_column,
    ACTIONS(19267), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [523994] = 3,
    ACTIONS(19269), 1,
      sym_keyword_update,
    ACTIONS(19271), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524005] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9090), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524016] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19273), 2,
      sym_keyword_first,
      sym_keyword_last,
  [524025] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19275), 2,
      sym_keyword_committed,
      sym_keyword_uncommitted,
  [524034] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(10137), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524045] = 3,
    ACTIONS(19277), 1,
      sym_keyword_outer,
    ACTIONS(19279), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524056] = 3,
    ACTIONS(19281), 1,
      sym_keyword_column,
    ACTIONS(19283), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524067] = 3,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9042), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524078] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19285), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524087] = 3,
    ACTIONS(19287), 1,
      sym_keyword_no,
    ACTIONS(19289), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524098] = 3,
    ACTIONS(19291), 1,
      sym_keyword_outer,
    ACTIONS(19293), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524109] = 3,
    ACTIONS(1588), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(19295), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524120] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19297), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524129] = 3,
    ACTIONS(18981), 1,
      anon_sym_LPAREN,
    ACTIONS(19299), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524140] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19297), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524149] = 3,
    ACTIONS(18110), 1,
      anon_sym_LPAREN,
    STATE(13349), 1,
      sym_function_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524160] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19301), 2,
      sym_keyword_row,
      sym_keyword_statement,
  [524169] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8987), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524180] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19303), 2,
      sym_keyword_preceding,
      sym_keyword_following,
  [524189] = 3,
    ACTIONS(19305), 1,
      anon_sym_RPAREN,
    ACTIONS(19307), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524200] = 3,
    ACTIONS(19309), 1,
      anon_sym_RPAREN,
    ACTIONS(19311), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524211] = 3,
    ACTIONS(19313), 1,
      anon_sym_RPAREN,
    ACTIONS(19315), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524222] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19317), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524231] = 3,
    ACTIONS(15855), 1,
      sym_keyword_outer,
    ACTIONS(15857), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524242] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8983), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524253] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8980), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524264] = 3,
    ACTIONS(19319), 1,
      sym_keyword_first,
    ACTIONS(19321), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524275] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19323), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524284] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19323), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524293] = 3,
    ACTIONS(19325), 1,
      sym_keyword_as,
    ACTIONS(19327), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524304] = 3,
    ACTIONS(19329), 1,
      anon_sym_SEMI,
    ACTIONS(19331), 1,
      sym_keyword_transaction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18641), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524324] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19333), 2,
      sym_keyword_first,
      sym_keyword_last,
  [524333] = 3,
    ACTIONS(19335), 1,
      sym_keyword_first,
    ACTIONS(19337), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524344] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19339), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524353] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19339), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524362] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18657), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524371] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19341), 2,
      sym_keyword_rename,
      sym_keyword_owner,
  [524380] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19343), 2,
      sym_keyword_first,
      sym_keyword_last,
  [524389] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19345), 2,
      sym_keyword_first,
      sym_keyword_last,
  [524398] = 3,
    ACTIONS(19347), 1,
      aux_sym__integer_token1,
    ACTIONS(19349), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524409] = 3,
    ACTIONS(19351), 1,
      anon_sym_LPAREN,
    STATE(4662), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524420] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19353), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [524429] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9983), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524440] = 3,
    ACTIONS(19355), 1,
      sym_keyword_then,
    ACTIONS(19357), 1,
      sym_keyword_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524451] = 3,
    ACTIONS(19359), 1,
      sym_keyword_on,
    ACTIONS(19361), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524462] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6622), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524473] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(8914), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524484] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18813), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524493] = 3,
    ACTIONS(18969), 1,
      anon_sym_SEMI,
    ACTIONS(19363), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524504] = 3,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524515] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(8898), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524526] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19365), 2,
      sym_keyword_range,
      sym_keyword_hash,
  [524535] = 3,
    ACTIONS(19367), 1,
      sym_keyword_update,
    ACTIONS(19369), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524546] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19371), 2,
      sym_keyword_first,
      sym_keyword_last,
  [524555] = 3,
    ACTIONS(19373), 1,
      sym_keyword_for,
    ACTIONS(19375), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524566] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19377), 2,
      sym_keyword_group,
      sym_keyword_role,
  [524575] = 3,
    ACTIONS(19379), 1,
      anon_sym_LPAREN,
    STATE(8094), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524586] = 3,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(10784), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524597] = 3,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9713), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524608] = 3,
    ACTIONS(19379), 1,
      anon_sym_LPAREN,
    STATE(10827), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524619] = 3,
    ACTIONS(15905), 1,
      sym_keyword_outer,
    ACTIONS(15907), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524630] = 3,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(8827), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524641] = 3,
    ACTIONS(19381), 1,
      sym_keyword_stats,
    ACTIONS(19383), 1,
      sym_keyword_incremental,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524652] = 3,
    ACTIONS(19385), 1,
      sym_keyword_from,
    STATE(9690), 1,
      sym__delete_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524663] = 3,
    ACTIONS(19387), 1,
      sym_keyword_as,
    ACTIONS(19389), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524674] = 3,
    ACTIONS(19391), 1,
      anon_sym_LPAREN,
    STATE(2702), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524685] = 3,
    ACTIONS(19393), 1,
      aux_sym__integer_token1,
    ACTIONS(19395), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524696] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19397), 2,
      sym_keyword_to,
      anon_sym_EQ,
  [524705] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9174), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524716] = 3,
    ACTIONS(19399), 1,
      sym_keyword_update,
    ACTIONS(19401), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524727] = 3,
    ACTIONS(18947), 1,
      anon_sym_LPAREN,
    STATE(8164), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524738] = 3,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(3367), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524749] = 3,
    ACTIONS(18458), 1,
      sym_keyword_isolation,
    STATE(11358), 1,
      sym__transaction_mode,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524760] = 3,
    ACTIONS(18220), 1,
      sym_keyword_isolation,
    STATE(10775), 1,
      sym__transaction_mode,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524771] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19403), 2,
      sym_keyword_to,
      anon_sym_EQ,
  [524780] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19405), 2,
      sym_keyword_to,
      anon_sym_EQ,
  [524789] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16796), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [524798] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(16792), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [524807] = 3,
    ACTIONS(19407), 1,
      sym_keyword_as,
    ACTIONS(19409), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524818] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12343), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524829] = 3,
    ACTIONS(16694), 1,
      sym_keyword_select,
    STATE(10589), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524840] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19411), 2,
      sym_keyword_definer,
      sym_keyword_invoker,
  [524849] = 3,
    ACTIONS(19413), 1,
      anon_sym_LPAREN,
    STATE(6714), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524860] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19415), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524869] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19415), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524878] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19415), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524887] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19415), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [524896] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19417), 2,
      sym_keyword_function,
      sym_keyword_procedure,
  [524905] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19419), 2,
      sym_keyword_old,
      sym_keyword_new,
  [524914] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19421), 2,
      sym_keyword_immediate,
      sym_keyword_deferred,
  [524923] = 3,
    ACTIONS(19423), 1,
      sym_keyword_tablespace,
    ACTIONS(19425), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524934] = 3,
    ACTIONS(19427), 1,
      sym_keyword_value,
    ACTIONS(19429), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524945] = 3,
    ACTIONS(18110), 1,
      anon_sym_LPAREN,
    STATE(12902), 1,
      sym_function_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524956] = 3,
    ACTIONS(19431), 1,
      anon_sym_LPAREN,
    STATE(6726), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524967] = 3,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6692), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524978] = 3,
    ACTIONS(18458), 1,
      sym_keyword_isolation,
    STATE(11302), 1,
      sym__transaction_mode,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [524989] = 3,
    ACTIONS(19433), 1,
      anon_sym_LPAREN,
    STATE(10276), 1,
      sym_enum_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525000] = 3,
    ACTIONS(19435), 1,
      sym_keyword_tablespace,
    ACTIONS(19437), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525011] = 3,
    ACTIONS(19439), 1,
      anon_sym_RPAREN,
    ACTIONS(19441), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525022] = 3,
    ACTIONS(19443), 1,
      anon_sym_RPAREN,
    ACTIONS(19445), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525033] = 3,
    ACTIONS(19447), 1,
      anon_sym_RPAREN,
    ACTIONS(19449), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525044] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19451), 2,
      sym_keyword_rename,
      sym_keyword_owner,
  [525053] = 3,
    ACTIONS(19453), 1,
      sym_keyword_update,
    ACTIONS(19455), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525064] = 3,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6765), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525075] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(9077), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525086] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8737), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525097] = 3,
    ACTIONS(19457), 1,
      sym_keyword_set,
    ACTIONS(19459), 1,
      sym_keyword_reset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525108] = 3,
    ACTIONS(14827), 1,
      sym_keyword_not,
    ACTIONS(19461), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525119] = 3,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(10380), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525130] = 3,
    ACTIONS(19463), 1,
      sym_keyword_set,
    ACTIONS(19465), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525141] = 3,
    ACTIONS(15380), 1,
      anon_sym_LPAREN,
    STATE(7426), 1,
      sym_window_specification,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525152] = 3,
    ACTIONS(19467), 1,
      sym_keyword_first,
    ACTIONS(19469), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525163] = 3,
    ACTIONS(19471), 1,
      sym_keyword_update,
    ACTIONS(19473), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525174] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(8721), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525185] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8988), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525196] = 3,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6701), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525207] = 3,
    ACTIONS(19475), 1,
      sym_keyword_first,
    ACTIONS(19477), 1,
      sym_keyword_last,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525218] = 3,
    ACTIONS(19479), 1,
      sym_keyword_not,
    ACTIONS(19481), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525229] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10452), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525240] = 3,
    ACTIONS(19483), 1,
      sym_keyword_no,
    ACTIONS(19485), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525251] = 3,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13301), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525262] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8974), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525273] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19487), 2,
      sym_keyword_first,
      sym_keyword_last,
  [525282] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13559), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [525291] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19489), 2,
      sym_keyword_definer,
      sym_keyword_invoker,
  [525300] = 3,
    ACTIONS(16948), 1,
      anon_sym_LPAREN,
    STATE(6471), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525311] = 3,
    ACTIONS(19491), 1,
      anon_sym_RPAREN,
    ACTIONS(19493), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525322] = 3,
    ACTIONS(14893), 1,
      sym_keyword_not,
    ACTIONS(19495), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525333] = 3,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(10012), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525344] = 3,
    ACTIONS(19497), 1,
      anon_sym_RPAREN,
    ACTIONS(19499), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525355] = 3,
    ACTIONS(19501), 1,
      anon_sym_RPAREN,
    ACTIONS(19503), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525366] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19505), 2,
      sym_keyword_first,
      sym_keyword_last,
  [525375] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(13510), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [525384] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19507), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [525393] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8924), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525404] = 3,
    ACTIONS(19509), 1,
      sym_keyword_update,
    ACTIONS(19511), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525415] = 3,
    ACTIONS(19513), 1,
      sym_keyword_update,
    ACTIONS(19515), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525426] = 3,
    ACTIONS(19517), 1,
      sym_keyword_as,
    ACTIONS(19519), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525437] = 3,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6723), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525448] = 3,
    ACTIONS(19521), 1,
      sym_keyword_not,
    ACTIONS(19523), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525459] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10634), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525470] = 3,
    ACTIONS(19525), 1,
      sym_keyword_no,
    ACTIONS(19527), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525481] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8905), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525492] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8896), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525503] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8895), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525514] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19529), 2,
      sym_keyword_definer,
      sym_keyword_invoker,
  [525523] = 3,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(9829), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525534] = 3,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(10720), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525545] = 3,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(13675), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525556] = 3,
    ACTIONS(19531), 1,
      aux_sym__integer_token1,
    ACTIONS(19533), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525567] = 3,
    ACTIONS(19535), 1,
      anon_sym_LPAREN,
    STATE(5676), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525578] = 3,
    ACTIONS(19537), 1,
      sym_keyword_no,
    ACTIONS(19539), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19541), 2,
      sym_keyword_first,
      sym_keyword_last,
  [525598] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8967), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525609] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8877), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525620] = 3,
    ACTIONS(19543), 1,
      sym_keyword_update,
    ACTIONS(19545), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525631] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8875), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525642] = 3,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6757), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525653] = 3,
    ACTIONS(19547), 1,
      sym_keyword_then,
    ACTIONS(19549), 1,
      sym_keyword_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525664] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9585), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525675] = 3,
    ACTIONS(19551), 1,
      sym_keyword_update,
    ACTIONS(19553), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525686] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9563), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525697] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(13667), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525708] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9531), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525719] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8852), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525730] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9454), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525741] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8851), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525752] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8844), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525763] = 3,
    ACTIONS(1592), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(19555), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525774] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9771), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525785] = 3,
    ACTIONS(19081), 1,
      sym_keyword_nothing,
    ACTIONS(19557), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525796] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9610), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525807] = 3,
    ACTIONS(19559), 1,
      sym_keyword_no,
    ACTIONS(19561), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525818] = 3,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(9719), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525829] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9922), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525840] = 3,
    ACTIONS(19179), 1,
      sym_keyword_nothing,
    ACTIONS(19563), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18360), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [525860] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19565), 2,
      sym_keyword_first,
      sym_keyword_last,
  [525869] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8823), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525880] = 3,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13335), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525891] = 3,
    ACTIONS(19567), 1,
      sym_keyword_update,
    ACTIONS(19569), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525902] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19571), 2,
      sym_keyword_only,
      sym_keyword_write,
  [525911] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8818), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525922] = 3,
    ACTIONS(19255), 1,
      sym_keyword_nothing,
    ACTIONS(19573), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525933] = 3,
    ACTIONS(19271), 1,
      sym_keyword_nothing,
    ACTIONS(19575), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525944] = 3,
    ACTIONS(19577), 1,
      sym_keyword_update,
    ACTIONS(19579), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525955] = 3,
    ACTIONS(11178), 1,
      anon_sym_LPAREN,
    STATE(6774), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525966] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9987), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525977] = 3,
    ACTIONS(19581), 1,
      sym_keyword_then,
    ACTIONS(19583), 1,
      sym_keyword_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525988] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10886), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [525999] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8803), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526010] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8751), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526021] = 3,
    ACTIONS(16694), 1,
      sym_keyword_select,
    STATE(10267), 1,
      sym_select,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526032] = 3,
    ACTIONS(13908), 1,
      anon_sym_LPAREN,
    STATE(9658), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526043] = 3,
    ACTIONS(19585), 1,
      sym_keyword_not,
    ACTIONS(19587), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526054] = 3,
    ACTIONS(19401), 1,
      sym_keyword_nothing,
    ACTIONS(19589), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526065] = 3,
    ACTIONS(19369), 1,
      sym_keyword_nothing,
    ACTIONS(19591), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526076] = 3,
    ACTIONS(16948), 1,
      anon_sym_LPAREN,
    STATE(6434), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526087] = 3,
    ACTIONS(19593), 1,
      sym_keyword_as,
    ACTIONS(19595), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526098] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8792), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526109] = 3,
    ACTIONS(19597), 1,
      sym_keyword_update,
    ACTIONS(19599), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526120] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8787), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526131] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(10941), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526142] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10948), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526153] = 3,
    ACTIONS(17414), 1,
      anon_sym_LPAREN,
    STATE(8780), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526164] = 3,
    ACTIONS(19601), 1,
      sym_keyword_matched,
    ACTIONS(19603), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526175] = 3,
    ACTIONS(19605), 1,
      anon_sym_SEMI,
    ACTIONS(19607), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526186] = 3,
    ACTIONS(19609), 1,
      anon_sym_LPAREN,
    STATE(4412), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526197] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8770), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526208] = 3,
    ACTIONS(19611), 1,
      sym_keyword_update,
    ACTIONS(19613), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526219] = 3,
    ACTIONS(19615), 1,
      anon_sym_RPAREN,
    ACTIONS(19617), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526230] = 3,
    ACTIONS(19619), 1,
      anon_sym_RPAREN,
    ACTIONS(19621), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526241] = 3,
    ACTIONS(19623), 1,
      anon_sym_RPAREN,
    ACTIONS(19625), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526252] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(10980), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526263] = 3,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(13966), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526274] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10981), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526285] = 3,
    ACTIONS(15292), 1,
      anon_sym_LPAREN,
    STATE(7406), 1,
      sym_window_specification,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526296] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6627), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526307] = 3,
    ACTIONS(19627), 1,
      sym_keyword_matched,
    ACTIONS(19629), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526318] = 3,
    ACTIONS(19631), 1,
      sym_keyword_update,
    ACTIONS(19633), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526329] = 3,
    ACTIONS(19635), 1,
      sym_keyword_update,
    ACTIONS(19637), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526340] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(8750), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526351] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(10789), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526362] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(11020), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526373] = 3,
    ACTIONS(19639), 1,
      anon_sym_SEMI,
    ACTIONS(19641), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526384] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19643), 2,
      sym_keyword_default,
      sym_keyword_null,
  [526393] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(11040), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526404] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(11048), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526415] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9886), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526426] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(11059), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526437] = 3,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13333), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526448] = 3,
    ACTIONS(19633), 1,
      sym_keyword_nothing,
    ACTIONS(19645), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526459] = 3,
    ACTIONS(16504), 1,
      sym_keyword_check,
    STATE(11069), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526470] = 3,
    ACTIONS(19647), 1,
      sym_keyword_with,
    ACTIONS(19649), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526481] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(11102), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526492] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19651), 2,
      sym_keyword_only,
      sym_keyword_write,
  [526501] = 3,
    ACTIONS(19637), 1,
      sym_keyword_nothing,
    ACTIONS(19653), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526512] = 3,
    ACTIONS(19655), 1,
      sym_keyword_with,
    ACTIONS(19657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526523] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19659), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [526532] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9849), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526543] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(8699), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526554] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19661), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [526563] = 3,
    ACTIONS(19663), 1,
      aux_sym__integer_token1,
    ACTIONS(19665), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526574] = 3,
    ACTIONS(19667), 1,
      sym_keyword_update,
    ACTIONS(19669), 1,
      sym_keyword_nothing,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526585] = 3,
    ACTIONS(2959), 1,
      aux_sym__single_quote_string_token1,
    STATE(3876), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526596] = 3,
    ACTIONS(12528), 1,
      sym_keyword_set,
    STATE(11011), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526607] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9836), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526618] = 3,
    ACTIONS(19671), 1,
      sym_keyword_with,
    ACTIONS(19673), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526629] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(7270), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526640] = 3,
    ACTIONS(19675), 1,
      anon_sym_LPAREN,
    STATE(3471), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526651] = 3,
    ACTIONS(19677), 1,
      sym_keyword_as,
    ACTIONS(19679), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526662] = 3,
    ACTIONS(18935), 1,
      sym_keyword_nothing,
    ACTIONS(19681), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526673] = 3,
    ACTIONS(19683), 1,
      aux_sym__integer_token1,
    ACTIONS(19685), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526684] = 3,
    ACTIONS(19687), 1,
      anon_sym_LPAREN,
    STATE(6811), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526695] = 3,
    ACTIONS(19689), 1,
      sym_keyword_distinct,
    ACTIONS(19691), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526706] = 3,
    ACTIONS(19693), 1,
      sym_keyword_with,
    ACTIONS(19695), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526717] = 3,
    ACTIONS(19697), 1,
      sym_keyword_with,
    ACTIONS(19699), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526728] = 3,
    ACTIONS(19701), 1,
      anon_sym_LPAREN,
    STATE(6807), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526739] = 3,
    ACTIONS(19703), 1,
      anon_sym_RPAREN,
    ACTIONS(19705), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526750] = 3,
    ACTIONS(19707), 1,
      anon_sym_RPAREN,
    ACTIONS(19709), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526761] = 3,
    ACTIONS(19711), 1,
      anon_sym_RPAREN,
    ACTIONS(19713), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526772] = 3,
    ACTIONS(18110), 1,
      anon_sym_LPAREN,
    STATE(13607), 1,
      sym_function_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526783] = 3,
    ACTIONS(19715), 1,
      anon_sym_LPAREN,
    STATE(8641), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526794] = 3,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(11029), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526805] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18573), 2,
      sym_keyword_true,
      sym_keyword_false,
  [526814] = 3,
    ACTIONS(19379), 1,
      anon_sym_LPAREN,
    STATE(7948), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526825] = 3,
    ACTIONS(19717), 1,
      sym_keyword_for,
    ACTIONS(19719), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526836] = 3,
    ACTIONS(11652), 1,
      aux_sym__single_quote_string_token1,
    STATE(7252), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526847] = 3,
    ACTIONS(19721), 1,
      sym_keyword_distinct,
    ACTIONS(19723), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526858] = 3,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(8762), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526869] = 3,
    ACTIONS(18971), 1,
      sym_keyword_from,
    STATE(11047), 1,
      sym__delete_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526880] = 3,
    ACTIONS(19725), 1,
      anon_sym_LPAREN,
    STATE(3986), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526891] = 3,
    ACTIONS(19727), 1,
      sym_keyword_table,
    ACTIONS(19729), 1,
      sym_keyword_tables,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526902] = 3,
    ACTIONS(19731), 1,
      aux_sym__integer_token1,
    ACTIONS(19733), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526913] = 3,
    ACTIONS(19735), 1,
      sym_keyword_outer,
    ACTIONS(19737), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526924] = 3,
    ACTIONS(19739), 1,
      anon_sym_LPAREN,
    ACTIONS(19741), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526935] = 3,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    ACTIONS(19743), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526946] = 3,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(19745), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526957] = 3,
    ACTIONS(14690), 1,
      sym_keyword_not,
    ACTIONS(19747), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526968] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9778), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526979] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19749), 2,
      sym_keyword_range,
      sym_keyword_hash,
  [526988] = 3,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(14094), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [526999] = 3,
    ACTIONS(19745), 1,
      anon_sym_LPAREN,
    ACTIONS(19751), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527010] = 3,
    ACTIONS(19753), 1,
      sym_keyword_as,
    ACTIONS(19755), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527021] = 3,
    ACTIONS(19757), 1,
      sym_keyword_matched,
    ACTIONS(19759), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527032] = 3,
    ACTIONS(19761), 1,
      anon_sym_LPAREN,
    ACTIONS(19763), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527043] = 3,
    ACTIONS(16948), 1,
      anon_sym_LPAREN,
    STATE(6443), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527054] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(14340), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527065] = 3,
    ACTIONS(19765), 1,
      anon_sym_RPAREN,
    ACTIONS(19767), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527076] = 3,
    ACTIONS(19769), 1,
      anon_sym_RPAREN,
    ACTIONS(19771), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527087] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9767), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527098] = 3,
    ACTIONS(19773), 1,
      anon_sym_RPAREN,
    ACTIONS(19775), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19777), 2,
      sym_keyword_group,
      sym_keyword_role,
  [527118] = 3,
    ACTIONS(19779), 1,
      anon_sym_LPAREN,
    ACTIONS(19781), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527129] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9764), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527140] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9763), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527151] = 3,
    ACTIONS(19783), 1,
      anon_sym_LBRACK,
    ACTIONS(19785), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527162] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(14550), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527173] = 3,
    ACTIONS(19787), 1,
      sym_keyword_as,
    ACTIONS(19789), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527184] = 3,
    ACTIONS(19791), 1,
      anon_sym_LPAREN,
    ACTIONS(19793), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527195] = 3,
    ACTIONS(19795), 1,
      anon_sym_LBRACK,
    ACTIONS(19797), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527206] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(14495), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527217] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19799), 2,
      sym_keyword_definer,
      sym_keyword_invoker,
  [527226] = 3,
    ACTIONS(19801), 1,
      anon_sym_LPAREN,
    ACTIONS(19803), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527237] = 3,
    ACTIONS(19805), 1,
      anon_sym_LBRACK,
    ACTIONS(19807), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527248] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(14059), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19809), 2,
      sym_keyword_is,
      sym_keyword_returns,
  [527268] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18032), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [527277] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19811), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [527286] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19811), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [527295] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(18027), 2,
      sym_keyword_on,
      sym_keyword_or,
  [527304] = 3,
    ACTIONS(19813), 1,
      anon_sym_RPAREN,
    ACTIONS(19815), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527315] = 3,
    ACTIONS(19817), 1,
      anon_sym_RPAREN,
    ACTIONS(19819), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527326] = 3,
    ACTIONS(19821), 1,
      anon_sym_RPAREN,
    ACTIONS(19823), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527337] = 3,
    ACTIONS(19825), 1,
      anon_sym_LPAREN,
    STATE(6385), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527348] = 3,
    ACTIONS(19827), 1,
      aux_sym__integer_token1,
    ACTIONS(19829), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527359] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19831), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [527368] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9073), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527379] = 3,
    ACTIONS(19833), 1,
      anon_sym_LPAREN,
    ACTIONS(19835), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527390] = 3,
    ACTIONS(19837), 1,
      anon_sym_LBRACK,
    ACTIONS(19839), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527401] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(13787), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527412] = 3,
    ACTIONS(19841), 1,
      anon_sym_RPAREN,
    ACTIONS(19843), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527423] = 3,
    ACTIONS(19845), 1,
      anon_sym_RPAREN,
    ACTIONS(19847), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527434] = 3,
    ACTIONS(19849), 1,
      anon_sym_RPAREN,
    ACTIONS(19851), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527445] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9686), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527456] = 3,
    ACTIONS(18110), 1,
      anon_sym_LPAREN,
    STATE(12107), 1,
      sym_function_arguments,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527467] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9661), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527478] = 3,
    ACTIONS(19361), 1,
      sym_keyword_using,
    ACTIONS(19853), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527489] = 3,
    ACTIONS(19855), 1,
      sym_keyword_then,
    ACTIONS(19857), 1,
      sym_keyword_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527500] = 3,
    ACTIONS(19801), 1,
      anon_sym_LPAREN,
    ACTIONS(19859), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527511] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19861), 2,
      sym_keyword_is,
      sym_keyword_returns,
  [527520] = 3,
    ACTIONS(19863), 1,
      anon_sym_LBRACK,
    ACTIONS(19865), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527531] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(13524), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527542] = 3,
    ACTIONS(19867), 1,
      anon_sym_LPAREN,
    ACTIONS(19869), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527553] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9631), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527564] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9628), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527575] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9626), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527586] = 3,
    ACTIONS(16948), 1,
      anon_sym_LPAREN,
    STATE(6470), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527597] = 3,
    ACTIONS(19871), 1,
      anon_sym_LBRACK,
    ACTIONS(19873), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527608] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19875), 2,
      sym_keyword_first,
      sym_keyword_last,
  [527617] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(13291), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527628] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19877), 2,
      sym_keyword_first,
      sym_keyword_last,
  [527637] = 3,
    ACTIONS(19879), 1,
      sym_keyword_as,
    ACTIONS(19881), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527648] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9220), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527659] = 3,
    ACTIONS(19883), 1,
      sym_keyword_no,
    ACTIONS(19885), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527670] = 3,
    ACTIONS(19887), 1,
      anon_sym_LPAREN,
    STATE(4409), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527681] = 3,
    ACTIONS(19889), 1,
      aux_sym__integer_token1,
    ACTIONS(19891), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527692] = 3,
    ACTIONS(19893), 1,
      aux_sym__integer_token1,
    ACTIONS(19895), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527703] = 3,
    ACTIONS(19897), 1,
      sym_keyword_set,
    ACTIONS(19899), 1,
      sym_keyword_reset,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527714] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9584), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527725] = 3,
    ACTIONS(9500), 1,
      anon_sym_LPAREN,
    ACTIONS(19901), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527736] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9580), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527747] = 3,
    ACTIONS(19903), 1,
      anon_sym_LPAREN,
    STATE(4908), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527758] = 3,
    ACTIONS(19905), 1,
      sym_keyword_then,
    ACTIONS(19907), 1,
      sym_keyword_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527769] = 3,
    ACTIONS(14660), 1,
      sym_keyword_not,
    ACTIONS(19909), 1,
      sym_keyword_default,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527780] = 3,
    ACTIONS(19911), 1,
      anon_sym_LBRACK,
    ACTIONS(19913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527791] = 3,
    ACTIONS(16500), 1,
      sym_keyword_check,
    STATE(9776), 1,
      sym__check_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527802] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9551), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527813] = 3,
    ACTIONS(19915), 1,
      sym_keyword_tablespace,
    ACTIONS(19917), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527824] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9548), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527835] = 3,
    ACTIONS(19919), 1,
      sym_keyword_column,
    ACTIONS(19921), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527846] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12505), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527857] = 3,
    ACTIONS(19923), 1,
      sym_keyword_value,
    ACTIONS(19925), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527868] = 3,
    ACTIONS(17338), 1,
      anon_sym_DOT,
    ACTIONS(19927), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527879] = 3,
    ACTIONS(19929), 1,
      anon_sym_LBRACK,
    ACTIONS(19931), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527890] = 3,
    ACTIONS(19933), 1,
      anon_sym_RPAREN,
    ACTIONS(19935), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527901] = 3,
    ACTIONS(19937), 1,
      anon_sym_RPAREN,
    ACTIONS(19939), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527912] = 3,
    ACTIONS(19941), 1,
      anon_sym_RPAREN,
    ACTIONS(19943), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527923] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9525), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527934] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12106), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527945] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9508), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527956] = 3,
    ACTIONS(19945), 1,
      anon_sym_LPAREN,
    ACTIONS(19947), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527967] = 3,
    ACTIONS(19949), 1,
      anon_sym_LBRACK,
    ACTIONS(19951), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527978] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12083), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [527989] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19953), 2,
      sym_keyword_only,
      sym_keyword_write,
  [527998] = 3,
    ACTIONS(17524), 1,
      anon_sym_LPAREN,
    STATE(9462), 1,
      sym_index_fields,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528009] = 3,
    ACTIONS(19955), 1,
      sym_keyword_not,
    ACTIONS(19957), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528020] = 3,
    ACTIONS(19927), 1,
      anon_sym_LPAREN,
    ACTIONS(19959), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528031] = 3,
    ACTIONS(19961), 1,
      anon_sym_LBRACK,
    ACTIONS(19963), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528042] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19965), 2,
      sym_keyword_delete,
      sym_keyword_update,
  [528051] = 3,
    ACTIONS(19967), 1,
      sym_keyword_on,
    ACTIONS(19969), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528062] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9438), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528073] = 3,
    ACTIONS(13867), 1,
      sym_keyword_using,
    ACTIONS(13934), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528084] = 3,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13210), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528095] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6629), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528106] = 3,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(13208), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528117] = 3,
    ACTIONS(12466), 1,
      sym_keyword_set,
    STATE(9433), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528128] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19971), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [528137] = 3,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(13190), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528148] = 3,
    ACTIONS(12510), 1,
      sym_keyword_set,
    STATE(9456), 1,
      sym__set_values,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528159] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17534), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [528168] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12254), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528179] = 3,
    ACTIONS(19973), 1,
      anon_sym_LPAREN,
    STATE(884), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528190] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(19975), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [528199] = 3,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(13188), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528210] = 3,
    ACTIONS(19977), 1,
      aux_sym__integer_token1,
    ACTIONS(19979), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528221] = 3,
    ACTIONS(19669), 1,
      sym_keyword_nothing,
    ACTIONS(19981), 1,
      sym_keyword_update,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528232] = 3,
    ACTIONS(19983), 1,
      anon_sym_LPAREN,
    ACTIONS(19985), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528243] = 3,
    ACTIONS(19987), 1,
      anon_sym_LBRACK,
    ACTIONS(19989), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528254] = 3,
    ACTIONS(19969), 1,
      sym_keyword_using,
    ACTIONS(19991), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528265] = 3,
    ACTIONS(13867), 1,
      sym_keyword_using,
    ACTIONS(13900), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528276] = 3,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(13128), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528287] = 3,
    ACTIONS(19993), 1,
      anon_sym_RPAREN,
    ACTIONS(19995), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528298] = 3,
    ACTIONS(19997), 1,
      anon_sym_RPAREN,
    ACTIONS(19999), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528309] = 3,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(12040), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528320] = 3,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(13126), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528331] = 3,
    ACTIONS(20001), 1,
      anon_sym_RPAREN,
    ACTIONS(20003), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528342] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12450), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528353] = 3,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(13124), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528364] = 3,
    ACTIONS(20005), 1,
      anon_sym_LPAREN,
    ACTIONS(20007), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528375] = 3,
    ACTIONS(20009), 1,
      anon_sym_LBRACK,
    ACTIONS(20011), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528386] = 3,
    ACTIONS(19969), 1,
      sym_keyword_using,
    ACTIONS(20013), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528397] = 3,
    ACTIONS(13865), 1,
      sym_keyword_on,
    ACTIONS(13867), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528408] = 3,
    ACTIONS(13118), 1,
      sym_keyword_on,
    ACTIONS(13120), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528419] = 3,
    ACTIONS(13114), 1,
      sym_keyword_on,
    ACTIONS(13116), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528430] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12547), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528441] = 3,
    ACTIONS(20015), 1,
      sym_keyword_outer,
    ACTIONS(20017), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528452] = 3,
    ACTIONS(20019), 1,
      sym_keyword_column,
    ACTIONS(20021), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528463] = 3,
    ACTIONS(20023), 1,
      sym_keyword_tablespace,
    ACTIONS(20025), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528474] = 3,
    ACTIONS(13110), 1,
      sym_keyword_on,
    ACTIONS(13112), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528485] = 3,
    ACTIONS(20027), 1,
      anon_sym_LPAREN,
    ACTIONS(20029), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528496] = 3,
    ACTIONS(20031), 1,
      anon_sym_LBRACK,
    ACTIONS(20033), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528507] = 3,
    ACTIONS(19361), 1,
      sym_keyword_using,
    ACTIONS(20035), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528518] = 3,
    ACTIONS(20037), 1,
      anon_sym_RPAREN,
    ACTIONS(20039), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528529] = 3,
    ACTIONS(20041), 1,
      anon_sym_RPAREN,
    ACTIONS(20043), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528540] = 3,
    ACTIONS(20045), 1,
      anon_sym_RPAREN,
    ACTIONS(20047), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528551] = 3,
    ACTIONS(13922), 1,
      sym_keyword_on,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528562] = 3,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13096), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528573] = 3,
    ACTIONS(20049), 1,
      anon_sym_LPAREN,
    STATE(5982), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528584] = 3,
    ACTIONS(20051), 1,
      aux_sym__integer_token1,
    ACTIONS(20053), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528595] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(20055), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [528604] = 3,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13094), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528615] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(12845), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528626] = 3,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13092), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528637] = 3,
    ACTIONS(20057), 1,
      anon_sym_RPAREN,
    ACTIONS(20059), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528648] = 3,
    ACTIONS(20061), 1,
      anon_sym_RPAREN,
    ACTIONS(20063), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528659] = 3,
    ACTIONS(20065), 1,
      anon_sym_RPAREN,
    ACTIONS(20067), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528670] = 3,
    ACTIONS(20069), 1,
      anon_sym_LPAREN,
    ACTIONS(20071), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528681] = 3,
    ACTIONS(19801), 1,
      anon_sym_LPAREN,
    ACTIONS(20073), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528692] = 3,
    ACTIONS(20075), 1,
      anon_sym_LBRACK,
    ACTIONS(20077), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528703] = 3,
    ACTIONS(19361), 1,
      sym_keyword_using,
    ACTIONS(20079), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528714] = 3,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(13954), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528725] = 3,
    ACTIONS(13960), 1,
      anon_sym_LPAREN,
    STATE(9725), 1,
      sym_ordered_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528736] = 3,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(13088), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528747] = 3,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(13076), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528758] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(13072), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528769] = 3,
    ACTIONS(20081), 1,
      aux_sym__integer_token1,
    ACTIONS(20083), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528780] = 3,
    ACTIONS(20085), 1,
      anon_sym_LPAREN,
    STATE(4627), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528791] = 3,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13074), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528802] = 3,
    ACTIONS(20027), 1,
      anon_sym_LPAREN,
    ACTIONS(20087), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528813] = 3,
    ACTIONS(19833), 1,
      anon_sym_LPAREN,
    ACTIONS(20089), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528824] = 3,
    ACTIONS(20091), 1,
      anon_sym_LBRACK,
    ACTIONS(20093), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528835] = 3,
    ACTIONS(19361), 1,
      sym_keyword_using,
    ACTIONS(20095), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528846] = 3,
    ACTIONS(15320), 1,
      anon_sym_LPAREN,
    STATE(7406), 1,
      sym_window_specification,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528857] = 3,
    ACTIONS(13924), 1,
      sym_keyword_using,
    ACTIONS(13991), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528868] = 3,
    ACTIONS(13064), 1,
      sym_keyword_on,
    ACTIONS(13066), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528879] = 3,
    ACTIONS(13028), 1,
      sym_keyword_on,
    ACTIONS(13030), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528890] = 3,
    ACTIONS(14750), 1,
      sym_keyword_where,
    STATE(13337), 1,
      sym_where,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528901] = 3,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(13036), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528912] = 3,
    ACTIONS(14220), 1,
      anon_sym_LPAREN,
    STATE(2436), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528923] = 3,
    ACTIONS(20097), 1,
      sym_keyword_with,
    ACTIONS(20099), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528934] = 3,
    ACTIONS(20101), 1,
      aux_sym__integer_token1,
    ACTIONS(20103), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528945] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(20105), 2,
      sym_keyword_range,
      sym_keyword_hash,
  [528954] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(17480), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [528963] = 3,
    ACTIONS(19379), 1,
      anon_sym_LPAREN,
    STATE(8157), 1,
      sym_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528974] = 3,
    ACTIONS(17334), 1,
      anon_sym_LPAREN,
    ACTIONS(20107), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528985] = 3,
    ACTIONS(20027), 1,
      anon_sym_LPAREN,
    ACTIONS(20109), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [528996] = 3,
    ACTIONS(20111), 1,
      anon_sym_LBRACK,
    ACTIONS(20113), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529007] = 3,
    ACTIONS(20115), 1,
      anon_sym_LPAREN,
    STATE(8663), 1,
      sym_column_definitions,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529018] = 3,
    ACTIONS(20117), 1,
      anon_sym_RPAREN,
    ACTIONS(20119), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529029] = 3,
    ACTIONS(20121), 1,
      anon_sym_RPAREN,
    ACTIONS(20123), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529040] = 3,
    ACTIONS(20125), 1,
      anon_sym_RPAREN,
    ACTIONS(20127), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529051] = 3,
    ACTIONS(10898), 1,
      anon_sym_LPAREN,
    STATE(6620), 1,
      sym__column_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529062] = 3,
    ACTIONS(13019), 1,
      sym_keyword_on,
    ACTIONS(13021), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529073] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(20129), 2,
      sym_keyword_committed,
      sym_keyword_uncommitted,
  [529082] = 3,
    ACTIONS(18220), 1,
      sym_keyword_isolation,
    STATE(11099), 1,
      sym__transaction_mode,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529093] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(20131), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [529102] = 3,
    ACTIONS(20133), 1,
      anon_sym_LPAREN,
    STATE(4313), 1,
      sym_subquery,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529113] = 3,
    ACTIONS(20135), 1,
      aux_sym__integer_token1,
    ACTIONS(20137), 1,
      aux_sym__decimal_number_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529124] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
    ACTIONS(20139), 2,
      sym_keyword_is,
      sym_keyword_returns,
  [529133] = 3,
    ACTIONS(2911), 1,
      aux_sym__single_quote_string_token1,
    STATE(9364), 1,
      sym__single_quote_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529144] = 3,
    ACTIONS(20141), 1,
      anon_sym_LPAREN,
    STATE(9681), 1,
      sym_enum_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529155] = 3,
    ACTIONS(20143), 1,
      sym_keyword_set,
    ACTIONS(20145), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529166] = 3,
    ACTIONS(20147), 1,
      anon_sym_RPAREN,
    ACTIONS(20149), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529177] = 3,
    ACTIONS(20151), 1,
      anon_sym_RPAREN,
    ACTIONS(20153), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529188] = 3,
    ACTIONS(20155), 1,
      sym_keyword_as,
    ACTIONS(20157), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529199] = 2,
    ACTIONS(20159), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529207] = 2,
    ACTIONS(20161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529215] = 2,
    ACTIONS(20163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529223] = 2,
    ACTIONS(20165), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529231] = 2,
    ACTIONS(20167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529239] = 2,
    ACTIONS(20169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529247] = 2,
    ACTIONS(20171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529255] = 2,
    ACTIONS(20173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529263] = 2,
    ACTIONS(20175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529271] = 2,
    ACTIONS(20177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529279] = 2,
    ACTIONS(20179), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529287] = 2,
    ACTIONS(20181), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529295] = 2,
    ACTIONS(16080), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529303] = 2,
    ACTIONS(20183), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529311] = 2,
    ACTIONS(15206), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529319] = 2,
    ACTIONS(20185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529327] = 2,
    ACTIONS(20187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529335] = 2,
    ACTIONS(14784), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529343] = 2,
    ACTIONS(20189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529351] = 2,
    ACTIONS(20191), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529359] = 2,
    ACTIONS(15226), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529367] = 2,
    ACTIONS(20193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529375] = 2,
    ACTIONS(16102), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529383] = 2,
    ACTIONS(9538), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529391] = 2,
    ACTIONS(14764), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529399] = 2,
    ACTIONS(20195), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529407] = 2,
    ACTIONS(20197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529415] = 2,
    ACTIONS(20199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529423] = 2,
    ACTIONS(20201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529431] = 2,
    ACTIONS(20203), 1,
      sym_keyword_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529439] = 2,
    ACTIONS(20205), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529447] = 2,
    ACTIONS(17622), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529455] = 2,
    ACTIONS(20207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529463] = 2,
    ACTIONS(20209), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529471] = 2,
    ACTIONS(20211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529479] = 2,
    ACTIONS(20213), 1,
      sym_keyword_materialized,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529487] = 2,
    ACTIONS(20215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529495] = 2,
    ACTIONS(20217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529503] = 2,
    ACTIONS(20219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529511] = 2,
    ACTIONS(20221), 1,
      sym_keyword_maxvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529519] = 2,
    ACTIONS(20223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529527] = 2,
    ACTIONS(20221), 1,
      sym_keyword_minvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529535] = 2,
    ACTIONS(20225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529543] = 2,
    ACTIONS(20227), 1,
      aux_sym__integer_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529551] = 2,
    ACTIONS(20229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529559] = 2,
    ACTIONS(20231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529567] = 2,
    ACTIONS(20233), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529575] = 2,
    ACTIONS(20235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529583] = 2,
    ACTIONS(20155), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529591] = 2,
    ACTIONS(20237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529599] = 2,
    ACTIONS(20239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529607] = 2,
    ACTIONS(20241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529615] = 2,
    ACTIONS(20243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529623] = 2,
    ACTIONS(20245), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529631] = 2,
    ACTIONS(20247), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529639] = 2,
    ACTIONS(20249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529647] = 2,
    ACTIONS(20251), 1,
      sym_keyword_delimited,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529655] = 2,
    ACTIONS(20253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529663] = 2,
    ACTIONS(20255), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529671] = 2,
    ACTIONS(20257), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529679] = 2,
    ACTIONS(20259), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529687] = 2,
    ACTIONS(20261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529695] = 2,
    ACTIONS(20263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529703] = 2,
    ACTIONS(20265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529711] = 2,
    ACTIONS(20267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529719] = 2,
    ACTIONS(20269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529727] = 2,
    ACTIONS(20271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529735] = 2,
    ACTIONS(20273), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529743] = 2,
    ACTIONS(20275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529751] = 2,
    ACTIONS(20277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529759] = 2,
    ACTIONS(20279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529767] = 2,
    ACTIONS(20281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529775] = 2,
    ACTIONS(20283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529783] = 2,
    ACTIONS(20285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529791] = 2,
    ACTIONS(20129), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529799] = 2,
    ACTIONS(20287), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529807] = 2,
    ACTIONS(20289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529815] = 2,
    ACTIONS(20291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529823] = 2,
    ACTIONS(20293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529831] = 2,
    ACTIONS(20295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529839] = 2,
    ACTIONS(20297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529847] = 2,
    ACTIONS(20299), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529855] = 2,
    ACTIONS(20301), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529863] = 2,
    ACTIONS(16068), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529871] = 2,
    ACTIONS(20303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529879] = 2,
    ACTIONS(20305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529887] = 2,
    ACTIONS(20307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529895] = 2,
    ACTIONS(20309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529903] = 2,
    ACTIONS(20311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529911] = 2,
    ACTIONS(20313), 1,
      sym_keyword_returns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529919] = 2,
    ACTIONS(20315), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529927] = 2,
    ACTIONS(20317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529935] = 2,
    ACTIONS(20319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529943] = 2,
    ACTIONS(20321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529951] = 2,
    ACTIONS(20323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529959] = 2,
    ACTIONS(20325), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529967] = 2,
    ACTIONS(16140), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529975] = 2,
    ACTIONS(20327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529983] = 2,
    ACTIONS(20329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529991] = 2,
    ACTIONS(15671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [529999] = 2,
    ACTIONS(20331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530007] = 2,
    ACTIONS(20333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530015] = 2,
    ACTIONS(20335), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530023] = 2,
    ACTIONS(20337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530031] = 2,
    ACTIONS(20339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530039] = 2,
    ACTIONS(20341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530047] = 2,
    ACTIONS(14627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530055] = 2,
    ACTIONS(15627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530063] = 2,
    ACTIONS(20343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530071] = 2,
    ACTIONS(20345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530079] = 2,
    ACTIONS(20347), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530087] = 2,
    ACTIONS(20349), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530095] = 2,
    ACTIONS(20351), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530103] = 2,
    ACTIONS(9574), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530111] = 2,
    ACTIONS(20353), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530119] = 2,
    ACTIONS(20355), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530127] = 2,
    ACTIONS(20357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530135] = 2,
    ACTIONS(20359), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530143] = 2,
    ACTIONS(20361), 1,
      sym_keyword_password,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530151] = 2,
    ACTIONS(20363), 1,
      sym_keyword_until,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530159] = 2,
    ACTIONS(20365), 1,
      sym_keyword_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530167] = 2,
    ACTIONS(20367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530175] = 2,
    ACTIONS(20369), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530183] = 2,
    ACTIONS(20371), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530191] = 2,
    ACTIONS(20373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530199] = 2,
    ACTIONS(20375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530207] = 2,
    ACTIONS(20377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530215] = 2,
    ACTIONS(20379), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530223] = 2,
    ACTIONS(20381), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530231] = 2,
    ACTIONS(20383), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530239] = 2,
    ACTIONS(20385), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530247] = 2,
    ACTIONS(20387), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530255] = 2,
    ACTIONS(20389), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530263] = 2,
    ACTIONS(20391), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530271] = 2,
    ACTIONS(20393), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530279] = 2,
    ACTIONS(20395), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530287] = 2,
    ACTIONS(20397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530295] = 2,
    ACTIONS(20399), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530303] = 2,
    ACTIONS(20401), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530311] = 2,
    ACTIONS(20403), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530319] = 2,
    ACTIONS(20405), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530327] = 2,
    ACTIONS(20407), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530335] = 2,
    ACTIONS(20409), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530343] = 2,
    ACTIONS(20411), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530351] = 2,
    ACTIONS(20413), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530359] = 2,
    ACTIONS(20415), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530367] = 2,
    ACTIONS(20417), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530375] = 2,
    ACTIONS(20419), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530383] = 2,
    ACTIONS(20421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530391] = 2,
    ACTIONS(20423), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530399] = 2,
    ACTIONS(20425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530407] = 2,
    ACTIONS(20427), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530415] = 2,
    ACTIONS(20429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530423] = 2,
    ACTIONS(20431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530431] = 2,
    ACTIONS(20433), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530439] = 2,
    ACTIONS(20435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530447] = 2,
    ACTIONS(20437), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530455] = 2,
    ACTIONS(20439), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530463] = 2,
    ACTIONS(20441), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530471] = 2,
    ACTIONS(20443), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530479] = 2,
    ACTIONS(20445), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530487] = 2,
    ACTIONS(20447), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530495] = 2,
    ACTIONS(20449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530503] = 2,
    ACTIONS(20451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530511] = 2,
    ACTIONS(20453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530519] = 2,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530527] = 2,
    ACTIONS(20455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530535] = 2,
    ACTIONS(20457), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530543] = 2,
    ACTIONS(20459), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530551] = 2,
    ACTIONS(20461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530559] = 2,
    ACTIONS(20463), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530567] = 2,
    ACTIONS(20465), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530575] = 2,
    ACTIONS(20467), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530583] = 2,
    ACTIONS(20469), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530591] = 2,
    ACTIONS(20471), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530599] = 2,
    ACTIONS(20473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530607] = 2,
    ACTIONS(20475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530615] = 2,
    ACTIONS(20477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530623] = 2,
    ACTIONS(20479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530631] = 2,
    ACTIONS(20481), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530639] = 2,
    ACTIONS(20483), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530647] = 2,
    ACTIONS(20485), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530655] = 2,
    ACTIONS(20487), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530663] = 2,
    ACTIONS(20489), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530671] = 2,
    ACTIONS(20491), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530679] = 2,
    ACTIONS(20493), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530687] = 2,
    ACTIONS(20495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530695] = 2,
    ACTIONS(20497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530703] = 2,
    ACTIONS(20499), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530711] = 2,
    ACTIONS(20501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530719] = 2,
    ACTIONS(20503), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530727] = 2,
    ACTIONS(20505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530735] = 2,
    ACTIONS(20507), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530743] = 2,
    ACTIONS(20509), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530751] = 2,
    ACTIONS(20511), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530759] = 2,
    ACTIONS(20513), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530767] = 2,
    ACTIONS(20515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530775] = 2,
    ACTIONS(20517), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530783] = 2,
    ACTIONS(20519), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530791] = 2,
    ACTIONS(20521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530799] = 2,
    ACTIONS(20523), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530807] = 2,
    ACTIONS(20525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530815] = 2,
    ACTIONS(20527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530823] = 2,
    ACTIONS(20529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530831] = 2,
    ACTIONS(20531), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530839] = 2,
    ACTIONS(20533), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530847] = 2,
    ACTIONS(20535), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530855] = 2,
    ACTIONS(20537), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530863] = 2,
    ACTIONS(20539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530871] = 2,
    ACTIONS(20541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530879] = 2,
    ACTIONS(20543), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530887] = 2,
    ACTIONS(20545), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530895] = 2,
    ACTIONS(20547), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530903] = 2,
    ACTIONS(20549), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530911] = 2,
    ACTIONS(20551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530919] = 2,
    ACTIONS(20553), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530927] = 2,
    ACTIONS(20555), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530935] = 2,
    ACTIONS(20557), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530943] = 2,
    ACTIONS(20559), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530951] = 2,
    ACTIONS(20561), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530959] = 2,
    ACTIONS(20563), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530967] = 2,
    ACTIONS(20565), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530975] = 2,
    ACTIONS(20567), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530983] = 2,
    ACTIONS(20569), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530991] = 2,
    ACTIONS(20571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [530999] = 2,
    ACTIONS(20573), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531007] = 2,
    ACTIONS(20575), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531015] = 2,
    ACTIONS(20577), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531023] = 2,
    ACTIONS(20579), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531031] = 2,
    ACTIONS(20581), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531039] = 2,
    ACTIONS(20583), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531047] = 2,
    ACTIONS(20585), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531055] = 2,
    ACTIONS(20587), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531063] = 2,
    ACTIONS(20589), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531071] = 2,
    ACTIONS(20591), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531079] = 2,
    ACTIONS(20593), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531087] = 2,
    ACTIONS(20595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531095] = 2,
    ACTIONS(20597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531103] = 2,
    ACTIONS(20599), 1,
      sym_keyword_always,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531111] = 2,
    ACTIONS(20601), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531119] = 2,
    ACTIONS(20603), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531127] = 2,
    ACTIONS(20605), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531135] = 2,
    ACTIONS(20607), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531143] = 2,
    ACTIONS(20609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531151] = 2,
    ACTIONS(20611), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531159] = 2,
    ACTIONS(20613), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531167] = 2,
    ACTIONS(20615), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531175] = 2,
    ACTIONS(20617), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531183] = 2,
    ACTIONS(20619), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531191] = 2,
    ACTIONS(20621), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531199] = 2,
    ACTIONS(20623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531207] = 2,
    ACTIONS(20625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531215] = 2,
    ACTIONS(20627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531223] = 2,
    ACTIONS(20629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531231] = 2,
    ACTIONS(20631), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531239] = 2,
    ACTIONS(20633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531247] = 2,
    ACTIONS(20635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531255] = 2,
    ACTIONS(20637), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531263] = 2,
    ACTIONS(20639), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531271] = 2,
    ACTIONS(20641), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531279] = 2,
    ACTIONS(20643), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531287] = 2,
    ACTIONS(20645), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531295] = 2,
    ACTIONS(20647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531303] = 2,
    ACTIONS(20649), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531311] = 2,
    ACTIONS(20651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531319] = 2,
    ACTIONS(20653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531327] = 2,
    ACTIONS(20655), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531335] = 2,
    ACTIONS(20657), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531343] = 2,
    ACTIONS(14716), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531351] = 2,
    ACTIONS(20659), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531359] = 2,
    ACTIONS(20661), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531367] = 2,
    ACTIONS(20663), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531375] = 2,
    ACTIONS(20665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531383] = 2,
    ACTIONS(20667), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531391] = 2,
    ACTIONS(20669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531399] = 2,
    ACTIONS(20671), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531407] = 2,
    ACTIONS(20673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531415] = 2,
    ACTIONS(20675), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531423] = 2,
    ACTIONS(20677), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531431] = 2,
    ACTIONS(20679), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531439] = 2,
    ACTIONS(20681), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531447] = 2,
    ACTIONS(20683), 1,
      sym_keyword_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531455] = 2,
    ACTIONS(20685), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531463] = 2,
    ACTIONS(14946), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531471] = 2,
    ACTIONS(14841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531479] = 2,
    ACTIONS(20687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531487] = 2,
    ACTIONS(20689), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531495] = 2,
    ACTIONS(15352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531503] = 2,
    ACTIONS(20691), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531511] = 2,
    ACTIONS(15404), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531519] = 2,
    ACTIONS(20693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531527] = 2,
    ACTIONS(20695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531535] = 2,
    ACTIONS(20697), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531543] = 2,
    ACTIONS(20699), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531551] = 2,
    ACTIONS(20701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531559] = 2,
    ACTIONS(20703), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531567] = 2,
    ACTIONS(20705), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531575] = 2,
    ACTIONS(16174), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531583] = 2,
    ACTIONS(20707), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531591] = 2,
    ACTIONS(20709), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531599] = 2,
    ACTIONS(20711), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531607] = 2,
    ACTIONS(20713), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531615] = 2,
    ACTIONS(20715), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531623] = 2,
    ACTIONS(20717), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531631] = 2,
    ACTIONS(20719), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531639] = 2,
    ACTIONS(20721), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531647] = 2,
    ACTIONS(20723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531655] = 2,
    ACTIONS(20725), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531663] = 2,
    ACTIONS(20727), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531671] = 2,
    ACTIONS(20729), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531679] = 2,
    ACTIONS(20731), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531687] = 2,
    ACTIONS(20733), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531695] = 2,
    ACTIONS(20735), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531703] = 2,
    ACTIONS(20737), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531711] = 2,
    ACTIONS(20739), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531719] = 2,
    ACTIONS(20741), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531727] = 2,
    ACTIONS(20743), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531735] = 2,
    ACTIONS(20745), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531743] = 2,
    ACTIONS(15368), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531751] = 2,
    ACTIONS(20747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531759] = 2,
    ACTIONS(20749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531767] = 2,
    ACTIONS(14718), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531775] = 2,
    ACTIONS(15346), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531783] = 2,
    ACTIONS(16027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531791] = 2,
    ACTIONS(20751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531799] = 2,
    ACTIONS(20753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531807] = 2,
    ACTIONS(20755), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531815] = 2,
    ACTIONS(20757), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531823] = 2,
    ACTIONS(20759), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531831] = 2,
    ACTIONS(20761), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531839] = 2,
    ACTIONS(20763), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531847] = 2,
    ACTIONS(20765), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531855] = 2,
    ACTIONS(20767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531863] = 2,
    ACTIONS(9650), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531871] = 2,
    ACTIONS(20769), 1,
      sym_keyword_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531879] = 2,
    ACTIONS(20771), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531887] = 2,
    ACTIONS(20773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531895] = 2,
    ACTIONS(20775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531903] = 2,
    ACTIONS(20777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531911] = 2,
    ACTIONS(14746), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531919] = 2,
    ACTIONS(20779), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531927] = 2,
    ACTIONS(20781), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531935] = 2,
    ACTIONS(20783), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531943] = 2,
    ACTIONS(20785), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531951] = 2,
    ACTIONS(20787), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531959] = 2,
    ACTIONS(20789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531967] = 2,
    ACTIONS(20791), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531975] = 2,
    ACTIONS(20793), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531983] = 2,
    ACTIONS(20795), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531991] = 2,
    ACTIONS(20797), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [531999] = 2,
    ACTIONS(20799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532007] = 2,
    ACTIONS(20801), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532015] = 2,
    ACTIONS(20803), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532023] = 2,
    ACTIONS(20805), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532031] = 2,
    ACTIONS(20807), 1,
      sym_keyword_minvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532039] = 2,
    ACTIONS(20809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532047] = 2,
    ACTIONS(20811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532055] = 2,
    ACTIONS(20813), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532063] = 2,
    ACTIONS(20815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532071] = 2,
    ACTIONS(20817), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532079] = 2,
    ACTIONS(20807), 1,
      sym_keyword_maxvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532087] = 2,
    ACTIONS(20819), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532095] = 2,
    ACTIONS(20821), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532103] = 2,
    ACTIONS(20823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532111] = 2,
    ACTIONS(20825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532119] = 2,
    ACTIONS(20827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532127] = 2,
    ACTIONS(20829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532135] = 2,
    ACTIONS(20831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532143] = 2,
    ACTIONS(20833), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532151] = 2,
    ACTIONS(20835), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532159] = 2,
    ACTIONS(20837), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532167] = 2,
    ACTIONS(20839), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532175] = 2,
    ACTIONS(20841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532183] = 2,
    ACTIONS(20843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532191] = 2,
    ACTIONS(20845), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532199] = 2,
    ACTIONS(20847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532207] = 2,
    ACTIONS(20017), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532215] = 2,
    ACTIONS(20849), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532223] = 2,
    ACTIONS(20851), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532231] = 2,
    ACTIONS(20853), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532239] = 2,
    ACTIONS(20855), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532247] = 2,
    ACTIONS(20857), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532255] = 2,
    ACTIONS(20859), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532263] = 2,
    ACTIONS(20861), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532271] = 2,
    ACTIONS(20863), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532279] = 2,
    ACTIONS(20865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532287] = 2,
    ACTIONS(20867), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532295] = 2,
    ACTIONS(20869), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532303] = 2,
    ACTIONS(20871), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532311] = 2,
    ACTIONS(20873), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532319] = 2,
    ACTIONS(20875), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532327] = 2,
    ACTIONS(20877), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532335] = 2,
    ACTIONS(20879), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532343] = 2,
    ACTIONS(20881), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532351] = 2,
    ACTIONS(20883), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532359] = 2,
    ACTIONS(20885), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532367] = 2,
    ACTIONS(20887), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532375] = 2,
    ACTIONS(20889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532383] = 2,
    ACTIONS(20891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532391] = 2,
    ACTIONS(20893), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532399] = 2,
    ACTIONS(20895), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532407] = 2,
    ACTIONS(20897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532415] = 2,
    ACTIONS(20899), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532423] = 2,
    ACTIONS(20901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532431] = 2,
    ACTIONS(20903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532439] = 2,
    ACTIONS(20905), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532447] = 2,
    ACTIONS(20907), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532455] = 2,
    ACTIONS(20909), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532463] = 2,
    ACTIONS(20911), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532471] = 2,
    ACTIONS(20913), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532479] = 2,
    ACTIONS(20915), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532487] = 2,
    ACTIONS(20917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532495] = 2,
    ACTIONS(20919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532503] = 2,
    ACTIONS(20921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532511] = 2,
    ACTIONS(20923), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532519] = 2,
    ACTIONS(20925), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532527] = 2,
    ACTIONS(20927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532535] = 2,
    ACTIONS(20929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532543] = 2,
    ACTIONS(20931), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532551] = 2,
    ACTIONS(20933), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532559] = 2,
    ACTIONS(20935), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532567] = 2,
    ACTIONS(20937), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532575] = 2,
    ACTIONS(20939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532583] = 2,
    ACTIONS(20941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532591] = 2,
    ACTIONS(20943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532599] = 2,
    ACTIONS(20945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532607] = 2,
    ACTIONS(20947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532615] = 2,
    ACTIONS(20949), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532623] = 2,
    ACTIONS(20951), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532631] = 2,
    ACTIONS(20953), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532639] = 2,
    ACTIONS(20955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532647] = 2,
    ACTIONS(20957), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532655] = 2,
    ACTIONS(20959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532663] = 2,
    ACTIONS(20961), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532671] = 2,
    ACTIONS(20963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532679] = 2,
    ACTIONS(20965), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532687] = 2,
    ACTIONS(20967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532695] = 2,
    ACTIONS(20969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532703] = 2,
    ACTIONS(20971), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532711] = 2,
    ACTIONS(20973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532719] = 2,
    ACTIONS(20975), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532727] = 2,
    ACTIONS(20977), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532735] = 2,
    ACTIONS(20979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532743] = 2,
    ACTIONS(20981), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532751] = 2,
    ACTIONS(20983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532759] = 2,
    ACTIONS(18108), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532767] = 2,
    ACTIONS(20985), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532775] = 2,
    ACTIONS(20987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532783] = 2,
    ACTIONS(20989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532791] = 2,
    ACTIONS(20991), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532799] = 2,
    ACTIONS(20993), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532807] = 2,
    ACTIONS(20995), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532815] = 2,
    ACTIONS(20997), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532823] = 2,
    ACTIONS(20999), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532831] = 2,
    ACTIONS(21001), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532839] = 2,
    ACTIONS(21003), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532847] = 2,
    ACTIONS(21005), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532855] = 2,
    ACTIONS(21007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532863] = 2,
    ACTIONS(21009), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532871] = 2,
    ACTIONS(21011), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532879] = 2,
    ACTIONS(21013), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532887] = 2,
    ACTIONS(21015), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532895] = 2,
    ACTIONS(21017), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532903] = 2,
    ACTIONS(21019), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532911] = 2,
    ACTIONS(21021), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532919] = 2,
    ACTIONS(21023), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532927] = 2,
    ACTIONS(21025), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532935] = 2,
    ACTIONS(21027), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532943] = 2,
    ACTIONS(21029), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532951] = 2,
    ACTIONS(21031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532959] = 2,
    ACTIONS(21033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532967] = 2,
    ACTIONS(21035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532975] = 2,
    ACTIONS(21037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532983] = 2,
    ACTIONS(21039), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532991] = 2,
    ACTIONS(21041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [532999] = 2,
    ACTIONS(21043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533007] = 2,
    ACTIONS(21045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533015] = 2,
    ACTIONS(21047), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533023] = 2,
    ACTIONS(21049), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533031] = 2,
    ACTIONS(21051), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533039] = 2,
    ACTIONS(21053), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533047] = 2,
    ACTIONS(21055), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533055] = 2,
    ACTIONS(21057), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533063] = 2,
    ACTIONS(21059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533071] = 2,
    ACTIONS(21061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533079] = 2,
    ACTIONS(21063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533087] = 2,
    ACTIONS(21065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533095] = 2,
    ACTIONS(21067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533103] = 2,
    ACTIONS(21069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533111] = 2,
    ACTIONS(21071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533119] = 2,
    ACTIONS(21073), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533127] = 2,
    ACTIONS(21075), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533135] = 2,
    ACTIONS(21077), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533143] = 2,
    ACTIONS(21079), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533151] = 2,
    ACTIONS(21081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533159] = 2,
    ACTIONS(21083), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533167] = 2,
    ACTIONS(21085), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533175] = 2,
    ACTIONS(21087), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533183] = 2,
    ACTIONS(16202), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533191] = 2,
    ACTIONS(21089), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533199] = 2,
    ACTIONS(21091), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533207] = 2,
    ACTIONS(21093), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533215] = 2,
    ACTIONS(21095), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533223] = 2,
    ACTIONS(21097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533231] = 2,
    ACTIONS(15074), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533239] = 2,
    ACTIONS(21099), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533247] = 2,
    ACTIONS(21101), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533255] = 2,
    ACTIONS(21103), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533263] = 2,
    ACTIONS(21105), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533271] = 2,
    ACTIONS(21107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533279] = 2,
    ACTIONS(14932), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533287] = 2,
    ACTIONS(15002), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533295] = 2,
    ACTIONS(21109), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533303] = 2,
    ACTIONS(21111), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533311] = 2,
    ACTIONS(21113), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533319] = 2,
    ACTIONS(17462), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533327] = 2,
    ACTIONS(21115), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533335] = 2,
    ACTIONS(21117), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533343] = 2,
    ACTIONS(21119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533351] = 2,
    ACTIONS(21121), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533359] = 2,
    ACTIONS(9754), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533367] = 2,
    ACTIONS(21123), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533375] = 2,
    ACTIONS(21125), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533383] = 2,
    ACTIONS(21127), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533391] = 2,
    ACTIONS(21129), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533399] = 2,
    ACTIONS(21131), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533407] = 2,
    ACTIONS(21133), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533415] = 2,
    ACTIONS(21135), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533423] = 2,
    ACTIONS(21137), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533431] = 2,
    ACTIONS(21139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533439] = 2,
    ACTIONS(21141), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533447] = 2,
    ACTIONS(21143), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533455] = 2,
    ACTIONS(21145), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533463] = 2,
    ACTIONS(21147), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533471] = 2,
    ACTIONS(21149), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533479] = 2,
    ACTIONS(21151), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533487] = 2,
    ACTIONS(21153), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533495] = 2,
    ACTIONS(21155), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533503] = 2,
    ACTIONS(21157), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533511] = 2,
    ACTIONS(21159), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533519] = 2,
    ACTIONS(21161), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533527] = 2,
    ACTIONS(21163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533535] = 2,
    ACTIONS(9520), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533543] = 2,
    ACTIONS(21165), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533551] = 2,
    ACTIONS(21167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533559] = 2,
    ACTIONS(21169), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533567] = 2,
    ACTIONS(21171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533575] = 2,
    ACTIONS(21173), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533583] = 2,
    ACTIONS(1754), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533591] = 2,
    ACTIONS(21175), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533599] = 2,
    ACTIONS(21177), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533607] = 2,
    ACTIONS(21179), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533615] = 2,
    ACTIONS(21181), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533623] = 2,
    ACTIONS(21183), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533631] = 2,
    ACTIONS(21185), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533639] = 2,
    ACTIONS(21187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533647] = 2,
    ACTIONS(21189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533655] = 2,
    ACTIONS(21191), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533663] = 2,
    ACTIONS(21193), 1,
      sym_keyword_materialized,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533671] = 2,
    ACTIONS(21195), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533679] = 2,
    ACTIONS(21197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533687] = 2,
    ACTIONS(21199), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533695] = 2,
    ACTIONS(21201), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533703] = 2,
    ACTIONS(21203), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533711] = 2,
    ACTIONS(21205), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533719] = 2,
    ACTIONS(21207), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533727] = 2,
    ACTIONS(21209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533735] = 2,
    ACTIONS(21211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533743] = 2,
    ACTIONS(21213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533751] = 2,
    ACTIONS(21215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533759] = 2,
    ACTIONS(21217), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533767] = 2,
    ACTIONS(21219), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533775] = 2,
    ACTIONS(21221), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533783] = 2,
    ACTIONS(21223), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533791] = 2,
    ACTIONS(21225), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533799] = 2,
    ACTIONS(21227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533807] = 2,
    ACTIONS(21229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533815] = 2,
    ACTIONS(21231), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533823] = 2,
    ACTIONS(21233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533831] = 2,
    ACTIONS(21235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533839] = 2,
    ACTIONS(21237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533847] = 2,
    ACTIONS(21239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533855] = 2,
    ACTIONS(21241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533863] = 2,
    ACTIONS(21243), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533871] = 2,
    ACTIONS(21245), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533879] = 2,
    ACTIONS(21247), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533887] = 2,
    ACTIONS(21249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533895] = 2,
    ACTIONS(21251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533903] = 2,
    ACTIONS(21253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533911] = 2,
    ACTIONS(21255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533919] = 2,
    ACTIONS(21257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533927] = 2,
    ACTIONS(21259), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533935] = 2,
    ACTIONS(21261), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533943] = 2,
    ACTIONS(21263), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533951] = 2,
    ACTIONS(21265), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533959] = 2,
    ACTIONS(21267), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533967] = 2,
    ACTIONS(21269), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533975] = 2,
    ACTIONS(21271), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533983] = 2,
    ACTIONS(21273), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533991] = 2,
    ACTIONS(21275), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [533999] = 2,
    ACTIONS(21277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534007] = 2,
    ACTIONS(21279), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534015] = 2,
    ACTIONS(21281), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534023] = 2,
    ACTIONS(21283), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534031] = 2,
    ACTIONS(21285), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534039] = 2,
    ACTIONS(21287), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534047] = 2,
    ACTIONS(21289), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534055] = 2,
    ACTIONS(21291), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534063] = 2,
    ACTIONS(21293), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534071] = 2,
    ACTIONS(21295), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534079] = 2,
    ACTIONS(21297), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534087] = 2,
    ACTIONS(21299), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534095] = 2,
    ACTIONS(21301), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534103] = 2,
    ACTIONS(21303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534111] = 2,
    ACTIONS(21305), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534119] = 2,
    ACTIONS(21307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534127] = 2,
    ACTIONS(21309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534135] = 2,
    ACTIONS(21311), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534143] = 2,
    ACTIONS(21313), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534151] = 2,
    ACTIONS(21315), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534159] = 2,
    ACTIONS(21317), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534167] = 2,
    ACTIONS(21319), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534175] = 2,
    ACTIONS(21321), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534183] = 2,
    ACTIONS(21323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534191] = 2,
    ACTIONS(21325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534199] = 2,
    ACTIONS(21327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534207] = 2,
    ACTIONS(21329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534215] = 2,
    ACTIONS(21331), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534223] = 2,
    ACTIONS(21333), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534231] = 2,
    ACTIONS(21335), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534239] = 2,
    ACTIONS(21337), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534247] = 2,
    ACTIONS(21339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534255] = 2,
    ACTIONS(21341), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534263] = 2,
    ACTIONS(21343), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534271] = 2,
    ACTIONS(21345), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534279] = 2,
    ACTIONS(21347), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534287] = 2,
    ACTIONS(21349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534295] = 2,
    ACTIONS(21351), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534303] = 2,
    ACTIONS(21353), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534311] = 2,
    ACTIONS(21355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534319] = 2,
    ACTIONS(21357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534327] = 2,
    ACTIONS(21359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534335] = 2,
    ACTIONS(21361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534343] = 2,
    ACTIONS(21363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534351] = 2,
    ACTIONS(21365), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534359] = 2,
    ACTIONS(21367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534367] = 2,
    ACTIONS(21369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534375] = 2,
    ACTIONS(21371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534383] = 2,
    ACTIONS(21373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534391] = 2,
    ACTIONS(21375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534399] = 2,
    ACTIONS(21377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534407] = 2,
    ACTIONS(21379), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534415] = 2,
    ACTIONS(21381), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534423] = 2,
    ACTIONS(21383), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534431] = 2,
    ACTIONS(21385), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534439] = 2,
    ACTIONS(21387), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534447] = 2,
    ACTIONS(21389), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534455] = 2,
    ACTIONS(21391), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534463] = 2,
    ACTIONS(21393), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534471] = 2,
    ACTIONS(21395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534479] = 2,
    ACTIONS(21397), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534487] = 2,
    ACTIONS(21399), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534495] = 2,
    ACTIONS(21401), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534503] = 2,
    ACTIONS(21403), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534511] = 2,
    ACTIONS(21405), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534519] = 2,
    ACTIONS(21407), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534527] = 2,
    ACTIONS(21409), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534535] = 2,
    ACTIONS(21411), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534543] = 2,
    ACTIONS(21413), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534551] = 2,
    ACTIONS(21415), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534559] = 2,
    ACTIONS(21417), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534567] = 2,
    ACTIONS(21419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534575] = 2,
    ACTIONS(21421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534583] = 2,
    ACTIONS(9506), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534591] = 2,
    ACTIONS(21423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534599] = 2,
    ACTIONS(21425), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534607] = 2,
    ACTIONS(21427), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534615] = 2,
    ACTIONS(21429), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534623] = 2,
    ACTIONS(21431), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534631] = 2,
    ACTIONS(21433), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534639] = 2,
    ACTIONS(21435), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534647] = 2,
    ACTIONS(21437), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534655] = 2,
    ACTIONS(21439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534663] = 2,
    ACTIONS(21441), 1,
      sym_keyword_compute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534671] = 2,
    ACTIONS(21443), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534679] = 2,
    ACTIONS(21445), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534687] = 2,
    ACTIONS(21447), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534695] = 2,
    ACTIONS(21449), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534703] = 2,
    ACTIONS(21451), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534711] = 2,
    ACTIONS(21453), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534719] = 2,
    ACTIONS(21455), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534727] = 2,
    ACTIONS(21457), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534735] = 2,
    ACTIONS(21459), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534743] = 2,
    ACTIONS(21461), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534751] = 2,
    ACTIONS(21463), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534759] = 2,
    ACTIONS(21465), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534767] = 2,
    ACTIONS(21467), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534775] = 2,
    ACTIONS(21469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534783] = 2,
    ACTIONS(21471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534791] = 2,
    ACTIONS(21473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534799] = 2,
    ACTIONS(21475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534807] = 2,
    ACTIONS(21477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534815] = 2,
    ACTIONS(21479), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534823] = 2,
    ACTIONS(21481), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534831] = 2,
    ACTIONS(21483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534839] = 2,
    ACTIONS(16254), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534847] = 2,
    ACTIONS(21485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534855] = 2,
    ACTIONS(21487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534863] = 2,
    ACTIONS(15138), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534871] = 2,
    ACTIONS(21489), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534879] = 2,
    ACTIONS(21491), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534887] = 2,
    ACTIONS(21493), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534895] = 2,
    ACTIONS(21495), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534903] = 2,
    ACTIONS(21497), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534911] = 2,
    ACTIONS(21499), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534919] = 2,
    ACTIONS(21501), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534927] = 2,
    ACTIONS(21503), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534935] = 2,
    ACTIONS(21505), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534943] = 2,
    ACTIONS(21507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534951] = 2,
    ACTIONS(21509), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534959] = 2,
    ACTIONS(21511), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534967] = 2,
    ACTIONS(21513), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534975] = 2,
    ACTIONS(21515), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534983] = 2,
    ACTIONS(21517), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534991] = 2,
    ACTIONS(21519), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [534999] = 2,
    ACTIONS(21521), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535007] = 2,
    ACTIONS(21523), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535015] = 2,
    ACTIONS(21525), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535023] = 2,
    ACTIONS(21527), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535031] = 2,
    ACTIONS(21529), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535039] = 2,
    ACTIONS(21531), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535047] = 2,
    ACTIONS(21533), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535055] = 2,
    ACTIONS(21535), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535063] = 2,
    ACTIONS(21537), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535071] = 2,
    ACTIONS(14788), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535079] = 2,
    ACTIONS(21539), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535087] = 2,
    ACTIONS(21541), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535095] = 2,
    ACTIONS(21543), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535103] = 2,
    ACTIONS(21545), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535111] = 2,
    ACTIONS(21547), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535119] = 2,
    ACTIONS(21549), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535127] = 2,
    ACTIONS(21551), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535135] = 2,
    ACTIONS(21553), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535143] = 2,
    ACTIONS(15216), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535151] = 2,
    ACTIONS(21555), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535159] = 2,
    ACTIONS(21557), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535167] = 2,
    ACTIONS(21559), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535175] = 2,
    ACTIONS(21561), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535183] = 2,
    ACTIONS(21563), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535191] = 2,
    ACTIONS(19753), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535199] = 2,
    ACTIONS(9819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535207] = 2,
    ACTIONS(21565), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535215] = 2,
    ACTIONS(21567), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535223] = 2,
    ACTIONS(21569), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535231] = 2,
    ACTIONS(21571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535239] = 2,
    ACTIONS(21573), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535247] = 2,
    ACTIONS(21575), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535255] = 2,
    ACTIONS(21577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535263] = 2,
    ACTIONS(21579), 1,
      sym_keyword_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535271] = 2,
    ACTIONS(21581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535279] = 2,
    ACTIONS(21583), 1,
      sym_keyword_cycle,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535287] = 2,
    ACTIONS(21585), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535295] = 2,
    ACTIONS(21587), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535303] = 2,
    ACTIONS(21589), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535311] = 2,
    ACTIONS(21591), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535319] = 2,
    ACTIONS(21593), 1,
      sym_keyword_current,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535327] = 2,
    ACTIONS(18078), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535335] = 2,
    ACTIONS(21595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535343] = 2,
    ACTIONS(21597), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535351] = 2,
    ACTIONS(21599), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535359] = 2,
    ACTIONS(21601), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535367] = 2,
    ACTIONS(21603), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535375] = 2,
    ACTIONS(21605), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535383] = 2,
    ACTIONS(21607), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535391] = 2,
    ACTIONS(21609), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535399] = 2,
    ACTIONS(21611), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535407] = 2,
    ACTIONS(21613), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535415] = 2,
    ACTIONS(21615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535423] = 2,
    ACTIONS(21617), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535431] = 2,
    ACTIONS(21619), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535439] = 2,
    ACTIONS(21621), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535447] = 2,
    ACTIONS(21623), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535455] = 2,
    ACTIONS(21625), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535463] = 2,
    ACTIONS(21627), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535471] = 2,
    ACTIONS(21629), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535479] = 2,
    ACTIONS(21631), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535487] = 2,
    ACTIONS(21633), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535495] = 2,
    ACTIONS(21635), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535503] = 2,
    ACTIONS(21637), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535511] = 2,
    ACTIONS(21639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535519] = 2,
    ACTIONS(21641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535527] = 2,
    ACTIONS(16918), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535535] = 2,
    ACTIONS(21643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535543] = 2,
    ACTIONS(21645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535551] = 2,
    ACTIONS(21647), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535559] = 2,
    ACTIONS(21649), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535567] = 2,
    ACTIONS(21651), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535575] = 2,
    ACTIONS(21653), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535583] = 2,
    ACTIONS(21655), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535591] = 2,
    ACTIONS(21657), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535599] = 2,
    ACTIONS(21659), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535607] = 2,
    ACTIONS(21661), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535615] = 2,
    ACTIONS(21663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535623] = 2,
    ACTIONS(21665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535631] = 2,
    ACTIONS(21667), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535639] = 2,
    ACTIONS(21669), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535647] = 2,
    ACTIONS(21671), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535655] = 2,
    ACTIONS(21673), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535663] = 2,
    ACTIONS(21675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535671] = 2,
    ACTIONS(21677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535679] = 2,
    ACTIONS(21679), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535687] = 2,
    ACTIONS(21681), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535695] = 2,
    ACTIONS(21683), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535703] = 2,
    ACTIONS(21685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535711] = 2,
    ACTIONS(21687), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535719] = 2,
    ACTIONS(21689), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535727] = 2,
    ACTIONS(15526), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535735] = 2,
    ACTIONS(21691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535743] = 2,
    ACTIONS(21693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535751] = 2,
    ACTIONS(21695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535759] = 2,
    ACTIONS(21697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535767] = 2,
    ACTIONS(21699), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535775] = 2,
    ACTIONS(21701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535783] = 2,
    ACTIONS(21703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535791] = 2,
    ACTIONS(21705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535799] = 2,
    ACTIONS(21707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535807] = 2,
    ACTIONS(21709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535815] = 2,
    ACTIONS(21711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535823] = 2,
    ACTIONS(21713), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535831] = 2,
    ACTIONS(21715), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535839] = 2,
    ACTIONS(21717), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535847] = 2,
    ACTIONS(21719), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535855] = 2,
    ACTIONS(21721), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535863] = 2,
    ACTIONS(21723), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535871] = 2,
    ACTIONS(21725), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535879] = 2,
    ACTIONS(21727), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535887] = 2,
    ACTIONS(21729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535895] = 2,
    ACTIONS(21731), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535903] = 2,
    ACTIONS(21733), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535911] = 2,
    ACTIONS(21735), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535919] = 2,
    ACTIONS(21737), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535927] = 2,
    ACTIONS(21739), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535935] = 2,
    ACTIONS(21741), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535943] = 2,
    ACTIONS(21743), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535951] = 2,
    ACTIONS(21745), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535959] = 2,
    ACTIONS(21747), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535967] = 2,
    ACTIONS(21749), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535975] = 2,
    ACTIONS(21751), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535983] = 2,
    ACTIONS(21753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535991] = 2,
    ACTIONS(21755), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [535999] = 2,
    ACTIONS(21757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536007] = 2,
    ACTIONS(21759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536015] = 2,
    ACTIONS(21761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536023] = 2,
    ACTIONS(21763), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536031] = 2,
    ACTIONS(21765), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536039] = 2,
    ACTIONS(21767), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536047] = 2,
    ACTIONS(21769), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536055] = 2,
    ACTIONS(21771), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536063] = 2,
    ACTIONS(21773), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536071] = 2,
    ACTIONS(17690), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536079] = 2,
    ACTIONS(21775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536087] = 2,
    ACTIONS(21777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536095] = 2,
    ACTIONS(21779), 1,
      sym_keyword_database,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536103] = 2,
    ACTIONS(21781), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536111] = 2,
    ACTIONS(21783), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536119] = 2,
    ACTIONS(21785), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536127] = 2,
    ACTIONS(21787), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536135] = 2,
    ACTIONS(21789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536143] = 2,
    ACTIONS(21791), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536151] = 2,
    ACTIONS(21793), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536159] = 2,
    ACTIONS(21795), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536167] = 2,
    ACTIONS(21797), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536175] = 2,
    ACTIONS(21799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536183] = 2,
    ACTIONS(21801), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536191] = 2,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536199] = 2,
    ACTIONS(21803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536207] = 2,
    ACTIONS(21805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536215] = 2,
    ACTIONS(21807), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536223] = 2,
    ACTIONS(21809), 1,
      sym_keyword_matched,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536231] = 2,
    ACTIONS(16330), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536239] = 2,
    ACTIONS(21811), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536247] = 2,
    ACTIONS(21813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536255] = 2,
    ACTIONS(21815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536263] = 2,
    ACTIONS(21817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536271] = 2,
    ACTIONS(21819), 1,
      sym_keyword_returns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536279] = 2,
    ACTIONS(21821), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536287] = 2,
    ACTIONS(18061), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536295] = 2,
    ACTIONS(21823), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536303] = 2,
    ACTIONS(21825), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536311] = 2,
    ACTIONS(21827), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536319] = 2,
    ACTIONS(21829), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536327] = 2,
    ACTIONS(15689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536335] = 2,
    ACTIONS(21831), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536343] = 2,
    ACTIONS(21833), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536351] = 2,
    ACTIONS(21835), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536359] = 2,
    ACTIONS(21837), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536367] = 2,
    ACTIONS(21839), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536375] = 2,
    ACTIONS(21841), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536383] = 2,
    ACTIONS(21843), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536391] = 2,
    ACTIONS(21845), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536399] = 2,
    ACTIONS(21847), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536407] = 2,
    ACTIONS(21849), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536415] = 2,
    ACTIONS(21851), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536423] = 2,
    ACTIONS(21853), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536431] = 2,
    ACTIONS(21855), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536439] = 2,
    ACTIONS(21857), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536447] = 2,
    ACTIONS(21859), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536455] = 2,
    ACTIONS(21861), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536463] = 2,
    ACTIONS(21863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536471] = 2,
    ACTIONS(21865), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536479] = 2,
    ACTIONS(21867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536487] = 2,
    ACTIONS(21869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536495] = 2,
    ACTIONS(21871), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536503] = 2,
    ACTIONS(21873), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536511] = 2,
    ACTIONS(21875), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536519] = 2,
    ACTIONS(21877), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536527] = 2,
    ACTIONS(21879), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536535] = 2,
    ACTIONS(21881), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536543] = 2,
    ACTIONS(21883), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536551] = 2,
    ACTIONS(16344), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536559] = 2,
    ACTIONS(21885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536567] = 2,
    ACTIONS(15068), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536575] = 2,
    ACTIONS(21887), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536583] = 2,
    ACTIONS(21889), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536591] = 2,
    ACTIONS(21891), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536599] = 2,
    ACTIONS(21893), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536607] = 2,
    ACTIONS(21895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536615] = 2,
    ACTIONS(21897), 1,
      aux_sym__integer_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536623] = 2,
    ACTIONS(21899), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536631] = 2,
    ACTIONS(21901), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536639] = 2,
    ACTIONS(21903), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536647] = 2,
    ACTIONS(14792), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536655] = 2,
    ACTIONS(21905), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536663] = 2,
    ACTIONS(21907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536671] = 2,
    ACTIONS(16001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536679] = 2,
    ACTIONS(15194), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536687] = 2,
    ACTIONS(21909), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536695] = 2,
    ACTIONS(9875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536703] = 2,
    ACTIONS(21911), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536711] = 2,
    ACTIONS(21913), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536719] = 2,
    ACTIONS(21915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536727] = 2,
    ACTIONS(21917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536735] = 2,
    ACTIONS(21919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536743] = 2,
    ACTIONS(21921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536751] = 2,
    ACTIONS(21923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536759] = 2,
    ACTIONS(18158), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536767] = 2,
    ACTIONS(21925), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536775] = 2,
    ACTIONS(21927), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536783] = 2,
    ACTIONS(21929), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536791] = 2,
    ACTIONS(21931), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536799] = 2,
    ACTIONS(21933), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536807] = 2,
    ACTIONS(21935), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536815] = 2,
    ACTIONS(21937), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536823] = 2,
    ACTIONS(21939), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536831] = 2,
    ACTIONS(21941), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536839] = 2,
    ACTIONS(21943), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536847] = 2,
    ACTIONS(21945), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536855] = 2,
    ACTIONS(21947), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536863] = 2,
    ACTIONS(21949), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536871] = 2,
    ACTIONS(21951), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536879] = 2,
    ACTIONS(21953), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536887] = 2,
    ACTIONS(21955), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536895] = 2,
    ACTIONS(21957), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536903] = 2,
    ACTIONS(21959), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536911] = 2,
    ACTIONS(21961), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536919] = 2,
    ACTIONS(21963), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536927] = 2,
    ACTIONS(21965), 1,
      sym_keyword_oids,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536935] = 2,
    ACTIONS(21967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536943] = 2,
    ACTIONS(21969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536951] = 2,
    ACTIONS(21971), 1,
      sym_keyword_leakproof,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536959] = 2,
    ACTIONS(21973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536967] = 2,
    ACTIONS(21975), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536975] = 2,
    ACTIONS(21977), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536983] = 2,
    ACTIONS(21979), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536991] = 2,
    ACTIONS(21981), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [536999] = 2,
    ACTIONS(21983), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537007] = 2,
    ACTIONS(21985), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537015] = 2,
    ACTIONS(21987), 1,
      sym_keyword_atomic,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537023] = 2,
    ACTIONS(21989), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537031] = 2,
    ACTIONS(21991), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537039] = 2,
    ACTIONS(21993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537047] = 2,
    ACTIONS(21995), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537055] = 2,
    ACTIONS(21997), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537063] = 2,
    ACTIONS(21999), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537071] = 2,
    ACTIONS(22001), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537079] = 2,
    ACTIONS(22003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537087] = 2,
    ACTIONS(22005), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537095] = 2,
    ACTIONS(22007), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537103] = 2,
    ACTIONS(22009), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537111] = 2,
    ACTIONS(22011), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537119] = 2,
    ACTIONS(22013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537127] = 2,
    ACTIONS(22015), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537135] = 2,
    ACTIONS(22017), 1,
      sym_keyword_distinct,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537143] = 2,
    ACTIONS(22019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537151] = 2,
    ACTIONS(22021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537159] = 2,
    ACTIONS(22023), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537167] = 2,
    ACTIONS(22025), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537175] = 2,
    ACTIONS(22027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537183] = 2,
    ACTIONS(22029), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537191] = 2,
    ACTIONS(22031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537199] = 2,
    ACTIONS(22033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537207] = 2,
    ACTIONS(22035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537215] = 2,
    ACTIONS(22037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537223] = 2,
    ACTIONS(22039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537231] = 2,
    ACTIONS(22041), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537239] = 2,
    ACTIONS(22043), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537247] = 2,
    ACTIONS(22045), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537255] = 2,
    ACTIONS(22047), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537263] = 2,
    ACTIONS(22049), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537271] = 2,
    ACTIONS(22051), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537279] = 2,
    ACTIONS(22053), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537287] = 2,
    ACTIONS(22055), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537295] = 2,
    ACTIONS(22057), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537303] = 2,
    ACTIONS(22059), 1,
      sym_keyword_security,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537311] = 2,
    ACTIONS(22061), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537319] = 2,
    ACTIONS(22063), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537327] = 2,
    ACTIONS(22065), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537335] = 2,
    ACTIONS(22067), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537343] = 2,
    ACTIONS(22069), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537351] = 2,
    ACTIONS(22071), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537359] = 2,
    ACTIONS(22073), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537367] = 2,
    ACTIONS(22075), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537375] = 2,
    ACTIONS(22077), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537383] = 2,
    ACTIONS(22079), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537391] = 2,
    ACTIONS(22081), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537399] = 2,
    ACTIONS(22083), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537407] = 2,
    ACTIONS(22085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537415] = 2,
    ACTIONS(22087), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537423] = 2,
    ACTIONS(22089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537431] = 2,
    ACTIONS(22091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537439] = 2,
    ACTIONS(22093), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537447] = 2,
    ACTIONS(22095), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537455] = 2,
    ACTIONS(22097), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537463] = 2,
    ACTIONS(22099), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537471] = 2,
    ACTIONS(22101), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537479] = 2,
    ACTIONS(22103), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537487] = 2,
    ACTIONS(22105), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537495] = 2,
    ACTIONS(22107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537503] = 2,
    ACTIONS(22109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537511] = 2,
    ACTIONS(22111), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537519] = 2,
    ACTIONS(22113), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537527] = 2,
    ACTIONS(22115), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537535] = 2,
    ACTIONS(22117), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537543] = 2,
    ACTIONS(22119), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537551] = 2,
    ACTIONS(22121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537559] = 2,
    ACTIONS(22123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537567] = 2,
    ACTIONS(22125), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537575] = 2,
    ACTIONS(22127), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537583] = 2,
    ACTIONS(22129), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537591] = 2,
    ACTIONS(22131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537599] = 2,
    ACTIONS(22133), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537607] = 2,
    ACTIONS(22135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537615] = 2,
    ACTIONS(22137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537623] = 2,
    ACTIONS(22139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537631] = 2,
    ACTIONS(22141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537639] = 2,
    ACTIONS(22143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537647] = 2,
    ACTIONS(22145), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537655] = 2,
    ACTIONS(22147), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537663] = 2,
    ACTIONS(22149), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537671] = 2,
    ACTIONS(16890), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537679] = 2,
    ACTIONS(22151), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537687] = 2,
    ACTIONS(22153), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537695] = 2,
    ACTIONS(22155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537703] = 2,
    ACTIONS(22157), 1,
      sym_keyword_format,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537711] = 2,
    ACTIONS(22159), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537719] = 2,
    ACTIONS(22161), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537727] = 2,
    ACTIONS(22163), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537735] = 2,
    ACTIONS(22165), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537743] = 2,
    ACTIONS(22167), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537751] = 2,
    ACTIONS(22169), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537759] = 2,
    ACTIONS(22171), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537767] = 2,
    ACTIONS(22173), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537775] = 2,
    ACTIONS(22175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537783] = 2,
    ACTIONS(22177), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537791] = 2,
    ACTIONS(22179), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537799] = 2,
    ACTIONS(22181), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537807] = 2,
    ACTIONS(22183), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537815] = 2,
    ACTIONS(22185), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537823] = 2,
    ACTIONS(22187), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537831] = 2,
    ACTIONS(22189), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537839] = 2,
    ACTIONS(22191), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537847] = 2,
    ACTIONS(22193), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537855] = 2,
    ACTIONS(22195), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537863] = 2,
    ACTIONS(22197), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537871] = 2,
    ACTIONS(22199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537879] = 2,
    ACTIONS(22201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537887] = 2,
    ACTIONS(22203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537895] = 2,
    ACTIONS(22205), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537903] = 2,
    ACTIONS(22207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537911] = 2,
    ACTIONS(22209), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537919] = 2,
    ACTIONS(22211), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537927] = 2,
    ACTIONS(22213), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537935] = 2,
    ACTIONS(22215), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537943] = 2,
    ACTIONS(22217), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537951] = 2,
    ACTIONS(22219), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537959] = 2,
    ACTIONS(22221), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537967] = 2,
    ACTIONS(22223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537975] = 2,
    ACTIONS(22225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537983] = 2,
    ACTIONS(22227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537991] = 2,
    ACTIONS(22229), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [537999] = 2,
    ACTIONS(22231), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538007] = 2,
    ACTIONS(22233), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538015] = 2,
    ACTIONS(22235), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538023] = 2,
    ACTIONS(22237), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538031] = 2,
    ACTIONS(22239), 1,
      sym_keyword_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538039] = 2,
    ACTIONS(22241), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538047] = 2,
    ACTIONS(22243), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538055] = 2,
    ACTIONS(22245), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538063] = 2,
    ACTIONS(22247), 1,
      sym_keyword_until,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538071] = 2,
    ACTIONS(22249), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538079] = 2,
    ACTIONS(22251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538087] = 2,
    ACTIONS(22253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538095] = 2,
    ACTIONS(22255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538103] = 2,
    ACTIONS(22257), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538111] = 2,
    ACTIONS(22259), 1,
      sym_keyword_password,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538119] = 2,
    ACTIONS(22261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538127] = 2,
    ACTIONS(22263), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538135] = 2,
    ACTIONS(22265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538143] = 2,
    ACTIONS(22267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538151] = 2,
    ACTIONS(22269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538159] = 2,
    ACTIONS(22271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538167] = 2,
    ACTIONS(22273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538175] = 2,
    ACTIONS(22275), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538183] = 2,
    ACTIONS(22277), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538191] = 2,
    ACTIONS(22279), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538199] = 2,
    ACTIONS(22281), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538207] = 2,
    ACTIONS(22283), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538215] = 2,
    ACTIONS(22285), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538223] = 2,
    ACTIONS(22287), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538231] = 2,
    ACTIONS(22289), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538239] = 2,
    ACTIONS(22291), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538247] = 2,
    ACTIONS(22293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538255] = 2,
    ACTIONS(22295), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538263] = 2,
    ACTIONS(22297), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538271] = 2,
    ACTIONS(22299), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538279] = 2,
    ACTIONS(22301), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538287] = 2,
    ACTIONS(22303), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538295] = 2,
    ACTIONS(22305), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538303] = 2,
    ACTIONS(22307), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538311] = 2,
    ACTIONS(22309), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538319] = 2,
    ACTIONS(22311), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538327] = 2,
    ACTIONS(22313), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538335] = 2,
    ACTIONS(22315), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538343] = 2,
    ACTIONS(22317), 1,
      sym_keyword_transaction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538351] = 2,
    ACTIONS(22319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538359] = 2,
    ACTIONS(22321), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538367] = 2,
    ACTIONS(22323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538375] = 2,
    ACTIONS(22325), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538383] = 2,
    ACTIONS(22327), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538391] = 2,
    ACTIONS(22329), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538399] = 2,
    ACTIONS(22331), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538407] = 2,
    ACTIONS(22333), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538415] = 2,
    ACTIONS(22335), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538423] = 2,
    ACTIONS(22337), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538431] = 2,
    ACTIONS(16402), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538439] = 2,
    ACTIONS(22339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538447] = 2,
    ACTIONS(15540), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538455] = 2,
    ACTIONS(22341), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538463] = 2,
    ACTIONS(22343), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538471] = 2,
    ACTIONS(22345), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538479] = 2,
    ACTIONS(22347), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538487] = 2,
    ACTIONS(22349), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538495] = 2,
    ACTIONS(22351), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538503] = 2,
    ACTIONS(22353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538511] = 2,
    ACTIONS(22355), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538519] = 2,
    ACTIONS(22357), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538527] = 2,
    ACTIONS(22359), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538535] = 2,
    ACTIONS(22361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538543] = 2,
    ACTIONS(22363), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538551] = 2,
    ACTIONS(22365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538559] = 2,
    ACTIONS(20021), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538567] = 2,
    ACTIONS(22367), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538575] = 2,
    ACTIONS(22369), 1,
      aux_sym__integer_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538583] = 2,
    ACTIONS(22371), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538591] = 2,
    ACTIONS(22373), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538599] = 2,
    ACTIONS(22375), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538607] = 2,
    ACTIONS(22377), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538615] = 2,
    ACTIONS(22379), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538623] = 2,
    ACTIONS(22381), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538631] = 2,
    ACTIONS(22383), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538639] = 2,
    ACTIONS(22385), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538647] = 2,
    ACTIONS(14680), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538655] = 2,
    ACTIONS(22387), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538663] = 2,
    ACTIONS(22389), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538671] = 2,
    ACTIONS(22391), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538679] = 2,
    ACTIONS(22393), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538687] = 2,
    ACTIONS(22395), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538695] = 2,
    ACTIONS(22397), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538703] = 2,
    ACTIONS(22399), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538711] = 2,
    ACTIONS(22401), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538719] = 2,
    ACTIONS(22403), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538727] = 2,
    ACTIONS(22405), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538735] = 2,
    ACTIONS(22407), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538743] = 2,
    ACTIONS(22409), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538751] = 2,
    ACTIONS(22411), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538759] = 2,
    ACTIONS(22413), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538767] = 2,
    ACTIONS(22415), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538775] = 2,
    ACTIONS(22417), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538783] = 2,
    ACTIONS(22419), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538791] = 2,
    ACTIONS(22421), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538799] = 2,
    ACTIONS(22423), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538807] = 2,
    ACTIONS(22425), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538815] = 2,
    ACTIONS(22427), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538823] = 2,
    ACTIONS(22429), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538831] = 2,
    ACTIONS(22431), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538839] = 2,
    ACTIONS(22433), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538847] = 2,
    ACTIONS(22435), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538855] = 2,
    ACTIONS(22437), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538863] = 2,
    ACTIONS(22439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538871] = 2,
    ACTIONS(22441), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538879] = 2,
    ACTIONS(15472), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538887] = 2,
    ACTIONS(22443), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538895] = 2,
    ACTIONS(22445), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538903] = 2,
    ACTIONS(22447), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538911] = 2,
    ACTIONS(22449), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538919] = 2,
    ACTIONS(22451), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538927] = 2,
    ACTIONS(22453), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538935] = 2,
    ACTIONS(22455), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538943] = 2,
    ACTIONS(22457), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538951] = 2,
    ACTIONS(22459), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538959] = 2,
    ACTIONS(22461), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538967] = 2,
    ACTIONS(22463), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538975] = 2,
    ACTIONS(22465), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538983] = 2,
    ACTIONS(22467), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538991] = 2,
    ACTIONS(22469), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [538999] = 2,
    ACTIONS(22471), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539007] = 2,
    ACTIONS(22473), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539015] = 2,
    ACTIONS(22475), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539023] = 2,
    ACTIONS(22477), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539031] = 2,
    ACTIONS(22479), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539039] = 2,
    ACTIONS(22481), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539047] = 2,
    ACTIONS(22483), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539055] = 2,
    ACTIONS(22485), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539063] = 2,
    ACTIONS(22487), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539071] = 2,
    ACTIONS(22489), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539079] = 2,
    ACTIONS(22491), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539087] = 2,
    ACTIONS(22493), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539095] = 2,
    ACTIONS(22495), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539103] = 2,
    ACTIONS(22497), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539111] = 2,
    ACTIONS(22499), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539119] = 2,
    ACTIONS(22501), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539127] = 2,
    ACTIONS(22503), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539135] = 2,
    ACTIONS(22505), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539143] = 2,
    ACTIONS(22507), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539151] = 2,
    ACTIONS(22509), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539159] = 2,
    ACTIONS(22511), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539167] = 2,
    ACTIONS(16448), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539175] = 2,
    ACTIONS(22513), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539183] = 2,
    ACTIONS(22515), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539191] = 2,
    ACTIONS(22517), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539199] = 2,
    ACTIONS(22519), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539207] = 2,
    ACTIONS(22521), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539215] = 2,
    ACTIONS(9588), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539223] = 2,
    ACTIONS(22523), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539231] = 2,
    ACTIONS(22525), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539239] = 2,
    ACTIONS(22527), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539247] = 2,
    ACTIONS(22529), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539255] = 2,
    ACTIONS(22531), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539263] = 2,
    ACTIONS(22533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539271] = 2,
    ACTIONS(22535), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539279] = 2,
    ACTIONS(22537), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539287] = 2,
    ACTIONS(22539), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539295] = 2,
    ACTIONS(22541), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539303] = 2,
    ACTIONS(22543), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539311] = 2,
    ACTIONS(22545), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539319] = 2,
    ACTIONS(22547), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539327] = 2,
    ACTIONS(22549), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539335] = 2,
    ACTIONS(22551), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539343] = 2,
    ACTIONS(22553), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539351] = 2,
    ACTIONS(22555), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539359] = 2,
    ACTIONS(22557), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539367] = 2,
    ACTIONS(22559), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539375] = 2,
    ACTIONS(19737), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539383] = 2,
    ACTIONS(22561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539391] = 2,
    ACTIONS(22563), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539399] = 2,
    ACTIONS(22565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539407] = 2,
    ACTIONS(22567), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539415] = 2,
    ACTIONS(22569), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539423] = 2,
    ACTIONS(22571), 1,
      sym_keyword_check,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539431] = 2,
    ACTIONS(22573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539439] = 2,
    ACTIONS(22575), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539447] = 2,
    ACTIONS(22577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539455] = 2,
    ACTIONS(16800), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539463] = 2,
    ACTIONS(22579), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539471] = 2,
    ACTIONS(22581), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539479] = 2,
    ACTIONS(22583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539487] = 2,
    ACTIONS(22585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539495] = 2,
    ACTIONS(22587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539503] = 2,
    ACTIONS(22589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539511] = 2,
    ACTIONS(22591), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539519] = 2,
    ACTIONS(22593), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539527] = 2,
    ACTIONS(22595), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539535] = 2,
    ACTIONS(22597), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539543] = 2,
    ACTIONS(22599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539551] = 2,
    ACTIONS(22601), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539559] = 2,
    ACTIONS(22603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539567] = 2,
    ACTIONS(22605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539575] = 2,
    ACTIONS(22607), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539583] = 2,
    ACTIONS(22609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539591] = 2,
    ACTIONS(22611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539599] = 2,
    ACTIONS(22613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539607] = 2,
    ACTIONS(22615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539615] = 2,
    ACTIONS(22617), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539623] = 2,
    ACTIONS(22619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539631] = 2,
    ACTIONS(22621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539639] = 2,
    ACTIONS(22623), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539647] = 2,
    ACTIONS(22625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539655] = 2,
    ACTIONS(22627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539663] = 2,
    ACTIONS(22629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539671] = 2,
    ACTIONS(22631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539679] = 2,
    ACTIONS(22633), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539687] = 2,
    ACTIONS(22635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539695] = 2,
    ACTIONS(22637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539703] = 2,
    ACTIONS(22639), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539711] = 2,
    ACTIONS(22641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539719] = 2,
    ACTIONS(22643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539727] = 2,
    ACTIONS(22645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539735] = 2,
    ACTIONS(22647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539743] = 2,
    ACTIONS(22649), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539751] = 2,
    ACTIONS(22651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539759] = 2,
    ACTIONS(22653), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539767] = 2,
    ACTIONS(22655), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539775] = 2,
    ACTIONS(22657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539783] = 2,
    ACTIONS(16748), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539791] = 2,
    ACTIONS(22659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539799] = 2,
    ACTIONS(22661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539807] = 2,
    ACTIONS(22663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539815] = 2,
    ACTIONS(22665), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539823] = 2,
    ACTIONS(22667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539831] = 2,
    ACTIONS(22669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539839] = 2,
    ACTIONS(22671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539847] = 2,
    ACTIONS(22673), 1,
      sym_keyword_returns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539855] = 2,
    ACTIONS(22675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539863] = 2,
    ACTIONS(22677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539871] = 2,
    ACTIONS(22679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539879] = 2,
    ACTIONS(22681), 1,
      sym_keyword_database,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539887] = 2,
    ACTIONS(22683), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539895] = 2,
    ACTIONS(22685), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539903] = 2,
    ACTIONS(22687), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539911] = 2,
    ACTIONS(22689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539919] = 2,
    ACTIONS(22691), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539927] = 2,
    ACTIONS(22693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539935] = 2,
    ACTIONS(22695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539943] = 2,
    ACTIONS(22697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539951] = 2,
    ACTIONS(22699), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539959] = 2,
    ACTIONS(22701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539967] = 2,
    ACTIONS(22703), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539975] = 2,
    ACTIONS(22705), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539983] = 2,
    ACTIONS(22707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539991] = 2,
    ACTIONS(22709), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [539999] = 2,
    ACTIONS(22711), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540007] = 2,
    ACTIONS(22713), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540015] = 2,
    ACTIONS(22715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540023] = 2,
    ACTIONS(22717), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540031] = 2,
    ACTIONS(22719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540039] = 2,
    ACTIONS(22721), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540047] = 2,
    ACTIONS(22723), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540055] = 2,
    ACTIONS(16450), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540063] = 2,
    ACTIONS(22725), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540071] = 2,
    ACTIONS(22727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540079] = 2,
    ACTIONS(15132), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540087] = 2,
    ACTIONS(22729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540095] = 2,
    ACTIONS(22731), 1,
      sym_keyword_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540103] = 2,
    ACTIONS(22733), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540111] = 2,
    ACTIONS(22735), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540119] = 2,
    ACTIONS(22737), 1,
      aux_sym__integer_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540127] = 2,
    ACTIONS(22739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540135] = 2,
    ACTIONS(14752), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540143] = 2,
    ACTIONS(15288), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540151] = 2,
    ACTIONS(22741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540159] = 2,
    ACTIONS(22743), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540167] = 2,
    ACTIONS(22745), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540175] = 2,
    ACTIONS(22747), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540183] = 2,
    ACTIONS(22749), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540191] = 2,
    ACTIONS(22751), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540199] = 2,
    ACTIONS(22753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540207] = 2,
    ACTIONS(22755), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540215] = 2,
    ACTIONS(22757), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540223] = 2,
    ACTIONS(22759), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540231] = 2,
    ACTIONS(22761), 1,
      sym_keyword_materialized,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540239] = 2,
    ACTIONS(22763), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540247] = 2,
    ACTIONS(22765), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540255] = 2,
    ACTIONS(22767), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540263] = 2,
    ACTIONS(22769), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540271] = 2,
    ACTIONS(9474), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540279] = 2,
    ACTIONS(22771), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540287] = 2,
    ACTIONS(22773), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540295] = 2,
    ACTIONS(22775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540303] = 2,
    ACTIONS(22777), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540311] = 2,
    ACTIONS(22779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540319] = 2,
    ACTIONS(22781), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540327] = 2,
    ACTIONS(22783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540335] = 2,
    ACTIONS(22785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540343] = 2,
    ACTIONS(22787), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540351] = 2,
    ACTIONS(22789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540359] = 2,
    ACTIONS(22791), 1,
      sym_keyword_security,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540367] = 2,
    ACTIONS(22793), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540375] = 2,
    ACTIONS(22795), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540383] = 2,
    ACTIONS(22797), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540391] = 2,
    ACTIONS(22799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540399] = 2,
    ACTIONS(22801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540407] = 2,
    ACTIONS(22803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540415] = 2,
    ACTIONS(22805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540423] = 2,
    ACTIONS(22807), 1,
      sym_keyword_others,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540431] = 2,
    ACTIONS(22809), 1,
      sym_keyword_row,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540439] = 2,
    ACTIONS(22811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540447] = 2,
    ACTIONS(22813), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540455] = 2,
    ACTIONS(22815), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540463] = 2,
    ACTIONS(22817), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540471] = 2,
    ACTIONS(22819), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540479] = 2,
    ACTIONS(22821), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540487] = 2,
    ACTIONS(22823), 1,
      sym_keyword_always,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540495] = 2,
    ACTIONS(22825), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540503] = 2,
    ACTIONS(22827), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540511] = 2,
    ACTIONS(22829), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540519] = 2,
    ACTIONS(22831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540527] = 2,
    ACTIONS(22833), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540535] = 2,
    ACTIONS(22835), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540543] = 2,
    ACTIONS(22837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540551] = 2,
    ACTIONS(22839), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540559] = 2,
    ACTIONS(9648), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540567] = 2,
    ACTIONS(22841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540575] = 2,
    ACTIONS(22843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540583] = 2,
    ACTIONS(22845), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540591] = 2,
    ACTIONS(22847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540599] = 2,
    ACTIONS(22849), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540607] = 2,
    ACTIONS(22851), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540615] = 2,
    ACTIONS(22853), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540623] = 2,
    ACTIONS(22855), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540631] = 2,
    ACTIONS(22857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540639] = 2,
    ACTIONS(15579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540647] = 2,
    ACTIONS(22859), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540655] = 2,
    ACTIONS(22861), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540663] = 2,
    ACTIONS(22863), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540671] = 2,
    ACTIONS(22865), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540679] = 2,
    ACTIONS(22867), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540687] = 2,
    ACTIONS(22869), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540695] = 2,
    ACTIONS(22871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540703] = 2,
    ACTIONS(9478), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540711] = 2,
    ACTIONS(19677), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540719] = 2,
    ACTIONS(22873), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540727] = 2,
    ACTIONS(22875), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540735] = 2,
    ACTIONS(22877), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540743] = 2,
    ACTIONS(15724), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540751] = 2,
    ACTIONS(14589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540759] = 2,
    ACTIONS(22879), 1,
      sym_keyword_atomic,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540767] = 2,
    ACTIONS(22881), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540775] = 2,
    ACTIONS(22883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540783] = 2,
    ACTIONS(22885), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540791] = 2,
    ACTIONS(22887), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540799] = 2,
    ACTIONS(22889), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540807] = 2,
    ACTIONS(15681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540815] = 2,
    ACTIONS(22891), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540823] = 2,
    ACTIONS(22893), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540831] = 2,
    ACTIONS(22895), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540839] = 2,
    ACTIONS(22897), 1,
      sym_keyword_action,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540847] = 2,
    ACTIONS(22899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540855] = 2,
    ACTIONS(22901), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540863] = 2,
    ACTIONS(22903), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540871] = 2,
    ACTIONS(22905), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540879] = 2,
    ACTIONS(22907), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540887] = 2,
    ACTIONS(22909), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540895] = 2,
    ACTIONS(22911), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540903] = 2,
    ACTIONS(22913), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540911] = 2,
    ACTIONS(22915), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540919] = 2,
    ACTIONS(22917), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540927] = 2,
    ACTIONS(15943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540935] = 2,
    ACTIONS(22919), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540943] = 2,
    ACTIONS(22921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540951] = 2,
    ACTIONS(22923), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540959] = 2,
    ACTIONS(22925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540967] = 2,
    ACTIONS(22927), 1,
      sym_keyword_bin_pack,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540975] = 2,
    ACTIONS(16486), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540983] = 2,
    ACTIONS(22929), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540991] = 2,
    ACTIONS(22931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [540999] = 2,
    ACTIONS(22933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541007] = 2,
    ACTIONS(22935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541015] = 2,
    ACTIONS(22937), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541023] = 2,
    ACTIONS(22939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541031] = 2,
    ACTIONS(22941), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541039] = 2,
    ACTIONS(22943), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541047] = 2,
    ACTIONS(22945), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541055] = 2,
    ACTIONS(19587), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541063] = 2,
    ACTIONS(22947), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541071] = 2,
    ACTIONS(22949), 1,
      sym_keyword_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541079] = 2,
    ACTIONS(22951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541087] = 2,
    ACTIONS(22953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541095] = 2,
    ACTIONS(22955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541103] = 2,
    ACTIONS(22957), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541111] = 2,
    ACTIONS(22959), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541119] = 2,
    ACTIONS(22961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541127] = 2,
    ACTIONS(22963), 1,
      sym_keyword_matched,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541135] = 2,
    ACTIONS(16568), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541143] = 2,
    ACTIONS(22965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541151] = 2,
    ACTIONS(22967), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541159] = 2,
    ACTIONS(22969), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541167] = 2,
    ACTIONS(16023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541175] = 2,
    ACTIONS(22971), 1,
      sym_keyword_input,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541183] = 2,
    ACTIONS(15328), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541191] = 2,
    ACTIONS(22973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541199] = 2,
    ACTIONS(22975), 1,
      sym_keyword_replication,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541207] = 2,
    ACTIONS(22977), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541215] = 2,
    ACTIONS(22979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541223] = 2,
    ACTIONS(22981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541231] = 2,
    ACTIONS(22983), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541239] = 2,
    ACTIONS(22985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541247] = 2,
    ACTIONS(22987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541255] = 2,
    ACTIONS(22989), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541263] = 2,
    ACTIONS(9500), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541271] = 2,
    ACTIONS(22991), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541279] = 2,
    ACTIONS(22993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541287] = 2,
    ACTIONS(19593), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541295] = 2,
    ACTIONS(22995), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541303] = 2,
    ACTIONS(22997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541311] = 2,
    ACTIONS(22999), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541319] = 2,
    ACTIONS(23001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541327] = 2,
    ACTIONS(15923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541335] = 2,
    ACTIONS(23003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541343] = 2,
    ACTIONS(23005), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541351] = 2,
    ACTIONS(23007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541359] = 2,
    ACTIONS(23009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541367] = 2,
    ACTIONS(23011), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541375] = 2,
    ACTIONS(23013), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541383] = 2,
    ACTIONS(23015), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541391] = 2,
    ACTIONS(23017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541399] = 2,
    ACTIONS(23019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541407] = 2,
    ACTIONS(23021), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541415] = 2,
    ACTIONS(23023), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541423] = 2,
    ACTIONS(23025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541431] = 2,
    ACTIONS(23027), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541439] = 2,
    ACTIONS(23029), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541447] = 2,
    ACTIONS(23031), 1,
      sym_keyword_input,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541455] = 2,
    ACTIONS(23033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541463] = 2,
    ACTIONS(23035), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541471] = 2,
    ACTIONS(23037), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541479] = 2,
    ACTIONS(23039), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541487] = 2,
    ACTIONS(23041), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541495] = 2,
    ACTIONS(23043), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541503] = 2,
    ACTIONS(23045), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541511] = 2,
    ACTIONS(23047), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541519] = 2,
    ACTIONS(23049), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541527] = 2,
    ACTIONS(23051), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541535] = 2,
    ACTIONS(23053), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541543] = 2,
    ACTIONS(23055), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541551] = 2,
    ACTIONS(23057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541559] = 2,
    ACTIONS(23059), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541567] = 2,
    ACTIONS(23061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541575] = 2,
    ACTIONS(23063), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541583] = 2,
    ACTIONS(19561), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541591] = 2,
    ACTIONS(23065), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541599] = 2,
    ACTIONS(23067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541607] = 2,
    ACTIONS(23069), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541615] = 2,
    ACTIONS(23071), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541623] = 2,
    ACTIONS(23073), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541631] = 2,
    ACTIONS(23075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541639] = 2,
    ACTIONS(23077), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541647] = 2,
    ACTIONS(23079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541655] = 2,
    ACTIONS(23081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541663] = 2,
    ACTIONS(23083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541671] = 2,
    ACTIONS(23085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541679] = 2,
    ACTIONS(23087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541687] = 2,
    ACTIONS(23089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541695] = 2,
    ACTIONS(23091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541703] = 2,
    ACTIONS(23093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541711] = 2,
    ACTIONS(23095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541719] = 2,
    ACTIONS(23097), 1,
      sym_keyword_bin_pack,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541727] = 2,
    ACTIONS(19539), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541735] = 2,
    ACTIONS(23099), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541743] = 2,
    ACTIONS(23101), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541751] = 2,
    ACTIONS(23103), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541759] = 2,
    ACTIONS(23105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541767] = 2,
    ACTIONS(23107), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541775] = 2,
    ACTIONS(23109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541783] = 2,
    ACTIONS(23111), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541791] = 2,
    ACTIONS(23113), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541799] = 2,
    ACTIONS(23115), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541807] = 2,
    ACTIONS(16390), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541815] = 2,
    ACTIONS(23117), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541823] = 2,
    ACTIONS(23119), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541831] = 2,
    ACTIONS(23121), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541839] = 2,
    ACTIONS(9458), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541847] = 2,
    ACTIONS(15268), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541855] = 2,
    ACTIONS(14776), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541863] = 2,
    ACTIONS(23123), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541871] = 2,
    ACTIONS(19527), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541879] = 2,
    ACTIONS(23125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541887] = 2,
    ACTIONS(20069), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541895] = 2,
    ACTIONS(15118), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541903] = 2,
    ACTIONS(19523), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541911] = 2,
    ACTIONS(23127), 1,
      sym_keyword_returns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541919] = 2,
    ACTIONS(23129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541927] = 2,
    ACTIONS(15879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541935] = 2,
    ACTIONS(23131), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541943] = 2,
    ACTIONS(23133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541951] = 2,
    ACTIONS(23135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541959] = 2,
    ACTIONS(23137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541967] = 2,
    ACTIONS(23139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541975] = 2,
    ACTIONS(23141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541983] = 2,
    ACTIONS(23143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541991] = 2,
    ACTIONS(23145), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [541999] = 2,
    ACTIONS(23147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542007] = 2,
    ACTIONS(23149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542015] = 2,
    ACTIONS(23151), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542023] = 2,
    ACTIONS(23153), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542031] = 2,
    ACTIONS(23155), 1,
      sym_keyword_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542039] = 2,
    ACTIONS(23157), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542047] = 2,
    ACTIONS(23159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542055] = 2,
    ACTIONS(23161), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542063] = 2,
    ACTIONS(23163), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542071] = 2,
    ACTIONS(16332), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542079] = 2,
    ACTIONS(23165), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542087] = 2,
    ACTIONS(19517), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542095] = 2,
    ACTIONS(23167), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542103] = 2,
    ACTIONS(23169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542111] = 2,
    ACTIONS(23171), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542119] = 2,
    ACTIONS(23173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542127] = 2,
    ACTIONS(23175), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542135] = 2,
    ACTIONS(23177), 1,
      sym_keyword_leakproof,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542143] = 2,
    ACTIONS(23179), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542151] = 2,
    ACTIONS(23181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542159] = 2,
    ACTIONS(23183), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542167] = 2,
    ACTIONS(23185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542175] = 2,
    ACTIONS(23187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542183] = 2,
    ACTIONS(23189), 1,
      sym_keyword_option,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542191] = 2,
    ACTIONS(23191), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542199] = 2,
    ACTIONS(23193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542207] = 2,
    ACTIONS(23195), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542215] = 2,
    ACTIONS(23197), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542223] = 2,
    ACTIONS(23199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542231] = 2,
    ACTIONS(23201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542239] = 2,
    ACTIONS(23203), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542247] = 2,
    ACTIONS(23205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542255] = 2,
    ACTIONS(23207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542263] = 2,
    ACTIONS(23209), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542271] = 2,
    ACTIONS(23211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542279] = 2,
    ACTIONS(23213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542287] = 2,
    ACTIONS(23215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542295] = 2,
    ACTIONS(23217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542303] = 2,
    ACTIONS(23219), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542311] = 2,
    ACTIONS(23221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542319] = 2,
    ACTIONS(23223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542327] = 2,
    ACTIONS(23225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542335] = 2,
    ACTIONS(23227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542343] = 2,
    ACTIONS(23229), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542351] = 2,
    ACTIONS(23231), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542359] = 2,
    ACTIONS(23233), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542367] = 2,
    ACTIONS(23235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542375] = 2,
    ACTIONS(23237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542383] = 2,
    ACTIONS(23239), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542391] = 2,
    ACTIONS(23241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542399] = 2,
    ACTIONS(23243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542407] = 2,
    ACTIONS(23245), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542415] = 2,
    ACTIONS(23247), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542423] = 2,
    ACTIONS(23249), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542431] = 2,
    ACTIONS(23251), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542439] = 2,
    ACTIONS(23253), 1,
      sym_keyword_columns,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542447] = 2,
    ACTIONS(15316), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542455] = 2,
    ACTIONS(17220), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542463] = 2,
    ACTIONS(23255), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542471] = 2,
    ACTIONS(23257), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542479] = 2,
    ACTIONS(23259), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542487] = 2,
    ACTIONS(23261), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542495] = 2,
    ACTIONS(23263), 1,
      sym_keyword_key,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542503] = 2,
    ACTIONS(23265), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542511] = 2,
    ACTIONS(23267), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542519] = 2,
    ACTIONS(23269), 1,
      sym_keyword_current,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542527] = 2,
    ACTIONS(23271), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542535] = 2,
    ACTIONS(18981), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542543] = 2,
    ACTIONS(23273), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542551] = 2,
    ACTIONS(23275), 1,
      sym_keyword_time,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542559] = 2,
    ACTIONS(23277), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542567] = 2,
    ACTIONS(17224), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542575] = 2,
    ACTIONS(23279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542583] = 2,
    ACTIONS(23281), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542591] = 2,
    ACTIONS(23283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542599] = 2,
    ACTIONS(23285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542607] = 2,
    ACTIONS(23287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542615] = 2,
    ACTIONS(23289), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542623] = 2,
    ACTIONS(23291), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542631] = 2,
    ACTIONS(23293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542639] = 2,
    ACTIONS(23295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542647] = 2,
    ACTIONS(23297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542655] = 2,
    ACTIONS(23299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542663] = 2,
    ACTIONS(23301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542671] = 2,
    ACTIONS(23303), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542679] = 2,
    ACTIONS(23305), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542687] = 2,
    ACTIONS(23307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542695] = 2,
    ACTIONS(23309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542703] = 2,
    ACTIONS(23311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542711] = 2,
    ACTIONS(23313), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542719] = 2,
    ACTIONS(23315), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542727] = 2,
    ACTIONS(23317), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542735] = 2,
    ACTIONS(23319), 1,
      sym_keyword_cycle,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542743] = 2,
    ACTIONS(23321), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542751] = 2,
    ACTIONS(23323), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542759] = 2,
    ACTIONS(23325), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542767] = 2,
    ACTIONS(23327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542775] = 2,
    ACTIONS(23329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542783] = 2,
    ACTIONS(23331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542791] = 2,
    ACTIONS(23333), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542799] = 2,
    ACTIONS(16180), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542807] = 2,
    ACTIONS(23335), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542815] = 2,
    ACTIONS(23337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542823] = 2,
    ACTIONS(15200), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542831] = 2,
    ACTIONS(23339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542839] = 2,
    ACTIONS(23341), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542847] = 2,
    ACTIONS(16168), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542855] = 2,
    ACTIONS(23343), 1,
      sym_keyword_bin_pack,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542863] = 2,
    ACTIONS(23345), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542871] = 2,
    ACTIONS(23347), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542879] = 2,
    ACTIONS(23349), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542887] = 2,
    ACTIONS(23351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542895] = 2,
    ACTIONS(23353), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542903] = 2,
    ACTIONS(23355), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542911] = 2,
    ACTIONS(23357), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542919] = 2,
    ACTIONS(23359), 1,
      sym_keyword_maxvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542927] = 2,
    ACTIONS(23361), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542935] = 2,
    ACTIONS(23363), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542943] = 2,
    ACTIONS(23365), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542951] = 2,
    ACTIONS(23367), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542959] = 2,
    ACTIONS(23359), 1,
      sym_keyword_minvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542967] = 2,
    ACTIONS(23369), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542975] = 2,
    ACTIONS(23371), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542983] = 2,
    ACTIONS(23373), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542991] = 2,
    ACTIONS(23375), 1,
      sym_keyword_maxvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [542999] = 2,
    ACTIONS(23375), 1,
      sym_keyword_minvalue,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543007] = 2,
    ACTIONS(23377), 1,
      aux_sym__integer_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543015] = 2,
    ACTIONS(23379), 1,
      sym_keyword_delimited,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543023] = 2,
    ACTIONS(23381), 1,
      sym_keyword_set,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543031] = 2,
    ACTIONS(23383), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543039] = 2,
    ACTIONS(23385), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543047] = 2,
    ACTIONS(23387), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543055] = 2,
    ACTIONS(23389), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543063] = 2,
    ACTIONS(23391), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543071] = 2,
    ACTIONS(17393), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543079] = 2,
    ACTIONS(23393), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543087] = 2,
    ACTIONS(23395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543095] = 2,
    ACTIONS(14734), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543103] = 2,
    ACTIONS(23397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543111] = 2,
    ACTIONS(23399), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543119] = 2,
    ACTIONS(15304), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543127] = 2,
    ACTIONS(17791), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543135] = 2,
    ACTIONS(23401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543143] = 2,
    ACTIONS(23403), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543151] = 2,
    ACTIONS(23405), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543159] = 2,
    ACTIONS(23407), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543167] = 2,
    ACTIONS(23409), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543175] = 2,
    ACTIONS(23411), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543183] = 2,
    ACTIONS(23413), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543191] = 2,
    ACTIONS(23415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543199] = 2,
    ACTIONS(23417), 1,
      sym_keyword_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543207] = 2,
    ACTIONS(23419), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543215] = 2,
    ACTIONS(23421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543223] = 2,
    ACTIONS(23423), 1,
      sym_keyword_is,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543231] = 2,
    ACTIONS(23425), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543239] = 2,
    ACTIONS(23427), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543247] = 2,
    ACTIONS(19421), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543255] = 2,
    ACTIONS(23429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543263] = 2,
    ACTIONS(23431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543271] = 2,
    ACTIONS(23433), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543279] = 2,
    ACTIONS(23435), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543287] = 2,
    ACTIONS(23437), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543295] = 2,
    ACTIONS(23439), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543303] = 2,
    ACTIONS(23441), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543311] = 2,
    ACTIONS(23443), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543319] = 2,
    ACTIONS(23445), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543327] = 2,
    ACTIONS(23447), 1,
      sym_keyword_schema,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543335] = 2,
    ACTIONS(17811), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543343] = 2,
    ACTIONS(15332), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543351] = 2,
    ACTIONS(23449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543359] = 2,
    ACTIONS(23451), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543367] = 2,
    ACTIONS(23453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543375] = 2,
    ACTIONS(23455), 1,
      sym_keyword_oids,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543383] = 2,
    ACTIONS(23457), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543391] = 2,
    ACTIONS(23459), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543399] = 2,
    ACTIONS(23461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543407] = 2,
    ACTIONS(23463), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543415] = 2,
    ACTIONS(23465), 1,
      sym_keyword_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543423] = 2,
    ACTIONS(23467), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543431] = 2,
    ACTIONS(23469), 1,
      sym_keyword_until,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543439] = 2,
    ACTIONS(23471), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543447] = 2,
    ACTIONS(23473), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543455] = 2,
    ACTIONS(23475), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543463] = 2,
    ACTIONS(23477), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543471] = 2,
    ACTIONS(23479), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543479] = 2,
    ACTIONS(23481), 1,
      sym_keyword_password,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543487] = 2,
    ACTIONS(23483), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543495] = 2,
    ACTIONS(23485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543503] = 2,
    ACTIONS(23487), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543511] = 2,
    ACTIONS(23489), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543519] = 2,
    ACTIONS(23491), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543527] = 2,
    ACTIONS(23493), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543535] = 2,
    ACTIONS(18192), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543543] = 2,
    ACTIONS(17113), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543551] = 2,
    ACTIONS(23495), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543559] = 2,
    ACTIONS(23497), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543567] = 2,
    ACTIONS(9705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543575] = 2,
    ACTIONS(23499), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543583] = 2,
    ACTIONS(23501), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543591] = 2,
    ACTIONS(23503), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543599] = 2,
    ACTIONS(23505), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543607] = 2,
    ACTIONS(15975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543615] = 2,
    ACTIONS(15913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543623] = 2,
    ACTIONS(23507), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543631] = 2,
    ACTIONS(23509), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543639] = 2,
    ACTIONS(23511), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543647] = 2,
    ACTIONS(23513), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543655] = 2,
    ACTIONS(23515), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543663] = 2,
    ACTIONS(23517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543671] = 2,
    ACTIONS(23519), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543679] = 2,
    ACTIONS(23521), 1,
      sym_keyword_exists,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543687] = 2,
    ACTIONS(23523), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543695] = 2,
    ACTIONS(23525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543703] = 2,
    ACTIONS(23527), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543711] = 2,
    ACTIONS(23529), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543719] = 2,
    ACTIONS(23531), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543727] = 2,
    ACTIONS(23533), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543735] = 2,
    ACTIONS(23535), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543743] = 2,
    ACTIONS(23537), 1,
      sym_keyword_compute,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543751] = 2,
    ACTIONS(23539), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543759] = 2,
    ACTIONS(23541), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543767] = 2,
    ACTIONS(23543), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543775] = 2,
    ACTIONS(23545), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543783] = 2,
    ACTIONS(23547), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543791] = 2,
    ACTIONS(23549), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543799] = 2,
    ACTIONS(23551), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543807] = 2,
    ACTIONS(23553), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543815] = 2,
    ACTIONS(23555), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543823] = 2,
    ACTIONS(23557), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543831] = 2,
    ACTIONS(23559), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543839] = 2,
    ACTIONS(23561), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543847] = 2,
    ACTIONS(23563), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543855] = 2,
    ACTIONS(23565), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543863] = 2,
    ACTIONS(23567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543871] = 2,
    ACTIONS(23569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543879] = 2,
    ACTIONS(23571), 1,
      sym_keyword_level,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543887] = 2,
    ACTIONS(23573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543895] = 2,
    ACTIONS(23575), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543903] = 2,
    ACTIONS(15927), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543911] = 2,
    ACTIONS(23577), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543919] = 2,
    ACTIONS(23579), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543927] = 2,
    ACTIONS(23581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543935] = 2,
    ACTIONS(23583), 1,
      sym__identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543943] = 2,
    ACTIONS(23585), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543951] = 2,
    ACTIONS(23587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543959] = 2,
    ACTIONS(23589), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543967] = 2,
    ACTIONS(23591), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543975] = 2,
    ACTIONS(23593), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543983] = 2,
    ACTIONS(23595), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543991] = 2,
    ACTIONS(15913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [543999] = 2,
    ACTIONS(23597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544007] = 2,
    ACTIONS(23599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544015] = 2,
    ACTIONS(23601), 1,
      sym_keyword_stats,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544023] = 2,
    ACTIONS(23603), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544031] = 2,
    ACTIONS(23605), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544039] = 2,
    ACTIONS(23607), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544047] = 2,
    ACTIONS(23609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544055] = 2,
    ACTIONS(23611), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544063] = 2,
    ACTIONS(23613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544071] = 2,
    ACTIONS(23615), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544079] = 2,
    ACTIONS(23617), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544087] = 2,
    ACTIONS(23619), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544095] = 2,
    ACTIONS(23621), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544103] = 2,
    ACTIONS(23623), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544111] = 2,
    ACTIONS(23625), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544119] = 2,
    ACTIONS(23627), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544127] = 2,
    ACTIONS(23629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544135] = 2,
    ACTIONS(23631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544143] = 2,
    ACTIONS(15907), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544151] = 2,
    ACTIONS(23633), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544159] = 2,
    ACTIONS(23635), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544167] = 2,
    ACTIONS(23637), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544175] = 2,
    ACTIONS(23639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544183] = 2,
    ACTIONS(23641), 1,
      sym_keyword_format,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544191] = 2,
    ACTIONS(23643), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544199] = 2,
    ACTIONS(23645), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544207] = 2,
    ACTIONS(23647), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544215] = 2,
    ACTIONS(23649), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544223] = 2,
    ACTIONS(23651), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544231] = 2,
    ACTIONS(23653), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544239] = 2,
    ACTIONS(23655), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544247] = 2,
    ACTIONS(23657), 1,
      sym_keyword_distinct,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544255] = 2,
    ACTIONS(23659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544263] = 2,
    ACTIONS(23661), 1,
      sym_keyword_statistics,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544271] = 2,
    ACTIONS(23663), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544279] = 2,
    ACTIONS(23665), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544287] = 2,
    ACTIONS(23667), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544295] = 2,
    ACTIONS(23669), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544303] = 2,
    ACTIONS(23671), 1,
      sym_keyword_type,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544311] = 2,
    ACTIONS(23673), 1,
      sym_keyword_limit,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544319] = 2,
    ACTIONS(23675), 1,
      sym_keyword_until,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544327] = 2,
    ACTIONS(23677), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544335] = 2,
    ACTIONS(23679), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544343] = 2,
    ACTIONS(23681), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544351] = 2,
    ACTIONS(23683), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544359] = 2,
    ACTIONS(23685), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544367] = 2,
    ACTIONS(23687), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544375] = 2,
    ACTIONS(23689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544383] = 2,
    ACTIONS(23691), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544391] = 2,
    ACTIONS(23693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544399] = 2,
    ACTIONS(23695), 1,
      sym_keyword_password,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544407] = 2,
    ACTIONS(23697), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544415] = 2,
    ACTIONS(23699), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544423] = 2,
    ACTIONS(23701), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544431] = 2,
    ACTIONS(23703), 1,
      sym_keyword_to,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544439] = 2,
    ACTIONS(23705), 1,
      sym_keyword_materialized,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544447] = 2,
    ACTIONS(23707), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544455] = 2,
    ACTIONS(23709), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544463] = 2,
    ACTIONS(23711), 1,
      sym_keyword_transaction,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544471] = 2,
    ACTIONS(23713), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544479] = 2,
    ACTIONS(23715), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544487] = 2,
    ACTIONS(23717), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544495] = 2,
    ACTIONS(23719), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544503] = 2,
    ACTIONS(23721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544511] = 2,
    ACTIONS(23723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544519] = 2,
    ACTIONS(23725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544527] = 2,
    ACTIONS(23727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544535] = 2,
    ACTIONS(23729), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544543] = 2,
    ACTIONS(23731), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544551] = 2,
    ACTIONS(23733), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544559] = 2,
    ACTIONS(23735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544567] = 2,
    ACTIONS(23737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544575] = 2,
    ACTIONS(23739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544583] = 2,
    ACTIONS(23741), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544591] = 2,
    ACTIONS(23743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544599] = 2,
    ACTIONS(23745), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544607] = 2,
    ACTIONS(23747), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544615] = 2,
    ACTIONS(23749), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544623] = 2,
    ACTIONS(23751), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544631] = 2,
    ACTIONS(23753), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544639] = 2,
    ACTIONS(23755), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544647] = 2,
    ACTIONS(23757), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544655] = 2,
    ACTIONS(23759), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544663] = 2,
    ACTIONS(23761), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544671] = 2,
    ACTIONS(23763), 1,
      sym_keyword_deferrable,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544679] = 2,
    ACTIONS(23765), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544687] = 2,
    ACTIONS(23767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544695] = 2,
    ACTIONS(23769), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544703] = 2,
    ACTIONS(23771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544711] = 2,
    ACTIONS(23773), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544719] = 2,
    ACTIONS(23775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544727] = 2,
    ACTIONS(23777), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544735] = 2,
    ACTIONS(23779), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544743] = 2,
    ACTIONS(23781), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544751] = 2,
    ACTIONS(23783), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544759] = 2,
    ACTIONS(23785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544767] = 2,
    ACTIONS(23787), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544775] = 2,
    ACTIONS(23789), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544783] = 2,
    ACTIONS(23791), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544791] = 2,
    ACTIONS(23793), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544799] = 2,
    ACTIONS(23795), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544807] = 2,
    ACTIONS(23797), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544815] = 2,
    ACTIONS(23799), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544823] = 2,
    ACTIONS(23801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544831] = 2,
    ACTIONS(23803), 1,
      sym_keyword_matched,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544839] = 2,
    ACTIONS(23805), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544847] = 2,
    ACTIONS(23807), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544855] = 2,
    ACTIONS(23809), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544863] = 2,
    ACTIONS(23811), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544871] = 2,
    ACTIONS(23813), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544879] = 2,
    ACTIONS(23815), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544887] = 2,
    ACTIONS(23817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544895] = 2,
    ACTIONS(23819), 1,
      sym_keyword_replication,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544903] = 2,
    ACTIONS(23821), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544911] = 2,
    ACTIONS(19289), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544919] = 2,
    ACTIONS(23823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544927] = 2,
    ACTIONS(1698), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544935] = 2,
    ACTIONS(15128), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544943] = 2,
    ACTIONS(18549), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544951] = 2,
    ACTIONS(23825), 1,
      sym_keyword_index,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544959] = 2,
    ACTIONS(23827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544967] = 2,
    ACTIONS(9450), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544975] = 2,
    ACTIONS(23829), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544983] = 2,
    ACTIONS(15036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544991] = 2,
    ACTIONS(23831), 1,
      sym_keyword_index,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [544999] = 2,
    ACTIONS(13638), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545007] = 2,
    ACTIONS(14571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545015] = 2,
    ACTIONS(23833), 1,
      sym_keyword_rewrite,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545023] = 2,
    ACTIONS(23835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545031] = 2,
    ACTIONS(19879), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545039] = 2,
    ACTIONS(15060), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545047] = 2,
    ACTIONS(23837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545055] = 2,
    ACTIONS(15819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545063] = 2,
    ACTIONS(23839), 1,
      sym_keyword_not,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545071] = 2,
    ACTIONS(23841), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545079] = 2,
    ACTIONS(23843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545087] = 2,
    ACTIONS(23845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545095] = 2,
    ACTIONS(16212), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545103] = 2,
    ACTIONS(23847), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545111] = 2,
    ACTIONS(23849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545119] = 2,
    ACTIONS(23851), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545127] = 2,
    ACTIONS(23853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545135] = 2,
    ACTIONS(23855), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545143] = 2,
    ACTIONS(23857), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545151] = 2,
    ACTIONS(23859), 1,
      sym_keyword_row,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545159] = 2,
    ACTIONS(18472), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545167] = 2,
    ACTIONS(23861), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545175] = 2,
    ACTIONS(23863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545183] = 2,
    ACTIONS(23865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545191] = 2,
    ACTIONS(23867), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545199] = 2,
    ACTIONS(23869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545207] = 2,
    ACTIONS(23871), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545215] = 2,
    ACTIONS(23873), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545223] = 2,
    ACTIONS(23875), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545231] = 2,
    ACTIONS(23877), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545239] = 2,
    ACTIONS(23879), 1,
      sym_keyword_input,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545247] = 2,
    ACTIONS(19293), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545255] = 2,
    ACTIONS(23881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545263] = 2,
    ACTIONS(18446), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545271] = 2,
    ACTIONS(23883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545279] = 2,
    ACTIONS(23885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545287] = 2,
    ACTIONS(23887), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545295] = 2,
    ACTIONS(23889), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545303] = 2,
    ACTIONS(23891), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545311] = 2,
    ACTIONS(23893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545319] = 2,
    ACTIONS(23895), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545327] = 2,
    ACTIONS(23897), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545335] = 2,
    ACTIONS(23899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545343] = 2,
    ACTIONS(23901), 1,
      sym_keyword_metadata,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545351] = 2,
    ACTIONS(23903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545359] = 2,
    ACTIONS(19279), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545367] = 2,
    ACTIONS(23905), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545375] = 2,
    ACTIONS(23907), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545383] = 2,
    ACTIONS(23909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545391] = 2,
    ACTIONS(23911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545399] = 2,
    ACTIONS(23913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545407] = 2,
    ACTIONS(23915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545415] = 2,
    ACTIONS(23917), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545423] = 2,
    ACTIONS(15785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545431] = 2,
    ACTIONS(23919), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545439] = 2,
    ACTIONS(23921), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545447] = 2,
    ACTIONS(23923), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545455] = 2,
    ACTIONS(19275), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545463] = 2,
    ACTIONS(23925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545471] = 2,
    ACTIONS(23927), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545479] = 2,
    ACTIONS(23929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545487] = 2,
    ACTIONS(23931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545495] = 2,
    ACTIONS(23933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545503] = 2,
    ACTIONS(23935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545511] = 2,
    ACTIONS(23937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545519] = 2,
    ACTIONS(23939), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545527] = 2,
    ACTIONS(23941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545535] = 2,
    ACTIONS(19267), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545543] = 2,
    ACTIONS(23943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545551] = 2,
    ACTIONS(23945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545559] = 2,
    ACTIONS(23947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545567] = 2,
    ACTIONS(23949), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545575] = 2,
    ACTIONS(16023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545583] = 2,
    ACTIONS(23951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545591] = 2,
    ACTIONS(23953), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545599] = 2,
    ACTIONS(23955), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545607] = 2,
    ACTIONS(23957), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545615] = 2,
    ACTIONS(23959), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545623] = 2,
    ACTIONS(23961), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545631] = 2,
    ACTIONS(23963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545639] = 2,
    ACTIONS(23965), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545647] = 2,
    ACTIONS(23967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545655] = 2,
    ACTIONS(23969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545663] = 2,
    ACTIONS(23971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545671] = 2,
    ACTIONS(23973), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545679] = 2,
    ACTIONS(23975), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545687] = 2,
    ACTIONS(23977), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545695] = 2,
    ACTIONS(23979), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545703] = 2,
    ACTIONS(23981), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545711] = 2,
    ACTIONS(23983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545719] = 2,
    ACTIONS(23985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545727] = 2,
    ACTIONS(23987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545735] = 2,
    ACTIONS(23989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545743] = 2,
    ACTIONS(23991), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545751] = 2,
    ACTIONS(23993), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545759] = 2,
    ACTIONS(23995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545767] = 2,
    ACTIONS(23997), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545775] = 2,
    ACTIONS(23999), 1,
      sym_keyword_rewrite,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545783] = 2,
    ACTIONS(24001), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545791] = 2,
    ACTIONS(24003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545799] = 2,
    ACTIONS(24005), 1,
      sym_keyword_stats,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545807] = 2,
    ACTIONS(24007), 1,
      sym_keyword_null,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545815] = 2,
    ACTIONS(24009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545823] = 2,
    ACTIONS(24011), 1,
      sym_keyword_check,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545831] = 2,
    ACTIONS(24013), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545839] = 2,
    ACTIONS(24015), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545847] = 2,
    ACTIONS(24017), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545855] = 2,
    ACTIONS(24019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545863] = 2,
    ACTIONS(24021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545871] = 2,
    ACTIONS(24023), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545879] = 2,
    ACTIONS(24025), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545887] = 2,
    ACTIONS(24027), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545895] = 2,
    ACTIONS(24029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545903] = 2,
    ACTIONS(24031), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545911] = 2,
    ACTIONS(24033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545919] = 2,
    ACTIONS(24035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545927] = 2,
    ACTIONS(24037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545935] = 2,
    ACTIONS(24039), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545943] = 2,
    ACTIONS(24041), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545951] = 2,
    ACTIONS(24043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545959] = 2,
    ACTIONS(24045), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545967] = 2,
    ACTIONS(24047), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545975] = 2,
    ACTIONS(24049), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545983] = 2,
    ACTIONS(24051), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545991] = 2,
    ACTIONS(24053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [545999] = 2,
    ACTIONS(24055), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546007] = 2,
    ACTIONS(24057), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546015] = 2,
    ACTIONS(24059), 1,
      sym_keyword_input,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546023] = 2,
    ACTIONS(17434), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546031] = 2,
    ACTIONS(24061), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546039] = 2,
    ACTIONS(24063), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546047] = 2,
    ACTIONS(24065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546055] = 2,
    ACTIONS(24067), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546063] = 2,
    ACTIONS(24069), 1,
      sym_keyword_authorization,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546071] = 2,
    ACTIONS(24071), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546079] = 2,
    ACTIONS(24073), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546087] = 2,
    ACTIONS(24075), 1,
      sym_keyword_data,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546095] = 2,
    ACTIONS(24077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546103] = 2,
    ACTIONS(24079), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546111] = 2,
    ACTIONS(24081), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546119] = 2,
    ACTIONS(24083), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546127] = 2,
    ACTIONS(24085), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546135] = 2,
    ACTIONS(24087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546143] = 2,
    ACTIONS(24089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546151] = 2,
    ACTIONS(24091), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546159] = 2,
    ACTIONS(24093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546167] = 2,
    ACTIONS(24095), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546175] = 2,
    ACTIONS(24097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546183] = 2,
    ACTIONS(24099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546191] = 2,
    ACTIONS(24101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546199] = 2,
    ACTIONS(24103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546207] = 2,
    ACTIONS(24105), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546215] = 2,
    ACTIONS(24107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546223] = 2,
    ACTIONS(24109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546231] = 2,
    ACTIONS(24111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546239] = 2,
    ACTIONS(24113), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546247] = 2,
    ACTIONS(24115), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546255] = 2,
    ACTIONS(24117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546263] = 2,
    ACTIONS(24119), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546271] = 2,
    ACTIONS(24121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546279] = 2,
    ACTIONS(24123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546287] = 2,
    ACTIONS(24125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546295] = 2,
    ACTIONS(24127), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546303] = 2,
    ACTIONS(24129), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546311] = 2,
    ACTIONS(24131), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546319] = 2,
    ACTIONS(24133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546327] = 2,
    ACTIONS(24135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546335] = 2,
    ACTIONS(24137), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546343] = 2,
    ACTIONS(24139), 1,
      sym_keyword_read,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546351] = 2,
    ACTIONS(24141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546359] = 2,
    ACTIONS(24143), 1,
      sym_keyword_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546367] = 2,
    ACTIONS(19161), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546375] = 2,
    ACTIONS(24145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546383] = 2,
    ACTIONS(24147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546391] = 2,
    ACTIONS(19157), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546399] = 2,
    ACTIONS(24149), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546407] = 2,
    ACTIONS(24151), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546415] = 2,
    ACTIONS(24153), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546423] = 2,
    ACTIONS(24155), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546431] = 2,
    ACTIONS(24157), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546439] = 2,
    ACTIONS(24159), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546447] = 2,
    ACTIONS(24161), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546455] = 2,
    ACTIONS(24163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546463] = 2,
    ACTIONS(24165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546471] = 2,
    ACTIONS(24167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546479] = 2,
    ACTIONS(24169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546487] = 2,
    ACTIONS(24171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546495] = 2,
    ACTIONS(24173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546503] = 2,
    ACTIONS(19145), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546511] = 2,
    ACTIONS(24175), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546519] = 2,
    ACTIONS(24177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546527] = 2,
    ACTIONS(19141), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546535] = 2,
    ACTIONS(24179), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546543] = 2,
    ACTIONS(24181), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546551] = 2,
    ACTIONS(24183), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546559] = 2,
    ACTIONS(24185), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546567] = 2,
    ACTIONS(24187), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546575] = 2,
    ACTIONS(24189), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546583] = 2,
    ACTIONS(24191), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546591] = 2,
    ACTIONS(24193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546599] = 2,
    ACTIONS(24195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546607] = 2,
    ACTIONS(24197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546615] = 2,
    ACTIONS(24199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546623] = 2,
    ACTIONS(24201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546631] = 2,
    ACTIONS(19129), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546639] = 2,
    ACTIONS(24203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546647] = 2,
    ACTIONS(24205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546655] = 2,
    ACTIONS(19125), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546663] = 2,
    ACTIONS(24207), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546671] = 2,
    ACTIONS(24209), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546679] = 2,
    ACTIONS(24211), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546687] = 2,
    ACTIONS(24213), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546695] = 2,
    ACTIONS(24215), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546703] = 2,
    ACTIONS(24217), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546711] = 2,
    ACTIONS(24219), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546719] = 2,
    ACTIONS(24221), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546727] = 2,
    ACTIONS(24223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546735] = 2,
    ACTIONS(24225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546743] = 2,
    ACTIONS(24227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546751] = 2,
    ACTIONS(24229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546759] = 2,
    ACTIONS(19115), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546767] = 2,
    ACTIONS(24231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546775] = 2,
    ACTIONS(24233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546783] = 2,
    ACTIONS(19111), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546791] = 2,
    ACTIONS(24235), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546799] = 2,
    ACTIONS(24237), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546807] = 2,
    ACTIONS(24239), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546815] = 2,
    ACTIONS(24241), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546823] = 2,
    ACTIONS(24243), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546831] = 2,
    ACTIONS(24245), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546839] = 2,
    ACTIONS(24247), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546847] = 2,
    ACTIONS(24249), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546855] = 2,
    ACTIONS(24251), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546863] = 2,
    ACTIONS(24253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546871] = 2,
    ACTIONS(24255), 1,
      sym_keyword_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546879] = 2,
    ACTIONS(24257), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546887] = 2,
    ACTIONS(19103), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546895] = 2,
    ACTIONS(15446), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546903] = 2,
    ACTIONS(24259), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546911] = 2,
    ACTIONS(24261), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546919] = 2,
    ACTIONS(24263), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546927] = 2,
    ACTIONS(24265), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546935] = 2,
    ACTIONS(24267), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546943] = 2,
    ACTIONS(24269), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546951] = 2,
    ACTIONS(24271), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546959] = 2,
    ACTIONS(24273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546967] = 2,
    ACTIONS(24275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546975] = 2,
    ACTIONS(24277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546983] = 2,
    ACTIONS(24279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546991] = 2,
    ACTIONS(19085), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [546999] = 2,
    ACTIONS(24281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547007] = 2,
    ACTIONS(24283), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547015] = 2,
    ACTIONS(24285), 1,
      sym_keyword_join,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547023] = 2,
    ACTIONS(24287), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547031] = 2,
    ACTIONS(24289), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547039] = 2,
    ACTIONS(24291), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547047] = 2,
    ACTIONS(24293), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547055] = 2,
    ACTIONS(24295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547063] = 2,
    ACTIONS(24297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547071] = 2,
    ACTIONS(24299), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547079] = 2,
    ACTIONS(24301), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547087] = 2,
    ACTIONS(24303), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547095] = 2,
    ACTIONS(24305), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547103] = 2,
    ACTIONS(24307), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547111] = 2,
    ACTIONS(24309), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547119] = 2,
    ACTIONS(24311), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547127] = 2,
    ACTIONS(16992), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547135] = 2,
    ACTIONS(24313), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547143] = 2,
    ACTIONS(24315), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547151] = 2,
    ACTIONS(24317), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547159] = 2,
    ACTIONS(24319), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547167] = 2,
    ACTIONS(24321), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547175] = 2,
    ACTIONS(24323), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547183] = 2,
    ACTIONS(14810), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547191] = 2,
    ACTIONS(24325), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547199] = 2,
    ACTIONS(24327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547207] = 2,
    ACTIONS(24329), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547215] = 2,
    ACTIONS(24331), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547223] = 2,
    ACTIONS(24333), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547231] = 2,
    ACTIONS(24335), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547239] = 2,
    ACTIONS(24337), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547247] = 2,
    ACTIONS(13728), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547255] = 2,
    ACTIONS(24339), 1,
      sym_keyword_index,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547263] = 2,
    ACTIONS(24341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547271] = 2,
    ACTIONS(24343), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547279] = 2,
    ACTIONS(24345), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547287] = 2,
    ACTIONS(24347), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547295] = 2,
    ACTIONS(24349), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547303] = 2,
    ACTIONS(24351), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547311] = 2,
    ACTIONS(24353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547319] = 2,
    ACTIONS(15508), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547327] = 2,
    ACTIONS(24355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547335] = 2,
    ACTIONS(24357), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547343] = 2,
    ACTIONS(24359), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547351] = 2,
    ACTIONS(24361), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547359] = 2,
    ACTIONS(24363), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547367] = 2,
    ACTIONS(24365), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547375] = 2,
    ACTIONS(15773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547383] = 2,
    ACTIONS(24367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547391] = 2,
    ACTIONS(24369), 1,
      sym_keyword_replace,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547399] = 2,
    ACTIONS(24371), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547407] = 2,
    ACTIONS(24373), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547415] = 2,
    ACTIONS(24375), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547423] = 2,
    ACTIONS(24377), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547431] = 2,
    ACTIONS(24379), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547439] = 2,
    ACTIONS(24381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547447] = 2,
    ACTIONS(24383), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547455] = 2,
    ACTIONS(24385), 1,
      sym_keyword_view,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547463] = 2,
    ACTIONS(24387), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547471] = 2,
    ACTIONS(24389), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547479] = 2,
    ACTIONS(24391), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547487] = 2,
    ACTIONS(24393), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547495] = 2,
    ACTIONS(24395), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547503] = 2,
    ACTIONS(24397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547511] = 2,
    ACTIONS(24399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547519] = 2,
    ACTIONS(24401), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547527] = 2,
    ACTIONS(24403), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547535] = 2,
    ACTIONS(24405), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547543] = 2,
    ACTIONS(24407), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547551] = 2,
    ACTIONS(24409), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547559] = 2,
    ACTIONS(24411), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547567] = 2,
    ACTIONS(24413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547575] = 2,
    ACTIONS(24415), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547583] = 2,
    ACTIONS(24417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547591] = 2,
    ACTIONS(24419), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547599] = 2,
    ACTIONS(24421), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547607] = 2,
    ACTIONS(24423), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547615] = 2,
    ACTIONS(24425), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547623] = 2,
    ACTIONS(24427), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547631] = 2,
    ACTIONS(24429), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547639] = 2,
    ACTIONS(24431), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547647] = 2,
    ACTIONS(24433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547655] = 2,
    ACTIONS(24435), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547663] = 2,
    ACTIONS(24437), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547671] = 2,
    ACTIONS(24439), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547679] = 2,
    ACTIONS(24441), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547687] = 2,
    ACTIONS(24443), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547695] = 2,
    ACTIONS(24445), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547703] = 2,
    ACTIONS(24447), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547711] = 2,
    ACTIONS(24449), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547719] = 2,
    ACTIONS(24451), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547727] = 2,
    ACTIONS(24453), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547735] = 2,
    ACTIONS(24455), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547743] = 2,
    ACTIONS(24457), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547751] = 2,
    ACTIONS(24459), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547759] = 2,
    ACTIONS(24461), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547767] = 2,
    ACTIONS(24463), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547775] = 2,
    ACTIONS(24465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547783] = 2,
    ACTIONS(24467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547791] = 2,
    ACTIONS(24469), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547799] = 2,
    ACTIONS(24471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547807] = 2,
    ACTIONS(24473), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547815] = 2,
    ACTIONS(24475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547823] = 2,
    ACTIONS(24477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547831] = 2,
    ACTIONS(24479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547839] = 2,
    ACTIONS(24481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547847] = 2,
    ACTIONS(24483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547855] = 2,
    ACTIONS(24485), 1,
      sym_keyword_index,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547863] = 2,
    ACTIONS(24487), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547871] = 2,
    ACTIONS(24489), 1,
      sym_keyword_rewrite,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547879] = 2,
    ACTIONS(24491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547887] = 2,
    ACTIONS(24493), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547895] = 2,
    ACTIONS(24495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547903] = 2,
    ACTIONS(24497), 1,
      sym_keyword_action,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547911] = 2,
    ACTIONS(24499), 1,
      sym_keyword_level,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547919] = 2,
    ACTIONS(24501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547927] = 2,
    ACTIONS(24503), 1,
      sym_keyword_terminated,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547935] = 2,
    ACTIONS(24505), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547943] = 2,
    ACTIONS(24507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547951] = 2,
    ACTIONS(24509), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547959] = 2,
    ACTIONS(24511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547967] = 2,
    ACTIONS(24513), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547975] = 2,
    ACTIONS(24515), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547983] = 2,
    ACTIONS(24517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547991] = 2,
    ACTIONS(24519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [547999] = 2,
    ACTIONS(24521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548007] = 2,
    ACTIONS(24523), 1,
      sym__dollar_quoted_string_end_tag,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548015] = 2,
    ACTIONS(24525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548023] = 2,
    ACTIONS(24527), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548031] = 2,
    ACTIONS(24529), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548039] = 2,
    ACTIONS(24531), 1,
      sym_keyword_by,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548047] = 2,
    ACTIONS(24533), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548055] = 2,
    ACTIONS(24535), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548063] = 2,
    ACTIONS(24537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548071] = 2,
    ACTIONS(24539), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548079] = 2,
    ACTIONS(24541), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548087] = 2,
    ACTIONS(24543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548095] = 2,
    ACTIONS(24545), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548103] = 2,
    ACTIONS(24547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548111] = 2,
    ACTIONS(24549), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548119] = 2,
    ACTIONS(24551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548127] = 2,
    ACTIONS(24553), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548135] = 2,
    ACTIONS(24555), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548143] = 2,
    ACTIONS(24557), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548151] = 2,
    ACTIONS(24559), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548159] = 2,
    ACTIONS(24561), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548167] = 2,
    ACTIONS(24563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548175] = 2,
    ACTIONS(24565), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548183] = 2,
    ACTIONS(24567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548191] = 2,
    ACTIONS(24569), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548199] = 2,
    ACTIONS(24571), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548207] = 2,
    ACTIONS(24573), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548215] = 2,
    ACTIONS(24575), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548223] = 2,
    ACTIONS(24577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548231] = 2,
    ACTIONS(24579), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548239] = 2,
    ACTIONS(24581), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548247] = 2,
    ACTIONS(24583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548255] = 2,
    ACTIONS(9522), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548263] = 2,
    ACTIONS(24585), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548271] = 2,
    ACTIONS(24587), 1,
      sym__natural_number,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548279] = 2,
    ACTIONS(24589), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548287] = 2,
    ACTIONS(24591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548295] = 2,
    ACTIONS(24593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548303] = 2,
    ACTIONS(24595), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548311] = 2,
    ACTIONS(24597), 1,
      sym_keyword_index,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548319] = 2,
    ACTIONS(24599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548327] = 2,
    ACTIONS(24601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548335] = 2,
    ACTIONS(24603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548343] = 2,
    ACTIONS(24605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548351] = 2,
    ACTIONS(24607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548359] = 2,
    ACTIONS(24609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548367] = 2,
    ACTIONS(24611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548375] = 2,
    ACTIONS(24613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548383] = 2,
    ACTIONS(24615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548391] = 2,
    ACTIONS(24617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548399] = 2,
    ACTIONS(24619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548407] = 2,
    ACTIONS(24621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548415] = 2,
    ACTIONS(24623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548423] = 2,
    ACTIONS(24625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548431] = 2,
    ACTIONS(24627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548439] = 2,
    ACTIONS(24629), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548447] = 2,
    ACTIONS(24631), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548455] = 2,
    ACTIONS(24633), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548463] = 2,
    ACTIONS(24635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548471] = 2,
    ACTIONS(24637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548479] = 2,
    ACTIONS(24639), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548487] = 2,
    ACTIONS(24641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548495] = 2,
    ACTIONS(24643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548503] = 2,
    ACTIONS(24645), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548511] = 2,
    ACTIONS(24647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548519] = 2,
    ACTIONS(24649), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548527] = 2,
    ACTIONS(24651), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548535] = 2,
    ACTIONS(24653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548543] = 2,
    ACTIONS(24655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548551] = 2,
    ACTIONS(24657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548559] = 2,
    ACTIONS(24659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548567] = 2,
    ACTIONS(24661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548575] = 2,
    ACTIONS(24663), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548583] = 2,
    ACTIONS(24665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548591] = 2,
    ACTIONS(24667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548599] = 2,
    ACTIONS(24669), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548607] = 2,
    ACTIONS(24671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548615] = 2,
    ACTIONS(24673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548623] = 2,
    ACTIONS(24675), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548631] = 2,
    ACTIONS(24677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548639] = 2,
    ACTIONS(24679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548647] = 2,
    ACTIONS(24681), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548655] = 2,
    ACTIONS(24683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548663] = 2,
    ACTIONS(24685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548671] = 2,
    ACTIONS(24687), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548679] = 2,
    ACTIONS(24689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548687] = 2,
    ACTIONS(18969), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548695] = 2,
    ACTIONS(24691), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548703] = 2,
    ACTIONS(24693), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548711] = 2,
    ACTIONS(24695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548719] = 2,
    ACTIONS(24697), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548727] = 2,
    ACTIONS(24699), 1,
      sym_keyword_on,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548735] = 2,
    ACTIONS(24701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548743] = 2,
    ACTIONS(24703), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548751] = 2,
    ACTIONS(24705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548759] = 2,
    ACTIONS(14595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548767] = 2,
    ACTIONS(24707), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548775] = 2,
    ACTIONS(24709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548783] = 2,
    ACTIONS(24711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548791] = 2,
    ACTIONS(24713), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548799] = 2,
    ACTIONS(24715), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548807] = 2,
    ACTIONS(24717), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548815] = 2,
    ACTIONS(24719), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548823] = 2,
    ACTIONS(24721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548831] = 2,
    ACTIONS(1720), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548839] = 2,
    ACTIONS(24723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548847] = 2,
    ACTIONS(24725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548855] = 2,
    ACTIONS(24727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548863] = 2,
    ACTIONS(17038), 1,
      sym_keyword_table,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548871] = 2,
    ACTIONS(24729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548879] = 2,
    ACTIONS(24731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548887] = 2,
    ACTIONS(24733), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548895] = 2,
    ACTIONS(24735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548903] = 2,
    ACTIONS(24737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548911] = 2,
    ACTIONS(15769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548919] = 2,
    ACTIONS(24739), 1,
      sym_keyword_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548927] = 2,
    ACTIONS(24741), 1,
      aux_sym__integer_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548935] = 2,
    ACTIONS(24743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548943] = 2,
    ACTIONS(24745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548951] = 2,
    ACTIONS(24747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548959] = 2,
    ACTIONS(24749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548967] = 2,
    ACTIONS(15563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548975] = 2,
    ACTIONS(24751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548983] = 2,
    ACTIONS(24753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548991] = 2,
    ACTIONS(24755), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [548999] = 2,
    ACTIONS(24757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549007] = 2,
    ACTIONS(24759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549015] = 2,
    ACTIONS(24761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549023] = 2,
    ACTIONS(14641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549031] = 2,
    ACTIONS(24763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549039] = 2,
    ACTIONS(24765), 1,
      sym_keyword_into,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549047] = 2,
    ACTIONS(24767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549055] = 2,
    ACTIONS(15585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549063] = 2,
    ACTIONS(24769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549071] = 2,
    ACTIONS(24771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549079] = 2,
    ACTIONS(24773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549087] = 2,
    ACTIONS(24775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549095] = 2,
    ACTIONS(24777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549103] = 2,
    ACTIONS(16830), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549111] = 2,
    ACTIONS(24779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549119] = 2,
    ACTIONS(24781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549127] = 2,
    ACTIONS(24783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549135] = 2,
    ACTIONS(24785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549143] = 2,
    ACTIONS(24787), 1,
      sym_keyword_into,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549151] = 2,
    ACTIONS(24789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549159] = 2,
    ACTIONS(9809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549167] = 2,
    ACTIONS(24791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549175] = 2,
    ACTIONS(24793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549183] = 2,
    ACTIONS(24795), 1,
      sym_keyword_using,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549191] = 2,
    ACTIONS(24797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549199] = 2,
    ACTIONS(24799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549207] = 2,
    ACTIONS(24801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549215] = 2,
    ACTIONS(24803), 1,
      sym_keyword_do,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549223] = 2,
    ACTIONS(24805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549231] = 2,
    ACTIONS(24807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549239] = 2,
    ACTIONS(24809), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549247] = 2,
    ACTIONS(24811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549255] = 2,
    ACTIONS(24813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549263] = 2,
    ACTIONS(24815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549271] = 2,
    ACTIONS(24817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549279] = 2,
    ACTIONS(24819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549287] = 2,
    ACTIONS(24821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549295] = 2,
    ACTIONS(24823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549303] = 2,
    ACTIONS(24825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549311] = 2,
    ACTIONS(24827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549319] = 2,
    ACTIONS(24829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549327] = 2,
    ACTIONS(24831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549335] = 2,
    ACTIONS(24833), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549343] = 2,
    ACTIONS(24835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549351] = 2,
    ACTIONS(24837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549359] = 2,
    ACTIONS(24839), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549367] = 2,
    ACTIONS(24841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549375] = 2,
    ACTIONS(24843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549383] = 2,
    ACTIONS(24845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549391] = 2,
    ACTIONS(24847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549399] = 2,
    ACTIONS(24849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549407] = 2,
    ACTIONS(24851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549415] = 2,
    ACTIONS(24853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549423] = 2,
    ACTIONS(24855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549431] = 2,
    ACTIONS(24857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549439] = 2,
    ACTIONS(24859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549447] = 2,
    ACTIONS(17843), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549455] = 2,
    ACTIONS(24861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549463] = 2,
    ACTIONS(17863), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549471] = 2,
    ACTIONS(17937), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549479] = 2,
    ACTIONS(24863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549487] = 2,
    ACTIONS(18118), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549495] = 2,
    ACTIONS(24865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549503] = 2,
    ACTIONS(24867), 1,
      sym_keyword_conflict,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549511] = 2,
    ACTIONS(18128), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549519] = 2,
    ACTIONS(18140), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549527] = 2,
    ACTIONS(9600), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549535] = 2,
    ACTIONS(18144), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549543] = 2,
    ACTIONS(16510), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549551] = 2,
    ACTIONS(24869), 1,
      sym_keyword_of,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549559] = 2,
    ACTIONS(24871), 1,
      sym_keyword_into,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549567] = 2,
    ACTIONS(24873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549575] = 2,
    ACTIONS(24875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549583] = 2,
    ACTIONS(24877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549591] = 2,
    ACTIONS(24879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549599] = 2,
    ACTIONS(24881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549607] = 2,
    ACTIONS(24883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549615] = 2,
    ACTIONS(24885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549623] = 2,
    ACTIONS(24887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549631] = 2,
    ACTIONS(24889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549639] = 2,
    ACTIONS(24891), 1,
      sym_keyword_zone,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549647] = 2,
    ACTIONS(24893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549655] = 2,
    ACTIONS(24895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549663] = 2,
    ACTIONS(24897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549671] = 2,
    ACTIONS(24899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549679] = 2,
    ACTIONS(24901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549687] = 2,
    ACTIONS(16736), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549695] = 2,
    ACTIONS(16296), 1,
      aux_sym__single_quote_string_token1,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549703] = 2,
    ACTIONS(24903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549711] = 2,
    ACTIONS(15899), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549719] = 2,
    ACTIONS(24905), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549727] = 2,
    ACTIONS(15891), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549735] = 2,
    ACTIONS(15765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549743] = 2,
    ACTIONS(16720), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549751] = 2,
    ACTIONS(24907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549759] = 2,
    ACTIONS(24909), 1,
      sym_keyword_trigger,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549767] = 2,
    ACTIONS(15740), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549775] = 2,
    ACTIONS(24911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549783] = 2,
    ACTIONS(24913), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
  [549791] = 2,
    ACTIONS(24915), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_marginalia,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(296)] = 0,
  [SMALL_STATE(297)] = 105,
  [SMALL_STATE(298)] = 186,
  [SMALL_STATE(299)] = 277,
  [SMALL_STATE(300)] = 368,
  [SMALL_STATE(301)] = 509,
  [SMALL_STATE(302)] = 596,
  [SMALL_STATE(303)] = 697,
  [SMALL_STATE(304)] = 774,
  [SMALL_STATE(305)] = 871,
  [SMALL_STATE(306)] = 980,
  [SMALL_STATE(307)] = 1087,
  [SMALL_STATE(308)] = 1168,
  [SMALL_STATE(309)] = 1309,
  [SMALL_STATE(310)] = 1392,
  [SMALL_STATE(311)] = 1497,
  [SMALL_STATE(312)] = 1571,
  [SMALL_STATE(313)] = 1645,
  [SMALL_STATE(314)] = 1715,
  [SMALL_STATE(315)] = 1789,
  [SMALL_STATE(316)] = 1863,
  [SMALL_STATE(317)] = 1937,
  [SMALL_STATE(318)] = 2011,
  [SMALL_STATE(319)] = 2085,
  [SMALL_STATE(320)] = 2159,
  [SMALL_STATE(321)] = 2233,
  [SMALL_STATE(322)] = 2307,
  [SMALL_STATE(323)] = 2381,
  [SMALL_STATE(324)] = 2455,
  [SMALL_STATE(325)] = 2529,
  [SMALL_STATE(326)] = 2603,
  [SMALL_STATE(327)] = 2677,
  [SMALL_STATE(328)] = 2751,
  [SMALL_STATE(329)] = 2825,
  [SMALL_STATE(330)] = 2899,
  [SMALL_STATE(331)] = 2973,
  [SMALL_STATE(332)] = 3108,
  [SMALL_STATE(333)] = 3243,
  [SMALL_STATE(334)] = 3378,
  [SMALL_STATE(335)] = 3513,
  [SMALL_STATE(336)] = 3648,
  [SMALL_STATE(337)] = 3783,
  [SMALL_STATE(338)] = 3918,
  [SMALL_STATE(339)] = 4053,
  [SMALL_STATE(340)] = 4188,
  [SMALL_STATE(341)] = 4323,
  [SMALL_STATE(342)] = 4458,
  [SMALL_STATE(343)] = 4593,
  [SMALL_STATE(344)] = 4728,
  [SMALL_STATE(345)] = 4863,
  [SMALL_STATE(346)] = 4936,
  [SMALL_STATE(347)] = 5071,
  [SMALL_STATE(348)] = 5144,
  [SMALL_STATE(349)] = 5217,
  [SMALL_STATE(350)] = 5352,
  [SMALL_STATE(351)] = 5487,
  [SMALL_STATE(352)] = 5622,
  [SMALL_STATE(353)] = 5757,
  [SMALL_STATE(354)] = 5892,
  [SMALL_STATE(355)] = 6027,
  [SMALL_STATE(356)] = 6162,
  [SMALL_STATE(357)] = 6297,
  [SMALL_STATE(358)] = 6432,
  [SMALL_STATE(359)] = 6567,
  [SMALL_STATE(360)] = 6702,
  [SMALL_STATE(361)] = 6837,
  [SMALL_STATE(362)] = 6972,
  [SMALL_STATE(363)] = 7107,
  [SMALL_STATE(364)] = 7242,
  [SMALL_STATE(365)] = 7377,
  [SMALL_STATE(366)] = 7512,
  [SMALL_STATE(367)] = 7647,
  [SMALL_STATE(368)] = 7782,
  [SMALL_STATE(369)] = 7917,
  [SMALL_STATE(370)] = 8052,
  [SMALL_STATE(371)] = 8187,
  [SMALL_STATE(372)] = 8322,
  [SMALL_STATE(373)] = 8457,
  [SMALL_STATE(374)] = 8592,
  [SMALL_STATE(375)] = 8727,
  [SMALL_STATE(376)] = 8862,
  [SMALL_STATE(377)] = 8997,
  [SMALL_STATE(378)] = 9132,
  [SMALL_STATE(379)] = 9267,
  [SMALL_STATE(380)] = 9402,
  [SMALL_STATE(381)] = 9537,
  [SMALL_STATE(382)] = 9672,
  [SMALL_STATE(383)] = 9807,
  [SMALL_STATE(384)] = 9942,
  [SMALL_STATE(385)] = 10077,
  [SMALL_STATE(386)] = 10212,
  [SMALL_STATE(387)] = 10347,
  [SMALL_STATE(388)] = 10482,
  [SMALL_STATE(389)] = 10617,
  [SMALL_STATE(390)] = 10752,
  [SMALL_STATE(391)] = 10887,
  [SMALL_STATE(392)] = 11022,
  [SMALL_STATE(393)] = 11157,
  [SMALL_STATE(394)] = 11292,
  [SMALL_STATE(395)] = 11360,
  [SMALL_STATE(396)] = 11428,
  [SMALL_STATE(397)] = 11496,
  [SMALL_STATE(398)] = 11564,
  [SMALL_STATE(399)] = 11632,
  [SMALL_STATE(400)] = 11700,
  [SMALL_STATE(401)] = 11768,
  [SMALL_STATE(402)] = 11836,
  [SMALL_STATE(403)] = 11904,
  [SMALL_STATE(404)] = 11972,
  [SMALL_STATE(405)] = 12040,
  [SMALL_STATE(406)] = 12108,
  [SMALL_STATE(407)] = 12176,
  [SMALL_STATE(408)] = 12244,
  [SMALL_STATE(409)] = 12312,
  [SMALL_STATE(410)] = 12380,
  [SMALL_STATE(411)] = 12448,
  [SMALL_STATE(412)] = 12516,
  [SMALL_STATE(413)] = 12584,
  [SMALL_STATE(414)] = 12652,
  [SMALL_STATE(415)] = 12727,
  [SMALL_STATE(416)] = 12798,
  [SMALL_STATE(417)] = 12869,
  [SMALL_STATE(418)] = 12940,
  [SMALL_STATE(419)] = 13011,
  [SMALL_STATE(420)] = 13082,
  [SMALL_STATE(421)] = 13149,
  [SMALL_STATE(422)] = 13224,
  [SMALL_STATE(423)] = 13299,
  [SMALL_STATE(424)] = 13370,
  [SMALL_STATE(425)] = 13441,
  [SMALL_STATE(426)] = 13508,
  [SMALL_STATE(427)] = 13579,
  [SMALL_STATE(428)] = 13650,
  [SMALL_STATE(429)] = 13721,
  [SMALL_STATE(430)] = 13792,
  [SMALL_STATE(431)] = 13863,
  [SMALL_STATE(432)] = 13938,
  [SMALL_STATE(433)] = 14005,
  [SMALL_STATE(434)] = 14076,
  [SMALL_STATE(435)] = 14147,
  [SMALL_STATE(436)] = 14218,
  [SMALL_STATE(437)] = 14289,
  [SMALL_STATE(438)] = 14360,
  [SMALL_STATE(439)] = 14435,
  [SMALL_STATE(440)] = 14506,
  [SMALL_STATE(441)] = 14577,
  [SMALL_STATE(442)] = 14652,
  [SMALL_STATE(443)] = 14722,
  [SMALL_STATE(444)] = 14848,
  [SMALL_STATE(445)] = 14916,
  [SMALL_STATE(446)] = 15042,
  [SMALL_STATE(447)] = 15142,
  [SMALL_STATE(448)] = 15268,
  [SMALL_STATE(449)] = 15340,
  [SMALL_STATE(450)] = 15406,
  [SMALL_STATE(451)] = 15478,
  [SMALL_STATE(452)] = 15544,
  [SMALL_STATE(453)] = 15670,
  [SMALL_STATE(454)] = 15736,
  [SMALL_STATE(455)] = 15806,
  [SMALL_STATE(456)] = 15906,
  [SMALL_STATE(457)] = 15976,
  [SMALL_STATE(458)] = 16102,
  [SMALL_STATE(459)] = 16168,
  [SMALL_STATE(460)] = 16238,
  [SMALL_STATE(461)] = 16304,
  [SMALL_STATE(462)] = 16430,
  [SMALL_STATE(463)] = 16500,
  [SMALL_STATE(464)] = 16626,
  [SMALL_STATE(465)] = 16696,
  [SMALL_STATE(466)] = 16822,
  [SMALL_STATE(467)] = 16892,
  [SMALL_STATE(468)] = 17018,
  [SMALL_STATE(469)] = 17088,
  [SMALL_STATE(470)] = 17214,
  [SMALL_STATE(471)] = 17340,
  [SMALL_STATE(472)] = 17466,
  [SMALL_STATE(473)] = 17538,
  [SMALL_STATE(474)] = 17610,
  [SMALL_STATE(475)] = 17736,
  [SMALL_STATE(476)] = 17838,
  [SMALL_STATE(477)] = 17910,
  [SMALL_STATE(478)] = 17980,
  [SMALL_STATE(479)] = 18050,
  [SMALL_STATE(480)] = 18116,
  [SMALL_STATE(481)] = 18186,
  [SMALL_STATE(482)] = 18316,
  [SMALL_STATE(483)] = 18386,
  [SMALL_STATE(484)] = 18456,
  [SMALL_STATE(485)] = 18526,
  [SMALL_STATE(486)] = 18622,
  [SMALL_STATE(487)] = 18692,
  [SMALL_STATE(488)] = 18818,
  [SMALL_STATE(489)] = 18894,
  [SMALL_STATE(490)] = 18976,
  [SMALL_STATE(491)] = 19048,
  [SMALL_STATE(492)] = 19118,
  [SMALL_STATE(493)] = 19244,
  [SMALL_STATE(494)] = 19330,
  [SMALL_STATE(495)] = 19456,
  [SMALL_STATE(496)] = 19582,
  [SMALL_STATE(497)] = 19686,
  [SMALL_STATE(498)] = 19756,
  [SMALL_STATE(499)] = 19826,
  [SMALL_STATE(500)] = 19896,
  [SMALL_STATE(501)] = 20022,
  [SMALL_STATE(502)] = 20098,
  [SMALL_STATE(503)] = 20164,
  [SMALL_STATE(504)] = 20290,
  [SMALL_STATE(505)] = 20416,
  [SMALL_STATE(506)] = 20542,
  [SMALL_STATE(507)] = 20614,
  [SMALL_STATE(508)] = 20700,
  [SMALL_STATE(509)] = 20792,
  [SMALL_STATE(510)] = 20918,
  [SMALL_STATE(511)] = 20996,
  [SMALL_STATE(512)] = 21122,
  [SMALL_STATE(513)] = 21194,
  [SMALL_STATE(514)] = 21266,
  [SMALL_STATE(515)] = 21338,
  [SMALL_STATE(516)] = 21464,
  [SMALL_STATE(517)] = 21536,
  [SMALL_STATE(518)] = 21662,
  [SMALL_STATE(519)] = 21787,
  [SMALL_STATE(520)] = 21914,
  [SMALL_STATE(521)] = 22039,
  [SMALL_STATE(522)] = 22162,
  [SMALL_STATE(523)] = 22227,
  [SMALL_STATE(524)] = 22296,
  [SMALL_STATE(525)] = 22419,
  [SMALL_STATE(526)] = 22544,
  [SMALL_STATE(527)] = 22669,
  [SMALL_STATE(528)] = 22794,
  [SMALL_STATE(529)] = 22919,
  [SMALL_STATE(530)] = 23044,
  [SMALL_STATE(531)] = 23169,
  [SMALL_STATE(532)] = 23292,
  [SMALL_STATE(533)] = 23417,
  [SMALL_STATE(534)] = 23542,
  [SMALL_STATE(535)] = 23667,
  [SMALL_STATE(536)] = 23792,
  [SMALL_STATE(537)] = 23917,
  [SMALL_STATE(538)] = 24042,
  [SMALL_STATE(539)] = 24167,
  [SMALL_STATE(540)] = 24292,
  [SMALL_STATE(541)] = 24417,
  [SMALL_STATE(542)] = 24540,
  [SMALL_STATE(543)] = 24605,
  [SMALL_STATE(544)] = 24730,
  [SMALL_STATE(545)] = 24855,
  [SMALL_STATE(546)] = 24980,
  [SMALL_STATE(547)] = 25105,
  [SMALL_STATE(548)] = 25230,
  [SMALL_STATE(549)] = 25355,
  [SMALL_STATE(550)] = 25480,
  [SMALL_STATE(551)] = 25605,
  [SMALL_STATE(552)] = 25730,
  [SMALL_STATE(553)] = 25799,
  [SMALL_STATE(554)] = 25924,
  [SMALL_STATE(555)] = 25989,
  [SMALL_STATE(556)] = 26114,
  [SMALL_STATE(557)] = 26237,
  [SMALL_STATE(558)] = 26302,
  [SMALL_STATE(559)] = 26427,
  [SMALL_STATE(560)] = 26552,
  [SMALL_STATE(561)] = 26617,
  [SMALL_STATE(562)] = 26742,
  [SMALL_STATE(563)] = 26865,
  [SMALL_STATE(564)] = 26934,
  [SMALL_STATE(565)] = 27059,
  [SMALL_STATE(566)] = 27184,
  [SMALL_STATE(567)] = 27307,
  [SMALL_STATE(568)] = 27376,
  [SMALL_STATE(569)] = 27501,
  [SMALL_STATE(570)] = 27626,
  [SMALL_STATE(571)] = 27751,
  [SMALL_STATE(572)] = 27820,
  [SMALL_STATE(573)] = 27945,
  [SMALL_STATE(574)] = 28014,
  [SMALL_STATE(575)] = 28083,
  [SMALL_STATE(576)] = 28148,
  [SMALL_STATE(577)] = 28271,
  [SMALL_STATE(578)] = 28396,
  [SMALL_STATE(579)] = 28461,
  [SMALL_STATE(580)] = 28584,
  [SMALL_STATE(581)] = 28653,
  [SMALL_STATE(582)] = 28718,
  [SMALL_STATE(583)] = 28843,
  [SMALL_STATE(584)] = 28966,
  [SMALL_STATE(585)] = 29091,
  [SMALL_STATE(586)] = 29216,
  [SMALL_STATE(587)] = 29315,
  [SMALL_STATE(588)] = 29438,
  [SMALL_STATE(589)] = 29563,
  [SMALL_STATE(590)] = 29688,
  [SMALL_STATE(591)] = 29813,
  [SMALL_STATE(592)] = 29882,
  [SMALL_STATE(593)] = 30007,
  [SMALL_STATE(594)] = 30072,
  [SMALL_STATE(595)] = 30195,
  [SMALL_STATE(596)] = 30320,
  [SMALL_STATE(597)] = 30443,
  [SMALL_STATE(598)] = 30566,
  [SMALL_STATE(599)] = 30631,
  [SMALL_STATE(600)] = 30754,
  [SMALL_STATE(601)] = 30877,
  [SMALL_STATE(602)] = 31000,
  [SMALL_STATE(603)] = 31123,
  [SMALL_STATE(604)] = 31248,
  [SMALL_STATE(605)] = 31371,
  [SMALL_STATE(606)] = 31466,
  [SMALL_STATE(607)] = 31531,
  [SMALL_STATE(608)] = 31596,
  [SMALL_STATE(609)] = 31671,
  [SMALL_STATE(610)] = 31752,
  [SMALL_STATE(611)] = 31837,
  [SMALL_STATE(612)] = 31962,
  [SMALL_STATE(613)] = 32087,
  [SMALL_STATE(614)] = 32212,
  [SMALL_STATE(615)] = 32337,
  [SMALL_STATE(616)] = 32460,
  [SMALL_STATE(617)] = 32527,
  [SMALL_STATE(618)] = 32652,
  [SMALL_STATE(619)] = 32717,
  [SMALL_STATE(620)] = 32842,
  [SMALL_STATE(621)] = 32967,
  [SMALL_STATE(622)] = 33038,
  [SMALL_STATE(623)] = 33103,
  [SMALL_STATE(624)] = 33168,
  [SMALL_STATE(625)] = 33293,
  [SMALL_STATE(626)] = 33418,
  [SMALL_STATE(627)] = 33541,
  [SMALL_STATE(628)] = 33666,
  [SMALL_STATE(629)] = 33789,
  [SMALL_STATE(630)] = 33914,
  [SMALL_STATE(631)] = 33983,
  [SMALL_STATE(632)] = 34106,
  [SMALL_STATE(633)] = 34175,
  [SMALL_STATE(634)] = 34300,
  [SMALL_STATE(635)] = 34423,
  [SMALL_STATE(636)] = 34546,
  [SMALL_STATE(637)] = 34645,
  [SMALL_STATE(638)] = 34770,
  [SMALL_STATE(639)] = 34893,
  [SMALL_STATE(640)] = 35018,
  [SMALL_STATE(641)] = 35143,
  [SMALL_STATE(642)] = 35212,
  [SMALL_STATE(643)] = 35335,
  [SMALL_STATE(644)] = 35460,
  [SMALL_STATE(645)] = 35585,
  [SMALL_STATE(646)] = 35710,
  [SMALL_STATE(647)] = 35833,
  [SMALL_STATE(648)] = 35898,
  [SMALL_STATE(649)] = 36021,
  [SMALL_STATE(650)] = 36088,
  [SMALL_STATE(651)] = 36153,
  [SMALL_STATE(652)] = 36222,
  [SMALL_STATE(653)] = 36347,
  [SMALL_STATE(654)] = 36472,
  [SMALL_STATE(655)] = 36537,
  [SMALL_STATE(656)] = 36602,
  [SMALL_STATE(657)] = 36671,
  [SMALL_STATE(658)] = 36736,
  [SMALL_STATE(659)] = 36863,
  [SMALL_STATE(660)] = 36988,
  [SMALL_STATE(661)] = 37057,
  [SMALL_STATE(662)] = 37182,
  [SMALL_STATE(663)] = 37307,
  [SMALL_STATE(664)] = 37376,
  [SMALL_STATE(665)] = 37477,
  [SMALL_STATE(666)] = 37600,
  [SMALL_STATE(667)] = 37723,
  [SMALL_STATE(668)] = 37826,
  [SMALL_STATE(669)] = 37917,
  [SMALL_STATE(670)] = 37994,
  [SMALL_STATE(671)] = 38117,
  [SMALL_STATE(672)] = 38186,
  [SMALL_STATE(673)] = 38271,
  [SMALL_STATE(674)] = 38394,
  [SMALL_STATE(675)] = 38517,
  [SMALL_STATE(676)] = 38642,
  [SMALL_STATE(677)] = 38711,
  [SMALL_STATE(678)] = 38836,
  [SMALL_STATE(679)] = 38905,
  [SMALL_STATE(680)] = 38980,
  [SMALL_STATE(681)] = 39078,
  [SMALL_STATE(682)] = 39144,
  [SMALL_STATE(683)] = 39210,
  [SMALL_STATE(684)] = 39274,
  [SMALL_STATE(685)] = 39340,
  [SMALL_STATE(686)] = 39460,
  [SMALL_STATE(687)] = 39564,
  [SMALL_STATE(688)] = 39630,
  [SMALL_STATE(689)] = 39696,
  [SMALL_STATE(690)] = 39760,
  [SMALL_STATE(691)] = 39828,
  [SMALL_STATE(692)] = 39892,
  [SMALL_STATE(693)] = 39956,
  [SMALL_STATE(694)] = 40022,
  [SMALL_STATE(695)] = 40088,
  [SMALL_STATE(696)] = 40208,
  [SMALL_STATE(697)] = 40328,
  [SMALL_STATE(698)] = 40392,
  [SMALL_STATE(699)] = 40458,
  [SMALL_STATE(700)] = 40578,
  [SMALL_STATE(701)] = 40698,
  [SMALL_STATE(702)] = 40792,
  [SMALL_STATE(703)] = 40858,
  [SMALL_STATE(704)] = 40922,
  [SMALL_STATE(705)] = 40988,
  [SMALL_STATE(706)] = 41078,
  [SMALL_STATE(707)] = 41152,
  [SMALL_STATE(708)] = 41216,
  [SMALL_STATE(709)] = 41282,
  [SMALL_STATE(710)] = 41348,
  [SMALL_STATE(711)] = 41428,
  [SMALL_STATE(712)] = 41512,
  [SMALL_STATE(713)] = 41578,
  [SMALL_STATE(714)] = 41642,
  [SMALL_STATE(715)] = 41746,
  [SMALL_STATE(716)] = 41866,
  [SMALL_STATE(717)] = 41936,
  [SMALL_STATE(718)] = 42002,
  [SMALL_STATE(719)] = 42068,
  [SMALL_STATE(720)] = 42136,
  [SMALL_STATE(721)] = 42202,
  [SMALL_STATE(722)] = 42268,
  [SMALL_STATE(723)] = 42334,
  [SMALL_STATE(724)] = 42438,
  [SMALL_STATE(725)] = 42502,
  [SMALL_STATE(726)] = 42576,
  [SMALL_STATE(727)] = 42676,
  [SMALL_STATE(728)] = 42796,
  [SMALL_STATE(729)] = 42862,
  [SMALL_STATE(730)] = 42926,
  [SMALL_STATE(731)] = 43010,
  [SMALL_STATE(732)] = 43130,
  [SMALL_STATE(733)] = 43234,
  [SMALL_STATE(734)] = 43300,
  [SMALL_STATE(735)] = 43404,
  [SMALL_STATE(736)] = 43508,
  [SMALL_STATE(737)] = 43628,
  [SMALL_STATE(738)] = 43696,
  [SMALL_STATE(739)] = 43816,
  [SMALL_STATE(740)] = 43882,
  [SMALL_STATE(741)] = 43986,
  [SMALL_STATE(742)] = 44090,
  [SMALL_STATE(743)] = 44154,
  [SMALL_STATE(744)] = 44274,
  [SMALL_STATE(745)] = 44394,
  [SMALL_STATE(746)] = 44460,
  [SMALL_STATE(747)] = 44580,
  [SMALL_STATE(748)] = 44700,
  [SMALL_STATE(749)] = 44764,
  [SMALL_STATE(750)] = 44830,
  [SMALL_STATE(751)] = 44896,
  [SMALL_STATE(752)] = 44960,
  [SMALL_STATE(753)] = 45030,
  [SMALL_STATE(754)] = 45096,
  [SMALL_STATE(755)] = 45160,
  [SMALL_STATE(756)] = 45224,
  [SMALL_STATE(757)] = 45290,
  [SMALL_STATE(758)] = 45410,
  [SMALL_STATE(759)] = 45530,
  [SMALL_STATE(760)] = 45634,
  [SMALL_STATE(761)] = 45698,
  [SMALL_STATE(762)] = 45818,
  [SMALL_STATE(763)] = 45884,
  [SMALL_STATE(764)] = 46004,
  [SMALL_STATE(765)] = 46102,
  [SMALL_STATE(766)] = 46222,
  [SMALL_STATE(767)] = 46326,
  [SMALL_STATE(768)] = 46446,
  [SMALL_STATE(769)] = 46566,
  [SMALL_STATE(770)] = 46630,
  [SMALL_STATE(771)] = 46694,
  [SMALL_STATE(772)] = 46770,
  [SMALL_STATE(773)] = 46890,
  [SMALL_STATE(774)] = 47010,
  [SMALL_STATE(775)] = 47074,
  [SMALL_STATE(776)] = 47178,
  [SMALL_STATE(777)] = 47244,
  [SMALL_STATE(778)] = 47308,
  [SMALL_STATE(779)] = 47428,
  [SMALL_STATE(780)] = 47548,
  [SMALL_STATE(781)] = 47614,
  [SMALL_STATE(782)] = 47718,
  [SMALL_STATE(783)] = 47784,
  [SMALL_STATE(784)] = 47848,
  [SMALL_STATE(785)] = 47914,
  [SMALL_STATE(786)] = 47978,
  [SMALL_STATE(787)] = 48044,
  [SMALL_STATE(788)] = 48108,
  [SMALL_STATE(789)] = 48174,
  [SMALL_STATE(790)] = 48294,
  [SMALL_STATE(791)] = 48360,
  [SMALL_STATE(792)] = 48480,
  [SMALL_STATE(793)] = 48584,
  [SMALL_STATE(794)] = 48648,
  [SMALL_STATE(795)] = 48712,
  [SMALL_STATE(796)] = 48814,
  [SMALL_STATE(797)] = 48880,
  [SMALL_STATE(798)] = 48946,
  [SMALL_STATE(799)] = 49009,
  [SMALL_STATE(800)] = 49072,
  [SMALL_STATE(801)] = 49135,
  [SMALL_STATE(802)] = 49198,
  [SMALL_STATE(803)] = 49261,
  [SMALL_STATE(804)] = 49324,
  [SMALL_STATE(805)] = 49427,
  [SMALL_STATE(806)] = 49530,
  [SMALL_STATE(807)] = 49593,
  [SMALL_STATE(808)] = 49656,
  [SMALL_STATE(809)] = 49759,
  [SMALL_STATE(810)] = 49862,
  [SMALL_STATE(811)] = 49925,
  [SMALL_STATE(812)] = 49988,
  [SMALL_STATE(813)] = 50051,
  [SMALL_STATE(814)] = 50114,
  [SMALL_STATE(815)] = 50177,
  [SMALL_STATE(816)] = 50240,
  [SMALL_STATE(817)] = 50303,
  [SMALL_STATE(818)] = 50366,
  [SMALL_STATE(819)] = 50429,
  [SMALL_STATE(820)] = 50492,
  [SMALL_STATE(821)] = 50555,
  [SMALL_STATE(822)] = 50618,
  [SMALL_STATE(823)] = 50681,
  [SMALL_STATE(824)] = 50744,
  [SMALL_STATE(825)] = 50863,
  [SMALL_STATE(826)] = 50926,
  [SMALL_STATE(827)] = 50989,
  [SMALL_STATE(828)] = 51052,
  [SMALL_STATE(829)] = 51115,
  [SMALL_STATE(830)] = 51178,
  [SMALL_STATE(831)] = 51241,
  [SMALL_STATE(832)] = 51304,
  [SMALL_STATE(833)] = 51367,
  [SMALL_STATE(834)] = 51430,
  [SMALL_STATE(835)] = 51493,
  [SMALL_STATE(836)] = 51556,
  [SMALL_STATE(837)] = 51619,
  [SMALL_STATE(838)] = 51682,
  [SMALL_STATE(839)] = 51745,
  [SMALL_STATE(840)] = 51808,
  [SMALL_STATE(841)] = 51871,
  [SMALL_STATE(842)] = 51934,
  [SMALL_STATE(843)] = 52037,
  [SMALL_STATE(844)] = 52100,
  [SMALL_STATE(845)] = 52163,
  [SMALL_STATE(846)] = 52226,
  [SMALL_STATE(847)] = 52289,
  [SMALL_STATE(848)] = 52408,
  [SMALL_STATE(849)] = 52471,
  [SMALL_STATE(850)] = 52534,
  [SMALL_STATE(851)] = 52637,
  [SMALL_STATE(852)] = 52700,
  [SMALL_STATE(853)] = 52763,
  [SMALL_STATE(854)] = 52826,
  [SMALL_STATE(855)] = 52889,
  [SMALL_STATE(856)] = 52952,
  [SMALL_STATE(857)] = 53015,
  [SMALL_STATE(858)] = 53078,
  [SMALL_STATE(859)] = 53141,
  [SMALL_STATE(860)] = 53244,
  [SMALL_STATE(861)] = 53347,
  [SMALL_STATE(862)] = 53450,
  [SMALL_STATE(863)] = 53513,
  [SMALL_STATE(864)] = 53576,
  [SMALL_STATE(865)] = 53639,
  [SMALL_STATE(866)] = 53742,
  [SMALL_STATE(867)] = 53805,
  [SMALL_STATE(868)] = 53908,
  [SMALL_STATE(869)] = 53971,
  [SMALL_STATE(870)] = 54034,
  [SMALL_STATE(871)] = 54097,
  [SMALL_STATE(872)] = 54160,
  [SMALL_STATE(873)] = 54223,
  [SMALL_STATE(874)] = 54286,
  [SMALL_STATE(875)] = 54349,
  [SMALL_STATE(876)] = 54412,
  [SMALL_STATE(877)] = 54475,
  [SMALL_STATE(878)] = 54538,
  [SMALL_STATE(879)] = 54601,
  [SMALL_STATE(880)] = 54664,
  [SMALL_STATE(881)] = 54727,
  [SMALL_STATE(882)] = 54790,
  [SMALL_STATE(883)] = 54853,
  [SMALL_STATE(884)] = 54916,
  [SMALL_STATE(885)] = 54979,
  [SMALL_STATE(886)] = 55042,
  [SMALL_STATE(887)] = 55105,
  [SMALL_STATE(888)] = 55168,
  [SMALL_STATE(889)] = 55231,
  [SMALL_STATE(890)] = 55334,
  [SMALL_STATE(891)] = 55397,
  [SMALL_STATE(892)] = 55460,
  [SMALL_STATE(893)] = 55523,
  [SMALL_STATE(894)] = 55626,
  [SMALL_STATE(895)] = 55689,
  [SMALL_STATE(896)] = 55792,
  [SMALL_STATE(897)] = 55855,
  [SMALL_STATE(898)] = 55918,
  [SMALL_STATE(899)] = 55981,
  [SMALL_STATE(900)] = 56044,
  [SMALL_STATE(901)] = 56107,
  [SMALL_STATE(902)] = 56170,
  [SMALL_STATE(903)] = 56233,
  [SMALL_STATE(904)] = 56296,
  [SMALL_STATE(905)] = 56399,
  [SMALL_STATE(906)] = 56462,
  [SMALL_STATE(907)] = 56525,
  [SMALL_STATE(908)] = 56588,
  [SMALL_STATE(909)] = 56651,
  [SMALL_STATE(910)] = 56714,
  [SMALL_STATE(911)] = 56777,
  [SMALL_STATE(912)] = 56840,
  [SMALL_STATE(913)] = 56903,
  [SMALL_STATE(914)] = 56966,
  [SMALL_STATE(915)] = 57029,
  [SMALL_STATE(916)] = 57092,
  [SMALL_STATE(917)] = 57155,
  [SMALL_STATE(918)] = 57217,
  [SMALL_STATE(919)] = 57331,
  [SMALL_STATE(920)] = 57445,
  [SMALL_STATE(921)] = 57559,
  [SMALL_STATE(922)] = 57637,
  [SMALL_STATE(923)] = 57753,
  [SMALL_STATE(924)] = 57869,
  [SMALL_STATE(925)] = 57983,
  [SMALL_STATE(926)] = 58097,
  [SMALL_STATE(927)] = 58213,
  [SMALL_STATE(928)] = 58327,
  [SMALL_STATE(929)] = 58405,
  [SMALL_STATE(930)] = 58483,
  [SMALL_STATE(931)] = 58599,
  [SMALL_STATE(932)] = 58677,
  [SMALL_STATE(933)] = 58791,
  [SMALL_STATE(934)] = 58905,
  [SMALL_STATE(935)] = 59019,
  [SMALL_STATE(936)] = 59097,
  [SMALL_STATE(937)] = 59211,
  [SMALL_STATE(938)] = 59325,
  [SMALL_STATE(939)] = 59439,
  [SMALL_STATE(940)] = 59553,
  [SMALL_STATE(941)] = 59631,
  [SMALL_STATE(942)] = 59701,
  [SMALL_STATE(943)] = 59817,
  [SMALL_STATE(944)] = 59879,
  [SMALL_STATE(945)] = 59993,
  [SMALL_STATE(946)] = 60071,
  [SMALL_STATE(947)] = 60187,
  [SMALL_STATE(948)] = 60301,
  [SMALL_STATE(949)] = 60415,
  [SMALL_STATE(950)] = 60529,
  [SMALL_STATE(951)] = 60645,
  [SMALL_STATE(952)] = 60761,
  [SMALL_STATE(953)] = 60877,
  [SMALL_STATE(954)] = 60991,
  [SMALL_STATE(955)] = 61105,
  [SMALL_STATE(956)] = 61219,
  [SMALL_STATE(957)] = 61281,
  [SMALL_STATE(958)] = 61383,
  [SMALL_STATE(959)] = 61499,
  [SMALL_STATE(960)] = 61613,
  [SMALL_STATE(961)] = 61683,
  [SMALL_STATE(962)] = 61761,
  [SMALL_STATE(963)] = 61839,
  [SMALL_STATE(964)] = 61955,
  [SMALL_STATE(965)] = 62069,
  [SMALL_STATE(966)] = 62183,
  [SMALL_STATE(967)] = 62297,
  [SMALL_STATE(968)] = 62375,
  [SMALL_STATE(969)] = 62453,
  [SMALL_STATE(970)] = 62567,
  [SMALL_STATE(971)] = 62681,
  [SMALL_STATE(972)] = 62797,
  [SMALL_STATE(973)] = 62911,
  [SMALL_STATE(974)] = 63025,
  [SMALL_STATE(975)] = 63103,
  [SMALL_STATE(976)] = 63217,
  [SMALL_STATE(977)] = 63333,
  [SMALL_STATE(978)] = 63411,
  [SMALL_STATE(979)] = 63525,
  [SMALL_STATE(980)] = 63595,
  [SMALL_STATE(981)] = 63709,
  [SMALL_STATE(982)] = 63787,
  [SMALL_STATE(983)] = 63849,
  [SMALL_STATE(984)] = 63963,
  [SMALL_STATE(985)] = 64079,
  [SMALL_STATE(986)] = 64195,
  [SMALL_STATE(987)] = 64309,
  [SMALL_STATE(988)] = 64387,
  [SMALL_STATE(989)] = 64465,
  [SMALL_STATE(990)] = 64579,
  [SMALL_STATE(991)] = 64693,
  [SMALL_STATE(992)] = 64807,
  [SMALL_STATE(993)] = 64923,
  [SMALL_STATE(994)] = 65037,
  [SMALL_STATE(995)] = 65153,
  [SMALL_STATE(996)] = 65267,
  [SMALL_STATE(997)] = 65369,
  [SMALL_STATE(998)] = 65447,
  [SMALL_STATE(999)] = 65561,
  [SMALL_STATE(1000)] = 65677,
  [SMALL_STATE(1001)] = 65739,
  [SMALL_STATE(1002)] = 65817,
  [SMALL_STATE(1003)] = 65933,
  [SMALL_STATE(1004)] = 66035,
  [SMALL_STATE(1005)] = 66137,
  [SMALL_STATE(1006)] = 66251,
  [SMALL_STATE(1007)] = 66353,
  [SMALL_STATE(1008)] = 66431,
  [SMALL_STATE(1009)] = 66545,
  [SMALL_STATE(1010)] = 66659,
  [SMALL_STATE(1011)] = 66773,
  [SMALL_STATE(1012)] = 66887,
  [SMALL_STATE(1013)] = 66965,
  [SMALL_STATE(1014)] = 67043,
  [SMALL_STATE(1015)] = 67105,
  [SMALL_STATE(1016)] = 67221,
  [SMALL_STATE(1017)] = 67283,
  [SMALL_STATE(1018)] = 67397,
  [SMALL_STATE(1019)] = 67499,
  [SMALL_STATE(1020)] = 67601,
  [SMALL_STATE(1021)] = 67703,
  [SMALL_STATE(1022)] = 67817,
  [SMALL_STATE(1023)] = 67919,
  [SMALL_STATE(1024)] = 68035,
  [SMALL_STATE(1025)] = 68151,
  [SMALL_STATE(1026)] = 68265,
  [SMALL_STATE(1027)] = 68381,
  [SMALL_STATE(1028)] = 68459,
  [SMALL_STATE(1029)] = 68521,
  [SMALL_STATE(1030)] = 68635,
  [SMALL_STATE(1031)] = 68713,
  [SMALL_STATE(1032)] = 68827,
  [SMALL_STATE(1033)] = 68929,
  [SMALL_STATE(1034)] = 69031,
  [SMALL_STATE(1035)] = 69133,
  [SMALL_STATE(1036)] = 69235,
  [SMALL_STATE(1037)] = 69337,
  [SMALL_STATE(1038)] = 69439,
  [SMALL_STATE(1039)] = 69509,
  [SMALL_STATE(1040)] = 69623,
  [SMALL_STATE(1041)] = 69734,
  [SMALL_STATE(1042)] = 69845,
  [SMALL_STATE(1043)] = 69914,
  [SMALL_STATE(1044)] = 70025,
  [SMALL_STATE(1045)] = 70136,
  [SMALL_STATE(1046)] = 70201,
  [SMALL_STATE(1047)] = 70266,
  [SMALL_STATE(1048)] = 70331,
  [SMALL_STATE(1049)] = 70396,
  [SMALL_STATE(1050)] = 70465,
  [SMALL_STATE(1051)] = 70576,
  [SMALL_STATE(1052)] = 70641,
  [SMALL_STATE(1053)] = 70710,
  [SMALL_STATE(1054)] = 70821,
  [SMALL_STATE(1055)] = 70932,
  [SMALL_STATE(1056)] = 71043,
  [SMALL_STATE(1057)] = 71112,
  [SMALL_STATE(1058)] = 71223,
  [SMALL_STATE(1059)] = 71334,
  [SMALL_STATE(1060)] = 71403,
  [SMALL_STATE(1061)] = 71514,
  [SMALL_STATE(1062)] = 71625,
  [SMALL_STATE(1063)] = 71736,
  [SMALL_STATE(1064)] = 71801,
  [SMALL_STATE(1065)] = 71866,
  [SMALL_STATE(1066)] = 71977,
  [SMALL_STATE(1067)] = 72042,
  [SMALL_STATE(1068)] = 72107,
  [SMALL_STATE(1069)] = 72172,
  [SMALL_STATE(1070)] = 72283,
  [SMALL_STATE(1071)] = 72394,
  [SMALL_STATE(1072)] = 72505,
  [SMALL_STATE(1073)] = 72616,
  [SMALL_STATE(1074)] = 72727,
  [SMALL_STATE(1075)] = 72838,
  [SMALL_STATE(1076)] = 72949,
  [SMALL_STATE(1077)] = 73060,
  [SMALL_STATE(1078)] = 73171,
  [SMALL_STATE(1079)] = 73282,
  [SMALL_STATE(1080)] = 73393,
  [SMALL_STATE(1081)] = 73504,
  [SMALL_STATE(1082)] = 73615,
  [SMALL_STATE(1083)] = 73680,
  [SMALL_STATE(1084)] = 73745,
  [SMALL_STATE(1085)] = 73856,
  [SMALL_STATE(1086)] = 73967,
  [SMALL_STATE(1087)] = 74078,
  [SMALL_STATE(1088)] = 74189,
  [SMALL_STATE(1089)] = 74300,
  [SMALL_STATE(1090)] = 74411,
  [SMALL_STATE(1091)] = 74522,
  [SMALL_STATE(1092)] = 74587,
  [SMALL_STATE(1093)] = 74698,
  [SMALL_STATE(1094)] = 74809,
  [SMALL_STATE(1095)] = 74920,
  [SMALL_STATE(1096)] = 75031,
  [SMALL_STATE(1097)] = 75142,
  [SMALL_STATE(1098)] = 75253,
  [SMALL_STATE(1099)] = 75364,
  [SMALL_STATE(1100)] = 75475,
  [SMALL_STATE(1101)] = 75540,
  [SMALL_STATE(1102)] = 75653,
  [SMALL_STATE(1103)] = 75764,
  [SMALL_STATE(1104)] = 75875,
  [SMALL_STATE(1105)] = 75986,
  [SMALL_STATE(1106)] = 76087,
  [SMALL_STATE(1107)] = 76198,
  [SMALL_STATE(1108)] = 76263,
  [SMALL_STATE(1109)] = 76328,
  [SMALL_STATE(1110)] = 76439,
  [SMALL_STATE(1111)] = 76540,
  [SMALL_STATE(1112)] = 76641,
  [SMALL_STATE(1113)] = 76742,
  [SMALL_STATE(1114)] = 76843,
  [SMALL_STATE(1115)] = 76954,
  [SMALL_STATE(1116)] = 77065,
  [SMALL_STATE(1117)] = 77176,
  [SMALL_STATE(1118)] = 77287,
  [SMALL_STATE(1119)] = 77398,
  [SMALL_STATE(1120)] = 77509,
  [SMALL_STATE(1121)] = 77620,
  [SMALL_STATE(1122)] = 77731,
  [SMALL_STATE(1123)] = 77832,
  [SMALL_STATE(1124)] = 77933,
  [SMALL_STATE(1125)] = 78044,
  [SMALL_STATE(1126)] = 78145,
  [SMALL_STATE(1127)] = 78246,
  [SMALL_STATE(1128)] = 78359,
  [SMALL_STATE(1129)] = 78460,
  [SMALL_STATE(1130)] = 78571,
  [SMALL_STATE(1131)] = 78682,
  [SMALL_STATE(1132)] = 78793,
  [SMALL_STATE(1133)] = 78904,
  [SMALL_STATE(1134)] = 79015,
  [SMALL_STATE(1135)] = 79126,
  [SMALL_STATE(1136)] = 79237,
  [SMALL_STATE(1137)] = 79348,
  [SMALL_STATE(1138)] = 79413,
  [SMALL_STATE(1139)] = 79524,
  [SMALL_STATE(1140)] = 79635,
  [SMALL_STATE(1141)] = 79746,
  [SMALL_STATE(1142)] = 79857,
  [SMALL_STATE(1143)] = 79968,
  [SMALL_STATE(1144)] = 80069,
  [SMALL_STATE(1145)] = 80170,
  [SMALL_STATE(1146)] = 80271,
  [SMALL_STATE(1147)] = 80382,
  [SMALL_STATE(1148)] = 80493,
  [SMALL_STATE(1149)] = 80604,
  [SMALL_STATE(1150)] = 80715,
  [SMALL_STATE(1151)] = 80780,
  [SMALL_STATE(1152)] = 80891,
  [SMALL_STATE(1153)] = 81002,
  [SMALL_STATE(1154)] = 81113,
  [SMALL_STATE(1155)] = 81224,
  [SMALL_STATE(1156)] = 81335,
  [SMALL_STATE(1157)] = 81400,
  [SMALL_STATE(1158)] = 81511,
  [SMALL_STATE(1159)] = 81622,
  [SMALL_STATE(1160)] = 81687,
  [SMALL_STATE(1161)] = 81798,
  [SMALL_STATE(1162)] = 81909,
  [SMALL_STATE(1163)] = 82020,
  [SMALL_STATE(1164)] = 82131,
  [SMALL_STATE(1165)] = 82242,
  [SMALL_STATE(1166)] = 82353,
  [SMALL_STATE(1167)] = 82464,
  [SMALL_STATE(1168)] = 82575,
  [SMALL_STATE(1169)] = 82686,
  [SMALL_STATE(1170)] = 82797,
  [SMALL_STATE(1171)] = 82908,
  [SMALL_STATE(1172)] = 83019,
  [SMALL_STATE(1173)] = 83130,
  [SMALL_STATE(1174)] = 83241,
  [SMALL_STATE(1175)] = 83352,
  [SMALL_STATE(1176)] = 83463,
  [SMALL_STATE(1177)] = 83574,
  [SMALL_STATE(1178)] = 83685,
  [SMALL_STATE(1179)] = 83796,
  [SMALL_STATE(1180)] = 83907,
  [SMALL_STATE(1181)] = 84018,
  [SMALL_STATE(1182)] = 84129,
  [SMALL_STATE(1183)] = 84240,
  [SMALL_STATE(1184)] = 84351,
  [SMALL_STATE(1185)] = 84462,
  [SMALL_STATE(1186)] = 84573,
  [SMALL_STATE(1187)] = 84684,
  [SMALL_STATE(1188)] = 84795,
  [SMALL_STATE(1189)] = 84906,
  [SMALL_STATE(1190)] = 85017,
  [SMALL_STATE(1191)] = 85128,
  [SMALL_STATE(1192)] = 85239,
  [SMALL_STATE(1193)] = 85350,
  [SMALL_STATE(1194)] = 85461,
  [SMALL_STATE(1195)] = 85572,
  [SMALL_STATE(1196)] = 85683,
  [SMALL_STATE(1197)] = 85794,
  [SMALL_STATE(1198)] = 85905,
  [SMALL_STATE(1199)] = 86016,
  [SMALL_STATE(1200)] = 86127,
  [SMALL_STATE(1201)] = 86238,
  [SMALL_STATE(1202)] = 86349,
  [SMALL_STATE(1203)] = 86460,
  [SMALL_STATE(1204)] = 86571,
  [SMALL_STATE(1205)] = 86682,
  [SMALL_STATE(1206)] = 86793,
  [SMALL_STATE(1207)] = 86858,
  [SMALL_STATE(1208)] = 86969,
  [SMALL_STATE(1209)] = 87080,
  [SMALL_STATE(1210)] = 87191,
  [SMALL_STATE(1211)] = 87302,
  [SMALL_STATE(1212)] = 87413,
  [SMALL_STATE(1213)] = 87524,
  [SMALL_STATE(1214)] = 87635,
  [SMALL_STATE(1215)] = 87746,
  [SMALL_STATE(1216)] = 87857,
  [SMALL_STATE(1217)] = 87968,
  [SMALL_STATE(1218)] = 88079,
  [SMALL_STATE(1219)] = 88190,
  [SMALL_STATE(1220)] = 88301,
  [SMALL_STATE(1221)] = 88412,
  [SMALL_STATE(1222)] = 88523,
  [SMALL_STATE(1223)] = 88634,
  [SMALL_STATE(1224)] = 88745,
  [SMALL_STATE(1225)] = 88856,
  [SMALL_STATE(1226)] = 88969,
  [SMALL_STATE(1227)] = 89080,
  [SMALL_STATE(1228)] = 89191,
  [SMALL_STATE(1229)] = 89302,
  [SMALL_STATE(1230)] = 89413,
  [SMALL_STATE(1231)] = 89524,
  [SMALL_STATE(1232)] = 89635,
  [SMALL_STATE(1233)] = 89746,
  [SMALL_STATE(1234)] = 89859,
  [SMALL_STATE(1235)] = 89970,
  [SMALL_STATE(1236)] = 90081,
  [SMALL_STATE(1237)] = 90192,
  [SMALL_STATE(1238)] = 90303,
  [SMALL_STATE(1239)] = 90414,
  [SMALL_STATE(1240)] = 90479,
  [SMALL_STATE(1241)] = 90592,
  [SMALL_STATE(1242)] = 90703,
  [SMALL_STATE(1243)] = 90768,
  [SMALL_STATE(1244)] = 90833,
  [SMALL_STATE(1245)] = 90944,
  [SMALL_STATE(1246)] = 91057,
  [SMALL_STATE(1247)] = 91168,
  [SMALL_STATE(1248)] = 91281,
  [SMALL_STATE(1249)] = 91394,
  [SMALL_STATE(1250)] = 91505,
  [SMALL_STATE(1251)] = 91618,
  [SMALL_STATE(1252)] = 91731,
  [SMALL_STATE(1253)] = 91844,
  [SMALL_STATE(1254)] = 91957,
  [SMALL_STATE(1255)] = 92068,
  [SMALL_STATE(1256)] = 92179,
  [SMALL_STATE(1257)] = 92290,
  [SMALL_STATE(1258)] = 92401,
  [SMALL_STATE(1259)] = 92512,
  [SMALL_STATE(1260)] = 92623,
  [SMALL_STATE(1261)] = 92734,
  [SMALL_STATE(1262)] = 92845,
  [SMALL_STATE(1263)] = 92956,
  [SMALL_STATE(1264)] = 93067,
  [SMALL_STATE(1265)] = 93178,
  [SMALL_STATE(1266)] = 93289,
  [SMALL_STATE(1267)] = 93400,
  [SMALL_STATE(1268)] = 93511,
  [SMALL_STATE(1269)] = 93622,
  [SMALL_STATE(1270)] = 93685,
  [SMALL_STATE(1271)] = 93750,
  [SMALL_STATE(1272)] = 93861,
  [SMALL_STATE(1273)] = 93926,
  [SMALL_STATE(1274)] = 94037,
  [SMALL_STATE(1275)] = 94148,
  [SMALL_STATE(1276)] = 94259,
  [SMALL_STATE(1277)] = 94370,
  [SMALL_STATE(1278)] = 94481,
  [SMALL_STATE(1279)] = 94592,
  [SMALL_STATE(1280)] = 94657,
  [SMALL_STATE(1281)] = 94768,
  [SMALL_STATE(1282)] = 94833,
  [SMALL_STATE(1283)] = 94898,
  [SMALL_STATE(1284)] = 95009,
  [SMALL_STATE(1285)] = 95120,
  [SMALL_STATE(1286)] = 95231,
  [SMALL_STATE(1287)] = 95342,
  [SMALL_STATE(1288)] = 95453,
  [SMALL_STATE(1289)] = 95514,
  [SMALL_STATE(1290)] = 95625,
  [SMALL_STATE(1291)] = 95736,
  [SMALL_STATE(1292)] = 95847,
  [SMALL_STATE(1293)] = 95958,
  [SMALL_STATE(1294)] = 96069,
  [SMALL_STATE(1295)] = 96180,
  [SMALL_STATE(1296)] = 96291,
  [SMALL_STATE(1297)] = 96402,
  [SMALL_STATE(1298)] = 96513,
  [SMALL_STATE(1299)] = 96624,
  [SMALL_STATE(1300)] = 96735,
  [SMALL_STATE(1301)] = 96846,
  [SMALL_STATE(1302)] = 96957,
  [SMALL_STATE(1303)] = 97068,
  [SMALL_STATE(1304)] = 97179,
  [SMALL_STATE(1305)] = 97292,
  [SMALL_STATE(1306)] = 97403,
  [SMALL_STATE(1307)] = 97514,
  [SMALL_STATE(1308)] = 97625,
  [SMALL_STATE(1309)] = 97736,
  [SMALL_STATE(1310)] = 97847,
  [SMALL_STATE(1311)] = 97958,
  [SMALL_STATE(1312)] = 98069,
  [SMALL_STATE(1313)] = 98136,
  [SMALL_STATE(1314)] = 98247,
  [SMALL_STATE(1315)] = 98358,
  [SMALL_STATE(1316)] = 98469,
  [SMALL_STATE(1317)] = 98580,
  [SMALL_STATE(1318)] = 98691,
  [SMALL_STATE(1319)] = 98802,
  [SMALL_STATE(1320)] = 98913,
  [SMALL_STATE(1321)] = 99024,
  [SMALL_STATE(1322)] = 99135,
  [SMALL_STATE(1323)] = 99246,
  [SMALL_STATE(1324)] = 99357,
  [SMALL_STATE(1325)] = 99468,
  [SMALL_STATE(1326)] = 99579,
  [SMALL_STATE(1327)] = 99646,
  [SMALL_STATE(1328)] = 99713,
  [SMALL_STATE(1329)] = 99780,
  [SMALL_STATE(1330)] = 99891,
  [SMALL_STATE(1331)] = 99958,
  [SMALL_STATE(1332)] = 100069,
  [SMALL_STATE(1333)] = 100180,
  [SMALL_STATE(1334)] = 100247,
  [SMALL_STATE(1335)] = 100358,
  [SMALL_STATE(1336)] = 100469,
  [SMALL_STATE(1337)] = 100536,
  [SMALL_STATE(1338)] = 100647,
  [SMALL_STATE(1339)] = 100712,
  [SMALL_STATE(1340)] = 100823,
  [SMALL_STATE(1341)] = 100888,
  [SMALL_STATE(1342)] = 100953,
  [SMALL_STATE(1343)] = 101064,
  [SMALL_STATE(1344)] = 101177,
  [SMALL_STATE(1345)] = 101288,
  [SMALL_STATE(1346)] = 101399,
  [SMALL_STATE(1347)] = 101510,
  [SMALL_STATE(1348)] = 101623,
  [SMALL_STATE(1349)] = 101734,
  [SMALL_STATE(1350)] = 101799,
  [SMALL_STATE(1351)] = 101910,
  [SMALL_STATE(1352)] = 102021,
  [SMALL_STATE(1353)] = 102132,
  [SMALL_STATE(1354)] = 102245,
  [SMALL_STATE(1355)] = 102358,
  [SMALL_STATE(1356)] = 102469,
  [SMALL_STATE(1357)] = 102534,
  [SMALL_STATE(1358)] = 102645,
  [SMALL_STATE(1359)] = 102758,
  [SMALL_STATE(1360)] = 102871,
  [SMALL_STATE(1361)] = 102984,
  [SMALL_STATE(1362)] = 103095,
  [SMALL_STATE(1363)] = 103206,
  [SMALL_STATE(1364)] = 103319,
  [SMALL_STATE(1365)] = 103432,
  [SMALL_STATE(1366)] = 103543,
  [SMALL_STATE(1367)] = 103654,
  [SMALL_STATE(1368)] = 103765,
  [SMALL_STATE(1369)] = 103876,
  [SMALL_STATE(1370)] = 103987,
  [SMALL_STATE(1371)] = 104098,
  [SMALL_STATE(1372)] = 104211,
  [SMALL_STATE(1373)] = 104324,
  [SMALL_STATE(1374)] = 104435,
  [SMALL_STATE(1375)] = 104546,
  [SMALL_STATE(1376)] = 104613,
  [SMALL_STATE(1377)] = 104724,
  [SMALL_STATE(1378)] = 104837,
  [SMALL_STATE(1379)] = 104950,
  [SMALL_STATE(1380)] = 105063,
  [SMALL_STATE(1381)] = 105174,
  [SMALL_STATE(1382)] = 105285,
  [SMALL_STATE(1383)] = 105396,
  [SMALL_STATE(1384)] = 105457,
  [SMALL_STATE(1385)] = 105568,
  [SMALL_STATE(1386)] = 105679,
  [SMALL_STATE(1387)] = 105792,
  [SMALL_STATE(1388)] = 105853,
  [SMALL_STATE(1389)] = 105964,
  [SMALL_STATE(1390)] = 106075,
  [SMALL_STATE(1391)] = 106186,
  [SMALL_STATE(1392)] = 106247,
  [SMALL_STATE(1393)] = 106358,
  [SMALL_STATE(1394)] = 106469,
  [SMALL_STATE(1395)] = 106530,
  [SMALL_STATE(1396)] = 106591,
  [SMALL_STATE(1397)] = 106702,
  [SMALL_STATE(1398)] = 106813,
  [SMALL_STATE(1399)] = 106924,
  [SMALL_STATE(1400)] = 106989,
  [SMALL_STATE(1401)] = 107100,
  [SMALL_STATE(1402)] = 107161,
  [SMALL_STATE(1403)] = 107226,
  [SMALL_STATE(1404)] = 107337,
  [SMALL_STATE(1405)] = 107448,
  [SMALL_STATE(1406)] = 107559,
  [SMALL_STATE(1407)] = 107670,
  [SMALL_STATE(1408)] = 107781,
  [SMALL_STATE(1409)] = 107892,
  [SMALL_STATE(1410)] = 108003,
  [SMALL_STATE(1411)] = 108114,
  [SMALL_STATE(1412)] = 108225,
  [SMALL_STATE(1413)] = 108336,
  [SMALL_STATE(1414)] = 108447,
  [SMALL_STATE(1415)] = 108558,
  [SMALL_STATE(1416)] = 108669,
  [SMALL_STATE(1417)] = 108780,
  [SMALL_STATE(1418)] = 108891,
  [SMALL_STATE(1419)] = 109002,
  [SMALL_STATE(1420)] = 109115,
  [SMALL_STATE(1421)] = 109226,
  [SMALL_STATE(1422)] = 109337,
  [SMALL_STATE(1423)] = 109448,
  [SMALL_STATE(1424)] = 109559,
  [SMALL_STATE(1425)] = 109624,
  [SMALL_STATE(1426)] = 109735,
  [SMALL_STATE(1427)] = 109846,
  [SMALL_STATE(1428)] = 109957,
  [SMALL_STATE(1429)] = 110068,
  [SMALL_STATE(1430)] = 110179,
  [SMALL_STATE(1431)] = 110290,
  [SMALL_STATE(1432)] = 110401,
  [SMALL_STATE(1433)] = 110512,
  [SMALL_STATE(1434)] = 110623,
  [SMALL_STATE(1435)] = 110734,
  [SMALL_STATE(1436)] = 110845,
  [SMALL_STATE(1437)] = 110956,
  [SMALL_STATE(1438)] = 111067,
  [SMALL_STATE(1439)] = 111178,
  [SMALL_STATE(1440)] = 111289,
  [SMALL_STATE(1441)] = 111400,
  [SMALL_STATE(1442)] = 111511,
  [SMALL_STATE(1443)] = 111622,
  [SMALL_STATE(1444)] = 111733,
  [SMALL_STATE(1445)] = 111844,
  [SMALL_STATE(1446)] = 111955,
  [SMALL_STATE(1447)] = 112024,
  [SMALL_STATE(1448)] = 112135,
  [SMALL_STATE(1449)] = 112246,
  [SMALL_STATE(1450)] = 112357,
  [SMALL_STATE(1451)] = 112468,
  [SMALL_STATE(1452)] = 112579,
  [SMALL_STATE(1453)] = 112690,
  [SMALL_STATE(1454)] = 112801,
  [SMALL_STATE(1455)] = 112912,
  [SMALL_STATE(1456)] = 113023,
  [SMALL_STATE(1457)] = 113134,
  [SMALL_STATE(1458)] = 113245,
  [SMALL_STATE(1459)] = 113356,
  [SMALL_STATE(1460)] = 113467,
  [SMALL_STATE(1461)] = 113578,
  [SMALL_STATE(1462)] = 113689,
  [SMALL_STATE(1463)] = 113800,
  [SMALL_STATE(1464)] = 113911,
  [SMALL_STATE(1465)] = 114022,
  [SMALL_STATE(1466)] = 114133,
  [SMALL_STATE(1467)] = 114244,
  [SMALL_STATE(1468)] = 114355,
  [SMALL_STATE(1469)] = 114466,
  [SMALL_STATE(1470)] = 114577,
  [SMALL_STATE(1471)] = 114688,
  [SMALL_STATE(1472)] = 114799,
  [SMALL_STATE(1473)] = 114910,
  [SMALL_STATE(1474)] = 115021,
  [SMALL_STATE(1475)] = 115132,
  [SMALL_STATE(1476)] = 115243,
  [SMALL_STATE(1477)] = 115354,
  [SMALL_STATE(1478)] = 115465,
  [SMALL_STATE(1479)] = 115576,
  [SMALL_STATE(1480)] = 115687,
  [SMALL_STATE(1481)] = 115798,
  [SMALL_STATE(1482)] = 115909,
  [SMALL_STATE(1483)] = 116020,
  [SMALL_STATE(1484)] = 116131,
  [SMALL_STATE(1485)] = 116242,
  [SMALL_STATE(1486)] = 116353,
  [SMALL_STATE(1487)] = 116464,
  [SMALL_STATE(1488)] = 116575,
  [SMALL_STATE(1489)] = 116686,
  [SMALL_STATE(1490)] = 116797,
  [SMALL_STATE(1491)] = 116908,
  [SMALL_STATE(1492)] = 117019,
  [SMALL_STATE(1493)] = 117130,
  [SMALL_STATE(1494)] = 117241,
  [SMALL_STATE(1495)] = 117352,
  [SMALL_STATE(1496)] = 117463,
  [SMALL_STATE(1497)] = 117574,
  [SMALL_STATE(1498)] = 117685,
  [SMALL_STATE(1499)] = 117796,
  [SMALL_STATE(1500)] = 117907,
  [SMALL_STATE(1501)] = 118018,
  [SMALL_STATE(1502)] = 118129,
  [SMALL_STATE(1503)] = 118240,
  [SMALL_STATE(1504)] = 118351,
  [SMALL_STATE(1505)] = 118462,
  [SMALL_STATE(1506)] = 118573,
  [SMALL_STATE(1507)] = 118684,
  [SMALL_STATE(1508)] = 118795,
  [SMALL_STATE(1509)] = 118906,
  [SMALL_STATE(1510)] = 119017,
  [SMALL_STATE(1511)] = 119128,
  [SMALL_STATE(1512)] = 119239,
  [SMALL_STATE(1513)] = 119350,
  [SMALL_STATE(1514)] = 119461,
  [SMALL_STATE(1515)] = 119572,
  [SMALL_STATE(1516)] = 119683,
  [SMALL_STATE(1517)] = 119794,
  [SMALL_STATE(1518)] = 119905,
  [SMALL_STATE(1519)] = 120016,
  [SMALL_STATE(1520)] = 120127,
  [SMALL_STATE(1521)] = 120238,
  [SMALL_STATE(1522)] = 120349,
  [SMALL_STATE(1523)] = 120460,
  [SMALL_STATE(1524)] = 120571,
  [SMALL_STATE(1525)] = 120682,
  [SMALL_STATE(1526)] = 120793,
  [SMALL_STATE(1527)] = 120904,
  [SMALL_STATE(1528)] = 121015,
  [SMALL_STATE(1529)] = 121126,
  [SMALL_STATE(1530)] = 121237,
  [SMALL_STATE(1531)] = 121348,
  [SMALL_STATE(1532)] = 121459,
  [SMALL_STATE(1533)] = 121570,
  [SMALL_STATE(1534)] = 121635,
  [SMALL_STATE(1535)] = 121746,
  [SMALL_STATE(1536)] = 121857,
  [SMALL_STATE(1537)] = 121968,
  [SMALL_STATE(1538)] = 122079,
  [SMALL_STATE(1539)] = 122190,
  [SMALL_STATE(1540)] = 122301,
  [SMALL_STATE(1541)] = 122412,
  [SMALL_STATE(1542)] = 122523,
  [SMALL_STATE(1543)] = 122634,
  [SMALL_STATE(1544)] = 122745,
  [SMALL_STATE(1545)] = 122856,
  [SMALL_STATE(1546)] = 122967,
  [SMALL_STATE(1547)] = 123078,
  [SMALL_STATE(1548)] = 123189,
  [SMALL_STATE(1549)] = 123300,
  [SMALL_STATE(1550)] = 123411,
  [SMALL_STATE(1551)] = 123522,
  [SMALL_STATE(1552)] = 123591,
  [SMALL_STATE(1553)] = 123702,
  [SMALL_STATE(1554)] = 123813,
  [SMALL_STATE(1555)] = 123924,
  [SMALL_STATE(1556)] = 124035,
  [SMALL_STATE(1557)] = 124146,
  [SMALL_STATE(1558)] = 124257,
  [SMALL_STATE(1559)] = 124368,
  [SMALL_STATE(1560)] = 124481,
  [SMALL_STATE(1561)] = 124592,
  [SMALL_STATE(1562)] = 124703,
  [SMALL_STATE(1563)] = 124814,
  [SMALL_STATE(1564)] = 124925,
  [SMALL_STATE(1565)] = 125036,
  [SMALL_STATE(1566)] = 125147,
  [SMALL_STATE(1567)] = 125258,
  [SMALL_STATE(1568)] = 125369,
  [SMALL_STATE(1569)] = 125480,
  [SMALL_STATE(1570)] = 125591,
  [SMALL_STATE(1571)] = 125702,
  [SMALL_STATE(1572)] = 125813,
  [SMALL_STATE(1573)] = 125924,
  [SMALL_STATE(1574)] = 126035,
  [SMALL_STATE(1575)] = 126146,
  [SMALL_STATE(1576)] = 126257,
  [SMALL_STATE(1577)] = 126368,
  [SMALL_STATE(1578)] = 126479,
  [SMALL_STATE(1579)] = 126590,
  [SMALL_STATE(1580)] = 126701,
  [SMALL_STATE(1581)] = 126812,
  [SMALL_STATE(1582)] = 126923,
  [SMALL_STATE(1583)] = 127034,
  [SMALL_STATE(1584)] = 127145,
  [SMALL_STATE(1585)] = 127256,
  [SMALL_STATE(1586)] = 127367,
  [SMALL_STATE(1587)] = 127478,
  [SMALL_STATE(1588)] = 127589,
  [SMALL_STATE(1589)] = 127700,
  [SMALL_STATE(1590)] = 127811,
  [SMALL_STATE(1591)] = 127922,
  [SMALL_STATE(1592)] = 128033,
  [SMALL_STATE(1593)] = 128144,
  [SMALL_STATE(1594)] = 128255,
  [SMALL_STATE(1595)] = 128366,
  [SMALL_STATE(1596)] = 128477,
  [SMALL_STATE(1597)] = 128588,
  [SMALL_STATE(1598)] = 128699,
  [SMALL_STATE(1599)] = 128810,
  [SMALL_STATE(1600)] = 128921,
  [SMALL_STATE(1601)] = 129032,
  [SMALL_STATE(1602)] = 129143,
  [SMALL_STATE(1603)] = 129254,
  [SMALL_STATE(1604)] = 129365,
  [SMALL_STATE(1605)] = 129476,
  [SMALL_STATE(1606)] = 129587,
  [SMALL_STATE(1607)] = 129698,
  [SMALL_STATE(1608)] = 129809,
  [SMALL_STATE(1609)] = 129920,
  [SMALL_STATE(1610)] = 130031,
  [SMALL_STATE(1611)] = 130142,
  [SMALL_STATE(1612)] = 130253,
  [SMALL_STATE(1613)] = 130364,
  [SMALL_STATE(1614)] = 130475,
  [SMALL_STATE(1615)] = 130586,
  [SMALL_STATE(1616)] = 130697,
  [SMALL_STATE(1617)] = 130808,
  [SMALL_STATE(1618)] = 130919,
  [SMALL_STATE(1619)] = 131030,
  [SMALL_STATE(1620)] = 131141,
  [SMALL_STATE(1621)] = 131252,
  [SMALL_STATE(1622)] = 131363,
  [SMALL_STATE(1623)] = 131474,
  [SMALL_STATE(1624)] = 131585,
  [SMALL_STATE(1625)] = 131696,
  [SMALL_STATE(1626)] = 131807,
  [SMALL_STATE(1627)] = 131918,
  [SMALL_STATE(1628)] = 132031,
  [SMALL_STATE(1629)] = 132142,
  [SMALL_STATE(1630)] = 132253,
  [SMALL_STATE(1631)] = 132364,
  [SMALL_STATE(1632)] = 132475,
  [SMALL_STATE(1633)] = 132586,
  [SMALL_STATE(1634)] = 132697,
  [SMALL_STATE(1635)] = 132808,
  [SMALL_STATE(1636)] = 132919,
  [SMALL_STATE(1637)] = 133030,
  [SMALL_STATE(1638)] = 133141,
  [SMALL_STATE(1639)] = 133252,
  [SMALL_STATE(1640)] = 133363,
  [SMALL_STATE(1641)] = 133474,
  [SMALL_STATE(1642)] = 133585,
  [SMALL_STATE(1643)] = 133696,
  [SMALL_STATE(1644)] = 133807,
  [SMALL_STATE(1645)] = 133918,
  [SMALL_STATE(1646)] = 134029,
  [SMALL_STATE(1647)] = 134140,
  [SMALL_STATE(1648)] = 134251,
  [SMALL_STATE(1649)] = 134362,
  [SMALL_STATE(1650)] = 134473,
  [SMALL_STATE(1651)] = 134584,
  [SMALL_STATE(1652)] = 134695,
  [SMALL_STATE(1653)] = 134806,
  [SMALL_STATE(1654)] = 134917,
  [SMALL_STATE(1655)] = 135028,
  [SMALL_STATE(1656)] = 135139,
  [SMALL_STATE(1657)] = 135250,
  [SMALL_STATE(1658)] = 135361,
  [SMALL_STATE(1659)] = 135472,
  [SMALL_STATE(1660)] = 135583,
  [SMALL_STATE(1661)] = 135694,
  [SMALL_STATE(1662)] = 135805,
  [SMALL_STATE(1663)] = 135916,
  [SMALL_STATE(1664)] = 136027,
  [SMALL_STATE(1665)] = 136138,
  [SMALL_STATE(1666)] = 136249,
  [SMALL_STATE(1667)] = 136360,
  [SMALL_STATE(1668)] = 136471,
  [SMALL_STATE(1669)] = 136582,
  [SMALL_STATE(1670)] = 136693,
  [SMALL_STATE(1671)] = 136804,
  [SMALL_STATE(1672)] = 136915,
  [SMALL_STATE(1673)] = 137026,
  [SMALL_STATE(1674)] = 137137,
  [SMALL_STATE(1675)] = 137248,
  [SMALL_STATE(1676)] = 137359,
  [SMALL_STATE(1677)] = 137470,
  [SMALL_STATE(1678)] = 137583,
  [SMALL_STATE(1679)] = 137694,
  [SMALL_STATE(1680)] = 137805,
  [SMALL_STATE(1681)] = 137916,
  [SMALL_STATE(1682)] = 138027,
  [SMALL_STATE(1683)] = 138138,
  [SMALL_STATE(1684)] = 138249,
  [SMALL_STATE(1685)] = 138360,
  [SMALL_STATE(1686)] = 138471,
  [SMALL_STATE(1687)] = 138582,
  [SMALL_STATE(1688)] = 138693,
  [SMALL_STATE(1689)] = 138804,
  [SMALL_STATE(1690)] = 138915,
  [SMALL_STATE(1691)] = 139026,
  [SMALL_STATE(1692)] = 139137,
  [SMALL_STATE(1693)] = 139248,
  [SMALL_STATE(1694)] = 139359,
  [SMALL_STATE(1695)] = 139470,
  [SMALL_STATE(1696)] = 139581,
  [SMALL_STATE(1697)] = 139692,
  [SMALL_STATE(1698)] = 139803,
  [SMALL_STATE(1699)] = 139914,
  [SMALL_STATE(1700)] = 140025,
  [SMALL_STATE(1701)] = 140136,
  [SMALL_STATE(1702)] = 140247,
  [SMALL_STATE(1703)] = 140358,
  [SMALL_STATE(1704)] = 140469,
  [SMALL_STATE(1705)] = 140580,
  [SMALL_STATE(1706)] = 140691,
  [SMALL_STATE(1707)] = 140802,
  [SMALL_STATE(1708)] = 140913,
  [SMALL_STATE(1709)] = 141024,
  [SMALL_STATE(1710)] = 141135,
  [SMALL_STATE(1711)] = 141246,
  [SMALL_STATE(1712)] = 141357,
  [SMALL_STATE(1713)] = 141470,
  [SMALL_STATE(1714)] = 141581,
  [SMALL_STATE(1715)] = 141694,
  [SMALL_STATE(1716)] = 141805,
  [SMALL_STATE(1717)] = 141916,
  [SMALL_STATE(1718)] = 142027,
  [SMALL_STATE(1719)] = 142138,
  [SMALL_STATE(1720)] = 142249,
  [SMALL_STATE(1721)] = 142360,
  [SMALL_STATE(1722)] = 142471,
  [SMALL_STATE(1723)] = 142582,
  [SMALL_STATE(1724)] = 142693,
  [SMALL_STATE(1725)] = 142804,
  [SMALL_STATE(1726)] = 142915,
  [SMALL_STATE(1727)] = 143026,
  [SMALL_STATE(1728)] = 143137,
  [SMALL_STATE(1729)] = 143248,
  [SMALL_STATE(1730)] = 143359,
  [SMALL_STATE(1731)] = 143470,
  [SMALL_STATE(1732)] = 143581,
  [SMALL_STATE(1733)] = 143692,
  [SMALL_STATE(1734)] = 143803,
  [SMALL_STATE(1735)] = 143914,
  [SMALL_STATE(1736)] = 144025,
  [SMALL_STATE(1737)] = 144136,
  [SMALL_STATE(1738)] = 144247,
  [SMALL_STATE(1739)] = 144358,
  [SMALL_STATE(1740)] = 144469,
  [SMALL_STATE(1741)] = 144580,
  [SMALL_STATE(1742)] = 144691,
  [SMALL_STATE(1743)] = 144802,
  [SMALL_STATE(1744)] = 144913,
  [SMALL_STATE(1745)] = 145026,
  [SMALL_STATE(1746)] = 145137,
  [SMALL_STATE(1747)] = 145248,
  [SMALL_STATE(1748)] = 145361,
  [SMALL_STATE(1749)] = 145474,
  [SMALL_STATE(1750)] = 145587,
  [SMALL_STATE(1751)] = 145698,
  [SMALL_STATE(1752)] = 145809,
  [SMALL_STATE(1753)] = 145920,
  [SMALL_STATE(1754)] = 146031,
  [SMALL_STATE(1755)] = 146144,
  [SMALL_STATE(1756)] = 146257,
  [SMALL_STATE(1757)] = 146368,
  [SMALL_STATE(1758)] = 146479,
  [SMALL_STATE(1759)] = 146590,
  [SMALL_STATE(1760)] = 146701,
  [SMALL_STATE(1761)] = 146814,
  [SMALL_STATE(1762)] = 146927,
  [SMALL_STATE(1763)] = 147040,
  [SMALL_STATE(1764)] = 147153,
  [SMALL_STATE(1765)] = 147264,
  [SMALL_STATE(1766)] = 147375,
  [SMALL_STATE(1767)] = 147486,
  [SMALL_STATE(1768)] = 147597,
  [SMALL_STATE(1769)] = 147710,
  [SMALL_STATE(1770)] = 147823,
  [SMALL_STATE(1771)] = 147934,
  [SMALL_STATE(1772)] = 148045,
  [SMALL_STATE(1773)] = 148156,
  [SMALL_STATE(1774)] = 148267,
  [SMALL_STATE(1775)] = 148378,
  [SMALL_STATE(1776)] = 148489,
  [SMALL_STATE(1777)] = 148600,
  [SMALL_STATE(1778)] = 148711,
  [SMALL_STATE(1779)] = 148822,
  [SMALL_STATE(1780)] = 148933,
  [SMALL_STATE(1781)] = 149044,
  [SMALL_STATE(1782)] = 149155,
  [SMALL_STATE(1783)] = 149266,
  [SMALL_STATE(1784)] = 149377,
  [SMALL_STATE(1785)] = 149488,
  [SMALL_STATE(1786)] = 149599,
  [SMALL_STATE(1787)] = 149710,
  [SMALL_STATE(1788)] = 149821,
  [SMALL_STATE(1789)] = 149932,
  [SMALL_STATE(1790)] = 150043,
  [SMALL_STATE(1791)] = 150154,
  [SMALL_STATE(1792)] = 150265,
  [SMALL_STATE(1793)] = 150376,
  [SMALL_STATE(1794)] = 150487,
  [SMALL_STATE(1795)] = 150598,
  [SMALL_STATE(1796)] = 150709,
  [SMALL_STATE(1797)] = 150820,
  [SMALL_STATE(1798)] = 150931,
  [SMALL_STATE(1799)] = 151042,
  [SMALL_STATE(1800)] = 151153,
  [SMALL_STATE(1801)] = 151264,
  [SMALL_STATE(1802)] = 151375,
  [SMALL_STATE(1803)] = 151486,
  [SMALL_STATE(1804)] = 151597,
  [SMALL_STATE(1805)] = 151708,
  [SMALL_STATE(1806)] = 151819,
  [SMALL_STATE(1807)] = 151930,
  [SMALL_STATE(1808)] = 151996,
  [SMALL_STATE(1809)] = 152060,
  [SMALL_STATE(1810)] = 152124,
  [SMALL_STATE(1811)] = 152190,
  [SMALL_STATE(1812)] = 152254,
  [SMALL_STATE(1813)] = 152316,
  [SMALL_STATE(1814)] = 152388,
  [SMALL_STATE(1815)] = 152454,
  [SMALL_STATE(1816)] = 152520,
  [SMALL_STATE(1817)] = 152580,
  [SMALL_STATE(1818)] = 152644,
  [SMALL_STATE(1819)] = 152706,
  [SMALL_STATE(1820)] = 152770,
  [SMALL_STATE(1821)] = 152834,
  [SMALL_STATE(1822)] = 152894,
  [SMALL_STATE(1823)] = 152958,
  [SMALL_STATE(1824)] = 153022,
  [SMALL_STATE(1825)] = 153082,
  [SMALL_STATE(1826)] = 153142,
  [SMALL_STATE(1827)] = 153228,
  [SMALL_STATE(1828)] = 153298,
  [SMALL_STATE(1829)] = 153378,
  [SMALL_STATE(1830)] = 153490,
  [SMALL_STATE(1831)] = 153554,
  [SMALL_STATE(1832)] = 153614,
  [SMALL_STATE(1833)] = 153682,
  [SMALL_STATE(1834)] = 153748,
  [SMALL_STATE(1835)] = 153814,
  [SMALL_STATE(1836)] = 153878,
  [SMALL_STATE(1837)] = 153942,
  [SMALL_STATE(1838)] = 154006,
  [SMALL_STATE(1839)] = 154068,
  [SMALL_STATE(1840)] = 154128,
  [SMALL_STATE(1841)] = 154192,
  [SMALL_STATE(1842)] = 154258,
  [SMALL_STATE(1843)] = 154356,
  [SMALL_STATE(1844)] = 154416,
  [SMALL_STATE(1845)] = 154480,
  [SMALL_STATE(1846)] = 154544,
  [SMALL_STATE(1847)] = 154612,
  [SMALL_STATE(1848)] = 154680,
  [SMALL_STATE(1849)] = 154748,
  [SMALL_STATE(1850)] = 154812,
  [SMALL_STATE(1851)] = 154878,
  [SMALL_STATE(1852)] = 154944,
  [SMALL_STATE(1853)] = 155010,
  [SMALL_STATE(1854)] = 155090,
  [SMALL_STATE(1855)] = 155156,
  [SMALL_STATE(1856)] = 155252,
  [SMALL_STATE(1857)] = 155318,
  [SMALL_STATE(1858)] = 155384,
  [SMALL_STATE(1859)] = 155446,
  [SMALL_STATE(1860)] = 155510,
  [SMALL_STATE(1861)] = 155574,
  [SMALL_STATE(1862)] = 155640,
  [SMALL_STATE(1863)] = 155700,
  [SMALL_STATE(1864)] = 155760,
  [SMALL_STATE(1865)] = 155830,
  [SMALL_STATE(1866)] = 155924,
  [SMALL_STATE(1867)] = 155992,
  [SMALL_STATE(1868)] = 156086,
  [SMALL_STATE(1869)] = 156152,
  [SMALL_STATE(1870)] = 156218,
  [SMALL_STATE(1871)] = 156288,
  [SMALL_STATE(1872)] = 156378,
  [SMALL_STATE(1873)] = 156444,
  [SMALL_STATE(1874)] = 156504,
  [SMALL_STATE(1875)] = 156564,
  [SMALL_STATE(1876)] = 156630,
  [SMALL_STATE(1877)] = 156690,
  [SMALL_STATE(1878)] = 156756,
  [SMALL_STATE(1879)] = 156822,
  [SMALL_STATE(1880)] = 156898,
  [SMALL_STATE(1881)] = 156964,
  [SMALL_STATE(1882)] = 157028,
  [SMALL_STATE(1883)] = 157088,
  [SMALL_STATE(1884)] = 157148,
  [SMALL_STATE(1885)] = 157211,
  [SMALL_STATE(1886)] = 157306,
  [SMALL_STATE(1887)] = 157369,
  [SMALL_STATE(1888)] = 157432,
  [SMALL_STATE(1889)] = 157495,
  [SMALL_STATE(1890)] = 157558,
  [SMALL_STATE(1891)] = 157621,
  [SMALL_STATE(1892)] = 157710,
  [SMALL_STATE(1893)] = 157773,
  [SMALL_STATE(1894)] = 157842,
  [SMALL_STATE(1895)] = 157901,
  [SMALL_STATE(1896)] = 157960,
  [SMALL_STATE(1897)] = 158035,
  [SMALL_STATE(1898)] = 158114,
  [SMALL_STATE(1899)] = 158175,
  [SMALL_STATE(1900)] = 158238,
  [SMALL_STATE(1901)] = 158297,
  [SMALL_STATE(1902)] = 158356,
  [SMALL_STATE(1903)] = 158415,
  [SMALL_STATE(1904)] = 158478,
  [SMALL_STATE(1905)] = 158537,
  [SMALL_STATE(1906)] = 158600,
  [SMALL_STATE(1907)] = 158663,
  [SMALL_STATE(1908)] = 158734,
  [SMALL_STATE(1909)] = 158797,
  [SMALL_STATE(1910)] = 158882,
  [SMALL_STATE(1911)] = 158945,
  [SMALL_STATE(1912)] = 159008,
  [SMALL_STATE(1913)] = 159105,
  [SMALL_STATE(1914)] = 159168,
  [SMALL_STATE(1915)] = 159229,
  [SMALL_STATE(1916)] = 159324,
  [SMALL_STATE(1917)] = 159417,
  [SMALL_STATE(1918)] = 159480,
  [SMALL_STATE(1919)] = 159543,
  [SMALL_STATE(1920)] = 159602,
  [SMALL_STATE(1921)] = 159665,
  [SMALL_STATE(1922)] = 159724,
  [SMALL_STATE(1923)] = 159817,
  [SMALL_STATE(1924)] = 159880,
  [SMALL_STATE(1925)] = 159943,
  [SMALL_STATE(1926)] = 160006,
  [SMALL_STATE(1927)] = 160069,
  [SMALL_STATE(1928)] = 160130,
  [SMALL_STATE(1929)] = 160193,
  [SMALL_STATE(1930)] = 160254,
  [SMALL_STATE(1931)] = 160325,
  [SMALL_STATE(1932)] = 160410,
  [SMALL_STATE(1933)] = 160469,
  [SMALL_STATE(1934)] = 160532,
  [SMALL_STATE(1935)] = 160595,
  [SMALL_STATE(1936)] = 160702,
  [SMALL_STATE(1937)] = 160763,
  [SMALL_STATE(1938)] = 160822,
  [SMALL_STATE(1939)] = 160901,
  [SMALL_STATE(1940)] = 161000,
  [SMALL_STATE(1941)] = 161063,
  [SMALL_STATE(1942)] = 161162,
  [SMALL_STATE(1943)] = 161261,
  [SMALL_STATE(1944)] = 161324,
  [SMALL_STATE(1945)] = 161423,
  [SMALL_STATE(1946)] = 161482,
  [SMALL_STATE(1947)] = 161545,
  [SMALL_STATE(1948)] = 161608,
  [SMALL_STATE(1949)] = 161671,
  [SMALL_STATE(1950)] = 161734,
  [SMALL_STATE(1951)] = 161793,
  [SMALL_STATE(1952)] = 161862,
  [SMALL_STATE(1953)] = 161921,
  [SMALL_STATE(1954)] = 161982,
  [SMALL_STATE(1955)] = 162041,
  [SMALL_STATE(1956)] = 162100,
  [SMALL_STATE(1957)] = 162211,
  [SMALL_STATE(1958)] = 162280,
  [SMALL_STATE(1959)] = 162349,
  [SMALL_STATE(1960)] = 162412,
  [SMALL_STATE(1961)] = 162491,
  [SMALL_STATE(1962)] = 162556,
  [SMALL_STATE(1963)] = 162621,
  [SMALL_STATE(1964)] = 162720,
  [SMALL_STATE(1965)] = 162779,
  [SMALL_STATE(1966)] = 162838,
  [SMALL_STATE(1967)] = 162917,
  [SMALL_STATE(1968)] = 162978,
  [SMALL_STATE(1969)] = 163039,
  [SMALL_STATE(1970)] = 163100,
  [SMALL_STATE(1971)] = 163159,
  [SMALL_STATE(1972)] = 163222,
  [SMALL_STATE(1973)] = 163285,
  [SMALL_STATE(1974)] = 163380,
  [SMALL_STATE(1975)] = 163479,
  [SMALL_STATE(1976)] = 163576,
  [SMALL_STATE(1977)] = 163673,
  [SMALL_STATE(1978)] = 163738,
  [SMALL_STATE(1979)] = 163823,
  [SMALL_STATE(1980)] = 163886,
  [SMALL_STATE(1981)] = 163957,
  [SMALL_STATE(1982)] = 164016,
  [SMALL_STATE(1983)] = 164075,
  [SMALL_STATE(1984)] = 164134,
  [SMALL_STATE(1985)] = 164199,
  [SMALL_STATE(1986)] = 164262,
  [SMALL_STATE(1987)] = 164321,
  [SMALL_STATE(1988)] = 164384,
  [SMALL_STATE(1989)] = 164443,
  [SMALL_STATE(1990)] = 164542,
  [SMALL_STATE(1991)] = 164603,
  [SMALL_STATE(1992)] = 164664,
  [SMALL_STATE(1993)] = 164727,
  [SMALL_STATE(1994)] = 164826,
  [SMALL_STATE(1995)] = 164889,
  [SMALL_STATE(1996)] = 164982,
  [SMALL_STATE(1997)] = 165041,
  [SMALL_STATE(1998)] = 165102,
  [SMALL_STATE(1999)] = 165161,
  [SMALL_STATE(2000)] = 165224,
  [SMALL_STATE(2001)] = 165285,
  [SMALL_STATE(2002)] = 165344,
  [SMALL_STATE(2003)] = 165403,
  [SMALL_STATE(2004)] = 165462,
  [SMALL_STATE(2005)] = 165523,
  [SMALL_STATE(2006)] = 165584,
  [SMALL_STATE(2007)] = 165647,
  [SMALL_STATE(2008)] = 165706,
  [SMALL_STATE(2009)] = 165767,
  [SMALL_STATE(2010)] = 165832,
  [SMALL_STATE(2011)] = 165891,
  [SMALL_STATE(2012)] = 165950,
  [SMALL_STATE(2013)] = 166009,
  [SMALL_STATE(2014)] = 166068,
  [SMALL_STATE(2015)] = 166131,
  [SMALL_STATE(2016)] = 166192,
  [SMALL_STATE(2017)] = 166253,
  [SMALL_STATE(2018)] = 166312,
  [SMALL_STATE(2019)] = 166375,
  [SMALL_STATE(2020)] = 166468,
  [SMALL_STATE(2021)] = 166531,
  [SMALL_STATE(2022)] = 166592,
  [SMALL_STATE(2023)] = 166657,
  [SMALL_STATE(2024)] = 166756,
  [SMALL_STATE(2025)] = 166855,
  [SMALL_STATE(2026)] = 166918,
  [SMALL_STATE(2027)] = 166977,
  [SMALL_STATE(2028)] = 167076,
  [SMALL_STATE(2029)] = 167175,
  [SMALL_STATE(2030)] = 167236,
  [SMALL_STATE(2031)] = 167297,
  [SMALL_STATE(2032)] = 167358,
  [SMALL_STATE(2033)] = 167419,
  [SMALL_STATE(2034)] = 167480,
  [SMALL_STATE(2035)] = 167541,
  [SMALL_STATE(2036)] = 167602,
  [SMALL_STATE(2037)] = 167695,
  [SMALL_STATE(2038)] = 167756,
  [SMALL_STATE(2039)] = 167819,
  [SMALL_STATE(2040)] = 167918,
  [SMALL_STATE(2041)] = 167979,
  [SMALL_STATE(2042)] = 168042,
  [SMALL_STATE(2043)] = 168101,
  [SMALL_STATE(2044)] = 168180,
  [SMALL_STATE(2045)] = 168239,
  [SMALL_STATE(2046)] = 168314,
  [SMALL_STATE(2047)] = 168375,
  [SMALL_STATE(2048)] = 168444,
  [SMALL_STATE(2049)] = 168505,
  [SMALL_STATE(2050)] = 168594,
  [SMALL_STATE(2051)] = 168655,
  [SMALL_STATE(2052)] = 168714,
  [SMALL_STATE(2053)] = 168775,
  [SMALL_STATE(2054)] = 168836,
  [SMALL_STATE(2055)] = 168897,
  [SMALL_STATE(2056)] = 168976,
  [SMALL_STATE(2057)] = 169035,
  [SMALL_STATE(2058)] = 169094,
  [SMALL_STATE(2059)] = 169153,
  [SMALL_STATE(2060)] = 169214,
  [SMALL_STATE(2061)] = 169275,
  [SMALL_STATE(2062)] = 169334,
  [SMALL_STATE(2063)] = 169395,
  [SMALL_STATE(2064)] = 169456,
  [SMALL_STATE(2065)] = 169517,
  [SMALL_STATE(2066)] = 169592,
  [SMALL_STATE(2067)] = 169661,
  [SMALL_STATE(2068)] = 169722,
  [SMALL_STATE(2069)] = 169781,
  [SMALL_STATE(2070)] = 169874,
  [SMALL_STATE(2071)] = 169963,
  [SMALL_STATE(2072)] = 170026,
  [SMALL_STATE(2073)] = 170085,
  [SMALL_STATE(2074)] = 170146,
  [SMALL_STATE(2075)] = 170206,
  [SMALL_STATE(2076)] = 170266,
  [SMALL_STATE(2077)] = 170354,
  [SMALL_STATE(2078)] = 170440,
  [SMALL_STATE(2079)] = 170498,
  [SMALL_STATE(2080)] = 170556,
  [SMALL_STATE(2081)] = 170616,
  [SMALL_STATE(2082)] = 170684,
  [SMALL_STATE(2083)] = 170744,
  [SMALL_STATE(2084)] = 170804,
  [SMALL_STATE(2085)] = 170864,
  [SMALL_STATE(2086)] = 170922,
  [SMALL_STATE(2087)] = 171020,
  [SMALL_STATE(2088)] = 171088,
  [SMALL_STATE(2089)] = 171162,
  [SMALL_STATE(2090)] = 171230,
  [SMALL_STATE(2091)] = 171288,
  [SMALL_STATE(2092)] = 171348,
  [SMALL_STATE(2093)] = 171406,
  [SMALL_STATE(2094)] = 171464,
  [SMALL_STATE(2095)] = 171524,
  [SMALL_STATE(2096)] = 171582,
  [SMALL_STATE(2097)] = 171674,
  [SMALL_STATE(2098)] = 171732,
  [SMALL_STATE(2099)] = 171790,
  [SMALL_STATE(2100)] = 171848,
  [SMALL_STATE(2101)] = 171908,
  [SMALL_STATE(2102)] = 171966,
  [SMALL_STATE(2103)] = 172024,
  [SMALL_STATE(2104)] = 172082,
  [SMALL_STATE(2105)] = 172142,
  [SMALL_STATE(2106)] = 172200,
  [SMALL_STATE(2107)] = 172260,
  [SMALL_STATE(2108)] = 172318,
  [SMALL_STATE(2109)] = 172378,
  [SMALL_STATE(2110)] = 172436,
  [SMALL_STATE(2111)] = 172514,
  [SMALL_STATE(2112)] = 172574,
  [SMALL_STATE(2113)] = 172632,
  [SMALL_STATE(2114)] = 172692,
  [SMALL_STATE(2115)] = 172786,
  [SMALL_STATE(2116)] = 172846,
  [SMALL_STATE(2117)] = 172942,
  [SMALL_STATE(2118)] = 173020,
  [SMALL_STATE(2119)] = 173080,
  [SMALL_STATE(2120)] = 173138,
  [SMALL_STATE(2121)] = 173196,
  [SMALL_STATE(2122)] = 173256,
  [SMALL_STATE(2123)] = 173314,
  [SMALL_STATE(2124)] = 173372,
  [SMALL_STATE(2125)] = 173430,
  [SMALL_STATE(2126)] = 173488,
  [SMALL_STATE(2127)] = 173572,
  [SMALL_STATE(2128)] = 173630,
  [SMALL_STATE(2129)] = 173700,
  [SMALL_STATE(2130)] = 173758,
  [SMALL_STATE(2131)] = 173816,
  [SMALL_STATE(2132)] = 173874,
  [SMALL_STATE(2133)] = 173932,
  [SMALL_STATE(2134)] = 173990,
  [SMALL_STATE(2135)] = 174048,
  [SMALL_STATE(2136)] = 174106,
  [SMALL_STATE(2137)] = 174164,
  [SMALL_STATE(2138)] = 174224,
  [SMALL_STATE(2139)] = 174282,
  [SMALL_STATE(2140)] = 174340,
  [SMALL_STATE(2141)] = 174398,
  [SMALL_STATE(2142)] = 174462,
  [SMALL_STATE(2143)] = 174520,
  [SMALL_STATE(2144)] = 174580,
  [SMALL_STATE(2145)] = 174638,
  [SMALL_STATE(2146)] = 174730,
  [SMALL_STATE(2147)] = 174790,
  [SMALL_STATE(2148)] = 174880,
  [SMALL_STATE(2149)] = 174940,
  [SMALL_STATE(2150)] = 174998,
  [SMALL_STATE(2151)] = 175056,
  [SMALL_STATE(2152)] = 175114,
  [SMALL_STATE(2153)] = 175172,
  [SMALL_STATE(2154)] = 175230,
  [SMALL_STATE(2155)] = 175288,
  [SMALL_STATE(2156)] = 175346,
  [SMALL_STATE(2157)] = 175404,
  [SMALL_STATE(2158)] = 175462,
  [SMALL_STATE(2159)] = 175520,
  [SMALL_STATE(2160)] = 175578,
  [SMALL_STATE(2161)] = 175636,
  [SMALL_STATE(2162)] = 175694,
  [SMALL_STATE(2163)] = 175752,
  [SMALL_STATE(2164)] = 175810,
  [SMALL_STATE(2165)] = 175868,
  [SMALL_STATE(2166)] = 175926,
  [SMALL_STATE(2167)] = 175988,
  [SMALL_STATE(2168)] = 176046,
  [SMALL_STATE(2169)] = 176104,
  [SMALL_STATE(2170)] = 176164,
  [SMALL_STATE(2171)] = 176222,
  [SMALL_STATE(2172)] = 176282,
  [SMALL_STATE(2173)] = 176340,
  [SMALL_STATE(2174)] = 176398,
  [SMALL_STATE(2175)] = 176458,
  [SMALL_STATE(2176)] = 176516,
  [SMALL_STATE(2177)] = 176574,
  [SMALL_STATE(2178)] = 176632,
  [SMALL_STATE(2179)] = 176690,
  [SMALL_STATE(2180)] = 176768,
  [SMALL_STATE(2181)] = 176838,
  [SMALL_STATE(2182)] = 176904,
  [SMALL_STATE(2183)] = 176970,
  [SMALL_STATE(2184)] = 177068,
  [SMALL_STATE(2185)] = 177126,
  [SMALL_STATE(2186)] = 177216,
  [SMALL_STATE(2187)] = 177274,
  [SMALL_STATE(2188)] = 177372,
  [SMALL_STATE(2189)] = 177430,
  [SMALL_STATE(2190)] = 177528,
  [SMALL_STATE(2191)] = 177588,
  [SMALL_STATE(2192)] = 177648,
  [SMALL_STATE(2193)] = 177708,
  [SMALL_STATE(2194)] = 177768,
  [SMALL_STATE(2195)] = 177828,
  [SMALL_STATE(2196)] = 177886,
  [SMALL_STATE(2197)] = 177984,
  [SMALL_STATE(2198)] = 178044,
  [SMALL_STATE(2199)] = 178104,
  [SMALL_STATE(2200)] = 178162,
  [SMALL_STATE(2201)] = 178220,
  [SMALL_STATE(2202)] = 178278,
  [SMALL_STATE(2203)] = 178336,
  [SMALL_STATE(2204)] = 178396,
  [SMALL_STATE(2205)] = 178454,
  [SMALL_STATE(2206)] = 178512,
  [SMALL_STATE(2207)] = 178616,
  [SMALL_STATE(2208)] = 178676,
  [SMALL_STATE(2209)] = 178736,
  [SMALL_STATE(2210)] = 178794,
  [SMALL_STATE(2211)] = 178852,
  [SMALL_STATE(2212)] = 178912,
  [SMALL_STATE(2213)] = 178970,
  [SMALL_STATE(2214)] = 179028,
  [SMALL_STATE(2215)] = 179112,
  [SMALL_STATE(2216)] = 179186,
  [SMALL_STATE(2217)] = 179284,
  [SMALL_STATE(2218)] = 179342,
  [SMALL_STATE(2219)] = 179400,
  [SMALL_STATE(2220)] = 179458,
  [SMALL_STATE(2221)] = 179556,
  [SMALL_STATE(2222)] = 179654,
  [SMALL_STATE(2223)] = 179712,
  [SMALL_STATE(2224)] = 179774,
  [SMALL_STATE(2225)] = 179836,
  [SMALL_STATE(2226)] = 179934,
  [SMALL_STATE(2227)] = 180028,
  [SMALL_STATE(2228)] = 180088,
  [SMALL_STATE(2229)] = 180146,
  [SMALL_STATE(2230)] = 180204,
  [SMALL_STATE(2231)] = 180262,
  [SMALL_STATE(2232)] = 180320,
  [SMALL_STATE(2233)] = 180378,
  [SMALL_STATE(2234)] = 180438,
  [SMALL_STATE(2235)] = 180506,
  [SMALL_STATE(2236)] = 180604,
  [SMALL_STATE(2237)] = 180664,
  [SMALL_STATE(2238)] = 180726,
  [SMALL_STATE(2239)] = 180824,
  [SMALL_STATE(2240)] = 180882,
  [SMALL_STATE(2241)] = 180960,
  [SMALL_STATE(2242)] = 181020,
  [SMALL_STATE(2243)] = 181078,
  [SMALL_STATE(2244)] = 181176,
  [SMALL_STATE(2245)] = 181234,
  [SMALL_STATE(2246)] = 181292,
  [SMALL_STATE(2247)] = 181390,
  [SMALL_STATE(2248)] = 181482,
  [SMALL_STATE(2249)] = 181542,
  [SMALL_STATE(2250)] = 181602,
  [SMALL_STATE(2251)] = 181666,
  [SMALL_STATE(2252)] = 181726,
  [SMALL_STATE(2253)] = 181786,
  [SMALL_STATE(2254)] = 181848,
  [SMALL_STATE(2255)] = 181906,
  [SMALL_STATE(2256)] = 181964,
  [SMALL_STATE(2257)] = 182032,
  [SMALL_STATE(2258)] = 182090,
  [SMALL_STATE(2259)] = 182150,
  [SMALL_STATE(2260)] = 182210,
  [SMALL_STATE(2261)] = 182288,
  [SMALL_STATE(2262)] = 182346,
  [SMALL_STATE(2263)] = 182406,
  [SMALL_STATE(2264)] = 182466,
  [SMALL_STATE(2265)] = 182534,
  [SMALL_STATE(2266)] = 182592,
  [SMALL_STATE(2267)] = 182650,
  [SMALL_STATE(2268)] = 182742,
  [SMALL_STATE(2269)] = 182852,
  [SMALL_STATE(2270)] = 182910,
  [SMALL_STATE(2271)] = 182968,
  [SMALL_STATE(2272)] = 183026,
  [SMALL_STATE(2273)] = 183086,
  [SMALL_STATE(2274)] = 183144,
  [SMALL_STATE(2275)] = 183208,
  [SMALL_STATE(2276)] = 183268,
  [SMALL_STATE(2277)] = 183356,
  [SMALL_STATE(2278)] = 183448,
  [SMALL_STATE(2279)] = 183510,
  [SMALL_STATE(2280)] = 183604,
  [SMALL_STATE(2281)] = 183662,
  [SMALL_STATE(2282)] = 183740,
  [SMALL_STATE(2283)] = 183814,
  [SMALL_STATE(2284)] = 183874,
  [SMALL_STATE(2285)] = 183942,
  [SMALL_STATE(2286)] = 184030,
  [SMALL_STATE(2287)] = 184090,
  [SMALL_STATE(2288)] = 184150,
  [SMALL_STATE(2289)] = 184208,
  [SMALL_STATE(2290)] = 184266,
  [SMALL_STATE(2291)] = 184326,
  [SMALL_STATE(2292)] = 184384,
  [SMALL_STATE(2293)] = 184442,
  [SMALL_STATE(2294)] = 184500,
  [SMALL_STATE(2295)] = 184596,
  [SMALL_STATE(2296)] = 184658,
  [SMALL_STATE(2297)] = 184716,
  [SMALL_STATE(2298)] = 184776,
  [SMALL_STATE(2299)] = 184840,
  [SMALL_STATE(2300)] = 184900,
  [SMALL_STATE(2301)] = 184970,
  [SMALL_STATE(2302)] = 185054,
  [SMALL_STATE(2303)] = 185128,
  [SMALL_STATE(2304)] = 185206,
  [SMALL_STATE(2305)] = 185276,
  [SMALL_STATE(2306)] = 185360,
  [SMALL_STATE(2307)] = 185420,
  [SMALL_STATE(2308)] = 185484,
  [SMALL_STATE(2309)] = 185544,
  [SMALL_STATE(2310)] = 185610,
  [SMALL_STATE(2311)] = 185670,
  [SMALL_STATE(2312)] = 185776,
  [SMALL_STATE(2313)] = 185844,
  [SMALL_STATE(2314)] = 185922,
  [SMALL_STATE(2315)] = 185982,
  [SMALL_STATE(2316)] = 186046,
  [SMALL_STATE(2317)] = 186140,
  [SMALL_STATE(2318)] = 186236,
  [SMALL_STATE(2319)] = 186296,
  [SMALL_STATE(2320)] = 186356,
  [SMALL_STATE(2321)] = 186418,
  [SMALL_STATE(2322)] = 186478,
  [SMALL_STATE(2323)] = 186538,
  [SMALL_STATE(2324)] = 186596,
  [SMALL_STATE(2325)] = 186656,
  [SMALL_STATE(2326)] = 186716,
  [SMALL_STATE(2327)] = 186776,
  [SMALL_STATE(2328)] = 186836,
  [SMALL_STATE(2329)] = 186928,
  [SMALL_STATE(2330)] = 186988,
  [SMALL_STATE(2331)] = 187080,
  [SMALL_STATE(2332)] = 187140,
  [SMALL_STATE(2333)] = 187200,
  [SMALL_STATE(2334)] = 187260,
  [SMALL_STATE(2335)] = 187317,
  [SMALL_STATE(2336)] = 187374,
  [SMALL_STATE(2337)] = 187431,
  [SMALL_STATE(2338)] = 187488,
  [SMALL_STATE(2339)] = 187545,
  [SMALL_STATE(2340)] = 187602,
  [SMALL_STATE(2341)] = 187659,
  [SMALL_STATE(2342)] = 187716,
  [SMALL_STATE(2343)] = 187773,
  [SMALL_STATE(2344)] = 187830,
  [SMALL_STATE(2345)] = 187887,
  [SMALL_STATE(2346)] = 187944,
  [SMALL_STATE(2347)] = 188001,
  [SMALL_STATE(2348)] = 188058,
  [SMALL_STATE(2349)] = 188115,
  [SMALL_STATE(2350)] = 188172,
  [SMALL_STATE(2351)] = 188229,
  [SMALL_STATE(2352)] = 188286,
  [SMALL_STATE(2353)] = 188343,
  [SMALL_STATE(2354)] = 188402,
  [SMALL_STATE(2355)] = 188459,
  [SMALL_STATE(2356)] = 188516,
  [SMALL_STATE(2357)] = 188573,
  [SMALL_STATE(2358)] = 188630,
  [SMALL_STATE(2359)] = 188687,
  [SMALL_STATE(2360)] = 188744,
  [SMALL_STATE(2361)] = 188801,
  [SMALL_STATE(2362)] = 188864,
  [SMALL_STATE(2363)] = 188927,
  [SMALL_STATE(2364)] = 188984,
  [SMALL_STATE(2365)] = 189041,
  [SMALL_STATE(2366)] = 189098,
  [SMALL_STATE(2367)] = 189187,
  [SMALL_STATE(2368)] = 189244,
  [SMALL_STATE(2369)] = 189301,
  [SMALL_STATE(2370)] = 189358,
  [SMALL_STATE(2371)] = 189415,
  [SMALL_STATE(2372)] = 189472,
  [SMALL_STATE(2373)] = 189529,
  [SMALL_STATE(2374)] = 189586,
  [SMALL_STATE(2375)] = 189643,
  [SMALL_STATE(2376)] = 189700,
  [SMALL_STATE(2377)] = 189757,
  [SMALL_STATE(2378)] = 189846,
  [SMALL_STATE(2379)] = 189903,
  [SMALL_STATE(2380)] = 189960,
  [SMALL_STATE(2381)] = 190017,
  [SMALL_STATE(2382)] = 190074,
  [SMALL_STATE(2383)] = 190131,
  [SMALL_STATE(2384)] = 190188,
  [SMALL_STATE(2385)] = 190245,
  [SMALL_STATE(2386)] = 190302,
  [SMALL_STATE(2387)] = 190359,
  [SMALL_STATE(2388)] = 190416,
  [SMALL_STATE(2389)] = 190473,
  [SMALL_STATE(2390)] = 190530,
  [SMALL_STATE(2391)] = 190587,
  [SMALL_STATE(2392)] = 190644,
  [SMALL_STATE(2393)] = 190701,
  [SMALL_STATE(2394)] = 190758,
  [SMALL_STATE(2395)] = 190815,
  [SMALL_STATE(2396)] = 190872,
  [SMALL_STATE(2397)] = 190929,
  [SMALL_STATE(2398)] = 190986,
  [SMALL_STATE(2399)] = 191043,
  [SMALL_STATE(2400)] = 191100,
  [SMALL_STATE(2401)] = 191157,
  [SMALL_STATE(2402)] = 191214,
  [SMALL_STATE(2403)] = 191271,
  [SMALL_STATE(2404)] = 191328,
  [SMALL_STATE(2405)] = 191385,
  [SMALL_STATE(2406)] = 191442,
  [SMALL_STATE(2407)] = 191499,
  [SMALL_STATE(2408)] = 191556,
  [SMALL_STATE(2409)] = 191613,
  [SMALL_STATE(2410)] = 191670,
  [SMALL_STATE(2411)] = 191773,
  [SMALL_STATE(2412)] = 191830,
  [SMALL_STATE(2413)] = 191887,
  [SMALL_STATE(2414)] = 191944,
  [SMALL_STATE(2415)] = 192001,
  [SMALL_STATE(2416)] = 192058,
  [SMALL_STATE(2417)] = 192115,
  [SMALL_STATE(2418)] = 192172,
  [SMALL_STATE(2419)] = 192229,
  [SMALL_STATE(2420)] = 192286,
  [SMALL_STATE(2421)] = 192343,
  [SMALL_STATE(2422)] = 192400,
  [SMALL_STATE(2423)] = 192485,
  [SMALL_STATE(2424)] = 192542,
  [SMALL_STATE(2425)] = 192599,
  [SMALL_STATE(2426)] = 192666,
  [SMALL_STATE(2427)] = 192739,
  [SMALL_STATE(2428)] = 192796,
  [SMALL_STATE(2429)] = 192853,
  [SMALL_STATE(2430)] = 192930,
  [SMALL_STATE(2431)] = 192987,
  [SMALL_STATE(2432)] = 193044,
  [SMALL_STATE(2433)] = 193101,
  [SMALL_STATE(2434)] = 193158,
  [SMALL_STATE(2435)] = 193215,
  [SMALL_STATE(2436)] = 193272,
  [SMALL_STATE(2437)] = 193329,
  [SMALL_STATE(2438)] = 193386,
  [SMALL_STATE(2439)] = 193443,
  [SMALL_STATE(2440)] = 193500,
  [SMALL_STATE(2441)] = 193557,
  [SMALL_STATE(2442)] = 193614,
  [SMALL_STATE(2443)] = 193679,
  [SMALL_STATE(2444)] = 193744,
  [SMALL_STATE(2445)] = 193801,
  [SMALL_STATE(2446)] = 193858,
  [SMALL_STATE(2447)] = 193915,
  [SMALL_STATE(2448)] = 193972,
  [SMALL_STATE(2449)] = 194029,
  [SMALL_STATE(2450)] = 194086,
  [SMALL_STATE(2451)] = 194143,
  [SMALL_STATE(2452)] = 194200,
  [SMALL_STATE(2453)] = 194257,
  [SMALL_STATE(2454)] = 194314,
  [SMALL_STATE(2455)] = 194371,
  [SMALL_STATE(2456)] = 194428,
  [SMALL_STATE(2457)] = 194485,
  [SMALL_STATE(2458)] = 194554,
  [SMALL_STATE(2459)] = 194637,
  [SMALL_STATE(2460)] = 194730,
  [SMALL_STATE(2461)] = 194821,
  [SMALL_STATE(2462)] = 194878,
  [SMALL_STATE(2463)] = 194935,
  [SMALL_STATE(2464)] = 194992,
  [SMALL_STATE(2465)] = 195049,
  [SMALL_STATE(2466)] = 195106,
  [SMALL_STATE(2467)] = 195163,
  [SMALL_STATE(2468)] = 195220,
  [SMALL_STATE(2469)] = 195277,
  [SMALL_STATE(2470)] = 195334,
  [SMALL_STATE(2471)] = 195391,
  [SMALL_STATE(2472)] = 195448,
  [SMALL_STATE(2473)] = 195505,
  [SMALL_STATE(2474)] = 195562,
  [SMALL_STATE(2475)] = 195671,
  [SMALL_STATE(2476)] = 195728,
  [SMALL_STATE(2477)] = 195785,
  [SMALL_STATE(2478)] = 195842,
  [SMALL_STATE(2479)] = 195899,
  [SMALL_STATE(2480)] = 195956,
  [SMALL_STATE(2481)] = 196013,
  [SMALL_STATE(2482)] = 196070,
  [SMALL_STATE(2483)] = 196127,
  [SMALL_STATE(2484)] = 196184,
  [SMALL_STATE(2485)] = 196241,
  [SMALL_STATE(2486)] = 196298,
  [SMALL_STATE(2487)] = 196355,
  [SMALL_STATE(2488)] = 196412,
  [SMALL_STATE(2489)] = 196469,
  [SMALL_STATE(2490)] = 196526,
  [SMALL_STATE(2491)] = 196591,
  [SMALL_STATE(2492)] = 196648,
  [SMALL_STATE(2493)] = 196705,
  [SMALL_STATE(2494)] = 196762,
  [SMALL_STATE(2495)] = 196819,
  [SMALL_STATE(2496)] = 196924,
  [SMALL_STATE(2497)] = 196981,
  [SMALL_STATE(2498)] = 197038,
  [SMALL_STATE(2499)] = 197095,
  [SMALL_STATE(2500)] = 197152,
  [SMALL_STATE(2501)] = 197209,
  [SMALL_STATE(2502)] = 197266,
  [SMALL_STATE(2503)] = 197323,
  [SMALL_STATE(2504)] = 197380,
  [SMALL_STATE(2505)] = 197437,
  [SMALL_STATE(2506)] = 197494,
  [SMALL_STATE(2507)] = 197551,
  [SMALL_STATE(2508)] = 197608,
  [SMALL_STATE(2509)] = 197665,
  [SMALL_STATE(2510)] = 197722,
  [SMALL_STATE(2511)] = 197779,
  [SMALL_STATE(2512)] = 197836,
  [SMALL_STATE(2513)] = 197893,
  [SMALL_STATE(2514)] = 197950,
  [SMALL_STATE(2515)] = 198007,
  [SMALL_STATE(2516)] = 198064,
  [SMALL_STATE(2517)] = 198121,
  [SMALL_STATE(2518)] = 198178,
  [SMALL_STATE(2519)] = 198235,
  [SMALL_STATE(2520)] = 198294,
  [SMALL_STATE(2521)] = 198357,
  [SMALL_STATE(2522)] = 198414,
  [SMALL_STATE(2523)] = 198471,
  [SMALL_STATE(2524)] = 198528,
  [SMALL_STATE(2525)] = 198585,
  [SMALL_STATE(2526)] = 198642,
  [SMALL_STATE(2527)] = 198699,
  [SMALL_STATE(2528)] = 198756,
  [SMALL_STATE(2529)] = 198813,
  [SMALL_STATE(2530)] = 198876,
  [SMALL_STATE(2531)] = 198939,
  [SMALL_STATE(2532)] = 199002,
  [SMALL_STATE(2533)] = 199059,
  [SMALL_STATE(2534)] = 199116,
  [SMALL_STATE(2535)] = 199173,
  [SMALL_STATE(2536)] = 199230,
  [SMALL_STATE(2537)] = 199287,
  [SMALL_STATE(2538)] = 199344,
  [SMALL_STATE(2539)] = 199447,
  [SMALL_STATE(2540)] = 199504,
  [SMALL_STATE(2541)] = 199567,
  [SMALL_STATE(2542)] = 199630,
  [SMALL_STATE(2543)] = 199687,
  [SMALL_STATE(2544)] = 199750,
  [SMALL_STATE(2545)] = 199807,
  [SMALL_STATE(2546)] = 199864,
  [SMALL_STATE(2547)] = 199921,
  [SMALL_STATE(2548)] = 199984,
  [SMALL_STATE(2549)] = 200041,
  [SMALL_STATE(2550)] = 200098,
  [SMALL_STATE(2551)] = 200155,
  [SMALL_STATE(2552)] = 200212,
  [SMALL_STATE(2553)] = 200275,
  [SMALL_STATE(2554)] = 200332,
  [SMALL_STATE(2555)] = 200395,
  [SMALL_STATE(2556)] = 200452,
  [SMALL_STATE(2557)] = 200509,
  [SMALL_STATE(2558)] = 200566,
  [SMALL_STATE(2559)] = 200629,
  [SMALL_STATE(2560)] = 200692,
  [SMALL_STATE(2561)] = 200789,
  [SMALL_STATE(2562)] = 200846,
  [SMALL_STATE(2563)] = 200903,
  [SMALL_STATE(2564)] = 200960,
  [SMALL_STATE(2565)] = 201017,
  [SMALL_STATE(2566)] = 201084,
  [SMALL_STATE(2567)] = 201141,
  [SMALL_STATE(2568)] = 201198,
  [SMALL_STATE(2569)] = 201255,
  [SMALL_STATE(2570)] = 201312,
  [SMALL_STATE(2571)] = 201375,
  [SMALL_STATE(2572)] = 201432,
  [SMALL_STATE(2573)] = 201509,
  [SMALL_STATE(2574)] = 201571,
  [SMALL_STATE(2575)] = 201627,
  [SMALL_STATE(2576)] = 201683,
  [SMALL_STATE(2577)] = 201743,
  [SMALL_STATE(2578)] = 201799,
  [SMALL_STATE(2579)] = 201861,
  [SMALL_STATE(2580)] = 201921,
  [SMALL_STATE(2581)] = 201977,
  [SMALL_STATE(2582)] = 202073,
  [SMALL_STATE(2583)] = 202135,
  [SMALL_STATE(2584)] = 202195,
  [SMALL_STATE(2585)] = 202251,
  [SMALL_STATE(2586)] = 202307,
  [SMALL_STATE(2587)] = 202363,
  [SMALL_STATE(2588)] = 202419,
  [SMALL_STATE(2589)] = 202481,
  [SMALL_STATE(2590)] = 202543,
  [SMALL_STATE(2591)] = 202599,
  [SMALL_STATE(2592)] = 202663,
  [SMALL_STATE(2593)] = 202719,
  [SMALL_STATE(2594)] = 202775,
  [SMALL_STATE(2595)] = 202831,
  [SMALL_STATE(2596)] = 202887,
  [SMALL_STATE(2597)] = 202943,
  [SMALL_STATE(2598)] = 202999,
  [SMALL_STATE(2599)] = 203055,
  [SMALL_STATE(2600)] = 203111,
  [SMALL_STATE(2601)] = 203167,
  [SMALL_STATE(2602)] = 203229,
  [SMALL_STATE(2603)] = 203293,
  [SMALL_STATE(2604)] = 203357,
  [SMALL_STATE(2605)] = 203419,
  [SMALL_STATE(2606)] = 203481,
  [SMALL_STATE(2607)] = 203537,
  [SMALL_STATE(2608)] = 203593,
  [SMALL_STATE(2609)] = 203649,
  [SMALL_STATE(2610)] = 203705,
  [SMALL_STATE(2611)] = 203761,
  [SMALL_STATE(2612)] = 203817,
  [SMALL_STATE(2613)] = 203873,
  [SMALL_STATE(2614)] = 203929,
  [SMALL_STATE(2615)] = 203985,
  [SMALL_STATE(2616)] = 204041,
  [SMALL_STATE(2617)] = 204097,
  [SMALL_STATE(2618)] = 204161,
  [SMALL_STATE(2619)] = 204217,
  [SMALL_STATE(2620)] = 204273,
  [SMALL_STATE(2621)] = 204375,
  [SMALL_STATE(2622)] = 204439,
  [SMALL_STATE(2623)] = 204495,
  [SMALL_STATE(2624)] = 204559,
  [SMALL_STATE(2625)] = 204615,
  [SMALL_STATE(2626)] = 204671,
  [SMALL_STATE(2627)] = 204727,
  [SMALL_STATE(2628)] = 204831,
  [SMALL_STATE(2629)] = 204889,
  [SMALL_STATE(2630)] = 204949,
  [SMALL_STATE(2631)] = 205005,
  [SMALL_STATE(2632)] = 205061,
  [SMALL_STATE(2633)] = 205117,
  [SMALL_STATE(2634)] = 205179,
  [SMALL_STATE(2635)] = 205235,
  [SMALL_STATE(2636)] = 205291,
  [SMALL_STATE(2637)] = 205387,
  [SMALL_STATE(2638)] = 205443,
  [SMALL_STATE(2639)] = 205503,
  [SMALL_STATE(2640)] = 205559,
  [SMALL_STATE(2641)] = 205619,
  [SMALL_STATE(2642)] = 205677,
  [SMALL_STATE(2643)] = 205733,
  [SMALL_STATE(2644)] = 205789,
  [SMALL_STATE(2645)] = 205849,
  [SMALL_STATE(2646)] = 205909,
  [SMALL_STATE(2647)] = 205971,
  [SMALL_STATE(2648)] = 206033,
  [SMALL_STATE(2649)] = 206093,
  [SMALL_STATE(2650)] = 206149,
  [SMALL_STATE(2651)] = 206209,
  [SMALL_STATE(2652)] = 206265,
  [SMALL_STATE(2653)] = 206329,
  [SMALL_STATE(2654)] = 206385,
  [SMALL_STATE(2655)] = 206441,
  [SMALL_STATE(2656)] = 206497,
  [SMALL_STATE(2657)] = 206553,
  [SMALL_STATE(2658)] = 206609,
  [SMALL_STATE(2659)] = 206669,
  [SMALL_STATE(2660)] = 206725,
  [SMALL_STATE(2661)] = 206781,
  [SMALL_STATE(2662)] = 206841,
  [SMALL_STATE(2663)] = 206897,
  [SMALL_STATE(2664)] = 206953,
  [SMALL_STATE(2665)] = 207009,
  [SMALL_STATE(2666)] = 207073,
  [SMALL_STATE(2667)] = 207129,
  [SMALL_STATE(2668)] = 207185,
  [SMALL_STATE(2669)] = 207241,
  [SMALL_STATE(2670)] = 207297,
  [SMALL_STATE(2671)] = 207353,
  [SMALL_STATE(2672)] = 207409,
  [SMALL_STATE(2673)] = 207465,
  [SMALL_STATE(2674)] = 207521,
  [SMALL_STATE(2675)] = 207577,
  [SMALL_STATE(2676)] = 207637,
  [SMALL_STATE(2677)] = 207693,
  [SMALL_STATE(2678)] = 207753,
  [SMALL_STATE(2679)] = 207809,
  [SMALL_STATE(2680)] = 207865,
  [SMALL_STATE(2681)] = 207921,
  [SMALL_STATE(2682)] = 207977,
  [SMALL_STATE(2683)] = 208037,
  [SMALL_STATE(2684)] = 208093,
  [SMALL_STATE(2685)] = 208153,
  [SMALL_STATE(2686)] = 208209,
  [SMALL_STATE(2687)] = 208265,
  [SMALL_STATE(2688)] = 208321,
  [SMALL_STATE(2689)] = 208381,
  [SMALL_STATE(2690)] = 208437,
  [SMALL_STATE(2691)] = 208493,
  [SMALL_STATE(2692)] = 208549,
  [SMALL_STATE(2693)] = 208605,
  [SMALL_STATE(2694)] = 208661,
  [SMALL_STATE(2695)] = 208717,
  [SMALL_STATE(2696)] = 208773,
  [SMALL_STATE(2697)] = 208829,
  [SMALL_STATE(2698)] = 208893,
  [SMALL_STATE(2699)] = 208949,
  [SMALL_STATE(2700)] = 209005,
  [SMALL_STATE(2701)] = 209061,
  [SMALL_STATE(2702)] = 209117,
  [SMALL_STATE(2703)] = 209173,
  [SMALL_STATE(2704)] = 209229,
  [SMALL_STATE(2705)] = 209285,
  [SMALL_STATE(2706)] = 209341,
  [SMALL_STATE(2707)] = 209400,
  [SMALL_STATE(2708)] = 209455,
  [SMALL_STATE(2709)] = 209516,
  [SMALL_STATE(2710)] = 209577,
  [SMALL_STATE(2711)] = 209640,
  [SMALL_STATE(2712)] = 209703,
  [SMALL_STATE(2713)] = 209758,
  [SMALL_STATE(2714)] = 209819,
  [SMALL_STATE(2715)] = 209878,
  [SMALL_STATE(2716)] = 209935,
  [SMALL_STATE(2717)] = 209996,
  [SMALL_STATE(2718)] = 210055,
  [SMALL_STATE(2719)] = 210116,
  [SMALL_STATE(2720)] = 210177,
  [SMALL_STATE(2721)] = 210236,
  [SMALL_STATE(2722)] = 210297,
  [SMALL_STATE(2723)] = 210352,
  [SMALL_STATE(2724)] = 210407,
  [SMALL_STATE(2725)] = 210462,
  [SMALL_STATE(2726)] = 210521,
  [SMALL_STATE(2727)] = 210582,
  [SMALL_STATE(2728)] = 210637,
  [SMALL_STATE(2729)] = 210700,
  [SMALL_STATE(2730)] = 210755,
  [SMALL_STATE(2731)] = 210810,
  [SMALL_STATE(2732)] = 210867,
  [SMALL_STATE(2733)] = 210924,
  [SMALL_STATE(2734)] = 210987,
  [SMALL_STATE(2735)] = 211042,
  [SMALL_STATE(2736)] = 211103,
  [SMALL_STATE(2737)] = 211160,
  [SMALL_STATE(2738)] = 211217,
  [SMALL_STATE(2739)] = 211274,
  [SMALL_STATE(2740)] = 211331,
  [SMALL_STATE(2741)] = 211390,
  [SMALL_STATE(2742)] = 211465,
  [SMALL_STATE(2743)] = 211530,
  [SMALL_STATE(2744)] = 211593,
  [SMALL_STATE(2745)] = 211656,
  [SMALL_STATE(2746)] = 211713,
  [SMALL_STATE(2747)] = 211768,
  [SMALL_STATE(2748)] = 211825,
  [SMALL_STATE(2749)] = 211880,
  [SMALL_STATE(2750)] = 211937,
  [SMALL_STATE(2751)] = 211994,
  [SMALL_STATE(2752)] = 212051,
  [SMALL_STATE(2753)] = 212108,
  [SMALL_STATE(2754)] = 212165,
  [SMALL_STATE(2755)] = 212222,
  [SMALL_STATE(2756)] = 212285,
  [SMALL_STATE(2757)] = 212342,
  [SMALL_STATE(2758)] = 212397,
  [SMALL_STATE(2759)] = 212456,
  [SMALL_STATE(2760)] = 212513,
  [SMALL_STATE(2761)] = 212570,
  [SMALL_STATE(2762)] = 212665,
  [SMALL_STATE(2763)] = 212722,
  [SMALL_STATE(2764)] = 212781,
  [SMALL_STATE(2765)] = 212844,
  [SMALL_STATE(2766)] = 212907,
  [SMALL_STATE(2767)] = 213002,
  [SMALL_STATE(2768)] = 213065,
  [SMALL_STATE(2769)] = 213128,
  [SMALL_STATE(2770)] = 213185,
  [SMALL_STATE(2771)] = 213246,
  [SMALL_STATE(2772)] = 213307,
  [SMALL_STATE(2773)] = 213402,
  [SMALL_STATE(2774)] = 213459,
  [SMALL_STATE(2775)] = 213514,
  [SMALL_STATE(2776)] = 213577,
  [SMALL_STATE(2777)] = 213640,
  [SMALL_STATE(2778)] = 213729,
  [SMALL_STATE(2779)] = 213784,
  [SMALL_STATE(2780)] = 213885,
  [SMALL_STATE(2781)] = 213974,
  [SMALL_STATE(2782)] = 214033,
  [SMALL_STATE(2783)] = 214092,
  [SMALL_STATE(2784)] = 214151,
  [SMALL_STATE(2785)] = 214236,
  [SMALL_STATE(2786)] = 214301,
  [SMALL_STATE(2787)] = 214372,
  [SMALL_STATE(2788)] = 214431,
  [SMALL_STATE(2789)] = 214490,
  [SMALL_STATE(2790)] = 214549,
  [SMALL_STATE(2791)] = 214606,
  [SMALL_STATE(2792)] = 214665,
  [SMALL_STATE(2793)] = 214724,
  [SMALL_STATE(2794)] = 214783,
  [SMALL_STATE(2795)] = 214840,
  [SMALL_STATE(2796)] = 214897,
  [SMALL_STATE(2797)] = 214954,
  [SMALL_STATE(2798)] = 215013,
  [SMALL_STATE(2799)] = 215088,
  [SMALL_STATE(2800)] = 215147,
  [SMALL_STATE(2801)] = 215206,
  [SMALL_STATE(2802)] = 215265,
  [SMALL_STATE(2803)] = 215324,
  [SMALL_STATE(2804)] = 215383,
  [SMALL_STATE(2805)] = 215442,
  [SMALL_STATE(2806)] = 215501,
  [SMALL_STATE(2807)] = 215568,
  [SMALL_STATE(2808)] = 215627,
  [SMALL_STATE(2809)] = 215708,
  [SMALL_STATE(2810)] = 215769,
  [SMALL_STATE(2811)] = 215862,
  [SMALL_STATE(2812)] = 215953,
  [SMALL_STATE(2813)] = 216048,
  [SMALL_STATE(2814)] = 216109,
  [SMALL_STATE(2815)] = 216170,
  [SMALL_STATE(2816)] = 216227,
  [SMALL_STATE(2817)] = 216284,
  [SMALL_STATE(2818)] = 216343,
  [SMALL_STATE(2819)] = 216404,
  [SMALL_STATE(2820)] = 216465,
  [SMALL_STATE(2821)] = 216524,
  [SMALL_STATE(2822)] = 216585,
  [SMALL_STATE(2823)] = 216644,
  [SMALL_STATE(2824)] = 216703,
  [SMALL_STATE(2825)] = 216764,
  [SMALL_STATE(2826)] = 216825,
  [SMALL_STATE(2827)] = 216884,
  [SMALL_STATE(2828)] = 216947,
  [SMALL_STATE(2829)] = 217010,
  [SMALL_STATE(2830)] = 217067,
  [SMALL_STATE(2831)] = 217126,
  [SMALL_STATE(2832)] = 217183,
  [SMALL_STATE(2833)] = 217244,
  [SMALL_STATE(2834)] = 217301,
  [SMALL_STATE(2835)] = 217356,
  [SMALL_STATE(2836)] = 217415,
  [SMALL_STATE(2837)] = 217472,
  [SMALL_STATE(2838)] = 217527,
  [SMALL_STATE(2839)] = 217590,
  [SMALL_STATE(2840)] = 217647,
  [SMALL_STATE(2841)] = 217704,
  [SMALL_STATE(2842)] = 217761,
  [SMALL_STATE(2843)] = 217818,
  [SMALL_STATE(2844)] = 217875,
  [SMALL_STATE(2845)] = 217932,
  [SMALL_STATE(2846)] = 217989,
  [SMALL_STATE(2847)] = 218044,
  [SMALL_STATE(2848)] = 218105,
  [SMALL_STATE(2849)] = 218160,
  [SMALL_STATE(2850)] = 218215,
  [SMALL_STATE(2851)] = 218269,
  [SMALL_STATE(2852)] = 218323,
  [SMALL_STATE(2853)] = 218383,
  [SMALL_STATE(2854)] = 218443,
  [SMALL_STATE(2855)] = 218501,
  [SMALL_STATE(2856)] = 218559,
  [SMALL_STATE(2857)] = 218619,
  [SMALL_STATE(2858)] = 218679,
  [SMALL_STATE(2859)] = 218733,
  [SMALL_STATE(2860)] = 218787,
  [SMALL_STATE(2861)] = 218841,
  [SMALL_STATE(2862)] = 218895,
  [SMALL_STATE(2863)] = 218953,
  [SMALL_STATE(2864)] = 219007,
  [SMALL_STATE(2865)] = 219067,
  [SMALL_STATE(2866)] = 219125,
  [SMALL_STATE(2867)] = 219179,
  [SMALL_STATE(2868)] = 219273,
  [SMALL_STATE(2869)] = 219333,
  [SMALL_STATE(2870)] = 219389,
  [SMALL_STATE(2871)] = 219443,
  [SMALL_STATE(2872)] = 219503,
  [SMALL_STATE(2873)] = 219561,
  [SMALL_STATE(2874)] = 219615,
  [SMALL_STATE(2875)] = 219669,
  [SMALL_STATE(2876)] = 219727,
  [SMALL_STATE(2877)] = 219785,
  [SMALL_STATE(2878)] = 219843,
  [SMALL_STATE(2879)] = 219901,
  [SMALL_STATE(2880)] = 219959,
  [SMALL_STATE(2881)] = 220015,
  [SMALL_STATE(2882)] = 220071,
  [SMALL_STATE(2883)] = 220133,
  [SMALL_STATE(2884)] = 220187,
  [SMALL_STATE(2885)] = 220241,
  [SMALL_STATE(2886)] = 220295,
  [SMALL_STATE(2887)] = 220351,
  [SMALL_STATE(2888)] = 220405,
  [SMALL_STATE(2889)] = 220459,
  [SMALL_STATE(2890)] = 220513,
  [SMALL_STATE(2891)] = 220571,
  [SMALL_STATE(2892)] = 220629,
  [SMALL_STATE(2893)] = 220687,
  [SMALL_STATE(2894)] = 220745,
  [SMALL_STATE(2895)] = 220803,
  [SMALL_STATE(2896)] = 220857,
  [SMALL_STATE(2897)] = 220915,
  [SMALL_STATE(2898)] = 220969,
  [SMALL_STATE(2899)] = 221023,
  [SMALL_STATE(2900)] = 221081,
  [SMALL_STATE(2901)] = 221135,
  [SMALL_STATE(2902)] = 221193,
  [SMALL_STATE(2903)] = 221253,
  [SMALL_STATE(2904)] = 221311,
  [SMALL_STATE(2905)] = 221365,
  [SMALL_STATE(2906)] = 221425,
  [SMALL_STATE(2907)] = 221479,
  [SMALL_STATE(2908)] = 221537,
  [SMALL_STATE(2909)] = 221595,
  [SMALL_STATE(2910)] = 221653,
  [SMALL_STATE(2911)] = 221711,
  [SMALL_STATE(2912)] = 221771,
  [SMALL_STATE(2913)] = 221829,
  [SMALL_STATE(2914)] = 221883,
  [SMALL_STATE(2915)] = 221945,
  [SMALL_STATE(2916)] = 222001,
  [SMALL_STATE(2917)] = 222057,
  [SMALL_STATE(2918)] = 222113,
  [SMALL_STATE(2919)] = 222169,
  [SMALL_STATE(2920)] = 222225,
  [SMALL_STATE(2921)] = 222279,
  [SMALL_STATE(2922)] = 222333,
  [SMALL_STATE(2923)] = 222387,
  [SMALL_STATE(2924)] = 222449,
  [SMALL_STATE(2925)] = 222505,
  [SMALL_STATE(2926)] = 222559,
  [SMALL_STATE(2927)] = 222613,
  [SMALL_STATE(2928)] = 222669,
  [SMALL_STATE(2929)] = 222729,
  [SMALL_STATE(2930)] = 222783,
  [SMALL_STATE(2931)] = 222839,
  [SMALL_STATE(2932)] = 222895,
  [SMALL_STATE(2933)] = 222953,
  [SMALL_STATE(2934)] = 223009,
  [SMALL_STATE(2935)] = 223063,
  [SMALL_STATE(2936)] = 223157,
  [SMALL_STATE(2937)] = 223215,
  [SMALL_STATE(2938)] = 223273,
  [SMALL_STATE(2939)] = 223331,
  [SMALL_STATE(2940)] = 223385,
  [SMALL_STATE(2941)] = 223439,
  [SMALL_STATE(2942)] = 223497,
  [SMALL_STATE(2943)] = 223553,
  [SMALL_STATE(2944)] = 223607,
  [SMALL_STATE(2945)] = 223663,
  [SMALL_STATE(2946)] = 223719,
  [SMALL_STATE(2947)] = 223773,
  [SMALL_STATE(2948)] = 223827,
  [SMALL_STATE(2949)] = 223881,
  [SMALL_STATE(2950)] = 223943,
  [SMALL_STATE(2951)] = 223997,
  [SMALL_STATE(2952)] = 224055,
  [SMALL_STATE(2953)] = 224109,
  [SMALL_STATE(2954)] = 224163,
  [SMALL_STATE(2955)] = 224225,
  [SMALL_STATE(2956)] = 224279,
  [SMALL_STATE(2957)] = 224333,
  [SMALL_STATE(2958)] = 224387,
  [SMALL_STATE(2959)] = 224449,
  [SMALL_STATE(2960)] = 224505,
  [SMALL_STATE(2961)] = 224563,
  [SMALL_STATE(2962)] = 224617,
  [SMALL_STATE(2963)] = 224675,
  [SMALL_STATE(2964)] = 224733,
  [SMALL_STATE(2965)] = 224791,
  [SMALL_STATE(2966)] = 224849,
  [SMALL_STATE(2967)] = 224907,
  [SMALL_STATE(2968)] = 224963,
  [SMALL_STATE(2969)] = 225017,
  [SMALL_STATE(2970)] = 225073,
  [SMALL_STATE(2971)] = 225131,
  [SMALL_STATE(2972)] = 225185,
  [SMALL_STATE(2973)] = 225239,
  [SMALL_STATE(2974)] = 225297,
  [SMALL_STATE(2975)] = 225357,
  [SMALL_STATE(2976)] = 225417,
  [SMALL_STATE(2977)] = 225473,
  [SMALL_STATE(2978)] = 225529,
  [SMALL_STATE(2979)] = 225585,
  [SMALL_STATE(2980)] = 225643,
  [SMALL_STATE(2981)] = 225697,
  [SMALL_STATE(2982)] = 225751,
  [SMALL_STATE(2983)] = 225805,
  [SMALL_STATE(2984)] = 225863,
  [SMALL_STATE(2985)] = 225917,
  [SMALL_STATE(2986)] = 225975,
  [SMALL_STATE(2987)] = 226029,
  [SMALL_STATE(2988)] = 226083,
  [SMALL_STATE(2989)] = 226143,
  [SMALL_STATE(2990)] = 226199,
  [SMALL_STATE(2991)] = 226259,
  [SMALL_STATE(2992)] = 226319,
  [SMALL_STATE(2993)] = 226379,
  [SMALL_STATE(2994)] = 226439,
  [SMALL_STATE(2995)] = 226499,
  [SMALL_STATE(2996)] = 226559,
  [SMALL_STATE(2997)] = 226613,
  [SMALL_STATE(2998)] = 226671,
  [SMALL_STATE(2999)] = 226727,
  [SMALL_STATE(3000)] = 226785,
  [SMALL_STATE(3001)] = 226839,
  [SMALL_STATE(3002)] = 226899,
  [SMALL_STATE(3003)] = 227001,
  [SMALL_STATE(3004)] = 227055,
  [SMALL_STATE(3005)] = 227113,
  [SMALL_STATE(3006)] = 227167,
  [SMALL_STATE(3007)] = 227221,
  [SMALL_STATE(3008)] = 227275,
  [SMALL_STATE(3009)] = 227337,
  [SMALL_STATE(3010)] = 227395,
  [SMALL_STATE(3011)] = 227449,
  [SMALL_STATE(3012)] = 227503,
  [SMALL_STATE(3013)] = 227557,
  [SMALL_STATE(3014)] = 227611,
  [SMALL_STATE(3015)] = 227665,
  [SMALL_STATE(3016)] = 227719,
  [SMALL_STATE(3017)] = 227775,
  [SMALL_STATE(3018)] = 227829,
  [SMALL_STATE(3019)] = 227885,
  [SMALL_STATE(3020)] = 227939,
  [SMALL_STATE(3021)] = 227993,
  [SMALL_STATE(3022)] = 228047,
  [SMALL_STATE(3023)] = 228103,
  [SMALL_STATE(3024)] = 228159,
  [SMALL_STATE(3025)] = 228217,
  [SMALL_STATE(3026)] = 228271,
  [SMALL_STATE(3027)] = 228331,
  [SMALL_STATE(3028)] = 228385,
  [SMALL_STATE(3029)] = 228439,
  [SMALL_STATE(3030)] = 228493,
  [SMALL_STATE(3031)] = 228551,
  [SMALL_STATE(3032)] = 228609,
  [SMALL_STATE(3033)] = 228665,
  [SMALL_STATE(3034)] = 228727,
  [SMALL_STATE(3035)] = 228789,
  [SMALL_STATE(3036)] = 228851,
  [SMALL_STATE(3037)] = 228911,
  [SMALL_STATE(3038)] = 228971,
  [SMALL_STATE(3039)] = 229031,
  [SMALL_STATE(3040)] = 229091,
  [SMALL_STATE(3041)] = 229151,
  [SMALL_STATE(3042)] = 229211,
  [SMALL_STATE(3043)] = 229269,
  [SMALL_STATE(3044)] = 229327,
  [SMALL_STATE(3045)] = 229385,
  [SMALL_STATE(3046)] = 229447,
  [SMALL_STATE(3047)] = 229509,
  [SMALL_STATE(3048)] = 229571,
  [SMALL_STATE(3049)] = 229627,
  [SMALL_STATE(3050)] = 229687,
  [SMALL_STATE(3051)] = 229741,
  [SMALL_STATE(3052)] = 229799,
  [SMALL_STATE(3053)] = 229861,
  [SMALL_STATE(3054)] = 229915,
  [SMALL_STATE(3055)] = 229969,
  [SMALL_STATE(3056)] = 230023,
  [SMALL_STATE(3057)] = 230077,
  [SMALL_STATE(3058)] = 230131,
  [SMALL_STATE(3059)] = 230187,
  [SMALL_STATE(3060)] = 230241,
  [SMALL_STATE(3061)] = 230303,
  [SMALL_STATE(3062)] = 230357,
  [SMALL_STATE(3063)] = 230411,
  [SMALL_STATE(3064)] = 230469,
  [SMALL_STATE(3065)] = 230523,
  [SMALL_STATE(3066)] = 230577,
  [SMALL_STATE(3067)] = 230635,
  [SMALL_STATE(3068)] = 230693,
  [SMALL_STATE(3069)] = 230751,
  [SMALL_STATE(3070)] = 230809,
  [SMALL_STATE(3071)] = 230863,
  [SMALL_STATE(3072)] = 230917,
  [SMALL_STATE(3073)] = 230979,
  [SMALL_STATE(3074)] = 231035,
  [SMALL_STATE(3075)] = 231093,
  [SMALL_STATE(3076)] = 231147,
  [SMALL_STATE(3077)] = 231201,
  [SMALL_STATE(3078)] = 231255,
  [SMALL_STATE(3079)] = 231311,
  [SMALL_STATE(3080)] = 231367,
  [SMALL_STATE(3081)] = 231421,
  [SMALL_STATE(3082)] = 231475,
  [SMALL_STATE(3083)] = 231531,
  [SMALL_STATE(3084)] = 231589,
  [SMALL_STATE(3085)] = 231651,
  [SMALL_STATE(3086)] = 231709,
  [SMALL_STATE(3087)] = 231767,
  [SMALL_STATE(3088)] = 231825,
  [SMALL_STATE(3089)] = 231919,
  [SMALL_STATE(3090)] = 231975,
  [SMALL_STATE(3091)] = 232031,
  [SMALL_STATE(3092)] = 232085,
  [SMALL_STATE(3093)] = 232143,
  [SMALL_STATE(3094)] = 232201,
  [SMALL_STATE(3095)] = 232259,
  [SMALL_STATE(3096)] = 232313,
  [SMALL_STATE(3097)] = 232371,
  [SMALL_STATE(3098)] = 232429,
  [SMALL_STATE(3099)] = 232486,
  [SMALL_STATE(3100)] = 232543,
  [SMALL_STATE(3101)] = 232596,
  [SMALL_STATE(3102)] = 232653,
  [SMALL_STATE(3103)] = 232708,
  [SMALL_STATE(3104)] = 232761,
  [SMALL_STATE(3105)] = 232816,
  [SMALL_STATE(3106)] = 232871,
  [SMALL_STATE(3107)] = 232924,
  [SMALL_STATE(3108)] = 232977,
  [SMALL_STATE(3109)] = 233030,
  [SMALL_STATE(3110)] = 233083,
  [SMALL_STATE(3111)] = 233140,
  [SMALL_STATE(3112)] = 233193,
  [SMALL_STATE(3113)] = 233246,
  [SMALL_STATE(3114)] = 233305,
  [SMALL_STATE(3115)] = 233358,
  [SMALL_STATE(3116)] = 233411,
  [SMALL_STATE(3117)] = 233466,
  [SMALL_STATE(3118)] = 233523,
  [SMALL_STATE(3119)] = 233578,
  [SMALL_STATE(3120)] = 233635,
  [SMALL_STATE(3121)] = 233690,
  [SMALL_STATE(3122)] = 233747,
  [SMALL_STATE(3123)] = 233802,
  [SMALL_STATE(3124)] = 233859,
  [SMALL_STATE(3125)] = 233964,
  [SMALL_STATE(3126)] = 234021,
  [SMALL_STATE(3127)] = 234078,
  [SMALL_STATE(3128)] = 234133,
  [SMALL_STATE(3129)] = 234188,
  [SMALL_STATE(3130)] = 234243,
  [SMALL_STATE(3131)] = 234298,
  [SMALL_STATE(3132)] = 234351,
  [SMALL_STATE(3133)] = 234408,
  [SMALL_STATE(3134)] = 234465,
  [SMALL_STATE(3135)] = 234522,
  [SMALL_STATE(3136)] = 234575,
  [SMALL_STATE(3137)] = 234632,
  [SMALL_STATE(3138)] = 234689,
  [SMALL_STATE(3139)] = 234742,
  [SMALL_STATE(3140)] = 234795,
  [SMALL_STATE(3141)] = 234852,
  [SMALL_STATE(3142)] = 234905,
  [SMALL_STATE(3143)] = 234958,
  [SMALL_STATE(3144)] = 235011,
  [SMALL_STATE(3145)] = 235066,
  [SMALL_STATE(3146)] = 235119,
  [SMALL_STATE(3147)] = 235172,
  [SMALL_STATE(3148)] = 235225,
  [SMALL_STATE(3149)] = 235282,
  [SMALL_STATE(3150)] = 235341,
  [SMALL_STATE(3151)] = 235400,
  [SMALL_STATE(3152)] = 235457,
  [SMALL_STATE(3153)] = 235558,
  [SMALL_STATE(3154)] = 235615,
  [SMALL_STATE(3155)] = 235668,
  [SMALL_STATE(3156)] = 235721,
  [SMALL_STATE(3157)] = 235778,
  [SMALL_STATE(3158)] = 235835,
  [SMALL_STATE(3159)] = 235892,
  [SMALL_STATE(3160)] = 235945,
  [SMALL_STATE(3161)] = 236002,
  [SMALL_STATE(3162)] = 236055,
  [SMALL_STATE(3163)] = 236112,
  [SMALL_STATE(3164)] = 236169,
  [SMALL_STATE(3165)] = 236224,
  [SMALL_STATE(3166)] = 236281,
  [SMALL_STATE(3167)] = 236334,
  [SMALL_STATE(3168)] = 236387,
  [SMALL_STATE(3169)] = 236444,
  [SMALL_STATE(3170)] = 236501,
  [SMALL_STATE(3171)] = 236554,
  [SMALL_STATE(3172)] = 236609,
  [SMALL_STATE(3173)] = 236664,
  [SMALL_STATE(3174)] = 236721,
  [SMALL_STATE(3175)] = 236778,
  [SMALL_STATE(3176)] = 236835,
  [SMALL_STATE(3177)] = 236892,
  [SMALL_STATE(3178)] = 236945,
  [SMALL_STATE(3179)] = 236998,
  [SMALL_STATE(3180)] = 237057,
  [SMALL_STATE(3181)] = 237114,
  [SMALL_STATE(3182)] = 237167,
  [SMALL_STATE(3183)] = 237224,
  [SMALL_STATE(3184)] = 237285,
  [SMALL_STATE(3185)] = 237346,
  [SMALL_STATE(3186)] = 237399,
  [SMALL_STATE(3187)] = 237456,
  [SMALL_STATE(3188)] = 237513,
  [SMALL_STATE(3189)] = 237570,
  [SMALL_STATE(3190)] = 237627,
  [SMALL_STATE(3191)] = 237682,
  [SMALL_STATE(3192)] = 237737,
  [SMALL_STATE(3193)] = 237792,
  [SMALL_STATE(3194)] = 237847,
  [SMALL_STATE(3195)] = 237902,
  [SMALL_STATE(3196)] = 237955,
  [SMALL_STATE(3197)] = 238008,
  [SMALL_STATE(3198)] = 238061,
  [SMALL_STATE(3199)] = 238114,
  [SMALL_STATE(3200)] = 238167,
  [SMALL_STATE(3201)] = 238220,
  [SMALL_STATE(3202)] = 238281,
  [SMALL_STATE(3203)] = 238338,
  [SMALL_STATE(3204)] = 238395,
  [SMALL_STATE(3205)] = 238452,
  [SMALL_STATE(3206)] = 238505,
  [SMALL_STATE(3207)] = 238558,
  [SMALL_STATE(3208)] = 238613,
  [SMALL_STATE(3209)] = 238668,
  [SMALL_STATE(3210)] = 238723,
  [SMALL_STATE(3211)] = 238776,
  [SMALL_STATE(3212)] = 238833,
  [SMALL_STATE(3213)] = 238892,
  [SMALL_STATE(3214)] = 238947,
  [SMALL_STATE(3215)] = 239006,
  [SMALL_STATE(3216)] = 239063,
  [SMALL_STATE(3217)] = 239118,
  [SMALL_STATE(3218)] = 239177,
  [SMALL_STATE(3219)] = 239236,
  [SMALL_STATE(3220)] = 239289,
  [SMALL_STATE(3221)] = 239348,
  [SMALL_STATE(3222)] = 239401,
  [SMALL_STATE(3223)] = 239456,
  [SMALL_STATE(3224)] = 239509,
  [SMALL_STATE(3225)] = 239564,
  [SMALL_STATE(3226)] = 239623,
  [SMALL_STATE(3227)] = 239680,
  [SMALL_STATE(3228)] = 239739,
  [SMALL_STATE(3229)] = 239796,
  [SMALL_STATE(3230)] = 239849,
  [SMALL_STATE(3231)] = 239902,
  [SMALL_STATE(3232)] = 239955,
  [SMALL_STATE(3233)] = 240008,
  [SMALL_STATE(3234)] = 240065,
  [SMALL_STATE(3235)] = 240120,
  [SMALL_STATE(3236)] = 240177,
  [SMALL_STATE(3237)] = 240230,
  [SMALL_STATE(3238)] = 240283,
  [SMALL_STATE(3239)] = 240336,
  [SMALL_STATE(3240)] = 240389,
  [SMALL_STATE(3241)] = 240446,
  [SMALL_STATE(3242)] = 240499,
  [SMALL_STATE(3243)] = 240552,
  [SMALL_STATE(3244)] = 240607,
  [SMALL_STATE(3245)] = 240662,
  [SMALL_STATE(3246)] = 240719,
  [SMALL_STATE(3247)] = 240776,
  [SMALL_STATE(3248)] = 240833,
  [SMALL_STATE(3249)] = 240890,
  [SMALL_STATE(3250)] = 240947,
  [SMALL_STATE(3251)] = 241002,
  [SMALL_STATE(3252)] = 241057,
  [SMALL_STATE(3253)] = 241110,
  [SMALL_STATE(3254)] = 241167,
  [SMALL_STATE(3255)] = 241224,
  [SMALL_STATE(3256)] = 241281,
  [SMALL_STATE(3257)] = 241338,
  [SMALL_STATE(3258)] = 241395,
  [SMALL_STATE(3259)] = 241448,
  [SMALL_STATE(3260)] = 241501,
  [SMALL_STATE(3261)] = 241554,
  [SMALL_STATE(3262)] = 241607,
  [SMALL_STATE(3263)] = 241662,
  [SMALL_STATE(3264)] = 241715,
  [SMALL_STATE(3265)] = 241772,
  [SMALL_STATE(3266)] = 241825,
  [SMALL_STATE(3267)] = 241878,
  [SMALL_STATE(3268)] = 241935,
  [SMALL_STATE(3269)] = 241988,
  [SMALL_STATE(3270)] = 242045,
  [SMALL_STATE(3271)] = 242098,
  [SMALL_STATE(3272)] = 242155,
  [SMALL_STATE(3273)] = 242212,
  [SMALL_STATE(3274)] = 242265,
  [SMALL_STATE(3275)] = 242322,
  [SMALL_STATE(3276)] = 242375,
  [SMALL_STATE(3277)] = 242428,
  [SMALL_STATE(3278)] = 242481,
  [SMALL_STATE(3279)] = 242538,
  [SMALL_STATE(3280)] = 242591,
  [SMALL_STATE(3281)] = 242644,
  [SMALL_STATE(3282)] = 242701,
  [SMALL_STATE(3283)] = 242754,
  [SMALL_STATE(3284)] = 242811,
  [SMALL_STATE(3285)] = 242866,
  [SMALL_STATE(3286)] = 242919,
  [SMALL_STATE(3287)] = 242972,
  [SMALL_STATE(3288)] = 243033,
  [SMALL_STATE(3289)] = 243090,
  [SMALL_STATE(3290)] = 243143,
  [SMALL_STATE(3291)] = 243196,
  [SMALL_STATE(3292)] = 243251,
  [SMALL_STATE(3293)] = 243308,
  [SMALL_STATE(3294)] = 243361,
  [SMALL_STATE(3295)] = 243414,
  [SMALL_STATE(3296)] = 243467,
  [SMALL_STATE(3297)] = 243520,
  [SMALL_STATE(3298)] = 243573,
  [SMALL_STATE(3299)] = 243630,
  [SMALL_STATE(3300)] = 243687,
  [SMALL_STATE(3301)] = 243744,
  [SMALL_STATE(3302)] = 243805,
  [SMALL_STATE(3303)] = 243860,
  [SMALL_STATE(3304)] = 243913,
  [SMALL_STATE(3305)] = 243966,
  [SMALL_STATE(3306)] = 244019,
  [SMALL_STATE(3307)] = 244072,
  [SMALL_STATE(3308)] = 244125,
  [SMALL_STATE(3309)] = 244182,
  [SMALL_STATE(3310)] = 244235,
  [SMALL_STATE(3311)] = 244288,
  [SMALL_STATE(3312)] = 244341,
  [SMALL_STATE(3313)] = 244398,
  [SMALL_STATE(3314)] = 244455,
  [SMALL_STATE(3315)] = 244508,
  [SMALL_STATE(3316)] = 244561,
  [SMALL_STATE(3317)] = 244616,
  [SMALL_STATE(3318)] = 244669,
  [SMALL_STATE(3319)] = 244726,
  [SMALL_STATE(3320)] = 244783,
  [SMALL_STATE(3321)] = 244840,
  [SMALL_STATE(3322)] = 244893,
  [SMALL_STATE(3323)] = 244950,
  [SMALL_STATE(3324)] = 245007,
  [SMALL_STATE(3325)] = 245060,
  [SMALL_STATE(3326)] = 245117,
  [SMALL_STATE(3327)] = 245174,
  [SMALL_STATE(3328)] = 245231,
  [SMALL_STATE(3329)] = 245284,
  [SMALL_STATE(3330)] = 245337,
  [SMALL_STATE(3331)] = 245394,
  [SMALL_STATE(3332)] = 245447,
  [SMALL_STATE(3333)] = 245500,
  [SMALL_STATE(3334)] = 245557,
  [SMALL_STATE(3335)] = 245610,
  [SMALL_STATE(3336)] = 245663,
  [SMALL_STATE(3337)] = 245720,
  [SMALL_STATE(3338)] = 245777,
  [SMALL_STATE(3339)] = 245834,
  [SMALL_STATE(3340)] = 245891,
  [SMALL_STATE(3341)] = 245948,
  [SMALL_STATE(3342)] = 246003,
  [SMALL_STATE(3343)] = 246060,
  [SMALL_STATE(3344)] = 246165,
  [SMALL_STATE(3345)] = 246220,
  [SMALL_STATE(3346)] = 246277,
  [SMALL_STATE(3347)] = 246332,
  [SMALL_STATE(3348)] = 246387,
  [SMALL_STATE(3349)] = 246444,
  [SMALL_STATE(3350)] = 246501,
  [SMALL_STATE(3351)] = 246554,
  [SMALL_STATE(3352)] = 246607,
  [SMALL_STATE(3353)] = 246664,
  [SMALL_STATE(3354)] = 246721,
  [SMALL_STATE(3355)] = 246776,
  [SMALL_STATE(3356)] = 246869,
  [SMALL_STATE(3357)] = 246922,
  [SMALL_STATE(3358)] = 246979,
  [SMALL_STATE(3359)] = 247036,
  [SMALL_STATE(3360)] = 247093,
  [SMALL_STATE(3361)] = 247150,
  [SMALL_STATE(3362)] = 247207,
  [SMALL_STATE(3363)] = 247264,
  [SMALL_STATE(3364)] = 247321,
  [SMALL_STATE(3365)] = 247378,
  [SMALL_STATE(3366)] = 247435,
  [SMALL_STATE(3367)] = 247490,
  [SMALL_STATE(3368)] = 247543,
  [SMALL_STATE(3369)] = 247596,
  [SMALL_STATE(3370)] = 247651,
  [SMALL_STATE(3371)] = 247706,
  [SMALL_STATE(3372)] = 247763,
  [SMALL_STATE(3373)] = 247818,
  [SMALL_STATE(3374)] = 247873,
  [SMALL_STATE(3375)] = 247930,
  [SMALL_STATE(3376)] = 247985,
  [SMALL_STATE(3377)] = 248040,
  [SMALL_STATE(3378)] = 248095,
  [SMALL_STATE(3379)] = 248152,
  [SMALL_STATE(3380)] = 248207,
  [SMALL_STATE(3381)] = 248260,
  [SMALL_STATE(3382)] = 248317,
  [SMALL_STATE(3383)] = 248372,
  [SMALL_STATE(3384)] = 248429,
  [SMALL_STATE(3385)] = 248484,
  [SMALL_STATE(3386)] = 248589,
  [SMALL_STATE(3387)] = 248642,
  [SMALL_STATE(3388)] = 248699,
  [SMALL_STATE(3389)] = 248756,
  [SMALL_STATE(3390)] = 248813,
  [SMALL_STATE(3391)] = 248872,
  [SMALL_STATE(3392)] = 248931,
  [SMALL_STATE(3393)] = 248988,
  [SMALL_STATE(3394)] = 249043,
  [SMALL_STATE(3395)] = 249100,
  [SMALL_STATE(3396)] = 249157,
  [SMALL_STATE(3397)] = 249212,
  [SMALL_STATE(3398)] = 249265,
  [SMALL_STATE(3399)] = 249320,
  [SMALL_STATE(3400)] = 249373,
  [SMALL_STATE(3401)] = 249428,
  [SMALL_STATE(3402)] = 249483,
  [SMALL_STATE(3403)] = 249542,
  [SMALL_STATE(3404)] = 249597,
  [SMALL_STATE(3405)] = 249652,
  [SMALL_STATE(3406)] = 249709,
  [SMALL_STATE(3407)] = 249764,
  [SMALL_STATE(3408)] = 249819,
  [SMALL_STATE(3409)] = 249874,
  [SMALL_STATE(3410)] = 249929,
  [SMALL_STATE(3411)] = 249984,
  [SMALL_STATE(3412)] = 250039,
  [SMALL_STATE(3413)] = 250094,
  [SMALL_STATE(3414)] = 250149,
  [SMALL_STATE(3415)] = 250204,
  [SMALL_STATE(3416)] = 250259,
  [SMALL_STATE(3417)] = 250314,
  [SMALL_STATE(3418)] = 250369,
  [SMALL_STATE(3419)] = 250424,
  [SMALL_STATE(3420)] = 250479,
  [SMALL_STATE(3421)] = 250534,
  [SMALL_STATE(3422)] = 250589,
  [SMALL_STATE(3423)] = 250644,
  [SMALL_STATE(3424)] = 250737,
  [SMALL_STATE(3425)] = 250790,
  [SMALL_STATE(3426)] = 250845,
  [SMALL_STATE(3427)] = 250902,
  [SMALL_STATE(3428)] = 250957,
  [SMALL_STATE(3429)] = 251011,
  [SMALL_STATE(3430)] = 251065,
  [SMALL_STATE(3431)] = 251119,
  [SMALL_STATE(3432)] = 251171,
  [SMALL_STATE(3433)] = 251223,
  [SMALL_STATE(3434)] = 251305,
  [SMALL_STATE(3435)] = 251357,
  [SMALL_STATE(3436)] = 251413,
  [SMALL_STATE(3437)] = 251467,
  [SMALL_STATE(3438)] = 251519,
  [SMALL_STATE(3439)] = 251571,
  [SMALL_STATE(3440)] = 251623,
  [SMALL_STATE(3441)] = 251675,
  [SMALL_STATE(3442)] = 251731,
  [SMALL_STATE(3443)] = 251783,
  [SMALL_STATE(3444)] = 251837,
  [SMALL_STATE(3445)] = 251889,
  [SMALL_STATE(3446)] = 251941,
  [SMALL_STATE(3447)] = 251993,
  [SMALL_STATE(3448)] = 252047,
  [SMALL_STATE(3449)] = 252099,
  [SMALL_STATE(3450)] = 252151,
  [SMALL_STATE(3451)] = 252203,
  [SMALL_STATE(3452)] = 252255,
  [SMALL_STATE(3453)] = 252307,
  [SMALL_STATE(3454)] = 252359,
  [SMALL_STATE(3455)] = 252411,
  [SMALL_STATE(3456)] = 252465,
  [SMALL_STATE(3457)] = 252517,
  [SMALL_STATE(3458)] = 252569,
  [SMALL_STATE(3459)] = 252621,
  [SMALL_STATE(3460)] = 252673,
  [SMALL_STATE(3461)] = 252727,
  [SMALL_STATE(3462)] = 252831,
  [SMALL_STATE(3463)] = 252883,
  [SMALL_STATE(3464)] = 252935,
  [SMALL_STATE(3465)] = 252989,
  [SMALL_STATE(3466)] = 253041,
  [SMALL_STATE(3467)] = 253093,
  [SMALL_STATE(3468)] = 253145,
  [SMALL_STATE(3469)] = 253197,
  [SMALL_STATE(3470)] = 253249,
  [SMALL_STATE(3471)] = 253301,
  [SMALL_STATE(3472)] = 253353,
  [SMALL_STATE(3473)] = 253407,
  [SMALL_STATE(3474)] = 253459,
  [SMALL_STATE(3475)] = 253511,
  [SMALL_STATE(3476)] = 253571,
  [SMALL_STATE(3477)] = 253623,
  [SMALL_STATE(3478)] = 253679,
  [SMALL_STATE(3479)] = 253739,
  [SMALL_STATE(3480)] = 253791,
  [SMALL_STATE(3481)] = 253853,
  [SMALL_STATE(3482)] = 253921,
  [SMALL_STATE(3483)] = 253973,
  [SMALL_STATE(3484)] = 254027,
  [SMALL_STATE(3485)] = 254079,
  [SMALL_STATE(3486)] = 254131,
  [SMALL_STATE(3487)] = 254189,
  [SMALL_STATE(3488)] = 254241,
  [SMALL_STATE(3489)] = 254313,
  [SMALL_STATE(3490)] = 254365,
  [SMALL_STATE(3491)] = 254417,
  [SMALL_STATE(3492)] = 254471,
  [SMALL_STATE(3493)] = 254523,
  [SMALL_STATE(3494)] = 254575,
  [SMALL_STATE(3495)] = 254627,
  [SMALL_STATE(3496)] = 254679,
  [SMALL_STATE(3497)] = 254733,
  [SMALL_STATE(3498)] = 254787,
  [SMALL_STATE(3499)] = 254843,
  [SMALL_STATE(3500)] = 254895,
  [SMALL_STATE(3501)] = 254949,
  [SMALL_STATE(3502)] = 255001,
  [SMALL_STATE(3503)] = 255053,
  [SMALL_STATE(3504)] = 255105,
  [SMALL_STATE(3505)] = 255157,
  [SMALL_STATE(3506)] = 255209,
  [SMALL_STATE(3507)] = 255265,
  [SMALL_STATE(3508)] = 255317,
  [SMALL_STATE(3509)] = 255369,
  [SMALL_STATE(3510)] = 255421,
  [SMALL_STATE(3511)] = 255473,
  [SMALL_STATE(3512)] = 255525,
  [SMALL_STATE(3513)] = 255577,
  [SMALL_STATE(3514)] = 255631,
  [SMALL_STATE(3515)] = 255683,
  [SMALL_STATE(3516)] = 255737,
  [SMALL_STATE(3517)] = 255789,
  [SMALL_STATE(3518)] = 255841,
  [SMALL_STATE(3519)] = 255895,
  [SMALL_STATE(3520)] = 255947,
  [SMALL_STATE(3521)] = 256001,
  [SMALL_STATE(3522)] = 256087,
  [SMALL_STATE(3523)] = 256143,
  [SMALL_STATE(3524)] = 256195,
  [SMALL_STATE(3525)] = 256247,
  [SMALL_STATE(3526)] = 256299,
  [SMALL_STATE(3527)] = 256351,
  [SMALL_STATE(3528)] = 256403,
  [SMALL_STATE(3529)] = 256457,
  [SMALL_STATE(3530)] = 256511,
  [SMALL_STATE(3531)] = 256563,
  [SMALL_STATE(3532)] = 256617,
  [SMALL_STATE(3533)] = 256671,
  [SMALL_STATE(3534)] = 256725,
  [SMALL_STATE(3535)] = 256777,
  [SMALL_STATE(3536)] = 256833,
  [SMALL_STATE(3537)] = 256885,
  [SMALL_STATE(3538)] = 256937,
  [SMALL_STATE(3539)] = 256993,
  [SMALL_STATE(3540)] = 257045,
  [SMALL_STATE(3541)] = 257101,
  [SMALL_STATE(3542)] = 257153,
  [SMALL_STATE(3543)] = 257205,
  [SMALL_STATE(3544)] = 257257,
  [SMALL_STATE(3545)] = 257311,
  [SMALL_STATE(3546)] = 257397,
  [SMALL_STATE(3547)] = 257449,
  [SMALL_STATE(3548)] = 257501,
  [SMALL_STATE(3549)] = 257553,
  [SMALL_STATE(3550)] = 257607,
  [SMALL_STATE(3551)] = 257663,
  [SMALL_STATE(3552)] = 257715,
  [SMALL_STATE(3553)] = 257767,
  [SMALL_STATE(3554)] = 257821,
  [SMALL_STATE(3555)] = 257877,
  [SMALL_STATE(3556)] = 257929,
  [SMALL_STATE(3557)] = 257981,
  [SMALL_STATE(3558)] = 258033,
  [SMALL_STATE(3559)] = 258085,
  [SMALL_STATE(3560)] = 258139,
  [SMALL_STATE(3561)] = 258191,
  [SMALL_STATE(3562)] = 258245,
  [SMALL_STATE(3563)] = 258297,
  [SMALL_STATE(3564)] = 258349,
  [SMALL_STATE(3565)] = 258401,
  [SMALL_STATE(3566)] = 258453,
  [SMALL_STATE(3567)] = 258505,
  [SMALL_STATE(3568)] = 258557,
  [SMALL_STATE(3569)] = 258611,
  [SMALL_STATE(3570)] = 258665,
  [SMALL_STATE(3571)] = 258719,
  [SMALL_STATE(3572)] = 258773,
  [SMALL_STATE(3573)] = 258865,
  [SMALL_STATE(3574)] = 258921,
  [SMALL_STATE(3575)] = 258977,
  [SMALL_STATE(3576)] = 259031,
  [SMALL_STATE(3577)] = 259087,
  [SMALL_STATE(3578)] = 259139,
  [SMALL_STATE(3579)] = 259193,
  [SMALL_STATE(3580)] = 259245,
  [SMALL_STATE(3581)] = 259297,
  [SMALL_STATE(3582)] = 259349,
  [SMALL_STATE(3583)] = 259403,
  [SMALL_STATE(3584)] = 259467,
  [SMALL_STATE(3585)] = 259521,
  [SMALL_STATE(3586)] = 259573,
  [SMALL_STATE(3587)] = 259627,
  [SMALL_STATE(3588)] = 259679,
  [SMALL_STATE(3589)] = 259733,
  [SMALL_STATE(3590)] = 259785,
  [SMALL_STATE(3591)] = 259839,
  [SMALL_STATE(3592)] = 259891,
  [SMALL_STATE(3593)] = 259943,
  [SMALL_STATE(3594)] = 259995,
  [SMALL_STATE(3595)] = 260051,
  [SMALL_STATE(3596)] = 260107,
  [SMALL_STATE(3597)] = 260159,
  [SMALL_STATE(3598)] = 260211,
  [SMALL_STATE(3599)] = 260263,
  [SMALL_STATE(3600)] = 260315,
  [SMALL_STATE(3601)] = 260367,
  [SMALL_STATE(3602)] = 260419,
  [SMALL_STATE(3603)] = 260471,
  [SMALL_STATE(3604)] = 260523,
  [SMALL_STATE(3605)] = 260575,
  [SMALL_STATE(3606)] = 260627,
  [SMALL_STATE(3607)] = 260679,
  [SMALL_STATE(3608)] = 260731,
  [SMALL_STATE(3609)] = 260783,
  [SMALL_STATE(3610)] = 260835,
  [SMALL_STATE(3611)] = 260891,
  [SMALL_STATE(3612)] = 260945,
  [SMALL_STATE(3613)] = 260997,
  [SMALL_STATE(3614)] = 261049,
  [SMALL_STATE(3615)] = 261101,
  [SMALL_STATE(3616)] = 261153,
  [SMALL_STATE(3617)] = 261209,
  [SMALL_STATE(3618)] = 261261,
  [SMALL_STATE(3619)] = 261313,
  [SMALL_STATE(3620)] = 261365,
  [SMALL_STATE(3621)] = 261419,
  [SMALL_STATE(3622)] = 261475,
  [SMALL_STATE(3623)] = 261547,
  [SMALL_STATE(3624)] = 261599,
  [SMALL_STATE(3625)] = 261651,
  [SMALL_STATE(3626)] = 261705,
  [SMALL_STATE(3627)] = 261761,
  [SMALL_STATE(3628)] = 261823,
  [SMALL_STATE(3629)] = 261877,
  [SMALL_STATE(3630)] = 261933,
  [SMALL_STATE(3631)] = 261985,
  [SMALL_STATE(3632)] = 262037,
  [SMALL_STATE(3633)] = 262091,
  [SMALL_STATE(3634)] = 262143,
  [SMALL_STATE(3635)] = 262201,
  [SMALL_STATE(3636)] = 262289,
  [SMALL_STATE(3637)] = 262343,
  [SMALL_STATE(3638)] = 262395,
  [SMALL_STATE(3639)] = 262485,
  [SMALL_STATE(3640)] = 262563,
  [SMALL_STATE(3641)] = 262615,
  [SMALL_STATE(3642)] = 262669,
  [SMALL_STATE(3643)] = 262723,
  [SMALL_STATE(3644)] = 262775,
  [SMALL_STATE(3645)] = 262827,
  [SMALL_STATE(3646)] = 262879,
  [SMALL_STATE(3647)] = 262931,
  [SMALL_STATE(3648)] = 262983,
  [SMALL_STATE(3649)] = 263035,
  [SMALL_STATE(3650)] = 263091,
  [SMALL_STATE(3651)] = 263143,
  [SMALL_STATE(3652)] = 263199,
  [SMALL_STATE(3653)] = 263253,
  [SMALL_STATE(3654)] = 263307,
  [SMALL_STATE(3655)] = 263361,
  [SMALL_STATE(3656)] = 263415,
  [SMALL_STATE(3657)] = 263467,
  [SMALL_STATE(3658)] = 263521,
  [SMALL_STATE(3659)] = 263575,
  [SMALL_STATE(3660)] = 263627,
  [SMALL_STATE(3661)] = 263679,
  [SMALL_STATE(3662)] = 263731,
  [SMALL_STATE(3663)] = 263783,
  [SMALL_STATE(3664)] = 263839,
  [SMALL_STATE(3665)] = 263895,
  [SMALL_STATE(3666)] = 263949,
  [SMALL_STATE(3667)] = 264001,
  [SMALL_STATE(3668)] = 264053,
  [SMALL_STATE(3669)] = 264105,
  [SMALL_STATE(3670)] = 264159,
  [SMALL_STATE(3671)] = 264215,
  [SMALL_STATE(3672)] = 264269,
  [SMALL_STATE(3673)] = 264323,
  [SMALL_STATE(3674)] = 264377,
  [SMALL_STATE(3675)] = 264429,
  [SMALL_STATE(3676)] = 264487,
  [SMALL_STATE(3677)] = 264539,
  [SMALL_STATE(3678)] = 264595,
  [SMALL_STATE(3679)] = 264649,
  [SMALL_STATE(3680)] = 264703,
  [SMALL_STATE(3681)] = 264757,
  [SMALL_STATE(3682)] = 264813,
  [SMALL_STATE(3683)] = 264867,
  [SMALL_STATE(3684)] = 264923,
  [SMALL_STATE(3685)] = 264977,
  [SMALL_STATE(3686)] = 265029,
  [SMALL_STATE(3687)] = 265083,
  [SMALL_STATE(3688)] = 265137,
  [SMALL_STATE(3689)] = 265189,
  [SMALL_STATE(3690)] = 265241,
  [SMALL_STATE(3691)] = 265295,
  [SMALL_STATE(3692)] = 265349,
  [SMALL_STATE(3693)] = 265401,
  [SMALL_STATE(3694)] = 265455,
  [SMALL_STATE(3695)] = 265509,
  [SMALL_STATE(3696)] = 265563,
  [SMALL_STATE(3697)] = 265615,
  [SMALL_STATE(3698)] = 265667,
  [SMALL_STATE(3699)] = 265721,
  [SMALL_STATE(3700)] = 265773,
  [SMALL_STATE(3701)] = 265825,
  [SMALL_STATE(3702)] = 265879,
  [SMALL_STATE(3703)] = 265933,
  [SMALL_STATE(3704)] = 265987,
  [SMALL_STATE(3705)] = 266039,
  [SMALL_STATE(3706)] = 266091,
  [SMALL_STATE(3707)] = 266145,
  [SMALL_STATE(3708)] = 266201,
  [SMALL_STATE(3709)] = 266257,
  [SMALL_STATE(3710)] = 266309,
  [SMALL_STATE(3711)] = 266361,
  [SMALL_STATE(3712)] = 266415,
  [SMALL_STATE(3713)] = 266471,
  [SMALL_STATE(3714)] = 266527,
  [SMALL_STATE(3715)] = 266579,
  [SMALL_STATE(3716)] = 266633,
  [SMALL_STATE(3717)] = 266687,
  [SMALL_STATE(3718)] = 266741,
  [SMALL_STATE(3719)] = 266795,
  [SMALL_STATE(3720)] = 266847,
  [SMALL_STATE(3721)] = 266901,
  [SMALL_STATE(3722)] = 266953,
  [SMALL_STATE(3723)] = 267005,
  [SMALL_STATE(3724)] = 267059,
  [SMALL_STATE(3725)] = 267111,
  [SMALL_STATE(3726)] = 267165,
  [SMALL_STATE(3727)] = 267217,
  [SMALL_STATE(3728)] = 267271,
  [SMALL_STATE(3729)] = 267323,
  [SMALL_STATE(3730)] = 267377,
  [SMALL_STATE(3731)] = 267431,
  [SMALL_STATE(3732)] = 267483,
  [SMALL_STATE(3733)] = 267539,
  [SMALL_STATE(3734)] = 267593,
  [SMALL_STATE(3735)] = 267647,
  [SMALL_STATE(3736)] = 267701,
  [SMALL_STATE(3737)] = 267755,
  [SMALL_STATE(3738)] = 267809,
  [SMALL_STATE(3739)] = 267863,
  [SMALL_STATE(3740)] = 267917,
  [SMALL_STATE(3741)] = 267971,
  [SMALL_STATE(3742)] = 268023,
  [SMALL_STATE(3743)] = 268079,
  [SMALL_STATE(3744)] = 268133,
  [SMALL_STATE(3745)] = 268185,
  [SMALL_STATE(3746)] = 268237,
  [SMALL_STATE(3747)] = 268289,
  [SMALL_STATE(3748)] = 268343,
  [SMALL_STATE(3749)] = 268395,
  [SMALL_STATE(3750)] = 268449,
  [SMALL_STATE(3751)] = 268501,
  [SMALL_STATE(3752)] = 268553,
  [SMALL_STATE(3753)] = 268605,
  [SMALL_STATE(3754)] = 268661,
  [SMALL_STATE(3755)] = 268715,
  [SMALL_STATE(3756)] = 268769,
  [SMALL_STATE(3757)] = 268823,
  [SMALL_STATE(3758)] = 268877,
  [SMALL_STATE(3759)] = 268931,
  [SMALL_STATE(3760)] = 268985,
  [SMALL_STATE(3761)] = 269045,
  [SMALL_STATE(3762)] = 269105,
  [SMALL_STATE(3763)] = 269159,
  [SMALL_STATE(3764)] = 269213,
  [SMALL_STATE(3765)] = 269265,
  [SMALL_STATE(3766)] = 269317,
  [SMALL_STATE(3767)] = 269369,
  [SMALL_STATE(3768)] = 269423,
  [SMALL_STATE(3769)] = 269475,
  [SMALL_STATE(3770)] = 269529,
  [SMALL_STATE(3771)] = 269581,
  [SMALL_STATE(3772)] = 269679,
  [SMALL_STATE(3773)] = 269731,
  [SMALL_STATE(3774)] = 269785,
  [SMALL_STATE(3775)] = 269837,
  [SMALL_STATE(3776)] = 269889,
  [SMALL_STATE(3777)] = 269943,
  [SMALL_STATE(3778)] = 269995,
  [SMALL_STATE(3779)] = 270047,
  [SMALL_STATE(3780)] = 270099,
  [SMALL_STATE(3781)] = 270155,
  [SMALL_STATE(3782)] = 270211,
  [SMALL_STATE(3783)] = 270263,
  [SMALL_STATE(3784)] = 270315,
  [SMALL_STATE(3785)] = 270371,
  [SMALL_STATE(3786)] = 270423,
  [SMALL_STATE(3787)] = 270475,
  [SMALL_STATE(3788)] = 270527,
  [SMALL_STATE(3789)] = 270579,
  [SMALL_STATE(3790)] = 270633,
  [SMALL_STATE(3791)] = 270687,
  [SMALL_STATE(3792)] = 270741,
  [SMALL_STATE(3793)] = 270793,
  [SMALL_STATE(3794)] = 270845,
  [SMALL_STATE(3795)] = 270897,
  [SMALL_STATE(3796)] = 270949,
  [SMALL_STATE(3797)] = 271001,
  [SMALL_STATE(3798)] = 271053,
  [SMALL_STATE(3799)] = 271105,
  [SMALL_STATE(3800)] = 271157,
  [SMALL_STATE(3801)] = 271209,
  [SMALL_STATE(3802)] = 271261,
  [SMALL_STATE(3803)] = 271313,
  [SMALL_STATE(3804)] = 271365,
  [SMALL_STATE(3805)] = 271417,
  [SMALL_STATE(3806)] = 271469,
  [SMALL_STATE(3807)] = 271521,
  [SMALL_STATE(3808)] = 271573,
  [SMALL_STATE(3809)] = 271625,
  [SMALL_STATE(3810)] = 271677,
  [SMALL_STATE(3811)] = 271729,
  [SMALL_STATE(3812)] = 271781,
  [SMALL_STATE(3813)] = 271835,
  [SMALL_STATE(3814)] = 271887,
  [SMALL_STATE(3815)] = 271939,
  [SMALL_STATE(3816)] = 271997,
  [SMALL_STATE(3817)] = 272051,
  [SMALL_STATE(3818)] = 272103,
  [SMALL_STATE(3819)] = 272155,
  [SMALL_STATE(3820)] = 272213,
  [SMALL_STATE(3821)] = 272265,
  [SMALL_STATE(3822)] = 272317,
  [SMALL_STATE(3823)] = 272369,
  [SMALL_STATE(3824)] = 272425,
  [SMALL_STATE(3825)] = 272477,
  [SMALL_STATE(3826)] = 272533,
  [SMALL_STATE(3827)] = 272585,
  [SMALL_STATE(3828)] = 272637,
  [SMALL_STATE(3829)] = 272693,
  [SMALL_STATE(3830)] = 272745,
  [SMALL_STATE(3831)] = 272801,
  [SMALL_STATE(3832)] = 272853,
  [SMALL_STATE(3833)] = 272911,
  [SMALL_STATE(3834)] = 272967,
  [SMALL_STATE(3835)] = 273023,
  [SMALL_STATE(3836)] = 273074,
  [SMALL_STATE(3837)] = 273125,
  [SMALL_STATE(3838)] = 273176,
  [SMALL_STATE(3839)] = 273227,
  [SMALL_STATE(3840)] = 273278,
  [SMALL_STATE(3841)] = 273329,
  [SMALL_STATE(3842)] = 273380,
  [SMALL_STATE(3843)] = 273431,
  [SMALL_STATE(3844)] = 273482,
  [SMALL_STATE(3845)] = 273533,
  [SMALL_STATE(3846)] = 273584,
  [SMALL_STATE(3847)] = 273635,
  [SMALL_STATE(3848)] = 273686,
  [SMALL_STATE(3849)] = 273737,
  [SMALL_STATE(3850)] = 273788,
  [SMALL_STATE(3851)] = 273839,
  [SMALL_STATE(3852)] = 273890,
  [SMALL_STATE(3853)] = 273941,
  [SMALL_STATE(3854)] = 273992,
  [SMALL_STATE(3855)] = 274043,
  [SMALL_STATE(3856)] = 274094,
  [SMALL_STATE(3857)] = 274155,
  [SMALL_STATE(3858)] = 274206,
  [SMALL_STATE(3859)] = 274257,
  [SMALL_STATE(3860)] = 274308,
  [SMALL_STATE(3861)] = 274359,
  [SMALL_STATE(3862)] = 274410,
  [SMALL_STATE(3863)] = 274461,
  [SMALL_STATE(3864)] = 274512,
  [SMALL_STATE(3865)] = 274563,
  [SMALL_STATE(3866)] = 274614,
  [SMALL_STATE(3867)] = 274665,
  [SMALL_STATE(3868)] = 274716,
  [SMALL_STATE(3869)] = 274767,
  [SMALL_STATE(3870)] = 274818,
  [SMALL_STATE(3871)] = 274869,
  [SMALL_STATE(3872)] = 274920,
  [SMALL_STATE(3873)] = 274971,
  [SMALL_STATE(3874)] = 275042,
  [SMALL_STATE(3875)] = 275093,
  [SMALL_STATE(3876)] = 275144,
  [SMALL_STATE(3877)] = 275195,
  [SMALL_STATE(3878)] = 275246,
  [SMALL_STATE(3879)] = 275297,
  [SMALL_STATE(3880)] = 275348,
  [SMALL_STATE(3881)] = 275399,
  [SMALL_STATE(3882)] = 275450,
  [SMALL_STATE(3883)] = 275501,
  [SMALL_STATE(3884)] = 275552,
  [SMALL_STATE(3885)] = 275603,
  [SMALL_STATE(3886)] = 275654,
  [SMALL_STATE(3887)] = 275705,
  [SMALL_STATE(3888)] = 275758,
  [SMALL_STATE(3889)] = 275811,
  [SMALL_STATE(3890)] = 275868,
  [SMALL_STATE(3891)] = 275921,
  [SMALL_STATE(3892)] = 275972,
  [SMALL_STATE(3893)] = 276023,
  [SMALL_STATE(3894)] = 276074,
  [SMALL_STATE(3895)] = 276125,
  [SMALL_STATE(3896)] = 276176,
  [SMALL_STATE(3897)] = 276227,
  [SMALL_STATE(3898)] = 276278,
  [SMALL_STATE(3899)] = 276329,
  [SMALL_STATE(3900)] = 276380,
  [SMALL_STATE(3901)] = 276437,
  [SMALL_STATE(3902)] = 276488,
  [SMALL_STATE(3903)] = 276539,
  [SMALL_STATE(3904)] = 276596,
  [SMALL_STATE(3905)] = 276647,
  [SMALL_STATE(3906)] = 276698,
  [SMALL_STATE(3907)] = 276749,
  [SMALL_STATE(3908)] = 276800,
  [SMALL_STATE(3909)] = 276851,
  [SMALL_STATE(3910)] = 276902,
  [SMALL_STATE(3911)] = 276953,
  [SMALL_STATE(3912)] = 277004,
  [SMALL_STATE(3913)] = 277057,
  [SMALL_STATE(3914)] = 277108,
  [SMALL_STATE(3915)] = 277159,
  [SMALL_STATE(3916)] = 277210,
  [SMALL_STATE(3917)] = 277261,
  [SMALL_STATE(3918)] = 277312,
  [SMALL_STATE(3919)] = 277363,
  [SMALL_STATE(3920)] = 277414,
  [SMALL_STATE(3921)] = 277465,
  [SMALL_STATE(3922)] = 277516,
  [SMALL_STATE(3923)] = 277569,
  [SMALL_STATE(3924)] = 277620,
  [SMALL_STATE(3925)] = 277673,
  [SMALL_STATE(3926)] = 277728,
  [SMALL_STATE(3927)] = 277779,
  [SMALL_STATE(3928)] = 277850,
  [SMALL_STATE(3929)] = 277901,
  [SMALL_STATE(3930)] = 277952,
  [SMALL_STATE(3931)] = 278013,
  [SMALL_STATE(3932)] = 278064,
  [SMALL_STATE(3933)] = 278117,
  [SMALL_STATE(3934)] = 278168,
  [SMALL_STATE(3935)] = 278219,
  [SMALL_STATE(3936)] = 278276,
  [SMALL_STATE(3937)] = 278327,
  [SMALL_STATE(3938)] = 278378,
  [SMALL_STATE(3939)] = 278431,
  [SMALL_STATE(3940)] = 278482,
  [SMALL_STATE(3941)] = 278533,
  [SMALL_STATE(3942)] = 278584,
  [SMALL_STATE(3943)] = 278635,
  [SMALL_STATE(3944)] = 278686,
  [SMALL_STATE(3945)] = 278741,
  [SMALL_STATE(3946)] = 278792,
  [SMALL_STATE(3947)] = 278843,
  [SMALL_STATE(3948)] = 278894,
  [SMALL_STATE(3949)] = 278977,
  [SMALL_STATE(3950)] = 279028,
  [SMALL_STATE(3951)] = 279079,
  [SMALL_STATE(3952)] = 279130,
  [SMALL_STATE(3953)] = 279181,
  [SMALL_STATE(3954)] = 279232,
  [SMALL_STATE(3955)] = 279283,
  [SMALL_STATE(3956)] = 279334,
  [SMALL_STATE(3957)] = 279385,
  [SMALL_STATE(3958)] = 279436,
  [SMALL_STATE(3959)] = 279521,
  [SMALL_STATE(3960)] = 279572,
  [SMALL_STATE(3961)] = 279623,
  [SMALL_STATE(3962)] = 279674,
  [SMALL_STATE(3963)] = 279725,
  [SMALL_STATE(3964)] = 279776,
  [SMALL_STATE(3965)] = 279827,
  [SMALL_STATE(3966)] = 279878,
  [SMALL_STATE(3967)] = 279929,
  [SMALL_STATE(3968)] = 279980,
  [SMALL_STATE(3969)] = 280031,
  [SMALL_STATE(3970)] = 280082,
  [SMALL_STATE(3971)] = 280173,
  [SMALL_STATE(3972)] = 280224,
  [SMALL_STATE(3973)] = 280275,
  [SMALL_STATE(3974)] = 280326,
  [SMALL_STATE(3975)] = 280379,
  [SMALL_STATE(3976)] = 280430,
  [SMALL_STATE(3977)] = 280483,
  [SMALL_STATE(3978)] = 280534,
  [SMALL_STATE(3979)] = 280587,
  [SMALL_STATE(3980)] = 280638,
  [SMALL_STATE(3981)] = 280691,
  [SMALL_STATE(3982)] = 280742,
  [SMALL_STATE(3983)] = 280795,
  [SMALL_STATE(3984)] = 280846,
  [SMALL_STATE(3985)] = 280897,
  [SMALL_STATE(3986)] = 280948,
  [SMALL_STATE(3987)] = 280999,
  [SMALL_STATE(3988)] = 281052,
  [SMALL_STATE(3989)] = 281103,
  [SMALL_STATE(3990)] = 281156,
  [SMALL_STATE(3991)] = 281209,
  [SMALL_STATE(3992)] = 281266,
  [SMALL_STATE(3993)] = 281317,
  [SMALL_STATE(3994)] = 281368,
  [SMALL_STATE(3995)] = 281421,
  [SMALL_STATE(3996)] = 281474,
  [SMALL_STATE(3997)] = 281527,
  [SMALL_STATE(3998)] = 281580,
  [SMALL_STATE(3999)] = 281633,
  [SMALL_STATE(4000)] = 281686,
  [SMALL_STATE(4001)] = 281739,
  [SMALL_STATE(4002)] = 281790,
  [SMALL_STATE(4003)] = 281843,
  [SMALL_STATE(4004)] = 281894,
  [SMALL_STATE(4005)] = 281945,
  [SMALL_STATE(4006)] = 281996,
  [SMALL_STATE(4007)] = 282047,
  [SMALL_STATE(4008)] = 282098,
  [SMALL_STATE(4009)] = 282149,
  [SMALL_STATE(4010)] = 282200,
  [SMALL_STATE(4011)] = 282251,
  [SMALL_STATE(4012)] = 282302,
  [SMALL_STATE(4013)] = 282353,
  [SMALL_STATE(4014)] = 282436,
  [SMALL_STATE(4015)] = 282487,
  [SMALL_STATE(4016)] = 282538,
  [SMALL_STATE(4017)] = 282589,
  [SMALL_STATE(4018)] = 282640,
  [SMALL_STATE(4019)] = 282691,
  [SMALL_STATE(4020)] = 282742,
  [SMALL_STATE(4021)] = 282793,
  [SMALL_STATE(4022)] = 282844,
  [SMALL_STATE(4023)] = 282929,
  [SMALL_STATE(4024)] = 282980,
  [SMALL_STATE(4025)] = 283031,
  [SMALL_STATE(4026)] = 283082,
  [SMALL_STATE(4027)] = 283133,
  [SMALL_STATE(4028)] = 283186,
  [SMALL_STATE(4029)] = 283237,
  [SMALL_STATE(4030)] = 283290,
  [SMALL_STATE(4031)] = 283341,
  [SMALL_STATE(4032)] = 283392,
  [SMALL_STATE(4033)] = 283443,
  [SMALL_STATE(4034)] = 283494,
  [SMALL_STATE(4035)] = 283545,
  [SMALL_STATE(4036)] = 283596,
  [SMALL_STATE(4037)] = 283647,
  [SMALL_STATE(4038)] = 283698,
  [SMALL_STATE(4039)] = 283749,
  [SMALL_STATE(4040)] = 283800,
  [SMALL_STATE(4041)] = 283853,
  [SMALL_STATE(4042)] = 283904,
  [SMALL_STATE(4043)] = 283963,
  [SMALL_STATE(4044)] = 284014,
  [SMALL_STATE(4045)] = 284065,
  [SMALL_STATE(4046)] = 284118,
  [SMALL_STATE(4047)] = 284171,
  [SMALL_STATE(4048)] = 284222,
  [SMALL_STATE(4049)] = 284273,
  [SMALL_STATE(4050)] = 284324,
  [SMALL_STATE(4051)] = 284375,
  [SMALL_STATE(4052)] = 284426,
  [SMALL_STATE(4053)] = 284477,
  [SMALL_STATE(4054)] = 284528,
  [SMALL_STATE(4055)] = 284579,
  [SMALL_STATE(4056)] = 284630,
  [SMALL_STATE(4057)] = 284685,
  [SMALL_STATE(4058)] = 284744,
  [SMALL_STATE(4059)] = 284795,
  [SMALL_STATE(4060)] = 284848,
  [SMALL_STATE(4061)] = 284901,
  [SMALL_STATE(4062)] = 284952,
  [SMALL_STATE(4063)] = 285005,
  [SMALL_STATE(4064)] = 285056,
  [SMALL_STATE(4065)] = 285107,
  [SMALL_STATE(4066)] = 285158,
  [SMALL_STATE(4067)] = 285209,
  [SMALL_STATE(4068)] = 285262,
  [SMALL_STATE(4069)] = 285315,
  [SMALL_STATE(4070)] = 285366,
  [SMALL_STATE(4071)] = 285417,
  [SMALL_STATE(4072)] = 285468,
  [SMALL_STATE(4073)] = 285553,
  [SMALL_STATE(4074)] = 285604,
  [SMALL_STATE(4075)] = 285655,
  [SMALL_STATE(4076)] = 285706,
  [SMALL_STATE(4077)] = 285757,
  [SMALL_STATE(4078)] = 285808,
  [SMALL_STATE(4079)] = 285859,
  [SMALL_STATE(4080)] = 285910,
  [SMALL_STATE(4081)] = 285961,
  [SMALL_STATE(4082)] = 286012,
  [SMALL_STATE(4083)] = 286063,
  [SMALL_STATE(4084)] = 286114,
  [SMALL_STATE(4085)] = 286199,
  [SMALL_STATE(4086)] = 286250,
  [SMALL_STATE(4087)] = 286301,
  [SMALL_STATE(4088)] = 286352,
  [SMALL_STATE(4089)] = 286403,
  [SMALL_STATE(4090)] = 286454,
  [SMALL_STATE(4091)] = 286507,
  [SMALL_STATE(4092)] = 286560,
  [SMALL_STATE(4093)] = 286611,
  [SMALL_STATE(4094)] = 286692,
  [SMALL_STATE(4095)] = 286753,
  [SMALL_STATE(4096)] = 286804,
  [SMALL_STATE(4097)] = 286855,
  [SMALL_STATE(4098)] = 286906,
  [SMALL_STATE(4099)] = 286957,
  [SMALL_STATE(4100)] = 287008,
  [SMALL_STATE(4101)] = 287075,
  [SMALL_STATE(4102)] = 287146,
  [SMALL_STATE(4103)] = 287197,
  [SMALL_STATE(4104)] = 287248,
  [SMALL_STATE(4105)] = 287299,
  [SMALL_STATE(4106)] = 287390,
  [SMALL_STATE(4107)] = 287441,
  [SMALL_STATE(4108)] = 287492,
  [SMALL_STATE(4109)] = 287543,
  [SMALL_STATE(4110)] = 287594,
  [SMALL_STATE(4111)] = 287645,
  [SMALL_STATE(4112)] = 287696,
  [SMALL_STATE(4113)] = 287747,
  [SMALL_STATE(4114)] = 287798,
  [SMALL_STATE(4115)] = 287849,
  [SMALL_STATE(4116)] = 287900,
  [SMALL_STATE(4117)] = 287951,
  [SMALL_STATE(4118)] = 288002,
  [SMALL_STATE(4119)] = 288053,
  [SMALL_STATE(4120)] = 288104,
  [SMALL_STATE(4121)] = 288155,
  [SMALL_STATE(4122)] = 288206,
  [SMALL_STATE(4123)] = 288257,
  [SMALL_STATE(4124)] = 288308,
  [SMALL_STATE(4125)] = 288359,
  [SMALL_STATE(4126)] = 288444,
  [SMALL_STATE(4127)] = 288529,
  [SMALL_STATE(4128)] = 288610,
  [SMALL_STATE(4129)] = 288671,
  [SMALL_STATE(4130)] = 288722,
  [SMALL_STATE(4131)] = 288773,
  [SMALL_STATE(4132)] = 288824,
  [SMALL_STATE(4133)] = 288875,
  [SMALL_STATE(4134)] = 288926,
  [SMALL_STATE(4135)] = 288977,
  [SMALL_STATE(4136)] = 289028,
  [SMALL_STATE(4137)] = 289079,
  [SMALL_STATE(4138)] = 289130,
  [SMALL_STATE(4139)] = 289197,
  [SMALL_STATE(4140)] = 289268,
  [SMALL_STATE(4141)] = 289321,
  [SMALL_STATE(4142)] = 289372,
  [SMALL_STATE(4143)] = 289423,
  [SMALL_STATE(4144)] = 289476,
  [SMALL_STATE(4145)] = 289529,
  [SMALL_STATE(4146)] = 289592,
  [SMALL_STATE(4147)] = 289669,
  [SMALL_STATE(4148)] = 289724,
  [SMALL_STATE(4149)] = 289775,
  [SMALL_STATE(4150)] = 289864,
  [SMALL_STATE(4151)] = 289915,
  [SMALL_STATE(4152)] = 289966,
  [SMALL_STATE(4153)] = 290053,
  [SMALL_STATE(4154)] = 290104,
  [SMALL_STATE(4155)] = 290155,
  [SMALL_STATE(4156)] = 290212,
  [SMALL_STATE(4157)] = 290273,
  [SMALL_STATE(4158)] = 290324,
  [SMALL_STATE(4159)] = 290375,
  [SMALL_STATE(4160)] = 290426,
  [SMALL_STATE(4161)] = 290477,
  [SMALL_STATE(4162)] = 290528,
  [SMALL_STATE(4163)] = 290579,
  [SMALL_STATE(4164)] = 290642,
  [SMALL_STATE(4165)] = 290693,
  [SMALL_STATE(4166)] = 290744,
  [SMALL_STATE(4167)] = 290821,
  [SMALL_STATE(4168)] = 290878,
  [SMALL_STATE(4169)] = 290929,
  [SMALL_STATE(4170)] = 290980,
  [SMALL_STATE(4171)] = 291031,
  [SMALL_STATE(4172)] = 291082,
  [SMALL_STATE(4173)] = 291133,
  [SMALL_STATE(4174)] = 291184,
  [SMALL_STATE(4175)] = 291273,
  [SMALL_STATE(4176)] = 291324,
  [SMALL_STATE(4177)] = 291375,
  [SMALL_STATE(4178)] = 291426,
  [SMALL_STATE(4179)] = 291477,
  [SMALL_STATE(4180)] = 291528,
  [SMALL_STATE(4181)] = 291579,
  [SMALL_STATE(4182)] = 291630,
  [SMALL_STATE(4183)] = 291681,
  [SMALL_STATE(4184)] = 291732,
  [SMALL_STATE(4185)] = 291783,
  [SMALL_STATE(4186)] = 291870,
  [SMALL_STATE(4187)] = 291921,
  [SMALL_STATE(4188)] = 291972,
  [SMALL_STATE(4189)] = 292023,
  [SMALL_STATE(4190)] = 292074,
  [SMALL_STATE(4191)] = 292131,
  [SMALL_STATE(4192)] = 292188,
  [SMALL_STATE(4193)] = 292239,
  [SMALL_STATE(4194)] = 292290,
  [SMALL_STATE(4195)] = 292341,
  [SMALL_STATE(4196)] = 292392,
  [SMALL_STATE(4197)] = 292451,
  [SMALL_STATE(4198)] = 292502,
  [SMALL_STATE(4199)] = 292553,
  [SMALL_STATE(4200)] = 292604,
  [SMALL_STATE(4201)] = 292685,
  [SMALL_STATE(4202)] = 292738,
  [SMALL_STATE(4203)] = 292799,
  [SMALL_STATE(4204)] = 292850,
  [SMALL_STATE(4205)] = 292929,
  [SMALL_STATE(4206)] = 292990,
  [SMALL_STATE(4207)] = 293057,
  [SMALL_STATE(4208)] = 293108,
  [SMALL_STATE(4209)] = 293175,
  [SMALL_STATE(4210)] = 293226,
  [SMALL_STATE(4211)] = 293277,
  [SMALL_STATE(4212)] = 293348,
  [SMALL_STATE(4213)] = 293399,
  [SMALL_STATE(4214)] = 293450,
  [SMALL_STATE(4215)] = 293521,
  [SMALL_STATE(4216)] = 293572,
  [SMALL_STATE(4217)] = 293623,
  [SMALL_STATE(4218)] = 293674,
  [SMALL_STATE(4219)] = 293725,
  [SMALL_STATE(4220)] = 293776,
  [SMALL_STATE(4221)] = 293827,
  [SMALL_STATE(4222)] = 293878,
  [SMALL_STATE(4223)] = 293929,
  [SMALL_STATE(4224)] = 293980,
  [SMALL_STATE(4225)] = 294031,
  [SMALL_STATE(4226)] = 294082,
  [SMALL_STATE(4227)] = 294133,
  [SMALL_STATE(4228)] = 294184,
  [SMALL_STATE(4229)] = 294235,
  [SMALL_STATE(4230)] = 294286,
  [SMALL_STATE(4231)] = 294337,
  [SMALL_STATE(4232)] = 294388,
  [SMALL_STATE(4233)] = 294439,
  [SMALL_STATE(4234)] = 294490,
  [SMALL_STATE(4235)] = 294541,
  [SMALL_STATE(4236)] = 294592,
  [SMALL_STATE(4237)] = 294643,
  [SMALL_STATE(4238)] = 294694,
  [SMALL_STATE(4239)] = 294765,
  [SMALL_STATE(4240)] = 294816,
  [SMALL_STATE(4241)] = 294867,
  [SMALL_STATE(4242)] = 294918,
  [SMALL_STATE(4243)] = 294969,
  [SMALL_STATE(4244)] = 295020,
  [SMALL_STATE(4245)] = 295071,
  [SMALL_STATE(4246)] = 295122,
  [SMALL_STATE(4247)] = 295173,
  [SMALL_STATE(4248)] = 295224,
  [SMALL_STATE(4249)] = 295275,
  [SMALL_STATE(4250)] = 295346,
  [SMALL_STATE(4251)] = 295397,
  [SMALL_STATE(4252)] = 295448,
  [SMALL_STATE(4253)] = 295499,
  [SMALL_STATE(4254)] = 295550,
  [SMALL_STATE(4255)] = 295601,
  [SMALL_STATE(4256)] = 295662,
  [SMALL_STATE(4257)] = 295715,
  [SMALL_STATE(4258)] = 295766,
  [SMALL_STATE(4259)] = 295837,
  [SMALL_STATE(4260)] = 295888,
  [SMALL_STATE(4261)] = 295939,
  [SMALL_STATE(4262)] = 295990,
  [SMALL_STATE(4263)] = 296041,
  [SMALL_STATE(4264)] = 296092,
  [SMALL_STATE(4265)] = 296143,
  [SMALL_STATE(4266)] = 296194,
  [SMALL_STATE(4267)] = 296245,
  [SMALL_STATE(4268)] = 296306,
  [SMALL_STATE(4269)] = 296357,
  [SMALL_STATE(4270)] = 296408,
  [SMALL_STATE(4271)] = 296459,
  [SMALL_STATE(4272)] = 296510,
  [SMALL_STATE(4273)] = 296561,
  [SMALL_STATE(4274)] = 296612,
  [SMALL_STATE(4275)] = 296663,
  [SMALL_STATE(4276)] = 296714,
  [SMALL_STATE(4277)] = 296765,
  [SMALL_STATE(4278)] = 296816,
  [SMALL_STATE(4279)] = 296867,
  [SMALL_STATE(4280)] = 296918,
  [SMALL_STATE(4281)] = 296969,
  [SMALL_STATE(4282)] = 297022,
  [SMALL_STATE(4283)] = 297081,
  [SMALL_STATE(4284)] = 297140,
  [SMALL_STATE(4285)] = 297191,
  [SMALL_STATE(4286)] = 297242,
  [SMALL_STATE(4287)] = 297293,
  [SMALL_STATE(4288)] = 297344,
  [SMALL_STATE(4289)] = 297395,
  [SMALL_STATE(4290)] = 297446,
  [SMALL_STATE(4291)] = 297509,
  [SMALL_STATE(4292)] = 297586,
  [SMALL_STATE(4293)] = 297637,
  [SMALL_STATE(4294)] = 297688,
  [SMALL_STATE(4295)] = 297739,
  [SMALL_STATE(4296)] = 297794,
  [SMALL_STATE(4297)] = 297845,
  [SMALL_STATE(4298)] = 297896,
  [SMALL_STATE(4299)] = 297947,
  [SMALL_STATE(4300)] = 298034,
  [SMALL_STATE(4301)] = 298085,
  [SMALL_STATE(4302)] = 298138,
  [SMALL_STATE(4303)] = 298189,
  [SMALL_STATE(4304)] = 298240,
  [SMALL_STATE(4305)] = 298325,
  [SMALL_STATE(4306)] = 298376,
  [SMALL_STATE(4307)] = 298427,
  [SMALL_STATE(4308)] = 298512,
  [SMALL_STATE(4309)] = 298563,
  [SMALL_STATE(4310)] = 298614,
  [SMALL_STATE(4311)] = 298665,
  [SMALL_STATE(4312)] = 298716,
  [SMALL_STATE(4313)] = 298767,
  [SMALL_STATE(4314)] = 298818,
  [SMALL_STATE(4315)] = 298869,
  [SMALL_STATE(4316)] = 298920,
  [SMALL_STATE(4317)] = 298971,
  [SMALL_STATE(4318)] = 299022,
  [SMALL_STATE(4319)] = 299073,
  [SMALL_STATE(4320)] = 299124,
  [SMALL_STATE(4321)] = 299175,
  [SMALL_STATE(4322)] = 299226,
  [SMALL_STATE(4323)] = 299307,
  [SMALL_STATE(4324)] = 299358,
  [SMALL_STATE(4325)] = 299443,
  [SMALL_STATE(4326)] = 299504,
  [SMALL_STATE(4327)] = 299559,
  [SMALL_STATE(4328)] = 299610,
  [SMALL_STATE(4329)] = 299661,
  [SMALL_STATE(4330)] = 299728,
  [SMALL_STATE(4331)] = 299799,
  [SMALL_STATE(4332)] = 299850,
  [SMALL_STATE(4333)] = 299909,
  [SMALL_STATE(4334)] = 299968,
  [SMALL_STATE(4335)] = 300019,
  [SMALL_STATE(4336)] = 300070,
  [SMALL_STATE(4337)] = 300121,
  [SMALL_STATE(4338)] = 300172,
  [SMALL_STATE(4339)] = 300223,
  [SMALL_STATE(4340)] = 300274,
  [SMALL_STATE(4341)] = 300325,
  [SMALL_STATE(4342)] = 300376,
  [SMALL_STATE(4343)] = 300427,
  [SMALL_STATE(4344)] = 300478,
  [SMALL_STATE(4345)] = 300529,
  [SMALL_STATE(4346)] = 300580,
  [SMALL_STATE(4347)] = 300631,
  [SMALL_STATE(4348)] = 300682,
  [SMALL_STATE(4349)] = 300745,
  [SMALL_STATE(4350)] = 300796,
  [SMALL_STATE(4351)] = 300873,
  [SMALL_STATE(4352)] = 300930,
  [SMALL_STATE(4353)] = 301019,
  [SMALL_STATE(4354)] = 301106,
  [SMALL_STATE(4355)] = 301193,
  [SMALL_STATE(4356)] = 301282,
  [SMALL_STATE(4357)] = 301333,
  [SMALL_STATE(4358)] = 301384,
  [SMALL_STATE(4359)] = 301461,
  [SMALL_STATE(4360)] = 301524,
  [SMALL_STATE(4361)] = 301574,
  [SMALL_STATE(4362)] = 301624,
  [SMALL_STATE(4363)] = 301678,
  [SMALL_STATE(4364)] = 301760,
  [SMALL_STATE(4365)] = 301842,
  [SMALL_STATE(4366)] = 301892,
  [SMALL_STATE(4367)] = 301942,
  [SMALL_STATE(4368)] = 301992,
  [SMALL_STATE(4369)] = 302070,
  [SMALL_STATE(4370)] = 302130,
  [SMALL_STATE(4371)] = 302196,
  [SMALL_STATE(4372)] = 302266,
  [SMALL_STATE(4373)] = 302318,
  [SMALL_STATE(4374)] = 302372,
  [SMALL_STATE(4375)] = 302422,
  [SMALL_STATE(4376)] = 302472,
  [SMALL_STATE(4377)] = 302522,
  [SMALL_STATE(4378)] = 302584,
  [SMALL_STATE(4379)] = 302642,
  [SMALL_STATE(4380)] = 302692,
  [SMALL_STATE(4381)] = 302768,
  [SMALL_STATE(4382)] = 302818,
  [SMALL_STATE(4383)] = 302874,
  [SMALL_STATE(4384)] = 302960,
  [SMALL_STATE(4385)] = 303044,
  [SMALL_STATE(4386)] = 303094,
  [SMALL_STATE(4387)] = 303144,
  [SMALL_STATE(4388)] = 303194,
  [SMALL_STATE(4389)] = 303244,
  [SMALL_STATE(4390)] = 303296,
  [SMALL_STATE(4391)] = 303352,
  [SMALL_STATE(4392)] = 303408,
  [SMALL_STATE(4393)] = 303458,
  [SMALL_STATE(4394)] = 303548,
  [SMALL_STATE(4395)] = 303634,
  [SMALL_STATE(4396)] = 303684,
  [SMALL_STATE(4397)] = 303772,
  [SMALL_STATE(4398)] = 303822,
  [SMALL_STATE(4399)] = 303878,
  [SMALL_STATE(4400)] = 303954,
  [SMALL_STATE(4401)] = 304016,
  [SMALL_STATE(4402)] = 304086,
  [SMALL_STATE(4403)] = 304136,
  [SMALL_STATE(4404)] = 304186,
  [SMALL_STATE(4405)] = 304236,
  [SMALL_STATE(4406)] = 304286,
  [SMALL_STATE(4407)] = 304336,
  [SMALL_STATE(4408)] = 304396,
  [SMALL_STATE(4409)] = 304456,
  [SMALL_STATE(4410)] = 304506,
  [SMALL_STATE(4411)] = 304556,
  [SMALL_STATE(4412)] = 304606,
  [SMALL_STATE(4413)] = 304656,
  [SMALL_STATE(4414)] = 304736,
  [SMALL_STATE(4415)] = 304786,
  [SMALL_STATE(4416)] = 304836,
  [SMALL_STATE(4417)] = 304920,
  [SMALL_STATE(4418)] = 305004,
  [SMALL_STATE(4419)] = 305054,
  [SMALL_STATE(4420)] = 305104,
  [SMALL_STATE(4421)] = 305154,
  [SMALL_STATE(4422)] = 305204,
  [SMALL_STATE(4423)] = 305254,
  [SMALL_STATE(4424)] = 305304,
  [SMALL_STATE(4425)] = 305354,
  [SMALL_STATE(4426)] = 305404,
  [SMALL_STATE(4427)] = 305454,
  [SMALL_STATE(4428)] = 305504,
  [SMALL_STATE(4429)] = 305554,
  [SMALL_STATE(4430)] = 305604,
  [SMALL_STATE(4431)] = 305654,
  [SMALL_STATE(4432)] = 305704,
  [SMALL_STATE(4433)] = 305754,
  [SMALL_STATE(4434)] = 305804,
  [SMALL_STATE(4435)] = 305854,
  [SMALL_STATE(4436)] = 305904,
  [SMALL_STATE(4437)] = 305954,
  [SMALL_STATE(4438)] = 306004,
  [SMALL_STATE(4439)] = 306054,
  [SMALL_STATE(4440)] = 306104,
  [SMALL_STATE(4441)] = 306154,
  [SMALL_STATE(4442)] = 306204,
  [SMALL_STATE(4443)] = 306254,
  [SMALL_STATE(4444)] = 306304,
  [SMALL_STATE(4445)] = 306354,
  [SMALL_STATE(4446)] = 306414,
  [SMALL_STATE(4447)] = 306464,
  [SMALL_STATE(4448)] = 306534,
  [SMALL_STATE(4449)] = 306584,
  [SMALL_STATE(4450)] = 306634,
  [SMALL_STATE(4451)] = 306684,
  [SMALL_STATE(4452)] = 306734,
  [SMALL_STATE(4453)] = 306784,
  [SMALL_STATE(4454)] = 306834,
  [SMALL_STATE(4455)] = 306884,
  [SMALL_STATE(4456)] = 306934,
  [SMALL_STATE(4457)] = 306988,
  [SMALL_STATE(4458)] = 307038,
  [SMALL_STATE(4459)] = 307088,
  [SMALL_STATE(4460)] = 307138,
  [SMALL_STATE(4461)] = 307188,
  [SMALL_STATE(4462)] = 307238,
  [SMALL_STATE(4463)] = 307288,
  [SMALL_STATE(4464)] = 307338,
  [SMALL_STATE(4465)] = 307388,
  [SMALL_STATE(4466)] = 307438,
  [SMALL_STATE(4467)] = 307492,
  [SMALL_STATE(4468)] = 307542,
  [SMALL_STATE(4469)] = 307592,
  [SMALL_STATE(4470)] = 307646,
  [SMALL_STATE(4471)] = 307696,
  [SMALL_STATE(4472)] = 307746,
  [SMALL_STATE(4473)] = 307796,
  [SMALL_STATE(4474)] = 307846,
  [SMALL_STATE(4475)] = 307896,
  [SMALL_STATE(4476)] = 307946,
  [SMALL_STATE(4477)] = 308000,
  [SMALL_STATE(4478)] = 308054,
  [SMALL_STATE(4479)] = 308108,
  [SMALL_STATE(4480)] = 308158,
  [SMALL_STATE(4481)] = 308212,
  [SMALL_STATE(4482)] = 308266,
  [SMALL_STATE(4483)] = 308316,
  [SMALL_STATE(4484)] = 308366,
  [SMALL_STATE(4485)] = 308424,
  [SMALL_STATE(4486)] = 308474,
  [SMALL_STATE(4487)] = 308532,
  [SMALL_STATE(4488)] = 308622,
  [SMALL_STATE(4489)] = 308672,
  [SMALL_STATE(4490)] = 308728,
  [SMALL_STATE(4491)] = 308784,
  [SMALL_STATE(4492)] = 308834,
  [SMALL_STATE(4493)] = 308884,
  [SMALL_STATE(4494)] = 308934,
  [SMALL_STATE(4495)] = 308984,
  [SMALL_STATE(4496)] = 309034,
  [SMALL_STATE(4497)] = 309084,
  [SMALL_STATE(4498)] = 309134,
  [SMALL_STATE(4499)] = 309188,
  [SMALL_STATE(4500)] = 309238,
  [SMALL_STATE(4501)] = 309288,
  [SMALL_STATE(4502)] = 309342,
  [SMALL_STATE(4503)] = 309394,
  [SMALL_STATE(4504)] = 309444,
  [SMALL_STATE(4505)] = 309494,
  [SMALL_STATE(4506)] = 309544,
  [SMALL_STATE(4507)] = 309594,
  [SMALL_STATE(4508)] = 309644,
  [SMALL_STATE(4509)] = 309694,
  [SMALL_STATE(4510)] = 309748,
  [SMALL_STATE(4511)] = 309814,
  [SMALL_STATE(4512)] = 309884,
  [SMALL_STATE(4513)] = 309934,
  [SMALL_STATE(4514)] = 309988,
  [SMALL_STATE(4515)] = 310042,
  [SMALL_STATE(4516)] = 310092,
  [SMALL_STATE(4517)] = 310142,
  [SMALL_STATE(4518)] = 310192,
  [SMALL_STATE(4519)] = 310242,
  [SMALL_STATE(4520)] = 310292,
  [SMALL_STATE(4521)] = 310342,
  [SMALL_STATE(4522)] = 310392,
  [SMALL_STATE(4523)] = 310442,
  [SMALL_STATE(4524)] = 310492,
  [SMALL_STATE(4525)] = 310542,
  [SMALL_STATE(4526)] = 310632,
  [SMALL_STATE(4527)] = 310682,
  [SMALL_STATE(4528)] = 310732,
  [SMALL_STATE(4529)] = 310782,
  [SMALL_STATE(4530)] = 310832,
  [SMALL_STATE(4531)] = 310882,
  [SMALL_STATE(4532)] = 310932,
  [SMALL_STATE(4533)] = 310982,
  [SMALL_STATE(4534)] = 311032,
  [SMALL_STATE(4535)] = 311082,
  [SMALL_STATE(4536)] = 311136,
  [SMALL_STATE(4537)] = 311190,
  [SMALL_STATE(4538)] = 311240,
  [SMALL_STATE(4539)] = 311290,
  [SMALL_STATE(4540)] = 311340,
  [SMALL_STATE(4541)] = 311390,
  [SMALL_STATE(4542)] = 311440,
  [SMALL_STATE(4543)] = 311494,
  [SMALL_STATE(4544)] = 311544,
  [SMALL_STATE(4545)] = 311594,
  [SMALL_STATE(4546)] = 311644,
  [SMALL_STATE(4547)] = 311694,
  [SMALL_STATE(4548)] = 311744,
  [SMALL_STATE(4549)] = 311794,
  [SMALL_STATE(4550)] = 311844,
  [SMALL_STATE(4551)] = 311894,
  [SMALL_STATE(4552)] = 311944,
  [SMALL_STATE(4553)] = 311994,
  [SMALL_STATE(4554)] = 312044,
  [SMALL_STATE(4555)] = 312094,
  [SMALL_STATE(4556)] = 312144,
  [SMALL_STATE(4557)] = 312194,
  [SMALL_STATE(4558)] = 312244,
  [SMALL_STATE(4559)] = 312294,
  [SMALL_STATE(4560)] = 312344,
  [SMALL_STATE(4561)] = 312394,
  [SMALL_STATE(4562)] = 312444,
  [SMALL_STATE(4563)] = 312494,
  [SMALL_STATE(4564)] = 312544,
  [SMALL_STATE(4565)] = 312594,
  [SMALL_STATE(4566)] = 312644,
  [SMALL_STATE(4567)] = 312700,
  [SMALL_STATE(4568)] = 312750,
  [SMALL_STATE(4569)] = 312806,
  [SMALL_STATE(4570)] = 312856,
  [SMALL_STATE(4571)] = 312906,
  [SMALL_STATE(4572)] = 312956,
  [SMALL_STATE(4573)] = 313006,
  [SMALL_STATE(4574)] = 313056,
  [SMALL_STATE(4575)] = 313106,
  [SMALL_STATE(4576)] = 313156,
  [SMALL_STATE(4577)] = 313206,
  [SMALL_STATE(4578)] = 313256,
  [SMALL_STATE(4579)] = 313310,
  [SMALL_STATE(4580)] = 313360,
  [SMALL_STATE(4581)] = 313410,
  [SMALL_STATE(4582)] = 313460,
  [SMALL_STATE(4583)] = 313510,
  [SMALL_STATE(4584)] = 313560,
  [SMALL_STATE(4585)] = 313610,
  [SMALL_STATE(4586)] = 313660,
  [SMALL_STATE(4587)] = 313710,
  [SMALL_STATE(4588)] = 313760,
  [SMALL_STATE(4589)] = 313810,
  [SMALL_STATE(4590)] = 313860,
  [SMALL_STATE(4591)] = 313910,
  [SMALL_STATE(4592)] = 313960,
  [SMALL_STATE(4593)] = 314010,
  [SMALL_STATE(4594)] = 314060,
  [SMALL_STATE(4595)] = 314110,
  [SMALL_STATE(4596)] = 314160,
  [SMALL_STATE(4597)] = 314210,
  [SMALL_STATE(4598)] = 314260,
  [SMALL_STATE(4599)] = 314310,
  [SMALL_STATE(4600)] = 314360,
  [SMALL_STATE(4601)] = 314410,
  [SMALL_STATE(4602)] = 314460,
  [SMALL_STATE(4603)] = 314510,
  [SMALL_STATE(4604)] = 314560,
  [SMALL_STATE(4605)] = 314610,
  [SMALL_STATE(4606)] = 314660,
  [SMALL_STATE(4607)] = 314710,
  [SMALL_STATE(4608)] = 314760,
  [SMALL_STATE(4609)] = 314810,
  [SMALL_STATE(4610)] = 314860,
  [SMALL_STATE(4611)] = 314910,
  [SMALL_STATE(4612)] = 314960,
  [SMALL_STATE(4613)] = 315010,
  [SMALL_STATE(4614)] = 315060,
  [SMALL_STATE(4615)] = 315110,
  [SMALL_STATE(4616)] = 315160,
  [SMALL_STATE(4617)] = 315210,
  [SMALL_STATE(4618)] = 315260,
  [SMALL_STATE(4619)] = 315310,
  [SMALL_STATE(4620)] = 315360,
  [SMALL_STATE(4621)] = 315410,
  [SMALL_STATE(4622)] = 315460,
  [SMALL_STATE(4623)] = 315510,
  [SMALL_STATE(4624)] = 315560,
  [SMALL_STATE(4625)] = 315650,
  [SMALL_STATE(4626)] = 315700,
  [SMALL_STATE(4627)] = 315750,
  [SMALL_STATE(4628)] = 315800,
  [SMALL_STATE(4629)] = 315850,
  [SMALL_STATE(4630)] = 315900,
  [SMALL_STATE(4631)] = 315950,
  [SMALL_STATE(4632)] = 316000,
  [SMALL_STATE(4633)] = 316050,
  [SMALL_STATE(4634)] = 316100,
  [SMALL_STATE(4635)] = 316150,
  [SMALL_STATE(4636)] = 316200,
  [SMALL_STATE(4637)] = 316250,
  [SMALL_STATE(4638)] = 316300,
  [SMALL_STATE(4639)] = 316350,
  [SMALL_STATE(4640)] = 316400,
  [SMALL_STATE(4641)] = 316450,
  [SMALL_STATE(4642)] = 316500,
  [SMALL_STATE(4643)] = 316550,
  [SMALL_STATE(4644)] = 316600,
  [SMALL_STATE(4645)] = 316650,
  [SMALL_STATE(4646)] = 316700,
  [SMALL_STATE(4647)] = 316750,
  [SMALL_STATE(4648)] = 316800,
  [SMALL_STATE(4649)] = 316850,
  [SMALL_STATE(4650)] = 316900,
  [SMALL_STATE(4651)] = 316950,
  [SMALL_STATE(4652)] = 317000,
  [SMALL_STATE(4653)] = 317050,
  [SMALL_STATE(4654)] = 317100,
  [SMALL_STATE(4655)] = 317150,
  [SMALL_STATE(4656)] = 317200,
  [SMALL_STATE(4657)] = 317250,
  [SMALL_STATE(4658)] = 317300,
  [SMALL_STATE(4659)] = 317350,
  [SMALL_STATE(4660)] = 317400,
  [SMALL_STATE(4661)] = 317450,
  [SMALL_STATE(4662)] = 317505,
  [SMALL_STATE(4663)] = 317554,
  [SMALL_STATE(4664)] = 317643,
  [SMALL_STATE(4665)] = 317692,
  [SMALL_STATE(4666)] = 317781,
  [SMALL_STATE(4667)] = 317830,
  [SMALL_STATE(4668)] = 317879,
  [SMALL_STATE(4669)] = 317968,
  [SMALL_STATE(4670)] = 318017,
  [SMALL_STATE(4671)] = 318110,
  [SMALL_STATE(4672)] = 318159,
  [SMALL_STATE(4673)] = 318208,
  [SMALL_STATE(4674)] = 318257,
  [SMALL_STATE(4675)] = 318306,
  [SMALL_STATE(4676)] = 318355,
  [SMALL_STATE(4677)] = 318408,
  [SMALL_STATE(4678)] = 318463,
  [SMALL_STATE(4679)] = 318520,
  [SMALL_STATE(4680)] = 318577,
  [SMALL_STATE(4681)] = 318632,
  [SMALL_STATE(4682)] = 318687,
  [SMALL_STATE(4683)] = 318736,
  [SMALL_STATE(4684)] = 318825,
  [SMALL_STATE(4685)] = 318878,
  [SMALL_STATE(4686)] = 318927,
  [SMALL_STATE(4687)] = 318976,
  [SMALL_STATE(4688)] = 319025,
  [SMALL_STATE(4689)] = 319082,
  [SMALL_STATE(4690)] = 319139,
  [SMALL_STATE(4691)] = 319198,
  [SMALL_STATE(4692)] = 319247,
  [SMALL_STATE(4693)] = 319296,
  [SMALL_STATE(4694)] = 319345,
  [SMALL_STATE(4695)] = 319394,
  [SMALL_STATE(4696)] = 319463,
  [SMALL_STATE(4697)] = 319552,
  [SMALL_STATE(4698)] = 319601,
  [SMALL_STATE(4699)] = 319650,
  [SMALL_STATE(4700)] = 319699,
  [SMALL_STATE(4701)] = 319748,
  [SMALL_STATE(4702)] = 319797,
  [SMALL_STATE(4703)] = 319846,
  [SMALL_STATE(4704)] = 319895,
  [SMALL_STATE(4705)] = 319984,
  [SMALL_STATE(4706)] = 320033,
  [SMALL_STATE(4707)] = 320082,
  [SMALL_STATE(4708)] = 320131,
  [SMALL_STATE(4709)] = 320182,
  [SMALL_STATE(4710)] = 320263,
  [SMALL_STATE(4711)] = 320344,
  [SMALL_STATE(4712)] = 320427,
  [SMALL_STATE(4713)] = 320512,
  [SMALL_STATE(4714)] = 320567,
  [SMALL_STATE(4715)] = 320642,
  [SMALL_STATE(4716)] = 320703,
  [SMALL_STATE(4717)] = 320752,
  [SMALL_STATE(4718)] = 320841,
  [SMALL_STATE(4719)] = 320890,
  [SMALL_STATE(4720)] = 320939,
  [SMALL_STATE(4721)] = 320988,
  [SMALL_STATE(4722)] = 321077,
  [SMALL_STATE(4723)] = 321126,
  [SMALL_STATE(4724)] = 321175,
  [SMALL_STATE(4725)] = 321224,
  [SMALL_STATE(4726)] = 321273,
  [SMALL_STATE(4727)] = 321322,
  [SMALL_STATE(4728)] = 321371,
  [SMALL_STATE(4729)] = 321448,
  [SMALL_STATE(4730)] = 321517,
  [SMALL_STATE(4731)] = 321566,
  [SMALL_STATE(4732)] = 321631,
  [SMALL_STATE(4733)] = 321690,
  [SMALL_STATE(4734)] = 321739,
  [SMALL_STATE(4735)] = 321793,
  [SMALL_STATE(4736)] = 321847,
  [SMALL_STATE(4737)] = 321895,
  [SMALL_STATE(4738)] = 321943,
  [SMALL_STATE(4739)] = 321991,
  [SMALL_STATE(4740)] = 322039,
  [SMALL_STATE(4741)] = 322087,
  [SMALL_STATE(4742)] = 322135,
  [SMALL_STATE(4743)] = 322183,
  [SMALL_STATE(4744)] = 322271,
  [SMALL_STATE(4745)] = 322325,
  [SMALL_STATE(4746)] = 322381,
  [SMALL_STATE(4747)] = 322429,
  [SMALL_STATE(4748)] = 322485,
  [SMALL_STATE(4749)] = 322539,
  [SMALL_STATE(4750)] = 322595,
  [SMALL_STATE(4751)] = 322645,
  [SMALL_STATE(4752)] = 322693,
  [SMALL_STATE(4753)] = 322747,
  [SMALL_STATE(4754)] = 322803,
  [SMALL_STATE(4755)] = 322851,
  [SMALL_STATE(4756)] = 322899,
  [SMALL_STATE(4757)] = 322947,
  [SMALL_STATE(4758)] = 323001,
  [SMALL_STATE(4759)] = 323049,
  [SMALL_STATE(4760)] = 323105,
  [SMALL_STATE(4761)] = 323159,
  [SMALL_STATE(4762)] = 323207,
  [SMALL_STATE(4763)] = 323255,
  [SMALL_STATE(4764)] = 323303,
  [SMALL_STATE(4765)] = 323351,
  [SMALL_STATE(4766)] = 323405,
  [SMALL_STATE(4767)] = 323459,
  [SMALL_STATE(4768)] = 323513,
  [SMALL_STATE(4769)] = 323567,
  [SMALL_STATE(4770)] = 323621,
  [SMALL_STATE(4771)] = 323675,
  [SMALL_STATE(4772)] = 323729,
  [SMALL_STATE(4773)] = 323785,
  [SMALL_STATE(4774)] = 323839,
  [SMALL_STATE(4775)] = 323887,
  [SMALL_STATE(4776)] = 323935,
  [SMALL_STATE(4777)] = 323983,
  [SMALL_STATE(4778)] = 324037,
  [SMALL_STATE(4779)] = 324091,
  [SMALL_STATE(4780)] = 324145,
  [SMALL_STATE(4781)] = 324201,
  [SMALL_STATE(4782)] = 324257,
  [SMALL_STATE(4783)] = 324309,
  [SMALL_STATE(4784)] = 324361,
  [SMALL_STATE(4785)] = 324417,
  [SMALL_STATE(4786)] = 324465,
  [SMALL_STATE(4787)] = 324519,
  [SMALL_STATE(4788)] = 324567,
  [SMALL_STATE(4789)] = 324615,
  [SMALL_STATE(4790)] = 324663,
  [SMALL_STATE(4791)] = 324711,
  [SMALL_STATE(4792)] = 324759,
  [SMALL_STATE(4793)] = 324807,
  [SMALL_STATE(4794)] = 324855,
  [SMALL_STATE(4795)] = 324909,
  [SMALL_STATE(4796)] = 324957,
  [SMALL_STATE(4797)] = 325005,
  [SMALL_STATE(4798)] = 325053,
  [SMALL_STATE(4799)] = 325101,
  [SMALL_STATE(4800)] = 325148,
  [SMALL_STATE(4801)] = 325195,
  [SMALL_STATE(4802)] = 325250,
  [SMALL_STATE(4803)] = 325305,
  [SMALL_STATE(4804)] = 325360,
  [SMALL_STATE(4805)] = 325447,
  [SMALL_STATE(4806)] = 325498,
  [SMALL_STATE(4807)] = 325549,
  [SMALL_STATE(4808)] = 325596,
  [SMALL_STATE(4809)] = 325647,
  [SMALL_STATE(4810)] = 325698,
  [SMALL_STATE(4811)] = 325749,
  [SMALL_STATE(4812)] = 325800,
  [SMALL_STATE(4813)] = 325851,
  [SMALL_STATE(4814)] = 325898,
  [SMALL_STATE(4815)] = 325945,
  [SMALL_STATE(4816)] = 325992,
  [SMALL_STATE(4817)] = 326043,
  [SMALL_STATE(4818)] = 326094,
  [SMALL_STATE(4819)] = 326141,
  [SMALL_STATE(4820)] = 326188,
  [SMALL_STATE(4821)] = 326239,
  [SMALL_STATE(4822)] = 326286,
  [SMALL_STATE(4823)] = 326333,
  [SMALL_STATE(4824)] = 326420,
  [SMALL_STATE(4825)] = 326467,
  [SMALL_STATE(4826)] = 326518,
  [SMALL_STATE(4827)] = 326565,
  [SMALL_STATE(4828)] = 326616,
  [SMALL_STATE(4829)] = 326667,
  [SMALL_STATE(4830)] = 326714,
  [SMALL_STATE(4831)] = 326765,
  [SMALL_STATE(4832)] = 326814,
  [SMALL_STATE(4833)] = 326861,
  [SMALL_STATE(4834)] = 326908,
  [SMALL_STATE(4835)] = 326959,
  [SMALL_STATE(4836)] = 327010,
  [SMALL_STATE(4837)] = 327061,
  [SMALL_STATE(4838)] = 327114,
  [SMALL_STATE(4839)] = 327167,
  [SMALL_STATE(4840)] = 327254,
  [SMALL_STATE(4841)] = 327301,
  [SMALL_STATE(4842)] = 327352,
  [SMALL_STATE(4843)] = 327403,
  [SMALL_STATE(4844)] = 327452,
  [SMALL_STATE(4845)] = 327507,
  [SMALL_STATE(4846)] = 327558,
  [SMALL_STATE(4847)] = 327613,
  [SMALL_STATE(4848)] = 327664,
  [SMALL_STATE(4849)] = 327715,
  [SMALL_STATE(4850)] = 327762,
  [SMALL_STATE(4851)] = 327849,
  [SMALL_STATE(4852)] = 327896,
  [SMALL_STATE(4853)] = 327947,
  [SMALL_STATE(4854)] = 328034,
  [SMALL_STATE(4855)] = 328081,
  [SMALL_STATE(4856)] = 328128,
  [SMALL_STATE(4857)] = 328181,
  [SMALL_STATE(4858)] = 328234,
  [SMALL_STATE(4859)] = 328287,
  [SMALL_STATE(4860)] = 328340,
  [SMALL_STATE(4861)] = 328393,
  [SMALL_STATE(4862)] = 328446,
  [SMALL_STATE(4863)] = 328499,
  [SMALL_STATE(4864)] = 328546,
  [SMALL_STATE(4865)] = 328597,
  [SMALL_STATE(4866)] = 328650,
  [SMALL_STATE(4867)] = 328697,
  [SMALL_STATE(4868)] = 328746,
  [SMALL_STATE(4869)] = 328793,
  [SMALL_STATE(4870)] = 328840,
  [SMALL_STATE(4871)] = 328887,
  [SMALL_STATE(4872)] = 328934,
  [SMALL_STATE(4873)] = 328981,
  [SMALL_STATE(4874)] = 329036,
  [SMALL_STATE(4875)] = 329083,
  [SMALL_STATE(4876)] = 329134,
  [SMALL_STATE(4877)] = 329185,
  [SMALL_STATE(4878)] = 329236,
  [SMALL_STATE(4879)] = 329287,
  [SMALL_STATE(4880)] = 329334,
  [SMALL_STATE(4881)] = 329385,
  [SMALL_STATE(4882)] = 329432,
  [SMALL_STATE(4883)] = 329483,
  [SMALL_STATE(4884)] = 329536,
  [SMALL_STATE(4885)] = 329591,
  [SMALL_STATE(4886)] = 329638,
  [SMALL_STATE(4887)] = 329691,
  [SMALL_STATE(4888)] = 329742,
  [SMALL_STATE(4889)] = 329793,
  [SMALL_STATE(4890)] = 329844,
  [SMALL_STATE(4891)] = 329895,
  [SMALL_STATE(4892)] = 329946,
  [SMALL_STATE(4893)] = 329997,
  [SMALL_STATE(4894)] = 330044,
  [SMALL_STATE(4895)] = 330097,
  [SMALL_STATE(4896)] = 330150,
  [SMALL_STATE(4897)] = 330203,
  [SMALL_STATE(4898)] = 330256,
  [SMALL_STATE(4899)] = 330307,
  [SMALL_STATE(4900)] = 330354,
  [SMALL_STATE(4901)] = 330407,
  [SMALL_STATE(4902)] = 330460,
  [SMALL_STATE(4903)] = 330511,
  [SMALL_STATE(4904)] = 330562,
  [SMALL_STATE(4905)] = 330609,
  [SMALL_STATE(4906)] = 330656,
  [SMALL_STATE(4907)] = 330707,
  [SMALL_STATE(4908)] = 330758,
  [SMALL_STATE(4909)] = 330805,
  [SMALL_STATE(4910)] = 330852,
  [SMALL_STATE(4911)] = 330899,
  [SMALL_STATE(4912)] = 330946,
  [SMALL_STATE(4913)] = 330993,
  [SMALL_STATE(4914)] = 331040,
  [SMALL_STATE(4915)] = 331127,
  [SMALL_STATE(4916)] = 331174,
  [SMALL_STATE(4917)] = 331221,
  [SMALL_STATE(4918)] = 331268,
  [SMALL_STATE(4919)] = 331360,
  [SMALL_STATE(4920)] = 331408,
  [SMALL_STATE(4921)] = 331500,
  [SMALL_STATE(4922)] = 331548,
  [SMALL_STATE(4923)] = 331596,
  [SMALL_STATE(4924)] = 331644,
  [SMALL_STATE(4925)] = 331736,
  [SMALL_STATE(4926)] = 331784,
  [SMALL_STATE(4927)] = 331834,
  [SMALL_STATE(4928)] = 331926,
  [SMALL_STATE(4929)] = 332018,
  [SMALL_STATE(4930)] = 332110,
  [SMALL_STATE(4931)] = 332158,
  [SMALL_STATE(4932)] = 332250,
  [SMALL_STATE(4933)] = 332342,
  [SMALL_STATE(4934)] = 332390,
  [SMALL_STATE(4935)] = 332438,
  [SMALL_STATE(4936)] = 332486,
  [SMALL_STATE(4937)] = 332534,
  [SMALL_STATE(4938)] = 332582,
  [SMALL_STATE(4939)] = 332632,
  [SMALL_STATE(4940)] = 332684,
  [SMALL_STATE(4941)] = 332770,
  [SMALL_STATE(4942)] = 332820,
  [SMALL_STATE(4943)] = 332906,
  [SMALL_STATE(4944)] = 332998,
  [SMALL_STATE(4945)] = 333048,
  [SMALL_STATE(4946)] = 333140,
  [SMALL_STATE(4947)] = 333190,
  [SMALL_STATE(4948)] = 333240,
  [SMALL_STATE(4949)] = 333290,
  [SMALL_STATE(4950)] = 333340,
  [SMALL_STATE(4951)] = 333388,
  [SMALL_STATE(4952)] = 333474,
  [SMALL_STATE(4953)] = 333522,
  [SMALL_STATE(4954)] = 333614,
  [SMALL_STATE(4955)] = 333706,
  [SMALL_STATE(4956)] = 333754,
  [SMALL_STATE(4957)] = 333802,
  [SMALL_STATE(4958)] = 333850,
  [SMALL_STATE(4959)] = 333942,
  [SMALL_STATE(4960)] = 333990,
  [SMALL_STATE(4961)] = 334082,
  [SMALL_STATE(4962)] = 334132,
  [SMALL_STATE(4963)] = 334182,
  [SMALL_STATE(4964)] = 334232,
  [SMALL_STATE(4965)] = 334282,
  [SMALL_STATE(4966)] = 334330,
  [SMALL_STATE(4967)] = 334380,
  [SMALL_STATE(4968)] = 334430,
  [SMALL_STATE(4969)] = 334478,
  [SMALL_STATE(4970)] = 334526,
  [SMALL_STATE(4971)] = 334574,
  [SMALL_STATE(4972)] = 334622,
  [SMALL_STATE(4973)] = 334670,
  [SMALL_STATE(4974)] = 334718,
  [SMALL_STATE(4975)] = 334766,
  [SMALL_STATE(4976)] = 334814,
  [SMALL_STATE(4977)] = 334860,
  [SMALL_STATE(4978)] = 334952,
  [SMALL_STATE(4979)] = 335000,
  [SMALL_STATE(4980)] = 335092,
  [SMALL_STATE(4981)] = 335140,
  [SMALL_STATE(4982)] = 335232,
  [SMALL_STATE(4983)] = 335280,
  [SMALL_STATE(4984)] = 335330,
  [SMALL_STATE(4985)] = 335380,
  [SMALL_STATE(4986)] = 335428,
  [SMALL_STATE(4987)] = 335476,
  [SMALL_STATE(4988)] = 335526,
  [SMALL_STATE(4989)] = 335618,
  [SMALL_STATE(4990)] = 335668,
  [SMALL_STATE(4991)] = 335760,
  [SMALL_STATE(4992)] = 335810,
  [SMALL_STATE(4993)] = 335860,
  [SMALL_STATE(4994)] = 335910,
  [SMALL_STATE(4995)] = 335960,
  [SMALL_STATE(4996)] = 336008,
  [SMALL_STATE(4997)] = 336054,
  [SMALL_STATE(4998)] = 336104,
  [SMALL_STATE(4999)] = 336154,
  [SMALL_STATE(5000)] = 336204,
  [SMALL_STATE(5001)] = 336254,
  [SMALL_STATE(5002)] = 336304,
  [SMALL_STATE(5003)] = 336352,
  [SMALL_STATE(5004)] = 336398,
  [SMALL_STATE(5005)] = 336490,
  [SMALL_STATE(5006)] = 336538,
  [SMALL_STATE(5007)] = 336584,
  [SMALL_STATE(5008)] = 336630,
  [SMALL_STATE(5009)] = 336716,
  [SMALL_STATE(5010)] = 336808,
  [SMALL_STATE(5011)] = 336856,
  [SMALL_STATE(5012)] = 336948,
  [SMALL_STATE(5013)] = 337040,
  [SMALL_STATE(5014)] = 337088,
  [SMALL_STATE(5015)] = 337180,
  [SMALL_STATE(5016)] = 337228,
  [SMALL_STATE(5017)] = 337320,
  [SMALL_STATE(5018)] = 337368,
  [SMALL_STATE(5019)] = 337414,
  [SMALL_STATE(5020)] = 337462,
  [SMALL_STATE(5021)] = 337510,
  [SMALL_STATE(5022)] = 337558,
  [SMALL_STATE(5023)] = 337606,
  [SMALL_STATE(5024)] = 337698,
  [SMALL_STATE(5025)] = 337790,
  [SMALL_STATE(5026)] = 337838,
  [SMALL_STATE(5027)] = 337886,
  [SMALL_STATE(5028)] = 337936,
  [SMALL_STATE(5029)] = 337986,
  [SMALL_STATE(5030)] = 338078,
  [SMALL_STATE(5031)] = 338170,
  [SMALL_STATE(5032)] = 338224,
  [SMALL_STATE(5033)] = 338274,
  [SMALL_STATE(5034)] = 338328,
  [SMALL_STATE(5035)] = 338382,
  [SMALL_STATE(5036)] = 338430,
  [SMALL_STATE(5037)] = 338480,
  [SMALL_STATE(5038)] = 338572,
  [SMALL_STATE(5039)] = 338620,
  [SMALL_STATE(5040)] = 338670,
  [SMALL_STATE(5041)] = 338718,
  [SMALL_STATE(5042)] = 338766,
  [SMALL_STATE(5043)] = 338858,
  [SMALL_STATE(5044)] = 338906,
  [SMALL_STATE(5045)] = 338998,
  [SMALL_STATE(5046)] = 339048,
  [SMALL_STATE(5047)] = 339140,
  [SMALL_STATE(5048)] = 339226,
  [SMALL_STATE(5049)] = 339274,
  [SMALL_STATE(5050)] = 339322,
  [SMALL_STATE(5051)] = 339370,
  [SMALL_STATE(5052)] = 339418,
  [SMALL_STATE(5053)] = 339466,
  [SMALL_STATE(5054)] = 339514,
  [SMALL_STATE(5055)] = 339562,
  [SMALL_STATE(5056)] = 339612,
  [SMALL_STATE(5057)] = 339662,
  [SMALL_STATE(5058)] = 339712,
  [SMALL_STATE(5059)] = 339804,
  [SMALL_STATE(5060)] = 339854,
  [SMALL_STATE(5061)] = 339904,
  [SMALL_STATE(5062)] = 339954,
  [SMALL_STATE(5063)] = 340004,
  [SMALL_STATE(5064)] = 340052,
  [SMALL_STATE(5065)] = 340104,
  [SMALL_STATE(5066)] = 340152,
  [SMALL_STATE(5067)] = 340202,
  [SMALL_STATE(5068)] = 340250,
  [SMALL_STATE(5069)] = 340298,
  [SMALL_STATE(5070)] = 340352,
  [SMALL_STATE(5071)] = 340406,
  [SMALL_STATE(5072)] = 340454,
  [SMALL_STATE(5073)] = 340502,
  [SMALL_STATE(5074)] = 340550,
  [SMALL_STATE(5075)] = 340598,
  [SMALL_STATE(5076)] = 340646,
  [SMALL_STATE(5077)] = 340700,
  [SMALL_STATE(5078)] = 340748,
  [SMALL_STATE(5079)] = 340796,
  [SMALL_STATE(5080)] = 340844,
  [SMALL_STATE(5081)] = 340892,
  [SMALL_STATE(5082)] = 340940,
  [SMALL_STATE(5083)] = 340988,
  [SMALL_STATE(5084)] = 341036,
  [SMALL_STATE(5085)] = 341086,
  [SMALL_STATE(5086)] = 341134,
  [SMALL_STATE(5087)] = 341180,
  [SMALL_STATE(5088)] = 341272,
  [SMALL_STATE(5089)] = 341322,
  [SMALL_STATE(5090)] = 341414,
  [SMALL_STATE(5091)] = 341464,
  [SMALL_STATE(5092)] = 341514,
  [SMALL_STATE(5093)] = 341564,
  [SMALL_STATE(5094)] = 341611,
  [SMALL_STATE(5095)] = 341656,
  [SMALL_STATE(5096)] = 341745,
  [SMALL_STATE(5097)] = 341834,
  [SMALL_STATE(5098)] = 341923,
  [SMALL_STATE(5099)] = 342012,
  [SMALL_STATE(5100)] = 342101,
  [SMALL_STATE(5101)] = 342190,
  [SMALL_STATE(5102)] = 342235,
  [SMALL_STATE(5103)] = 342324,
  [SMALL_STATE(5104)] = 342371,
  [SMALL_STATE(5105)] = 342460,
  [SMALL_STATE(5106)] = 342549,
  [SMALL_STATE(5107)] = 342604,
  [SMALL_STATE(5108)] = 342693,
  [SMALL_STATE(5109)] = 342782,
  [SMALL_STATE(5110)] = 342831,
  [SMALL_STATE(5111)] = 342920,
  [SMALL_STATE(5112)] = 343009,
  [SMALL_STATE(5113)] = 343098,
  [SMALL_STATE(5114)] = 343187,
  [SMALL_STATE(5115)] = 343276,
  [SMALL_STATE(5116)] = 343365,
  [SMALL_STATE(5117)] = 343454,
  [SMALL_STATE(5118)] = 343543,
  [SMALL_STATE(5119)] = 343632,
  [SMALL_STATE(5120)] = 343689,
  [SMALL_STATE(5121)] = 343734,
  [SMALL_STATE(5122)] = 343779,
  [SMALL_STATE(5123)] = 343824,
  [SMALL_STATE(5124)] = 343869,
  [SMALL_STATE(5125)] = 343914,
  [SMALL_STATE(5126)] = 343959,
  [SMALL_STATE(5127)] = 344004,
  [SMALL_STATE(5128)] = 344093,
  [SMALL_STATE(5129)] = 344142,
  [SMALL_STATE(5130)] = 344187,
  [SMALL_STATE(5131)] = 344276,
  [SMALL_STATE(5132)] = 344321,
  [SMALL_STATE(5133)] = 344372,
  [SMALL_STATE(5134)] = 344417,
  [SMALL_STATE(5135)] = 344462,
  [SMALL_STATE(5136)] = 344507,
  [SMALL_STATE(5137)] = 344552,
  [SMALL_STATE(5138)] = 344597,
  [SMALL_STATE(5139)] = 344642,
  [SMALL_STATE(5140)] = 344687,
  [SMALL_STATE(5141)] = 344732,
  [SMALL_STATE(5142)] = 344821,
  [SMALL_STATE(5143)] = 344910,
  [SMALL_STATE(5144)] = 344955,
  [SMALL_STATE(5145)] = 345044,
  [SMALL_STATE(5146)] = 345089,
  [SMALL_STATE(5147)] = 345178,
  [SMALL_STATE(5148)] = 345223,
  [SMALL_STATE(5149)] = 345312,
  [SMALL_STATE(5150)] = 345357,
  [SMALL_STATE(5151)] = 345446,
  [SMALL_STATE(5152)] = 345533,
  [SMALL_STATE(5153)] = 345578,
  [SMALL_STATE(5154)] = 345623,
  [SMALL_STATE(5155)] = 345712,
  [SMALL_STATE(5156)] = 345763,
  [SMALL_STATE(5157)] = 345852,
  [SMALL_STATE(5158)] = 345941,
  [SMALL_STATE(5159)] = 346030,
  [SMALL_STATE(5160)] = 346081,
  [SMALL_STATE(5161)] = 346126,
  [SMALL_STATE(5162)] = 346171,
  [SMALL_STATE(5163)] = 346260,
  [SMALL_STATE(5164)] = 346305,
  [SMALL_STATE(5165)] = 346394,
  [SMALL_STATE(5166)] = 346439,
  [SMALL_STATE(5167)] = 346484,
  [SMALL_STATE(5168)] = 346529,
  [SMALL_STATE(5169)] = 346574,
  [SMALL_STATE(5170)] = 346621,
  [SMALL_STATE(5171)] = 346666,
  [SMALL_STATE(5172)] = 346755,
  [SMALL_STATE(5173)] = 346800,
  [SMALL_STATE(5174)] = 346845,
  [SMALL_STATE(5175)] = 346890,
  [SMALL_STATE(5176)] = 346935,
  [SMALL_STATE(5177)] = 346980,
  [SMALL_STATE(5178)] = 347025,
  [SMALL_STATE(5179)] = 347070,
  [SMALL_STATE(5180)] = 347115,
  [SMALL_STATE(5181)] = 347160,
  [SMALL_STATE(5182)] = 347205,
  [SMALL_STATE(5183)] = 347250,
  [SMALL_STATE(5184)] = 347295,
  [SMALL_STATE(5185)] = 347340,
  [SMALL_STATE(5186)] = 347385,
  [SMALL_STATE(5187)] = 347430,
  [SMALL_STATE(5188)] = 347475,
  [SMALL_STATE(5189)] = 347564,
  [SMALL_STATE(5190)] = 347615,
  [SMALL_STATE(5191)] = 347666,
  [SMALL_STATE(5192)] = 347717,
  [SMALL_STATE(5193)] = 347768,
  [SMALL_STATE(5194)] = 347813,
  [SMALL_STATE(5195)] = 347858,
  [SMALL_STATE(5196)] = 347947,
  [SMALL_STATE(5197)] = 347992,
  [SMALL_STATE(5198)] = 348081,
  [SMALL_STATE(5199)] = 348126,
  [SMALL_STATE(5200)] = 348213,
  [SMALL_STATE(5201)] = 348302,
  [SMALL_STATE(5202)] = 348347,
  [SMALL_STATE(5203)] = 348392,
  [SMALL_STATE(5204)] = 348447,
  [SMALL_STATE(5205)] = 348492,
  [SMALL_STATE(5206)] = 348537,
  [SMALL_STATE(5207)] = 348582,
  [SMALL_STATE(5208)] = 348627,
  [SMALL_STATE(5209)] = 348716,
  [SMALL_STATE(5210)] = 348761,
  [SMALL_STATE(5211)] = 348850,
  [SMALL_STATE(5212)] = 348895,
  [SMALL_STATE(5213)] = 348940,
  [SMALL_STATE(5214)] = 348985,
  [SMALL_STATE(5215)] = 349030,
  [SMALL_STATE(5216)] = 349075,
  [SMALL_STATE(5217)] = 349162,
  [SMALL_STATE(5218)] = 349207,
  [SMALL_STATE(5219)] = 349252,
  [SMALL_STATE(5220)] = 349297,
  [SMALL_STATE(5221)] = 349342,
  [SMALL_STATE(5222)] = 349387,
  [SMALL_STATE(5223)] = 349432,
  [SMALL_STATE(5224)] = 349477,
  [SMALL_STATE(5225)] = 349566,
  [SMALL_STATE(5226)] = 349611,
  [SMALL_STATE(5227)] = 349700,
  [SMALL_STATE(5228)] = 349745,
  [SMALL_STATE(5229)] = 349790,
  [SMALL_STATE(5230)] = 349835,
  [SMALL_STATE(5231)] = 349922,
  [SMALL_STATE(5232)] = 349967,
  [SMALL_STATE(5233)] = 350012,
  [SMALL_STATE(5234)] = 350057,
  [SMALL_STATE(5235)] = 350102,
  [SMALL_STATE(5236)] = 350147,
  [SMALL_STATE(5237)] = 350192,
  [SMALL_STATE(5238)] = 350237,
  [SMALL_STATE(5239)] = 350282,
  [SMALL_STATE(5240)] = 350327,
  [SMALL_STATE(5241)] = 350372,
  [SMALL_STATE(5242)] = 350459,
  [SMALL_STATE(5243)] = 350504,
  [SMALL_STATE(5244)] = 350591,
  [SMALL_STATE(5245)] = 350636,
  [SMALL_STATE(5246)] = 350683,
  [SMALL_STATE(5247)] = 350728,
  [SMALL_STATE(5248)] = 350773,
  [SMALL_STATE(5249)] = 350818,
  [SMALL_STATE(5250)] = 350867,
  [SMALL_STATE(5251)] = 350956,
  [SMALL_STATE(5252)] = 351001,
  [SMALL_STATE(5253)] = 351046,
  [SMALL_STATE(5254)] = 351091,
  [SMALL_STATE(5255)] = 351136,
  [SMALL_STATE(5256)] = 351181,
  [SMALL_STATE(5257)] = 351226,
  [SMALL_STATE(5258)] = 351271,
  [SMALL_STATE(5259)] = 351316,
  [SMALL_STATE(5260)] = 351405,
  [SMALL_STATE(5261)] = 351450,
  [SMALL_STATE(5262)] = 351495,
  [SMALL_STATE(5263)] = 351540,
  [SMALL_STATE(5264)] = 351585,
  [SMALL_STATE(5265)] = 351630,
  [SMALL_STATE(5266)] = 351675,
  [SMALL_STATE(5267)] = 351762,
  [SMALL_STATE(5268)] = 351807,
  [SMALL_STATE(5269)] = 351852,
  [SMALL_STATE(5270)] = 351939,
  [SMALL_STATE(5271)] = 351984,
  [SMALL_STATE(5272)] = 352029,
  [SMALL_STATE(5273)] = 352074,
  [SMALL_STATE(5274)] = 352119,
  [SMALL_STATE(5275)] = 352164,
  [SMALL_STATE(5276)] = 352209,
  [SMALL_STATE(5277)] = 352254,
  [SMALL_STATE(5278)] = 352299,
  [SMALL_STATE(5279)] = 352344,
  [SMALL_STATE(5280)] = 352389,
  [SMALL_STATE(5281)] = 352434,
  [SMALL_STATE(5282)] = 352523,
  [SMALL_STATE(5283)] = 352568,
  [SMALL_STATE(5284)] = 352613,
  [SMALL_STATE(5285)] = 352658,
  [SMALL_STATE(5286)] = 352703,
  [SMALL_STATE(5287)] = 352748,
  [SMALL_STATE(5288)] = 352793,
  [SMALL_STATE(5289)] = 352838,
  [SMALL_STATE(5290)] = 352883,
  [SMALL_STATE(5291)] = 352928,
  [SMALL_STATE(5292)] = 353017,
  [SMALL_STATE(5293)] = 353062,
  [SMALL_STATE(5294)] = 353113,
  [SMALL_STATE(5295)] = 353158,
  [SMALL_STATE(5296)] = 353203,
  [SMALL_STATE(5297)] = 353292,
  [SMALL_STATE(5298)] = 353337,
  [SMALL_STATE(5299)] = 353382,
  [SMALL_STATE(5300)] = 353427,
  [SMALL_STATE(5301)] = 353516,
  [SMALL_STATE(5302)] = 353561,
  [SMALL_STATE(5303)] = 353648,
  [SMALL_STATE(5304)] = 353699,
  [SMALL_STATE(5305)] = 353750,
  [SMALL_STATE(5306)] = 353801,
  [SMALL_STATE(5307)] = 353852,
  [SMALL_STATE(5308)] = 353903,
  [SMALL_STATE(5309)] = 353954,
  [SMALL_STATE(5310)] = 353999,
  [SMALL_STATE(5311)] = 354044,
  [SMALL_STATE(5312)] = 354089,
  [SMALL_STATE(5313)] = 354176,
  [SMALL_STATE(5314)] = 354221,
  [SMALL_STATE(5315)] = 354266,
  [SMALL_STATE(5316)] = 354311,
  [SMALL_STATE(5317)] = 354356,
  [SMALL_STATE(5318)] = 354401,
  [SMALL_STATE(5319)] = 354490,
  [SMALL_STATE(5320)] = 354535,
  [SMALL_STATE(5321)] = 354624,
  [SMALL_STATE(5322)] = 354669,
  [SMALL_STATE(5323)] = 354714,
  [SMALL_STATE(5324)] = 354759,
  [SMALL_STATE(5325)] = 354846,
  [SMALL_STATE(5326)] = 354933,
  [SMALL_STATE(5327)] = 355020,
  [SMALL_STATE(5328)] = 355107,
  [SMALL_STATE(5329)] = 355152,
  [SMALL_STATE(5330)] = 355197,
  [SMALL_STATE(5331)] = 355246,
  [SMALL_STATE(5332)] = 355335,
  [SMALL_STATE(5333)] = 355380,
  [SMALL_STATE(5334)] = 355469,
  [SMALL_STATE(5335)] = 355516,
  [SMALL_STATE(5336)] = 355563,
  [SMALL_STATE(5337)] = 355652,
  [SMALL_STATE(5338)] = 355697,
  [SMALL_STATE(5339)] = 355746,
  [SMALL_STATE(5340)] = 355793,
  [SMALL_STATE(5341)] = 355838,
  [SMALL_STATE(5342)] = 355883,
  [SMALL_STATE(5343)] = 355928,
  [SMALL_STATE(5344)] = 355979,
  [SMALL_STATE(5345)] = 356026,
  [SMALL_STATE(5346)] = 356071,
  [SMALL_STATE(5347)] = 356118,
  [SMALL_STATE(5348)] = 356207,
  [SMALL_STATE(5349)] = 356254,
  [SMALL_STATE(5350)] = 356305,
  [SMALL_STATE(5351)] = 356390,
  [SMALL_STATE(5352)] = 356435,
  [SMALL_STATE(5353)] = 356484,
  [SMALL_STATE(5354)] = 356573,
  [SMALL_STATE(5355)] = 356620,
  [SMALL_STATE(5356)] = 356667,
  [SMALL_STATE(5357)] = 356756,
  [SMALL_STATE(5358)] = 356845,
  [SMALL_STATE(5359)] = 356934,
  [SMALL_STATE(5360)] = 357019,
  [SMALL_STATE(5361)] = 357064,
  [SMALL_STATE(5362)] = 357109,
  [SMALL_STATE(5363)] = 357156,
  [SMALL_STATE(5364)] = 357203,
  [SMALL_STATE(5365)] = 357250,
  [SMALL_STATE(5366)] = 357335,
  [SMALL_STATE(5367)] = 357382,
  [SMALL_STATE(5368)] = 357429,
  [SMALL_STATE(5369)] = 357476,
  [SMALL_STATE(5370)] = 357523,
  [SMALL_STATE(5371)] = 357570,
  [SMALL_STATE(5372)] = 357617,
  [SMALL_STATE(5373)] = 357702,
  [SMALL_STATE(5374)] = 357749,
  [SMALL_STATE(5375)] = 357796,
  [SMALL_STATE(5376)] = 357843,
  [SMALL_STATE(5377)] = 357890,
  [SMALL_STATE(5378)] = 357975,
  [SMALL_STATE(5379)] = 358022,
  [SMALL_STATE(5380)] = 358069,
  [SMALL_STATE(5381)] = 358116,
  [SMALL_STATE(5382)] = 358165,
  [SMALL_STATE(5383)] = 358210,
  [SMALL_STATE(5384)] = 358255,
  [SMALL_STATE(5385)] = 358300,
  [SMALL_STATE(5386)] = 358347,
  [SMALL_STATE(5387)] = 358434,
  [SMALL_STATE(5388)] = 358481,
  [SMALL_STATE(5389)] = 358532,
  [SMALL_STATE(5390)] = 358577,
  [SMALL_STATE(5391)] = 358622,
  [SMALL_STATE(5392)] = 358669,
  [SMALL_STATE(5393)] = 358758,
  [SMALL_STATE(5394)] = 358803,
  [SMALL_STATE(5395)] = 358892,
  [SMALL_STATE(5396)] = 358981,
  [SMALL_STATE(5397)] = 359026,
  [SMALL_STATE(5398)] = 359115,
  [SMALL_STATE(5399)] = 359164,
  [SMALL_STATE(5400)] = 359249,
  [SMALL_STATE(5401)] = 359296,
  [SMALL_STATE(5402)] = 359343,
  [SMALL_STATE(5403)] = 359430,
  [SMALL_STATE(5404)] = 359477,
  [SMALL_STATE(5405)] = 359566,
  [SMALL_STATE(5406)] = 359613,
  [SMALL_STATE(5407)] = 359658,
  [SMALL_STATE(5408)] = 359709,
  [SMALL_STATE(5409)] = 359760,
  [SMALL_STATE(5410)] = 359807,
  [SMALL_STATE(5411)] = 359896,
  [SMALL_STATE(5412)] = 359943,
  [SMALL_STATE(5413)] = 359990,
  [SMALL_STATE(5414)] = 360035,
  [SMALL_STATE(5415)] = 360120,
  [SMALL_STATE(5416)] = 360167,
  [SMALL_STATE(5417)] = 360214,
  [SMALL_STATE(5418)] = 360261,
  [SMALL_STATE(5419)] = 360308,
  [SMALL_STATE(5420)] = 360359,
  [SMALL_STATE(5421)] = 360406,
  [SMALL_STATE(5422)] = 360453,
  [SMALL_STATE(5423)] = 360500,
  [SMALL_STATE(5424)] = 360547,
  [SMALL_STATE(5425)] = 360636,
  [SMALL_STATE(5426)] = 360725,
  [SMALL_STATE(5427)] = 360772,
  [SMALL_STATE(5428)] = 360819,
  [SMALL_STATE(5429)] = 360866,
  [SMALL_STATE(5430)] = 360917,
  [SMALL_STATE(5431)] = 360968,
  [SMALL_STATE(5432)] = 361057,
  [SMALL_STATE(5433)] = 361102,
  [SMALL_STATE(5434)] = 361149,
  [SMALL_STATE(5435)] = 361196,
  [SMALL_STATE(5436)] = 361243,
  [SMALL_STATE(5437)] = 361332,
  [SMALL_STATE(5438)] = 361385,
  [SMALL_STATE(5439)] = 361470,
  [SMALL_STATE(5440)] = 361555,
  [SMALL_STATE(5441)] = 361644,
  [SMALL_STATE(5442)] = 361733,
  [SMALL_STATE(5443)] = 361780,
  [SMALL_STATE(5444)] = 361827,
  [SMALL_STATE(5445)] = 361874,
  [SMALL_STATE(5446)] = 361921,
  [SMALL_STATE(5447)] = 362010,
  [SMALL_STATE(5448)] = 362057,
  [SMALL_STATE(5449)] = 362104,
  [SMALL_STATE(5450)] = 362151,
  [SMALL_STATE(5451)] = 362240,
  [SMALL_STATE(5452)] = 362287,
  [SMALL_STATE(5453)] = 362374,
  [SMALL_STATE(5454)] = 362463,
  [SMALL_STATE(5455)] = 362510,
  [SMALL_STATE(5456)] = 362597,
  [SMALL_STATE(5457)] = 362644,
  [SMALL_STATE(5458)] = 362691,
  [SMALL_STATE(5459)] = 362738,
  [SMALL_STATE(5460)] = 362785,
  [SMALL_STATE(5461)] = 362832,
  [SMALL_STATE(5462)] = 362879,
  [SMALL_STATE(5463)] = 362926,
  [SMALL_STATE(5464)] = 362979,
  [SMALL_STATE(5465)] = 363026,
  [SMALL_STATE(5466)] = 363073,
  [SMALL_STATE(5467)] = 363120,
  [SMALL_STATE(5468)] = 363167,
  [SMALL_STATE(5469)] = 363214,
  [SMALL_STATE(5470)] = 363261,
  [SMALL_STATE(5471)] = 363308,
  [SMALL_STATE(5472)] = 363361,
  [SMALL_STATE(5473)] = 363408,
  [SMALL_STATE(5474)] = 363453,
  [SMALL_STATE(5475)] = 363542,
  [SMALL_STATE(5476)] = 363631,
  [SMALL_STATE(5477)] = 363717,
  [SMALL_STATE(5478)] = 363803,
  [SMALL_STATE(5479)] = 363851,
  [SMALL_STATE(5480)] = 363895,
  [SMALL_STATE(5481)] = 363939,
  [SMALL_STATE(5482)] = 363983,
  [SMALL_STATE(5483)] = 364027,
  [SMALL_STATE(5484)] = 364071,
  [SMALL_STATE(5485)] = 364115,
  [SMALL_STATE(5486)] = 364159,
  [SMALL_STATE(5487)] = 364207,
  [SMALL_STATE(5488)] = 364251,
  [SMALL_STATE(5489)] = 364337,
  [SMALL_STATE(5490)] = 364423,
  [SMALL_STATE(5491)] = 364467,
  [SMALL_STATE(5492)] = 364511,
  [SMALL_STATE(5493)] = 364555,
  [SMALL_STATE(5494)] = 364641,
  [SMALL_STATE(5495)] = 364687,
  [SMALL_STATE(5496)] = 364731,
  [SMALL_STATE(5497)] = 364775,
  [SMALL_STATE(5498)] = 364819,
  [SMALL_STATE(5499)] = 364863,
  [SMALL_STATE(5500)] = 364949,
  [SMALL_STATE(5501)] = 364993,
  [SMALL_STATE(5502)] = 365037,
  [SMALL_STATE(5503)] = 365081,
  [SMALL_STATE(5504)] = 365127,
  [SMALL_STATE(5505)] = 365171,
  [SMALL_STATE(5506)] = 365217,
  [SMALL_STATE(5507)] = 365261,
  [SMALL_STATE(5508)] = 365305,
  [SMALL_STATE(5509)] = 365349,
  [SMALL_STATE(5510)] = 365393,
  [SMALL_STATE(5511)] = 365441,
  [SMALL_STATE(5512)] = 365485,
  [SMALL_STATE(5513)] = 365529,
  [SMALL_STATE(5514)] = 365573,
  [SMALL_STATE(5515)] = 365617,
  [SMALL_STATE(5516)] = 365661,
  [SMALL_STATE(5517)] = 365705,
  [SMALL_STATE(5518)] = 365751,
  [SMALL_STATE(5519)] = 365795,
  [SMALL_STATE(5520)] = 365839,
  [SMALL_STATE(5521)] = 365883,
  [SMALL_STATE(5522)] = 365927,
  [SMALL_STATE(5523)] = 365971,
  [SMALL_STATE(5524)] = 366019,
  [SMALL_STATE(5525)] = 366063,
  [SMALL_STATE(5526)] = 366107,
  [SMALL_STATE(5527)] = 366151,
  [SMALL_STATE(5528)] = 366195,
  [SMALL_STATE(5529)] = 366239,
  [SMALL_STATE(5530)] = 366283,
  [SMALL_STATE(5531)] = 366327,
  [SMALL_STATE(5532)] = 366371,
  [SMALL_STATE(5533)] = 366425,
  [SMALL_STATE(5534)] = 366469,
  [SMALL_STATE(5535)] = 366513,
  [SMALL_STATE(5536)] = 366557,
  [SMALL_STATE(5537)] = 366643,
  [SMALL_STATE(5538)] = 366687,
  [SMALL_STATE(5539)] = 366731,
  [SMALL_STATE(5540)] = 366775,
  [SMALL_STATE(5541)] = 366819,
  [SMALL_STATE(5542)] = 366905,
  [SMALL_STATE(5543)] = 366949,
  [SMALL_STATE(5544)] = 366993,
  [SMALL_STATE(5545)] = 367039,
  [SMALL_STATE(5546)] = 367083,
  [SMALL_STATE(5547)] = 367131,
  [SMALL_STATE(5548)] = 367179,
  [SMALL_STATE(5549)] = 367223,
  [SMALL_STATE(5550)] = 367267,
  [SMALL_STATE(5551)] = 367311,
  [SMALL_STATE(5552)] = 367355,
  [SMALL_STATE(5553)] = 367399,
  [SMALL_STATE(5554)] = 367443,
  [SMALL_STATE(5555)] = 367491,
  [SMALL_STATE(5556)] = 367535,
  [SMALL_STATE(5557)] = 367579,
  [SMALL_STATE(5558)] = 367623,
  [SMALL_STATE(5559)] = 367667,
  [SMALL_STATE(5560)] = 367711,
  [SMALL_STATE(5561)] = 367755,
  [SMALL_STATE(5562)] = 367799,
  [SMALL_STATE(5563)] = 367843,
  [SMALL_STATE(5564)] = 367889,
  [SMALL_STATE(5565)] = 367937,
  [SMALL_STATE(5566)] = 367981,
  [SMALL_STATE(5567)] = 368025,
  [SMALL_STATE(5568)] = 368069,
  [SMALL_STATE(5569)] = 368113,
  [SMALL_STATE(5570)] = 368157,
  [SMALL_STATE(5571)] = 368201,
  [SMALL_STATE(5572)] = 368287,
  [SMALL_STATE(5573)] = 368331,
  [SMALL_STATE(5574)] = 368379,
  [SMALL_STATE(5575)] = 368423,
  [SMALL_STATE(5576)] = 368471,
  [SMALL_STATE(5577)] = 368557,
  [SMALL_STATE(5578)] = 368601,
  [SMALL_STATE(5579)] = 368645,
  [SMALL_STATE(5580)] = 368689,
  [SMALL_STATE(5581)] = 368733,
  [SMALL_STATE(5582)] = 368777,
  [SMALL_STATE(5583)] = 368821,
  [SMALL_STATE(5584)] = 368865,
  [SMALL_STATE(5585)] = 368951,
  [SMALL_STATE(5586)] = 368995,
  [SMALL_STATE(5587)] = 369043,
  [SMALL_STATE(5588)] = 369087,
  [SMALL_STATE(5589)] = 369131,
  [SMALL_STATE(5590)] = 369179,
  [SMALL_STATE(5591)] = 369227,
  [SMALL_STATE(5592)] = 369275,
  [SMALL_STATE(5593)] = 369361,
  [SMALL_STATE(5594)] = 369409,
  [SMALL_STATE(5595)] = 369493,
  [SMALL_STATE(5596)] = 369537,
  [SMALL_STATE(5597)] = 369581,
  [SMALL_STATE(5598)] = 369625,
  [SMALL_STATE(5599)] = 369669,
  [SMALL_STATE(5600)] = 369713,
  [SMALL_STATE(5601)] = 369757,
  [SMALL_STATE(5602)] = 369801,
  [SMALL_STATE(5603)] = 369845,
  [SMALL_STATE(5604)] = 369931,
  [SMALL_STATE(5605)] = 369975,
  [SMALL_STATE(5606)] = 370023,
  [SMALL_STATE(5607)] = 370071,
  [SMALL_STATE(5608)] = 370115,
  [SMALL_STATE(5609)] = 370163,
  [SMALL_STATE(5610)] = 370207,
  [SMALL_STATE(5611)] = 370291,
  [SMALL_STATE(5612)] = 370335,
  [SMALL_STATE(5613)] = 370383,
  [SMALL_STATE(5614)] = 370427,
  [SMALL_STATE(5615)] = 370475,
  [SMALL_STATE(5616)] = 370519,
  [SMALL_STATE(5617)] = 370567,
  [SMALL_STATE(5618)] = 370611,
  [SMALL_STATE(5619)] = 370655,
  [SMALL_STATE(5620)] = 370699,
  [SMALL_STATE(5621)] = 370743,
  [SMALL_STATE(5622)] = 370787,
  [SMALL_STATE(5623)] = 370831,
  [SMALL_STATE(5624)] = 370875,
  [SMALL_STATE(5625)] = 370919,
  [SMALL_STATE(5626)] = 370967,
  [SMALL_STATE(5627)] = 371015,
  [SMALL_STATE(5628)] = 371061,
  [SMALL_STATE(5629)] = 371105,
  [SMALL_STATE(5630)] = 371149,
  [SMALL_STATE(5631)] = 371193,
  [SMALL_STATE(5632)] = 371237,
  [SMALL_STATE(5633)] = 371321,
  [SMALL_STATE(5634)] = 371365,
  [SMALL_STATE(5635)] = 371409,
  [SMALL_STATE(5636)] = 371453,
  [SMALL_STATE(5637)] = 371497,
  [SMALL_STATE(5638)] = 371545,
  [SMALL_STATE(5639)] = 371589,
  [SMALL_STATE(5640)] = 371633,
  [SMALL_STATE(5641)] = 371687,
  [SMALL_STATE(5642)] = 371731,
  [SMALL_STATE(5643)] = 371775,
  [SMALL_STATE(5644)] = 371819,
  [SMALL_STATE(5645)] = 371863,
  [SMALL_STATE(5646)] = 371907,
  [SMALL_STATE(5647)] = 371951,
  [SMALL_STATE(5648)] = 371995,
  [SMALL_STATE(5649)] = 372039,
  [SMALL_STATE(5650)] = 372083,
  [SMALL_STATE(5651)] = 372127,
  [SMALL_STATE(5652)] = 372171,
  [SMALL_STATE(5653)] = 372215,
  [SMALL_STATE(5654)] = 372259,
  [SMALL_STATE(5655)] = 372303,
  [SMALL_STATE(5656)] = 372347,
  [SMALL_STATE(5657)] = 372395,
  [SMALL_STATE(5658)] = 372443,
  [SMALL_STATE(5659)] = 372487,
  [SMALL_STATE(5660)] = 372535,
  [SMALL_STATE(5661)] = 372579,
  [SMALL_STATE(5662)] = 372663,
  [SMALL_STATE(5663)] = 372711,
  [SMALL_STATE(5664)] = 372755,
  [SMALL_STATE(5665)] = 372803,
  [SMALL_STATE(5666)] = 372851,
  [SMALL_STATE(5667)] = 372895,
  [SMALL_STATE(5668)] = 372939,
  [SMALL_STATE(5669)] = 372983,
  [SMALL_STATE(5670)] = 373027,
  [SMALL_STATE(5671)] = 373071,
  [SMALL_STATE(5672)] = 373115,
  [SMALL_STATE(5673)] = 373199,
  [SMALL_STATE(5674)] = 373247,
  [SMALL_STATE(5675)] = 373291,
  [SMALL_STATE(5676)] = 373335,
  [SMALL_STATE(5677)] = 373379,
  [SMALL_STATE(5678)] = 373465,
  [SMALL_STATE(5679)] = 373509,
  [SMALL_STATE(5680)] = 373553,
  [SMALL_STATE(5681)] = 373597,
  [SMALL_STATE(5682)] = 373641,
  [SMALL_STATE(5683)] = 373685,
  [SMALL_STATE(5684)] = 373729,
  [SMALL_STATE(5685)] = 373773,
  [SMALL_STATE(5686)] = 373817,
  [SMALL_STATE(5687)] = 373861,
  [SMALL_STATE(5688)] = 373905,
  [SMALL_STATE(5689)] = 373949,
  [SMALL_STATE(5690)] = 373993,
  [SMALL_STATE(5691)] = 374037,
  [SMALL_STATE(5692)] = 374121,
  [SMALL_STATE(5693)] = 374169,
  [SMALL_STATE(5694)] = 374255,
  [SMALL_STATE(5695)] = 374299,
  [SMALL_STATE(5696)] = 374383,
  [SMALL_STATE(5697)] = 374427,
  [SMALL_STATE(5698)] = 374471,
  [SMALL_STATE(5699)] = 374515,
  [SMALL_STATE(5700)] = 374559,
  [SMALL_STATE(5701)] = 374603,
  [SMALL_STATE(5702)] = 374647,
  [SMALL_STATE(5703)] = 374691,
  [SMALL_STATE(5704)] = 374735,
  [SMALL_STATE(5705)] = 374779,
  [SMALL_STATE(5706)] = 374823,
  [SMALL_STATE(5707)] = 374867,
  [SMALL_STATE(5708)] = 374911,
  [SMALL_STATE(5709)] = 374995,
  [SMALL_STATE(5710)] = 375039,
  [SMALL_STATE(5711)] = 375083,
  [SMALL_STATE(5712)] = 375127,
  [SMALL_STATE(5713)] = 375171,
  [SMALL_STATE(5714)] = 375215,
  [SMALL_STATE(5715)] = 375263,
  [SMALL_STATE(5716)] = 375311,
  [SMALL_STATE(5717)] = 375355,
  [SMALL_STATE(5718)] = 375399,
  [SMALL_STATE(5719)] = 375443,
  [SMALL_STATE(5720)] = 375491,
  [SMALL_STATE(5721)] = 375537,
  [SMALL_STATE(5722)] = 375585,
  [SMALL_STATE(5723)] = 375629,
  [SMALL_STATE(5724)] = 375673,
  [SMALL_STATE(5725)] = 375757,
  [SMALL_STATE(5726)] = 375801,
  [SMALL_STATE(5727)] = 375845,
  [SMALL_STATE(5728)] = 375891,
  [SMALL_STATE(5729)] = 375939,
  [SMALL_STATE(5730)] = 375983,
  [SMALL_STATE(5731)] = 376029,
  [SMALL_STATE(5732)] = 376077,
  [SMALL_STATE(5733)] = 376121,
  [SMALL_STATE(5734)] = 376165,
  [SMALL_STATE(5735)] = 376249,
  [SMALL_STATE(5736)] = 376293,
  [SMALL_STATE(5737)] = 376337,
  [SMALL_STATE(5738)] = 376381,
  [SMALL_STATE(5739)] = 376425,
  [SMALL_STATE(5740)] = 376509,
  [SMALL_STATE(5741)] = 376553,
  [SMALL_STATE(5742)] = 376597,
  [SMALL_STATE(5743)] = 376641,
  [SMALL_STATE(5744)] = 376685,
  [SMALL_STATE(5745)] = 376771,
  [SMALL_STATE(5746)] = 376857,
  [SMALL_STATE(5747)] = 376901,
  [SMALL_STATE(5748)] = 376985,
  [SMALL_STATE(5749)] = 377029,
  [SMALL_STATE(5750)] = 377073,
  [SMALL_STATE(5751)] = 377117,
  [SMALL_STATE(5752)] = 377203,
  [SMALL_STATE(5753)] = 377251,
  [SMALL_STATE(5754)] = 377335,
  [SMALL_STATE(5755)] = 377419,
  [SMALL_STATE(5756)] = 377503,
  [SMALL_STATE(5757)] = 377550,
  [SMALL_STATE(5758)] = 377633,
  [SMALL_STATE(5759)] = 377716,
  [SMALL_STATE(5760)] = 377761,
  [SMALL_STATE(5761)] = 377806,
  [SMALL_STATE(5762)] = 377853,
  [SMALL_STATE(5763)] = 377898,
  [SMALL_STATE(5764)] = 377943,
  [SMALL_STATE(5765)] = 378026,
  [SMALL_STATE(5766)] = 378109,
  [SMALL_STATE(5767)] = 378154,
  [SMALL_STATE(5768)] = 378199,
  [SMALL_STATE(5769)] = 378244,
  [SMALL_STATE(5770)] = 378289,
  [SMALL_STATE(5771)] = 378334,
  [SMALL_STATE(5772)] = 378377,
  [SMALL_STATE(5773)] = 378422,
  [SMALL_STATE(5774)] = 378467,
  [SMALL_STATE(5775)] = 378550,
  [SMALL_STATE(5776)] = 378597,
  [SMALL_STATE(5777)] = 378642,
  [SMALL_STATE(5778)] = 378687,
  [SMALL_STATE(5779)] = 378770,
  [SMALL_STATE(5780)] = 378815,
  [SMALL_STATE(5781)] = 378898,
  [SMALL_STATE(5782)] = 378943,
  [SMALL_STATE(5783)] = 379026,
  [SMALL_STATE(5784)] = 379071,
  [SMALL_STATE(5785)] = 379116,
  [SMALL_STATE(5786)] = 379163,
  [SMALL_STATE(5787)] = 379210,
  [SMALL_STATE(5788)] = 379259,
  [SMALL_STATE(5789)] = 379306,
  [SMALL_STATE(5790)] = 379351,
  [SMALL_STATE(5791)] = 379398,
  [SMALL_STATE(5792)] = 379443,
  [SMALL_STATE(5793)] = 379488,
  [SMALL_STATE(5794)] = 379533,
  [SMALL_STATE(5795)] = 379576,
  [SMALL_STATE(5796)] = 379659,
  [SMALL_STATE(5797)] = 379702,
  [SMALL_STATE(5798)] = 379747,
  [SMALL_STATE(5799)] = 379790,
  [SMALL_STATE(5800)] = 379835,
  [SMALL_STATE(5801)] = 379918,
  [SMALL_STATE(5802)] = 379963,
  [SMALL_STATE(5803)] = 380046,
  [SMALL_STATE(5804)] = 380129,
  [SMALL_STATE(5805)] = 380172,
  [SMALL_STATE(5806)] = 380215,
  [SMALL_STATE(5807)] = 380260,
  [SMALL_STATE(5808)] = 380307,
  [SMALL_STATE(5809)] = 380352,
  [SMALL_STATE(5810)] = 380397,
  [SMALL_STATE(5811)] = 380442,
  [SMALL_STATE(5812)] = 380485,
  [SMALL_STATE(5813)] = 380568,
  [SMALL_STATE(5814)] = 380615,
  [SMALL_STATE(5815)] = 380660,
  [SMALL_STATE(5816)] = 380707,
  [SMALL_STATE(5817)] = 380754,
  [SMALL_STATE(5818)] = 380801,
  [SMALL_STATE(5819)] = 380850,
  [SMALL_STATE(5820)] = 380933,
  [SMALL_STATE(5821)] = 381016,
  [SMALL_STATE(5822)] = 381099,
  [SMALL_STATE(5823)] = 381142,
  [SMALL_STATE(5824)] = 381185,
  [SMALL_STATE(5825)] = 381268,
  [SMALL_STATE(5826)] = 381315,
  [SMALL_STATE(5827)] = 381398,
  [SMALL_STATE(5828)] = 381443,
  [SMALL_STATE(5829)] = 381488,
  [SMALL_STATE(5830)] = 381535,
  [SMALL_STATE(5831)] = 381580,
  [SMALL_STATE(5832)] = 381625,
  [SMALL_STATE(5833)] = 381668,
  [SMALL_STATE(5834)] = 381713,
  [SMALL_STATE(5835)] = 381758,
  [SMALL_STATE(5836)] = 381801,
  [SMALL_STATE(5837)] = 381846,
  [SMALL_STATE(5838)] = 381929,
  [SMALL_STATE(5839)] = 381974,
  [SMALL_STATE(5840)] = 382019,
  [SMALL_STATE(5841)] = 382064,
  [SMALL_STATE(5842)] = 382107,
  [SMALL_STATE(5843)] = 382190,
  [SMALL_STATE(5844)] = 382273,
  [SMALL_STATE(5845)] = 382318,
  [SMALL_STATE(5846)] = 382363,
  [SMALL_STATE(5847)] = 382446,
  [SMALL_STATE(5848)] = 382529,
  [SMALL_STATE(5849)] = 382572,
  [SMALL_STATE(5850)] = 382655,
  [SMALL_STATE(5851)] = 382700,
  [SMALL_STATE(5852)] = 382783,
  [SMALL_STATE(5853)] = 382828,
  [SMALL_STATE(5854)] = 382875,
  [SMALL_STATE(5855)] = 382922,
  [SMALL_STATE(5856)] = 383005,
  [SMALL_STATE(5857)] = 383088,
  [SMALL_STATE(5858)] = 383171,
  [SMALL_STATE(5859)] = 383254,
  [SMALL_STATE(5860)] = 383299,
  [SMALL_STATE(5861)] = 383344,
  [SMALL_STATE(5862)] = 383389,
  [SMALL_STATE(5863)] = 383472,
  [SMALL_STATE(5864)] = 383517,
  [SMALL_STATE(5865)] = 383560,
  [SMALL_STATE(5866)] = 383643,
  [SMALL_STATE(5867)] = 383726,
  [SMALL_STATE(5868)] = 383809,
  [SMALL_STATE(5869)] = 383852,
  [SMALL_STATE(5870)] = 383935,
  [SMALL_STATE(5871)] = 383982,
  [SMALL_STATE(5872)] = 384065,
  [SMALL_STATE(5873)] = 384148,
  [SMALL_STATE(5874)] = 384193,
  [SMALL_STATE(5875)] = 384276,
  [SMALL_STATE(5876)] = 384321,
  [SMALL_STATE(5877)] = 384364,
  [SMALL_STATE(5878)] = 384411,
  [SMALL_STATE(5879)] = 384458,
  [SMALL_STATE(5880)] = 384541,
  [SMALL_STATE(5881)] = 384624,
  [SMALL_STATE(5882)] = 384707,
  [SMALL_STATE(5883)] = 384790,
  [SMALL_STATE(5884)] = 384873,
  [SMALL_STATE(5885)] = 384956,
  [SMALL_STATE(5886)] = 385039,
  [SMALL_STATE(5887)] = 385122,
  [SMALL_STATE(5888)] = 385205,
  [SMALL_STATE(5889)] = 385288,
  [SMALL_STATE(5890)] = 385371,
  [SMALL_STATE(5891)] = 385454,
  [SMALL_STATE(5892)] = 385537,
  [SMALL_STATE(5893)] = 385620,
  [SMALL_STATE(5894)] = 385703,
  [SMALL_STATE(5895)] = 385786,
  [SMALL_STATE(5896)] = 385829,
  [SMALL_STATE(5897)] = 385912,
  [SMALL_STATE(5898)] = 385959,
  [SMALL_STATE(5899)] = 386042,
  [SMALL_STATE(5900)] = 386125,
  [SMALL_STATE(5901)] = 386208,
  [SMALL_STATE(5902)] = 386291,
  [SMALL_STATE(5903)] = 386374,
  [SMALL_STATE(5904)] = 386457,
  [SMALL_STATE(5905)] = 386502,
  [SMALL_STATE(5906)] = 386585,
  [SMALL_STATE(5907)] = 386668,
  [SMALL_STATE(5908)] = 386751,
  [SMALL_STATE(5909)] = 386796,
  [SMALL_STATE(5910)] = 386879,
  [SMALL_STATE(5911)] = 386962,
  [SMALL_STATE(5912)] = 387045,
  [SMALL_STATE(5913)] = 387128,
  [SMALL_STATE(5914)] = 387211,
  [SMALL_STATE(5915)] = 387294,
  [SMALL_STATE(5916)] = 387377,
  [SMALL_STATE(5917)] = 387460,
  [SMALL_STATE(5918)] = 387543,
  [SMALL_STATE(5919)] = 387626,
  [SMALL_STATE(5920)] = 387709,
  [SMALL_STATE(5921)] = 387758,
  [SMALL_STATE(5922)] = 387803,
  [SMALL_STATE(5923)] = 387886,
  [SMALL_STATE(5924)] = 387969,
  [SMALL_STATE(5925)] = 388014,
  [SMALL_STATE(5926)] = 388097,
  [SMALL_STATE(5927)] = 388180,
  [SMALL_STATE(5928)] = 388263,
  [SMALL_STATE(5929)] = 388346,
  [SMALL_STATE(5930)] = 388393,
  [SMALL_STATE(5931)] = 388440,
  [SMALL_STATE(5932)] = 388523,
  [SMALL_STATE(5933)] = 388606,
  [SMALL_STATE(5934)] = 388651,
  [SMALL_STATE(5935)] = 388734,
  [SMALL_STATE(5936)] = 388781,
  [SMALL_STATE(5937)] = 388828,
  [SMALL_STATE(5938)] = 388911,
  [SMALL_STATE(5939)] = 388956,
  [SMALL_STATE(5940)] = 389003,
  [SMALL_STATE(5941)] = 389050,
  [SMALL_STATE(5942)] = 389133,
  [SMALL_STATE(5943)] = 389216,
  [SMALL_STATE(5944)] = 389299,
  [SMALL_STATE(5945)] = 389346,
  [SMALL_STATE(5946)] = 389429,
  [SMALL_STATE(5947)] = 389474,
  [SMALL_STATE(5948)] = 389521,
  [SMALL_STATE(5949)] = 389604,
  [SMALL_STATE(5950)] = 389687,
  [SMALL_STATE(5951)] = 389770,
  [SMALL_STATE(5952)] = 389815,
  [SMALL_STATE(5953)] = 389898,
  [SMALL_STATE(5954)] = 389943,
  [SMALL_STATE(5955)] = 390026,
  [SMALL_STATE(5956)] = 390109,
  [SMALL_STATE(5957)] = 390192,
  [SMALL_STATE(5958)] = 390237,
  [SMALL_STATE(5959)] = 390320,
  [SMALL_STATE(5960)] = 390403,
  [SMALL_STATE(5961)] = 390486,
  [SMALL_STATE(5962)] = 390531,
  [SMALL_STATE(5963)] = 390578,
  [SMALL_STATE(5964)] = 390661,
  [SMALL_STATE(5965)] = 390708,
  [SMALL_STATE(5966)] = 390791,
  [SMALL_STATE(5967)] = 390834,
  [SMALL_STATE(5968)] = 390917,
  [SMALL_STATE(5969)] = 390964,
  [SMALL_STATE(5970)] = 391007,
  [SMALL_STATE(5971)] = 391050,
  [SMALL_STATE(5972)] = 391133,
  [SMALL_STATE(5973)] = 391180,
  [SMALL_STATE(5974)] = 391227,
  [SMALL_STATE(5975)] = 391274,
  [SMALL_STATE(5976)] = 391357,
  [SMALL_STATE(5977)] = 391440,
  [SMALL_STATE(5978)] = 391523,
  [SMALL_STATE(5979)] = 391606,
  [SMALL_STATE(5980)] = 391649,
  [SMALL_STATE(5981)] = 391696,
  [SMALL_STATE(5982)] = 391779,
  [SMALL_STATE(5983)] = 391822,
  [SMALL_STATE(5984)] = 391905,
  [SMALL_STATE(5985)] = 391950,
  [SMALL_STATE(5986)] = 392033,
  [SMALL_STATE(5987)] = 392080,
  [SMALL_STATE(5988)] = 392123,
  [SMALL_STATE(5989)] = 392206,
  [SMALL_STATE(5990)] = 392253,
  [SMALL_STATE(5991)] = 392336,
  [SMALL_STATE(5992)] = 392379,
  [SMALL_STATE(5993)] = 392462,
  [SMALL_STATE(5994)] = 392509,
  [SMALL_STATE(5995)] = 392556,
  [SMALL_STATE(5996)] = 392603,
  [SMALL_STATE(5997)] = 392646,
  [SMALL_STATE(5998)] = 392693,
  [SMALL_STATE(5999)] = 392740,
  [SMALL_STATE(6000)] = 392785,
  [SMALL_STATE(6001)] = 392828,
  [SMALL_STATE(6002)] = 392871,
  [SMALL_STATE(6003)] = 392914,
  [SMALL_STATE(6004)] = 392957,
  [SMALL_STATE(6005)] = 393002,
  [SMALL_STATE(6006)] = 393045,
  [SMALL_STATE(6007)] = 393128,
  [SMALL_STATE(6008)] = 393211,
  [SMALL_STATE(6009)] = 393294,
  [SMALL_STATE(6010)] = 393377,
  [SMALL_STATE(6011)] = 393420,
  [SMALL_STATE(6012)] = 393465,
  [SMALL_STATE(6013)] = 393548,
  [SMALL_STATE(6014)] = 393591,
  [SMALL_STATE(6015)] = 393634,
  [SMALL_STATE(6016)] = 393677,
  [SMALL_STATE(6017)] = 393724,
  [SMALL_STATE(6018)] = 393771,
  [SMALL_STATE(6019)] = 393854,
  [SMALL_STATE(6020)] = 393901,
  [SMALL_STATE(6021)] = 393984,
  [SMALL_STATE(6022)] = 394067,
  [SMALL_STATE(6023)] = 394112,
  [SMALL_STATE(6024)] = 394159,
  [SMALL_STATE(6025)] = 394242,
  [SMALL_STATE(6026)] = 394325,
  [SMALL_STATE(6027)] = 394372,
  [SMALL_STATE(6028)] = 394417,
  [SMALL_STATE(6029)] = 394500,
  [SMALL_STATE(6030)] = 394543,
  [SMALL_STATE(6031)] = 394590,
  [SMALL_STATE(6032)] = 394673,
  [SMALL_STATE(6033)] = 394720,
  [SMALL_STATE(6034)] = 394765,
  [SMALL_STATE(6035)] = 394812,
  [SMALL_STATE(6036)] = 394895,
  [SMALL_STATE(6037)] = 394938,
  [SMALL_STATE(6038)] = 394985,
  [SMALL_STATE(6039)] = 395032,
  [SMALL_STATE(6040)] = 395079,
  [SMALL_STATE(6041)] = 395162,
  [SMALL_STATE(6042)] = 395209,
  [SMALL_STATE(6043)] = 395252,
  [SMALL_STATE(6044)] = 395299,
  [SMALL_STATE(6045)] = 395382,
  [SMALL_STATE(6046)] = 395465,
  [SMALL_STATE(6047)] = 395512,
  [SMALL_STATE(6048)] = 395559,
  [SMALL_STATE(6049)] = 395606,
  [SMALL_STATE(6050)] = 395689,
  [SMALL_STATE(6051)] = 395732,
  [SMALL_STATE(6052)] = 395815,
  [SMALL_STATE(6053)] = 395858,
  [SMALL_STATE(6054)] = 395905,
  [SMALL_STATE(6055)] = 395988,
  [SMALL_STATE(6056)] = 396035,
  [SMALL_STATE(6057)] = 396118,
  [SMALL_STATE(6058)] = 396165,
  [SMALL_STATE(6059)] = 396248,
  [SMALL_STATE(6060)] = 396331,
  [SMALL_STATE(6061)] = 396414,
  [SMALL_STATE(6062)] = 396497,
  [SMALL_STATE(6063)] = 396544,
  [SMALL_STATE(6064)] = 396627,
  [SMALL_STATE(6065)] = 396674,
  [SMALL_STATE(6066)] = 396721,
  [SMALL_STATE(6067)] = 396768,
  [SMALL_STATE(6068)] = 396851,
  [SMALL_STATE(6069)] = 396934,
  [SMALL_STATE(6070)] = 397017,
  [SMALL_STATE(6071)] = 397100,
  [SMALL_STATE(6072)] = 397183,
  [SMALL_STATE(6073)] = 397266,
  [SMALL_STATE(6074)] = 397313,
  [SMALL_STATE(6075)] = 397356,
  [SMALL_STATE(6076)] = 397439,
  [SMALL_STATE(6077)] = 397522,
  [SMALL_STATE(6078)] = 397569,
  [SMALL_STATE(6079)] = 397616,
  [SMALL_STATE(6080)] = 397659,
  [SMALL_STATE(6081)] = 397702,
  [SMALL_STATE(6082)] = 397785,
  [SMALL_STATE(6083)] = 397828,
  [SMALL_STATE(6084)] = 397875,
  [SMALL_STATE(6085)] = 397958,
  [SMALL_STATE(6086)] = 398001,
  [SMALL_STATE(6087)] = 398044,
  [SMALL_STATE(6088)] = 398127,
  [SMALL_STATE(6089)] = 398210,
  [SMALL_STATE(6090)] = 398257,
  [SMALL_STATE(6091)] = 398300,
  [SMALL_STATE(6092)] = 398383,
  [SMALL_STATE(6093)] = 398430,
  [SMALL_STATE(6094)] = 398477,
  [SMALL_STATE(6095)] = 398524,
  [SMALL_STATE(6096)] = 398569,
  [SMALL_STATE(6097)] = 398612,
  [SMALL_STATE(6098)] = 398695,
  [SMALL_STATE(6099)] = 398738,
  [SMALL_STATE(6100)] = 398783,
  [SMALL_STATE(6101)] = 398866,
  [SMALL_STATE(6102)] = 398913,
  [SMALL_STATE(6103)] = 398996,
  [SMALL_STATE(6104)] = 399079,
  [SMALL_STATE(6105)] = 399122,
  [SMALL_STATE(6106)] = 399165,
  [SMALL_STATE(6107)] = 399208,
  [SMALL_STATE(6108)] = 399251,
  [SMALL_STATE(6109)] = 399294,
  [SMALL_STATE(6110)] = 399341,
  [SMALL_STATE(6111)] = 399424,
  [SMALL_STATE(6112)] = 399466,
  [SMALL_STATE(6113)] = 399546,
  [SMALL_STATE(6114)] = 399590,
  [SMALL_STATE(6115)] = 399674,
  [SMALL_STATE(6116)] = 399716,
  [SMALL_STATE(6117)] = 399758,
  [SMALL_STATE(6118)] = 399800,
  [SMALL_STATE(6119)] = 399842,
  [SMALL_STATE(6120)] = 399884,
  [SMALL_STATE(6121)] = 399926,
  [SMALL_STATE(6122)] = 399968,
  [SMALL_STATE(6123)] = 400010,
  [SMALL_STATE(6124)] = 400052,
  [SMALL_STATE(6125)] = 400094,
  [SMALL_STATE(6126)] = 400136,
  [SMALL_STATE(6127)] = 400178,
  [SMALL_STATE(6128)] = 400220,
  [SMALL_STATE(6129)] = 400262,
  [SMALL_STATE(6130)] = 400304,
  [SMALL_STATE(6131)] = 400346,
  [SMALL_STATE(6132)] = 400388,
  [SMALL_STATE(6133)] = 400430,
  [SMALL_STATE(6134)] = 400472,
  [SMALL_STATE(6135)] = 400514,
  [SMALL_STATE(6136)] = 400556,
  [SMALL_STATE(6137)] = 400598,
  [SMALL_STATE(6138)] = 400640,
  [SMALL_STATE(6139)] = 400682,
  [SMALL_STATE(6140)] = 400724,
  [SMALL_STATE(6141)] = 400766,
  [SMALL_STATE(6142)] = 400808,
  [SMALL_STATE(6143)] = 400850,
  [SMALL_STATE(6144)] = 400892,
  [SMALL_STATE(6145)] = 400934,
  [SMALL_STATE(6146)] = 400976,
  [SMALL_STATE(6147)] = 401018,
  [SMALL_STATE(6148)] = 401060,
  [SMALL_STATE(6149)] = 401102,
  [SMALL_STATE(6150)] = 401144,
  [SMALL_STATE(6151)] = 401186,
  [SMALL_STATE(6152)] = 401228,
  [SMALL_STATE(6153)] = 401270,
  [SMALL_STATE(6154)] = 401312,
  [SMALL_STATE(6155)] = 401354,
  [SMALL_STATE(6156)] = 401396,
  [SMALL_STATE(6157)] = 401438,
  [SMALL_STATE(6158)] = 401480,
  [SMALL_STATE(6159)] = 401564,
  [SMALL_STATE(6160)] = 401606,
  [SMALL_STATE(6161)] = 401648,
  [SMALL_STATE(6162)] = 401690,
  [SMALL_STATE(6163)] = 401732,
  [SMALL_STATE(6164)] = 401774,
  [SMALL_STATE(6165)] = 401816,
  [SMALL_STATE(6166)] = 401858,
  [SMALL_STATE(6167)] = 401942,
  [SMALL_STATE(6168)] = 402024,
  [SMALL_STATE(6169)] = 402108,
  [SMALL_STATE(6170)] = 402150,
  [SMALL_STATE(6171)] = 402192,
  [SMALL_STATE(6172)] = 402234,
  [SMALL_STATE(6173)] = 402276,
  [SMALL_STATE(6174)] = 402318,
  [SMALL_STATE(6175)] = 402360,
  [SMALL_STATE(6176)] = 402402,
  [SMALL_STATE(6177)] = 402444,
  [SMALL_STATE(6178)] = 402486,
  [SMALL_STATE(6179)] = 402570,
  [SMALL_STATE(6180)] = 402624,
  [SMALL_STATE(6181)] = 402666,
  [SMALL_STATE(6182)] = 402708,
  [SMALL_STATE(6183)] = 402750,
  [SMALL_STATE(6184)] = 402792,
  [SMALL_STATE(6185)] = 402872,
  [SMALL_STATE(6186)] = 402952,
  [SMALL_STATE(6187)] = 403032,
  [SMALL_STATE(6188)] = 403112,
  [SMALL_STATE(6189)] = 403192,
  [SMALL_STATE(6190)] = 403272,
  [SMALL_STATE(6191)] = 403352,
  [SMALL_STATE(6192)] = 403432,
  [SMALL_STATE(6193)] = 403516,
  [SMALL_STATE(6194)] = 403596,
  [SMALL_STATE(6195)] = 403676,
  [SMALL_STATE(6196)] = 403756,
  [SMALL_STATE(6197)] = 403836,
  [SMALL_STATE(6198)] = 403916,
  [SMALL_STATE(6199)] = 403996,
  [SMALL_STATE(6200)] = 404076,
  [SMALL_STATE(6201)] = 404156,
  [SMALL_STATE(6202)] = 404236,
  [SMALL_STATE(6203)] = 404320,
  [SMALL_STATE(6204)] = 404400,
  [SMALL_STATE(6205)] = 404480,
  [SMALL_STATE(6206)] = 404560,
  [SMALL_STATE(6207)] = 404640,
  [SMALL_STATE(6208)] = 404720,
  [SMALL_STATE(6209)] = 404800,
  [SMALL_STATE(6210)] = 404880,
  [SMALL_STATE(6211)] = 404960,
  [SMALL_STATE(6212)] = 405044,
  [SMALL_STATE(6213)] = 405124,
  [SMALL_STATE(6214)] = 405204,
  [SMALL_STATE(6215)] = 405284,
  [SMALL_STATE(6216)] = 405364,
  [SMALL_STATE(6217)] = 405406,
  [SMALL_STATE(6218)] = 405450,
  [SMALL_STATE(6219)] = 405530,
  [SMALL_STATE(6220)] = 405614,
  [SMALL_STATE(6221)] = 405656,
  [SMALL_STATE(6222)] = 405736,
  [SMALL_STATE(6223)] = 405816,
  [SMALL_STATE(6224)] = 405896,
  [SMALL_STATE(6225)] = 405938,
  [SMALL_STATE(6226)] = 406018,
  [SMALL_STATE(6227)] = 406098,
  [SMALL_STATE(6228)] = 406140,
  [SMALL_STATE(6229)] = 406220,
  [SMALL_STATE(6230)] = 406262,
  [SMALL_STATE(6231)] = 406304,
  [SMALL_STATE(6232)] = 406346,
  [SMALL_STATE(6233)] = 406388,
  [SMALL_STATE(6234)] = 406430,
  [SMALL_STATE(6235)] = 406472,
  [SMALL_STATE(6236)] = 406514,
  [SMALL_STATE(6237)] = 406556,
  [SMALL_STATE(6238)] = 406598,
  [SMALL_STATE(6239)] = 406640,
  [SMALL_STATE(6240)] = 406682,
  [SMALL_STATE(6241)] = 406724,
  [SMALL_STATE(6242)] = 406766,
  [SMALL_STATE(6243)] = 406808,
  [SMALL_STATE(6244)] = 406850,
  [SMALL_STATE(6245)] = 406892,
  [SMALL_STATE(6246)] = 406972,
  [SMALL_STATE(6247)] = 407014,
  [SMALL_STATE(6248)] = 407056,
  [SMALL_STATE(6249)] = 407098,
  [SMALL_STATE(6250)] = 407140,
  [SMALL_STATE(6251)] = 407182,
  [SMALL_STATE(6252)] = 407224,
  [SMALL_STATE(6253)] = 407266,
  [SMALL_STATE(6254)] = 407346,
  [SMALL_STATE(6255)] = 407428,
  [SMALL_STATE(6256)] = 407508,
  [SMALL_STATE(6257)] = 407590,
  [SMALL_STATE(6258)] = 407672,
  [SMALL_STATE(6259)] = 407714,
  [SMALL_STATE(6260)] = 407756,
  [SMALL_STATE(6261)] = 407798,
  [SMALL_STATE(6262)] = 407840,
  [SMALL_STATE(6263)] = 407882,
  [SMALL_STATE(6264)] = 407924,
  [SMALL_STATE(6265)] = 407966,
  [SMALL_STATE(6266)] = 408008,
  [SMALL_STATE(6267)] = 408050,
  [SMALL_STATE(6268)] = 408092,
  [SMALL_STATE(6269)] = 408134,
  [SMALL_STATE(6270)] = 408176,
  [SMALL_STATE(6271)] = 408218,
  [SMALL_STATE(6272)] = 408260,
  [SMALL_STATE(6273)] = 408302,
  [SMALL_STATE(6274)] = 408344,
  [SMALL_STATE(6275)] = 408386,
  [SMALL_STATE(6276)] = 408428,
  [SMALL_STATE(6277)] = 408470,
  [SMALL_STATE(6278)] = 408512,
  [SMALL_STATE(6279)] = 408554,
  [SMALL_STATE(6280)] = 408596,
  [SMALL_STATE(6281)] = 408638,
  [SMALL_STATE(6282)] = 408680,
  [SMALL_STATE(6283)] = 408722,
  [SMALL_STATE(6284)] = 408764,
  [SMALL_STATE(6285)] = 408806,
  [SMALL_STATE(6286)] = 408848,
  [SMALL_STATE(6287)] = 408890,
  [SMALL_STATE(6288)] = 408932,
  [SMALL_STATE(6289)] = 408974,
  [SMALL_STATE(6290)] = 409016,
  [SMALL_STATE(6291)] = 409058,
  [SMALL_STATE(6292)] = 409100,
  [SMALL_STATE(6293)] = 409184,
  [SMALL_STATE(6294)] = 409266,
  [SMALL_STATE(6295)] = 409346,
  [SMALL_STATE(6296)] = 409426,
  [SMALL_STATE(6297)] = 409510,
  [SMALL_STATE(6298)] = 409552,
  [SMALL_STATE(6299)] = 409594,
  [SMALL_STATE(6300)] = 409636,
  [SMALL_STATE(6301)] = 409678,
  [SMALL_STATE(6302)] = 409720,
  [SMALL_STATE(6303)] = 409762,
  [SMALL_STATE(6304)] = 409804,
  [SMALL_STATE(6305)] = 409884,
  [SMALL_STATE(6306)] = 409964,
  [SMALL_STATE(6307)] = 410044,
  [SMALL_STATE(6308)] = 410124,
  [SMALL_STATE(6309)] = 410166,
  [SMALL_STATE(6310)] = 410208,
  [SMALL_STATE(6311)] = 410250,
  [SMALL_STATE(6312)] = 410292,
  [SMALL_STATE(6313)] = 410334,
  [SMALL_STATE(6314)] = 410376,
  [SMALL_STATE(6315)] = 410418,
  [SMALL_STATE(6316)] = 410460,
  [SMALL_STATE(6317)] = 410502,
  [SMALL_STATE(6318)] = 410582,
  [SMALL_STATE(6319)] = 410624,
  [SMALL_STATE(6320)] = 410666,
  [SMALL_STATE(6321)] = 410712,
  [SMALL_STATE(6322)] = 410792,
  [SMALL_STATE(6323)] = 410872,
  [SMALL_STATE(6324)] = 410914,
  [SMALL_STATE(6325)] = 410956,
  [SMALL_STATE(6326)] = 410998,
  [SMALL_STATE(6327)] = 411040,
  [SMALL_STATE(6328)] = 411082,
  [SMALL_STATE(6329)] = 411162,
  [SMALL_STATE(6330)] = 411246,
  [SMALL_STATE(6331)] = 411287,
  [SMALL_STATE(6332)] = 411328,
  [SMALL_STATE(6333)] = 411401,
  [SMALL_STATE(6334)] = 411442,
  [SMALL_STATE(6335)] = 411483,
  [SMALL_STATE(6336)] = 411524,
  [SMALL_STATE(6337)] = 411565,
  [SMALL_STATE(6338)] = 411646,
  [SMALL_STATE(6339)] = 411687,
  [SMALL_STATE(6340)] = 411768,
  [SMALL_STATE(6341)] = 411851,
  [SMALL_STATE(6342)] = 411932,
  [SMALL_STATE(6343)] = 412013,
  [SMALL_STATE(6344)] = 412094,
  [SMALL_STATE(6345)] = 412135,
  [SMALL_STATE(6346)] = 412216,
  [SMALL_STATE(6347)] = 412297,
  [SMALL_STATE(6348)] = 412378,
  [SMALL_STATE(6349)] = 412419,
  [SMALL_STATE(6350)] = 412502,
  [SMALL_STATE(6351)] = 412575,
  [SMALL_STATE(6352)] = 412648,
  [SMALL_STATE(6353)] = 412729,
  [SMALL_STATE(6354)] = 412770,
  [SMALL_STATE(6355)] = 412811,
  [SMALL_STATE(6356)] = 412894,
  [SMALL_STATE(6357)] = 412977,
  [SMALL_STATE(6358)] = 413028,
  [SMALL_STATE(6359)] = 413079,
  [SMALL_STATE(6360)] = 413120,
  [SMALL_STATE(6361)] = 413203,
  [SMALL_STATE(6362)] = 413286,
  [SMALL_STATE(6363)] = 413369,
  [SMALL_STATE(6364)] = 413450,
  [SMALL_STATE(6365)] = 413491,
  [SMALL_STATE(6366)] = 413574,
  [SMALL_STATE(6367)] = 413613,
  [SMALL_STATE(6368)] = 413696,
  [SMALL_STATE(6369)] = 413737,
  [SMALL_STATE(6370)] = 413818,
  [SMALL_STATE(6371)] = 413859,
  [SMALL_STATE(6372)] = 413942,
  [SMALL_STATE(6373)] = 414025,
  [SMALL_STATE(6374)] = 414106,
  [SMALL_STATE(6375)] = 414189,
  [SMALL_STATE(6376)] = 414230,
  [SMALL_STATE(6377)] = 414303,
  [SMALL_STATE(6378)] = 414342,
  [SMALL_STATE(6379)] = 414425,
  [SMALL_STATE(6380)] = 414508,
  [SMALL_STATE(6381)] = 414591,
  [SMALL_STATE(6382)] = 414672,
  [SMALL_STATE(6383)] = 414753,
  [SMALL_STATE(6384)] = 414794,
  [SMALL_STATE(6385)] = 414835,
  [SMALL_STATE(6386)] = 414876,
  [SMALL_STATE(6387)] = 414917,
  [SMALL_STATE(6388)] = 414958,
  [SMALL_STATE(6389)] = 415039,
  [SMALL_STATE(6390)] = 415120,
  [SMALL_STATE(6391)] = 415161,
  [SMALL_STATE(6392)] = 415202,
  [SMALL_STATE(6393)] = 415243,
  [SMALL_STATE(6394)] = 415284,
  [SMALL_STATE(6395)] = 415325,
  [SMALL_STATE(6396)] = 415366,
  [SMALL_STATE(6397)] = 415407,
  [SMALL_STATE(6398)] = 415448,
  [SMALL_STATE(6399)] = 415489,
  [SMALL_STATE(6400)] = 415530,
  [SMALL_STATE(6401)] = 415571,
  [SMALL_STATE(6402)] = 415644,
  [SMALL_STATE(6403)] = 415685,
  [SMALL_STATE(6404)] = 415726,
  [SMALL_STATE(6405)] = 415799,
  [SMALL_STATE(6406)] = 415872,
  [SMALL_STATE(6407)] = 415913,
  [SMALL_STATE(6408)] = 415954,
  [SMALL_STATE(6409)] = 415995,
  [SMALL_STATE(6410)] = 416036,
  [SMALL_STATE(6411)] = 416077,
  [SMALL_STATE(6412)] = 416118,
  [SMALL_STATE(6413)] = 416159,
  [SMALL_STATE(6414)] = 416200,
  [SMALL_STATE(6415)] = 416242,
  [SMALL_STATE(6416)] = 416282,
  [SMALL_STATE(6417)] = 416322,
  [SMALL_STATE(6418)] = 416394,
  [SMALL_STATE(6419)] = 416466,
  [SMALL_STATE(6420)] = 416538,
  [SMALL_STATE(6421)] = 416610,
  [SMALL_STATE(6422)] = 416650,
  [SMALL_STATE(6423)] = 416692,
  [SMALL_STATE(6424)] = 416764,
  [SMALL_STATE(6425)] = 416836,
  [SMALL_STATE(6426)] = 416908,
  [SMALL_STATE(6427)] = 416950,
  [SMALL_STATE(6428)] = 416992,
  [SMALL_STATE(6429)] = 417044,
  [SMALL_STATE(6430)] = 417117,
  [SMALL_STATE(6431)] = 417194,
  [SMALL_STATE(6432)] = 417255,
  [SMALL_STATE(6433)] = 417328,
  [SMALL_STATE(6434)] = 417405,
  [SMALL_STATE(6435)] = 417478,
  [SMALL_STATE(6436)] = 417551,
  [SMALL_STATE(6437)] = 417624,
  [SMALL_STATE(6438)] = 417695,
  [SMALL_STATE(6439)] = 417766,
  [SMALL_STATE(6440)] = 417837,
  [SMALL_STATE(6441)] = 417910,
  [SMALL_STATE(6442)] = 417983,
  [SMALL_STATE(6443)] = 418054,
  [SMALL_STATE(6444)] = 418127,
  [SMALL_STATE(6445)] = 418200,
  [SMALL_STATE(6446)] = 418273,
  [SMALL_STATE(6447)] = 418344,
  [SMALL_STATE(6448)] = 418421,
  [SMALL_STATE(6449)] = 418494,
  [SMALL_STATE(6450)] = 418567,
  [SMALL_STATE(6451)] = 418640,
  [SMALL_STATE(6452)] = 418713,
  [SMALL_STATE(6453)] = 418786,
  [SMALL_STATE(6454)] = 418857,
  [SMALL_STATE(6455)] = 418898,
  [SMALL_STATE(6456)] = 418969,
  [SMALL_STATE(6457)] = 419046,
  [SMALL_STATE(6458)] = 419119,
  [SMALL_STATE(6459)] = 419192,
  [SMALL_STATE(6460)] = 419265,
  [SMALL_STATE(6461)] = 419338,
  [SMALL_STATE(6462)] = 419411,
  [SMALL_STATE(6463)] = 419484,
  [SMALL_STATE(6464)] = 419561,
  [SMALL_STATE(6465)] = 419622,
  [SMALL_STATE(6466)] = 419699,
  [SMALL_STATE(6467)] = 419772,
  [SMALL_STATE(6468)] = 419845,
  [SMALL_STATE(6469)] = 419918,
  [SMALL_STATE(6470)] = 419991,
  [SMALL_STATE(6471)] = 420064,
  [SMALL_STATE(6472)] = 420137,
  [SMALL_STATE(6473)] = 420210,
  [SMALL_STATE(6474)] = 420271,
  [SMALL_STATE(6475)] = 420335,
  [SMALL_STATE(6476)] = 420399,
  [SMALL_STATE(6477)] = 420463,
  [SMALL_STATE(6478)] = 420533,
  [SMALL_STATE(6479)] = 420597,
  [SMALL_STATE(6480)] = 420661,
  [SMALL_STATE(6481)] = 420725,
  [SMALL_STATE(6482)] = 420789,
  [SMALL_STATE(6483)] = 420853,
  [SMALL_STATE(6484)] = 420913,
  [SMALL_STATE(6485)] = 420977,
  [SMALL_STATE(6486)] = 421041,
  [SMALL_STATE(6487)] = 421087,
  [SMALL_STATE(6488)] = 421127,
  [SMALL_STATE(6489)] = 421187,
  [SMALL_STATE(6490)] = 421251,
  [SMALL_STATE(6491)] = 421315,
  [SMALL_STATE(6492)] = 421379,
  [SMALL_STATE(6493)] = 421443,
  [SMALL_STATE(6494)] = 421507,
  [SMALL_STATE(6495)] = 421571,
  [SMALL_STATE(6496)] = 421635,
  [SMALL_STATE(6497)] = 421705,
  [SMALL_STATE(6498)] = 421775,
  [SMALL_STATE(6499)] = 421845,
  [SMALL_STATE(6500)] = 421915,
  [SMALL_STATE(6501)] = 421985,
  [SMALL_STATE(6502)] = 422055,
  [SMALL_STATE(6503)] = 422119,
  [SMALL_STATE(6504)] = 422155,
  [SMALL_STATE(6505)] = 422191,
  [SMALL_STATE(6506)] = 422255,
  [SMALL_STATE(6507)] = 422319,
  [SMALL_STATE(6508)] = 422383,
  [SMALL_STATE(6509)] = 422421,
  [SMALL_STATE(6510)] = 422485,
  [SMALL_STATE(6511)] = 422545,
  [SMALL_STATE(6512)] = 422609,
  [SMALL_STATE(6513)] = 422673,
  [SMALL_STATE(6514)] = 422709,
  [SMALL_STATE(6515)] = 422773,
  [SMALL_STATE(6516)] = 422836,
  [SMALL_STATE(6517)] = 422877,
  [SMALL_STATE(6518)] = 422940,
  [SMALL_STATE(6519)] = 423003,
  [SMALL_STATE(6520)] = 423042,
  [SMALL_STATE(6521)] = 423081,
  [SMALL_STATE(6522)] = 423144,
  [SMALL_STATE(6523)] = 423183,
  [SMALL_STATE(6524)] = 423246,
  [SMALL_STATE(6525)] = 423309,
  [SMALL_STATE(6526)] = 423372,
  [SMALL_STATE(6527)] = 423411,
  [SMALL_STATE(6528)] = 423450,
  [SMALL_STATE(6529)] = 423489,
  [SMALL_STATE(6530)] = 423528,
  [SMALL_STATE(6531)] = 423567,
  [SMALL_STATE(6532)] = 423606,
  [SMALL_STATE(6533)] = 423669,
  [SMALL_STATE(6534)] = 423708,
  [SMALL_STATE(6535)] = 423747,
  [SMALL_STATE(6536)] = 423788,
  [SMALL_STATE(6537)] = 423851,
  [SMALL_STATE(6538)] = 423914,
  [SMALL_STATE(6539)] = 423977,
  [SMALL_STATE(6540)] = 424040,
  [SMALL_STATE(6541)] = 424085,
  [SMALL_STATE(6542)] = 424122,
  [SMALL_STATE(6543)] = 424185,
  [SMALL_STATE(6544)] = 424222,
  [SMALL_STATE(6545)] = 424261,
  [SMALL_STATE(6546)] = 424300,
  [SMALL_STATE(6547)] = 424339,
  [SMALL_STATE(6548)] = 424402,
  [SMALL_STATE(6549)] = 424441,
  [SMALL_STATE(6550)] = 424504,
  [SMALL_STATE(6551)] = 424539,
  [SMALL_STATE(6552)] = 424580,
  [SMALL_STATE(6553)] = 424643,
  [SMALL_STATE(6554)] = 424682,
  [SMALL_STATE(6555)] = 424745,
  [SMALL_STATE(6556)] = 424808,
  [SMALL_STATE(6557)] = 424871,
  [SMALL_STATE(6558)] = 424934,
  [SMALL_STATE(6559)] = 424973,
  [SMALL_STATE(6560)] = 425012,
  [SMALL_STATE(6561)] = 425047,
  [SMALL_STATE(6562)] = 425086,
  [SMALL_STATE(6563)] = 425149,
  [SMALL_STATE(6564)] = 425188,
  [SMALL_STATE(6565)] = 425227,
  [SMALL_STATE(6566)] = 425292,
  [SMALL_STATE(6567)] = 425355,
  [SMALL_STATE(6568)] = 425392,
  [SMALL_STATE(6569)] = 425455,
  [SMALL_STATE(6570)] = 425490,
  [SMALL_STATE(6571)] = 425553,
  [SMALL_STATE(6572)] = 425592,
  [SMALL_STATE(6573)] = 425655,
  [SMALL_STATE(6574)] = 425701,
  [SMALL_STATE(6575)] = 425741,
  [SMALL_STATE(6576)] = 425809,
  [SMALL_STATE(6577)] = 425877,
  [SMALL_STATE(6578)] = 425917,
  [SMALL_STATE(6579)] = 425985,
  [SMALL_STATE(6580)] = 426025,
  [SMALL_STATE(6581)] = 426069,
  [SMALL_STATE(6582)] = 426115,
  [SMALL_STATE(6583)] = 426155,
  [SMALL_STATE(6584)] = 426223,
  [SMALL_STATE(6585)] = 426263,
  [SMALL_STATE(6586)] = 426331,
  [SMALL_STATE(6587)] = 426379,
  [SMALL_STATE(6588)] = 426447,
  [SMALL_STATE(6589)] = 426485,
  [SMALL_STATE(6590)] = 426553,
  [SMALL_STATE(6591)] = 426586,
  [SMALL_STATE(6592)] = 426621,
  [SMALL_STATE(6593)] = 426666,
  [SMALL_STATE(6594)] = 426701,
  [SMALL_STATE(6595)] = 426768,
  [SMALL_STATE(6596)] = 426805,
  [SMALL_STATE(6597)] = 426850,
  [SMALL_STATE(6598)] = 426883,
  [SMALL_STATE(6599)] = 426916,
  [SMALL_STATE(6600)] = 426949,
  [SMALL_STATE(6601)] = 426984,
  [SMALL_STATE(6602)] = 427019,
  [SMALL_STATE(6603)] = 427054,
  [SMALL_STATE(6604)] = 427091,
  [SMALL_STATE(6605)] = 427128,
  [SMALL_STATE(6606)] = 427195,
  [SMALL_STATE(6607)] = 427230,
  [SMALL_STATE(6608)] = 427263,
  [SMALL_STATE(6609)] = 427296,
  [SMALL_STATE(6610)] = 427331,
  [SMALL_STATE(6611)] = 427378,
  [SMALL_STATE(6612)] = 427413,
  [SMALL_STATE(6613)] = 427450,
  [SMALL_STATE(6614)] = 427517,
  [SMALL_STATE(6615)] = 427584,
  [SMALL_STATE(6616)] = 427651,
  [SMALL_STATE(6617)] = 427718,
  [SMALL_STATE(6618)] = 427753,
  [SMALL_STATE(6619)] = 427820,
  [SMALL_STATE(6620)] = 427866,
  [SMALL_STATE(6621)] = 427898,
  [SMALL_STATE(6622)] = 427930,
  [SMALL_STATE(6623)] = 427962,
  [SMALL_STATE(6624)] = 427994,
  [SMALL_STATE(6625)] = 428030,
  [SMALL_STATE(6626)] = 428064,
  [SMALL_STATE(6627)] = 428140,
  [SMALL_STATE(6628)] = 428172,
  [SMALL_STATE(6629)] = 428204,
  [SMALL_STATE(6630)] = 428236,
  [SMALL_STATE(6631)] = 428276,
  [SMALL_STATE(6632)] = 428352,
  [SMALL_STATE(6633)] = 428384,
  [SMALL_STATE(6634)] = 428460,
  [SMALL_STATE(6635)] = 428492,
  [SMALL_STATE(6636)] = 428523,
  [SMALL_STATE(6637)] = 428584,
  [SMALL_STATE(6638)] = 428619,
  [SMALL_STATE(6639)] = 428664,
  [SMALL_STATE(6640)] = 428701,
  [SMALL_STATE(6641)] = 428738,
  [SMALL_STATE(6642)] = 428769,
  [SMALL_STATE(6643)] = 428830,
  [SMALL_STATE(6644)] = 428867,
  [SMALL_STATE(6645)] = 428928,
  [SMALL_STATE(6646)] = 428965,
  [SMALL_STATE(6647)] = 429002,
  [SMALL_STATE(6648)] = 429039,
  [SMALL_STATE(6649)] = 429100,
  [SMALL_STATE(6650)] = 429137,
  [SMALL_STATE(6651)] = 429174,
  [SMALL_STATE(6652)] = 429209,
  [SMALL_STATE(6653)] = 429246,
  [SMALL_STATE(6654)] = 429285,
  [SMALL_STATE(6655)] = 429349,
  [SMALL_STATE(6656)] = 429411,
  [SMALL_STATE(6657)] = 429441,
  [SMALL_STATE(6658)] = 429475,
  [SMALL_STATE(6659)] = 429511,
  [SMALL_STATE(6660)] = 429547,
  [SMALL_STATE(6661)] = 429577,
  [SMALL_STATE(6662)] = 429613,
  [SMALL_STATE(6663)] = 429675,
  [SMALL_STATE(6664)] = 429709,
  [SMALL_STATE(6665)] = 429771,
  [SMALL_STATE(6666)] = 429803,
  [SMALL_STATE(6667)] = 429865,
  [SMALL_STATE(6668)] = 429901,
  [SMALL_STATE(6669)] = 429937,
  [SMALL_STATE(6670)] = 430001,
  [SMALL_STATE(6671)] = 430037,
  [SMALL_STATE(6672)] = 430099,
  [SMALL_STATE(6673)] = 430131,
  [SMALL_STATE(6674)] = 430167,
  [SMALL_STATE(6675)] = 430229,
  [SMALL_STATE(6676)] = 430289,
  [SMALL_STATE(6677)] = 430321,
  [SMALL_STATE(6678)] = 430357,
  [SMALL_STATE(6679)] = 430421,
  [SMALL_STATE(6680)] = 430457,
  [SMALL_STATE(6681)] = 430489,
  [SMALL_STATE(6682)] = 430549,
  [SMALL_STATE(6683)] = 430581,
  [SMALL_STATE(6684)] = 430615,
  [SMALL_STATE(6685)] = 430677,
  [SMALL_STATE(6686)] = 430707,
  [SMALL_STATE(6687)] = 430743,
  [SMALL_STATE(6688)] = 430815,
  [SMALL_STATE(6689)] = 430877,
  [SMALL_STATE(6690)] = 430937,
  [SMALL_STATE(6691)] = 430997,
  [SMALL_STATE(6692)] = 431028,
  [SMALL_STATE(6693)] = 431057,
  [SMALL_STATE(6694)] = 431088,
  [SMALL_STATE(6695)] = 431119,
  [SMALL_STATE(6696)] = 431150,
  [SMALL_STATE(6697)] = 431181,
  [SMALL_STATE(6698)] = 431212,
  [SMALL_STATE(6699)] = 431243,
  [SMALL_STATE(6700)] = 431274,
  [SMALL_STATE(6701)] = 431305,
  [SMALL_STATE(6702)] = 431334,
  [SMALL_STATE(6703)] = 431365,
  [SMALL_STATE(6704)] = 431424,
  [SMALL_STATE(6705)] = 431483,
  [SMALL_STATE(6706)] = 431516,
  [SMALL_STATE(6707)] = 431547,
  [SMALL_STATE(6708)] = 431606,
  [SMALL_STATE(6709)] = 431665,
  [SMALL_STATE(6710)] = 431724,
  [SMALL_STATE(6711)] = 431755,
  [SMALL_STATE(6712)] = 431786,
  [SMALL_STATE(6713)] = 431821,
  [SMALL_STATE(6714)] = 431852,
  [SMALL_STATE(6715)] = 431883,
  [SMALL_STATE(6716)] = 431914,
  [SMALL_STATE(6717)] = 431945,
  [SMALL_STATE(6718)] = 431976,
  [SMALL_STATE(6719)] = 432009,
  [SMALL_STATE(6720)] = 432040,
  [SMALL_STATE(6721)] = 432071,
  [SMALL_STATE(6722)] = 432102,
  [SMALL_STATE(6723)] = 432161,
  [SMALL_STATE(6724)] = 432190,
  [SMALL_STATE(6725)] = 432221,
  [SMALL_STATE(6726)] = 432252,
  [SMALL_STATE(6727)] = 432283,
  [SMALL_STATE(6728)] = 432314,
  [SMALL_STATE(6729)] = 432345,
  [SMALL_STATE(6730)] = 432376,
  [SMALL_STATE(6731)] = 432407,
  [SMALL_STATE(6732)] = 432438,
  [SMALL_STATE(6733)] = 432469,
  [SMALL_STATE(6734)] = 432500,
  [SMALL_STATE(6735)] = 432531,
  [SMALL_STATE(6736)] = 432590,
  [SMALL_STATE(6737)] = 432621,
  [SMALL_STATE(6738)] = 432652,
  [SMALL_STATE(6739)] = 432683,
  [SMALL_STATE(6740)] = 432714,
  [SMALL_STATE(6741)] = 432745,
  [SMALL_STATE(6742)] = 432776,
  [SMALL_STATE(6743)] = 432805,
  [SMALL_STATE(6744)] = 432836,
  [SMALL_STATE(6745)] = 432865,
  [SMALL_STATE(6746)] = 432896,
  [SMALL_STATE(6747)] = 432955,
  [SMALL_STATE(6748)] = 432986,
  [SMALL_STATE(6749)] = 433045,
  [SMALL_STATE(6750)] = 433076,
  [SMALL_STATE(6751)] = 433135,
  [SMALL_STATE(6752)] = 433194,
  [SMALL_STATE(6753)] = 433253,
  [SMALL_STATE(6754)] = 433312,
  [SMALL_STATE(6755)] = 433355,
  [SMALL_STATE(6756)] = 433384,
  [SMALL_STATE(6757)] = 433415,
  [SMALL_STATE(6758)] = 433444,
  [SMALL_STATE(6759)] = 433473,
  [SMALL_STATE(6760)] = 433504,
  [SMALL_STATE(6761)] = 433535,
  [SMALL_STATE(6762)] = 433566,
  [SMALL_STATE(6763)] = 433597,
  [SMALL_STATE(6764)] = 433628,
  [SMALL_STATE(6765)] = 433659,
  [SMALL_STATE(6766)] = 433688,
  [SMALL_STATE(6767)] = 433719,
  [SMALL_STATE(6768)] = 433750,
  [SMALL_STATE(6769)] = 433781,
  [SMALL_STATE(6770)] = 433812,
  [SMALL_STATE(6771)] = 433843,
  [SMALL_STATE(6772)] = 433874,
  [SMALL_STATE(6773)] = 433905,
  [SMALL_STATE(6774)] = 433936,
  [SMALL_STATE(6775)] = 433965,
  [SMALL_STATE(6776)] = 433996,
  [SMALL_STATE(6777)] = 434027,
  [SMALL_STATE(6778)] = 434056,
  [SMALL_STATE(6779)] = 434086,
  [SMALL_STATE(6780)] = 434142,
  [SMALL_STATE(6781)] = 434198,
  [SMALL_STATE(6782)] = 434254,
  [SMALL_STATE(6783)] = 434310,
  [SMALL_STATE(6784)] = 434340,
  [SMALL_STATE(6785)] = 434370,
  [SMALL_STATE(6786)] = 434426,
  [SMALL_STATE(6787)] = 434482,
  [SMALL_STATE(6788)] = 434538,
  [SMALL_STATE(6789)] = 434594,
  [SMALL_STATE(6790)] = 434624,
  [SMALL_STATE(6791)] = 434680,
  [SMALL_STATE(6792)] = 434736,
  [SMALL_STATE(6793)] = 434792,
  [SMALL_STATE(6794)] = 434822,
  [SMALL_STATE(6795)] = 434878,
  [SMALL_STATE(6796)] = 434908,
  [SMALL_STATE(6797)] = 434964,
  [SMALL_STATE(6798)] = 434994,
  [SMALL_STATE(6799)] = 435024,
  [SMALL_STATE(6800)] = 435054,
  [SMALL_STATE(6801)] = 435110,
  [SMALL_STATE(6802)] = 435166,
  [SMALL_STATE(6803)] = 435196,
  [SMALL_STATE(6804)] = 435252,
  [SMALL_STATE(6805)] = 435282,
  [SMALL_STATE(6806)] = 435312,
  [SMALL_STATE(6807)] = 435368,
  [SMALL_STATE(6808)] = 435398,
  [SMALL_STATE(6809)] = 435454,
  [SMALL_STATE(6810)] = 435510,
  [SMALL_STATE(6811)] = 435540,
  [SMALL_STATE(6812)] = 435570,
  [SMALL_STATE(6813)] = 435602,
  [SMALL_STATE(6814)] = 435632,
  [SMALL_STATE(6815)] = 435662,
  [SMALL_STATE(6816)] = 435692,
  [SMALL_STATE(6817)] = 435722,
  [SMALL_STATE(6818)] = 435778,
  [SMALL_STATE(6819)] = 435808,
  [SMALL_STATE(6820)] = 435838,
  [SMALL_STATE(6821)] = 435894,
  [SMALL_STATE(6822)] = 435950,
  [SMALL_STATE(6823)] = 436006,
  [SMALL_STATE(6824)] = 436036,
  [SMALL_STATE(6825)] = 436066,
  [SMALL_STATE(6826)] = 436096,
  [SMALL_STATE(6827)] = 436126,
  [SMALL_STATE(6828)] = 436182,
  [SMALL_STATE(6829)] = 436238,
  [SMALL_STATE(6830)] = 436268,
  [SMALL_STATE(6831)] = 436324,
  [SMALL_STATE(6832)] = 436354,
  [SMALL_STATE(6833)] = 436384,
  [SMALL_STATE(6834)] = 436414,
  [SMALL_STATE(6835)] = 436470,
  [SMALL_STATE(6836)] = 436500,
  [SMALL_STATE(6837)] = 436530,
  [SMALL_STATE(6838)] = 436586,
  [SMALL_STATE(6839)] = 436642,
  [SMALL_STATE(6840)] = 436672,
  [SMALL_STATE(6841)] = 436702,
  [SMALL_STATE(6842)] = 436758,
  [SMALL_STATE(6843)] = 436788,
  [SMALL_STATE(6844)] = 436844,
  [SMALL_STATE(6845)] = 436900,
  [SMALL_STATE(6846)] = 436956,
  [SMALL_STATE(6847)] = 437012,
  [SMALL_STATE(6848)] = 437068,
  [SMALL_STATE(6849)] = 437124,
  [SMALL_STATE(6850)] = 437154,
  [SMALL_STATE(6851)] = 437210,
  [SMALL_STATE(6852)] = 437266,
  [SMALL_STATE(6853)] = 437322,
  [SMALL_STATE(6854)] = 437378,
  [SMALL_STATE(6855)] = 437434,
  [SMALL_STATE(6856)] = 437464,
  [SMALL_STATE(6857)] = 437520,
  [SMALL_STATE(6858)] = 437576,
  [SMALL_STATE(6859)] = 437606,
  [SMALL_STATE(6860)] = 437662,
  [SMALL_STATE(6861)] = 437718,
  [SMALL_STATE(6862)] = 437774,
  [SMALL_STATE(6863)] = 437804,
  [SMALL_STATE(6864)] = 437846,
  [SMALL_STATE(6865)] = 437876,
  [SMALL_STATE(6866)] = 437906,
  [SMALL_STATE(6867)] = 437936,
  [SMALL_STATE(6868)] = 437992,
  [SMALL_STATE(6869)] = 438048,
  [SMALL_STATE(6870)] = 438078,
  [SMALL_STATE(6871)] = 438134,
  [SMALL_STATE(6872)] = 438190,
  [SMALL_STATE(6873)] = 438220,
  [SMALL_STATE(6874)] = 438273,
  [SMALL_STATE(6875)] = 438302,
  [SMALL_STATE(6876)] = 438331,
  [SMALL_STATE(6877)] = 438357,
  [SMALL_STATE(6878)] = 438407,
  [SMALL_STATE(6879)] = 438457,
  [SMALL_STATE(6880)] = 438491,
  [SMALL_STATE(6881)] = 438525,
  [SMALL_STATE(6882)] = 438577,
  [SMALL_STATE(6883)] = 438615,
  [SMALL_STATE(6884)] = 438671,
  [SMALL_STATE(6885)] = 438697,
  [SMALL_STATE(6886)] = 438723,
  [SMALL_STATE(6887)] = 438749,
  [SMALL_STATE(6888)] = 438775,
  [SMALL_STATE(6889)] = 438801,
  [SMALL_STATE(6890)] = 438853,
  [SMALL_STATE(6891)] = 438903,
  [SMALL_STATE(6892)] = 438937,
  [SMALL_STATE(6893)] = 438987,
  [SMALL_STATE(6894)] = 439039,
  [SMALL_STATE(6895)] = 439065,
  [SMALL_STATE(6896)] = 439117,
  [SMALL_STATE(6897)] = 439143,
  [SMALL_STATE(6898)] = 439168,
  [SMALL_STATE(6899)] = 439193,
  [SMALL_STATE(6900)] = 439218,
  [SMALL_STATE(6901)] = 439243,
  [SMALL_STATE(6902)] = 439268,
  [SMALL_STATE(6903)] = 439293,
  [SMALL_STATE(6904)] = 439348,
  [SMALL_STATE(6905)] = 439379,
  [SMALL_STATE(6906)] = 439404,
  [SMALL_STATE(6907)] = 439435,
  [SMALL_STATE(6908)] = 439484,
  [SMALL_STATE(6909)] = 439533,
  [SMALL_STATE(6910)] = 439558,
  [SMALL_STATE(6911)] = 439583,
  [SMALL_STATE(6912)] = 439632,
  [SMALL_STATE(6913)] = 439667,
  [SMALL_STATE(6914)] = 439716,
  [SMALL_STATE(6915)] = 439747,
  [SMALL_STATE(6916)] = 439778,
  [SMALL_STATE(6917)] = 439809,
  [SMALL_STATE(6918)] = 439840,
  [SMALL_STATE(6919)] = 439881,
  [SMALL_STATE(6920)] = 439922,
  [SMALL_STATE(6921)] = 439947,
  [SMALL_STATE(6922)] = 439988,
  [SMALL_STATE(6923)] = 440019,
  [SMALL_STATE(6924)] = 440044,
  [SMALL_STATE(6925)] = 440069,
  [SMALL_STATE(6926)] = 440100,
  [SMALL_STATE(6927)] = 440125,
  [SMALL_STATE(6928)] = 440156,
  [SMALL_STATE(6929)] = 440187,
  [SMALL_STATE(6930)] = 440212,
  [SMALL_STATE(6931)] = 440249,
  [SMALL_STATE(6932)] = 440276,
  [SMALL_STATE(6933)] = 440301,
  [SMALL_STATE(6934)] = 440342,
  [SMALL_STATE(6935)] = 440367,
  [SMALL_STATE(6936)] = 440392,
  [SMALL_STATE(6937)] = 440417,
  [SMALL_STATE(6938)] = 440442,
  [SMALL_STATE(6939)] = 440467,
  [SMALL_STATE(6940)] = 440492,
  [SMALL_STATE(6941)] = 440517,
  [SMALL_STATE(6942)] = 440542,
  [SMALL_STATE(6943)] = 440567,
  [SMALL_STATE(6944)] = 440592,
  [SMALL_STATE(6945)] = 440617,
  [SMALL_STATE(6946)] = 440658,
  [SMALL_STATE(6947)] = 440693,
  [SMALL_STATE(6948)] = 440718,
  [SMALL_STATE(6949)] = 440743,
  [SMALL_STATE(6950)] = 440770,
  [SMALL_STATE(6951)] = 440810,
  [SMALL_STATE(6952)] = 440838,
  [SMALL_STATE(6953)] = 440878,
  [SMALL_STATE(6954)] = 440906,
  [SMALL_STATE(6955)] = 440958,
  [SMALL_STATE(6956)] = 440998,
  [SMALL_STATE(6957)] = 441028,
  [SMALL_STATE(6958)] = 441054,
  [SMALL_STATE(6959)] = 441082,
  [SMALL_STATE(6960)] = 441110,
  [SMALL_STATE(6961)] = 441150,
  [SMALL_STATE(6962)] = 441190,
  [SMALL_STATE(6963)] = 441218,
  [SMALL_STATE(6964)] = 441244,
  [SMALL_STATE(6965)] = 441296,
  [SMALL_STATE(6966)] = 441348,
  [SMALL_STATE(6967)] = 441376,
  [SMALL_STATE(6968)] = 441428,
  [SMALL_STATE(6969)] = 441452,
  [SMALL_STATE(6970)] = 441480,
  [SMALL_STATE(6971)] = 441506,
  [SMALL_STATE(6972)] = 441530,
  [SMALL_STATE(6973)] = 441582,
  [SMALL_STATE(6974)] = 441634,
  [SMALL_STATE(6975)] = 441662,
  [SMALL_STATE(6976)] = 441702,
  [SMALL_STATE(6977)] = 441754,
  [SMALL_STATE(6978)] = 441806,
  [SMALL_STATE(6979)] = 441858,
  [SMALL_STATE(6980)] = 441910,
  [SMALL_STATE(6981)] = 441962,
  [SMALL_STATE(6982)] = 441986,
  [SMALL_STATE(6983)] = 442018,
  [SMALL_STATE(6984)] = 442044,
  [SMALL_STATE(6985)] = 442072,
  [SMALL_STATE(6986)] = 442124,
  [SMALL_STATE(6987)] = 442152,
  [SMALL_STATE(6988)] = 442182,
  [SMALL_STATE(6989)] = 442212,
  [SMALL_STATE(6990)] = 442240,
  [SMALL_STATE(6991)] = 442270,
  [SMALL_STATE(6992)] = 442298,
  [SMALL_STATE(6993)] = 442338,
  [SMALL_STATE(6994)] = 442368,
  [SMALL_STATE(6995)] = 442396,
  [SMALL_STATE(6996)] = 442424,
  [SMALL_STATE(6997)] = 442452,
  [SMALL_STATE(6998)] = 442480,
  [SMALL_STATE(6999)] = 442515,
  [SMALL_STATE(7000)] = 442538,
  [SMALL_STATE(7001)] = 442573,
  [SMALL_STATE(7002)] = 442598,
  [SMALL_STATE(7003)] = 442623,
  [SMALL_STATE(7004)] = 442648,
  [SMALL_STATE(7005)] = 442677,
  [SMALL_STATE(7006)] = 442704,
  [SMALL_STATE(7007)] = 442733,
  [SMALL_STATE(7008)] = 442760,
  [SMALL_STATE(7009)] = 442787,
  [SMALL_STATE(7010)] = 442816,
  [SMALL_STATE(7011)] = 442845,
  [SMALL_STATE(7012)] = 442884,
  [SMALL_STATE(7013)] = 442923,
  [SMALL_STATE(7014)] = 442962,
  [SMALL_STATE(7015)] = 443001,
  [SMALL_STATE(7016)] = 443026,
  [SMALL_STATE(7017)] = 443065,
  [SMALL_STATE(7018)] = 443090,
  [SMALL_STATE(7019)] = 443113,
  [SMALL_STATE(7020)] = 443140,
  [SMALL_STATE(7021)] = 443165,
  [SMALL_STATE(7022)] = 443188,
  [SMALL_STATE(7023)] = 443241,
  [SMALL_STATE(7024)] = 443266,
  [SMALL_STATE(7025)] = 443301,
  [SMALL_STATE(7026)] = 443328,
  [SMALL_STATE(7027)] = 443379,
  [SMALL_STATE(7028)] = 443414,
  [SMALL_STATE(7029)] = 443439,
  [SMALL_STATE(7030)] = 443492,
  [SMALL_STATE(7031)] = 443543,
  [SMALL_STATE(7032)] = 443574,
  [SMALL_STATE(7033)] = 443625,
  [SMALL_STATE(7034)] = 443650,
  [SMALL_STATE(7035)] = 443675,
  [SMALL_STATE(7036)] = 443700,
  [SMALL_STATE(7037)] = 443725,
  [SMALL_STATE(7038)] = 443750,
  [SMALL_STATE(7039)] = 443775,
  [SMALL_STATE(7040)] = 443800,
  [SMALL_STATE(7041)] = 443825,
  [SMALL_STATE(7042)] = 443848,
  [SMALL_STATE(7043)] = 443873,
  [SMALL_STATE(7044)] = 443898,
  [SMALL_STATE(7045)] = 443923,
  [SMALL_STATE(7046)] = 443974,
  [SMALL_STATE(7047)] = 443999,
  [SMALL_STATE(7048)] = 444028,
  [SMALL_STATE(7049)] = 444053,
  [SMALL_STATE(7050)] = 444078,
  [SMALL_STATE(7051)] = 444107,
  [SMALL_STATE(7052)] = 444142,
  [SMALL_STATE(7053)] = 444167,
  [SMALL_STATE(7054)] = 444192,
  [SMALL_STATE(7055)] = 444227,
  [SMALL_STATE(7056)] = 444252,
  [SMALL_STATE(7057)] = 444277,
  [SMALL_STATE(7058)] = 444302,
  [SMALL_STATE(7059)] = 444327,
  [SMALL_STATE(7060)] = 444352,
  [SMALL_STATE(7061)] = 444377,
  [SMALL_STATE(7062)] = 444400,
  [SMALL_STATE(7063)] = 444425,
  [SMALL_STATE(7064)] = 444452,
  [SMALL_STATE(7065)] = 444477,
  [SMALL_STATE(7066)] = 444502,
  [SMALL_STATE(7067)] = 444531,
  [SMALL_STATE(7068)] = 444556,
  [SMALL_STATE(7069)] = 444581,
  [SMALL_STATE(7070)] = 444606,
  [SMALL_STATE(7071)] = 444631,
  [SMALL_STATE(7072)] = 444653,
  [SMALL_STATE(7073)] = 444675,
  [SMALL_STATE(7074)] = 444697,
  [SMALL_STATE(7075)] = 444719,
  [SMALL_STATE(7076)] = 444741,
  [SMALL_STATE(7077)] = 444763,
  [SMALL_STATE(7078)] = 444785,
  [SMALL_STATE(7079)] = 444807,
  [SMALL_STATE(7080)] = 444829,
  [SMALL_STATE(7081)] = 444855,
  [SMALL_STATE(7082)] = 444877,
  [SMALL_STATE(7083)] = 444899,
  [SMALL_STATE(7084)] = 444921,
  [SMALL_STATE(7085)] = 444943,
  [SMALL_STATE(7086)] = 444977,
  [SMALL_STATE(7087)] = 444999,
  [SMALL_STATE(7088)] = 445021,
  [SMALL_STATE(7089)] = 445043,
  [SMALL_STATE(7090)] = 445065,
  [SMALL_STATE(7091)] = 445087,
  [SMALL_STATE(7092)] = 445109,
  [SMALL_STATE(7093)] = 445131,
  [SMALL_STATE(7094)] = 445153,
  [SMALL_STATE(7095)] = 445175,
  [SMALL_STATE(7096)] = 445197,
  [SMALL_STATE(7097)] = 445219,
  [SMALL_STATE(7098)] = 445241,
  [SMALL_STATE(7099)] = 445263,
  [SMALL_STATE(7100)] = 445289,
  [SMALL_STATE(7101)] = 445323,
  [SMALL_STATE(7102)] = 445345,
  [SMALL_STATE(7103)] = 445369,
  [SMALL_STATE(7104)] = 445393,
  [SMALL_STATE(7105)] = 445417,
  [SMALL_STATE(7106)] = 445439,
  [SMALL_STATE(7107)] = 445461,
  [SMALL_STATE(7108)] = 445483,
  [SMALL_STATE(7109)] = 445505,
  [SMALL_STATE(7110)] = 445529,
  [SMALL_STATE(7111)] = 445553,
  [SMALL_STATE(7112)] = 445575,
  [SMALL_STATE(7113)] = 445597,
  [SMALL_STATE(7114)] = 445623,
  [SMALL_STATE(7115)] = 445645,
  [SMALL_STATE(7116)] = 445667,
  [SMALL_STATE(7117)] = 445689,
  [SMALL_STATE(7118)] = 445711,
  [SMALL_STATE(7119)] = 445749,
  [SMALL_STATE(7120)] = 445775,
  [SMALL_STATE(7121)] = 445807,
  [SMALL_STATE(7122)] = 445829,
  [SMALL_STATE(7123)] = 445851,
  [SMALL_STATE(7124)] = 445873,
  [SMALL_STATE(7125)] = 445897,
  [SMALL_STATE(7126)] = 445921,
  [SMALL_STATE(7127)] = 445945,
  [SMALL_STATE(7128)] = 445977,
  [SMALL_STATE(7129)] = 445999,
  [SMALL_STATE(7130)] = 446023,
  [SMALL_STATE(7131)] = 446045,
  [SMALL_STATE(7132)] = 446067,
  [SMALL_STATE(7133)] = 446089,
  [SMALL_STATE(7134)] = 446111,
  [SMALL_STATE(7135)] = 446141,
  [SMALL_STATE(7136)] = 446163,
  [SMALL_STATE(7137)] = 446197,
  [SMALL_STATE(7138)] = 446219,
  [SMALL_STATE(7139)] = 446241,
  [SMALL_STATE(7140)] = 446267,
  [SMALL_STATE(7141)] = 446289,
  [SMALL_STATE(7142)] = 446315,
  [SMALL_STATE(7143)] = 446337,
  [SMALL_STATE(7144)] = 446371,
  [SMALL_STATE(7145)] = 446393,
  [SMALL_STATE(7146)] = 446415,
  [SMALL_STATE(7147)] = 446449,
  [SMALL_STATE(7148)] = 446475,
  [SMALL_STATE(7149)] = 446497,
  [SMALL_STATE(7150)] = 446519,
  [SMALL_STATE(7151)] = 446541,
  [SMALL_STATE(7152)] = 446563,
  [SMALL_STATE(7153)] = 446585,
  [SMALL_STATE(7154)] = 446619,
  [SMALL_STATE(7155)] = 446641,
  [SMALL_STATE(7156)] = 446679,
  [SMALL_STATE(7157)] = 446701,
  [SMALL_STATE(7158)] = 446739,
  [SMALL_STATE(7159)] = 446777,
  [SMALL_STATE(7160)] = 446815,
  [SMALL_STATE(7161)] = 446837,
  [SMALL_STATE(7162)] = 446859,
  [SMALL_STATE(7163)] = 446881,
  [SMALL_STATE(7164)] = 446903,
  [SMALL_STATE(7165)] = 446925,
  [SMALL_STATE(7166)] = 446968,
  [SMALL_STATE(7167)] = 447001,
  [SMALL_STATE(7168)] = 447034,
  [SMALL_STATE(7169)] = 447063,
  [SMALL_STATE(7170)] = 447084,
  [SMALL_STATE(7171)] = 447117,
  [SMALL_STATE(7172)] = 447138,
  [SMALL_STATE(7173)] = 447167,
  [SMALL_STATE(7174)] = 447200,
  [SMALL_STATE(7175)] = 447233,
  [SMALL_STATE(7176)] = 447266,
  [SMALL_STATE(7177)] = 447287,
  [SMALL_STATE(7178)] = 447316,
  [SMALL_STATE(7179)] = 447359,
  [SMALL_STATE(7180)] = 447402,
  [SMALL_STATE(7181)] = 447423,
  [SMALL_STATE(7182)] = 447452,
  [SMALL_STATE(7183)] = 447493,
  [SMALL_STATE(7184)] = 447536,
  [SMALL_STATE(7185)] = 447583,
  [SMALL_STATE(7186)] = 447626,
  [SMALL_STATE(7187)] = 447655,
  [SMALL_STATE(7188)] = 447702,
  [SMALL_STATE(7189)] = 447723,
  [SMALL_STATE(7190)] = 447744,
  [SMALL_STATE(7191)] = 447787,
  [SMALL_STATE(7192)] = 447830,
  [SMALL_STATE(7193)] = 447863,
  [SMALL_STATE(7194)] = 447906,
  [SMALL_STATE(7195)] = 447949,
  [SMALL_STATE(7196)] = 447972,
  [SMALL_STATE(7197)] = 448005,
  [SMALL_STATE(7198)] = 448038,
  [SMALL_STATE(7199)] = 448081,
  [SMALL_STATE(7200)] = 448114,
  [SMALL_STATE(7201)] = 448147,
  [SMALL_STATE(7202)] = 448168,
  [SMALL_STATE(7203)] = 448201,
  [SMALL_STATE(7204)] = 448242,
  [SMALL_STATE(7205)] = 448275,
  [SMALL_STATE(7206)] = 448296,
  [SMALL_STATE(7207)] = 448319,
  [SMALL_STATE(7208)] = 448342,
  [SMALL_STATE(7209)] = 448383,
  [SMALL_STATE(7210)] = 448426,
  [SMALL_STATE(7211)] = 448459,
  [SMALL_STATE(7212)] = 448500,
  [SMALL_STATE(7213)] = 448529,
  [SMALL_STATE(7214)] = 448558,
  [SMALL_STATE(7215)] = 448591,
  [SMALL_STATE(7216)] = 448638,
  [SMALL_STATE(7217)] = 448671,
  [SMALL_STATE(7218)] = 448714,
  [SMALL_STATE(7219)] = 448747,
  [SMALL_STATE(7220)] = 448780,
  [SMALL_STATE(7221)] = 448813,
  [SMALL_STATE(7222)] = 448846,
  [SMALL_STATE(7223)] = 448871,
  [SMALL_STATE(7224)] = 448892,
  [SMALL_STATE(7225)] = 448933,
  [SMALL_STATE(7226)] = 448974,
  [SMALL_STATE(7227)] = 449021,
  [SMALL_STATE(7228)] = 449044,
  [SMALL_STATE(7229)] = 449067,
  [SMALL_STATE(7230)] = 449108,
  [SMALL_STATE(7231)] = 449133,
  [SMALL_STATE(7232)] = 449176,
  [SMALL_STATE(7233)] = 449197,
  [SMALL_STATE(7234)] = 449240,
  [SMALL_STATE(7235)] = 449273,
  [SMALL_STATE(7236)] = 449316,
  [SMALL_STATE(7237)] = 449349,
  [SMALL_STATE(7238)] = 449372,
  [SMALL_STATE(7239)] = 449401,
  [SMALL_STATE(7240)] = 449424,
  [SMALL_STATE(7241)] = 449447,
  [SMALL_STATE(7242)] = 449480,
  [SMALL_STATE(7243)] = 449503,
  [SMALL_STATE(7244)] = 449536,
  [SMALL_STATE(7245)] = 449569,
  [SMALL_STATE(7246)] = 449609,
  [SMALL_STATE(7247)] = 449631,
  [SMALL_STATE(7248)] = 449651,
  [SMALL_STATE(7249)] = 449671,
  [SMALL_STATE(7250)] = 449691,
  [SMALL_STATE(7251)] = 449711,
  [SMALL_STATE(7252)] = 449731,
  [SMALL_STATE(7253)] = 449751,
  [SMALL_STATE(7254)] = 449771,
  [SMALL_STATE(7255)] = 449791,
  [SMALL_STATE(7256)] = 449811,
  [SMALL_STATE(7257)] = 449841,
  [SMALL_STATE(7258)] = 449865,
  [SMALL_STATE(7259)] = 449901,
  [SMALL_STATE(7260)] = 449921,
  [SMALL_STATE(7261)] = 449945,
  [SMALL_STATE(7262)] = 449985,
  [SMALL_STATE(7263)] = 450007,
  [SMALL_STATE(7264)] = 450043,
  [SMALL_STATE(7265)] = 450087,
  [SMALL_STATE(7266)] = 450111,
  [SMALL_STATE(7267)] = 450147,
  [SMALL_STATE(7268)] = 450177,
  [SMALL_STATE(7269)] = 450207,
  [SMALL_STATE(7270)] = 450231,
  [SMALL_STATE(7271)] = 450251,
  [SMALL_STATE(7272)] = 450287,
  [SMALL_STATE(7273)] = 450307,
  [SMALL_STATE(7274)] = 450335,
  [SMALL_STATE(7275)] = 450357,
  [SMALL_STATE(7276)] = 450397,
  [SMALL_STATE(7277)] = 450417,
  [SMALL_STATE(7278)] = 450457,
  [SMALL_STATE(7279)] = 450493,
  [SMALL_STATE(7280)] = 450537,
  [SMALL_STATE(7281)] = 450573,
  [SMALL_STATE(7282)] = 450609,
  [SMALL_STATE(7283)] = 450645,
  [SMALL_STATE(7284)] = 450665,
  [SMALL_STATE(7285)] = 450685,
  [SMALL_STATE(7286)] = 450705,
  [SMALL_STATE(7287)] = 450725,
  [SMALL_STATE(7288)] = 450745,
  [SMALL_STATE(7289)] = 450773,
  [SMALL_STATE(7290)] = 450809,
  [SMALL_STATE(7291)] = 450845,
  [SMALL_STATE(7292)] = 450881,
  [SMALL_STATE(7293)] = 450921,
  [SMALL_STATE(7294)] = 450945,
  [SMALL_STATE(7295)] = 450969,
  [SMALL_STATE(7296)] = 451005,
  [SMALL_STATE(7297)] = 451041,
  [SMALL_STATE(7298)] = 451085,
  [SMALL_STATE(7299)] = 451121,
  [SMALL_STATE(7300)] = 451165,
  [SMALL_STATE(7301)] = 451201,
  [SMALL_STATE(7302)] = 451237,
  [SMALL_STATE(7303)] = 451273,
  [SMALL_STATE(7304)] = 451309,
  [SMALL_STATE(7305)] = 451349,
  [SMALL_STATE(7306)] = 451385,
  [SMALL_STATE(7307)] = 451421,
  [SMALL_STATE(7308)] = 451457,
  [SMALL_STATE(7309)] = 451485,
  [SMALL_STATE(7310)] = 451527,
  [SMALL_STATE(7311)] = 451563,
  [SMALL_STATE(7312)] = 451601,
  [SMALL_STATE(7313)] = 451641,
  [SMALL_STATE(7314)] = 451679,
  [SMALL_STATE(7315)] = 451715,
  [SMALL_STATE(7316)] = 451755,
  [SMALL_STATE(7317)] = 451779,
  [SMALL_STATE(7318)] = 451811,
  [SMALL_STATE(7319)] = 451847,
  [SMALL_STATE(7320)] = 451887,
  [SMALL_STATE(7321)] = 451923,
  [SMALL_STATE(7322)] = 451959,
  [SMALL_STATE(7323)] = 451991,
  [SMALL_STATE(7324)] = 452011,
  [SMALL_STATE(7325)] = 452031,
  [SMALL_STATE(7326)] = 452073,
  [SMALL_STATE(7327)] = 452105,
  [SMALL_STATE(7328)] = 452125,
  [SMALL_STATE(7329)] = 452157,
  [SMALL_STATE(7330)] = 452193,
  [SMALL_STATE(7331)] = 452225,
  [SMALL_STATE(7332)] = 452261,
  [SMALL_STATE(7333)] = 452293,
  [SMALL_STATE(7334)] = 452335,
  [SMALL_STATE(7335)] = 452375,
  [SMALL_STATE(7336)] = 452403,
  [SMALL_STATE(7337)] = 452423,
  [SMALL_STATE(7338)] = 452443,
  [SMALL_STATE(7339)] = 452467,
  [SMALL_STATE(7340)] = 452487,
  [SMALL_STATE(7341)] = 452511,
  [SMALL_STATE(7342)] = 452531,
  [SMALL_STATE(7343)] = 452573,
  [SMALL_STATE(7344)] = 452613,
  [SMALL_STATE(7345)] = 452649,
  [SMALL_STATE(7346)] = 452689,
  [SMALL_STATE(7347)] = 452709,
  [SMALL_STATE(7348)] = 452729,
  [SMALL_STATE(7349)] = 452749,
  [SMALL_STATE(7350)] = 452793,
  [SMALL_STATE(7351)] = 452833,
  [SMALL_STATE(7352)] = 452853,
  [SMALL_STATE(7353)] = 452889,
  [SMALL_STATE(7354)] = 452909,
  [SMALL_STATE(7355)] = 452949,
  [SMALL_STATE(7356)] = 452993,
  [SMALL_STATE(7357)] = 453037,
  [SMALL_STATE(7358)] = 453065,
  [SMALL_STATE(7359)] = 453103,
  [SMALL_STATE(7360)] = 453139,
  [SMALL_STATE(7361)] = 453163,
  [SMALL_STATE(7362)] = 453201,
  [SMALL_STATE(7363)] = 453243,
  [SMALL_STATE(7364)] = 453283,
  [SMALL_STATE(7365)] = 453323,
  [SMALL_STATE(7366)] = 453347,
  [SMALL_STATE(7367)] = 453383,
  [SMALL_STATE(7368)] = 453407,
  [SMALL_STATE(7369)] = 453437,
  [SMALL_STATE(7370)] = 453473,
  [SMALL_STATE(7371)] = 453513,
  [SMALL_STATE(7372)] = 453543,
  [SMALL_STATE(7373)] = 453587,
  [SMALL_STATE(7374)] = 453615,
  [SMALL_STATE(7375)] = 453655,
  [SMALL_STATE(7376)] = 453691,
  [SMALL_STATE(7377)] = 453721,
  [SMALL_STATE(7378)] = 453751,
  [SMALL_STATE(7379)] = 453795,
  [SMALL_STATE(7380)] = 453825,
  [SMALL_STATE(7381)] = 453855,
  [SMALL_STATE(7382)] = 453895,
  [SMALL_STATE(7383)] = 453925,
  [SMALL_STATE(7384)] = 453955,
  [SMALL_STATE(7385)] = 453995,
  [SMALL_STATE(7386)] = 454035,
  [SMALL_STATE(7387)] = 454075,
  [SMALL_STATE(7388)] = 454111,
  [SMALL_STATE(7389)] = 454135,
  [SMALL_STATE(7390)] = 454171,
  [SMALL_STATE(7391)] = 454201,
  [SMALL_STATE(7392)] = 454225,
  [SMALL_STATE(7393)] = 454255,
  [SMALL_STATE(7394)] = 454297,
  [SMALL_STATE(7395)] = 454333,
  [SMALL_STATE(7396)] = 454373,
  [SMALL_STATE(7397)] = 454413,
  [SMALL_STATE(7398)] = 454443,
  [SMALL_STATE(7399)] = 454473,
  [SMALL_STATE(7400)] = 454503,
  [SMALL_STATE(7401)] = 454527,
  [SMALL_STATE(7402)] = 454555,
  [SMALL_STATE(7403)] = 454575,
  [SMALL_STATE(7404)] = 454599,
  [SMALL_STATE(7405)] = 454629,
  [SMALL_STATE(7406)] = 454659,
  [SMALL_STATE(7407)] = 454679,
  [SMALL_STATE(7408)] = 454705,
  [SMALL_STATE(7409)] = 454741,
  [SMALL_STATE(7410)] = 454778,
  [SMALL_STATE(7411)] = 454797,
  [SMALL_STATE(7412)] = 454816,
  [SMALL_STATE(7413)] = 454839,
  [SMALL_STATE(7414)] = 454880,
  [SMALL_STATE(7415)] = 454903,
  [SMALL_STATE(7416)] = 454922,
  [SMALL_STATE(7417)] = 454957,
  [SMALL_STATE(7418)] = 454980,
  [SMALL_STATE(7419)] = 455003,
  [SMALL_STATE(7420)] = 455044,
  [SMALL_STATE(7421)] = 455067,
  [SMALL_STATE(7422)] = 455090,
  [SMALL_STATE(7423)] = 455125,
  [SMALL_STATE(7424)] = 455160,
  [SMALL_STATE(7425)] = 455201,
  [SMALL_STATE(7426)] = 455234,
  [SMALL_STATE(7427)] = 455253,
  [SMALL_STATE(7428)] = 455294,
  [SMALL_STATE(7429)] = 455335,
  [SMALL_STATE(7430)] = 455370,
  [SMALL_STATE(7431)] = 455407,
  [SMALL_STATE(7432)] = 455448,
  [SMALL_STATE(7433)] = 455489,
  [SMALL_STATE(7434)] = 455524,
  [SMALL_STATE(7435)] = 455565,
  [SMALL_STATE(7436)] = 455604,
  [SMALL_STATE(7437)] = 455639,
  [SMALL_STATE(7438)] = 455674,
  [SMALL_STATE(7439)] = 455697,
  [SMALL_STATE(7440)] = 455732,
  [SMALL_STATE(7441)] = 455773,
  [SMALL_STATE(7442)] = 455800,
  [SMALL_STATE(7443)] = 455823,
  [SMALL_STATE(7444)] = 455864,
  [SMALL_STATE(7445)] = 455905,
  [SMALL_STATE(7446)] = 455946,
  [SMALL_STATE(7447)] = 455965,
  [SMALL_STATE(7448)] = 455984,
  [SMALL_STATE(7449)] = 456007,
  [SMALL_STATE(7450)] = 456026,
  [SMALL_STATE(7451)] = 456045,
  [SMALL_STATE(7452)] = 456072,
  [SMALL_STATE(7453)] = 456113,
  [SMALL_STATE(7454)] = 456140,
  [SMALL_STATE(7455)] = 456167,
  [SMALL_STATE(7456)] = 456202,
  [SMALL_STATE(7457)] = 456221,
  [SMALL_STATE(7458)] = 456244,
  [SMALL_STATE(7459)] = 456263,
  [SMALL_STATE(7460)] = 456290,
  [SMALL_STATE(7461)] = 456309,
  [SMALL_STATE(7462)] = 456344,
  [SMALL_STATE(7463)] = 456363,
  [SMALL_STATE(7464)] = 456382,
  [SMALL_STATE(7465)] = 456423,
  [SMALL_STATE(7466)] = 456464,
  [SMALL_STATE(7467)] = 456487,
  [SMALL_STATE(7468)] = 456506,
  [SMALL_STATE(7469)] = 456525,
  [SMALL_STATE(7470)] = 456564,
  [SMALL_STATE(7471)] = 456599,
  [SMALL_STATE(7472)] = 456622,
  [SMALL_STATE(7473)] = 456659,
  [SMALL_STATE(7474)] = 456696,
  [SMALL_STATE(7475)] = 456735,
  [SMALL_STATE(7476)] = 456758,
  [SMALL_STATE(7477)] = 456781,
  [SMALL_STATE(7478)] = 456822,
  [SMALL_STATE(7479)] = 456863,
  [SMALL_STATE(7480)] = 456890,
  [SMALL_STATE(7481)] = 456917,
  [SMALL_STATE(7482)] = 456954,
  [SMALL_STATE(7483)] = 456989,
  [SMALL_STATE(7484)] = 457012,
  [SMALL_STATE(7485)] = 457047,
  [SMALL_STATE(7486)] = 457088,
  [SMALL_STATE(7487)] = 457123,
  [SMALL_STATE(7488)] = 457164,
  [SMALL_STATE(7489)] = 457183,
  [SMALL_STATE(7490)] = 457222,
  [SMALL_STATE(7491)] = 457241,
  [SMALL_STATE(7492)] = 457260,
  [SMALL_STATE(7493)] = 457279,
  [SMALL_STATE(7494)] = 457314,
  [SMALL_STATE(7495)] = 457349,
  [SMALL_STATE(7496)] = 457388,
  [SMALL_STATE(7497)] = 457415,
  [SMALL_STATE(7498)] = 457434,
  [SMALL_STATE(7499)] = 457457,
  [SMALL_STATE(7500)] = 457492,
  [SMALL_STATE(7501)] = 457533,
  [SMALL_STATE(7502)] = 457568,
  [SMALL_STATE(7503)] = 457591,
  [SMALL_STATE(7504)] = 457614,
  [SMALL_STATE(7505)] = 457655,
  [SMALL_STATE(7506)] = 457674,
  [SMALL_STATE(7507)] = 457693,
  [SMALL_STATE(7508)] = 457712,
  [SMALL_STATE(7509)] = 457735,
  [SMALL_STATE(7510)] = 457772,
  [SMALL_STATE(7511)] = 457791,
  [SMALL_STATE(7512)] = 457814,
  [SMALL_STATE(7513)] = 457833,
  [SMALL_STATE(7514)] = 457855,
  [SMALL_STATE(7515)] = 457877,
  [SMALL_STATE(7516)] = 457913,
  [SMALL_STATE(7517)] = 457939,
  [SMALL_STATE(7518)] = 457961,
  [SMALL_STATE(7519)] = 457987,
  [SMALL_STATE(7520)] = 458009,
  [SMALL_STATE(7521)] = 458035,
  [SMALL_STATE(7522)] = 458057,
  [SMALL_STATE(7523)] = 458083,
  [SMALL_STATE(7524)] = 458109,
  [SMALL_STATE(7525)] = 458141,
  [SMALL_STATE(7526)] = 458163,
  [SMALL_STATE(7527)] = 458185,
  [SMALL_STATE(7528)] = 458211,
  [SMALL_STATE(7529)] = 458247,
  [SMALL_STATE(7530)] = 458273,
  [SMALL_STATE(7531)] = 458295,
  [SMALL_STATE(7532)] = 458313,
  [SMALL_STATE(7533)] = 458343,
  [SMALL_STATE(7534)] = 458375,
  [SMALL_STATE(7535)] = 458397,
  [SMALL_STATE(7536)] = 458427,
  [SMALL_STATE(7537)] = 458445,
  [SMALL_STATE(7538)] = 458463,
  [SMALL_STATE(7539)] = 458497,
  [SMALL_STATE(7540)] = 458527,
  [SMALL_STATE(7541)] = 458551,
  [SMALL_STATE(7542)] = 458587,
  [SMALL_STATE(7543)] = 458609,
  [SMALL_STATE(7544)] = 458627,
  [SMALL_STATE(7545)] = 458657,
  [SMALL_STATE(7546)] = 458687,
  [SMALL_STATE(7547)] = 458723,
  [SMALL_STATE(7548)] = 458745,
  [SMALL_STATE(7549)] = 458763,
  [SMALL_STATE(7550)] = 458795,
  [SMALL_STATE(7551)] = 458819,
  [SMALL_STATE(7552)] = 458837,
  [SMALL_STATE(7553)] = 458863,
  [SMALL_STATE(7554)] = 458881,
  [SMALL_STATE(7555)] = 458913,
  [SMALL_STATE(7556)] = 458931,
  [SMALL_STATE(7557)] = 458949,
  [SMALL_STATE(7558)] = 458981,
  [SMALL_STATE(7559)] = 459011,
  [SMALL_STATE(7560)] = 459041,
  [SMALL_STATE(7561)] = 459077,
  [SMALL_STATE(7562)] = 459109,
  [SMALL_STATE(7563)] = 459127,
  [SMALL_STATE(7564)] = 459151,
  [SMALL_STATE(7565)] = 459181,
  [SMALL_STATE(7566)] = 459205,
  [SMALL_STATE(7567)] = 459229,
  [SMALL_STATE(7568)] = 459259,
  [SMALL_STATE(7569)] = 459295,
  [SMALL_STATE(7570)] = 459331,
  [SMALL_STATE(7571)] = 459361,
  [SMALL_STATE(7572)] = 459379,
  [SMALL_STATE(7573)] = 459415,
  [SMALL_STATE(7574)] = 459433,
  [SMALL_STATE(7575)] = 459469,
  [SMALL_STATE(7576)] = 459499,
  [SMALL_STATE(7577)] = 459517,
  [SMALL_STATE(7578)] = 459547,
  [SMALL_STATE(7579)] = 459577,
  [SMALL_STATE(7580)] = 459611,
  [SMALL_STATE(7581)] = 459641,
  [SMALL_STATE(7582)] = 459669,
  [SMALL_STATE(7583)] = 459691,
  [SMALL_STATE(7584)] = 459719,
  [SMALL_STATE(7585)] = 459737,
  [SMALL_STATE(7586)] = 459755,
  [SMALL_STATE(7587)] = 459791,
  [SMALL_STATE(7588)] = 459827,
  [SMALL_STATE(7589)] = 459851,
  [SMALL_STATE(7590)] = 459873,
  [SMALL_STATE(7591)] = 459895,
  [SMALL_STATE(7592)] = 459913,
  [SMALL_STATE(7593)] = 459943,
  [SMALL_STATE(7594)] = 459961,
  [SMALL_STATE(7595)] = 459997,
  [SMALL_STATE(7596)] = 460015,
  [SMALL_STATE(7597)] = 460050,
  [SMALL_STATE(7598)] = 460067,
  [SMALL_STATE(7599)] = 460084,
  [SMALL_STATE(7600)] = 460115,
  [SMALL_STATE(7601)] = 460132,
  [SMALL_STATE(7602)] = 460155,
  [SMALL_STATE(7603)] = 460184,
  [SMALL_STATE(7604)] = 460219,
  [SMALL_STATE(7605)] = 460248,
  [SMALL_STATE(7606)] = 460277,
  [SMALL_STATE(7607)] = 460312,
  [SMALL_STATE(7608)] = 460343,
  [SMALL_STATE(7609)] = 460374,
  [SMALL_STATE(7610)] = 460405,
  [SMALL_STATE(7611)] = 460440,
  [SMALL_STATE(7612)] = 460457,
  [SMALL_STATE(7613)] = 460486,
  [SMALL_STATE(7614)] = 460503,
  [SMALL_STATE(7615)] = 460520,
  [SMALL_STATE(7616)] = 460543,
  [SMALL_STATE(7617)] = 460566,
  [SMALL_STATE(7618)] = 460597,
  [SMALL_STATE(7619)] = 460626,
  [SMALL_STATE(7620)] = 460645,
  [SMALL_STATE(7621)] = 460662,
  [SMALL_STATE(7622)] = 460697,
  [SMALL_STATE(7623)] = 460720,
  [SMALL_STATE(7624)] = 460739,
  [SMALL_STATE(7625)] = 460774,
  [SMALL_STATE(7626)] = 460809,
  [SMALL_STATE(7627)] = 460840,
  [SMALL_STATE(7628)] = 460869,
  [SMALL_STATE(7629)] = 460904,
  [SMALL_STATE(7630)] = 460935,
  [SMALL_STATE(7631)] = 460970,
  [SMALL_STATE(7632)] = 460993,
  [SMALL_STATE(7633)] = 461010,
  [SMALL_STATE(7634)] = 461041,
  [SMALL_STATE(7635)] = 461058,
  [SMALL_STATE(7636)] = 461089,
  [SMALL_STATE(7637)] = 461118,
  [SMALL_STATE(7638)] = 461153,
  [SMALL_STATE(7639)] = 461170,
  [SMALL_STATE(7640)] = 461187,
  [SMALL_STATE(7641)] = 461204,
  [SMALL_STATE(7642)] = 461235,
  [SMALL_STATE(7643)] = 461270,
  [SMALL_STATE(7644)] = 461287,
  [SMALL_STATE(7645)] = 461316,
  [SMALL_STATE(7646)] = 461333,
  [SMALL_STATE(7647)] = 461364,
  [SMALL_STATE(7648)] = 461381,
  [SMALL_STATE(7649)] = 461416,
  [SMALL_STATE(7650)] = 461433,
  [SMALL_STATE(7651)] = 461464,
  [SMALL_STATE(7652)] = 461499,
  [SMALL_STATE(7653)] = 461530,
  [SMALL_STATE(7654)] = 461559,
  [SMALL_STATE(7655)] = 461580,
  [SMALL_STATE(7656)] = 461597,
  [SMALL_STATE(7657)] = 461614,
  [SMALL_STATE(7658)] = 461635,
  [SMALL_STATE(7659)] = 461664,
  [SMALL_STATE(7660)] = 461693,
  [SMALL_STATE(7661)] = 461710,
  [SMALL_STATE(7662)] = 461727,
  [SMALL_STATE(7663)] = 461744,
  [SMALL_STATE(7664)] = 461775,
  [SMALL_STATE(7665)] = 461804,
  [SMALL_STATE(7666)] = 461833,
  [SMALL_STATE(7667)] = 461854,
  [SMALL_STATE(7668)] = 461883,
  [SMALL_STATE(7669)] = 461904,
  [SMALL_STATE(7670)] = 461933,
  [SMALL_STATE(7671)] = 461950,
  [SMALL_STATE(7672)] = 461971,
  [SMALL_STATE(7673)] = 462006,
  [SMALL_STATE(7674)] = 462035,
  [SMALL_STATE(7675)] = 462070,
  [SMALL_STATE(7676)] = 462105,
  [SMALL_STATE(7677)] = 462140,
  [SMALL_STATE(7678)] = 462171,
  [SMALL_STATE(7679)] = 462192,
  [SMALL_STATE(7680)] = 462213,
  [SMALL_STATE(7681)] = 462244,
  [SMALL_STATE(7682)] = 462273,
  [SMALL_STATE(7683)] = 462308,
  [SMALL_STATE(7684)] = 462339,
  [SMALL_STATE(7685)] = 462370,
  [SMALL_STATE(7686)] = 462405,
  [SMALL_STATE(7687)] = 462422,
  [SMALL_STATE(7688)] = 462439,
  [SMALL_STATE(7689)] = 462474,
  [SMALL_STATE(7690)] = 462491,
  [SMALL_STATE(7691)] = 462522,
  [SMALL_STATE(7692)] = 462553,
  [SMALL_STATE(7693)] = 462584,
  [SMALL_STATE(7694)] = 462601,
  [SMALL_STATE(7695)] = 462636,
  [SMALL_STATE(7696)] = 462667,
  [SMALL_STATE(7697)] = 462698,
  [SMALL_STATE(7698)] = 462733,
  [SMALL_STATE(7699)] = 462768,
  [SMALL_STATE(7700)] = 462797,
  [SMALL_STATE(7701)] = 462828,
  [SMALL_STATE(7702)] = 462847,
  [SMALL_STATE(7703)] = 462882,
  [SMALL_STATE(7704)] = 462917,
  [SMALL_STATE(7705)] = 462948,
  [SMALL_STATE(7706)] = 462979,
  [SMALL_STATE(7707)] = 463010,
  [SMALL_STATE(7708)] = 463027,
  [SMALL_STATE(7709)] = 463062,
  [SMALL_STATE(7710)] = 463093,
  [SMALL_STATE(7711)] = 463124,
  [SMALL_STATE(7712)] = 463159,
  [SMALL_STATE(7713)] = 463190,
  [SMALL_STATE(7714)] = 463219,
  [SMALL_STATE(7715)] = 463254,
  [SMALL_STATE(7716)] = 463283,
  [SMALL_STATE(7717)] = 463312,
  [SMALL_STATE(7718)] = 463343,
  [SMALL_STATE(7719)] = 463364,
  [SMALL_STATE(7720)] = 463381,
  [SMALL_STATE(7721)] = 463410,
  [SMALL_STATE(7722)] = 463441,
  [SMALL_STATE(7723)] = 463470,
  [SMALL_STATE(7724)] = 463487,
  [SMALL_STATE(7725)] = 463518,
  [SMALL_STATE(7726)] = 463535,
  [SMALL_STATE(7727)] = 463552,
  [SMALL_STATE(7728)] = 463578,
  [SMALL_STATE(7729)] = 463610,
  [SMALL_STATE(7730)] = 463638,
  [SMALL_STATE(7731)] = 463664,
  [SMALL_STATE(7732)] = 463692,
  [SMALL_STATE(7733)] = 463720,
  [SMALL_STATE(7734)] = 463746,
  [SMALL_STATE(7735)] = 463774,
  [SMALL_STATE(7736)] = 463792,
  [SMALL_STATE(7737)] = 463824,
  [SMALL_STATE(7738)] = 463852,
  [SMALL_STATE(7739)] = 463884,
  [SMALL_STATE(7740)] = 463904,
  [SMALL_STATE(7741)] = 463932,
  [SMALL_STATE(7742)] = 463964,
  [SMALL_STATE(7743)] = 463996,
  [SMALL_STATE(7744)] = 464016,
  [SMALL_STATE(7745)] = 464044,
  [SMALL_STATE(7746)] = 464070,
  [SMALL_STATE(7747)] = 464096,
  [SMALL_STATE(7748)] = 464128,
  [SMALL_STATE(7749)] = 464156,
  [SMALL_STATE(7750)] = 464188,
  [SMALL_STATE(7751)] = 464216,
  [SMALL_STATE(7752)] = 464244,
  [SMALL_STATE(7753)] = 464272,
  [SMALL_STATE(7754)] = 464298,
  [SMALL_STATE(7755)] = 464330,
  [SMALL_STATE(7756)] = 464362,
  [SMALL_STATE(7757)] = 464388,
  [SMALL_STATE(7758)] = 464416,
  [SMALL_STATE(7759)] = 464442,
  [SMALL_STATE(7760)] = 464468,
  [SMALL_STATE(7761)] = 464500,
  [SMALL_STATE(7762)] = 464526,
  [SMALL_STATE(7763)] = 464552,
  [SMALL_STATE(7764)] = 464580,
  [SMALL_STATE(7765)] = 464612,
  [SMALL_STATE(7766)] = 464640,
  [SMALL_STATE(7767)] = 464666,
  [SMALL_STATE(7768)] = 464698,
  [SMALL_STATE(7769)] = 464730,
  [SMALL_STATE(7770)] = 464762,
  [SMALL_STATE(7771)] = 464794,
  [SMALL_STATE(7772)] = 464822,
  [SMALL_STATE(7773)] = 464850,
  [SMALL_STATE(7774)] = 464882,
  [SMALL_STATE(7775)] = 464914,
  [SMALL_STATE(7776)] = 464946,
  [SMALL_STATE(7777)] = 464972,
  [SMALL_STATE(7778)] = 465000,
  [SMALL_STATE(7779)] = 465028,
  [SMALL_STATE(7780)] = 465056,
  [SMALL_STATE(7781)] = 465084,
  [SMALL_STATE(7782)] = 465112,
  [SMALL_STATE(7783)] = 465144,
  [SMALL_STATE(7784)] = 465170,
  [SMALL_STATE(7785)] = 465196,
  [SMALL_STATE(7786)] = 465224,
  [SMALL_STATE(7787)] = 465252,
  [SMALL_STATE(7788)] = 465278,
  [SMALL_STATE(7789)] = 465310,
  [SMALL_STATE(7790)] = 465342,
  [SMALL_STATE(7791)] = 465370,
  [SMALL_STATE(7792)] = 465398,
  [SMALL_STATE(7793)] = 465424,
  [SMALL_STATE(7794)] = 465456,
  [SMALL_STATE(7795)] = 465480,
  [SMALL_STATE(7796)] = 465512,
  [SMALL_STATE(7797)] = 465538,
  [SMALL_STATE(7798)] = 465562,
  [SMALL_STATE(7799)] = 465594,
  [SMALL_STATE(7800)] = 465620,
  [SMALL_STATE(7801)] = 465652,
  [SMALL_STATE(7802)] = 465684,
  [SMALL_STATE(7803)] = 465716,
  [SMALL_STATE(7804)] = 465742,
  [SMALL_STATE(7805)] = 465774,
  [SMALL_STATE(7806)] = 465802,
  [SMALL_STATE(7807)] = 465834,
  [SMALL_STATE(7808)] = 465866,
  [SMALL_STATE(7809)] = 465894,
  [SMALL_STATE(7810)] = 465922,
  [SMALL_STATE(7811)] = 465948,
  [SMALL_STATE(7812)] = 465980,
  [SMALL_STATE(7813)] = 466012,
  [SMALL_STATE(7814)] = 466044,
  [SMALL_STATE(7815)] = 466072,
  [SMALL_STATE(7816)] = 466098,
  [SMALL_STATE(7817)] = 466130,
  [SMALL_STATE(7818)] = 466162,
  [SMALL_STATE(7819)] = 466194,
  [SMALL_STATE(7820)] = 466226,
  [SMALL_STATE(7821)] = 466258,
  [SMALL_STATE(7822)] = 466290,
  [SMALL_STATE(7823)] = 466322,
  [SMALL_STATE(7824)] = 466350,
  [SMALL_STATE(7825)] = 466382,
  [SMALL_STATE(7826)] = 466410,
  [SMALL_STATE(7827)] = 466438,
  [SMALL_STATE(7828)] = 466470,
  [SMALL_STATE(7829)] = 466498,
  [SMALL_STATE(7830)] = 466524,
  [SMALL_STATE(7831)] = 466552,
  [SMALL_STATE(7832)] = 466580,
  [SMALL_STATE(7833)] = 466608,
  [SMALL_STATE(7834)] = 466636,
  [SMALL_STATE(7835)] = 466664,
  [SMALL_STATE(7836)] = 466696,
  [SMALL_STATE(7837)] = 466724,
  [SMALL_STATE(7838)] = 466744,
  [SMALL_STATE(7839)] = 466776,
  [SMALL_STATE(7840)] = 466802,
  [SMALL_STATE(7841)] = 466830,
  [SMALL_STATE(7842)] = 466862,
  [SMALL_STATE(7843)] = 466894,
  [SMALL_STATE(7844)] = 466922,
  [SMALL_STATE(7845)] = 466940,
  [SMALL_STATE(7846)] = 466964,
  [SMALL_STATE(7847)] = 466996,
  [SMALL_STATE(7848)] = 467028,
  [SMALL_STATE(7849)] = 467060,
  [SMALL_STATE(7850)] = 467084,
  [SMALL_STATE(7851)] = 467110,
  [SMALL_STATE(7852)] = 467138,
  [SMALL_STATE(7853)] = 467166,
  [SMALL_STATE(7854)] = 467192,
  [SMALL_STATE(7855)] = 467218,
  [SMALL_STATE(7856)] = 467240,
  [SMALL_STATE(7857)] = 467272,
  [SMALL_STATE(7858)] = 467296,
  [SMALL_STATE(7859)] = 467328,
  [SMALL_STATE(7860)] = 467356,
  [SMALL_STATE(7861)] = 467384,
  [SMALL_STATE(7862)] = 467404,
  [SMALL_STATE(7863)] = 467432,
  [SMALL_STATE(7864)] = 467460,
  [SMALL_STATE(7865)] = 467492,
  [SMALL_STATE(7866)] = 467524,
  [SMALL_STATE(7867)] = 467552,
  [SMALL_STATE(7868)] = 467578,
  [SMALL_STATE(7869)] = 467598,
  [SMALL_STATE(7870)] = 467626,
  [SMALL_STATE(7871)] = 467654,
  [SMALL_STATE(7872)] = 467682,
  [SMALL_STATE(7873)] = 467714,
  [SMALL_STATE(7874)] = 467742,
  [SMALL_STATE(7875)] = 467768,
  [SMALL_STATE(7876)] = 467800,
  [SMALL_STATE(7877)] = 467822,
  [SMALL_STATE(7878)] = 467848,
  [SMALL_STATE(7879)] = 467874,
  [SMALL_STATE(7880)] = 467900,
  [SMALL_STATE(7881)] = 467926,
  [SMALL_STATE(7882)] = 467958,
  [SMALL_STATE(7883)] = 467990,
  [SMALL_STATE(7884)] = 468016,
  [SMALL_STATE(7885)] = 468044,
  [SMALL_STATE(7886)] = 468066,
  [SMALL_STATE(7887)] = 468094,
  [SMALL_STATE(7888)] = 468126,
  [SMALL_STATE(7889)] = 468150,
  [SMALL_STATE(7890)] = 468182,
  [SMALL_STATE(7891)] = 468214,
  [SMALL_STATE(7892)] = 468246,
  [SMALL_STATE(7893)] = 468272,
  [SMALL_STATE(7894)] = 468298,
  [SMALL_STATE(7895)] = 468330,
  [SMALL_STATE(7896)] = 468362,
  [SMALL_STATE(7897)] = 468388,
  [SMALL_STATE(7898)] = 468410,
  [SMALL_STATE(7899)] = 468426,
  [SMALL_STATE(7900)] = 468458,
  [SMALL_STATE(7901)] = 468484,
  [SMALL_STATE(7902)] = 468516,
  [SMALL_STATE(7903)] = 468548,
  [SMALL_STATE(7904)] = 468580,
  [SMALL_STATE(7905)] = 468604,
  [SMALL_STATE(7906)] = 468620,
  [SMALL_STATE(7907)] = 468652,
  [SMALL_STATE(7908)] = 468680,
  [SMALL_STATE(7909)] = 468712,
  [SMALL_STATE(7910)] = 468740,
  [SMALL_STATE(7911)] = 468772,
  [SMALL_STATE(7912)] = 468792,
  [SMALL_STATE(7913)] = 468820,
  [SMALL_STATE(7914)] = 468846,
  [SMALL_STATE(7915)] = 468878,
  [SMALL_STATE(7916)] = 468910,
  [SMALL_STATE(7917)] = 468942,
  [SMALL_STATE(7918)] = 468974,
  [SMALL_STATE(7919)] = 469006,
  [SMALL_STATE(7920)] = 469038,
  [SMALL_STATE(7921)] = 469070,
  [SMALL_STATE(7922)] = 469102,
  [SMALL_STATE(7923)] = 469120,
  [SMALL_STATE(7924)] = 469148,
  [SMALL_STATE(7925)] = 469170,
  [SMALL_STATE(7926)] = 469196,
  [SMALL_STATE(7927)] = 469228,
  [SMALL_STATE(7928)] = 469260,
  [SMALL_STATE(7929)] = 469292,
  [SMALL_STATE(7930)] = 469320,
  [SMALL_STATE(7931)] = 469346,
  [SMALL_STATE(7932)] = 469366,
  [SMALL_STATE(7933)] = 469394,
  [SMALL_STATE(7934)] = 469422,
  [SMALL_STATE(7935)] = 469444,
  [SMALL_STATE(7936)] = 469476,
  [SMALL_STATE(7937)] = 469504,
  [SMALL_STATE(7938)] = 469536,
  [SMALL_STATE(7939)] = 469564,
  [SMALL_STATE(7940)] = 469596,
  [SMALL_STATE(7941)] = 469628,
  [SMALL_STATE(7942)] = 469660,
  [SMALL_STATE(7943)] = 469692,
  [SMALL_STATE(7944)] = 469721,
  [SMALL_STATE(7945)] = 469750,
  [SMALL_STATE(7946)] = 469779,
  [SMALL_STATE(7947)] = 469808,
  [SMALL_STATE(7948)] = 469831,
  [SMALL_STATE(7949)] = 469850,
  [SMALL_STATE(7950)] = 469879,
  [SMALL_STATE(7951)] = 469904,
  [SMALL_STATE(7952)] = 469933,
  [SMALL_STATE(7953)] = 469952,
  [SMALL_STATE(7954)] = 469977,
  [SMALL_STATE(7955)] = 470006,
  [SMALL_STATE(7956)] = 470035,
  [SMALL_STATE(7957)] = 470064,
  [SMALL_STATE(7958)] = 470083,
  [SMALL_STATE(7959)] = 470108,
  [SMALL_STATE(7960)] = 470137,
  [SMALL_STATE(7961)] = 470152,
  [SMALL_STATE(7962)] = 470171,
  [SMALL_STATE(7963)] = 470200,
  [SMALL_STATE(7964)] = 470229,
  [SMALL_STATE(7965)] = 470258,
  [SMALL_STATE(7966)] = 470287,
  [SMALL_STATE(7967)] = 470316,
  [SMALL_STATE(7968)] = 470345,
  [SMALL_STATE(7969)] = 470374,
  [SMALL_STATE(7970)] = 470389,
  [SMALL_STATE(7971)] = 470412,
  [SMALL_STATE(7972)] = 470433,
  [SMALL_STATE(7973)] = 470462,
  [SMALL_STATE(7974)] = 470491,
  [SMALL_STATE(7975)] = 470514,
  [SMALL_STATE(7976)] = 470529,
  [SMALL_STATE(7977)] = 470554,
  [SMALL_STATE(7978)] = 470583,
  [SMALL_STATE(7979)] = 470606,
  [SMALL_STATE(7980)] = 470629,
  [SMALL_STATE(7981)] = 470652,
  [SMALL_STATE(7982)] = 470675,
  [SMALL_STATE(7983)] = 470704,
  [SMALL_STATE(7984)] = 470733,
  [SMALL_STATE(7985)] = 470762,
  [SMALL_STATE(7986)] = 470791,
  [SMALL_STATE(7987)] = 470820,
  [SMALL_STATE(7988)] = 470835,
  [SMALL_STATE(7989)] = 470850,
  [SMALL_STATE(7990)] = 470879,
  [SMALL_STATE(7991)] = 470908,
  [SMALL_STATE(7992)] = 470937,
  [SMALL_STATE(7993)] = 470966,
  [SMALL_STATE(7994)] = 470995,
  [SMALL_STATE(7995)] = 471024,
  [SMALL_STATE(7996)] = 471053,
  [SMALL_STATE(7997)] = 471078,
  [SMALL_STATE(7998)] = 471107,
  [SMALL_STATE(7999)] = 471130,
  [SMALL_STATE(8000)] = 471159,
  [SMALL_STATE(8001)] = 471188,
  [SMALL_STATE(8002)] = 471217,
  [SMALL_STATE(8003)] = 471246,
  [SMALL_STATE(8004)] = 471275,
  [SMALL_STATE(8005)] = 471304,
  [SMALL_STATE(8006)] = 471329,
  [SMALL_STATE(8007)] = 471354,
  [SMALL_STATE(8008)] = 471383,
  [SMALL_STATE(8009)] = 471412,
  [SMALL_STATE(8010)] = 471439,
  [SMALL_STATE(8011)] = 471468,
  [SMALL_STATE(8012)] = 471483,
  [SMALL_STATE(8013)] = 471506,
  [SMALL_STATE(8014)] = 471533,
  [SMALL_STATE(8015)] = 471548,
  [SMALL_STATE(8016)] = 471577,
  [SMALL_STATE(8017)] = 471606,
  [SMALL_STATE(8018)] = 471635,
  [SMALL_STATE(8019)] = 471658,
  [SMALL_STATE(8020)] = 471685,
  [SMALL_STATE(8021)] = 471714,
  [SMALL_STATE(8022)] = 471737,
  [SMALL_STATE(8023)] = 471766,
  [SMALL_STATE(8024)] = 471789,
  [SMALL_STATE(8025)] = 471818,
  [SMALL_STATE(8026)] = 471847,
  [SMALL_STATE(8027)] = 471876,
  [SMALL_STATE(8028)] = 471899,
  [SMALL_STATE(8029)] = 471922,
  [SMALL_STATE(8030)] = 471937,
  [SMALL_STATE(8031)] = 471960,
  [SMALL_STATE(8032)] = 471989,
  [SMALL_STATE(8033)] = 472006,
  [SMALL_STATE(8034)] = 472023,
  [SMALL_STATE(8035)] = 472046,
  [SMALL_STATE(8036)] = 472075,
  [SMALL_STATE(8037)] = 472096,
  [SMALL_STATE(8038)] = 472125,
  [SMALL_STATE(8039)] = 472140,
  [SMALL_STATE(8040)] = 472169,
  [SMALL_STATE(8041)] = 472190,
  [SMALL_STATE(8042)] = 472211,
  [SMALL_STATE(8043)] = 472240,
  [SMALL_STATE(8044)] = 472261,
  [SMALL_STATE(8045)] = 472286,
  [SMALL_STATE(8046)] = 472315,
  [SMALL_STATE(8047)] = 472336,
  [SMALL_STATE(8048)] = 472365,
  [SMALL_STATE(8049)] = 472390,
  [SMALL_STATE(8050)] = 472419,
  [SMALL_STATE(8051)] = 472446,
  [SMALL_STATE(8052)] = 472473,
  [SMALL_STATE(8053)] = 472502,
  [SMALL_STATE(8054)] = 472531,
  [SMALL_STATE(8055)] = 472560,
  [SMALL_STATE(8056)] = 472589,
  [SMALL_STATE(8057)] = 472614,
  [SMALL_STATE(8058)] = 472637,
  [SMALL_STATE(8059)] = 472652,
  [SMALL_STATE(8060)] = 472675,
  [SMALL_STATE(8061)] = 472698,
  [SMALL_STATE(8062)] = 472727,
  [SMALL_STATE(8063)] = 472750,
  [SMALL_STATE(8064)] = 472779,
  [SMALL_STATE(8065)] = 472808,
  [SMALL_STATE(8066)] = 472831,
  [SMALL_STATE(8067)] = 472858,
  [SMALL_STATE(8068)] = 472883,
  [SMALL_STATE(8069)] = 472908,
  [SMALL_STATE(8070)] = 472937,
  [SMALL_STATE(8071)] = 472962,
  [SMALL_STATE(8072)] = 472991,
  [SMALL_STATE(8073)] = 473020,
  [SMALL_STATE(8074)] = 473049,
  [SMALL_STATE(8075)] = 473078,
  [SMALL_STATE(8076)] = 473101,
  [SMALL_STATE(8077)] = 473124,
  [SMALL_STATE(8078)] = 473143,
  [SMALL_STATE(8079)] = 473172,
  [SMALL_STATE(8080)] = 473187,
  [SMALL_STATE(8081)] = 473210,
  [SMALL_STATE(8082)] = 473233,
  [SMALL_STATE(8083)] = 473262,
  [SMALL_STATE(8084)] = 473291,
  [SMALL_STATE(8085)] = 473316,
  [SMALL_STATE(8086)] = 473339,
  [SMALL_STATE(8087)] = 473358,
  [SMALL_STATE(8088)] = 473381,
  [SMALL_STATE(8089)] = 473404,
  [SMALL_STATE(8090)] = 473429,
  [SMALL_STATE(8091)] = 473458,
  [SMALL_STATE(8092)] = 473487,
  [SMALL_STATE(8093)] = 473516,
  [SMALL_STATE(8094)] = 473545,
  [SMALL_STATE(8095)] = 473564,
  [SMALL_STATE(8096)] = 473589,
  [SMALL_STATE(8097)] = 473612,
  [SMALL_STATE(8098)] = 473637,
  [SMALL_STATE(8099)] = 473666,
  [SMALL_STATE(8100)] = 473689,
  [SMALL_STATE(8101)] = 473704,
  [SMALL_STATE(8102)] = 473729,
  [SMALL_STATE(8103)] = 473758,
  [SMALL_STATE(8104)] = 473781,
  [SMALL_STATE(8105)] = 473810,
  [SMALL_STATE(8106)] = 473837,
  [SMALL_STATE(8107)] = 473866,
  [SMALL_STATE(8108)] = 473895,
  [SMALL_STATE(8109)] = 473918,
  [SMALL_STATE(8110)] = 473947,
  [SMALL_STATE(8111)] = 473974,
  [SMALL_STATE(8112)] = 473993,
  [SMALL_STATE(8113)] = 474018,
  [SMALL_STATE(8114)] = 474041,
  [SMALL_STATE(8115)] = 474070,
  [SMALL_STATE(8116)] = 474097,
  [SMALL_STATE(8117)] = 474126,
  [SMALL_STATE(8118)] = 474149,
  [SMALL_STATE(8119)] = 474178,
  [SMALL_STATE(8120)] = 474207,
  [SMALL_STATE(8121)] = 474230,
  [SMALL_STATE(8122)] = 474253,
  [SMALL_STATE(8123)] = 474282,
  [SMALL_STATE(8124)] = 474305,
  [SMALL_STATE(8125)] = 474326,
  [SMALL_STATE(8126)] = 474343,
  [SMALL_STATE(8127)] = 474372,
  [SMALL_STATE(8128)] = 474401,
  [SMALL_STATE(8129)] = 474418,
  [SMALL_STATE(8130)] = 474437,
  [SMALL_STATE(8131)] = 474464,
  [SMALL_STATE(8132)] = 474486,
  [SMALL_STATE(8133)] = 474508,
  [SMALL_STATE(8134)] = 474530,
  [SMALL_STATE(8135)] = 474554,
  [SMALL_STATE(8136)] = 474572,
  [SMALL_STATE(8137)] = 474596,
  [SMALL_STATE(8138)] = 474620,
  [SMALL_STATE(8139)] = 474642,
  [SMALL_STATE(8140)] = 474666,
  [SMALL_STATE(8141)] = 474690,
  [SMALL_STATE(8142)] = 474712,
  [SMALL_STATE(8143)] = 474736,
  [SMALL_STATE(8144)] = 474760,
  [SMALL_STATE(8145)] = 474782,
  [SMALL_STATE(8146)] = 474806,
  [SMALL_STATE(8147)] = 474830,
  [SMALL_STATE(8148)] = 474850,
  [SMALL_STATE(8149)] = 474870,
  [SMALL_STATE(8150)] = 474894,
  [SMALL_STATE(8151)] = 474916,
  [SMALL_STATE(8152)] = 474938,
  [SMALL_STATE(8153)] = 474962,
  [SMALL_STATE(8154)] = 474980,
  [SMALL_STATE(8155)] = 475000,
  [SMALL_STATE(8156)] = 475022,
  [SMALL_STATE(8157)] = 475042,
  [SMALL_STATE(8158)] = 475056,
  [SMALL_STATE(8159)] = 475078,
  [SMALL_STATE(8160)] = 475100,
  [SMALL_STATE(8161)] = 475124,
  [SMALL_STATE(8162)] = 475148,
  [SMALL_STATE(8163)] = 475172,
  [SMALL_STATE(8164)] = 475192,
  [SMALL_STATE(8165)] = 475210,
  [SMALL_STATE(8166)] = 475232,
  [SMALL_STATE(8167)] = 475254,
  [SMALL_STATE(8168)] = 475274,
  [SMALL_STATE(8169)] = 475298,
  [SMALL_STATE(8170)] = 475322,
  [SMALL_STATE(8171)] = 475346,
  [SMALL_STATE(8172)] = 475368,
  [SMALL_STATE(8173)] = 475382,
  [SMALL_STATE(8174)] = 475400,
  [SMALL_STATE(8175)] = 475424,
  [SMALL_STATE(8176)] = 475448,
  [SMALL_STATE(8177)] = 475468,
  [SMALL_STATE(8178)] = 475486,
  [SMALL_STATE(8179)] = 475510,
  [SMALL_STATE(8180)] = 475530,
  [SMALL_STATE(8181)] = 475556,
  [SMALL_STATE(8182)] = 475580,
  [SMALL_STATE(8183)] = 475602,
  [SMALL_STATE(8184)] = 475626,
  [SMALL_STATE(8185)] = 475650,
  [SMALL_STATE(8186)] = 475674,
  [SMALL_STATE(8187)] = 475690,
  [SMALL_STATE(8188)] = 475714,
  [SMALL_STATE(8189)] = 475734,
  [SMALL_STATE(8190)] = 475760,
  [SMALL_STATE(8191)] = 475784,
  [SMALL_STATE(8192)] = 475808,
  [SMALL_STATE(8193)] = 475832,
  [SMALL_STATE(8194)] = 475856,
  [SMALL_STATE(8195)] = 475876,
  [SMALL_STATE(8196)] = 475898,
  [SMALL_STATE(8197)] = 475920,
  [SMALL_STATE(8198)] = 475944,
  [SMALL_STATE(8199)] = 475968,
  [SMALL_STATE(8200)] = 475988,
  [SMALL_STATE(8201)] = 476012,
  [SMALL_STATE(8202)] = 476034,
  [SMALL_STATE(8203)] = 476058,
  [SMALL_STATE(8204)] = 476082,
  [SMALL_STATE(8205)] = 476102,
  [SMALL_STATE(8206)] = 476126,
  [SMALL_STATE(8207)] = 476148,
  [SMALL_STATE(8208)] = 476174,
  [SMALL_STATE(8209)] = 476194,
  [SMALL_STATE(8210)] = 476216,
  [SMALL_STATE(8211)] = 476236,
  [SMALL_STATE(8212)] = 476258,
  [SMALL_STATE(8213)] = 476278,
  [SMALL_STATE(8214)] = 476302,
  [SMALL_STATE(8215)] = 476322,
  [SMALL_STATE(8216)] = 476346,
  [SMALL_STATE(8217)] = 476366,
  [SMALL_STATE(8218)] = 476390,
  [SMALL_STATE(8219)] = 476414,
  [SMALL_STATE(8220)] = 476436,
  [SMALL_STATE(8221)] = 476456,
  [SMALL_STATE(8222)] = 476478,
  [SMALL_STATE(8223)] = 476504,
  [SMALL_STATE(8224)] = 476524,
  [SMALL_STATE(8225)] = 476548,
  [SMALL_STATE(8226)] = 476570,
  [SMALL_STATE(8227)] = 476594,
  [SMALL_STATE(8228)] = 476616,
  [SMALL_STATE(8229)] = 476638,
  [SMALL_STATE(8230)] = 476660,
  [SMALL_STATE(8231)] = 476684,
  [SMALL_STATE(8232)] = 476710,
  [SMALL_STATE(8233)] = 476734,
  [SMALL_STATE(8234)] = 476758,
  [SMALL_STATE(8235)] = 476780,
  [SMALL_STATE(8236)] = 476800,
  [SMALL_STATE(8237)] = 476822,
  [SMALL_STATE(8238)] = 476842,
  [SMALL_STATE(8239)] = 476866,
  [SMALL_STATE(8240)] = 476890,
  [SMALL_STATE(8241)] = 476912,
  [SMALL_STATE(8242)] = 476932,
  [SMALL_STATE(8243)] = 476956,
  [SMALL_STATE(8244)] = 476982,
  [SMALL_STATE(8245)] = 477004,
  [SMALL_STATE(8246)] = 477028,
  [SMALL_STATE(8247)] = 477050,
  [SMALL_STATE(8248)] = 477070,
  [SMALL_STATE(8249)] = 477084,
  [SMALL_STATE(8250)] = 477108,
  [SMALL_STATE(8251)] = 477132,
  [SMALL_STATE(8252)] = 477146,
  [SMALL_STATE(8253)] = 477166,
  [SMALL_STATE(8254)] = 477188,
  [SMALL_STATE(8255)] = 477210,
  [SMALL_STATE(8256)] = 477236,
  [SMALL_STATE(8257)] = 477260,
  [SMALL_STATE(8258)] = 477278,
  [SMALL_STATE(8259)] = 477296,
  [SMALL_STATE(8260)] = 477320,
  [SMALL_STATE(8261)] = 477344,
  [SMALL_STATE(8262)] = 477368,
  [SMALL_STATE(8263)] = 477390,
  [SMALL_STATE(8264)] = 477412,
  [SMALL_STATE(8265)] = 477436,
  [SMALL_STATE(8266)] = 477456,
  [SMALL_STATE(8267)] = 477480,
  [SMALL_STATE(8268)] = 477504,
  [SMALL_STATE(8269)] = 477518,
  [SMALL_STATE(8270)] = 477544,
  [SMALL_STATE(8271)] = 477566,
  [SMALL_STATE(8272)] = 477592,
  [SMALL_STATE(8273)] = 477616,
  [SMALL_STATE(8274)] = 477638,
  [SMALL_STATE(8275)] = 477662,
  [SMALL_STATE(8276)] = 477686,
  [SMALL_STATE(8277)] = 477710,
  [SMALL_STATE(8278)] = 477734,
  [SMALL_STATE(8279)] = 477758,
  [SMALL_STATE(8280)] = 477782,
  [SMALL_STATE(8281)] = 477806,
  [SMALL_STATE(8282)] = 477830,
  [SMALL_STATE(8283)] = 477850,
  [SMALL_STATE(8284)] = 477874,
  [SMALL_STATE(8285)] = 477894,
  [SMALL_STATE(8286)] = 477914,
  [SMALL_STATE(8287)] = 477930,
  [SMALL_STATE(8288)] = 477954,
  [SMALL_STATE(8289)] = 477974,
  [SMALL_STATE(8290)] = 477998,
  [SMALL_STATE(8291)] = 478022,
  [SMALL_STATE(8292)] = 478046,
  [SMALL_STATE(8293)] = 478070,
  [SMALL_STATE(8294)] = 478094,
  [SMALL_STATE(8295)] = 478120,
  [SMALL_STATE(8296)] = 478140,
  [SMALL_STATE(8297)] = 478164,
  [SMALL_STATE(8298)] = 478188,
  [SMALL_STATE(8299)] = 478202,
  [SMALL_STATE(8300)] = 478222,
  [SMALL_STATE(8301)] = 478244,
  [SMALL_STATE(8302)] = 478264,
  [SMALL_STATE(8303)] = 478284,
  [SMALL_STATE(8304)] = 478306,
  [SMALL_STATE(8305)] = 478332,
  [SMALL_STATE(8306)] = 478356,
  [SMALL_STATE(8307)] = 478374,
  [SMALL_STATE(8308)] = 478398,
  [SMALL_STATE(8309)] = 478424,
  [SMALL_STATE(8310)] = 478448,
  [SMALL_STATE(8311)] = 478466,
  [SMALL_STATE(8312)] = 478486,
  [SMALL_STATE(8313)] = 478504,
  [SMALL_STATE(8314)] = 478528,
  [SMALL_STATE(8315)] = 478548,
  [SMALL_STATE(8316)] = 478572,
  [SMALL_STATE(8317)] = 478596,
  [SMALL_STATE(8318)] = 478620,
  [SMALL_STATE(8319)] = 478642,
  [SMALL_STATE(8320)] = 478666,
  [SMALL_STATE(8321)] = 478690,
  [SMALL_STATE(8322)] = 478712,
  [SMALL_STATE(8323)] = 478734,
  [SMALL_STATE(8324)] = 478758,
  [SMALL_STATE(8325)] = 478778,
  [SMALL_STATE(8326)] = 478791,
  [SMALL_STATE(8327)] = 478810,
  [SMALL_STATE(8328)] = 478827,
  [SMALL_STATE(8329)] = 478850,
  [SMALL_STATE(8330)] = 478863,
  [SMALL_STATE(8331)] = 478876,
  [SMALL_STATE(8332)] = 478893,
  [SMALL_STATE(8333)] = 478914,
  [SMALL_STATE(8334)] = 478935,
  [SMALL_STATE(8335)] = 478948,
  [SMALL_STATE(8336)] = 478969,
  [SMALL_STATE(8337)] = 478990,
  [SMALL_STATE(8338)] = 479009,
  [SMALL_STATE(8339)] = 479030,
  [SMALL_STATE(8340)] = 479047,
  [SMALL_STATE(8341)] = 479060,
  [SMALL_STATE(8342)] = 479081,
  [SMALL_STATE(8343)] = 479094,
  [SMALL_STATE(8344)] = 479111,
  [SMALL_STATE(8345)] = 479132,
  [SMALL_STATE(8346)] = 479153,
  [SMALL_STATE(8347)] = 479170,
  [SMALL_STATE(8348)] = 479191,
  [SMALL_STATE(8349)] = 479210,
  [SMALL_STATE(8350)] = 479227,
  [SMALL_STATE(8351)] = 479244,
  [SMALL_STATE(8352)] = 479263,
  [SMALL_STATE(8353)] = 479284,
  [SMALL_STATE(8354)] = 479303,
  [SMALL_STATE(8355)] = 479316,
  [SMALL_STATE(8356)] = 479337,
  [SMALL_STATE(8357)] = 479360,
  [SMALL_STATE(8358)] = 479377,
  [SMALL_STATE(8359)] = 479390,
  [SMALL_STATE(8360)] = 479411,
  [SMALL_STATE(8361)] = 479430,
  [SMALL_STATE(8362)] = 479447,
  [SMALL_STATE(8363)] = 479468,
  [SMALL_STATE(8364)] = 479485,
  [SMALL_STATE(8365)] = 479504,
  [SMALL_STATE(8366)] = 479523,
  [SMALL_STATE(8367)] = 479544,
  [SMALL_STATE(8368)] = 479561,
  [SMALL_STATE(8369)] = 479578,
  [SMALL_STATE(8370)] = 479601,
  [SMALL_STATE(8371)] = 479614,
  [SMALL_STATE(8372)] = 479633,
  [SMALL_STATE(8373)] = 479654,
  [SMALL_STATE(8374)] = 479675,
  [SMALL_STATE(8375)] = 479694,
  [SMALL_STATE(8376)] = 479713,
  [SMALL_STATE(8377)] = 479732,
  [SMALL_STATE(8378)] = 479753,
  [SMALL_STATE(8379)] = 479774,
  [SMALL_STATE(8380)] = 479795,
  [SMALL_STATE(8381)] = 479814,
  [SMALL_STATE(8382)] = 479827,
  [SMALL_STATE(8383)] = 479844,
  [SMALL_STATE(8384)] = 479863,
  [SMALL_STATE(8385)] = 479886,
  [SMALL_STATE(8386)] = 479903,
  [SMALL_STATE(8387)] = 479924,
  [SMALL_STATE(8388)] = 479943,
  [SMALL_STATE(8389)] = 479964,
  [SMALL_STATE(8390)] = 479987,
  [SMALL_STATE(8391)] = 480010,
  [SMALL_STATE(8392)] = 480027,
  [SMALL_STATE(8393)] = 480046,
  [SMALL_STATE(8394)] = 480067,
  [SMALL_STATE(8395)] = 480088,
  [SMALL_STATE(8396)] = 480109,
  [SMALL_STATE(8397)] = 480122,
  [SMALL_STATE(8398)] = 480143,
  [SMALL_STATE(8399)] = 480164,
  [SMALL_STATE(8400)] = 480177,
  [SMALL_STATE(8401)] = 480194,
  [SMALL_STATE(8402)] = 480215,
  [SMALL_STATE(8403)] = 480232,
  [SMALL_STATE(8404)] = 480249,
  [SMALL_STATE(8405)] = 480270,
  [SMALL_STATE(8406)] = 480289,
  [SMALL_STATE(8407)] = 480310,
  [SMALL_STATE(8408)] = 480331,
  [SMALL_STATE(8409)] = 480352,
  [SMALL_STATE(8410)] = 480373,
  [SMALL_STATE(8411)] = 480394,
  [SMALL_STATE(8412)] = 480415,
  [SMALL_STATE(8413)] = 480438,
  [SMALL_STATE(8414)] = 480451,
  [SMALL_STATE(8415)] = 480472,
  [SMALL_STATE(8416)] = 480493,
  [SMALL_STATE(8417)] = 480516,
  [SMALL_STATE(8418)] = 480539,
  [SMALL_STATE(8419)] = 480562,
  [SMALL_STATE(8420)] = 480581,
  [SMALL_STATE(8421)] = 480602,
  [SMALL_STATE(8422)] = 480621,
  [SMALL_STATE(8423)] = 480640,
  [SMALL_STATE(8424)] = 480661,
  [SMALL_STATE(8425)] = 480678,
  [SMALL_STATE(8426)] = 480691,
  [SMALL_STATE(8427)] = 480704,
  [SMALL_STATE(8428)] = 480725,
  [SMALL_STATE(8429)] = 480738,
  [SMALL_STATE(8430)] = 480751,
  [SMALL_STATE(8431)] = 480764,
  [SMALL_STATE(8432)] = 480785,
  [SMALL_STATE(8433)] = 480800,
  [SMALL_STATE(8434)] = 480817,
  [SMALL_STATE(8435)] = 480836,
  [SMALL_STATE(8436)] = 480849,
  [SMALL_STATE(8437)] = 480864,
  [SMALL_STATE(8438)] = 480885,
  [SMALL_STATE(8439)] = 480906,
  [SMALL_STATE(8440)] = 480925,
  [SMALL_STATE(8441)] = 480942,
  [SMALL_STATE(8442)] = 480963,
  [SMALL_STATE(8443)] = 480984,
  [SMALL_STATE(8444)] = 481007,
  [SMALL_STATE(8445)] = 481030,
  [SMALL_STATE(8446)] = 481053,
  [SMALL_STATE(8447)] = 481074,
  [SMALL_STATE(8448)] = 481087,
  [SMALL_STATE(8449)] = 481108,
  [SMALL_STATE(8450)] = 481129,
  [SMALL_STATE(8451)] = 481152,
  [SMALL_STATE(8452)] = 481171,
  [SMALL_STATE(8453)] = 481190,
  [SMALL_STATE(8454)] = 481207,
  [SMALL_STATE(8455)] = 481228,
  [SMALL_STATE(8456)] = 481251,
  [SMALL_STATE(8457)] = 481272,
  [SMALL_STATE(8458)] = 481285,
  [SMALL_STATE(8459)] = 481298,
  [SMALL_STATE(8460)] = 481311,
  [SMALL_STATE(8461)] = 481332,
  [SMALL_STATE(8462)] = 481345,
  [SMALL_STATE(8463)] = 481362,
  [SMALL_STATE(8464)] = 481375,
  [SMALL_STATE(8465)] = 481392,
  [SMALL_STATE(8466)] = 481409,
  [SMALL_STATE(8467)] = 481424,
  [SMALL_STATE(8468)] = 481445,
  [SMALL_STATE(8469)] = 481464,
  [SMALL_STATE(8470)] = 481481,
  [SMALL_STATE(8471)] = 481498,
  [SMALL_STATE(8472)] = 481519,
  [SMALL_STATE(8473)] = 481540,
  [SMALL_STATE(8474)] = 481553,
  [SMALL_STATE(8475)] = 481574,
  [SMALL_STATE(8476)] = 481597,
  [SMALL_STATE(8477)] = 481618,
  [SMALL_STATE(8478)] = 481631,
  [SMALL_STATE(8479)] = 481652,
  [SMALL_STATE(8480)] = 481667,
  [SMALL_STATE(8481)] = 481684,
  [SMALL_STATE(8482)] = 481705,
  [SMALL_STATE(8483)] = 481726,
  [SMALL_STATE(8484)] = 481747,
  [SMALL_STATE(8485)] = 481768,
  [SMALL_STATE(8486)] = 481787,
  [SMALL_STATE(8487)] = 481804,
  [SMALL_STATE(8488)] = 481827,
  [SMALL_STATE(8489)] = 481844,
  [SMALL_STATE(8490)] = 481861,
  [SMALL_STATE(8491)] = 481878,
  [SMALL_STATE(8492)] = 481899,
  [SMALL_STATE(8493)] = 481912,
  [SMALL_STATE(8494)] = 481935,
  [SMALL_STATE(8495)] = 481954,
  [SMALL_STATE(8496)] = 481975,
  [SMALL_STATE(8497)] = 481996,
  [SMALL_STATE(8498)] = 482015,
  [SMALL_STATE(8499)] = 482034,
  [SMALL_STATE(8500)] = 482051,
  [SMALL_STATE(8501)] = 482068,
  [SMALL_STATE(8502)] = 482089,
  [SMALL_STATE(8503)] = 482102,
  [SMALL_STATE(8504)] = 482125,
  [SMALL_STATE(8505)] = 482148,
  [SMALL_STATE(8506)] = 482169,
  [SMALL_STATE(8507)] = 482190,
  [SMALL_STATE(8508)] = 482211,
  [SMALL_STATE(8509)] = 482234,
  [SMALL_STATE(8510)] = 482257,
  [SMALL_STATE(8511)] = 482274,
  [SMALL_STATE(8512)] = 482295,
  [SMALL_STATE(8513)] = 482316,
  [SMALL_STATE(8514)] = 482337,
  [SMALL_STATE(8515)] = 482358,
  [SMALL_STATE(8516)] = 482375,
  [SMALL_STATE(8517)] = 482398,
  [SMALL_STATE(8518)] = 482419,
  [SMALL_STATE(8519)] = 482432,
  [SMALL_STATE(8520)] = 482453,
  [SMALL_STATE(8521)] = 482470,
  [SMALL_STATE(8522)] = 482487,
  [SMALL_STATE(8523)] = 482500,
  [SMALL_STATE(8524)] = 482517,
  [SMALL_STATE(8525)] = 482534,
  [SMALL_STATE(8526)] = 482547,
  [SMALL_STATE(8527)] = 482564,
  [SMALL_STATE(8528)] = 482583,
  [SMALL_STATE(8529)] = 482604,
  [SMALL_STATE(8530)] = 482627,
  [SMALL_STATE(8531)] = 482648,
  [SMALL_STATE(8532)] = 482667,
  [SMALL_STATE(8533)] = 482688,
  [SMALL_STATE(8534)] = 482709,
  [SMALL_STATE(8535)] = 482728,
  [SMALL_STATE(8536)] = 482749,
  [SMALL_STATE(8537)] = 482766,
  [SMALL_STATE(8538)] = 482779,
  [SMALL_STATE(8539)] = 482798,
  [SMALL_STATE(8540)] = 482819,
  [SMALL_STATE(8541)] = 482836,
  [SMALL_STATE(8542)] = 482849,
  [SMALL_STATE(8543)] = 482862,
  [SMALL_STATE(8544)] = 482883,
  [SMALL_STATE(8545)] = 482900,
  [SMALL_STATE(8546)] = 482923,
  [SMALL_STATE(8547)] = 482944,
  [SMALL_STATE(8548)] = 482965,
  [SMALL_STATE(8549)] = 482986,
  [SMALL_STATE(8550)] = 482999,
  [SMALL_STATE(8551)] = 483012,
  [SMALL_STATE(8552)] = 483029,
  [SMALL_STATE(8553)] = 483046,
  [SMALL_STATE(8554)] = 483067,
  [SMALL_STATE(8555)] = 483084,
  [SMALL_STATE(8556)] = 483103,
  [SMALL_STATE(8557)] = 483126,
  [SMALL_STATE(8558)] = 483143,
  [SMALL_STATE(8559)] = 483164,
  [SMALL_STATE(8560)] = 483181,
  [SMALL_STATE(8561)] = 483198,
  [SMALL_STATE(8562)] = 483219,
  [SMALL_STATE(8563)] = 483236,
  [SMALL_STATE(8564)] = 483257,
  [SMALL_STATE(8565)] = 483274,
  [SMALL_STATE(8566)] = 483293,
  [SMALL_STATE(8567)] = 483306,
  [SMALL_STATE(8568)] = 483323,
  [SMALL_STATE(8569)] = 483344,
  [SMALL_STATE(8570)] = 483361,
  [SMALL_STATE(8571)] = 483384,
  [SMALL_STATE(8572)] = 483401,
  [SMALL_STATE(8573)] = 483422,
  [SMALL_STATE(8574)] = 483441,
  [SMALL_STATE(8575)] = 483462,
  [SMALL_STATE(8576)] = 483483,
  [SMALL_STATE(8577)] = 483496,
  [SMALL_STATE(8578)] = 483519,
  [SMALL_STATE(8579)] = 483540,
  [SMALL_STATE(8580)] = 483553,
  [SMALL_STATE(8581)] = 483566,
  [SMALL_STATE(8582)] = 483587,
  [SMALL_STATE(8583)] = 483610,
  [SMALL_STATE(8584)] = 483631,
  [SMALL_STATE(8585)] = 483648,
  [SMALL_STATE(8586)] = 483669,
  [SMALL_STATE(8587)] = 483682,
  [SMALL_STATE(8588)] = 483701,
  [SMALL_STATE(8589)] = 483718,
  [SMALL_STATE(8590)] = 483739,
  [SMALL_STATE(8591)] = 483756,
  [SMALL_STATE(8592)] = 483777,
  [SMALL_STATE(8593)] = 483794,
  [SMALL_STATE(8594)] = 483811,
  [SMALL_STATE(8595)] = 483834,
  [SMALL_STATE(8596)] = 483853,
  [SMALL_STATE(8597)] = 483874,
  [SMALL_STATE(8598)] = 483897,
  [SMALL_STATE(8599)] = 483916,
  [SMALL_STATE(8600)] = 483939,
  [SMALL_STATE(8601)] = 483956,
  [SMALL_STATE(8602)] = 483973,
  [SMALL_STATE(8603)] = 483992,
  [SMALL_STATE(8604)] = 484011,
  [SMALL_STATE(8605)] = 484028,
  [SMALL_STATE(8606)] = 484045,
  [SMALL_STATE(8607)] = 484064,
  [SMALL_STATE(8608)] = 484085,
  [SMALL_STATE(8609)] = 484106,
  [SMALL_STATE(8610)] = 484125,
  [SMALL_STATE(8611)] = 484144,
  [SMALL_STATE(8612)] = 484163,
  [SMALL_STATE(8613)] = 484182,
  [SMALL_STATE(8614)] = 484199,
  [SMALL_STATE(8615)] = 484216,
  [SMALL_STATE(8616)] = 484237,
  [SMALL_STATE(8617)] = 484254,
  [SMALL_STATE(8618)] = 484271,
  [SMALL_STATE(8619)] = 484288,
  [SMALL_STATE(8620)] = 484305,
  [SMALL_STATE(8621)] = 484318,
  [SMALL_STATE(8622)] = 484341,
  [SMALL_STATE(8623)] = 484362,
  [SMALL_STATE(8624)] = 484383,
  [SMALL_STATE(8625)] = 484402,
  [SMALL_STATE(8626)] = 484419,
  [SMALL_STATE(8627)] = 484440,
  [SMALL_STATE(8628)] = 484457,
  [SMALL_STATE(8629)] = 484474,
  [SMALL_STATE(8630)] = 484493,
  [SMALL_STATE(8631)] = 484514,
  [SMALL_STATE(8632)] = 484533,
  [SMALL_STATE(8633)] = 484554,
  [SMALL_STATE(8634)] = 484569,
  [SMALL_STATE(8635)] = 484590,
  [SMALL_STATE(8636)] = 484607,
  [SMALL_STATE(8637)] = 484620,
  [SMALL_STATE(8638)] = 484633,
  [SMALL_STATE(8639)] = 484650,
  [SMALL_STATE(8640)] = 484669,
  [SMALL_STATE(8641)] = 484692,
  [SMALL_STATE(8642)] = 484705,
  [SMALL_STATE(8643)] = 484724,
  [SMALL_STATE(8644)] = 484739,
  [SMALL_STATE(8645)] = 484762,
  [SMALL_STATE(8646)] = 484775,
  [SMALL_STATE(8647)] = 484798,
  [SMALL_STATE(8648)] = 484815,
  [SMALL_STATE(8649)] = 484836,
  [SMALL_STATE(8650)] = 484857,
  [SMALL_STATE(8651)] = 484874,
  [SMALL_STATE(8652)] = 484893,
  [SMALL_STATE(8653)] = 484914,
  [SMALL_STATE(8654)] = 484931,
  [SMALL_STATE(8655)] = 484950,
  [SMALL_STATE(8656)] = 484971,
  [SMALL_STATE(8657)] = 484988,
  [SMALL_STATE(8658)] = 485001,
  [SMALL_STATE(8659)] = 485018,
  [SMALL_STATE(8660)] = 485035,
  [SMALL_STATE(8661)] = 485052,
  [SMALL_STATE(8662)] = 485073,
  [SMALL_STATE(8663)] = 485094,
  [SMALL_STATE(8664)] = 485107,
  [SMALL_STATE(8665)] = 485130,
  [SMALL_STATE(8666)] = 485147,
  [SMALL_STATE(8667)] = 485168,
  [SMALL_STATE(8668)] = 485189,
  [SMALL_STATE(8669)] = 485210,
  [SMALL_STATE(8670)] = 485231,
  [SMALL_STATE(8671)] = 485252,
  [SMALL_STATE(8672)] = 485265,
  [SMALL_STATE(8673)] = 485278,
  [SMALL_STATE(8674)] = 485301,
  [SMALL_STATE(8675)] = 485320,
  [SMALL_STATE(8676)] = 485332,
  [SMALL_STATE(8677)] = 485350,
  [SMALL_STATE(8678)] = 485368,
  [SMALL_STATE(8679)] = 485384,
  [SMALL_STATE(8680)] = 485400,
  [SMALL_STATE(8681)] = 485416,
  [SMALL_STATE(8682)] = 485432,
  [SMALL_STATE(8683)] = 485452,
  [SMALL_STATE(8684)] = 485468,
  [SMALL_STATE(8685)] = 485484,
  [SMALL_STATE(8686)] = 485500,
  [SMALL_STATE(8687)] = 485518,
  [SMALL_STATE(8688)] = 485536,
  [SMALL_STATE(8689)] = 485552,
  [SMALL_STATE(8690)] = 485572,
  [SMALL_STATE(8691)] = 485588,
  [SMALL_STATE(8692)] = 485608,
  [SMALL_STATE(8693)] = 485626,
  [SMALL_STATE(8694)] = 485642,
  [SMALL_STATE(8695)] = 485660,
  [SMALL_STATE(8696)] = 485676,
  [SMALL_STATE(8697)] = 485696,
  [SMALL_STATE(8698)] = 485712,
  [SMALL_STATE(8699)] = 485728,
  [SMALL_STATE(8700)] = 485744,
  [SMALL_STATE(8701)] = 485764,
  [SMALL_STATE(8702)] = 485784,
  [SMALL_STATE(8703)] = 485800,
  [SMALL_STATE(8704)] = 485816,
  [SMALL_STATE(8705)] = 485832,
  [SMALL_STATE(8706)] = 485848,
  [SMALL_STATE(8707)] = 485864,
  [SMALL_STATE(8708)] = 485880,
  [SMALL_STATE(8709)] = 485896,
  [SMALL_STATE(8710)] = 485914,
  [SMALL_STATE(8711)] = 485930,
  [SMALL_STATE(8712)] = 485946,
  [SMALL_STATE(8713)] = 485962,
  [SMALL_STATE(8714)] = 485978,
  [SMALL_STATE(8715)] = 485994,
  [SMALL_STATE(8716)] = 486010,
  [SMALL_STATE(8717)] = 486022,
  [SMALL_STATE(8718)] = 486040,
  [SMALL_STATE(8719)] = 486054,
  [SMALL_STATE(8720)] = 486070,
  [SMALL_STATE(8721)] = 486086,
  [SMALL_STATE(8722)] = 486102,
  [SMALL_STATE(8723)] = 486118,
  [SMALL_STATE(8724)] = 486134,
  [SMALL_STATE(8725)] = 486150,
  [SMALL_STATE(8726)] = 486166,
  [SMALL_STATE(8727)] = 486182,
  [SMALL_STATE(8728)] = 486198,
  [SMALL_STATE(8729)] = 486214,
  [SMALL_STATE(8730)] = 486230,
  [SMALL_STATE(8731)] = 486246,
  [SMALL_STATE(8732)] = 486262,
  [SMALL_STATE(8733)] = 486278,
  [SMALL_STATE(8734)] = 486294,
  [SMALL_STATE(8735)] = 486310,
  [SMALL_STATE(8736)] = 486326,
  [SMALL_STATE(8737)] = 486340,
  [SMALL_STATE(8738)] = 486356,
  [SMALL_STATE(8739)] = 486372,
  [SMALL_STATE(8740)] = 486388,
  [SMALL_STATE(8741)] = 486404,
  [SMALL_STATE(8742)] = 486420,
  [SMALL_STATE(8743)] = 486436,
  [SMALL_STATE(8744)] = 486452,
  [SMALL_STATE(8745)] = 486468,
  [SMALL_STATE(8746)] = 486484,
  [SMALL_STATE(8747)] = 486504,
  [SMALL_STATE(8748)] = 486520,
  [SMALL_STATE(8749)] = 486536,
  [SMALL_STATE(8750)] = 486550,
  [SMALL_STATE(8751)] = 486566,
  [SMALL_STATE(8752)] = 486582,
  [SMALL_STATE(8753)] = 486598,
  [SMALL_STATE(8754)] = 486614,
  [SMALL_STATE(8755)] = 486630,
  [SMALL_STATE(8756)] = 486646,
  [SMALL_STATE(8757)] = 486662,
  [SMALL_STATE(8758)] = 486678,
  [SMALL_STATE(8759)] = 486696,
  [SMALL_STATE(8760)] = 486714,
  [SMALL_STATE(8761)] = 486730,
  [SMALL_STATE(8762)] = 486746,
  [SMALL_STATE(8763)] = 486760,
  [SMALL_STATE(8764)] = 486776,
  [SMALL_STATE(8765)] = 486792,
  [SMALL_STATE(8766)] = 486806,
  [SMALL_STATE(8767)] = 486822,
  [SMALL_STATE(8768)] = 486838,
  [SMALL_STATE(8769)] = 486854,
  [SMALL_STATE(8770)] = 486872,
  [SMALL_STATE(8771)] = 486888,
  [SMALL_STATE(8772)] = 486904,
  [SMALL_STATE(8773)] = 486920,
  [SMALL_STATE(8774)] = 486936,
  [SMALL_STATE(8775)] = 486952,
  [SMALL_STATE(8776)] = 486964,
  [SMALL_STATE(8777)] = 486978,
  [SMALL_STATE(8778)] = 486996,
  [SMALL_STATE(8779)] = 487014,
  [SMALL_STATE(8780)] = 487032,
  [SMALL_STATE(8781)] = 487048,
  [SMALL_STATE(8782)] = 487064,
  [SMALL_STATE(8783)] = 487080,
  [SMALL_STATE(8784)] = 487096,
  [SMALL_STATE(8785)] = 487112,
  [SMALL_STATE(8786)] = 487132,
  [SMALL_STATE(8787)] = 487148,
  [SMALL_STATE(8788)] = 487164,
  [SMALL_STATE(8789)] = 487180,
  [SMALL_STATE(8790)] = 487196,
  [SMALL_STATE(8791)] = 487212,
  [SMALL_STATE(8792)] = 487228,
  [SMALL_STATE(8793)] = 487244,
  [SMALL_STATE(8794)] = 487264,
  [SMALL_STATE(8795)] = 487284,
  [SMALL_STATE(8796)] = 487300,
  [SMALL_STATE(8797)] = 487320,
  [SMALL_STATE(8798)] = 487340,
  [SMALL_STATE(8799)] = 487358,
  [SMALL_STATE(8800)] = 487374,
  [SMALL_STATE(8801)] = 487390,
  [SMALL_STATE(8802)] = 487406,
  [SMALL_STATE(8803)] = 487424,
  [SMALL_STATE(8804)] = 487440,
  [SMALL_STATE(8805)] = 487458,
  [SMALL_STATE(8806)] = 487474,
  [SMALL_STATE(8807)] = 487494,
  [SMALL_STATE(8808)] = 487514,
  [SMALL_STATE(8809)] = 487530,
  [SMALL_STATE(8810)] = 487548,
  [SMALL_STATE(8811)] = 487564,
  [SMALL_STATE(8812)] = 487582,
  [SMALL_STATE(8813)] = 487598,
  [SMALL_STATE(8814)] = 487618,
  [SMALL_STATE(8815)] = 487634,
  [SMALL_STATE(8816)] = 487650,
  [SMALL_STATE(8817)] = 487668,
  [SMALL_STATE(8818)] = 487684,
  [SMALL_STATE(8819)] = 487700,
  [SMALL_STATE(8820)] = 487716,
  [SMALL_STATE(8821)] = 487732,
  [SMALL_STATE(8822)] = 487744,
  [SMALL_STATE(8823)] = 487756,
  [SMALL_STATE(8824)] = 487772,
  [SMALL_STATE(8825)] = 487788,
  [SMALL_STATE(8826)] = 487804,
  [SMALL_STATE(8827)] = 487820,
  [SMALL_STATE(8828)] = 487834,
  [SMALL_STATE(8829)] = 487850,
  [SMALL_STATE(8830)] = 487866,
  [SMALL_STATE(8831)] = 487882,
  [SMALL_STATE(8832)] = 487898,
  [SMALL_STATE(8833)] = 487916,
  [SMALL_STATE(8834)] = 487934,
  [SMALL_STATE(8835)] = 487948,
  [SMALL_STATE(8836)] = 487964,
  [SMALL_STATE(8837)] = 487980,
  [SMALL_STATE(8838)] = 487996,
  [SMALL_STATE(8839)] = 488014,
  [SMALL_STATE(8840)] = 488030,
  [SMALL_STATE(8841)] = 488050,
  [SMALL_STATE(8842)] = 488066,
  [SMALL_STATE(8843)] = 488082,
  [SMALL_STATE(8844)] = 488098,
  [SMALL_STATE(8845)] = 488114,
  [SMALL_STATE(8846)] = 488130,
  [SMALL_STATE(8847)] = 488150,
  [SMALL_STATE(8848)] = 488166,
  [SMALL_STATE(8849)] = 488184,
  [SMALL_STATE(8850)] = 488200,
  [SMALL_STATE(8851)] = 488216,
  [SMALL_STATE(8852)] = 488232,
  [SMALL_STATE(8853)] = 488248,
  [SMALL_STATE(8854)] = 488262,
  [SMALL_STATE(8855)] = 488276,
  [SMALL_STATE(8856)] = 488292,
  [SMALL_STATE(8857)] = 488310,
  [SMALL_STATE(8858)] = 488330,
  [SMALL_STATE(8859)] = 488344,
  [SMALL_STATE(8860)] = 488360,
  [SMALL_STATE(8861)] = 488378,
  [SMALL_STATE(8862)] = 488396,
  [SMALL_STATE(8863)] = 488412,
  [SMALL_STATE(8864)] = 488428,
  [SMALL_STATE(8865)] = 488444,
  [SMALL_STATE(8866)] = 488460,
  [SMALL_STATE(8867)] = 488476,
  [SMALL_STATE(8868)] = 488492,
  [SMALL_STATE(8869)] = 488506,
  [SMALL_STATE(8870)] = 488522,
  [SMALL_STATE(8871)] = 488540,
  [SMALL_STATE(8872)] = 488556,
  [SMALL_STATE(8873)] = 488572,
  [SMALL_STATE(8874)] = 488588,
  [SMALL_STATE(8875)] = 488604,
  [SMALL_STATE(8876)] = 488620,
  [SMALL_STATE(8877)] = 488636,
  [SMALL_STATE(8878)] = 488652,
  [SMALL_STATE(8879)] = 488668,
  [SMALL_STATE(8880)] = 488684,
  [SMALL_STATE(8881)] = 488700,
  [SMALL_STATE(8882)] = 488716,
  [SMALL_STATE(8883)] = 488732,
  [SMALL_STATE(8884)] = 488748,
  [SMALL_STATE(8885)] = 488764,
  [SMALL_STATE(8886)] = 488780,
  [SMALL_STATE(8887)] = 488800,
  [SMALL_STATE(8888)] = 488816,
  [SMALL_STATE(8889)] = 488832,
  [SMALL_STATE(8890)] = 488848,
  [SMALL_STATE(8891)] = 488864,
  [SMALL_STATE(8892)] = 488880,
  [SMALL_STATE(8893)] = 488896,
  [SMALL_STATE(8894)] = 488912,
  [SMALL_STATE(8895)] = 488930,
  [SMALL_STATE(8896)] = 488946,
  [SMALL_STATE(8897)] = 488962,
  [SMALL_STATE(8898)] = 488980,
  [SMALL_STATE(8899)] = 488996,
  [SMALL_STATE(8900)] = 489016,
  [SMALL_STATE(8901)] = 489034,
  [SMALL_STATE(8902)] = 489048,
  [SMALL_STATE(8903)] = 489068,
  [SMALL_STATE(8904)] = 489086,
  [SMALL_STATE(8905)] = 489102,
  [SMALL_STATE(8906)] = 489118,
  [SMALL_STATE(8907)] = 489134,
  [SMALL_STATE(8908)] = 489150,
  [SMALL_STATE(8909)] = 489166,
  [SMALL_STATE(8910)] = 489182,
  [SMALL_STATE(8911)] = 489198,
  [SMALL_STATE(8912)] = 489214,
  [SMALL_STATE(8913)] = 489232,
  [SMALL_STATE(8914)] = 489248,
  [SMALL_STATE(8915)] = 489264,
  [SMALL_STATE(8916)] = 489280,
  [SMALL_STATE(8917)] = 489296,
  [SMALL_STATE(8918)] = 489312,
  [SMALL_STATE(8919)] = 489328,
  [SMALL_STATE(8920)] = 489344,
  [SMALL_STATE(8921)] = 489360,
  [SMALL_STATE(8922)] = 489380,
  [SMALL_STATE(8923)] = 489396,
  [SMALL_STATE(8924)] = 489412,
  [SMALL_STATE(8925)] = 489428,
  [SMALL_STATE(8926)] = 489444,
  [SMALL_STATE(8927)] = 489460,
  [SMALL_STATE(8928)] = 489478,
  [SMALL_STATE(8929)] = 489498,
  [SMALL_STATE(8930)] = 489518,
  [SMALL_STATE(8931)] = 489534,
  [SMALL_STATE(8932)] = 489550,
  [SMALL_STATE(8933)] = 489566,
  [SMALL_STATE(8934)] = 489586,
  [SMALL_STATE(8935)] = 489600,
  [SMALL_STATE(8936)] = 489616,
  [SMALL_STATE(8937)] = 489634,
  [SMALL_STATE(8938)] = 489650,
  [SMALL_STATE(8939)] = 489666,
  [SMALL_STATE(8940)] = 489682,
  [SMALL_STATE(8941)] = 489698,
  [SMALL_STATE(8942)] = 489714,
  [SMALL_STATE(8943)] = 489730,
  [SMALL_STATE(8944)] = 489746,
  [SMALL_STATE(8945)] = 489762,
  [SMALL_STATE(8946)] = 489778,
  [SMALL_STATE(8947)] = 489794,
  [SMALL_STATE(8948)] = 489810,
  [SMALL_STATE(8949)] = 489830,
  [SMALL_STATE(8950)] = 489850,
  [SMALL_STATE(8951)] = 489866,
  [SMALL_STATE(8952)] = 489882,
  [SMALL_STATE(8953)] = 489896,
  [SMALL_STATE(8954)] = 489910,
  [SMALL_STATE(8955)] = 489926,
  [SMALL_STATE(8956)] = 489942,
  [SMALL_STATE(8957)] = 489958,
  [SMALL_STATE(8958)] = 489970,
  [SMALL_STATE(8959)] = 489986,
  [SMALL_STATE(8960)] = 490002,
  [SMALL_STATE(8961)] = 490022,
  [SMALL_STATE(8962)] = 490036,
  [SMALL_STATE(8963)] = 490056,
  [SMALL_STATE(8964)] = 490072,
  [SMALL_STATE(8965)] = 490088,
  [SMALL_STATE(8966)] = 490102,
  [SMALL_STATE(8967)] = 490116,
  [SMALL_STATE(8968)] = 490132,
  [SMALL_STATE(8969)] = 490148,
  [SMALL_STATE(8970)] = 490162,
  [SMALL_STATE(8971)] = 490178,
  [SMALL_STATE(8972)] = 490194,
  [SMALL_STATE(8973)] = 490210,
  [SMALL_STATE(8974)] = 490226,
  [SMALL_STATE(8975)] = 490242,
  [SMALL_STATE(8976)] = 490258,
  [SMALL_STATE(8977)] = 490274,
  [SMALL_STATE(8978)] = 490290,
  [SMALL_STATE(8979)] = 490306,
  [SMALL_STATE(8980)] = 490322,
  [SMALL_STATE(8981)] = 490338,
  [SMALL_STATE(8982)] = 490356,
  [SMALL_STATE(8983)] = 490374,
  [SMALL_STATE(8984)] = 490390,
  [SMALL_STATE(8985)] = 490406,
  [SMALL_STATE(8986)] = 490422,
  [SMALL_STATE(8987)] = 490438,
  [SMALL_STATE(8988)] = 490454,
  [SMALL_STATE(8989)] = 490470,
  [SMALL_STATE(8990)] = 490486,
  [SMALL_STATE(8991)] = 490500,
  [SMALL_STATE(8992)] = 490516,
  [SMALL_STATE(8993)] = 490532,
  [SMALL_STATE(8994)] = 490544,
  [SMALL_STATE(8995)] = 490562,
  [SMALL_STATE(8996)] = 490578,
  [SMALL_STATE(8997)] = 490594,
  [SMALL_STATE(8998)] = 490610,
  [SMALL_STATE(8999)] = 490626,
  [SMALL_STATE(9000)] = 490642,
  [SMALL_STATE(9001)] = 490658,
  [SMALL_STATE(9002)] = 490674,
  [SMALL_STATE(9003)] = 490694,
  [SMALL_STATE(9004)] = 490710,
  [SMALL_STATE(9005)] = 490726,
  [SMALL_STATE(9006)] = 490742,
  [SMALL_STATE(9007)] = 490758,
  [SMALL_STATE(9008)] = 490776,
  [SMALL_STATE(9009)] = 490794,
  [SMALL_STATE(9010)] = 490812,
  [SMALL_STATE(9011)] = 490828,
  [SMALL_STATE(9012)] = 490844,
  [SMALL_STATE(9013)] = 490862,
  [SMALL_STATE(9014)] = 490880,
  [SMALL_STATE(9015)] = 490898,
  [SMALL_STATE(9016)] = 490914,
  [SMALL_STATE(9017)] = 490930,
  [SMALL_STATE(9018)] = 490948,
  [SMALL_STATE(9019)] = 490966,
  [SMALL_STATE(9020)] = 490982,
  [SMALL_STATE(9021)] = 490998,
  [SMALL_STATE(9022)] = 491014,
  [SMALL_STATE(9023)] = 491030,
  [SMALL_STATE(9024)] = 491048,
  [SMALL_STATE(9025)] = 491066,
  [SMALL_STATE(9026)] = 491084,
  [SMALL_STATE(9027)] = 491102,
  [SMALL_STATE(9028)] = 491120,
  [SMALL_STATE(9029)] = 491136,
  [SMALL_STATE(9030)] = 491154,
  [SMALL_STATE(9031)] = 491170,
  [SMALL_STATE(9032)] = 491182,
  [SMALL_STATE(9033)] = 491202,
  [SMALL_STATE(9034)] = 491218,
  [SMALL_STATE(9035)] = 491234,
  [SMALL_STATE(9036)] = 491252,
  [SMALL_STATE(9037)] = 491268,
  [SMALL_STATE(9038)] = 491286,
  [SMALL_STATE(9039)] = 491304,
  [SMALL_STATE(9040)] = 491320,
  [SMALL_STATE(9041)] = 491336,
  [SMALL_STATE(9042)] = 491352,
  [SMALL_STATE(9043)] = 491366,
  [SMALL_STATE(9044)] = 491382,
  [SMALL_STATE(9045)] = 491398,
  [SMALL_STATE(9046)] = 491414,
  [SMALL_STATE(9047)] = 491432,
  [SMALL_STATE(9048)] = 491448,
  [SMALL_STATE(9049)] = 491462,
  [SMALL_STATE(9050)] = 491478,
  [SMALL_STATE(9051)] = 491496,
  [SMALL_STATE(9052)] = 491512,
  [SMALL_STATE(9053)] = 491528,
  [SMALL_STATE(9054)] = 491546,
  [SMALL_STATE(9055)] = 491564,
  [SMALL_STATE(9056)] = 491584,
  [SMALL_STATE(9057)] = 491602,
  [SMALL_STATE(9058)] = 491618,
  [SMALL_STATE(9059)] = 491634,
  [SMALL_STATE(9060)] = 491650,
  [SMALL_STATE(9061)] = 491668,
  [SMALL_STATE(9062)] = 491686,
  [SMALL_STATE(9063)] = 491702,
  [SMALL_STATE(9064)] = 491722,
  [SMALL_STATE(9065)] = 491738,
  [SMALL_STATE(9066)] = 491756,
  [SMALL_STATE(9067)] = 491774,
  [SMALL_STATE(9068)] = 491792,
  [SMALL_STATE(9069)] = 491810,
  [SMALL_STATE(9070)] = 491828,
  [SMALL_STATE(9071)] = 491844,
  [SMALL_STATE(9072)] = 491862,
  [SMALL_STATE(9073)] = 491878,
  [SMALL_STATE(9074)] = 491894,
  [SMALL_STATE(9075)] = 491910,
  [SMALL_STATE(9076)] = 491926,
  [SMALL_STATE(9077)] = 491944,
  [SMALL_STATE(9078)] = 491960,
  [SMALL_STATE(9079)] = 491980,
  [SMALL_STATE(9080)] = 491996,
  [SMALL_STATE(9081)] = 492012,
  [SMALL_STATE(9082)] = 492028,
  [SMALL_STATE(9083)] = 492046,
  [SMALL_STATE(9084)] = 492062,
  [SMALL_STATE(9085)] = 492080,
  [SMALL_STATE(9086)] = 492096,
  [SMALL_STATE(9087)] = 492114,
  [SMALL_STATE(9088)] = 492132,
  [SMALL_STATE(9089)] = 492148,
  [SMALL_STATE(9090)] = 492164,
  [SMALL_STATE(9091)] = 492180,
  [SMALL_STATE(9092)] = 492198,
  [SMALL_STATE(9093)] = 492214,
  [SMALL_STATE(9094)] = 492230,
  [SMALL_STATE(9095)] = 492242,
  [SMALL_STATE(9096)] = 492258,
  [SMALL_STATE(9097)] = 492276,
  [SMALL_STATE(9098)] = 492296,
  [SMALL_STATE(9099)] = 492312,
  [SMALL_STATE(9100)] = 492328,
  [SMALL_STATE(9101)] = 492344,
  [SMALL_STATE(9102)] = 492360,
  [SMALL_STATE(9103)] = 492376,
  [SMALL_STATE(9104)] = 492392,
  [SMALL_STATE(9105)] = 492408,
  [SMALL_STATE(9106)] = 492424,
  [SMALL_STATE(9107)] = 492440,
  [SMALL_STATE(9108)] = 492456,
  [SMALL_STATE(9109)] = 492472,
  [SMALL_STATE(9110)] = 492490,
  [SMALL_STATE(9111)] = 492506,
  [SMALL_STATE(9112)] = 492522,
  [SMALL_STATE(9113)] = 492540,
  [SMALL_STATE(9114)] = 492556,
  [SMALL_STATE(9115)] = 492572,
  [SMALL_STATE(9116)] = 492588,
  [SMALL_STATE(9117)] = 492604,
  [SMALL_STATE(9118)] = 492620,
  [SMALL_STATE(9119)] = 492638,
  [SMALL_STATE(9120)] = 492650,
  [SMALL_STATE(9121)] = 492666,
  [SMALL_STATE(9122)] = 492684,
  [SMALL_STATE(9123)] = 492700,
  [SMALL_STATE(9124)] = 492716,
  [SMALL_STATE(9125)] = 492734,
  [SMALL_STATE(9126)] = 492752,
  [SMALL_STATE(9127)] = 492768,
  [SMALL_STATE(9128)] = 492784,
  [SMALL_STATE(9129)] = 492802,
  [SMALL_STATE(9130)] = 492818,
  [SMALL_STATE(9131)] = 492836,
  [SMALL_STATE(9132)] = 492854,
  [SMALL_STATE(9133)] = 492872,
  [SMALL_STATE(9134)] = 492888,
  [SMALL_STATE(9135)] = 492906,
  [SMALL_STATE(9136)] = 492924,
  [SMALL_STATE(9137)] = 492940,
  [SMALL_STATE(9138)] = 492958,
  [SMALL_STATE(9139)] = 492974,
  [SMALL_STATE(9140)] = 492992,
  [SMALL_STATE(9141)] = 493010,
  [SMALL_STATE(9142)] = 493026,
  [SMALL_STATE(9143)] = 493040,
  [SMALL_STATE(9144)] = 493058,
  [SMALL_STATE(9145)] = 493076,
  [SMALL_STATE(9146)] = 493094,
  [SMALL_STATE(9147)] = 493110,
  [SMALL_STATE(9148)] = 493128,
  [SMALL_STATE(9149)] = 493146,
  [SMALL_STATE(9150)] = 493162,
  [SMALL_STATE(9151)] = 493178,
  [SMALL_STATE(9152)] = 493194,
  [SMALL_STATE(9153)] = 493212,
  [SMALL_STATE(9154)] = 493230,
  [SMALL_STATE(9155)] = 493250,
  [SMALL_STATE(9156)] = 493268,
  [SMALL_STATE(9157)] = 493284,
  [SMALL_STATE(9158)] = 493300,
  [SMALL_STATE(9159)] = 493316,
  [SMALL_STATE(9160)] = 493334,
  [SMALL_STATE(9161)] = 493352,
  [SMALL_STATE(9162)] = 493368,
  [SMALL_STATE(9163)] = 493386,
  [SMALL_STATE(9164)] = 493406,
  [SMALL_STATE(9165)] = 493422,
  [SMALL_STATE(9166)] = 493438,
  [SMALL_STATE(9167)] = 493452,
  [SMALL_STATE(9168)] = 493466,
  [SMALL_STATE(9169)] = 493486,
  [SMALL_STATE(9170)] = 493502,
  [SMALL_STATE(9171)] = 493522,
  [SMALL_STATE(9172)] = 493538,
  [SMALL_STATE(9173)] = 493554,
  [SMALL_STATE(9174)] = 493570,
  [SMALL_STATE(9175)] = 493586,
  [SMALL_STATE(9176)] = 493604,
  [SMALL_STATE(9177)] = 493616,
  [SMALL_STATE(9178)] = 493630,
  [SMALL_STATE(9179)] = 493648,
  [SMALL_STATE(9180)] = 493666,
  [SMALL_STATE(9181)] = 493684,
  [SMALL_STATE(9182)] = 493700,
  [SMALL_STATE(9183)] = 493718,
  [SMALL_STATE(9184)] = 493736,
  [SMALL_STATE(9185)] = 493754,
  [SMALL_STATE(9186)] = 493772,
  [SMALL_STATE(9187)] = 493790,
  [SMALL_STATE(9188)] = 493806,
  [SMALL_STATE(9189)] = 493822,
  [SMALL_STATE(9190)] = 493842,
  [SMALL_STATE(9191)] = 493860,
  [SMALL_STATE(9192)] = 493876,
  [SMALL_STATE(9193)] = 493892,
  [SMALL_STATE(9194)] = 493910,
  [SMALL_STATE(9195)] = 493930,
  [SMALL_STATE(9196)] = 493944,
  [SMALL_STATE(9197)] = 493960,
  [SMALL_STATE(9198)] = 493980,
  [SMALL_STATE(9199)] = 493998,
  [SMALL_STATE(9200)] = 494016,
  [SMALL_STATE(9201)] = 494034,
  [SMALL_STATE(9202)] = 494052,
  [SMALL_STATE(9203)] = 494066,
  [SMALL_STATE(9204)] = 494084,
  [SMALL_STATE(9205)] = 494102,
  [SMALL_STATE(9206)] = 494118,
  [SMALL_STATE(9207)] = 494134,
  [SMALL_STATE(9208)] = 494150,
  [SMALL_STATE(9209)] = 494166,
  [SMALL_STATE(9210)] = 494182,
  [SMALL_STATE(9211)] = 494198,
  [SMALL_STATE(9212)] = 494218,
  [SMALL_STATE(9213)] = 494236,
  [SMALL_STATE(9214)] = 494248,
  [SMALL_STATE(9215)] = 494264,
  [SMALL_STATE(9216)] = 494282,
  [SMALL_STATE(9217)] = 494298,
  [SMALL_STATE(9218)] = 494314,
  [SMALL_STATE(9219)] = 494332,
  [SMALL_STATE(9220)] = 494348,
  [SMALL_STATE(9221)] = 494364,
  [SMALL_STATE(9222)] = 494382,
  [SMALL_STATE(9223)] = 494398,
  [SMALL_STATE(9224)] = 494414,
  [SMALL_STATE(9225)] = 494432,
  [SMALL_STATE(9226)] = 494448,
  [SMALL_STATE(9227)] = 494464,
  [SMALL_STATE(9228)] = 494482,
  [SMALL_STATE(9229)] = 494498,
  [SMALL_STATE(9230)] = 494514,
  [SMALL_STATE(9231)] = 494530,
  [SMALL_STATE(9232)] = 494548,
  [SMALL_STATE(9233)] = 494568,
  [SMALL_STATE(9234)] = 494584,
  [SMALL_STATE(9235)] = 494600,
  [SMALL_STATE(9236)] = 494616,
  [SMALL_STATE(9237)] = 494632,
  [SMALL_STATE(9238)] = 494648,
  [SMALL_STATE(9239)] = 494664,
  [SMALL_STATE(9240)] = 494680,
  [SMALL_STATE(9241)] = 494696,
  [SMALL_STATE(9242)] = 494714,
  [SMALL_STATE(9243)] = 494730,
  [SMALL_STATE(9244)] = 494746,
  [SMALL_STATE(9245)] = 494762,
  [SMALL_STATE(9246)] = 494778,
  [SMALL_STATE(9247)] = 494792,
  [SMALL_STATE(9248)] = 494808,
  [SMALL_STATE(9249)] = 494824,
  [SMALL_STATE(9250)] = 494840,
  [SMALL_STATE(9251)] = 494854,
  [SMALL_STATE(9252)] = 494870,
  [SMALL_STATE(9253)] = 494884,
  [SMALL_STATE(9254)] = 494898,
  [SMALL_STATE(9255)] = 494914,
  [SMALL_STATE(9256)] = 494928,
  [SMALL_STATE(9257)] = 494946,
  [SMALL_STATE(9258)] = 494962,
  [SMALL_STATE(9259)] = 494980,
  [SMALL_STATE(9260)] = 494998,
  [SMALL_STATE(9261)] = 495016,
  [SMALL_STATE(9262)] = 495034,
  [SMALL_STATE(9263)] = 495052,
  [SMALL_STATE(9264)] = 495070,
  [SMALL_STATE(9265)] = 495082,
  [SMALL_STATE(9266)] = 495100,
  [SMALL_STATE(9267)] = 495118,
  [SMALL_STATE(9268)] = 495134,
  [SMALL_STATE(9269)] = 495150,
  [SMALL_STATE(9270)] = 495166,
  [SMALL_STATE(9271)] = 495182,
  [SMALL_STATE(9272)] = 495200,
  [SMALL_STATE(9273)] = 495218,
  [SMALL_STATE(9274)] = 495234,
  [SMALL_STATE(9275)] = 495252,
  [SMALL_STATE(9276)] = 495272,
  [SMALL_STATE(9277)] = 495290,
  [SMALL_STATE(9278)] = 495310,
  [SMALL_STATE(9279)] = 495328,
  [SMALL_STATE(9280)] = 495342,
  [SMALL_STATE(9281)] = 495358,
  [SMALL_STATE(9282)] = 495374,
  [SMALL_STATE(9283)] = 495390,
  [SMALL_STATE(9284)] = 495402,
  [SMALL_STATE(9285)] = 495418,
  [SMALL_STATE(9286)] = 495430,
  [SMALL_STATE(9287)] = 495446,
  [SMALL_STATE(9288)] = 495462,
  [SMALL_STATE(9289)] = 495480,
  [SMALL_STATE(9290)] = 495498,
  [SMALL_STATE(9291)] = 495516,
  [SMALL_STATE(9292)] = 495534,
  [SMALL_STATE(9293)] = 495552,
  [SMALL_STATE(9294)] = 495570,
  [SMALL_STATE(9295)] = 495588,
  [SMALL_STATE(9296)] = 495604,
  [SMALL_STATE(9297)] = 495620,
  [SMALL_STATE(9298)] = 495636,
  [SMALL_STATE(9299)] = 495652,
  [SMALL_STATE(9300)] = 495670,
  [SMALL_STATE(9301)] = 495686,
  [SMALL_STATE(9302)] = 495704,
  [SMALL_STATE(9303)] = 495722,
  [SMALL_STATE(9304)] = 495740,
  [SMALL_STATE(9305)] = 495758,
  [SMALL_STATE(9306)] = 495774,
  [SMALL_STATE(9307)] = 495792,
  [SMALL_STATE(9308)] = 495808,
  [SMALL_STATE(9309)] = 495826,
  [SMALL_STATE(9310)] = 495846,
  [SMALL_STATE(9311)] = 495862,
  [SMALL_STATE(9312)] = 495878,
  [SMALL_STATE(9313)] = 495894,
  [SMALL_STATE(9314)] = 495910,
  [SMALL_STATE(9315)] = 495926,
  [SMALL_STATE(9316)] = 495942,
  [SMALL_STATE(9317)] = 495958,
  [SMALL_STATE(9318)] = 495974,
  [SMALL_STATE(9319)] = 495990,
  [SMALL_STATE(9320)] = 496006,
  [SMALL_STATE(9321)] = 496022,
  [SMALL_STATE(9322)] = 496038,
  [SMALL_STATE(9323)] = 496052,
  [SMALL_STATE(9324)] = 496068,
  [SMALL_STATE(9325)] = 496084,
  [SMALL_STATE(9326)] = 496102,
  [SMALL_STATE(9327)] = 496120,
  [SMALL_STATE(9328)] = 496138,
  [SMALL_STATE(9329)] = 496154,
  [SMALL_STATE(9330)] = 496172,
  [SMALL_STATE(9331)] = 496188,
  [SMALL_STATE(9332)] = 496204,
  [SMALL_STATE(9333)] = 496220,
  [SMALL_STATE(9334)] = 496236,
  [SMALL_STATE(9335)] = 496252,
  [SMALL_STATE(9336)] = 496270,
  [SMALL_STATE(9337)] = 496286,
  [SMALL_STATE(9338)] = 496302,
  [SMALL_STATE(9339)] = 496318,
  [SMALL_STATE(9340)] = 496334,
  [SMALL_STATE(9341)] = 496350,
  [SMALL_STATE(9342)] = 496366,
  [SMALL_STATE(9343)] = 496382,
  [SMALL_STATE(9344)] = 496398,
  [SMALL_STATE(9345)] = 496414,
  [SMALL_STATE(9346)] = 496432,
  [SMALL_STATE(9347)] = 496450,
  [SMALL_STATE(9348)] = 496466,
  [SMALL_STATE(9349)] = 496480,
  [SMALL_STATE(9350)] = 496498,
  [SMALL_STATE(9351)] = 496516,
  [SMALL_STATE(9352)] = 496532,
  [SMALL_STATE(9353)] = 496548,
  [SMALL_STATE(9354)] = 496564,
  [SMALL_STATE(9355)] = 496584,
  [SMALL_STATE(9356)] = 496600,
  [SMALL_STATE(9357)] = 496620,
  [SMALL_STATE(9358)] = 496636,
  [SMALL_STATE(9359)] = 496654,
  [SMALL_STATE(9360)] = 496670,
  [SMALL_STATE(9361)] = 496688,
  [SMALL_STATE(9362)] = 496704,
  [SMALL_STATE(9363)] = 496720,
  [SMALL_STATE(9364)] = 496738,
  [SMALL_STATE(9365)] = 496752,
  [SMALL_STATE(9366)] = 496768,
  [SMALL_STATE(9367)] = 496788,
  [SMALL_STATE(9368)] = 496804,
  [SMALL_STATE(9369)] = 496820,
  [SMALL_STATE(9370)] = 496836,
  [SMALL_STATE(9371)] = 496852,
  [SMALL_STATE(9372)] = 496868,
  [SMALL_STATE(9373)] = 496884,
  [SMALL_STATE(9374)] = 496900,
  [SMALL_STATE(9375)] = 496916,
  [SMALL_STATE(9376)] = 496932,
  [SMALL_STATE(9377)] = 496944,
  [SMALL_STATE(9378)] = 496960,
  [SMALL_STATE(9379)] = 496976,
  [SMALL_STATE(9380)] = 496992,
  [SMALL_STATE(9381)] = 497008,
  [SMALL_STATE(9382)] = 497024,
  [SMALL_STATE(9383)] = 497042,
  [SMALL_STATE(9384)] = 497058,
  [SMALL_STATE(9385)] = 497078,
  [SMALL_STATE(9386)] = 497094,
  [SMALL_STATE(9387)] = 497110,
  [SMALL_STATE(9388)] = 497128,
  [SMALL_STATE(9389)] = 497144,
  [SMALL_STATE(9390)] = 497160,
  [SMALL_STATE(9391)] = 497176,
  [SMALL_STATE(9392)] = 497192,
  [SMALL_STATE(9393)] = 497208,
  [SMALL_STATE(9394)] = 497224,
  [SMALL_STATE(9395)] = 497240,
  [SMALL_STATE(9396)] = 497260,
  [SMALL_STATE(9397)] = 497276,
  [SMALL_STATE(9398)] = 497292,
  [SMALL_STATE(9399)] = 497308,
  [SMALL_STATE(9400)] = 497324,
  [SMALL_STATE(9401)] = 497340,
  [SMALL_STATE(9402)] = 497356,
  [SMALL_STATE(9403)] = 497372,
  [SMALL_STATE(9404)] = 497390,
  [SMALL_STATE(9405)] = 497408,
  [SMALL_STATE(9406)] = 497424,
  [SMALL_STATE(9407)] = 497440,
  [SMALL_STATE(9408)] = 497456,
  [SMALL_STATE(9409)] = 497472,
  [SMALL_STATE(9410)] = 497490,
  [SMALL_STATE(9411)] = 497508,
  [SMALL_STATE(9412)] = 497524,
  [SMALL_STATE(9413)] = 497540,
  [SMALL_STATE(9414)] = 497556,
  [SMALL_STATE(9415)] = 497570,
  [SMALL_STATE(9416)] = 497586,
  [SMALL_STATE(9417)] = 497602,
  [SMALL_STATE(9418)] = 497618,
  [SMALL_STATE(9419)] = 497634,
  [SMALL_STATE(9420)] = 497650,
  [SMALL_STATE(9421)] = 497666,
  [SMALL_STATE(9422)] = 497682,
  [SMALL_STATE(9423)] = 497698,
  [SMALL_STATE(9424)] = 497714,
  [SMALL_STATE(9425)] = 497732,
  [SMALL_STATE(9426)] = 497748,
  [SMALL_STATE(9427)] = 497766,
  [SMALL_STATE(9428)] = 497784,
  [SMALL_STATE(9429)] = 497800,
  [SMALL_STATE(9430)] = 497816,
  [SMALL_STATE(9431)] = 497832,
  [SMALL_STATE(9432)] = 497848,
  [SMALL_STATE(9433)] = 497864,
  [SMALL_STATE(9434)] = 497880,
  [SMALL_STATE(9435)] = 497898,
  [SMALL_STATE(9436)] = 497911,
  [SMALL_STATE(9437)] = 497922,
  [SMALL_STATE(9438)] = 497937,
  [SMALL_STATE(9439)] = 497952,
  [SMALL_STATE(9440)] = 497963,
  [SMALL_STATE(9441)] = 497976,
  [SMALL_STATE(9442)] = 497989,
  [SMALL_STATE(9443)] = 498000,
  [SMALL_STATE(9444)] = 498013,
  [SMALL_STATE(9445)] = 498026,
  [SMALL_STATE(9446)] = 498041,
  [SMALL_STATE(9447)] = 498054,
  [SMALL_STATE(9448)] = 498067,
  [SMALL_STATE(9449)] = 498080,
  [SMALL_STATE(9450)] = 498095,
  [SMALL_STATE(9451)] = 498108,
  [SMALL_STATE(9452)] = 498123,
  [SMALL_STATE(9453)] = 498140,
  [SMALL_STATE(9454)] = 498151,
  [SMALL_STATE(9455)] = 498162,
  [SMALL_STATE(9456)] = 498173,
  [SMALL_STATE(9457)] = 498188,
  [SMALL_STATE(9458)] = 498203,
  [SMALL_STATE(9459)] = 498214,
  [SMALL_STATE(9460)] = 498231,
  [SMALL_STATE(9461)] = 498244,
  [SMALL_STATE(9462)] = 498257,
  [SMALL_STATE(9463)] = 498272,
  [SMALL_STATE(9464)] = 498289,
  [SMALL_STATE(9465)] = 498304,
  [SMALL_STATE(9466)] = 498317,
  [SMALL_STATE(9467)] = 498330,
  [SMALL_STATE(9468)] = 498343,
  [SMALL_STATE(9469)] = 498356,
  [SMALL_STATE(9470)] = 498367,
  [SMALL_STATE(9471)] = 498380,
  [SMALL_STATE(9472)] = 498393,
  [SMALL_STATE(9473)] = 498410,
  [SMALL_STATE(9474)] = 498423,
  [SMALL_STATE(9475)] = 498440,
  [SMALL_STATE(9476)] = 498457,
  [SMALL_STATE(9477)] = 498474,
  [SMALL_STATE(9478)] = 498487,
  [SMALL_STATE(9479)] = 498498,
  [SMALL_STATE(9480)] = 498509,
  [SMALL_STATE(9481)] = 498524,
  [SMALL_STATE(9482)] = 498537,
  [SMALL_STATE(9483)] = 498550,
  [SMALL_STATE(9484)] = 498563,
  [SMALL_STATE(9485)] = 498576,
  [SMALL_STATE(9486)] = 498589,
  [SMALL_STATE(9487)] = 498600,
  [SMALL_STATE(9488)] = 498611,
  [SMALL_STATE(9489)] = 498624,
  [SMALL_STATE(9490)] = 498635,
  [SMALL_STATE(9491)] = 498648,
  [SMALL_STATE(9492)] = 498661,
  [SMALL_STATE(9493)] = 498678,
  [SMALL_STATE(9494)] = 498691,
  [SMALL_STATE(9495)] = 498704,
  [SMALL_STATE(9496)] = 498715,
  [SMALL_STATE(9497)] = 498726,
  [SMALL_STATE(9498)] = 498739,
  [SMALL_STATE(9499)] = 498752,
  [SMALL_STATE(9500)] = 498769,
  [SMALL_STATE(9501)] = 498782,
  [SMALL_STATE(9502)] = 498795,
  [SMALL_STATE(9503)] = 498808,
  [SMALL_STATE(9504)] = 498821,
  [SMALL_STATE(9505)] = 498834,
  [SMALL_STATE(9506)] = 498845,
  [SMALL_STATE(9507)] = 498862,
  [SMALL_STATE(9508)] = 498875,
  [SMALL_STATE(9509)] = 498890,
  [SMALL_STATE(9510)] = 498903,
  [SMALL_STATE(9511)] = 498916,
  [SMALL_STATE(9512)] = 498929,
  [SMALL_STATE(9513)] = 498942,
  [SMALL_STATE(9514)] = 498953,
  [SMALL_STATE(9515)] = 498966,
  [SMALL_STATE(9516)] = 498981,
  [SMALL_STATE(9517)] = 498994,
  [SMALL_STATE(9518)] = 499007,
  [SMALL_STATE(9519)] = 499020,
  [SMALL_STATE(9520)] = 499031,
  [SMALL_STATE(9521)] = 499044,
  [SMALL_STATE(9522)] = 499057,
  [SMALL_STATE(9523)] = 499074,
  [SMALL_STATE(9524)] = 499087,
  [SMALL_STATE(9525)] = 499100,
  [SMALL_STATE(9526)] = 499115,
  [SMALL_STATE(9527)] = 499130,
  [SMALL_STATE(9528)] = 499147,
  [SMALL_STATE(9529)] = 499162,
  [SMALL_STATE(9530)] = 499173,
  [SMALL_STATE(9531)] = 499188,
  [SMALL_STATE(9532)] = 499199,
  [SMALL_STATE(9533)] = 499212,
  [SMALL_STATE(9534)] = 499225,
  [SMALL_STATE(9535)] = 499236,
  [SMALL_STATE(9536)] = 499249,
  [SMALL_STATE(9537)] = 499262,
  [SMALL_STATE(9538)] = 499273,
  [SMALL_STATE(9539)] = 499286,
  [SMALL_STATE(9540)] = 499303,
  [SMALL_STATE(9541)] = 499318,
  [SMALL_STATE(9542)] = 499329,
  [SMALL_STATE(9543)] = 499342,
  [SMALL_STATE(9544)] = 499355,
  [SMALL_STATE(9545)] = 499368,
  [SMALL_STATE(9546)] = 499379,
  [SMALL_STATE(9547)] = 499390,
  [SMALL_STATE(9548)] = 499401,
  [SMALL_STATE(9549)] = 499416,
  [SMALL_STATE(9550)] = 499429,
  [SMALL_STATE(9551)] = 499442,
  [SMALL_STATE(9552)] = 499457,
  [SMALL_STATE(9553)] = 499472,
  [SMALL_STATE(9554)] = 499483,
  [SMALL_STATE(9555)] = 499496,
  [SMALL_STATE(9556)] = 499507,
  [SMALL_STATE(9557)] = 499520,
  [SMALL_STATE(9558)] = 499535,
  [SMALL_STATE(9559)] = 499548,
  [SMALL_STATE(9560)] = 499561,
  [SMALL_STATE(9561)] = 499574,
  [SMALL_STATE(9562)] = 499587,
  [SMALL_STATE(9563)] = 499602,
  [SMALL_STATE(9564)] = 499613,
  [SMALL_STATE(9565)] = 499624,
  [SMALL_STATE(9566)] = 499637,
  [SMALL_STATE(9567)] = 499650,
  [SMALL_STATE(9568)] = 499661,
  [SMALL_STATE(9569)] = 499674,
  [SMALL_STATE(9570)] = 499685,
  [SMALL_STATE(9571)] = 499696,
  [SMALL_STATE(9572)] = 499707,
  [SMALL_STATE(9573)] = 499720,
  [SMALL_STATE(9574)] = 499731,
  [SMALL_STATE(9575)] = 499744,
  [SMALL_STATE(9576)] = 499757,
  [SMALL_STATE(9577)] = 499768,
  [SMALL_STATE(9578)] = 499781,
  [SMALL_STATE(9579)] = 499792,
  [SMALL_STATE(9580)] = 499803,
  [SMALL_STATE(9581)] = 499818,
  [SMALL_STATE(9582)] = 499829,
  [SMALL_STATE(9583)] = 499842,
  [SMALL_STATE(9584)] = 499855,
  [SMALL_STATE(9585)] = 499870,
  [SMALL_STATE(9586)] = 499881,
  [SMALL_STATE(9587)] = 499892,
  [SMALL_STATE(9588)] = 499903,
  [SMALL_STATE(9589)] = 499918,
  [SMALL_STATE(9590)] = 499931,
  [SMALL_STATE(9591)] = 499944,
  [SMALL_STATE(9592)] = 499955,
  [SMALL_STATE(9593)] = 499966,
  [SMALL_STATE(9594)] = 499979,
  [SMALL_STATE(9595)] = 499990,
  [SMALL_STATE(9596)] = 500007,
  [SMALL_STATE(9597)] = 500018,
  [SMALL_STATE(9598)] = 500029,
  [SMALL_STATE(9599)] = 500040,
  [SMALL_STATE(9600)] = 500053,
  [SMALL_STATE(9601)] = 500064,
  [SMALL_STATE(9602)] = 500075,
  [SMALL_STATE(9603)] = 500090,
  [SMALL_STATE(9604)] = 500107,
  [SMALL_STATE(9605)] = 500122,
  [SMALL_STATE(9606)] = 500139,
  [SMALL_STATE(9607)] = 500152,
  [SMALL_STATE(9608)] = 500165,
  [SMALL_STATE(9609)] = 500176,
  [SMALL_STATE(9610)] = 500187,
  [SMALL_STATE(9611)] = 500198,
  [SMALL_STATE(9612)] = 500209,
  [SMALL_STATE(9613)] = 500220,
  [SMALL_STATE(9614)] = 500235,
  [SMALL_STATE(9615)] = 500250,
  [SMALL_STATE(9616)] = 500261,
  [SMALL_STATE(9617)] = 500274,
  [SMALL_STATE(9618)] = 500285,
  [SMALL_STATE(9619)] = 500300,
  [SMALL_STATE(9620)] = 500311,
  [SMALL_STATE(9621)] = 500322,
  [SMALL_STATE(9622)] = 500339,
  [SMALL_STATE(9623)] = 500352,
  [SMALL_STATE(9624)] = 500363,
  [SMALL_STATE(9625)] = 500380,
  [SMALL_STATE(9626)] = 500391,
  [SMALL_STATE(9627)] = 500406,
  [SMALL_STATE(9628)] = 500423,
  [SMALL_STATE(9629)] = 500438,
  [SMALL_STATE(9630)] = 500449,
  [SMALL_STATE(9631)] = 500460,
  [SMALL_STATE(9632)] = 500475,
  [SMALL_STATE(9633)] = 500488,
  [SMALL_STATE(9634)] = 500499,
  [SMALL_STATE(9635)] = 500512,
  [SMALL_STATE(9636)] = 500525,
  [SMALL_STATE(9637)] = 500538,
  [SMALL_STATE(9638)] = 500551,
  [SMALL_STATE(9639)] = 500564,
  [SMALL_STATE(9640)] = 500575,
  [SMALL_STATE(9641)] = 500588,
  [SMALL_STATE(9642)] = 500603,
  [SMALL_STATE(9643)] = 500616,
  [SMALL_STATE(9644)] = 500629,
  [SMALL_STATE(9645)] = 500646,
  [SMALL_STATE(9646)] = 500659,
  [SMALL_STATE(9647)] = 500670,
  [SMALL_STATE(9648)] = 500687,
  [SMALL_STATE(9649)] = 500698,
  [SMALL_STATE(9650)] = 500709,
  [SMALL_STATE(9651)] = 500722,
  [SMALL_STATE(9652)] = 500733,
  [SMALL_STATE(9653)] = 500746,
  [SMALL_STATE(9654)] = 500759,
  [SMALL_STATE(9655)] = 500770,
  [SMALL_STATE(9656)] = 500781,
  [SMALL_STATE(9657)] = 500792,
  [SMALL_STATE(9658)] = 500809,
  [SMALL_STATE(9659)] = 500822,
  [SMALL_STATE(9660)] = 500833,
  [SMALL_STATE(9661)] = 500846,
  [SMALL_STATE(9662)] = 500861,
  [SMALL_STATE(9663)] = 500874,
  [SMALL_STATE(9664)] = 500887,
  [SMALL_STATE(9665)] = 500898,
  [SMALL_STATE(9666)] = 500909,
  [SMALL_STATE(9667)] = 500920,
  [SMALL_STATE(9668)] = 500937,
  [SMALL_STATE(9669)] = 500950,
  [SMALL_STATE(9670)] = 500963,
  [SMALL_STATE(9671)] = 500974,
  [SMALL_STATE(9672)] = 500987,
  [SMALL_STATE(9673)] = 501004,
  [SMALL_STATE(9674)] = 501015,
  [SMALL_STATE(9675)] = 501028,
  [SMALL_STATE(9676)] = 501039,
  [SMALL_STATE(9677)] = 501052,
  [SMALL_STATE(9678)] = 501065,
  [SMALL_STATE(9679)] = 501076,
  [SMALL_STATE(9680)] = 501089,
  [SMALL_STATE(9681)] = 501100,
  [SMALL_STATE(9682)] = 501111,
  [SMALL_STATE(9683)] = 501124,
  [SMALL_STATE(9684)] = 501135,
  [SMALL_STATE(9685)] = 501148,
  [SMALL_STATE(9686)] = 501165,
  [SMALL_STATE(9687)] = 501180,
  [SMALL_STATE(9688)] = 501191,
  [SMALL_STATE(9689)] = 501208,
  [SMALL_STATE(9690)] = 501223,
  [SMALL_STATE(9691)] = 501238,
  [SMALL_STATE(9692)] = 501249,
  [SMALL_STATE(9693)] = 501260,
  [SMALL_STATE(9694)] = 501273,
  [SMALL_STATE(9695)] = 501284,
  [SMALL_STATE(9696)] = 501297,
  [SMALL_STATE(9697)] = 501312,
  [SMALL_STATE(9698)] = 501327,
  [SMALL_STATE(9699)] = 501344,
  [SMALL_STATE(9700)] = 501361,
  [SMALL_STATE(9701)] = 501376,
  [SMALL_STATE(9702)] = 501387,
  [SMALL_STATE(9703)] = 501400,
  [SMALL_STATE(9704)] = 501413,
  [SMALL_STATE(9705)] = 501430,
  [SMALL_STATE(9706)] = 501441,
  [SMALL_STATE(9707)] = 501454,
  [SMALL_STATE(9708)] = 501471,
  [SMALL_STATE(9709)] = 501484,
  [SMALL_STATE(9710)] = 501501,
  [SMALL_STATE(9711)] = 501518,
  [SMALL_STATE(9712)] = 501531,
  [SMALL_STATE(9713)] = 501546,
  [SMALL_STATE(9714)] = 501557,
  [SMALL_STATE(9715)] = 501574,
  [SMALL_STATE(9716)] = 501589,
  [SMALL_STATE(9717)] = 501602,
  [SMALL_STATE(9718)] = 501615,
  [SMALL_STATE(9719)] = 501630,
  [SMALL_STATE(9720)] = 501643,
  [SMALL_STATE(9721)] = 501660,
  [SMALL_STATE(9722)] = 501671,
  [SMALL_STATE(9723)] = 501684,
  [SMALL_STATE(9724)] = 501695,
  [SMALL_STATE(9725)] = 501708,
  [SMALL_STATE(9726)] = 501719,
  [SMALL_STATE(9727)] = 501732,
  [SMALL_STATE(9728)] = 501745,
  [SMALL_STATE(9729)] = 501758,
  [SMALL_STATE(9730)] = 501771,
  [SMALL_STATE(9731)] = 501782,
  [SMALL_STATE(9732)] = 501795,
  [SMALL_STATE(9733)] = 501808,
  [SMALL_STATE(9734)] = 501821,
  [SMALL_STATE(9735)] = 501834,
  [SMALL_STATE(9736)] = 501849,
  [SMALL_STATE(9737)] = 501860,
  [SMALL_STATE(9738)] = 501877,
  [SMALL_STATE(9739)] = 501888,
  [SMALL_STATE(9740)] = 501899,
  [SMALL_STATE(9741)] = 501910,
  [SMALL_STATE(9742)] = 501921,
  [SMALL_STATE(9743)] = 501932,
  [SMALL_STATE(9744)] = 501947,
  [SMALL_STATE(9745)] = 501958,
  [SMALL_STATE(9746)] = 501971,
  [SMALL_STATE(9747)] = 501984,
  [SMALL_STATE(9748)] = 501997,
  [SMALL_STATE(9749)] = 502010,
  [SMALL_STATE(9750)] = 502021,
  [SMALL_STATE(9751)] = 502032,
  [SMALL_STATE(9752)] = 502043,
  [SMALL_STATE(9753)] = 502058,
  [SMALL_STATE(9754)] = 502073,
  [SMALL_STATE(9755)] = 502086,
  [SMALL_STATE(9756)] = 502099,
  [SMALL_STATE(9757)] = 502116,
  [SMALL_STATE(9758)] = 502129,
  [SMALL_STATE(9759)] = 502140,
  [SMALL_STATE(9760)] = 502153,
  [SMALL_STATE(9761)] = 502168,
  [SMALL_STATE(9762)] = 502181,
  [SMALL_STATE(9763)] = 502196,
  [SMALL_STATE(9764)] = 502211,
  [SMALL_STATE(9765)] = 502226,
  [SMALL_STATE(9766)] = 502241,
  [SMALL_STATE(9767)] = 502256,
  [SMALL_STATE(9768)] = 502271,
  [SMALL_STATE(9769)] = 502282,
  [SMALL_STATE(9770)] = 502295,
  [SMALL_STATE(9771)] = 502308,
  [SMALL_STATE(9772)] = 502319,
  [SMALL_STATE(9773)] = 502334,
  [SMALL_STATE(9774)] = 502347,
  [SMALL_STATE(9775)] = 502364,
  [SMALL_STATE(9776)] = 502377,
  [SMALL_STATE(9777)] = 502388,
  [SMALL_STATE(9778)] = 502399,
  [SMALL_STATE(9779)] = 502414,
  [SMALL_STATE(9780)] = 502425,
  [SMALL_STATE(9781)] = 502436,
  [SMALL_STATE(9782)] = 502449,
  [SMALL_STATE(9783)] = 502466,
  [SMALL_STATE(9784)] = 502479,
  [SMALL_STATE(9785)] = 502492,
  [SMALL_STATE(9786)] = 502507,
  [SMALL_STATE(9787)] = 502520,
  [SMALL_STATE(9788)] = 502533,
  [SMALL_STATE(9789)] = 502544,
  [SMALL_STATE(9790)] = 502557,
  [SMALL_STATE(9791)] = 502570,
  [SMALL_STATE(9792)] = 502587,
  [SMALL_STATE(9793)] = 502600,
  [SMALL_STATE(9794)] = 502611,
  [SMALL_STATE(9795)] = 502626,
  [SMALL_STATE(9796)] = 502641,
  [SMALL_STATE(9797)] = 502656,
  [SMALL_STATE(9798)] = 502671,
  [SMALL_STATE(9799)] = 502684,
  [SMALL_STATE(9800)] = 502695,
  [SMALL_STATE(9801)] = 502712,
  [SMALL_STATE(9802)] = 502725,
  [SMALL_STATE(9803)] = 502740,
  [SMALL_STATE(9804)] = 502755,
  [SMALL_STATE(9805)] = 502766,
  [SMALL_STATE(9806)] = 502779,
  [SMALL_STATE(9807)] = 502794,
  [SMALL_STATE(9808)] = 502809,
  [SMALL_STATE(9809)] = 502822,
  [SMALL_STATE(9810)] = 502837,
  [SMALL_STATE(9811)] = 502854,
  [SMALL_STATE(9812)] = 502869,
  [SMALL_STATE(9813)] = 502882,
  [SMALL_STATE(9814)] = 502895,
  [SMALL_STATE(9815)] = 502908,
  [SMALL_STATE(9816)] = 502921,
  [SMALL_STATE(9817)] = 502936,
  [SMALL_STATE(9818)] = 502951,
  [SMALL_STATE(9819)] = 502966,
  [SMALL_STATE(9820)] = 502979,
  [SMALL_STATE(9821)] = 502996,
  [SMALL_STATE(9822)] = 503011,
  [SMALL_STATE(9823)] = 503028,
  [SMALL_STATE(9824)] = 503041,
  [SMALL_STATE(9825)] = 503054,
  [SMALL_STATE(9826)] = 503067,
  [SMALL_STATE(9827)] = 503082,
  [SMALL_STATE(9828)] = 503095,
  [SMALL_STATE(9829)] = 503108,
  [SMALL_STATE(9830)] = 503121,
  [SMALL_STATE(9831)] = 503134,
  [SMALL_STATE(9832)] = 503147,
  [SMALL_STATE(9833)] = 503158,
  [SMALL_STATE(9834)] = 503175,
  [SMALL_STATE(9835)] = 503188,
  [SMALL_STATE(9836)] = 503201,
  [SMALL_STATE(9837)] = 503216,
  [SMALL_STATE(9838)] = 503229,
  [SMALL_STATE(9839)] = 503242,
  [SMALL_STATE(9840)] = 503259,
  [SMALL_STATE(9841)] = 503270,
  [SMALL_STATE(9842)] = 503281,
  [SMALL_STATE(9843)] = 503298,
  [SMALL_STATE(9844)] = 503313,
  [SMALL_STATE(9845)] = 503330,
  [SMALL_STATE(9846)] = 503345,
  [SMALL_STATE(9847)] = 503360,
  [SMALL_STATE(9848)] = 503375,
  [SMALL_STATE(9849)] = 503386,
  [SMALL_STATE(9850)] = 503401,
  [SMALL_STATE(9851)] = 503414,
  [SMALL_STATE(9852)] = 503427,
  [SMALL_STATE(9853)] = 503438,
  [SMALL_STATE(9854)] = 503453,
  [SMALL_STATE(9855)] = 503468,
  [SMALL_STATE(9856)] = 503481,
  [SMALL_STATE(9857)] = 503492,
  [SMALL_STATE(9858)] = 503505,
  [SMALL_STATE(9859)] = 503522,
  [SMALL_STATE(9860)] = 503533,
  [SMALL_STATE(9861)] = 503546,
  [SMALL_STATE(9862)] = 503561,
  [SMALL_STATE(9863)] = 503574,
  [SMALL_STATE(9864)] = 503585,
  [SMALL_STATE(9865)] = 503600,
  [SMALL_STATE(9866)] = 503613,
  [SMALL_STATE(9867)] = 503630,
  [SMALL_STATE(9868)] = 503643,
  [SMALL_STATE(9869)] = 503656,
  [SMALL_STATE(9870)] = 503671,
  [SMALL_STATE(9871)] = 503682,
  [SMALL_STATE(9872)] = 503693,
  [SMALL_STATE(9873)] = 503708,
  [SMALL_STATE(9874)] = 503719,
  [SMALL_STATE(9875)] = 503732,
  [SMALL_STATE(9876)] = 503745,
  [SMALL_STATE(9877)] = 503756,
  [SMALL_STATE(9878)] = 503769,
  [SMALL_STATE(9879)] = 503784,
  [SMALL_STATE(9880)] = 503795,
  [SMALL_STATE(9881)] = 503808,
  [SMALL_STATE(9882)] = 503819,
  [SMALL_STATE(9883)] = 503830,
  [SMALL_STATE(9884)] = 503841,
  [SMALL_STATE(9885)] = 503854,
  [SMALL_STATE(9886)] = 503867,
  [SMALL_STATE(9887)] = 503882,
  [SMALL_STATE(9888)] = 503895,
  [SMALL_STATE(9889)] = 503908,
  [SMALL_STATE(9890)] = 503921,
  [SMALL_STATE(9891)] = 503938,
  [SMALL_STATE(9892)] = 503951,
  [SMALL_STATE(9893)] = 503964,
  [SMALL_STATE(9894)] = 503977,
  [SMALL_STATE(9895)] = 503992,
  [SMALL_STATE(9896)] = 504009,
  [SMALL_STATE(9897)] = 504024,
  [SMALL_STATE(9898)] = 504037,
  [SMALL_STATE(9899)] = 504050,
  [SMALL_STATE(9900)] = 504063,
  [SMALL_STATE(9901)] = 504076,
  [SMALL_STATE(9902)] = 504089,
  [SMALL_STATE(9903)] = 504102,
  [SMALL_STATE(9904)] = 504115,
  [SMALL_STATE(9905)] = 504126,
  [SMALL_STATE(9906)] = 504139,
  [SMALL_STATE(9907)] = 504150,
  [SMALL_STATE(9908)] = 504161,
  [SMALL_STATE(9909)] = 504174,
  [SMALL_STATE(9910)] = 504187,
  [SMALL_STATE(9911)] = 504200,
  [SMALL_STATE(9912)] = 504211,
  [SMALL_STATE(9913)] = 504228,
  [SMALL_STATE(9914)] = 504245,
  [SMALL_STATE(9915)] = 504258,
  [SMALL_STATE(9916)] = 504275,
  [SMALL_STATE(9917)] = 504292,
  [SMALL_STATE(9918)] = 504309,
  [SMALL_STATE(9919)] = 504322,
  [SMALL_STATE(9920)] = 504333,
  [SMALL_STATE(9921)] = 504346,
  [SMALL_STATE(9922)] = 504361,
  [SMALL_STATE(9923)] = 504372,
  [SMALL_STATE(9924)] = 504383,
  [SMALL_STATE(9925)] = 504396,
  [SMALL_STATE(9926)] = 504409,
  [SMALL_STATE(9927)] = 504426,
  [SMALL_STATE(9928)] = 504439,
  [SMALL_STATE(9929)] = 504452,
  [SMALL_STATE(9930)] = 504469,
  [SMALL_STATE(9931)] = 504486,
  [SMALL_STATE(9932)] = 504499,
  [SMALL_STATE(9933)] = 504512,
  [SMALL_STATE(9934)] = 504525,
  [SMALL_STATE(9935)] = 504536,
  [SMALL_STATE(9936)] = 504547,
  [SMALL_STATE(9937)] = 504558,
  [SMALL_STATE(9938)] = 504571,
  [SMALL_STATE(9939)] = 504582,
  [SMALL_STATE(9940)] = 504595,
  [SMALL_STATE(9941)] = 504608,
  [SMALL_STATE(9942)] = 504623,
  [SMALL_STATE(9943)] = 504636,
  [SMALL_STATE(9944)] = 504647,
  [SMALL_STATE(9945)] = 504662,
  [SMALL_STATE(9946)] = 504677,
  [SMALL_STATE(9947)] = 504690,
  [SMALL_STATE(9948)] = 504703,
  [SMALL_STATE(9949)] = 504716,
  [SMALL_STATE(9950)] = 504729,
  [SMALL_STATE(9951)] = 504742,
  [SMALL_STATE(9952)] = 504755,
  [SMALL_STATE(9953)] = 504768,
  [SMALL_STATE(9954)] = 504783,
  [SMALL_STATE(9955)] = 504796,
  [SMALL_STATE(9956)] = 504807,
  [SMALL_STATE(9957)] = 504824,
  [SMALL_STATE(9958)] = 504841,
  [SMALL_STATE(9959)] = 504856,
  [SMALL_STATE(9960)] = 504871,
  [SMALL_STATE(9961)] = 504886,
  [SMALL_STATE(9962)] = 504897,
  [SMALL_STATE(9963)] = 504912,
  [SMALL_STATE(9964)] = 504925,
  [SMALL_STATE(9965)] = 504938,
  [SMALL_STATE(9966)] = 504949,
  [SMALL_STATE(9967)] = 504960,
  [SMALL_STATE(9968)] = 504973,
  [SMALL_STATE(9969)] = 504988,
  [SMALL_STATE(9970)] = 505003,
  [SMALL_STATE(9971)] = 505016,
  [SMALL_STATE(9972)] = 505027,
  [SMALL_STATE(9973)] = 505040,
  [SMALL_STATE(9974)] = 505053,
  [SMALL_STATE(9975)] = 505070,
  [SMALL_STATE(9976)] = 505087,
  [SMALL_STATE(9977)] = 505098,
  [SMALL_STATE(9978)] = 505111,
  [SMALL_STATE(9979)] = 505126,
  [SMALL_STATE(9980)] = 505141,
  [SMALL_STATE(9981)] = 505152,
  [SMALL_STATE(9982)] = 505167,
  [SMALL_STATE(9983)] = 505180,
  [SMALL_STATE(9984)] = 505191,
  [SMALL_STATE(9985)] = 505206,
  [SMALL_STATE(9986)] = 505219,
  [SMALL_STATE(9987)] = 505234,
  [SMALL_STATE(9988)] = 505249,
  [SMALL_STATE(9989)] = 505262,
  [SMALL_STATE(9990)] = 505279,
  [SMALL_STATE(9991)] = 505290,
  [SMALL_STATE(9992)] = 505307,
  [SMALL_STATE(9993)] = 505320,
  [SMALL_STATE(9994)] = 505333,
  [SMALL_STATE(9995)] = 505346,
  [SMALL_STATE(9996)] = 505361,
  [SMALL_STATE(9997)] = 505374,
  [SMALL_STATE(9998)] = 505387,
  [SMALL_STATE(9999)] = 505402,
  [SMALL_STATE(10000)] = 505415,
  [SMALL_STATE(10001)] = 505432,
  [SMALL_STATE(10002)] = 505443,
  [SMALL_STATE(10003)] = 505454,
  [SMALL_STATE(10004)] = 505467,
  [SMALL_STATE(10005)] = 505480,
  [SMALL_STATE(10006)] = 505493,
  [SMALL_STATE(10007)] = 505510,
  [SMALL_STATE(10008)] = 505523,
  [SMALL_STATE(10009)] = 505536,
  [SMALL_STATE(10010)] = 505549,
  [SMALL_STATE(10011)] = 505562,
  [SMALL_STATE(10012)] = 505579,
  [SMALL_STATE(10013)] = 505592,
  [SMALL_STATE(10014)] = 505605,
  [SMALL_STATE(10015)] = 505616,
  [SMALL_STATE(10016)] = 505633,
  [SMALL_STATE(10017)] = 505646,
  [SMALL_STATE(10018)] = 505659,
  [SMALL_STATE(10019)] = 505676,
  [SMALL_STATE(10020)] = 505689,
  [SMALL_STATE(10021)] = 505702,
  [SMALL_STATE(10022)] = 505713,
  [SMALL_STATE(10023)] = 505730,
  [SMALL_STATE(10024)] = 505745,
  [SMALL_STATE(10025)] = 505758,
  [SMALL_STATE(10026)] = 505771,
  [SMALL_STATE(10027)] = 505784,
  [SMALL_STATE(10028)] = 505799,
  [SMALL_STATE(10029)] = 505812,
  [SMALL_STATE(10030)] = 505825,
  [SMALL_STATE(10031)] = 505840,
  [SMALL_STATE(10032)] = 505851,
  [SMALL_STATE(10033)] = 505864,
  [SMALL_STATE(10034)] = 505875,
  [SMALL_STATE(10035)] = 505888,
  [SMALL_STATE(10036)] = 505899,
  [SMALL_STATE(10037)] = 505912,
  [SMALL_STATE(10038)] = 505929,
  [SMALL_STATE(10039)] = 505942,
  [SMALL_STATE(10040)] = 505955,
  [SMALL_STATE(10041)] = 505968,
  [SMALL_STATE(10042)] = 505981,
  [SMALL_STATE(10043)] = 505994,
  [SMALL_STATE(10044)] = 506009,
  [SMALL_STATE(10045)] = 506022,
  [SMALL_STATE(10046)] = 506035,
  [SMALL_STATE(10047)] = 506048,
  [SMALL_STATE(10048)] = 506059,
  [SMALL_STATE(10049)] = 506070,
  [SMALL_STATE(10050)] = 506083,
  [SMALL_STATE(10051)] = 506096,
  [SMALL_STATE(10052)] = 506107,
  [SMALL_STATE(10053)] = 506124,
  [SMALL_STATE(10054)] = 506137,
  [SMALL_STATE(10055)] = 506150,
  [SMALL_STATE(10056)] = 506163,
  [SMALL_STATE(10057)] = 506176,
  [SMALL_STATE(10058)] = 506187,
  [SMALL_STATE(10059)] = 506198,
  [SMALL_STATE(10060)] = 506211,
  [SMALL_STATE(10061)] = 506224,
  [SMALL_STATE(10062)] = 506237,
  [SMALL_STATE(10063)] = 506250,
  [SMALL_STATE(10064)] = 506261,
  [SMALL_STATE(10065)] = 506276,
  [SMALL_STATE(10066)] = 506293,
  [SMALL_STATE(10067)] = 506306,
  [SMALL_STATE(10068)] = 506323,
  [SMALL_STATE(10069)] = 506336,
  [SMALL_STATE(10070)] = 506349,
  [SMALL_STATE(10071)] = 506366,
  [SMALL_STATE(10072)] = 506381,
  [SMALL_STATE(10073)] = 506392,
  [SMALL_STATE(10074)] = 506405,
  [SMALL_STATE(10075)] = 506418,
  [SMALL_STATE(10076)] = 506435,
  [SMALL_STATE(10077)] = 506452,
  [SMALL_STATE(10078)] = 506469,
  [SMALL_STATE(10079)] = 506480,
  [SMALL_STATE(10080)] = 506491,
  [SMALL_STATE(10081)] = 506508,
  [SMALL_STATE(10082)] = 506521,
  [SMALL_STATE(10083)] = 506534,
  [SMALL_STATE(10084)] = 506547,
  [SMALL_STATE(10085)] = 506564,
  [SMALL_STATE(10086)] = 506575,
  [SMALL_STATE(10087)] = 506592,
  [SMALL_STATE(10088)] = 506605,
  [SMALL_STATE(10089)] = 506622,
  [SMALL_STATE(10090)] = 506637,
  [SMALL_STATE(10091)] = 506654,
  [SMALL_STATE(10092)] = 506667,
  [SMALL_STATE(10093)] = 506682,
  [SMALL_STATE(10094)] = 506693,
  [SMALL_STATE(10095)] = 506704,
  [SMALL_STATE(10096)] = 506721,
  [SMALL_STATE(10097)] = 506732,
  [SMALL_STATE(10098)] = 506745,
  [SMALL_STATE(10099)] = 506760,
  [SMALL_STATE(10100)] = 506773,
  [SMALL_STATE(10101)] = 506784,
  [SMALL_STATE(10102)] = 506801,
  [SMALL_STATE(10103)] = 506814,
  [SMALL_STATE(10104)] = 506827,
  [SMALL_STATE(10105)] = 506844,
  [SMALL_STATE(10106)] = 506857,
  [SMALL_STATE(10107)] = 506870,
  [SMALL_STATE(10108)] = 506883,
  [SMALL_STATE(10109)] = 506900,
  [SMALL_STATE(10110)] = 506913,
  [SMALL_STATE(10111)] = 506928,
  [SMALL_STATE(10112)] = 506939,
  [SMALL_STATE(10113)] = 506956,
  [SMALL_STATE(10114)] = 506969,
  [SMALL_STATE(10115)] = 506980,
  [SMALL_STATE(10116)] = 506991,
  [SMALL_STATE(10117)] = 507002,
  [SMALL_STATE(10118)] = 507015,
  [SMALL_STATE(10119)] = 507030,
  [SMALL_STATE(10120)] = 507045,
  [SMALL_STATE(10121)] = 507058,
  [SMALL_STATE(10122)] = 507075,
  [SMALL_STATE(10123)] = 507088,
  [SMALL_STATE(10124)] = 507101,
  [SMALL_STATE(10125)] = 507114,
  [SMALL_STATE(10126)] = 507127,
  [SMALL_STATE(10127)] = 507140,
  [SMALL_STATE(10128)] = 507153,
  [SMALL_STATE(10129)] = 507164,
  [SMALL_STATE(10130)] = 507177,
  [SMALL_STATE(10131)] = 507190,
  [SMALL_STATE(10132)] = 507203,
  [SMALL_STATE(10133)] = 507220,
  [SMALL_STATE(10134)] = 507231,
  [SMALL_STATE(10135)] = 507246,
  [SMALL_STATE(10136)] = 507259,
  [SMALL_STATE(10137)] = 507272,
  [SMALL_STATE(10138)] = 507283,
  [SMALL_STATE(10139)] = 507298,
  [SMALL_STATE(10140)] = 507311,
  [SMALL_STATE(10141)] = 507324,
  [SMALL_STATE(10142)] = 507339,
  [SMALL_STATE(10143)] = 507354,
  [SMALL_STATE(10144)] = 507367,
  [SMALL_STATE(10145)] = 507384,
  [SMALL_STATE(10146)] = 507397,
  [SMALL_STATE(10147)] = 507408,
  [SMALL_STATE(10148)] = 507421,
  [SMALL_STATE(10149)] = 507434,
  [SMALL_STATE(10150)] = 507445,
  [SMALL_STATE(10151)] = 507462,
  [SMALL_STATE(10152)] = 507475,
  [SMALL_STATE(10153)] = 507488,
  [SMALL_STATE(10154)] = 507503,
  [SMALL_STATE(10155)] = 507520,
  [SMALL_STATE(10156)] = 507535,
  [SMALL_STATE(10157)] = 507552,
  [SMALL_STATE(10158)] = 507563,
  [SMALL_STATE(10159)] = 507578,
  [SMALL_STATE(10160)] = 507589,
  [SMALL_STATE(10161)] = 507600,
  [SMALL_STATE(10162)] = 507613,
  [SMALL_STATE(10163)] = 507624,
  [SMALL_STATE(10164)] = 507637,
  [SMALL_STATE(10165)] = 507654,
  [SMALL_STATE(10166)] = 507667,
  [SMALL_STATE(10167)] = 507680,
  [SMALL_STATE(10168)] = 507691,
  [SMALL_STATE(10169)] = 507704,
  [SMALL_STATE(10170)] = 507717,
  [SMALL_STATE(10171)] = 507734,
  [SMALL_STATE(10172)] = 507745,
  [SMALL_STATE(10173)] = 507756,
  [SMALL_STATE(10174)] = 507769,
  [SMALL_STATE(10175)] = 507780,
  [SMALL_STATE(10176)] = 507795,
  [SMALL_STATE(10177)] = 507806,
  [SMALL_STATE(10178)] = 507821,
  [SMALL_STATE(10179)] = 507836,
  [SMALL_STATE(10180)] = 507849,
  [SMALL_STATE(10181)] = 507864,
  [SMALL_STATE(10182)] = 507881,
  [SMALL_STATE(10183)] = 507894,
  [SMALL_STATE(10184)] = 507905,
  [SMALL_STATE(10185)] = 507918,
  [SMALL_STATE(10186)] = 507933,
  [SMALL_STATE(10187)] = 507946,
  [SMALL_STATE(10188)] = 507959,
  [SMALL_STATE(10189)] = 507976,
  [SMALL_STATE(10190)] = 507987,
  [SMALL_STATE(10191)] = 508002,
  [SMALL_STATE(10192)] = 508015,
  [SMALL_STATE(10193)] = 508026,
  [SMALL_STATE(10194)] = 508037,
  [SMALL_STATE(10195)] = 508054,
  [SMALL_STATE(10196)] = 508071,
  [SMALL_STATE(10197)] = 508084,
  [SMALL_STATE(10198)] = 508097,
  [SMALL_STATE(10199)] = 508110,
  [SMALL_STATE(10200)] = 508123,
  [SMALL_STATE(10201)] = 508136,
  [SMALL_STATE(10202)] = 508149,
  [SMALL_STATE(10203)] = 508162,
  [SMALL_STATE(10204)] = 508177,
  [SMALL_STATE(10205)] = 508194,
  [SMALL_STATE(10206)] = 508207,
  [SMALL_STATE(10207)] = 508220,
  [SMALL_STATE(10208)] = 508233,
  [SMALL_STATE(10209)] = 508250,
  [SMALL_STATE(10210)] = 508263,
  [SMALL_STATE(10211)] = 508276,
  [SMALL_STATE(10212)] = 508291,
  [SMALL_STATE(10213)] = 508306,
  [SMALL_STATE(10214)] = 508319,
  [SMALL_STATE(10215)] = 508332,
  [SMALL_STATE(10216)] = 508345,
  [SMALL_STATE(10217)] = 508358,
  [SMALL_STATE(10218)] = 508369,
  [SMALL_STATE(10219)] = 508386,
  [SMALL_STATE(10220)] = 508401,
  [SMALL_STATE(10221)] = 508414,
  [SMALL_STATE(10222)] = 508427,
  [SMALL_STATE(10223)] = 508440,
  [SMALL_STATE(10224)] = 508453,
  [SMALL_STATE(10225)] = 508463,
  [SMALL_STATE(10226)] = 508473,
  [SMALL_STATE(10227)] = 508483,
  [SMALL_STATE(10228)] = 508497,
  [SMALL_STATE(10229)] = 508511,
  [SMALL_STATE(10230)] = 508521,
  [SMALL_STATE(10231)] = 508531,
  [SMALL_STATE(10232)] = 508541,
  [SMALL_STATE(10233)] = 508551,
  [SMALL_STATE(10234)] = 508561,
  [SMALL_STATE(10235)] = 508571,
  [SMALL_STATE(10236)] = 508581,
  [SMALL_STATE(10237)] = 508591,
  [SMALL_STATE(10238)] = 508601,
  [SMALL_STATE(10239)] = 508611,
  [SMALL_STATE(10240)] = 508621,
  [SMALL_STATE(10241)] = 508631,
  [SMALL_STATE(10242)] = 508641,
  [SMALL_STATE(10243)] = 508651,
  [SMALL_STATE(10244)] = 508665,
  [SMALL_STATE(10245)] = 508679,
  [SMALL_STATE(10246)] = 508689,
  [SMALL_STATE(10247)] = 508703,
  [SMALL_STATE(10248)] = 508713,
  [SMALL_STATE(10249)] = 508723,
  [SMALL_STATE(10250)] = 508733,
  [SMALL_STATE(10251)] = 508743,
  [SMALL_STATE(10252)] = 508753,
  [SMALL_STATE(10253)] = 508765,
  [SMALL_STATE(10254)] = 508779,
  [SMALL_STATE(10255)] = 508789,
  [SMALL_STATE(10256)] = 508799,
  [SMALL_STATE(10257)] = 508809,
  [SMALL_STATE(10258)] = 508823,
  [SMALL_STATE(10259)] = 508833,
  [SMALL_STATE(10260)] = 508847,
  [SMALL_STATE(10261)] = 508861,
  [SMALL_STATE(10262)] = 508871,
  [SMALL_STATE(10263)] = 508885,
  [SMALL_STATE(10264)] = 508899,
  [SMALL_STATE(10265)] = 508913,
  [SMALL_STATE(10266)] = 508927,
  [SMALL_STATE(10267)] = 508941,
  [SMALL_STATE(10268)] = 508955,
  [SMALL_STATE(10269)] = 508969,
  [SMALL_STATE(10270)] = 508983,
  [SMALL_STATE(10271)] = 508997,
  [SMALL_STATE(10272)] = 509011,
  [SMALL_STATE(10273)] = 509025,
  [SMALL_STATE(10274)] = 509035,
  [SMALL_STATE(10275)] = 509049,
  [SMALL_STATE(10276)] = 509063,
  [SMALL_STATE(10277)] = 509073,
  [SMALL_STATE(10278)] = 509087,
  [SMALL_STATE(10279)] = 509101,
  [SMALL_STATE(10280)] = 509115,
  [SMALL_STATE(10281)] = 509125,
  [SMALL_STATE(10282)] = 509139,
  [SMALL_STATE(10283)] = 509153,
  [SMALL_STATE(10284)] = 509167,
  [SMALL_STATE(10285)] = 509181,
  [SMALL_STATE(10286)] = 509195,
  [SMALL_STATE(10287)] = 509209,
  [SMALL_STATE(10288)] = 509221,
  [SMALL_STATE(10289)] = 509235,
  [SMALL_STATE(10290)] = 509249,
  [SMALL_STATE(10291)] = 509263,
  [SMALL_STATE(10292)] = 509277,
  [SMALL_STATE(10293)] = 509291,
  [SMALL_STATE(10294)] = 509305,
  [SMALL_STATE(10295)] = 509319,
  [SMALL_STATE(10296)] = 509329,
  [SMALL_STATE(10297)] = 509343,
  [SMALL_STATE(10298)] = 509357,
  [SMALL_STATE(10299)] = 509367,
  [SMALL_STATE(10300)] = 509381,
  [SMALL_STATE(10301)] = 509395,
  [SMALL_STATE(10302)] = 509409,
  [SMALL_STATE(10303)] = 509423,
  [SMALL_STATE(10304)] = 509437,
  [SMALL_STATE(10305)] = 509447,
  [SMALL_STATE(10306)] = 509457,
  [SMALL_STATE(10307)] = 509471,
  [SMALL_STATE(10308)] = 509485,
  [SMALL_STATE(10309)] = 509495,
  [SMALL_STATE(10310)] = 509505,
  [SMALL_STATE(10311)] = 509515,
  [SMALL_STATE(10312)] = 509529,
  [SMALL_STATE(10313)] = 509543,
  [SMALL_STATE(10314)] = 509557,
  [SMALL_STATE(10315)] = 509571,
  [SMALL_STATE(10316)] = 509585,
  [SMALL_STATE(10317)] = 509599,
  [SMALL_STATE(10318)] = 509613,
  [SMALL_STATE(10319)] = 509623,
  [SMALL_STATE(10320)] = 509637,
  [SMALL_STATE(10321)] = 509647,
  [SMALL_STATE(10322)] = 509661,
  [SMALL_STATE(10323)] = 509671,
  [SMALL_STATE(10324)] = 509685,
  [SMALL_STATE(10325)] = 509699,
  [SMALL_STATE(10326)] = 509713,
  [SMALL_STATE(10327)] = 509723,
  [SMALL_STATE(10328)] = 509737,
  [SMALL_STATE(10329)] = 509751,
  [SMALL_STATE(10330)] = 509765,
  [SMALL_STATE(10331)] = 509775,
  [SMALL_STATE(10332)] = 509789,
  [SMALL_STATE(10333)] = 509803,
  [SMALL_STATE(10334)] = 509817,
  [SMALL_STATE(10335)] = 509831,
  [SMALL_STATE(10336)] = 509841,
  [SMALL_STATE(10337)] = 509851,
  [SMALL_STATE(10338)] = 509865,
  [SMALL_STATE(10339)] = 509879,
  [SMALL_STATE(10340)] = 509889,
  [SMALL_STATE(10341)] = 509899,
  [SMALL_STATE(10342)] = 509911,
  [SMALL_STATE(10343)] = 509923,
  [SMALL_STATE(10344)] = 509937,
  [SMALL_STATE(10345)] = 509947,
  [SMALL_STATE(10346)] = 509961,
  [SMALL_STATE(10347)] = 509971,
  [SMALL_STATE(10348)] = 509981,
  [SMALL_STATE(10349)] = 509993,
  [SMALL_STATE(10350)] = 510003,
  [SMALL_STATE(10351)] = 510015,
  [SMALL_STATE(10352)] = 510029,
  [SMALL_STATE(10353)] = 510043,
  [SMALL_STATE(10354)] = 510057,
  [SMALL_STATE(10355)] = 510071,
  [SMALL_STATE(10356)] = 510085,
  [SMALL_STATE(10357)] = 510099,
  [SMALL_STATE(10358)] = 510111,
  [SMALL_STATE(10359)] = 510121,
  [SMALL_STATE(10360)] = 510135,
  [SMALL_STATE(10361)] = 510145,
  [SMALL_STATE(10362)] = 510155,
  [SMALL_STATE(10363)] = 510165,
  [SMALL_STATE(10364)] = 510177,
  [SMALL_STATE(10365)] = 510191,
  [SMALL_STATE(10366)] = 510201,
  [SMALL_STATE(10367)] = 510213,
  [SMALL_STATE(10368)] = 510227,
  [SMALL_STATE(10369)] = 510239,
  [SMALL_STATE(10370)] = 510249,
  [SMALL_STATE(10371)] = 510263,
  [SMALL_STATE(10372)] = 510277,
  [SMALL_STATE(10373)] = 510287,
  [SMALL_STATE(10374)] = 510297,
  [SMALL_STATE(10375)] = 510307,
  [SMALL_STATE(10376)] = 510317,
  [SMALL_STATE(10377)] = 510331,
  [SMALL_STATE(10378)] = 510343,
  [SMALL_STATE(10379)] = 510357,
  [SMALL_STATE(10380)] = 510371,
  [SMALL_STATE(10381)] = 510381,
  [SMALL_STATE(10382)] = 510391,
  [SMALL_STATE(10383)] = 510401,
  [SMALL_STATE(10384)] = 510415,
  [SMALL_STATE(10385)] = 510429,
  [SMALL_STATE(10386)] = 510443,
  [SMALL_STATE(10387)] = 510455,
  [SMALL_STATE(10388)] = 510469,
  [SMALL_STATE(10389)] = 510483,
  [SMALL_STATE(10390)] = 510497,
  [SMALL_STATE(10391)] = 510511,
  [SMALL_STATE(10392)] = 510523,
  [SMALL_STATE(10393)] = 510537,
  [SMALL_STATE(10394)] = 510551,
  [SMALL_STATE(10395)] = 510565,
  [SMALL_STATE(10396)] = 510579,
  [SMALL_STATE(10397)] = 510593,
  [SMALL_STATE(10398)] = 510607,
  [SMALL_STATE(10399)] = 510617,
  [SMALL_STATE(10400)] = 510631,
  [SMALL_STATE(10401)] = 510645,
  [SMALL_STATE(10402)] = 510655,
  [SMALL_STATE(10403)] = 510669,
  [SMALL_STATE(10404)] = 510683,
  [SMALL_STATE(10405)] = 510697,
  [SMALL_STATE(10406)] = 510709,
  [SMALL_STATE(10407)] = 510723,
  [SMALL_STATE(10408)] = 510737,
  [SMALL_STATE(10409)] = 510751,
  [SMALL_STATE(10410)] = 510765,
  [SMALL_STATE(10411)] = 510779,
  [SMALL_STATE(10412)] = 510793,
  [SMALL_STATE(10413)] = 510807,
  [SMALL_STATE(10414)] = 510817,
  [SMALL_STATE(10415)] = 510831,
  [SMALL_STATE(10416)] = 510845,
  [SMALL_STATE(10417)] = 510857,
  [SMALL_STATE(10418)] = 510867,
  [SMALL_STATE(10419)] = 510877,
  [SMALL_STATE(10420)] = 510889,
  [SMALL_STATE(10421)] = 510899,
  [SMALL_STATE(10422)] = 510909,
  [SMALL_STATE(10423)] = 510921,
  [SMALL_STATE(10424)] = 510931,
  [SMALL_STATE(10425)] = 510945,
  [SMALL_STATE(10426)] = 510955,
  [SMALL_STATE(10427)] = 510969,
  [SMALL_STATE(10428)] = 510979,
  [SMALL_STATE(10429)] = 510989,
  [SMALL_STATE(10430)] = 511003,
  [SMALL_STATE(10431)] = 511013,
  [SMALL_STATE(10432)] = 511027,
  [SMALL_STATE(10433)] = 511041,
  [SMALL_STATE(10434)] = 511055,
  [SMALL_STATE(10435)] = 511069,
  [SMALL_STATE(10436)] = 511079,
  [SMALL_STATE(10437)] = 511089,
  [SMALL_STATE(10438)] = 511103,
  [SMALL_STATE(10439)] = 511113,
  [SMALL_STATE(10440)] = 511127,
  [SMALL_STATE(10441)] = 511139,
  [SMALL_STATE(10442)] = 511153,
  [SMALL_STATE(10443)] = 511167,
  [SMALL_STATE(10444)] = 511177,
  [SMALL_STATE(10445)] = 511191,
  [SMALL_STATE(10446)] = 511205,
  [SMALL_STATE(10447)] = 511219,
  [SMALL_STATE(10448)] = 511233,
  [SMALL_STATE(10449)] = 511243,
  [SMALL_STATE(10450)] = 511255,
  [SMALL_STATE(10451)] = 511265,
  [SMALL_STATE(10452)] = 511275,
  [SMALL_STATE(10453)] = 511285,
  [SMALL_STATE(10454)] = 511297,
  [SMALL_STATE(10455)] = 511307,
  [SMALL_STATE(10456)] = 511319,
  [SMALL_STATE(10457)] = 511329,
  [SMALL_STATE(10458)] = 511339,
  [SMALL_STATE(10459)] = 511353,
  [SMALL_STATE(10460)] = 511363,
  [SMALL_STATE(10461)] = 511373,
  [SMALL_STATE(10462)] = 511383,
  [SMALL_STATE(10463)] = 511393,
  [SMALL_STATE(10464)] = 511403,
  [SMALL_STATE(10465)] = 511417,
  [SMALL_STATE(10466)] = 511427,
  [SMALL_STATE(10467)] = 511437,
  [SMALL_STATE(10468)] = 511449,
  [SMALL_STATE(10469)] = 511459,
  [SMALL_STATE(10470)] = 511473,
  [SMALL_STATE(10471)] = 511483,
  [SMALL_STATE(10472)] = 511497,
  [SMALL_STATE(10473)] = 511511,
  [SMALL_STATE(10474)] = 511525,
  [SMALL_STATE(10475)] = 511535,
  [SMALL_STATE(10476)] = 511549,
  [SMALL_STATE(10477)] = 511559,
  [SMALL_STATE(10478)] = 511569,
  [SMALL_STATE(10479)] = 511579,
  [SMALL_STATE(10480)] = 511591,
  [SMALL_STATE(10481)] = 511601,
  [SMALL_STATE(10482)] = 511611,
  [SMALL_STATE(10483)] = 511625,
  [SMALL_STATE(10484)] = 511639,
  [SMALL_STATE(10485)] = 511653,
  [SMALL_STATE(10486)] = 511665,
  [SMALL_STATE(10487)] = 511679,
  [SMALL_STATE(10488)] = 511689,
  [SMALL_STATE(10489)] = 511703,
  [SMALL_STATE(10490)] = 511717,
  [SMALL_STATE(10491)] = 511727,
  [SMALL_STATE(10492)] = 511741,
  [SMALL_STATE(10493)] = 511755,
  [SMALL_STATE(10494)] = 511765,
  [SMALL_STATE(10495)] = 511775,
  [SMALL_STATE(10496)] = 511789,
  [SMALL_STATE(10497)] = 511803,
  [SMALL_STATE(10498)] = 511813,
  [SMALL_STATE(10499)] = 511827,
  [SMALL_STATE(10500)] = 511841,
  [SMALL_STATE(10501)] = 511855,
  [SMALL_STATE(10502)] = 511869,
  [SMALL_STATE(10503)] = 511883,
  [SMALL_STATE(10504)] = 511893,
  [SMALL_STATE(10505)] = 511907,
  [SMALL_STATE(10506)] = 511917,
  [SMALL_STATE(10507)] = 511931,
  [SMALL_STATE(10508)] = 511945,
  [SMALL_STATE(10509)] = 511959,
  [SMALL_STATE(10510)] = 511969,
  [SMALL_STATE(10511)] = 511983,
  [SMALL_STATE(10512)] = 511993,
  [SMALL_STATE(10513)] = 512007,
  [SMALL_STATE(10514)] = 512021,
  [SMALL_STATE(10515)] = 512035,
  [SMALL_STATE(10516)] = 512045,
  [SMALL_STATE(10517)] = 512055,
  [SMALL_STATE(10518)] = 512069,
  [SMALL_STATE(10519)] = 512079,
  [SMALL_STATE(10520)] = 512089,
  [SMALL_STATE(10521)] = 512099,
  [SMALL_STATE(10522)] = 512113,
  [SMALL_STATE(10523)] = 512127,
  [SMALL_STATE(10524)] = 512141,
  [SMALL_STATE(10525)] = 512151,
  [SMALL_STATE(10526)] = 512161,
  [SMALL_STATE(10527)] = 512173,
  [SMALL_STATE(10528)] = 512187,
  [SMALL_STATE(10529)] = 512199,
  [SMALL_STATE(10530)] = 512213,
  [SMALL_STATE(10531)] = 512227,
  [SMALL_STATE(10532)] = 512241,
  [SMALL_STATE(10533)] = 512255,
  [SMALL_STATE(10534)] = 512265,
  [SMALL_STATE(10535)] = 512279,
  [SMALL_STATE(10536)] = 512293,
  [SMALL_STATE(10537)] = 512303,
  [SMALL_STATE(10538)] = 512317,
  [SMALL_STATE(10539)] = 512331,
  [SMALL_STATE(10540)] = 512345,
  [SMALL_STATE(10541)] = 512359,
  [SMALL_STATE(10542)] = 512369,
  [SMALL_STATE(10543)] = 512383,
  [SMALL_STATE(10544)] = 512393,
  [SMALL_STATE(10545)] = 512405,
  [SMALL_STATE(10546)] = 512415,
  [SMALL_STATE(10547)] = 512427,
  [SMALL_STATE(10548)] = 512441,
  [SMALL_STATE(10549)] = 512451,
  [SMALL_STATE(10550)] = 512465,
  [SMALL_STATE(10551)] = 512479,
  [SMALL_STATE(10552)] = 512489,
  [SMALL_STATE(10553)] = 512503,
  [SMALL_STATE(10554)] = 512513,
  [SMALL_STATE(10555)] = 512527,
  [SMALL_STATE(10556)] = 512537,
  [SMALL_STATE(10557)] = 512549,
  [SMALL_STATE(10558)] = 512563,
  [SMALL_STATE(10559)] = 512573,
  [SMALL_STATE(10560)] = 512587,
  [SMALL_STATE(10561)] = 512601,
  [SMALL_STATE(10562)] = 512615,
  [SMALL_STATE(10563)] = 512627,
  [SMALL_STATE(10564)] = 512641,
  [SMALL_STATE(10565)] = 512655,
  [SMALL_STATE(10566)] = 512667,
  [SMALL_STATE(10567)] = 512681,
  [SMALL_STATE(10568)] = 512695,
  [SMALL_STATE(10569)] = 512709,
  [SMALL_STATE(10570)] = 512721,
  [SMALL_STATE(10571)] = 512731,
  [SMALL_STATE(10572)] = 512745,
  [SMALL_STATE(10573)] = 512759,
  [SMALL_STATE(10574)] = 512773,
  [SMALL_STATE(10575)] = 512785,
  [SMALL_STATE(10576)] = 512795,
  [SMALL_STATE(10577)] = 512809,
  [SMALL_STATE(10578)] = 512821,
  [SMALL_STATE(10579)] = 512835,
  [SMALL_STATE(10580)] = 512849,
  [SMALL_STATE(10581)] = 512861,
  [SMALL_STATE(10582)] = 512875,
  [SMALL_STATE(10583)] = 512887,
  [SMALL_STATE(10584)] = 512899,
  [SMALL_STATE(10585)] = 512913,
  [SMALL_STATE(10586)] = 512923,
  [SMALL_STATE(10587)] = 512933,
  [SMALL_STATE(10588)] = 512947,
  [SMALL_STATE(10589)] = 512957,
  [SMALL_STATE(10590)] = 512971,
  [SMALL_STATE(10591)] = 512985,
  [SMALL_STATE(10592)] = 512997,
  [SMALL_STATE(10593)] = 513009,
  [SMALL_STATE(10594)] = 513019,
  [SMALL_STATE(10595)] = 513033,
  [SMALL_STATE(10596)] = 513047,
  [SMALL_STATE(10597)] = 513061,
  [SMALL_STATE(10598)] = 513075,
  [SMALL_STATE(10599)] = 513089,
  [SMALL_STATE(10600)] = 513101,
  [SMALL_STATE(10601)] = 513115,
  [SMALL_STATE(10602)] = 513129,
  [SMALL_STATE(10603)] = 513139,
  [SMALL_STATE(10604)] = 513149,
  [SMALL_STATE(10605)] = 513163,
  [SMALL_STATE(10606)] = 513177,
  [SMALL_STATE(10607)] = 513187,
  [SMALL_STATE(10608)] = 513197,
  [SMALL_STATE(10609)] = 513207,
  [SMALL_STATE(10610)] = 513221,
  [SMALL_STATE(10611)] = 513233,
  [SMALL_STATE(10612)] = 513243,
  [SMALL_STATE(10613)] = 513253,
  [SMALL_STATE(10614)] = 513263,
  [SMALL_STATE(10615)] = 513277,
  [SMALL_STATE(10616)] = 513291,
  [SMALL_STATE(10617)] = 513301,
  [SMALL_STATE(10618)] = 513311,
  [SMALL_STATE(10619)] = 513325,
  [SMALL_STATE(10620)] = 513337,
  [SMALL_STATE(10621)] = 513351,
  [SMALL_STATE(10622)] = 513365,
  [SMALL_STATE(10623)] = 513377,
  [SMALL_STATE(10624)] = 513391,
  [SMALL_STATE(10625)] = 513401,
  [SMALL_STATE(10626)] = 513415,
  [SMALL_STATE(10627)] = 513427,
  [SMALL_STATE(10628)] = 513437,
  [SMALL_STATE(10629)] = 513451,
  [SMALL_STATE(10630)] = 513465,
  [SMALL_STATE(10631)] = 513479,
  [SMALL_STATE(10632)] = 513493,
  [SMALL_STATE(10633)] = 513505,
  [SMALL_STATE(10634)] = 513519,
  [SMALL_STATE(10635)] = 513529,
  [SMALL_STATE(10636)] = 513541,
  [SMALL_STATE(10637)] = 513555,
  [SMALL_STATE(10638)] = 513565,
  [SMALL_STATE(10639)] = 513575,
  [SMALL_STATE(10640)] = 513589,
  [SMALL_STATE(10641)] = 513603,
  [SMALL_STATE(10642)] = 513617,
  [SMALL_STATE(10643)] = 513631,
  [SMALL_STATE(10644)] = 513645,
  [SMALL_STATE(10645)] = 513655,
  [SMALL_STATE(10646)] = 513669,
  [SMALL_STATE(10647)] = 513683,
  [SMALL_STATE(10648)] = 513697,
  [SMALL_STATE(10649)] = 513711,
  [SMALL_STATE(10650)] = 513721,
  [SMALL_STATE(10651)] = 513735,
  [SMALL_STATE(10652)] = 513745,
  [SMALL_STATE(10653)] = 513759,
  [SMALL_STATE(10654)] = 513773,
  [SMALL_STATE(10655)] = 513783,
  [SMALL_STATE(10656)] = 513797,
  [SMALL_STATE(10657)] = 513811,
  [SMALL_STATE(10658)] = 513825,
  [SMALL_STATE(10659)] = 513835,
  [SMALL_STATE(10660)] = 513849,
  [SMALL_STATE(10661)] = 513863,
  [SMALL_STATE(10662)] = 513873,
  [SMALL_STATE(10663)] = 513883,
  [SMALL_STATE(10664)] = 513897,
  [SMALL_STATE(10665)] = 513907,
  [SMALL_STATE(10666)] = 513919,
  [SMALL_STATE(10667)] = 513931,
  [SMALL_STATE(10668)] = 513945,
  [SMALL_STATE(10669)] = 513959,
  [SMALL_STATE(10670)] = 513973,
  [SMALL_STATE(10671)] = 513983,
  [SMALL_STATE(10672)] = 513997,
  [SMALL_STATE(10673)] = 514007,
  [SMALL_STATE(10674)] = 514017,
  [SMALL_STATE(10675)] = 514031,
  [SMALL_STATE(10676)] = 514041,
  [SMALL_STATE(10677)] = 514055,
  [SMALL_STATE(10678)] = 514065,
  [SMALL_STATE(10679)] = 514075,
  [SMALL_STATE(10680)] = 514085,
  [SMALL_STATE(10681)] = 514095,
  [SMALL_STATE(10682)] = 514109,
  [SMALL_STATE(10683)] = 514119,
  [SMALL_STATE(10684)] = 514133,
  [SMALL_STATE(10685)] = 514147,
  [SMALL_STATE(10686)] = 514157,
  [SMALL_STATE(10687)] = 514167,
  [SMALL_STATE(10688)] = 514181,
  [SMALL_STATE(10689)] = 514191,
  [SMALL_STATE(10690)] = 514201,
  [SMALL_STATE(10691)] = 514211,
  [SMALL_STATE(10692)] = 514225,
  [SMALL_STATE(10693)] = 514239,
  [SMALL_STATE(10694)] = 514253,
  [SMALL_STATE(10695)] = 514267,
  [SMALL_STATE(10696)] = 514279,
  [SMALL_STATE(10697)] = 514293,
  [SMALL_STATE(10698)] = 514303,
  [SMALL_STATE(10699)] = 514313,
  [SMALL_STATE(10700)] = 514323,
  [SMALL_STATE(10701)] = 514333,
  [SMALL_STATE(10702)] = 514343,
  [SMALL_STATE(10703)] = 514357,
  [SMALL_STATE(10704)] = 514371,
  [SMALL_STATE(10705)] = 514381,
  [SMALL_STATE(10706)] = 514393,
  [SMALL_STATE(10707)] = 514407,
  [SMALL_STATE(10708)] = 514419,
  [SMALL_STATE(10709)] = 514429,
  [SMALL_STATE(10710)] = 514439,
  [SMALL_STATE(10711)] = 514453,
  [SMALL_STATE(10712)] = 514463,
  [SMALL_STATE(10713)] = 514473,
  [SMALL_STATE(10714)] = 514487,
  [SMALL_STATE(10715)] = 514501,
  [SMALL_STATE(10716)] = 514515,
  [SMALL_STATE(10717)] = 514529,
  [SMALL_STATE(10718)] = 514543,
  [SMALL_STATE(10719)] = 514557,
  [SMALL_STATE(10720)] = 514567,
  [SMALL_STATE(10721)] = 514577,
  [SMALL_STATE(10722)] = 514587,
  [SMALL_STATE(10723)] = 514601,
  [SMALL_STATE(10724)] = 514615,
  [SMALL_STATE(10725)] = 514625,
  [SMALL_STATE(10726)] = 514639,
  [SMALL_STATE(10727)] = 514649,
  [SMALL_STATE(10728)] = 514663,
  [SMALL_STATE(10729)] = 514677,
  [SMALL_STATE(10730)] = 514687,
  [SMALL_STATE(10731)] = 514697,
  [SMALL_STATE(10732)] = 514709,
  [SMALL_STATE(10733)] = 514723,
  [SMALL_STATE(10734)] = 514737,
  [SMALL_STATE(10735)] = 514751,
  [SMALL_STATE(10736)] = 514763,
  [SMALL_STATE(10737)] = 514777,
  [SMALL_STATE(10738)] = 514787,
  [SMALL_STATE(10739)] = 514801,
  [SMALL_STATE(10740)] = 514815,
  [SMALL_STATE(10741)] = 514825,
  [SMALL_STATE(10742)] = 514837,
  [SMALL_STATE(10743)] = 514849,
  [SMALL_STATE(10744)] = 514863,
  [SMALL_STATE(10745)] = 514873,
  [SMALL_STATE(10746)] = 514887,
  [SMALL_STATE(10747)] = 514899,
  [SMALL_STATE(10748)] = 514913,
  [SMALL_STATE(10749)] = 514927,
  [SMALL_STATE(10750)] = 514941,
  [SMALL_STATE(10751)] = 514955,
  [SMALL_STATE(10752)] = 514965,
  [SMALL_STATE(10753)] = 514979,
  [SMALL_STATE(10754)] = 514993,
  [SMALL_STATE(10755)] = 515007,
  [SMALL_STATE(10756)] = 515021,
  [SMALL_STATE(10757)] = 515035,
  [SMALL_STATE(10758)] = 515045,
  [SMALL_STATE(10759)] = 515059,
  [SMALL_STATE(10760)] = 515073,
  [SMALL_STATE(10761)] = 515087,
  [SMALL_STATE(10762)] = 515101,
  [SMALL_STATE(10763)] = 515115,
  [SMALL_STATE(10764)] = 515129,
  [SMALL_STATE(10765)] = 515139,
  [SMALL_STATE(10766)] = 515153,
  [SMALL_STATE(10767)] = 515167,
  [SMALL_STATE(10768)] = 515179,
  [SMALL_STATE(10769)] = 515193,
  [SMALL_STATE(10770)] = 515203,
  [SMALL_STATE(10771)] = 515213,
  [SMALL_STATE(10772)] = 515223,
  [SMALL_STATE(10773)] = 515233,
  [SMALL_STATE(10774)] = 515247,
  [SMALL_STATE(10775)] = 515259,
  [SMALL_STATE(10776)] = 515269,
  [SMALL_STATE(10777)] = 515283,
  [SMALL_STATE(10778)] = 515293,
  [SMALL_STATE(10779)] = 515307,
  [SMALL_STATE(10780)] = 515321,
  [SMALL_STATE(10781)] = 515335,
  [SMALL_STATE(10782)] = 515349,
  [SMALL_STATE(10783)] = 515363,
  [SMALL_STATE(10784)] = 515377,
  [SMALL_STATE(10785)] = 515387,
  [SMALL_STATE(10786)] = 515397,
  [SMALL_STATE(10787)] = 515411,
  [SMALL_STATE(10788)] = 515421,
  [SMALL_STATE(10789)] = 515435,
  [SMALL_STATE(10790)] = 515445,
  [SMALL_STATE(10791)] = 515459,
  [SMALL_STATE(10792)] = 515469,
  [SMALL_STATE(10793)] = 515483,
  [SMALL_STATE(10794)] = 515497,
  [SMALL_STATE(10795)] = 515507,
  [SMALL_STATE(10796)] = 515521,
  [SMALL_STATE(10797)] = 515535,
  [SMALL_STATE(10798)] = 515549,
  [SMALL_STATE(10799)] = 515563,
  [SMALL_STATE(10800)] = 515577,
  [SMALL_STATE(10801)] = 515587,
  [SMALL_STATE(10802)] = 515597,
  [SMALL_STATE(10803)] = 515611,
  [SMALL_STATE(10804)] = 515625,
  [SMALL_STATE(10805)] = 515637,
  [SMALL_STATE(10806)] = 515651,
  [SMALL_STATE(10807)] = 515665,
  [SMALL_STATE(10808)] = 515677,
  [SMALL_STATE(10809)] = 515691,
  [SMALL_STATE(10810)] = 515705,
  [SMALL_STATE(10811)] = 515715,
  [SMALL_STATE(10812)] = 515725,
  [SMALL_STATE(10813)] = 515735,
  [SMALL_STATE(10814)] = 515745,
  [SMALL_STATE(10815)] = 515755,
  [SMALL_STATE(10816)] = 515769,
  [SMALL_STATE(10817)] = 515783,
  [SMALL_STATE(10818)] = 515797,
  [SMALL_STATE(10819)] = 515811,
  [SMALL_STATE(10820)] = 515821,
  [SMALL_STATE(10821)] = 515831,
  [SMALL_STATE(10822)] = 515845,
  [SMALL_STATE(10823)] = 515855,
  [SMALL_STATE(10824)] = 515865,
  [SMALL_STATE(10825)] = 515879,
  [SMALL_STATE(10826)] = 515889,
  [SMALL_STATE(10827)] = 515899,
  [SMALL_STATE(10828)] = 515913,
  [SMALL_STATE(10829)] = 515923,
  [SMALL_STATE(10830)] = 515933,
  [SMALL_STATE(10831)] = 515943,
  [SMALL_STATE(10832)] = 515957,
  [SMALL_STATE(10833)] = 515971,
  [SMALL_STATE(10834)] = 515985,
  [SMALL_STATE(10835)] = 515999,
  [SMALL_STATE(10836)] = 516013,
  [SMALL_STATE(10837)] = 516023,
  [SMALL_STATE(10838)] = 516033,
  [SMALL_STATE(10839)] = 516047,
  [SMALL_STATE(10840)] = 516057,
  [SMALL_STATE(10841)] = 516071,
  [SMALL_STATE(10842)] = 516085,
  [SMALL_STATE(10843)] = 516095,
  [SMALL_STATE(10844)] = 516109,
  [SMALL_STATE(10845)] = 516119,
  [SMALL_STATE(10846)] = 516129,
  [SMALL_STATE(10847)] = 516143,
  [SMALL_STATE(10848)] = 516155,
  [SMALL_STATE(10849)] = 516169,
  [SMALL_STATE(10850)] = 516183,
  [SMALL_STATE(10851)] = 516193,
  [SMALL_STATE(10852)] = 516203,
  [SMALL_STATE(10853)] = 516215,
  [SMALL_STATE(10854)] = 516229,
  [SMALL_STATE(10855)] = 516243,
  [SMALL_STATE(10856)] = 516257,
  [SMALL_STATE(10857)] = 516271,
  [SMALL_STATE(10858)] = 516285,
  [SMALL_STATE(10859)] = 516299,
  [SMALL_STATE(10860)] = 516309,
  [SMALL_STATE(10861)] = 516323,
  [SMALL_STATE(10862)] = 516335,
  [SMALL_STATE(10863)] = 516349,
  [SMALL_STATE(10864)] = 516363,
  [SMALL_STATE(10865)] = 516377,
  [SMALL_STATE(10866)] = 516387,
  [SMALL_STATE(10867)] = 516401,
  [SMALL_STATE(10868)] = 516415,
  [SMALL_STATE(10869)] = 516429,
  [SMALL_STATE(10870)] = 516443,
  [SMALL_STATE(10871)] = 516453,
  [SMALL_STATE(10872)] = 516467,
  [SMALL_STATE(10873)] = 516477,
  [SMALL_STATE(10874)] = 516491,
  [SMALL_STATE(10875)] = 516505,
  [SMALL_STATE(10876)] = 516519,
  [SMALL_STATE(10877)] = 516529,
  [SMALL_STATE(10878)] = 516543,
  [SMALL_STATE(10879)] = 516557,
  [SMALL_STATE(10880)] = 516571,
  [SMALL_STATE(10881)] = 516581,
  [SMALL_STATE(10882)] = 516595,
  [SMALL_STATE(10883)] = 516609,
  [SMALL_STATE(10884)] = 516623,
  [SMALL_STATE(10885)] = 516637,
  [SMALL_STATE(10886)] = 516651,
  [SMALL_STATE(10887)] = 516661,
  [SMALL_STATE(10888)] = 516675,
  [SMALL_STATE(10889)] = 516685,
  [SMALL_STATE(10890)] = 516695,
  [SMALL_STATE(10891)] = 516709,
  [SMALL_STATE(10892)] = 516719,
  [SMALL_STATE(10893)] = 516733,
  [SMALL_STATE(10894)] = 516743,
  [SMALL_STATE(10895)] = 516757,
  [SMALL_STATE(10896)] = 516771,
  [SMALL_STATE(10897)] = 516785,
  [SMALL_STATE(10898)] = 516799,
  [SMALL_STATE(10899)] = 516813,
  [SMALL_STATE(10900)] = 516827,
  [SMALL_STATE(10901)] = 516837,
  [SMALL_STATE(10902)] = 516851,
  [SMALL_STATE(10903)] = 516861,
  [SMALL_STATE(10904)] = 516873,
  [SMALL_STATE(10905)] = 516887,
  [SMALL_STATE(10906)] = 516901,
  [SMALL_STATE(10907)] = 516915,
  [SMALL_STATE(10908)] = 516929,
  [SMALL_STATE(10909)] = 516943,
  [SMALL_STATE(10910)] = 516953,
  [SMALL_STATE(10911)] = 516967,
  [SMALL_STATE(10912)] = 516981,
  [SMALL_STATE(10913)] = 516995,
  [SMALL_STATE(10914)] = 517009,
  [SMALL_STATE(10915)] = 517023,
  [SMALL_STATE(10916)] = 517037,
  [SMALL_STATE(10917)] = 517049,
  [SMALL_STATE(10918)] = 517063,
  [SMALL_STATE(10919)] = 517077,
  [SMALL_STATE(10920)] = 517091,
  [SMALL_STATE(10921)] = 517105,
  [SMALL_STATE(10922)] = 517119,
  [SMALL_STATE(10923)] = 517133,
  [SMALL_STATE(10924)] = 517147,
  [SMALL_STATE(10925)] = 517159,
  [SMALL_STATE(10926)] = 517169,
  [SMALL_STATE(10927)] = 517183,
  [SMALL_STATE(10928)] = 517197,
  [SMALL_STATE(10929)] = 517211,
  [SMALL_STATE(10930)] = 517223,
  [SMALL_STATE(10931)] = 517233,
  [SMALL_STATE(10932)] = 517247,
  [SMALL_STATE(10933)] = 517261,
  [SMALL_STATE(10934)] = 517271,
  [SMALL_STATE(10935)] = 517285,
  [SMALL_STATE(10936)] = 517299,
  [SMALL_STATE(10937)] = 517313,
  [SMALL_STATE(10938)] = 517327,
  [SMALL_STATE(10939)] = 517341,
  [SMALL_STATE(10940)] = 517355,
  [SMALL_STATE(10941)] = 517369,
  [SMALL_STATE(10942)] = 517379,
  [SMALL_STATE(10943)] = 517393,
  [SMALL_STATE(10944)] = 517407,
  [SMALL_STATE(10945)] = 517421,
  [SMALL_STATE(10946)] = 517431,
  [SMALL_STATE(10947)] = 517441,
  [SMALL_STATE(10948)] = 517455,
  [SMALL_STATE(10949)] = 517465,
  [SMALL_STATE(10950)] = 517475,
  [SMALL_STATE(10951)] = 517489,
  [SMALL_STATE(10952)] = 517499,
  [SMALL_STATE(10953)] = 517513,
  [SMALL_STATE(10954)] = 517527,
  [SMALL_STATE(10955)] = 517537,
  [SMALL_STATE(10956)] = 517547,
  [SMALL_STATE(10957)] = 517561,
  [SMALL_STATE(10958)] = 517575,
  [SMALL_STATE(10959)] = 517589,
  [SMALL_STATE(10960)] = 517603,
  [SMALL_STATE(10961)] = 517617,
  [SMALL_STATE(10962)] = 517631,
  [SMALL_STATE(10963)] = 517645,
  [SMALL_STATE(10964)] = 517659,
  [SMALL_STATE(10965)] = 517673,
  [SMALL_STATE(10966)] = 517687,
  [SMALL_STATE(10967)] = 517701,
  [SMALL_STATE(10968)] = 517711,
  [SMALL_STATE(10969)] = 517725,
  [SMALL_STATE(10970)] = 517739,
  [SMALL_STATE(10971)] = 517753,
  [SMALL_STATE(10972)] = 517767,
  [SMALL_STATE(10973)] = 517777,
  [SMALL_STATE(10974)] = 517791,
  [SMALL_STATE(10975)] = 517805,
  [SMALL_STATE(10976)] = 517819,
  [SMALL_STATE(10977)] = 517833,
  [SMALL_STATE(10978)] = 517847,
  [SMALL_STATE(10979)] = 517861,
  [SMALL_STATE(10980)] = 517871,
  [SMALL_STATE(10981)] = 517881,
  [SMALL_STATE(10982)] = 517891,
  [SMALL_STATE(10983)] = 517905,
  [SMALL_STATE(10984)] = 517919,
  [SMALL_STATE(10985)] = 517933,
  [SMALL_STATE(10986)] = 517947,
  [SMALL_STATE(10987)] = 517961,
  [SMALL_STATE(10988)] = 517975,
  [SMALL_STATE(10989)] = 517985,
  [SMALL_STATE(10990)] = 517995,
  [SMALL_STATE(10991)] = 518005,
  [SMALL_STATE(10992)] = 518017,
  [SMALL_STATE(10993)] = 518029,
  [SMALL_STATE(10994)] = 518043,
  [SMALL_STATE(10995)] = 518057,
  [SMALL_STATE(10996)] = 518071,
  [SMALL_STATE(10997)] = 518081,
  [SMALL_STATE(10998)] = 518095,
  [SMALL_STATE(10999)] = 518109,
  [SMALL_STATE(11000)] = 518123,
  [SMALL_STATE(11001)] = 518137,
  [SMALL_STATE(11002)] = 518147,
  [SMALL_STATE(11003)] = 518159,
  [SMALL_STATE(11004)] = 518173,
  [SMALL_STATE(11005)] = 518183,
  [SMALL_STATE(11006)] = 518193,
  [SMALL_STATE(11007)] = 518207,
  [SMALL_STATE(11008)] = 518221,
  [SMALL_STATE(11009)] = 518231,
  [SMALL_STATE(11010)] = 518245,
  [SMALL_STATE(11011)] = 518259,
  [SMALL_STATE(11012)] = 518269,
  [SMALL_STATE(11013)] = 518283,
  [SMALL_STATE(11014)] = 518293,
  [SMALL_STATE(11015)] = 518307,
  [SMALL_STATE(11016)] = 518321,
  [SMALL_STATE(11017)] = 518331,
  [SMALL_STATE(11018)] = 518341,
  [SMALL_STATE(11019)] = 518351,
  [SMALL_STATE(11020)] = 518365,
  [SMALL_STATE(11021)] = 518375,
  [SMALL_STATE(11022)] = 518385,
  [SMALL_STATE(11023)] = 518399,
  [SMALL_STATE(11024)] = 518409,
  [SMALL_STATE(11025)] = 518423,
  [SMALL_STATE(11026)] = 518437,
  [SMALL_STATE(11027)] = 518451,
  [SMALL_STATE(11028)] = 518465,
  [SMALL_STATE(11029)] = 518479,
  [SMALL_STATE(11030)] = 518489,
  [SMALL_STATE(11031)] = 518503,
  [SMALL_STATE(11032)] = 518517,
  [SMALL_STATE(11033)] = 518531,
  [SMALL_STATE(11034)] = 518545,
  [SMALL_STATE(11035)] = 518555,
  [SMALL_STATE(11036)] = 518569,
  [SMALL_STATE(11037)] = 518583,
  [SMALL_STATE(11038)] = 518593,
  [SMALL_STATE(11039)] = 518603,
  [SMALL_STATE(11040)] = 518617,
  [SMALL_STATE(11041)] = 518627,
  [SMALL_STATE(11042)] = 518641,
  [SMALL_STATE(11043)] = 518655,
  [SMALL_STATE(11044)] = 518665,
  [SMALL_STATE(11045)] = 518675,
  [SMALL_STATE(11046)] = 518685,
  [SMALL_STATE(11047)] = 518699,
  [SMALL_STATE(11048)] = 518713,
  [SMALL_STATE(11049)] = 518723,
  [SMALL_STATE(11050)] = 518733,
  [SMALL_STATE(11051)] = 518743,
  [SMALL_STATE(11052)] = 518757,
  [SMALL_STATE(11053)] = 518771,
  [SMALL_STATE(11054)] = 518785,
  [SMALL_STATE(11055)] = 518799,
  [SMALL_STATE(11056)] = 518813,
  [SMALL_STATE(11057)] = 518825,
  [SMALL_STATE(11058)] = 518839,
  [SMALL_STATE(11059)] = 518853,
  [SMALL_STATE(11060)] = 518863,
  [SMALL_STATE(11061)] = 518877,
  [SMALL_STATE(11062)] = 518887,
  [SMALL_STATE(11063)] = 518901,
  [SMALL_STATE(11064)] = 518911,
  [SMALL_STATE(11065)] = 518925,
  [SMALL_STATE(11066)] = 518939,
  [SMALL_STATE(11067)] = 518949,
  [SMALL_STATE(11068)] = 518963,
  [SMALL_STATE(11069)] = 518973,
  [SMALL_STATE(11070)] = 518983,
  [SMALL_STATE(11071)] = 518995,
  [SMALL_STATE(11072)] = 519007,
  [SMALL_STATE(11073)] = 519021,
  [SMALL_STATE(11074)] = 519035,
  [SMALL_STATE(11075)] = 519049,
  [SMALL_STATE(11076)] = 519063,
  [SMALL_STATE(11077)] = 519077,
  [SMALL_STATE(11078)] = 519091,
  [SMALL_STATE(11079)] = 519105,
  [SMALL_STATE(11080)] = 519119,
  [SMALL_STATE(11081)] = 519133,
  [SMALL_STATE(11082)] = 519147,
  [SMALL_STATE(11083)] = 519161,
  [SMALL_STATE(11084)] = 519175,
  [SMALL_STATE(11085)] = 519189,
  [SMALL_STATE(11086)] = 519199,
  [SMALL_STATE(11087)] = 519213,
  [SMALL_STATE(11088)] = 519227,
  [SMALL_STATE(11089)] = 519241,
  [SMALL_STATE(11090)] = 519255,
  [SMALL_STATE(11091)] = 519269,
  [SMALL_STATE(11092)] = 519283,
  [SMALL_STATE(11093)] = 519295,
  [SMALL_STATE(11094)] = 519309,
  [SMALL_STATE(11095)] = 519323,
  [SMALL_STATE(11096)] = 519337,
  [SMALL_STATE(11097)] = 519351,
  [SMALL_STATE(11098)] = 519365,
  [SMALL_STATE(11099)] = 519379,
  [SMALL_STATE(11100)] = 519389,
  [SMALL_STATE(11101)] = 519403,
  [SMALL_STATE(11102)] = 519415,
  [SMALL_STATE(11103)] = 519425,
  [SMALL_STATE(11104)] = 519439,
  [SMALL_STATE(11105)] = 519453,
  [SMALL_STATE(11106)] = 519467,
  [SMALL_STATE(11107)] = 519481,
  [SMALL_STATE(11108)] = 519491,
  [SMALL_STATE(11109)] = 519501,
  [SMALL_STATE(11110)] = 519511,
  [SMALL_STATE(11111)] = 519525,
  [SMALL_STATE(11112)] = 519539,
  [SMALL_STATE(11113)] = 519549,
  [SMALL_STATE(11114)] = 519563,
  [SMALL_STATE(11115)] = 519577,
  [SMALL_STATE(11116)] = 519591,
  [SMALL_STATE(11117)] = 519605,
  [SMALL_STATE(11118)] = 519619,
  [SMALL_STATE(11119)] = 519633,
  [SMALL_STATE(11120)] = 519647,
  [SMALL_STATE(11121)] = 519661,
  [SMALL_STATE(11122)] = 519675,
  [SMALL_STATE(11123)] = 519689,
  [SMALL_STATE(11124)] = 519699,
  [SMALL_STATE(11125)] = 519713,
  [SMALL_STATE(11126)] = 519727,
  [SMALL_STATE(11127)] = 519737,
  [SMALL_STATE(11128)] = 519747,
  [SMALL_STATE(11129)] = 519761,
  [SMALL_STATE(11130)] = 519775,
  [SMALL_STATE(11131)] = 519789,
  [SMALL_STATE(11132)] = 519803,
  [SMALL_STATE(11133)] = 519817,
  [SMALL_STATE(11134)] = 519831,
  [SMALL_STATE(11135)] = 519845,
  [SMALL_STATE(11136)] = 519859,
  [SMALL_STATE(11137)] = 519873,
  [SMALL_STATE(11138)] = 519887,
  [SMALL_STATE(11139)] = 519901,
  [SMALL_STATE(11140)] = 519915,
  [SMALL_STATE(11141)] = 519925,
  [SMALL_STATE(11142)] = 519939,
  [SMALL_STATE(11143)] = 519953,
  [SMALL_STATE(11144)] = 519967,
  [SMALL_STATE(11145)] = 519981,
  [SMALL_STATE(11146)] = 519995,
  [SMALL_STATE(11147)] = 520009,
  [SMALL_STATE(11148)] = 520023,
  [SMALL_STATE(11149)] = 520037,
  [SMALL_STATE(11150)] = 520051,
  [SMALL_STATE(11151)] = 520065,
  [SMALL_STATE(11152)] = 520079,
  [SMALL_STATE(11153)] = 520089,
  [SMALL_STATE(11154)] = 520103,
  [SMALL_STATE(11155)] = 520117,
  [SMALL_STATE(11156)] = 520131,
  [SMALL_STATE(11157)] = 520141,
  [SMALL_STATE(11158)] = 520155,
  [SMALL_STATE(11159)] = 520165,
  [SMALL_STATE(11160)] = 520179,
  [SMALL_STATE(11161)] = 520193,
  [SMALL_STATE(11162)] = 520207,
  [SMALL_STATE(11163)] = 520217,
  [SMALL_STATE(11164)] = 520231,
  [SMALL_STATE(11165)] = 520245,
  [SMALL_STATE(11166)] = 520255,
  [SMALL_STATE(11167)] = 520265,
  [SMALL_STATE(11168)] = 520275,
  [SMALL_STATE(11169)] = 520289,
  [SMALL_STATE(11170)] = 520299,
  [SMALL_STATE(11171)] = 520309,
  [SMALL_STATE(11172)] = 520323,
  [SMALL_STATE(11173)] = 520337,
  [SMALL_STATE(11174)] = 520347,
  [SMALL_STATE(11175)] = 520361,
  [SMALL_STATE(11176)] = 520375,
  [SMALL_STATE(11177)] = 520389,
  [SMALL_STATE(11178)] = 520403,
  [SMALL_STATE(11179)] = 520417,
  [SMALL_STATE(11180)] = 520429,
  [SMALL_STATE(11181)] = 520439,
  [SMALL_STATE(11182)] = 520449,
  [SMALL_STATE(11183)] = 520463,
  [SMALL_STATE(11184)] = 520477,
  [SMALL_STATE(11185)] = 520491,
  [SMALL_STATE(11186)] = 520501,
  [SMALL_STATE(11187)] = 520515,
  [SMALL_STATE(11188)] = 520529,
  [SMALL_STATE(11189)] = 520539,
  [SMALL_STATE(11190)] = 520553,
  [SMALL_STATE(11191)] = 520567,
  [SMALL_STATE(11192)] = 520581,
  [SMALL_STATE(11193)] = 520595,
  [SMALL_STATE(11194)] = 520609,
  [SMALL_STATE(11195)] = 520623,
  [SMALL_STATE(11196)] = 520637,
  [SMALL_STATE(11197)] = 520647,
  [SMALL_STATE(11198)] = 520657,
  [SMALL_STATE(11199)] = 520669,
  [SMALL_STATE(11200)] = 520683,
  [SMALL_STATE(11201)] = 520697,
  [SMALL_STATE(11202)] = 520707,
  [SMALL_STATE(11203)] = 520721,
  [SMALL_STATE(11204)] = 520735,
  [SMALL_STATE(11205)] = 520745,
  [SMALL_STATE(11206)] = 520759,
  [SMALL_STATE(11207)] = 520773,
  [SMALL_STATE(11208)] = 520787,
  [SMALL_STATE(11209)] = 520801,
  [SMALL_STATE(11210)] = 520815,
  [SMALL_STATE(11211)] = 520829,
  [SMALL_STATE(11212)] = 520843,
  [SMALL_STATE(11213)] = 520857,
  [SMALL_STATE(11214)] = 520871,
  [SMALL_STATE(11215)] = 520885,
  [SMALL_STATE(11216)] = 520899,
  [SMALL_STATE(11217)] = 520909,
  [SMALL_STATE(11218)] = 520923,
  [SMALL_STATE(11219)] = 520937,
  [SMALL_STATE(11220)] = 520951,
  [SMALL_STATE(11221)] = 520965,
  [SMALL_STATE(11222)] = 520979,
  [SMALL_STATE(11223)] = 520993,
  [SMALL_STATE(11224)] = 521003,
  [SMALL_STATE(11225)] = 521013,
  [SMALL_STATE(11226)] = 521027,
  [SMALL_STATE(11227)] = 521038,
  [SMALL_STATE(11228)] = 521049,
  [SMALL_STATE(11229)] = 521058,
  [SMALL_STATE(11230)] = 521067,
  [SMALL_STATE(11231)] = 521076,
  [SMALL_STATE(11232)] = 521085,
  [SMALL_STATE(11233)] = 521094,
  [SMALL_STATE(11234)] = 521103,
  [SMALL_STATE(11235)] = 521112,
  [SMALL_STATE(11236)] = 521121,
  [SMALL_STATE(11237)] = 521130,
  [SMALL_STATE(11238)] = 521141,
  [SMALL_STATE(11239)] = 521152,
  [SMALL_STATE(11240)] = 521163,
  [SMALL_STATE(11241)] = 521172,
  [SMALL_STATE(11242)] = 521181,
  [SMALL_STATE(11243)] = 521192,
  [SMALL_STATE(11244)] = 521201,
  [SMALL_STATE(11245)] = 521210,
  [SMALL_STATE(11246)] = 521219,
  [SMALL_STATE(11247)] = 521228,
  [SMALL_STATE(11248)] = 521237,
  [SMALL_STATE(11249)] = 521246,
  [SMALL_STATE(11250)] = 521255,
  [SMALL_STATE(11251)] = 521264,
  [SMALL_STATE(11252)] = 521273,
  [SMALL_STATE(11253)] = 521282,
  [SMALL_STATE(11254)] = 521291,
  [SMALL_STATE(11255)] = 521300,
  [SMALL_STATE(11256)] = 521309,
  [SMALL_STATE(11257)] = 521318,
  [SMALL_STATE(11258)] = 521327,
  [SMALL_STATE(11259)] = 521336,
  [SMALL_STATE(11260)] = 521345,
  [SMALL_STATE(11261)] = 521354,
  [SMALL_STATE(11262)] = 521363,
  [SMALL_STATE(11263)] = 521372,
  [SMALL_STATE(11264)] = 521383,
  [SMALL_STATE(11265)] = 521392,
  [SMALL_STATE(11266)] = 521401,
  [SMALL_STATE(11267)] = 521410,
  [SMALL_STATE(11268)] = 521419,
  [SMALL_STATE(11269)] = 521428,
  [SMALL_STATE(11270)] = 521437,
  [SMALL_STATE(11271)] = 521448,
  [SMALL_STATE(11272)] = 521457,
  [SMALL_STATE(11273)] = 521466,
  [SMALL_STATE(11274)] = 521477,
  [SMALL_STATE(11275)] = 521488,
  [SMALL_STATE(11276)] = 521497,
  [SMALL_STATE(11277)] = 521506,
  [SMALL_STATE(11278)] = 521515,
  [SMALL_STATE(11279)] = 521524,
  [SMALL_STATE(11280)] = 521533,
  [SMALL_STATE(11281)] = 521542,
  [SMALL_STATE(11282)] = 521551,
  [SMALL_STATE(11283)] = 521560,
  [SMALL_STATE(11284)] = 521569,
  [SMALL_STATE(11285)] = 521578,
  [SMALL_STATE(11286)] = 521587,
  [SMALL_STATE(11287)] = 521596,
  [SMALL_STATE(11288)] = 521607,
  [SMALL_STATE(11289)] = 521616,
  [SMALL_STATE(11290)] = 521627,
  [SMALL_STATE(11291)] = 521636,
  [SMALL_STATE(11292)] = 521645,
  [SMALL_STATE(11293)] = 521654,
  [SMALL_STATE(11294)] = 521663,
  [SMALL_STATE(11295)] = 521672,
  [SMALL_STATE(11296)] = 521681,
  [SMALL_STATE(11297)] = 521690,
  [SMALL_STATE(11298)] = 521701,
  [SMALL_STATE(11299)] = 521712,
  [SMALL_STATE(11300)] = 521721,
  [SMALL_STATE(11301)] = 521730,
  [SMALL_STATE(11302)] = 521739,
  [SMALL_STATE(11303)] = 521748,
  [SMALL_STATE(11304)] = 521757,
  [SMALL_STATE(11305)] = 521768,
  [SMALL_STATE(11306)] = 521777,
  [SMALL_STATE(11307)] = 521786,
  [SMALL_STATE(11308)] = 521795,
  [SMALL_STATE(11309)] = 521804,
  [SMALL_STATE(11310)] = 521813,
  [SMALL_STATE(11311)] = 521822,
  [SMALL_STATE(11312)] = 521831,
  [SMALL_STATE(11313)] = 521840,
  [SMALL_STATE(11314)] = 521849,
  [SMALL_STATE(11315)] = 521858,
  [SMALL_STATE(11316)] = 521867,
  [SMALL_STATE(11317)] = 521876,
  [SMALL_STATE(11318)] = 521885,
  [SMALL_STATE(11319)] = 521894,
  [SMALL_STATE(11320)] = 521903,
  [SMALL_STATE(11321)] = 521912,
  [SMALL_STATE(11322)] = 521923,
  [SMALL_STATE(11323)] = 521932,
  [SMALL_STATE(11324)] = 521941,
  [SMALL_STATE(11325)] = 521950,
  [SMALL_STATE(11326)] = 521959,
  [SMALL_STATE(11327)] = 521968,
  [SMALL_STATE(11328)] = 521977,
  [SMALL_STATE(11329)] = 521986,
  [SMALL_STATE(11330)] = 521997,
  [SMALL_STATE(11331)] = 522008,
  [SMALL_STATE(11332)] = 522017,
  [SMALL_STATE(11333)] = 522028,
  [SMALL_STATE(11334)] = 522037,
  [SMALL_STATE(11335)] = 522048,
  [SMALL_STATE(11336)] = 522059,
  [SMALL_STATE(11337)] = 522070,
  [SMALL_STATE(11338)] = 522079,
  [SMALL_STATE(11339)] = 522088,
  [SMALL_STATE(11340)] = 522097,
  [SMALL_STATE(11341)] = 522108,
  [SMALL_STATE(11342)] = 522117,
  [SMALL_STATE(11343)] = 522126,
  [SMALL_STATE(11344)] = 522135,
  [SMALL_STATE(11345)] = 522146,
  [SMALL_STATE(11346)] = 522155,
  [SMALL_STATE(11347)] = 522164,
  [SMALL_STATE(11348)] = 522175,
  [SMALL_STATE(11349)] = 522184,
  [SMALL_STATE(11350)] = 522193,
  [SMALL_STATE(11351)] = 522202,
  [SMALL_STATE(11352)] = 522211,
  [SMALL_STATE(11353)] = 522220,
  [SMALL_STATE(11354)] = 522229,
  [SMALL_STATE(11355)] = 522238,
  [SMALL_STATE(11356)] = 522249,
  [SMALL_STATE(11357)] = 522258,
  [SMALL_STATE(11358)] = 522267,
  [SMALL_STATE(11359)] = 522276,
  [SMALL_STATE(11360)] = 522285,
  [SMALL_STATE(11361)] = 522296,
  [SMALL_STATE(11362)] = 522307,
  [SMALL_STATE(11363)] = 522318,
  [SMALL_STATE(11364)] = 522329,
  [SMALL_STATE(11365)] = 522338,
  [SMALL_STATE(11366)] = 522347,
  [SMALL_STATE(11367)] = 522356,
  [SMALL_STATE(11368)] = 522365,
  [SMALL_STATE(11369)] = 522374,
  [SMALL_STATE(11370)] = 522383,
  [SMALL_STATE(11371)] = 522392,
  [SMALL_STATE(11372)] = 522401,
  [SMALL_STATE(11373)] = 522412,
  [SMALL_STATE(11374)] = 522421,
  [SMALL_STATE(11375)] = 522430,
  [SMALL_STATE(11376)] = 522439,
  [SMALL_STATE(11377)] = 522448,
  [SMALL_STATE(11378)] = 522457,
  [SMALL_STATE(11379)] = 522466,
  [SMALL_STATE(11380)] = 522475,
  [SMALL_STATE(11381)] = 522484,
  [SMALL_STATE(11382)] = 522495,
  [SMALL_STATE(11383)] = 522504,
  [SMALL_STATE(11384)] = 522515,
  [SMALL_STATE(11385)] = 522526,
  [SMALL_STATE(11386)] = 522535,
  [SMALL_STATE(11387)] = 522546,
  [SMALL_STATE(11388)] = 522555,
  [SMALL_STATE(11389)] = 522566,
  [SMALL_STATE(11390)] = 522575,
  [SMALL_STATE(11391)] = 522584,
  [SMALL_STATE(11392)] = 522595,
  [SMALL_STATE(11393)] = 522604,
  [SMALL_STATE(11394)] = 522615,
  [SMALL_STATE(11395)] = 522624,
  [SMALL_STATE(11396)] = 522633,
  [SMALL_STATE(11397)] = 522642,
  [SMALL_STATE(11398)] = 522651,
  [SMALL_STATE(11399)] = 522660,
  [SMALL_STATE(11400)] = 522671,
  [SMALL_STATE(11401)] = 522682,
  [SMALL_STATE(11402)] = 522693,
  [SMALL_STATE(11403)] = 522704,
  [SMALL_STATE(11404)] = 522713,
  [SMALL_STATE(11405)] = 522722,
  [SMALL_STATE(11406)] = 522733,
  [SMALL_STATE(11407)] = 522744,
  [SMALL_STATE(11408)] = 522753,
  [SMALL_STATE(11409)] = 522762,
  [SMALL_STATE(11410)] = 522771,
  [SMALL_STATE(11411)] = 522780,
  [SMALL_STATE(11412)] = 522791,
  [SMALL_STATE(11413)] = 522800,
  [SMALL_STATE(11414)] = 522811,
  [SMALL_STATE(11415)] = 522822,
  [SMALL_STATE(11416)] = 522833,
  [SMALL_STATE(11417)] = 522842,
  [SMALL_STATE(11418)] = 522851,
  [SMALL_STATE(11419)] = 522860,
  [SMALL_STATE(11420)] = 522869,
  [SMALL_STATE(11421)] = 522880,
  [SMALL_STATE(11422)] = 522891,
  [SMALL_STATE(11423)] = 522900,
  [SMALL_STATE(11424)] = 522911,
  [SMALL_STATE(11425)] = 522920,
  [SMALL_STATE(11426)] = 522931,
  [SMALL_STATE(11427)] = 522940,
  [SMALL_STATE(11428)] = 522949,
  [SMALL_STATE(11429)] = 522958,
  [SMALL_STATE(11430)] = 522967,
  [SMALL_STATE(11431)] = 522976,
  [SMALL_STATE(11432)] = 522987,
  [SMALL_STATE(11433)] = 522998,
  [SMALL_STATE(11434)] = 523007,
  [SMALL_STATE(11435)] = 523016,
  [SMALL_STATE(11436)] = 523027,
  [SMALL_STATE(11437)] = 523038,
  [SMALL_STATE(11438)] = 523047,
  [SMALL_STATE(11439)] = 523058,
  [SMALL_STATE(11440)] = 523069,
  [SMALL_STATE(11441)] = 523080,
  [SMALL_STATE(11442)] = 523091,
  [SMALL_STATE(11443)] = 523102,
  [SMALL_STATE(11444)] = 523113,
  [SMALL_STATE(11445)] = 523124,
  [SMALL_STATE(11446)] = 523135,
  [SMALL_STATE(11447)] = 523146,
  [SMALL_STATE(11448)] = 523155,
  [SMALL_STATE(11449)] = 523166,
  [SMALL_STATE(11450)] = 523177,
  [SMALL_STATE(11451)] = 523188,
  [SMALL_STATE(11452)] = 523199,
  [SMALL_STATE(11453)] = 523210,
  [SMALL_STATE(11454)] = 523221,
  [SMALL_STATE(11455)] = 523232,
  [SMALL_STATE(11456)] = 523243,
  [SMALL_STATE(11457)] = 523252,
  [SMALL_STATE(11458)] = 523261,
  [SMALL_STATE(11459)] = 523272,
  [SMALL_STATE(11460)] = 523283,
  [SMALL_STATE(11461)] = 523292,
  [SMALL_STATE(11462)] = 523303,
  [SMALL_STATE(11463)] = 523314,
  [SMALL_STATE(11464)] = 523323,
  [SMALL_STATE(11465)] = 523332,
  [SMALL_STATE(11466)] = 523343,
  [SMALL_STATE(11467)] = 523354,
  [SMALL_STATE(11468)] = 523363,
  [SMALL_STATE(11469)] = 523374,
  [SMALL_STATE(11470)] = 523385,
  [SMALL_STATE(11471)] = 523394,
  [SMALL_STATE(11472)] = 523403,
  [SMALL_STATE(11473)] = 523412,
  [SMALL_STATE(11474)] = 523423,
  [SMALL_STATE(11475)] = 523434,
  [SMALL_STATE(11476)] = 523445,
  [SMALL_STATE(11477)] = 523454,
  [SMALL_STATE(11478)] = 523463,
  [SMALL_STATE(11479)] = 523474,
  [SMALL_STATE(11480)] = 523483,
  [SMALL_STATE(11481)] = 523494,
  [SMALL_STATE(11482)] = 523505,
  [SMALL_STATE(11483)] = 523516,
  [SMALL_STATE(11484)] = 523527,
  [SMALL_STATE(11485)] = 523538,
  [SMALL_STATE(11486)] = 523549,
  [SMALL_STATE(11487)] = 523560,
  [SMALL_STATE(11488)] = 523571,
  [SMALL_STATE(11489)] = 523580,
  [SMALL_STATE(11490)] = 523589,
  [SMALL_STATE(11491)] = 523598,
  [SMALL_STATE(11492)] = 523607,
  [SMALL_STATE(11493)] = 523616,
  [SMALL_STATE(11494)] = 523625,
  [SMALL_STATE(11495)] = 523634,
  [SMALL_STATE(11496)] = 523643,
  [SMALL_STATE(11497)] = 523652,
  [SMALL_STATE(11498)] = 523663,
  [SMALL_STATE(11499)] = 523672,
  [SMALL_STATE(11500)] = 523681,
  [SMALL_STATE(11501)] = 523692,
  [SMALL_STATE(11502)] = 523701,
  [SMALL_STATE(11503)] = 523712,
  [SMALL_STATE(11504)] = 523721,
  [SMALL_STATE(11505)] = 523730,
  [SMALL_STATE(11506)] = 523741,
  [SMALL_STATE(11507)] = 523750,
  [SMALL_STATE(11508)] = 523759,
  [SMALL_STATE(11509)] = 523768,
  [SMALL_STATE(11510)] = 523777,
  [SMALL_STATE(11511)] = 523788,
  [SMALL_STATE(11512)] = 523797,
  [SMALL_STATE(11513)] = 523808,
  [SMALL_STATE(11514)] = 523817,
  [SMALL_STATE(11515)] = 523826,
  [SMALL_STATE(11516)] = 523837,
  [SMALL_STATE(11517)] = 523846,
  [SMALL_STATE(11518)] = 523855,
  [SMALL_STATE(11519)] = 523864,
  [SMALL_STATE(11520)] = 523875,
  [SMALL_STATE(11521)] = 523886,
  [SMALL_STATE(11522)] = 523897,
  [SMALL_STATE(11523)] = 523906,
  [SMALL_STATE(11524)] = 523917,
  [SMALL_STATE(11525)] = 523928,
  [SMALL_STATE(11526)] = 523939,
  [SMALL_STATE(11527)] = 523950,
  [SMALL_STATE(11528)] = 523961,
  [SMALL_STATE(11529)] = 523972,
  [SMALL_STATE(11530)] = 523983,
  [SMALL_STATE(11531)] = 523994,
  [SMALL_STATE(11532)] = 524005,
  [SMALL_STATE(11533)] = 524016,
  [SMALL_STATE(11534)] = 524025,
  [SMALL_STATE(11535)] = 524034,
  [SMALL_STATE(11536)] = 524045,
  [SMALL_STATE(11537)] = 524056,
  [SMALL_STATE(11538)] = 524067,
  [SMALL_STATE(11539)] = 524078,
  [SMALL_STATE(11540)] = 524087,
  [SMALL_STATE(11541)] = 524098,
  [SMALL_STATE(11542)] = 524109,
  [SMALL_STATE(11543)] = 524120,
  [SMALL_STATE(11544)] = 524129,
  [SMALL_STATE(11545)] = 524140,
  [SMALL_STATE(11546)] = 524149,
  [SMALL_STATE(11547)] = 524160,
  [SMALL_STATE(11548)] = 524169,
  [SMALL_STATE(11549)] = 524180,
  [SMALL_STATE(11550)] = 524189,
  [SMALL_STATE(11551)] = 524200,
  [SMALL_STATE(11552)] = 524211,
  [SMALL_STATE(11553)] = 524222,
  [SMALL_STATE(11554)] = 524231,
  [SMALL_STATE(11555)] = 524242,
  [SMALL_STATE(11556)] = 524253,
  [SMALL_STATE(11557)] = 524264,
  [SMALL_STATE(11558)] = 524275,
  [SMALL_STATE(11559)] = 524284,
  [SMALL_STATE(11560)] = 524293,
  [SMALL_STATE(11561)] = 524304,
  [SMALL_STATE(11562)] = 524315,
  [SMALL_STATE(11563)] = 524324,
  [SMALL_STATE(11564)] = 524333,
  [SMALL_STATE(11565)] = 524344,
  [SMALL_STATE(11566)] = 524353,
  [SMALL_STATE(11567)] = 524362,
  [SMALL_STATE(11568)] = 524371,
  [SMALL_STATE(11569)] = 524380,
  [SMALL_STATE(11570)] = 524389,
  [SMALL_STATE(11571)] = 524398,
  [SMALL_STATE(11572)] = 524409,
  [SMALL_STATE(11573)] = 524420,
  [SMALL_STATE(11574)] = 524429,
  [SMALL_STATE(11575)] = 524440,
  [SMALL_STATE(11576)] = 524451,
  [SMALL_STATE(11577)] = 524462,
  [SMALL_STATE(11578)] = 524473,
  [SMALL_STATE(11579)] = 524484,
  [SMALL_STATE(11580)] = 524493,
  [SMALL_STATE(11581)] = 524504,
  [SMALL_STATE(11582)] = 524515,
  [SMALL_STATE(11583)] = 524526,
  [SMALL_STATE(11584)] = 524535,
  [SMALL_STATE(11585)] = 524546,
  [SMALL_STATE(11586)] = 524555,
  [SMALL_STATE(11587)] = 524566,
  [SMALL_STATE(11588)] = 524575,
  [SMALL_STATE(11589)] = 524586,
  [SMALL_STATE(11590)] = 524597,
  [SMALL_STATE(11591)] = 524608,
  [SMALL_STATE(11592)] = 524619,
  [SMALL_STATE(11593)] = 524630,
  [SMALL_STATE(11594)] = 524641,
  [SMALL_STATE(11595)] = 524652,
  [SMALL_STATE(11596)] = 524663,
  [SMALL_STATE(11597)] = 524674,
  [SMALL_STATE(11598)] = 524685,
  [SMALL_STATE(11599)] = 524696,
  [SMALL_STATE(11600)] = 524705,
  [SMALL_STATE(11601)] = 524716,
  [SMALL_STATE(11602)] = 524727,
  [SMALL_STATE(11603)] = 524738,
  [SMALL_STATE(11604)] = 524749,
  [SMALL_STATE(11605)] = 524760,
  [SMALL_STATE(11606)] = 524771,
  [SMALL_STATE(11607)] = 524780,
  [SMALL_STATE(11608)] = 524789,
  [SMALL_STATE(11609)] = 524798,
  [SMALL_STATE(11610)] = 524807,
  [SMALL_STATE(11611)] = 524818,
  [SMALL_STATE(11612)] = 524829,
  [SMALL_STATE(11613)] = 524840,
  [SMALL_STATE(11614)] = 524849,
  [SMALL_STATE(11615)] = 524860,
  [SMALL_STATE(11616)] = 524869,
  [SMALL_STATE(11617)] = 524878,
  [SMALL_STATE(11618)] = 524887,
  [SMALL_STATE(11619)] = 524896,
  [SMALL_STATE(11620)] = 524905,
  [SMALL_STATE(11621)] = 524914,
  [SMALL_STATE(11622)] = 524923,
  [SMALL_STATE(11623)] = 524934,
  [SMALL_STATE(11624)] = 524945,
  [SMALL_STATE(11625)] = 524956,
  [SMALL_STATE(11626)] = 524967,
  [SMALL_STATE(11627)] = 524978,
  [SMALL_STATE(11628)] = 524989,
  [SMALL_STATE(11629)] = 525000,
  [SMALL_STATE(11630)] = 525011,
  [SMALL_STATE(11631)] = 525022,
  [SMALL_STATE(11632)] = 525033,
  [SMALL_STATE(11633)] = 525044,
  [SMALL_STATE(11634)] = 525053,
  [SMALL_STATE(11635)] = 525064,
  [SMALL_STATE(11636)] = 525075,
  [SMALL_STATE(11637)] = 525086,
  [SMALL_STATE(11638)] = 525097,
  [SMALL_STATE(11639)] = 525108,
  [SMALL_STATE(11640)] = 525119,
  [SMALL_STATE(11641)] = 525130,
  [SMALL_STATE(11642)] = 525141,
  [SMALL_STATE(11643)] = 525152,
  [SMALL_STATE(11644)] = 525163,
  [SMALL_STATE(11645)] = 525174,
  [SMALL_STATE(11646)] = 525185,
  [SMALL_STATE(11647)] = 525196,
  [SMALL_STATE(11648)] = 525207,
  [SMALL_STATE(11649)] = 525218,
  [SMALL_STATE(11650)] = 525229,
  [SMALL_STATE(11651)] = 525240,
  [SMALL_STATE(11652)] = 525251,
  [SMALL_STATE(11653)] = 525262,
  [SMALL_STATE(11654)] = 525273,
  [SMALL_STATE(11655)] = 525282,
  [SMALL_STATE(11656)] = 525291,
  [SMALL_STATE(11657)] = 525300,
  [SMALL_STATE(11658)] = 525311,
  [SMALL_STATE(11659)] = 525322,
  [SMALL_STATE(11660)] = 525333,
  [SMALL_STATE(11661)] = 525344,
  [SMALL_STATE(11662)] = 525355,
  [SMALL_STATE(11663)] = 525366,
  [SMALL_STATE(11664)] = 525375,
  [SMALL_STATE(11665)] = 525384,
  [SMALL_STATE(11666)] = 525393,
  [SMALL_STATE(11667)] = 525404,
  [SMALL_STATE(11668)] = 525415,
  [SMALL_STATE(11669)] = 525426,
  [SMALL_STATE(11670)] = 525437,
  [SMALL_STATE(11671)] = 525448,
  [SMALL_STATE(11672)] = 525459,
  [SMALL_STATE(11673)] = 525470,
  [SMALL_STATE(11674)] = 525481,
  [SMALL_STATE(11675)] = 525492,
  [SMALL_STATE(11676)] = 525503,
  [SMALL_STATE(11677)] = 525514,
  [SMALL_STATE(11678)] = 525523,
  [SMALL_STATE(11679)] = 525534,
  [SMALL_STATE(11680)] = 525545,
  [SMALL_STATE(11681)] = 525556,
  [SMALL_STATE(11682)] = 525567,
  [SMALL_STATE(11683)] = 525578,
  [SMALL_STATE(11684)] = 525589,
  [SMALL_STATE(11685)] = 525598,
  [SMALL_STATE(11686)] = 525609,
  [SMALL_STATE(11687)] = 525620,
  [SMALL_STATE(11688)] = 525631,
  [SMALL_STATE(11689)] = 525642,
  [SMALL_STATE(11690)] = 525653,
  [SMALL_STATE(11691)] = 525664,
  [SMALL_STATE(11692)] = 525675,
  [SMALL_STATE(11693)] = 525686,
  [SMALL_STATE(11694)] = 525697,
  [SMALL_STATE(11695)] = 525708,
  [SMALL_STATE(11696)] = 525719,
  [SMALL_STATE(11697)] = 525730,
  [SMALL_STATE(11698)] = 525741,
  [SMALL_STATE(11699)] = 525752,
  [SMALL_STATE(11700)] = 525763,
  [SMALL_STATE(11701)] = 525774,
  [SMALL_STATE(11702)] = 525785,
  [SMALL_STATE(11703)] = 525796,
  [SMALL_STATE(11704)] = 525807,
  [SMALL_STATE(11705)] = 525818,
  [SMALL_STATE(11706)] = 525829,
  [SMALL_STATE(11707)] = 525840,
  [SMALL_STATE(11708)] = 525851,
  [SMALL_STATE(11709)] = 525860,
  [SMALL_STATE(11710)] = 525869,
  [SMALL_STATE(11711)] = 525880,
  [SMALL_STATE(11712)] = 525891,
  [SMALL_STATE(11713)] = 525902,
  [SMALL_STATE(11714)] = 525911,
  [SMALL_STATE(11715)] = 525922,
  [SMALL_STATE(11716)] = 525933,
  [SMALL_STATE(11717)] = 525944,
  [SMALL_STATE(11718)] = 525955,
  [SMALL_STATE(11719)] = 525966,
  [SMALL_STATE(11720)] = 525977,
  [SMALL_STATE(11721)] = 525988,
  [SMALL_STATE(11722)] = 525999,
  [SMALL_STATE(11723)] = 526010,
  [SMALL_STATE(11724)] = 526021,
  [SMALL_STATE(11725)] = 526032,
  [SMALL_STATE(11726)] = 526043,
  [SMALL_STATE(11727)] = 526054,
  [SMALL_STATE(11728)] = 526065,
  [SMALL_STATE(11729)] = 526076,
  [SMALL_STATE(11730)] = 526087,
  [SMALL_STATE(11731)] = 526098,
  [SMALL_STATE(11732)] = 526109,
  [SMALL_STATE(11733)] = 526120,
  [SMALL_STATE(11734)] = 526131,
  [SMALL_STATE(11735)] = 526142,
  [SMALL_STATE(11736)] = 526153,
  [SMALL_STATE(11737)] = 526164,
  [SMALL_STATE(11738)] = 526175,
  [SMALL_STATE(11739)] = 526186,
  [SMALL_STATE(11740)] = 526197,
  [SMALL_STATE(11741)] = 526208,
  [SMALL_STATE(11742)] = 526219,
  [SMALL_STATE(11743)] = 526230,
  [SMALL_STATE(11744)] = 526241,
  [SMALL_STATE(11745)] = 526252,
  [SMALL_STATE(11746)] = 526263,
  [SMALL_STATE(11747)] = 526274,
  [SMALL_STATE(11748)] = 526285,
  [SMALL_STATE(11749)] = 526296,
  [SMALL_STATE(11750)] = 526307,
  [SMALL_STATE(11751)] = 526318,
  [SMALL_STATE(11752)] = 526329,
  [SMALL_STATE(11753)] = 526340,
  [SMALL_STATE(11754)] = 526351,
  [SMALL_STATE(11755)] = 526362,
  [SMALL_STATE(11756)] = 526373,
  [SMALL_STATE(11757)] = 526384,
  [SMALL_STATE(11758)] = 526393,
  [SMALL_STATE(11759)] = 526404,
  [SMALL_STATE(11760)] = 526415,
  [SMALL_STATE(11761)] = 526426,
  [SMALL_STATE(11762)] = 526437,
  [SMALL_STATE(11763)] = 526448,
  [SMALL_STATE(11764)] = 526459,
  [SMALL_STATE(11765)] = 526470,
  [SMALL_STATE(11766)] = 526481,
  [SMALL_STATE(11767)] = 526492,
  [SMALL_STATE(11768)] = 526501,
  [SMALL_STATE(11769)] = 526512,
  [SMALL_STATE(11770)] = 526523,
  [SMALL_STATE(11771)] = 526532,
  [SMALL_STATE(11772)] = 526543,
  [SMALL_STATE(11773)] = 526554,
  [SMALL_STATE(11774)] = 526563,
  [SMALL_STATE(11775)] = 526574,
  [SMALL_STATE(11776)] = 526585,
  [SMALL_STATE(11777)] = 526596,
  [SMALL_STATE(11778)] = 526607,
  [SMALL_STATE(11779)] = 526618,
  [SMALL_STATE(11780)] = 526629,
  [SMALL_STATE(11781)] = 526640,
  [SMALL_STATE(11782)] = 526651,
  [SMALL_STATE(11783)] = 526662,
  [SMALL_STATE(11784)] = 526673,
  [SMALL_STATE(11785)] = 526684,
  [SMALL_STATE(11786)] = 526695,
  [SMALL_STATE(11787)] = 526706,
  [SMALL_STATE(11788)] = 526717,
  [SMALL_STATE(11789)] = 526728,
  [SMALL_STATE(11790)] = 526739,
  [SMALL_STATE(11791)] = 526750,
  [SMALL_STATE(11792)] = 526761,
  [SMALL_STATE(11793)] = 526772,
  [SMALL_STATE(11794)] = 526783,
  [SMALL_STATE(11795)] = 526794,
  [SMALL_STATE(11796)] = 526805,
  [SMALL_STATE(11797)] = 526814,
  [SMALL_STATE(11798)] = 526825,
  [SMALL_STATE(11799)] = 526836,
  [SMALL_STATE(11800)] = 526847,
  [SMALL_STATE(11801)] = 526858,
  [SMALL_STATE(11802)] = 526869,
  [SMALL_STATE(11803)] = 526880,
  [SMALL_STATE(11804)] = 526891,
  [SMALL_STATE(11805)] = 526902,
  [SMALL_STATE(11806)] = 526913,
  [SMALL_STATE(11807)] = 526924,
  [SMALL_STATE(11808)] = 526935,
  [SMALL_STATE(11809)] = 526946,
  [SMALL_STATE(11810)] = 526957,
  [SMALL_STATE(11811)] = 526968,
  [SMALL_STATE(11812)] = 526979,
  [SMALL_STATE(11813)] = 526988,
  [SMALL_STATE(11814)] = 526999,
  [SMALL_STATE(11815)] = 527010,
  [SMALL_STATE(11816)] = 527021,
  [SMALL_STATE(11817)] = 527032,
  [SMALL_STATE(11818)] = 527043,
  [SMALL_STATE(11819)] = 527054,
  [SMALL_STATE(11820)] = 527065,
  [SMALL_STATE(11821)] = 527076,
  [SMALL_STATE(11822)] = 527087,
  [SMALL_STATE(11823)] = 527098,
  [SMALL_STATE(11824)] = 527109,
  [SMALL_STATE(11825)] = 527118,
  [SMALL_STATE(11826)] = 527129,
  [SMALL_STATE(11827)] = 527140,
  [SMALL_STATE(11828)] = 527151,
  [SMALL_STATE(11829)] = 527162,
  [SMALL_STATE(11830)] = 527173,
  [SMALL_STATE(11831)] = 527184,
  [SMALL_STATE(11832)] = 527195,
  [SMALL_STATE(11833)] = 527206,
  [SMALL_STATE(11834)] = 527217,
  [SMALL_STATE(11835)] = 527226,
  [SMALL_STATE(11836)] = 527237,
  [SMALL_STATE(11837)] = 527248,
  [SMALL_STATE(11838)] = 527259,
  [SMALL_STATE(11839)] = 527268,
  [SMALL_STATE(11840)] = 527277,
  [SMALL_STATE(11841)] = 527286,
  [SMALL_STATE(11842)] = 527295,
  [SMALL_STATE(11843)] = 527304,
  [SMALL_STATE(11844)] = 527315,
  [SMALL_STATE(11845)] = 527326,
  [SMALL_STATE(11846)] = 527337,
  [SMALL_STATE(11847)] = 527348,
  [SMALL_STATE(11848)] = 527359,
  [SMALL_STATE(11849)] = 527368,
  [SMALL_STATE(11850)] = 527379,
  [SMALL_STATE(11851)] = 527390,
  [SMALL_STATE(11852)] = 527401,
  [SMALL_STATE(11853)] = 527412,
  [SMALL_STATE(11854)] = 527423,
  [SMALL_STATE(11855)] = 527434,
  [SMALL_STATE(11856)] = 527445,
  [SMALL_STATE(11857)] = 527456,
  [SMALL_STATE(11858)] = 527467,
  [SMALL_STATE(11859)] = 527478,
  [SMALL_STATE(11860)] = 527489,
  [SMALL_STATE(11861)] = 527500,
  [SMALL_STATE(11862)] = 527511,
  [SMALL_STATE(11863)] = 527520,
  [SMALL_STATE(11864)] = 527531,
  [SMALL_STATE(11865)] = 527542,
  [SMALL_STATE(11866)] = 527553,
  [SMALL_STATE(11867)] = 527564,
  [SMALL_STATE(11868)] = 527575,
  [SMALL_STATE(11869)] = 527586,
  [SMALL_STATE(11870)] = 527597,
  [SMALL_STATE(11871)] = 527608,
  [SMALL_STATE(11872)] = 527617,
  [SMALL_STATE(11873)] = 527628,
  [SMALL_STATE(11874)] = 527637,
  [SMALL_STATE(11875)] = 527648,
  [SMALL_STATE(11876)] = 527659,
  [SMALL_STATE(11877)] = 527670,
  [SMALL_STATE(11878)] = 527681,
  [SMALL_STATE(11879)] = 527692,
  [SMALL_STATE(11880)] = 527703,
  [SMALL_STATE(11881)] = 527714,
  [SMALL_STATE(11882)] = 527725,
  [SMALL_STATE(11883)] = 527736,
  [SMALL_STATE(11884)] = 527747,
  [SMALL_STATE(11885)] = 527758,
  [SMALL_STATE(11886)] = 527769,
  [SMALL_STATE(11887)] = 527780,
  [SMALL_STATE(11888)] = 527791,
  [SMALL_STATE(11889)] = 527802,
  [SMALL_STATE(11890)] = 527813,
  [SMALL_STATE(11891)] = 527824,
  [SMALL_STATE(11892)] = 527835,
  [SMALL_STATE(11893)] = 527846,
  [SMALL_STATE(11894)] = 527857,
  [SMALL_STATE(11895)] = 527868,
  [SMALL_STATE(11896)] = 527879,
  [SMALL_STATE(11897)] = 527890,
  [SMALL_STATE(11898)] = 527901,
  [SMALL_STATE(11899)] = 527912,
  [SMALL_STATE(11900)] = 527923,
  [SMALL_STATE(11901)] = 527934,
  [SMALL_STATE(11902)] = 527945,
  [SMALL_STATE(11903)] = 527956,
  [SMALL_STATE(11904)] = 527967,
  [SMALL_STATE(11905)] = 527978,
  [SMALL_STATE(11906)] = 527989,
  [SMALL_STATE(11907)] = 527998,
  [SMALL_STATE(11908)] = 528009,
  [SMALL_STATE(11909)] = 528020,
  [SMALL_STATE(11910)] = 528031,
  [SMALL_STATE(11911)] = 528042,
  [SMALL_STATE(11912)] = 528051,
  [SMALL_STATE(11913)] = 528062,
  [SMALL_STATE(11914)] = 528073,
  [SMALL_STATE(11915)] = 528084,
  [SMALL_STATE(11916)] = 528095,
  [SMALL_STATE(11917)] = 528106,
  [SMALL_STATE(11918)] = 528117,
  [SMALL_STATE(11919)] = 528128,
  [SMALL_STATE(11920)] = 528137,
  [SMALL_STATE(11921)] = 528148,
  [SMALL_STATE(11922)] = 528159,
  [SMALL_STATE(11923)] = 528168,
  [SMALL_STATE(11924)] = 528179,
  [SMALL_STATE(11925)] = 528190,
  [SMALL_STATE(11926)] = 528199,
  [SMALL_STATE(11927)] = 528210,
  [SMALL_STATE(11928)] = 528221,
  [SMALL_STATE(11929)] = 528232,
  [SMALL_STATE(11930)] = 528243,
  [SMALL_STATE(11931)] = 528254,
  [SMALL_STATE(11932)] = 528265,
  [SMALL_STATE(11933)] = 528276,
  [SMALL_STATE(11934)] = 528287,
  [SMALL_STATE(11935)] = 528298,
  [SMALL_STATE(11936)] = 528309,
  [SMALL_STATE(11937)] = 528320,
  [SMALL_STATE(11938)] = 528331,
  [SMALL_STATE(11939)] = 528342,
  [SMALL_STATE(11940)] = 528353,
  [SMALL_STATE(11941)] = 528364,
  [SMALL_STATE(11942)] = 528375,
  [SMALL_STATE(11943)] = 528386,
  [SMALL_STATE(11944)] = 528397,
  [SMALL_STATE(11945)] = 528408,
  [SMALL_STATE(11946)] = 528419,
  [SMALL_STATE(11947)] = 528430,
  [SMALL_STATE(11948)] = 528441,
  [SMALL_STATE(11949)] = 528452,
  [SMALL_STATE(11950)] = 528463,
  [SMALL_STATE(11951)] = 528474,
  [SMALL_STATE(11952)] = 528485,
  [SMALL_STATE(11953)] = 528496,
  [SMALL_STATE(11954)] = 528507,
  [SMALL_STATE(11955)] = 528518,
  [SMALL_STATE(11956)] = 528529,
  [SMALL_STATE(11957)] = 528540,
  [SMALL_STATE(11958)] = 528551,
  [SMALL_STATE(11959)] = 528562,
  [SMALL_STATE(11960)] = 528573,
  [SMALL_STATE(11961)] = 528584,
  [SMALL_STATE(11962)] = 528595,
  [SMALL_STATE(11963)] = 528604,
  [SMALL_STATE(11964)] = 528615,
  [SMALL_STATE(11965)] = 528626,
  [SMALL_STATE(11966)] = 528637,
  [SMALL_STATE(11967)] = 528648,
  [SMALL_STATE(11968)] = 528659,
  [SMALL_STATE(11969)] = 528670,
  [SMALL_STATE(11970)] = 528681,
  [SMALL_STATE(11971)] = 528692,
  [SMALL_STATE(11972)] = 528703,
  [SMALL_STATE(11973)] = 528714,
  [SMALL_STATE(11974)] = 528725,
  [SMALL_STATE(11975)] = 528736,
  [SMALL_STATE(11976)] = 528747,
  [SMALL_STATE(11977)] = 528758,
  [SMALL_STATE(11978)] = 528769,
  [SMALL_STATE(11979)] = 528780,
  [SMALL_STATE(11980)] = 528791,
  [SMALL_STATE(11981)] = 528802,
  [SMALL_STATE(11982)] = 528813,
  [SMALL_STATE(11983)] = 528824,
  [SMALL_STATE(11984)] = 528835,
  [SMALL_STATE(11985)] = 528846,
  [SMALL_STATE(11986)] = 528857,
  [SMALL_STATE(11987)] = 528868,
  [SMALL_STATE(11988)] = 528879,
  [SMALL_STATE(11989)] = 528890,
  [SMALL_STATE(11990)] = 528901,
  [SMALL_STATE(11991)] = 528912,
  [SMALL_STATE(11992)] = 528923,
  [SMALL_STATE(11993)] = 528934,
  [SMALL_STATE(11994)] = 528945,
  [SMALL_STATE(11995)] = 528954,
  [SMALL_STATE(11996)] = 528963,
  [SMALL_STATE(11997)] = 528974,
  [SMALL_STATE(11998)] = 528985,
  [SMALL_STATE(11999)] = 528996,
  [SMALL_STATE(12000)] = 529007,
  [SMALL_STATE(12001)] = 529018,
  [SMALL_STATE(12002)] = 529029,
  [SMALL_STATE(12003)] = 529040,
  [SMALL_STATE(12004)] = 529051,
  [SMALL_STATE(12005)] = 529062,
  [SMALL_STATE(12006)] = 529073,
  [SMALL_STATE(12007)] = 529082,
  [SMALL_STATE(12008)] = 529093,
  [SMALL_STATE(12009)] = 529102,
  [SMALL_STATE(12010)] = 529113,
  [SMALL_STATE(12011)] = 529124,
  [SMALL_STATE(12012)] = 529133,
  [SMALL_STATE(12013)] = 529144,
  [SMALL_STATE(12014)] = 529155,
  [SMALL_STATE(12015)] = 529166,
  [SMALL_STATE(12016)] = 529177,
  [SMALL_STATE(12017)] = 529188,
  [SMALL_STATE(12018)] = 529199,
  [SMALL_STATE(12019)] = 529207,
  [SMALL_STATE(12020)] = 529215,
  [SMALL_STATE(12021)] = 529223,
  [SMALL_STATE(12022)] = 529231,
  [SMALL_STATE(12023)] = 529239,
  [SMALL_STATE(12024)] = 529247,
  [SMALL_STATE(12025)] = 529255,
  [SMALL_STATE(12026)] = 529263,
  [SMALL_STATE(12027)] = 529271,
  [SMALL_STATE(12028)] = 529279,
  [SMALL_STATE(12029)] = 529287,
  [SMALL_STATE(12030)] = 529295,
  [SMALL_STATE(12031)] = 529303,
  [SMALL_STATE(12032)] = 529311,
  [SMALL_STATE(12033)] = 529319,
  [SMALL_STATE(12034)] = 529327,
  [SMALL_STATE(12035)] = 529335,
  [SMALL_STATE(12036)] = 529343,
  [SMALL_STATE(12037)] = 529351,
  [SMALL_STATE(12038)] = 529359,
  [SMALL_STATE(12039)] = 529367,
  [SMALL_STATE(12040)] = 529375,
  [SMALL_STATE(12041)] = 529383,
  [SMALL_STATE(12042)] = 529391,
  [SMALL_STATE(12043)] = 529399,
  [SMALL_STATE(12044)] = 529407,
  [SMALL_STATE(12045)] = 529415,
  [SMALL_STATE(12046)] = 529423,
  [SMALL_STATE(12047)] = 529431,
  [SMALL_STATE(12048)] = 529439,
  [SMALL_STATE(12049)] = 529447,
  [SMALL_STATE(12050)] = 529455,
  [SMALL_STATE(12051)] = 529463,
  [SMALL_STATE(12052)] = 529471,
  [SMALL_STATE(12053)] = 529479,
  [SMALL_STATE(12054)] = 529487,
  [SMALL_STATE(12055)] = 529495,
  [SMALL_STATE(12056)] = 529503,
  [SMALL_STATE(12057)] = 529511,
  [SMALL_STATE(12058)] = 529519,
  [SMALL_STATE(12059)] = 529527,
  [SMALL_STATE(12060)] = 529535,
  [SMALL_STATE(12061)] = 529543,
  [SMALL_STATE(12062)] = 529551,
  [SMALL_STATE(12063)] = 529559,
  [SMALL_STATE(12064)] = 529567,
  [SMALL_STATE(12065)] = 529575,
  [SMALL_STATE(12066)] = 529583,
  [SMALL_STATE(12067)] = 529591,
  [SMALL_STATE(12068)] = 529599,
  [SMALL_STATE(12069)] = 529607,
  [SMALL_STATE(12070)] = 529615,
  [SMALL_STATE(12071)] = 529623,
  [SMALL_STATE(12072)] = 529631,
  [SMALL_STATE(12073)] = 529639,
  [SMALL_STATE(12074)] = 529647,
  [SMALL_STATE(12075)] = 529655,
  [SMALL_STATE(12076)] = 529663,
  [SMALL_STATE(12077)] = 529671,
  [SMALL_STATE(12078)] = 529679,
  [SMALL_STATE(12079)] = 529687,
  [SMALL_STATE(12080)] = 529695,
  [SMALL_STATE(12081)] = 529703,
  [SMALL_STATE(12082)] = 529711,
  [SMALL_STATE(12083)] = 529719,
  [SMALL_STATE(12084)] = 529727,
  [SMALL_STATE(12085)] = 529735,
  [SMALL_STATE(12086)] = 529743,
  [SMALL_STATE(12087)] = 529751,
  [SMALL_STATE(12088)] = 529759,
  [SMALL_STATE(12089)] = 529767,
  [SMALL_STATE(12090)] = 529775,
  [SMALL_STATE(12091)] = 529783,
  [SMALL_STATE(12092)] = 529791,
  [SMALL_STATE(12093)] = 529799,
  [SMALL_STATE(12094)] = 529807,
  [SMALL_STATE(12095)] = 529815,
  [SMALL_STATE(12096)] = 529823,
  [SMALL_STATE(12097)] = 529831,
  [SMALL_STATE(12098)] = 529839,
  [SMALL_STATE(12099)] = 529847,
  [SMALL_STATE(12100)] = 529855,
  [SMALL_STATE(12101)] = 529863,
  [SMALL_STATE(12102)] = 529871,
  [SMALL_STATE(12103)] = 529879,
  [SMALL_STATE(12104)] = 529887,
  [SMALL_STATE(12105)] = 529895,
  [SMALL_STATE(12106)] = 529903,
  [SMALL_STATE(12107)] = 529911,
  [SMALL_STATE(12108)] = 529919,
  [SMALL_STATE(12109)] = 529927,
  [SMALL_STATE(12110)] = 529935,
  [SMALL_STATE(12111)] = 529943,
  [SMALL_STATE(12112)] = 529951,
  [SMALL_STATE(12113)] = 529959,
  [SMALL_STATE(12114)] = 529967,
  [SMALL_STATE(12115)] = 529975,
  [SMALL_STATE(12116)] = 529983,
  [SMALL_STATE(12117)] = 529991,
  [SMALL_STATE(12118)] = 529999,
  [SMALL_STATE(12119)] = 530007,
  [SMALL_STATE(12120)] = 530015,
  [SMALL_STATE(12121)] = 530023,
  [SMALL_STATE(12122)] = 530031,
  [SMALL_STATE(12123)] = 530039,
  [SMALL_STATE(12124)] = 530047,
  [SMALL_STATE(12125)] = 530055,
  [SMALL_STATE(12126)] = 530063,
  [SMALL_STATE(12127)] = 530071,
  [SMALL_STATE(12128)] = 530079,
  [SMALL_STATE(12129)] = 530087,
  [SMALL_STATE(12130)] = 530095,
  [SMALL_STATE(12131)] = 530103,
  [SMALL_STATE(12132)] = 530111,
  [SMALL_STATE(12133)] = 530119,
  [SMALL_STATE(12134)] = 530127,
  [SMALL_STATE(12135)] = 530135,
  [SMALL_STATE(12136)] = 530143,
  [SMALL_STATE(12137)] = 530151,
  [SMALL_STATE(12138)] = 530159,
  [SMALL_STATE(12139)] = 530167,
  [SMALL_STATE(12140)] = 530175,
  [SMALL_STATE(12141)] = 530183,
  [SMALL_STATE(12142)] = 530191,
  [SMALL_STATE(12143)] = 530199,
  [SMALL_STATE(12144)] = 530207,
  [SMALL_STATE(12145)] = 530215,
  [SMALL_STATE(12146)] = 530223,
  [SMALL_STATE(12147)] = 530231,
  [SMALL_STATE(12148)] = 530239,
  [SMALL_STATE(12149)] = 530247,
  [SMALL_STATE(12150)] = 530255,
  [SMALL_STATE(12151)] = 530263,
  [SMALL_STATE(12152)] = 530271,
  [SMALL_STATE(12153)] = 530279,
  [SMALL_STATE(12154)] = 530287,
  [SMALL_STATE(12155)] = 530295,
  [SMALL_STATE(12156)] = 530303,
  [SMALL_STATE(12157)] = 530311,
  [SMALL_STATE(12158)] = 530319,
  [SMALL_STATE(12159)] = 530327,
  [SMALL_STATE(12160)] = 530335,
  [SMALL_STATE(12161)] = 530343,
  [SMALL_STATE(12162)] = 530351,
  [SMALL_STATE(12163)] = 530359,
  [SMALL_STATE(12164)] = 530367,
  [SMALL_STATE(12165)] = 530375,
  [SMALL_STATE(12166)] = 530383,
  [SMALL_STATE(12167)] = 530391,
  [SMALL_STATE(12168)] = 530399,
  [SMALL_STATE(12169)] = 530407,
  [SMALL_STATE(12170)] = 530415,
  [SMALL_STATE(12171)] = 530423,
  [SMALL_STATE(12172)] = 530431,
  [SMALL_STATE(12173)] = 530439,
  [SMALL_STATE(12174)] = 530447,
  [SMALL_STATE(12175)] = 530455,
  [SMALL_STATE(12176)] = 530463,
  [SMALL_STATE(12177)] = 530471,
  [SMALL_STATE(12178)] = 530479,
  [SMALL_STATE(12179)] = 530487,
  [SMALL_STATE(12180)] = 530495,
  [SMALL_STATE(12181)] = 530503,
  [SMALL_STATE(12182)] = 530511,
  [SMALL_STATE(12183)] = 530519,
  [SMALL_STATE(12184)] = 530527,
  [SMALL_STATE(12185)] = 530535,
  [SMALL_STATE(12186)] = 530543,
  [SMALL_STATE(12187)] = 530551,
  [SMALL_STATE(12188)] = 530559,
  [SMALL_STATE(12189)] = 530567,
  [SMALL_STATE(12190)] = 530575,
  [SMALL_STATE(12191)] = 530583,
  [SMALL_STATE(12192)] = 530591,
  [SMALL_STATE(12193)] = 530599,
  [SMALL_STATE(12194)] = 530607,
  [SMALL_STATE(12195)] = 530615,
  [SMALL_STATE(12196)] = 530623,
  [SMALL_STATE(12197)] = 530631,
  [SMALL_STATE(12198)] = 530639,
  [SMALL_STATE(12199)] = 530647,
  [SMALL_STATE(12200)] = 530655,
  [SMALL_STATE(12201)] = 530663,
  [SMALL_STATE(12202)] = 530671,
  [SMALL_STATE(12203)] = 530679,
  [SMALL_STATE(12204)] = 530687,
  [SMALL_STATE(12205)] = 530695,
  [SMALL_STATE(12206)] = 530703,
  [SMALL_STATE(12207)] = 530711,
  [SMALL_STATE(12208)] = 530719,
  [SMALL_STATE(12209)] = 530727,
  [SMALL_STATE(12210)] = 530735,
  [SMALL_STATE(12211)] = 530743,
  [SMALL_STATE(12212)] = 530751,
  [SMALL_STATE(12213)] = 530759,
  [SMALL_STATE(12214)] = 530767,
  [SMALL_STATE(12215)] = 530775,
  [SMALL_STATE(12216)] = 530783,
  [SMALL_STATE(12217)] = 530791,
  [SMALL_STATE(12218)] = 530799,
  [SMALL_STATE(12219)] = 530807,
  [SMALL_STATE(12220)] = 530815,
  [SMALL_STATE(12221)] = 530823,
  [SMALL_STATE(12222)] = 530831,
  [SMALL_STATE(12223)] = 530839,
  [SMALL_STATE(12224)] = 530847,
  [SMALL_STATE(12225)] = 530855,
  [SMALL_STATE(12226)] = 530863,
  [SMALL_STATE(12227)] = 530871,
  [SMALL_STATE(12228)] = 530879,
  [SMALL_STATE(12229)] = 530887,
  [SMALL_STATE(12230)] = 530895,
  [SMALL_STATE(12231)] = 530903,
  [SMALL_STATE(12232)] = 530911,
  [SMALL_STATE(12233)] = 530919,
  [SMALL_STATE(12234)] = 530927,
  [SMALL_STATE(12235)] = 530935,
  [SMALL_STATE(12236)] = 530943,
  [SMALL_STATE(12237)] = 530951,
  [SMALL_STATE(12238)] = 530959,
  [SMALL_STATE(12239)] = 530967,
  [SMALL_STATE(12240)] = 530975,
  [SMALL_STATE(12241)] = 530983,
  [SMALL_STATE(12242)] = 530991,
  [SMALL_STATE(12243)] = 530999,
  [SMALL_STATE(12244)] = 531007,
  [SMALL_STATE(12245)] = 531015,
  [SMALL_STATE(12246)] = 531023,
  [SMALL_STATE(12247)] = 531031,
  [SMALL_STATE(12248)] = 531039,
  [SMALL_STATE(12249)] = 531047,
  [SMALL_STATE(12250)] = 531055,
  [SMALL_STATE(12251)] = 531063,
  [SMALL_STATE(12252)] = 531071,
  [SMALL_STATE(12253)] = 531079,
  [SMALL_STATE(12254)] = 531087,
  [SMALL_STATE(12255)] = 531095,
  [SMALL_STATE(12256)] = 531103,
  [SMALL_STATE(12257)] = 531111,
  [SMALL_STATE(12258)] = 531119,
  [SMALL_STATE(12259)] = 531127,
  [SMALL_STATE(12260)] = 531135,
  [SMALL_STATE(12261)] = 531143,
  [SMALL_STATE(12262)] = 531151,
  [SMALL_STATE(12263)] = 531159,
  [SMALL_STATE(12264)] = 531167,
  [SMALL_STATE(12265)] = 531175,
  [SMALL_STATE(12266)] = 531183,
  [SMALL_STATE(12267)] = 531191,
  [SMALL_STATE(12268)] = 531199,
  [SMALL_STATE(12269)] = 531207,
  [SMALL_STATE(12270)] = 531215,
  [SMALL_STATE(12271)] = 531223,
  [SMALL_STATE(12272)] = 531231,
  [SMALL_STATE(12273)] = 531239,
  [SMALL_STATE(12274)] = 531247,
  [SMALL_STATE(12275)] = 531255,
  [SMALL_STATE(12276)] = 531263,
  [SMALL_STATE(12277)] = 531271,
  [SMALL_STATE(12278)] = 531279,
  [SMALL_STATE(12279)] = 531287,
  [SMALL_STATE(12280)] = 531295,
  [SMALL_STATE(12281)] = 531303,
  [SMALL_STATE(12282)] = 531311,
  [SMALL_STATE(12283)] = 531319,
  [SMALL_STATE(12284)] = 531327,
  [SMALL_STATE(12285)] = 531335,
  [SMALL_STATE(12286)] = 531343,
  [SMALL_STATE(12287)] = 531351,
  [SMALL_STATE(12288)] = 531359,
  [SMALL_STATE(12289)] = 531367,
  [SMALL_STATE(12290)] = 531375,
  [SMALL_STATE(12291)] = 531383,
  [SMALL_STATE(12292)] = 531391,
  [SMALL_STATE(12293)] = 531399,
  [SMALL_STATE(12294)] = 531407,
  [SMALL_STATE(12295)] = 531415,
  [SMALL_STATE(12296)] = 531423,
  [SMALL_STATE(12297)] = 531431,
  [SMALL_STATE(12298)] = 531439,
  [SMALL_STATE(12299)] = 531447,
  [SMALL_STATE(12300)] = 531455,
  [SMALL_STATE(12301)] = 531463,
  [SMALL_STATE(12302)] = 531471,
  [SMALL_STATE(12303)] = 531479,
  [SMALL_STATE(12304)] = 531487,
  [SMALL_STATE(12305)] = 531495,
  [SMALL_STATE(12306)] = 531503,
  [SMALL_STATE(12307)] = 531511,
  [SMALL_STATE(12308)] = 531519,
  [SMALL_STATE(12309)] = 531527,
  [SMALL_STATE(12310)] = 531535,
  [SMALL_STATE(12311)] = 531543,
  [SMALL_STATE(12312)] = 531551,
  [SMALL_STATE(12313)] = 531559,
  [SMALL_STATE(12314)] = 531567,
  [SMALL_STATE(12315)] = 531575,
  [SMALL_STATE(12316)] = 531583,
  [SMALL_STATE(12317)] = 531591,
  [SMALL_STATE(12318)] = 531599,
  [SMALL_STATE(12319)] = 531607,
  [SMALL_STATE(12320)] = 531615,
  [SMALL_STATE(12321)] = 531623,
  [SMALL_STATE(12322)] = 531631,
  [SMALL_STATE(12323)] = 531639,
  [SMALL_STATE(12324)] = 531647,
  [SMALL_STATE(12325)] = 531655,
  [SMALL_STATE(12326)] = 531663,
  [SMALL_STATE(12327)] = 531671,
  [SMALL_STATE(12328)] = 531679,
  [SMALL_STATE(12329)] = 531687,
  [SMALL_STATE(12330)] = 531695,
  [SMALL_STATE(12331)] = 531703,
  [SMALL_STATE(12332)] = 531711,
  [SMALL_STATE(12333)] = 531719,
  [SMALL_STATE(12334)] = 531727,
  [SMALL_STATE(12335)] = 531735,
  [SMALL_STATE(12336)] = 531743,
  [SMALL_STATE(12337)] = 531751,
  [SMALL_STATE(12338)] = 531759,
  [SMALL_STATE(12339)] = 531767,
  [SMALL_STATE(12340)] = 531775,
  [SMALL_STATE(12341)] = 531783,
  [SMALL_STATE(12342)] = 531791,
  [SMALL_STATE(12343)] = 531799,
  [SMALL_STATE(12344)] = 531807,
  [SMALL_STATE(12345)] = 531815,
  [SMALL_STATE(12346)] = 531823,
  [SMALL_STATE(12347)] = 531831,
  [SMALL_STATE(12348)] = 531839,
  [SMALL_STATE(12349)] = 531847,
  [SMALL_STATE(12350)] = 531855,
  [SMALL_STATE(12351)] = 531863,
  [SMALL_STATE(12352)] = 531871,
  [SMALL_STATE(12353)] = 531879,
  [SMALL_STATE(12354)] = 531887,
  [SMALL_STATE(12355)] = 531895,
  [SMALL_STATE(12356)] = 531903,
  [SMALL_STATE(12357)] = 531911,
  [SMALL_STATE(12358)] = 531919,
  [SMALL_STATE(12359)] = 531927,
  [SMALL_STATE(12360)] = 531935,
  [SMALL_STATE(12361)] = 531943,
  [SMALL_STATE(12362)] = 531951,
  [SMALL_STATE(12363)] = 531959,
  [SMALL_STATE(12364)] = 531967,
  [SMALL_STATE(12365)] = 531975,
  [SMALL_STATE(12366)] = 531983,
  [SMALL_STATE(12367)] = 531991,
  [SMALL_STATE(12368)] = 531999,
  [SMALL_STATE(12369)] = 532007,
  [SMALL_STATE(12370)] = 532015,
  [SMALL_STATE(12371)] = 532023,
  [SMALL_STATE(12372)] = 532031,
  [SMALL_STATE(12373)] = 532039,
  [SMALL_STATE(12374)] = 532047,
  [SMALL_STATE(12375)] = 532055,
  [SMALL_STATE(12376)] = 532063,
  [SMALL_STATE(12377)] = 532071,
  [SMALL_STATE(12378)] = 532079,
  [SMALL_STATE(12379)] = 532087,
  [SMALL_STATE(12380)] = 532095,
  [SMALL_STATE(12381)] = 532103,
  [SMALL_STATE(12382)] = 532111,
  [SMALL_STATE(12383)] = 532119,
  [SMALL_STATE(12384)] = 532127,
  [SMALL_STATE(12385)] = 532135,
  [SMALL_STATE(12386)] = 532143,
  [SMALL_STATE(12387)] = 532151,
  [SMALL_STATE(12388)] = 532159,
  [SMALL_STATE(12389)] = 532167,
  [SMALL_STATE(12390)] = 532175,
  [SMALL_STATE(12391)] = 532183,
  [SMALL_STATE(12392)] = 532191,
  [SMALL_STATE(12393)] = 532199,
  [SMALL_STATE(12394)] = 532207,
  [SMALL_STATE(12395)] = 532215,
  [SMALL_STATE(12396)] = 532223,
  [SMALL_STATE(12397)] = 532231,
  [SMALL_STATE(12398)] = 532239,
  [SMALL_STATE(12399)] = 532247,
  [SMALL_STATE(12400)] = 532255,
  [SMALL_STATE(12401)] = 532263,
  [SMALL_STATE(12402)] = 532271,
  [SMALL_STATE(12403)] = 532279,
  [SMALL_STATE(12404)] = 532287,
  [SMALL_STATE(12405)] = 532295,
  [SMALL_STATE(12406)] = 532303,
  [SMALL_STATE(12407)] = 532311,
  [SMALL_STATE(12408)] = 532319,
  [SMALL_STATE(12409)] = 532327,
  [SMALL_STATE(12410)] = 532335,
  [SMALL_STATE(12411)] = 532343,
  [SMALL_STATE(12412)] = 532351,
  [SMALL_STATE(12413)] = 532359,
  [SMALL_STATE(12414)] = 532367,
  [SMALL_STATE(12415)] = 532375,
  [SMALL_STATE(12416)] = 532383,
  [SMALL_STATE(12417)] = 532391,
  [SMALL_STATE(12418)] = 532399,
  [SMALL_STATE(12419)] = 532407,
  [SMALL_STATE(12420)] = 532415,
  [SMALL_STATE(12421)] = 532423,
  [SMALL_STATE(12422)] = 532431,
  [SMALL_STATE(12423)] = 532439,
  [SMALL_STATE(12424)] = 532447,
  [SMALL_STATE(12425)] = 532455,
  [SMALL_STATE(12426)] = 532463,
  [SMALL_STATE(12427)] = 532471,
  [SMALL_STATE(12428)] = 532479,
  [SMALL_STATE(12429)] = 532487,
  [SMALL_STATE(12430)] = 532495,
  [SMALL_STATE(12431)] = 532503,
  [SMALL_STATE(12432)] = 532511,
  [SMALL_STATE(12433)] = 532519,
  [SMALL_STATE(12434)] = 532527,
  [SMALL_STATE(12435)] = 532535,
  [SMALL_STATE(12436)] = 532543,
  [SMALL_STATE(12437)] = 532551,
  [SMALL_STATE(12438)] = 532559,
  [SMALL_STATE(12439)] = 532567,
  [SMALL_STATE(12440)] = 532575,
  [SMALL_STATE(12441)] = 532583,
  [SMALL_STATE(12442)] = 532591,
  [SMALL_STATE(12443)] = 532599,
  [SMALL_STATE(12444)] = 532607,
  [SMALL_STATE(12445)] = 532615,
  [SMALL_STATE(12446)] = 532623,
  [SMALL_STATE(12447)] = 532631,
  [SMALL_STATE(12448)] = 532639,
  [SMALL_STATE(12449)] = 532647,
  [SMALL_STATE(12450)] = 532655,
  [SMALL_STATE(12451)] = 532663,
  [SMALL_STATE(12452)] = 532671,
  [SMALL_STATE(12453)] = 532679,
  [SMALL_STATE(12454)] = 532687,
  [SMALL_STATE(12455)] = 532695,
  [SMALL_STATE(12456)] = 532703,
  [SMALL_STATE(12457)] = 532711,
  [SMALL_STATE(12458)] = 532719,
  [SMALL_STATE(12459)] = 532727,
  [SMALL_STATE(12460)] = 532735,
  [SMALL_STATE(12461)] = 532743,
  [SMALL_STATE(12462)] = 532751,
  [SMALL_STATE(12463)] = 532759,
  [SMALL_STATE(12464)] = 532767,
  [SMALL_STATE(12465)] = 532775,
  [SMALL_STATE(12466)] = 532783,
  [SMALL_STATE(12467)] = 532791,
  [SMALL_STATE(12468)] = 532799,
  [SMALL_STATE(12469)] = 532807,
  [SMALL_STATE(12470)] = 532815,
  [SMALL_STATE(12471)] = 532823,
  [SMALL_STATE(12472)] = 532831,
  [SMALL_STATE(12473)] = 532839,
  [SMALL_STATE(12474)] = 532847,
  [SMALL_STATE(12475)] = 532855,
  [SMALL_STATE(12476)] = 532863,
  [SMALL_STATE(12477)] = 532871,
  [SMALL_STATE(12478)] = 532879,
  [SMALL_STATE(12479)] = 532887,
  [SMALL_STATE(12480)] = 532895,
  [SMALL_STATE(12481)] = 532903,
  [SMALL_STATE(12482)] = 532911,
  [SMALL_STATE(12483)] = 532919,
  [SMALL_STATE(12484)] = 532927,
  [SMALL_STATE(12485)] = 532935,
  [SMALL_STATE(12486)] = 532943,
  [SMALL_STATE(12487)] = 532951,
  [SMALL_STATE(12488)] = 532959,
  [SMALL_STATE(12489)] = 532967,
  [SMALL_STATE(12490)] = 532975,
  [SMALL_STATE(12491)] = 532983,
  [SMALL_STATE(12492)] = 532991,
  [SMALL_STATE(12493)] = 532999,
  [SMALL_STATE(12494)] = 533007,
  [SMALL_STATE(12495)] = 533015,
  [SMALL_STATE(12496)] = 533023,
  [SMALL_STATE(12497)] = 533031,
  [SMALL_STATE(12498)] = 533039,
  [SMALL_STATE(12499)] = 533047,
  [SMALL_STATE(12500)] = 533055,
  [SMALL_STATE(12501)] = 533063,
  [SMALL_STATE(12502)] = 533071,
  [SMALL_STATE(12503)] = 533079,
  [SMALL_STATE(12504)] = 533087,
  [SMALL_STATE(12505)] = 533095,
  [SMALL_STATE(12506)] = 533103,
  [SMALL_STATE(12507)] = 533111,
  [SMALL_STATE(12508)] = 533119,
  [SMALL_STATE(12509)] = 533127,
  [SMALL_STATE(12510)] = 533135,
  [SMALL_STATE(12511)] = 533143,
  [SMALL_STATE(12512)] = 533151,
  [SMALL_STATE(12513)] = 533159,
  [SMALL_STATE(12514)] = 533167,
  [SMALL_STATE(12515)] = 533175,
  [SMALL_STATE(12516)] = 533183,
  [SMALL_STATE(12517)] = 533191,
  [SMALL_STATE(12518)] = 533199,
  [SMALL_STATE(12519)] = 533207,
  [SMALL_STATE(12520)] = 533215,
  [SMALL_STATE(12521)] = 533223,
  [SMALL_STATE(12522)] = 533231,
  [SMALL_STATE(12523)] = 533239,
  [SMALL_STATE(12524)] = 533247,
  [SMALL_STATE(12525)] = 533255,
  [SMALL_STATE(12526)] = 533263,
  [SMALL_STATE(12527)] = 533271,
  [SMALL_STATE(12528)] = 533279,
  [SMALL_STATE(12529)] = 533287,
  [SMALL_STATE(12530)] = 533295,
  [SMALL_STATE(12531)] = 533303,
  [SMALL_STATE(12532)] = 533311,
  [SMALL_STATE(12533)] = 533319,
  [SMALL_STATE(12534)] = 533327,
  [SMALL_STATE(12535)] = 533335,
  [SMALL_STATE(12536)] = 533343,
  [SMALL_STATE(12537)] = 533351,
  [SMALL_STATE(12538)] = 533359,
  [SMALL_STATE(12539)] = 533367,
  [SMALL_STATE(12540)] = 533375,
  [SMALL_STATE(12541)] = 533383,
  [SMALL_STATE(12542)] = 533391,
  [SMALL_STATE(12543)] = 533399,
  [SMALL_STATE(12544)] = 533407,
  [SMALL_STATE(12545)] = 533415,
  [SMALL_STATE(12546)] = 533423,
  [SMALL_STATE(12547)] = 533431,
  [SMALL_STATE(12548)] = 533439,
  [SMALL_STATE(12549)] = 533447,
  [SMALL_STATE(12550)] = 533455,
  [SMALL_STATE(12551)] = 533463,
  [SMALL_STATE(12552)] = 533471,
  [SMALL_STATE(12553)] = 533479,
  [SMALL_STATE(12554)] = 533487,
  [SMALL_STATE(12555)] = 533495,
  [SMALL_STATE(12556)] = 533503,
  [SMALL_STATE(12557)] = 533511,
  [SMALL_STATE(12558)] = 533519,
  [SMALL_STATE(12559)] = 533527,
  [SMALL_STATE(12560)] = 533535,
  [SMALL_STATE(12561)] = 533543,
  [SMALL_STATE(12562)] = 533551,
  [SMALL_STATE(12563)] = 533559,
  [SMALL_STATE(12564)] = 533567,
  [SMALL_STATE(12565)] = 533575,
  [SMALL_STATE(12566)] = 533583,
  [SMALL_STATE(12567)] = 533591,
  [SMALL_STATE(12568)] = 533599,
  [SMALL_STATE(12569)] = 533607,
  [SMALL_STATE(12570)] = 533615,
  [SMALL_STATE(12571)] = 533623,
  [SMALL_STATE(12572)] = 533631,
  [SMALL_STATE(12573)] = 533639,
  [SMALL_STATE(12574)] = 533647,
  [SMALL_STATE(12575)] = 533655,
  [SMALL_STATE(12576)] = 533663,
  [SMALL_STATE(12577)] = 533671,
  [SMALL_STATE(12578)] = 533679,
  [SMALL_STATE(12579)] = 533687,
  [SMALL_STATE(12580)] = 533695,
  [SMALL_STATE(12581)] = 533703,
  [SMALL_STATE(12582)] = 533711,
  [SMALL_STATE(12583)] = 533719,
  [SMALL_STATE(12584)] = 533727,
  [SMALL_STATE(12585)] = 533735,
  [SMALL_STATE(12586)] = 533743,
  [SMALL_STATE(12587)] = 533751,
  [SMALL_STATE(12588)] = 533759,
  [SMALL_STATE(12589)] = 533767,
  [SMALL_STATE(12590)] = 533775,
  [SMALL_STATE(12591)] = 533783,
  [SMALL_STATE(12592)] = 533791,
  [SMALL_STATE(12593)] = 533799,
  [SMALL_STATE(12594)] = 533807,
  [SMALL_STATE(12595)] = 533815,
  [SMALL_STATE(12596)] = 533823,
  [SMALL_STATE(12597)] = 533831,
  [SMALL_STATE(12598)] = 533839,
  [SMALL_STATE(12599)] = 533847,
  [SMALL_STATE(12600)] = 533855,
  [SMALL_STATE(12601)] = 533863,
  [SMALL_STATE(12602)] = 533871,
  [SMALL_STATE(12603)] = 533879,
  [SMALL_STATE(12604)] = 533887,
  [SMALL_STATE(12605)] = 533895,
  [SMALL_STATE(12606)] = 533903,
  [SMALL_STATE(12607)] = 533911,
  [SMALL_STATE(12608)] = 533919,
  [SMALL_STATE(12609)] = 533927,
  [SMALL_STATE(12610)] = 533935,
  [SMALL_STATE(12611)] = 533943,
  [SMALL_STATE(12612)] = 533951,
  [SMALL_STATE(12613)] = 533959,
  [SMALL_STATE(12614)] = 533967,
  [SMALL_STATE(12615)] = 533975,
  [SMALL_STATE(12616)] = 533983,
  [SMALL_STATE(12617)] = 533991,
  [SMALL_STATE(12618)] = 533999,
  [SMALL_STATE(12619)] = 534007,
  [SMALL_STATE(12620)] = 534015,
  [SMALL_STATE(12621)] = 534023,
  [SMALL_STATE(12622)] = 534031,
  [SMALL_STATE(12623)] = 534039,
  [SMALL_STATE(12624)] = 534047,
  [SMALL_STATE(12625)] = 534055,
  [SMALL_STATE(12626)] = 534063,
  [SMALL_STATE(12627)] = 534071,
  [SMALL_STATE(12628)] = 534079,
  [SMALL_STATE(12629)] = 534087,
  [SMALL_STATE(12630)] = 534095,
  [SMALL_STATE(12631)] = 534103,
  [SMALL_STATE(12632)] = 534111,
  [SMALL_STATE(12633)] = 534119,
  [SMALL_STATE(12634)] = 534127,
  [SMALL_STATE(12635)] = 534135,
  [SMALL_STATE(12636)] = 534143,
  [SMALL_STATE(12637)] = 534151,
  [SMALL_STATE(12638)] = 534159,
  [SMALL_STATE(12639)] = 534167,
  [SMALL_STATE(12640)] = 534175,
  [SMALL_STATE(12641)] = 534183,
  [SMALL_STATE(12642)] = 534191,
  [SMALL_STATE(12643)] = 534199,
  [SMALL_STATE(12644)] = 534207,
  [SMALL_STATE(12645)] = 534215,
  [SMALL_STATE(12646)] = 534223,
  [SMALL_STATE(12647)] = 534231,
  [SMALL_STATE(12648)] = 534239,
  [SMALL_STATE(12649)] = 534247,
  [SMALL_STATE(12650)] = 534255,
  [SMALL_STATE(12651)] = 534263,
  [SMALL_STATE(12652)] = 534271,
  [SMALL_STATE(12653)] = 534279,
  [SMALL_STATE(12654)] = 534287,
  [SMALL_STATE(12655)] = 534295,
  [SMALL_STATE(12656)] = 534303,
  [SMALL_STATE(12657)] = 534311,
  [SMALL_STATE(12658)] = 534319,
  [SMALL_STATE(12659)] = 534327,
  [SMALL_STATE(12660)] = 534335,
  [SMALL_STATE(12661)] = 534343,
  [SMALL_STATE(12662)] = 534351,
  [SMALL_STATE(12663)] = 534359,
  [SMALL_STATE(12664)] = 534367,
  [SMALL_STATE(12665)] = 534375,
  [SMALL_STATE(12666)] = 534383,
  [SMALL_STATE(12667)] = 534391,
  [SMALL_STATE(12668)] = 534399,
  [SMALL_STATE(12669)] = 534407,
  [SMALL_STATE(12670)] = 534415,
  [SMALL_STATE(12671)] = 534423,
  [SMALL_STATE(12672)] = 534431,
  [SMALL_STATE(12673)] = 534439,
  [SMALL_STATE(12674)] = 534447,
  [SMALL_STATE(12675)] = 534455,
  [SMALL_STATE(12676)] = 534463,
  [SMALL_STATE(12677)] = 534471,
  [SMALL_STATE(12678)] = 534479,
  [SMALL_STATE(12679)] = 534487,
  [SMALL_STATE(12680)] = 534495,
  [SMALL_STATE(12681)] = 534503,
  [SMALL_STATE(12682)] = 534511,
  [SMALL_STATE(12683)] = 534519,
  [SMALL_STATE(12684)] = 534527,
  [SMALL_STATE(12685)] = 534535,
  [SMALL_STATE(12686)] = 534543,
  [SMALL_STATE(12687)] = 534551,
  [SMALL_STATE(12688)] = 534559,
  [SMALL_STATE(12689)] = 534567,
  [SMALL_STATE(12690)] = 534575,
  [SMALL_STATE(12691)] = 534583,
  [SMALL_STATE(12692)] = 534591,
  [SMALL_STATE(12693)] = 534599,
  [SMALL_STATE(12694)] = 534607,
  [SMALL_STATE(12695)] = 534615,
  [SMALL_STATE(12696)] = 534623,
  [SMALL_STATE(12697)] = 534631,
  [SMALL_STATE(12698)] = 534639,
  [SMALL_STATE(12699)] = 534647,
  [SMALL_STATE(12700)] = 534655,
  [SMALL_STATE(12701)] = 534663,
  [SMALL_STATE(12702)] = 534671,
  [SMALL_STATE(12703)] = 534679,
  [SMALL_STATE(12704)] = 534687,
  [SMALL_STATE(12705)] = 534695,
  [SMALL_STATE(12706)] = 534703,
  [SMALL_STATE(12707)] = 534711,
  [SMALL_STATE(12708)] = 534719,
  [SMALL_STATE(12709)] = 534727,
  [SMALL_STATE(12710)] = 534735,
  [SMALL_STATE(12711)] = 534743,
  [SMALL_STATE(12712)] = 534751,
  [SMALL_STATE(12713)] = 534759,
  [SMALL_STATE(12714)] = 534767,
  [SMALL_STATE(12715)] = 534775,
  [SMALL_STATE(12716)] = 534783,
  [SMALL_STATE(12717)] = 534791,
  [SMALL_STATE(12718)] = 534799,
  [SMALL_STATE(12719)] = 534807,
  [SMALL_STATE(12720)] = 534815,
  [SMALL_STATE(12721)] = 534823,
  [SMALL_STATE(12722)] = 534831,
  [SMALL_STATE(12723)] = 534839,
  [SMALL_STATE(12724)] = 534847,
  [SMALL_STATE(12725)] = 534855,
  [SMALL_STATE(12726)] = 534863,
  [SMALL_STATE(12727)] = 534871,
  [SMALL_STATE(12728)] = 534879,
  [SMALL_STATE(12729)] = 534887,
  [SMALL_STATE(12730)] = 534895,
  [SMALL_STATE(12731)] = 534903,
  [SMALL_STATE(12732)] = 534911,
  [SMALL_STATE(12733)] = 534919,
  [SMALL_STATE(12734)] = 534927,
  [SMALL_STATE(12735)] = 534935,
  [SMALL_STATE(12736)] = 534943,
  [SMALL_STATE(12737)] = 534951,
  [SMALL_STATE(12738)] = 534959,
  [SMALL_STATE(12739)] = 534967,
  [SMALL_STATE(12740)] = 534975,
  [SMALL_STATE(12741)] = 534983,
  [SMALL_STATE(12742)] = 534991,
  [SMALL_STATE(12743)] = 534999,
  [SMALL_STATE(12744)] = 535007,
  [SMALL_STATE(12745)] = 535015,
  [SMALL_STATE(12746)] = 535023,
  [SMALL_STATE(12747)] = 535031,
  [SMALL_STATE(12748)] = 535039,
  [SMALL_STATE(12749)] = 535047,
  [SMALL_STATE(12750)] = 535055,
  [SMALL_STATE(12751)] = 535063,
  [SMALL_STATE(12752)] = 535071,
  [SMALL_STATE(12753)] = 535079,
  [SMALL_STATE(12754)] = 535087,
  [SMALL_STATE(12755)] = 535095,
  [SMALL_STATE(12756)] = 535103,
  [SMALL_STATE(12757)] = 535111,
  [SMALL_STATE(12758)] = 535119,
  [SMALL_STATE(12759)] = 535127,
  [SMALL_STATE(12760)] = 535135,
  [SMALL_STATE(12761)] = 535143,
  [SMALL_STATE(12762)] = 535151,
  [SMALL_STATE(12763)] = 535159,
  [SMALL_STATE(12764)] = 535167,
  [SMALL_STATE(12765)] = 535175,
  [SMALL_STATE(12766)] = 535183,
  [SMALL_STATE(12767)] = 535191,
  [SMALL_STATE(12768)] = 535199,
  [SMALL_STATE(12769)] = 535207,
  [SMALL_STATE(12770)] = 535215,
  [SMALL_STATE(12771)] = 535223,
  [SMALL_STATE(12772)] = 535231,
  [SMALL_STATE(12773)] = 535239,
  [SMALL_STATE(12774)] = 535247,
  [SMALL_STATE(12775)] = 535255,
  [SMALL_STATE(12776)] = 535263,
  [SMALL_STATE(12777)] = 535271,
  [SMALL_STATE(12778)] = 535279,
  [SMALL_STATE(12779)] = 535287,
  [SMALL_STATE(12780)] = 535295,
  [SMALL_STATE(12781)] = 535303,
  [SMALL_STATE(12782)] = 535311,
  [SMALL_STATE(12783)] = 535319,
  [SMALL_STATE(12784)] = 535327,
  [SMALL_STATE(12785)] = 535335,
  [SMALL_STATE(12786)] = 535343,
  [SMALL_STATE(12787)] = 535351,
  [SMALL_STATE(12788)] = 535359,
  [SMALL_STATE(12789)] = 535367,
  [SMALL_STATE(12790)] = 535375,
  [SMALL_STATE(12791)] = 535383,
  [SMALL_STATE(12792)] = 535391,
  [SMALL_STATE(12793)] = 535399,
  [SMALL_STATE(12794)] = 535407,
  [SMALL_STATE(12795)] = 535415,
  [SMALL_STATE(12796)] = 535423,
  [SMALL_STATE(12797)] = 535431,
  [SMALL_STATE(12798)] = 535439,
  [SMALL_STATE(12799)] = 535447,
  [SMALL_STATE(12800)] = 535455,
  [SMALL_STATE(12801)] = 535463,
  [SMALL_STATE(12802)] = 535471,
  [SMALL_STATE(12803)] = 535479,
  [SMALL_STATE(12804)] = 535487,
  [SMALL_STATE(12805)] = 535495,
  [SMALL_STATE(12806)] = 535503,
  [SMALL_STATE(12807)] = 535511,
  [SMALL_STATE(12808)] = 535519,
  [SMALL_STATE(12809)] = 535527,
  [SMALL_STATE(12810)] = 535535,
  [SMALL_STATE(12811)] = 535543,
  [SMALL_STATE(12812)] = 535551,
  [SMALL_STATE(12813)] = 535559,
  [SMALL_STATE(12814)] = 535567,
  [SMALL_STATE(12815)] = 535575,
  [SMALL_STATE(12816)] = 535583,
  [SMALL_STATE(12817)] = 535591,
  [SMALL_STATE(12818)] = 535599,
  [SMALL_STATE(12819)] = 535607,
  [SMALL_STATE(12820)] = 535615,
  [SMALL_STATE(12821)] = 535623,
  [SMALL_STATE(12822)] = 535631,
  [SMALL_STATE(12823)] = 535639,
  [SMALL_STATE(12824)] = 535647,
  [SMALL_STATE(12825)] = 535655,
  [SMALL_STATE(12826)] = 535663,
  [SMALL_STATE(12827)] = 535671,
  [SMALL_STATE(12828)] = 535679,
  [SMALL_STATE(12829)] = 535687,
  [SMALL_STATE(12830)] = 535695,
  [SMALL_STATE(12831)] = 535703,
  [SMALL_STATE(12832)] = 535711,
  [SMALL_STATE(12833)] = 535719,
  [SMALL_STATE(12834)] = 535727,
  [SMALL_STATE(12835)] = 535735,
  [SMALL_STATE(12836)] = 535743,
  [SMALL_STATE(12837)] = 535751,
  [SMALL_STATE(12838)] = 535759,
  [SMALL_STATE(12839)] = 535767,
  [SMALL_STATE(12840)] = 535775,
  [SMALL_STATE(12841)] = 535783,
  [SMALL_STATE(12842)] = 535791,
  [SMALL_STATE(12843)] = 535799,
  [SMALL_STATE(12844)] = 535807,
  [SMALL_STATE(12845)] = 535815,
  [SMALL_STATE(12846)] = 535823,
  [SMALL_STATE(12847)] = 535831,
  [SMALL_STATE(12848)] = 535839,
  [SMALL_STATE(12849)] = 535847,
  [SMALL_STATE(12850)] = 535855,
  [SMALL_STATE(12851)] = 535863,
  [SMALL_STATE(12852)] = 535871,
  [SMALL_STATE(12853)] = 535879,
  [SMALL_STATE(12854)] = 535887,
  [SMALL_STATE(12855)] = 535895,
  [SMALL_STATE(12856)] = 535903,
  [SMALL_STATE(12857)] = 535911,
  [SMALL_STATE(12858)] = 535919,
  [SMALL_STATE(12859)] = 535927,
  [SMALL_STATE(12860)] = 535935,
  [SMALL_STATE(12861)] = 535943,
  [SMALL_STATE(12862)] = 535951,
  [SMALL_STATE(12863)] = 535959,
  [SMALL_STATE(12864)] = 535967,
  [SMALL_STATE(12865)] = 535975,
  [SMALL_STATE(12866)] = 535983,
  [SMALL_STATE(12867)] = 535991,
  [SMALL_STATE(12868)] = 535999,
  [SMALL_STATE(12869)] = 536007,
  [SMALL_STATE(12870)] = 536015,
  [SMALL_STATE(12871)] = 536023,
  [SMALL_STATE(12872)] = 536031,
  [SMALL_STATE(12873)] = 536039,
  [SMALL_STATE(12874)] = 536047,
  [SMALL_STATE(12875)] = 536055,
  [SMALL_STATE(12876)] = 536063,
  [SMALL_STATE(12877)] = 536071,
  [SMALL_STATE(12878)] = 536079,
  [SMALL_STATE(12879)] = 536087,
  [SMALL_STATE(12880)] = 536095,
  [SMALL_STATE(12881)] = 536103,
  [SMALL_STATE(12882)] = 536111,
  [SMALL_STATE(12883)] = 536119,
  [SMALL_STATE(12884)] = 536127,
  [SMALL_STATE(12885)] = 536135,
  [SMALL_STATE(12886)] = 536143,
  [SMALL_STATE(12887)] = 536151,
  [SMALL_STATE(12888)] = 536159,
  [SMALL_STATE(12889)] = 536167,
  [SMALL_STATE(12890)] = 536175,
  [SMALL_STATE(12891)] = 536183,
  [SMALL_STATE(12892)] = 536191,
  [SMALL_STATE(12893)] = 536199,
  [SMALL_STATE(12894)] = 536207,
  [SMALL_STATE(12895)] = 536215,
  [SMALL_STATE(12896)] = 536223,
  [SMALL_STATE(12897)] = 536231,
  [SMALL_STATE(12898)] = 536239,
  [SMALL_STATE(12899)] = 536247,
  [SMALL_STATE(12900)] = 536255,
  [SMALL_STATE(12901)] = 536263,
  [SMALL_STATE(12902)] = 536271,
  [SMALL_STATE(12903)] = 536279,
  [SMALL_STATE(12904)] = 536287,
  [SMALL_STATE(12905)] = 536295,
  [SMALL_STATE(12906)] = 536303,
  [SMALL_STATE(12907)] = 536311,
  [SMALL_STATE(12908)] = 536319,
  [SMALL_STATE(12909)] = 536327,
  [SMALL_STATE(12910)] = 536335,
  [SMALL_STATE(12911)] = 536343,
  [SMALL_STATE(12912)] = 536351,
  [SMALL_STATE(12913)] = 536359,
  [SMALL_STATE(12914)] = 536367,
  [SMALL_STATE(12915)] = 536375,
  [SMALL_STATE(12916)] = 536383,
  [SMALL_STATE(12917)] = 536391,
  [SMALL_STATE(12918)] = 536399,
  [SMALL_STATE(12919)] = 536407,
  [SMALL_STATE(12920)] = 536415,
  [SMALL_STATE(12921)] = 536423,
  [SMALL_STATE(12922)] = 536431,
  [SMALL_STATE(12923)] = 536439,
  [SMALL_STATE(12924)] = 536447,
  [SMALL_STATE(12925)] = 536455,
  [SMALL_STATE(12926)] = 536463,
  [SMALL_STATE(12927)] = 536471,
  [SMALL_STATE(12928)] = 536479,
  [SMALL_STATE(12929)] = 536487,
  [SMALL_STATE(12930)] = 536495,
  [SMALL_STATE(12931)] = 536503,
  [SMALL_STATE(12932)] = 536511,
  [SMALL_STATE(12933)] = 536519,
  [SMALL_STATE(12934)] = 536527,
  [SMALL_STATE(12935)] = 536535,
  [SMALL_STATE(12936)] = 536543,
  [SMALL_STATE(12937)] = 536551,
  [SMALL_STATE(12938)] = 536559,
  [SMALL_STATE(12939)] = 536567,
  [SMALL_STATE(12940)] = 536575,
  [SMALL_STATE(12941)] = 536583,
  [SMALL_STATE(12942)] = 536591,
  [SMALL_STATE(12943)] = 536599,
  [SMALL_STATE(12944)] = 536607,
  [SMALL_STATE(12945)] = 536615,
  [SMALL_STATE(12946)] = 536623,
  [SMALL_STATE(12947)] = 536631,
  [SMALL_STATE(12948)] = 536639,
  [SMALL_STATE(12949)] = 536647,
  [SMALL_STATE(12950)] = 536655,
  [SMALL_STATE(12951)] = 536663,
  [SMALL_STATE(12952)] = 536671,
  [SMALL_STATE(12953)] = 536679,
  [SMALL_STATE(12954)] = 536687,
  [SMALL_STATE(12955)] = 536695,
  [SMALL_STATE(12956)] = 536703,
  [SMALL_STATE(12957)] = 536711,
  [SMALL_STATE(12958)] = 536719,
  [SMALL_STATE(12959)] = 536727,
  [SMALL_STATE(12960)] = 536735,
  [SMALL_STATE(12961)] = 536743,
  [SMALL_STATE(12962)] = 536751,
  [SMALL_STATE(12963)] = 536759,
  [SMALL_STATE(12964)] = 536767,
  [SMALL_STATE(12965)] = 536775,
  [SMALL_STATE(12966)] = 536783,
  [SMALL_STATE(12967)] = 536791,
  [SMALL_STATE(12968)] = 536799,
  [SMALL_STATE(12969)] = 536807,
  [SMALL_STATE(12970)] = 536815,
  [SMALL_STATE(12971)] = 536823,
  [SMALL_STATE(12972)] = 536831,
  [SMALL_STATE(12973)] = 536839,
  [SMALL_STATE(12974)] = 536847,
  [SMALL_STATE(12975)] = 536855,
  [SMALL_STATE(12976)] = 536863,
  [SMALL_STATE(12977)] = 536871,
  [SMALL_STATE(12978)] = 536879,
  [SMALL_STATE(12979)] = 536887,
  [SMALL_STATE(12980)] = 536895,
  [SMALL_STATE(12981)] = 536903,
  [SMALL_STATE(12982)] = 536911,
  [SMALL_STATE(12983)] = 536919,
  [SMALL_STATE(12984)] = 536927,
  [SMALL_STATE(12985)] = 536935,
  [SMALL_STATE(12986)] = 536943,
  [SMALL_STATE(12987)] = 536951,
  [SMALL_STATE(12988)] = 536959,
  [SMALL_STATE(12989)] = 536967,
  [SMALL_STATE(12990)] = 536975,
  [SMALL_STATE(12991)] = 536983,
  [SMALL_STATE(12992)] = 536991,
  [SMALL_STATE(12993)] = 536999,
  [SMALL_STATE(12994)] = 537007,
  [SMALL_STATE(12995)] = 537015,
  [SMALL_STATE(12996)] = 537023,
  [SMALL_STATE(12997)] = 537031,
  [SMALL_STATE(12998)] = 537039,
  [SMALL_STATE(12999)] = 537047,
  [SMALL_STATE(13000)] = 537055,
  [SMALL_STATE(13001)] = 537063,
  [SMALL_STATE(13002)] = 537071,
  [SMALL_STATE(13003)] = 537079,
  [SMALL_STATE(13004)] = 537087,
  [SMALL_STATE(13005)] = 537095,
  [SMALL_STATE(13006)] = 537103,
  [SMALL_STATE(13007)] = 537111,
  [SMALL_STATE(13008)] = 537119,
  [SMALL_STATE(13009)] = 537127,
  [SMALL_STATE(13010)] = 537135,
  [SMALL_STATE(13011)] = 537143,
  [SMALL_STATE(13012)] = 537151,
  [SMALL_STATE(13013)] = 537159,
  [SMALL_STATE(13014)] = 537167,
  [SMALL_STATE(13015)] = 537175,
  [SMALL_STATE(13016)] = 537183,
  [SMALL_STATE(13017)] = 537191,
  [SMALL_STATE(13018)] = 537199,
  [SMALL_STATE(13019)] = 537207,
  [SMALL_STATE(13020)] = 537215,
  [SMALL_STATE(13021)] = 537223,
  [SMALL_STATE(13022)] = 537231,
  [SMALL_STATE(13023)] = 537239,
  [SMALL_STATE(13024)] = 537247,
  [SMALL_STATE(13025)] = 537255,
  [SMALL_STATE(13026)] = 537263,
  [SMALL_STATE(13027)] = 537271,
  [SMALL_STATE(13028)] = 537279,
  [SMALL_STATE(13029)] = 537287,
  [SMALL_STATE(13030)] = 537295,
  [SMALL_STATE(13031)] = 537303,
  [SMALL_STATE(13032)] = 537311,
  [SMALL_STATE(13033)] = 537319,
  [SMALL_STATE(13034)] = 537327,
  [SMALL_STATE(13035)] = 537335,
  [SMALL_STATE(13036)] = 537343,
  [SMALL_STATE(13037)] = 537351,
  [SMALL_STATE(13038)] = 537359,
  [SMALL_STATE(13039)] = 537367,
  [SMALL_STATE(13040)] = 537375,
  [SMALL_STATE(13041)] = 537383,
  [SMALL_STATE(13042)] = 537391,
  [SMALL_STATE(13043)] = 537399,
  [SMALL_STATE(13044)] = 537407,
  [SMALL_STATE(13045)] = 537415,
  [SMALL_STATE(13046)] = 537423,
  [SMALL_STATE(13047)] = 537431,
  [SMALL_STATE(13048)] = 537439,
  [SMALL_STATE(13049)] = 537447,
  [SMALL_STATE(13050)] = 537455,
  [SMALL_STATE(13051)] = 537463,
  [SMALL_STATE(13052)] = 537471,
  [SMALL_STATE(13053)] = 537479,
  [SMALL_STATE(13054)] = 537487,
  [SMALL_STATE(13055)] = 537495,
  [SMALL_STATE(13056)] = 537503,
  [SMALL_STATE(13057)] = 537511,
  [SMALL_STATE(13058)] = 537519,
  [SMALL_STATE(13059)] = 537527,
  [SMALL_STATE(13060)] = 537535,
  [SMALL_STATE(13061)] = 537543,
  [SMALL_STATE(13062)] = 537551,
  [SMALL_STATE(13063)] = 537559,
  [SMALL_STATE(13064)] = 537567,
  [SMALL_STATE(13065)] = 537575,
  [SMALL_STATE(13066)] = 537583,
  [SMALL_STATE(13067)] = 537591,
  [SMALL_STATE(13068)] = 537599,
  [SMALL_STATE(13069)] = 537607,
  [SMALL_STATE(13070)] = 537615,
  [SMALL_STATE(13071)] = 537623,
  [SMALL_STATE(13072)] = 537631,
  [SMALL_STATE(13073)] = 537639,
  [SMALL_STATE(13074)] = 537647,
  [SMALL_STATE(13075)] = 537655,
  [SMALL_STATE(13076)] = 537663,
  [SMALL_STATE(13077)] = 537671,
  [SMALL_STATE(13078)] = 537679,
  [SMALL_STATE(13079)] = 537687,
  [SMALL_STATE(13080)] = 537695,
  [SMALL_STATE(13081)] = 537703,
  [SMALL_STATE(13082)] = 537711,
  [SMALL_STATE(13083)] = 537719,
  [SMALL_STATE(13084)] = 537727,
  [SMALL_STATE(13085)] = 537735,
  [SMALL_STATE(13086)] = 537743,
  [SMALL_STATE(13087)] = 537751,
  [SMALL_STATE(13088)] = 537759,
  [SMALL_STATE(13089)] = 537767,
  [SMALL_STATE(13090)] = 537775,
  [SMALL_STATE(13091)] = 537783,
  [SMALL_STATE(13092)] = 537791,
  [SMALL_STATE(13093)] = 537799,
  [SMALL_STATE(13094)] = 537807,
  [SMALL_STATE(13095)] = 537815,
  [SMALL_STATE(13096)] = 537823,
  [SMALL_STATE(13097)] = 537831,
  [SMALL_STATE(13098)] = 537839,
  [SMALL_STATE(13099)] = 537847,
  [SMALL_STATE(13100)] = 537855,
  [SMALL_STATE(13101)] = 537863,
  [SMALL_STATE(13102)] = 537871,
  [SMALL_STATE(13103)] = 537879,
  [SMALL_STATE(13104)] = 537887,
  [SMALL_STATE(13105)] = 537895,
  [SMALL_STATE(13106)] = 537903,
  [SMALL_STATE(13107)] = 537911,
  [SMALL_STATE(13108)] = 537919,
  [SMALL_STATE(13109)] = 537927,
  [SMALL_STATE(13110)] = 537935,
  [SMALL_STATE(13111)] = 537943,
  [SMALL_STATE(13112)] = 537951,
  [SMALL_STATE(13113)] = 537959,
  [SMALL_STATE(13114)] = 537967,
  [SMALL_STATE(13115)] = 537975,
  [SMALL_STATE(13116)] = 537983,
  [SMALL_STATE(13117)] = 537991,
  [SMALL_STATE(13118)] = 537999,
  [SMALL_STATE(13119)] = 538007,
  [SMALL_STATE(13120)] = 538015,
  [SMALL_STATE(13121)] = 538023,
  [SMALL_STATE(13122)] = 538031,
  [SMALL_STATE(13123)] = 538039,
  [SMALL_STATE(13124)] = 538047,
  [SMALL_STATE(13125)] = 538055,
  [SMALL_STATE(13126)] = 538063,
  [SMALL_STATE(13127)] = 538071,
  [SMALL_STATE(13128)] = 538079,
  [SMALL_STATE(13129)] = 538087,
  [SMALL_STATE(13130)] = 538095,
  [SMALL_STATE(13131)] = 538103,
  [SMALL_STATE(13132)] = 538111,
  [SMALL_STATE(13133)] = 538119,
  [SMALL_STATE(13134)] = 538127,
  [SMALL_STATE(13135)] = 538135,
  [SMALL_STATE(13136)] = 538143,
  [SMALL_STATE(13137)] = 538151,
  [SMALL_STATE(13138)] = 538159,
  [SMALL_STATE(13139)] = 538167,
  [SMALL_STATE(13140)] = 538175,
  [SMALL_STATE(13141)] = 538183,
  [SMALL_STATE(13142)] = 538191,
  [SMALL_STATE(13143)] = 538199,
  [SMALL_STATE(13144)] = 538207,
  [SMALL_STATE(13145)] = 538215,
  [SMALL_STATE(13146)] = 538223,
  [SMALL_STATE(13147)] = 538231,
  [SMALL_STATE(13148)] = 538239,
  [SMALL_STATE(13149)] = 538247,
  [SMALL_STATE(13150)] = 538255,
  [SMALL_STATE(13151)] = 538263,
  [SMALL_STATE(13152)] = 538271,
  [SMALL_STATE(13153)] = 538279,
  [SMALL_STATE(13154)] = 538287,
  [SMALL_STATE(13155)] = 538295,
  [SMALL_STATE(13156)] = 538303,
  [SMALL_STATE(13157)] = 538311,
  [SMALL_STATE(13158)] = 538319,
  [SMALL_STATE(13159)] = 538327,
  [SMALL_STATE(13160)] = 538335,
  [SMALL_STATE(13161)] = 538343,
  [SMALL_STATE(13162)] = 538351,
  [SMALL_STATE(13163)] = 538359,
  [SMALL_STATE(13164)] = 538367,
  [SMALL_STATE(13165)] = 538375,
  [SMALL_STATE(13166)] = 538383,
  [SMALL_STATE(13167)] = 538391,
  [SMALL_STATE(13168)] = 538399,
  [SMALL_STATE(13169)] = 538407,
  [SMALL_STATE(13170)] = 538415,
  [SMALL_STATE(13171)] = 538423,
  [SMALL_STATE(13172)] = 538431,
  [SMALL_STATE(13173)] = 538439,
  [SMALL_STATE(13174)] = 538447,
  [SMALL_STATE(13175)] = 538455,
  [SMALL_STATE(13176)] = 538463,
  [SMALL_STATE(13177)] = 538471,
  [SMALL_STATE(13178)] = 538479,
  [SMALL_STATE(13179)] = 538487,
  [SMALL_STATE(13180)] = 538495,
  [SMALL_STATE(13181)] = 538503,
  [SMALL_STATE(13182)] = 538511,
  [SMALL_STATE(13183)] = 538519,
  [SMALL_STATE(13184)] = 538527,
  [SMALL_STATE(13185)] = 538535,
  [SMALL_STATE(13186)] = 538543,
  [SMALL_STATE(13187)] = 538551,
  [SMALL_STATE(13188)] = 538559,
  [SMALL_STATE(13189)] = 538567,
  [SMALL_STATE(13190)] = 538575,
  [SMALL_STATE(13191)] = 538583,
  [SMALL_STATE(13192)] = 538591,
  [SMALL_STATE(13193)] = 538599,
  [SMALL_STATE(13194)] = 538607,
  [SMALL_STATE(13195)] = 538615,
  [SMALL_STATE(13196)] = 538623,
  [SMALL_STATE(13197)] = 538631,
  [SMALL_STATE(13198)] = 538639,
  [SMALL_STATE(13199)] = 538647,
  [SMALL_STATE(13200)] = 538655,
  [SMALL_STATE(13201)] = 538663,
  [SMALL_STATE(13202)] = 538671,
  [SMALL_STATE(13203)] = 538679,
  [SMALL_STATE(13204)] = 538687,
  [SMALL_STATE(13205)] = 538695,
  [SMALL_STATE(13206)] = 538703,
  [SMALL_STATE(13207)] = 538711,
  [SMALL_STATE(13208)] = 538719,
  [SMALL_STATE(13209)] = 538727,
  [SMALL_STATE(13210)] = 538735,
  [SMALL_STATE(13211)] = 538743,
  [SMALL_STATE(13212)] = 538751,
  [SMALL_STATE(13213)] = 538759,
  [SMALL_STATE(13214)] = 538767,
  [SMALL_STATE(13215)] = 538775,
  [SMALL_STATE(13216)] = 538783,
  [SMALL_STATE(13217)] = 538791,
  [SMALL_STATE(13218)] = 538799,
  [SMALL_STATE(13219)] = 538807,
  [SMALL_STATE(13220)] = 538815,
  [SMALL_STATE(13221)] = 538823,
  [SMALL_STATE(13222)] = 538831,
  [SMALL_STATE(13223)] = 538839,
  [SMALL_STATE(13224)] = 538847,
  [SMALL_STATE(13225)] = 538855,
  [SMALL_STATE(13226)] = 538863,
  [SMALL_STATE(13227)] = 538871,
  [SMALL_STATE(13228)] = 538879,
  [SMALL_STATE(13229)] = 538887,
  [SMALL_STATE(13230)] = 538895,
  [SMALL_STATE(13231)] = 538903,
  [SMALL_STATE(13232)] = 538911,
  [SMALL_STATE(13233)] = 538919,
  [SMALL_STATE(13234)] = 538927,
  [SMALL_STATE(13235)] = 538935,
  [SMALL_STATE(13236)] = 538943,
  [SMALL_STATE(13237)] = 538951,
  [SMALL_STATE(13238)] = 538959,
  [SMALL_STATE(13239)] = 538967,
  [SMALL_STATE(13240)] = 538975,
  [SMALL_STATE(13241)] = 538983,
  [SMALL_STATE(13242)] = 538991,
  [SMALL_STATE(13243)] = 538999,
  [SMALL_STATE(13244)] = 539007,
  [SMALL_STATE(13245)] = 539015,
  [SMALL_STATE(13246)] = 539023,
  [SMALL_STATE(13247)] = 539031,
  [SMALL_STATE(13248)] = 539039,
  [SMALL_STATE(13249)] = 539047,
  [SMALL_STATE(13250)] = 539055,
  [SMALL_STATE(13251)] = 539063,
  [SMALL_STATE(13252)] = 539071,
  [SMALL_STATE(13253)] = 539079,
  [SMALL_STATE(13254)] = 539087,
  [SMALL_STATE(13255)] = 539095,
  [SMALL_STATE(13256)] = 539103,
  [SMALL_STATE(13257)] = 539111,
  [SMALL_STATE(13258)] = 539119,
  [SMALL_STATE(13259)] = 539127,
  [SMALL_STATE(13260)] = 539135,
  [SMALL_STATE(13261)] = 539143,
  [SMALL_STATE(13262)] = 539151,
  [SMALL_STATE(13263)] = 539159,
  [SMALL_STATE(13264)] = 539167,
  [SMALL_STATE(13265)] = 539175,
  [SMALL_STATE(13266)] = 539183,
  [SMALL_STATE(13267)] = 539191,
  [SMALL_STATE(13268)] = 539199,
  [SMALL_STATE(13269)] = 539207,
  [SMALL_STATE(13270)] = 539215,
  [SMALL_STATE(13271)] = 539223,
  [SMALL_STATE(13272)] = 539231,
  [SMALL_STATE(13273)] = 539239,
  [SMALL_STATE(13274)] = 539247,
  [SMALL_STATE(13275)] = 539255,
  [SMALL_STATE(13276)] = 539263,
  [SMALL_STATE(13277)] = 539271,
  [SMALL_STATE(13278)] = 539279,
  [SMALL_STATE(13279)] = 539287,
  [SMALL_STATE(13280)] = 539295,
  [SMALL_STATE(13281)] = 539303,
  [SMALL_STATE(13282)] = 539311,
  [SMALL_STATE(13283)] = 539319,
  [SMALL_STATE(13284)] = 539327,
  [SMALL_STATE(13285)] = 539335,
  [SMALL_STATE(13286)] = 539343,
  [SMALL_STATE(13287)] = 539351,
  [SMALL_STATE(13288)] = 539359,
  [SMALL_STATE(13289)] = 539367,
  [SMALL_STATE(13290)] = 539375,
  [SMALL_STATE(13291)] = 539383,
  [SMALL_STATE(13292)] = 539391,
  [SMALL_STATE(13293)] = 539399,
  [SMALL_STATE(13294)] = 539407,
  [SMALL_STATE(13295)] = 539415,
  [SMALL_STATE(13296)] = 539423,
  [SMALL_STATE(13297)] = 539431,
  [SMALL_STATE(13298)] = 539439,
  [SMALL_STATE(13299)] = 539447,
  [SMALL_STATE(13300)] = 539455,
  [SMALL_STATE(13301)] = 539463,
  [SMALL_STATE(13302)] = 539471,
  [SMALL_STATE(13303)] = 539479,
  [SMALL_STATE(13304)] = 539487,
  [SMALL_STATE(13305)] = 539495,
  [SMALL_STATE(13306)] = 539503,
  [SMALL_STATE(13307)] = 539511,
  [SMALL_STATE(13308)] = 539519,
  [SMALL_STATE(13309)] = 539527,
  [SMALL_STATE(13310)] = 539535,
  [SMALL_STATE(13311)] = 539543,
  [SMALL_STATE(13312)] = 539551,
  [SMALL_STATE(13313)] = 539559,
  [SMALL_STATE(13314)] = 539567,
  [SMALL_STATE(13315)] = 539575,
  [SMALL_STATE(13316)] = 539583,
  [SMALL_STATE(13317)] = 539591,
  [SMALL_STATE(13318)] = 539599,
  [SMALL_STATE(13319)] = 539607,
  [SMALL_STATE(13320)] = 539615,
  [SMALL_STATE(13321)] = 539623,
  [SMALL_STATE(13322)] = 539631,
  [SMALL_STATE(13323)] = 539639,
  [SMALL_STATE(13324)] = 539647,
  [SMALL_STATE(13325)] = 539655,
  [SMALL_STATE(13326)] = 539663,
  [SMALL_STATE(13327)] = 539671,
  [SMALL_STATE(13328)] = 539679,
  [SMALL_STATE(13329)] = 539687,
  [SMALL_STATE(13330)] = 539695,
  [SMALL_STATE(13331)] = 539703,
  [SMALL_STATE(13332)] = 539711,
  [SMALL_STATE(13333)] = 539719,
  [SMALL_STATE(13334)] = 539727,
  [SMALL_STATE(13335)] = 539735,
  [SMALL_STATE(13336)] = 539743,
  [SMALL_STATE(13337)] = 539751,
  [SMALL_STATE(13338)] = 539759,
  [SMALL_STATE(13339)] = 539767,
  [SMALL_STATE(13340)] = 539775,
  [SMALL_STATE(13341)] = 539783,
  [SMALL_STATE(13342)] = 539791,
  [SMALL_STATE(13343)] = 539799,
  [SMALL_STATE(13344)] = 539807,
  [SMALL_STATE(13345)] = 539815,
  [SMALL_STATE(13346)] = 539823,
  [SMALL_STATE(13347)] = 539831,
  [SMALL_STATE(13348)] = 539839,
  [SMALL_STATE(13349)] = 539847,
  [SMALL_STATE(13350)] = 539855,
  [SMALL_STATE(13351)] = 539863,
  [SMALL_STATE(13352)] = 539871,
  [SMALL_STATE(13353)] = 539879,
  [SMALL_STATE(13354)] = 539887,
  [SMALL_STATE(13355)] = 539895,
  [SMALL_STATE(13356)] = 539903,
  [SMALL_STATE(13357)] = 539911,
  [SMALL_STATE(13358)] = 539919,
  [SMALL_STATE(13359)] = 539927,
  [SMALL_STATE(13360)] = 539935,
  [SMALL_STATE(13361)] = 539943,
  [SMALL_STATE(13362)] = 539951,
  [SMALL_STATE(13363)] = 539959,
  [SMALL_STATE(13364)] = 539967,
  [SMALL_STATE(13365)] = 539975,
  [SMALL_STATE(13366)] = 539983,
  [SMALL_STATE(13367)] = 539991,
  [SMALL_STATE(13368)] = 539999,
  [SMALL_STATE(13369)] = 540007,
  [SMALL_STATE(13370)] = 540015,
  [SMALL_STATE(13371)] = 540023,
  [SMALL_STATE(13372)] = 540031,
  [SMALL_STATE(13373)] = 540039,
  [SMALL_STATE(13374)] = 540047,
  [SMALL_STATE(13375)] = 540055,
  [SMALL_STATE(13376)] = 540063,
  [SMALL_STATE(13377)] = 540071,
  [SMALL_STATE(13378)] = 540079,
  [SMALL_STATE(13379)] = 540087,
  [SMALL_STATE(13380)] = 540095,
  [SMALL_STATE(13381)] = 540103,
  [SMALL_STATE(13382)] = 540111,
  [SMALL_STATE(13383)] = 540119,
  [SMALL_STATE(13384)] = 540127,
  [SMALL_STATE(13385)] = 540135,
  [SMALL_STATE(13386)] = 540143,
  [SMALL_STATE(13387)] = 540151,
  [SMALL_STATE(13388)] = 540159,
  [SMALL_STATE(13389)] = 540167,
  [SMALL_STATE(13390)] = 540175,
  [SMALL_STATE(13391)] = 540183,
  [SMALL_STATE(13392)] = 540191,
  [SMALL_STATE(13393)] = 540199,
  [SMALL_STATE(13394)] = 540207,
  [SMALL_STATE(13395)] = 540215,
  [SMALL_STATE(13396)] = 540223,
  [SMALL_STATE(13397)] = 540231,
  [SMALL_STATE(13398)] = 540239,
  [SMALL_STATE(13399)] = 540247,
  [SMALL_STATE(13400)] = 540255,
  [SMALL_STATE(13401)] = 540263,
  [SMALL_STATE(13402)] = 540271,
  [SMALL_STATE(13403)] = 540279,
  [SMALL_STATE(13404)] = 540287,
  [SMALL_STATE(13405)] = 540295,
  [SMALL_STATE(13406)] = 540303,
  [SMALL_STATE(13407)] = 540311,
  [SMALL_STATE(13408)] = 540319,
  [SMALL_STATE(13409)] = 540327,
  [SMALL_STATE(13410)] = 540335,
  [SMALL_STATE(13411)] = 540343,
  [SMALL_STATE(13412)] = 540351,
  [SMALL_STATE(13413)] = 540359,
  [SMALL_STATE(13414)] = 540367,
  [SMALL_STATE(13415)] = 540375,
  [SMALL_STATE(13416)] = 540383,
  [SMALL_STATE(13417)] = 540391,
  [SMALL_STATE(13418)] = 540399,
  [SMALL_STATE(13419)] = 540407,
  [SMALL_STATE(13420)] = 540415,
  [SMALL_STATE(13421)] = 540423,
  [SMALL_STATE(13422)] = 540431,
  [SMALL_STATE(13423)] = 540439,
  [SMALL_STATE(13424)] = 540447,
  [SMALL_STATE(13425)] = 540455,
  [SMALL_STATE(13426)] = 540463,
  [SMALL_STATE(13427)] = 540471,
  [SMALL_STATE(13428)] = 540479,
  [SMALL_STATE(13429)] = 540487,
  [SMALL_STATE(13430)] = 540495,
  [SMALL_STATE(13431)] = 540503,
  [SMALL_STATE(13432)] = 540511,
  [SMALL_STATE(13433)] = 540519,
  [SMALL_STATE(13434)] = 540527,
  [SMALL_STATE(13435)] = 540535,
  [SMALL_STATE(13436)] = 540543,
  [SMALL_STATE(13437)] = 540551,
  [SMALL_STATE(13438)] = 540559,
  [SMALL_STATE(13439)] = 540567,
  [SMALL_STATE(13440)] = 540575,
  [SMALL_STATE(13441)] = 540583,
  [SMALL_STATE(13442)] = 540591,
  [SMALL_STATE(13443)] = 540599,
  [SMALL_STATE(13444)] = 540607,
  [SMALL_STATE(13445)] = 540615,
  [SMALL_STATE(13446)] = 540623,
  [SMALL_STATE(13447)] = 540631,
  [SMALL_STATE(13448)] = 540639,
  [SMALL_STATE(13449)] = 540647,
  [SMALL_STATE(13450)] = 540655,
  [SMALL_STATE(13451)] = 540663,
  [SMALL_STATE(13452)] = 540671,
  [SMALL_STATE(13453)] = 540679,
  [SMALL_STATE(13454)] = 540687,
  [SMALL_STATE(13455)] = 540695,
  [SMALL_STATE(13456)] = 540703,
  [SMALL_STATE(13457)] = 540711,
  [SMALL_STATE(13458)] = 540719,
  [SMALL_STATE(13459)] = 540727,
  [SMALL_STATE(13460)] = 540735,
  [SMALL_STATE(13461)] = 540743,
  [SMALL_STATE(13462)] = 540751,
  [SMALL_STATE(13463)] = 540759,
  [SMALL_STATE(13464)] = 540767,
  [SMALL_STATE(13465)] = 540775,
  [SMALL_STATE(13466)] = 540783,
  [SMALL_STATE(13467)] = 540791,
  [SMALL_STATE(13468)] = 540799,
  [SMALL_STATE(13469)] = 540807,
  [SMALL_STATE(13470)] = 540815,
  [SMALL_STATE(13471)] = 540823,
  [SMALL_STATE(13472)] = 540831,
  [SMALL_STATE(13473)] = 540839,
  [SMALL_STATE(13474)] = 540847,
  [SMALL_STATE(13475)] = 540855,
  [SMALL_STATE(13476)] = 540863,
  [SMALL_STATE(13477)] = 540871,
  [SMALL_STATE(13478)] = 540879,
  [SMALL_STATE(13479)] = 540887,
  [SMALL_STATE(13480)] = 540895,
  [SMALL_STATE(13481)] = 540903,
  [SMALL_STATE(13482)] = 540911,
  [SMALL_STATE(13483)] = 540919,
  [SMALL_STATE(13484)] = 540927,
  [SMALL_STATE(13485)] = 540935,
  [SMALL_STATE(13486)] = 540943,
  [SMALL_STATE(13487)] = 540951,
  [SMALL_STATE(13488)] = 540959,
  [SMALL_STATE(13489)] = 540967,
  [SMALL_STATE(13490)] = 540975,
  [SMALL_STATE(13491)] = 540983,
  [SMALL_STATE(13492)] = 540991,
  [SMALL_STATE(13493)] = 540999,
  [SMALL_STATE(13494)] = 541007,
  [SMALL_STATE(13495)] = 541015,
  [SMALL_STATE(13496)] = 541023,
  [SMALL_STATE(13497)] = 541031,
  [SMALL_STATE(13498)] = 541039,
  [SMALL_STATE(13499)] = 541047,
  [SMALL_STATE(13500)] = 541055,
  [SMALL_STATE(13501)] = 541063,
  [SMALL_STATE(13502)] = 541071,
  [SMALL_STATE(13503)] = 541079,
  [SMALL_STATE(13504)] = 541087,
  [SMALL_STATE(13505)] = 541095,
  [SMALL_STATE(13506)] = 541103,
  [SMALL_STATE(13507)] = 541111,
  [SMALL_STATE(13508)] = 541119,
  [SMALL_STATE(13509)] = 541127,
  [SMALL_STATE(13510)] = 541135,
  [SMALL_STATE(13511)] = 541143,
  [SMALL_STATE(13512)] = 541151,
  [SMALL_STATE(13513)] = 541159,
  [SMALL_STATE(13514)] = 541167,
  [SMALL_STATE(13515)] = 541175,
  [SMALL_STATE(13516)] = 541183,
  [SMALL_STATE(13517)] = 541191,
  [SMALL_STATE(13518)] = 541199,
  [SMALL_STATE(13519)] = 541207,
  [SMALL_STATE(13520)] = 541215,
  [SMALL_STATE(13521)] = 541223,
  [SMALL_STATE(13522)] = 541231,
  [SMALL_STATE(13523)] = 541239,
  [SMALL_STATE(13524)] = 541247,
  [SMALL_STATE(13525)] = 541255,
  [SMALL_STATE(13526)] = 541263,
  [SMALL_STATE(13527)] = 541271,
  [SMALL_STATE(13528)] = 541279,
  [SMALL_STATE(13529)] = 541287,
  [SMALL_STATE(13530)] = 541295,
  [SMALL_STATE(13531)] = 541303,
  [SMALL_STATE(13532)] = 541311,
  [SMALL_STATE(13533)] = 541319,
  [SMALL_STATE(13534)] = 541327,
  [SMALL_STATE(13535)] = 541335,
  [SMALL_STATE(13536)] = 541343,
  [SMALL_STATE(13537)] = 541351,
  [SMALL_STATE(13538)] = 541359,
  [SMALL_STATE(13539)] = 541367,
  [SMALL_STATE(13540)] = 541375,
  [SMALL_STATE(13541)] = 541383,
  [SMALL_STATE(13542)] = 541391,
  [SMALL_STATE(13543)] = 541399,
  [SMALL_STATE(13544)] = 541407,
  [SMALL_STATE(13545)] = 541415,
  [SMALL_STATE(13546)] = 541423,
  [SMALL_STATE(13547)] = 541431,
  [SMALL_STATE(13548)] = 541439,
  [SMALL_STATE(13549)] = 541447,
  [SMALL_STATE(13550)] = 541455,
  [SMALL_STATE(13551)] = 541463,
  [SMALL_STATE(13552)] = 541471,
  [SMALL_STATE(13553)] = 541479,
  [SMALL_STATE(13554)] = 541487,
  [SMALL_STATE(13555)] = 541495,
  [SMALL_STATE(13556)] = 541503,
  [SMALL_STATE(13557)] = 541511,
  [SMALL_STATE(13558)] = 541519,
  [SMALL_STATE(13559)] = 541527,
  [SMALL_STATE(13560)] = 541535,
  [SMALL_STATE(13561)] = 541543,
  [SMALL_STATE(13562)] = 541551,
  [SMALL_STATE(13563)] = 541559,
  [SMALL_STATE(13564)] = 541567,
  [SMALL_STATE(13565)] = 541575,
  [SMALL_STATE(13566)] = 541583,
  [SMALL_STATE(13567)] = 541591,
  [SMALL_STATE(13568)] = 541599,
  [SMALL_STATE(13569)] = 541607,
  [SMALL_STATE(13570)] = 541615,
  [SMALL_STATE(13571)] = 541623,
  [SMALL_STATE(13572)] = 541631,
  [SMALL_STATE(13573)] = 541639,
  [SMALL_STATE(13574)] = 541647,
  [SMALL_STATE(13575)] = 541655,
  [SMALL_STATE(13576)] = 541663,
  [SMALL_STATE(13577)] = 541671,
  [SMALL_STATE(13578)] = 541679,
  [SMALL_STATE(13579)] = 541687,
  [SMALL_STATE(13580)] = 541695,
  [SMALL_STATE(13581)] = 541703,
  [SMALL_STATE(13582)] = 541711,
  [SMALL_STATE(13583)] = 541719,
  [SMALL_STATE(13584)] = 541727,
  [SMALL_STATE(13585)] = 541735,
  [SMALL_STATE(13586)] = 541743,
  [SMALL_STATE(13587)] = 541751,
  [SMALL_STATE(13588)] = 541759,
  [SMALL_STATE(13589)] = 541767,
  [SMALL_STATE(13590)] = 541775,
  [SMALL_STATE(13591)] = 541783,
  [SMALL_STATE(13592)] = 541791,
  [SMALL_STATE(13593)] = 541799,
  [SMALL_STATE(13594)] = 541807,
  [SMALL_STATE(13595)] = 541815,
  [SMALL_STATE(13596)] = 541823,
  [SMALL_STATE(13597)] = 541831,
  [SMALL_STATE(13598)] = 541839,
  [SMALL_STATE(13599)] = 541847,
  [SMALL_STATE(13600)] = 541855,
  [SMALL_STATE(13601)] = 541863,
  [SMALL_STATE(13602)] = 541871,
  [SMALL_STATE(13603)] = 541879,
  [SMALL_STATE(13604)] = 541887,
  [SMALL_STATE(13605)] = 541895,
  [SMALL_STATE(13606)] = 541903,
  [SMALL_STATE(13607)] = 541911,
  [SMALL_STATE(13608)] = 541919,
  [SMALL_STATE(13609)] = 541927,
  [SMALL_STATE(13610)] = 541935,
  [SMALL_STATE(13611)] = 541943,
  [SMALL_STATE(13612)] = 541951,
  [SMALL_STATE(13613)] = 541959,
  [SMALL_STATE(13614)] = 541967,
  [SMALL_STATE(13615)] = 541975,
  [SMALL_STATE(13616)] = 541983,
  [SMALL_STATE(13617)] = 541991,
  [SMALL_STATE(13618)] = 541999,
  [SMALL_STATE(13619)] = 542007,
  [SMALL_STATE(13620)] = 542015,
  [SMALL_STATE(13621)] = 542023,
  [SMALL_STATE(13622)] = 542031,
  [SMALL_STATE(13623)] = 542039,
  [SMALL_STATE(13624)] = 542047,
  [SMALL_STATE(13625)] = 542055,
  [SMALL_STATE(13626)] = 542063,
  [SMALL_STATE(13627)] = 542071,
  [SMALL_STATE(13628)] = 542079,
  [SMALL_STATE(13629)] = 542087,
  [SMALL_STATE(13630)] = 542095,
  [SMALL_STATE(13631)] = 542103,
  [SMALL_STATE(13632)] = 542111,
  [SMALL_STATE(13633)] = 542119,
  [SMALL_STATE(13634)] = 542127,
  [SMALL_STATE(13635)] = 542135,
  [SMALL_STATE(13636)] = 542143,
  [SMALL_STATE(13637)] = 542151,
  [SMALL_STATE(13638)] = 542159,
  [SMALL_STATE(13639)] = 542167,
  [SMALL_STATE(13640)] = 542175,
  [SMALL_STATE(13641)] = 542183,
  [SMALL_STATE(13642)] = 542191,
  [SMALL_STATE(13643)] = 542199,
  [SMALL_STATE(13644)] = 542207,
  [SMALL_STATE(13645)] = 542215,
  [SMALL_STATE(13646)] = 542223,
  [SMALL_STATE(13647)] = 542231,
  [SMALL_STATE(13648)] = 542239,
  [SMALL_STATE(13649)] = 542247,
  [SMALL_STATE(13650)] = 542255,
  [SMALL_STATE(13651)] = 542263,
  [SMALL_STATE(13652)] = 542271,
  [SMALL_STATE(13653)] = 542279,
  [SMALL_STATE(13654)] = 542287,
  [SMALL_STATE(13655)] = 542295,
  [SMALL_STATE(13656)] = 542303,
  [SMALL_STATE(13657)] = 542311,
  [SMALL_STATE(13658)] = 542319,
  [SMALL_STATE(13659)] = 542327,
  [SMALL_STATE(13660)] = 542335,
  [SMALL_STATE(13661)] = 542343,
  [SMALL_STATE(13662)] = 542351,
  [SMALL_STATE(13663)] = 542359,
  [SMALL_STATE(13664)] = 542367,
  [SMALL_STATE(13665)] = 542375,
  [SMALL_STATE(13666)] = 542383,
  [SMALL_STATE(13667)] = 542391,
  [SMALL_STATE(13668)] = 542399,
  [SMALL_STATE(13669)] = 542407,
  [SMALL_STATE(13670)] = 542415,
  [SMALL_STATE(13671)] = 542423,
  [SMALL_STATE(13672)] = 542431,
  [SMALL_STATE(13673)] = 542439,
  [SMALL_STATE(13674)] = 542447,
  [SMALL_STATE(13675)] = 542455,
  [SMALL_STATE(13676)] = 542463,
  [SMALL_STATE(13677)] = 542471,
  [SMALL_STATE(13678)] = 542479,
  [SMALL_STATE(13679)] = 542487,
  [SMALL_STATE(13680)] = 542495,
  [SMALL_STATE(13681)] = 542503,
  [SMALL_STATE(13682)] = 542511,
  [SMALL_STATE(13683)] = 542519,
  [SMALL_STATE(13684)] = 542527,
  [SMALL_STATE(13685)] = 542535,
  [SMALL_STATE(13686)] = 542543,
  [SMALL_STATE(13687)] = 542551,
  [SMALL_STATE(13688)] = 542559,
  [SMALL_STATE(13689)] = 542567,
  [SMALL_STATE(13690)] = 542575,
  [SMALL_STATE(13691)] = 542583,
  [SMALL_STATE(13692)] = 542591,
  [SMALL_STATE(13693)] = 542599,
  [SMALL_STATE(13694)] = 542607,
  [SMALL_STATE(13695)] = 542615,
  [SMALL_STATE(13696)] = 542623,
  [SMALL_STATE(13697)] = 542631,
  [SMALL_STATE(13698)] = 542639,
  [SMALL_STATE(13699)] = 542647,
  [SMALL_STATE(13700)] = 542655,
  [SMALL_STATE(13701)] = 542663,
  [SMALL_STATE(13702)] = 542671,
  [SMALL_STATE(13703)] = 542679,
  [SMALL_STATE(13704)] = 542687,
  [SMALL_STATE(13705)] = 542695,
  [SMALL_STATE(13706)] = 542703,
  [SMALL_STATE(13707)] = 542711,
  [SMALL_STATE(13708)] = 542719,
  [SMALL_STATE(13709)] = 542727,
  [SMALL_STATE(13710)] = 542735,
  [SMALL_STATE(13711)] = 542743,
  [SMALL_STATE(13712)] = 542751,
  [SMALL_STATE(13713)] = 542759,
  [SMALL_STATE(13714)] = 542767,
  [SMALL_STATE(13715)] = 542775,
  [SMALL_STATE(13716)] = 542783,
  [SMALL_STATE(13717)] = 542791,
  [SMALL_STATE(13718)] = 542799,
  [SMALL_STATE(13719)] = 542807,
  [SMALL_STATE(13720)] = 542815,
  [SMALL_STATE(13721)] = 542823,
  [SMALL_STATE(13722)] = 542831,
  [SMALL_STATE(13723)] = 542839,
  [SMALL_STATE(13724)] = 542847,
  [SMALL_STATE(13725)] = 542855,
  [SMALL_STATE(13726)] = 542863,
  [SMALL_STATE(13727)] = 542871,
  [SMALL_STATE(13728)] = 542879,
  [SMALL_STATE(13729)] = 542887,
  [SMALL_STATE(13730)] = 542895,
  [SMALL_STATE(13731)] = 542903,
  [SMALL_STATE(13732)] = 542911,
  [SMALL_STATE(13733)] = 542919,
  [SMALL_STATE(13734)] = 542927,
  [SMALL_STATE(13735)] = 542935,
  [SMALL_STATE(13736)] = 542943,
  [SMALL_STATE(13737)] = 542951,
  [SMALL_STATE(13738)] = 542959,
  [SMALL_STATE(13739)] = 542967,
  [SMALL_STATE(13740)] = 542975,
  [SMALL_STATE(13741)] = 542983,
  [SMALL_STATE(13742)] = 542991,
  [SMALL_STATE(13743)] = 542999,
  [SMALL_STATE(13744)] = 543007,
  [SMALL_STATE(13745)] = 543015,
  [SMALL_STATE(13746)] = 543023,
  [SMALL_STATE(13747)] = 543031,
  [SMALL_STATE(13748)] = 543039,
  [SMALL_STATE(13749)] = 543047,
  [SMALL_STATE(13750)] = 543055,
  [SMALL_STATE(13751)] = 543063,
  [SMALL_STATE(13752)] = 543071,
  [SMALL_STATE(13753)] = 543079,
  [SMALL_STATE(13754)] = 543087,
  [SMALL_STATE(13755)] = 543095,
  [SMALL_STATE(13756)] = 543103,
  [SMALL_STATE(13757)] = 543111,
  [SMALL_STATE(13758)] = 543119,
  [SMALL_STATE(13759)] = 543127,
  [SMALL_STATE(13760)] = 543135,
  [SMALL_STATE(13761)] = 543143,
  [SMALL_STATE(13762)] = 543151,
  [SMALL_STATE(13763)] = 543159,
  [SMALL_STATE(13764)] = 543167,
  [SMALL_STATE(13765)] = 543175,
  [SMALL_STATE(13766)] = 543183,
  [SMALL_STATE(13767)] = 543191,
  [SMALL_STATE(13768)] = 543199,
  [SMALL_STATE(13769)] = 543207,
  [SMALL_STATE(13770)] = 543215,
  [SMALL_STATE(13771)] = 543223,
  [SMALL_STATE(13772)] = 543231,
  [SMALL_STATE(13773)] = 543239,
  [SMALL_STATE(13774)] = 543247,
  [SMALL_STATE(13775)] = 543255,
  [SMALL_STATE(13776)] = 543263,
  [SMALL_STATE(13777)] = 543271,
  [SMALL_STATE(13778)] = 543279,
  [SMALL_STATE(13779)] = 543287,
  [SMALL_STATE(13780)] = 543295,
  [SMALL_STATE(13781)] = 543303,
  [SMALL_STATE(13782)] = 543311,
  [SMALL_STATE(13783)] = 543319,
  [SMALL_STATE(13784)] = 543327,
  [SMALL_STATE(13785)] = 543335,
  [SMALL_STATE(13786)] = 543343,
  [SMALL_STATE(13787)] = 543351,
  [SMALL_STATE(13788)] = 543359,
  [SMALL_STATE(13789)] = 543367,
  [SMALL_STATE(13790)] = 543375,
  [SMALL_STATE(13791)] = 543383,
  [SMALL_STATE(13792)] = 543391,
  [SMALL_STATE(13793)] = 543399,
  [SMALL_STATE(13794)] = 543407,
  [SMALL_STATE(13795)] = 543415,
  [SMALL_STATE(13796)] = 543423,
  [SMALL_STATE(13797)] = 543431,
  [SMALL_STATE(13798)] = 543439,
  [SMALL_STATE(13799)] = 543447,
  [SMALL_STATE(13800)] = 543455,
  [SMALL_STATE(13801)] = 543463,
  [SMALL_STATE(13802)] = 543471,
  [SMALL_STATE(13803)] = 543479,
  [SMALL_STATE(13804)] = 543487,
  [SMALL_STATE(13805)] = 543495,
  [SMALL_STATE(13806)] = 543503,
  [SMALL_STATE(13807)] = 543511,
  [SMALL_STATE(13808)] = 543519,
  [SMALL_STATE(13809)] = 543527,
  [SMALL_STATE(13810)] = 543535,
  [SMALL_STATE(13811)] = 543543,
  [SMALL_STATE(13812)] = 543551,
  [SMALL_STATE(13813)] = 543559,
  [SMALL_STATE(13814)] = 543567,
  [SMALL_STATE(13815)] = 543575,
  [SMALL_STATE(13816)] = 543583,
  [SMALL_STATE(13817)] = 543591,
  [SMALL_STATE(13818)] = 543599,
  [SMALL_STATE(13819)] = 543607,
  [SMALL_STATE(13820)] = 543615,
  [SMALL_STATE(13821)] = 543623,
  [SMALL_STATE(13822)] = 543631,
  [SMALL_STATE(13823)] = 543639,
  [SMALL_STATE(13824)] = 543647,
  [SMALL_STATE(13825)] = 543655,
  [SMALL_STATE(13826)] = 543663,
  [SMALL_STATE(13827)] = 543671,
  [SMALL_STATE(13828)] = 543679,
  [SMALL_STATE(13829)] = 543687,
  [SMALL_STATE(13830)] = 543695,
  [SMALL_STATE(13831)] = 543703,
  [SMALL_STATE(13832)] = 543711,
  [SMALL_STATE(13833)] = 543719,
  [SMALL_STATE(13834)] = 543727,
  [SMALL_STATE(13835)] = 543735,
  [SMALL_STATE(13836)] = 543743,
  [SMALL_STATE(13837)] = 543751,
  [SMALL_STATE(13838)] = 543759,
  [SMALL_STATE(13839)] = 543767,
  [SMALL_STATE(13840)] = 543775,
  [SMALL_STATE(13841)] = 543783,
  [SMALL_STATE(13842)] = 543791,
  [SMALL_STATE(13843)] = 543799,
  [SMALL_STATE(13844)] = 543807,
  [SMALL_STATE(13845)] = 543815,
  [SMALL_STATE(13846)] = 543823,
  [SMALL_STATE(13847)] = 543831,
  [SMALL_STATE(13848)] = 543839,
  [SMALL_STATE(13849)] = 543847,
  [SMALL_STATE(13850)] = 543855,
  [SMALL_STATE(13851)] = 543863,
  [SMALL_STATE(13852)] = 543871,
  [SMALL_STATE(13853)] = 543879,
  [SMALL_STATE(13854)] = 543887,
  [SMALL_STATE(13855)] = 543895,
  [SMALL_STATE(13856)] = 543903,
  [SMALL_STATE(13857)] = 543911,
  [SMALL_STATE(13858)] = 543919,
  [SMALL_STATE(13859)] = 543927,
  [SMALL_STATE(13860)] = 543935,
  [SMALL_STATE(13861)] = 543943,
  [SMALL_STATE(13862)] = 543951,
  [SMALL_STATE(13863)] = 543959,
  [SMALL_STATE(13864)] = 543967,
  [SMALL_STATE(13865)] = 543975,
  [SMALL_STATE(13866)] = 543983,
  [SMALL_STATE(13867)] = 543991,
  [SMALL_STATE(13868)] = 543999,
  [SMALL_STATE(13869)] = 544007,
  [SMALL_STATE(13870)] = 544015,
  [SMALL_STATE(13871)] = 544023,
  [SMALL_STATE(13872)] = 544031,
  [SMALL_STATE(13873)] = 544039,
  [SMALL_STATE(13874)] = 544047,
  [SMALL_STATE(13875)] = 544055,
  [SMALL_STATE(13876)] = 544063,
  [SMALL_STATE(13877)] = 544071,
  [SMALL_STATE(13878)] = 544079,
  [SMALL_STATE(13879)] = 544087,
  [SMALL_STATE(13880)] = 544095,
  [SMALL_STATE(13881)] = 544103,
  [SMALL_STATE(13882)] = 544111,
  [SMALL_STATE(13883)] = 544119,
  [SMALL_STATE(13884)] = 544127,
  [SMALL_STATE(13885)] = 544135,
  [SMALL_STATE(13886)] = 544143,
  [SMALL_STATE(13887)] = 544151,
  [SMALL_STATE(13888)] = 544159,
  [SMALL_STATE(13889)] = 544167,
  [SMALL_STATE(13890)] = 544175,
  [SMALL_STATE(13891)] = 544183,
  [SMALL_STATE(13892)] = 544191,
  [SMALL_STATE(13893)] = 544199,
  [SMALL_STATE(13894)] = 544207,
  [SMALL_STATE(13895)] = 544215,
  [SMALL_STATE(13896)] = 544223,
  [SMALL_STATE(13897)] = 544231,
  [SMALL_STATE(13898)] = 544239,
  [SMALL_STATE(13899)] = 544247,
  [SMALL_STATE(13900)] = 544255,
  [SMALL_STATE(13901)] = 544263,
  [SMALL_STATE(13902)] = 544271,
  [SMALL_STATE(13903)] = 544279,
  [SMALL_STATE(13904)] = 544287,
  [SMALL_STATE(13905)] = 544295,
  [SMALL_STATE(13906)] = 544303,
  [SMALL_STATE(13907)] = 544311,
  [SMALL_STATE(13908)] = 544319,
  [SMALL_STATE(13909)] = 544327,
  [SMALL_STATE(13910)] = 544335,
  [SMALL_STATE(13911)] = 544343,
  [SMALL_STATE(13912)] = 544351,
  [SMALL_STATE(13913)] = 544359,
  [SMALL_STATE(13914)] = 544367,
  [SMALL_STATE(13915)] = 544375,
  [SMALL_STATE(13916)] = 544383,
  [SMALL_STATE(13917)] = 544391,
  [SMALL_STATE(13918)] = 544399,
  [SMALL_STATE(13919)] = 544407,
  [SMALL_STATE(13920)] = 544415,
  [SMALL_STATE(13921)] = 544423,
  [SMALL_STATE(13922)] = 544431,
  [SMALL_STATE(13923)] = 544439,
  [SMALL_STATE(13924)] = 544447,
  [SMALL_STATE(13925)] = 544455,
  [SMALL_STATE(13926)] = 544463,
  [SMALL_STATE(13927)] = 544471,
  [SMALL_STATE(13928)] = 544479,
  [SMALL_STATE(13929)] = 544487,
  [SMALL_STATE(13930)] = 544495,
  [SMALL_STATE(13931)] = 544503,
  [SMALL_STATE(13932)] = 544511,
  [SMALL_STATE(13933)] = 544519,
  [SMALL_STATE(13934)] = 544527,
  [SMALL_STATE(13935)] = 544535,
  [SMALL_STATE(13936)] = 544543,
  [SMALL_STATE(13937)] = 544551,
  [SMALL_STATE(13938)] = 544559,
  [SMALL_STATE(13939)] = 544567,
  [SMALL_STATE(13940)] = 544575,
  [SMALL_STATE(13941)] = 544583,
  [SMALL_STATE(13942)] = 544591,
  [SMALL_STATE(13943)] = 544599,
  [SMALL_STATE(13944)] = 544607,
  [SMALL_STATE(13945)] = 544615,
  [SMALL_STATE(13946)] = 544623,
  [SMALL_STATE(13947)] = 544631,
  [SMALL_STATE(13948)] = 544639,
  [SMALL_STATE(13949)] = 544647,
  [SMALL_STATE(13950)] = 544655,
  [SMALL_STATE(13951)] = 544663,
  [SMALL_STATE(13952)] = 544671,
  [SMALL_STATE(13953)] = 544679,
  [SMALL_STATE(13954)] = 544687,
  [SMALL_STATE(13955)] = 544695,
  [SMALL_STATE(13956)] = 544703,
  [SMALL_STATE(13957)] = 544711,
  [SMALL_STATE(13958)] = 544719,
  [SMALL_STATE(13959)] = 544727,
  [SMALL_STATE(13960)] = 544735,
  [SMALL_STATE(13961)] = 544743,
  [SMALL_STATE(13962)] = 544751,
  [SMALL_STATE(13963)] = 544759,
  [SMALL_STATE(13964)] = 544767,
  [SMALL_STATE(13965)] = 544775,
  [SMALL_STATE(13966)] = 544783,
  [SMALL_STATE(13967)] = 544791,
  [SMALL_STATE(13968)] = 544799,
  [SMALL_STATE(13969)] = 544807,
  [SMALL_STATE(13970)] = 544815,
  [SMALL_STATE(13971)] = 544823,
  [SMALL_STATE(13972)] = 544831,
  [SMALL_STATE(13973)] = 544839,
  [SMALL_STATE(13974)] = 544847,
  [SMALL_STATE(13975)] = 544855,
  [SMALL_STATE(13976)] = 544863,
  [SMALL_STATE(13977)] = 544871,
  [SMALL_STATE(13978)] = 544879,
  [SMALL_STATE(13979)] = 544887,
  [SMALL_STATE(13980)] = 544895,
  [SMALL_STATE(13981)] = 544903,
  [SMALL_STATE(13982)] = 544911,
  [SMALL_STATE(13983)] = 544919,
  [SMALL_STATE(13984)] = 544927,
  [SMALL_STATE(13985)] = 544935,
  [SMALL_STATE(13986)] = 544943,
  [SMALL_STATE(13987)] = 544951,
  [SMALL_STATE(13988)] = 544959,
  [SMALL_STATE(13989)] = 544967,
  [SMALL_STATE(13990)] = 544975,
  [SMALL_STATE(13991)] = 544983,
  [SMALL_STATE(13992)] = 544991,
  [SMALL_STATE(13993)] = 544999,
  [SMALL_STATE(13994)] = 545007,
  [SMALL_STATE(13995)] = 545015,
  [SMALL_STATE(13996)] = 545023,
  [SMALL_STATE(13997)] = 545031,
  [SMALL_STATE(13998)] = 545039,
  [SMALL_STATE(13999)] = 545047,
  [SMALL_STATE(14000)] = 545055,
  [SMALL_STATE(14001)] = 545063,
  [SMALL_STATE(14002)] = 545071,
  [SMALL_STATE(14003)] = 545079,
  [SMALL_STATE(14004)] = 545087,
  [SMALL_STATE(14005)] = 545095,
  [SMALL_STATE(14006)] = 545103,
  [SMALL_STATE(14007)] = 545111,
  [SMALL_STATE(14008)] = 545119,
  [SMALL_STATE(14009)] = 545127,
  [SMALL_STATE(14010)] = 545135,
  [SMALL_STATE(14011)] = 545143,
  [SMALL_STATE(14012)] = 545151,
  [SMALL_STATE(14013)] = 545159,
  [SMALL_STATE(14014)] = 545167,
  [SMALL_STATE(14015)] = 545175,
  [SMALL_STATE(14016)] = 545183,
  [SMALL_STATE(14017)] = 545191,
  [SMALL_STATE(14018)] = 545199,
  [SMALL_STATE(14019)] = 545207,
  [SMALL_STATE(14020)] = 545215,
  [SMALL_STATE(14021)] = 545223,
  [SMALL_STATE(14022)] = 545231,
  [SMALL_STATE(14023)] = 545239,
  [SMALL_STATE(14024)] = 545247,
  [SMALL_STATE(14025)] = 545255,
  [SMALL_STATE(14026)] = 545263,
  [SMALL_STATE(14027)] = 545271,
  [SMALL_STATE(14028)] = 545279,
  [SMALL_STATE(14029)] = 545287,
  [SMALL_STATE(14030)] = 545295,
  [SMALL_STATE(14031)] = 545303,
  [SMALL_STATE(14032)] = 545311,
  [SMALL_STATE(14033)] = 545319,
  [SMALL_STATE(14034)] = 545327,
  [SMALL_STATE(14035)] = 545335,
  [SMALL_STATE(14036)] = 545343,
  [SMALL_STATE(14037)] = 545351,
  [SMALL_STATE(14038)] = 545359,
  [SMALL_STATE(14039)] = 545367,
  [SMALL_STATE(14040)] = 545375,
  [SMALL_STATE(14041)] = 545383,
  [SMALL_STATE(14042)] = 545391,
  [SMALL_STATE(14043)] = 545399,
  [SMALL_STATE(14044)] = 545407,
  [SMALL_STATE(14045)] = 545415,
  [SMALL_STATE(14046)] = 545423,
  [SMALL_STATE(14047)] = 545431,
  [SMALL_STATE(14048)] = 545439,
  [SMALL_STATE(14049)] = 545447,
  [SMALL_STATE(14050)] = 545455,
  [SMALL_STATE(14051)] = 545463,
  [SMALL_STATE(14052)] = 545471,
  [SMALL_STATE(14053)] = 545479,
  [SMALL_STATE(14054)] = 545487,
  [SMALL_STATE(14055)] = 545495,
  [SMALL_STATE(14056)] = 545503,
  [SMALL_STATE(14057)] = 545511,
  [SMALL_STATE(14058)] = 545519,
  [SMALL_STATE(14059)] = 545527,
  [SMALL_STATE(14060)] = 545535,
  [SMALL_STATE(14061)] = 545543,
  [SMALL_STATE(14062)] = 545551,
  [SMALL_STATE(14063)] = 545559,
  [SMALL_STATE(14064)] = 545567,
  [SMALL_STATE(14065)] = 545575,
  [SMALL_STATE(14066)] = 545583,
  [SMALL_STATE(14067)] = 545591,
  [SMALL_STATE(14068)] = 545599,
  [SMALL_STATE(14069)] = 545607,
  [SMALL_STATE(14070)] = 545615,
  [SMALL_STATE(14071)] = 545623,
  [SMALL_STATE(14072)] = 545631,
  [SMALL_STATE(14073)] = 545639,
  [SMALL_STATE(14074)] = 545647,
  [SMALL_STATE(14075)] = 545655,
  [SMALL_STATE(14076)] = 545663,
  [SMALL_STATE(14077)] = 545671,
  [SMALL_STATE(14078)] = 545679,
  [SMALL_STATE(14079)] = 545687,
  [SMALL_STATE(14080)] = 545695,
  [SMALL_STATE(14081)] = 545703,
  [SMALL_STATE(14082)] = 545711,
  [SMALL_STATE(14083)] = 545719,
  [SMALL_STATE(14084)] = 545727,
  [SMALL_STATE(14085)] = 545735,
  [SMALL_STATE(14086)] = 545743,
  [SMALL_STATE(14087)] = 545751,
  [SMALL_STATE(14088)] = 545759,
  [SMALL_STATE(14089)] = 545767,
  [SMALL_STATE(14090)] = 545775,
  [SMALL_STATE(14091)] = 545783,
  [SMALL_STATE(14092)] = 545791,
  [SMALL_STATE(14093)] = 545799,
  [SMALL_STATE(14094)] = 545807,
  [SMALL_STATE(14095)] = 545815,
  [SMALL_STATE(14096)] = 545823,
  [SMALL_STATE(14097)] = 545831,
  [SMALL_STATE(14098)] = 545839,
  [SMALL_STATE(14099)] = 545847,
  [SMALL_STATE(14100)] = 545855,
  [SMALL_STATE(14101)] = 545863,
  [SMALL_STATE(14102)] = 545871,
  [SMALL_STATE(14103)] = 545879,
  [SMALL_STATE(14104)] = 545887,
  [SMALL_STATE(14105)] = 545895,
  [SMALL_STATE(14106)] = 545903,
  [SMALL_STATE(14107)] = 545911,
  [SMALL_STATE(14108)] = 545919,
  [SMALL_STATE(14109)] = 545927,
  [SMALL_STATE(14110)] = 545935,
  [SMALL_STATE(14111)] = 545943,
  [SMALL_STATE(14112)] = 545951,
  [SMALL_STATE(14113)] = 545959,
  [SMALL_STATE(14114)] = 545967,
  [SMALL_STATE(14115)] = 545975,
  [SMALL_STATE(14116)] = 545983,
  [SMALL_STATE(14117)] = 545991,
  [SMALL_STATE(14118)] = 545999,
  [SMALL_STATE(14119)] = 546007,
  [SMALL_STATE(14120)] = 546015,
  [SMALL_STATE(14121)] = 546023,
  [SMALL_STATE(14122)] = 546031,
  [SMALL_STATE(14123)] = 546039,
  [SMALL_STATE(14124)] = 546047,
  [SMALL_STATE(14125)] = 546055,
  [SMALL_STATE(14126)] = 546063,
  [SMALL_STATE(14127)] = 546071,
  [SMALL_STATE(14128)] = 546079,
  [SMALL_STATE(14129)] = 546087,
  [SMALL_STATE(14130)] = 546095,
  [SMALL_STATE(14131)] = 546103,
  [SMALL_STATE(14132)] = 546111,
  [SMALL_STATE(14133)] = 546119,
  [SMALL_STATE(14134)] = 546127,
  [SMALL_STATE(14135)] = 546135,
  [SMALL_STATE(14136)] = 546143,
  [SMALL_STATE(14137)] = 546151,
  [SMALL_STATE(14138)] = 546159,
  [SMALL_STATE(14139)] = 546167,
  [SMALL_STATE(14140)] = 546175,
  [SMALL_STATE(14141)] = 546183,
  [SMALL_STATE(14142)] = 546191,
  [SMALL_STATE(14143)] = 546199,
  [SMALL_STATE(14144)] = 546207,
  [SMALL_STATE(14145)] = 546215,
  [SMALL_STATE(14146)] = 546223,
  [SMALL_STATE(14147)] = 546231,
  [SMALL_STATE(14148)] = 546239,
  [SMALL_STATE(14149)] = 546247,
  [SMALL_STATE(14150)] = 546255,
  [SMALL_STATE(14151)] = 546263,
  [SMALL_STATE(14152)] = 546271,
  [SMALL_STATE(14153)] = 546279,
  [SMALL_STATE(14154)] = 546287,
  [SMALL_STATE(14155)] = 546295,
  [SMALL_STATE(14156)] = 546303,
  [SMALL_STATE(14157)] = 546311,
  [SMALL_STATE(14158)] = 546319,
  [SMALL_STATE(14159)] = 546327,
  [SMALL_STATE(14160)] = 546335,
  [SMALL_STATE(14161)] = 546343,
  [SMALL_STATE(14162)] = 546351,
  [SMALL_STATE(14163)] = 546359,
  [SMALL_STATE(14164)] = 546367,
  [SMALL_STATE(14165)] = 546375,
  [SMALL_STATE(14166)] = 546383,
  [SMALL_STATE(14167)] = 546391,
  [SMALL_STATE(14168)] = 546399,
  [SMALL_STATE(14169)] = 546407,
  [SMALL_STATE(14170)] = 546415,
  [SMALL_STATE(14171)] = 546423,
  [SMALL_STATE(14172)] = 546431,
  [SMALL_STATE(14173)] = 546439,
  [SMALL_STATE(14174)] = 546447,
  [SMALL_STATE(14175)] = 546455,
  [SMALL_STATE(14176)] = 546463,
  [SMALL_STATE(14177)] = 546471,
  [SMALL_STATE(14178)] = 546479,
  [SMALL_STATE(14179)] = 546487,
  [SMALL_STATE(14180)] = 546495,
  [SMALL_STATE(14181)] = 546503,
  [SMALL_STATE(14182)] = 546511,
  [SMALL_STATE(14183)] = 546519,
  [SMALL_STATE(14184)] = 546527,
  [SMALL_STATE(14185)] = 546535,
  [SMALL_STATE(14186)] = 546543,
  [SMALL_STATE(14187)] = 546551,
  [SMALL_STATE(14188)] = 546559,
  [SMALL_STATE(14189)] = 546567,
  [SMALL_STATE(14190)] = 546575,
  [SMALL_STATE(14191)] = 546583,
  [SMALL_STATE(14192)] = 546591,
  [SMALL_STATE(14193)] = 546599,
  [SMALL_STATE(14194)] = 546607,
  [SMALL_STATE(14195)] = 546615,
  [SMALL_STATE(14196)] = 546623,
  [SMALL_STATE(14197)] = 546631,
  [SMALL_STATE(14198)] = 546639,
  [SMALL_STATE(14199)] = 546647,
  [SMALL_STATE(14200)] = 546655,
  [SMALL_STATE(14201)] = 546663,
  [SMALL_STATE(14202)] = 546671,
  [SMALL_STATE(14203)] = 546679,
  [SMALL_STATE(14204)] = 546687,
  [SMALL_STATE(14205)] = 546695,
  [SMALL_STATE(14206)] = 546703,
  [SMALL_STATE(14207)] = 546711,
  [SMALL_STATE(14208)] = 546719,
  [SMALL_STATE(14209)] = 546727,
  [SMALL_STATE(14210)] = 546735,
  [SMALL_STATE(14211)] = 546743,
  [SMALL_STATE(14212)] = 546751,
  [SMALL_STATE(14213)] = 546759,
  [SMALL_STATE(14214)] = 546767,
  [SMALL_STATE(14215)] = 546775,
  [SMALL_STATE(14216)] = 546783,
  [SMALL_STATE(14217)] = 546791,
  [SMALL_STATE(14218)] = 546799,
  [SMALL_STATE(14219)] = 546807,
  [SMALL_STATE(14220)] = 546815,
  [SMALL_STATE(14221)] = 546823,
  [SMALL_STATE(14222)] = 546831,
  [SMALL_STATE(14223)] = 546839,
  [SMALL_STATE(14224)] = 546847,
  [SMALL_STATE(14225)] = 546855,
  [SMALL_STATE(14226)] = 546863,
  [SMALL_STATE(14227)] = 546871,
  [SMALL_STATE(14228)] = 546879,
  [SMALL_STATE(14229)] = 546887,
  [SMALL_STATE(14230)] = 546895,
  [SMALL_STATE(14231)] = 546903,
  [SMALL_STATE(14232)] = 546911,
  [SMALL_STATE(14233)] = 546919,
  [SMALL_STATE(14234)] = 546927,
  [SMALL_STATE(14235)] = 546935,
  [SMALL_STATE(14236)] = 546943,
  [SMALL_STATE(14237)] = 546951,
  [SMALL_STATE(14238)] = 546959,
  [SMALL_STATE(14239)] = 546967,
  [SMALL_STATE(14240)] = 546975,
  [SMALL_STATE(14241)] = 546983,
  [SMALL_STATE(14242)] = 546991,
  [SMALL_STATE(14243)] = 546999,
  [SMALL_STATE(14244)] = 547007,
  [SMALL_STATE(14245)] = 547015,
  [SMALL_STATE(14246)] = 547023,
  [SMALL_STATE(14247)] = 547031,
  [SMALL_STATE(14248)] = 547039,
  [SMALL_STATE(14249)] = 547047,
  [SMALL_STATE(14250)] = 547055,
  [SMALL_STATE(14251)] = 547063,
  [SMALL_STATE(14252)] = 547071,
  [SMALL_STATE(14253)] = 547079,
  [SMALL_STATE(14254)] = 547087,
  [SMALL_STATE(14255)] = 547095,
  [SMALL_STATE(14256)] = 547103,
  [SMALL_STATE(14257)] = 547111,
  [SMALL_STATE(14258)] = 547119,
  [SMALL_STATE(14259)] = 547127,
  [SMALL_STATE(14260)] = 547135,
  [SMALL_STATE(14261)] = 547143,
  [SMALL_STATE(14262)] = 547151,
  [SMALL_STATE(14263)] = 547159,
  [SMALL_STATE(14264)] = 547167,
  [SMALL_STATE(14265)] = 547175,
  [SMALL_STATE(14266)] = 547183,
  [SMALL_STATE(14267)] = 547191,
  [SMALL_STATE(14268)] = 547199,
  [SMALL_STATE(14269)] = 547207,
  [SMALL_STATE(14270)] = 547215,
  [SMALL_STATE(14271)] = 547223,
  [SMALL_STATE(14272)] = 547231,
  [SMALL_STATE(14273)] = 547239,
  [SMALL_STATE(14274)] = 547247,
  [SMALL_STATE(14275)] = 547255,
  [SMALL_STATE(14276)] = 547263,
  [SMALL_STATE(14277)] = 547271,
  [SMALL_STATE(14278)] = 547279,
  [SMALL_STATE(14279)] = 547287,
  [SMALL_STATE(14280)] = 547295,
  [SMALL_STATE(14281)] = 547303,
  [SMALL_STATE(14282)] = 547311,
  [SMALL_STATE(14283)] = 547319,
  [SMALL_STATE(14284)] = 547327,
  [SMALL_STATE(14285)] = 547335,
  [SMALL_STATE(14286)] = 547343,
  [SMALL_STATE(14287)] = 547351,
  [SMALL_STATE(14288)] = 547359,
  [SMALL_STATE(14289)] = 547367,
  [SMALL_STATE(14290)] = 547375,
  [SMALL_STATE(14291)] = 547383,
  [SMALL_STATE(14292)] = 547391,
  [SMALL_STATE(14293)] = 547399,
  [SMALL_STATE(14294)] = 547407,
  [SMALL_STATE(14295)] = 547415,
  [SMALL_STATE(14296)] = 547423,
  [SMALL_STATE(14297)] = 547431,
  [SMALL_STATE(14298)] = 547439,
  [SMALL_STATE(14299)] = 547447,
  [SMALL_STATE(14300)] = 547455,
  [SMALL_STATE(14301)] = 547463,
  [SMALL_STATE(14302)] = 547471,
  [SMALL_STATE(14303)] = 547479,
  [SMALL_STATE(14304)] = 547487,
  [SMALL_STATE(14305)] = 547495,
  [SMALL_STATE(14306)] = 547503,
  [SMALL_STATE(14307)] = 547511,
  [SMALL_STATE(14308)] = 547519,
  [SMALL_STATE(14309)] = 547527,
  [SMALL_STATE(14310)] = 547535,
  [SMALL_STATE(14311)] = 547543,
  [SMALL_STATE(14312)] = 547551,
  [SMALL_STATE(14313)] = 547559,
  [SMALL_STATE(14314)] = 547567,
  [SMALL_STATE(14315)] = 547575,
  [SMALL_STATE(14316)] = 547583,
  [SMALL_STATE(14317)] = 547591,
  [SMALL_STATE(14318)] = 547599,
  [SMALL_STATE(14319)] = 547607,
  [SMALL_STATE(14320)] = 547615,
  [SMALL_STATE(14321)] = 547623,
  [SMALL_STATE(14322)] = 547631,
  [SMALL_STATE(14323)] = 547639,
  [SMALL_STATE(14324)] = 547647,
  [SMALL_STATE(14325)] = 547655,
  [SMALL_STATE(14326)] = 547663,
  [SMALL_STATE(14327)] = 547671,
  [SMALL_STATE(14328)] = 547679,
  [SMALL_STATE(14329)] = 547687,
  [SMALL_STATE(14330)] = 547695,
  [SMALL_STATE(14331)] = 547703,
  [SMALL_STATE(14332)] = 547711,
  [SMALL_STATE(14333)] = 547719,
  [SMALL_STATE(14334)] = 547727,
  [SMALL_STATE(14335)] = 547735,
  [SMALL_STATE(14336)] = 547743,
  [SMALL_STATE(14337)] = 547751,
  [SMALL_STATE(14338)] = 547759,
  [SMALL_STATE(14339)] = 547767,
  [SMALL_STATE(14340)] = 547775,
  [SMALL_STATE(14341)] = 547783,
  [SMALL_STATE(14342)] = 547791,
  [SMALL_STATE(14343)] = 547799,
  [SMALL_STATE(14344)] = 547807,
  [SMALL_STATE(14345)] = 547815,
  [SMALL_STATE(14346)] = 547823,
  [SMALL_STATE(14347)] = 547831,
  [SMALL_STATE(14348)] = 547839,
  [SMALL_STATE(14349)] = 547847,
  [SMALL_STATE(14350)] = 547855,
  [SMALL_STATE(14351)] = 547863,
  [SMALL_STATE(14352)] = 547871,
  [SMALL_STATE(14353)] = 547879,
  [SMALL_STATE(14354)] = 547887,
  [SMALL_STATE(14355)] = 547895,
  [SMALL_STATE(14356)] = 547903,
  [SMALL_STATE(14357)] = 547911,
  [SMALL_STATE(14358)] = 547919,
  [SMALL_STATE(14359)] = 547927,
  [SMALL_STATE(14360)] = 547935,
  [SMALL_STATE(14361)] = 547943,
  [SMALL_STATE(14362)] = 547951,
  [SMALL_STATE(14363)] = 547959,
  [SMALL_STATE(14364)] = 547967,
  [SMALL_STATE(14365)] = 547975,
  [SMALL_STATE(14366)] = 547983,
  [SMALL_STATE(14367)] = 547991,
  [SMALL_STATE(14368)] = 547999,
  [SMALL_STATE(14369)] = 548007,
  [SMALL_STATE(14370)] = 548015,
  [SMALL_STATE(14371)] = 548023,
  [SMALL_STATE(14372)] = 548031,
  [SMALL_STATE(14373)] = 548039,
  [SMALL_STATE(14374)] = 548047,
  [SMALL_STATE(14375)] = 548055,
  [SMALL_STATE(14376)] = 548063,
  [SMALL_STATE(14377)] = 548071,
  [SMALL_STATE(14378)] = 548079,
  [SMALL_STATE(14379)] = 548087,
  [SMALL_STATE(14380)] = 548095,
  [SMALL_STATE(14381)] = 548103,
  [SMALL_STATE(14382)] = 548111,
  [SMALL_STATE(14383)] = 548119,
  [SMALL_STATE(14384)] = 548127,
  [SMALL_STATE(14385)] = 548135,
  [SMALL_STATE(14386)] = 548143,
  [SMALL_STATE(14387)] = 548151,
  [SMALL_STATE(14388)] = 548159,
  [SMALL_STATE(14389)] = 548167,
  [SMALL_STATE(14390)] = 548175,
  [SMALL_STATE(14391)] = 548183,
  [SMALL_STATE(14392)] = 548191,
  [SMALL_STATE(14393)] = 548199,
  [SMALL_STATE(14394)] = 548207,
  [SMALL_STATE(14395)] = 548215,
  [SMALL_STATE(14396)] = 548223,
  [SMALL_STATE(14397)] = 548231,
  [SMALL_STATE(14398)] = 548239,
  [SMALL_STATE(14399)] = 548247,
  [SMALL_STATE(14400)] = 548255,
  [SMALL_STATE(14401)] = 548263,
  [SMALL_STATE(14402)] = 548271,
  [SMALL_STATE(14403)] = 548279,
  [SMALL_STATE(14404)] = 548287,
  [SMALL_STATE(14405)] = 548295,
  [SMALL_STATE(14406)] = 548303,
  [SMALL_STATE(14407)] = 548311,
  [SMALL_STATE(14408)] = 548319,
  [SMALL_STATE(14409)] = 548327,
  [SMALL_STATE(14410)] = 548335,
  [SMALL_STATE(14411)] = 548343,
  [SMALL_STATE(14412)] = 548351,
  [SMALL_STATE(14413)] = 548359,
  [SMALL_STATE(14414)] = 548367,
  [SMALL_STATE(14415)] = 548375,
  [SMALL_STATE(14416)] = 548383,
  [SMALL_STATE(14417)] = 548391,
  [SMALL_STATE(14418)] = 548399,
  [SMALL_STATE(14419)] = 548407,
  [SMALL_STATE(14420)] = 548415,
  [SMALL_STATE(14421)] = 548423,
  [SMALL_STATE(14422)] = 548431,
  [SMALL_STATE(14423)] = 548439,
  [SMALL_STATE(14424)] = 548447,
  [SMALL_STATE(14425)] = 548455,
  [SMALL_STATE(14426)] = 548463,
  [SMALL_STATE(14427)] = 548471,
  [SMALL_STATE(14428)] = 548479,
  [SMALL_STATE(14429)] = 548487,
  [SMALL_STATE(14430)] = 548495,
  [SMALL_STATE(14431)] = 548503,
  [SMALL_STATE(14432)] = 548511,
  [SMALL_STATE(14433)] = 548519,
  [SMALL_STATE(14434)] = 548527,
  [SMALL_STATE(14435)] = 548535,
  [SMALL_STATE(14436)] = 548543,
  [SMALL_STATE(14437)] = 548551,
  [SMALL_STATE(14438)] = 548559,
  [SMALL_STATE(14439)] = 548567,
  [SMALL_STATE(14440)] = 548575,
  [SMALL_STATE(14441)] = 548583,
  [SMALL_STATE(14442)] = 548591,
  [SMALL_STATE(14443)] = 548599,
  [SMALL_STATE(14444)] = 548607,
  [SMALL_STATE(14445)] = 548615,
  [SMALL_STATE(14446)] = 548623,
  [SMALL_STATE(14447)] = 548631,
  [SMALL_STATE(14448)] = 548639,
  [SMALL_STATE(14449)] = 548647,
  [SMALL_STATE(14450)] = 548655,
  [SMALL_STATE(14451)] = 548663,
  [SMALL_STATE(14452)] = 548671,
  [SMALL_STATE(14453)] = 548679,
  [SMALL_STATE(14454)] = 548687,
  [SMALL_STATE(14455)] = 548695,
  [SMALL_STATE(14456)] = 548703,
  [SMALL_STATE(14457)] = 548711,
  [SMALL_STATE(14458)] = 548719,
  [SMALL_STATE(14459)] = 548727,
  [SMALL_STATE(14460)] = 548735,
  [SMALL_STATE(14461)] = 548743,
  [SMALL_STATE(14462)] = 548751,
  [SMALL_STATE(14463)] = 548759,
  [SMALL_STATE(14464)] = 548767,
  [SMALL_STATE(14465)] = 548775,
  [SMALL_STATE(14466)] = 548783,
  [SMALL_STATE(14467)] = 548791,
  [SMALL_STATE(14468)] = 548799,
  [SMALL_STATE(14469)] = 548807,
  [SMALL_STATE(14470)] = 548815,
  [SMALL_STATE(14471)] = 548823,
  [SMALL_STATE(14472)] = 548831,
  [SMALL_STATE(14473)] = 548839,
  [SMALL_STATE(14474)] = 548847,
  [SMALL_STATE(14475)] = 548855,
  [SMALL_STATE(14476)] = 548863,
  [SMALL_STATE(14477)] = 548871,
  [SMALL_STATE(14478)] = 548879,
  [SMALL_STATE(14479)] = 548887,
  [SMALL_STATE(14480)] = 548895,
  [SMALL_STATE(14481)] = 548903,
  [SMALL_STATE(14482)] = 548911,
  [SMALL_STATE(14483)] = 548919,
  [SMALL_STATE(14484)] = 548927,
  [SMALL_STATE(14485)] = 548935,
  [SMALL_STATE(14486)] = 548943,
  [SMALL_STATE(14487)] = 548951,
  [SMALL_STATE(14488)] = 548959,
  [SMALL_STATE(14489)] = 548967,
  [SMALL_STATE(14490)] = 548975,
  [SMALL_STATE(14491)] = 548983,
  [SMALL_STATE(14492)] = 548991,
  [SMALL_STATE(14493)] = 548999,
  [SMALL_STATE(14494)] = 549007,
  [SMALL_STATE(14495)] = 549015,
  [SMALL_STATE(14496)] = 549023,
  [SMALL_STATE(14497)] = 549031,
  [SMALL_STATE(14498)] = 549039,
  [SMALL_STATE(14499)] = 549047,
  [SMALL_STATE(14500)] = 549055,
  [SMALL_STATE(14501)] = 549063,
  [SMALL_STATE(14502)] = 549071,
  [SMALL_STATE(14503)] = 549079,
  [SMALL_STATE(14504)] = 549087,
  [SMALL_STATE(14505)] = 549095,
  [SMALL_STATE(14506)] = 549103,
  [SMALL_STATE(14507)] = 549111,
  [SMALL_STATE(14508)] = 549119,
  [SMALL_STATE(14509)] = 549127,
  [SMALL_STATE(14510)] = 549135,
  [SMALL_STATE(14511)] = 549143,
  [SMALL_STATE(14512)] = 549151,
  [SMALL_STATE(14513)] = 549159,
  [SMALL_STATE(14514)] = 549167,
  [SMALL_STATE(14515)] = 549175,
  [SMALL_STATE(14516)] = 549183,
  [SMALL_STATE(14517)] = 549191,
  [SMALL_STATE(14518)] = 549199,
  [SMALL_STATE(14519)] = 549207,
  [SMALL_STATE(14520)] = 549215,
  [SMALL_STATE(14521)] = 549223,
  [SMALL_STATE(14522)] = 549231,
  [SMALL_STATE(14523)] = 549239,
  [SMALL_STATE(14524)] = 549247,
  [SMALL_STATE(14525)] = 549255,
  [SMALL_STATE(14526)] = 549263,
  [SMALL_STATE(14527)] = 549271,
  [SMALL_STATE(14528)] = 549279,
  [SMALL_STATE(14529)] = 549287,
  [SMALL_STATE(14530)] = 549295,
  [SMALL_STATE(14531)] = 549303,
  [SMALL_STATE(14532)] = 549311,
  [SMALL_STATE(14533)] = 549319,
  [SMALL_STATE(14534)] = 549327,
  [SMALL_STATE(14535)] = 549335,
  [SMALL_STATE(14536)] = 549343,
  [SMALL_STATE(14537)] = 549351,
  [SMALL_STATE(14538)] = 549359,
  [SMALL_STATE(14539)] = 549367,
  [SMALL_STATE(14540)] = 549375,
  [SMALL_STATE(14541)] = 549383,
  [SMALL_STATE(14542)] = 549391,
  [SMALL_STATE(14543)] = 549399,
  [SMALL_STATE(14544)] = 549407,
  [SMALL_STATE(14545)] = 549415,
  [SMALL_STATE(14546)] = 549423,
  [SMALL_STATE(14547)] = 549431,
  [SMALL_STATE(14548)] = 549439,
  [SMALL_STATE(14549)] = 549447,
  [SMALL_STATE(14550)] = 549455,
  [SMALL_STATE(14551)] = 549463,
  [SMALL_STATE(14552)] = 549471,
  [SMALL_STATE(14553)] = 549479,
  [SMALL_STATE(14554)] = 549487,
  [SMALL_STATE(14555)] = 549495,
  [SMALL_STATE(14556)] = 549503,
  [SMALL_STATE(14557)] = 549511,
  [SMALL_STATE(14558)] = 549519,
  [SMALL_STATE(14559)] = 549527,
  [SMALL_STATE(14560)] = 549535,
  [SMALL_STATE(14561)] = 549543,
  [SMALL_STATE(14562)] = 549551,
  [SMALL_STATE(14563)] = 549559,
  [SMALL_STATE(14564)] = 549567,
  [SMALL_STATE(14565)] = 549575,
  [SMALL_STATE(14566)] = 549583,
  [SMALL_STATE(14567)] = 549591,
  [SMALL_STATE(14568)] = 549599,
  [SMALL_STATE(14569)] = 549607,
  [SMALL_STATE(14570)] = 549615,
  [SMALL_STATE(14571)] = 549623,
  [SMALL_STATE(14572)] = 549631,
  [SMALL_STATE(14573)] = 549639,
  [SMALL_STATE(14574)] = 549647,
  [SMALL_STATE(14575)] = 549655,
  [SMALL_STATE(14576)] = 549663,
  [SMALL_STATE(14577)] = 549671,
  [SMALL_STATE(14578)] = 549679,
  [SMALL_STATE(14579)] = 549687,
  [SMALL_STATE(14580)] = 549695,
  [SMALL_STATE(14581)] = 549703,
  [SMALL_STATE(14582)] = 549711,
  [SMALL_STATE(14583)] = 549719,
  [SMALL_STATE(14584)] = 549727,
  [SMALL_STATE(14585)] = 549735,
  [SMALL_STATE(14586)] = 549743,
  [SMALL_STATE(14587)] = 549751,
  [SMALL_STATE(14588)] = 549759,
  [SMALL_STATE(14589)] = 549767,
  [SMALL_STATE(14590)] = 549775,
  [SMALL_STATE(14591)] = 549783,
  [SMALL_STATE(14592)] = 549791,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9405),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7580),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14498),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14472),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11340),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8056),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7893),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9226),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11344),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14459),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [55] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_reference, 1, 0, 6),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6838),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7120),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13395),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_reference, 1, 0, 6),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9536),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12011),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11729),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6435),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5486),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5852),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6326),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6325),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6324),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5123),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5124),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6027),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6022),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5132),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6013),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6010),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6004),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13644),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5999),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6323),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11818),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11869),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11657),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6434),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6860),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3382),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13747),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6850),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13331),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7583),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13855),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4925),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6801),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4846),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5750),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5749),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5748),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4904),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4909),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4910),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4912),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5093),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4913),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4901),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4745),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5344),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13807),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5348),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4781),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4780),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5746),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6830),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13965),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3677),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4091),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4465),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4467),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4470),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4067),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2949),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4062),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4060),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13951),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4484),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6800),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3625),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13919),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3880),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3868),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3654),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13973),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6782),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13871),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3617),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4333),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4332),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4843),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6820),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5126),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4797),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4796),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4798),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5041),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5054),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4679),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4985),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5007),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5002),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13935),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5035),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5360),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4965),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6817),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4801),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4966),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5622),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5621),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5620),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4872),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4870),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5428),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4866),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5433),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5094),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13903),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5435),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4778),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5587),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6791),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13823),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6856),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3776),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3773),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13788),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4599),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5720),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5471),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5721),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5845),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5844),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6182),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6181),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5285),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5286),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5288),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5289),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5839),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5034),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5835),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5834),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5832),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5831),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13769),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5830),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5022),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5019),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5134),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5135),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4793),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4795),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4791),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4788),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4786),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4678),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5006),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4919),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13691),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4661),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5153),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4282),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6573),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13719),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6983),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6780),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6984),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7069),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7117),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6939),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6938),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6934),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7055),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7052),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7041),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7036),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6999),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7068),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13887),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7067),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6879),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6880),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7112),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6808),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3666),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13839),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [1351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quote_string, 1, 0, 0),
  [1353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quote_string, 1, 0, 0),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quote_string, 2, 0, 0),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quote_string, 2, 0, 0),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0),
  [1367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal_string, 1, 0, 0),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal_string, 1, 0, 0),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14125),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11500),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11561),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13601),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12532),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11756),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11423),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [1404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(447),
  [1407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(9405),
  [1410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7580),
  [1413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7499),
  [1416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7318),
  [1419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(14498),
  [1422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7319),
  [1425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6633),
  [1428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7692),
  [1431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(14472),
  [1434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [1437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7538),
  [1440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(8347),
  [1443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(11340),
  [1446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(8056),
  [1449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(89),
  [1452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7893),
  [1455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(9226),
  [1458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(11344),
  [1461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(8190),
  [1464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(14459),
  [1467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(8026),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14511),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13984),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7579),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11804),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9059),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8605),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11594),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13292),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11738),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(447),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(9405),
  [1522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7580),
  [1525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7499),
  [1528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7318),
  [1531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(14498),
  [1534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7319),
  [1537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(6633),
  [1540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7692),
  [1543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(14472),
  [1546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [1549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7538),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0),
  [1554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(8347),
  [1557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(11340),
  [1560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(8056),
  [1563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7893),
  [1566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(9226),
  [1569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1757),
  [1572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(11344),
  [1575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(8190),
  [1578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(14459),
  [1581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(8026),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11413),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6902),
  [1594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(447),
  [1597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(9405),
  [1600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7580),
  [1603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7499),
  [1606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7318),
  [1609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(14498),
  [1612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7319),
  [1615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(6633),
  [1618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7692),
  [1621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(14472),
  [1624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [1627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7538),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0),
  [1632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(8347),
  [1635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(11340),
  [1638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(8056),
  [1641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(7893),
  [1644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(9226),
  [1647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(11344),
  [1650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(8190),
  [1653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(14459),
  [1656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_transaction_repeat1, 2, 0, 0), SHIFT_REPEAT(8026),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(117),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column, 1, 0, 0),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12352),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8110),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6803),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8434),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7814),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12299),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12296),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column, 1, 0, 0),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8051),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8375),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7752),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13502),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13428),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9353),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14563),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8997),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9151),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [1746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column, 1, 0, 13),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column, 1, 0, 13),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9801),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6807),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8342),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8537),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_timestamp, 1, 0, 0),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13687),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13687),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13684),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 1, 0, 0),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 1, 0, 0),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14045),
  [1794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_time, 1, 0, 0),
  [1796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_time, 1, 0, 0),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13686),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_mediumint, 1, 0, 0),
  [1802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_mediumint, 1, 0, 0),
  [1804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_int, 1, 0, 0),
  [1806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_int, 1, 0, 0),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 1, 0, 0),
  [1810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 1, 0, 0),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13676),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 1, 0, 0),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 1, 0, 0),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13670),
  [1828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 1, 0, 0),
  [1830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 1, 0, 0),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13681),
  [1838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argmode, 1, 0, 0),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argmode, 1, 0, 0),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_timestamp, 4, 0, 114),
  [1846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_time, 4, 0, 114),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_time, 4, 0, 114),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 2, 0, 0),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 2, 0, 0),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14070),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 1, 0, 0),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 1, 0, 0),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13682),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_tinyint, 1, 0, 0),
  [1874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_tinyint, 1, 0, 0),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_smallint, 1, 0, 0),
  [1878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_smallint, 1, 0, 0),
  [1880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 1, 0, 0),
  [1882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 1, 0, 0),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13679),
  [1890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1, 0, 0),
  [1892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1, 0, 0),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13713),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_real, 1, 0, 0),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_real, 1, 0, 0),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_bigint, 1, 0, 0),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_bigint, 1, 0, 0),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 6, 0, 176),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 6, 0, 176),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 4, 0, 114),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 4, 0, 114),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 7, 0, 201),
  [1926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 7, 0, 201),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 6, 0, 176),
  [1934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 6, 0, 176),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 4, 0, 114),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 4, 0, 114),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit, 1, 0, 0),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit, 1, 0, 0),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13753),
  [1956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argmode, 2, 0, 0),
  [1958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argmode, 2, 0, 0),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_char, 1, 0, 0),
  [1962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_char, 1, 0, 0),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 4, 0, 114),
  [1968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 4, 0, 114),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14069),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 4, 0, 114),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 4, 0, 114),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 4, 0, 114),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 4, 0, 114),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datetimeoffset, 1, 0, 0),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datetimeoffset, 1, 0, 0),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13688),
  [2000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_reference, 3, 0, 22),
  [2002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_reference, 3, 0, 22),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 5, 0, 114),
  [2006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 5, 0, 114),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 8, 0, 201),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 8, 0, 201),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 5, 0, 114),
  [2018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 5, 0, 114),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_varchar, 2, 0, 0),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_varchar, 2, 0, 0),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 2, 0, 0),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 2, 0, 0),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 3, 0, 0),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 3, 0, 0),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 5, 0, 114),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 5, 0, 114),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73),
  [2046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73),
  [2048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8962),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 2, 0, 0),
  [2053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 2, 0, 0),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14068),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varchar, 1, 0, 0),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varchar, 1, 0, 0),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13651),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14086),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 2, 0, 0),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 2, 0, 0),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13561),
  [2071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 1, 0, 0),
  [2073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 1, 0, 0),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13669),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 2, 0, 0),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 2, 0, 0),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13558),
  [2083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 1, 0, 0),
  [2085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 1, 0, 0),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13749),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varbinary, 1, 0, 0),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varbinary, 1, 0, 0),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13748),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13557),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 2, 0, 0),
  [2101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 2, 0, 0),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13556),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 2, 0, 0),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 2, 0, 0),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13555),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 7, 0, 176),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 7, 0, 176),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 5, 0, 114),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 5, 0, 114),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 1, 0, 0),
  [2127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decimal, 1, 0, 0),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13741),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_numeric, 1, 0, 0),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_numeric, 1, 0, 0),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13732),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit, 2, 0, 0),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit, 2, 0, 0),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13554),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 5, 0, 114),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 5, 0, 114),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 7, 0, 176),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 7, 0, 176),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nvarchar, 1, 0, 0),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nvarchar, 1, 0, 0),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13567),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_varchar, 1, 0, 0),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_varchar, 1, 0, 0),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nchar, 1, 0, 0),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nchar, 1, 0, 0),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13711),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit, 5, 0, 145),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit, 5, 0, 145),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 4, 0, 0),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 4, 0, 0),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_time, 2, 0, 0),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_time, 2, 0, 0),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_timestamp, 2, 0, 0),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_timestamp, 2, 0, 0),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 6, 0, 114),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 6, 0, 114),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 6, 0, 114),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 6, 0, 114),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 5, 0, 144),
  [2203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 5, 0, 144),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 5, 0, 144),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 5, 0, 144),
  [2209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 5, 0, 144),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 5, 0, 144),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 4, 0, 115),
  [2215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 4, 0, 115),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 6, 0, 114),
  [2219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 6, 0, 114),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 6, 0, 114),
  [2223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 6, 0, 114),
  [2225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 7, 0, 201),
  [2227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 7, 0, 201),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 5, 0, 144),
  [2231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 5, 0, 144),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 6, 0, 114),
  [2235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 6, 0, 114),
  [2237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_datetimeoffset, 4, 0, 114),
  [2239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_datetimeoffset, 4, 0, 114),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_bigserial, 1, 0, 0),
  [2243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_bigserial, 1, 0, 0),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_serial, 1, 0, 0),
  [2247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_serial, 1, 0, 0),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__include_time_zone, 3, 0, 0),
  [2251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__include_time_zone, 3, 0, 0),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_numeric, 6, 0, 176),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_numeric, 6, 0, 176),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_smallserial, 1, 0, 0),
  [2259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_smallserial, 1, 0, 0),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 6, 0, 176),
  [2263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decimal, 6, 0, 176),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 5, 0, 144),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 5, 0, 144),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nvarchar, 4, 0, 114),
  [2271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nvarchar, 4, 0, 114),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nchar, 4, 0, 114),
  [2275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nchar, 4, 0, 114),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 4, 0, 113),
  [2279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 4, 0, 113),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 5, 0, 147),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 5, 0, 147),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_numeric, 4, 0, 113),
  [2287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_numeric, 4, 0, 113),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 4, 0, 113),
  [2291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decimal, 4, 0, 113),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_time, 5, 0, 114),
  [2295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_time, 5, 0, 114),
  [2297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_timestamp, 5, 0, 114),
  [2299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_timestamp, 5, 0, 114),
  [2301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 3, 0, 0),
  [2303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 3, 0, 0),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tinyint, 3, 0, 0),
  [2307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tinyint, 3, 0, 0),
  [2309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_smallint, 3, 0, 0),
  [2311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_smallint, 3, 0, 0),
  [2313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mediumint, 3, 0, 0),
  [2315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mediumint, 3, 0, 0),
  [2317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 3, 0, 0),
  [2319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 3, 0, 0),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigint, 3, 0, 0),
  [2323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigint, 3, 0, 0),
  [2325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 9, 0, 201),
  [2327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 9, 0, 201),
  [2329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varbinary, 4, 0, 113),
  [2331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varbinary, 4, 0, 113),
  [2333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 8, 0, 176),
  [2335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 8, 0, 176),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 8, 0, 176),
  [2339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 8, 0, 176),
  [2341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double, 8, 0, 218),
  [2343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double, 8, 0, 218),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 4, 0, 113),
  [2347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 4, 0, 113),
  [2349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varchar, 4, 0, 114),
  [2351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varchar, 4, 0, 114),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit, 4, 0, 113),
  [2355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit, 4, 0, 113),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 4, 0, 114),
  [2359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 4, 0, 114),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(285),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 2, 0, 0),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 2, 0, 0),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 1, 0, 38),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_size_definition_repeat1, 1, 0, 38),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_size_definition, 3, 0, 112),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_size_definition, 3, 0, 112),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 2, 0, 21),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 2, 0, 21),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_size_definition, 2, 0, 72),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_size_definition, 2, 0, 72),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_size_definition, 2, 0, 0),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_size_definition, 2, 0, 0),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_between_expression, 5, 0, 71),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_between_expression, 5, 0, 71),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10357),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6601),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13922),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 9),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 9),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14344),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11597),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8347),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13588),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9363),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11519),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5353),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11598),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11598),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8572),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13900),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5200),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_between_expression, 6, 0, 110),
  [2491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_between_expression, 6, 0, 110),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 6, 0, 67),
  [2495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 6, 0, 67),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13365),
  [2499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 4, 0, 36),
  [2501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 4, 0, 36),
  [2503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 6, 0, 103),
  [2505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 6, 0, 103),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 6, 0, 104),
  [2509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 6, 0, 104),
  [2511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 6, 0, 36),
  [2513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 6, 0, 36),
  [2515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 6, 0, 105),
  [2517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 6, 0, 105),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 3, 0, 0),
  [2521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 3, 0, 0),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 8, 0, 175),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 8, 0, 175),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 143),
  [2529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 143),
  [2531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 9, 0, 175),
  [2533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 9, 0, 175),
  [2535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 104),
  [2537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 104),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 5, 0, 69),
  [2541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 5, 0, 69),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 5, 0, 36),
  [2545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 5, 0, 36),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 142),
  [2549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 142),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 67),
  [2553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 67),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 5, 0, 67),
  [2557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 5, 0, 67),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 141),
  [2561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 141),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 8, 0, 143),
  [2565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 8, 0, 143),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 8, 0, 141),
  [2569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 8, 0, 141),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5112),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5358),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5113),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5115),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5117),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5118),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5142),
  [2613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(345),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5318),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5127),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5296),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5441),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5210),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5392),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5397),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5259),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5336),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5111),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5164),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5357),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5150),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5171),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5320),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5425),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5424),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5188),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5208),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5281),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5404),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5097),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5100),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5410),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5197),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5450),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5446),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5154),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5095),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5162),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 8, 0, 142),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 8, 0, 142),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 10, 0, 175),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 10, 0, 175),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 4, 0, 0),
  [2732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 4, 0, 0),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 103),
  [2736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 103),
  [2738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_filter_expression, 4, 0, 0),
  [2740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_filter_expression, 4, 0, 0),
  [2742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 9, 0, 143),
  [2744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 9, 0, 143),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 8, 0, 67),
  [2748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 8, 0, 67),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 36),
  [2752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 36),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 7, 0, 105),
  [2756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 7, 0, 105),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 9, 0, 141),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 9, 0, 141),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 8, 0, 104),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 8, 0, 104),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation, 6, 0, 69),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation, 6, 0, 69),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 21),
  [2772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 21),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13873),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14285),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12856),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12856),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13035),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13034),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subquery, 3, 0, 0),
  [2796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subquery, 3, 0, 0),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [2800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_field, 1, 0, 6),
  [2804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_field, 1, 0, 6),
  [2806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_reference, 1, 0, 6), SHIFT(9536),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13791),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14425),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11781),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8686),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11999),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11784),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11784),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11101),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [2881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14433),
  [2887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11360),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9266),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11362),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11363),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11363),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [2931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14449),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11979),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [2941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9014),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11896),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11879),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11879),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12862),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12861),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12851),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11549),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14012),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8667),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14288),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [3046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [3072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14452),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [3086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11884),
  [3090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4863),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8982),
  [3094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11887),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11774),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11774),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12863),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12859),
  [3138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12860),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bit_string, 2, 0, 0),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bit_string, 2, 0, 0),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9545),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9633),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9612),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10954),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [3178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bit_string, 1, 0, 0),
  [3180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bit_string, 1, 0, 0),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11016),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11044),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10366),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8589),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9458),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_size_definition, 1, 0, 38),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_size_definition, 1, 0, 38),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11068),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11109),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10988),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11127),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11162),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11216),
  [3244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8589),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11188),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14287),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9659),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8716),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [3279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(660),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12846),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [3294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(671),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9639),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11198),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12874),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12875),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 5, 0, 0),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12873),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12848),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8666),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12847),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14289),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 4, 0, 79),
  [3364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [3366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12872),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12852),
  [3380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 7, 0, 75),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14286),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 8, 0, 202),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12849),
  [3390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 6, 0, 0),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 8, 0, 116),
  [3394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(737),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 9, 0, 150),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 7, 0, 0),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12853),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12850),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12855),
  [3409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8840),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12871),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 5, 0, 122),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_join, 6, 0, 39),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 6, 0, 153),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_size_definition, 1, 0, 0),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_size_definition, 1, 0, 0),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 7, 0, 155),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12876),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 9, 0, 219),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12865),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12864),
  [3448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_constraint, 2, 0, 0),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_constraint, 2, 0, 0),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_specification, 5, 0, 0),
  [3462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_window_specification, 5, 0, 0),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14437),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6762),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11942),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11961),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11961),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 10, 0, 0),
  [3496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 10, 0, 0),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_field, 3, 0, 15),
  [3504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_field, 3, 0, 15),
  [3506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 5, 0, 0),
  [3508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 5, 0, 0),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 5),
  [3512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 5),
  [3514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__integer, 2, 0, 0),
  [3516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__integer, 2, 0, 0),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_cast, 3, 0, 20),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_cast, 3, 0, 20),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decimal_number, 2, 0, 0),
  [3524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__decimal_number, 2, 0, 0),
  [3526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14464),
  [3528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [3530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6829),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [3534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11836),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6189),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11289),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11289),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_function, 3, 0, 0),
  [3560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_window_function, 3, 0, 0),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__integer, 1, 0, 0),
  [3564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__integer, 1, 0, 0),
  [3566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [3568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [3570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_casting, 2, 0, 0),
  [3572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_casting, 2, 0, 0),
  [3574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4, 0, 0),
  [3576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4, 0, 0),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, 0, 0),
  [3580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, 0, 0),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_field, 5, 0, 66),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_field, 5, 0, 66),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2, 0, 0),
  [3588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2, 0, 0),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interval, 2, 0, 0),
  [3592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interval, 2, 0, 0),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 9, 0, 0),
  [3596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 9, 0, 0),
  [3598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exists, 2, 0, 0),
  [3600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exists, 2, 0, 0),
  [3602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_specification, 3, 0, 0),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_window_specification, 3, 0, 0),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 0),
  [3612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, 0, 0),
  [3614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 7, 0, 0),
  [3616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 7, 0, 0),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, 0, 111),
  [3620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, 0, 111),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, 0, 37),
  [3624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, 0, 37),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_constraint, 4, 0, 0),
  [3628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_constraint, 4, 0, 0),
  [3630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_specification, 2, 0, 0),
  [3632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_window_specification, 2, 0, 0),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast, 6, 0, 102),
  [3636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast, 6, 0, 102),
  [3638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 0),
  [3640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 0),
  [3642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_specification, 4, 0, 0),
  [3644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_window_specification, 4, 0, 0),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 8, 0, 0),
  [3648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 8, 0, 0),
  [3650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14434),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11877),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4650),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9350),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11953),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11927),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11927),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5331),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14461),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11572),
  [3698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8861),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11851),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11242),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11242),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [3726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_not, 2, 0, 0),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12275),
  [3730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_not, 2, 0, 0),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5018),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13401),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14440),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11960),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5805),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9179),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11930),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11993),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11993),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [3766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5804),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6067),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14455),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11739),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4446),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8936),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11870),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11571),
  [3806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11571),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [3830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6061),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6069),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5395),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5431),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6072),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5440),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14431),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11846),
  [3868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6390),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11971),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4713),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11878),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11878),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6375),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6075),
  [3902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4915),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14458),
  [3906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11682),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5585),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8894),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11863),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11483),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11483),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5555),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5333),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5291),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6060),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11924),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9258),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6076),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5975),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5356),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6059),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6056),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14443),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11991),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9130),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11910),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12010),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12010),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5474),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5096),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6020),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5099),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6091),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [4112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11487),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8802),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3771),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4382),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14428),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11803),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3940),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8677),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11983),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11847),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11847),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14467),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11270),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [4180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8758),
  [4184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11832),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11384),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6097),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5226),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5110),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14446),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [4228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12009),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9066),
  [4238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11904),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11978),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11978),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5130),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14470),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11287),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8709),
  [4282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11828),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11432),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11432),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6063),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14261),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4920),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5455),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4304),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13723),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12679),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12679),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12740),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4307),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12739),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5151),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5983),
  [4372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5977),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5843),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4348),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4353),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [4408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5914),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5959),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5958),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5956),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5903),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5954),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6294),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5952),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5899),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5950),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5949),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5948),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5945),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5241),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5243),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5880),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5927),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5266),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5269),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5302),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5925),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5826),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5842),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5923),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13937),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5922),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5918),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5917),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5312),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5910),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5909),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5907),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4696),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5892),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5820),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5030),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [4540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [4542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5891),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5890),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5889),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5888),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4445),
  [4552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4396),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4731),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5887),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4401),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4510),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5744),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4408),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4413),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6184),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4670),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5886),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5885),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5884),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5883),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5881),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5879),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5869),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4711),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5867),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5866),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5865),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5857),
  [4620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4416),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4417),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5386),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4695),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5324),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5325),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5326),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5327),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [4678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5919),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5800),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5913),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [4724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5803),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5802),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5856),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6255),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [4744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [4746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4665),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4258),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4149),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4146),
  [4782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5439),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5402),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4127),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5695),
  [4806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [4824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14264),
  [4832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [4834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5493),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4721),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [4842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6188),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5089),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [4848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [4856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6040),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12686),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12685),
  [4870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12684),
  [4878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12683),
  [4888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5937),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12682),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5960),
  [4900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [4906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [4908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [4910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5677),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [4914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [4918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5632),
  [4920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6087),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [4930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [4936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [4940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [4942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [4944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [4946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [4948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [4952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5837),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [4958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5365),
  [4960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [4964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12674),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5932),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [5002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5934),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5477),
  [5016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6191),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5452),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6100),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5824),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [5036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [5038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [5040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6035),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5905),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [5062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5739),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5992),
  [5072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [5074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4380),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4377),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5978),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6295),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5592),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6328),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4977),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4924),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5902),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14330),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [5126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5900),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [5136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4717),
  [5152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5894),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6193),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4945),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5872),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4943),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5821),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4369),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [5190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [5194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5819),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5758),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [5210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5751),
  [5212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6322),
  [5214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4931),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5847),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4932),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5849),
  [5226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5851),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5874),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6195),
  [5234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5603),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6197),
  [5238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4958),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [5244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4918),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5963),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5795),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [5282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4364),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [5292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5967),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6198),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5571),
  [5298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6012),
  [5300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6006),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6199),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [5308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5774),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5855),
  [5314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4487),
  [5316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [5318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [5320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12225),
  [5324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [5326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [5328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [5330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5988),
  [5332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4690),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5990),
  [5338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6200),
  [5342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [5344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6196),
  [5346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5009),
  [5348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6007),
  [5350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [5352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [5356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [5358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6009),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [5362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [5366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6203),
  [5368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [5370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [5372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [5374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [5376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4355),
  [5378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4267),
  [5380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [5382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [5384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [5386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5536),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [5390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3635),
  [5392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [5394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [5396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [5398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4358),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [5402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [5404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4359),
  [5406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4214),
  [5408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4084),
  [5416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4072),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [5420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5871),
  [5426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6204),
  [5428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4185),
  [5430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [5432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5023),
  [5434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4166),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4100),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4094),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4393),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6021),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5024),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6044),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5594),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4093),
  [5468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6031),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [5476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [5478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5499),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [5486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [5488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6206),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [5502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [5504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [5506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5042),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5985),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6110),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6102),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [5524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5199),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5216),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5230),
  [5536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6207),
  [5538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5488),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5058),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6058),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6054),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6051),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [5558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5780),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6208),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5672),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4804),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5747),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5661),
  [5570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5489),
  [5574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6209),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5044),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6049),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5037),
  [5586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4013),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4290),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6210),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4299),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [5614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [5616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5576),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5724),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6212),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5691),
  [5638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [5640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [5642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4929),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5943),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4954),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5893),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6317),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [5666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6307),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4927),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5782),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [5674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [5676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [5678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5778),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5765),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [5698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5764),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [5716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5610),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6213),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5584),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [5728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4583),
  [5730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [5732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [5734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5812),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4953),
  [5740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [5746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [5748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [5752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4668),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5901),
  [5758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4634),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [5762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4960),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [5774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [5776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5928),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5931),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6112),
  [5810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5359),
  [5812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [5814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [5818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6222),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6223),
  [5822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [5824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [5830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [5832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6228),
  [5834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12186),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14333),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14263),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9514),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14402),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10861),
  [5896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8415),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [5905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [5907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [5909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_reference, 1, 0, 6), REDUCE(sym__qualified_field, 1, 0, 6),
  [5912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 4),
  [5914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_term, 1, 0, 4),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9490),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11092),
  [5920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [5922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [5926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8655),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [5930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6601),
  [5932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13922),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1836),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12669),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13196),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [5989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13201),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13201),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13280),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13279),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13204),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13205),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13206),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13207),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13208),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [6035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [6037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12188),
  [6041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12198),
  [6047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12199),
  [6053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [6055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12230),
  [6059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12213),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12100),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12212),
  [6065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [6067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12185),
  [6071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1881),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [6078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [6082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [6090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8655),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13648),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12688),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [6113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [6119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10479),
  [6121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8622),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [6130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [6132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [6160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [6162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [6166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12272),
  [6174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [6176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1934),
  [6179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_by, 3, 0, 0),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [6183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10807),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [6187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8507),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [6211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [6213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [6215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [6229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9448),
  [6231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10592),
  [6233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [6235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8626),
  [6241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [6257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14332),
  [6273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8507),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12670),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12671),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [6294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12672),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12673),
  [6300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14099),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [6306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8960),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9583),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14265),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12675),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13191),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12676),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12699),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12698),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12697),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12678),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12696),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12695),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12694),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14262),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12687),
  [6353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [6355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [6357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11179),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [6361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8661),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [6370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [6376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [6378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [6380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [6382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10546),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [6386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8563),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [6395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [6401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [6403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [6407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [6409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [6413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [6417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [6425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14080),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13192),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14144),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13193),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14139),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10804),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [6451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [6457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [6459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14127),
  [6469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14110),
  [6471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8607),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14106),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14098),
  [6478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9516),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13194),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13195),
  [6492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(12679),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13093),
  [6497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(12679),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13094),
  [6502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [6514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [6516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [6518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_target, 1, 0, 0),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9550),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [6532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13197),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13198),
  [6538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2223),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8500),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13200),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13209),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13210),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [6555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9032),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12260),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12257),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12233),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12231),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12365),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12224),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12222),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12215),
  [6576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8626),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12172),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12169),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14331),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [6593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8691),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14334),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [6600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14277),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13211),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13212),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13213),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13214),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13215),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13216),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8551),
  [6642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(12679),
  [6645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(12679),
  [6648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11002),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8669),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [6660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [6666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [6668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [6670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [6672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8669),
  [6675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(13201),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13287),
  [6680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(13201),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13288),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [6693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14201),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2884),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12792),
  [6711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12326),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12327),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12797),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12976),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12975),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9918),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12328),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [6733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14280),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [6739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12800),
  [6743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [6745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12801),
  [6749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [6751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12802),
  [6755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [6757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12803),
  [6761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2844),
  [6763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12804),
  [6767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0),
  [6769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [6771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14206),
  [6775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14279),
  [6779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inner_default_expression, 1, 0, 0),
  [6781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inner_default_expression, 1, 0, 0),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [6785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [6787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12333),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [6793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12332),
  [6797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12331),
  [6803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12738),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12738),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12799),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12798),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12330),
  [6817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [6819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12329),
  [6823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14217),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [6843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [6845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12321),
  [6849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where, 2, 0, 42),
  [6851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12787),
  [6855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [6861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [6865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [6867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [6869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(13201),
  [6872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(13201),
  [6875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [6877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [6879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [6895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2684),
  [6898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [6900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14269),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12745),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12744),
  [6922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13695),
  [6924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12743),
  [6932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12316),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12742),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12741),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12733),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12788),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12789),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14272),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [6974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12791),
  [6978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [6990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [6994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14335),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12793),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12794),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12796),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12805),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12806),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12790),
  [7020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14278),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10991),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [7030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [7040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [7044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [7046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14205),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14244),
  [7058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__having, 2, 0, 0),
  [7060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13239),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13239),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13281),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13282),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9440),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [7074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8528),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12813),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12814),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12815),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12816),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [7091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [7097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [7099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14222),
  [7107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12412),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12411),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12410),
  [7127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [7129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12409),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12408),
  [7143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [7145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [7147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12405),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12405),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12407),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12406),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12817),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12400),
  [7163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [7165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [7167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14309),
  [7177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12812),
  [7181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [7183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [7185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [7187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14281),
  [7191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8886),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13036),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13037),
  [7206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12313),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13038),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13039),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13040),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13028),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12395),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [7246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [7248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [7250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [7258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2894),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14221),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14312),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [7293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [7297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [7299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [7301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_list, 4, 0, 40),
  [7303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_list, 4, 0, 40),
  [7305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [7307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [7309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [7311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9232),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14207),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [7336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_list, 3, 0, 40),
  [7340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_list, 3, 0, 40),
  [7342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14325),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13825),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12349),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12348),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12347),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12346),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12544),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12345),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12552),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12553),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12554),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12555),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12556),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14248),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12344),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14204),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12335),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12334),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13234),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12325),
  [7448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13033),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13033),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13240),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13241),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13242),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13243),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13244),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13245),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13246),
  [7486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12549),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12549),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12621),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12622),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12323),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14338),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12322),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12728),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12320),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12319),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12318),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12317),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14271),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [7532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13841),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13889),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14273),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13772),
  [7544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8921),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [7555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10861),
  [7557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [7559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [7561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [7563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8420),
  [7565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [7573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [7579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [7581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [7583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12758),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12539),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9461),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10903),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [7607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8670),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [7625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [7631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [7633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [7635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13953),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12757),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14328),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14247),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [7685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13151),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13151),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13278),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13277),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14337),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12756),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12755),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12754),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12753),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14270),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12747),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12746),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12737),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13158),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12735),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13157),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13156),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13155),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12734),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13154),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13023),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13146),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12732),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12731),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12730),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12729),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10151),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13229),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10705),
  [7827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [7829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [7831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [7833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8662),
  [7835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [7851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [7853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [7855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [7865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3362),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12396),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12397),
  [7902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9729),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10991),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [7908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [7910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [7912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8441),
  [7914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [7922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [7928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12398),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12399),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12401),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12402),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12404),
  [7956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9154),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14223),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14311),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12413),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12414),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12428),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12427),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12426),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12425),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12424),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14220),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12423),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13052),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13051),
  [8001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8670),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13050),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13921),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13049),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13048),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14310),
  [8016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [8018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [8020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [8022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8478),
  [8024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [8030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [8036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [8038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [8040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [8044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(12405),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12857),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [8051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(12405),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12858),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13042),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13053),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [8066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3506),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13041),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13032),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13030),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9466),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13029),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9507),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13027),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13026),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14313),
  [8131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8696),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13230),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13231),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13232),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13233),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [8156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8658),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [8162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9055),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13141),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13025),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14249),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13024),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8499),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13235),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13236),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13238),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13247),
  [8205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3707),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13248),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14336),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13249),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9518),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13250),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13251),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13252),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12572),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14327),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12571),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12570),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12569),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12568),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12567),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13253),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14246),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13254),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12558),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12557),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [8264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(12213),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12551),
  [8269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(12213),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12550),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12548),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12546),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12545),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12543),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12542),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12541),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12540),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14339),
  [8304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8701),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [8335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [8337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [8339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8440),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [8345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(12405),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [8368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [8372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8689),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14329),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10705),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [8385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10252),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [8393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13171),
  [8421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(12405),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13170),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13169),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13168),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13167),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13166),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14326),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [8442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(13033),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13283),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13160),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13159),
  [8451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(13033),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13284),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13150),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13148),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13147),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13145),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13144),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13143),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13142),
  [8470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8441),
  [8473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8662),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8520),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8523),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [8482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(12213),
  [8485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(12213),
  [8488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8578),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [8493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8634),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [8498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(12549),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12917),
  [8503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(12549),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12916),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [8512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8420),
  [8515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4326),
  [8518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(12797),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13273),
  [8523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(12797),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13272),
  [8528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13857),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8344),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [8538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [8544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [8546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [8548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [8550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8344),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [8559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(12797),
  [8562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(12797),
  [8565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 76),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [8571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8478),
  [8574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 1, 0, 0), SHIFT(13151),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13286),
  [8579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 1, 0, 0), SHIFT(13151),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13285),
  [8584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(13033),
  [8587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(13033),
  [8590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(12549),
  [8593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(12549),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [8600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12244),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12245),
  [8604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10666),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8543),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [8624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [8632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [8634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [8636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_partition_by, 3, 0, 0),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [8640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_time, 4, 0, 114), SHIFT(13151),
  [8643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4959),
  [8645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5172),
  [8647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14185),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14317),
  [8659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_timestamp, 4, 0, 114), SHIFT(13151),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12246),
  [8664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13092),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13092),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13267),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13268),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [8674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 19), SHIFT(8543),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14320),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14253),
  [8693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8488),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13087),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [8705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4937),
  [8707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5213),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14190),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13095),
  [8717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4950),
  [8719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5202),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12251),
  [8723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [8725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12250),
  [8729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4955),
  [8731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12249),
  [8735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [8737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5193),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12248),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13096),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13097),
  [8753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5464),
  [8755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5567),
  [8757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4856),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14301),
  [8761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [8763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5175),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12247),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13099),
  [8773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12974),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13203),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13202),
  [8779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12620),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12620),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12681),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12680),
  [8787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4968),
  [8789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12239),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13098),
  [8799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14319),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13905),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [8841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4976),
  [8843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4969),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12234),
  [8847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 4, 0, 0),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11948),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11554),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12394),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12392),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8771),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12389),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12388),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14407),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10213),
  [8873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13082),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [8883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 3, 0, 0),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5472),
  [8887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14304),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5469),
  [8893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12981),
  [8897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [8899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5553),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12980),
  [8903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5467),
  [8905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12979),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5466),
  [8911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5558),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12978),
  [8915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5465),
  [8917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5560),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12977),
  [8921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14189),
  [8925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5462),
  [8927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5570),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12969),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14256),
  [8937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4923),
  [8939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [8941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [8943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5278),
  [8945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [8947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5279),
  [8949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4933),
  [8951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5280),
  [8953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4930),
  [8955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5283),
  [8957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [8959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5284),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [8963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12627),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12626),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12625),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12624),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12623),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12615),
  [8997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4921),
  [8999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [9001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4922),
  [9003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [9005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 2, 0, 0),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12240),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [9021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [9023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12610),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [9057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [9059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [9061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14188),
  [9065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5240),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14255),
  [9071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9309),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11465),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14184),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13696),
  [9082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12140),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12141),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13987),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9650),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7874),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [9128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5232),
  [9130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5231),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [9140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5228),
  [9142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5222),
  [9144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5220),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [9168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [9170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5461),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12964),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13809),
  [9176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5209),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12267),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12266),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12265),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12264),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12263),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12262),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12253),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12252),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12243),
  [9208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5470),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14303),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13088),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13101),
  [9218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5457),
  [9220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5581),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [9226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [9228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5582),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [9234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5448),
  [9236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5588),
  [9238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [9240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5595),
  [9242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5459),
  [9244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5580),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12241),
  [9248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [9250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5624),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [9254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5639),
  [9256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4999),
  [9259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [9261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5667),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13089),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [9267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [9269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [9271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [9273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [9275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12238),
  [9277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [9281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [9285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [9287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [9289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13083),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12237),
  [9297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12236),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13084),
  [9301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13100),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12235),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14191),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [9319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [9321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [9325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12477),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12477),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12479),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12478),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14231),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13091),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13085),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [9369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9868),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13086),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [9389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8682),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14321),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [9398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12156),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12156),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12158),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12157),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14168),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13112),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13111),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13110),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13109),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13108),
  [9432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13107),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14318),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12614),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [9448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [9454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [9464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8638),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9384),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6534),
  [9496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 1, 0, 0),
  [9498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relation, 1, 0, 0),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12151),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [9516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [9522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11750),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12159),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [9538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [9542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12160),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [9552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [9554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12161),
  [9562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12162),
  [9568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12163),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11737),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [9582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [9584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11816),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12472),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [9610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [9612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12480),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [9620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [9622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12481),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12482),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12483),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6169),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12484),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12611),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12612),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12613),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [9664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14235),
  [9666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12616),
  [9668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12617),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12619),
  [9674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14173),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11473),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11462),
  [9684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14167),
  [9686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7696),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14039),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14040),
  [9696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5352),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12628),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12629),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [9711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, 0, 60),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14254),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12635),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9992),
  [9719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 6, 0, 15),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12636),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12637),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12638),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12639),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12640),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9679),
  [9737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14257),
  [9745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9002),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [9760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [9766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5671),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [9778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 4, 0, 0),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [9784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5669),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [9788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8746),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12965),
  [9793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12966),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9493),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12967),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9504),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12968),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12970),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12971),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12973),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [9823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5615),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12982),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12983),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14302),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12989),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5613),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12990),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12991),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [9845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5611),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12992),
  [9849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5543),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12993),
  [9853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5609),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12994),
  [9857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5539),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [9861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5525),
  [9863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5524),
  [9865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [9867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [9869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5518),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14305),
  [9873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5497),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6402),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [9881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12146),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [9901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [9905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13751),
  [9915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8544),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [9919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [9923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [9929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [9939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [9941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [9945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [9949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [9953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6260),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [9971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8331),
  [9973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_return, 2, 0, 0),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [9979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 3, 0, 0),
  [9981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relation, 3, 0, 0),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [10005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [10009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14172),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12467),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8490),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11451),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11443),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14216),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9208),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12310),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12311),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [10053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [10057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [10061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14234),
  [10067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6249),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12500),
  [10117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9097),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [10122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12499),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12498),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12497),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [10140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [10142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12496),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12495),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14236),
  [10148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14233),
  [10150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12179),
  [10152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [10154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [10156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12486),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12485),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12476),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12474),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12473),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [10176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12471),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12470),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12178),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12469),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12468),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [10194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12177),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12148),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [10206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12176),
  [10212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12175),
  [10214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12174),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14171),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14174),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [10252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [10258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [10270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0),
  [10272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [10275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(10854),
  [10278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0),
  [10280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(9812),
  [10283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13113),
  [10286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(6649),
  [10289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13105),
  [10292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(12984),
  [10295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13081),
  [10298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13079),
  [10301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13078),
  [10304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(9288),
  [10307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(14006),
  [10310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13076),
  [10313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(2006),
  [10316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(118),
  [10319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [10322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(135),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [10331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10003),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [10349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8070),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [10369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(9384),
  [10372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12164),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [10414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [10420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [10422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [10424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [10426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [10428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [10430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [10432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [10450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [10452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12155),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12153),
  [10472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [10474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12152),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12150),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12149),
  [10498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [10500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [10502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12165),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [10506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [10508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [10510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [10512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [10514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [10524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [10554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [10556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12147),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [10560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [10562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [10572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 6, 0, 0),
  [10574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10987),
  [10576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_table, 6, 0, 0),
  [10578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10006),
  [10580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9867),
  [10582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13894),
  [10584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6667),
  [10586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13338),
  [10588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13790),
  [10590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13891),
  [10592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13888),
  [10594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13339),
  [10596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8897),
  [10598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12128),
  [10600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14029),
  [10602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 7, 0, 0),
  [10604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_table, 7, 0, 0),
  [10606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9833),
  [10608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(10987),
  [10611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(9867),
  [10614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13894),
  [10617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(6667),
  [10620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13338),
  [10623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13790),
  [10626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13891),
  [10629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13888),
  [10632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(13339),
  [10635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(8897),
  [10638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(12128),
  [10641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_table_repeat1, 2, 0, 0), SHIFT_REPEAT(14029),
  [10644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 5, 0, 0),
  [10646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_table, 5, 0, 0),
  [10648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10188),
  [10650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 4, 0, 0),
  [10652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_table, 4, 0, 0),
  [10654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10080),
  [10656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9543),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [10672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10854),
  [10674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10150),
  [10676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9812),
  [10678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13113),
  [10680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [10682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13105),
  [10684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12984),
  [10686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13081),
  [10688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13079),
  [10690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13078),
  [10692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9288),
  [10694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14006),
  [10696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13076),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [10732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10076),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [10740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8343),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [10748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11536),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11469),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14038),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9117),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13821),
  [10774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13808),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9792),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [10780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10090),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [10784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9499),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [10802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13784),
  [10804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8769),
  [10806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8291),
  [10808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7297),
  [10810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8202),
  [10812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7184),
  [10814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [10816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14001),
  [10818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8519),
  [10820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13778),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [10828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7798),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7596),
  [10832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12713),
  [10834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9190),
  [10836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8224),
  [10838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [10840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8136),
  [10842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7215),
  [10844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7485),
  [10846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8438),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12819),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11458),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11449),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14200),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7712),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9169),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12228),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12229),
  [10866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9737),
  [10868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7939),
  [10870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9624),
  [10872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9707),
  [10874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7804),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [10878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7775),
  [10880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alias, 2, 0, 18),
  [10882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9810),
  [10884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7738),
  [10886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7942),
  [10888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 6, 0, 0),
  [10890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alias, 1, 0, 11),
  [10892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8870),
  [10894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 5, 0, 0),
  [10896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 4, 0, 41),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7813),
  [10900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 2, 0, 12),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10242),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10241),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9866),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12987),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12995),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12996),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12997),
  [10916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10689),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13013),
  [10928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13014),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9265),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11834),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13031),
  [10938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0),
  [10940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6749),
  [10943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(12352),
  [10946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1442),
  [10949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6788),
  [10952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(12259),
  [10955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6431),
  [10958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(12256),
  [10961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [10964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8926),
  [10967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(12296),
  [10970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8927),
  [10973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7917),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10144),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13463),
  [10979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [10981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7769),
  [10983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 2, 0, 61),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12352),
  [10989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12259),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12256),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8926),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12296),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8927),
  [11007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definition, 3, 0, 61),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [11011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 8, 0, 132),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10143),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [11017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0),
  [11019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(12987),
  [11022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(12996),
  [11025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(12997),
  [11028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(10143),
  [11031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(6720),
  [11034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(6710),
  [11037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(10689),
  [11040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13013),
  [11043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(6711),
  [11046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13014),
  [11049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(9013),
  [11052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(11834),
  [11055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13031),
  [11058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 9, 0, 0),
  [11060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 10, 0, 138),
  [11062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 10, 0, 0),
  [11064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 10, 0, 169),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13680),
  [11070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13677),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13429),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8923),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13428),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [11088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 9, 0, 138),
  [11090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 9, 0, 169),
  [11092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat1, 2, 0, 0),
  [11094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7880),
  [11097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6798),
  [11100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(13680),
  [11103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1339),
  [11106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6785),
  [11109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(13677),
  [11112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6488),
  [11115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(13429),
  [11118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(847),
  [11121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8923),
  [11124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(13428),
  [11127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(9125),
  [11130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 9, 0, 132),
  [11132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 11, 0, 0),
  [11134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 11, 0, 169),
  [11136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 8, 0, 138),
  [11138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 3, 0, 24),
  [11140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 8, 0, 0),
  [11142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 7, 0, 132),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [11146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_function, 7, 0, 0),
  [11148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 5, 0, 78),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13635),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13634),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14094),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10602),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13464),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13632),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9201),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11656),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13413),
  [11176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6535),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [11180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6535),
  [11183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_cross_join, 4, 0, 0),
  [11185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lateral_cross_join, 4, 0, 0),
  [11187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9520),
  [11189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definitions, 3, 0, 0),
  [11191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_column_definitions, 3, 0, 0),
  [11193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definitions, 5, 0, 0),
  [11195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_column_definitions, 5, 0, 0),
  [11197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [11199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0),
  [11201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(9860),
  [11204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(9265),
  [11207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_definitions, 4, 0, 0),
  [11209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_column_definitions, 4, 0, 0),
  [11211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13635),
  [11214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13634),
  [11217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(14094),
  [11220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(9954),
  [11223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(6926),
  [11226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(6924),
  [11229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(10602),
  [11232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13464),
  [11235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(6910),
  [11238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13632),
  [11241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(9201),
  [11244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(11656),
  [11247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_function_repeat1, 2, 0, 0), SHIFT_REPEAT(13413),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8962),
  [11254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6574),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10239),
  [11261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9798),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [11265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6574),
  [11267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0),
  [11269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11948),
  [11272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11554),
  [11275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(12394),
  [11278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(12392),
  [11281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(7709),
  [11284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(8771),
  [11287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7874),
  [11290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_similar_to, 2, 0, 0),
  [11292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_similar_to, 2, 0, 0),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8840),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6869),
  [11300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_like, 2, 0, 0),
  [11302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_like, 2, 0, 0),
  [11304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_like, 1, 0, 0),
  [11306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_like, 1, 0, 0),
  [11308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_distinct_from, 4, 0, 0),
  [11310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_distinct_from, 4, 0, 0),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6797),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [11316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_similar_to, 3, 0, 0),
  [11318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_similar_to, 3, 0, 0),
  [11320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11465),
  [11323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11455),
  [11326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(14184),
  [11329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(13696),
  [11332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(7724),
  [11335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(9136),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [11340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_distinct_from, 3, 0, 0),
  [11342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_distinct_from, 3, 0, 0),
  [11344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11473),
  [11347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11462),
  [11350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(14167),
  [11353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(7696),
  [11356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(9120),
  [11359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 4, 0, 80),
  [11361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_hint, 5, 0, 74),
  [11363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 8, 0, 203),
  [11365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 5, 0, 123),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9642),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13990),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9710),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14292),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9357),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [11391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8718),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11529),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13992),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13993),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8215),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9411),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14591),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13300),
  [11411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 7, 0, 179),
  [11413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 6, 0, 154),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8289),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14300),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8355),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8293),
  [11435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9246),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9246),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11332),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14350),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14274),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8372),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8296),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14260),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14476),
  [11455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_hint, 7, 0, 149),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11435),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14275),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14259),
  [11467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join, 9, 0, 220),
  [11469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10775),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9501),
  [11473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11451),
  [11476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11443),
  [11479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(14216),
  [11482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(7691),
  [11485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(9208),
  [11488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_constraint, 5, 0, 0),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [11492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_constraint, 5, 0, 0),
  [11494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11327),
  [11496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_constraint, 7, 0, 0),
  [11498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_constraint, 7, 0, 0),
  [11500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11358),
  [11502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_constraint, 6, 0, 0),
  [11504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_constraint, 6, 0, 0),
  [11506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_format, 3, 0, 0),
  [11508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_format, 3, 0, 0),
  [11510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12749),
  [11512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12751),
  [11514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10417),
  [11516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_option, 1, 0, 6),
  [11518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_option, 1, 0, 6),
  [11520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12077),
  [11522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_format, 7, 0, 205),
  [11524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_format, 7, 0, 205),
  [11526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14155),
  [11528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14156),
  [11530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 4, 0, 0),
  [11532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__column_constraint_repeat1, 4, 0, 0),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9558),
  [11536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 2, 0, 0),
  [11538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 2, 0, 0), SHIFT_REPEAT(11447),
  [11541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__column_constraint_repeat1, 2, 0, 0),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8207),
  [11545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_cross_join, 6, 0, 116),
  [11547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_location, 2, 0, 46),
  [11549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_location, 2, 0, 46),
  [11551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14163),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11911),
  [11555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lateral_cross_join, 5, 0, 75),
  [11557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_format, 10, 0, 233),
  [11559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_format, 10, 0, 233),
  [11561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14359),
  [11563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 3, 0, 0),
  [11565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__column_constraint_repeat1, 3, 0, 0),
  [11567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 2, 0, 0), SHIFT_REPEAT(11911),
  [11570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_key, 2, 0, 0),
  [11572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_key, 2, 0, 0),
  [11574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13453),
  [11576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13454),
  [11578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_location, 5, 0, 156),
  [11580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_location, 5, 0, 156),
  [11582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13980),
  [11584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6715),
  [11586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 7, 0, 0),
  [11588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__column_constraint_repeat1, 7, 0, 0),
  [11590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_constraint_repeat1, 8, 0, 0),
  [11592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__column_constraint_repeat1, 8, 0, 0),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [11596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cross_join, 3, 0, 0),
  [11598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12656),
  [11600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13548),
  [11602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_security, 3, 0, 0),
  [11604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_security, 3, 0, 0),
  [11606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_support, 2, 0, 137),
  [11608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_support, 2, 0, 137),
  [11610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_cost, 2, 0, 0),
  [11612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_cost, 2, 0, 0),
  [11614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_safety, 2, 0, 0),
  [11616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_safety, 2, 0, 0),
  [11618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_language, 2, 0, 0),
  [11620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_language, 2, 0, 0),
  [11622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_rows, 2, 0, 0),
  [11624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_rows, 2, 0, 0),
  [11626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_leakproof, 2, 0, 0),
  [11628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_leakproof, 2, 0, 0),
  [11630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 6, 0, 152),
  [11632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 6, 0, 152),
  [11634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 2, 0, 0),
  [11636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 2, 0, 0),
  [11638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 7, 0, 178),
  [11640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 7, 0, 178),
  [11642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13743),
  [11644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7251),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11681),
  [11648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11681),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [11654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7255),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [11662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13742),
  [11664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13565),
  [11666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_sort, 6, 0, 0),
  [11668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_sort, 6, 0, 0),
  [11670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6834),
  [11672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13738),
  [11674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13733),
  [11676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_leakproof, 1, 0, 0),
  [11678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_leakproof, 1, 0, 0),
  [11680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_strictness, 1, 0, 0),
  [11682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_strictness, 1, 0, 0),
  [11684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13518),
  [11686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6855),
  [11688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__check_constraint, 6, 0, 0),
  [11690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__check_constraint, 6, 0, 0),
  [11692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 3, 0, 0),
  [11694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 3, 0, 0),
  [11696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_location, 6, 0, 156),
  [11698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_location, 6, 0, 156),
  [11700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_strictness, 5, 0, 0),
  [11702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_strictness, 5, 0, 0),
  [11704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_parameters, 6, 0, 0),
  [11706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_parameters, 6, 0, 0),
  [11708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13532),
  [11710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_volatility, 1, 0, 0),
  [11712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_volatility, 1, 0, 0),
  [11714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stored_as, 3, 0, 0),
  [11716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stored_as, 3, 0, 0),
  [11718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10791),
  [11720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 7, 0, 0),
  [11722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 7, 0, 0),
  [11724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 5, 0, 0),
  [11726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 5, 0, 0),
  [11728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 4, 0, 0),
  [11730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 4, 0, 0),
  [11732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_sort, 5, 0, 0),
  [11734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_sort, 5, 0, 0),
  [11736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 4, 0, 77),
  [11738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 4, 0, 77),
  [11740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_settings, 5, 0, 0),
  [11742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__table_settings, 5, 0, 0),
  [11744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_parameters, 5, 0, 0),
  [11746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_parameters, 5, 0, 0),
  [11748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_security, 2, 0, 0),
  [11750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_security, 2, 0, 0),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [11754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_format, 7, 0, 206),
  [11756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_format, 7, 0, 206),
  [11758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 5, 0, 118),
  [11760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 5, 0, 118),
  [11762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__check_constraint, 4, 0, 0),
  [11764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__check_constraint, 4, 0, 0),
  [11766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 6, 0, 0),
  [11768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 6, 0, 0),
  [11770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 6, 0, 151),
  [11772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 6, 0, 151),
  [11774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_option, 3, 0, 84),
  [11776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_option, 3, 0, 84),
  [11778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_expression, 4, 0, 0),
  [11780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__default_expression, 4, 0, 0),
  [11782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11283),
  [11784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_format, 14, 0, 242),
  [11786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_format, 14, 0, 242),
  [11788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12057),
  [11790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7176),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11805),
  [11794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11805),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7110),
  [11798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7169),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [11804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_direction, 1, 0, 0),
  [11806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_direction, 1, 0, 0),
  [11808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12059),
  [11810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6837),
  [11812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12372),
  [11814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12378),
  [11816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11536),
  [11819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11469),
  [11822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(14038),
  [11825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(7635),
  [11828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(9117),
  [11831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_format, 11, 0, 235),
  [11833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_format, 11, 0, 235),
  [11835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_option, 4, 0, 0),
  [11837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_option, 4, 0, 0),
  [11839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_statement_repeat1, 2, 0, 0),
  [11841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_set_statement_repeat1, 2, 0, 0),
  [11843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__column_comment, 2, 0, 137),
  [11845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__column_comment, 2, 0, 137),
  [11847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_expression, 2, 0, 0),
  [11849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__default_expression, 2, 0, 0),
  [11851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_strictness, 4, 0, 0),
  [11853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_strictness, 4, 0, 0),
  [11855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_parameters, 4, 0, 0),
  [11857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_parameters, 4, 0, 0),
  [11859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_option, 2, 0, 0),
  [11861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_option, 2, 0, 0),
  [11863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_settings, 2, 0, 0),
  [11865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__table_settings, 2, 0, 0),
  [11867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_location, 9, 0, 230),
  [11869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_location, 9, 0, 230),
  [11871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__not_null, 2, 0, 0),
  [11873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__not_null, 2, 0, 0),
  [11875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__table_settings, 4, 0, 0),
  [11877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__table_settings, 4, 0, 0),
  [11879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_parameters, 7, 0, 0),
  [11881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_parameters, 7, 0, 0),
  [11883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_partition, 5, 0, 121),
  [11885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_partition, 5, 0, 121),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [11899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6929),
  [11915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7057),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [11931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [11947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [11963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [11979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [11995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [12011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [12027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5362),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [12033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [12043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10113),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [12055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [12059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [12061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5445),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [12077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5085),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [12093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [12099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [12109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5810),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [12125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [12141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [12143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [12145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [12149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [12153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [12157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [12161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [12165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [12173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [12189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [12205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [12209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11458),
  [12212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(11449),
  [12215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(14200),
  [12218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(7712),
  [12221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_from_repeat1, 2, 0, 0), SHIFT_REPEAT(9169),
  [12224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_role, 3, 0, 0),
  [12226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_role, 3, 0, 0),
  [12228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11824),
  [12230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [12232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9805),
  [12234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8583),
  [12236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13132),
  [12238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13126),
  [12240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13122),
  [12242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_all_fields, 3, 0, 0),
  [12244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_all_fields, 3, 0, 0),
  [12246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_all_fields, 1, 0, 0),
  [12248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_all_fields, 1, 0, 0),
  [12250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 4, 0, 0),
  [12252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_role, 5, 0, 43),
  [12254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_role, 5, 0, 43),
  [12256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_role, 4, 0, 27),
  [12258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_role, 4, 0, 27),
  [12260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12915),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12915),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13152),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13153),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8794),
  [12270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 3, 0, 0),
  [12272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9205),
  [12274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12880),
  [12276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7361),
  [12278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12877),
  [12280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8630),
  [12282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13803),
  [12284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13797),
  [12286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13795),
  [12288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8676),
  [12290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 6, 0, 0),
  [12292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 5, 0, 0),
  [12294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 7, 0, 0),
  [12296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 8, 0, 0),
  [12298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 9, 0, 0),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8806),
  [12302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45),
  [12304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(293),
  [12307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45),
  [12309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(11824),
  [12312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(9805),
  [12315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(8583),
  [12318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13132),
  [12321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13126),
  [12324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13122),
  [12327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(293),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14293),
  [12338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_role, 4, 0, 0),
  [12340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_role, 4, 0, 0),
  [12342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 0),
  [12344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11587),
  [12346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6907),
  [12348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9825),
  [12350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8539),
  [12352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13918),
  [12354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13908),
  [12356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13907),
  [12358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 137),
  [12360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8910),
  [12362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13353),
  [12364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7472),
  [12366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13785),
  [12368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8496),
  [12370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12136),
  [12372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12137),
  [12374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12138),
  [12376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9182),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7056),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12922),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7058),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12921),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [12394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(154),
  [12397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(11587),
  [12400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(9825),
  [12403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(8539),
  [12406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13918),
  [12409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13908),
  [12412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13907),
  [12415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_role_repeat1, 2, 0, 45), SHIFT_REPEAT(154),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7060),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12920),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7062),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12919),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12918),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14296),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12910),
  [12448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_target, 3, 0, 0),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11533),
  [12452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 7, 0, 0),
  [12454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_target, 2, 0, 0),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11585),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7059),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [12462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__create_statement, 1, 0, 0),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11588),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [12468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11028),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13902),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [12476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9857),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7142),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [12487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9341),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9341),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13541),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9693),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14433),
  [12499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9663),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9370),
  [12503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__create_statement_repeat1, 2, 0, 0),
  [12505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__create_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6626),
  [12508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__create_statement, 2, 0, 0),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8048),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9635),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9577),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9634),
  [12518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_target, 5, 0, 0),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7160),
  [12524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11602),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9593),
  [12536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__create_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6633),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9703),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10131),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [12549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_target, 4, 0, 0),
  [12551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_by, 4, 0, 0),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12905),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [12561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__user_access_role_config, 3, 0, 0),
  [12563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__user_access_role_config, 3, 0, 0),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9857),
  [12567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__user_access_role_config, 2, 0, 0),
  [12569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__user_access_role_config, 2, 0, 0),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7053),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14295),
  [12575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__user_access_role_config, 4, 0, 0),
  [12577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__user_access_role_config, 4, 0, 0),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7075),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7065),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7098),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9727),
  [12601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__create_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6631),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [12606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 2, 0, 10),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11724),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [12612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 8, 0, 0),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10569),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6753),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12782),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9170),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12778),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12877),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12819),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10015),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6707),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6708),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13846),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13710),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13785),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13778),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7362),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10000),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10350),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12906),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7078),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12911),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12924),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12923),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12935),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12934),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12933),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10626),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7231),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12932),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12931),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12930),
  [12704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_size_definition_repeat1, 2, 0, 73), SHIFT_REPEAT(8793),
  [12707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12018),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14297),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12908),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14294),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7115),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7073),
  [12725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1603),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [12732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9727),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12914),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12912),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12907),
  [12741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [12744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 3, 0, 81),
  [12746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 3, 0, 81),
  [12748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 2, 0, 44),
  [12750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 2, 0, 44),
  [12752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 2, 0, 0),
  [12754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 2, 0, 0),
  [12756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 3, 0, 0),
  [12758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 3, 0, 0),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [12762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quote_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7119),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9032),
  [12769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 1, 0, 26),
  [12771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 1, 0, 26),
  [12773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_role_repeat1, 1, 0, 25),
  [12775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_create_role_repeat1, 1, 0, 25),
  [12777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 3, 0, 82),
  [12779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 3, 0, 82),
  [12781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role_options, 3, 0, 83),
  [12783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__role_options, 3, 0, 83),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [12789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_sequence, 4, 0, 31),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7233),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9403),
  [12795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11796),
  [12797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11780),
  [12799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11004),
  [12801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11005),
  [12803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9811),
  [12805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [12809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_by, 5, 0, 0),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10190),
  [12813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9403),
  [12816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11796),
  [12819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11780),
  [12822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11004),
  [12825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11005),
  [12828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 0),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10761),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10005),
  [12834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_sequence, 3, 0, 0),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9277),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13054),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9275),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [12854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7478),
  [12856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9660),
  [12858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 9, 0, 0),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10193),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9968),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9806),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9795),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9712),
  [12880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_sequence, 6, 0, 92),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [12884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_sequence, 4, 0, 0),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [12888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_sequence, 4, 0, 28),
  [12890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7504),
  [12892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9967),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9526),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9528),
  [12898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [12901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_sequence, 5, 0, 47),
  [12903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52),
  [12905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(9277),
  [12908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(6750),
  [12911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(6748),
  [12914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(13054),
  [12917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(9275),
  [12920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(68),
  [12923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(10708),
  [12926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(7225),
  [12929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(9842),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [12934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_sequence, 5, 0, 0),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [12938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1794),
  [12941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_sequence, 5, 0, 62),
  [12943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64),
  [12945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(6751),
  [12948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(6752),
  [12951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(6753),
  [12954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(12782),
  [12957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(9170),
  [12960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(9168),
  [12963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(53),
  [12966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(12778),
  [12969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(7233),
  [12972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(10015),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10986),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10139),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10873),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10871),
  [12983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10849),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10766),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13878),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8902),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10662),
  [13001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9913),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11709),
  [13007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 2, 0, 0),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11478),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14005),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7892),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9116),
  [13019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [13021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11321),
  [13023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0), SHIFT_REPEAT(918),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9503),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11916),
  [13032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8362),
  [13034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7424),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [13038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by, 3, 0, 0),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12004),
  [13046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__copy_statement_repeat1, 2, 0, 173),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11684),
  [13050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [13052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9358),
  [13054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10936),
  [13056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7626),
  [13058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7430),
  [13060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8717),
  [13062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13875),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11749),
  [13068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8336),
  [13070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7440),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [13078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 48),
  [13080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 0),
  [13082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 49),
  [13084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 50),
  [13086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 51),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [13098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7465),
  [13100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13828),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11626),
  [13106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8615),
  [13108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7477),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11635),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11647),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11670),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8110),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12299),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [13142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 5, 0, 43),
  [13144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45),
  [13146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(295),
  [13149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(8630),
  [13152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13803),
  [13155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13797),
  [13158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(13795),
  [13161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(295),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [13166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__truncate_statement, 1, 0, 0),
  [13168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7425),
  [13170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10769),
  [13172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7567),
  [13174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6790),
  [13176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9360),
  [13178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10790),
  [13180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7663),
  [13182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7481),
  [13184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9293),
  [13186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14315),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [13192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 3, 0, 97),
  [13194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 3, 0, 86),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8375),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7752),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13502),
  [13206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 3, 0, 0),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [13212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(6707),
  [13215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(6708),
  [13218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(6709),
  [13221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(13846),
  [13224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(8928),
  [13227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(8929),
  [13230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(73),
  [13233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(13710),
  [13236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(7333),
  [13239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 64), SHIFT_REPEAT(10000),
  [13242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 3, 0, 85),
  [13244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 3, 0, 0),
  [13246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 3, 0, 86),
  [13248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 10, 0, 0),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [13256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(8899),
  [13259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(6703),
  [13262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(6704),
  [13265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(13878),
  [13268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(8902),
  [13271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(83),
  [13274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(10662),
  [13277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(7345),
  [13280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_sequence_repeat1, 2, 0, 52), SHIFT_REPEAT(9913),
  [13283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 0),
  [13285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 49),
  [13287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 63),
  [13289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8548),
  [13291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7444),
  [13293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 50),
  [13295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_sequence_repeat1, 2, 0, 51),
  [13297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7500),
  [13299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 4, 0, 27),
  [13301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [13303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1258),
  [13306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 4, 0, 0),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [13310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_expression, 1, 0, 0),
  [13312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limit, 2, 0, 0),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [13320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8395),
  [13322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7443),
  [13324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8335),
  [13326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7431),
  [13328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0),
  [13330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(768),
  [13333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [13335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [13337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by, 4, 0, 0),
  [13339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_clause, 4, 0, 0),
  [13341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 3, 0, 0),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [13345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7592),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [13349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(761),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [13356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7575),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11592),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13886),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8800),
  [13366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__truncate_statement, 2, 0, 0),
  [13368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10450),
  [13370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7570),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [13374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6821),
  [13376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9346),
  [13378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9345),
  [13380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13844),
  [13382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13315),
  [13384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13838),
  [13386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8407),
  [13388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [13390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9988),
  [13392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11871),
  [13394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 1, 0, 88),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8641),
  [13398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9862),
  [13400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13792),
  [13402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9864),
  [13404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7557),
  [13406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11385),
  [13408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7618),
  [13410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8484),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [13414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9996),
  [13416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11873),
  [13418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 1, 0, 87),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [13422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select, 2, 0, 0),
  [13424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0), SHIFT_REPEAT(1008),
  [13427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 1, 0, 0),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [13431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8423),
  [13433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [13435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8832),
  [13437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8833),
  [13439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13843),
  [13441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13837),
  [13443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13842),
  [13445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9521),
  [13447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11570),
  [13449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 3, 0, 157),
  [13451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7577),
  [13453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0), SHIFT_REPEAT(1021),
  [13456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(154),
  [13459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(8496),
  [13462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(12136),
  [13465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(12137),
  [13468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(12138),
  [13471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_role_repeat1, 2, 0, 45), SHIFT_REPEAT(154),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [13478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cte, 4, 0, 0),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9237),
  [13482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cte, 3, 0, 0),
  [13484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cte_repeat1, 2, 0, 0),
  [13486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cte_repeat1, 2, 0, 0), SHIFT_REPEAT(9237),
  [13489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_database, 4, 0, 0),
  [13491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_database, 4, 0, 0),
  [13493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7713),
  [13495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cte, 2, 0, 0),
  [13497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [13499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(765),
  [13502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8714),
  [13504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8209),
  [13506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8005),
  [13508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11569),
  [13510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 3, 0, 87),
  [13512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from, 11, 0, 0),
  [13514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 3, 0, 0),
  [13516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8280),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8278),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8277),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8275),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8274),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [13532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [13534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_read, 1, 0, 0),
  [13536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8785),
  [13538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9603),
  [13540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0), SHIFT_REPEAT(989),
  [13543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9398),
  [13545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8244),
  [13547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8101),
  [13549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11476),
  [13551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 157),
  [13553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_read, 4, 0, 0),
  [13555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 4, 0, 0),
  [13557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11563),
  [13559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 3, 0, 88),
  [13561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11374),
  [13563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7612),
  [13565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_database, 3, 0, 0),
  [13567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_database, 3, 0, 0),
  [13569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7602),
  [13571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17),
  [13573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(8785),
  [13576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(9603),
  [13579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_read, 2, 0, 0),
  [13581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__truncate_statement, 3, 0, 0),
  [13583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10751),
  [13585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 3, 0, 35),
  [13587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 16),
  [13589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_statement, 2, 0, 0),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [13593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8266),
  [13597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [13599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [13605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8409),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [13609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9365),
  [13611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8303),
  [13613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8089),
  [13615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [13617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8886),
  [13619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limit, 3, 0, 0),
  [13621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_operation, 2, 0, 8),
  [13623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9801),
  [13626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset, 2, 0, 0),
  [13628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 9, 0, 216),
  [13630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7832),
  [13632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(8807),
  [13635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(9688),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8307),
  [13640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14014),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9657),
  [13644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10944),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10944),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14013),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8232),
  [13652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8782),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14592),
  [13656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_database, 4, 0, 30),
  [13658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_database, 4, 0, 30),
  [13660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7936),
  [13662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7879),
  [13664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7829),
  [13666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11359),
  [13668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 7, 0, 171),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8807),
  [13672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9688),
  [13674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7883),
  [13676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10135),
  [13680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_role_repeat1, 1, 0, 25),
  [13682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alter_role_repeat1, 1, 0, 25),
  [13684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7853),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7688),
  [13688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8121),
  [13690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [13692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 6, 0, 139),
  [13694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8113),
  [13696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_database, 6, 0, 90),
  [13698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_database, 6, 0, 90),
  [13700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8108),
  [13702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 8, 0, 198),
  [13704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 8, 0, 199),
  [13706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7978),
  [13708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7979),
  [13710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 2, 0, 0),
  [13712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [13714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1679),
  [13717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [13719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 5, 0, 99),
  [13721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 11, 0, 232),
  [13723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [13725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0), SHIFT_REPEAT(920),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [13730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13750),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10067),
  [13734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10315),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10315),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13752),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9244),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13734),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [13752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8233),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9532),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9535),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [13762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [13764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(695),
  [13767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8018),
  [13769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11591),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9227),
  [13773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8130),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8305),
  [13777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8341),
  [13781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9994),
  [13783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10029),
  [13787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8021),
  [13789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 10, 0, 228),
  [13791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7783),
  [13793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8023),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [13797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 10, 0, 227),
  [13799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7727),
  [13801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8120),
  [13803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 3, 0, 0),
  [13805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8117),
  [13807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 3, 0, 0),
  [13809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10053),
  [13811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8027),
  [13813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8103),
  [13815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8028),
  [13817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8065),
  [13819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8057),
  [13821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8030),
  [13823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_database, 5, 0, 0),
  [13825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_database, 5, 0, 0),
  [13827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_database, 5, 0, 53),
  [13829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_create_database, 5, 0, 53),
  [13831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8059),
  [13833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 9, 0, 217),
  [13835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8060),
  [13837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_database_repeat1, 2, 0, 56),
  [13839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_create_database_repeat1, 2, 0, 56), SHIFT_REPEAT(88),
  [13842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_create_database_repeat1, 2, 0, 56),
  [13844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_database_repeat1, 2, 0, 56), SHIFT_REPEAT(88),
  [13847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8062),
  [13849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cte, 9, 0, 215),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [13853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12713),
  [13857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12748),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12727),
  [13861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11894),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10499),
  [13865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [13867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11689),
  [13869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10214),
  [13871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [13873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [13877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8271),
  [13879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__set_values_repeat1, 2, 0, 0),
  [13881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__set_values_repeat1, 2, 0, 0), SHIFT_REPEAT(8006),
  [13884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8930),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13773),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13774),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10599),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11621),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11620),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [13904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8371),
  [13906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11786),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11277),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12304),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11577),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11490),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [13940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11479),
  [13942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [13944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11419),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11573),
  [13950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [13952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7935),
  [13954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [13956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8485),
  [13958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11800),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [13972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__set_values_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11404),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7847),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [13981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__or_replace, 2, 0, 0),
  [13983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__or_replace, 2, 0, 0),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11398),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10468),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11397),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7864),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [14001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__set_values, 3, 0, 0),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11396),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11506),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13784),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13354),
  [14017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13768),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11623),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [14023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__set_values, 2, 0, 0),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11361),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9354),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10945),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7891),
  [14037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11501),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [14041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(9354),
  [14044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(9714),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11499),
  [14053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(8930),
  [14056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(13773),
  [14059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(13774),
  [14062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(10599),
  [14065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(7889),
  [14068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(11621),
  [14071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 2, 0, 0), SHIFT_REPEAT(11620),
  [14074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8973),
  [14076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11496),
  [14078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11495),
  [14082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11797),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [14086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11494),
  [14088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7908),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6406),
  [14092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11493),
  [14094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [14096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11492),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11491),
  [14106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [14108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [14110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat2, 2, 0, 0),
  [14112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(11592),
  [14115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(13886),
  [14118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(7900),
  [14121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mysql_update_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(8800),
  [14124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11489),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [14128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11619),
  [14130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11518),
  [14132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9109),
  [14138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [14140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [14142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__truncate_statement, 5, 0, 0),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11112),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [14148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_values, 3, 0, 23),
  [14150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11996),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9291),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [14158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9373),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9289),
  [14162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [14166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_values, 3, 0, 0),
  [14168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__insert_values_repeat1, 2, 0, 0),
  [14170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__insert_values_repeat1, 2, 0, 0), SHIFT_REPEAT(11996),
  [14173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11403),
  [14175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13872),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [14183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_values, 4, 0, 23),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9184),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9301),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9303),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10751),
  [14211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compute_stats_repeat1, 2, 0, 0), SHIFT_REPEAT(295),
  [14214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__compute_stats_repeat1, 2, 0, 0),
  [14216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_read, 6, 0, 0),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7945),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8017),
  [14222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__truncate_statement, 4, 0, 0),
  [14224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10413),
  [14226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8778),
  [14228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [14230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [14232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [14234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [14236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [14238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6721),
  [14240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9178),
  [14242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [14244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [14246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9025),
  [14248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [14250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [14252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [14254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [14256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [14258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9271),
  [14260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [14262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [14264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 3, 0, 0),
  [14266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10149),
  [14268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [14270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11482),
  [14272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [14274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8777),
  [14276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [14278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [14280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 3, 0, 0),
  [14282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9923),
  [14284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8324),
  [14286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9931),
  [14288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [14290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9118),
  [14292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [14294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [14296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [14298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [14300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [14302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [14304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [14306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [14308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8733),
  [14310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8262),
  [14312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6872),
  [14314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [14316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [14318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [14320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [14322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9050),
  [14324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [14326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [14328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6784),
  [14330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6015),
  [14332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13728),
  [14334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8745),
  [14336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [14338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9144),
  [14340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [14342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [14344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13827),
  [14346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9060),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [14352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_settings, 2, 0, 54),
  [14354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_settings, 2, 0, 54),
  [14356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_settings, 2, 0, 55),
  [14358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_settings, 2, 0, 55),
  [14360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 4, 0, 0),
  [14362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10031),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8282),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10028),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8049),
  [14370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9197),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9957),
  [14374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(9197),
  [14377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_operation_repeat1, 2, 0, 17), SHIFT_REPEAT(9957),
  [14380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 4, 0, 0),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11439),
  [14388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9033),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9260),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [14396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10612),
  [14398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14126),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8015),
  [14402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 4, 0, 0),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9086),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9256),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9082),
  [14418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [14420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [14422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 5, 0, 79),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9777),
  [14426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11420),
  [14430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10872),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [14434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11734),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9152),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [14444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 6, 0, 122),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11013),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7572),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11758),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9155),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [14458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8084),
  [14460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat2, 5, 0, 0),
  [14462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 4, 0, 0),
  [14464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8727),
  [14466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8150),
  [14468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_values, 2, 0, 0),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [14472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11777),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9455),
  [14478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7569),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11411),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10450),
  [14484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_read, 3, 0, 0),
  [14486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8730),
  [14488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [14490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9069),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9218),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [14504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9212),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9017),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [14526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__set_values_repeat1, 2, 0, 0), SHIFT_REPEAT(8084),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10941),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11745),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9007),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [14547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__compute_stats_repeat2, 2, 0, 0),
  [14549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_settings, 3, 0, 91),
  [14551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_settings, 3, 0, 91),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9046),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9200),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [14563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [14565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__with_settings, 3, 0, 84),
  [14567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__with_settings, 3, 0, 84),
  [14569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9165),
  [14571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10511),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10046),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8098),
  [14581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11330),
  [14585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8333),
  [14587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8427),
  [14593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8483),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11303),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9347),
  [14605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [14607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [14611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 1, 0, 0),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [14617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9375),
  [14619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8791),
  [14621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 8, 0, 169),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10049),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10787),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [14629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_column, 5, 0, 166),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11328),
  [14633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9351),
  [14635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13824),
  [14637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postgres_update_statement, 2, 0, 0),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [14645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_partition_by, 4, 0, 0),
  [14647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8176),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11528),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [14653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__truncate_statement_repeat1, 2, 0, 0),
  [14655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__truncate_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8814),
  [14658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8519),
  [14660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13264),
  [14662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [14664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13266),
  [14666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9376),
  [14668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13271),
  [14670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [14672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9343),
  [14674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8506),
  [14676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [14678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9241),
  [14680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [14682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9477),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11788),
  [14686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [14688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modify_column, 2, 0, 0),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13856),
  [14692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [14694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13858),
  [14696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8821),
  [14698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13860),
  [14700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9704),
  [14702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [14704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8947),
  [14706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14091),
  [14708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8204),
  [14710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [14712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [14714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 3, 0, 0),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [14720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8378),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10680),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8674),
  [14726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [14728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7989),
  [14730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11307),
  [14732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_column, 4, 0, 135),
  [14734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [14736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modify_column, 4, 0, 0),
  [14738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8167),
  [14740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 4, 0, 0),
  [14742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [14744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10218),
  [14746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_frame, 3, 0, 0),
  [14748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11695),
  [14750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [14752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [14754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 5, 0, 66),
  [14756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [14758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10066),
  [14760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11359),
  [14762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 6, 0, 0),
  [14764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9695),
  [14766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10880),
  [14768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8352),
  [14770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11697),
  [14772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7690),
  [14774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [14776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [14778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [14780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_extension, 5, 0, 0),
  [14782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10459),
  [14784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [14786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11701),
  [14788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [14790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [14792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [14794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 10, 0, 214),
  [14796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10586),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [14802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9148),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [14808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10820),
  [14810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [14812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11769),
  [14814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8848),
  [14816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__insert_values_repeat1, 2, 0, 0), SHIFT_REPEAT(11330),
  [14819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8553),
  [14821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [14823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8761),
  [14825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modify_column, 3, 0, 0),
  [14827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13627),
  [14829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [14831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13626),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9213),
  [14835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13625),
  [14837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [14843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8338),
  [14845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9745),
  [14847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 5, 0, 0),
  [14849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9740),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8093),
  [14855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 4, 0, 33),
  [14857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8891),
  [14859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9837),
  [14861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 7, 0, 138),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9549),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11034),
  [14867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_database_repeat1, 1, 0, 29),
  [14869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_create_database_repeat1, 1, 0, 29),
  [14871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_extension, 4, 0, 0),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10744),
  [14875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8449),
  [14877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [14879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9885),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [14883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_column, 3, 0, 95),
  [14885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 2, 0, 0),
  [14887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_extension, 3, 0, 0),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10425),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [14893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13594),
  [14895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [14897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13593),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9283),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13592),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8882),
  [14907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 3, 0, 15),
  [14909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9138),
  [14911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10087),
  [14913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_repeat1, 2, 0, 0), SHIFT_REPEAT(993),
  [14916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 7, 0, 0),
  [14918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9556),
  [14920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11152),
  [14922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat2, 2, 0, 0), SHIFT_REPEAT(90),
  [14925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_body_repeat2, 2, 0, 0),
  [14927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat2, 2, 0, 0), SHIFT_REPEAT(90),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11374),
  [14932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11636),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10428),
  [14938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10102),
  [14940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_type, 3, 0, 0),
  [14942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10435),
  [14944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9159),
  [14946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [14948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [14950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11675),
  [14952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11676),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [14956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [14958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8786),
  [14960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9381),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9052),
  [14964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [14966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_sequence, 3, 0, 0),
  [14968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [14970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [14972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13399),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [14976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13398),
  [14978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8881),
  [14980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_view, 3, 0, 0),
  [14982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10456),
  [14984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9108),
  [14986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9676),
  [14988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11252),
  [14990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_table, 3, 0, 0),
  [14992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10457),
  [14994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11286),
  [14996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9533),
  [14998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11309),
  [15000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [15002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [15004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [15006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_type, 4, 0, 0),
  [15008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10729),
  [15010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11875),
  [15012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [15014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9582),
  [15016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11431),
  [15018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 223),
  [15020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_sequence, 4, 0, 0),
  [15022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10698),
  [15024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9369),
  [15026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_schema, 3, 0, 0),
  [15028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [15030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_schema, 4, 0, 0),
  [15032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10737),
  [15034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9261),
  [15036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [15038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [15040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11556),
  [15042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8913),
  [15044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 3, 0, 0),
  [15046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12708),
  [15048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8252),
  [15050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9388),
  [15052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11674),
  [15054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_view, 4, 0, 0),
  [15056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10697),
  [15058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9262),
  [15060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [15062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [15064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10344),
  [15066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [15068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [15070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [15072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9091),
  [15074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [15076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [15078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_table, 4, 0, 0),
  [15080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10690),
  [15082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10772),
  [15084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11306),
  [15086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8764),
  [15088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11555),
  [15090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 12, 0, 214),
  [15092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11224),
  [15094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [15096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 6, 0, 0),
  [15098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [15100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [15102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 11, 0, 33),
  [15104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [15106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8900),
  [15108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10336),
  [15110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8820),
  [15112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8824),
  [15114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9422),
  [15116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9224),
  [15118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [15120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [15122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11637),
  [15124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9901),
  [15126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [15128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [15130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9023),
  [15132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [15136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9076),
  [15138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [15140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [15142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [15144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9115),
  [15146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10363),
  [15148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 4, 0, 0),
  [15150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [15152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [15154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_frame, 2, 0, 0),
  [15156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11696),
  [15158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11907),
  [15160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11226),
  [15162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11719),
  [15164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11891),
  [15166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [15168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 10, 0, 169),
  [15170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10606),
  [15172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11889),
  [15174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [15176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9952),
  [15178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8946),
  [15180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10256),
  [15182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10206),
  [15184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [15186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7791),
  [15188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [15190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9415),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9061),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [15196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [15198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [15200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [15202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [15204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9147),
  [15206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [15208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [15210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11698),
  [15212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9191),
  [15214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9071),
  [15216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [15218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [15220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [15222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10198),
  [15224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9145),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [15228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [15230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7450),
  [15232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11699),
  [15234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11868),
  [15236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11867),
  [15238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11866),
  [15240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 13, 0, 66),
  [15242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11548),
  [15244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 7, 0, 0),
  [15246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 8, 0, 0),
  [15248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [15250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9706),
  [15252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 8, 0, 60),
  [15254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [15256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10097),
  [15258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7462),
  [15260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_values, 2, 0, 23),
  [15262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [15264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10103),
  [15266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9221),
  [15268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [15270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [15272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9196),
  [15274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11453),
  [15276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [15278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [15280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10123),
  [15282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9416),
  [15284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [15286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9018),
  [15288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [15290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [15292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [15294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7778),
  [15296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [15298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9684),
  [15300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11849),
  [15302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8811),
  [15304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [15306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [15308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9906),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9904),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [15314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11308),
  [15316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10124),
  [15318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11280),
  [15320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [15322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [15324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [15326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9643),
  [15328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9395),
  [15330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9056),
  [15332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [15334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [15336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8454),
  [15338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [15340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10109),
  [15342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [15344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [15346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [15348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [15350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9162),
  [15352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [15354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [15356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [15358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7327),
  [15360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9408),
  [15362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8799),
  [15364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 12, 0, 66),
  [15366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9124),
  [15368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [15370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [15372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8872),
  [15374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11827),
  [15376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9671),
  [15378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9146),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7863),
  [15382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 5, 0, 0),
  [15384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11723),
  [15386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [15388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [15390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11600),
  [15392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 7, 0, 0),
  [15394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10058),
  [15396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [15398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10520),
  [15400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [15402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8759),
  [15404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [15406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [15408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [15410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9662),
  [15412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11337),
  [15414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10061),
  [15416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [15418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10191),
  [15420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [15422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [15424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10196),
  [15426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 3, 0, 0),
  [15428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9858),
  [15430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [15432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 6, 0, 0),
  [15434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13380),
  [15436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13381),
  [15438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 11, 0, 0),
  [15440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11826),
  [15442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [15444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [15446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [15448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [15450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [15452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10197),
  [15454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7337),
  [15456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9267),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11653),
  [15460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11822),
  [15462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [15464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 9, 0, 0),
  [15466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [15468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10635),
  [15470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9029),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [15474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [15476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 9, 0, 15),
  [15478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8855),
  [15480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 9, 0, 138),
  [15482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10254),
  [15484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 9, 0, 60),
  [15486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [15488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10062),
  [15490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 9, 0, 0),
  [15492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10229),
  [15494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [15496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11333),
  [15498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11685),
  [15500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [15502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10059),
  [15504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 12, 0, 0),
  [15506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [15508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [15510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [15512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 12, 0, 33),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [15516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [15518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10055),
  [15520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [15522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9554),
  [15524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9186),
  [15526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [15528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [15530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [15532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11778),
  [15534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11645),
  [15536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9421),
  [15538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9037),
  [15540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [15548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8863),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11771),
  [15552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7598),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [15556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7805),
  [15558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(743),
  [15561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9308),
  [15563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [15565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [15567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 5, 0, 0),
  [15569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12047),
  [15571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12031),
  [15573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [15575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9441),
  [15577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9185),
  [15579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [15581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [15583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9306),
  [15585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [15587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [15589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(744),
  [15592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9653),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11232),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7765),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [15602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11643),
  [15604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 2, 0, 125),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11648),
  [15608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 2, 0, 127),
  [15610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 10, 0, 0),
  [15612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 10, 0, 15),
  [15614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8975),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [15618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__truncate_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9347),
  [15621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 10, 0, 60),
  [15623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11475),
  [15625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9137),
  [15627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [15629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [15631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [15633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8972),
  [15635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [15637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 10, 0, 33),
  [15639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 8, 0, 0),
  [15641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [15643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10004),
  [15645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11264),
  [15647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10047),
  [15649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [15651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9524),
  [15653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_class, 1, 0, 126),
  [15655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [15657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [15659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [15661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11502),
  [15663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11722),
  [15665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9997),
  [15667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11260),
  [15669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9139),
  [15671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [15673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [15675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11505),
  [15677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 185),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9204),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [15683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [15685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11736),
  [15687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9292),
  [15689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [15691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [15693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 11, 0, 66),
  [15695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9432),
  [15697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11512),
  [15699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 183),
  [15701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [15703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9827),
  [15705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11515),
  [15707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 182),
  [15709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [15711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9533),
  [15714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [15716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_frame, 5, 0, 0),
  [15718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [15720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [15722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9203),
  [15724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [15726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [15728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 11, 0, 15),
  [15730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [15738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9294),
  [15740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [15744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_fields, 4, 0, 124),
  [15746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10543),
  [15748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 9, 0, 181),
  [15750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 9, 0, 180),
  [15752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__merge_statement_repeat1, 2, 0, 0),
  [15754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__merge_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11737),
  [15757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [15759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14484),
  [15761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14484),
  [15763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [15765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [15767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [15769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [15771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [15773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [15775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [15777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 9, 0, 0),
  [15779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [15781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [15783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [15785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [15787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_class, 3, 0, 184),
  [15789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11608),
  [15791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__temporary, 1, 0, 0),
  [15793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8178),
  [15795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 9, 0, 0),
  [15797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 8, 0, 140),
  [15799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [15801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 8, 0, 0),
  [15803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 8, 0, 172),
  [15805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 9, 0, 158),
  [15807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 8, 0, 0),
  [15809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14036),
  [15811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10777),
  [15813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 6, 0, 0),
  [15815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [15817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 9, 0, 128),
  [15819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [15821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 9, 0, 89),
  [15823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [15825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 6, 0, 0),
  [15827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11876),
  [15829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 14, 0, 177),
  [15831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 11, 0, 189),
  [15833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10560),
  [15835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10528),
  [15837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 6, 0, 0),
  [15839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 3, 0, 60),
  [15841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8830),
  [15843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 3, 0, 0),
  [15845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [15847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_column, 1, 0, 6),
  [15849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9638),
  [15851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 13, 0, 150),
  [15853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11541),
  [15855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14024),
  [15857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [15859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11228),
  [15861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 9, 0, 189),
  [15863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_fields, 2, 0, 0),
  [15865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 9, 0, 190),
  [15867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10128),
  [15869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 12, 0, 189),
  [15871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 12, 0, 229),
  [15873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [15875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 12, 0, 0),
  [15877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10355),
  [15879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [15881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 12, 0, 116),
  [15883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [15885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9644),
  [15887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14586),
  [15889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14586),
  [15891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [15893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9647),
  [15895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14584),
  [15897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14584),
  [15899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [15901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6903),
  [15903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11806),
  [15905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13290),
  [15907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [15909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 6, 0, 89),
  [15911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 11, 0, 158),
  [15913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [15915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9774),
  [15917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11612),
  [15919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 11, 0, 222),
  [15921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 11, 0, 221),
  [15923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [15925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 11, 0, 0),
  [15927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [15929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_columns, 3, 0, 0),
  [15931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 11, 0, 75),
  [15933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 4, 0, 15),
  [15935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9036),
  [15937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 4, 0, 0),
  [15939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9041),
  [15941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optimize_table, 5, 0, 0),
  [15943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [15945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [15947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 10, 0, 189),
  [15949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 10, 0, 0),
  [15951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14008),
  [15953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11622),
  [15955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11537),
  [15957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13840),
  [15959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12767),
  [15961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 10, 0, 128),
  [15963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 10, 0, 158),
  [15965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 6, 0, 93),
  [15967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9879),
  [15969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 9, 0, 0),
  [15971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10133),
  [15973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [15975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [15977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 10, 0, 204),
  [15979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 8, 0, 0),
  [15981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11540),
  [15983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 10, 0, 202),
  [15985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9887),
  [15987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11842),
  [15989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 10, 0, 39),
  [15991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 9, 0, 172),
  [15993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 10, 0, 0),
  [15995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 5, 0, 0),
  [15997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11240),
  [15999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11241),
  [16001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [16003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [16005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11231),
  [16007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10088),
  [16009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13383),
  [16011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13383),
  [16013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [16015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10480),
  [16017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_schema, 3, 0, 0),
  [16019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9888),
  [16021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10112),
  [16023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8100),
  [16025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10551),
  [16027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [16029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__merge_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11816),
  [16032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [16034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10154),
  [16036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [16038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10839),
  [16040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11629),
  [16042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11530),
  [16044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13597),
  [16046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 10, 0, 0),
  [16048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10134),
  [16050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [16052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10402),
  [16054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11251),
  [16056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [16058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10384),
  [16060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10321),
  [16062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9839),
  [16064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12809),
  [16066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12809),
  [16068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [16070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 5, 0, 57),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9852),
  [16074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10294),
  [16076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10289),
  [16078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_class, 4, 0, 207),
  [16080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [16082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [16084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 8, 0, 0),
  [16086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [16088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [16090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 8, 0, 161),
  [16092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [16094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 5, 0, 0),
  [16096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9682),
  [16098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 8, 0, 89),
  [16100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 6, 0, 93),
  [16102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11795),
  [16104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 8, 0, 128),
  [16106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 8, 0, 158),
  [16108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__vacuum_option, 1, 0, 0),
  [16110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10719),
  [16112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_option, 1, 0, 0),
  [16114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 8, 0, 0),
  [16116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 5, 0, 0),
  [16118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10995),
  [16120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10272),
  [16122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__merge_statement, 8, 0, 155),
  [16124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 8, 0, 0),
  [16126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 5, 0, 0),
  [16128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [16130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13997),
  [16132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [16134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_query, 1, 0, 0),
  [16136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_statement, 5, 0, 0),
  [16138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mysql_update_statement, 4, 0, 0),
  [16140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [16142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 6, 0, 0),
  [16144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5864),
  [16146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7898),
  [16148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10053),
  [16150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11268),
  [16152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10506),
  [16154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10503),
  [16156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [16158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 7, 0, 89),
  [16160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 7, 0, 128),
  [16162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11299),
  [16164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_columns, 4, 0, 0),
  [16166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [16168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [16170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 5, 0, 33),
  [16172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9181),
  [16174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [16176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 5, 0, 0),
  [16178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9192),
  [16180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [16182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13622),
  [16184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13621),
  [16186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [16188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11890),
  [16190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11892),
  [16192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12759),
  [16194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10346),
  [16196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [16198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 7, 0, 0),
  [16200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optimize_table, 4, 0, 0),
  [16202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [16204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, 0, 6),
  [16206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [16208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11474),
  [16210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14164),
  [16212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11466),
  [16216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14181),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [16220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_class, 5, 0, 224),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11459),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14197),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13673),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13672),
  [16234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11296),
  [16236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_database, 4, 0, 0),
  [16238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10730),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9824),
  [16242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11452),
  [16244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14213),
  [16246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7776),
  [16248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 11, 0, 0),
  [16250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9869),
  [16252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10661),
  [16254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [16256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [16258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10703),
  [16260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11950),
  [16262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11949),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12420),
  [16266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 7, 0, 0),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9796),
  [16270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 7, 0, 0),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11683),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9929),
  [16276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12061),
  [16278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12061),
  [16280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [16282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11448),
  [16284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14229),
  [16286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [16288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9930),
  [16290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10747),
  [16292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_fields, 3, 0, 124),
  [16294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_not_exists, 3, 0, 0),
  [16296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_not_exists, 3, 0, 0),
  [16298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11325),
  [16300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10008),
  [16302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 6, 0, 66),
  [16304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9296),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9989),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13355),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [16312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 9, 0, 0),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9995),
  [16316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11442),
  [16318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14242),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [16322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11310),
  [16324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10022),
  [16326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12101),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12101),
  [16330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8319),
  [16332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10740),
  [16334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_database, 3, 0, 0),
  [16336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10430),
  [16338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10099),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10529),
  [16342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11312),
  [16344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [16346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6883),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [16350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11314),
  [16352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11315),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11343),
  [16356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11319),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12565),
  [16360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8197),
  [16362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [16364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_exists, 2, 0, 0),
  [16366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_exists, 2, 0, 0),
  [16368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_schema, 4, 0, 0),
  [16370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [16372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 7, 0, 131),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10048),
  [16376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11094),
  [16378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mysql_update_statement, 3, 0, 0),
  [16380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10075),
  [16382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10084),
  [16384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 12, 0, 0),
  [16386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9530),
  [16388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11072),
  [16390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10701),
  [16392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12066),
  [16394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13573),
  [16396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11609),
  [16398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8208),
  [16400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_statement, 4, 0, 0),
  [16402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [16404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11338),
  [16406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [16408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_configuration, 3, 0, 133),
  [16410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optimize_table, 3, 0, 0),
  [16412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11341),
  [16414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 8, 0, 0),
  [16416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9445),
  [16418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11342),
  [16420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10819),
  [16422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11346),
  [16424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [16426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [16428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [16430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_constraint, 2, 0, 0),
  [16432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8763),
  [16434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9685),
  [16436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11373),
  [16438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10850),
  [16440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 7, 0, 131),
  [16442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11589),
  [16444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [16446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13629),
  [16448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9630),
  [16450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [16452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 7, 0, 0),
  [16454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13910),
  [16456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11037),
  [16458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13529),
  [16460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [16462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 7, 0, 0),
  [16464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__rename_statement_repeat1, 2, 0, 0),
  [16466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__rename_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8612),
  [16469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_statement, 7, 0, 140),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12833),
  [16475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete, 1, 0, 0),
  [16477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 13, 0, 0),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13457),
  [16483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(738),
  [16486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8029),
  [16488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13140),
  [16490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11757),
  [16492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [16494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13473),
  [16496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 14, 0, 150),
  [16498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11535),
  [16500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12776),
  [16502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11759),
  [16504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13641),
  [16506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_statement, 2, 0, 0),
  [16508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [16510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [16512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [16514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 9, 0, 39),
  [16516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 7, 0, 79),
  [16518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 7, 0, 122),
  [16520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11755),
  [16522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 14, 0, 0),
  [16524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [16526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11764),
  [16528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 6, 0, 0),
  [16530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12433),
  [16532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 6, 0, 75),
  [16534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12534),
  [16536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 14, 0, 236),
  [16538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [16540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [16542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 14, 0, 0),
  [16544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 14, 0, 237),
  [16546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 9, 0, 177),
  [16548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14064),
  [16550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mysql_update_statement, 5, 0, 0),
  [16552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 9, 0, 0),
  [16554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 50),
  [16556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 50),
  [16558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [16560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update, 2, 0, 0),
  [16562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [16564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10026),
  [16566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [16568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [16570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 8, 0, 150),
  [16572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13949),
  [16574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11421),
  [16576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [16578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 8, 0, 174),
  [16580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 8, 0, 0),
  [16582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 15, 0, 177),
  [16584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11406),
  [16586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 8, 0, 122),
  [16588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 15, 0, 238),
  [16590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [16592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0), SHIFT_REPEAT(1542),
  [16595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0),
  [16597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_from, 6, 0, 0),
  [16599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 15, 0, 0),
  [16601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__partition_spec, 5, 0, 0),
  [16603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6931),
  [16605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [16607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11747),
  [16609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 15, 0, 0),
  [16611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11888),
  [16613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 3, 0, 0),
  [16615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13328),
  [16617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_statement, 1, 0, 0),
  [16619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [16621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 9, 0, 122),
  [16623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 9, 0, 153),
  [16625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 9, 0, 186),
  [16627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 16, 0, 240),
  [16629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rename_column, 5, 0, 167),
  [16631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 16, 0, 241),
  [16633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 16, 0, 0),
  [16635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9464),
  [16637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 50),
  [16639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 50),
  [16641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 13, 0, 234),
  [16643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_view, 16, 0, 0),
  [16645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 13, 0, 189),
  [16647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_elements, 4, 0, 187),
  [16649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 10, 0, 153),
  [16651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint_literal, 3, 0, 60),
  [16653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_invocation_repeat1, 2, 0, 68),
  [16655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 17, 0, 243),
  [16657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update, 3, 0, 0),
  [16659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 17, 0, 244),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [16663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 9, 0, 0),
  [16665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_column, 5, 0, 0),
  [16667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 17, 0, 0),
  [16669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modify_column, 5, 0, 0),
  [16671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_column, 5, 0, 135),
  [16673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__merge_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11750),
  [16676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9449),
  [16678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 18, 0, 245),
  [16680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 18, 0, 246),
  [16682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 18, 0, 0),
  [16684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 9, 0, 161),
  [16686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 15, 0, 239),
  [16688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, 0, 165),
  [16690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [16692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 19, 0, 247),
  [16694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [16696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 19, 0, 248),
  [16698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12945),
  [16700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12945),
  [16702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [16704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, 0, 164),
  [16706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 19, 0, 0),
  [16708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 4, 0, 0),
  [16710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12132),
  [16712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 13, 0, 0),
  [16714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11735),
  [16716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14588),
  [16718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14588),
  [16720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8168),
  [16722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 20, 0, 249),
  [16724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 20, 0, 250),
  [16726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 20, 0, 0),
  [16728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 21, 0, 251),
  [16730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 21, 0, 252),
  [16732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14582),
  [16734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14582),
  [16736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8317),
  [16738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9074),
  [16740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 21, 0, 0),
  [16742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 22, 0, 253),
  [16744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 6, 0, 191),
  [16746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 22, 0, 254),
  [16748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6826),
  [16750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [16752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__partition_spec, 4, 0, 0),
  [16754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 6, 0, 192),
  [16756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 22, 0, 0),
  [16758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 23, 0, 255),
  [16760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 23, 0, 256),
  [16762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 6, 0, 0),
  [16764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 24, 0, 257),
  [16766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 6, 0, 193),
  [16768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 6, 0, 194),
  [16770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, 0, 163),
  [16772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 5, 0, 15),
  [16774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__update_statement, 1, 0, 0),
  [16776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [16778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [16780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 6, 0, 53),
  [16782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_column, 6, 0, 166),
  [16784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14579),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14579),
  [16788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 10, 0, 200),
  [16790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint_literal, 4, 0, 60),
  [16792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10775),
  [16794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9072),
  [16796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11358),
  [16798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9070),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [16802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rename_column, 4, 0, 136),
  [16804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_key_constraint, 2, 0, 0),
  [16806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13336),
  [16808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_schema, 6, 0, 0),
  [16810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_constraint, 4, 0, 0),
  [16812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_column, 4, 0, 33),
  [16814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_column, 4, 0, 95),
  [16816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9877),
  [16818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 4, 0, 134),
  [16820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postgres_update_statement, 3, 0, 0),
  [16822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 4, 0, 60),
  [16824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 7, 0, 0),
  [16826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6343),
  [16828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 7, 0, 130),
  [16830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [16832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 6, 0, 0),
  [16834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11721),
  [16836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 6, 0, 79),
  [16838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 13, 0, 0),
  [16840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 13, 0, 177),
  [16842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9439),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [16846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11339),
  [16848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10619),
  [16850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__check_option, 2, 0, 0),
  [16852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 9, 0, 0),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10251),
  [16856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [16858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rename_table_names, 3, 0, 0),
  [16860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 9, 0, 174),
  [16862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 9, 0, 200),
  [16864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11574),
  [16866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 9, 0, 0),
  [16868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 13, 0, 116),
  [16870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11412),
  [16872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6665),
  [16874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14356),
  [16876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10417),
  [16878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [16880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_table, 3, 0, 0),
  [16882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [16884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [16886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 2, 0, 50),
  [16888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [16890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [16892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11327),
  [16894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13369),
  [16896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_database, 5, 0, 0),
  [16898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10460),
  [16900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [16902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [16904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9034),
  [16906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [16908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [16910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 5, 0, 33),
  [16912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8978),
  [16914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13074),
  [16916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13074),
  [16918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [16920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 10, 0, 75),
  [16922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rename_object, 3, 0, 0),
  [16924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [16926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 6, 0, 0),
  [16928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_schema, 3, 0, 94),
  [16930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10825),
  [16932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 50),
  [16934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 50),
  [16936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 6, 0, 57),
  [16938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11754),
  [16940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10823),
  [16942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_trigger, 12, 0, 0),
  [16944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12037),
  [16946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12013),
  [16948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [16950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12077),
  [16952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [16954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [16956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11414),
  [16958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_column, 3, 0, 15),
  [16960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [16962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 3, 0, 20),
  [16964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [16966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_table, 8, 0, 0),
  [16968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10034),
  [16970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__create_trigger_event, 3, 0, 0),
  [16972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 7, 0, 93),
  [16974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 12, 0, 158),
  [16976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13811),
  [16978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13811),
  [16980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 4, 0, 0),
  [16982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [16984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [16986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_elements, 2, 0, 0),
  [16988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 7, 0, 0),
  [16990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [16992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8198),
  [16994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12129),
  [16996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7246),
  [16998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [17000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_table, 5, 0, 0),
  [17002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 5, 0, 0),
  [17004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13610),
  [17006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11628),
  [17008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [17010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9641),
  [17012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 12, 0, 150),
  [17014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 12, 0, 75),
  [17016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11311),
  [17018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10348),
  [17020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13530),
  [17022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_position, 1, 0, 0),
  [17024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, 0, 0),
  [17026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_constraint, 3, 0, 0),
  [17028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, 0, 5),
  [17030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_column, 2, 0, 60),
  [17032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 5, 0, 0),
  [17034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13406),
  [17036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [17038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8205),
  [17040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_change_ownership, 3, 0, 0),
  [17042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 5, 0, 39),
  [17044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13408),
  [17046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13544),
  [17048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11249),
  [17050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_table_repeat1, 2, 0, 0),
  [17052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_table_repeat1, 2, 0, 0), SHIFT_REPEAT(6343),
  [17055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_column_position, 2, 0, 96),
  [17057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11480),
  [17059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11672),
  [17061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 10, 0, 0),
  [17063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [17065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9011),
  [17067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [17069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10177),
  [17071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 8, 0, 225),
  [17073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [17075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 1, 0, 58),
  [17077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [17079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10200),
  [17081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11703),
  [17083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_schema, 5, 0, 0),
  [17085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_materialized_view, 11, 0, 0),
  [17087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [17089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10700),
  [17091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10699),
  [17093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__create_trigger_event, 4, 0, 0),
  [17095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_table, 2, 0, 0),
  [17097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [17099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 8, 0, 131),
  [17101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [17103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10236),
  [17105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 6, 0, 66),
  [17107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9383),
  [17109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12897),
  [17111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12897),
  [17113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [17115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9772),
  [17117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13190),
  [17119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13190),
  [17121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [17123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 10, 0, 89),
  [17125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13507),
  [17127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [17129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 4, 0, 15),
  [17131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [17133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 11, 0, 0),
  [17135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_index, 11, 0, 128),
  [17137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [17139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__rename_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8365),
  [17142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13744),
  [17144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13744),
  [17146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [17148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 7, 0, 0),
  [17150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13585),
  [17152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11284),
  [17154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14556),
  [17156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [17158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11263),
  [17160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [17162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 10, 0, 190),
  [17164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14523),
  [17166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_extension, 10, 0, 0),
  [17168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11438),
  [17170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13459),
  [17172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optimize_table, 6, 0, 0),
  [17174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [17176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [17178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10505),
  [17180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 7, 0, 116),
  [17182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13512),
  [17184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 11, 0, 39),
  [17186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 7, 0, 208),
  [17188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11673),
  [17190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [17192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9853),
  [17194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 7, 0, 209),
  [17196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13483),
  [17198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13480),
  [17200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13449),
  [17202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_column, 7, 0, 210),
  [17204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_insert, 11, 0, 116),
  [17206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11650),
  [17208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [17210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [17212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_elements, 3, 0, 160),
  [17214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9998),
  [17216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11651),
  [17218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_create_type, 8, 0, 159),
  [17220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11274),
  [17222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_invocation_repeat1, 3, 0, 36),
  [17224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [17226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13446),
  [17228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10347),
  [17230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [17232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 10, 0, 0),
  [17234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10608),
  [17236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13420),
  [17238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13421),
  [17240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13422),
  [17242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13423),
  [17244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_table_repeat1, 2, 0, 0), SHIFT_REPEAT(6337),
  [17247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [17249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12703),
  [17251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 10, 0, 0),
  [17253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frame_definition, 2, 0, 109),
  [17255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frame_definition, 2, 0, 108),
  [17257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frame_definition, 2, 0, 107),
  [17259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frame_definition, 2, 0, 106),
  [17261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_index_repeat1, 2, 0, 148),
  [17263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_index_repeat1, 2, 0, 148), SHIFT_REPEAT(9761),
  [17266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [17268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9096),
  [17270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [17272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__current_row, 2, 0, 0),
  [17274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 10, 0, 0),
  [17276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frame_definition, 2, 0, 0),
  [17278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [17280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [17282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 10, 0, 138),
  [17284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 10, 0, 213),
  [17286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [17288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [17290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [17292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [17294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 10, 0, 212),
  [17296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [17298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [17300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [17302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [17306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10603),
  [17308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9761),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [17312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9123),
  [17316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [17318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [17320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 10, 0, 211),
  [17322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [17324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [17326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [17328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [17330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [17332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [17334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [17336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12306),
  [17338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9517),
  [17340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [17342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12223),
  [17344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9567),
  [17346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8819),
  [17348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8999),
  [17350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [17352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9103),
  [17354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [17356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [17358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9100),
  [17360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [17362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [17364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 10, 0, 174),
  [17366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [17368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [17370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [17372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9099),
  [17374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [17376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9038),
  [17378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_columns_repeat1, 2, 0, 0),
  [17380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ordered_columns_repeat1, 2, 0, 0), SHIFT_REPEAT(7630),
  [17383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11285),
  [17385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [17387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [17389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [17391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10021),
  [17393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8315),
  [17395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12886),
  [17397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [17399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10162),
  [17401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [17403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [17405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1421),
  [17408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [17410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [17412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8381),
  [17414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [17416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [17418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8755),
  [17420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [17422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [17424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [17426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8330),
  [17428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [17430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14227),
  [17432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14406),
  [17434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [17436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14225),
  [17438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [17440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_table, 4, 0, 0),
  [17442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10340),
  [17444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [17446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [17448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [17450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [17452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [17454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8308),
  [17456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11659),
  [17458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [17460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9114),
  [17462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [17464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13225),
  [17466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13289),
  [17468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [17470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 3, 0, 14),
  [17472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8541),
  [17474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9044),
  [17476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [17478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [17480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__vacuum_table_repeat1, 2, 0, 0),
  [17482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__vacuum_table_repeat1, 2, 0, 0), SHIFT_REPEAT(8874),
  [17485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11433),
  [17487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 157),
  [17489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_table, 6, 0, 0),
  [17491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12927),
  [17493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [17495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [17497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2, 0, 0),
  [17499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [17501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11639),
  [17503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [17505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14393),
  [17507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [17509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_column_repeat1, 2, 0, 119),
  [17511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_column_repeat1, 2, 0, 119), SHIFT_REPEAT(8685),
  [17514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [17516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9089),
  [17518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13683),
  [17520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [17522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [17524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [17526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 2, 0, 0),
  [17528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7393),
  [17530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10349),
  [17532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14392),
  [17534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_column_definitions_repeat1, 2, 0, 0),
  [17536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_column_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(7648),
  [17539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9088),
  [17541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [17543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [17545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8657),
  [17547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [17549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 3, 0, 0),
  [17551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [17553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cte_repeat1, 2, 0, 101),
  [17555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cte_repeat1, 2, 0, 101), SHIFT_REPEAT(9814),
  [17558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2, 0, 7),
  [17560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [17562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [17564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_values, 3, 0, 0),
  [17566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [17568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8502),
  [17570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [17572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [17574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9062),
  [17576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8549),
  [17578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14386),
  [17580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14385),
  [17582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_database, 4, 0, 0),
  [17584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14378),
  [17586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [17588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [17590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [17592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [17594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11278),
  [17596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [17598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12387),
  [17600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [17602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11272),
  [17604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11454),
  [17606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 185),
  [17608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [17610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [17612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [17614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13396),
  [17616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13397),
  [17618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [17620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14377),
  [17622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8756),
  [17624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13986),
  [17626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14398),
  [17628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [17630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_extension, 6, 0, 0),
  [17632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_database, 6, 0, 0),
  [17634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 6, 0, 15),
  [17636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_role, 4, 0, 0),
  [17638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 6, 0, 33),
  [17640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 4, 0, 0),
  [17642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 6, 0, 0),
  [17644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8358),
  [17646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [17648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9670),
  [17650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_schema, 6, 0, 0),
  [17652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [17654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_database, 6, 0, 98),
  [17656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [17658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_database, 6, 0, 0),
  [17660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 4, 0, 32),
  [17662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [17664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [17666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [17668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14372),
  [17670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [17672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [17674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [17676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [17678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [17680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 4, 0, 0),
  [17682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [17684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [17686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [17688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11936),
  [17690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [17692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [17694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [17696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [17698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9268),
  [17700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [17702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [17704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_role, 3, 0, 0),
  [17706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [17708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [17710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [17712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [17714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 4, 0, 0),
  [17716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [17718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [17720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [17722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [17724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11461),
  [17726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 183),
  [17728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(1301),
  [17731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__create_trigger_event, 1, 0, 0),
  [17733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9781),
  [17735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8864),
  [17737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [17739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11862),
  [17741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [17743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [17745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [17747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [17749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [17751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [17753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [17755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [17757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 5, 0, 0),
  [17759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12783),
  [17761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [17763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_sequence, 4, 0, 0),
  [17765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [17767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 5, 0, 59),
  [17769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [17771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [17773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 6, 0, 0),
  [17775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [17777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11557),
  [17779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 3, 0, 127),
  [17781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [17783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11886),
  [17785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [17787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [17789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9298),
  [17791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [17793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13589),
  [17795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13727),
  [17797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11468),
  [17799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 182),
  [17801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [17803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9217),
  [17805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12904),
  [17807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12459),
  [17809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11680),
  [17811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9146),
  [17813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9677),
  [17815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [17817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10627),
  [17819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_view, 4, 0, 0),
  [17821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [17823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [17825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8992),
  [17829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14549),
  [17831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_sequence, 6, 0, 0),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8465),
  [17835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11663),
  [17837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 2, 0, 87),
  [17839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12130),
  [17841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10057),
  [17843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8985),
  [17845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14551),
  [17847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [17849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11654),
  [17851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 2, 0, 88),
  [17853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14364),
  [17855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [17857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 11, 0, 214),
  [17859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [17861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10494),
  [17863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8956),
  [17865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14552),
  [17867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [17869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10497),
  [17871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [17873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8457),
  [17875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [17877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [17879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [17881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11547),
  [17883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [17885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [17887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [17889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 11, 0, 226),
  [17891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [17893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10678),
  [17895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 11, 0, 169),
  [17897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compute_stats, 11, 0, 0),
  [17899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [17901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10106),
  [17903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11322),
  [17905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__copy_statement, 11, 0, 200),
  [17907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset_statement, 2, 0, 0),
  [17909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [17911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transaction_mode, 8, 0, 0),
  [17913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [17915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [17917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11564),
  [17919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 3, 0, 125),
  [17921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [17923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_view, 5, 0, 0),
  [17925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11266),
  [17927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9993),
  [17929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [17931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_sequence, 5, 0, 0),
  [17933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8399),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12531),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [17939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14554),
  [17941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [17943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [17945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [17947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 5, 0, 0),
  [17949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [17951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [17953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11259),
  [17955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [17957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_index_fields_repeat1, 2, 0, 0),
  [17959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_index_fields_repeat1, 2, 0, 0), SHIFT_REPEAT(7355),
  [17962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [17964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [17966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [17968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 1),
  [17970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [17972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [17974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [17976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [17978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [17980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10189),
  [17982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12577),
  [17984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12576),
  [17986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [17988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_write, 1, 0, 0),
  [17990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [17992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10183),
  [17994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_database, 5, 0, 0),
  [17996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [17998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [18000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ddl_statement, 1, 0, 2),
  [18002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11415),
  [18004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 7, 0, 223),
  [18006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [18008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [18010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6702),
  [18012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_type_repeat1, 2, 0, 56),
  [18014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_type_repeat1, 2, 0, 56), SHIFT_REPEAT(8819),
  [18017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_database, 5, 0, 65),
  [18019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [18021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [18023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ddl_statement, 1, 0, 3),
  [18025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 5, 0, 0),
  [18027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat1, 2, 0, 0),
  [18029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat1, 2, 0, 0), SHIFT_REPEAT(8871),
  [18032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_arguments_repeat1, 2, 0, 0),
  [18034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [18037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [18039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [18041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reset_statement, 3, 0, 0),
  [18043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [18045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_table, 5, 0, 0),
  [18047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [18049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [18051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [18053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11810),
  [18055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [18057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [18059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [18061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [18063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12049),
  [18065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [18067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_view, 5, 0, 0),
  [18069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_sequence, 5, 0, 0),
  [18071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9413),
  [18073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [18075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alter_table_repeat1, 2, 0, 0), SHIFT_REPEAT(6382),
  [18078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9257),
  [18080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13810),
  [18082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7284),
  [18084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [18086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [18088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [18090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9832),
  [18092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [18094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10685),
  [18096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [18098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8522),
  [18100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_option, 2, 0, 0),
  [18102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 5, 0, 15),
  [18104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [18106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [18108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_target, 2, 0, 0),
  [18110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [18112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11838),
  [18114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [18116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_type, 5, 0, 0),
  [18118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8944),
  [18120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14557),
  [18122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10712),
  [18124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [18126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [18128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [18130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14558),
  [18132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [18134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_schema, 5, 0, 0),
  [18136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [18138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12630),
  [18140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [18142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14560),
  [18144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [18146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14562),
  [18148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8470),
  [18150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11236),
  [18152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8705),
  [18154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12051),
  [18156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12053),
  [18158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [18160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [18162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12603),
  [18164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8430),
  [18166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [18168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11254),
  [18170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11253),
  [18172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8435),
  [18174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12258),
  [18176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [18178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9173),
  [18180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [18182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [18184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8497),
  [18186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [18188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_table, 5, 0, 0),
  [18190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [18192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8789),
  [18194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14026),
  [18196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [18198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [18200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [18202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [18204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10369),
  [18206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [18208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 9, 0, 197),
  [18210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12093),
  [18212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12092),
  [18214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12006),
  [18216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 9, 0, 169),
  [18218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8458),
  [18220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13853),
  [18222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11605),
  [18224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_configuration, 3, 0, 26),
  [18226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [18228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [18230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12535),
  [18232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12533),
  [18234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [18236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [18238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [18240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12662),
  [18242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10255),
  [18244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [18246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9206),
  [18248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13835),
  [18250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13759),
  [18252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [18254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [18256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8645),
  [18258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [18260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10828),
  [18262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [18264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 9, 0, 196),
  [18266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 9, 0, 0),
  [18268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 9, 0, 195),
  [18270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10829),
  [18272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [18274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9730),
  [18276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10273),
  [18278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 8, 0, 0),
  [18280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [18282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [18284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_values, 2, 0, 0),
  [18286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [18288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [18290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [18292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11245),
  [18294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [18296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_role, 8, 0, 162),
  [18298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_sequence, 7, 0, 0),
  [18300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [18302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 7, 0, 0),
  [18304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11243),
  [18306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12721),
  [18308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_statement, 5, 0, 0),
  [18310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dml_write, 2, 0, 0),
  [18312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12780),
  [18314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [18316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [18318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_statement, 3, 0, 0),
  [18320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_statement, 5, 0, 57),
  [18322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [18324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [18326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11583),
  [18328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [18330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9031),
  [18332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [18334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8542),
  [18336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13374),
  [18338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14050),
  [18340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11534),
  [18342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11008),
  [18344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [18346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [18348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8550),
  [18350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [18352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13981),
  [18354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [18356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [18358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [18360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__table_settings_repeat1, 2, 0, 0),
  [18362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__table_settings_repeat1, 2, 0, 0), SHIFT_REPEAT(7469),
  [18365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [18369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10174),
  [18373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9609),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [18377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [18381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10167),
  [18383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [18385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9683),
  [18387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12839),
  [18389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [18391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9680),
  [18393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [18395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [18397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9678),
  [18399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_database, 7, 0, 0),
  [18401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [18403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [18405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8413),
  [18407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [18409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [18411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [18413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9666),
  [18415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9664),
  [18417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [18419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12750),
  [18421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [18423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [18425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [18427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [18429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [18431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14128),
  [18433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_storage_parameters_repeat1, 2, 0, 0),
  [18435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_storage_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(10026),
  [18438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6717),
  [18440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [18442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9648),
  [18444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [18446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [18448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14121),
  [18450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [18452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [18454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [18456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [18458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14357),
  [18460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11604),
  [18462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9176),
  [18464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [18466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [18468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [18470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [18472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [18474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14033),
  [18476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 7, 0, 66),
  [18478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [18480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6815),
  [18482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9469),
  [18484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12898),
  [18486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 7, 0, 33),
  [18488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9625),
  [18490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [18492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9623),
  [18494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10909),
  [18496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [18498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [18500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [18502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [18504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8477),
  [18506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [18508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [18510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [18512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [18514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [18516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8429),
  [18518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [18520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13920),
  [18522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13923),
  [18524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6654),
  [18526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [18528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [18530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [18532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_elements_repeat1, 2, 0, 188),
  [18534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_elements_repeat1, 2, 0, 188), SHIFT_REPEAT(9038),
  [18537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9608),
  [18539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [18541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11233),
  [18543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11994),
  [18545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [18547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [18549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9172),
  [18551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12784),
  [18553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6680),
  [18555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8515),
  [18557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__vacuum_table, 7, 0, 0),
  [18559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13765),
  [18561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [18563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9591),
  [18565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12957),
  [18567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transaction_mode, 6, 0, 0),
  [18569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [18571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9479),
  [18573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [18575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11173),
  [18577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [18579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 8, 0, 0),
  [18581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10813),
  [18583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10812),
  [18585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [18587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__compute_stats_repeat2, 2, 0, 0), SHIFT_REPEAT(8593),
  [18590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_index, 8, 0, 168),
  [18592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [18594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optimize_table, 7, 0, 0),
  [18596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [18598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8660),
  [18600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11812),
  [18602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [18604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 8, 0, 170),
  [18606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [18608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [18610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [18612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 8, 0, 138),
  [18614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9423),
  [18616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9571),
  [18618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9569),
  [18620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_invocation_repeat1, 2, 0, 70),
  [18622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_invocation_repeat1, 2, 0, 70), SHIFT_REPEAT(597),
  [18625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [18627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [18629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_drop_index, 8, 0, 66),
  [18631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_frame_definition, 1, 0, 0),
  [18633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13016),
  [18635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [18637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9547),
  [18639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11507),
  [18641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 88),
  [18643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [18645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [18647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [18649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [18651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [18653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8774),
  [18655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11513),
  [18657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 87),
  [18659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11516),
  [18661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 157),
  [18663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [18665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [18667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [18669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [18671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8554),
  [18673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [18675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [18677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [18679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 148),
  [18681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 148), SHIFT_REPEAT(9096),
  [18684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_returning, 2, 0, 0),
  [18686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9407),
  [18688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [18690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [18692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11204),
  [18694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11197),
  [18696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [18698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11196),
  [18700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8938),
  [18702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [18704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11185),
  [18706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11181),
  [18708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8753),
  [18710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_statement, 6, 0, 0),
  [18712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11170),
  [18714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [18716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8671),
  [18718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11166),
  [18720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [18722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [18724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [18726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__truncate_statement, 6, 0, 0),
  [18728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [18730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11165),
  [18732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13075),
  [18734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11156),
  [18736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13437),
  [18738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [18740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11140),
  [18742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [18744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13134),
  [18746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 3, 0, 0),
  [18748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11126),
  [18750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11123),
  [18752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [18754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [18756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [18758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [18760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [18762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [18764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [18766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8698),
  [18768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [18770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13265),
  [18772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat3, 2, 0, 70),
  [18774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat3, 2, 0, 70), SHIFT_REPEAT(779),
  [18777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11108),
  [18779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11107),
  [18781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [18783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [18785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [18787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [18789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [18791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [18793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [18795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [18797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [18799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [18801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [18803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [18805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [18807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8710),
  [18809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__update_statement, 2, 0, 0),
  [18811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [18813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraints_repeat1, 2, 0, 0),
  [18815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(7393),
  [18818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [18820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [18822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [18824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delete_statement, 3, 0, 0),
  [18826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [18828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [18830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [18832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [18834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11066),
  [18836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [18838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11063),
  [18840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [18842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8720),
  [18844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8719),
  [18846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [18848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [18850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [18852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_list_repeat1, 2, 0, 0),
  [18854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__column_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7915),
  [18857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [18859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [18861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [18863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8334),
  [18865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [18867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11045),
  [18869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__insert_statement, 2, 0, 0),
  [18871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9534),
  [18873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [18875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11043),
  [18877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8742),
  [18879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [18881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8340),
  [18883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [18885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [18887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [18889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10990),
  [18891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [18893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [18895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13189),
  [18897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11021),
  [18899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11017),
  [18901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13227),
  [18903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [18905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transaction_mode, 7, 0, 0),
  [18907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alter_type, 13, 0, 214),
  [18909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [18911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [18913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12706),
  [18915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [18917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13117),
  [18919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [18921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13118),
  [18923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [18925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13119),
  [18927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4691),
  [18929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [18931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__column_list_repeat1, 2, 0, 40),
  [18933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11918),
  [18935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10116),
  [18937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [18939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [18941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [18943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [18945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12386),
  [18947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [18949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [18951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13176),
  [18953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [18955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13177),
  [18957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [18959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13178),
  [18961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8245),
  [18963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [18965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [18967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14093),
  [18969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6641),
  [18971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [18973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [18975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [18977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [18979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [18981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [18983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8703),
  [18985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [18987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13060),
  [18989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [18991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [18993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [18995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13059),
  [18997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [18999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13058),
  [19001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [19003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12432),
  [19005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [19007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12291),
  [19009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9374),
  [19011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9362),
  [19013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9391),
  [19015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [19017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13217),
  [19019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [19021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13218),
  [19023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [19025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13219),
  [19027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9401),
  [19029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_trigger_repeat3, 2, 0, 68),
  [19031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 9, 0, 223),
  [19033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9412),
  [19035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [19037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14369),
  [19039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [19041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11409),
  [19043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11408),
  [19045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 8, 0, 223),
  [19047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 8, 0, 157),
  [19049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [19051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_index_repeat1, 4, 0, 231),
  [19053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14308),
  [19055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [19057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [19059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 7, 0, 185),
  [19061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 7, 0, 183),
  [19063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 7, 0, 182),
  [19065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11417),
  [19067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11416),
  [19069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [19071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [19073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11418),
  [19075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 7, 0, 157),
  [19077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9372),
  [19079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [19081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [19083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14245),
  [19085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [19087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [19089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13255),
  [19091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [19093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13256),
  [19095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [19097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13257),
  [19099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9802),
  [19101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14232),
  [19103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [19105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9851),
  [19107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [19109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14219),
  [19111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7684),
  [19113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14218),
  [19115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7784),
  [19117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11426),
  [19119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11457),
  [19121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 185),
  [19123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14203),
  [19125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7706),
  [19127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14202),
  [19129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [19131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 88),
  [19133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11428),
  [19135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11427),
  [19137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 183),
  [19139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14187),
  [19141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [19143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14186),
  [19145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7733),
  [19147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 87),
  [19149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11430),
  [19151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [19153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 6, 0, 182),
  [19155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14170),
  [19157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [19159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14169),
  [19161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [19163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11434),
  [19165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11908),
  [19167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9245),
  [19169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10657),
  [19171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9242),
  [19173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5552),
  [19175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [19177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11441),
  [19179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [19181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [19183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9317),
  [19185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9318),
  [19187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9319),
  [19189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9321),
  [19191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9324),
  [19193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9330),
  [19195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9331),
  [19197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9334),
  [19199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9342),
  [19201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commit, 1, 0, 0),
  [19203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13595),
  [19205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9361),
  [19207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 127),
  [19209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11488),
  [19211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11456),
  [19213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9377),
  [19215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11460),
  [19217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 88),
  [19219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 125),
  [19221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11464),
  [19223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11463),
  [19225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11467),
  [19227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 5, 0, 87),
  [19229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11471),
  [19231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11470),
  [19233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11472),
  [19235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [19237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [19239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8042),
  [19241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [19243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14097),
  [19245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [19247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_storage_parameters_repeat1, 4, 0, 0),
  [19249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8044),
  [19251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [19253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11484),
  [19255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10172),
  [19257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14081),
  [19259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [19261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14079),
  [19263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [19265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14078),
  [19267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13430),
  [19269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11486),
  [19271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [19273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [19275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13414),
  [19277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14067),
  [19279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7641),
  [19281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14060),
  [19283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13390),
  [19285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_column, 2, 0, 6),
  [19287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14129),
  [19289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [19291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14048),
  [19293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [19295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14119),
  [19297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 5, 0, 20),
  [19299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [19301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [19303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10249),
  [19305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [19307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13001),
  [19309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [19311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13000),
  [19313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [19315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12999),
  [19317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_elements_repeat1, 2, 0, 160),
  [19319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11504),
  [19321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11503),
  [19323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 127),
  [19325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7802),
  [19327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9367),
  [19329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rollback, 1, 0, 0),
  [19331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13591),
  [19333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11508),
  [19335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11511),
  [19337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11509),
  [19339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__index_field, 4, 0, 125),
  [19341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13766),
  [19343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11514),
  [19345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [19347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [19349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [19351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7955),
  [19353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [19355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7996),
  [19357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [19359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [19361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11524),
  [19363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [19365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11625),
  [19367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11532),
  [19369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9840),
  [19371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [19373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13394),
  [19375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9599),
  [19377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [19379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [19381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9352),
  [19383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13870),
  [19385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [19387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [19389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9380),
  [19391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [19393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [19395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [19397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [19399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11527),
  [19401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9859),
  [19403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6648),
  [19405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [19407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [19409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9284),
  [19411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [19413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [19415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 4, 0, 50),
  [19417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [19419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14011),
  [19421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7960),
  [19423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10107),
  [19425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9021),
  [19427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10108),
  [19429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [19431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [19433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8401),
  [19435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10222),
  [19437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [19439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [19441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13481),
  [19443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [19445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13478),
  [19447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [19449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13477),
  [19451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12709),
  [19453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11646),
  [19455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10318),
  [19457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [19459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [19461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10360),
  [19463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13368),
  [19465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [19467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11566),
  [19469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11565),
  [19471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11666),
  [19473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10443),
  [19475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11559),
  [19477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11558),
  [19479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13606),
  [19481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11269),
  [19483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13602),
  [19485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10470),
  [19487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11562),
  [19489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6899),
  [19491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [19493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12942),
  [19495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [19497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [19499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12941),
  [19501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [19503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12940),
  [19505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11567),
  [19507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_index_fields_repeat1, 2, 0, 124),
  [19509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11686),
  [19511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10613),
  [19513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11688),
  [19515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10616),
  [19517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [19519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [19521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13570),
  [19523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11256),
  [19525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13566),
  [19527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10637),
  [19529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [19531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7254),
  [19533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [19535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [19537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13982),
  [19539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9489),
  [19541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7446),
  [19543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [19545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10771),
  [19547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [19549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [19551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11710),
  [19553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10770),
  [19555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13519),
  [19557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11921),
  [19559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13513),
  [19561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10794),
  [19563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11913),
  [19565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [19567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11731),
  [19569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10859),
  [19571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11649),
  [19573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11902),
  [19575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11900),
  [19577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11733),
  [19579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10865),
  [19581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8112),
  [19583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [19585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13952),
  [19587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [19589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11883),
  [19591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11881),
  [19593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7767),
  [19595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9428),
  [19597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11740),
  [19599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10930),
  [19601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11575),
  [19603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13972),
  [19605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13482),
  [19607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [19609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8116),
  [19611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11753),
  [19613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10893),
  [19615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [19617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12883),
  [19619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [19621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12882),
  [19623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [19625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12881),
  [19627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11860),
  [19629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13509),
  [19631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11858),
  [19633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [19635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11856),
  [19637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9486),
  [19639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13471),
  [19641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [19643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6683),
  [19645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11578),
  [19647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12048),
  [19649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [19651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11671),
  [19653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11582),
  [19655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12135),
  [19657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [19659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_invocation_repeat1, 4, 0, 36),
  [19661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 146),
  [19663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [19665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [19667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11811),
  [19669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9513),
  [19671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13470),
  [19673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [19675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7954),
  [19677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [19679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9402),
  [19681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11760),
  [19683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [19685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [19687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [19689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8383),
  [19691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13010),
  [19693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13435),
  [19695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7405),
  [19697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13432),
  [19699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [19701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [19703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [19705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12189),
  [19707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [19709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12190),
  [19711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [19713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12191),
  [19715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [19717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14021),
  [19719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [19721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [19723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13899),
  [19725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7984),
  [19727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8287),
  [19729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8287),
  [19731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7188),
  [19733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [19735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12072),
  [19737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [19739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [19741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9497),
  [19743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9485),
  [19745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [19747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9694),
  [19749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12000),
  [19751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9481),
  [19753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [19755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [19757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11690),
  [19759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12896),
  [19761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [19763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9470),
  [19765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [19767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12276),
  [19769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [19771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12277),
  [19773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [19775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12278),
  [19777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10105),
  [19779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [19781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [19783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [19785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [19787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [19789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8991),
  [19791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [19793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9494),
  [19795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [19797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7963),
  [19799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [19801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [19803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9566),
  [19805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [19807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7956),
  [19809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arguments, 4, 0, 0),
  [19811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_argument, 3, 0, 58),
  [19813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [19815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12824),
  [19817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [19819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12823),
  [19821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [19823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12822),
  [19825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [19827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [19829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [19831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_create_type_repeat1, 2, 0, 129),
  [19833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [19835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9668),
  [19837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [19839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8007),
  [19841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [19843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12358),
  [19845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [19847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12359),
  [19849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [19851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12360),
  [19853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [19855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8250),
  [19857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [19859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9755),
  [19861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arguments, 3, 0, 0),
  [19863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [19865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [19867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [19869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9838),
  [19871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [19873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7943),
  [19875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11655),
  [19877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11664),
  [19879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [19881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9286),
  [19883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13584),
  [19885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9804),
  [19887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [19889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6370),
  [19891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [19893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [19895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [19897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9311),
  [19899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9329),
  [19901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [19903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8114),
  [19905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [19907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [19909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [19911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [19913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8119),
  [19915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [19917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [19919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13188),
  [19921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12453),
  [19923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9917),
  [19925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9914),
  [19927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [19929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [19931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [19933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [19935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12436),
  [19937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [19939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12437),
  [19941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [19943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12438),
  [19945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [19947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10060),
  [19949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [19951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8083),
  [19953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11726),
  [19955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13500),
  [19957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11001),
  [19959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10130),
  [19961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [19963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [19965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9437),
  [19967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [19969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11718),
  [19971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_value_pair, 3, 0, 120),
  [19973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8047),
  [19975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alter_column_repeat1, 2, 0, 117),
  [19977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4654),
  [19979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [19981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11772),
  [19983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [19985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10221),
  [19987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [19989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8054),
  [19991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [19993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12508),
  [19997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [19999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12509),
  [20001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [20003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12510),
  [20005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10140),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [20013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13569),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12218),
  [20021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12216),
  [20023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9999),
  [20025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [20029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10019),
  [20031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [20033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8022),
  [20035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [20037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [20039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12765),
  [20041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [20043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12764),
  [20045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [20047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12763),
  [20049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8074),
  [20051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [20053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [20055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_invocation_repeat1, 3, 0, 68),
  [20057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [20059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12580),
  [20061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [20063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12581),
  [20065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [20067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12582),
  [20069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [20071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9897),
  [20073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9249),
  [20075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [20077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [20079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [20081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [20083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [20085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [20087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [20089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9340),
  [20091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [20093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [20095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [20097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13415),
  [20099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [20101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [20103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [20105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11789),
  [20107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9589),
  [20109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [20111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [20113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7964),
  [20115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7413),
  [20117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [20119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12645),
  [20121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [20123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12646),
  [20125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [20127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12647),
  [20129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14161),
  [20131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cte_repeat1, 2, 0, 100),
  [20133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8082),
  [20135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [20137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [20139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arguments, 2, 0, 0),
  [20141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8495),
  [20143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13312),
  [20145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [20147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [20149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12705),
  [20151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [20153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12704),
  [20155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [20157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8849),
  [20159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11661),
  [20161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [20163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [20165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [20167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [20169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [20171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [20173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [20175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [20177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [20179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [20181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13310),
  [20183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9632),
  [20185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [20187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [20189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [20191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8494),
  [20193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [20195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [20197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [20199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [20201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [20203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9379),
  [20205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [20207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [20209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [20211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [20213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13389),
  [20215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [20217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [20219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [20221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [20223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [20225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [20227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [20229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [20231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [20233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [20235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [20237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [20239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [20241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [20243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [20245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9640),
  [20247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [20249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [20251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [20253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [20255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9502),
  [20257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_character, 1, 0, 0),
  [20259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [20261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [20263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [20265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [20267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [20269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [20271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [20273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [20275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [20277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [20279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [20281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [20283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [20285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [20287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11477),
  [20289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [20291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [20293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [20295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [20297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [20299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [20301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14480),
  [20303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [20305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [20307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [20309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [20311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [20313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [20315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11273),
  [20317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [20319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [20321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [20323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [20325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [20327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [20329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [20331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [20333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13812),
  [20335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9393),
  [20337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [20339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [20341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [20343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [20345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [20347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11785),
  [20349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13388),
  [20351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9606),
  [20353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14520),
  [20355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [20357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [20359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [20361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [20363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [20365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [20367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [20369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [20371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [20373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [20375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [20377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [20379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9471),
  [20381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13372),
  [20383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13371),
  [20385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13370),
  [20387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11790),
  [20389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11791),
  [20391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11792),
  [20393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13361),
  [20395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13360),
  [20397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [20399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13359),
  [20401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13358),
  [20403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13357),
  [20405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13351),
  [20407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13350),
  [20409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13348),
  [20411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13347),
  [20413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13346),
  [20415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13344),
  [20417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13343),
  [20419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13342),
  [20421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [20423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_target, 4, 0, 0),
  [20425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [20427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14508),
  [20429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [20431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [20433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14521),
  [20435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [20437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13333),
  [20439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13332),
  [20441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13329),
  [20443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13327),
  [20445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13326),
  [20447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13325),
  [20449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [20451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [20453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [20455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [20457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14507),
  [20459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14505),
  [20461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [20463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14494),
  [20465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13317),
  [20467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13316),
  [20469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13314),
  [20471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13185),
  [20473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [20475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [20477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [20479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [20481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [20483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14493),
  [20485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14490),
  [20487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12019),
  [20489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13304),
  [20491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13303),
  [20493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [20495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [20497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [20499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [20501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [20503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13299),
  [20505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [20507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [20509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [20511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14447),
  [20513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14423),
  [20515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [20517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14414),
  [20519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13309),
  [20521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [20523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13308),
  [20525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [20527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [20529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [20531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14405),
  [20533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9770),
  [20535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14404),
  [20537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14403),
  [20539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [20541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [20543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [20545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [20547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11391),
  [20549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11393),
  [20551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [20553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11304),
  [20555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13164),
  [20557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13162),
  [20559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13149),
  [20561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11820),
  [20563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11821),
  [20565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11823),
  [20567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13137),
  [20569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13135),
  [20571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [20573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13133),
  [20575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13131),
  [20577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13130),
  [20579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13116),
  [20581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13115),
  [20583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13114),
  [20585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13106),
  [20587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13103),
  [20589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13102),
  [20591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13090),
  [20593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13080),
  [20595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [20597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [20599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13301),
  [20601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14282),
  [20603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10975),
  [20605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6769),
  [20607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14276),
  [20609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [20611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13063),
  [20613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13062),
  [20615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13056),
  [20617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12928),
  [20619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13047),
  [20621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13046),
  [20623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [20625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [20627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [20629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [20631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14162),
  [20633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [20635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [20637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [20639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13019),
  [20641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13018),
  [20643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13017),
  [20645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13015),
  [20647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [20649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [20651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [20653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [20655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [20657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [20659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13008),
  [20661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13003),
  [20663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12998),
  [20665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [20667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13436),
  [20669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [20671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [20673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [20675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12988),
  [20677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [20679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [20681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [20683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [20685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9970),
  [20687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [20689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [20691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9910),
  [20693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [20695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [20697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [20699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [20701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [20703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11611),
  [20705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [20707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12929),
  [20709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12867),
  [20711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12926),
  [20713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11853),
  [20715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11854),
  [20717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11855),
  [20719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12901),
  [20721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12900),
  [20723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [20725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12899),
  [20727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12895),
  [20729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12894),
  [20731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12890),
  [20733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12885),
  [20735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12879),
  [20737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12878),
  [20739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12870),
  [20741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12869),
  [20743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12807),
  [20745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12866),
  [20747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6107),
  [20749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [20751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [20753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [20755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12842),
  [20757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12841),
  [20759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12840),
  [20761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12838),
  [20763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12837),
  [20765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12836),
  [20767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [20769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [20771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [20773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [20775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [20777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [20779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12827),
  [20781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12826),
  [20783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12821),
  [20785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12820),
  [20787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [20789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [20791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13425),
  [20793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13426),
  [20795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [20797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13427),
  [20799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [20801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12810),
  [20803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12808),
  [20805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12677),
  [20807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [20809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [20811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [20813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [20815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [20817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12795),
  [20819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [20821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [20823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [20825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [20827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [20829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [20831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [20833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13433),
  [20835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10032),
  [20837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [20839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [20841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [20843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [20845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [20847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [20849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12719),
  [20851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12718),
  [20853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12717),
  [20855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11897),
  [20857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11898),
  [20859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11899),
  [20861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12692),
  [20863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12690),
  [20865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [20867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12689),
  [20869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12650),
  [20871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12668),
  [20873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12667),
  [20875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12665),
  [20877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12664),
  [20879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12663),
  [20881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12661),
  [20883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12660),
  [20885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12659),
  [20887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12658),
  [20889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [20891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [20893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [20895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [20897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [20899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8945),
  [20901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [20903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [20905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12643),
  [20907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12642),
  [20909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12641),
  [20911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12634),
  [20913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12633),
  [20915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12631),
  [20917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [20919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [20921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [20923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13412),
  [20925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13458),
  [20927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [20929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [20931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12607),
  [20933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12606),
  [20935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12605),
  [20937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12604),
  [20939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [20941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [20943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6142),
  [20945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [20947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [20949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12599),
  [20951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12594),
  [20953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12593),
  [20955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [20957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [20959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [20961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12587),
  [20963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [20965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12029),
  [20967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [20969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [20971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13441),
  [20973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [20975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8831),
  [20977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10152),
  [20979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [20981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_target, 2, 0, 34),
  [20983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [20985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13489),
  [20987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [20989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [20991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12512),
  [20993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12507),
  [20995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12506),
  [20997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11934),
  [20999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11935),
  [21001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11938),
  [21003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12501),
  [21005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12494),
  [21007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [21009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12493),
  [21011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12491),
  [21013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12490),
  [21015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12488),
  [21017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12487),
  [21019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12475),
  [21021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12466),
  [21023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12465),
  [21025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12462),
  [21027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12460),
  [21029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12457),
  [21031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [21033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [21035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [21037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [21039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [21041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [21043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [21045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [21047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12443),
  [21049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12442),
  [21051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12440),
  [21053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12435),
  [21055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12434),
  [21057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12415),
  [21059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [21061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [21063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [21065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [21067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [21069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [21071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [21073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12422),
  [21075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12421),
  [21077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12419),
  [21079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12416),
  [21081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [21083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [21085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [21087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13442),
  [21089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12393),
  [21091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12391),
  [21093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12390),
  [21095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [21097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [21099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12385),
  [21101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [21103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [21105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [21107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [21109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transaction, 4, 0, 0),
  [21111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10201),
  [21113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 0),
  [21115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13450),
  [21117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13294),
  [21119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [21121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11768),
  [21123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12312),
  [21125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12309),
  [21127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12308),
  [21129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11966),
  [21131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11967),
  [21133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11968),
  [21135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12294),
  [21137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12292),
  [21139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [21141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12180),
  [21143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12285),
  [21145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12283),
  [21147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12282),
  [21149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12280),
  [21151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12274),
  [21153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12273),
  [21155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12271),
  [21157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12269),
  [21159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12268),
  [21161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12261),
  [21163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [21165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9427),
  [21167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [21169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [21171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [21173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10748),
  [21175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12227),
  [21177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12226),
  [21179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12221),
  [21181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12220),
  [21183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12219),
  [21185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12214),
  [21187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [21189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [21191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [21193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12963),
  [21195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [21197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [21199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11763),
  [21201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12196),
  [21203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12195),
  [21205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12193),
  [21207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12187),
  [21209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [21211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [21213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [21215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [21217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [21219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12181),
  [21221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12166),
  [21223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12173),
  [21225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [21227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [21229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [21231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12170),
  [21233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [21235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [21237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [21239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [21241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [21243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [21245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [21247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10126),
  [21249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [21251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [21253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [21255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [21257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [21259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [21261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12112),
  [21263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12111),
  [21265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12110),
  [21267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12001),
  [21269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12002),
  [21271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12003),
  [21273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12105),
  [21275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12104),
  [21277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [21279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12102),
  [21281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12099),
  [21283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12098),
  [21285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12097),
  [21287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12096),
  [21289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12095),
  [21291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12094),
  [21293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12090),
  [21295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12089),
  [21297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12087),
  [21299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12086),
  [21301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7827),
  [21303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [21305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [21307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [21309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [21311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12080),
  [21313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12079),
  [21315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12078),
  [21317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12075),
  [21319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12073),
  [21321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12070),
  [21323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [21325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [21327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [21329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [21331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12065),
  [21333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12063),
  [21335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12062),
  [21337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12060),
  [21339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [21341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [21343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12056),
  [21345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12055),
  [21347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12054),
  [21349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [21351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12052),
  [21353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [21355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [21357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [21359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [21361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [21363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [21365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10050),
  [21367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [21369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [21371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [21373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [21375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [21377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [21379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12027),
  [21381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12026),
  [21383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12025),
  [21385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12016),
  [21387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12015),
  [21389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11227),
  [21391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12024),
  [21393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12023),
  [21395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [21397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12022),
  [21399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12021),
  [21401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12020),
  [21403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13305),
  [21405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12036),
  [21407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12039),
  [21409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12045),
  [21411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12046),
  [21413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12069),
  [21415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12088),
  [21417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12091),
  [21419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [21421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [21423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [21425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11741),
  [21427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12121),
  [21429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12122),
  [21431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12123),
  [21433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12126),
  [21435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12034),
  [21437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12134),
  [21439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [21441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12760),
  [21443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [21445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8595),
  [21447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12154),
  [21449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12127),
  [21451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12171),
  [21453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12182),
  [21455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [21457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9889),
  [21459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12203),
  [21461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12207),
  [21463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12209),
  [21465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10009),
  [21467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12217),
  [21469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [21471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [21473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [21475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [21477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [21479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [21481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9947),
  [21483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [21485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [21487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [21489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8513),
  [21491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12355),
  [21493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12356),
  [21495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12363),
  [21497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11957),
  [21499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11956),
  [21501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11955),
  [21503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12381),
  [21505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12382),
  [21507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [21509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12290),
  [21511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12418),
  [21513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12431),
  [21515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12441),
  [21517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12448),
  [21519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12452),
  [21521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12454),
  [21523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12489),
  [21525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12492),
  [21527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12502),
  [21529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12503),
  [21531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [21533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13527),
  [21535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7824),
  [21537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13536),
  [21539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12564),
  [21541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12573),
  [21543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12578),
  [21545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12584),
  [21547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12585),
  [21549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12586),
  [21551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8906),
  [21553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8538),
  [21555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [21557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12598),
  [21559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12618),
  [21561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12657),
  [21563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12868),
  [21565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12715),
  [21567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12716),
  [21569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12725),
  [21571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [21573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12772),
  [21575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13499),
  [21577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10466),
  [21579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9788),
  [21581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [21583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [21585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11732),
  [21587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [21589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [21591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [21593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10791),
  [21595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [21597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [21599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12959),
  [21601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12960),
  [21603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12961),
  [21605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11845),
  [21607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11844),
  [21609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11843),
  [21611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12962),
  [21613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12986),
  [21615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [21617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13011),
  [21619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13022),
  [21621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13070),
  [21623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13073),
  [21625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13104),
  [21627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13128),
  [21629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13129),
  [21631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13136),
  [21633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13138),
  [21635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13139),
  [21637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13069),
  [21639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [21641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [21643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [21645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [21647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13187),
  [21649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13313),
  [21651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13321),
  [21653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13324),
  [21655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13330),
  [21657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13352),
  [21659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13515),
  [21661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9948),
  [21663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [21665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [21667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13384),
  [21669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13393),
  [21671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13407),
  [21673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13409),
  [21675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [21677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [21679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13434),
  [21681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13311),
  [21683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13440),
  [21685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [21687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13447),
  [21689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [21691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [21693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [21695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [21697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [21699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [21701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [21703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [21705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [21707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [21709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [21711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [21713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13486),
  [21715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13488),
  [21717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13492),
  [21719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11744),
  [21721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11743),
  [21723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11742),
  [21725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13493),
  [21727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13439),
  [21729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [21731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13647),
  [21733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13495),
  [21735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13496),
  [21737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13503),
  [21739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13504),
  [21741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13505),
  [21743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13508),
  [21745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13511),
  [21747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13517),
  [21749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13520),
  [21751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13521),
  [21753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [21755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [21757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [21759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [21761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [21763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13533),
  [21765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13537),
  [21767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13538),
  [21769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13542),
  [21771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13543),
  [21773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13546),
  [21775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [21777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [21779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10017),
  [21781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13564),
  [21783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13494),
  [21785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13568),
  [21787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13572),
  [21789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [21791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [21793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13575),
  [21795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13576),
  [21797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13577),
  [21799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [21801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13582),
  [21803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [21805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [21807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [21809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11720),
  [21811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9652),
  [21813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [21815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [21817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [21819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [21821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11717),
  [21823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13618),
  [21825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13619),
  [21827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13624),
  [21829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11662),
  [21831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11658),
  [21833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13631),
  [21835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13633),
  [21837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11712),
  [21839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13640),
  [21841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13642),
  [21843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13643),
  [21845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13646),
  [21847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13876),
  [21849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13650),
  [21851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13690),
  [21853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13756),
  [21855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13767),
  [21857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13770),
  [21859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13776),
  [21861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13535),
  [21863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [21865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [21867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [21869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [21871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13805),
  [21873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13851),
  [21875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13854),
  [21877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13859),
  [21879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13869),
  [21881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13874),
  [21883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [21885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [21887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13885),
  [21889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13942),
  [21891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13948),
  [21893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13830),
  [21895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [21897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [21899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13958),
  [21901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13963),
  [21903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13964),
  [21905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13971),
  [21907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [21909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [21911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [21913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [21915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [21917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [21919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [21921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [21923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [21925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14003),
  [21927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14004),
  [21929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14007),
  [21931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11552),
  [21933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11551),
  [21935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11550),
  [21937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14009),
  [21939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14015),
  [21941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13545),
  [21943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14016),
  [21945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14019),
  [21947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14025),
  [21949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14027),
  [21951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14028),
  [21953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14032),
  [21955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14035),
  [21957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14037),
  [21959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14051),
  [21961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14053),
  [21963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14056),
  [21965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [21967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [21969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [21971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [21973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [21975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14063),
  [21977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14072),
  [21979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14074),
  [21981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14075),
  [21983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14076),
  [21985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13954),
  [21987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [21989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [21991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13804),
  [21993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [21995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14088),
  [21997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14092),
  [21999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14095),
  [22001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14100),
  [22003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [22005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8514),
  [22007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14112),
  [22009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14130),
  [22011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14141),
  [22013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [22015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14145),
  [22017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [22019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [22021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [22023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13806),
  [22025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [22027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [22029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9491),
  [22031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [22033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [22035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [22037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [22039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [22041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [22043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14379),
  [22045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14399),
  [22047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14540),
  [22049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11388),
  [22051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11386),
  [22053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11383),
  [22055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14409),
  [22057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14420),
  [22059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11613),
  [22061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14422),
  [22063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14424),
  [22065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14438),
  [22067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14442),
  [22069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14445),
  [22071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14448),
  [22073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14471),
  [22075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14481),
  [22077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14485),
  [22079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14487),
  [22081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14488),
  [22083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6894),
  [22085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [22087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13549),
  [22089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [22091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [22093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14501),
  [22095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14502),
  [22097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14503),
  [22099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14504),
  [22101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14509),
  [22103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14510),
  [22105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [22107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [22109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [22111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7821),
  [22113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14515),
  [22115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14517),
  [22117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14518),
  [22119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14519),
  [22121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [22123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [22125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14525),
  [22127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14527),
  [22129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14532),
  [22131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [22133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14539),
  [22135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [22137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [22139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [22141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [22143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [22145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [22147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [22149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12071),
  [22151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [22153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7987),
  [22155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [22157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12074),
  [22159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14581),
  [22161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14578),
  [22163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14577),
  [22165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11237),
  [22167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11238),
  [22169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [22171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14576),
  [22173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14575),
  [22175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [22177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14574),
  [22179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14573),
  [22181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14572),
  [22183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14571),
  [22185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14570),
  [22187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14569),
  [22189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14568),
  [22191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14567),
  [22193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14566),
  [22195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14565),
  [22197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14564),
  [22199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [22201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [22203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [22205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10091),
  [22207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [22209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14546),
  [22211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14545),
  [22213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14544),
  [22215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14543),
  [22217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14542),
  [22219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14541),
  [22221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [22223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [22225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [22227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [22229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14536),
  [22231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14535),
  [22233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14534),
  [22235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14533),
  [22237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10100),
  [22239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10101),
  [22241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14530),
  [22243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14529),
  [22245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14528),
  [22247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8994),
  [22249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14526),
  [22251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [22253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [22255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [22257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [22259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8668),
  [22261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [22263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9473),
  [22265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [22267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [22269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [22271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [22273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [22275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7817),
  [22277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14478),
  [22279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14477),
  [22281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14475),
  [22283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11334),
  [22285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11335),
  [22287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11336),
  [22289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14474),
  [22291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14473),
  [22293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [22295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14469),
  [22297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14468),
  [22299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14466),
  [22301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14465),
  [22303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14441),
  [22305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14462),
  [22307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14460),
  [22309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14457),
  [22311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14453),
  [22313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14451),
  [22315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14450),
  [22317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12007),
  [22319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [22321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9327),
  [22323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [22325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [22327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14435),
  [22329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14432),
  [22331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14430),
  [22333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14429),
  [22335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14427),
  [22337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14426),
  [22339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [22341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [22343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14418),
  [22345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14417),
  [22347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14416),
  [22349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14415),
  [22351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9326),
  [22353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [22355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14412),
  [22357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14411),
  [22359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14410),
  [22361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [22363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14408),
  [22365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [22367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [22369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [22371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14396),
  [22373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14391),
  [22375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14389),
  [22377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11399),
  [22379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11400),
  [22381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11401),
  [22383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14383),
  [22385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14381),
  [22387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14376),
  [22389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14371),
  [22391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14370),
  [22393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14367),
  [22395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14366),
  [22397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14363),
  [22399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14361),
  [22401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14358),
  [22403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14355),
  [22405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14353),
  [22407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14349),
  [22409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14348),
  [22411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14347),
  [22413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14346),
  [22415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14345),
  [22417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14343),
  [22419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14341),
  [22421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14324),
  [22423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14316),
  [22425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14314),
  [22427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14307),
  [22429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14306),
  [22431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14299),
  [22433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14298),
  [22435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14291),
  [22437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12120),
  [22439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [22441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9488),
  [22443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14251),
  [22445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14250),
  [22447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14243),
  [22449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11444),
  [22451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11445),
  [22453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11446),
  [22455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14239),
  [22457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14238),
  [22459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11687),
  [22461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14226),
  [22463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14224),
  [22465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14215),
  [22467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14214),
  [22469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14212),
  [22471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14211),
  [22473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14210),
  [22475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14209),
  [22477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14153),
  [22479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14199),
  [22481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14198),
  [22483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14196),
  [22485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14195),
  [22487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14194),
  [22489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14193),
  [22491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14192),
  [22493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14183),
  [22495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14180),
  [22497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14179),
  [22499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14178),
  [22501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14177),
  [22503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14176),
  [22505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14175),
  [22507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14166),
  [22509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14165),
  [22511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11692),
  [22513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9500),
  [22515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [22517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14158),
  [22519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14154),
  [22521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13578),
  [22523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9629),
  [22525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14152),
  [22527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14150),
  [22529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13579),
  [22531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13580),
  [22533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [22535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14147),
  [22537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14146),
  [22539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14143),
  [22541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14142),
  [22543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14136),
  [22545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14135),
  [22547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14124),
  [22549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14117),
  [22551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14109),
  [22553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14108),
  [22555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14105),
  [22557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14101),
  [22559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9003),
  [22561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [22563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6992),
  [22565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [22567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9006),
  [22569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [22571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13892),
  [22573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [22575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transaction, 5, 0, 0),
  [22577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [22579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [22581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9568),
  [22583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [22585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [22587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [22589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [22591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [22593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13901),
  [22595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13904),
  [22597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [22599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [22601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13906),
  [22603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [22605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [22607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13926),
  [22609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [22611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [22613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [22615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [22617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [22619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [22621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [22623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13822),
  [22625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [22627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6266),
  [22629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [22631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6268),
  [22633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12108),
  [22635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [22637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [22639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [22641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6270),
  [22643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [22645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [22647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [22649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13645),
  [22651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [22653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9622),
  [22655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7474),
  [22657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [22659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [22661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [22663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [22665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [22667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [22669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [22671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [22673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [22675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [22677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [22679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [22681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [22683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9674),
  [22685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7435),
  [22687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13583),
  [22689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [22691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [22693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [22695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [22697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [22699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [22701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [22703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9726),
  [22705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11694),
  [22707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [22709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [22711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13586),
  [22713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13547),
  [22715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [22717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [22719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [22721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [22723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11713),
  [22725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [22727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [22729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [22731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8734),
  [22733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9538),
  [22735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8558),
  [22737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [22739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [22741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7613),
  [22743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14580),
  [22745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [22747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13497),
  [22749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13587),
  [22751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [22753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [22755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12145),
  [22757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9024),
  [22759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [22761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13916),
  [22763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [22765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_in, 2, 0, 0),
  [22767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11748),
  [22769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [22771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8723),
  [22773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13476),
  [22775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [22777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13475),
  [22779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [22781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13472),
  [22783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [22785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [22787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [22789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [22791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11677),
  [22793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11767),
  [22795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [22797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [22799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [22801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [22803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_frame, 4, 0, 0),
  [22805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclude_group, 2, 0, 0),
  [22807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13932),
  [22809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13933),
  [22811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclude_ties, 2, 0, 0),
  [22813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8345),
  [22815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13934),
  [22817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13936),
  [22819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13938),
  [22821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [22823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13392),
  [22825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13391),
  [22827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [22829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [22831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [22833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [22835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [22837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [22839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10202),
  [22841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [22843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [22845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13940),
  [22847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [22849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13275),
  [22851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13274),
  [22853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13269),
  [22855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13263),
  [22857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [22859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13237),
  [22861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11584),
  [22863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [22865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [22867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13180),
  [22869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13163),
  [22871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [22873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11601),
  [22875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13955),
  [22877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [22879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [22881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13045),
  [22883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [22885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [22887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [22889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12972),
  [22891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [22893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [22895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11668),
  [22897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [22899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [22901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11667),
  [22903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13611),
  [22905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13612),
  [22907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13613),
  [22909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12925),
  [22911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12913),
  [22913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13614),
  [22915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [22917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12903),
  [22919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [22921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [22923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [22925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [22927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10142),
  [22929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_target, 3, 0, 0),
  [22931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [22933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [22935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [22937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [22939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [22941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13623),
  [22943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12818),
  [22945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [22947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [22949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [22951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [22953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [22955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [22957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [22959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12779),
  [22961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [22963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11885),
  [22965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [22967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13947),
  [22969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10902),
  [22971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [22973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [22975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12774),
  [22977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [22979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [22981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [22983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8431),
  [22985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [22987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [22989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9880),
  [22991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [22993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [22995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12693),
  [22997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [22999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9175),
  [23001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [23003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [23005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [23007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [23009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [23011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9891),
  [23013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9892),
  [23015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [23017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [23019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [23021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10847),
  [23023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11244),
  [23025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [23027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11644),
  [23029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12592),
  [23031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6909),
  [23033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [23035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9899),
  [23037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9900),
  [23039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12464),
  [23041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13653),
  [23043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13654),
  [23045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13655),
  [23047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13657),
  [23049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13658),
  [23051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [23053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9903),
  [23055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13659),
  [23057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [23059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [23061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [23063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12561),
  [23065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13705),
  [23067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [23069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7633),
  [23071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11246),
  [23073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11642),
  [23075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [23077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [23079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [23081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [23083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [23085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [23087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [23089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [23091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [23093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [23095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [23097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10464),
  [23099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10746),
  [23101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [23103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11255),
  [23105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [23107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13671),
  [23109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [23111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rollback, 2, 0, 0),
  [23113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10704),
  [23115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [23117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commit, 2, 0, 0),
  [23119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transaction, 3, 0, 0),
  [23121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [23123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [23125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [23127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [23129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [23131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [23133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [23135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [23137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [23139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [23141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [23143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [23145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [23147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [23149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [23151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [23153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10467),
  [23155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [23157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11265),
  [23159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [23161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10524),
  [23163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [23165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7742),
  [23167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [23169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [23171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [23173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [23175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [23177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [23179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10184),
  [23181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [23183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11985),
  [23185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9189),
  [23187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [23189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10335),
  [23191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [23193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [23195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9008),
  [23197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11634),
  [23199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [23201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [23203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11989),
  [23205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [23207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [23209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13692),
  [23211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [23213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [23215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [23217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [23219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12192),
  [23221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [23223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [23225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [23227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [23229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12200),
  [23231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12201),
  [23233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12202),
  [23235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [23237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [23239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12208),
  [23241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [23243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [23245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13693),
  [23247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13694),
  [23249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8996),
  [23251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10405),
  [23253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10119),
  [23255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13637),
  [23257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [23259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [23261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13697),
  [23263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [23265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13698),
  [23267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13699),
  [23269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11283),
  [23271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13700),
  [23273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13701),
  [23275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13703),
  [23277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13704),
  [23279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [23281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [23283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [23285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [23287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [23289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11977),
  [23291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [23293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [23295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [23297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [23299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [23301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [23303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12279),
  [23305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [23307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [23309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [23311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [23313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12287),
  [23315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12288),
  [23317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12289),
  [23319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [23321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13706),
  [23323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12295),
  [23325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [23327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [23329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [23331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [23333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [23335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [23337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [23339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [23341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11964),
  [23343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10178),
  [23345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9039),
  [23347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9043),
  [23349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9964),
  [23351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11292),
  [23353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12361),
  [23355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9054),
  [23357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11631),
  [23359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [23361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [23363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12369),
  [23365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12370),
  [23367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12371),
  [23369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10216),
  [23371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12377),
  [23373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11630),
  [23375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [23377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [23379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [23381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10182),
  [23383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [23385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13714),
  [23387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13715),
  [23389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [23391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11947),
  [23393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13716),
  [23395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [23397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [23399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12439),
  [23401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11317),
  [23403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12445),
  [23405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12446),
  [23407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12447),
  [23409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12451),
  [23411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [23413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10117),
  [23415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [23417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8366),
  [23419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9084),
  [23421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [23423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8393),
  [23425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11939),
  [23427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [23429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [23431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [23433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12511),
  [23435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10083),
  [23437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [23439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12517),
  [23441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12518),
  [23443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12519),
  [23445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12523),
  [23447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10073),
  [23449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [23451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9112),
  [23453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [23455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [23457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11923),
  [23459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [23461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [23463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [23465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [23467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12583),
  [23469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9180),
  [23471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [23473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12589),
  [23475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12590),
  [23477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12591),
  [23479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12595),
  [23481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [23483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14022),
  [23485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [23487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14023),
  [23489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [23491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [23493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11905),
  [23495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9972),
  [23497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12648),
  [23499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12651),
  [23501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12652),
  [23503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12653),
  [23505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12655),
  [23507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [23509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13725),
  [23511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9143),
  [23513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9295),
  [23515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11901),
  [23517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11348),
  [23519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13121),
  [23521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9250),
  [23523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12707),
  [23525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [23527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12710),
  [23529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12711),
  [23531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12712),
  [23533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12714),
  [23535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13726),
  [23537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13731),
  [23539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13161),
  [23541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [23543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9153),
  [23545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9022),
  [23547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11893),
  [23549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [23551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [23553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9263),
  [23555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12766),
  [23557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [23559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12769),
  [23561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12770),
  [23563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12771),
  [23565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12773),
  [23567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [23569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [23571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10786),
  [23573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [23575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9183),
  [23577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11872),
  [23579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [23581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [23583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9665),
  [23585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12825),
  [23587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [23589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12828),
  [23591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12829),
  [23593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12830),
  [23595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12832),
  [23597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11369),
  [23599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [23601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9297),
  [23603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9198),
  [23605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11366),
  [23607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11864),
  [23609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [23611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [23613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6995),
  [23615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12884),
  [23617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8472),
  [23619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12887),
  [23621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12888),
  [23623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12889),
  [23625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12891),
  [23627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [23629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [23631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7086),
  [23633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9215),
  [23635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8011),
  [23637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11852),
  [23639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [23641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13745),
  [23643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [23645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12943),
  [23647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [23649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12946),
  [23651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12947),
  [23653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12948),
  [23655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12950),
  [23657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8573),
  [23659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [23661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14034),
  [23663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11794),
  [23665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9259),
  [23667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10814),
  [23669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11837),
  [23671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [23673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10070),
  [23675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [23677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13002),
  [23679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9790),
  [23681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13005),
  [23683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13006),
  [23685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13007),
  [23687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13009),
  [23689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7647),
  [23691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [23693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7649),
  [23695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8481),
  [23697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9272),
  [23699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [23701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11833),
  [23703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [23705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14043),
  [23707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [23709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13061),
  [23711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11627),
  [23713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13064),
  [23715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13065),
  [23717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13066),
  [23719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13068),
  [23721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [23723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclude_no_others, 3, 0, 0),
  [23725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclude_current_row, 3, 0, 0),
  [23727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [23729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9290),
  [23731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14055),
  [23733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11829),
  [23735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [23737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [23739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [23741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13120),
  [23743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [23745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13123),
  [23747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13124),
  [23749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13125),
  [23751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13127),
  [23753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11531),
  [23755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [23757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14058),
  [23759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [23761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [23763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10617),
  [23765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11819),
  [23767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [23769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11525),
  [23771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [23773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13179),
  [23775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [23777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13182),
  [23779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13183),
  [23781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13184),
  [23783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13186),
  [23785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [23787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [23789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9325),
  [23791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13220),
  [23793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13221),
  [23795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13222),
  [23797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13223),
  [23799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13224),
  [23801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [23803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11523),
  [23805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9335),
  [23807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13258),
  [23809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13259),
  [23811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13260),
  [23813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13261),
  [23815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13262),
  [23817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [23819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14077),
  [23821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10020),
  [23823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [23825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11798),
  [23827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [23829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [23831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [23833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13323),
  [23835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [23837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [23839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13794),
  [23841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [23843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [23845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [23847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11614),
  [23849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [23851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [23853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [23855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [23857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9009),
  [23859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10247),
  [23861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8272),
  [23863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [23865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [23867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13356),
  [23869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9366),
  [23871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [23873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [23875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13367),
  [23877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14120),
  [23879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [23881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [23883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [23885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [23887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13376),
  [23889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10179),
  [23891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8442),
  [23893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [23895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8203),
  [23897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10261),
  [23899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [23901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10210),
  [23903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [23905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [23907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [23909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7726),
  [23911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7597),
  [23913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [23915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7723),
  [23917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13404),
  [23919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11783),
  [23921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [23923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [23925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [23927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [23929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [23931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_window_frame, 6, 0, 0),
  [23933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [23935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [23937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [23939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11485),
  [23941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [23943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [23945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [23947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [23949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14151),
  [23951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10418),
  [23953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7646),
  [23955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13443),
  [23957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13444),
  [23959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13445),
  [23961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11775),
  [23963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [23965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [23967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [23969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [23971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [23973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14157),
  [23975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13468),
  [23977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [23979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12384),
  [23981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [23983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7687),
  [23985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [23987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [23989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [23991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13479),
  [23993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11752),
  [23995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [23997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11751),
  [23999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13553),
  [24001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [24003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [24005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9312),
  [24007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13498),
  [24009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [24011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13501),
  [24013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [24015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12364),
  [24017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12367),
  [24019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [24021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [24023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [24025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11728),
  [24027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11727),
  [24029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [24031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12368),
  [24033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [24035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [24037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [24039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12373),
  [24041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [24043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [24045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [24047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [24049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11715),
  [24051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transaction, 2, 0, 0),
  [24053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [24055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [24057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [24059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [24061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [24063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11707),
  [24065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [24067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [24069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10688),
  [24071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12374),
  [24073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7760),
  [24075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10035),
  [24077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [24079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10010),
  [24081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [24083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11702),
  [24085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10165),
  [24087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [24089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [24091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [24093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [24095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12376),
  [24097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [24099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [24101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [24103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [24105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12383),
  [24107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [24109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [24111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [24113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [24115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [24117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [24119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11440),
  [24121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [24123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [24125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [24127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9231),
  [24129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14258),
  [24131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6768),
  [24133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [24135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [24137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [24139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11906),
  [24141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [24143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9160),
  [24145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [24147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [24149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13656),
  [24151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [24153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [24155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13661),
  [24157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13662),
  [24159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13663),
  [24161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13666),
  [24163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [24165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [24167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [24169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [24171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [24173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [24175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [24177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [24179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13702),
  [24181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [24183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [24185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13707),
  [24187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13708),
  [24189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13709),
  [24191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13712),
  [24193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [24195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [24197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [24199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [24201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [24203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [24205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [24207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13730),
  [24209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [24211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [24213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13735),
  [24215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13736),
  [24217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13737),
  [24219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13740),
  [24221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [24223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [24225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [24227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [24229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [24231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [24233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [24235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13757),
  [24237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [24239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7680),
  [24241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13761),
  [24243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13762),
  [24245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13763),
  [24247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13764),
  [24249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [24251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9280),
  [24253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [24255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7806),
  [24257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9831),
  [24259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13777),
  [24261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [24263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13780),
  [24265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13781),
  [24267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13782),
  [24269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13783),
  [24271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9813),
  [24273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [24275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [24277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [24279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [24281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [24283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13796),
  [24285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [24287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13799),
  [24289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13800),
  [24291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13801),
  [24293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13802),
  [24295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [24297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [24299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [24301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13813),
  [24303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13815),
  [24305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13816),
  [24307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13817),
  [24309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13818),
  [24311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9349),
  [24313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10038),
  [24315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13829),
  [24317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13831),
  [24319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13832),
  [24321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13833),
  [24323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13834),
  [24325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [24327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [24329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13845),
  [24331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13847),
  [24333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13848),
  [24335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13849),
  [24337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13850),
  [24339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [24341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [24343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13861),
  [24345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13863),
  [24347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13864),
  [24349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13865),
  [24351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13866),
  [24353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [24355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [24357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13877),
  [24359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13879),
  [24361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13880),
  [24363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13881),
  [24365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13882),
  [24367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [24369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [24371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13893),
  [24373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13895),
  [24375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13896),
  [24377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13897),
  [24379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13898),
  [24381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [24383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [24385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [24387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13909),
  [24389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13911),
  [24391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13912),
  [24393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13913),
  [24395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13914),
  [24397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [24399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [24401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [24403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13925),
  [24405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13927),
  [24407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13928),
  [24409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13929),
  [24411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13930),
  [24413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [24415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [24417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [24419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13941),
  [24421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13943),
  [24423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13944),
  [24425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13945),
  [24427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13946),
  [24429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9446),
  [24431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9444),
  [24433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [24435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13957),
  [24437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13959),
  [24439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13960),
  [24441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13961),
  [24443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13962),
  [24445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13966),
  [24447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13967),
  [24449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13968),
  [24451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13969),
  [24453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13970),
  [24455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13974),
  [24457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13975),
  [24459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13976),
  [24461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13977),
  [24463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13978),
  [24465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [24467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [24469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [24471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [24473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [24475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [24477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [24479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [24481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [24483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [24485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7279),
  [24487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9498),
  [24489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14017),
  [24491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [24493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9523),
  [24495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [24497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [24499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10858),
  [24501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [24503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14373),
  [24505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [24507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [24509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [24511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [24513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14047),
  [24515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [24517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [24519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [24521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14375),
  [24523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [24525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [24527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [24529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14071),
  [24531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9404),
  [24533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [24535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [24537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [24539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14087),
  [24541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14089),
  [24543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [24545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [24547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [24549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [24551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [24553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [24555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14103),
  [24557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14104),
  [24559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [24561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [24563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [24565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [24567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [24569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14114),
  [24571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14115),
  [24573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [24575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [24577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [24579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [24581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14123),
  [24583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [24585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete, 2, 0, 0),
  [24587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12456),
  [24589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12515),
  [24591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [24593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [24595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14133),
  [24597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11586),
  [24599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [24601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [24603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [24605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [24607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [24609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [24611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [24613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [24615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [24617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [24619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [24621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [24623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [24625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [24627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [24629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [24631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [24633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [24635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [24637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [24639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [24641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [24643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [24645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [24647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [24649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [24651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [24653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [24655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [24657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [24659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [24661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [24663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [24665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [24667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [24669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [24671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [24673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [24675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [24677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [24679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [24681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [24683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [24685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [24687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [24689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [24691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [24693] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [24695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [24697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [24699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [24701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [24703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [24705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [24707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [24709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [24711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6928),
  [24713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [24715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [24717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [24719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [24721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [24723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [24725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [24727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [24729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [24731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [24733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [24735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [24737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [24739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [24741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [24743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [24745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [24747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [24749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [24751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [24753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [24755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [24757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [24759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [24761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [24763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [24765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [24767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [24769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [24771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [24773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [24775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [24777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [24779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [24781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [24783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [24785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [24787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9225),
  [24789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [24791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [24793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [24795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8300),
  [24797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [24799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [24801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [24803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11928),
  [24805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [24807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [24809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12537),
  [24811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [24813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [24815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [24817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [24819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [24821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [24823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [24825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [24827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [24829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [24831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [24833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [24835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [24837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [24839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [24841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [24843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [24845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [24847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [24849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [24851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [24853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [24855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [24857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [24859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [24861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [24863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [24865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [24867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12579),
  [24869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8937),
  [24871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8931),
  [24873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [24875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [24877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [24879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [24881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [24883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [24885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [24887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [24889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [24891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [24893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [24895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [24897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [24899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [24901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [24903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [24905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [24907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [24909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8169),
  [24911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [24913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9565),
  [24915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9443),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__dollar_quoted_string_start_tag = 0,
  ts_external_token__dollar_quoted_string_end_tag = 1,
  ts_external_token__dollar_quoted_string = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__dollar_quoted_string_start_tag] = sym__dollar_quoted_string_start_tag,
  [ts_external_token__dollar_quoted_string_end_tag] = sym__dollar_quoted_string_end_tag,
  [ts_external_token__dollar_quoted_string] = sym__dollar_quoted_string,
};

static const bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__dollar_quoted_string_start_tag] = true,
    [ts_external_token__dollar_quoted_string_end_tag] = true,
    [ts_external_token__dollar_quoted_string] = true,
  },
  [2] = {
    [ts_external_token__dollar_quoted_string_end_tag] = true,
  },
  [3] = {
    [ts_external_token__dollar_quoted_string] = true,
  },
  [4] = {
    [ts_external_token__dollar_quoted_string_end_tag] = true,
    [ts_external_token__dollar_quoted_string] = true,
  },
  [5] = {
    [ts_external_token__dollar_quoted_string_start_tag] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_sql_external_scanner_create(void);
void tree_sitter_sql_external_scanner_destroy(void *);
bool tree_sitter_sql_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_sql_external_scanner_serialize(void *, char *);
void tree_sitter_sql_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_sql(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_sql_external_scanner_create,
      tree_sitter_sql_external_scanner_destroy,
      tree_sitter_sql_external_scanner_scan,
      tree_sitter_sql_external_scanner_serialize,
      tree_sitter_sql_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
